/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the AArch64 target                         *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 90;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(AArch64InstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(AArch64InstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static AArch64InstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static AArch64InstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(2),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_s8,
  GILLT_s16,
  GILLT_s32,
  GILLT_s64,
  GILLT_s128,
  GILLT_v2s32,
  GILLT_v2s64,
  GILLT_v4s16,
  GILLT_v4s32,
  GILLT_v8s8,
  GILLT_v8s16,
  GILLT_v16s8,
  GILLT_nxv1s1,
  GILLT_nxv2s1,
  GILLT_nxv2s16,
  GILLT_nxv2s32,
  GILLT_nxv2s64,
  GILLT_nxv4s1,
  GILLT_nxv4s16,
  GILLT_nxv4s32,
  GILLT_nxv8s1,
  GILLT_nxv8s16,
  GILLT_nxv16s1,
  GILLT_nxv16s8,
};
const static size_t NumTypeObjects = 24;
const static LLT TypeObjects[] = {
  LLT::scalar(8),
  LLT::scalar(16),
  LLT::scalar(32),
  LLT::scalar(64),
  LLT::scalar(128),
  LLT::vector(ElementCount::getFixed(2), 32),
  LLT::vector(ElementCount::getFixed(2), 64),
  LLT::vector(ElementCount::getFixed(4), 16),
  LLT::vector(ElementCount::getFixed(4), 32),
  LLT::vector(ElementCount::getFixed(8), 8),
  LLT::vector(ElementCount::getFixed(8), 16),
  LLT::vector(ElementCount::getFixed(16), 8),
  LLT::vector(ElementCount::getScalable(1), 1),
  LLT::vector(ElementCount::getScalable(2), 1),
  LLT::vector(ElementCount::getScalable(2), 16),
  LLT::vector(ElementCount::getScalable(2), 32),
  LLT::vector(ElementCount::getScalable(2), 64),
  LLT::vector(ElementCount::getScalable(4), 1),
  LLT::vector(ElementCount::getScalable(4), 16),
  LLT::vector(ElementCount::getScalable(4), 32),
  LLT::vector(ElementCount::getScalable(8), 1),
  LLT::vector(ElementCount::getScalable(8), 16),
  LLT::vector(ElementCount::getScalable(16), 1),
  LLT::vector(ElementCount::getScalable(16), 8),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_HasPAuthBit = 6,
  Feature_HasJSBit = 8,
  Feature_HasComplxNumBit = 63,
  Feature_HasRCPC_IMMOBit = 83,
  Feature_HasFPARMv8Bit = 7,
  Feature_HasNEONBit = 5,
  Feature_HasSM4Bit = 62,
  Feature_HasSHA3Bit = 61,
  Feature_HasSHA2Bit = 19,
  Feature_HasAESBit = 18,
  Feature_HasDotProdBit = 2,
  Feature_HasCRCBit = 10,
  Feature_HasCSSCBit = 20,
  Feature_HasNoCSSCBit = 29,
  Feature_HasLSEBit = 30,
  Feature_HasNoLSEBit = 89,
  Feature_HasRDMBit = 16,
  Feature_HasFullFP16Bit = 13,
  Feature_HasNoFullFP16Bit = 80,
  Feature_HasFP16FMLBit = 4,
  Feature_HasFuseAESBit = 74,
  Feature_HasSVEBit = 26,
  Feature_HasSVE2Bit = 27,
  Feature_HasSVE2p1Bit = 43,
  Feature_HasSVEAESBit = 36,
  Feature_HasSVE2SM4Bit = 40,
  Feature_HasSVE2SHA3Bit = 88,
  Feature_HasSVEBitPermBit = 38,
  Feature_HasSMEandIsNonStreamingSafeBit = 55,
  Feature_HasSMEBit = 49,
  Feature_HasSMEF64F64Bit = 51,
  Feature_HasSMEI16I64Bit = 54,
  Feature_HasSME2andIsNonStreamingSafeBit = 58,
  Feature_HasSME2Bit = 57,
  Feature_HasSME2p1Bit = 60,
  Feature_HasFP8Bit = 21,
  Feature_HasFAMINMAXBit = 22,
  Feature_HasFP8FMABit = 23,
  Feature_HasSSVE_FP8FMABit = 46,
  Feature_HasFP8DOT2Bit = 24,
  Feature_HasSSVE_FP8DOT2Bit = 41,
  Feature_HasFP8DOT4Bit = 25,
  Feature_HasSSVE_FP8DOT4Bit = 47,
  Feature_HasLUTBit = 48,
  Feature_HasSME_LUTv2Bit = 59,
  Feature_HasSMEF8F16Bit = 52,
  Feature_HasSMEF8F32Bit = 50,
  Feature_HasCMPBRBit = 81,
  Feature_HasFPRCVTBit = 14,
  Feature_HasSVE_or_SMEBit = 0,
  Feature_HasNonStreamingSVE_or_SME2p2Bit = 39,
  Feature_HasSVE2_or_SMEBit = 32,
  Feature_HasSVE2_or_SME2Bit = 45,
  Feature_HasNonStreamingSVE2_or_SSVE_AESBit = 35,
  Feature_HasSVE2p1_or_SMEBit = 56,
  Feature_HasSVE2p1_or_SME2Bit = 28,
  Feature_HasSVE2p1_or_SME2p1Bit = 44,
  Feature_HasSVE2p2_or_SME2p2Bit = 31,
  Feature_HasSMEF16F16_or_SMEF8F16Bit = 53,
  Feature_HasNonStreamingSVE2_or_SSVE_BitPermBit = 37,
  Feature_HasNEONandIsStreamingSafeBit = 17,
  Feature_HasNEONandIsSME2p2StreamingSafeBit = 71,
  Feature_HasRCPCBit = 82,
  Feature_HasFRInt3264Bit = 15,
  Feature_HasMTEBit = 11,
  Feature_HasTMEBit = 9,
  Feature_HasMatMulInt8Bit = 3,
  Feature_HasMatMulFP32Bit = 87,
  Feature_HasMatMulFP64Bit = 42,
  Feature_HasLS64Bit = 78,
  Feature_HasHBCBit = 12,
  Feature_HasRCPC3Bit = 79,
  Feature_HasGCSBit = 1,
  Feature_IsLEBit = 69,
  Feature_IsBEBit = 75,
  Feature_UseExperimentalZeroingPseudosBit = 34,
  Feature_UseAlternateSExtLoadCVTF32Bit = 73,
  Feature_UseScalarIncVLBit = 33,
  Feature_NoUseScalarIncVLBit = 86,
  Feature_UseSVEFPLD1RBit = 85,
  Feature_UseLDAPURBit = 84,
  Feature_NotForCodeSizeBit = 72,
  Feature_UseSTRQroBit = 70,
  Feature_TailCallX16X17Bit = 65,
  Feature_TailCallX17Bit = 76,
  Feature_TailCallNotX16Bit = 77,
  Feature_TailCallAnyBit = 64,
  Feature_SLSBLRMitigationBit = 68,
  Feature_NoSLSBLRMitigationBit = 67,
  Feature_OptimizedGISelOrOtherSelectorBit = 66,
};

PredicateBitset AArch64InstructionSelector::
computeAvailableModuleFeatures(const AArch64Subtarget *Subtarget) const {
  PredicateBitset Features{};
  if (Subtarget->hasPAuth())
    Features.set(Feature_HasPAuthBit);
  if (Subtarget->hasJS())
    Features.set(Feature_HasJSBit);
  if (Subtarget->hasComplxNum())
    Features.set(Feature_HasComplxNumBit);
  if (Subtarget->hasRCPC_IMMO())
    Features.set(Feature_HasRCPC_IMMOBit);
  if (Subtarget->hasFPARMv8())
    Features.set(Feature_HasFPARMv8Bit);
  if (Subtarget->isNeonAvailable())
    Features.set(Feature_HasNEONBit);
  if (Subtarget->hasSM4())
    Features.set(Feature_HasSM4Bit);
  if (Subtarget->hasSHA3())
    Features.set(Feature_HasSHA3Bit);
  if (Subtarget->hasSHA2())
    Features.set(Feature_HasSHA2Bit);
  if (Subtarget->hasAES())
    Features.set(Feature_HasAESBit);
  if (Subtarget->hasDotProd())
    Features.set(Feature_HasDotProdBit);
  if (Subtarget->hasCRC())
    Features.set(Feature_HasCRCBit);
  if (Subtarget->hasCSSC())
    Features.set(Feature_HasCSSCBit);
  if (!Subtarget->hasCSSC())
    Features.set(Feature_HasNoCSSCBit);
  if (Subtarget->hasLSE())
    Features.set(Feature_HasLSEBit);
  if (!Subtarget->hasLSE())
    Features.set(Feature_HasNoLSEBit);
  if (Subtarget->hasRDM())
    Features.set(Feature_HasRDMBit);
  if (Subtarget->hasFullFP16())
    Features.set(Feature_HasFullFP16Bit);
  if (!Subtarget->hasFullFP16())
    Features.set(Feature_HasNoFullFP16Bit);
  if (Subtarget->hasFP16FML())
    Features.set(Feature_HasFP16FMLBit);
  if (Subtarget->hasFuseAES())
    Features.set(Feature_HasFuseAESBit);
  if (Subtarget->isSVEAvailable())
    Features.set(Feature_HasSVEBit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2())
    Features.set(Feature_HasSVE2Bit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2p1())
    Features.set(Feature_HasSVE2p1Bit);
  if (Subtarget->hasSVEAES())
    Features.set(Feature_HasSVEAESBit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2SM4())
    Features.set(Feature_HasSVE2SM4Bit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2SHA3())
    Features.set(Feature_HasSVE2SHA3Bit);
  if (Subtarget->hasSVEBitPerm())
    Features.set(Feature_HasSVEBitPermBit);
  if (Subtarget->hasSME())
    Features.set(Feature_HasSMEandIsNonStreamingSafeBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME())
    Features.set(Feature_HasSMEBit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF64F64())
    Features.set(Feature_HasSMEF64F64Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEI16I64())
    Features.set(Feature_HasSMEI16I64Bit);
  if (Subtarget->hasSME2())
    Features.set(Feature_HasSME2andIsNonStreamingSafeBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME2())
    Features.set(Feature_HasSME2Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSME2p1())
    Features.set(Feature_HasSME2p1Bit);
  if (Subtarget->hasFP8())
    Features.set(Feature_HasFP8Bit);
  if (Subtarget->hasFAMINMAX())
    Features.set(Feature_HasFAMINMAXBit);
  if (Subtarget->hasFP8FMA())
    Features.set(Feature_HasFP8FMABit);
  if (Subtarget->hasSSVE_FP8FMA() || (Subtarget->hasSVE2() && Subtarget->hasFP8FMA()))
    Features.set(Feature_HasSSVE_FP8FMABit);
  if (Subtarget->hasFP8DOT2())
    Features.set(Feature_HasFP8DOT2Bit);
  if (Subtarget->hasSSVE_FP8DOT2() || (Subtarget->hasSVE2() && Subtarget->hasFP8DOT2()))
    Features.set(Feature_HasSSVE_FP8DOT2Bit);
  if (Subtarget->hasFP8DOT4())
    Features.set(Feature_HasFP8DOT4Bit);
  if (Subtarget->hasSSVE_FP8DOT4() || (Subtarget->hasSVE2() && Subtarget->hasFP8DOT4()))
    Features.set(Feature_HasSSVE_FP8DOT4Bit);
  if (Subtarget->hasLUT())
    Features.set(Feature_HasLUTBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME_LUTv2())
    Features.set(Feature_HasSME_LUTv2Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF8F16())
    Features.set(Feature_HasSMEF8F16Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF8F32())
    Features.set(Feature_HasSMEF8F32Bit);
  if (Subtarget->hasCMPBR())
    Features.set(Feature_HasCMPBRBit);
  if (Subtarget->hasFPRCVT())
    Features.set(Feature_HasFPRCVTBit);
  if (Subtarget->hasSVE() || (Subtarget->isStreaming() && Subtarget->hasSME()))
    Features.set(Feature_HasSVE_or_SMEBit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSME2p2()))
    Features.set(Feature_HasNonStreamingSVE_or_SME2p2Bit);
  if (Subtarget->hasSVE2() || (Subtarget->isStreaming() && Subtarget->hasSME()))
    Features.set(Feature_HasSVE2_or_SMEBit);
  if (Subtarget->hasSVE2() || (Subtarget->isStreaming() && Subtarget->hasSME2()))
    Features.set(Feature_HasSVE2_or_SME2Bit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE2()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSSVE_AES()))
    Features.set(Feature_HasNonStreamingSVE2_or_SSVE_AESBit);
  if (Subtarget->hasSVE2p1() || (Subtarget->isStreaming() && Subtarget->hasSME()))
    Features.set(Feature_HasSVE2p1_or_SMEBit);
  if (Subtarget->hasSVE2p1() || (Subtarget->isStreaming() && Subtarget->hasSME2()))
    Features.set(Feature_HasSVE2p1_or_SME2Bit);
  if (Subtarget->hasSVE2p1() || (Subtarget->isStreaming() && Subtarget->hasSME2p1()))
    Features.set(Feature_HasSVE2p1_or_SME2p1Bit);
  if (Subtarget->isSVEorStreamingSVEAvailable() && (Subtarget->hasSVE2p2() || Subtarget->hasSME2p2()))
    Features.set(Feature_HasSVE2p2_or_SME2p2Bit);
  if (Subtarget->isStreaming() && (Subtarget->hasSMEF16F16() || Subtarget->hasSMEF8F16()))
    Features.set(Feature_HasSMEF16F16_or_SMEF8F16Bit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE2()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSSVE_BitPerm()))
    Features.set(Feature_HasNonStreamingSVE2_or_SSVE_BitPermBit);
  if (Subtarget->hasNEON())
    Features.set(Feature_HasNEONandIsStreamingSafeBit);
  if (Subtarget->isNeonAvailable() || (Subtarget->hasNEON() && Subtarget->hasSME2p2()))
    Features.set(Feature_HasNEONandIsSME2p2StreamingSafeBit);
  if (Subtarget->hasRCPC())
    Features.set(Feature_HasRCPCBit);
  if (Subtarget->hasFRInt3264())
    Features.set(Feature_HasFRInt3264Bit);
  if (Subtarget->hasMTE())
    Features.set(Feature_HasMTEBit);
  if (Subtarget->hasTME())
    Features.set(Feature_HasTMEBit);
  if (Subtarget->hasMatMulInt8())
    Features.set(Feature_HasMatMulInt8Bit);
  if (Subtarget->hasMatMulFP32())
    Features.set(Feature_HasMatMulFP32Bit);
  if (Subtarget->hasMatMulFP64())
    Features.set(Feature_HasMatMulFP64Bit);
  if (Subtarget->hasLS64())
    Features.set(Feature_HasLS64Bit);
  if (Subtarget->hasHBC())
    Features.set(Feature_HasHBCBit);
  if (Subtarget->hasRCPC3())
    Features.set(Feature_HasRCPC3Bit);
  if (Subtarget->hasGCS())
    Features.set(Feature_HasGCSBit);
  if (Subtarget->isLittleEndian())
    Features.set(Feature_IsLEBit);
  if (!Subtarget->isLittleEndian())
    Features.set(Feature_IsBEBit);
  if (Subtarget->useExperimentalZeroingPseudos())
    Features.set(Feature_UseExperimentalZeroingPseudosBit);
  if (Subtarget->useAlternateSExtLoadCVTF32Pattern())
    Features.set(Feature_UseAlternateSExtLoadCVTF32Bit);
  if (Subtarget->useScalarIncVL())
    Features.set(Feature_UseScalarIncVLBit);
  if (!Subtarget->useScalarIncVL())
    Features.set(Feature_NoUseScalarIncVLBit);
  if (!Subtarget->noSVEFPLD1R())
    Features.set(Feature_UseSVEFPLD1RBit);
  if (!Subtarget->avoidLDAPUR())
    Features.set(Feature_UseLDAPURBit);
  return Features;
}

void AArch64InstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const AArch64Subtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset AArch64InstructionSelector::
computeAvailableFunctionFeatures(const AArch64Subtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  if (!shouldOptForSize(MF))
    Features.set(Feature_NotForCodeSizeBit);
  if (!Subtarget->isSTRQroSlow() || shouldOptForSize(MF))
    Features.set(Feature_UseSTRQroBit);
  if (  MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && !MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallX16X17Bit);
  if ( MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallX17Bit);
  if ( !MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallNotX16Bit);
  if ( !MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && !MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallAnyBit);
  if ( MF->getSubtarget<AArch64Subtarget>().hardenSlsBlr() )
    Features.set(Feature_SLSBLRMitigationBit);
  if ( !MF->getSubtarget<AArch64Subtarget>().hardenSlsBlr() )
    Features.set(Feature_NoSLSBLRMitigationBit);
  if (!MF->getFunction().hasOptNone() || MF->getProperties().hasProperty(MachineFunctionProperties::Property::FailedISel) || !MF->getProperties().hasProperty(MachineFunctionProperties::Property::Legalized))
    Features.set(Feature_OptimizedGISelOrOtherSelectorBit);
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_HasAES,
  GIFBS_HasCRC,
  GIFBS_HasCSSC,
  GIFBS_HasDotProd,
  GIFBS_HasFP8,
  GIFBS_HasFP8DOT2,
  GIFBS_HasFP8DOT4,
  GIFBS_HasFP8FMA,
  GIFBS_HasFPARMv8,
  GIFBS_HasFRInt3264,
  GIFBS_HasFullFP16,
  GIFBS_HasFuseAES,
  GIFBS_HasGCS,
  GIFBS_HasLSE,
  GIFBS_HasLUT,
  GIFBS_HasMTE,
  GIFBS_HasMatMulInt8,
  GIFBS_HasNEON,
  GIFBS_HasNEONandIsSME2p2StreamingSafe,
  GIFBS_HasNEONandIsStreamingSafe,
  GIFBS_HasNoCSSC,
  GIFBS_HasNoFullFP16,
  GIFBS_HasNoLSE,
  GIFBS_HasNonStreamingSVE_or_SME2p2,
  GIFBS_HasPAuth,
  GIFBS_HasRCPC,
  GIFBS_HasRCPC_IMMO,
  GIFBS_HasRDM,
  GIFBS_HasSHA2,
  GIFBS_HasSHA3,
  GIFBS_HasSM4,
  GIFBS_HasSME,
  GIFBS_HasSME2,
  GIFBS_HasSMEF16F16_or_SMEF8F16,
  GIFBS_HasSMEF64F64,
  GIFBS_HasSMEF8F16,
  GIFBS_HasSMEF8F32,
  GIFBS_HasSMEI16I64,
  GIFBS_HasSMEandIsNonStreamingSafe,
  GIFBS_HasSSVE_FP8DOT2,
  GIFBS_HasSSVE_FP8DOT4,
  GIFBS_HasSSVE_FP8FMA,
  GIFBS_HasSVE,
  GIFBS_HasSVE2,
  GIFBS_HasSVE2SHA3,
  GIFBS_HasSVE2SM4,
  GIFBS_HasSVE2_or_SME,
  GIFBS_HasSVE2p1_or_SME,
  GIFBS_HasSVE2p1_or_SME2,
  GIFBS_HasSVE2p1_or_SME2p1,
  GIFBS_HasSVE_or_SME,
  GIFBS_HasTME,
  GIFBS_IsBE,
  GIFBS_IsLE,
  GIFBS_OptimizedGISelOrOtherSelector,
  GIFBS_UseSTRQro,
  GIFBS_HasComplxNum_HasNEON,
  GIFBS_HasFAMINMAX_HasNEON,
  GIFBS_HasFAMINMAX_HasSVE2_or_SME2,
  GIFBS_HasFP16FML_HasNEON,
  GIFBS_HasFP8_HasSVE2_or_SME2,
  GIFBS_HasFPARMv8_HasJS,
  GIFBS_HasFPRCVT_HasNEON,
  GIFBS_HasFullFP16_HasNEON,
  GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe,
  GIFBS_HasFullFP16_HasNEONandIsStreamingSafe,
  GIFBS_HasLUT_HasSVE2_or_SME2,
  GIFBS_HasMatMulFP32_HasSVE,
  GIFBS_HasMatMulFP64_HasSVE,
  GIFBS_HasMatMulFP64_HasSVE_or_SME,
  GIFBS_HasMatMulInt8_HasSVE,
  GIFBS_HasMatMulInt8_HasSVE_or_SME,
  GIFBS_HasNEON_HasRCPC3,
  GIFBS_HasNEON_HasRDM,
  GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES,
  GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm,
  GIFBS_HasRCPC_IMMO_UseLDAPUR,
  GIFBS_HasSVE_or_SME_UseScalarIncVL,
  GIFBS_IsLE_UseSTRQro,
  GIFBS_HasComplxNum_HasFullFP16_HasNEON,
  GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_HasAESBit, },
  {Feature_HasCRCBit, },
  {Feature_HasCSSCBit, },
  {Feature_HasDotProdBit, },
  {Feature_HasFP8Bit, },
  {Feature_HasFP8DOT2Bit, },
  {Feature_HasFP8DOT4Bit, },
  {Feature_HasFP8FMABit, },
  {Feature_HasFPARMv8Bit, },
  {Feature_HasFRInt3264Bit, },
  {Feature_HasFullFP16Bit, },
  {Feature_HasFuseAESBit, },
  {Feature_HasGCSBit, },
  {Feature_HasLSEBit, },
  {Feature_HasLUTBit, },
  {Feature_HasMTEBit, },
  {Feature_HasMatMulInt8Bit, },
  {Feature_HasNEONBit, },
  {Feature_HasNEONandIsSME2p2StreamingSafeBit, },
  {Feature_HasNEONandIsStreamingSafeBit, },
  {Feature_HasNoCSSCBit, },
  {Feature_HasNoFullFP16Bit, },
  {Feature_HasNoLSEBit, },
  {Feature_HasNonStreamingSVE_or_SME2p2Bit, },
  {Feature_HasPAuthBit, },
  {Feature_HasRCPCBit, },
  {Feature_HasRCPC_IMMOBit, },
  {Feature_HasRDMBit, },
  {Feature_HasSHA2Bit, },
  {Feature_HasSHA3Bit, },
  {Feature_HasSM4Bit, },
  {Feature_HasSMEBit, },
  {Feature_HasSME2Bit, },
  {Feature_HasSMEF16F16_or_SMEF8F16Bit, },
  {Feature_HasSMEF64F64Bit, },
  {Feature_HasSMEF8F16Bit, },
  {Feature_HasSMEF8F32Bit, },
  {Feature_HasSMEI16I64Bit, },
  {Feature_HasSMEandIsNonStreamingSafeBit, },
  {Feature_HasSSVE_FP8DOT2Bit, },
  {Feature_HasSSVE_FP8DOT4Bit, },
  {Feature_HasSSVE_FP8FMABit, },
  {Feature_HasSVEBit, },
  {Feature_HasSVE2Bit, },
  {Feature_HasSVE2SHA3Bit, },
  {Feature_HasSVE2SM4Bit, },
  {Feature_HasSVE2_or_SMEBit, },
  {Feature_HasSVE2p1_or_SMEBit, },
  {Feature_HasSVE2p1_or_SME2Bit, },
  {Feature_HasSVE2p1_or_SME2p1Bit, },
  {Feature_HasSVE_or_SMEBit, },
  {Feature_HasTMEBit, },
  {Feature_IsBEBit, },
  {Feature_IsLEBit, },
  {Feature_OptimizedGISelOrOtherSelectorBit, },
  {Feature_UseSTRQroBit, },
  {Feature_HasComplxNumBit, Feature_HasNEONBit, },
  {Feature_HasFAMINMAXBit, Feature_HasNEONBit, },
  {Feature_HasFAMINMAXBit, Feature_HasSVE2_or_SME2Bit, },
  {Feature_HasFP16FMLBit, Feature_HasNEONBit, },
  {Feature_HasFP8Bit, Feature_HasSVE2_or_SME2Bit, },
  {Feature_HasFPARMv8Bit, Feature_HasJSBit, },
  {Feature_HasFPRCVTBit, Feature_HasNEONBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONandIsSME2p2StreamingSafeBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONandIsStreamingSafeBit, },
  {Feature_HasLUTBit, Feature_HasSVE2_or_SME2Bit, },
  {Feature_HasMatMulFP32Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulFP64Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulFP64Bit, Feature_HasSVE_or_SMEBit, },
  {Feature_HasMatMulInt8Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulInt8Bit, Feature_HasSVE_or_SMEBit, },
  {Feature_HasNEONBit, Feature_HasRCPC3Bit, },
  {Feature_HasNEONBit, Feature_HasRDMBit, },
  {Feature_HasNonStreamingSVE2_or_SSVE_AESBit, Feature_HasSVEAESBit, },
  {Feature_HasNonStreamingSVE2_or_SSVE_BitPermBit, Feature_HasSVEBitPermBit, },
  {Feature_HasRCPC_IMMOBit, Feature_UseLDAPURBit, },
  {Feature_HasSVE_or_SMEBit, Feature_UseScalarIncVLBit, },
  {Feature_IsLEBit, Feature_UseSTRQroBit, },
  {Feature_HasComplxNumBit, Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasNEONBit, Feature_NotForCodeSizeBit, Feature_UseAlternateSExtLoadCVTF32Bit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
  GICP_gi_addsub_shifted_imm32,
  GICP_gi_addsub_shifted_imm64,
  GICP_gi_am_indexed128,
  GICP_gi_am_indexed16,
  GICP_gi_am_indexed32,
  GICP_gi_am_indexed64,
  GICP_gi_am_indexed8,
  GICP_gi_am_unscaled128,
  GICP_gi_am_unscaled16,
  GICP_gi_am_unscaled32,
  GICP_gi_am_unscaled64,
  GICP_gi_am_unscaled8,
  GICP_gi_arith_extended_reg32_i32,
  GICP_gi_arith_extended_reg32_i64,
  GICP_gi_arith_extended_reg32to64_i64,
  GICP_gi_arith_shifted_reg32,
  GICP_gi_arith_shifted_reg64,
  GICP_gi_extract_high_v16i8,
  GICP_gi_extract_high_v4f32,
  GICP_gi_extract_high_v4i32,
  GICP_gi_extract_high_v8f16,
  GICP_gi_extract_high_v8i16,
  GICP_gi_logical_shifted_reg32,
  GICP_gi_logical_shifted_reg64,
  GICP_gi_neg_addsub_shifted_imm32,
  GICP_gi_neg_addsub_shifted_imm64,
  GICP_gi_ro_Windexed128,
  GICP_gi_ro_Windexed16,
  GICP_gi_ro_Windexed32,
  GICP_gi_ro_Windexed64,
  GICP_gi_ro_Windexed8,
  GICP_gi_ro_Xindexed128,
  GICP_gi_ro_Xindexed16,
  GICP_gi_ro_Xindexed32,
  GICP_gi_ro_Xindexed64,
  GICP_gi_ro_Xindexed8,
};
// See constructor for table contents

AArch64InstructionSelector::ComplexMatcherMemFn
AArch64InstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
  &AArch64InstructionSelector::selectArithImmed, // gi_addsub_shifted_imm32
  &AArch64InstructionSelector::selectArithImmed, // gi_addsub_shifted_imm64
  &AArch64InstructionSelector::selectAddrModeIndexed<128>, // gi_am_indexed128
  &AArch64InstructionSelector::selectAddrModeIndexed<16>, // gi_am_indexed16
  &AArch64InstructionSelector::selectAddrModeIndexed<32>, // gi_am_indexed32
  &AArch64InstructionSelector::selectAddrModeIndexed<64>, // gi_am_indexed64
  &AArch64InstructionSelector::selectAddrModeIndexed<8>, // gi_am_indexed8
  &AArch64InstructionSelector::selectAddrModeUnscaled128, // gi_am_unscaled128
  &AArch64InstructionSelector::selectAddrModeUnscaled16, // gi_am_unscaled16
  &AArch64InstructionSelector::selectAddrModeUnscaled32, // gi_am_unscaled32
  &AArch64InstructionSelector::selectAddrModeUnscaled64, // gi_am_unscaled64
  &AArch64InstructionSelector::selectAddrModeUnscaled8, // gi_am_unscaled8
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32_i32
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32_i64
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32to64_i64
  &AArch64InstructionSelector::selectArithShiftedRegister, // gi_arith_shifted_reg32
  &AArch64InstructionSelector::selectArithShiftedRegister, // gi_arith_shifted_reg64
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v16i8
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v4f32
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v4i32
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v8f16
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v8i16
  &AArch64InstructionSelector::selectLogicalShiftedRegister, // gi_logical_shifted_reg32
  &AArch64InstructionSelector::selectLogicalShiftedRegister, // gi_logical_shifted_reg64
  &AArch64InstructionSelector::selectNegArithImmed, // gi_neg_addsub_shifted_imm32
  &AArch64InstructionSelector::selectNegArithImmed, // gi_neg_addsub_shifted_imm64
  &AArch64InstructionSelector::selectAddrModeWRO<128>, // gi_ro_Windexed128
  &AArch64InstructionSelector::selectAddrModeWRO<16>, // gi_ro_Windexed16
  &AArch64InstructionSelector::selectAddrModeWRO<32>, // gi_ro_Windexed32
  &AArch64InstructionSelector::selectAddrModeWRO<64>, // gi_ro_Windexed64
  &AArch64InstructionSelector::selectAddrModeWRO<8>, // gi_ro_Windexed8
  &AArch64InstructionSelector::selectAddrModeXRO<128>, // gi_ro_Xindexed128
  &AArch64InstructionSelector::selectAddrModeXRO<16>, // gi_ro_Xindexed16
  &AArch64InstructionSelector::selectAddrModeXRO<32>, // gi_ro_Xindexed32
  &AArch64InstructionSelector::selectAddrModeXRO<64>, // gi_ro_Xindexed64
  &AArch64InstructionSelector::selectAddrModeXRO<8>, // gi_ro_Xindexed8
};

// PatFrag predicates.
enum {
  GICXXPred_MI_Predicate_add_and_or_is_add = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_ldaxr_1,
  GICXXPred_MI_Predicate_ldaxr_2,
  GICXXPred_MI_Predicate_ldaxr_4,
  GICXXPred_MI_Predicate_ldaxr_8,
  GICXXPred_MI_Predicate_ldxr_1,
  GICXXPred_MI_Predicate_ldxr_2,
  GICXXPred_MI_Predicate_ldxr_4,
  GICXXPred_MI_Predicate_ldxr_8,
  GICXXPred_MI_Predicate_stlxr_1,
  GICXXPred_MI_Predicate_stlxr_2,
  GICXXPred_MI_Predicate_stlxr_4,
  GICXXPred_MI_Predicate_stlxr_8,
  GICXXPred_MI_Predicate_stxr_1,
  GICXXPred_MI_Predicate_stxr_2,
  GICXXPred_MI_Predicate_stxr_4,
  GICXXPred_MI_Predicate_stxr_8,
};
bool AArch64InstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_add_and_or_is_add: {
    
         return MI.getOpcode() == TargetOpcode::G_ADD ||
                (MI.getOpcode() == TargetOpcode::G_OR &&
                 MI.getFlag(MachineInstr::MIFlag::Disjoint));
      
  }
  case GICXXPred_MI_Predicate_ldaxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_ldaxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_ldaxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_ldaxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_ldxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_ldxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_ldxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_ldxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_stlxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_stlxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_stlxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_stlxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_stxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_stxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_stxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_stxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_VectorIndex0 = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_VectorIndex0_timm,
  GICXXPred_I64_Predicate_VectorIndex1,
  GICXXPred_I64_Predicate_VectorIndex1_timm,
  GICXXPred_I64_Predicate_VectorIndex032b,
  GICXXPred_I64_Predicate_VectorIndex032b_timm,
  GICXXPred_I64_Predicate_VectorIndex132b,
  GICXXPred_I64_Predicate_VectorIndex132b_timm,
  GICXXPred_I64_Predicate_VectorIndexB,
  GICXXPred_I64_Predicate_VectorIndexB32b,
  GICXXPred_I64_Predicate_VectorIndexB32b_timm,
  GICXXPred_I64_Predicate_VectorIndexB_timm,
  GICXXPred_I64_Predicate_VectorIndexD,
  GICXXPred_I64_Predicate_VectorIndexD32b,
  GICXXPred_I64_Predicate_VectorIndexD32b_timm,
  GICXXPred_I64_Predicate_VectorIndexD_timm,
  GICXXPred_I64_Predicate_VectorIndexH,
  GICXXPred_I64_Predicate_VectorIndexH32b,
  GICXXPred_I64_Predicate_VectorIndexH32b_timm,
  GICXXPred_I64_Predicate_VectorIndexH_timm,
  GICXXPred_I64_Predicate_VectorIndexS,
  GICXXPred_I64_Predicate_VectorIndexS32b,
  GICXXPred_I64_Predicate_VectorIndexS32b_timm,
  GICXXPred_I64_Predicate_VectorIndexS_timm,
  GICXXPred_I64_Predicate_complexrotateop,
  GICXXPred_I64_Predicate_complexrotateopodd,
  GICXXPred_I64_Predicate_extq_timm32_0_1m8,
  GICXXPred_I64_Predicate_extq_timm32_0_3m4,
  GICXXPred_I64_Predicate_extq_timm32_0_7m2,
  GICXXPred_I64_Predicate_i64imm_32bit,
  GICXXPred_I64_Predicate_i64imm_32bit_tgt,
  GICXXPred_I64_Predicate_imm0_1,
  GICXXPred_I64_Predicate_imm0_3,
  GICXXPred_I64_Predicate_imm0_7,
  GICXXPred_I64_Predicate_imm0_15,
  GICXXPred_I64_Predicate_imm0_31,
  GICXXPred_I64_Predicate_imm0_63,
  GICXXPred_I64_Predicate_imm0_127,
  GICXXPred_I64_Predicate_imm0_127_64b,
  GICXXPred_I64_Predicate_imm0_255,
  GICXXPred_I64_Predicate_imm32_0_7,
  GICXXPred_I64_Predicate_imm32_0_15,
  GICXXPred_I64_Predicate_imm32_0_31,
  GICXXPred_I64_Predicate_imm64_0_65535,
  GICXXPred_I64_Predicate_maski8_or_more,
  GICXXPred_I64_Predicate_maski16_or_more,
  GICXXPred_I64_Predicate_rprfop,
  GICXXPred_I64_Predicate_s64imm_32bit,
  GICXXPred_I64_Predicate_simm4s1,
  GICXXPred_I64_Predicate_simm4s2,
  GICXXPred_I64_Predicate_simm4s3,
  GICXXPred_I64_Predicate_simm4s4,
  GICXXPred_I64_Predicate_simm4s16,
  GICXXPred_I64_Predicate_simm4s32,
  GICXXPred_I64_Predicate_simm5_8b,
  GICXXPred_I64_Predicate_simm5_8b_tgt,
  GICXXPred_I64_Predicate_simm5_16b,
  GICXXPred_I64_Predicate_simm5_16b_tgt,
  GICXXPred_I64_Predicate_simm5_32b,
  GICXXPred_I64_Predicate_simm5_32b_tgt,
  GICXXPred_I64_Predicate_simm5_64b,
  GICXXPred_I64_Predicate_simm5_64b_tgt,
  GICXXPred_I64_Predicate_simm6_32b,
  GICXXPred_I64_Predicate_simm6s1,
  GICXXPred_I64_Predicate_simm8_32b,
  GICXXPred_I64_Predicate_simm8_64b,
  GICXXPred_I64_Predicate_simm9,
  GICXXPred_I64_Predicate_sme_elm_idx0_0,
  GICXXPred_I64_Predicate_sme_elm_idx0_1,
  GICXXPred_I64_Predicate_sme_elm_idx0_3,
  GICXXPred_I64_Predicate_sme_elm_idx0_7,
  GICXXPred_I64_Predicate_sme_elm_idx0_15,
  GICXXPred_I64_Predicate_svcr_op,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_b,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_b_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_d,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_d_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_h,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_h_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_q,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_q_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_s,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_s_timm,
  GICXXPred_I64_Predicate_sve_incdec_imm,
  GICXXPred_I64_Predicate_sve_pred_enum,
  GICXXPred_I64_Predicate_sve_prfop,
  GICXXPred_I64_Predicate_sve_vec_len_specifier_enum,
  GICXXPred_I64_Predicate_tbz_imm0_31_diag,
  GICXXPred_I64_Predicate_tbz_imm0_31_nodiag,
  GICXXPred_I64_Predicate_tbz_imm32_63,
  GICXXPred_I64_Predicate_timm0_1,
  GICXXPred_I64_Predicate_timm0_31,
  GICXXPred_I64_Predicate_timm0_63,
  GICXXPred_I64_Predicate_timm32_0_0,
  GICXXPred_I64_Predicate_timm32_0_1,
  GICXXPred_I64_Predicate_timm32_0_3,
  GICXXPred_I64_Predicate_timm32_0_7,
  GICXXPred_I64_Predicate_timm32_0_15,
  GICXXPred_I64_Predicate_timm32_0_31,
  GICXXPred_I64_Predicate_timm32_0_255,
  GICXXPred_I64_Predicate_timm32_0_65535,
  GICXXPred_I64_Predicate_timm32_1_1,
  GICXXPred_I64_Predicate_timm32_1_3,
  GICXXPred_I64_Predicate_timm32_1_7,
  GICXXPred_I64_Predicate_timm64_0_65535,
  GICXXPred_I64_Predicate_tuimm5s2,
  GICXXPred_I64_Predicate_tuimm5s4,
  GICXXPred_I64_Predicate_tuimm5s8,
  GICXXPred_I64_Predicate_tvecshiftL8,
  GICXXPred_I64_Predicate_tvecshiftL16,
  GICXXPred_I64_Predicate_tvecshiftL32,
  GICXXPred_I64_Predicate_tvecshiftL64,
  GICXXPred_I64_Predicate_tvecshiftR8,
  GICXXPred_I64_Predicate_tvecshiftR16,
  GICXXPred_I64_Predicate_tvecshiftR32,
  GICXXPred_I64_Predicate_tvecshiftR64,
  GICXXPred_I64_Predicate_ubsan_trap_imm,
  GICXXPred_I64_Predicate_uimm0s2range,
  GICXXPred_I64_Predicate_uimm0s4range,
  GICXXPred_I64_Predicate_uimm1s2range,
  GICXXPred_I64_Predicate_uimm1s4range,
  GICXXPred_I64_Predicate_uimm2s2range,
  GICXXPred_I64_Predicate_uimm2s4range,
  GICXXPred_I64_Predicate_uimm3s2range,
  GICXXPred_I64_Predicate_uimm3s8,
  GICXXPred_I64_Predicate_uimm5s2,
  GICXXPred_I64_Predicate_uimm5s4,
  GICXXPred_I64_Predicate_uimm5s8,
  GICXXPred_I64_Predicate_uimm6,
  GICXXPred_I64_Predicate_uimm6_32b,
  GICXXPred_I64_Predicate_uimm6_64b,
  GICXXPred_I64_Predicate_uimm6s1,
  GICXXPred_I64_Predicate_uimm6s2,
  GICXXPred_I64_Predicate_uimm6s4,
  GICXXPred_I64_Predicate_uimm6s8,
  GICXXPred_I64_Predicate_uimm6s16,
  GICXXPred_I64_Predicate_uimm8_32b,
  GICXXPred_I64_Predicate_uimm8_64b,
  GICXXPred_I64_Predicate_uimm16,
  GICXXPred_I64_Predicate_vecshiftL8,
  GICXXPred_I64_Predicate_vecshiftL16,
  GICXXPred_I64_Predicate_vecshiftL32,
  GICXXPred_I64_Predicate_vecshiftL64,
  GICXXPred_I64_Predicate_vecshiftR8,
  GICXXPred_I64_Predicate_vecshiftR16,
  GICXXPred_I64_Predicate_vecshiftR16Narrow,
  GICXXPred_I64_Predicate_vecshiftR32,
  GICXXPred_I64_Predicate_vecshiftR32Narrow,
  GICXXPred_I64_Predicate_vecshiftR64,
  GICXXPred_I64_Predicate_vecshiftR64Narrow,
};
bool AArch64InstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_VectorIndex0: {
     return ((uint64_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex0_timm: {
     return ((uint64_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex1: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex1_timm: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex032b: {
     return ((uint32_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex032b_timm: {
     return ((uint32_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex132b: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex132b_timm: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB32b: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB32b_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD32b: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD32b_timm: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD_timm: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH32b: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH32b_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS32b: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS32b_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_complexrotateop: {
     return Imm >= 0 && Imm <= 270;  
  }
  case GICXXPred_I64_Predicate_complexrotateopodd: {
     return Imm >= 0 && Imm <= 270;  
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_1m8: {
    
      return ((uint32_t)Imm) < 2;
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_3m4: {
    
      return ((uint32_t)Imm) < 4;
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_7m2: {
    
      return ((uint32_t)Imm) < 8;
  }
  case GICXXPred_I64_Predicate_i64imm_32bit: {
    
      return (Imm & 0xffffffffULL) == static_cast<uint64_t>(Imm);
    
  }
  case GICXXPred_I64_Predicate_i64imm_32bit_tgt: {
    
      return (Imm & 0xffffffffULL) == static_cast<uint64_t>(Imm);
    
  }
  case GICXXPred_I64_Predicate_imm0_1: {
    
      return ((uint64_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_imm0_3: {
    
      return ((uint64_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_imm0_7: {
    
      return ((uint64_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_imm0_15: {
    
      return ((uint64_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_imm0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_imm0_63: {
    
      return ((uint64_t)Imm) < 64;
    
  }
  case GICXXPred_I64_Predicate_imm0_127: {
    
      return ((uint32_t)Imm) < 128;
    
  }
  case GICXXPred_I64_Predicate_imm0_127_64b: {
    
      return ((uint64_t)Imm) < 128;
    
  }
  case GICXXPred_I64_Predicate_imm0_255: {
    
      return ((uint32_t)Imm) < 256;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_7: {
    
      return ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_15: {
    
      return ((uint32_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_imm64_0_65535: {
    
      return ((uint64_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_maski8_or_more: {
     return (Imm & 0xff) == 0xff; 
  }
  case GICXXPred_I64_Predicate_maski16_or_more: {
     return (Imm & 0xffff) == 0xffff; 
  }
  case GICXXPred_I64_Predicate_rprfop: {
    
        return (((uint32_t)Imm) <= 63);
      
  }
  case GICXXPred_I64_Predicate_s64imm_32bit: {
    
      int64_t Imm64 = static_cast<int64_t>(Imm);
      return Imm64 >= std::numeric_limits<int32_t>::min() &&
             Imm64 <= std::numeric_limits<int32_t>::max();
    
    llvm_unreachable("s64imm_32bit should have returned");
  }
  case GICXXPred_I64_Predicate_simm4s1: {
     return Imm >=-8  && Imm <= 7; 
  }
  case GICXXPred_I64_Predicate_simm4s2: {
     return Imm >=-16  && Imm <= 14 && (Imm % 2) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s3: {
     return Imm >=-24  && Imm <= 21 && (Imm % 3) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s4: {
     return Imm >=-32  && Imm <= 28 && (Imm % 4) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s16: {
     return Imm >=-128  && Imm <= 112 && (Imm % 16) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s32: {
     return Imm >=-256  && Imm <= 224 && (Imm % 32) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm5_8b: {
     return (int8_t)Imm >= -16 && (int8_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_8b_tgt: {
     return (int8_t)Imm >= -16 && (int8_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_16b: {
     return (int16_t)Imm >= -16 && (int16_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_16b_tgt: {
     return (int16_t)Imm >= -16 && (int16_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_32b: {
     return Imm >= -16 && Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_32b_tgt: {
     return (int32_t)Imm >= -16 && (int32_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_64b: {
     return Imm >= -16 && Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_64b_tgt: {
     return (int64_t)Imm >= -16 && (int64_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm6_32b: {
     return Imm >= -32 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_simm6s1: {
     return Imm >= -32 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_simm8_32b: {
     return Imm >= -128 && Imm < 128; 
  }
  case GICXXPred_I64_Predicate_simm8_64b: {
     return Imm >= -128 && Imm < 128; 
  }
  case GICXXPred_I64_Predicate_simm9: {
     return Imm >= -256 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_0: {
    
      return ((uint32_t)Imm) == 0;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_1: {
    
      return ((uint32_t)Imm) <= 1;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_3: {
    
      return ((uint32_t)Imm) <= 3;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_7: {
    
      return ((uint32_t)Imm) <= 7;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_15: {
    
      return ((uint32_t)Imm) <= 15;
    
  }
  case GICXXPred_I64_Predicate_svcr_op: {
    
        return AArch64SVCR::lookupSVCRByEncoding(Imm) != nullptr;
      
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_b: {
     return ((uint64_t)Imm) < 64; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_b_timm: {
     return ((uint64_t)Imm) < 64; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_d: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_d_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_h: {
     return ((uint64_t)Imm) < 32; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_h_timm: {
     return ((uint64_t)Imm) < 32; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_q: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_q_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_s: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_s_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_sve_incdec_imm: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_sve_pred_enum: {
    
      return (((uint32_t)Imm) < 32);
      
  }
  case GICXXPred_I64_Predicate_sve_prfop: {
    
        return (((uint32_t)Imm) <= 15);
      
  }
  case GICXXPred_I64_Predicate_sve_vec_len_specifier_enum: {
    
      return (((uint32_t)Imm) < 2);
      
  }
  case GICXXPred_I64_Predicate_tbz_imm0_31_diag: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tbz_imm0_31_nodiag: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tbz_imm32_63: {
    
      return (((uint32_t)Imm) > 31) && (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_timm0_1: {
    
      return ((uint64_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_timm0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_timm0_63: {
    
      return ((uint64_t)Imm) < 64;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_0: {
    
      return ((uint32_t)Imm) == 0;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_1: {
    
      return ((uint32_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_3: {
    
      return ((uint32_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_7: {
    
      return ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_15: {
    
      return ((uint32_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_31: {
    
      return ((uint32_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_255: {
    
      return ((uint32_t)Imm) < 256;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_65535: {
    
      return ((uint32_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_1: {
    
        return ((uint32_t)Imm) == 1;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_3: {
    
      return ((uint32_t)Imm) > 0 && ((uint32_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_7: {
    
      return ((uint32_t)Imm) > 0 && ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_timm64_0_65535: {
    
      return ((uint64_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_tuimm5s2: {
     return Imm >= 0 && Imm < (32*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_tuimm5s4: {
     return Imm >= 0 && Imm < (32*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_tuimm5s8: {
     return Imm >= 0 && Imm < (32*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_tvecshiftL8: {
    
      return (((uint32_t)Imm) < 8);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL16: {
    
      return (((uint32_t)Imm) < 16);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL32: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL64: {
    
      return (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR8: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR16: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR32: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR64: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 65);
    
  }
  case GICXXPred_I64_Predicate_ubsan_trap_imm: {
    
      return isUInt<8>(Imm);
    
  }
  case GICXXPred_I64_Predicate_uimm0s2range: {
     return Imm == 0; 
  }
  case GICXXPred_I64_Predicate_uimm0s4range: {
     return Imm == 0; 
  }
  case GICXXPred_I64_Predicate_uimm1s2range: {
     return Imm >= 0 && Imm <= 2 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm1s4range: {
     return Imm >= 0 && Imm <= 4 && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm2s2range: {
     return Imm >= 0 && Imm <= 6 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm2s4range: {
     return Imm >= 0 && Imm <= 12 && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm3s2range: {
     return Imm >= 0 && Imm <= 14 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm3s8: {
     return Imm >= 0 && Imm <= 56 && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s2: {
     return Imm >= 0 && Imm < (32*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s4: {
     return Imm >= 0 && Imm < (32*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s8: {
     return Imm >= 0 && Imm < (32*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6_32b: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6_64b: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6s1: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6s2: {
     return Imm >= 0 && Imm < (64*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s4: {
     return Imm >= 0 && Imm < (64*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s8: {
     return Imm >= 0 && Imm < (64*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s16: {
     return Imm >= 0 && Imm < (64*16) && ((Imm % 16) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm8_32b: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_uimm8_64b: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_uimm16: {
    return Imm >= 0 && Imm < 65536;
  }
  case GICXXPred_I64_Predicate_vecshiftL8: {
    
      return (((uint32_t)Imm) < 8);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL16: {
    
      return (((uint32_t)Imm) < 16);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL32: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL64: {
    
      return (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR8: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR16: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR16Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR32: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR32Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR64: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 65);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR64Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APFloat_Predicate_fpimm0 = GICXXPred_Invalid + 1,
  GICXXPred_APFloat_Predicate_fpimm16,
  GICXXPred_APFloat_Predicate_fpimm32,
  GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4,
  GICXXPred_APFloat_Predicate_fpimm64,
  GICXXPred_APFloat_Predicate_fpimm_half,
  GICXXPred_APFloat_Predicate_fpimm_minus0,
  GICXXPred_APFloat_Predicate_fpimm_one,
  GICXXPred_APFloat_Predicate_fpimm_two,
  GICXXPred_APFloat_Predicate_fpimmbf16,
  GICXXPred_APFloat_Predicate_simdimmtype10,
};
bool AArch64InstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APFloat_Predicate_fpimm0: {
    
      return Imm.isExactlyValue(+0.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm16: {
    
          return AArch64_AM::getFP16Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm32: {
    
          return AArch64_AM::getFP32Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4: {
    
          uint64_t Enc = Imm.bitcastToAPInt().getZExtValue();
          return Enc != 0 && AArch64_AM::isAdvSIMDModImmType4(Enc << 32 | Enc);
        
    llvm_unreachable("fpimm32SIMDModImmType4 should have returned");
  }
  case GICXXPred_APFloat_Predicate_fpimm64: {
    
          return AArch64_AM::getFP64Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm_half: {
    
      return Imm.isExactlyValue(+0.5);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_minus0: {
    
      return Imm.isExactlyValue(-0.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_one: {
    
      return Imm.isExactlyValue(+1.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_two: {
    
      return Imm.isExactlyValue(+2.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimmbf16: {
    
          return AArch64_AM::getFP16Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_simdimmtype10: {
    
          return AArch64_AM::isAdvSIMDModImmType10(
                     Imm.bitcastToAPInt().getZExtValue());
        
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APInt_Predicate_logical_imm32 = GICXXPred_Invalid + 1,
  GICXXPred_APInt_Predicate_logical_imm64,
};
bool AArch64InstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APInt_Predicate_logical_imm32: {
    
      return AArch64_AM::isLogicalImmediate(Imm.getZExtValue(), 32);
    
  }
  case GICXXPred_APInt_Predicate_logical_imm64: {
    
      return AArch64_AM::isLogicalImmediate(Imm.getZExtValue(), 64);
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AArch64InstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("AArch64InstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
  GICR_renderFPImm16,
  GICR_renderFPImm32,
  GICR_renderFPImm32SIMDModImmType4,
  GICR_renderFPImm64,
  GICR_renderLogicalImm32,
  GICR_renderLogicalImm64,
  GICR_renderTruncImm,
  GICR_renderUbsanTrap,
};
AArch64InstructionSelector::CustomRendererFn
AArch64InstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
  &AArch64InstructionSelector::renderFPImm16,
  &AArch64InstructionSelector::renderFPImm32,
  &AArch64InstructionSelector::renderFPImm32SIMDModImmType4,
  &AArch64InstructionSelector::renderFPImm64,
  &AArch64InstructionSelector::renderLogicalImm32,
  &AArch64InstructionSelector::renderLogicalImm64,
  &AArch64InstructionSelector::renderTruncImm,
  &AArch64InstructionSelector::renderUbsanTrap,
};

bool AArch64InstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool AArch64InstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("AArch64InstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *AArch64InstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*      0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(841), /*)*//*default:*//*Label 154*/ GIMT_Encode4(402538),
     /*     10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(3162),
     /*     14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(34665),
     /*     18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(48013),
     /*     22 */ /*TargetOpcode::G_SDIV*//*Label 3*/ GIMT_Encode4(49842),
     /*     26 */ /*TargetOpcode::G_UDIV*//*Label 4*/ GIMT_Encode4(49924), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     46 */ /*TargetOpcode::G_AND*//*Label 5*/ GIMT_Encode4(50006),
     /*     50 */ /*TargetOpcode::G_OR*//*Label 6*/ GIMT_Encode4(57752),
     /*     54 */ /*TargetOpcode::G_XOR*//*Label 7*/ GIMT_Encode4(69799), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    114 */ /*TargetOpcode::G_CONCAT_VECTORS*//*Label 8*/ GIMT_Encode4(75738), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    126 */ /*TargetOpcode::G_BITCAST*//*Label 9*/ GIMT_Encode4(83262), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    142 */ /*TargetOpcode::G_INTRINSIC_TRUNC*//*Label 10*/ GIMT_Encode4(93206),
     /*    146 */ /*TargetOpcode::G_INTRINSIC_ROUND*//*Label 11*/ GIMT_Encode4(93697),
     /*    150 */ /*TargetOpcode::G_INTRINSIC_LRINT*//*Label 12*/ GIMT_Encode4(94188),
     /*    154 */ /*TargetOpcode::G_INTRINSIC_LLRINT*//*Label 13*/ GIMT_Encode4(94456),
     /*    158 */ /*TargetOpcode::G_INTRINSIC_ROUNDEVEN*//*Label 14*/ GIMT_Encode4(94606),
     /*    162 */ /*TargetOpcode::G_READCYCLECOUNTER*//*Label 15*/ GIMT_Encode4(95097), GIMT_Encode4(0),
     /*    170 */ /*TargetOpcode::G_LOAD*//*Label 16*/ GIMT_Encode4(95130),
     /*    174 */ /*TargetOpcode::G_SEXTLOAD*//*Label 17*/ GIMT_Encode4(103726),
     /*    178 */ /*TargetOpcode::G_ZEXTLOAD*//*Label 18*/ GIMT_Encode4(104776), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    194 */ /*TargetOpcode::G_STORE*//*Label 19*/ GIMT_Encode4(107745), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    206 */ /*TargetOpcode::G_ATOMIC_CMPXCHG*//*Label 20*/ GIMT_Encode4(121057),
     /*    210 */ /*TargetOpcode::G_ATOMICRMW_XCHG*//*Label 21*/ GIMT_Encode4(122408),
     /*    214 */ /*TargetOpcode::G_ATOMICRMW_ADD*//*Label 22*/ GIMT_Encode4(123400),
     /*    218 */ /*TargetOpcode::G_ATOMICRMW_SUB*//*Label 23*/ GIMT_Encode4(124392),
     /*    222 */ /*TargetOpcode::G_ATOMICRMW_AND*//*Label 24*/ GIMT_Encode4(125884), GIMT_Encode4(0),
     /*    230 */ /*TargetOpcode::G_ATOMICRMW_OR*//*Label 25*/ GIMT_Encode4(127376),
     /*    234 */ /*TargetOpcode::G_ATOMICRMW_XOR*//*Label 26*/ GIMT_Encode4(128368),
     /*    238 */ /*TargetOpcode::G_ATOMICRMW_MAX*//*Label 27*/ GIMT_Encode4(129360),
     /*    242 */ /*TargetOpcode::G_ATOMICRMW_MIN*//*Label 28*/ GIMT_Encode4(130352),
     /*    246 */ /*TargetOpcode::G_ATOMICRMW_UMAX*//*Label 29*/ GIMT_Encode4(131344),
     /*    250 */ /*TargetOpcode::G_ATOMICRMW_UMIN*//*Label 30*/ GIMT_Encode4(132336), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    286 */ /*TargetOpcode::G_FENCE*//*Label 31*/ GIMT_Encode4(133328), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    306 */ /*TargetOpcode::G_INTRINSIC*//*Label 32*/ GIMT_Encode4(133379),
     /*    310 */ /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 33*/ GIMT_Encode4(243112), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    322 */ /*TargetOpcode::G_ANYEXT*//*Label 34*/ GIMT_Encode4(253368),
     /*    326 */ /*TargetOpcode::G_TRUNC*//*Label 35*/ GIMT_Encode4(253658),
     /*    330 */ /*TargetOpcode::G_CONSTANT*//*Label 36*/ GIMT_Encode4(255095),
     /*    334 */ /*TargetOpcode::G_FCONSTANT*//*Label 37*/ GIMT_Encode4(255215), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    346 */ /*TargetOpcode::G_SEXT*//*Label 38*/ GIMT_Encode4(255456),
     /*    350 */ /*TargetOpcode::G_SEXT_INREG*//*Label 39*/ GIMT_Encode4(257354),
     /*    354 */ /*TargetOpcode::G_ZEXT*//*Label 40*/ GIMT_Encode4(259008),
     /*    358 */ /*TargetOpcode::G_SHL*//*Label 41*/ GIMT_Encode4(261787),
     /*    362 */ /*TargetOpcode::G_LSHR*//*Label 42*/ GIMT_Encode4(262567),
     /*    366 */ /*TargetOpcode::G_ASHR*//*Label 43*/ GIMT_Encode4(262960), GIMT_Encode4(0),
     /*    374 */ /*TargetOpcode::G_FSHR*//*Label 44*/ GIMT_Encode4(263736),
     /*    378 */ /*TargetOpcode::G_ROTR*//*Label 45*/ GIMT_Encode4(263866), GIMT_Encode4(0),
     /*    386 */ /*TargetOpcode::G_ICMP*//*Label 46*/ GIMT_Encode4(264359), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    402 */ /*TargetOpcode::G_SELECT*//*Label 47*/ GIMT_Encode4(268935), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    446 */ /*TargetOpcode::G_UMULH*//*Label 48*/ GIMT_Encode4(269641),
     /*    450 */ /*TargetOpcode::G_SMULH*//*Label 49*/ GIMT_Encode4(270125),
     /*    454 */ /*TargetOpcode::G_UADDSAT*//*Label 50*/ GIMT_Encode4(270609),
     /*    458 */ /*TargetOpcode::G_SADDSAT*//*Label 51*/ GIMT_Encode4(271039),
     /*    462 */ /*TargetOpcode::G_USUBSAT*//*Label 52*/ GIMT_Encode4(271469),
     /*    466 */ /*TargetOpcode::G_SSUBSAT*//*Label 53*/ GIMT_Encode4(271899), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    510 */ /*TargetOpcode::G_FADD*//*Label 54*/ GIMT_Encode4(272329),
     /*    514 */ /*TargetOpcode::G_FSUB*//*Label 55*/ GIMT_Encode4(274127),
     /*    518 */ /*TargetOpcode::G_FMUL*//*Label 56*/ GIMT_Encode4(274865),
     /*    522 */ /*TargetOpcode::G_FMA*//*Label 57*/ GIMT_Encode4(278961), GIMT_Encode4(0),
     /*    530 */ /*TargetOpcode::G_FDIV*//*Label 58*/ GIMT_Encode4(295234), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    578 */ /*TargetOpcode::G_FNEG*//*Label 59*/ GIMT_Encode4(295850),
     /*    582 */ /*TargetOpcode::G_FPEXT*//*Label 60*/ GIMT_Encode4(299357),
     /*    586 */ /*TargetOpcode::G_FPTRUNC*//*Label 61*/ GIMT_Encode4(299605),
     /*    590 */ /*TargetOpcode::G_FPTOSI*//*Label 62*/ GIMT_Encode4(299793),
     /*    594 */ /*TargetOpcode::G_FPTOUI*//*Label 63*/ GIMT_Encode4(300856),
     /*    598 */ /*TargetOpcode::G_SITOFP*//*Label 64*/ GIMT_Encode4(301919),
     /*    602 */ /*TargetOpcode::G_UITOFP*//*Label 65*/ GIMT_Encode4(306316),
     /*    606 */ /*TargetOpcode::G_FPTOSI_SAT*//*Label 66*/ GIMT_Encode4(310091),
     /*    610 */ /*TargetOpcode::G_FPTOUI_SAT*//*Label 67*/ GIMT_Encode4(310411),
     /*    614 */ /*TargetOpcode::G_FABS*//*Label 68*/ GIMT_Encode4(310731), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    626 */ /*TargetOpcode::G_FCANONICALIZE*//*Label 69*/ GIMT_Encode4(311588),
     /*    630 */ /*TargetOpcode::G_FMINNUM*//*Label 70*/ GIMT_Encode4(311870),
     /*    634 */ /*TargetOpcode::G_FMAXNUM*//*Label 71*/ GIMT_Encode4(312248),
     /*    638 */ /*TargetOpcode::G_FMINNUM_IEEE*//*Label 72*/ GIMT_Encode4(312626),
     /*    642 */ /*TargetOpcode::G_FMAXNUM_IEEE*//*Label 73*/ GIMT_Encode4(312976),
     /*    646 */ /*TargetOpcode::G_FMINIMUM*//*Label 74*/ GIMT_Encode4(313326),
     /*    650 */ /*TargetOpcode::G_FMAXIMUM*//*Label 75*/ GIMT_Encode4(314029), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    686 */ /*TargetOpcode::G_SMIN*//*Label 76*/ GIMT_Encode4(314732),
     /*    690 */ /*TargetOpcode::G_SMAX*//*Label 77*/ GIMT_Encode4(315136),
     /*    694 */ /*TargetOpcode::G_UMIN*//*Label 78*/ GIMT_Encode4(315540),
     /*    698 */ /*TargetOpcode::G_UMAX*//*Label 79*/ GIMT_Encode4(315944),
     /*    702 */ /*TargetOpcode::G_ABS*//*Label 80*/ GIMT_Encode4(316348),
     /*    706 */ /*TargetOpcode::G_LROUND*//*Label 81*/ GIMT_Encode4(317163),
     /*    710 */ /*TargetOpcode::G_LLROUND*//*Label 82*/ GIMT_Encode4(317329),
     /*    714 */ /*TargetOpcode::G_BR*//*Label 83*/ GIMT_Encode4(317428), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    730 */ /*TargetOpcode::G_EXTRACT_SUBVECTOR*//*Label 84*/ GIMT_Encode4(317444),
     /*    734 */ /*TargetOpcode::G_INSERT_VECTOR_ELT*//*Label 85*/ GIMT_Encode4(322456),
     /*    738 */ /*TargetOpcode::G_EXTRACT_VECTOR_ELT*//*Label 86*/ GIMT_Encode4(349853), GIMT_Encode4(0),
     /*    746 */ /*TargetOpcode::G_SPLAT_VECTOR*//*Label 87*/ GIMT_Encode4(352771), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    758 */ /*TargetOpcode::G_CTTZ*//*Label 88*/ GIMT_Encode4(354477), GIMT_Encode4(0),
     /*    766 */ /*TargetOpcode::G_CTLZ*//*Label 89*/ GIMT_Encode4(354629), GIMT_Encode4(0),
     /*    774 */ /*TargetOpcode::G_CTPOP*//*Label 90*/ GIMT_Encode4(355303),
     /*    778 */ /*TargetOpcode::G_BSWAP*//*Label 91*/ GIMT_Encode4(355463),
     /*    782 */ /*TargetOpcode::G_BITREVERSE*//*Label 92*/ GIMT_Encode4(355777),
     /*    786 */ /*TargetOpcode::G_FCEIL*//*Label 93*/ GIMT_Encode4(355931), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    834 */ /*TargetOpcode::G_FSQRT*//*Label 94*/ GIMT_Encode4(356422),
     /*    838 */ /*TargetOpcode::G_FFLOOR*//*Label 95*/ GIMT_Encode4(356722),
     /*    842 */ /*TargetOpcode::G_FRINT*//*Label 96*/ GIMT_Encode4(357213),
     /*    846 */ /*TargetOpcode::G_FNEARBYINT*//*Label 97*/ GIMT_Encode4(357704), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    874 */ /*TargetOpcode::G_STRICT_FADD*//*Label 98*/ GIMT_Encode4(358195),
     /*    878 */ /*TargetOpcode::G_STRICT_FSUB*//*Label 99*/ GIMT_Encode4(359321),
     /*    882 */ /*TargetOpcode::G_STRICT_FMUL*//*Label 100*/ GIMT_Encode4(359937),
     /*    886 */ /*TargetOpcode::G_STRICT_FDIV*//*Label 101*/ GIMT_Encode4(363659), GIMT_Encode4(0),
     /*    894 */ /*TargetOpcode::G_STRICT_FMA*//*Label 102*/ GIMT_Encode4(364275),
     /*    898 */ /*TargetOpcode::G_STRICT_FSQRT*//*Label 103*/ GIMT_Encode4(379882), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    934 */ /*TargetOpcode::G_TRAP*//*Label 104*/ GIMT_Encode4(380182),
     /*    938 */ /*TargetOpcode::G_DEBUGTRAP*//*Label 105*/ GIMT_Encode4(380196),
     /*    942 */ /*TargetOpcode::G_UBSANTRAP*//*Label 106*/ GIMT_Encode4(380217), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    954 */ /*TargetOpcode::G_VECREDUCE_FADD*//*Label 107*/ GIMT_Encode4(380242), GIMT_Encode4(0),
     /*    962 */ /*TargetOpcode::G_VECREDUCE_FMAX*//*Label 108*/ GIMT_Encode4(380552),
     /*    966 */ /*TargetOpcode::G_VECREDUCE_FMIN*//*Label 109*/ GIMT_Encode4(380723),
     /*    970 */ /*TargetOpcode::G_VECREDUCE_FMAXIMUM*//*Label 110*/ GIMT_Encode4(380894),
     /*    974 */ /*TargetOpcode::G_VECREDUCE_FMINIMUM*//*Label 111*/ GIMT_Encode4(381065),
     /*    978 */ /*TargetOpcode::G_VECREDUCE_ADD*//*Label 112*/ GIMT_Encode4(381236), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    998 */ /*TargetOpcode::G_VECREDUCE_SMAX*//*Label 113*/ GIMT_Encode4(382365),
     /*   1002 */ /*TargetOpcode::G_VECREDUCE_SMIN*//*Label 114*/ GIMT_Encode4(382568),
     /*   1006 */ /*TargetOpcode::G_VECREDUCE_UMAX*//*Label 115*/ GIMT_Encode4(382771),
     /*   1010 */ /*TargetOpcode::G_VECREDUCE_UMIN*//*Label 116*/ GIMT_Encode4(382974), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   3010 */ /*AArch64::G_AARCH64_PREFETCH*//*Label 117*/ GIMT_Encode4(383177), GIMT_Encode4(0),
     /*   3018 */ /*AArch64::G_BSP*//*Label 118*/ GIMT_Encode4(383317),
     /*   3022 */ /*AArch64::G_DUP*//*Label 119*/ GIMT_Encode4(383857),
     /*   3026 */ /*AArch64::G_DUPLANE16*//*Label 120*/ GIMT_Encode4(385680),
     /*   3030 */ /*AArch64::G_DUPLANE32*//*Label 121*/ GIMT_Encode4(385935),
     /*   3034 */ /*AArch64::G_DUPLANE64*//*Label 122*/ GIMT_Encode4(386190),
     /*   3038 */ /*AArch64::G_DUPLANE8*//*Label 123*/ GIMT_Encode4(386336),
     /*   3042 */ /*AArch64::G_EXT*//*Label 124*/ GIMT_Encode4(386515),
     /*   3046 */ /*AArch64::G_FCMEQ*//*Label 125*/ GIMT_Encode4(388165),
     /*   3050 */ /*AArch64::G_FCMEQZ*//*Label 126*/ GIMT_Encode4(388504),
     /*   3054 */ /*AArch64::G_FCMGE*//*Label 127*/ GIMT_Encode4(388734),
     /*   3058 */ /*AArch64::G_FCMGEZ*//*Label 128*/ GIMT_Encode4(389398),
     /*   3062 */ /*AArch64::G_FCMGT*//*Label 129*/ GIMT_Encode4(389628),
     /*   3066 */ /*AArch64::G_FCMGTZ*//*Label 130*/ GIMT_Encode4(390292),
     /*   3070 */ /*AArch64::G_FCMLEZ*//*Label 131*/ GIMT_Encode4(390522),
     /*   3074 */ /*AArch64::G_FCMLTZ*//*Label 132*/ GIMT_Encode4(390752),
     /*   3078 */ /*AArch64::G_REV16*//*Label 133*/ GIMT_Encode4(390982),
     /*   3082 */ /*AArch64::G_REV32*//*Label 134*/ GIMT_Encode4(391136),
     /*   3086 */ /*AArch64::G_REV64*//*Label 135*/ GIMT_Encode4(391312),
     /*   3090 */ /*AArch64::G_SADDLP*//*Label 136*/ GIMT_Encode4(391586),
     /*   3094 */ /*AArch64::G_SADDLV*//*Label 137*/ GIMT_Encode4(391792),
     /*   3098 */ /*AArch64::G_SDOT*//*Label 138*/ GIMT_Encode4(392191),
     /*   3102 */ /*AArch64::G_SITOF*//*Label 139*/ GIMT_Encode4(392561),
     /*   3106 */ /*AArch64::G_SMULL*//*Label 140*/ GIMT_Encode4(392678),
     /*   3110 */ /*AArch64::G_TRN1*//*Label 141*/ GIMT_Encode4(393911),
     /*   3114 */ /*AArch64::G_TRN2*//*Label 142*/ GIMT_Encode4(394691),
     /*   3118 */ /*AArch64::G_UADDLP*//*Label 143*/ GIMT_Encode4(395471),
     /*   3122 */ /*AArch64::G_UADDLV*//*Label 144*/ GIMT_Encode4(395677),
     /*   3126 */ /*AArch64::G_UDOT*//*Label 145*/ GIMT_Encode4(396544),
     /*   3130 */ /*AArch64::G_UITOF*//*Label 146*/ GIMT_Encode4(396914),
     /*   3134 */ /*AArch64::G_UMULL*//*Label 147*/ GIMT_Encode4(397031),
     /*   3138 */ /*AArch64::G_UZP1*//*Label 148*/ GIMT_Encode4(398264),
     /*   3142 */ /*AArch64::G_UZP2*//*Label 149*/ GIMT_Encode4(399044),
     /*   3146 */ /*AArch64::G_VASHR*//*Label 150*/ GIMT_Encode4(399824),
     /*   3150 */ /*AArch64::G_VLSHR*//*Label 151*/ GIMT_Encode4(400522),
     /*   3154 */ /*AArch64::G_ZIP1*//*Label 152*/ GIMT_Encode4(400978),
     /*   3158 */ /*AArch64::G_ZIP2*//*Label 153*/ GIMT_Encode4(401758),
     /*   3162 */ // Label 0: @3162
     /*   3162 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 168*/ GIMT_Encode4(34664),
     /*   3173 */ /*GILLT_s32*//*Label 155*/ GIMT_Encode4(3261),
     /*   3177 */ /*GILLT_s64*//*Label 156*/ GIMT_Encode4(4784), GIMT_Encode4(0),
     /*   3185 */ /*GILLT_v2s32*//*Label 157*/ GIMT_Encode4(9876),
     /*   3189 */ /*GILLT_v2s64*//*Label 158*/ GIMT_Encode4(13484),
     /*   3193 */ /*GILLT_v4s16*//*Label 159*/ GIMT_Encode4(19386),
     /*   3197 */ /*GILLT_v4s32*//*Label 160*/ GIMT_Encode4(22884),
     /*   3201 */ /*GILLT_v8s8*//*Label 161*/ GIMT_Encode4(29062),
     /*   3205 */ /*GILLT_v8s16*//*Label 162*/ GIMT_Encode4(29912),
     /*   3209 */ /*GILLT_v16s8*//*Label 163*/ GIMT_Encode4(33490), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   3229 */ /*GILLT_nxv2s64*//*Label 164*/ GIMT_Encode4(34214), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   3241 */ /*GILLT_nxv4s32*//*Label 165*/ GIMT_Encode4(34586), GIMT_Encode4(0),
     /*   3249 */ /*GILLT_nxv8s16*//*Label 166*/ GIMT_Encode4(34612), GIMT_Encode4(0),
     /*   3257 */ /*GILLT_nxv16s8*//*Label 167*/ GIMT_Encode4(34638),
     /*   3261 */ // Label 155: @3261
     /*   3261 */ GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(4783),
     /*   3266 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   3269 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   3272 */   GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(3305), // Rule ID 12920 //
     /*   3277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   3281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   3285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
     /*   3292 */     // (add:{ *:[i32] } addsub_shifted_imm32:{ *:[i32] }:$imm, GPR32sp:{ *:[i32] }:$Rn)  =>  (ADDWri:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   3292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
     /*   3295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   3299 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   3303 */     GIR_RootConstrainSelectedInstOperands,
     /*   3304 */     // GIR_Coverage, 12920,
     /*   3304 */     GIR_EraseRootFromParent_Done,
     /*   3305 */   // Label 170: @3305
     /*   3305 */   GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(3457), // Rule ID 13347 //
     /*   3310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3329 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3333 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3337 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3340 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   3345 */     // MIs[2] pattern
     /*   3345 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3348 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3357 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3359 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1238:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3359 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3362 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3366 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3371 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3373 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   3376 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   3380 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3385 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   3388 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   3392 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   3395 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3400 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3405 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3410 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   3413 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   3417 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3422 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   3425 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   3429 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   3432 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   3434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   3437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3439 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   3446 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3451 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   3456 */     // GIR_Coverage, 13347,
     /*   3456 */     GIR_EraseRootFromParent_Done,
     /*   3457 */   // Label 171: @3457
     /*   3457 */   GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(3609), // Rule ID 15204 //
     /*   3462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3477 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3481 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3485 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3489 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3492 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   3497 */     // MIs[2] pattern
     /*   3497 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3500 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3509 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3511 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1240:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3511 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3514 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3518 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3523 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3525 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   3528 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   3532 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3537 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   3540 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   3544 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   3547 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3552 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3557 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3562 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   3565 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   3569 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3574 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   3577 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   3581 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   3584 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   3586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   3589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3591 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   3598 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3603 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   3608 */     // GIR_Coverage, 15204,
     /*   3608 */     GIR_EraseRootFromParent_Done,
     /*   3609 */   // Label 172: @3609
     /*   3609 */   GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(3761), // Rule ID 15216 //
     /*   3614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3633 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3637 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3641 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3644 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   3649 */     // MIs[2] pattern
     /*   3649 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3652 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3661 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3663 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1246:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3663 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3666 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3670 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3675 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3677 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   3680 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   3684 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3689 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   3692 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   3696 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   3699 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3704 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3709 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3714 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   3717 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   3721 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3726 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   3729 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   3733 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   3736 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   3738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   3741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3743 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   3750 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3755 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   3760 */     // GIR_Coverage, 15216,
     /*   3760 */     GIR_EraseRootFromParent_Done,
     /*   3761 */   // Label 173: @3761
     /*   3761 */   GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(3913), // Rule ID 15228 //
     /*   3766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3785 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3789 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3793 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3796 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   3801 */     // MIs[2] pattern
     /*   3801 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3804 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3813 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3815 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1239:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3815 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3818 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3822 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3827 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3829 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   3832 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   3836 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3841 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   3844 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   3848 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   3851 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3856 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3861 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3866 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   3869 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   3873 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3878 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   3881 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   3885 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   3888 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   3890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   3893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3895 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   3902 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3907 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   3912 */     // GIR_Coverage, 15228,
     /*   3912 */     GIR_EraseRootFromParent_Done,
     /*   3913 */   // Label 174: @3913
     /*   3913 */   GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(3946), // Rule ID 91 //
     /*   3918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   3922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   3926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
     /*   3933 */     // (add:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (ADDWri:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   3933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
     /*   3936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3938 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   3940 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   3944 */     GIR_RootConstrainSelectedInstOperands,
     /*   3945 */     // GIR_Coverage, 91,
     /*   3945 */     GIR_EraseRootFromParent_Done,
     /*   3946 */   // Label 175: @3946
     /*   3946 */   GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(4098), // Rule ID 2642 //
     /*   3951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3958 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3974 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3978 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3982 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3985 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   3990 */     // MIs[2] pattern
     /*   3990 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3993 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3998 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4000 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1238:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4000 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4003 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4007 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4014 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4017 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4021 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4026 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4029 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4033 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4036 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4041 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4046 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4051 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4054 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   4058 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4063 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4066 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4070 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4073 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4080 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4087 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4092 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4097 */     // GIR_Coverage, 2642,
     /*   4097 */     GIR_EraseRootFromParent_Done,
     /*   4098 */   // Label 176: @4098
     /*   4098 */   GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(4250), // Rule ID 9791 //
     /*   4103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4110 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4126 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4130 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4134 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4137 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   4142 */     // MIs[2] pattern
     /*   4142 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4145 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4150 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4152 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1240:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4152 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4155 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4159 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4164 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4166 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4169 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4173 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4178 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4181 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4185 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4188 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4193 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4198 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4203 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4206 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   4210 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4215 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4218 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4222 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4225 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4232 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4239 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4244 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4249 */     // GIR_Coverage, 9791,
     /*   4249 */     GIR_EraseRootFromParent_Done,
     /*   4250 */   // Label 177: @4250
     /*   4250 */   GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(4402), // Rule ID 9803 //
     /*   4255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4262 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4278 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4282 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4286 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4289 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   4294 */     // MIs[2] pattern
     /*   4294 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4297 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4302 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4304 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1246:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4304 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4307 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4311 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4316 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4318 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4321 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4325 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4330 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4333 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4337 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4340 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4345 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4350 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4355 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4358 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   4362 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4367 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4370 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4374 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4377 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4384 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4391 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4396 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4401 */     // GIR_Coverage, 9803,
     /*   4401 */     GIR_EraseRootFromParent_Done,
     /*   4402 */   // Label 178: @4402
     /*   4402 */   GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(4554), // Rule ID 9815 //
     /*   4407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4414 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4434 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4438 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4441 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   4446 */     // MIs[2] pattern
     /*   4446 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4449 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4454 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4456 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1239:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4456 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4459 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4463 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4468 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4470 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4473 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4477 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4482 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4485 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4489 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4492 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4497 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4502 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4507 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4510 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   4514 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4519 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4522 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4526 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4529 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4536 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4543 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4548 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4553 */     // GIR_Coverage, 9815,
     /*   4553 */     GIR_EraseRootFromParent_Done,
     /*   4554 */   // Label 179: @4554
     /*   4554 */   GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(4587), // Rule ID 12924 //
     /*   4559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   4563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   4567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
     /*   4574 */     // (add:{ *:[i32] } arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend, GPR32sp:{ *:[i32] }:$Rn)  =>  (ADDWrx:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)
     /*   4574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrx),
     /*   4577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   4581 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*   4585 */     GIR_RootConstrainSelectedInstOperands,
     /*   4586 */     // GIR_Coverage, 12924,
     /*   4586 */     GIR_EraseRootFromParent_Done,
     /*   4587 */   // Label 180: @4587
     /*   4587 */   GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(4623), // Rule ID 13487 //
     /*   4592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
     /*   4607 */     // (add:{ *:[i32] } neg_addsub_shifted_imm32:{ *:[i32] }:$imm, GPR32:{ *:[i32] }:$Rn)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   4607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
     /*   4610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   4614 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   4618 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*   4621 */     GIR_RootConstrainSelectedInstOperands,
     /*   4622 */     // GIR_Coverage, 13487,
     /*   4622 */     GIR_EraseRootFromParent_Done,
     /*   4623 */   // Label 181: @4623
     /*   4623 */   GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(4656), // Rule ID 97 //
     /*   4628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   4632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   4636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
     /*   4643 */     // (add:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)  =>  (ADDWrx:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)
     /*   4643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrx),
     /*   4646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4648 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   4650 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*   4654 */     GIR_RootConstrainSelectedInstOperands,
     /*   4655 */     // GIR_Coverage, 97,
     /*   4655 */     GIR_EraseRootFromParent_Done,
     /*   4656 */   // Label 182: @4656
     /*   4656 */   GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(4692), // Rule ID 3863 //
     /*   4661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
     /*   4676 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   4676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
     /*   4679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4681 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   4683 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   4687 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*   4690 */     GIR_RootConstrainSelectedInstOperands,
     /*   4691 */     // GIR_Coverage, 3863,
     /*   4691 */     GIR_EraseRootFromParent_Done,
     /*   4692 */   // Label 183: @4692
     /*   4692 */   GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(4725), // Rule ID 12922 //
     /*   4697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
     /*   4712 */     // (add:{ *:[i32] } arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ADDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*   4712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrs),
     /*   4715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   4719 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*   4723 */     GIR_RootConstrainSelectedInstOperands,
     /*   4724 */     // GIR_Coverage, 12922,
     /*   4724 */     GIR_EraseRootFromParent_Done,
     /*   4725 */   // Label 184: @4725
     /*   4725 */   GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(4758), // Rule ID 95 //
     /*   4730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4734 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
     /*   4745 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ADDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*   4745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrs),
     /*   4748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4750 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   4752 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*   4756 */     GIR_RootConstrainSelectedInstOperands,
     /*   4757 */     // GIR_Coverage, 95,
     /*   4757 */     GIR_EraseRootFromParent_Done,
     /*   4758 */   // Label 185: @4758
     /*   4758 */   GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(4782), // Rule ID 93 //
     /*   4763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4767 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4775 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ADDWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*   4775 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDWrr),
     /*   4780 */     GIR_RootConstrainSelectedInstOperands,
     /*   4781 */     // GIR_Coverage, 93,
     /*   4781 */     GIR_Done,
     /*   4782 */   // Label 186: @4782
     /*   4782 */   GIM_Reject,
     /*   4783 */ // Label 169: @4783
     /*   4783 */ GIM_Reject,
     /*   4784 */ // Label 156: @4784
     /*   4784 */ GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(9875),
     /*   4789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   4792 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   4795 */   GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(4931), // Rule ID 5313 //
     /*   4800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   4804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   4812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   4816 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4820 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   4824 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   4828 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   4833 */     // MIs[1] Operand 2
     /*   4833 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   4844 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   4848 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   4852 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   4856 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   4860 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   4864 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   4868 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   4873 */     // MIs[3] Operand 2
     /*   4873 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   4884 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   4886 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   4886 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   4889 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   4893 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4898 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   4902 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   4906 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4913 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   4920 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   4925 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   4930 */     // GIR_Coverage, 5313,
     /*   4930 */     GIR_EraseRootFromParent_Done,
     /*   4931 */   // Label 188: @4931
     /*   4931 */   GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(5067), // Rule ID 5312 //
     /*   4936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   4940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   4948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   4952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   4960 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   4964 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   4969 */     // MIs[1] Operand 2
     /*   4969 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   4980 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   4984 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   4988 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   4992 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   4996 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   5000 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   5004 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   5009 */     // MIs[3] Operand 2
     /*   5009 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   5020 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   5022 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   5022 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   5025 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   5029 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5034 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   5038 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   5042 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5049 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   5056 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   5061 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   5066 */     // GIR_Coverage, 5312,
     /*   5066 */     GIR_EraseRootFromParent_Done,
     /*   5067 */   // Label 189: @5067
     /*   5067 */   GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(5203), // Rule ID 5322 //
     /*   5072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   5076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   5084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   5088 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5092 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   5096 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   5100 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   5105 */     // MIs[1] Operand 2
     /*   5105 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   5116 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   5120 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   5124 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   5128 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   5132 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   5136 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   5140 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   5145 */     // MIs[3] Operand 2
     /*   5145 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   5156 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   5158 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   5158 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   5161 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv2i32_v2i64),
     /*   5165 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5170 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   5174 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   5178 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5185 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   5192 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   5197 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   5202 */     // GIR_Coverage, 5322,
     /*   5202 */     GIR_EraseRootFromParent_Done,
     /*   5203 */   // Label 190: @5203
     /*   5203 */   GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(5339), // Rule ID 5311 //
     /*   5208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   5212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   5220 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   5224 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5228 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   5232 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   5236 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   5241 */     // MIs[1] Operand 2
     /*   5241 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   5252 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   5256 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   5260 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   5264 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   5268 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   5272 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   5276 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   5281 */     // MIs[3] Operand 2
     /*   5281 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   5292 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   5294 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   5294 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   5297 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   5301 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5306 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   5310 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   5314 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5321 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   5328 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   5333 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   5338 */     // GIR_Coverage, 5311,
     /*   5338 */     GIR_EraseRootFromParent_Done,
     /*   5339 */   // Label 191: @5339
     /*   5339 */   GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(5475), // Rule ID 5310 //
     /*   5344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   5348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   5356 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   5360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   5368 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   5372 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   5377 */     // MIs[1] Operand 2
     /*   5377 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   5388 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   5392 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   5396 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   5400 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   5404 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   5408 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   5412 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   5417 */     // MIs[3] Operand 2
     /*   5417 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   5428 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   5430 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   5430 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   5433 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   5437 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5442 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   5446 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   5450 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5457 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   5464 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   5469 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   5474 */     // GIR_Coverage, 5310,
     /*   5474 */     GIR_EraseRootFromParent_Done,
     /*   5475 */   // Label 192: @5475
     /*   5475 */   GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(5543), // Rule ID 6819 //
     /*   5480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   5484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   5492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   5496 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   5500 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   5505 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /*   5509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   5513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   5517 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   5521 */     // MIs[2] Rn
     /*   5521 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*   5526 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*   5530 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5532 */     // (add:{ *:[i64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }))  =>  (ADDPv2i64p:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn)
     /*   5532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /*   5535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5541 */     GIR_RootConstrainSelectedInstOperands,
     /*   5542 */     // GIR_Coverage, 6819,
     /*   5542 */     GIR_EraseRootFromParent_Done,
     /*   5543 */   // Label 193: @5543
     /*   5543 */   GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(5611), // Rule ID 13648 //
     /*   5548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   5552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   5560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   5564 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   5568 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   5573 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*   5577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   5581 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   5585 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   5589 */     // MIs[2] Rn
     /*   5589 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*   5594 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /*   5598 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5600 */     // (add:{ *:[i64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (ADDPv2i64p:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn)
     /*   5600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /*   5603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5609 */     GIR_RootConstrainSelectedInstOperands,
     /*   5610 */     // GIR_Coverage, 13648,
     /*   5610 */     GIR_EraseRootFromParent_Done,
     /*   5611 */   // Label 194: @5611
     /*   5611 */   GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(5644), // Rule ID 12921 //
     /*   5616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   5620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   5624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
     /*   5631 */     // (add:{ *:[i64] } addsub_shifted_imm64:{ *:[i64] }:$imm, GPR64sp:{ *:[i64] }:$Rn)  =>  (ADDXri:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*   5631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
     /*   5634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   5638 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   5642 */     GIR_RootConstrainSelectedInstOperands,
     /*   5643 */     // GIR_Coverage, 12921,
     /*   5643 */     GIR_EraseRootFromParent_Done,
     /*   5644 */   // Label 195: @5644
     /*   5644 */   GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(5777), // Rule ID 3915 //
     /*   5649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5665 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   5669 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5673 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   5677 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   5681 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5686 */     // MIs[2] Operand 2
     /*   5686 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*   5697 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   5701 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   5705 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   5709 */     // MIs[3] Operand 1
     /*   5709 */     // No operand predicates
     /*   5709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5713 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   5715 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   5715 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*   5718 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   5722 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5727 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   5732 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*   5734 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   5737 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5741 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5746 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*   5752 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5757 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   5765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5767 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   5770 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*   5773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5775 */     GIR_RootConstrainSelectedInstOperands,
     /*   5776 */     // GIR_Coverage, 3915,
     /*   5776 */     GIR_EraseRootFromParent_Done,
     /*   5777 */   // Label 196: @5777
     /*   5777 */   GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(5872), // Rule ID 3913 //
     /*   5782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5798 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   5802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   5810 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   5814 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5819 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   5823 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   5827 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   5831 */     // MIs[3] Operand 1
     /*   5831 */     // No operand predicates
     /*   5831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5835 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   5837 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   5837 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   5840 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   5844 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5849 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   5854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   5859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   5865 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   5868 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5870 */     GIR_RootConstrainSelectedInstOperands,
     /*   5871 */     // GIR_Coverage, 3913,
     /*   5871 */     GIR_EraseRootFromParent_Done,
     /*   5872 */   // Label 197: @5872
     /*   5872 */   GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(5967), // Rule ID 3914 //
     /*   5877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5889 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5893 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   5897 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5901 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   5905 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   5909 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5914 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   5918 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   5922 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*   5926 */     // MIs[3] Operand 1
     /*   5926 */     // No operand predicates
     /*   5926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5930 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   5932 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   5932 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   5935 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   5939 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5944 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   5949 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   5954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   5960 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   5963 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5965 */     GIR_RootConstrainSelectedInstOperands,
     /*   5966 */     // GIR_Coverage, 3914,
     /*   5966 */     GIR_EraseRootFromParent_Done,
     /*   5967 */   // Label 198: @5967
     /*   5967 */   GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(6000), // Rule ID 92 //
     /*   5972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   5976 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   5980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
     /*   5987 */     // (add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (ADDXri:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*   5987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
     /*   5990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5992 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   5994 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   5998 */     GIR_RootConstrainSelectedInstOperands,
     /*   5999 */     // GIR_Coverage, 92,
     /*   5999 */     GIR_EraseRootFromParent_Done,
     /*   6000 */   // Label 199: @6000
     /*   6000 */   GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(6133), // Rule ID 13497 //
     /*   6005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   6021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   6025 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   6029 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6033 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   6037 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   6041 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6046 */     // MIs[2] Operand 2
     /*   6046 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*   6057 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   6061 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   6065 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   6069 */     // MIs[3] Operand 1
     /*   6069 */     // No operand predicates
     /*   6069 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   6071 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   6071 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*   6074 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   6078 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6083 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   6088 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*   6090 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   6093 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6097 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6102 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*   6108 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6113 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   6121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6123 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   6126 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*   6129 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   6131 */     GIR_RootConstrainSelectedInstOperands,
     /*   6132 */     // GIR_Coverage, 13497,
     /*   6132 */     GIR_EraseRootFromParent_Done,
     /*   6133 */   // Label 200: @6133
     /*   6133 */   GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(6228), // Rule ID 13495 //
     /*   6138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   6154 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   6158 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   6162 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6166 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   6170 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   6174 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6179 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   6183 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   6187 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   6191 */     // MIs[3] Operand 1
     /*   6191 */     // No operand predicates
     /*   6191 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   6193 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   6193 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   6196 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   6200 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6205 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   6210 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   6215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6221 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   6224 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   6226 */     GIR_RootConstrainSelectedInstOperands,
     /*   6227 */     // GIR_Coverage, 13495,
     /*   6227 */     GIR_EraseRootFromParent_Done,
     /*   6228 */   // Label 201: @6228
     /*   6228 */   GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(6323), // Rule ID 13496 //
     /*   6233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   6249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   6253 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   6257 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6261 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6265 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   6269 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6274 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   6278 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   6282 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*   6286 */     // MIs[3] Operand 1
     /*   6286 */     // No operand predicates
     /*   6286 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   6288 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   6288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   6291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   6295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6300 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   6305 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   6310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6316 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   6319 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   6321 */     GIR_RootConstrainSelectedInstOperands,
     /*   6322 */     // GIR_Coverage, 13496,
     /*   6322 */     GIR_EraseRootFromParent_Done,
     /*   6323 */   // Label 202: @6323
     /*   6323 */   GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(6405), // Rule ID 12932 //
     /*   6328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   6340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   6344 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   6348 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6352 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   6356 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   6360 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6365 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   6369 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   6373 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   6377 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6386 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   6388 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   6388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   6391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6393 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   6401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   6403 */     GIR_RootConstrainSelectedInstOperands,
     /*   6404 */     // GIR_Coverage, 12932,
     /*   6404 */     GIR_EraseRootFromParent_Done,
     /*   6405 */   // Label 203: @6405
     /*   6405 */   GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(6487), // Rule ID 12933 //
     /*   6410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   6422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   6426 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   6430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6434 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6438 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   6442 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6447 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   6451 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6455 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   6459 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6468 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   6470 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)), GPR64:{ *:[i64] }:$Ra)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   6470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   6473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   6483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   6485 */     GIR_RootConstrainSelectedInstOperands,
     /*   6486 */     // GIR_Coverage, 12933,
     /*   6486 */     GIR_EraseRootFromParent_Done,
     /*   6487 */   // Label 204: @6487
     /*   6487 */   GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(6569), // Rule ID 123 //
     /*   6492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6496 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   6508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   6512 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   6516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   6524 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   6528 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6533 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   6537 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   6541 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   6545 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6550 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   6552 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   6552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   6555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   6565 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   6567 */     GIR_RootConstrainSelectedInstOperands,
     /*   6568 */     // GIR_Coverage, 123,
     /*   6568 */     GIR_EraseRootFromParent_Done,
     /*   6569 */   // Label 205: @6569
     /*   6569 */   GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(6651), // Rule ID 125 //
     /*   6574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   6590 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   6594 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   6598 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6602 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6606 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   6610 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6615 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   6619 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6623 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   6627 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6632 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   6634 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   6634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   6637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   6647 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   6649 */     GIR_RootConstrainSelectedInstOperands,
     /*   6650 */     // GIR_Coverage, 125,
     /*   6650 */     GIR_EraseRootFromParent_Done,
     /*   6651 */   // Label 206: @6651
     /*   6651 */   GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(6709), // Rule ID 13342 //
     /*   6656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   6659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   6671 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   6674 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   6679 */     // MIs[1] pattern
     /*   6679 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   6682 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   6687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6693 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1238:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   6693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   6696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   6698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   6700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   6704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   6707 */     GIR_RootConstrainSelectedInstOperands,
     /*   6708 */     // GIR_Coverage, 13342,
     /*   6708 */     GIR_EraseRootFromParent_Done,
     /*   6709 */   // Label 207: @6709
     /*   6709 */   GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(6767), // Rule ID 15199 //
     /*   6714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   6717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   6729 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   6732 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   6737 */     // MIs[1] pattern
     /*   6737 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   6740 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   6745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6749 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6751 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1240:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   6751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   6754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   6756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   6758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   6762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   6765 */     GIR_RootConstrainSelectedInstOperands,
     /*   6766 */     // GIR_Coverage, 15199,
     /*   6766 */     GIR_EraseRootFromParent_Done,
     /*   6767 */   // Label 208: @6767
     /*   6767 */   GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(6825), // Rule ID 15211 //
     /*   6772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   6775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   6787 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   6790 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   6795 */     // MIs[1] pattern
     /*   6795 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   6798 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   6803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6809 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1246:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   6809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   6812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   6814 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   6816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   6820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   6823 */     GIR_RootConstrainSelectedInstOperands,
     /*   6824 */     // GIR_Coverage, 15211,
     /*   6824 */     GIR_EraseRootFromParent_Done,
     /*   6825 */   // Label 209: @6825
     /*   6825 */   GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(6883), // Rule ID 15223 //
     /*   6830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   6833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   6845 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   6848 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   6853 */     // MIs[1] pattern
     /*   6853 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   6856 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   6861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6867 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1239:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   6867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   6870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   6872 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   6874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   6878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   6881 */     GIR_RootConstrainSelectedInstOperands,
     /*   6882 */     // GIR_Coverage, 15223,
     /*   6882 */     GIR_EraseRootFromParent_Done,
     /*   6883 */   // Label 210: @6883
     /*   6883 */   GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(6941), // Rule ID 2639 //
     /*   6888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   6891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   6907 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   6910 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   6915 */     // MIs[1] pattern
     /*   6915 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   6918 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   6923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6925 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1238:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   6925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   6928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   6930 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   6932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   6936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   6939 */     GIR_RootConstrainSelectedInstOperands,
     /*   6940 */     // GIR_Coverage, 2639,
     /*   6940 */     GIR_EraseRootFromParent_Done,
     /*   6941 */   // Label 211: @6941
     /*   6941 */   GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(6999), // Rule ID 9788 //
     /*   6946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   6949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6953 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   6965 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   6968 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   6973 */     // MIs[1] pattern
     /*   6973 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   6976 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   6981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6983 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1240:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   6983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   6986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   6988 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   6990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   6994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   6997 */     GIR_RootConstrainSelectedInstOperands,
     /*   6998 */     // GIR_Coverage, 9788,
     /*   6998 */     GIR_EraseRootFromParent_Done,
     /*   6999 */   // Label 212: @6999
     /*   6999 */   GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(7057), // Rule ID 9800 //
     /*   7004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   7007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   7023 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   7026 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   7031 */     // MIs[1] pattern
     /*   7031 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   7034 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   7039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7041 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1246:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   7041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   7044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   7046 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   7048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   7052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   7055 */     GIR_RootConstrainSelectedInstOperands,
     /*   7056 */     // GIR_Coverage, 9800,
     /*   7056 */     GIR_EraseRootFromParent_Done,
     /*   7057 */   // Label 213: @7057
     /*   7057 */   GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(7115), // Rule ID 9812 //
     /*   7062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   7065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7069 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   7081 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   7084 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   7089 */     // MIs[1] pattern
     /*   7089 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   7092 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   7097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7099 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1239:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   7099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   7102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   7104 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   7106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   7110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   7113 */     GIR_RootConstrainSelectedInstOperands,
     /*   7114 */     // GIR_Coverage, 9812,
     /*   7114 */     GIR_EraseRootFromParent_Done,
     /*   7115 */   // Label 214: @7115
     /*   7115 */   GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(7278), // Rule ID 13614 //
     /*   7120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   7132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   7136 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7140 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*   7144 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7148 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   7152 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7157 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7162 */     // MIs[1] Operand 2
     /*   7162 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   7173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7177 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7179 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   7179 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   7182 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   7186 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7191 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   7193 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   7196 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   7200 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7205 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   7208 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*   7212 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   7215 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7220 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7225 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7230 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   7233 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*   7237 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7242 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   7245 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7249 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   7253 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   7258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7260 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   7267 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7272 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7277 */     // GIR_Coverage, 13614,
     /*   7277 */     GIR_EraseRootFromParent_Done,
     /*   7278 */   // Label 215: @7278
     /*   7278 */   GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(7441), // Rule ID 13611 //
     /*   7283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   7295 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   7299 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7303 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*   7307 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7311 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   7315 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7320 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7325 */     // MIs[1] Operand 2
     /*   7325 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   7336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7340 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7342 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   7342 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   7345 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   7349 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7354 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   7356 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   7359 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   7363 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7368 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   7371 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*   7375 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   7378 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7383 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7388 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7393 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   7396 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*   7400 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7405 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   7408 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7412 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   7416 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   7421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7423 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   7430 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7435 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7440 */     // GIR_Coverage, 13611,
     /*   7440 */     GIR_EraseRootFromParent_Done,
     /*   7441 */   // Label 216: @7441
     /*   7441 */   GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(7591), // Rule ID 13620 //
     /*   7446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   7458 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   7462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7470 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7474 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7479 */     // MIs[1] Operand 2
     /*   7479 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   7490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7494 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7496 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   7496 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   7499 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   7503 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   7510 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   7513 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   7517 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7522 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   7525 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   7529 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   7532 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7537 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7542 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   7550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*   7554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7559 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   7562 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   7566 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   7571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7573 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   7580 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7585 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7590 */     // GIR_Coverage, 13620,
     /*   7590 */     GIR_EraseRootFromParent_Done,
     /*   7591 */   // Label 217: @7591
     /*   7591 */   GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(7741), // Rule ID 13623 //
     /*   7596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   7608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   7612 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7616 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7620 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7624 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7629 */     // MIs[1] Operand 2
     /*   7629 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   7640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7644 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7646 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   7646 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   7649 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   7653 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   7660 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   7663 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   7667 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7672 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   7675 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   7679 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   7682 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7687 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7692 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7697 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   7700 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*   7704 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7709 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   7712 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   7716 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   7721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7723 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   7730 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7735 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7740 */     // GIR_Coverage, 13623,
     /*   7740 */     GIR_EraseRootFromParent_Done,
     /*   7741 */   // Label 218: @7741
     /*   7741 */   GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(7891), // Rule ID 13619 //
     /*   7746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   7758 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   7762 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7766 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7770 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7774 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7779 */     // MIs[1] Operand 2
     /*   7779 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   7790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7794 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7796 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   7796 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   7799 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   7803 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7808 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   7810 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   7813 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   7817 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7822 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   7825 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   7829 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   7832 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7837 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7842 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7847 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   7850 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*   7854 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7859 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   7862 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   7866 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   7871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7873 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   7880 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7885 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7890 */     // GIR_Coverage, 13619,
     /*   7890 */     GIR_EraseRootFromParent_Done,
     /*   7891 */   // Label 219: @7891
     /*   7891 */   GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(8054), // Rule ID 5295 //
     /*   7896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7900 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   7912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   7916 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7920 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*   7924 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7928 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   7932 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7937 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7942 */     // MIs[1] Operand 2
     /*   7942 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   7953 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7955 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   7955 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   7958 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   7962 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7967 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   7969 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   7972 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   7976 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7981 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   7984 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*   7988 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   7991 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7996 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8001 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8006 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   8009 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*   8013 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8018 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   8021 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   8025 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   8029 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   8031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   8034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8036 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   8043 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8048 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8053 */     // GIR_Coverage, 5295,
     /*   8053 */     GIR_EraseRootFromParent_Done,
     /*   8054 */   // Label 220: @8054
     /*   8054 */   GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(8217), // Rule ID 5292 //
     /*   8059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8063 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   8075 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   8079 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8083 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*   8087 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   8091 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   8095 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8100 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8105 */     // MIs[1] Operand 2
     /*   8105 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   8116 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8118 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   8118 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   8121 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   8125 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8130 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   8132 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   8135 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   8139 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8144 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   8147 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*   8151 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   8154 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8159 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8164 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8169 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   8172 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*   8176 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8181 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   8184 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   8188 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   8192 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   8194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   8197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8199 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   8206 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8211 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8216 */     // GIR_Coverage, 5292,
     /*   8216 */     GIR_EraseRootFromParent_Done,
     /*   8217 */   // Label 221: @8217
     /*   8217 */   GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(8367), // Rule ID 5319 //
     /*   8222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8226 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   8238 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   8242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8246 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8250 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   8254 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8259 */     // MIs[1] Operand 2
     /*   8259 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   8270 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8272 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   8272 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   8275 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   8279 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8284 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   8286 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   8289 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   8293 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8298 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   8301 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   8305 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   8308 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8313 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8318 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   8326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*   8330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8335 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   8338 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   8342 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   8344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   8347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8349 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   8356 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8361 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8366 */     // GIR_Coverage, 5319,
     /*   8366 */     GIR_EraseRootFromParent_Done,
     /*   8367 */   // Label 222: @8367
     /*   8367 */   GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(8517), // Rule ID 5325 //
     /*   8372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   8388 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   8392 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8396 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8400 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   8404 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8409 */     // MIs[1] Operand 2
     /*   8409 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   8420 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8422 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   8422 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   8425 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   8429 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8434 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   8436 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   8439 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   8443 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8448 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   8451 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   8455 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   8458 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8463 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8468 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8473 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   8476 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*   8480 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8485 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   8488 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   8492 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   8494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   8497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8499 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   8506 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8511 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8516 */     // GIR_Coverage, 5325,
     /*   8516 */     GIR_EraseRootFromParent_Done,
     /*   8517 */   // Label 223: @8517
     /*   8517 */   GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(8667), // Rule ID 5318 //
     /*   8522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8526 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   8538 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   8542 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8546 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8550 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   8554 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8559 */     // MIs[1] Operand 2
     /*   8559 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   8570 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8572 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   8572 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   8575 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   8579 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8584 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   8586 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   8589 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   8593 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8598 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   8601 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   8605 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   8608 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8613 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8618 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8623 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   8626 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*   8630 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8635 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   8638 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   8642 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   8644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   8647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8649 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   8656 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8661 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8666 */     // GIR_Coverage, 5318,
     /*   8666 */     GIR_EraseRootFromParent_Done,
     /*   8667 */   // Label 224: @8667
     /*   8667 */   GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(8700), // Rule ID 12925 //
     /*   8672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   8676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   8680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
     /*   8687 */     // (add:{ *:[i64] } arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend, GPR64sp:{ *:[i64] }:$Rn)  =>  (ADDXrx:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)
     /*   8687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrx),
     /*   8690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   8694 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*   8698 */     GIR_RootConstrainSelectedInstOperands,
     /*   8699 */     // GIR_Coverage, 12925,
     /*   8699 */     GIR_EraseRootFromParent_Done,
     /*   8700 */   // Label 225: @8700
     /*   8700 */   GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(8736), // Rule ID 13488 //
     /*   8705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
     /*   8720 */     // (add:{ *:[i64] } neg_addsub_shifted_imm64:{ *:[i64] }:$imm, GPR64:{ *:[i64] }:$Rn)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*   8720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
     /*   8723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   8727 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   8731 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*   8734 */     GIR_RootConstrainSelectedInstOperands,
     /*   8735 */     // GIR_Coverage, 13488,
     /*   8735 */     GIR_EraseRootFromParent_Done,
     /*   8736 */   // Label 226: @8736
     /*   8736 */   GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(8769), // Rule ID 98 //
     /*   8741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   8745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   8749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
     /*   8756 */     // (add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)  =>  (ADDXrx:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)
     /*   8756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrx),
     /*   8759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8761 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   8763 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*   8767 */     GIR_RootConstrainSelectedInstOperands,
     /*   8768 */     // GIR_Coverage, 98,
     /*   8768 */     GIR_EraseRootFromParent_Done,
     /*   8769 */   // Label 227: @8769
     /*   8769 */   GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(8805), // Rule ID 3864 //
     /*   8774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
     /*   8789 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*   8789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
     /*   8792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8794 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   8796 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   8800 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*   8803 */     GIR_RootConstrainSelectedInstOperands,
     /*   8804 */     // GIR_Coverage, 3864,
     /*   8804 */     GIR_EraseRootFromParent_Done,
     /*   8805 */   // Label 228: @8805
     /*   8805 */   GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(8838), // Rule ID 12923 //
     /*   8810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
     /*   8825 */     // (add:{ *:[i64] } arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ADDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*   8825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrs),
     /*   8828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   8832 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*   8836 */     GIR_RootConstrainSelectedInstOperands,
     /*   8837 */     // GIR_Coverage, 12923,
     /*   8837 */     GIR_EraseRootFromParent_Done,
     /*   8838 */   // Label 229: @8838
     /*   8838 */   GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(8871), // Rule ID 96 //
     /*   8843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
     /*   8858 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ADDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*   8858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrs),
     /*   8861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8863 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   8865 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*   8869 */     GIR_RootConstrainSelectedInstOperands,
     /*   8870 */     // GIR_Coverage, 96,
     /*   8870 */     GIR_EraseRootFromParent_Done,
     /*   8871 */   // Label 230: @8871
     /*   8871 */   GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(8927), // Rule ID 13031 //
     /*   8876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8891 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8894 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*   8899 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   8903 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8914 */     // (add:{ *:[v1i64] } (intrinsic_wo_chain:{ *:[v1i64] } 660:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*   8914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*   8917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*   8921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*   8925 */     GIR_RootConstrainSelectedInstOperands,
     /*   8926 */     // GIR_Coverage, 13031,
     /*   8926 */     GIR_EraseRootFromParent_Done,
     /*   8927 */   // Label 231: @8927
     /*   8927 */   GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(8983), // Rule ID 13043 //
     /*   8932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8947 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8950 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*   8955 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   8959 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8968 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8970 */     // (add:{ *:[v1i64] } (intrinsic_wo_chain:{ *:[v1i64] } 725:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*   8970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*   8973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8975 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*   8977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*   8981 */     GIR_RootConstrainSelectedInstOperands,
     /*   8982 */     // GIR_Coverage, 13043,
     /*   8982 */     GIR_EraseRootFromParent_Done,
     /*   8983 */   // Label 232: @8983
     /*   8983 */   GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(9050), // Rule ID 13249 //
     /*   8988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*   9003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   9007 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9012 */     // MIs[1] imm
     /*   9012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   9016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   9020 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*   9024 */     // MIs[2] Operand 1
     /*   9024 */     // No operand predicates
     /*   9024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9028 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*   9032 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9034 */     // (add:{ *:[i64] } (AArch64vashr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*   9034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*   9037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9039 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*   9041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   9045 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*   9048 */     GIR_RootConstrainSelectedInstOperands,
     /*   9049 */     // GIR_Coverage, 13249,
     /*   9049 */     GIR_EraseRootFromParent_Done,
     /*   9050 */   // Label 233: @9050
     /*   9050 */   GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(9117), // Rule ID 13637 //
     /*   9055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*   9070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   9074 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9079 */     // MIs[1] imm
     /*   9079 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   9083 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   9087 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*   9091 */     // MIs[2] Operand 1
     /*   9091 */     // No operand predicates
     /*   9091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9095 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*   9099 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9101 */     // (add:{ *:[v1i64] } (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /*   9101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*   9104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*   9108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   9112 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*   9115 */     GIR_RootConstrainSelectedInstOperands,
     /*   9116 */     // GIR_Coverage, 13637,
     /*   9116 */     GIR_EraseRootFromParent_Done,
     /*   9117 */   // Label 234: @9117
     /*   9117 */   GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(9184), // Rule ID 13252 //
     /*   9122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*   9137 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   9141 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9146 */     // MIs[1] imm
     /*   9146 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   9150 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   9154 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*   9158 */     // MIs[2] Operand 1
     /*   9158 */     // No operand predicates
     /*   9158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9162 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*   9166 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9168 */     // (add:{ *:[i64] } (AArch64vlshr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*   9168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*   9171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*   9175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   9179 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*   9182 */     GIR_RootConstrainSelectedInstOperands,
     /*   9183 */     // GIR_Coverage, 13252,
     /*   9183 */     GIR_EraseRootFromParent_Done,
     /*   9184 */   // Label 235: @9184
     /*   9184 */   GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(9251), // Rule ID 13640 //
     /*   9189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*   9204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   9208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9213 */     // MIs[1] imm
     /*   9213 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   9217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   9221 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*   9225 */     // MIs[2] Operand 1
     /*   9225 */     // No operand predicates
     /*   9225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9229 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*   9233 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9235 */     // (add:{ *:[v1i64] } (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /*   9235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*   9238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*   9242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   9246 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*   9249 */     GIR_RootConstrainSelectedInstOperands,
     /*   9250 */     // GIR_Coverage, 13640,
     /*   9250 */     GIR_EraseRootFromParent_Done,
     /*   9251 */   // Label 236: @9251
     /*   9251 */   GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(9307), // Rule ID 990 //
     /*   9256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   9275 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   9278 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*   9283 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   9287 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9292 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9294 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (intrinsic_wo_chain:{ *:[v1i64] } 660:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn))  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*   9294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*   9297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9299 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*   9301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*   9305 */     GIR_RootConstrainSelectedInstOperands,
     /*   9306 */     // GIR_Coverage, 990,
     /*   9306 */     GIR_EraseRootFromParent_Done,
     /*   9307 */   // Label 237: @9307
     /*   9307 */   GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(9363), // Rule ID 1051 //
     /*   9312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   9331 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   9334 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*   9339 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   9343 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9350 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (intrinsic_wo_chain:{ *:[v1i64] } 725:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn))  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*   9350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*   9353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9355 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*   9357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*   9361 */     GIR_RootConstrainSelectedInstOperands,
     /*   9362 */     // GIR_Coverage, 1051,
     /*   9362 */     GIR_EraseRootFromParent_Done,
     /*   9363 */   // Label 238: @9363
     /*   9363 */   GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(9430), // Rule ID 2112 //
     /*   9368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9375 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*   9387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   9391 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9396 */     // MIs[1] imm
     /*   9396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   9400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   9404 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*   9408 */     // MIs[2] Operand 1
     /*   9408 */     // No operand predicates
     /*   9408 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*   9412 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9414 */     // (add:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, (AArch64vashr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*   9414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*   9417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9419 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*   9421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   9425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*   9428 */     GIR_RootConstrainSelectedInstOperands,
     /*   9429 */     // GIR_Coverage, 2112,
     /*   9429 */     GIR_EraseRootFromParent_Done,
     /*   9430 */   // Label 239: @9430
     /*   9430 */   GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(9497), // Rule ID 6197 //
     /*   9435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*   9454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   9458 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9463 */     // MIs[1] imm
     /*   9463 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   9467 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   9471 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*   9475 */     // MIs[2] Operand 1
     /*   9475 */     // No operand predicates
     /*   9475 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*   9479 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9481 */     // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /*   9481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*   9484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9486 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*   9488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   9492 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*   9495 */     GIR_RootConstrainSelectedInstOperands,
     /*   9496 */     // GIR_Coverage, 6197,
     /*   9496 */     GIR_EraseRootFromParent_Done,
     /*   9497 */   // Label 240: @9497
     /*   9497 */   GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(9564), // Rule ID 2121 //
     /*   9502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*   9521 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   9525 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9530 */     // MIs[1] imm
     /*   9530 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   9534 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   9538 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*   9542 */     // MIs[2] Operand 1
     /*   9542 */     // No operand predicates
     /*   9542 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*   9546 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9548 */     // (add:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, (AArch64vlshr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*   9548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*   9551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9553 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*   9555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   9559 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*   9562 */     GIR_RootConstrainSelectedInstOperands,
     /*   9563 */     // GIR_Coverage, 2121,
     /*   9563 */     GIR_EraseRootFromParent_Done,
     /*   9564 */   // Label 241: @9564
     /*   9564 */   GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(9631), // Rule ID 6203 //
     /*   9569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9576 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*   9588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   9592 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9597 */     // MIs[1] imm
     /*   9597 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   9601 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   9605 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*   9609 */     // MIs[2] Operand 1
     /*   9609 */     // No operand predicates
     /*   9609 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*   9613 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9615 */     // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /*   9615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*   9618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9620 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*   9622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   9626 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*   9629 */     GIR_RootConstrainSelectedInstOperands,
     /*   9630 */     // GIR_Coverage, 6203,
     /*   9630 */     GIR_EraseRootFromParent_Done,
     /*   9631 */   // Label 242: @9631
     /*   9631 */   GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(9679), // Rule ID 13030 //
     /*   9636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*   9651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9655 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9666 */     // (add:{ *:[v1i64] } (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*   9666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*   9669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*   9673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   9677 */     GIR_RootConstrainSelectedInstOperands,
     /*   9678 */     // GIR_Coverage, 13030,
     /*   9678 */     GIR_EraseRootFromParent_Done,
     /*   9679 */   // Label 243: @9679
     /*   9679 */   GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(9727), // Rule ID 13042 //
     /*   9684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*   9699 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9703 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9712 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9714 */     // (add:{ *:[v1i64] } (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*   9714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*   9717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*   9721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   9725 */     GIR_RootConstrainSelectedInstOperands,
     /*   9726 */     // GIR_Coverage, 13042,
     /*   9726 */     GIR_EraseRootFromParent_Done,
     /*   9727 */   // Label 244: @9727
     /*   9727 */   GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(9775), // Rule ID 989 //
     /*   9732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9739 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*   9751 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9755 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9762 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn))  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*   9762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*   9765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9767 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*   9769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   9773 */     GIR_RootConstrainSelectedInstOperands,
     /*   9774 */     // GIR_Coverage, 989,
     /*   9774 */     GIR_EraseRootFromParent_Done,
     /*   9775 */   // Label 245: @9775
     /*   9775 */   GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(9823), // Rule ID 1050 //
     /*   9780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*   9799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9803 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9808 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9810 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn))  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*   9810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*   9813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9815 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*   9817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   9821 */     GIR_RootConstrainSelectedInstOperands,
     /*   9822 */     // GIR_Coverage, 1050,
     /*   9822 */     GIR_EraseRootFromParent_Done,
     /*   9823 */   // Label 246: @9823
     /*   9823 */   GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(9847), // Rule ID 94 //
     /*   9828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   9832 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   9836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   9840 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ADDXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*   9840 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDXrr),
     /*   9845 */     GIR_RootConstrainSelectedInstOperands,
     /*   9846 */     // GIR_Coverage, 94,
     /*   9846 */     GIR_Done,
     /*   9847 */   // Label 247: @9847
     /*   9847 */   GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(9874), // Rule ID 1600 //
     /*   9852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9867 */     // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (ADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /*   9867 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv1i64),
     /*   9872 */     GIR_RootConstrainSelectedInstOperands,
     /*   9873 */     // GIR_Coverage, 1600,
     /*   9873 */     GIR_Done,
     /*   9874 */   // Label 248: @9874
     /*   9874 */   GIM_Reject,
     /*   9875 */ // Label 187: @9875
     /*   9875 */ GIM_Reject,
     /*   9876 */ // Label 157: @9876
     /*   9876 */ GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(13483),
     /*   9881 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9884 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   9887 */   GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(10075), // Rule ID 6840 //
     /*   9892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP1),
     /*   9904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9908 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   9912 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9916 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9920 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9924 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9929 */     // MIs[2] Operand 2
     /*   9929 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*   9940 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   9944 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9948 */     // MIs[3] Rn
     /*   9948 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   9953 */     // MIs[3] Operand 2
     /*   9953 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(2),
     /*   9964 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*   9968 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_ZIP2),
     /*   9972 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9976 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   9980 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   9984 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9988 */     // MIs[5] Rn
     /*   9988 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   9993 */     // MIs[5] Operand 2
     /*   9993 */     GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(0),
     /*  10004 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/4, /*OpIdx*/2, // MIs[6]
     /*  10008 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10012 */     // MIs[6] Rn
     /*  10012 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  10017 */     // MIs[6] Operand 2
     /*  10017 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(2),
     /*  10028 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  10030 */     // (add:{ *:[v2i32] } (AArch64zip1:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })), (AArch64zip2:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (ADDPv4i32:{ *:[f128] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /*  10030 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  10033 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  10037 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10042 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  10046 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  10050 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  10052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10057 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  10064 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10069 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10074 */     // GIR_Coverage, 6840,
     /*  10074 */     GIR_EraseRootFromParent_Done,
     /*  10075 */   // Label 250: @10075
     /*  10075 */   GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(10263), // Rule ID 13659 //
     /*  10080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP2),
     /*  10092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  10096 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  10100 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10104 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10108 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10112 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10117 */     // MIs[2] Operand 2
     /*  10117 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  10128 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  10132 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10136 */     // MIs[3] Rn
     /*  10136 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  10141 */     // MIs[3] Operand 2
     /*  10141 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(2),
     /*  10152 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  10156 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_ZIP1),
     /*  10160 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  10164 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  10168 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  10172 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10176 */     // MIs[5] Rn
     /*  10176 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  10181 */     // MIs[5] Operand 2
     /*  10181 */     GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(0),
     /*  10192 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/4, /*OpIdx*/2, // MIs[6]
     /*  10196 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10200 */     // MIs[6] Rn
     /*  10200 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  10205 */     // MIs[6] Operand 2
     /*  10205 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(2),
     /*  10216 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  10218 */     // (add:{ *:[v2i32] } (AArch64zip2:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })), (AArch64zip1:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (ADDPv4i32:{ *:[f128] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /*  10218 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  10221 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  10225 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10230 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  10234 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  10238 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  10240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10245 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  10252 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10257 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10262 */     // GIR_Coverage, 13659,
     /*  10262 */     GIR_EraseRootFromParent_Done,
     /*  10263 */   // Label 251: @10263
     /*  10263 */   GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(10399), // Rule ID 5309 //
     /*  10268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10284 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10288 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  10292 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  10296 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10301 */     // MIs[1] Operand 2
     /*  10301 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  10312 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  10316 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10320 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10324 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  10328 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  10332 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  10336 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10341 */     // MIs[3] Operand 2
     /*  10341 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  10352 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  10354 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  10354 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  10357 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  10361 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10366 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  10370 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  10374 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  10376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10381 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  10388 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10393 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10398 */     // GIR_Coverage, 5309,
     /*  10398 */     GIR_EraseRootFromParent_Done,
     /*  10399 */   // Label 252: @10399
     /*  10399 */   GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(10535), // Rule ID 5308 //
     /*  10404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10424 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  10428 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  10432 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10437 */     // MIs[1] Operand 2
     /*  10437 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  10448 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  10452 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10456 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10460 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  10464 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  10468 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  10472 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10477 */     // MIs[3] Operand 2
     /*  10477 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  10488 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  10490 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  10490 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  10493 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  10497 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10502 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  10506 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  10510 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  10512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10517 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  10524 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10529 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10534 */     // GIR_Coverage, 5308,
     /*  10534 */     GIR_EraseRootFromParent_Done,
     /*  10535 */   // Label 253: @10535
     /*  10535 */   GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(10671), // Rule ID 5321 //
     /*  10540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10552 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10556 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10560 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  10564 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  10568 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10573 */     // MIs[1] Operand 2
     /*  10573 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  10584 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  10588 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10592 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10596 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  10600 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  10604 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  10608 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10613 */     // MIs[3] Operand 2
     /*  10613 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  10624 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  10626 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  10626 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  10629 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i16_v4i32),
     /*  10633 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10638 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  10642 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  10646 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  10648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10653 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  10660 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10665 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10670 */     // GIR_Coverage, 5321,
     /*  10670 */     GIR_EraseRootFromParent_Done,
     /*  10671 */   // Label 254: @10671
     /*  10671 */   GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(10807), // Rule ID 5307 //
     /*  10676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10692 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10696 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  10700 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  10704 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10709 */     // MIs[1] Operand 2
     /*  10709 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  10720 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  10724 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10728 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10732 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  10736 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  10740 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  10744 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10749 */     // MIs[3] Operand 2
     /*  10749 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  10760 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  10762 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  10762 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  10765 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  10769 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10774 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  10778 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  10782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  10784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10789 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  10796 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10801 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10806 */     // GIR_Coverage, 5307,
     /*  10806 */     GIR_EraseRootFromParent_Done,
     /*  10807 */   // Label 255: @10807
     /*  10807 */   GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(10943), // Rule ID 5306 //
     /*  10812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10828 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10832 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  10836 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  10840 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10845 */     // MIs[1] Operand 2
     /*  10845 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  10856 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  10860 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10864 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10868 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  10872 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  10876 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  10880 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10885 */     // MIs[3] Operand 2
     /*  10885 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  10896 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  10898 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  10898 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  10901 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  10905 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10910 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  10914 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  10918 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  10920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10925 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  10932 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10937 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10942 */     // GIR_Coverage, 5306,
     /*  10942 */     GIR_EraseRootFromParent_Done,
     /*  10943 */   // Label 256: @10943
     /*  10943 */   GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(11106), // Rule ID 13613 //
     /*  10948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10964 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10968 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  10972 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  10976 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  10980 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10985 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10990 */     // MIs[1] Operand 2
     /*  10990 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  11001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11005 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11007 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  11007 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  11010 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  11014 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11019 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  11021 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  11024 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  11028 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11033 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  11036 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  11040 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  11043 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11048 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11053 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  11061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  11065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11070 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  11073 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  11077 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  11081 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  11083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  11086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11088 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  11095 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11100 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11105 */     // GIR_Coverage, 13613,
     /*  11105 */     GIR_EraseRootFromParent_Done,
     /*  11106 */   // Label 257: @11106
     /*  11106 */   GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(11269), // Rule ID 13610 //
     /*  11111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11123 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11131 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  11135 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11139 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  11143 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11148 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11153 */     // MIs[1] Operand 2
     /*  11153 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  11164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11168 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11170 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  11170 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  11173 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  11177 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11182 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  11184 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  11187 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  11191 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11196 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  11199 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  11203 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  11206 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11211 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11216 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11221 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  11224 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  11228 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11233 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  11236 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  11240 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  11244 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  11246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  11249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11251 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  11258 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11263 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11268 */     // GIR_Coverage, 13610,
     /*  11268 */     GIR_EraseRootFromParent_Done,
     /*  11269 */   // Label 258: @11269
     /*  11269 */   GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(11419), // Rule ID 13618 //
     /*  11274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11298 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11302 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11307 */     // MIs[1] Operand 2
     /*  11307 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  11318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11322 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11324 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  11324 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  11327 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  11331 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11336 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  11338 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  11341 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  11345 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11350 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  11353 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  11357 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  11360 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11365 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11370 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11375 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  11378 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  11382 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11387 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  11390 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  11394 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  11396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  11399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11401 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  11408 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11413 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11418 */     // GIR_Coverage, 13618,
     /*  11418 */     GIR_EraseRootFromParent_Done,
     /*  11419 */   // Label 259: @11419
     /*  11419 */   GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(11569), // Rule ID 13622 //
     /*  11424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11440 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11444 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  11448 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11452 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11457 */     // MIs[1] Operand 2
     /*  11457 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  11468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11472 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11474 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  11474 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  11477 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  11481 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11486 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  11488 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  11491 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  11495 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11500 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  11503 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  11507 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  11510 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11515 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11520 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11525 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  11528 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  11532 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11537 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  11540 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  11544 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  11546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  11549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11551 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  11558 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11563 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11568 */     // GIR_Coverage, 13622,
     /*  11568 */     GIR_EraseRootFromParent_Done,
     /*  11569 */   // Label 260: @11569
     /*  11569 */   GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(11719), // Rule ID 13617 //
     /*  11574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11590 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11594 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11598 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11602 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11607 */     // MIs[1] Operand 2
     /*  11607 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  11618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11622 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11624 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  11624 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  11627 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  11631 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11636 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  11638 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  11641 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  11645 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11650 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  11653 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  11657 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  11660 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11665 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11670 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11675 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  11678 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  11682 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11687 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  11690 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  11694 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  11696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  11699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11701 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  11708 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11713 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11718 */     // GIR_Coverage, 13617,
     /*  11718 */     GIR_EraseRootFromParent_Done,
     /*  11719 */   // Label 261: @11719
     /*  11719 */   GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(11882), // Rule ID 5294 //
     /*  11724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11728 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11744 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11748 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  11752 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11756 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  11760 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11765 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11770 */     // MIs[1] Operand 2
     /*  11770 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  11781 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11783 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  11783 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  11786 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  11790 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  11797 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  11800 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  11804 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11809 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  11812 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  11816 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  11819 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11824 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11829 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11834 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  11837 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  11841 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11846 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  11849 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  11853 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  11857 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  11859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  11862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11864 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  11871 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11876 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11881 */     // GIR_Coverage, 5294,
     /*  11881 */     GIR_EraseRootFromParent_Done,
     /*  11882 */   // Label 262: @11882
     /*  11882 */   GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(12045), // Rule ID 5291 //
     /*  11887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11907 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11911 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  11915 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11919 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  11923 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11928 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11933 */     // MIs[1] Operand 2
     /*  11933 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  11944 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11946 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  11946 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  11949 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  11953 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11958 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  11960 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  11963 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  11967 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11972 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  11975 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  11979 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  11982 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11987 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11992 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11997 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12000 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  12004 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12009 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  12012 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12016 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  12020 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12027 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12034 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12039 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12044 */     // GIR_Coverage, 5291,
     /*  12044 */     GIR_EraseRootFromParent_Done,
     /*  12045 */   // Label 263: @12045
     /*  12045 */   GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(12195), // Rule ID 5317 //
     /*  12050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12054 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12066 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12070 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12074 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12078 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12082 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12087 */     // MIs[1] Operand 2
     /*  12087 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12098 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12100 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12100 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  12103 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  12107 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12112 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  12114 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  12117 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  12121 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12126 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  12129 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  12133 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  12136 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12141 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12146 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12151 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12154 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  12158 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12163 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  12166 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  12170 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12177 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12184 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12189 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12194 */     // GIR_Coverage, 5317,
     /*  12194 */     GIR_EraseRootFromParent_Done,
     /*  12195 */   // Label 264: @12195
     /*  12195 */   GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(12345), // Rule ID 5324 //
     /*  12200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12204 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12216 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12220 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12224 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12228 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12232 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12237 */     // MIs[1] Operand 2
     /*  12237 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12248 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12250 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12250 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  12253 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  12257 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12262 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  12264 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  12267 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  12271 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12276 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  12279 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  12283 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  12286 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12291 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12296 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12301 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12304 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  12308 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12313 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  12316 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  12320 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12327 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12334 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12339 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12344 */     // GIR_Coverage, 5324,
     /*  12344 */     GIR_EraseRootFromParent_Done,
     /*  12345 */   // Label 265: @12345
     /*  12345 */   GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(12495), // Rule ID 5316 //
     /*  12350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12370 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12374 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12378 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12382 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12387 */     // MIs[1] Operand 2
     /*  12387 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12398 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12400 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12400 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  12403 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  12407 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12412 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  12414 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  12417 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  12421 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12426 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  12429 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  12433 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  12436 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12441 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12446 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12451 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12454 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  12458 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12463 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  12466 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  12470 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12477 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12484 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12489 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12494 */     // GIR_Coverage, 5316,
     /*  12494 */     GIR_EraseRootFromParent_Done,
     /*  12495 */   // Label 266: @12495
     /*  12495 */   GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(12564), // Rule ID 13065 //
     /*  12500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  12515 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  12518 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  12523 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  12527 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  12531 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12536 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12547 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V64:{ *:[v2i32] }:$Rd)  =>  (SABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  12547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv2i32),
     /*  12550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12552 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  12554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  12558 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  12562 */     GIR_RootConstrainSelectedInstOperands,
     /*  12563 */     // GIR_Coverage, 13065,
     /*  12563 */     GIR_EraseRootFromParent_Done,
     /*  12564 */   // Label 267: @12564
     /*  12564 */   GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(12633), // Rule ID 13077 //
     /*  12569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  12584 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  12587 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  12592 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  12596 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  12600 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12605 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12614 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12616 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V64:{ *:[v2i32] }:$Rd)  =>  (UABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  12616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv2i32),
     /*  12619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  12623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  12627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  12631 */     GIR_RootConstrainSelectedInstOperands,
     /*  12632 */     // GIR_Coverage, 13077,
     /*  12632 */     GIR_EraseRootFromParent_Done,
     /*  12633 */   // Label 268: @12633
     /*  12633 */   GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(12689), // Rule ID 13027 //
     /*  12638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  12653 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  12656 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  12661 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  12665 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12674 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12676 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 660:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  12676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  12679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  12683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  12687 */     GIR_RootConstrainSelectedInstOperands,
     /*  12688 */     // GIR_Coverage, 13027,
     /*  12688 */     GIR_EraseRootFromParent_Done,
     /*  12689 */   // Label 269: @12689
     /*  12689 */   GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(12745), // Rule ID 13039 //
     /*  12694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  12709 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  12712 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  12717 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  12721 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12730 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12732 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 725:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  12732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  12735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  12739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  12743 */     GIR_RootConstrainSelectedInstOperands,
     /*  12744 */     // GIR_Coverage, 13039,
     /*  12744 */     GIR_EraseRootFromParent_Done,
     /*  12745 */   // Label 270: @12745
     /*  12745 */   GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(12812), // Rule ID 13269 //
     /*  12750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  12765 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  12769 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12774 */     // MIs[1] imm
     /*  12774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  12778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  12782 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  12786 */     // MIs[2] Operand 1
     /*  12786 */     // No operand predicates
     /*  12786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12790 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  12794 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12796 */     // (add:{ *:[v2i32] } (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  12796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  12799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  12803 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  12807 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  12810 */     GIR_RootConstrainSelectedInstOperands,
     /*  12811 */     // GIR_Coverage, 13269,
     /*  12811 */     GIR_EraseRootFromParent_Done,
     /*  12812 */   // Label 271: @12812
     /*  12812 */   GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(12879), // Rule ID 13290 //
     /*  12817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  12832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  12836 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12841 */     // MIs[1] imm
     /*  12841 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  12845 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  12849 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  12853 */     // MIs[2] Operand 1
     /*  12853 */     // No operand predicates
     /*  12853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12857 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  12861 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12863 */     // (add:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  12863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  12866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12868 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  12870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  12874 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  12877 */     GIR_RootConstrainSelectedInstOperands,
     /*  12878 */     // GIR_Coverage, 13290,
     /*  12878 */     GIR_EraseRootFromParent_Done,
     /*  12879 */   // Label 272: @12879
     /*  12879 */   GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(12948), // Rule ID 1358 //
     /*  12884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  12903 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  12906 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  12911 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  12915 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  12919 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12924 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12931 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  12931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv2i32),
     /*  12934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12936 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  12938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  12942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  12946 */     GIR_RootConstrainSelectedInstOperands,
     /*  12947 */     // GIR_Coverage, 1358,
     /*  12947 */     GIR_EraseRootFromParent_Done,
     /*  12948 */   // Label 273: @12948
     /*  12948 */   GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(13017), // Rule ID 1481 //
     /*  12953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  12972 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  12975 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  12980 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  12984 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  12988 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12993 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12998 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13000 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  13000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv2i32),
     /*  13003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13005 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  13007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  13011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  13015 */     GIR_RootConstrainSelectedInstOperands,
     /*  13016 */     // GIR_Coverage, 1481,
     /*  13016 */     GIR_EraseRootFromParent_Done,
     /*  13017 */   // Label 274: @13017
     /*  13017 */   GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(13073), // Rule ID 986 //
     /*  13022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  13041 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  13044 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  13049 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  13053 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13058 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13060 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 660:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  13060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  13063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13065 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  13067 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  13071 */     GIR_RootConstrainSelectedInstOperands,
     /*  13072 */     // GIR_Coverage, 986,
     /*  13072 */     GIR_EraseRootFromParent_Done,
     /*  13073 */   // Label 275: @13073
     /*  13073 */   GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(13129), // Rule ID 1047 //
     /*  13078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13085 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  13097 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  13100 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  13105 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  13109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13114 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13116 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 725:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  13116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  13119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13121 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  13123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  13127 */     GIR_RootConstrainSelectedInstOperands,
     /*  13128 */     // GIR_Coverage, 1047,
     /*  13128 */     GIR_EraseRootFromParent_Done,
     /*  13129 */   // Label 276: @13129
     /*  13129 */   GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(13196), // Rule ID 2229 //
     /*  13134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  13153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  13157 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13162 */     // MIs[1] imm
     /*  13162 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  13166 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  13170 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  13174 */     // MIs[2] Operand 1
     /*  13174 */     // No operand predicates
     /*  13174 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  13178 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13180 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  13180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  13183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13185 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  13187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  13191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  13194 */     GIR_RootConstrainSelectedInstOperands,
     /*  13195 */     // GIR_Coverage, 2229,
     /*  13195 */     GIR_EraseRootFromParent_Done,
     /*  13196 */   // Label 277: @13196
     /*  13196 */   GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(13263), // Rule ID 2288 //
     /*  13201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13208 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  13220 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  13224 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13229 */     // MIs[1] imm
     /*  13229 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  13233 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  13237 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  13241 */     // MIs[2] Operand 1
     /*  13241 */     // No operand predicates
     /*  13241 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  13245 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13247 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  13247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  13250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13252 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  13254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  13258 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  13261 */     GIR_RootConstrainSelectedInstOperands,
     /*  13262 */     // GIR_Coverage, 2288,
     /*  13262 */     GIR_EraseRootFromParent_Done,
     /*  13263 */   // Label 278: @13263
     /*  13263 */   GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(13311), // Rule ID 13026 //
     /*  13268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  13283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13287 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13296 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13298 */     // (add:{ *:[v2i32] } (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  13298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  13301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  13305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  13309 */     GIR_RootConstrainSelectedInstOperands,
     /*  13310 */     // GIR_Coverage, 13026,
     /*  13310 */     GIR_EraseRootFromParent_Done,
     /*  13311 */   // Label 279: @13311
     /*  13311 */   GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(13359), // Rule ID 13038 //
     /*  13316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  13331 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13335 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13344 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13346 */     // (add:{ *:[v2i32] } (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  13346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  13349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  13353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  13357 */     GIR_RootConstrainSelectedInstOperands,
     /*  13358 */     // GIR_Coverage, 13038,
     /*  13358 */     GIR_EraseRootFromParent_Done,
     /*  13359 */   // Label 280: @13359
     /*  13359 */   GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(13407), // Rule ID 985 //
     /*  13364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  13383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13387 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13394 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  13394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  13397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13399 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  13401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  13405 */     GIR_RootConstrainSelectedInstOperands,
     /*  13406 */     // GIR_Coverage, 985,
     /*  13406 */     GIR_EraseRootFromParent_Done,
     /*  13407 */   // Label 281: @13407
     /*  13407 */   GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(13455), // Rule ID 1046 //
     /*  13412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  13431 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13435 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13440 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13442 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  13442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  13445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13447 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  13449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  13453 */     GIR_RootConstrainSelectedInstOperands,
     /*  13454 */     // GIR_Coverage, 1046,
     /*  13454 */     GIR_EraseRootFromParent_Done,
     /*  13455 */   // Label 282: @13455
     /*  13455 */   GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(13482), // Rule ID 1097 //
     /*  13460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13475 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  13475 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv2i32),
     /*  13480 */     GIR_RootConstrainSelectedInstOperands,
     /*  13481 */     // GIR_Coverage, 1097,
     /*  13481 */     GIR_Done,
     /*  13482 */   // Label 283: @13482
     /*  13482 */   GIM_Reject,
     /*  13483 */ // Label 249: @13483
     /*  13483 */ GIM_Reject,
     /*  13484 */ // Label 158: @13484
     /*  13484 */ GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(19385),
     /*  13489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  13492 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  13495 */   GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(13613), // Rule ID 13204 //
     /*  13500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  13515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  13519 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  13523 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  13527 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13531 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13535 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  13539 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  13543 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13547 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  13551 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13556 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  13560 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  13564 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  13568 */     // MIs[4] Operand 1
     /*  13568 */     // No operand predicates
     /*  13568 */     // MIs[2] Operand 2
     /*  13568 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  13579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13583 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  13585 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  13592 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  13592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  13595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  13599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  13604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  13608 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  13611 */     GIR_RootConstrainSelectedInstOperands,
     /*  13612 */     // GIR_Coverage, 13204,
     /*  13612 */     GIR_EraseRootFromParent_Done,
     /*  13613 */   // Label 285: @13613
     /*  13613 */   GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(13731), // Rule ID 13205 //
     /*  13618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  13633 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  13637 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  13641 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13645 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13649 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13653 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  13657 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  13661 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13665 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  13669 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13674 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  13678 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  13682 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  13686 */     // MIs[4] Operand 1
     /*  13686 */     // No operand predicates
     /*  13686 */     // MIs[2] Operand 2
     /*  13686 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  13697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13701 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  13703 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  13710 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  13710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  13713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13715 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  13717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  13722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  13726 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  13729 */     GIR_RootConstrainSelectedInstOperands,
     /*  13730 */     // GIR_Coverage, 13205,
     /*  13730 */     GIR_EraseRootFromParent_Done,
     /*  13731 */   // Label 286: @13731
     /*  13731 */   GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(13849), // Rule ID 13234 //
     /*  13736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  13751 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  13755 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  13759 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  13763 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13767 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13771 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  13775 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  13779 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13783 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  13787 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13792 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  13796 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  13800 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  13804 */     // MIs[4] Operand 1
     /*  13804 */     // No operand predicates
     /*  13804 */     // MIs[2] Operand 2
     /*  13804 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  13815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13819 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  13821 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  13828 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  13828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  13831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  13835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  13840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  13844 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  13847 */     GIR_RootConstrainSelectedInstOperands,
     /*  13848 */     // GIR_Coverage, 13234,
     /*  13848 */     GIR_EraseRootFromParent_Done,
     /*  13849 */   // Label 287: @13849
     /*  13849 */   GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(13967), // Rule ID 13235 //
     /*  13854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  13869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  13873 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  13877 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13881 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13885 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13889 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  13893 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  13897 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13901 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  13905 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13910 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  13914 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  13918 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  13922 */     // MIs[4] Operand 1
     /*  13922 */     // No operand predicates
     /*  13922 */     // MIs[2] Operand 2
     /*  13922 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  13933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13937 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  13939 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  13946 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  13946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  13949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  13953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  13958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  13962 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  13965 */     GIR_RootConstrainSelectedInstOperands,
     /*  13966 */     // GIR_Coverage, 13235,
     /*  13966 */     GIR_EraseRootFromParent_Done,
     /*  13967 */   // Label 288: @13967
     /*  13967 */   GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(14085), // Rule ID 2035 //
     /*  13972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13979 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  13991 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  13995 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  13999 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14003 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  14007 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14011 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  14015 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  14019 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14023 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  14027 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14032 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  14036 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14040 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  14044 */     // MIs[4] Operand 1
     /*  14044 */     // No operand predicates
     /*  14044 */     // MIs[2] Operand 2
     /*  14044 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  14055 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  14057 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  14064 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  14064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  14067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14069 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  14076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  14080 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  14083 */     GIR_RootConstrainSelectedInstOperands,
     /*  14084 */     // GIR_Coverage, 2035,
     /*  14084 */     GIR_EraseRootFromParent_Done,
     /*  14085 */   // Label 289: @14085
     /*  14085 */   GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(14203), // Rule ID 13203 //
     /*  14090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14097 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  14109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14113 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  14125 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14129 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  14133 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  14137 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14141 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  14145 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14150 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  14154 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14158 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  14162 */     // MIs[4] Operand 1
     /*  14162 */     // No operand predicates
     /*  14162 */     // MIs[2] Operand 2
     /*  14162 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  14173 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  14175 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  14182 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  14182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  14185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14187 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  14194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  14198 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  14201 */     GIR_RootConstrainSelectedInstOperands,
     /*  14202 */     // GIR_Coverage, 13203,
     /*  14202 */     GIR_EraseRootFromParent_Done,
     /*  14203 */   // Label 290: @14203
     /*  14203 */   GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(14321), // Rule ID 2087 //
     /*  14208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  14227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14231 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14235 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14239 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  14243 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14247 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  14251 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  14255 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14259 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  14263 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14268 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  14272 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14276 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  14280 */     // MIs[4] Operand 1
     /*  14280 */     // No operand predicates
     /*  14280 */     // MIs[2] Operand 2
     /*  14280 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  14291 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  14293 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  14300 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  14300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  14303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14305 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  14312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  14316 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  14319 */     GIR_RootConstrainSelectedInstOperands,
     /*  14320 */     // GIR_Coverage, 2087,
     /*  14320 */     GIR_EraseRootFromParent_Done,
     /*  14321 */   // Label 291: @14321
     /*  14321 */   GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(14439), // Rule ID 13233 //
     /*  14326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  14345 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14349 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14353 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14357 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  14361 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14365 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  14369 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  14373 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14377 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  14381 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14386 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  14390 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14394 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  14398 */     // MIs[4] Operand 1
     /*  14398 */     // No operand predicates
     /*  14398 */     // MIs[2] Operand 2
     /*  14398 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  14409 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  14411 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  14418 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  14418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  14421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14423 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  14430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  14434 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  14437 */     GIR_RootConstrainSelectedInstOperands,
     /*  14438 */     // GIR_Coverage, 13233,
     /*  14438 */     GIR_EraseRootFromParent_Done,
     /*  14439 */   // Label 292: @14439
     /*  14439 */   GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(14526), // Rule ID 13109 //
     /*  14444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  14459 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14463 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14467 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14471 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  14474 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  14479 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14483 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14491 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14493 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  14500 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  14507 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))), V128:{ *:[v2i64] }:$Rd)  =>  (SABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  14507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i32_v2i64),
     /*  14510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14512 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  14519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  14524 */     GIR_RootConstrainSelectedInstOperands,
     /*  14525 */     // GIR_Coverage, 13109,
     /*  14525 */     GIR_EraseRootFromParent_Done,
     /*  14526 */   // Label 293: @14526
     /*  14526 */   GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(14613), // Rule ID 13133 //
     /*  14531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  14546 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14550 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14554 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14558 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  14561 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  14566 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14570 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14578 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14580 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  14587 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  14594 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))), V128:{ *:[v2i64] }:$Rd)  =>  (UABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  14594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i32_v2i64),
     /*  14597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  14606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  14611 */     GIR_RootConstrainSelectedInstOperands,
     /*  14612 */     // GIR_Coverage, 13133,
     /*  14612 */     GIR_EraseRootFromParent_Done,
     /*  14613 */   // Label 294: @14613
     /*  14613 */   GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(14700), // Rule ID 1692 //
     /*  14618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  14637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14641 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14645 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14649 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  14652 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  14657 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14661 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14665 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14667 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  14674 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  14681 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))))  =>  (SABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  14681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i32_v2i64),
     /*  14684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14686 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  14693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  14698 */     GIR_RootConstrainSelectedInstOperands,
     /*  14699 */     // GIR_Coverage, 1692,
     /*  14699 */     GIR_EraseRootFromParent_Done,
     /*  14700 */   // Label 295: @14700
     /*  14700 */   GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(14787), // Rule ID 1770 //
     /*  14705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  14724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14736 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  14739 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  14744 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14748 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14752 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14754 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  14761 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  14768 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))))  =>  (UABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  14768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i32_v2i64),
     /*  14771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14773 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  14780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  14785 */     GIR_RootConstrainSelectedInstOperands,
     /*  14786 */     // GIR_Coverage, 1770,
     /*  14786 */     GIR_EraseRootFromParent_Done,
     /*  14787 */   // Label 296: @14787
     /*  14787 */   GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(14902), // Rule ID 13199 //
     /*  14792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  14807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14811 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14815 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14819 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  14823 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14827 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  14831 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  14835 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14839 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  14843 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14848 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  14852 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14856 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  14860 */     // MIs[4] Operand 1
     /*  14860 */     // No operand predicates
     /*  14860 */     // MIs[2] Operand 2
     /*  14860 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  14871 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14880 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  14882 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  14882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  14885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  14897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  14900 */     GIR_RootConstrainSelectedInstOperands,
     /*  14901 */     // GIR_Coverage, 13199,
     /*  14901 */     GIR_EraseRootFromParent_Done,
     /*  14902 */   // Label 297: @14902
     /*  14902 */   GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(15017), // Rule ID 13198 //
     /*  14907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  14922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14926 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14930 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14935 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14939 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  14943 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14947 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  14951 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  14955 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14959 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  14963 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14968 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  14972 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14976 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  14980 */     // MIs[4] Operand 1
     /*  14980 */     // No operand predicates
     /*  14980 */     // MIs[2] Operand 2
     /*  14980 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  14991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14995 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  14997 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  14997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  15000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15012 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15015 */     GIR_RootConstrainSelectedInstOperands,
     /*  15016 */     // GIR_Coverage, 13198,
     /*  15016 */     GIR_EraseRootFromParent_Done,
     /*  15017 */   // Label 298: @15017
     /*  15017 */   GIM_Try, /*On fail goto*//*Label 299*/ GIMT_Encode4(15132), // Rule ID 13229 //
     /*  15022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  15037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15041 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15045 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15049 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15053 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15057 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15061 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15065 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15069 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15073 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15078 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15082 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15086 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15090 */     // MIs[4] Operand 1
     /*  15090 */     // No operand predicates
     /*  15090 */     // MIs[2] Operand 2
     /*  15090 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  15101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15110 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15112 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  15115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  15123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15127 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15130 */     GIR_RootConstrainSelectedInstOperands,
     /*  15131 */     // GIR_Coverage, 13229,
     /*  15131 */     GIR_EraseRootFromParent_Done,
     /*  15132 */   // Label 299: @15132
     /*  15132 */   GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(15247), // Rule ID 13228 //
     /*  15137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  15152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15156 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15160 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15165 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15169 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15173 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15177 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15181 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15185 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15189 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15193 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15198 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15202 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15206 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15210 */     // MIs[4] Operand 1
     /*  15210 */     // No operand predicates
     /*  15210 */     // MIs[2] Operand 2
     /*  15210 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  15221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15225 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15227 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  15230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15242 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15245 */     GIR_RootConstrainSelectedInstOperands,
     /*  15246 */     // GIR_Coverage, 13228,
     /*  15246 */     GIR_EraseRootFromParent_Done,
     /*  15247 */   // Label 300: @15247
     /*  15247 */   GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(15316), // Rule ID 1794 //
     /*  15252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  15267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15271 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  15275 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  15279 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15283 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  15285 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15292 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15299 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  15299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  15302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  15314 */     GIR_RootConstrainSelectedInstOperands,
     /*  15315 */     // GIR_Coverage, 1794,
     /*  15315 */     GIR_EraseRootFromParent_Done,
     /*  15316 */   // Label 301: @15316
     /*  15316 */   GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(15385), // Rule ID 1793 //
     /*  15321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  15336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15340 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  15344 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  15348 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15352 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  15354 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15361 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15368 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  15368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  15371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  15383 */     GIR_RootConstrainSelectedInstOperands,
     /*  15384 */     // GIR_Coverage, 1793,
     /*  15384 */     GIR_EraseRootFromParent_Done,
     /*  15385 */   // Label 302: @15385
     /*  15385 */   GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(15454), // Rule ID 1710 //
     /*  15390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  15405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15409 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  15413 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  15417 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15421 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  15423 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15430 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15437 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  15437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i32_v2i64),
     /*  15440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  15452 */     GIR_RootConstrainSelectedInstOperands,
     /*  15453 */     // GIR_Coverage, 1710,
     /*  15453 */     GIR_EraseRootFromParent_Done,
     /*  15454 */   // Label 303: @15454
     /*  15454 */   GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(15523), // Rule ID 1792 //
     /*  15459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  15474 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15478 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  15482 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  15486 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15490 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  15492 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15499 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15506 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  15506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  15509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  15521 */     GIR_RootConstrainSelectedInstOperands,
     /*  15522 */     // GIR_Coverage, 1792,
     /*  15522 */     GIR_EraseRootFromParent_Done,
     /*  15523 */   // Label 304: @15523
     /*  15523 */   GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(15592), // Rule ID 1791 //
     /*  15528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  15543 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15547 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  15551 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  15555 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15559 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  15561 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15568 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15575 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  15575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  15578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  15590 */     GIR_RootConstrainSelectedInstOperands,
     /*  15591 */     // GIR_Coverage, 1791,
     /*  15591 */     GIR_EraseRootFromParent_Done,
     /*  15592 */   // Label 305: @15592
     /*  15592 */   GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(15707), // Rule ID 13197 //
     /*  15597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  15616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15620 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15624 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15628 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15632 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15636 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15640 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15644 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15648 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15652 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15657 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15661 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15665 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15669 */     // MIs[4] Operand 1
     /*  15669 */     // No operand predicates
     /*  15669 */     // MIs[2] Operand 2
     /*  15669 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  15680 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15685 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15687 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  15690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15692 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  15698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15702 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15705 */     GIR_RootConstrainSelectedInstOperands,
     /*  15706 */     // GIR_Coverage, 13197,
     /*  15706 */     GIR_EraseRootFromParent_Done,
     /*  15707 */   // Label 306: @15707
     /*  15707 */   GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(15822), // Rule ID 2033 //
     /*  15712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  15731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15735 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15739 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15744 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15748 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15752 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15756 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15760 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15764 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15768 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15772 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15777 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15781 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15785 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15789 */     // MIs[4] Operand 1
     /*  15789 */     // No operand predicates
     /*  15789 */     // MIs[2] Operand 2
     /*  15789 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  15800 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15802 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  15805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15807 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15817 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15820 */     GIR_RootConstrainSelectedInstOperands,
     /*  15821 */     // GIR_Coverage, 2033,
     /*  15821 */     GIR_EraseRootFromParent_Done,
     /*  15822 */   // Label 307: @15822
     /*  15822 */   GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(15937), // Rule ID 13227 //
     /*  15827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15834 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  15846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15850 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15854 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15858 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15862 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15866 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15870 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15874 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15878 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15882 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15887 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15891 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15895 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15899 */     // MIs[4] Operand 1
     /*  15899 */     // No operand predicates
     /*  15899 */     // MIs[2] Operand 2
     /*  15899 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  15910 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15915 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15917 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  15920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15922 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  15928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15932 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15935 */     GIR_RootConstrainSelectedInstOperands,
     /*  15936 */     // GIR_Coverage, 13227,
     /*  15936 */     GIR_EraseRootFromParent_Done,
     /*  15937 */   // Label 308: @15937
     /*  15937 */   GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(16052), // Rule ID 2085 //
     /*  15942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15949 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  15961 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15965 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15969 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15974 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15978 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15982 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15986 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15990 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15994 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15998 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16002 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16007 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16011 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16015 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16019 */     // MIs[4] Operand 1
     /*  16019 */     // No operand predicates
     /*  16019 */     // MIs[2] Operand 2
     /*  16019 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  16030 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16032 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  16035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16037 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16039 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  16043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16047 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16050 */     GIR_RootConstrainSelectedInstOperands,
     /*  16051 */     // GIR_Coverage, 2085,
     /*  16051 */     GIR_EraseRootFromParent_Done,
     /*  16052 */   // Label 309: @16052
     /*  16052 */   GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(16119), // Rule ID 13121 //
     /*  16057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  16072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16076 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16084 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16086 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16093 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16100 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_v2i64),
     /*  16103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16117 */     GIR_RootConstrainSelectedInstOperands,
     /*  16118 */     // GIR_Coverage, 13121,
     /*  16118 */     GIR_EraseRootFromParent_Done,
     /*  16119 */   // Label 310: @16119
     /*  16119 */   GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(16186), // Rule ID 13151 //
     /*  16124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16139 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16143 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16153 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16160 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16167 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_v2i64),
     /*  16170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16184 */     GIR_RootConstrainSelectedInstOperands,
     /*  16185 */     // GIR_Coverage, 13151,
     /*  16185 */     GIR_EraseRootFromParent_Done,
     /*  16186 */   // Label 311: @16186
     /*  16186 */   GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(16253), // Rule ID 1722 //
     /*  16191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16198 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  16210 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16214 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16218 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16220 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16227 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16234 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_v2i64),
     /*  16237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16239 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16251 */     GIR_RootConstrainSelectedInstOperands,
     /*  16252 */     // GIR_Coverage, 1722,
     /*  16252 */     GIR_EraseRootFromParent_Done,
     /*  16253 */   // Label 312: @16253
     /*  16253 */   GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(16320), // Rule ID 1812 //
     /*  16258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16277 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16281 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16285 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16287 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16294 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16301 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_v2i64),
     /*  16304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16306 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16318 */     GIR_RootConstrainSelectedInstOperands,
     /*  16319 */     // GIR_Coverage, 1812,
     /*  16319 */     GIR_EraseRootFromParent_Done,
     /*  16320 */   // Label 313: @16320
     /*  16320 */   GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(16401), // Rule ID 13107 //
     /*  16325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16352 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16355 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  16360 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16364 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16368 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16373 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16382 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16384 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (SABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  16384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv2i32_v2i64),
     /*  16387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  16395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  16399 */     GIR_RootConstrainSelectedInstOperands,
     /*  16400 */     // GIR_Coverage, 13107,
     /*  16400 */     GIR_EraseRootFromParent_Done,
     /*  16401 */   // Label 314: @16401
     /*  16401 */   GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(16482), // Rule ID 13131 //
     /*  16406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16421 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16425 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16429 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16433 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16436 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  16441 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16445 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16449 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16454 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16463 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16465 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (UABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  16465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv2i32_v2i64),
     /*  16468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  16476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  16480 */     GIR_RootConstrainSelectedInstOperands,
     /*  16481 */     // GIR_Coverage, 13131,
     /*  16481 */     GIR_EraseRootFromParent_Done,
     /*  16482 */   // Label 315: @16482
     /*  16482 */   GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(16563), // Rule ID 1690 //
     /*  16487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16510 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16514 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16518 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16521 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  16526 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16530 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16534 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16539 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16544 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16546 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)))  =>  (SABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  16546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv2i32_v2i64),
     /*  16549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16551 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  16557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  16561 */     GIR_RootConstrainSelectedInstOperands,
     /*  16562 */     // GIR_Coverage, 1690,
     /*  16562 */     GIR_EraseRootFromParent_Done,
     /*  16563 */   // Label 316: @16563
     /*  16563 */   GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(16644), // Rule ID 1768 //
     /*  16568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16591 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16595 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16599 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16602 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  16607 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16611 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16615 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16620 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16625 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16627 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)))  =>  (UABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  16627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv2i32_v2i64),
     /*  16630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16632 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  16638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  16642 */     GIR_RootConstrainSelectedInstOperands,
     /*  16643 */     // GIR_Coverage, 1768,
     /*  16643 */     GIR_EraseRootFromParent_Done,
     /*  16644 */   // Label 317: @16644
     /*  16644 */   GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(16736), // Rule ID 13202 //
     /*  16649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  16664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16668 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16672 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16676 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16680 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16684 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  16688 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16693 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  16697 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16701 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16705 */     // MIs[3] Operand 1
     /*  16705 */     // No operand predicates
     /*  16705 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16714 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  16716 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  16719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  16727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  16731 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  16734 */     GIR_RootConstrainSelectedInstOperands,
     /*  16735 */     // GIR_Coverage, 13202,
     /*  16735 */     GIR_EraseRootFromParent_Done,
     /*  16736 */   // Label 318: @16736
     /*  16736 */   GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(16828), // Rule ID 13201 //
     /*  16741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  16756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16760 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16764 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16777 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16781 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  16785 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16790 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  16794 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16798 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16802 */     // MIs[3] Operand 1
     /*  16802 */     // No operand predicates
     /*  16802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16806 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  16808 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  16811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  16819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  16823 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  16826 */     GIR_RootConstrainSelectedInstOperands,
     /*  16827 */     // GIR_Coverage, 13201,
     /*  16827 */     GIR_EraseRootFromParent_Done,
     /*  16828 */   // Label 319: @16828
     /*  16828 */   GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(16920), // Rule ID 13232 //
     /*  16833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16848 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16852 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16856 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16860 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16864 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16868 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  16872 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16877 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  16881 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16885 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16889 */     // MIs[3] Operand 1
     /*  16889 */     // No operand predicates
     /*  16889 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16898 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  16900 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  16903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  16911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  16915 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  16918 */     GIR_RootConstrainSelectedInstOperands,
     /*  16919 */     // GIR_Coverage, 13232,
     /*  16919 */     GIR_EraseRootFromParent_Done,
     /*  16920 */   // Label 320: @16920
     /*  16920 */   GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(17012), // Rule ID 13231 //
     /*  16925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16940 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16944 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16948 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16953 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16957 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16961 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16965 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  16969 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16974 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  16978 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16982 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16986 */     // MIs[3] Operand 1
     /*  16986 */     // No operand predicates
     /*  16986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16990 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  16992 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  16995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  17003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  17007 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  17010 */     GIR_RootConstrainSelectedInstOperands,
     /*  17011 */     // GIR_Coverage, 13231,
     /*  17011 */     GIR_EraseRootFromParent_Done,
     /*  17012 */   // Label 321: @17012
     /*  17012 */   GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(17104), // Rule ID 13200 //
     /*  17017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17024 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  17036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17040 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17044 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  17048 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17052 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17056 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  17060 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17065 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  17069 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17073 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17077 */     // MIs[3] Operand 1
     /*  17077 */     // No operand predicates
     /*  17077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17082 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  17084 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  17087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17089 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  17095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  17099 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  17102 */     GIR_RootConstrainSelectedInstOperands,
     /*  17103 */     // GIR_Coverage, 13200,
     /*  17103 */     GIR_EraseRootFromParent_Done,
     /*  17104 */   // Label 322: @17104
     /*  17104 */   GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(17196), // Rule ID 2034 //
     /*  17109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17116 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  17128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17132 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17136 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17141 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17145 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17149 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17153 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  17157 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17162 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  17166 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17170 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17174 */     // MIs[3] Operand 1
     /*  17174 */     // No operand predicates
     /*  17174 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  17176 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  17179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17181 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  17187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  17191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  17194 */     GIR_RootConstrainSelectedInstOperands,
     /*  17195 */     // GIR_Coverage, 2034,
     /*  17195 */     GIR_EraseRootFromParent_Done,
     /*  17196 */   // Label 323: @17196
     /*  17196 */   GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(17288), // Rule ID 13230 //
     /*  17201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17208 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  17220 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17224 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17228 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  17232 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17236 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17240 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  17244 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17249 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  17253 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17257 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17261 */     // MIs[3] Operand 1
     /*  17261 */     // No operand predicates
     /*  17261 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17266 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  17268 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  17271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17273 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  17279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  17283 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  17286 */     GIR_RootConstrainSelectedInstOperands,
     /*  17287 */     // GIR_Coverage, 13230,
     /*  17287 */     GIR_EraseRootFromParent_Done,
     /*  17288 */   // Label 324: @17288
     /*  17288 */   GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(17380), // Rule ID 2086 //
     /*  17293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17300 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  17312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17316 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17325 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17329 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17333 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17337 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  17341 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17346 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  17350 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17354 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17358 */     // MIs[3] Operand 1
     /*  17358 */     // No operand predicates
     /*  17358 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  17360 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  17363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17365 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  17371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  17375 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  17378 */     GIR_RootConstrainSelectedInstOperands,
     /*  17379 */     // GIR_Coverage, 2086,
     /*  17379 */     GIR_EraseRootFromParent_Done,
     /*  17380 */   // Label 325: @17380
     /*  17380 */   GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(17431), // Rule ID 13145 //
     /*  17385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17400 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17408 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17410 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17417 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  17420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  17424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  17429 */     GIR_RootConstrainSelectedInstOperands,
     /*  17430 */     // GIR_Coverage, 13145,
     /*  17430 */     GIR_EraseRootFromParent_Done,
     /*  17431 */   // Label 326: @17431
     /*  17431 */   GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(17482), // Rule ID 13115 //
     /*  17436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  17451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17461 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17468 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (SADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i32_v2i64),
     /*  17471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  17475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  17480 */     GIR_RootConstrainSelectedInstOperands,
     /*  17481 */     // GIR_Coverage, 13115,
     /*  17481 */     GIR_EraseRootFromParent_Done,
     /*  17482 */   // Label 327: @17482
     /*  17482 */   GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(17533), // Rule ID 13144 //
     /*  17487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17510 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17512 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17519 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  17522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  17526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  17531 */     GIR_RootConstrainSelectedInstOperands,
     /*  17532 */     // GIR_Coverage, 13144,
     /*  17532 */     GIR_EraseRootFromParent_Done,
     /*  17533 */   // Label 328: @17533
     /*  17533 */   GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(17584), // Rule ID 1806 //
     /*  17538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17563 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17570 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  17573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17575 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  17582 */     GIR_RootConstrainSelectedInstOperands,
     /*  17583 */     // GIR_Coverage, 1806,
     /*  17583 */     GIR_EraseRootFromParent_Done,
     /*  17584 */   // Label 329: @17584
     /*  17584 */   GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(17635), // Rule ID 1716 //
     /*  17589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17596 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  17608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17612 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17614 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17621 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i32_v2i64),
     /*  17624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17626 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  17633 */     GIR_RootConstrainSelectedInstOperands,
     /*  17634 */     // GIR_Coverage, 1716,
     /*  17634 */     GIR_EraseRootFromParent_Done,
     /*  17635 */   // Label 330: @17635
     /*  17635 */   GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(17686), // Rule ID 1805 //
     /*  17640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17647 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17665 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17672 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  17675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17677 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  17684 */     GIR_RootConstrainSelectedInstOperands,
     /*  17685 */     // GIR_Coverage, 1805,
     /*  17685 */     GIR_EraseRootFromParent_Done,
     /*  17686 */   // Label 331: @17686
     /*  17686 */   GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(17742), // Rule ID 13033 //
     /*  17691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  17706 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  17709 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  17714 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17718 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17729 */     // (add:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 660:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  17729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  17732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17734 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  17736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  17740 */     GIR_RootConstrainSelectedInstOperands,
     /*  17741 */     // GIR_Coverage, 13033,
     /*  17741 */     GIR_EraseRootFromParent_Done,
     /*  17742 */   // Label 332: @17742
     /*  17742 */   GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(17798), // Rule ID 13045 //
     /*  17747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  17762 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  17765 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  17770 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17774 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17785 */     // (add:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 725:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  17785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  17788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  17792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  17796 */     GIR_RootConstrainSelectedInstOperands,
     /*  17797 */     // GIR_Coverage, 13045,
     /*  17797 */     GIR_EraseRootFromParent_Done,
     /*  17798 */   // Label 333: @17798
     /*  17798 */   GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(17865), // Rule ID 13273 //
     /*  17803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  17818 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  17822 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17827 */     // MIs[1] imm
     /*  17827 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17831 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17835 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  17839 */     // MIs[2] Operand 1
     /*  17839 */     // No operand predicates
     /*  17839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17843 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  17847 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17849 */     // (add:{ *:[v2i64] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  17849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  17852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  17856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  17860 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  17863 */     GIR_RootConstrainSelectedInstOperands,
     /*  17864 */     // GIR_Coverage, 13273,
     /*  17864 */     GIR_EraseRootFromParent_Done,
     /*  17865 */   // Label 334: @17865
     /*  17865 */   GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(17932), // Rule ID 13294 //
     /*  17870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  17885 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  17889 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17894 */     // MIs[1] imm
     /*  17894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17898 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17902 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  17906 */     // MIs[2] Operand 1
     /*  17906 */     // No operand predicates
     /*  17906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17910 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  17914 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17916 */     // (add:{ *:[v2i64] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  17916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  17919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  17923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  17927 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  17930 */     GIR_RootConstrainSelectedInstOperands,
     /*  17931 */     // GIR_Coverage, 13294,
     /*  17931 */     GIR_EraseRootFromParent_Done,
     /*  17932 */   // Label 335: @17932
     /*  17932 */   GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(17988), // Rule ID 992 //
     /*  17937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  17956 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  17959 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  17964 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17968 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17975 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 660:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  17975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  17978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17980 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  17986 */     GIR_RootConstrainSelectedInstOperands,
     /*  17987 */     // GIR_Coverage, 992,
     /*  17987 */     GIR_EraseRootFromParent_Done,
     /*  17988 */   // Label 336: @17988
     /*  17988 */   GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(18044), // Rule ID 1053 //
     /*  17993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18012 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  18015 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  18020 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18024 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18031 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 725:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  18031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  18034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18036 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  18042 */     GIR_RootConstrainSelectedInstOperands,
     /*  18043 */     // GIR_Coverage, 1053,
     /*  18043 */     GIR_EraseRootFromParent_Done,
     /*  18044 */   // Label 337: @18044
     /*  18044 */   GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(18111), // Rule ID 2233 //
     /*  18049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18056 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  18068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  18072 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18077 */     // MIs[1] imm
     /*  18077 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18081 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18085 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  18089 */     // MIs[2] Operand 1
     /*  18089 */     // No operand predicates
     /*  18089 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  18093 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18095 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  18095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  18098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18100 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18102 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18106 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  18109 */     GIR_RootConstrainSelectedInstOperands,
     /*  18110 */     // GIR_Coverage, 2233,
     /*  18110 */     GIR_EraseRootFromParent_Done,
     /*  18111 */   // Label 338: @18111
     /*  18111 */   GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(18178), // Rule ID 2292 //
     /*  18116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18123 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  18135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  18139 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18144 */     // MIs[1] imm
     /*  18144 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18148 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18152 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  18156 */     // MIs[2] Operand 1
     /*  18156 */     // No operand predicates
     /*  18156 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  18160 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18162 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  18162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  18165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18167 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18173 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  18176 */     GIR_RootConstrainSelectedInstOperands,
     /*  18177 */     // GIR_Coverage, 2292,
     /*  18177 */     GIR_EraseRootFromParent_Done,
     /*  18178 */   // Label 339: @18178
     /*  18178 */   GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(18248), // Rule ID 6836 //
     /*  18183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP1),
     /*  18195 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  18199 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  18203 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18213 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP2),
     /*  18221 */     // MIs[2] Rn
     /*  18221 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18226 */     // MIs[2] Rm
     /*  18226 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  18231 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18233 */     // (add:{ *:[v2i64] } (AArch64zip1:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm), (AArch64zip2:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm))  =>  (ADDPv2i64:{ *:[v2i64] } ?:{ *:[v2i64] }:$Rn, ?:{ *:[v2i64] }:$Rm)
     /*  18233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64),
     /*  18236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  18238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  18246 */     GIR_RootConstrainSelectedInstOperands,
     /*  18247 */     // GIR_Coverage, 6836,
     /*  18247 */     GIR_EraseRootFromParent_Done,
     /*  18248 */   // Label 340: @18248
     /*  18248 */   GIM_Try, /*On fail goto*//*Label 341*/ GIMT_Encode4(18318), // Rule ID 13655 //
     /*  18253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP2),
     /*  18265 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  18269 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  18273 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18278 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18283 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18287 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP1),
     /*  18291 */     // MIs[2] Rn
     /*  18291 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18296 */     // MIs[2] Rm
     /*  18296 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  18301 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18303 */     // (add:{ *:[v2i64] } (AArch64zip2:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm), (AArch64zip1:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm))  =>  (ADDPv2i64:{ *:[v2i64] } ?:{ *:[v2i64] }:$Rn, ?:{ *:[v2i64] }:$Rm)
     /*  18303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64),
     /*  18306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  18308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  18316 */     GIR_RootConstrainSelectedInstOperands,
     /*  18317 */     // GIR_Coverage, 13655,
     /*  18317 */     GIR_EraseRootFromParent_Done,
     /*  18318 */   // Label 341: @18318
     /*  18318 */   GIM_Try, /*On fail goto*//*Label 342*/ GIMT_Encode4(18381), // Rule ID 1790 //
     /*  18323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  18338 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18342 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18347 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18351 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  18355 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18359 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18364 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18366 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  18369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  18371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18379 */     GIR_RootConstrainSelectedInstOperands,
     /*  18380 */     // GIR_Coverage, 1790,
     /*  18380 */     GIR_EraseRootFromParent_Done,
     /*  18381 */   // Label 342: @18381
     /*  18381 */   GIM_Try, /*On fail goto*//*Label 343*/ GIMT_Encode4(18444), // Rule ID 1789 //
     /*  18386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  18401 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18405 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18410 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18414 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18418 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18422 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18427 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18429 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  18432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  18434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18442 */     GIR_RootConstrainSelectedInstOperands,
     /*  18443 */     // GIR_Coverage, 1789,
     /*  18443 */     GIR_EraseRootFromParent_Done,
     /*  18444 */   // Label 343: @18444
     /*  18444 */   GIM_Try, /*On fail goto*//*Label 344*/ GIMT_Encode4(18507), // Rule ID 1709 //
     /*  18449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  18464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18468 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18473 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18477 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  18481 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18485 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18490 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18492 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv2i32_v2i64),
     /*  18495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  18497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18505 */     GIR_RootConstrainSelectedInstOperands,
     /*  18506 */     // GIR_Coverage, 1709,
     /*  18506 */     GIR_EraseRootFromParent_Done,
     /*  18507 */   // Label 344: @18507
     /*  18507 */   GIM_Try, /*On fail goto*//*Label 345*/ GIMT_Encode4(18570), // Rule ID 1788 //
     /*  18512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18527 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18531 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18536 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18540 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  18544 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18548 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18553 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18555 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  18558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  18560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18568 */     GIR_RootConstrainSelectedInstOperands,
     /*  18569 */     // GIR_Coverage, 1788,
     /*  18569 */     GIR_EraseRootFromParent_Done,
     /*  18570 */   // Label 345: @18570
     /*  18570 */   GIM_Try, /*On fail goto*//*Label 346*/ GIMT_Encode4(18633), // Rule ID 1787 //
     /*  18575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18590 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18594 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18599 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18603 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18607 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18611 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18616 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18618 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  18621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  18623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18631 */     GIR_RootConstrainSelectedInstOperands,
     /*  18632 */     // GIR_Coverage, 1787,
     /*  18632 */     GIR_EraseRootFromParent_Done,
     /*  18633 */   // Label 346: @18633
     /*  18633 */   GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(18694), // Rule ID 13120 //
     /*  18638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18657 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18661 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18666 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18677 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*  18680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  18692 */     GIR_RootConstrainSelectedInstOperands,
     /*  18693 */     // GIR_Coverage, 13120,
     /*  18693 */     GIR_EraseRootFromParent_Done,
     /*  18694 */   // Label 347: @18694
     /*  18694 */   GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(18755), // Rule ID 13150 //
     /*  18699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18714 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18718 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18722 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18727 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18738 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*  18741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18743 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  18753 */     GIR_RootConstrainSelectedInstOperands,
     /*  18754 */     // GIR_Coverage, 13150,
     /*  18754 */     GIR_EraseRootFromParent_Done,
     /*  18755 */   // Label 348: @18755
     /*  18755 */   GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(18803), // Rule ID 13143 //
     /*  18760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  18775 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18779 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18790 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  18793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  18795 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  18797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  18801 */     GIR_RootConstrainSelectedInstOperands,
     /*  18802 */     // GIR_Coverage, 13143,
     /*  18802 */     GIR_EraseRootFromParent_Done,
     /*  18803 */   // Label 349: @18803
     /*  18803 */   GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(18851), // Rule ID 13032 //
     /*  18808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  18823 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18827 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18836 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18838 */     // (add:{ *:[v2i64] } (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  18838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  18841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18849 */     GIR_RootConstrainSelectedInstOperands,
     /*  18850 */     // GIR_Coverage, 13032,
     /*  18850 */     GIR_EraseRootFromParent_Done,
     /*  18851 */   // Label 350: @18851
     /*  18851 */   GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(18899), // Rule ID 13114 //
     /*  18856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  18871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18875 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18884 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18886 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (SADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*  18889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  18891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  18893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  18897 */     GIR_RootConstrainSelectedInstOperands,
     /*  18898 */     // GIR_Coverage, 13114,
     /*  18898 */     GIR_EraseRootFromParent_Done,
     /*  18899 */   // Label 351: @18899
     /*  18899 */   GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(18947), // Rule ID 13044 //
     /*  18904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  18919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18923 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18932 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18934 */     // (add:{ *:[v2i64] } (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  18934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  18937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18939 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18945 */     GIR_RootConstrainSelectedInstOperands,
     /*  18946 */     // GIR_Coverage, 13044,
     /*  18946 */     GIR_EraseRootFromParent_Done,
     /*  18947 */   // Label 352: @18947
     /*  18947 */   GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(18995), // Rule ID 13142 //
     /*  18952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18971 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18980 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18982 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  18985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  18987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  18989 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  18993 */     GIR_RootConstrainSelectedInstOperands,
     /*  18994 */     // GIR_Coverage, 13142,
     /*  18994 */     GIR_EraseRootFromParent_Done,
     /*  18995 */   // Label 353: @18995
     /*  18995 */   GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(19056), // Rule ID 1721 //
     /*  19000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19007 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  19019 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19023 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  19027 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19032 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19037 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19039 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  19039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*  19042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19044 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  19054 */     GIR_RootConstrainSelectedInstOperands,
     /*  19055 */     // GIR_Coverage, 1721,
     /*  19055 */     GIR_EraseRootFromParent_Done,
     /*  19056 */   // Label 354: @19056
     /*  19056 */   GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(19117), // Rule ID 1811 //
     /*  19061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19068 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  19080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19084 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  19088 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19093 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19100 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  19100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*  19103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19105 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  19115 */     GIR_RootConstrainSelectedInstOperands,
     /*  19116 */     // GIR_Coverage, 1811,
     /*  19116 */     GIR_EraseRootFromParent_Done,
     /*  19117 */   // Label 355: @19117
     /*  19117 */   GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(19165), // Rule ID 1804 //
     /*  19122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  19141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19145 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19150 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19152 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  19152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  19155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19157 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  19159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  19163 */     GIR_RootConstrainSelectedInstOperands,
     /*  19164 */     // GIR_Coverage, 1804,
     /*  19164 */     GIR_EraseRootFromParent_Done,
     /*  19165 */   // Label 356: @19165
     /*  19165 */   GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(19213), // Rule ID 991 //
     /*  19170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19177 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  19189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19193 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19200 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  19200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  19203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19205 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19211 */     GIR_RootConstrainSelectedInstOperands,
     /*  19212 */     // GIR_Coverage, 991,
     /*  19212 */     GIR_EraseRootFromParent_Done,
     /*  19213 */   // Label 357: @19213
     /*  19213 */   GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(19261), // Rule ID 1715 //
     /*  19218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  19237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19248 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  19248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*  19251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19253 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  19255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  19259 */     GIR_RootConstrainSelectedInstOperands,
     /*  19260 */     // GIR_Coverage, 1715,
     /*  19260 */     GIR_EraseRootFromParent_Done,
     /*  19261 */   // Label 358: @19261
     /*  19261 */   GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(19309), // Rule ID 1052 //
     /*  19266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  19285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19289 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19294 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19296 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  19296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  19299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19301 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19307 */     GIR_RootConstrainSelectedInstOperands,
     /*  19308 */     // GIR_Coverage, 1052,
     /*  19308 */     GIR_EraseRootFromParent_Done,
     /*  19309 */   // Label 359: @19309
     /*  19309 */   GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(19357), // Rule ID 1803 //
     /*  19314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  19333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19337 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19344 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  19344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  19347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19349 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  19351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  19355 */     GIR_RootConstrainSelectedInstOperands,
     /*  19356 */     // GIR_Coverage, 1803,
     /*  19356 */     GIR_EraseRootFromParent_Done,
     /*  19357 */   // Label 360: @19357
     /*  19357 */   GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(19384), // Rule ID 1099 //
     /*  19362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19377 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  19377 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv2i64),
     /*  19382 */     GIR_RootConstrainSelectedInstOperands,
     /*  19383 */     // GIR_Coverage, 1099,
     /*  19383 */     GIR_Done,
     /*  19384 */   // Label 361: @19384
     /*  19384 */   GIM_Reject,
     /*  19385 */ // Label 284: @19385
     /*  19385 */ GIM_Reject,
     /*  19386 */ // Label 159: @19386
     /*  19386 */ GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(22883),
     /*  19391 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  19394 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  19397 */   GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(19533), // Rule ID 5305 //
     /*  19402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  19414 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  19418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19422 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  19426 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  19430 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19435 */     // MIs[1] Operand 2
     /*  19435 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  19446 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19450 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  19454 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  19458 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19462 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  19466 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  19470 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19475 */     // MIs[3] Operand 2
     /*  19475 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  19486 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19488 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  19488 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  19491 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  19495 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19500 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  19504 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  19508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  19510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  19513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19515 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  19522 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19527 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19532 */     // GIR_Coverage, 5305,
     /*  19532 */     GIR_EraseRootFromParent_Done,
     /*  19533 */   // Label 363: @19533
     /*  19533 */   GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(19669), // Rule ID 5304 //
     /*  19538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  19550 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  19554 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19558 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  19562 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  19566 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19571 */     // MIs[1] Operand 2
     /*  19571 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  19582 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19586 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  19590 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  19594 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19598 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  19602 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  19606 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19611 */     // MIs[3] Operand 2
     /*  19611 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  19622 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19624 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  19624 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  19627 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  19631 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19636 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  19640 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  19644 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  19646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  19649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19651 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  19658 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19663 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19668 */     // GIR_Coverage, 5304,
     /*  19668 */     GIR_EraseRootFromParent_Done,
     /*  19669 */   // Label 364: @19669
     /*  19669 */   GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(19805), // Rule ID 5320 //
     /*  19674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  19686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  19690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  19698 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  19702 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19707 */     // MIs[1] Operand 2
     /*  19707 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  19718 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19722 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  19726 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  19730 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19734 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  19738 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  19742 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19747 */     // MIs[3] Operand 2
     /*  19747 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  19758 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19760 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  19760 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  19763 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i8_v8i16),
     /*  19767 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19772 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  19776 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  19780 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  19782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  19785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19787 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  19794 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19799 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19804 */     // GIR_Coverage, 5320,
     /*  19804 */     GIR_EraseRootFromParent_Done,
     /*  19805 */   // Label 365: @19805
     /*  19805 */   GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(19941), // Rule ID 5303 //
     /*  19810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  19822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  19826 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19830 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  19834 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  19838 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19843 */     // MIs[1] Operand 2
     /*  19843 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  19854 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19858 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  19862 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  19866 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19870 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  19874 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  19878 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19883 */     // MIs[3] Operand 2
     /*  19883 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  19894 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19896 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  19896 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  19899 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  19903 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19908 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  19912 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  19916 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  19918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  19921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19923 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  19930 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19935 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19940 */     // GIR_Coverage, 5303,
     /*  19940 */     GIR_EraseRootFromParent_Done,
     /*  19941 */   // Label 366: @19941
     /*  19941 */   GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(20077), // Rule ID 5302 //
     /*  19946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  19958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  19962 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19966 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  19970 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  19974 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19979 */     // MIs[1] Operand 2
     /*  19979 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  19990 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19994 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  19998 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  20002 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  20006 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20010 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  20014 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20019 */     // MIs[3] Operand 2
     /*  20019 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  20030 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20032 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  20032 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  20035 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  20039 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20044 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  20048 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  20052 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  20054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20059 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  20066 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20071 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20076 */     // GIR_Coverage, 5302,
     /*  20076 */     GIR_EraseRootFromParent_Done,
     /*  20077 */   // Label 367: @20077
     /*  20077 */   GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(20210), // Rule ID 13660 //
     /*  20082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  20094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  20098 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  20102 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  20106 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  20110 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  20114 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20119 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  20123 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  20127 */     // MIs[1] Operand 2
     /*  20127 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  20138 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  20142 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  20146 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20150 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  20154 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  20158 */     // MIs[5] Rn
     /*  20158 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  20163 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  20165 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, (undef:{ *:[v8i16] })), 0:{ *:[i64] }), (trunc:{ *:[v4i16] } (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$Rn)))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (ADDPv8i16:{ *:[f128] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rn), dsub:{ *:[i32] })
     /*  20165 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  20168 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  20172 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20177 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  20181 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  20185 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  20187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20192 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  20199 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20204 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20209 */     // GIR_Coverage, 13660,
     /*  20209 */     GIR_EraseRootFromParent_Done,
     /*  20210 */   // Label 368: @20210
     /*  20210 */   GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(20343), // Rule ID 6841 //
     /*  20215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  20227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20231 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  20235 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  20239 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  20243 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20248 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  20252 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  20256 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  20260 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  20264 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_UZP2),
     /*  20268 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  20272 */     // MIs[4] Rn
     /*  20272 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  20277 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  20281 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  20285 */     // MIs[3] Operand 2
     /*  20285 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  20296 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  20298 */     // (add:{ *:[v4i16] } (trunc:{ *:[v4i16] } (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$Rn)), (extract_subvector:{ *:[v4i16] } (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, (undef:{ *:[v8i16] })), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (ADDPv8i16:{ *:[f128] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rn), dsub:{ *:[i32] })
     /*  20298 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  20301 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  20305 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20310 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  20314 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  20318 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  20320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20325 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  20332 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20337 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20342 */     // GIR_Coverage, 6841,
     /*  20342 */     GIR_EraseRootFromParent_Done,
     /*  20343 */   // Label 369: @20343
     /*  20343 */   GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(20506), // Rule ID 13612 //
     /*  20348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  20360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  20364 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  20368 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  20372 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  20376 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  20380 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20385 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20390 */     // MIs[1] Operand 2
     /*  20390 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  20401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20405 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20407 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  20407 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  20410 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  20414 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20419 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  20421 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  20424 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  20428 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20433 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  20436 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  20440 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  20443 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20448 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20453 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20458 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  20461 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  20465 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20470 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  20473 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  20477 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  20481 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  20483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20488 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  20495 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20500 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20505 */     // GIR_Coverage, 13612,
     /*  20505 */     GIR_EraseRootFromParent_Done,
     /*  20506 */   // Label 370: @20506
     /*  20506 */   GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(20669), // Rule ID 13609 //
     /*  20511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  20523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  20527 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  20531 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  20535 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  20539 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  20543 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20548 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20553 */     // MIs[1] Operand 2
     /*  20553 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  20564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20568 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20570 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  20570 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  20573 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  20577 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  20584 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  20587 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  20591 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20596 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  20599 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  20603 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  20606 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20611 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20616 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20621 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  20624 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  20628 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20633 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  20636 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  20640 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  20644 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  20646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20651 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  20658 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20663 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20668 */     // GIR_Coverage, 13609,
     /*  20668 */     GIR_EraseRootFromParent_Done,
     /*  20669 */   // Label 371: @20669
     /*  20669 */   GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(20819), // Rule ID 13616 //
     /*  20674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  20686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  20690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  20694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20698 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  20702 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20707 */     // MIs[1] Operand 2
     /*  20707 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  20718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20722 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20724 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  20724 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  20727 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  20731 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20736 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  20738 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  20741 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  20745 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20750 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  20753 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  20757 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  20760 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20765 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20770 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20775 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  20778 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  20782 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20787 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  20790 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20794 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  20796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20801 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  20808 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20813 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20818 */     // GIR_Coverage, 13616,
     /*  20818 */     GIR_EraseRootFromParent_Done,
     /*  20819 */   // Label 372: @20819
     /*  20819 */   GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(20969), // Rule ID 13621 //
     /*  20824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  20836 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  20840 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  20844 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  20848 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  20852 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20857 */     // MIs[1] Operand 2
     /*  20857 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  20868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20872 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20874 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  20874 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  20877 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  20881 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20886 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  20888 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  20891 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  20895 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20900 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  20903 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  20907 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  20910 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20915 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20920 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20925 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  20928 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  20932 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20937 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  20940 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20944 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  20946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20951 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  20958 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20963 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20968 */     // GIR_Coverage, 13621,
     /*  20968 */     GIR_EraseRootFromParent_Done,
     /*  20969 */   // Label 373: @20969
     /*  20969 */   GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(21119), // Rule ID 13615 //
     /*  20974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  20986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  20990 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  20994 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20998 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21002 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21007 */     // MIs[1] Operand 2
     /*  21007 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21022 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21024 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21024 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  21027 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  21031 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21036 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  21038 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  21041 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  21045 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21050 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  21053 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  21057 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  21060 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21065 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21070 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21075 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21078 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  21082 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21087 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  21090 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  21094 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21101 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21108 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21113 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21118 */     // GIR_Coverage, 13615,
     /*  21118 */     GIR_EraseRootFromParent_Done,
     /*  21119 */   // Label 374: @21119
     /*  21119 */   GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(21282), // Rule ID 5293 //
     /*  21124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21128 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21144 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21148 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  21152 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21156 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  21160 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21165 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21170 */     // MIs[1] Operand 2
     /*  21170 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21181 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21183 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21183 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  21186 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  21190 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21195 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  21197 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  21200 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  21204 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21209 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  21212 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  21216 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  21219 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21224 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21229 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21234 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21237 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  21241 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21246 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  21249 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21253 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  21257 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21264 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21271 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21276 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21281 */     // GIR_Coverage, 5293,
     /*  21281 */     GIR_EraseRootFromParent_Done,
     /*  21282 */   // Label 375: @21282
     /*  21282 */   GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(21445), // Rule ID 5290 //
     /*  21287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21291 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21307 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21311 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  21315 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21319 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  21323 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21328 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21333 */     // MIs[1] Operand 2
     /*  21333 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21344 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21346 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21346 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  21349 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  21353 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21358 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  21360 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  21363 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  21367 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21372 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  21375 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  21379 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  21382 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21387 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21392 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21397 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21400 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  21404 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21409 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  21412 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21416 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  21420 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21427 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21434 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21439 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21444 */     // GIR_Coverage, 5290,
     /*  21444 */     GIR_EraseRootFromParent_Done,
     /*  21445 */   // Label 376: @21445
     /*  21445 */   GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(21595), // Rule ID 5315 //
     /*  21450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21470 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21474 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21478 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21482 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21487 */     // MIs[1] Operand 2
     /*  21487 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21498 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21500 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21500 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  21503 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  21507 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21512 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  21514 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  21517 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  21521 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21526 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  21529 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  21533 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  21536 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21541 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21546 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21551 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21554 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  21558 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21563 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  21566 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  21570 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21577 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21584 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21589 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21594 */     // GIR_Coverage, 5315,
     /*  21594 */     GIR_EraseRootFromParent_Done,
     /*  21595 */   // Label 377: @21595
     /*  21595 */   GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(21745), // Rule ID 5323 //
     /*  21600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  21628 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21632 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21637 */     // MIs[1] Operand 2
     /*  21637 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21648 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21650 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21650 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  21653 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  21657 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21662 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  21664 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  21667 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  21671 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21676 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  21679 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  21683 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  21686 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21691 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21696 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21701 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21704 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  21708 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21713 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  21716 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  21720 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21727 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21734 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21739 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21744 */     // GIR_Coverage, 5323,
     /*  21744 */     GIR_EraseRootFromParent_Done,
     /*  21745 */   // Label 378: @21745
     /*  21745 */   GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(21895), // Rule ID 5314 //
     /*  21750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21774 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21778 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21782 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21787 */     // MIs[1] Operand 2
     /*  21787 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21798 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21800 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21800 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  21803 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  21807 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21812 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  21814 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  21817 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  21821 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21826 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  21829 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  21833 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  21836 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21841 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21846 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21851 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21854 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  21858 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21863 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  21866 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  21870 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21877 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21884 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21889 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21894 */     // GIR_Coverage, 5314,
     /*  21894 */     GIR_EraseRootFromParent_Done,
     /*  21895 */   // Label 379: @21895
     /*  21895 */   GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(21964), // Rule ID 13061 //
     /*  21900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  21915 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  21918 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  21923 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  21927 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  21931 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21947 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V64:{ *:[v4i16] }:$Rd)  =>  (SABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  21947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i16),
     /*  21950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  21954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  21958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  21962 */     GIR_RootConstrainSelectedInstOperands,
     /*  21963 */     // GIR_Coverage, 13061,
     /*  21963 */     GIR_EraseRootFromParent_Done,
     /*  21964 */   // Label 380: @21964
     /*  21964 */   GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(22033), // Rule ID 13073 //
     /*  21969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  21984 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  21987 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  21992 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  21996 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  22000 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22005 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22016 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V64:{ *:[v4i16] }:$Rd)  =>  (UABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  22016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i16),
     /*  22019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  22023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  22027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  22031 */     GIR_RootConstrainSelectedInstOperands,
     /*  22032 */     // GIR_Coverage, 13073,
     /*  22032 */     GIR_EraseRootFromParent_Done,
     /*  22033 */   // Label 381: @22033
     /*  22033 */   GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(22089), // Rule ID 13023 //
     /*  22038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  22041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  22053 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  22056 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  22061 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  22065 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22074 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22076 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 660:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  22076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  22079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  22083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  22087 */     GIR_RootConstrainSelectedInstOperands,
     /*  22088 */     // GIR_Coverage, 13023,
     /*  22088 */     GIR_EraseRootFromParent_Done,
     /*  22089 */   // Label 382: @22089
     /*  22089 */   GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(22145), // Rule ID 13035 //
     /*  22094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  22097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  22109 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  22112 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  22117 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  22121 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22132 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  22132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  22135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  22139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  22143 */     GIR_RootConstrainSelectedInstOperands,
     /*  22144 */     // GIR_Coverage, 13035,
     /*  22144 */     GIR_EraseRootFromParent_Done,
     /*  22145 */   // Label 383: @22145
     /*  22145 */   GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(22212), // Rule ID 13265 //
     /*  22150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  22153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  22165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  22169 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22174 */     // MIs[1] imm
     /*  22174 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22178 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22182 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  22186 */     // MIs[2] Operand 1
     /*  22186 */     // No operand predicates
     /*  22186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22190 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  22194 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22196 */     // (add:{ *:[v4i16] } (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  22196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  22199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  22203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  22207 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  22210 */     GIR_RootConstrainSelectedInstOperands,
     /*  22211 */     // GIR_Coverage, 13265,
     /*  22211 */     GIR_EraseRootFromParent_Done,
     /*  22212 */   // Label 384: @22212
     /*  22212 */   GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(22279), // Rule ID 13286 //
     /*  22217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  22220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  22232 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  22236 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22241 */     // MIs[1] imm
     /*  22241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22249 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  22253 */     // MIs[2] Operand 1
     /*  22253 */     // No operand predicates
     /*  22253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22257 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  22261 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22263 */     // (add:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  22263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  22266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  22270 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  22274 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  22277 */     GIR_RootConstrainSelectedInstOperands,
     /*  22278 */     // GIR_Coverage, 13286,
     /*  22278 */     GIR_EraseRootFromParent_Done,
     /*  22279 */   // Label 385: @22279
     /*  22279 */   GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(22348), // Rule ID 1354 //
     /*  22284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  22287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22291 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  22303 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  22306 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  22311 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  22315 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  22319 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22324 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22331 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  22331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i16),
     /*  22334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22336 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  22338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  22342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  22346 */     GIR_RootConstrainSelectedInstOperands,
     /*  22347 */     // GIR_Coverage, 1354,
     /*  22347 */     GIR_EraseRootFromParent_Done,
     /*  22348 */   // Label 386: @22348
     /*  22348 */   GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(22417), // Rule ID 1477 //
     /*  22353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  22356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  22372 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  22375 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  22380 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  22384 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  22388 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22393 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22398 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22400 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  22400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i16),
     /*  22403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22405 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  22407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  22411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  22415 */     GIR_RootConstrainSelectedInstOperands,
     /*  22416 */     // GIR_Coverage, 1477,
     /*  22416 */     GIR_EraseRootFromParent_Done,
     /*  22417 */   // Label 387: @22417
     /*  22417 */   GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(22473), // Rule ID 982 //
     /*  22422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  22425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  22441 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  22444 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  22449 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  22453 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22458 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22460 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 660:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  22460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  22463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22465 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  22467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  22471 */     GIR_RootConstrainSelectedInstOperands,
     /*  22472 */     // GIR_Coverage, 982,
     /*  22472 */     GIR_EraseRootFromParent_Done,
     /*  22473 */   // Label 388: @22473
     /*  22473 */   GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(22529), // Rule ID 1043 //
     /*  22478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  22481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22485 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  22497 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  22500 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  22505 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  22509 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22514 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22516 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  22516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  22519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22521 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  22523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  22527 */     GIR_RootConstrainSelectedInstOperands,
     /*  22528 */     // GIR_Coverage, 1043,
     /*  22528 */     GIR_EraseRootFromParent_Done,
     /*  22529 */   // Label 389: @22529
     /*  22529 */   GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(22596), // Rule ID 2225 //
     /*  22534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  22537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  22553 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  22557 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22562 */     // MIs[1] imm
     /*  22562 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22566 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22570 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  22574 */     // MIs[2] Operand 1
     /*  22574 */     // No operand predicates
     /*  22574 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  22578 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22580 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  22580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  22583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22585 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  22587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  22591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  22594 */     GIR_RootConstrainSelectedInstOperands,
     /*  22595 */     // GIR_Coverage, 2225,
     /*  22595 */     GIR_EraseRootFromParent_Done,
     /*  22596 */   // Label 390: @22596
     /*  22596 */   GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(22663), // Rule ID 2284 //
     /*  22601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  22604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22608 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  22620 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  22624 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22629 */     // MIs[1] imm
     /*  22629 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22633 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22637 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  22641 */     // MIs[2] Operand 1
     /*  22641 */     // No operand predicates
     /*  22641 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  22645 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22647 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  22647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  22650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22652 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  22654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  22658 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  22661 */     GIR_RootConstrainSelectedInstOperands,
     /*  22662 */     // GIR_Coverage, 2284,
     /*  22662 */     GIR_EraseRootFromParent_Done,
     /*  22663 */   // Label 391: @22663
     /*  22663 */   GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(22711), // Rule ID 13022 //
     /*  22668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  22671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  22683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22698 */     // (add:{ *:[v4i16] } (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  22698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  22701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  22705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  22709 */     GIR_RootConstrainSelectedInstOperands,
     /*  22710 */     // GIR_Coverage, 13022,
     /*  22710 */     GIR_EraseRootFromParent_Done,
     /*  22711 */   // Label 392: @22711
     /*  22711 */   GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(22759), // Rule ID 13034 //
     /*  22716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  22719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  22731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22735 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22744 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22746 */     // (add:{ *:[v4i16] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  22746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  22749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  22753 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  22757 */     GIR_RootConstrainSelectedInstOperands,
     /*  22758 */     // GIR_Coverage, 13034,
     /*  22758 */     GIR_EraseRootFromParent_Done,
     /*  22759 */   // Label 393: @22759
     /*  22759 */   GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(22807), // Rule ID 981 //
     /*  22764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  22767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  22783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22787 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22794 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  22794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  22797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22799 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  22801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  22805 */     GIR_RootConstrainSelectedInstOperands,
     /*  22806 */     // GIR_Coverage, 981,
     /*  22806 */     GIR_EraseRootFromParent_Done,
     /*  22807 */   // Label 394: @22807
     /*  22807 */   GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(22855), // Rule ID 1042 //
     /*  22812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  22815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  22831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22835 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22840 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22842 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  22842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  22845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22847 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  22849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  22853 */     GIR_RootConstrainSelectedInstOperands,
     /*  22854 */     // GIR_Coverage, 1042,
     /*  22854 */     GIR_EraseRootFromParent_Done,
     /*  22855 */   // Label 395: @22855
     /*  22855 */   GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(22882), // Rule ID 1095 //
     /*  22860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  22863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22867 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22875 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  22875 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i16),
     /*  22880 */     GIR_RootConstrainSelectedInstOperands,
     /*  22881 */     // GIR_Coverage, 1095,
     /*  22881 */     GIR_Done,
     /*  22882 */   // Label 396: @22882
     /*  22882 */   GIM_Reject,
     /*  22883 */ // Label 362: @22883
     /*  22883 */ GIM_Reject,
     /*  22884 */ // Label 160: @22884
     /*  22884 */ GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(29061),
     /*  22889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22892 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22895 */   GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(23013), // Rule ID 13195 //
     /*  22900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  22903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  22915 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  22919 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  22923 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22927 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22931 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22935 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  22939 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  22943 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22947 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  22951 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  22956 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  22960 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22964 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  22968 */     // MIs[4] Operand 1
     /*  22968 */     // No operand predicates
     /*  22968 */     // MIs[2] Operand 2
     /*  22968 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  22979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22983 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  22985 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  22992 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  22992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  22995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  22999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  23004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  23008 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  23011 */     GIR_RootConstrainSelectedInstOperands,
     /*  23012 */     // GIR_Coverage, 13195,
     /*  23012 */     GIR_EraseRootFromParent_Done,
     /*  23013 */   // Label 398: @23013
     /*  23013 */   GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(23131), // Rule ID 13196 //
     /*  23018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  23033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23049 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23053 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  23057 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  23061 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23065 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  23069 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  23074 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  23078 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23082 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  23086 */     // MIs[4] Operand 1
     /*  23086 */     // No operand predicates
     /*  23086 */     // MIs[2] Operand 2
     /*  23086 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  23097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23101 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  23103 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  23110 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  23110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  23113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23115 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  23122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  23126 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  23129 */     GIR_RootConstrainSelectedInstOperands,
     /*  23130 */     // GIR_Coverage, 13196,
     /*  23130 */     GIR_EraseRootFromParent_Done,
     /*  23131 */   // Label 399: @23131
     /*  23131 */   GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(23249), // Rule ID 13225 //
     /*  23136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  23151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23155 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23159 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23163 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23167 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23171 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  23175 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  23179 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23183 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  23187 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  23192 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  23196 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23200 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  23204 */     // MIs[4] Operand 1
     /*  23204 */     // No operand predicates
     /*  23204 */     // MIs[2] Operand 2
     /*  23204 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  23215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23219 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  23221 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  23228 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  23228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  23231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  23240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  23244 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  23247 */     GIR_RootConstrainSelectedInstOperands,
     /*  23248 */     // GIR_Coverage, 13225,
     /*  23248 */     GIR_EraseRootFromParent_Done,
     /*  23249 */   // Label 400: @23249
     /*  23249 */   GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(23367), // Rule ID 13226 //
     /*  23254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  23269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23273 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23277 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23281 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23285 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23289 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  23293 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  23297 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23301 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  23305 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  23310 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  23314 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23318 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  23322 */     // MIs[4] Operand 1
     /*  23322 */     // No operand predicates
     /*  23322 */     // MIs[2] Operand 2
     /*  23322 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  23333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23337 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  23339 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  23346 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  23346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  23349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  23358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  23362 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  23365 */     GIR_RootConstrainSelectedInstOperands,
     /*  23366 */     // GIR_Coverage, 13226,
     /*  23366 */     GIR_EraseRootFromParent_Done,
     /*  23367 */   // Label 401: @23367
     /*  23367 */   GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(23485), // Rule ID 2032 //
     /*  23372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23379 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  23391 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23395 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23399 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23403 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23407 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23411 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  23415 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  23419 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23423 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  23427 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  23432 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  23436 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23440 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  23444 */     // MIs[4] Operand 1
     /*  23444 */     // No operand predicates
     /*  23444 */     // MIs[2] Operand 2
     /*  23444 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  23455 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  23457 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  23464 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  23464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  23467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23469 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  23471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  23476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  23480 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  23483 */     GIR_RootConstrainSelectedInstOperands,
     /*  23484 */     // GIR_Coverage, 2032,
     /*  23484 */     GIR_EraseRootFromParent_Done,
     /*  23485 */   // Label 402: @23485
     /*  23485 */   GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(23603), // Rule ID 13194 //
     /*  23490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23497 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  23509 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23513 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23525 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23529 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  23533 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  23537 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23541 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  23545 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  23550 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  23554 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23558 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  23562 */     // MIs[4] Operand 1
     /*  23562 */     // No operand predicates
     /*  23562 */     // MIs[2] Operand 2
     /*  23562 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  23573 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  23575 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  23582 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  23582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  23585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23587 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  23589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  23594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  23598 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  23601 */     GIR_RootConstrainSelectedInstOperands,
     /*  23602 */     // GIR_Coverage, 13194,
     /*  23602 */     GIR_EraseRootFromParent_Done,
     /*  23603 */   // Label 403: @23603
     /*  23603 */   GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(23721), // Rule ID 2084 //
     /*  23608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  23627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23631 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23635 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23639 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23643 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23647 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  23651 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  23655 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23659 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  23663 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  23668 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  23672 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23676 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  23680 */     // MIs[4] Operand 1
     /*  23680 */     // No operand predicates
     /*  23680 */     // MIs[2] Operand 2
     /*  23680 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  23691 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  23693 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  23700 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  23700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  23703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23705 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  23707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  23712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  23716 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  23719 */     GIR_RootConstrainSelectedInstOperands,
     /*  23720 */     // GIR_Coverage, 2084,
     /*  23720 */     GIR_EraseRootFromParent_Done,
     /*  23721 */   // Label 404: @23721
     /*  23721 */   GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(23839), // Rule ID 13224 //
     /*  23726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23733 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  23745 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23749 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23753 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23757 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23761 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23765 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  23769 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  23773 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23777 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  23781 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  23786 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  23790 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23794 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  23798 */     // MIs[4] Operand 1
     /*  23798 */     // No operand predicates
     /*  23798 */     // MIs[2] Operand 2
     /*  23798 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  23809 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  23811 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  23818 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  23818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  23821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23823 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  23825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  23830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  23834 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  23837 */     GIR_RootConstrainSelectedInstOperands,
     /*  23838 */     // GIR_Coverage, 13224,
     /*  23838 */     GIR_EraseRootFromParent_Done,
     /*  23839 */   // Label 405: @23839
     /*  23839 */   GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(23926), // Rule ID 13105 //
     /*  23844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  23859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23863 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23867 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23871 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  23874 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  23879 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23883 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  23887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23891 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23893 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  23900 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  23907 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))), V128:{ *:[v4i32] }:$Rd)  =>  (SABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  23907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i16_v4i32),
     /*  23910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  23919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  23924 */     GIR_RootConstrainSelectedInstOperands,
     /*  23925 */     // GIR_Coverage, 13105,
     /*  23925 */     GIR_EraseRootFromParent_Done,
     /*  23926 */   // Label 406: @23926
     /*  23926 */   GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(24013), // Rule ID 13129 //
     /*  23931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  23946 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23950 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23954 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23958 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  23961 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  23966 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23970 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  23974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23978 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23980 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  23987 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  23994 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))), V128:{ *:[v4i32] }:$Rd)  =>  (UABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  23994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i16_v4i32),
     /*  23997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23999 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  24006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  24011 */     GIR_RootConstrainSelectedInstOperands,
     /*  24012 */     // GIR_Coverage, 13129,
     /*  24012 */     GIR_EraseRootFromParent_Done,
     /*  24013 */   // Label 407: @24013
     /*  24013 */   GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(24100), // Rule ID 1688 //
     /*  24018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  24037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  24045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24049 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  24052 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  24057 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24061 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  24065 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24067 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24074 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24081 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))))  =>  (SABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  24081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i16_v4i32),
     /*  24084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24086 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  24093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  24098 */     GIR_RootConstrainSelectedInstOperands,
     /*  24099 */     // GIR_Coverage, 1688,
     /*  24099 */     GIR_EraseRootFromParent_Done,
     /*  24100 */   // Label 408: @24100
     /*  24100 */   GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(24187), // Rule ID 1766 //
     /*  24105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24112 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  24124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24128 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  24132 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24136 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  24139 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  24144 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24148 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  24152 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24154 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24161 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24168 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))))  =>  (UABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  24168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i16_v4i32),
     /*  24171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24173 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  24180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  24185 */     GIR_RootConstrainSelectedInstOperands,
     /*  24186 */     // GIR_Coverage, 1766,
     /*  24186 */     GIR_EraseRootFromParent_Done,
     /*  24187 */   // Label 409: @24187
     /*  24187 */   GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(24302), // Rule ID 13190 //
     /*  24192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  24207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24211 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  24219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  24223 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24227 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  24231 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  24235 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24239 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  24243 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  24248 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  24252 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24256 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  24260 */     // MIs[4] Operand 1
     /*  24260 */     // No operand predicates
     /*  24260 */     // MIs[2] Operand 2
     /*  24260 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  24271 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24280 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  24282 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  24282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  24285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  24297 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  24300 */     GIR_RootConstrainSelectedInstOperands,
     /*  24301 */     // GIR_Coverage, 13190,
     /*  24301 */     GIR_EraseRootFromParent_Done,
     /*  24302 */   // Label 410: @24302
     /*  24302 */   GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(24417), // Rule ID 13189 //
     /*  24307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  24322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24326 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24330 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24335 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24339 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  24343 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24347 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  24351 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  24355 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24359 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  24363 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  24368 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  24372 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24376 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  24380 */     // MIs[4] Operand 1
     /*  24380 */     // No operand predicates
     /*  24380 */     // MIs[2] Operand 2
     /*  24380 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  24391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24395 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  24397 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  24397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  24400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  24412 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  24415 */     GIR_RootConstrainSelectedInstOperands,
     /*  24416 */     // GIR_Coverage, 13189,
     /*  24416 */     GIR_EraseRootFromParent_Done,
     /*  24417 */   // Label 411: @24417
     /*  24417 */   GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(24532), // Rule ID 13220 //
     /*  24422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  24437 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24441 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24445 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  24449 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  24453 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24457 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  24461 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  24465 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24469 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  24473 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  24478 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  24482 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24486 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  24490 */     // MIs[4] Operand 1
     /*  24490 */     // No operand predicates
     /*  24490 */     // MIs[2] Operand 2
     /*  24490 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  24501 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24510 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  24512 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  24512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  24515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  24527 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  24530 */     GIR_RootConstrainSelectedInstOperands,
     /*  24531 */     // GIR_Coverage, 13220,
     /*  24531 */     GIR_EraseRootFromParent_Done,
     /*  24532 */   // Label 412: @24532
     /*  24532 */   GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(24647), // Rule ID 13219 //
     /*  24537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  24552 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24556 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24560 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24565 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24569 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  24573 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24577 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  24581 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  24585 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24589 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  24593 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  24598 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  24602 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24606 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  24610 */     // MIs[4] Operand 1
     /*  24610 */     // No operand predicates
     /*  24610 */     // MIs[2] Operand 2
     /*  24610 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  24621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24625 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  24627 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  24627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  24630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  24642 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  24645 */     GIR_RootConstrainSelectedInstOperands,
     /*  24646 */     // GIR_Coverage, 13219,
     /*  24646 */     GIR_EraseRootFromParent_Done,
     /*  24647 */   // Label 413: @24647
     /*  24647 */   GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(24716), // Rule ID 1786 //
     /*  24652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  24667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24671 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  24675 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  24679 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24683 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24685 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24692 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24699 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  24699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  24702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  24709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  24714 */     GIR_RootConstrainSelectedInstOperands,
     /*  24715 */     // GIR_Coverage, 1786,
     /*  24715 */     GIR_EraseRootFromParent_Done,
     /*  24716 */   // Label 414: @24716
     /*  24716 */   GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(24785), // Rule ID 1785 //
     /*  24721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  24736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24740 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  24744 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  24748 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24752 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24754 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24761 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24768 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  24768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  24771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  24778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  24783 */     GIR_RootConstrainSelectedInstOperands,
     /*  24784 */     // GIR_Coverage, 1785,
     /*  24784 */     GIR_EraseRootFromParent_Done,
     /*  24785 */   // Label 415: @24785
     /*  24785 */   GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(24854), // Rule ID 1708 //
     /*  24790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  24805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24809 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  24813 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  24817 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24821 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24823 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24830 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24837 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  24837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i16_v4i32),
     /*  24840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  24847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  24852 */     GIR_RootConstrainSelectedInstOperands,
     /*  24853 */     // GIR_Coverage, 1708,
     /*  24853 */     GIR_EraseRootFromParent_Done,
     /*  24854 */   // Label 416: @24854
     /*  24854 */   GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(24923), // Rule ID 1784 //
     /*  24859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  24874 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24878 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  24882 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  24886 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24890 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24892 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24899 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24906 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  24906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  24909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  24916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  24921 */     GIR_RootConstrainSelectedInstOperands,
     /*  24922 */     // GIR_Coverage, 1784,
     /*  24922 */     GIR_EraseRootFromParent_Done,
     /*  24923 */   // Label 417: @24923
     /*  24923 */   GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(24992), // Rule ID 1783 //
     /*  24928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  24943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24947 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  24951 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  24955 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24959 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24961 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24968 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24975 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  24975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  24978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  24985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  24990 */     GIR_RootConstrainSelectedInstOperands,
     /*  24991 */     // GIR_Coverage, 1783,
     /*  24991 */     GIR_EraseRootFromParent_Done,
     /*  24992 */   // Label 418: @24992
     /*  24992 */   GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(25107), // Rule ID 13188 //
     /*  24997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25004 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25016 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25020 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25024 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25028 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25032 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25036 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25040 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25044 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25048 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25052 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25057 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25061 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25065 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25069 */     // MIs[4] Operand 1
     /*  25069 */     // No operand predicates
     /*  25069 */     // MIs[2] Operand 2
     /*  25069 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  25080 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25085 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25087 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  25090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25092 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  25098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25102 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25105 */     GIR_RootConstrainSelectedInstOperands,
     /*  25106 */     // GIR_Coverage, 13188,
     /*  25106 */     GIR_EraseRootFromParent_Done,
     /*  25107 */   // Label 419: @25107
     /*  25107 */   GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(25222), // Rule ID 2030 //
     /*  25112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25119 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25131 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25135 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25139 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25144 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25148 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25152 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25156 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25160 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25164 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25168 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25172 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25177 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25181 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25185 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25189 */     // MIs[4] Operand 1
     /*  25189 */     // No operand predicates
     /*  25189 */     // MIs[2] Operand 2
     /*  25189 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  25200 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25202 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  25205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25207 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  25213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25217 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25220 */     GIR_RootConstrainSelectedInstOperands,
     /*  25221 */     // GIR_Coverage, 2030,
     /*  25221 */     GIR_EraseRootFromParent_Done,
     /*  25222 */   // Label 420: @25222
     /*  25222 */   GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(25337), // Rule ID 13218 //
     /*  25227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25234 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  25246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25250 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25254 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25258 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25262 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25266 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25270 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25274 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25278 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25282 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25287 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25291 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25295 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25299 */     // MIs[4] Operand 1
     /*  25299 */     // No operand predicates
     /*  25299 */     // MIs[2] Operand 2
     /*  25299 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  25310 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25315 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25317 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  25320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25322 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  25328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25332 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25335 */     GIR_RootConstrainSelectedInstOperands,
     /*  25336 */     // GIR_Coverage, 13218,
     /*  25336 */     GIR_EraseRootFromParent_Done,
     /*  25337 */   // Label 421: @25337
     /*  25337 */   GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(25452), // Rule ID 2082 //
     /*  25342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25349 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  25361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25365 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25369 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25382 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25386 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25390 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25394 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25398 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25402 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25407 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25411 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25415 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25419 */     // MIs[4] Operand 1
     /*  25419 */     // No operand predicates
     /*  25419 */     // MIs[2] Operand 2
     /*  25419 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  25430 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25432 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  25435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25437 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  25443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25447 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25450 */     GIR_RootConstrainSelectedInstOperands,
     /*  25451 */     // GIR_Coverage, 2082,
     /*  25451 */     GIR_EraseRootFromParent_Done,
     /*  25452 */   // Label 422: @25452
     /*  25452 */   GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(25519), // Rule ID 13119 //
     /*  25457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25476 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25484 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25486 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25493 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25500 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  25500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_v4i32),
     /*  25503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  25517 */     GIR_RootConstrainSelectedInstOperands,
     /*  25518 */     // GIR_Coverage, 13119,
     /*  25518 */     GIR_EraseRootFromParent_Done,
     /*  25519 */   // Label 423: @25519
     /*  25519 */   GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(25586), // Rule ID 13149 //
     /*  25524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  25539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25543 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25553 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25560 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25567 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  25567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_v4i32),
     /*  25570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  25584 */     GIR_RootConstrainSelectedInstOperands,
     /*  25585 */     // GIR_Coverage, 13149,
     /*  25585 */     GIR_EraseRootFromParent_Done,
     /*  25586 */   // Label 424: @25586
     /*  25586 */   GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(25653), // Rule ID 1720 //
     /*  25591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25614 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25618 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25620 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25627 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25634 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  25634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_v4i32),
     /*  25637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25639 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  25651 */     GIR_RootConstrainSelectedInstOperands,
     /*  25652 */     // GIR_Coverage, 1720,
     /*  25652 */     GIR_EraseRootFromParent_Done,
     /*  25653 */   // Label 425: @25653
     /*  25653 */   GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(25720), // Rule ID 1810 //
     /*  25658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  25677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25681 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25687 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25694 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25701 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  25701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_v4i32),
     /*  25704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25706 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  25718 */     GIR_RootConstrainSelectedInstOperands,
     /*  25719 */     // GIR_Coverage, 1810,
     /*  25719 */     GIR_EraseRootFromParent_Done,
     /*  25720 */   // Label 426: @25720
     /*  25720 */   GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(25801), // Rule ID 13103 //
     /*  25725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  25740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25744 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25748 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25752 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  25755 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  25760 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25764 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  25768 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25773 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25782 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  25784 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (SABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  25784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i16_v4i32),
     /*  25787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  25795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  25799 */     GIR_RootConstrainSelectedInstOperands,
     /*  25800 */     // GIR_Coverage, 13103,
     /*  25800 */     GIR_EraseRootFromParent_Done,
     /*  25801 */   // Label 427: @25801
     /*  25801 */   GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(25882), // Rule ID 13127 //
     /*  25806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  25821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25829 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25833 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  25836 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  25841 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25845 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  25849 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25854 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25863 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  25865 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (UABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  25865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i16_v4i32),
     /*  25868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  25876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  25880 */     GIR_RootConstrainSelectedInstOperands,
     /*  25881 */     // GIR_Coverage, 13127,
     /*  25881 */     GIR_EraseRootFromParent_Done,
     /*  25882 */   // Label 428: @25882
     /*  25882 */   GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(25963), // Rule ID 1686 //
     /*  25887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  25906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25910 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25914 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25918 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  25921 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  25926 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25930 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  25934 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25939 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25944 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  25946 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)))  =>  (SABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  25946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i16_v4i32),
     /*  25949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25951 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  25957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  25961 */     GIR_RootConstrainSelectedInstOperands,
     /*  25962 */     // GIR_Coverage, 1686,
     /*  25962 */     GIR_EraseRootFromParent_Done,
     /*  25963 */   // Label 429: @25963
     /*  25963 */   GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(26044), // Rule ID 1764 //
     /*  25968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  25987 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25991 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25995 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25999 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  26002 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  26007 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26011 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  26015 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26020 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26025 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26027 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)))  =>  (UABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  26027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i16_v4i32),
     /*  26030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26032 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  26034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  26038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  26042 */     GIR_RootConstrainSelectedInstOperands,
     /*  26043 */     // GIR_Coverage, 1764,
     /*  26043 */     GIR_EraseRootFromParent_Done,
     /*  26044 */   // Label 430: @26044
     /*  26044 */   GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(26136), // Rule ID 13193 //
     /*  26049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  26064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26068 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26072 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26076 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26080 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26084 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  26088 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26093 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  26097 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26101 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26105 */     // MIs[3] Operand 1
     /*  26105 */     // No operand predicates
     /*  26105 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26114 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  26116 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  26127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  26131 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  26134 */     GIR_RootConstrainSelectedInstOperands,
     /*  26135 */     // GIR_Coverage, 13193,
     /*  26135 */     GIR_EraseRootFromParent_Done,
     /*  26136 */   // Label 431: @26136
     /*  26136 */   GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(26228), // Rule ID 13192 //
     /*  26141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  26156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26160 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26164 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26169 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26173 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26177 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26181 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  26185 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26190 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  26194 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26198 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26202 */     // MIs[3] Operand 1
     /*  26202 */     // No operand predicates
     /*  26202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26206 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  26208 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  26219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  26223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  26226 */     GIR_RootConstrainSelectedInstOperands,
     /*  26227 */     // GIR_Coverage, 13192,
     /*  26227 */     GIR_EraseRootFromParent_Done,
     /*  26228 */   // Label 432: @26228
     /*  26228 */   GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(26320), // Rule ID 13223 //
     /*  26233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  26248 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26252 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26256 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26260 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26264 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26268 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  26272 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26277 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  26281 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26285 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26289 */     // MIs[3] Operand 1
     /*  26289 */     // No operand predicates
     /*  26289 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26298 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  26300 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  26303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26307 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  26311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  26315 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  26318 */     GIR_RootConstrainSelectedInstOperands,
     /*  26319 */     // GIR_Coverage, 13223,
     /*  26319 */     GIR_EraseRootFromParent_Done,
     /*  26320 */   // Label 433: @26320
     /*  26320 */   GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(26412), // Rule ID 13222 //
     /*  26325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  26340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26344 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26348 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26353 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26357 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26361 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26365 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  26369 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26374 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  26378 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26382 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26386 */     // MIs[3] Operand 1
     /*  26386 */     // No operand predicates
     /*  26386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26390 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  26392 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  26395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  26403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  26407 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  26410 */     GIR_RootConstrainSelectedInstOperands,
     /*  26411 */     // GIR_Coverage, 13222,
     /*  26411 */     GIR_EraseRootFromParent_Done,
     /*  26412 */   // Label 434: @26412
     /*  26412 */   GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(26504), // Rule ID 13191 //
     /*  26417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  26436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26440 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26444 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26448 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26452 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26456 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  26460 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26465 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  26469 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26473 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26477 */     // MIs[3] Operand 1
     /*  26477 */     // No operand predicates
     /*  26477 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26482 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  26484 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26489 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  26491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  26495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  26499 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  26502 */     GIR_RootConstrainSelectedInstOperands,
     /*  26503 */     // GIR_Coverage, 13191,
     /*  26503 */     GIR_EraseRootFromParent_Done,
     /*  26504 */   // Label 435: @26504
     /*  26504 */   GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(26596), // Rule ID 2031 //
     /*  26509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  26528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26532 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26536 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26541 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26545 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26549 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26553 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  26557 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26562 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  26566 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26570 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26574 */     // MIs[3] Operand 1
     /*  26574 */     // No operand predicates
     /*  26574 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  26576 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26581 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  26583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  26587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  26591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  26594 */     GIR_RootConstrainSelectedInstOperands,
     /*  26595 */     // GIR_Coverage, 2031,
     /*  26595 */     GIR_EraseRootFromParent_Done,
     /*  26596 */   // Label 436: @26596
     /*  26596 */   GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(26688), // Rule ID 13221 //
     /*  26601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26608 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  26620 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26624 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26628 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26632 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26636 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26640 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  26644 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26649 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  26653 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26657 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26661 */     // MIs[3] Operand 1
     /*  26661 */     // No operand predicates
     /*  26661 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26666 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  26668 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  26671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26673 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  26675 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  26679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  26683 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  26686 */     GIR_RootConstrainSelectedInstOperands,
     /*  26687 */     // GIR_Coverage, 13221,
     /*  26687 */     GIR_EraseRootFromParent_Done,
     /*  26688 */   // Label 437: @26688
     /*  26688 */   GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(26780), // Rule ID 2083 //
     /*  26693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  26712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26716 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26725 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26729 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26733 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26737 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  26741 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26746 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  26750 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26754 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26758 */     // MIs[3] Operand 1
     /*  26758 */     // No operand predicates
     /*  26758 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  26760 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  26763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26765 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  26767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  26771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  26775 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  26778 */     GIR_RootConstrainSelectedInstOperands,
     /*  26779 */     // GIR_Coverage, 2083,
     /*  26779 */     GIR_EraseRootFromParent_Done,
     /*  26780 */   // Label 438: @26780
     /*  26780 */   GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(26831), // Rule ID 13141 //
     /*  26785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  26800 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26808 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26810 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26817 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  26820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  26824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  26829 */     GIR_RootConstrainSelectedInstOperands,
     /*  26830 */     // GIR_Coverage, 13141,
     /*  26830 */     GIR_EraseRootFromParent_Done,
     /*  26831 */   // Label 439: @26831
     /*  26831 */   GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(26882), // Rule ID 13113 //
     /*  26836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  26851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26861 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26868 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (SADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i16_v4i32),
     /*  26871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  26875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  26880 */     GIR_RootConstrainSelectedInstOperands,
     /*  26881 */     // GIR_Coverage, 13113,
     /*  26881 */     GIR_EraseRootFromParent_Done,
     /*  26882 */   // Label 440: @26882
     /*  26882 */   GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(26933), // Rule ID 13140 //
     /*  26887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26902 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26910 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26912 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26919 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  26922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  26926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  26931 */     GIR_RootConstrainSelectedInstOperands,
     /*  26932 */     // GIR_Coverage, 13140,
     /*  26932 */     GIR_EraseRootFromParent_Done,
     /*  26933 */   // Label 441: @26933
     /*  26933 */   GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(26984), // Rule ID 1802 //
     /*  26938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26945 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  26957 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26961 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26963 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26970 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  26973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26975 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  26977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  26982 */     GIR_RootConstrainSelectedInstOperands,
     /*  26983 */     // GIR_Coverage, 1802,
     /*  26983 */     GIR_EraseRootFromParent_Done,
     /*  26984 */   // Label 442: @26984
     /*  26984 */   GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(27035), // Rule ID 1714 //
     /*  26989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  27008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27012 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27014 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27021 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i16_v4i32),
     /*  27024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  27026 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  27028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  27033 */     GIR_RootConstrainSelectedInstOperands,
     /*  27034 */     // GIR_Coverage, 1714,
     /*  27034 */     GIR_EraseRootFromParent_Done,
     /*  27035 */   // Label 443: @27035
     /*  27035 */   GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(27086), // Rule ID 1801 //
     /*  27040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27047 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27059 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27065 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27072 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  27075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  27077 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  27079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  27084 */     GIR_RootConstrainSelectedInstOperands,
     /*  27085 */     // GIR_Coverage, 1801,
     /*  27085 */     GIR_EraseRootFromParent_Done,
     /*  27086 */   // Label 444: @27086
     /*  27086 */   GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(27155), // Rule ID 13067 //
     /*  27091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27106 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  27109 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  27114 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27118 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  27122 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27127 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27138 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 659:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (SABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  27138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i32),
     /*  27141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  27153 */     GIR_RootConstrainSelectedInstOperands,
     /*  27154 */     // GIR_Coverage, 13067,
     /*  27154 */     GIR_EraseRootFromParent_Done,
     /*  27155 */   // Label 445: @27155
     /*  27155 */   GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(27224), // Rule ID 13079 //
     /*  27160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27175 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  27178 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  27183 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27187 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  27191 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27196 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27207 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 724:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (UABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  27207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i32),
     /*  27210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  27222 */     GIR_RootConstrainSelectedInstOperands,
     /*  27223 */     // GIR_Coverage, 13079,
     /*  27223 */     GIR_EraseRootFromParent_Done,
     /*  27224 */   // Label 446: @27224
     /*  27224 */   GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(27280), // Rule ID 13029 //
     /*  27229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27244 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  27247 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  27252 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  27256 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27267 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 660:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  27267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  27270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27274 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27278 */     GIR_RootConstrainSelectedInstOperands,
     /*  27279 */     // GIR_Coverage, 13029,
     /*  27279 */     GIR_EraseRootFromParent_Done,
     /*  27280 */   // Label 447: @27280
     /*  27280 */   GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(27336), // Rule ID 13041 //
     /*  27285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27300 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  27303 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  27308 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  27312 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27323 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  27323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  27326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27334 */     GIR_RootConstrainSelectedInstOperands,
     /*  27335 */     // GIR_Coverage, 13041,
     /*  27335 */     GIR_EraseRootFromParent_Done,
     /*  27336 */   // Label 448: @27336
     /*  27336 */   GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(27403), // Rule ID 13271 //
     /*  27341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  27356 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27360 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27365 */     // MIs[1] imm
     /*  27365 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  27369 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27373 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  27377 */     // MIs[2] Operand 1
     /*  27377 */     // No operand predicates
     /*  27377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27381 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  27385 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27387 */     // (add:{ *:[v4i32] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  27387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  27390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  27398 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  27401 */     GIR_RootConstrainSelectedInstOperands,
     /*  27402 */     // GIR_Coverage, 13271,
     /*  27402 */     GIR_EraseRootFromParent_Done,
     /*  27403 */   // Label 449: @27403
     /*  27403 */   GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(27470), // Rule ID 13292 //
     /*  27408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  27423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27427 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27432 */     // MIs[1] imm
     /*  27432 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  27436 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27440 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  27444 */     // MIs[2] Operand 1
     /*  27444 */     // No operand predicates
     /*  27444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27448 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  27452 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27454 */     // (add:{ *:[v4i32] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  27454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  27457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  27465 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  27468 */     GIR_RootConstrainSelectedInstOperands,
     /*  27469 */     // GIR_Coverage, 13292,
     /*  27469 */     GIR_EraseRootFromParent_Done,
     /*  27470 */   // Label 450: @27470
     /*  27470 */   GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(27539), // Rule ID 1360 //
     /*  27475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27482 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27494 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  27497 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  27502 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27506 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  27510 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27515 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27522 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 659:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (SABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  27522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i32),
     /*  27525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27527 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  27537 */     GIR_RootConstrainSelectedInstOperands,
     /*  27538 */     // GIR_Coverage, 1360,
     /*  27538 */     GIR_EraseRootFromParent_Done,
     /*  27539 */   // Label 451: @27539
     /*  27539 */   GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(27608), // Rule ID 1483 //
     /*  27544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27563 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  27566 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  27571 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27575 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  27579 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27584 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27591 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 724:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (UABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  27591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i32),
     /*  27594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27596 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  27606 */     GIR_RootConstrainSelectedInstOperands,
     /*  27607 */     // GIR_Coverage, 1483,
     /*  27607 */     GIR_EraseRootFromParent_Done,
     /*  27608 */   // Label 452: @27608
     /*  27608 */   GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(27664), // Rule ID 988 //
     /*  27613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27632 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  27635 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  27640 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  27644 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27651 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 660:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  27651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  27654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27656 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27662 */     GIR_RootConstrainSelectedInstOperands,
     /*  27663 */     // GIR_Coverage, 988,
     /*  27663 */     GIR_EraseRootFromParent_Done,
     /*  27664 */   // Label 453: @27664
     /*  27664 */   GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(27720), // Rule ID 1049 //
     /*  27669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27676 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27688 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  27691 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  27696 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  27700 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27707 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  27707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  27710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27712 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27718 */     GIR_RootConstrainSelectedInstOperands,
     /*  27719 */     // GIR_Coverage, 1049,
     /*  27719 */     GIR_EraseRootFromParent_Done,
     /*  27720 */   // Label 454: @27720
     /*  27720 */   GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(27787), // Rule ID 2231 //
     /*  27725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  27744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27748 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27753 */     // MIs[1] imm
     /*  27753 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  27757 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27761 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  27765 */     // MIs[2] Operand 1
     /*  27765 */     // No operand predicates
     /*  27765 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  27769 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27771 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  27771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  27774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27776 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  27782 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  27785 */     GIR_RootConstrainSelectedInstOperands,
     /*  27786 */     // GIR_Coverage, 2231,
     /*  27786 */     GIR_EraseRootFromParent_Done,
     /*  27787 */   // Label 455: @27787
     /*  27787 */   GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(27854), // Rule ID 2290 //
     /*  27792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27799 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  27811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27815 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27820 */     // MIs[1] imm
     /*  27820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  27824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27828 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  27832 */     // MIs[2] Operand 1
     /*  27832 */     // No operand predicates
     /*  27832 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  27836 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27838 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  27838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  27841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27843 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  27849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  27852 */     GIR_RootConstrainSelectedInstOperands,
     /*  27853 */     // GIR_Coverage, 2290,
     /*  27853 */     GIR_EraseRootFromParent_Done,
     /*  27854 */   // Label 456: @27854
     /*  27854 */   GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(27924), // Rule ID 6837 //
     /*  27859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /*  27871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27879 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27884 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27889 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  27893 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  27897 */     // MIs[2] Rn
     /*  27897 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  27902 */     // MIs[2] Rm
     /*  27902 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  27907 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27909 */     // (add:{ *:[v4i32] } (AArch64uzp1:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm), (AArch64uzp2:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm))  =>  (ADDPv4i32:{ *:[v4i32] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rm)
     /*  27909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  27912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  27914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  27918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  27922 */     GIR_RootConstrainSelectedInstOperands,
     /*  27923 */     // GIR_Coverage, 6837,
     /*  27923 */     GIR_EraseRootFromParent_Done,
     /*  27924 */   // Label 457: @27924
     /*  27924 */   GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(27994), // Rule ID 13656 //
     /*  27929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /*  27941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27945 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27949 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27954 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27959 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  27963 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /*  27967 */     // MIs[2] Rn
     /*  27967 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  27972 */     // MIs[2] Rm
     /*  27972 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  27977 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27979 */     // (add:{ *:[v4i32] } (AArch64uzp2:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm), (AArch64uzp1:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm))  =>  (ADDPv4i32:{ *:[v4i32] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rm)
     /*  27979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  27982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  27984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  27988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  27992 */     GIR_RootConstrainSelectedInstOperands,
     /*  27993 */     // GIR_Coverage, 13656,
     /*  27993 */     GIR_EraseRootFromParent_Done,
     /*  27994 */   // Label 458: @27994
     /*  27994 */   GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(28057), // Rule ID 1782 //
     /*  27999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  28014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28018 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28023 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  28027 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  28031 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28035 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28040 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28042 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  28045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28055 */     GIR_RootConstrainSelectedInstOperands,
     /*  28056 */     // GIR_Coverage, 1782,
     /*  28056 */     GIR_EraseRootFromParent_Done,
     /*  28057 */   // Label 459: @28057
     /*  28057 */   GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(28120), // Rule ID 1781 //
     /*  28062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  28077 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28081 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28086 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  28090 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  28094 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28098 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28103 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28105 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  28108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28118 */     GIR_RootConstrainSelectedInstOperands,
     /*  28119 */     // GIR_Coverage, 1781,
     /*  28119 */     GIR_EraseRootFromParent_Done,
     /*  28120 */   // Label 460: @28120
     /*  28120 */   GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(28183), // Rule ID 1707 //
     /*  28125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  28140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28144 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28149 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  28153 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  28157 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28161 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28166 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28168 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i16_v4i32),
     /*  28171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28181 */     GIR_RootConstrainSelectedInstOperands,
     /*  28182 */     // GIR_Coverage, 1707,
     /*  28182 */     GIR_EraseRootFromParent_Done,
     /*  28183 */   // Label 461: @28183
     /*  28183 */   GIM_Try, /*On fail goto*//*Label 462*/ GIMT_Encode4(28246), // Rule ID 1780 //
     /*  28188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  28203 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28207 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28212 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  28216 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  28220 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28224 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28229 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28231 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  28234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28236 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28244 */     GIR_RootConstrainSelectedInstOperands,
     /*  28245 */     // GIR_Coverage, 1780,
     /*  28245 */     GIR_EraseRootFromParent_Done,
     /*  28246 */   // Label 462: @28246
     /*  28246 */   GIM_Try, /*On fail goto*//*Label 463*/ GIMT_Encode4(28309), // Rule ID 1779 //
     /*  28251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  28266 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28270 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28275 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  28279 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  28283 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28287 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28292 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28294 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  28297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28307 */     GIR_RootConstrainSelectedInstOperands,
     /*  28308 */     // GIR_Coverage, 1779,
     /*  28308 */     GIR_EraseRootFromParent_Done,
     /*  28309 */   // Label 463: @28309
     /*  28309 */   GIM_Try, /*On fail goto*//*Label 464*/ GIMT_Encode4(28370), // Rule ID 13118 //
     /*  28314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  28329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28333 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28337 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28342 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28353 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  28356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28364 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  28368 */     GIR_RootConstrainSelectedInstOperands,
     /*  28369 */     // GIR_Coverage, 13118,
     /*  28369 */     GIR_EraseRootFromParent_Done,
     /*  28370 */   // Label 464: @28370
     /*  28370 */   GIM_Try, /*On fail goto*//*Label 465*/ GIMT_Encode4(28431), // Rule ID 13148 //
     /*  28375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  28390 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28394 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28398 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28403 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28412 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28414 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  28417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28425 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  28429 */     GIR_RootConstrainSelectedInstOperands,
     /*  28430 */     // GIR_Coverage, 13148,
     /*  28430 */     GIR_EraseRootFromParent_Done,
     /*  28431 */   // Label 465: @28431
     /*  28431 */   GIM_Try, /*On fail goto*//*Label 466*/ GIMT_Encode4(28479), // Rule ID 13139 //
     /*  28436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  28451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28455 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28464 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28466 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  28469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  28473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  28477 */     GIR_RootConstrainSelectedInstOperands,
     /*  28478 */     // GIR_Coverage, 13139,
     /*  28478 */     GIR_EraseRootFromParent_Done,
     /*  28479 */   // Label 466: @28479
     /*  28479 */   GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(28527), // Rule ID 13028 //
     /*  28484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  28499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28503 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28514 */     // (add:{ *:[v4i32] } (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  28514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  28517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28519 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28525 */     GIR_RootConstrainSelectedInstOperands,
     /*  28526 */     // GIR_Coverage, 13028,
     /*  28526 */     GIR_EraseRootFromParent_Done,
     /*  28527 */   // Label 467: @28527
     /*  28527 */   GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(28575), // Rule ID 13112 //
     /*  28532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  28547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28551 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28560 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28562 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (SADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  28565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  28569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  28573 */     GIR_RootConstrainSelectedInstOperands,
     /*  28574 */     // GIR_Coverage, 13112,
     /*  28574 */     GIR_EraseRootFromParent_Done,
     /*  28575 */   // Label 468: @28575
     /*  28575 */   GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(28623), // Rule ID 13040 //
     /*  28580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  28595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28599 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28610 */     // (add:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  28610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  28613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28615 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28621 */     GIR_RootConstrainSelectedInstOperands,
     /*  28622 */     // GIR_Coverage, 13040,
     /*  28622 */     GIR_EraseRootFromParent_Done,
     /*  28623 */   // Label 469: @28623
     /*  28623 */   GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(28671), // Rule ID 13138 //
     /*  28628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  28643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28647 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28656 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28658 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  28661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28663 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  28665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  28669 */     GIR_RootConstrainSelectedInstOperands,
     /*  28670 */     // GIR_Coverage, 13138,
     /*  28670 */     GIR_EraseRootFromParent_Done,
     /*  28671 */   // Label 470: @28671
     /*  28671 */   GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(28732), // Rule ID 1719 //
     /*  28676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  28695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28699 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28703 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28708 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28715 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  28718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28720 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  28730 */     GIR_RootConstrainSelectedInstOperands,
     /*  28731 */     // GIR_Coverage, 1719,
     /*  28731 */     GIR_EraseRootFromParent_Done,
     /*  28732 */   // Label 471: @28732
     /*  28732 */   GIM_Try, /*On fail goto*//*Label 472*/ GIMT_Encode4(28793), // Rule ID 1809 //
     /*  28737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28744 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  28756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28760 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28764 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28769 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28774 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28776 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  28779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28781 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  28791 */     GIR_RootConstrainSelectedInstOperands,
     /*  28792 */     // GIR_Coverage, 1809,
     /*  28792 */     GIR_EraseRootFromParent_Done,
     /*  28793 */   // Label 472: @28793
     /*  28793 */   GIM_Try, /*On fail goto*//*Label 473*/ GIMT_Encode4(28841), // Rule ID 1800 //
     /*  28798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  28817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28821 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28826 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28828 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  28831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28833 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  28835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  28839 */     GIR_RootConstrainSelectedInstOperands,
     /*  28840 */     // GIR_Coverage, 1800,
     /*  28840 */     GIR_EraseRootFromParent_Done,
     /*  28841 */   // Label 473: @28841
     /*  28841 */   GIM_Try, /*On fail goto*//*Label 474*/ GIMT_Encode4(28889), // Rule ID 987 //
     /*  28846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  28865 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28874 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28876 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  28876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  28879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28881 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28887 */     GIR_RootConstrainSelectedInstOperands,
     /*  28888 */     // GIR_Coverage, 987,
     /*  28888 */     GIR_EraseRootFromParent_Done,
     /*  28889 */   // Label 474: @28889
     /*  28889 */   GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(28937), // Rule ID 1713 //
     /*  28894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  28913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28917 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28922 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28924 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  28927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28929 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  28931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  28935 */     GIR_RootConstrainSelectedInstOperands,
     /*  28936 */     // GIR_Coverage, 1713,
     /*  28936 */     GIR_EraseRootFromParent_Done,
     /*  28937 */   // Label 475: @28937
     /*  28937 */   GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(28985), // Rule ID 1048 //
     /*  28942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28949 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  28961 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28965 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28972 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  28972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  28975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28977 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28983 */     GIR_RootConstrainSelectedInstOperands,
     /*  28984 */     // GIR_Coverage, 1048,
     /*  28984 */     GIR_EraseRootFromParent_Done,
     /*  28985 */   // Label 476: @28985
     /*  28985 */   GIM_Try, /*On fail goto*//*Label 477*/ GIMT_Encode4(29033), // Rule ID 1799 //
     /*  28990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28997 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  29009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29018 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29020 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  29020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  29023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29025 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  29027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  29031 */     GIR_RootConstrainSelectedInstOperands,
     /*  29032 */     // GIR_Coverage, 1799,
     /*  29032 */     GIR_EraseRootFromParent_Done,
     /*  29033 */   // Label 477: @29033
     /*  29033 */   GIM_Try, /*On fail goto*//*Label 478*/ GIMT_Encode4(29060), // Rule ID 1098 //
     /*  29038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29045 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29053 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  29053 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
     /*  29058 */     GIR_RootConstrainSelectedInstOperands,
     /*  29059 */     // GIR_Coverage, 1098,
     /*  29059 */     GIR_Done,
     /*  29060 */   // Label 478: @29060
     /*  29060 */   GIM_Reject,
     /*  29061 */ // Label 397: @29061
     /*  29061 */ GIM_Reject,
     /*  29062 */ // Label 161: @29062
     /*  29062 */ GIM_Try, /*On fail goto*//*Label 479*/ GIMT_Encode4(29911),
     /*  29067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  29070 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  29073 */   GIM_Try, /*On fail goto*//*Label 480*/ GIMT_Encode4(29206), // Rule ID 13661 //
     /*  29078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  29090 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29094 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  29098 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  29102 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29106 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  29110 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29115 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  29119 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  29123 */     // MIs[1] Operand 2
     /*  29123 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  29134 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  29138 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  29142 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29146 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  29150 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  29154 */     // MIs[5] Rn
     /*  29154 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  29159 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  29161 */     // (add:{ *:[v8i8] } (extract_subvector:{ *:[v8i8] } (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, (undef:{ *:[v16i8] })), 0:{ *:[i64] }), (trunc:{ *:[v8i8] } (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$Rn)))  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (ADDPv16i8:{ *:[f128] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rn), dsub:{ *:[i32] })
     /*  29161 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  29164 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  29168 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29173 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  29177 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  29181 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  29183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29188 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  29195 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29200 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29205 */     // GIR_Coverage, 13661,
     /*  29205 */     GIR_EraseRootFromParent_Done,
     /*  29206 */   // Label 480: @29206
     /*  29206 */   GIM_Try, /*On fail goto*//*Label 481*/ GIMT_Encode4(29339), // Rule ID 6842 //
     /*  29211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  29223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29227 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  29231 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  29235 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29239 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29244 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  29248 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  29252 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29256 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  29260 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_UZP2),
     /*  29264 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  29268 */     // MIs[4] Rn
     /*  29268 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  29273 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  29277 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  29281 */     // MIs[3] Operand 2
     /*  29281 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  29292 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  29294 */     // (add:{ *:[v8i8] } (trunc:{ *:[v8i8] } (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$Rn)), (extract_subvector:{ *:[v8i8] } (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, (undef:{ *:[v16i8] })), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (ADDPv16i8:{ *:[f128] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rn), dsub:{ *:[i32] })
     /*  29294 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  29297 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  29301 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29306 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  29310 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  29314 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  29316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29321 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  29328 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29333 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29338 */     // GIR_Coverage, 6842,
     /*  29338 */     GIR_EraseRootFromParent_Done,
     /*  29339 */   // Label 481: @29339
     /*  29339 */   GIM_Try, /*On fail goto*//*Label 482*/ GIMT_Encode4(29408), // Rule ID 13057 //
     /*  29344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29359 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  29362 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  29367 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  29371 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  29375 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29380 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29391 */     // (add:{ *:[v8i8] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V64:{ *:[v8i8] }:$Rd)  =>  (SABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  29391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i8),
     /*  29394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29402 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  29406 */     GIR_RootConstrainSelectedInstOperands,
     /*  29407 */     // GIR_Coverage, 13057,
     /*  29407 */     GIR_EraseRootFromParent_Done,
     /*  29408 */   // Label 482: @29408
     /*  29408 */   GIM_Try, /*On fail goto*//*Label 483*/ GIMT_Encode4(29477), // Rule ID 13069 //
     /*  29413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29428 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  29431 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  29436 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  29440 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  29444 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29449 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29458 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29460 */     // (add:{ *:[v8i8] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V64:{ *:[v8i8] }:$Rd)  =>  (UABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  29460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i8),
     /*  29463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  29475 */     GIR_RootConstrainSelectedInstOperands,
     /*  29476 */     // GIR_Coverage, 13069,
     /*  29476 */     GIR_EraseRootFromParent_Done,
     /*  29477 */   // Label 483: @29477
     /*  29477 */   GIM_Try, /*On fail goto*//*Label 484*/ GIMT_Encode4(29544), // Rule ID 13261 //
     /*  29482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  29497 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  29501 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29506 */     // MIs[1] imm
     /*  29506 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29510 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29514 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  29518 */     // MIs[2] Operand 1
     /*  29518 */     // No operand predicates
     /*  29518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29522 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29526 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29528 */     // (add:{ *:[v8i8] } (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  29531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29542 */     GIR_RootConstrainSelectedInstOperands,
     /*  29543 */     // GIR_Coverage, 13261,
     /*  29543 */     GIR_EraseRootFromParent_Done,
     /*  29544 */   // Label 484: @29544
     /*  29544 */   GIM_Try, /*On fail goto*//*Label 485*/ GIMT_Encode4(29611), // Rule ID 13282 //
     /*  29549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  29564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  29568 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29573 */     // MIs[1] imm
     /*  29573 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29577 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29581 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  29585 */     // MIs[2] Operand 1
     /*  29585 */     // No operand predicates
     /*  29585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29589 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29593 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29595 */     // (add:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  29598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29600 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29606 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29609 */     GIR_RootConstrainSelectedInstOperands,
     /*  29610 */     // GIR_Coverage, 13282,
     /*  29610 */     GIR_EraseRootFromParent_Done,
     /*  29611 */   // Label 485: @29611
     /*  29611 */   GIM_Try, /*On fail goto*//*Label 486*/ GIMT_Encode4(29680), // Rule ID 1350 //
     /*  29616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29623 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29635 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  29638 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  29643 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  29647 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  29651 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29656 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29663 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  29663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i8),
     /*  29666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29668 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  29678 */     GIR_RootConstrainSelectedInstOperands,
     /*  29679 */     // GIR_Coverage, 1350,
     /*  29679 */     GIR_EraseRootFromParent_Done,
     /*  29680 */   // Label 486: @29680
     /*  29680 */   GIM_Try, /*On fail goto*//*Label 487*/ GIMT_Encode4(29749), // Rule ID 1473 //
     /*  29685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29704 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  29707 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  29712 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  29716 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  29720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29725 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29730 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29732 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  29732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i8),
     /*  29735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29737 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  29747 */     GIR_RootConstrainSelectedInstOperands,
     /*  29748 */     // GIR_Coverage, 1473,
     /*  29748 */     GIR_EraseRootFromParent_Done,
     /*  29749 */   // Label 487: @29749
     /*  29749 */   GIM_Try, /*On fail goto*//*Label 488*/ GIMT_Encode4(29816), // Rule ID 2221 //
     /*  29754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  29773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  29777 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29782 */     // MIs[1] imm
     /*  29782 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29786 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29790 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  29794 */     // MIs[2] Operand 1
     /*  29794 */     // No operand predicates
     /*  29794 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29798 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29800 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  29803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29805 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29811 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29814 */     GIR_RootConstrainSelectedInstOperands,
     /*  29815 */     // GIR_Coverage, 2221,
     /*  29815 */     GIR_EraseRootFromParent_Done,
     /*  29816 */   // Label 488: @29816
     /*  29816 */   GIM_Try, /*On fail goto*//*Label 489*/ GIMT_Encode4(29883), // Rule ID 2280 //
     /*  29821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29828 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  29840 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  29844 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29849 */     // MIs[1] imm
     /*  29849 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29853 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29857 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  29861 */     // MIs[2] Operand 1
     /*  29861 */     // No operand predicates
     /*  29861 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29865 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29867 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  29870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29872 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29878 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29881 */     GIR_RootConstrainSelectedInstOperands,
     /*  29882 */     // GIR_Coverage, 2280,
     /*  29882 */     GIR_EraseRootFromParent_Done,
     /*  29883 */   // Label 489: @29883
     /*  29883 */   GIM_Try, /*On fail goto*//*Label 490*/ GIMT_Encode4(29910), // Rule ID 1093 //
     /*  29888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29903 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  29903 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv8i8),
     /*  29908 */     GIR_RootConstrainSelectedInstOperands,
     /*  29909 */     // GIR_Coverage, 1093,
     /*  29909 */     GIR_Done,
     /*  29910 */   // Label 490: @29910
     /*  29910 */   GIM_Reject,
     /*  29911 */ // Label 479: @29911
     /*  29911 */ GIM_Reject,
     /*  29912 */ // Label 162: @29912
     /*  29912 */ GIM_Try, /*On fail goto*//*Label 491*/ GIMT_Encode4(33489),
     /*  29917 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29920 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  29923 */   GIM_Try, /*On fail goto*//*Label 492*/ GIMT_Encode4(30010), // Rule ID 13101 //
     /*  29928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  29943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  29947 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  29951 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29955 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  29958 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  29963 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  29967 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  29971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29975 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29977 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  29984 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  29991 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))), V128:{ *:[v8i16] }:$Rd)  =>  (SABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  29991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv16i8_v8i16),
     /*  29994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  30003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  30008 */     GIR_RootConstrainSelectedInstOperands,
     /*  30009 */     // GIR_Coverage, 13101,
     /*  30009 */     GIR_EraseRootFromParent_Done,
     /*  30010 */   // Label 492: @30010
     /*  30010 */   GIM_Try, /*On fail goto*//*Label 493*/ GIMT_Encode4(30097), // Rule ID 13125 //
     /*  30015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30030 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30034 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30038 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  30042 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  30045 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  30050 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  30054 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  30058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30062 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30064 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30071 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30078 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))), V128:{ *:[v8i16] }:$Rd)  =>  (UABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  30078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv16i8_v8i16),
     /*  30081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  30090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  30095 */     GIR_RootConstrainSelectedInstOperands,
     /*  30096 */     // GIR_Coverage, 13125,
     /*  30096 */     GIR_EraseRootFromParent_Done,
     /*  30097 */   // Label 493: @30097
     /*  30097 */   GIM_Try, /*On fail goto*//*Label 494*/ GIMT_Encode4(30184), // Rule ID 1684 //
     /*  30102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30109 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30125 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30129 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  30133 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  30136 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  30141 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  30145 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  30149 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30151 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30158 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30165 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))))  =>  (SABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  30165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv16i8_v8i16),
     /*  30168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30170 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  30177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  30182 */     GIR_RootConstrainSelectedInstOperands,
     /*  30183 */     // GIR_Coverage, 1684,
     /*  30183 */     GIR_EraseRootFromParent_Done,
     /*  30184 */   // Label 494: @30184
     /*  30184 */   GIM_Try, /*On fail goto*//*Label 495*/ GIMT_Encode4(30271), // Rule ID 1762 //
     /*  30189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30196 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30208 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30212 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30216 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  30220 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  30223 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  30228 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  30232 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  30236 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30238 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30245 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30252 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))))  =>  (UABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  30252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv16i8_v8i16),
     /*  30255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30257 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  30264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  30269 */     GIR_RootConstrainSelectedInstOperands,
     /*  30270 */     // GIR_Coverage, 1762,
     /*  30270 */     GIR_EraseRootFromParent_Done,
     /*  30271 */   // Label 495: @30271
     /*  30271 */   GIM_Try, /*On fail goto*//*Label 496*/ GIMT_Encode4(30340), // Rule ID 1778 //
     /*  30276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  30291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30295 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  30299 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  30303 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30307 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30309 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30316 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30323 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  30323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  30326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  30333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  30338 */     GIR_RootConstrainSelectedInstOperands,
     /*  30339 */     // GIR_Coverage, 1778,
     /*  30339 */     GIR_EraseRootFromParent_Done,
     /*  30340 */   // Label 496: @30340
     /*  30340 */   GIM_Try, /*On fail goto*//*Label 497*/ GIMT_Encode4(30409), // Rule ID 1777 //
     /*  30345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  30360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30364 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  30368 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30372 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30376 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30378 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30385 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30392 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  30392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  30395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  30402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  30407 */     GIR_RootConstrainSelectedInstOperands,
     /*  30408 */     // GIR_Coverage, 1777,
     /*  30408 */     GIR_EraseRootFromParent_Done,
     /*  30409 */   // Label 497: @30409
     /*  30409 */   GIM_Try, /*On fail goto*//*Label 498*/ GIMT_Encode4(30478), // Rule ID 1706 //
     /*  30414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  30429 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  30437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  30441 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30445 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30447 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30454 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30461 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  30461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv16i8_v8i16),
     /*  30464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  30471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  30476 */     GIR_RootConstrainSelectedInstOperands,
     /*  30477 */     // GIR_Coverage, 1706,
     /*  30477 */     GIR_EraseRootFromParent_Done,
     /*  30478 */   // Label 498: @30478
     /*  30478 */   GIM_Try, /*On fail goto*//*Label 499*/ GIMT_Encode4(30547), // Rule ID 1776 //
     /*  30483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30498 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30502 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  30506 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  30510 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30514 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30516 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30523 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30530 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  30530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  30533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  30540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  30545 */     GIR_RootConstrainSelectedInstOperands,
     /*  30546 */     // GIR_Coverage, 1776,
     /*  30546 */     GIR_EraseRootFromParent_Done,
     /*  30547 */   // Label 499: @30547
     /*  30547 */   GIM_Try, /*On fail goto*//*Label 500*/ GIMT_Encode4(30616), // Rule ID 1775 //
     /*  30552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30567 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30571 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  30575 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30579 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30583 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30585 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30592 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30599 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  30599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  30602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  30609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  30614 */     GIR_RootConstrainSelectedInstOperands,
     /*  30615 */     // GIR_Coverage, 1775,
     /*  30615 */     GIR_EraseRootFromParent_Done,
     /*  30616 */   // Label 500: @30616
     /*  30616 */   GIM_Try, /*On fail goto*//*Label 501*/ GIMT_Encode4(30683), // Rule ID 13117 //
     /*  30621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  30636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30640 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  30644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30648 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30650 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30657 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30664 */     // (add:{ *:[v8i16] } (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (SMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  30664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv16i8_v8i16),
     /*  30667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  30676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  30681 */     GIR_RootConstrainSelectedInstOperands,
     /*  30682 */     // GIR_Coverage, 13117,
     /*  30682 */     GIR_EraseRootFromParent_Done,
     /*  30683 */   // Label 501: @30683
     /*  30683 */   GIM_Try, /*On fail goto*//*Label 502*/ GIMT_Encode4(30750), // Rule ID 13147 //
     /*  30688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  30703 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30707 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  30711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30717 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30724 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30731 */     // (add:{ *:[v8i16] } (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (UMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  30731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv16i8_v8i16),
     /*  30734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  30743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  30748 */     GIR_RootConstrainSelectedInstOperands,
     /*  30749 */     // GIR_Coverage, 13147,
     /*  30749 */     GIR_EraseRootFromParent_Done,
     /*  30750 */   // Label 502: @30750
     /*  30750 */   GIM_Try, /*On fail goto*//*Label 503*/ GIMT_Encode4(30817), // Rule ID 1718 //
     /*  30755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  30774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30778 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  30782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30784 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30791 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30798 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  30798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv16i8_v8i16),
     /*  30801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30803 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  30810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  30815 */     GIR_RootConstrainSelectedInstOperands,
     /*  30816 */     // GIR_Coverage, 1718,
     /*  30816 */     GIR_EraseRootFromParent_Done,
     /*  30817 */   // Label 503: @30817
     /*  30817 */   GIM_Try, /*On fail goto*//*Label 504*/ GIMT_Encode4(30884), // Rule ID 1808 //
     /*  30822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30829 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  30841 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30845 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  30849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30851 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30858 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  30865 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  30865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv16i8_v8i16),
     /*  30868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30870 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  30877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  30882 */     GIR_RootConstrainSelectedInstOperands,
     /*  30883 */     // GIR_Coverage, 1808,
     /*  30883 */     GIR_EraseRootFromParent_Done,
     /*  30884 */   // Label 504: @30884
     /*  30884 */   GIM_Try, /*On fail goto*//*Label 505*/ GIMT_Encode4(30965), // Rule ID 13099 //
     /*  30889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30908 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30912 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  30916 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  30919 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  30924 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  30928 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  30932 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30937 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30946 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30948 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (SABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  30948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i8_v8i16),
     /*  30951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  30959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  30963 */     GIR_RootConstrainSelectedInstOperands,
     /*  30964 */     // GIR_Coverage, 13099,
     /*  30964 */     GIR_EraseRootFromParent_Done,
     /*  30965 */   // Label 505: @30965
     /*  30965 */   GIM_Try, /*On fail goto*//*Label 506*/ GIMT_Encode4(31046), // Rule ID 13123 //
     /*  30970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30989 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30993 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  30997 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  31000 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  31005 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31009 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31013 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31018 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31027 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31029 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (UABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i8_v8i16),
     /*  31032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  31040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  31044 */     GIR_RootConstrainSelectedInstOperands,
     /*  31045 */     // GIR_Coverage, 13123,
     /*  31045 */     GIR_EraseRootFromParent_Done,
     /*  31046 */   // Label 506: @31046
     /*  31046 */   GIM_Try, /*On fail goto*//*Label 507*/ GIMT_Encode4(31127), // Rule ID 1682 //
     /*  31051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31074 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31078 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31082 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  31085 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31090 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31094 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31098 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31103 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31108 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31110 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)))  =>  (SABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i8_v8i16),
     /*  31113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31115 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  31121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  31125 */     GIR_RootConstrainSelectedInstOperands,
     /*  31126 */     // GIR_Coverage, 1682,
     /*  31126 */     GIR_EraseRootFromParent_Done,
     /*  31127 */   // Label 507: @31127
     /*  31127 */   GIM_Try, /*On fail goto*//*Label 508*/ GIMT_Encode4(31208), // Rule ID 1760 //
     /*  31132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31163 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  31166 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  31171 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31175 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31179 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31184 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31189 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31191 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)))  =>  (UABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i8_v8i16),
     /*  31194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31196 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  31202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  31206 */     GIR_RootConstrainSelectedInstOperands,
     /*  31207 */     // GIR_Coverage, 1760,
     /*  31207 */     GIR_EraseRootFromParent_Done,
     /*  31208 */   // Label 508: @31208
     /*  31208 */   GIM_Try, /*On fail goto*//*Label 509*/ GIMT_Encode4(31259), // Rule ID 13137 //
     /*  31213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  31228 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31236 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31238 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31245 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  31248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  31250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  31252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  31257 */     GIR_RootConstrainSelectedInstOperands,
     /*  31258 */     // GIR_Coverage, 13137,
     /*  31258 */     GIR_EraseRootFromParent_Done,
     /*  31259 */   // Label 509: @31259
     /*  31259 */   GIM_Try, /*On fail goto*//*Label 510*/ GIMT_Encode4(31310), // Rule ID 13111 //
     /*  31264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  31279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31289 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31296 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (SADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv16i8_v8i16),
     /*  31299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  31301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  31303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  31308 */     GIR_RootConstrainSelectedInstOperands,
     /*  31309 */     // GIR_Coverage, 13111,
     /*  31309 */     GIR_EraseRootFromParent_Done,
     /*  31310 */   // Label 510: @31310
     /*  31310 */   GIM_Try, /*On fail goto*//*Label 511*/ GIMT_Encode4(31361), // Rule ID 13136 //
     /*  31315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31330 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31338 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31340 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31347 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  31350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  31352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  31354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  31359 */     GIR_RootConstrainSelectedInstOperands,
     /*  31360 */     // GIR_Coverage, 13136,
     /*  31360 */     GIR_EraseRootFromParent_Done,
     /*  31361 */   // Label 511: @31361
     /*  31361 */   GIM_Try, /*On fail goto*//*Label 512*/ GIMT_Encode4(31412), // Rule ID 1798 //
     /*  31366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31373 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  31385 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31391 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31398 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  31401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  31403 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  31405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  31410 */     GIR_RootConstrainSelectedInstOperands,
     /*  31411 */     // GIR_Coverage, 1798,
     /*  31411 */     GIR_EraseRootFromParent_Done,
     /*  31412 */   // Label 512: @31412
     /*  31412 */   GIM_Try, /*On fail goto*//*Label 513*/ GIMT_Encode4(31463), // Rule ID 1712 //
     /*  31417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  31436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31440 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31442 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31449 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv16i8_v8i16),
     /*  31452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  31454 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  31456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  31461 */     GIR_RootConstrainSelectedInstOperands,
     /*  31462 */     // GIR_Coverage, 1712,
     /*  31462 */     GIR_EraseRootFromParent_Done,
     /*  31463 */   // Label 513: @31463
     /*  31463 */   GIM_Try, /*On fail goto*//*Label 514*/ GIMT_Encode4(31514), // Rule ID 1797 //
     /*  31468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31487 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31493 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31500 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  31503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  31505 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  31507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  31512 */     GIR_RootConstrainSelectedInstOperands,
     /*  31513 */     // GIR_Coverage, 1797,
     /*  31513 */     GIR_EraseRootFromParent_Done,
     /*  31514 */   // Label 514: @31514
     /*  31514 */   GIM_Try, /*On fail goto*//*Label 515*/ GIMT_Encode4(31583), // Rule ID 13063 //
     /*  31519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31534 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31537 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31542 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  31546 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  31550 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31555 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31564 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31566 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 659:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (SABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  31566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i16),
     /*  31569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31581 */     GIR_RootConstrainSelectedInstOperands,
     /*  31582 */     // GIR_Coverage, 13063,
     /*  31582 */     GIR_EraseRootFromParent_Done,
     /*  31583 */   // Label 515: @31583
     /*  31583 */   GIM_Try, /*On fail goto*//*Label 516*/ GIMT_Encode4(31652), // Rule ID 13075 //
     /*  31588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31603 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31606 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  31611 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  31615 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  31619 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31624 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31635 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 724:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (UABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  31635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i16),
     /*  31638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31650 */     GIR_RootConstrainSelectedInstOperands,
     /*  31651 */     // GIR_Coverage, 13075,
     /*  31651 */     GIR_EraseRootFromParent_Done,
     /*  31652 */   // Label 516: @31652
     /*  31652 */   GIM_Try, /*On fail goto*//*Label 517*/ GIMT_Encode4(31708), // Rule ID 13025 //
     /*  31657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31672 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  31675 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  31680 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  31684 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31693 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31695 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 660:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  31695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  31698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31700 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31706 */     GIR_RootConstrainSelectedInstOperands,
     /*  31707 */     // GIR_Coverage, 13025,
     /*  31707 */     GIR_EraseRootFromParent_Done,
     /*  31708 */   // Label 517: @31708
     /*  31708 */   GIM_Try, /*On fail goto*//*Label 518*/ GIMT_Encode4(31764), // Rule ID 13037 //
     /*  31713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31728 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  31731 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  31736 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  31740 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31749 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31751 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  31751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  31754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31762 */     GIR_RootConstrainSelectedInstOperands,
     /*  31763 */     // GIR_Coverage, 13037,
     /*  31763 */     GIR_EraseRootFromParent_Done,
     /*  31764 */   // Label 518: @31764
     /*  31764 */   GIM_Try, /*On fail goto*//*Label 519*/ GIMT_Encode4(31831), // Rule ID 13267 //
     /*  31769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  31784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31788 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31793 */     // MIs[1] imm
     /*  31793 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31797 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  31801 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  31805 */     // MIs[2] Operand 1
     /*  31805 */     // No operand predicates
     /*  31805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31809 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  31813 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31815 */     // (add:{ *:[v8i16] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  31815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  31818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31826 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  31829 */     GIR_RootConstrainSelectedInstOperands,
     /*  31830 */     // GIR_Coverage, 13267,
     /*  31830 */     GIR_EraseRootFromParent_Done,
     /*  31831 */   // Label 519: @31831
     /*  31831 */   GIM_Try, /*On fail goto*//*Label 520*/ GIMT_Encode4(31898), // Rule ID 13288 //
     /*  31836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  31851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31855 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31860 */     // MIs[1] imm
     /*  31860 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31864 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  31868 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  31872 */     // MIs[2] Operand 1
     /*  31872 */     // No operand predicates
     /*  31872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31876 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  31880 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31882 */     // (add:{ *:[v8i16] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  31882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  31885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31893 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  31896 */     GIR_RootConstrainSelectedInstOperands,
     /*  31897 */     // GIR_Coverage, 13288,
     /*  31897 */     GIR_EraseRootFromParent_Done,
     /*  31898 */   // Label 520: @31898
     /*  31898 */   GIM_Try, /*On fail goto*//*Label 521*/ GIMT_Encode4(31967), // Rule ID 1356 //
     /*  31903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31922 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31925 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31930 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  31934 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  31938 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31943 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31948 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31950 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 659:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (SABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  31950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i16),
     /*  31953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31955 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31965 */     GIR_RootConstrainSelectedInstOperands,
     /*  31966 */     // GIR_Coverage, 1356,
     /*  31966 */     GIR_EraseRootFromParent_Done,
     /*  31967 */   // Label 521: @31967
     /*  31967 */   GIM_Try, /*On fail goto*//*Label 522*/ GIMT_Encode4(32036), // Rule ID 1479 //
     /*  31972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31979 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31991 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31994 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  31999 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  32003 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  32007 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32012 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32019 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 724:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (UABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  32019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i16),
     /*  32022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32024 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  32030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  32034 */     GIR_RootConstrainSelectedInstOperands,
     /*  32035 */     // GIR_Coverage, 1479,
     /*  32035 */     GIR_EraseRootFromParent_Done,
     /*  32036 */   // Label 522: @32036
     /*  32036 */   GIM_Try, /*On fail goto*//*Label 523*/ GIMT_Encode4(32092), // Rule ID 984 //
     /*  32041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32048 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32060 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  32063 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  32068 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  32072 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32077 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32079 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 660:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  32079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  32082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32084 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  32090 */     GIR_RootConstrainSelectedInstOperands,
     /*  32091 */     // GIR_Coverage, 984,
     /*  32091 */     GIR_EraseRootFromParent_Done,
     /*  32092 */   // Label 523: @32092
     /*  32092 */   GIM_Try, /*On fail goto*//*Label 524*/ GIMT_Encode4(32148), // Rule ID 1045 //
     /*  32097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32104 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32116 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  32119 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  32124 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  32128 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32133 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32135 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  32135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  32138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32140 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  32146 */     GIR_RootConstrainSelectedInstOperands,
     /*  32147 */     // GIR_Coverage, 1045,
     /*  32147 */     GIR_EraseRootFromParent_Done,
     /*  32148 */   // Label 524: @32148
     /*  32148 */   GIM_Try, /*On fail goto*//*Label 525*/ GIMT_Encode4(32215), // Rule ID 2227 //
     /*  32153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32160 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  32172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32176 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32181 */     // MIs[1] imm
     /*  32181 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  32185 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  32189 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  32193 */     // MIs[2] Operand 1
     /*  32193 */     // No operand predicates
     /*  32193 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  32197 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32199 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  32199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  32202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32204 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  32210 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  32213 */     GIR_RootConstrainSelectedInstOperands,
     /*  32214 */     // GIR_Coverage, 2227,
     /*  32214 */     GIR_EraseRootFromParent_Done,
     /*  32215 */   // Label 525: @32215
     /*  32215 */   GIM_Try, /*On fail goto*//*Label 526*/ GIMT_Encode4(32282), // Rule ID 2286 //
     /*  32220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32227 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  32239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32243 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32248 */     // MIs[1] imm
     /*  32248 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  32252 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  32256 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  32260 */     // MIs[2] Operand 1
     /*  32260 */     // No operand predicates
     /*  32260 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  32264 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32266 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  32266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  32269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32271 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  32277 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  32280 */     GIR_RootConstrainSelectedInstOperands,
     /*  32281 */     // GIR_Coverage, 2286,
     /*  32281 */     GIR_EraseRootFromParent_Done,
     /*  32282 */   // Label 526: @32282
     /*  32282 */   GIM_Try, /*On fail goto*//*Label 527*/ GIMT_Encode4(32352), // Rule ID 6838 //
     /*  32287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /*  32299 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32303 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  32307 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32312 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  32325 */     // MIs[2] Rn
     /*  32325 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  32330 */     // MIs[2] Rm
     /*  32330 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  32335 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32337 */     // (add:{ *:[v8i16] } (AArch64uzp1:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm), (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm))  =>  (ADDPv8i16:{ *:[v8i16] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rm)
     /*  32337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  32340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  32346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  32350 */     GIR_RootConstrainSelectedInstOperands,
     /*  32351 */     // GIR_Coverage, 6838,
     /*  32351 */     GIR_EraseRootFromParent_Done,
     /*  32352 */   // Label 527: @32352
     /*  32352 */   GIM_Try, /*On fail goto*//*Label 528*/ GIMT_Encode4(32422), // Rule ID 13657 //
     /*  32357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /*  32369 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32373 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  32377 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32382 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32387 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32391 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /*  32395 */     // MIs[2] Rn
     /*  32395 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  32400 */     // MIs[2] Rm
     /*  32400 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  32405 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32407 */     // (add:{ *:[v8i16] } (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm), (AArch64uzp1:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm))  =>  (ADDPv8i16:{ *:[v8i16] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rm)
     /*  32407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  32410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  32416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  32420 */     GIR_RootConstrainSelectedInstOperands,
     /*  32421 */     // GIR_Coverage, 13657,
     /*  32421 */     GIR_EraseRootFromParent_Done,
     /*  32422 */   // Label 528: @32422
     /*  32422 */   GIM_Try, /*On fail goto*//*Label 529*/ GIMT_Encode4(32485), // Rule ID 1774 //
     /*  32427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32446 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32451 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32455 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32459 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32463 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32468 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32470 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  32473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  32479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  32483 */     GIR_RootConstrainSelectedInstOperands,
     /*  32484 */     // GIR_Coverage, 1774,
     /*  32484 */     GIR_EraseRootFromParent_Done,
     /*  32485 */   // Label 529: @32485
     /*  32485 */   GIM_Try, /*On fail goto*//*Label 530*/ GIMT_Encode4(32548), // Rule ID 1773 //
     /*  32490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32509 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32522 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32526 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32531 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32533 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  32536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  32542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  32546 */     GIR_RootConstrainSelectedInstOperands,
     /*  32547 */     // GIR_Coverage, 1773,
     /*  32547 */     GIR_EraseRootFromParent_Done,
     /*  32548 */   // Label 530: @32548
     /*  32548 */   GIM_Try, /*On fail goto*//*Label 531*/ GIMT_Encode4(32611), // Rule ID 1705 //
     /*  32553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  32568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32572 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32581 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  32585 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32589 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32594 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32596 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i8_v8i16),
     /*  32599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32601 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  32605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  32609 */     GIR_RootConstrainSelectedInstOperands,
     /*  32610 */     // GIR_Coverage, 1705,
     /*  32610 */     GIR_EraseRootFromParent_Done,
     /*  32611 */   // Label 531: @32611
     /*  32611 */   GIM_Try, /*On fail goto*//*Label 532*/ GIMT_Encode4(32674), // Rule ID 1772 //
     /*  32616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32631 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32635 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32640 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32644 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32648 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32652 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32657 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32659 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  32662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  32668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  32672 */     GIR_RootConstrainSelectedInstOperands,
     /*  32673 */     // GIR_Coverage, 1772,
     /*  32673 */     GIR_EraseRootFromParent_Done,
     /*  32674 */   // Label 532: @32674
     /*  32674 */   GIM_Try, /*On fail goto*//*Label 533*/ GIMT_Encode4(32737), // Rule ID 1771 //
     /*  32679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32694 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32698 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32703 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32707 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32711 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32715 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32720 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32722 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  32725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  32731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  32735 */     GIR_RootConstrainSelectedInstOperands,
     /*  32736 */     // GIR_Coverage, 1771,
     /*  32736 */     GIR_EraseRootFromParent_Done,
     /*  32737 */   // Label 533: @32737
     /*  32737 */   GIM_Try, /*On fail goto*//*Label 534*/ GIMT_Encode4(32798), // Rule ID 13116 //
     /*  32742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  32757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32761 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32765 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32770 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32779 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32781 */     // (add:{ *:[v8i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (SMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  32784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  32792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  32796 */     GIR_RootConstrainSelectedInstOperands,
     /*  32797 */     // GIR_Coverage, 13116,
     /*  32797 */     GIR_EraseRootFromParent_Done,
     /*  32798 */   // Label 534: @32798
     /*  32798 */   GIM_Try, /*On fail goto*//*Label 535*/ GIMT_Encode4(32859), // Rule ID 13146 //
     /*  32803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  32818 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32822 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32826 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32831 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32840 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32842 */     // (add:{ *:[v8i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (UMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  32845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  32853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  32857 */     GIR_RootConstrainSelectedInstOperands,
     /*  32858 */     // GIR_Coverage, 13146,
     /*  32858 */     GIR_EraseRootFromParent_Done,
     /*  32859 */   // Label 535: @32859
     /*  32859 */   GIM_Try, /*On fail goto*//*Label 536*/ GIMT_Encode4(32907), // Rule ID 13135 //
     /*  32864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32883 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32892 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32894 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  32897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32899 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  32901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  32905 */     GIR_RootConstrainSelectedInstOperands,
     /*  32906 */     // GIR_Coverage, 13135,
     /*  32906 */     GIR_EraseRootFromParent_Done,
     /*  32907 */   // Label 536: @32907
     /*  32907 */   GIM_Try, /*On fail goto*//*Label 537*/ GIMT_Encode4(32955), // Rule ID 13024 //
     /*  32912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  32927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  32931 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32940 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32942 */     // (add:{ *:[v8i16] } (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  32942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  32945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  32953 */     GIR_RootConstrainSelectedInstOperands,
     /*  32954 */     // GIR_Coverage, 13024,
     /*  32954 */     GIR_EraseRootFromParent_Done,
     /*  32955 */   // Label 537: @32955
     /*  32955 */   GIM_Try, /*On fail goto*//*Label 538*/ GIMT_Encode4(33003), // Rule ID 13110 //
     /*  32960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  32975 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32979 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32990 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (SADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  32993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  32997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  33001 */     GIR_RootConstrainSelectedInstOperands,
     /*  33002 */     // GIR_Coverage, 13110,
     /*  33002 */     GIR_EraseRootFromParent_Done,
     /*  33003 */   // Label 538: @33003
     /*  33003 */   GIM_Try, /*On fail goto*//*Label 539*/ GIMT_Encode4(33051), // Rule ID 13036 //
     /*  33008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  33023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33027 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33038 */     // (add:{ *:[v8i16] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  33038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  33041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33049 */     GIR_RootConstrainSelectedInstOperands,
     /*  33050 */     // GIR_Coverage, 13036,
     /*  33050 */     GIR_EraseRootFromParent_Done,
     /*  33051 */   // Label 539: @33051
     /*  33051 */   GIM_Try, /*On fail goto*//*Label 540*/ GIMT_Encode4(33099), // Rule ID 13134 //
     /*  33056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  33071 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33075 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33084 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33086 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  33086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  33089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  33093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  33097 */     GIR_RootConstrainSelectedInstOperands,
     /*  33098 */     // GIR_Coverage, 13134,
     /*  33098 */     GIR_EraseRootFromParent_Done,
     /*  33099 */   // Label 540: @33099
     /*  33099 */   GIM_Try, /*On fail goto*//*Label 541*/ GIMT_Encode4(33160), // Rule ID 1717 //
     /*  33104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  33123 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33127 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  33131 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33136 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33143 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  33143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  33146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33148 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  33158 */     GIR_RootConstrainSelectedInstOperands,
     /*  33159 */     // GIR_Coverage, 1717,
     /*  33159 */     GIR_EraseRootFromParent_Done,
     /*  33160 */   // Label 541: @33160
     /*  33160 */   GIM_Try, /*On fail goto*//*Label 542*/ GIMT_Encode4(33221), // Rule ID 1807 //
     /*  33165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33172 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  33184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33188 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  33192 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33197 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33202 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33204 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  33204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  33207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33209 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  33219 */     GIR_RootConstrainSelectedInstOperands,
     /*  33220 */     // GIR_Coverage, 1807,
     /*  33220 */     GIR_EraseRootFromParent_Done,
     /*  33221 */   // Label 542: @33221
     /*  33221 */   GIM_Try, /*On fail goto*//*Label 543*/ GIMT_Encode4(33269), // Rule ID 1796 //
     /*  33226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  33245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33249 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33256 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  33256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  33259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33261 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  33263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  33267 */     GIR_RootConstrainSelectedInstOperands,
     /*  33268 */     // GIR_Coverage, 1796,
     /*  33268 */     GIR_EraseRootFromParent_Done,
     /*  33269 */   // Label 543: @33269
     /*  33269 */   GIM_Try, /*On fail goto*//*Label 544*/ GIMT_Encode4(33317), // Rule ID 983 //
     /*  33274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  33293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33297 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33302 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33304 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  33304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  33307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33309 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33315 */     GIR_RootConstrainSelectedInstOperands,
     /*  33316 */     // GIR_Coverage, 983,
     /*  33316 */     GIR_EraseRootFromParent_Done,
     /*  33317 */   // Label 544: @33317
     /*  33317 */   GIM_Try, /*On fail goto*//*Label 545*/ GIMT_Encode4(33365), // Rule ID 1711 //
     /*  33322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33329 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  33341 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33345 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33350 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33352 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  33352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  33355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33357 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  33359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  33363 */     GIR_RootConstrainSelectedInstOperands,
     /*  33364 */     // GIR_Coverage, 1711,
     /*  33364 */     GIR_EraseRootFromParent_Done,
     /*  33365 */   // Label 545: @33365
     /*  33365 */   GIM_Try, /*On fail goto*//*Label 546*/ GIMT_Encode4(33413), // Rule ID 1044 //
     /*  33370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  33389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33393 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33398 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33400 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  33400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  33403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33405 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33411 */     GIR_RootConstrainSelectedInstOperands,
     /*  33412 */     // GIR_Coverage, 1044,
     /*  33412 */     GIR_EraseRootFromParent_Done,
     /*  33413 */   // Label 546: @33413
     /*  33413 */   GIM_Try, /*On fail goto*//*Label 547*/ GIMT_Encode4(33461), // Rule ID 1795 //
     /*  33418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33425 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  33437 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33441 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33446 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33448 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  33448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  33451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33453 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  33455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  33459 */     GIR_RootConstrainSelectedInstOperands,
     /*  33460 */     // GIR_Coverage, 1795,
     /*  33460 */     GIR_EraseRootFromParent_Done,
     /*  33461 */   // Label 547: @33461
     /*  33461 */   GIM_Try, /*On fail goto*//*Label 548*/ GIMT_Encode4(33488), // Rule ID 1096 //
     /*  33466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33473 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33481 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  33481 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv8i16),
     /*  33486 */     GIR_RootConstrainSelectedInstOperands,
     /*  33487 */     // GIR_Coverage, 1096,
     /*  33487 */     GIR_Done,
     /*  33488 */   // Label 548: @33488
     /*  33488 */   GIM_Reject,
     /*  33489 */ // Label 491: @33489
     /*  33489 */ GIM_Reject,
     /*  33490 */ // Label 163: @33490
     /*  33490 */ GIM_Try, /*On fail goto*//*Label 549*/ GIMT_Encode4(34213),
     /*  33495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33498 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  33501 */   GIM_Try, /*On fail goto*//*Label 550*/ GIMT_Encode4(33570), // Rule ID 13059 //
     /*  33506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33521 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33524 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  33529 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  33533 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  33537 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33542 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33553 */     // (add:{ *:[v16i8] } (intrinsic_wo_chain:{ *:[v16i8] } 659:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm), V128:{ *:[v16i8] }:$Rd)  =>  (SABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv16i8),
     /*  33556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33568 */     GIR_RootConstrainSelectedInstOperands,
     /*  33569 */     // GIR_Coverage, 13059,
     /*  33569 */     GIR_EraseRootFromParent_Done,
     /*  33570 */   // Label 550: @33570
     /*  33570 */   GIM_Try, /*On fail goto*//*Label 551*/ GIMT_Encode4(33639), // Rule ID 13071 //
     /*  33575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33590 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33593 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  33598 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  33602 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  33606 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33611 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33620 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33622 */     // (add:{ *:[v16i8] } (intrinsic_wo_chain:{ *:[v16i8] } 724:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm), V128:{ *:[v16i8] }:$Rd)  =>  (UABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv16i8),
     /*  33625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33637 */     GIR_RootConstrainSelectedInstOperands,
     /*  33638 */     // GIR_Coverage, 13071,
     /*  33638 */     GIR_EraseRootFromParent_Done,
     /*  33639 */   // Label 551: @33639
     /*  33639 */   GIM_Try, /*On fail goto*//*Label 552*/ GIMT_Encode4(33706), // Rule ID 13263 //
     /*  33644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  33659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33663 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33668 */     // MIs[1] imm
     /*  33668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  33676 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  33680 */     // MIs[2] Operand 1
     /*  33680 */     // No operand predicates
     /*  33680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33684 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  33688 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33690 */     // (add:{ *:[v16i8] } (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  33690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  33693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33701 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  33704 */     GIR_RootConstrainSelectedInstOperands,
     /*  33705 */     // GIR_Coverage, 13263,
     /*  33705 */     GIR_EraseRootFromParent_Done,
     /*  33706 */   // Label 552: @33706
     /*  33706 */   GIM_Try, /*On fail goto*//*Label 553*/ GIMT_Encode4(33773), // Rule ID 13284 //
     /*  33711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  33726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33730 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33735 */     // MIs[1] imm
     /*  33735 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33739 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  33743 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  33747 */     // MIs[2] Operand 1
     /*  33747 */     // No operand predicates
     /*  33747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33751 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  33755 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33757 */     // (add:{ *:[v16i8] } (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  33757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  33760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33762 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33768 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  33771 */     GIR_RootConstrainSelectedInstOperands,
     /*  33772 */     // GIR_Coverage, 13284,
     /*  33772 */     GIR_EraseRootFromParent_Done,
     /*  33773 */   // Label 553: @33773
     /*  33773 */   GIM_Try, /*On fail goto*//*Label 554*/ GIMT_Encode4(33842), // Rule ID 1352 //
     /*  33778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33797 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33800 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  33805 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  33809 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  33813 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33818 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33823 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33825 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (intrinsic_wo_chain:{ *:[v16i8] } 659:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))  =>  (SABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv16i8),
     /*  33828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33830 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33840 */     GIR_RootConstrainSelectedInstOperands,
     /*  33841 */     // GIR_Coverage, 1352,
     /*  33841 */     GIR_EraseRootFromParent_Done,
     /*  33842 */   // Label 554: @33842
     /*  33842 */   GIM_Try, /*On fail goto*//*Label 555*/ GIMT_Encode4(33911), // Rule ID 1475 //
     /*  33847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33866 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33869 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  33874 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  33878 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  33882 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33887 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33892 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33894 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (intrinsic_wo_chain:{ *:[v16i8] } 724:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))  =>  (UABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv16i8),
     /*  33897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33899 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33909 */     GIR_RootConstrainSelectedInstOperands,
     /*  33910 */     // GIR_Coverage, 1475,
     /*  33910 */     GIR_EraseRootFromParent_Done,
     /*  33911 */   // Label 555: @33911
     /*  33911 */   GIM_Try, /*On fail goto*//*Label 556*/ GIMT_Encode4(33978), // Rule ID 2223 //
     /*  33916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33923 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  33935 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33939 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33944 */     // MIs[1] imm
     /*  33944 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33948 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  33952 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  33956 */     // MIs[2] Operand 1
     /*  33956 */     // No operand predicates
     /*  33956 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  33960 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33962 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  33962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  33965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33967 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33973 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  33976 */     GIR_RootConstrainSelectedInstOperands,
     /*  33977 */     // GIR_Coverage, 2223,
     /*  33977 */     GIR_EraseRootFromParent_Done,
     /*  33978 */   // Label 556: @33978
     /*  33978 */   GIM_Try, /*On fail goto*//*Label 557*/ GIMT_Encode4(34045), // Rule ID 2282 //
     /*  33983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33990 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  34002 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34006 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34011 */     // MIs[1] imm
     /*  34011 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  34015 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  34019 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  34023 */     // MIs[2] Operand 1
     /*  34023 */     // No operand predicates
     /*  34023 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  34027 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34029 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  34029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  34032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34034 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  34036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34040 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  34043 */     GIR_RootConstrainSelectedInstOperands,
     /*  34044 */     // GIR_Coverage, 2282,
     /*  34044 */     GIR_EraseRootFromParent_Done,
     /*  34045 */   // Label 557: @34045
     /*  34045 */   GIM_Try, /*On fail goto*//*Label 558*/ GIMT_Encode4(34115), // Rule ID 6839 //
     /*  34050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /*  34062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34066 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  34070 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34075 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  34088 */     // MIs[2] Rn
     /*  34088 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  34093 */     // MIs[2] Rm
     /*  34093 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  34098 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34100 */     // (add:{ *:[v16i8] } (AArch64uzp1:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm), (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm))  =>  (ADDPv16i8:{ *:[v16i8] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm)
     /*  34100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  34103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34113 */     GIR_RootConstrainSelectedInstOperands,
     /*  34114 */     // GIR_Coverage, 6839,
     /*  34114 */     GIR_EraseRootFromParent_Done,
     /*  34115 */   // Label 558: @34115
     /*  34115 */   GIM_Try, /*On fail goto*//*Label 559*/ GIMT_Encode4(34185), // Rule ID 13658 //
     /*  34120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /*  34132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34136 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  34140 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34145 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34150 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34154 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /*  34158 */     // MIs[2] Rn
     /*  34158 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  34163 */     // MIs[2] Rm
     /*  34163 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  34168 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34170 */     // (add:{ *:[v16i8] } (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm), (AArch64uzp1:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm))  =>  (ADDPv16i8:{ *:[v16i8] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm)
     /*  34170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  34173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34183 */     GIR_RootConstrainSelectedInstOperands,
     /*  34184 */     // GIR_Coverage, 13658,
     /*  34184 */     GIR_EraseRootFromParent_Done,
     /*  34185 */   // Label 559: @34185
     /*  34185 */   GIM_Try, /*On fail goto*//*Label 560*/ GIMT_Encode4(34212), // Rule ID 1094 //
     /*  34190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34205 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  34205 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv16i8),
     /*  34210 */     GIR_RootConstrainSelectedInstOperands,
     /*  34211 */     // GIR_Coverage, 1094,
     /*  34211 */     GIR_Done,
     /*  34212 */   // Label 560: @34212
     /*  34212 */   GIM_Reject,
     /*  34213 */ // Label 549: @34213
     /*  34213 */ GIM_Reject,
     /*  34214 */ // Label 164: @34214
     /*  34214 */ GIM_Try, /*On fail goto*//*Label 561*/ GIMT_Encode4(34585),
     /*  34219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  34222 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  34225 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  34229 */   GIM_Try, /*On fail goto*//*Label 562*/ GIMT_Encode4(34291), // Rule ID 14842 //
     /*  34234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  34237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  34249 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  34253 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34257 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  34261 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  34265 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  34276 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34278 */     // (add:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  34278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  34281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  34283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  34285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  34289 */     GIR_RootConstrainSelectedInstOperands,
     /*  34290 */     // GIR_Coverage, 14842,
     /*  34290 */     GIR_EraseRootFromParent_Done,
     /*  34291 */   // Label 562: @34291
     /*  34291 */   GIM_Try, /*On fail goto*//*Label 563*/ GIMT_Encode4(34353), // Rule ID 14841 //
     /*  34296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  34299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34307 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  34311 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  34315 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  34319 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  34323 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  34327 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  34338 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34340 */     // (add:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  34340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  34343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  34345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  34347 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  34351 */     GIR_RootConstrainSelectedInstOperands,
     /*  34352 */     // GIR_Coverage, 14841,
     /*  34352 */     GIR_EraseRootFromParent_Done,
     /*  34353 */   // Label 563: @34353
     /*  34353 */   GIM_Try, /*On fail goto*//*Label 564*/ GIMT_Encode4(34415), // Rule ID 14840 //
     /*  34358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  34361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34369 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  34373 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  34377 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34381 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  34385 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  34389 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  34400 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34402 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  34402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  34405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  34407 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  34409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  34413 */     GIR_RootConstrainSelectedInstOperands,
     /*  34414 */     // GIR_Coverage, 14840,
     /*  34414 */     GIR_EraseRootFromParent_Done,
     /*  34415 */   // Label 564: @34415
     /*  34415 */   GIM_Try, /*On fail goto*//*Label 565*/ GIMT_Encode4(34477), // Rule ID 8738 //
     /*  34420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  34423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34431 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  34435 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  34439 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  34443 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  34447 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  34451 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  34462 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34464 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] })))  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  34464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  34467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  34469 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  34471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  34475 */     GIR_RootConstrainSelectedInstOperands,
     /*  34476 */     // GIR_Coverage, 8738,
     /*  34476 */     GIR_EraseRootFromParent_Done,
     /*  34477 */   // Label 565: @34477
     /*  34477 */   GIM_Try, /*On fail goto*//*Label 566*/ GIMT_Encode4(34523), // Rule ID 14843 //
     /*  34482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  34485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  34493 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  34497 */     // MIs[1] Operand 2
     /*  34497 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  34508 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34510 */     // (add:{ *:[nxv2i64] } (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i32:{ *:[Other] }), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (ADR_SXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  34510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_SXTW_ZZZ_D_0),
     /*  34513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  34515 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  34517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  34521 */     GIR_RootConstrainSelectedInstOperands,
     /*  34522 */     // GIR_Coverage, 14843,
     /*  34522 */     GIR_EraseRootFromParent_Done,
     /*  34523 */   // Label 566: @34523
     /*  34523 */   GIM_Try, /*On fail goto*//*Label 567*/ GIMT_Encode4(34569), // Rule ID 8739 //
     /*  34528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  34531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  34539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  34543 */     // MIs[1] Operand 2
     /*  34543 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  34554 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34556 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i32:{ *:[Other] }))  =>  (ADR_SXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  34556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_SXTW_ZZZ_D_0),
     /*  34559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  34561 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  34563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  34567 */     GIR_RootConstrainSelectedInstOperands,
     /*  34568 */     // GIR_Coverage, 8739,
     /*  34568 */     GIR_EraseRootFromParent_Done,
     /*  34569 */   // Label 567: @34569
     /*  34569 */   GIM_Try, /*On fail goto*//*Label 568*/ GIMT_Encode4(34584), // Rule ID 2766 //
     /*  34574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  34577 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  34577 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_D),
     /*  34582 */     GIR_RootConstrainSelectedInstOperands,
     /*  34583 */     // GIR_Coverage, 2766,
     /*  34583 */     GIR_Done,
     /*  34584 */   // Label 568: @34584
     /*  34584 */   GIM_Reject,
     /*  34585 */ // Label 561: @34585
     /*  34585 */ GIM_Reject,
     /*  34586 */ // Label 165: @34586
     /*  34586 */ GIM_Try, /*On fail goto*//*Label 569*/ GIMT_Encode4(34611), // Rule ID 2765 //
     /*  34591 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  34594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  34597 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  34600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  34604 */   // (add:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  34604 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_S),
     /*  34609 */   GIR_RootConstrainSelectedInstOperands,
     /*  34610 */   // GIR_Coverage, 2765,
     /*  34610 */   GIR_Done,
     /*  34611 */ // Label 569: @34611
     /*  34611 */ GIM_Reject,
     /*  34612 */ // Label 166: @34612
     /*  34612 */ GIM_Try, /*On fail goto*//*Label 570*/ GIMT_Encode4(34637), // Rule ID 2764 //
     /*  34617 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  34620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  34623 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  34626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  34630 */   // (add:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  34630 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_H),
     /*  34635 */   GIR_RootConstrainSelectedInstOperands,
     /*  34636 */   // GIR_Coverage, 2764,
     /*  34636 */   GIR_Done,
     /*  34637 */ // Label 570: @34637
     /*  34637 */ GIM_Reject,
     /*  34638 */ // Label 167: @34638
     /*  34638 */ GIM_Try, /*On fail goto*//*Label 571*/ GIMT_Encode4(34663), // Rule ID 2763 //
     /*  34643 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  34646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  34649 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  34652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  34656 */   // (add:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  34656 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_B),
     /*  34661 */   GIR_RootConstrainSelectedInstOperands,
     /*  34662 */   // GIR_Coverage, 2763,
     /*  34662 */   GIR_Done,
     /*  34663 */ // Label 571: @34663
     /*  34663 */ GIM_Reject,
     /*  34664 */ // Label 168: @34664
     /*  34664 */ GIM_Reject,
     /*  34665 */ // Label 1: @34665
     /*  34665 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 585*/ GIMT_Encode4(48012),
     /*  34676 */ /*GILLT_s32*//*Label 572*/ GIMT_Encode4(34764),
     /*  34680 */ /*GILLT_s64*//*Label 573*/ GIMT_Encode4(35618), GIMT_Encode4(0),
     /*  34688 */ /*GILLT_v2s32*//*Label 574*/ GIMT_Encode4(38648),
     /*  34692 */ /*GILLT_v2s64*//*Label 575*/ GIMT_Encode4(40139),
     /*  34696 */ /*GILLT_v4s16*//*Label 576*/ GIMT_Encode4(42599),
     /*  34700 */ /*GILLT_v4s32*//*Label 577*/ GIMT_Encode4(44090),
     /*  34704 */ /*GILLT_v8s8*//*Label 578*/ GIMT_Encode4(46550),
     /*  34708 */ /*GILLT_v8s16*//*Label 579*/ GIMT_Encode4(46625),
     /*  34712 */ /*GILLT_v16s8*//*Label 580*/ GIMT_Encode4(47833), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  34732 */ /*GILLT_nxv2s64*//*Label 581*/ GIMT_Encode4(47908), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  34744 */ /*GILLT_nxv4s32*//*Label 582*/ GIMT_Encode4(47934), GIMT_Encode4(0),
     /*  34752 */ /*GILLT_nxv8s16*//*Label 583*/ GIMT_Encode4(47960), GIMT_Encode4(0),
     /*  34760 */ /*GILLT_nxv16s8*//*Label 584*/ GIMT_Encode4(47986),
     /*  34764 */ // Label 572: @34764
     /*  34764 */ GIM_Try, /*On fail goto*//*Label 586*/ GIMT_Encode4(35617),
     /*  34769 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  34772 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  34775 */   GIM_Try, /*On fail goto*//*Label 587*/ GIMT_Encode4(34927), // Rule ID 9785 //
     /*  34780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  34783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  34787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  34791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  34799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  34803 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34807 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  34811 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  34814 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*  34819 */     // MIs[2] pattern
     /*  34819 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  34822 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  34827 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34829 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1238:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  34829 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  34832 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34836 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34841 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  34843 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  34846 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  34850 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34855 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  34858 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  34862 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  34865 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  34870 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  34875 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  34880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  34883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECB_XPiI),
     /*  34887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34892 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  34895 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  34899 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  34902 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  34904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34909 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  34916 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  34921 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  34926 */     // GIR_Coverage, 9785,
     /*  34926 */     GIR_EraseRootFromParent_Done,
     /*  34927 */   // Label 587: @34927
     /*  34927 */   GIM_Try, /*On fail goto*//*Label 588*/ GIMT_Encode4(35079), // Rule ID 9797 //
     /*  34932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  34935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  34939 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  34943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  34951 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  34955 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34959 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  34963 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  34966 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*  34971 */     // MIs[2] pattern
     /*  34971 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  34974 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  34979 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34981 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1240:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  34981 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  34984 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34988 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34993 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  34995 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  34998 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  35002 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35007 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  35010 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  35014 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  35017 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  35022 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  35027 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35032 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  35035 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECH_XPiI),
     /*  35039 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35044 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  35047 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  35051 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  35054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  35056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35061 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  35068 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35073 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  35078 */     // GIR_Coverage, 9797,
     /*  35078 */     GIR_EraseRootFromParent_Done,
     /*  35079 */   // Label 588: @35079
     /*  35079 */   GIM_Try, /*On fail goto*//*Label 589*/ GIMT_Encode4(35231), // Rule ID 9809 //
     /*  35084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  35087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  35103 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  35107 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35111 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  35115 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  35118 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*  35123 */     // MIs[2] pattern
     /*  35123 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  35126 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  35131 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35133 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1246:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  35133 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  35136 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35140 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35145 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  35147 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  35150 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  35154 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35159 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  35162 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  35166 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  35169 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  35174 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  35179 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35184 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  35187 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECW_XPiI),
     /*  35191 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35196 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  35199 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  35203 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  35206 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  35208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35213 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  35220 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35225 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  35230 */     // GIR_Coverage, 9809,
     /*  35230 */     GIR_EraseRootFromParent_Done,
     /*  35231 */   // Label 589: @35231
     /*  35231 */   GIM_Try, /*On fail goto*//*Label 590*/ GIMT_Encode4(35383), // Rule ID 9821 //
     /*  35236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  35239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  35255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  35259 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35263 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  35267 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  35270 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*  35275 */     // MIs[2] pattern
     /*  35275 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  35278 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  35283 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35285 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1239:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  35285 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  35288 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35292 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35297 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  35299 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  35302 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  35306 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35311 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  35314 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  35318 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  35321 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  35326 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  35331 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35336 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  35339 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECD_XPiI),
     /*  35343 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35348 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  35351 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  35355 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  35358 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  35360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35365 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  35372 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35377 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  35382 */     // GIR_Coverage, 9821,
     /*  35382 */     GIR_EraseRootFromParent_Done,
     /*  35383 */   // Label 590: @35383
     /*  35383 */   GIM_Try, /*On fail goto*//*Label 591*/ GIMT_Encode4(35445), // Rule ID 3895 //
     /*  35388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35392 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  35396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  35404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  35408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  35412 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35417 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35422 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35424 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm))  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  35424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
     /*  35427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35429 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  35437 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35443 */     GIR_RootConstrainSelectedInstOperands,
     /*  35444 */     // GIR_Coverage, 3895,
     /*  35444 */     GIR_EraseRootFromParent_Done,
     /*  35445 */   // Label 591: @35445
     /*  35445 */   GIM_Try, /*On fail goto*//*Label 592*/ GIMT_Encode4(35481), // Rule ID 3860 //
     /*  35450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  35458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
     /*  35465 */     // (sub:{ *:[i32] } GPR32sp:{ *:[i32] }:$R2, arith_extended_reg32_i32:{ *:[i32] }:$R3)  =>  (SUBSWrx:{ *:[i32] }:{ *:[i32] } GPR32sp:{ *:[i32] }:$R2, arith_extended_reg32_i32:{ *:[i32] }:$R3)
     /*  35465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrx),
     /*  35468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35470 */     GIR_RootToRootCopy, /*OpIdx*/1, // R2
     /*  35472 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // R3
     /*  35476 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  35479 */     GIR_RootConstrainSelectedInstOperands,
     /*  35480 */     // GIR_Coverage, 3860,
     /*  35480 */     GIR_EraseRootFromParent_Done,
     /*  35481 */   // Label 592: @35481
     /*  35481 */   GIM_Try, /*On fail goto*//*Label 593*/ GIMT_Encode4(35514), // Rule ID 3865 //
     /*  35486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  35490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
     /*  35501 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (ADDWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*  35501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
     /*  35504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35506 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  35508 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  35512 */     GIR_RootConstrainSelectedInstOperands,
     /*  35513 */     // GIR_Coverage, 3865,
     /*  35513 */     GIR_EraseRootFromParent_Done,
     /*  35514 */   // Label 593: @35514
     /*  35514 */   GIM_Try, /*On fail goto*//*Label 594*/ GIMT_Encode4(35550), // Rule ID 3854 //
     /*  35519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35523 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  35527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
     /*  35534 */     // (sub:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*  35534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
     /*  35537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35539 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  35541 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  35545 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  35548 */     GIR_RootConstrainSelectedInstOperands,
     /*  35549 */     // GIR_Coverage, 3854,
     /*  35549 */     GIR_EraseRootFromParent_Done,
     /*  35550 */   // Label 594: @35550
     /*  35550 */   GIM_Try, /*On fail goto*//*Label 595*/ GIMT_Encode4(35586), // Rule ID 3858 //
     /*  35555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
     /*  35570 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm)  =>  (SUBSWrs:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm)
     /*  35570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrs),
     /*  35573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35575 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  35577 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm
     /*  35581 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  35584 */     GIR_RootConstrainSelectedInstOperands,
     /*  35585 */     // GIR_Coverage, 3858,
     /*  35585 */     GIR_EraseRootFromParent_Done,
     /*  35586 */   // Label 595: @35586
     /*  35586 */   GIM_Try, /*On fail goto*//*Label 596*/ GIMT_Encode4(35616), // Rule ID 3856 //
     /*  35591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35595 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  35603 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SUBSWrr:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  35603 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrr),
     /*  35608 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AArch64::NZCV), GIMT_Encode2(RegState::Dead),
     /*  35614 */     GIR_RootConstrainSelectedInstOperands,
     /*  35615 */     // GIR_Coverage, 3856,
     /*  35615 */     GIR_Done,
     /*  35616 */   // Label 596: @35616
     /*  35616 */   GIM_Reject,
     /*  35617 */ // Label 586: @35617
     /*  35617 */ GIM_Reject,
     /*  35618 */ // Label 573: @35618
     /*  35618 */ GIM_Try, /*On fail goto*//*Label 597*/ GIMT_Encode4(38647),
     /*  35623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  35626 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  35629 */   GIM_Try, /*On fail goto*//*Label 598*/ GIMT_Encode4(35765), // Rule ID 5337 //
     /*  35634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  35646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  35658 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  35662 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35667 */     // MIs[1] Operand 2
     /*  35667 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  35678 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  35682 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  35686 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35690 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  35694 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  35698 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  35702 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35707 */     // MIs[3] Operand 2
     /*  35707 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  35718 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  35720 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  35720 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  35723 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  35727 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35732 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  35736 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  35740 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  35742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35747 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  35754 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35759 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35764 */     // GIR_Coverage, 5337,
     /*  35764 */     GIR_EraseRootFromParent_Done,
     /*  35765 */   // Label 598: @35765
     /*  35765 */   GIM_Try, /*On fail goto*//*Label 599*/ GIMT_Encode4(35901), // Rule ID 5336 //
     /*  35770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  35782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35786 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35790 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  35794 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  35798 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35803 */     // MIs[1] Operand 2
     /*  35803 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  35814 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  35818 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  35822 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35826 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  35830 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  35834 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  35838 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35843 */     // MIs[3] Operand 2
     /*  35843 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  35854 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  35856 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  35856 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  35859 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  35863 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35868 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  35872 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  35876 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  35878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35883 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  35890 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35895 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35900 */     // GIR_Coverage, 5336,
     /*  35900 */     GIR_EraseRootFromParent_Done,
     /*  35901 */   // Label 599: @35901
     /*  35901 */   GIM_Try, /*On fail goto*//*Label 600*/ GIMT_Encode4(36037), // Rule ID 5346 //
     /*  35906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  35918 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35922 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35926 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  35930 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  35934 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35939 */     // MIs[1] Operand 2
     /*  35939 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  35950 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  35954 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  35958 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35962 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  35966 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  35970 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  35974 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35979 */     // MIs[3] Operand 2
     /*  35979 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  35990 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  35992 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SSUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  35992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  35995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv2i32_v2i64),
     /*  35999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36004 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  36008 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  36012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  36017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36019 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  36026 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  36031 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36036 */     // GIR_Coverage, 5346,
     /*  36036 */     GIR_EraseRootFromParent_Done,
     /*  36037 */   // Label 600: @36037
     /*  36037 */   GIM_Try, /*On fail goto*//*Label 601*/ GIMT_Encode4(36173), // Rule ID 5335 //
     /*  36042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  36046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  36054 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  36058 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36062 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  36066 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  36070 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  36075 */     // MIs[1] Operand 2
     /*  36075 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  36086 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  36090 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  36094 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  36098 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  36102 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  36106 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  36110 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  36115 */     // MIs[3] Operand 2
     /*  36115 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  36126 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  36128 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  36128 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  36131 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  36135 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36140 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  36144 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  36148 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  36153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36155 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  36162 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  36167 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36172 */     // GIR_Coverage, 5335,
     /*  36172 */     GIR_EraseRootFromParent_Done,
     /*  36173 */   // Label 601: @36173
     /*  36173 */   GIM_Try, /*On fail goto*//*Label 602*/ GIMT_Encode4(36309), // Rule ID 5334 //
     /*  36178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  36182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  36190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  36194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36198 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  36202 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  36206 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  36211 */     // MIs[1] Operand 2
     /*  36211 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  36222 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  36226 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  36230 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  36234 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  36238 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  36242 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  36246 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  36251 */     // MIs[3] Operand 2
     /*  36251 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  36262 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  36264 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  36264 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  36267 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  36271 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36276 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  36280 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  36284 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  36289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36291 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  36298 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  36303 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36308 */     // GIR_Coverage, 5334,
     /*  36308 */     GIR_EraseRootFromParent_Done,
     /*  36309 */   // Label 602: @36309
     /*  36309 */   GIM_Try, /*On fail goto*//*Label 603*/ GIMT_Encode4(36446), // Rule ID 3912 //
     /*  36314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36318 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  36322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  36330 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36334 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  36338 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36342 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  36346 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36350 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36355 */     // MIs[2] Operand 2
     /*  36355 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  36366 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  36370 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  36374 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  36378 */     // MIs[3] Operand 1
     /*  36378 */     // No operand predicates
     /*  36378 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  36380 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  36380 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  36383 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  36387 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36392 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  36397 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  36399 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  36402 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  36406 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36411 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  36417 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36422 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  36430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  36432 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36435 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  36438 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36444 */     GIR_RootConstrainSelectedInstOperands,
     /*  36445 */     // GIR_Coverage, 3912,
     /*  36445 */     GIR_EraseRootFromParent_Done,
     /*  36446 */   // Label 603: @36446
     /*  36446 */   GIM_Try, /*On fail goto*//*Label 604*/ GIMT_Encode4(36545), // Rule ID 3910 //
     /*  36451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36455 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  36459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  36467 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36471 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  36475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  36483 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  36487 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36492 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  36496 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  36500 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  36504 */     // MIs[3] Operand 1
     /*  36504 */     // No operand predicates
     /*  36504 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  36506 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  36506 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  36509 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  36513 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36518 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  36523 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  36528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  36530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  36534 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36537 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36543 */     GIR_RootConstrainSelectedInstOperands,
     /*  36544 */     // GIR_Coverage, 3910,
     /*  36544 */     GIR_EraseRootFromParent_Done,
     /*  36545 */   // Label 604: @36545
     /*  36545 */   GIM_Try, /*On fail goto*//*Label 605*/ GIMT_Encode4(36644), // Rule ID 3911 //
     /*  36550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36554 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  36558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  36566 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36570 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  36574 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36578 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  36582 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  36586 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36591 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  36595 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  36599 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*  36603 */     // MIs[3] Operand 1
     /*  36603 */     // No operand predicates
     /*  36603 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  36605 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  36605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  36608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  36612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36617 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  36622 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  36627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  36629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  36633 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36636 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36642 */     GIR_RootConstrainSelectedInstOperands,
     /*  36643 */     // GIR_Coverage, 3911,
     /*  36643 */     GIR_EraseRootFromParent_Done,
     /*  36644 */   // Label 605: @36644
     /*  36644 */   GIM_Try, /*On fail goto*//*Label 606*/ GIMT_Encode4(36730), // Rule ID 3905 //
     /*  36649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36653 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  36657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  36665 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36669 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  36673 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36677 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  36681 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  36685 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36690 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  36694 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  36698 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  36702 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36707 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  36709 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  36709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  36712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  36714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  36718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  36722 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36728 */     GIR_RootConstrainSelectedInstOperands,
     /*  36729 */     // GIR_Coverage, 3905,
     /*  36729 */     GIR_EraseRootFromParent_Done,
     /*  36730 */   // Label 606: @36730
     /*  36730 */   GIM_Try, /*On fail goto*//*Label 607*/ GIMT_Encode4(36816), // Rule ID 3906 //
     /*  36735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36739 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  36743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  36751 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36755 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  36759 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36763 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  36767 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  36771 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36776 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  36780 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  36784 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  36788 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36793 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  36795 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  36795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  36798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  36800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  36804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  36808 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36814 */     GIR_RootConstrainSelectedInstOperands,
     /*  36815 */     // GIR_Coverage, 3906,
     /*  36815 */     GIR_EraseRootFromParent_Done,
     /*  36816 */   // Label 607: @36816
     /*  36816 */   GIM_Try, /*On fail goto*//*Label 608*/ GIMT_Encode4(36949), // Rule ID 3918 //
     /*  36821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  36837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36841 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  36845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  36853 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36857 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36862 */     // MIs[2] Operand 2
     /*  36862 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  36873 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  36877 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  36881 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  36885 */     // MIs[3] Operand 1
     /*  36885 */     // No operand predicates
     /*  36885 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  36887 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*  36887 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  36890 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  36894 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36899 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  36904 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  36906 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  36909 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  36913 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36918 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  36924 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36929 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  36937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  36939 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36942 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  36945 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  36947 */     GIR_RootConstrainSelectedInstOperands,
     /*  36948 */     // GIR_Coverage, 3918,
     /*  36948 */     GIR_EraseRootFromParent_Done,
     /*  36949 */   // Label 608: @36949
     /*  36949 */   GIM_Try, /*On fail goto*//*Label 609*/ GIMT_Encode4(37044), // Rule ID 3916 //
     /*  36954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36958 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  36970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36974 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  36978 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36982 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  36986 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  36990 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36995 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  36999 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  37003 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  37007 */     // MIs[3] Operand 1
     /*  37007 */     // No operand predicates
     /*  37007 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  37009 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*  37009 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  37012 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  37016 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37021 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  37026 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  37031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  37037 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  37040 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  37042 */     GIR_RootConstrainSelectedInstOperands,
     /*  37043 */     // GIR_Coverage, 3916,
     /*  37043 */     GIR_EraseRootFromParent_Done,
     /*  37044 */   // Label 609: @37044
     /*  37044 */   GIM_Try, /*On fail goto*//*Label 610*/ GIMT_Encode4(37139), // Rule ID 3917 //
     /*  37049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  37065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37069 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  37073 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37077 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  37081 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  37085 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37090 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  37094 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  37098 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*  37102 */     // MIs[3] Operand 1
     /*  37102 */     // No operand predicates
     /*  37102 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  37104 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*  37104 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  37107 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  37111 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37116 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  37121 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  37126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  37132 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  37135 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  37137 */     GIR_RootConstrainSelectedInstOperands,
     /*  37138 */     // GIR_Coverage, 3917,
     /*  37138 */     GIR_EraseRootFromParent_Done,
     /*  37139 */   // Label 610: @37139
     /*  37139 */   GIM_Try, /*On fail goto*//*Label 611*/ GIMT_Encode4(37221), // Rule ID 124 //
     /*  37144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37148 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  37160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37164 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  37168 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37172 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  37176 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  37180 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37185 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  37189 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  37193 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  37197 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37202 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  37204 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*  37204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  37207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  37213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  37217 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  37219 */     GIR_RootConstrainSelectedInstOperands,
     /*  37220 */     // GIR_Coverage, 124,
     /*  37220 */     GIR_EraseRootFromParent_Done,
     /*  37221 */   // Label 611: @37221
     /*  37221 */   GIM_Try, /*On fail goto*//*Label 612*/ GIMT_Encode4(37303), // Rule ID 126 //
     /*  37226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37230 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  37242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37246 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  37250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  37258 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  37262 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37267 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  37271 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  37275 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  37279 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37284 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  37286 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*  37286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  37289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  37295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  37299 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  37301 */     GIR_RootConstrainSelectedInstOperands,
     /*  37302 */     // GIR_Coverage, 126,
     /*  37302 */     GIR_EraseRootFromParent_Done,
     /*  37303 */   // Label 612: @37303
     /*  37303 */   GIM_Try, /*On fail goto*//*Label 613*/ GIMT_Encode4(37365), // Rule ID 3896 //
     /*  37308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37312 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  37316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  37324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37328 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  37332 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37337 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37344 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm))  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  37344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
     /*  37347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  37353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  37357 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37363 */     GIR_RootConstrainSelectedInstOperands,
     /*  37364 */     // GIR_Coverage, 3896,
     /*  37364 */     GIR_EraseRootFromParent_Done,
     /*  37365 */   // Label 613: @37365
     /*  37365 */   GIM_Try, /*On fail goto*//*Label 614*/ GIMT_Encode4(37423), // Rule ID 9782 //
     /*  37370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  37373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37389 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  37392 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*  37397 */     // MIs[1] pattern
     /*  37397 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  37400 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  37405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37407 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1238:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  37407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECB_XPiI),
     /*  37410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  37412 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  37414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  37418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  37421 */     GIR_RootConstrainSelectedInstOperands,
     /*  37422 */     // GIR_Coverage, 9782,
     /*  37422 */     GIR_EraseRootFromParent_Done,
     /*  37423 */   // Label 614: @37423
     /*  37423 */   GIM_Try, /*On fail goto*//*Label 615*/ GIMT_Encode4(37481), // Rule ID 9794 //
     /*  37428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  37431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37447 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  37450 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*  37455 */     // MIs[1] pattern
     /*  37455 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  37458 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  37463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37465 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1240:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  37465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECH_XPiI),
     /*  37468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  37470 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  37472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  37476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  37479 */     GIR_RootConstrainSelectedInstOperands,
     /*  37480 */     // GIR_Coverage, 9794,
     /*  37480 */     GIR_EraseRootFromParent_Done,
     /*  37481 */   // Label 615: @37481
     /*  37481 */   GIM_Try, /*On fail goto*//*Label 616*/ GIMT_Encode4(37539), // Rule ID 9806 //
     /*  37486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  37489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37505 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  37508 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*  37513 */     // MIs[1] pattern
     /*  37513 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  37516 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  37521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37523 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1246:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  37523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECW_XPiI),
     /*  37526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  37528 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  37530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  37534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  37537 */     GIR_RootConstrainSelectedInstOperands,
     /*  37538 */     // GIR_Coverage, 9806,
     /*  37538 */     GIR_EraseRootFromParent_Done,
     /*  37539 */   // Label 616: @37539
     /*  37539 */   GIM_Try, /*On fail goto*//*Label 617*/ GIMT_Encode4(37597), // Rule ID 9818 //
     /*  37544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  37547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37563 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  37566 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*  37571 */     // MIs[1] pattern
     /*  37571 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  37574 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  37579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37581 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1239:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  37581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECD_XPiI),
     /*  37584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  37586 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  37588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  37592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  37595 */     GIR_RootConstrainSelectedInstOperands,
     /*  37596 */     // GIR_Coverage, 9818,
     /*  37596 */     GIR_EraseRootFromParent_Done,
     /*  37597 */   // Label 617: @37597
     /*  37597 */   GIM_Try, /*On fail goto*//*Label 618*/ GIMT_Encode4(37760), // Rule ID 5301 //
     /*  37602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  37618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  37622 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37626 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  37630 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  37634 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37638 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37643 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37648 */     // MIs[1] Operand 2
     /*  37648 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  37659 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37661 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLSLv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  37661 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  37664 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37668 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37673 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37675 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  37678 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37682 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37687 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37690 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  37694 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  37697 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  37702 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  37707 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37712 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  37715 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_v2i64),
     /*  37719 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37724 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37727 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  37731 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  37735 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37742 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  37749 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37754 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  37759 */     // GIR_Coverage, 5301,
     /*  37759 */     GIR_EraseRootFromParent_Done,
     /*  37760 */   // Label 618: @37760
     /*  37760 */   GIM_Try, /*On fail goto*//*Label 619*/ GIMT_Encode4(37923), // Rule ID 5298 //
     /*  37765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  37781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  37785 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37789 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  37793 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  37797 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37801 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37806 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37811 */     // MIs[1] Operand 2
     /*  37811 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  37822 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37824 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLSLv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  37824 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  37827 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37831 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37836 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37838 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  37841 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37845 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37850 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37853 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  37857 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  37860 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  37865 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  37870 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37875 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  37878 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_v2i64),
     /*  37882 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37887 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37890 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  37894 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  37898 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37905 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  37912 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37917 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  37922 */     // GIR_Coverage, 5298,
     /*  37922 */     GIR_EraseRootFromParent_Done,
     /*  37923 */   // Label 619: @37923
     /*  37923 */   GIM_Try, /*On fail goto*//*Label 620*/ GIMT_Encode4(38073), // Rule ID 5343 //
     /*  37928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37932 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  37944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  37948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  37956 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  37960 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37965 */     // MIs[1] Operand 2
     /*  37965 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  37976 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37978 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  37978 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  37981 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37985 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37990 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37992 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  37995 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37999 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38004 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  38007 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  38011 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  38014 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38019 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38024 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38029 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38032 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  38036 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38041 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  38044 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  38048 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38055 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38062 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38067 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38072 */     // GIR_Coverage, 5343,
     /*  38072 */     GIR_EraseRootFromParent_Done,
     /*  38073 */   // Label 620: @38073
     /*  38073 */   GIM_Try, /*On fail goto*//*Label 621*/ GIMT_Encode4(38223), // Rule ID 5349 //
     /*  38078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38098 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38102 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  38106 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38110 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38115 */     // MIs[1] Operand 2
     /*  38115 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38126 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  38128 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SSUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38128 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  38131 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  38135 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38140 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  38142 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  38145 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  38149 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38154 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  38157 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  38161 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  38164 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38169 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38174 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38179 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38182 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv2i32_v2i64),
     /*  38186 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38191 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  38194 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  38198 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38205 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38212 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38217 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38222 */     // GIR_Coverage, 5349,
     /*  38222 */     GIR_EraseRootFromParent_Done,
     /*  38223 */   // Label 621: @38223
     /*  38223 */   GIM_Try, /*On fail goto*//*Label 622*/ GIMT_Encode4(38373), // Rule ID 5342 //
     /*  38228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38248 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38252 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38256 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38260 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38265 */     // MIs[1] Operand 2
     /*  38265 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38276 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  38278 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38278 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  38281 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  38285 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38290 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  38292 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  38295 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  38299 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38304 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  38307 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  38311 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  38314 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38319 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38324 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38329 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38332 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  38336 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38341 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  38344 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  38348 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38355 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38362 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38367 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38372 */     // GIR_Coverage, 5342,
     /*  38372 */     GIR_EraseRootFromParent_Done,
     /*  38373 */   // Label 622: @38373
     /*  38373 */   GIM_Try, /*On fail goto*//*Label 623*/ GIMT_Encode4(38409), // Rule ID 3861 //
     /*  38378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38382 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  38386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
     /*  38393 */     // (sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$R2, arith_extended_reg32to64_i64:{ *:[i64] }:$R3)  =>  (SUBSXrx:{ *:[i64] }:{ *:[i32] } GPR64sp:{ *:[i64] }:$R2, arith_extended_reg32to64_i64:{ *:[i64] }:$R3)
     /*  38393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrx),
     /*  38396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38398 */     GIR_RootToRootCopy, /*OpIdx*/1, // R2
     /*  38400 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // R3
     /*  38404 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  38407 */     GIR_RootConstrainSelectedInstOperands,
     /*  38408 */     // GIR_Coverage, 3861,
     /*  38408 */     GIR_EraseRootFromParent_Done,
     /*  38409 */   // Label 623: @38409
     /*  38409 */   GIM_Try, /*On fail goto*//*Label 624*/ GIMT_Encode4(38442), // Rule ID 3866 //
     /*  38414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  38418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
     /*  38429 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (ADDXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  38429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
     /*  38432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38434 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  38436 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  38440 */     GIR_RootConstrainSelectedInstOperands,
     /*  38441 */     // GIR_Coverage, 3866,
     /*  38441 */     GIR_EraseRootFromParent_Done,
     /*  38442 */   // Label 624: @38442
     /*  38442 */   GIM_Try, /*On fail goto*//*Label 625*/ GIMT_Encode4(38478), // Rule ID 3855 //
     /*  38447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  38455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
     /*  38462 */     // (sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  38462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
     /*  38465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38467 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  38469 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  38473 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  38476 */     GIR_RootConstrainSelectedInstOperands,
     /*  38477 */     // GIR_Coverage, 3855,
     /*  38477 */     GIR_EraseRootFromParent_Done,
     /*  38478 */   // Label 625: @38478
     /*  38478 */   GIM_Try, /*On fail goto*//*Label 626*/ GIMT_Encode4(38514), // Rule ID 3859 //
     /*  38483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
     /*  38498 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm)  =>  (SUBSXrs:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm)
     /*  38498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrs),
     /*  38501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38503 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  38505 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm
     /*  38509 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  38512 */     GIR_RootConstrainSelectedInstOperands,
     /*  38513 */     // GIR_Coverage, 3859,
     /*  38513 */     GIR_EraseRootFromParent_Done,
     /*  38514 */   // Label 626: @38514
     /*  38514 */   GIM_Try, /*On fail goto*//*Label 627*/ GIMT_Encode4(38553), // Rule ID 1648 //
     /*  38519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38530 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38536 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  38538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38542 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  38544 */     // (sub:{ *:[v1i64] } immAllZerosV:{ *:[v1i64] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (NEGv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /*  38544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv1i64),
     /*  38547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  38551 */     GIR_RootConstrainSelectedInstOperands,
     /*  38552 */     // GIR_Coverage, 1648,
     /*  38552 */     GIR_EraseRootFromParent_Done,
     /*  38553 */   // Label 627: @38553
     /*  38553 */   GIM_Try, /*On fail goto*//*Label 628*/ GIMT_Encode4(38589), // Rule ID 5184 //
     /*  38558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38566 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38572 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  38574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38578 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  38580 */     // (sub:{ *:[i64] } immAllZerosV:{ *:[i64] }, FPR64:{ *:[i64] }:$Rn)  =>  (NEGv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /*  38580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv1i64),
     /*  38583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  38587 */     GIR_RootConstrainSelectedInstOperands,
     /*  38588 */     // GIR_Coverage, 5184,
     /*  38588 */     GIR_EraseRootFromParent_Done,
     /*  38589 */   // Label 628: @38589
     /*  38589 */   GIM_Try, /*On fail goto*//*Label 629*/ GIMT_Encode4(38616), // Rule ID 1637 //
     /*  38594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38609 */     // (sub:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /*  38609 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv1i64),
     /*  38614 */     GIR_RootConstrainSelectedInstOperands,
     /*  38615 */     // GIR_Coverage, 1637,
     /*  38615 */     GIR_Done,
     /*  38616 */   // Label 629: @38616
     /*  38616 */   GIM_Try, /*On fail goto*//*Label 630*/ GIMT_Encode4(38646), // Rule ID 3857 //
     /*  38621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38633 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SUBSXrr:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  38633 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrr),
     /*  38638 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AArch64::NZCV), GIMT_Encode2(RegState::Dead),
     /*  38644 */     GIR_RootConstrainSelectedInstOperands,
     /*  38645 */     // GIR_Coverage, 3857,
     /*  38645 */     GIR_Done,
     /*  38646 */   // Label 630: @38646
     /*  38646 */   GIM_Reject,
     /*  38647 */ // Label 597: @38647
     /*  38647 */ GIM_Reject,
     /*  38648 */ // Label 574: @38648
     /*  38648 */ GIM_Try, /*On fail goto*//*Label 631*/ GIMT_Encode4(40138),
     /*  38653 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38656 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  38659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38663 */   GIM_Try, /*On fail goto*//*Label 632*/ GIMT_Encode4(38795), // Rule ID 5333 //
     /*  38668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38676 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38680 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38684 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38688 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  38692 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38697 */     // MIs[1] Operand 2
     /*  38697 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38708 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38712 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38716 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38720 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38724 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38728 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  38732 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38737 */     // MIs[3] Operand 2
     /*  38737 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38748 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38750 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  38750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  38753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  38757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38762 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38766 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38770 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38777 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38784 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38789 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38794 */     // GIR_Coverage, 5333,
     /*  38794 */     GIR_EraseRootFromParent_Done,
     /*  38795 */   // Label 632: @38795
     /*  38795 */   GIM_Try, /*On fail goto*//*Label 633*/ GIMT_Encode4(38927), // Rule ID 5332 //
     /*  38800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38812 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38816 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38820 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  38824 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38829 */     // MIs[1] Operand 2
     /*  38829 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38840 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38844 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38848 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38852 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38856 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38860 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  38864 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38869 */     // MIs[3] Operand 2
     /*  38869 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38880 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38882 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  38882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  38885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  38889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38894 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38898 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38902 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38909 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38916 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38921 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38926 */     // GIR_Coverage, 5332,
     /*  38926 */     GIR_EraseRootFromParent_Done,
     /*  38927 */   // Label 633: @38927
     /*  38927 */   GIM_Try, /*On fail goto*//*Label 634*/ GIMT_Encode4(39059), // Rule ID 5345 //
     /*  38932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38940 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38944 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38948 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  38952 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  38956 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38961 */     // MIs[1] Operand 2
     /*  38961 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38972 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38976 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38980 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38984 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38988 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  38992 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  38996 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39001 */     // MIs[3] Operand 2
     /*  39001 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  39012 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  39014 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SSUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  39014 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  39017 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i16_v4i32),
     /*  39021 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39026 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39030 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  39034 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39041 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  39048 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39053 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39058 */     // GIR_Coverage, 5345,
     /*  39058 */     GIR_EraseRootFromParent_Done,
     /*  39059 */   // Label 634: @39059
     /*  39059 */   GIM_Try, /*On fail goto*//*Label 635*/ GIMT_Encode4(39191), // Rule ID 5331 //
     /*  39064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  39072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39076 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39080 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39084 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  39088 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39093 */     // MIs[1] Operand 2
     /*  39093 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  39104 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  39108 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  39112 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39116 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  39120 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  39124 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  39128 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39133 */     // MIs[3] Operand 2
     /*  39133 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  39144 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  39146 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  39146 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  39149 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  39153 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39158 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39162 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  39166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39173 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  39180 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39185 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39190 */     // GIR_Coverage, 5331,
     /*  39190 */     GIR_EraseRootFromParent_Done,
     /*  39191 */   // Label 635: @39191
     /*  39191 */   GIM_Try, /*On fail goto*//*Label 636*/ GIMT_Encode4(39323), // Rule ID 5330 //
     /*  39196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  39204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39208 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39212 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39216 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  39220 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39225 */     // MIs[1] Operand 2
     /*  39225 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  39236 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  39240 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  39244 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39248 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  39252 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39256 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  39260 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39265 */     // MIs[3] Operand 2
     /*  39265 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  39276 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  39278 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  39278 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  39281 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  39285 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39290 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39294 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  39298 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39305 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  39312 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39317 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39322 */     // GIR_Coverage, 5330,
     /*  39322 */     GIR_EraseRootFromParent_Done,
     /*  39323 */   // Label 636: @39323
     /*  39323 */   GIM_Try, /*On fail goto*//*Label 637*/ GIMT_Encode4(39482), // Rule ID 5300 //
     /*  39328 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  39340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  39352 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  39356 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  39360 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39365 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39370 */     // MIs[1] Operand 2
     /*  39370 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  39381 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  39383 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLSLv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  39383 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  39386 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  39390 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  39397 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  39400 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  39404 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39409 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  39412 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  39416 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  39419 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39424 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39429 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39434 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  39437 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_v4i32),
     /*  39441 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39446 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  39449 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39453 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  39457 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39464 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  39471 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39476 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39481 */     // GIR_Coverage, 5300,
     /*  39481 */     GIR_EraseRootFromParent_Done,
     /*  39482 */   // Label 637: @39482
     /*  39482 */   GIM_Try, /*On fail goto*//*Label 638*/ GIMT_Encode4(39641), // Rule ID 5297 //
     /*  39487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  39499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39503 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39507 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  39511 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  39515 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  39519 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39524 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39529 */     // MIs[1] Operand 2
     /*  39529 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  39540 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  39542 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLSLv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  39542 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  39545 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  39549 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39554 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  39556 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  39559 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  39563 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39568 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  39571 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  39575 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  39578 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39583 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39588 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39593 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  39596 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_v4i32),
     /*  39600 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39605 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  39608 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39612 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  39616 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39623 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  39630 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39635 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39640 */     // GIR_Coverage, 5297,
     /*  39640 */     GIR_EraseRootFromParent_Done,
     /*  39641 */   // Label 638: @39641
     /*  39641 */   GIM_Try, /*On fail goto*//*Label 639*/ GIMT_Encode4(39787), // Rule ID 5341 //
     /*  39646 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  39658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39662 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39666 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  39670 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  39674 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39679 */     // MIs[1] Operand 2
     /*  39679 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  39690 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  39692 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  39692 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  39695 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  39699 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39704 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  39706 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  39709 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  39713 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39718 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  39721 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  39725 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  39728 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39733 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39738 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39743 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  39746 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  39750 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39755 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  39758 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  39762 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39769 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  39776 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39781 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39786 */     // GIR_Coverage, 5341,
     /*  39786 */     GIR_EraseRootFromParent_Done,
     /*  39787 */   // Label 639: @39787
     /*  39787 */   GIM_Try, /*On fail goto*//*Label 640*/ GIMT_Encode4(39933), // Rule ID 5348 //
     /*  39792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  39804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39816 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  39820 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39825 */     // MIs[1] Operand 2
     /*  39825 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  39836 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  39838 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SSUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  39838 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  39841 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  39845 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39850 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  39852 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  39855 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  39859 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39864 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  39867 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  39871 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  39874 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39879 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39884 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39889 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  39892 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i16_v4i32),
     /*  39896 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39901 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  39904 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  39908 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39915 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  39922 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39927 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39932 */     // GIR_Coverage, 5348,
     /*  39932 */     GIR_EraseRootFromParent_Done,
     /*  39933 */   // Label 640: @39933
     /*  39933 */   GIM_Try, /*On fail goto*//*Label 641*/ GIMT_Encode4(40079), // Rule ID 5340 //
     /*  39938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  39950 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39954 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39958 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39962 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  39966 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39971 */     // MIs[1] Operand 2
     /*  39971 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  39982 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  39984 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  39984 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  39987 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  39991 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39996 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  39998 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  40001 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40005 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40010 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40013 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  40017 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  40020 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40025 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40030 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40035 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  40038 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  40042 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40047 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40050 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  40054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40061 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  40068 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40073 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40078 */     // GIR_Coverage, 5340,
     /*  40078 */     GIR_EraseRootFromParent_Done,
     /*  40079 */   // Label 641: @40079
     /*  40079 */   GIM_Try, /*On fail goto*//*Label 642*/ GIMT_Encode4(40114), // Rule ID 962 //
     /*  40084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  40087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40091 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40097 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  40099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40105 */     // (sub:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn)  =>  (NEGv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /*  40105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv2i32),
     /*  40108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40110 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  40112 */     GIR_RootConstrainSelectedInstOperands,
     /*  40113 */     // GIR_Coverage, 962,
     /*  40113 */     GIR_EraseRootFromParent_Done,
     /*  40114 */   // Label 642: @40114
     /*  40114 */   GIM_Try, /*On fail goto*//*Label 643*/ GIMT_Encode4(40137), // Rule ID 1469 //
     /*  40119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  40122 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40130 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  40130 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv2i32),
     /*  40135 */     GIR_RootConstrainSelectedInstOperands,
     /*  40136 */     // GIR_Coverage, 1469,
     /*  40136 */     GIR_Done,
     /*  40137 */   // Label 643: @40137
     /*  40137 */   GIM_Reject,
     /*  40138 */ // Label 631: @40138
     /*  40138 */ GIM_Reject,
     /*  40139 */ // Label 575: @40139
     /*  40139 */ GIM_Try, /*On fail goto*//*Label 644*/ GIMT_Encode4(42598),
     /*  40144 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  40147 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  40150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40154 */   GIM_Try, /*On fail goto*//*Label 645*/ GIMT_Encode4(40268), // Rule ID 2041 //
     /*  40159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  40162 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  40174 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40178 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40182 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  40186 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40190 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40194 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  40198 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  40202 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40206 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  40210 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40215 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  40219 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  40223 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  40227 */     // MIs[4] Operand 1
     /*  40227 */     // No operand predicates
     /*  40227 */     // MIs[2] Operand 2
     /*  40227 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  40238 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  40240 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  40247 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  40247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_indexed),
     /*  40250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40252 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  40254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  40259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  40263 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  40266 */     GIR_RootConstrainSelectedInstOperands,
     /*  40267 */     // GIR_Coverage, 2041,
     /*  40267 */     GIR_EraseRootFromParent_Done,
     /*  40268 */   // Label 645: @40268
     /*  40268 */   GIM_Try, /*On fail goto*//*Label 646*/ GIMT_Encode4(40382), // Rule ID 13211 //
     /*  40273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  40276 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  40288 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40292 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40296 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40300 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40304 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40308 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  40312 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  40316 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40320 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  40324 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40329 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  40333 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  40337 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  40341 */     // MIs[4] Operand 1
     /*  40341 */     // No operand predicates
     /*  40341 */     // MIs[2] Operand 2
     /*  40341 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  40352 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  40354 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  40361 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (SMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  40361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_indexed),
     /*  40364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40366 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  40368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  40373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  40377 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  40380 */     GIR_RootConstrainSelectedInstOperands,
     /*  40381 */     // GIR_Coverage, 13211,
     /*  40381 */     GIR_EraseRootFromParent_Done,
     /*  40382 */   // Label 646: @40382
     /*  40382 */   GIM_Try, /*On fail goto*//*Label 647*/ GIMT_Encode4(40496), // Rule ID 2093 //
     /*  40387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  40390 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  40402 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40406 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40410 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  40414 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40418 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40422 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  40426 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  40430 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40434 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  40438 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40443 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  40447 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  40451 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  40455 */     // MIs[4] Operand 1
     /*  40455 */     // No operand predicates
     /*  40455 */     // MIs[2] Operand 2
     /*  40455 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  40466 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  40468 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  40475 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (UMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  40475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_indexed),
     /*  40478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40480 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  40482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  40487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  40491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  40494 */     GIR_RootConstrainSelectedInstOperands,
     /*  40495 */     // GIR_Coverage, 2093,
     /*  40495 */     GIR_EraseRootFromParent_Done,
     /*  40496 */   // Label 647: @40496
     /*  40496 */   GIM_Try, /*On fail goto*//*Label 648*/ GIMT_Encode4(40610), // Rule ID 13241 //
     /*  40501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  40504 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  40516 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40520 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40524 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40528 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40532 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40536 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  40540 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  40544 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40548 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  40552 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40557 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  40561 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  40565 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  40569 */     // MIs[4] Operand 1
     /*  40569 */     // No operand predicates
     /*  40569 */     // MIs[2] Operand 2
     /*  40569 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  40580 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  40582 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  40589 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (UMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  40589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_indexed),
     /*  40592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40594 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  40596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  40601 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  40605 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  40608 */     GIR_RootConstrainSelectedInstOperands,
     /*  40609 */     // GIR_Coverage, 13241,
     /*  40609 */     GIR_EraseRootFromParent_Done,
     /*  40610 */   // Label 648: @40610
     /*  40610 */   GIM_Try, /*On fail goto*//*Label 649*/ GIMT_Encode4(40675), // Rule ID 1848 //
     /*  40615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  40618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  40626 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40630 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  40634 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  40638 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40642 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40644 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  40651 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  40658 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  40658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  40661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  40668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  40673 */     GIR_RootConstrainSelectedInstOperands,
     /*  40674 */     // GIR_Coverage, 1848,
     /*  40674 */     GIR_EraseRootFromParent_Done,
     /*  40675 */   // Label 649: @40675
     /*  40675 */   GIM_Try, /*On fail goto*//*Label 650*/ GIMT_Encode4(40740), // Rule ID 1847 //
     /*  40680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  40683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  40691 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  40699 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  40703 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40707 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40709 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  40716 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  40723 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  40723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  40726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  40733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  40738 */     GIR_RootConstrainSelectedInstOperands,
     /*  40739 */     // GIR_Coverage, 1847,
     /*  40739 */     GIR_EraseRootFromParent_Done,
     /*  40740 */   // Label 650: @40740
     /*  40740 */   GIM_Try, /*On fail goto*//*Label 651*/ GIMT_Encode4(40805), // Rule ID 1752 //
     /*  40745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  40748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  40756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40760 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  40764 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  40768 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40772 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40774 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  40781 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  40788 */     // (sub:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SSUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  40788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i32_v2i64),
     /*  40791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  40798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  40803 */     GIR_RootConstrainSelectedInstOperands,
     /*  40804 */     // GIR_Coverage, 1752,
     /*  40804 */     GIR_EraseRootFromParent_Done,
     /*  40805 */   // Label 651: @40805
     /*  40805 */   GIM_Try, /*On fail goto*//*Label 652*/ GIMT_Encode4(40870), // Rule ID 1846 //
     /*  40810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  40813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  40821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  40829 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  40833 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40837 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40839 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  40846 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  40853 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  40853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  40856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  40863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  40868 */     GIR_RootConstrainSelectedInstOperands,
     /*  40869 */     // GIR_Coverage, 1846,
     /*  40869 */     GIR_EraseRootFromParent_Done,
     /*  40870 */   // Label 652: @40870
     /*  40870 */   GIM_Try, /*On fail goto*//*Label 653*/ GIMT_Encode4(40935), // Rule ID 1845 //
     /*  40875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  40878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  40886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40890 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  40894 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  40898 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40902 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40904 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  40911 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  40918 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  40918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  40921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  40928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  40933 */     GIR_RootConstrainSelectedInstOperands,
     /*  40934 */     // GIR_Coverage, 1845,
     /*  40934 */     GIR_EraseRootFromParent_Done,
     /*  40935 */   // Label 653: @40935
     /*  40935 */   GIM_Try, /*On fail goto*//*Label 654*/ GIMT_Encode4(41046), // Rule ID 13209 //
     /*  40940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  40943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  40955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40959 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40963 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40967 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40971 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40975 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  40979 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  40983 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40987 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  40991 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40996 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  41000 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  41004 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  41008 */     // MIs[4] Operand 1
     /*  41008 */     // No operand predicates
     /*  41008 */     // MIs[2] Operand 2
     /*  41008 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  41019 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41024 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41026 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  41026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  41029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41031 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  41033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  41037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  41041 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  41044 */     GIR_RootConstrainSelectedInstOperands,
     /*  41045 */     // GIR_Coverage, 13209,
     /*  41045 */     GIR_EraseRootFromParent_Done,
     /*  41046 */   // Label 654: @41046
     /*  41046 */   GIM_Try, /*On fail goto*//*Label 655*/ GIMT_Encode4(41157), // Rule ID 2039 //
     /*  41051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41054 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  41066 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41070 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  41074 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41079 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  41083 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41087 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41091 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  41095 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  41099 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41103 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  41107 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41112 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  41116 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  41120 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  41124 */     // MIs[4] Operand 1
     /*  41124 */     // No operand predicates
     /*  41124 */     // MIs[2] Operand 2
     /*  41124 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  41135 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41137 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  41137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  41140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41142 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  41144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  41148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  41152 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  41155 */     GIR_RootConstrainSelectedInstOperands,
     /*  41156 */     // GIR_Coverage, 2039,
     /*  41156 */     GIR_EraseRootFromParent_Done,
     /*  41157 */   // Label 655: @41157
     /*  41157 */   GIM_Try, /*On fail goto*//*Label 656*/ GIMT_Encode4(41268), // Rule ID 13239 //
     /*  41162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41165 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  41177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41181 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  41185 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41189 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41193 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41197 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  41201 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  41205 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41209 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  41213 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41218 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  41222 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  41226 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  41230 */     // MIs[4] Operand 1
     /*  41230 */     // No operand predicates
     /*  41230 */     // MIs[2] Operand 2
     /*  41230 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  41241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41246 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41248 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  41248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  41251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41253 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  41255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  41259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  41263 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  41266 */     GIR_RootConstrainSelectedInstOperands,
     /*  41267 */     // GIR_Coverage, 13239,
     /*  41267 */     GIR_EraseRootFromParent_Done,
     /*  41268 */   // Label 656: @41268
     /*  41268 */   GIM_Try, /*On fail goto*//*Label 657*/ GIMT_Encode4(41379), // Rule ID 2091 //
     /*  41273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41276 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  41288 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41292 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  41296 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41301 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  41305 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41309 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41313 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  41317 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  41321 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41325 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  41329 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41334 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  41338 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  41342 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  41346 */     // MIs[4] Operand 1
     /*  41346 */     // No operand predicates
     /*  41346 */     // MIs[2] Operand 2
     /*  41346 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  41357 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41359 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  41359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  41362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41364 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  41366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  41370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  41374 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  41377 */     GIR_RootConstrainSelectedInstOperands,
     /*  41378 */     // GIR_Coverage, 2091,
     /*  41378 */     GIR_EraseRootFromParent_Done,
     /*  41379 */   // Label 657: @41379
     /*  41379 */   GIM_Try, /*On fail goto*//*Label 658*/ GIMT_Encode4(41442), // Rule ID 1728 //
     /*  41384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41387 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  41399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41403 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  41407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41409 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  41416 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  41423 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  41423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_v2i64),
     /*  41426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41428 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  41430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  41435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  41440 */     GIR_RootConstrainSelectedInstOperands,
     /*  41441 */     // GIR_Coverage, 1728,
     /*  41441 */     GIR_EraseRootFromParent_Done,
     /*  41442 */   // Label 658: @41442
     /*  41442 */   GIM_Try, /*On fail goto*//*Label 659*/ GIMT_Encode4(41505), // Rule ID 1818 //
     /*  41447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  41462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41466 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  41470 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41472 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  41479 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  41486 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  41486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_v2i64),
     /*  41489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41491 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  41493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  41498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  41503 */     GIR_RootConstrainSelectedInstOperands,
     /*  41504 */     // GIR_Coverage, 1818,
     /*  41504 */     GIR_EraseRootFromParent_Done,
     /*  41505 */   // Label 659: @41505
     /*  41505 */   GIM_Try, /*On fail goto*//*Label 660*/ GIMT_Encode4(41593), // Rule ID 13210 //
     /*  41510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  41525 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41529 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  41533 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41537 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  41541 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41545 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  41549 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41554 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  41558 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  41562 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  41566 */     // MIs[3] Operand 1
     /*  41566 */     // No operand predicates
     /*  41566 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41571 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  41573 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  41573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  41576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41578 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  41580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  41584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  41588 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  41591 */     GIR_RootConstrainSelectedInstOperands,
     /*  41592 */     // GIR_Coverage, 13210,
     /*  41592 */     GIR_EraseRootFromParent_Done,
     /*  41593 */   // Label 660: @41593
     /*  41593 */   GIM_Try, /*On fail goto*//*Label 661*/ GIMT_Encode4(41681), // Rule ID 2040 //
     /*  41598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  41613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41617 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  41621 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41626 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  41630 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  41634 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41638 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  41642 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41647 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  41651 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  41655 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  41659 */     // MIs[3] Operand 1
     /*  41659 */     // No operand predicates
     /*  41659 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  41661 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  41661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  41664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41666 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  41668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  41672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  41676 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  41679 */     GIR_RootConstrainSelectedInstOperands,
     /*  41680 */     // GIR_Coverage, 2040,
     /*  41680 */     GIR_EraseRootFromParent_Done,
     /*  41681 */   // Label 661: @41681
     /*  41681 */   GIM_Try, /*On fail goto*//*Label 662*/ GIMT_Encode4(41769), // Rule ID 13240 //
     /*  41686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  41701 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41705 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  41709 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41713 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  41717 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41721 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  41725 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41730 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  41734 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  41738 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  41742 */     // MIs[3] Operand 1
     /*  41742 */     // No operand predicates
     /*  41742 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41747 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  41749 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  41749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  41752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41754 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  41756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  41760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  41764 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  41767 */     GIR_RootConstrainSelectedInstOperands,
     /*  41768 */     // GIR_Coverage, 13240,
     /*  41768 */     GIR_EraseRootFromParent_Done,
     /*  41769 */   // Label 662: @41769
     /*  41769 */   GIM_Try, /*On fail goto*//*Label 663*/ GIMT_Encode4(41857), // Rule ID 2092 //
     /*  41774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41777 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  41789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41793 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  41797 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  41806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  41810 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41814 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  41818 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41823 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  41827 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  41831 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  41835 */     // MIs[3] Operand 1
     /*  41835 */     // No operand predicates
     /*  41835 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  41837 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  41837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  41840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41842 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  41844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  41848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  41852 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  41855 */     GIR_RootConstrainSelectedInstOperands,
     /*  41856 */     // GIR_Coverage, 2092,
     /*  41856 */     GIR_EraseRootFromParent_Done,
     /*  41857 */   // Label 663: @41857
     /*  41857 */   GIM_Try, /*On fail goto*//*Label 664*/ GIMT_Encode4(41904), // Rule ID 1860 //
     /*  41862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41865 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  41877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41883 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  41890 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  41890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i32_v2i64),
     /*  41893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41895 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  41897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  41902 */     GIR_RootConstrainSelectedInstOperands,
     /*  41903 */     // GIR_Coverage, 1860,
     /*  41903 */     GIR_EraseRootFromParent_Done,
     /*  41904 */   // Label 664: @41904
     /*  41904 */   GIM_Try, /*On fail goto*//*Label 665*/ GIMT_Encode4(41951), // Rule ID 1758 //
     /*  41909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  41924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41928 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41930 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  41937 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SSUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  41937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i32_v2i64),
     /*  41940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41942 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  41944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  41949 */     GIR_RootConstrainSelectedInstOperands,
     /*  41950 */     // GIR_Coverage, 1758,
     /*  41950 */     GIR_EraseRootFromParent_Done,
     /*  41951 */   // Label 665: @41951
     /*  41951 */   GIM_Try, /*On fail goto*//*Label 666*/ GIMT_Encode4(41998), // Rule ID 1859 //
     /*  41956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41959 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  41971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41977 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  41984 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  41984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i32_v2i64),
     /*  41987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41989 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  41991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  41996 */     GIR_RootConstrainSelectedInstOperands,
     /*  41997 */     // GIR_Coverage, 1859,
     /*  41997 */     GIR_EraseRootFromParent_Done,
     /*  41998 */   // Label 666: @41998
     /*  41998 */   GIM_Try, /*On fail goto*//*Label 667*/ GIMT_Encode4(42057), // Rule ID 1844 //
     /*  42003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  42014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42018 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42023 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  42027 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  42031 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42035 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42040 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42042 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  42042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  42045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  42051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  42055 */     GIR_RootConstrainSelectedInstOperands,
     /*  42056 */     // GIR_Coverage, 1844,
     /*  42056 */     GIR_EraseRootFromParent_Done,
     /*  42057 */   // Label 667: @42057
     /*  42057 */   GIM_Try, /*On fail goto*//*Label 668*/ GIMT_Encode4(42116), // Rule ID 1843 //
     /*  42062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  42073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42082 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  42086 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  42090 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42094 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42099 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42101 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  42101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  42104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  42110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  42114 */     GIR_RootConstrainSelectedInstOperands,
     /*  42115 */     // GIR_Coverage, 1843,
     /*  42115 */     GIR_EraseRootFromParent_Done,
     /*  42116 */   // Label 668: @42116
     /*  42116 */   GIM_Try, /*On fail goto*//*Label 669*/ GIMT_Encode4(42175), // Rule ID 1751 //
     /*  42121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  42132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42136 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42141 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  42145 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  42149 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42153 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42158 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42160 */     // (sub:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SSUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  42160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv2i32_v2i64),
     /*  42163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  42169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  42173 */     GIR_RootConstrainSelectedInstOperands,
     /*  42174 */     // GIR_Coverage, 1751,
     /*  42174 */     GIR_EraseRootFromParent_Done,
     /*  42175 */   // Label 669: @42175
     /*  42175 */   GIM_Try, /*On fail goto*//*Label 670*/ GIMT_Encode4(42234), // Rule ID 1842 //
     /*  42180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  42191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42195 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42200 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  42204 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  42208 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42212 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42217 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42219 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  42219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  42222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  42228 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  42232 */     GIR_RootConstrainSelectedInstOperands,
     /*  42233 */     // GIR_Coverage, 1842,
     /*  42233 */     GIR_EraseRootFromParent_Done,
     /*  42234 */   // Label 670: @42234
     /*  42234 */   GIM_Try, /*On fail goto*//*Label 671*/ GIMT_Encode4(42293), // Rule ID 1841 //
     /*  42239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  42250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42254 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42259 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  42263 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  42267 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42271 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42276 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42278 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  42278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  42281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  42287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  42291 */     GIR_RootConstrainSelectedInstOperands,
     /*  42292 */     // GIR_Coverage, 1841,
     /*  42292 */     GIR_EraseRootFromParent_Done,
     /*  42293 */   // Label 671: @42293
     /*  42293 */   GIM_Try, /*On fail goto*//*Label 672*/ GIMT_Encode4(42328), // Rule ID 964 //
     /*  42298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42305 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42311 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  42313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42319 */     // (sub:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn)  =>  (NEGv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /*  42319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv2i64),
     /*  42322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  42326 */     GIR_RootConstrainSelectedInstOperands,
     /*  42327 */     // GIR_Coverage, 964,
     /*  42327 */     GIR_EraseRootFromParent_Done,
     /*  42328 */   // Label 672: @42328
     /*  42328 */   GIM_Try, /*On fail goto*//*Label 673*/ GIMT_Encode4(42385), // Rule ID 1727 //
     /*  42333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  42348 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42352 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  42356 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42361 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42366 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42368 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  42368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_v2i64),
     /*  42371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42373 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  42375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  42379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  42383 */     GIR_RootConstrainSelectedInstOperands,
     /*  42384 */     // GIR_Coverage, 1727,
     /*  42384 */     GIR_EraseRootFromParent_Done,
     /*  42385 */   // Label 673: @42385
     /*  42385 */   GIM_Try, /*On fail goto*//*Label 674*/ GIMT_Encode4(42442), // Rule ID 1817 //
     /*  42390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  42405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42409 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  42413 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42418 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42425 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  42425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_v2i64),
     /*  42428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42430 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  42432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  42436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  42440 */     GIR_RootConstrainSelectedInstOperands,
     /*  42441 */     // GIR_Coverage, 1817,
     /*  42441 */     GIR_EraseRootFromParent_Done,
     /*  42442 */   // Label 674: @42442
     /*  42442 */   GIM_Try, /*On fail goto*//*Label 675*/ GIMT_Encode4(42486), // Rule ID 1858 //
     /*  42447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  42462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42466 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42473 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  42473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  42476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42478 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  42480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  42484 */     GIR_RootConstrainSelectedInstOperands,
     /*  42485 */     // GIR_Coverage, 1858,
     /*  42485 */     GIR_EraseRootFromParent_Done,
     /*  42486 */   // Label 675: @42486
     /*  42486 */   GIM_Try, /*On fail goto*//*Label 676*/ GIMT_Encode4(42530), // Rule ID 1757 //
     /*  42491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  42506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42510 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42517 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SSUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  42517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv2i32_v2i64),
     /*  42520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42522 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  42524 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  42528 */     GIR_RootConstrainSelectedInstOperands,
     /*  42529 */     // GIR_Coverage, 1757,
     /*  42529 */     GIR_EraseRootFromParent_Done,
     /*  42530 */   // Label 676: @42530
     /*  42530 */   GIM_Try, /*On fail goto*//*Label 677*/ GIMT_Encode4(42574), // Rule ID 1857 //
     /*  42535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42538 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  42550 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42554 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42561 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  42561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  42564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42566 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  42568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  42572 */     GIR_RootConstrainSelectedInstOperands,
     /*  42573 */     // GIR_Coverage, 1857,
     /*  42573 */     GIR_EraseRootFromParent_Done,
     /*  42574 */   // Label 677: @42574
     /*  42574 */   GIM_Try, /*On fail goto*//*Label 678*/ GIMT_Encode4(42597), // Rule ID 1471 //
     /*  42579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42590 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  42590 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv2i64),
     /*  42595 */     GIR_RootConstrainSelectedInstOperands,
     /*  42596 */     // GIR_Coverage, 1471,
     /*  42596 */     GIR_Done,
     /*  42597 */   // Label 678: @42597
     /*  42597 */   GIM_Reject,
     /*  42598 */ // Label 644: @42598
     /*  42598 */ GIM_Reject,
     /*  42599 */ // Label 576: @42599
     /*  42599 */ GIM_Try, /*On fail goto*//*Label 679*/ GIMT_Encode4(44089),
     /*  42604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42607 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  42610 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42614 */   GIM_Try, /*On fail goto*//*Label 680*/ GIMT_Encode4(42746), // Rule ID 5329 //
     /*  42619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  42631 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42635 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  42639 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  42643 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42648 */     // MIs[1] Operand 2
     /*  42648 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42659 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  42663 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42667 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  42671 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  42675 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  42679 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  42683 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42688 */     // MIs[3] Operand 2
     /*  42688 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  42699 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  42701 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  42701 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  42704 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  42708 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42713 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  42717 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  42721 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42728 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42735 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42740 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42745 */     // GIR_Coverage, 5329,
     /*  42745 */     GIR_EraseRootFromParent_Done,
     /*  42746 */   // Label 680: @42746
     /*  42746 */   GIM_Try, /*On fail goto*//*Label 681*/ GIMT_Encode4(42878), // Rule ID 5328 //
     /*  42751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  42763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  42771 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  42775 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42780 */     // MIs[1] Operand 2
     /*  42780 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42791 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  42795 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42799 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  42803 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  42807 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  42811 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  42815 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42820 */     // MIs[3] Operand 2
     /*  42820 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  42831 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  42833 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  42833 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  42836 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  42840 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42845 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  42849 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  42853 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42860 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42867 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42872 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42877 */     // GIR_Coverage, 5328,
     /*  42877 */     GIR_EraseRootFromParent_Done,
     /*  42878 */   // Label 681: @42878
     /*  42878 */   GIM_Try, /*On fail goto*//*Label 682*/ GIMT_Encode4(43010), // Rule ID 5344 //
     /*  42883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  42895 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42899 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  42903 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  42907 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42912 */     // MIs[1] Operand 2
     /*  42912 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42923 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  42927 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42931 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  42935 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  42939 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  42943 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  42947 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42952 */     // MIs[3] Operand 2
     /*  42952 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  42963 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  42965 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SSUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  42965 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  42968 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i8_v8i16),
     /*  42972 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42977 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  42981 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  42985 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42992 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42999 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43004 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43009 */     // GIR_Coverage, 5344,
     /*  43009 */     GIR_EraseRootFromParent_Done,
     /*  43010 */   // Label 682: @43010
     /*  43010 */   GIM_Try, /*On fail goto*//*Label 683*/ GIMT_Encode4(43142), // Rule ID 5327 //
     /*  43015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  43027 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43031 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43035 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  43039 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43044 */     // MIs[1] Operand 2
     /*  43044 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  43055 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  43059 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43063 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  43067 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  43071 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  43075 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  43079 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43084 */     // MIs[3] Operand 2
     /*  43084 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  43095 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43097 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  43097 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  43100 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  43104 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43109 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  43113 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  43117 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43124 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  43131 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43136 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43141 */     // GIR_Coverage, 5327,
     /*  43141 */     GIR_EraseRootFromParent_Done,
     /*  43142 */   // Label 683: @43142
     /*  43142 */   GIM_Try, /*On fail goto*//*Label 684*/ GIMT_Encode4(43274), // Rule ID 5326 //
     /*  43147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  43159 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43163 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43167 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  43171 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43176 */     // MIs[1] Operand 2
     /*  43176 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  43187 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  43191 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43195 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  43199 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  43203 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43207 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  43211 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43216 */     // MIs[3] Operand 2
     /*  43216 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  43227 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43229 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  43229 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  43232 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  43236 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43241 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  43245 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  43249 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43256 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  43263 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43268 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43273 */     // GIR_Coverage, 5326,
     /*  43273 */     GIR_EraseRootFromParent_Done,
     /*  43274 */   // Label 684: @43274
     /*  43274 */   GIM_Try, /*On fail goto*//*Label 685*/ GIMT_Encode4(43433), // Rule ID 5299 //
     /*  43279 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  43295 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43299 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  43303 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  43307 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  43311 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43316 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43321 */     // MIs[1] Operand 2
     /*  43321 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  43332 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43334 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLSLv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  43334 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  43337 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43341 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43346 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  43348 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  43351 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  43355 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43360 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  43363 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  43367 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  43370 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43375 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43380 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43385 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  43388 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i8_v8i16),
     /*  43392 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43397 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  43400 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  43404 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  43408 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43415 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  43422 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43427 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43432 */     // GIR_Coverage, 5299,
     /*  43432 */     GIR_EraseRootFromParent_Done,
     /*  43433 */   // Label 685: @43433
     /*  43433 */   GIM_Try, /*On fail goto*//*Label 686*/ GIMT_Encode4(43592), // Rule ID 5296 //
     /*  43438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  43454 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43458 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  43462 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  43466 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  43470 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43475 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43480 */     // MIs[1] Operand 2
     /*  43480 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  43491 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43493 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLSLv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  43493 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  43496 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43500 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43505 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  43507 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  43510 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  43514 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43519 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  43522 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  43526 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  43529 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43534 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43539 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43544 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  43547 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i8_v8i16),
     /*  43551 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43556 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  43559 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  43563 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  43567 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43574 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  43581 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43586 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43591 */     // GIR_Coverage, 5296,
     /*  43591 */     GIR_EraseRootFromParent_Done,
     /*  43592 */   // Label 686: @43592
     /*  43592 */   GIM_Try, /*On fail goto*//*Label 687*/ GIMT_Encode4(43738), // Rule ID 5339 //
     /*  43597 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  43613 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43617 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  43621 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  43625 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43630 */     // MIs[1] Operand 2
     /*  43630 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  43641 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43643 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  43643 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  43646 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43650 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43655 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  43657 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  43660 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  43664 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43669 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  43672 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  43676 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  43679 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43684 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43689 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43694 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  43697 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  43701 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43706 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  43709 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  43713 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43720 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  43727 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43732 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43737 */     // GIR_Coverage, 5339,
     /*  43737 */     GIR_EraseRootFromParent_Done,
     /*  43738 */   // Label 687: @43738
     /*  43738 */   GIM_Try, /*On fail goto*//*Label 688*/ GIMT_Encode4(43884), // Rule ID 5347 //
     /*  43743 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  43759 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43763 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  43767 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  43771 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43776 */     // MIs[1] Operand 2
     /*  43776 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  43787 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43789 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SSUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  43789 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  43792 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43796 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43801 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  43803 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  43806 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  43810 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43815 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  43818 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  43822 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  43825 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43830 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43835 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43840 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  43843 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i8_v8i16),
     /*  43847 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43852 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  43855 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  43859 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43866 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  43873 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43878 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43883 */     // GIR_Coverage, 5347,
     /*  43883 */     GIR_EraseRootFromParent_Done,
     /*  43884 */   // Label 688: @43884
     /*  43884 */   GIM_Try, /*On fail goto*//*Label 689*/ GIMT_Encode4(44030), // Rule ID 5338 //
     /*  43889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43901 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  43905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43913 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  43917 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43922 */     // MIs[1] Operand 2
     /*  43922 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  43933 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43935 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  43935 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  43938 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43942 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43947 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  43949 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  43952 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  43956 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43961 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  43964 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  43968 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  43971 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43976 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43981 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43986 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  43989 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  43993 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43998 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  44001 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44005 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  44007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44012 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  44019 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44024 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44029 */     // GIR_Coverage, 5338,
     /*  44029 */     GIR_EraseRootFromParent_Done,
     /*  44030 */   // Label 689: @44030
     /*  44030 */   GIM_Try, /*On fail goto*//*Label 690*/ GIMT_Encode4(44065), // Rule ID 960 //
     /*  44035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44042 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44048 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  44050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44054 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44056 */     // (sub:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn)  =>  (NEGv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /*  44056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv4i16),
     /*  44059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  44063 */     GIR_RootConstrainSelectedInstOperands,
     /*  44064 */     // GIR_Coverage, 960,
     /*  44064 */     GIR_EraseRootFromParent_Done,
     /*  44065 */   // Label 690: @44065
     /*  44065 */   GIM_Try, /*On fail goto*//*Label 691*/ GIMT_Encode4(44088), // Rule ID 1467 //
     /*  44070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44081 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  44081 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv4i16),
     /*  44086 */     GIR_RootConstrainSelectedInstOperands,
     /*  44087 */     // GIR_Coverage, 1467,
     /*  44087 */     GIR_Done,
     /*  44088 */   // Label 691: @44088
     /*  44088 */   GIM_Reject,
     /*  44089 */ // Label 679: @44089
     /*  44089 */ GIM_Reject,
     /*  44090 */ // Label 577: @44090
     /*  44090 */ GIM_Try, /*On fail goto*//*Label 692*/ GIMT_Encode4(46549),
     /*  44095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44098 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44105 */   GIM_Try, /*On fail goto*//*Label 693*/ GIMT_Encode4(44219), // Rule ID 2038 //
     /*  44110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  44129 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  44133 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  44137 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  44141 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  44145 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  44149 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  44153 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  44157 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  44161 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  44166 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  44170 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44174 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  44178 */     // MIs[4] Operand 1
     /*  44178 */     // No operand predicates
     /*  44178 */     // MIs[2] Operand 2
     /*  44178 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  44189 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  44191 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  44198 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_indexed),
     /*  44201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44203 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  44214 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  44217 */     GIR_RootConstrainSelectedInstOperands,
     /*  44218 */     // GIR_Coverage, 2038,
     /*  44218 */     GIR_EraseRootFromParent_Done,
     /*  44219 */   // Label 693: @44219
     /*  44219 */   GIM_Try, /*On fail goto*//*Label 694*/ GIMT_Encode4(44333), // Rule ID 13208 //
     /*  44224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44227 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  44243 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  44247 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44251 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  44255 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  44259 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  44263 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  44267 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  44271 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  44275 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  44280 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  44284 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44288 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  44292 */     // MIs[4] Operand 1
     /*  44292 */     // No operand predicates
     /*  44292 */     // MIs[2] Operand 2
     /*  44292 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  44303 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  44305 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  44312 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (SMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_indexed),
     /*  44315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44317 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  44328 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  44331 */     GIR_RootConstrainSelectedInstOperands,
     /*  44332 */     // GIR_Coverage, 13208,
     /*  44332 */     GIR_EraseRootFromParent_Done,
     /*  44333 */   // Label 694: @44333
     /*  44333 */   GIM_Try, /*On fail goto*//*Label 695*/ GIMT_Encode4(44447), // Rule ID 2090 //
     /*  44338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44341 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  44353 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  44357 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  44361 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  44365 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  44369 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  44373 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  44377 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  44381 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  44385 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  44389 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  44394 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  44398 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44402 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  44406 */     // MIs[4] Operand 1
     /*  44406 */     // No operand predicates
     /*  44406 */     // MIs[2] Operand 2
     /*  44406 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  44417 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  44419 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  44426 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (UMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_indexed),
     /*  44429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44431 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  44442 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  44445 */     GIR_RootConstrainSelectedInstOperands,
     /*  44446 */     // GIR_Coverage, 2090,
     /*  44446 */     GIR_EraseRootFromParent_Done,
     /*  44447 */   // Label 695: @44447
     /*  44447 */   GIM_Try, /*On fail goto*//*Label 696*/ GIMT_Encode4(44561), // Rule ID 13238 //
     /*  44452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44455 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  44467 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  44471 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  44475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  44483 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  44487 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  44491 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  44495 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  44499 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  44503 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  44508 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  44512 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44516 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  44520 */     // MIs[4] Operand 1
     /*  44520 */     // No operand predicates
     /*  44520 */     // MIs[2] Operand 2
     /*  44520 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  44531 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  44533 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  44540 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (UMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_indexed),
     /*  44543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44545 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  44556 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  44559 */     GIR_RootConstrainSelectedInstOperands,
     /*  44560 */     // GIR_Coverage, 13238,
     /*  44560 */     GIR_EraseRootFromParent_Done,
     /*  44561 */   // Label 696: @44561
     /*  44561 */   GIM_Try, /*On fail goto*//*Label 697*/ GIMT_Encode4(44626), // Rule ID 1840 //
     /*  44566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44577 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  44581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44589 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  44593 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44595 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  44602 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  44609 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  44609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  44612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  44624 */     GIR_RootConstrainSelectedInstOperands,
     /*  44625 */     // GIR_Coverage, 1840,
     /*  44625 */     GIR_EraseRootFromParent_Done,
     /*  44626 */   // Label 697: @44626
     /*  44626 */   GIM_Try, /*On fail goto*//*Label 698*/ GIMT_Encode4(44691), // Rule ID 1839 //
     /*  44631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  44646 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44650 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44654 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  44658 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44660 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  44667 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  44674 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  44674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  44677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  44689 */     GIR_RootConstrainSelectedInstOperands,
     /*  44690 */     // GIR_Coverage, 1839,
     /*  44690 */     GIR_EraseRootFromParent_Done,
     /*  44691 */   // Label 698: @44691
     /*  44691 */   GIM_Try, /*On fail goto*//*Label 699*/ GIMT_Encode4(44756), // Rule ID 1750 //
     /*  44696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  44707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  44711 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44715 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  44719 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  44723 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44725 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  44732 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  44739 */     // (sub:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SSUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  44739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i16_v4i32),
     /*  44742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  44754 */     GIR_RootConstrainSelectedInstOperands,
     /*  44755 */     // GIR_Coverage, 1750,
     /*  44755 */     GIR_EraseRootFromParent_Done,
     /*  44756 */   // Label 699: @44756
     /*  44756 */   GIM_Try, /*On fail goto*//*Label 700*/ GIMT_Encode4(44821), // Rule ID 1838 //
     /*  44761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  44776 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44780 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44784 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  44788 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44790 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  44797 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  44804 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  44804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  44807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  44819 */     GIR_RootConstrainSelectedInstOperands,
     /*  44820 */     // GIR_Coverage, 1838,
     /*  44820 */     GIR_EraseRootFromParent_Done,
     /*  44821 */   // Label 700: @44821
     /*  44821 */   GIM_Try, /*On fail goto*//*Label 701*/ GIMT_Encode4(44886), // Rule ID 1837 //
     /*  44826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  44841 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44845 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44849 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  44853 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44855 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  44862 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  44869 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  44869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  44872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  44884 */     GIR_RootConstrainSelectedInstOperands,
     /*  44885 */     // GIR_Coverage, 1837,
     /*  44885 */     GIR_EraseRootFromParent_Done,
     /*  44886 */   // Label 701: @44886
     /*  44886 */   GIM_Try, /*On fail goto*//*Label 702*/ GIMT_Encode4(44997), // Rule ID 13206 //
     /*  44891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  44910 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  44914 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44918 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  44922 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  44926 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  44930 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  44934 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  44938 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  44942 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  44947 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  44951 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44955 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  44959 */     // MIs[4] Operand 1
     /*  44959 */     // No operand predicates
     /*  44959 */     // MIs[2] Operand 2
     /*  44959 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  44970 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44975 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  44977 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  44980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44982 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  44988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  44992 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  44995 */     GIR_RootConstrainSelectedInstOperands,
     /*  44996 */     // GIR_Coverage, 13206,
     /*  44996 */     GIR_EraseRootFromParent_Done,
     /*  44997 */   // Label 702: @44997
     /*  44997 */   GIM_Try, /*On fail goto*//*Label 703*/ GIMT_Encode4(45108), // Rule ID 2036 //
     /*  45002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  45017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45021 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45025 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45030 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  45034 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45038 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45042 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  45046 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  45050 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45054 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  45058 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  45063 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  45067 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45071 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  45075 */     // MIs[4] Operand 1
     /*  45075 */     // No operand predicates
     /*  45075 */     // MIs[2] Operand 2
     /*  45075 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  45086 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45088 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  45088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  45091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45093 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  45099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  45103 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  45106 */     GIR_RootConstrainSelectedInstOperands,
     /*  45107 */     // GIR_Coverage, 2036,
     /*  45107 */     GIR_EraseRootFromParent_Done,
     /*  45108 */   // Label 703: @45108
     /*  45108 */   GIM_Try, /*On fail goto*//*Label 704*/ GIMT_Encode4(45219), // Rule ID 13236 //
     /*  45113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45116 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  45128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45132 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45136 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45140 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45144 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45148 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  45152 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  45156 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45160 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  45164 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  45169 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  45173 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45177 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  45181 */     // MIs[4] Operand 1
     /*  45181 */     // No operand predicates
     /*  45181 */     // MIs[2] Operand 2
     /*  45181 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  45192 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45197 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45199 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  45199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  45202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45204 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  45210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  45214 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  45217 */     GIR_RootConstrainSelectedInstOperands,
     /*  45218 */     // GIR_Coverage, 13236,
     /*  45218 */     GIR_EraseRootFromParent_Done,
     /*  45219 */   // Label 704: @45219
     /*  45219 */   GIM_Try, /*On fail goto*//*Label 705*/ GIMT_Encode4(45330), // Rule ID 2088 //
     /*  45224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45227 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  45239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45243 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45247 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45252 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  45256 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45260 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45264 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  45268 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  45272 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45276 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  45280 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  45285 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  45289 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45293 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  45297 */     // MIs[4] Operand 1
     /*  45297 */     // No operand predicates
     /*  45297 */     // MIs[2] Operand 2
     /*  45297 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  45308 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45310 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  45310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  45313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45315 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  45321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  45325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  45328 */     GIR_RootConstrainSelectedInstOperands,
     /*  45329 */     // GIR_Coverage, 2088,
     /*  45329 */     GIR_EraseRootFromParent_Done,
     /*  45330 */   // Label 705: @45330
     /*  45330 */   GIM_Try, /*On fail goto*//*Label 706*/ GIMT_Encode4(45393), // Rule ID 1726 //
     /*  45335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  45350 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45354 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45360 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  45367 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  45374 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  45374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_v4i32),
     /*  45377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45379 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  45386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  45391 */     GIR_RootConstrainSelectedInstOperands,
     /*  45392 */     // GIR_Coverage, 1726,
     /*  45392 */     GIR_EraseRootFromParent_Done,
     /*  45393 */   // Label 706: @45393
     /*  45393 */   GIM_Try, /*On fail goto*//*Label 707*/ GIMT_Encode4(45456), // Rule ID 1816 //
     /*  45398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  45413 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45417 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45423 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  45430 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  45437 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  45437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_v4i32),
     /*  45440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45442 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  45449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  45454 */     GIR_RootConstrainSelectedInstOperands,
     /*  45455 */     // GIR_Coverage, 1816,
     /*  45455 */     GIR_EraseRootFromParent_Done,
     /*  45456 */   // Label 707: @45456
     /*  45456 */   GIM_Try, /*On fail goto*//*Label 708*/ GIMT_Encode4(45544), // Rule ID 13207 //
     /*  45461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  45476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45480 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  45492 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45496 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  45500 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  45505 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45509 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45513 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  45517 */     // MIs[3] Operand 1
     /*  45517 */     // No operand predicates
     /*  45517 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45522 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  45524 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  45524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  45527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45529 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  45535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  45539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  45542 */     GIR_RootConstrainSelectedInstOperands,
     /*  45543 */     // GIR_Coverage, 13207,
     /*  45543 */     GIR_EraseRootFromParent_Done,
     /*  45544 */   // Label 708: @45544
     /*  45544 */   GIM_Try, /*On fail goto*//*Label 709*/ GIMT_Encode4(45632), // Rule ID 2037 //
     /*  45549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45552 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  45564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45568 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45572 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  45581 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  45585 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45589 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  45593 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  45598 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45602 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45606 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  45610 */     // MIs[3] Operand 1
     /*  45610 */     // No operand predicates
     /*  45610 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  45612 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  45612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  45615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45617 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  45623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  45627 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  45630 */     GIR_RootConstrainSelectedInstOperands,
     /*  45631 */     // GIR_Coverage, 2037,
     /*  45631 */     GIR_EraseRootFromParent_Done,
     /*  45632 */   // Label 709: @45632
     /*  45632 */   GIM_Try, /*On fail goto*//*Label 710*/ GIMT_Encode4(45720), // Rule ID 13237 //
     /*  45637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  45652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45656 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45660 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45664 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  45668 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45672 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  45676 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  45681 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45685 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45689 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  45693 */     // MIs[3] Operand 1
     /*  45693 */     // No operand predicates
     /*  45693 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45698 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  45700 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  45700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  45703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45705 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  45711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  45715 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  45718 */     GIR_RootConstrainSelectedInstOperands,
     /*  45719 */     // GIR_Coverage, 13237,
     /*  45719 */     GIR_EraseRootFromParent_Done,
     /*  45720 */   // Label 710: @45720
     /*  45720 */   GIM_Try, /*On fail goto*//*Label 711*/ GIMT_Encode4(45808), // Rule ID 2089 //
     /*  45725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45728 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  45740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45744 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45748 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45753 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  45757 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  45761 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45765 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  45769 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  45774 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45778 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45782 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  45786 */     // MIs[3] Operand 1
     /*  45786 */     // No operand predicates
     /*  45786 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  45788 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  45788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  45791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45793 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  45799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  45803 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  45806 */     GIR_RootConstrainSelectedInstOperands,
     /*  45807 */     // GIR_Coverage, 2089,
     /*  45807 */     GIR_EraseRootFromParent_Done,
     /*  45808 */   // Label 711: @45808
     /*  45808 */   GIM_Try, /*On fail goto*//*Label 712*/ GIMT_Encode4(45855), // Rule ID 1856 //
     /*  45813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45828 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45832 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45834 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  45841 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  45841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i16_v4i32),
     /*  45844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45846 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  45848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  45853 */     GIR_RootConstrainSelectedInstOperands,
     /*  45854 */     // GIR_Coverage, 1856,
     /*  45854 */     GIR_EraseRootFromParent_Done,
     /*  45855 */   // Label 712: @45855
     /*  45855 */   GIM_Try, /*On fail goto*//*Label 713*/ GIMT_Encode4(45902), // Rule ID 1756 //
     /*  45860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45863 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  45875 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45881 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  45888 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SSUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  45888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i16_v4i32),
     /*  45891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45893 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  45895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  45900 */     GIR_RootConstrainSelectedInstOperands,
     /*  45901 */     // GIR_Coverage, 1756,
     /*  45901 */     GIR_EraseRootFromParent_Done,
     /*  45902 */   // Label 713: @45902
     /*  45902 */   GIM_Try, /*On fail goto*//*Label 714*/ GIMT_Encode4(45949), // Rule ID 1855 //
     /*  45907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45926 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45928 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  45935 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  45935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i16_v4i32),
     /*  45938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45940 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  45942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  45947 */     GIR_RootConstrainSelectedInstOperands,
     /*  45948 */     // GIR_Coverage, 1855,
     /*  45948 */     GIR_EraseRootFromParent_Done,
     /*  45949 */   // Label 714: @45949
     /*  45949 */   GIM_Try, /*On fail goto*//*Label 715*/ GIMT_Encode4(46008), // Rule ID 1836 //
     /*  45954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45965 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45969 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45974 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  45978 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45982 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45986 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45991 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  45993 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  45993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  45996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  46002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46006 */     GIR_RootConstrainSelectedInstOperands,
     /*  46007 */     // GIR_Coverage, 1836,
     /*  46007 */     GIR_EraseRootFromParent_Done,
     /*  46008 */   // Label 715: @46008
     /*  46008 */   GIM_Try, /*On fail goto*//*Label 716*/ GIMT_Encode4(46067), // Rule ID 1835 //
     /*  46013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  46024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46028 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46037 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46041 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46045 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46050 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46052 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  46052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  46055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  46061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46065 */     GIR_RootConstrainSelectedInstOperands,
     /*  46066 */     // GIR_Coverage, 1835,
     /*  46066 */     GIR_EraseRootFromParent_Done,
     /*  46067 */   // Label 716: @46067
     /*  46067 */   GIM_Try, /*On fail goto*//*Label 717*/ GIMT_Encode4(46126), // Rule ID 1749 //
     /*  46072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  46083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46087 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46092 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46096 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  46100 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46104 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46109 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46111 */     // (sub:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SSUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  46111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i16_v4i32),
     /*  46114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  46120 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46124 */     GIR_RootConstrainSelectedInstOperands,
     /*  46125 */     // GIR_Coverage, 1749,
     /*  46125 */     GIR_EraseRootFromParent_Done,
     /*  46126 */   // Label 717: @46126
     /*  46126 */   GIM_Try, /*On fail goto*//*Label 718*/ GIMT_Encode4(46185), // Rule ID 1834 //
     /*  46131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46142 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46146 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46151 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46155 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  46159 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46163 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46168 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46170 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  46170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  46173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  46179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46183 */     GIR_RootConstrainSelectedInstOperands,
     /*  46184 */     // GIR_Coverage, 1834,
     /*  46184 */     GIR_EraseRootFromParent_Done,
     /*  46185 */   // Label 718: @46185
     /*  46185 */   GIM_Try, /*On fail goto*//*Label 719*/ GIMT_Encode4(46244), // Rule ID 1833 //
     /*  46190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46201 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46205 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46210 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46214 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46218 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46222 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46227 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46229 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  46229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  46232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  46238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46242 */     GIR_RootConstrainSelectedInstOperands,
     /*  46243 */     // GIR_Coverage, 1833,
     /*  46243 */     GIR_EraseRootFromParent_Done,
     /*  46244 */   // Label 719: @46244
     /*  46244 */   GIM_Try, /*On fail goto*//*Label 720*/ GIMT_Encode4(46279), // Rule ID 963 //
     /*  46249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46256 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46262 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  46264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46270 */     // (sub:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn)  =>  (NEGv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /*  46270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv4i32),
     /*  46273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46275 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46277 */     GIR_RootConstrainSelectedInstOperands,
     /*  46278 */     // GIR_Coverage, 963,
     /*  46278 */     GIR_EraseRootFromParent_Done,
     /*  46279 */   // Label 720: @46279
     /*  46279 */   GIM_Try, /*On fail goto*//*Label 721*/ GIMT_Encode4(46336), // Rule ID 1725 //
     /*  46284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  46299 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46303 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  46307 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46312 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46319 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  46319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_v4i32),
     /*  46322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46324 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  46326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  46330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  46334 */     GIR_RootConstrainSelectedInstOperands,
     /*  46335 */     // GIR_Coverage, 1725,
     /*  46335 */     GIR_EraseRootFromParent_Done,
     /*  46336 */   // Label 721: @46336
     /*  46336 */   GIM_Try, /*On fail goto*//*Label 722*/ GIMT_Encode4(46393), // Rule ID 1815 //
     /*  46341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46344 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  46356 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46360 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  46364 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46369 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46374 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46376 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  46376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_v4i32),
     /*  46379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46381 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  46383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  46387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  46391 */     GIR_RootConstrainSelectedInstOperands,
     /*  46392 */     // GIR_Coverage, 1815,
     /*  46392 */     GIR_EraseRootFromParent_Done,
     /*  46393 */   // Label 722: @46393
     /*  46393 */   GIM_Try, /*On fail goto*//*Label 723*/ GIMT_Encode4(46437), // Rule ID 1854 //
     /*  46398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  46413 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46417 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46422 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46424 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  46424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  46427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46429 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  46431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  46435 */     GIR_RootConstrainSelectedInstOperands,
     /*  46436 */     // GIR_Coverage, 1854,
     /*  46436 */     GIR_EraseRootFromParent_Done,
     /*  46437 */   // Label 723: @46437
     /*  46437 */   GIM_Try, /*On fail goto*//*Label 724*/ GIMT_Encode4(46481), // Rule ID 1755 //
     /*  46442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46445 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  46457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46461 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46466 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46468 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SSUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  46468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i16_v4i32),
     /*  46471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46473 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  46475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  46479 */     GIR_RootConstrainSelectedInstOperands,
     /*  46480 */     // GIR_Coverage, 1755,
     /*  46480 */     GIR_EraseRootFromParent_Done,
     /*  46481 */   // Label 724: @46481
     /*  46481 */   GIM_Try, /*On fail goto*//*Label 725*/ GIMT_Encode4(46525), // Rule ID 1853 //
     /*  46486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46489 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46505 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46510 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46512 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  46512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  46515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46517 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  46519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  46523 */     GIR_RootConstrainSelectedInstOperands,
     /*  46524 */     // GIR_Coverage, 1853,
     /*  46524 */     GIR_EraseRootFromParent_Done,
     /*  46525 */   // Label 725: @46525
     /*  46525 */   GIM_Try, /*On fail goto*//*Label 726*/ GIMT_Encode4(46548), // Rule ID 1470 //
     /*  46530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46533 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46541 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  46541 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv4i32),
     /*  46546 */     GIR_RootConstrainSelectedInstOperands,
     /*  46547 */     // GIR_Coverage, 1470,
     /*  46547 */     GIR_Done,
     /*  46548 */   // Label 726: @46548
     /*  46548 */   GIM_Reject,
     /*  46549 */ // Label 692: @46549
     /*  46549 */ GIM_Reject,
     /*  46550 */ // Label 578: @46550
     /*  46550 */ GIM_Try, /*On fail goto*//*Label 727*/ GIMT_Encode4(46624),
     /*  46555 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46558 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  46561 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46565 */   GIM_Try, /*On fail goto*//*Label 728*/ GIMT_Encode4(46600), // Rule ID 958 //
     /*  46570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46577 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46583 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  46585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46591 */     // (sub:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn)  =>  (NEGv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /*  46591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv8i8),
     /*  46594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46598 */     GIR_RootConstrainSelectedInstOperands,
     /*  46599 */     // GIR_Coverage, 958,
     /*  46599 */     GIR_EraseRootFromParent_Done,
     /*  46600 */   // Label 728: @46600
     /*  46600 */   GIM_Try, /*On fail goto*//*Label 729*/ GIMT_Encode4(46623), // Rule ID 1465 //
     /*  46605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46608 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46616 */     // (sub:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  46616 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv8i8),
     /*  46621 */     GIR_RootConstrainSelectedInstOperands,
     /*  46622 */     // GIR_Coverage, 1465,
     /*  46622 */     GIR_Done,
     /*  46623 */   // Label 729: @46623
     /*  46623 */   GIM_Reject,
     /*  46624 */ // Label 727: @46624
     /*  46624 */ GIM_Reject,
     /*  46625 */ // Label 579: @46625
     /*  46625 */ GIM_Try, /*On fail goto*//*Label 730*/ GIMT_Encode4(47832),
     /*  46630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46633 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  46636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46640 */   GIM_Try, /*On fail goto*//*Label 731*/ GIMT_Encode4(46705), // Rule ID 1832 //
     /*  46645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  46656 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46660 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46664 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  46668 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46672 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46674 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  46681 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  46688 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  46688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  46691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  46698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  46703 */     GIR_RootConstrainSelectedInstOperands,
     /*  46704 */     // GIR_Coverage, 1832,
     /*  46704 */     GIR_EraseRootFromParent_Done,
     /*  46705 */   // Label 731: @46705
     /*  46705 */   GIM_Try, /*On fail goto*//*Label 732*/ GIMT_Encode4(46770), // Rule ID 1831 //
     /*  46710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  46721 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46725 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46729 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46733 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46737 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46739 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  46746 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  46753 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  46753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  46756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  46763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  46768 */     GIR_RootConstrainSelectedInstOperands,
     /*  46769 */     // GIR_Coverage, 1831,
     /*  46769 */     GIR_EraseRootFromParent_Done,
     /*  46770 */   // Label 732: @46770
     /*  46770 */   GIM_Try, /*On fail goto*//*Label 733*/ GIMT_Encode4(46835), // Rule ID 1748 //
     /*  46775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  46786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46790 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46794 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  46798 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46802 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46804 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  46811 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  46818 */     // (sub:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SSUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  46818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv16i8_v8i16),
     /*  46821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  46828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  46833 */     GIR_RootConstrainSelectedInstOperands,
     /*  46834 */     // GIR_Coverage, 1748,
     /*  46834 */     GIR_EraseRootFromParent_Done,
     /*  46835 */   // Label 733: @46835
     /*  46835 */   GIM_Try, /*On fail goto*//*Label 734*/ GIMT_Encode4(46900), // Rule ID 1830 //
     /*  46840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46855 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46859 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  46863 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46867 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46869 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  46876 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  46883 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  46883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  46886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  46893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  46898 */     GIR_RootConstrainSelectedInstOperands,
     /*  46899 */     // GIR_Coverage, 1830,
     /*  46899 */     GIR_EraseRootFromParent_Done,
     /*  46900 */   // Label 734: @46900
     /*  46900 */   GIM_Try, /*On fail goto*//*Label 735*/ GIMT_Encode4(46965), // Rule ID 1829 //
     /*  46905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46920 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46924 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46928 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46932 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46934 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  46941 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  46948 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  46948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  46951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  46958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  46963 */     GIR_RootConstrainSelectedInstOperands,
     /*  46964 */     // GIR_Coverage, 1829,
     /*  46964 */     GIR_EraseRootFromParent_Done,
     /*  46965 */   // Label 735: @46965
     /*  46965 */   GIM_Try, /*On fail goto*//*Label 736*/ GIMT_Encode4(47028), // Rule ID 1724 //
     /*  46970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46973 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  46985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46989 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  46993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46995 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  47002 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  47009 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SMLSLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  47009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv16i8_v8i16),
     /*  47012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47014 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47026 */     GIR_RootConstrainSelectedInstOperands,
     /*  47027 */     // GIR_Coverage, 1724,
     /*  47027 */     GIR_EraseRootFromParent_Done,
     /*  47028 */   // Label 736: @47028
     /*  47028 */   GIM_Try, /*On fail goto*//*Label 737*/ GIMT_Encode4(47091), // Rule ID 1814 //
     /*  47033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47036 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  47048 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47052 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  47056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47058 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  47065 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  47072 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UMLSLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  47072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv16i8_v8i16),
     /*  47075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47077 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47089 */     GIR_RootConstrainSelectedInstOperands,
     /*  47090 */     // GIR_Coverage, 1814,
     /*  47090 */     GIR_EraseRootFromParent_Done,
     /*  47091 */   // Label 737: @47091
     /*  47091 */   GIM_Try, /*On fail goto*//*Label 738*/ GIMT_Encode4(47138), // Rule ID 1852 //
     /*  47096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47099 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47111 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47115 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47117 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  47124 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  47124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv16i8_v8i16),
     /*  47127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47129 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  47131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  47136 */     GIR_RootConstrainSelectedInstOperands,
     /*  47137 */     // GIR_Coverage, 1852,
     /*  47137 */     GIR_EraseRootFromParent_Done,
     /*  47138 */   // Label 738: @47138
     /*  47138 */   GIM_Try, /*On fail goto*//*Label 739*/ GIMT_Encode4(47185), // Rule ID 1754 //
     /*  47143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  47158 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47164 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  47171 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SSUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  47171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv16i8_v8i16),
     /*  47174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47176 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  47178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  47183 */     GIR_RootConstrainSelectedInstOperands,
     /*  47184 */     // GIR_Coverage, 1754,
     /*  47184 */     GIR_EraseRootFromParent_Done,
     /*  47185 */   // Label 739: @47185
     /*  47185 */   GIM_Try, /*On fail goto*//*Label 740*/ GIMT_Encode4(47232), // Rule ID 1851 //
     /*  47190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47211 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  47218 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  47218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv16i8_v8i16),
     /*  47221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47223 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  47225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  47230 */     GIR_RootConstrainSelectedInstOperands,
     /*  47231 */     // GIR_Coverage, 1851,
     /*  47231 */     GIR_EraseRootFromParent_Done,
     /*  47232 */   // Label 740: @47232
     /*  47232 */   GIM_Try, /*On fail goto*//*Label 741*/ GIMT_Encode4(47291), // Rule ID 1828 //
     /*  47237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47248 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47252 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47257 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47261 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47265 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47269 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47274 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47276 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  47276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  47279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  47285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  47289 */     GIR_RootConstrainSelectedInstOperands,
     /*  47290 */     // GIR_Coverage, 1828,
     /*  47290 */     GIR_EraseRootFromParent_Done,
     /*  47291 */   // Label 741: @47291
     /*  47291 */   GIM_Try, /*On fail goto*//*Label 742*/ GIMT_Encode4(47350), // Rule ID 1827 //
     /*  47296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47307 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47311 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47316 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47320 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47324 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47328 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47333 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47335 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  47335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  47338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  47344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  47348 */     GIR_RootConstrainSelectedInstOperands,
     /*  47349 */     // GIR_Coverage, 1827,
     /*  47349 */     GIR_EraseRootFromParent_Done,
     /*  47350 */   // Label 742: @47350
     /*  47350 */   GIM_Try, /*On fail goto*//*Label 743*/ GIMT_Encode4(47409), // Rule ID 1747 //
     /*  47355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  47366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47370 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47375 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  47383 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47387 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47392 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47394 */     // (sub:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SSUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  47394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i8_v8i16),
     /*  47397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  47403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  47407 */     GIR_RootConstrainSelectedInstOperands,
     /*  47408 */     // GIR_Coverage, 1747,
     /*  47408 */     GIR_EraseRootFromParent_Done,
     /*  47409 */   // Label 743: @47409
     /*  47409 */   GIM_Try, /*On fail goto*//*Label 744*/ GIMT_Encode4(47468), // Rule ID 1826 //
     /*  47414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47425 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47429 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47434 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47438 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47442 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47446 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47451 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47453 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  47453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  47456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  47462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  47466 */     GIR_RootConstrainSelectedInstOperands,
     /*  47467 */     // GIR_Coverage, 1826,
     /*  47467 */     GIR_EraseRootFromParent_Done,
     /*  47468 */   // Label 744: @47468
     /*  47468 */   GIM_Try, /*On fail goto*//*Label 745*/ GIMT_Encode4(47527), // Rule ID 1825 //
     /*  47473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47488 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47501 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47505 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47510 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47512 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  47512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  47515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  47521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  47525 */     GIR_RootConstrainSelectedInstOperands,
     /*  47526 */     // GIR_Coverage, 1825,
     /*  47526 */     GIR_EraseRootFromParent_Done,
     /*  47527 */   // Label 745: @47527
     /*  47527 */   GIM_Try, /*On fail goto*//*Label 746*/ GIMT_Encode4(47562), // Rule ID 961 //
     /*  47532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47539 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47545 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  47547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47553 */     // (sub:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn)  =>  (NEGv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /*  47553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv8i16),
     /*  47556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47560 */     GIR_RootConstrainSelectedInstOperands,
     /*  47561 */     // GIR_Coverage, 961,
     /*  47561 */     GIR_EraseRootFromParent_Done,
     /*  47562 */   // Label 746: @47562
     /*  47562 */   GIM_Try, /*On fail goto*//*Label 747*/ GIMT_Encode4(47619), // Rule ID 1723 //
     /*  47567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47570 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  47582 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47586 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  47590 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47595 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47600 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47602 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SMLSLv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  47602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i8_v8i16),
     /*  47605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47607 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47609 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  47613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  47617 */     GIR_RootConstrainSelectedInstOperands,
     /*  47618 */     // GIR_Coverage, 1723,
     /*  47618 */     GIR_EraseRootFromParent_Done,
     /*  47619 */   // Label 747: @47619
     /*  47619 */   GIM_Try, /*On fail goto*//*Label 748*/ GIMT_Encode4(47676), // Rule ID 1813 //
     /*  47624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47627 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  47639 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47643 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  47647 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47652 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47659 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UMLSLv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  47659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i8_v8i16),
     /*  47662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47664 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  47670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  47674 */     GIR_RootConstrainSelectedInstOperands,
     /*  47675 */     // GIR_Coverage, 1813,
     /*  47675 */     GIR_EraseRootFromParent_Done,
     /*  47676 */   // Label 748: @47676
     /*  47676 */   GIM_Try, /*On fail goto*//*Label 749*/ GIMT_Encode4(47720), // Rule ID 1850 //
     /*  47681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47700 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47707 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  47707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  47710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47712 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  47714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  47718 */     GIR_RootConstrainSelectedInstOperands,
     /*  47719 */     // GIR_Coverage, 1850,
     /*  47719 */     GIR_EraseRootFromParent_Done,
     /*  47720 */   // Label 749: @47720
     /*  47720 */   GIM_Try, /*On fail goto*//*Label 750*/ GIMT_Encode4(47764), // Rule ID 1753 //
     /*  47725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47728 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  47740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47744 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47749 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47751 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SSUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  47751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i8_v8i16),
     /*  47754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47756 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  47758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  47762 */     GIR_RootConstrainSelectedInstOperands,
     /*  47763 */     // GIR_Coverage, 1753,
     /*  47763 */     GIR_EraseRootFromParent_Done,
     /*  47764 */   // Label 750: @47764
     /*  47764 */   GIM_Try, /*On fail goto*//*Label 751*/ GIMT_Encode4(47808), // Rule ID 1849 //
     /*  47769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47788 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47795 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  47795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  47798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47800 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  47802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  47806 */     GIR_RootConstrainSelectedInstOperands,
     /*  47807 */     // GIR_Coverage, 1849,
     /*  47807 */     GIR_EraseRootFromParent_Done,
     /*  47808 */   // Label 751: @47808
     /*  47808 */   GIM_Try, /*On fail goto*//*Label 752*/ GIMT_Encode4(47831), // Rule ID 1468 //
     /*  47813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47824 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47824 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv8i16),
     /*  47829 */     GIR_RootConstrainSelectedInstOperands,
     /*  47830 */     // GIR_Coverage, 1468,
     /*  47830 */     GIR_Done,
     /*  47831 */   // Label 752: @47831
     /*  47831 */   GIM_Reject,
     /*  47832 */ // Label 730: @47832
     /*  47832 */ GIM_Reject,
     /*  47833 */ // Label 580: @47833
     /*  47833 */ GIM_Try, /*On fail goto*//*Label 753*/ GIMT_Encode4(47907),
     /*  47838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  47841 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  47844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47848 */   GIM_Try, /*On fail goto*//*Label 754*/ GIMT_Encode4(47883), // Rule ID 959 //
     /*  47853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47860 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47866 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  47868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47872 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47874 */     // (sub:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn)  =>  (NEGv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /*  47874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv16i8),
     /*  47877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47881 */     GIR_RootConstrainSelectedInstOperands,
     /*  47882 */     // GIR_Coverage, 959,
     /*  47882 */     GIR_EraseRootFromParent_Done,
     /*  47883 */   // Label 754: @47883
     /*  47883 */   GIM_Try, /*On fail goto*//*Label 755*/ GIMT_Encode4(47906), // Rule ID 1466 //
     /*  47888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47899 */     // (sub:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  47899 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv16i8),
     /*  47904 */     GIR_RootConstrainSelectedInstOperands,
     /*  47905 */     // GIR_Coverage, 1466,
     /*  47905 */     GIR_Done,
     /*  47906 */   // Label 755: @47906
     /*  47906 */   GIM_Reject,
     /*  47907 */ // Label 753: @47907
     /*  47907 */ GIM_Reject,
     /*  47908 */ // Label 581: @47908
     /*  47908 */ GIM_Try, /*On fail goto*//*Label 756*/ GIMT_Encode4(47933), // Rule ID 7289 //
     /*  47913 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  47916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  47919 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  47922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  47926 */   // (sub:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  47926 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_D),
     /*  47931 */   GIR_RootConstrainSelectedInstOperands,
     /*  47932 */   // GIR_Coverage, 7289,
     /*  47932 */   GIR_Done,
     /*  47933 */ // Label 756: @47933
     /*  47933 */ GIM_Reject,
     /*  47934 */ // Label 582: @47934
     /*  47934 */ GIM_Try, /*On fail goto*//*Label 757*/ GIMT_Encode4(47959), // Rule ID 7288 //
     /*  47939 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  47942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  47945 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  47948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  47952 */   // (sub:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  47952 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_S),
     /*  47957 */   GIR_RootConstrainSelectedInstOperands,
     /*  47958 */   // GIR_Coverage, 7288,
     /*  47958 */   GIR_Done,
     /*  47959 */ // Label 757: @47959
     /*  47959 */ GIM_Reject,
     /*  47960 */ // Label 583: @47960
     /*  47960 */ GIM_Try, /*On fail goto*//*Label 758*/ GIMT_Encode4(47985), // Rule ID 7287 //
     /*  47965 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  47968 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  47971 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  47974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  47978 */   // (sub:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  47978 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_H),
     /*  47983 */   GIR_RootConstrainSelectedInstOperands,
     /*  47984 */   // GIR_Coverage, 7287,
     /*  47984 */   GIR_Done,
     /*  47985 */ // Label 758: @47985
     /*  47985 */ GIM_Reject,
     /*  47986 */ // Label 584: @47986
     /*  47986 */ GIM_Try, /*On fail goto*//*Label 759*/ GIMT_Encode4(48011), // Rule ID 7286 //
     /*  47991 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  47994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  47997 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  48000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  48004 */   // (sub:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  48004 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_B),
     /*  48009 */   GIR_RootConstrainSelectedInstOperands,
     /*  48010 */   // GIR_Coverage, 7286,
     /*  48010 */   GIR_Done,
     /*  48011 */ // Label 759: @48011
     /*  48011 */ GIM_Reject,
     /*  48012 */ // Label 585: @48012
     /*  48012 */ GIM_Reject,
     /*  48013 */ // Label 2: @48013
     /*  48013 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 768*/ GIMT_Encode4(49841),
     /*  48024 */ /*GILLT_s32*//*Label 760*/ GIMT_Encode4(48064),
     /*  48028 */ /*GILLT_s64*//*Label 761*/ GIMT_Encode4(48221), GIMT_Encode4(0),
     /*  48036 */ /*GILLT_v2s32*//*Label 762*/ GIMT_Encode4(48765), GIMT_Encode4(0),
     /*  48044 */ /*GILLT_v4s16*//*Label 763*/ GIMT_Encode4(49103),
     /*  48048 */ /*GILLT_v4s32*//*Label 764*/ GIMT_Encode4(49441),
     /*  48052 */ /*GILLT_v8s8*//*Label 765*/ GIMT_Encode4(49607),
     /*  48056 */ /*GILLT_v8s16*//*Label 766*/ GIMT_Encode4(49641),
     /*  48060 */ /*GILLT_v16s8*//*Label 767*/ GIMT_Encode4(49807),
     /*  48064 */ // Label 760: @48064
     /*  48064 */ GIM_Try, /*On fail goto*//*Label 769*/ GIMT_Encode4(48220),
     /*  48069 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  48072 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  48079 */   GIM_Try, /*On fail goto*//*Label 770*/ GIMT_Encode4(48134), // Rule ID 3897 //
     /*  48084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  48092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  48096 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  48100 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  48104 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  48109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  48113 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48115 */     // (mul:{ *:[i32] } (sub:{ *:[i32] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rn), GPR32:{ *:[i32] }:$Rm)  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  48115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
     /*  48118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48120 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  48124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  48126 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48132 */     GIR_RootConstrainSelectedInstOperands,
     /*  48133 */     // GIR_Coverage, 3897,
     /*  48133 */     GIR_EraseRootFromParent_Done,
     /*  48134 */   // Label 770: @48134
     /*  48134 */   GIM_Try, /*On fail goto*//*Label 771*/ GIMT_Encode4(48189), // Rule ID 13491 //
     /*  48139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  48143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  48151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  48155 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  48159 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  48163 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  48168 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48170 */     // (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, (sub:{ *:[i32] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rn))  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  48170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
     /*  48173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  48179 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  48181 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48187 */     GIR_RootConstrainSelectedInstOperands,
     /*  48188 */     // GIR_Coverage, 13491,
     /*  48188 */     GIR_EraseRootFromParent_Done,
     /*  48189 */   // Label 771: @48189
     /*  48189 */   GIM_Try, /*On fail goto*//*Label 772*/ GIMT_Encode4(48219), // Rule ID 3893 //
     /*  48194 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  48198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  48202 */     // (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (MADDWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  48202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MADDWrrr),
     /*  48205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48207 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  48209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  48211 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48217 */     GIR_RootConstrainSelectedInstOperands,
     /*  48218 */     // GIR_Coverage, 3893,
     /*  48218 */     GIR_EraseRootFromParent_Done,
     /*  48219 */   // Label 772: @48219
     /*  48219 */   GIM_Reject,
     /*  48220 */ // Label 769: @48220
     /*  48220 */ GIM_Reject,
     /*  48221 */ // Label 761: @48221
     /*  48221 */ GIM_Try, /*On fail goto*//*Label 773*/ GIMT_Encode4(48764),
     /*  48226 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  48229 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  48232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  48236 */   GIM_Try, /*On fail goto*//*Label 774*/ GIMT_Encode4(48291), // Rule ID 3898 //
     /*  48241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  48249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  48253 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  48257 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  48261 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  48266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  48270 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48272 */     // (mul:{ *:[i64] } (sub:{ *:[i64] } 0:{ *:[i64] }, GPR64:{ *:[i64] }:$Rn), GPR64:{ *:[i64] }:$Rm)  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  48272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
     /*  48275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  48281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  48283 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48289 */     GIR_RootConstrainSelectedInstOperands,
     /*  48290 */     // GIR_Coverage, 3898,
     /*  48290 */     GIR_EraseRootFromParent_Done,
     /*  48291 */   // Label 774: @48291
     /*  48291 */   GIM_Try, /*On fail goto*//*Label 775*/ GIMT_Encode4(48346), // Rule ID 13492 //
     /*  48296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  48300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  48308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  48312 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  48316 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  48320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  48325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48327 */     // (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, (sub:{ *:[i64] } 0:{ *:[i64] }, GPR64:{ *:[i64] }:$Rn))  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  48327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
     /*  48330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  48336 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  48338 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48344 */     GIR_RootConstrainSelectedInstOperands,
     /*  48345 */     // GIR_Coverage, 13492,
     /*  48345 */     GIR_EraseRootFromParent_Done,
     /*  48346 */   // Label 775: @48346
     /*  48346 */   GIM_Try, /*On fail goto*//*Label 776*/ GIMT_Encode4(48459), // Rule ID 3909 //
     /*  48351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  48359 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  48363 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  48368 */     // MIs[1] Operand 2
     /*  48368 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  48379 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48383 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48387 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  48391 */     // MIs[2] Operand 1
     /*  48391 */     // No operand predicates
     /*  48391 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48393 */     // (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C)  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  48393 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  48396 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  48400 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48405 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  48410 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  48412 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48415 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48419 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48424 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  48430 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  48435 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  48440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  48443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48445 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  48448 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  48451 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48457 */     GIR_RootConstrainSelectedInstOperands,
     /*  48458 */     // GIR_Coverage, 3909,
     /*  48458 */     GIR_EraseRootFromParent_Done,
     /*  48459 */   // Label 776: @48459
     /*  48459 */   GIM_Try, /*On fail goto*//*Label 777*/ GIMT_Encode4(48534), // Rule ID 3907 //
     /*  48464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  48472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  48476 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  48481 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48485 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48489 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  48493 */     // MIs[2] Operand 1
     /*  48493 */     // No operand predicates
     /*  48493 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48495 */     // (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  48495 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48498 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  48502 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48507 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  48512 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  48517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  48526 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48532 */     GIR_RootConstrainSelectedInstOperands,
     /*  48533 */     // GIR_Coverage, 3907,
     /*  48533 */     GIR_EraseRootFromParent_Done,
     /*  48534 */   // Label 777: @48534
     /*  48534 */   GIM_Try, /*On fail goto*//*Label 778*/ GIMT_Encode4(48609), // Rule ID 3908 //
     /*  48539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  48551 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  48556 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48560 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48564 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*  48568 */     // MIs[2] Operand 1
     /*  48568 */     // No operand predicates
     /*  48568 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48570 */     // (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  48570 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48573 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  48577 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48582 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  48587 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  48592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48598 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  48601 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48607 */     GIR_RootConstrainSelectedInstOperands,
     /*  48608 */     // GIR_Coverage, 3908,
     /*  48608 */     GIR_EraseRootFromParent_Done,
     /*  48609 */   // Label 778: @48609
     /*  48609 */   GIM_Try, /*On fail goto*//*Label 779*/ GIMT_Encode4(48671), // Rule ID 3901 //
     /*  48614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  48622 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  48626 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  48631 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48635 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  48639 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  48643 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  48648 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48650 */     // (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  48650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  48653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48663 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48669 */     GIR_RootConstrainSelectedInstOperands,
     /*  48670 */     // GIR_Coverage, 3901,
     /*  48670 */     GIR_EraseRootFromParent_Done,
     /*  48671 */   // Label 779: @48671
     /*  48671 */   GIM_Try, /*On fail goto*//*Label 780*/ GIMT_Encode4(48733), // Rule ID 3904 //
     /*  48676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  48688 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  48693 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48697 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48701 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  48705 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  48710 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48712 */     // (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  48712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  48715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48725 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48731 */     GIR_RootConstrainSelectedInstOperands,
     /*  48732 */     // GIR_Coverage, 3904,
     /*  48732 */     GIR_EraseRootFromParent_Done,
     /*  48733 */   // Label 780: @48733
     /*  48733 */   GIM_Try, /*On fail goto*//*Label 781*/ GIMT_Encode4(48763), // Rule ID 3894 //
     /*  48738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  48742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  48746 */     // (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (MADDXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  48746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MADDXrrr),
     /*  48749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48751 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  48753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  48755 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48761 */     GIR_RootConstrainSelectedInstOperands,
     /*  48762 */     // GIR_Coverage, 3894,
     /*  48762 */     GIR_EraseRootFromParent_Done,
     /*  48763 */   // Label 781: @48763
     /*  48763 */   GIM_Reject,
     /*  48764 */ // Label 773: @48764
     /*  48764 */ GIM_Reject,
     /*  48765 */ // Label 762: @48765
     /*  48765 */ GIM_Try, /*On fail goto*//*Label 782*/ GIMT_Encode4(49102),
     /*  48770 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  48773 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  48776 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48780 */   GIM_Try, /*On fail goto*//*Label 783*/ GIMT_Encode4(48866), // Rule ID 13185 //
     /*  48785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  48796 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  48800 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  48804 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  48808 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  48812 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48816 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48821 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  48825 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48829 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  48833 */     // MIs[3] Operand 1
     /*  48833 */     // No operand predicates
     /*  48833 */     // MIs[1] Operand 2
     /*  48833 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  48844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48848 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48850 */     // (mul:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  48853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48861 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  48864 */     GIR_RootConstrainSelectedInstOperands,
     /*  48865 */     // GIR_Coverage, 13185,
     /*  48865 */     GIR_EraseRootFromParent_Done,
     /*  48866 */   // Label 783: @48866
     /*  48866 */   GIM_Try, /*On fail goto*//*Label 784*/ GIMT_Encode4(48952), // Rule ID 2027 //
     /*  48871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48874 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  48886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  48890 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  48894 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  48898 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  48902 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48906 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48911 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  48915 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48919 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  48923 */     // MIs[3] Operand 1
     /*  48923 */     // No operand predicates
     /*  48923 */     // MIs[1] Operand 2
     /*  48923 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  48934 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48936 */     // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  48939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48941 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  48943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48947 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  48950 */     GIR_RootConstrainSelectedInstOperands,
     /*  48951 */     // GIR_Coverage, 2027,
     /*  48951 */     GIR_EraseRootFromParent_Done,
     /*  48952 */   // Label 784: @48952
     /*  48952 */   GIM_Try, /*On fail goto*//*Label 785*/ GIMT_Encode4(49015), // Rule ID 13186 //
     /*  48957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  48968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  48972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  48976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  48985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48989 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  48993 */     // MIs[2] Operand 1
     /*  48993 */     // No operand predicates
     /*  48993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48997 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48999 */     // (mul:{ *:[v2i32] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  49002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49010 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  49013 */     GIR_RootConstrainSelectedInstOperands,
     /*  49014 */     // GIR_Coverage, 13186,
     /*  49014 */     GIR_EraseRootFromParent_Done,
     /*  49015 */   // Label 785: @49015
     /*  49015 */   GIM_Try, /*On fail goto*//*Label 786*/ GIMT_Encode4(49078), // Rule ID 2028 //
     /*  49020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  49035 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  49039 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  49043 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49048 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  49052 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49056 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  49060 */     // MIs[2] Operand 1
     /*  49060 */     // No operand predicates
     /*  49060 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49062 */     // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  49062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  49065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49067 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49073 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  49076 */     GIR_RootConstrainSelectedInstOperands,
     /*  49077 */     // GIR_Coverage, 2028,
     /*  49077 */     GIR_EraseRootFromParent_Done,
     /*  49078 */   // Label 786: @49078
     /*  49078 */   GIM_Try, /*On fail goto*//*Label 787*/ GIMT_Encode4(49101), // Rule ID 1345 //
     /*  49083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49086 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49094 */     // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (MULv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  49094 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32),
     /*  49099 */     GIR_RootConstrainSelectedInstOperands,
     /*  49100 */     // GIR_Coverage, 1345,
     /*  49100 */     GIR_Done,
     /*  49101 */   // Label 787: @49101
     /*  49101 */   GIM_Reject,
     /*  49102 */ // Label 782: @49102
     /*  49102 */ GIM_Reject,
     /*  49103 */ // Label 763: @49103
     /*  49103 */ GIM_Try, /*On fail goto*//*Label 788*/ GIMT_Encode4(49440),
     /*  49108 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49111 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  49114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49118 */   GIM_Try, /*On fail goto*//*Label 789*/ GIMT_Encode4(49204), // Rule ID 13182 //
     /*  49123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  49134 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  49142 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  49146 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49150 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  49154 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  49159 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  49163 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49167 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  49171 */     // MIs[3] Operand 1
     /*  49171 */     // No operand predicates
     /*  49171 */     // MIs[1] Operand 2
     /*  49171 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  49182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49186 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  49188 */     // (mul:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  49188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  49191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  49199 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  49202 */     GIR_RootConstrainSelectedInstOperands,
     /*  49203 */     // GIR_Coverage, 13182,
     /*  49203 */     GIR_EraseRootFromParent_Done,
     /*  49204 */   // Label 789: @49204
     /*  49204 */   GIM_Try, /*On fail goto*//*Label 790*/ GIMT_Encode4(49290), // Rule ID 2024 //
     /*  49209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49212 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  49224 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49228 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  49232 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  49236 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49240 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  49244 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  49249 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  49253 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49257 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  49261 */     // MIs[3] Operand 1
     /*  49261 */     // No operand predicates
     /*  49261 */     // MIs[1] Operand 2
     /*  49261 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  49272 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  49274 */     // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  49274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  49277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49279 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  49285 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  49288 */     GIR_RootConstrainSelectedInstOperands,
     /*  49289 */     // GIR_Coverage, 2024,
     /*  49289 */     GIR_EraseRootFromParent_Done,
     /*  49290 */   // Label 790: @49290
     /*  49290 */   GIM_Try, /*On fail goto*//*Label 791*/ GIMT_Encode4(49353), // Rule ID 13183 //
     /*  49295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  49306 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49310 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  49314 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  49319 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  49323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49327 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  49331 */     // MIs[2] Operand 1
     /*  49331 */     // No operand predicates
     /*  49331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49335 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49337 */     // (mul:{ *:[v4i16] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  49337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  49340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49348 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  49351 */     GIR_RootConstrainSelectedInstOperands,
     /*  49352 */     // GIR_Coverage, 13183,
     /*  49352 */     GIR_EraseRootFromParent_Done,
     /*  49353 */   // Label 791: @49353
     /*  49353 */   GIM_Try, /*On fail goto*//*Label 792*/ GIMT_Encode4(49416), // Rule ID 2025 //
     /*  49358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  49373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49377 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  49381 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  49386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  49390 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49394 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  49398 */     // MIs[2] Operand 1
     /*  49398 */     // No operand predicates
     /*  49398 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49400 */     // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  49400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  49403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49405 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49411 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  49414 */     GIR_RootConstrainSelectedInstOperands,
     /*  49415 */     // GIR_Coverage, 2025,
     /*  49415 */     GIR_EraseRootFromParent_Done,
     /*  49416 */   // Label 792: @49416
     /*  49416 */   GIM_Try, /*On fail goto*//*Label 793*/ GIMT_Encode4(49439), // Rule ID 1343 //
     /*  49421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49432 */     // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (MULv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  49432 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16),
     /*  49437 */     GIR_RootConstrainSelectedInstOperands,
     /*  49438 */     // GIR_Coverage, 1343,
     /*  49438 */     GIR_Done,
     /*  49439 */   // Label 793: @49439
     /*  49439 */   GIM_Reject,
     /*  49440 */ // Label 788: @49440
     /*  49440 */ GIM_Reject,
     /*  49441 */ // Label 764: @49441
     /*  49441 */ GIM_Try, /*On fail goto*//*Label 794*/ GIMT_Encode4(49606),
     /*  49446 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  49449 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  49452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49456 */   GIM_Try, /*On fail goto*//*Label 795*/ GIMT_Encode4(49519), // Rule ID 13187 //
     /*  49461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  49472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  49476 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  49480 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49485 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  49489 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49493 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  49497 */     // MIs[2] Operand 1
     /*  49497 */     // No operand predicates
     /*  49497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49501 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49503 */     // (mul:{ *:[v4i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4i32] }:$Rn)  =>  (MULv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  49503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32_indexed),
     /*  49506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49514 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  49517 */     GIR_RootConstrainSelectedInstOperands,
     /*  49518 */     // GIR_Coverage, 13187,
     /*  49518 */     GIR_EraseRootFromParent_Done,
     /*  49519 */   // Label 795: @49519
     /*  49519 */   GIM_Try, /*On fail goto*//*Label 796*/ GIMT_Encode4(49582), // Rule ID 2029 //
     /*  49524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49527 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  49539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  49543 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  49547 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49552 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  49556 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49560 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  49564 */     // MIs[2] Operand 1
     /*  49564 */     // No operand predicates
     /*  49564 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49566 */     // (mul:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (MULv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  49566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32_indexed),
     /*  49569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49571 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49577 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  49580 */     GIR_RootConstrainSelectedInstOperands,
     /*  49581 */     // GIR_Coverage, 2029,
     /*  49581 */     GIR_EraseRootFromParent_Done,
     /*  49582 */   // Label 796: @49582
     /*  49582 */   GIM_Try, /*On fail goto*//*Label 797*/ GIMT_Encode4(49605), // Rule ID 1346 //
     /*  49587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49590 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49598 */     // (mul:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (MULv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  49598 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32),
     /*  49603 */     GIR_RootConstrainSelectedInstOperands,
     /*  49604 */     // GIR_Coverage, 1346,
     /*  49604 */     GIR_Done,
     /*  49605 */   // Label 797: @49605
     /*  49605 */   GIM_Reject,
     /*  49606 */ // Label 794: @49606
     /*  49606 */ GIM_Reject,
     /*  49607 */ // Label 765: @49607
     /*  49607 */ GIM_Try, /*On fail goto*//*Label 798*/ GIMT_Encode4(49640), // Rule ID 1341 //
     /*  49612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49618 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  49621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49625 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49629 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49633 */   // (mul:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (MULv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  49633 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv8i8),
     /*  49638 */   GIR_RootConstrainSelectedInstOperands,
     /*  49639 */   // GIR_Coverage, 1341,
     /*  49639 */   GIR_Done,
     /*  49640 */ // Label 798: @49640
     /*  49640 */ GIM_Reject,
     /*  49641 */ // Label 766: @49641
     /*  49641 */ GIM_Try, /*On fail goto*//*Label 799*/ GIMT_Encode4(49806),
     /*  49646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49649 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  49652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49656 */   GIM_Try, /*On fail goto*//*Label 800*/ GIMT_Encode4(49719), // Rule ID 13184 //
     /*  49661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  49672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49676 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  49680 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  49685 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  49689 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49693 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  49697 */     // MIs[2] Operand 1
     /*  49697 */     // No operand predicates
     /*  49697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49701 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49703 */     // (mul:{ *:[v8i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8i16] }:$Rn)  =>  (MULv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  49703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16_indexed),
     /*  49706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49714 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  49717 */     GIR_RootConstrainSelectedInstOperands,
     /*  49718 */     // GIR_Coverage, 13184,
     /*  49718 */     GIR_EraseRootFromParent_Done,
     /*  49719 */   // Label 800: @49719
     /*  49719 */   GIM_Try, /*On fail goto*//*Label 801*/ GIMT_Encode4(49782), // Rule ID 2026 //
     /*  49724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49727 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  49739 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49743 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  49747 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  49752 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  49756 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49760 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  49764 */     // MIs[2] Operand 1
     /*  49764 */     // No operand predicates
     /*  49764 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49766 */     // (mul:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (MULv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  49766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16_indexed),
     /*  49769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49771 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49773 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49777 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  49780 */     GIR_RootConstrainSelectedInstOperands,
     /*  49781 */     // GIR_Coverage, 2026,
     /*  49781 */     GIR_EraseRootFromParent_Done,
     /*  49782 */   // Label 801: @49782
     /*  49782 */   GIM_Try, /*On fail goto*//*Label 802*/ GIMT_Encode4(49805), // Rule ID 1344 //
     /*  49787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49798 */     // (mul:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (MULv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  49798 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16),
     /*  49803 */     GIR_RootConstrainSelectedInstOperands,
     /*  49804 */     // GIR_Coverage, 1344,
     /*  49804 */     GIR_Done,
     /*  49805 */   // Label 802: @49805
     /*  49805 */   GIM_Reject,
     /*  49806 */ // Label 799: @49806
     /*  49806 */ GIM_Reject,
     /*  49807 */ // Label 767: @49807
     /*  49807 */ GIM_Try, /*On fail goto*//*Label 803*/ GIMT_Encode4(49840), // Rule ID 1342 //
     /*  49812 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49815 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  49818 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  49821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49825 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49829 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49833 */   // (mul:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (MULv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49833 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv16i8),
     /*  49838 */   GIR_RootConstrainSelectedInstOperands,
     /*  49839 */   // GIR_Coverage, 1342,
     /*  49839 */   GIR_Done,
     /*  49840 */ // Label 803: @49840
     /*  49840 */ GIM_Reject,
     /*  49841 */ // Label 768: @49841
     /*  49841 */ GIM_Reject,
     /*  49842 */ // Label 3: @49842
     /*  49842 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 806*/ GIMT_Encode4(49923),
     /*  49853 */ /*GILLT_s32*//*Label 804*/ GIMT_Encode4(49861),
     /*  49857 */ /*GILLT_s64*//*Label 805*/ GIMT_Encode4(49892),
     /*  49861 */ // Label 804: @49861
     /*  49861 */ GIM_Try, /*On fail goto*//*Label 807*/ GIMT_Encode4(49891), // Rule ID 117 //
     /*  49866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49869 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  49876 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  49880 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  49884 */   // (sdiv:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  49884 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDIVWr),
     /*  49889 */   GIR_RootConstrainSelectedInstOperands,
     /*  49890 */   // GIR_Coverage, 117,
     /*  49890 */   GIR_Done,
     /*  49891 */ // Label 807: @49891
     /*  49891 */ GIM_Reject,
     /*  49892 */ // Label 805: @49892
     /*  49892 */ GIM_Try, /*On fail goto*//*Label 808*/ GIMT_Encode4(49922), // Rule ID 118 //
     /*  49897 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49900 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  49903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  49907 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  49911 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  49915 */   // (sdiv:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  49915 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDIVXr),
     /*  49920 */   GIR_RootConstrainSelectedInstOperands,
     /*  49921 */   // GIR_Coverage, 118,
     /*  49921 */   GIR_Done,
     /*  49922 */ // Label 808: @49922
     /*  49922 */ GIM_Reject,
     /*  49923 */ // Label 806: @49923
     /*  49923 */ GIM_Reject,
     /*  49924 */ // Label 4: @49924
     /*  49924 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 811*/ GIMT_Encode4(50005),
     /*  49935 */ /*GILLT_s32*//*Label 809*/ GIMT_Encode4(49943),
     /*  49939 */ /*GILLT_s64*//*Label 810*/ GIMT_Encode4(49974),
     /*  49943 */ // Label 809: @49943
     /*  49943 */ GIM_Try, /*On fail goto*//*Label 812*/ GIMT_Encode4(49973), // Rule ID 115 //
     /*  49948 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49951 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  49958 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  49962 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  49966 */   // (udiv:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  49966 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDIVWr),
     /*  49971 */   GIR_RootConstrainSelectedInstOperands,
     /*  49972 */   // GIR_Coverage, 115,
     /*  49972 */   GIR_Done,
     /*  49973 */ // Label 812: @49973
     /*  49973 */ GIM_Reject,
     /*  49974 */ // Label 810: @49974
     /*  49974 */ GIM_Try, /*On fail goto*//*Label 813*/ GIMT_Encode4(50004), // Rule ID 116 //
     /*  49979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49982 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  49985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  49989 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  49993 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  49997 */   // (udiv:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  49997 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDIVXr),
     /*  50002 */   GIR_RootConstrainSelectedInstOperands,
     /*  50003 */   // GIR_Coverage, 116,
     /*  50003 */   GIR_Done,
     /*  50004 */ // Label 813: @50004
     /*  50004 */ GIM_Reject,
     /*  50005 */ // Label 811: @50005
     /*  50005 */ GIM_Reject,
     /*  50006 */ // Label 5: @50006
     /*  50006 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 832*/ GIMT_Encode4(57751),
     /*  50017 */ /*GILLT_s32*//*Label 814*/ GIMT_Encode4(50105),
     /*  50021 */ /*GILLT_s64*//*Label 815*/ GIMT_Encode4(50603), GIMT_Encode4(0),
     /*  50029 */ /*GILLT_v2s32*//*Label 816*/ GIMT_Encode4(52038),
     /*  50033 */ /*GILLT_v2s64*//*Label 817*/ GIMT_Encode4(52198),
     /*  50037 */ /*GILLT_v4s16*//*Label 818*/ GIMT_Encode4(52358),
     /*  50041 */ /*GILLT_v4s32*//*Label 819*/ GIMT_Encode4(52518),
     /*  50045 */ /*GILLT_v8s8*//*Label 820*/ GIMT_Encode4(52678),
     /*  50049 */ /*GILLT_v8s16*//*Label 821*/ GIMT_Encode4(52838),
     /*  50053 */ /*GILLT_v16s8*//*Label 822*/ GIMT_Encode4(52998),
     /*  50057 */ /*GILLT_nxv1s1*//*Label 823*/ GIMT_Encode4(53158),
     /*  50061 */ /*GILLT_nxv2s1*//*Label 824*/ GIMT_Encode4(53699), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  50073 */ /*GILLT_nxv2s64*//*Label 825*/ GIMT_Encode4(54240),
     /*  50077 */ /*GILLT_nxv4s1*//*Label 826*/ GIMT_Encode4(54712), GIMT_Encode4(0),
     /*  50085 */ /*GILLT_nxv4s32*//*Label 827*/ GIMT_Encode4(55253),
     /*  50089 */ /*GILLT_nxv8s1*//*Label 828*/ GIMT_Encode4(55725),
     /*  50093 */ /*GILLT_nxv8s16*//*Label 829*/ GIMT_Encode4(56266),
     /*  50097 */ /*GILLT_nxv16s1*//*Label 830*/ GIMT_Encode4(56738),
     /*  50101 */ /*GILLT_nxv16s8*//*Label 831*/ GIMT_Encode4(57279),
     /*  50105 */ // Label 814: @50105
     /*  50105 */ GIM_Try, /*On fail goto*//*Label 833*/ GIMT_Encode4(50602),
     /*  50110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  50113 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  50116 */   GIM_Try, /*On fail goto*//*Label 834*/ GIMT_Encode4(50171), // Rule ID 12944 //
     /*  50121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  50133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  50137 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  50141 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  50145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50151 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  50158 */     // (and:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (BICWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  50158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrs),
     /*  50161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50163 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  50165 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  50169 */     GIR_RootConstrainSelectedInstOperands,
     /*  50170 */     // GIR_Coverage, 12944,
     /*  50170 */     GIR_EraseRootFromParent_Done,
     /*  50171 */   // Label 834: @50171
     /*  50171 */   GIM_Try, /*On fail goto*//*Label 835*/ GIMT_Encode4(50226), // Rule ID 162 //
     /*  50176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50180 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  50192 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  50196 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  50200 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  50204 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50206 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  50213 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (BICWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  50213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrs),
     /*  50216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50218 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50220 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  50224 */     GIR_RootConstrainSelectedInstOperands,
     /*  50225 */     // GIR_Coverage, 162,
     /*  50225 */     GIR_EraseRootFromParent_Done,
     /*  50226 */   // Label 835: @50226
     /*  50226 */   GIM_Try, /*On fail goto*//*Label 836*/ GIMT_Encode4(50295), // Rule ID 5590 //
     /*  50231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  50243 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  50247 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  50251 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50256 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  50260 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  50264 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /*  50268 */     // MIs[2] Operand 1
     /*  50268 */     // No operand predicates
     /*  50268 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  50279 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50281 */     // (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), 255:{ *:[i32] })  =>  (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /*  50281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /*  50284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50290 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  50293 */     GIR_RootConstrainSelectedInstOperands,
     /*  50294 */     // GIR_Coverage, 5590,
     /*  50294 */     GIR_EraseRootFromParent_Done,
     /*  50295 */   // Label 836: @50295
     /*  50295 */   GIM_Try, /*On fail goto*//*Label 837*/ GIMT_Encode4(50364), // Rule ID 5591 //
     /*  50300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  50312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  50316 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  50320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50325 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  50329 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  50333 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  50337 */     // MIs[2] Operand 1
     /*  50337 */     // No operand predicates
     /*  50337 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  50348 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50350 */     // (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 65535:{ *:[i32] })  =>  (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /*  50350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /*  50353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50359 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  50362 */     GIR_RootConstrainSelectedInstOperands,
     /*  50363 */     // GIR_Coverage, 5591,
     /*  50363 */     GIR_EraseRootFromParent_Done,
     /*  50364 */   // Label 837: @50364
     /*  50364 */   GIM_Try, /*On fail goto*//*Label 838*/ GIMT_Encode4(50417), // Rule ID 12942 //
     /*  50369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  50381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  50385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  50389 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50394 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  50398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50402 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50404 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (BICWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  50404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrr),
     /*  50407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  50411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  50415 */     GIR_RootConstrainSelectedInstOperands,
     /*  50416 */     // GIR_Coverage, 12942,
     /*  50416 */     GIR_EraseRootFromParent_Done,
     /*  50417 */   // Label 838: @50417
     /*  50417 */   GIM_Try, /*On fail goto*//*Label 839*/ GIMT_Encode4(50470), // Rule ID 160 //
     /*  50422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  50438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  50442 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  50446 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50451 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  50455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50457 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (BICWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  50457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrr),
     /*  50460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50462 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  50468 */     GIR_RootConstrainSelectedInstOperands,
     /*  50469 */     // GIR_Coverage, 160,
     /*  50469 */     GIR_EraseRootFromParent_Done,
     /*  50470 */   // Label 839: @50470
     /*  50470 */   GIM_Try, /*On fail goto*//*Label 840*/ GIMT_Encode4(50511), // Rule ID 142 //
     /*  50475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  50479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  50491 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
     /*  50495 */     // MIs[1] Operand 1
     /*  50495 */     // No operand predicates
     /*  50495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50497 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (ANDWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  50497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWri),
     /*  50500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50502 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50504 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
     /*  50509 */     GIR_RootConstrainSelectedInstOperands,
     /*  50510 */     // GIR_Coverage, 142,
     /*  50510 */     GIR_EraseRootFromParent_Done,
     /*  50511 */   // Label 840: @50511
     /*  50511 */   GIM_Try, /*On fail goto*//*Label 841*/ GIMT_Encode4(50544), // Rule ID 12940 //
     /*  50516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  50531 */     // (and:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ANDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  50531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWrs),
     /*  50534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  50538 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  50542 */     GIR_RootConstrainSelectedInstOperands,
     /*  50543 */     // GIR_Coverage, 12940,
     /*  50543 */     GIR_EraseRootFromParent_Done,
     /*  50544 */   // Label 841: @50544
     /*  50544 */   GIM_Try, /*On fail goto*//*Label 842*/ GIMT_Encode4(50577), // Rule ID 158 //
     /*  50549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50553 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  50564 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ANDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  50564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWrs),
     /*  50567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50569 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50571 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  50575 */     GIR_RootConstrainSelectedInstOperands,
     /*  50576 */     // GIR_Coverage, 158,
     /*  50576 */     GIR_EraseRootFromParent_Done,
     /*  50577 */   // Label 842: @50577
     /*  50577 */   GIM_Try, /*On fail goto*//*Label 843*/ GIMT_Encode4(50601), // Rule ID 156 //
     /*  50582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50594 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ANDWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  50594 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDWrr),
     /*  50599 */     GIR_RootConstrainSelectedInstOperands,
     /*  50600 */     // GIR_Coverage, 156,
     /*  50600 */     GIR_Done,
     /*  50601 */   // Label 843: @50601
     /*  50601 */   GIM_Reject,
     /*  50602 */ // Label 833: @50602
     /*  50602 */ GIM_Reject,
     /*  50603 */ // Label 815: @50603
     /*  50603 */ GIM_Try, /*On fail goto*//*Label 844*/ GIMT_Encode4(52037),
     /*  50608 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  50611 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  50614 */   GIM_Try, /*On fail goto*//*Label 845*/ GIMT_Encode4(50669), // Rule ID 12945 //
     /*  50619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  50631 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  50635 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  50639 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  50643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50649 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  50656 */     // (and:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (BICXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  50656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrs),
     /*  50659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  50663 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  50667 */     GIR_RootConstrainSelectedInstOperands,
     /*  50668 */     // GIR_Coverage, 12945,
     /*  50668 */     GIR_EraseRootFromParent_Done,
     /*  50669 */   // Label 845: @50669
     /*  50669 */   GIM_Try, /*On fail goto*//*Label 846*/ GIMT_Encode4(50724), // Rule ID 163 //
     /*  50674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50678 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  50690 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  50694 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  50698 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  50702 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50704 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  50711 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (BICXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  50711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrs),
     /*  50714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50716 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50718 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  50722 */     GIR_RootConstrainSelectedInstOperands,
     /*  50723 */     // GIR_Coverage, 163,
     /*  50723 */     GIR_EraseRootFromParent_Done,
     /*  50724 */   // Label 846: @50724
     /*  50724 */   GIM_Try, /*On fail goto*//*Label 847*/ GIMT_Encode4(50837), // Rule ID 5592 //
     /*  50729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  50733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  50745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  50749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  50753 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  50757 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  50761 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50766 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  50770 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  50774 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /*  50778 */     // MIs[3] Operand 1
     /*  50778 */     // No operand predicates
     /*  50778 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  50789 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  50791 */     // (and:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)), 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), sub_32:{ *:[i32] })
     /*  50791 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50794 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /*  50798 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50803 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  50807 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // idx
     /*  50810 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  50815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  50820 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  50823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  50826 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  50831 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50836 */     // GIR_Coverage, 5592,
     /*  50836 */     GIR_EraseRootFromParent_Done,
     /*  50837 */   // Label 847: @50837
     /*  50837 */   GIM_Try, /*On fail goto*//*Label 848*/ GIMT_Encode4(50950), // Rule ID 5593 //
     /*  50842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  50846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  50858 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  50862 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  50866 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  50870 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  50874 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50879 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  50883 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  50887 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  50891 */     // MIs[3] Operand 1
     /*  50891 */     // No operand predicates
     /*  50891 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  50902 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  50904 */     // (and:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), sub_32:{ *:[i32] })
     /*  50904 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50907 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /*  50911 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50916 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  50920 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // idx
     /*  50923 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  50928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  50933 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  50936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  50939 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  50944 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50949 */     // GIR_Coverage, 5593,
     /*  50949 */     GIR_EraseRootFromParent_Done,
     /*  50950 */   // Label 848: @50950
     /*  50950 */   GIM_Try, /*On fail goto*//*Label 849*/ GIMT_Encode4(51049), // Rule ID 7008 //
     /*  50955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  50959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  50967 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  50970 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /*  50975 */     // MIs[1] addr
     /*  50975 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  50979 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  50984 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_1),
     /*  50988 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  50999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51001 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_1>>, 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  51001 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51004 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRB),
     /*  51008 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51013 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  51017 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51022 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  51027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  51032 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  51038 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  51043 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51048 */     // GIR_Coverage, 7008,
     /*  51048 */     GIR_EraseRootFromParent_Done,
     /*  51049 */   // Label 849: @51049
     /*  51049 */   GIM_Try, /*On fail goto*//*Label 850*/ GIMT_Encode4(51148), // Rule ID 7009 //
     /*  51054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  51058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  51066 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  51069 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /*  51074 */     // MIs[1] addr
     /*  51074 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  51078 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  51083 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_2),
     /*  51087 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  51098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51100 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_2>>, 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  51100 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51103 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRH),
     /*  51107 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51112 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  51116 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51121 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  51126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  51131 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  51137 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  51142 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51147 */     // GIR_Coverage, 7009,
     /*  51147 */     GIR_EraseRootFromParent_Done,
     /*  51148 */   // Label 850: @51148
     /*  51148 */   GIM_Try, /*On fail goto*//*Label 851*/ GIMT_Encode4(51247), // Rule ID 7010 //
     /*  51153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  51157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  51165 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  51168 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /*  51173 */     // MIs[1] addr
     /*  51173 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  51177 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  51182 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_4),
     /*  51186 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  51197 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51199 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_4>>, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  51199 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51202 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRW),
     /*  51206 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51211 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  51215 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  51225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  51230 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  51236 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  51241 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51246 */     // GIR_Coverage, 7010,
     /*  51246 */     GIR_EraseRootFromParent_Done,
     /*  51247 */   // Label 851: @51247
     /*  51247 */   GIM_Try, /*On fail goto*//*Label 852*/ GIMT_Encode4(51346), // Rule ID 7015 //
     /*  51252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  51256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  51264 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  51267 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /*  51272 */     // MIs[1] addr
     /*  51272 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  51276 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  51281 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_1),
     /*  51285 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  51296 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51298 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_1>>, 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  51298 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51301 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRB),
     /*  51305 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51310 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  51314 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51319 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  51324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  51329 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  51335 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  51340 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51345 */     // GIR_Coverage, 7015,
     /*  51345 */     GIR_EraseRootFromParent_Done,
     /*  51346 */   // Label 852: @51346
     /*  51346 */   GIM_Try, /*On fail goto*//*Label 853*/ GIMT_Encode4(51445), // Rule ID 7016 //
     /*  51351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  51355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  51363 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  51366 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /*  51371 */     // MIs[1] addr
     /*  51371 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  51375 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  51380 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_2),
     /*  51384 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  51395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51397 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_2>>, 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  51397 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51400 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRH),
     /*  51404 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51409 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  51413 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51418 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  51423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  51428 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  51434 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  51439 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51444 */     // GIR_Coverage, 7016,
     /*  51444 */     GIR_EraseRootFromParent_Done,
     /*  51445 */   // Label 853: @51445
     /*  51445 */   GIM_Try, /*On fail goto*//*Label 854*/ GIMT_Encode4(51544), // Rule ID 7017 //
     /*  51450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  51454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  51462 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  51465 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /*  51470 */     // MIs[1] addr
     /*  51470 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  51474 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  51479 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_4),
     /*  51483 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  51494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51496 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_4>>, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  51496 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51499 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRW),
     /*  51503 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51508 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  51512 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51517 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  51522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  51527 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  51533 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  51538 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51543 */     // GIR_Coverage, 7017,
     /*  51543 */     GIR_EraseRootFromParent_Done,
     /*  51544 */   // Label 854: @51544
     /*  51544 */   GIM_Try, /*On fail goto*//*Label 855*/ GIMT_Encode4(51597), // Rule ID 12943 //
     /*  51549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  51561 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51565 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51569 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51574 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  51578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51582 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51584 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (BICXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  51584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrr),
     /*  51587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  51591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  51595 */     GIR_RootConstrainSelectedInstOperands,
     /*  51596 */     // GIR_Coverage, 12943,
     /*  51596 */     GIR_EraseRootFromParent_Done,
     /*  51597 */   // Label 855: @51597
     /*  51597 */   GIM_Try, /*On fail goto*//*Label 856*/ GIMT_Encode4(51650), // Rule ID 161 //
     /*  51602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  51618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51622 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51626 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51631 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  51635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51637 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }))  =>  (BICXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  51637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrr),
     /*  51640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51642 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  51644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  51648 */     GIR_RootConstrainSelectedInstOperands,
     /*  51649 */     // GIR_Coverage, 161,
     /*  51649 */     GIR_EraseRootFromParent_Done,
     /*  51650 */   // Label 856: @51650
     /*  51650 */   GIM_Try, /*On fail goto*//*Label 857*/ GIMT_Encode4(51750), // Rule ID 3946 //
     /*  51655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  51659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51663 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  51674 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (ORRWrr:{ *:[i32] } WZR:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  51674 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  51677 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51681 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51686 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  51692 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51697 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51702 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51705 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORRWrr),
     /*  51709 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51714 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51720 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  51723 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  51728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  51733 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  51739 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  51744 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51749 */     // GIR_Coverage, 3946,
     /*  51749 */     GIR_EraseRootFromParent_Done,
     /*  51750 */   // Label 857: @51750
     /*  51750 */   GIM_Try, /*On fail goto*//*Label 858*/ GIMT_Encode4(51791), // Rule ID 143 //
     /*  51755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  51759 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51771 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
     /*  51775 */     // MIs[1] Operand 1
     /*  51775 */     // No operand predicates
     /*  51775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51777 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (ANDXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
     /*  51777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXri),
     /*  51780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51782 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  51784 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
     /*  51789 */     GIR_RootConstrainSelectedInstOperands,
     /*  51790 */     // GIR_Coverage, 143,
     /*  51790 */     GIR_EraseRootFromParent_Done,
     /*  51791 */   // Label 858: @51791
     /*  51791 */   GIM_Try, /*On fail goto*//*Label 859*/ GIMT_Encode4(51824), // Rule ID 12941 //
     /*  51796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  51811 */     // (and:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ANDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  51811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXrs),
     /*  51814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51816 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  51818 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  51822 */     GIR_RootConstrainSelectedInstOperands,
     /*  51823 */     // GIR_Coverage, 12941,
     /*  51823 */     GIR_EraseRootFromParent_Done,
     /*  51824 */   // Label 859: @51824
     /*  51824 */   GIM_Try, /*On fail goto*//*Label 860*/ GIMT_Encode4(51857), // Rule ID 159 //
     /*  51829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  51844 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ANDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  51844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXrs),
     /*  51847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51849 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  51851 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  51855 */     GIR_RootConstrainSelectedInstOperands,
     /*  51856 */     // GIR_Coverage, 159,
     /*  51856 */     GIR_EraseRootFromParent_Done,
     /*  51857 */   // Label 860: @51857
     /*  51857 */   GIM_Try, /*On fail goto*//*Label 861*/ GIMT_Encode4(51921), // Rule ID 13596 //
     /*  51862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  51877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51881 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51885 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51890 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  51894 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  51900 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  51902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51906 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51908 */     // (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$LHS)  =>  (BICv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  51908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  51911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51913 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  51915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  51919 */     GIR_RootConstrainSelectedInstOperands,
     /*  51920 */     // GIR_Coverage, 13596,
     /*  51920 */     GIR_EraseRootFromParent_Done,
     /*  51921 */   // Label 861: @51921
     /*  51921 */   GIM_Try, /*On fail goto*//*Label 862*/ GIMT_Encode4(51985), // Rule ID 4981 //
     /*  51926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  51945 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51949 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51953 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51958 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  51962 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  51968 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  51970 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51972 */     // (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }))  =>  (BICv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  51972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  51975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51977 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  51979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  51983 */     GIR_RootConstrainSelectedInstOperands,
     /*  51984 */     // GIR_Coverage, 4981,
     /*  51984 */     GIR_EraseRootFromParent_Done,
     /*  51985 */   // Label 862: @51985
     /*  51985 */   GIM_Try, /*On fail goto*//*Label 863*/ GIMT_Encode4(52009), // Rule ID 157 //
     /*  51990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52002 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ANDXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  52002 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDXrr),
     /*  52007 */     GIR_RootConstrainSelectedInstOperands,
     /*  52008 */     // GIR_Coverage, 157,
     /*  52008 */     GIR_Done,
     /*  52009 */   // Label 863: @52009
     /*  52009 */   GIM_Try, /*On fail goto*//*Label 864*/ GIMT_Encode4(52036), // Rule ID 2475 //
     /*  52014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52029 */     // (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (ANDv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  52029 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  52034 */     GIR_RootConstrainSelectedInstOperands,
     /*  52035 */     // GIR_Coverage, 2475,
     /*  52035 */     GIR_Done,
     /*  52036 */   // Label 864: @52036
     /*  52036 */   GIM_Reject,
     /*  52037 */ // Label 844: @52037
     /*  52037 */ GIM_Reject,
     /*  52038 */ // Label 816: @52038
     /*  52038 */ GIM_Try, /*On fail goto*//*Label 865*/ GIMT_Encode4(52197),
     /*  52043 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  52046 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  52049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52053 */   GIM_Try, /*On fail goto*//*Label 866*/ GIMT_Encode4(52113), // Rule ID 13595 //
     /*  52058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  52069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  52073 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  52077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52082 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52086 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  52092 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  52094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52098 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52100 */     // (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$LHS)  =>  (BICv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  52100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  52103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52105 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  52107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  52111 */     GIR_RootConstrainSelectedInstOperands,
     /*  52112 */     // GIR_Coverage, 13595,
     /*  52112 */     GIR_EraseRootFromParent_Done,
     /*  52113 */   // Label 866: @52113
     /*  52113 */   GIM_Try, /*On fail goto*//*Label 867*/ GIMT_Encode4(52173), // Rule ID 4980 //
     /*  52118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  52133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  52137 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  52141 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52146 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52150 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  52156 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  52158 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52160 */     // (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }))  =>  (BICv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  52160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  52163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52165 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  52167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  52171 */     GIR_RootConstrainSelectedInstOperands,
     /*  52172 */     // GIR_Coverage, 4980,
     /*  52172 */     GIR_EraseRootFromParent_Done,
     /*  52173 */   // Label 867: @52173
     /*  52173 */   GIM_Try, /*On fail goto*//*Label 868*/ GIMT_Encode4(52196), // Rule ID 2474 //
     /*  52178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52181 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52189 */     // (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (ANDv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  52189 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  52194 */     GIR_RootConstrainSelectedInstOperands,
     /*  52195 */     // GIR_Coverage, 2474,
     /*  52195 */     GIR_Done,
     /*  52196 */   // Label 868: @52196
     /*  52196 */   GIM_Reject,
     /*  52197 */ // Label 865: @52197
     /*  52197 */ GIM_Reject,
     /*  52198 */ // Label 817: @52198
     /*  52198 */ GIM_Try, /*On fail goto*//*Label 869*/ GIMT_Encode4(52357),
     /*  52203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  52206 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  52209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52213 */   GIM_Try, /*On fail goto*//*Label 870*/ GIMT_Encode4(52273), // Rule ID 13599 //
     /*  52218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  52229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  52233 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  52237 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52246 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  52252 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  52254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52258 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52260 */     // (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$LHS)  =>  (BICv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  52260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  52263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52265 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  52267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  52271 */     GIR_RootConstrainSelectedInstOperands,
     /*  52272 */     // GIR_Coverage, 13599,
     /*  52272 */     GIR_EraseRootFromParent_Done,
     /*  52273 */   // Label 870: @52273
     /*  52273 */   GIM_Try, /*On fail goto*//*Label 871*/ GIMT_Encode4(52333), // Rule ID 4984 //
     /*  52278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  52293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  52297 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  52301 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52306 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52310 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  52316 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  52318 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52320 */     // (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }))  =>  (BICv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  52320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  52323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52325 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  52327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  52331 */     GIR_RootConstrainSelectedInstOperands,
     /*  52332 */     // GIR_Coverage, 4984,
     /*  52332 */     GIR_EraseRootFromParent_Done,
     /*  52333 */   // Label 871: @52333
     /*  52333 */   GIM_Try, /*On fail goto*//*Label 872*/ GIMT_Encode4(52356), // Rule ID 2478 //
     /*  52338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52341 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52349 */     // (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (ANDv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  52349 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  52354 */     GIR_RootConstrainSelectedInstOperands,
     /*  52355 */     // GIR_Coverage, 2478,
     /*  52355 */     GIR_Done,
     /*  52356 */   // Label 872: @52356
     /*  52356 */   GIM_Reject,
     /*  52357 */ // Label 869: @52357
     /*  52357 */ GIM_Reject,
     /*  52358 */ // Label 818: @52358
     /*  52358 */ GIM_Try, /*On fail goto*//*Label 873*/ GIMT_Encode4(52517),
     /*  52363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  52366 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  52369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52373 */   GIM_Try, /*On fail goto*//*Label 874*/ GIMT_Encode4(52433), // Rule ID 13594 //
     /*  52378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  52389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  52393 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  52397 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52406 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  52412 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  52414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52418 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52420 */     // (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$LHS)  =>  (BICv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  52420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  52423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52425 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  52427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  52431 */     GIR_RootConstrainSelectedInstOperands,
     /*  52432 */     // GIR_Coverage, 13594,
     /*  52432 */     GIR_EraseRootFromParent_Done,
     /*  52433 */   // Label 874: @52433
     /*  52433 */   GIM_Try, /*On fail goto*//*Label 875*/ GIMT_Encode4(52493), // Rule ID 4979 //
     /*  52438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52441 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  52453 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  52457 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  52461 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52466 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52470 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  52476 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  52478 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52480 */     // (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }))  =>  (BICv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  52480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  52483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52485 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  52487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  52491 */     GIR_RootConstrainSelectedInstOperands,
     /*  52492 */     // GIR_Coverage, 4979,
     /*  52492 */     GIR_EraseRootFromParent_Done,
     /*  52493 */   // Label 875: @52493
     /*  52493 */   GIM_Try, /*On fail goto*//*Label 876*/ GIMT_Encode4(52516), // Rule ID 2473 //
     /*  52498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52509 */     // (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (ANDv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  52509 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  52514 */     GIR_RootConstrainSelectedInstOperands,
     /*  52515 */     // GIR_Coverage, 2473,
     /*  52515 */     GIR_Done,
     /*  52516 */   // Label 876: @52516
     /*  52516 */   GIM_Reject,
     /*  52517 */ // Label 873: @52517
     /*  52517 */ GIM_Reject,
     /*  52518 */ // Label 819: @52518
     /*  52518 */ GIM_Try, /*On fail goto*//*Label 877*/ GIMT_Encode4(52677),
     /*  52523 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52526 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52533 */   GIM_Try, /*On fail goto*//*Label 878*/ GIMT_Encode4(52593), // Rule ID 13598 //
     /*  52538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  52549 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52553 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52557 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52562 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52566 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  52572 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  52574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52578 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52580 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$LHS)  =>  (BICv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  52580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  52583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52585 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  52587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  52591 */     GIR_RootConstrainSelectedInstOperands,
     /*  52592 */     // GIR_Coverage, 13598,
     /*  52592 */     GIR_EraseRootFromParent_Done,
     /*  52593 */   // Label 878: @52593
     /*  52593 */   GIM_Try, /*On fail goto*//*Label 879*/ GIMT_Encode4(52653), // Rule ID 4983 //
     /*  52598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  52613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52617 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52621 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52626 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52630 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  52636 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  52638 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52640 */     // (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }))  =>  (BICv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  52640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  52643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52645 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  52647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  52651 */     GIR_RootConstrainSelectedInstOperands,
     /*  52652 */     // GIR_Coverage, 4983,
     /*  52652 */     GIR_EraseRootFromParent_Done,
     /*  52653 */   // Label 879: @52653
     /*  52653 */   GIM_Try, /*On fail goto*//*Label 880*/ GIMT_Encode4(52676), // Rule ID 2477 //
     /*  52658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52661 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52669 */     // (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (ANDv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  52669 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  52674 */     GIR_RootConstrainSelectedInstOperands,
     /*  52675 */     // GIR_Coverage, 2477,
     /*  52675 */     GIR_Done,
     /*  52676 */   // Label 880: @52676
     /*  52676 */   GIM_Reject,
     /*  52677 */ // Label 877: @52677
     /*  52677 */ GIM_Reject,
     /*  52678 */ // Label 820: @52678
     /*  52678 */ GIM_Try, /*On fail goto*//*Label 881*/ GIMT_Encode4(52837),
     /*  52683 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  52686 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  52689 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52693 */   GIM_Try, /*On fail goto*//*Label 882*/ GIMT_Encode4(52753), // Rule ID 13080 //
     /*  52698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  52709 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  52713 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  52717 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52722 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52726 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  52732 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  52734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52738 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52740 */     // (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rn)  =>  (BICv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  52740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  52743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  52747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52751 */     GIR_RootConstrainSelectedInstOperands,
     /*  52752 */     // GIR_Coverage, 13080,
     /*  52752 */     GIR_EraseRootFromParent_Done,
     /*  52753 */   // Label 882: @52753
     /*  52753 */   GIM_Try, /*On fail goto*//*Label 883*/ GIMT_Encode4(52813), // Rule ID 1590 //
     /*  52758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  52773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  52777 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  52781 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52786 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52790 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  52796 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  52798 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52800 */     // (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }))  =>  (BICv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  52800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  52803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52805 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52811 */     GIR_RootConstrainSelectedInstOperands,
     /*  52812 */     // GIR_Coverage, 1590,
     /*  52812 */     GIR_EraseRootFromParent_Done,
     /*  52813 */   // Label 883: @52813
     /*  52813 */   GIM_Try, /*On fail goto*//*Label 884*/ GIMT_Encode4(52836), // Rule ID 1588 //
     /*  52818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52829 */     // (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ANDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  52829 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  52834 */     GIR_RootConstrainSelectedInstOperands,
     /*  52835 */     // GIR_Coverage, 1588,
     /*  52835 */     GIR_Done,
     /*  52836 */   // Label 884: @52836
     /*  52836 */   GIM_Reject,
     /*  52837 */ // Label 881: @52837
     /*  52837 */ GIM_Reject,
     /*  52838 */ // Label 821: @52838
     /*  52838 */ GIM_Try, /*On fail goto*//*Label 885*/ GIMT_Encode4(52997),
     /*  52843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52846 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  52849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52853 */   GIM_Try, /*On fail goto*//*Label 886*/ GIMT_Encode4(52913), // Rule ID 13597 //
     /*  52858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  52869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52873 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  52877 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52882 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52886 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  52892 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  52894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52898 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52900 */     // (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$LHS)  =>  (BICv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  52900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  52903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52905 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  52907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  52911 */     GIR_RootConstrainSelectedInstOperands,
     /*  52912 */     // GIR_Coverage, 13597,
     /*  52912 */     GIR_EraseRootFromParent_Done,
     /*  52913 */   // Label 886: @52913
     /*  52913 */   GIM_Try, /*On fail goto*//*Label 887*/ GIMT_Encode4(52973), // Rule ID 4982 //
     /*  52918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  52933 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52937 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  52941 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52946 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52950 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  52956 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  52958 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52960 */     // (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }))  =>  (BICv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  52960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  52963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52965 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  52967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  52971 */     GIR_RootConstrainSelectedInstOperands,
     /*  52972 */     // GIR_Coverage, 4982,
     /*  52972 */     GIR_EraseRootFromParent_Done,
     /*  52973 */   // Label 887: @52973
     /*  52973 */   GIM_Try, /*On fail goto*//*Label 888*/ GIMT_Encode4(52996), // Rule ID 2476 //
     /*  52978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52981 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52989 */     // (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (ANDv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  52989 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  52994 */     GIR_RootConstrainSelectedInstOperands,
     /*  52995 */     // GIR_Coverage, 2476,
     /*  52995 */     GIR_Done,
     /*  52996 */   // Label 888: @52996
     /*  52996 */   GIM_Reject,
     /*  52997 */ // Label 885: @52997
     /*  52997 */ GIM_Reject,
     /*  52998 */ // Label 822: @52998
     /*  52998 */ GIM_Try, /*On fail goto*//*Label 889*/ GIMT_Encode4(53157),
     /*  53003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  53006 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  53009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53013 */   GIM_Try, /*On fail goto*//*Label 890*/ GIMT_Encode4(53073), // Rule ID 13081 //
     /*  53018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  53033 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  53037 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53042 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53046 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  53052 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  53054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53058 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53060 */     // (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rn)  =>  (BICv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  53060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  53063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  53067 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53071 */     GIR_RootConstrainSelectedInstOperands,
     /*  53072 */     // GIR_Coverage, 13081,
     /*  53072 */     GIR_EraseRootFromParent_Done,
     /*  53073 */   // Label 890: @53073
     /*  53073 */   GIM_Try, /*On fail goto*//*Label 891*/ GIMT_Encode4(53133), // Rule ID 1591 //
     /*  53078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53093 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  53097 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  53101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53106 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53110 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  53116 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  53118 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53120 */     // (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }))  =>  (BICv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  53120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  53123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53125 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53131 */     GIR_RootConstrainSelectedInstOperands,
     /*  53132 */     // GIR_Coverage, 1591,
     /*  53132 */     GIR_EraseRootFromParent_Done,
     /*  53133 */   // Label 891: @53133
     /*  53133 */   GIM_Try, /*On fail goto*//*Label 892*/ GIMT_Encode4(53156), // Rule ID 1589 //
     /*  53138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53149 */     // (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ANDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  53149 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  53154 */     GIR_RootConstrainSelectedInstOperands,
     /*  53155 */     // GIR_Coverage, 1589,
     /*  53155 */     GIR_Done,
     /*  53156 */   // Label 892: @53156
     /*  53156 */   GIM_Reject,
     /*  53157 */ // Label 889: @53157
     /*  53157 */ GIM_Reject,
     /*  53158 */ // Label 823: @53158
     /*  53158 */ GIM_Try, /*On fail goto*//*Label 893*/ GIMT_Encode4(53698),
     /*  53163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  53166 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  53169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  53173 */   GIM_Try, /*On fail goto*//*Label 894*/ GIMT_Encode4(53230), // Rule ID 14797 //
     /*  53178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  53181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  53193 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  53197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  53201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  53205 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  53209 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  53213 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53215 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] }), nxv1i1:{ *:[nxv1i1] }:$Op2), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  53215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  53218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  53220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  53222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  53224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  53228 */     GIR_RootConstrainSelectedInstOperands,
     /*  53229 */     // GIR_Coverage, 14797,
     /*  53229 */     GIR_EraseRootFromParent_Done,
     /*  53230 */   // Label 894: @53230
     /*  53230 */   GIM_Try, /*On fail goto*//*Label 895*/ GIMT_Encode4(53287), // Rule ID 14800 //
     /*  53235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  53238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  53250 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  53254 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  53258 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  53262 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  53266 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  53270 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53272 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] }), nxv1i1:{ *:[nxv1i1] }:$Op2), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  53272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  53275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  53277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  53279 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  53281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  53285 */     GIR_RootConstrainSelectedInstOperands,
     /*  53286 */     // GIR_Coverage, 14800,
     /*  53286 */     GIR_EraseRootFromParent_Done,
     /*  53287 */   // Label 895: @53287
     /*  53287 */   GIM_Try, /*On fail goto*//*Label 896*/ GIMT_Encode4(53344), // Rule ID 14796 //
     /*  53292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  53295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  53307 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  53311 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53315 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  53319 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  53323 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  53327 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53329 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] })), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  53329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  53332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  53334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  53336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  53338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  53342 */     GIR_RootConstrainSelectedInstOperands,
     /*  53343 */     // GIR_Coverage, 14796,
     /*  53343 */     GIR_EraseRootFromParent_Done,
     /*  53344 */   // Label 896: @53344
     /*  53344 */   GIM_Try, /*On fail goto*//*Label 897*/ GIMT_Encode4(53401), // Rule ID 14799 //
     /*  53349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  53352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  53364 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  53368 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53372 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  53376 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  53380 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  53384 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53386 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] })), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  53386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  53389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  53391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  53393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  53395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  53399 */     GIR_RootConstrainSelectedInstOperands,
     /*  53400 */     // GIR_Coverage, 14799,
     /*  53400 */     GIR_EraseRootFromParent_Done,
     /*  53401 */   // Label 897: @53401
     /*  53401 */   GIM_Try, /*On fail goto*//*Label 898*/ GIMT_Encode4(53458), // Rule ID 14795 //
     /*  53406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  53409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  53421 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  53425 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  53429 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  53433 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  53437 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  53441 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53443 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] }), nxv1i1:{ *:[nxv1i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  53443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  53446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  53448 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  53450 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  53452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  53456 */     GIR_RootConstrainSelectedInstOperands,
     /*  53457 */     // GIR_Coverage, 14795,
     /*  53457 */     GIR_EraseRootFromParent_Done,
     /*  53458 */   // Label 898: @53458
     /*  53458 */   GIM_Try, /*On fail goto*//*Label 899*/ GIMT_Encode4(53515), // Rule ID 14798 //
     /*  53463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  53466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53474 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  53478 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  53482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  53486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  53490 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  53494 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  53498 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53500 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] }), nxv1i1:{ *:[nxv1i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  53500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  53503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  53505 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  53507 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  53509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  53513 */     GIR_RootConstrainSelectedInstOperands,
     /*  53514 */     // GIR_Coverage, 14798,
     /*  53514 */     GIR_EraseRootFromParent_Done,
     /*  53515 */   // Label 899: @53515
     /*  53515 */   GIM_Try, /*On fail goto*//*Label 900*/ GIMT_Encode4(53572), // Rule ID 8277 //
     /*  53520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  53523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53531 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  53535 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  53539 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53543 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  53547 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  53551 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  53555 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53557 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  53557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  53560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  53562 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  53564 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  53566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  53570 */     GIR_RootConstrainSelectedInstOperands,
     /*  53571 */     // GIR_Coverage, 8277,
     /*  53571 */     GIR_EraseRootFromParent_Done,
     /*  53572 */   // Label 900: @53572
     /*  53572 */   GIM_Try, /*On fail goto*//*Label 901*/ GIMT_Encode4(53629), // Rule ID 8278 //
     /*  53577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  53580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  53592 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  53596 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53600 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  53604 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  53608 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  53612 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53614 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  53614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  53617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  53619 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  53621 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  53623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  53627 */     GIR_RootConstrainSelectedInstOperands,
     /*  53628 */     // GIR_Coverage, 8278,
     /*  53628 */     GIR_EraseRootFromParent_Done,
     /*  53629 */   // Label 901: @53629
     /*  53629 */   GIM_Try, /*On fail goto*//*Label 902*/ GIMT_Encode4(53676), // Rule ID 10529 //
     /*  53634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  53637 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  53641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  53645 */     // (and:{ *:[nxv1i1] } PPR:{ *:[nxv1i1] }:$Ps1, PPR:{ *:[nxv1i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv1i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv1i1] }:$Ps1, PPR:{ *:[nxv1i1] }:$Ps2)
     /*  53645 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  53648 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  53652 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53657 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  53660 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  53665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  53667 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53670 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  53672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  53674 */     GIR_RootConstrainSelectedInstOperands,
     /*  53675 */     // GIR_Coverage, 10529,
     /*  53675 */     GIR_EraseRootFromParent_Done,
     /*  53676 */   // Label 902: @53676
     /*  53676 */   GIM_Try, /*On fail goto*//*Label 903*/ GIMT_Encode4(53697), // Rule ID 2739 //
     /*  53681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  53684 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  53684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  53687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  53689 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  53691 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  53693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  53695 */     GIR_RootConstrainSelectedInstOperands,
     /*  53696 */     // GIR_Coverage, 2739,
     /*  53696 */     GIR_EraseRootFromParent_Done,
     /*  53697 */   // Label 903: @53697
     /*  53697 */   GIM_Reject,
     /*  53698 */ // Label 893: @53698
     /*  53698 */ GIM_Reject,
     /*  53699 */ // Label 824: @53699
     /*  53699 */ GIM_Try, /*On fail goto*//*Label 904*/ GIMT_Encode4(54239),
     /*  53704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  53707 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  53710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  53714 */   GIM_Try, /*On fail goto*//*Label 905*/ GIMT_Encode4(53771), // Rule ID 14788 //
     /*  53719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  53722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53730 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  53734 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  53738 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  53742 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  53746 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  53750 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  53754 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53756 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] }), nxv2i1:{ *:[nxv2i1] }:$Op2), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  53756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  53759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  53761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  53763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  53765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  53769 */     GIR_RootConstrainSelectedInstOperands,
     /*  53770 */     // GIR_Coverage, 14788,
     /*  53770 */     GIR_EraseRootFromParent_Done,
     /*  53771 */   // Label 905: @53771
     /*  53771 */   GIM_Try, /*On fail goto*//*Label 906*/ GIMT_Encode4(53828), // Rule ID 14791 //
     /*  53776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  53779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53787 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  53791 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  53795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  53799 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  53803 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  53807 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  53811 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53813 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] }), nxv2i1:{ *:[nxv2i1] }:$Op2), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  53813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  53816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  53818 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  53820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  53822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  53826 */     GIR_RootConstrainSelectedInstOperands,
     /*  53827 */     // GIR_Coverage, 14791,
     /*  53827 */     GIR_EraseRootFromParent_Done,
     /*  53828 */   // Label 906: @53828
     /*  53828 */   GIM_Try, /*On fail goto*//*Label 907*/ GIMT_Encode4(53885), // Rule ID 14787 //
     /*  53833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  53836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53844 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  53848 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  53852 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53856 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  53860 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  53864 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  53868 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53870 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] })), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  53870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  53873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  53875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  53877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  53879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  53883 */     GIR_RootConstrainSelectedInstOperands,
     /*  53884 */     // GIR_Coverage, 14787,
     /*  53884 */     GIR_EraseRootFromParent_Done,
     /*  53885 */   // Label 907: @53885
     /*  53885 */   GIM_Try, /*On fail goto*//*Label 908*/ GIMT_Encode4(53942), // Rule ID 14790 //
     /*  53890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  53893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53901 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  53905 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  53909 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53913 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  53917 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  53921 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  53925 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53927 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] })), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  53927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  53930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  53932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  53934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  53936 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  53940 */     GIR_RootConstrainSelectedInstOperands,
     /*  53941 */     // GIR_Coverage, 14790,
     /*  53941 */     GIR_EraseRootFromParent_Done,
     /*  53942 */   // Label 908: @53942
     /*  53942 */   GIM_Try, /*On fail goto*//*Label 909*/ GIMT_Encode4(53999), // Rule ID 14786 //
     /*  53947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  53950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  53962 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  53966 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  53970 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  53974 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  53978 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  53982 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53984 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] }), nxv2i1:{ *:[nxv2i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  53984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  53987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  53989 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  53991 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  53993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  53997 */     GIR_RootConstrainSelectedInstOperands,
     /*  53998 */     // GIR_Coverage, 14786,
     /*  53998 */     GIR_EraseRootFromParent_Done,
     /*  53999 */   // Label 909: @53999
     /*  53999 */   GIM_Try, /*On fail goto*//*Label 910*/ GIMT_Encode4(54056), // Rule ID 14789 //
     /*  54004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  54019 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  54023 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54027 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  54031 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  54035 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  54039 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54041 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] }), nxv2i1:{ *:[nxv2i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  54041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  54044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  54046 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  54048 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  54050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  54054 */     GIR_RootConstrainSelectedInstOperands,
     /*  54055 */     // GIR_Coverage, 14789,
     /*  54055 */     GIR_EraseRootFromParent_Done,
     /*  54056 */   // Label 910: @54056
     /*  54056 */   GIM_Try, /*On fail goto*//*Label 911*/ GIMT_Encode4(54113), // Rule ID 8273 //
     /*  54061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  54076 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  54080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  54088 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  54092 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  54096 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54098 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  54098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  54101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  54103 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  54105 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  54107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  54111 */     GIR_RootConstrainSelectedInstOperands,
     /*  54112 */     // GIR_Coverage, 8273,
     /*  54112 */     GIR_EraseRootFromParent_Done,
     /*  54113 */   // Label 911: @54113
     /*  54113 */   GIM_Try, /*On fail goto*//*Label 912*/ GIMT_Encode4(54170), // Rule ID 8274 //
     /*  54118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  54133 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  54137 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54141 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  54145 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  54149 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  54153 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54155 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  54155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  54158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  54160 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  54162 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  54164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  54168 */     GIR_RootConstrainSelectedInstOperands,
     /*  54169 */     // GIR_Coverage, 8274,
     /*  54169 */     GIR_EraseRootFromParent_Done,
     /*  54170 */   // Label 912: @54170
     /*  54170 */   GIM_Try, /*On fail goto*//*Label 913*/ GIMT_Encode4(54217), // Rule ID 10528 //
     /*  54175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  54182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  54186 */     // (and:{ *:[nxv2i1] } PPR:{ *:[nxv2i1] }:$Ps1, PPR:{ *:[nxv2i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv2i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv2i1] }:$Ps1, PPR:{ *:[nxv2i1] }:$Ps2)
     /*  54186 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  54189 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  54193 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54198 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  54201 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  54206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  54208 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54211 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  54213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  54215 */     GIR_RootConstrainSelectedInstOperands,
     /*  54216 */     // GIR_Coverage, 10528,
     /*  54216 */     GIR_EraseRootFromParent_Done,
     /*  54217 */   // Label 913: @54217
     /*  54217 */   GIM_Try, /*On fail goto*//*Label 914*/ GIMT_Encode4(54238), // Rule ID 2738 //
     /*  54222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54225 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  54225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  54228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  54230 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  54232 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  54234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  54236 */     GIR_RootConstrainSelectedInstOperands,
     /*  54237 */     // GIR_Coverage, 2738,
     /*  54237 */     GIR_EraseRootFromParent_Done,
     /*  54238 */   // Label 914: @54238
     /*  54238 */   GIM_Reject,
     /*  54239 */ // Label 904: @54239
     /*  54239 */ GIM_Reject,
     /*  54240 */ // Label 825: @54240
     /*  54240 */ GIM_Try, /*On fail goto*//*Label 915*/ GIMT_Encode4(54711),
     /*  54245 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  54248 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  54251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  54255 */   GIM_Try, /*On fail goto*//*Label 916*/ GIMT_Encode4(54310), // Rule ID 14728 //
     /*  54260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54271 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  54275 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  54279 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54283 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  54287 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  54291 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  54295 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54297 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  54297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  54300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  54302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  54304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  54308 */     GIR_RootConstrainSelectedInstOperands,
     /*  54309 */     // GIR_Coverage, 14728,
     /*  54309 */     GIR_EraseRootFromParent_Done,
     /*  54310 */   // Label 916: @54310
     /*  54310 */   GIM_Try, /*On fail goto*//*Label 917*/ GIMT_Encode4(54365), // Rule ID 14731 //
     /*  54315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54326 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  54330 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  54334 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54338 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  54342 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  54346 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  54350 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54352 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  54352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  54355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  54357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  54359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  54363 */     GIR_RootConstrainSelectedInstOperands,
     /*  54364 */     // GIR_Coverage, 14731,
     /*  54364 */     GIR_EraseRootFromParent_Done,
     /*  54365 */   // Label 917: @54365
     /*  54365 */   GIM_Try, /*On fail goto*//*Label 918*/ GIMT_Encode4(54420), // Rule ID 14727 //
     /*  54370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  54385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  54389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  54397 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  54401 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  54405 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54407 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  54407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  54410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  54412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  54414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  54418 */     GIR_RootConstrainSelectedInstOperands,
     /*  54419 */     // GIR_Coverage, 14727,
     /*  54419 */     GIR_EraseRootFromParent_Done,
     /*  54420 */   // Label 918: @54420
     /*  54420 */   GIM_Try, /*On fail goto*//*Label 919*/ GIMT_Encode4(54475), // Rule ID 14730 //
     /*  54425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  54440 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  54444 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54448 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  54452 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  54456 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  54460 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54462 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  54462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  54465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  54467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  54469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  54473 */     GIR_RootConstrainSelectedInstOperands,
     /*  54474 */     // GIR_Coverage, 14730,
     /*  54474 */     GIR_EraseRootFromParent_Done,
     /*  54475 */   // Label 919: @54475
     /*  54475 */   GIM_Try, /*On fail goto*//*Label 920*/ GIMT_Encode4(54530), // Rule ID 14726 //
     /*  54480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54491 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  54495 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  54499 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54503 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  54507 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  54511 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  54515 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54517 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  54517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  54520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  54522 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  54524 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  54528 */     GIR_RootConstrainSelectedInstOperands,
     /*  54529 */     // GIR_Coverage, 14726,
     /*  54529 */     GIR_EraseRootFromParent_Done,
     /*  54530 */   // Label 920: @54530
     /*  54530 */   GIM_Try, /*On fail goto*//*Label 921*/ GIMT_Encode4(54585), // Rule ID 14729 //
     /*  54535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54546 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  54550 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  54554 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54558 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  54562 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  54566 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  54570 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54572 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  54572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  54575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  54577 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  54579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  54583 */     GIR_RootConstrainSelectedInstOperands,
     /*  54584 */     // GIR_Coverage, 14729,
     /*  54584 */     GIR_EraseRootFromParent_Done,
     /*  54585 */   // Label 921: @54585
     /*  54585 */   GIM_Try, /*On fail goto*//*Label 922*/ GIMT_Encode4(54640), // Rule ID 7326 //
     /*  54590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  54605 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  54609 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54613 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  54617 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  54621 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  54625 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54627 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  54627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  54630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  54632 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  54634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  54638 */     GIR_RootConstrainSelectedInstOperands,
     /*  54639 */     // GIR_Coverage, 7326,
     /*  54639 */     GIR_EraseRootFromParent_Done,
     /*  54640 */   // Label 922: @54640
     /*  54640 */   GIM_Try, /*On fail goto*//*Label 923*/ GIMT_Encode4(54695), // Rule ID 7327 //
     /*  54645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54656 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  54660 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  54664 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54668 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  54672 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  54676 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  54680 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54682 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  54682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  54685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  54687 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  54689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  54693 */     GIR_RootConstrainSelectedInstOperands,
     /*  54694 */     // GIR_Coverage, 7327,
     /*  54694 */     GIR_EraseRootFromParent_Done,
     /*  54695 */   // Label 923: @54695
     /*  54695 */   GIM_Try, /*On fail goto*//*Label 924*/ GIMT_Encode4(54710), // Rule ID 3132 //
     /*  54700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54703 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  54703 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  54708 */     GIR_RootConstrainSelectedInstOperands,
     /*  54709 */     // GIR_Coverage, 3132,
     /*  54709 */     GIR_Done,
     /*  54710 */   // Label 924: @54710
     /*  54710 */   GIM_Reject,
     /*  54711 */ // Label 915: @54711
     /*  54711 */ GIM_Reject,
     /*  54712 */ // Label 826: @54712
     /*  54712 */ GIM_Try, /*On fail goto*//*Label 925*/ GIMT_Encode4(55252),
     /*  54717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  54720 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  54723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  54727 */   GIM_Try, /*On fail goto*//*Label 926*/ GIMT_Encode4(54784), // Rule ID 14779 //
     /*  54732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54743 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  54747 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  54751 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54755 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  54759 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  54763 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  54767 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54769 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] }), nxv4i1:{ *:[nxv4i1] }:$Op2), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  54769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  54772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  54774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  54776 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  54778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  54782 */     GIR_RootConstrainSelectedInstOperands,
     /*  54783 */     // GIR_Coverage, 14779,
     /*  54783 */     GIR_EraseRootFromParent_Done,
     /*  54784 */   // Label 926: @54784
     /*  54784 */   GIM_Try, /*On fail goto*//*Label 927*/ GIMT_Encode4(54841), // Rule ID 14782 //
     /*  54789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54800 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  54804 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  54808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  54816 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  54820 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  54824 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54826 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] }), nxv4i1:{ *:[nxv4i1] }:$Op2), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  54826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  54829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  54831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  54833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  54835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  54839 */     GIR_RootConstrainSelectedInstOperands,
     /*  54840 */     // GIR_Coverage, 14782,
     /*  54840 */     GIR_EraseRootFromParent_Done,
     /*  54841 */   // Label 927: @54841
     /*  54841 */   GIM_Try, /*On fail goto*//*Label 928*/ GIMT_Encode4(54898), // Rule ID 14778 //
     /*  54846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54857 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  54861 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  54865 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54869 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  54873 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  54877 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  54881 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54883 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] })), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  54883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  54886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  54888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  54890 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  54892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  54896 */     GIR_RootConstrainSelectedInstOperands,
     /*  54897 */     // GIR_Coverage, 14778,
     /*  54897 */     GIR_EraseRootFromParent_Done,
     /*  54898 */   // Label 928: @54898
     /*  54898 */   GIM_Try, /*On fail goto*//*Label 929*/ GIMT_Encode4(54955), // Rule ID 14781 //
     /*  54903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  54918 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  54922 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54926 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  54930 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  54934 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  54938 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54940 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] })), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  54940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  54943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  54945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  54947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  54949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  54953 */     GIR_RootConstrainSelectedInstOperands,
     /*  54954 */     // GIR_Coverage, 14781,
     /*  54954 */     GIR_EraseRootFromParent_Done,
     /*  54955 */   // Label 929: @54955
     /*  54955 */   GIM_Try, /*On fail goto*//*Label 930*/ GIMT_Encode4(55012), // Rule ID 14777 //
     /*  54960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  54963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  54975 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  54979 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54983 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  54987 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  54991 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  54995 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54997 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] }), nxv4i1:{ *:[nxv4i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  54997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  55000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  55002 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  55004 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  55006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  55010 */     GIR_RootConstrainSelectedInstOperands,
     /*  55011 */     // GIR_Coverage, 14777,
     /*  55011 */     GIR_EraseRootFromParent_Done,
     /*  55012 */   // Label 930: @55012
     /*  55012 */   GIM_Try, /*On fail goto*//*Label 931*/ GIMT_Encode4(55069), // Rule ID 14780 //
     /*  55017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55028 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  55032 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  55036 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55040 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55044 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  55048 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55052 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55054 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] }), nxv4i1:{ *:[nxv4i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  55054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  55057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  55059 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  55061 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  55063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  55067 */     GIR_RootConstrainSelectedInstOperands,
     /*  55068 */     // GIR_Coverage, 14780,
     /*  55068 */     GIR_EraseRootFromParent_Done,
     /*  55069 */   // Label 931: @55069
     /*  55069 */   GIM_Try, /*On fail goto*//*Label 932*/ GIMT_Encode4(55126), // Rule ID 8269 //
     /*  55074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55085 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  55089 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  55093 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55097 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55101 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  55105 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55109 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55111 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  55111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  55114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  55116 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  55118 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  55120 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  55124 */     GIR_RootConstrainSelectedInstOperands,
     /*  55125 */     // GIR_Coverage, 8269,
     /*  55125 */     GIR_EraseRootFromParent_Done,
     /*  55126 */   // Label 932: @55126
     /*  55126 */   GIM_Try, /*On fail goto*//*Label 933*/ GIMT_Encode4(55183), // Rule ID 8270 //
     /*  55131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55142 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  55146 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  55150 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55154 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55158 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  55162 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55166 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55168 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  55168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  55171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  55173 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  55175 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  55177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  55181 */     GIR_RootConstrainSelectedInstOperands,
     /*  55182 */     // GIR_Coverage, 8270,
     /*  55182 */     GIR_EraseRootFromParent_Done,
     /*  55183 */   // Label 933: @55183
     /*  55183 */   GIM_Try, /*On fail goto*//*Label 934*/ GIMT_Encode4(55230), // Rule ID 10527 //
     /*  55188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55191 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  55195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  55199 */     // (and:{ *:[nxv4i1] } PPR:{ *:[nxv4i1] }:$Ps1, PPR:{ *:[nxv4i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv4i1] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv4i1] }:$Ps1, PPR:{ *:[nxv4i1] }:$Ps2)
     /*  55199 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  55202 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /*  55206 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55211 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  55214 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  55216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  55219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  55221 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  55224 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  55226 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  55228 */     GIR_RootConstrainSelectedInstOperands,
     /*  55229 */     // GIR_Coverage, 10527,
     /*  55229 */     GIR_EraseRootFromParent_Done,
     /*  55230 */   // Label 934: @55230
     /*  55230 */   GIM_Try, /*On fail goto*//*Label 935*/ GIMT_Encode4(55251), // Rule ID 2737 //
     /*  55235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55238 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  55238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  55241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  55243 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  55245 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  55247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  55249 */     GIR_RootConstrainSelectedInstOperands,
     /*  55250 */     // GIR_Coverage, 2737,
     /*  55250 */     GIR_EraseRootFromParent_Done,
     /*  55251 */   // Label 935: @55251
     /*  55251 */   GIM_Reject,
     /*  55252 */ // Label 925: @55252
     /*  55252 */ GIM_Reject,
     /*  55253 */ // Label 827: @55253
     /*  55253 */ GIM_Try, /*On fail goto*//*Label 936*/ GIMT_Encode4(55724),
     /*  55258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  55261 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  55264 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  55268 */   GIM_Try, /*On fail goto*//*Label 937*/ GIMT_Encode4(55323), // Rule ID 14719 //
     /*  55273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  55288 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  55292 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55296 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55300 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  55304 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55308 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55310 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  55310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  55313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  55315 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  55321 */     GIR_RootConstrainSelectedInstOperands,
     /*  55322 */     // GIR_Coverage, 14719,
     /*  55322 */     GIR_EraseRootFromParent_Done,
     /*  55323 */   // Label 937: @55323
     /*  55323 */   GIM_Try, /*On fail goto*//*Label 938*/ GIMT_Encode4(55378), // Rule ID 14722 //
     /*  55328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  55343 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  55347 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55351 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55355 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  55359 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55363 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55365 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] }), nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  55365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  55368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  55370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  55376 */     GIR_RootConstrainSelectedInstOperands,
     /*  55377 */     // GIR_Coverage, 14722,
     /*  55377 */     GIR_EraseRootFromParent_Done,
     /*  55378 */   // Label 938: @55378
     /*  55378 */   GIM_Try, /*On fail goto*//*Label 939*/ GIMT_Encode4(55433), // Rule ID 14718 //
     /*  55383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55394 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  55398 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  55402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55406 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55410 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  55414 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55418 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55420 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] })), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  55420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  55423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  55425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  55431 */     GIR_RootConstrainSelectedInstOperands,
     /*  55432 */     // GIR_Coverage, 14718,
     /*  55432 */     GIR_EraseRootFromParent_Done,
     /*  55433 */   // Label 939: @55433
     /*  55433 */   GIM_Try, /*On fail goto*//*Label 940*/ GIMT_Encode4(55488), // Rule ID 14721 //
     /*  55438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  55453 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  55457 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55461 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55465 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  55469 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55473 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55475 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] })), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  55475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  55478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  55480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  55486 */     GIR_RootConstrainSelectedInstOperands,
     /*  55487 */     // GIR_Coverage, 14721,
     /*  55487 */     GIR_EraseRootFromParent_Done,
     /*  55488 */   // Label 940: @55488
     /*  55488 */   GIM_Try, /*On fail goto*//*Label 941*/ GIMT_Encode4(55543), // Rule ID 14717 //
     /*  55493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55504 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  55508 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  55512 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55516 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55520 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  55524 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55528 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55530 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  55530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  55533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  55535 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  55537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  55541 */     GIR_RootConstrainSelectedInstOperands,
     /*  55542 */     // GIR_Coverage, 14717,
     /*  55542 */     GIR_EraseRootFromParent_Done,
     /*  55543 */   // Label 941: @55543
     /*  55543 */   GIM_Try, /*On fail goto*//*Label 942*/ GIMT_Encode4(55598), // Rule ID 14720 //
     /*  55548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55559 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  55563 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  55567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55575 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  55579 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55583 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55585 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  55585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  55588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  55590 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  55592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  55596 */     GIR_RootConstrainSelectedInstOperands,
     /*  55597 */     // GIR_Coverage, 14720,
     /*  55597 */     GIR_EraseRootFromParent_Done,
     /*  55598 */   // Label 942: @55598
     /*  55598 */   GIM_Try, /*On fail goto*//*Label 943*/ GIMT_Encode4(55653), // Rule ID 7322 //
     /*  55603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55614 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  55618 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  55622 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55626 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55630 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  55634 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55638 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55640 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  55640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  55643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  55645 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  55647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  55651 */     GIR_RootConstrainSelectedInstOperands,
     /*  55652 */     // GIR_Coverage, 7322,
     /*  55652 */     GIR_EraseRootFromParent_Done,
     /*  55653 */   // Label 943: @55653
     /*  55653 */   GIM_Try, /*On fail goto*//*Label 944*/ GIMT_Encode4(55708), // Rule ID 7323 //
     /*  55658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  55673 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  55677 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55681 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55685 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  55689 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55693 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55695 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  55695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  55698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  55700 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  55702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  55706 */     GIR_RootConstrainSelectedInstOperands,
     /*  55707 */     // GIR_Coverage, 7323,
     /*  55707 */     GIR_EraseRootFromParent_Done,
     /*  55708 */   // Label 944: @55708
     /*  55708 */   GIM_Try, /*On fail goto*//*Label 945*/ GIMT_Encode4(55723), // Rule ID 3131 //
     /*  55713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55716 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  55716 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  55721 */     GIR_RootConstrainSelectedInstOperands,
     /*  55722 */     // GIR_Coverage, 3131,
     /*  55722 */     GIR_Done,
     /*  55723 */   // Label 945: @55723
     /*  55723 */   GIM_Reject,
     /*  55724 */ // Label 936: @55724
     /*  55724 */ GIM_Reject,
     /*  55725 */ // Label 828: @55725
     /*  55725 */ GIM_Try, /*On fail goto*//*Label 946*/ GIMT_Encode4(56265),
     /*  55730 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  55733 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  55736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  55740 */   GIM_Try, /*On fail goto*//*Label 947*/ GIMT_Encode4(55797), // Rule ID 14770 //
     /*  55745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  55760 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  55764 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55768 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55772 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  55776 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55780 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55782 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] }), nxv8i1:{ *:[nxv8i1] }:$Op2), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  55782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  55785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  55787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  55795 */     GIR_RootConstrainSelectedInstOperands,
     /*  55796 */     // GIR_Coverage, 14770,
     /*  55796 */     GIR_EraseRootFromParent_Done,
     /*  55797 */   // Label 947: @55797
     /*  55797 */   GIM_Try, /*On fail goto*//*Label 948*/ GIMT_Encode4(55854), // Rule ID 14773 //
     /*  55802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55813 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  55817 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  55821 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55825 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55829 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  55833 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55837 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55839 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] }), nxv8i1:{ *:[nxv8i1] }:$Op2), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  55839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  55842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  55844 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  55852 */     GIR_RootConstrainSelectedInstOperands,
     /*  55853 */     // GIR_Coverage, 14773,
     /*  55853 */     GIR_EraseRootFromParent_Done,
     /*  55854 */   // Label 948: @55854
     /*  55854 */   GIM_Try, /*On fail goto*//*Label 949*/ GIMT_Encode4(55911), // Rule ID 14769 //
     /*  55859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  55874 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  55878 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55882 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55886 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  55890 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55894 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55896 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] })), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  55896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  55899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  55901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  55909 */     GIR_RootConstrainSelectedInstOperands,
     /*  55910 */     // GIR_Coverage, 14769,
     /*  55910 */     GIR_EraseRootFromParent_Done,
     /*  55911 */   // Label 949: @55911
     /*  55911 */   GIM_Try, /*On fail goto*//*Label 950*/ GIMT_Encode4(55968), // Rule ID 14772 //
     /*  55916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  55931 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  55935 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55939 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55943 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  55947 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55951 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55953 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] })), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  55953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  55956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  55958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  55966 */     GIR_RootConstrainSelectedInstOperands,
     /*  55967 */     // GIR_Coverage, 14772,
     /*  55967 */     GIR_EraseRootFromParent_Done,
     /*  55968 */   // Label 950: @55968
     /*  55968 */   GIM_Try, /*On fail goto*//*Label 951*/ GIMT_Encode4(56025), // Rule ID 14768 //
     /*  55973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  55988 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  55992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56000 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56004 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56008 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56010 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] }), nxv8i1:{ *:[nxv8i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  56010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56015 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56017 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56023 */     GIR_RootConstrainSelectedInstOperands,
     /*  56024 */     // GIR_Coverage, 14768,
     /*  56024 */     GIR_EraseRootFromParent_Done,
     /*  56025 */   // Label 951: @56025
     /*  56025 */   GIM_Try, /*On fail goto*//*Label 952*/ GIMT_Encode4(56082), // Rule ID 14771 //
     /*  56030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56041 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  56045 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  56049 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56053 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56057 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56061 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56065 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56067 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] }), nxv8i1:{ *:[nxv8i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  56067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56072 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56074 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56080 */     GIR_RootConstrainSelectedInstOperands,
     /*  56081 */     // GIR_Coverage, 14771,
     /*  56081 */     GIR_EraseRootFromParent_Done,
     /*  56082 */   // Label 952: @56082
     /*  56082 */   GIM_Try, /*On fail goto*//*Label 953*/ GIMT_Encode4(56139), // Rule ID 8265 //
     /*  56087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56098 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  56102 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  56106 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56110 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56114 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56118 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56122 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56124 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  56124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56129 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56131 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56137 */     GIR_RootConstrainSelectedInstOperands,
     /*  56138 */     // GIR_Coverage, 8265,
     /*  56138 */     GIR_EraseRootFromParent_Done,
     /*  56139 */   // Label 953: @56139
     /*  56139 */   GIM_Try, /*On fail goto*//*Label 954*/ GIMT_Encode4(56196), // Rule ID 8266 //
     /*  56144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  56159 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  56163 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56167 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56171 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56175 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56179 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56181 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  56181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56186 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56188 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56194 */     GIR_RootConstrainSelectedInstOperands,
     /*  56195 */     // GIR_Coverage, 8266,
     /*  56195 */     GIR_EraseRootFromParent_Done,
     /*  56196 */   // Label 954: @56196
     /*  56196 */   GIM_Try, /*On fail goto*//*Label 955*/ GIMT_Encode4(56243), // Rule ID 10526 //
     /*  56201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56204 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  56208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  56212 */     // (and:{ *:[nxv8i1] } PPR:{ *:[nxv8i1] }:$Ps1, PPR:{ *:[nxv8i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv8i1] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv8i1] }:$Ps1, PPR:{ *:[nxv8i1] }:$Ps2)
     /*  56212 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  56215 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /*  56219 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56224 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  56227 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  56229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  56232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  56237 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  56239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  56241 */     GIR_RootConstrainSelectedInstOperands,
     /*  56242 */     // GIR_Coverage, 10526,
     /*  56242 */     GIR_EraseRootFromParent_Done,
     /*  56243 */   // Label 955: @56243
     /*  56243 */   GIM_Try, /*On fail goto*//*Label 956*/ GIMT_Encode4(56264), // Rule ID 2736 //
     /*  56248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56251 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  56251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  56254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56256 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56258 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  56262 */     GIR_RootConstrainSelectedInstOperands,
     /*  56263 */     // GIR_Coverage, 2736,
     /*  56263 */     GIR_EraseRootFromParent_Done,
     /*  56264 */   // Label 956: @56264
     /*  56264 */   GIM_Reject,
     /*  56265 */ // Label 946: @56265
     /*  56265 */ GIM_Reject,
     /*  56266 */ // Label 829: @56266
     /*  56266 */ GIM_Try, /*On fail goto*//*Label 957*/ GIMT_Encode4(56737),
     /*  56271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  56274 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  56277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  56281 */   GIM_Try, /*On fail goto*//*Label 958*/ GIMT_Encode4(56336), // Rule ID 14710 //
     /*  56286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56297 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  56301 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  56305 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56309 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56313 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56317 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56321 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56323 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] }), nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  56323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  56326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  56328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56334 */     GIR_RootConstrainSelectedInstOperands,
     /*  56335 */     // GIR_Coverage, 14710,
     /*  56335 */     GIR_EraseRootFromParent_Done,
     /*  56336 */   // Label 958: @56336
     /*  56336 */   GIM_Try, /*On fail goto*//*Label 959*/ GIMT_Encode4(56391), // Rule ID 14713 //
     /*  56341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  56356 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  56360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56368 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56372 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56376 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56378 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] }), nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  56378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  56381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  56383 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56389 */     GIR_RootConstrainSelectedInstOperands,
     /*  56390 */     // GIR_Coverage, 14713,
     /*  56390 */     GIR_EraseRootFromParent_Done,
     /*  56391 */   // Label 959: @56391
     /*  56391 */   GIM_Try, /*On fail goto*//*Label 960*/ GIMT_Encode4(56446), // Rule ID 14709 //
     /*  56396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  56411 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  56415 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56419 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56423 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56427 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56431 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56433 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] })), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  56433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  56436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  56438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56444 */     GIR_RootConstrainSelectedInstOperands,
     /*  56445 */     // GIR_Coverage, 14709,
     /*  56445 */     GIR_EraseRootFromParent_Done,
     /*  56446 */   // Label 960: @56446
     /*  56446 */   GIM_Try, /*On fail goto*//*Label 961*/ GIMT_Encode4(56501), // Rule ID 14712 //
     /*  56451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  56466 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  56470 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56474 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56478 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56482 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56486 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56488 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] })), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  56488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  56491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  56493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56499 */     GIR_RootConstrainSelectedInstOperands,
     /*  56500 */     // GIR_Coverage, 14712,
     /*  56500 */     GIR_EraseRootFromParent_Done,
     /*  56501 */   // Label 961: @56501
     /*  56501 */   GIM_Try, /*On fail goto*//*Label 962*/ GIMT_Encode4(56556), // Rule ID 14708 //
     /*  56506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  56521 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  56525 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56529 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56533 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56537 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56541 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56543 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  56543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  56546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  56548 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56554 */     GIR_RootConstrainSelectedInstOperands,
     /*  56555 */     // GIR_Coverage, 14708,
     /*  56555 */     GIR_EraseRootFromParent_Done,
     /*  56556 */   // Label 962: @56556
     /*  56556 */   GIM_Try, /*On fail goto*//*Label 963*/ GIMT_Encode4(56611), // Rule ID 14711 //
     /*  56561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  56576 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  56580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56588 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56592 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56596 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56598 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  56598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  56601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  56603 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56609 */     GIR_RootConstrainSelectedInstOperands,
     /*  56610 */     // GIR_Coverage, 14711,
     /*  56610 */     GIR_EraseRootFromParent_Done,
     /*  56611 */   // Label 963: @56611
     /*  56611 */   GIM_Try, /*On fail goto*//*Label 964*/ GIMT_Encode4(56666), // Rule ID 7318 //
     /*  56616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  56631 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  56635 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56639 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56643 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56647 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56651 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56653 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  56653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  56656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  56658 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56664 */     GIR_RootConstrainSelectedInstOperands,
     /*  56665 */     // GIR_Coverage, 7318,
     /*  56665 */     GIR_EraseRootFromParent_Done,
     /*  56666 */   // Label 964: @56666
     /*  56666 */   GIM_Try, /*On fail goto*//*Label 965*/ GIMT_Encode4(56721), // Rule ID 7319 //
     /*  56671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56682 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  56686 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  56690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56698 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56702 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56706 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56708 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  56708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  56711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  56713 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56719 */     GIR_RootConstrainSelectedInstOperands,
     /*  56720 */     // GIR_Coverage, 7319,
     /*  56720 */     GIR_EraseRootFromParent_Done,
     /*  56721 */   // Label 965: @56721
     /*  56721 */   GIM_Try, /*On fail goto*//*Label 966*/ GIMT_Encode4(56736), // Rule ID 3130 //
     /*  56726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56729 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  56729 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  56734 */     GIR_RootConstrainSelectedInstOperands,
     /*  56735 */     // GIR_Coverage, 3130,
     /*  56735 */     GIR_Done,
     /*  56736 */   // Label 966: @56736
     /*  56736 */   GIM_Reject,
     /*  56737 */ // Label 957: @56737
     /*  56737 */ GIM_Reject,
     /*  56738 */ // Label 830: @56738
     /*  56738 */ GIM_Try, /*On fail goto*//*Label 967*/ GIMT_Encode4(57278),
     /*  56743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  56746 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  56749 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  56753 */   GIM_Try, /*On fail goto*//*Label 968*/ GIMT_Encode4(56810), // Rule ID 14761 //
     /*  56758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56769 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  56773 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  56777 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56781 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56785 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56789 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56793 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56795 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] }), nxv16i1:{ *:[nxv16i1] }:$Op2), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  56795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56802 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56808 */     GIR_RootConstrainSelectedInstOperands,
     /*  56809 */     // GIR_Coverage, 14761,
     /*  56809 */     GIR_EraseRootFromParent_Done,
     /*  56810 */   // Label 968: @56810
     /*  56810 */   GIM_Try, /*On fail goto*//*Label 969*/ GIMT_Encode4(56867), // Rule ID 14764 //
     /*  56815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  56830 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  56834 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56838 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56842 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56846 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56850 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56852 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] }), nxv16i1:{ *:[nxv16i1] }:$Op2), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  56852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56865 */     GIR_RootConstrainSelectedInstOperands,
     /*  56866 */     // GIR_Coverage, 14764,
     /*  56866 */     GIR_EraseRootFromParent_Done,
     /*  56867 */   // Label 969: @56867
     /*  56867 */   GIM_Try, /*On fail goto*//*Label 970*/ GIMT_Encode4(56924), // Rule ID 14760 //
     /*  56872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  56887 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  56891 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56895 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56899 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56903 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56907 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56909 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] })), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  56909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56914 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56922 */     GIR_RootConstrainSelectedInstOperands,
     /*  56923 */     // GIR_Coverage, 14760,
     /*  56923 */     GIR_EraseRootFromParent_Done,
     /*  56924 */   // Label 970: @56924
     /*  56924 */   GIM_Try, /*On fail goto*//*Label 971*/ GIMT_Encode4(56981), // Rule ID 14763 //
     /*  56929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56940 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  56944 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  56948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56956 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56960 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56964 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56966 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] })), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  56966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56979 */     GIR_RootConstrainSelectedInstOperands,
     /*  56980 */     // GIR_Coverage, 14763,
     /*  56980 */     GIR_EraseRootFromParent_Done,
     /*  56981 */   // Label 971: @56981
     /*  56981 */   GIM_Try, /*On fail goto*//*Label 972*/ GIMT_Encode4(57038), // Rule ID 14759 //
     /*  56986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  57001 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  57005 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57009 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57013 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57017 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57021 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57023 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] }), nxv16i1:{ *:[nxv16i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  57023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57028 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57030 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57036 */     GIR_RootConstrainSelectedInstOperands,
     /*  57037 */     // GIR_Coverage, 14759,
     /*  57037 */     GIR_EraseRootFromParent_Done,
     /*  57038 */   // Label 972: @57038
     /*  57038 */   GIM_Try, /*On fail goto*//*Label 973*/ GIMT_Encode4(57095), // Rule ID 14762 //
     /*  57043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57054 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  57058 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  57062 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57066 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57070 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57074 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57078 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57080 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] }), nxv16i1:{ *:[nxv16i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  57080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57085 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57087 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57093 */     GIR_RootConstrainSelectedInstOperands,
     /*  57094 */     // GIR_Coverage, 14762,
     /*  57094 */     GIR_EraseRootFromParent_Done,
     /*  57095 */   // Label 973: @57095
     /*  57095 */   GIM_Try, /*On fail goto*//*Label 974*/ GIMT_Encode4(57152), // Rule ID 8261 //
     /*  57100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57111 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  57115 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  57119 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57123 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57127 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57131 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57135 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57137 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  57137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57142 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57144 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57150 */     GIR_RootConstrainSelectedInstOperands,
     /*  57151 */     // GIR_Coverage, 8261,
     /*  57151 */     GIR_EraseRootFromParent_Done,
     /*  57152 */   // Label 974: @57152
     /*  57152 */   GIM_Try, /*On fail goto*//*Label 975*/ GIMT_Encode4(57209), // Rule ID 8262 //
     /*  57157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57168 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  57172 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  57176 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57180 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57184 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57188 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57192 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57194 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  57194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57199 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57201 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57207 */     GIR_RootConstrainSelectedInstOperands,
     /*  57208 */     // GIR_Coverage, 8262,
     /*  57208 */     GIR_EraseRootFromParent_Done,
     /*  57209 */   // Label 975: @57209
     /*  57209 */   GIM_Try, /*On fail goto*//*Label 976*/ GIMT_Encode4(57256), // Rule ID 10525 //
     /*  57214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57217 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  57221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  57225 */     // (and:{ *:[nxv16i1] } PPR:{ *:[nxv16i1] }:$Ps1, PPR:{ *:[nxv16i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv16i1] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv16i1] }:$Ps1, PPR:{ *:[nxv16i1] }:$Ps2)
     /*  57225 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  57228 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /*  57232 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57237 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  57240 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  57242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  57245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57247 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  57250 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  57252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  57254 */     GIR_RootConstrainSelectedInstOperands,
     /*  57255 */     // GIR_Coverage, 10525,
     /*  57255 */     GIR_EraseRootFromParent_Done,
     /*  57256 */   // Label 976: @57256
     /*  57256 */   GIM_Try, /*On fail goto*//*Label 977*/ GIMT_Encode4(57277), // Rule ID 2735 //
     /*  57261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57264 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  57264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  57267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57269 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57271 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57273 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  57275 */     GIR_RootConstrainSelectedInstOperands,
     /*  57276 */     // GIR_Coverage, 2735,
     /*  57276 */     GIR_EraseRootFromParent_Done,
     /*  57277 */   // Label 977: @57277
     /*  57277 */   GIM_Reject,
     /*  57278 */ // Label 967: @57278
     /*  57278 */ GIM_Reject,
     /*  57279 */ // Label 831: @57279
     /*  57279 */ GIM_Try, /*On fail goto*//*Label 978*/ GIMT_Encode4(57750),
     /*  57284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  57287 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  57290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  57294 */   GIM_Try, /*On fail goto*//*Label 979*/ GIMT_Encode4(57349), // Rule ID 14701 //
     /*  57299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57310 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  57314 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  57318 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57322 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57326 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57330 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57334 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57336 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] }), nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  57336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57347 */     GIR_RootConstrainSelectedInstOperands,
     /*  57348 */     // GIR_Coverage, 14701,
     /*  57348 */     GIR_EraseRootFromParent_Done,
     /*  57349 */   // Label 979: @57349
     /*  57349 */   GIM_Try, /*On fail goto*//*Label 980*/ GIMT_Encode4(57404), // Rule ID 14704 //
     /*  57354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57365 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  57369 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  57373 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57377 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57381 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57385 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57389 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57391 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] }), nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  57391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57402 */     GIR_RootConstrainSelectedInstOperands,
     /*  57403 */     // GIR_Coverage, 14704,
     /*  57403 */     GIR_EraseRootFromParent_Done,
     /*  57404 */   // Label 980: @57404
     /*  57404 */   GIM_Try, /*On fail goto*//*Label 981*/ GIMT_Encode4(57459), // Rule ID 14700 //
     /*  57409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  57424 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  57428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57440 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57444 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57446 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] })), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  57446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57457 */     GIR_RootConstrainSelectedInstOperands,
     /*  57458 */     // GIR_Coverage, 14700,
     /*  57458 */     GIR_EraseRootFromParent_Done,
     /*  57459 */   // Label 981: @57459
     /*  57459 */   GIM_Try, /*On fail goto*//*Label 982*/ GIMT_Encode4(57514), // Rule ID 14703 //
     /*  57464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  57479 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  57483 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57487 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57491 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57495 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57499 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57501 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] })), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  57501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57506 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57512 */     GIR_RootConstrainSelectedInstOperands,
     /*  57513 */     // GIR_Coverage, 14703,
     /*  57513 */     GIR_EraseRootFromParent_Done,
     /*  57514 */   // Label 982: @57514
     /*  57514 */   GIM_Try, /*On fail goto*//*Label 983*/ GIMT_Encode4(57569), // Rule ID 14699 //
     /*  57519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57530 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  57534 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  57538 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57542 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57546 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57550 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57554 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57556 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  57556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57561 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57567 */     GIR_RootConstrainSelectedInstOperands,
     /*  57568 */     // GIR_Coverage, 14699,
     /*  57568 */     GIR_EraseRootFromParent_Done,
     /*  57569 */   // Label 983: @57569
     /*  57569 */   GIM_Try, /*On fail goto*//*Label 984*/ GIMT_Encode4(57624), // Rule ID 14702 //
     /*  57574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57585 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  57589 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  57593 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57597 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57601 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57605 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57609 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57611 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  57611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57616 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57622 */     GIR_RootConstrainSelectedInstOperands,
     /*  57623 */     // GIR_Coverage, 14702,
     /*  57623 */     GIR_EraseRootFromParent_Done,
     /*  57624 */   // Label 984: @57624
     /*  57624 */   GIM_Try, /*On fail goto*//*Label 985*/ GIMT_Encode4(57679), // Rule ID 7314 //
     /*  57629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57640 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  57644 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  57648 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57652 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57656 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57660 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57664 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57666 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  57666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57671 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57677 */     GIR_RootConstrainSelectedInstOperands,
     /*  57678 */     // GIR_Coverage, 7314,
     /*  57678 */     GIR_EraseRootFromParent_Done,
     /*  57679 */   // Label 985: @57679
     /*  57679 */   GIM_Try, /*On fail goto*//*Label 986*/ GIMT_Encode4(57734), // Rule ID 7315 //
     /*  57684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  57699 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  57703 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57707 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57711 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57715 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57719 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57721 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  57721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57726 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57732 */     GIR_RootConstrainSelectedInstOperands,
     /*  57733 */     // GIR_Coverage, 7315,
     /*  57733 */     GIR_EraseRootFromParent_Done,
     /*  57734 */   // Label 986: @57734
     /*  57734 */   GIM_Try, /*On fail goto*//*Label 987*/ GIMT_Encode4(57749), // Rule ID 3129 //
     /*  57739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57742 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  57742 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  57747 */     GIR_RootConstrainSelectedInstOperands,
     /*  57748 */     // GIR_Coverage, 3129,
     /*  57748 */     GIR_Done,
     /*  57749 */   // Label 987: @57749
     /*  57749 */   GIM_Reject,
     /*  57750 */ // Label 978: @57750
     /*  57750 */ GIM_Reject,
     /*  57751 */ // Label 832: @57751
     /*  57751 */ GIM_Reject,
     /*  57752 */ // Label 6: @57752
     /*  57752 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 1006*/ GIMT_Encode4(69798),
     /*  57763 */ /*GILLT_s32*//*Label 988*/ GIMT_Encode4(57851),
     /*  57767 */ /*GILLT_s64*//*Label 989*/ GIMT_Encode4(58211), GIMT_Encode4(0),
     /*  57775 */ /*GILLT_v2s32*//*Label 990*/ GIMT_Encode4(60378),
     /*  57779 */ /*GILLT_v2s64*//*Label 991*/ GIMT_Encode4(61686),
     /*  57783 */ /*GILLT_v4s16*//*Label 992*/ GIMT_Encode4(62994),
     /*  57787 */ /*GILLT_v4s32*//*Label 993*/ GIMT_Encode4(64302),
     /*  57791 */ /*GILLT_v8s8*//*Label 994*/ GIMT_Encode4(65610),
     /*  57795 */ /*GILLT_v8s16*//*Label 995*/ GIMT_Encode4(66918),
     /*  57799 */ /*GILLT_v16s8*//*Label 996*/ GIMT_Encode4(68226),
     /*  57803 */ /*GILLT_nxv1s1*//*Label 997*/ GIMT_Encode4(69534),
     /*  57807 */ /*GILLT_nxv2s1*//*Label 998*/ GIMT_Encode4(69566), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  57819 */ /*GILLT_nxv2s64*//*Label 999*/ GIMT_Encode4(69598),
     /*  57823 */ /*GILLT_nxv4s1*//*Label 1000*/ GIMT_Encode4(69624), GIMT_Encode4(0),
     /*  57831 */ /*GILLT_nxv4s32*//*Label 1001*/ GIMT_Encode4(69656),
     /*  57835 */ /*GILLT_nxv8s1*//*Label 1002*/ GIMT_Encode4(69682),
     /*  57839 */ /*GILLT_nxv8s16*//*Label 1003*/ GIMT_Encode4(69714),
     /*  57843 */ /*GILLT_nxv16s1*//*Label 1004*/ GIMT_Encode4(69740),
     /*  57847 */ /*GILLT_nxv16s8*//*Label 1005*/ GIMT_Encode4(69772),
     /*  57851 */ // Label 988: @57851
     /*  57851 */ GIM_Try, /*On fail goto*//*Label 1007*/ GIMT_Encode4(58210),
     /*  57856 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  57859 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  57862 */   GIM_Try, /*On fail goto*//*Label 1008*/ GIMT_Encode4(57917), // Rule ID 12964 //
     /*  57867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  57871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  57883 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  57887 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  57891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  57895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  57897 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  57904 */     // (or:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (ORNWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  57904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrs),
     /*  57907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  57909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  57911 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  57915 */     GIR_RootConstrainSelectedInstOperands,
     /*  57916 */     // GIR_Coverage, 12964,
     /*  57916 */     GIR_EraseRootFromParent_Done,
     /*  57917 */   // Label 1008: @57917
     /*  57917 */   GIM_Try, /*On fail goto*//*Label 1009*/ GIMT_Encode4(57972), // Rule ID 174 //
     /*  57922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  57926 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  57930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57938 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  57942 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  57946 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  57950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  57952 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  57959 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (ORNWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  57959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrs),
     /*  57962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  57964 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  57966 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  57970 */     GIR_RootConstrainSelectedInstOperands,
     /*  57971 */     // GIR_Coverage, 174,
     /*  57971 */     GIR_EraseRootFromParent_Done,
     /*  57972 */   // Label 1009: @57972
     /*  57972 */   GIM_Try, /*On fail goto*//*Label 1010*/ GIMT_Encode4(58013), // Rule ID 146 //
     /*  57977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  57981 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  57985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  57993 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
     /*  57997 */     // MIs[1] Operand 1
     /*  57997 */     // No operand predicates
     /*  57997 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  57999 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (ORRWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  57999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWri),
     /*  58002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  58004 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  58006 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
     /*  58011 */     GIR_RootConstrainSelectedInstOperands,
     /*  58012 */     // GIR_Coverage, 146,
     /*  58012 */     GIR_EraseRootFromParent_Done,
     /*  58013 */   // Label 1010: @58013
     /*  58013 */   GIM_Try, /*On fail goto*//*Label 1011*/ GIMT_Encode4(58046), // Rule ID 12966 //
     /*  58018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  58022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  58026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  58033 */     // (or:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ORRWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  58033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWrs),
     /*  58036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  58038 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  58040 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  58044 */     GIR_RootConstrainSelectedInstOperands,
     /*  58045 */     // GIR_Coverage, 12966,
     /*  58045 */     GIR_EraseRootFromParent_Done,
     /*  58046 */   // Label 1011: @58046
     /*  58046 */   GIM_Try, /*On fail goto*//*Label 1012*/ GIMT_Encode4(58079), // Rule ID 178 //
     /*  58051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  58055 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  58059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  58066 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ORRWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  58066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWrs),
     /*  58069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  58071 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  58073 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  58077 */     GIR_RootConstrainSelectedInstOperands,
     /*  58078 */     // GIR_Coverage, 178,
     /*  58078 */     GIR_EraseRootFromParent_Done,
     /*  58079 */   // Label 1012: @58079
     /*  58079 */   GIM_Try, /*On fail goto*//*Label 1013*/ GIMT_Encode4(58132), // Rule ID 12962 //
     /*  58084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  58088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  58100 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  58104 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  58109 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  58113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  58117 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  58119 */     // (or:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (ORNWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  58119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /*  58122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  58124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  58126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  58130 */     GIR_RootConstrainSelectedInstOperands,
     /*  58131 */     // GIR_Coverage, 12962,
     /*  58131 */     GIR_EraseRootFromParent_Done,
     /*  58132 */   // Label 1013: @58132
     /*  58132 */   GIM_Try, /*On fail goto*//*Label 1014*/ GIMT_Encode4(58185), // Rule ID 172 //
     /*  58137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  58141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  58145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  58157 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  58161 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  58166 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  58170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  58172 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (ORNWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  58172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /*  58175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  58177 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  58179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  58183 */     GIR_RootConstrainSelectedInstOperands,
     /*  58184 */     // GIR_Coverage, 172,
     /*  58184 */     GIR_EraseRootFromParent_Done,
     /*  58185 */   // Label 1014: @58185
     /*  58185 */   GIM_Try, /*On fail goto*//*Label 1015*/ GIMT_Encode4(58209), // Rule ID 176 //
     /*  58190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  58194 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  58198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  58202 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ORRWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  58202 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRWrr),
     /*  58207 */     GIR_RootConstrainSelectedInstOperands,
     /*  58208 */     // GIR_Coverage, 176,
     /*  58208 */     GIR_Done,
     /*  58209 */   // Label 1015: @58209
     /*  58209 */   GIM_Reject,
     /*  58210 */ // Label 1007: @58210
     /*  58210 */ GIM_Reject,
     /*  58211 */ // Label 989: @58211
     /*  58211 */ GIM_Try, /*On fail goto*//*Label 1016*/ GIMT_Encode4(60377),
     /*  58216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  58219 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  58222 */   GIM_Try, /*On fail goto*//*Label 1017*/ GIMT_Encode4(58344), // Rule ID 3959 //
     /*  58227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  58231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  58239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  58243 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  58247 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58251 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  58255 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58259 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  58263 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  58268 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  58272 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(71777214294589695),
     /*  58283 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  58287 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  58291 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  58295 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  58299 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  58303 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  58307 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  58311 */     // MIs[4] Rn
     /*  58311 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  58316 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  58320 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(-71777214294589696),
     /*  58331 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  58333 */     // (or:{ *:[i64] } (and:{ *:[i64] } (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), 71777214294589695:{ *:[i64] }), (and:{ *:[i64] } (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), -71777214294589696:{ *:[i64] }))  =>  (REV16Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /*  58333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Xr),
     /*  58336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  58338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  58342 */     GIR_RootConstrainSelectedInstOperands,
     /*  58343 */     // GIR_Coverage, 3959,
     /*  58343 */     GIR_EraseRootFromParent_Done,
     /*  58344 */   // Label 1017: @58344
     /*  58344 */   GIM_Try, /*On fail goto*//*Label 1018*/ GIMT_Encode4(58466), // Rule ID 13514 //
     /*  58349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  58353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  58361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  58365 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  58369 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58373 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  58377 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58381 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  58385 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  58390 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  58394 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(-71777214294589696),
     /*  58405 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  58409 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  58413 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  58417 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  58421 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  58425 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  58429 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  58433 */     // MIs[4] Rn
     /*  58433 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  58438 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  58442 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(71777214294589695),
     /*  58453 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  58455 */     // (or:{ *:[i64] } (and:{ *:[i64] } (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), -71777214294589696:{ *:[i64] }), (and:{ *:[i64] } (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), 71777214294589695:{ *:[i64] }))  =>  (REV16Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /*  58455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Xr),
     /*  58458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  58460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  58464 */     GIR_RootConstrainSelectedInstOperands,
     /*  58465 */     // GIR_Coverage, 13514,
     /*  58465 */     GIR_EraseRootFromParent_Done,
     /*  58466 */   // Label 1018: @58466
     /*  58466 */   GIM_Try, /*On fail goto*//*Label 1019*/ GIMT_Encode4(58521), // Rule ID 12965 //
     /*  58471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  58475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  58487 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  58491 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  58495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  58499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  58501 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  58508 */     // (or:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (ORNXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  58508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrs),
     /*  58511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  58513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  58515 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  58519 */     GIR_RootConstrainSelectedInstOperands,
     /*  58520 */     // GIR_Coverage, 12965,
     /*  58520 */     GIR_EraseRootFromParent_Done,
     /*  58521 */   // Label 1019: @58521
     /*  58521 */   GIM_Try, /*On fail goto*//*Label 1020*/ GIMT_Encode4(58576), // Rule ID 175 //
     /*  58526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  58530 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  58534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  58546 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  58550 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  58554 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  58556 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  58563 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (ORNXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  58563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrs),
     /*  58566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  58568 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  58570 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  58574 */     GIR_RootConstrainSelectedInstOperands,
     /*  58575 */     // GIR_Coverage, 175,
     /*  58575 */     GIR_EraseRootFromParent_Done,
     /*  58576 */   // Label 1020: @58576
     /*  58576 */   GIM_Try, /*On fail goto*//*Label 1021*/ GIMT_Encode4(58685), // Rule ID 13314 //
     /*  58581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  58588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  58596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  58600 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  58604 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58608 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58612 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58616 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  58620 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  58625 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  58629 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  58635 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  58637 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  58642 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  58646 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  58650 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  58654 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  58659 */     // MIs[4] LHS
     /*  58659 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  58664 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  58666 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  58666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  58669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  58675 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  58679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  58683 */     GIR_RootConstrainSelectedInstOperands,
     /*  58684 */     // GIR_Coverage, 13314,
     /*  58684 */     GIR_EraseRootFromParent_Done,
     /*  58685 */   // Label 1021: @58685
     /*  58685 */   GIM_Try, /*On fail goto*//*Label 1022*/ GIMT_Encode4(58794), // Rule ID 13313 //
     /*  58690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  58697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  58705 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  58709 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  58713 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58717 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58721 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58725 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  58729 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  58734 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  58738 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  58744 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  58746 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  58751 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  58755 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  58759 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  58763 */     // MIs[4] LHS
     /*  58763 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  58768 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  58773 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  58775 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  58775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  58778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  58784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  58788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  58792 */     GIR_RootConstrainSelectedInstOperands,
     /*  58793 */     // GIR_Coverage, 13313,
     /*  58793 */     GIR_EraseRootFromParent_Done,
     /*  58794 */   // Label 1022: @58794
     /*  58794 */   GIM_Try, /*On fail goto*//*Label 1023*/ GIMT_Encode4(58903), // Rule ID 13316 //
     /*  58799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  58806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  58814 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  58818 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  58822 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  58827 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58831 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58835 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58839 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  58843 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  58848 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  58852 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  58858 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  58860 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  58864 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  58868 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  58872 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  58877 */     // MIs[4] LHS
     /*  58877 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  58882 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  58884 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  58884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  58887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  58893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  58897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  58901 */     GIR_RootConstrainSelectedInstOperands,
     /*  58902 */     // GIR_Coverage, 13316,
     /*  58902 */     GIR_EraseRootFromParent_Done,
     /*  58903 */   // Label 1023: @58903
     /*  58903 */   GIM_Try, /*On fail goto*//*Label 1024*/ GIMT_Encode4(59012), // Rule ID 13315 //
     /*  58908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  58915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  58923 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  58927 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  58931 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  58936 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58940 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58944 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58948 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  58952 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  58957 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  58961 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  58967 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  58969 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  58973 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  58977 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  58981 */     // MIs[4] LHS
     /*  58981 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  58986 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  58991 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  58993 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  58993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  58996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  59002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  59006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  59010 */     GIR_RootConstrainSelectedInstOperands,
     /*  59011 */     // GIR_Coverage, 13315,
     /*  59011 */     GIR_EraseRootFromParent_Done,
     /*  59012 */   // Label 1024: @59012
     /*  59012 */   GIM_Try, /*On fail goto*//*Label 1025*/ GIMT_Encode4(59121), // Rule ID 2462 //
     /*  59017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  59020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  59032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  59036 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  59040 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59045 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59050 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  59054 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  59058 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59062 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  59066 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  59070 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59074 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  59078 */     // MIs[3] LHS
     /*  59078 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  59083 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  59087 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  59093 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  59095 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59100 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  59102 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS), (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  59102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  59105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  59111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  59115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  59119 */     GIR_RootConstrainSelectedInstOperands,
     /*  59120 */     // GIR_Coverage, 2462,
     /*  59120 */     GIR_EraseRootFromParent_Done,
     /*  59121 */   // Label 1025: @59121
     /*  59121 */   GIM_Try, /*On fail goto*//*Label 1026*/ GIMT_Encode4(59230), // Rule ID 13311 //
     /*  59126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  59129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  59141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  59145 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  59149 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59154 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59159 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  59163 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  59167 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59171 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  59175 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  59179 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59183 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  59187 */     // MIs[3] LHS
     /*  59187 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  59192 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  59196 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  59202 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  59204 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59209 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  59211 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS), (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  59211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  59214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  59220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  59224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  59228 */     GIR_RootConstrainSelectedInstOperands,
     /*  59229 */     // GIR_Coverage, 13311,
     /*  59229 */     GIR_EraseRootFromParent_Done,
     /*  59230 */   // Label 1026: @59230
     /*  59230 */   GIM_Try, /*On fail goto*//*Label 1027*/ GIMT_Encode4(59339), // Rule ID 13310 //
     /*  59235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  59238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  59250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  59254 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  59258 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59263 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59268 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  59272 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  59276 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59280 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  59284 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59289 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  59293 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59297 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  59301 */     // MIs[3] LHS
     /*  59301 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  59306 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  59310 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  59316 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  59318 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  59320 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  59320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  59323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  59329 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  59333 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  59337 */     GIR_RootConstrainSelectedInstOperands,
     /*  59338 */     // GIR_Coverage, 13310,
     /*  59338 */     GIR_EraseRootFromParent_Done,
     /*  59339 */   // Label 1027: @59339
     /*  59339 */   GIM_Try, /*On fail goto*//*Label 1028*/ GIMT_Encode4(59448), // Rule ID 13312 //
     /*  59344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  59347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  59359 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  59363 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  59367 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59372 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59377 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  59381 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  59385 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59389 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  59393 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59398 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  59402 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59406 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  59410 */     // MIs[3] LHS
     /*  59410 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  59415 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  59419 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  59425 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  59427 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  59429 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  59429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  59432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  59438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  59442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  59446 */     GIR_RootConstrainSelectedInstOperands,
     /*  59447 */     // GIR_Coverage, 13312,
     /*  59447 */     GIR_EraseRootFromParent_Done,
     /*  59448 */   // Label 1028: @59448
     /*  59448 */   GIM_Try, /*On fail goto*//*Label 1029*/ GIMT_Encode4(59489), // Rule ID 147 //
     /*  59453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  59457 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  59461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  59469 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
     /*  59473 */     // MIs[1] Operand 1
     /*  59473 */     // No operand predicates
     /*  59473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  59475 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (ORRXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
     /*  59475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXri),
     /*  59478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59480 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  59482 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
     /*  59487 */     GIR_RootConstrainSelectedInstOperands,
     /*  59488 */     // GIR_Coverage, 147,
     /*  59488 */     GIR_EraseRootFromParent_Done,
     /*  59489 */   // Label 1029: @59489
     /*  59489 */   GIM_Try, /*On fail goto*//*Label 1030*/ GIMT_Encode4(59522), // Rule ID 12967 //
     /*  59494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  59498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  59502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  59509 */     // (or:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ORRXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  59509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXrs),
     /*  59512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59516 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  59520 */     GIR_RootConstrainSelectedInstOperands,
     /*  59521 */     // GIR_Coverage, 12967,
     /*  59521 */     GIR_EraseRootFromParent_Done,
     /*  59522 */   // Label 1030: @59522
     /*  59522 */   GIM_Try, /*On fail goto*//*Label 1031*/ GIMT_Encode4(59555), // Rule ID 179 //
     /*  59527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  59531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  59535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  59542 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ORRXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  59542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXrs),
     /*  59545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59547 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  59549 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  59553 */     GIR_RootConstrainSelectedInstOperands,
     /*  59554 */     // GIR_Coverage, 179,
     /*  59554 */     GIR_EraseRootFromParent_Done,
     /*  59555 */   // Label 1031: @59555
     /*  59555 */   GIM_Try, /*On fail goto*//*Label 1032*/ GIMT_Encode4(59622), // Rule ID 13250 //
     /*  59560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  59563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  59575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  59579 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59584 */     // MIs[1] imm
     /*  59584 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59588 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  59592 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  59596 */     // MIs[2] Operand 1
     /*  59596 */     // No operand predicates
     /*  59596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59600 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  59604 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59606 */     // (or:{ *:[i64] } (AArch64vashr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  59606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  59609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  59613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  59617 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  59620 */     GIR_RootConstrainSelectedInstOperands,
     /*  59621 */     // GIR_Coverage, 13250,
     /*  59621 */     GIR_EraseRootFromParent_Done,
     /*  59622 */   // Label 1032: @59622
     /*  59622 */   GIM_Try, /*On fail goto*//*Label 1033*/ GIMT_Encode4(59689), // Rule ID 13638 //
     /*  59627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  59630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  59642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  59646 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59651 */     // MIs[1] imm
     /*  59651 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59655 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  59659 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  59663 */     // MIs[2] Operand 1
     /*  59663 */     // No operand predicates
     /*  59663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59667 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  59671 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59673 */     // (or:{ *:[v1i64] } (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /*  59673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  59676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  59680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  59684 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  59687 */     GIR_RootConstrainSelectedInstOperands,
     /*  59688 */     // GIR_Coverage, 13638,
     /*  59688 */     GIR_EraseRootFromParent_Done,
     /*  59689 */   // Label 1033: @59689
     /*  59689 */   GIM_Try, /*On fail goto*//*Label 1034*/ GIMT_Encode4(59756), // Rule ID 13253 //
     /*  59694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  59697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  59709 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  59713 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59718 */     // MIs[1] imm
     /*  59718 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59722 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  59726 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  59730 */     // MIs[2] Operand 1
     /*  59730 */     // No operand predicates
     /*  59730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59734 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  59738 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59740 */     // (or:{ *:[i64] } (AArch64vlshr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  59740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  59743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  59747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  59751 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  59754 */     GIR_RootConstrainSelectedInstOperands,
     /*  59755 */     // GIR_Coverage, 13253,
     /*  59755 */     GIR_EraseRootFromParent_Done,
     /*  59756 */   // Label 1034: @59756
     /*  59756 */   GIM_Try, /*On fail goto*//*Label 1035*/ GIMT_Encode4(59823), // Rule ID 13641 //
     /*  59761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  59764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  59776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  59780 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59785 */     // MIs[1] imm
     /*  59785 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59789 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  59793 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  59797 */     // MIs[2] Operand 1
     /*  59797 */     // No operand predicates
     /*  59797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59801 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  59805 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59807 */     // (or:{ *:[v1i64] } (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /*  59807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  59810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  59814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  59818 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  59821 */     GIR_RootConstrainSelectedInstOperands,
     /*  59822 */     // GIR_Coverage, 13641,
     /*  59822 */     GIR_EraseRootFromParent_Done,
     /*  59823 */   // Label 1035: @59823
     /*  59823 */   GIM_Try, /*On fail goto*//*Label 1036*/ GIMT_Encode4(59876), // Rule ID 12963 //
     /*  59828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  59832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59840 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  59844 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  59848 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  59853 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  59857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  59861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  59863 */     // (or:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (ORNXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  59863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /*  59866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59868 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  59874 */     GIR_RootConstrainSelectedInstOperands,
     /*  59875 */     // GIR_Coverage, 12963,
     /*  59875 */     GIR_EraseRootFromParent_Done,
     /*  59876 */   // Label 1036: @59876
     /*  59876 */   GIM_Try, /*On fail goto*//*Label 1037*/ GIMT_Encode4(59943), // Rule ID 2113 //
     /*  59881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  59884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59888 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  59900 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  59904 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59909 */     // MIs[1] imm
     /*  59909 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59913 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  59917 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  59921 */     // MIs[2] Operand 1
     /*  59921 */     // No operand predicates
     /*  59921 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  59925 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59927 */     // (or:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, (AArch64vashr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  59927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  59930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59932 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  59934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  59938 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  59941 */     GIR_RootConstrainSelectedInstOperands,
     /*  59942 */     // GIR_Coverage, 2113,
     /*  59942 */     GIR_EraseRootFromParent_Done,
     /*  59943 */   // Label 1037: @59943
     /*  59943 */   GIM_Try, /*On fail goto*//*Label 1038*/ GIMT_Encode4(60010), // Rule ID 6198 //
     /*  59948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  59951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  59967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  59971 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  59976 */     // MIs[1] imm
     /*  59976 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59980 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  59984 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  59988 */     // MIs[2] Operand 1
     /*  59988 */     // No operand predicates
     /*  59988 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  59992 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59994 */     // (or:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /*  59994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  59997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59999 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  60001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  60005 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  60008 */     GIR_RootConstrainSelectedInstOperands,
     /*  60009 */     // GIR_Coverage, 6198,
     /*  60009 */     GIR_EraseRootFromParent_Done,
     /*  60010 */   // Label 1038: @60010
     /*  60010 */   GIM_Try, /*On fail goto*//*Label 1039*/ GIMT_Encode4(60077), // Rule ID 2122 //
     /*  60015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  60018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60022 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  60034 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  60038 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60043 */     // MIs[1] imm
     /*  60043 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60047 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  60051 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  60055 */     // MIs[2] Operand 1
     /*  60055 */     // No operand predicates
     /*  60055 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  60059 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60061 */     // (or:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, (AArch64vlshr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  60061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  60064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60066 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  60068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  60072 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  60075 */     GIR_RootConstrainSelectedInstOperands,
     /*  60076 */     // GIR_Coverage, 2122,
     /*  60076 */     GIR_EraseRootFromParent_Done,
     /*  60077 */   // Label 1039: @60077
     /*  60077 */   GIM_Try, /*On fail goto*//*Label 1040*/ GIMT_Encode4(60144), // Rule ID 6204 //
     /*  60082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  60085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  60101 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  60105 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60110 */     // MIs[1] imm
     /*  60110 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60114 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  60118 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  60122 */     // MIs[2] Operand 1
     /*  60122 */     // No operand predicates
     /*  60122 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  60126 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60128 */     // (or:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /*  60128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  60131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60133 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  60135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  60139 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  60142 */     GIR_RootConstrainSelectedInstOperands,
     /*  60143 */     // GIR_Coverage, 6204,
     /*  60143 */     GIR_EraseRootFromParent_Done,
     /*  60144 */   // Label 1040: @60144
     /*  60144 */   GIM_Try, /*On fail goto*//*Label 1041*/ GIMT_Encode4(60197), // Rule ID 173 //
     /*  60149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  60153 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  60157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  60169 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  60173 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  60178 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  60182 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  60184 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }))  =>  (ORNXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  60184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /*  60187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60189 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  60191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  60195 */     GIR_RootConstrainSelectedInstOperands,
     /*  60196 */     // GIR_Coverage, 173,
     /*  60196 */     GIR_EraseRootFromParent_Done,
     /*  60197 */   // Label 1041: @60197
     /*  60197 */   GIM_Try, /*On fail goto*//*Label 1042*/ GIMT_Encode4(60261), // Rule ID 13602 //
     /*  60202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  60205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  60221 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  60225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60234 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  60240 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  60242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60246 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60248 */     // (or:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$LHS)  =>  (ORNv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  60248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  60251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60253 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  60255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  60259 */     GIR_RootConstrainSelectedInstOperands,
     /*  60260 */     // GIR_Coverage, 13602,
     /*  60260 */     GIR_EraseRootFromParent_Done,
     /*  60261 */   // Label 1042: @60261
     /*  60261 */   GIM_Try, /*On fail goto*//*Label 1043*/ GIMT_Encode4(60325), // Rule ID 4993 //
     /*  60266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  60269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  60289 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  60293 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60298 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60302 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  60308 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  60310 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60312 */     // (or:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }))  =>  (ORNv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  60312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  60315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60317 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  60319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  60323 */     GIR_RootConstrainSelectedInstOperands,
     /*  60324 */     // GIR_Coverage, 4993,
     /*  60324 */     GIR_EraseRootFromParent_Done,
     /*  60325 */   // Label 1043: @60325
     /*  60325 */   GIM_Try, /*On fail goto*//*Label 1044*/ GIMT_Encode4(60349), // Rule ID 177 //
     /*  60330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  60334 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  60338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  60342 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ORRXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  60342 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRXrr),
     /*  60347 */     GIR_RootConstrainSelectedInstOperands,
     /*  60348 */     // GIR_Coverage, 177,
     /*  60348 */     GIR_Done,
     /*  60349 */   // Label 1044: @60349
     /*  60349 */   GIM_Try, /*On fail goto*//*Label 1045*/ GIMT_Encode4(60376), // Rule ID 4999 //
     /*  60354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  60357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60369 */     // (or:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (ORRv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  60369 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  60374 */     GIR_RootConstrainSelectedInstOperands,
     /*  60375 */     // GIR_Coverage, 4999,
     /*  60375 */     GIR_Done,
     /*  60376 */   // Label 1045: @60376
     /*  60376 */   GIM_Reject,
     /*  60377 */ // Label 1016: @60377
     /*  60377 */ GIM_Reject,
     /*  60378 */ // Label 990: @60378
     /*  60378 */ GIM_Try, /*On fail goto*//*Label 1046*/ GIMT_Encode4(61685),
     /*  60383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  60386 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60389 */   GIM_Try, /*On fail goto*//*Label 1047*/ GIMT_Encode4(60498), // Rule ID 13307 //
     /*  60394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  60397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  60409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  60413 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60417 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60421 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60425 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  60429 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60433 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60438 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  60442 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  60448 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  60450 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60455 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  60459 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  60463 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  60467 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60472 */     // MIs[4] LHS
     /*  60472 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  60477 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  60479 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  60479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  60482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60484 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  60488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  60492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  60496 */     GIR_RootConstrainSelectedInstOperands,
     /*  60497 */     // GIR_Coverage, 13307,
     /*  60497 */     GIR_EraseRootFromParent_Done,
     /*  60498 */   // Label 1047: @60498
     /*  60498 */   GIM_Try, /*On fail goto*//*Label 1048*/ GIMT_Encode4(60607), // Rule ID 13306 //
     /*  60503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  60506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  60518 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  60522 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60530 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60534 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  60538 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60542 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60547 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  60551 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  60557 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  60559 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60564 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  60568 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  60572 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60576 */     // MIs[4] LHS
     /*  60576 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  60581 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60586 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  60588 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  60588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  60591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  60597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  60601 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  60605 */     GIR_RootConstrainSelectedInstOperands,
     /*  60606 */     // GIR_Coverage, 13306,
     /*  60606 */     GIR_EraseRootFromParent_Done,
     /*  60607 */   // Label 1048: @60607
     /*  60607 */   GIM_Try, /*On fail goto*//*Label 1049*/ GIMT_Encode4(60716), // Rule ID 13309 //
     /*  60612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  60615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  60627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  60631 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60635 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60640 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60644 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60648 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  60652 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60656 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60661 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  60665 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  60671 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  60673 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  60677 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  60681 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  60685 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60690 */     // MIs[4] LHS
     /*  60690 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  60695 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  60697 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  60697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  60700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  60706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  60710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  60714 */     GIR_RootConstrainSelectedInstOperands,
     /*  60715 */     // GIR_Coverage, 13309,
     /*  60715 */     GIR_EraseRootFromParent_Done,
     /*  60716 */   // Label 1049: @60716
     /*  60716 */   GIM_Try, /*On fail goto*//*Label 1050*/ GIMT_Encode4(60825), // Rule ID 13308 //
     /*  60721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  60724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  60736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  60740 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60744 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60749 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60753 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60757 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  60761 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60765 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60770 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  60774 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  60780 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  60782 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  60786 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  60790 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60794 */     // MIs[4] LHS
     /*  60794 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  60799 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60804 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  60806 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  60806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  60809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  60815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  60819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  60823 */     GIR_RootConstrainSelectedInstOperands,
     /*  60824 */     // GIR_Coverage, 13308,
     /*  60824 */     GIR_EraseRootFromParent_Done,
     /*  60825 */   // Label 1050: @60825
     /*  60825 */   GIM_Try, /*On fail goto*//*Label 1051*/ GIMT_Encode4(60934), // Rule ID 2461 //
     /*  60830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  60833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  60845 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  60849 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60853 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60858 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60863 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  60867 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  60871 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  60875 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60879 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  60883 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60887 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60891 */     // MIs[3] LHS
     /*  60891 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  60896 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  60900 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  60906 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  60908 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60913 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  60915 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS), (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  60915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  60918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60920 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  60924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  60928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  60932 */     GIR_RootConstrainSelectedInstOperands,
     /*  60933 */     // GIR_Coverage, 2461,
     /*  60933 */     GIR_EraseRootFromParent_Done,
     /*  60934 */   // Label 1051: @60934
     /*  60934 */   GIM_Try, /*On fail goto*//*Label 1052*/ GIMT_Encode4(61043), // Rule ID 13304 //
     /*  60939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  60942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  60954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  60958 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60962 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60967 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  60972 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  60976 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  60980 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  60984 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60988 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  60992 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60996 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  61000 */     // MIs[3] LHS
     /*  61000 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  61005 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  61009 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61015 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  61017 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61022 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61024 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS), (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  61024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  61027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61029 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  61033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  61037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  61041 */     GIR_RootConstrainSelectedInstOperands,
     /*  61042 */     // GIR_Coverage, 13304,
     /*  61042 */     GIR_EraseRootFromParent_Done,
     /*  61043 */   // Label 1052: @61043
     /*  61043 */   GIM_Try, /*On fail goto*//*Label 1053*/ GIMT_Encode4(61152), // Rule ID 13303 //
     /*  61048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  61067 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  61071 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61076 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61081 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  61085 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61089 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  61093 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  61097 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61102 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  61106 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61110 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  61114 */     // MIs[3] LHS
     /*  61114 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  61119 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  61123 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61129 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  61131 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61133 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  61133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  61136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  61142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  61146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  61150 */     GIR_RootConstrainSelectedInstOperands,
     /*  61151 */     // GIR_Coverage, 13303,
     /*  61151 */     GIR_EraseRootFromParent_Done,
     /*  61152 */   // Label 1053: @61152
     /*  61152 */   GIM_Try, /*On fail goto*//*Label 1054*/ GIMT_Encode4(61261), // Rule ID 13305 //
     /*  61157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  61176 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  61180 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61185 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61190 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  61194 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61198 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  61202 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  61206 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61211 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  61215 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61219 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  61223 */     // MIs[3] LHS
     /*  61223 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  61228 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  61232 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61238 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  61240 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61242 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  61242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  61245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  61251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  61255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  61259 */     GIR_RootConstrainSelectedInstOperands,
     /*  61260 */     // GIR_Coverage, 13305,
     /*  61260 */     GIR_EraseRootFromParent_Done,
     /*  61261 */   // Label 1054: @61261
     /*  61261 */   GIM_Try, /*On fail goto*//*Label 1055*/ GIMT_Encode4(61328), // Rule ID 13270 //
     /*  61266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  61281 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  61285 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61290 */     // MIs[1] imm
     /*  61290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  61298 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  61302 */     // MIs[2] Operand 1
     /*  61302 */     // No operand predicates
     /*  61302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61306 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  61310 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61312 */     // (or:{ *:[v2i32] } (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  61312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  61315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  61319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  61323 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  61326 */     GIR_RootConstrainSelectedInstOperands,
     /*  61327 */     // GIR_Coverage, 13270,
     /*  61327 */     GIR_EraseRootFromParent_Done,
     /*  61328 */   // Label 1055: @61328
     /*  61328 */   GIM_Try, /*On fail goto*//*Label 1056*/ GIMT_Encode4(61395), // Rule ID 13291 //
     /*  61333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  61348 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  61352 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61357 */     // MIs[1] imm
     /*  61357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  61365 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  61369 */     // MIs[2] Operand 1
     /*  61369 */     // No operand predicates
     /*  61369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61373 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  61377 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61379 */     // (or:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  61379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  61382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61384 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  61386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  61390 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  61393 */     GIR_RootConstrainSelectedInstOperands,
     /*  61394 */     // GIR_Coverage, 13291,
     /*  61394 */     GIR_EraseRootFromParent_Done,
     /*  61395 */   // Label 1056: @61395
     /*  61395 */   GIM_Try, /*On fail goto*//*Label 1057*/ GIMT_Encode4(61462), // Rule ID 2230 //
     /*  61400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61407 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  61419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  61423 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61428 */     // MIs[1] imm
     /*  61428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  61436 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  61440 */     // MIs[2] Operand 1
     /*  61440 */     // No operand predicates
     /*  61440 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  61444 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61446 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  61446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  61449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61451 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  61453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  61457 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  61460 */     GIR_RootConstrainSelectedInstOperands,
     /*  61461 */     // GIR_Coverage, 2230,
     /*  61461 */     GIR_EraseRootFromParent_Done,
     /*  61462 */   // Label 1057: @61462
     /*  61462 */   GIM_Try, /*On fail goto*//*Label 1058*/ GIMT_Encode4(61529), // Rule ID 2289 //
     /*  61467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  61486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  61490 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61495 */     // MIs[1] imm
     /*  61495 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61499 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  61503 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  61507 */     // MIs[2] Operand 1
     /*  61507 */     // No operand predicates
     /*  61507 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  61511 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61513 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  61513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  61516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61518 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  61520 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  61524 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  61527 */     GIR_RootConstrainSelectedInstOperands,
     /*  61528 */     // GIR_Coverage, 2289,
     /*  61528 */     GIR_EraseRootFromParent_Done,
     /*  61529 */   // Label 1058: @61529
     /*  61529 */   GIM_Try, /*On fail goto*//*Label 1059*/ GIMT_Encode4(61593), // Rule ID 13601 //
     /*  61534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61549 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  61553 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  61557 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61562 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61566 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61572 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  61574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61578 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61580 */     // (or:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$LHS)  =>  (ORNv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  61580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  61583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61585 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  61587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  61591 */     GIR_RootConstrainSelectedInstOperands,
     /*  61592 */     // GIR_Coverage, 13601,
     /*  61592 */     GIR_EraseRootFromParent_Done,
     /*  61593 */   // Label 1059: @61593
     /*  61593 */   GIM_Try, /*On fail goto*//*Label 1060*/ GIMT_Encode4(61657), // Rule ID 4992 //
     /*  61598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61605 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  61621 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  61625 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61630 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61634 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61640 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  61642 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61644 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }))  =>  (ORNv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  61644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  61647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61649 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  61651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  61655 */     GIR_RootConstrainSelectedInstOperands,
     /*  61656 */     // GIR_Coverage, 4992,
     /*  61656 */     GIR_EraseRootFromParent_Done,
     /*  61657 */   // Label 1060: @61657
     /*  61657 */   GIM_Try, /*On fail goto*//*Label 1061*/ GIMT_Encode4(61684), // Rule ID 4998 //
     /*  61662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61677 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (ORRv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  61677 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  61682 */     GIR_RootConstrainSelectedInstOperands,
     /*  61683 */     // GIR_Coverage, 4998,
     /*  61683 */     GIR_Done,
     /*  61684 */   // Label 1061: @61684
     /*  61684 */   GIM_Reject,
     /*  61685 */ // Label 1046: @61685
     /*  61685 */ GIM_Reject,
     /*  61686 */ // Label 991: @61686
     /*  61686 */ GIM_Try, /*On fail goto*//*Label 1062*/ GIMT_Encode4(62993),
     /*  61691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  61694 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  61697 */   GIM_Try, /*On fail goto*//*Label 1063*/ GIMT_Encode4(61806), // Rule ID 13335 //
     /*  61702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  61709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  61721 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  61725 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61729 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61733 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  61737 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  61741 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  61746 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  61750 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61756 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  61758 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  61763 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  61767 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61771 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  61775 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  61780 */     // MIs[4] LHS
     /*  61780 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61785 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61787 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  61787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  61790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  61796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  61800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  61804 */     GIR_RootConstrainSelectedInstOperands,
     /*  61805 */     // GIR_Coverage, 13335,
     /*  61805 */     GIR_EraseRootFromParent_Done,
     /*  61806 */   // Label 1063: @61806
     /*  61806 */   GIM_Try, /*On fail goto*//*Label 1064*/ GIMT_Encode4(61915), // Rule ID 13334 //
     /*  61811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  61818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  61830 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  61834 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61838 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61842 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  61846 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  61850 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  61855 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  61859 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61865 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  61867 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  61872 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  61876 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61880 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  61884 */     // MIs[4] LHS
     /*  61884 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61889 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  61894 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61896 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  61896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  61899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  61905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  61909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  61913 */     GIR_RootConstrainSelectedInstOperands,
     /*  61914 */     // GIR_Coverage, 13334,
     /*  61914 */     GIR_EraseRootFromParent_Done,
     /*  61915 */   // Label 1064: @61915
     /*  61915 */   GIM_Try, /*On fail goto*//*Label 1065*/ GIMT_Encode4(62024), // Rule ID 13337 //
     /*  61920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  61927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61935 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  61939 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  61943 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  61948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61956 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  61960 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  61964 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  61969 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  61973 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61979 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  61981 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  61985 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61989 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  61993 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  61998 */     // MIs[4] LHS
     /*  61998 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62003 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62005 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  62005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  62008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  62014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  62018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  62022 */     GIR_RootConstrainSelectedInstOperands,
     /*  62023 */     // GIR_Coverage, 13337,
     /*  62023 */     GIR_EraseRootFromParent_Done,
     /*  62024 */   // Label 1065: @62024
     /*  62024 */   GIM_Try, /*On fail goto*//*Label 1066*/ GIMT_Encode4(62133), // Rule ID 13336 //
     /*  62029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62044 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  62048 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62052 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62057 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62061 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62065 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  62069 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62073 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62078 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  62082 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62088 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  62090 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  62094 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62098 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62102 */     // MIs[4] LHS
     /*  62102 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62107 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62112 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62114 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  62114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  62117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  62123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  62127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  62131 */     GIR_RootConstrainSelectedInstOperands,
     /*  62132 */     // GIR_Coverage, 13336,
     /*  62132 */     GIR_EraseRootFromParent_Done,
     /*  62133 */   // Label 1066: @62133
     /*  62133 */   GIM_Try, /*On fail goto*//*Label 1067*/ GIMT_Encode4(62242), // Rule ID 2465 //
     /*  62138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  62157 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62161 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62166 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62171 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  62175 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62179 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  62183 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62187 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  62191 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62195 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62199 */     // MIs[3] LHS
     /*  62199 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  62204 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  62208 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62214 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  62216 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62221 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62223 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  62223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  62226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62228 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  62232 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  62236 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  62240 */     GIR_RootConstrainSelectedInstOperands,
     /*  62241 */     // GIR_Coverage, 2465,
     /*  62241 */     GIR_EraseRootFromParent_Done,
     /*  62242 */   // Label 1067: @62242
     /*  62242 */   GIM_Try, /*On fail goto*//*Label 1068*/ GIMT_Encode4(62351), // Rule ID 13332 //
     /*  62247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  62266 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62270 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62275 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62280 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  62284 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62288 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  62292 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62296 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  62300 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62304 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62308 */     // MIs[3] LHS
     /*  62308 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  62313 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  62317 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62323 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  62325 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62330 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62332 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  62332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  62335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  62341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  62345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  62349 */     GIR_RootConstrainSelectedInstOperands,
     /*  62350 */     // GIR_Coverage, 13332,
     /*  62350 */     GIR_EraseRootFromParent_Done,
     /*  62351 */   // Label 1068: @62351
     /*  62351 */   GIM_Try, /*On fail goto*//*Label 1069*/ GIMT_Encode4(62460), // Rule ID 13331 //
     /*  62356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  62375 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62379 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62384 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  62393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62397 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  62401 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62405 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62410 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  62414 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62418 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62422 */     // MIs[3] LHS
     /*  62422 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  62427 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  62431 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62437 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  62439 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62441 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  62441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  62444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  62450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  62454 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  62458 */     GIR_RootConstrainSelectedInstOperands,
     /*  62459 */     // GIR_Coverage, 13331,
     /*  62459 */     GIR_EraseRootFromParent_Done,
     /*  62460 */   // Label 1069: @62460
     /*  62460 */   GIM_Try, /*On fail goto*//*Label 1070*/ GIMT_Encode4(62569), // Rule ID 13333 //
     /*  62465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  62484 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62488 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62493 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62498 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  62502 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62506 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  62510 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62514 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62519 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  62523 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62527 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62531 */     // MIs[3] LHS
     /*  62531 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  62536 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  62540 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62546 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  62548 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62550 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  62550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  62553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  62559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  62563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  62567 */     GIR_RootConstrainSelectedInstOperands,
     /*  62568 */     // GIR_Coverage, 13333,
     /*  62568 */     GIR_EraseRootFromParent_Done,
     /*  62569 */   // Label 1070: @62569
     /*  62569 */   GIM_Try, /*On fail goto*//*Label 1071*/ GIMT_Encode4(62636), // Rule ID 13274 //
     /*  62574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  62589 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  62593 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62598 */     // MIs[1] imm
     /*  62598 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62602 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62606 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  62610 */     // MIs[2] Operand 1
     /*  62610 */     // No operand predicates
     /*  62610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62614 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  62618 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62620 */     // (or:{ *:[v2i64] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  62620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  62623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  62627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  62631 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  62634 */     GIR_RootConstrainSelectedInstOperands,
     /*  62635 */     // GIR_Coverage, 13274,
     /*  62635 */     GIR_EraseRootFromParent_Done,
     /*  62636 */   // Label 1071: @62636
     /*  62636 */   GIM_Try, /*On fail goto*//*Label 1072*/ GIMT_Encode4(62703), // Rule ID 13295 //
     /*  62641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  62656 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  62660 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62665 */     // MIs[1] imm
     /*  62665 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62669 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62673 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  62677 */     // MIs[2] Operand 1
     /*  62677 */     // No operand predicates
     /*  62677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62681 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  62685 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62687 */     // (or:{ *:[v2i64] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  62687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  62690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  62694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  62698 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  62701 */     GIR_RootConstrainSelectedInstOperands,
     /*  62702 */     // GIR_Coverage, 13295,
     /*  62702 */     GIR_EraseRootFromParent_Done,
     /*  62703 */   // Label 1072: @62703
     /*  62703 */   GIM_Try, /*On fail goto*//*Label 1073*/ GIMT_Encode4(62770), // Rule ID 2234 //
     /*  62708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62715 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  62727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  62731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62736 */     // MIs[1] imm
     /*  62736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62744 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  62748 */     // MIs[2] Operand 1
     /*  62748 */     // No operand predicates
     /*  62748 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  62752 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62754 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  62754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  62757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62759 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  62761 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  62765 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  62768 */     GIR_RootConstrainSelectedInstOperands,
     /*  62769 */     // GIR_Coverage, 2234,
     /*  62769 */     GIR_EraseRootFromParent_Done,
     /*  62770 */   // Label 1073: @62770
     /*  62770 */   GIM_Try, /*On fail goto*//*Label 1074*/ GIMT_Encode4(62837), // Rule ID 2293 //
     /*  62775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  62794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  62798 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62803 */     // MIs[1] imm
     /*  62803 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62807 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62811 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  62815 */     // MIs[2] Operand 1
     /*  62815 */     // No operand predicates
     /*  62815 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  62819 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62821 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  62821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  62824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62826 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  62828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  62832 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  62835 */     GIR_RootConstrainSelectedInstOperands,
     /*  62836 */     // GIR_Coverage, 2293,
     /*  62836 */     GIR_EraseRootFromParent_Done,
     /*  62837 */   // Label 1074: @62837
     /*  62837 */   GIM_Try, /*On fail goto*//*Label 1075*/ GIMT_Encode4(62901), // Rule ID 13605 //
     /*  62842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62857 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  62861 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62865 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62870 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62874 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62880 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  62882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62886 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62888 */     // (or:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$LHS)  =>  (ORNv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  62888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  62891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62893 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  62895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  62899 */     GIR_RootConstrainSelectedInstOperands,
     /*  62900 */     // GIR_Coverage, 13605,
     /*  62900 */     GIR_EraseRootFromParent_Done,
     /*  62901 */   // Label 1075: @62901
     /*  62901 */   GIM_Try, /*On fail goto*//*Label 1076*/ GIMT_Encode4(62965), // Rule ID 4996 //
     /*  62906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  62929 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62933 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62938 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62942 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62948 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  62950 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62952 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }))  =>  (ORNv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  62952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  62955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62957 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  62959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  62963 */     GIR_RootConstrainSelectedInstOperands,
     /*  62964 */     // GIR_Coverage, 4996,
     /*  62964 */     GIR_EraseRootFromParent_Done,
     /*  62965 */   // Label 1076: @62965
     /*  62965 */   GIM_Try, /*On fail goto*//*Label 1077*/ GIMT_Encode4(62992), // Rule ID 5002 //
     /*  62970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62977 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  62985 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (ORRv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  62985 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  62990 */     GIR_RootConstrainSelectedInstOperands,
     /*  62991 */     // GIR_Coverage, 5002,
     /*  62991 */     GIR_Done,
     /*  62992 */   // Label 1077: @62992
     /*  62992 */   GIM_Reject,
     /*  62993 */ // Label 1062: @62993
     /*  62993 */ GIM_Reject,
     /*  62994 */ // Label 992: @62994
     /*  62994 */ GIM_Try, /*On fail goto*//*Label 1078*/ GIMT_Encode4(64301),
     /*  62999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63002 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63005 */   GIM_Try, /*On fail goto*//*Label 1079*/ GIMT_Encode4(63114), // Rule ID 13300 //
     /*  63010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63029 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63037 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63041 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63045 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63049 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63054 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63058 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63064 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63066 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63071 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63075 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63079 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63083 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63088 */     // MIs[4] LHS
     /*  63088 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63093 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63095 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  63095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  63108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  63112 */     GIR_RootConstrainSelectedInstOperands,
     /*  63113 */     // GIR_Coverage, 13300,
     /*  63113 */     GIR_EraseRootFromParent_Done,
     /*  63114 */   // Label 1079: @63114
     /*  63114 */   GIM_Try, /*On fail goto*//*Label 1080*/ GIMT_Encode4(63223), // Rule ID 13299 //
     /*  63119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63134 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63138 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63142 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63146 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63150 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63154 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63158 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63163 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63167 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63173 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63175 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63180 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63184 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63188 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63192 */     // MIs[4] LHS
     /*  63192 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63197 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63202 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63204 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  63204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  63217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  63221 */     GIR_RootConstrainSelectedInstOperands,
     /*  63222 */     // GIR_Coverage, 13299,
     /*  63222 */     GIR_EraseRootFromParent_Done,
     /*  63223 */   // Label 1080: @63223
     /*  63223 */   GIM_Try, /*On fail goto*//*Label 1081*/ GIMT_Encode4(63332), // Rule ID 13302 //
     /*  63228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63243 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63247 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63251 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63256 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63260 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63264 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63268 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63272 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63277 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63281 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63287 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63289 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63293 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63297 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63301 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63306 */     // MIs[4] LHS
     /*  63306 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63311 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63313 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  63313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  63326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  63330 */     GIR_RootConstrainSelectedInstOperands,
     /*  63331 */     // GIR_Coverage, 13302,
     /*  63331 */     GIR_EraseRootFromParent_Done,
     /*  63332 */   // Label 1081: @63332
     /*  63332 */   GIM_Try, /*On fail goto*//*Label 1082*/ GIMT_Encode4(63441), // Rule ID 13301 //
     /*  63337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63356 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63360 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63365 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63369 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63373 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63377 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63381 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63386 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63390 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63396 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63398 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63402 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63406 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63410 */     // MIs[4] LHS
     /*  63410 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63415 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63420 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63422 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  63422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  63435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  63439 */     GIR_RootConstrainSelectedInstOperands,
     /*  63440 */     // GIR_Coverage, 13301,
     /*  63440 */     GIR_EraseRootFromParent_Done,
     /*  63441 */   // Label 1082: @63441
     /*  63441 */   GIM_Try, /*On fail goto*//*Label 1083*/ GIMT_Encode4(63550), // Rule ID 2460 //
     /*  63446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63465 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63469 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63474 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63479 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  63483 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63487 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63491 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63495 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  63499 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63503 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63507 */     // MIs[3] LHS
     /*  63507 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  63512 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  63516 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63522 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  63524 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63529 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63531 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS), (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  63531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  63540 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  63544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  63548 */     GIR_RootConstrainSelectedInstOperands,
     /*  63549 */     // GIR_Coverage, 2460,
     /*  63549 */     GIR_EraseRootFromParent_Done,
     /*  63550 */   // Label 1083: @63550
     /*  63550 */   GIM_Try, /*On fail goto*//*Label 1084*/ GIMT_Encode4(63659), // Rule ID 13297 //
     /*  63555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63570 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63574 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63578 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63583 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63588 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  63592 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63596 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63600 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63604 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  63608 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63612 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63616 */     // MIs[3] LHS
     /*  63616 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  63621 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  63625 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63631 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  63633 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63638 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63640 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS), (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  63640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  63649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  63653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  63657 */     GIR_RootConstrainSelectedInstOperands,
     /*  63658 */     // GIR_Coverage, 13297,
     /*  63658 */     GIR_EraseRootFromParent_Done,
     /*  63659 */   // Label 1084: @63659
     /*  63659 */   GIM_Try, /*On fail goto*//*Label 1085*/ GIMT_Encode4(63768), // Rule ID 13296 //
     /*  63664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63679 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63683 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63692 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63697 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  63701 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63705 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63709 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63713 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63718 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63722 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63726 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63730 */     // MIs[3] LHS
     /*  63730 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  63735 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  63739 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63745 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  63747 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63749 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  63749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  63758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  63762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  63766 */     GIR_RootConstrainSelectedInstOperands,
     /*  63767 */     // GIR_Coverage, 13296,
     /*  63767 */     GIR_EraseRootFromParent_Done,
     /*  63768 */   // Label 1085: @63768
     /*  63768 */   GIM_Try, /*On fail goto*//*Label 1086*/ GIMT_Encode4(63877), // Rule ID 13298 //
     /*  63773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63792 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63796 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63801 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63806 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  63810 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63814 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63818 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63822 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63827 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63831 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63835 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  63839 */     // MIs[3] LHS
     /*  63839 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  63844 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  63848 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63854 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  63856 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63858 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  63858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  63867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  63871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  63875 */     GIR_RootConstrainSelectedInstOperands,
     /*  63876 */     // GIR_Coverage, 13298,
     /*  63876 */     GIR_EraseRootFromParent_Done,
     /*  63877 */   // Label 1086: @63877
     /*  63877 */   GIM_Try, /*On fail goto*//*Label 1087*/ GIMT_Encode4(63944), // Rule ID 13266 //
     /*  63882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  63897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63901 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63906 */     // MIs[1] imm
     /*  63906 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63910 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63914 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  63918 */     // MIs[2] Operand 1
     /*  63918 */     // No operand predicates
     /*  63918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63922 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  63926 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63928 */     // (or:{ *:[v4i16] } (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  63928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  63931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  63935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  63939 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  63942 */     GIR_RootConstrainSelectedInstOperands,
     /*  63943 */     // GIR_Coverage, 13266,
     /*  63943 */     GIR_EraseRootFromParent_Done,
     /*  63944 */   // Label 1087: @63944
     /*  63944 */   GIM_Try, /*On fail goto*//*Label 1088*/ GIMT_Encode4(64011), // Rule ID 13287 //
     /*  63949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  63964 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  63968 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63973 */     // MIs[1] imm
     /*  63973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63977 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63981 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  63985 */     // MIs[2] Operand 1
     /*  63985 */     // No operand predicates
     /*  63985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63989 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  63993 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63995 */     // (or:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  63995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  63998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  64002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64006 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64009 */     GIR_RootConstrainSelectedInstOperands,
     /*  64010 */     // GIR_Coverage, 13287,
     /*  64010 */     GIR_EraseRootFromParent_Done,
     /*  64011 */   // Label 1088: @64011
     /*  64011 */   GIM_Try, /*On fail goto*//*Label 1089*/ GIMT_Encode4(64078), // Rule ID 2226 //
     /*  64016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  64035 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  64039 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64044 */     // MIs[1] imm
     /*  64044 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64048 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64052 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  64056 */     // MIs[2] Operand 1
     /*  64056 */     // No operand predicates
     /*  64056 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  64060 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64062 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  64062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  64065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64067 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  64069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64073 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64076 */     GIR_RootConstrainSelectedInstOperands,
     /*  64077 */     // GIR_Coverage, 2226,
     /*  64077 */     GIR_EraseRootFromParent_Done,
     /*  64078 */   // Label 1089: @64078
     /*  64078 */   GIM_Try, /*On fail goto*//*Label 1090*/ GIMT_Encode4(64145), // Rule ID 2285 //
     /*  64083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64090 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  64102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  64106 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64111 */     // MIs[1] imm
     /*  64111 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64115 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64119 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  64123 */     // MIs[2] Operand 1
     /*  64123 */     // No operand predicates
     /*  64123 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  64127 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64129 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  64129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  64132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64134 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  64136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64140 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64143 */     GIR_RootConstrainSelectedInstOperands,
     /*  64144 */     // GIR_Coverage, 2285,
     /*  64144 */     GIR_EraseRootFromParent_Done,
     /*  64145 */   // Label 1090: @64145
     /*  64145 */   GIM_Try, /*On fail goto*//*Label 1091*/ GIMT_Encode4(64209), // Rule ID 13600 //
     /*  64150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  64169 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  64173 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64178 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64182 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64188 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  64190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64194 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64196 */     // (or:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$LHS)  =>  (ORNv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  64196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  64199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  64201 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  64203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  64207 */     GIR_RootConstrainSelectedInstOperands,
     /*  64208 */     // GIR_Coverage, 13600,
     /*  64208 */     GIR_EraseRootFromParent_Done,
     /*  64209 */   // Label 1091: @64209
     /*  64209 */   GIM_Try, /*On fail goto*//*Label 1092*/ GIMT_Encode4(64273), // Rule ID 4991 //
     /*  64214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64233 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  64237 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  64241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64246 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64250 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64256 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  64258 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64260 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }))  =>  (ORNv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  64260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  64263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  64265 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  64267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  64271 */     GIR_RootConstrainSelectedInstOperands,
     /*  64272 */     // GIR_Coverage, 4991,
     /*  64272 */     GIR_EraseRootFromParent_Done,
     /*  64273 */   // Label 1092: @64273
     /*  64273 */   GIM_Try, /*On fail goto*//*Label 1093*/ GIMT_Encode4(64300), // Rule ID 4997 //
     /*  64278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64285 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64293 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (ORRv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  64293 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  64298 */     GIR_RootConstrainSelectedInstOperands,
     /*  64299 */     // GIR_Coverage, 4997,
     /*  64299 */     GIR_Done,
     /*  64300 */   // Label 1093: @64300
     /*  64300 */   GIM_Reject,
     /*  64301 */ // Label 1078: @64301
     /*  64301 */ GIM_Reject,
     /*  64302 */ // Label 993: @64302
     /*  64302 */ GIM_Try, /*On fail goto*//*Label 1094*/ GIMT_Encode4(65609),
     /*  64307 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  64310 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64313 */   GIM_Try, /*On fail goto*//*Label 1095*/ GIMT_Encode4(64422), // Rule ID 13328 //
     /*  64318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  64337 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64341 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64345 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64349 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  64353 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64357 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64362 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64366 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64372 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  64374 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64379 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  64383 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64387 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  64391 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64396 */     // MIs[4] LHS
     /*  64396 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64401 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64403 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  64403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  64412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  64416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  64420 */     GIR_RootConstrainSelectedInstOperands,
     /*  64421 */     // GIR_Coverage, 13328,
     /*  64421 */     GIR_EraseRootFromParent_Done,
     /*  64422 */   // Label 1095: @64422
     /*  64422 */   GIM_Try, /*On fail goto*//*Label 1096*/ GIMT_Encode4(64531), // Rule ID 13327 //
     /*  64427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  64446 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64450 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64454 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64458 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  64462 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64466 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64471 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64475 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64481 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  64483 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64488 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  64492 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64496 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64500 */     // MIs[4] LHS
     /*  64500 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64505 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64510 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64512 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  64512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  64521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  64525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  64529 */     GIR_RootConstrainSelectedInstOperands,
     /*  64530 */     // GIR_Coverage, 13327,
     /*  64530 */     GIR_EraseRootFromParent_Done,
     /*  64531 */   // Label 1096: @64531
     /*  64531 */   GIM_Try, /*On fail goto*//*Label 1097*/ GIMT_Encode4(64640), // Rule ID 13330 //
     /*  64536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64551 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  64555 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64559 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64572 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  64576 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64580 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64585 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64589 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64595 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  64597 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  64601 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64605 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  64609 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64614 */     // MIs[4] LHS
     /*  64614 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64619 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64621 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  64621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  64630 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  64634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  64638 */     GIR_RootConstrainSelectedInstOperands,
     /*  64639 */     // GIR_Coverage, 13330,
     /*  64639 */     GIR_EraseRootFromParent_Done,
     /*  64640 */   // Label 1097: @64640
     /*  64640 */   GIM_Try, /*On fail goto*//*Label 1098*/ GIMT_Encode4(64749), // Rule ID 13329 //
     /*  64645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64660 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  64664 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64668 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64673 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64677 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64681 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  64685 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64689 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64694 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64698 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64704 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  64706 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  64710 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64714 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64718 */     // MIs[4] LHS
     /*  64718 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64723 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64728 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64730 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  64730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64735 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  64739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  64743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  64747 */     GIR_RootConstrainSelectedInstOperands,
     /*  64748 */     // GIR_Coverage, 13329,
     /*  64748 */     GIR_EraseRootFromParent_Done,
     /*  64749 */   // Label 1098: @64749
     /*  64749 */   GIM_Try, /*On fail goto*//*Label 1099*/ GIMT_Encode4(64858), // Rule ID 2464 //
     /*  64754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64769 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  64773 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64777 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64782 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64787 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  64791 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64795 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  64799 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64803 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  64807 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64811 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64815 */     // MIs[3] LHS
     /*  64815 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  64820 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  64824 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64830 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  64832 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64837 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64839 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  64839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  64848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  64852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  64856 */     GIR_RootConstrainSelectedInstOperands,
     /*  64857 */     // GIR_Coverage, 2464,
     /*  64857 */     GIR_EraseRootFromParent_Done,
     /*  64858 */   // Label 1099: @64858
     /*  64858 */   GIM_Try, /*On fail goto*//*Label 1100*/ GIMT_Encode4(64967), // Rule ID 13325 //
     /*  64863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64878 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  64882 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64886 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64891 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  64900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64904 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  64908 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64912 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  64916 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64920 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64924 */     // MIs[3] LHS
     /*  64924 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  64929 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  64933 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64939 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  64941 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64946 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64948 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  64948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  64957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  64961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  64965 */     GIR_RootConstrainSelectedInstOperands,
     /*  64966 */     // GIR_Coverage, 13325,
     /*  64966 */     GIR_EraseRootFromParent_Done,
     /*  64967 */   // Label 1100: @64967
     /*  64967 */   GIM_Try, /*On fail goto*//*Label 1101*/ GIMT_Encode4(65076), // Rule ID 13324 //
     /*  64972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64987 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  64991 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64995 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65000 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65005 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65009 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65013 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  65017 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65021 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65026 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65030 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65034 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65038 */     // MIs[3] LHS
     /*  65038 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  65043 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65047 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65053 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65055 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65057 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  65057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  65060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  65066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  65070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  65074 */     GIR_RootConstrainSelectedInstOperands,
     /*  65075 */     // GIR_Coverage, 13324,
     /*  65075 */     GIR_EraseRootFromParent_Done,
     /*  65076 */   // Label 1101: @65076
     /*  65076 */   GIM_Try, /*On fail goto*//*Label 1102*/ GIMT_Encode4(65185), // Rule ID 13326 //
     /*  65081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  65100 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65104 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65114 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65118 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65122 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  65126 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65130 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65135 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65139 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65143 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65147 */     // MIs[3] LHS
     /*  65147 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  65152 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65156 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65162 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65164 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65166 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  65166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  65169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  65175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  65179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  65183 */     GIR_RootConstrainSelectedInstOperands,
     /*  65184 */     // GIR_Coverage, 13326,
     /*  65184 */     GIR_EraseRootFromParent_Done,
     /*  65185 */   // Label 1102: @65185
     /*  65185 */   GIM_Try, /*On fail goto*//*Label 1103*/ GIMT_Encode4(65252), // Rule ID 13272 //
     /*  65190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  65205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  65209 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65214 */     // MIs[1] imm
     /*  65214 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65218 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65222 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  65226 */     // MIs[2] Operand 1
     /*  65226 */     // No operand predicates
     /*  65226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65230 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65234 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65236 */     // (or:{ *:[v4i32] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  65239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  65243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65247 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65250 */     GIR_RootConstrainSelectedInstOperands,
     /*  65251 */     // GIR_Coverage, 13272,
     /*  65251 */     GIR_EraseRootFromParent_Done,
     /*  65252 */   // Label 1103: @65252
     /*  65252 */   GIM_Try, /*On fail goto*//*Label 1104*/ GIMT_Encode4(65319), // Rule ID 13293 //
     /*  65257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  65272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  65276 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65281 */     // MIs[1] imm
     /*  65281 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65285 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65289 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  65293 */     // MIs[2] Operand 1
     /*  65293 */     // No operand predicates
     /*  65293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65297 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65301 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65303 */     // (or:{ *:[v4i32] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  65306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  65310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65314 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65317 */     GIR_RootConstrainSelectedInstOperands,
     /*  65318 */     // GIR_Coverage, 13293,
     /*  65318 */     GIR_EraseRootFromParent_Done,
     /*  65319 */   // Label 1104: @65319
     /*  65319 */   GIM_Try, /*On fail goto*//*Label 1105*/ GIMT_Encode4(65386), // Rule ID 2232 //
     /*  65324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  65339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  65343 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  65347 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65352 */     // MIs[1] imm
     /*  65352 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65356 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65360 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  65364 */     // MIs[2] Operand 1
     /*  65364 */     // No operand predicates
     /*  65364 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65368 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65370 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  65373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65375 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  65377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65381 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65384 */     GIR_RootConstrainSelectedInstOperands,
     /*  65385 */     // GIR_Coverage, 2232,
     /*  65385 */     GIR_EraseRootFromParent_Done,
     /*  65386 */   // Label 1105: @65386
     /*  65386 */   GIM_Try, /*On fail goto*//*Label 1106*/ GIMT_Encode4(65453), // Rule ID 2291 //
     /*  65391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65398 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  65406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  65410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  65414 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65419 */     // MIs[1] imm
     /*  65419 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65423 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65427 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  65431 */     // MIs[2] Operand 1
     /*  65431 */     // No operand predicates
     /*  65431 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65435 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65437 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  65440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65442 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  65444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65448 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65451 */     GIR_RootConstrainSelectedInstOperands,
     /*  65452 */     // GIR_Coverage, 2291,
     /*  65452 */     GIR_EraseRootFromParent_Done,
     /*  65453 */   // Label 1106: @65453
     /*  65453 */   GIM_Try, /*On fail goto*//*Label 1107*/ GIMT_Encode4(65517), // Rule ID 13604 //
     /*  65458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65473 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  65477 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65481 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65486 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65490 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65496 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  65498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65502 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65504 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$LHS)  =>  (ORNv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  65504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  65507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  65509 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  65511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  65515 */     GIR_RootConstrainSelectedInstOperands,
     /*  65516 */     // GIR_Coverage, 13604,
     /*  65516 */     GIR_EraseRootFromParent_Done,
     /*  65517 */   // Label 1107: @65517
     /*  65517 */   GIM_Try, /*On fail goto*//*Label 1108*/ GIMT_Encode4(65581), // Rule ID 4995 //
     /*  65522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65529 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  65537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  65545 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65549 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65554 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65558 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65564 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  65566 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65568 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }))  =>  (ORNv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  65568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  65571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  65573 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  65575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  65579 */     GIR_RootConstrainSelectedInstOperands,
     /*  65580 */     // GIR_Coverage, 4995,
     /*  65580 */     GIR_EraseRootFromParent_Done,
     /*  65581 */   // Label 1108: @65581
     /*  65581 */   GIM_Try, /*On fail goto*//*Label 1109*/ GIMT_Encode4(65608), // Rule ID 5001 //
     /*  65586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65601 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (ORRv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  65601 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  65606 */     GIR_RootConstrainSelectedInstOperands,
     /*  65607 */     // GIR_Coverage, 5001,
     /*  65607 */     GIR_Done,
     /*  65608 */   // Label 1109: @65608
     /*  65608 */   GIM_Reject,
     /*  65609 */ // Label 1094: @65609
     /*  65609 */ GIM_Reject,
     /*  65610 */ // Label 994: @65610
     /*  65610 */ GIM_Try, /*On fail goto*//*Label 1110*/ GIMT_Encode4(66917),
     /*  65615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  65618 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  65621 */   GIM_Try, /*On fail goto*//*Label 1111*/ GIMT_Encode4(65730), // Rule ID 13088 //
     /*  65626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  65645 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  65649 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65653 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65657 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  65661 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  65665 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65670 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65674 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65680 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  65682 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65687 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  65691 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65695 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  65699 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65704 */     // MIs[4] Rd
     /*  65704 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65709 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65711 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  65711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  65714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  65720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  65724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  65728 */     GIR_RootConstrainSelectedInstOperands,
     /*  65729 */     // GIR_Coverage, 13088,
     /*  65729 */     GIR_EraseRootFromParent_Done,
     /*  65730 */   // Label 1111: @65730
     /*  65730 */   GIM_Try, /*On fail goto*//*Label 1112*/ GIMT_Encode4(65839), // Rule ID 13087 //
     /*  65735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  65754 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  65758 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65762 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65766 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  65770 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  65774 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65779 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65783 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65789 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  65791 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65796 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  65800 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65804 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  65808 */     // MIs[4] Rd
     /*  65808 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65813 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65818 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65820 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  65820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  65823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  65829 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  65833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  65837 */     GIR_RootConstrainSelectedInstOperands,
     /*  65838 */     // GIR_Coverage, 13087,
     /*  65838 */     GIR_EraseRootFromParent_Done,
     /*  65839 */   // Label 1112: @65839
     /*  65839 */   GIM_Try, /*On fail goto*//*Label 1113*/ GIMT_Encode4(65948), // Rule ID 13090 //
     /*  65844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  65863 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  65867 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65876 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65880 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  65884 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  65888 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65893 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65897 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65903 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  65905 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  65909 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65913 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  65917 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65922 */     // MIs[4] Rd
     /*  65922 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65927 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65929 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  65929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  65932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  65938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  65942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  65946 */     GIR_RootConstrainSelectedInstOperands,
     /*  65947 */     // GIR_Coverage, 13090,
     /*  65947 */     GIR_EraseRootFromParent_Done,
     /*  65948 */   // Label 1113: @65948
     /*  65948 */   GIM_Try, /*On fail goto*//*Label 1114*/ GIMT_Encode4(66057), // Rule ID 13089 //
     /*  65953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  65972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  65976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65989 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  65993 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  65997 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66002 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66006 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66012 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66014 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66018 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66022 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  66026 */     // MIs[4] Rd
     /*  66026 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66031 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66036 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66038 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  66038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  66047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  66051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  66055 */     GIR_RootConstrainSelectedInstOperands,
     /*  66056 */     // GIR_Coverage, 13089,
     /*  66056 */     GIR_EraseRootFromParent_Done,
     /*  66057 */   // Label 1114: @66057
     /*  66057 */   GIM_Try, /*On fail goto*//*Label 1115*/ GIMT_Encode4(66166), // Rule ID 1598 //
     /*  66062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66077 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  66081 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  66085 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66090 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66095 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66099 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66103 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  66107 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  66111 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  66115 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66119 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  66123 */     // MIs[3] Rd
     /*  66123 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  66128 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66132 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66138 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66140 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66145 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66147 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn), (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  66147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  66156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  66160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  66164 */     GIR_RootConstrainSelectedInstOperands,
     /*  66165 */     // GIR_Coverage, 1598,
     /*  66165 */     GIR_EraseRootFromParent_Done,
     /*  66166 */   // Label 1115: @66166
     /*  66166 */   GIM_Try, /*On fail goto*//*Label 1116*/ GIMT_Encode4(66275), // Rule ID 13085 //
     /*  66171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  66190 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  66194 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66199 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66204 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66208 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66212 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  66216 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  66220 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  66224 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66228 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  66232 */     // MIs[3] Rd
     /*  66232 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  66237 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66241 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66247 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66249 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66254 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66256 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd), (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  66256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  66265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  66269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  66273 */     GIR_RootConstrainSelectedInstOperands,
     /*  66274 */     // GIR_Coverage, 13085,
     /*  66274 */     GIR_EraseRootFromParent_Done,
     /*  66275 */   // Label 1116: @66275
     /*  66275 */   GIM_Try, /*On fail goto*//*Label 1117*/ GIMT_Encode4(66384), // Rule ID 13084 //
     /*  66280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66295 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  66299 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  66303 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66308 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66313 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66317 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66321 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  66325 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  66329 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66334 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66338 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66342 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  66346 */     // MIs[3] Rd
     /*  66346 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  66351 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66355 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66361 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66363 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66365 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  66365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  66374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  66378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  66382 */     GIR_RootConstrainSelectedInstOperands,
     /*  66383 */     // GIR_Coverage, 13084,
     /*  66383 */     GIR_EraseRootFromParent_Done,
     /*  66384 */   // Label 1117: @66384
     /*  66384 */   GIM_Try, /*On fail goto*//*Label 1118*/ GIMT_Encode4(66493), // Rule ID 13086 //
     /*  66389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  66408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  66412 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66417 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66422 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66426 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66430 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  66434 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  66438 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66443 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66447 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66451 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  66455 */     // MIs[3] Rd
     /*  66455 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  66460 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66464 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66470 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66472 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66474 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  66474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  66483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  66487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  66491 */     GIR_RootConstrainSelectedInstOperands,
     /*  66492 */     // GIR_Coverage, 13086,
     /*  66492 */     GIR_EraseRootFromParent_Done,
     /*  66493 */   // Label 1118: @66493
     /*  66493 */   GIM_Try, /*On fail goto*//*Label 1119*/ GIMT_Encode4(66560), // Rule ID 13262 //
     /*  66498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  66513 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  66517 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66522 */     // MIs[1] imm
     /*  66522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66526 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66530 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  66534 */     // MIs[2] Operand 1
     /*  66534 */     // No operand predicates
     /*  66534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66538 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  66542 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66544 */     // (or:{ *:[v8i8] } (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  66544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  66547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  66551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  66555 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  66558 */     GIR_RootConstrainSelectedInstOperands,
     /*  66559 */     // GIR_Coverage, 13262,
     /*  66559 */     GIR_EraseRootFromParent_Done,
     /*  66560 */   // Label 1119: @66560
     /*  66560 */   GIM_Try, /*On fail goto*//*Label 1120*/ GIMT_Encode4(66627), // Rule ID 13283 //
     /*  66565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  66580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  66584 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66589 */     // MIs[1] imm
     /*  66589 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66593 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66597 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  66601 */     // MIs[2] Operand 1
     /*  66601 */     // No operand predicates
     /*  66601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66605 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  66609 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66611 */     // (or:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  66611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  66614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66616 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  66618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  66622 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  66625 */     GIR_RootConstrainSelectedInstOperands,
     /*  66626 */     // GIR_Coverage, 13283,
     /*  66626 */     GIR_EraseRootFromParent_Done,
     /*  66627 */   // Label 1120: @66627
     /*  66627 */   GIM_Try, /*On fail goto*//*Label 1121*/ GIMT_Encode4(66694), // Rule ID 2222 //
     /*  66632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  66647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  66651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  66655 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66660 */     // MIs[1] imm
     /*  66660 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66664 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66668 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  66672 */     // MIs[2] Operand 1
     /*  66672 */     // No operand predicates
     /*  66672 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  66676 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66678 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  66678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  66681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66683 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  66685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  66689 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  66692 */     GIR_RootConstrainSelectedInstOperands,
     /*  66693 */     // GIR_Coverage, 2222,
     /*  66693 */     GIR_EraseRootFromParent_Done,
     /*  66694 */   // Label 1121: @66694
     /*  66694 */   GIM_Try, /*On fail goto*//*Label 1122*/ GIMT_Encode4(66761), // Rule ID 2281 //
     /*  66699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  66714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  66718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  66722 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66727 */     // MIs[1] imm
     /*  66727 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66731 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66735 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  66739 */     // MIs[2] Operand 1
     /*  66739 */     // No operand predicates
     /*  66739 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  66743 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66745 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  66745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  66748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66750 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  66752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  66756 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  66759 */     GIR_RootConstrainSelectedInstOperands,
     /*  66760 */     // GIR_Coverage, 2281,
     /*  66760 */     GIR_EraseRootFromParent_Done,
     /*  66761 */   // Label 1122: @66761
     /*  66761 */   GIM_Try, /*On fail goto*//*Label 1123*/ GIMT_Encode4(66825), // Rule ID 13082 //
     /*  66766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  66785 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  66789 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66794 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66798 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66804 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  66806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66810 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66812 */     // (or:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rn)  =>  (ORNv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  66812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  66815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  66817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  66819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  66823 */     GIR_RootConstrainSelectedInstOperands,
     /*  66824 */     // GIR_Coverage, 13082,
     /*  66824 */     GIR_EraseRootFromParent_Done,
     /*  66825 */   // Label 1123: @66825
     /*  66825 */   GIM_Try, /*On fail goto*//*Label 1124*/ GIMT_Encode4(66889), // Rule ID 1594 //
     /*  66830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  66845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  66853 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  66857 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66866 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66872 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  66874 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66876 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }))  =>  (ORNv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  66876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  66879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  66881 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  66883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  66887 */     GIR_RootConstrainSelectedInstOperands,
     /*  66888 */     // GIR_Coverage, 1594,
     /*  66888 */     GIR_EraseRootFromParent_Done,
     /*  66889 */   // Label 1124: @66889
     /*  66889 */   GIM_Try, /*On fail goto*//*Label 1125*/ GIMT_Encode4(66916), // Rule ID 1596 //
     /*  66894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66909 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ORRv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  66909 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  66914 */     GIR_RootConstrainSelectedInstOperands,
     /*  66915 */     // GIR_Coverage, 1596,
     /*  66915 */     GIR_Done,
     /*  66916 */   // Label 1125: @66916
     /*  66916 */   GIM_Reject,
     /*  66917 */ // Label 1110: @66917
     /*  66917 */ GIM_Reject,
     /*  66918 */ // Label 995: @66918
     /*  66918 */ GIM_Try, /*On fail goto*//*Label 1126*/ GIMT_Encode4(68225),
     /*  66923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  66926 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  66929 */   GIM_Try, /*On fail goto*//*Label 1127*/ GIMT_Encode4(67038), // Rule ID 13321 //
     /*  66934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66949 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  66953 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  66957 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66961 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66965 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  66969 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  66973 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66978 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66982 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66988 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66990 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66995 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66999 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67003 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67007 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67012 */     // MIs[4] LHS
     /*  67012 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67017 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67019 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  67019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  67032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  67036 */     GIR_RootConstrainSelectedInstOperands,
     /*  67037 */     // GIR_Coverage, 13321,
     /*  67037 */     GIR_EraseRootFromParent_Done,
     /*  67038 */   // Label 1127: @67038
     /*  67038 */   GIM_Try, /*On fail goto*//*Label 1128*/ GIMT_Encode4(67147), // Rule ID 13320 //
     /*  67043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67058 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67062 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67066 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67070 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67074 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67078 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67082 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67087 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67091 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67097 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67099 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67104 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67108 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67112 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67116 */     // MIs[4] LHS
     /*  67116 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67121 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67126 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67128 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  67128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  67141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  67145 */     GIR_RootConstrainSelectedInstOperands,
     /*  67146 */     // GIR_Coverage, 13320,
     /*  67146 */     GIR_EraseRootFromParent_Done,
     /*  67147 */   // Label 1128: @67147
     /*  67147 */   GIM_Try, /*On fail goto*//*Label 1129*/ GIMT_Encode4(67256), // Rule ID 13323 //
     /*  67152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67167 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67171 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67175 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67180 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67184 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67188 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67192 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67196 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67201 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67205 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67211 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67213 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67217 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67221 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67225 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67230 */     // MIs[4] LHS
     /*  67230 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67235 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67237 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  67237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  67250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67254 */     GIR_RootConstrainSelectedInstOperands,
     /*  67255 */     // GIR_Coverage, 13323,
     /*  67255 */     GIR_EraseRootFromParent_Done,
     /*  67256 */   // Label 1129: @67256
     /*  67256 */   GIM_Try, /*On fail goto*//*Label 1130*/ GIMT_Encode4(67365), // Rule ID 13322 //
     /*  67261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67280 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67284 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67289 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67293 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67297 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67301 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67305 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67310 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67314 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67320 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67322 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67326 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67330 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67334 */     // MIs[4] LHS
     /*  67334 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67339 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67344 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67346 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  67346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  67359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67363 */     GIR_RootConstrainSelectedInstOperands,
     /*  67364 */     // GIR_Coverage, 13322,
     /*  67364 */     GIR_EraseRootFromParent_Done,
     /*  67365 */   // Label 1130: @67365
     /*  67365 */   GIM_Try, /*On fail goto*//*Label 1131*/ GIMT_Encode4(67474), // Rule ID 2463 //
     /*  67370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67385 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67389 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67393 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67398 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67403 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  67407 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67411 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67415 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67419 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  67423 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67427 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67431 */     // MIs[3] LHS
     /*  67431 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  67436 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  67440 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67446 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  67448 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67453 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67455 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  67455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  67464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  67468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  67472 */     GIR_RootConstrainSelectedInstOperands,
     /*  67473 */     // GIR_Coverage, 2463,
     /*  67473 */     GIR_EraseRootFromParent_Done,
     /*  67474 */   // Label 1131: @67474
     /*  67474 */   GIM_Try, /*On fail goto*//*Label 1132*/ GIMT_Encode4(67583), // Rule ID 13318 //
     /*  67479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67494 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67498 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67502 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67507 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67512 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  67516 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67520 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67524 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67528 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  67532 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67536 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67540 */     // MIs[3] LHS
     /*  67540 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  67545 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  67549 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67555 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  67557 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67562 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67564 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  67564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  67573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  67577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  67581 */     GIR_RootConstrainSelectedInstOperands,
     /*  67582 */     // GIR_Coverage, 13318,
     /*  67582 */     GIR_EraseRootFromParent_Done,
     /*  67583 */   // Label 1132: @67583
     /*  67583 */   GIM_Try, /*On fail goto*//*Label 1133*/ GIMT_Encode4(67692), // Rule ID 13317 //
     /*  67588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67603 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67607 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67611 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67616 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67621 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  67625 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67629 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67633 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67637 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67642 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67646 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67650 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67654 */     // MIs[3] LHS
     /*  67654 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  67659 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  67663 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67669 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  67671 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67673 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  67673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  67682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  67686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  67690 */     GIR_RootConstrainSelectedInstOperands,
     /*  67691 */     // GIR_Coverage, 13317,
     /*  67691 */     GIR_EraseRootFromParent_Done,
     /*  67692 */   // Label 1133: @67692
     /*  67692 */   GIM_Try, /*On fail goto*//*Label 1134*/ GIMT_Encode4(67801), // Rule ID 13319 //
     /*  67697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67716 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67725 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67730 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  67734 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67738 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67742 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67746 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67751 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67755 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67759 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67763 */     // MIs[3] LHS
     /*  67763 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  67768 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  67772 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67778 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  67780 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67782 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  67782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  67791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  67795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  67799 */     GIR_RootConstrainSelectedInstOperands,
     /*  67800 */     // GIR_Coverage, 13319,
     /*  67800 */     GIR_EraseRootFromParent_Done,
     /*  67801 */   // Label 1134: @67801
     /*  67801 */   GIM_Try, /*On fail goto*//*Label 1135*/ GIMT_Encode4(67868), // Rule ID 13268 //
     /*  67806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  67821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67825 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67830 */     // MIs[1] imm
     /*  67830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67838 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  67842 */     // MIs[2] Operand 1
     /*  67842 */     // No operand predicates
     /*  67842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67846 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  67850 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67852 */     // (or:{ *:[v8i16] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  67852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  67855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  67859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  67863 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  67866 */     GIR_RootConstrainSelectedInstOperands,
     /*  67867 */     // GIR_Coverage, 13268,
     /*  67867 */     GIR_EraseRootFromParent_Done,
     /*  67868 */   // Label 1135: @67868
     /*  67868 */   GIM_Try, /*On fail goto*//*Label 1136*/ GIMT_Encode4(67935), // Rule ID 13289 //
     /*  67873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  67888 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67892 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67897 */     // MIs[1] imm
     /*  67897 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67901 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67905 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  67909 */     // MIs[2] Operand 1
     /*  67909 */     // No operand predicates
     /*  67909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67913 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  67917 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67919 */     // (or:{ *:[v8i16] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  67919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  67922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  67926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  67930 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  67933 */     GIR_RootConstrainSelectedInstOperands,
     /*  67934 */     // GIR_Coverage, 13289,
     /*  67934 */     GIR_EraseRootFromParent_Done,
     /*  67935 */   // Label 1136: @67935
     /*  67935 */   GIM_Try, /*On fail goto*//*Label 1137*/ GIMT_Encode4(68002), // Rule ID 2228 //
     /*  67940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67947 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  67955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  67959 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67963 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67968 */     // MIs[1] imm
     /*  67968 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67972 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67976 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  67980 */     // MIs[2] Operand 1
     /*  67980 */     // No operand predicates
     /*  67980 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  67984 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67986 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  67986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  67989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67991 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  67993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  67997 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68000 */     GIR_RootConstrainSelectedInstOperands,
     /*  68001 */     // GIR_Coverage, 2228,
     /*  68001 */     GIR_EraseRootFromParent_Done,
     /*  68002 */   // Label 1137: @68002
     /*  68002 */   GIM_Try, /*On fail goto*//*Label 1138*/ GIMT_Encode4(68069), // Rule ID 2287 //
     /*  68007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  68022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  68026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  68030 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68035 */     // MIs[1] imm
     /*  68035 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68039 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68043 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  68047 */     // MIs[2] Operand 1
     /*  68047 */     // No operand predicates
     /*  68047 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  68051 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68053 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  68053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  68056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68058 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  68060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68064 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68067 */     GIR_RootConstrainSelectedInstOperands,
     /*  68068 */     // GIR_Coverage, 2287,
     /*  68068 */     GIR_EraseRootFromParent_Done,
     /*  68069 */   // Label 1138: @68069
     /*  68069 */   GIM_Try, /*On fail goto*//*Label 1139*/ GIMT_Encode4(68133), // Rule ID 13603 //
     /*  68074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  68093 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68097 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68102 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68106 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68112 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  68114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68118 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68120 */     // (or:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$LHS)  =>  (ORNv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  68120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  68123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  68125 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  68127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  68131 */     GIR_RootConstrainSelectedInstOperands,
     /*  68132 */     // GIR_Coverage, 13603,
     /*  68132 */     GIR_EraseRootFromParent_Done,
     /*  68133 */   // Label 1139: @68133
     /*  68133 */   GIM_Try, /*On fail goto*//*Label 1140*/ GIMT_Encode4(68197), // Rule ID 4994 //
     /*  68138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68145 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  68153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  68161 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68165 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68170 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68174 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68180 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  68182 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68184 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }))  =>  (ORNv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  68184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  68187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  68189 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  68191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  68195 */     GIR_RootConstrainSelectedInstOperands,
     /*  68196 */     // GIR_Coverage, 4994,
     /*  68196 */     GIR_EraseRootFromParent_Done,
     /*  68197 */   // Label 1140: @68197
     /*  68197 */   GIM_Try, /*On fail goto*//*Label 1141*/ GIMT_Encode4(68224), // Rule ID 5000 //
     /*  68202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68217 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (ORRv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  68217 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  68222 */     GIR_RootConstrainSelectedInstOperands,
     /*  68223 */     // GIR_Coverage, 5000,
     /*  68223 */     GIR_Done,
     /*  68224 */   // Label 1141: @68224
     /*  68224 */   GIM_Reject,
     /*  68225 */ // Label 1126: @68225
     /*  68225 */ GIM_Reject,
     /*  68226 */ // Label 996: @68226
     /*  68226 */ GIM_Try, /*On fail goto*//*Label 1142*/ GIMT_Encode4(69533),
     /*  68231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68234 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68237 */   GIM_Try, /*On fail goto*//*Label 1143*/ GIMT_Encode4(68346), // Rule ID 13095 //
     /*  68242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68261 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68265 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68269 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68273 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68277 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68281 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68286 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68290 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68296 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  68298 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68303 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  68307 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68311 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68315 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68320 */     // MIs[4] Rd
     /*  68320 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68325 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68327 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  68327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  68330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  68336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  68340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  68344 */     GIR_RootConstrainSelectedInstOperands,
     /*  68345 */     // GIR_Coverage, 13095,
     /*  68345 */     GIR_EraseRootFromParent_Done,
     /*  68346 */   // Label 1143: @68346
     /*  68346 */   GIM_Try, /*On fail goto*//*Label 1144*/ GIMT_Encode4(68455), // Rule ID 13094 //
     /*  68351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68370 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68382 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68386 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68390 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68395 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68399 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68405 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  68407 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68412 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  68416 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68420 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68424 */     // MIs[4] Rd
     /*  68424 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68429 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68434 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68436 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  68436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  68439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  68445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  68449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  68453 */     GIR_RootConstrainSelectedInstOperands,
     /*  68454 */     // GIR_Coverage, 13094,
     /*  68454 */     GIR_EraseRootFromParent_Done,
     /*  68455 */   // Label 1144: @68455
     /*  68455 */   GIM_Try, /*On fail goto*//*Label 1145*/ GIMT_Encode4(68564), // Rule ID 13097 //
     /*  68460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68479 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68483 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68488 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68492 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68496 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68500 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68504 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68509 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68513 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68519 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  68521 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  68525 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68529 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68533 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68538 */     // MIs[4] Rd
     /*  68538 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68543 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68545 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  68545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  68548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  68554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  68558 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  68562 */     GIR_RootConstrainSelectedInstOperands,
     /*  68563 */     // GIR_Coverage, 13097,
     /*  68563 */     GIR_EraseRootFromParent_Done,
     /*  68564 */   // Label 1145: @68564
     /*  68564 */   GIM_Try, /*On fail goto*//*Label 1146*/ GIMT_Encode4(68673), // Rule ID 13096 //
     /*  68569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68584 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68588 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68592 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68597 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68601 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68605 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68609 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68613 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68618 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68622 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68628 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  68630 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  68634 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68638 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68642 */     // MIs[4] Rd
     /*  68642 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68647 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68652 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68654 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  68654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  68657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  68663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  68667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  68671 */     GIR_RootConstrainSelectedInstOperands,
     /*  68672 */     // GIR_Coverage, 13096,
     /*  68672 */     GIR_EraseRootFromParent_Done,
     /*  68673 */   // Label 1146: @68673
     /*  68673 */   GIM_Try, /*On fail goto*//*Label 1147*/ GIMT_Encode4(68782), // Rule ID 1599 //
     /*  68678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68697 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68701 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68706 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68711 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  68715 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68719 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68723 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68727 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  68731 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68735 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68739 */     // MIs[3] Rd
     /*  68739 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  68744 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  68748 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68754 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  68756 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68761 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68763 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  68763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  68766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  68772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  68776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  68780 */     GIR_RootConstrainSelectedInstOperands,
     /*  68781 */     // GIR_Coverage, 1599,
     /*  68781 */     GIR_EraseRootFromParent_Done,
     /*  68782 */   // Label 1147: @68782
     /*  68782 */   GIM_Try, /*On fail goto*//*Label 1148*/ GIMT_Encode4(68891), // Rule ID 13092 //
     /*  68787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68806 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68810 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68815 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  68824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68828 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68832 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68836 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  68840 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68844 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68848 */     // MIs[3] Rd
     /*  68848 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  68853 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  68857 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68863 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  68865 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68870 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68872 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  68872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  68875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  68881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  68889 */     GIR_RootConstrainSelectedInstOperands,
     /*  68890 */     // GIR_Coverage, 13092,
     /*  68890 */     GIR_EraseRootFromParent_Done,
     /*  68891 */   // Label 1148: @68891
     /*  68891 */   GIM_Try, /*On fail goto*//*Label 1149*/ GIMT_Encode4(69000), // Rule ID 13091 //
     /*  68896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68911 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68915 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68919 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68924 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  68933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68937 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  68941 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68945 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68950 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68954 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68958 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68962 */     // MIs[3] Rd
     /*  68962 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  68967 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  68971 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68977 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  68979 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68981 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  68981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  68984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  68990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  68994 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  68998 */     GIR_RootConstrainSelectedInstOperands,
     /*  68999 */     // GIR_Coverage, 13091,
     /*  68999 */     GIR_EraseRootFromParent_Done,
     /*  69000 */   // Label 1149: @69000
     /*  69000 */   GIM_Try, /*On fail goto*//*Label 1150*/ GIMT_Encode4(69109), // Rule ID 13093 //
     /*  69005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  69024 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69028 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69033 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69038 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  69042 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69046 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  69050 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69054 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69059 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69063 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69067 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69071 */     // MIs[3] Rd
     /*  69071 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  69076 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  69080 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69086 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  69088 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69090 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  69090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  69093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  69099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  69107 */     GIR_RootConstrainSelectedInstOperands,
     /*  69108 */     // GIR_Coverage, 13093,
     /*  69108 */     GIR_EraseRootFromParent_Done,
     /*  69109 */   // Label 1150: @69109
     /*  69109 */   GIM_Try, /*On fail goto*//*Label 1151*/ GIMT_Encode4(69176), // Rule ID 13264 //
     /*  69114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  69129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  69133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69138 */     // MIs[1] imm
     /*  69138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69142 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69146 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  69150 */     // MIs[2] Operand 1
     /*  69150 */     // No operand predicates
     /*  69150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69154 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69158 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69160 */     // (or:{ *:[v16i8] } (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  69163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  69167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69171 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69174 */     GIR_RootConstrainSelectedInstOperands,
     /*  69175 */     // GIR_Coverage, 13264,
     /*  69175 */     GIR_EraseRootFromParent_Done,
     /*  69176 */   // Label 1151: @69176
     /*  69176 */   GIM_Try, /*On fail goto*//*Label 1152*/ GIMT_Encode4(69243), // Rule ID 13285 //
     /*  69181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  69196 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  69200 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69205 */     // MIs[1] imm
     /*  69205 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69209 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69213 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  69217 */     // MIs[2] Operand 1
     /*  69217 */     // No operand predicates
     /*  69217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69221 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69225 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69227 */     // (or:{ *:[v16i8] } (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  69230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  69234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69238 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69241 */     GIR_RootConstrainSelectedInstOperands,
     /*  69242 */     // GIR_Coverage, 13285,
     /*  69242 */     GIR_EraseRootFromParent_Done,
     /*  69243 */   // Label 1152: @69243
     /*  69243 */   GIM_Try, /*On fail goto*//*Label 1153*/ GIMT_Encode4(69310), // Rule ID 2224 //
     /*  69248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69255 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  69267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  69271 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69276 */     // MIs[1] imm
     /*  69276 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69280 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69284 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  69288 */     // MIs[2] Operand 1
     /*  69288 */     // No operand predicates
     /*  69288 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69292 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69294 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  69297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69299 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  69301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69305 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69308 */     GIR_RootConstrainSelectedInstOperands,
     /*  69309 */     // GIR_Coverage, 2224,
     /*  69309 */     GIR_EraseRootFromParent_Done,
     /*  69310 */   // Label 1153: @69310
     /*  69310 */   GIM_Try, /*On fail goto*//*Label 1154*/ GIMT_Encode4(69377), // Rule ID 2283 //
     /*  69315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  69334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  69338 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69343 */     // MIs[1] imm
     /*  69343 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69347 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69351 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  69355 */     // MIs[2] Operand 1
     /*  69355 */     // No operand predicates
     /*  69355 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69359 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69361 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  69364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69366 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  69368 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69372 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69375 */     GIR_RootConstrainSelectedInstOperands,
     /*  69376 */     // GIR_Coverage, 2283,
     /*  69376 */     GIR_EraseRootFromParent_Done,
     /*  69377 */   // Label 1154: @69377
     /*  69377 */   GIM_Try, /*On fail goto*//*Label 1155*/ GIMT_Encode4(69441), // Rule ID 13083 //
     /*  69382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  69401 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69405 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69410 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69414 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69420 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  69422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69426 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69428 */     // (or:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rn)  =>  (ORNv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  69428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  69431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  69435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  69439 */     GIR_RootConstrainSelectedInstOperands,
     /*  69440 */     // GIR_Coverage, 13083,
     /*  69440 */     GIR_EraseRootFromParent_Done,
     /*  69441 */   // Label 1155: @69441
     /*  69441 */   GIM_Try, /*On fail goto*//*Label 1156*/ GIMT_Encode4(69505), // Rule ID 1595 //
     /*  69446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69465 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  69469 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69473 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69478 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69482 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69488 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  69490 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69492 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }))  =>  (ORNv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  69492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  69495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69497 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  69499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  69503 */     GIR_RootConstrainSelectedInstOperands,
     /*  69504 */     // GIR_Coverage, 1595,
     /*  69504 */     GIR_EraseRootFromParent_Done,
     /*  69505 */   // Label 1156: @69505
     /*  69505 */   GIM_Try, /*On fail goto*//*Label 1157*/ GIMT_Encode4(69532), // Rule ID 1597 //
     /*  69510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69525 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ORRv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  69525 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  69530 */     GIR_RootConstrainSelectedInstOperands,
     /*  69531 */     // GIR_Coverage, 1597,
     /*  69531 */     GIR_Done,
     /*  69532 */   // Label 1157: @69532
     /*  69532 */   GIM_Reject,
     /*  69533 */ // Label 1142: @69533
     /*  69533 */ GIM_Reject,
     /*  69534 */ // Label 997: @69534
     /*  69534 */ GIM_Try, /*On fail goto*//*Label 1158*/ GIMT_Encode4(69565), // Rule ID 8300 //
     /*  69539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  69542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  69545 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  69548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  69552 */   // (or:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  69552 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  69555 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  69557 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  69559 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  69561 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  69563 */   GIR_RootConstrainSelectedInstOperands,
     /*  69564 */   // GIR_Coverage, 8300,
     /*  69564 */   GIR_EraseRootFromParent_Done,
     /*  69565 */ // Label 1158: @69565
     /*  69565 */ GIM_Reject,
     /*  69566 */ // Label 998: @69566
     /*  69566 */ GIM_Try, /*On fail goto*//*Label 1159*/ GIMT_Encode4(69597), // Rule ID 8299 //
     /*  69571 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  69574 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  69577 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  69580 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  69584 */   // (or:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  69584 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  69587 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  69589 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  69591 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  69593 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  69595 */   GIR_RootConstrainSelectedInstOperands,
     /*  69596 */   // GIR_Coverage, 8299,
     /*  69596 */   GIR_EraseRootFromParent_Done,
     /*  69597 */ // Label 1159: @69597
     /*  69597 */ GIM_Reject,
     /*  69598 */ // Label 999: @69598
     /*  69598 */ GIM_Try, /*On fail goto*//*Label 1160*/ GIMT_Encode4(69623), // Rule ID 7309 //
     /*  69603 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  69606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  69609 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  69612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  69616 */   // (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  69616 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  69621 */   GIR_RootConstrainSelectedInstOperands,
     /*  69622 */   // GIR_Coverage, 7309,
     /*  69622 */   GIR_Done,
     /*  69623 */ // Label 1160: @69623
     /*  69623 */ GIM_Reject,
     /*  69624 */ // Label 1000: @69624
     /*  69624 */ GIM_Try, /*On fail goto*//*Label 1161*/ GIMT_Encode4(69655), // Rule ID 8298 //
     /*  69629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  69632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  69635 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  69638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  69642 */   // (or:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  69642 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  69645 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  69647 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  69649 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  69651 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  69653 */   GIR_RootConstrainSelectedInstOperands,
     /*  69654 */   // GIR_Coverage, 8298,
     /*  69654 */   GIR_EraseRootFromParent_Done,
     /*  69655 */ // Label 1161: @69655
     /*  69655 */ GIM_Reject,
     /*  69656 */ // Label 1001: @69656
     /*  69656 */ GIM_Try, /*On fail goto*//*Label 1162*/ GIMT_Encode4(69681), // Rule ID 7308 //
     /*  69661 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  69664 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  69667 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  69670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  69674 */   // (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  69674 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  69679 */   GIR_RootConstrainSelectedInstOperands,
     /*  69680 */   // GIR_Coverage, 7308,
     /*  69680 */   GIR_Done,
     /*  69681 */ // Label 1162: @69681
     /*  69681 */ GIM_Reject,
     /*  69682 */ // Label 1002: @69682
     /*  69682 */ GIM_Try, /*On fail goto*//*Label 1163*/ GIMT_Encode4(69713), // Rule ID 8297 //
     /*  69687 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  69690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  69693 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  69696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  69700 */   // (or:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  69700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  69703 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  69705 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  69707 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  69709 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  69711 */   GIR_RootConstrainSelectedInstOperands,
     /*  69712 */   // GIR_Coverage, 8297,
     /*  69712 */   GIR_EraseRootFromParent_Done,
     /*  69713 */ // Label 1163: @69713
     /*  69713 */ GIM_Reject,
     /*  69714 */ // Label 1003: @69714
     /*  69714 */ GIM_Try, /*On fail goto*//*Label 1164*/ GIMT_Encode4(69739), // Rule ID 7307 //
     /*  69719 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  69722 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  69725 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  69728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  69732 */   // (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  69732 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  69737 */   GIR_RootConstrainSelectedInstOperands,
     /*  69738 */   // GIR_Coverage, 7307,
     /*  69738 */   GIR_Done,
     /*  69739 */ // Label 1164: @69739
     /*  69739 */ GIM_Reject,
     /*  69740 */ // Label 1004: @69740
     /*  69740 */ GIM_Try, /*On fail goto*//*Label 1165*/ GIMT_Encode4(69771), // Rule ID 8296 //
     /*  69745 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  69748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  69751 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  69754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  69758 */   // (or:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  69758 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  69761 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  69763 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  69765 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  69767 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  69769 */   GIR_RootConstrainSelectedInstOperands,
     /*  69770 */   // GIR_Coverage, 8296,
     /*  69770 */   GIR_EraseRootFromParent_Done,
     /*  69771 */ // Label 1165: @69771
     /*  69771 */ GIM_Reject,
     /*  69772 */ // Label 1005: @69772
     /*  69772 */ GIM_Try, /*On fail goto*//*Label 1166*/ GIMT_Encode4(69797), // Rule ID 7306 //
     /*  69777 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  69780 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  69783 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  69786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  69790 */   // (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  69790 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  69795 */   GIR_RootConstrainSelectedInstOperands,
     /*  69796 */   // GIR_Coverage, 7306,
     /*  69796 */   GIR_Done,
     /*  69797 */ // Label 1166: @69797
     /*  69797 */ GIM_Reject,
     /*  69798 */ // Label 1006: @69798
     /*  69798 */ GIM_Reject,
     /*  69799 */ // Label 7: @69799
     /*  69799 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 1185*/ GIMT_Encode4(75737),
     /*  69810 */ /*GILLT_s32*//*Label 1167*/ GIMT_Encode4(69898),
     /*  69814 */ /*GILLT_s64*//*Label 1168*/ GIMT_Encode4(70578), GIMT_Encode4(0),
     /*  69822 */ /*GILLT_v2s32*//*Label 1169*/ GIMT_Encode4(71321),
     /*  69826 */ /*GILLT_v2s64*//*Label 1170*/ GIMT_Encode4(71389),
     /*  69830 */ /*GILLT_v4s16*//*Label 1171*/ GIMT_Encode4(71915),
     /*  69834 */ /*GILLT_v4s32*//*Label 1172*/ GIMT_Encode4(71983),
     /*  69838 */ /*GILLT_v8s8*//*Label 1173*/ GIMT_Encode4(72509),
     /*  69842 */ /*GILLT_v8s16*//*Label 1174*/ GIMT_Encode4(72580),
     /*  69846 */ /*GILLT_v16s8*//*Label 1175*/ GIMT_Encode4(73106),
     /*  69850 */ /*GILLT_nxv1s1*//*Label 1176*/ GIMT_Encode4(73635),
     /*  69854 */ /*GILLT_nxv2s1*//*Label 1177*/ GIMT_Encode4(73685), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  69866 */ /*GILLT_nxv2s64*//*Label 1178*/ GIMT_Encode4(73735),
     /*  69870 */ /*GILLT_nxv4s1*//*Label 1179*/ GIMT_Encode4(74198), GIMT_Encode4(0),
     /*  69878 */ /*GILLT_nxv4s32*//*Label 1180*/ GIMT_Encode4(74248),
     /*  69882 */ /*GILLT_nxv8s1*//*Label 1181*/ GIMT_Encode4(74711),
     /*  69886 */ /*GILLT_nxv8s16*//*Label 1182*/ GIMT_Encode4(74761),
     /*  69890 */ /*GILLT_nxv16s1*//*Label 1183*/ GIMT_Encode4(75224),
     /*  69894 */ /*GILLT_nxv16s8*//*Label 1184*/ GIMT_Encode4(75274),
     /*  69898 */ // Label 1167: @69898
     /*  69898 */ GIM_Try, /*On fail goto*//*Label 1186*/ GIMT_Encode4(70577),
     /*  69903 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  69906 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69909 */   GIM_Try, /*On fail goto*//*Label 1187*/ GIMT_Encode4(69967), // Rule ID 12953 //
     /*  69914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  69918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  69930 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  69934 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  69939 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  69943 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  69952 */     // (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }))  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  69952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  69955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69961 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  69965 */     GIR_RootConstrainSelectedInstOperands,
     /*  69966 */     // GIR_Coverage, 12953,
     /*  69966 */     GIR_EraseRootFromParent_Done,
     /*  69967 */   // Label 1187: @69967
     /*  69967 */   GIM_Try, /*On fail goto*//*Label 1188*/ GIMT_Encode4(70022), // Rule ID 12952 //
     /*  69972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  69976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  69988 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  69992 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  69996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70002 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  70009 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  70009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  70012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  70016 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  70020 */     GIR_RootConstrainSelectedInstOperands,
     /*  70021 */     // GIR_Coverage, 12952,
     /*  70021 */     GIR_EraseRootFromParent_Done,
     /*  70022 */   // Label 1188: @70022
     /*  70022 */   GIM_Try, /*On fail goto*//*Label 1189*/ GIMT_Encode4(70080), // Rule ID 12950 //
     /*  70027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70039 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70043 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70047 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70052 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  70056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70058 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  70065 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn), -1:{ *:[i32] })  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  70065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  70068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  70074 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  70078 */     GIR_RootConstrainSelectedInstOperands,
     /*  70079 */     // GIR_Coverage, 12950,
     /*  70079 */     GIR_EraseRootFromParent_Done,
     /*  70080 */   // Label 1189: @70080
     /*  70080 */   GIM_Try, /*On fail goto*//*Label 1190*/ GIMT_Encode4(70138), // Rule ID 166 //
     /*  70085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70101 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70105 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70110 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  70114 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70116 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  70123 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift), -1:{ *:[i32] })  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  70123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  70126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70132 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  70136 */     GIR_RootConstrainSelectedInstOperands,
     /*  70137 */     // GIR_Coverage, 166,
     /*  70137 */     GIR_EraseRootFromParent_Done,
     /*  70138 */   // Label 1190: @70138
     /*  70138 */   GIM_Try, /*On fail goto*//*Label 1191*/ GIMT_Encode4(70196), // Rule ID 12951 //
     /*  70143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70159 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70163 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70168 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  70172 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  70181 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }), logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  70181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  70184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70190 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  70194 */     GIR_RootConstrainSelectedInstOperands,
     /*  70195 */     // GIR_Coverage, 12951,
     /*  70195 */     GIR_EraseRootFromParent_Done,
     /*  70196 */   // Label 1191: @70196
     /*  70196 */   GIM_Try, /*On fail goto*//*Label 1192*/ GIMT_Encode4(70251), // Rule ID 12954 //
     /*  70201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  70213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70221 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70225 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  70229 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70231 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  70238 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  70238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  70241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70243 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  70245 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  70249 */     GIR_RootConstrainSelectedInstOperands,
     /*  70250 */     // GIR_Coverage, 12954,
     /*  70250 */     GIR_EraseRootFromParent_Done,
     /*  70251 */   // Label 1192: @70251
     /*  70251 */   GIM_Try, /*On fail goto*//*Label 1193*/ GIMT_Encode4(70292), // Rule ID 144 //
     /*  70256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  70260 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  70268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  70272 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
     /*  70276 */     // MIs[1] Operand 1
     /*  70276 */     // No operand predicates
     /*  70276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70278 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (EORWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  70278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWri),
     /*  70281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70283 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  70285 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
     /*  70290 */     GIR_RootConstrainSelectedInstOperands,
     /*  70291 */     // GIR_Coverage, 144,
     /*  70291 */     GIR_EraseRootFromParent_Done,
     /*  70292 */   // Label 1193: @70292
     /*  70292 */   GIM_Try, /*On fail goto*//*Label 1194*/ GIMT_Encode4(70325), // Rule ID 12960 //
     /*  70297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  70312 */     // (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (EORWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  70312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWrs),
     /*  70315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  70319 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  70323 */     GIR_RootConstrainSelectedInstOperands,
     /*  70324 */     // GIR_Coverage, 12960,
     /*  70324 */     GIR_EraseRootFromParent_Done,
     /*  70325 */   // Label 1194: @70325
     /*  70325 */   GIM_Try, /*On fail goto*//*Label 1195*/ GIMT_Encode4(70358), // Rule ID 170 //
     /*  70330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70334 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  70345 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (EORWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  70345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWrs),
     /*  70348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70350 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  70352 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  70356 */     GIR_RootConstrainSelectedInstOperands,
     /*  70357 */     // GIR_Coverage, 170,
     /*  70357 */     GIR_EraseRootFromParent_Done,
     /*  70358 */   // Label 1195: @70358
     /*  70358 */   GIM_Try, /*On fail goto*//*Label 1196*/ GIMT_Encode4(70411), // Rule ID 12946 //
     /*  70363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70375 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70379 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70383 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70388 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  70392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70398 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rm)  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  70398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
     /*  70401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  70409 */     GIR_RootConstrainSelectedInstOperands,
     /*  70410 */     // GIR_Coverage, 12946,
     /*  70410 */     GIR_EraseRootFromParent_Done,
     /*  70411 */   // Label 1196: @70411
     /*  70411 */   GIM_Try, /*On fail goto*//*Label 1197*/ GIMT_Encode4(70467), // Rule ID 164 //
     /*  70416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70428 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70432 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70436 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70441 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70446 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  70450 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70452 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm), -1:{ *:[i32] })  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  70452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
     /*  70455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  70465 */     GIR_RootConstrainSelectedInstOperands,
     /*  70466 */     // GIR_Coverage, 164,
     /*  70466 */     GIR_EraseRootFromParent_Done,
     /*  70467 */   // Label 1197: @70467
     /*  70467 */   GIM_Try, /*On fail goto*//*Label 1198*/ GIMT_Encode4(70520), // Rule ID 12947 //
     /*  70472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  70484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70488 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70492 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70496 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70501 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  70505 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70507 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }))  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  70507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
     /*  70510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70512 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70516 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  70518 */     GIR_RootConstrainSelectedInstOperands,
     /*  70519 */     // GIR_Coverage, 12947,
     /*  70519 */     GIR_EraseRootFromParent_Done,
     /*  70520 */   // Label 1198: @70520
     /*  70520 */   GIM_Try, /*On fail goto*//*Label 1199*/ GIMT_Encode4(70552), // Rule ID 3944 //
     /*  70525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70529 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70533 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  70537 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Wm, -1:{ *:[i32] })  =>  (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Wm)
     /*  70537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /*  70540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70542 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70548 */     GIR_RootToRootCopy, /*OpIdx*/1, // Wm
     /*  70550 */     GIR_RootConstrainSelectedInstOperands,
     /*  70551 */     // GIR_Coverage, 3944,
     /*  70551 */     GIR_EraseRootFromParent_Done,
     /*  70552 */   // Label 1199: @70552
     /*  70552 */   GIM_Try, /*On fail goto*//*Label 1200*/ GIMT_Encode4(70576), // Rule ID 168 //
     /*  70557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  70569 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (EORWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  70569 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORWrr),
     /*  70574 */     GIR_RootConstrainSelectedInstOperands,
     /*  70575 */     // GIR_Coverage, 168,
     /*  70575 */     GIR_Done,
     /*  70576 */   // Label 1200: @70576
     /*  70576 */   GIM_Reject,
     /*  70577 */ // Label 1186: @70577
     /*  70577 */ GIM_Reject,
     /*  70578 */ // Label 1168: @70578
     /*  70578 */ GIM_Try, /*On fail goto*//*Label 1201*/ GIMT_Encode4(71320),
     /*  70583 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  70586 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  70589 */   GIM_Try, /*On fail goto*//*Label 1202*/ GIMT_Encode4(70647), // Rule ID 12958 //
     /*  70594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  70598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  70602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70606 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  70610 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  70614 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  70619 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  70623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  70632 */     // (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }))  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  70632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  70635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70641 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  70645 */     GIR_RootConstrainSelectedInstOperands,
     /*  70646 */     // GIR_Coverage, 12958,
     /*  70646 */     GIR_EraseRootFromParent_Done,
     /*  70647 */   // Label 1202: @70647
     /*  70647 */   GIM_Try, /*On fail goto*//*Label 1203*/ GIMT_Encode4(70702), // Rule ID 12957 //
     /*  70652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  70656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  70668 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  70672 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  70676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  70680 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70682 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  70689 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  70689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  70692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  70696 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  70700 */     GIR_RootConstrainSelectedInstOperands,
     /*  70701 */     // GIR_Coverage, 12957,
     /*  70701 */     GIR_EraseRootFromParent_Done,
     /*  70702 */   // Label 1203: @70702
     /*  70702 */   GIM_Try, /*On fail goto*//*Label 1204*/ GIMT_Encode4(70760), // Rule ID 12955 //
     /*  70707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  70711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70719 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  70723 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  70727 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  70732 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  70736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70738 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  70745 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn), -1:{ *:[i64] })  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  70745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  70748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  70754 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  70758 */     GIR_RootConstrainSelectedInstOperands,
     /*  70759 */     // GIR_Coverage, 12955,
     /*  70759 */     GIR_EraseRootFromParent_Done,
     /*  70760 */   // Label 1204: @70760
     /*  70760 */   GIM_Try, /*On fail goto*//*Label 1205*/ GIMT_Encode4(70818), // Rule ID 167 //
     /*  70765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  70769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  70781 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  70785 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  70790 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  70794 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70796 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  70803 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift), -1:{ *:[i64] })  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  70803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  70806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70808 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70812 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  70816 */     GIR_RootConstrainSelectedInstOperands,
     /*  70817 */     // GIR_Coverage, 167,
     /*  70817 */     GIR_EraseRootFromParent_Done,
     /*  70818 */   // Label 1205: @70818
     /*  70818 */   GIM_Try, /*On fail goto*//*Label 1206*/ GIMT_Encode4(70876), // Rule ID 12956 //
     /*  70823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  70827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  70839 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  70843 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  70848 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  70852 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  70861 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }), logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  70861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  70864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70870 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  70874 */     GIR_RootConstrainSelectedInstOperands,
     /*  70875 */     // GIR_Coverage, 12956,
     /*  70875 */     GIR_EraseRootFromParent_Done,
     /*  70876 */   // Label 1206: @70876
     /*  70876 */   GIM_Try, /*On fail goto*//*Label 1207*/ GIMT_Encode4(70931), // Rule ID 12959 //
     /*  70881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  70885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  70889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  70893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  70901 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  70905 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  70909 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70911 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  70918 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  70918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  70921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70923 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  70925 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  70929 */     GIR_RootConstrainSelectedInstOperands,
     /*  70930 */     // GIR_Coverage, 12959,
     /*  70930 */     GIR_EraseRootFromParent_Done,
     /*  70931 */   // Label 1207: @70931
     /*  70931 */   GIM_Try, /*On fail goto*//*Label 1208*/ GIMT_Encode4(70972), // Rule ID 145 //
     /*  70936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  70940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  70944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  70948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  70952 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
     /*  70956 */     // MIs[1] Operand 1
     /*  70956 */     // No operand predicates
     /*  70956 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70958 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (EORXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
     /*  70958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXri),
     /*  70961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70963 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  70965 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
     /*  70970 */     GIR_RootConstrainSelectedInstOperands,
     /*  70971 */     // GIR_Coverage, 145,
     /*  70971 */     GIR_EraseRootFromParent_Done,
     /*  70972 */   // Label 1208: @70972
     /*  70972 */   GIM_Try, /*On fail goto*//*Label 1209*/ GIMT_Encode4(71005), // Rule ID 12961 //
     /*  70977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  70981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  70985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  70992 */     // (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (EORXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  70992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXrs),
     /*  70995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  70999 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  71003 */     GIR_RootConstrainSelectedInstOperands,
     /*  71004 */     // GIR_Coverage, 12961,
     /*  71004 */     GIR_EraseRootFromParent_Done,
     /*  71005 */   // Label 1209: @71005
     /*  71005 */   GIM_Try, /*On fail goto*//*Label 1210*/ GIMT_Encode4(71038), // Rule ID 171 //
     /*  71010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  71014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  71018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  71025 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (EORXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  71025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXrs),
     /*  71028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71030 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  71032 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  71036 */     GIR_RootConstrainSelectedInstOperands,
     /*  71037 */     // GIR_Coverage, 171,
     /*  71037 */     GIR_EraseRootFromParent_Done,
     /*  71038 */   // Label 1210: @71038
     /*  71038 */   GIM_Try, /*On fail goto*//*Label 1211*/ GIMT_Encode4(71091), // Rule ID 12948 //
     /*  71043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  71047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71055 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  71059 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  71063 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  71068 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  71072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  71076 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  71078 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rm)  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  71078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
     /*  71081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  71089 */     GIR_RootConstrainSelectedInstOperands,
     /*  71090 */     // GIR_Coverage, 12948,
     /*  71090 */     GIR_EraseRootFromParent_Done,
     /*  71091 */   // Label 1211: @71091
     /*  71091 */   GIM_Try, /*On fail goto*//*Label 1212*/ GIMT_Encode4(71147), // Rule ID 165 //
     /*  71096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  71100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  71112 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  71116 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  71121 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  71126 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  71130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  71132 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm), -1:{ *:[i64] })  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  71132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
     /*  71135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  71145 */     GIR_RootConstrainSelectedInstOperands,
     /*  71146 */     // GIR_Coverage, 165,
     /*  71146 */     GIR_EraseRootFromParent_Done,
     /*  71147 */   // Label 1212: @71147
     /*  71147 */   GIM_Try, /*On fail goto*//*Label 1213*/ GIMT_Encode4(71200), // Rule ID 12949 //
     /*  71152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  71156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  71160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71168 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  71172 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  71176 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  71181 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  71185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  71187 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }))  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  71187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
     /*  71190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71196 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  71198 */     GIR_RootConstrainSelectedInstOperands,
     /*  71199 */     // GIR_Coverage, 12949,
     /*  71199 */     GIR_EraseRootFromParent_Done,
     /*  71200 */   // Label 1213: @71200
     /*  71200 */   GIM_Try, /*On fail goto*//*Label 1214*/ GIMT_Encode4(71232), // Rule ID 3945 //
     /*  71205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  71209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  71213 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  71217 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Xm, -1:{ *:[i64] })  =>  (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Xm)
     /*  71217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /*  71220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71222 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71228 */     GIR_RootToRootCopy, /*OpIdx*/1, // Xm
     /*  71230 */     GIR_RootConstrainSelectedInstOperands,
     /*  71231 */     // GIR_Coverage, 3945,
     /*  71231 */     GIR_EraseRootFromParent_Done,
     /*  71232 */   // Label 1214: @71232
     /*  71232 */   GIM_Try, /*On fail goto*//*Label 1215*/ GIMT_Encode4(71268), // Rule ID 4891 //
     /*  71237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71249 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71255 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  71257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  71259 */     // (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, immAllOnesV:{ *:[v1i64] })  =>  (NOTv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn)
     /*  71259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  71262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71264 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  71266 */     GIR_RootConstrainSelectedInstOperands,
     /*  71267 */     // GIR_Coverage, 4891,
     /*  71267 */     GIR_EraseRootFromParent_Done,
     /*  71268 */   // Label 1215: @71268
     /*  71268 */   GIM_Try, /*On fail goto*//*Label 1216*/ GIMT_Encode4(71292), // Rule ID 169 //
     /*  71273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  71277 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  71281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  71285 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (EORXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  71285 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORXrr),
     /*  71290 */     GIR_RootConstrainSelectedInstOperands,
     /*  71291 */     // GIR_Coverage, 169,
     /*  71291 */     GIR_Done,
     /*  71292 */   // Label 1216: @71292
     /*  71292 */   GIM_Try, /*On fail goto*//*Label 1217*/ GIMT_Encode4(71319), // Rule ID 4987 //
     /*  71297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71304 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71312 */     // (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (EORv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  71312 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  71317 */     GIR_RootConstrainSelectedInstOperands,
     /*  71318 */     // GIR_Coverage, 4987,
     /*  71318 */     GIR_Done,
     /*  71319 */   // Label 1217: @71319
     /*  71319 */   GIM_Reject,
     /*  71320 */ // Label 1201: @71320
     /*  71320 */ GIM_Reject,
     /*  71321 */ // Label 1169: @71321
     /*  71321 */ GIM_Try, /*On fail goto*//*Label 1218*/ GIMT_Encode4(71388),
     /*  71326 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  71329 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  71332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71336 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71340 */   GIM_Try, /*On fail goto*//*Label 1219*/ GIMT_Encode4(71368), // Rule ID 4889 //
     /*  71345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71349 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71355 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  71357 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  71359 */     // (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllOnesV:{ *:[v2i32] })  =>  (NOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /*  71359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  71362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71364 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  71366 */     GIR_RootConstrainSelectedInstOperands,
     /*  71367 */     // GIR_Coverage, 4889,
     /*  71367 */     GIR_EraseRootFromParent_Done,
     /*  71368 */   // Label 1219: @71368
     /*  71368 */   GIM_Try, /*On fail goto*//*Label 1220*/ GIMT_Encode4(71387), // Rule ID 4986 //
     /*  71373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71380 */     // (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (EORv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  71380 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  71385 */     GIR_RootConstrainSelectedInstOperands,
     /*  71386 */     // GIR_Coverage, 4986,
     /*  71386 */     GIR_Done,
     /*  71387 */   // Label 1220: @71387
     /*  71387 */   GIM_Reject,
     /*  71388 */ // Label 1218: @71388
     /*  71388 */ GIM_Reject,
     /*  71389 */ // Label 1170: @71389
     /*  71389 */ GIM_Try, /*On fail goto*//*Label 1221*/ GIMT_Encode4(71914),
     /*  71394 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  71397 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71404 */   GIM_Try, /*On fail goto*//*Label 1222*/ GIMT_Encode4(71489), // Rule ID 13483 //
     /*  71409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  71412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  71424 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  71440 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71444 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71449 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71453 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71459 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71461 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71470 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  71472 */     // (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$Vm), V128:{ *:[v2i64] }:$Vn)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  71472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  71475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  71477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  71479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  71483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  71487 */     GIR_RootConstrainSelectedInstOperands,
     /*  71488 */     // GIR_Coverage, 13483,
     /*  71488 */     GIR_EraseRootFromParent_Done,
     /*  71489 */   // Label 1222: @71489
     /*  71489 */   GIM_Try, /*On fail goto*//*Label 1223*/ GIMT_Encode4(71574), // Rule ID 13482 //
     /*  71494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  71497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  71509 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71513 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71518 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71522 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71526 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  71530 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71534 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71539 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71543 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71549 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71555 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  71557 */     // (xor:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] })), V128:{ *:[v2i64] }:$Vn)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  71557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  71560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  71562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  71564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  71568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  71572 */     GIR_RootConstrainSelectedInstOperands,
     /*  71573 */     // GIR_Coverage, 13482,
     /*  71573 */     GIR_EraseRootFromParent_Done,
     /*  71574 */   // Label 1223: @71574
     /*  71574 */   GIM_Try, /*On fail goto*//*Label 1224*/ GIMT_Encode4(71659), // Rule ID 13481 //
     /*  71579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  71582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71594 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  71598 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71602 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71606 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71610 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  71614 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71618 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71623 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71627 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71633 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71635 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71640 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  71642 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$Vm))  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  71642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  71645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  71647 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  71649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  71653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  71657 */     GIR_RootConstrainSelectedInstOperands,
     /*  71658 */     // GIR_Coverage, 13481,
     /*  71658 */     GIR_EraseRootFromParent_Done,
     /*  71659 */   // Label 1224: @71659
     /*  71659 */   GIM_Try, /*On fail goto*//*Label 1225*/ GIMT_Encode4(71744), // Rule ID 3772 //
     /*  71664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  71667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71679 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  71683 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71692 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71696 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71700 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  71704 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71708 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71713 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71717 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71723 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71725 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  71727 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] })))  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  71727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  71730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  71732 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  71734 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  71738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  71742 */     GIR_RootConstrainSelectedInstOperands,
     /*  71743 */     // GIR_Coverage, 3772,
     /*  71743 */     GIR_EraseRootFromParent_Done,
     /*  71744 */   // Label 1225: @71744
     /*  71744 */   GIM_Try, /*On fail goto*//*Label 1226*/ GIMT_Encode4(71776), // Rule ID 4892 //
     /*  71749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71757 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71763 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  71765 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  71767 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] })  =>  (NOTv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /*  71767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  71770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71772 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  71774 */     GIR_RootConstrainSelectedInstOperands,
     /*  71775 */     // GIR_Coverage, 4892,
     /*  71775 */     GIR_EraseRootFromParent_Done,
     /*  71776 */   // Label 1226: @71776
     /*  71776 */   GIM_Try, /*On fail goto*//*Label 1227*/ GIMT_Encode4(71833), // Rule ID 3768 //
     /*  71781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  71784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71792 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  71796 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71800 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71805 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  71816 */     // (xor:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm), V128:{ *:[v2i64] }:$Va)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  71816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  71819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  71821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  71825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  71829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  71831 */     GIR_RootConstrainSelectedInstOperands,
     /*  71832 */     // GIR_Coverage, 3768,
     /*  71832 */     GIR_EraseRootFromParent_Done,
     /*  71833 */   // Label 1227: @71833
     /*  71833 */   GIM_Try, /*On fail goto*//*Label 1228*/ GIMT_Encode4(71890), // Rule ID 13471 //
     /*  71838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  71841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71853 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  71857 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71861 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71866 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71871 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  71873 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm))  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  71873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  71876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  71878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  71882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  71886 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  71888 */     GIR_RootConstrainSelectedInstOperands,
     /*  71889 */     // GIR_Coverage, 13471,
     /*  71889 */     GIR_EraseRootFromParent_Done,
     /*  71890 */   // Label 1228: @71890
     /*  71890 */   GIM_Try, /*On fail goto*//*Label 1229*/ GIMT_Encode4(71913), // Rule ID 4990 //
     /*  71895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71906 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (EORv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  71906 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  71911 */     GIR_RootConstrainSelectedInstOperands,
     /*  71912 */     // GIR_Coverage, 4990,
     /*  71912 */     GIR_Done,
     /*  71913 */   // Label 1229: @71913
     /*  71913 */   GIM_Reject,
     /*  71914 */ // Label 1221: @71914
     /*  71914 */ GIM_Reject,
     /*  71915 */ // Label 1171: @71915
     /*  71915 */ GIM_Try, /*On fail goto*//*Label 1230*/ GIMT_Encode4(71982),
     /*  71920 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  71923 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  71926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71930 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71934 */   GIM_Try, /*On fail goto*//*Label 1231*/ GIMT_Encode4(71962), // Rule ID 4887 //
     /*  71939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71943 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71949 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  71951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  71953 */     // (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllOnesV:{ *:[v4i16] })  =>  (NOTv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /*  71953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  71956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71958 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  71960 */     GIR_RootConstrainSelectedInstOperands,
     /*  71961 */     // GIR_Coverage, 4887,
     /*  71961 */     GIR_EraseRootFromParent_Done,
     /*  71962 */   // Label 1231: @71962
     /*  71962 */   GIM_Try, /*On fail goto*//*Label 1232*/ GIMT_Encode4(71981), // Rule ID 4985 //
     /*  71967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71974 */     // (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (EORv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  71974 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  71979 */     GIR_RootConstrainSelectedInstOperands,
     /*  71980 */     // GIR_Coverage, 4985,
     /*  71980 */     GIR_Done,
     /*  71981 */   // Label 1232: @71981
     /*  71981 */   GIM_Reject,
     /*  71982 */ // Label 1230: @71982
     /*  71982 */ GIM_Reject,
     /*  71983 */ // Label 1172: @71983
     /*  71983 */ GIM_Try, /*On fail goto*//*Label 1233*/ GIMT_Encode4(72508),
     /*  71988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  71991 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  71994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71998 */   GIM_Try, /*On fail goto*//*Label 1234*/ GIMT_Encode4(72083), // Rule ID 13480 //
     /*  72003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  72006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  72018 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72022 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72026 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72030 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  72034 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72038 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72043 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72047 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72053 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  72055 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72064 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72066 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$Vm), V128:{ *:[v4i32] }:$Vn)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  72066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  72069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  72073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  72077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  72081 */     GIR_RootConstrainSelectedInstOperands,
     /*  72082 */     // GIR_Coverage, 13480,
     /*  72082 */     GIR_EraseRootFromParent_Done,
     /*  72083 */   // Label 1234: @72083
     /*  72083 */   GIM_Try, /*On fail goto*//*Label 1235*/ GIMT_Encode4(72168), // Rule ID 13479 //
     /*  72088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  72091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72099 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  72103 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72107 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72112 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72116 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72120 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  72124 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72128 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72133 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72137 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72143 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  72145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72149 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72151 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] })), V128:{ *:[v4i32] }:$Vn)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  72151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  72154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  72158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  72162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  72166 */     GIR_RootConstrainSelectedInstOperands,
     /*  72167 */     // GIR_Coverage, 13479,
     /*  72167 */     GIR_EraseRootFromParent_Done,
     /*  72168 */   // Label 1235: @72168
     /*  72168 */   GIM_Try, /*On fail goto*//*Label 1236*/ GIMT_Encode4(72253), // Rule ID 13478 //
     /*  72173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  72176 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  72192 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72196 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72200 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72204 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  72208 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72212 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72217 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72221 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72227 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  72229 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72234 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72236 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$Vm))  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  72236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  72239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72241 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  72243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  72247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  72251 */     GIR_RootConstrainSelectedInstOperands,
     /*  72252 */     // GIR_Coverage, 13478,
     /*  72252 */     GIR_EraseRootFromParent_Done,
     /*  72253 */   // Label 1236: @72253
     /*  72253 */   GIM_Try, /*On fail goto*//*Label 1237*/ GIMT_Encode4(72338), // Rule ID 3771 //
     /*  72258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  72261 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  72277 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72281 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72290 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72294 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  72298 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72302 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72307 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72311 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72317 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  72319 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72321 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] })))  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  72321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  72324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72326 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  72328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  72332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  72336 */     GIR_RootConstrainSelectedInstOperands,
     /*  72337 */     // GIR_Coverage, 3771,
     /*  72337 */     GIR_EraseRootFromParent_Done,
     /*  72338 */   // Label 1237: @72338
     /*  72338 */   GIM_Try, /*On fail goto*//*Label 1238*/ GIMT_Encode4(72370), // Rule ID 4890 //
     /*  72343 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72351 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72357 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  72359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72361 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] })  =>  (NOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /*  72361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  72364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72366 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  72368 */     GIR_RootConstrainSelectedInstOperands,
     /*  72369 */     // GIR_Coverage, 4890,
     /*  72369 */     GIR_EraseRootFromParent_Done,
     /*  72370 */   // Label 1238: @72370
     /*  72370 */   GIM_Try, /*On fail goto*//*Label 1239*/ GIMT_Encode4(72427), // Rule ID 3767 //
     /*  72375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  72378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72386 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  72390 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72394 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72399 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72408 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72410 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm), V128:{ *:[v4i32] }:$Va)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  72410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  72413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  72419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  72423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  72425 */     GIR_RootConstrainSelectedInstOperands,
     /*  72426 */     // GIR_Coverage, 3767,
     /*  72426 */     GIR_EraseRootFromParent_Done,
     /*  72427 */   // Label 1239: @72427
     /*  72427 */   GIM_Try, /*On fail goto*//*Label 1240*/ GIMT_Encode4(72484), // Rule ID 13470 //
     /*  72432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  72435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72447 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  72451 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72455 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72460 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72465 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72467 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm))  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  72467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  72470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  72476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  72480 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  72482 */     GIR_RootConstrainSelectedInstOperands,
     /*  72483 */     // GIR_Coverage, 13470,
     /*  72483 */     GIR_EraseRootFromParent_Done,
     /*  72484 */   // Label 1240: @72484
     /*  72484 */   GIM_Try, /*On fail goto*//*Label 1241*/ GIMT_Encode4(72507), // Rule ID 4989 //
     /*  72489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72492 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72500 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (EORv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  72500 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  72505 */     GIR_RootConstrainSelectedInstOperands,
     /*  72506 */     // GIR_Coverage, 4989,
     /*  72506 */     GIR_Done,
     /*  72507 */   // Label 1241: @72507
     /*  72507 */   GIM_Reject,
     /*  72508 */ // Label 1233: @72508
     /*  72508 */ GIM_Reject,
     /*  72509 */ // Label 1173: @72509
     /*  72509 */ GIM_Try, /*On fail goto*//*Label 1242*/ GIMT_Encode4(72579),
     /*  72514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  72517 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  72520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  72524 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  72528 */   GIM_Try, /*On fail goto*//*Label 1243*/ GIMT_Encode4(72559), // Rule ID 965 //
     /*  72533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72540 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72546 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  72548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72550 */     // (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllOnesV:{ *:[v8i8] })  =>  (NOTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /*  72550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  72553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72555 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  72557 */     GIR_RootConstrainSelectedInstOperands,
     /*  72558 */     // GIR_Coverage, 965,
     /*  72558 */     GIR_EraseRootFromParent_Done,
     /*  72559 */   // Label 1243: @72559
     /*  72559 */   GIM_Try, /*On fail goto*//*Label 1244*/ GIMT_Encode4(72578), // Rule ID 1592 //
     /*  72564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  72571 */     // (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (EORv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  72571 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  72576 */     GIR_RootConstrainSelectedInstOperands,
     /*  72577 */     // GIR_Coverage, 1592,
     /*  72577 */     GIR_Done,
     /*  72578 */   // Label 1244: @72578
     /*  72578 */   GIM_Reject,
     /*  72579 */ // Label 1242: @72579
     /*  72579 */ GIM_Reject,
     /*  72580 */ // Label 1174: @72580
     /*  72580 */ GIM_Try, /*On fail goto*//*Label 1245*/ GIMT_Encode4(73105),
     /*  72585 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72588 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72595 */   GIM_Try, /*On fail goto*//*Label 1246*/ GIMT_Encode4(72680), // Rule ID 13477 //
     /*  72600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  72603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72615 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72619 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72623 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72627 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72631 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72635 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72640 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72644 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72650 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  72652 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72661 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72663 */     // (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$Vm), V128:{ *:[v8i16] }:$Vn)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  72663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  72666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  72670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  72674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  72678 */     GIR_RootConstrainSelectedInstOperands,
     /*  72679 */     // GIR_Coverage, 13477,
     /*  72679 */     GIR_EraseRootFromParent_Done,
     /*  72680 */   // Label 1246: @72680
     /*  72680 */   GIM_Try, /*On fail goto*//*Label 1247*/ GIMT_Encode4(72765), // Rule ID 13476 //
     /*  72685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  72688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72700 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72704 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72709 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72713 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72717 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72721 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72725 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72730 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72734 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72740 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  72742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72746 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72748 */     // (xor:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] })), V128:{ *:[v8i16] }:$Vn)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  72748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  72751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  72755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  72759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  72763 */     GIR_RootConstrainSelectedInstOperands,
     /*  72764 */     // GIR_Coverage, 13476,
     /*  72764 */     GIR_EraseRootFromParent_Done,
     /*  72765 */   // Label 1247: @72765
     /*  72765 */   GIM_Try, /*On fail goto*//*Label 1248*/ GIMT_Encode4(72850), // Rule ID 13475 //
     /*  72770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  72773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72785 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72789 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72793 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72797 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72801 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72805 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72809 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72814 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72818 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72824 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  72826 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72831 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72833 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$Vm))  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  72833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  72836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72838 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  72840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  72844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  72848 */     GIR_RootConstrainSelectedInstOperands,
     /*  72849 */     // GIR_Coverage, 13475,
     /*  72849 */     GIR_EraseRootFromParent_Done,
     /*  72850 */   // Label 1248: @72850
     /*  72850 */   GIM_Try, /*On fail goto*//*Label 1249*/ GIMT_Encode4(72935), // Rule ID 3770 //
     /*  72855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  72858 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72874 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72878 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72883 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72887 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72891 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72895 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72899 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72904 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72908 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72914 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  72916 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72918 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] })))  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  72918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  72921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72923 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  72925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  72929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  72933 */     GIR_RootConstrainSelectedInstOperands,
     /*  72934 */     // GIR_Coverage, 3770,
     /*  72934 */     GIR_EraseRootFromParent_Done,
     /*  72935 */   // Label 1249: @72935
     /*  72935 */   GIM_Try, /*On fail goto*//*Label 1250*/ GIMT_Encode4(72967), // Rule ID 4888 //
     /*  72940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72948 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72954 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  72956 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72958 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] })  =>  (NOTv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /*  72958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  72961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72963 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  72965 */     GIR_RootConstrainSelectedInstOperands,
     /*  72966 */     // GIR_Coverage, 4888,
     /*  72966 */     GIR_EraseRootFromParent_Done,
     /*  72967 */   // Label 1250: @72967
     /*  72967 */   GIM_Try, /*On fail goto*//*Label 1251*/ GIMT_Encode4(73024), // Rule ID 3766 //
     /*  72972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  72975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72983 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72987 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72991 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72996 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73007 */     // (xor:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm), V128:{ *:[v8i16] }:$Va)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  73007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  73010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  73012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  73016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  73020 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  73022 */     GIR_RootConstrainSelectedInstOperands,
     /*  73023 */     // GIR_Coverage, 3766,
     /*  73023 */     GIR_EraseRootFromParent_Done,
     /*  73024 */   // Label 1251: @73024
     /*  73024 */   GIM_Try, /*On fail goto*//*Label 1252*/ GIMT_Encode4(73081), // Rule ID 13469 //
     /*  73029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  73032 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73044 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  73048 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  73052 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73057 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73062 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73064 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm))  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  73064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  73067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  73069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  73073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  73077 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  73079 */     GIR_RootConstrainSelectedInstOperands,
     /*  73080 */     // GIR_Coverage, 13469,
     /*  73080 */     GIR_EraseRootFromParent_Done,
     /*  73081 */   // Label 1252: @73081
     /*  73081 */   GIM_Try, /*On fail goto*//*Label 1253*/ GIMT_Encode4(73104), // Rule ID 4988 //
     /*  73086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73097 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (EORv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  73097 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  73102 */     GIR_RootConstrainSelectedInstOperands,
     /*  73103 */     // GIR_Coverage, 4988,
     /*  73103 */     GIR_Done,
     /*  73104 */   // Label 1253: @73104
     /*  73104 */   GIM_Reject,
     /*  73105 */ // Label 1245: @73105
     /*  73105 */ GIM_Reject,
     /*  73106 */ // Label 1175: @73106
     /*  73106 */ GIM_Try, /*On fail goto*//*Label 1254*/ GIMT_Encode4(73634),
     /*  73111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73114 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73121 */   GIM_Try, /*On fail goto*//*Label 1255*/ GIMT_Encode4(73206), // Rule ID 13474 //
     /*  73126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  73129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73137 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73141 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73145 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73149 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73153 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73157 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73161 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73166 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73170 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73176 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73178 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73187 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  73189 */     // (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Vm), V128:{ *:[v16i8] }:$Vn)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  73189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  73192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  73194 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  73196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  73200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  73204 */     GIR_RootConstrainSelectedInstOperands,
     /*  73205 */     // GIR_Coverage, 13474,
     /*  73205 */     GIR_EraseRootFromParent_Done,
     /*  73206 */   // Label 1255: @73206
     /*  73206 */   GIM_Try, /*On fail goto*//*Label 1256*/ GIMT_Encode4(73291), // Rule ID 13473 //
     /*  73211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  73214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73222 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73226 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73230 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73235 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73239 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73243 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73247 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73251 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73256 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73260 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73266 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73272 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  73274 */     // (xor:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] })), V128:{ *:[v16i8] }:$Vn)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  73274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  73277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  73279 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  73281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  73285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  73289 */     GIR_RootConstrainSelectedInstOperands,
     /*  73290 */     // GIR_Coverage, 13473,
     /*  73290 */     GIR_EraseRootFromParent_Done,
     /*  73291 */   // Label 1256: @73291
     /*  73291 */   GIM_Try, /*On fail goto*//*Label 1257*/ GIMT_Encode4(73376), // Rule ID 13472 //
     /*  73296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  73299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73315 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73319 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73327 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73331 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73335 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73340 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73344 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73350 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73352 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73357 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  73359 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Vm))  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  73359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  73362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  73364 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  73366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  73370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  73374 */     GIR_RootConstrainSelectedInstOperands,
     /*  73375 */     // GIR_Coverage, 13472,
     /*  73375 */     GIR_EraseRootFromParent_Done,
     /*  73376 */   // Label 1257: @73376
     /*  73376 */   GIM_Try, /*On fail goto*//*Label 1258*/ GIMT_Encode4(73461), // Rule ID 3769 //
     /*  73381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  73384 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73400 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73404 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73409 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73413 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73417 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73421 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73425 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73430 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73434 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73440 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73442 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  73444 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] })))  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  73444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  73447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  73449 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  73451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  73455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  73459 */     GIR_RootConstrainSelectedInstOperands,
     /*  73460 */     // GIR_Coverage, 3769,
     /*  73460 */     GIR_EraseRootFromParent_Done,
     /*  73461 */   // Label 1258: @73461
     /*  73461 */   GIM_Try, /*On fail goto*//*Label 1259*/ GIMT_Encode4(73496), // Rule ID 966 //
     /*  73466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73477 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73483 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  73485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73487 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllOnesV:{ *:[v16i8] })  =>  (NOTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /*  73487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  73490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73492 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  73494 */     GIR_RootConstrainSelectedInstOperands,
     /*  73495 */     // GIR_Coverage, 966,
     /*  73495 */     GIR_EraseRootFromParent_Done,
     /*  73496 */   // Label 1259: @73496
     /*  73496 */   GIM_Try, /*On fail goto*//*Label 1260*/ GIMT_Encode4(73553), // Rule ID 3765 //
     /*  73501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  73504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73512 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73516 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73520 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73525 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73534 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73536 */     // (xor:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm), V128:{ *:[v16i8] }:$Va)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  73536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  73539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  73541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  73545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  73549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  73551 */     GIR_RootConstrainSelectedInstOperands,
     /*  73552 */     // GIR_Coverage, 3765,
     /*  73552 */     GIR_EraseRootFromParent_Done,
     /*  73553 */   // Label 1260: @73553
     /*  73553 */   GIM_Try, /*On fail goto*//*Label 1261*/ GIMT_Encode4(73610), // Rule ID 13468 //
     /*  73558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  73561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73577 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73581 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73586 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73593 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm))  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  73593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  73596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  73598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  73602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  73606 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  73608 */     GIR_RootConstrainSelectedInstOperands,
     /*  73609 */     // GIR_Coverage, 13468,
     /*  73609 */     GIR_EraseRootFromParent_Done,
     /*  73610 */   // Label 1261: @73610
     /*  73610 */   GIM_Try, /*On fail goto*//*Label 1262*/ GIMT_Encode4(73633), // Rule ID 1593 //
     /*  73615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73626 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (EORv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  73626 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  73631 */     GIR_RootConstrainSelectedInstOperands,
     /*  73632 */     // GIR_Coverage, 1593,
     /*  73632 */     GIR_Done,
     /*  73633 */   // Label 1262: @73633
     /*  73633 */   GIM_Reject,
     /*  73634 */ // Label 1254: @73634
     /*  73634 */ GIM_Reject,
     /*  73635 */ // Label 1176: @73635
     /*  73635 */ GIM_Try, /*On fail goto*//*Label 1263*/ GIMT_Encode4(73684), // Rule ID 8290 //
     /*  73640 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  73643 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  73646 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  73649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  73653 */   // (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv1i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  73653 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  73656 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  73660 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73665 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  73668 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  73670 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  73673 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  73675 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73678 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  73680 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  73682 */   GIR_RootConstrainSelectedInstOperands,
     /*  73683 */   // GIR_Coverage, 8290,
     /*  73683 */   GIR_EraseRootFromParent_Done,
     /*  73684 */ // Label 1263: @73684
     /*  73684 */ GIM_Reject,
     /*  73685 */ // Label 1177: @73685
     /*  73685 */ GIM_Try, /*On fail goto*//*Label 1264*/ GIMT_Encode4(73734), // Rule ID 8289 //
     /*  73690 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  73693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  73696 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  73699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  73703 */   // (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv2i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  73703 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  73706 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  73710 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73715 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  73718 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  73720 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  73723 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  73725 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73728 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  73730 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  73732 */   GIR_RootConstrainSelectedInstOperands,
     /*  73733 */   // GIR_Coverage, 8289,
     /*  73733 */   GIR_EraseRootFromParent_Done,
     /*  73734 */ // Label 1264: @73734
     /*  73734 */ GIM_Reject,
     /*  73735 */ // Label 1178: @73735
     /*  73735 */ GIM_Try, /*On fail goto*//*Label 1265*/ GIMT_Encode4(74197),
     /*  73740 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73743 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  73750 */   GIM_Try, /*On fail goto*//*Label 1266*/ GIMT_Encode4(73821), // Rule ID 15326 //
     /*  73755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  73758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73770 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73782 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73786 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73790 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73794 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73800 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73802 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  73804 */     // (xor:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  73804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  73807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  73809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  73811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  73815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  73819 */     GIR_RootConstrainSelectedInstOperands,
     /*  73820 */     // GIR_Coverage, 15326,
     /*  73820 */     GIR_EraseRootFromParent_Done,
     /*  73821 */   // Label 1266: @73821
     /*  73821 */   GIM_Try, /*On fail goto*//*Label 1267*/ GIMT_Encode4(73892), // Rule ID 15325 //
     /*  73826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  73829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73841 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73853 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73857 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73861 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73865 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73871 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73873 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  73875 */     // (xor:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  73875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  73878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  73880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  73882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  73886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  73890 */     GIR_RootConstrainSelectedInstOperands,
     /*  73891 */     // GIR_Coverage, 15325,
     /*  73891 */     GIR_EraseRootFromParent_Done,
     /*  73892 */   // Label 1267: @73892
     /*  73892 */   GIM_Try, /*On fail goto*//*Label 1268*/ GIMT_Encode4(73963), // Rule ID 15324 //
     /*  73897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  73900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73912 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73916 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73920 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73924 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73928 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73932 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73936 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73942 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73944 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  73946 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  73946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  73949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  73951 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  73953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  73957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  73961 */     GIR_RootConstrainSelectedInstOperands,
     /*  73962 */     // GIR_Coverage, 15324,
     /*  73962 */     GIR_EraseRootFromParent_Done,
     /*  73963 */   // Label 1268: @73963
     /*  73963 */   GIM_Try, /*On fail goto*//*Label 1269*/ GIMT_Encode4(74034), // Rule ID 11672 //
     /*  73968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  73971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73983 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73987 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73991 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73995 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73999 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74003 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74007 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74013 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74015 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74017 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  74020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74022 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  74024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  74028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  74032 */     GIR_RootConstrainSelectedInstOperands,
     /*  74033 */     // GIR_Coverage, 11672,
     /*  74033 */     GIR_EraseRootFromParent_Done,
     /*  74034 */   // Label 1269: @74034
     /*  74034 */   GIM_Try, /*On fail goto*//*Label 1270*/ GIMT_Encode4(74095), // Rule ID 11696 //
     /*  74039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  74050 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74054 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74058 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  74062 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  74066 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74072 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  74074 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74076 */     // (xor:{ *:[nxv2i64] } (AArch64bsp:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  74079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  74085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  74089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  74093 */     GIR_RootConstrainSelectedInstOperands,
     /*  74094 */     // GIR_Coverage, 11696,
     /*  74094 */     GIR_EraseRootFromParent_Done,
     /*  74095 */   // Label 1270: @74095
     /*  74095 */   GIM_Try, /*On fail goto*//*Label 1271*/ GIMT_Encode4(74138), // Rule ID 13435 //
     /*  74100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74111 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74115 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74121 */     // (xor:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  74124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  74130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  74134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  74136 */     GIR_RootConstrainSelectedInstOperands,
     /*  74137 */     // GIR_Coverage, 13435,
     /*  74137 */     GIR_EraseRootFromParent_Done,
     /*  74138 */   // Label 1271: @74138
     /*  74138 */   GIM_Try, /*On fail goto*//*Label 1272*/ GIMT_Encode4(74181), // Rule ID 3140 //
     /*  74143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  74150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74154 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74158 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74164 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  74167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74169 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  74171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  74175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  74179 */     GIR_RootConstrainSelectedInstOperands,
     /*  74180 */     // GIR_Coverage, 3140,
     /*  74180 */     GIR_EraseRootFromParent_Done,
     /*  74181 */   // Label 1272: @74181
     /*  74181 */   GIM_Try, /*On fail goto*//*Label 1273*/ GIMT_Encode4(74196), // Rule ID 7313 //
     /*  74186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  74189 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  74189 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  74194 */     GIR_RootConstrainSelectedInstOperands,
     /*  74195 */     // GIR_Coverage, 7313,
     /*  74195 */     GIR_Done,
     /*  74196 */   // Label 1273: @74196
     /*  74196 */   GIM_Reject,
     /*  74197 */ // Label 1265: @74197
     /*  74197 */ GIM_Reject,
     /*  74198 */ // Label 1179: @74198
     /*  74198 */ GIM_Try, /*On fail goto*//*Label 1274*/ GIMT_Encode4(74247), // Rule ID 8288 //
     /*  74203 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  74206 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  74209 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  74212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  74216 */   // (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv4i1] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  74216 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  74219 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /*  74223 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74228 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  74231 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  74233 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  74236 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  74238 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74241 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  74243 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  74245 */   GIR_RootConstrainSelectedInstOperands,
     /*  74246 */   // GIR_Coverage, 8288,
     /*  74246 */   GIR_EraseRootFromParent_Done,
     /*  74247 */ // Label 1274: @74247
     /*  74247 */ GIM_Reject,
     /*  74248 */ // Label 1180: @74248
     /*  74248 */ GIM_Try, /*On fail goto*//*Label 1275*/ GIMT_Encode4(74710),
     /*  74253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  74256 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  74259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  74263 */   GIM_Try, /*On fail goto*//*Label 1276*/ GIMT_Encode4(74334), // Rule ID 15323 //
     /*  74268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  74283 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  74287 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74291 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74295 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  74299 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  74303 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74307 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74313 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74315 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74317 */     // (xor:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  74317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  74320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  74324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  74328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  74332 */     GIR_RootConstrainSelectedInstOperands,
     /*  74333 */     // GIR_Coverage, 15323,
     /*  74333 */     GIR_EraseRootFromParent_Done,
     /*  74334 */   // Label 1276: @74334
     /*  74334 */   GIM_Try, /*On fail goto*//*Label 1277*/ GIMT_Encode4(74405), // Rule ID 15322 //
     /*  74339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74350 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  74354 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  74358 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74362 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74366 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  74370 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  74374 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74378 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74384 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74386 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74388 */     // (xor:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  74388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  74391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  74395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  74399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  74403 */     GIR_RootConstrainSelectedInstOperands,
     /*  74404 */     // GIR_Coverage, 15322,
     /*  74404 */     GIR_EraseRootFromParent_Done,
     /*  74405 */   // Label 1277: @74405
     /*  74405 */   GIM_Try, /*On fail goto*//*Label 1278*/ GIMT_Encode4(74476), // Rule ID 15321 //
     /*  74410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  74417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74421 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  74425 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  74429 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74433 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74437 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  74441 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  74445 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74449 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74455 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74457 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74459 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  74459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  74462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74464 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  74466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  74470 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  74474 */     GIR_RootConstrainSelectedInstOperands,
     /*  74475 */     // GIR_Coverage, 15321,
     /*  74475 */     GIR_EraseRootFromParent_Done,
     /*  74476 */   // Label 1278: @74476
     /*  74476 */   GIM_Try, /*On fail goto*//*Label 1279*/ GIMT_Encode4(74547), // Rule ID 11670 //
     /*  74481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  74488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  74496 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  74500 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74504 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74508 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  74512 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  74516 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74520 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74526 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74528 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74530 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  74530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  74533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74535 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  74537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  74541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  74545 */     GIR_RootConstrainSelectedInstOperands,
     /*  74546 */     // GIR_Coverage, 11670,
     /*  74546 */     GIR_EraseRootFromParent_Done,
     /*  74547 */   // Label 1279: @74547
     /*  74547 */   GIM_Try, /*On fail goto*//*Label 1280*/ GIMT_Encode4(74608), // Rule ID 11694 //
     /*  74552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  74563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  74567 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  74571 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  74575 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  74579 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74585 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  74587 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74589 */     // (xor:{ *:[nxv4i32] } (AArch64bsp:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  74589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  74592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  74598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  74602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  74606 */     GIR_RootConstrainSelectedInstOperands,
     /*  74607 */     // GIR_Coverage, 11694,
     /*  74607 */     GIR_EraseRootFromParent_Done,
     /*  74608 */   // Label 1280: @74608
     /*  74608 */   GIM_Try, /*On fail goto*//*Label 1281*/ GIMT_Encode4(74651), // Rule ID 13434 //
     /*  74613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74624 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  74628 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  74632 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74634 */     // (xor:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  74634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  74637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  74643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  74647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  74649 */     GIR_RootConstrainSelectedInstOperands,
     /*  74650 */     // GIR_Coverage, 13434,
     /*  74650 */     GIR_EraseRootFromParent_Done,
     /*  74651 */   // Label 1281: @74651
     /*  74651 */   GIM_Try, /*On fail goto*//*Label 1282*/ GIMT_Encode4(74694), // Rule ID 3138 //
     /*  74656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  74663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  74671 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  74675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74677 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  74677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  74680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74682 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  74684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  74688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  74692 */     GIR_RootConstrainSelectedInstOperands,
     /*  74693 */     // GIR_Coverage, 3138,
     /*  74693 */     GIR_EraseRootFromParent_Done,
     /*  74694 */   // Label 1282: @74694
     /*  74694 */   GIM_Try, /*On fail goto*//*Label 1283*/ GIMT_Encode4(74709), // Rule ID 7312 //
     /*  74699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  74702 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  74702 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  74707 */     GIR_RootConstrainSelectedInstOperands,
     /*  74708 */     // GIR_Coverage, 7312,
     /*  74708 */     GIR_Done,
     /*  74709 */   // Label 1283: @74709
     /*  74709 */   GIM_Reject,
     /*  74710 */ // Label 1275: @74710
     /*  74710 */ GIM_Reject,
     /*  74711 */ // Label 1181: @74711
     /*  74711 */ GIM_Try, /*On fail goto*//*Label 1284*/ GIMT_Encode4(74760), // Rule ID 8287 //
     /*  74716 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  74719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  74722 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  74725 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  74729 */   // (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv8i1] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  74729 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  74732 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /*  74736 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74741 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  74744 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  74746 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  74749 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  74751 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74754 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  74756 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  74758 */   GIR_RootConstrainSelectedInstOperands,
     /*  74759 */   // GIR_Coverage, 8287,
     /*  74759 */   GIR_EraseRootFromParent_Done,
     /*  74760 */ // Label 1284: @74760
     /*  74760 */ GIM_Reject,
     /*  74761 */ // Label 1182: @74761
     /*  74761 */ GIM_Try, /*On fail goto*//*Label 1285*/ GIMT_Encode4(75223),
     /*  74766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  74769 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  74772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  74776 */   GIM_Try, /*On fail goto*//*Label 1286*/ GIMT_Encode4(74847), // Rule ID 15320 //
     /*  74781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74792 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  74796 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  74800 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74804 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74808 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  74812 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  74816 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74820 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74826 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74828 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74830 */     // (xor:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  74830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  74833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  74837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  74841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  74845 */     GIR_RootConstrainSelectedInstOperands,
     /*  74846 */     // GIR_Coverage, 15320,
     /*  74846 */     GIR_EraseRootFromParent_Done,
     /*  74847 */   // Label 1286: @74847
     /*  74847 */   GIM_Try, /*On fail goto*//*Label 1287*/ GIMT_Encode4(74918), // Rule ID 15319 //
     /*  74852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  74867 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  74871 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74875 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74879 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  74883 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  74887 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74891 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74897 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74899 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74901 */     // (xor:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  74901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  74904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  74908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  74912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  74916 */     GIR_RootConstrainSelectedInstOperands,
     /*  74917 */     // GIR_Coverage, 15319,
     /*  74917 */     GIR_EraseRootFromParent_Done,
     /*  74918 */   // Label 1287: @74918
     /*  74918 */   GIM_Try, /*On fail goto*//*Label 1288*/ GIMT_Encode4(74989), // Rule ID 15318 //
     /*  74923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  74930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  74938 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  74942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74950 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  74954 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  74958 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74962 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74968 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74970 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74972 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  74972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  74975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74977 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  74979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  74983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  74987 */     GIR_RootConstrainSelectedInstOperands,
     /*  74988 */     // GIR_Coverage, 15318,
     /*  74988 */     GIR_EraseRootFromParent_Done,
     /*  74989 */   // Label 1288: @74989
     /*  74989 */   GIM_Try, /*On fail goto*//*Label 1289*/ GIMT_Encode4(75060), // Rule ID 11668 //
     /*  74994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  75009 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  75013 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75017 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75021 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  75025 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  75029 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75033 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75039 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75041 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75043 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  75043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  75046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75048 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  75050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  75054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  75058 */     GIR_RootConstrainSelectedInstOperands,
     /*  75059 */     // GIR_Coverage, 11668,
     /*  75059 */     GIR_EraseRootFromParent_Done,
     /*  75060 */   // Label 1289: @75060
     /*  75060 */   GIM_Try, /*On fail goto*//*Label 1290*/ GIMT_Encode4(75121), // Rule ID 11692 //
     /*  75065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  75076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  75080 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  75084 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  75088 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  75092 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75098 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  75100 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  75102 */     // (xor:{ *:[nxv8i16] } (AArch64bsp:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  75102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  75105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  75111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  75115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  75119 */     GIR_RootConstrainSelectedInstOperands,
     /*  75120 */     // GIR_Coverage, 11692,
     /*  75120 */     GIR_EraseRootFromParent_Done,
     /*  75121 */   // Label 1290: @75121
     /*  75121 */   GIM_Try, /*On fail goto*//*Label 1291*/ GIMT_Encode4(75164), // Rule ID 13433 //
     /*  75126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75137 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  75141 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  75145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75147 */     // (xor:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  75147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  75150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  75156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  75160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  75162 */     GIR_RootConstrainSelectedInstOperands,
     /*  75163 */     // GIR_Coverage, 13433,
     /*  75163 */     GIR_EraseRootFromParent_Done,
     /*  75164 */   // Label 1291: @75164
     /*  75164 */   GIM_Try, /*On fail goto*//*Label 1292*/ GIMT_Encode4(75207), // Rule ID 3136 //
     /*  75169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  75184 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  75188 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75190 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  75190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  75193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75195 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  75197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  75201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  75205 */     GIR_RootConstrainSelectedInstOperands,
     /*  75206 */     // GIR_Coverage, 3136,
     /*  75206 */     GIR_EraseRootFromParent_Done,
     /*  75207 */   // Label 1292: @75207
     /*  75207 */   GIM_Try, /*On fail goto*//*Label 1293*/ GIMT_Encode4(75222), // Rule ID 7311 //
     /*  75212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  75215 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  75215 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  75220 */     GIR_RootConstrainSelectedInstOperands,
     /*  75221 */     // GIR_Coverage, 7311,
     /*  75221 */     GIR_Done,
     /*  75222 */   // Label 1293: @75222
     /*  75222 */   GIM_Reject,
     /*  75223 */ // Label 1285: @75223
     /*  75223 */ GIM_Reject,
     /*  75224 */ // Label 1183: @75224
     /*  75224 */ GIM_Try, /*On fail goto*//*Label 1294*/ GIMT_Encode4(75273), // Rule ID 8286 //
     /*  75229 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  75232 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  75235 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  75238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  75242 */   // (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv16i1] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  75242 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  75245 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /*  75249 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75254 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  75257 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  75259 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  75262 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  75264 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75267 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  75269 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  75271 */   GIR_RootConstrainSelectedInstOperands,
     /*  75272 */   // GIR_Coverage, 8286,
     /*  75272 */   GIR_EraseRootFromParent_Done,
     /*  75273 */ // Label 1294: @75273
     /*  75273 */ GIM_Reject,
     /*  75274 */ // Label 1184: @75274
     /*  75274 */ GIM_Try, /*On fail goto*//*Label 1295*/ GIMT_Encode4(75736),
     /*  75279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  75282 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  75285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  75289 */   GIM_Try, /*On fail goto*//*Label 1296*/ GIMT_Encode4(75360), // Rule ID 15317 //
     /*  75294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  75309 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  75313 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  75317 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75321 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  75325 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  75329 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75333 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75339 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75341 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75343 */     // (xor:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  75343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  75346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  75350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  75354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  75358 */     GIR_RootConstrainSelectedInstOperands,
     /*  75359 */     // GIR_Coverage, 15317,
     /*  75359 */     GIR_EraseRootFromParent_Done,
     /*  75360 */   // Label 1296: @75360
     /*  75360 */   GIM_Try, /*On fail goto*//*Label 1297*/ GIMT_Encode4(75431), // Rule ID 15316 //
     /*  75365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75376 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  75380 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  75384 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75388 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75392 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  75396 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  75400 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75404 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75410 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75412 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75414 */     // (xor:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  75414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  75417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  75421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  75425 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  75429 */     GIR_RootConstrainSelectedInstOperands,
     /*  75430 */     // GIR_Coverage, 15316,
     /*  75430 */     GIR_EraseRootFromParent_Done,
     /*  75431 */   // Label 1297: @75431
     /*  75431 */   GIM_Try, /*On fail goto*//*Label 1298*/ GIMT_Encode4(75502), // Rule ID 15315 //
     /*  75436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75447 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  75451 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  75455 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  75459 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75463 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  75467 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  75471 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75475 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75481 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75483 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75485 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  75485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  75488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75490 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  75492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  75496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  75500 */     GIR_RootConstrainSelectedInstOperands,
     /*  75501 */     // GIR_Coverage, 15315,
     /*  75501 */     GIR_EraseRootFromParent_Done,
     /*  75502 */   // Label 1298: @75502
     /*  75502 */   GIM_Try, /*On fail goto*//*Label 1299*/ GIMT_Encode4(75573), // Rule ID 11666 //
     /*  75507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75518 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  75522 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  75526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75530 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75534 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  75538 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  75542 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75546 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75552 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75554 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75556 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  75556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  75559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75561 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  75563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  75567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  75571 */     GIR_RootConstrainSelectedInstOperands,
     /*  75572 */     // GIR_Coverage, 11666,
     /*  75572 */     GIR_EraseRootFromParent_Done,
     /*  75573 */   // Label 1299: @75573
     /*  75573 */   GIM_Try, /*On fail goto*//*Label 1300*/ GIMT_Encode4(75634), // Rule ID 11690 //
     /*  75578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  75589 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  75593 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  75597 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  75601 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  75605 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75611 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  75613 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  75615 */     // (xor:{ *:[nxv16i8] } (AArch64bsp:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  75615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  75618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  75624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  75628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  75632 */     GIR_RootConstrainSelectedInstOperands,
     /*  75633 */     // GIR_Coverage, 11690,
     /*  75633 */     GIR_EraseRootFromParent_Done,
     /*  75634 */   // Label 1300: @75634
     /*  75634 */   GIM_Try, /*On fail goto*//*Label 1301*/ GIMT_Encode4(75677), // Rule ID 13432 //
     /*  75639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75650 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  75654 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  75658 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75660 */     // (xor:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  75660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  75663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  75669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  75673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  75675 */     GIR_RootConstrainSelectedInstOperands,
     /*  75676 */     // GIR_Coverage, 13432,
     /*  75676 */     GIR_EraseRootFromParent_Done,
     /*  75677 */   // Label 1301: @75677
     /*  75677 */   GIM_Try, /*On fail goto*//*Label 1302*/ GIMT_Encode4(75720), // Rule ID 3134 //
     /*  75682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  75697 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  75701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75703 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  75703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  75706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75708 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  75710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  75714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  75718 */     GIR_RootConstrainSelectedInstOperands,
     /*  75719 */     // GIR_Coverage, 3134,
     /*  75719 */     GIR_EraseRootFromParent_Done,
     /*  75720 */   // Label 1302: @75720
     /*  75720 */   GIM_Try, /*On fail goto*//*Label 1303*/ GIMT_Encode4(75735), // Rule ID 7310 //
     /*  75725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  75728 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  75728 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  75733 */     GIR_RootConstrainSelectedInstOperands,
     /*  75734 */     // GIR_Coverage, 7310,
     /*  75734 */     GIR_Done,
     /*  75735 */   // Label 1303: @75735
     /*  75735 */   GIM_Reject,
     /*  75736 */ // Label 1295: @75736
     /*  75736 */ GIM_Reject,
     /*  75737 */ // Label 1185: @75737
     /*  75737 */ GIM_Reject,
     /*  75738 */ // Label 8: @75738
     /*  75738 */ GIM_Try, /*On fail goto*//*Label 1304*/ GIMT_Encode4(83261),
     /*  75743 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  75746 */   GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(23), /*)*//*default:*//*Label 1316*/ GIMT_Encode4(83260),
     /*  75757 */   /*GILLT_v2s64*//*Label 1305*/ GIMT_Encode4(75825), GIMT_Encode4(0),
     /*  75765 */   /*GILLT_v4s32*//*Label 1306*/ GIMT_Encode4(76346), GIMT_Encode4(0),
     /*  75773 */   /*GILLT_v8s16*//*Label 1307*/ GIMT_Encode4(78758),
     /*  75777 */   /*GILLT_v16s8*//*Label 1308*/ GIMT_Encode4(81167), GIMT_Encode4(0),
     /*  75785 */   /*GILLT_nxv2s1*//*Label 1309*/ GIMT_Encode4(83078), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  75801 */   /*GILLT_nxv4s1*//*Label 1310*/ GIMT_Encode4(83104),
     /*  75805 */   /*GILLT_nxv4s16*//*Label 1311*/ GIMT_Encode4(83130),
     /*  75809 */   /*GILLT_nxv4s32*//*Label 1312*/ GIMT_Encode4(83156),
     /*  75813 */   /*GILLT_nxv8s1*//*Label 1313*/ GIMT_Encode4(83182),
     /*  75817 */   /*GILLT_nxv8s16*//*Label 1314*/ GIMT_Encode4(83208),
     /*  75821 */   /*GILLT_nxv16s1*//*Label 1315*/ GIMT_Encode4(83234),
     /*  75825 */   // Label 1305: @75825
     /*  75825 */   GIM_Try, /*On fail goto*//*Label 1317*/ GIMT_Encode4(76345),
     /*  75830 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  75833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  75836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  75844 */     GIM_Try, /*On fail goto*//*Label 1318*/ GIMT_Encode4(75906), // Rule ID 5698 //
     /*  75849 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75853 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75859 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  75861 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75863 */       // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v1i64] }:$Rn), dsub:{ *:[i32] })
     /*  75863 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  75866 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  75870 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75875 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  75879 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  75881 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  75884 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  75886 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75889 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75892 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  75895 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75900 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  75905 */       // GIR_Coverage, 5698,
     /*  75905 */       GIR_EraseRootFromParent_Done,
     /*  75906 */     // Label 1318: @75906
     /*  75906 */     GIM_Try, /*On fail goto*//*Label 1319*/ GIMT_Encode4(75968), // Rule ID 5702 //
     /*  75911 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75915 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75921 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  75923 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75925 */       // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rn, immAllZerosV:{ *:[v1f64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v1f64] }:$Rn), dsub:{ *:[i32] })
     /*  75925 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  75928 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  75932 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75937 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  75941 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  75943 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  75946 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  75948 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75951 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75954 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  75957 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75962 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  75967 */       // GIR_Coverage, 5702,
     /*  75967 */       GIR_EraseRootFromParent_Done,
     /*  75968 */     // Label 1319: @75968
     /*  75968 */     GIM_Try, /*On fail goto*//*Label 1320*/ GIMT_Encode4(76026), // Rule ID 5699 //
     /*  75973 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75977 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  75981 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75983 */       // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rn, (undef:{ *:[v1i64] }))  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] })
     /*  75983 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  75986 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75990 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75995 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  75997 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  76000 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  76002 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76005 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  76007 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  76010 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76015 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76020 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76025 */       // GIR_Coverage, 5699,
     /*  76025 */       GIR_EraseRootFromParent_Done,
     /*  76026 */     // Label 1320: @76026
     /*  76026 */     GIM_Try, /*On fail goto*//*Label 1321*/ GIMT_Encode4(76084), // Rule ID 5703 //
     /*  76031 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76035 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  76039 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76041 */       // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rn, (undef:{ *:[v1f64] }))  =>  (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] })
     /*  76041 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  76044 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  76048 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76053 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  76055 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  76058 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  76060 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76063 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  76065 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  76068 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76073 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76078 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76083 */       // GIR_Coverage, 5703,
     /*  76083 */       GIR_EraseRootFromParent_Done,
     /*  76084 */     // Label 1321: @76084
     /*  76084 */     GIM_Try, /*On fail goto*//*Label 1322*/ GIMT_Encode4(76214), // Rule ID 5697 //
     /*  76089 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76093 */       // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn)  =>  (INSvi64lane:{ *:[v2i64] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1i64] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  76093 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  76096 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  76100 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76105 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  76107 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  76110 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  76114 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76119 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  76122 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  76126 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  76129 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76134 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76139 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76144 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  76147 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  76151 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76156 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  76158 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  76161 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  76165 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76170 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  76173 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  76177 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  76180 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76185 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76190 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76195 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  76198 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  76200 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76203 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  76206 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  76209 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76212 */       GIR_RootConstrainSelectedInstOperands,
     /*  76213 */       // GIR_Coverage, 5697,
     /*  76213 */       GIR_EraseRootFromParent_Done,
     /*  76214 */     // Label 1322: @76214
     /*  76214 */     GIM_Try, /*On fail goto*//*Label 1323*/ GIMT_Encode4(76344), // Rule ID 5701 //
     /*  76219 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76223 */       // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rd, V64:{ *:[v1f64] }:$Rn)  =>  (INSvi64lane:{ *:[v2f64] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1f64] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  76223 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  76226 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  76230 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76235 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  76237 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  76240 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  76244 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76249 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  76252 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  76256 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  76259 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76264 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76269 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76274 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  76277 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  76281 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76286 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  76288 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  76291 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  76295 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76300 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  76303 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  76307 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  76310 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76315 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76320 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76325 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  76328 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  76330 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76333 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  76336 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  76339 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76342 */       GIR_RootConstrainSelectedInstOperands,
     /*  76343 */       // GIR_Coverage, 5701,
     /*  76343 */       GIR_EraseRootFromParent_Done,
     /*  76344 */     // Label 1323: @76344
     /*  76344 */     GIM_Reject,
     /*  76345 */   // Label 1317: @76345
     /*  76345 */   GIM_Reject,
     /*  76346 */   // Label 1306: @76346
     /*  76346 */   GIM_Try, /*On fail goto*//*Label 1324*/ GIMT_Encode4(78757),
     /*  76351 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  76354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  76357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76361 */     GIM_Try, /*On fail goto*//*Label 1325*/ GIMT_Encode4(76490), // Rule ID 5367 //
     /*  76366 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76370 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76374 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  76378 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  76382 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76386 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  76390 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  76394 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  76398 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76402 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  76406 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  76410 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76415 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  76419 */       GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76425 */       GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  76427 */       // MIs[2] Operand 2
     /*  76427 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  76438 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  76440 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] }:$Rm), 32:{ *:[i32] })))  =>  (SUBHNv2i64_v4i32:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /*  76440 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  76443 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  76447 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76452 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  76455 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  76459 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  76462 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76467 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76472 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v4i32),
     /*  76475 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  76477 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76480 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  76484 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  76488 */       GIR_RootConstrainSelectedInstOperands,
     /*  76489 */       // GIR_Coverage, 5367,
     /*  76489 */       GIR_EraseRootFromParent_Done,
     /*  76490 */     // Label 1325: @76490
     /*  76490 */     GIM_Try, /*On fail goto*//*Label 1326*/ GIMT_Encode4(76612), // Rule ID 5363 //
     /*  76495 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76499 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76503 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  76507 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  76511 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76515 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  76519 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  76523 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  76527 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  76531 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  76535 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  76539 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76544 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76549 */       // MIs[2] Operand 2
     /*  76549 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  76560 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76562 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] })))  =>  (ADDHNv2i64_v4i32:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  76562 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  76565 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  76569 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76574 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  76577 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  76581 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  76584 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76589 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76594 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v4i32),
     /*  76597 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  76599 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76602 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  76606 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  76610 */       GIR_RootConstrainSelectedInstOperands,
     /*  76611 */       // GIR_Coverage, 5363,
     /*  76611 */       GIR_EraseRootFromParent_Done,
     /*  76612 */     // Label 1326: @76612
     /*  76612 */     GIM_Try, /*On fail goto*//*Label 1327*/ GIMT_Encode4(76734), // Rule ID 5365 //
     /*  76617 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76621 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76625 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  76629 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  76633 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76637 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  76641 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  76645 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  76649 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  76653 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  76657 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  76661 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76666 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76671 */       // MIs[2] Operand 2
     /*  76671 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  76682 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76684 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] })))  =>  (SUBHNv2i64_v4i32:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  76684 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  76687 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  76691 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76696 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  76699 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  76703 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  76706 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76711 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76716 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v4i32),
     /*  76719 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  76721 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76724 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  76728 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  76732 */       GIR_RootConstrainSelectedInstOperands,
     /*  76733 */       // GIR_Coverage, 5365,
     /*  76733 */       GIR_EraseRootFromParent_Done,
     /*  76734 */     // Label 1327: @76734
     /*  76734 */     GIM_Try, /*On fail goto*//*Label 1328*/ GIMT_Encode4(76836), // Rule ID 5513 //
     /*  76739 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76743 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  76747 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  76751 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76755 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  76759 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  76763 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76768 */       // MIs[2] Operand 2
     /*  76768 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  76779 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  76783 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  76787 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  76791 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  76795 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
     /*  76799 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  76803 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76808 */       // MIs[4] Operand 2
     /*  76808 */       GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(32),
     /*  76819 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  76821 */       // (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] })), (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, 32:{ *:[i32] })))  =>  (UZP2v4i32:{ *:[v4i32] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /*  76821 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /*  76824 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  76826 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /*  76830 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
     /*  76834 */       GIR_RootConstrainSelectedInstOperands,
     /*  76835 */       // GIR_Coverage, 5513,
     /*  76835 */       GIR_EraseRootFromParent_Done,
     /*  76836 */     // Label 1328: @76836
     /*  76836 */     GIM_Try, /*On fail goto*//*Label 1329*/ GIMT_Encode4(76965), // Rule ID 6251 //
     /*  76841 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76845 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76849 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  76853 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  76856 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  76861 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  76865 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  76869 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76874 */       GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 32,
     /*  76878 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76880 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Vd, (intrinsic_wo_chain:{ *:[v2i32] } 657:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] }))  =>  (RADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Vn, (MOVIv2d_ns:{ *:[v2i64] } 0:{ *:[i32] }))
     /*  76880 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  76883 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /*  76887 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76892 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  76895 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  76897 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  76900 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  76904 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76909 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  76911 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  76914 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  76918 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76923 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  76926 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
     /*  76930 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  76933 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76938 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76943 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76948 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v4i32),
     /*  76951 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  76953 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76956 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /*  76960 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  76963 */       GIR_RootConstrainSelectedInstOperands,
     /*  76964 */       // GIR_Coverage, 6251,
     /*  76964 */       GIR_EraseRootFromParent_Done,
     /*  76965 */     // Label 1329: @76965
     /*  76965 */     GIM_Try, /*On fail goto*//*Label 1330*/ GIMT_Encode4(77007), // Rule ID 5708 //
     /*  76970 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  76977 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  76984 */       // (concat_vectors:{ *:[v4i32] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (INSvi64lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] })
     /*  76984 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  76987 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  76989 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  76994 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76997 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  77002 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  77005 */       GIR_RootConstrainSelectedInstOperands,
     /*  77006 */       // GIR_Coverage, 5708,
     /*  77006 */       GIR_EraseRootFromParent_Done,
     /*  77007 */     // Label 1330: @77007
     /*  77007 */     GIM_Try, /*On fail goto*//*Label 1331*/ GIMT_Encode4(77049), // Rule ID 5712 //
     /*  77012 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4f32),
     /*  77019 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4f32),
     /*  77026 */       // (concat_vectors:{ *:[v4f32] } (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn), (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm))  =>  (INSvi64lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] })
     /*  77026 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  77029 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  77031 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  77036 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77039 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  77044 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  77047 */       GIR_RootConstrainSelectedInstOperands,
     /*  77048 */       // GIR_Coverage, 5712,
     /*  77048 */       GIR_EraseRootFromParent_Done,
     /*  77049 */     // Label 1331: @77049
     /*  77049 */     GIM_Try, /*On fail goto*//*Label 1332*/ GIMT_Encode4(77172), // Rule ID 2569 //
     /*  77054 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  77057 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  77061 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77065 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  77069 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  77072 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  77077 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  77081 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  77085 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77090 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  77094 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  77098 */       GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /*  77102 */       // MIs[2] Operand 1
     /*  77102 */       // No operand predicates
     /*  77102 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  77104 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 657:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (RSHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
     /*  77104 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  77107 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77111 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77116 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  77118 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  77121 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  77125 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77130 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  77133 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  77137 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  77140 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77145 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77150 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  77155 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv4i32_shift),
     /*  77158 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  77160 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77163 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  77167 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  77170 */       GIR_RootConstrainSelectedInstOperands,
     /*  77171 */       // GIR_Coverage, 2569,
     /*  77171 */       GIR_EraseRootFromParent_Done,
     /*  77172 */     // Label 1332: @77172
     /*  77172 */     GIM_Try, /*On fail goto*//*Label 1333*/ GIMT_Encode4(77295), // Rule ID 6219 //
     /*  77177 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  77180 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  77184 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77188 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  77192 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  77196 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77200 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
     /*  77204 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  77208 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77213 */       // MIs[2] imm
     /*  77213 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77217 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  77221 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /*  77225 */       // MIs[3] Operand 1
     /*  77225 */       // No operand predicates
     /*  77225 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77227 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)))  =>  (SHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
     /*  77227 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  77230 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77234 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77239 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  77241 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  77244 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  77248 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77253 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  77256 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  77260 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  77263 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77268 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77273 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  77278 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i32_shift),
     /*  77281 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  77283 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77286 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  77290 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  77293 */       GIR_RootConstrainSelectedInstOperands,
     /*  77294 */       // GIR_Coverage, 6219,
     /*  77294 */       GIR_EraseRootFromParent_Done,
     /*  77295 */     // Label 1333: @77295
     /*  77295 */     GIM_Try, /*On fail goto*//*Label 1334*/ GIMT_Encode4(77415), // Rule ID 6257 //
     /*  77300 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  77304 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77308 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  77312 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  77316 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77320 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  77324 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  77328 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77333 */       // MIs[2] imm
     /*  77333 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77337 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  77341 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /*  77345 */       // MIs[3] Operand 1
     /*  77345 */       // No operand predicates
     /*  77345 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77347 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)))  =>  (SHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /*  77347 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  77350 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77354 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77359 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  77361 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  77364 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  77368 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77373 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  77376 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  77380 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  77383 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77388 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77393 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  77398 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i32_shift),
     /*  77401 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  77403 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77406 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  77410 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  77413 */       GIR_RootConstrainSelectedInstOperands,
     /*  77414 */       // GIR_Coverage, 6257,
     /*  77414 */       GIR_EraseRootFromParent_Done,
     /*  77415 */     // Label 1334: @77415
     /*  77415 */     GIM_Try, /*On fail goto*//*Label 1335*/ GIMT_Encode4(77532), // Rule ID 2492 //
     /*  77420 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  77423 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  77427 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77431 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  77435 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  77438 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /*  77443 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  77447 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  77451 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77456 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77461 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  77463 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 569:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (ADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  77463 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  77466 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77470 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77475 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  77477 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  77480 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  77484 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77489 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  77492 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  77496 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  77499 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77504 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77509 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  77514 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v4i32),
     /*  77517 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  77519 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77522 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  77526 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  77530 */       GIR_RootConstrainSelectedInstOperands,
     /*  77531 */       // GIR_Coverage, 2492,
     /*  77531 */       GIR_EraseRootFromParent_Done,
     /*  77532 */     // Label 1335: @77532
     /*  77532 */     GIM_Try, /*On fail goto*//*Label 1336*/ GIMT_Encode4(77649), // Rule ID 5283 //
     /*  77537 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  77540 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  77544 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77548 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  77552 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  77555 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /*  77560 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  77564 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  77568 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77573 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77578 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  77580 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 714:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (SUBHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  77580 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  77583 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77587 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77592 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  77594 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  77597 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  77601 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77606 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  77609 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  77613 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  77616 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77621 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77626 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  77631 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v4i32),
     /*  77634 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  77636 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77639 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  77643 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  77647 */       GIR_RootConstrainSelectedInstOperands,
     /*  77648 */       // GIR_Coverage, 5283,
     /*  77648 */       GIR_EraseRootFromParent_Done,
     /*  77649 */     // Label 1336: @77649
     /*  77649 */     GIM_Try, /*On fail goto*//*Label 1337*/ GIMT_Encode4(77766), // Rule ID 5286 //
     /*  77654 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  77657 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  77661 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77665 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  77669 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  77672 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /*  77677 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  77681 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  77685 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77690 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77695 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  77697 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 656:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (RADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  77697 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  77700 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77704 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77709 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  77711 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  77714 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  77718 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77723 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  77726 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  77730 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  77733 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77738 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77743 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  77748 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v4i32),
     /*  77751 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  77753 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77756 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  77760 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  77764 */       GIR_RootConstrainSelectedInstOperands,
     /*  77765 */       // GIR_Coverage, 5286,
     /*  77765 */       GIR_EraseRootFromParent_Done,
     /*  77766 */     // Label 1337: @77766
     /*  77766 */     GIM_Try, /*On fail goto*//*Label 1338*/ GIMT_Encode4(77883), // Rule ID 5289 //
     /*  77771 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  77774 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  77778 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77782 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  77786 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  77789 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /*  77794 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  77798 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  77802 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77807 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77812 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  77814 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 658:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (RSUBHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  77814 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  77817 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77821 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77826 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  77828 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  77831 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  77835 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77840 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  77843 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  77847 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  77850 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77855 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77860 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  77865 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv2i64_v4i32),
     /*  77868 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  77870 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77873 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  77877 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  77881 */       GIR_RootConstrainSelectedInstOperands,
     /*  77882 */       // GIR_Coverage, 5289,
     /*  77882 */       GIR_EraseRootFromParent_Done,
     /*  77883 */     // Label 1338: @77883
     /*  77883 */     GIM_Try, /*On fail goto*//*Label 1339*/ GIMT_Encode4(77987), // Rule ID 2488 //
     /*  77888 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  77891 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  77895 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77899 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  77903 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  77906 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtxn),
     /*  77911 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  77915 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77920 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  77922 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, (intrinsic_wo_chain:{ *:[v2f32] } 591:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn))  =>  (FCVTXNv4f32:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rn)
     /*  77922 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  77925 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77929 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77934 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  77936 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  77939 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  77943 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77948 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  77951 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  77955 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  77958 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77963 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77968 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  77973 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv4f32),
     /*  77976 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  77978 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77981 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  77985 */       GIR_RootConstrainSelectedInstOperands,
     /*  77986 */       // GIR_Coverage, 2488,
     /*  77986 */       GIR_EraseRootFromParent_Done,
     /*  77987 */     // Label 1339: @77987
     /*  77987 */     GIM_Try, /*On fail goto*//*Label 1340*/ GIMT_Encode4(78043), // Rule ID 5446 //
     /*  77992 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77996 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  78000 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  78004 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78009 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  78013 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  78017 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  78021 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78026 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  78028 */       // (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn), (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vm))  =>  (UZP1v4i32:{ *:[v4i32] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /*  78028 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /*  78031 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  78033 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  78037 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  78041 */       GIR_RootConstrainSelectedInstOperands,
     /*  78042 */       // GIR_Coverage, 5446,
     /*  78042 */       GIR_EraseRootFromParent_Done,
     /*  78043 */     // Label 1340: @78043
     /*  78043 */     GIM_Try, /*On fail goto*//*Label 1341*/ GIMT_Encode4(78109), // Rule ID 5706 //
     /*  78048 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78052 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78056 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78062 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  78064 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  78066 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
     /*  78066 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  78069 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  78073 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78078 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  78082 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  78084 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  78087 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  78089 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78092 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78095 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  78098 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78103 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78108 */       // GIR_Coverage, 5706,
     /*  78108 */       GIR_EraseRootFromParent_Done,
     /*  78109 */     // Label 1341: @78109
     /*  78109 */     GIM_Try, /*On fail goto*//*Label 1342*/ GIMT_Encode4(78175), // Rule ID 5710 //
     /*  78114 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78118 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78122 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78128 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  78130 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  78132 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rn, immAllZerosV:{ *:[v2f32] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v2f32] }:$Rn), dsub:{ *:[i32] })
     /*  78132 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  78135 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  78139 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78144 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  78148 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  78150 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  78153 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  78155 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78158 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78161 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  78164 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78169 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78174 */       // GIR_Coverage, 5710,
     /*  78174 */       GIR_EraseRootFromParent_Done,
     /*  78175 */     // Label 1342: @78175
     /*  78175 */     GIM_Try, /*On fail goto*//*Label 1343*/ GIMT_Encode4(78268), // Rule ID 4854 //
     /*  78180 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78184 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78188 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  78192 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  78196 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78201 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  78203 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, (fpround:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn))  =>  (FCVTNv4i32:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rn)
     /*  78203 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  78206 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78210 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78215 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  78217 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  78220 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  78224 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78229 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  78232 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  78236 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  78239 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78244 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78249 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78254 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i32),
     /*  78257 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  78259 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78262 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  78266 */       GIR_RootConstrainSelectedInstOperands,
     /*  78267 */       // GIR_Coverage, 4854,
     /*  78267 */       GIR_EraseRootFromParent_Done,
     /*  78268 */     // Label 1343: @78268
     /*  78268 */     GIM_Try, /*On fail goto*//*Label 1344*/ GIMT_Encode4(78364), // Rule ID 4901 //
     /*  78273 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  78276 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78280 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78284 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  78288 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  78292 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78297 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  78299 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn))  =>  (XTNv4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn)
     /*  78299 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  78302 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78306 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78311 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  78313 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  78316 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  78320 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78325 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  78328 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  78332 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  78335 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78340 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78345 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78350 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i32),
     /*  78353 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  78355 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78358 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  78362 */       GIR_RootConstrainSelectedInstOperands,
     /*  78363 */       // GIR_Coverage, 4901,
     /*  78363 */       GIR_EraseRootFromParent_Done,
     /*  78364 */     // Label 1344: @78364
     /*  78364 */     GIM_Try, /*On fail goto*//*Label 1345*/ GIMT_Encode4(78426), // Rule ID 5707 //
     /*  78369 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78373 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78377 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  78381 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  78383 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rn, (undef:{ *:[v2i32] }))  =>  (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] })
     /*  78383 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78386 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78390 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78395 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  78397 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  78400 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  78402 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78405 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  78407 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  78410 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78415 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78420 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78425 */       // GIR_Coverage, 5707,
     /*  78425 */       GIR_EraseRootFromParent_Done,
     /*  78426 */     // Label 1345: @78426
     /*  78426 */     GIM_Try, /*On fail goto*//*Label 1346*/ GIMT_Encode4(78488), // Rule ID 5711 //
     /*  78431 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78435 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78439 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  78443 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  78445 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rn, (undef:{ *:[v2f32] }))  =>  (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] })
     /*  78445 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78448 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78452 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78457 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  78459 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  78462 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  78464 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78467 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  78469 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  78472 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78477 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78482 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78487 */       // GIR_Coverage, 5711,
     /*  78487 */       GIR_EraseRootFromParent_Done,
     /*  78488 */     // Label 1346: @78488
     /*  78488 */     GIM_Try, /*On fail goto*//*Label 1347*/ GIMT_Encode4(78622), // Rule ID 5705 //
     /*  78493 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78497 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78501 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (INSvi64lane:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  78501 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  78504 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78508 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78513 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  78515 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  78518 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  78522 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78527 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  78530 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  78534 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  78537 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78542 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78547 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78552 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  78555 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78559 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78564 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  78566 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  78569 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  78573 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78578 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  78581 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  78585 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  78588 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78593 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78598 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78603 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  78606 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  78608 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78611 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  78614 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  78617 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78620 */       GIR_RootConstrainSelectedInstOperands,
     /*  78621 */       // GIR_Coverage, 5705,
     /*  78621 */       GIR_EraseRootFromParent_Done,
     /*  78622 */     // Label 1347: @78622
     /*  78622 */     GIM_Try, /*On fail goto*//*Label 1348*/ GIMT_Encode4(78756), // Rule ID 5709 //
     /*  78627 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78631 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78635 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn)  =>  (INSvi64lane:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  78635 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  78638 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78642 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78647 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  78649 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  78652 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  78656 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78661 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  78664 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  78668 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  78671 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78676 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78681 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78686 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  78689 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78693 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78698 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  78700 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  78703 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  78707 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78712 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  78715 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  78719 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  78722 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78727 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78732 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78737 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  78740 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  78742 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78745 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  78748 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  78751 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78754 */       GIR_RootConstrainSelectedInstOperands,
     /*  78755 */       // GIR_Coverage, 5709,
     /*  78755 */       GIR_EraseRootFromParent_Done,
     /*  78756 */     // Label 1348: @78756
     /*  78756 */     GIM_Reject,
     /*  78757 */   // Label 1324: @78757
     /*  78757 */   GIM_Reject,
     /*  78758 */   // Label 1307: @78758
     /*  78758 */   GIM_Try, /*On fail goto*//*Label 1349*/ GIMT_Encode4(81166),
     /*  78763 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  78766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  78769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78773 */     GIM_Try, /*On fail goto*//*Label 1350*/ GIMT_Encode4(78902), // Rule ID 5361 //
     /*  78778 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78782 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78786 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  78790 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  78794 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78798 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  78802 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  78806 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  78810 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78814 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  78818 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  78822 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78827 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  78831 */       GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78837 */       GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  78839 */       // MIs[2] Operand 2
     /*  78839 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  78850 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  78852 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] }:$Rm), 16:{ *:[i32] })))  =>  (SUBHNv4i32_v8i16:{ *:[v8i16] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /*  78852 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  78855 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  78859 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78864 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  78867 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  78871 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  78874 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78879 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78884 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v8i16),
     /*  78887 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  78889 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78892 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  78896 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  78900 */       GIR_RootConstrainSelectedInstOperands,
     /*  78901 */       // GIR_Coverage, 5361,
     /*  78901 */       GIR_EraseRootFromParent_Done,
     /*  78902 */     // Label 1350: @78902
     /*  78902 */     GIM_Try, /*On fail goto*//*Label 1351*/ GIMT_Encode4(79024), // Rule ID 5357 //
     /*  78907 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78911 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78915 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  78919 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  78923 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78927 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  78931 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  78935 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  78939 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  78943 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  78947 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  78951 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78956 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78961 */       // MIs[2] Operand 2
     /*  78961 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  78972 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78974 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] })))  =>  (ADDHNv4i32_v8i16:{ *:[v8i16] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  78974 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  78977 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  78981 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78986 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  78989 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  78993 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  78996 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79001 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79006 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v8i16),
     /*  79009 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  79011 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79014 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  79018 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  79022 */       GIR_RootConstrainSelectedInstOperands,
     /*  79023 */       // GIR_Coverage, 5357,
     /*  79023 */       GIR_EraseRootFromParent_Done,
     /*  79024 */     // Label 1351: @79024
     /*  79024 */     GIM_Try, /*On fail goto*//*Label 1352*/ GIMT_Encode4(79146), // Rule ID 5359 //
     /*  79029 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79033 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79037 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  79041 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  79045 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79049 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  79053 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  79057 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  79061 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  79065 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  79069 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  79073 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79078 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79083 */       // MIs[2] Operand 2
     /*  79083 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  79094 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  79096 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] })))  =>  (SUBHNv4i32_v8i16:{ *:[v8i16] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  79096 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  79099 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  79103 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79108 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  79111 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  79115 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  79118 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79123 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79128 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v8i16),
     /*  79131 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  79133 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79136 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  79140 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  79144 */       GIR_RootConstrainSelectedInstOperands,
     /*  79145 */       // GIR_Coverage, 5359,
     /*  79145 */       GIR_EraseRootFromParent_Done,
     /*  79146 */     // Label 1352: @79146
     /*  79146 */     GIM_Try, /*On fail goto*//*Label 1353*/ GIMT_Encode4(79248), // Rule ID 5512 //
     /*  79151 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79155 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  79159 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  79163 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79167 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  79171 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  79175 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79180 */       // MIs[2] Operand 2
     /*  79180 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  79191 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  79195 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  79199 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  79203 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  79207 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
     /*  79211 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  79215 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79220 */       // MIs[4] Operand 2
     /*  79220 */       GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(16),
     /*  79231 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  79233 */       // (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] })), (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, 16:{ *:[i32] })))  =>  (UZP2v8i16:{ *:[v8i16] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /*  79233 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /*  79236 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  79238 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /*  79242 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
     /*  79246 */       GIR_RootConstrainSelectedInstOperands,
     /*  79247 */       // GIR_Coverage, 5512,
     /*  79247 */       GIR_EraseRootFromParent_Done,
     /*  79248 */     // Label 1353: @79248
     /*  79248 */     GIM_Try, /*On fail goto*//*Label 1354*/ GIMT_Encode4(79377), // Rule ID 6250 //
     /*  79253 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79257 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79261 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  79265 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  79268 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  79273 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  79277 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  79281 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79286 */       GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 16,
     /*  79290 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  79292 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Vd, (intrinsic_wo_chain:{ *:[v4i16] } 657:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] }))  =>  (RADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Vn, (MOVIv2d_ns:{ *:[v4i32] } 0:{ *:[i32] }))
     /*  79292 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  79295 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /*  79299 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79304 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  79307 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  79309 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  79312 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79316 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79321 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  79323 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  79326 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  79330 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79335 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  79338 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
     /*  79342 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  79345 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79350 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79355 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79360 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v8i16),
     /*  79363 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  79365 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79368 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /*  79372 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  79375 */       GIR_RootConstrainSelectedInstOperands,
     /*  79376 */       // GIR_Coverage, 6250,
     /*  79376 */       GIR_EraseRootFromParent_Done,
     /*  79377 */     // Label 1354: @79377
     /*  79377 */     GIM_Try, /*On fail goto*//*Label 1355*/ GIMT_Encode4(79419), // Rule ID 5716 //
     /*  79382 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  79389 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  79396 */       // (concat_vectors:{ *:[v8i16] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (INSvi64lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] })
     /*  79396 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  79399 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  79401 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  79406 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79409 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  79414 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  79417 */       GIR_RootConstrainSelectedInstOperands,
     /*  79418 */       // GIR_Coverage, 5716,
     /*  79418 */       GIR_EraseRootFromParent_Done,
     /*  79419 */     // Label 1355: @79419
     /*  79419 */     GIM_Try, /*On fail goto*//*Label 1356*/ GIMT_Encode4(79461), // Rule ID 5720 //
     /*  79424 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8f16),
     /*  79431 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8f16),
     /*  79438 */       // (concat_vectors:{ *:[v8f16] } (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn), (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rm))  =>  (INSvi64lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] })
     /*  79438 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  79441 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  79443 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  79448 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79451 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  79456 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  79459 */       GIR_RootConstrainSelectedInstOperands,
     /*  79460 */       // GIR_Coverage, 5720,
     /*  79460 */       GIR_EraseRootFromParent_Done,
     /*  79461 */     // Label 1356: @79461
     /*  79461 */     GIM_Try, /*On fail goto*//*Label 1357*/ GIMT_Encode4(79584), // Rule ID 2567 //
     /*  79466 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  79469 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79473 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79477 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  79481 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  79484 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  79489 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  79493 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  79497 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79502 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  79506 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  79510 */       GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /*  79514 */       // MIs[2] Operand 1
     /*  79514 */       // No operand predicates
     /*  79514 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79516 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 657:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (RSHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /*  79516 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  79519 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79523 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79528 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  79530 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  79533 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  79537 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79542 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  79545 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  79549 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  79552 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79557 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79562 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79567 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv8i16_shift),
     /*  79570 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  79572 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79575 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  79579 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  79582 */       GIR_RootConstrainSelectedInstOperands,
     /*  79583 */       // GIR_Coverage, 2567,
     /*  79583 */       GIR_EraseRootFromParent_Done,
     /*  79584 */     // Label 1357: @79584
     /*  79584 */     GIM_Try, /*On fail goto*//*Label 1358*/ GIMT_Encode4(79707), // Rule ID 6218 //
     /*  79589 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  79592 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79596 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79600 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  79604 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  79608 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79612 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
     /*  79616 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  79620 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79625 */       // MIs[2] imm
     /*  79625 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79629 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  79633 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /*  79637 */       // MIs[3] Operand 1
     /*  79637 */       // No operand predicates
     /*  79637 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  79639 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)))  =>  (SHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /*  79639 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  79642 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79646 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79651 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  79653 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  79656 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  79660 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79665 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  79668 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  79672 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  79675 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79680 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79685 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79690 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i16_shift),
     /*  79693 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  79695 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79698 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  79702 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  79705 */       GIR_RootConstrainSelectedInstOperands,
     /*  79706 */       // GIR_Coverage, 6218,
     /*  79706 */       GIR_EraseRootFromParent_Done,
     /*  79707 */     // Label 1358: @79707
     /*  79707 */     GIM_Try, /*On fail goto*//*Label 1359*/ GIMT_Encode4(79827), // Rule ID 6256 //
     /*  79712 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79716 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79720 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  79724 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  79728 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79732 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  79736 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  79740 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79745 */       // MIs[2] imm
     /*  79745 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79749 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  79753 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /*  79757 */       // MIs[3] Operand 1
     /*  79757 */       // No operand predicates
     /*  79757 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  79759 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)))  =>  (SHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /*  79759 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  79762 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79766 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79771 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  79773 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  79776 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  79780 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79785 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  79788 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  79792 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  79795 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79800 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79805 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79810 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i16_shift),
     /*  79813 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  79815 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79818 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  79822 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  79825 */       GIR_RootConstrainSelectedInstOperands,
     /*  79826 */       // GIR_Coverage, 6256,
     /*  79826 */       GIR_EraseRootFromParent_Done,
     /*  79827 */     // Label 1359: @79827
     /*  79827 */     GIM_Try, /*On fail goto*//*Label 1360*/ GIMT_Encode4(79944), // Rule ID 2491 //
     /*  79832 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  79835 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79839 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79843 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  79847 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  79850 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /*  79855 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  79859 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79863 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79868 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79873 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  79875 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 569:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (ADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  79875 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  79878 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79882 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79887 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  79889 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  79892 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  79896 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79901 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  79904 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  79908 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  79911 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79916 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79921 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79926 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v8i16),
     /*  79929 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  79931 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79934 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  79938 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  79942 */       GIR_RootConstrainSelectedInstOperands,
     /*  79943 */       // GIR_Coverage, 2491,
     /*  79943 */       GIR_EraseRootFromParent_Done,
     /*  79944 */     // Label 1360: @79944
     /*  79944 */     GIM_Try, /*On fail goto*//*Label 1361*/ GIMT_Encode4(80061), // Rule ID 5282 //
     /*  79949 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  79952 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79956 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79960 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  79964 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  79967 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /*  79972 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  79976 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79980 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79985 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79990 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  79992 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 714:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (SUBHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  79992 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  79995 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79999 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80004 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  80006 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80009 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80013 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80018 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  80021 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80025 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80028 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80033 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80038 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80043 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v8i16),
     /*  80046 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80048 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80051 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  80055 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  80059 */       GIR_RootConstrainSelectedInstOperands,
     /*  80060 */       // GIR_Coverage, 5282,
     /*  80060 */       GIR_EraseRootFromParent_Done,
     /*  80061 */     // Label 1361: @80061
     /*  80061 */     GIM_Try, /*On fail goto*//*Label 1362*/ GIMT_Encode4(80178), // Rule ID 5285 //
     /*  80066 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  80069 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80073 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80077 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  80081 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  80084 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /*  80089 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  80093 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  80097 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80102 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80107 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80109 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 656:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (RADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  80109 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  80112 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80116 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80121 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  80123 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80126 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80130 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80135 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  80138 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80142 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80145 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80150 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80155 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80160 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v8i16),
     /*  80163 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80165 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80168 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  80172 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  80176 */       GIR_RootConstrainSelectedInstOperands,
     /*  80177 */       // GIR_Coverage, 5285,
     /*  80177 */       GIR_EraseRootFromParent_Done,
     /*  80178 */     // Label 1362: @80178
     /*  80178 */     GIM_Try, /*On fail goto*//*Label 1363*/ GIMT_Encode4(80295), // Rule ID 5288 //
     /*  80183 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  80186 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80190 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80194 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  80198 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  80201 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /*  80206 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  80210 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  80214 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80219 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80224 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80226 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 658:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (RSUBHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  80226 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  80229 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80233 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80238 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  80240 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80243 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80247 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80252 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  80255 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80259 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80262 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80267 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80272 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80277 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv4i32_v8i16),
     /*  80280 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80282 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80285 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  80289 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  80293 */       GIR_RootConstrainSelectedInstOperands,
     /*  80294 */       // GIR_Coverage, 5288,
     /*  80294 */       GIR_EraseRootFromParent_Done,
     /*  80295 */     // Label 1363: @80295
     /*  80295 */     GIM_Try, /*On fail goto*//*Label 1364*/ GIMT_Encode4(80396), // Rule ID 4848 //
     /*  80300 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80304 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80308 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  80312 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  80315 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2hf),
     /*  80320 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  80324 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80329 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80331 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 764:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn))  =>  (FCVTNv8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rn)
     /*  80331 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  80334 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80338 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80343 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  80345 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80348 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80352 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80357 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  80360 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80364 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80367 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80372 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80377 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80382 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /*  80385 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80387 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80390 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  80394 */       GIR_RootConstrainSelectedInstOperands,
     /*  80395 */       // GIR_Coverage, 4848,
     /*  80395 */       GIR_EraseRootFromParent_Done,
     /*  80396 */     // Label 1364: @80396
     /*  80396 */     GIM_Try, /*On fail goto*//*Label 1365*/ GIMT_Encode4(80452), // Rule ID 5437 //
     /*  80401 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80405 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  80409 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  80413 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80418 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  80422 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  80426 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  80430 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80435 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  80437 */       // (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn), (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vm))  =>  (UZP1v8i16:{ *:[v8i16] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /*  80437 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /*  80440 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  80442 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  80446 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  80450 */       GIR_RootConstrainSelectedInstOperands,
     /*  80451 */       // GIR_Coverage, 5437,
     /*  80451 */       GIR_EraseRootFromParent_Done,
     /*  80452 */     // Label 1365: @80452
     /*  80452 */     GIM_Try, /*On fail goto*//*Label 1366*/ GIMT_Encode4(80518), // Rule ID 5714 //
     /*  80457 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80461 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80465 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80471 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  80473 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80475 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v4i16] }:$Rn), dsub:{ *:[i32] })
     /*  80475 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  80478 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  80482 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80487 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  80491 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  80493 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  80496 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80498 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80501 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80504 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  80507 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80512 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80517 */       // GIR_Coverage, 5714,
     /*  80517 */       GIR_EraseRootFromParent_Done,
     /*  80518 */     // Label 1366: @80518
     /*  80518 */     GIM_Try, /*On fail goto*//*Label 1367*/ GIMT_Encode4(80584), // Rule ID 5718 //
     /*  80523 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80527 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80531 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80537 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  80539 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80541 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rn, immAllZerosV:{ *:[v4f16] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v4f16] }:$Rn), dsub:{ *:[i32] })
     /*  80541 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  80544 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  80548 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80553 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  80557 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  80559 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  80562 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80564 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80567 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80570 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  80573 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80578 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80583 */       // GIR_Coverage, 5718,
     /*  80583 */       GIR_EraseRootFromParent_Done,
     /*  80584 */     // Label 1367: @80584
     /*  80584 */     GIM_Try, /*On fail goto*//*Label 1368*/ GIMT_Encode4(80677), // Rule ID 4856 //
     /*  80589 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80593 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80597 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  80601 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  80605 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80610 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80612 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rd, (fpround:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn))  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rn)
     /*  80612 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  80615 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80619 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80624 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  80626 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80629 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80633 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80638 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  80641 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80645 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80648 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80653 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80658 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80663 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /*  80666 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80668 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80671 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  80675 */       GIR_RootConstrainSelectedInstOperands,
     /*  80676 */       // GIR_Coverage, 4856,
     /*  80676 */       GIR_EraseRootFromParent_Done,
     /*  80677 */     // Label 1368: @80677
     /*  80677 */     GIM_Try, /*On fail goto*//*Label 1369*/ GIMT_Encode4(80773), // Rule ID 4900 //
     /*  80682 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  80685 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80689 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80693 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  80697 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  80701 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80706 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80708 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn))  =>  (XTNv8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn)
     /*  80708 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  80711 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80715 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80720 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  80722 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80725 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80729 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80734 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  80737 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80741 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80744 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80749 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80754 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80759 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i16),
     /*  80762 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80764 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80767 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  80771 */       GIR_RootConstrainSelectedInstOperands,
     /*  80772 */       // GIR_Coverage, 4900,
     /*  80772 */       GIR_EraseRootFromParent_Done,
     /*  80773 */     // Label 1369: @80773
     /*  80773 */     GIM_Try, /*On fail goto*//*Label 1370*/ GIMT_Encode4(80835), // Rule ID 5715 //
     /*  80778 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80782 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80786 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  80790 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80792 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rn, (undef:{ *:[v4i16] }))  =>  (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] })
     /*  80792 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  80795 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80799 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80804 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  80806 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80809 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80811 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80814 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  80816 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  80819 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80824 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80829 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80834 */       // GIR_Coverage, 5715,
     /*  80834 */       GIR_EraseRootFromParent_Done,
     /*  80835 */     // Label 1370: @80835
     /*  80835 */     GIM_Try, /*On fail goto*//*Label 1371*/ GIMT_Encode4(80897), // Rule ID 5719 //
     /*  80840 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80844 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80848 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  80852 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80854 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rn, (undef:{ *:[v4f16] }))  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] })
     /*  80854 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  80857 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80861 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80866 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  80868 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80871 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80873 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80876 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  80878 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  80881 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80886 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80891 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80896 */       // GIR_Coverage, 5719,
     /*  80896 */       GIR_EraseRootFromParent_Done,
     /*  80897 */     // Label 1371: @80897
     /*  80897 */     GIM_Try, /*On fail goto*//*Label 1372*/ GIMT_Encode4(81031), // Rule ID 5713 //
     /*  80902 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80906 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80910 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (INSvi64lane:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  80910 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  80913 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80917 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80922 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  80924 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  80927 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80931 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80936 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  80939 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  80943 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  80946 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80951 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80956 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80961 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  80964 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80968 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80973 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  80975 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80978 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80982 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80987 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  80990 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80994 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80997 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81002 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81007 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81012 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  81015 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81017 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81020 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  81023 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  81026 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81029 */       GIR_RootConstrainSelectedInstOperands,
     /*  81030 */       // GIR_Coverage, 5713,
     /*  81030 */       GIR_EraseRootFromParent_Done,
     /*  81031 */     // Label 1372: @81031
     /*  81031 */     GIM_Try, /*On fail goto*//*Label 1373*/ GIMT_Encode4(81165), // Rule ID 5717 //
     /*  81036 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81040 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81044 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn)  =>  (INSvi64lane:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  81044 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  81047 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81051 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81056 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  81058 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  81061 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81065 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81070 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  81073 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  81077 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  81080 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81085 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81090 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81095 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81098 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81102 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81107 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81109 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81112 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81116 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81121 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81124 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81128 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81131 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81136 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81141 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81146 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  81149 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81151 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81154 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  81157 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  81160 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81163 */       GIR_RootConstrainSelectedInstOperands,
     /*  81164 */       // GIR_Coverage, 5717,
     /*  81164 */       GIR_EraseRootFromParent_Done,
     /*  81165 */     // Label 1373: @81165
     /*  81165 */     GIM_Reject,
     /*  81166 */   // Label 1349: @81166
     /*  81166 */   GIM_Reject,
     /*  81167 */   // Label 1308: @81167
     /*  81167 */   GIM_Try, /*On fail goto*//*Label 1374*/ GIMT_Encode4(83077),
     /*  81172 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  81175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  81178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81182 */     GIM_Try, /*On fail goto*//*Label 1375*/ GIMT_Encode4(81311), // Rule ID 5355 //
     /*  81187 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81191 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81195 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  81199 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  81203 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81207 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  81211 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  81215 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  81219 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81223 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  81227 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  81231 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81236 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  81240 */       GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81246 */       GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  81248 */       // MIs[2] Operand 2
     /*  81248 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /*  81259 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  81261 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] }:$Rm), 8:{ *:[i32] })))  =>  (SUBHNv8i16_v16i8:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /*  81261 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81264 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  81268 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81273 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  81276 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81280 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81283 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81288 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81293 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v16i8),
     /*  81296 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81298 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81301 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  81305 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  81309 */       GIR_RootConstrainSelectedInstOperands,
     /*  81310 */       // GIR_Coverage, 5355,
     /*  81310 */       GIR_EraseRootFromParent_Done,
     /*  81311 */     // Label 1375: @81311
     /*  81311 */     GIM_Try, /*On fail goto*//*Label 1376*/ GIMT_Encode4(81433), // Rule ID 5351 //
     /*  81316 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81320 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81324 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  81328 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  81332 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81336 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  81340 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  81344 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  81348 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  81352 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  81356 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  81360 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81365 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81370 */       // MIs[2] Operand 2
     /*  81370 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /*  81381 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  81383 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] })))  =>  (ADDHNv8i16_v16i8:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  81383 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81386 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  81390 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81395 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  81398 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81402 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81405 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81410 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81415 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v16i8),
     /*  81418 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81420 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81423 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  81427 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  81431 */       GIR_RootConstrainSelectedInstOperands,
     /*  81432 */       // GIR_Coverage, 5351,
     /*  81432 */       GIR_EraseRootFromParent_Done,
     /*  81433 */     // Label 1376: @81433
     /*  81433 */     GIM_Try, /*On fail goto*//*Label 1377*/ GIMT_Encode4(81555), // Rule ID 5353 //
     /*  81438 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81442 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81446 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  81450 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  81454 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81458 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  81462 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  81466 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  81470 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  81474 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  81478 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  81482 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81487 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81492 */       // MIs[2] Operand 2
     /*  81492 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /*  81503 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  81505 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] })))  =>  (SUBHNv8i16_v16i8:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  81505 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81508 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  81512 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81517 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  81520 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81524 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81527 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81532 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81537 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v16i8),
     /*  81540 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81542 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81545 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  81549 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  81553 */       GIR_RootConstrainSelectedInstOperands,
     /*  81554 */       // GIR_Coverage, 5353,
     /*  81554 */       GIR_EraseRootFromParent_Done,
     /*  81555 */     // Label 1377: @81555
     /*  81555 */     GIM_Try, /*On fail goto*//*Label 1378*/ GIMT_Encode4(81657), // Rule ID 5511 //
     /*  81560 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81564 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  81568 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  81572 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81576 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  81580 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  81584 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81589 */       // MIs[2] Operand 2
     /*  81589 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /*  81600 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  81604 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  81608 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  81612 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  81616 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
     /*  81620 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  81624 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81629 */       // MIs[4] Operand 2
     /*  81629 */       GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(8),
     /*  81640 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  81642 */       // (concat_vectors:{ *:[v16i8] } (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] })), (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, 8:{ *:[i32] })))  =>  (UZP2v16i8:{ *:[v16i8] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /*  81642 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /*  81645 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  81647 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /*  81651 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
     /*  81655 */       GIR_RootConstrainSelectedInstOperands,
     /*  81656 */       // GIR_Coverage, 5511,
     /*  81656 */       GIR_EraseRootFromParent_Done,
     /*  81657 */     // Label 1378: @81657
     /*  81657 */     GIM_Try, /*On fail goto*//*Label 1379*/ GIMT_Encode4(81786), // Rule ID 6249 //
     /*  81662 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81666 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81670 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  81674 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  81677 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  81682 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  81686 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  81690 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81695 */       GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 8,
     /*  81699 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81701 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Vd, (intrinsic_wo_chain:{ *:[v8i8] } 657:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] }))  =>  (RADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Vn, (MOVIv2d_ns:{ *:[v8i16] } 0:{ *:[i32] }))
     /*  81701 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  81704 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /*  81708 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81713 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  81716 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  81718 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81721 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81725 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81730 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81732 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81735 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81739 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81744 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81747 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
     /*  81751 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81754 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81759 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81764 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81769 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v16i8),
     /*  81772 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81774 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81777 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /*  81781 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  81784 */       GIR_RootConstrainSelectedInstOperands,
     /*  81785 */       // GIR_Coverage, 6249,
     /*  81785 */       GIR_EraseRootFromParent_Done,
     /*  81786 */     // Label 1379: @81786
     /*  81786 */     GIM_Try, /*On fail goto*//*Label 1380*/ GIMT_Encode4(81828), // Rule ID 5724 //
     /*  81791 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  81798 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  81805 */       // (concat_vectors:{ *:[v16i8] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (INSvi64lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] })
     /*  81805 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  81808 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81810 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  81815 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81818 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  81823 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  81826 */       GIR_RootConstrainSelectedInstOperands,
     /*  81827 */       // GIR_Coverage, 5724,
     /*  81827 */       GIR_EraseRootFromParent_Done,
     /*  81828 */     // Label 1380: @81828
     /*  81828 */     GIM_Try, /*On fail goto*//*Label 1381*/ GIMT_Encode4(81951), // Rule ID 2565 //
     /*  81833 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  81836 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81840 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81844 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  81848 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  81851 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  81856 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  81860 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  81864 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81869 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  81873 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  81877 */       GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /*  81881 */       // MIs[2] Operand 1
     /*  81881 */       // No operand predicates
     /*  81881 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  81883 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 657:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (RSHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /*  81883 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81886 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81890 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81895 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81897 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81900 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81904 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81909 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81912 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81916 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81919 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81924 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81929 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81934 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv16i8_shift),
     /*  81937 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81939 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81942 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  81946 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  81949 */       GIR_RootConstrainSelectedInstOperands,
     /*  81950 */       // GIR_Coverage, 2565,
     /*  81950 */       GIR_EraseRootFromParent_Done,
     /*  81951 */     // Label 1381: @81951
     /*  81951 */     GIM_Try, /*On fail goto*//*Label 1382*/ GIMT_Encode4(82074), // Rule ID 6217 //
     /*  81956 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  81959 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81963 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81967 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  81971 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  81975 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81979 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
     /*  81983 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  81987 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81992 */       // MIs[2] imm
     /*  81992 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  81996 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82000 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /*  82004 */       // MIs[3] Operand 1
     /*  82004 */       // No operand predicates
     /*  82004 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  82006 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)))  =>  (SHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /*  82006 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82009 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82013 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82018 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82020 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82023 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82027 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82032 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82035 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82039 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82042 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82047 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82052 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82057 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv16i8_shift),
     /*  82060 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82062 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82065 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  82069 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  82072 */       GIR_RootConstrainSelectedInstOperands,
     /*  82073 */       // GIR_Coverage, 6217,
     /*  82073 */       GIR_EraseRootFromParent_Done,
     /*  82074 */     // Label 1382: @82074
     /*  82074 */     GIM_Try, /*On fail goto*//*Label 1383*/ GIMT_Encode4(82194), // Rule ID 6255 //
     /*  82079 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82083 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82087 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  82091 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  82095 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  82099 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  82103 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  82107 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82112 */       // MIs[2] imm
     /*  82112 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  82116 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82120 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /*  82124 */       // MIs[3] Operand 1
     /*  82124 */       // No operand predicates
     /*  82124 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  82126 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)))  =>  (SHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /*  82126 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82129 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82133 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82138 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82140 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82143 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82147 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82152 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82155 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82159 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82162 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82167 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82172 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82177 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv16i8_shift),
     /*  82180 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82182 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82185 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  82189 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  82192 */       GIR_RootConstrainSelectedInstOperands,
     /*  82193 */       // GIR_Coverage, 6255,
     /*  82193 */       GIR_EraseRootFromParent_Done,
     /*  82194 */     // Label 1383: @82194
     /*  82194 */     GIM_Try, /*On fail goto*//*Label 1384*/ GIMT_Encode4(82311), // Rule ID 2490 //
     /*  82199 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  82202 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82206 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82210 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  82214 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  82217 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /*  82222 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  82226 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  82230 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82235 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82240 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82242 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 569:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (ADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  82242 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82245 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82249 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82254 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82256 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82259 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82263 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82268 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82271 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82275 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82278 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82283 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82288 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82293 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v16i8),
     /*  82296 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82298 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82301 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  82305 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  82309 */       GIR_RootConstrainSelectedInstOperands,
     /*  82310 */       // GIR_Coverage, 2490,
     /*  82310 */       GIR_EraseRootFromParent_Done,
     /*  82311 */     // Label 1384: @82311
     /*  82311 */     GIM_Try, /*On fail goto*//*Label 1385*/ GIMT_Encode4(82428), // Rule ID 5281 //
     /*  82316 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  82319 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82323 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82327 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  82331 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  82334 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /*  82339 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  82343 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  82347 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82352 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82357 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82359 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 714:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (SUBHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  82359 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82362 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82366 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82371 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82373 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82376 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82380 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82385 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82388 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82392 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82395 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82400 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82405 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82410 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v16i8),
     /*  82413 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82415 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82418 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  82422 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  82426 */       GIR_RootConstrainSelectedInstOperands,
     /*  82427 */       // GIR_Coverage, 5281,
     /*  82427 */       GIR_EraseRootFromParent_Done,
     /*  82428 */     // Label 1385: @82428
     /*  82428 */     GIM_Try, /*On fail goto*//*Label 1386*/ GIMT_Encode4(82545), // Rule ID 5284 //
     /*  82433 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  82436 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82440 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82444 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  82448 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  82451 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /*  82456 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  82460 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  82464 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82469 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82474 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82476 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 656:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (RADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  82476 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82479 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82483 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82488 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82490 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82493 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82497 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82502 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82505 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82509 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82512 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82517 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82522 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82527 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v16i8),
     /*  82530 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82532 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82535 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  82539 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  82543 */       GIR_RootConstrainSelectedInstOperands,
     /*  82544 */       // GIR_Coverage, 5284,
     /*  82544 */       GIR_EraseRootFromParent_Done,
     /*  82545 */     // Label 1386: @82545
     /*  82545 */     GIM_Try, /*On fail goto*//*Label 1387*/ GIMT_Encode4(82662), // Rule ID 5287 //
     /*  82550 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  82553 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82557 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82561 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  82565 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  82568 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /*  82573 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  82577 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  82581 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82586 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82591 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82593 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 658:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (RSUBHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  82593 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82596 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82600 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82605 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82607 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82610 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82614 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82619 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82622 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82626 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82629 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82634 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82639 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82644 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv8i16_v16i8),
     /*  82647 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82649 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82652 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  82656 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  82660 */       GIR_RootConstrainSelectedInstOperands,
     /*  82661 */       // GIR_Coverage, 5287,
     /*  82661 */       GIR_EraseRootFromParent_Done,
     /*  82662 */     // Label 1387: @82662
     /*  82662 */     GIM_Try, /*On fail goto*//*Label 1388*/ GIMT_Encode4(82718), // Rule ID 5428 //
     /*  82667 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82671 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  82675 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  82679 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82684 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  82688 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  82692 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  82696 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82701 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  82703 */       // (concat_vectors:{ *:[v16i8] } (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vn), (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vm))  =>  (UZP1v16i8:{ *:[v16i8] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /*  82703 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v16i8),
     /*  82706 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  82708 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  82712 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  82716 */       GIR_RootConstrainSelectedInstOperands,
     /*  82717 */       // GIR_Coverage, 5428,
     /*  82717 */       GIR_EraseRootFromParent_Done,
     /*  82718 */     // Label 1388: @82718
     /*  82718 */     GIM_Try, /*On fail goto*//*Label 1389*/ GIMT_Encode4(82784), // Rule ID 5722 //
     /*  82723 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82727 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82731 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82737 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  82739 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82741 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v8i8] }:$Rn), dsub:{ *:[i32] })
     /*  82741 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  82744 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  82748 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82753 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  82757 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  82759 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  82762 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82764 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82767 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82770 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  82773 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82778 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82783 */       // GIR_Coverage, 5722,
     /*  82783 */       GIR_EraseRootFromParent_Done,
     /*  82784 */     // Label 1389: @82784
     /*  82784 */     GIM_Try, /*On fail goto*//*Label 1390*/ GIMT_Encode4(82880), // Rule ID 4899 //
     /*  82789 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  82792 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82796 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82800 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  82804 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  82808 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82813 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82815 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn))  =>  (XTNv16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn)
     /*  82815 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82818 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82822 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82827 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82829 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82832 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82836 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82841 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82844 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82848 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82851 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82856 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82861 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82866 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv16i8),
     /*  82869 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82871 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82874 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  82878 */       GIR_RootConstrainSelectedInstOperands,
     /*  82879 */       // GIR_Coverage, 4899,
     /*  82879 */       GIR_EraseRootFromParent_Done,
     /*  82880 */     // Label 1390: @82880
     /*  82880 */     GIM_Try, /*On fail goto*//*Label 1391*/ GIMT_Encode4(82942), // Rule ID 5723 //
     /*  82885 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82889 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82893 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  82897 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82899 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rn, (undef:{ *:[v8i8] }))  =>  (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] })
     /*  82899 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  82902 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82906 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82911 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  82913 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82916 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82918 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82921 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  82923 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  82926 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82931 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82936 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82941 */       // GIR_Coverage, 5723,
     /*  82941 */       GIR_EraseRootFromParent_Done,
     /*  82942 */     // Label 1391: @82942
     /*  82942 */     GIM_Try, /*On fail goto*//*Label 1392*/ GIMT_Encode4(83076), // Rule ID 5721 //
     /*  82947 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82951 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82955 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (INSvi64lane:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  82955 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  82958 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82962 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82967 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  82969 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  82972 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82976 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82981 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  82984 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  82988 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  82991 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82996 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83001 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83006 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  83009 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  83013 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83018 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  83020 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  83023 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  83027 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83032 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  83035 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  83039 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  83042 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83047 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83052 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83057 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  83060 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83062 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83065 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  83068 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  83071 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83074 */       GIR_RootConstrainSelectedInstOperands,
     /*  83075 */       // GIR_Coverage, 5721,
     /*  83075 */       GIR_EraseRootFromParent_Done,
     /*  83076 */     // Label 1392: @83076
     /*  83076 */     GIM_Reject,
     /*  83077 */   // Label 1374: @83077
     /*  83077 */   GIM_Reject,
     /*  83078 */   // Label 1309: @83078
     /*  83078 */   GIM_Try, /*On fail goto*//*Label 1393*/ GIMT_Encode4(83103), // Rule ID 8917 //
     /*  83083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  83086 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  83089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  83092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  83096 */     // (concat_vectors:{ *:[nxv2i1] } nxv1i1:{ *:[nxv1i1] }:$p1, nxv1i1:{ *:[nxv1i1] }:$p2)  =>  (UZP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv1i1] }:$p1, ?:{ *:[nxv1i1] }:$p2)
     /*  83096 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
     /*  83101 */     GIR_RootConstrainSelectedInstOperands,
     /*  83102 */     // GIR_Coverage, 8917,
     /*  83102 */     GIR_Done,
     /*  83103 */   // Label 1393: @83103
     /*  83103 */   GIM_Reject,
     /*  83104 */   // Label 1310: @83104
     /*  83104 */   GIM_Try, /*On fail goto*//*Label 1394*/ GIMT_Encode4(83129), // Rule ID 8918 //
     /*  83109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  83112 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  83115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  83118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  83122 */     // (concat_vectors:{ *:[nxv4i1] } nxv2i1:{ *:[nxv2i1] }:$p1, nxv2i1:{ *:[nxv2i1] }:$p2)  =>  (UZP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv2i1] }:$p1, ?:{ *:[nxv2i1] }:$p2)
     /*  83122 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
     /*  83127 */     GIR_RootConstrainSelectedInstOperands,
     /*  83128 */     // GIR_Coverage, 8918,
     /*  83128 */     GIR_Done,
     /*  83129 */   // Label 1394: @83129
     /*  83129 */   GIM_Reject,
     /*  83130 */   // Label 1311: @83130
     /*  83130 */   GIM_Try, /*On fail goto*//*Label 1395*/ GIMT_Encode4(83155), // Rule ID 8921 //
     /*  83135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  83138 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*  83141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  83144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  83148 */     // (concat_vectors:{ *:[nxv4f16] } nxv2f16:{ *:[nxv2f16] }:$v1, nxv2f16:{ *:[nxv2f16] }:$v2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv2f16] }:$v1, ?:{ *:[nxv2f16] }:$v2)
     /*  83148 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /*  83153 */     GIR_RootConstrainSelectedInstOperands,
     /*  83154 */     // GIR_Coverage, 8921,
     /*  83154 */     GIR_Done,
     /*  83155 */   // Label 1395: @83155
     /*  83155 */   GIM_Reject,
     /*  83156 */   // Label 1312: @83156
     /*  83156 */   GIM_Try, /*On fail goto*//*Label 1396*/ GIMT_Encode4(83181), // Rule ID 8923 //
     /*  83161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  83164 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*  83167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  83170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  83174 */     // (concat_vectors:{ *:[nxv4f32] } nxv2f32:{ *:[nxv2f32] }:$v1, nxv2f32:{ *:[nxv2f32] }:$v2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv2f32] }:$v1, ?:{ *:[nxv2f32] }:$v2)
     /*  83174 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /*  83179 */     GIR_RootConstrainSelectedInstOperands,
     /*  83180 */     // GIR_Coverage, 8923,
     /*  83180 */     GIR_Done,
     /*  83181 */   // Label 1396: @83181
     /*  83181 */   GIM_Reject,
     /*  83182 */   // Label 1313: @83182
     /*  83182 */   GIM_Try, /*On fail goto*//*Label 1397*/ GIMT_Encode4(83207), // Rule ID 8919 //
     /*  83187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  83190 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  83193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  83196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  83200 */     // (concat_vectors:{ *:[nxv8i1] } nxv4i1:{ *:[nxv4i1] }:$p1, nxv4i1:{ *:[nxv4i1] }:$p2)  =>  (UZP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv4i1] }:$p1, ?:{ *:[nxv4i1] }:$p2)
     /*  83200 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
     /*  83205 */     GIR_RootConstrainSelectedInstOperands,
     /*  83206 */     // GIR_Coverage, 8919,
     /*  83206 */     GIR_Done,
     /*  83207 */   // Label 1397: @83207
     /*  83207 */   GIM_Reject,
     /*  83208 */   // Label 1314: @83208
     /*  83208 */   GIM_Try, /*On fail goto*//*Label 1398*/ GIMT_Encode4(83233), // Rule ID 8922 //
     /*  83213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  83216 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*  83219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  83222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  83226 */     // (concat_vectors:{ *:[nxv8f16] } nxv4f16:{ *:[nxv4f16] }:$v1, nxv4f16:{ *:[nxv4f16] }:$v2)  =>  (UZP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv4f16] }:$v1, ?:{ *:[nxv4f16] }:$v2)
     /*  83226 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
     /*  83231 */     GIR_RootConstrainSelectedInstOperands,
     /*  83232 */     // GIR_Coverage, 8922,
     /*  83232 */     GIR_Done,
     /*  83233 */   // Label 1398: @83233
     /*  83233 */   GIM_Reject,
     /*  83234 */   // Label 1315: @83234
     /*  83234 */   GIM_Try, /*On fail goto*//*Label 1399*/ GIMT_Encode4(83259), // Rule ID 8920 //
     /*  83239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  83242 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  83245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  83248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  83252 */     // (concat_vectors:{ *:[nxv16i1] } nxv8i1:{ *:[nxv8i1] }:$p1, nxv8i1:{ *:[nxv8i1] }:$p2)  =>  (UZP1_PPP_B:{ *:[nxv16i1] } ?:{ *:[nxv8i1] }:$p1, ?:{ *:[nxv8i1] }:$p2)
     /*  83252 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_B),
     /*  83257 */     GIR_RootConstrainSelectedInstOperands,
     /*  83258 */     // GIR_Coverage, 8920,
     /*  83258 */     GIR_Done,
     /*  83259 */   // Label 1399: @83259
     /*  83259 */   GIM_Reject,
     /*  83260 */   // Label 1316: @83260
     /*  83260 */   GIM_Reject,
     /*  83261 */ // Label 1304: @83261
     /*  83261 */ GIM_Reject,
     /*  83262 */ // Label 9: @83262
     /*  83262 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 1414*/ GIMT_Encode4(93205),
     /*  83273 */ /*GILLT_s32*//*Label 1400*/ GIMT_Encode4(83361),
     /*  83277 */ /*GILLT_s64*//*Label 1401*/ GIMT_Encode4(83742),
     /*  83281 */ /*GILLT_s128*//*Label 1402*/ GIMT_Encode4(85717),
     /*  83285 */ /*GILLT_v2s32*//*Label 1403*/ GIMT_Encode4(86363),
     /*  83289 */ /*GILLT_v2s64*//*Label 1404*/ GIMT_Encode4(87278),
     /*  83293 */ /*GILLT_v4s16*//*Label 1405*/ GIMT_Encode4(88047),
     /*  83297 */ /*GILLT_v4s32*//*Label 1406*/ GIMT_Encode4(88962),
     /*  83301 */ /*GILLT_v8s8*//*Label 1407*/ GIMT_Encode4(89807),
     /*  83305 */ /*GILLT_v8s16*//*Label 1408*/ GIMT_Encode4(90368),
     /*  83309 */ /*GILLT_v16s8*//*Label 1409*/ GIMT_Encode4(91213), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  83329 */ /*GILLT_nxv2s64*//*Label 1410*/ GIMT_Encode4(91665), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  83341 */ /*GILLT_nxv4s32*//*Label 1411*/ GIMT_Encode4(92114), GIMT_Encode4(0),
     /*  83349 */ /*GILLT_nxv8s16*//*Label 1412*/ GIMT_Encode4(92563), GIMT_Encode4(0),
     /*  83357 */ /*GILLT_nxv16s8*//*Label 1413*/ GIMT_Encode4(93012),
     /*  83361 */ // Label 1400: @83361
     /*  83361 */ GIM_Try, /*On fail goto*//*Label 1415*/ GIMT_Encode4(83741),
     /*  83366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  83369 */   GIM_Try, /*On fail goto*//*Label 1416*/ GIMT_Encode4(83439), // Rule ID 6968 //
     /*  83374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  83378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  83386 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  83389 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  83396 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  83399 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  83403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  83405 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /*  83412 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15519>>)  =>  (LDRSroW:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /*  83412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /*  83415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  83417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  83422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  83427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  83432 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  83437 */     GIR_RootConstrainSelectedInstOperands,
     /*  83438 */     // GIR_Coverage, 6968,
     /*  83438 */     GIR_EraseRootFromParent_Done,
     /*  83439 */   // Label 1416: @83439
     /*  83439 */   GIM_Try, /*On fail goto*//*Label 1417*/ GIMT_Encode4(83509), // Rule ID 6969 //
     /*  83444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  83448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  83456 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  83459 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  83466 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  83469 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  83473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  83475 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /*  83482 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15519>>)  =>  (LDRSroX:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /*  83482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /*  83485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  83487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  83492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  83497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  83502 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  83507 */     GIR_RootConstrainSelectedInstOperands,
     /*  83508 */     // GIR_Coverage, 6969,
     /*  83508 */     GIR_EraseRootFromParent_Done,
     /*  83509 */   // Label 1417: @83509
     /*  83509 */   GIM_Try, /*On fail goto*//*Label 1418*/ GIMT_Encode4(83574), // Rule ID 6970 //
     /*  83514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  83518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  83526 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  83529 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  83536 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  83539 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  83543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  83545 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /*  83552 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15519>>)  =>  (LDRSui:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /*  83552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /*  83555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  83557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  83562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  83567 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  83572 */     GIR_RootConstrainSelectedInstOperands,
     /*  83573 */     // GIR_Coverage, 6970,
     /*  83573 */     GIR_EraseRootFromParent_Done,
     /*  83574 */   // Label 1418: @83574
     /*  83574 */   GIM_Try, /*On fail goto*//*Label 1419*/ GIMT_Encode4(83639), // Rule ID 6971 //
     /*  83579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  83583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  83591 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  83594 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  83601 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  83604 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  83608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  83610 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /*  83617 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15519>>)  =>  (LDURSi:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  83617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /*  83620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  83622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  83627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  83632 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  83637 */     GIR_RootConstrainSelectedInstOperands,
     /*  83638 */     // GIR_Coverage, 6971,
     /*  83638 */     GIR_EraseRootFromParent_Done,
     /*  83639 */   // Label 1419: @83639
     /*  83639 */   GIM_Try, /*On fail goto*//*Label 1420*/ GIMT_Encode4(83692), // Rule ID 5688 //
     /*  83644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  83648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  83656 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83660 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  83664 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /*  83668 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  83670 */     // (bitconvert:{ *:[f32] } (vector_extract:{ *:[i32] } v4i32:{ *:[v4i32] }:$src, 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4i32] }:$src, ssub:{ *:[i32] })
     /*  83670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83675 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // src
     /*  83681 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  83686 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83691 */     // GIR_Coverage, 5688,
     /*  83691 */     GIR_EraseRootFromParent_Done,
     /*  83692 */   // Label 1420: @83692
     /*  83692 */   GIM_Try, /*On fail goto*//*Label 1421*/ GIMT_Encode4(83716), // Rule ID 6581 //
     /*  83697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  83701 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  83705 */     // (bitconvert:{ *:[f32] } GPR32:{ *:[i32] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Xn, FPR32:{ *:[i32] })
     /*  83705 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83710 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  83715 */     // GIR_Coverage, 6581,
     /*  83715 */     GIR_Done,
     /*  83716 */   // Label 1421: @83716
     /*  83716 */   GIM_Try, /*On fail goto*//*Label 1422*/ GIMT_Encode4(83740), // Rule ID 6582 //
     /*  83721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  83725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  83729 */     // (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[i32] } FPR32:{ *:[f32] }:$Xn, GPR32:{ *:[i32] })
     /*  83729 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83734 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  83739 */     // GIR_Coverage, 6582,
     /*  83739 */     GIR_Done,
     /*  83740 */   // Label 1422: @83740
     /*  83740 */   GIM_Reject,
     /*  83741 */ // Label 1415: @83741
     /*  83741 */ GIM_Reject,
     /*  83742 */ // Label 1401: @83742
     /*  83742 */ GIM_Try, /*On fail goto*//*Label 1423*/ GIMT_Encode4(83815), // Rule ID 6972 //
     /*  83747 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  83750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83754 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83758 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  83762 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  83765 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  83772 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  83775 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  83779 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  83781 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /*  83788 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15527>>)  =>  (LDRDroW:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /*  83788 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /*  83791 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  83793 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  83798 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  83803 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  83808 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  83813 */   GIR_RootConstrainSelectedInstOperands,
     /*  83814 */   // GIR_Coverage, 6972,
     /*  83814 */   GIR_EraseRootFromParent_Done,
     /*  83815 */ // Label 1423: @83815
     /*  83815 */ GIM_Try, /*On fail goto*//*Label 1424*/ GIMT_Encode4(83888), // Rule ID 6973 //
     /*  83820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  83823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83827 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83831 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  83835 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  83838 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  83845 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  83848 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  83852 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  83854 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /*  83861 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15527>>)  =>  (LDRDroX:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /*  83861 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /*  83864 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  83866 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  83871 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  83876 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  83881 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  83886 */   GIR_RootConstrainSelectedInstOperands,
     /*  83887 */   // GIR_Coverage, 6973,
     /*  83887 */   GIR_EraseRootFromParent_Done,
     /*  83888 */ // Label 1424: @83888
     /*  83888 */ GIM_Try, /*On fail goto*//*Label 1425*/ GIMT_Encode4(83956), // Rule ID 6974 //
     /*  83893 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  83896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83900 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83904 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  83908 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  83911 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  83918 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  83921 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  83925 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  83927 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /*  83934 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15527>>)  =>  (LDRDui:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /*  83934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /*  83937 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  83939 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  83944 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  83949 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  83954 */   GIR_RootConstrainSelectedInstOperands,
     /*  83955 */   // GIR_Coverage, 6974,
     /*  83955 */   GIR_EraseRootFromParent_Done,
     /*  83956 */ // Label 1425: @83956
     /*  83956 */ GIM_Try, /*On fail goto*//*Label 1426*/ GIMT_Encode4(84024), // Rule ID 6975 //
     /*  83961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  83964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83968 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83972 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  83976 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  83979 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  83986 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  83989 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  83993 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  83995 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /*  84002 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15527>>)  =>  (LDURDi:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  84002 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /*  84005 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  84007 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  84012 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  84017 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  84022 */   GIR_RootConstrainSelectedInstOperands,
     /*  84023 */   // GIR_Coverage, 6975,
     /*  84023 */   GIR_EraseRootFromParent_Done,
     /*  84024 */ // Label 1426: @84024
     /*  84024 */ GIM_Try, /*On fail goto*//*Label 1427*/ GIMT_Encode4(84080), // Rule ID 5690 //
     /*  84029 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  84032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84036 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84040 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  84044 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  84048 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  84052 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /*  84056 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  84058 */   // (bitconvert:{ *:[f64] } (vector_extract:{ *:[i64] } v2i64:{ *:[v2i64] }:$src, 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2i64] }:$src, dsub:{ *:[i32] })
     /*  84058 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84061 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84063 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // src
     /*  84069 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84074 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84079 */   // GIR_Coverage, 5690,
     /*  84079 */   GIR_EraseRootFromParent_Done,
     /*  84080 */ // Label 1427: @84080
     /*  84080 */ GIM_Try, /*On fail goto*//*Label 1428*/ GIMT_Encode4(84110), // Rule ID 6556 //
     /*  84085 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  84088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  84091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84095 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84099 */   // (bitconvert:{ *:[i64] } V64:{ *:[v8i8] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v8i8] }:$Vn, GPR64:{ *:[i32] })
     /*  84099 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84104 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84109 */   // GIR_Coverage, 6556,
     /*  84109 */   GIR_Done,
     /*  84110 */ // Label 1428: @84110
     /*  84110 */ GIM_Try, /*On fail goto*//*Label 1429*/ GIMT_Encode4(84140), // Rule ID 6557 //
     /*  84115 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  84118 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  84121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84125 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84129 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4i16] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4i16] }:$Vn, GPR64:{ *:[i32] })
     /*  84129 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84134 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84139 */   // GIR_Coverage, 6557,
     /*  84139 */   GIR_Done,
     /*  84140 */ // Label 1429: @84140
     /*  84140 */ GIM_Try, /*On fail goto*//*Label 1430*/ GIMT_Encode4(84170), // Rule ID 6558 //
     /*  84145 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  84148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  84151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84155 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84159 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2i32] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2i32] }:$Vn, GPR64:{ *:[i32] })
     /*  84159 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84164 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84169 */   // GIR_Coverage, 6558,
     /*  84169 */   GIR_Done,
     /*  84170 */ // Label 1430: @84170
     /*  84170 */ GIM_Try, /*On fail goto*//*Label 1431*/ GIMT_Encode4(84200), // Rule ID 6559 //
     /*  84175 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  84178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  84181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84185 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84189 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4f16] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4f16] }:$Vn, GPR64:{ *:[i32] })
     /*  84189 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84194 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84199 */   // GIR_Coverage, 6559,
     /*  84199 */   GIR_Done,
     /*  84200 */ // Label 1431: @84200
     /*  84200 */ GIM_Try, /*On fail goto*//*Label 1432*/ GIMT_Encode4(84230), // Rule ID 6560 //
     /*  84205 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  84208 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  84211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84215 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84219 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2f32] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2f32] }:$Vn, GPR64:{ *:[i32] })
     /*  84219 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84224 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84229 */   // GIR_Coverage, 6560,
     /*  84229 */   GIR_Done,
     /*  84230 */ // Label 1432: @84230
     /*  84230 */ GIM_Try, /*On fail goto*//*Label 1433*/ GIMT_Encode4(84260), // Rule ID 6561 //
     /*  84235 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  84238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  84241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84245 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84249 */   // (bitconvert:{ *:[i64] } V64:{ *:[v1f64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1f64] }:$Vn, GPR64:{ *:[i32] })
     /*  84249 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84254 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84259 */   // GIR_Coverage, 6561,
     /*  84259 */   GIR_Done,
     /*  84260 */ // Label 1433: @84260
     /*  84260 */ GIM_Try, /*On fail goto*//*Label 1434*/ GIMT_Encode4(84310), // Rule ID 6567 //
     /*  84265 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  84268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  84271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84275 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84279 */   // (bitconvert:{ *:[i64] } V64:{ *:[v8i8] }:$Vn)  =>  (REV64v8i8:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v8i8] }:$Vn, GPR64:{ *:[i32] }))
     /*  84279 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  84282 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84286 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84291 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /*  84295 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84300 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  84303 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  84305 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84308 */   GIR_RootConstrainSelectedInstOperands,
     /*  84309 */   // GIR_Coverage, 6567,
     /*  84309 */   GIR_EraseRootFromParent_Done,
     /*  84310 */ // Label 1434: @84310
     /*  84310 */ GIM_Try, /*On fail goto*//*Label 1435*/ GIMT_Encode4(84360), // Rule ID 6568 //
     /*  84315 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  84318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  84321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84325 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84329 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4i16] }:$Vn)  =>  (REV64v4i16:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4i16] }:$Vn, GPR64:{ *:[i32] }))
     /*  84329 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  84332 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84336 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84341 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /*  84345 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84350 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  84353 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  84355 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84358 */   GIR_RootConstrainSelectedInstOperands,
     /*  84359 */   // GIR_Coverage, 6568,
     /*  84359 */   GIR_EraseRootFromParent_Done,
     /*  84360 */ // Label 1435: @84360
     /*  84360 */ GIM_Try, /*On fail goto*//*Label 1436*/ GIMT_Encode4(84410), // Rule ID 6569 //
     /*  84365 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  84368 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  84371 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84375 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84379 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2i32] }:$Vn)  =>  (REV64v2i32:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2i32] }:$Vn, GPR64:{ *:[i32] }))
     /*  84379 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  84382 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84386 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84391 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /*  84395 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84400 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  84403 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  84405 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84408 */   GIR_RootConstrainSelectedInstOperands,
     /*  84409 */   // GIR_Coverage, 6569,
     /*  84409 */   GIR_EraseRootFromParent_Done,
     /*  84410 */ // Label 1436: @84410
     /*  84410 */ GIM_Try, /*On fail goto*//*Label 1437*/ GIMT_Encode4(84460), // Rule ID 6570 //
     /*  84415 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  84418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  84421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84425 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84429 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4f16] }:$Vn)  =>  (REV64v4i16:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4f16] }:$Vn, GPR64:{ *:[i32] }))
     /*  84429 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  84432 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84436 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84441 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /*  84445 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84450 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  84453 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  84455 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84458 */   GIR_RootConstrainSelectedInstOperands,
     /*  84459 */   // GIR_Coverage, 6570,
     /*  84459 */   GIR_EraseRootFromParent_Done,
     /*  84460 */ // Label 1437: @84460
     /*  84460 */ GIM_Try, /*On fail goto*//*Label 1438*/ GIMT_Encode4(84510), // Rule ID 6571 //
     /*  84465 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  84468 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  84471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84475 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84479 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2f32] }:$Vn)  =>  (REV64v2i32:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2f32] }:$Vn, GPR64:{ *:[i32] }))
     /*  84479 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  84482 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84486 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84491 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /*  84495 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84500 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  84503 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  84505 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84508 */   GIR_RootConstrainSelectedInstOperands,
     /*  84509 */   // GIR_Coverage, 6571,
     /*  84509 */   GIR_EraseRootFromParent_Done,
     /*  84510 */ // Label 1438: @84510
     /*  84510 */ GIM_Try, /*On fail goto*//*Label 1439*/ GIMT_Encode4(84537), // Rule ID 6572 //
     /*  84515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  84518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84522 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84526 */   // (bitconvert:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  84526 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84531 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84536 */   // GIR_Coverage, 6572,
     /*  84536 */   GIR_Done,
     /*  84537 */ // Label 1439: @84537
     /*  84537 */ GIM_Try, /*On fail goto*//*Label 1440*/ GIMT_Encode4(84564), // Rule ID 6573 //
     /*  84542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  84545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84549 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84553 */   // (bitconvert:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  84553 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84558 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84563 */   // GIR_Coverage, 6573,
     /*  84563 */   GIR_Done,
     /*  84564 */ // Label 1440: @84564
     /*  84564 */ GIM_Try, /*On fail goto*//*Label 1441*/ GIMT_Encode4(84591), // Rule ID 6574 //
     /*  84569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  84572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84576 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84580 */   // (bitconvert:{ *:[i64] } V64:{ *:[v1i64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1i64] }:$Vn, GPR64:{ *:[i32] })
     /*  84580 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84585 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84590 */   // GIR_Coverage, 6574,
     /*  84590 */   GIR_Done,
     /*  84591 */ // Label 1441: @84591
     /*  84591 */ GIM_Try, /*On fail goto*//*Label 1442*/ GIMT_Encode4(84618), // Rule ID 6583 //
     /*  84596 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  84599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84603 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84607 */   // (bitconvert:{ *:[f64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  84607 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84612 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84617 */   // GIR_Coverage, 6583,
     /*  84617 */   GIR_Done,
     /*  84618 */ // Label 1442: @84618
     /*  84618 */ GIM_Try, /*On fail goto*//*Label 1443*/ GIMT_Encode4(84645), // Rule ID 6584 //
     /*  84623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  84626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84630 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84634 */   // (bitconvert:{ *:[i64] } FPR64:{ *:[f64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } FPR64:{ *:[f64] }:$Xn, GPR64:{ *:[i32] })
     /*  84634 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84639 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84644 */   // GIR_Coverage, 6584,
     /*  84644 */   GIR_Done,
     /*  84645 */ // Label 1443: @84645
     /*  84645 */ GIM_Try, /*On fail goto*//*Label 1444*/ GIMT_Encode4(84672), // Rule ID 6585 //
     /*  84650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  84653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84657 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84661 */   // (bitconvert:{ *:[i64] } V64:{ *:[v1f64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1f64] }:$Vn, GPR64:{ *:[i32] })
     /*  84661 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84666 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  84671 */   // GIR_Coverage, 6585,
     /*  84671 */   GIR_Done,
     /*  84672 */ // Label 1444: @84672
     /*  84672 */ GIM_Try, /*On fail goto*//*Label 1445*/ GIMT_Encode4(84704), // Rule ID 6586 //
     /*  84677 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  84680 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  84683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84687 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84691 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  84691 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84694 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  84696 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  84698 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84703 */   // GIR_Coverage, 6586,
     /*  84703 */   GIR_EraseRootFromParent_Done,
     /*  84704 */ // Label 1445: @84704
     /*  84704 */ GIM_Try, /*On fail goto*//*Label 1446*/ GIMT_Encode4(84736), // Rule ID 6587 //
     /*  84709 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  84712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  84715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84719 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84723 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  84723 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84726 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  84728 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  84730 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84735 */   // GIR_Coverage, 6587,
     /*  84735 */   GIR_EraseRootFromParent_Done,
     /*  84736 */ // Label 1446: @84736
     /*  84736 */ GIM_Try, /*On fail goto*//*Label 1447*/ GIMT_Encode4(84768), // Rule ID 6588 //
     /*  84741 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  84744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  84747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84751 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84755 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  84755 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84758 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  84760 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  84762 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84767 */   // GIR_Coverage, 6588,
     /*  84767 */   GIR_EraseRootFromParent_Done,
     /*  84768 */ // Label 1447: @84768
     /*  84768 */ GIM_Try, /*On fail goto*//*Label 1448*/ GIMT_Encode4(84800), // Rule ID 6589 //
     /*  84773 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  84776 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  84779 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84783 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84787 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  84787 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84790 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  84792 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  84794 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84799 */   // GIR_Coverage, 6589,
     /*  84799 */   GIR_EraseRootFromParent_Done,
     /*  84800 */ // Label 1448: @84800
     /*  84800 */ GIM_Try, /*On fail goto*//*Label 1449*/ GIMT_Encode4(84832), // Rule ID 6590 //
     /*  84805 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  84808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  84811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84815 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84819 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  84819 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84822 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  84824 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  84826 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84831 */   // GIR_Coverage, 6590,
     /*  84831 */   GIR_EraseRootFromParent_Done,
     /*  84832 */ // Label 1449: @84832
     /*  84832 */ GIM_Try, /*On fail goto*//*Label 1450*/ GIMT_Encode4(84858), // Rule ID 6591 //
     /*  84837 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  84840 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  84843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84847 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84851 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)
     /*  84851 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  84856 */   GIR_RootConstrainSelectedInstOperands,
     /*  84857 */   // GIR_Coverage, 6591,
     /*  84857 */   GIR_Done,
     /*  84858 */ // Label 1450: @84858
     /*  84858 */ GIM_Try, /*On fail goto*//*Label 1451*/ GIMT_Encode4(84884), // Rule ID 6592 //
     /*  84863 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  84866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  84869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84873 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84877 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)
     /*  84877 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  84882 */   GIR_RootConstrainSelectedInstOperands,
     /*  84883 */   // GIR_Coverage, 6592,
     /*  84883 */   GIR_Done,
     /*  84884 */ // Label 1451: @84884
     /*  84884 */ GIM_Try, /*On fail goto*//*Label 1452*/ GIMT_Encode4(84910), // Rule ID 6593 //
     /*  84889 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  84892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  84895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84899 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84903 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)
     /*  84903 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  84908 */   GIR_RootConstrainSelectedInstOperands,
     /*  84909 */   // GIR_Coverage, 6593,
     /*  84909 */   GIR_Done,
     /*  84910 */ // Label 1452: @84910
     /*  84910 */ GIM_Try, /*On fail goto*//*Label 1453*/ GIMT_Encode4(84936), // Rule ID 6594 //
     /*  84915 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  84918 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  84921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84925 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84929 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)
     /*  84929 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  84934 */   GIR_RootConstrainSelectedInstOperands,
     /*  84935 */   // GIR_Coverage, 6594,
     /*  84935 */   GIR_Done,
     /*  84936 */ // Label 1453: @84936
     /*  84936 */ GIM_Try, /*On fail goto*//*Label 1454*/ GIMT_Encode4(84962), // Rule ID 6595 //
     /*  84941 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  84944 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  84947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84951 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84955 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)
     /*  84955 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  84960 */   GIR_RootConstrainSelectedInstOperands,
     /*  84961 */   // GIR_Coverage, 6595,
     /*  84961 */   GIR_Done,
     /*  84962 */ // Label 1454: @84962
     /*  84962 */ GIM_Try, /*On fail goto*//*Label 1455*/ GIMT_Encode4(84991), // Rule ID 6596 //
     /*  84967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  84970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84974 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84978 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  84978 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84981 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  84983 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  84985 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84990 */   // GIR_Coverage, 6596,
     /*  84990 */   GIR_EraseRootFromParent_Done,
     /*  84991 */ // Label 1455: @84991
     /*  84991 */ GIM_Try, /*On fail goto*//*Label 1456*/ GIMT_Encode4(85020), // Rule ID 6597 //
     /*  84996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  84999 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85003 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85007 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  85007 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85010 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85012 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85014 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85019 */   // GIR_Coverage, 6597,
     /*  85019 */   GIR_EraseRootFromParent_Done,
     /*  85020 */ // Label 1456: @85020
     /*  85020 */ GIM_Try, /*On fail goto*//*Label 1457*/ GIMT_Encode4(85052), // Rule ID 6651 //
     /*  85025 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  85031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85035 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85039 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  85039 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85042 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85044 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85046 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85051 */   // GIR_Coverage, 6651,
     /*  85051 */   GIR_EraseRootFromParent_Done,
     /*  85052 */ // Label 1457: @85052
     /*  85052 */ GIM_Try, /*On fail goto*//*Label 1458*/ GIMT_Encode4(85084), // Rule ID 6652 //
     /*  85057 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85060 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  85063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85067 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85071 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  85071 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85074 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85076 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85078 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85083 */   // GIR_Coverage, 6652,
     /*  85083 */   GIR_EraseRootFromParent_Done,
     /*  85084 */ // Label 1458: @85084
     /*  85084 */ GIM_Try, /*On fail goto*//*Label 1459*/ GIMT_Encode4(85116), // Rule ID 6653 //
     /*  85089 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85092 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  85095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85099 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85103 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  85103 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85106 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85108 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85110 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85115 */   // GIR_Coverage, 6653,
     /*  85115 */   GIR_EraseRootFromParent_Done,
     /*  85116 */ // Label 1459: @85116
     /*  85116 */ GIM_Try, /*On fail goto*//*Label 1460*/ GIMT_Encode4(85148), // Rule ID 6654 //
     /*  85121 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  85127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85131 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85135 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  85135 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85138 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85140 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85142 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85147 */   // GIR_Coverage, 6654,
     /*  85147 */   GIR_EraseRootFromParent_Done,
     /*  85148 */ // Label 1460: @85148
     /*  85148 */ GIM_Try, /*On fail goto*//*Label 1461*/ GIMT_Encode4(85180), // Rule ID 6655 //
     /*  85153 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  85159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85163 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85167 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  85167 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85170 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85172 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85174 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85179 */   // GIR_Coverage, 6655,
     /*  85179 */   GIR_EraseRootFromParent_Done,
     /*  85180 */ // Label 1461: @85180
     /*  85180 */ GIM_Try, /*On fail goto*//*Label 1462*/ GIMT_Encode4(85206), // Rule ID 6656 //
     /*  85185 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  85188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  85191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85195 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85199 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)
     /*  85199 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  85204 */   GIR_RootConstrainSelectedInstOperands,
     /*  85205 */   // GIR_Coverage, 6656,
     /*  85205 */   GIR_Done,
     /*  85206 */ // Label 1462: @85206
     /*  85206 */ GIM_Try, /*On fail goto*//*Label 1463*/ GIMT_Encode4(85232), // Rule ID 6657 //
     /*  85211 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  85214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  85217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85221 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85225 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)
     /*  85225 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  85230 */   GIR_RootConstrainSelectedInstOperands,
     /*  85231 */   // GIR_Coverage, 6657,
     /*  85231 */   GIR_Done,
     /*  85232 */ // Label 1463: @85232
     /*  85232 */ GIM_Try, /*On fail goto*//*Label 1464*/ GIMT_Encode4(85258), // Rule ID 6658 //
     /*  85237 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  85240 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  85243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85247 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85251 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)
     /*  85251 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  85256 */   GIR_RootConstrainSelectedInstOperands,
     /*  85257 */   // GIR_Coverage, 6658,
     /*  85257 */   GIR_Done,
     /*  85258 */ // Label 1464: @85258
     /*  85258 */ GIM_Try, /*On fail goto*//*Label 1465*/ GIMT_Encode4(85284), // Rule ID 6659 //
     /*  85263 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  85266 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  85269 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85273 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85277 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)
     /*  85277 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  85282 */   GIR_RootConstrainSelectedInstOperands,
     /*  85283 */   // GIR_Coverage, 6659,
     /*  85283 */   GIR_Done,
     /*  85284 */ // Label 1465: @85284
     /*  85284 */ GIM_Try, /*On fail goto*//*Label 1466*/ GIMT_Encode4(85310), // Rule ID 6660 //
     /*  85289 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  85292 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  85295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85299 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85303 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)
     /*  85303 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  85308 */   GIR_RootConstrainSelectedInstOperands,
     /*  85309 */   // GIR_Coverage, 6660,
     /*  85309 */   GIR_Done,
     /*  85310 */ // Label 1466: @85310
     /*  85310 */ GIM_Try, /*On fail goto*//*Label 1467*/ GIMT_Encode4(85339), // Rule ID 6661 //
     /*  85315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  85318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85322 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85326 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  85326 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85329 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85331 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85333 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85338 */   // GIR_Coverage, 6661,
     /*  85338 */   GIR_EraseRootFromParent_Done,
     /*  85339 */ // Label 1467: @85339
     /*  85339 */ GIM_Try, /*On fail goto*//*Label 1468*/ GIMT_Encode4(85368), // Rule ID 6662 //
     /*  85344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  85347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85351 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85355 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  85355 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85358 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85360 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85362 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85367 */   // GIR_Coverage, 6662,
     /*  85367 */   GIR_EraseRootFromParent_Done,
     /*  85368 */ // Label 1468: @85368
     /*  85368 */ GIM_Try, /*On fail goto*//*Label 1469*/ GIMT_Encode4(85400), // Rule ID 6663 //
     /*  85373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  85379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85383 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85387 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  85387 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85390 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85392 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85394 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85399 */   // GIR_Coverage, 6663,
     /*  85399 */   GIR_EraseRootFromParent_Done,
     /*  85400 */ // Label 1469: @85400
     /*  85400 */ GIM_Try, /*On fail goto*//*Label 1470*/ GIMT_Encode4(85432), // Rule ID 6664 //
     /*  85405 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  85411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85415 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85419 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  85419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85422 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85424 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85426 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85431 */   // GIR_Coverage, 6664,
     /*  85431 */   GIR_EraseRootFromParent_Done,
     /*  85432 */ // Label 1470: @85432
     /*  85432 */ GIM_Try, /*On fail goto*//*Label 1471*/ GIMT_Encode4(85464), // Rule ID 6665 //
     /*  85437 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  85443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85447 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85451 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  85451 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85454 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85456 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85458 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85463 */   // GIR_Coverage, 6665,
     /*  85463 */   GIR_EraseRootFromParent_Done,
     /*  85464 */ // Label 1471: @85464
     /*  85464 */ GIM_Try, /*On fail goto*//*Label 1472*/ GIMT_Encode4(85496), // Rule ID 6666 //
     /*  85469 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85472 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  85475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85479 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85483 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  85483 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85486 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85488 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85490 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85495 */   // GIR_Coverage, 6666,
     /*  85495 */   GIR_EraseRootFromParent_Done,
     /*  85496 */ // Label 1472: @85496
     /*  85496 */ GIM_Try, /*On fail goto*//*Label 1473*/ GIMT_Encode4(85528), // Rule ID 6667 //
     /*  85501 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85504 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  85507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85511 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85515 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  85515 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85518 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85520 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85522 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85527 */   // GIR_Coverage, 6667,
     /*  85527 */   GIR_EraseRootFromParent_Done,
     /*  85528 */ // Label 1473: @85528
     /*  85528 */ GIM_Try, /*On fail goto*//*Label 1474*/ GIMT_Encode4(85554), // Rule ID 6668 //
     /*  85533 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  85536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  85539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85543 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85547 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)
     /*  85547 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  85552 */   GIR_RootConstrainSelectedInstOperands,
     /*  85553 */   // GIR_Coverage, 6668,
     /*  85553 */   GIR_Done,
     /*  85554 */ // Label 1474: @85554
     /*  85554 */ GIM_Try, /*On fail goto*//*Label 1475*/ GIMT_Encode4(85580), // Rule ID 6669 //
     /*  85559 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  85562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  85565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85569 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85573 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)
     /*  85573 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  85578 */   GIR_RootConstrainSelectedInstOperands,
     /*  85579 */   // GIR_Coverage, 6669,
     /*  85579 */   GIR_Done,
     /*  85580 */ // Label 1475: @85580
     /*  85580 */ GIM_Try, /*On fail goto*//*Label 1476*/ GIMT_Encode4(85606), // Rule ID 6670 //
     /*  85585 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  85588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  85591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85595 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85599 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)
     /*  85599 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  85604 */   GIR_RootConstrainSelectedInstOperands,
     /*  85605 */   // GIR_Coverage, 6670,
     /*  85605 */   GIR_Done,
     /*  85606 */ // Label 1476: @85606
     /*  85606 */ GIM_Try, /*On fail goto*//*Label 1477*/ GIMT_Encode4(85632), // Rule ID 6671 //
     /*  85611 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  85614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  85617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85621 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85625 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)
     /*  85625 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  85630 */   GIR_RootConstrainSelectedInstOperands,
     /*  85631 */   // GIR_Coverage, 6671,
     /*  85631 */   GIR_Done,
     /*  85632 */ // Label 1477: @85632
     /*  85632 */ GIM_Try, /*On fail goto*//*Label 1478*/ GIMT_Encode4(85658), // Rule ID 6672 //
     /*  85637 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  85640 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  85643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85647 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85651 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)
     /*  85651 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  85656 */   GIR_RootConstrainSelectedInstOperands,
     /*  85657 */   // GIR_Coverage, 6672,
     /*  85657 */   GIR_Done,
     /*  85658 */ // Label 1478: @85658
     /*  85658 */ GIM_Try, /*On fail goto*//*Label 1479*/ GIMT_Encode4(85687), // Rule ID 6673 //
     /*  85663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  85666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85670 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85674 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  85674 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85677 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85679 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85681 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85686 */   // GIR_Coverage, 6673,
     /*  85686 */   GIR_EraseRootFromParent_Done,
     /*  85687 */ // Label 1479: @85687
     /*  85687 */ GIM_Try, /*On fail goto*//*Label 1480*/ GIMT_Encode4(85716), // Rule ID 6674 //
     /*  85692 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  85695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85699 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85703 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  85703 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85706 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85708 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85710 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85715 */   // GIR_Coverage, 6674,
     /*  85715 */   GIR_EraseRootFromParent_Done,
     /*  85716 */ // Label 1480: @85716
     /*  85716 */ GIM_Reject,
     /*  85717 */ // Label 1402: @85717
     /*  85717 */ GIM_Try, /*On fail goto*//*Label 1481*/ GIMT_Encode4(85749), // Rule ID 6688 //
     /*  85722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  85728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85732 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85736 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  85736 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85739 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85741 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85743 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85748 */   // GIR_Coverage, 6688,
     /*  85748 */   GIR_EraseRootFromParent_Done,
     /*  85749 */ // Label 1481: @85749
     /*  85749 */ GIM_Try, /*On fail goto*//*Label 1482*/ GIMT_Encode4(85781), // Rule ID 6689 //
     /*  85754 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  85760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85764 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85768 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  85768 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85771 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85773 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85775 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85780 */   // GIR_Coverage, 6689,
     /*  85780 */   GIR_EraseRootFromParent_Done,
     /*  85781 */ // Label 1482: @85781
     /*  85781 */ GIM_Try, /*On fail goto*//*Label 1483*/ GIMT_Encode4(85813), // Rule ID 6690 //
     /*  85786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85796 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85800 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  85800 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85803 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85805 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85807 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85812 */   // GIR_Coverage, 6690,
     /*  85812 */   GIR_EraseRootFromParent_Done,
     /*  85813 */ // Label 1483: @85813
     /*  85813 */ GIM_Try, /*On fail goto*//*Label 1484*/ GIMT_Encode4(85845), // Rule ID 6691 //
     /*  85818 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  85824 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85828 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85832 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  85832 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85835 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85837 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85839 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85844 */   // GIR_Coverage, 6691,
     /*  85844 */   GIR_EraseRootFromParent_Done,
     /*  85845 */ // Label 1484: @85845
     /*  85845 */ GIM_Try, /*On fail goto*//*Label 1485*/ GIMT_Encode4(85877), // Rule ID 6692 //
     /*  85850 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85853 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  85856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85860 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85864 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  85864 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85867 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85869 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85871 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85876 */   // GIR_Coverage, 6692,
     /*  85876 */   GIR_EraseRootFromParent_Done,
     /*  85877 */ // Label 1485: @85877
     /*  85877 */ GIM_Try, /*On fail goto*//*Label 1486*/ GIMT_Encode4(85909), // Rule ID 6693 //
     /*  85882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85892 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85896 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  85896 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85899 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85901 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85903 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85908 */   // GIR_Coverage, 6693,
     /*  85908 */   GIR_EraseRootFromParent_Done,
     /*  85909 */ // Label 1486: @85909
     /*  85909 */ GIM_Try, /*On fail goto*//*Label 1487*/ GIMT_Encode4(85941), // Rule ID 6694 //
     /*  85914 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  85917 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  85920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85924 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85928 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  85928 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85931 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  85933 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85935 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85940 */   // GIR_Coverage, 6694,
     /*  85940 */   GIR_EraseRootFromParent_Done,
     /*  85941 */ // Label 1487: @85941
     /*  85941 */ GIM_Try, /*On fail goto*//*Label 1488*/ GIMT_Encode4(85974), // Rule ID 6695 //
     /*  85946 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  85949 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  85952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85956 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85960 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2i64] }:$src)  =>  (EXTv16i8:{ *:[f128] } FPR128:{ *:[v2i64] }:$src, FPR128:{ *:[v2i64] }:$src, 8:{ *:[i32] })
     /*  85960 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  85963 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  85965 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85967 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  85969 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  85972 */   GIR_RootConstrainSelectedInstOperands,
     /*  85973 */   // GIR_Coverage, 6695,
     /*  85973 */   GIR_EraseRootFromParent_Done,
     /*  85974 */ // Label 1488: @85974
     /*  85974 */ GIM_Try, /*On fail goto*//*Label 1489*/ GIMT_Encode4(86045), // Rule ID 6696 //
     /*  85979 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  85982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  85985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85989 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85993 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4i32] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4i32] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4i32] }:$src), 8:{ *:[i32] })
     /*  85993 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  85996 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  86000 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86005 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  86009 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  86011 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  86014 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  86018 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86023 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  86027 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  86029 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  86032 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86034 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86037 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  86040 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  86043 */   GIR_RootConstrainSelectedInstOperands,
     /*  86044 */   // GIR_Coverage, 6696,
     /*  86044 */   GIR_EraseRootFromParent_Done,
     /*  86045 */ // Label 1489: @86045
     /*  86045 */ GIM_Try, /*On fail goto*//*Label 1490*/ GIMT_Encode4(86116), // Rule ID 6697 //
     /*  86050 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  86053 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  86056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86060 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86064 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8i16] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8i16] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8i16] }:$src), 8:{ *:[i32] })
     /*  86064 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  86067 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  86071 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86076 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  86080 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  86082 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  86085 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  86089 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86094 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  86098 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  86100 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  86103 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86105 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86108 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  86111 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  86114 */   GIR_RootConstrainSelectedInstOperands,
     /*  86115 */   // GIR_Coverage, 6697,
     /*  86115 */   GIR_EraseRootFromParent_Done,
     /*  86116 */ // Label 1490: @86116
     /*  86116 */ GIM_Try, /*On fail goto*//*Label 1491*/ GIMT_Encode4(86187), // Rule ID 6698 //
     /*  86121 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  86124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  86127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86131 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86135 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8f16] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8f16] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8f16] }:$src), 8:{ *:[i32] })
     /*  86135 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  86138 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  86142 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86147 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  86151 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  86153 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  86156 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  86160 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86165 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  86169 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  86171 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  86174 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86176 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86179 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  86182 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  86185 */   GIR_RootConstrainSelectedInstOperands,
     /*  86186 */   // GIR_Coverage, 6698,
     /*  86186 */   GIR_EraseRootFromParent_Done,
     /*  86187 */ // Label 1491: @86187
     /*  86187 */ GIM_Try, /*On fail goto*//*Label 1492*/ GIMT_Encode4(86220), // Rule ID 6699 //
     /*  86192 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  86195 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  86198 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86202 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86206 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2f64] }:$src)  =>  (EXTv16i8:{ *:[f128] } FPR128:{ *:[v2f64] }:$src, FPR128:{ *:[v2f64] }:$src, 8:{ *:[i32] })
     /*  86206 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  86209 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86211 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  86213 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  86215 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  86218 */   GIR_RootConstrainSelectedInstOperands,
     /*  86219 */   // GIR_Coverage, 6699,
     /*  86219 */   GIR_EraseRootFromParent_Done,
     /*  86220 */ // Label 1492: @86220
     /*  86220 */ GIM_Try, /*On fail goto*//*Label 1493*/ GIMT_Encode4(86291), // Rule ID 6700 //
     /*  86225 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  86228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  86231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86235 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86239 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4f32] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4f32] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4f32] }:$src), 8:{ *:[i32] })
     /*  86239 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  86242 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  86246 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86251 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  86255 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  86257 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  86260 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  86264 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86269 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  86273 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  86275 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  86278 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86280 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86283 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  86286 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  86289 */   GIR_RootConstrainSelectedInstOperands,
     /*  86290 */   // GIR_Coverage, 6700,
     /*  86290 */   GIR_EraseRootFromParent_Done,
     /*  86291 */ // Label 1493: @86291
     /*  86291 */ GIM_Try, /*On fail goto*//*Label 1494*/ GIMT_Encode4(86362), // Rule ID 6701 //
     /*  86296 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  86299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  86302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86306 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86310 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v16i8] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v16i8:{ *:[f128] } FPR128:{ *:[v16i8] }:$src), (REV64v16i8:{ *:[f128] } FPR128:{ *:[v16i8] }:$src), 8:{ *:[i32] })
     /*  86310 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  86313 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  86317 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86322 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  86326 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  86328 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  86331 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  86335 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86340 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  86344 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  86346 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  86349 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86351 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86354 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  86357 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  86360 */   GIR_RootConstrainSelectedInstOperands,
     /*  86361 */   // GIR_Coverage, 6701,
     /*  86361 */   GIR_EraseRootFromParent_Done,
     /*  86362 */ // Label 1494: @86362
     /*  86362 */ GIM_Reject,
     /*  86363 */ // Label 1403: @86363
     /*  86363 */ GIM_Try, /*On fail goto*//*Label 1495*/ GIMT_Encode4(86393), // Rule ID 6553 //
     /*  86368 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  86371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  86374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86378 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  86382 */   // (bitconvert:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  86382 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86387 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86392 */   // GIR_Coverage, 6553,
     /*  86392 */   GIR_Done,
     /*  86393 */ // Label 1495: @86393
     /*  86393 */ GIM_Try, /*On fail goto*//*Label 1496*/ GIMT_Encode4(86423), // Rule ID 6555 //
     /*  86398 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  86401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  86404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  86412 */   // (bitconvert:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  86412 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86417 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86422 */   // GIR_Coverage, 6555,
     /*  86422 */   GIR_Done,
     /*  86423 */ // Label 1496: @86423
     /*  86423 */ GIM_Try, /*On fail goto*//*Label 1497*/ GIMT_Encode4(86473), // Rule ID 6564 //
     /*  86428 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  86431 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  86434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86438 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  86442 */   // (bitconvert:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v2i32:{ *:[v2i32] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /*  86442 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  86445 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86449 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86454 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /*  86458 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86463 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  86466 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86468 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86471 */   GIR_RootConstrainSelectedInstOperands,
     /*  86472 */   // GIR_Coverage, 6564,
     /*  86472 */   GIR_EraseRootFromParent_Done,
     /*  86473 */ // Label 1497: @86473
     /*  86473 */ GIM_Try, /*On fail goto*//*Label 1498*/ GIMT_Encode4(86523), // Rule ID 6566 //
     /*  86478 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  86481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  86484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86488 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  86492 */   // (bitconvert:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v2i32:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /*  86492 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  86495 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86499 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86504 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /*  86508 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86513 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  86516 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86518 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86521 */   GIR_RootConstrainSelectedInstOperands,
     /*  86522 */   // GIR_Coverage, 6566,
     /*  86522 */   GIR_EraseRootFromParent_Done,
     /*  86523 */ // Label 1498: @86523
     /*  86523 */ GIM_Try, /*On fail goto*//*Label 1499*/ GIMT_Encode4(86555), // Rule ID 6598 //
     /*  86528 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  86531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  86534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86538 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86542 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  86542 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86545 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  86547 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  86549 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86554 */   // GIR_Coverage, 6598,
     /*  86554 */   GIR_EraseRootFromParent_Done,
     /*  86555 */ // Label 1499: @86555
     /*  86555 */ GIM_Try, /*On fail goto*//*Label 1500*/ GIMT_Encode4(86587), // Rule ID 6599 //
     /*  86560 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  86563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  86566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86570 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86574 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  86574 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86577 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  86579 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  86581 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86586 */   // GIR_Coverage, 6599,
     /*  86586 */   GIR_EraseRootFromParent_Done,
     /*  86587 */ // Label 1500: @86587
     /*  86587 */ GIM_Try, /*On fail goto*//*Label 1501*/ GIMT_Encode4(86619), // Rule ID 6600 //
     /*  86592 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  86595 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  86598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86602 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86606 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  86606 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86609 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  86611 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  86613 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86618 */   // GIR_Coverage, 6600,
     /*  86618 */   GIR_EraseRootFromParent_Done,
     /*  86619 */ // Label 1501: @86619
     /*  86619 */ GIM_Try, /*On fail goto*//*Label 1502*/ GIMT_Encode4(86651), // Rule ID 6601 //
     /*  86624 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  86627 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  86630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86634 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86638 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  86638 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86641 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  86643 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  86645 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86650 */   // GIR_Coverage, 6601,
     /*  86650 */   GIR_EraseRootFromParent_Done,
     /*  86651 */ // Label 1502: @86651
     /*  86651 */ GIM_Try, /*On fail goto*//*Label 1503*/ GIMT_Encode4(86683), // Rule ID 6602 //
     /*  86656 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  86659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  86662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86666 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86670 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  86670 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86673 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  86675 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  86677 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86682 */   // GIR_Coverage, 6602,
     /*  86682 */   GIR_EraseRootFromParent_Done,
     /*  86683 */ // Label 1503: @86683
     /*  86683 */ GIM_Try, /*On fail goto*//*Label 1504*/ GIMT_Encode4(86715), // Rule ID 6603 //
     /*  86688 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  86691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  86694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86698 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86702 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  86702 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86705 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  86707 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  86709 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86714 */   // GIR_Coverage, 6603,
     /*  86714 */   GIR_EraseRootFromParent_Done,
     /*  86715 */ // Label 1504: @86715
     /*  86715 */ GIM_Try, /*On fail goto*//*Label 1505*/ GIMT_Encode4(86741), // Rule ID 6604 //
     /*  86720 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  86723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  86726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86730 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86734 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)
     /*  86734 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  86739 */   GIR_RootConstrainSelectedInstOperands,
     /*  86740 */   // GIR_Coverage, 6604,
     /*  86740 */   GIR_Done,
     /*  86741 */ // Label 1505: @86741
     /*  86741 */ GIM_Try, /*On fail goto*//*Label 1506*/ GIMT_Encode4(86767), // Rule ID 6605 //
     /*  86746 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  86749 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  86752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86756 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86760 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)  =>  (REV32v4i16:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)
     /*  86760 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  86765 */   GIR_RootConstrainSelectedInstOperands,
     /*  86766 */   // GIR_Coverage, 6605,
     /*  86766 */   GIR_Done,
     /*  86767 */ // Label 1506: @86767
     /*  86767 */ GIM_Try, /*On fail goto*//*Label 1507*/ GIMT_Encode4(86793), // Rule ID 6606 //
     /*  86772 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  86775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  86778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86782 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86786 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)  =>  (REV32v8i8:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)
     /*  86786 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /*  86791 */   GIR_RootConstrainSelectedInstOperands,
     /*  86792 */   // GIR_Coverage, 6606,
     /*  86792 */   GIR_Done,
     /*  86793 */ // Label 1507: @86793
     /*  86793 */ GIM_Try, /*On fail goto*//*Label 1508*/ GIMT_Encode4(86819), // Rule ID 6607 //
     /*  86798 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  86801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  86804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86808 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86812 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)
     /*  86812 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  86817 */   GIR_RootConstrainSelectedInstOperands,
     /*  86818 */   // GIR_Coverage, 6607,
     /*  86818 */   GIR_Done,
     /*  86819 */ // Label 1508: @86819
     /*  86819 */ GIM_Try, /*On fail goto*//*Label 1509*/ GIMT_Encode4(86845), // Rule ID 6608 //
     /*  86824 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  86827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  86830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86834 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86838 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)
     /*  86838 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  86843 */   GIR_RootConstrainSelectedInstOperands,
     /*  86844 */   // GIR_Coverage, 6608,
     /*  86844 */   GIR_Done,
     /*  86845 */ // Label 1509: @86845
     /*  86845 */ GIM_Try, /*On fail goto*//*Label 1510*/ GIMT_Encode4(86871), // Rule ID 6609 //
     /*  86850 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  86853 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  86856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86860 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86864 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)  =>  (REV32v4i16:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)
     /*  86864 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  86869 */   GIR_RootConstrainSelectedInstOperands,
     /*  86870 */   // GIR_Coverage, 6609,
     /*  86870 */   GIR_Done,
     /*  86871 */ // Label 1510: @86871
     /*  86871 */ GIM_Try, /*On fail goto*//*Label 1511*/ GIMT_Encode4(86900), // Rule ID 6610 //
     /*  86876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  86879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86883 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86887 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  86887 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86890 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  86892 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  86894 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86899 */   // GIR_Coverage, 6610,
     /*  86899 */   GIR_EraseRootFromParent_Done,
     /*  86900 */ // Label 1511: @86900
     /*  86900 */ GIM_Try, /*On fail goto*//*Label 1512*/ GIMT_Encode4(86932), // Rule ID 6675 //
     /*  86905 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  86908 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  86911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86915 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86919 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  86919 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86922 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  86924 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  86926 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86931 */   // GIR_Coverage, 6675,
     /*  86931 */   GIR_EraseRootFromParent_Done,
     /*  86932 */ // Label 1512: @86932
     /*  86932 */ GIM_Try, /*On fail goto*//*Label 1513*/ GIMT_Encode4(86964), // Rule ID 6676 //
     /*  86937 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  86940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  86943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86947 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86951 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  86951 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86954 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  86956 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  86958 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86963 */   // GIR_Coverage, 6676,
     /*  86963 */   GIR_EraseRootFromParent_Done,
     /*  86964 */ // Label 1513: @86964
     /*  86964 */ GIM_Try, /*On fail goto*//*Label 1514*/ GIMT_Encode4(86996), // Rule ID 6677 //
     /*  86969 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  86972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  86975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86979 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86983 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  86983 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86986 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  86988 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  86990 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86995 */   // GIR_Coverage, 6677,
     /*  86995 */   GIR_EraseRootFromParent_Done,
     /*  86996 */ // Label 1514: @86996
     /*  86996 */ GIM_Try, /*On fail goto*//*Label 1515*/ GIMT_Encode4(87028), // Rule ID 6678 //
     /*  87001 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  87007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87011 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87015 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  87015 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87018 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87020 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87022 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87027 */   // GIR_Coverage, 6678,
     /*  87027 */   GIR_EraseRootFromParent_Done,
     /*  87028 */ // Label 1515: @87028
     /*  87028 */ GIM_Try, /*On fail goto*//*Label 1516*/ GIMT_Encode4(87060), // Rule ID 6679 //
     /*  87033 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87036 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  87039 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87043 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87047 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  87047 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87050 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87052 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87054 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87059 */   // GIR_Coverage, 6679,
     /*  87059 */   GIR_EraseRootFromParent_Done,
     /*  87060 */ // Label 1516: @87060
     /*  87060 */ GIM_Try, /*On fail goto*//*Label 1517*/ GIMT_Encode4(87092), // Rule ID 6680 //
     /*  87065 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87068 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  87071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87075 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87079 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  87079 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87082 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87084 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87086 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87091 */   // GIR_Coverage, 6680,
     /*  87091 */   GIR_EraseRootFromParent_Done,
     /*  87092 */ // Label 1517: @87092
     /*  87092 */ GIM_Try, /*On fail goto*//*Label 1518*/ GIMT_Encode4(87118), // Rule ID 6681 //
     /*  87097 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  87103 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87107 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87111 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)
     /*  87111 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  87116 */   GIR_RootConstrainSelectedInstOperands,
     /*  87117 */   // GIR_Coverage, 6681,
     /*  87117 */   GIR_Done,
     /*  87118 */ // Label 1518: @87118
     /*  87118 */ GIM_Try, /*On fail goto*//*Label 1519*/ GIMT_Encode4(87144), // Rule ID 6682 //
     /*  87123 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87126 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  87129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87133 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87137 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)  =>  (REV32v4i16:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)
     /*  87137 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  87142 */   GIR_RootConstrainSelectedInstOperands,
     /*  87143 */   // GIR_Coverage, 6682,
     /*  87143 */   GIR_Done,
     /*  87144 */ // Label 1519: @87144
     /*  87144 */ GIM_Try, /*On fail goto*//*Label 1520*/ GIMT_Encode4(87170), // Rule ID 6683 //
     /*  87149 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  87155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87159 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87163 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)  =>  (REV32v8i8:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)
     /*  87163 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /*  87168 */   GIR_RootConstrainSelectedInstOperands,
     /*  87169 */   // GIR_Coverage, 6683,
     /*  87169 */   GIR_Done,
     /*  87170 */ // Label 1520: @87170
     /*  87170 */ GIM_Try, /*On fail goto*//*Label 1521*/ GIMT_Encode4(87196), // Rule ID 6684 //
     /*  87175 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  87181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87185 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87189 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)
     /*  87189 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  87194 */   GIR_RootConstrainSelectedInstOperands,
     /*  87195 */   // GIR_Coverage, 6684,
     /*  87195 */   GIR_Done,
     /*  87196 */ // Label 1521: @87196
     /*  87196 */ GIM_Try, /*On fail goto*//*Label 1522*/ GIMT_Encode4(87222), // Rule ID 6685 //
     /*  87201 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87204 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  87207 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87211 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87215 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)
     /*  87215 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  87220 */   GIR_RootConstrainSelectedInstOperands,
     /*  87221 */   // GIR_Coverage, 6685,
     /*  87221 */   GIR_Done,
     /*  87222 */ // Label 1522: @87222
     /*  87222 */ GIM_Try, /*On fail goto*//*Label 1523*/ GIMT_Encode4(87248), // Rule ID 6686 //
     /*  87227 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87230 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  87233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87237 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87241 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)  =>  (REV32v4i16:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)
     /*  87241 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  87246 */   GIR_RootConstrainSelectedInstOperands,
     /*  87247 */   // GIR_Coverage, 6686,
     /*  87247 */   GIR_Done,
     /*  87248 */ // Label 1523: @87248
     /*  87248 */ GIM_Try, /*On fail goto*//*Label 1524*/ GIMT_Encode4(87277), // Rule ID 6687 //
     /*  87253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  87256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87260 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87264 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  87264 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87267 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87269 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87271 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87276 */   // GIR_Coverage, 6687,
     /*  87276 */   GIR_EraseRootFromParent_Done,
     /*  87277 */ // Label 1524: @87277
     /*  87277 */ GIM_Reject,
     /*  87278 */ // Label 1404: @87278
     /*  87278 */ GIM_Try, /*On fail goto*//*Label 1525*/ GIMT_Encode4(87310), // Rule ID 6702 //
     /*  87283 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87286 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  87289 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87293 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87297 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  87297 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87300 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87302 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87304 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87309 */   // GIR_Coverage, 6702,
     /*  87309 */   GIR_EraseRootFromParent_Done,
     /*  87310 */ // Label 1525: @87310
     /*  87310 */ GIM_Try, /*On fail goto*//*Label 1526*/ GIMT_Encode4(87342), // Rule ID 6703 //
     /*  87315 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  87321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87325 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87329 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  87329 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87332 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87334 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87336 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87341 */   // GIR_Coverage, 6703,
     /*  87341 */   GIR_EraseRootFromParent_Done,
     /*  87342 */ // Label 1526: @87342
     /*  87342 */ GIM_Try, /*On fail goto*//*Label 1527*/ GIMT_Encode4(87374), // Rule ID 6704 //
     /*  87347 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87350 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  87353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87357 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87361 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  87361 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87364 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87366 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87368 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87373 */   // GIR_Coverage, 6704,
     /*  87373 */   GIR_EraseRootFromParent_Done,
     /*  87374 */ // Label 1527: @87374
     /*  87374 */ GIM_Try, /*On fail goto*//*Label 1528*/ GIMT_Encode4(87406), // Rule ID 6705 //
     /*  87379 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  87385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87389 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87393 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  87393 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87396 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87398 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87400 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87405 */   // GIR_Coverage, 6705,
     /*  87405 */   GIR_EraseRootFromParent_Done,
     /*  87406 */ // Label 1528: @87406
     /*  87406 */ GIM_Try, /*On fail goto*//*Label 1529*/ GIMT_Encode4(87438), // Rule ID 6706 //
     /*  87411 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87414 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  87417 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87421 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87425 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  87425 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87428 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87430 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87432 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87437 */   // GIR_Coverage, 6706,
     /*  87437 */   GIR_EraseRootFromParent_Done,
     /*  87438 */ // Label 1529: @87438
     /*  87438 */ GIM_Try, /*On fail goto*//*Label 1530*/ GIMT_Encode4(87470), // Rule ID 6707 //
     /*  87443 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87446 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  87449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87453 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87457 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  87457 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87460 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87462 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87464 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87469 */   // GIR_Coverage, 6707,
     /*  87469 */   GIR_EraseRootFromParent_Done,
     /*  87470 */ // Label 1530: @87470
     /*  87470 */ GIM_Try, /*On fail goto*//*Label 1531*/ GIMT_Encode4(87503), // Rule ID 6708 //
     /*  87475 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  87481 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87485 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87489 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v2f64] } FPR128:{ *:[f128] }:$src, FPR128:{ *:[f128] }:$src, 8:{ *:[i32] })
     /*  87489 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  87492 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87494 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87496 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87498 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  87501 */   GIR_RootConstrainSelectedInstOperands,
     /*  87502 */   // GIR_Coverage, 6708,
     /*  87502 */   GIR_EraseRootFromParent_Done,
     /*  87503 */ // Label 1531: @87503
     /*  87503 */ GIM_Try, /*On fail goto*//*Label 1532*/ GIMT_Encode4(87529), // Rule ID 6709 //
     /*  87508 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87511 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  87514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87518 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87522 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)  =>  (REV64v4i32:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)
     /*  87522 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  87527 */   GIR_RootConstrainSelectedInstOperands,
     /*  87528 */   // GIR_Coverage, 6709,
     /*  87528 */   GIR_Done,
     /*  87529 */ // Label 1532: @87529
     /*  87529 */ GIM_Try, /*On fail goto*//*Label 1533*/ GIMT_Encode4(87555), // Rule ID 6710 //
     /*  87534 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87537 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  87540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87544 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87548 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)  =>  (REV64v8i16:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)
     /*  87548 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  87553 */   GIR_RootConstrainSelectedInstOperands,
     /*  87554 */   // GIR_Coverage, 6710,
     /*  87554 */   GIR_Done,
     /*  87555 */ // Label 1533: @87555
     /*  87555 */ GIM_Try, /*On fail goto*//*Label 1534*/ GIMT_Encode4(87581), // Rule ID 6711 //
     /*  87560 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  87566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87570 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87574 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)  =>  (REV64v8i16:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)
     /*  87574 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  87579 */   GIR_RootConstrainSelectedInstOperands,
     /*  87580 */   // GIR_Coverage, 6711,
     /*  87580 */   GIR_Done,
     /*  87581 */ // Label 1534: @87581
     /*  87581 */ GIM_Try, /*On fail goto*//*Label 1535*/ GIMT_Encode4(87607), // Rule ID 6712 //
     /*  87586 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87589 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  87592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87596 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87600 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)  =>  (REV64v16i8:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)
     /*  87600 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  87605 */   GIR_RootConstrainSelectedInstOperands,
     /*  87606 */   // GIR_Coverage, 6712,
     /*  87606 */   GIR_Done,
     /*  87607 */ // Label 1535: @87607
     /*  87607 */ GIM_Try, /*On fail goto*//*Label 1536*/ GIMT_Encode4(87633), // Rule ID 6713 //
     /*  87612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  87618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87622 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87626 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)  =>  (REV64v4i32:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)
     /*  87626 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  87631 */   GIR_RootConstrainSelectedInstOperands,
     /*  87632 */   // GIR_Coverage, 6713,
     /*  87632 */   GIR_Done,
     /*  87633 */ // Label 1536: @87633
     /*  87633 */ GIM_Try, /*On fail goto*//*Label 1537*/ GIMT_Encode4(87662), // Rule ID 6714 //
     /*  87638 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  87641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87645 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87649 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  87649 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87652 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87654 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87656 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87661 */   // GIR_Coverage, 6714,
     /*  87661 */   GIR_EraseRootFromParent_Done,
     /*  87662 */ // Label 1537: @87662
     /*  87662 */ GIM_Try, /*On fail goto*//*Label 1538*/ GIMT_Encode4(87694), // Rule ID 6728 //
     /*  87667 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87670 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  87673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87677 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87681 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  87681 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87684 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87686 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87688 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87693 */   // GIR_Coverage, 6728,
     /*  87693 */   GIR_EraseRootFromParent_Done,
     /*  87694 */ // Label 1538: @87694
     /*  87694 */ GIM_Try, /*On fail goto*//*Label 1539*/ GIMT_Encode4(87726), // Rule ID 6729 //
     /*  87699 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  87705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87709 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87713 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  87713 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87716 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87718 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87720 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87725 */   // GIR_Coverage, 6729,
     /*  87725 */   GIR_EraseRootFromParent_Done,
     /*  87726 */ // Label 1539: @87726
     /*  87726 */ GIM_Try, /*On fail goto*//*Label 1540*/ GIMT_Encode4(87758), // Rule ID 6730 //
     /*  87731 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87734 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  87737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87741 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87745 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  87745 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87748 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87750 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87752 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87757 */   // GIR_Coverage, 6730,
     /*  87757 */   GIR_EraseRootFromParent_Done,
     /*  87758 */ // Label 1540: @87758
     /*  87758 */ GIM_Try, /*On fail goto*//*Label 1541*/ GIMT_Encode4(87790), // Rule ID 6731 //
     /*  87763 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  87769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87773 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87777 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  87777 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87780 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87782 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87784 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87789 */   // GIR_Coverage, 6731,
     /*  87789 */   GIR_EraseRootFromParent_Done,
     /*  87790 */ // Label 1541: @87790
     /*  87790 */ GIM_Try, /*On fail goto*//*Label 1542*/ GIMT_Encode4(87822), // Rule ID 6732 //
     /*  87795 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87798 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  87801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87805 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87809 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  87809 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87812 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87814 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87816 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87821 */   // GIR_Coverage, 6732,
     /*  87821 */   GIR_EraseRootFromParent_Done,
     /*  87822 */ // Label 1542: @87822
     /*  87822 */ GIM_Try, /*On fail goto*//*Label 1543*/ GIMT_Encode4(87854), // Rule ID 6733 //
     /*  87827 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  87833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87837 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87841 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  87841 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87844 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87846 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87848 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87853 */   // GIR_Coverage, 6733,
     /*  87853 */   GIR_EraseRootFromParent_Done,
     /*  87854 */ // Label 1543: @87854
     /*  87854 */ GIM_Try, /*On fail goto*//*Label 1544*/ GIMT_Encode4(87887), // Rule ID 6734 //
     /*  87859 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  87865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87869 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87873 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v2i64] } FPR128:{ *:[f128] }:$src, FPR128:{ *:[f128] }:$src, 8:{ *:[i32] })
     /*  87873 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  87876 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87878 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87880 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87882 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  87885 */   GIR_RootConstrainSelectedInstOperands,
     /*  87886 */   // GIR_Coverage, 6734,
     /*  87886 */   GIR_EraseRootFromParent_Done,
     /*  87887 */ // Label 1544: @87887
     /*  87887 */ GIM_Try, /*On fail goto*//*Label 1545*/ GIMT_Encode4(87913), // Rule ID 6735 //
     /*  87892 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87895 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  87898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87902 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87906 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)  =>  (REV64v4i32:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)
     /*  87906 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  87911 */   GIR_RootConstrainSelectedInstOperands,
     /*  87912 */   // GIR_Coverage, 6735,
     /*  87912 */   GIR_Done,
     /*  87913 */ // Label 1545: @87913
     /*  87913 */ GIM_Try, /*On fail goto*//*Label 1546*/ GIMT_Encode4(87939), // Rule ID 6736 //
     /*  87918 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  87924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87928 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87932 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)  =>  (REV64v8i16:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)
     /*  87932 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  87937 */   GIR_RootConstrainSelectedInstOperands,
     /*  87938 */   // GIR_Coverage, 6736,
     /*  87938 */   GIR_Done,
     /*  87939 */ // Label 1546: @87939
     /*  87939 */ GIM_Try, /*On fail goto*//*Label 1547*/ GIMT_Encode4(87965), // Rule ID 6737 //
     /*  87944 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  87950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87954 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87958 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)  =>  (REV64v16i8:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)
     /*  87958 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  87963 */   GIR_RootConstrainSelectedInstOperands,
     /*  87964 */   // GIR_Coverage, 6737,
     /*  87964 */   GIR_Done,
     /*  87965 */ // Label 1547: @87965
     /*  87965 */ GIM_Try, /*On fail goto*//*Label 1548*/ GIMT_Encode4(87991), // Rule ID 6738 //
     /*  87970 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87973 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  87976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87980 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87984 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)  =>  (REV64v4i32:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)
     /*  87984 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  87989 */   GIR_RootConstrainSelectedInstOperands,
     /*  87990 */   // GIR_Coverage, 6738,
     /*  87990 */   GIR_Done,
     /*  87991 */ // Label 1548: @87991
     /*  87991 */ GIM_Try, /*On fail goto*//*Label 1549*/ GIMT_Encode4(88017), // Rule ID 6739 //
     /*  87996 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  88002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88006 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88010 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)  =>  (REV64v8i16:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)
     /*  88010 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  88015 */   GIR_RootConstrainSelectedInstOperands,
     /*  88016 */   // GIR_Coverage, 6739,
     /*  88016 */   GIR_Done,
     /*  88017 */ // Label 1549: @88017
     /*  88017 */ GIM_Try, /*On fail goto*//*Label 1550*/ GIMT_Encode4(88046), // Rule ID 6740 //
     /*  88022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  88025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88029 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88033 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  88033 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88036 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88038 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88040 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88045 */   // GIR_Coverage, 6740,
     /*  88045 */   GIR_EraseRootFromParent_Done,
     /*  88046 */ // Label 1550: @88046
     /*  88046 */ GIM_Reject,
     /*  88047 */ // Label 1405: @88047
     /*  88047 */ GIM_Try, /*On fail goto*//*Label 1551*/ GIMT_Encode4(88077), // Rule ID 6552 //
     /*  88052 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88062 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88066 */   // (bitconvert:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  88066 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88071 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88076 */   // GIR_Coverage, 6552,
     /*  88076 */   GIR_Done,
     /*  88077 */ // Label 1551: @88077
     /*  88077 */ GIM_Try, /*On fail goto*//*Label 1552*/ GIMT_Encode4(88107), // Rule ID 6554 //
     /*  88082 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88085 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88092 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88096 */   // (bitconvert:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  88096 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88101 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88106 */   // GIR_Coverage, 6554,
     /*  88106 */   GIR_Done,
     /*  88107 */ // Label 1552: @88107
     /*  88107 */ GIM_Try, /*On fail goto*//*Label 1553*/ GIMT_Encode4(88157), // Rule ID 6563 //
     /*  88112 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88122 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88126 */   // (bitconvert:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v4i16:{ *:[v4i16] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /*  88126 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  88129 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88133 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88138 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /*  88142 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88147 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  88150 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88152 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88155 */   GIR_RootConstrainSelectedInstOperands,
     /*  88156 */   // GIR_Coverage, 6563,
     /*  88156 */   GIR_EraseRootFromParent_Done,
     /*  88157 */ // Label 1553: @88157
     /*  88157 */ GIM_Try, /*On fail goto*//*Label 1554*/ GIMT_Encode4(88207), // Rule ID 6565 //
     /*  88162 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88172 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88176 */   // (bitconvert:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v4i16:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /*  88176 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  88179 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88183 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88188 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /*  88192 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88197 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  88200 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88202 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88205 */   GIR_RootConstrainSelectedInstOperands,
     /*  88206 */   // GIR_Coverage, 6565,
     /*  88206 */   GIR_EraseRootFromParent_Done,
     /*  88207 */ // Label 1554: @88207
     /*  88207 */ GIM_Try, /*On fail goto*//*Label 1555*/ GIMT_Encode4(88239), // Rule ID 6611 //
     /*  88212 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88222 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88226 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  88226 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88229 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88231 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88233 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88238 */   // GIR_Coverage, 6611,
     /*  88238 */   GIR_EraseRootFromParent_Done,
     /*  88239 */ // Label 1555: @88239
     /*  88239 */ GIM_Try, /*On fail goto*//*Label 1556*/ GIMT_Encode4(88271), // Rule ID 6612 //
     /*  88244 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88254 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88258 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  88258 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88261 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88263 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88265 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88270 */   // GIR_Coverage, 6612,
     /*  88270 */   GIR_EraseRootFromParent_Done,
     /*  88271 */ // Label 1556: @88271
     /*  88271 */ GIM_Try, /*On fail goto*//*Label 1557*/ GIMT_Encode4(88303), // Rule ID 6613 //
     /*  88276 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  88282 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88286 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88290 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  88290 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88293 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88295 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88297 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88302 */   // GIR_Coverage, 6613,
     /*  88302 */   GIR_EraseRootFromParent_Done,
     /*  88303 */ // Label 1557: @88303
     /*  88303 */ GIM_Try, /*On fail goto*//*Label 1558*/ GIMT_Encode4(88335), // Rule ID 6614 //
     /*  88308 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88318 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88322 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  88322 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88325 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88327 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88329 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88334 */   // GIR_Coverage, 6614,
     /*  88334 */   GIR_EraseRootFromParent_Done,
     /*  88335 */ // Label 1558: @88335
     /*  88335 */ GIM_Try, /*On fail goto*//*Label 1559*/ GIMT_Encode4(88367), // Rule ID 6615 //
     /*  88340 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88343 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88350 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88354 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  88354 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88357 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88359 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88361 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88366 */   // GIR_Coverage, 6615,
     /*  88366 */   GIR_EraseRootFromParent_Done,
     /*  88367 */ // Label 1559: @88367
     /*  88367 */ GIM_Try, /*On fail goto*//*Label 1560*/ GIMT_Encode4(88399), // Rule ID 6616 //
     /*  88372 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88375 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88382 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88386 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  88386 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88389 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88391 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88393 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88398 */   // GIR_Coverage, 6616,
     /*  88398 */   GIR_EraseRootFromParent_Done,
     /*  88399 */ // Label 1560: @88399
     /*  88399 */ GIM_Try, /*On fail goto*//*Label 1561*/ GIMT_Encode4(88425), // Rule ID 6617 //
     /*  88404 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88407 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88414 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88418 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)
     /*  88418 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  88423 */   GIR_RootConstrainSelectedInstOperands,
     /*  88424 */   // GIR_Coverage, 6617,
     /*  88424 */   GIR_Done,
     /*  88425 */ // Label 1561: @88425
     /*  88425 */ GIM_Try, /*On fail goto*//*Label 1562*/ GIMT_Encode4(88451), // Rule ID 6618 //
     /*  88430 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88440 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88444 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v4i16:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)
     /*  88444 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  88449 */   GIR_RootConstrainSelectedInstOperands,
     /*  88450 */   // GIR_Coverage, 6618,
     /*  88450 */   GIR_Done,
     /*  88451 */ // Label 1562: @88451
     /*  88451 */ GIM_Try, /*On fail goto*//*Label 1563*/ GIMT_Encode4(88477), // Rule ID 6619 //
     /*  88456 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  88462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88466 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88470 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)  =>  (REV16v8i8:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)
     /*  88470 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /*  88475 */   GIR_RootConstrainSelectedInstOperands,
     /*  88476 */   // GIR_Coverage, 6619,
     /*  88476 */   GIR_Done,
     /*  88477 */ // Label 1563: @88477
     /*  88477 */ GIM_Try, /*On fail goto*//*Label 1564*/ GIMT_Encode4(88503), // Rule ID 6620 //
     /*  88482 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88485 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88492 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88496 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)
     /*  88496 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  88501 */   GIR_RootConstrainSelectedInstOperands,
     /*  88502 */   // GIR_Coverage, 6620,
     /*  88502 */   GIR_Done,
     /*  88503 */ // Label 1564: @88503
     /*  88503 */ GIM_Try, /*On fail goto*//*Label 1565*/ GIMT_Encode4(88529), // Rule ID 6621 //
     /*  88508 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88511 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88518 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88522 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v4i16:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)
     /*  88522 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  88527 */   GIR_RootConstrainSelectedInstOperands,
     /*  88528 */   // GIR_Coverage, 6621,
     /*  88528 */   GIR_Done,
     /*  88529 */ // Label 1565: @88529
     /*  88529 */ GIM_Try, /*On fail goto*//*Label 1566*/ GIMT_Encode4(88555), // Rule ID 6622 //
     /*  88534 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88537 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88544 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88548 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)
     /*  88548 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  88553 */   GIR_RootConstrainSelectedInstOperands,
     /*  88554 */   // GIR_Coverage, 6622,
     /*  88554 */   GIR_Done,
     /*  88555 */ // Label 1566: @88555
     /*  88555 */ GIM_Try, /*On fail goto*//*Label 1567*/ GIMT_Encode4(88584), // Rule ID 6623 //
     /*  88560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88567 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88571 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  88571 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88574 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88576 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88578 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88583 */   // GIR_Coverage, 6623,
     /*  88583 */   GIR_EraseRootFromParent_Done,
     /*  88584 */ // Label 1567: @88584
     /*  88584 */ GIM_Try, /*On fail goto*//*Label 1568*/ GIMT_Encode4(88616), // Rule ID 6624 //
     /*  88589 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88592 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88599 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88603 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  88603 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88606 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88608 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88610 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88615 */   // GIR_Coverage, 6624,
     /*  88615 */   GIR_EraseRootFromParent_Done,
     /*  88616 */ // Label 1568: @88616
     /*  88616 */ GIM_Try, /*On fail goto*//*Label 1569*/ GIMT_Encode4(88648), // Rule ID 6625 //
     /*  88621 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88624 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88631 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88635 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  88635 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88638 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88640 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88642 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88647 */   // GIR_Coverage, 6625,
     /*  88647 */   GIR_EraseRootFromParent_Done,
     /*  88648 */ // Label 1569: @88648
     /*  88648 */ GIM_Try, /*On fail goto*//*Label 1570*/ GIMT_Encode4(88680), // Rule ID 6626 //
     /*  88653 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88656 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  88659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88663 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88667 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  88667 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88670 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88672 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88674 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88679 */   // GIR_Coverage, 6626,
     /*  88679 */   GIR_EraseRootFromParent_Done,
     /*  88680 */ // Label 1570: @88680
     /*  88680 */ GIM_Try, /*On fail goto*//*Label 1571*/ GIMT_Encode4(88712), // Rule ID 6627 //
     /*  88685 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88688 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88695 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88699 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  88699 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88702 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88704 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88706 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88711 */   // GIR_Coverage, 6627,
     /*  88711 */   GIR_EraseRootFromParent_Done,
     /*  88712 */ // Label 1571: @88712
     /*  88712 */ GIM_Try, /*On fail goto*//*Label 1572*/ GIMT_Encode4(88744), // Rule ID 6628 //
     /*  88717 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88727 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88731 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  88731 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88734 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88736 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88738 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88743 */   // GIR_Coverage, 6628,
     /*  88743 */   GIR_EraseRootFromParent_Done,
     /*  88744 */ // Label 1572: @88744
     /*  88744 */ GIM_Try, /*On fail goto*//*Label 1573*/ GIMT_Encode4(88776), // Rule ID 6629 //
     /*  88749 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88752 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88755 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88759 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88763 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  88763 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88766 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88768 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88770 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88775 */   // GIR_Coverage, 6629,
     /*  88775 */   GIR_EraseRootFromParent_Done,
     /*  88776 */ // Label 1573: @88776
     /*  88776 */ GIM_Try, /*On fail goto*//*Label 1574*/ GIMT_Encode4(88802), // Rule ID 6630 //
     /*  88781 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88784 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88791 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88795 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)
     /*  88795 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  88800 */   GIR_RootConstrainSelectedInstOperands,
     /*  88801 */   // GIR_Coverage, 6630,
     /*  88801 */   GIR_Done,
     /*  88802 */ // Label 1574: @88802
     /*  88802 */ GIM_Try, /*On fail goto*//*Label 1575*/ GIMT_Encode4(88828), // Rule ID 6631 //
     /*  88807 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88810 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88817 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88821 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v4i16:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)
     /*  88821 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  88826 */   GIR_RootConstrainSelectedInstOperands,
     /*  88827 */   // GIR_Coverage, 6631,
     /*  88827 */   GIR_Done,
     /*  88828 */ // Label 1575: @88828
     /*  88828 */ GIM_Try, /*On fail goto*//*Label 1576*/ GIMT_Encode4(88854), // Rule ID 6632 //
     /*  88833 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88836 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  88839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88843 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88847 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)  =>  (REV16v8i8:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)
     /*  88847 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /*  88852 */   GIR_RootConstrainSelectedInstOperands,
     /*  88853 */   // GIR_Coverage, 6632,
     /*  88853 */   GIR_Done,
     /*  88854 */ // Label 1576: @88854
     /*  88854 */ GIM_Try, /*On fail goto*//*Label 1577*/ GIMT_Encode4(88880), // Rule ID 6633 //
     /*  88859 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88869 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88873 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)
     /*  88873 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  88878 */   GIR_RootConstrainSelectedInstOperands,
     /*  88879 */   // GIR_Coverage, 6633,
     /*  88879 */   GIR_Done,
     /*  88880 */ // Label 1577: @88880
     /*  88880 */ GIM_Try, /*On fail goto*//*Label 1578*/ GIMT_Encode4(88906), // Rule ID 6634 //
     /*  88885 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88888 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88895 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88899 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v4i16:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)
     /*  88899 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  88904 */   GIR_RootConstrainSelectedInstOperands,
     /*  88905 */   // GIR_Coverage, 6634,
     /*  88905 */   GIR_Done,
     /*  88906 */ // Label 1578: @88906
     /*  88906 */ GIM_Try, /*On fail goto*//*Label 1579*/ GIMT_Encode4(88932), // Rule ID 6635 //
     /*  88911 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88914 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88921 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88925 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)
     /*  88925 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  88930 */   GIR_RootConstrainSelectedInstOperands,
     /*  88931 */   // GIR_Coverage, 6635,
     /*  88931 */   GIR_Done,
     /*  88932 */ // Label 1579: @88932
     /*  88932 */ GIM_Try, /*On fail goto*//*Label 1580*/ GIMT_Encode4(88961), // Rule ID 6636 //
     /*  88937 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88944 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88948 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  88948 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88951 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88953 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88955 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88960 */   // GIR_Coverage, 6636,
     /*  88960 */   GIR_EraseRootFromParent_Done,
     /*  88961 */ // Label 1580: @88961
     /*  88961 */ GIM_Reject,
     /*  88962 */ // Label 1406: @88962
     /*  88962 */ GIM_Try, /*On fail goto*//*Label 1581*/ GIMT_Encode4(88994), // Rule ID 6715 //
     /*  88967 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  88973 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88977 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88981 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  88981 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88984 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88986 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88988 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88993 */   // GIR_Coverage, 6715,
     /*  88993 */   GIR_EraseRootFromParent_Done,
     /*  88994 */ // Label 1581: @88994
     /*  88994 */ GIM_Try, /*On fail goto*//*Label 1582*/ GIMT_Encode4(89026), // Rule ID 6716 //
     /*  88999 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  89005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89009 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89013 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  89013 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89016 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89018 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89020 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89025 */   // GIR_Coverage, 6716,
     /*  89025 */   GIR_EraseRootFromParent_Done,
     /*  89026 */ // Label 1582: @89026
     /*  89026 */ GIM_Try, /*On fail goto*//*Label 1583*/ GIMT_Encode4(89058), // Rule ID 6717 //
     /*  89031 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89034 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  89037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89041 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89045 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  89045 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89048 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89050 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89052 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89057 */   // GIR_Coverage, 6717,
     /*  89057 */   GIR_EraseRootFromParent_Done,
     /*  89058 */ // Label 1583: @89058
     /*  89058 */ GIM_Try, /*On fail goto*//*Label 1584*/ GIMT_Encode4(89090), // Rule ID 6718 //
     /*  89063 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  89069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89073 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89077 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  89077 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89080 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89082 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89084 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89089 */   // GIR_Coverage, 6718,
     /*  89089 */   GIR_EraseRootFromParent_Done,
     /*  89090 */ // Label 1584: @89090
     /*  89090 */ GIM_Try, /*On fail goto*//*Label 1585*/ GIMT_Encode4(89122), // Rule ID 6719 //
     /*  89095 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89098 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89105 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89109 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  89109 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89112 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89114 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89116 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89121 */   // GIR_Coverage, 6719,
     /*  89121 */   GIR_EraseRootFromParent_Done,
     /*  89122 */ // Label 1585: @89122
     /*  89122 */ GIM_Try, /*On fail goto*//*Label 1586*/ GIMT_Encode4(89154), // Rule ID 6720 //
     /*  89127 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89130 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89137 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89141 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  89141 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89144 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89146 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89148 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89153 */   // GIR_Coverage, 6720,
     /*  89153 */   GIR_EraseRootFromParent_Done,
     /*  89154 */ // Label 1586: @89154
     /*  89154 */ GIM_Try, /*On fail goto*//*Label 1587*/ GIMT_Encode4(89225), // Rule ID 6721 //
     /*  89159 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  89165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89169 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89173 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v4f32] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /*  89173 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  89176 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  89180 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89185 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  89189 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  89191 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  89194 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  89198 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89203 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  89207 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  89209 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  89212 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89214 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  89217 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  89220 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  89223 */   GIR_RootConstrainSelectedInstOperands,
     /*  89224 */   // GIR_Coverage, 6721,
     /*  89224 */   GIR_EraseRootFromParent_Done,
     /*  89225 */ // Label 1587: @89225
     /*  89225 */ GIM_Try, /*On fail goto*//*Label 1588*/ GIMT_Encode4(89251), // Rule ID 6722 //
     /*  89230 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  89236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89240 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89244 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)  =>  (REV32v8i16:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)
     /*  89244 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  89249 */   GIR_RootConstrainSelectedInstOperands,
     /*  89250 */   // GIR_Coverage, 6722,
     /*  89250 */   GIR_Done,
     /*  89251 */ // Label 1588: @89251
     /*  89251 */ GIM_Try, /*On fail goto*//*Label 1589*/ GIMT_Encode4(89277), // Rule ID 6723 //
     /*  89256 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89259 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  89262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89266 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89270 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)  =>  (REV32v8i16:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)
     /*  89270 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  89275 */   GIR_RootConstrainSelectedInstOperands,
     /*  89276 */   // GIR_Coverage, 6723,
     /*  89276 */   GIR_Done,
     /*  89277 */ // Label 1589: @89277
     /*  89277 */ GIM_Try, /*On fail goto*//*Label 1590*/ GIMT_Encode4(89303), // Rule ID 6724 //
     /*  89282 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89285 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  89288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89292 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89296 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)  =>  (REV32v16i8:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)
     /*  89296 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /*  89301 */   GIR_RootConstrainSelectedInstOperands,
     /*  89302 */   // GIR_Coverage, 6724,
     /*  89302 */   GIR_Done,
     /*  89303 */ // Label 1590: @89303
     /*  89303 */ GIM_Try, /*On fail goto*//*Label 1591*/ GIMT_Encode4(89329), // Rule ID 6725 //
     /*  89308 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89318 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89322 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v4i32:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)
     /*  89322 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  89327 */   GIR_RootConstrainSelectedInstOperands,
     /*  89328 */   // GIR_Coverage, 6725,
     /*  89328 */   GIR_Done,
     /*  89329 */ // Label 1591: @89329
     /*  89329 */ GIM_Try, /*On fail goto*//*Label 1592*/ GIMT_Encode4(89355), // Rule ID 6726 //
     /*  89334 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89344 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89348 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v4i32:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)
     /*  89348 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  89353 */   GIR_RootConstrainSelectedInstOperands,
     /*  89354 */   // GIR_Coverage, 6726,
     /*  89354 */   GIR_Done,
     /*  89355 */ // Label 1592: @89355
     /*  89355 */ GIM_Try, /*On fail goto*//*Label 1593*/ GIMT_Encode4(89384), // Rule ID 6727 //
     /*  89360 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89367 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89371 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  89371 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89374 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89376 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89378 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89383 */   // GIR_Coverage, 6727,
     /*  89383 */   GIR_EraseRootFromParent_Done,
     /*  89384 */ // Label 1593: @89384
     /*  89384 */ GIM_Try, /*On fail goto*//*Label 1594*/ GIMT_Encode4(89416), // Rule ID 6741 //
     /*  89389 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  89395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89399 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89403 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  89403 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89406 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89408 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89410 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89415 */   // GIR_Coverage, 6741,
     /*  89415 */   GIR_EraseRootFromParent_Done,
     /*  89416 */ // Label 1594: @89416
     /*  89416 */ GIM_Try, /*On fail goto*//*Label 1595*/ GIMT_Encode4(89448), // Rule ID 6742 //
     /*  89421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89431 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89435 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  89435 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89438 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89440 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89442 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89447 */   // GIR_Coverage, 6742,
     /*  89447 */   GIR_EraseRootFromParent_Done,
     /*  89448 */ // Label 1595: @89448
     /*  89448 */ GIM_Try, /*On fail goto*//*Label 1596*/ GIMT_Encode4(89480), // Rule ID 6743 //
     /*  89453 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  89459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89463 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89467 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  89467 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89470 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89472 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89474 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89479 */   // GIR_Coverage, 6743,
     /*  89479 */   GIR_EraseRootFromParent_Done,
     /*  89480 */ // Label 1596: @89480
     /*  89480 */ GIM_Try, /*On fail goto*//*Label 1597*/ GIMT_Encode4(89512), // Rule ID 6744 //
     /*  89485 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89488 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  89491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89495 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89499 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  89499 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89502 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89504 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89506 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89511 */   // GIR_Coverage, 6744,
     /*  89511 */   GIR_EraseRootFromParent_Done,
     /*  89512 */ // Label 1597: @89512
     /*  89512 */ GIM_Try, /*On fail goto*//*Label 1598*/ GIMT_Encode4(89544), // Rule ID 6745 //
     /*  89517 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89527 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89531 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  89531 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89534 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89536 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89538 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89543 */   // GIR_Coverage, 6745,
     /*  89543 */   GIR_EraseRootFromParent_Done,
     /*  89544 */ // Label 1598: @89544
     /*  89544 */ GIM_Try, /*On fail goto*//*Label 1599*/ GIMT_Encode4(89576), // Rule ID 6746 //
     /*  89549 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89552 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  89555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89559 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89563 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  89563 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89566 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89568 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89570 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89575 */   // GIR_Coverage, 6746,
     /*  89575 */   GIR_EraseRootFromParent_Done,
     /*  89576 */ // Label 1599: @89576
     /*  89576 */ GIM_Try, /*On fail goto*//*Label 1600*/ GIMT_Encode4(89647), // Rule ID 6747 //
     /*  89581 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89584 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  89587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89591 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89595 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v4i32] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /*  89595 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  89598 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  89602 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89607 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  89611 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  89613 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  89616 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  89620 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89625 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  89629 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  89631 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  89634 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89636 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  89639 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  89642 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  89645 */   GIR_RootConstrainSelectedInstOperands,
     /*  89646 */   // GIR_Coverage, 6747,
     /*  89646 */   GIR_EraseRootFromParent_Done,
     /*  89647 */ // Label 1600: @89647
     /*  89647 */ GIM_Try, /*On fail goto*//*Label 1601*/ GIMT_Encode4(89673), // Rule ID 6748 //
     /*  89652 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89655 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89658 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89662 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89666 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v4i32:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)
     /*  89666 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  89671 */   GIR_RootConstrainSelectedInstOperands,
     /*  89672 */   // GIR_Coverage, 6748,
     /*  89672 */   GIR_Done,
     /*  89673 */ // Label 1601: @89673
     /*  89673 */ GIM_Try, /*On fail goto*//*Label 1602*/ GIMT_Encode4(89699), // Rule ID 6749 //
     /*  89678 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  89684 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89688 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89692 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)  =>  (REV32v8i16:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)
     /*  89692 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  89697 */   GIR_RootConstrainSelectedInstOperands,
     /*  89698 */   // GIR_Coverage, 6749,
     /*  89698 */   GIR_Done,
     /*  89699 */ // Label 1602: @89699
     /*  89699 */ GIM_Try, /*On fail goto*//*Label 1603*/ GIMT_Encode4(89725), // Rule ID 6750 //
     /*  89704 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  89710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89714 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89718 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)  =>  (REV32v16i8:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)
     /*  89718 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /*  89723 */   GIR_RootConstrainSelectedInstOperands,
     /*  89724 */   // GIR_Coverage, 6750,
     /*  89724 */   GIR_Done,
     /*  89725 */ // Label 1603: @89725
     /*  89725 */ GIM_Try, /*On fail goto*//*Label 1604*/ GIMT_Encode4(89751), // Rule ID 6751 //
     /*  89730 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89740 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89744 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v4i32:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)
     /*  89744 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  89749 */   GIR_RootConstrainSelectedInstOperands,
     /*  89750 */   // GIR_Coverage, 6751,
     /*  89750 */   GIR_Done,
     /*  89751 */ // Label 1604: @89751
     /*  89751 */ GIM_Try, /*On fail goto*//*Label 1605*/ GIMT_Encode4(89777), // Rule ID 6752 //
     /*  89756 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89759 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  89762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89766 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89770 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)  =>  (REV32v8i16:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)
     /*  89770 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  89775 */   GIR_RootConstrainSelectedInstOperands,
     /*  89776 */   // GIR_Coverage, 6752,
     /*  89776 */   GIR_Done,
     /*  89777 */ // Label 1605: @89777
     /*  89777 */ GIM_Try, /*On fail goto*//*Label 1606*/ GIMT_Encode4(89806), // Rule ID 6753 //
     /*  89782 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89789 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89793 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  89793 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89796 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89798 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89800 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89805 */   // GIR_Coverage, 6753,
     /*  89805 */   GIR_EraseRootFromParent_Done,
     /*  89806 */ // Label 1606: @89806
     /*  89806 */ GIM_Reject,
     /*  89807 */ // Label 1407: @89807
     /*  89807 */ GIM_Try, /*On fail goto*//*Label 1607*/ GIMT_Encode4(89881), // Rule ID 5598 //
     /*  89812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89819 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  89823 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  89827 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  89831 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  89836 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89838 */   // (bitconvert:{ *:[v8i8] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn))  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i32] }, (FMOVWSr:{ *:[f32] } GPR32:{ *:[i32] }:$Rn), ssub:{ *:[i32] })
     /*  89838 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  89841 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVWSr),
     /*  89845 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89850 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  89854 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  89856 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  89859 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89861 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89864 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  89867 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /*  89870 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89875 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  89880 */   // GIR_Coverage, 5598,
     /*  89880 */   GIR_EraseRootFromParent_Done,
     /*  89881 */ // Label 1607: @89881
     /*  89881 */ GIM_Try, /*On fail goto*//*Label 1608*/ GIMT_Encode4(89911), // Rule ID 6551 //
     /*  89886 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89896 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89900 */   // (bitconvert:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  89900 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89905 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89910 */   // GIR_Coverage, 6551,
     /*  89910 */   GIR_Done,
     /*  89911 */ // Label 1608: @89911
     /*  89911 */ GIM_Try, /*On fail goto*//*Label 1609*/ GIMT_Encode4(89961), // Rule ID 6562 //
     /*  89916 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89926 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89930 */   // (bitconvert:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v8i8:{ *:[v8i8] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /*  89930 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  89933 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89937 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89942 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /*  89946 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89951 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  89954 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89956 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  89959 */   GIR_RootConstrainSelectedInstOperands,
     /*  89960 */   // GIR_Coverage, 6562,
     /*  89960 */   GIR_EraseRootFromParent_Done,
     /*  89961 */ // Label 1609: @89961
     /*  89961 */ GIM_Try, /*On fail goto*//*Label 1610*/ GIMT_Encode4(89993), // Rule ID 6637 //
     /*  89966 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89969 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89976 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89980 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  89980 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89983 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89985 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89987 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89992 */   // GIR_Coverage, 6637,
     /*  89992 */   GIR_EraseRootFromParent_Done,
     /*  89993 */ // Label 1610: @89993
     /*  89993 */ GIM_Try, /*On fail goto*//*Label 1611*/ GIMT_Encode4(90025), // Rule ID 6638 //
     /*  89998 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  90004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90008 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90012 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  90012 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90015 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90017 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90019 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90024 */   // GIR_Coverage, 6638,
     /*  90024 */   GIR_EraseRootFromParent_Done,
     /*  90025 */ // Label 1611: @90025
     /*  90025 */ GIM_Try, /*On fail goto*//*Label 1612*/ GIMT_Encode4(90057), // Rule ID 6639 //
     /*  90030 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  90036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90040 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90044 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  90044 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90047 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90049 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90051 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90056 */   // GIR_Coverage, 6639,
     /*  90056 */   GIR_EraseRootFromParent_Done,
     /*  90057 */ // Label 1612: @90057
     /*  90057 */ GIM_Try, /*On fail goto*//*Label 1613*/ GIMT_Encode4(90089), // Rule ID 6640 //
     /*  90062 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90072 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90076 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  90076 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90079 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90081 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90083 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90088 */   // GIR_Coverage, 6640,
     /*  90088 */   GIR_EraseRootFromParent_Done,
     /*  90089 */ // Label 1613: @90089
     /*  90089 */ GIM_Try, /*On fail goto*//*Label 1614*/ GIMT_Encode4(90121), // Rule ID 6641 //
     /*  90094 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90097 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  90100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90104 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90108 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  90108 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90111 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90113 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90115 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90120 */   // GIR_Coverage, 6641,
     /*  90120 */   GIR_EraseRootFromParent_Done,
     /*  90121 */ // Label 1614: @90121
     /*  90121 */ GIM_Try, /*On fail goto*//*Label 1615*/ GIMT_Encode4(90153), // Rule ID 6642 //
     /*  90126 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90129 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90136 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90140 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  90140 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90143 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90145 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90147 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90152 */   // GIR_Coverage, 6642,
     /*  90152 */   GIR_EraseRootFromParent_Done,
     /*  90153 */ // Label 1615: @90153
     /*  90153 */ GIM_Try, /*On fail goto*//*Label 1616*/ GIMT_Encode4(90185), // Rule ID 6643 //
     /*  90158 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90161 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  90164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90168 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90172 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  90172 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90175 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90177 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90179 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90184 */   // GIR_Coverage, 6643,
     /*  90184 */   GIR_EraseRootFromParent_Done,
     /*  90185 */ // Label 1616: @90185
     /*  90185 */ GIM_Try, /*On fail goto*//*Label 1617*/ GIMT_Encode4(90211), // Rule ID 6644 //
     /*  90190 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90193 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90200 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90204 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)
     /*  90204 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  90209 */   GIR_RootConstrainSelectedInstOperands,
     /*  90210 */   // GIR_Coverage, 6644,
     /*  90210 */   GIR_Done,
     /*  90211 */ // Label 1617: @90211
     /*  90211 */ GIM_Try, /*On fail goto*//*Label 1618*/ GIMT_Encode4(90237), // Rule ID 6645 //
     /*  90216 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  90222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90226 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90230 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v8i8:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)
     /*  90230 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /*  90235 */   GIR_RootConstrainSelectedInstOperands,
     /*  90236 */   // GIR_Coverage, 6645,
     /*  90236 */   GIR_Done,
     /*  90237 */ // Label 1618: @90237
     /*  90237 */ GIM_Try, /*On fail goto*//*Label 1619*/ GIMT_Encode4(90263), // Rule ID 6646 //
     /*  90242 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90245 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  90248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90252 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90256 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)  =>  (REV16v8i8:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)
     /*  90256 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /*  90261 */   GIR_RootConstrainSelectedInstOperands,
     /*  90262 */   // GIR_Coverage, 6646,
     /*  90262 */   GIR_Done,
     /*  90263 */ // Label 1619: @90263
     /*  90263 */ GIM_Try, /*On fail goto*//*Label 1620*/ GIMT_Encode4(90289), // Rule ID 6647 //
     /*  90268 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90278 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90282 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)
     /*  90282 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  90287 */   GIR_RootConstrainSelectedInstOperands,
     /*  90288 */   // GIR_Coverage, 6647,
     /*  90288 */   GIR_Done,
     /*  90289 */ // Label 1620: @90289
     /*  90289 */ GIM_Try, /*On fail goto*//*Label 1621*/ GIMT_Encode4(90315), // Rule ID 6648 //
     /*  90294 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  90300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90304 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90308 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v8i8:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)
     /*  90308 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /*  90313 */   GIR_RootConstrainSelectedInstOperands,
     /*  90314 */   // GIR_Coverage, 6648,
     /*  90314 */   GIR_Done,
     /*  90315 */ // Label 1621: @90315
     /*  90315 */ GIM_Try, /*On fail goto*//*Label 1622*/ GIMT_Encode4(90341), // Rule ID 6649 //
     /*  90320 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90330 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90334 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)
     /*  90334 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  90339 */   GIR_RootConstrainSelectedInstOperands,
     /*  90340 */   // GIR_Coverage, 6649,
     /*  90340 */   GIR_Done,
     /*  90341 */ // Label 1622: @90341
     /*  90341 */ GIM_Try, /*On fail goto*//*Label 1623*/ GIMT_Encode4(90367), // Rule ID 6650 //
     /*  90346 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  90352 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90356 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90360 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)  =>  (REV16v8i8:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)
     /*  90360 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /*  90365 */   GIR_RootConstrainSelectedInstOperands,
     /*  90366 */   // GIR_Coverage, 6650,
     /*  90366 */   GIR_Done,
     /*  90367 */ // Label 1623: @90367
     /*  90367 */ GIM_Reject,
     /*  90368 */ // Label 1408: @90368
     /*  90368 */ GIM_Try, /*On fail goto*//*Label 1624*/ GIMT_Encode4(90400), // Rule ID 6754 //
     /*  90373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  90379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90383 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90387 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  90387 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90390 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90392 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90394 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90399 */   // GIR_Coverage, 6754,
     /*  90399 */   GIR_EraseRootFromParent_Done,
     /*  90400 */ // Label 1624: @90400
     /*  90400 */ GIM_Try, /*On fail goto*//*Label 1625*/ GIMT_Encode4(90432), // Rule ID 6755 //
     /*  90405 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  90411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90415 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90419 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  90419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90422 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90424 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90426 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90431 */   // GIR_Coverage, 6755,
     /*  90431 */   GIR_EraseRootFromParent_Done,
     /*  90432 */ // Label 1625: @90432
     /*  90432 */ GIM_Try, /*On fail goto*//*Label 1626*/ GIMT_Encode4(90464), // Rule ID 6756 //
     /*  90437 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90447 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90451 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  90451 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90454 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90456 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90458 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90463 */   // GIR_Coverage, 6756,
     /*  90463 */   GIR_EraseRootFromParent_Done,
     /*  90464 */ // Label 1626: @90464
     /*  90464 */ GIM_Try, /*On fail goto*//*Label 1627*/ GIMT_Encode4(90496), // Rule ID 6757 //
     /*  90469 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90472 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  90475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90479 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90483 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  90483 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90486 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90488 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90490 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90495 */   // GIR_Coverage, 6757,
     /*  90495 */   GIR_EraseRootFromParent_Done,
     /*  90496 */ // Label 1627: @90496
     /*  90496 */ GIM_Try, /*On fail goto*//*Label 1628*/ GIMT_Encode4(90528), // Rule ID 6758 //
     /*  90501 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90504 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  90507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90511 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90515 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  90515 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90518 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90520 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90522 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90527 */   // GIR_Coverage, 6758,
     /*  90527 */   GIR_EraseRootFromParent_Done,
     /*  90528 */ // Label 1628: @90528
     /*  90528 */ GIM_Try, /*On fail goto*//*Label 1629*/ GIMT_Encode4(90560), // Rule ID 6759 //
     /*  90533 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90543 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90547 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  90547 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90550 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90552 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90554 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90559 */   // GIR_Coverage, 6759,
     /*  90559 */   GIR_EraseRootFromParent_Done,
     /*  90560 */ // Label 1629: @90560
     /*  90560 */ GIM_Try, /*On fail goto*//*Label 1630*/ GIMT_Encode4(90631), // Rule ID 6760 //
     /*  90565 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  90571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90575 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90579 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v8i16] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /*  90579 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  90582 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  90586 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90591 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  90595 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  90597 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  90600 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  90604 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90609 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  90613 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  90615 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  90618 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90620 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90623 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  90626 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  90629 */   GIR_RootConstrainSelectedInstOperands,
     /*  90630 */   // GIR_Coverage, 6760,
     /*  90630 */   GIR_EraseRootFromParent_Done,
     /*  90631 */ // Label 1630: @90631
     /*  90631 */ GIM_Try, /*On fail goto*//*Label 1631*/ GIMT_Encode4(90657), // Rule ID 6761 //
     /*  90636 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  90642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90646 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90650 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v8i16:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)
     /*  90650 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  90655 */   GIR_RootConstrainSelectedInstOperands,
     /*  90656 */   // GIR_Coverage, 6761,
     /*  90656 */   GIR_Done,
     /*  90657 */ // Label 1631: @90657
     /*  90657 */ GIM_Try, /*On fail goto*//*Label 1632*/ GIMT_Encode4(90683), // Rule ID 6762 //
     /*  90662 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90668 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90672 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90676 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v8i16:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)
     /*  90676 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  90681 */   GIR_RootConstrainSelectedInstOperands,
     /*  90682 */   // GIR_Coverage, 6762,
     /*  90682 */   GIR_Done,
     /*  90683 */ // Label 1632: @90683
     /*  90683 */ GIM_Try, /*On fail goto*//*Label 1633*/ GIMT_Encode4(90709), // Rule ID 6763 //
     /*  90688 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  90694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90698 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90702 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)  =>  (REV16v16i8:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)
     /*  90702 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /*  90707 */   GIR_RootConstrainSelectedInstOperands,
     /*  90708 */   // GIR_Coverage, 6763,
     /*  90708 */   GIR_Done,
     /*  90709 */ // Label 1633: @90709
     /*  90709 */ GIM_Try, /*On fail goto*//*Label 1634*/ GIMT_Encode4(90735), // Rule ID 6764 //
     /*  90714 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  90720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90724 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90728 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v8i16:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)
     /*  90728 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  90733 */   GIR_RootConstrainSelectedInstOperands,
     /*  90734 */   // GIR_Coverage, 6764,
     /*  90734 */   GIR_Done,
     /*  90735 */ // Label 1634: @90735
     /*  90735 */ GIM_Try, /*On fail goto*//*Label 1635*/ GIMT_Encode4(90761), // Rule ID 6765 //
     /*  90740 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90750 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90754 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v8i16:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)
     /*  90754 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  90759 */   GIR_RootConstrainSelectedInstOperands,
     /*  90760 */   // GIR_Coverage, 6765,
     /*  90760 */   GIR_Done,
     /*  90761 */ // Label 1635: @90761
     /*  90761 */ GIM_Try, /*On fail goto*//*Label 1636*/ GIMT_Encode4(90790), // Rule ID 6766 //
     /*  90766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90773 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90777 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  90777 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90780 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90782 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90784 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90789 */   // GIR_Coverage, 6766,
     /*  90789 */   GIR_EraseRootFromParent_Done,
     /*  90790 */ // Label 1636: @90790
     /*  90790 */ GIM_Try, /*On fail goto*//*Label 1637*/ GIMT_Encode4(90822), // Rule ID 6767 //
     /*  90795 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90798 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  90801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90805 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90809 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  90809 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90812 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90814 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90816 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90821 */   // GIR_Coverage, 6767,
     /*  90821 */   GIR_EraseRootFromParent_Done,
     /*  90822 */ // Label 1637: @90822
     /*  90822 */ GIM_Try, /*On fail goto*//*Label 1638*/ GIMT_Encode4(90854), // Rule ID 6768 //
     /*  90827 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  90833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90837 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90841 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  90841 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90844 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90846 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90848 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90853 */   // GIR_Coverage, 6768,
     /*  90853 */   GIR_EraseRootFromParent_Done,
     /*  90854 */ // Label 1638: @90854
     /*  90854 */ GIM_Try, /*On fail goto*//*Label 1639*/ GIMT_Encode4(90886), // Rule ID 6769 //
     /*  90859 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90869 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90873 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  90873 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90876 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90878 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90880 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90885 */   // GIR_Coverage, 6769,
     /*  90885 */   GIR_EraseRootFromParent_Done,
     /*  90886 */ // Label 1639: @90886
     /*  90886 */ GIM_Try, /*On fail goto*//*Label 1640*/ GIMT_Encode4(90918), // Rule ID 6770 //
     /*  90891 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90894 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  90897 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90901 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90905 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  90905 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90908 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90910 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90912 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90917 */   // GIR_Coverage, 6770,
     /*  90917 */   GIR_EraseRootFromParent_Done,
     /*  90918 */ // Label 1640: @90918
     /*  90918 */ GIM_Try, /*On fail goto*//*Label 1641*/ GIMT_Encode4(90950), // Rule ID 6771 //
     /*  90923 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  90929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90933 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90937 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  90937 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90940 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90942 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90944 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90949 */   // GIR_Coverage, 6771,
     /*  90949 */   GIR_EraseRootFromParent_Done,
     /*  90950 */ // Label 1641: @90950
     /*  90950 */ GIM_Try, /*On fail goto*//*Label 1642*/ GIMT_Encode4(90982), // Rule ID 6772 //
     /*  90955 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90965 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90969 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  90969 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90972 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90974 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90976 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90981 */   // GIR_Coverage, 6772,
     /*  90981 */   GIR_EraseRootFromParent_Done,
     /*  90982 */ // Label 1642: @90982
     /*  90982 */ GIM_Try, /*On fail goto*//*Label 1643*/ GIMT_Encode4(91053), // Rule ID 6773 //
     /*  90987 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90990 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  90993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90997 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91001 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v8f16] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /*  91001 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  91004 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  91008 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  91013 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  91017 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  91019 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  91022 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  91026 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  91031 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  91035 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  91037 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  91040 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  91042 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  91045 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  91048 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  91051 */   GIR_RootConstrainSelectedInstOperands,
     /*  91052 */   // GIR_Coverage, 6773,
     /*  91052 */   GIR_EraseRootFromParent_Done,
     /*  91053 */ // Label 1643: @91053
     /*  91053 */ GIM_Try, /*On fail goto*//*Label 1644*/ GIMT_Encode4(91079), // Rule ID 6774 //
     /*  91058 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  91064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91068 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91072 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v8i16:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)
     /*  91072 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  91077 */   GIR_RootConstrainSelectedInstOperands,
     /*  91078 */   // GIR_Coverage, 6774,
     /*  91078 */   GIR_Done,
     /*  91079 */ // Label 1644: @91079
     /*  91079 */ GIM_Try, /*On fail goto*//*Label 1645*/ GIMT_Encode4(91105), // Rule ID 6775 //
     /*  91084 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91094 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91098 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v8i16:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)
     /*  91098 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  91103 */   GIR_RootConstrainSelectedInstOperands,
     /*  91104 */   // GIR_Coverage, 6775,
     /*  91104 */   GIR_Done,
     /*  91105 */ // Label 1645: @91105
     /*  91105 */ GIM_Try, /*On fail goto*//*Label 1646*/ GIMT_Encode4(91131), // Rule ID 6776 //
     /*  91110 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91113 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  91116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91120 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91124 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)  =>  (REV16v16i8:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)
     /*  91124 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /*  91129 */   GIR_RootConstrainSelectedInstOperands,
     /*  91130 */   // GIR_Coverage, 6776,
     /*  91130 */   GIR_Done,
     /*  91131 */ // Label 1646: @91131
     /*  91131 */ GIM_Try, /*On fail goto*//*Label 1647*/ GIMT_Encode4(91157), // Rule ID 6777 //
     /*  91136 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91139 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  91142 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91146 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91150 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v8i16:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)
     /*  91150 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  91155 */   GIR_RootConstrainSelectedInstOperands,
     /*  91156 */   // GIR_Coverage, 6777,
     /*  91156 */   GIR_Done,
     /*  91157 */ // Label 1647: @91157
     /*  91157 */ GIM_Try, /*On fail goto*//*Label 1648*/ GIMT_Encode4(91183), // Rule ID 6778 //
     /*  91162 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91172 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91176 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v8i16:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)
     /*  91176 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  91181 */   GIR_RootConstrainSelectedInstOperands,
     /*  91182 */   // GIR_Coverage, 6778,
     /*  91182 */   GIR_Done,
     /*  91183 */ // Label 1648: @91183
     /*  91183 */ GIM_Try, /*On fail goto*//*Label 1649*/ GIMT_Encode4(91212), // Rule ID 6779 //
     /*  91188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91195 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91199 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  91199 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91202 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91204 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91206 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91211 */   // GIR_Coverage, 6779,
     /*  91211 */   GIR_EraseRootFromParent_Done,
     /*  91212 */ // Label 1649: @91212
     /*  91212 */ GIM_Reject,
     /*  91213 */ // Label 1409: @91213
     /*  91213 */ GIM_Try, /*On fail goto*//*Label 1650*/ GIMT_Encode4(91245), // Rule ID 6780 //
     /*  91218 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  91224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91228 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91232 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  91232 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91235 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91237 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91239 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91244 */   // GIR_Coverage, 6780,
     /*  91244 */   GIR_EraseRootFromParent_Done,
     /*  91245 */ // Label 1650: @91245
     /*  91245 */ GIM_Try, /*On fail goto*//*Label 1651*/ GIMT_Encode4(91277), // Rule ID 6781 //
     /*  91250 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  91256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91260 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91264 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  91264 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91267 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91269 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91271 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91276 */   // GIR_Coverage, 6781,
     /*  91276 */   GIR_EraseRootFromParent_Done,
     /*  91277 */ // Label 1651: @91277
     /*  91277 */ GIM_Try, /*On fail goto*//*Label 1652*/ GIMT_Encode4(91309), // Rule ID 6782 //
     /*  91282 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91285 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91292 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91296 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  91296 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91299 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91301 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91303 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91308 */   // GIR_Coverage, 6782,
     /*  91308 */   GIR_EraseRootFromParent_Done,
     /*  91309 */ // Label 1652: @91309
     /*  91309 */ GIM_Try, /*On fail goto*//*Label 1653*/ GIMT_Encode4(91341), // Rule ID 6783 //
     /*  91314 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91317 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91324 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91328 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  91328 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91331 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91333 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91335 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91340 */   // GIR_Coverage, 6783,
     /*  91340 */   GIR_EraseRootFromParent_Done,
     /*  91341 */ // Label 1653: @91341
     /*  91341 */ GIM_Try, /*On fail goto*//*Label 1654*/ GIMT_Encode4(91373), // Rule ID 6784 //
     /*  91346 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  91352 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91356 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91360 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  91360 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91363 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91365 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91367 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91372 */   // GIR_Coverage, 6784,
     /*  91372 */   GIR_EraseRootFromParent_Done,
     /*  91373 */ // Label 1654: @91373
     /*  91373 */ GIM_Try, /*On fail goto*//*Label 1655*/ GIMT_Encode4(91405), // Rule ID 6785 //
     /*  91378 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91388 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91392 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  91392 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91395 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91397 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91399 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91404 */   // GIR_Coverage, 6785,
     /*  91404 */   GIR_EraseRootFromParent_Done,
     /*  91405 */ // Label 1655: @91405
     /*  91405 */ GIM_Try, /*On fail goto*//*Label 1656*/ GIMT_Encode4(91437), // Rule ID 6786 //
     /*  91410 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91420 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91424 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  91424 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91427 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91429 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91431 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91436 */   // GIR_Coverage, 6786,
     /*  91436 */   GIR_EraseRootFromParent_Done,
     /*  91437 */ // Label 1656: @91437
     /*  91437 */ GIM_Try, /*On fail goto*//*Label 1657*/ GIMT_Encode4(91508), // Rule ID 6787 //
     /*  91442 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  91448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91456 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v16i8] } (REV64v16i8:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v16i8:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /*  91456 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  91459 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  91463 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  91468 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  91472 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  91474 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  91477 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  91481 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  91486 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  91490 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  91492 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  91495 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  91497 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  91500 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  91503 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  91506 */   GIR_RootConstrainSelectedInstOperands,
     /*  91507 */   // GIR_Coverage, 6787,
     /*  91507 */   GIR_EraseRootFromParent_Done,
     /*  91508 */ // Label 1657: @91508
     /*  91508 */ GIM_Try, /*On fail goto*//*Label 1658*/ GIMT_Encode4(91534), // Rule ID 6788 //
     /*  91513 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  91519 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91523 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91527 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v16i8:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)
     /*  91527 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  91532 */   GIR_RootConstrainSelectedInstOperands,
     /*  91533 */   // GIR_Coverage, 6788,
     /*  91533 */   GIR_Done,
     /*  91534 */ // Label 1658: @91534
     /*  91534 */ GIM_Try, /*On fail goto*//*Label 1659*/ GIMT_Encode4(91560), // Rule ID 6789 //
     /*  91539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91549 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91553 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v16i8:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)
     /*  91553 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /*  91558 */   GIR_RootConstrainSelectedInstOperands,
     /*  91559 */   // GIR_Coverage, 6789,
     /*  91559 */   GIR_Done,
     /*  91560 */ // Label 1659: @91560
     /*  91560 */ GIM_Try, /*On fail goto*//*Label 1660*/ GIMT_Encode4(91586), // Rule ID 6790 //
     /*  91565 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91575 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91579 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)  =>  (REV16v16i8:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)
     /*  91579 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /*  91584 */   GIR_RootConstrainSelectedInstOperands,
     /*  91585 */   // GIR_Coverage, 6790,
     /*  91585 */   GIR_Done,
     /*  91586 */ // Label 1660: @91586
     /*  91586 */ GIM_Try, /*On fail goto*//*Label 1661*/ GIMT_Encode4(91612), // Rule ID 6791 //
     /*  91591 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  91597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91601 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91605 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v16i8:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)
     /*  91605 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  91610 */   GIR_RootConstrainSelectedInstOperands,
     /*  91611 */   // GIR_Coverage, 6791,
     /*  91611 */   GIR_Done,
     /*  91612 */ // Label 1661: @91612
     /*  91612 */ GIM_Try, /*On fail goto*//*Label 1662*/ GIMT_Encode4(91638), // Rule ID 6792 //
     /*  91617 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91627 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91631 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v16i8:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)
     /*  91631 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /*  91636 */   GIR_RootConstrainSelectedInstOperands,
     /*  91637 */   // GIR_Coverage, 6792,
     /*  91637 */   GIR_Done,
     /*  91638 */ // Label 1662: @91638
     /*  91638 */ GIM_Try, /*On fail goto*//*Label 1663*/ GIMT_Encode4(91664), // Rule ID 6793 //
     /*  91643 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91653 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91657 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)  =>  (REV16v16i8:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)
     /*  91657 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /*  91662 */   GIR_RootConstrainSelectedInstOperands,
     /*  91663 */   // GIR_Coverage, 6793,
     /*  91663 */   GIR_Done,
     /*  91664 */ // Label 1663: @91664
     /*  91664 */ GIM_Reject,
     /*  91665 */ // Label 1410: @91665
     /*  91665 */ GIM_Try, /*On fail goto*//*Label 1664*/ GIMT_Encode4(91697), // Rule ID 10406 //
     /*  91670 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  91676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91680 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91684 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  91684 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91687 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91689 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91691 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91696 */   // GIR_Coverage, 10406,
     /*  91696 */   GIR_EraseRootFromParent_Done,
     /*  91697 */ // Label 1664: @91697
     /*  91697 */ GIM_Try, /*On fail goto*//*Label 1665*/ GIMT_Encode4(91729), // Rule ID 10407 //
     /*  91702 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91705 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  91708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91712 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91716 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  91716 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91719 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91721 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91723 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91728 */   // GIR_Coverage, 10407,
     /*  91728 */   GIR_EraseRootFromParent_Done,
     /*  91729 */ // Label 1665: @91729
     /*  91729 */ GIM_Try, /*On fail goto*//*Label 1666*/ GIMT_Encode4(91761), // Rule ID 10408 //
     /*  91734 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  91740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91744 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91748 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  91748 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91751 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91753 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91755 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91760 */   // GIR_Coverage, 10408,
     /*  91760 */   GIR_EraseRootFromParent_Done,
     /*  91761 */ // Label 1666: @91761
     /*  91761 */ GIM_Try, /*On fail goto*//*Label 1667*/ GIMT_Encode4(91793), // Rule ID 10409 //
     /*  91766 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91769 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  91772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91776 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91780 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  91780 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91783 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91785 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91787 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91792 */   // GIR_Coverage, 10409,
     /*  91792 */   GIR_EraseRootFromParent_Done,
     /*  91793 */ // Label 1667: @91793
     /*  91793 */ GIM_Try, /*On fail goto*//*Label 1668*/ GIMT_Encode4(91825), // Rule ID 10410 //
     /*  91798 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  91804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91808 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91812 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  91812 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91815 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91817 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91819 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91824 */   // GIR_Coverage, 10410,
     /*  91824 */   GIR_EraseRootFromParent_Done,
     /*  91825 */ // Label 1668: @91825
     /*  91825 */ GIM_Try, /*On fail goto*//*Label 1669*/ GIMT_Encode4(91857), // Rule ID 10411 //
     /*  91830 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91840 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91844 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  91844 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91847 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91849 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91851 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91856 */   // GIR_Coverage, 10411,
     /*  91856 */   GIR_EraseRootFromParent_Done,
     /*  91857 */ // Label 1669: @91857
     /*  91857 */ GIM_Try, /*On fail goto*//*Label 1670*/ GIMT_Encode4(91889), // Rule ID 10424 //
     /*  91862 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  91868 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91872 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91876 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  91876 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91879 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91881 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91883 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91888 */   // GIR_Coverage, 10424,
     /*  91888 */   GIR_EraseRootFromParent_Done,
     /*  91889 */ // Label 1670: @91889
     /*  91889 */ GIM_Try, /*On fail goto*//*Label 1671*/ GIMT_Encode4(91921), // Rule ID 10425 //
     /*  91894 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91897 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  91900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91904 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91908 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  91908 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91911 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91913 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91915 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91920 */   // GIR_Coverage, 10425,
     /*  91920 */   GIR_EraseRootFromParent_Done,
     /*  91921 */ // Label 1671: @91921
     /*  91921 */ GIM_Try, /*On fail goto*//*Label 1672*/ GIMT_Encode4(91953), // Rule ID 10426 //
     /*  91926 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  91932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91936 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91940 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  91940 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91943 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91945 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91947 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91952 */   // GIR_Coverage, 10426,
     /*  91952 */   GIR_EraseRootFromParent_Done,
     /*  91953 */ // Label 1672: @91953
     /*  91953 */ GIM_Try, /*On fail goto*//*Label 1673*/ GIMT_Encode4(91985), // Rule ID 10427 //
     /*  91958 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91968 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91972 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  91972 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91975 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91977 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91979 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91984 */   // GIR_Coverage, 10427,
     /*  91984 */   GIR_EraseRootFromParent_Done,
     /*  91985 */ // Label 1673: @91985
     /*  91985 */ GIM_Try, /*On fail goto*//*Label 1674*/ GIMT_Encode4(92017), // Rule ID 10428 //
     /*  91990 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  91996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92000 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92004 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  92004 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92007 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92009 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92011 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92016 */   // GIR_Coverage, 10428,
     /*  92016 */   GIR_EraseRootFromParent_Done,
     /*  92017 */ // Label 1674: @92017
     /*  92017 */ GIM_Try, /*On fail goto*//*Label 1675*/ GIMT_Encode4(92049), // Rule ID 10429 //
     /*  92022 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  92028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92032 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92036 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  92036 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92039 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92041 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92043 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92048 */   // GIR_Coverage, 10429,
     /*  92048 */   GIR_EraseRootFromParent_Done,
     /*  92049 */ // Label 1675: @92049
     /*  92049 */ GIM_Try, /*On fail goto*//*Label 1676*/ GIMT_Encode4(92081), // Rule ID 10434 //
     /*  92054 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  92057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92064 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92068 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  92068 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92071 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92073 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92075 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92080 */   // GIR_Coverage, 10434,
     /*  92080 */   GIR_EraseRootFromParent_Done,
     /*  92081 */ // Label 1676: @92081
     /*  92081 */ GIM_Try, /*On fail goto*//*Label 1677*/ GIMT_Encode4(92113), // Rule ID 10435 //
     /*  92086 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  92089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92096 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92100 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  92100 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92103 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92105 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92107 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92112 */   // GIR_Coverage, 10435,
     /*  92112 */   GIR_EraseRootFromParent_Done,
     /*  92113 */ // Label 1677: @92113
     /*  92113 */ GIM_Reject,
     /*  92114 */ // Label 1411: @92114
     /*  92114 */ GIM_Try, /*On fail goto*//*Label 1678*/ GIMT_Encode4(92146), // Rule ID 10400 //
     /*  92119 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92122 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  92125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92129 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92133 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  92133 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92136 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92138 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92140 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92145 */   // GIR_Coverage, 10400,
     /*  92145 */   GIR_EraseRootFromParent_Done,
     /*  92146 */ // Label 1678: @92146
     /*  92146 */ GIM_Try, /*On fail goto*//*Label 1679*/ GIMT_Encode4(92178), // Rule ID 10401 //
     /*  92151 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  92157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92161 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92165 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  92165 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92168 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92170 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92172 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92177 */   // GIR_Coverage, 10401,
     /*  92177 */   GIR_EraseRootFromParent_Done,
     /*  92178 */ // Label 1679: @92178
     /*  92178 */ GIM_Try, /*On fail goto*//*Label 1680*/ GIMT_Encode4(92210), // Rule ID 10402 //
     /*  92183 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92186 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92193 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92197 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  92197 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92200 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92202 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92204 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92209 */   // GIR_Coverage, 10402,
     /*  92209 */   GIR_EraseRootFromParent_Done,
     /*  92210 */ // Label 1680: @92210
     /*  92210 */ GIM_Try, /*On fail goto*//*Label 1681*/ GIMT_Encode4(92242), // Rule ID 10403 //
     /*  92215 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92218 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  92221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92225 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92229 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  92229 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92232 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92234 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92236 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92241 */   // GIR_Coverage, 10403,
     /*  92241 */   GIR_EraseRootFromParent_Done,
     /*  92242 */ // Label 1681: @92242
     /*  92242 */ GIM_Try, /*On fail goto*//*Label 1682*/ GIMT_Encode4(92274), // Rule ID 10404 //
     /*  92247 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  92253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92257 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92261 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  92261 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92264 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92266 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92268 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92273 */   // GIR_Coverage, 10404,
     /*  92273 */   GIR_EraseRootFromParent_Done,
     /*  92274 */ // Label 1682: @92274
     /*  92274 */ GIM_Try, /*On fail goto*//*Label 1683*/ GIMT_Encode4(92306), // Rule ID 10405 //
     /*  92279 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92282 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92289 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92293 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  92293 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92296 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92298 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92300 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92305 */   // GIR_Coverage, 10405,
     /*  92305 */   GIR_EraseRootFromParent_Done,
     /*  92306 */ // Label 1683: @92306
     /*  92306 */ GIM_Try, /*On fail goto*//*Label 1684*/ GIMT_Encode4(92338), // Rule ID 10418 //
     /*  92311 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92314 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  92317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92321 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92325 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  92325 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92328 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92330 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92332 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92337 */   // GIR_Coverage, 10418,
     /*  92337 */   GIR_EraseRootFromParent_Done,
     /*  92338 */ // Label 1684: @92338
     /*  92338 */ GIM_Try, /*On fail goto*//*Label 1685*/ GIMT_Encode4(92370), // Rule ID 10419 //
     /*  92343 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92346 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  92349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92353 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92357 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  92357 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92360 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92362 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92364 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92369 */   // GIR_Coverage, 10419,
     /*  92369 */   GIR_EraseRootFromParent_Done,
     /*  92370 */ // Label 1685: @92370
     /*  92370 */ GIM_Try, /*On fail goto*//*Label 1686*/ GIMT_Encode4(92402), // Rule ID 10420 //
     /*  92375 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92378 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  92381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92385 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92389 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  92389 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92392 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92394 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92396 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92401 */   // GIR_Coverage, 10420,
     /*  92401 */   GIR_EraseRootFromParent_Done,
     /*  92402 */ // Label 1686: @92402
     /*  92402 */ GIM_Try, /*On fail goto*//*Label 1687*/ GIMT_Encode4(92434), // Rule ID 10421 //
     /*  92407 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92410 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92417 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92421 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  92421 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92424 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92426 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92428 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92433 */   // GIR_Coverage, 10421,
     /*  92433 */   GIR_EraseRootFromParent_Done,
     /*  92434 */ // Label 1687: @92434
     /*  92434 */ GIM_Try, /*On fail goto*//*Label 1688*/ GIMT_Encode4(92466), // Rule ID 10422 //
     /*  92439 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92442 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  92445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92449 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92453 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  92453 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92456 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92458 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92460 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92465 */   // GIR_Coverage, 10422,
     /*  92465 */   GIR_EraseRootFromParent_Done,
     /*  92466 */ // Label 1688: @92466
     /*  92466 */ GIM_Try, /*On fail goto*//*Label 1689*/ GIMT_Encode4(92498), // Rule ID 10423 //
     /*  92471 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92474 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92481 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92485 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  92485 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92488 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92490 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92492 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92497 */   // GIR_Coverage, 10423,
     /*  92497 */   GIR_EraseRootFromParent_Done,
     /*  92498 */ // Label 1689: @92498
     /*  92498 */ GIM_Try, /*On fail goto*//*Label 1690*/ GIMT_Encode4(92530), // Rule ID 10432 //
     /*  92503 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  92506 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  92509 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92513 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92517 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  92517 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92520 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92522 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92524 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92529 */   // GIR_Coverage, 10432,
     /*  92529 */   GIR_EraseRootFromParent_Done,
     /*  92530 */ // Label 1690: @92530
     /*  92530 */ GIM_Try, /*On fail goto*//*Label 1691*/ GIMT_Encode4(92562), // Rule ID 10433 //
     /*  92535 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  92538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  92541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92545 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92549 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  92549 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92552 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92554 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92556 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92561 */   // GIR_Coverage, 10433,
     /*  92561 */   GIR_EraseRootFromParent_Done,
     /*  92562 */ // Label 1691: @92562
     /*  92562 */ GIM_Reject,
     /*  92563 */ // Label 1412: @92563
     /*  92563 */ GIM_Try, /*On fail goto*//*Label 1692*/ GIMT_Encode4(92595), // Rule ID 10394 //
     /*  92568 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  92574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92578 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92582 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  92582 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92585 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92587 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92589 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92594 */   // GIR_Coverage, 10394,
     /*  92594 */   GIR_EraseRootFromParent_Done,
     /*  92595 */ // Label 1692: @92595
     /*  92595 */ GIM_Try, /*On fail goto*//*Label 1693*/ GIMT_Encode4(92627), // Rule ID 10395 //
     /*  92600 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92603 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  92606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92610 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92614 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  92614 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92617 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92619 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92621 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92626 */   // GIR_Coverage, 10395,
     /*  92626 */   GIR_EraseRootFromParent_Done,
     /*  92627 */ // Label 1693: @92627
     /*  92627 */ GIM_Try, /*On fail goto*//*Label 1694*/ GIMT_Encode4(92659), // Rule ID 10396 //
     /*  92632 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92635 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92642 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92646 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  92646 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92649 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92651 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92653 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92658 */   // GIR_Coverage, 10396,
     /*  92658 */   GIR_EraseRootFromParent_Done,
     /*  92659 */ // Label 1694: @92659
     /*  92659 */ GIM_Try, /*On fail goto*//*Label 1695*/ GIMT_Encode4(92691), // Rule ID 10397 //
     /*  92664 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  92670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92674 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92678 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  92678 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92681 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92683 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92685 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92690 */   // GIR_Coverage, 10397,
     /*  92690 */   GIR_EraseRootFromParent_Done,
     /*  92691 */ // Label 1695: @92691
     /*  92691 */ GIM_Try, /*On fail goto*//*Label 1696*/ GIMT_Encode4(92723), // Rule ID 10398 //
     /*  92696 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  92702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92706 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92710 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  92710 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92713 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92715 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92717 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92722 */   // GIR_Coverage, 10398,
     /*  92722 */   GIR_EraseRootFromParent_Done,
     /*  92723 */ // Label 1696: @92723
     /*  92723 */ GIM_Try, /*On fail goto*//*Label 1697*/ GIMT_Encode4(92755), // Rule ID 10399 //
     /*  92728 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92738 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92742 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  92742 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92745 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92747 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92749 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92754 */   // GIR_Coverage, 10399,
     /*  92754 */   GIR_EraseRootFromParent_Done,
     /*  92755 */ // Label 1697: @92755
     /*  92755 */ GIM_Try, /*On fail goto*//*Label 1698*/ GIMT_Encode4(92787), // Rule ID 10412 //
     /*  92760 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  92766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92770 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92774 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  92774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92777 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92779 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92781 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92786 */   // GIR_Coverage, 10412,
     /*  92786 */   GIR_EraseRootFromParent_Done,
     /*  92787 */ // Label 1698: @92787
     /*  92787 */ GIM_Try, /*On fail goto*//*Label 1699*/ GIMT_Encode4(92819), // Rule ID 10413 //
     /*  92792 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  92798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92802 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92806 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  92806 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92809 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92811 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92813 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92818 */   // GIR_Coverage, 10413,
     /*  92818 */   GIR_EraseRootFromParent_Done,
     /*  92819 */ // Label 1699: @92819
     /*  92819 */ GIM_Try, /*On fail goto*//*Label 1700*/ GIMT_Encode4(92851), // Rule ID 10414 //
     /*  92824 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  92830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92834 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92838 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  92838 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92841 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92843 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92845 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92850 */   // GIR_Coverage, 10414,
     /*  92850 */   GIR_EraseRootFromParent_Done,
     /*  92851 */ // Label 1700: @92851
     /*  92851 */ GIM_Try, /*On fail goto*//*Label 1701*/ GIMT_Encode4(92883), // Rule ID 10415 //
     /*  92856 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92866 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92870 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  92870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92873 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92875 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92877 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92882 */   // GIR_Coverage, 10415,
     /*  92882 */   GIR_EraseRootFromParent_Done,
     /*  92883 */ // Label 1701: @92883
     /*  92883 */ GIM_Try, /*On fail goto*//*Label 1702*/ GIMT_Encode4(92915), // Rule ID 10416 //
     /*  92888 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  92894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92898 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92902 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  92902 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92905 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92907 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92909 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92914 */   // GIR_Coverage, 10416,
     /*  92914 */   GIR_EraseRootFromParent_Done,
     /*  92915 */ // Label 1702: @92915
     /*  92915 */ GIM_Try, /*On fail goto*//*Label 1703*/ GIMT_Encode4(92947), // Rule ID 10417 //
     /*  92920 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92930 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92934 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  92934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92937 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92939 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92941 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92946 */   // GIR_Coverage, 10417,
     /*  92946 */   GIR_EraseRootFromParent_Done,
     /*  92947 */ // Label 1703: @92947
     /*  92947 */ GIM_Try, /*On fail goto*//*Label 1704*/ GIMT_Encode4(92979), // Rule ID 10430 //
     /*  92952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  92955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  92958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92962 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92966 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  92966 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92969 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92971 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92973 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92978 */   // GIR_Coverage, 10430,
     /*  92978 */   GIR_EraseRootFromParent_Done,
     /*  92979 */ // Label 1704: @92979
     /*  92979 */ GIM_Try, /*On fail goto*//*Label 1705*/ GIMT_Encode4(93011), // Rule ID 10431 //
     /*  92984 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  92987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  92990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92994 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92998 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  92998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93001 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93003 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93005 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93010 */   // GIR_Coverage, 10431,
     /*  93010 */   GIR_EraseRootFromParent_Done,
     /*  93011 */ // Label 1705: @93011
     /*  93011 */ GIM_Reject,
     /*  93012 */ // Label 1413: @93012
     /*  93012 */ GIM_Try, /*On fail goto*//*Label 1706*/ GIMT_Encode4(93044), // Rule ID 10388 //
     /*  93017 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93020 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  93023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93027 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93031 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  93031 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93034 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93036 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93038 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93043 */   // GIR_Coverage, 10388,
     /*  93043 */   GIR_EraseRootFromParent_Done,
     /*  93044 */ // Label 1706: @93044
     /*  93044 */ GIM_Try, /*On fail goto*//*Label 1707*/ GIMT_Encode4(93076), // Rule ID 10389 //
     /*  93049 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93052 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93059 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93063 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  93063 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93066 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93068 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93070 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93075 */   // GIR_Coverage, 10389,
     /*  93075 */   GIR_EraseRootFromParent_Done,
     /*  93076 */ // Label 1707: @93076
     /*  93076 */ GIM_Try, /*On fail goto*//*Label 1708*/ GIMT_Encode4(93108), // Rule ID 10390 //
     /*  93081 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93091 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93095 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  93095 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93098 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93100 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93102 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93107 */   // GIR_Coverage, 10390,
     /*  93107 */   GIR_EraseRootFromParent_Done,
     /*  93108 */ // Label 1708: @93108
     /*  93108 */ GIM_Try, /*On fail goto*//*Label 1709*/ GIMT_Encode4(93140), // Rule ID 10391 //
     /*  93113 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93116 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  93119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93123 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93127 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  93127 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93130 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93132 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93134 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93139 */   // GIR_Coverage, 10391,
     /*  93139 */   GIR_EraseRootFromParent_Done,
     /*  93140 */ // Label 1709: @93140
     /*  93140 */ GIM_Try, /*On fail goto*//*Label 1710*/ GIMT_Encode4(93172), // Rule ID 10392 //
     /*  93145 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93155 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93159 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  93159 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93162 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93164 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93166 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93171 */   // GIR_Coverage, 10392,
     /*  93171 */   GIR_EraseRootFromParent_Done,
     /*  93172 */ // Label 1710: @93172
     /*  93172 */ GIM_Try, /*On fail goto*//*Label 1711*/ GIMT_Encode4(93204), // Rule ID 10393 //
     /*  93177 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93180 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93183 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93187 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93191 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  93191 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93194 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93196 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93198 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  93203 */   // GIR_Coverage, 10393,
     /*  93203 */   GIR_EraseRootFromParent_Done,
     /*  93204 */ // Label 1711: @93204
     /*  93204 */ GIM_Reject,
     /*  93205 */ // Label 1414: @93205
     /*  93205 */ GIM_Reject,
     /*  93206 */ // Label 10: @93206
     /*  93206 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1720*/ GIMT_Encode4(93696),
     /*  93217 */ /*GILLT_s16*//*Label 1712*/ GIMT_Encode4(93257),
     /*  93221 */ /*GILLT_s32*//*Label 1713*/ GIMT_Encode4(93288),
     /*  93225 */ /*GILLT_s64*//*Label 1714*/ GIMT_Encode4(93319), GIMT_Encode4(0),
     /*  93233 */ /*GILLT_v2s32*//*Label 1715*/ GIMT_Encode4(93350),
     /*  93237 */ /*GILLT_v2s64*//*Label 1716*/ GIMT_Encode4(93381),
     /*  93241 */ /*GILLT_v4s16*//*Label 1717*/ GIMT_Encode4(93412),
     /*  93245 */ /*GILLT_v4s32*//*Label 1718*/ GIMT_Encode4(93443), GIMT_Encode4(0),
     /*  93253 */ /*GILLT_v8s16*//*Label 1719*/ GIMT_Encode4(93474),
     /*  93257 */ // Label 1712: @93257
     /*  93257 */ GIM_Try, /*On fail goto*//*Label 1721*/ GIMT_Encode4(93287), // Rule ID 564 //
     /*  93262 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  93265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  93268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  93272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  93276 */   // (ftrunc:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTZHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /*  93276 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZHr),
     /*  93281 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  93285 */   GIR_RootConstrainSelectedInstOperands,
     /*  93286 */   // GIR_Coverage, 564,
     /*  93286 */   GIR_Done,
     /*  93287 */ // Label 1721: @93287
     /*  93287 */ GIM_Reject,
     /*  93288 */ // Label 1713: @93288
     /*  93288 */ GIM_Try, /*On fail goto*//*Label 1722*/ GIMT_Encode4(93318), // Rule ID 566 //
     /*  93293 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  93296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  93299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  93303 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  93307 */   // (ftrunc:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /*  93307 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZSr),
     /*  93312 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  93316 */   GIR_RootConstrainSelectedInstOperands,
     /*  93317 */   // GIR_Coverage, 566,
     /*  93317 */   GIR_Done,
     /*  93318 */ // Label 1722: @93318
     /*  93318 */ GIM_Reject,
     /*  93319 */ // Label 1714: @93319
     /*  93319 */ GIM_Try, /*On fail goto*//*Label 1723*/ GIMT_Encode4(93349), // Rule ID 568 //
     /*  93324 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  93327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  93330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93334 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93338 */   // (ftrunc:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /*  93338 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZDr),
     /*  93343 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  93347 */   GIR_RootConstrainSelectedInstOperands,
     /*  93348 */   // GIR_Coverage, 568,
     /*  93348 */   GIR_Done,
     /*  93349 */ // Label 1723: @93349
     /*  93349 */ GIM_Reject,
     /*  93350 */ // Label 1715: @93350
     /*  93350 */ GIM_Try, /*On fail goto*//*Label 1724*/ GIMT_Encode4(93380), // Rule ID 926 //
     /*  93355 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  93358 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  93361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93365 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93369 */   // (ftrunc:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTZv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /*  93369 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv2f32),
     /*  93374 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  93378 */   GIR_RootConstrainSelectedInstOperands,
     /*  93379 */   // GIR_Coverage, 926,
     /*  93379 */   GIR_Done,
     /*  93380 */ // Label 1724: @93380
     /*  93380 */ GIM_Reject,
     /*  93381 */ // Label 1716: @93381
     /*  93381 */ GIM_Try, /*On fail goto*//*Label 1725*/ GIMT_Encode4(93411), // Rule ID 930 //
     /*  93386 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  93389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  93392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93396 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93400 */   // (ftrunc:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTZv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /*  93400 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv2f64),
     /*  93405 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  93409 */   GIR_RootConstrainSelectedInstOperands,
     /*  93410 */   // GIR_Coverage, 930,
     /*  93410 */   GIR_Done,
     /*  93411 */ // Label 1725: @93411
     /*  93411 */ GIM_Reject,
     /*  93412 */ // Label 1717: @93412
     /*  93412 */ GIM_Try, /*On fail goto*//*Label 1726*/ GIMT_Encode4(93442), // Rule ID 922 //
     /*  93417 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  93420 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  93423 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93427 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93431 */   // (ftrunc:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTZv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /*  93431 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f16),
     /*  93436 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  93440 */   GIR_RootConstrainSelectedInstOperands,
     /*  93441 */   // GIR_Coverage, 922,
     /*  93441 */   GIR_Done,
     /*  93442 */ // Label 1726: @93442
     /*  93442 */ GIM_Reject,
     /*  93443 */ // Label 1718: @93443
     /*  93443 */ GIM_Try, /*On fail goto*//*Label 1727*/ GIMT_Encode4(93473), // Rule ID 928 //
     /*  93448 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  93451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  93454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93458 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93462 */   // (ftrunc:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTZv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /*  93462 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
     /*  93467 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  93471 */   GIR_RootConstrainSelectedInstOperands,
     /*  93472 */   // GIR_Coverage, 928,
     /*  93472 */   GIR_Done,
     /*  93473 */ // Label 1727: @93473
     /*  93473 */ GIM_Reject,
     /*  93474 */ // Label 1719: @93474
     /*  93474 */ GIM_Try, /*On fail goto*//*Label 1728*/ GIMT_Encode4(93695),
     /*  93479 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  93482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93486 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93490 */   GIM_Try, /*On fail goto*//*Label 1729*/ GIMT_Encode4(93509), // Rule ID 924 //
     /*  93495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  93498 */     // (ftrunc:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTZv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /*  93498 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv8f16),
     /*  93503 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  93507 */     GIR_RootConstrainSelectedInstOperands,
     /*  93508 */     // GIR_Coverage, 924,
     /*  93508 */     GIR_Done,
     /*  93509 */   // Label 1729: @93509
     /*  93509 */   GIM_Try, /*On fail goto*//*Label 1730*/ GIMT_Encode4(93694), // Rule ID 6912 //
     /*  93514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /*  93517 */     // (ftrunc:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTZv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTZv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /*  93517 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /*  93520 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /*  93524 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93529 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  93533 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  93535 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /*  93538 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
     /*  93542 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93547 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  93550 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  93552 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /*  93555 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93559 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93564 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /*  93570 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93575 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93580 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /*  93583 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /*  93587 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93592 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  93595 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  93597 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /*  93600 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
     /*  93604 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93609 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  93612 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  93614 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /*  93617 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /*  93621 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93626 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  93629 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  93631 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  93634 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  93638 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93643 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  93645 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  93648 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  93652 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93657 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  93660 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  93663 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  93666 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93671 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93676 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /*  93684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93686 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  93689 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  93692 */     GIR_RootConstrainSelectedInstOperands,
     /*  93693 */     // GIR_Coverage, 6912,
     /*  93693 */     GIR_EraseRootFromParent_Done,
     /*  93694 */   // Label 1730: @93694
     /*  93694 */   GIM_Reject,
     /*  93695 */ // Label 1728: @93695
     /*  93695 */ GIM_Reject,
     /*  93696 */ // Label 1720: @93696
     /*  93696 */ GIM_Reject,
     /*  93697 */ // Label 11: @93697
     /*  93697 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1739*/ GIMT_Encode4(94187),
     /*  93708 */ /*GILLT_s16*//*Label 1731*/ GIMT_Encode4(93748),
     /*  93712 */ /*GILLT_s32*//*Label 1732*/ GIMT_Encode4(93779),
     /*  93716 */ /*GILLT_s64*//*Label 1733*/ GIMT_Encode4(93810), GIMT_Encode4(0),
     /*  93724 */ /*GILLT_v2s32*//*Label 1734*/ GIMT_Encode4(93841),
     /*  93728 */ /*GILLT_v2s64*//*Label 1735*/ GIMT_Encode4(93872),
     /*  93732 */ /*GILLT_v4s16*//*Label 1736*/ GIMT_Encode4(93903),
     /*  93736 */ /*GILLT_v4s32*//*Label 1737*/ GIMT_Encode4(93934), GIMT_Encode4(0),
     /*  93744 */ /*GILLT_v8s16*//*Label 1738*/ GIMT_Encode4(93965),
     /*  93748 */ // Label 1731: @93748
     /*  93748 */ GIM_Try, /*On fail goto*//*Label 1740*/ GIMT_Encode4(93778), // Rule ID 528 //
     /*  93753 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  93756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  93759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  93763 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  93767 */   // (fround:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTAHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /*  93767 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAHr),
     /*  93772 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  93776 */   GIR_RootConstrainSelectedInstOperands,
     /*  93777 */   // GIR_Coverage, 528,
     /*  93777 */   GIR_Done,
     /*  93778 */ // Label 1740: @93778
     /*  93778 */ GIM_Reject,
     /*  93779 */ // Label 1732: @93779
     /*  93779 */ GIM_Try, /*On fail goto*//*Label 1741*/ GIMT_Encode4(93809), // Rule ID 530 //
     /*  93784 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  93787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  93790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  93794 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  93798 */   // (fround:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTASr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /*  93798 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTASr),
     /*  93803 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  93807 */   GIR_RootConstrainSelectedInstOperands,
     /*  93808 */   // GIR_Coverage, 530,
     /*  93808 */   GIR_Done,
     /*  93809 */ // Label 1741: @93809
     /*  93809 */ GIM_Reject,
     /*  93810 */ // Label 1733: @93810
     /*  93810 */ GIM_Try, /*On fail goto*//*Label 1742*/ GIMT_Encode4(93840), // Rule ID 532 //
     /*  93815 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  93818 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  93821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93825 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93829 */   // (fround:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTADr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /*  93829 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTADr),
     /*  93834 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  93838 */   GIR_RootConstrainSelectedInstOperands,
     /*  93839 */   // GIR_Coverage, 532,
     /*  93839 */   GIR_Done,
     /*  93840 */ // Label 1742: @93840
     /*  93840 */ GIM_Reject,
     /*  93841 */ // Label 1734: @93841
     /*  93841 */ GIM_Try, /*On fail goto*//*Label 1743*/ GIMT_Encode4(93871), // Rule ID 866 //
     /*  93846 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  93849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  93852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93856 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93860 */   // (fround:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /*  93860 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv2f32),
     /*  93865 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  93869 */   GIR_RootConstrainSelectedInstOperands,
     /*  93870 */   // GIR_Coverage, 866,
     /*  93870 */   GIR_Done,
     /*  93871 */ // Label 1743: @93871
     /*  93871 */ GIM_Reject,
     /*  93872 */ // Label 1735: @93872
     /*  93872 */ GIM_Try, /*On fail goto*//*Label 1744*/ GIMT_Encode4(93902), // Rule ID 870 //
     /*  93877 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  93880 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  93883 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93887 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93891 */   // (fround:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /*  93891 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv2f64),
     /*  93896 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  93900 */   GIR_RootConstrainSelectedInstOperands,
     /*  93901 */   // GIR_Coverage, 870,
     /*  93901 */   GIR_Done,
     /*  93902 */ // Label 1744: @93902
     /*  93902 */ GIM_Reject,
     /*  93903 */ // Label 1736: @93903
     /*  93903 */ GIM_Try, /*On fail goto*//*Label 1745*/ GIMT_Encode4(93933), // Rule ID 862 //
     /*  93908 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  93911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  93914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93918 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93922 */   // (fround:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /*  93922 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f16),
     /*  93927 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  93931 */   GIR_RootConstrainSelectedInstOperands,
     /*  93932 */   // GIR_Coverage, 862,
     /*  93932 */   GIR_Done,
     /*  93933 */ // Label 1745: @93933
     /*  93933 */ GIM_Reject,
     /*  93934 */ // Label 1737: @93934
     /*  93934 */ GIM_Try, /*On fail goto*//*Label 1746*/ GIMT_Encode4(93964), // Rule ID 868 //
     /*  93939 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  93942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  93945 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93949 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93953 */   // (fround:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /*  93953 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
     /*  93958 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  93962 */   GIR_RootConstrainSelectedInstOperands,
     /*  93963 */   // GIR_Coverage, 868,
     /*  93963 */   GIR_Done,
     /*  93964 */ // Label 1746: @93964
     /*  93964 */ GIM_Reject,
     /*  93965 */ // Label 1738: @93965
     /*  93965 */ GIM_Try, /*On fail goto*//*Label 1747*/ GIMT_Encode4(94186),
     /*  93970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  93973 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93977 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93981 */   GIM_Try, /*On fail goto*//*Label 1748*/ GIMT_Encode4(94000), // Rule ID 864 //
     /*  93986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  93989 */     // (fround:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /*  93989 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv8f16),
     /*  93994 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  93998 */     GIR_RootConstrainSelectedInstOperands,
     /*  93999 */     // GIR_Coverage, 864,
     /*  93999 */     GIR_Done,
     /*  94000 */   // Label 1748: @94000
     /*  94000 */   GIM_Try, /*On fail goto*//*Label 1749*/ GIMT_Encode4(94185), // Rule ID 6906 //
     /*  94005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /*  94008 */     // (fround:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTAv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTAv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /*  94008 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /*  94011 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /*  94015 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94020 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  94024 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  94026 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /*  94029 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
     /*  94033 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94038 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  94041 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  94043 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /*  94046 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94050 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94055 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /*  94061 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94066 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94071 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /*  94074 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /*  94078 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94083 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  94086 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  94088 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /*  94091 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
     /*  94095 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94100 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  94103 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  94105 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /*  94108 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /*  94112 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94117 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  94120 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  94122 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  94125 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  94129 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94134 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  94136 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  94139 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  94143 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94148 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  94151 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  94154 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  94157 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94162 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94167 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /*  94175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94177 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94180 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  94183 */     GIR_RootConstrainSelectedInstOperands,
     /*  94184 */     // GIR_Coverage, 6906,
     /*  94184 */     GIR_EraseRootFromParent_Done,
     /*  94185 */   // Label 1749: @94185
     /*  94185 */   GIM_Reject,
     /*  94186 */ // Label 1747: @94186
     /*  94186 */ GIM_Reject,
     /*  94187 */ // Label 1739: @94187
     /*  94187 */ GIM_Reject,
     /*  94188 */ // Label 12: @94188
     /*  94188 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 1752*/ GIMT_Encode4(94455),
     /*  94199 */ /*GILLT_s32*//*Label 1750*/ GIMT_Encode4(94207),
     /*  94203 */ /*GILLT_s64*//*Label 1751*/ GIMT_Encode4(94331),
     /*  94207 */ // Label 1750: @94207
     /*  94207 */ GIM_Try, /*On fail goto*//*Label 1753*/ GIMT_Encode4(94250), // Rule ID 4725 //
     /*  94212 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  94215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  94218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  94222 */   // (lrint:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
     /*  94222 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  94225 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /*  94229 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94234 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  94238 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94240 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /*  94243 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94245 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94248 */   GIR_RootConstrainSelectedInstOperands,
     /*  94249 */   // GIR_Coverage, 4725,
     /*  94249 */   GIR_EraseRootFromParent_Done,
     /*  94250 */ // Label 1753: @94250
     /*  94250 */ GIM_Try, /*On fail goto*//*Label 1754*/ GIMT_Encode4(94290), // Rule ID 4731 //
     /*  94255 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  94258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  94262 */   // (lrint:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /*  94262 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  94265 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /*  94269 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94274 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  94278 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94280 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /*  94283 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94285 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94288 */   GIR_RootConstrainSelectedInstOperands,
     /*  94289 */   // GIR_Coverage, 4731,
     /*  94289 */   GIR_EraseRootFromParent_Done,
     /*  94290 */ // Label 1754: @94290
     /*  94290 */ GIM_Try, /*On fail goto*//*Label 1755*/ GIMT_Encode4(94330), // Rule ID 4733 //
     /*  94295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  94298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  94302 */   // (lrint:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /*  94302 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  94305 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /*  94309 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94314 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  94318 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94320 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /*  94323 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94325 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94328 */   GIR_RootConstrainSelectedInstOperands,
     /*  94329 */   // GIR_Coverage, 4733,
     /*  94329 */   GIR_EraseRootFromParent_Done,
     /*  94330 */ // Label 1755: @94330
     /*  94330 */ GIM_Reject,
     /*  94331 */ // Label 1751: @94331
     /*  94331 */ GIM_Try, /*On fail goto*//*Label 1756*/ GIMT_Encode4(94374), // Rule ID 4727 //
     /*  94336 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  94339 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  94342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  94346 */   // (lrint:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
     /*  94346 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  94349 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /*  94353 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94358 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  94362 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94364 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /*  94367 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94369 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94372 */   GIR_RootConstrainSelectedInstOperands,
     /*  94373 */   // GIR_Coverage, 4727,
     /*  94373 */   GIR_EraseRootFromParent_Done,
     /*  94374 */ // Label 1756: @94374
     /*  94374 */ GIM_Try, /*On fail goto*//*Label 1757*/ GIMT_Encode4(94414), // Rule ID 4735 //
     /*  94379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  94382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  94386 */   // (lrint:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /*  94386 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  94389 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /*  94393 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94398 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  94402 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94404 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /*  94407 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94409 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94412 */   GIR_RootConstrainSelectedInstOperands,
     /*  94413 */   // GIR_Coverage, 4735,
     /*  94413 */   GIR_EraseRootFromParent_Done,
     /*  94414 */ // Label 1757: @94414
     /*  94414 */ GIM_Try, /*On fail goto*//*Label 1758*/ GIMT_Encode4(94454), // Rule ID 4737 //
     /*  94419 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  94422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  94426 */   // (lrint:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /*  94426 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  94429 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /*  94433 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94438 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  94442 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94444 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /*  94447 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94449 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94452 */   GIR_RootConstrainSelectedInstOperands,
     /*  94453 */   // GIR_Coverage, 4737,
     /*  94453 */   GIR_EraseRootFromParent_Done,
     /*  94454 */ // Label 1758: @94454
     /*  94454 */ GIM_Reject,
     /*  94455 */ // Label 1752: @94455
     /*  94455 */ GIM_Reject,
     /*  94456 */ // Label 13: @94456
     /*  94456 */ GIM_Try, /*On fail goto*//*Label 1759*/ GIMT_Encode4(94605),
     /*  94461 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  94464 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 1763*/ GIMT_Encode4(94604),
     /*  94475 */   /*GILLT_s16*//*Label 1760*/ GIMT_Encode4(94487),
     /*  94479 */   /*GILLT_s32*//*Label 1761*/ GIMT_Encode4(94528),
     /*  94483 */   /*GILLT_s64*//*Label 1762*/ GIMT_Encode4(94566),
     /*  94487 */   // Label 1760: @94487
     /*  94487 */   GIM_Try, /*On fail goto*//*Label 1764*/ GIMT_Encode4(94527), // Rule ID 4729 //
     /*  94492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  94495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  94499 */     // (llrint:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
     /*  94499 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  94502 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /*  94506 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94511 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  94515 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /*  94520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94522 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94525 */     GIR_RootConstrainSelectedInstOperands,
     /*  94526 */     // GIR_Coverage, 4729,
     /*  94526 */     GIR_EraseRootFromParent_Done,
     /*  94527 */   // Label 1764: @94527
     /*  94527 */   GIM_Reject,
     /*  94528 */   // Label 1761: @94528
     /*  94528 */   GIM_Try, /*On fail goto*//*Label 1765*/ GIMT_Encode4(94565), // Rule ID 4739 //
     /*  94533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  94537 */     // (llrint:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /*  94537 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  94540 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /*  94544 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94549 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  94553 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /*  94558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94560 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94563 */     GIR_RootConstrainSelectedInstOperands,
     /*  94564 */     // GIR_Coverage, 4739,
     /*  94564 */     GIR_EraseRootFromParent_Done,
     /*  94565 */   // Label 1765: @94565
     /*  94565 */   GIM_Reject,
     /*  94566 */   // Label 1762: @94566
     /*  94566 */   GIM_Try, /*On fail goto*//*Label 1766*/ GIMT_Encode4(94603), // Rule ID 4741 //
     /*  94571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  94575 */     // (llrint:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /*  94575 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  94578 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /*  94582 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94587 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  94591 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /*  94596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94598 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94601 */     GIR_RootConstrainSelectedInstOperands,
     /*  94602 */     // GIR_Coverage, 4741,
     /*  94602 */     GIR_EraseRootFromParent_Done,
     /*  94603 */   // Label 1766: @94603
     /*  94603 */   GIM_Reject,
     /*  94604 */   // Label 1763: @94604
     /*  94604 */   GIM_Reject,
     /*  94605 */ // Label 1759: @94605
     /*  94605 */ GIM_Reject,
     /*  94606 */ // Label 14: @94606
     /*  94606 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1775*/ GIMT_Encode4(95096),
     /*  94617 */ /*GILLT_s16*//*Label 1767*/ GIMT_Encode4(94657),
     /*  94621 */ /*GILLT_s32*//*Label 1768*/ GIMT_Encode4(94688),
     /*  94625 */ /*GILLT_s64*//*Label 1769*/ GIMT_Encode4(94719), GIMT_Encode4(0),
     /*  94633 */ /*GILLT_v2s32*//*Label 1770*/ GIMT_Encode4(94750),
     /*  94637 */ /*GILLT_v2s64*//*Label 1771*/ GIMT_Encode4(94781),
     /*  94641 */ /*GILLT_v4s16*//*Label 1772*/ GIMT_Encode4(94812),
     /*  94645 */ /*GILLT_v4s32*//*Label 1773*/ GIMT_Encode4(94843), GIMT_Encode4(0),
     /*  94653 */ /*GILLT_v8s16*//*Label 1774*/ GIMT_Encode4(94874),
     /*  94657 */ // Label 1767: @94657
     /*  94657 */ GIM_Try, /*On fail goto*//*Label 1776*/ GIMT_Encode4(94687), // Rule ID 546 //
     /*  94662 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  94665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  94668 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  94672 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  94676 */   // (froundeven:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTNHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /*  94676 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNHr),
     /*  94681 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  94685 */   GIR_RootConstrainSelectedInstOperands,
     /*  94686 */   // GIR_Coverage, 546,
     /*  94686 */   GIR_Done,
     /*  94687 */ // Label 1776: @94687
     /*  94687 */ GIM_Reject,
     /*  94688 */ // Label 1768: @94688
     /*  94688 */ GIM_Try, /*On fail goto*//*Label 1777*/ GIMT_Encode4(94718), // Rule ID 548 //
     /*  94693 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  94696 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  94699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  94703 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  94707 */   // (froundeven:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTNSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /*  94707 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNSr),
     /*  94712 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  94716 */   GIR_RootConstrainSelectedInstOperands,
     /*  94717 */   // GIR_Coverage, 548,
     /*  94717 */   GIR_Done,
     /*  94718 */ // Label 1777: @94718
     /*  94718 */ GIM_Reject,
     /*  94719 */ // Label 1769: @94719
     /*  94719 */ GIM_Try, /*On fail goto*//*Label 1778*/ GIMT_Encode4(94749), // Rule ID 550 //
     /*  94724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  94727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  94730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94734 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94738 */   // (froundeven:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTNDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /*  94738 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNDr),
     /*  94743 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  94747 */   GIR_RootConstrainSelectedInstOperands,
     /*  94748 */   // GIR_Coverage, 550,
     /*  94748 */   GIR_Done,
     /*  94749 */ // Label 1778: @94749
     /*  94749 */ GIM_Reject,
     /*  94750 */ // Label 1770: @94750
     /*  94750 */ GIM_Try, /*On fail goto*//*Label 1779*/ GIMT_Encode4(94780), // Rule ID 896 //
     /*  94755 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  94758 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  94761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94765 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94769 */   // (froundeven:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTNv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /*  94769 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv2f32),
     /*  94774 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  94778 */   GIR_RootConstrainSelectedInstOperands,
     /*  94779 */   // GIR_Coverage, 896,
     /*  94779 */   GIR_Done,
     /*  94780 */ // Label 1779: @94780
     /*  94780 */ GIM_Reject,
     /*  94781 */ // Label 1771: @94781
     /*  94781 */ GIM_Try, /*On fail goto*//*Label 1780*/ GIMT_Encode4(94811), // Rule ID 900 //
     /*  94786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  94789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  94792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94796 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94800 */   // (froundeven:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTNv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /*  94800 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv2f64),
     /*  94805 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  94809 */   GIR_RootConstrainSelectedInstOperands,
     /*  94810 */   // GIR_Coverage, 900,
     /*  94810 */   GIR_Done,
     /*  94811 */ // Label 1780: @94811
     /*  94811 */ GIM_Reject,
     /*  94812 */ // Label 1772: @94812
     /*  94812 */ GIM_Try, /*On fail goto*//*Label 1781*/ GIMT_Encode4(94842), // Rule ID 892 //
     /*  94817 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  94820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  94823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94827 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94831 */   // (froundeven:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTNv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /*  94831 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f16),
     /*  94836 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  94840 */   GIR_RootConstrainSelectedInstOperands,
     /*  94841 */   // GIR_Coverage, 892,
     /*  94841 */   GIR_Done,
     /*  94842 */ // Label 1781: @94842
     /*  94842 */ GIM_Reject,
     /*  94843 */ // Label 1773: @94843
     /*  94843 */ GIM_Try, /*On fail goto*//*Label 1782*/ GIMT_Encode4(94873), // Rule ID 898 //
     /*  94848 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  94851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  94854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94858 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94862 */   // (froundeven:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTNv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /*  94862 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
     /*  94867 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  94871 */   GIR_RootConstrainSelectedInstOperands,
     /*  94872 */   // GIR_Coverage, 898,
     /*  94872 */   GIR_Done,
     /*  94873 */ // Label 1782: @94873
     /*  94873 */ GIM_Reject,
     /*  94874 */ // Label 1774: @94874
     /*  94874 */ GIM_Try, /*On fail goto*//*Label 1783*/ GIMT_Encode4(95095),
     /*  94879 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  94882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94886 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94890 */   GIM_Try, /*On fail goto*//*Label 1784*/ GIMT_Encode4(94909), // Rule ID 894 //
     /*  94895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  94898 */     // (froundeven:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTNv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /*  94898 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv8f16),
     /*  94903 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  94907 */     GIR_RootConstrainSelectedInstOperands,
     /*  94908 */     // GIR_Coverage, 894,
     /*  94908 */     GIR_Done,
     /*  94909 */   // Label 1784: @94909
     /*  94909 */   GIM_Try, /*On fail goto*//*Label 1785*/ GIMT_Encode4(95094), // Rule ID 6908 //
     /*  94914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /*  94917 */     // (froundeven:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTNv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTNv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /*  94917 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /*  94920 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /*  94924 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94929 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  94933 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  94935 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /*  94938 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
     /*  94942 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94947 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  94950 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  94952 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /*  94955 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94959 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94964 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /*  94970 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94975 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94980 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /*  94983 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /*  94987 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94992 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  94995 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  94997 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /*  95000 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
     /*  95004 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95009 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  95012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  95014 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /*  95017 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /*  95021 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95026 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  95029 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  95031 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  95034 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  95038 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95043 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  95045 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  95048 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  95052 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95057 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  95060 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  95063 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  95066 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95071 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95076 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  95081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /*  95084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95086 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  95089 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  95092 */     GIR_RootConstrainSelectedInstOperands,
     /*  95093 */     // GIR_Coverage, 6908,
     /*  95093 */     GIR_EraseRootFromParent_Done,
     /*  95094 */   // Label 1785: @95094
     /*  95094 */   GIM_Reject,
     /*  95095 */ // Label 1783: @95095
     /*  95095 */ GIM_Reject,
     /*  95096 */ // Label 1775: @95096
     /*  95096 */ GIM_Reject,
     /*  95097 */ // Label 15: @95097
     /*  95097 */ GIM_Try, /*On fail goto*//*Label 1786*/ GIMT_Encode4(95129), // Rule ID 3846 //
     /*  95102 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  95105 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  95109 */   // (readcyclecounter:{ *:[i64] })  =>  (MRS:{ *:[i64] }:{ *:[i32] } 57090:{ *:[i32] })
     /*  95109 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS),
     /*  95112 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  95114 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(57090),
     /*  95124 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  95127 */   GIR_RootConstrainSelectedInstOperands,
     /*  95128 */   // GIR_Coverage, 3846,
     /*  95128 */   GIR_EraseRootFromParent_Done,
     /*  95129 */ // Label 1786: @95129
     /*  95129 */ GIM_Reject,
     /*  95130 */ // Label 16: @95130
     /*  95130 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(24), /*)*//*default:*//*Label 1807*/ GIMT_Encode4(103725),
     /*  95141 */ /*GILLT_s8*//*Label 1787*/ GIMT_Encode4(95237),
     /*  95145 */ /*GILLT_s16*//*Label 1788*/ GIMT_Encode4(95413),
     /*  95149 */ /*GILLT_s32*//*Label 1789*/ GIMT_Encode4(95589),
     /*  95153 */ /*GILLT_s64*//*Label 1790*/ GIMT_Encode4(97887),
     /*  95157 */ /*GILLT_s128*//*Label 1791*/ GIMT_Encode4(100568),
     /*  95161 */ /*GILLT_v2s32*//*Label 1792*/ GIMT_Encode4(100777),
     /*  95165 */ /*GILLT_v2s64*//*Label 1793*/ GIMT_Encode4(101155),
     /*  95169 */ /*GILLT_v4s16*//*Label 1794*/ GIMT_Encode4(101533),
     /*  95173 */ /*GILLT_v4s32*//*Label 1795*/ GIMT_Encode4(101911),
     /*  95177 */ /*GILLT_v8s8*//*Label 1796*/ GIMT_Encode4(102289),
     /*  95181 */ /*GILLT_v8s16*//*Label 1797*/ GIMT_Encode4(102497),
     /*  95185 */ /*GILLT_v16s8*//*Label 1798*/ GIMT_Encode4(102875), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  95197 */ /*GILLT_nxv2s16*//*Label 1799*/ GIMT_Encode4(103083),
     /*  95201 */ /*GILLT_nxv2s32*//*Label 1800*/ GIMT_Encode4(103147),
     /*  95205 */ /*GILLT_nxv2s64*//*Label 1801*/ GIMT_Encode4(103211), GIMT_Encode4(0),
     /*  95213 */ /*GILLT_nxv4s16*//*Label 1802*/ GIMT_Encode4(103325),
     /*  95217 */ /*GILLT_nxv4s32*//*Label 1803*/ GIMT_Encode4(103389), GIMT_Encode4(0),
     /*  95225 */ /*GILLT_nxv8s16*//*Label 1804*/ GIMT_Encode4(103503),
     /*  95229 */ /*GILLT_nxv16s1*//*Label 1805*/ GIMT_Encode4(103617),
     /*  95233 */ /*GILLT_nxv16s8*//*Label 1806*/ GIMT_Encode4(103661),
     /*  95237 */ // Label 1787: @95237
     /*  95237 */ GIM_Try, /*On fail goto*//*Label 1808*/ GIMT_Encode4(95412),
     /*  95242 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95245 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  95249 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /*  95253 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95257 */   GIM_Try, /*On fail goto*//*Label 1809*/ GIMT_Encode4(95298), // Rule ID 237 //
     /*  95262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  95265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /*  95272 */     // (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /*  95272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /*  95275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  95277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  95282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  95287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  95292 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95296 */     GIR_RootConstrainSelectedInstOperands,
     /*  95297 */     // GIR_Coverage, 237,
     /*  95297 */     GIR_EraseRootFromParent_Done,
     /*  95298 */   // Label 1809: @95298
     /*  95298 */   GIM_Try, /*On fail goto*//*Label 1810*/ GIMT_Encode4(95339), // Rule ID 238 //
     /*  95303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  95306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /*  95313 */     // (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /*  95313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /*  95316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  95318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  95323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  95328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  95333 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95337 */     GIR_RootConstrainSelectedInstOperands,
     /*  95338 */     // GIR_Coverage, 238,
     /*  95338 */     GIR_EraseRootFromParent_Done,
     /*  95339 */   // Label 1810: @95339
     /*  95339 */   GIM_Try, /*On fail goto*//*Label 1811*/ GIMT_Encode4(95375), // Rule ID 261 //
     /*  95344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  95347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /*  95354 */     // (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /*  95354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /*  95357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  95359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  95364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  95369 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95373 */     GIR_RootConstrainSelectedInstOperands,
     /*  95374 */     // GIR_Coverage, 261,
     /*  95374 */     GIR_EraseRootFromParent_Done,
     /*  95375 */   // Label 1811: @95375
     /*  95375 */   GIM_Try, /*On fail goto*//*Label 1812*/ GIMT_Encode4(95411), // Rule ID 282 //
     /*  95380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  95383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /*  95390 */     // (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /*  95390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /*  95393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  95395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  95400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  95405 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95409 */     GIR_RootConstrainSelectedInstOperands,
     /*  95410 */     // GIR_Coverage, 282,
     /*  95410 */     GIR_EraseRootFromParent_Done,
     /*  95411 */   // Label 1812: @95411
     /*  95411 */   GIM_Reject,
     /*  95412 */ // Label 1808: @95412
     /*  95412 */ GIM_Reject,
     /*  95413 */ // Label 1788: @95413
     /*  95413 */ GIM_Try, /*On fail goto*//*Label 1813*/ GIMT_Encode4(95588),
     /*  95418 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95421 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  95425 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  95429 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95433 */   GIM_Try, /*On fail goto*//*Label 1814*/ GIMT_Encode4(95474), // Rule ID 239 //
     /*  95438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  95441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /*  95448 */     // (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHroW:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /*  95448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /*  95451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  95453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  95458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  95463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  95468 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95472 */     GIR_RootConstrainSelectedInstOperands,
     /*  95473 */     // GIR_Coverage, 239,
     /*  95473 */     GIR_EraseRootFromParent_Done,
     /*  95474 */   // Label 1814: @95474
     /*  95474 */   GIM_Try, /*On fail goto*//*Label 1815*/ GIMT_Encode4(95515), // Rule ID 240 //
     /*  95479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  95482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /*  95489 */     // (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHroX:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /*  95489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /*  95492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  95494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  95499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  95504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  95509 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95513 */     GIR_RootConstrainSelectedInstOperands,
     /*  95514 */     // GIR_Coverage, 240,
     /*  95514 */     GIR_EraseRootFromParent_Done,
     /*  95515 */   // Label 1815: @95515
     /*  95515 */   GIM_Try, /*On fail goto*//*Label 1816*/ GIMT_Encode4(95551), // Rule ID 262 //
     /*  95520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  95523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /*  95530 */     // (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHui:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /*  95530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /*  95533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  95535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  95540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  95545 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95549 */     GIR_RootConstrainSelectedInstOperands,
     /*  95550 */     // GIR_Coverage, 262,
     /*  95550 */     GIR_EraseRootFromParent_Done,
     /*  95551 */   // Label 1816: @95551
     /*  95551 */   GIM_Try, /*On fail goto*//*Label 1817*/ GIMT_Encode4(95587), // Rule ID 283 //
     /*  95556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  95559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /*  95566 */     // (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURHi:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /*  95566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /*  95569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  95571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  95576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  95581 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95585 */     GIR_RootConstrainSelectedInstOperands,
     /*  95586 */     // GIR_Coverage, 283,
     /*  95586 */     GIR_EraseRootFromParent_Done,
     /*  95587 */   // Label 1817: @95587
     /*  95587 */   GIM_Reject,
     /*  95588 */ // Label 1813: @95588
     /*  95588 */ GIM_Reject,
     /*  95589 */ // Label 1789: @95589
     /*  95589 */ GIM_Try, /*On fail goto*//*Label 1818*/ GIMT_Encode4(95642), // Rule ID 233 //
     /*  95594 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95597 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  95601 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  95605 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95609 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /*  95616 */   // (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /*  95616 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /*  95619 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  95621 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  95626 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  95631 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  95636 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95640 */   GIR_RootConstrainSelectedInstOperands,
     /*  95641 */   // GIR_Coverage, 233,
     /*  95641 */   GIR_EraseRootFromParent_Done,
     /*  95642 */ // Label 1818: @95642
     /*  95642 */ GIM_Try, /*On fail goto*//*Label 1819*/ GIMT_Encode4(95695), // Rule ID 234 //
     /*  95647 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95650 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  95654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  95658 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95662 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /*  95669 */   // (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /*  95669 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /*  95672 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  95674 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  95679 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  95684 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  95689 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95693 */   GIR_RootConstrainSelectedInstOperands,
     /*  95694 */   // GIR_Coverage, 234,
     /*  95694 */   GIR_EraseRootFromParent_Done,
     /*  95695 */ // Label 1819: @95695
     /*  95695 */ GIM_Try, /*On fail goto*//*Label 1820*/ GIMT_Encode4(95751), // Rule ID 241 //
     /*  95700 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  95703 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95706 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  95710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  95714 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95718 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /*  95725 */   // (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSroW:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /*  95725 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /*  95728 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  95730 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  95735 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  95740 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  95745 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95749 */   GIR_RootConstrainSelectedInstOperands,
     /*  95750 */   // GIR_Coverage, 241,
     /*  95750 */   GIR_EraseRootFromParent_Done,
     /*  95751 */ // Label 1820: @95751
     /*  95751 */ GIM_Try, /*On fail goto*//*Label 1821*/ GIMT_Encode4(95807), // Rule ID 242 //
     /*  95756 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  95759 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95762 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  95766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  95770 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95774 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /*  95781 */   // (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSroX:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /*  95781 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /*  95784 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  95786 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  95791 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  95796 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  95801 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95805 */   GIR_RootConstrainSelectedInstOperands,
     /*  95806 */   // GIR_Coverage, 242,
     /*  95806 */   GIR_EraseRootFromParent_Done,
     /*  95807 */ // Label 1821: @95807
     /*  95807 */ GIM_Try, /*On fail goto*//*Label 1822*/ GIMT_Encode4(95867), // Rule ID 4062 //
     /*  95812 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95815 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  95819 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  95826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  95830 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95834 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /*  95841 */   // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /*  95841 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /*  95844 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  95846 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  95851 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  95856 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  95861 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95865 */   GIR_RootConstrainSelectedInstOperands,
     /*  95866 */   // GIR_Coverage, 4062,
     /*  95866 */   GIR_EraseRootFromParent_Done,
     /*  95867 */ // Label 1822: @95867
     /*  95867 */ GIM_Try, /*On fail goto*//*Label 1823*/ GIMT_Encode4(95927), // Rule ID 4063 //
     /*  95872 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95875 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  95879 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  95886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  95890 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95894 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /*  95901 */   // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /*  95901 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /*  95904 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  95906 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  95911 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  95916 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  95921 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95925 */   GIR_RootConstrainSelectedInstOperands,
     /*  95926 */   // GIR_Coverage, 4063,
     /*  95926 */   GIR_EraseRootFromParent_Done,
     /*  95927 */ // Label 1823: @95927
     /*  95927 */ GIM_Try, /*On fail goto*//*Label 1824*/ GIMT_Encode4(95987), // Rule ID 4064 //
     /*  95932 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95935 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  95939 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  95946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  95950 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95954 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /*  95961 */   // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /*  95961 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /*  95964 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  95966 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  95971 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  95976 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  95981 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95985 */   GIR_RootConstrainSelectedInstOperands,
     /*  95986 */   // GIR_Coverage, 4064,
     /*  95986 */   GIR_EraseRootFromParent_Done,
     /*  95987 */ // Label 1824: @95987
     /*  95987 */ GIM_Try, /*On fail goto*//*Label 1825*/ GIMT_Encode4(96047), // Rule ID 4065 //
     /*  95992 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95995 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  95999 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  96006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  96010 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96014 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /*  96021 */   // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /*  96021 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /*  96024 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96026 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96031 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  96036 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  96041 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96045 */   GIR_RootConstrainSelectedInstOperands,
     /*  96046 */   // GIR_Coverage, 4065,
     /*  96046 */   GIR_EraseRootFromParent_Done,
     /*  96047 */ // Label 1825: @96047
     /*  96047 */ GIM_Try, /*On fail goto*//*Label 1826*/ GIMT_Encode4(96107), // Rule ID 4066 //
     /*  96052 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96055 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  96059 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  96066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  96070 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96074 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /*  96081 */   // (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /*  96081 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /*  96084 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96086 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96091 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  96096 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  96101 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96105 */   GIR_RootConstrainSelectedInstOperands,
     /*  96106 */   // GIR_Coverage, 4066,
     /*  96106 */   GIR_EraseRootFromParent_Done,
     /*  96107 */ // Label 1826: @96107
     /*  96107 */ GIM_Try, /*On fail goto*//*Label 1827*/ GIMT_Encode4(96167), // Rule ID 4067 //
     /*  96112 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96115 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  96119 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  96126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  96130 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96134 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /*  96141 */   // (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /*  96141 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /*  96144 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96146 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96151 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  96156 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  96161 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96165 */   GIR_RootConstrainSelectedInstOperands,
     /*  96166 */   // GIR_Coverage, 4067,
     /*  96166 */   GIR_EraseRootFromParent_Done,
     /*  96167 */ // Label 1827: @96167
     /*  96167 */ GIM_Try, /*On fail goto*//*Label 1828*/ GIMT_Encode4(96215), // Rule ID 260 //
     /*  96172 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96175 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  96179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  96183 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96187 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /*  96194 */   // (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /*  96194 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /*  96197 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96199 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96204 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  96209 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96213 */   GIR_RootConstrainSelectedInstOperands,
     /*  96214 */   // GIR_Coverage, 260,
     /*  96214 */   GIR_EraseRootFromParent_Done,
     /*  96215 */ // Label 1828: @96215
     /*  96215 */ GIM_Try, /*On fail goto*//*Label 1829*/ GIMT_Encode4(96266), // Rule ID 263 //
     /*  96220 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  96223 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96226 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  96230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  96234 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96238 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /*  96245 */   // (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSui:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /*  96245 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /*  96248 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96250 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96255 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  96260 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96264 */   GIR_RootConstrainSelectedInstOperands,
     /*  96265 */   // GIR_Coverage, 263,
     /*  96265 */   GIR_EraseRootFromParent_Done,
     /*  96266 */ // Label 1829: @96266
     /*  96266 */ GIM_Try, /*On fail goto*//*Label 1830*/ GIMT_Encode4(96325), // Rule ID 6936 //
     /*  96271 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  96274 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  96281 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  96284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  96288 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96292 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /*  96299 */   // (atomic_load:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15502>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset)
     /*  96299 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /*  96302 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96304 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96309 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  96314 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  96319 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96323 */   GIR_RootConstrainSelectedInstOperands,
     /*  96324 */   // GIR_Coverage, 6936,
     /*  96324 */   GIR_EraseRootFromParent_Done,
     /*  96325 */ // Label 1830: @96325
     /*  96325 */ GIM_Try, /*On fail goto*//*Label 1831*/ GIMT_Encode4(96384), // Rule ID 6938 //
     /*  96330 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  96333 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  96340 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  96343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  96347 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96351 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /*  96358 */   // (atomic_load:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15502>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset)
     /*  96358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /*  96361 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96363 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96368 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  96373 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  96378 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96382 */   GIR_RootConstrainSelectedInstOperands,
     /*  96383 */   // GIR_Coverage, 6938,
     /*  96383 */   GIR_EraseRootFromParent_Done,
     /*  96384 */ // Label 1831: @96384
     /*  96384 */ GIM_Try, /*On fail goto*//*Label 1832*/ GIMT_Encode4(96443), // Rule ID 6948 //
     /*  96389 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  96392 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  96399 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  96402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  96406 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96410 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /*  96417 */   // (atomic_load:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15511>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /*  96417 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /*  96420 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96422 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96427 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  96432 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  96437 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96441 */   GIR_RootConstrainSelectedInstOperands,
     /*  96442 */   // GIR_Coverage, 6948,
     /*  96442 */   GIR_EraseRootFromParent_Done,
     /*  96443 */ // Label 1832: @96443
     /*  96443 */ GIM_Try, /*On fail goto*//*Label 1833*/ GIMT_Encode4(96502), // Rule ID 6950 //
     /*  96448 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  96451 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  96458 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  96461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  96465 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96469 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /*  96476 */   // (atomic_load:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15511>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /*  96476 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /*  96479 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96481 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96486 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  96491 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  96496 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96500 */   GIR_RootConstrainSelectedInstOperands,
     /*  96501 */   // GIR_Coverage, 6950,
     /*  96501 */   GIR_EraseRootFromParent_Done,
     /*  96502 */ // Label 1833: @96502
     /*  96502 */ GIM_Try, /*On fail goto*//*Label 1834*/ GIMT_Encode4(96561), // Rule ID 6958 //
     /*  96507 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  96510 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  96517 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  96520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  96524 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96528 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /*  96535 */   // (atomic_load:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15519>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /*  96535 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /*  96538 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96540 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96545 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  96550 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  96555 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96559 */   GIR_RootConstrainSelectedInstOperands,
     /*  96560 */   // GIR_Coverage, 6958,
     /*  96560 */   GIR_EraseRootFromParent_Done,
     /*  96561 */ // Label 1834: @96561
     /*  96561 */ GIM_Try, /*On fail goto*//*Label 1835*/ GIMT_Encode4(96620), // Rule ID 6959 //
     /*  96566 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  96569 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  96576 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  96579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  96583 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96587 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /*  96594 */   // (atomic_load:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15519>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /*  96594 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /*  96597 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96599 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96604 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  96609 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  96614 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96618 */   GIR_RootConstrainSelectedInstOperands,
     /*  96619 */   // GIR_Coverage, 6959,
     /*  96619 */   GIR_EraseRootFromParent_Done,
     /*  96620 */ // Label 1835: @96620
     /*  96620 */ GIM_Try, /*On fail goto*//*Label 1836*/ GIMT_Encode4(96668), // Rule ID 281 //
     /*  96625 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96628 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  96632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  96636 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96640 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /*  96647 */   // (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /*  96647 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /*  96650 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96652 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96657 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  96662 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96666 */   GIR_RootConstrainSelectedInstOperands,
     /*  96667 */   // GIR_Coverage, 281,
     /*  96667 */   GIR_EraseRootFromParent_Done,
     /*  96668 */ // Label 1836: @96668
     /*  96668 */ GIM_Try, /*On fail goto*//*Label 1837*/ GIMT_Encode4(96719), // Rule ID 284 //
     /*  96673 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  96676 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96679 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  96683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  96687 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96691 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /*  96698 */   // (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURSi:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /*  96698 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /*  96701 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96703 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96708 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  96713 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96717 */   GIR_RootConstrainSelectedInstOperands,
     /*  96718 */   // GIR_Coverage, 284,
     /*  96718 */   GIR_EraseRootFromParent_Done,
     /*  96719 */ // Label 1837: @96719
     /*  96719 */ GIM_Try, /*On fail goto*//*Label 1838*/ GIMT_Encode4(96773), // Rule ID 6940 //
     /*  96724 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  96727 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  96734 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  96737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  96741 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96745 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /*  96752 */   // (atomic_load:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15502>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /*  96752 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /*  96755 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96757 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96762 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  96767 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96771 */   GIR_RootConstrainSelectedInstOperands,
     /*  96772 */   // GIR_Coverage, 6940,
     /*  96772 */   GIR_EraseRootFromParent_Done,
     /*  96773 */ // Label 1838: @96773
     /*  96773 */ GIM_Try, /*On fail goto*//*Label 1839*/ GIMT_Encode4(96827), // Rule ID 6942 //
     /*  96778 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  96781 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  96788 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  96791 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  96795 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96799 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /*  96806 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15502>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  96806 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /*  96809 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96811 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96816 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  96821 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96825 */   GIR_RootConstrainSelectedInstOperands,
     /*  96826 */   // GIR_Coverage, 6942,
     /*  96826 */   GIR_EraseRootFromParent_Done,
     /*  96827 */ // Label 1839: @96827
     /*  96827 */ GIM_Try, /*On fail goto*//*Label 1840*/ GIMT_Encode4(96881), // Rule ID 6952 //
     /*  96832 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  96835 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  96842 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  96845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  96849 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96853 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /*  96860 */   // (atomic_load:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15511>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /*  96860 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /*  96863 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96865 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96870 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  96875 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96879 */   GIR_RootConstrainSelectedInstOperands,
     /*  96880 */   // GIR_Coverage, 6952,
     /*  96880 */   GIR_EraseRootFromParent_Done,
     /*  96881 */ // Label 1840: @96881
     /*  96881 */ GIM_Try, /*On fail goto*//*Label 1841*/ GIMT_Encode4(96935), // Rule ID 6954 //
     /*  96886 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  96889 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  96896 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  96899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  96903 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96907 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /*  96914 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15511>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  96914 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /*  96917 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96919 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96924 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  96929 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96933 */   GIR_RootConstrainSelectedInstOperands,
     /*  96934 */   // GIR_Coverage, 6954,
     /*  96934 */   GIR_EraseRootFromParent_Done,
     /*  96935 */ // Label 1841: @96935
     /*  96935 */ GIM_Try, /*On fail goto*//*Label 1842*/ GIMT_Encode4(96989), // Rule ID 6960 //
     /*  96940 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  96943 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  96950 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  96953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  96957 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96961 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /*  96968 */   // (atomic_load:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15519>>  =>  (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /*  96968 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /*  96971 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  96973 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  96978 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  96983 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96987 */   GIR_RootConstrainSelectedInstOperands,
     /*  96988 */   // GIR_Coverage, 6960,
     /*  96988 */   GIR_EraseRootFromParent_Done,
     /*  96989 */ // Label 1842: @96989
     /*  96989 */ GIM_Try, /*On fail goto*//*Label 1843*/ GIMT_Encode4(97043), // Rule ID 6961 //
     /*  96994 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  96997 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  97004 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  97007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97011 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97015 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /*  97022 */   // (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15519>>  =>  (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  97022 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /*  97025 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  97027 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  97032 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  97037 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97041 */   GIR_RootConstrainSelectedInstOperands,
     /*  97042 */   // GIR_Coverage, 6961,
     /*  97042 */   GIR_EraseRootFromParent_Done,
     /*  97043 */ // Label 1843: @97043
     /*  97043 */ GIM_Try, /*On fail goto*//*Label 1844*/ GIMT_Encode4(97100), // Rule ID 7276 //
     /*  97048 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /*  97051 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  97054 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  97061 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  97064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97068 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97072 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /*  97079 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15500>>  =>  (LDAPURBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  97079 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURBi),
     /*  97082 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  97084 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  97089 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  97094 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97098 */   GIR_RootConstrainSelectedInstOperands,
     /*  97099 */   // GIR_Coverage, 7276,
     /*  97099 */   GIR_EraseRootFromParent_Done,
     /*  97100 */ // Label 1844: @97100
     /*  97100 */ GIM_Try, /*On fail goto*//*Label 1845*/ GIMT_Encode4(97157), // Rule ID 7278 //
     /*  97105 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /*  97108 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  97111 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  97118 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  97121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97125 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97129 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /*  97136 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15509>>  =>  (LDAPURHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  97136 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURHi),
     /*  97139 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  97141 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  97146 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  97151 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97155 */   GIR_RootConstrainSelectedInstOperands,
     /*  97156 */   // GIR_Coverage, 7278,
     /*  97156 */   GIR_EraseRootFromParent_Done,
     /*  97157 */ // Label 1845: @97157
     /*  97157 */ GIM_Try, /*On fail goto*//*Label 1846*/ GIMT_Encode4(97214), // Rule ID 7280 //
     /*  97162 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /*  97165 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  97168 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  97175 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  97178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97182 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97186 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /*  97193 */   // (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15494>>  =>  (LDAPURi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  97193 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURi),
     /*  97196 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  97198 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  97203 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  97208 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97212 */   GIR_RootConstrainSelectedInstOperands,
     /*  97213 */   // GIR_Coverage, 7280,
     /*  97213 */   GIR_EraseRootFromParent_Done,
     /*  97214 */ // Label 1846: @97214
     /*  97214 */ GIM_Try, /*On fail goto*//*Label 1847*/ GIMT_Encode4(97269), // Rule ID 4089 //
     /*  97219 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97222 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  97226 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  97233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97237 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97241 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /*  97248 */   // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /*  97248 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /*  97251 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  97253 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  97258 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  97263 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97267 */   GIR_RootConstrainSelectedInstOperands,
     /*  97268 */   // GIR_Coverage, 4089,
     /*  97268 */   GIR_EraseRootFromParent_Done,
     /*  97269 */ // Label 1847: @97269
     /*  97269 */ GIM_Try, /*On fail goto*//*Label 1848*/ GIMT_Encode4(97324), // Rule ID 4090 //
     /*  97274 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97277 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  97281 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  97288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97292 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97296 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /*  97303 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /*  97303 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /*  97306 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  97308 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  97313 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  97318 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97322 */   GIR_RootConstrainSelectedInstOperands,
     /*  97323 */   // GIR_Coverage, 4090,
     /*  97323 */   GIR_EraseRootFromParent_Done,
     /*  97324 */ // Label 1848: @97324
     /*  97324 */ GIM_Try, /*On fail goto*//*Label 1849*/ GIMT_Encode4(97379), // Rule ID 4091 //
     /*  97329 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97332 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  97336 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  97343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97347 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97351 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /*  97358 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /*  97358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /*  97361 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  97363 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  97368 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  97373 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97377 */   GIR_RootConstrainSelectedInstOperands,
     /*  97378 */   // GIR_Coverage, 4091,
     /*  97378 */   GIR_EraseRootFromParent_Done,
     /*  97379 */ // Label 1849: @97379
     /*  97379 */ GIM_Try, /*On fail goto*//*Label 1850*/ GIMT_Encode4(97434), // Rule ID 4112 //
     /*  97384 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97387 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  97391 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  97398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97402 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97406 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /*  97413 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  97413 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /*  97416 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  97418 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  97423 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  97428 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97432 */   GIR_RootConstrainSelectedInstOperands,
     /*  97433 */   // GIR_Coverage, 4112,
     /*  97433 */   GIR_EraseRootFromParent_Done,
     /*  97434 */ // Label 1850: @97434
     /*  97434 */ GIM_Try, /*On fail goto*//*Label 1851*/ GIMT_Encode4(97489), // Rule ID 4113 //
     /*  97439 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97442 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  97446 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  97453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97457 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97461 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /*  97468 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  97468 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /*  97471 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  97473 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  97478 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  97483 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97487 */   GIR_RootConstrainSelectedInstOperands,
     /*  97488 */   // GIR_Coverage, 4113,
     /*  97488 */   GIR_EraseRootFromParent_Done,
     /*  97489 */ // Label 1851: @97489
     /*  97489 */ GIM_Try, /*On fail goto*//*Label 1852*/ GIMT_Encode4(97544), // Rule ID 4114 //
     /*  97494 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97497 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  97501 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  97508 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97512 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97516 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /*  97523 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  97523 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /*  97526 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  97528 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  97533 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  97538 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97542 */   GIR_RootConstrainSelectedInstOperands,
     /*  97543 */   // GIR_Coverage, 4114,
     /*  97543 */   GIR_EraseRootFromParent_Done,
     /*  97544 */ // Label 1852: @97544
     /*  97544 */ GIM_Try, /*On fail goto*//*Label 1853*/ GIMT_Encode4(97584), // Rule ID 6928 //
     /*  97549 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /*  97552 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  97555 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  97562 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  97565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97569 */   // MIs[0] ptr
     /*  97569 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  97573 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  97577 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15490>>  =>  (LDAPRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /*  97577 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRB),
     /*  97582 */   GIR_RootConstrainSelectedInstOperands,
     /*  97583 */   // GIR_Coverage, 6928,
     /*  97583 */   GIR_Done,
     /*  97584 */ // Label 1853: @97584
     /*  97584 */ GIM_Try, /*On fail goto*//*Label 1854*/ GIMT_Encode4(97624), // Rule ID 6929 //
     /*  97589 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /*  97592 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  97595 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  97602 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  97605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97609 */   // MIs[0] ptr
     /*  97609 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  97613 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  97617 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15492>>  =>  (LDAPRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /*  97617 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRH),
     /*  97622 */   GIR_RootConstrainSelectedInstOperands,
     /*  97623 */   // GIR_Coverage, 6929,
     /*  97623 */   GIR_Done,
     /*  97624 */ // Label 1854: @97624
     /*  97624 */ GIM_Try, /*On fail goto*//*Label 1855*/ GIMT_Encode4(97664), // Rule ID 6930 //
     /*  97629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /*  97632 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  97635 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  97642 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  97645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97649 */   // MIs[0] ptr
     /*  97649 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  97653 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  97657 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15494>>  =>  (LDAPRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /*  97657 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRW),
     /*  97662 */   GIR_RootConstrainSelectedInstOperands,
     /*  97663 */   // GIR_Coverage, 6930,
     /*  97663 */   GIR_Done,
     /*  97664 */ // Label 1855: @97664
     /*  97664 */ GIM_Try, /*On fail goto*//*Label 1856*/ GIMT_Encode4(97701), // Rule ID 6932 //
     /*  97669 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  97672 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  97679 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  97682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97686 */   // MIs[0] ptr
     /*  97686 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  97690 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  97694 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15498>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /*  97694 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /*  97699 */   GIR_RootConstrainSelectedInstOperands,
     /*  97700 */   // GIR_Coverage, 6932,
     /*  97700 */   GIR_Done,
     /*  97701 */ // Label 1856: @97701
     /*  97701 */ GIM_Try, /*On fail goto*//*Label 1857*/ GIMT_Encode4(97738), // Rule ID 6934 //
     /*  97706 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  97709 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  97716 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  97719 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97723 */   // MIs[0] ptr
     /*  97723 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  97727 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  97731 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15500>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /*  97731 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /*  97736 */   GIR_RootConstrainSelectedInstOperands,
     /*  97737 */   // GIR_Coverage, 6934,
     /*  97737 */   GIR_Done,
     /*  97738 */ // Label 1857: @97738
     /*  97738 */ GIM_Try, /*On fail goto*//*Label 1858*/ GIMT_Encode4(97775), // Rule ID 6944 //
     /*  97743 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  97746 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  97753 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  97756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97760 */   // MIs[0] ptr
     /*  97760 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  97764 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  97768 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15507>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /*  97768 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /*  97773 */   GIR_RootConstrainSelectedInstOperands,
     /*  97774 */   // GIR_Coverage, 6944,
     /*  97774 */   GIR_Done,
     /*  97775 */ // Label 1858: @97775
     /*  97775 */ GIM_Try, /*On fail goto*//*Label 1859*/ GIMT_Encode4(97812), // Rule ID 6946 //
     /*  97780 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  97783 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  97790 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  97793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97797 */   // MIs[0] ptr
     /*  97797 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  97801 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  97805 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15509>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /*  97805 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /*  97810 */   GIR_RootConstrainSelectedInstOperands,
     /*  97811 */   // GIR_Coverage, 6946,
     /*  97811 */   GIR_Done,
     /*  97812 */ // Label 1859: @97812
     /*  97812 */ GIM_Try, /*On fail goto*//*Label 1860*/ GIMT_Encode4(97849), // Rule ID 6956 //
     /*  97817 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  97820 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  97827 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  97830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97834 */   // MIs[0] ptr
     /*  97834 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  97838 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  97842 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15516>>  =>  (LDARW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /*  97842 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARW),
     /*  97847 */   GIR_RootConstrainSelectedInstOperands,
     /*  97848 */   // GIR_Coverage, 6956,
     /*  97848 */   GIR_Done,
     /*  97849 */ // Label 1860: @97849
     /*  97849 */ GIM_Try, /*On fail goto*//*Label 1861*/ GIMT_Encode4(97886), // Rule ID 6957 //
     /*  97854 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  97857 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  97864 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  97867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97871 */   // MIs[0] ptr
     /*  97871 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  97875 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  97879 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15494>>  =>  (LDARW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /*  97879 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARW),
     /*  97884 */   GIR_RootConstrainSelectedInstOperands,
     /*  97885 */   // GIR_Coverage, 6957,
     /*  97885 */   GIR_Done,
     /*  97886 */ // Label 1861: @97886
     /*  97886 */ GIM_Reject,
     /*  97887 */ // Label 1790: @97887
     /*  97887 */ GIM_Try, /*On fail goto*//*Label 1862*/ GIMT_Encode4(97940), // Rule ID 235 //
     /*  97892 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97895 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  97899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  97903 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97907 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /*  97914 */   // (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /*  97914 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroW),
     /*  97917 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  97919 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  97924 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  97929 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  97934 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97938 */   GIR_RootConstrainSelectedInstOperands,
     /*  97939 */   // GIR_Coverage, 235,
     /*  97939 */   GIR_EraseRootFromParent_Done,
     /*  97940 */ // Label 1862: @97940
     /*  97940 */ GIM_Try, /*On fail goto*//*Label 1863*/ GIMT_Encode4(97993), // Rule ID 236 //
     /*  97945 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97948 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  97952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  97956 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97960 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /*  97967 */   // (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /*  97967 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroX),
     /*  97970 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  97972 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  97977 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  97982 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  97987 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97991 */   GIR_RootConstrainSelectedInstOperands,
     /*  97992 */   // GIR_Coverage, 236,
     /*  97992 */   GIR_EraseRootFromParent_Done,
     /*  97993 */ // Label 1863: @97993
     /*  97993 */ GIM_Try, /*On fail goto*//*Label 1864*/ GIMT_Encode4(98049), // Rule ID 243 //
     /*  97998 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  98001 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98004 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98012 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98016 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /*  98023 */   // (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /*  98023 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /*  98026 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  98028 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98033 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98038 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98043 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98047 */   GIR_RootConstrainSelectedInstOperands,
     /*  98048 */   // GIR_Coverage, 243,
     /*  98048 */   GIR_EraseRootFromParent_Done,
     /*  98049 */ // Label 1864: @98049
     /*  98049 */ GIM_Try, /*On fail goto*//*Label 1865*/ GIMT_Encode4(98105), // Rule ID 244 //
     /*  98054 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  98057 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98060 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98068 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98072 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /*  98079 */   // (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /*  98079 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /*  98082 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  98084 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98089 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98094 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98099 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98103 */   GIR_RootConstrainSelectedInstOperands,
     /*  98104 */   // GIR_Coverage, 244,
     /*  98104 */   GIR_EraseRootFromParent_Done,
     /*  98105 */ // Label 1865: @98105
     /*  98105 */ GIM_Try, /*On fail goto*//*Label 1866*/ GIMT_Encode4(98158), // Rule ID 4028 //
     /*  98110 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98113 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98121 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98125 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /*  98132 */   // (ld:{ *:[v1i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /*  98132 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /*  98135 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  98137 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98142 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98147 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98152 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98156 */   GIR_RootConstrainSelectedInstOperands,
     /*  98157 */   // GIR_Coverage, 4028,
     /*  98157 */   GIR_EraseRootFromParent_Done,
     /*  98158 */ // Label 1866: @98158
     /*  98158 */ GIM_Try, /*On fail goto*//*Label 1867*/ GIMT_Encode4(98211), // Rule ID 4029 //
     /*  98163 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98166 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98174 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98178 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /*  98185 */   // (ld:{ *:[v1i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /*  98185 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /*  98188 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  98190 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98195 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98200 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98205 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98209 */   GIR_RootConstrainSelectedInstOperands,
     /*  98210 */   // GIR_Coverage, 4029,
     /*  98210 */   GIR_EraseRootFromParent_Done,
     /*  98211 */ // Label 1867: @98211
     /*  98211 */ GIM_Try, /*On fail goto*//*Label 1868*/ GIMT_Encode4(98264), // Rule ID 4030 //
     /*  98216 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98219 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98227 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98231 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /*  98238 */   // (ld:{ *:[v1f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /*  98238 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /*  98241 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  98243 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98248 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98253 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98258 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98262 */   GIR_RootConstrainSelectedInstOperands,
     /*  98263 */   // GIR_Coverage, 4030,
     /*  98263 */   GIR_EraseRootFromParent_Done,
     /*  98264 */ // Label 1868: @98264
     /*  98264 */ GIM_Try, /*On fail goto*//*Label 1869*/ GIMT_Encode4(98317), // Rule ID 4031 //
     /*  98269 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98272 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98280 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98284 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /*  98291 */   // (ld:{ *:[v1f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /*  98291 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /*  98294 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  98296 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98301 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98306 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98311 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98315 */   GIR_RootConstrainSelectedInstOperands,
     /*  98316 */   // GIR_Coverage, 4031,
     /*  98316 */   GIR_EraseRootFromParent_Done,
     /*  98317 */ // Label 1869: @98317
     /*  98317 */ GIM_Try, /*On fail goto*//*Label 1870*/ GIMT_Encode4(98409), // Rule ID 4054 //
     /*  98322 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98325 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98329 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  98336 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  98340 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98344 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /*  98351 */   // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /*  98351 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  98354 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /*  98358 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98363 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98368 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98373 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98378 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98382 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98384 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  98387 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98389 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98392 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98395 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  98398 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  98403 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  98408 */   // GIR_Coverage, 4054,
     /*  98408 */   GIR_EraseRootFromParent_Done,
     /*  98409 */ // Label 1870: @98409
     /*  98409 */ GIM_Try, /*On fail goto*//*Label 1871*/ GIMT_Encode4(98501), // Rule ID 4055 //
     /*  98414 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98417 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98421 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  98428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  98432 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98436 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /*  98443 */   // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /*  98443 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  98446 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /*  98450 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98455 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98460 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98465 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98470 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98474 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98476 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  98479 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98481 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98484 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98487 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  98490 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  98495 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  98500 */   // GIR_Coverage, 4055,
     /*  98500 */   GIR_EraseRootFromParent_Done,
     /*  98501 */ // Label 1871: @98501
     /*  98501 */ GIM_Try, /*On fail goto*//*Label 1872*/ GIMT_Encode4(98593), // Rule ID 4056 //
     /*  98506 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98509 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98513 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  98520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  98524 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98528 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /*  98535 */   // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /*  98535 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  98538 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /*  98542 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98547 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98552 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98557 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98562 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98566 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98568 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  98571 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98573 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98576 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98579 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  98582 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  98587 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  98592 */   // GIR_Coverage, 4056,
     /*  98592 */   GIR_EraseRootFromParent_Done,
     /*  98593 */ // Label 1872: @98593
     /*  98593 */ GIM_Try, /*On fail goto*//*Label 1873*/ GIMT_Encode4(98685), // Rule ID 4057 //
     /*  98598 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98601 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98605 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  98612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  98616 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98620 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /*  98627 */   // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /*  98627 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  98630 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /*  98634 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98639 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98644 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98649 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98654 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98658 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98660 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  98663 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98665 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98668 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98671 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  98674 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  98679 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  98684 */   // GIR_Coverage, 4057,
     /*  98684 */   GIR_EraseRootFromParent_Done,
     /*  98685 */ // Label 1873: @98685
     /*  98685 */ GIM_Try, /*On fail goto*//*Label 1874*/ GIMT_Encode4(98777), // Rule ID 4058 //
     /*  98690 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98693 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98697 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  98704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  98708 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98712 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /*  98719 */   // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /*  98719 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  98722 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /*  98726 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98731 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98736 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98741 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98746 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98750 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98752 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  98755 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98757 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98760 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98763 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  98766 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  98771 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  98776 */   // GIR_Coverage, 4058,
     /*  98776 */   GIR_EraseRootFromParent_Done,
     /*  98777 */ // Label 1874: @98777
     /*  98777 */ GIM_Try, /*On fail goto*//*Label 1875*/ GIMT_Encode4(98869), // Rule ID 4059 //
     /*  98782 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98785 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98789 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  98796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  98800 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98804 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /*  98811 */   // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /*  98811 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  98814 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /*  98818 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98823 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98828 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98833 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98838 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98842 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98844 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  98847 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98849 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98852 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98855 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  98858 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  98863 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  98868 */   // GIR_Coverage, 4059,
     /*  98868 */   GIR_EraseRootFromParent_Done,
     /*  98869 */ // Label 1875: @98869
     /*  98869 */ GIM_Try, /*On fail goto*//*Label 1876*/ GIMT_Encode4(98961), // Rule ID 4060 //
     /*  98874 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98877 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98881 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  98888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  98892 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98896 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /*  98903 */   // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /*  98903 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  98906 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /*  98910 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98915 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98920 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98925 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98930 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98934 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98936 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  98939 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98941 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98944 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98947 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  98950 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  98955 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  98960 */   // GIR_Coverage, 4060,
     /*  98960 */   GIR_EraseRootFromParent_Done,
     /*  98961 */ // Label 1876: @98961
     /*  98961 */ GIM_Try, /*On fail goto*//*Label 1877*/ GIMT_Encode4(99053), // Rule ID 4061 //
     /*  98966 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98969 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98973 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  98980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  98984 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98988 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /*  98995 */   // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /*  98995 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  98998 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /*  99002 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99007 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99012 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99017 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99022 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99026 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  99028 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  99031 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99033 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99036 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99039 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  99042 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  99047 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99052 */   // GIR_Coverage, 4061,
     /*  99052 */   GIR_EraseRootFromParent_Done,
     /*  99053 */ // Label 1877: @99053
     /*  99053 */ GIM_Try, /*On fail goto*//*Label 1878*/ GIMT_Encode4(99101), // Rule ID 259 //
     /*  99058 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99061 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  99069 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99073 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /*  99080 */   // (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /*  99080 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXui),
     /*  99083 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99085 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99090 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99095 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99099 */   GIR_RootConstrainSelectedInstOperands,
     /*  99100 */   // GIR_Coverage, 259,
     /*  99100 */   GIR_EraseRootFromParent_Done,
     /*  99101 */ // Label 1878: @99101
     /*  99101 */ GIM_Try, /*On fail goto*//*Label 1879*/ GIMT_Encode4(99152), // Rule ID 264 //
     /*  99106 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99109 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99112 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99120 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99124 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /*  99131 */   // (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /*  99131 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /*  99134 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99136 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99141 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99146 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99150 */   GIR_RootConstrainSelectedInstOperands,
     /*  99151 */   // GIR_Coverage, 264,
     /*  99151 */   GIR_EraseRootFromParent_Done,
     /*  99152 */ // Label 1879: @99152
     /*  99152 */ GIM_Try, /*On fail goto*//*Label 1880*/ GIMT_Encode4(99211), // Rule ID 6964 //
     /*  99157 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  99160 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  99167 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  99170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  99174 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99178 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /*  99185 */   // (atomic_load:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15527>>  =>  (LDRXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /*  99185 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroW),
     /*  99188 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99190 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99195 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99200 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99205 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99209 */   GIR_RootConstrainSelectedInstOperands,
     /*  99210 */   // GIR_Coverage, 6964,
     /*  99210 */   GIR_EraseRootFromParent_Done,
     /*  99211 */ // Label 1880: @99211
     /*  99211 */ GIM_Try, /*On fail goto*//*Label 1881*/ GIMT_Encode4(99270), // Rule ID 6965 //
     /*  99216 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  99219 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  99226 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  99229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  99233 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99237 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /*  99244 */   // (atomic_load:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15527>>  =>  (LDRXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /*  99244 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroX),
     /*  99247 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99249 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99254 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99259 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99264 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99268 */   GIR_RootConstrainSelectedInstOperands,
     /*  99269 */   // GIR_Coverage, 6965,
     /*  99269 */   GIR_EraseRootFromParent_Done,
     /*  99270 */ // Label 1881: @99270
     /*  99270 */ GIM_Try, /*On fail goto*//*Label 1882*/ GIMT_Encode4(99318), // Rule ID 280 //
     /*  99275 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99278 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99282 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  99286 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99290 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /*  99297 */   // (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /*  99297 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURXi),
     /*  99300 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99302 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99307 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99312 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99316 */   GIR_RootConstrainSelectedInstOperands,
     /*  99317 */   // GIR_Coverage, 280,
     /*  99317 */   GIR_EraseRootFromParent_Done,
     /*  99318 */ // Label 1882: @99318
     /*  99318 */ GIM_Try, /*On fail goto*//*Label 1883*/ GIMT_Encode4(99369), // Rule ID 285 //
     /*  99323 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99326 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99329 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99337 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99341 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /*  99348 */   // (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /*  99348 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /*  99351 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99353 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99358 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99363 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99367 */   GIR_RootConstrainSelectedInstOperands,
     /*  99368 */   // GIR_Coverage, 285,
     /*  99368 */   GIR_EraseRootFromParent_Done,
     /*  99369 */ // Label 1883: @99369
     /*  99369 */ GIM_Try, /*On fail goto*//*Label 1884*/ GIMT_Encode4(99423), // Rule ID 6966 //
     /*  99374 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  99377 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  99384 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  99387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  99391 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99395 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /*  99402 */   // (atomic_load:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15527>>  =>  (LDRXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /*  99402 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXui),
     /*  99405 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99407 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99412 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99417 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99421 */   GIR_RootConstrainSelectedInstOperands,
     /*  99422 */   // GIR_Coverage, 6966,
     /*  99422 */   GIR_EraseRootFromParent_Done,
     /*  99423 */ // Label 1884: @99423
     /*  99423 */ GIM_Try, /*On fail goto*//*Label 1885*/ GIMT_Encode4(99477), // Rule ID 6967 //
     /*  99428 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  99431 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  99438 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  99441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  99445 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99449 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /*  99456 */   // (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15527>>  =>  (LDURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  99456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURXi),
     /*  99459 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99461 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99466 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99471 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99475 */   GIR_RootConstrainSelectedInstOperands,
     /*  99476 */   // GIR_Coverage, 6967,
     /*  99476 */   GIR_EraseRootFromParent_Done,
     /*  99477 */ // Label 1885: @99477
     /*  99477 */ GIM_Try, /*On fail goto*//*Label 1886*/ GIMT_Encode4(99534), // Rule ID 7281 //
     /*  99482 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /*  99485 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  99488 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  99495 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  99498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  99502 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99506 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /*  99513 */   // (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15496>>  =>  (LDAPURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  99513 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURXi),
     /*  99516 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99518 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99523 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99528 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99532 */   GIR_RootConstrainSelectedInstOperands,
     /*  99533 */   // GIR_Coverage, 7281,
     /*  99533 */   GIR_EraseRootFromParent_Done,
     /*  99534 */ // Label 1886: @99534
     /*  99534 */ GIM_Try, /*On fail goto*//*Label 1887*/ GIMT_Encode4(99582), // Rule ID 4075 //
     /*  99539 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99542 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99550 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99554 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /*  99561 */   // (ld:{ *:[v1f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /*  99561 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /*  99564 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99566 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99571 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99576 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99580 */   GIR_RootConstrainSelectedInstOperands,
     /*  99581 */   // GIR_Coverage, 4075,
     /*  99581 */   GIR_EraseRootFromParent_Done,
     /*  99582 */ // Label 1887: @99582
     /*  99582 */ GIM_Try, /*On fail goto*//*Label 1888*/ GIMT_Encode4(99630), // Rule ID 4076 //
     /*  99587 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99590 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99598 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99602 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /*  99609 */   // (ld:{ *:[v1i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /*  99609 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /*  99612 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99614 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99619 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99624 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99628 */   GIR_RootConstrainSelectedInstOperands,
     /*  99629 */   // GIR_Coverage, 4076,
     /*  99629 */   GIR_EraseRootFromParent_Done,
     /*  99630 */ // Label 1888: @99630
     /*  99630 */ GIM_Try, /*On fail goto*//*Label 1889*/ GIMT_Encode4(99717), // Rule ID 4092 //
     /*  99635 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99638 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99642 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  99649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  99653 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99657 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /*  99664 */   // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /*  99664 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  99667 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /*  99671 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99676 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99681 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99686 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99690 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  99692 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  99695 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99697 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99700 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99703 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  99706 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  99711 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99716 */   // GIR_Coverage, 4092,
     /*  99716 */   GIR_EraseRootFromParent_Done,
     /*  99717 */ // Label 1889: @99717
     /*  99717 */ GIM_Try, /*On fail goto*//*Label 1890*/ GIMT_Encode4(99804), // Rule ID 4093 //
     /*  99722 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99725 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99729 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  99736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  99740 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99744 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /*  99751 */   // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /*  99751 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  99754 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /*  99758 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99763 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99768 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99773 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99777 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  99779 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  99782 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99784 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99787 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99790 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  99793 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  99798 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99803 */   // GIR_Coverage, 4093,
     /*  99803 */   GIR_EraseRootFromParent_Done,
     /*  99804 */ // Label 1890: @99804
     /*  99804 */ GIM_Try, /*On fail goto*//*Label 1891*/ GIMT_Encode4(99891), // Rule ID 4094 //
     /*  99809 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99812 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99816 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  99823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  99827 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99831 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /*  99838 */   // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /*  99838 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  99841 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /*  99845 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99850 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99855 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99860 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99864 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  99866 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  99869 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99871 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99874 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99877 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  99880 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  99885 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99890 */   // GIR_Coverage, 4094,
     /*  99890 */   GIR_EraseRootFromParent_Done,
     /*  99891 */ // Label 1891: @99891
     /*  99891 */ GIM_Try, /*On fail goto*//*Label 1892*/ GIMT_Encode4(99978), // Rule ID 4095 //
     /*  99896 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99899 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99903 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  99910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  99914 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99918 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /*  99925 */   // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /*  99925 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  99928 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /*  99932 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99937 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99942 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99947 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99951 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  99953 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  99956 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99958 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99961 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99964 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  99967 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  99972 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99977 */   // GIR_Coverage, 4095,
     /*  99977 */   GIR_EraseRootFromParent_Done,
     /*  99978 */ // Label 1892: @99978
     /*  99978 */ GIM_Try, /*On fail goto*//*Label 1893*/ GIMT_Encode4(100026), // Rule ID 4103 //
     /*  99983 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99986 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99994 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99998 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 100005 */   // (ld:{ *:[v1f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 100005 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 100008 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100010 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100015 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100020 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100024 */   GIR_RootConstrainSelectedInstOperands,
     /* 100025 */   // GIR_Coverage, 4103,
     /* 100025 */   GIR_EraseRootFromParent_Done,
     /* 100026 */ // Label 1893: @100026
     /* 100026 */ GIM_Try, /*On fail goto*//*Label 1894*/ GIMT_Encode4(100074), // Rule ID 4104 //
     /* 100031 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100034 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100042 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100046 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 100053 */   // (ld:{ *:[v1i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 100053 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 100056 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100058 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100063 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100068 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100072 */   GIR_RootConstrainSelectedInstOperands,
     /* 100073 */   // GIR_Coverage, 4104,
     /* 100073 */   GIR_EraseRootFromParent_Done,
     /* 100074 */ // Label 1894: @100074
     /* 100074 */ GIM_Try, /*On fail goto*//*Label 1895*/ GIMT_Encode4(100161), // Rule ID 4115 //
     /* 100079 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100082 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100086 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 100093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 100097 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100101 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 100108 */   // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 100108 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 100111 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 100115 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100120 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100125 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100130 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100134 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 100136 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 100139 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100141 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100144 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100147 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 100150 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 100155 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100160 */   // GIR_Coverage, 4115,
     /* 100160 */   GIR_EraseRootFromParent_Done,
     /* 100161 */ // Label 1895: @100161
     /* 100161 */ GIM_Try, /*On fail goto*//*Label 1896*/ GIMT_Encode4(100248), // Rule ID 4116 //
     /* 100166 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100169 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100173 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 100180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 100184 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100188 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 100195 */   // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 100195 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 100198 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 100202 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100207 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100212 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100217 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100221 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 100223 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 100226 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100228 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100231 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100234 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 100237 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 100242 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100247 */   // GIR_Coverage, 4116,
     /* 100247 */   GIR_EraseRootFromParent_Done,
     /* 100248 */ // Label 1896: @100248
     /* 100248 */ GIM_Try, /*On fail goto*//*Label 1897*/ GIMT_Encode4(100335), // Rule ID 4117 //
     /* 100253 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100256 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100260 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 100267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 100271 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100275 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 100282 */   // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 100282 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 100285 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 100289 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100294 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100299 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100304 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100308 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 100310 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 100313 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100315 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100318 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100321 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 100324 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 100329 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100334 */   // GIR_Coverage, 4117,
     /* 100334 */   GIR_EraseRootFromParent_Done,
     /* 100335 */ // Label 1897: @100335
     /* 100335 */ GIM_Try, /*On fail goto*//*Label 1898*/ GIMT_Encode4(100422), // Rule ID 4118 //
     /* 100340 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100343 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100347 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 100354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 100358 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100362 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 100369 */   // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 100369 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 100372 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 100376 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100381 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100386 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100391 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100395 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 100397 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 100400 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100402 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100405 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100408 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 100411 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 100416 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100421 */   // GIR_Coverage, 4118,
     /* 100421 */   GIR_EraseRootFromParent_Done,
     /* 100422 */ // Label 1898: @100422
     /* 100422 */ GIM_Try, /*On fail goto*//*Label 1899*/ GIMT_Encode4(100462), // Rule ID 6931 //
     /* 100427 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 100430 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100433 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 100440 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 100447 */   // MIs[0] ptr
     /* 100447 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 100451 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 100455 */   // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15496>>  =>  (LDAPRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
     /* 100455 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRX),
     /* 100460 */   GIR_RootConstrainSelectedInstOperands,
     /* 100461 */   // GIR_Coverage, 6931,
     /* 100461 */   GIR_Done,
     /* 100462 */ // Label 1899: @100462
     /* 100462 */ GIM_Try, /*On fail goto*//*Label 1900*/ GIMT_Encode4(100499), // Rule ID 6962 //
     /* 100467 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100470 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 100477 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 100480 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 100484 */   // MIs[0] ptr
     /* 100484 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 100488 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 100492 */   // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15524>>  =>  (LDARX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
     /* 100492 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARX),
     /* 100497 */   GIR_RootConstrainSelectedInstOperands,
     /* 100498 */   // GIR_Coverage, 6962,
     /* 100498 */   GIR_Done,
     /* 100499 */ // Label 1900: @100499
     /* 100499 */ GIM_Try, /*On fail goto*//*Label 1901*/ GIMT_Encode4(100536), // Rule ID 6963 //
     /* 100504 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100507 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 100514 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100517 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 100521 */   // MIs[0] ptr
     /* 100521 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 100525 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 100529 */   // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15496>>  =>  (LDARX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
     /* 100529 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARX),
     /* 100534 */   GIR_RootConstrainSelectedInstOperands,
     /* 100535 */   // GIR_Coverage, 6963,
     /* 100535 */   GIR_Done,
     /* 100536 */ // Label 1901: @100536
     /* 100536 */ GIM_Try, /*On fail goto*//*Label 1902*/ GIMT_Encode4(100567), // Rule ID 6311 //
     /* 100541 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100544 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100552 */   // MIs[0] Rn
     /* 100552 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 100556 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 100560 */   // (ld:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 100560 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev1d),
     /* 100565 */   GIR_RootConstrainSelectedInstOperands,
     /* 100566 */   // GIR_Coverage, 6311,
     /* 100566 */   GIR_Done,
     /* 100567 */ // Label 1902: @100567
     /* 100567 */ GIM_Reject,
     /* 100568 */ // Label 1791: @100568
     /* 100568 */ GIM_Try, /*On fail goto*//*Label 1903*/ GIMT_Encode4(100776),
     /* 100573 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100576 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100580 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100584 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100588 */   GIM_Try, /*On fail goto*//*Label 1904*/ GIMT_Encode4(100629), // Rule ID 245 //
     /* 100593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 100596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 100603 */     // (ld:{ *:[f128] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 100603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 100606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100623 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100627 */     GIR_RootConstrainSelectedInstOperands,
     /* 100628 */     // GIR_Coverage, 245,
     /* 100628 */     GIR_EraseRootFromParent_Done,
     /* 100629 */   // Label 1904: @100629
     /* 100629 */   GIM_Try, /*On fail goto*//*Label 1905*/ GIMT_Encode4(100670), // Rule ID 246 //
     /* 100634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 100637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 100644 */     // (ld:{ *:[f128] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 100644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 100647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100664 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100668 */     GIR_RootConstrainSelectedInstOperands,
     /* 100669 */     // GIR_Coverage, 246,
     /* 100669 */     GIR_EraseRootFromParent_Done,
     /* 100670 */   // Label 1905: @100670
     /* 100670 */   GIM_Try, /*On fail goto*//*Label 1906*/ GIMT_Encode4(100706), // Rule ID 265 //
     /* 100675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 100678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 100685 */     // (ld:{ *:[f128] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 100685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 100688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100700 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100704 */     GIR_RootConstrainSelectedInstOperands,
     /* 100705 */     // GIR_Coverage, 265,
     /* 100705 */     GIR_EraseRootFromParent_Done,
     /* 100706 */   // Label 1906: @100706
     /* 100706 */   GIM_Try, /*On fail goto*//*Label 1907*/ GIMT_Encode4(100742), // Rule ID 286 //
     /* 100711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 100714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 100721 */     // (ld:{ *:[f128] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 100721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 100724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100736 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100740 */     GIR_RootConstrainSelectedInstOperands,
     /* 100741 */     // GIR_Coverage, 286,
     /* 100741 */     GIR_EraseRootFromParent_Done,
     /* 100742 */   // Label 1907: @100742
     /* 100742 */   GIM_Try, /*On fail goto*//*Label 1908*/ GIMT_Encode4(100775), // Rule ID 4084 //
     /* 100747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 100754 */     // (ld:{ *:[f128] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 100754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 100757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100769 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100773 */     GIR_RootConstrainSelectedInstOperands,
     /* 100774 */     // GIR_Coverage, 4084,
     /* 100774 */     GIR_EraseRootFromParent_Done,
     /* 100775 */   // Label 1908: @100775
     /* 100775 */   GIM_Reject,
     /* 100776 */ // Label 1903: @100776
     /* 100776 */ GIM_Reject,
     /* 100777 */ // Label 1792: @100777
     /* 100777 */ GIM_Try, /*On fail goto*//*Label 1909*/ GIMT_Encode4(101154),
     /* 100782 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100785 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100793 */   GIM_Try, /*On fail goto*//*Label 1910*/ GIMT_Encode4(100838), // Rule ID 4018 //
     /* 100798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 100801 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 100812 */     // (ld:{ *:[v2i32] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 100812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 100815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100832 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100836 */     GIR_RootConstrainSelectedInstOperands,
     /* 100837 */     // GIR_Coverage, 4018,
     /* 100837 */     GIR_EraseRootFromParent_Done,
     /* 100838 */   // Label 1910: @100838
     /* 100838 */   GIM_Try, /*On fail goto*//*Label 1911*/ GIMT_Encode4(100883), // Rule ID 4019 //
     /* 100843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 100846 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 100857 */     // (ld:{ *:[v2i32] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 100857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 100860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100877 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100881 */     GIR_RootConstrainSelectedInstOperands,
     /* 100882 */     // GIR_Coverage, 4019,
     /* 100882 */     GIR_EraseRootFromParent_Done,
     /* 100883 */   // Label 1911: @100883
     /* 100883 */   GIM_Try, /*On fail goto*//*Label 1912*/ GIMT_Encode4(100928), // Rule ID 4020 //
     /* 100888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 100891 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 100902 */     // (ld:{ *:[v2f32] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 100902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 100905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100922 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100926 */     GIR_RootConstrainSelectedInstOperands,
     /* 100927 */     // GIR_Coverage, 4020,
     /* 100927 */     GIR_EraseRootFromParent_Done,
     /* 100928 */   // Label 1912: @100928
     /* 100928 */   GIM_Try, /*On fail goto*//*Label 1913*/ GIMT_Encode4(100973), // Rule ID 4021 //
     /* 100933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 100936 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 100947 */     // (ld:{ *:[v2f32] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 100947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 100950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100967 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100971 */     GIR_RootConstrainSelectedInstOperands,
     /* 100972 */     // GIR_Coverage, 4021,
     /* 100972 */     GIR_EraseRootFromParent_Done,
     /* 100973 */   // Label 1913: @100973
     /* 100973 */   GIM_Try, /*On fail goto*//*Label 1914*/ GIMT_Encode4(101013), // Rule ID 4070 //
     /* 100978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 100981 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 100992 */     // (ld:{ *:[v2f32] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 100992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 100995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101007 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101011 */     GIR_RootConstrainSelectedInstOperands,
     /* 101012 */     // GIR_Coverage, 4070,
     /* 101012 */     GIR_EraseRootFromParent_Done,
     /* 101013 */   // Label 1914: @101013
     /* 101013 */   GIM_Try, /*On fail goto*//*Label 1915*/ GIMT_Encode4(101053), // Rule ID 4073 //
     /* 101018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101021 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 101032 */     // (ld:{ *:[v2i32] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 101032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 101035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101047 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101051 */     GIR_RootConstrainSelectedInstOperands,
     /* 101052 */     // GIR_Coverage, 4073,
     /* 101052 */     GIR_EraseRootFromParent_Done,
     /* 101053 */   // Label 1915: @101053
     /* 101053 */   GIM_Try, /*On fail goto*//*Label 1916*/ GIMT_Encode4(101093), // Rule ID 4098 //
     /* 101058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101061 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 101072 */     // (ld:{ *:[v2f32] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 101075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101087 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101091 */     GIR_RootConstrainSelectedInstOperands,
     /* 101092 */     // GIR_Coverage, 4098,
     /* 101092 */     GIR_EraseRootFromParent_Done,
     /* 101093 */   // Label 1916: @101093
     /* 101093 */   GIM_Try, /*On fail goto*//*Label 1917*/ GIMT_Encode4(101133), // Rule ID 4099 //
     /* 101098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101101 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 101112 */     // (ld:{ *:[v2i32] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 101115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101127 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101131 */     GIR_RootConstrainSelectedInstOperands,
     /* 101132 */     // GIR_Coverage, 4099,
     /* 101132 */     GIR_EraseRootFromParent_Done,
     /* 101133 */   // Label 1917: @101133
     /* 101133 */   GIM_Try, /*On fail goto*//*Label 1918*/ GIMT_Encode4(101153), // Rule ID 6310 //
     /* 101138 */     // MIs[0] Rn
     /* 101138 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 101142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 101146 */     // (ld:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 101146 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev2s),
     /* 101151 */     GIR_RootConstrainSelectedInstOperands,
     /* 101152 */     // GIR_Coverage, 6310,
     /* 101152 */     GIR_Done,
     /* 101153 */   // Label 1918: @101153
     /* 101153 */   GIM_Reject,
     /* 101154 */ // Label 1909: @101154
     /* 101154 */ GIM_Reject,
     /* 101155 */ // Label 1793: @101155
     /* 101155 */ GIM_Try, /*On fail goto*//*Label 1919*/ GIMT_Encode4(101532),
     /* 101160 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101163 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101167 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101171 */   GIM_Try, /*On fail goto*//*Label 1920*/ GIMT_Encode4(101216), // Rule ID 4032 //
     /* 101176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101179 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 101190 */     // (ld:{ *:[v2i64] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 101190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 101193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101210 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101214 */     GIR_RootConstrainSelectedInstOperands,
     /* 101215 */     // GIR_Coverage, 4032,
     /* 101215 */     GIR_EraseRootFromParent_Done,
     /* 101216 */   // Label 1920: @101216
     /* 101216 */   GIM_Try, /*On fail goto*//*Label 1921*/ GIMT_Encode4(101261), // Rule ID 4033 //
     /* 101221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101224 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 101235 */     // (ld:{ *:[v2i64] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 101235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 101238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101255 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101259 */     GIR_RootConstrainSelectedInstOperands,
     /* 101260 */     // GIR_Coverage, 4033,
     /* 101260 */     GIR_EraseRootFromParent_Done,
     /* 101261 */   // Label 1921: @101261
     /* 101261 */   GIM_Try, /*On fail goto*//*Label 1922*/ GIMT_Encode4(101306), // Rule ID 4034 //
     /* 101266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101269 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 101280 */     // (ld:{ *:[v2f64] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 101280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 101283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101300 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101304 */     GIR_RootConstrainSelectedInstOperands,
     /* 101305 */     // GIR_Coverage, 4034,
     /* 101305 */     GIR_EraseRootFromParent_Done,
     /* 101306 */   // Label 1922: @101306
     /* 101306 */   GIM_Try, /*On fail goto*//*Label 1923*/ GIMT_Encode4(101351), // Rule ID 4035 //
     /* 101311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101314 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 101325 */     // (ld:{ *:[v2f64] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 101325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 101328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101345 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101349 */     GIR_RootConstrainSelectedInstOperands,
     /* 101350 */     // GIR_Coverage, 4035,
     /* 101350 */     GIR_EraseRootFromParent_Done,
     /* 101351 */   // Label 1923: @101351
     /* 101351 */   GIM_Try, /*On fail goto*//*Label 1924*/ GIMT_Encode4(101391), // Rule ID 4078 //
     /* 101356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101359 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 101370 */     // (ld:{ *:[v2f64] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 101370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 101373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101385 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101389 */     GIR_RootConstrainSelectedInstOperands,
     /* 101390 */     // GIR_Coverage, 4078,
     /* 101390 */     GIR_EraseRootFromParent_Done,
     /* 101391 */   // Label 1924: @101391
     /* 101391 */   GIM_Try, /*On fail goto*//*Label 1925*/ GIMT_Encode4(101431), // Rule ID 4082 //
     /* 101396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101399 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 101410 */     // (ld:{ *:[v2i64] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 101410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 101413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101425 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101429 */     GIR_RootConstrainSelectedInstOperands,
     /* 101430 */     // GIR_Coverage, 4082,
     /* 101430 */     GIR_EraseRootFromParent_Done,
     /* 101431 */   // Label 1925: @101431
     /* 101431 */   GIM_Try, /*On fail goto*//*Label 1926*/ GIMT_Encode4(101471), // Rule ID 4105 //
     /* 101436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101439 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 101450 */     // (ld:{ *:[v2f64] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 101453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101465 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101469 */     GIR_RootConstrainSelectedInstOperands,
     /* 101470 */     // GIR_Coverage, 4105,
     /* 101470 */     GIR_EraseRootFromParent_Done,
     /* 101471 */   // Label 1926: @101471
     /* 101471 */   GIM_Try, /*On fail goto*//*Label 1927*/ GIMT_Encode4(101511), // Rule ID 4106 //
     /* 101476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101479 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 101490 */     // (ld:{ *:[v2i64] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 101493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101505 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101509 */     GIR_RootConstrainSelectedInstOperands,
     /* 101510 */     // GIR_Coverage, 4106,
     /* 101510 */     GIR_EraseRootFromParent_Done,
     /* 101511 */   // Label 1927: @101511
     /* 101511 */   GIM_Try, /*On fail goto*//*Label 1928*/ GIMT_Encode4(101531), // Rule ID 6307 //
     /* 101516 */     // MIs[0] Rn
     /* 101516 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 101520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 101524 */     // (ld:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 101524 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev2d),
     /* 101529 */     GIR_RootConstrainSelectedInstOperands,
     /* 101530 */     // GIR_Coverage, 6307,
     /* 101530 */     GIR_Done,
     /* 101531 */   // Label 1928: @101531
     /* 101531 */   GIM_Reject,
     /* 101532 */ // Label 1919: @101532
     /* 101532 */ GIM_Reject,
     /* 101533 */ // Label 1794: @101533
     /* 101533 */ GIM_Try, /*On fail goto*//*Label 1929*/ GIMT_Encode4(101910),
     /* 101538 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101541 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101549 */   GIM_Try, /*On fail goto*//*Label 1930*/ GIMT_Encode4(101594), // Rule ID 4024 //
     /* 101554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101557 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 101568 */     // (ld:{ *:[v4i16] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 101568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 101571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101588 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101592 */     GIR_RootConstrainSelectedInstOperands,
     /* 101593 */     // GIR_Coverage, 4024,
     /* 101593 */     GIR_EraseRootFromParent_Done,
     /* 101594 */   // Label 1930: @101594
     /* 101594 */   GIM_Try, /*On fail goto*//*Label 1931*/ GIMT_Encode4(101639), // Rule ID 4025 //
     /* 101599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101602 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 101613 */     // (ld:{ *:[v4i16] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 101613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 101616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101633 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101637 */     GIR_RootConstrainSelectedInstOperands,
     /* 101638 */     // GIR_Coverage, 4025,
     /* 101638 */     GIR_EraseRootFromParent_Done,
     /* 101639 */   // Label 1931: @101639
     /* 101639 */   GIM_Try, /*On fail goto*//*Label 1932*/ GIMT_Encode4(101684), // Rule ID 4026 //
     /* 101644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101647 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 101658 */     // (ld:{ *:[v4f16] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 101658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 101661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101678 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101682 */     GIR_RootConstrainSelectedInstOperands,
     /* 101683 */     // GIR_Coverage, 4026,
     /* 101683 */     GIR_EraseRootFromParent_Done,
     /* 101684 */   // Label 1932: @101684
     /* 101684 */   GIM_Try, /*On fail goto*//*Label 1933*/ GIMT_Encode4(101729), // Rule ID 4027 //
     /* 101689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101692 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 101703 */     // (ld:{ *:[v4f16] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 101703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 101706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101723 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101727 */     GIR_RootConstrainSelectedInstOperands,
     /* 101728 */     // GIR_Coverage, 4027,
     /* 101728 */     GIR_EraseRootFromParent_Done,
     /* 101729 */   // Label 1933: @101729
     /* 101729 */   GIM_Try, /*On fail goto*//*Label 1934*/ GIMT_Encode4(101769), // Rule ID 4072 //
     /* 101734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101737 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 101748 */     // (ld:{ *:[v4i16] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 101748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 101751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101763 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101767 */     GIR_RootConstrainSelectedInstOperands,
     /* 101768 */     // GIR_Coverage, 4072,
     /* 101768 */     GIR_EraseRootFromParent_Done,
     /* 101769 */   // Label 1934: @101769
     /* 101769 */   GIM_Try, /*On fail goto*//*Label 1935*/ GIMT_Encode4(101809), // Rule ID 4074 //
     /* 101774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101777 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 101788 */     // (ld:{ *:[v4f16] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 101788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 101791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101803 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101807 */     GIR_RootConstrainSelectedInstOperands,
     /* 101808 */     // GIR_Coverage, 4074,
     /* 101808 */     GIR_EraseRootFromParent_Done,
     /* 101809 */   // Label 1935: @101809
     /* 101809 */   GIM_Try, /*On fail goto*//*Label 1936*/ GIMT_Encode4(101849), // Rule ID 4100 //
     /* 101814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101817 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 101828 */     // (ld:{ *:[v4i16] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 101831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101843 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101847 */     GIR_RootConstrainSelectedInstOperands,
     /* 101848 */     // GIR_Coverage, 4100,
     /* 101848 */     GIR_EraseRootFromParent_Done,
     /* 101849 */   // Label 1936: @101849
     /* 101849 */   GIM_Try, /*On fail goto*//*Label 1937*/ GIMT_Encode4(101889), // Rule ID 4102 //
     /* 101854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101857 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 101868 */     // (ld:{ *:[v4f16] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 101871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101883 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101887 */     GIR_RootConstrainSelectedInstOperands,
     /* 101888 */     // GIR_Coverage, 4102,
     /* 101888 */     GIR_EraseRootFromParent_Done,
     /* 101889 */   // Label 1937: @101889
     /* 101889 */   GIM_Try, /*On fail goto*//*Label 1938*/ GIMT_Encode4(101909), // Rule ID 6309 //
     /* 101894 */     // MIs[0] Rn
     /* 101894 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 101898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 101902 */     // (ld:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 101902 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev4h),
     /* 101907 */     GIR_RootConstrainSelectedInstOperands,
     /* 101908 */     // GIR_Coverage, 6309,
     /* 101908 */     GIR_Done,
     /* 101909 */   // Label 1938: @101909
     /* 101909 */   GIM_Reject,
     /* 101910 */ // Label 1929: @101910
     /* 101910 */ GIM_Reject,
     /* 101911 */ // Label 1795: @101911
     /* 101911 */ GIM_Try, /*On fail goto*//*Label 1939*/ GIMT_Encode4(102288),
     /* 101916 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101919 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101927 */   GIM_Try, /*On fail goto*//*Label 1940*/ GIMT_Encode4(101972), // Rule ID 4036 //
     /* 101932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101935 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 101946 */     // (ld:{ *:[v4i32] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 101946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 101949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101966 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101970 */     GIR_RootConstrainSelectedInstOperands,
     /* 101971 */     // GIR_Coverage, 4036,
     /* 101971 */     GIR_EraseRootFromParent_Done,
     /* 101972 */   // Label 1940: @101972
     /* 101972 */   GIM_Try, /*On fail goto*//*Label 1941*/ GIMT_Encode4(102017), // Rule ID 4037 //
     /* 101977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 101980 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 101991 */     // (ld:{ *:[v4i32] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 101991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 101994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102011 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102015 */     GIR_RootConstrainSelectedInstOperands,
     /* 102016 */     // GIR_Coverage, 4037,
     /* 102016 */     GIR_EraseRootFromParent_Done,
     /* 102017 */   // Label 1941: @102017
     /* 102017 */   GIM_Try, /*On fail goto*//*Label 1942*/ GIMT_Encode4(102062), // Rule ID 4038 //
     /* 102022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102025 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 102036 */     // (ld:{ *:[v4f32] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 102036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 102039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102056 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102060 */     GIR_RootConstrainSelectedInstOperands,
     /* 102061 */     // GIR_Coverage, 4038,
     /* 102061 */     GIR_EraseRootFromParent_Done,
     /* 102062 */   // Label 1942: @102062
     /* 102062 */   GIM_Try, /*On fail goto*//*Label 1943*/ GIMT_Encode4(102107), // Rule ID 4039 //
     /* 102067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102070 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 102081 */     // (ld:{ *:[v4f32] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 102081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 102084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102101 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102105 */     GIR_RootConstrainSelectedInstOperands,
     /* 102106 */     // GIR_Coverage, 4039,
     /* 102106 */     GIR_EraseRootFromParent_Done,
     /* 102107 */   // Label 1943: @102107
     /* 102107 */   GIM_Try, /*On fail goto*//*Label 1944*/ GIMT_Encode4(102147), // Rule ID 4077 //
     /* 102112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102115 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 102126 */     // (ld:{ *:[v4f32] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 102126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 102129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102141 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102145 */     GIR_RootConstrainSelectedInstOperands,
     /* 102146 */     // GIR_Coverage, 4077,
     /* 102146 */     GIR_EraseRootFromParent_Done,
     /* 102147 */   // Label 1944: @102147
     /* 102147 */   GIM_Try, /*On fail goto*//*Label 1945*/ GIMT_Encode4(102187), // Rule ID 4081 //
     /* 102152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102155 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 102166 */     // (ld:{ *:[v4i32] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 102166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 102169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102181 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102185 */     GIR_RootConstrainSelectedInstOperands,
     /* 102186 */     // GIR_Coverage, 4081,
     /* 102186 */     GIR_EraseRootFromParent_Done,
     /* 102187 */   // Label 1945: @102187
     /* 102187 */   GIM_Try, /*On fail goto*//*Label 1946*/ GIMT_Encode4(102227), // Rule ID 4107 //
     /* 102192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102195 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 102206 */     // (ld:{ *:[v4f32] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 102206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 102209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102221 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102225 */     GIR_RootConstrainSelectedInstOperands,
     /* 102226 */     // GIR_Coverage, 4107,
     /* 102226 */     GIR_EraseRootFromParent_Done,
     /* 102227 */   // Label 1946: @102227
     /* 102227 */   GIM_Try, /*On fail goto*//*Label 1947*/ GIMT_Encode4(102267), // Rule ID 4108 //
     /* 102232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102235 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 102246 */     // (ld:{ *:[v4i32] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 102246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 102249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102261 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102265 */     GIR_RootConstrainSelectedInstOperands,
     /* 102266 */     // GIR_Coverage, 4108,
     /* 102266 */     GIR_EraseRootFromParent_Done,
     /* 102267 */   // Label 1947: @102267
     /* 102267 */   GIM_Try, /*On fail goto*//*Label 1948*/ GIMT_Encode4(102287), // Rule ID 6306 //
     /* 102272 */     // MIs[0] Rn
     /* 102272 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 102276 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 102280 */     // (ld:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 102280 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev4s),
     /* 102285 */     GIR_RootConstrainSelectedInstOperands,
     /* 102286 */     // GIR_Coverage, 6306,
     /* 102286 */     GIR_Done,
     /* 102287 */   // Label 1948: @102287
     /* 102287 */   GIM_Reject,
     /* 102288 */ // Label 1939: @102288
     /* 102288 */ GIM_Reject,
     /* 102289 */ // Label 1796: @102289
     /* 102289 */ GIM_Try, /*On fail goto*//*Label 1949*/ GIMT_Encode4(102496),
     /* 102294 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102297 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102305 */   GIM_Try, /*On fail goto*//*Label 1950*/ GIMT_Encode4(102350), // Rule ID 4022 //
     /* 102310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102313 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 102324 */     // (ld:{ *:[v8i8] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 102324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 102327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102344 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102348 */     GIR_RootConstrainSelectedInstOperands,
     /* 102349 */     // GIR_Coverage, 4022,
     /* 102349 */     GIR_EraseRootFromParent_Done,
     /* 102350 */   // Label 1950: @102350
     /* 102350 */   GIM_Try, /*On fail goto*//*Label 1951*/ GIMT_Encode4(102395), // Rule ID 4023 //
     /* 102355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102358 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 102369 */     // (ld:{ *:[v8i8] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 102369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 102372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102389 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102393 */     GIR_RootConstrainSelectedInstOperands,
     /* 102394 */     // GIR_Coverage, 4023,
     /* 102394 */     GIR_EraseRootFromParent_Done,
     /* 102395 */   // Label 1951: @102395
     /* 102395 */   GIM_Try, /*On fail goto*//*Label 1952*/ GIMT_Encode4(102435), // Rule ID 4071 //
     /* 102400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102403 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 102414 */     // (ld:{ *:[v8i8] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 102414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 102417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102429 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102433 */     GIR_RootConstrainSelectedInstOperands,
     /* 102434 */     // GIR_Coverage, 4071,
     /* 102434 */     GIR_EraseRootFromParent_Done,
     /* 102435 */   // Label 1952: @102435
     /* 102435 */   GIM_Try, /*On fail goto*//*Label 1953*/ GIMT_Encode4(102475), // Rule ID 4101 //
     /* 102440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102443 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 102454 */     // (ld:{ *:[v8i8] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 102454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 102457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102469 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102473 */     GIR_RootConstrainSelectedInstOperands,
     /* 102474 */     // GIR_Coverage, 4101,
     /* 102474 */     GIR_EraseRootFromParent_Done,
     /* 102475 */   // Label 1953: @102475
     /* 102475 */   GIM_Try, /*On fail goto*//*Label 1954*/ GIMT_Encode4(102495), // Rule ID 6308 //
     /* 102480 */     // MIs[0] Rn
     /* 102480 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 102484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 102488 */     // (ld:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 102488 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev8b),
     /* 102493 */     GIR_RootConstrainSelectedInstOperands,
     /* 102494 */     // GIR_Coverage, 6308,
     /* 102494 */     GIR_Done,
     /* 102495 */   // Label 1954: @102495
     /* 102495 */   GIM_Reject,
     /* 102496 */ // Label 1949: @102496
     /* 102496 */ GIM_Reject,
     /* 102497 */ // Label 1797: @102497
     /* 102497 */ GIM_Try, /*On fail goto*//*Label 1955*/ GIMT_Encode4(102874),
     /* 102502 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102505 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102509 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102513 */   GIM_Try, /*On fail goto*//*Label 1956*/ GIMT_Encode4(102558), // Rule ID 4040 //
     /* 102518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102521 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 102532 */     // (ld:{ *:[v8i16] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 102532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 102535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102552 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102556 */     GIR_RootConstrainSelectedInstOperands,
     /* 102557 */     // GIR_Coverage, 4040,
     /* 102557 */     GIR_EraseRootFromParent_Done,
     /* 102558 */   // Label 1956: @102558
     /* 102558 */   GIM_Try, /*On fail goto*//*Label 1957*/ GIMT_Encode4(102603), // Rule ID 4041 //
     /* 102563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102566 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 102577 */     // (ld:{ *:[v8i16] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 102577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 102580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102597 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102601 */     GIR_RootConstrainSelectedInstOperands,
     /* 102602 */     // GIR_Coverage, 4041,
     /* 102602 */     GIR_EraseRootFromParent_Done,
     /* 102603 */   // Label 1957: @102603
     /* 102603 */   GIM_Try, /*On fail goto*//*Label 1958*/ GIMT_Encode4(102648), // Rule ID 4042 //
     /* 102608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102611 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 102622 */     // (ld:{ *:[v8f16] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 102622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 102625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102642 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102646 */     GIR_RootConstrainSelectedInstOperands,
     /* 102647 */     // GIR_Coverage, 4042,
     /* 102647 */     GIR_EraseRootFromParent_Done,
     /* 102648 */   // Label 1958: @102648
     /* 102648 */   GIM_Try, /*On fail goto*//*Label 1959*/ GIMT_Encode4(102693), // Rule ID 4043 //
     /* 102653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102656 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 102667 */     // (ld:{ *:[v8f16] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 102667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 102670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102687 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102691 */     GIR_RootConstrainSelectedInstOperands,
     /* 102692 */     // GIR_Coverage, 4043,
     /* 102692 */     GIR_EraseRootFromParent_Done,
     /* 102693 */   // Label 1959: @102693
     /* 102693 */   GIM_Try, /*On fail goto*//*Label 1960*/ GIMT_Encode4(102733), // Rule ID 4080 //
     /* 102698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102701 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 102712 */     // (ld:{ *:[v8i16] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 102712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 102715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102727 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102731 */     GIR_RootConstrainSelectedInstOperands,
     /* 102732 */     // GIR_Coverage, 4080,
     /* 102732 */     GIR_EraseRootFromParent_Done,
     /* 102733 */   // Label 1960: @102733
     /* 102733 */   GIM_Try, /*On fail goto*//*Label 1961*/ GIMT_Encode4(102773), // Rule ID 4083 //
     /* 102738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102741 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 102752 */     // (ld:{ *:[v8f16] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 102752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 102755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102767 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102771 */     GIR_RootConstrainSelectedInstOperands,
     /* 102772 */     // GIR_Coverage, 4083,
     /* 102772 */     GIR_EraseRootFromParent_Done,
     /* 102773 */   // Label 1961: @102773
     /* 102773 */   GIM_Try, /*On fail goto*//*Label 1962*/ GIMT_Encode4(102813), // Rule ID 4109 //
     /* 102778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102781 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 102792 */     // (ld:{ *:[v8i16] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 102792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 102795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102807 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102811 */     GIR_RootConstrainSelectedInstOperands,
     /* 102812 */     // GIR_Coverage, 4109,
     /* 102812 */     GIR_EraseRootFromParent_Done,
     /* 102813 */   // Label 1962: @102813
     /* 102813 */   GIM_Try, /*On fail goto*//*Label 1963*/ GIMT_Encode4(102853), // Rule ID 4111 //
     /* 102818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102821 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 102832 */     // (ld:{ *:[v8f16] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 102832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 102835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102847 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102851 */     GIR_RootConstrainSelectedInstOperands,
     /* 102852 */     // GIR_Coverage, 4111,
     /* 102852 */     GIR_EraseRootFromParent_Done,
     /* 102853 */   // Label 1963: @102853
     /* 102853 */   GIM_Try, /*On fail goto*//*Label 1964*/ GIMT_Encode4(102873), // Rule ID 6305 //
     /* 102858 */     // MIs[0] Rn
     /* 102858 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 102862 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 102866 */     // (ld:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 102866 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev8h),
     /* 102871 */     GIR_RootConstrainSelectedInstOperands,
     /* 102872 */     // GIR_Coverage, 6305,
     /* 102872 */     GIR_Done,
     /* 102873 */   // Label 1964: @102873
     /* 102873 */   GIM_Reject,
     /* 102874 */ // Label 1955: @102874
     /* 102874 */ GIM_Reject,
     /* 102875 */ // Label 1798: @102875
     /* 102875 */ GIM_Try, /*On fail goto*//*Label 1965*/ GIMT_Encode4(103082),
     /* 102880 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102883 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102891 */   GIM_Try, /*On fail goto*//*Label 1966*/ GIMT_Encode4(102936), // Rule ID 4044 //
     /* 102896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102899 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 102910 */     // (ld:{ *:[v16i8] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 102910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 102913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102930 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102934 */     GIR_RootConstrainSelectedInstOperands,
     /* 102935 */     // GIR_Coverage, 4044,
     /* 102935 */     GIR_EraseRootFromParent_Done,
     /* 102936 */   // Label 1966: @102936
     /* 102936 */   GIM_Try, /*On fail goto*//*Label 1967*/ GIMT_Encode4(102981), // Rule ID 4045 //
     /* 102941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102944 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 102955 */     // (ld:{ *:[v16i8] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 102955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 102958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102975 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102979 */     GIR_RootConstrainSelectedInstOperands,
     /* 102980 */     // GIR_Coverage, 4045,
     /* 102980 */     GIR_EraseRootFromParent_Done,
     /* 102981 */   // Label 1967: @102981
     /* 102981 */   GIM_Try, /*On fail goto*//*Label 1968*/ GIMT_Encode4(103021), // Rule ID 4079 //
     /* 102986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 102989 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 103000 */     // (ld:{ *:[v16i8] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 103000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 103003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103015 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103019 */     GIR_RootConstrainSelectedInstOperands,
     /* 103020 */     // GIR_Coverage, 4079,
     /* 103020 */     GIR_EraseRootFromParent_Done,
     /* 103021 */   // Label 1968: @103021
     /* 103021 */   GIM_Try, /*On fail goto*//*Label 1969*/ GIMT_Encode4(103061), // Rule ID 4110 //
     /* 103026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 103029 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 103040 */     // (ld:{ *:[v16i8] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 103040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 103043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103055 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103059 */     GIR_RootConstrainSelectedInstOperands,
     /* 103060 */     // GIR_Coverage, 4110,
     /* 103060 */     GIR_EraseRootFromParent_Done,
     /* 103061 */   // Label 1969: @103061
     /* 103061 */   GIM_Try, /*On fail goto*//*Label 1970*/ GIMT_Encode4(103081), // Rule ID 6304 //
     /* 103066 */     // MIs[0] Rn
     /* 103066 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 103070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 103074 */     // (ld:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 103074 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev16b),
     /* 103079 */     GIR_RootConstrainSelectedInstOperands,
     /* 103080 */     // GIR_Coverage, 6304,
     /* 103080 */     GIR_Done,
     /* 103081 */   // Label 1970: @103081
     /* 103081 */   GIM_Reject,
     /* 103082 */ // Label 1965: @103082
     /* 103082 */ GIM_Reject,
     /* 103083 */ // Label 1799: @103083
     /* 103083 */ GIM_Try, /*On fail goto*//*Label 1971*/ GIMT_Encode4(103146), // Rule ID 10790 //
     /* 103088 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 103091 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103094 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 103102 */   // MIs[0] base
     /* 103102 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 103106 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103110 */   // (ld:{ *:[nxv2f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_D_IMM:{ *:[nxv2f16] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 103110 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 103113 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 103117 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103122 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 103125 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103127 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_D_IMM),
     /* 103130 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 103132 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103135 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 103137 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103140 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103144 */   GIR_RootConstrainSelectedInstOperands,
     /* 103145 */   // GIR_Coverage, 10790,
     /* 103145 */   GIR_EraseRootFromParent_Done,
     /* 103146 */ // Label 1971: @103146
     /* 103146 */ GIM_Reject,
     /* 103147 */ // Label 1800: @103147
     /* 103147 */ GIM_Try, /*On fail goto*//*Label 1972*/ GIMT_Encode4(103210), // Rule ID 10796 //
     /* 103152 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 103155 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103158 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 103166 */   // MIs[0] base
     /* 103166 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 103170 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103174 */   // (ld:{ *:[nxv2f32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_D_IMM:{ *:[nxv2f32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 103174 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 103177 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 103181 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103186 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 103189 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103191 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_D_IMM),
     /* 103194 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 103196 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103199 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 103201 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103204 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103208 */   GIR_RootConstrainSelectedInstOperands,
     /* 103209 */   // GIR_Coverage, 10796,
     /* 103209 */   GIR_EraseRootFromParent_Done,
     /* 103210 */ // Label 1972: @103210
     /* 103210 */ GIM_Reject,
     /* 103211 */ // Label 1801: @103211
     /* 103211 */ GIM_Try, /*On fail goto*//*Label 1973*/ GIMT_Encode4(103324),
     /* 103216 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103219 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 103227 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 103231 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103235 */   GIM_Try, /*On fail goto*//*Label 1974*/ GIMT_Encode4(103279), // Rule ID 10781 //
     /* 103240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 103243 */     // (ld:{ *:[nxv2i64] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1D_IMM:{ *:[nxv2i64] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 103243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 103246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 103250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103255 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 103258 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_IMM),
     /* 103263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 103265 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103268 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 103270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103273 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103277 */     GIR_RootConstrainSelectedInstOperands,
     /* 103278 */     // GIR_Coverage, 10781,
     /* 103278 */     GIR_EraseRootFromParent_Done,
     /* 103279 */   // Label 1974: @103279
     /* 103279 */   GIM_Try, /*On fail goto*//*Label 1975*/ GIMT_Encode4(103323), // Rule ID 10799 //
     /* 103284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 103287 */     // (ld:{ *:[nxv2f64] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1D_IMM:{ *:[nxv2f64] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 103287 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 103290 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 103294 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103299 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 103302 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_IMM),
     /* 103307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 103309 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103312 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 103314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103317 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103321 */     GIR_RootConstrainSelectedInstOperands,
     /* 103322 */     // GIR_Coverage, 10799,
     /* 103322 */     GIR_EraseRootFromParent_Done,
     /* 103323 */   // Label 1975: @103323
     /* 103323 */   GIM_Reject,
     /* 103324 */ // Label 1973: @103324
     /* 103324 */ GIM_Reject,
     /* 103325 */ // Label 1802: @103325
     /* 103325 */ GIM_Try, /*On fail goto*//*Label 1976*/ GIMT_Encode4(103388), // Rule ID 10787 //
     /* 103330 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 103333 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103336 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 103344 */   // MIs[0] base
     /* 103344 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 103348 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103352 */   // (ld:{ *:[nxv4f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_S_IMM:{ *:[nxv4f16] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 103352 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 103355 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 103359 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103364 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 103367 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103369 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_S_IMM),
     /* 103372 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 103374 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103377 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 103379 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103382 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103386 */   GIR_RootConstrainSelectedInstOperands,
     /* 103387 */   // GIR_Coverage, 10787,
     /* 103387 */   GIR_EraseRootFromParent_Done,
     /* 103388 */ // Label 1976: @103388
     /* 103388 */ GIM_Reject,
     /* 103389 */ // Label 1803: @103389
     /* 103389 */ GIM_Try, /*On fail goto*//*Label 1977*/ GIMT_Encode4(103502),
     /* 103394 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103397 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 103405 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 103409 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103413 */   GIM_Try, /*On fail goto*//*Label 1978*/ GIMT_Encode4(103457), // Rule ID 10769 //
     /* 103418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 103421 */     // (ld:{ *:[nxv4i32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_IMM:{ *:[nxv4i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 103421 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 103424 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 103428 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103433 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 103436 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_IMM),
     /* 103441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 103443 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103446 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 103448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103451 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103455 */     GIR_RootConstrainSelectedInstOperands,
     /* 103456 */     // GIR_Coverage, 10769,
     /* 103456 */     GIR_EraseRootFromParent_Done,
     /* 103457 */   // Label 1978: @103457
     /* 103457 */   GIM_Try, /*On fail goto*//*Label 1979*/ GIMT_Encode4(103501), // Rule ID 10793 //
     /* 103462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 103465 */     // (ld:{ *:[nxv4f32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_IMM:{ *:[nxv4f32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 103465 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 103468 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 103472 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103477 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 103480 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_IMM),
     /* 103485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 103487 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103490 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 103492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103495 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103499 */     GIR_RootConstrainSelectedInstOperands,
     /* 103500 */     // GIR_Coverage, 10793,
     /* 103500 */     GIR_EraseRootFromParent_Done,
     /* 103501 */   // Label 1979: @103501
     /* 103501 */   GIM_Reject,
     /* 103502 */ // Label 1977: @103502
     /* 103502 */ GIM_Reject,
     /* 103503 */ // Label 1804: @103503
     /* 103503 */ GIM_Try, /*On fail goto*//*Label 1980*/ GIMT_Encode4(103616),
     /* 103508 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103511 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 103519 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 103523 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103527 */   GIM_Try, /*On fail goto*//*Label 1981*/ GIMT_Encode4(103571), // Rule ID 10748 //
     /* 103532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 103535 */     // (ld:{ *:[nxv8i16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_IMM:{ *:[nxv8i16] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 103535 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 103538 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 103542 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103547 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 103550 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_IMM),
     /* 103555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 103557 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103560 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 103562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103565 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103569 */     GIR_RootConstrainSelectedInstOperands,
     /* 103570 */     // GIR_Coverage, 10748,
     /* 103570 */     GIR_EraseRootFromParent_Done,
     /* 103571 */   // Label 1981: @103571
     /* 103571 */   GIM_Try, /*On fail goto*//*Label 1982*/ GIMT_Encode4(103615), // Rule ID 10784 //
     /* 103576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 103579 */     // (ld:{ *:[nxv8f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_IMM:{ *:[nxv8f16] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 103579 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 103582 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 103586 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103591 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 103594 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_IMM),
     /* 103599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 103601 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103604 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 103606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103609 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103613 */     GIR_RootConstrainSelectedInstOperands,
     /* 103614 */     // GIR_Coverage, 10784,
     /* 103614 */     GIR_EraseRootFromParent_Done,
     /* 103615 */   // Label 1982: @103615
     /* 103615 */   GIM_Reject,
     /* 103616 */ // Label 1980: @103616
     /* 103616 */ GIM_Reject,
     /* 103617 */ // Label 1805: @103617
     /* 103617 */ GIM_Try, /*On fail goto*//*Label 1983*/ GIMT_Encode4(103660), // Rule ID 2419 //
     /* 103622 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 103625 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103628 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 103636 */   // MIs[0] base
     /* 103636 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 103640 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103644 */   // (ld:{ *:[nxv16i1] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_PXI:{ *:[nxv16i1] } GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 103644 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_PXI),
     /* 103647 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pt]
     /* 103649 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 103651 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103654 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103658 */   GIR_RootConstrainSelectedInstOperands,
     /* 103659 */   // GIR_Coverage, 2419,
     /* 103659 */   GIR_EraseRootFromParent_Done,
     /* 103660 */ // Label 1983: @103660
     /* 103660 */ GIM_Reject,
     /* 103661 */ // Label 1806: @103661
     /* 103661 */ GIM_Try, /*On fail goto*//*Label 1984*/ GIMT_Encode4(103724), // Rule ID 10716 //
     /* 103666 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 103669 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103672 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 103680 */   // MIs[0] base
     /* 103680 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 103684 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103688 */   // (ld:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1B_IMM:{ *:[nxv16i8] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 103688 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 103691 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /* 103695 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103700 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 103703 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103705 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1B_IMM),
     /* 103708 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 103710 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103713 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 103715 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103718 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103722 */   GIR_RootConstrainSelectedInstOperands,
     /* 103723 */   // GIR_Coverage, 10716,
     /* 103723 */   GIR_EraseRootFromParent_Done,
     /* 103724 */ // Label 1984: @103724
     /* 103724 */ GIM_Reject,
     /* 103725 */ // Label 1807: @103725
     /* 103725 */ GIM_Reject,
     /* 103726 */ // Label 17: @103726
     /* 103726 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 1987*/ GIMT_Encode4(104775),
     /* 103737 */ /*GILLT_s32*//*Label 1985*/ GIMT_Encode4(103745),
     /* 103741 */ /*GILLT_s64*//*Label 1986*/ GIMT_Encode4(104159),
     /* 103745 */ // Label 1985: @103745
     /* 103745 */ GIM_Try, /*On fail goto*//*Label 1988*/ GIMT_Encode4(104158),
     /* 103750 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103753 */   GIM_Try, /*On fail goto*//*Label 1989*/ GIMT_Encode4(103806), // Rule ID 247 //
     /* 103758 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 103765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 103769 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 103780 */     // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 103780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWroW),
     /* 103783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 103795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 103800 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103804 */     GIR_RootConstrainSelectedInstOperands,
     /* 103805 */     // GIR_Coverage, 247,
     /* 103805 */     GIR_EraseRootFromParent_Done,
     /* 103806 */   // Label 1989: @103806
     /* 103806 */   GIM_Try, /*On fail goto*//*Label 1990*/ GIMT_Encode4(103859), // Rule ID 248 //
     /* 103811 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 103818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 103822 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 103833 */     // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 103833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWroX),
     /* 103836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 103848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 103853 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103857 */     GIR_RootConstrainSelectedInstOperands,
     /* 103858 */     // GIR_Coverage, 248,
     /* 103858 */     GIR_EraseRootFromParent_Done,
     /* 103859 */   // Label 1990: @103859
     /* 103859 */   GIM_Try, /*On fail goto*//*Label 1991*/ GIMT_Encode4(103912), // Rule ID 251 //
     /* 103864 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 103871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 103875 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 103886 */     // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 103886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWroW),
     /* 103889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 103901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 103906 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103910 */     GIR_RootConstrainSelectedInstOperands,
     /* 103911 */     // GIR_Coverage, 251,
     /* 103911 */     GIR_EraseRootFromParent_Done,
     /* 103912 */   // Label 1991: @103912
     /* 103912 */   GIM_Try, /*On fail goto*//*Label 1992*/ GIMT_Encode4(103965), // Rule ID 252 //
     /* 103917 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 103924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 103928 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 103939 */     // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 103939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWroX),
     /* 103942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 103954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 103959 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103963 */     GIR_RootConstrainSelectedInstOperands,
     /* 103964 */     // GIR_Coverage, 252,
     /* 103964 */     GIR_EraseRootFromParent_Done,
     /* 103965 */   // Label 1992: @103965
     /* 103965 */   GIM_Try, /*On fail goto*//*Label 1993*/ GIMT_Encode4(104013), // Rule ID 268 //
     /* 103970 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 103977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 103981 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 103992 */     // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 103992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWui),
     /* 103995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104007 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104011 */     GIR_RootConstrainSelectedInstOperands,
     /* 104012 */     // GIR_Coverage, 268,
     /* 104012 */     GIR_EraseRootFromParent_Done,
     /* 104013 */   // Label 1993: @104013
     /* 104013 */   GIM_Try, /*On fail goto*//*Label 1994*/ GIMT_Encode4(104061), // Rule ID 270 //
     /* 104018 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 104025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 104029 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 104040 */     // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 104040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWui),
     /* 104043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104055 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104059 */     GIR_RootConstrainSelectedInstOperands,
     /* 104060 */     // GIR_Coverage, 270,
     /* 104060 */     GIR_EraseRootFromParent_Done,
     /* 104061 */   // Label 1994: @104061
     /* 104061 */   GIM_Try, /*On fail goto*//*Label 1995*/ GIMT_Encode4(104109), // Rule ID 289 //
     /* 104066 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 104073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 104077 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 104088 */     // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDURSHWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 104088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSHWi),
     /* 104091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104103 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104107 */     GIR_RootConstrainSelectedInstOperands,
     /* 104108 */     // GIR_Coverage, 289,
     /* 104108 */     GIR_EraseRootFromParent_Done,
     /* 104109 */   // Label 1995: @104109
     /* 104109 */   GIM_Try, /*On fail goto*//*Label 1996*/ GIMT_Encode4(104157), // Rule ID 291 //
     /* 104114 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 104121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 104125 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 104136 */     // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDURSBWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 104136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSBWi),
     /* 104139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104151 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104155 */     GIR_RootConstrainSelectedInstOperands,
     /* 104156 */     // GIR_Coverage, 291,
     /* 104156 */     GIR_EraseRootFromParent_Done,
     /* 104157 */   // Label 1996: @104157
     /* 104157 */   GIM_Reject,
     /* 104158 */ // Label 1988: @104158
     /* 104158 */ GIM_Reject,
     /* 104159 */ // Label 1986: @104159
     /* 104159 */ GIM_Try, /*On fail goto*//*Label 1997*/ GIMT_Encode4(104774),
     /* 104164 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104167 */   GIM_Try, /*On fail goto*//*Label 1998*/ GIMT_Encode4(104220), // Rule ID 249 //
     /* 104172 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 104179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104183 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 104194 */     // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 104194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXroW),
     /* 104197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104214 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104218 */     GIR_RootConstrainSelectedInstOperands,
     /* 104219 */     // GIR_Coverage, 249,
     /* 104219 */     GIR_EraseRootFromParent_Done,
     /* 104220 */   // Label 1998: @104220
     /* 104220 */   GIM_Try, /*On fail goto*//*Label 1999*/ GIMT_Encode4(104273), // Rule ID 250 //
     /* 104225 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 104232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104236 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 104247 */     // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 104247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXroX),
     /* 104250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104267 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104271 */     GIR_RootConstrainSelectedInstOperands,
     /* 104272 */     // GIR_Coverage, 250,
     /* 104272 */     GIR_EraseRootFromParent_Done,
     /* 104273 */   // Label 1999: @104273
     /* 104273 */   GIM_Try, /*On fail goto*//*Label 2000*/ GIMT_Encode4(104326), // Rule ID 253 //
     /* 104278 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 104285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104289 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 104300 */     // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 104300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXroW),
     /* 104303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104320 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104324 */     GIR_RootConstrainSelectedInstOperands,
     /* 104325 */     // GIR_Coverage, 253,
     /* 104325 */     GIR_EraseRootFromParent_Done,
     /* 104326 */   // Label 2000: @104326
     /* 104326 */   GIM_Try, /*On fail goto*//*Label 2001*/ GIMT_Encode4(104379), // Rule ID 254 //
     /* 104331 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 104338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104342 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 104353 */     // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 104353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXroX),
     /* 104356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104373 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104377 */     GIR_RootConstrainSelectedInstOperands,
     /* 104378 */     // GIR_Coverage, 254,
     /* 104378 */     GIR_EraseRootFromParent_Done,
     /* 104379 */   // Label 2001: @104379
     /* 104379 */   GIM_Try, /*On fail goto*//*Label 2002*/ GIMT_Encode4(104432), // Rule ID 255 //
     /* 104384 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 104391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104395 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 104406 */     // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 104406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWroW),
     /* 104409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104426 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104430 */     GIR_RootConstrainSelectedInstOperands,
     /* 104431 */     // GIR_Coverage, 255,
     /* 104431 */     GIR_EraseRootFromParent_Done,
     /* 104432 */   // Label 2002: @104432
     /* 104432 */   GIM_Try, /*On fail goto*//*Label 2003*/ GIMT_Encode4(104485), // Rule ID 256 //
     /* 104437 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 104444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104448 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 104459 */     // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 104459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWroX),
     /* 104462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104479 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104483 */     GIR_RootConstrainSelectedInstOperands,
     /* 104484 */     // GIR_Coverage, 256,
     /* 104484 */     GIR_EraseRootFromParent_Done,
     /* 104485 */   // Label 2003: @104485
     /* 104485 */   GIM_Try, /*On fail goto*//*Label 2004*/ GIMT_Encode4(104533), // Rule ID 269 //
     /* 104490 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 104497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104501 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 104512 */     // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 104512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXui),
     /* 104515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104527 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104531 */     GIR_RootConstrainSelectedInstOperands,
     /* 104532 */     // GIR_Coverage, 269,
     /* 104532 */     GIR_EraseRootFromParent_Done,
     /* 104533 */   // Label 2004: @104533
     /* 104533 */   GIM_Try, /*On fail goto*//*Label 2005*/ GIMT_Encode4(104581), // Rule ID 271 //
     /* 104538 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 104545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104549 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 104560 */     // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 104560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXui),
     /* 104563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104575 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104579 */     GIR_RootConstrainSelectedInstOperands,
     /* 104580 */     // GIR_Coverage, 271,
     /* 104580 */     GIR_EraseRootFromParent_Done,
     /* 104581 */   // Label 2005: @104581
     /* 104581 */   GIM_Try, /*On fail goto*//*Label 2006*/ GIMT_Encode4(104629), // Rule ID 272 //
     /* 104586 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 104593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104597 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 104608 */     // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 104608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWui),
     /* 104611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104623 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104627 */     GIR_RootConstrainSelectedInstOperands,
     /* 104628 */     // GIR_Coverage, 272,
     /* 104628 */     GIR_EraseRootFromParent_Done,
     /* 104629 */   // Label 2006: @104629
     /* 104629 */   GIM_Try, /*On fail goto*//*Label 2007*/ GIMT_Encode4(104677), // Rule ID 290 //
     /* 104634 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 104641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104645 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 104656 */     // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDURSHXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 104656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSHXi),
     /* 104659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104671 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104675 */     GIR_RootConstrainSelectedInstOperands,
     /* 104676 */     // GIR_Coverage, 290,
     /* 104676 */     GIR_EraseRootFromParent_Done,
     /* 104677 */   // Label 2007: @104677
     /* 104677 */   GIM_Try, /*On fail goto*//*Label 2008*/ GIMT_Encode4(104725), // Rule ID 292 //
     /* 104682 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 104689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104693 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 104704 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDURSBXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 104704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSBXi),
     /* 104707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104719 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104723 */     GIR_RootConstrainSelectedInstOperands,
     /* 104724 */     // GIR_Coverage, 292,
     /* 104724 */     GIR_EraseRootFromParent_Done,
     /* 104725 */   // Label 2008: @104725
     /* 104725 */   GIM_Try, /*On fail goto*//*Label 2009*/ GIMT_Encode4(104773), // Rule ID 293 //
     /* 104730 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 104737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104741 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 104752 */     // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDURSWi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 104752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSWi),
     /* 104755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104767 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104771 */     GIR_RootConstrainSelectedInstOperands,
     /* 104772 */     // GIR_Coverage, 293,
     /* 104772 */     GIR_EraseRootFromParent_Done,
     /* 104773 */   // Label 2009: @104773
     /* 104773 */   GIM_Reject,
     /* 104774 */ // Label 1997: @104774
     /* 104774 */ GIM_Reject,
     /* 104775 */ // Label 1987: @104775
     /* 104775 */ GIM_Reject,
     /* 104776 */ // Label 18: @104776
     /* 104776 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2012*/ GIMT_Encode4(107744),
     /* 104787 */ /*GILLT_s32*//*Label 2010*/ GIMT_Encode4(104795),
     /* 104791 */ /*GILLT_s64*//*Label 2011*/ GIMT_Encode4(106254),
     /* 104795 */ // Label 2010: @104795
     /* 104795 */ GIM_Try, /*On fail goto*//*Label 2013*/ GIMT_Encode4(104851), // Rule ID 229 //
     /* 104800 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104803 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 104810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 104814 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104818 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 104825 */   // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 104825 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 104828 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104830 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104835 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104840 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104845 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104849 */   GIR_RootConstrainSelectedInstOperands,
     /* 104850 */   // GIR_Coverage, 229,
     /* 104850 */   GIR_EraseRootFromParent_Done,
     /* 104851 */ // Label 2013: @104851
     /* 104851 */ GIM_Try, /*On fail goto*//*Label 2014*/ GIMT_Encode4(104907), // Rule ID 230 //
     /* 104856 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104859 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 104866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 104870 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104874 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 104881 */   // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 104881 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 104884 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104886 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104891 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104896 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104901 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104905 */   GIR_RootConstrainSelectedInstOperands,
     /* 104906 */   // GIR_Coverage, 230,
     /* 104906 */   GIR_EraseRootFromParent_Done,
     /* 104907 */ // Label 2014: @104907
     /* 104907 */ GIM_Try, /*On fail goto*//*Label 2015*/ GIMT_Encode4(104963), // Rule ID 231 //
     /* 104912 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104915 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 104922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 104926 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104930 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 104937 */   // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 104937 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 104940 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104942 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104947 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104952 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104957 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104961 */   GIR_RootConstrainSelectedInstOperands,
     /* 104962 */   // GIR_Coverage, 231,
     /* 104962 */   GIR_EraseRootFromParent_Done,
     /* 104963 */ // Label 2015: @104963
     /* 104963 */ GIM_Try, /*On fail goto*//*Label 2016*/ GIMT_Encode4(105019), // Rule ID 232 //
     /* 104968 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104971 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 104978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 104982 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104986 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 104993 */   // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 104993 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 104996 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104998 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105003 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105008 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105013 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105017 */   GIR_RootConstrainSelectedInstOperands,
     /* 105018 */   // GIR_Coverage, 232,
     /* 105018 */   GIR_EraseRootFromParent_Done,
     /* 105019 */ // Label 2016: @105019
     /* 105019 */ GIM_Try, /*On fail goto*//*Label 2017*/ GIMT_Encode4(105075), // Rule ID 4068 //
     /* 105024 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105027 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 105034 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105038 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105042 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 105049 */   // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 105049 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 105052 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105054 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105059 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105064 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105069 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105073 */   GIR_RootConstrainSelectedInstOperands,
     /* 105074 */   // GIR_Coverage, 4068,
     /* 105074 */   GIR_EraseRootFromParent_Done,
     /* 105075 */ // Label 2017: @105075
     /* 105075 */ GIM_Try, /*On fail goto*//*Label 2018*/ GIMT_Encode4(105131), // Rule ID 4069 //
     /* 105080 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105083 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 105090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105094 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105098 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 105105 */   // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 105105 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 105108 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105110 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105115 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105120 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105125 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105129 */   GIR_RootConstrainSelectedInstOperands,
     /* 105130 */   // GIR_Coverage, 4069,
     /* 105130 */   GIR_EraseRootFromParent_Done,
     /* 105131 */ // Label 2018: @105131
     /* 105131 */ GIM_Try, /*On fail goto*//*Label 2019*/ GIMT_Encode4(105182), // Rule ID 266 //
     /* 105136 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105139 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 105146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105150 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105154 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 105161 */   // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 105161 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 105164 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105166 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105171 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105176 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105180 */   GIR_RootConstrainSelectedInstOperands,
     /* 105181 */   // GIR_Coverage, 266,
     /* 105181 */   GIR_EraseRootFromParent_Done,
     /* 105182 */ // Label 2019: @105182
     /* 105182 */ GIM_Try, /*On fail goto*//*Label 2020*/ GIMT_Encode4(105233), // Rule ID 267 //
     /* 105187 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105190 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 105197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105201 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105205 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 105212 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 105212 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 105215 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105217 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105222 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105227 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105231 */   GIR_RootConstrainSelectedInstOperands,
     /* 105232 */   // GIR_Coverage, 267,
     /* 105232 */   GIR_EraseRootFromParent_Done,
     /* 105233 */ // Label 2020: @105233
     /* 105233 */ GIM_Try, /*On fail goto*//*Label 2021*/ GIMT_Encode4(105292), // Rule ID 6937 //
     /* 105238 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 105241 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 105248 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 105251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105255 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105259 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 105266 */   // (atomic_load:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15502>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset)
     /* 105266 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 105269 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105271 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105276 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105281 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 105286 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105290 */   GIR_RootConstrainSelectedInstOperands,
     /* 105291 */   // GIR_Coverage, 6937,
     /* 105291 */   GIR_EraseRootFromParent_Done,
     /* 105292 */ // Label 2021: @105292
     /* 105292 */ GIM_Try, /*On fail goto*//*Label 2022*/ GIMT_Encode4(105351), // Rule ID 6939 //
     /* 105297 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 105300 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 105307 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 105310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105314 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105318 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 105325 */   // (atomic_load:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15502>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset)
     /* 105325 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 105328 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105330 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105335 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105340 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 105345 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105349 */   GIR_RootConstrainSelectedInstOperands,
     /* 105350 */   // GIR_Coverage, 6939,
     /* 105350 */   GIR_EraseRootFromParent_Done,
     /* 105351 */ // Label 2022: @105351
     /* 105351 */ GIM_Try, /*On fail goto*//*Label 2023*/ GIMT_Encode4(105410), // Rule ID 6949 //
     /* 105356 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 105359 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 105366 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 105369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105373 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105377 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 105384 */   // (atomic_load:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15511>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 105384 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 105387 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105389 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105394 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105399 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105404 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105408 */   GIR_RootConstrainSelectedInstOperands,
     /* 105409 */   // GIR_Coverage, 6949,
     /* 105409 */   GIR_EraseRootFromParent_Done,
     /* 105410 */ // Label 2023: @105410
     /* 105410 */ GIM_Try, /*On fail goto*//*Label 2024*/ GIMT_Encode4(105469), // Rule ID 6951 //
     /* 105415 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 105418 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 105425 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 105428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105432 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105436 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 105443 */   // (atomic_load:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15511>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 105443 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 105446 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105448 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105453 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105458 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105463 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105467 */   GIR_RootConstrainSelectedInstOperands,
     /* 105468 */   // GIR_Coverage, 6951,
     /* 105468 */   GIR_EraseRootFromParent_Done,
     /* 105469 */ // Label 2024: @105469
     /* 105469 */ GIM_Try, /*On fail goto*//*Label 2025*/ GIMT_Encode4(105520), // Rule ID 287 //
     /* 105474 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105477 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 105484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105488 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105492 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 105499 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 105499 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 105502 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105504 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105509 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105514 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105518 */   GIR_RootConstrainSelectedInstOperands,
     /* 105519 */   // GIR_Coverage, 287,
     /* 105519 */   GIR_EraseRootFromParent_Done,
     /* 105520 */ // Label 2025: @105520
     /* 105520 */ GIM_Try, /*On fail goto*//*Label 2026*/ GIMT_Encode4(105571), // Rule ID 288 //
     /* 105525 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105528 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 105535 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105539 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105543 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 105550 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 105550 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 105553 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105555 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105560 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105565 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105569 */   GIR_RootConstrainSelectedInstOperands,
     /* 105570 */   // GIR_Coverage, 288,
     /* 105570 */   GIR_EraseRootFromParent_Done,
     /* 105571 */ // Label 2026: @105571
     /* 105571 */ GIM_Try, /*On fail goto*//*Label 2027*/ GIMT_Encode4(105622), // Rule ID 4087 //
     /* 105576 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105579 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 105586 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105590 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105594 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 105601 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 105601 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 105604 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105606 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105611 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105616 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105620 */   GIR_RootConstrainSelectedInstOperands,
     /* 105621 */   // GIR_Coverage, 4087,
     /* 105621 */   GIR_EraseRootFromParent_Done,
     /* 105622 */ // Label 2027: @105622
     /* 105622 */ GIM_Try, /*On fail goto*//*Label 2028*/ GIMT_Encode4(105673), // Rule ID 4119 //
     /* 105627 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105630 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 105637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105641 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105645 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 105652 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105652 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 105655 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105657 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105662 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105667 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105671 */   GIR_RootConstrainSelectedInstOperands,
     /* 105672 */   // GIR_Coverage, 4119,
     /* 105672 */   GIR_EraseRootFromParent_Done,
     /* 105673 */ // Label 2028: @105673
     /* 105673 */ GIM_Try, /*On fail goto*//*Label 2029*/ GIMT_Encode4(105724), // Rule ID 4120 //
     /* 105678 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105681 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 105688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105692 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105696 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 105703 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105703 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 105706 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105708 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105713 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105718 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105722 */   GIR_RootConstrainSelectedInstOperands,
     /* 105723 */   // GIR_Coverage, 4120,
     /* 105723 */   GIR_EraseRootFromParent_Done,
     /* 105724 */ // Label 2029: @105724
     /* 105724 */ GIM_Try, /*On fail goto*//*Label 2030*/ GIMT_Encode4(105775), // Rule ID 4121 //
     /* 105729 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105732 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 105739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105743 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105747 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 105754 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105754 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 105757 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105759 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105764 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105769 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105773 */   GIR_RootConstrainSelectedInstOperands,
     /* 105774 */   // GIR_Coverage, 4121,
     /* 105774 */   GIR_EraseRootFromParent_Done,
     /* 105775 */ // Label 2030: @105775
     /* 105775 */ GIM_Try, /*On fail goto*//*Label 2031*/ GIMT_Encode4(105829), // Rule ID 6941 //
     /* 105780 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 105783 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 105790 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 105793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105797 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105801 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 105808 */   // (atomic_load:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15502>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 105808 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 105811 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105813 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105818 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105823 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105827 */   GIR_RootConstrainSelectedInstOperands,
     /* 105828 */   // GIR_Coverage, 6941,
     /* 105828 */   GIR_EraseRootFromParent_Done,
     /* 105829 */ // Label 2031: @105829
     /* 105829 */ GIM_Try, /*On fail goto*//*Label 2032*/ GIMT_Encode4(105883), // Rule ID 6943 //
     /* 105834 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 105837 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 105844 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 105847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105851 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105855 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 105862 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15502>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105862 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 105865 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105867 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105872 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105877 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105881 */   GIR_RootConstrainSelectedInstOperands,
     /* 105882 */   // GIR_Coverage, 6943,
     /* 105882 */   GIR_EraseRootFromParent_Done,
     /* 105883 */ // Label 2032: @105883
     /* 105883 */ GIM_Try, /*On fail goto*//*Label 2033*/ GIMT_Encode4(105937), // Rule ID 6953 //
     /* 105888 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 105891 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 105898 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 105901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105905 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105909 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 105916 */   // (atomic_load:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15511>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 105916 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 105919 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105921 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105926 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105931 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105935 */   GIR_RootConstrainSelectedInstOperands,
     /* 105936 */   // GIR_Coverage, 6953,
     /* 105936 */   GIR_EraseRootFromParent_Done,
     /* 105937 */ // Label 2033: @105937
     /* 105937 */ GIM_Try, /*On fail goto*//*Label 2034*/ GIMT_Encode4(105991), // Rule ID 6955 //
     /* 105942 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 105945 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 105952 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 105955 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105959 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105963 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 105970 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15511>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105970 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 105973 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105975 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105980 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105985 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105989 */   GIR_RootConstrainSelectedInstOperands,
     /* 105990 */   // GIR_Coverage, 6955,
     /* 105990 */   GIR_EraseRootFromParent_Done,
     /* 105991 */ // Label 2034: @105991
     /* 105991 */ GIM_Try, /*On fail goto*//*Label 2035*/ GIMT_Encode4(106048), // Rule ID 7277 //
     /* 105996 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 105999 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 106002 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 106009 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 106012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106016 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106020 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 106027 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15500>>  =>  (LDAPURBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 106027 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURBi),
     /* 106030 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106032 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106037 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106042 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106046 */   GIR_RootConstrainSelectedInstOperands,
     /* 106047 */   // GIR_Coverage, 7277,
     /* 106047 */   GIR_EraseRootFromParent_Done,
     /* 106048 */ // Label 2035: @106048
     /* 106048 */ GIM_Try, /*On fail goto*//*Label 2036*/ GIMT_Encode4(106105), // Rule ID 7279 //
     /* 106053 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 106056 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 106059 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 106066 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 106069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106073 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106077 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 106084 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15509>>  =>  (LDAPURHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 106084 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURHi),
     /* 106087 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106089 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106094 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106099 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106103 */   GIR_RootConstrainSelectedInstOperands,
     /* 106104 */   // GIR_Coverage, 7279,
     /* 106104 */   GIR_EraseRootFromParent_Done,
     /* 106105 */ // Label 2036: @106105
     /* 106105 */ GIM_Try, /*On fail goto*//*Label 2037*/ GIMT_Encode4(106142), // Rule ID 6933 //
     /* 106110 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 106113 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 106120 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 106123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106127 */   // MIs[0] ptr
     /* 106127 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 106131 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 106135 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15498>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 106135 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 106140 */   GIR_RootConstrainSelectedInstOperands,
     /* 106141 */   // GIR_Coverage, 6933,
     /* 106141 */   GIR_Done,
     /* 106142 */ // Label 2037: @106142
     /* 106142 */ GIM_Try, /*On fail goto*//*Label 2038*/ GIMT_Encode4(106179), // Rule ID 6935 //
     /* 106147 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 106150 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 106157 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 106160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106164 */   // MIs[0] ptr
     /* 106164 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 106168 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 106172 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15500>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 106172 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 106177 */   GIR_RootConstrainSelectedInstOperands,
     /* 106178 */   // GIR_Coverage, 6935,
     /* 106178 */   GIR_Done,
     /* 106179 */ // Label 2038: @106179
     /* 106179 */ GIM_Try, /*On fail goto*//*Label 2039*/ GIMT_Encode4(106216), // Rule ID 6945 //
     /* 106184 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 106187 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 106194 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 106197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106201 */   // MIs[0] ptr
     /* 106201 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 106205 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 106209 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15507>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 106209 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 106214 */   GIR_RootConstrainSelectedInstOperands,
     /* 106215 */   // GIR_Coverage, 6945,
     /* 106215 */   GIR_Done,
     /* 106216 */ // Label 2039: @106216
     /* 106216 */ GIM_Try, /*On fail goto*//*Label 2040*/ GIMT_Encode4(106253), // Rule ID 6947 //
     /* 106221 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 106224 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 106231 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 106234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106238 */   // MIs[0] ptr
     /* 106238 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 106242 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 106246 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15509>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 106246 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 106251 */   GIR_RootConstrainSelectedInstOperands,
     /* 106252 */   // GIR_Coverage, 6947,
     /* 106252 */   GIR_Done,
     /* 106253 */ // Label 2040: @106253
     /* 106253 */ GIM_Reject,
     /* 106254 */ // Label 2011: @106254
     /* 106254 */ GIM_Try, /*On fail goto*//*Label 2041*/ GIMT_Encode4(107743),
     /* 106259 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 106262 */   GIM_Try, /*On fail goto*//*Label 2042*/ GIMT_Encode4(106347), // Rule ID 4046 //
     /* 106267 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 106274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 106278 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 106289 */     // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 106289 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 106292 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 106296 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106316 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106320 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 106325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106330 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 106336 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 106341 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106346 */     // GIR_Coverage, 4046,
     /* 106346 */     GIR_EraseRootFromParent_Done,
     /* 106347 */   // Label 2042: @106347
     /* 106347 */   GIM_Try, /*On fail goto*//*Label 2043*/ GIMT_Encode4(106432), // Rule ID 4047 //
     /* 106352 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 106359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 106363 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 106374 */     // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 106374 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 106377 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 106381 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106401 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106405 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 106410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106415 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 106421 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 106426 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106431 */     // GIR_Coverage, 4047,
     /* 106431 */     GIR_EraseRootFromParent_Done,
     /* 106432 */   // Label 2043: @106432
     /* 106432 */   GIM_Try, /*On fail goto*//*Label 2044*/ GIMT_Encode4(106517), // Rule ID 4048 //
     /* 106437 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 106444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 106448 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 106459 */     // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 106459 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 106462 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 106466 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106486 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106490 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 106495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106500 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 106506 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 106511 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106516 */     // GIR_Coverage, 4048,
     /* 106516 */     GIR_EraseRootFromParent_Done,
     /* 106517 */   // Label 2044: @106517
     /* 106517 */   GIM_Try, /*On fail goto*//*Label 2045*/ GIMT_Encode4(106602), // Rule ID 4049 //
     /* 106522 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 106529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 106533 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 106544 */     // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 106544 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 106547 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 106551 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106571 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106575 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 106580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106585 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 106591 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 106596 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106601 */     // GIR_Coverage, 4049,
     /* 106601 */     GIR_EraseRootFromParent_Done,
     /* 106602 */   // Label 2045: @106602
     /* 106602 */   GIM_Try, /*On fail goto*//*Label 2046*/ GIMT_Encode4(106687), // Rule ID 4050 //
     /* 106607 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 106614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 106618 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 106629 */     // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 106629 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 106632 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 106636 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106656 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106660 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 106665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106670 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 106676 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 106681 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106686 */     // GIR_Coverage, 4050,
     /* 106686 */     GIR_EraseRootFromParent_Done,
     /* 106687 */   // Label 2046: @106687
     /* 106687 */   GIM_Try, /*On fail goto*//*Label 2047*/ GIMT_Encode4(106772), // Rule ID 4051 //
     /* 106692 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 106699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 106703 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 106714 */     // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 106714 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 106717 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 106721 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106741 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106745 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 106750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106755 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 106761 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 106766 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106771 */     // GIR_Coverage, 4051,
     /* 106771 */     GIR_EraseRootFromParent_Done,
     /* 106772 */   // Label 2047: @106772
     /* 106772 */   GIM_Try, /*On fail goto*//*Label 2048*/ GIMT_Encode4(106857), // Rule ID 4052 //
     /* 106777 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 106784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 106788 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 106799 */     // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 106799 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 106802 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 106806 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106826 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106830 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 106835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106840 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 106846 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 106851 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106856 */     // GIR_Coverage, 4052,
     /* 106856 */     GIR_EraseRootFromParent_Done,
     /* 106857 */   // Label 2048: @106857
     /* 106857 */   GIM_Try, /*On fail goto*//*Label 2049*/ GIMT_Encode4(106942), // Rule ID 4053 //
     /* 106862 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 106869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 106873 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 106884 */     // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 106884 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 106887 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 106891 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106911 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106915 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 106920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106925 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 106931 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 106936 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106941 */     // GIR_Coverage, 4053,
     /* 106941 */     GIR_EraseRootFromParent_Done,
     /* 106942 */   // Label 2049: @106942
     /* 106942 */   GIM_Try, /*On fail goto*//*Label 2050*/ GIMT_Encode4(107022), // Rule ID 4085 //
     /* 106947 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 106954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 106958 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 106969 */     // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 106969 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 106972 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 106976 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106991 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106995 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 107000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107005 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 107011 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107016 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107021 */     // GIR_Coverage, 4085,
     /* 107021 */     GIR_EraseRootFromParent_Done,
     /* 107022 */   // Label 2050: @107022
     /* 107022 */   GIM_Try, /*On fail goto*//*Label 2051*/ GIMT_Encode4(107102), // Rule ID 4086 //
     /* 107027 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 107034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107038 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 107049 */     // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 107049 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 107052 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 107056 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107071 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107075 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 107080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107085 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 107091 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107096 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107101 */     // GIR_Coverage, 4086,
     /* 107101 */     GIR_EraseRootFromParent_Done,
     /* 107102 */   // Label 2051: @107102
     /* 107102 */   GIM_Try, /*On fail goto*//*Label 2052*/ GIMT_Encode4(107182), // Rule ID 4088 //
     /* 107107 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 107114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107118 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 107129 */     // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 107129 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 107132 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 107136 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107151 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107155 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 107160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107165 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 107171 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107176 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107181 */     // GIR_Coverage, 4088,
     /* 107181 */     GIR_EraseRootFromParent_Done,
     /* 107182 */   // Label 2052: @107182
     /* 107182 */   GIM_Try, /*On fail goto*//*Label 2053*/ GIMT_Encode4(107262), // Rule ID 4096 //
     /* 107187 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 107194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107198 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 107209 */     // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 107209 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 107212 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /* 107216 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107231 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107235 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 107240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107245 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 107251 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107256 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107261 */     // GIR_Coverage, 4096,
     /* 107261 */     GIR_EraseRootFromParent_Done,
     /* 107262 */   // Label 2053: @107262
     /* 107262 */   GIM_Try, /*On fail goto*//*Label 2054*/ GIMT_Encode4(107342), // Rule ID 4122 //
     /* 107267 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 107274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107278 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 107289 */     // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 107289 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 107292 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 107296 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107311 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107315 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 107320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107325 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 107331 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107336 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107341 */     // GIR_Coverage, 4122,
     /* 107341 */     GIR_EraseRootFromParent_Done,
     /* 107342 */   // Label 2054: @107342
     /* 107342 */   GIM_Try, /*On fail goto*//*Label 2055*/ GIMT_Encode4(107422), // Rule ID 4123 //
     /* 107347 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 107354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107358 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 107369 */     // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 107369 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 107372 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 107376 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107391 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 107400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107405 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 107411 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107416 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107421 */     // GIR_Coverage, 4123,
     /* 107421 */     GIR_EraseRootFromParent_Done,
     /* 107422 */   // Label 2055: @107422
     /* 107422 */   GIM_Try, /*On fail goto*//*Label 2056*/ GIMT_Encode4(107502), // Rule ID 4124 //
     /* 107427 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 107434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107438 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 107449 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 107449 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 107452 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 107456 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107471 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107475 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 107480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107485 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 107491 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107496 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107501 */     // GIR_Coverage, 4124,
     /* 107501 */     GIR_EraseRootFromParent_Done,
     /* 107502 */   // Label 2056: @107502
     /* 107502 */   GIM_Try, /*On fail goto*//*Label 2057*/ GIMT_Encode4(107582), // Rule ID 4125 //
     /* 107507 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 107514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107518 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 107529 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 107529 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 107532 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 107536 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107551 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107555 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 107560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107565 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 107571 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107576 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107581 */     // GIR_Coverage, 4125,
     /* 107581 */     GIR_EraseRootFromParent_Done,
     /* 107582 */   // Label 2057: @107582
     /* 107582 */   GIM_Try, /*On fail goto*//*Label 2058*/ GIMT_Encode4(107662), // Rule ID 4126 //
     /* 107587 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 107594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107598 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 107609 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 107609 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 107612 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 107616 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107631 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107635 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 107640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107645 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 107651 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107656 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107661 */     // GIR_Coverage, 4126,
     /* 107661 */     GIR_EraseRootFromParent_Done,
     /* 107662 */   // Label 2058: @107662
     /* 107662 */   GIM_Try, /*On fail goto*//*Label 2059*/ GIMT_Encode4(107742), // Rule ID 4127 //
     /* 107667 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 107674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107678 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 107689 */     // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 107689 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 107692 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 107696 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107711 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107715 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 107720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107725 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 107731 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 107736 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107741 */     // GIR_Coverage, 4127,
     /* 107741 */     GIR_EraseRootFromParent_Done,
     /* 107742 */   // Label 2059: @107742
     /* 107742 */   GIM_Reject,
     /* 107743 */ // Label 2041: @107743
     /* 107743 */ GIM_Reject,
     /* 107744 */ // Label 2012: @107744
     /* 107744 */ GIM_Reject,
     /* 107745 */ // Label 19: @107745
     /* 107745 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(24), /*)*//*default:*//*Label 2080*/ GIMT_Encode4(121056),
     /* 107756 */ /*GILLT_s8*//*Label 2060*/ GIMT_Encode4(107852),
     /* 107760 */ /*GILLT_s16*//*Label 2061*/ GIMT_Encode4(108219),
     /* 107764 */ /*GILLT_s32*//*Label 2062*/ GIMT_Encode4(109358),
     /* 107768 */ /*GILLT_s64*//*Label 2063*/ GIMT_Encode4(113953),
     /* 107772 */ /*GILLT_s128*//*Label 2064*/ GIMT_Encode4(117722),
     /* 107776 */ /*GILLT_v2s32*//*Label 2065*/ GIMT_Encode4(117928),
     /* 107780 */ /*GILLT_v2s64*//*Label 2066*/ GIMT_Encode4(118334),
     /* 107784 */ /*GILLT_v4s16*//*Label 2067*/ GIMT_Encode4(118784),
     /* 107788 */ /*GILLT_v4s32*//*Label 2068*/ GIMT_Encode4(119190),
     /* 107792 */ /*GILLT_v8s8*//*Label 2069*/ GIMT_Encode4(119596),
     /* 107796 */ /*GILLT_v8s16*//*Label 2070*/ GIMT_Encode4(119816),
     /* 107800 */ /*GILLT_v16s8*//*Label 2071*/ GIMT_Encode4(120222), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 107812 */ /*GILLT_nxv2s16*//*Label 2072*/ GIMT_Encode4(120442),
     /* 107816 */ /*GILLT_nxv2s32*//*Label 2073*/ GIMT_Encode4(120502),
     /* 107820 */ /*GILLT_nxv2s64*//*Label 2074*/ GIMT_Encode4(120562), GIMT_Encode4(0),
     /* 107828 */ /*GILLT_nxv4s16*//*Label 2075*/ GIMT_Encode4(120672),
     /* 107832 */ /*GILLT_nxv4s32*//*Label 2076*/ GIMT_Encode4(120732), GIMT_Encode4(0),
     /* 107840 */ /*GILLT_nxv8s16*//*Label 2077*/ GIMT_Encode4(120842),
     /* 107844 */ /*GILLT_nxv16s1*//*Label 2078*/ GIMT_Encode4(120952),
     /* 107848 */ /*GILLT_nxv16s8*//*Label 2079*/ GIMT_Encode4(120996),
     /* 107852 */ // Label 2060: @107852
     /* 107852 */ GIM_Try, /*On fail goto*//*Label 2081*/ GIMT_Encode4(108218),
     /* 107857 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 107860 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107864 */   GIM_Try, /*On fail goto*//*Label 2082*/ GIMT_Encode4(107932), // Rule ID 12905 //
     /* 107869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 107873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 107877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 107881 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 107885 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107890 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 107894 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 107898 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 107902 */     // MIs[2] Operand 1
     /* 107902 */     // No operand predicates
     /* 107902 */     // MIs[0] Rn
     /* 107902 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 107906 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 107910 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 107912 */     // (st (vector_extract:{ *:[i8] } VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i8 VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 107912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 107915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 107919 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 107922 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 107924 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 107930 */     GIR_RootConstrainSelectedInstOperands,
     /* 107931 */     // GIR_Coverage, 12905,
     /* 107931 */     GIR_EraseRootFromParent_Done,
     /* 107932 */   // Label 2082: @107932
     /* 107932 */   GIM_Try, /*On fail goto*//*Label 2083*/ GIMT_Encode4(108031), // Rule ID 12906 //
     /* 107937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 107941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 107945 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 107949 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 107953 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107958 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 107962 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 107966 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 107970 */     // MIs[2] Operand 1
     /* 107970 */     // No operand predicates
     /* 107970 */     // MIs[0] Rn
     /* 107970 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 107974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 107978 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 107980 */     // (st (vector_extract:{ *:[i8] } VecListOne64:{ *:[v8i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i8 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 107980 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 107983 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 107987 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107992 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 107995 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 107999 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 108002 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108007 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 108015 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108018 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 108021 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 108023 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 108029 */     GIR_RootConstrainSelectedInstOperands,
     /* 108030 */     // GIR_Coverage, 12906,
     /* 108030 */     GIR_EraseRootFromParent_Done,
     /* 108031 */   // Label 2083: @108031
     /* 108031 */   GIM_Try, /*On fail goto*//*Label 2084*/ GIMT_Encode4(108080), // Rule ID 303 //
     /* 108036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 108039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 108043 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 108054 */     // (st FPR8Op:{ *:[i8] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBroW FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 108054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBroW),
     /* 108057 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 108059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108074 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108078 */     GIR_RootConstrainSelectedInstOperands,
     /* 108079 */     // GIR_Coverage, 303,
     /* 108079 */     GIR_EraseRootFromParent_Done,
     /* 108080 */   // Label 2084: @108080
     /* 108080 */   GIM_Try, /*On fail goto*//*Label 2085*/ GIMT_Encode4(108129), // Rule ID 304 //
     /* 108085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 108088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 108092 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 108103 */     // (st FPR8Op:{ *:[i8] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBroX FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 108103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBroX),
     /* 108106 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 108108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108123 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108127 */     GIR_RootConstrainSelectedInstOperands,
     /* 108128 */     // GIR_Coverage, 304,
     /* 108128 */     GIR_EraseRootFromParent_Done,
     /* 108129 */   // Label 2085: @108129
     /* 108129 */   GIM_Try, /*On fail goto*//*Label 2086*/ GIMT_Encode4(108173), // Rule ID 313 //
     /* 108134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 108137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 108141 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 108152 */     // (st FPR8Op:{ *:[i8] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBui FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 108152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBui),
     /* 108155 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 108157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108167 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108171 */     GIR_RootConstrainSelectedInstOperands,
     /* 108172 */     // GIR_Coverage, 313,
     /* 108172 */     GIR_EraseRootFromParent_Done,
     /* 108173 */   // Label 2086: @108173
     /* 108173 */   GIM_Try, /*On fail goto*//*Label 2087*/ GIMT_Encode4(108217), // Rule ID 321 //
     /* 108178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 108181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 108185 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 108196 */     // (st FPR8Op:{ *:[i8] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURBi FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 108196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBi),
     /* 108199 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 108201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108211 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108215 */     GIR_RootConstrainSelectedInstOperands,
     /* 108216 */     // GIR_Coverage, 321,
     /* 108216 */     GIR_EraseRootFromParent_Done,
     /* 108217 */   // Label 2087: @108217
     /* 108217 */   GIM_Reject,
     /* 108218 */ // Label 2081: @108218
     /* 108218 */ GIM_Reject,
     /* 108219 */ // Label 2061: @108219
     /* 108219 */ GIM_Try, /*On fail goto*//*Label 2088*/ GIMT_Encode4(109357),
     /* 108224 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 108227 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108231 */   GIM_Try, /*On fail goto*//*Label 2089*/ GIMT_Encode4(108330), // Rule ID 4424 //
     /* 108236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 108240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 108244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 108248 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 108252 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108257 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 108261 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 108274 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 108274 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 108277 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108281 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108286 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 108292 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 108297 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 108305 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108323 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 108328 */     GIR_RootConstrainSelectedInstOperands,
     /* 108329 */     // GIR_Coverage, 4424,
     /* 108329 */     GIR_EraseRootFromParent_Done,
     /* 108330 */   // Label 2089: @108330
     /* 108330 */   GIM_Try, /*On fail goto*//*Label 2090*/ GIMT_Encode4(108429), // Rule ID 4425 //
     /* 108335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 108339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 108343 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 108347 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 108351 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108356 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 108360 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108364 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 108373 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 108373 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 108376 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108380 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108385 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 108391 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 108396 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 108404 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108422 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 108427 */     GIR_RootConstrainSelectedInstOperands,
     /* 108428 */     // GIR_Coverage, 4425,
     /* 108428 */     GIR_EraseRootFromParent_Done,
     /* 108429 */   // Label 2090: @108429
     /* 108429 */   GIM_Try, /*On fail goto*//*Label 2091*/ GIMT_Encode4(108528), // Rule ID 12903 //
     /* 108434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 108438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 108442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108446 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 108450 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108455 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 108459 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 108472 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 108472 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 108475 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108479 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108484 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 108490 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 108495 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 108503 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108521 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 108526 */     GIR_RootConstrainSelectedInstOperands,
     /* 108527 */     // GIR_Coverage, 12903,
     /* 108527 */     GIR_EraseRootFromParent_Done,
     /* 108528 */   // Label 2091: @108528
     /* 108528 */   GIM_Try, /*On fail goto*//*Label 2092*/ GIMT_Encode4(108627), // Rule ID 12904 //
     /* 108533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 108537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 108541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108545 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 108549 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108554 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 108558 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108562 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 108571 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 108571 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 108574 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108578 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108583 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 108589 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 108594 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 108602 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108620 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 108625 */     GIR_RootConstrainSelectedInstOperands,
     /* 108626 */     // GIR_Coverage, 12904,
     /* 108626 */     GIR_EraseRootFromParent_Done,
     /* 108627 */   // Label 2092: @108627
     /* 108627 */   GIM_Try, /*On fail goto*//*Label 2093*/ GIMT_Encode4(108721), // Rule ID 4453 //
     /* 108632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 108636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 108640 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 108644 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 108648 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108653 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 108657 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 108670 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 108670 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 108673 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108677 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108682 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 108688 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 108693 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 108701 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108714 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 108719 */     GIR_RootConstrainSelectedInstOperands,
     /* 108720 */     // GIR_Coverage, 4453,
     /* 108720 */     GIR_EraseRootFromParent_Done,
     /* 108721 */   // Label 2093: @108721
     /* 108721 */   GIM_Try, /*On fail goto*//*Label 2094*/ GIMT_Encode4(108815), // Rule ID 4478 //
     /* 108726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 108730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 108734 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 108738 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 108742 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108747 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 108751 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 108764 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 108764 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 108767 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108771 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108776 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 108782 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 108787 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 108795 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108808 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 108813 */     GIR_RootConstrainSelectedInstOperands,
     /* 108814 */     // GIR_Coverage, 4478,
     /* 108814 */     GIR_EraseRootFromParent_Done,
     /* 108815 */   // Label 2094: @108815
     /* 108815 */   GIM_Try, /*On fail goto*//*Label 2095*/ GIMT_Encode4(108909), // Rule ID 12902 //
     /* 108820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 108824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 108828 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108832 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 108836 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108841 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 108845 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 108858 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 108858 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 108861 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108865 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108870 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 108876 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 108881 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 108889 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108902 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 108907 */     GIR_RootConstrainSelectedInstOperands,
     /* 108908 */     // GIR_Coverage, 12902,
     /* 108908 */     GIR_EraseRootFromParent_Done,
     /* 108909 */   // Label 2095: @108909
     /* 108909 */   GIM_Try, /*On fail goto*//*Label 2096*/ GIMT_Encode4(109003), // Rule ID 12908 //
     /* 108914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 108918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 108922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108926 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 108930 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108935 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 108939 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108943 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 108952 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 108952 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 108955 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108959 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108964 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 108970 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 108975 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 108983 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108996 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 109001 */     GIR_RootConstrainSelectedInstOperands,
     /* 109002 */     // GIR_Coverage, 12908,
     /* 109002 */     GIR_EraseRootFromParent_Done,
     /* 109003 */   // Label 2096: @109003
     /* 109003 */   GIM_Try, /*On fail goto*//*Label 2097*/ GIMT_Encode4(109071), // Rule ID 6371 //
     /* 109008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 109012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 109016 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109020 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 109024 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109029 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 109033 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 109037 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 109041 */     // MIs[2] Operand 1
     /* 109041 */     // No operand predicates
     /* 109041 */     // MIs[0] Rn
     /* 109041 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 109045 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 109049 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 109051 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i16 VecListOne128:{ *:[v8f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 109051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 109054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 109058 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 109061 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 109063 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 109069 */     GIR_RootConstrainSelectedInstOperands,
     /* 109070 */     // GIR_Coverage, 6371,
     /* 109070 */     GIR_EraseRootFromParent_Done,
     /* 109071 */   // Label 2097: @109071
     /* 109071 */   GIM_Try, /*On fail goto*//*Label 2098*/ GIMT_Encode4(109170), // Rule ID 6376 //
     /* 109076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 109080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 109084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 109088 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 109092 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 109101 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 109105 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 109109 */     // MIs[2] Operand 1
     /* 109109 */     // No operand predicates
     /* 109109 */     // MIs[0] Rn
     /* 109109 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 109113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 109117 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 109119 */     // (st (vector_extract:{ *:[f16] } VecListOne64:{ *:[v4f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i16 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4f16] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 109119 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 109122 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 109126 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109131 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 109134 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 109138 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 109141 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109146 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 109154 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109157 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 109160 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 109162 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 109168 */     GIR_RootConstrainSelectedInstOperands,
     /* 109169 */     // GIR_Coverage, 6376,
     /* 109169 */     GIR_EraseRootFromParent_Done,
     /* 109170 */   // Label 2098: @109170
     /* 109170 */   GIM_Try, /*On fail goto*//*Label 2099*/ GIMT_Encode4(109219), // Rule ID 305 //
     /* 109175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 109178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 109182 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 109193 */     // (st FPR16Op:{ *:[f16] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 109193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 109196 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 109198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109213 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109217 */     GIR_RootConstrainSelectedInstOperands,
     /* 109218 */     // GIR_Coverage, 305,
     /* 109218 */     GIR_EraseRootFromParent_Done,
     /* 109219 */   // Label 2099: @109219
     /* 109219 */   GIM_Try, /*On fail goto*//*Label 2100*/ GIMT_Encode4(109268), // Rule ID 306 //
     /* 109224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 109227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 109231 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 109242 */     // (st FPR16Op:{ *:[f16] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 109242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 109245 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 109247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109262 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109266 */     GIR_RootConstrainSelectedInstOperands,
     /* 109267 */     // GIR_Coverage, 306,
     /* 109267 */     GIR_EraseRootFromParent_Done,
     /* 109268 */   // Label 2100: @109268
     /* 109268 */   GIM_Try, /*On fail goto*//*Label 2101*/ GIMT_Encode4(109312), // Rule ID 314 //
     /* 109273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 109276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 109280 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 109291 */     // (st FPR16Op:{ *:[f16] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 109291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 109294 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 109296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109306 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109310 */     GIR_RootConstrainSelectedInstOperands,
     /* 109311 */     // GIR_Coverage, 314,
     /* 109311 */     GIR_EraseRootFromParent_Done,
     /* 109312 */   // Label 2101: @109312
     /* 109312 */   GIM_Try, /*On fail goto*//*Label 2102*/ GIMT_Encode4(109356), // Rule ID 322 //
     /* 109317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 109320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 109324 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 109335 */     // (st FPR16Op:{ *:[f16] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 109335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 109338 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 109340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109350 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109354 */     GIR_RootConstrainSelectedInstOperands,
     /* 109355 */     // GIR_Coverage, 322,
     /* 109355 */     GIR_EraseRootFromParent_Done,
     /* 109356 */   // Label 2102: @109356
     /* 109356 */   GIM_Reject,
     /* 109357 */ // Label 2088: @109357
     /* 109357 */ GIM_Reject,
     /* 109358 */ // Label 2062: @109358
     /* 109358 */ GIM_Try, /*On fail goto*//*Label 2103*/ GIMT_Encode4(109471), // Rule ID 4422 //
     /* 109363 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109366 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 109370 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 109377 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 109381 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 109385 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109389 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 109393 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109398 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 109402 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109406 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109408 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 109415 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 109415 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 109418 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109422 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109427 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 109433 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 109438 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109443 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 109446 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109449 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109454 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109459 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109464 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 109469 */   GIR_RootConstrainSelectedInstOperands,
     /* 109470 */   // GIR_Coverage, 4422,
     /* 109470 */   GIR_EraseRootFromParent_Done,
     /* 109471 */ // Label 2103: @109471
     /* 109471 */ GIM_Try, /*On fail goto*//*Label 2104*/ GIMT_Encode4(109584), // Rule ID 4423 //
     /* 109476 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109479 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 109483 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 109490 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 109494 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 109498 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109502 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 109506 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109511 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 109515 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109519 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109521 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 109528 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 109528 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 109531 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109535 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109540 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 109546 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 109551 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109556 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 109559 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109562 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109567 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109572 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109577 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 109582 */   GIR_RootConstrainSelectedInstOperands,
     /* 109583 */   // GIR_Coverage, 4423,
     /* 109583 */   GIR_EraseRootFromParent_Done,
     /* 109584 */ // Label 2104: @109584
     /* 109584 */ GIM_Try, /*On fail goto*//*Label 2105*/ GIMT_Encode4(109690), // Rule ID 4426 //
     /* 109589 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109592 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 109596 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 109600 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 109604 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 109608 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 109612 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109617 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 109621 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109625 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109627 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 109634 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 109634 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 109637 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109641 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109646 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 109652 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 109657 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109662 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 109665 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109668 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109673 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109678 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109683 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 109688 */   GIR_RootConstrainSelectedInstOperands,
     /* 109689 */   // GIR_Coverage, 4426,
     /* 109689 */   GIR_EraseRootFromParent_Done,
     /* 109690 */ // Label 2105: @109690
     /* 109690 */ GIM_Try, /*On fail goto*//*Label 2106*/ GIMT_Encode4(109796), // Rule ID 4427 //
     /* 109695 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109698 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 109702 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 109706 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 109710 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 109714 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 109718 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109723 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 109727 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109731 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109733 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 109740 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 109740 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 109743 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109747 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109752 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 109758 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 109763 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109768 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 109771 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109774 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109779 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109784 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109789 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 109794 */   GIR_RootConstrainSelectedInstOperands,
     /* 109795 */   // GIR_Coverage, 4427,
     /* 109795 */   GIR_EraseRootFromParent_Done,
     /* 109796 */ // Label 2106: @109796
     /* 109796 */ GIM_Try, /*On fail goto*//*Label 2107*/ GIMT_Encode4(109902), // Rule ID 4428 //
     /* 109801 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109804 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 109808 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 109812 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 109816 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 109820 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 109824 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109829 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 109833 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109837 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109839 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 109846 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 109846 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 109849 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109853 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109858 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 109864 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 109869 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109874 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 109877 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109880 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109885 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109890 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109895 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 109900 */   GIR_RootConstrainSelectedInstOperands,
     /* 109901 */   // GIR_Coverage, 4428,
     /* 109901 */   GIR_EraseRootFromParent_Done,
     /* 109902 */ // Label 2107: @109902
     /* 109902 */ GIM_Try, /*On fail goto*//*Label 2108*/ GIMT_Encode4(110008), // Rule ID 4429 //
     /* 109907 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109910 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 109914 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 109918 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 109922 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 109926 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 109930 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109935 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 109939 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109943 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109945 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 109952 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 109952 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 109955 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109959 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109964 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 109970 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 109975 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109980 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 109983 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109986 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109991 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109996 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 110001 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 110006 */   GIR_RootConstrainSelectedInstOperands,
     /* 110007 */   // GIR_Coverage, 4429,
     /* 110007 */   GIR_EraseRootFromParent_Done,
     /* 110008 */ // Label 2108: @110008
     /* 110008 */ GIM_Try, /*On fail goto*//*Label 2109*/ GIMT_Encode4(110114), // Rule ID 12910 //
     /* 110013 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110016 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 110020 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 110024 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 110028 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 110032 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 110036 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110041 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 110045 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110049 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110051 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 110058 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 110058 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110061 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110065 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110070 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 110076 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 110081 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110086 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 110089 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110092 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110097 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 110102 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 110107 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 110112 */   GIR_RootConstrainSelectedInstOperands,
     /* 110113 */   // GIR_Coverage, 12910,
     /* 110113 */   GIR_EraseRootFromParent_Done,
     /* 110114 */ // Label 2109: @110114
     /* 110114 */ GIM_Try, /*On fail goto*//*Label 2110*/ GIMT_Encode4(110220), // Rule ID 12911 //
     /* 110119 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110122 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 110126 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 110130 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 110134 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 110138 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 110142 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110147 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 110151 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110155 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110157 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 110164 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 110164 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110167 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110171 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110176 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 110182 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 110187 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110192 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 110195 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110198 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110203 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 110208 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 110213 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 110218 */   GIR_RootConstrainSelectedInstOperands,
     /* 110219 */   // GIR_Coverage, 12911,
     /* 110219 */   GIR_EraseRootFromParent_Done,
     /* 110220 */ // Label 2110: @110220
     /* 110220 */ GIM_Try, /*On fail goto*//*Label 2111*/ GIMT_Encode4(110328), // Rule ID 4452 //
     /* 110225 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110228 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 110232 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 110239 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 110243 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 110247 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 110251 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 110255 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110260 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 110264 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110268 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110270 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 110277 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 110277 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 110280 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110284 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110289 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 110295 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 110300 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110305 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 110308 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110311 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110316 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110321 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 110326 */   GIR_RootConstrainSelectedInstOperands,
     /* 110327 */   // GIR_Coverage, 4452,
     /* 110327 */   GIR_EraseRootFromParent_Done,
     /* 110328 */ // Label 2111: @110328
     /* 110328 */ GIM_Try, /*On fail goto*//*Label 2112*/ GIMT_Encode4(110429), // Rule ID 4454 //
     /* 110333 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110336 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 110340 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 110344 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 110348 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 110352 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 110356 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110361 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 110365 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110369 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110371 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 110378 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 110378 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110381 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110385 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110390 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 110396 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 110401 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110406 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 110409 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110412 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110417 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110422 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 110427 */   GIR_RootConstrainSelectedInstOperands,
     /* 110428 */   // GIR_Coverage, 4454,
     /* 110428 */   GIR_EraseRootFromParent_Done,
     /* 110429 */ // Label 2112: @110429
     /* 110429 */ GIM_Try, /*On fail goto*//*Label 2113*/ GIMT_Encode4(110530), // Rule ID 4455 //
     /* 110434 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110437 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 110441 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 110445 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 110449 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 110453 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 110457 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110462 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 110466 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110470 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110472 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 110479 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 110479 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110482 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110486 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110491 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 110497 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 110502 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110507 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 110510 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110513 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110518 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110523 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 110528 */   GIR_RootConstrainSelectedInstOperands,
     /* 110529 */   // GIR_Coverage, 4455,
     /* 110529 */   GIR_EraseRootFromParent_Done,
     /* 110530 */ // Label 2113: @110530
     /* 110530 */ GIM_Try, /*On fail goto*//*Label 2114*/ GIMT_Encode4(110638), // Rule ID 4477 //
     /* 110535 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110538 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 110542 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 110549 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 110553 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 110557 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 110561 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 110565 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110570 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 110574 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110578 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110580 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 110587 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 110587 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 110590 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110594 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110599 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 110605 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 110610 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110615 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 110618 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110621 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110626 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110631 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 110636 */   GIR_RootConstrainSelectedInstOperands,
     /* 110637 */   // GIR_Coverage, 4477,
     /* 110637 */   GIR_EraseRootFromParent_Done,
     /* 110638 */ // Label 2114: @110638
     /* 110638 */ GIM_Try, /*On fail goto*//*Label 2115*/ GIMT_Encode4(110739), // Rule ID 4479 //
     /* 110643 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110646 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 110650 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 110654 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 110658 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 110662 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 110666 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110671 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 110675 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110679 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110681 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 110688 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 110688 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110691 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110695 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110700 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 110706 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 110711 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110716 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 110719 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110722 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110727 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110732 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 110737 */   GIR_RootConstrainSelectedInstOperands,
     /* 110738 */   // GIR_Coverage, 4479,
     /* 110738 */   GIR_EraseRootFromParent_Done,
     /* 110739 */ // Label 2115: @110739
     /* 110739 */ GIM_Try, /*On fail goto*//*Label 2116*/ GIMT_Encode4(110840), // Rule ID 4480 //
     /* 110744 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110747 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 110751 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 110755 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 110759 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 110763 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 110767 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110772 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 110776 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110780 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110782 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 110789 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 110789 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110792 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110796 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110801 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 110807 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 110812 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110817 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 110820 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110823 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110828 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110833 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 110838 */   GIR_RootConstrainSelectedInstOperands,
     /* 110839 */   // GIR_Coverage, 4480,
     /* 110839 */   GIR_EraseRootFromParent_Done,
     /* 110840 */ // Label 2116: @110840
     /* 110840 */ GIM_Try, /*On fail goto*//*Label 2117*/ GIMT_Encode4(110941), // Rule ID 12907 //
     /* 110845 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110848 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 110852 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 110856 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 110860 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 110864 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 110868 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110873 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 110877 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110881 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110883 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 110890 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 110890 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110893 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110897 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110902 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 110908 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 110913 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110918 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 110921 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110924 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110929 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110934 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 110939 */   GIR_RootConstrainSelectedInstOperands,
     /* 110940 */   // GIR_Coverage, 12907,
     /* 110940 */   GIR_EraseRootFromParent_Done,
     /* 110941 */ // Label 2117: @110941
     /* 110941 */ GIM_Try, /*On fail goto*//*Label 2118*/ GIMT_Encode4(111042), // Rule ID 12909 //
     /* 110946 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110949 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 110953 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 110957 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 110961 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 110965 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 110969 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110974 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 110978 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110982 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110984 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 110991 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 110991 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110994 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110998 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111003 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 111009 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 111014 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111019 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 111022 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111025 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111030 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111035 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 111040 */   GIR_RootConstrainSelectedInstOperands,
     /* 111041 */   // GIR_Coverage, 12909,
     /* 111041 */   GIR_EraseRootFromParent_Done,
     /* 111042 */ // Label 2118: @111042
     /* 111042 */ GIM_Try, /*On fail goto*//*Label 2119*/ GIMT_Encode4(111124), // Rule ID 6365 //
     /* 111047 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 111050 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111054 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 111061 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 111065 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 111069 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 111073 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 111077 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111082 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 111086 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 111090 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 111094 */   // MIs[2] Operand 1
     /* 111094 */   // No operand predicates
     /* 111094 */   // MIs[0] Rn
     /* 111094 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 111098 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 111102 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111104 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (ST1i8 VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 111104 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 111107 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 111111 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 111114 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 111116 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 111122 */   GIR_RootConstrainSelectedInstOperands,
     /* 111123 */   // GIR_Coverage, 6365,
     /* 111123 */   GIR_EraseRootFromParent_Done,
     /* 111124 */ // Label 2119: @111124
     /* 111124 */ GIM_Try, /*On fail goto*//*Label 2120*/ GIMT_Encode4(111206), // Rule ID 6366 //
     /* 111129 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 111132 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111136 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 111143 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 111147 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 111151 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 111155 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 111159 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111164 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 111168 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 111172 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 111176 */   // MIs[2] Operand 1
     /* 111176 */   // No operand predicates
     /* 111176 */   // MIs[0] Rn
     /* 111176 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 111180 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 111184 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111186 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (ST1i16 VecListOne128:{ *:[v8i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 111186 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 111189 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 111193 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 111196 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 111198 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 111204 */   GIR_RootConstrainSelectedInstOperands,
     /* 111205 */   // GIR_Coverage, 6366,
     /* 111205 */   GIR_EraseRootFromParent_Done,
     /* 111206 */ // Label 2120: @111206
     /* 111206 */ GIM_Try, /*On fail goto*//*Label 2121*/ GIMT_Encode4(111281), // Rule ID 6367 //
     /* 111211 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 111214 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111218 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 111222 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 111226 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 111230 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 111234 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111239 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 111243 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 111247 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 111251 */   // MIs[2] Operand 1
     /* 111251 */   // No operand predicates
     /* 111251 */   // MIs[0] Rn
     /* 111251 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 111255 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 111259 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111261 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 VecListOne128:{ *:[v4i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 111261 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 111264 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 111268 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 111271 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 111273 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 111279 */   GIR_RootConstrainSelectedInstOperands,
     /* 111280 */   // GIR_Coverage, 6367,
     /* 111280 */   GIR_EraseRootFromParent_Done,
     /* 111281 */ // Label 2121: @111281
     /* 111281 */ GIM_Try, /*On fail goto*//*Label 2122*/ GIMT_Encode4(111356), // Rule ID 6368 //
     /* 111286 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 111289 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111293 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 111297 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 111301 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 111305 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 111309 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111314 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 111318 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 111322 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 111326 */   // MIs[2] Operand 1
     /* 111326 */   // No operand predicates
     /* 111326 */   // MIs[0] Rn
     /* 111326 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 111330 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 111334 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111336 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 VecListOne128:{ *:[v4f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 111336 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 111339 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 111343 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 111346 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 111348 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 111354 */   GIR_RootConstrainSelectedInstOperands,
     /* 111355 */   // GIR_Coverage, 6368,
     /* 111355 */   GIR_EraseRootFromParent_Done,
     /* 111356 */ // Label 2122: @111356
     /* 111356 */ GIM_Try, /*On fail goto*//*Label 2123*/ GIMT_Encode4(111469), // Rule ID 6372 //
     /* 111361 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 111364 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111368 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 111375 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 111379 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 111383 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 111387 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 111391 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111396 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 111400 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 111404 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 111408 */   // MIs[2] Operand 1
     /* 111408 */   // No operand predicates
     /* 111408 */   // MIs[0] Rn
     /* 111408 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 111412 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 111416 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111418 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v8i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (ST1i8 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 111418 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 111421 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111425 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111430 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 111433 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 111437 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 111440 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111445 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111450 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 111453 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111456 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 111459 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 111461 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 111467 */   GIR_RootConstrainSelectedInstOperands,
     /* 111468 */   // GIR_Coverage, 6372,
     /* 111468 */   GIR_EraseRootFromParent_Done,
     /* 111469 */ // Label 2123: @111469
     /* 111469 */ GIM_Try, /*On fail goto*//*Label 2124*/ GIMT_Encode4(111582), // Rule ID 6373 //
     /* 111474 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 111477 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111481 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 111488 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 111492 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 111496 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 111500 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 111504 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111509 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 111513 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 111517 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 111521 */   // MIs[2] Operand 1
     /* 111521 */   // No operand predicates
     /* 111521 */   // MIs[0] Rn
     /* 111521 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 111525 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 111529 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111531 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v4i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (ST1i16 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4i16] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 111531 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 111534 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111538 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111543 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 111546 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 111550 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 111553 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111558 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111563 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 111566 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111569 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 111572 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 111574 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 111580 */   GIR_RootConstrainSelectedInstOperands,
     /* 111581 */   // GIR_Coverage, 6373,
     /* 111581 */   GIR_EraseRootFromParent_Done,
     /* 111582 */ // Label 2124: @111582
     /* 111582 */ GIM_Try, /*On fail goto*//*Label 2125*/ GIMT_Encode4(111688), // Rule ID 6374 //
     /* 111587 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 111590 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111594 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 111598 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 111602 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 111606 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 111610 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111615 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 111619 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 111623 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 111627 */   // MIs[2] Operand 1
     /* 111627 */   // No operand predicates
     /* 111627 */   // MIs[0] Rn
     /* 111627 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 111631 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 111635 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111637 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2i32] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 111637 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 111640 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111644 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111649 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 111652 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 111656 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 111659 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111664 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111669 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 111672 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111675 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 111678 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 111680 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 111686 */   GIR_RootConstrainSelectedInstOperands,
     /* 111687 */   // GIR_Coverage, 6374,
     /* 111687 */   GIR_EraseRootFromParent_Done,
     /* 111688 */ // Label 2125: @111688
     /* 111688 */ GIM_Try, /*On fail goto*//*Label 2126*/ GIMT_Encode4(111794), // Rule ID 6375 //
     /* 111693 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 111696 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111700 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 111704 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 111708 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 111712 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 111716 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111721 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 111725 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 111729 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 111733 */   // MIs[2] Operand 1
     /* 111733 */   // No operand predicates
     /* 111733 */   // MIs[0] Rn
     /* 111733 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 111737 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 111741 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111743 */   // (st (vector_extract:{ *:[f32] } VecListOne64:{ *:[v2f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2f32] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 111743 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 111746 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111750 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111755 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 111758 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 111762 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 111765 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111770 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111775 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 111778 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111781 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 111784 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 111786 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 111792 */   GIR_RootConstrainSelectedInstOperands,
     /* 111793 */   // GIR_Coverage, 6375,
     /* 111793 */   GIR_EraseRootFromParent_Done,
     /* 111794 */ // Label 2126: @111794
     /* 111794 */ GIM_Try, /*On fail goto*//*Label 2127*/ GIMT_Encode4(111854), // Rule ID 295 //
     /* 111799 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 111802 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111806 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 111813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111817 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111821 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 111828 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 111828 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
     /* 111831 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 111833 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111838 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 111843 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 111848 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111852 */   GIR_RootConstrainSelectedInstOperands,
     /* 111853 */   // GIR_Coverage, 295,
     /* 111853 */   GIR_EraseRootFromParent_Done,
     /* 111854 */ // Label 2127: @111854
     /* 111854 */ GIM_Try, /*On fail goto*//*Label 2128*/ GIMT_Encode4(111914), // Rule ID 296 //
     /* 111859 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 111862 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111866 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 111873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111877 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111881 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 111888 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 111888 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
     /* 111891 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 111893 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111898 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 111903 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 111908 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111912 */   GIR_RootConstrainSelectedInstOperands,
     /* 111913 */   // GIR_Coverage, 296,
     /* 111913 */   GIR_EraseRootFromParent_Done,
     /* 111914 */ // Label 2128: @111914
     /* 111914 */ GIM_Try, /*On fail goto*//*Label 2129*/ GIMT_Encode4(111974), // Rule ID 297 //
     /* 111919 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 111922 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111926 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 111933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111937 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111941 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 111948 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 111948 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
     /* 111951 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 111953 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111958 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 111963 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 111968 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111972 */   GIR_RootConstrainSelectedInstOperands,
     /* 111973 */   // GIR_Coverage, 297,
     /* 111973 */   GIR_EraseRootFromParent_Done,
     /* 111974 */ // Label 2129: @111974
     /* 111974 */ GIM_Try, /*On fail goto*//*Label 2130*/ GIMT_Encode4(112034), // Rule ID 298 //
     /* 111979 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 111982 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111986 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 111993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111997 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112001 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 112008 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 112008 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
     /* 112011 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 112013 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112018 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112023 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112028 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112032 */   GIR_RootConstrainSelectedInstOperands,
     /* 112033 */   // GIR_Coverage, 298,
     /* 112033 */   GIR_EraseRootFromParent_Done,
     /* 112034 */ // Label 2130: @112034
     /* 112034 */ GIM_Try, /*On fail goto*//*Label 2131*/ GIMT_Encode4(112087), // Rule ID 299 //
     /* 112039 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112042 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112046 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112050 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112054 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 112061 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 112061 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
     /* 112064 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 112066 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112071 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112076 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112081 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112085 */   GIR_RootConstrainSelectedInstOperands,
     /* 112086 */   // GIR_Coverage, 299,
     /* 112086 */   GIR_EraseRootFromParent_Done,
     /* 112087 */ // Label 2131: @112087
     /* 112087 */ GIM_Try, /*On fail goto*//*Label 2132*/ GIMT_Encode4(112140), // Rule ID 300 //
     /* 112092 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112095 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112103 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112107 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 112114 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 112114 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
     /* 112117 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 112119 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112124 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112129 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112134 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112138 */   GIR_RootConstrainSelectedInstOperands,
     /* 112139 */   // GIR_Coverage, 300,
     /* 112139 */   GIR_EraseRootFromParent_Done,
     /* 112140 */ // Label 2132: @112140
     /* 112140 */ GIM_Try, /*On fail goto*//*Label 2133*/ GIMT_Encode4(112196), // Rule ID 307 //
     /* 112145 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 112148 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112151 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 112159 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112163 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 112170 */   // (st FPR32Op:{ *:[f32] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 112170 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 112173 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 112175 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112180 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112185 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112190 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112194 */   GIR_RootConstrainSelectedInstOperands,
     /* 112195 */   // GIR_Coverage, 307,
     /* 112195 */   GIR_EraseRootFromParent_Done,
     /* 112196 */ // Label 2133: @112196
     /* 112196 */ GIM_Try, /*On fail goto*//*Label 2134*/ GIMT_Encode4(112252), // Rule ID 308 //
     /* 112201 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 112204 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112207 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 112215 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112219 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 112226 */   // (st FPR32Op:{ *:[f32] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 112226 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 112229 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 112231 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112236 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112241 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112246 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112250 */   GIR_RootConstrainSelectedInstOperands,
     /* 112251 */   // GIR_Coverage, 308,
     /* 112251 */   GIR_EraseRootFromParent_Done,
     /* 112252 */ // Label 2134: @112252
     /* 112252 */ GIM_Try, /*On fail goto*//*Label 2135*/ GIMT_Encode4(112304), // Rule ID 312 //
     /* 112257 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112260 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112264 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112268 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112272 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 112279 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 112279 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
     /* 112282 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 112288 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112293 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112298 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112302 */   GIR_RootConstrainSelectedInstOperands,
     /* 112303 */   // GIR_Coverage, 312,
     /* 112303 */   GIR_EraseRootFromParent_Done,
     /* 112304 */ // Label 2135: @112304
     /* 112304 */ GIM_Try, /*On fail goto*//*Label 2136*/ GIMT_Encode4(112355), // Rule ID 315 //
     /* 112309 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 112312 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112315 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112319 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 112323 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112327 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 112334 */   // (st FPR32Op:{ *:[f32] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 112334 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 112337 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 112339 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112344 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112349 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112353 */   GIR_RootConstrainSelectedInstOperands,
     /* 112354 */   // GIR_Coverage, 315,
     /* 112354 */   GIR_EraseRootFromParent_Done,
     /* 112355 */ // Label 2136: @112355
     /* 112355 */ GIM_Try, /*On fail goto*//*Label 2137*/ GIMT_Encode4(112414), // Rule ID 317 //
     /* 112360 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112363 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112367 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 112374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112378 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112382 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 112389 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 112389 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
     /* 112392 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 112398 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112403 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112408 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112412 */   GIR_RootConstrainSelectedInstOperands,
     /* 112413 */   // GIR_Coverage, 317,
     /* 112413 */   GIR_EraseRootFromParent_Done,
     /* 112414 */ // Label 2137: @112414
     /* 112414 */ GIM_Try, /*On fail goto*//*Label 2138*/ GIMT_Encode4(112473), // Rule ID 318 //
     /* 112419 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112422 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112426 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 112433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112437 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112441 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 112448 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 112448 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
     /* 112451 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 112457 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112462 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112467 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112471 */   GIR_RootConstrainSelectedInstOperands,
     /* 112472 */   // GIR_Coverage, 318,
     /* 112472 */   GIR_EraseRootFromParent_Done,
     /* 112473 */ // Label 2138: @112473
     /* 112473 */ GIM_Try, /*On fail goto*//*Label 2139*/ GIMT_Encode4(112550), // Rule ID 6996 //
     /* 112478 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 112481 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 112488 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 112491 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 112495 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 112499 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 112503 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 112508 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112512 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112514 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 112521 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15556>>  =>  (STRSroW FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 112521 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 112524 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 112528 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112533 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112538 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112543 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112548 */   GIR_RootConstrainSelectedInstOperands,
     /* 112549 */   // GIR_Coverage, 6996,
     /* 112549 */   GIR_EraseRootFromParent_Done,
     /* 112550 */ // Label 2139: @112550
     /* 112550 */ GIM_Try, /*On fail goto*//*Label 2140*/ GIMT_Encode4(112627), // Rule ID 6997 //
     /* 112555 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 112558 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 112565 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 112568 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 112572 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 112576 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 112580 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 112585 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112589 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112591 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 112598 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15556>>  =>  (STRSroX FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 112598 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 112601 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 112605 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112610 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112615 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112620 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112625 */   GIR_RootConstrainSelectedInstOperands,
     /* 112626 */   // GIR_Coverage, 6997,
     /* 112626 */   GIR_EraseRootFromParent_Done,
     /* 112627 */ // Label 2140: @112627
     /* 112627 */ GIM_Try, /*On fail goto*//*Label 2141*/ GIMT_Encode4(112686), // Rule ID 6977 //
     /* 112632 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 112635 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 112642 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 112645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112649 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112653 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 112660 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15542>>  =>  (STRBBroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 112660 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
     /* 112663 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 112665 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112670 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112675 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112680 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112684 */   GIR_RootConstrainSelectedInstOperands,
     /* 112685 */   // GIR_Coverage, 6977,
     /* 112685 */   GIR_EraseRootFromParent_Done,
     /* 112686 */ // Label 2141: @112686
     /* 112686 */ GIM_Try, /*On fail goto*//*Label 2142*/ GIMT_Encode4(112745), // Rule ID 6978 //
     /* 112691 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 112694 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 112701 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 112704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112708 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112712 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 112719 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15542>>  =>  (STRBBroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 112719 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
     /* 112722 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 112724 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112729 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112734 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112739 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112743 */   GIR_RootConstrainSelectedInstOperands,
     /* 112744 */   // GIR_Coverage, 6978,
     /* 112744 */   GIR_EraseRootFromParent_Done,
     /* 112745 */ // Label 2142: @112745
     /* 112745 */ GIM_Try, /*On fail goto*//*Label 2143*/ GIMT_Encode4(112804), // Rule ID 6982 //
     /* 112750 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 112753 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 112760 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 112763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112767 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112771 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 112778 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15549>>  =>  (STRHHroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 112778 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
     /* 112781 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 112783 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112788 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112793 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112798 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112802 */   GIR_RootConstrainSelectedInstOperands,
     /* 112803 */   // GIR_Coverage, 6982,
     /* 112803 */   GIR_EraseRootFromParent_Done,
     /* 112804 */ // Label 2143: @112804
     /* 112804 */ GIM_Try, /*On fail goto*//*Label 2144*/ GIMT_Encode4(112863), // Rule ID 6983 //
     /* 112809 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 112812 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 112819 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 112822 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112826 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112830 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 112837 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15549>>  =>  (STRHHroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 112837 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
     /* 112840 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 112842 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112847 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112852 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112857 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112861 */   GIR_RootConstrainSelectedInstOperands,
     /* 112862 */   // GIR_Coverage, 6983,
     /* 112862 */   GIR_EraseRootFromParent_Done,
     /* 112863 */ // Label 2144: @112863
     /* 112863 */ GIM_Try, /*On fail goto*//*Label 2145*/ GIMT_Encode4(112922), // Rule ID 6987 //
     /* 112868 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 112871 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 112878 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 112881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112885 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112889 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 112896 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15556>>  =>  (STRWroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 112896 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
     /* 112899 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 112901 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112906 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112911 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112916 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112920 */   GIR_RootConstrainSelectedInstOperands,
     /* 112921 */   // GIR_Coverage, 6987,
     /* 112921 */   GIR_EraseRootFromParent_Done,
     /* 112922 */ // Label 2145: @112922
     /* 112922 */ GIM_Try, /*On fail goto*//*Label 2146*/ GIMT_Encode4(112981), // Rule ID 6988 //
     /* 112927 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 112930 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 112937 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 112940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112944 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112948 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 112955 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15556>>  =>  (STRWroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 112955 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
     /* 112958 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 112960 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112965 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112970 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112975 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112979 */   GIR_RootConstrainSelectedInstOperands,
     /* 112980 */   // GIR_Coverage, 6988,
     /* 112980 */   GIR_EraseRootFromParent_Done,
     /* 112981 */ // Label 2146: @112981
     /* 112981 */ GIM_Try, /*On fail goto*//*Label 2147*/ GIMT_Encode4(113053), // Rule ID 6998 //
     /* 112986 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 112989 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 112996 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 112999 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113003 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 113007 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 113011 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 113016 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113020 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113022 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 113029 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15556>>  =>  (STRSui FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 113029 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 113032 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 113036 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113041 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113046 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113051 */   GIR_RootConstrainSelectedInstOperands,
     /* 113052 */   // GIR_Coverage, 6998,
     /* 113052 */   GIR_EraseRootFromParent_Done,
     /* 113053 */ // Label 2147: @113053
     /* 113053 */ GIM_Try, /*On fail goto*//*Label 2148*/ GIMT_Encode4(113125), // Rule ID 6999 //
     /* 113058 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 113061 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 113068 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 113071 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113075 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 113079 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 113083 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 113088 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113092 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113094 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 113101 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15556>>  =>  (STURSi FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 113101 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 113104 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 113108 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113113 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113118 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113123 */   GIR_RootConstrainSelectedInstOperands,
     /* 113124 */   // GIR_Coverage, 6999,
     /* 113124 */   GIR_EraseRootFromParent_Done,
     /* 113125 */ // Label 2148: @113125
     /* 113125 */ GIM_Try, /*On fail goto*//*Label 2149*/ GIMT_Encode4(113177), // Rule ID 320 //
     /* 113130 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113133 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113137 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 113141 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113145 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 113152 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURWi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 113152 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
     /* 113155 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 113161 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113166 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113171 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113175 */   GIR_RootConstrainSelectedInstOperands,
     /* 113176 */   // GIR_Coverage, 320,
     /* 113176 */   GIR_EraseRootFromParent_Done,
     /* 113177 */ // Label 2149: @113177
     /* 113177 */ GIM_Try, /*On fail goto*//*Label 2150*/ GIMT_Encode4(113228), // Rule ID 323 //
     /* 113182 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 113185 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113188 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 113196 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113200 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 113207 */   // (st FPR32Op:{ *:[f32] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 113207 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 113210 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 113212 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113217 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113222 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113226 */   GIR_RootConstrainSelectedInstOperands,
     /* 113227 */   // GIR_Coverage, 323,
     /* 113227 */   GIR_EraseRootFromParent_Done,
     /* 113228 */ // Label 2150: @113228
     /* 113228 */ GIM_Try, /*On fail goto*//*Label 2151*/ GIMT_Encode4(113287), // Rule ID 326 //
     /* 113233 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113236 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113240 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 113247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 113251 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113255 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 113262 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHHi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 113262 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
     /* 113265 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 113271 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113276 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113281 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113285 */   GIR_RootConstrainSelectedInstOperands,
     /* 113286 */   // GIR_Coverage, 326,
     /* 113286 */   GIR_EraseRootFromParent_Done,
     /* 113287 */ // Label 2151: @113287
     /* 113287 */ GIM_Try, /*On fail goto*//*Label 2152*/ GIMT_Encode4(113346), // Rule ID 327 //
     /* 113292 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113295 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113299 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 113306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 113310 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113314 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 113321 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STURBBi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 113321 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
     /* 113324 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 113330 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113335 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113340 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113344 */   GIR_RootConstrainSelectedInstOperands,
     /* 113345 */   // GIR_Coverage, 327,
     /* 113345 */   GIR_EraseRootFromParent_Done,
     /* 113346 */ // Label 2152: @113346
     /* 113346 */ GIM_Try, /*On fail goto*//*Label 2153*/ GIMT_Encode4(113400), // Rule ID 6979 //
     /* 113351 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 113354 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 113361 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 113364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 113368 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113372 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 113379 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15542>>  =>  (STRBBui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 113379 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
     /* 113382 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 113384 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113389 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113394 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113398 */   GIR_RootConstrainSelectedInstOperands,
     /* 113399 */   // GIR_Coverage, 6979,
     /* 113399 */   GIR_EraseRootFromParent_Done,
     /* 113400 */ // Label 2153: @113400
     /* 113400 */ GIM_Try, /*On fail goto*//*Label 2154*/ GIMT_Encode4(113454), // Rule ID 6980 //
     /* 113405 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 113408 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 113415 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 113418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 113422 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113426 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 113433 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15542>>  =>  (STURBBi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 113433 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
     /* 113436 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 113438 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113443 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113448 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113452 */   GIR_RootConstrainSelectedInstOperands,
     /* 113453 */   // GIR_Coverage, 6980,
     /* 113453 */   GIR_EraseRootFromParent_Done,
     /* 113454 */ // Label 2154: @113454
     /* 113454 */ GIM_Try, /*On fail goto*//*Label 2155*/ GIMT_Encode4(113508), // Rule ID 6984 //
     /* 113459 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 113462 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 113469 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 113472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 113476 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113480 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 113487 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15549>>  =>  (STRHHui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 113487 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
     /* 113490 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 113492 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113497 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113502 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113506 */   GIR_RootConstrainSelectedInstOperands,
     /* 113507 */   // GIR_Coverage, 6984,
     /* 113507 */   GIR_EraseRootFromParent_Done,
     /* 113508 */ // Label 2155: @113508
     /* 113508 */ GIM_Try, /*On fail goto*//*Label 2156*/ GIMT_Encode4(113562), // Rule ID 6985 //
     /* 113513 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 113516 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 113523 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 113526 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 113530 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113534 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 113541 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15549>>  =>  (STURHHi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 113541 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
     /* 113544 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 113546 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113551 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113556 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113560 */   GIR_RootConstrainSelectedInstOperands,
     /* 113561 */   // GIR_Coverage, 6985,
     /* 113561 */   GIR_EraseRootFromParent_Done,
     /* 113562 */ // Label 2156: @113562
     /* 113562 */ GIM_Try, /*On fail goto*//*Label 2157*/ GIMT_Encode4(113616), // Rule ID 6989 //
     /* 113567 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 113570 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 113577 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 113580 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 113584 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113588 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 113595 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15556>>  =>  (STRWui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 113595 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
     /* 113598 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 113600 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113605 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113610 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113614 */   GIR_RootConstrainSelectedInstOperands,
     /* 113615 */   // GIR_Coverage, 6989,
     /* 113615 */   GIR_EraseRootFromParent_Done,
     /* 113616 */ // Label 2157: @113616
     /* 113616 */ GIM_Try, /*On fail goto*//*Label 2158*/ GIMT_Encode4(113670), // Rule ID 6990 //
     /* 113621 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 113624 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 113631 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 113634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 113638 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113642 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 113649 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15556>>  =>  (STURWi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 113649 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
     /* 113652 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 113654 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113659 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113664 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113668 */   GIR_RootConstrainSelectedInstOperands,
     /* 113669 */   // GIR_Coverage, 6990,
     /* 113669 */   GIR_EraseRootFromParent_Done,
     /* 113670 */ // Label 2158: @113670
     /* 113670 */ GIM_Try, /*On fail goto*//*Label 2159*/ GIMT_Encode4(113727), // Rule ID 7282 //
     /* 113675 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 113678 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 113681 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 113688 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 113691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 113695 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113699 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 113706 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15540>>  =>  (STLURBi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 113706 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURBi),
     /* 113709 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 113711 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113716 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113721 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113725 */   GIR_RootConstrainSelectedInstOperands,
     /* 113726 */   // GIR_Coverage, 7282,
     /* 113726 */   GIR_EraseRootFromParent_Done,
     /* 113727 */ // Label 2159: @113727
     /* 113727 */ GIM_Try, /*On fail goto*//*Label 2160*/ GIMT_Encode4(113784), // Rule ID 7283 //
     /* 113732 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 113735 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 113738 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 113745 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 113748 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 113752 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113756 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 113763 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15547>>  =>  (STLURHi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 113763 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURHi),
     /* 113766 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 113768 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113773 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113778 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113782 */   GIR_RootConstrainSelectedInstOperands,
     /* 113783 */   // GIR_Coverage, 7283,
     /* 113783 */   GIR_EraseRootFromParent_Done,
     /* 113784 */ // Label 2160: @113784
     /* 113784 */ GIM_Try, /*On fail goto*//*Label 2161*/ GIMT_Encode4(113841), // Rule ID 7284 //
     /* 113789 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 113792 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 113795 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 113802 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 113805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 113809 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113813 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 113820 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15554>>  =>  (STLURWi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 113820 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURWi),
     /* 113823 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 113825 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113830 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113835 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113839 */   GIR_RootConstrainSelectedInstOperands,
     /* 113840 */   // GIR_Coverage, 7284,
     /* 113840 */   GIR_EraseRootFromParent_Done,
     /* 113841 */ // Label 2161: @113841
     /* 113841 */ GIM_Try, /*On fail goto*//*Label 2162*/ GIMT_Encode4(113878), // Rule ID 6976 //
     /* 113846 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 113849 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 113856 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 113859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 113863 */   // MIs[0] ptr
     /* 113863 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 113867 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 113871 */   // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15540>>  =>  (STLRB GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 113871 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRB),
     /* 113876 */   GIR_RootConstrainSelectedInstOperands,
     /* 113877 */   // GIR_Coverage, 6976,
     /* 113877 */   GIR_Done,
     /* 113878 */ // Label 2162: @113878
     /* 113878 */ GIM_Try, /*On fail goto*//*Label 2163*/ GIMT_Encode4(113915), // Rule ID 6981 //
     /* 113883 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 113886 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 113893 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 113896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 113900 */   // MIs[0] ptr
     /* 113900 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 113904 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 113908 */   // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15547>>  =>  (STLRH GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 113908 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRH),
     /* 113913 */   GIR_RootConstrainSelectedInstOperands,
     /* 113914 */   // GIR_Coverage, 6981,
     /* 113914 */   GIR_Done,
     /* 113915 */ // Label 2163: @113915
     /* 113915 */ GIM_Try, /*On fail goto*//*Label 2164*/ GIMT_Encode4(113952), // Rule ID 6986 //
     /* 113920 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 113923 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 113930 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 113933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 113937 */   // MIs[0] ptr
     /* 113937 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 113941 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 113945 */   // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15554>>  =>  (STLRW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 113945 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRW),
     /* 113950 */   GIR_RootConstrainSelectedInstOperands,
     /* 113951 */   // GIR_Coverage, 6986,
     /* 113951 */   GIR_Done,
     /* 113952 */ // Label 2164: @113952
     /* 113952 */ GIM_Reject,
     /* 113953 */ // Label 2063: @113953
     /* 113953 */ GIM_Try, /*On fail goto*//*Label 2165*/ GIMT_Encode4(114059), // Rule ID 4430 //
     /* 113958 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113961 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113965 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113969 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113973 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 113977 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113981 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113986 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 113990 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113994 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113996 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 114003 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 114003 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 114006 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114010 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114015 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 114021 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114026 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114031 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 114034 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114037 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114042 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 114047 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 114052 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114057 */   GIR_RootConstrainSelectedInstOperands,
     /* 114058 */   // GIR_Coverage, 4430,
     /* 114058 */   GIR_EraseRootFromParent_Done,
     /* 114059 */ // Label 2165: @114059
     /* 114059 */ GIM_Try, /*On fail goto*//*Label 2166*/ GIMT_Encode4(114165), // Rule ID 4431 //
     /* 114064 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114067 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114071 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114075 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114079 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114083 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114087 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114092 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114096 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114100 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114102 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 114109 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 114109 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 114112 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114116 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114121 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 114127 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114132 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114137 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 114140 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114143 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114148 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 114153 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 114158 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114163 */   GIR_RootConstrainSelectedInstOperands,
     /* 114164 */   // GIR_Coverage, 4431,
     /* 114164 */   GIR_EraseRootFromParent_Done,
     /* 114165 */ // Label 2166: @114165
     /* 114165 */ GIM_Try, /*On fail goto*//*Label 2167*/ GIMT_Encode4(114271), // Rule ID 4432 //
     /* 114170 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114173 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114177 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114181 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114185 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114189 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114193 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114198 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114202 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114206 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114208 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 114215 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 114215 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 114218 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114222 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114227 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 114233 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114238 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114243 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 114246 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114249 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114254 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 114259 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 114264 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114269 */   GIR_RootConstrainSelectedInstOperands,
     /* 114270 */   // GIR_Coverage, 4432,
     /* 114270 */   GIR_EraseRootFromParent_Done,
     /* 114271 */ // Label 2167: @114271
     /* 114271 */ GIM_Try, /*On fail goto*//*Label 2168*/ GIMT_Encode4(114377), // Rule ID 4433 //
     /* 114276 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114279 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114283 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114287 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114291 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114295 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114299 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114304 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114308 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114312 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114314 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 114321 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 114321 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 114324 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114328 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114333 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 114339 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114344 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114349 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 114352 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114355 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114360 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 114365 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 114370 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114375 */   GIR_RootConstrainSelectedInstOperands,
     /* 114376 */   // GIR_Coverage, 4433,
     /* 114376 */   GIR_EraseRootFromParent_Done,
     /* 114377 */ // Label 2168: @114377
     /* 114377 */ GIM_Try, /*On fail goto*//*Label 2169*/ GIMT_Encode4(114478), // Rule ID 4456 //
     /* 114382 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114385 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114389 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114393 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114397 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114401 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114405 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114410 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114414 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114418 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114420 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 114427 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 114427 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 114430 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114434 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114439 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 114445 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114450 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114455 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 114458 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114461 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114466 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 114471 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114476 */   GIR_RootConstrainSelectedInstOperands,
     /* 114477 */   // GIR_Coverage, 4456,
     /* 114477 */   GIR_EraseRootFromParent_Done,
     /* 114478 */ // Label 2169: @114478
     /* 114478 */ GIM_Try, /*On fail goto*//*Label 2170*/ GIMT_Encode4(114579), // Rule ID 4457 //
     /* 114483 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114486 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114490 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114494 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114498 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114502 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114506 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114511 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114515 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114519 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114521 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 114528 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 114528 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 114531 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114535 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114540 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 114546 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114551 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114556 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 114559 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114562 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114567 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 114572 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114577 */   GIR_RootConstrainSelectedInstOperands,
     /* 114578 */   // GIR_Coverage, 4457,
     /* 114578 */   GIR_EraseRootFromParent_Done,
     /* 114579 */ // Label 2170: @114579
     /* 114579 */ GIM_Try, /*On fail goto*//*Label 2171*/ GIMT_Encode4(114680), // Rule ID 4481 //
     /* 114584 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114587 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114591 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114595 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114599 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114603 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114607 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114612 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114616 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114620 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114622 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 114629 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 114629 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 114632 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114636 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114641 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 114647 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114652 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114657 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 114660 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114663 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114668 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 114673 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114678 */   GIR_RootConstrainSelectedInstOperands,
     /* 114679 */   // GIR_Coverage, 4481,
     /* 114679 */   GIR_EraseRootFromParent_Done,
     /* 114680 */ // Label 2171: @114680
     /* 114680 */ GIM_Try, /*On fail goto*//*Label 2172*/ GIMT_Encode4(114781), // Rule ID 4482 //
     /* 114685 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114688 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114692 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114696 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114700 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114704 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114708 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114713 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114717 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114721 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114723 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 114730 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 114730 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 114733 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114737 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114742 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 114748 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114753 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114758 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 114761 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114764 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114769 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 114774 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114779 */   GIR_RootConstrainSelectedInstOperands,
     /* 114780 */   // GIR_Coverage, 4482,
     /* 114780 */   GIR_EraseRootFromParent_Done,
     /* 114781 */ // Label 2172: @114781
     /* 114781 */ GIM_Try, /*On fail goto*//*Label 2173*/ GIMT_Encode4(114856), // Rule ID 6369 //
     /* 114786 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114789 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114793 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114797 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114801 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114805 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114809 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114814 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 114818 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 114822 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 114826 */   // MIs[2] Operand 1
     /* 114826 */   // No operand predicates
     /* 114826 */   // MIs[0] Rn
     /* 114826 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 114830 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 114834 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 114836 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i64 VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 114836 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i64),
     /* 114839 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 114843 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 114846 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 114848 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 114854 */   GIR_RootConstrainSelectedInstOperands,
     /* 114855 */   // GIR_Coverage, 6369,
     /* 114855 */   GIR_EraseRootFromParent_Done,
     /* 114856 */ // Label 2173: @114856
     /* 114856 */ GIM_Try, /*On fail goto*//*Label 2174*/ GIMT_Encode4(114931), // Rule ID 6370 //
     /* 114861 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114864 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114868 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114872 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114876 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114880 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114884 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114889 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 114893 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 114897 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 114901 */   // MIs[2] Operand 1
     /* 114901 */   // No operand predicates
     /* 114901 */   // MIs[0] Rn
     /* 114901 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 114905 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 114909 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 114911 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i64 VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 114911 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i64),
     /* 114914 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 114918 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 114921 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 114923 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 114929 */   GIR_RootConstrainSelectedInstOperands,
     /* 114930 */   // GIR_Coverage, 6370,
     /* 114930 */   GIR_EraseRootFromParent_Done,
     /* 114931 */ // Label 2174: @114931
     /* 114931 */ GIM_Try, /*On fail goto*//*Label 2175*/ GIMT_Encode4(114984), // Rule ID 301 //
     /* 114936 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114939 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 114947 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114951 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 114958 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXroW GPR64:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 114958 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroW),
     /* 114961 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 114963 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114968 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 114973 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 114978 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 114982 */   GIR_RootConstrainSelectedInstOperands,
     /* 114983 */   // GIR_Coverage, 301,
     /* 114983 */   GIR_EraseRootFromParent_Done,
     /* 114984 */ // Label 2175: @114984
     /* 114984 */ GIM_Try, /*On fail goto*//*Label 2176*/ GIMT_Encode4(115037), // Rule ID 302 //
     /* 114989 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114992 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115000 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115004 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 115011 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXroX GPR64:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 115011 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroX),
     /* 115014 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 115016 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115021 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115026 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115031 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115035 */   GIR_RootConstrainSelectedInstOperands,
     /* 115036 */   // GIR_Coverage, 302,
     /* 115036 */   GIR_EraseRootFromParent_Done,
     /* 115037 */ // Label 2176: @115037
     /* 115037 */ GIM_Try, /*On fail goto*//*Label 2177*/ GIMT_Encode4(115093), // Rule ID 309 //
     /* 115042 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 115045 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115048 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115056 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115060 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 115067 */   // (st FPR64Op:{ *:[f64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 115067 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 115070 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 115072 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115077 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115082 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115087 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115091 */   GIR_RootConstrainSelectedInstOperands,
     /* 115092 */   // GIR_Coverage, 309,
     /* 115092 */   GIR_EraseRootFromParent_Done,
     /* 115093 */ // Label 2177: @115093
     /* 115093 */ GIM_Try, /*On fail goto*//*Label 2178*/ GIMT_Encode4(115149), // Rule ID 310 //
     /* 115098 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 115101 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115104 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115112 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115116 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 115123 */   // (st FPR64Op:{ *:[f64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 115123 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 115126 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 115128 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115133 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115138 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115143 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115147 */   GIR_RootConstrainSelectedInstOperands,
     /* 115148 */   // GIR_Coverage, 310,
     /* 115148 */   GIR_EraseRootFromParent_Done,
     /* 115149 */ // Label 2178: @115149
     /* 115149 */ GIM_Try, /*On fail goto*//*Label 2179*/ GIMT_Encode4(115238), // Rule ID 4388 //
     /* 115154 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115157 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115161 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 115168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115172 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115176 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 115183 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 115183 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115186 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115190 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115195 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 115201 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115206 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115211 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
     /* 115214 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115217 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115222 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115227 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115232 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115236 */   GIR_RootConstrainSelectedInstOperands,
     /* 115237 */   // GIR_Coverage, 4388,
     /* 115237 */   GIR_EraseRootFromParent_Done,
     /* 115238 */ // Label 2179: @115238
     /* 115238 */ GIM_Try, /*On fail goto*//*Label 2180*/ GIMT_Encode4(115327), // Rule ID 4389 //
     /* 115243 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115246 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115250 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 115257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115261 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115265 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 115272 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 115272 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115275 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115279 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115284 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 115290 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115295 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115300 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
     /* 115303 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115306 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115311 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115316 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115321 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115325 */   GIR_RootConstrainSelectedInstOperands,
     /* 115326 */   // GIR_Coverage, 4389,
     /* 115326 */   GIR_EraseRootFromParent_Done,
     /* 115327 */ // Label 2180: @115327
     /* 115327 */ GIM_Try, /*On fail goto*//*Label 2181*/ GIMT_Encode4(115416), // Rule ID 4390 //
     /* 115332 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115335 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115339 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 115346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115350 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115354 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 115361 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 115361 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115364 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115368 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115373 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 115379 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115384 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115389 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
     /* 115392 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115395 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115400 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115405 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115410 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115414 */   GIR_RootConstrainSelectedInstOperands,
     /* 115415 */   // GIR_Coverage, 4390,
     /* 115415 */   GIR_EraseRootFromParent_Done,
     /* 115416 */ // Label 2181: @115416
     /* 115416 */ GIM_Try, /*On fail goto*//*Label 2182*/ GIMT_Encode4(115505), // Rule ID 4391 //
     /* 115421 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115424 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115428 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 115435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115439 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115443 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 115450 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 115450 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115453 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115457 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115462 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 115468 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115473 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115478 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
     /* 115481 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115484 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115489 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115494 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115499 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115503 */   GIR_RootConstrainSelectedInstOperands,
     /* 115504 */   // GIR_Coverage, 4391,
     /* 115504 */   GIR_EraseRootFromParent_Done,
     /* 115505 */ // Label 2182: @115505
     /* 115505 */ GIM_Try, /*On fail goto*//*Label 2183*/ GIMT_Encode4(115594), // Rule ID 4392 //
     /* 115510 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115513 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115517 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 115524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115528 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115532 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 115539 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 115539 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115542 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115546 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115551 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 115557 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115562 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115567 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
     /* 115570 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115573 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115578 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115583 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115588 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115592 */   GIR_RootConstrainSelectedInstOperands,
     /* 115593 */   // GIR_Coverage, 4392,
     /* 115593 */   GIR_EraseRootFromParent_Done,
     /* 115594 */ // Label 2183: @115594
     /* 115594 */ GIM_Try, /*On fail goto*//*Label 2184*/ GIMT_Encode4(115683), // Rule ID 4393 //
     /* 115599 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115602 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115606 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 115613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115617 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115621 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 115628 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 115628 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115631 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115635 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115640 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 115646 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115651 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115656 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
     /* 115659 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115662 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115667 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115672 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115677 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115681 */   GIR_RootConstrainSelectedInstOperands,
     /* 115682 */   // GIR_Coverage, 4393,
     /* 115682 */   GIR_EraseRootFromParent_Done,
     /* 115683 */ // Label 2184: @115683
     /* 115683 */ GIM_Try, /*On fail goto*//*Label 2185*/ GIMT_Encode4(115736), // Rule ID 4404 //
     /* 115688 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115691 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115699 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115703 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 115710 */   // (st FPR64:{ *:[v1i64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 115710 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 115713 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 115715 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115720 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115725 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115730 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115734 */   GIR_RootConstrainSelectedInstOperands,
     /* 115735 */   // GIR_Coverage, 4404,
     /* 115735 */   GIR_EraseRootFromParent_Done,
     /* 115736 */ // Label 2185: @115736
     /* 115736 */ GIM_Try, /*On fail goto*//*Label 2186*/ GIMT_Encode4(115789), // Rule ID 4405 //
     /* 115741 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115744 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115748 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115752 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115756 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 115763 */   // (st FPR64:{ *:[v1i64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 115763 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 115766 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 115768 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115773 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115778 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115783 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115787 */   GIR_RootConstrainSelectedInstOperands,
     /* 115788 */   // GIR_Coverage, 4405,
     /* 115788 */   GIR_EraseRootFromParent_Done,
     /* 115789 */ // Label 2186: @115789
     /* 115789 */ GIM_Try, /*On fail goto*//*Label 2187*/ GIMT_Encode4(115842), // Rule ID 4406 //
     /* 115794 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115797 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115805 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115809 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 115816 */   // (st FPR64:{ *:[v1f64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 115816 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 115819 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 115821 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115826 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115831 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115836 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115840 */   GIR_RootConstrainSelectedInstOperands,
     /* 115841 */   // GIR_Coverage, 4406,
     /* 115841 */   GIR_EraseRootFromParent_Done,
     /* 115842 */ // Label 2187: @115842
     /* 115842 */ GIM_Try, /*On fail goto*//*Label 2188*/ GIMT_Encode4(115895), // Rule ID 4407 //
     /* 115847 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115850 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115858 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115862 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 115869 */   // (st FPR64:{ *:[v1f64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 115869 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 115872 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 115874 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115879 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115884 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115889 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115893 */   GIR_RootConstrainSelectedInstOperands,
     /* 115894 */   // GIR_Coverage, 4407,
     /* 115894 */   GIR_EraseRootFromParent_Done,
     /* 115895 */ // Label 2188: @115895
     /* 115895 */ GIM_Try, /*On fail goto*//*Label 2189*/ GIMT_Encode4(115947), // Rule ID 311 //
     /* 115900 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115903 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115911 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115915 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 115922 */   // (st GPR64z:{ *:[i64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXui GPR64z:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 115922 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXui),
     /* 115925 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::XZR), // Rt
     /* 115931 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115936 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 115941 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115945 */   GIR_RootConstrainSelectedInstOperands,
     /* 115946 */   // GIR_Coverage, 311,
     /* 115946 */   GIR_EraseRootFromParent_Done,
     /* 115947 */ // Label 2189: @115947
     /* 115947 */ GIM_Try, /*On fail goto*//*Label 2190*/ GIMT_Encode4(115998), // Rule ID 316 //
     /* 115952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 115955 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115958 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115966 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115970 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 115977 */   // (st FPR64Op:{ *:[f64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 115977 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 115980 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 115982 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115987 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 115992 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115996 */   GIR_RootConstrainSelectedInstOperands,
     /* 115997 */   // GIR_Coverage, 316,
     /* 115997 */   GIR_EraseRootFromParent_Done,
     /* 115998 */ // Label 2190: @115998
     /* 115998 */ GIM_Try, /*On fail goto*//*Label 2191*/ GIMT_Encode4(116046), // Rule ID 4434 //
     /* 116003 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116006 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116014 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116018 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 116025 */   // (st FPR64:{ *:[v1i64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 116025 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 116028 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 116030 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116035 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116040 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116044 */   GIR_RootConstrainSelectedInstOperands,
     /* 116045 */   // GIR_Coverage, 4434,
     /* 116045 */   GIR_EraseRootFromParent_Done,
     /* 116046 */ // Label 2191: @116046
     /* 116046 */ GIM_Try, /*On fail goto*//*Label 2192*/ GIMT_Encode4(116094), // Rule ID 4435 //
     /* 116051 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116054 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116062 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116066 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 116073 */   // (st FPR64:{ *:[v1f64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 116073 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 116076 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 116078 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116083 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116088 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116092 */   GIR_RootConstrainSelectedInstOperands,
     /* 116093 */   // GIR_Coverage, 4435,
     /* 116093 */   GIR_EraseRootFromParent_Done,
     /* 116094 */ // Label 2192: @116094
     /* 116094 */ GIM_Try, /*On fail goto*//*Label 2193*/ GIMT_Encode4(116178), // Rule ID 4449 //
     /* 116099 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116102 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116106 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 116113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 116117 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116121 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 116128 */   // (st GPR64:{ *:[i64] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 116128 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116131 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116135 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116140 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 116146 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116151 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 116156 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
     /* 116159 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116162 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116167 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116172 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116176 */   GIR_RootConstrainSelectedInstOperands,
     /* 116177 */   // GIR_Coverage, 4449,
     /* 116177 */   GIR_EraseRootFromParent_Done,
     /* 116178 */ // Label 2193: @116178
     /* 116178 */ GIM_Try, /*On fail goto*//*Label 2194*/ GIMT_Encode4(116262), // Rule ID 4450 //
     /* 116183 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116186 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116190 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 116197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 116201 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116205 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 116212 */   // (st GPR64:{ *:[i64] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 116212 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116215 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116219 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116224 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 116230 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116235 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 116240 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
     /* 116243 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116246 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116251 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116256 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116260 */   GIR_RootConstrainSelectedInstOperands,
     /* 116261 */   // GIR_Coverage, 4450,
     /* 116261 */   GIR_EraseRootFromParent_Done,
     /* 116262 */ // Label 2194: @116262
     /* 116262 */ GIM_Try, /*On fail goto*//*Label 2195*/ GIMT_Encode4(116346), // Rule ID 4451 //
     /* 116267 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116270 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116274 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 116281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 116285 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116289 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 116296 */   // (st GPR64:{ *:[i64] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 116296 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116299 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116303 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116308 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 116314 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116319 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 116324 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
     /* 116327 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116330 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116335 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116340 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116344 */   GIR_RootConstrainSelectedInstOperands,
     /* 116345 */   // GIR_Coverage, 4451,
     /* 116345 */   GIR_EraseRootFromParent_Done,
     /* 116346 */ // Label 2195: @116346
     /* 116346 */ GIM_Try, /*On fail goto*//*Label 2196*/ GIMT_Encode4(116423), // Rule ID 7000 //
     /* 116351 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116354 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 116361 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116364 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 116368 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 116372 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 116376 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116381 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116385 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116387 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 116394 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15563>>  =>  (STRDroW FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 116394 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 116397 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 116401 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116406 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116411 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116416 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 116421 */   GIR_RootConstrainSelectedInstOperands,
     /* 116422 */   // GIR_Coverage, 7000,
     /* 116422 */   GIR_EraseRootFromParent_Done,
     /* 116423 */ // Label 2196: @116423
     /* 116423 */ GIM_Try, /*On fail goto*//*Label 2197*/ GIMT_Encode4(116500), // Rule ID 7001 //
     /* 116428 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116431 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 116438 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116441 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 116445 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 116449 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 116453 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116458 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116462 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116464 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 116471 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15563>>  =>  (STRDroX FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 116471 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 116474 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 116478 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116483 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116488 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116493 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 116498 */   GIR_RootConstrainSelectedInstOperands,
     /* 116499 */   // GIR_Coverage, 7001,
     /* 116499 */   GIR_EraseRootFromParent_Done,
     /* 116500 */ // Label 2197: @116500
     /* 116500 */ GIM_Try, /*On fail goto*//*Label 2198*/ GIMT_Encode4(116559), // Rule ID 6992 //
     /* 116505 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116508 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 116515 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 116522 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116526 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 116533 */   // (atomic_store GPR64:{ *:[i64] }:$val, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15563>>  =>  (STRXroW GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 116533 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroW),
     /* 116536 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 116538 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116543 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116548 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116553 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116557 */   GIR_RootConstrainSelectedInstOperands,
     /* 116558 */   // GIR_Coverage, 6992,
     /* 116558 */   GIR_EraseRootFromParent_Done,
     /* 116559 */ // Label 2198: @116559
     /* 116559 */ GIM_Try, /*On fail goto*//*Label 2199*/ GIMT_Encode4(116618), // Rule ID 6993 //
     /* 116564 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116567 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 116574 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 116581 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116585 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 116592 */   // (atomic_store GPR64:{ *:[i64] }:$val, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15563>>  =>  (STRXroX GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 116592 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroX),
     /* 116595 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 116597 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116602 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116607 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116612 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116616 */   GIR_RootConstrainSelectedInstOperands,
     /* 116617 */   // GIR_Coverage, 6993,
     /* 116617 */   GIR_EraseRootFromParent_Done,
     /* 116618 */ // Label 2199: @116618
     /* 116618 */ GIM_Try, /*On fail goto*//*Label 2200*/ GIMT_Encode4(116690), // Rule ID 7002 //
     /* 116623 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116626 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 116633 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116636 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 116640 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 116644 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 116648 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116653 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116657 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116659 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 116666 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15563>>  =>  (STRDui FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 116666 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 116669 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 116673 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116678 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116683 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 116688 */   GIR_RootConstrainSelectedInstOperands,
     /* 116689 */   // GIR_Coverage, 7002,
     /* 116689 */   GIR_EraseRootFromParent_Done,
     /* 116690 */ // Label 2200: @116690
     /* 116690 */ GIM_Try, /*On fail goto*//*Label 2201*/ GIMT_Encode4(116762), // Rule ID 7003 //
     /* 116695 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116698 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 116705 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116708 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 116712 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 116716 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 116720 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116725 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116729 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116731 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 116738 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15563>>  =>  (STURDi FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 116738 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 116741 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 116745 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116750 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116755 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 116760 */   GIR_RootConstrainSelectedInstOperands,
     /* 116761 */   // GIR_Coverage, 7003,
     /* 116761 */   GIR_EraseRootFromParent_Done,
     /* 116762 */ // Label 2201: @116762
     /* 116762 */ GIM_Try, /*On fail goto*//*Label 2202*/ GIMT_Encode4(116859), // Rule ID 7274 //
     /* 116767 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 116770 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116773 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 116780 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116783 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 116787 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 116791 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 116795 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 116799 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 116803 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 116807 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 116811 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116816 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 116820 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116824 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 116828 */   // MIs[3] Operand 1
     /* 116828 */   // No operand predicates
     /* 116828 */   // MIs[0] Rn
     /* 116828 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 116832 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 116836 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 116838 */   // (atomic_store (bitconvert:{ *:[i64] } (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15561>>  =>  (STL1 VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 116838 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
     /* 116841 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vt
     /* 116845 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 116848 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 116850 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /* 116857 */   GIR_RootConstrainSelectedInstOperands,
     /* 116858 */   // GIR_Coverage, 7274,
     /* 116858 */   GIR_EraseRootFromParent_Done,
     /* 116859 */ // Label 2202: @116859
     /* 116859 */ GIM_Try, /*On fail goto*//*Label 2203*/ GIMT_Encode4(116911), // Rule ID 319 //
     /* 116864 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116867 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 116875 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116879 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 116886 */   // (st GPR64z:{ *:[i64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURXi GPR64z:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 116886 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURXi),
     /* 116889 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::XZR), // Rt
     /* 116895 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116900 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116905 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116909 */   GIR_RootConstrainSelectedInstOperands,
     /* 116910 */   // GIR_Coverage, 319,
     /* 116910 */   GIR_EraseRootFromParent_Done,
     /* 116911 */ // Label 2203: @116911
     /* 116911 */ GIM_Try, /*On fail goto*//*Label 2204*/ GIMT_Encode4(116962), // Rule ID 324 //
     /* 116916 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116919 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116922 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116930 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116934 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 116941 */   // (st FPR64Op:{ *:[f64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 116941 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 116944 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 116946 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116951 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116956 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116960 */   GIR_RootConstrainSelectedInstOperands,
     /* 116961 */   // GIR_Coverage, 324,
     /* 116961 */   GIR_EraseRootFromParent_Done,
     /* 116962 */ // Label 2204: @116962
     /* 116962 */ GIM_Try, /*On fail goto*//*Label 2205*/ GIMT_Encode4(117016), // Rule ID 6994 //
     /* 116967 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116970 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 116977 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 116984 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116988 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 116995 */   // (atomic_store GPR64:{ *:[i64] }:$val, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15563>>  =>  (STRXui GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 116995 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXui),
     /* 116998 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117000 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117005 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117010 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117014 */   GIR_RootConstrainSelectedInstOperands,
     /* 117015 */   // GIR_Coverage, 6994,
     /* 117015 */   GIR_EraseRootFromParent_Done,
     /* 117016 */ // Label 2205: @117016
     /* 117016 */ GIM_Try, /*On fail goto*//*Label 2206*/ GIMT_Encode4(117070), // Rule ID 6995 //
     /* 117021 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117024 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 117031 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117034 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117038 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117042 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 117049 */   // (atomic_store GPR64:{ *:[i64] }:$val, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15563>>  =>  (STURXi GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 117049 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURXi),
     /* 117052 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117054 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117059 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117064 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117068 */   GIR_RootConstrainSelectedInstOperands,
     /* 117069 */   // GIR_Coverage, 6995,
     /* 117069 */   GIR_EraseRootFromParent_Done,
     /* 117070 */ // Label 2206: @117070
     /* 117070 */ GIM_Try, /*On fail goto*//*Label 2207*/ GIMT_Encode4(117127), // Rule ID 7285 //
     /* 117075 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 117078 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117081 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 117088 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117095 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117099 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 117106 */   // (atomic_store GPR64:{ *:[i64] }:$val, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15561>>  =>  (STLURXi GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 117106 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURXi),
     /* 117109 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117111 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117116 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117121 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117125 */   GIR_RootConstrainSelectedInstOperands,
     /* 117126 */   // GIR_Coverage, 7285,
     /* 117126 */   GIR_EraseRootFromParent_Done,
     /* 117127 */ // Label 2207: @117127
     /* 117127 */ GIM_Try, /*On fail goto*//*Label 2208*/ GIMT_Encode4(117175), // Rule ID 4458 //
     /* 117132 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117135 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117139 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117143 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117147 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 117154 */   // (st FPR64:{ *:[v1f64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 117154 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 117157 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 117159 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117164 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117169 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117173 */   GIR_RootConstrainSelectedInstOperands,
     /* 117174 */   // GIR_Coverage, 4458,
     /* 117174 */   GIR_EraseRootFromParent_Done,
     /* 117175 */ // Label 2208: @117175
     /* 117175 */ GIM_Try, /*On fail goto*//*Label 2209*/ GIMT_Encode4(117223), // Rule ID 4459 //
     /* 117180 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117183 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117191 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117195 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 117202 */   // (st FPR64:{ *:[v1i64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 117202 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 117205 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 117207 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117212 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117217 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117221 */   GIR_RootConstrainSelectedInstOperands,
     /* 117222 */   // GIR_Coverage, 4459,
     /* 117222 */   GIR_EraseRootFromParent_Done,
     /* 117223 */ // Label 2209: @117223
     /* 117223 */ GIM_Try, /*On fail goto*//*Label 2210*/ GIMT_Encode4(117307), // Rule ID 4474 //
     /* 117228 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117231 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117235 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 117242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117246 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117250 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 117257 */   // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STURWi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 117257 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117260 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117264 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117269 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 117275 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117280 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117285 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
     /* 117288 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117291 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117296 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117301 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117305 */   GIR_RootConstrainSelectedInstOperands,
     /* 117306 */   // GIR_Coverage, 4474,
     /* 117306 */   GIR_EraseRootFromParent_Done,
     /* 117307 */ // Label 2210: @117307
     /* 117307 */ GIM_Try, /*On fail goto*//*Label 2211*/ GIMT_Encode4(117391), // Rule ID 4475 //
     /* 117312 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117315 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117319 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 117326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117330 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117334 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 117341 */   // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHHi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 117341 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117344 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117348 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117353 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 117359 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117364 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117369 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
     /* 117372 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117375 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117380 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117385 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117389 */   GIR_RootConstrainSelectedInstOperands,
     /* 117390 */   // GIR_Coverage, 4475,
     /* 117390 */   GIR_EraseRootFromParent_Done,
     /* 117391 */ // Label 2211: @117391
     /* 117391 */ GIM_Try, /*On fail goto*//*Label 2212*/ GIMT_Encode4(117475), // Rule ID 4476 //
     /* 117396 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117399 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117403 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 117410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117414 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117418 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 117425 */   // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STURBBi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 117425 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117428 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117432 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117437 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 117443 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117448 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117453 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
     /* 117456 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117459 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117464 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117469 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117473 */   GIR_RootConstrainSelectedInstOperands,
     /* 117474 */   // GIR_Coverage, 4476,
     /* 117474 */   GIR_EraseRootFromParent_Done,
     /* 117475 */ // Label 2212: @117475
     /* 117475 */ GIM_Try, /*On fail goto*//*Label 2213*/ GIMT_Encode4(117559), // Rule ID 7273 //
     /* 117480 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 117483 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117486 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 117493 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117496 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 117500 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 117504 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 117508 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 117512 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117517 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 117521 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 117525 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 117529 */   // MIs[2] Operand 1
     /* 117529 */   // No operand predicates
     /* 117529 */   // MIs[0] Rn
     /* 117529 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 117533 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 117537 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 117539 */   // (atomic_store (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15561>>  =>  (STL1 VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 117539 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
     /* 117542 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 117546 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 117549 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 117551 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 117557 */   GIR_RootConstrainSelectedInstOperands,
     /* 117558 */   // GIR_Coverage, 7273,
     /* 117558 */   GIR_EraseRootFromParent_Done,
     /* 117559 */ // Label 2213: @117559
     /* 117559 */ GIM_Try, /*On fail goto*//*Label 2214*/ GIMT_Encode4(117657), // Rule ID 7275 //
     /* 117564 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 117567 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117570 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 117577 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117580 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 117584 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 117588 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 117592 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117597 */   // MIs[0] Rn
     /* 117597 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 117601 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 117605 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117607 */   // (atomic_store (bitconvert:{ *:[i64] } VecListOne64:{ *:[v1f64] }:$Vt), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15561>>  =>  (STL1 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, VecListOne64:{ *:[v1f64] }:$Vt, dsub:{ *:[i32] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn)
     /* 117607 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 117610 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 117614 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117619 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 117622 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 117626 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 117629 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117634 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117639 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
     /* 117642 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117645 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117648 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 117650 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 117655 */   GIR_RootConstrainSelectedInstOperands,
     /* 117656 */   // GIR_Coverage, 7275,
     /* 117656 */   GIR_EraseRootFromParent_Done,
     /* 117657 */ // Label 2214: @117657
     /* 117657 */ GIM_Try, /*On fail goto*//*Label 2215*/ GIMT_Encode4(117694), // Rule ID 6991 //
     /* 117662 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117665 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 117672 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117675 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117679 */   // MIs[0] ptr
     /* 117679 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 117683 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 117687 */   // (atomic_store GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15561>>  =>  (STLRX GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 117687 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRX),
     /* 117692 */   GIR_RootConstrainSelectedInstOperands,
     /* 117693 */   // GIR_Coverage, 6991,
     /* 117693 */   GIR_Done,
     /* 117694 */ // Label 2215: @117694
     /* 117694 */ GIM_Try, /*On fail goto*//*Label 2216*/ GIMT_Encode4(117721), // Rule ID 6319 //
     /* 117699 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117702 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117706 */   // MIs[0] Rn
     /* 117706 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 117710 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 117714 */   // (st v1i64:{ *:[v1i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev1d v1i64:{ *:[v1i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 117714 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev1d),
     /* 117719 */   GIR_RootConstrainSelectedInstOperands,
     /* 117720 */   // GIR_Coverage, 6319,
     /* 117720 */   GIR_Done,
     /* 117721 */ // Label 2216: @117721
     /* 117721 */ GIM_Reject,
     /* 117722 */ // Label 2064: @117722
     /* 117722 */ GIM_Try, /*On fail goto*//*Label 2217*/ GIMT_Encode4(117927),
     /* 117727 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117730 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117738 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117742 */   GIM_Try, /*On fail goto*//*Label 2218*/ GIMT_Encode4(117783), // Rule ID 4386 //
     /* 117747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSTRQro),
     /* 117750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 117757 */     // (st FPR128:{ *:[f128] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 117757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 117760 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 117762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117777 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117781 */     GIR_RootConstrainSelectedInstOperands,
     /* 117782 */     // GIR_Coverage, 4386,
     /* 117782 */     GIR_EraseRootFromParent_Done,
     /* 117783 */   // Label 2218: @117783
     /* 117783 */   GIM_Try, /*On fail goto*//*Label 2219*/ GIMT_Encode4(117824), // Rule ID 4387 //
     /* 117788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSTRQro),
     /* 117791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 117798 */     // (st FPR128:{ *:[f128] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 117798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 117801 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 117803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117818 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117822 */     GIR_RootConstrainSelectedInstOperands,
     /* 117823 */     // GIR_Coverage, 4387,
     /* 117823 */     GIR_EraseRootFromParent_Done,
     /* 117824 */   // Label 2219: @117824
     /* 117824 */   GIM_Try, /*On fail goto*//*Label 2220*/ GIMT_Encode4(117857), // Rule ID 4441 //
     /* 117829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 117836 */     // (st FPR128:{ *:[f128] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 117836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 117839 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 117841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117851 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117855 */     GIR_RootConstrainSelectedInstOperands,
     /* 117856 */     // GIR_Coverage, 4441,
     /* 117856 */     GIR_EraseRootFromParent_Done,
     /* 117857 */   // Label 2220: @117857
     /* 117857 */   GIM_Try, /*On fail goto*//*Label 2221*/ GIMT_Encode4(117890), // Rule ID 4465 //
     /* 117862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 117869 */     // (st FPR128:{ *:[f128] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 117869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 117872 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 117874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117884 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117888 */     GIR_RootConstrainSelectedInstOperands,
     /* 117889 */     // GIR_Coverage, 4465,
     /* 117889 */     GIR_EraseRootFromParent_Done,
     /* 117890 */   // Label 2221: @117890
     /* 117890 */   GIM_Try, /*On fail goto*//*Label 2222*/ GIMT_Encode4(117926), // Rule ID 325 //
     /* 117895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 117898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 117905 */     // (st FPR128Op:{ *:[f128] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128Op:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 117905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 117908 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 117910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117920 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117924 */     GIR_RootConstrainSelectedInstOperands,
     /* 117925 */     // GIR_Coverage, 325,
     /* 117925 */     GIR_EraseRootFromParent_Done,
     /* 117926 */   // Label 2222: @117926
     /* 117926 */   GIM_Reject,
     /* 117927 */ // Label 2217: @117927
     /* 117927 */ GIM_Reject,
     /* 117928 */ // Label 2065: @117928
     /* 117928 */ GIM_Try, /*On fail goto*//*Label 2223*/ GIMT_Encode4(118333),
     /* 117933 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117936 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117940 */   GIM_Try, /*On fail goto*//*Label 2224*/ GIMT_Encode4(117989), // Rule ID 4394 //
     /* 117945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 117948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117952 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 117963 */     // (st FPR64:{ *:[v2i32] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 117963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 117966 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 117968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117983 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117987 */     GIR_RootConstrainSelectedInstOperands,
     /* 117988 */     // GIR_Coverage, 4394,
     /* 117988 */     GIR_EraseRootFromParent_Done,
     /* 117989 */   // Label 2224: @117989
     /* 117989 */   GIM_Try, /*On fail goto*//*Label 2225*/ GIMT_Encode4(118038), // Rule ID 4395 //
     /* 117994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 117997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118001 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 118012 */     // (st FPR64:{ *:[v2i32] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 118012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 118015 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118032 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118036 */     GIR_RootConstrainSelectedInstOperands,
     /* 118037 */     // GIR_Coverage, 4395,
     /* 118037 */     GIR_EraseRootFromParent_Done,
     /* 118038 */   // Label 2225: @118038
     /* 118038 */   GIM_Try, /*On fail goto*//*Label 2226*/ GIMT_Encode4(118087), // Rule ID 4396 //
     /* 118043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 118046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118050 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 118061 */     // (st FPR64:{ *:[v2f32] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 118061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 118064 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118081 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118085 */     GIR_RootConstrainSelectedInstOperands,
     /* 118086 */     // GIR_Coverage, 4396,
     /* 118086 */     GIR_EraseRootFromParent_Done,
     /* 118087 */   // Label 2226: @118087
     /* 118087 */   GIM_Try, /*On fail goto*//*Label 2227*/ GIMT_Encode4(118136), // Rule ID 4397 //
     /* 118092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 118095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118099 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 118110 */     // (st FPR64:{ *:[v2f32] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 118110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 118113 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118130 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118134 */     GIR_RootConstrainSelectedInstOperands,
     /* 118135 */     // GIR_Coverage, 4397,
     /* 118135 */     GIR_EraseRootFromParent_Done,
     /* 118136 */   // Label 2227: @118136
     /* 118136 */   GIM_Try, /*On fail goto*//*Label 2228*/ GIMT_Encode4(118180), // Rule ID 4436 //
     /* 118141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 118144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118148 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 118159 */     // (st FPR64:{ *:[v2f32] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 118159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 118162 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118174 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118178 */     GIR_RootConstrainSelectedInstOperands,
     /* 118179 */     // GIR_Coverage, 4436,
     /* 118179 */     GIR_EraseRootFromParent_Done,
     /* 118180 */   // Label 2228: @118180
     /* 118180 */   GIM_Try, /*On fail goto*//*Label 2229*/ GIMT_Encode4(118224), // Rule ID 4439 //
     /* 118185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 118188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118192 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 118203 */     // (st FPR64:{ *:[v2i32] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 118203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 118206 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118218 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118222 */     GIR_RootConstrainSelectedInstOperands,
     /* 118223 */     // GIR_Coverage, 4439,
     /* 118223 */     GIR_EraseRootFromParent_Done,
     /* 118224 */   // Label 2229: @118224
     /* 118224 */   GIM_Try, /*On fail goto*//*Label 2230*/ GIMT_Encode4(118268), // Rule ID 4460 //
     /* 118229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 118232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118236 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 118247 */     // (st FPR64:{ *:[v2f32] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 118250 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118262 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118266 */     GIR_RootConstrainSelectedInstOperands,
     /* 118267 */     // GIR_Coverage, 4460,
     /* 118267 */     GIR_EraseRootFromParent_Done,
     /* 118268 */   // Label 2230: @118268
     /* 118268 */   GIM_Try, /*On fail goto*//*Label 2231*/ GIMT_Encode4(118312), // Rule ID 4463 //
     /* 118273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 118276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118280 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 118291 */     // (st FPR64:{ *:[v2i32] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 118294 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118306 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118310 */     GIR_RootConstrainSelectedInstOperands,
     /* 118311 */     // GIR_Coverage, 4463,
     /* 118311 */     GIR_EraseRootFromParent_Done,
     /* 118312 */   // Label 2231: @118312
     /* 118312 */   GIM_Try, /*On fail goto*//*Label 2232*/ GIMT_Encode4(118332), // Rule ID 6318 //
     /* 118317 */     // MIs[0] Rn
     /* 118317 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 118321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 118325 */     // (st v2i32:{ *:[v2i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev2s v2i32:{ *:[v2i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 118325 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev2s),
     /* 118330 */     GIR_RootConstrainSelectedInstOperands,
     /* 118331 */     // GIR_Coverage, 6318,
     /* 118331 */     GIR_Done,
     /* 118332 */   // Label 2232: @118332
     /* 118332 */   GIM_Reject,
     /* 118333 */ // Label 2223: @118333
     /* 118333 */ GIM_Reject,
     /* 118334 */ // Label 2066: @118334
     /* 118334 */ GIM_Try, /*On fail goto*//*Label 2233*/ GIMT_Encode4(118783),
     /* 118339 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118342 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118346 */   GIM_Try, /*On fail goto*//*Label 2234*/ GIMT_Encode4(118395), // Rule ID 4408 //
     /* 118351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 118354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118358 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 118369 */     // (st FPR128:{ *:[v2i64] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 118369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 118372 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118389 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118393 */     GIR_RootConstrainSelectedInstOperands,
     /* 118394 */     // GIR_Coverage, 4408,
     /* 118394 */     GIR_EraseRootFromParent_Done,
     /* 118395 */   // Label 2234: @118395
     /* 118395 */   GIM_Try, /*On fail goto*//*Label 2235*/ GIMT_Encode4(118444), // Rule ID 4409 //
     /* 118400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 118403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118407 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 118418 */     // (st FPR128:{ *:[v2i64] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 118418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 118421 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118438 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118442 */     GIR_RootConstrainSelectedInstOperands,
     /* 118443 */     // GIR_Coverage, 4409,
     /* 118443 */     GIR_EraseRootFromParent_Done,
     /* 118444 */   // Label 2235: @118444
     /* 118444 */   GIM_Try, /*On fail goto*//*Label 2236*/ GIMT_Encode4(118493), // Rule ID 4410 //
     /* 118449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 118452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118456 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 118467 */     // (st FPR128:{ *:[v2f64] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 118467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 118470 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118487 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118491 */     GIR_RootConstrainSelectedInstOperands,
     /* 118492 */     // GIR_Coverage, 4410,
     /* 118492 */     GIR_EraseRootFromParent_Done,
     /* 118493 */   // Label 2236: @118493
     /* 118493 */   GIM_Try, /*On fail goto*//*Label 2237*/ GIMT_Encode4(118542), // Rule ID 4411 //
     /* 118498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 118501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118505 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 118516 */     // (st FPR128:{ *:[v2f64] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 118516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 118519 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118536 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118540 */     GIR_RootConstrainSelectedInstOperands,
     /* 118541 */     // GIR_Coverage, 4411,
     /* 118541 */     GIR_EraseRootFromParent_Done,
     /* 118542 */   // Label 2237: @118542
     /* 118542 */   GIM_Try, /*On fail goto*//*Label 2238*/ GIMT_Encode4(118586), // Rule ID 4443 //
     /* 118547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 118550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118554 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 118565 */     // (st FPR128:{ *:[v2f64] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 118565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 118568 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118580 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118584 */     GIR_RootConstrainSelectedInstOperands,
     /* 118585 */     // GIR_Coverage, 4443,
     /* 118585 */     GIR_EraseRootFromParent_Done,
     /* 118586 */   // Label 2238: @118586
     /* 118586 */   GIM_Try, /*On fail goto*//*Label 2239*/ GIMT_Encode4(118630), // Rule ID 4447 //
     /* 118591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 118594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118598 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 118609 */     // (st FPR128:{ *:[v2i64] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 118609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 118612 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118624 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118628 */     GIR_RootConstrainSelectedInstOperands,
     /* 118629 */     // GIR_Coverage, 4447,
     /* 118629 */     GIR_EraseRootFromParent_Done,
     /* 118630 */   // Label 2239: @118630
     /* 118630 */   GIM_Try, /*On fail goto*//*Label 2240*/ GIMT_Encode4(118674), // Rule ID 4467 //
     /* 118635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 118638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118642 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 118653 */     // (st FPR128:{ *:[v2f64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 118656 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118668 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118672 */     GIR_RootConstrainSelectedInstOperands,
     /* 118673 */     // GIR_Coverage, 4467,
     /* 118673 */     GIR_EraseRootFromParent_Done,
     /* 118674 */   // Label 2240: @118674
     /* 118674 */   GIM_Try, /*On fail goto*//*Label 2241*/ GIMT_Encode4(118718), // Rule ID 4471 //
     /* 118679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 118682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118686 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 118697 */     // (st FPR128:{ *:[v2i64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 118700 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118712 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118716 */     GIR_RootConstrainSelectedInstOperands,
     /* 118717 */     // GIR_Coverage, 4471,
     /* 118717 */     GIR_EraseRootFromParent_Done,
     /* 118718 */   // Label 2241: @118718
     /* 118718 */   GIM_Try, /*On fail goto*//*Label 2242*/ GIMT_Encode4(118762), // Rule ID 4472 //
     /* 118723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 118726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118730 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 118741 */     // (st FPR128:{ *:[v2f64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 118744 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118756 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118760 */     GIR_RootConstrainSelectedInstOperands,
     /* 118761 */     // GIR_Coverage, 4472,
     /* 118761 */     GIR_EraseRootFromParent_Done,
     /* 118762 */   // Label 2242: @118762
     /* 118762 */   GIM_Try, /*On fail goto*//*Label 2243*/ GIMT_Encode4(118782), // Rule ID 6315 //
     /* 118767 */     // MIs[0] Rn
     /* 118767 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 118771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 118775 */     // (st v2i64:{ *:[v2i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev2d v2i64:{ *:[v2i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 118775 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev2d),
     /* 118780 */     GIR_RootConstrainSelectedInstOperands,
     /* 118781 */     // GIR_Coverage, 6315,
     /* 118781 */     GIR_Done,
     /* 118782 */   // Label 2243: @118782
     /* 118782 */   GIM_Reject,
     /* 118783 */ // Label 2233: @118783
     /* 118783 */ GIM_Reject,
     /* 118784 */ // Label 2067: @118784
     /* 118784 */ GIM_Try, /*On fail goto*//*Label 2244*/ GIMT_Encode4(119189),
     /* 118789 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118792 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118796 */   GIM_Try, /*On fail goto*//*Label 2245*/ GIMT_Encode4(118845), // Rule ID 4398 //
     /* 118801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 118804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118808 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 118819 */     // (st FPR64:{ *:[v4i16] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 118819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 118822 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118839 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118843 */     GIR_RootConstrainSelectedInstOperands,
     /* 118844 */     // GIR_Coverage, 4398,
     /* 118844 */     GIR_EraseRootFromParent_Done,
     /* 118845 */   // Label 2245: @118845
     /* 118845 */   GIM_Try, /*On fail goto*//*Label 2246*/ GIMT_Encode4(118894), // Rule ID 4399 //
     /* 118850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 118853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118857 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 118868 */     // (st FPR64:{ *:[v4i16] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 118868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 118871 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118888 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118892 */     GIR_RootConstrainSelectedInstOperands,
     /* 118893 */     // GIR_Coverage, 4399,
     /* 118893 */     GIR_EraseRootFromParent_Done,
     /* 118894 */   // Label 2246: @118894
     /* 118894 */   GIM_Try, /*On fail goto*//*Label 2247*/ GIMT_Encode4(118943), // Rule ID 4402 //
     /* 118899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 118902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118906 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 118917 */     // (st FPR64:{ *:[v4f16] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 118917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 118920 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118937 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118941 */     GIR_RootConstrainSelectedInstOperands,
     /* 118942 */     // GIR_Coverage, 4402,
     /* 118942 */     GIR_EraseRootFromParent_Done,
     /* 118943 */   // Label 2247: @118943
     /* 118943 */   GIM_Try, /*On fail goto*//*Label 2248*/ GIMT_Encode4(118992), // Rule ID 4403 //
     /* 118948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 118951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118955 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 118966 */     // (st FPR64:{ *:[v4f16] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 118966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 118969 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118986 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118990 */     GIR_RootConstrainSelectedInstOperands,
     /* 118991 */     // GIR_Coverage, 4403,
     /* 118991 */     GIR_EraseRootFromParent_Done,
     /* 118992 */   // Label 2248: @118992
     /* 118992 */   GIM_Try, /*On fail goto*//*Label 2249*/ GIMT_Encode4(119036), // Rule ID 4438 //
     /* 118997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 119000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119004 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 119015 */     // (st FPR64:{ *:[v4i16] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 119015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 119018 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119030 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119034 */     GIR_RootConstrainSelectedInstOperands,
     /* 119035 */     // GIR_Coverage, 4438,
     /* 119035 */     GIR_EraseRootFromParent_Done,
     /* 119036 */   // Label 2249: @119036
     /* 119036 */   GIM_Try, /*On fail goto*//*Label 2250*/ GIMT_Encode4(119080), // Rule ID 4440 //
     /* 119041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 119044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119048 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 119059 */     // (st FPR64:{ *:[v4f16] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 119059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 119062 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119074 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119078 */     GIR_RootConstrainSelectedInstOperands,
     /* 119079 */     // GIR_Coverage, 4440,
     /* 119079 */     GIR_EraseRootFromParent_Done,
     /* 119080 */   // Label 2250: @119080
     /* 119080 */   GIM_Try, /*On fail goto*//*Label 2251*/ GIMT_Encode4(119124), // Rule ID 4462 //
     /* 119085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 119088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119092 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 119103 */     // (st FPR64:{ *:[v4i16] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 119103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 119106 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119118 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119122 */     GIR_RootConstrainSelectedInstOperands,
     /* 119123 */     // GIR_Coverage, 4462,
     /* 119123 */     GIR_EraseRootFromParent_Done,
     /* 119124 */   // Label 2251: @119124
     /* 119124 */   GIM_Try, /*On fail goto*//*Label 2252*/ GIMT_Encode4(119168), // Rule ID 4464 //
     /* 119129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 119132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119136 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 119147 */     // (st FPR64:{ *:[v4f16] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 119147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 119150 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119162 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119166 */     GIR_RootConstrainSelectedInstOperands,
     /* 119167 */     // GIR_Coverage, 4464,
     /* 119167 */     GIR_EraseRootFromParent_Done,
     /* 119168 */   // Label 2252: @119168
     /* 119168 */   GIM_Try, /*On fail goto*//*Label 2253*/ GIMT_Encode4(119188), // Rule ID 6317 //
     /* 119173 */     // MIs[0] Rn
     /* 119173 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 119177 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 119181 */     // (st v4i16:{ *:[v4i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev4h v4i16:{ *:[v4i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 119181 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev4h),
     /* 119186 */     GIR_RootConstrainSelectedInstOperands,
     /* 119187 */     // GIR_Coverage, 6317,
     /* 119187 */     GIR_Done,
     /* 119188 */   // Label 2253: @119188
     /* 119188 */   GIM_Reject,
     /* 119189 */ // Label 2244: @119189
     /* 119189 */ GIM_Reject,
     /* 119190 */ // Label 2068: @119190
     /* 119190 */ GIM_Try, /*On fail goto*//*Label 2254*/ GIMT_Encode4(119595),
     /* 119195 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119198 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119202 */   GIM_Try, /*On fail goto*//*Label 2255*/ GIMT_Encode4(119251), // Rule ID 4412 //
     /* 119207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 119210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119214 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 119225 */     // (st FPR128:{ *:[v4i32] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 119225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 119228 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119245 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119249 */     GIR_RootConstrainSelectedInstOperands,
     /* 119250 */     // GIR_Coverage, 4412,
     /* 119250 */     GIR_EraseRootFromParent_Done,
     /* 119251 */   // Label 2255: @119251
     /* 119251 */   GIM_Try, /*On fail goto*//*Label 2256*/ GIMT_Encode4(119300), // Rule ID 4413 //
     /* 119256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 119259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119263 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 119274 */     // (st FPR128:{ *:[v4i32] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 119274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 119277 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119294 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119298 */     GIR_RootConstrainSelectedInstOperands,
     /* 119299 */     // GIR_Coverage, 4413,
     /* 119299 */     GIR_EraseRootFromParent_Done,
     /* 119300 */   // Label 2256: @119300
     /* 119300 */   GIM_Try, /*On fail goto*//*Label 2257*/ GIMT_Encode4(119349), // Rule ID 4414 //
     /* 119305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 119308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119312 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 119323 */     // (st FPR128:{ *:[v4f32] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 119323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 119326 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119343 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119347 */     GIR_RootConstrainSelectedInstOperands,
     /* 119348 */     // GIR_Coverage, 4414,
     /* 119348 */     GIR_EraseRootFromParent_Done,
     /* 119349 */   // Label 2257: @119349
     /* 119349 */   GIM_Try, /*On fail goto*//*Label 2258*/ GIMT_Encode4(119398), // Rule ID 4415 //
     /* 119354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 119357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119361 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 119372 */     // (st FPR128:{ *:[v4f32] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 119372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 119375 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119392 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119396 */     GIR_RootConstrainSelectedInstOperands,
     /* 119397 */     // GIR_Coverage, 4415,
     /* 119397 */     GIR_EraseRootFromParent_Done,
     /* 119398 */   // Label 2258: @119398
     /* 119398 */   GIM_Try, /*On fail goto*//*Label 2259*/ GIMT_Encode4(119442), // Rule ID 4442 //
     /* 119403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 119406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119410 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 119421 */     // (st FPR128:{ *:[v4f32] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 119421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 119424 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119436 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119440 */     GIR_RootConstrainSelectedInstOperands,
     /* 119441 */     // GIR_Coverage, 4442,
     /* 119441 */     GIR_EraseRootFromParent_Done,
     /* 119442 */   // Label 2259: @119442
     /* 119442 */   GIM_Try, /*On fail goto*//*Label 2260*/ GIMT_Encode4(119486), // Rule ID 4446 //
     /* 119447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 119450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119454 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 119465 */     // (st FPR128:{ *:[v4i32] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 119465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 119468 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119480 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119484 */     GIR_RootConstrainSelectedInstOperands,
     /* 119485 */     // GIR_Coverage, 4446,
     /* 119485 */     GIR_EraseRootFromParent_Done,
     /* 119486 */   // Label 2260: @119486
     /* 119486 */   GIM_Try, /*On fail goto*//*Label 2261*/ GIMT_Encode4(119530), // Rule ID 4466 //
     /* 119491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 119494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119498 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 119509 */     // (st FPR128:{ *:[v4f32] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 119509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 119512 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119524 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119528 */     GIR_RootConstrainSelectedInstOperands,
     /* 119529 */     // GIR_Coverage, 4466,
     /* 119529 */     GIR_EraseRootFromParent_Done,
     /* 119530 */   // Label 2261: @119530
     /* 119530 */   GIM_Try, /*On fail goto*//*Label 2262*/ GIMT_Encode4(119574), // Rule ID 4470 //
     /* 119535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 119538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119542 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 119553 */     // (st FPR128:{ *:[v4i32] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 119553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 119556 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119568 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119572 */     GIR_RootConstrainSelectedInstOperands,
     /* 119573 */     // GIR_Coverage, 4470,
     /* 119573 */     GIR_EraseRootFromParent_Done,
     /* 119574 */   // Label 2262: @119574
     /* 119574 */   GIM_Try, /*On fail goto*//*Label 2263*/ GIMT_Encode4(119594), // Rule ID 6314 //
     /* 119579 */     // MIs[0] Rn
     /* 119579 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 119583 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 119587 */     // (st v4i32:{ *:[v4i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev4s v4i32:{ *:[v4i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 119587 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev4s),
     /* 119592 */     GIR_RootConstrainSelectedInstOperands,
     /* 119593 */     // GIR_Coverage, 6314,
     /* 119593 */     GIR_Done,
     /* 119594 */   // Label 2263: @119594
     /* 119594 */   GIM_Reject,
     /* 119595 */ // Label 2254: @119595
     /* 119595 */ GIM_Reject,
     /* 119596 */ // Label 2069: @119596
     /* 119596 */ GIM_Try, /*On fail goto*//*Label 2264*/ GIMT_Encode4(119815),
     /* 119601 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119604 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119608 */   GIM_Try, /*On fail goto*//*Label 2265*/ GIMT_Encode4(119657), // Rule ID 4400 //
     /* 119613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 119616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119620 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 119631 */     // (st FPR64:{ *:[v8i8] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 119631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 119634 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119651 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119655 */     GIR_RootConstrainSelectedInstOperands,
     /* 119656 */     // GIR_Coverage, 4400,
     /* 119656 */     GIR_EraseRootFromParent_Done,
     /* 119657 */   // Label 2265: @119657
     /* 119657 */   GIM_Try, /*On fail goto*//*Label 2266*/ GIMT_Encode4(119706), // Rule ID 4401 //
     /* 119662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 119665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119669 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 119680 */     // (st FPR64:{ *:[v8i8] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 119680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 119683 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119700 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119704 */     GIR_RootConstrainSelectedInstOperands,
     /* 119705 */     // GIR_Coverage, 4401,
     /* 119705 */     GIR_EraseRootFromParent_Done,
     /* 119706 */   // Label 2266: @119706
     /* 119706 */   GIM_Try, /*On fail goto*//*Label 2267*/ GIMT_Encode4(119750), // Rule ID 4437 //
     /* 119711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 119714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119718 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 119729 */     // (st FPR64:{ *:[v8i8] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 119729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 119732 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119744 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119748 */     GIR_RootConstrainSelectedInstOperands,
     /* 119749 */     // GIR_Coverage, 4437,
     /* 119749 */     GIR_EraseRootFromParent_Done,
     /* 119750 */   // Label 2267: @119750
     /* 119750 */   GIM_Try, /*On fail goto*//*Label 2268*/ GIMT_Encode4(119794), // Rule ID 4461 //
     /* 119755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 119758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119762 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 119773 */     // (st FPR64:{ *:[v8i8] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 119773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 119776 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119788 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119792 */     GIR_RootConstrainSelectedInstOperands,
     /* 119793 */     // GIR_Coverage, 4461,
     /* 119793 */     GIR_EraseRootFromParent_Done,
     /* 119794 */   // Label 2268: @119794
     /* 119794 */   GIM_Try, /*On fail goto*//*Label 2269*/ GIMT_Encode4(119814), // Rule ID 6316 //
     /* 119799 */     // MIs[0] Rn
     /* 119799 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 119803 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 119807 */     // (st v8i8:{ *:[v8i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev8b v8i8:{ *:[v8i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 119807 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev8b),
     /* 119812 */     GIR_RootConstrainSelectedInstOperands,
     /* 119813 */     // GIR_Coverage, 6316,
     /* 119813 */     GIR_Done,
     /* 119814 */   // Label 2269: @119814
     /* 119814 */   GIM_Reject,
     /* 119815 */ // Label 2264: @119815
     /* 119815 */ GIM_Reject,
     /* 119816 */ // Label 2070: @119816
     /* 119816 */ GIM_Try, /*On fail goto*//*Label 2270*/ GIMT_Encode4(120221),
     /* 119821 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119824 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119828 */   GIM_Try, /*On fail goto*//*Label 2271*/ GIMT_Encode4(119877), // Rule ID 4416 //
     /* 119833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 119836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119840 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 119851 */     // (st FPR128:{ *:[v8i16] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 119851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 119854 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119871 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119875 */     GIR_RootConstrainSelectedInstOperands,
     /* 119876 */     // GIR_Coverage, 4416,
     /* 119876 */     GIR_EraseRootFromParent_Done,
     /* 119877 */   // Label 2271: @119877
     /* 119877 */   GIM_Try, /*On fail goto*//*Label 2272*/ GIMT_Encode4(119926), // Rule ID 4417 //
     /* 119882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 119885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119889 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 119900 */     // (st FPR128:{ *:[v8i16] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 119900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 119903 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119920 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119924 */     GIR_RootConstrainSelectedInstOperands,
     /* 119925 */     // GIR_Coverage, 4417,
     /* 119925 */     GIR_EraseRootFromParent_Done,
     /* 119926 */   // Label 2272: @119926
     /* 119926 */   GIM_Try, /*On fail goto*//*Label 2273*/ GIMT_Encode4(119975), // Rule ID 4420 //
     /* 119931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 119934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119938 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 119949 */     // (st FPR128:{ *:[v8f16] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 119949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 119952 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119969 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119973 */     GIR_RootConstrainSelectedInstOperands,
     /* 119974 */     // GIR_Coverage, 4420,
     /* 119974 */     GIR_EraseRootFromParent_Done,
     /* 119975 */   // Label 2273: @119975
     /* 119975 */   GIM_Try, /*On fail goto*//*Label 2274*/ GIMT_Encode4(120024), // Rule ID 4421 //
     /* 119980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 119983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119987 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 119998 */     // (st FPR128:{ *:[v8f16] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 119998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 120001 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120018 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120022 */     GIR_RootConstrainSelectedInstOperands,
     /* 120023 */     // GIR_Coverage, 4421,
     /* 120023 */     GIR_EraseRootFromParent_Done,
     /* 120024 */   // Label 2274: @120024
     /* 120024 */   GIM_Try, /*On fail goto*//*Label 2275*/ GIMT_Encode4(120068), // Rule ID 4445 //
     /* 120029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 120032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 120036 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 120047 */     // (st FPR128:{ *:[v8i16] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 120047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 120050 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120062 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120066 */     GIR_RootConstrainSelectedInstOperands,
     /* 120067 */     // GIR_Coverage, 4445,
     /* 120067 */     GIR_EraseRootFromParent_Done,
     /* 120068 */   // Label 2275: @120068
     /* 120068 */   GIM_Try, /*On fail goto*//*Label 2276*/ GIMT_Encode4(120112), // Rule ID 4448 //
     /* 120073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 120076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 120080 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 120091 */     // (st FPR128:{ *:[v8f16] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 120091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 120094 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120106 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120110 */     GIR_RootConstrainSelectedInstOperands,
     /* 120111 */     // GIR_Coverage, 4448,
     /* 120111 */     GIR_EraseRootFromParent_Done,
     /* 120112 */   // Label 2276: @120112
     /* 120112 */   GIM_Try, /*On fail goto*//*Label 2277*/ GIMT_Encode4(120156), // Rule ID 4469 //
     /* 120117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 120120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 120124 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 120135 */     // (st FPR128:{ *:[v8i16] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 120138 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120150 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120154 */     GIR_RootConstrainSelectedInstOperands,
     /* 120155 */     // GIR_Coverage, 4469,
     /* 120155 */     GIR_EraseRootFromParent_Done,
     /* 120156 */   // Label 2277: @120156
     /* 120156 */   GIM_Try, /*On fail goto*//*Label 2278*/ GIMT_Encode4(120200), // Rule ID 4473 //
     /* 120161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 120164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 120168 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 120179 */     // (st FPR128:{ *:[v8f16] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 120182 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120194 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120198 */     GIR_RootConstrainSelectedInstOperands,
     /* 120199 */     // GIR_Coverage, 4473,
     /* 120199 */     GIR_EraseRootFromParent_Done,
     /* 120200 */   // Label 2278: @120200
     /* 120200 */   GIM_Try, /*On fail goto*//*Label 2279*/ GIMT_Encode4(120220), // Rule ID 6313 //
     /* 120205 */     // MIs[0] Rn
     /* 120205 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 120213 */     // (st v8i16:{ *:[v8i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev8h v8i16:{ *:[v8i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 120213 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev8h),
     /* 120218 */     GIR_RootConstrainSelectedInstOperands,
     /* 120219 */     // GIR_Coverage, 6313,
     /* 120219 */     GIR_Done,
     /* 120220 */   // Label 2279: @120220
     /* 120220 */   GIM_Reject,
     /* 120221 */ // Label 2270: @120221
     /* 120221 */ GIM_Reject,
     /* 120222 */ // Label 2071: @120222
     /* 120222 */ GIM_Try, /*On fail goto*//*Label 2280*/ GIMT_Encode4(120441),
     /* 120227 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120230 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120234 */   GIM_Try, /*On fail goto*//*Label 2281*/ GIMT_Encode4(120283), // Rule ID 4418 //
     /* 120239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 120242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 120246 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 120257 */     // (st FPR128:{ *:[v16i8] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 120257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 120260 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120277 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120281 */     GIR_RootConstrainSelectedInstOperands,
     /* 120282 */     // GIR_Coverage, 4418,
     /* 120282 */     GIR_EraseRootFromParent_Done,
     /* 120283 */   // Label 2281: @120283
     /* 120283 */   GIM_Try, /*On fail goto*//*Label 2282*/ GIMT_Encode4(120332), // Rule ID 4419 //
     /* 120288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 120291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 120295 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 120306 */     // (st FPR128:{ *:[v16i8] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 120306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 120309 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120326 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120330 */     GIR_RootConstrainSelectedInstOperands,
     /* 120331 */     // GIR_Coverage, 4419,
     /* 120331 */     GIR_EraseRootFromParent_Done,
     /* 120332 */   // Label 2282: @120332
     /* 120332 */   GIM_Try, /*On fail goto*//*Label 2283*/ GIMT_Encode4(120376), // Rule ID 4444 //
     /* 120337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 120340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 120344 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 120355 */     // (st FPR128:{ *:[v16i8] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 120355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 120358 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120370 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120374 */     GIR_RootConstrainSelectedInstOperands,
     /* 120375 */     // GIR_Coverage, 4444,
     /* 120375 */     GIR_EraseRootFromParent_Done,
     /* 120376 */   // Label 2283: @120376
     /* 120376 */   GIM_Try, /*On fail goto*//*Label 2284*/ GIMT_Encode4(120420), // Rule ID 4468 //
     /* 120381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 120384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 120388 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 120399 */     // (st FPR128:{ *:[v16i8] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 120402 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120414 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120418 */     GIR_RootConstrainSelectedInstOperands,
     /* 120419 */     // GIR_Coverage, 4468,
     /* 120419 */     GIR_EraseRootFromParent_Done,
     /* 120420 */   // Label 2284: @120420
     /* 120420 */   GIM_Try, /*On fail goto*//*Label 2285*/ GIMT_Encode4(120440), // Rule ID 6312 //
     /* 120425 */     // MIs[0] Rn
     /* 120425 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 120433 */     // (st v16i8:{ *:[v16i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev16b v16i8:{ *:[v16i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 120433 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev16b),
     /* 120438 */     GIR_RootConstrainSelectedInstOperands,
     /* 120439 */     // GIR_Coverage, 6312,
     /* 120439 */     GIR_Done,
     /* 120440 */   // Label 2285: @120440
     /* 120440 */   GIM_Reject,
     /* 120441 */ // Label 2280: @120441
     /* 120441 */ GIM_Reject,
     /* 120442 */ // Label 2072: @120442
     /* 120442 */ GIM_Try, /*On fail goto*//*Label 2286*/ GIMT_Encode4(120501), // Rule ID 10706 //
     /* 120447 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 120450 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120453 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120457 */   // MIs[0] base
     /* 120457 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120461 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120465 */   // (st nxv2f16:{ *:[nxv2f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_D_IMM ZPR:{ *:[nxv2f16] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 120465 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 120468 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 120472 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120477 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 120480 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 120482 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_D_IMM),
     /* 120485 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 120487 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120490 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 120492 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120495 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120499 */   GIR_RootConstrainSelectedInstOperands,
     /* 120500 */   // GIR_Coverage, 10706,
     /* 120500 */   GIR_EraseRootFromParent_Done,
     /* 120501 */ // Label 2286: @120501
     /* 120501 */ GIM_Reject,
     /* 120502 */ // Label 2073: @120502
     /* 120502 */ GIM_Try, /*On fail goto*//*Label 2287*/ GIMT_Encode4(120561), // Rule ID 10712 //
     /* 120507 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 120510 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120513 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120517 */   // MIs[0] base
     /* 120517 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120521 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120525 */   // (st nxv2f32:{ *:[nxv2f32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_D_IMM ZPR:{ *:[nxv2f32] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 120525 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 120528 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 120532 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120537 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 120540 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 120542 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_D_IMM),
     /* 120545 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 120547 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120550 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 120552 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120555 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120559 */   GIR_RootConstrainSelectedInstOperands,
     /* 120560 */   // GIR_Coverage, 10712,
     /* 120560 */   GIR_EraseRootFromParent_Done,
     /* 120561 */ // Label 2287: @120561
     /* 120561 */ GIM_Reject,
     /* 120562 */ // Label 2074: @120562
     /* 120562 */ GIM_Try, /*On fail goto*//*Label 2288*/ GIMT_Encode4(120671),
     /* 120567 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120570 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120574 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120578 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120582 */   GIM_Try, /*On fail goto*//*Label 2289*/ GIMT_Encode4(120626), // Rule ID 10697 //
     /* 120587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 120590 */     // (st nxv2i64:{ *:[nxv2i64] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1D_IMM ZPR:{ *:[nxv2i64] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 120590 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 120593 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 120597 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120602 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 120605 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 120607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_IMM),
     /* 120610 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 120612 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120615 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 120617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120620 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120624 */     GIR_RootConstrainSelectedInstOperands,
     /* 120625 */     // GIR_Coverage, 10697,
     /* 120625 */     GIR_EraseRootFromParent_Done,
     /* 120626 */   // Label 2289: @120626
     /* 120626 */   GIM_Try, /*On fail goto*//*Label 2290*/ GIMT_Encode4(120670), // Rule ID 10715 //
     /* 120631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 120634 */     // (st nxv2f64:{ *:[nxv2f64] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1D_IMM ZPR:{ *:[nxv2f64] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 120634 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 120637 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 120641 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120646 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 120649 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 120651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_IMM),
     /* 120654 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 120656 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120659 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 120661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120664 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120668 */     GIR_RootConstrainSelectedInstOperands,
     /* 120669 */     // GIR_Coverage, 10715,
     /* 120669 */     GIR_EraseRootFromParent_Done,
     /* 120670 */   // Label 2290: @120670
     /* 120670 */   GIM_Reject,
     /* 120671 */ // Label 2288: @120671
     /* 120671 */ GIM_Reject,
     /* 120672 */ // Label 2075: @120672
     /* 120672 */ GIM_Try, /*On fail goto*//*Label 2291*/ GIMT_Encode4(120731), // Rule ID 10703 //
     /* 120677 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 120680 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120683 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120687 */   // MIs[0] base
     /* 120687 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120691 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120695 */   // (st nxv4f16:{ *:[nxv4f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_S_IMM ZPR:{ *:[nxv4f16] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 120695 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 120698 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 120702 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120707 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 120710 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 120712 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_S_IMM),
     /* 120715 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 120717 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120720 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 120722 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120725 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120729 */   GIR_RootConstrainSelectedInstOperands,
     /* 120730 */   // GIR_Coverage, 10703,
     /* 120730 */   GIR_EraseRootFromParent_Done,
     /* 120731 */ // Label 2291: @120731
     /* 120731 */ GIM_Reject,
     /* 120732 */ // Label 2076: @120732
     /* 120732 */ GIM_Try, /*On fail goto*//*Label 2292*/ GIMT_Encode4(120841),
     /* 120737 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120740 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120744 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120748 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120752 */   GIM_Try, /*On fail goto*//*Label 2293*/ GIMT_Encode4(120796), // Rule ID 10691 //
     /* 120757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 120760 */     // (st nxv4i32:{ *:[nxv4i32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_IMM ZPR:{ *:[nxv4i32] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 120760 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 120763 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 120767 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120772 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 120775 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 120777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_IMM),
     /* 120780 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 120782 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120785 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 120787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120790 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120794 */     GIR_RootConstrainSelectedInstOperands,
     /* 120795 */     // GIR_Coverage, 10691,
     /* 120795 */     GIR_EraseRootFromParent_Done,
     /* 120796 */   // Label 2293: @120796
     /* 120796 */   GIM_Try, /*On fail goto*//*Label 2294*/ GIMT_Encode4(120840), // Rule ID 10709 //
     /* 120801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 120804 */     // (st nxv4f32:{ *:[nxv4f32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_IMM ZPR:{ *:[nxv4f32] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 120804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 120807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 120811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120816 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 120819 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 120821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_IMM),
     /* 120824 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 120826 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120829 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 120831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120834 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120838 */     GIR_RootConstrainSelectedInstOperands,
     /* 120839 */     // GIR_Coverage, 10709,
     /* 120839 */     GIR_EraseRootFromParent_Done,
     /* 120840 */   // Label 2294: @120840
     /* 120840 */   GIM_Reject,
     /* 120841 */ // Label 2292: @120841
     /* 120841 */ GIM_Reject,
     /* 120842 */ // Label 2077: @120842
     /* 120842 */ GIM_Try, /*On fail goto*//*Label 2295*/ GIMT_Encode4(120951),
     /* 120847 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120850 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120854 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120858 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120862 */   GIM_Try, /*On fail goto*//*Label 2296*/ GIMT_Encode4(120906), // Rule ID 10682 //
     /* 120867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 120870 */     // (st nxv8i16:{ *:[nxv8i16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_IMM ZPR:{ *:[nxv8i16] }:$val, (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 120870 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 120873 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 120877 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120882 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 120885 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 120887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_IMM),
     /* 120890 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 120892 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120895 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 120897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120900 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120904 */     GIR_RootConstrainSelectedInstOperands,
     /* 120905 */     // GIR_Coverage, 10682,
     /* 120905 */     GIR_EraseRootFromParent_Done,
     /* 120906 */   // Label 2296: @120906
     /* 120906 */   GIM_Try, /*On fail goto*//*Label 2297*/ GIMT_Encode4(120950), // Rule ID 10700 //
     /* 120911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 120914 */     // (st nxv8f16:{ *:[nxv8f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_IMM ZPR:{ *:[nxv8f16] }:$val, (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 120914 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 120917 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 120921 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120926 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 120929 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 120931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_IMM),
     /* 120934 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 120936 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120939 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 120941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120944 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120948 */     GIR_RootConstrainSelectedInstOperands,
     /* 120949 */     // GIR_Coverage, 10700,
     /* 120949 */     GIR_EraseRootFromParent_Done,
     /* 120950 */   // Label 2297: @120950
     /* 120950 */   GIM_Reject,
     /* 120951 */ // Label 2295: @120951
     /* 120951 */ GIM_Reject,
     /* 120952 */ // Label 2078: @120952
     /* 120952 */ GIM_Try, /*On fail goto*//*Label 2298*/ GIMT_Encode4(120995), // Rule ID 2421 //
     /* 120957 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 120960 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120963 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 120971 */   // MIs[0] base
     /* 120971 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120975 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120979 */   // (st PPR:{ *:[nxv16i1] }:$Val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_PXI PPR:{ *:[nxv16i1] }:$Val, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 120979 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_PXI),
     /* 120982 */   GIR_RootToRootCopy, /*OpIdx*/0, // Val
     /* 120984 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 120986 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120989 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120993 */   GIR_RootConstrainSelectedInstOperands,
     /* 120994 */   // GIR_Coverage, 2421,
     /* 120994 */   GIR_EraseRootFromParent_Done,
     /* 120995 */ // Label 2298: @120995
     /* 120995 */ GIM_Reject,
     /* 120996 */ // Label 2079: @120996
     /* 120996 */ GIM_Try, /*On fail goto*//*Label 2299*/ GIMT_Encode4(121055), // Rule ID 10668 //
     /* 121001 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 121004 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121007 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121011 */   // MIs[0] base
     /* 121011 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121015 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121019 */   // (st nxv16i8:{ *:[nxv16i8] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1B_IMM ZPR:{ *:[nxv16i8] }:$val, (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 121019 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 121022 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /* 121026 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121031 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 121034 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 121036 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1B_IMM),
     /* 121039 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 121041 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121044 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 121046 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121049 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121053 */   GIR_RootConstrainSelectedInstOperands,
     /* 121054 */   // GIR_Coverage, 10668,
     /* 121054 */   GIR_EraseRootFromParent_Done,
     /* 121055 */ // Label 2299: @121055
     /* 121055 */ GIM_Reject,
     /* 121056 */ // Label 2080: @121056
     /* 121056 */ GIM_Reject,
     /* 121057 */ // Label 20: @121057
     /* 121057 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2302*/ GIMT_Encode4(122407),
     /* 121068 */ /*GILLT_s32*//*Label 2300*/ GIMT_Encode4(121076),
     /* 121072 */ /*GILLT_s64*//*Label 2301*/ GIMT_Encode4(122094),
     /* 121076 */ // Label 2300: @121076
     /* 121076 */ GIM_Try, /*On fail goto*//*Label 2303*/ GIMT_Encode4(122093),
     /* 121081 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 121084 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 121087 */   GIM_Try, /*On fail goto*//*Label 2304*/ GIMT_Encode4(121142), // Rule ID 7214 //
     /* 121092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 121095 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 121102 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 121105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121109 */     // MIs[0] Rn
     /* 121109 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121125 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (CASW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 121125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASW),
     /* 121128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 121130 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 121132 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 121134 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 121136 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121140 */     GIR_RootConstrainSelectedInstOperands,
     /* 121141 */     // GIR_Coverage, 7214,
     /* 121141 */     GIR_EraseRootFromParent_Done,
     /* 121142 */   // Label 2304: @121142
     /* 121142 */   GIM_Try, /*On fail goto*//*Label 2305*/ GIMT_Encode4(121197), // Rule ID 7215 //
     /* 121147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 121150 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 121157 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 121160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121164 */     // MIs[0] Rn
     /* 121164 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121168 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121180 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (CASAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 121180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAW),
     /* 121183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 121185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 121187 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 121189 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 121191 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121195 */     GIR_RootConstrainSelectedInstOperands,
     /* 121196 */     // GIR_Coverage, 7215,
     /* 121196 */     GIR_EraseRootFromParent_Done,
     /* 121197 */   // Label 2305: @121197
     /* 121197 */   GIM_Try, /*On fail goto*//*Label 2306*/ GIMT_Encode4(121252), // Rule ID 7216 //
     /* 121202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 121205 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 121212 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 121215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121219 */     // MIs[0] Rn
     /* 121219 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121235 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (CASLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 121235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLW),
     /* 121238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 121240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 121242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 121244 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 121246 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121250 */     GIR_RootConstrainSelectedInstOperands,
     /* 121251 */     // GIR_Coverage, 7216,
     /* 121251 */     GIR_EraseRootFromParent_Done,
     /* 121252 */   // Label 2306: @121252
     /* 121252 */   GIM_Try, /*On fail goto*//*Label 2307*/ GIMT_Encode4(121307), // Rule ID 7217 //
     /* 121257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 121260 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 121267 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 121270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121274 */     // MIs[0] Rn
     /* 121274 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121278 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121290 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (CASALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 121290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALW),
     /* 121293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 121295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 121297 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 121299 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 121301 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121305 */     GIR_RootConstrainSelectedInstOperands,
     /* 121306 */     // GIR_Coverage, 7217,
     /* 121306 */     GIR_EraseRootFromParent_Done,
     /* 121307 */   // Label 2307: @121307
     /* 121307 */   GIM_Try, /*On fail goto*//*Label 2308*/ GIMT_Encode4(121362), // Rule ID 7218 //
     /* 121312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 121315 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 121322 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 121325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121329 */     // MIs[0] Rn
     /* 121329 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121345 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (CASALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 121345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALW),
     /* 121348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 121350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 121352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 121354 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 121356 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121360 */     GIR_RootConstrainSelectedInstOperands,
     /* 121361 */     // GIR_Coverage, 7218,
     /* 121361 */     GIR_EraseRootFromParent_Done,
     /* 121362 */   // Label 2308: @121362
     /* 121362 */   GIM_Try, /*On fail goto*//*Label 2309*/ GIMT_Encode4(121417), // Rule ID 7219 //
     /* 121367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 121370 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 121377 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 121380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121384 */     // MIs[0] Rn
     /* 121384 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121388 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121400 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_monotonic>>  =>  (CASH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 121400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASH),
     /* 121403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 121405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 121407 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 121409 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 121411 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121415 */     GIR_RootConstrainSelectedInstOperands,
     /* 121416 */     // GIR_Coverage, 7219,
     /* 121416 */     GIR_EraseRootFromParent_Done,
     /* 121417 */   // Label 2309: @121417
     /* 121417 */   GIM_Try, /*On fail goto*//*Label 2310*/ GIMT_Encode4(121472), // Rule ID 7220 //
     /* 121422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 121425 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 121432 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 121435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121439 */     // MIs[0] Rn
     /* 121439 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121455 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acquire>>  =>  (CASAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 121455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAH),
     /* 121458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 121460 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 121462 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 121464 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 121466 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121470 */     GIR_RootConstrainSelectedInstOperands,
     /* 121471 */     // GIR_Coverage, 7220,
     /* 121471 */     GIR_EraseRootFromParent_Done,
     /* 121472 */   // Label 2310: @121472
     /* 121472 */   GIM_Try, /*On fail goto*//*Label 2311*/ GIMT_Encode4(121527), // Rule ID 7221 //
     /* 121477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 121480 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 121487 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 121490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121494 */     // MIs[0] Rn
     /* 121494 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121498 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121510 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_release>>  =>  (CASLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 121510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLH),
     /* 121513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 121515 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 121517 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 121519 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 121521 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121525 */     GIR_RootConstrainSelectedInstOperands,
     /* 121526 */     // GIR_Coverage, 7221,
     /* 121526 */     GIR_EraseRootFromParent_Done,
     /* 121527 */   // Label 2311: @121527
     /* 121527 */   GIM_Try, /*On fail goto*//*Label 2312*/ GIMT_Encode4(121582), // Rule ID 7222 //
     /* 121532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 121535 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 121542 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 121545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121549 */     // MIs[0] Rn
     /* 121549 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121553 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121565 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acq_rel>>  =>  (CASALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 121565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALH),
     /* 121568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 121570 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 121572 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 121574 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 121576 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121580 */     GIR_RootConstrainSelectedInstOperands,
     /* 121581 */     // GIR_Coverage, 7222,
     /* 121581 */     GIR_EraseRootFromParent_Done,
     /* 121582 */   // Label 2312: @121582
     /* 121582 */   GIM_Try, /*On fail goto*//*Label 2313*/ GIMT_Encode4(121637), // Rule ID 7223 //
     /* 121587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 121590 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 121597 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 121600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121604 */     // MIs[0] Rn
     /* 121604 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121608 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121620 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_seq_cst>>  =>  (CASALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 121620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALH),
     /* 121623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 121625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 121627 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 121629 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 121631 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121635 */     GIR_RootConstrainSelectedInstOperands,
     /* 121636 */     // GIR_Coverage, 7223,
     /* 121636 */     GIR_EraseRootFromParent_Done,
     /* 121637 */   // Label 2313: @121637
     /* 121637 */   GIM_Try, /*On fail goto*//*Label 2314*/ GIMT_Encode4(121692), // Rule ID 7224 //
     /* 121642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 121645 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 121652 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 121655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121659 */     // MIs[0] Rn
     /* 121659 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121663 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121675 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_monotonic>>  =>  (CASB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 121675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASB),
     /* 121678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 121680 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 121682 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 121684 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 121686 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121690 */     GIR_RootConstrainSelectedInstOperands,
     /* 121691 */     // GIR_Coverage, 7224,
     /* 121691 */     GIR_EraseRootFromParent_Done,
     /* 121692 */   // Label 2314: @121692
     /* 121692 */   GIM_Try, /*On fail goto*//*Label 2315*/ GIMT_Encode4(121747), // Rule ID 7225 //
     /* 121697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 121700 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 121707 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 121710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121714 */     // MIs[0] Rn
     /* 121714 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121730 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acquire>>  =>  (CASAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 121730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAB),
     /* 121733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 121735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 121737 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 121739 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 121741 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121745 */     GIR_RootConstrainSelectedInstOperands,
     /* 121746 */     // GIR_Coverage, 7225,
     /* 121746 */     GIR_EraseRootFromParent_Done,
     /* 121747 */   // Label 2315: @121747
     /* 121747 */   GIM_Try, /*On fail goto*//*Label 2316*/ GIMT_Encode4(121802), // Rule ID 7226 //
     /* 121752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 121755 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 121762 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 121765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121769 */     // MIs[0] Rn
     /* 121769 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121785 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_release>>  =>  (CASLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 121785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLB),
     /* 121788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 121790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 121792 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 121794 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 121796 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121800 */     GIR_RootConstrainSelectedInstOperands,
     /* 121801 */     // GIR_Coverage, 7226,
     /* 121801 */     GIR_EraseRootFromParent_Done,
     /* 121802 */   // Label 2316: @121802
     /* 121802 */   GIM_Try, /*On fail goto*//*Label 2317*/ GIMT_Encode4(121857), // Rule ID 7227 //
     /* 121807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 121810 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 121817 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 121820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121824 */     // MIs[0] Rn
     /* 121824 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121828 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121840 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acq_rel>>  =>  (CASALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 121840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALB),
     /* 121843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 121845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 121847 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 121849 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 121851 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121855 */     GIR_RootConstrainSelectedInstOperands,
     /* 121856 */     // GIR_Coverage, 7227,
     /* 121856 */     GIR_EraseRootFromParent_Done,
     /* 121857 */   // Label 2317: @121857
     /* 121857 */   GIM_Try, /*On fail goto*//*Label 2318*/ GIMT_Encode4(121912), // Rule ID 7228 //
     /* 121862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 121865 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 121872 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 121875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121879 */     // MIs[0] Rn
     /* 121879 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121883 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121895 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_seq_cst>>  =>  (CASALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 121895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALB),
     /* 121898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 121900 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 121902 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 121904 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 121906 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121910 */     GIR_RootConstrainSelectedInstOperands,
     /* 121911 */     // GIR_Coverage, 7228,
     /* 121911 */     GIR_EraseRootFromParent_Done,
     /* 121912 */   // Label 2318: @121912
     /* 121912 */   GIM_Try, /*On fail goto*//*Label 2319*/ GIMT_Encode4(121972), // Rule ID 12834 //
     /* 121917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 121920 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 121927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121931 */     // MIs[0] addr
     /* 121931 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121935 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121947 */     // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>>  =>  (CMP_SWAP_8:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
     /* 121947 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_8),
     /* 121953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 121955 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 121960 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 121962 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 121964 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 121966 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121970 */     GIR_RootConstrainSelectedInstOperands,
     /* 121971 */     // GIR_Coverage, 12834,
     /* 121971 */     GIR_EraseRootFromParent_Done,
     /* 121972 */   // Label 2319: @121972
     /* 121972 */   GIM_Try, /*On fail goto*//*Label 2320*/ GIMT_Encode4(122032), // Rule ID 12835 //
     /* 121977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 121980 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 121987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121991 */     // MIs[0] addr
     /* 121991 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122007 */     // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>>  =>  (CMP_SWAP_16:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
     /* 122007 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_16),
     /* 122013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 122015 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 122020 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 122022 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 122024 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 122026 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122030 */     GIR_RootConstrainSelectedInstOperands,
     /* 122031 */     // GIR_Coverage, 12835,
     /* 122031 */     GIR_EraseRootFromParent_Done,
     /* 122032 */   // Label 2320: @122032
     /* 122032 */   GIM_Try, /*On fail goto*//*Label 2321*/ GIMT_Encode4(122092), // Rule ID 12836 //
     /* 122037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 122040 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 122047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122051 */     // MIs[0] addr
     /* 122051 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122055 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122067 */     // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>>  =>  (CMP_SWAP_32:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
     /* 122067 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_32),
     /* 122073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 122075 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 122080 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 122082 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 122084 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 122086 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122090 */     GIR_RootConstrainSelectedInstOperands,
     /* 122091 */     // GIR_Coverage, 12836,
     /* 122091 */     GIR_EraseRootFromParent_Done,
     /* 122092 */   // Label 2321: @122092
     /* 122092 */   GIM_Reject,
     /* 122093 */ // Label 2303: @122093
     /* 122093 */ GIM_Reject,
     /* 122094 */ // Label 2301: @122094
     /* 122094 */ GIM_Try, /*On fail goto*//*Label 2322*/ GIMT_Encode4(122406),
     /* 122099 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 122102 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 122105 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 122112 */   GIM_Try, /*On fail goto*//*Label 2323*/ GIMT_Encode4(122160), // Rule ID 2575 //
     /* 122117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 122120 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 122123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122127 */     // MIs[0] Rn
     /* 122127 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122131 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122143 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_monotonic>>  =>  (CASX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 122143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASX),
     /* 122146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 122148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 122150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 122152 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122154 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122158 */     GIR_RootConstrainSelectedInstOperands,
     /* 122159 */     // GIR_Coverage, 2575,
     /* 122159 */     GIR_EraseRootFromParent_Done,
     /* 122160 */   // Label 2323: @122160
     /* 122160 */   GIM_Try, /*On fail goto*//*Label 2324*/ GIMT_Encode4(122208), // Rule ID 2576 //
     /* 122165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 122168 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 122171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122175 */     // MIs[0] Rn
     /* 122175 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122179 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122191 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acquire>>  =>  (CASAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 122191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAX),
     /* 122194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 122196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 122198 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 122200 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122202 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122206 */     GIR_RootConstrainSelectedInstOperands,
     /* 122207 */     // GIR_Coverage, 2576,
     /* 122207 */     GIR_EraseRootFromParent_Done,
     /* 122208 */   // Label 2324: @122208
     /* 122208 */   GIM_Try, /*On fail goto*//*Label 2325*/ GIMT_Encode4(122256), // Rule ID 2577 //
     /* 122213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 122216 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 122219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122223 */     // MIs[0] Rn
     /* 122223 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122227 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122239 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_release>>  =>  (CASLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 122239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLX),
     /* 122242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 122244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 122246 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 122248 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122250 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122254 */     GIR_RootConstrainSelectedInstOperands,
     /* 122255 */     // GIR_Coverage, 2577,
     /* 122255 */     GIR_EraseRootFromParent_Done,
     /* 122256 */   // Label 2325: @122256
     /* 122256 */   GIM_Try, /*On fail goto*//*Label 2326*/ GIMT_Encode4(122304), // Rule ID 2578 //
     /* 122261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 122264 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 122267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122271 */     // MIs[0] Rn
     /* 122271 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122275 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122287 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acq_rel>>  =>  (CASALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 122287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALX),
     /* 122290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 122292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 122294 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 122296 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122298 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122302 */     GIR_RootConstrainSelectedInstOperands,
     /* 122303 */     // GIR_Coverage, 2578,
     /* 122303 */     GIR_EraseRootFromParent_Done,
     /* 122304 */   // Label 2326: @122304
     /* 122304 */   GIM_Try, /*On fail goto*//*Label 2327*/ GIMT_Encode4(122352), // Rule ID 2579 //
     /* 122309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 122312 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 122315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122319 */     // MIs[0] Rn
     /* 122319 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122323 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122335 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_seq_cst>>  =>  (CASALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 122335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALX),
     /* 122338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 122340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 122342 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 122344 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122346 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122350 */     GIR_RootConstrainSelectedInstOperands,
     /* 122351 */     // GIR_Coverage, 2579,
     /* 122351 */     GIR_EraseRootFromParent_Done,
     /* 122352 */   // Label 2327: @122352
     /* 122352 */   GIM_Try, /*On fail goto*//*Label 2328*/ GIMT_Encode4(122405), // Rule ID 12837 //
     /* 122357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 122360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122364 */     // MIs[0] addr
     /* 122364 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122368 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122380 */     // (atomic_cmp_swap:{ *:[i64] } GPR64:{ *:[i64] }:$addr, GPR64:{ *:[i64] }:$desired, GPR64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>>  =>  (CMP_SWAP_64:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR64:{ *:[i64] }:$desired, GPR64:{ *:[i64] }:$new)
     /* 122380 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_64),
     /* 122386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 122388 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 122393 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 122395 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 122397 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 122399 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122403 */     GIR_RootConstrainSelectedInstOperands,
     /* 122404 */     // GIR_Coverage, 12837,
     /* 122404 */     GIR_EraseRootFromParent_Done,
     /* 122405 */   // Label 2328: @122405
     /* 122405 */   GIM_Reject,
     /* 122406 */ // Label 2322: @122406
     /* 122406 */ GIM_Reject,
     /* 122407 */ // Label 2302: @122407
     /* 122407 */ GIM_Reject,
     /* 122408 */ // Label 21: @122408
     /* 122408 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2331*/ GIMT_Encode4(123399),
     /* 122419 */ /*GILLT_s32*//*Label 2329*/ GIMT_Encode4(122427),
     /* 122423 */ /*GILLT_s64*//*Label 2330*/ GIMT_Encode4(123172),
     /* 122427 */ // Label 2329: @122427
     /* 122427 */ GIM_Try, /*On fail goto*//*Label 2332*/ GIMT_Encode4(123171),
     /* 122432 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 122435 */   GIM_Try, /*On fail goto*//*Label 2333*/ GIMT_Encode4(122484), // Rule ID 7199 //
     /* 122440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 122443 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 122450 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 122453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122457 */     // MIs[0] Rn
     /* 122457 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122461 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122469 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_monotonic>>  =>  (SWPW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 122469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPW),
     /* 122472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122474 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 122476 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122478 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122482 */     GIR_RootConstrainSelectedInstOperands,
     /* 122483 */     // GIR_Coverage, 7199,
     /* 122483 */     GIR_EraseRootFromParent_Done,
     /* 122484 */   // Label 2333: @122484
     /* 122484 */   GIM_Try, /*On fail goto*//*Label 2334*/ GIMT_Encode4(122533), // Rule ID 7200 //
     /* 122489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 122492 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 122499 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 122502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122506 */     // MIs[0] Rn
     /* 122506 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122510 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122518 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acquire>>  =>  (SWPAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 122518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAW),
     /* 122521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122523 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 122525 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122527 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122531 */     GIR_RootConstrainSelectedInstOperands,
     /* 122532 */     // GIR_Coverage, 7200,
     /* 122532 */     GIR_EraseRootFromParent_Done,
     /* 122533 */   // Label 2334: @122533
     /* 122533 */   GIM_Try, /*On fail goto*//*Label 2335*/ GIMT_Encode4(122582), // Rule ID 7201 //
     /* 122538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 122541 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 122548 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 122551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122555 */     // MIs[0] Rn
     /* 122555 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122567 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_release>>  =>  (SWPLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 122567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLW),
     /* 122570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 122574 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122576 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122580 */     GIR_RootConstrainSelectedInstOperands,
     /* 122581 */     // GIR_Coverage, 7201,
     /* 122581 */     GIR_EraseRootFromParent_Done,
     /* 122582 */   // Label 2335: @122582
     /* 122582 */   GIM_Try, /*On fail goto*//*Label 2336*/ GIMT_Encode4(122631), // Rule ID 7202 //
     /* 122587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 122590 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 122597 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 122600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122604 */     // MIs[0] Rn
     /* 122604 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122608 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122616 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acq_rel>>  =>  (SWPALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 122616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALW),
     /* 122619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 122623 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122625 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122629 */     GIR_RootConstrainSelectedInstOperands,
     /* 122630 */     // GIR_Coverage, 7202,
     /* 122630 */     GIR_EraseRootFromParent_Done,
     /* 122631 */   // Label 2336: @122631
     /* 122631 */   GIM_Try, /*On fail goto*//*Label 2337*/ GIMT_Encode4(122680), // Rule ID 7203 //
     /* 122636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 122639 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 122646 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 122649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122653 */     // MIs[0] Rn
     /* 122653 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122657 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122665 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_seq_cst>>  =>  (SWPALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 122665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALW),
     /* 122668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122670 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 122672 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122674 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122678 */     GIR_RootConstrainSelectedInstOperands,
     /* 122679 */     // GIR_Coverage, 7203,
     /* 122679 */     GIR_EraseRootFromParent_Done,
     /* 122680 */   // Label 2337: @122680
     /* 122680 */   GIM_Try, /*On fail goto*//*Label 2338*/ GIMT_Encode4(122729), // Rule ID 7204 //
     /* 122685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 122688 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 122695 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 122698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122702 */     // MIs[0] Rn
     /* 122702 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122714 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_monotonic>>  =>  (SWPH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 122714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPH),
     /* 122717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 122721 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122723 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122727 */     GIR_RootConstrainSelectedInstOperands,
     /* 122728 */     // GIR_Coverage, 7204,
     /* 122728 */     GIR_EraseRootFromParent_Done,
     /* 122729 */   // Label 2338: @122729
     /* 122729 */   GIM_Try, /*On fail goto*//*Label 2339*/ GIMT_Encode4(122778), // Rule ID 7205 //
     /* 122734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 122737 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 122744 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 122747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122751 */     // MIs[0] Rn
     /* 122751 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122755 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122763 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acquire>>  =>  (SWPAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 122763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAH),
     /* 122766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122768 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 122770 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122772 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122776 */     GIR_RootConstrainSelectedInstOperands,
     /* 122777 */     // GIR_Coverage, 7205,
     /* 122777 */     GIR_EraseRootFromParent_Done,
     /* 122778 */   // Label 2339: @122778
     /* 122778 */   GIM_Try, /*On fail goto*//*Label 2340*/ GIMT_Encode4(122827), // Rule ID 7206 //
     /* 122783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 122786 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 122793 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 122796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122800 */     // MIs[0] Rn
     /* 122800 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122812 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_release>>  =>  (SWPLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 122812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLH),
     /* 122815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 122819 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122821 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122825 */     GIR_RootConstrainSelectedInstOperands,
     /* 122826 */     // GIR_Coverage, 7206,
     /* 122826 */     GIR_EraseRootFromParent_Done,
     /* 122827 */   // Label 2340: @122827
     /* 122827 */   GIM_Try, /*On fail goto*//*Label 2341*/ GIMT_Encode4(122876), // Rule ID 7207 //
     /* 122832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 122835 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 122842 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 122845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122849 */     // MIs[0] Rn
     /* 122849 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122861 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acq_rel>>  =>  (SWPALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 122861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALH),
     /* 122864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 122868 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122870 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122874 */     GIR_RootConstrainSelectedInstOperands,
     /* 122875 */     // GIR_Coverage, 7207,
     /* 122875 */     GIR_EraseRootFromParent_Done,
     /* 122876 */   // Label 2341: @122876
     /* 122876 */   GIM_Try, /*On fail goto*//*Label 2342*/ GIMT_Encode4(122925), // Rule ID 7208 //
     /* 122881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 122884 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 122891 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 122894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122898 */     // MIs[0] Rn
     /* 122898 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122910 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_seq_cst>>  =>  (SWPALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 122910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALH),
     /* 122913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122915 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 122917 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122919 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122923 */     GIR_RootConstrainSelectedInstOperands,
     /* 122924 */     // GIR_Coverage, 7208,
     /* 122924 */     GIR_EraseRootFromParent_Done,
     /* 122925 */   // Label 2342: @122925
     /* 122925 */   GIM_Try, /*On fail goto*//*Label 2343*/ GIMT_Encode4(122974), // Rule ID 7209 //
     /* 122930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 122933 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 122940 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 122943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122947 */     // MIs[0] Rn
     /* 122947 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122951 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122959 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_monotonic>>  =>  (SWPB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 122959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPB),
     /* 122962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122964 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 122966 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 122968 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122972 */     GIR_RootConstrainSelectedInstOperands,
     /* 122973 */     // GIR_Coverage, 7209,
     /* 122973 */     GIR_EraseRootFromParent_Done,
     /* 122974 */   // Label 2343: @122974
     /* 122974 */   GIM_Try, /*On fail goto*//*Label 2344*/ GIMT_Encode4(123023), // Rule ID 7210 //
     /* 122979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 122982 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 122989 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 122992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122996 */     // MIs[0] Rn
     /* 122996 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123008 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acquire>>  =>  (SWPAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAB),
     /* 123011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123015 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123017 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123021 */     GIR_RootConstrainSelectedInstOperands,
     /* 123022 */     // GIR_Coverage, 7210,
     /* 123022 */     GIR_EraseRootFromParent_Done,
     /* 123023 */   // Label 2344: @123023
     /* 123023 */   GIM_Try, /*On fail goto*//*Label 2345*/ GIMT_Encode4(123072), // Rule ID 7211 //
     /* 123028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123031 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 123038 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 123041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123045 */     // MIs[0] Rn
     /* 123045 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123049 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123057 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_release>>  =>  (SWPLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLB),
     /* 123060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123064 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123066 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123070 */     GIR_RootConstrainSelectedInstOperands,
     /* 123071 */     // GIR_Coverage, 7211,
     /* 123071 */     GIR_EraseRootFromParent_Done,
     /* 123072 */   // Label 2345: @123072
     /* 123072 */   GIM_Try, /*On fail goto*//*Label 2346*/ GIMT_Encode4(123121), // Rule ID 7212 //
     /* 123077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123080 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 123087 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 123090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123094 */     // MIs[0] Rn
     /* 123094 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123098 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123106 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acq_rel>>  =>  (SWPALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALB),
     /* 123109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123111 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123113 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123115 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123119 */     GIR_RootConstrainSelectedInstOperands,
     /* 123120 */     // GIR_Coverage, 7212,
     /* 123120 */     GIR_EraseRootFromParent_Done,
     /* 123121 */   // Label 2346: @123121
     /* 123121 */   GIM_Try, /*On fail goto*//*Label 2347*/ GIMT_Encode4(123170), // Rule ID 7213 //
     /* 123126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123129 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 123136 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 123139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123143 */     // MIs[0] Rn
     /* 123143 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123147 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123155 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_seq_cst>>  =>  (SWPALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALB),
     /* 123158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123162 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123164 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123168 */     GIR_RootConstrainSelectedInstOperands,
     /* 123169 */     // GIR_Coverage, 7213,
     /* 123169 */     GIR_EraseRootFromParent_Done,
     /* 123170 */   // Label 2347: @123170
     /* 123170 */   GIM_Reject,
     /* 123171 */ // Label 2332: @123171
     /* 123171 */ GIM_Reject,
     /* 123172 */ // Label 2330: @123172
     /* 123172 */ GIM_Try, /*On fail goto*//*Label 2348*/ GIMT_Encode4(123398),
     /* 123177 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 123180 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 123187 */   GIM_Try, /*On fail goto*//*Label 2349*/ GIMT_Encode4(123229), // Rule ID 7194 //
     /* 123192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123195 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 123198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123202 */     // MIs[0] Rn
     /* 123202 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123214 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_monotonic>>  =>  (SWPX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPX),
     /* 123217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123219 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123221 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123223 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123227 */     GIR_RootConstrainSelectedInstOperands,
     /* 123228 */     // GIR_Coverage, 7194,
     /* 123228 */     GIR_EraseRootFromParent_Done,
     /* 123229 */   // Label 2349: @123229
     /* 123229 */   GIM_Try, /*On fail goto*//*Label 2350*/ GIMT_Encode4(123271), // Rule ID 7195 //
     /* 123234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123237 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 123240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123244 */     // MIs[0] Rn
     /* 123244 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123248 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123256 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acquire>>  =>  (SWPAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAX),
     /* 123259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123263 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123265 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123269 */     GIR_RootConstrainSelectedInstOperands,
     /* 123270 */     // GIR_Coverage, 7195,
     /* 123270 */     GIR_EraseRootFromParent_Done,
     /* 123271 */   // Label 2350: @123271
     /* 123271 */   GIM_Try, /*On fail goto*//*Label 2351*/ GIMT_Encode4(123313), // Rule ID 7196 //
     /* 123276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123279 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 123282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123286 */     // MIs[0] Rn
     /* 123286 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123290 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123298 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_release>>  =>  (SWPLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLX),
     /* 123301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123305 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123307 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123311 */     GIR_RootConstrainSelectedInstOperands,
     /* 123312 */     // GIR_Coverage, 7196,
     /* 123312 */     GIR_EraseRootFromParent_Done,
     /* 123313 */   // Label 2351: @123313
     /* 123313 */   GIM_Try, /*On fail goto*//*Label 2352*/ GIMT_Encode4(123355), // Rule ID 7197 //
     /* 123318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123321 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 123324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123328 */     // MIs[0] Rn
     /* 123328 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123332 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123340 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acq_rel>>  =>  (SWPALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALX),
     /* 123343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123347 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123349 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123353 */     GIR_RootConstrainSelectedInstOperands,
     /* 123354 */     // GIR_Coverage, 7197,
     /* 123354 */     GIR_EraseRootFromParent_Done,
     /* 123355 */   // Label 2352: @123355
     /* 123355 */   GIM_Try, /*On fail goto*//*Label 2353*/ GIMT_Encode4(123397), // Rule ID 7198 //
     /* 123360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123363 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 123366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123370 */     // MIs[0] Rn
     /* 123370 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123382 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_seq_cst>>  =>  (SWPALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALX),
     /* 123385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123389 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123391 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123395 */     GIR_RootConstrainSelectedInstOperands,
     /* 123396 */     // GIR_Coverage, 7198,
     /* 123396 */     GIR_EraseRootFromParent_Done,
     /* 123397 */   // Label 2353: @123397
     /* 123397 */   GIM_Reject,
     /* 123398 */ // Label 2348: @123398
     /* 123398 */ GIM_Reject,
     /* 123399 */ // Label 2331: @123399
     /* 123399 */ GIM_Reject,
     /* 123400 */ // Label 22: @123400
     /* 123400 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2356*/ GIMT_Encode4(124391),
     /* 123411 */ /*GILLT_s32*//*Label 2354*/ GIMT_Encode4(123419),
     /* 123415 */ /*GILLT_s64*//*Label 2355*/ GIMT_Encode4(124164),
     /* 123419 */ // Label 2354: @123419
     /* 123419 */ GIM_Try, /*On fail goto*//*Label 2357*/ GIMT_Encode4(124163),
     /* 123424 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 123427 */   GIM_Try, /*On fail goto*//*Label 2358*/ GIMT_Encode4(123476), // Rule ID 7039 //
     /* 123432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123435 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 123442 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 123445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123449 */     // MIs[0] Rn
     /* 123449 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123461 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_monotonic>>  =>  (LDADDW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDW),
     /* 123464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123466 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123468 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123470 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123474 */     GIR_RootConstrainSelectedInstOperands,
     /* 123475 */     // GIR_Coverage, 7039,
     /* 123475 */     GIR_EraseRootFromParent_Done,
     /* 123476 */   // Label 2358: @123476
     /* 123476 */   GIM_Try, /*On fail goto*//*Label 2359*/ GIMT_Encode4(123525), // Rule ID 7040 //
     /* 123481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123484 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 123491 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 123494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123498 */     // MIs[0] Rn
     /* 123498 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123510 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acquire>>  =>  (LDADDAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAW),
     /* 123513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123515 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123517 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123519 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123523 */     GIR_RootConstrainSelectedInstOperands,
     /* 123524 */     // GIR_Coverage, 7040,
     /* 123524 */     GIR_EraseRootFromParent_Done,
     /* 123525 */   // Label 2359: @123525
     /* 123525 */   GIM_Try, /*On fail goto*//*Label 2360*/ GIMT_Encode4(123574), // Rule ID 7041 //
     /* 123530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123533 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 123540 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 123543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123547 */     // MIs[0] Rn
     /* 123547 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123559 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_release>>  =>  (LDADDLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLW),
     /* 123562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123566 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123568 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123572 */     GIR_RootConstrainSelectedInstOperands,
     /* 123573 */     // GIR_Coverage, 7041,
     /* 123573 */     GIR_EraseRootFromParent_Done,
     /* 123574 */   // Label 2360: @123574
     /* 123574 */   GIM_Try, /*On fail goto*//*Label 2361*/ GIMT_Encode4(123623), // Rule ID 7042 //
     /* 123579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123582 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 123589 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 123592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123596 */     // MIs[0] Rn
     /* 123596 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123600 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123608 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acq_rel>>  =>  (LDADDALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 123611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123615 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123617 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123621 */     GIR_RootConstrainSelectedInstOperands,
     /* 123622 */     // GIR_Coverage, 7042,
     /* 123622 */     GIR_EraseRootFromParent_Done,
     /* 123623 */   // Label 2361: @123623
     /* 123623 */   GIM_Try, /*On fail goto*//*Label 2362*/ GIMT_Encode4(123672), // Rule ID 7043 //
     /* 123628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123631 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 123638 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 123641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123645 */     // MIs[0] Rn
     /* 123645 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123657 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_seq_cst>>  =>  (LDADDALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 123660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123664 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123666 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123670 */     GIR_RootConstrainSelectedInstOperands,
     /* 123671 */     // GIR_Coverage, 7043,
     /* 123671 */     GIR_EraseRootFromParent_Done,
     /* 123672 */   // Label 2362: @123672
     /* 123672 */   GIM_Try, /*On fail goto*//*Label 2363*/ GIMT_Encode4(123721), // Rule ID 7044 //
     /* 123677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123680 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 123687 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 123690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123694 */     // MIs[0] Rn
     /* 123694 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123698 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123706 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_monotonic>>  =>  (LDADDH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDH),
     /* 123709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123713 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123715 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123719 */     GIR_RootConstrainSelectedInstOperands,
     /* 123720 */     // GIR_Coverage, 7044,
     /* 123720 */     GIR_EraseRootFromParent_Done,
     /* 123721 */   // Label 2363: @123721
     /* 123721 */   GIM_Try, /*On fail goto*//*Label 2364*/ GIMT_Encode4(123770), // Rule ID 7045 //
     /* 123726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123729 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 123736 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 123739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123743 */     // MIs[0] Rn
     /* 123743 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123747 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123755 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acquire>>  =>  (LDADDAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAH),
     /* 123758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123760 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123762 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123764 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123768 */     GIR_RootConstrainSelectedInstOperands,
     /* 123769 */     // GIR_Coverage, 7045,
     /* 123769 */     GIR_EraseRootFromParent_Done,
     /* 123770 */   // Label 2364: @123770
     /* 123770 */   GIM_Try, /*On fail goto*//*Label 2365*/ GIMT_Encode4(123819), // Rule ID 7046 //
     /* 123775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123778 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 123785 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 123788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123792 */     // MIs[0] Rn
     /* 123792 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123796 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123804 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_release>>  =>  (LDADDLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLH),
     /* 123807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123811 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123813 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123817 */     GIR_RootConstrainSelectedInstOperands,
     /* 123818 */     // GIR_Coverage, 7046,
     /* 123818 */     GIR_EraseRootFromParent_Done,
     /* 123819 */   // Label 2365: @123819
     /* 123819 */   GIM_Try, /*On fail goto*//*Label 2366*/ GIMT_Encode4(123868), // Rule ID 7047 //
     /* 123824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123827 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 123834 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 123837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123841 */     // MIs[0] Rn
     /* 123841 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123845 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123853 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acq_rel>>  =>  (LDADDALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 123856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123858 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123860 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123862 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123866 */     GIR_RootConstrainSelectedInstOperands,
     /* 123867 */     // GIR_Coverage, 7047,
     /* 123867 */     GIR_EraseRootFromParent_Done,
     /* 123868 */   // Label 2366: @123868
     /* 123868 */   GIM_Try, /*On fail goto*//*Label 2367*/ GIMT_Encode4(123917), // Rule ID 7048 //
     /* 123873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123876 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 123883 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 123886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123890 */     // MIs[0] Rn
     /* 123890 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123902 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_seq_cst>>  =>  (LDADDALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 123905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123909 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123911 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123915 */     GIR_RootConstrainSelectedInstOperands,
     /* 123916 */     // GIR_Coverage, 7048,
     /* 123916 */     GIR_EraseRootFromParent_Done,
     /* 123917 */   // Label 2367: @123917
     /* 123917 */   GIM_Try, /*On fail goto*//*Label 2368*/ GIMT_Encode4(123966), // Rule ID 7049 //
     /* 123922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123925 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 123932 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 123935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123939 */     // MIs[0] Rn
     /* 123939 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123951 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_monotonic>>  =>  (LDADDB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 123951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDB),
     /* 123954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 123958 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 123960 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123964 */     GIR_RootConstrainSelectedInstOperands,
     /* 123965 */     // GIR_Coverage, 7049,
     /* 123965 */     GIR_EraseRootFromParent_Done,
     /* 123966 */   // Label 2368: @123966
     /* 123966 */   GIM_Try, /*On fail goto*//*Label 2369*/ GIMT_Encode4(124015), // Rule ID 7050 //
     /* 123971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 123974 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 123981 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 123984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123988 */     // MIs[0] Rn
     /* 123988 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123992 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124000 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acquire>>  =>  (LDADDAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 124000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAB),
     /* 124003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 124007 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124009 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124013 */     GIR_RootConstrainSelectedInstOperands,
     /* 124014 */     // GIR_Coverage, 7050,
     /* 124014 */     GIR_EraseRootFromParent_Done,
     /* 124015 */   // Label 2369: @124015
     /* 124015 */   GIM_Try, /*On fail goto*//*Label 2370*/ GIMT_Encode4(124064), // Rule ID 7051 //
     /* 124020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124023 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 124030 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 124033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124037 */     // MIs[0] Rn
     /* 124037 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124041 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124049 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_release>>  =>  (LDADDLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 124049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLB),
     /* 124052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124054 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 124056 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124058 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124062 */     GIR_RootConstrainSelectedInstOperands,
     /* 124063 */     // GIR_Coverage, 7051,
     /* 124063 */     GIR_EraseRootFromParent_Done,
     /* 124064 */   // Label 2370: @124064
     /* 124064 */   GIM_Try, /*On fail goto*//*Label 2371*/ GIMT_Encode4(124113), // Rule ID 7052 //
     /* 124069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124072 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 124079 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 124082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124086 */     // MIs[0] Rn
     /* 124086 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124090 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124098 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acq_rel>>  =>  (LDADDALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 124098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 124101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 124105 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124107 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124111 */     GIR_RootConstrainSelectedInstOperands,
     /* 124112 */     // GIR_Coverage, 7052,
     /* 124112 */     GIR_EraseRootFromParent_Done,
     /* 124113 */   // Label 2371: @124113
     /* 124113 */   GIM_Try, /*On fail goto*//*Label 2372*/ GIMT_Encode4(124162), // Rule ID 7053 //
     /* 124118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124121 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 124128 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 124131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124135 */     // MIs[0] Rn
     /* 124135 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124147 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_seq_cst>>  =>  (LDADDALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 124147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 124150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124152 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 124154 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124156 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124160 */     GIR_RootConstrainSelectedInstOperands,
     /* 124161 */     // GIR_Coverage, 7053,
     /* 124161 */     GIR_EraseRootFromParent_Done,
     /* 124162 */   // Label 2372: @124162
     /* 124162 */   GIM_Reject,
     /* 124163 */ // Label 2357: @124163
     /* 124163 */ GIM_Reject,
     /* 124164 */ // Label 2355: @124164
     /* 124164 */ GIM_Try, /*On fail goto*//*Label 2373*/ GIMT_Encode4(124390),
     /* 124169 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 124172 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 124179 */   GIM_Try, /*On fail goto*//*Label 2374*/ GIMT_Encode4(124221), // Rule ID 2570 //
     /* 124184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124187 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 124190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124194 */     // MIs[0] Rn
     /* 124194 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124198 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124206 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_monotonic>>  =>  (LDADDX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 124206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDX),
     /* 124209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 124213 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124215 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124219 */     GIR_RootConstrainSelectedInstOperands,
     /* 124220 */     // GIR_Coverage, 2570,
     /* 124220 */     GIR_EraseRootFromParent_Done,
     /* 124221 */   // Label 2374: @124221
     /* 124221 */   GIM_Try, /*On fail goto*//*Label 2375*/ GIMT_Encode4(124263), // Rule ID 2571 //
     /* 124226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124229 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 124232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124236 */     // MIs[0] Rn
     /* 124236 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124240 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124248 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acquire>>  =>  (LDADDAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 124248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAX),
     /* 124251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 124255 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124257 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124261 */     GIR_RootConstrainSelectedInstOperands,
     /* 124262 */     // GIR_Coverage, 2571,
     /* 124262 */     GIR_EraseRootFromParent_Done,
     /* 124263 */   // Label 2375: @124263
     /* 124263 */   GIM_Try, /*On fail goto*//*Label 2376*/ GIMT_Encode4(124305), // Rule ID 2572 //
     /* 124268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124271 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 124274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124278 */     // MIs[0] Rn
     /* 124278 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124290 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_release>>  =>  (LDADDLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 124290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLX),
     /* 124293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 124297 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124299 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124303 */     GIR_RootConstrainSelectedInstOperands,
     /* 124304 */     // GIR_Coverage, 2572,
     /* 124304 */     GIR_EraseRootFromParent_Done,
     /* 124305 */   // Label 2376: @124305
     /* 124305 */   GIM_Try, /*On fail goto*//*Label 2377*/ GIMT_Encode4(124347), // Rule ID 2573 //
     /* 124310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124313 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 124316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124320 */     // MIs[0] Rn
     /* 124320 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124324 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124332 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acq_rel>>  =>  (LDADDALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 124332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 124335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 124339 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124341 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124345 */     GIR_RootConstrainSelectedInstOperands,
     /* 124346 */     // GIR_Coverage, 2573,
     /* 124346 */     GIR_EraseRootFromParent_Done,
     /* 124347 */   // Label 2377: @124347
     /* 124347 */   GIM_Try, /*On fail goto*//*Label 2378*/ GIMT_Encode4(124389), // Rule ID 2574 //
     /* 124352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124355 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 124358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124362 */     // MIs[0] Rn
     /* 124362 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124374 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_seq_cst>>  =>  (LDADDALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 124374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 124377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124379 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 124381 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124383 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124387 */     GIR_RootConstrainSelectedInstOperands,
     /* 124388 */     // GIR_Coverage, 2574,
     /* 124388 */     GIR_EraseRootFromParent_Done,
     /* 124389 */   // Label 2378: @124389
     /* 124389 */   GIM_Reject,
     /* 124390 */ // Label 2373: @124390
     /* 124390 */ GIM_Reject,
     /* 124391 */ // Label 2356: @124391
     /* 124391 */ GIM_Reject,
     /* 124392 */ // Label 23: @124392
     /* 124392 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2381*/ GIMT_Encode4(125883),
     /* 124403 */ /*GILLT_s32*//*Label 2379*/ GIMT_Encode4(124411),
     /* 124407 */ /*GILLT_s64*//*Label 2380*/ GIMT_Encode4(125531),
     /* 124411 */ // Label 2379: @124411
     /* 124411 */ GIM_Try, /*On fail goto*//*Label 2382*/ GIMT_Encode4(125530),
     /* 124416 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 124419 */   GIM_Try, /*On fail goto*//*Label 2383*/ GIMT_Encode4(124493), // Rule ID 7234 //
     /* 124424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124427 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 124434 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 124437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124441 */     // MIs[0] Rn
     /* 124441 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124445 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124453 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_monotonic>>  =>  (LDADDW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 124453 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 124456 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 124460 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124465 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124471 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 124475 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDW),
     /* 124480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124482 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124485 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124487 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124491 */     GIR_RootConstrainSelectedInstOperands,
     /* 124492 */     // GIR_Coverage, 7234,
     /* 124492 */     GIR_EraseRootFromParent_Done,
     /* 124493 */   // Label 2383: @124493
     /* 124493 */   GIM_Try, /*On fail goto*//*Label 2384*/ GIMT_Encode4(124567), // Rule ID 7235 //
     /* 124498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124501 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 124508 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 124511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124515 */     // MIs[0] Rn
     /* 124515 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124527 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_acquire>>  =>  (LDADDAW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 124527 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 124530 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 124534 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124539 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124545 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 124549 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAW),
     /* 124554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124556 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124559 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124561 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124565 */     GIR_RootConstrainSelectedInstOperands,
     /* 124566 */     // GIR_Coverage, 7235,
     /* 124566 */     GIR_EraseRootFromParent_Done,
     /* 124567 */   // Label 2384: @124567
     /* 124567 */   GIM_Try, /*On fail goto*//*Label 2385*/ GIMT_Encode4(124641), // Rule ID 7236 //
     /* 124572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124575 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 124582 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 124585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124589 */     // MIs[0] Rn
     /* 124589 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124601 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_release>>  =>  (LDADDLW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 124601 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 124604 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 124608 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124613 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124619 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 124623 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLW),
     /* 124628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124630 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124633 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124635 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124639 */     GIR_RootConstrainSelectedInstOperands,
     /* 124640 */     // GIR_Coverage, 7236,
     /* 124640 */     GIR_EraseRootFromParent_Done,
     /* 124641 */   // Label 2385: @124641
     /* 124641 */   GIM_Try, /*On fail goto*//*Label 2386*/ GIMT_Encode4(124715), // Rule ID 7237 //
     /* 124646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124649 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 124656 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 124659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124663 */     // MIs[0] Rn
     /* 124663 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124675 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_acq_rel>>  =>  (LDADDALW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 124675 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 124678 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 124682 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124687 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124693 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 124697 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 124702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124704 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124707 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124709 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124713 */     GIR_RootConstrainSelectedInstOperands,
     /* 124714 */     // GIR_Coverage, 7237,
     /* 124714 */     GIR_EraseRootFromParent_Done,
     /* 124715 */   // Label 2386: @124715
     /* 124715 */   GIM_Try, /*On fail goto*//*Label 2387*/ GIMT_Encode4(124789), // Rule ID 7238 //
     /* 124720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124723 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 124730 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 124733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124737 */     // MIs[0] Rn
     /* 124737 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124749 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_seq_cst>>  =>  (LDADDALW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 124749 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 124752 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 124756 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124761 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124767 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 124771 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 124776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124778 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124781 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124783 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124787 */     GIR_RootConstrainSelectedInstOperands,
     /* 124788 */     // GIR_Coverage, 7238,
     /* 124788 */     GIR_EraseRootFromParent_Done,
     /* 124789 */   // Label 2387: @124789
     /* 124789 */   GIM_Try, /*On fail goto*//*Label 2388*/ GIMT_Encode4(124863), // Rule ID 7239 //
     /* 124794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124797 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 124804 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 124807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124811 */     // MIs[0] Rn
     /* 124811 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124823 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_monotonic>>  =>  (LDADDH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 124823 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 124826 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 124830 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124835 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124841 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 124845 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDH),
     /* 124850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124852 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124855 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124857 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124861 */     GIR_RootConstrainSelectedInstOperands,
     /* 124862 */     // GIR_Coverage, 7239,
     /* 124862 */     GIR_EraseRootFromParent_Done,
     /* 124863 */   // Label 2388: @124863
     /* 124863 */   GIM_Try, /*On fail goto*//*Label 2389*/ GIMT_Encode4(124937), // Rule ID 7240 //
     /* 124868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124871 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 124878 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 124881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124885 */     // MIs[0] Rn
     /* 124885 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124897 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_acquire>>  =>  (LDADDAH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 124897 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 124900 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 124904 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124909 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124915 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 124919 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAH),
     /* 124924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124926 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124929 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124931 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124935 */     GIR_RootConstrainSelectedInstOperands,
     /* 124936 */     // GIR_Coverage, 7240,
     /* 124936 */     GIR_EraseRootFromParent_Done,
     /* 124937 */   // Label 2389: @124937
     /* 124937 */   GIM_Try, /*On fail goto*//*Label 2390*/ GIMT_Encode4(125011), // Rule ID 7241 //
     /* 124942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124945 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 124952 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 124955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124959 */     // MIs[0] Rn
     /* 124959 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124971 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_release>>  =>  (LDADDLH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 124971 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 124974 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 124978 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124983 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124989 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 124993 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLH),
     /* 124998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125000 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125003 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125005 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125009 */     GIR_RootConstrainSelectedInstOperands,
     /* 125010 */     // GIR_Coverage, 7241,
     /* 125010 */     GIR_EraseRootFromParent_Done,
     /* 125011 */   // Label 2390: @125011
     /* 125011 */   GIM_Try, /*On fail goto*//*Label 2391*/ GIMT_Encode4(125085), // Rule ID 7242 //
     /* 125016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125019 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 125026 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 125029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125033 */     // MIs[0] Rn
     /* 125033 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125037 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125045 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_acq_rel>>  =>  (LDADDALH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 125045 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 125048 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 125052 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125057 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125063 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 125067 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 125072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125074 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125077 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125079 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125083 */     GIR_RootConstrainSelectedInstOperands,
     /* 125084 */     // GIR_Coverage, 7242,
     /* 125084 */     GIR_EraseRootFromParent_Done,
     /* 125085 */   // Label 2391: @125085
     /* 125085 */   GIM_Try, /*On fail goto*//*Label 2392*/ GIMT_Encode4(125159), // Rule ID 7243 //
     /* 125090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125093 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 125100 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 125103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125107 */     // MIs[0] Rn
     /* 125107 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125119 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_seq_cst>>  =>  (LDADDALH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 125119 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 125122 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 125126 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125131 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125137 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 125141 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 125146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125148 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125151 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125153 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125157 */     GIR_RootConstrainSelectedInstOperands,
     /* 125158 */     // GIR_Coverage, 7243,
     /* 125158 */     GIR_EraseRootFromParent_Done,
     /* 125159 */   // Label 2392: @125159
     /* 125159 */   GIM_Try, /*On fail goto*//*Label 2393*/ GIMT_Encode4(125233), // Rule ID 7244 //
     /* 125164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125167 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 125174 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 125177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125181 */     // MIs[0] Rn
     /* 125181 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125185 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125193 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_monotonic>>  =>  (LDADDB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 125193 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 125196 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 125200 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125205 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125211 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 125215 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDB),
     /* 125220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125222 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125225 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125227 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125231 */     GIR_RootConstrainSelectedInstOperands,
     /* 125232 */     // GIR_Coverage, 7244,
     /* 125232 */     GIR_EraseRootFromParent_Done,
     /* 125233 */   // Label 2393: @125233
     /* 125233 */   GIM_Try, /*On fail goto*//*Label 2394*/ GIMT_Encode4(125307), // Rule ID 7245 //
     /* 125238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125241 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 125248 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 125251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125255 */     // MIs[0] Rn
     /* 125255 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125259 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125267 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_acquire>>  =>  (LDADDAB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 125267 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 125270 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 125274 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125279 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125285 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 125289 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAB),
     /* 125294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125296 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125299 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125301 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125305 */     GIR_RootConstrainSelectedInstOperands,
     /* 125306 */     // GIR_Coverage, 7245,
     /* 125306 */     GIR_EraseRootFromParent_Done,
     /* 125307 */   // Label 2394: @125307
     /* 125307 */   GIM_Try, /*On fail goto*//*Label 2395*/ GIMT_Encode4(125381), // Rule ID 7246 //
     /* 125312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125315 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 125322 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 125325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125329 */     // MIs[0] Rn
     /* 125329 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125341 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_release>>  =>  (LDADDLB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 125341 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 125344 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 125348 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125353 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125359 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 125363 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLB),
     /* 125368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125370 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125373 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125375 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125379 */     GIR_RootConstrainSelectedInstOperands,
     /* 125380 */     // GIR_Coverage, 7246,
     /* 125380 */     GIR_EraseRootFromParent_Done,
     /* 125381 */   // Label 2395: @125381
     /* 125381 */   GIM_Try, /*On fail goto*//*Label 2396*/ GIMT_Encode4(125455), // Rule ID 7247 //
     /* 125386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125389 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 125396 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 125399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125403 */     // MIs[0] Rn
     /* 125403 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125407 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125415 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_acq_rel>>  =>  (LDADDALB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 125415 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 125418 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 125422 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125427 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125433 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 125437 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 125442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125444 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125447 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125449 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125453 */     GIR_RootConstrainSelectedInstOperands,
     /* 125454 */     // GIR_Coverage, 7247,
     /* 125454 */     GIR_EraseRootFromParent_Done,
     /* 125455 */   // Label 2396: @125455
     /* 125455 */   GIM_Try, /*On fail goto*//*Label 2397*/ GIMT_Encode4(125529), // Rule ID 7248 //
     /* 125460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125463 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 125470 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 125473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125477 */     // MIs[0] Rn
     /* 125477 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125481 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125489 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_seq_cst>>  =>  (LDADDALB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 125489 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 125492 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 125496 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125501 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125507 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 125511 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 125516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125518 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125521 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125523 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125527 */     GIR_RootConstrainSelectedInstOperands,
     /* 125528 */     // GIR_Coverage, 7248,
     /* 125528 */     GIR_EraseRootFromParent_Done,
     /* 125529 */   // Label 2397: @125529
     /* 125529 */   GIM_Reject,
     /* 125530 */ // Label 2382: @125530
     /* 125530 */ GIM_Reject,
     /* 125531 */ // Label 2380: @125531
     /* 125531 */ GIM_Try, /*On fail goto*//*Label 2398*/ GIMT_Encode4(125882),
     /* 125536 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 125539 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 125546 */   GIM_Try, /*On fail goto*//*Label 2399*/ GIMT_Encode4(125613), // Rule ID 7229 //
     /* 125551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125554 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 125557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125561 */     // MIs[0] Rn
     /* 125561 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125565 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125573 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_monotonic>>  =>  (LDADDX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 125573 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 125576 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 125580 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125585 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125591 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 125595 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDX),
     /* 125600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125602 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125605 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125607 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125611 */     GIR_RootConstrainSelectedInstOperands,
     /* 125612 */     // GIR_Coverage, 7229,
     /* 125612 */     GIR_EraseRootFromParent_Done,
     /* 125613 */   // Label 2399: @125613
     /* 125613 */   GIM_Try, /*On fail goto*//*Label 2400*/ GIMT_Encode4(125680), // Rule ID 7230 //
     /* 125618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125621 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 125624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125628 */     // MIs[0] Rn
     /* 125628 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125640 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_acquire>>  =>  (LDADDAX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 125640 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 125643 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 125647 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125652 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125658 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 125662 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAX),
     /* 125667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125669 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125672 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125674 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125678 */     GIR_RootConstrainSelectedInstOperands,
     /* 125679 */     // GIR_Coverage, 7230,
     /* 125679 */     GIR_EraseRootFromParent_Done,
     /* 125680 */   // Label 2400: @125680
     /* 125680 */   GIM_Try, /*On fail goto*//*Label 2401*/ GIMT_Encode4(125747), // Rule ID 7231 //
     /* 125685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125688 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 125691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125695 */     // MIs[0] Rn
     /* 125695 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125699 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125707 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_release>>  =>  (LDADDLX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 125707 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 125710 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 125714 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125719 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125725 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 125729 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLX),
     /* 125734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125736 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125739 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125741 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125745 */     GIR_RootConstrainSelectedInstOperands,
     /* 125746 */     // GIR_Coverage, 7231,
     /* 125746 */     GIR_EraseRootFromParent_Done,
     /* 125747 */   // Label 2401: @125747
     /* 125747 */   GIM_Try, /*On fail goto*//*Label 2402*/ GIMT_Encode4(125814), // Rule ID 7232 //
     /* 125752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125755 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 125758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125762 */     // MIs[0] Rn
     /* 125762 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125774 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_acq_rel>>  =>  (LDADDALX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 125774 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 125777 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 125781 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125786 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125792 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 125796 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 125801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125803 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125806 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125808 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125812 */     GIR_RootConstrainSelectedInstOperands,
     /* 125813 */     // GIR_Coverage, 7232,
     /* 125813 */     GIR_EraseRootFromParent_Done,
     /* 125814 */   // Label 2402: @125814
     /* 125814 */   GIM_Try, /*On fail goto*//*Label 2403*/ GIMT_Encode4(125881), // Rule ID 7233 //
     /* 125819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125822 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 125825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125829 */     // MIs[0] Rn
     /* 125829 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125841 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_seq_cst>>  =>  (LDADDALX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 125841 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 125844 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 125848 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125853 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125859 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 125863 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 125868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125870 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125873 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125875 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125879 */     GIR_RootConstrainSelectedInstOperands,
     /* 125880 */     // GIR_Coverage, 7233,
     /* 125880 */     GIR_EraseRootFromParent_Done,
     /* 125881 */   // Label 2403: @125881
     /* 125881 */   GIM_Reject,
     /* 125882 */ // Label 2398: @125882
     /* 125882 */ GIM_Reject,
     /* 125883 */ // Label 2381: @125883
     /* 125883 */ GIM_Reject,
     /* 125884 */ // Label 24: @125884
     /* 125884 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2406*/ GIMT_Encode4(127375),
     /* 125895 */ /*GILLT_s32*//*Label 2404*/ GIMT_Encode4(125903),
     /* 125899 */ /*GILLT_s64*//*Label 2405*/ GIMT_Encode4(127023),
     /* 125903 */ // Label 2404: @125903
     /* 125903 */ GIM_Try, /*On fail goto*//*Label 2407*/ GIMT_Encode4(127022),
     /* 125908 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 125911 */   GIM_Try, /*On fail goto*//*Label 2408*/ GIMT_Encode4(125985), // Rule ID 7254 //
     /* 125916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125919 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 125926 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 125929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125933 */     // MIs[0] Rn
     /* 125933 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125937 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125945 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_monotonic>>  =>  (LDCLRW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 125945 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 125948 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 125952 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125957 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125963 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 125967 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRW),
     /* 125972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125974 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125977 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125979 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125983 */     GIR_RootConstrainSelectedInstOperands,
     /* 125984 */     // GIR_Coverage, 7254,
     /* 125984 */     GIR_EraseRootFromParent_Done,
     /* 125985 */   // Label 2408: @125985
     /* 125985 */   GIM_Try, /*On fail goto*//*Label 2409*/ GIMT_Encode4(126059), // Rule ID 7255 //
     /* 125990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125993 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126000 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 126003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126007 */     // MIs[0] Rn
     /* 126007 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126019 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acquire>>  =>  (LDCLRAW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 126019 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126022 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 126026 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126031 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126037 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 126041 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAW),
     /* 126046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126048 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126051 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126053 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126057 */     GIR_RootConstrainSelectedInstOperands,
     /* 126058 */     // GIR_Coverage, 7255,
     /* 126058 */     GIR_EraseRootFromParent_Done,
     /* 126059 */   // Label 2409: @126059
     /* 126059 */   GIM_Try, /*On fail goto*//*Label 2410*/ GIMT_Encode4(126133), // Rule ID 7256 //
     /* 126064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126067 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126074 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 126077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126081 */     // MIs[0] Rn
     /* 126081 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126085 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126093 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_release>>  =>  (LDCLRLW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 126093 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126096 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 126100 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126105 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126111 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 126115 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLW),
     /* 126120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126122 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126125 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126127 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126131 */     GIR_RootConstrainSelectedInstOperands,
     /* 126132 */     // GIR_Coverage, 7256,
     /* 126132 */     GIR_EraseRootFromParent_Done,
     /* 126133 */   // Label 2410: @126133
     /* 126133 */   GIM_Try, /*On fail goto*//*Label 2411*/ GIMT_Encode4(126207), // Rule ID 7257 //
     /* 126138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126141 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126148 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 126151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126155 */     // MIs[0] Rn
     /* 126155 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126159 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126167 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acq_rel>>  =>  (LDCLRALW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 126167 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126170 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 126174 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126179 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126185 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 126189 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALW),
     /* 126194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126196 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126199 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126201 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126205 */     GIR_RootConstrainSelectedInstOperands,
     /* 126206 */     // GIR_Coverage, 7257,
     /* 126206 */     GIR_EraseRootFromParent_Done,
     /* 126207 */   // Label 2411: @126207
     /* 126207 */   GIM_Try, /*On fail goto*//*Label 2412*/ GIMT_Encode4(126281), // Rule ID 7258 //
     /* 126212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126215 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126222 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 126225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126229 */     // MIs[0] Rn
     /* 126229 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126241 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_seq_cst>>  =>  (LDCLRALW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 126241 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126244 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 126248 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126253 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126259 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 126263 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALW),
     /* 126268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126270 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126273 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126275 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126279 */     GIR_RootConstrainSelectedInstOperands,
     /* 126280 */     // GIR_Coverage, 7258,
     /* 126280 */     GIR_EraseRootFromParent_Done,
     /* 126281 */   // Label 2412: @126281
     /* 126281 */   GIM_Try, /*On fail goto*//*Label 2413*/ GIMT_Encode4(126355), // Rule ID 7259 //
     /* 126286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126289 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126296 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 126299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126303 */     // MIs[0] Rn
     /* 126303 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126315 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_monotonic>>  =>  (LDCLRH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 126315 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126318 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 126322 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126327 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126333 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 126337 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRH),
     /* 126342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126344 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126347 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126349 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126353 */     GIR_RootConstrainSelectedInstOperands,
     /* 126354 */     // GIR_Coverage, 7259,
     /* 126354 */     GIR_EraseRootFromParent_Done,
     /* 126355 */   // Label 2413: @126355
     /* 126355 */   GIM_Try, /*On fail goto*//*Label 2414*/ GIMT_Encode4(126429), // Rule ID 7260 //
     /* 126360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126363 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126370 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 126373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126377 */     // MIs[0] Rn
     /* 126377 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126389 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acquire>>  =>  (LDCLRAH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 126389 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126392 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 126396 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126401 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126407 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 126411 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAH),
     /* 126416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126418 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126421 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126423 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126427 */     GIR_RootConstrainSelectedInstOperands,
     /* 126428 */     // GIR_Coverage, 7260,
     /* 126428 */     GIR_EraseRootFromParent_Done,
     /* 126429 */   // Label 2414: @126429
     /* 126429 */   GIM_Try, /*On fail goto*//*Label 2415*/ GIMT_Encode4(126503), // Rule ID 7261 //
     /* 126434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126437 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126444 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 126447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126451 */     // MIs[0] Rn
     /* 126451 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126455 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126463 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_release>>  =>  (LDCLRLH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 126463 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126466 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 126470 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126475 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126481 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 126485 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLH),
     /* 126490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126492 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126495 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126497 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126501 */     GIR_RootConstrainSelectedInstOperands,
     /* 126502 */     // GIR_Coverage, 7261,
     /* 126502 */     GIR_EraseRootFromParent_Done,
     /* 126503 */   // Label 2415: @126503
     /* 126503 */   GIM_Try, /*On fail goto*//*Label 2416*/ GIMT_Encode4(126577), // Rule ID 7262 //
     /* 126508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126511 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126518 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 126521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126525 */     // MIs[0] Rn
     /* 126525 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126529 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126537 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acq_rel>>  =>  (LDCLRALH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 126537 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126540 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 126544 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126549 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126555 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 126559 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALH),
     /* 126564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126566 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126569 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126571 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126575 */     GIR_RootConstrainSelectedInstOperands,
     /* 126576 */     // GIR_Coverage, 7262,
     /* 126576 */     GIR_EraseRootFromParent_Done,
     /* 126577 */   // Label 2416: @126577
     /* 126577 */   GIM_Try, /*On fail goto*//*Label 2417*/ GIMT_Encode4(126651), // Rule ID 7263 //
     /* 126582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126585 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126592 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 126595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126599 */     // MIs[0] Rn
     /* 126599 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126603 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126611 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_seq_cst>>  =>  (LDCLRALH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 126611 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126614 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 126618 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126623 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126629 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 126633 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALH),
     /* 126638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126640 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126643 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126645 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126649 */     GIR_RootConstrainSelectedInstOperands,
     /* 126650 */     // GIR_Coverage, 7263,
     /* 126650 */     GIR_EraseRootFromParent_Done,
     /* 126651 */   // Label 2417: @126651
     /* 126651 */   GIM_Try, /*On fail goto*//*Label 2418*/ GIMT_Encode4(126725), // Rule ID 7264 //
     /* 126656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126659 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126666 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 126669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126673 */     // MIs[0] Rn
     /* 126673 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126677 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126685 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_monotonic>>  =>  (LDCLRB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 126685 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126688 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 126692 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126697 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126703 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 126707 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRB),
     /* 126712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126714 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126717 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126719 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126723 */     GIR_RootConstrainSelectedInstOperands,
     /* 126724 */     // GIR_Coverage, 7264,
     /* 126724 */     GIR_EraseRootFromParent_Done,
     /* 126725 */   // Label 2418: @126725
     /* 126725 */   GIM_Try, /*On fail goto*//*Label 2419*/ GIMT_Encode4(126799), // Rule ID 7265 //
     /* 126730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126733 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126740 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 126743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126747 */     // MIs[0] Rn
     /* 126747 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126751 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126759 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acquire>>  =>  (LDCLRAB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 126759 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126762 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 126766 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126771 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126777 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 126781 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAB),
     /* 126786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126788 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126791 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126793 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126797 */     GIR_RootConstrainSelectedInstOperands,
     /* 126798 */     // GIR_Coverage, 7265,
     /* 126798 */     GIR_EraseRootFromParent_Done,
     /* 126799 */   // Label 2419: @126799
     /* 126799 */   GIM_Try, /*On fail goto*//*Label 2420*/ GIMT_Encode4(126873), // Rule ID 7266 //
     /* 126804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126807 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126814 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 126817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126821 */     // MIs[0] Rn
     /* 126821 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126833 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_release>>  =>  (LDCLRLB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 126833 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126836 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 126840 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126845 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126851 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 126855 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLB),
     /* 126860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126862 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126865 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126867 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126871 */     GIR_RootConstrainSelectedInstOperands,
     /* 126872 */     // GIR_Coverage, 7266,
     /* 126872 */     GIR_EraseRootFromParent_Done,
     /* 126873 */   // Label 2420: @126873
     /* 126873 */   GIM_Try, /*On fail goto*//*Label 2421*/ GIMT_Encode4(126947), // Rule ID 7267 //
     /* 126878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126881 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126888 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 126891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126895 */     // MIs[0] Rn
     /* 126895 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126899 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126907 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acq_rel>>  =>  (LDCLRALB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 126907 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126910 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 126914 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126919 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126925 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 126929 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALB),
     /* 126934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126936 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126939 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126941 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126945 */     GIR_RootConstrainSelectedInstOperands,
     /* 126946 */     // GIR_Coverage, 7267,
     /* 126946 */     GIR_EraseRootFromParent_Done,
     /* 126947 */   // Label 2421: @126947
     /* 126947 */   GIM_Try, /*On fail goto*//*Label 2422*/ GIMT_Encode4(127021), // Rule ID 7268 //
     /* 126952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126955 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126962 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 126965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126969 */     // MIs[0] Rn
     /* 126969 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126973 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126981 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_seq_cst>>  =>  (LDCLRALB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 126981 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126984 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 126988 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126993 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126999 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 127003 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALB),
     /* 127008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127010 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127013 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127015 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127019 */     GIR_RootConstrainSelectedInstOperands,
     /* 127020 */     // GIR_Coverage, 7268,
     /* 127020 */     GIR_EraseRootFromParent_Done,
     /* 127021 */   // Label 2422: @127021
     /* 127021 */   GIM_Reject,
     /* 127022 */ // Label 2407: @127022
     /* 127022 */ GIM_Reject,
     /* 127023 */ // Label 2405: @127023
     /* 127023 */ GIM_Try, /*On fail goto*//*Label 2423*/ GIMT_Encode4(127374),
     /* 127028 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 127031 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 127038 */   GIM_Try, /*On fail goto*//*Label 2424*/ GIMT_Encode4(127105), // Rule ID 7249 //
     /* 127043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127046 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 127049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127053 */     // MIs[0] Rn
     /* 127053 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127057 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127065 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_monotonic>>  =>  (LDCLRX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 127065 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 127068 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 127072 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127077 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127083 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 127087 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRX),
     /* 127092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127094 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127097 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127099 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127103 */     GIR_RootConstrainSelectedInstOperands,
     /* 127104 */     // GIR_Coverage, 7249,
     /* 127104 */     GIR_EraseRootFromParent_Done,
     /* 127105 */   // Label 2424: @127105
     /* 127105 */   GIM_Try, /*On fail goto*//*Label 2425*/ GIMT_Encode4(127172), // Rule ID 7250 //
     /* 127110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127113 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127120 */     // MIs[0] Rn
     /* 127120 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127124 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127132 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acquire>>  =>  (LDCLRAX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 127132 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 127135 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 127139 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127144 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127150 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 127154 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAX),
     /* 127159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127161 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127164 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127166 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127170 */     GIR_RootConstrainSelectedInstOperands,
     /* 127171 */     // GIR_Coverage, 7250,
     /* 127171 */     GIR_EraseRootFromParent_Done,
     /* 127172 */   // Label 2425: @127172
     /* 127172 */   GIM_Try, /*On fail goto*//*Label 2426*/ GIMT_Encode4(127239), // Rule ID 7251 //
     /* 127177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127180 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 127183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127187 */     // MIs[0] Rn
     /* 127187 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127191 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127199 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_release>>  =>  (LDCLRLX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 127199 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 127202 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 127206 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127211 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127217 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 127221 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLX),
     /* 127226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127228 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127231 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127233 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127237 */     GIR_RootConstrainSelectedInstOperands,
     /* 127238 */     // GIR_Coverage, 7251,
     /* 127238 */     GIR_EraseRootFromParent_Done,
     /* 127239 */   // Label 2426: @127239
     /* 127239 */   GIM_Try, /*On fail goto*//*Label 2427*/ GIMT_Encode4(127306), // Rule ID 7252 //
     /* 127244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127247 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 127250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127254 */     // MIs[0] Rn
     /* 127254 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127258 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127266 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acq_rel>>  =>  (LDCLRALX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 127266 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 127269 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 127273 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127278 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127284 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 127288 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALX),
     /* 127293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127295 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127298 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127300 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127304 */     GIR_RootConstrainSelectedInstOperands,
     /* 127305 */     // GIR_Coverage, 7252,
     /* 127305 */     GIR_EraseRootFromParent_Done,
     /* 127306 */   // Label 2427: @127306
     /* 127306 */   GIM_Try, /*On fail goto*//*Label 2428*/ GIMT_Encode4(127373), // Rule ID 7253 //
     /* 127311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127314 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 127317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127321 */     // MIs[0] Rn
     /* 127321 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127325 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127333 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_seq_cst>>  =>  (LDCLRALX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 127333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 127336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 127340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127345 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127351 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 127355 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALX),
     /* 127360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127362 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127365 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127367 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127371 */     GIR_RootConstrainSelectedInstOperands,
     /* 127372 */     // GIR_Coverage, 7253,
     /* 127372 */     GIR_EraseRootFromParent_Done,
     /* 127373 */   // Label 2428: @127373
     /* 127373 */   GIM_Reject,
     /* 127374 */ // Label 2423: @127374
     /* 127374 */ GIM_Reject,
     /* 127375 */ // Label 2406: @127375
     /* 127375 */ GIM_Reject,
     /* 127376 */ // Label 25: @127376
     /* 127376 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2431*/ GIMT_Encode4(128367),
     /* 127387 */ /*GILLT_s32*//*Label 2429*/ GIMT_Encode4(127395),
     /* 127391 */ /*GILLT_s64*//*Label 2430*/ GIMT_Encode4(128140),
     /* 127395 */ // Label 2429: @127395
     /* 127395 */ GIM_Try, /*On fail goto*//*Label 2432*/ GIMT_Encode4(128139),
     /* 127400 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 127403 */   GIM_Try, /*On fail goto*//*Label 2433*/ GIMT_Encode4(127452), // Rule ID 7059 //
     /* 127408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127411 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127418 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 127421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127425 */     // MIs[0] Rn
     /* 127425 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127437 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_monotonic>>  =>  (LDSETW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETW),
     /* 127440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127444 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127446 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127450 */     GIR_RootConstrainSelectedInstOperands,
     /* 127451 */     // GIR_Coverage, 7059,
     /* 127451 */     GIR_EraseRootFromParent_Done,
     /* 127452 */   // Label 2433: @127452
     /* 127452 */   GIM_Try, /*On fail goto*//*Label 2434*/ GIMT_Encode4(127501), // Rule ID 7060 //
     /* 127457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127460 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127467 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127474 */     // MIs[0] Rn
     /* 127474 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127478 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127486 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acquire>>  =>  (LDSETAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAW),
     /* 127489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127491 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127493 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127495 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127499 */     GIR_RootConstrainSelectedInstOperands,
     /* 127500 */     // GIR_Coverage, 7060,
     /* 127500 */     GIR_EraseRootFromParent_Done,
     /* 127501 */   // Label 2434: @127501
     /* 127501 */   GIM_Try, /*On fail goto*//*Label 2435*/ GIMT_Encode4(127550), // Rule ID 7061 //
     /* 127506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127509 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127516 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 127519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127523 */     // MIs[0] Rn
     /* 127523 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127527 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127535 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_release>>  =>  (LDSETLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLW),
     /* 127538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127540 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127542 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127544 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127548 */     GIR_RootConstrainSelectedInstOperands,
     /* 127549 */     // GIR_Coverage, 7061,
     /* 127549 */     GIR_EraseRootFromParent_Done,
     /* 127550 */   // Label 2435: @127550
     /* 127550 */   GIM_Try, /*On fail goto*//*Label 2436*/ GIMT_Encode4(127599), // Rule ID 7062 //
     /* 127555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127558 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127565 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 127568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127572 */     // MIs[0] Rn
     /* 127572 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127576 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127584 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acq_rel>>  =>  (LDSETALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALW),
     /* 127587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127591 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127593 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127597 */     GIR_RootConstrainSelectedInstOperands,
     /* 127598 */     // GIR_Coverage, 7062,
     /* 127598 */     GIR_EraseRootFromParent_Done,
     /* 127599 */   // Label 2436: @127599
     /* 127599 */   GIM_Try, /*On fail goto*//*Label 2437*/ GIMT_Encode4(127648), // Rule ID 7063 //
     /* 127604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127607 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127614 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 127617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127621 */     // MIs[0] Rn
     /* 127621 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127633 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_seq_cst>>  =>  (LDSETALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALW),
     /* 127636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127640 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127642 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127646 */     GIR_RootConstrainSelectedInstOperands,
     /* 127647 */     // GIR_Coverage, 7063,
     /* 127647 */     GIR_EraseRootFromParent_Done,
     /* 127648 */   // Label 2437: @127648
     /* 127648 */   GIM_Try, /*On fail goto*//*Label 2438*/ GIMT_Encode4(127697), // Rule ID 7064 //
     /* 127653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127656 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127663 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 127666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127670 */     // MIs[0] Rn
     /* 127670 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127682 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_monotonic>>  =>  (LDSETH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETH),
     /* 127685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127689 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127691 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127695 */     GIR_RootConstrainSelectedInstOperands,
     /* 127696 */     // GIR_Coverage, 7064,
     /* 127696 */     GIR_EraseRootFromParent_Done,
     /* 127697 */   // Label 2438: @127697
     /* 127697 */   GIM_Try, /*On fail goto*//*Label 2439*/ GIMT_Encode4(127746), // Rule ID 7065 //
     /* 127702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127705 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127712 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127719 */     // MIs[0] Rn
     /* 127719 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127731 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acquire>>  =>  (LDSETAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAH),
     /* 127734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127738 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127740 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127744 */     GIR_RootConstrainSelectedInstOperands,
     /* 127745 */     // GIR_Coverage, 7065,
     /* 127745 */     GIR_EraseRootFromParent_Done,
     /* 127746 */   // Label 2439: @127746
     /* 127746 */   GIM_Try, /*On fail goto*//*Label 2440*/ GIMT_Encode4(127795), // Rule ID 7066 //
     /* 127751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127754 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127761 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 127764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127768 */     // MIs[0] Rn
     /* 127768 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127780 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_release>>  =>  (LDSETLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLH),
     /* 127783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127785 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127787 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127789 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127793 */     GIR_RootConstrainSelectedInstOperands,
     /* 127794 */     // GIR_Coverage, 7066,
     /* 127794 */     GIR_EraseRootFromParent_Done,
     /* 127795 */   // Label 2440: @127795
     /* 127795 */   GIM_Try, /*On fail goto*//*Label 2441*/ GIMT_Encode4(127844), // Rule ID 7067 //
     /* 127800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127803 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127810 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 127813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127817 */     // MIs[0] Rn
     /* 127817 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127829 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acq_rel>>  =>  (LDSETALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALH),
     /* 127832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127834 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127836 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127838 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127842 */     GIR_RootConstrainSelectedInstOperands,
     /* 127843 */     // GIR_Coverage, 7067,
     /* 127843 */     GIR_EraseRootFromParent_Done,
     /* 127844 */   // Label 2441: @127844
     /* 127844 */   GIM_Try, /*On fail goto*//*Label 2442*/ GIMT_Encode4(127893), // Rule ID 7068 //
     /* 127849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127852 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127859 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 127862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127866 */     // MIs[0] Rn
     /* 127866 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127870 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127878 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_seq_cst>>  =>  (LDSETALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALH),
     /* 127881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127885 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127887 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127891 */     GIR_RootConstrainSelectedInstOperands,
     /* 127892 */     // GIR_Coverage, 7068,
     /* 127892 */     GIR_EraseRootFromParent_Done,
     /* 127893 */   // Label 2442: @127893
     /* 127893 */   GIM_Try, /*On fail goto*//*Label 2443*/ GIMT_Encode4(127942), // Rule ID 7069 //
     /* 127898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127901 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127908 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 127911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127915 */     // MIs[0] Rn
     /* 127915 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127919 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127927 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_monotonic>>  =>  (LDSETB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETB),
     /* 127930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127934 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127936 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127940 */     GIR_RootConstrainSelectedInstOperands,
     /* 127941 */     // GIR_Coverage, 7069,
     /* 127941 */     GIR_EraseRootFromParent_Done,
     /* 127942 */   // Label 2443: @127942
     /* 127942 */   GIM_Try, /*On fail goto*//*Label 2444*/ GIMT_Encode4(127991), // Rule ID 7070 //
     /* 127947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127950 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127957 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127964 */     // MIs[0] Rn
     /* 127964 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127968 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127976 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acquire>>  =>  (LDSETAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAB),
     /* 127979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127983 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127985 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127989 */     GIR_RootConstrainSelectedInstOperands,
     /* 127990 */     // GIR_Coverage, 7070,
     /* 127990 */     GIR_EraseRootFromParent_Done,
     /* 127991 */   // Label 2444: @127991
     /* 127991 */   GIM_Try, /*On fail goto*//*Label 2445*/ GIMT_Encode4(128040), // Rule ID 7071 //
     /* 127996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127999 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128006 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 128009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128013 */     // MIs[0] Rn
     /* 128013 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128025 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_release>>  =>  (LDSETLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLB),
     /* 128028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128032 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128034 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128038 */     GIR_RootConstrainSelectedInstOperands,
     /* 128039 */     // GIR_Coverage, 7071,
     /* 128039 */     GIR_EraseRootFromParent_Done,
     /* 128040 */   // Label 2445: @128040
     /* 128040 */   GIM_Try, /*On fail goto*//*Label 2446*/ GIMT_Encode4(128089), // Rule ID 7072 //
     /* 128045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128048 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128055 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 128058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128062 */     // MIs[0] Rn
     /* 128062 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128074 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acq_rel>>  =>  (LDSETALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALB),
     /* 128077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128081 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128083 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128087 */     GIR_RootConstrainSelectedInstOperands,
     /* 128088 */     // GIR_Coverage, 7072,
     /* 128088 */     GIR_EraseRootFromParent_Done,
     /* 128089 */   // Label 2446: @128089
     /* 128089 */   GIM_Try, /*On fail goto*//*Label 2447*/ GIMT_Encode4(128138), // Rule ID 7073 //
     /* 128094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128097 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128104 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 128107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128111 */     // MIs[0] Rn
     /* 128111 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128115 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128123 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_seq_cst>>  =>  (LDSETALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALB),
     /* 128126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128130 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128132 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128136 */     GIR_RootConstrainSelectedInstOperands,
     /* 128137 */     // GIR_Coverage, 7073,
     /* 128137 */     GIR_EraseRootFromParent_Done,
     /* 128138 */   // Label 2447: @128138
     /* 128138 */   GIM_Reject,
     /* 128139 */ // Label 2432: @128139
     /* 128139 */ GIM_Reject,
     /* 128140 */ // Label 2430: @128140
     /* 128140 */ GIM_Try, /*On fail goto*//*Label 2448*/ GIMT_Encode4(128366),
     /* 128145 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 128148 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 128155 */   GIM_Try, /*On fail goto*//*Label 2449*/ GIMT_Encode4(128197), // Rule ID 7054 //
     /* 128160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128163 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 128166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128170 */     // MIs[0] Rn
     /* 128170 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128174 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128182 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_monotonic>>  =>  (LDSETX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETX),
     /* 128185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128189 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128191 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128195 */     GIR_RootConstrainSelectedInstOperands,
     /* 128196 */     // GIR_Coverage, 7054,
     /* 128196 */     GIR_EraseRootFromParent_Done,
     /* 128197 */   // Label 2449: @128197
     /* 128197 */   GIM_Try, /*On fail goto*//*Label 2450*/ GIMT_Encode4(128239), // Rule ID 7055 //
     /* 128202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128205 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128212 */     // MIs[0] Rn
     /* 128212 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128216 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128224 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acquire>>  =>  (LDSETAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAX),
     /* 128227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128231 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128233 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128237 */     GIR_RootConstrainSelectedInstOperands,
     /* 128238 */     // GIR_Coverage, 7055,
     /* 128238 */     GIR_EraseRootFromParent_Done,
     /* 128239 */   // Label 2450: @128239
     /* 128239 */   GIM_Try, /*On fail goto*//*Label 2451*/ GIMT_Encode4(128281), // Rule ID 7056 //
     /* 128244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128247 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 128250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128254 */     // MIs[0] Rn
     /* 128254 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128258 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128266 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_release>>  =>  (LDSETLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLX),
     /* 128269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128271 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128273 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128275 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128279 */     GIR_RootConstrainSelectedInstOperands,
     /* 128280 */     // GIR_Coverage, 7056,
     /* 128280 */     GIR_EraseRootFromParent_Done,
     /* 128281 */   // Label 2451: @128281
     /* 128281 */   GIM_Try, /*On fail goto*//*Label 2452*/ GIMT_Encode4(128323), // Rule ID 7057 //
     /* 128286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128289 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 128292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128296 */     // MIs[0] Rn
     /* 128296 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128300 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128308 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acq_rel>>  =>  (LDSETALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALX),
     /* 128311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128315 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128317 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128321 */     GIR_RootConstrainSelectedInstOperands,
     /* 128322 */     // GIR_Coverage, 7057,
     /* 128322 */     GIR_EraseRootFromParent_Done,
     /* 128323 */   // Label 2452: @128323
     /* 128323 */   GIM_Try, /*On fail goto*//*Label 2453*/ GIMT_Encode4(128365), // Rule ID 7058 //
     /* 128328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128331 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 128334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128338 */     // MIs[0] Rn
     /* 128338 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128342 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128350 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_seq_cst>>  =>  (LDSETALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALX),
     /* 128353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128355 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128357 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128359 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128363 */     GIR_RootConstrainSelectedInstOperands,
     /* 128364 */     // GIR_Coverage, 7058,
     /* 128364 */     GIR_EraseRootFromParent_Done,
     /* 128365 */   // Label 2453: @128365
     /* 128365 */   GIM_Reject,
     /* 128366 */ // Label 2448: @128366
     /* 128366 */ GIM_Reject,
     /* 128367 */ // Label 2431: @128367
     /* 128367 */ GIM_Reject,
     /* 128368 */ // Label 26: @128368
     /* 128368 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2456*/ GIMT_Encode4(129359),
     /* 128379 */ /*GILLT_s32*//*Label 2454*/ GIMT_Encode4(128387),
     /* 128383 */ /*GILLT_s64*//*Label 2455*/ GIMT_Encode4(129132),
     /* 128387 */ // Label 2454: @128387
     /* 128387 */ GIM_Try, /*On fail goto*//*Label 2457*/ GIMT_Encode4(129131),
     /* 128392 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 128395 */   GIM_Try, /*On fail goto*//*Label 2458*/ GIMT_Encode4(128444), // Rule ID 7079 //
     /* 128400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128403 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128410 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 128413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128417 */     // MIs[0] Rn
     /* 128417 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128429 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_monotonic>>  =>  (LDEORW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORW),
     /* 128432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128436 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128438 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128442 */     GIR_RootConstrainSelectedInstOperands,
     /* 128443 */     // GIR_Coverage, 7079,
     /* 128443 */     GIR_EraseRootFromParent_Done,
     /* 128444 */   // Label 2458: @128444
     /* 128444 */   GIM_Try, /*On fail goto*//*Label 2459*/ GIMT_Encode4(128493), // Rule ID 7080 //
     /* 128449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128452 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128459 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128466 */     // MIs[0] Rn
     /* 128466 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128470 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128478 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acquire>>  =>  (LDEORAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAW),
     /* 128481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128485 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128487 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128491 */     GIR_RootConstrainSelectedInstOperands,
     /* 128492 */     // GIR_Coverage, 7080,
     /* 128492 */     GIR_EraseRootFromParent_Done,
     /* 128493 */   // Label 2459: @128493
     /* 128493 */   GIM_Try, /*On fail goto*//*Label 2460*/ GIMT_Encode4(128542), // Rule ID 7081 //
     /* 128498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128501 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128508 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 128511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128515 */     // MIs[0] Rn
     /* 128515 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128527 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_release>>  =>  (LDEORLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLW),
     /* 128530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128534 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128536 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128540 */     GIR_RootConstrainSelectedInstOperands,
     /* 128541 */     // GIR_Coverage, 7081,
     /* 128541 */     GIR_EraseRootFromParent_Done,
     /* 128542 */   // Label 2460: @128542
     /* 128542 */   GIM_Try, /*On fail goto*//*Label 2461*/ GIMT_Encode4(128591), // Rule ID 7082 //
     /* 128547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128550 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128557 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 128560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128564 */     // MIs[0] Rn
     /* 128564 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128568 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128576 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acq_rel>>  =>  (LDEORALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALW),
     /* 128579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128583 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128585 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128589 */     GIR_RootConstrainSelectedInstOperands,
     /* 128590 */     // GIR_Coverage, 7082,
     /* 128590 */     GIR_EraseRootFromParent_Done,
     /* 128591 */   // Label 2461: @128591
     /* 128591 */   GIM_Try, /*On fail goto*//*Label 2462*/ GIMT_Encode4(128640), // Rule ID 7083 //
     /* 128596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128599 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128606 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 128609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128613 */     // MIs[0] Rn
     /* 128613 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128617 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128625 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_seq_cst>>  =>  (LDEORALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALW),
     /* 128628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128632 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128634 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128638 */     GIR_RootConstrainSelectedInstOperands,
     /* 128639 */     // GIR_Coverage, 7083,
     /* 128639 */     GIR_EraseRootFromParent_Done,
     /* 128640 */   // Label 2462: @128640
     /* 128640 */   GIM_Try, /*On fail goto*//*Label 2463*/ GIMT_Encode4(128689), // Rule ID 7084 //
     /* 128645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128648 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128655 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 128658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128662 */     // MIs[0] Rn
     /* 128662 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128674 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_monotonic>>  =>  (LDEORH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORH),
     /* 128677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128681 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128683 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128687 */     GIR_RootConstrainSelectedInstOperands,
     /* 128688 */     // GIR_Coverage, 7084,
     /* 128688 */     GIR_EraseRootFromParent_Done,
     /* 128689 */   // Label 2463: @128689
     /* 128689 */   GIM_Try, /*On fail goto*//*Label 2464*/ GIMT_Encode4(128738), // Rule ID 7085 //
     /* 128694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128697 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128704 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128711 */     // MIs[0] Rn
     /* 128711 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128715 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128723 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acquire>>  =>  (LDEORAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAH),
     /* 128726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128730 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128732 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128736 */     GIR_RootConstrainSelectedInstOperands,
     /* 128737 */     // GIR_Coverage, 7085,
     /* 128737 */     GIR_EraseRootFromParent_Done,
     /* 128738 */   // Label 2464: @128738
     /* 128738 */   GIM_Try, /*On fail goto*//*Label 2465*/ GIMT_Encode4(128787), // Rule ID 7086 //
     /* 128743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128746 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128753 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 128756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128760 */     // MIs[0] Rn
     /* 128760 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128764 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128772 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_release>>  =>  (LDEORLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLH),
     /* 128775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128779 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128781 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128785 */     GIR_RootConstrainSelectedInstOperands,
     /* 128786 */     // GIR_Coverage, 7086,
     /* 128786 */     GIR_EraseRootFromParent_Done,
     /* 128787 */   // Label 2465: @128787
     /* 128787 */   GIM_Try, /*On fail goto*//*Label 2466*/ GIMT_Encode4(128836), // Rule ID 7087 //
     /* 128792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128795 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128802 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 128805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128809 */     // MIs[0] Rn
     /* 128809 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128821 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acq_rel>>  =>  (LDEORALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALH),
     /* 128824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128828 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128830 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128834 */     GIR_RootConstrainSelectedInstOperands,
     /* 128835 */     // GIR_Coverage, 7087,
     /* 128835 */     GIR_EraseRootFromParent_Done,
     /* 128836 */   // Label 2466: @128836
     /* 128836 */   GIM_Try, /*On fail goto*//*Label 2467*/ GIMT_Encode4(128885), // Rule ID 7088 //
     /* 128841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128844 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128851 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 128854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128858 */     // MIs[0] Rn
     /* 128858 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128862 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128870 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_seq_cst>>  =>  (LDEORALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALH),
     /* 128873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128877 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128879 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128883 */     GIR_RootConstrainSelectedInstOperands,
     /* 128884 */     // GIR_Coverage, 7088,
     /* 128884 */     GIR_EraseRootFromParent_Done,
     /* 128885 */   // Label 2467: @128885
     /* 128885 */   GIM_Try, /*On fail goto*//*Label 2468*/ GIMT_Encode4(128934), // Rule ID 7089 //
     /* 128890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128893 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128900 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 128903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128907 */     // MIs[0] Rn
     /* 128907 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128911 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128919 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_monotonic>>  =>  (LDEORB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORB),
     /* 128922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128926 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128928 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128932 */     GIR_RootConstrainSelectedInstOperands,
     /* 128933 */     // GIR_Coverage, 7089,
     /* 128933 */     GIR_EraseRootFromParent_Done,
     /* 128934 */   // Label 2468: @128934
     /* 128934 */   GIM_Try, /*On fail goto*//*Label 2469*/ GIMT_Encode4(128983), // Rule ID 7090 //
     /* 128939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128942 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128949 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128956 */     // MIs[0] Rn
     /* 128956 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128968 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acquire>>  =>  (LDEORAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAB),
     /* 128971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128975 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128977 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128981 */     GIR_RootConstrainSelectedInstOperands,
     /* 128982 */     // GIR_Coverage, 7090,
     /* 128982 */     GIR_EraseRootFromParent_Done,
     /* 128983 */   // Label 2469: @128983
     /* 128983 */   GIM_Try, /*On fail goto*//*Label 2470*/ GIMT_Encode4(129032), // Rule ID 7091 //
     /* 128988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128991 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128998 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 129001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129005 */     // MIs[0] Rn
     /* 129005 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129017 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_release>>  =>  (LDEORLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLB),
     /* 129020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129024 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129026 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129030 */     GIR_RootConstrainSelectedInstOperands,
     /* 129031 */     // GIR_Coverage, 7091,
     /* 129031 */     GIR_EraseRootFromParent_Done,
     /* 129032 */   // Label 2470: @129032
     /* 129032 */   GIM_Try, /*On fail goto*//*Label 2471*/ GIMT_Encode4(129081), // Rule ID 7092 //
     /* 129037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129040 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129047 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 129050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129054 */     // MIs[0] Rn
     /* 129054 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129066 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acq_rel>>  =>  (LDEORALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALB),
     /* 129069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129073 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129075 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129079 */     GIR_RootConstrainSelectedInstOperands,
     /* 129080 */     // GIR_Coverage, 7092,
     /* 129080 */     GIR_EraseRootFromParent_Done,
     /* 129081 */   // Label 2471: @129081
     /* 129081 */   GIM_Try, /*On fail goto*//*Label 2472*/ GIMT_Encode4(129130), // Rule ID 7093 //
     /* 129086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129089 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129096 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 129099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129103 */     // MIs[0] Rn
     /* 129103 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129107 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129115 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_seq_cst>>  =>  (LDEORALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALB),
     /* 129118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129120 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129122 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129124 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129128 */     GIR_RootConstrainSelectedInstOperands,
     /* 129129 */     // GIR_Coverage, 7093,
     /* 129129 */     GIR_EraseRootFromParent_Done,
     /* 129130 */   // Label 2472: @129130
     /* 129130 */   GIM_Reject,
     /* 129131 */ // Label 2457: @129131
     /* 129131 */ GIM_Reject,
     /* 129132 */ // Label 2455: @129132
     /* 129132 */ GIM_Try, /*On fail goto*//*Label 2473*/ GIMT_Encode4(129358),
     /* 129137 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 129140 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 129147 */   GIM_Try, /*On fail goto*//*Label 2474*/ GIMT_Encode4(129189), // Rule ID 7074 //
     /* 129152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129155 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 129158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129162 */     // MIs[0] Rn
     /* 129162 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129166 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129174 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_monotonic>>  =>  (LDEORX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORX),
     /* 129177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129181 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129183 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129187 */     GIR_RootConstrainSelectedInstOperands,
     /* 129188 */     // GIR_Coverage, 7074,
     /* 129188 */     GIR_EraseRootFromParent_Done,
     /* 129189 */   // Label 2474: @129189
     /* 129189 */   GIM_Try, /*On fail goto*//*Label 2475*/ GIMT_Encode4(129231), // Rule ID 7075 //
     /* 129194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129197 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129204 */     // MIs[0] Rn
     /* 129204 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129208 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129216 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acquire>>  =>  (LDEORAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAX),
     /* 129219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129223 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129225 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129229 */     GIR_RootConstrainSelectedInstOperands,
     /* 129230 */     // GIR_Coverage, 7075,
     /* 129230 */     GIR_EraseRootFromParent_Done,
     /* 129231 */   // Label 2475: @129231
     /* 129231 */   GIM_Try, /*On fail goto*//*Label 2476*/ GIMT_Encode4(129273), // Rule ID 7076 //
     /* 129236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129239 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 129242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129246 */     // MIs[0] Rn
     /* 129246 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129250 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129258 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_release>>  =>  (LDEORLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLX),
     /* 129261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129263 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129265 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129267 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129271 */     GIR_RootConstrainSelectedInstOperands,
     /* 129272 */     // GIR_Coverage, 7076,
     /* 129272 */     GIR_EraseRootFromParent_Done,
     /* 129273 */   // Label 2476: @129273
     /* 129273 */   GIM_Try, /*On fail goto*//*Label 2477*/ GIMT_Encode4(129315), // Rule ID 7077 //
     /* 129278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129281 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 129284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129288 */     // MIs[0] Rn
     /* 129288 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129292 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129300 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acq_rel>>  =>  (LDEORALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALX),
     /* 129303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129307 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129309 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129313 */     GIR_RootConstrainSelectedInstOperands,
     /* 129314 */     // GIR_Coverage, 7077,
     /* 129314 */     GIR_EraseRootFromParent_Done,
     /* 129315 */   // Label 2477: @129315
     /* 129315 */   GIM_Try, /*On fail goto*//*Label 2478*/ GIMT_Encode4(129357), // Rule ID 7078 //
     /* 129320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129323 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 129326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129330 */     // MIs[0] Rn
     /* 129330 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129334 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129342 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_seq_cst>>  =>  (LDEORALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALX),
     /* 129345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129349 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129351 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129355 */     GIR_RootConstrainSelectedInstOperands,
     /* 129356 */     // GIR_Coverage, 7078,
     /* 129356 */     GIR_EraseRootFromParent_Done,
     /* 129357 */   // Label 2478: @129357
     /* 129357 */   GIM_Reject,
     /* 129358 */ // Label 2473: @129358
     /* 129358 */ GIM_Reject,
     /* 129359 */ // Label 2456: @129359
     /* 129359 */ GIM_Reject,
     /* 129360 */ // Label 27: @129360
     /* 129360 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2481*/ GIMT_Encode4(130351),
     /* 129371 */ /*GILLT_s32*//*Label 2479*/ GIMT_Encode4(129379),
     /* 129375 */ /*GILLT_s64*//*Label 2480*/ GIMT_Encode4(130124),
     /* 129379 */ // Label 2479: @129379
     /* 129379 */ GIM_Try, /*On fail goto*//*Label 2482*/ GIMT_Encode4(130123),
     /* 129384 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 129387 */   GIM_Try, /*On fail goto*//*Label 2483*/ GIMT_Encode4(129436), // Rule ID 7119 //
     /* 129392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129395 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 129402 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 129405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129409 */     // MIs[0] Rn
     /* 129409 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129413 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129421 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_monotonic>>  =>  (LDSMAXW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXW),
     /* 129424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129428 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129430 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129434 */     GIR_RootConstrainSelectedInstOperands,
     /* 129435 */     // GIR_Coverage, 7119,
     /* 129435 */     GIR_EraseRootFromParent_Done,
     /* 129436 */   // Label 2483: @129436
     /* 129436 */   GIM_Try, /*On fail goto*//*Label 2484*/ GIMT_Encode4(129485), // Rule ID 7120 //
     /* 129441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129444 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 129451 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129458 */     // MIs[0] Rn
     /* 129458 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129462 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129470 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acquire>>  =>  (LDSMAXAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAW),
     /* 129473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129475 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129477 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129479 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129483 */     GIR_RootConstrainSelectedInstOperands,
     /* 129484 */     // GIR_Coverage, 7120,
     /* 129484 */     GIR_EraseRootFromParent_Done,
     /* 129485 */   // Label 2484: @129485
     /* 129485 */   GIM_Try, /*On fail goto*//*Label 2485*/ GIMT_Encode4(129534), // Rule ID 7121 //
     /* 129490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129493 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 129500 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 129503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129507 */     // MIs[0] Rn
     /* 129507 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129519 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_release>>  =>  (LDSMAXLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLW),
     /* 129522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129526 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129528 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129532 */     GIR_RootConstrainSelectedInstOperands,
     /* 129533 */     // GIR_Coverage, 7121,
     /* 129533 */     GIR_EraseRootFromParent_Done,
     /* 129534 */   // Label 2485: @129534
     /* 129534 */   GIM_Try, /*On fail goto*//*Label 2486*/ GIMT_Encode4(129583), // Rule ID 7122 //
     /* 129539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129542 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 129549 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 129552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129556 */     // MIs[0] Rn
     /* 129556 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129568 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acq_rel>>  =>  (LDSMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALW),
     /* 129571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129575 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129577 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129581 */     GIR_RootConstrainSelectedInstOperands,
     /* 129582 */     // GIR_Coverage, 7122,
     /* 129582 */     GIR_EraseRootFromParent_Done,
     /* 129583 */   // Label 2486: @129583
     /* 129583 */   GIM_Try, /*On fail goto*//*Label 2487*/ GIMT_Encode4(129632), // Rule ID 7123 //
     /* 129588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129591 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 129598 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 129601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129605 */     // MIs[0] Rn
     /* 129605 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129609 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129617 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_seq_cst>>  =>  (LDSMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALW),
     /* 129620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129622 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129624 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129626 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129630 */     GIR_RootConstrainSelectedInstOperands,
     /* 129631 */     // GIR_Coverage, 7123,
     /* 129631 */     GIR_EraseRootFromParent_Done,
     /* 129632 */   // Label 2487: @129632
     /* 129632 */   GIM_Try, /*On fail goto*//*Label 2488*/ GIMT_Encode4(129681), // Rule ID 7124 //
     /* 129637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129640 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129647 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 129650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129654 */     // MIs[0] Rn
     /* 129654 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129658 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129666 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_monotonic>>  =>  (LDSMAXH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXH),
     /* 129669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129673 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129675 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129679 */     GIR_RootConstrainSelectedInstOperands,
     /* 129680 */     // GIR_Coverage, 7124,
     /* 129680 */     GIR_EraseRootFromParent_Done,
     /* 129681 */   // Label 2488: @129681
     /* 129681 */   GIM_Try, /*On fail goto*//*Label 2489*/ GIMT_Encode4(129730), // Rule ID 7125 //
     /* 129686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129689 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129696 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129703 */     // MIs[0] Rn
     /* 129703 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129707 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129715 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acquire>>  =>  (LDSMAXAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAH),
     /* 129718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129722 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129724 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129728 */     GIR_RootConstrainSelectedInstOperands,
     /* 129729 */     // GIR_Coverage, 7125,
     /* 129729 */     GIR_EraseRootFromParent_Done,
     /* 129730 */   // Label 2489: @129730
     /* 129730 */   GIM_Try, /*On fail goto*//*Label 2490*/ GIMT_Encode4(129779), // Rule ID 7126 //
     /* 129735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129738 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129745 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 129748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129752 */     // MIs[0] Rn
     /* 129752 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129764 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_release>>  =>  (LDSMAXLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLH),
     /* 129767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129771 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129773 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129777 */     GIR_RootConstrainSelectedInstOperands,
     /* 129778 */     // GIR_Coverage, 7126,
     /* 129778 */     GIR_EraseRootFromParent_Done,
     /* 129779 */   // Label 2490: @129779
     /* 129779 */   GIM_Try, /*On fail goto*//*Label 2491*/ GIMT_Encode4(129828), // Rule ID 7127 //
     /* 129784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129787 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129794 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 129797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129801 */     // MIs[0] Rn
     /* 129801 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129813 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acq_rel>>  =>  (LDSMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALH),
     /* 129816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129818 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129820 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129822 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129826 */     GIR_RootConstrainSelectedInstOperands,
     /* 129827 */     // GIR_Coverage, 7127,
     /* 129827 */     GIR_EraseRootFromParent_Done,
     /* 129828 */   // Label 2491: @129828
     /* 129828 */   GIM_Try, /*On fail goto*//*Label 2492*/ GIMT_Encode4(129877), // Rule ID 7128 //
     /* 129833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129836 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129843 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 129846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129850 */     // MIs[0] Rn
     /* 129850 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129862 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_seq_cst>>  =>  (LDSMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALH),
     /* 129865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129867 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129869 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129871 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129875 */     GIR_RootConstrainSelectedInstOperands,
     /* 129876 */     // GIR_Coverage, 7128,
     /* 129876 */     GIR_EraseRootFromParent_Done,
     /* 129877 */   // Label 2492: @129877
     /* 129877 */   GIM_Try, /*On fail goto*//*Label 2493*/ GIMT_Encode4(129926), // Rule ID 7129 //
     /* 129882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129885 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129892 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 129895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129899 */     // MIs[0] Rn
     /* 129899 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129903 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129911 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_monotonic>>  =>  (LDSMAXB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXB),
     /* 129914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129918 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129920 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129924 */     GIR_RootConstrainSelectedInstOperands,
     /* 129925 */     // GIR_Coverage, 7129,
     /* 129925 */     GIR_EraseRootFromParent_Done,
     /* 129926 */   // Label 2493: @129926
     /* 129926 */   GIM_Try, /*On fail goto*//*Label 2494*/ GIMT_Encode4(129975), // Rule ID 7130 //
     /* 129931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129934 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129941 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129948 */     // MIs[0] Rn
     /* 129948 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129952 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129960 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acquire>>  =>  (LDSMAXAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 129960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAB),
     /* 129963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 129967 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129969 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129973 */     GIR_RootConstrainSelectedInstOperands,
     /* 129974 */     // GIR_Coverage, 7130,
     /* 129974 */     GIR_EraseRootFromParent_Done,
     /* 129975 */   // Label 2494: @129975
     /* 129975 */   GIM_Try, /*On fail goto*//*Label 2495*/ GIMT_Encode4(130024), // Rule ID 7131 //
     /* 129980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129983 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129990 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 129993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129997 */     // MIs[0] Rn
     /* 129997 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130001 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130009 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_release>>  =>  (LDSMAXLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLB),
     /* 130012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130016 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130018 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130022 */     GIR_RootConstrainSelectedInstOperands,
     /* 130023 */     // GIR_Coverage, 7131,
     /* 130023 */     GIR_EraseRootFromParent_Done,
     /* 130024 */   // Label 2495: @130024
     /* 130024 */   GIM_Try, /*On fail goto*//*Label 2496*/ GIMT_Encode4(130073), // Rule ID 7132 //
     /* 130029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130032 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130039 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 130042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130046 */     // MIs[0] Rn
     /* 130046 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130058 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acq_rel>>  =>  (LDSMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALB),
     /* 130061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130065 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130067 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130071 */     GIR_RootConstrainSelectedInstOperands,
     /* 130072 */     // GIR_Coverage, 7132,
     /* 130072 */     GIR_EraseRootFromParent_Done,
     /* 130073 */   // Label 2496: @130073
     /* 130073 */   GIM_Try, /*On fail goto*//*Label 2497*/ GIMT_Encode4(130122), // Rule ID 7133 //
     /* 130078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130081 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130088 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 130091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130095 */     // MIs[0] Rn
     /* 130095 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130099 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130107 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_seq_cst>>  =>  (LDSMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALB),
     /* 130110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130114 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130116 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130120 */     GIR_RootConstrainSelectedInstOperands,
     /* 130121 */     // GIR_Coverage, 7133,
     /* 130121 */     GIR_EraseRootFromParent_Done,
     /* 130122 */   // Label 2497: @130122
     /* 130122 */   GIM_Reject,
     /* 130123 */ // Label 2482: @130123
     /* 130123 */ GIM_Reject,
     /* 130124 */ // Label 2480: @130124
     /* 130124 */ GIM_Try, /*On fail goto*//*Label 2498*/ GIMT_Encode4(130350),
     /* 130129 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 130132 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 130139 */   GIM_Try, /*On fail goto*//*Label 2499*/ GIMT_Encode4(130181), // Rule ID 7114 //
     /* 130144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130147 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 130150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130154 */     // MIs[0] Rn
     /* 130154 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130158 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130166 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_monotonic>>  =>  (LDSMAXX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXX),
     /* 130169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130173 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130175 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130179 */     GIR_RootConstrainSelectedInstOperands,
     /* 130180 */     // GIR_Coverage, 7114,
     /* 130180 */     GIR_EraseRootFromParent_Done,
     /* 130181 */   // Label 2499: @130181
     /* 130181 */   GIM_Try, /*On fail goto*//*Label 2500*/ GIMT_Encode4(130223), // Rule ID 7115 //
     /* 130186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130189 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 130192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130196 */     // MIs[0] Rn
     /* 130196 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130208 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acquire>>  =>  (LDSMAXAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAX),
     /* 130211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130215 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130217 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130221 */     GIR_RootConstrainSelectedInstOperands,
     /* 130222 */     // GIR_Coverage, 7115,
     /* 130222 */     GIR_EraseRootFromParent_Done,
     /* 130223 */   // Label 2500: @130223
     /* 130223 */   GIM_Try, /*On fail goto*//*Label 2501*/ GIMT_Encode4(130265), // Rule ID 7116 //
     /* 130228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130231 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 130234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130238 */     // MIs[0] Rn
     /* 130238 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130242 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130250 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_release>>  =>  (LDSMAXLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLX),
     /* 130253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130257 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130259 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130263 */     GIR_RootConstrainSelectedInstOperands,
     /* 130264 */     // GIR_Coverage, 7116,
     /* 130264 */     GIR_EraseRootFromParent_Done,
     /* 130265 */   // Label 2501: @130265
     /* 130265 */   GIM_Try, /*On fail goto*//*Label 2502*/ GIMT_Encode4(130307), // Rule ID 7117 //
     /* 130270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130273 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 130276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130280 */     // MIs[0] Rn
     /* 130280 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130284 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130292 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acq_rel>>  =>  (LDSMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALX),
     /* 130295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130299 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130301 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130305 */     GIR_RootConstrainSelectedInstOperands,
     /* 130306 */     // GIR_Coverage, 7117,
     /* 130306 */     GIR_EraseRootFromParent_Done,
     /* 130307 */   // Label 2502: @130307
     /* 130307 */   GIM_Try, /*On fail goto*//*Label 2503*/ GIMT_Encode4(130349), // Rule ID 7118 //
     /* 130312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130315 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 130318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130322 */     // MIs[0] Rn
     /* 130322 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130334 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_seq_cst>>  =>  (LDSMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALX),
     /* 130337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130339 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130341 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130343 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130347 */     GIR_RootConstrainSelectedInstOperands,
     /* 130348 */     // GIR_Coverage, 7118,
     /* 130348 */     GIR_EraseRootFromParent_Done,
     /* 130349 */   // Label 2503: @130349
     /* 130349 */   GIM_Reject,
     /* 130350 */ // Label 2498: @130350
     /* 130350 */ GIM_Reject,
     /* 130351 */ // Label 2481: @130351
     /* 130351 */ GIM_Reject,
     /* 130352 */ // Label 28: @130352
     /* 130352 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2506*/ GIMT_Encode4(131343),
     /* 130363 */ /*GILLT_s32*//*Label 2504*/ GIMT_Encode4(130371),
     /* 130367 */ /*GILLT_s64*//*Label 2505*/ GIMT_Encode4(131116),
     /* 130371 */ // Label 2504: @130371
     /* 130371 */ GIM_Try, /*On fail goto*//*Label 2507*/ GIMT_Encode4(131115),
     /* 130376 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 130379 */   GIM_Try, /*On fail goto*//*Label 2508*/ GIMT_Encode4(130428), // Rule ID 7139 //
     /* 130384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130387 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 130394 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 130397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130401 */     // MIs[0] Rn
     /* 130401 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130413 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_monotonic>>  =>  (LDSMINW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINW),
     /* 130416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130418 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130420 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130422 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130426 */     GIR_RootConstrainSelectedInstOperands,
     /* 130427 */     // GIR_Coverage, 7139,
     /* 130427 */     GIR_EraseRootFromParent_Done,
     /* 130428 */   // Label 2508: @130428
     /* 130428 */   GIM_Try, /*On fail goto*//*Label 2509*/ GIMT_Encode4(130477), // Rule ID 7140 //
     /* 130433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130436 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 130443 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 130446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130450 */     // MIs[0] Rn
     /* 130450 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130462 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acquire>>  =>  (LDSMINAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAW),
     /* 130465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130469 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130471 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130475 */     GIR_RootConstrainSelectedInstOperands,
     /* 130476 */     // GIR_Coverage, 7140,
     /* 130476 */     GIR_EraseRootFromParent_Done,
     /* 130477 */   // Label 2509: @130477
     /* 130477 */   GIM_Try, /*On fail goto*//*Label 2510*/ GIMT_Encode4(130526), // Rule ID 7141 //
     /* 130482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130485 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 130492 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 130495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130499 */     // MIs[0] Rn
     /* 130499 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130503 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130511 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_release>>  =>  (LDSMINLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLW),
     /* 130514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130518 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130520 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130524 */     GIR_RootConstrainSelectedInstOperands,
     /* 130525 */     // GIR_Coverage, 7141,
     /* 130525 */     GIR_EraseRootFromParent_Done,
     /* 130526 */   // Label 2510: @130526
     /* 130526 */   GIM_Try, /*On fail goto*//*Label 2511*/ GIMT_Encode4(130575), // Rule ID 7142 //
     /* 130531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130534 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 130541 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 130544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130548 */     // MIs[0] Rn
     /* 130548 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130552 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130560 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acq_rel>>  =>  (LDSMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALW),
     /* 130563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130565 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130567 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130569 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130573 */     GIR_RootConstrainSelectedInstOperands,
     /* 130574 */     // GIR_Coverage, 7142,
     /* 130574 */     GIR_EraseRootFromParent_Done,
     /* 130575 */   // Label 2511: @130575
     /* 130575 */   GIM_Try, /*On fail goto*//*Label 2512*/ GIMT_Encode4(130624), // Rule ID 7143 //
     /* 130580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130583 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 130590 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 130593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130597 */     // MIs[0] Rn
     /* 130597 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130609 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_seq_cst>>  =>  (LDSMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALW),
     /* 130612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130614 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130616 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130618 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130622 */     GIR_RootConstrainSelectedInstOperands,
     /* 130623 */     // GIR_Coverage, 7143,
     /* 130623 */     GIR_EraseRootFromParent_Done,
     /* 130624 */   // Label 2512: @130624
     /* 130624 */   GIM_Try, /*On fail goto*//*Label 2513*/ GIMT_Encode4(130673), // Rule ID 7144 //
     /* 130629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130632 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 130639 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 130642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130646 */     // MIs[0] Rn
     /* 130646 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130658 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_monotonic>>  =>  (LDSMINH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINH),
     /* 130661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130663 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130665 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130667 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130671 */     GIR_RootConstrainSelectedInstOperands,
     /* 130672 */     // GIR_Coverage, 7144,
     /* 130672 */     GIR_EraseRootFromParent_Done,
     /* 130673 */   // Label 2513: @130673
     /* 130673 */   GIM_Try, /*On fail goto*//*Label 2514*/ GIMT_Encode4(130722), // Rule ID 7145 //
     /* 130678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130681 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 130688 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 130691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130695 */     // MIs[0] Rn
     /* 130695 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130699 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130707 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acquire>>  =>  (LDSMINAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAH),
     /* 130710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130714 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130716 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130720 */     GIR_RootConstrainSelectedInstOperands,
     /* 130721 */     // GIR_Coverage, 7145,
     /* 130721 */     GIR_EraseRootFromParent_Done,
     /* 130722 */   // Label 2514: @130722
     /* 130722 */   GIM_Try, /*On fail goto*//*Label 2515*/ GIMT_Encode4(130771), // Rule ID 7146 //
     /* 130727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130730 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 130737 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 130740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130744 */     // MIs[0] Rn
     /* 130744 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130748 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130756 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_release>>  =>  (LDSMINLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLH),
     /* 130759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130763 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130765 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130769 */     GIR_RootConstrainSelectedInstOperands,
     /* 130770 */     // GIR_Coverage, 7146,
     /* 130770 */     GIR_EraseRootFromParent_Done,
     /* 130771 */   // Label 2515: @130771
     /* 130771 */   GIM_Try, /*On fail goto*//*Label 2516*/ GIMT_Encode4(130820), // Rule ID 7147 //
     /* 130776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130779 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 130786 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 130789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130793 */     // MIs[0] Rn
     /* 130793 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130797 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130805 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acq_rel>>  =>  (LDSMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALH),
     /* 130808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130812 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130814 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130818 */     GIR_RootConstrainSelectedInstOperands,
     /* 130819 */     // GIR_Coverage, 7147,
     /* 130819 */     GIR_EraseRootFromParent_Done,
     /* 130820 */   // Label 2516: @130820
     /* 130820 */   GIM_Try, /*On fail goto*//*Label 2517*/ GIMT_Encode4(130869), // Rule ID 7148 //
     /* 130825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130828 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 130835 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 130838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130842 */     // MIs[0] Rn
     /* 130842 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130854 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_seq_cst>>  =>  (LDSMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALH),
     /* 130857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130861 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130863 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130867 */     GIR_RootConstrainSelectedInstOperands,
     /* 130868 */     // GIR_Coverage, 7148,
     /* 130868 */     GIR_EraseRootFromParent_Done,
     /* 130869 */   // Label 2517: @130869
     /* 130869 */   GIM_Try, /*On fail goto*//*Label 2518*/ GIMT_Encode4(130918), // Rule ID 7149 //
     /* 130874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130877 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130884 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 130887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130891 */     // MIs[0] Rn
     /* 130891 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130903 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_monotonic>>  =>  (LDSMINB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINB),
     /* 130906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130910 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130912 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130916 */     GIR_RootConstrainSelectedInstOperands,
     /* 130917 */     // GIR_Coverage, 7149,
     /* 130917 */     GIR_EraseRootFromParent_Done,
     /* 130918 */   // Label 2518: @130918
     /* 130918 */   GIM_Try, /*On fail goto*//*Label 2519*/ GIMT_Encode4(130967), // Rule ID 7150 //
     /* 130923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130926 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130933 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 130936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130940 */     // MIs[0] Rn
     /* 130940 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130952 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acquire>>  =>  (LDSMINAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAB),
     /* 130955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130959 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130961 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130965 */     GIR_RootConstrainSelectedInstOperands,
     /* 130966 */     // GIR_Coverage, 7150,
     /* 130966 */     GIR_EraseRootFromParent_Done,
     /* 130967 */   // Label 2519: @130967
     /* 130967 */   GIM_Try, /*On fail goto*//*Label 2520*/ GIMT_Encode4(131016), // Rule ID 7151 //
     /* 130972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130975 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130982 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 130985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130989 */     // MIs[0] Rn
     /* 130989 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130993 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131001 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_release>>  =>  (LDSMINLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLB),
     /* 131004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131006 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131008 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131010 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131014 */     GIR_RootConstrainSelectedInstOperands,
     /* 131015 */     // GIR_Coverage, 7151,
     /* 131015 */     GIR_EraseRootFromParent_Done,
     /* 131016 */   // Label 2520: @131016
     /* 131016 */   GIM_Try, /*On fail goto*//*Label 2521*/ GIMT_Encode4(131065), // Rule ID 7152 //
     /* 131021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131024 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 131031 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 131034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131038 */     // MIs[0] Rn
     /* 131038 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131042 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131050 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acq_rel>>  =>  (LDSMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALB),
     /* 131053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131057 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131059 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131063 */     GIR_RootConstrainSelectedInstOperands,
     /* 131064 */     // GIR_Coverage, 7152,
     /* 131064 */     GIR_EraseRootFromParent_Done,
     /* 131065 */   // Label 2521: @131065
     /* 131065 */   GIM_Try, /*On fail goto*//*Label 2522*/ GIMT_Encode4(131114), // Rule ID 7153 //
     /* 131070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131073 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 131080 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 131083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131087 */     // MIs[0] Rn
     /* 131087 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131099 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_seq_cst>>  =>  (LDSMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALB),
     /* 131102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131104 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131106 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131108 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131112 */     GIR_RootConstrainSelectedInstOperands,
     /* 131113 */     // GIR_Coverage, 7153,
     /* 131113 */     GIR_EraseRootFromParent_Done,
     /* 131114 */   // Label 2522: @131114
     /* 131114 */   GIM_Reject,
     /* 131115 */ // Label 2507: @131115
     /* 131115 */ GIM_Reject,
     /* 131116 */ // Label 2505: @131116
     /* 131116 */ GIM_Try, /*On fail goto*//*Label 2523*/ GIMT_Encode4(131342),
     /* 131121 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 131124 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 131131 */   GIM_Try, /*On fail goto*//*Label 2524*/ GIMT_Encode4(131173), // Rule ID 7134 //
     /* 131136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131139 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 131142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131146 */     // MIs[0] Rn
     /* 131146 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131150 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131158 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_monotonic>>  =>  (LDSMINX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINX),
     /* 131161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131163 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131165 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131167 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131171 */     GIR_RootConstrainSelectedInstOperands,
     /* 131172 */     // GIR_Coverage, 7134,
     /* 131172 */     GIR_EraseRootFromParent_Done,
     /* 131173 */   // Label 2524: @131173
     /* 131173 */   GIM_Try, /*On fail goto*//*Label 2525*/ GIMT_Encode4(131215), // Rule ID 7135 //
     /* 131178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131181 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 131184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131188 */     // MIs[0] Rn
     /* 131188 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131200 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acquire>>  =>  (LDSMINAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAX),
     /* 131203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131207 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131209 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131213 */     GIR_RootConstrainSelectedInstOperands,
     /* 131214 */     // GIR_Coverage, 7135,
     /* 131214 */     GIR_EraseRootFromParent_Done,
     /* 131215 */   // Label 2525: @131215
     /* 131215 */   GIM_Try, /*On fail goto*//*Label 2526*/ GIMT_Encode4(131257), // Rule ID 7136 //
     /* 131220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131223 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 131226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131230 */     // MIs[0] Rn
     /* 131230 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131234 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131242 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_release>>  =>  (LDSMINLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLX),
     /* 131245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131249 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131251 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131255 */     GIR_RootConstrainSelectedInstOperands,
     /* 131256 */     // GIR_Coverage, 7136,
     /* 131256 */     GIR_EraseRootFromParent_Done,
     /* 131257 */   // Label 2526: @131257
     /* 131257 */   GIM_Try, /*On fail goto*//*Label 2527*/ GIMT_Encode4(131299), // Rule ID 7137 //
     /* 131262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131265 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 131268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131272 */     // MIs[0] Rn
     /* 131272 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131276 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131284 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acq_rel>>  =>  (LDSMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALX),
     /* 131287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131291 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131293 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131297 */     GIR_RootConstrainSelectedInstOperands,
     /* 131298 */     // GIR_Coverage, 7137,
     /* 131298 */     GIR_EraseRootFromParent_Done,
     /* 131299 */   // Label 2527: @131299
     /* 131299 */   GIM_Try, /*On fail goto*//*Label 2528*/ GIMT_Encode4(131341), // Rule ID 7138 //
     /* 131304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131307 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 131310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131314 */     // MIs[0] Rn
     /* 131314 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131318 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131326 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_seq_cst>>  =>  (LDSMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALX),
     /* 131329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131333 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131335 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131339 */     GIR_RootConstrainSelectedInstOperands,
     /* 131340 */     // GIR_Coverage, 7138,
     /* 131340 */     GIR_EraseRootFromParent_Done,
     /* 131341 */   // Label 2528: @131341
     /* 131341 */   GIM_Reject,
     /* 131342 */ // Label 2523: @131342
     /* 131342 */ GIM_Reject,
     /* 131343 */ // Label 2506: @131343
     /* 131343 */ GIM_Reject,
     /* 131344 */ // Label 29: @131344
     /* 131344 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2531*/ GIMT_Encode4(132335),
     /* 131355 */ /*GILLT_s32*//*Label 2529*/ GIMT_Encode4(131363),
     /* 131359 */ /*GILLT_s64*//*Label 2530*/ GIMT_Encode4(132108),
     /* 131363 */ // Label 2529: @131363
     /* 131363 */ GIM_Try, /*On fail goto*//*Label 2532*/ GIMT_Encode4(132107),
     /* 131368 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 131371 */   GIM_Try, /*On fail goto*//*Label 2533*/ GIMT_Encode4(131420), // Rule ID 7159 //
     /* 131376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131379 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 131386 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 131389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131393 */     // MIs[0] Rn
     /* 131393 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131405 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_monotonic>>  =>  (LDUMAXW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXW),
     /* 131408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131410 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131412 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131414 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131418 */     GIR_RootConstrainSelectedInstOperands,
     /* 131419 */     // GIR_Coverage, 7159,
     /* 131419 */     GIR_EraseRootFromParent_Done,
     /* 131420 */   // Label 2533: @131420
     /* 131420 */   GIM_Try, /*On fail goto*//*Label 2534*/ GIMT_Encode4(131469), // Rule ID 7160 //
     /* 131425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131428 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 131435 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 131438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131442 */     // MIs[0] Rn
     /* 131442 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131446 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131454 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acquire>>  =>  (LDUMAXAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAW),
     /* 131457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131461 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131463 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131467 */     GIR_RootConstrainSelectedInstOperands,
     /* 131468 */     // GIR_Coverage, 7160,
     /* 131468 */     GIR_EraseRootFromParent_Done,
     /* 131469 */   // Label 2534: @131469
     /* 131469 */   GIM_Try, /*On fail goto*//*Label 2535*/ GIMT_Encode4(131518), // Rule ID 7161 //
     /* 131474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131477 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 131484 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 131487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131491 */     // MIs[0] Rn
     /* 131491 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131503 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_release>>  =>  (LDUMAXLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLW),
     /* 131506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131510 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131512 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131516 */     GIR_RootConstrainSelectedInstOperands,
     /* 131517 */     // GIR_Coverage, 7161,
     /* 131517 */     GIR_EraseRootFromParent_Done,
     /* 131518 */   // Label 2535: @131518
     /* 131518 */   GIM_Try, /*On fail goto*//*Label 2536*/ GIMT_Encode4(131567), // Rule ID 7162 //
     /* 131523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131526 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 131533 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 131536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131540 */     // MIs[0] Rn
     /* 131540 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131552 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acq_rel>>  =>  (LDUMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALW),
     /* 131555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131559 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131561 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131565 */     GIR_RootConstrainSelectedInstOperands,
     /* 131566 */     // GIR_Coverage, 7162,
     /* 131566 */     GIR_EraseRootFromParent_Done,
     /* 131567 */   // Label 2536: @131567
     /* 131567 */   GIM_Try, /*On fail goto*//*Label 2537*/ GIMT_Encode4(131616), // Rule ID 7163 //
     /* 131572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131575 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 131582 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 131585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131589 */     // MIs[0] Rn
     /* 131589 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131601 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_seq_cst>>  =>  (LDUMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALW),
     /* 131604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131608 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131610 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131614 */     GIR_RootConstrainSelectedInstOperands,
     /* 131615 */     // GIR_Coverage, 7163,
     /* 131615 */     GIR_EraseRootFromParent_Done,
     /* 131616 */   // Label 2537: @131616
     /* 131616 */   GIM_Try, /*On fail goto*//*Label 2538*/ GIMT_Encode4(131665), // Rule ID 7164 //
     /* 131621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131624 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131631 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 131634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131638 */     // MIs[0] Rn
     /* 131638 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131642 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131650 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_monotonic>>  =>  (LDUMAXH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXH),
     /* 131653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131657 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131659 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131663 */     GIR_RootConstrainSelectedInstOperands,
     /* 131664 */     // GIR_Coverage, 7164,
     /* 131664 */     GIR_EraseRootFromParent_Done,
     /* 131665 */   // Label 2538: @131665
     /* 131665 */   GIM_Try, /*On fail goto*//*Label 2539*/ GIMT_Encode4(131714), // Rule ID 7165 //
     /* 131670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131673 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131680 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 131683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131687 */     // MIs[0] Rn
     /* 131687 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131691 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131699 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acquire>>  =>  (LDUMAXAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAH),
     /* 131702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131704 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131706 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131708 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131712 */     GIR_RootConstrainSelectedInstOperands,
     /* 131713 */     // GIR_Coverage, 7165,
     /* 131713 */     GIR_EraseRootFromParent_Done,
     /* 131714 */   // Label 2539: @131714
     /* 131714 */   GIM_Try, /*On fail goto*//*Label 2540*/ GIMT_Encode4(131763), // Rule ID 7166 //
     /* 131719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131722 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131729 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 131732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131736 */     // MIs[0] Rn
     /* 131736 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131748 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_release>>  =>  (LDUMAXLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLH),
     /* 131751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131755 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131757 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131761 */     GIR_RootConstrainSelectedInstOperands,
     /* 131762 */     // GIR_Coverage, 7166,
     /* 131762 */     GIR_EraseRootFromParent_Done,
     /* 131763 */   // Label 2540: @131763
     /* 131763 */   GIM_Try, /*On fail goto*//*Label 2541*/ GIMT_Encode4(131812), // Rule ID 7167 //
     /* 131768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131771 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131778 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 131781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131785 */     // MIs[0] Rn
     /* 131785 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131789 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131797 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acq_rel>>  =>  (LDUMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALH),
     /* 131800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131802 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131804 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131806 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131810 */     GIR_RootConstrainSelectedInstOperands,
     /* 131811 */     // GIR_Coverage, 7167,
     /* 131811 */     GIR_EraseRootFromParent_Done,
     /* 131812 */   // Label 2541: @131812
     /* 131812 */   GIM_Try, /*On fail goto*//*Label 2542*/ GIMT_Encode4(131861), // Rule ID 7168 //
     /* 131817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131820 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131827 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 131830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131834 */     // MIs[0] Rn
     /* 131834 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131838 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131846 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_seq_cst>>  =>  (LDUMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALH),
     /* 131849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131853 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131855 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131859 */     GIR_RootConstrainSelectedInstOperands,
     /* 131860 */     // GIR_Coverage, 7168,
     /* 131860 */     GIR_EraseRootFromParent_Done,
     /* 131861 */   // Label 2542: @131861
     /* 131861 */   GIM_Try, /*On fail goto*//*Label 2543*/ GIMT_Encode4(131910), // Rule ID 7169 //
     /* 131866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131869 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 131876 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 131879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131883 */     // MIs[0] Rn
     /* 131883 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131895 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_monotonic>>  =>  (LDUMAXB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXB),
     /* 131898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131900 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131902 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131904 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131908 */     GIR_RootConstrainSelectedInstOperands,
     /* 131909 */     // GIR_Coverage, 7169,
     /* 131909 */     GIR_EraseRootFromParent_Done,
     /* 131910 */   // Label 2543: @131910
     /* 131910 */   GIM_Try, /*On fail goto*//*Label 2544*/ GIMT_Encode4(131959), // Rule ID 7170 //
     /* 131915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131918 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 131925 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 131928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131932 */     // MIs[0] Rn
     /* 131932 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131944 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acquire>>  =>  (LDUMAXAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAB),
     /* 131947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131951 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131953 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131957 */     GIR_RootConstrainSelectedInstOperands,
     /* 131958 */     // GIR_Coverage, 7170,
     /* 131958 */     GIR_EraseRootFromParent_Done,
     /* 131959 */   // Label 2544: @131959
     /* 131959 */   GIM_Try, /*On fail goto*//*Label 2545*/ GIMT_Encode4(132008), // Rule ID 7171 //
     /* 131964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131967 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 131974 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 131977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131981 */     // MIs[0] Rn
     /* 131981 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131985 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131993 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_release>>  =>  (LDUMAXLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLB),
     /* 131996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132000 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132002 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132006 */     GIR_RootConstrainSelectedInstOperands,
     /* 132007 */     // GIR_Coverage, 7171,
     /* 132007 */     GIR_EraseRootFromParent_Done,
     /* 132008 */   // Label 2545: @132008
     /* 132008 */   GIM_Try, /*On fail goto*//*Label 2546*/ GIMT_Encode4(132057), // Rule ID 7172 //
     /* 132013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132016 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 132023 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 132026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132030 */     // MIs[0] Rn
     /* 132030 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132034 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132042 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acq_rel>>  =>  (LDUMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALB),
     /* 132045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132047 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132049 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132051 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132055 */     GIR_RootConstrainSelectedInstOperands,
     /* 132056 */     // GIR_Coverage, 7172,
     /* 132056 */     GIR_EraseRootFromParent_Done,
     /* 132057 */   // Label 2546: @132057
     /* 132057 */   GIM_Try, /*On fail goto*//*Label 2547*/ GIMT_Encode4(132106), // Rule ID 7173 //
     /* 132062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132065 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 132072 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 132075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132079 */     // MIs[0] Rn
     /* 132079 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132083 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132091 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_seq_cst>>  =>  (LDUMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALB),
     /* 132094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132096 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132098 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132100 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132104 */     GIR_RootConstrainSelectedInstOperands,
     /* 132105 */     // GIR_Coverage, 7173,
     /* 132105 */     GIR_EraseRootFromParent_Done,
     /* 132106 */   // Label 2547: @132106
     /* 132106 */   GIM_Reject,
     /* 132107 */ // Label 2532: @132107
     /* 132107 */ GIM_Reject,
     /* 132108 */ // Label 2530: @132108
     /* 132108 */ GIM_Try, /*On fail goto*//*Label 2548*/ GIMT_Encode4(132334),
     /* 132113 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 132116 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 132123 */   GIM_Try, /*On fail goto*//*Label 2549*/ GIMT_Encode4(132165), // Rule ID 7154 //
     /* 132128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132131 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 132134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132138 */     // MIs[0] Rn
     /* 132138 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132150 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_monotonic>>  =>  (LDUMAXX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXX),
     /* 132153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132155 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132157 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132159 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132163 */     GIR_RootConstrainSelectedInstOperands,
     /* 132164 */     // GIR_Coverage, 7154,
     /* 132164 */     GIR_EraseRootFromParent_Done,
     /* 132165 */   // Label 2549: @132165
     /* 132165 */   GIM_Try, /*On fail goto*//*Label 2550*/ GIMT_Encode4(132207), // Rule ID 7155 //
     /* 132170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132173 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 132176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132180 */     // MIs[0] Rn
     /* 132180 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132192 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acquire>>  =>  (LDUMAXAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAX),
     /* 132195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132199 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132201 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132205 */     GIR_RootConstrainSelectedInstOperands,
     /* 132206 */     // GIR_Coverage, 7155,
     /* 132206 */     GIR_EraseRootFromParent_Done,
     /* 132207 */   // Label 2550: @132207
     /* 132207 */   GIM_Try, /*On fail goto*//*Label 2551*/ GIMT_Encode4(132249), // Rule ID 7156 //
     /* 132212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132215 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 132218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132222 */     // MIs[0] Rn
     /* 132222 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132226 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132234 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_release>>  =>  (LDUMAXLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLX),
     /* 132237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132241 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132243 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132247 */     GIR_RootConstrainSelectedInstOperands,
     /* 132248 */     // GIR_Coverage, 7156,
     /* 132248 */     GIR_EraseRootFromParent_Done,
     /* 132249 */   // Label 2551: @132249
     /* 132249 */   GIM_Try, /*On fail goto*//*Label 2552*/ GIMT_Encode4(132291), // Rule ID 7157 //
     /* 132254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132257 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 132260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132264 */     // MIs[0] Rn
     /* 132264 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132268 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132276 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acq_rel>>  =>  (LDUMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALX),
     /* 132279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132283 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132285 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132289 */     GIR_RootConstrainSelectedInstOperands,
     /* 132290 */     // GIR_Coverage, 7157,
     /* 132290 */     GIR_EraseRootFromParent_Done,
     /* 132291 */   // Label 2552: @132291
     /* 132291 */   GIM_Try, /*On fail goto*//*Label 2553*/ GIMT_Encode4(132333), // Rule ID 7158 //
     /* 132296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132299 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 132302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132306 */     // MIs[0] Rn
     /* 132306 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132318 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_seq_cst>>  =>  (LDUMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALX),
     /* 132321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132323 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132325 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132327 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132331 */     GIR_RootConstrainSelectedInstOperands,
     /* 132332 */     // GIR_Coverage, 7158,
     /* 132332 */     GIR_EraseRootFromParent_Done,
     /* 132333 */   // Label 2553: @132333
     /* 132333 */   GIM_Reject,
     /* 132334 */ // Label 2548: @132334
     /* 132334 */ GIM_Reject,
     /* 132335 */ // Label 2531: @132335
     /* 132335 */ GIM_Reject,
     /* 132336 */ // Label 30: @132336
     /* 132336 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2556*/ GIMT_Encode4(133327),
     /* 132347 */ /*GILLT_s32*//*Label 2554*/ GIMT_Encode4(132355),
     /* 132351 */ /*GILLT_s64*//*Label 2555*/ GIMT_Encode4(133100),
     /* 132355 */ // Label 2554: @132355
     /* 132355 */ GIM_Try, /*On fail goto*//*Label 2557*/ GIMT_Encode4(133099),
     /* 132360 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 132363 */   GIM_Try, /*On fail goto*//*Label 2558*/ GIMT_Encode4(132412), // Rule ID 7179 //
     /* 132368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132371 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 132378 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 132381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132385 */     // MIs[0] Rn
     /* 132385 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132389 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132397 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_monotonic>>  =>  (LDUMINW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINW),
     /* 132400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132404 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132406 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132410 */     GIR_RootConstrainSelectedInstOperands,
     /* 132411 */     // GIR_Coverage, 7179,
     /* 132411 */     GIR_EraseRootFromParent_Done,
     /* 132412 */   // Label 2558: @132412
     /* 132412 */   GIM_Try, /*On fail goto*//*Label 2559*/ GIMT_Encode4(132461), // Rule ID 7180 //
     /* 132417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132420 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 132427 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 132430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132434 */     // MIs[0] Rn
     /* 132434 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132446 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acquire>>  =>  (LDUMINAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAW),
     /* 132449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132453 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132455 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132459 */     GIR_RootConstrainSelectedInstOperands,
     /* 132460 */     // GIR_Coverage, 7180,
     /* 132460 */     GIR_EraseRootFromParent_Done,
     /* 132461 */   // Label 2559: @132461
     /* 132461 */   GIM_Try, /*On fail goto*//*Label 2560*/ GIMT_Encode4(132510), // Rule ID 7181 //
     /* 132466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132469 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 132476 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 132479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132483 */     // MIs[0] Rn
     /* 132483 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132495 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_release>>  =>  (LDUMINLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLW),
     /* 132498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132502 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132504 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132508 */     GIR_RootConstrainSelectedInstOperands,
     /* 132509 */     // GIR_Coverage, 7181,
     /* 132509 */     GIR_EraseRootFromParent_Done,
     /* 132510 */   // Label 2560: @132510
     /* 132510 */   GIM_Try, /*On fail goto*//*Label 2561*/ GIMT_Encode4(132559), // Rule ID 7182 //
     /* 132515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132518 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 132525 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 132528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132532 */     // MIs[0] Rn
     /* 132532 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132536 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132544 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acq_rel>>  =>  (LDUMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALW),
     /* 132547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132551 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132553 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132557 */     GIR_RootConstrainSelectedInstOperands,
     /* 132558 */     // GIR_Coverage, 7182,
     /* 132558 */     GIR_EraseRootFromParent_Done,
     /* 132559 */   // Label 2561: @132559
     /* 132559 */   GIM_Try, /*On fail goto*//*Label 2562*/ GIMT_Encode4(132608), // Rule ID 7183 //
     /* 132564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132567 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 132574 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 132577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132581 */     // MIs[0] Rn
     /* 132581 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132593 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_seq_cst>>  =>  (LDUMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALW),
     /* 132596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132600 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132602 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132606 */     GIR_RootConstrainSelectedInstOperands,
     /* 132607 */     // GIR_Coverage, 7183,
     /* 132607 */     GIR_EraseRootFromParent_Done,
     /* 132608 */   // Label 2562: @132608
     /* 132608 */   GIM_Try, /*On fail goto*//*Label 2563*/ GIMT_Encode4(132657), // Rule ID 7184 //
     /* 132613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132616 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132623 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 132626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132630 */     // MIs[0] Rn
     /* 132630 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132642 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_monotonic>>  =>  (LDUMINH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINH),
     /* 132645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132649 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132651 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132655 */     GIR_RootConstrainSelectedInstOperands,
     /* 132656 */     // GIR_Coverage, 7184,
     /* 132656 */     GIR_EraseRootFromParent_Done,
     /* 132657 */   // Label 2563: @132657
     /* 132657 */   GIM_Try, /*On fail goto*//*Label 2564*/ GIMT_Encode4(132706), // Rule ID 7185 //
     /* 132662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132665 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132672 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 132675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132679 */     // MIs[0] Rn
     /* 132679 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132691 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acquire>>  =>  (LDUMINAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAH),
     /* 132694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132698 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132700 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132704 */     GIR_RootConstrainSelectedInstOperands,
     /* 132705 */     // GIR_Coverage, 7185,
     /* 132705 */     GIR_EraseRootFromParent_Done,
     /* 132706 */   // Label 2564: @132706
     /* 132706 */   GIM_Try, /*On fail goto*//*Label 2565*/ GIMT_Encode4(132755), // Rule ID 7186 //
     /* 132711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132714 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132721 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 132724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132728 */     // MIs[0] Rn
     /* 132728 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132740 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_release>>  =>  (LDUMINLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLH),
     /* 132743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132747 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132749 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132753 */     GIR_RootConstrainSelectedInstOperands,
     /* 132754 */     // GIR_Coverage, 7186,
     /* 132754 */     GIR_EraseRootFromParent_Done,
     /* 132755 */   // Label 2565: @132755
     /* 132755 */   GIM_Try, /*On fail goto*//*Label 2566*/ GIMT_Encode4(132804), // Rule ID 7187 //
     /* 132760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132763 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132770 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 132773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132777 */     // MIs[0] Rn
     /* 132777 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132781 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132789 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acq_rel>>  =>  (LDUMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALH),
     /* 132792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132794 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132796 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132798 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132802 */     GIR_RootConstrainSelectedInstOperands,
     /* 132803 */     // GIR_Coverage, 7187,
     /* 132803 */     GIR_EraseRootFromParent_Done,
     /* 132804 */   // Label 2566: @132804
     /* 132804 */   GIM_Try, /*On fail goto*//*Label 2567*/ GIMT_Encode4(132853), // Rule ID 7188 //
     /* 132809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132812 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132819 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 132822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132826 */     // MIs[0] Rn
     /* 132826 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132830 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132838 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_seq_cst>>  =>  (LDUMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALH),
     /* 132841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132845 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132847 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132851 */     GIR_RootConstrainSelectedInstOperands,
     /* 132852 */     // GIR_Coverage, 7188,
     /* 132852 */     GIR_EraseRootFromParent_Done,
     /* 132853 */   // Label 2567: @132853
     /* 132853 */   GIM_Try, /*On fail goto*//*Label 2568*/ GIMT_Encode4(132902), // Rule ID 7189 //
     /* 132858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132861 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 132868 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 132871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132875 */     // MIs[0] Rn
     /* 132875 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132887 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_monotonic>>  =>  (LDUMINB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINB),
     /* 132890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132894 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132896 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132900 */     GIR_RootConstrainSelectedInstOperands,
     /* 132901 */     // GIR_Coverage, 7189,
     /* 132901 */     GIR_EraseRootFromParent_Done,
     /* 132902 */   // Label 2568: @132902
     /* 132902 */   GIM_Try, /*On fail goto*//*Label 2569*/ GIMT_Encode4(132951), // Rule ID 7190 //
     /* 132907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132910 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 132917 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 132920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132924 */     // MIs[0] Rn
     /* 132924 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132936 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acquire>>  =>  (LDUMINAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAB),
     /* 132939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132943 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132945 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132949 */     GIR_RootConstrainSelectedInstOperands,
     /* 132950 */     // GIR_Coverage, 7190,
     /* 132950 */     GIR_EraseRootFromParent_Done,
     /* 132951 */   // Label 2569: @132951
     /* 132951 */   GIM_Try, /*On fail goto*//*Label 2570*/ GIMT_Encode4(133000), // Rule ID 7191 //
     /* 132956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132959 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 132966 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 132969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132973 */     // MIs[0] Rn
     /* 132973 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132977 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132985 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_release>>  =>  (LDUMINLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLB),
     /* 132988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132992 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132994 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132998 */     GIR_RootConstrainSelectedInstOperands,
     /* 132999 */     // GIR_Coverage, 7191,
     /* 132999 */     GIR_EraseRootFromParent_Done,
     /* 133000 */   // Label 2570: @133000
     /* 133000 */   GIM_Try, /*On fail goto*//*Label 2571*/ GIMT_Encode4(133049), // Rule ID 7192 //
     /* 133005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133008 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133015 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 133018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133022 */     // MIs[0] Rn
     /* 133022 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133026 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133034 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acq_rel>>  =>  (LDUMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALB),
     /* 133037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133039 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133041 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133043 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133047 */     GIR_RootConstrainSelectedInstOperands,
     /* 133048 */     // GIR_Coverage, 7192,
     /* 133048 */     GIR_EraseRootFromParent_Done,
     /* 133049 */   // Label 2571: @133049
     /* 133049 */   GIM_Try, /*On fail goto*//*Label 2572*/ GIMT_Encode4(133098), // Rule ID 7193 //
     /* 133054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133057 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133064 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 133067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133071 */     // MIs[0] Rn
     /* 133071 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133075 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133083 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_seq_cst>>  =>  (LDUMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALB),
     /* 133086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133090 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133092 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133096 */     GIR_RootConstrainSelectedInstOperands,
     /* 133097 */     // GIR_Coverage, 7193,
     /* 133097 */     GIR_EraseRootFromParent_Done,
     /* 133098 */   // Label 2572: @133098
     /* 133098 */   GIM_Reject,
     /* 133099 */ // Label 2557: @133099
     /* 133099 */ GIM_Reject,
     /* 133100 */ // Label 2555: @133100
     /* 133100 */ GIM_Try, /*On fail goto*//*Label 2573*/ GIMT_Encode4(133326),
     /* 133105 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 133108 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 133115 */   GIM_Try, /*On fail goto*//*Label 2574*/ GIMT_Encode4(133157), // Rule ID 7174 //
     /* 133120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133123 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 133126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133130 */     // MIs[0] Rn
     /* 133130 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133142 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_monotonic>>  =>  (LDUMINX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINX),
     /* 133145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133149 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133151 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133155 */     GIR_RootConstrainSelectedInstOperands,
     /* 133156 */     // GIR_Coverage, 7174,
     /* 133156 */     GIR_EraseRootFromParent_Done,
     /* 133157 */   // Label 2574: @133157
     /* 133157 */   GIM_Try, /*On fail goto*//*Label 2575*/ GIMT_Encode4(133199), // Rule ID 7175 //
     /* 133162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133165 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 133168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133172 */     // MIs[0] Rn
     /* 133172 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133176 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133184 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acquire>>  =>  (LDUMINAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAX),
     /* 133187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133191 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133193 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133197 */     GIR_RootConstrainSelectedInstOperands,
     /* 133198 */     // GIR_Coverage, 7175,
     /* 133198 */     GIR_EraseRootFromParent_Done,
     /* 133199 */   // Label 2575: @133199
     /* 133199 */   GIM_Try, /*On fail goto*//*Label 2576*/ GIMT_Encode4(133241), // Rule ID 7176 //
     /* 133204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133207 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 133210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133214 */     // MIs[0] Rn
     /* 133214 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133218 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133226 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_release>>  =>  (LDUMINLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLX),
     /* 133229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133231 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133233 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133235 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133239 */     GIR_RootConstrainSelectedInstOperands,
     /* 133240 */     // GIR_Coverage, 7176,
     /* 133240 */     GIR_EraseRootFromParent_Done,
     /* 133241 */   // Label 2576: @133241
     /* 133241 */   GIM_Try, /*On fail goto*//*Label 2577*/ GIMT_Encode4(133283), // Rule ID 7177 //
     /* 133246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133249 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 133252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133256 */     // MIs[0] Rn
     /* 133256 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133260 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133268 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acq_rel>>  =>  (LDUMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALX),
     /* 133271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133273 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133275 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133277 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133281 */     GIR_RootConstrainSelectedInstOperands,
     /* 133282 */     // GIR_Coverage, 7177,
     /* 133282 */     GIR_EraseRootFromParent_Done,
     /* 133283 */   // Label 2577: @133283
     /* 133283 */   GIM_Try, /*On fail goto*//*Label 2578*/ GIMT_Encode4(133325), // Rule ID 7178 //
     /* 133288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133291 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 133294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133298 */     // MIs[0] Rn
     /* 133298 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133302 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133310 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_seq_cst>>  =>  (LDUMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALX),
     /* 133313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133315 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133317 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133319 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133323 */     GIR_RootConstrainSelectedInstOperands,
     /* 133324 */     // GIR_Coverage, 7178,
     /* 133324 */     GIR_EraseRootFromParent_Done,
     /* 133325 */   // Label 2578: @133325
     /* 133325 */   GIM_Reject,
     /* 133326 */ // Label 2573: @133326
     /* 133326 */ GIM_Reject,
     /* 133327 */ // Label 2556: @133327
     /* 133327 */ GIM_Reject,
     /* 133328 */ // Label 31: @133328
     /* 133328 */ GIM_Try, /*On fail goto*//*Label 2579*/ GIMT_Encode4(133355), // Rule ID 6926 //
     /* 133333 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 133336 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 4,
     /* 133340 */   // MIs[0] Operand 1
     /* 133340 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 133343 */   // (atomic_fence 4:{ *:[i64] }, (timm:{ *:[i64] }))  =>  (DMB 9:{ *:[i32] })
     /* 133343 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
     /* 133346 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 133349 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133353 */   GIR_RootConstrainSelectedInstOperands,
     /* 133354 */   // GIR_Coverage, 6926,
     /* 133354 */   GIR_EraseRootFromParent_Done,
     /* 133355 */ // Label 2579: @133355
     /* 133355 */ GIM_Try, /*On fail goto*//*Label 2580*/ GIMT_Encode4(133378), // Rule ID 6927 //
     /* 133360 */   // MIs[0] Operand 0
     /* 133360 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 133363 */   // MIs[0] Operand 1
     /* 133363 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 133366 */   // (atomic_fence (timm:{ *:[iPTR] }), (timm:{ *:[iPTR] }))  =>  (DMB 11:{ *:[i32] })
     /* 133366 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
     /* 133369 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/11,
     /* 133372 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133376 */   GIR_RootConstrainSelectedInstOperands,
     /* 133377 */   // GIR_Coverage, 6927,
     /* 133377 */   GIR_EraseRootFromParent_Done,
     /* 133378 */ // Label 2580: @133378
     /* 133378 */ GIM_Reject,
     /* 133379 */ // Label 32: @133379
     /* 133379 */ GIM_Try, /*On fail goto*//*Label 2581*/ GIMT_Encode4(145906),
     /* 133384 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 133387 */   GIM_Try, /*On fail goto*//*Label 2582*/ GIMT_Encode4(133478), // Rule ID 6405 //
     /* 133392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFuseAES),
     /* 133395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesmc),
     /* 133400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 133403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 133406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 133414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 133418 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 133421 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aese),
     /* 133426 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 133430 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 133434 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133439 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133446 */     // (intrinsic_wo_chain:{ *:[v16i8] } 514:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[v16i8] } 512:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))  =>  (AESMCrrTied:{ *:[v16i8] } (AESErr:{ *:[v16i8] } V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))
     /* 133446 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 133449 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::AESErr),
     /* 133453 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133458 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 133462 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // src2
     /* 133466 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 133468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMCrrTied),
     /* 133471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 133473 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133476 */     GIR_RootConstrainSelectedInstOperands,
     /* 133477 */     // GIR_Coverage, 6405,
     /* 133477 */     GIR_EraseRootFromParent_Done,
     /* 133478 */   // Label 2582: @133478
     /* 133478 */   GIM_Try, /*On fail goto*//*Label 2583*/ GIMT_Encode4(133569), // Rule ID 6406 //
     /* 133483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFuseAES),
     /* 133486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesimc),
     /* 133491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 133494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 133497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 133505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 133509 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 133512 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesd),
     /* 133517 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 133521 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 133525 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133530 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133537 */     // (intrinsic_wo_chain:{ *:[v16i8] } 513:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[v16i8] } 511:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))  =>  (AESIMCrrTied:{ *:[v16i8] } (AESDrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))
     /* 133537 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 133540 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::AESDrr),
     /* 133544 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133549 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 133553 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // src2
     /* 133557 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 133559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMCrrTied),
     /* 133562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 133564 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133567 */     GIR_RootConstrainSelectedInstOperands,
     /* 133568 */     // GIR_Coverage, 6406,
     /* 133568 */     GIR_EraseRootFromParent_Done,
     /* 133569 */   // Label 2583: @133569
     /* 133569 */   GIM_Try, /*On fail goto*//*Label 2584*/ GIMT_Encode4(133630), // Rule ID 4838 //
     /* 133574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvthf2fp),
     /* 133579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 133582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 133585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 133593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 133597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 133601 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133606 */     // MIs[1] Operand 2
     /* 133606 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 133617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133619 */     // (intrinsic_wo_chain:{ *:[v4f32] } 767:{ *:[iPTR] }, (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }))  =>  (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8i16] }:$Rn)
     /* 133619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 133622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 133624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 133628 */     GIR_RootConstrainSelectedInstOperands,
     /* 133629 */     // GIR_Coverage, 4838,
     /* 133629 */     GIR_EraseRootFromParent_Done,
     /* 133630 */   // Label 2584: @133630
     /* 133630 */   GIM_Try, /*On fail goto*//*Label 2585*/ GIMT_Encode4(133670), // Rule ID 2637 //
     /* 133635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 133638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /* 133643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 133646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133650 */     // MIs[0] pattern
     /* 133650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 133653 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 133658 */     // (intrinsic_wo_chain:{ *:[i64] } 1238:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTB_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 133658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTB_XPiI),
     /* 133661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 133663 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 133665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 133668 */     GIR_RootConstrainSelectedInstOperands,
     /* 133669 */     // GIR_Coverage, 2637,
     /* 133669 */     GIR_EraseRootFromParent_Done,
     /* 133670 */   // Label 2585: @133670
     /* 133670 */   GIM_Try, /*On fail goto*//*Label 2586*/ GIMT_Encode4(133710), // Rule ID 9771 //
     /* 133675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 133678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /* 133683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 133686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133690 */     // MIs[0] pattern
     /* 133690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 133693 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 133698 */     // (intrinsic_wo_chain:{ *:[i64] } 1240:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTH_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 133698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTH_XPiI),
     /* 133701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 133703 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 133705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 133708 */     GIR_RootConstrainSelectedInstOperands,
     /* 133709 */     // GIR_Coverage, 9771,
     /* 133709 */     GIR_EraseRootFromParent_Done,
     /* 133710 */   // Label 2586: @133710
     /* 133710 */   GIM_Try, /*On fail goto*//*Label 2587*/ GIMT_Encode4(133750), // Rule ID 9774 //
     /* 133715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 133718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /* 133723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 133726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133730 */     // MIs[0] pattern
     /* 133730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 133733 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 133738 */     // (intrinsic_wo_chain:{ *:[i64] } 1246:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTW_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 133738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTW_XPiI),
     /* 133741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 133743 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 133745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 133748 */     GIR_RootConstrainSelectedInstOperands,
     /* 133749 */     // GIR_Coverage, 9774,
     /* 133749 */     GIR_EraseRootFromParent_Done,
     /* 133750 */   // Label 2587: @133750
     /* 133750 */   GIM_Try, /*On fail goto*//*Label 2588*/ GIMT_Encode4(133790), // Rule ID 9777 //
     /* 133755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 133758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /* 133763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 133766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133770 */     // MIs[0] pattern
     /* 133770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 133773 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 133778 */     // (intrinsic_wo_chain:{ *:[i64] } 1239:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTD_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 133778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTD_XPiI),
     /* 133781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 133783 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 133785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 133788 */     GIR_RootConstrainSelectedInstOperands,
     /* 133789 */     // GIR_Coverage, 9777,
     /* 133789 */     GIR_EraseRootFromParent_Done,
     /* 133790 */   // Label 2588: @133790
     /* 133790 */   GIM_Try, /*On fail goto*//*Label 2589*/ GIMT_Encode4(133829), // Rule ID 66 //
     /* 133795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasJS),
     /* 133798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_fjcvtzs),
     /* 133803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 133806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 133809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 133817 */     // (intrinsic_wo_chain:{ *:[i32] } 546:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FJCVTZS:{ *:[i32] }:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 133817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FJCVTZS),
     /* 133820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 133822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 133824 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 133827 */     GIR_RootConstrainSelectedInstOperands,
     /* 133828 */     // GIR_Coverage, 66,
     /* 133828 */     GIR_EraseRootFromParent_Done,
     /* 133829 */   // Label 2589: @133829
     /* 133829 */   GIM_Try, /*On fail goto*//*Label 2590*/ GIMT_Encode4(133865), // Rule ID 346 //
     /* 133834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 133837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 133842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 133845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 133848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 133856 */     // (intrinsic_wo_chain:{ *:[i32] } 583:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTASUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 133856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWHr),
     /* 133859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 133861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 133863 */     GIR_RootConstrainSelectedInstOperands,
     /* 133864 */     // GIR_Coverage, 346,
     /* 133864 */     GIR_EraseRootFromParent_Done,
     /* 133865 */   // Label 2590: @133865
     /* 133865 */   GIM_Try, /*On fail goto*//*Label 2591*/ GIMT_Encode4(133901), // Rule ID 347 //
     /* 133870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 133873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 133878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 133881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 133884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 133892 */     // (intrinsic_wo_chain:{ *:[i64] } 583:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 133892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
     /* 133895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 133897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 133899 */     GIR_RootConstrainSelectedInstOperands,
     /* 133900 */     // GIR_Coverage, 347,
     /* 133900 */     GIR_EraseRootFromParent_Done,
     /* 133901 */   // Label 2591: @133901
     /* 133901 */   GIM_Try, /*On fail goto*//*Label 2592*/ GIMT_Encode4(133937), // Rule ID 348 //
     /* 133906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 133909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 133914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 133917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 133920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 133928 */     // (intrinsic_wo_chain:{ *:[i32] } 583:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTASUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 133928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
     /* 133931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 133933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 133935 */     GIR_RootConstrainSelectedInstOperands,
     /* 133936 */     // GIR_Coverage, 348,
     /* 133936 */     GIR_EraseRootFromParent_Done,
     /* 133937 */   // Label 2592: @133937
     /* 133937 */   GIM_Try, /*On fail goto*//*Label 2593*/ GIMT_Encode4(133973), // Rule ID 349 //
     /* 133942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 133945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 133950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 133953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 133956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 133964 */     // (intrinsic_wo_chain:{ *:[i64] } 583:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 133964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 133967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 133969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 133971 */     GIR_RootConstrainSelectedInstOperands,
     /* 133972 */     // GIR_Coverage, 349,
     /* 133972 */     GIR_EraseRootFromParent_Done,
     /* 133973 */   // Label 2593: @133973
     /* 133973 */   GIM_Try, /*On fail goto*//*Label 2594*/ GIMT_Encode4(134009), // Rule ID 350 //
     /* 133978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 133981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 133986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 133989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 133992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134000 */     // (intrinsic_wo_chain:{ *:[i32] } 583:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTASUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 134000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
     /* 134003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134007 */     GIR_RootConstrainSelectedInstOperands,
     /* 134008 */     // GIR_Coverage, 350,
     /* 134008 */     GIR_EraseRootFromParent_Done,
     /* 134009 */   // Label 2594: @134009
     /* 134009 */   GIM_Try, /*On fail goto*//*Label 2595*/ GIMT_Encode4(134045), // Rule ID 351 //
     /* 134014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 134017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 134022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 134025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 134028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134036 */     // (intrinsic_wo_chain:{ *:[i64] } 583:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 134036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 134039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134043 */     GIR_RootConstrainSelectedInstOperands,
     /* 134044 */     // GIR_Coverage, 351,
     /* 134044 */     GIR_EraseRootFromParent_Done,
     /* 134045 */   // Label 2595: @134045
     /* 134045 */   GIM_Try, /*On fail goto*//*Label 2596*/ GIMT_Encode4(134081), // Rule ID 352 //
     /* 134050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 134053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 134058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 134061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 134064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 134072 */     // (intrinsic_wo_chain:{ *:[i32] } 584:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTAUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 134072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWHr),
     /* 134075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134079 */     GIR_RootConstrainSelectedInstOperands,
     /* 134080 */     // GIR_Coverage, 352,
     /* 134080 */     GIR_EraseRootFromParent_Done,
     /* 134081 */   // Label 2596: @134081
     /* 134081 */   GIM_Try, /*On fail goto*//*Label 2597*/ GIMT_Encode4(134117), // Rule ID 353 //
     /* 134086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 134089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 134094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 134097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 134100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 134108 */     // (intrinsic_wo_chain:{ *:[i64] } 584:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTAUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 134108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXHr),
     /* 134111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134115 */     GIR_RootConstrainSelectedInstOperands,
     /* 134116 */     // GIR_Coverage, 353,
     /* 134116 */     GIR_EraseRootFromParent_Done,
     /* 134117 */   // Label 2597: @134117
     /* 134117 */   GIM_Try, /*On fail goto*//*Label 2598*/ GIMT_Encode4(134153), // Rule ID 354 //
     /* 134122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 134125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 134130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 134133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 134136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134144 */     // (intrinsic_wo_chain:{ *:[i32] } 584:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTAUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 134144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWSr),
     /* 134147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134151 */     GIR_RootConstrainSelectedInstOperands,
     /* 134152 */     // GIR_Coverage, 354,
     /* 134152 */     GIR_EraseRootFromParent_Done,
     /* 134153 */   // Label 2598: @134153
     /* 134153 */   GIM_Try, /*On fail goto*//*Label 2599*/ GIMT_Encode4(134189), // Rule ID 355 //
     /* 134158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 134161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 134166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 134169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 134172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134180 */     // (intrinsic_wo_chain:{ *:[i64] } 584:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTAUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 134180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXSr),
     /* 134183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134187 */     GIR_RootConstrainSelectedInstOperands,
     /* 134188 */     // GIR_Coverage, 355,
     /* 134188 */     GIR_EraseRootFromParent_Done,
     /* 134189 */   // Label 2599: @134189
     /* 134189 */   GIM_Try, /*On fail goto*//*Label 2600*/ GIMT_Encode4(134225), // Rule ID 356 //
     /* 134194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 134197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 134202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 134205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 134208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134216 */     // (intrinsic_wo_chain:{ *:[i32] } 584:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTAUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 134216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWDr),
     /* 134219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134223 */     GIR_RootConstrainSelectedInstOperands,
     /* 134224 */     // GIR_Coverage, 356,
     /* 134224 */     GIR_EraseRootFromParent_Done,
     /* 134225 */   // Label 2600: @134225
     /* 134225 */   GIM_Try, /*On fail goto*//*Label 2601*/ GIMT_Encode4(134261), // Rule ID 357 //
     /* 134230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 134233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 134238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 134241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 134244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134252 */     // (intrinsic_wo_chain:{ *:[i64] } 584:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTAUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 134252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXDr),
     /* 134255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134259 */     GIR_RootConstrainSelectedInstOperands,
     /* 134260 */     // GIR_Coverage, 357,
     /* 134260 */     GIR_EraseRootFromParent_Done,
     /* 134261 */   // Label 2601: @134261
     /* 134261 */   GIM_Try, /*On fail goto*//*Label 2602*/ GIMT_Encode4(134297), // Rule ID 358 //
     /* 134266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 134269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 134274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 134277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 134280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 134288 */     // (intrinsic_wo_chain:{ *:[i32] } 585:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 134288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWHr),
     /* 134291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134295 */     GIR_RootConstrainSelectedInstOperands,
     /* 134296 */     // GIR_Coverage, 358,
     /* 134296 */     GIR_EraseRootFromParent_Done,
     /* 134297 */   // Label 2602: @134297
     /* 134297 */   GIM_Try, /*On fail goto*//*Label 2603*/ GIMT_Encode4(134333), // Rule ID 359 //
     /* 134302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 134305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 134310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 134313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 134316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 134324 */     // (intrinsic_wo_chain:{ *:[i64] } 585:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 134324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXHr),
     /* 134327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134329 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134331 */     GIR_RootConstrainSelectedInstOperands,
     /* 134332 */     // GIR_Coverage, 359,
     /* 134332 */     GIR_EraseRootFromParent_Done,
     /* 134333 */   // Label 2603: @134333
     /* 134333 */   GIM_Try, /*On fail goto*//*Label 2604*/ GIMT_Encode4(134369), // Rule ID 360 //
     /* 134338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 134341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 134346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 134349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 134352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134360 */     // (intrinsic_wo_chain:{ *:[i32] } 585:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 134360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWSr),
     /* 134363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134367 */     GIR_RootConstrainSelectedInstOperands,
     /* 134368 */     // GIR_Coverage, 360,
     /* 134368 */     GIR_EraseRootFromParent_Done,
     /* 134369 */   // Label 2604: @134369
     /* 134369 */   GIM_Try, /*On fail goto*//*Label 2605*/ GIMT_Encode4(134405), // Rule ID 361 //
     /* 134374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 134377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 134382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 134385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 134388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134396 */     // (intrinsic_wo_chain:{ *:[i64] } 585:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 134396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXSr),
     /* 134399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134403 */     GIR_RootConstrainSelectedInstOperands,
     /* 134404 */     // GIR_Coverage, 361,
     /* 134404 */     GIR_EraseRootFromParent_Done,
     /* 134405 */   // Label 2605: @134405
     /* 134405 */   GIM_Try, /*On fail goto*//*Label 2606*/ GIMT_Encode4(134441), // Rule ID 362 //
     /* 134410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 134413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 134418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 134421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 134424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134432 */     // (intrinsic_wo_chain:{ *:[i32] } 585:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 134432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWDr),
     /* 134435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134439 */     GIR_RootConstrainSelectedInstOperands,
     /* 134440 */     // GIR_Coverage, 362,
     /* 134440 */     GIR_EraseRootFromParent_Done,
     /* 134441 */   // Label 2606: @134441
     /* 134441 */   GIM_Try, /*On fail goto*//*Label 2607*/ GIMT_Encode4(134477), // Rule ID 363 //
     /* 134446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 134449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 134454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 134457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 134460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134468 */     // (intrinsic_wo_chain:{ *:[i64] } 585:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 134468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXDr),
     /* 134471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134475 */     GIR_RootConstrainSelectedInstOperands,
     /* 134476 */     // GIR_Coverage, 363,
     /* 134476 */     GIR_EraseRootFromParent_Done,
     /* 134477 */   // Label 2607: @134477
     /* 134477 */   GIM_Try, /*On fail goto*//*Label 2608*/ GIMT_Encode4(134513), // Rule ID 364 //
     /* 134482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 134485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 134490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 134493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 134496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 134504 */     // (intrinsic_wo_chain:{ *:[i32] } 586:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 134504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWHr),
     /* 134507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134511 */     GIR_RootConstrainSelectedInstOperands,
     /* 134512 */     // GIR_Coverage, 364,
     /* 134512 */     GIR_EraseRootFromParent_Done,
     /* 134513 */   // Label 2608: @134513
     /* 134513 */   GIM_Try, /*On fail goto*//*Label 2609*/ GIMT_Encode4(134549), // Rule ID 365 //
     /* 134518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 134521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 134526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 134529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 134532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 134540 */     // (intrinsic_wo_chain:{ *:[i64] } 586:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 134540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXHr),
     /* 134543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134547 */     GIR_RootConstrainSelectedInstOperands,
     /* 134548 */     // GIR_Coverage, 365,
     /* 134548 */     GIR_EraseRootFromParent_Done,
     /* 134549 */   // Label 2609: @134549
     /* 134549 */   GIM_Try, /*On fail goto*//*Label 2610*/ GIMT_Encode4(134585), // Rule ID 366 //
     /* 134554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 134557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 134562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 134565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 134568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134576 */     // (intrinsic_wo_chain:{ *:[i32] } 586:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 134576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWSr),
     /* 134579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134583 */     GIR_RootConstrainSelectedInstOperands,
     /* 134584 */     // GIR_Coverage, 366,
     /* 134584 */     GIR_EraseRootFromParent_Done,
     /* 134585 */   // Label 2610: @134585
     /* 134585 */   GIM_Try, /*On fail goto*//*Label 2611*/ GIMT_Encode4(134621), // Rule ID 367 //
     /* 134590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 134593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 134598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 134601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 134604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134612 */     // (intrinsic_wo_chain:{ *:[i64] } 586:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 134612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXSr),
     /* 134615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134619 */     GIR_RootConstrainSelectedInstOperands,
     /* 134620 */     // GIR_Coverage, 367,
     /* 134620 */     GIR_EraseRootFromParent_Done,
     /* 134621 */   // Label 2611: @134621
     /* 134621 */   GIM_Try, /*On fail goto*//*Label 2612*/ GIMT_Encode4(134657), // Rule ID 368 //
     /* 134626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 134629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 134634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 134637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 134640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134648 */     // (intrinsic_wo_chain:{ *:[i32] } 586:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 134648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWDr),
     /* 134651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134655 */     GIR_RootConstrainSelectedInstOperands,
     /* 134656 */     // GIR_Coverage, 368,
     /* 134656 */     GIR_EraseRootFromParent_Done,
     /* 134657 */   // Label 2612: @134657
     /* 134657 */   GIM_Try, /*On fail goto*//*Label 2613*/ GIMT_Encode4(134693), // Rule ID 369 //
     /* 134662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 134665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 134670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 134673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 134676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134684 */     // (intrinsic_wo_chain:{ *:[i64] } 586:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 134684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXDr),
     /* 134687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134691 */     GIR_RootConstrainSelectedInstOperands,
     /* 134692 */     // GIR_Coverage, 369,
     /* 134692 */     GIR_EraseRootFromParent_Done,
     /* 134693 */   // Label 2613: @134693
     /* 134693 */   GIM_Try, /*On fail goto*//*Label 2614*/ GIMT_Encode4(134729), // Rule ID 370 //
     /* 134698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 134701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 134706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 134709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 134712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 134720 */     // (intrinsic_wo_chain:{ *:[i32] } 587:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 134720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWHr),
     /* 134723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134727 */     GIR_RootConstrainSelectedInstOperands,
     /* 134728 */     // GIR_Coverage, 370,
     /* 134728 */     GIR_EraseRootFromParent_Done,
     /* 134729 */   // Label 2614: @134729
     /* 134729 */   GIM_Try, /*On fail goto*//*Label 2615*/ GIMT_Encode4(134765), // Rule ID 371 //
     /* 134734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 134737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 134742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 134745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 134748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 134756 */     // (intrinsic_wo_chain:{ *:[i64] } 587:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 134756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXHr),
     /* 134759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134763 */     GIR_RootConstrainSelectedInstOperands,
     /* 134764 */     // GIR_Coverage, 371,
     /* 134764 */     GIR_EraseRootFromParent_Done,
     /* 134765 */   // Label 2615: @134765
     /* 134765 */   GIM_Try, /*On fail goto*//*Label 2616*/ GIMT_Encode4(134801), // Rule ID 372 //
     /* 134770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 134773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 134778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 134781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 134784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134792 */     // (intrinsic_wo_chain:{ *:[i32] } 587:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 134792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWSr),
     /* 134795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134799 */     GIR_RootConstrainSelectedInstOperands,
     /* 134800 */     // GIR_Coverage, 372,
     /* 134800 */     GIR_EraseRootFromParent_Done,
     /* 134801 */   // Label 2616: @134801
     /* 134801 */   GIM_Try, /*On fail goto*//*Label 2617*/ GIMT_Encode4(134837), // Rule ID 373 //
     /* 134806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 134809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 134814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 134817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 134820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134828 */     // (intrinsic_wo_chain:{ *:[i64] } 587:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 134828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXSr),
     /* 134831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134835 */     GIR_RootConstrainSelectedInstOperands,
     /* 134836 */     // GIR_Coverage, 373,
     /* 134836 */     GIR_EraseRootFromParent_Done,
     /* 134837 */   // Label 2617: @134837
     /* 134837 */   GIM_Try, /*On fail goto*//*Label 2618*/ GIMT_Encode4(134873), // Rule ID 374 //
     /* 134842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 134845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 134850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 134853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 134856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134864 */     // (intrinsic_wo_chain:{ *:[i32] } 587:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 134864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWDr),
     /* 134867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134871 */     GIR_RootConstrainSelectedInstOperands,
     /* 134872 */     // GIR_Coverage, 374,
     /* 134872 */     GIR_EraseRootFromParent_Done,
     /* 134873 */   // Label 2618: @134873
     /* 134873 */   GIM_Try, /*On fail goto*//*Label 2619*/ GIMT_Encode4(134909), // Rule ID 375 //
     /* 134878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 134881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 134886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 134889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 134892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134900 */     // (intrinsic_wo_chain:{ *:[i64] } 587:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 134900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXDr),
     /* 134903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134907 */     GIR_RootConstrainSelectedInstOperands,
     /* 134908 */     // GIR_Coverage, 375,
     /* 134908 */     GIR_EraseRootFromParent_Done,
     /* 134909 */   // Label 2619: @134909
     /* 134909 */   GIM_Try, /*On fail goto*//*Label 2620*/ GIMT_Encode4(134945), // Rule ID 376 //
     /* 134914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 134917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 134922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 134925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 134928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 134936 */     // (intrinsic_wo_chain:{ *:[i32] } 588:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 134936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWHr),
     /* 134939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134943 */     GIR_RootConstrainSelectedInstOperands,
     /* 134944 */     // GIR_Coverage, 376,
     /* 134944 */     GIR_EraseRootFromParent_Done,
     /* 134945 */   // Label 2620: @134945
     /* 134945 */   GIM_Try, /*On fail goto*//*Label 2621*/ GIMT_Encode4(134981), // Rule ID 377 //
     /* 134950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 134953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 134958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 134961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 134964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 134972 */     // (intrinsic_wo_chain:{ *:[i64] } 588:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 134972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXHr),
     /* 134975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 134977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 134979 */     GIR_RootConstrainSelectedInstOperands,
     /* 134980 */     // GIR_Coverage, 377,
     /* 134980 */     GIR_EraseRootFromParent_Done,
     /* 134981 */   // Label 2621: @134981
     /* 134981 */   GIM_Try, /*On fail goto*//*Label 2622*/ GIMT_Encode4(135017), // Rule ID 378 //
     /* 134986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 134989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 134994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 134997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 135000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135008 */     // (intrinsic_wo_chain:{ *:[i32] } 588:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 135008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWSr),
     /* 135011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135015 */     GIR_RootConstrainSelectedInstOperands,
     /* 135016 */     // GIR_Coverage, 378,
     /* 135016 */     GIR_EraseRootFromParent_Done,
     /* 135017 */   // Label 2622: @135017
     /* 135017 */   GIM_Try, /*On fail goto*//*Label 2623*/ GIMT_Encode4(135053), // Rule ID 379 //
     /* 135022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 135025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 135030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 135033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 135036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135044 */     // (intrinsic_wo_chain:{ *:[i64] } 588:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 135044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXSr),
     /* 135047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135051 */     GIR_RootConstrainSelectedInstOperands,
     /* 135052 */     // GIR_Coverage, 379,
     /* 135052 */     GIR_EraseRootFromParent_Done,
     /* 135053 */   // Label 2623: @135053
     /* 135053 */   GIM_Try, /*On fail goto*//*Label 2624*/ GIMT_Encode4(135089), // Rule ID 380 //
     /* 135058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 135061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 135066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 135069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 135072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135080 */     // (intrinsic_wo_chain:{ *:[i32] } 588:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 135080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWDr),
     /* 135083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135087 */     GIR_RootConstrainSelectedInstOperands,
     /* 135088 */     // GIR_Coverage, 380,
     /* 135088 */     GIR_EraseRootFromParent_Done,
     /* 135089 */   // Label 2624: @135089
     /* 135089 */   GIM_Try, /*On fail goto*//*Label 2625*/ GIMT_Encode4(135125), // Rule ID 381 //
     /* 135094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 135097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 135102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 135105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 135108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135116 */     // (intrinsic_wo_chain:{ *:[i64] } 588:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 135116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXDr),
     /* 135119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135123 */     GIR_RootConstrainSelectedInstOperands,
     /* 135124 */     // GIR_Coverage, 381,
     /* 135124 */     GIR_EraseRootFromParent_Done,
     /* 135125 */   // Label 2625: @135125
     /* 135125 */   GIM_Try, /*On fail goto*//*Label 2626*/ GIMT_Encode4(135161), // Rule ID 382 //
     /* 135130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 135133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 135138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 135141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 135144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 135152 */     // (intrinsic_wo_chain:{ *:[i32] } 589:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 135152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWHr),
     /* 135155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135159 */     GIR_RootConstrainSelectedInstOperands,
     /* 135160 */     // GIR_Coverage, 382,
     /* 135160 */     GIR_EraseRootFromParent_Done,
     /* 135161 */   // Label 2626: @135161
     /* 135161 */   GIM_Try, /*On fail goto*//*Label 2627*/ GIMT_Encode4(135197), // Rule ID 383 //
     /* 135166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 135169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 135174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 135177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 135180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 135188 */     // (intrinsic_wo_chain:{ *:[i64] } 589:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 135188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXHr),
     /* 135191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135195 */     GIR_RootConstrainSelectedInstOperands,
     /* 135196 */     // GIR_Coverage, 383,
     /* 135196 */     GIR_EraseRootFromParent_Done,
     /* 135197 */   // Label 2627: @135197
     /* 135197 */   GIM_Try, /*On fail goto*//*Label 2628*/ GIMT_Encode4(135233), // Rule ID 384 //
     /* 135202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 135205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 135210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 135213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 135216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135224 */     // (intrinsic_wo_chain:{ *:[i32] } 589:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 135224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWSr),
     /* 135227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135231 */     GIR_RootConstrainSelectedInstOperands,
     /* 135232 */     // GIR_Coverage, 384,
     /* 135232 */     GIR_EraseRootFromParent_Done,
     /* 135233 */   // Label 2628: @135233
     /* 135233 */   GIM_Try, /*On fail goto*//*Label 2629*/ GIMT_Encode4(135269), // Rule ID 385 //
     /* 135238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 135241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 135246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 135249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 135252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135260 */     // (intrinsic_wo_chain:{ *:[i64] } 589:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 135260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXSr),
     /* 135263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135265 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135267 */     GIR_RootConstrainSelectedInstOperands,
     /* 135268 */     // GIR_Coverage, 385,
     /* 135268 */     GIR_EraseRootFromParent_Done,
     /* 135269 */   // Label 2629: @135269
     /* 135269 */   GIM_Try, /*On fail goto*//*Label 2630*/ GIMT_Encode4(135305), // Rule ID 386 //
     /* 135274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 135277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 135282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 135285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 135288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135296 */     // (intrinsic_wo_chain:{ *:[i32] } 589:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 135296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWDr),
     /* 135299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135303 */     GIR_RootConstrainSelectedInstOperands,
     /* 135304 */     // GIR_Coverage, 386,
     /* 135304 */     GIR_EraseRootFromParent_Done,
     /* 135305 */   // Label 2630: @135305
     /* 135305 */   GIM_Try, /*On fail goto*//*Label 2631*/ GIMT_Encode4(135341), // Rule ID 387 //
     /* 135310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 135313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 135318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 135321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 135324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135332 */     // (intrinsic_wo_chain:{ *:[i64] } 589:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 135332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXDr),
     /* 135335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135339 */     GIR_RootConstrainSelectedInstOperands,
     /* 135340 */     // GIR_Coverage, 387,
     /* 135340 */     GIR_EraseRootFromParent_Done,
     /* 135341 */   // Label 2631: @135341
     /* 135341 */   GIM_Try, /*On fail goto*//*Label 2632*/ GIMT_Encode4(135377), // Rule ID 388 //
     /* 135346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 135349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 135354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 135357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 135360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 135368 */     // (intrinsic_wo_chain:{ *:[i32] } 590:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 135368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWHr),
     /* 135371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135375 */     GIR_RootConstrainSelectedInstOperands,
     /* 135376 */     // GIR_Coverage, 388,
     /* 135376 */     GIR_EraseRootFromParent_Done,
     /* 135377 */   // Label 2632: @135377
     /* 135377 */   GIM_Try, /*On fail goto*//*Label 2633*/ GIMT_Encode4(135413), // Rule ID 389 //
     /* 135382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 135385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 135390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 135393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 135396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 135404 */     // (intrinsic_wo_chain:{ *:[i64] } 590:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 135404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXHr),
     /* 135407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135411 */     GIR_RootConstrainSelectedInstOperands,
     /* 135412 */     // GIR_Coverage, 389,
     /* 135412 */     GIR_EraseRootFromParent_Done,
     /* 135413 */   // Label 2633: @135413
     /* 135413 */   GIM_Try, /*On fail goto*//*Label 2634*/ GIMT_Encode4(135449), // Rule ID 390 //
     /* 135418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 135421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 135426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 135429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 135432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135440 */     // (intrinsic_wo_chain:{ *:[i32] } 590:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 135440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWSr),
     /* 135443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135447 */     GIR_RootConstrainSelectedInstOperands,
     /* 135448 */     // GIR_Coverage, 390,
     /* 135448 */     GIR_EraseRootFromParent_Done,
     /* 135449 */   // Label 2634: @135449
     /* 135449 */   GIM_Try, /*On fail goto*//*Label 2635*/ GIMT_Encode4(135485), // Rule ID 391 //
     /* 135454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 135457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 135462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 135465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 135468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135476 */     // (intrinsic_wo_chain:{ *:[i64] } 590:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 135476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXSr),
     /* 135479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135483 */     GIR_RootConstrainSelectedInstOperands,
     /* 135484 */     // GIR_Coverage, 391,
     /* 135484 */     GIR_EraseRootFromParent_Done,
     /* 135485 */   // Label 2635: @135485
     /* 135485 */   GIM_Try, /*On fail goto*//*Label 2636*/ GIMT_Encode4(135521), // Rule ID 392 //
     /* 135490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 135493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 135498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 135501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 135504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135512 */     // (intrinsic_wo_chain:{ *:[i32] } 590:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 135512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWDr),
     /* 135515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135519 */     GIR_RootConstrainSelectedInstOperands,
     /* 135520 */     // GIR_Coverage, 392,
     /* 135520 */     GIR_EraseRootFromParent_Done,
     /* 135521 */   // Label 2636: @135521
     /* 135521 */   GIM_Try, /*On fail goto*//*Label 2637*/ GIMT_Encode4(135557), // Rule ID 393 //
     /* 135526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 135529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 135534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 135537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 135540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135548 */     // (intrinsic_wo_chain:{ *:[i64] } 590:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 135548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXDr),
     /* 135551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135555 */     GIR_RootConstrainSelectedInstOperands,
     /* 135556 */     // GIR_Coverage, 393,
     /* 135556 */     GIR_EraseRootFromParent_Done,
     /* 135557 */   // Label 2637: @135557
     /* 135557 */   GIM_Try, /*On fail goto*//*Label 2638*/ GIMT_Encode4(135593), // Rule ID 575 //
     /* 135562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 135565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32z),
     /* 135570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 135573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 135576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135584 */     // (intrinsic_wo_chain:{ *:[f32] } 548:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT32ZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 135584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZSr),
     /* 135587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135591 */     GIR_RootConstrainSelectedInstOperands,
     /* 135592 */     // GIR_Coverage, 575,
     /* 135592 */     GIR_EraseRootFromParent_Done,
     /* 135593 */   // Label 2638: @135593
     /* 135593 */   GIM_Try, /*On fail goto*//*Label 2639*/ GIMT_Encode4(135629), // Rule ID 576 //
     /* 135598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 135601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32z),
     /* 135606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 135609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 135612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135620 */     // (intrinsic_wo_chain:{ *:[f64] } 548:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT32ZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 135620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZDr),
     /* 135623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135627 */     GIR_RootConstrainSelectedInstOperands,
     /* 135628 */     // GIR_Coverage, 576,
     /* 135628 */     GIR_EraseRootFromParent_Done,
     /* 135629 */   // Label 2639: @135629
     /* 135629 */   GIM_Try, /*On fail goto*//*Label 2640*/ GIMT_Encode4(135665), // Rule ID 577 //
     /* 135634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 135637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64z),
     /* 135642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 135645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 135648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135656 */     // (intrinsic_wo_chain:{ *:[f32] } 550:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT64ZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 135656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZSr),
     /* 135659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135663 */     GIR_RootConstrainSelectedInstOperands,
     /* 135664 */     // GIR_Coverage, 577,
     /* 135664 */     GIR_EraseRootFromParent_Done,
     /* 135665 */   // Label 2640: @135665
     /* 135665 */   GIM_Try, /*On fail goto*//*Label 2641*/ GIMT_Encode4(135701), // Rule ID 578 //
     /* 135670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 135673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64z),
     /* 135678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 135681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 135684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135692 */     // (intrinsic_wo_chain:{ *:[f64] } 550:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT64ZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 135692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZDr),
     /* 135695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135699 */     GIR_RootConstrainSelectedInstOperands,
     /* 135700 */     // GIR_Coverage, 578,
     /* 135700 */     GIR_EraseRootFromParent_Done,
     /* 135701 */   // Label 2641: @135701
     /* 135701 */   GIM_Try, /*On fail goto*//*Label 2642*/ GIMT_Encode4(135737), // Rule ID 579 //
     /* 135706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 135709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32x),
     /* 135714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 135717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 135720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135728 */     // (intrinsic_wo_chain:{ *:[f32] } 547:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT32XSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 135728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XSr),
     /* 135731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135733 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135735 */     GIR_RootConstrainSelectedInstOperands,
     /* 135736 */     // GIR_Coverage, 579,
     /* 135736 */     GIR_EraseRootFromParent_Done,
     /* 135737 */   // Label 2642: @135737
     /* 135737 */   GIM_Try, /*On fail goto*//*Label 2643*/ GIMT_Encode4(135773), // Rule ID 580 //
     /* 135742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 135745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32x),
     /* 135750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 135753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 135756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135764 */     // (intrinsic_wo_chain:{ *:[f64] } 547:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT32XDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 135764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XDr),
     /* 135767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135771 */     GIR_RootConstrainSelectedInstOperands,
     /* 135772 */     // GIR_Coverage, 580,
     /* 135772 */     GIR_EraseRootFromParent_Done,
     /* 135773 */   // Label 2643: @135773
     /* 135773 */   GIM_Try, /*On fail goto*//*Label 2644*/ GIMT_Encode4(135809), // Rule ID 581 //
     /* 135778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 135781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64x),
     /* 135786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 135789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 135792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135800 */     // (intrinsic_wo_chain:{ *:[f32] } 549:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT64XSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 135800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XSr),
     /* 135803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135807 */     GIR_RootConstrainSelectedInstOperands,
     /* 135808 */     // GIR_Coverage, 581,
     /* 135808 */     GIR_EraseRootFromParent_Done,
     /* 135809 */   // Label 2644: @135809
     /* 135809 */   GIM_Try, /*On fail goto*//*Label 2645*/ GIMT_Encode4(135845), // Rule ID 582 //
     /* 135814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 135817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64x),
     /* 135822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 135825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 135828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135836 */     // (intrinsic_wo_chain:{ *:[f64] } 549:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT64XDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 135836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XDr),
     /* 135839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135843 */     GIR_RootConstrainSelectedInstOperands,
     /* 135844 */     // GIR_Coverage, 582,
     /* 135844 */     GIR_EraseRootFromParent_Done,
     /* 135845 */   // Label 2645: @135845
     /* 135845 */   GIM_Try, /*On fail goto*//*Label 2646*/ GIMT_Encode4(135881), // Rule ID 710 //
     /* 135850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 135853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 135858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 135861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 135864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135872 */     // (intrinsic_wo_chain:{ *:[v8i8] } 575:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (CLSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 135872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv8i8),
     /* 135875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135879 */     GIR_RootConstrainSelectedInstOperands,
     /* 135880 */     // GIR_Coverage, 710,
     /* 135880 */     GIR_EraseRootFromParent_Done,
     /* 135881 */   // Label 2646: @135881
     /* 135881 */   GIM_Try, /*On fail goto*//*Label 2647*/ GIMT_Encode4(135917), // Rule ID 711 //
     /* 135886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 135889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 135894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 135897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 135900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 135904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 135908 */     // (intrinsic_wo_chain:{ *:[v16i8] } 575:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (CLSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 135908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv16i8),
     /* 135911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135915 */     GIR_RootConstrainSelectedInstOperands,
     /* 135916 */     // GIR_Coverage, 711,
     /* 135916 */     GIR_EraseRootFromParent_Done,
     /* 135917 */   // Label 2647: @135917
     /* 135917 */   GIM_Try, /*On fail goto*//*Label 2648*/ GIMT_Encode4(135953), // Rule ID 712 //
     /* 135922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 135925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 135930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 135933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 135936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135944 */     // (intrinsic_wo_chain:{ *:[v4i16] } 575:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (CLSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 135944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv4i16),
     /* 135947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135951 */     GIR_RootConstrainSelectedInstOperands,
     /* 135952 */     // GIR_Coverage, 712,
     /* 135952 */     GIR_EraseRootFromParent_Done,
     /* 135953 */   // Label 2648: @135953
     /* 135953 */   GIM_Try, /*On fail goto*//*Label 2649*/ GIMT_Encode4(135989), // Rule ID 713 //
     /* 135958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 135961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 135966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 135969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 135972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 135976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 135980 */     // (intrinsic_wo_chain:{ *:[v8i16] } 575:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (CLSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 135980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv8i16),
     /* 135983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 135985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 135987 */     GIR_RootConstrainSelectedInstOperands,
     /* 135988 */     // GIR_Coverage, 713,
     /* 135988 */     GIR_EraseRootFromParent_Done,
     /* 135989 */   // Label 2649: @135989
     /* 135989 */   GIM_Try, /*On fail goto*//*Label 2650*/ GIMT_Encode4(136025), // Rule ID 714 //
     /* 135994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 135997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 136002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 136005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 136008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136016 */     // (intrinsic_wo_chain:{ *:[v2i32] } 575:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (CLSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 136016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv2i32),
     /* 136019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136023 */     GIR_RootConstrainSelectedInstOperands,
     /* 136024 */     // GIR_Coverage, 714,
     /* 136024 */     GIR_EraseRootFromParent_Done,
     /* 136025 */   // Label 2650: @136025
     /* 136025 */   GIM_Try, /*On fail goto*//*Label 2651*/ GIMT_Encode4(136061), // Rule ID 715 //
     /* 136030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 136033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 136038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 136041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 136044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136052 */     // (intrinsic_wo_chain:{ *:[v4i32] } 575:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (CLSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 136052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv4i32),
     /* 136055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136059 */     GIR_RootConstrainSelectedInstOperands,
     /* 136060 */     // GIR_Coverage, 715,
     /* 136060 */     GIR_EraseRootFromParent_Done,
     /* 136061 */   // Label 2651: @136061
     /* 136061 */   GIM_Try, /*On fail goto*//*Label 2652*/ GIMT_Encode4(136097), // Rule ID 789 //
     /* 136066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 136069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 136074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 136077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 136080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136088 */     // (intrinsic_wo_chain:{ *:[v4i16] } 583:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTASv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 136088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv4f16),
     /* 136091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136095 */     GIR_RootConstrainSelectedInstOperands,
     /* 136096 */     // GIR_Coverage, 789,
     /* 136096 */     GIR_EraseRootFromParent_Done,
     /* 136097 */   // Label 2652: @136097
     /* 136097 */   GIM_Try, /*On fail goto*//*Label 2653*/ GIMT_Encode4(136133), // Rule ID 790 //
     /* 136102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 136105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 136110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 136113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 136116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136124 */     // (intrinsic_wo_chain:{ *:[v8i16] } 583:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTASv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 136124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv8f16),
     /* 136127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136131 */     GIR_RootConstrainSelectedInstOperands,
     /* 136132 */     // GIR_Coverage, 790,
     /* 136132 */     GIR_EraseRootFromParent_Done,
     /* 136133 */   // Label 2653: @136133
     /* 136133 */   GIM_Try, /*On fail goto*//*Label 2654*/ GIMT_Encode4(136169), // Rule ID 791 //
     /* 136138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 136141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 136146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 136149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 136152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136160 */     // (intrinsic_wo_chain:{ *:[v2i32] } 583:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTASv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 136160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv2f32),
     /* 136163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136167 */     GIR_RootConstrainSelectedInstOperands,
     /* 136168 */     // GIR_Coverage, 791,
     /* 136168 */     GIR_EraseRootFromParent_Done,
     /* 136169 */   // Label 2654: @136169
     /* 136169 */   GIM_Try, /*On fail goto*//*Label 2655*/ GIMT_Encode4(136205), // Rule ID 792 //
     /* 136174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 136177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 136182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 136185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 136188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136196 */     // (intrinsic_wo_chain:{ *:[v4i32] } 583:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTASv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 136196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv4f32),
     /* 136199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136203 */     GIR_RootConstrainSelectedInstOperands,
     /* 136204 */     // GIR_Coverage, 792,
     /* 136204 */     GIR_EraseRootFromParent_Done,
     /* 136205 */   // Label 2655: @136205
     /* 136205 */   GIM_Try, /*On fail goto*//*Label 2656*/ GIMT_Encode4(136241), // Rule ID 793 //
     /* 136210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 136213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 136218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 136221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 136224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136232 */     // (intrinsic_wo_chain:{ *:[v2i64] } 583:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTASv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 136232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv2f64),
     /* 136235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136239 */     GIR_RootConstrainSelectedInstOperands,
     /* 136240 */     // GIR_Coverage, 793,
     /* 136240 */     GIR_EraseRootFromParent_Done,
     /* 136241 */   // Label 2656: @136241
     /* 136241 */   GIM_Try, /*On fail goto*//*Label 2657*/ GIMT_Encode4(136277), // Rule ID 794 //
     /* 136246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 136249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 136254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 136257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 136260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136268 */     // (intrinsic_wo_chain:{ *:[v4i16] } 584:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTAUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 136268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv4f16),
     /* 136271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136273 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136275 */     GIR_RootConstrainSelectedInstOperands,
     /* 136276 */     // GIR_Coverage, 794,
     /* 136276 */     GIR_EraseRootFromParent_Done,
     /* 136277 */   // Label 2657: @136277
     /* 136277 */   GIM_Try, /*On fail goto*//*Label 2658*/ GIMT_Encode4(136313), // Rule ID 795 //
     /* 136282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 136285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 136290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 136293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 136296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136304 */     // (intrinsic_wo_chain:{ *:[v8i16] } 584:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTAUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 136304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv8f16),
     /* 136307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136309 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136311 */     GIR_RootConstrainSelectedInstOperands,
     /* 136312 */     // GIR_Coverage, 795,
     /* 136312 */     GIR_EraseRootFromParent_Done,
     /* 136313 */   // Label 2658: @136313
     /* 136313 */   GIM_Try, /*On fail goto*//*Label 2659*/ GIMT_Encode4(136349), // Rule ID 796 //
     /* 136318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 136321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 136326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 136329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 136332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136340 */     // (intrinsic_wo_chain:{ *:[v2i32] } 584:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTAUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 136340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv2f32),
     /* 136343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136347 */     GIR_RootConstrainSelectedInstOperands,
     /* 136348 */     // GIR_Coverage, 796,
     /* 136348 */     GIR_EraseRootFromParent_Done,
     /* 136349 */   // Label 2659: @136349
     /* 136349 */   GIM_Try, /*On fail goto*//*Label 2660*/ GIMT_Encode4(136385), // Rule ID 797 //
     /* 136354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 136357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 136362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 136365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 136368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136376 */     // (intrinsic_wo_chain:{ *:[v4i32] } 584:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTAUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 136376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv4f32),
     /* 136379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136383 */     GIR_RootConstrainSelectedInstOperands,
     /* 136384 */     // GIR_Coverage, 797,
     /* 136384 */     GIR_EraseRootFromParent_Done,
     /* 136385 */   // Label 2660: @136385
     /* 136385 */   GIM_Try, /*On fail goto*//*Label 2661*/ GIMT_Encode4(136421), // Rule ID 798 //
     /* 136390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 136393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 136398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 136401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 136404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136412 */     // (intrinsic_wo_chain:{ *:[v2i64] } 584:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTAUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 136412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv2f64),
     /* 136415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136419 */     GIR_RootConstrainSelectedInstOperands,
     /* 136420 */     // GIR_Coverage, 798,
     /* 136420 */     GIR_EraseRootFromParent_Done,
     /* 136421 */   // Label 2661: @136421
     /* 136421 */   GIM_Try, /*On fail goto*//*Label 2662*/ GIMT_Encode4(136457), // Rule ID 799 //
     /* 136426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 136429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 136434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 136437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 136440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136448 */     // (intrinsic_wo_chain:{ *:[v4i16] } 585:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTMSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 136448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv4f16),
     /* 136451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136455 */     GIR_RootConstrainSelectedInstOperands,
     /* 136456 */     // GIR_Coverage, 799,
     /* 136456 */     GIR_EraseRootFromParent_Done,
     /* 136457 */   // Label 2662: @136457
     /* 136457 */   GIM_Try, /*On fail goto*//*Label 2663*/ GIMT_Encode4(136493), // Rule ID 800 //
     /* 136462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 136465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 136470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 136473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 136476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136484 */     // (intrinsic_wo_chain:{ *:[v8i16] } 585:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTMSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 136484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv8f16),
     /* 136487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136491 */     GIR_RootConstrainSelectedInstOperands,
     /* 136492 */     // GIR_Coverage, 800,
     /* 136492 */     GIR_EraseRootFromParent_Done,
     /* 136493 */   // Label 2663: @136493
     /* 136493 */   GIM_Try, /*On fail goto*//*Label 2664*/ GIMT_Encode4(136529), // Rule ID 801 //
     /* 136498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 136501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 136506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 136509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 136512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136520 */     // (intrinsic_wo_chain:{ *:[v2i32] } 585:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTMSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 136520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv2f32),
     /* 136523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136525 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136527 */     GIR_RootConstrainSelectedInstOperands,
     /* 136528 */     // GIR_Coverage, 801,
     /* 136528 */     GIR_EraseRootFromParent_Done,
     /* 136529 */   // Label 2664: @136529
     /* 136529 */   GIM_Try, /*On fail goto*//*Label 2665*/ GIMT_Encode4(136565), // Rule ID 802 //
     /* 136534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 136537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 136542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 136545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 136548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136556 */     // (intrinsic_wo_chain:{ *:[v4i32] } 585:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTMSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 136556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv4f32),
     /* 136559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136563 */     GIR_RootConstrainSelectedInstOperands,
     /* 136564 */     // GIR_Coverage, 802,
     /* 136564 */     GIR_EraseRootFromParent_Done,
     /* 136565 */   // Label 2665: @136565
     /* 136565 */   GIM_Try, /*On fail goto*//*Label 2666*/ GIMT_Encode4(136601), // Rule ID 803 //
     /* 136570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 136573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 136578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 136581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 136584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136592 */     // (intrinsic_wo_chain:{ *:[v2i64] } 585:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTMSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 136592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv2f64),
     /* 136595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136599 */     GIR_RootConstrainSelectedInstOperands,
     /* 136600 */     // GIR_Coverage, 803,
     /* 136600 */     GIR_EraseRootFromParent_Done,
     /* 136601 */   // Label 2666: @136601
     /* 136601 */   GIM_Try, /*On fail goto*//*Label 2667*/ GIMT_Encode4(136637), // Rule ID 804 //
     /* 136606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 136609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 136614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 136617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 136620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136628 */     // (intrinsic_wo_chain:{ *:[v4i16] } 586:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTMUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 136628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv4f16),
     /* 136631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136635 */     GIR_RootConstrainSelectedInstOperands,
     /* 136636 */     // GIR_Coverage, 804,
     /* 136636 */     GIR_EraseRootFromParent_Done,
     /* 136637 */   // Label 2667: @136637
     /* 136637 */   GIM_Try, /*On fail goto*//*Label 2668*/ GIMT_Encode4(136673), // Rule ID 805 //
     /* 136642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 136645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 136650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 136653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 136656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136664 */     // (intrinsic_wo_chain:{ *:[v8i16] } 586:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTMUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 136664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv8f16),
     /* 136667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136671 */     GIR_RootConstrainSelectedInstOperands,
     /* 136672 */     // GIR_Coverage, 805,
     /* 136672 */     GIR_EraseRootFromParent_Done,
     /* 136673 */   // Label 2668: @136673
     /* 136673 */   GIM_Try, /*On fail goto*//*Label 2669*/ GIMT_Encode4(136709), // Rule ID 806 //
     /* 136678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 136681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 136686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 136689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 136692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136700 */     // (intrinsic_wo_chain:{ *:[v2i32] } 586:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTMUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 136700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv2f32),
     /* 136703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136707 */     GIR_RootConstrainSelectedInstOperands,
     /* 136708 */     // GIR_Coverage, 806,
     /* 136708 */     GIR_EraseRootFromParent_Done,
     /* 136709 */   // Label 2669: @136709
     /* 136709 */   GIM_Try, /*On fail goto*//*Label 2670*/ GIMT_Encode4(136745), // Rule ID 807 //
     /* 136714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 136717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 136722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 136725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 136728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136736 */     // (intrinsic_wo_chain:{ *:[v4i32] } 586:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTMUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 136736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv4f32),
     /* 136739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136743 */     GIR_RootConstrainSelectedInstOperands,
     /* 136744 */     // GIR_Coverage, 807,
     /* 136744 */     GIR_EraseRootFromParent_Done,
     /* 136745 */   // Label 2670: @136745
     /* 136745 */   GIM_Try, /*On fail goto*//*Label 2671*/ GIMT_Encode4(136781), // Rule ID 808 //
     /* 136750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 136753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 136758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 136761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 136764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136772 */     // (intrinsic_wo_chain:{ *:[v2i64] } 586:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTMUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 136772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv2f64),
     /* 136775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136779 */     GIR_RootConstrainSelectedInstOperands,
     /* 136780 */     // GIR_Coverage, 808,
     /* 136780 */     GIR_EraseRootFromParent_Done,
     /* 136781 */   // Label 2671: @136781
     /* 136781 */   GIM_Try, /*On fail goto*//*Label 2672*/ GIMT_Encode4(136817), // Rule ID 809 //
     /* 136786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 136789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 136794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 136797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 136800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136808 */     // (intrinsic_wo_chain:{ *:[v4i16] } 587:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTNSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 136808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv4f16),
     /* 136811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136815 */     GIR_RootConstrainSelectedInstOperands,
     /* 136816 */     // GIR_Coverage, 809,
     /* 136816 */     GIR_EraseRootFromParent_Done,
     /* 136817 */   // Label 2672: @136817
     /* 136817 */   GIM_Try, /*On fail goto*//*Label 2673*/ GIMT_Encode4(136853), // Rule ID 810 //
     /* 136822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 136825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 136830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 136833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 136836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136844 */     // (intrinsic_wo_chain:{ *:[v8i16] } 587:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 136844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv8f16),
     /* 136847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136851 */     GIR_RootConstrainSelectedInstOperands,
     /* 136852 */     // GIR_Coverage, 810,
     /* 136852 */     GIR_EraseRootFromParent_Done,
     /* 136853 */   // Label 2673: @136853
     /* 136853 */   GIM_Try, /*On fail goto*//*Label 2674*/ GIMT_Encode4(136889), // Rule ID 811 //
     /* 136858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 136861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 136866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 136869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 136872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136880 */     // (intrinsic_wo_chain:{ *:[v2i32] } 587:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTNSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 136880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv2f32),
     /* 136883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136887 */     GIR_RootConstrainSelectedInstOperands,
     /* 136888 */     // GIR_Coverage, 811,
     /* 136888 */     GIR_EraseRootFromParent_Done,
     /* 136889 */   // Label 2674: @136889
     /* 136889 */   GIM_Try, /*On fail goto*//*Label 2675*/ GIMT_Encode4(136925), // Rule ID 812 //
     /* 136894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 136897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 136902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 136905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 136908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136916 */     // (intrinsic_wo_chain:{ *:[v4i32] } 587:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 136916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv4f32),
     /* 136919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136923 */     GIR_RootConstrainSelectedInstOperands,
     /* 136924 */     // GIR_Coverage, 812,
     /* 136924 */     GIR_EraseRootFromParent_Done,
     /* 136925 */   // Label 2675: @136925
     /* 136925 */   GIM_Try, /*On fail goto*//*Label 2676*/ GIMT_Encode4(136961), // Rule ID 813 //
     /* 136930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 136933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 136938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 136941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 136944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136952 */     // (intrinsic_wo_chain:{ *:[v2i64] } 587:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 136952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv2f64),
     /* 136955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136959 */     GIR_RootConstrainSelectedInstOperands,
     /* 136960 */     // GIR_Coverage, 813,
     /* 136960 */     GIR_EraseRootFromParent_Done,
     /* 136961 */   // Label 2676: @136961
     /* 136961 */   GIM_Try, /*On fail goto*//*Label 2677*/ GIMT_Encode4(136997), // Rule ID 814 //
     /* 136966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 136969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 136974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 136977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 136980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136988 */     // (intrinsic_wo_chain:{ *:[v4i16] } 588:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTNUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 136988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv4f16),
     /* 136991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 136993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 136995 */     GIR_RootConstrainSelectedInstOperands,
     /* 136996 */     // GIR_Coverage, 814,
     /* 136996 */     GIR_EraseRootFromParent_Done,
     /* 136997 */   // Label 2677: @136997
     /* 136997 */   GIM_Try, /*On fail goto*//*Label 2678*/ GIMT_Encode4(137033), // Rule ID 815 //
     /* 137002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 137005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 137010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 137013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 137016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137024 */     // (intrinsic_wo_chain:{ *:[v8i16] } 588:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 137024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv8f16),
     /* 137027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137031 */     GIR_RootConstrainSelectedInstOperands,
     /* 137032 */     // GIR_Coverage, 815,
     /* 137032 */     GIR_EraseRootFromParent_Done,
     /* 137033 */   // Label 2678: @137033
     /* 137033 */   GIM_Try, /*On fail goto*//*Label 2679*/ GIMT_Encode4(137069), // Rule ID 816 //
     /* 137038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 137041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 137046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 137049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 137052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137060 */     // (intrinsic_wo_chain:{ *:[v2i32] } 588:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTNUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 137060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv2f32),
     /* 137063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137067 */     GIR_RootConstrainSelectedInstOperands,
     /* 137068 */     // GIR_Coverage, 816,
     /* 137068 */     GIR_EraseRootFromParent_Done,
     /* 137069 */   // Label 2679: @137069
     /* 137069 */   GIM_Try, /*On fail goto*//*Label 2680*/ GIMT_Encode4(137105), // Rule ID 817 //
     /* 137074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 137077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 137082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 137085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 137088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137096 */     // (intrinsic_wo_chain:{ *:[v4i32] } 588:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 137096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv4f32),
     /* 137099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137103 */     GIR_RootConstrainSelectedInstOperands,
     /* 137104 */     // GIR_Coverage, 817,
     /* 137104 */     GIR_EraseRootFromParent_Done,
     /* 137105 */   // Label 2680: @137105
     /* 137105 */   GIM_Try, /*On fail goto*//*Label 2681*/ GIMT_Encode4(137141), // Rule ID 818 //
     /* 137110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 137113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 137118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 137121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 137124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137132 */     // (intrinsic_wo_chain:{ *:[v2i64] } 588:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 137132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv2f64),
     /* 137135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137139 */     GIR_RootConstrainSelectedInstOperands,
     /* 137140 */     // GIR_Coverage, 818,
     /* 137140 */     GIR_EraseRootFromParent_Done,
     /* 137141 */   // Label 2681: @137141
     /* 137141 */   GIM_Try, /*On fail goto*//*Label 2682*/ GIMT_Encode4(137177), // Rule ID 819 //
     /* 137146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 137149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 137154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 137157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 137160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137168 */     // (intrinsic_wo_chain:{ *:[v4i16] } 589:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTPSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 137168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv4f16),
     /* 137171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137175 */     GIR_RootConstrainSelectedInstOperands,
     /* 137176 */     // GIR_Coverage, 819,
     /* 137176 */     GIR_EraseRootFromParent_Done,
     /* 137177 */   // Label 2682: @137177
     /* 137177 */   GIM_Try, /*On fail goto*//*Label 2683*/ GIMT_Encode4(137213), // Rule ID 820 //
     /* 137182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 137185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 137190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 137193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 137196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137204 */     // (intrinsic_wo_chain:{ *:[v8i16] } 589:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTPSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 137204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv8f16),
     /* 137207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137211 */     GIR_RootConstrainSelectedInstOperands,
     /* 137212 */     // GIR_Coverage, 820,
     /* 137212 */     GIR_EraseRootFromParent_Done,
     /* 137213 */   // Label 2683: @137213
     /* 137213 */   GIM_Try, /*On fail goto*//*Label 2684*/ GIMT_Encode4(137249), // Rule ID 821 //
     /* 137218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 137221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 137226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 137229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 137232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137240 */     // (intrinsic_wo_chain:{ *:[v2i32] } 589:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTPSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 137240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv2f32),
     /* 137243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137247 */     GIR_RootConstrainSelectedInstOperands,
     /* 137248 */     // GIR_Coverage, 821,
     /* 137248 */     GIR_EraseRootFromParent_Done,
     /* 137249 */   // Label 2684: @137249
     /* 137249 */   GIM_Try, /*On fail goto*//*Label 2685*/ GIMT_Encode4(137285), // Rule ID 822 //
     /* 137254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 137257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 137262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 137265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 137268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137276 */     // (intrinsic_wo_chain:{ *:[v4i32] } 589:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTPSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 137276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv4f32),
     /* 137279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137283 */     GIR_RootConstrainSelectedInstOperands,
     /* 137284 */     // GIR_Coverage, 822,
     /* 137284 */     GIR_EraseRootFromParent_Done,
     /* 137285 */   // Label 2685: @137285
     /* 137285 */   GIM_Try, /*On fail goto*//*Label 2686*/ GIMT_Encode4(137321), // Rule ID 823 //
     /* 137290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 137293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 137298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 137301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 137304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137312 */     // (intrinsic_wo_chain:{ *:[v2i64] } 589:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTPSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 137312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv2f64),
     /* 137315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137319 */     GIR_RootConstrainSelectedInstOperands,
     /* 137320 */     // GIR_Coverage, 823,
     /* 137320 */     GIR_EraseRootFromParent_Done,
     /* 137321 */   // Label 2686: @137321
     /* 137321 */   GIM_Try, /*On fail goto*//*Label 2687*/ GIMT_Encode4(137357), // Rule ID 824 //
     /* 137326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 137329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 137334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 137337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 137340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137348 */     // (intrinsic_wo_chain:{ *:[v4i16] } 590:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTPUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 137348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv4f16),
     /* 137351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137355 */     GIR_RootConstrainSelectedInstOperands,
     /* 137356 */     // GIR_Coverage, 824,
     /* 137356 */     GIR_EraseRootFromParent_Done,
     /* 137357 */   // Label 2687: @137357
     /* 137357 */   GIM_Try, /*On fail goto*//*Label 2688*/ GIMT_Encode4(137393), // Rule ID 825 //
     /* 137362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 137365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 137370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 137373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 137376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137384 */     // (intrinsic_wo_chain:{ *:[v8i16] } 590:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTPUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 137384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv8f16),
     /* 137387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137391 */     GIR_RootConstrainSelectedInstOperands,
     /* 137392 */     // GIR_Coverage, 825,
     /* 137392 */     GIR_EraseRootFromParent_Done,
     /* 137393 */   // Label 2688: @137393
     /* 137393 */   GIM_Try, /*On fail goto*//*Label 2689*/ GIMT_Encode4(137429), // Rule ID 826 //
     /* 137398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 137401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 137406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 137409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 137412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137420 */     // (intrinsic_wo_chain:{ *:[v2i32] } 590:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTPUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 137420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv2f32),
     /* 137423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137427 */     GIR_RootConstrainSelectedInstOperands,
     /* 137428 */     // GIR_Coverage, 826,
     /* 137428 */     GIR_EraseRootFromParent_Done,
     /* 137429 */   // Label 2689: @137429
     /* 137429 */   GIM_Try, /*On fail goto*//*Label 2690*/ GIMT_Encode4(137465), // Rule ID 827 //
     /* 137434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 137437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 137442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 137445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 137448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137456 */     // (intrinsic_wo_chain:{ *:[v4i32] } 590:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTPUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 137456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv4f32),
     /* 137459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137463 */     GIR_RootConstrainSelectedInstOperands,
     /* 137464 */     // GIR_Coverage, 827,
     /* 137464 */     GIR_EraseRootFromParent_Done,
     /* 137465 */   // Label 2690: @137465
     /* 137465 */   GIM_Try, /*On fail goto*//*Label 2691*/ GIMT_Encode4(137501), // Rule ID 828 //
     /* 137470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 137473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 137478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 137481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 137484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137492 */     // (intrinsic_wo_chain:{ *:[v2i64] } 590:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTPUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 137492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv2f64),
     /* 137495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137499 */     GIR_RootConstrainSelectedInstOperands,
     /* 137500 */     // GIR_Coverage, 828,
     /* 137500 */     GIR_EraseRootFromParent_Done,
     /* 137501 */   // Label 2691: @137501
     /* 137501 */   GIM_Try, /*On fail goto*//*Label 2692*/ GIMT_Encode4(137537), // Rule ID 829 //
     /* 137506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 137509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtxn),
     /* 137514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 137517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 137520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137528 */     // (intrinsic_wo_chain:{ *:[v2f32] } 591:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTXNv2f32:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)
     /* 137528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv2f32),
     /* 137531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137535 */     GIR_RootConstrainSelectedInstOperands,
     /* 137536 */     // GIR_Coverage, 829,
     /* 137536 */     GIR_EraseRootFromParent_Done,
     /* 137537 */   // Label 2692: @137537
     /* 137537 */   GIM_Try, /*On fail goto*//*Label 2693*/ GIMT_Encode4(137573), // Rule ID 856 //
     /* 137542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 137545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 137550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 137553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 137556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137564 */     // (intrinsic_wo_chain:{ *:[v4f16] } 632:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FRECPEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 137564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv4f16),
     /* 137567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137569 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137571 */     GIR_RootConstrainSelectedInstOperands,
     /* 137572 */     // GIR_Coverage, 856,
     /* 137572 */     GIR_EraseRootFromParent_Done,
     /* 137573 */   // Label 2693: @137573
     /* 137573 */   GIM_Try, /*On fail goto*//*Label 2694*/ GIMT_Encode4(137609), // Rule ID 857 //
     /* 137578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 137581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 137586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 137589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 137592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137600 */     // (intrinsic_wo_chain:{ *:[v8f16] } 632:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FRECPEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 137600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv8f16),
     /* 137603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137607 */     GIR_RootConstrainSelectedInstOperands,
     /* 137608 */     // GIR_Coverage, 857,
     /* 137608 */     GIR_EraseRootFromParent_Done,
     /* 137609 */   // Label 2694: @137609
     /* 137609 */   GIM_Try, /*On fail goto*//*Label 2695*/ GIMT_Encode4(137645), // Rule ID 858 //
     /* 137614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 137617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 137622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 137625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 137628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137636 */     // (intrinsic_wo_chain:{ *:[v2f32] } 632:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRECPEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 137636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv2f32),
     /* 137639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137643 */     GIR_RootConstrainSelectedInstOperands,
     /* 137644 */     // GIR_Coverage, 858,
     /* 137644 */     GIR_EraseRootFromParent_Done,
     /* 137645 */   // Label 2695: @137645
     /* 137645 */   GIM_Try, /*On fail goto*//*Label 2696*/ GIMT_Encode4(137681), // Rule ID 859 //
     /* 137650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 137653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 137658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 137661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 137664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137672 */     // (intrinsic_wo_chain:{ *:[v4f32] } 632:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRECPEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 137672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv4f32),
     /* 137675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137679 */     GIR_RootConstrainSelectedInstOperands,
     /* 137680 */     // GIR_Coverage, 859,
     /* 137680 */     GIR_EraseRootFromParent_Done,
     /* 137681 */   // Label 2696: @137681
     /* 137681 */   GIM_Try, /*On fail goto*//*Label 2697*/ GIMT_Encode4(137717), // Rule ID 860 //
     /* 137686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 137689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 137694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 137697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 137700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137708 */     // (intrinsic_wo_chain:{ *:[v2f64] } 632:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRECPEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 137708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv2f64),
     /* 137711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137715 */     GIR_RootConstrainSelectedInstOperands,
     /* 137716 */     // GIR_Coverage, 860,
     /* 137716 */     GIR_EraseRootFromParent_Done,
     /* 137717 */   // Label 2697: @137717
     /* 137717 */   GIM_Try, /*On fail goto*//*Label 2698*/ GIMT_Encode4(137753), // Rule ID 931 //
     /* 137722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 137725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 137730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 137733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 137736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137744 */     // (intrinsic_wo_chain:{ *:[v2f32] } 636:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT32Zv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 137744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv2f32),
     /* 137747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137751 */     GIR_RootConstrainSelectedInstOperands,
     /* 137752 */     // GIR_Coverage, 931,
     /* 137752 */     GIR_EraseRootFromParent_Done,
     /* 137753 */   // Label 2698: @137753
     /* 137753 */   GIM_Try, /*On fail goto*//*Label 2699*/ GIMT_Encode4(137789), // Rule ID 932 //
     /* 137758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 137761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 137766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 137769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 137772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137780 */     // (intrinsic_wo_chain:{ *:[v4f32] } 636:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT32Zv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 137780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv4f32),
     /* 137783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137785 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137787 */     GIR_RootConstrainSelectedInstOperands,
     /* 137788 */     // GIR_Coverage, 932,
     /* 137788 */     GIR_EraseRootFromParent_Done,
     /* 137789 */   // Label 2699: @137789
     /* 137789 */   GIM_Try, /*On fail goto*//*Label 2700*/ GIMT_Encode4(137825), // Rule ID 933 //
     /* 137794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 137797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 137802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 137805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 137808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137816 */     // (intrinsic_wo_chain:{ *:[v2f64] } 636:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT32Zv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 137816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv2f64),
     /* 137819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137823 */     GIR_RootConstrainSelectedInstOperands,
     /* 137824 */     // GIR_Coverage, 933,
     /* 137824 */     GIR_EraseRootFromParent_Done,
     /* 137825 */   // Label 2700: @137825
     /* 137825 */   GIM_Try, /*On fail goto*//*Label 2701*/ GIMT_Encode4(137861), // Rule ID 934 //
     /* 137830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 137833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 137838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 137841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 137844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137852 */     // (intrinsic_wo_chain:{ *:[v2f32] } 638:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT64Zv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 137852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv2f32),
     /* 137855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137859 */     GIR_RootConstrainSelectedInstOperands,
     /* 137860 */     // GIR_Coverage, 934,
     /* 137860 */     GIR_EraseRootFromParent_Done,
     /* 137861 */   // Label 2701: @137861
     /* 137861 */   GIM_Try, /*On fail goto*//*Label 2702*/ GIMT_Encode4(137897), // Rule ID 935 //
     /* 137866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 137869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 137874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 137877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 137880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137888 */     // (intrinsic_wo_chain:{ *:[v4f32] } 638:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT64Zv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 137888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv4f32),
     /* 137891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137895 */     GIR_RootConstrainSelectedInstOperands,
     /* 137896 */     // GIR_Coverage, 935,
     /* 137896 */     GIR_EraseRootFromParent_Done,
     /* 137897 */   // Label 2702: @137897
     /* 137897 */   GIM_Try, /*On fail goto*//*Label 2703*/ GIMT_Encode4(137933), // Rule ID 936 //
     /* 137902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 137905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 137910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 137913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 137916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137924 */     // (intrinsic_wo_chain:{ *:[v2f64] } 638:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT64Zv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 137924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv2f64),
     /* 137927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137931 */     GIR_RootConstrainSelectedInstOperands,
     /* 137932 */     // GIR_Coverage, 936,
     /* 137932 */     GIR_EraseRootFromParent_Done,
     /* 137933 */   // Label 2703: @137933
     /* 137933 */   GIM_Try, /*On fail goto*//*Label 2704*/ GIMT_Encode4(137969), // Rule ID 937 //
     /* 137938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 137941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 137946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 137949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 137952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137960 */     // (intrinsic_wo_chain:{ *:[v2f32] } 635:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT32Xv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 137960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv2f32),
     /* 137963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 137965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 137967 */     GIR_RootConstrainSelectedInstOperands,
     /* 137968 */     // GIR_Coverage, 937,
     /* 137968 */     GIR_EraseRootFromParent_Done,
     /* 137969 */   // Label 2704: @137969
     /* 137969 */   GIM_Try, /*On fail goto*//*Label 2705*/ GIMT_Encode4(138005), // Rule ID 938 //
     /* 137974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 137977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 137982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 137985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 137988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137996 */     // (intrinsic_wo_chain:{ *:[v4f32] } 635:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT32Xv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 137996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv4f32),
     /* 137999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138003 */     GIR_RootConstrainSelectedInstOperands,
     /* 138004 */     // GIR_Coverage, 938,
     /* 138004 */     GIR_EraseRootFromParent_Done,
     /* 138005 */   // Label 2705: @138005
     /* 138005 */   GIM_Try, /*On fail goto*//*Label 2706*/ GIMT_Encode4(138041), // Rule ID 939 //
     /* 138010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 138013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 138018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 138021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 138024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138032 */     // (intrinsic_wo_chain:{ *:[v2f64] } 635:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT32Xv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 138032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv2f64),
     /* 138035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138039 */     GIR_RootConstrainSelectedInstOperands,
     /* 138040 */     // GIR_Coverage, 939,
     /* 138040 */     GIR_EraseRootFromParent_Done,
     /* 138041 */   // Label 2706: @138041
     /* 138041 */   GIM_Try, /*On fail goto*//*Label 2707*/ GIMT_Encode4(138077), // Rule ID 940 //
     /* 138046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 138049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 138054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 138057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 138060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138068 */     // (intrinsic_wo_chain:{ *:[v2f32] } 637:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT64Xv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 138068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv2f32),
     /* 138071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138075 */     GIR_RootConstrainSelectedInstOperands,
     /* 138076 */     // GIR_Coverage, 940,
     /* 138076 */     GIR_EraseRootFromParent_Done,
     /* 138077 */   // Label 2707: @138077
     /* 138077 */   GIM_Try, /*On fail goto*//*Label 2708*/ GIMT_Encode4(138113), // Rule ID 941 //
     /* 138082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 138085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 138090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 138093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 138096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138104 */     // (intrinsic_wo_chain:{ *:[v4f32] } 637:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT64Xv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 138104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv4f32),
     /* 138107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138111 */     GIR_RootConstrainSelectedInstOperands,
     /* 138112 */     // GIR_Coverage, 941,
     /* 138112 */     GIR_EraseRootFromParent_Done,
     /* 138113 */   // Label 2708: @138113
     /* 138113 */   GIM_Try, /*On fail goto*//*Label 2709*/ GIMT_Encode4(138149), // Rule ID 942 //
     /* 138118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 138121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 138126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 138129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 138132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138140 */     // (intrinsic_wo_chain:{ *:[v2f64] } 637:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT64Xv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 138140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv2f64),
     /* 138143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138147 */     GIR_RootConstrainSelectedInstOperands,
     /* 138148 */     // GIR_Coverage, 942,
     /* 138148 */     GIR_EraseRootFromParent_Done,
     /* 138149 */   // Label 2709: @138149
     /* 138149 */   GIM_Try, /*On fail goto*//*Label 2710*/ GIMT_Encode4(138185), // Rule ID 943 //
     /* 138154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 138157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 138162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 138165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 138168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138176 */     // (intrinsic_wo_chain:{ *:[v4f16] } 639:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FRSQRTEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 138176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv4f16),
     /* 138179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138183 */     GIR_RootConstrainSelectedInstOperands,
     /* 138184 */     // GIR_Coverage, 943,
     /* 138184 */     GIR_EraseRootFromParent_Done,
     /* 138185 */   // Label 2710: @138185
     /* 138185 */   GIM_Try, /*On fail goto*//*Label 2711*/ GIMT_Encode4(138221), // Rule ID 944 //
     /* 138190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 138193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 138198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 138201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 138204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138212 */     // (intrinsic_wo_chain:{ *:[v8f16] } 639:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FRSQRTEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 138212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv8f16),
     /* 138215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138219 */     GIR_RootConstrainSelectedInstOperands,
     /* 138220 */     // GIR_Coverage, 944,
     /* 138220 */     GIR_EraseRootFromParent_Done,
     /* 138221 */   // Label 2711: @138221
     /* 138221 */   GIM_Try, /*On fail goto*//*Label 2712*/ GIMT_Encode4(138257), // Rule ID 945 //
     /* 138226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 138234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 138237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 138240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138248 */     // (intrinsic_wo_chain:{ *:[v2f32] } 639:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRSQRTEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 138248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv2f32),
     /* 138251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138255 */     GIR_RootConstrainSelectedInstOperands,
     /* 138256 */     // GIR_Coverage, 945,
     /* 138256 */     GIR_EraseRootFromParent_Done,
     /* 138257 */   // Label 2712: @138257
     /* 138257 */   GIM_Try, /*On fail goto*//*Label 2713*/ GIMT_Encode4(138293), // Rule ID 946 //
     /* 138262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 138270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 138273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 138276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138284 */     // (intrinsic_wo_chain:{ *:[v4f32] } 639:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRSQRTEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 138284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv4f32),
     /* 138287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138291 */     GIR_RootConstrainSelectedInstOperands,
     /* 138292 */     // GIR_Coverage, 946,
     /* 138292 */     GIR_EraseRootFromParent_Done,
     /* 138293 */   // Label 2713: @138293
     /* 138293 */   GIM_Try, /*On fail goto*//*Label 2714*/ GIMT_Encode4(138329), // Rule ID 947 //
     /* 138298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 138306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 138309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 138312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138320 */     // (intrinsic_wo_chain:{ *:[v2f64] } 639:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRSQRTEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 138320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv2f64),
     /* 138323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138327 */     GIR_RootConstrainSelectedInstOperands,
     /* 138328 */     // GIR_Coverage, 947,
     /* 138328 */     GIR_EraseRootFromParent_Done,
     /* 138329 */   // Label 2714: @138329
     /* 138329 */   GIM_Try, /*On fail goto*//*Label 2715*/ GIMT_Encode4(138365), // Rule ID 994 //
     /* 138334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 138342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 138345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 138348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138356 */     // (intrinsic_wo_chain:{ *:[v4i16] } 660:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 138356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i8_v4i16),
     /* 138359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138363 */     GIR_RootConstrainSelectedInstOperands,
     /* 138364 */     // GIR_Coverage, 994,
     /* 138364 */     GIR_EraseRootFromParent_Done,
     /* 138365 */   // Label 2715: @138365
     /* 138365 */   GIM_Try, /*On fail goto*//*Label 2716*/ GIMT_Encode4(138401), // Rule ID 996 //
     /* 138370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 138378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 138381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 138384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138392 */     // (intrinsic_wo_chain:{ *:[v8i16] } 660:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 138392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv16i8_v8i16),
     /* 138395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138399 */     GIR_RootConstrainSelectedInstOperands,
     /* 138400 */     // GIR_Coverage, 996,
     /* 138400 */     GIR_EraseRootFromParent_Done,
     /* 138401 */   // Label 2716: @138401
     /* 138401 */   GIM_Try, /*On fail goto*//*Label 2717*/ GIMT_Encode4(138437), // Rule ID 998 //
     /* 138406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 138414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 138417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 138420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138428 */     // (intrinsic_wo_chain:{ *:[v2i32] } 660:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 138428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i16_v2i32),
     /* 138431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138435 */     GIR_RootConstrainSelectedInstOperands,
     /* 138436 */     // GIR_Coverage, 998,
     /* 138436 */     GIR_EraseRootFromParent_Done,
     /* 138437 */   // Label 2717: @138437
     /* 138437 */   GIM_Try, /*On fail goto*//*Label 2718*/ GIMT_Encode4(138473), // Rule ID 1000 //
     /* 138442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 138450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 138453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 138456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138464 */     // (intrinsic_wo_chain:{ *:[v4i32] } 660:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 138464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i16_v4i32),
     /* 138467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138471 */     GIR_RootConstrainSelectedInstOperands,
     /* 138472 */     // GIR_Coverage, 1000,
     /* 138472 */     GIR_EraseRootFromParent_Done,
     /* 138473 */   // Label 2718: @138473
     /* 138473 */   GIM_Try, /*On fail goto*//*Label 2719*/ GIMT_Encode4(138509), // Rule ID 1002 //
     /* 138478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 138486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 138489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 138492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138500 */     // (intrinsic_wo_chain:{ *:[v1i64] } 660:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 138500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
     /* 138503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138507 */     GIR_RootConstrainSelectedInstOperands,
     /* 138508 */     // GIR_Coverage, 1002,
     /* 138508 */     GIR_EraseRootFromParent_Done,
     /* 138509 */   // Label 2719: @138509
     /* 138509 */   GIM_Try, /*On fail goto*//*Label 2720*/ GIMT_Encode4(138545), // Rule ID 1004 //
     /* 138514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 138522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 138525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 138528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138536 */     // (intrinsic_wo_chain:{ *:[v2i64] } 660:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 138536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i32_v2i64),
     /* 138539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138543 */     GIR_RootConstrainSelectedInstOperands,
     /* 138544 */     // GIR_Coverage, 1004,
     /* 138544 */     GIR_EraseRootFromParent_Done,
     /* 138545 */   // Label 2720: @138545
     /* 138545 */   GIM_Try, /*On fail goto*//*Label 2721*/ GIMT_Encode4(138581), // Rule ID 1015 //
     /* 138550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 138558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 138561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 138564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138572 */     // (intrinsic_wo_chain:{ *:[v8i8] } 678:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SQABSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 138572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv8i8),
     /* 138575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138579 */     GIR_RootConstrainSelectedInstOperands,
     /* 138580 */     // GIR_Coverage, 1015,
     /* 138580 */     GIR_EraseRootFromParent_Done,
     /* 138581 */   // Label 2721: @138581
     /* 138581 */   GIM_Try, /*On fail goto*//*Label 2722*/ GIMT_Encode4(138617), // Rule ID 1016 //
     /* 138586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 138594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 138597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 138600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138608 */     // (intrinsic_wo_chain:{ *:[v16i8] } 678:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SQABSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 138608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv16i8),
     /* 138611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138615 */     GIR_RootConstrainSelectedInstOperands,
     /* 138616 */     // GIR_Coverage, 1016,
     /* 138616 */     GIR_EraseRootFromParent_Done,
     /* 138617 */   // Label 2722: @138617
     /* 138617 */   GIM_Try, /*On fail goto*//*Label 2723*/ GIMT_Encode4(138653), // Rule ID 1017 //
     /* 138622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 138630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 138633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 138636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138644 */     // (intrinsic_wo_chain:{ *:[v4i16] } 678:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SQABSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 138644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv4i16),
     /* 138647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138651 */     GIR_RootConstrainSelectedInstOperands,
     /* 138652 */     // GIR_Coverage, 1017,
     /* 138652 */     GIR_EraseRootFromParent_Done,
     /* 138653 */   // Label 2723: @138653
     /* 138653 */   GIM_Try, /*On fail goto*//*Label 2724*/ GIMT_Encode4(138689), // Rule ID 1018 //
     /* 138658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 138666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 138669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 138672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138680 */     // (intrinsic_wo_chain:{ *:[v8i16] } 678:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SQABSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 138680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv8i16),
     /* 138683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138687 */     GIR_RootConstrainSelectedInstOperands,
     /* 138688 */     // GIR_Coverage, 1018,
     /* 138688 */     GIR_EraseRootFromParent_Done,
     /* 138689 */   // Label 2724: @138689
     /* 138689 */   GIM_Try, /*On fail goto*//*Label 2725*/ GIMT_Encode4(138725), // Rule ID 1019 //
     /* 138694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 138702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 138705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 138708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138716 */     // (intrinsic_wo_chain:{ *:[v2i32] } 678:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SQABSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 138716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv2i32),
     /* 138719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138723 */     GIR_RootConstrainSelectedInstOperands,
     /* 138724 */     // GIR_Coverage, 1019,
     /* 138724 */     GIR_EraseRootFromParent_Done,
     /* 138725 */   // Label 2725: @138725
     /* 138725 */   GIM_Try, /*On fail goto*//*Label 2726*/ GIMT_Encode4(138761), // Rule ID 1020 //
     /* 138730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 138738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 138741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 138744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138752 */     // (intrinsic_wo_chain:{ *:[v4i32] } 678:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SQABSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 138752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv4i32),
     /* 138755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138759 */     GIR_RootConstrainSelectedInstOperands,
     /* 138760 */     // GIR_Coverage, 1020,
     /* 138760 */     GIR_EraseRootFromParent_Done,
     /* 138761 */   // Label 2726: @138761
     /* 138761 */   GIM_Try, /*On fail goto*//*Label 2727*/ GIMT_Encode4(138797), // Rule ID 1021 //
     /* 138766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 138774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 138777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 138780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138788 */     // (intrinsic_wo_chain:{ *:[v2i64] } 678:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (SQABSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 138788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv2i64),
     /* 138791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138795 */     GIR_RootConstrainSelectedInstOperands,
     /* 138796 */     // GIR_Coverage, 1021,
     /* 138796 */     GIR_EraseRootFromParent_Done,
     /* 138797 */   // Label 2727: @138797
     /* 138797 */   GIM_Try, /*On fail goto*//*Label 2728*/ GIMT_Encode4(138833), // Rule ID 1022 //
     /* 138802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 138810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 138813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 138816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138824 */     // (intrinsic_wo_chain:{ *:[v8i8] } 685:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SQNEGv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 138824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv8i8),
     /* 138827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138831 */     GIR_RootConstrainSelectedInstOperands,
     /* 138832 */     // GIR_Coverage, 1022,
     /* 138832 */     GIR_EraseRootFromParent_Done,
     /* 138833 */   // Label 2728: @138833
     /* 138833 */   GIM_Try, /*On fail goto*//*Label 2729*/ GIMT_Encode4(138869), // Rule ID 1023 //
     /* 138838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 138846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 138849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 138852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138860 */     // (intrinsic_wo_chain:{ *:[v16i8] } 685:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SQNEGv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 138860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv16i8),
     /* 138863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138867 */     GIR_RootConstrainSelectedInstOperands,
     /* 138868 */     // GIR_Coverage, 1023,
     /* 138868 */     GIR_EraseRootFromParent_Done,
     /* 138869 */   // Label 2729: @138869
     /* 138869 */   GIM_Try, /*On fail goto*//*Label 2730*/ GIMT_Encode4(138905), // Rule ID 1024 //
     /* 138874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 138882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 138885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 138888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138896 */     // (intrinsic_wo_chain:{ *:[v4i16] } 685:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SQNEGv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 138896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv4i16),
     /* 138899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138903 */     GIR_RootConstrainSelectedInstOperands,
     /* 138904 */     // GIR_Coverage, 1024,
     /* 138904 */     GIR_EraseRootFromParent_Done,
     /* 138905 */   // Label 2730: @138905
     /* 138905 */   GIM_Try, /*On fail goto*//*Label 2731*/ GIMT_Encode4(138941), // Rule ID 1025 //
     /* 138910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 138918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 138921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 138924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138932 */     // (intrinsic_wo_chain:{ *:[v8i16] } 685:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SQNEGv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 138932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv8i16),
     /* 138935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138939 */     GIR_RootConstrainSelectedInstOperands,
     /* 138940 */     // GIR_Coverage, 1025,
     /* 138940 */     GIR_EraseRootFromParent_Done,
     /* 138941 */   // Label 2731: @138941
     /* 138941 */   GIM_Try, /*On fail goto*//*Label 2732*/ GIMT_Encode4(138977), // Rule ID 1026 //
     /* 138946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 138954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 138957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 138960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138968 */     // (intrinsic_wo_chain:{ *:[v2i32] } 685:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SQNEGv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 138968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv2i32),
     /* 138971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 138975 */     GIR_RootConstrainSelectedInstOperands,
     /* 138976 */     // GIR_Coverage, 1026,
     /* 138976 */     GIR_EraseRootFromParent_Done,
     /* 138977 */   // Label 2732: @138977
     /* 138977 */   GIM_Try, /*On fail goto*//*Label 2733*/ GIMT_Encode4(139013), // Rule ID 1027 //
     /* 138982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 138985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 138990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 138993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 138996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139004 */     // (intrinsic_wo_chain:{ *:[v4i32] } 685:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SQNEGv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 139004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv4i32),
     /* 139007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139011 */     GIR_RootConstrainSelectedInstOperands,
     /* 139012 */     // GIR_Coverage, 1027,
     /* 139012 */     GIR_EraseRootFromParent_Done,
     /* 139013 */   // Label 2733: @139013
     /* 139013 */   GIM_Try, /*On fail goto*//*Label 2734*/ GIMT_Encode4(139049), // Rule ID 1028 //
     /* 139018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 139026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 139029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 139032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139040 */     // (intrinsic_wo_chain:{ *:[v2i64] } 685:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (SQNEGv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 139040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv2i64),
     /* 139043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139047 */     GIR_RootConstrainSelectedInstOperands,
     /* 139048 */     // GIR_Coverage, 1028,
     /* 139048 */     GIR_EraseRootFromParent_Done,
     /* 139049 */   // Label 2734: @139049
     /* 139049 */   GIM_Try, /*On fail goto*//*Label 2735*/ GIMT_Encode4(139085), // Rule ID 1055 //
     /* 139054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 139062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 139065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 139068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139076 */     // (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 139076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i8_v4i16),
     /* 139079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139083 */     GIR_RootConstrainSelectedInstOperands,
     /* 139084 */     // GIR_Coverage, 1055,
     /* 139084 */     GIR_EraseRootFromParent_Done,
     /* 139085 */   // Label 2735: @139085
     /* 139085 */   GIM_Try, /*On fail goto*//*Label 2736*/ GIMT_Encode4(139121), // Rule ID 1057 //
     /* 139090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 139098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 139101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 139104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139112 */     // (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 139112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv16i8_v8i16),
     /* 139115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139119 */     GIR_RootConstrainSelectedInstOperands,
     /* 139120 */     // GIR_Coverage, 1057,
     /* 139120 */     GIR_EraseRootFromParent_Done,
     /* 139121 */   // Label 2736: @139121
     /* 139121 */   GIM_Try, /*On fail goto*//*Label 2737*/ GIMT_Encode4(139157), // Rule ID 1059 //
     /* 139126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 139134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 139137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 139140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139148 */     // (intrinsic_wo_chain:{ *:[v2i32] } 725:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 139148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i16_v2i32),
     /* 139151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139155 */     GIR_RootConstrainSelectedInstOperands,
     /* 139156 */     // GIR_Coverage, 1059,
     /* 139156 */     GIR_EraseRootFromParent_Done,
     /* 139157 */   // Label 2737: @139157
     /* 139157 */   GIM_Try, /*On fail goto*//*Label 2738*/ GIMT_Encode4(139193), // Rule ID 1061 //
     /* 139162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 139170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 139173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 139176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139184 */     // (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 139184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i16_v4i32),
     /* 139187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139191 */     GIR_RootConstrainSelectedInstOperands,
     /* 139192 */     // GIR_Coverage, 1061,
     /* 139192 */     GIR_EraseRootFromParent_Done,
     /* 139193 */   // Label 2738: @139193
     /* 139193 */   GIM_Try, /*On fail goto*//*Label 2739*/ GIMT_Encode4(139229), // Rule ID 1063 //
     /* 139198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 139206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 139209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 139212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139220 */     // (intrinsic_wo_chain:{ *:[v1i64] } 725:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (UADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 139220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
     /* 139223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139227 */     GIR_RootConstrainSelectedInstOperands,
     /* 139228 */     // GIR_Coverage, 1063,
     /* 139228 */     GIR_EraseRootFromParent_Done,
     /* 139229 */   // Label 2739: @139229
     /* 139229 */   GIM_Try, /*On fail goto*//*Label 2740*/ GIMT_Encode4(139265), // Rule ID 1065 //
     /* 139234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 139242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 139245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 139248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139256 */     // (intrinsic_wo_chain:{ *:[v2i64] } 725:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (UADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 139256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i32_v2i64),
     /* 139259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139263 */     GIR_RootConstrainSelectedInstOperands,
     /* 139264 */     // GIR_Coverage, 1065,
     /* 139264 */     GIR_EraseRootFromParent_Done,
     /* 139265 */   // Label 2740: @139265
     /* 139265 */   GIM_Try, /*On fail goto*//*Label 2741*/ GIMT_Encode4(139301), // Rule ID 1079 //
     /* 139270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urecpe),
     /* 139278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 139281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 139284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139292 */     // (intrinsic_wo_chain:{ *:[v2i32] } 746:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (URECPEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 139292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPEv2i32),
     /* 139295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139299 */     GIR_RootConstrainSelectedInstOperands,
     /* 139300 */     // GIR_Coverage, 1079,
     /* 139300 */     GIR_EraseRootFromParent_Done,
     /* 139301 */   // Label 2741: @139301
     /* 139301 */   GIM_Try, /*On fail goto*//*Label 2742*/ GIMT_Encode4(139337), // Rule ID 1080 //
     /* 139306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urecpe),
     /* 139314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 139317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 139320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139328 */     // (intrinsic_wo_chain:{ *:[v4i32] } 746:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (URECPEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 139328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPEv4i32),
     /* 139331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139335 */     GIR_RootConstrainSelectedInstOperands,
     /* 139336 */     // GIR_Coverage, 1080,
     /* 139336 */     GIR_EraseRootFromParent_Done,
     /* 139337 */   // Label 2742: @139337
     /* 139337 */   GIM_Try, /*On fail goto*//*Label 2743*/ GIMT_Encode4(139373), // Rule ID 1081 //
     /* 139342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ursqrte),
     /* 139350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 139353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 139356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139364 */     // (intrinsic_wo_chain:{ *:[v2i32] } 749:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (URSQRTEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 139364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTEv2i32),
     /* 139367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139369 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139371 */     GIR_RootConstrainSelectedInstOperands,
     /* 139372 */     // GIR_Coverage, 1081,
     /* 139372 */     GIR_EraseRootFromParent_Done,
     /* 139373 */   // Label 2743: @139373
     /* 139373 */   GIM_Try, /*On fail goto*//*Label 2744*/ GIMT_Encode4(139409), // Rule ID 1082 //
     /* 139378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ursqrte),
     /* 139386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 139389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 139392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139400 */     // (intrinsic_wo_chain:{ *:[v4i32] } 749:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (URSQRTEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 139400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTEv4i32),
     /* 139403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139407 */     GIR_RootConstrainSelectedInstOperands,
     /* 139408 */     // GIR_Coverage, 1082,
     /* 139408 */     GIR_EraseRootFromParent_Done,
     /* 139409 */   // Label 2744: @139409
     /* 139409 */   GIM_Try, /*On fail goto*//*Label 2745*/ GIMT_Encode4(139445), // Rule ID 1646 //
     /* 139414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fcvtxn),
     /* 139422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 139425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 139428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139436 */     // (intrinsic_wo_chain:{ *:[f32] } 786:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTXNv1i64:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 139436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv1i64),
     /* 139439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139443 */     GIR_RootConstrainSelectedInstOperands,
     /* 139444 */     // GIR_Coverage, 1646,
     /* 139444 */     GIR_EraseRootFromParent_Done,
     /* 139445 */   // Label 2745: @139445
     /* 139445 */   GIM_Try, /*On fail goto*//*Label 2746*/ GIMT_Encode4(139481), // Rule ID 1652 //
     /* 139450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 139458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 139461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 139464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139472 */     // (intrinsic_wo_chain:{ *:[i64] } 678:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn)  =>  (SQABSv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /* 139472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i64),
     /* 139475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139479 */     GIR_RootConstrainSelectedInstOperands,
     /* 139480 */     // GIR_Coverage, 1652,
     /* 139480 */     GIR_EraseRootFromParent_Done,
     /* 139481 */   // Label 2746: @139481
     /* 139481 */   GIM_Try, /*On fail goto*//*Label 2747*/ GIMT_Encode4(139517), // Rule ID 1653 //
     /* 139486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 139494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 139497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 139500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139508 */     // (intrinsic_wo_chain:{ *:[i32] } 678:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SQABSv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
     /* 139508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i32),
     /* 139511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139515 */     GIR_RootConstrainSelectedInstOperands,
     /* 139516 */     // GIR_Coverage, 1653,
     /* 139516 */     GIR_EraseRootFromParent_Done,
     /* 139517 */   // Label 2747: @139517
     /* 139517 */   GIM_Try, /*On fail goto*//*Label 2748*/ GIMT_Encode4(139553), // Rule ID 1654 //
     /* 139522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 139530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 139533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 139536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139544 */     // (intrinsic_wo_chain:{ *:[i64] } 685:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn)  =>  (SQNEGv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /* 139544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i64),
     /* 139547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139551 */     GIR_RootConstrainSelectedInstOperands,
     /* 139552 */     // GIR_Coverage, 1654,
     /* 139552 */     GIR_EraseRootFromParent_Done,
     /* 139553 */   // Label 2748: @139553
     /* 139553 */   GIM_Try, /*On fail goto*//*Label 2749*/ GIMT_Encode4(139589), // Rule ID 1655 //
     /* 139558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 139566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 139569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 139572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139580 */     // (intrinsic_wo_chain:{ *:[i32] } 685:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SQNEGv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
     /* 139580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i32),
     /* 139583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139587 */     GIR_RootConstrainSelectedInstOperands,
     /* 139588 */     // GIR_Coverage, 1655,
     /* 139588 */     GIR_EraseRootFromParent_Done,
     /* 139589 */   // Label 2749: @139589
     /* 139589 */   GIM_Try, /*On fail goto*//*Label 2750*/ GIMT_Encode4(139625), // Rule ID 1656 //
     /* 139594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_sqxtn),
     /* 139602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 139605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 139608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139616 */     // (intrinsic_wo_chain:{ *:[f32] } 663:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (SQXTNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 139616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNv1i32),
     /* 139619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139623 */     GIR_RootConstrainSelectedInstOperands,
     /* 139624 */     // GIR_Coverage, 1656,
     /* 139624 */     GIR_EraseRootFromParent_Done,
     /* 139625 */   // Label 2750: @139625
     /* 139625 */   GIM_Try, /*On fail goto*//*Label 2751*/ GIMT_Encode4(139661), // Rule ID 1657 //
     /* 139630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_sqxtun),
     /* 139638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 139641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 139644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139652 */     // (intrinsic_wo_chain:{ *:[f32] } 664:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (SQXTUNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 139652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNv1i32),
     /* 139655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139659 */     GIR_RootConstrainSelectedInstOperands,
     /* 139660 */     // GIR_Coverage, 1657,
     /* 139660 */     GIR_EraseRootFromParent_Done,
     /* 139661 */   // Label 2751: @139661
     /* 139661 */   GIM_Try, /*On fail goto*//*Label 2752*/ GIMT_Encode4(139697), // Rule ID 1663 //
     /* 139666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_uqxtn),
     /* 139674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 139677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 139680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139688 */     // (intrinsic_wo_chain:{ *:[f32] } 665:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (UQXTNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 139688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNv1i32),
     /* 139691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139695 */     GIR_RootConstrainSelectedInstOperands,
     /* 139696 */     // GIR_Coverage, 1663,
     /* 139696 */     GIR_EraseRootFromParent_Done,
     /* 139697 */   // Label 2752: @139697
     /* 139697 */   GIM_Try, /*On fail goto*//*Label 2753*/ GIMT_Encode4(139733), // Rule ID 1936 //
     /* 139702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 139705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 139710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 139713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 139716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139724 */     // (intrinsic_wo_chain:{ *:[f16] } 597:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMAXNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 139724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i16v),
     /* 139727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139731 */     GIR_RootConstrainSelectedInstOperands,
     /* 139732 */     // GIR_Coverage, 1936,
     /* 139732 */     GIR_EraseRootFromParent_Done,
     /* 139733 */   // Label 2753: @139733
     /* 139733 */   GIM_Try, /*On fail goto*//*Label 2754*/ GIMT_Encode4(139769), // Rule ID 1938 //
     /* 139738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 139741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 139746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 139749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 139752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139760 */     // (intrinsic_wo_chain:{ *:[f16] } 597:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMAXNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 139760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv8i16v),
     /* 139763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139767 */     GIR_RootConstrainSelectedInstOperands,
     /* 139768 */     // GIR_Coverage, 1938,
     /* 139768 */     GIR_EraseRootFromParent_Done,
     /* 139769 */   // Label 2754: @139769
     /* 139769 */   GIM_Try, /*On fail goto*//*Label 2755*/ GIMT_Encode4(139805), // Rule ID 1940 //
     /* 139774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 139782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 139785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 139788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139796 */     // (intrinsic_wo_chain:{ *:[f32] } 597:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMAXNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 139796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i32v),
     /* 139799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139803 */     GIR_RootConstrainSelectedInstOperands,
     /* 139804 */     // GIR_Coverage, 1940,
     /* 139804 */     GIR_EraseRootFromParent_Done,
     /* 139805 */   // Label 2755: @139805
     /* 139805 */   GIM_Try, /*On fail goto*//*Label 2756*/ GIMT_Encode4(139841), // Rule ID 1942 //
     /* 139810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 139813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 139818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 139821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 139824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139832 */     // (intrinsic_wo_chain:{ *:[f16] } 599:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMAXVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 139832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i16v),
     /* 139835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139839 */     GIR_RootConstrainSelectedInstOperands,
     /* 139840 */     // GIR_Coverage, 1942,
     /* 139840 */     GIR_EraseRootFromParent_Done,
     /* 139841 */   // Label 2756: @139841
     /* 139841 */   GIM_Try, /*On fail goto*//*Label 2757*/ GIMT_Encode4(139877), // Rule ID 1944 //
     /* 139846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 139849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 139854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 139857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 139860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139868 */     // (intrinsic_wo_chain:{ *:[f16] } 599:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMAXVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 139868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv8i16v),
     /* 139871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139875 */     GIR_RootConstrainSelectedInstOperands,
     /* 139876 */     // GIR_Coverage, 1944,
     /* 139876 */     GIR_EraseRootFromParent_Done,
     /* 139877 */   // Label 2757: @139877
     /* 139877 */   GIM_Try, /*On fail goto*//*Label 2758*/ GIMT_Encode4(139913), // Rule ID 1946 //
     /* 139882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 139890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 139893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 139896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139904 */     // (intrinsic_wo_chain:{ *:[f32] } 599:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMAXVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 139904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i32v),
     /* 139907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139911 */     GIR_RootConstrainSelectedInstOperands,
     /* 139912 */     // GIR_Coverage, 1946,
     /* 139912 */     GIR_EraseRootFromParent_Done,
     /* 139913 */   // Label 2758: @139913
     /* 139913 */   GIM_Try, /*On fail goto*//*Label 2759*/ GIMT_Encode4(139949), // Rule ID 1948 //
     /* 139918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 139921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 139926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 139929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 139932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139940 */     // (intrinsic_wo_chain:{ *:[f16] } 603:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 139940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i16v),
     /* 139943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139947 */     GIR_RootConstrainSelectedInstOperands,
     /* 139948 */     // GIR_Coverage, 1948,
     /* 139948 */     GIR_EraseRootFromParent_Done,
     /* 139949 */   // Label 2759: @139949
     /* 139949 */   GIM_Try, /*On fail goto*//*Label 2760*/ GIMT_Encode4(139985), // Rule ID 1950 //
     /* 139954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 139957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 139962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 139965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 139968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139976 */     // (intrinsic_wo_chain:{ *:[f16] } 603:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 139976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv8i16v),
     /* 139979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139983 */     GIR_RootConstrainSelectedInstOperands,
     /* 139984 */     // GIR_Coverage, 1950,
     /* 139984 */     GIR_EraseRootFromParent_Done,
     /* 139985 */   // Label 2760: @139985
     /* 139985 */   GIM_Try, /*On fail goto*//*Label 2761*/ GIMT_Encode4(140021), // Rule ID 1952 //
     /* 139990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 139993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 139998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 140004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140012 */     // (intrinsic_wo_chain:{ *:[f32] } 603:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 140012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i32v),
     /* 140015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140019 */     GIR_RootConstrainSelectedInstOperands,
     /* 140020 */     // GIR_Coverage, 1952,
     /* 140020 */     GIR_EraseRootFromParent_Done,
     /* 140021 */   // Label 2761: @140021
     /* 140021 */   GIM_Try, /*On fail goto*//*Label 2762*/ GIMT_Encode4(140057), // Rule ID 1954 //
     /* 140026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 140029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 140034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 140037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 140040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140048 */     // (intrinsic_wo_chain:{ *:[f16] } 605:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMINVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 140048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i16v),
     /* 140051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140055 */     GIR_RootConstrainSelectedInstOperands,
     /* 140056 */     // GIR_Coverage, 1954,
     /* 140056 */     GIR_EraseRootFromParent_Done,
     /* 140057 */   // Label 2762: @140057
     /* 140057 */   GIM_Try, /*On fail goto*//*Label 2763*/ GIMT_Encode4(140093), // Rule ID 1956 //
     /* 140062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 140065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 140070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 140073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 140076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140084 */     // (intrinsic_wo_chain:{ *:[f16] } 605:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMINVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 140084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv8i16v),
     /* 140087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140091 */     GIR_RootConstrainSelectedInstOperands,
     /* 140092 */     // GIR_Coverage, 1956,
     /* 140092 */     GIR_EraseRootFromParent_Done,
     /* 140093 */   // Label 2763: @140093
     /* 140093 */   GIM_Try, /*On fail goto*//*Label 2764*/ GIMT_Encode4(140129), // Rule ID 1958 //
     /* 140098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 140101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 140106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 140112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140120 */     // (intrinsic_wo_chain:{ *:[f32] } 605:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMINVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 140120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i32v),
     /* 140123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140127 */     GIR_RootConstrainSelectedInstOperands,
     /* 140128 */     // GIR_Coverage, 1958,
     /* 140128 */     GIR_EraseRootFromParent_Done,
     /* 140129 */   // Label 2764: @140129
     /* 140129 */   GIM_Try, /*On fail goto*//*Label 2765*/ GIMT_Encode4(140165), // Rule ID 2296 //
     /* 140134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 140137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesmc),
     /* 140142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 140145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 140148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140156 */     // (intrinsic_wo_chain:{ *:[v16i8] } 514:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (AESMCrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 140156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMCrr),
     /* 140159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140163 */     GIR_RootConstrainSelectedInstOperands,
     /* 140164 */     // GIR_Coverage, 2296,
     /* 140164 */     GIR_EraseRootFromParent_Done,
     /* 140165 */   // Label 2765: @140165
     /* 140165 */   GIM_Try, /*On fail goto*//*Label 2766*/ GIMT_Encode4(140201), // Rule ID 2297 //
     /* 140170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 140173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesimc),
     /* 140178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 140181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 140184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140192 */     // (intrinsic_wo_chain:{ *:[v16i8] } 513:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (AESIMCrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 140192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMCrr),
     /* 140195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140199 */     GIR_RootConstrainSelectedInstOperands,
     /* 140200 */     // GIR_Coverage, 2297,
     /* 140200 */     GIR_EraseRootFromParent_Done,
     /* 140201 */   // Label 2766: @140201
     /* 140201 */   GIM_Try, /*On fail goto*//*Label 2767*/ GIMT_Encode4(140237), // Rule ID 2305 //
     /* 140206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 140209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1h),
     /* 140214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 140220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140228 */     // (intrinsic_wo_chain:{ *:[i32] } 521:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SHA1Hrr:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
     /* 140228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Hrr),
     /* 140231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140235 */     GIR_RootConstrainSelectedInstOperands,
     /* 140236 */     // GIR_Coverage, 2305,
     /* 140236 */     GIR_EraseRootFromParent_Done,
     /* 140237 */   // Label 2767: @140237
     /* 140237 */   GIM_Try, /*On fail goto*//*Label 2768*/ GIMT_Encode4(140273), // Rule ID 2506 //
     /* 140242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 140245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 140250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140264 */     // (intrinsic_wo_chain:{ *:[v1i64] } 678:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (SQABSv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 140264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i64),
     /* 140267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140271 */     GIR_RootConstrainSelectedInstOperands,
     /* 140272 */     // GIR_Coverage, 2506,
     /* 140272 */     GIR_EraseRootFromParent_Done,
     /* 140273 */   // Label 2768: @140273
     /* 140273 */   GIM_Try, /*On fail goto*//*Label 2769*/ GIMT_Encode4(140312), // Rule ID 3528 //
     /* 140278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 140281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 140286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 140289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 140292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 140296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 140300 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1533:{ *:[iPTR] }, ZPRAny:{ *:[nxv16i8] }:$Zn)  =>  (PMOV_PZI_B:{ *:[nxv16i1] } ZPRAny:{ *:[nxv16i8] }:$Zn, 0:{ *:[i32] })
     /* 140300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_B),
     /* 140303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 140305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 140307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140310 */     GIR_RootConstrainSelectedInstOperands,
     /* 140311 */     // GIR_Coverage, 3528,
     /* 140311 */     GIR_EraseRootFromParent_Done,
     /* 140312 */   // Label 2769: @140312
     /* 140312 */   GIM_Try, /*On fail goto*//*Label 2770*/ GIMT_Encode4(140351), // Rule ID 3529 //
     /* 140317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 140320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 140325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 140328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 140331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 140335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 140339 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1533:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zn)  =>  (PMOV_PZI_H:{ *:[nxv8i1] } ZPRAny:{ *:[nxv8i16] }:$Zn, 0:{ *:[i32] })
     /* 140339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_H),
     /* 140342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 140344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 140346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140349 */     GIR_RootConstrainSelectedInstOperands,
     /* 140350 */     // GIR_Coverage, 3529,
     /* 140350 */     GIR_EraseRootFromParent_Done,
     /* 140351 */   // Label 2770: @140351
     /* 140351 */   GIM_Try, /*On fail goto*//*Label 2771*/ GIMT_Encode4(140390), // Rule ID 3530 //
     /* 140356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 140359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 140364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 140367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 140370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 140374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 140378 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1533:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zn)  =>  (PMOV_PZI_S:{ *:[nxv4i1] } ZPRAny:{ *:[nxv4i32] }:$Zn, 0:{ *:[i32] })
     /* 140378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_S),
     /* 140381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 140383 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 140385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140388 */     GIR_RootConstrainSelectedInstOperands,
     /* 140389 */     // GIR_Coverage, 3530,
     /* 140389 */     GIR_EraseRootFromParent_Done,
     /* 140390 */   // Label 2771: @140390
     /* 140390 */   GIM_Try, /*On fail goto*//*Label 2772*/ GIMT_Encode4(140429), // Rule ID 3531 //
     /* 140395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 140398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 140403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 140406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 140409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 140413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 140417 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1533:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zn)  =>  (PMOV_PZI_D:{ *:[nxv2i1] } ZPRAny:{ *:[nxv2i64] }:$Zn, 0:{ *:[i32] })
     /* 140417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_D),
     /* 140420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 140422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 140424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140427 */     GIR_RootConstrainSelectedInstOperands,
     /* 140428 */     // GIR_Coverage, 3531,
     /* 140428 */     GIR_EraseRootFromParent_Done,
     /* 140429 */   // Label 2772: @140429
     /* 140429 */   GIM_Try, /*On fail goto*//*Label 2773*/ GIMT_Encode4(140485), // Rule ID 3535 //
     /* 140434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 140437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 140442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 140445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 140448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 140452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 140456 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1535:{ *:[iPTR] }, PPR8:{ *:[nxv16i1] }:$Pn)  =>  (PMOV_ZIP_B:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i64] }, PPR8:{ *:[nxv16i1] }:$Pn)
     /* 140456 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 140459 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 140463 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140468 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 140470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_B),
     /* 140473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 140475 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 140483 */     GIR_RootConstrainSelectedInstOperands,
     /* 140484 */     // GIR_Coverage, 3535,
     /* 140484 */     GIR_EraseRootFromParent_Done,
     /* 140485 */   // Label 2773: @140485
     /* 140485 */   GIM_Try, /*On fail goto*//*Label 2774*/ GIMT_Encode4(140541), // Rule ID 3536 //
     /* 140490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 140493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 140498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 140501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 140504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 140508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 140512 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1535:{ *:[iPTR] }, PPR16:{ *:[nxv8i1] }:$Pn)  =>  (PMOV_ZIP_H:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR16:{ *:[nxv8i1] }:$Pn)
     /* 140512 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 140515 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 140519 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140524 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 140526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_H),
     /* 140529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 140531 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 140539 */     GIR_RootConstrainSelectedInstOperands,
     /* 140540 */     // GIR_Coverage, 3536,
     /* 140540 */     GIR_EraseRootFromParent_Done,
     /* 140541 */   // Label 2774: @140541
     /* 140541 */   GIM_Try, /*On fail goto*//*Label 2775*/ GIMT_Encode4(140597), // Rule ID 3537 //
     /* 140546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 140549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 140554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 140557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 140560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 140564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 140568 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1535:{ *:[iPTR] }, PPR32:{ *:[nxv4i1] }:$Pn)  =>  (PMOV_ZIP_S:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR32:{ *:[nxv4i1] }:$Pn)
     /* 140568 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 140571 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 140575 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140580 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 140582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_S),
     /* 140585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 140587 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 140595 */     GIR_RootConstrainSelectedInstOperands,
     /* 140596 */     // GIR_Coverage, 3537,
     /* 140596 */     GIR_EraseRootFromParent_Done,
     /* 140597 */   // Label 2775: @140597
     /* 140597 */   GIM_Try, /*On fail goto*//*Label 2776*/ GIMT_Encode4(140653), // Rule ID 3538 //
     /* 140602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 140605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 140610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 140613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 140616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 140620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 140624 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1535:{ *:[iPTR] }, PPR64:{ *:[nxv2i1] }:$Pn)  =>  (PMOV_ZIP_D:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR64:{ *:[nxv2i1] }:$Pn)
     /* 140624 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 140627 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 140631 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140636 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 140638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_D),
     /* 140641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 140643 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 140651 */     GIR_RootConstrainSelectedInstOperands,
     /* 140652 */     // GIR_Coverage, 3538,
     /* 140652 */     GIR_EraseRootFromParent_Done,
     /* 140653 */   // Label 2776: @140653
     /* 140653 */   GIM_Try, /*On fail goto*//*Label 2777*/ GIMT_Encode4(140686), // Rule ID 3951 //
     /* 140658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_cls),
     /* 140663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 140669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140677 */     // (intrinsic_wo_chain:{ *:[i32] } 501:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn)  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 140677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
     /* 140680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140684 */     GIR_RootConstrainSelectedInstOperands,
     /* 140685 */     // GIR_Coverage, 3951,
     /* 140685 */     GIR_EraseRootFromParent_Done,
     /* 140686 */   // Label 2777: @140686
     /* 140686 */   GIM_Try, /*On fail goto*//*Label 2778*/ GIMT_Encode4(140751), // Rule ID 3952 //
     /* 140691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_cls64),
     /* 140696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140710 */     // (intrinsic_wo_chain:{ *:[i32] } 502:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rm)  =>  (EXTRACT_SUBREG:{ *:[i32] } (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rm), sub_32:{ *:[i32] })
     /* 140710 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 140713 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
     /* 140717 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140722 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 140726 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 140728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 140731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140733 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /* 140740 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140745 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140750 */     // GIR_Coverage, 3952,
     /* 140750 */     GIR_EraseRootFromParent_Done,
     /* 140751 */   // Label 2778: @140751
     /* 140751 */   GIM_Try, /*On fail goto*//*Label 2779*/ GIMT_Encode4(140784), // Rule ID 4720 //
     /* 140756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 140761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140775 */     // (intrinsic_wo_chain:{ *:[v1f64] } 636:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT32ZDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 140775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZDr),
     /* 140778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140780 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140782 */     GIR_RootConstrainSelectedInstOperands,
     /* 140783 */     // GIR_Coverage, 4720,
     /* 140783 */     GIR_EraseRootFromParent_Done,
     /* 140784 */   // Label 2779: @140784
     /* 140784 */   GIM_Try, /*On fail goto*//*Label 2780*/ GIMT_Encode4(140817), // Rule ID 4721 //
     /* 140789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 140794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140808 */     // (intrinsic_wo_chain:{ *:[v1f64] } 638:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT64ZDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 140808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZDr),
     /* 140811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140815 */     GIR_RootConstrainSelectedInstOperands,
     /* 140816 */     // GIR_Coverage, 4721,
     /* 140816 */     GIR_EraseRootFromParent_Done,
     /* 140817 */   // Label 2780: @140817
     /* 140817 */   GIM_Try, /*On fail goto*//*Label 2781*/ GIMT_Encode4(140850), // Rule ID 4722 //
     /* 140822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 140827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140841 */     // (intrinsic_wo_chain:{ *:[v1f64] } 635:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT32XDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 140841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XDr),
     /* 140844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140848 */     GIR_RootConstrainSelectedInstOperands,
     /* 140849 */     // GIR_Coverage, 4722,
     /* 140849 */     GIR_EraseRootFromParent_Done,
     /* 140850 */   // Label 2781: @140850
     /* 140850 */   GIM_Try, /*On fail goto*//*Label 2782*/ GIMT_Encode4(140883), // Rule ID 4723 //
     /* 140855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 140860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140874 */     // (intrinsic_wo_chain:{ *:[v1f64] } 637:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT64XDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 140874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XDr),
     /* 140877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140881 */     GIR_RootConstrainSelectedInstOperands,
     /* 140882 */     // GIR_Coverage, 4723,
     /* 140882 */     GIR_EraseRootFromParent_Done,
     /* 140883 */   // Label 2782: @140883
     /* 140883 */   GIM_Try, /*On fail goto*//*Label 2783*/ GIMT_Encode4(140916), // Rule ID 4837 //
     /* 140888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvthf2fp),
     /* 140893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 140896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 140899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140907 */     // (intrinsic_wo_chain:{ *:[v4f32] } 767:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (FCVTLv4i16:{ *:[v4f32] } V64:{ *:[v4i16] }:$Rn)
     /* 140907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 140910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140914 */     GIR_RootConstrainSelectedInstOperands,
     /* 140915 */     // GIR_Coverage, 4837,
     /* 140915 */     GIR_EraseRootFromParent_Done,
     /* 140916 */   // Label 2783: @140916
     /* 140916 */   GIM_Try, /*On fail goto*//*Label 2784*/ GIMT_Encode4(140949), // Rule ID 4847 //
     /* 140921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2hf),
     /* 140926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 140929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 140932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140940 */     // (intrinsic_wo_chain:{ *:[v4i16] } 764:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNv4i16:{ *:[v4i16] } V128:{ *:[v4f32] }:$Rn)
     /* 140940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 140943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140947 */     GIR_RootConstrainSelectedInstOperands,
     /* 140948 */     // GIR_Coverage, 4847,
     /* 140948 */     GIR_EraseRootFromParent_Done,
     /* 140949 */   // Label 2784: @140949
     /* 140949 */   GIM_Try, /*On fail goto*//*Label 2785*/ GIMT_Encode4(140985), // Rule ID 5185 //
     /* 140954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 140957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 140962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140976 */     // (intrinsic_wo_chain:{ *:[v1i64] } 685:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (SQNEGv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 140976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i64),
     /* 140979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140983 */     GIR_RootConstrainSelectedInstOperands,
     /* 140984 */     // GIR_Coverage, 5185,
     /* 140984 */     GIR_EraseRootFromParent_Done,
     /* 140985 */   // Label 2785: @140985
     /* 140985 */   GIM_Try, /*On fail goto*//*Label 2786*/ GIMT_Encode4(141018), // Rule ID 5188 //
     /* 140990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 140995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141009 */     // (intrinsic_wo_chain:{ *:[v1i64] } 583:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTASv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 141009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv1i64),
     /* 141012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141016 */     GIR_RootConstrainSelectedInstOperands,
     /* 141017 */     // GIR_Coverage, 5188,
     /* 141017 */     GIR_EraseRootFromParent_Done,
     /* 141018 */   // Label 2786: @141018
     /* 141018 */   GIM_Try, /*On fail goto*//*Label 2787*/ GIMT_Encode4(141051), // Rule ID 5189 //
     /* 141023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 141028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141042 */     // (intrinsic_wo_chain:{ *:[v1i64] } 584:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTAUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 141042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv1i64),
     /* 141045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141047 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141049 */     GIR_RootConstrainSelectedInstOperands,
     /* 141050 */     // GIR_Coverage, 5189,
     /* 141050 */     GIR_EraseRootFromParent_Done,
     /* 141051 */   // Label 2787: @141051
     /* 141051 */   GIM_Try, /*On fail goto*//*Label 2788*/ GIMT_Encode4(141084), // Rule ID 5190 //
     /* 141056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 141061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141075 */     // (intrinsic_wo_chain:{ *:[v1i64] } 585:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTMSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 141075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv1i64),
     /* 141078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141080 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141082 */     GIR_RootConstrainSelectedInstOperands,
     /* 141083 */     // GIR_Coverage, 5190,
     /* 141083 */     GIR_EraseRootFromParent_Done,
     /* 141084 */   // Label 2788: @141084
     /* 141084 */   GIM_Try, /*On fail goto*//*Label 2789*/ GIMT_Encode4(141117), // Rule ID 5191 //
     /* 141089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 141094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141108 */     // (intrinsic_wo_chain:{ *:[v1i64] } 586:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTMUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 141108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv1i64),
     /* 141111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141115 */     GIR_RootConstrainSelectedInstOperands,
     /* 141116 */     // GIR_Coverage, 5191,
     /* 141116 */     GIR_EraseRootFromParent_Done,
     /* 141117 */   // Label 2789: @141117
     /* 141117 */   GIM_Try, /*On fail goto*//*Label 2790*/ GIMT_Encode4(141150), // Rule ID 5192 //
     /* 141122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 141127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141141 */     // (intrinsic_wo_chain:{ *:[v1i64] } 587:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTNSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 141141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv1i64),
     /* 141144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141146 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141148 */     GIR_RootConstrainSelectedInstOperands,
     /* 141149 */     // GIR_Coverage, 5192,
     /* 141149 */     GIR_EraseRootFromParent_Done,
     /* 141150 */   // Label 2790: @141150
     /* 141150 */   GIM_Try, /*On fail goto*//*Label 2791*/ GIMT_Encode4(141183), // Rule ID 5193 //
     /* 141155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 141160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141174 */     // (intrinsic_wo_chain:{ *:[v1i64] } 588:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTNUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 141174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv1i64),
     /* 141177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141181 */     GIR_RootConstrainSelectedInstOperands,
     /* 141182 */     // GIR_Coverage, 5193,
     /* 141182 */     GIR_EraseRootFromParent_Done,
     /* 141183 */   // Label 2791: @141183
     /* 141183 */   GIM_Try, /*On fail goto*//*Label 2792*/ GIMT_Encode4(141216), // Rule ID 5194 //
     /* 141188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 141193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141207 */     // (intrinsic_wo_chain:{ *:[v1i64] } 589:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTPSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 141207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv1i64),
     /* 141210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141214 */     GIR_RootConstrainSelectedInstOperands,
     /* 141215 */     // GIR_Coverage, 5194,
     /* 141215 */     GIR_EraseRootFromParent_Done,
     /* 141216 */   // Label 2792: @141216
     /* 141216 */   GIM_Try, /*On fail goto*//*Label 2793*/ GIMT_Encode4(141249), // Rule ID 5195 //
     /* 141221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 141226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141240 */     // (intrinsic_wo_chain:{ *:[v1i64] } 590:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTPUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 141240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv1i64),
     /* 141243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141247 */     GIR_RootConstrainSelectedInstOperands,
     /* 141248 */     // GIR_Coverage, 5195,
     /* 141248 */     GIR_EraseRootFromParent_Done,
     /* 141249 */   // Label 2793: @141249
     /* 141249 */   GIM_Try, /*On fail goto*//*Label 2794*/ GIMT_Encode4(141282), // Rule ID 5196 //
     /* 141254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 141259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141273 */     // (intrinsic_wo_chain:{ *:[v1i64] } 592:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTZSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 141273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i64),
     /* 141276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141280 */     GIR_RootConstrainSelectedInstOperands,
     /* 141281 */     // GIR_Coverage, 5196,
     /* 141281 */     GIR_EraseRootFromParent_Done,
     /* 141282 */   // Label 2794: @141282
     /* 141282 */   GIM_Try, /*On fail goto*//*Label 2795*/ GIMT_Encode4(141315), // Rule ID 5197 //
     /* 141287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 141292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141306 */     // (intrinsic_wo_chain:{ *:[v1i64] } 593:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTZUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 141306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i64),
     /* 141309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141313 */     GIR_RootConstrainSelectedInstOperands,
     /* 141314 */     // GIR_Coverage, 5197,
     /* 141314 */     GIR_EraseRootFromParent_Done,
     /* 141315 */   // Label 2795: @141315
     /* 141315 */   GIM_Try, /*On fail goto*//*Label 2796*/ GIMT_Encode4(141348), // Rule ID 5198 //
     /* 141320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 141325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 141328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 141331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141339 */     // (intrinsic_wo_chain:{ *:[f16] } 632:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRECPEv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 141339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1f16),
     /* 141342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141346 */     GIR_RootConstrainSelectedInstOperands,
     /* 141347 */     // GIR_Coverage, 5198,
     /* 141347 */     GIR_EraseRootFromParent_Done,
     /* 141348 */   // Label 2796: @141348
     /* 141348 */   GIM_Try, /*On fail goto*//*Label 2797*/ GIMT_Encode4(141381), // Rule ID 5199 //
     /* 141353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 141358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 141364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141372 */     // (intrinsic_wo_chain:{ *:[f32] } 632:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRECPEv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 141372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i32),
     /* 141375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141379 */     GIR_RootConstrainSelectedInstOperands,
     /* 141380 */     // GIR_Coverage, 5199,
     /* 141380 */     GIR_EraseRootFromParent_Done,
     /* 141381 */   // Label 2797: @141381
     /* 141381 */   GIM_Try, /*On fail goto*//*Label 2798*/ GIMT_Encode4(141414), // Rule ID 5200 //
     /* 141386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 141391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141405 */     // (intrinsic_wo_chain:{ *:[f64] } 632:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRECPEv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 141405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i64),
     /* 141408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141410 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141412 */     GIR_RootConstrainSelectedInstOperands,
     /* 141413 */     // GIR_Coverage, 5200,
     /* 141413 */     GIR_EraseRootFromParent_Done,
     /* 141414 */   // Label 2798: @141414
     /* 141414 */   GIM_Try, /*On fail goto*//*Label 2799*/ GIMT_Encode4(141447), // Rule ID 5201 //
     /* 141419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 141424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141438 */     // (intrinsic_wo_chain:{ *:[v1f64] } 632:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRECPEv1i64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 141438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i64),
     /* 141441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141445 */     GIR_RootConstrainSelectedInstOperands,
     /* 141446 */     // GIR_Coverage, 5201,
     /* 141446 */     GIR_EraseRootFromParent_Done,
     /* 141447 */   // Label 2799: @141447
     /* 141447 */   GIM_Try, /*On fail goto*//*Label 2800*/ GIMT_Encode4(141480), // Rule ID 5213 //
     /* 141452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
     /* 141457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 141460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 141463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141471 */     // (intrinsic_wo_chain:{ *:[f16] } 634:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRECPXv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 141471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1f16),
     /* 141474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141478 */     GIR_RootConstrainSelectedInstOperands,
     /* 141479 */     // GIR_Coverage, 5213,
     /* 141479 */     GIR_EraseRootFromParent_Done,
     /* 141480 */   // Label 2800: @141480
     /* 141480 */   GIM_Try, /*On fail goto*//*Label 2801*/ GIMT_Encode4(141513), // Rule ID 5214 //
     /* 141485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
     /* 141490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 141496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141504 */     // (intrinsic_wo_chain:{ *:[f32] } 634:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRECPXv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 141504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1i32),
     /* 141507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141511 */     GIR_RootConstrainSelectedInstOperands,
     /* 141512 */     // GIR_Coverage, 5214,
     /* 141512 */     GIR_EraseRootFromParent_Done,
     /* 141513 */   // Label 2801: @141513
     /* 141513 */   GIM_Try, /*On fail goto*//*Label 2802*/ GIMT_Encode4(141546), // Rule ID 5215 //
     /* 141518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
     /* 141523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141537 */     // (intrinsic_wo_chain:{ *:[f64] } 634:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRECPXv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 141537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1i64),
     /* 141540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141544 */     GIR_RootConstrainSelectedInstOperands,
     /* 141545 */     // GIR_Coverage, 5215,
     /* 141545 */     GIR_EraseRootFromParent_Done,
     /* 141546 */   // Label 2802: @141546
     /* 141546 */   GIM_Try, /*On fail goto*//*Label 2803*/ GIMT_Encode4(141579), // Rule ID 5216 //
     /* 141551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 141556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 141559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 141562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141570 */     // (intrinsic_wo_chain:{ *:[f16] } 639:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRSQRTEv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 141570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1f16),
     /* 141573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141577 */     GIR_RootConstrainSelectedInstOperands,
     /* 141578 */     // GIR_Coverage, 5216,
     /* 141578 */     GIR_EraseRootFromParent_Done,
     /* 141579 */   // Label 2803: @141579
     /* 141579 */   GIM_Try, /*On fail goto*//*Label 2804*/ GIMT_Encode4(141612), // Rule ID 5217 //
     /* 141584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 141589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 141595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141603 */     // (intrinsic_wo_chain:{ *:[f32] } 639:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRSQRTEv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 141603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i32),
     /* 141606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141610 */     GIR_RootConstrainSelectedInstOperands,
     /* 141611 */     // GIR_Coverage, 5217,
     /* 141611 */     GIR_EraseRootFromParent_Done,
     /* 141612 */   // Label 2804: @141612
     /* 141612 */   GIM_Try, /*On fail goto*//*Label 2805*/ GIMT_Encode4(141645), // Rule ID 5218 //
     /* 141617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 141622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141636 */     // (intrinsic_wo_chain:{ *:[f64] } 639:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRSQRTEv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 141636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i64),
     /* 141639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141643 */     GIR_RootConstrainSelectedInstOperands,
     /* 141644 */     // GIR_Coverage, 5218,
     /* 141644 */     GIR_EraseRootFromParent_Done,
     /* 141645 */   // Label 2805: @141645
     /* 141645 */   GIM_Try, /*On fail goto*//*Label 2806*/ GIMT_Encode4(141678), // Rule ID 5219 //
     /* 141650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 141655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141669 */     // (intrinsic_wo_chain:{ *:[v1f64] } 639:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRSQRTEv1i64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 141669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i64),
     /* 141672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141676 */     GIR_RootConstrainSelectedInstOperands,
     /* 141677 */     // GIR_Coverage, 5219,
     /* 141677 */     GIR_EraseRootFromParent_Done,
     /* 141678 */   // Label 2806: @141678
     /* 141678 */   GIM_Try, /*On fail goto*//*Label 2807*/ GIMT_Encode4(141711), // Rule ID 5543 //
     /* 141683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
     /* 141688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 141694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141702 */     // (intrinsic_wo_chain:{ *:[f32] } 580:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 141702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 141705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141709 */     GIR_RootConstrainSelectedInstOperands,
     /* 141710 */     // GIR_Coverage, 5543,
     /* 141710 */     GIR_EraseRootFromParent_Done,
     /* 141711 */   // Label 2807: @141711
     /* 141711 */   GIM_Try, /*On fail goto*//*Label 2808*/ GIMT_Encode4(141796), // Rule ID 5544 //
     /* 141716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
     /* 141721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 141727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141735 */     // (intrinsic_wo_chain:{ *:[f32] } 580:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv4f32:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] }))
     /* 141735 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 141738 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 141742 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141747 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 141751 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 141755 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 141757 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 141760 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 141764 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141769 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 141776 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141781 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 141789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141791 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 141794 */     GIR_RootConstrainSelectedInstOperands,
     /* 141795 */     // GIR_Coverage, 5544,
     /* 141795 */     GIR_EraseRootFromParent_Done,
     /* 141796 */   // Label 2808: @141796
     /* 141796 */   GIM_Try, /*On fail goto*//*Label 2809*/ GIMT_Encode4(141829), // Rule ID 5545 //
     /* 141801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
     /* 141806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 141812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141820 */     // (intrinsic_wo_chain:{ *:[f64] } 580:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FADDPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 141820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 141823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141827 */     GIR_RootConstrainSelectedInstOperands,
     /* 141828 */     // GIR_Coverage, 5545,
     /* 141828 */     GIR_EraseRootFromParent_Done,
     /* 141829 */   // Label 2809: @141829
     /* 141829 */   GIM_Try, /*On fail goto*//*Label 2810*/ GIMT_Encode4(141862), // Rule ID 5547 //
     /* 141834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 141839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 141845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141853 */     // (intrinsic_wo_chain:{ *:[f32] } 597:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMAXNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 141853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i32p),
     /* 141856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141858 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141860 */     GIR_RootConstrainSelectedInstOperands,
     /* 141861 */     // GIR_Coverage, 5547,
     /* 141861 */     GIR_EraseRootFromParent_Done,
     /* 141862 */   // Label 2810: @141862
     /* 141862 */   GIM_Try, /*On fail goto*//*Label 2811*/ GIMT_Encode4(141895), // Rule ID 5549 //
     /* 141867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 141872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 141878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141886 */     // (intrinsic_wo_chain:{ *:[f64] } 597:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMAXNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 141886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i64p),
     /* 141889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141893 */     GIR_RootConstrainSelectedInstOperands,
     /* 141894 */     // GIR_Coverage, 5549,
     /* 141894 */     GIR_EraseRootFromParent_Done,
     /* 141895 */   // Label 2811: @141895
     /* 141895 */   GIM_Try, /*On fail goto*//*Label 2812*/ GIMT_Encode4(141928), // Rule ID 5551 //
     /* 141900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 141905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 141911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141919 */     // (intrinsic_wo_chain:{ *:[f32] } 599:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMAXPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 141919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i32p),
     /* 141922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141926 */     GIR_RootConstrainSelectedInstOperands,
     /* 141927 */     // GIR_Coverage, 5551,
     /* 141927 */     GIR_EraseRootFromParent_Done,
     /* 141928 */   // Label 2812: @141928
     /* 141928 */   GIM_Try, /*On fail goto*//*Label 2813*/ GIMT_Encode4(141961), // Rule ID 5553 //
     /* 141933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 141938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 141944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141952 */     // (intrinsic_wo_chain:{ *:[f64] } 599:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMAXPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 141952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i64p),
     /* 141955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141959 */     GIR_RootConstrainSelectedInstOperands,
     /* 141960 */     // GIR_Coverage, 5553,
     /* 141960 */     GIR_EraseRootFromParent_Done,
     /* 141961 */   // Label 2813: @141961
     /* 141961 */   GIM_Try, /*On fail goto*//*Label 2814*/ GIMT_Encode4(141994), // Rule ID 5555 //
     /* 141966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 141971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 141977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141985 */     // (intrinsic_wo_chain:{ *:[f32] } 603:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 141985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i32p),
     /* 141988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141992 */     GIR_RootConstrainSelectedInstOperands,
     /* 141993 */     // GIR_Coverage, 5555,
     /* 141993 */     GIR_EraseRootFromParent_Done,
     /* 141994 */   // Label 2814: @141994
     /* 141994 */   GIM_Try, /*On fail goto*//*Label 2815*/ GIMT_Encode4(142027), // Rule ID 5557 //
     /* 141999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 142004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 142007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 142010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142018 */     // (intrinsic_wo_chain:{ *:[f64] } 603:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 142018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i64p),
     /* 142021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142025 */     GIR_RootConstrainSelectedInstOperands,
     /* 142026 */     // GIR_Coverage, 5557,
     /* 142026 */     GIR_EraseRootFromParent_Done,
     /* 142027 */   // Label 2815: @142027
     /* 142027 */   GIM_Try, /*On fail goto*//*Label 2816*/ GIMT_Encode4(142060), // Rule ID 5559 //
     /* 142032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 142037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 142043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142051 */     // (intrinsic_wo_chain:{ *:[f32] } 605:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMINPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 142051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i32p),
     /* 142054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142056 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142058 */     GIR_RootConstrainSelectedInstOperands,
     /* 142059 */     // GIR_Coverage, 5559,
     /* 142059 */     GIR_EraseRootFromParent_Done,
     /* 142060 */   // Label 2816: @142060
     /* 142060 */   GIM_Try, /*On fail goto*//*Label 2817*/ GIMT_Encode4(142093), // Rule ID 5561 //
     /* 142065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 142070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 142073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 142076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142084 */     // (intrinsic_wo_chain:{ *:[f64] } 605:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMINPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 142084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i64p),
     /* 142087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142091 */     GIR_RootConstrainSelectedInstOperands,
     /* 142092 */     // GIR_Coverage, 5561,
     /* 142092 */     GIR_EraseRootFromParent_Done,
     /* 142093 */   // Label 2817: @142093
     /* 142093 */   GIM_Try, /*On fail goto*//*Label 2818*/ GIMT_Encode4(142126), // Rule ID 12841 //
     /* 142098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 142103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 142106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 142109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 142113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142117 */     // (intrinsic_wo_chain:{ *:[i8] } 662:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 142117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 142120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142124 */     GIR_RootConstrainSelectedInstOperands,
     /* 142125 */     // GIR_Coverage, 12841,
     /* 142125 */     GIR_EraseRootFromParent_Done,
     /* 142126 */   // Label 2818: @142126
     /* 142126 */   GIM_Try, /*On fail goto*//*Label 2819*/ GIMT_Encode4(142159), // Rule ID 12843 //
     /* 142131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 142136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 142139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 142142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 142146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142150 */     // (intrinsic_wo_chain:{ *:[i8] } 662:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 142150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 142153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142155 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142157 */     GIR_RootConstrainSelectedInstOperands,
     /* 142158 */     // GIR_Coverage, 12843,
     /* 142158 */     GIR_EraseRootFromParent_Done,
     /* 142159 */   // Label 2819: @142159
     /* 142159 */   GIM_Try, /*On fail goto*//*Label 2820*/ GIMT_Encode4(142192), // Rule ID 12845 //
     /* 142164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 142169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 142172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 142175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 142179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142183 */     // (intrinsic_wo_chain:{ *:[i16] } 662:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 142183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 142186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142190 */     GIR_RootConstrainSelectedInstOperands,
     /* 142191 */     // GIR_Coverage, 12845,
     /* 142191 */     GIR_EraseRootFromParent_Done,
     /* 142192 */   // Label 2820: @142192
     /* 142192 */   GIM_Try, /*On fail goto*//*Label 2821*/ GIMT_Encode4(142225), // Rule ID 12847 //
     /* 142197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 142202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 142205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 142208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 142212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142216 */     // (intrinsic_wo_chain:{ *:[i16] } 662:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 142216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 142219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142223 */     GIR_RootConstrainSelectedInstOperands,
     /* 142224 */     // GIR_Coverage, 12847,
     /* 142224 */     GIR_EraseRootFromParent_Done,
     /* 142225 */   // Label 2821: @142225
     /* 142225 */   GIM_Try, /*On fail goto*//*Label 2822*/ GIMT_Encode4(142340), // Rule ID 12848 //
     /* 142230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 142235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 142241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142249 */     // (intrinsic_wo_chain:{ *:[i32] } 662:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 142249 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 142252 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
     /* 142256 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142261 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 142265 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 142267 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 142270 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 142274 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142279 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 142281 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 142284 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 142288 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142293 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 142296 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 142299 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 142302 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142307 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142312 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 142320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142322 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 142329 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142334 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142339 */     // GIR_Coverage, 12848,
     /* 142339 */     GIR_EraseRootFromParent_Done,
     /* 142340 */   // Label 2822: @142340
     /* 142340 */   GIM_Try, /*On fail goto*//*Label 2823*/ GIMT_Encode4(142373), // Rule ID 12850 //
     /* 142345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 142350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 142353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 142356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 142360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142364 */     // (intrinsic_wo_chain:{ *:[i8] } 727:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 142364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 142367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142369 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142371 */     GIR_RootConstrainSelectedInstOperands,
     /* 142372 */     // GIR_Coverage, 12850,
     /* 142372 */     GIR_EraseRootFromParent_Done,
     /* 142373 */   // Label 2823: @142373
     /* 142373 */   GIM_Try, /*On fail goto*//*Label 2824*/ GIMT_Encode4(142406), // Rule ID 12852 //
     /* 142378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 142383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 142386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 142389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 142393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142397 */     // (intrinsic_wo_chain:{ *:[i8] } 727:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 142397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 142400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142404 */     GIR_RootConstrainSelectedInstOperands,
     /* 142405 */     // GIR_Coverage, 12852,
     /* 142405 */     GIR_EraseRootFromParent_Done,
     /* 142406 */   // Label 2824: @142406
     /* 142406 */   GIM_Try, /*On fail goto*//*Label 2825*/ GIMT_Encode4(142439), // Rule ID 12854 //
     /* 142411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 142416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 142419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 142422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 142426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142430 */     // (intrinsic_wo_chain:{ *:[i16] } 727:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 142430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 142433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142435 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142437 */     GIR_RootConstrainSelectedInstOperands,
     /* 142438 */     // GIR_Coverage, 12854,
     /* 142438 */     GIR_EraseRootFromParent_Done,
     /* 142439 */   // Label 2825: @142439
     /* 142439 */   GIM_Try, /*On fail goto*//*Label 2826*/ GIMT_Encode4(142472), // Rule ID 12856 //
     /* 142444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 142449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 142452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 142455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 142459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142463 */     // (intrinsic_wo_chain:{ *:[i16] } 727:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 142463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 142466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142470 */     GIR_RootConstrainSelectedInstOperands,
     /* 142471 */     // GIR_Coverage, 12856,
     /* 142471 */     GIR_EraseRootFromParent_Done,
     /* 142472 */   // Label 2826: @142472
     /* 142472 */   GIM_Try, /*On fail goto*//*Label 2827*/ GIMT_Encode4(142587), // Rule ID 12857 //
     /* 142477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 142482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 142488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142496 */     // (intrinsic_wo_chain:{ *:[i32] } 727:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 142496 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 142499 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
     /* 142503 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142508 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 142512 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 142514 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 142517 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 142521 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142526 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 142528 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 142531 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 142535 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142540 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 142543 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 142546 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 142549 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142554 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142559 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 142567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142569 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 142576 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142581 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142586 */     // GIR_Coverage, 12857,
     /* 142586 */     GIR_EraseRootFromParent_Done,
     /* 142587 */   // Label 2827: @142587
     /* 142587 */   GIM_Try, /*On fail goto*//*Label 2828*/ GIMT_Encode4(142706), // Rule ID 12858 //
     /* 142592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 142597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 142603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142611 */     // (intrinsic_wo_chain:{ *:[i32] } 662:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 142611 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 142614 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 142618 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142623 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 142627 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 142631 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 142633 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 142636 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 142640 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142645 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 142647 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 142650 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 142654 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142659 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 142662 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 142665 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 142668 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142673 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142678 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 142686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142688 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 142695 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142700 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142705 */     // GIR_Coverage, 12858,
     /* 142705 */     GIR_EraseRootFromParent_Done,
     /* 142706 */   // Label 2828: @142706
     /* 142706 */   GIM_Try, /*On fail goto*//*Label 2829*/ GIMT_Encode4(142821), // Rule ID 12859 //
     /* 142711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 142716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 142719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 142722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142730 */     // (intrinsic_wo_chain:{ *:[i64] } 662:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn), dsub:{ *:[i32] }), dsub:{ *:[i32] })
     /* 142730 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 142733 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /* 142737 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142742 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 142746 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 142748 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 142751 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 142755 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142760 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 142762 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 142765 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 142769 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142774 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 142777 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 142780 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 142783 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142788 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142793 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 142801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142803 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 142810 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142815 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142820 */     // GIR_Coverage, 12859,
     /* 142820 */     GIR_EraseRootFromParent_Done,
     /* 142821 */   // Label 2829: @142821
     /* 142821 */   GIM_Try, /*On fail goto*//*Label 2830*/ GIMT_Encode4(142940), // Rule ID 12860 //
     /* 142826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 142831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 142837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142845 */     // (intrinsic_wo_chain:{ *:[i32] } 727:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 142845 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 142848 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 142852 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142857 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 142861 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 142865 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 142867 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 142870 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 142874 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142879 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 142881 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 142884 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 142888 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142893 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 142896 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 142899 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 142902 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142907 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142912 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 142920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142922 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 142929 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142934 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142939 */     // GIR_Coverage, 12860,
     /* 142939 */     GIR_EraseRootFromParent_Done,
     /* 142940 */   // Label 2830: @142940
     /* 142940 */   GIM_Try, /*On fail goto*//*Label 2831*/ GIMT_Encode4(143055), // Rule ID 12861 //
     /* 142945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 142950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 142953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 142956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142964 */     // (intrinsic_wo_chain:{ *:[i64] } 727:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn), dsub:{ *:[i32] }), dsub:{ *:[i32] })
     /* 142964 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 142967 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /* 142971 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142976 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 142980 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 142982 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 142985 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 142989 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142994 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 142996 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 142999 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 143003 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143008 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 143011 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 143014 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 143017 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143022 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143027 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 143035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143037 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 143044 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143049 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143054 */     // GIR_Coverage, 12861,
     /* 143054 */     GIR_EraseRootFromParent_Done,
     /* 143055 */   // Label 2831: @143055
     /* 143055 */   GIM_Try, /*On fail goto*//*Label 2832*/ GIMT_Encode4(143088), // Rule ID 12863 //
     /* 143060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 143065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 143068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 143071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 143075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143079 */     // (intrinsic_wo_chain:{ *:[i8] } 672:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 143079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
     /* 143082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143086 */     GIR_RootConstrainSelectedInstOperands,
     /* 143087 */     // GIR_Coverage, 12863,
     /* 143087 */     GIR_EraseRootFromParent_Done,
     /* 143088 */   // Label 2832: @143088
     /* 143088 */   GIM_Try, /*On fail goto*//*Label 2833*/ GIMT_Encode4(143121), // Rule ID 12865 //
     /* 143093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 143098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 143101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 143104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 143108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143112 */     // (intrinsic_wo_chain:{ *:[i8] } 672:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 143112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
     /* 143115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143119 */     GIR_RootConstrainSelectedInstOperands,
     /* 143120 */     // GIR_Coverage, 12865,
     /* 143120 */     GIR_EraseRootFromParent_Done,
     /* 143121 */   // Label 2833: @143121
     /* 143121 */   GIM_Try, /*On fail goto*//*Label 2834*/ GIMT_Encode4(143154), // Rule ID 12867 //
     /* 143126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 143131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 143134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 143137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 143141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143145 */     // (intrinsic_wo_chain:{ *:[i16] } 672:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 143145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
     /* 143148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143152 */     GIR_RootConstrainSelectedInstOperands,
     /* 143153 */     // GIR_Coverage, 12867,
     /* 143153 */     GIR_EraseRootFromParent_Done,
     /* 143154 */   // Label 2834: @143154
     /* 143154 */   GIM_Try, /*On fail goto*//*Label 2835*/ GIMT_Encode4(143187), // Rule ID 12869 //
     /* 143159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 143164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 143167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 143170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 143174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143178 */     // (intrinsic_wo_chain:{ *:[i16] } 672:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 143178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
     /* 143181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143185 */     GIR_RootConstrainSelectedInstOperands,
     /* 143186 */     // GIR_Coverage, 12869,
     /* 143186 */     GIR_EraseRootFromParent_Done,
     /* 143187 */   // Label 2835: @143187
     /* 143187 */   GIM_Try, /*On fail goto*//*Label 2836*/ GIMT_Encode4(143302), // Rule ID 12870 //
     /* 143192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 143197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 143200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 143203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 143207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143211 */     // (intrinsic_wo_chain:{ *:[i32] } 672:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 143211 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 143214 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i32v),
     /* 143218 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143223 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 143227 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 143229 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 143232 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 143236 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143241 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 143243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 143246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 143250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143255 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 143258 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 143261 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 143264 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143269 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143274 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 143279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 143282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143284 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 143291 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 143296 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143301 */     // GIR_Coverage, 12870,
     /* 143301 */     GIR_EraseRootFromParent_Done,
     /* 143302 */   // Label 2836: @143302
     /* 143302 */   GIM_Try, /*On fail goto*//*Label 2837*/ GIMT_Encode4(143421), // Rule ID 12871 //
     /* 143307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 143312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 143315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 143318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 143322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143326 */     // (intrinsic_wo_chain:{ *:[i32] } 672:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 143326 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 143329 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
     /* 143333 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143338 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 143342 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 143346 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 143348 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 143351 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 143355 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143360 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 143362 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 143365 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 143369 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143374 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 143377 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 143380 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 143383 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143388 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143393 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 143401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143403 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 143410 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 143415 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143420 */     // GIR_Coverage, 12871,
     /* 143420 */     GIR_EraseRootFromParent_Done,
     /* 143421 */   // Label 2837: @143421
     /* 143421 */   GIM_Try, /*On fail goto*//*Label 2838*/ GIMT_Encode4(143454), // Rule ID 12873 //
     /* 143426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 143431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 143434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 143437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 143441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143445 */     // (intrinsic_wo_chain:{ *:[i8] } 675:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 143445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
     /* 143448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143450 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143452 */     GIR_RootConstrainSelectedInstOperands,
     /* 143453 */     // GIR_Coverage, 12873,
     /* 143453 */     GIR_EraseRootFromParent_Done,
     /* 143454 */   // Label 2838: @143454
     /* 143454 */   GIM_Try, /*On fail goto*//*Label 2839*/ GIMT_Encode4(143487), // Rule ID 12875 //
     /* 143459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 143464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 143467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 143470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 143474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143478 */     // (intrinsic_wo_chain:{ *:[i8] } 675:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 143478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
     /* 143481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143485 */     GIR_RootConstrainSelectedInstOperands,
     /* 143486 */     // GIR_Coverage, 12875,
     /* 143486 */     GIR_EraseRootFromParent_Done,
     /* 143487 */   // Label 2839: @143487
     /* 143487 */   GIM_Try, /*On fail goto*//*Label 2840*/ GIMT_Encode4(143520), // Rule ID 12877 //
     /* 143492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 143497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 143500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 143503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 143507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143511 */     // (intrinsic_wo_chain:{ *:[i16] } 675:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 143511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
     /* 143514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143518 */     GIR_RootConstrainSelectedInstOperands,
     /* 143519 */     // GIR_Coverage, 12877,
     /* 143519 */     GIR_EraseRootFromParent_Done,
     /* 143520 */   // Label 2840: @143520
     /* 143520 */   GIM_Try, /*On fail goto*//*Label 2841*/ GIMT_Encode4(143553), // Rule ID 12879 //
     /* 143525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 143530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 143533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 143536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 143540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143544 */     // (intrinsic_wo_chain:{ *:[i16] } 675:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 143544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
     /* 143547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143551 */     GIR_RootConstrainSelectedInstOperands,
     /* 143552 */     // GIR_Coverage, 12879,
     /* 143552 */     GIR_EraseRootFromParent_Done,
     /* 143553 */   // Label 2841: @143553
     /* 143553 */   GIM_Try, /*On fail goto*//*Label 2842*/ GIMT_Encode4(143668), // Rule ID 12880 //
     /* 143558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 143563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 143566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 143569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 143573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143577 */     // (intrinsic_wo_chain:{ *:[i32] } 675:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 143577 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 143580 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i32v),
     /* 143584 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143589 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 143593 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 143595 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 143598 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 143602 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143607 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 143609 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 143612 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 143616 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143621 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 143624 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 143627 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 143630 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143635 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143640 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 143645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 143648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143650 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 143657 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 143662 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143667 */     // GIR_Coverage, 12880,
     /* 143667 */     GIR_EraseRootFromParent_Done,
     /* 143668 */   // Label 2842: @143668
     /* 143668 */   GIM_Try, /*On fail goto*//*Label 2843*/ GIMT_Encode4(143787), // Rule ID 12881 //
     /* 143673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 143678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 143681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 143684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 143688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143692 */     // (intrinsic_wo_chain:{ *:[i32] } 675:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 143692 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 143695 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
     /* 143699 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143704 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 143708 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 143712 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 143714 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 143717 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 143721 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143726 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 143728 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 143731 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 143735 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143740 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 143743 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 143746 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 143749 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143754 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143759 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 143767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143769 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 143776 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 143781 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143786 */     // GIR_Coverage, 12881,
     /* 143786 */     GIR_EraseRootFromParent_Done,
     /* 143787 */   // Label 2843: @143787
     /* 143787 */   GIM_Try, /*On fail goto*//*Label 2844*/ GIMT_Encode4(143820), // Rule ID 12883 //
     /* 143792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 143797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 143800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 143803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 143807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143811 */     // (intrinsic_wo_chain:{ *:[i8] } 733:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 143811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
     /* 143814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143816 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143818 */     GIR_RootConstrainSelectedInstOperands,
     /* 143819 */     // GIR_Coverage, 12883,
     /* 143819 */     GIR_EraseRootFromParent_Done,
     /* 143820 */   // Label 2844: @143820
     /* 143820 */   GIM_Try, /*On fail goto*//*Label 2845*/ GIMT_Encode4(143853), // Rule ID 12885 //
     /* 143825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 143830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 143833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 143836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 143840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143844 */     // (intrinsic_wo_chain:{ *:[i8] } 733:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 143844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
     /* 143847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143851 */     GIR_RootConstrainSelectedInstOperands,
     /* 143852 */     // GIR_Coverage, 12885,
     /* 143852 */     GIR_EraseRootFromParent_Done,
     /* 143853 */   // Label 2845: @143853
     /* 143853 */   GIM_Try, /*On fail goto*//*Label 2846*/ GIMT_Encode4(143886), // Rule ID 12887 //
     /* 143858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 143863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 143866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 143869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 143873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143877 */     // (intrinsic_wo_chain:{ *:[i16] } 733:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 143877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
     /* 143880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143882 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143884 */     GIR_RootConstrainSelectedInstOperands,
     /* 143885 */     // GIR_Coverage, 12887,
     /* 143885 */     GIR_EraseRootFromParent_Done,
     /* 143886 */   // Label 2846: @143886
     /* 143886 */   GIM_Try, /*On fail goto*//*Label 2847*/ GIMT_Encode4(143919), // Rule ID 12889 //
     /* 143891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 143896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 143899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 143902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 143906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143910 */     // (intrinsic_wo_chain:{ *:[i16] } 733:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 143910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
     /* 143913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143915 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143917 */     GIR_RootConstrainSelectedInstOperands,
     /* 143918 */     // GIR_Coverage, 12889,
     /* 143918 */     GIR_EraseRootFromParent_Done,
     /* 143919 */   // Label 2847: @143919
     /* 143919 */   GIM_Try, /*On fail goto*//*Label 2848*/ GIMT_Encode4(144034), // Rule ID 12890 //
     /* 143924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 143929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 143932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 143935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 143939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143943 */     // (intrinsic_wo_chain:{ *:[i32] } 733:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 143943 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 143946 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i32v),
     /* 143950 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143955 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 143959 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 143961 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 143964 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 143968 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143973 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 143975 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 143978 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 143982 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143987 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 143990 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 143993 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 143996 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144001 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144006 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 144014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144016 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 144023 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144028 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144033 */     // GIR_Coverage, 12890,
     /* 144033 */     GIR_EraseRootFromParent_Done,
     /* 144034 */   // Label 2848: @144034
     /* 144034 */   GIM_Try, /*On fail goto*//*Label 2849*/ GIMT_Encode4(144153), // Rule ID 12891 //
     /* 144039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 144044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 144047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 144050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144058 */     // (intrinsic_wo_chain:{ *:[i32] } 733:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 144058 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 144061 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
     /* 144065 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144070 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 144074 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 144078 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 144080 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 144083 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 144087 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144092 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 144094 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 144097 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 144101 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144106 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 144109 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 144112 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 144115 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144120 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144125 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 144133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144135 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 144142 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144147 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144152 */     // GIR_Coverage, 12891,
     /* 144152 */     GIR_EraseRootFromParent_Done,
     /* 144153 */   // Label 2849: @144153
     /* 144153 */   GIM_Try, /*On fail goto*//*Label 2850*/ GIMT_Encode4(144186), // Rule ID 12893 //
     /* 144158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 144163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 144166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 144169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 144173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144177 */     // (intrinsic_wo_chain:{ *:[i8] } 736:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 144177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
     /* 144180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144182 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144184 */     GIR_RootConstrainSelectedInstOperands,
     /* 144185 */     // GIR_Coverage, 12893,
     /* 144185 */     GIR_EraseRootFromParent_Done,
     /* 144186 */   // Label 2850: @144186
     /* 144186 */   GIM_Try, /*On fail goto*//*Label 2851*/ GIMT_Encode4(144219), // Rule ID 12895 //
     /* 144191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 144196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 144199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 144202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 144206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144210 */     // (intrinsic_wo_chain:{ *:[i8] } 736:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 144210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
     /* 144213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144215 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144217 */     GIR_RootConstrainSelectedInstOperands,
     /* 144218 */     // GIR_Coverage, 12895,
     /* 144218 */     GIR_EraseRootFromParent_Done,
     /* 144219 */   // Label 2851: @144219
     /* 144219 */   GIM_Try, /*On fail goto*//*Label 2852*/ GIMT_Encode4(144252), // Rule ID 12897 //
     /* 144224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 144229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 144232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 144235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 144239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144243 */     // (intrinsic_wo_chain:{ *:[i16] } 736:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 144243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
     /* 144246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144250 */     GIR_RootConstrainSelectedInstOperands,
     /* 144251 */     // GIR_Coverage, 12897,
     /* 144251 */     GIR_EraseRootFromParent_Done,
     /* 144252 */   // Label 2852: @144252
     /* 144252 */   GIM_Try, /*On fail goto*//*Label 2853*/ GIMT_Encode4(144285), // Rule ID 12899 //
     /* 144257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 144262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 144265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 144268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 144272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144276 */     // (intrinsic_wo_chain:{ *:[i16] } 736:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 144276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
     /* 144279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144283 */     GIR_RootConstrainSelectedInstOperands,
     /* 144284 */     // GIR_Coverage, 12899,
     /* 144284 */     GIR_EraseRootFromParent_Done,
     /* 144285 */   // Label 2853: @144285
     /* 144285 */   GIM_Try, /*On fail goto*//*Label 2854*/ GIMT_Encode4(144400), // Rule ID 12900 //
     /* 144290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 144295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 144298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 144301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144309 */     // (intrinsic_wo_chain:{ *:[i32] } 736:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 144309 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 144312 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i32v),
     /* 144316 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144321 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 144325 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 144327 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 144330 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 144334 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144339 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 144341 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 144344 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 144348 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144353 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 144356 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 144359 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 144362 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144367 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144372 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 144380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144382 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 144389 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144394 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144399 */     // GIR_Coverage, 12900,
     /* 144399 */     GIR_EraseRootFromParent_Done,
     /* 144400 */   // Label 2854: @144400
     /* 144400 */   GIM_Try, /*On fail goto*//*Label 2855*/ GIMT_Encode4(144519), // Rule ID 12901 //
     /* 144405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 144410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 144413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 144416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144424 */     // (intrinsic_wo_chain:{ *:[i32] } 736:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 144424 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 144427 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
     /* 144431 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144436 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 144440 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 144444 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 144446 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 144449 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 144453 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144458 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 144460 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 144463 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 144467 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144472 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 144475 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 144478 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 144481 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144486 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144491 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 144499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144501 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 144508 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144513 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144518 */     // GIR_Coverage, 12901,
     /* 144518 */     GIR_EraseRootFromParent_Done,
     /* 144519 */   // Label 2855: @144519
     /* 144519 */   GIM_Try, /*On fail goto*//*Label 2856*/ GIMT_Encode4(144551), // Rule ID 2384 //
     /* 144524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 144527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b16),
     /* 144532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 144535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 144538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 144542 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1575:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
     /* 144542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_H),
     /* 144545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 144547 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 144549 */     GIR_RootConstrainSelectedInstOperands,
     /* 144550 */     // GIR_Coverage, 2384,
     /* 144550 */     GIR_EraseRootFromParent_Done,
     /* 144551 */   // Label 2856: @144551
     /* 144551 */   GIM_Try, /*On fail goto*//*Label 2857*/ GIMT_Encode4(144583), // Rule ID 2385 //
     /* 144556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 144559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b32),
     /* 144564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 144567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 144570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 144574 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1576:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
     /* 144574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_S),
     /* 144577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 144579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 144581 */     GIR_RootConstrainSelectedInstOperands,
     /* 144582 */     // GIR_Coverage, 2385,
     /* 144582 */     GIR_EraseRootFromParent_Done,
     /* 144583 */   // Label 2857: @144583
     /* 144583 */   GIM_Try, /*On fail goto*//*Label 2858*/ GIMT_Encode4(144615), // Rule ID 2386 //
     /* 144588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 144591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b64),
     /* 144596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 144599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 144602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 144606 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1577:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
     /* 144606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_D),
     /* 144609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 144611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 144613 */     GIR_RootConstrainSelectedInstOperands,
     /* 144614 */     // GIR_Coverage, 2386,
     /* 144614 */     GIR_EraseRootFromParent_Done,
     /* 144615 */   // Label 2858: @144615
     /* 144615 */   GIM_Try, /*On fail goto*//*Label 2859*/ GIMT_Encode4(144647), // Rule ID 3079 //
     /* 144620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 144623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
     /* 144628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 144631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 144634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 144638 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1757:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (SQXTNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
     /* 144638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_B),
     /* 144641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 144643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 144645 */     GIR_RootConstrainSelectedInstOperands,
     /* 144646 */     // GIR_Coverage, 3079,
     /* 144646 */     GIR_EraseRootFromParent_Done,
     /* 144647 */   // Label 2859: @144647
     /* 144647 */   GIM_Try, /*On fail goto*//*Label 2860*/ GIMT_Encode4(144679), // Rule ID 3080 //
     /* 144652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 144655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
     /* 144660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 144663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 144666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 144670 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1757:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (SQXTNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
     /* 144670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_H),
     /* 144673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 144675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 144677 */     GIR_RootConstrainSelectedInstOperands,
     /* 144678 */     // GIR_Coverage, 3080,
     /* 144678 */     GIR_EraseRootFromParent_Done,
     /* 144679 */   // Label 2860: @144679
     /* 144679 */   GIM_Try, /*On fail goto*//*Label 2861*/ GIMT_Encode4(144711), // Rule ID 3081 //
     /* 144684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 144687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
     /* 144692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 144695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 144698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 144702 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1757:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (SQXTNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
     /* 144702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_S),
     /* 144705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 144707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 144709 */     GIR_RootConstrainSelectedInstOperands,
     /* 144710 */     // GIR_Coverage, 3081,
     /* 144710 */     GIR_EraseRootFromParent_Done,
     /* 144711 */   // Label 2861: @144711
     /* 144711 */   GIM_Try, /*On fail goto*//*Label 2862*/ GIMT_Encode4(144743), // Rule ID 3329 //
     /* 144716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 144719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
     /* 144724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 144727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 144730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 144734 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1567:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv8i1] } ?:{ *:[nxv16i1] }:$Op1)
     /* 144734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 144737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 144739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 144741 */     GIR_RootConstrainSelectedInstOperands,
     /* 144742 */     // GIR_Coverage, 3329,
     /* 144742 */     GIR_EraseRootFromParent_Done,
     /* 144743 */   // Label 2862: @144743
     /* 144743 */   GIM_Try, /*On fail goto*//*Label 2863*/ GIMT_Encode4(144775), // Rule ID 3330 //
     /* 144748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 144751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
     /* 144756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 144759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 144762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 144766 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1567:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv4i1] } ?:{ *:[nxv8i1] }:$Op1)
     /* 144766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 144769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 144771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 144773 */     GIR_RootConstrainSelectedInstOperands,
     /* 144774 */     // GIR_Coverage, 3330,
     /* 144774 */     GIR_EraseRootFromParent_Done,
     /* 144775 */   // Label 2863: @144775
     /* 144775 */   GIM_Try, /*On fail goto*//*Label 2864*/ GIMT_Encode4(144807), // Rule ID 3331 //
     /* 144780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 144783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
     /* 144788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 144791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 144794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 144798 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1567:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv2i1] } ?:{ *:[nxv4i1] }:$Op1)
     /* 144798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 144801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 144803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 144805 */     GIR_RootConstrainSelectedInstOperands,
     /* 144806 */     // GIR_Coverage, 3331,
     /* 144806 */     GIR_EraseRootFromParent_Done,
     /* 144807 */   // Label 2864: @144807
     /* 144807 */   GIM_Try, /*On fail goto*//*Label 2865*/ GIMT_Encode4(144839), // Rule ID 3410 //
     /* 144812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 144815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
     /* 144820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 144823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 144826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 144830 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1328:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (FEXPA_ZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i16] }:$Op1)
     /* 144830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_H),
     /* 144833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 144835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 144837 */     GIR_RootConstrainSelectedInstOperands,
     /* 144838 */     // GIR_Coverage, 3410,
     /* 144838 */     GIR_EraseRootFromParent_Done,
     /* 144839 */   // Label 2865: @144839
     /* 144839 */   GIM_Try, /*On fail goto*//*Label 2866*/ GIMT_Encode4(144871), // Rule ID 3411 //
     /* 144844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 144847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
     /* 144852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 144855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 144858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 144862 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1328:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (FEXPA_ZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i32] }:$Op1)
     /* 144862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_S),
     /* 144865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 144867 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 144869 */     GIR_RootConstrainSelectedInstOperands,
     /* 144870 */     // GIR_Coverage, 3411,
     /* 144870 */     GIR_EraseRootFromParent_Done,
     /* 144871 */   // Label 2866: @144871
     /* 144871 */   GIM_Try, /*On fail goto*//*Label 2867*/ GIMT_Encode4(144903), // Rule ID 3412 //
     /* 144876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 144879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
     /* 144884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 144887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 144890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 144894 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1328:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (FEXPA_ZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i64] }:$Op1)
     /* 144894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_D),
     /* 144897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 144899 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 144901 */     GIR_RootConstrainSelectedInstOperands,
     /* 144902 */     // GIR_Coverage, 3412,
     /* 144902 */     GIR_EraseRootFromParent_Done,
     /* 144903 */   // Label 2867: @144903
     /* 144903 */   GIM_Try, /*On fail goto*//*Label 2868*/ GIMT_Encode4(144935), // Rule ID 3438 //
     /* 144908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 144911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesmc),
     /* 144916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 144919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 144922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 144926 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1167:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (AESMC_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1)
     /* 144926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMC_ZZ_B),
     /* 144929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 144931 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 144933 */     GIR_RootConstrainSelectedInstOperands,
     /* 144934 */     // GIR_Coverage, 3438,
     /* 144934 */     GIR_EraseRootFromParent_Done,
     /* 144935 */   // Label 2868: @144935
     /* 144935 */   GIM_Try, /*On fail goto*//*Label 2869*/ GIMT_Encode4(144967), // Rule ID 4565 //
     /* 144940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 144943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 144948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 144951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 144954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144958 */     // (intrinsic_wo_chain:{ *:[i32] } 592:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } ?:{ *:[f16] }:$Rn)
     /* 144958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 144961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144963 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144965 */     GIR_RootConstrainSelectedInstOperands,
     /* 144966 */     // GIR_Coverage, 4565,
     /* 144966 */     GIR_EraseRootFromParent_Done,
     /* 144967 */   // Label 2869: @144967
     /* 144967 */   GIM_Try, /*On fail goto*//*Label 2870*/ GIMT_Encode4(144999), // Rule ID 4566 //
     /* 144972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 144975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 144980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 144983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 144986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144990 */     // (intrinsic_wo_chain:{ *:[i64] } 592:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } ?:{ *:[f16] }:$Rn)
     /* 144990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 144993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144997 */     GIR_RootConstrainSelectedInstOperands,
     /* 144998 */     // GIR_Coverage, 4566,
     /* 144998 */     GIR_EraseRootFromParent_Done,
     /* 144999 */   // Label 2870: @144999
     /* 144999 */   GIM_Try, /*On fail goto*//*Label 2871*/ GIMT_Encode4(145028), // Rule ID 4567 //
     /* 145004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 145009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 145012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 145015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145019 */     // (intrinsic_wo_chain:{ *:[i32] } 592:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } ?:{ *:[f32] }:$Rn)
     /* 145019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 145022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145024 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145026 */     GIR_RootConstrainSelectedInstOperands,
     /* 145027 */     // GIR_Coverage, 4567,
     /* 145027 */     GIR_EraseRootFromParent_Done,
     /* 145028 */   // Label 2871: @145028
     /* 145028 */   GIM_Try, /*On fail goto*//*Label 2872*/ GIMT_Encode4(145057), // Rule ID 4568 //
     /* 145033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 145038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 145041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 145044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145048 */     // (intrinsic_wo_chain:{ *:[i64] } 592:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } ?:{ *:[f32] }:$Rn)
     /* 145048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 145051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145055 */     GIR_RootConstrainSelectedInstOperands,
     /* 145056 */     // GIR_Coverage, 4568,
     /* 145056 */     GIR_EraseRootFromParent_Done,
     /* 145057 */   // Label 2872: @145057
     /* 145057 */   GIM_Try, /*On fail goto*//*Label 2873*/ GIMT_Encode4(145086), // Rule ID 4569 //
     /* 145062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 145067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 145070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 145073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145077 */     // (intrinsic_wo_chain:{ *:[i32] } 592:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } ?:{ *:[f64] }:$Rn)
     /* 145077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 145080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145084 */     GIR_RootConstrainSelectedInstOperands,
     /* 145085 */     // GIR_Coverage, 4569,
     /* 145085 */     GIR_EraseRootFromParent_Done,
     /* 145086 */   // Label 2873: @145086
     /* 145086 */   GIM_Try, /*On fail goto*//*Label 2874*/ GIMT_Encode4(145115), // Rule ID 4570 //
     /* 145091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 145096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 145099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 145102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145106 */     // (intrinsic_wo_chain:{ *:[i64] } 592:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } ?:{ *:[f64] }:$Rn)
     /* 145106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 145109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145111 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145113 */     GIR_RootConstrainSelectedInstOperands,
     /* 145114 */     // GIR_Coverage, 4570,
     /* 145114 */     GIR_EraseRootFromParent_Done,
     /* 145115 */   // Label 2874: @145115
     /* 145115 */   GIM_Try, /*On fail goto*//*Label 2875*/ GIMT_Encode4(145147), // Rule ID 4577 //
     /* 145120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 145123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 145128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 145131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 145134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145138 */     // (intrinsic_wo_chain:{ *:[i32] } 593:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } ?:{ *:[f16] }:$Rn)
     /* 145138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
     /* 145141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145145 */     GIR_RootConstrainSelectedInstOperands,
     /* 145146 */     // GIR_Coverage, 4577,
     /* 145146 */     GIR_EraseRootFromParent_Done,
     /* 145147 */   // Label 2875: @145147
     /* 145147 */   GIM_Try, /*On fail goto*//*Label 2876*/ GIMT_Encode4(145179), // Rule ID 4578 //
     /* 145152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 145155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 145160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 145163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 145166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145170 */     // (intrinsic_wo_chain:{ *:[i64] } 593:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } ?:{ *:[f16] }:$Rn)
     /* 145170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
     /* 145173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145175 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145177 */     GIR_RootConstrainSelectedInstOperands,
     /* 145178 */     // GIR_Coverage, 4578,
     /* 145178 */     GIR_EraseRootFromParent_Done,
     /* 145179 */   // Label 2876: @145179
     /* 145179 */   GIM_Try, /*On fail goto*//*Label 2877*/ GIMT_Encode4(145208), // Rule ID 4579 //
     /* 145184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 145189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 145192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 145195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145199 */     // (intrinsic_wo_chain:{ *:[i32] } 593:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } ?:{ *:[f32] }:$Rn)
     /* 145199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 145202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145206 */     GIR_RootConstrainSelectedInstOperands,
     /* 145207 */     // GIR_Coverage, 4579,
     /* 145207 */     GIR_EraseRootFromParent_Done,
     /* 145208 */   // Label 2877: @145208
     /* 145208 */   GIM_Try, /*On fail goto*//*Label 2878*/ GIMT_Encode4(145237), // Rule ID 4580 //
     /* 145213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 145218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 145221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 145224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145228 */     // (intrinsic_wo_chain:{ *:[i64] } 593:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } ?:{ *:[f32] }:$Rn)
     /* 145228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 145231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145235 */     GIR_RootConstrainSelectedInstOperands,
     /* 145236 */     // GIR_Coverage, 4580,
     /* 145236 */     GIR_EraseRootFromParent_Done,
     /* 145237 */   // Label 2878: @145237
     /* 145237 */   GIM_Try, /*On fail goto*//*Label 2879*/ GIMT_Encode4(145266), // Rule ID 4581 //
     /* 145242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 145247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 145250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 145253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145257 */     // (intrinsic_wo_chain:{ *:[i32] } 593:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } ?:{ *:[f64] }:$Rn)
     /* 145257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 145260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145264 */     GIR_RootConstrainSelectedInstOperands,
     /* 145265 */     // GIR_Coverage, 4581,
     /* 145265 */     GIR_EraseRootFromParent_Done,
     /* 145266 */   // Label 2879: @145266
     /* 145266 */   GIM_Try, /*On fail goto*//*Label 2880*/ GIMT_Encode4(145295), // Rule ID 4582 //
     /* 145271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 145276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 145279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 145282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145286 */     // (intrinsic_wo_chain:{ *:[i64] } 593:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } ?:{ *:[f64] }:$Rn)
     /* 145286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 145289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145293 */     GIR_RootConstrainSelectedInstOperands,
     /* 145294 */     // GIR_Coverage, 4582,
     /* 145294 */     GIR_EraseRootFromParent_Done,
     /* 145295 */   // Label 2880: @145295
     /* 145295 */   GIM_Try, /*On fail goto*//*Label 2881*/ GIMT_Encode4(145324), // Rule ID 4877 //
     /* 145300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 145305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 145308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 145311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145315 */     // (intrinsic_wo_chain:{ *:[v4i16] } 592:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } ?:{ *:[v4f16] }:$Rn)
     /* 145315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
     /* 145318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145322 */     GIR_RootConstrainSelectedInstOperands,
     /* 145323 */     // GIR_Coverage, 4877,
     /* 145323 */     GIR_EraseRootFromParent_Done,
     /* 145324 */   // Label 2881: @145324
     /* 145324 */   GIM_Try, /*On fail goto*//*Label 2882*/ GIMT_Encode4(145353), // Rule ID 4878 //
     /* 145329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 145334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 145337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 145340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145344 */     // (intrinsic_wo_chain:{ *:[v8i16] } 592:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } ?:{ *:[v8f16] }:$Rn)
     /* 145344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
     /* 145347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145351 */     GIR_RootConstrainSelectedInstOperands,
     /* 145352 */     // GIR_Coverage, 4878,
     /* 145352 */     GIR_EraseRootFromParent_Done,
     /* 145353 */   // Label 2882: @145353
     /* 145353 */   GIM_Try, /*On fail goto*//*Label 2883*/ GIMT_Encode4(145382), // Rule ID 4879 //
     /* 145358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 145363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 145366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 145369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145373 */     // (intrinsic_wo_chain:{ *:[v2i32] } 592:{ *:[iPTR] }, v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } ?:{ *:[v2f32] }:$Rn)
     /* 145373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
     /* 145376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145380 */     GIR_RootConstrainSelectedInstOperands,
     /* 145381 */     // GIR_Coverage, 4879,
     /* 145381 */     GIR_EraseRootFromParent_Done,
     /* 145382 */   // Label 2883: @145382
     /* 145382 */   GIM_Try, /*On fail goto*//*Label 2884*/ GIMT_Encode4(145411), // Rule ID 4880 //
     /* 145387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 145392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 145395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 145398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145402 */     // (intrinsic_wo_chain:{ *:[v4i32] } 592:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } ?:{ *:[v4f32] }:$Rn)
     /* 145402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
     /* 145405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145409 */     GIR_RootConstrainSelectedInstOperands,
     /* 145410 */     // GIR_Coverage, 4880,
     /* 145410 */     GIR_EraseRootFromParent_Done,
     /* 145411 */   // Label 2884: @145411
     /* 145411 */   GIM_Try, /*On fail goto*//*Label 2885*/ GIMT_Encode4(145440), // Rule ID 4881 //
     /* 145416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 145421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 145424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 145427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145431 */     // (intrinsic_wo_chain:{ *:[v2i64] } 592:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } ?:{ *:[v2f64] }:$Rn)
     /* 145431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 145434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145438 */     GIR_RootConstrainSelectedInstOperands,
     /* 145439 */     // GIR_Coverage, 4881,
     /* 145439 */     GIR_EraseRootFromParent_Done,
     /* 145440 */   // Label 2885: @145440
     /* 145440 */   GIM_Try, /*On fail goto*//*Label 2886*/ GIMT_Encode4(145469), // Rule ID 4882 //
     /* 145445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 145450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 145453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 145456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145460 */     // (intrinsic_wo_chain:{ *:[v4i16] } 593:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } ?:{ *:[v4f16] }:$Rn)
     /* 145460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
     /* 145463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145467 */     GIR_RootConstrainSelectedInstOperands,
     /* 145468 */     // GIR_Coverage, 4882,
     /* 145468 */     GIR_EraseRootFromParent_Done,
     /* 145469 */   // Label 2886: @145469
     /* 145469 */   GIM_Try, /*On fail goto*//*Label 2887*/ GIMT_Encode4(145498), // Rule ID 4883 //
     /* 145474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 145479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 145482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 145485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145489 */     // (intrinsic_wo_chain:{ *:[v8i16] } 593:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } ?:{ *:[v8f16] }:$Rn)
     /* 145489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
     /* 145492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145494 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145496 */     GIR_RootConstrainSelectedInstOperands,
     /* 145497 */     // GIR_Coverage, 4883,
     /* 145497 */     GIR_EraseRootFromParent_Done,
     /* 145498 */   // Label 2887: @145498
     /* 145498 */   GIM_Try, /*On fail goto*//*Label 2888*/ GIMT_Encode4(145527), // Rule ID 4884 //
     /* 145503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 145508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 145511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 145514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145518 */     // (intrinsic_wo_chain:{ *:[v2i32] } 593:{ *:[iPTR] }, v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } ?:{ *:[v2f32] }:$Rn)
     /* 145518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
     /* 145521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145523 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145525 */     GIR_RootConstrainSelectedInstOperands,
     /* 145526 */     // GIR_Coverage, 4884,
     /* 145526 */     GIR_EraseRootFromParent_Done,
     /* 145527 */   // Label 2888: @145527
     /* 145527 */   GIM_Try, /*On fail goto*//*Label 2889*/ GIMT_Encode4(145556), // Rule ID 4885 //
     /* 145532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 145537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 145540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 145543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145547 */     // (intrinsic_wo_chain:{ *:[v4i32] } 593:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } ?:{ *:[v4f32] }:$Rn)
     /* 145547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
     /* 145550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145552 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145554 */     GIR_RootConstrainSelectedInstOperands,
     /* 145555 */     // GIR_Coverage, 4885,
     /* 145555 */     GIR_EraseRootFromParent_Done,
     /* 145556 */   // Label 2889: @145556
     /* 145556 */   GIM_Try, /*On fail goto*//*Label 2890*/ GIMT_Encode4(145585), // Rule ID 4886 //
     /* 145561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 145566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 145569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 145572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145576 */     // (intrinsic_wo_chain:{ *:[v2i64] } 593:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } ?:{ *:[v2f64] }:$Rn)
     /* 145576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 145579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145583 */     GIR_RootConstrainSelectedInstOperands,
     /* 145584 */     // GIR_Coverage, 4886,
     /* 145584 */     GIR_EraseRootFromParent_Done,
     /* 145585 */   // Label 2890: @145585
     /* 145585 */   GIM_Try, /*On fail goto*//*Label 2891*/ GIMT_Encode4(145617), // Rule ID 8249 //
     /* 145590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 145593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
     /* 145598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 145601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 145604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 145608 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1566:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv8i1] } ?:{ *:[nxv16i1] }:$Op1)
     /* 145608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 145611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 145613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 145615 */     GIR_RootConstrainSelectedInstOperands,
     /* 145616 */     // GIR_Coverage, 8249,
     /* 145616 */     GIR_EraseRootFromParent_Done,
     /* 145617 */   // Label 2891: @145617
     /* 145617 */   GIM_Try, /*On fail goto*//*Label 2892*/ GIMT_Encode4(145649), // Rule ID 8250 //
     /* 145622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 145625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
     /* 145630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 145633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 145636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 145640 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1566:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv4i1] } ?:{ *:[nxv8i1] }:$Op1)
     /* 145640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 145643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 145645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 145647 */     GIR_RootConstrainSelectedInstOperands,
     /* 145648 */     // GIR_Coverage, 8250,
     /* 145648 */     GIR_EraseRootFromParent_Done,
     /* 145649 */   // Label 2892: @145649
     /* 145649 */   GIM_Try, /*On fail goto*//*Label 2893*/ GIMT_Encode4(145681), // Rule ID 8251 //
     /* 145654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 145657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
     /* 145662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 145665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 145668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 145672 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1566:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv2i1] } ?:{ *:[nxv4i1] }:$Op1)
     /* 145672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 145675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 145677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 145679 */     GIR_RootConstrainSelectedInstOperands,
     /* 145680 */     // GIR_Coverage, 8251,
     /* 145680 */     GIR_EraseRootFromParent_Done,
     /* 145681 */   // Label 2893: @145681
     /* 145681 */   GIM_Try, /*On fail goto*//*Label 2894*/ GIMT_Encode4(145713), // Rule ID 11612 //
     /* 145686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 145689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
     /* 145694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 145697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 145700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 145704 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1950:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (UQXTNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
     /* 145704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_B),
     /* 145707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 145709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 145711 */     GIR_RootConstrainSelectedInstOperands,
     /* 145712 */     // GIR_Coverage, 11612,
     /* 145712 */     GIR_EraseRootFromParent_Done,
     /* 145713 */   // Label 2894: @145713
     /* 145713 */   GIM_Try, /*On fail goto*//*Label 2895*/ GIMT_Encode4(145745), // Rule ID 11613 //
     /* 145718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 145721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
     /* 145726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 145729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 145732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 145736 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1950:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (UQXTNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
     /* 145736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_H),
     /* 145739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 145741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 145743 */     GIR_RootConstrainSelectedInstOperands,
     /* 145744 */     // GIR_Coverage, 11613,
     /* 145744 */     GIR_EraseRootFromParent_Done,
     /* 145745 */   // Label 2895: @145745
     /* 145745 */   GIM_Try, /*On fail goto*//*Label 2896*/ GIMT_Encode4(145777), // Rule ID 11614 //
     /* 145750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 145753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
     /* 145758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 145761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 145764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 145768 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1950:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (UQXTNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
     /* 145768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_S),
     /* 145771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 145773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 145775 */     GIR_RootConstrainSelectedInstOperands,
     /* 145776 */     // GIR_Coverage, 11614,
     /* 145776 */     GIR_EraseRootFromParent_Done,
     /* 145777 */   // Label 2896: @145777
     /* 145777 */   GIM_Try, /*On fail goto*//*Label 2897*/ GIMT_Encode4(145809), // Rule ID 11615 //
     /* 145782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 145785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
     /* 145790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 145793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 145796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 145800 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1759:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (SQXTUNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
     /* 145800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_B),
     /* 145803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 145805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 145807 */     GIR_RootConstrainSelectedInstOperands,
     /* 145808 */     // GIR_Coverage, 11615,
     /* 145808 */     GIR_EraseRootFromParent_Done,
     /* 145809 */   // Label 2897: @145809
     /* 145809 */   GIM_Try, /*On fail goto*//*Label 2898*/ GIMT_Encode4(145841), // Rule ID 11616 //
     /* 145814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 145817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
     /* 145822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 145825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 145828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 145832 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1759:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (SQXTUNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
     /* 145832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_H),
     /* 145835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 145837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 145839 */     GIR_RootConstrainSelectedInstOperands,
     /* 145840 */     // GIR_Coverage, 11616,
     /* 145840 */     GIR_EraseRootFromParent_Done,
     /* 145841 */   // Label 2898: @145841
     /* 145841 */   GIM_Try, /*On fail goto*//*Label 2899*/ GIMT_Encode4(145873), // Rule ID 11617 //
     /* 145846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 145849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
     /* 145854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 145857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 145860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 145864 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1759:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (SQXTUNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
     /* 145864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_S),
     /* 145867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 145869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 145871 */     GIR_RootConstrainSelectedInstOperands,
     /* 145872 */     // GIR_Coverage, 11617,
     /* 145872 */     GIR_EraseRootFromParent_Done,
     /* 145873 */   // Label 2899: @145873
     /* 145873 */   GIM_Try, /*On fail goto*//*Label 2900*/ GIMT_Encode4(145905), // Rule ID 11772 //
     /* 145878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 145881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesimc),
     /* 145886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 145889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 145892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 145896 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1166:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (AESIMC_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1)
     /* 145896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMC_ZZ_B),
     /* 145899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 145901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 145903 */     GIR_RootConstrainSelectedInstOperands,
     /* 145904 */     // GIR_Coverage, 11772,
     /* 145904 */     GIR_EraseRootFromParent_Done,
     /* 145905 */   // Label 2900: @145905
     /* 145905 */   GIM_Reject,
     /* 145906 */ // Label 2581: @145906
     /* 145906 */ GIM_Try, /*On fail goto*//*Label 2901*/ GIMT_Encode4(192217),
     /* 145911 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 145914 */   GIM_Try, /*On fail goto*//*Label 2902*/ GIMT_Encode4(146098), // Rule ID 2559 //
     /* 145919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 145927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 145930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 145933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 145936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 145940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 145944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 145948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 145952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 145956 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 145960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 145964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 145968 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 145971 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 145976 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 145980 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 145984 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145989 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 145993 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 145997 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 146001 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 146005 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 146009 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 146013 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 146017 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 146022 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /* 146026 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 146030 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 146034 */     // MIs[5] Operand 1
     /* 146034 */     // No operand predicates
     /* 146034 */     // MIs[3] Operand 2
     /* 146034 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /* 146045 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 146049 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /* 146051 */     // (intrinsic_wo_chain:{ *:[i32] } 679:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 146051 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 146054 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 146058 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146063 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 146069 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 146074 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
     /* 146082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 146086 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /* 146093 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/5, // idx
     /* 146096 */     GIR_RootConstrainSelectedInstOperands,
     /* 146097 */     // GIR_Coverage, 2559,
     /* 146097 */     GIR_EraseRootFromParent_Done,
     /* 146098 */   // Label 2902: @146098
     /* 146098 */   GIM_Try, /*On fail goto*//*Label 2903*/ GIMT_Encode4(146282), // Rule ID 6167 //
     /* 146103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 146111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 146114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 146117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 146120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 146132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 146136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 146140 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 146144 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 146148 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 146152 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 146155 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 146160 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 146164 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 146168 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146173 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 146177 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 146181 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 146185 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 146189 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 146193 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 146197 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 146201 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 146206 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /* 146210 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 146214 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 146218 */     // MIs[5] Operand 1
     /* 146218 */     // No operand predicates
     /* 146218 */     // MIs[3] Operand 2
     /* 146218 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /* 146229 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 146233 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /* 146235 */     // (intrinsic_wo_chain:{ *:[i32] } 698:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 146235 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 146238 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 146242 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146247 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 146253 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 146258 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
     /* 146266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 146270 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /* 146277 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/5, // idx
     /* 146280 */     GIR_RootConstrainSelectedInstOperands,
     /* 146281 */     // GIR_Coverage, 6167,
     /* 146281 */     GIR_EraseRootFromParent_Done,
     /* 146282 */   // Label 2903: @146282
     /* 146282 */   GIM_Try, /*On fail goto*//*Label 2904*/ GIMT_Encode4(146422), // Rule ID 2050 //
     /* 146287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 146295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 146298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 146301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 146304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 146316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 146320 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 146323 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 146328 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 146332 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 146336 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 146340 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 146344 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 146348 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 146352 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 146356 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 146360 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 146364 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 146369 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 146373 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 146377 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 146381 */     // MIs[4] Operand 1
     /* 146381 */     // No operand predicates
     /* 146381 */     // MIs[2] Operand 2
     /* 146381 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 146392 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 146394 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 146401 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SQDMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 146401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv8i16_indexed),
     /* 146404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146406 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 146408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 146413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 146417 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 146420 */     GIR_RootConstrainSelectedInstOperands,
     /* 146421 */     // GIR_Coverage, 2050,
     /* 146421 */     GIR_EraseRootFromParent_Done,
     /* 146422 */   // Label 2904: @146422
     /* 146422 */   GIM_Try, /*On fail goto*//*Label 2905*/ GIMT_Encode4(146562), // Rule ID 2057 //
     /* 146427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 146435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 146438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 146441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 146444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 146456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 146460 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 146463 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 146468 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 146472 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 146476 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 146480 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 146484 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 146488 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 146492 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 146496 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 146500 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 146504 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 146509 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 146513 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 146517 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 146521 */     // MIs[4] Operand 1
     /* 146521 */     // No operand predicates
     /* 146521 */     // MIs[2] Operand 2
     /* 146521 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 146532 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 146534 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 146541 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SQDMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 146541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv8i16_indexed),
     /* 146544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 146548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 146553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 146557 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 146560 */     GIR_RootConstrainSelectedInstOperands,
     /* 146561 */     // GIR_Coverage, 2057,
     /* 146561 */     GIR_EraseRootFromParent_Done,
     /* 146562 */   // Label 2905: @146562
     /* 146562 */   GIM_Try, /*On fail goto*//*Label 2906*/ GIMT_Encode4(146702), // Rule ID 2053 //
     /* 146567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 146575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 146578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 146581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 146584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 146596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 146600 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 146603 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 146608 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 146612 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 146616 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 146620 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 146624 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 146628 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 146632 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 146636 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 146640 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 146644 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146649 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 146653 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 146657 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 146661 */     // MIs[4] Operand 1
     /* 146661 */     // No operand predicates
     /* 146661 */     // MIs[2] Operand 2
     /* 146661 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 146672 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 146674 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 146681 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SQDMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 146681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i32_indexed),
     /* 146684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 146688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 146693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 146697 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 146700 */     GIR_RootConstrainSelectedInstOperands,
     /* 146701 */     // GIR_Coverage, 2053,
     /* 146701 */     GIR_EraseRootFromParent_Done,
     /* 146702 */   // Label 2906: @146702
     /* 146702 */   GIM_Try, /*On fail goto*//*Label 2907*/ GIMT_Encode4(146842), // Rule ID 2060 //
     /* 146707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 146715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 146718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 146721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 146724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 146736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 146740 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 146743 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 146748 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 146752 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 146756 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 146760 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 146764 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 146768 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 146772 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 146776 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 146780 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 146784 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146789 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 146793 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 146797 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 146801 */     // MIs[4] Operand 1
     /* 146801 */     // No operand predicates
     /* 146801 */     // MIs[2] Operand 2
     /* 146801 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 146812 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 146814 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 146821 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SQDMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 146821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i32_indexed),
     /* 146824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 146828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 146833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 146837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 146840 */     GIR_RootConstrainSelectedInstOperands,
     /* 146841 */     // GIR_Coverage, 2060,
     /* 146841 */     GIR_EraseRootFromParent_Done,
     /* 146842 */   // Label 2907: @146842
     /* 146842 */   GIM_Try, /*On fail goto*//*Label 2908*/ GIMT_Encode4(146979), // Rule ID 2048 //
     /* 146847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 146855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 146858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 146861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 146864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 146876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 146880 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 146883 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 146888 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 146892 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 146896 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146901 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 146905 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 146909 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 146913 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 146917 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 146921 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 146925 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 146929 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 146934 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 146938 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 146942 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 146946 */     // MIs[4] Operand 1
     /* 146946 */     // No operand predicates
     /* 146946 */     // MIs[2] Operand 2
     /* 146946 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 146957 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 146959 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 146959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_indexed),
     /* 146962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146964 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 146966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 146970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 146974 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 146977 */     GIR_RootConstrainSelectedInstOperands,
     /* 146978 */     // GIR_Coverage, 2048,
     /* 146978 */     GIR_EraseRootFromParent_Done,
     /* 146979 */   // Label 2908: @146979
     /* 146979 */   GIM_Try, /*On fail goto*//*Label 2909*/ GIMT_Encode4(147116), // Rule ID 2055 //
     /* 146984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 146992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 146995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 146998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 147001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 147013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 147017 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 147020 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 147025 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 147029 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 147033 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147038 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 147042 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 147046 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 147050 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 147054 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 147058 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 147062 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 147066 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 147071 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 147075 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 147079 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 147083 */     // MIs[4] Operand 1
     /* 147083 */     // No operand predicates
     /* 147083 */     // MIs[2] Operand 2
     /* 147083 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 147094 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 147096 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 147096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_indexed),
     /* 147099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 147103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 147107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 147111 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 147114 */     GIR_RootConstrainSelectedInstOperands,
     /* 147115 */     // GIR_Coverage, 2055,
     /* 147115 */     GIR_EraseRootFromParent_Done,
     /* 147116 */   // Label 2909: @147116
     /* 147116 */   GIM_Try, /*On fail goto*//*Label 2910*/ GIMT_Encode4(147253), // Rule ID 2051 //
     /* 147121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 147129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 147132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 147135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 147138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 147150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 147154 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 147157 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 147162 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 147166 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 147170 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147175 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 147179 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 147183 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 147187 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 147191 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 147195 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 147199 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 147203 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147208 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 147212 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 147216 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 147220 */     // MIs[4] Operand 1
     /* 147220 */     // No operand predicates
     /* 147220 */     // MIs[2] Operand 2
     /* 147220 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 147231 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 147233 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 147233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_indexed),
     /* 147236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 147240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 147244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 147248 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 147251 */     GIR_RootConstrainSelectedInstOperands,
     /* 147252 */     // GIR_Coverage, 2051,
     /* 147252 */     GIR_EraseRootFromParent_Done,
     /* 147253 */   // Label 2910: @147253
     /* 147253 */   GIM_Try, /*On fail goto*//*Label 2911*/ GIMT_Encode4(147390), // Rule ID 2058 //
     /* 147258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 147266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 147269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 147272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 147275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 147287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 147291 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 147294 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 147299 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 147303 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 147307 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147312 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 147316 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 147320 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 147324 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 147328 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 147332 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 147336 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 147340 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147345 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 147349 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 147353 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 147357 */     // MIs[4] Operand 1
     /* 147357 */     // No operand predicates
     /* 147357 */     // MIs[2] Operand 2
     /* 147357 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 147368 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 147370 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 147370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_indexed),
     /* 147373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147375 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 147377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 147381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 147385 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 147388 */     GIR_RootConstrainSelectedInstOperands,
     /* 147389 */     // GIR_Coverage, 2058,
     /* 147389 */     GIR_EraseRootFromParent_Done,
     /* 147390 */   // Label 2911: @147390
     /* 147390 */   GIM_Try, /*On fail goto*//*Label 2912*/ GIMT_Encode4(147551), // Rule ID 2560 //
     /* 147395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 147403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 147406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 147409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 147412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 147416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 147420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 147424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 147428 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 147432 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 147436 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 147440 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 147444 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 147447 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 147452 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 147456 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 147460 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147465 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 147469 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 147473 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 147477 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 147481 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 147486 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 147490 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 147494 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 147498 */     // MIs[4] Operand 1
     /* 147498 */     // No operand predicates
     /* 147498 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 147502 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 147504 */     // (intrinsic_wo_chain:{ *:[i32] } 679:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 147504 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 147507 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 147511 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147516 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 147522 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 147527 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
     /* 147535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 147539 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 147546 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 147549 */     GIR_RootConstrainSelectedInstOperands,
     /* 147550 */     // GIR_Coverage, 2560,
     /* 147550 */     GIR_EraseRootFromParent_Done,
     /* 147551 */   // Label 2912: @147551
     /* 147551 */   GIM_Try, /*On fail goto*//*Label 2913*/ GIMT_Encode4(147712), // Rule ID 6168 //
     /* 147556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 147564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 147567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 147570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 147573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 147577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 147581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 147585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 147589 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 147593 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 147597 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 147601 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 147605 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 147608 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 147613 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 147617 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 147621 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147626 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 147630 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 147634 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 147638 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 147642 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 147647 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 147651 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 147655 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 147659 */     // MIs[4] Operand 1
     /* 147659 */     // No operand predicates
     /* 147659 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 147663 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 147665 */     // (intrinsic_wo_chain:{ *:[i32] } 698:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 147665 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 147668 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 147672 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147677 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 147683 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 147688 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
     /* 147696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 147700 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 147707 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 147710 */     GIR_RootConstrainSelectedInstOperands,
     /* 147711 */     // GIR_Coverage, 6168,
     /* 147711 */     GIR_EraseRootFromParent_Done,
     /* 147712 */   // Label 2913: @147712
     /* 147712 */   GIM_Try, /*On fail goto*//*Label 2914*/ GIMT_Encode4(147822), // Rule ID 2078 //
     /* 147717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 147725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 147728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 147731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 147734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 147742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 147746 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 147750 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 147754 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 147758 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 147762 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 147766 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 147771 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 147775 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 147779 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 147783 */     // MIs[3] Operand 1
     /* 147783 */     // No operand predicates
     /* 147783 */     // MIs[1] Operand 2
     /* 147783 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 147794 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 147796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 147803 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (SQDMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 147803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv8i16_indexed),
     /* 147806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 147813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 147817 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 147820 */     GIR_RootConstrainSelectedInstOperands,
     /* 147821 */     // GIR_Coverage, 2078,
     /* 147821 */     GIR_EraseRootFromParent_Done,
     /* 147822 */   // Label 2914: @147822
     /* 147822 */   GIM_Try, /*On fail goto*//*Label 2915*/ GIMT_Encode4(147932), // Rule ID 2081 //
     /* 147827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 147835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 147838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 147841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 147844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 147852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 147856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 147860 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 147864 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 147868 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 147872 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 147876 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147881 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 147885 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 147889 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 147893 */     // MIs[3] Operand 1
     /* 147893 */     // No operand predicates
     /* 147893 */     // MIs[1] Operand 2
     /* 147893 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 147904 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 147906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 147913 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (SQDMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 147913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i32_indexed),
     /* 147916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 147923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 147927 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 147930 */     GIR_RootConstrainSelectedInstOperands,
     /* 147931 */     // GIR_Coverage, 2081,
     /* 147931 */     GIR_EraseRootFromParent_Done,
     /* 147932 */   // Label 2915: @147932
     /* 147932 */   GIM_Try, /*On fail goto*//*Label 2916*/ GIMT_Encode4(148021), // Rule ID 1736 //
     /* 147937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 147945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 147948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 147951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 147954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 147966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 147970 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 147973 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 147978 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 147982 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 147986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147988 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 147995 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 148002 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SQDMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 148002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv8i16_v4i32),
     /* 148005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 148009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 148014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 148019 */     GIR_RootConstrainSelectedInstOperands,
     /* 148020 */     // GIR_Coverage, 1736,
     /* 148020 */     GIR_EraseRootFromParent_Done,
     /* 148021 */   // Label 2916: @148021
     /* 148021 */   GIM_Try, /*On fail goto*//*Label 2917*/ GIMT_Encode4(148110), // Rule ID 1738 //
     /* 148026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 148029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 148034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 148037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 148040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 148043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 148055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 148059 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 148062 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 148067 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 148071 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 148075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148077 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 148084 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 148091 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SQDMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 148091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i32_v2i64),
     /* 148094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148096 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 148098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 148103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 148108 */     GIR_RootConstrainSelectedInstOperands,
     /* 148109 */     // GIR_Coverage, 1738,
     /* 148109 */     GIR_EraseRootFromParent_Done,
     /* 148110 */   // Label 2917: @148110
     /* 148110 */   GIM_Try, /*On fail goto*//*Label 2918*/ GIMT_Encode4(148199), // Rule ID 1740 //
     /* 148115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 148118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 148123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 148126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 148129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 148132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 148144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 148148 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 148151 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 148156 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 148160 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 148164 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148166 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 148173 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 148180 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SQDMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 148180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv8i16_v4i32),
     /* 148183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 148187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 148192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 148197 */     GIR_RootConstrainSelectedInstOperands,
     /* 148198 */     // GIR_Coverage, 1740,
     /* 148198 */     GIR_EraseRootFromParent_Done,
     /* 148199 */   // Label 2918: @148199
     /* 148199 */   GIM_Try, /*On fail goto*//*Label 2919*/ GIMT_Encode4(148288), // Rule ID 1742 //
     /* 148204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 148207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 148212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 148215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 148218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 148221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 148233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 148237 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 148240 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 148245 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 148249 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 148253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148255 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 148262 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 148269 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SQDMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 148269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i32_v2i64),
     /* 148272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148274 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 148276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 148281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 148286 */     GIR_RootConstrainSelectedInstOperands,
     /* 148287 */     // GIR_Coverage, 1742,
     /* 148287 */     GIR_EraseRootFromParent_Done,
     /* 148288 */   // Label 2919: @148288
     /* 148288 */   GIM_Try, /*On fail goto*//*Label 2920*/ GIMT_Encode4(148410), // Rule ID 6827 //
     /* 148293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 148298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 148301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 148304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 148307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 148315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 148319 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 148323 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148328 */     // MIs[1] Operand 2
     /* 148328 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 148339 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 148343 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 148347 */     // MIs[2] Rn
     /* 148347 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 148352 */     // MIs[2] Operand 2
     /* 148352 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 148363 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 148365 */     // (intrinsic_wo_chain:{ *:[v2i32] } 570:{ *:[iPTR] }, (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (ADDPv4i32:{ *:[f128] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /* 148365 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 148368 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /* 148372 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148377 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 148381 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 148385 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148392 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 148399 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148404 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148409 */     // GIR_Coverage, 6827,
     /* 148409 */     GIR_EraseRootFromParent_Done,
     /* 148410 */   // Label 2920: @148410
     /* 148410 */   GIM_Try, /*On fail goto*//*Label 2921*/ GIMT_Encode4(148532), // Rule ID 6829 //
     /* 148415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 148420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 148423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 148426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 148429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 148437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 148441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 148445 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148450 */     // MIs[1] Operand 2
     /* 148450 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 148461 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 148465 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 148469 */     // MIs[2] Rn
     /* 148469 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 148474 */     // MIs[2] Operand 2
     /* 148474 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 148485 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 148487 */     // (intrinsic_wo_chain:{ *:[v4i16] } 570:{ *:[iPTR] }, (extract_subvector:{ *:[v4i16] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } FPR128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (ADDPv8i16:{ *:[f128] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rn), dsub:{ *:[i32] })
     /* 148487 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 148490 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /* 148494 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148499 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 148503 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 148507 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148514 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 148521 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148526 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148531 */     // GIR_Coverage, 6829,
     /* 148531 */     GIR_EraseRootFromParent_Done,
     /* 148532 */   // Label 2921: @148532
     /* 148532 */   GIM_Try, /*On fail goto*//*Label 2922*/ GIMT_Encode4(148654), // Rule ID 6831 //
     /* 148537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 148542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 148545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 148548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 148551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 148559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 148563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 148567 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148572 */     // MIs[1] Operand 2
     /* 148572 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 148583 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 148587 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 148591 */     // MIs[2] Rn
     /* 148591 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 148596 */     // MIs[2] Operand 2
     /* 148596 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 148607 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 148609 */     // (intrinsic_wo_chain:{ *:[v8i8] } 570:{ *:[iPTR] }, (extract_subvector:{ *:[v8i8] } FPR128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v8i8] } FPR128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (ADDPv16i8:{ *:[f128] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rn), dsub:{ *:[i32] })
     /* 148609 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 148612 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /* 148616 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148621 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 148625 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 148629 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148636 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 148643 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148648 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148653 */     // GIR_Coverage, 6831,
     /* 148653 */     GIR_EraseRootFromParent_Done,
     /* 148654 */   // Label 2922: @148654
     /* 148654 */   GIM_Try, /*On fail goto*//*Label 2923*/ GIMT_Encode4(148776), // Rule ID 6833 //
     /* 148659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 148664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 148667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 148670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 148673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 148681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 148685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 148689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148694 */     // MIs[1] Operand 2
     /* 148694 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 148705 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 148709 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 148713 */     // MIs[2] Rn
     /* 148713 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 148718 */     // MIs[2] Operand 2
     /* 148718 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 148729 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 148731 */     // (intrinsic_wo_chain:{ *:[v2f32] } 579:{ *:[iPTR] }, (extract_subvector:{ *:[v2f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2f32] } FPR128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (FADDPv4f32:{ *:[f128] } ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] })
     /* 148731 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 148734 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 148738 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148743 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 148747 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 148751 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148758 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 148765 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148770 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148775 */     // GIR_Coverage, 6833,
     /* 148775 */     GIR_EraseRootFromParent_Done,
     /* 148776 */   // Label 2923: @148776
     /* 148776 */   GIM_Try, /*On fail goto*//*Label 2924*/ GIMT_Encode4(148898), // Rule ID 6835 //
     /* 148781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 148786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 148789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 148792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 148795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 148803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 148807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 148811 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148816 */     // MIs[1] Operand 2
     /* 148816 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 148827 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 148831 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 148835 */     // MIs[2] Rn
     /* 148835 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 148840 */     // MIs[2] Operand 2
     /* 148840 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 148851 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 148853 */     // (intrinsic_wo_chain:{ *:[v4f16] } 579:{ *:[iPTR] }, (extract_subvector:{ *:[v4f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4f16] } FPR128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (FADDPv8f16:{ *:[f128] } ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rn), dsub:{ *:[i32] })
     /* 148853 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 148856 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 148860 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148865 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 148869 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 148873 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148880 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 148887 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148892 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148897 */     // GIR_Coverage, 6835,
     /* 148897 */     GIR_EraseRootFromParent_Done,
     /* 148898 */   // Label 2924: @148898
     /* 148898 */   GIM_Try, /*On fail goto*//*Label 2925*/ GIMT_Encode4(149081), // Rule ID 2558 //
     /* 148903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 148906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 148911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 148914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 148917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 148920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 148932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 148936 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 148940 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 148944 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 148948 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 148952 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 148955 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 148960 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 148964 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 148968 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148973 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148978 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 148982 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 148984 */     // (intrinsic_wo_chain:{ *:[i32] } 679:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v4i16] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 148984 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 148987 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 148991 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148996 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 148998 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 149001 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 149005 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149010 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 149013 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /* 149017 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 149020 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149025 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149030 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149035 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 149038 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149042 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149047 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 149053 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 149058 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
     /* 149066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 149070 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149073 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 149076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149079 */     GIR_RootConstrainSelectedInstOperands,
     /* 149080 */     // GIR_Coverage, 2558,
     /* 149080 */     GIR_EraseRootFromParent_Done,
     /* 149081 */   // Label 2925: @149081
     /* 149081 */   GIM_Try, /*On fail goto*//*Label 2926*/ GIMT_Encode4(149264), // Rule ID 6166 //
     /* 149086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 149089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 149094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 149097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 149100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 149103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 149115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 149119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 149123 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 149127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 149131 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 149135 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 149138 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 149143 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 149147 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 149151 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149156 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149161 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 149165 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 149167 */     // (intrinsic_wo_chain:{ *:[i32] } 698:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v4i16] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 149167 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 149170 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 149174 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149179 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 149181 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 149184 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 149188 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149193 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 149196 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /* 149200 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 149203 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149208 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149213 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149218 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 149221 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149225 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149230 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 149236 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 149241 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
     /* 149249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 149253 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149256 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 149259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149262 */     GIR_RootConstrainSelectedInstOperands,
     /* 149263 */     // GIR_Coverage, 6166,
     /* 149263 */     GIR_EraseRootFromParent_Done,
     /* 149264 */   // Label 2926: @149264
     /* 149264 */   GIM_Try, /*On fail goto*//*Label 2927*/ GIMT_Encode4(149368), // Rule ID 13152 //
     /* 149269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 149272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 149277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 149280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 149283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 149286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 149294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 149298 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 149302 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 149306 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 149310 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 149314 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 149318 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 149323 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 149327 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 149331 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 149335 */     // MIs[3] Operand 1
     /* 149335 */     // No operand predicates
     /* 149335 */     // MIs[1] Operand 2
     /* 149335 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 149346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149350 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 149352 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 149352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 149355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149357 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 149359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 149363 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 149366 */     GIR_RootConstrainSelectedInstOperands,
     /* 149367 */     // GIR_Coverage, 13152,
     /* 149367 */     GIR_EraseRootFromParent_Done,
     /* 149368 */   // Label 2927: @149368
     /* 149368 */   GIM_Try, /*On fail goto*//*Label 2928*/ GIMT_Encode4(149472), // Rule ID 13155 //
     /* 149373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 149376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 149381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 149384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 149387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 149390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 149398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 149402 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 149406 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 149410 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 149414 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 149418 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 149422 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149427 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 149431 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 149435 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 149439 */     // MIs[3] Operand 1
     /* 149439 */     // No operand predicates
     /* 149439 */     // MIs[1] Operand 2
     /* 149439 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 149450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149454 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 149456 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 149456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 149459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149461 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 149463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 149467 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 149470 */     GIR_RootConstrainSelectedInstOperands,
     /* 149471 */     // GIR_Coverage, 13155,
     /* 149471 */     GIR_EraseRootFromParent_Done,
     /* 149472 */   // Label 2928: @149472
     /* 149472 */   GIM_Try, /*On fail goto*//*Label 2929*/ GIMT_Encode4(149603), // Rule ID 2515 //
     /* 149477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 149480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 149485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 149488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 149491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 149494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 149498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 149502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 149506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 149510 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 149514 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149519 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 149523 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 149527 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 149531 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 149535 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 149539 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149544 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 149548 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 149552 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 149556 */     // MIs[3] Operand 1
     /* 149556 */     // No operand predicates
     /* 149556 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 149558 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 149558 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 149561 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149565 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149570 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 149576 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 149581 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 149589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149591 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 149598 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 149601 */     GIR_RootConstrainSelectedInstOperands,
     /* 149602 */     // GIR_Coverage, 2515,
     /* 149602 */     GIR_EraseRootFromParent_Done,
     /* 149603 */   // Label 2929: @149603
     /* 149603 */   GIM_Try, /*On fail goto*//*Label 2930*/ GIMT_Encode4(149734), // Rule ID 2516 //
     /* 149608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 149611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 149616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 149619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 149622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 149625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 149633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 149637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 149641 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 149645 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149650 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 149654 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 149658 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 149662 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 149666 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 149670 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149675 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 149679 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 149683 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 149687 */     // MIs[3] Operand 1
     /* 149687 */     // No operand predicates
     /* 149687 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 149689 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 149689 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 149692 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149696 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149701 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 149707 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149712 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 149720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149722 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149725 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 149729 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 149732 */     GIR_RootConstrainSelectedInstOperands,
     /* 149733 */     // GIR_Coverage, 2516,
     /* 149733 */     GIR_EraseRootFromParent_Done,
     /* 149734 */   // Label 2930: @149734
     /* 149734 */   GIM_Try, /*On fail goto*//*Label 2931*/ GIMT_Encode4(149865), // Rule ID 2517 //
     /* 149739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 149742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 149747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 149750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 149753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 149756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 149764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 149768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 149772 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 149776 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149781 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 149785 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 149789 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 149793 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 149797 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 149801 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149806 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 149810 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 149814 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 149818 */     // MIs[3] Operand 1
     /* 149818 */     // No operand predicates
     /* 149818 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 149820 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 149820 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 149823 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149827 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149832 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 149838 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149843 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 149851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149853 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 149860 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 149863 */     GIR_RootConstrainSelectedInstOperands,
     /* 149864 */     // GIR_Coverage, 2517,
     /* 149864 */     GIR_EraseRootFromParent_Done,
     /* 149865 */   // Label 2931: @149865
     /* 149865 */   GIM_Try, /*On fail goto*//*Label 2932*/ GIMT_Encode4(149996), // Rule ID 13338 //
     /* 149870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 149873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 149878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 149881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 149884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 149887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 149891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 149895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 149899 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 149903 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 149907 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149912 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 149916 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 149920 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 149924 */     // MIs[2] Operand 1
     /* 149924 */     // No operand predicates
     /* 149924 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 149928 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 149932 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 149936 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 149940 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149945 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 149949 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 149951 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 149951 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 149954 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149958 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149963 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 149969 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 149974 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 149982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149984 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 149991 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 149994 */     GIR_RootConstrainSelectedInstOperands,
     /* 149995 */     // GIR_Coverage, 13338,
     /* 149995 */     GIR_EraseRootFromParent_Done,
     /* 149996 */   // Label 2932: @149996
     /* 149996 */   GIM_Try, /*On fail goto*//*Label 2933*/ GIMT_Encode4(150127), // Rule ID 13339 //
     /* 150001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 150004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 150009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 150012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 150015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 150018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 150026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 150030 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 150034 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 150038 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150043 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 150047 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 150051 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 150055 */     // MIs[2] Operand 1
     /* 150055 */     // No operand predicates
     /* 150055 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 150059 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 150063 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 150067 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 150071 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150076 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 150080 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 150082 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 150082 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 150085 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150089 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150094 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 150100 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150105 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 150113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 150122 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 150125 */     GIR_RootConstrainSelectedInstOperands,
     /* 150126 */     // GIR_Coverage, 13339,
     /* 150126 */     GIR_EraseRootFromParent_Done,
     /* 150127 */   // Label 2933: @150127
     /* 150127 */   GIM_Try, /*On fail goto*//*Label 2934*/ GIMT_Encode4(150258), // Rule ID 13340 //
     /* 150132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 150135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 150140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 150143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 150146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 150149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 150157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 150161 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 150165 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 150169 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150174 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 150178 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 150182 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 150186 */     // MIs[2] Operand 1
     /* 150186 */     // No operand predicates
     /* 150186 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 150190 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 150194 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 150198 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 150202 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150207 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 150211 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 150213 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 150213 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 150216 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150220 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150225 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 150231 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150236 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 150244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150246 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150249 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 150253 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 150256 */     GIR_RootConstrainSelectedInstOperands,
     /* 150257 */     // GIR_Coverage, 13340,
     /* 150257 */     GIR_EraseRootFromParent_Done,
     /* 150258 */   // Label 2934: @150258
     /* 150258 */   GIM_Try, /*On fail goto*//*Label 2935*/ GIMT_Encode4(150372), // Rule ID 2049 //
     /* 150263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 150266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 150271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 150274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 150277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 150280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 150292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 150296 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 150299 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 150304 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 150308 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 150312 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 150321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 150325 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 150329 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 150333 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 150338 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 150342 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 150346 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 150350 */     // MIs[3] Operand 1
     /* 150350 */     // No operand predicates
     /* 150350 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 150352 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SQDMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 150352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_indexed),
     /* 150355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 150359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 150363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 150367 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 150370 */     GIR_RootConstrainSelectedInstOperands,
     /* 150371 */     // GIR_Coverage, 2049,
     /* 150371 */     GIR_EraseRootFromParent_Done,
     /* 150372 */   // Label 2935: @150372
     /* 150372 */   GIM_Try, /*On fail goto*//*Label 2936*/ GIMT_Encode4(150486), // Rule ID 2056 //
     /* 150377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 150380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 150385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 150388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 150391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 150394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 150406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 150410 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 150413 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 150418 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 150422 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 150426 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150431 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 150435 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 150439 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 150443 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 150447 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 150452 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 150456 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 150460 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 150464 */     // MIs[3] Operand 1
     /* 150464 */     // No operand predicates
     /* 150464 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 150466 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SQDMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 150466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_indexed),
     /* 150469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 150473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 150477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 150481 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 150484 */     GIR_RootConstrainSelectedInstOperands,
     /* 150485 */     // GIR_Coverage, 2056,
     /* 150485 */     GIR_EraseRootFromParent_Done,
     /* 150486 */   // Label 2936: @150486
     /* 150486 */   GIM_Try, /*On fail goto*//*Label 2937*/ GIMT_Encode4(150600), // Rule ID 2052 //
     /* 150491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 150494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 150499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 150502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 150505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 150508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 150520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 150524 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 150527 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 150532 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 150536 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 150540 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150545 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 150549 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 150553 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 150557 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 150561 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150566 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 150570 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 150574 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 150578 */     // MIs[3] Operand 1
     /* 150578 */     // No operand predicates
     /* 150578 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 150580 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 150580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_indexed),
     /* 150583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 150587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 150591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 150595 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 150598 */     GIR_RootConstrainSelectedInstOperands,
     /* 150599 */     // GIR_Coverage, 2052,
     /* 150599 */     GIR_EraseRootFromParent_Done,
     /* 150600 */   // Label 2937: @150600
     /* 150600 */   GIM_Try, /*On fail goto*//*Label 2938*/ GIMT_Encode4(150714), // Rule ID 2059 //
     /* 150605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 150608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 150613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 150616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 150619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 150622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 150634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 150638 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 150641 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 150646 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 150650 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 150654 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150659 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 150663 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 150667 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 150671 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 150675 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150680 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 150684 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 150688 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 150692 */     // MIs[3] Operand 1
     /* 150692 */     // No operand predicates
     /* 150692 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 150694 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 150694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_indexed),
     /* 150697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 150701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 150705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 150709 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 150712 */     GIR_RootConstrainSelectedInstOperands,
     /* 150713 */     // GIR_Coverage, 2059,
     /* 150713 */     GIR_EraseRootFromParent_Done,
     /* 150714 */   // Label 2938: @150714
     /* 150714 */   GIM_Try, /*On fail goto*//*Label 2939*/ GIMT_Encode4(150828), // Rule ID 2054 //
     /* 150719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 150722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 150727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 150730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 150733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 150736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 150748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 150752 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 150755 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 150760 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 150764 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 150768 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150773 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 150777 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 150781 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 150785 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 150789 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150794 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 150798 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 150802 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 150806 */     // MIs[3] Operand 1
     /* 150806 */     // No operand predicates
     /* 150806 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 150808 */     // (intrinsic_wo_chain:{ *:[i64] } 679:{ *:[iPTR] }, FPR64Op:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLALv1i64_indexed:{ *:[i64] } FPR64Op:{ *:[i64] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 150808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i64_indexed),
     /* 150811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 150815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 150819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 150823 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 150826 */     GIR_RootConstrainSelectedInstOperands,
     /* 150827 */     // GIR_Coverage, 2054,
     /* 150827 */     GIR_EraseRootFromParent_Done,
     /* 150828 */   // Label 2939: @150828
     /* 150828 */   GIM_Try, /*On fail goto*//*Label 2940*/ GIMT_Encode4(150942), // Rule ID 2061 //
     /* 150833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 150836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 150841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 150844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 150847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 150850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 150862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 150866 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 150869 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 150874 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 150878 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 150882 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150887 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 150891 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 150895 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 150899 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 150903 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150908 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 150912 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 150916 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 150920 */     // MIs[3] Operand 1
     /* 150920 */     // No operand predicates
     /* 150920 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 150922 */     // (intrinsic_wo_chain:{ *:[i64] } 698:{ *:[iPTR] }, FPR64Op:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLSLv1i64_indexed:{ *:[i64] } FPR64Op:{ *:[i64] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 150922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i64_indexed),
     /* 150925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 150929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 150933 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 150937 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 150940 */     GIR_RootConstrainSelectedInstOperands,
     /* 150941 */     // GIR_Coverage, 2061,
     /* 150941 */     GIR_EraseRootFromParent_Done,
     /* 150942 */   // Label 2940: @150942
     /* 150942 */   GIM_Try, /*On fail goto*//*Label 2941*/ GIMT_Encode4(151046), // Rule ID 1980 //
     /* 150947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 150950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 150955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 150958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 150961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 150964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 150976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 150980 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 150984 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 150988 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 150992 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 150996 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 151000 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 151005 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 151009 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 151013 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 151017 */     // MIs[3] Operand 1
     /* 151017 */     // No operand predicates
     /* 151017 */     // MIs[1] Operand 2
     /* 151017 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 151028 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 151030 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 151030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 151033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 151041 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 151044 */     GIR_RootConstrainSelectedInstOperands,
     /* 151045 */     // GIR_Coverage, 1980,
     /* 151045 */     GIR_EraseRootFromParent_Done,
     /* 151046 */   // Label 2941: @151046
     /* 151046 */   GIM_Try, /*On fail goto*//*Label 2942*/ GIMT_Encode4(151150), // Rule ID 2010 //
     /* 151051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 151054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 151059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 151062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 151065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 151068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 151080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 151084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 151088 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 151092 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 151096 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 151100 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 151104 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 151109 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 151113 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 151117 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 151121 */     // MIs[3] Operand 1
     /* 151121 */     // No operand predicates
     /* 151121 */     // MIs[1] Operand 2
     /* 151121 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 151132 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 151134 */     // (intrinsic_wo_chain:{ *:[v4i16] } 680:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 151134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16_indexed),
     /* 151137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 151145 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 151148 */     GIR_RootConstrainSelectedInstOperands,
     /* 151149 */     // GIR_Coverage, 2010,
     /* 151149 */     GIR_EraseRootFromParent_Done,
     /* 151150 */   // Label 2942: @151150
     /* 151150 */   GIM_Try, /*On fail goto*//*Label 2943*/ GIMT_Encode4(151254), // Rule ID 2017 //
     /* 151155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 151158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 151163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 151166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 151169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 151172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 151184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 151188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 151192 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 151196 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 151200 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 151204 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 151208 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 151213 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 151217 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 151221 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 151225 */     // MIs[3] Operand 1
     /* 151225 */     // No operand predicates
     /* 151225 */     // MIs[1] Operand 2
     /* 151225 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 151236 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 151238 */     // (intrinsic_wo_chain:{ *:[v4i16] } 688:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 151238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16_indexed),
     /* 151241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 151249 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 151252 */     GIR_RootConstrainSelectedInstOperands,
     /* 151253 */     // GIR_Coverage, 2017,
     /* 151253 */     GIR_EraseRootFromParent_Done,
     /* 151254 */   // Label 2943: @151254
     /* 151254 */   GIM_Try, /*On fail goto*//*Label 2944*/ GIMT_Encode4(151358), // Rule ID 2076 //
     /* 151259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 151262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 151267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 151270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 151273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 151276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 151288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 151292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 151296 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 151300 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 151304 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 151308 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 151312 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 151317 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 151321 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 151325 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 151329 */     // MIs[3] Operand 1
     /* 151329 */     // No operand predicates
     /* 151329 */     // MIs[1] Operand 2
     /* 151329 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 151340 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 151342 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 151342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_indexed),
     /* 151345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 151353 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 151356 */     GIR_RootConstrainSelectedInstOperands,
     /* 151357 */     // GIR_Coverage, 2076,
     /* 151357 */     GIR_EraseRootFromParent_Done,
     /* 151358 */   // Label 2944: @151358
     /* 151358 */   GIM_Try, /*On fail goto*//*Label 2945*/ GIMT_Encode4(151462), // Rule ID 1983 //
     /* 151363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 151366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 151371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 151374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 151377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 151380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 151392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 151396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 151400 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 151404 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 151408 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 151412 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 151416 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151421 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 151425 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 151429 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 151433 */     // MIs[3] Operand 1
     /* 151433 */     // No operand predicates
     /* 151433 */     // MIs[1] Operand 2
     /* 151433 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 151444 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 151446 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 151446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 151449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 151457 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 151460 */     GIR_RootConstrainSelectedInstOperands,
     /* 151461 */     // GIR_Coverage, 1983,
     /* 151461 */     GIR_EraseRootFromParent_Done,
     /* 151462 */   // Label 2945: @151462
     /* 151462 */   GIM_Try, /*On fail goto*//*Label 2946*/ GIMT_Encode4(151566), // Rule ID 2013 //
     /* 151467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 151470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 151475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 151478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 151481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 151484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 151496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 151500 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 151504 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 151508 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 151512 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 151516 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 151520 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151525 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 151529 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 151533 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 151537 */     // MIs[3] Operand 1
     /* 151537 */     // No operand predicates
     /* 151537 */     // MIs[1] Operand 2
     /* 151537 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 151548 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 151550 */     // (intrinsic_wo_chain:{ *:[v2i32] } 680:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 151550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32_indexed),
     /* 151553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 151561 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 151564 */     GIR_RootConstrainSelectedInstOperands,
     /* 151565 */     // GIR_Coverage, 2013,
     /* 151565 */     GIR_EraseRootFromParent_Done,
     /* 151566 */   // Label 2946: @151566
     /* 151566 */   GIM_Try, /*On fail goto*//*Label 2947*/ GIMT_Encode4(151670), // Rule ID 2020 //
     /* 151571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 151574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 151579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 151582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 151585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 151588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 151600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 151604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 151608 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 151612 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 151616 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 151620 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 151624 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151629 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 151633 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 151637 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 151641 */     // MIs[3] Operand 1
     /* 151641 */     // No operand predicates
     /* 151641 */     // MIs[1] Operand 2
     /* 151641 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 151652 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 151654 */     // (intrinsic_wo_chain:{ *:[v2i32] } 688:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 151654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32_indexed),
     /* 151657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151659 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 151665 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 151668 */     GIR_RootConstrainSelectedInstOperands,
     /* 151669 */     // GIR_Coverage, 2020,
     /* 151669 */     GIR_EraseRootFromParent_Done,
     /* 151670 */   // Label 2947: @151670
     /* 151670 */   GIM_Try, /*On fail goto*//*Label 2948*/ GIMT_Encode4(151774), // Rule ID 2079 //
     /* 151675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 151678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 151683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 151686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 151689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 151692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 151704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 151708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 151712 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 151716 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 151720 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 151724 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 151728 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151733 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 151737 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 151741 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 151745 */     // MIs[3] Operand 1
     /* 151745 */     // No operand predicates
     /* 151745 */     // MIs[1] Operand 2
     /* 151745 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 151756 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 151758 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 151758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_indexed),
     /* 151761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 151769 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 151772 */     GIR_RootConstrainSelectedInstOperands,
     /* 151773 */     // GIR_Coverage, 2079,
     /* 151773 */     GIR_EraseRootFromParent_Done,
     /* 151774 */   // Label 2948: @151774
     /* 151774 */   GIM_Try, /*On fail goto*//*Label 2949*/ GIMT_Encode4(151831), // Rule ID 1744 //
     /* 151779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 151782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 151787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 151790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 151793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 151796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 151807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 151814 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (SQDMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 151814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv8i16_v4i32),
     /* 151817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 151824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 151829 */     GIR_RootConstrainSelectedInstOperands,
     /* 151830 */     // GIR_Coverage, 1744,
     /* 151830 */     GIR_EraseRootFromParent_Done,
     /* 151831 */   // Label 2949: @151831
     /* 151831 */   GIM_Try, /*On fail goto*//*Label 2950*/ GIMT_Encode4(151888), // Rule ID 1746 //
     /* 151836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 151839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 151844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 151847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 151850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 151853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 151864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 151871 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (SQDMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 151871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i32_v2i64),
     /* 151874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 151881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 151886 */     GIR_RootConstrainSelectedInstOperands,
     /* 151887 */     // GIR_Coverage, 1746,
     /* 151887 */     GIR_EraseRootFromParent_Done,
     /* 151888 */   // Label 2950: @151888
     /* 151888 */   GIM_Try, /*On fail goto*//*Label 2951*/ GIMT_Encode4(151998), // Rule ID 6185 //
     /* 151893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 151898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 151901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 151904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 151907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 151911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 151915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 151919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 151923 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 151927 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 151932 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 151943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 151947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 151951 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 151955 */     // MIs[2] Operand 1
     /* 151955 */     // No operand predicates
     /* 151955 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 151957 */     // (intrinsic_wo_chain:{ *:[f16] } 766:{ *:[iPTR] }, (and:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 151957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 151960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151969 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 151975 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 151980 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 151985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
     /* 151988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151990 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 151993 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 151996 */     GIR_RootConstrainSelectedInstOperands,
     /* 151997 */     // GIR_Coverage, 6185,
     /* 151997 */     GIR_EraseRootFromParent_Done,
     /* 151998 */   // Label 2951: @151998
     /* 151998 */   GIM_Try, /*On fail goto*//*Label 2952*/ GIMT_Encode4(152095), // Rule ID 13606 //
     /* 152003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 152006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 152011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 152014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 152017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 152020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 152024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 152032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 152036 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 152040 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152045 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 152049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 152053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152055 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 152055 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 152058 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152062 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152067 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 152073 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 152078 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
     /* 152086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152088 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 152090 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 152093 */     GIR_RootConstrainSelectedInstOperands,
     /* 152094 */     // GIR_Coverage, 13606,
     /* 152094 */     GIR_EraseRootFromParent_Done,
     /* 152095 */   // Label 2952: @152095
     /* 152095 */   GIM_Try, /*On fail goto*//*Label 2953*/ GIMT_Encode4(152192), // Rule ID 13607 //
     /* 152100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 152103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 152108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 152111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 152114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 152117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 152129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 152133 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 152137 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152142 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 152146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152150 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152152 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 152152 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 152155 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152159 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152164 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 152170 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152175 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
     /* 152183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152185 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 152187 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 152190 */     GIR_RootConstrainSelectedInstOperands,
     /* 152191 */     // GIR_Coverage, 13607,
     /* 152191 */     GIR_EraseRootFromParent_Done,
     /* 152192 */   // Label 2953: @152192
     /* 152192 */   GIM_Try, /*On fail goto*//*Label 2954*/ GIMT_Encode4(152289), // Rule ID 13608 //
     /* 152197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 152200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 152205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 152208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 152211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 152214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 152226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 152230 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 152234 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152239 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 152243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152249 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 152249 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 152252 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152256 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152261 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 152267 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152272 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 152280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152282 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 152284 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 152287 */     GIR_RootConstrainSelectedInstOperands,
     /* 152288 */     // GIR_Coverage, 13608,
     /* 152288 */     GIR_EraseRootFromParent_Done,
     /* 152289 */   // Label 2954: @152289
     /* 152289 */   GIM_Try, /*On fail goto*//*Label 2955*/ GIMT_Encode4(152372), // Rule ID 1735 //
     /* 152294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 152297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 152302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 152305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 152308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 152311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 152323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 152327 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 152330 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 152335 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 152339 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 152343 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152348 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152355 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SQDMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 152355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_v4i32),
     /* 152358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152360 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 152362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 152366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 152370 */     GIR_RootConstrainSelectedInstOperands,
     /* 152371 */     // GIR_Coverage, 1735,
     /* 152371 */     GIR_EraseRootFromParent_Done,
     /* 152372 */   // Label 2955: @152372
     /* 152372 */   GIM_Try, /*On fail goto*//*Label 2956*/ GIMT_Encode4(152455), // Rule ID 1737 //
     /* 152377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 152380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 152385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 152388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 152391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 152394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 152406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 152410 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 152413 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 152418 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 152422 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 152426 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152431 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152438 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SQDMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 152438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_v2i64),
     /* 152441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 152445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 152449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 152453 */     GIR_RootConstrainSelectedInstOperands,
     /* 152454 */     // GIR_Coverage, 1737,
     /* 152454 */     GIR_EraseRootFromParent_Done,
     /* 152455 */   // Label 2956: @152455
     /* 152455 */   GIM_Try, /*On fail goto*//*Label 2957*/ GIMT_Encode4(152538), // Rule ID 1739 //
     /* 152460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 152463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 152468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 152471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 152474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 152477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 152489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 152493 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 152496 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 152501 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 152505 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 152509 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152514 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152521 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SQDMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 152521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_v4i32),
     /* 152524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 152528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 152532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 152536 */     GIR_RootConstrainSelectedInstOperands,
     /* 152537 */     // GIR_Coverage, 1739,
     /* 152537 */     GIR_EraseRootFromParent_Done,
     /* 152538 */   // Label 2957: @152538
     /* 152538 */   GIM_Try, /*On fail goto*//*Label 2958*/ GIMT_Encode4(152621), // Rule ID 1741 //
     /* 152543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 152546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 152551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 152554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 152557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 152560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 152572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 152576 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 152579 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 152584 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 152588 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 152592 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152597 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152602 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152604 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SQDMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 152604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_v2i64),
     /* 152607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 152611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 152615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 152619 */     GIR_RootConstrainSelectedInstOperands,
     /* 152620 */     // GIR_Coverage, 1741,
     /* 152620 */     GIR_EraseRootFromParent_Done,
     /* 152621 */   // Label 2958: @152621
     /* 152621 */   GIM_Try, /*On fail goto*//*Label 2959*/ GIMT_Encode4(152701), // Rule ID 5174 //
     /* 152626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 152631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 152634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 152637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 152640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 152652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 152656 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 152659 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 152664 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 152668 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 152672 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152677 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152682 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152684 */     // (intrinsic_wo_chain:{ *:[i64] } 679:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm))  =>  (SQDMLALi32:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 152684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALi32),
     /* 152687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 152691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 152695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 152699 */     GIR_RootConstrainSelectedInstOperands,
     /* 152700 */     // GIR_Coverage, 5174,
     /* 152700 */     GIR_EraseRootFromParent_Done,
     /* 152701 */   // Label 2959: @152701
     /* 152701 */   GIM_Try, /*On fail goto*//*Label 2960*/ GIMT_Encode4(152781), // Rule ID 5175 //
     /* 152706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 152711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 152714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 152717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 152720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 152732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 152736 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 152739 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 152744 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 152748 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 152752 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152757 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152762 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152764 */     // (intrinsic_wo_chain:{ *:[i64] } 698:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm))  =>  (SQDMLSLi32:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 152764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLi32),
     /* 152767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 152771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 152775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 152779 */     GIR_RootConstrainSelectedInstOperands,
     /* 152780 */     // GIR_Coverage, 5175,
     /* 152780 */     GIR_EraseRootFromParent_Done,
     /* 152781 */   // Label 2960: @152781
     /* 152781 */   GIM_Try, /*On fail goto*//*Label 2961*/ GIMT_Encode4(152878), // Rule ID 5171 //
     /* 152786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 152789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 152794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 152797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 152800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 152803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 152807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 152811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 152815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 152819 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 152823 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 152827 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152832 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 152836 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152838 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 152838 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 152841 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152845 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152850 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 152856 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 152861 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
     /* 152869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 152873 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 152876 */     GIR_RootConstrainSelectedInstOperands,
     /* 152877 */     // GIR_Coverage, 5171,
     /* 152877 */     GIR_EraseRootFromParent_Done,
     /* 152878 */   // Label 2961: @152878
     /* 152878 */   GIM_Try, /*On fail goto*//*Label 2962*/ GIMT_Encode4(152975), // Rule ID 5172 //
     /* 152883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 152886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 152891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 152894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 152897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 152900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 152912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 152916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 152920 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 152924 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152929 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 152933 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152935 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 152935 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 152938 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152942 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152947 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 152953 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152958 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
     /* 152966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 152970 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 152973 */     GIR_RootConstrainSelectedInstOperands,
     /* 152974 */     // GIR_Coverage, 5172,
     /* 152974 */     GIR_EraseRootFromParent_Done,
     /* 152975 */   // Label 2962: @152975
     /* 152975 */   GIM_Try, /*On fail goto*//*Label 2963*/ GIMT_Encode4(153072), // Rule ID 5173 //
     /* 152980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 152983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 152988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 152991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 152994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 152997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 153013 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 153017 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 153021 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153026 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 153030 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153032 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 153032 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 153035 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153039 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153044 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 153050 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153055 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 153063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 153067 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 153070 */     GIR_RootConstrainSelectedInstOperands,
     /* 153071 */     // GIR_Coverage, 5173,
     /* 153071 */     GIR_EraseRootFromParent_Done,
     /* 153072 */   // Label 2963: @153072
     /* 153072 */   GIM_Try, /*On fail goto*//*Label 2964*/ GIMT_Encode4(153153), // Rule ID 13153 //
     /* 153077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 153080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 153085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 153088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 153091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 153094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 153106 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153110 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 153114 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 153119 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 153123 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153127 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 153131 */     // MIs[2] Operand 1
     /* 153131 */     // No operand predicates
     /* 153131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153135 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 153137 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 153140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153142 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 153144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 153148 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 153151 */     GIR_RootConstrainSelectedInstOperands,
     /* 153152 */     // GIR_Coverage, 13153,
     /* 153152 */     GIR_EraseRootFromParent_Done,
     /* 153153 */   // Label 2964: @153153
     /* 153153 */   GIM_Try, /*On fail goto*//*Label 2965*/ GIMT_Encode4(153234), // Rule ID 13154 //
     /* 153158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 153161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 153166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 153169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 153172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 153175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 153187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153191 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 153195 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 153200 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 153204 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153208 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 153212 */     // MIs[2] Operand 1
     /* 153212 */     // No operand predicates
     /* 153212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153216 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 153218 */     // (intrinsic_wo_chain:{ *:[v8f16] } 610:{ *:[iPTR] }, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULXv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8i16_indexed),
     /* 153221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153223 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 153225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 153229 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 153232 */     GIR_RootConstrainSelectedInstOperands,
     /* 153233 */     // GIR_Coverage, 13154,
     /* 153233 */     GIR_EraseRootFromParent_Done,
     /* 153234 */   // Label 2965: @153234
     /* 153234 */   GIM_Try, /*On fail goto*//*Label 2966*/ GIMT_Encode4(153315), // Rule ID 13156 //
     /* 153239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 153247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 153250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 153253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 153256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 153268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 153272 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 153276 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153281 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 153285 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153289 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 153293 */     // MIs[2] Operand 1
     /* 153293 */     // No operand predicates
     /* 153293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153297 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 153299 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 153302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 153306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 153310 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 153313 */     GIR_RootConstrainSelectedInstOperands,
     /* 153314 */     // GIR_Coverage, 13156,
     /* 153314 */     GIR_EraseRootFromParent_Done,
     /* 153315 */   // Label 2966: @153315
     /* 153315 */   GIM_Try, /*On fail goto*//*Label 2967*/ GIMT_Encode4(153396), // Rule ID 13157 //
     /* 153320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 153328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 153331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 153334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 153337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 153349 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 153353 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 153357 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153362 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 153366 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153370 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 153374 */     // MIs[2] Operand 1
     /* 153374 */     // No operand predicates
     /* 153374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153378 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 153380 */     // (intrinsic_wo_chain:{ *:[v4f32] } 610:{ *:[iPTR] }, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULXv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i32_indexed),
     /* 153383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153385 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 153387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 153391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 153394 */     GIR_RootConstrainSelectedInstOperands,
     /* 153395 */     // GIR_Coverage, 13157,
     /* 153395 */     GIR_EraseRootFromParent_Done,
     /* 153396 */   // Label 2967: @153396
     /* 153396 */   GIM_Try, /*On fail goto*//*Label 2968*/ GIMT_Encode4(153477), // Rule ID 13158 //
     /* 153401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 153409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 153412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 153415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 153418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 153430 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 153434 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 153438 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153443 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 153447 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153451 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 153455 */     // MIs[2] Operand 1
     /* 153455 */     // No operand predicates
     /* 153455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153459 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 153461 */     // (intrinsic_wo_chain:{ *:[v2f64] } 610:{ *:[iPTR] }, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULXv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i64_indexed),
     /* 153464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153466 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 153468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 153472 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 153475 */     GIR_RootConstrainSelectedInstOperands,
     /* 153476 */     // GIR_Coverage, 13158,
     /* 153476 */     GIR_EraseRootFromParent_Done,
     /* 153477 */   // Label 2968: @153477
     /* 153477 */   GIM_Try, /*On fail goto*//*Label 2969*/ GIMT_Encode4(153558), // Rule ID 13159 //
     /* 153482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 153485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 153490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 153493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 153496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 153499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 153503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 153511 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153515 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 153519 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 153524 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 153528 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153532 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 153536 */     // MIs[2] Operand 1
     /* 153536 */     // No operand predicates
     /* 153536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 153540 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 153542 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULXv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 153545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153547 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 153549 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 153553 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 153556 */     GIR_RootConstrainSelectedInstOperands,
     /* 153557 */     // GIR_Coverage, 13159,
     /* 153557 */     GIR_EraseRootFromParent_Done,
     /* 153558 */   // Label 2969: @153558
     /* 153558 */   GIM_Try, /*On fail goto*//*Label 2970*/ GIMT_Encode4(153639), // Rule ID 13160 //
     /* 153563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 153571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 153574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 153577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 153580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 153584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 153592 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 153596 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 153600 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153605 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 153609 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153613 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 153617 */     // MIs[2] Operand 1
     /* 153617 */     // No operand predicates
     /* 153617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 153621 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 153623 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULXv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 153626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153628 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 153630 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 153634 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 153637 */     GIR_RootConstrainSelectedInstOperands,
     /* 153638 */     // GIR_Coverage, 13160,
     /* 153638 */     GIR_EraseRootFromParent_Done,
     /* 153639 */   // Label 2970: @153639
     /* 153639 */   GIM_Try, /*On fail goto*//*Label 2971*/ GIMT_Encode4(153720), // Rule ID 13161 //
     /* 153644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 153652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 153655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 153658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 153661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 153673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 153677 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 153681 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153686 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 153690 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153694 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 153698 */     // MIs[2] Operand 1
     /* 153698 */     // No operand predicates
     /* 153698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153702 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 153704 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULXv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 153707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153709 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 153711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 153715 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 153718 */     GIR_RootConstrainSelectedInstOperands,
     /* 153719 */     // GIR_Coverage, 13161,
     /* 153719 */     GIR_EraseRootFromParent_Done,
     /* 153720 */   // Label 2971: @153720
     /* 153720 */   GIM_Try, /*On fail goto*//*Label 2972*/ GIMT_Encode4(153826), // Rule ID 6182 //
     /* 153725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 153730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 153733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 153736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 153739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 153743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 153751 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 153755 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 153760 */     // MIs[1] Operand 2
     /* 153760 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 153771 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 153775 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153779 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 153783 */     // MIs[2] Operand 1
     /* 153783 */     // No operand predicates
     /* 153783 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 153785 */     // (intrinsic_wo_chain:{ *:[f16] } 765:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 153785 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 153788 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153792 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153797 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 153803 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 153808 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 153813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
     /* 153816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153818 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 153821 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 153824 */     GIR_RootConstrainSelectedInstOperands,
     /* 153825 */     // GIR_Coverage, 6182,
     /* 153825 */     GIR_EraseRootFromParent_Done,
     /* 153826 */   // Label 2972: @153826
     /* 153826 */   GIM_Try, /*On fail goto*//*Label 2973*/ GIMT_Encode4(153907), // Rule ID 1981 //
     /* 153831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 153834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 153839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 153842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 153845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 153848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 153864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153868 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 153872 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 153877 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 153881 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153885 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 153889 */     // MIs[2] Operand 1
     /* 153889 */     // No operand predicates
     /* 153889 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 153891 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 153894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 153898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 153902 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 153905 */     GIR_RootConstrainSelectedInstOperands,
     /* 153906 */     // GIR_Coverage, 1981,
     /* 153906 */     GIR_EraseRootFromParent_Done,
     /* 153907 */   // Label 2973: @153907
     /* 153907 */   GIM_Try, /*On fail goto*//*Label 2974*/ GIMT_Encode4(153988), // Rule ID 1982 //
     /* 153912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 153915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 153920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 153923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 153926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 153929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 153945 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153949 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 153953 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 153958 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 153962 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153966 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 153970 */     // MIs[2] Operand 1
     /* 153970 */     // No operand predicates
     /* 153970 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 153972 */     // (intrinsic_wo_chain:{ *:[v8f16] } 610:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8i16_indexed),
     /* 153975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 153979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 153983 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 153986 */     GIR_RootConstrainSelectedInstOperands,
     /* 153987 */     // GIR_Coverage, 1982,
     /* 153987 */     GIR_EraseRootFromParent_Done,
     /* 153988 */   // Label 2974: @153988
     /* 153988 */   GIM_Try, /*On fail goto*//*Label 2975*/ GIMT_Encode4(154069), // Rule ID 2011 //
     /* 153993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 154001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 154004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 154007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 154010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 154026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 154030 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 154034 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 154039 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 154043 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154047 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 154051 */     // MIs[2] Operand 1
     /* 154051 */     // No operand predicates
     /* 154051 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154053 */     // (intrinsic_wo_chain:{ *:[v4i16] } 680:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 154053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16_indexed),
     /* 154056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 154058 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 154060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 154064 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 154067 */     GIR_RootConstrainSelectedInstOperands,
     /* 154068 */     // GIR_Coverage, 2011,
     /* 154068 */     GIR_EraseRootFromParent_Done,
     /* 154069 */   // Label 2975: @154069
     /* 154069 */   GIM_Try, /*On fail goto*//*Label 2976*/ GIMT_Encode4(154150), // Rule ID 2012 //
     /* 154074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 154082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 154085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 154088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 154091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 154107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 154111 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 154115 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 154120 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 154124 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154128 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 154132 */     // MIs[2] Operand 1
     /* 154132 */     // No operand predicates
     /* 154132 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154134 */     // (intrinsic_wo_chain:{ *:[v8i16] } 680:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 154134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv8i16_indexed),
     /* 154137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 154139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 154141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 154145 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 154148 */     GIR_RootConstrainSelectedInstOperands,
     /* 154149 */     // GIR_Coverage, 2012,
     /* 154149 */     GIR_EraseRootFromParent_Done,
     /* 154150 */   // Label 2976: @154150
     /* 154150 */   GIM_Try, /*On fail goto*//*Label 2977*/ GIMT_Encode4(154231), // Rule ID 2018 //
     /* 154155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 154163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 154166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 154169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 154172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 154188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 154192 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 154196 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 154201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 154205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154209 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 154213 */     // MIs[2] Operand 1
     /* 154213 */     // No operand predicates
     /* 154213 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154215 */     // (intrinsic_wo_chain:{ *:[v4i16] } 688:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 154215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16_indexed),
     /* 154218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 154220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 154222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 154226 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 154229 */     GIR_RootConstrainSelectedInstOperands,
     /* 154230 */     // GIR_Coverage, 2018,
     /* 154230 */     GIR_EraseRootFromParent_Done,
     /* 154231 */   // Label 2977: @154231
     /* 154231 */   GIM_Try, /*On fail goto*//*Label 2978*/ GIMT_Encode4(154312), // Rule ID 2019 //
     /* 154236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 154244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 154247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 154250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 154253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 154269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 154273 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 154277 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 154282 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 154286 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154290 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 154294 */     // MIs[2] Operand 1
     /* 154294 */     // No operand predicates
     /* 154294 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154296 */     // (intrinsic_wo_chain:{ *:[v8i16] } 688:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMULHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 154296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv8i16_indexed),
     /* 154299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 154301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 154303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 154307 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 154310 */     GIR_RootConstrainSelectedInstOperands,
     /* 154311 */     // GIR_Coverage, 2019,
     /* 154311 */     GIR_EraseRootFromParent_Done,
     /* 154312 */   // Label 2978: @154312
     /* 154312 */   GIM_Try, /*On fail goto*//*Label 2979*/ GIMT_Encode4(154393), // Rule ID 2077 //
     /* 154317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 154325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 154328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 154331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 154334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 154350 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 154354 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 154358 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 154363 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 154367 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154371 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 154375 */     // MIs[2] Operand 1
     /* 154375 */     // No operand predicates
     /* 154375 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154377 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 154377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_indexed),
     /* 154380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 154382 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 154384 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 154388 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 154391 */     GIR_RootConstrainSelectedInstOperands,
     /* 154392 */     // GIR_Coverage, 2077,
     /* 154392 */     GIR_EraseRootFromParent_Done,
     /* 154393 */   // Label 2979: @154393
     /* 154393 */   GIM_Try, /*On fail goto*//*Label 2980*/ GIMT_Encode4(154474), // Rule ID 1984 //
     /* 154398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 154406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 154409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 154412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 154415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 154431 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 154435 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 154439 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154444 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 154448 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154452 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 154456 */     // MIs[2] Operand 1
     /* 154456 */     // No operand predicates
     /* 154456 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154458 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 154458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 154461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 154463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 154465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 154469 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 154472 */     GIR_RootConstrainSelectedInstOperands,
     /* 154473 */     // GIR_Coverage, 1984,
     /* 154473 */     GIR_EraseRootFromParent_Done,
     /* 154474 */   // Label 2980: @154474
     /* 154474 */   GIM_Try, /*On fail goto*//*Label 2981*/ GIMT_Encode4(154555), // Rule ID 1985 //
     /* 154479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 154487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 154490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 154493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 154496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 154512 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 154516 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 154520 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154525 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 154529 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154533 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 154537 */     // MIs[2] Operand 1
     /* 154537 */     // No operand predicates
     /* 154537 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154539 */     // (intrinsic_wo_chain:{ *:[v4f32] } 610:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 154539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i32_indexed),
     /* 154542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 154544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 154546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 154550 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 154553 */     GIR_RootConstrainSelectedInstOperands,
     /* 154554 */     // GIR_Coverage, 1985,
     /* 154554 */     GIR_EraseRootFromParent_Done,
     /* 154555 */   // Label 2981: @154555
     /* 154555 */   GIM_Try, /*On fail goto*//*Label 2982*/ GIMT_Encode4(154636), // Rule ID 2014 //
     /* 154560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 154568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 154571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 154574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 154577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 154593 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 154597 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 154601 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154606 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 154610 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154614 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 154618 */     // MIs[2] Operand 1
     /* 154618 */     // No operand predicates
     /* 154618 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154620 */     // (intrinsic_wo_chain:{ *:[v2i32] } 680:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 154620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32_indexed),
     /* 154623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 154625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 154627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 154631 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 154634 */     GIR_RootConstrainSelectedInstOperands,
     /* 154635 */     // GIR_Coverage, 2014,
     /* 154635 */     GIR_EraseRootFromParent_Done,
     /* 154636 */   // Label 2982: @154636
     /* 154636 */   GIM_Try, /*On fail goto*//*Label 2983*/ GIMT_Encode4(154717), // Rule ID 2015 //
     /* 154641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 154649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 154652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 154655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 154658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 154674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 154678 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 154682 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 154691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154695 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 154699 */     // MIs[2] Operand 1
     /* 154699 */     // No operand predicates
     /* 154699 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154701 */     // (intrinsic_wo_chain:{ *:[v4i32] } 680:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 154701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i32_indexed),
     /* 154704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 154706 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 154708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 154712 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 154715 */     GIR_RootConstrainSelectedInstOperands,
     /* 154716 */     // GIR_Coverage, 2015,
     /* 154716 */     GIR_EraseRootFromParent_Done,
     /* 154717 */   // Label 2983: @154717
     /* 154717 */   GIM_Try, /*On fail goto*//*Label 2984*/ GIMT_Encode4(154798), // Rule ID 2021 //
     /* 154722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 154730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 154733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 154736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 154739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 154755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 154759 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 154763 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154768 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 154772 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154776 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 154780 */     // MIs[2] Operand 1
     /* 154780 */     // No operand predicates
     /* 154780 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154782 */     // (intrinsic_wo_chain:{ *:[v2i32] } 688:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 154782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32_indexed),
     /* 154785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 154787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 154789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 154793 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 154796 */     GIR_RootConstrainSelectedInstOperands,
     /* 154797 */     // GIR_Coverage, 2021,
     /* 154797 */     GIR_EraseRootFromParent_Done,
     /* 154798 */   // Label 2984: @154798
     /* 154798 */   GIM_Try, /*On fail goto*//*Label 2985*/ GIMT_Encode4(154879), // Rule ID 2022 //
     /* 154803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 154811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 154814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 154817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 154820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 154836 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 154840 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 154844 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154849 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 154853 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154857 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 154861 */     // MIs[2] Operand 1
     /* 154861 */     // No operand predicates
     /* 154861 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154863 */     // (intrinsic_wo_chain:{ *:[v4i32] } 688:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 154863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i32_indexed),
     /* 154866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 154868 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 154870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 154874 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 154877 */     GIR_RootConstrainSelectedInstOperands,
     /* 154878 */     // GIR_Coverage, 2022,
     /* 154878 */     GIR_EraseRootFromParent_Done,
     /* 154879 */   // Label 2985: @154879
     /* 154879 */   GIM_Try, /*On fail goto*//*Label 2986*/ GIMT_Encode4(154960), // Rule ID 2080 //
     /* 154884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 154892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 154895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 154898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 154901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 154917 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 154921 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 154925 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154930 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 154934 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154938 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 154942 */     // MIs[2] Operand 1
     /* 154942 */     // No operand predicates
     /* 154942 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154944 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 154944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_indexed),
     /* 154947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 154949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 154951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 154955 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 154958 */     GIR_RootConstrainSelectedInstOperands,
     /* 154959 */     // GIR_Coverage, 2080,
     /* 154959 */     GIR_EraseRootFromParent_Done,
     /* 154960 */   // Label 2986: @154960
     /* 154960 */   GIM_Try, /*On fail goto*//*Label 2987*/ GIMT_Encode4(155041), // Rule ID 1986 //
     /* 154965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 154973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 154976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 154979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 154982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 154998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 155002 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 155006 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155011 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 155015 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155019 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 155023 */     // MIs[2] Operand 1
     /* 155023 */     // No operand predicates
     /* 155023 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 155025 */     // (intrinsic_wo_chain:{ *:[v2f64] } 610:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 155025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i64_indexed),
     /* 155028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 155032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 155036 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 155039 */     GIR_RootConstrainSelectedInstOperands,
     /* 155040 */     // GIR_Coverage, 1986,
     /* 155040 */     GIR_EraseRootFromParent_Done,
     /* 155041 */   // Label 2987: @155041
     /* 155041 */   GIM_Try, /*On fail goto*//*Label 2988*/ GIMT_Encode4(155122), // Rule ID 1987 //
     /* 155046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 155049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 155054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 155057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 155060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 155063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 155075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 155079 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 155083 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 155087 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 155092 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 155096 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155100 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 155104 */     // MIs[2] Operand 1
     /* 155104 */     // No operand predicates
     /* 155104 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 155106 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 155106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 155109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155111 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 155113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 155117 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 155120 */     GIR_RootConstrainSelectedInstOperands,
     /* 155121 */     // GIR_Coverage, 1987,
     /* 155121 */     GIR_EraseRootFromParent_Done,
     /* 155122 */   // Label 2988: @155122
     /* 155122 */   GIM_Try, /*On fail goto*//*Label 2989*/ GIMT_Encode4(155203), // Rule ID 1988 //
     /* 155127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 155130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 155135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 155138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 155141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 155144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 155156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 155160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155164 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 155168 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 155177 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155181 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 155185 */     // MIs[2] Operand 1
     /* 155185 */     // No operand predicates
     /* 155185 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 155187 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 155187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 155190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 155194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 155198 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 155201 */     GIR_RootConstrainSelectedInstOperands,
     /* 155202 */     // GIR_Coverage, 1988,
     /* 155202 */     GIR_EraseRootFromParent_Done,
     /* 155203 */   // Label 2989: @155203
     /* 155203 */   GIM_Try, /*On fail goto*//*Label 2990*/ GIMT_Encode4(155284), // Rule ID 1989 //
     /* 155208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 155211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 155216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 155219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 155222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 155225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 155237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 155241 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 155245 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 155249 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155254 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 155258 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155262 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 155266 */     // MIs[2] Operand 1
     /* 155266 */     // No operand predicates
     /* 155266 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 155268 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 155268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 155271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155273 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 155275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 155279 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 155282 */     GIR_RootConstrainSelectedInstOperands,
     /* 155283 */     // GIR_Coverage, 1989,
     /* 155283 */     GIR_EraseRootFromParent_Done,
     /* 155284 */   // Label 2990: @155284
     /* 155284 */   GIM_Try, /*On fail goto*//*Label 2991*/ GIMT_Encode4(155365), // Rule ID 2016 //
     /* 155289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 155292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 155297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 155300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 155303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 155306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 155318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 155322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155326 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 155330 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155335 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 155339 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155343 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 155347 */     // MIs[2] Operand 1
     /* 155347 */     // No operand predicates
     /* 155347 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 155349 */     // (intrinsic_wo_chain:{ *:[i32] } 680:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 155349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv1i32_indexed),
     /* 155352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 155356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 155360 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 155363 */     GIR_RootConstrainSelectedInstOperands,
     /* 155364 */     // GIR_Coverage, 2016,
     /* 155364 */     GIR_EraseRootFromParent_Done,
     /* 155365 */   // Label 2991: @155365
     /* 155365 */   GIM_Try, /*On fail goto*//*Label 2992*/ GIMT_Encode4(155446), // Rule ID 2023 //
     /* 155370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 155373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 155378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 155381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 155384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 155387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 155399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 155403 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155407 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 155411 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155416 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 155420 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155424 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 155428 */     // MIs[2] Operand 1
     /* 155428 */     // No operand predicates
     /* 155428 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 155430 */     // (intrinsic_wo_chain:{ *:[i32] } 688:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 155430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv1i32_indexed),
     /* 155433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155435 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 155437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 155441 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 155444 */     GIR_RootConstrainSelectedInstOperands,
     /* 155445 */     // GIR_Coverage, 2023,
     /* 155445 */     GIR_EraseRootFromParent_Done,
     /* 155446 */   // Label 2992: @155446
     /* 155446 */   GIM_Try, /*On fail goto*//*Label 2993*/ GIMT_Encode4(155524), // Rule ID 6169 //
     /* 155451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 155456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 155459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 155462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 155465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 155477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 155481 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155485 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 155489 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155494 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 155498 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155502 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 155506 */     // MIs[2] Operand 1
     /* 155506 */     // No operand predicates
     /* 155506 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 155508 */     // (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Vm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULLv1i64_indexed:{ *:[i64] } FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Vm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 155508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv1i64_indexed),
     /* 155511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 155515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /* 155519 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 155522 */     GIR_RootConstrainSelectedInstOperands,
     /* 155523 */     // GIR_Coverage, 6169,
     /* 155523 */     GIR_EraseRootFromParent_Done,
     /* 155524 */   // Label 2993: @155524
     /* 155524 */   GIM_Try, /*On fail goto*//*Label 2994*/ GIMT_Encode4(155584), // Rule ID 6243 //
     /* 155529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 155534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 155537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 155540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 155543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155551 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
     /* 155555 */     // (intrinsic_wo_chain:{ *:[v8i8] } 657:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] })  =>  (RADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vn, (MOVIv2d_ns:{ *:[v8i16] } 0:{ *:[i32] }))
     /* 155555 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 155558 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 155562 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155567 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 155570 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 155572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v8i8),
     /* 155575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 155579 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155582 */     GIR_RootConstrainSelectedInstOperands,
     /* 155583 */     // GIR_Coverage, 6243,
     /* 155583 */     GIR_EraseRootFromParent_Done,
     /* 155584 */   // Label 2994: @155584
     /* 155584 */   GIM_Try, /*On fail goto*//*Label 2995*/ GIMT_Encode4(155644), // Rule ID 6244 //
     /* 155589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 155594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 155597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 155600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 155603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155611 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
     /* 155615 */     // (intrinsic_wo_chain:{ *:[v4i16] } 657:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] })  =>  (RADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn, (MOVIv2d_ns:{ *:[v4i32] } 0:{ *:[i32] }))
     /* 155615 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 155618 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 155622 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155627 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 155630 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 155632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v4i16),
     /* 155635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 155639 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155642 */     GIR_RootConstrainSelectedInstOperands,
     /* 155643 */     // GIR_Coverage, 6244,
     /* 155643 */     GIR_EraseRootFromParent_Done,
     /* 155644 */   // Label 2995: @155644
     /* 155644 */   GIM_Try, /*On fail goto*//*Label 2996*/ GIMT_Encode4(155704), // Rule ID 6245 //
     /* 155649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 155654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 155657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 155660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 155663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155671 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 32,
     /* 155675 */     // (intrinsic_wo_chain:{ *:[v2i32] } 657:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] })  =>  (RADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn, (MOVIv2d_ns:{ *:[v2i64] } 0:{ *:[i32] }))
     /* 155675 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 155678 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 155682 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155687 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 155690 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 155692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v2i32),
     /* 155695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 155699 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155702 */     GIR_RootConstrainSelectedInstOperands,
     /* 155703 */     // GIR_Coverage, 6245,
     /* 155703 */     GIR_EraseRootFromParent_Done,
     /* 155704 */   // Label 2996: @155704
     /* 155704 */   GIM_Try, /*On fail goto*//*Label 2997*/ GIMT_Encode4(155751), // Rule ID 3839 //
     /* 155709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 155712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 155717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 155720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 155723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155731 */     // MIs[0] Operand 3
     /* 155731 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 155742 */     // (intrinsic_wo_chain:{ *:[i64] } 298:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] })  =>  (XPACI:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 155742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACI),
     /* 155745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 155749 */     GIR_RootConstrainSelectedInstOperands,
     /* 155750 */     // GIR_Coverage, 3839,
     /* 155750 */     GIR_EraseRootFromParent_Done,
     /* 155751 */   // Label 2997: @155751
     /* 155751 */   GIM_Try, /*On fail goto*//*Label 2998*/ GIMT_Encode4(155798), // Rule ID 3840 //
     /* 155756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 155759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 155764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 155767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 155770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155778 */     // MIs[0] Operand 3
     /* 155778 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 155789 */     // (intrinsic_wo_chain:{ *:[i64] } 298:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] })  =>  (XPACI:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 155789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACI),
     /* 155792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155794 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 155796 */     GIR_RootConstrainSelectedInstOperands,
     /* 155797 */     // GIR_Coverage, 3840,
     /* 155797 */     GIR_EraseRootFromParent_Done,
     /* 155798 */   // Label 2998: @155798
     /* 155798 */   GIM_Try, /*On fail goto*//*Label 2999*/ GIMT_Encode4(155845), // Rule ID 3841 //
     /* 155803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 155806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 155811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 155814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 155817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155825 */     // MIs[0] Operand 3
     /* 155825 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 155836 */     // (intrinsic_wo_chain:{ *:[i64] } 298:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] })  =>  (XPACD:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 155836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACD),
     /* 155839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 155843 */     GIR_RootConstrainSelectedInstOperands,
     /* 155844 */     // GIR_Coverage, 3841,
     /* 155844 */     GIR_EraseRootFromParent_Done,
     /* 155845 */   // Label 2999: @155845
     /* 155845 */   GIM_Try, /*On fail goto*//*Label 3000*/ GIMT_Encode4(155892), // Rule ID 3842 //
     /* 155850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 155853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 155858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 155861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 155864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155872 */     // MIs[0] Operand 3
     /* 155872 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 155883 */     // (intrinsic_wo_chain:{ *:[i64] } 298:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] })  =>  (XPACD:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 155883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACD),
     /* 155886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 155890 */     GIR_RootConstrainSelectedInstOperands,
     /* 155891 */     // GIR_Coverage, 3842,
     /* 155891 */     GIR_EraseRootFromParent_Done,
     /* 155892 */   // Label 3000: @155892
     /* 155892 */   GIM_Try, /*On fail goto*//*Label 3001*/ GIMT_Encode4(155938), // Rule ID 3524 //
     /* 155897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 155900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 155905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 155908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 155911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 155915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 155919 */     // MIs[0] Idx
     /* 155919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 155922 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_0),
     /* 155927 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1532:{ *:[iPTR] }, ZPRAny:{ *:[nxv16i8] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_0>>:$Idx)  =>  (PMOV_PZI_B:{ *:[nxv16i1] } ZPRAny:{ *:[nxv16i8] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_0>>:$Idx)
     /* 155927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_B),
     /* 155930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 155932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 155934 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 155936 */     GIR_RootConstrainSelectedInstOperands,
     /* 155937 */     // GIR_Coverage, 3524,
     /* 155937 */     GIR_EraseRootFromParent_Done,
     /* 155938 */   // Label 3001: @155938
     /* 155938 */   GIM_Try, /*On fail goto*//*Label 3002*/ GIMT_Encode4(155984), // Rule ID 3525 //
     /* 155943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 155946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 155951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 155954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 155957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 155961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 155965 */     // MIs[0] Idx
     /* 155965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 155968 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 155973 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1532:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Idx)  =>  (PMOV_PZI_H:{ *:[nxv8i1] } ZPRAny:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Idx)
     /* 155973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_H),
     /* 155976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 155978 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 155980 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 155982 */     GIR_RootConstrainSelectedInstOperands,
     /* 155983 */     // GIR_Coverage, 3525,
     /* 155983 */     GIR_EraseRootFromParent_Done,
     /* 155984 */   // Label 3002: @155984
     /* 155984 */   GIM_Try, /*On fail goto*//*Label 3003*/ GIMT_Encode4(156030), // Rule ID 3526 //
     /* 155989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 155992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 155997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 156000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 156003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 156007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 156011 */     // MIs[0] Idx
     /* 156011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 156014 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 156019 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1532:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Idx)  =>  (PMOV_PZI_S:{ *:[nxv4i1] } ZPRAny:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Idx)
     /* 156019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_S),
     /* 156022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 156024 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 156026 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 156028 */     GIR_RootConstrainSelectedInstOperands,
     /* 156029 */     // GIR_Coverage, 3526,
     /* 156029 */     GIR_EraseRootFromParent_Done,
     /* 156030 */   // Label 3003: @156030
     /* 156030 */   GIM_Try, /*On fail goto*//*Label 3004*/ GIMT_Encode4(156076), // Rule ID 3527 //
     /* 156035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 156038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 156043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 156046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 156049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 156053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 156057 */     // MIs[0] Idx
     /* 156057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 156060 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 156065 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1532:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Idx)  =>  (PMOV_PZI_D:{ *:[nxv2i1] } ZPRAny:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Idx)
     /* 156065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_D),
     /* 156068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 156070 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 156072 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 156074 */     GIR_RootConstrainSelectedInstOperands,
     /* 156075 */     // GIR_Coverage, 3527,
     /* 156075 */     GIR_EraseRootFromParent_Done,
     /* 156076 */   // Label 3004: @156076
     /* 156076 */   GIM_Try, /*On fail goto*//*Label 3005*/ GIMT_Encode4(156132), // Rule ID 2101 //
     /* 156081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshrn),
     /* 156089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 156092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 156095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 156098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156114 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 156118 */     // MIs[1] Operand 1
     /* 156118 */     // No operand predicates
     /* 156118 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156120 */     // (intrinsic_wo_chain:{ *:[i32] } 692:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQRSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 156120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNs),
     /* 156123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 156127 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 156130 */     GIR_RootConstrainSelectedInstOperands,
     /* 156131 */     // GIR_Coverage, 2101,
     /* 156131 */     GIR_EraseRootFromParent_Done,
     /* 156132 */   // Label 3005: @156132
     /* 156132 */   GIM_Try, /*On fail goto*//*Label 3006*/ GIMT_Encode4(156188), // Rule ID 2102 //
     /* 156137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshrun),
     /* 156145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 156148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 156151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 156154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156170 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 156174 */     // MIs[1] Operand 1
     /* 156174 */     // No operand predicates
     /* 156174 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156176 */     // (intrinsic_wo_chain:{ *:[i32] } 693:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQRSHRUNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 156176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNs),
     /* 156179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 156183 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 156186 */     GIR_RootConstrainSelectedInstOperands,
     /* 156187 */     // GIR_Coverage, 2102,
     /* 156187 */     GIR_EraseRootFromParent_Done,
     /* 156188 */   // Label 3006: @156188
     /* 156188 */   GIM_Try, /*On fail goto*//*Label 3007*/ GIMT_Encode4(156244), // Rule ID 2107 //
     /* 156193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshrn),
     /* 156201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 156204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 156207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 156210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156226 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 156230 */     // MIs[1] Operand 1
     /* 156230 */     // No operand predicates
     /* 156230 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156232 */     // (intrinsic_wo_chain:{ *:[i32] } 696:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 156232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNs),
     /* 156235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 156239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 156242 */     GIR_RootConstrainSelectedInstOperands,
     /* 156243 */     // GIR_Coverage, 2107,
     /* 156243 */     GIR_EraseRootFromParent_Done,
     /* 156244 */   // Label 3007: @156244
     /* 156244 */   GIM_Try, /*On fail goto*//*Label 3008*/ GIMT_Encode4(156300), // Rule ID 2108 //
     /* 156249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshrun),
     /* 156257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 156260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 156263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 156266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156282 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 156286 */     // MIs[1] Operand 1
     /* 156286 */     // No operand predicates
     /* 156286 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156288 */     // (intrinsic_wo_chain:{ *:[i32] } 697:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQSHRUNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 156288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNs),
     /* 156291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 156295 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 156298 */     GIR_RootConstrainSelectedInstOperands,
     /* 156299 */     // GIR_Coverage, 2108,
     /* 156299 */     GIR_EraseRootFromParent_Done,
     /* 156300 */   // Label 3008: @156300
     /* 156300 */   GIM_Try, /*On fail goto*//*Label 3009*/ GIMT_Encode4(156356), // Rule ID 2114 //
     /* 156305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshrn),
     /* 156313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 156316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 156319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 156322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156338 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 156342 */     // MIs[1] Operand 1
     /* 156342 */     // No operand predicates
     /* 156342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156344 */     // (intrinsic_wo_chain:{ *:[i32] } 741:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UQRSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 156344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNs),
     /* 156347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 156351 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 156354 */     GIR_RootConstrainSelectedInstOperands,
     /* 156355 */     // GIR_Coverage, 2114,
     /* 156355 */     GIR_EraseRootFromParent_Done,
     /* 156356 */   // Label 3009: @156356
     /* 156356 */   GIM_Try, /*On fail goto*//*Label 3010*/ GIMT_Encode4(156412), // Rule ID 2117 //
     /* 156361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshrn),
     /* 156369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 156372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 156375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 156378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156394 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 156398 */     // MIs[1] Operand 1
     /* 156398 */     // No operand predicates
     /* 156398 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156400 */     // (intrinsic_wo_chain:{ *:[i32] } 743:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UQSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 156400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNs),
     /* 156403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 156407 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 156410 */     GIR_RootConstrainSelectedInstOperands,
     /* 156411 */     // GIR_Coverage, 2117,
     /* 156411 */     GIR_EraseRootFromParent_Done,
     /* 156412 */   // Label 3010: @156412
     /* 156412 */   GIM_Try, /*On fail goto*//*Label 3011*/ GIMT_Encode4(156468), // Rule ID 2139 //
     /* 156417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 156425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 156428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 156431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 156434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156450 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 156454 */     // MIs[1] Operand 1
     /* 156454 */     // No operand predicates
     /* 156454 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156456 */     // (intrinsic_wo_chain:{ *:[v8i8] } 657:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)  =>  (RSHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 156456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv8i8_shift),
     /* 156459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 156463 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 156466 */     GIR_RootConstrainSelectedInstOperands,
     /* 156467 */     // GIR_Coverage, 2139,
     /* 156467 */     GIR_EraseRootFromParent_Done,
     /* 156468 */   // Label 3011: @156468
     /* 156468 */   GIM_Try, /*On fail goto*//*Label 3012*/ GIMT_Encode4(156524), // Rule ID 2141 //
     /* 156473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 156481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 156484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 156487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 156490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156506 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 156510 */     // MIs[1] Operand 1
     /* 156510 */     // No operand predicates
     /* 156510 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156512 */     // (intrinsic_wo_chain:{ *:[v4i16] } 657:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)  =>  (RSHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 156512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv4i16_shift),
     /* 156515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 156519 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 156522 */     GIR_RootConstrainSelectedInstOperands,
     /* 156523 */     // GIR_Coverage, 2141,
     /* 156523 */     GIR_EraseRootFromParent_Done,
     /* 156524 */   // Label 3012: @156524
     /* 156524 */   GIM_Try, /*On fail goto*//*Label 3013*/ GIMT_Encode4(156580), // Rule ID 2143 //
     /* 156529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 156537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 156540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 156543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 156546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156562 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 156566 */     // MIs[1] Operand 1
     /* 156566 */     // No operand predicates
     /* 156566 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156568 */     // (intrinsic_wo_chain:{ *:[v2i32] } 657:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)  =>  (RSHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 156568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv2i32_shift),
     /* 156571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 156575 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 156578 */     GIR_RootConstrainSelectedInstOperands,
     /* 156579 */     // GIR_Coverage, 2143,
     /* 156579 */     GIR_EraseRootFromParent_Done,
     /* 156580 */   // Label 3013: @156580
     /* 156580 */   GIM_Try, /*On fail goto*//*Label 3014*/ GIMT_Encode4(156633), // Rule ID 6170 //
     /* 156585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 156590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 156593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 156596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 156599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156615 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 156619 */     // MIs[1] Operand 1
     /* 156619 */     // No operand predicates
     /* 156619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156621 */     // (intrinsic_wo_chain:{ *:[i32] } 762:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (FCVTZSs:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 156621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSs),
     /* 156624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156626 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 156628 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 156631 */     GIR_RootConstrainSelectedInstOperands,
     /* 156632 */     // GIR_Coverage, 6170,
     /* 156632 */     GIR_EraseRootFromParent_Done,
     /* 156633 */   // Label 3014: @156633
     /* 156633 */   GIM_Try, /*On fail goto*//*Label 3015*/ GIMT_Encode4(156686), // Rule ID 6171 //
     /* 156638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 156643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 156646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 156649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 156652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156668 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 156672 */     // MIs[1] Operand 1
     /* 156672 */     // No operand predicates
     /* 156672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156674 */     // (intrinsic_wo_chain:{ *:[i32] } 763:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (FCVTZUs:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 156674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUs),
     /* 156677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 156681 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 156684 */     GIR_RootConstrainSelectedInstOperands,
     /* 156685 */     // GIR_Coverage, 6171,
     /* 156685 */     GIR_EraseRootFromParent_Done,
     /* 156686 */   // Label 3015: @156686
     /* 156686 */   GIM_Try, /*On fail goto*//*Label 3016*/ GIMT_Encode4(156739), // Rule ID 6172 //
     /* 156691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 156696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 156699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 156702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 156705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156721 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 156725 */     // MIs[1] Operand 1
     /* 156725 */     // No operand predicates
     /* 156725 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156727 */     // (intrinsic_wo_chain:{ *:[i64] } 762:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZSd:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 156727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSd),
     /* 156730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 156734 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 156737 */     GIR_RootConstrainSelectedInstOperands,
     /* 156738 */     // GIR_Coverage, 6172,
     /* 156738 */     GIR_EraseRootFromParent_Done,
     /* 156739 */   // Label 3016: @156739
     /* 156739 */   GIM_Try, /*On fail goto*//*Label 3017*/ GIMT_Encode4(156792), // Rule ID 6173 //
     /* 156744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 156749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 156752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 156755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 156758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156774 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 156778 */     // MIs[1] Operand 1
     /* 156778 */     // No operand predicates
     /* 156778 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156780 */     // (intrinsic_wo_chain:{ *:[i64] } 763:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZUd:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 156780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUd),
     /* 156783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156785 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 156787 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 156790 */     GIR_RootConstrainSelectedInstOperands,
     /* 156791 */     // GIR_Coverage, 6173,
     /* 156791 */     GIR_EraseRootFromParent_Done,
     /* 156792 */   // Label 3017: @156792
     /* 156792 */   GIM_Try, /*On fail goto*//*Label 3018*/ GIMT_Encode4(156845), // Rule ID 6174 //
     /* 156797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 156802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 156805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 156808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 156811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156827 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 156831 */     // MIs[1] Operand 1
     /* 156831 */     // No operand predicates
     /* 156831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156833 */     // (intrinsic_wo_chain:{ *:[v1i64] } 762:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZSd:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 156833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSd),
     /* 156836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 156840 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 156843 */     GIR_RootConstrainSelectedInstOperands,
     /* 156844 */     // GIR_Coverage, 6174,
     /* 156844 */     GIR_EraseRootFromParent_Done,
     /* 156845 */   // Label 3018: @156845
     /* 156845 */   GIM_Try, /*On fail goto*//*Label 3019*/ GIMT_Encode4(156898), // Rule ID 6175 //
     /* 156850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 156855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 156858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 156861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 156864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156880 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 156884 */     // MIs[1] Operand 1
     /* 156884 */     // No operand predicates
     /* 156884 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156886 */     // (intrinsic_wo_chain:{ *:[v1i64] } 763:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZUd:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 156886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUd),
     /* 156889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 156893 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 156896 */     GIR_RootConstrainSelectedInstOperands,
     /* 156897 */     // GIR_Coverage, 6175,
     /* 156897 */     GIR_EraseRootFromParent_Done,
     /* 156898 */   // Label 3019: @156898
     /* 156898 */   GIM_Try, /*On fail goto*//*Label 3020*/ GIMT_Encode4(156951), // Rule ID 6176 //
     /* 156903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 156908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 156911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 156914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 156917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156933 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 156937 */     // MIs[1] Operand 1
     /* 156937 */     // No operand predicates
     /* 156937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156939 */     // (intrinsic_wo_chain:{ *:[f32] } 766:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UCVTFs:{ *:[f32] } FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 156939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFs),
     /* 156942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 156946 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 156949 */     GIR_RootConstrainSelectedInstOperands,
     /* 156950 */     // GIR_Coverage, 6176,
     /* 156950 */     GIR_EraseRootFromParent_Done,
     /* 156951 */   // Label 3020: @156951
     /* 156951 */   GIM_Try, /*On fail goto*//*Label 3021*/ GIMT_Encode4(157004), // Rule ID 6177 //
     /* 156956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 156961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 156964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 156967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 156970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156986 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 156990 */     // MIs[1] Operand 1
     /* 156990 */     // No operand predicates
     /* 156990 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156992 */     // (intrinsic_wo_chain:{ *:[f64] } 766:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (UCVTFd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 156992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFd),
     /* 156995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 156999 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 157002 */     GIR_RootConstrainSelectedInstOperands,
     /* 157003 */     // GIR_Coverage, 6177,
     /* 157003 */     GIR_EraseRootFromParent_Done,
     /* 157004 */   // Label 3021: @157004
     /* 157004 */   GIM_Try, /*On fail goto*//*Label 3022*/ GIMT_Encode4(157057), // Rule ID 6178 //
     /* 157009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 157014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 157017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 157020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 157023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157039 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 157043 */     // MIs[1] Operand 1
     /* 157043 */     // No operand predicates
     /* 157043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157045 */     // (intrinsic_wo_chain:{ *:[v1f64] } 765:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SCVTFd:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 157045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFd),
     /* 157048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 157052 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 157055 */     GIR_RootConstrainSelectedInstOperands,
     /* 157056 */     // GIR_Coverage, 6178,
     /* 157056 */     GIR_EraseRootFromParent_Done,
     /* 157057 */   // Label 3022: @157057
     /* 157057 */   GIM_Try, /*On fail goto*//*Label 3023*/ GIMT_Encode4(157110), // Rule ID 6179 //
     /* 157062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 157067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 157070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 157073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 157076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157092 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 157096 */     // MIs[1] Operand 1
     /* 157096 */     // No operand predicates
     /* 157096 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157098 */     // (intrinsic_wo_chain:{ *:[f64] } 765:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SCVTFd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 157098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFd),
     /* 157101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 157105 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 157108 */     GIR_RootConstrainSelectedInstOperands,
     /* 157109 */     // GIR_Coverage, 6179,
     /* 157109 */     GIR_EraseRootFromParent_Done,
     /* 157110 */   // Label 3023: @157110
     /* 157110 */   GIM_Try, /*On fail goto*//*Label 3024*/ GIMT_Encode4(157163), // Rule ID 6180 //
     /* 157115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 157120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 157123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 157126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 157129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157145 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 157149 */     // MIs[1] Operand 1
     /* 157149 */     // No operand predicates
     /* 157149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157151 */     // (intrinsic_wo_chain:{ *:[v1f64] } 766:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (UCVTFd:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 157151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFd),
     /* 157154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 157158 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 157161 */     GIR_RootConstrainSelectedInstOperands,
     /* 157162 */     // GIR_Coverage, 6180,
     /* 157162 */     GIR_EraseRootFromParent_Done,
     /* 157163 */   // Label 3024: @157163
     /* 157163 */   GIM_Try, /*On fail goto*//*Label 3025*/ GIMT_Encode4(157216), // Rule ID 6181 //
     /* 157168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 157173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 157176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 157179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 157182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157198 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 157202 */     // MIs[1] Operand 1
     /* 157202 */     // No operand predicates
     /* 157202 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157204 */     // (intrinsic_wo_chain:{ *:[f32] } 765:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SCVTFs:{ *:[f32] } FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 157204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFs),
     /* 157207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 157211 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 157214 */     GIR_RootConstrainSelectedInstOperands,
     /* 157215 */     // GIR_Coverage, 6181,
     /* 157215 */     GIR_EraseRootFromParent_Done,
     /* 157216 */   // Label 3025: @157216
     /* 157216 */   GIM_Try, /*On fail goto*//*Label 3026*/ GIMT_Encode4(157298), // Rule ID 6183 //
     /* 157221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 157226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 157229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 157232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 157235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157251 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 157255 */     // MIs[1] Operand 1
     /* 157255 */     // No operand predicates
     /* 157255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157257 */     // (intrinsic_wo_chain:{ *:[f16] } 765:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 157257 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 157260 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157264 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157269 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 157275 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157280 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
     /* 157288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157290 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157293 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 157296 */     GIR_RootConstrainSelectedInstOperands,
     /* 157297 */     // GIR_Coverage, 6183,
     /* 157297 */     GIR_EraseRootFromParent_Done,
     /* 157298 */   // Label 3026: @157298
     /* 157298 */   GIM_Try, /*On fail goto*//*Label 3027*/ GIMT_Encode4(157380), // Rule ID 6184 //
     /* 157303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 157308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 157311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 157314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 157317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157333 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 157337 */     // MIs[1] Operand 1
     /* 157337 */     // No operand predicates
     /* 157337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157339 */     // (intrinsic_wo_chain:{ *:[f16] } 765:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 157339 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 157342 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157346 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157351 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 157357 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157362 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
     /* 157370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157372 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157375 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 157378 */     GIR_RootConstrainSelectedInstOperands,
     /* 157379 */     // GIR_Coverage, 6184,
     /* 157379 */     GIR_EraseRootFromParent_Done,
     /* 157380 */   // Label 3027: @157380
     /* 157380 */   GIM_Try, /*On fail goto*//*Label 3028*/ GIMT_Encode4(157462), // Rule ID 6186 //
     /* 157385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 157390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 157393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 157396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 157399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157415 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 157419 */     // MIs[1] Operand 1
     /* 157419 */     // No operand predicates
     /* 157419 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157421 */     // (intrinsic_wo_chain:{ *:[f16] } 766:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 157421 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 157424 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157428 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157433 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 157439 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157444 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
     /* 157452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157454 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157457 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 157460 */     GIR_RootConstrainSelectedInstOperands,
     /* 157461 */     // GIR_Coverage, 6186,
     /* 157461 */     GIR_EraseRootFromParent_Done,
     /* 157462 */   // Label 3028: @157462
     /* 157462 */   GIM_Try, /*On fail goto*//*Label 3029*/ GIMT_Encode4(157544), // Rule ID 6187 //
     /* 157467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 157472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 157475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 157478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 157481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157497 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 157501 */     // MIs[1] Operand 1
     /* 157501 */     // No operand predicates
     /* 157501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157503 */     // (intrinsic_wo_chain:{ *:[f16] } 766:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 157503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 157506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157515 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 157521 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157526 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
     /* 157534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157536 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 157542 */     GIR_RootConstrainSelectedInstOperands,
     /* 157543 */     // GIR_Coverage, 6187,
     /* 157543 */     GIR_EraseRootFromParent_Done,
     /* 157544 */   // Label 3029: @157544
     /* 157544 */   GIM_Try, /*On fail goto*//*Label 3030*/ GIMT_Encode4(157650), // Rule ID 6188 //
     /* 157549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 157554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 157557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 157560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 157563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157579 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 157583 */     // MIs[1] Operand 1
     /* 157583 */     // No operand predicates
     /* 157583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157585 */     // (intrinsic_wo_chain:{ *:[i32] } 762:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FCVTZSh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), hsub:{ *:[i32] })
     /* 157585 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 157588 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSh),
     /* 157592 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157597 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 157601 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 157604 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 157606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 157609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 157613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157618 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 157620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 157623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157625 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157628 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 157631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 157634 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157639 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157644 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157649 */     // GIR_Coverage, 6188,
     /* 157649 */     GIR_EraseRootFromParent_Done,
     /* 157650 */   // Label 3030: @157650
     /* 157650 */   GIM_Try, /*On fail goto*//*Label 3031*/ GIMT_Encode4(157756), // Rule ID 6189 //
     /* 157655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 157660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 157663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 157666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 157669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157685 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 157689 */     // MIs[1] Operand 1
     /* 157689 */     // No operand predicates
     /* 157689 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157691 */     // (intrinsic_wo_chain:{ *:[i64] } 762:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (FCVTZSh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), hsub:{ *:[i32] })
     /* 157691 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 157694 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSh),
     /* 157698 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157703 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 157707 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 157710 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 157712 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 157715 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 157719 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157724 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 157726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 157729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157731 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 157737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 157740 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157745 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157750 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157755 */     // GIR_Coverage, 6189,
     /* 157755 */     GIR_EraseRootFromParent_Done,
     /* 157756 */   // Label 3031: @157756
     /* 157756 */   GIM_Try, /*On fail goto*//*Label 3032*/ GIMT_Encode4(157862), // Rule ID 6190 //
     /* 157761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 157766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 157769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 157772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 157775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157791 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 157795 */     // MIs[1] Operand 1
     /* 157795 */     // No operand predicates
     /* 157795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157797 */     // (intrinsic_wo_chain:{ *:[i32] } 763:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FCVTZUh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), hsub:{ *:[i32] })
     /* 157797 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 157800 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUh),
     /* 157804 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157809 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 157813 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 157816 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 157818 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 157821 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 157825 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157830 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 157832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 157835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157837 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157840 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 157843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 157846 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157851 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157856 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157861 */     // GIR_Coverage, 6190,
     /* 157861 */     GIR_EraseRootFromParent_Done,
     /* 157862 */   // Label 3032: @157862
     /* 157862 */   GIM_Try, /*On fail goto*//*Label 3033*/ GIMT_Encode4(157968), // Rule ID 6191 //
     /* 157867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 157872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 157875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 157878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 157881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157897 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 157901 */     // MIs[1] Operand 1
     /* 157901 */     // No operand predicates
     /* 157901 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157903 */     // (intrinsic_wo_chain:{ *:[i64] } 763:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (FCVTZUh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), hsub:{ *:[i32] })
     /* 157903 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 157906 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUh),
     /* 157910 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157915 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 157919 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 157922 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 157924 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 157927 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 157931 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157936 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 157938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 157941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157943 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157946 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 157949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 157952 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157957 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157962 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157967 */     // GIR_Coverage, 6191,
     /* 157967 */     GIR_EraseRootFromParent_Done,
     /* 157968 */   // Label 3033: @157968
     /* 157968 */   GIM_Try, /*On fail goto*//*Label 3034*/ GIMT_Encode4(158023), // Rule ID 6888 //
     /* 157973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_blend),
     /* 157978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 157981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 157984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 157987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 157991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 157995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 158003 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64_0_65535),
     /* 158007 */     // MIs[1] Operand 1
     /* 158007 */     // No operand predicates
     /* 158007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158009 */     // (intrinsic_wo_chain:{ *:[i64] } 294:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_imm64_0_65535>>:$imm)  =>  (PAUTH_BLEND:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm64_0_65535>>:$imm))
     /* 158009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PAUTH_BLEND),
     /* 158012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[disc]
     /* 158014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 158016 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // imm
     /* 158021 */     GIR_RootConstrainSelectedInstOperands,
     /* 158022 */     // GIR_Coverage, 6888,
     /* 158022 */     GIR_EraseRootFromParent_Done,
     /* 158023 */   // Label 3034: @158023
     /* 158023 */   GIM_Try, /*On fail goto*//*Label 3035*/ GIMT_Encode4(158065), // Rule ID 3031 //
     /* 158028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 158031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
     /* 158036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 158039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 158042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 158046 */     // MIs[0] Op2
     /* 158046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 158049 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 158054 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1770:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (SSHLLB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 158054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_H),
     /* 158057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 158059 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 158061 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 158063 */     GIR_RootConstrainSelectedInstOperands,
     /* 158064 */     // GIR_Coverage, 3031,
     /* 158064 */     GIR_EraseRootFromParent_Done,
     /* 158065 */   // Label 3035: @158065
     /* 158065 */   GIM_Try, /*On fail goto*//*Label 3036*/ GIMT_Encode4(158107), // Rule ID 3032 //
     /* 158070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 158073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
     /* 158078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 158081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 158084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 158088 */     // MIs[0] Op2
     /* 158088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 158091 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 158096 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1770:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (SSHLLB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 158096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_S),
     /* 158099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 158101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 158103 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 158105 */     GIR_RootConstrainSelectedInstOperands,
     /* 158106 */     // GIR_Coverage, 3032,
     /* 158106 */     GIR_EraseRootFromParent_Done,
     /* 158107 */   // Label 3036: @158107
     /* 158107 */   GIM_Try, /*On fail goto*//*Label 3037*/ GIMT_Encode4(158149), // Rule ID 3033 //
     /* 158112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 158115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
     /* 158120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 158123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 158126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 158130 */     // MIs[0] Op2
     /* 158130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 158133 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 158138 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1770:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (SSHLLB_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 158138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_D),
     /* 158141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 158143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 158145 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 158147 */     GIR_RootConstrainSelectedInstOperands,
     /* 158148 */     // GIR_Coverage, 3033,
     /* 158148 */     GIR_EraseRootFromParent_Done,
     /* 158149 */   // Label 3037: @158149
     /* 158149 */   GIM_Try, /*On fail goto*//*Label 3038*/ GIMT_Encode4(158191), // Rule ID 3067 //
     /* 158154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 158157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
     /* 158162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 158165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 158168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 158172 */     // MIs[0] Op2
     /* 158172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 158175 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 158180 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1751:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQSHRUNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 158180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_B),
     /* 158183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 158185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 158187 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 158189 */     GIR_RootConstrainSelectedInstOperands,
     /* 158190 */     // GIR_Coverage, 3067,
     /* 158190 */     GIR_EraseRootFromParent_Done,
     /* 158191 */   // Label 3038: @158191
     /* 158191 */   GIM_Try, /*On fail goto*//*Label 3039*/ GIMT_Encode4(158233), // Rule ID 3068 //
     /* 158196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 158199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
     /* 158204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 158207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 158210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 158214 */     // MIs[0] Op2
     /* 158214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 158217 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 158222 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1751:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQSHRUNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 158222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_H),
     /* 158225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 158227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 158229 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 158231 */     GIR_RootConstrainSelectedInstOperands,
     /* 158232 */     // GIR_Coverage, 3068,
     /* 158232 */     GIR_EraseRootFromParent_Done,
     /* 158233 */   // Label 3039: @158233
     /* 158233 */   GIM_Try, /*On fail goto*//*Label 3040*/ GIMT_Encode4(158275), // Rule ID 3069 //
     /* 158238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 158241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
     /* 158246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 158249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 158252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 158256 */     // MIs[0] Op2
     /* 158256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 158259 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 158264 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1751:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQSHRUNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 158264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_S),
     /* 158267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 158269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 158271 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 158273 */     GIR_RootConstrainSelectedInstOperands,
     /* 158274 */     // GIR_Coverage, 3069,
     /* 158274 */     GIR_EraseRootFromParent_Done,
     /* 158275 */   // Label 3040: @158275
     /* 158275 */   GIM_Try, /*On fail goto*//*Label 3041*/ GIMT_Encode4(158317), // Rule ID 3510 //
     /* 158280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 158283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 158288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 158291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 158294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 158298 */     // MIs[0] Op2
     /* 158298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 158301 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 158306 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1251:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Op2)  =>  (DUPQ_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Op2)
     /* 158306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_B),
     /* 158309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 158311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 158313 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 158315 */     GIR_RootConstrainSelectedInstOperands,
     /* 158316 */     // GIR_Coverage, 3510,
     /* 158316 */     GIR_EraseRootFromParent_Done,
     /* 158317 */   // Label 3041: @158317
     /* 158317 */   GIM_Try, /*On fail goto*//*Label 3042*/ GIMT_Encode4(158359), // Rule ID 3511 //
     /* 158322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 158325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 158330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 158333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 158336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 158340 */     // MIs[0] Op2
     /* 158340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 158343 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 158348 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1251:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)  =>  (DUPQ_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)
     /* 158348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_H),
     /* 158351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 158353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 158355 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 158357 */     GIR_RootConstrainSelectedInstOperands,
     /* 158358 */     // GIR_Coverage, 3511,
     /* 158358 */     GIR_EraseRootFromParent_Done,
     /* 158359 */   // Label 3042: @158359
     /* 158359 */   GIM_Try, /*On fail goto*//*Label 3043*/ GIMT_Encode4(158401), // Rule ID 3512 //
     /* 158364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 158367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 158372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 158375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 158378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 158382 */     // MIs[0] Op2
     /* 158382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 158385 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 158390 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1251:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)  =>  (DUPQ_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)
     /* 158390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_S),
     /* 158393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 158395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 158397 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 158399 */     GIR_RootConstrainSelectedInstOperands,
     /* 158400 */     // GIR_Coverage, 3512,
     /* 158400 */     GIR_EraseRootFromParent_Done,
     /* 158401 */   // Label 3043: @158401
     /* 158401 */   GIM_Try, /*On fail goto*//*Label 3044*/ GIMT_Encode4(158443), // Rule ID 3513 //
     /* 158406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 158409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 158414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 158417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 158420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 158424 */     // MIs[0] Op2
     /* 158424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 158427 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 158432 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1251:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)  =>  (DUPQ_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)
     /* 158432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_D),
     /* 158435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 158437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 158439 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 158441 */     GIR_RootConstrainSelectedInstOperands,
     /* 158442 */     // GIR_Coverage, 3513,
     /* 158442 */     GIR_EraseRootFromParent_Done,
     /* 158443 */   // Label 3044: @158443
     /* 158443 */   GIM_Try, /*On fail goto*//*Label 3045*/ GIMT_Encode4(158485), // Rule ID 3514 //
     /* 158448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 158451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 158456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 158459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 158462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 158466 */     // MIs[0] Op2
     /* 158466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 158469 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 158474 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1251:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)  =>  (DUPQ_ZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)
     /* 158474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_H),
     /* 158477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 158479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 158481 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 158483 */     GIR_RootConstrainSelectedInstOperands,
     /* 158484 */     // GIR_Coverage, 3514,
     /* 158484 */     GIR_EraseRootFromParent_Done,
     /* 158485 */   // Label 3045: @158485
     /* 158485 */   GIM_Try, /*On fail goto*//*Label 3046*/ GIMT_Encode4(158527), // Rule ID 3515 //
     /* 158490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 158493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 158498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 158501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 158504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 158508 */     // MIs[0] Op2
     /* 158508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 158511 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 158516 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1251:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)  =>  (DUPQ_ZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)
     /* 158516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_S),
     /* 158519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 158521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 158523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 158525 */     GIR_RootConstrainSelectedInstOperands,
     /* 158526 */     // GIR_Coverage, 3515,
     /* 158526 */     GIR_EraseRootFromParent_Done,
     /* 158527 */   // Label 3046: @158527
     /* 158527 */   GIM_Try, /*On fail goto*//*Label 3047*/ GIMT_Encode4(158569), // Rule ID 3516 //
     /* 158532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 158535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 158540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 158543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 158546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 158550 */     // MIs[0] Op2
     /* 158550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 158553 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 158558 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1251:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)  =>  (DUPQ_ZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)
     /* 158558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_D),
     /* 158561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 158563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 158565 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 158567 */     GIR_RootConstrainSelectedInstOperands,
     /* 158568 */     // GIR_Coverage, 3516,
     /* 158568 */     GIR_EraseRootFromParent_Done,
     /* 158569 */   // Label 3047: @158569
     /* 158569 */   GIM_Try, /*On fail goto*//*Label 3048*/ GIMT_Encode4(158611), // Rule ID 11549 //
     /* 158574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 158577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
     /* 158582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 158585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 158588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 158592 */     // MIs[0] Op2
     /* 158592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 158595 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 158600 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1745:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQRSHRUNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 158600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_B),
     /* 158603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 158605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 158607 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 158609 */     GIR_RootConstrainSelectedInstOperands,
     /* 158610 */     // GIR_Coverage, 11549,
     /* 158610 */     GIR_EraseRootFromParent_Done,
     /* 158611 */   // Label 3048: @158611
     /* 158611 */   GIM_Try, /*On fail goto*//*Label 3049*/ GIMT_Encode4(158653), // Rule ID 11550 //
     /* 158616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 158619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
     /* 158624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 158627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 158630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 158634 */     // MIs[0] Op2
     /* 158634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 158637 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 158642 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1745:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQRSHRUNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 158642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_H),
     /* 158645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 158647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 158649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 158651 */     GIR_RootConstrainSelectedInstOperands,
     /* 158652 */     // GIR_Coverage, 11550,
     /* 158652 */     GIR_EraseRootFromParent_Done,
     /* 158653 */   // Label 3049: @158653
     /* 158653 */   GIM_Try, /*On fail goto*//*Label 3050*/ GIMT_Encode4(158695), // Rule ID 11551 //
     /* 158658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 158661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
     /* 158666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 158669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 158672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 158676 */     // MIs[0] Op2
     /* 158676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 158679 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 158684 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1745:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQRSHRUNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 158684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_S),
     /* 158687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 158689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 158691 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 158693 */     GIR_RootConstrainSelectedInstOperands,
     /* 158694 */     // GIR_Coverage, 11551,
     /* 158694 */     GIR_EraseRootFromParent_Done,
     /* 158695 */   // Label 3050: @158695
     /* 158695 */   GIM_Try, /*On fail goto*//*Label 3051*/ GIMT_Encode4(158737), // Rule ID 11552 //
     /* 158700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 158703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
     /* 158708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 158711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 158714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 158718 */     // MIs[0] Op2
     /* 158718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 158721 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 158726 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1624:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 158726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_B),
     /* 158729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 158731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 158733 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 158735 */     GIR_RootConstrainSelectedInstOperands,
     /* 158736 */     // GIR_Coverage, 11552,
     /* 158736 */     GIR_EraseRootFromParent_Done,
     /* 158737 */   // Label 3051: @158737
     /* 158737 */   GIM_Try, /*On fail goto*//*Label 3052*/ GIMT_Encode4(158779), // Rule ID 11553 //
     /* 158742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 158745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
     /* 158750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 158753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 158756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 158760 */     // MIs[0] Op2
     /* 158760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 158763 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 158768 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1624:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 158768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_H),
     /* 158771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 158773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 158775 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 158777 */     GIR_RootConstrainSelectedInstOperands,
     /* 158778 */     // GIR_Coverage, 11553,
     /* 158778 */     GIR_EraseRootFromParent_Done,
     /* 158779 */   // Label 3052: @158779
     /* 158779 */   GIM_Try, /*On fail goto*//*Label 3053*/ GIMT_Encode4(158821), // Rule ID 11554 //
     /* 158784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 158787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
     /* 158792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 158795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 158798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 158802 */     // MIs[0] Op2
     /* 158802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 158805 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 158810 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1624:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 158810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_S),
     /* 158813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 158815 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 158817 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 158819 */     GIR_RootConstrainSelectedInstOperands,
     /* 158820 */     // GIR_Coverage, 11554,
     /* 158820 */     GIR_EraseRootFromParent_Done,
     /* 158821 */   // Label 3053: @158821
     /* 158821 */   GIM_Try, /*On fail goto*//*Label 3054*/ GIMT_Encode4(158863), // Rule ID 11556 //
     /* 158826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 158829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
     /* 158834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 158837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 158840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 158844 */     // MIs[0] Op2
     /* 158844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 158847 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 158852 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1582:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (RSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 158852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_B),
     /* 158855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 158857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 158859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 158861 */     GIR_RootConstrainSelectedInstOperands,
     /* 158862 */     // GIR_Coverage, 11556,
     /* 158862 */     GIR_EraseRootFromParent_Done,
     /* 158863 */   // Label 3054: @158863
     /* 158863 */   GIM_Try, /*On fail goto*//*Label 3055*/ GIMT_Encode4(158905), // Rule ID 11558 //
     /* 158868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 158871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
     /* 158876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 158879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 158882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 158886 */     // MIs[0] Op2
     /* 158886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 158889 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 158894 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1582:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (RSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 158894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_H),
     /* 158897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 158899 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 158901 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 158903 */     GIR_RootConstrainSelectedInstOperands,
     /* 158904 */     // GIR_Coverage, 11558,
     /* 158904 */     GIR_EraseRootFromParent_Done,
     /* 158905 */   // Label 3055: @158905
     /* 158905 */   GIM_Try, /*On fail goto*//*Label 3056*/ GIMT_Encode4(158947), // Rule ID 11560 //
     /* 158910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 158913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
     /* 158918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 158921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 158924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 158928 */     // MIs[0] Op2
     /* 158928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 158931 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 158936 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1582:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (RSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 158936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_S),
     /* 158939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 158941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 158943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 158945 */     GIR_RootConstrainSelectedInstOperands,
     /* 158946 */     // GIR_Coverage, 11560,
     /* 158946 */     GIR_EraseRootFromParent_Done,
     /* 158947 */   // Label 3056: @158947
     /* 158947 */   GIM_Try, /*On fail goto*//*Label 3057*/ GIMT_Encode4(158989), // Rule ID 11561 //
     /* 158952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 158955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
     /* 158960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 158963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 158966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 158970 */     // MIs[0] Op2
     /* 158970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 158973 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 158978 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1749:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 158978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_B),
     /* 158981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 158983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 158985 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 158987 */     GIR_RootConstrainSelectedInstOperands,
     /* 158988 */     // GIR_Coverage, 11561,
     /* 158988 */     GIR_EraseRootFromParent_Done,
     /* 158989 */   // Label 3057: @158989
     /* 158989 */   GIM_Try, /*On fail goto*//*Label 3058*/ GIMT_Encode4(159031), // Rule ID 11562 //
     /* 158994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 158997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
     /* 159002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 159005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 159008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 159012 */     // MIs[0] Op2
     /* 159012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 159015 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 159020 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1749:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 159020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_H),
     /* 159023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 159025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 159027 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 159029 */     GIR_RootConstrainSelectedInstOperands,
     /* 159030 */     // GIR_Coverage, 11562,
     /* 159030 */     GIR_EraseRootFromParent_Done,
     /* 159031 */   // Label 3058: @159031
     /* 159031 */   GIM_Try, /*On fail goto*//*Label 3059*/ GIMT_Encode4(159073), // Rule ID 11563 //
     /* 159036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 159039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
     /* 159044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 159047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 159050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 159054 */     // MIs[0] Op2
     /* 159054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 159057 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 159062 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1749:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 159062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_S),
     /* 159065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 159067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 159069 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 159071 */     GIR_RootConstrainSelectedInstOperands,
     /* 159072 */     // GIR_Coverage, 11563,
     /* 159072 */     GIR_EraseRootFromParent_Done,
     /* 159073 */   // Label 3059: @159073
     /* 159073 */   GIM_Try, /*On fail goto*//*Label 3060*/ GIMT_Encode4(159115), // Rule ID 11564 //
     /* 159078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 159081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
     /* 159086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 159089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 159092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 159096 */     // MIs[0] Op2
     /* 159096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 159099 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 159104 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1739:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQRSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 159104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_B),
     /* 159107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 159109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 159111 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 159113 */     GIR_RootConstrainSelectedInstOperands,
     /* 159114 */     // GIR_Coverage, 11564,
     /* 159114 */     GIR_EraseRootFromParent_Done,
     /* 159115 */   // Label 3060: @159115
     /* 159115 */   GIM_Try, /*On fail goto*//*Label 3061*/ GIMT_Encode4(159157), // Rule ID 11565 //
     /* 159120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 159123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
     /* 159128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 159131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 159134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 159138 */     // MIs[0] Op2
     /* 159138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 159141 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 159146 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1739:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQRSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 159146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_H),
     /* 159149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 159151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 159153 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 159155 */     GIR_RootConstrainSelectedInstOperands,
     /* 159156 */     // GIR_Coverage, 11565,
     /* 159156 */     GIR_EraseRootFromParent_Done,
     /* 159157 */   // Label 3061: @159157
     /* 159157 */   GIM_Try, /*On fail goto*//*Label 3062*/ GIMT_Encode4(159199), // Rule ID 11566 //
     /* 159162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 159165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
     /* 159170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 159173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 159176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 159180 */     // MIs[0] Op2
     /* 159180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 159183 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 159188 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1739:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQRSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 159188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_S),
     /* 159191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 159193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 159195 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 159197 */     GIR_RootConstrainSelectedInstOperands,
     /* 159198 */     // GIR_Coverage, 11566,
     /* 159198 */     GIR_EraseRootFromParent_Done,
     /* 159199 */   // Label 3062: @159199
     /* 159199 */   GIM_Try, /*On fail goto*//*Label 3063*/ GIMT_Encode4(159241), // Rule ID 11567 //
     /* 159204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 159207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
     /* 159212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 159215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 159218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 159222 */     // MIs[0] Op2
     /* 159222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 159225 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 159230 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1944:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (UQSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 159230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_B),
     /* 159233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 159235 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 159237 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 159239 */     GIR_RootConstrainSelectedInstOperands,
     /* 159240 */     // GIR_Coverage, 11567,
     /* 159240 */     GIR_EraseRootFromParent_Done,
     /* 159241 */   // Label 3063: @159241
     /* 159241 */   GIM_Try, /*On fail goto*//*Label 3064*/ GIMT_Encode4(159283), // Rule ID 11568 //
     /* 159246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 159249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
     /* 159254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 159257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 159260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 159264 */     // MIs[0] Op2
     /* 159264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 159267 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 159272 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1944:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (UQSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 159272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_H),
     /* 159275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 159277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 159279 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 159281 */     GIR_RootConstrainSelectedInstOperands,
     /* 159282 */     // GIR_Coverage, 11568,
     /* 159282 */     GIR_EraseRootFromParent_Done,
     /* 159283 */   // Label 3064: @159283
     /* 159283 */   GIM_Try, /*On fail goto*//*Label 3065*/ GIMT_Encode4(159325), // Rule ID 11569 //
     /* 159288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 159291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
     /* 159296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 159299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 159302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 159306 */     // MIs[0] Op2
     /* 159306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 159309 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 159314 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1944:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (UQSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 159314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_S),
     /* 159317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 159319 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 159321 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 159323 */     GIR_RootConstrainSelectedInstOperands,
     /* 159324 */     // GIR_Coverage, 11569,
     /* 159324 */     GIR_EraseRootFromParent_Done,
     /* 159325 */   // Label 3065: @159325
     /* 159325 */   GIM_Try, /*On fail goto*//*Label 3066*/ GIMT_Encode4(159367), // Rule ID 11570 //
     /* 159330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 159333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
     /* 159338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 159341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 159344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 159348 */     // MIs[0] Op2
     /* 159348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 159351 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 159356 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1941:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (UQRSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 159356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_B),
     /* 159359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 159361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 159363 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 159365 */     GIR_RootConstrainSelectedInstOperands,
     /* 159366 */     // GIR_Coverage, 11570,
     /* 159366 */     GIR_EraseRootFromParent_Done,
     /* 159367 */   // Label 3066: @159367
     /* 159367 */   GIM_Try, /*On fail goto*//*Label 3067*/ GIMT_Encode4(159409), // Rule ID 11571 //
     /* 159372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 159375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
     /* 159380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 159383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 159386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 159390 */     // MIs[0] Op2
     /* 159390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 159393 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 159398 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1941:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (UQRSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 159398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_H),
     /* 159401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 159403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 159405 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 159407 */     GIR_RootConstrainSelectedInstOperands,
     /* 159408 */     // GIR_Coverage, 11571,
     /* 159408 */     GIR_EraseRootFromParent_Done,
     /* 159409 */   // Label 3067: @159409
     /* 159409 */   GIM_Try, /*On fail goto*//*Label 3068*/ GIMT_Encode4(159451), // Rule ID 11572 //
     /* 159414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 159417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
     /* 159422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 159425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 159428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 159432 */     // MIs[0] Op2
     /* 159432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 159435 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 159440 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1941:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (UQRSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 159440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_S),
     /* 159443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 159445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 159447 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 159449 */     GIR_RootConstrainSelectedInstOperands,
     /* 159450 */     // GIR_Coverage, 11572,
     /* 159450 */     GIR_EraseRootFromParent_Done,
     /* 159451 */   // Label 3068: @159451
     /* 159451 */   GIM_Try, /*On fail goto*//*Label 3069*/ GIMT_Encode4(159493), // Rule ID 11630 //
     /* 159456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 159459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
     /* 159464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 159467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 159470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 159474 */     // MIs[0] Op2
     /* 159474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 159477 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 159482 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1771:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (SSHLLT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 159482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_H),
     /* 159485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 159487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 159489 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 159491 */     GIR_RootConstrainSelectedInstOperands,
     /* 159492 */     // GIR_Coverage, 11630,
     /* 159492 */     GIR_EraseRootFromParent_Done,
     /* 159493 */   // Label 3069: @159493
     /* 159493 */   GIM_Try, /*On fail goto*//*Label 3070*/ GIMT_Encode4(159535), // Rule ID 11631 //
     /* 159498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 159501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
     /* 159506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 159509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 159512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 159516 */     // MIs[0] Op2
     /* 159516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 159519 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 159524 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1771:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (SSHLLT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 159524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_S),
     /* 159527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 159529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 159531 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 159533 */     GIR_RootConstrainSelectedInstOperands,
     /* 159534 */     // GIR_Coverage, 11631,
     /* 159534 */     GIR_EraseRootFromParent_Done,
     /* 159535 */   // Label 3070: @159535
     /* 159535 */   GIM_Try, /*On fail goto*//*Label 3071*/ GIMT_Encode4(159577), // Rule ID 11632 //
     /* 159540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 159543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
     /* 159548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 159551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 159554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 159558 */     // MIs[0] Op2
     /* 159558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 159561 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 159566 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1771:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (SSHLLT_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 159566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_D),
     /* 159569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 159571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 159573 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 159575 */     GIR_RootConstrainSelectedInstOperands,
     /* 159576 */     // GIR_Coverage, 11632,
     /* 159576 */     GIR_EraseRootFromParent_Done,
     /* 159577 */   // Label 3071: @159577
     /* 159577 */   GIM_Try, /*On fail goto*//*Label 3072*/ GIMT_Encode4(159619), // Rule ID 11633 //
     /* 159582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 159585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
     /* 159590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 159593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 159596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 159600 */     // MIs[0] Op2
     /* 159600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 159603 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 159608 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1964:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (USHLLB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 159608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_H),
     /* 159611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 159613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 159615 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 159617 */     GIR_RootConstrainSelectedInstOperands,
     /* 159618 */     // GIR_Coverage, 11633,
     /* 159618 */     GIR_EraseRootFromParent_Done,
     /* 159619 */   // Label 3072: @159619
     /* 159619 */   GIM_Try, /*On fail goto*//*Label 3073*/ GIMT_Encode4(159661), // Rule ID 11634 //
     /* 159624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 159627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
     /* 159632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 159635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 159638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 159642 */     // MIs[0] Op2
     /* 159642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 159645 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 159650 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1964:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (USHLLB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 159650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_S),
     /* 159653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 159655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 159657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 159659 */     GIR_RootConstrainSelectedInstOperands,
     /* 159660 */     // GIR_Coverage, 11634,
     /* 159660 */     GIR_EraseRootFromParent_Done,
     /* 159661 */   // Label 3073: @159661
     /* 159661 */   GIM_Try, /*On fail goto*//*Label 3074*/ GIMT_Encode4(159703), // Rule ID 11635 //
     /* 159666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 159669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
     /* 159674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 159677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 159680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 159684 */     // MIs[0] Op2
     /* 159684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 159687 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 159692 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1964:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (USHLLB_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 159692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_D),
     /* 159695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 159697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 159699 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 159701 */     GIR_RootConstrainSelectedInstOperands,
     /* 159702 */     // GIR_Coverage, 11635,
     /* 159702 */     GIR_EraseRootFromParent_Done,
     /* 159703 */   // Label 3074: @159703
     /* 159703 */   GIM_Try, /*On fail goto*//*Label 3075*/ GIMT_Encode4(159745), // Rule ID 11636 //
     /* 159708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 159711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
     /* 159716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 159719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 159722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 159726 */     // MIs[0] Op2
     /* 159726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 159729 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 159734 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1965:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (USHLLT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 159734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_H),
     /* 159737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 159739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 159741 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 159743 */     GIR_RootConstrainSelectedInstOperands,
     /* 159744 */     // GIR_Coverage, 11636,
     /* 159744 */     GIR_EraseRootFromParent_Done,
     /* 159745 */   // Label 3075: @159745
     /* 159745 */   GIM_Try, /*On fail goto*//*Label 3076*/ GIMT_Encode4(159787), // Rule ID 11637 //
     /* 159750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 159753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
     /* 159758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 159761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 159764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 159768 */     // MIs[0] Op2
     /* 159768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 159771 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 159776 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1965:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (USHLLT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 159776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_S),
     /* 159779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 159781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 159783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 159785 */     GIR_RootConstrainSelectedInstOperands,
     /* 159786 */     // GIR_Coverage, 11637,
     /* 159786 */     GIR_EraseRootFromParent_Done,
     /* 159787 */   // Label 3076: @159787
     /* 159787 */   GIM_Try, /*On fail goto*//*Label 3077*/ GIMT_Encode4(159829), // Rule ID 11638 //
     /* 159792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 159795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
     /* 159800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 159803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 159806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 159810 */     // MIs[0] Op2
     /* 159810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 159813 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 159818 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1965:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (USHLLT_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 159818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_D),
     /* 159821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 159823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 159825 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 159827 */     GIR_RootConstrainSelectedInstOperands,
     /* 159828 */     // GIR_Coverage, 11638,
     /* 159828 */     GIR_EraseRootFromParent_Done,
     /* 159829 */   // Label 3077: @159829
     /* 159829 */   GIM_Try, /*On fail goto*//*Label 3078*/ GIMT_Encode4(159881), // Rule ID 2123 //
     /* 159834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 159837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 159842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 159845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 159848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 159851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159867 */     // MIs[1] Operand 1
     /* 159867 */     // No operand predicates
     /* 159867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159869 */     // (intrinsic_wo_chain:{ *:[v4i16] } 762:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv4i16_shift:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 159869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4i16_shift),
     /* 159872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159876 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 159879 */     GIR_RootConstrainSelectedInstOperands,
     /* 159880 */     // GIR_Coverage, 2123,
     /* 159880 */     GIR_EraseRootFromParent_Done,
     /* 159881 */   // Label 3078: @159881
     /* 159881 */   GIM_Try, /*On fail goto*//*Label 3079*/ GIMT_Encode4(159933), // Rule ID 2124 //
     /* 159886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 159889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 159894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 159897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 159900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 159903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159919 */     // MIs[1] Operand 1
     /* 159919 */     // No operand predicates
     /* 159919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159921 */     // (intrinsic_wo_chain:{ *:[v8i16] } 762:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv8i16_shift:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 159921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8i16_shift),
     /* 159924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159928 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 159931 */     GIR_RootConstrainSelectedInstOperands,
     /* 159932 */     // GIR_Coverage, 2124,
     /* 159932 */     GIR_EraseRootFromParent_Done,
     /* 159933 */   // Label 3079: @159933
     /* 159933 */   GIM_Try, /*On fail goto*//*Label 3080*/ GIMT_Encode4(159985), // Rule ID 2125 //
     /* 159938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 159941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 159946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 159949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 159952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 159955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159971 */     // MIs[1] Operand 1
     /* 159971 */     // No operand predicates
     /* 159971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159973 */     // (intrinsic_wo_chain:{ *:[v2i32] } 762:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv2i32_shift:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 159973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2i32_shift),
     /* 159976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159978 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159980 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 159983 */     GIR_RootConstrainSelectedInstOperands,
     /* 159984 */     // GIR_Coverage, 2125,
     /* 159984 */     GIR_EraseRootFromParent_Done,
     /* 159985 */   // Label 3080: @159985
     /* 159985 */   GIM_Try, /*On fail goto*//*Label 3081*/ GIMT_Encode4(160037), // Rule ID 2126 //
     /* 159990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 159993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 159998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 160001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 160004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160023 */     // MIs[1] Operand 1
     /* 160023 */     // No operand predicates
     /* 160023 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160025 */     // (intrinsic_wo_chain:{ *:[v4i32] } 762:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv4i32_shift:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 160025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4i32_shift),
     /* 160028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160032 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 160035 */     GIR_RootConstrainSelectedInstOperands,
     /* 160036 */     // GIR_Coverage, 2126,
     /* 160036 */     GIR_EraseRootFromParent_Done,
     /* 160037 */   // Label 3081: @160037
     /* 160037 */   GIM_Try, /*On fail goto*//*Label 3082*/ GIMT_Encode4(160089), // Rule ID 2127 //
     /* 160042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 160050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 160053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 160056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160075 */     // MIs[1] Operand 1
     /* 160075 */     // No operand predicates
     /* 160075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160077 */     // (intrinsic_wo_chain:{ *:[v2i64] } 762:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv2i64_shift:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 160077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2i64_shift),
     /* 160080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160084 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 160087 */     GIR_RootConstrainSelectedInstOperands,
     /* 160088 */     // GIR_Coverage, 2127,
     /* 160088 */     GIR_EraseRootFromParent_Done,
     /* 160089 */   // Label 3082: @160089
     /* 160089 */   GIM_Try, /*On fail goto*//*Label 3083*/ GIMT_Encode4(160141), // Rule ID 2128 //
     /* 160094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 160097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 160102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 160105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 160108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160127 */     // MIs[1] Operand 1
     /* 160127 */     // No operand predicates
     /* 160127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160129 */     // (intrinsic_wo_chain:{ *:[v4i16] } 763:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv4i16_shift:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 160129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4i16_shift),
     /* 160132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160136 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 160139 */     GIR_RootConstrainSelectedInstOperands,
     /* 160140 */     // GIR_Coverage, 2128,
     /* 160140 */     GIR_EraseRootFromParent_Done,
     /* 160141 */   // Label 3083: @160141
     /* 160141 */   GIM_Try, /*On fail goto*//*Label 3084*/ GIMT_Encode4(160193), // Rule ID 2129 //
     /* 160146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 160149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 160154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 160157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 160160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160179 */     // MIs[1] Operand 1
     /* 160179 */     // No operand predicates
     /* 160179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160181 */     // (intrinsic_wo_chain:{ *:[v8i16] } 763:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv8i16_shift:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 160181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8i16_shift),
     /* 160184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160188 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 160191 */     GIR_RootConstrainSelectedInstOperands,
     /* 160192 */     // GIR_Coverage, 2129,
     /* 160192 */     GIR_EraseRootFromParent_Done,
     /* 160193 */   // Label 3084: @160193
     /* 160193 */   GIM_Try, /*On fail goto*//*Label 3085*/ GIMT_Encode4(160245), // Rule ID 2130 //
     /* 160198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 160206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 160209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 160212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160231 */     // MIs[1] Operand 1
     /* 160231 */     // No operand predicates
     /* 160231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160233 */     // (intrinsic_wo_chain:{ *:[v2i32] } 763:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv2i32_shift:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 160233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2i32_shift),
     /* 160236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160240 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 160243 */     GIR_RootConstrainSelectedInstOperands,
     /* 160244 */     // GIR_Coverage, 2130,
     /* 160244 */     GIR_EraseRootFromParent_Done,
     /* 160245 */   // Label 3085: @160245
     /* 160245 */   GIM_Try, /*On fail goto*//*Label 3086*/ GIMT_Encode4(160297), // Rule ID 2131 //
     /* 160250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 160258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 160261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 160264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160283 */     // MIs[1] Operand 1
     /* 160283 */     // No operand predicates
     /* 160283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160285 */     // (intrinsic_wo_chain:{ *:[v4i32] } 763:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv4i32_shift:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 160285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4i32_shift),
     /* 160288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160292 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 160295 */     GIR_RootConstrainSelectedInstOperands,
     /* 160296 */     // GIR_Coverage, 2131,
     /* 160296 */     GIR_EraseRootFromParent_Done,
     /* 160297 */   // Label 3086: @160297
     /* 160297 */   GIM_Try, /*On fail goto*//*Label 3087*/ GIMT_Encode4(160349), // Rule ID 2132 //
     /* 160302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 160310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 160313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 160316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160335 */     // MIs[1] Operand 1
     /* 160335 */     // No operand predicates
     /* 160335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160337 */     // (intrinsic_wo_chain:{ *:[v2i64] } 763:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv2i64_shift:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 160337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2i64_shift),
     /* 160340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160344 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 160347 */     GIR_RootConstrainSelectedInstOperands,
     /* 160348 */     // GIR_Coverage, 2132,
     /* 160348 */     GIR_EraseRootFromParent_Done,
     /* 160349 */   // Label 3087: @160349
     /* 160349 */   GIM_Try, /*On fail goto*//*Label 3088*/ GIMT_Encode4(160401), // Rule ID 2133 //
     /* 160354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 160357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 160362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 160365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 160368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160387 */     // MIs[1] Operand 1
     /* 160387 */     // No operand predicates
     /* 160387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160389 */     // (intrinsic_wo_chain:{ *:[v4f16] } 765:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv4i16_shift:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 160389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4i16_shift),
     /* 160392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160396 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 160399 */     GIR_RootConstrainSelectedInstOperands,
     /* 160400 */     // GIR_Coverage, 2133,
     /* 160400 */     GIR_EraseRootFromParent_Done,
     /* 160401 */   // Label 3088: @160401
     /* 160401 */   GIM_Try, /*On fail goto*//*Label 3089*/ GIMT_Encode4(160453), // Rule ID 2134 //
     /* 160406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 160409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 160414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 160417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 160420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160439 */     // MIs[1] Operand 1
     /* 160439 */     // No operand predicates
     /* 160439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160441 */     // (intrinsic_wo_chain:{ *:[v8f16] } 765:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv8i16_shift:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 160441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv8i16_shift),
     /* 160444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160448 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 160451 */     GIR_RootConstrainSelectedInstOperands,
     /* 160452 */     // GIR_Coverage, 2134,
     /* 160452 */     GIR_EraseRootFromParent_Done,
     /* 160453 */   // Label 3089: @160453
     /* 160453 */   GIM_Try, /*On fail goto*//*Label 3090*/ GIMT_Encode4(160505), // Rule ID 2135 //
     /* 160458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 160466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 160469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 160472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160491 */     // MIs[1] Operand 1
     /* 160491 */     // No operand predicates
     /* 160491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160493 */     // (intrinsic_wo_chain:{ *:[v2f32] } 765:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv2i32_shift:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 160493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2i32_shift),
     /* 160496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160500 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 160503 */     GIR_RootConstrainSelectedInstOperands,
     /* 160504 */     // GIR_Coverage, 2135,
     /* 160504 */     GIR_EraseRootFromParent_Done,
     /* 160505 */   // Label 3090: @160505
     /* 160505 */   GIM_Try, /*On fail goto*//*Label 3091*/ GIMT_Encode4(160557), // Rule ID 2136 //
     /* 160510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 160518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 160521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 160524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160543 */     // MIs[1] Operand 1
     /* 160543 */     // No operand predicates
     /* 160543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160545 */     // (intrinsic_wo_chain:{ *:[v4f32] } 765:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv4i32_shift:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 160545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4i32_shift),
     /* 160548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160550 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160552 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 160555 */     GIR_RootConstrainSelectedInstOperands,
     /* 160556 */     // GIR_Coverage, 2136,
     /* 160556 */     GIR_EraseRootFromParent_Done,
     /* 160557 */   // Label 3091: @160557
     /* 160557 */   GIM_Try, /*On fail goto*//*Label 3092*/ GIMT_Encode4(160609), // Rule ID 2137 //
     /* 160562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 160570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 160573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 160576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160595 */     // MIs[1] Operand 1
     /* 160595 */     // No operand predicates
     /* 160595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160597 */     // (intrinsic_wo_chain:{ *:[v2f64] } 765:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv2i64_shift:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 160597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2i64_shift),
     /* 160600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160604 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 160607 */     GIR_RootConstrainSelectedInstOperands,
     /* 160608 */     // GIR_Coverage, 2137,
     /* 160608 */     GIR_EraseRootFromParent_Done,
     /* 160609 */   // Label 3092: @160609
     /* 160609 */   GIM_Try, /*On fail goto*//*Label 3093*/ GIMT_Encode4(160661), // Rule ID 2235 //
     /* 160614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 160617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 160622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 160625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 160628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160647 */     // MIs[1] Operand 1
     /* 160647 */     // No operand predicates
     /* 160647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160649 */     // (intrinsic_wo_chain:{ *:[v4f16] } 766:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv4i16_shift:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 160649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4i16_shift),
     /* 160652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160656 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 160659 */     GIR_RootConstrainSelectedInstOperands,
     /* 160660 */     // GIR_Coverage, 2235,
     /* 160660 */     GIR_EraseRootFromParent_Done,
     /* 160661 */   // Label 3093: @160661
     /* 160661 */   GIM_Try, /*On fail goto*//*Label 3094*/ GIMT_Encode4(160713), // Rule ID 2236 //
     /* 160666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 160669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 160674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 160677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 160680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160699 */     // MIs[1] Operand 1
     /* 160699 */     // No operand predicates
     /* 160699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160701 */     // (intrinsic_wo_chain:{ *:[v8f16] } 766:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv8i16_shift:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 160701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv8i16_shift),
     /* 160704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160706 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160708 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 160711 */     GIR_RootConstrainSelectedInstOperands,
     /* 160712 */     // GIR_Coverage, 2236,
     /* 160712 */     GIR_EraseRootFromParent_Done,
     /* 160713 */   // Label 3094: @160713
     /* 160713 */   GIM_Try, /*On fail goto*//*Label 3095*/ GIMT_Encode4(160765), // Rule ID 2237 //
     /* 160718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 160726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 160729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 160732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160751 */     // MIs[1] Operand 1
     /* 160751 */     // No operand predicates
     /* 160751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160753 */     // (intrinsic_wo_chain:{ *:[v2f32] } 766:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv2i32_shift:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 160753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2i32_shift),
     /* 160756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160760 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 160763 */     GIR_RootConstrainSelectedInstOperands,
     /* 160764 */     // GIR_Coverage, 2237,
     /* 160764 */     GIR_EraseRootFromParent_Done,
     /* 160765 */   // Label 3095: @160765
     /* 160765 */   GIM_Try, /*On fail goto*//*Label 3096*/ GIMT_Encode4(160817), // Rule ID 2238 //
     /* 160770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 160778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 160781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 160784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160803 */     // MIs[1] Operand 1
     /* 160803 */     // No operand predicates
     /* 160803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160805 */     // (intrinsic_wo_chain:{ *:[v4f32] } 766:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv4i32_shift:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 160805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4i32_shift),
     /* 160808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160812 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 160815 */     GIR_RootConstrainSelectedInstOperands,
     /* 160816 */     // GIR_Coverage, 2238,
     /* 160816 */     GIR_EraseRootFromParent_Done,
     /* 160817 */   // Label 3096: @160817
     /* 160817 */   GIM_Try, /*On fail goto*//*Label 3097*/ GIMT_Encode4(160869), // Rule ID 2239 //
     /* 160822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 160830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 160833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 160836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160855 */     // MIs[1] Operand 1
     /* 160855 */     // No operand predicates
     /* 160855 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160857 */     // (intrinsic_wo_chain:{ *:[v2f64] } 766:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv2i64_shift:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 160857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2i64_shift),
     /* 160860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160864 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 160867 */     GIR_RootConstrainSelectedInstOperands,
     /* 160868 */     // GIR_Coverage, 2239,
     /* 160868 */     GIR_EraseRootFromParent_Done,
     /* 160869 */   // Label 3097: @160869
     /* 160869 */   GIM_Try, /*On fail goto*//*Label 3098*/ GIMT_Encode4(160914), // Rule ID 63 //
     /* 160874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 160877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign_generic),
     /* 160882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 160888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 160891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 160903 */     // (intrinsic_wo_chain:{ *:[i64] } 297:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)  =>  (PACGA:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)
     /* 160903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACGA),
     /* 160906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160910 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 160912 */     GIR_RootConstrainSelectedInstOperands,
     /* 160913 */     // GIR_Coverage, 63,
     /* 160913 */     GIR_EraseRootFromParent_Done,
     /* 160914 */   // Label 3098: @160914
     /* 160914 */   GIM_Try, /*On fail goto*//*Label 3099*/ GIMT_Encode4(160959), // Rule ID 129 //
     /* 160919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 160922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32b),
     /* 160927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160948 */     // (intrinsic_wo_chain:{ *:[i32] } 503:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Brr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 160948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Brr),
     /* 160951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160955 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 160957 */     GIR_RootConstrainSelectedInstOperands,
     /* 160958 */     // GIR_Coverage, 129,
     /* 160958 */     GIR_EraseRootFromParent_Done,
     /* 160959 */   // Label 3099: @160959
     /* 160959 */   GIM_Try, /*On fail goto*//*Label 3100*/ GIMT_Encode4(161004), // Rule ID 130 //
     /* 160964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 160967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32h),
     /* 160972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160993 */     // (intrinsic_wo_chain:{ *:[i32] } 508:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Hrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 160993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Hrr),
     /* 160996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161000 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 161002 */     GIR_RootConstrainSelectedInstOperands,
     /* 161003 */     // GIR_Coverage, 130,
     /* 161003 */     GIR_EraseRootFromParent_Done,
     /* 161004 */   // Label 3100: @161004
     /* 161004 */   GIM_Try, /*On fail goto*//*Label 3101*/ GIMT_Encode4(161049), // Rule ID 131 //
     /* 161009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 161012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32w),
     /* 161017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 161026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161038 */     // (intrinsic_wo_chain:{ *:[i32] } 509:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Wrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 161038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Wrr),
     /* 161041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161045 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 161047 */     GIR_RootConstrainSelectedInstOperands,
     /* 161048 */     // GIR_Coverage, 131,
     /* 161048 */     GIR_EraseRootFromParent_Done,
     /* 161049 */   // Label 3101: @161049
     /* 161049 */   GIM_Try, /*On fail goto*//*Label 3102*/ GIMT_Encode4(161094), // Rule ID 132 //
     /* 161054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 161057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32x),
     /* 161062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 161071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161083 */     // (intrinsic_wo_chain:{ *:[i32] } 510:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (CRC32Xrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 161083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Xrr),
     /* 161086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161090 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 161092 */     GIR_RootConstrainSelectedInstOperands,
     /* 161093 */     // GIR_Coverage, 132,
     /* 161093 */     GIR_EraseRootFromParent_Done,
     /* 161094 */   // Label 3102: @161094
     /* 161094 */   GIM_Try, /*On fail goto*//*Label 3103*/ GIMT_Encode4(161139), // Rule ID 133 //
     /* 161099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 161102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cb),
     /* 161107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 161116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161128 */     // (intrinsic_wo_chain:{ *:[i32] } 504:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CBrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 161128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CBrr),
     /* 161131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161135 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 161137 */     GIR_RootConstrainSelectedInstOperands,
     /* 161138 */     // GIR_Coverage, 133,
     /* 161138 */     GIR_EraseRootFromParent_Done,
     /* 161139 */   // Label 3103: @161139
     /* 161139 */   GIM_Try, /*On fail goto*//*Label 3104*/ GIMT_Encode4(161184), // Rule ID 134 //
     /* 161144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 161147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32ch),
     /* 161152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 161161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161173 */     // (intrinsic_wo_chain:{ *:[i32] } 505:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CHrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 161173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CHrr),
     /* 161176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161180 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 161182 */     GIR_RootConstrainSelectedInstOperands,
     /* 161183 */     // GIR_Coverage, 134,
     /* 161183 */     GIR_EraseRootFromParent_Done,
     /* 161184 */   // Label 3104: @161184
     /* 161184 */   GIM_Try, /*On fail goto*//*Label 3105*/ GIMT_Encode4(161229), // Rule ID 135 //
     /* 161189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 161192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cw),
     /* 161197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 161206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161218 */     // (intrinsic_wo_chain:{ *:[i32] } 506:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 161218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CWrr),
     /* 161221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161223 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161225 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 161227 */     GIR_RootConstrainSelectedInstOperands,
     /* 161228 */     // GIR_Coverage, 135,
     /* 161228 */     GIR_EraseRootFromParent_Done,
     /* 161229 */   // Label 3105: @161229
     /* 161229 */   GIM_Try, /*On fail goto*//*Label 3106*/ GIMT_Encode4(161274), // Rule ID 136 //
     /* 161234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 161237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cx),
     /* 161242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 161251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161263 */     // (intrinsic_wo_chain:{ *:[i32] } 507:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (CRC32CXrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 161263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CXrr),
     /* 161266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161270 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 161272 */     GIR_RootConstrainSelectedInstOperands,
     /* 161273 */     // GIR_Coverage, 136,
     /* 161273 */     GIR_EraseRootFromParent_Done,
     /* 161274 */   // Label 3106: @161274
     /* 161274 */   GIM_Try, /*On fail goto*//*Label 3107*/ GIMT_Encode4(161319), // Rule ID 1035 //
     /* 161279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 161287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 161290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 161293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 161296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161308 */     // (intrinsic_wo_chain:{ *:[v8i8] } 715:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (SUQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /* 161308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv8i8),
     /* 161311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 161315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 161317 */     GIR_RootConstrainSelectedInstOperands,
     /* 161318 */     // GIR_Coverage, 1035,
     /* 161318 */     GIR_EraseRootFromParent_Done,
     /* 161319 */   // Label 3107: @161319
     /* 161319 */   GIM_Try, /*On fail goto*//*Label 3108*/ GIMT_Encode4(161364), // Rule ID 1036 //
     /* 161324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 161332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 161335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 161338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 161341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161353 */     // (intrinsic_wo_chain:{ *:[v16i8] } 715:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (SUQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 161353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv16i8),
     /* 161356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 161360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 161362 */     GIR_RootConstrainSelectedInstOperands,
     /* 161363 */     // GIR_Coverage, 1036,
     /* 161363 */     GIR_EraseRootFromParent_Done,
     /* 161364 */   // Label 3108: @161364
     /* 161364 */   GIM_Try, /*On fail goto*//*Label 3109*/ GIMT_Encode4(161409), // Rule ID 1037 //
     /* 161369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 161377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 161380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 161383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 161386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161398 */     // (intrinsic_wo_chain:{ *:[v4i16] } 715:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (SUQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /* 161398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv4i16),
     /* 161401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 161405 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 161407 */     GIR_RootConstrainSelectedInstOperands,
     /* 161408 */     // GIR_Coverage, 1037,
     /* 161408 */     GIR_EraseRootFromParent_Done,
     /* 161409 */   // Label 3109: @161409
     /* 161409 */   GIM_Try, /*On fail goto*//*Label 3110*/ GIMT_Encode4(161454), // Rule ID 1038 //
     /* 161414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 161422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 161425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 161428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 161431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161443 */     // (intrinsic_wo_chain:{ *:[v8i16] } 715:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)  =>  (SUQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /* 161443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv8i16),
     /* 161446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161448 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 161450 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 161452 */     GIR_RootConstrainSelectedInstOperands,
     /* 161453 */     // GIR_Coverage, 1038,
     /* 161453 */     GIR_EraseRootFromParent_Done,
     /* 161454 */   // Label 3110: @161454
     /* 161454 */   GIM_Try, /*On fail goto*//*Label 3111*/ GIMT_Encode4(161499), // Rule ID 1039 //
     /* 161459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 161467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 161470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 161473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 161476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161488 */     // (intrinsic_wo_chain:{ *:[v2i32] } 715:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (SUQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /* 161488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv2i32),
     /* 161491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 161495 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 161497 */     GIR_RootConstrainSelectedInstOperands,
     /* 161498 */     // GIR_Coverage, 1039,
     /* 161498 */     GIR_EraseRootFromParent_Done,
     /* 161499 */   // Label 3111: @161499
     /* 161499 */   GIM_Try, /*On fail goto*//*Label 3112*/ GIMT_Encode4(161544), // Rule ID 1040 //
     /* 161504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 161512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 161515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 161518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 161521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161533 */     // (intrinsic_wo_chain:{ *:[v4i32] } 715:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SUQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 161533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv4i32),
     /* 161536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 161540 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 161542 */     GIR_RootConstrainSelectedInstOperands,
     /* 161543 */     // GIR_Coverage, 1040,
     /* 161543 */     GIR_EraseRootFromParent_Done,
     /* 161544 */   // Label 3112: @161544
     /* 161544 */   GIM_Try, /*On fail goto*//*Label 3113*/ GIMT_Encode4(161589), // Rule ID 1041 //
     /* 161549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 161557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 161560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 161563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 161566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161578 */     // (intrinsic_wo_chain:{ *:[v2i64] } 715:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)  =>  (SUQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)
     /* 161578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv2i64),
     /* 161581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 161585 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 161587 */     GIR_RootConstrainSelectedInstOperands,
     /* 161588 */     // GIR_Coverage, 1041,
     /* 161588 */     GIR_EraseRootFromParent_Done,
     /* 161589 */   // Label 3113: @161589
     /* 161589 */   GIM_Try, /*On fail goto*//*Label 3114*/ GIMT_Encode4(161634), // Rule ID 1083 //
     /* 161594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 161602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 161605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 161608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 161611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161623 */     // (intrinsic_wo_chain:{ *:[v8i8] } 754:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (USQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /* 161623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv8i8),
     /* 161626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 161630 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 161632 */     GIR_RootConstrainSelectedInstOperands,
     /* 161633 */     // GIR_Coverage, 1083,
     /* 161633 */     GIR_EraseRootFromParent_Done,
     /* 161634 */   // Label 3114: @161634
     /* 161634 */   GIM_Try, /*On fail goto*//*Label 3115*/ GIMT_Encode4(161679), // Rule ID 1084 //
     /* 161639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 161647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 161650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 161653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 161656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161668 */     // (intrinsic_wo_chain:{ *:[v16i8] } 754:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (USQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 161668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv16i8),
     /* 161671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 161675 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 161677 */     GIR_RootConstrainSelectedInstOperands,
     /* 161678 */     // GIR_Coverage, 1084,
     /* 161678 */     GIR_EraseRootFromParent_Done,
     /* 161679 */   // Label 3115: @161679
     /* 161679 */   GIM_Try, /*On fail goto*//*Label 3116*/ GIMT_Encode4(161724), // Rule ID 1085 //
     /* 161684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 161692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 161695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 161698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 161701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161713 */     // (intrinsic_wo_chain:{ *:[v4i16] } 754:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (USQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /* 161713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv4i16),
     /* 161716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 161720 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 161722 */     GIR_RootConstrainSelectedInstOperands,
     /* 161723 */     // GIR_Coverage, 1085,
     /* 161723 */     GIR_EraseRootFromParent_Done,
     /* 161724 */   // Label 3116: @161724
     /* 161724 */   GIM_Try, /*On fail goto*//*Label 3117*/ GIMT_Encode4(161769), // Rule ID 1086 //
     /* 161729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 161737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 161740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 161743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 161746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161758 */     // (intrinsic_wo_chain:{ *:[v8i16] } 754:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)  =>  (USQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /* 161758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv8i16),
     /* 161761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 161765 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 161767 */     GIR_RootConstrainSelectedInstOperands,
     /* 161768 */     // GIR_Coverage, 1086,
     /* 161768 */     GIR_EraseRootFromParent_Done,
     /* 161769 */   // Label 3117: @161769
     /* 161769 */   GIM_Try, /*On fail goto*//*Label 3118*/ GIMT_Encode4(161814), // Rule ID 1087 //
     /* 161774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 161782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 161785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 161788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 161791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161803 */     // (intrinsic_wo_chain:{ *:[v2i32] } 754:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (USQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /* 161803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv2i32),
     /* 161806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 161810 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 161812 */     GIR_RootConstrainSelectedInstOperands,
     /* 161813 */     // GIR_Coverage, 1087,
     /* 161813 */     GIR_EraseRootFromParent_Done,
     /* 161814 */   // Label 3118: @161814
     /* 161814 */   GIM_Try, /*On fail goto*//*Label 3119*/ GIMT_Encode4(161859), // Rule ID 1088 //
     /* 161819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 161827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 161830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 161833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 161836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161848 */     // (intrinsic_wo_chain:{ *:[v4i32] } 754:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (USQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 161848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv4i32),
     /* 161851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 161855 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 161857 */     GIR_RootConstrainSelectedInstOperands,
     /* 161858 */     // GIR_Coverage, 1088,
     /* 161858 */     GIR_EraseRootFromParent_Done,
     /* 161859 */   // Label 3119: @161859
     /* 161859 */   GIM_Try, /*On fail goto*//*Label 3120*/ GIMT_Encode4(161904), // Rule ID 1089 //
     /* 161864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 161872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 161875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 161878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 161881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161893 */     // (intrinsic_wo_chain:{ *:[v2i64] } 754:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)  =>  (USQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)
     /* 161893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv2i64),
     /* 161896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161898 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 161900 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 161902 */     GIR_RootConstrainSelectedInstOperands,
     /* 161903 */     // GIR_Coverage, 1089,
     /* 161903 */     GIR_EraseRootFromParent_Done,
     /* 161904 */   // Label 3120: @161904
     /* 161904 */   GIM_Try, /*On fail goto*//*Label 3121*/ GIMT_Encode4(161949), // Rule ID 1101 //
     /* 161909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 161917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 161920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 161923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 161926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161938 */     // (intrinsic_wo_chain:{ *:[v8i8] } 570:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ADDPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 161938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i8),
     /* 161941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161945 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 161947 */     GIR_RootConstrainSelectedInstOperands,
     /* 161948 */     // GIR_Coverage, 1101,
     /* 161948 */     GIR_EraseRootFromParent_Done,
     /* 161949 */   // Label 3121: @161949
     /* 161949 */   GIM_Try, /*On fail goto*//*Label 3122*/ GIMT_Encode4(161994), // Rule ID 1103 //
     /* 161954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 161962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 161965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 161968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 161971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161983 */     // (intrinsic_wo_chain:{ *:[v16i8] } 570:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ADDPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 161983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /* 161986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161990 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 161992 */     GIR_RootConstrainSelectedInstOperands,
     /* 161993 */     // GIR_Coverage, 1103,
     /* 161993 */     GIR_EraseRootFromParent_Done,
     /* 161994 */   // Label 3122: @161994
     /* 161994 */   GIM_Try, /*On fail goto*//*Label 3123*/ GIMT_Encode4(162039), // Rule ID 1105 //
     /* 161999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 162007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 162010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 162013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 162016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162028 */     // (intrinsic_wo_chain:{ *:[v4i16] } 570:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ADDPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 162028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i16),
     /* 162031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162035 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 162037 */     GIR_RootConstrainSelectedInstOperands,
     /* 162038 */     // GIR_Coverage, 1105,
     /* 162038 */     GIR_EraseRootFromParent_Done,
     /* 162039 */   // Label 3123: @162039
     /* 162039 */   GIM_Try, /*On fail goto*//*Label 3124*/ GIMT_Encode4(162084), // Rule ID 1107 //
     /* 162044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 162052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 162055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 162061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162073 */     // (intrinsic_wo_chain:{ *:[v8i16] } 570:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 162073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /* 162076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162080 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 162082 */     GIR_RootConstrainSelectedInstOperands,
     /* 162083 */     // GIR_Coverage, 1107,
     /* 162083 */     GIR_EraseRootFromParent_Done,
     /* 162084 */   // Label 3124: @162084
     /* 162084 */   GIM_Try, /*On fail goto*//*Label 3125*/ GIMT_Encode4(162129), // Rule ID 1109 //
     /* 162089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 162097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 162100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 162103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 162106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162118 */     // (intrinsic_wo_chain:{ *:[v2i32] } 570:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ADDPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 162118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 162121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162123 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162125 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 162127 */     GIR_RootConstrainSelectedInstOperands,
     /* 162128 */     // GIR_Coverage, 1109,
     /* 162128 */     GIR_EraseRootFromParent_Done,
     /* 162129 */   // Label 3125: @162129
     /* 162129 */   GIM_Try, /*On fail goto*//*Label 3126*/ GIMT_Encode4(162174), // Rule ID 1111 //
     /* 162134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 162142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 162145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 162151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162163 */     // (intrinsic_wo_chain:{ *:[v4i32] } 570:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 162163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /* 162166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162170 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 162172 */     GIR_RootConstrainSelectedInstOperands,
     /* 162173 */     // GIR_Coverage, 1111,
     /* 162173 */     GIR_EraseRootFromParent_Done,
     /* 162174 */   // Label 3126: @162174
     /* 162174 */   GIM_Try, /*On fail goto*//*Label 3127*/ GIMT_Encode4(162219), // Rule ID 1113 //
     /* 162179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 162187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 162190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 162193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 162196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162208 */     // (intrinsic_wo_chain:{ *:[v2i64] } 570:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDPv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 162208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64),
     /* 162211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162215 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 162217 */     GIR_RootConstrainSelectedInstOperands,
     /* 162218 */     // GIR_Coverage, 1113,
     /* 162218 */     GIR_EraseRootFromParent_Done,
     /* 162219 */   // Label 3127: @162219
     /* 162219 */   GIM_Try, /*On fail goto*//*Label 3128*/ GIMT_Encode4(162264), // Rule ID 1156 //
     /* 162224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 162232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 162235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 162238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 162241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162253 */     // (intrinsic_wo_chain:{ *:[v4f16] } 576:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FABDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 162253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f16),
     /* 162256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162260 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 162262 */     GIR_RootConstrainSelectedInstOperands,
     /* 162263 */     // GIR_Coverage, 1156,
     /* 162263 */     GIR_EraseRootFromParent_Done,
     /* 162264 */   // Label 3128: @162264
     /* 162264 */   GIM_Try, /*On fail goto*//*Label 3129*/ GIMT_Encode4(162309), // Rule ID 1157 //
     /* 162269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 162277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 162280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 162286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162298 */     // (intrinsic_wo_chain:{ *:[v8f16] } 576:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FABDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 162298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv8f16),
     /* 162301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162305 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 162307 */     GIR_RootConstrainSelectedInstOperands,
     /* 162308 */     // GIR_Coverage, 1157,
     /* 162308 */     GIR_EraseRootFromParent_Done,
     /* 162309 */   // Label 3129: @162309
     /* 162309 */   GIM_Try, /*On fail goto*//*Label 3130*/ GIMT_Encode4(162354), // Rule ID 1158 //
     /* 162314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 162322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 162325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 162328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 162331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162343 */     // (intrinsic_wo_chain:{ *:[v2f32] } 576:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FABDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 162343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f32),
     /* 162346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162350 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 162352 */     GIR_RootConstrainSelectedInstOperands,
     /* 162353 */     // GIR_Coverage, 1158,
     /* 162353 */     GIR_EraseRootFromParent_Done,
     /* 162354 */   // Label 3130: @162354
     /* 162354 */   GIM_Try, /*On fail goto*//*Label 3131*/ GIMT_Encode4(162399), // Rule ID 1159 //
     /* 162359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 162367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 162370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 162376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162388 */     // (intrinsic_wo_chain:{ *:[v4f32] } 576:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FABDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 162388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f32),
     /* 162391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162395 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 162397 */     GIR_RootConstrainSelectedInstOperands,
     /* 162398 */     // GIR_Coverage, 1159,
     /* 162398 */     GIR_EraseRootFromParent_Done,
     /* 162399 */   // Label 3131: @162399
     /* 162399 */   GIM_Try, /*On fail goto*//*Label 3132*/ GIMT_Encode4(162444), // Rule ID 1160 //
     /* 162404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 162412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 162415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 162418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 162421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162433 */     // (intrinsic_wo_chain:{ *:[v2f64] } 576:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FABDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 162433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f64),
     /* 162436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162440 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 162442 */     GIR_RootConstrainSelectedInstOperands,
     /* 162443 */     // GIR_Coverage, 1160,
     /* 162443 */     GIR_EraseRootFromParent_Done,
     /* 162444 */   // Label 3132: @162444
     /* 162444 */   GIM_Try, /*On fail goto*//*Label 3133*/ GIMT_Encode4(162489), // Rule ID 1162 //
     /* 162449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 162457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 162460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 162463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 162466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162478 */     // (intrinsic_wo_chain:{ *:[v4i16] } 577:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FACGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 162478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f16),
     /* 162481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162485 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 162487 */     GIR_RootConstrainSelectedInstOperands,
     /* 162488 */     // GIR_Coverage, 1162,
     /* 162488 */     GIR_EraseRootFromParent_Done,
     /* 162489 */   // Label 3133: @162489
     /* 162489 */   GIM_Try, /*On fail goto*//*Label 3134*/ GIMT_Encode4(162534), // Rule ID 1164 //
     /* 162494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 162502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 162505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 162511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162523 */     // (intrinsic_wo_chain:{ *:[v8i16] } 577:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FACGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 162523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv8f16),
     /* 162526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162530 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 162532 */     GIR_RootConstrainSelectedInstOperands,
     /* 162533 */     // GIR_Coverage, 1164,
     /* 162533 */     GIR_EraseRootFromParent_Done,
     /* 162534 */   // Label 3134: @162534
     /* 162534 */   GIM_Try, /*On fail goto*//*Label 3135*/ GIMT_Encode4(162579), // Rule ID 1166 //
     /* 162539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 162547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 162550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 162553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 162556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162568 */     // (intrinsic_wo_chain:{ *:[v2i32] } 577:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FACGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 162568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f32),
     /* 162571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 162577 */     GIR_RootConstrainSelectedInstOperands,
     /* 162578 */     // GIR_Coverage, 1166,
     /* 162578 */     GIR_EraseRootFromParent_Done,
     /* 162579 */   // Label 3135: @162579
     /* 162579 */   GIM_Try, /*On fail goto*//*Label 3136*/ GIMT_Encode4(162624), // Rule ID 1168 //
     /* 162584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 162592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 162595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 162601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162613 */     // (intrinsic_wo_chain:{ *:[v4i32] } 577:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FACGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 162613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f32),
     /* 162616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 162622 */     GIR_RootConstrainSelectedInstOperands,
     /* 162623 */     // GIR_Coverage, 1168,
     /* 162623 */     GIR_EraseRootFromParent_Done,
     /* 162624 */   // Label 3136: @162624
     /* 162624 */   GIM_Try, /*On fail goto*//*Label 3137*/ GIMT_Encode4(162669), // Rule ID 1170 //
     /* 162629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 162637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 162640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 162643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 162646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162658 */     // (intrinsic_wo_chain:{ *:[v2i64] } 577:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FACGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 162658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f64),
     /* 162661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162663 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162665 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 162667 */     GIR_RootConstrainSelectedInstOperands,
     /* 162668 */     // GIR_Coverage, 1170,
     /* 162668 */     GIR_EraseRootFromParent_Done,
     /* 162669 */   // Label 3137: @162669
     /* 162669 */   GIM_Try, /*On fail goto*//*Label 3138*/ GIMT_Encode4(162714), // Rule ID 1172 //
     /* 162674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 162682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 162685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 162688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 162691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162703 */     // (intrinsic_wo_chain:{ *:[v4i16] } 578:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FACGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 162703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f16),
     /* 162706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162710 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 162712 */     GIR_RootConstrainSelectedInstOperands,
     /* 162713 */     // GIR_Coverage, 1172,
     /* 162713 */     GIR_EraseRootFromParent_Done,
     /* 162714 */   // Label 3138: @162714
     /* 162714 */   GIM_Try, /*On fail goto*//*Label 3139*/ GIMT_Encode4(162759), // Rule ID 1174 //
     /* 162719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 162727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 162730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 162736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162748 */     // (intrinsic_wo_chain:{ *:[v8i16] } 578:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FACGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 162748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv8f16),
     /* 162751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162755 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 162757 */     GIR_RootConstrainSelectedInstOperands,
     /* 162758 */     // GIR_Coverage, 1174,
     /* 162758 */     GIR_EraseRootFromParent_Done,
     /* 162759 */   // Label 3139: @162759
     /* 162759 */   GIM_Try, /*On fail goto*//*Label 3140*/ GIMT_Encode4(162804), // Rule ID 1176 //
     /* 162764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 162772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 162775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 162778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 162781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162793 */     // (intrinsic_wo_chain:{ *:[v2i32] } 578:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FACGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 162793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f32),
     /* 162796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 162802 */     GIR_RootConstrainSelectedInstOperands,
     /* 162803 */     // GIR_Coverage, 1176,
     /* 162803 */     GIR_EraseRootFromParent_Done,
     /* 162804 */   // Label 3140: @162804
     /* 162804 */   GIM_Try, /*On fail goto*//*Label 3141*/ GIMT_Encode4(162849), // Rule ID 1178 //
     /* 162809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 162817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 162820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 162826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162838 */     // (intrinsic_wo_chain:{ *:[v4i32] } 578:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FACGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 162838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f32),
     /* 162841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162845 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 162847 */     GIR_RootConstrainSelectedInstOperands,
     /* 162848 */     // GIR_Coverage, 1178,
     /* 162848 */     GIR_EraseRootFromParent_Done,
     /* 162849 */   // Label 3141: @162849
     /* 162849 */   GIM_Try, /*On fail goto*//*Label 3142*/ GIMT_Encode4(162894), // Rule ID 1180 //
     /* 162854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 162862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 162865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 162868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 162871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162883 */     // (intrinsic_wo_chain:{ *:[v2i64] } 578:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FACGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 162883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f64),
     /* 162886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162890 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 162892 */     GIR_RootConstrainSelectedInstOperands,
     /* 162893 */     // GIR_Coverage, 1180,
     /* 162893 */     GIR_EraseRootFromParent_Done,
     /* 162894 */   // Label 3142: @162894
     /* 162894 */   GIM_Try, /*On fail goto*//*Label 3143*/ GIMT_Encode4(162939), // Rule ID 1182 //
     /* 162899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 162907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 162910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 162913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 162916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162928 */     // (intrinsic_wo_chain:{ *:[v4f16] } 579:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 162928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f16),
     /* 162931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162935 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 162937 */     GIR_RootConstrainSelectedInstOperands,
     /* 162938 */     // GIR_Coverage, 1182,
     /* 162938 */     GIR_EraseRootFromParent_Done,
     /* 162939 */   // Label 3143: @162939
     /* 162939 */   GIM_Try, /*On fail goto*//*Label 3144*/ GIMT_Encode4(162984), // Rule ID 1184 //
     /* 162944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 162952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 162955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 162961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162973 */     // (intrinsic_wo_chain:{ *:[v8f16] } 579:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 162973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 162976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162978 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162980 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 162982 */     GIR_RootConstrainSelectedInstOperands,
     /* 162983 */     // GIR_Coverage, 1184,
     /* 162983 */     GIR_EraseRootFromParent_Done,
     /* 162984 */   // Label 3144: @162984
     /* 162984 */   GIM_Try, /*On fail goto*//*Label 3145*/ GIMT_Encode4(163029), // Rule ID 1186 //
     /* 162989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 162997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 163006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163018 */     // (intrinsic_wo_chain:{ *:[v2f32] } 579:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 163018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f32),
     /* 163021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163025 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163027 */     GIR_RootConstrainSelectedInstOperands,
     /* 163028 */     // GIR_Coverage, 1186,
     /* 163028 */     GIR_EraseRootFromParent_Done,
     /* 163029 */   // Label 3145: @163029
     /* 163029 */   GIM_Try, /*On fail goto*//*Label 3146*/ GIMT_Encode4(163074), // Rule ID 1188 //
     /* 163034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 163042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 163051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163063 */     // (intrinsic_wo_chain:{ *:[v4f32] } 579:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 163063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 163066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163070 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163072 */     GIR_RootConstrainSelectedInstOperands,
     /* 163073 */     // GIR_Coverage, 1188,
     /* 163073 */     GIR_EraseRootFromParent_Done,
     /* 163074 */   // Label 3146: @163074
     /* 163074 */   GIM_Try, /*On fail goto*//*Label 3147*/ GIMT_Encode4(163119), // Rule ID 1190 //
     /* 163079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 163087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 163090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 163096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163108 */     // (intrinsic_wo_chain:{ *:[v2f64] } 579:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 163108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f64),
     /* 163111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163115 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163117 */     GIR_RootConstrainSelectedInstOperands,
     /* 163118 */     // GIR_Coverage, 1190,
     /* 163118 */     GIR_EraseRootFromParent_Done,
     /* 163119 */   // Label 3147: @163119
     /* 163119 */   GIM_Try, /*On fail goto*//*Label 3148*/ GIMT_Encode4(163164), // Rule ID 1226 //
     /* 163124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 163132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 163135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 163138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 163141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163153 */     // (intrinsic_wo_chain:{ *:[v4f16] } 596:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 163153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv4f16),
     /* 163156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163160 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163162 */     GIR_RootConstrainSelectedInstOperands,
     /* 163163 */     // GIR_Coverage, 1226,
     /* 163163 */     GIR_EraseRootFromParent_Done,
     /* 163164 */   // Label 3148: @163164
     /* 163164 */   GIM_Try, /*On fail goto*//*Label 3149*/ GIMT_Encode4(163209), // Rule ID 1227 //
     /* 163169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 163177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 163180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 163183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 163186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163198 */     // (intrinsic_wo_chain:{ *:[v8f16] } 596:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 163198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv8f16),
     /* 163201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163205 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163207 */     GIR_RootConstrainSelectedInstOperands,
     /* 163208 */     // GIR_Coverage, 1227,
     /* 163208 */     GIR_EraseRootFromParent_Done,
     /* 163209 */   // Label 3149: @163209
     /* 163209 */   GIM_Try, /*On fail goto*//*Label 3150*/ GIMT_Encode4(163254), // Rule ID 1228 //
     /* 163214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 163222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 163231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163243 */     // (intrinsic_wo_chain:{ *:[v2f32] } 596:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 163243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2f32),
     /* 163246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163250 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163252 */     GIR_RootConstrainSelectedInstOperands,
     /* 163253 */     // GIR_Coverage, 1228,
     /* 163253 */     GIR_EraseRootFromParent_Done,
     /* 163254 */   // Label 3150: @163254
     /* 163254 */   GIM_Try, /*On fail goto*//*Label 3151*/ GIMT_Encode4(163299), // Rule ID 1229 //
     /* 163259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 163267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 163276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163288 */     // (intrinsic_wo_chain:{ *:[v4f32] } 596:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 163288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv4f32),
     /* 163291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163295 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163297 */     GIR_RootConstrainSelectedInstOperands,
     /* 163298 */     // GIR_Coverage, 1229,
     /* 163298 */     GIR_EraseRootFromParent_Done,
     /* 163299 */   // Label 3151: @163299
     /* 163299 */   GIM_Try, /*On fail goto*//*Label 3152*/ GIMT_Encode4(163344), // Rule ID 1230 //
     /* 163304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 163312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 163315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 163321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163333 */     // (intrinsic_wo_chain:{ *:[v2f64] } 596:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 163333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2f64),
     /* 163336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163338 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163340 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163342 */     GIR_RootConstrainSelectedInstOperands,
     /* 163343 */     // GIR_Coverage, 1230,
     /* 163343 */     GIR_EraseRootFromParent_Done,
     /* 163344 */   // Label 3152: @163344
     /* 163344 */   GIM_Try, /*On fail goto*//*Label 3153*/ GIMT_Encode4(163389), // Rule ID 1241 //
     /* 163349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 163357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 163360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 163363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 163366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163378 */     // (intrinsic_wo_chain:{ *:[v4f16] } 598:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 163378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv4f16),
     /* 163381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163383 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163385 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163387 */     GIR_RootConstrainSelectedInstOperands,
     /* 163388 */     // GIR_Coverage, 1241,
     /* 163388 */     GIR_EraseRootFromParent_Done,
     /* 163389 */   // Label 3153: @163389
     /* 163389 */   GIM_Try, /*On fail goto*//*Label 3154*/ GIMT_Encode4(163434), // Rule ID 1242 //
     /* 163394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 163402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 163405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 163408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 163411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163423 */     // (intrinsic_wo_chain:{ *:[v8f16] } 598:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 163423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv8f16),
     /* 163426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163430 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163432 */     GIR_RootConstrainSelectedInstOperands,
     /* 163433 */     // GIR_Coverage, 1242,
     /* 163433 */     GIR_EraseRootFromParent_Done,
     /* 163434 */   // Label 3154: @163434
     /* 163434 */   GIM_Try, /*On fail goto*//*Label 3155*/ GIMT_Encode4(163479), // Rule ID 1243 //
     /* 163439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 163447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 163456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163468 */     // (intrinsic_wo_chain:{ *:[v2f32] } 598:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 163468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2f32),
     /* 163471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163475 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163477 */     GIR_RootConstrainSelectedInstOperands,
     /* 163478 */     // GIR_Coverage, 1243,
     /* 163478 */     GIR_EraseRootFromParent_Done,
     /* 163479 */   // Label 3155: @163479
     /* 163479 */   GIM_Try, /*On fail goto*//*Label 3156*/ GIMT_Encode4(163524), // Rule ID 1244 //
     /* 163484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 163492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 163501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163513 */     // (intrinsic_wo_chain:{ *:[v4f32] } 598:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 163513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv4f32),
     /* 163516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163520 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163522 */     GIR_RootConstrainSelectedInstOperands,
     /* 163523 */     // GIR_Coverage, 1244,
     /* 163523 */     GIR_EraseRootFromParent_Done,
     /* 163524 */   // Label 3156: @163524
     /* 163524 */   GIM_Try, /*On fail goto*//*Label 3157*/ GIMT_Encode4(163569), // Rule ID 1245 //
     /* 163529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 163537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 163540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 163546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163558 */     // (intrinsic_wo_chain:{ *:[v2f64] } 598:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 163558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2f64),
     /* 163561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163565 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163567 */     GIR_RootConstrainSelectedInstOperands,
     /* 163568 */     // GIR_Coverage, 1245,
     /* 163568 */     GIR_EraseRootFromParent_Done,
     /* 163569 */   // Label 3157: @163569
     /* 163569 */   GIM_Try, /*On fail goto*//*Label 3158*/ GIMT_Encode4(163614), // Rule ID 1256 //
     /* 163574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 163582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 163585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 163588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 163591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163603 */     // (intrinsic_wo_chain:{ *:[v4f16] } 602:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 163603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv4f16),
     /* 163606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163610 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163612 */     GIR_RootConstrainSelectedInstOperands,
     /* 163613 */     // GIR_Coverage, 1256,
     /* 163613 */     GIR_EraseRootFromParent_Done,
     /* 163614 */   // Label 3158: @163614
     /* 163614 */   GIM_Try, /*On fail goto*//*Label 3159*/ GIMT_Encode4(163659), // Rule ID 1257 //
     /* 163619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 163627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 163630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 163633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 163636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163648 */     // (intrinsic_wo_chain:{ *:[v8f16] } 602:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 163648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv8f16),
     /* 163651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163655 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163657 */     GIR_RootConstrainSelectedInstOperands,
     /* 163658 */     // GIR_Coverage, 1257,
     /* 163658 */     GIR_EraseRootFromParent_Done,
     /* 163659 */   // Label 3159: @163659
     /* 163659 */   GIM_Try, /*On fail goto*//*Label 3160*/ GIMT_Encode4(163704), // Rule ID 1258 //
     /* 163664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 163672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 163681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163693 */     // (intrinsic_wo_chain:{ *:[v2f32] } 602:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 163693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2f32),
     /* 163696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163700 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163702 */     GIR_RootConstrainSelectedInstOperands,
     /* 163703 */     // GIR_Coverage, 1258,
     /* 163703 */     GIR_EraseRootFromParent_Done,
     /* 163704 */   // Label 3160: @163704
     /* 163704 */   GIM_Try, /*On fail goto*//*Label 3161*/ GIMT_Encode4(163749), // Rule ID 1259 //
     /* 163709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 163717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 163726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163738 */     // (intrinsic_wo_chain:{ *:[v4f32] } 602:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 163738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv4f32),
     /* 163741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163743 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163745 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163747 */     GIR_RootConstrainSelectedInstOperands,
     /* 163748 */     // GIR_Coverage, 1259,
     /* 163748 */     GIR_EraseRootFromParent_Done,
     /* 163749 */   // Label 3161: @163749
     /* 163749 */   GIM_Try, /*On fail goto*//*Label 3162*/ GIMT_Encode4(163794), // Rule ID 1260 //
     /* 163754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 163762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 163765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 163771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163783 */     // (intrinsic_wo_chain:{ *:[v2f64] } 602:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 163783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2f64),
     /* 163786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163788 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163790 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163792 */     GIR_RootConstrainSelectedInstOperands,
     /* 163793 */     // GIR_Coverage, 1260,
     /* 163793 */     GIR_EraseRootFromParent_Done,
     /* 163794 */   // Label 3162: @163794
     /* 163794 */   GIM_Try, /*On fail goto*//*Label 3163*/ GIMT_Encode4(163839), // Rule ID 1271 //
     /* 163799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 163807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 163810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 163813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 163816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163828 */     // (intrinsic_wo_chain:{ *:[v4f16] } 604:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 163828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv4f16),
     /* 163831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163835 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163837 */     GIR_RootConstrainSelectedInstOperands,
     /* 163838 */     // GIR_Coverage, 1271,
     /* 163838 */     GIR_EraseRootFromParent_Done,
     /* 163839 */   // Label 3163: @163839
     /* 163839 */   GIM_Try, /*On fail goto*//*Label 3164*/ GIMT_Encode4(163884), // Rule ID 1272 //
     /* 163844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 163852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 163855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 163858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 163861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163873 */     // (intrinsic_wo_chain:{ *:[v8f16] } 604:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 163873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv8f16),
     /* 163876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163882 */     GIR_RootConstrainSelectedInstOperands,
     /* 163883 */     // GIR_Coverage, 1272,
     /* 163883 */     GIR_EraseRootFromParent_Done,
     /* 163884 */   // Label 3164: @163884
     /* 163884 */   GIM_Try, /*On fail goto*//*Label 3165*/ GIMT_Encode4(163929), // Rule ID 1273 //
     /* 163889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 163897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 163906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163918 */     // (intrinsic_wo_chain:{ *:[v2f32] } 604:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 163918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2f32),
     /* 163921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163925 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163927 */     GIR_RootConstrainSelectedInstOperands,
     /* 163928 */     // GIR_Coverage, 1273,
     /* 163928 */     GIR_EraseRootFromParent_Done,
     /* 163929 */   // Label 3165: @163929
     /* 163929 */   GIM_Try, /*On fail goto*//*Label 3166*/ GIMT_Encode4(163974), // Rule ID 1274 //
     /* 163934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 163942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 163951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163963 */     // (intrinsic_wo_chain:{ *:[v4f32] } 604:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 163963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv4f32),
     /* 163966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163970 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 163972 */     GIR_RootConstrainSelectedInstOperands,
     /* 163973 */     // GIR_Coverage, 1274,
     /* 163973 */     GIR_EraseRootFromParent_Done,
     /* 163974 */   // Label 3166: @163974
     /* 163974 */   GIM_Try, /*On fail goto*//*Label 3167*/ GIMT_Encode4(164019), // Rule ID 1275 //
     /* 163979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 163987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 163990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 163996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164008 */     // (intrinsic_wo_chain:{ *:[v2f64] } 604:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 164008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2f64),
     /* 164011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164015 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164017 */     GIR_RootConstrainSelectedInstOperands,
     /* 164018 */     // GIR_Coverage, 1275,
     /* 164018 */     GIR_EraseRootFromParent_Done,
     /* 164019 */   // Label 3167: @164019
     /* 164019 */   GIM_Try, /*On fail goto*//*Label 3168*/ GIMT_Encode4(164064), // Rule ID 1306 //
     /* 164024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 164027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 164032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 164035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 164038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 164041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164053 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 164053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4f16),
     /* 164056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164058 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164060 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164062 */     GIR_RootConstrainSelectedInstOperands,
     /* 164063 */     // GIR_Coverage, 1306,
     /* 164063 */     GIR_EraseRootFromParent_Done,
     /* 164064 */   // Label 3168: @164064
     /* 164064 */   GIM_Try, /*On fail goto*//*Label 3169*/ GIMT_Encode4(164109), // Rule ID 1307 //
     /* 164069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 164072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 164077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 164080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 164083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 164086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164098 */     // (intrinsic_wo_chain:{ *:[v8f16] } 610:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 164098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8f16),
     /* 164101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164105 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164107 */     GIR_RootConstrainSelectedInstOperands,
     /* 164108 */     // GIR_Coverage, 1307,
     /* 164108 */     GIR_EraseRootFromParent_Done,
     /* 164109 */   // Label 3169: @164109
     /* 164109 */   GIM_Try, /*On fail goto*//*Label 3170*/ GIMT_Encode4(164154), // Rule ID 1308 //
     /* 164114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 164122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 164128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 164131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164143 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 164143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2f32),
     /* 164146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164152 */     GIR_RootConstrainSelectedInstOperands,
     /* 164153 */     // GIR_Coverage, 1308,
     /* 164153 */     GIR_EraseRootFromParent_Done,
     /* 164154 */   // Label 3170: @164154
     /* 164154 */   GIM_Try, /*On fail goto*//*Label 3171*/ GIMT_Encode4(164199), // Rule ID 1309 //
     /* 164159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 164167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 164170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 164176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164188 */     // (intrinsic_wo_chain:{ *:[v4f32] } 610:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 164188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4f32),
     /* 164191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164195 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164197 */     GIR_RootConstrainSelectedInstOperands,
     /* 164198 */     // GIR_Coverage, 1309,
     /* 164198 */     GIR_EraseRootFromParent_Done,
     /* 164199 */   // Label 3171: @164199
     /* 164199 */   GIM_Try, /*On fail goto*//*Label 3172*/ GIMT_Encode4(164244), // Rule ID 1310 //
     /* 164204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 164212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 164215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 164218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 164221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164233 */     // (intrinsic_wo_chain:{ *:[v2f64] } 610:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 164233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2f64),
     /* 164236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164240 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164242 */     GIR_RootConstrainSelectedInstOperands,
     /* 164243 */     // GIR_Coverage, 1310,
     /* 164243 */     GIR_EraseRootFromParent_Done,
     /* 164244 */   // Label 3172: @164244
     /* 164244 */   GIM_Try, /*On fail goto*//*Label 3173*/ GIMT_Encode4(164289), // Rule ID 1321 //
     /* 164249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 164252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 164257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 164260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 164263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 164266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164278 */     // (intrinsic_wo_chain:{ *:[v4f16] } 633:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FRECPSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 164278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv4f16),
     /* 164281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164285 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164287 */     GIR_RootConstrainSelectedInstOperands,
     /* 164288 */     // GIR_Coverage, 1321,
     /* 164288 */     GIR_EraseRootFromParent_Done,
     /* 164289 */   // Label 3173: @164289
     /* 164289 */   GIM_Try, /*On fail goto*//*Label 3174*/ GIMT_Encode4(164334), // Rule ID 1322 //
     /* 164294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 164297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 164302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 164305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 164308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 164311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164323 */     // (intrinsic_wo_chain:{ *:[v8f16] } 633:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FRECPSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 164323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv8f16),
     /* 164326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164332 */     GIR_RootConstrainSelectedInstOperands,
     /* 164333 */     // GIR_Coverage, 1322,
     /* 164333 */     GIR_EraseRootFromParent_Done,
     /* 164334 */   // Label 3174: @164334
     /* 164334 */   GIM_Try, /*On fail goto*//*Label 3175*/ GIMT_Encode4(164379), // Rule ID 1323 //
     /* 164339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 164347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 164353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 164356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164368 */     // (intrinsic_wo_chain:{ *:[v2f32] } 633:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FRECPSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 164368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv2f32),
     /* 164371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164375 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164377 */     GIR_RootConstrainSelectedInstOperands,
     /* 164378 */     // GIR_Coverage, 1323,
     /* 164378 */     GIR_EraseRootFromParent_Done,
     /* 164379 */   // Label 3175: @164379
     /* 164379 */   GIM_Try, /*On fail goto*//*Label 3176*/ GIMT_Encode4(164424), // Rule ID 1324 //
     /* 164384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 164392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 164395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 164401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164413 */     // (intrinsic_wo_chain:{ *:[v4f32] } 633:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FRECPSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 164413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv4f32),
     /* 164416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164418 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164420 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164422 */     GIR_RootConstrainSelectedInstOperands,
     /* 164423 */     // GIR_Coverage, 1324,
     /* 164423 */     GIR_EraseRootFromParent_Done,
     /* 164424 */   // Label 3176: @164424
     /* 164424 */   GIM_Try, /*On fail goto*//*Label 3177*/ GIMT_Encode4(164469), // Rule ID 1325 //
     /* 164429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 164437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 164440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 164443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 164446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164458 */     // (intrinsic_wo_chain:{ *:[v2f64] } 633:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FRECPSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 164458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv2f64),
     /* 164461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164465 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164467 */     GIR_RootConstrainSelectedInstOperands,
     /* 164468 */     // GIR_Coverage, 1325,
     /* 164468 */     GIR_EraseRootFromParent_Done,
     /* 164469 */   // Label 3177: @164469
     /* 164469 */   GIM_Try, /*On fail goto*//*Label 3178*/ GIMT_Encode4(164514), // Rule ID 1326 //
     /* 164474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 164477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 164482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 164485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 164488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 164491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164503 */     // (intrinsic_wo_chain:{ *:[v4f16] } 640:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FRSQRTSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 164503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv4f16),
     /* 164506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164510 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164512 */     GIR_RootConstrainSelectedInstOperands,
     /* 164513 */     // GIR_Coverage, 1326,
     /* 164513 */     GIR_EraseRootFromParent_Done,
     /* 164514 */   // Label 3178: @164514
     /* 164514 */   GIM_Try, /*On fail goto*//*Label 3179*/ GIMT_Encode4(164559), // Rule ID 1327 //
     /* 164519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 164522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 164527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 164530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 164533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 164536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164548 */     // (intrinsic_wo_chain:{ *:[v8f16] } 640:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FRSQRTSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 164548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv8f16),
     /* 164551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164555 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164557 */     GIR_RootConstrainSelectedInstOperands,
     /* 164558 */     // GIR_Coverage, 1327,
     /* 164558 */     GIR_EraseRootFromParent_Done,
     /* 164559 */   // Label 3179: @164559
     /* 164559 */   GIM_Try, /*On fail goto*//*Label 3180*/ GIMT_Encode4(164604), // Rule ID 1328 //
     /* 164564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 164572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 164578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 164581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164593 */     // (intrinsic_wo_chain:{ *:[v2f32] } 640:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FRSQRTSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 164593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv2f32),
     /* 164596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164602 */     GIR_RootConstrainSelectedInstOperands,
     /* 164603 */     // GIR_Coverage, 1328,
     /* 164603 */     GIR_EraseRootFromParent_Done,
     /* 164604 */   // Label 3180: @164604
     /* 164604 */   GIM_Try, /*On fail goto*//*Label 3181*/ GIMT_Encode4(164649), // Rule ID 1329 //
     /* 164609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 164617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 164620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 164626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164638 */     // (intrinsic_wo_chain:{ *:[v4f32] } 640:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FRSQRTSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 164638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv4f32),
     /* 164641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164645 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164647 */     GIR_RootConstrainSelectedInstOperands,
     /* 164648 */     // GIR_Coverage, 1329,
     /* 164648 */     GIR_EraseRootFromParent_Done,
     /* 164649 */   // Label 3181: @164649
     /* 164649 */   GIM_Try, /*On fail goto*//*Label 3182*/ GIMT_Encode4(164694), // Rule ID 1330 //
     /* 164654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 164662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 164665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 164668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 164671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164683 */     // (intrinsic_wo_chain:{ *:[v2f64] } 640:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FRSQRTSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 164683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv2f64),
     /* 164686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164688 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164690 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164692 */     GIR_RootConstrainSelectedInstOperands,
     /* 164693 */     // GIR_Coverage, 1330,
     /* 164693 */     GIR_EraseRootFromParent_Done,
     /* 164694 */   // Label 3182: @164694
     /* 164694 */   GIM_Try, /*On fail goto*//*Label 3183*/ GIMT_Encode4(164739), // Rule ID 1347 //
     /* 164699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_pmul),
     /* 164707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 164710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 164713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 164716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164728 */     // (intrinsic_wo_chain:{ *:[v8i8] } 653:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (PMULv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 164728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULv8i8),
     /* 164731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164733 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164735 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164737 */     GIR_RootConstrainSelectedInstOperands,
     /* 164738 */     // GIR_Coverage, 1347,
     /* 164738 */     GIR_EraseRootFromParent_Done,
     /* 164739 */   // Label 3183: @164739
     /* 164739 */   GIM_Try, /*On fail goto*//*Label 3184*/ GIMT_Encode4(164784), // Rule ID 1348 //
     /* 164744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_pmul),
     /* 164752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 164755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 164758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 164761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164773 */     // (intrinsic_wo_chain:{ *:[v16i8] } 653:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (PMULv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 164773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULv16i8),
     /* 164776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164782 */     GIR_RootConstrainSelectedInstOperands,
     /* 164783 */     // GIR_Coverage, 1348,
     /* 164783 */     GIR_EraseRootFromParent_Done,
     /* 164784 */   // Label 3184: @164784
     /* 164784 */   GIM_Try, /*On fail goto*//*Label 3185*/ GIMT_Encode4(164829), // Rule ID 1362 //
     /* 164789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 164797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 164800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 164803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 164806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164818 */     // (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SABDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 164818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv8i8),
     /* 164821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164825 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164827 */     GIR_RootConstrainSelectedInstOperands,
     /* 164828 */     // GIR_Coverage, 1362,
     /* 164828 */     GIR_EraseRootFromParent_Done,
     /* 164829 */   // Label 3185: @164829
     /* 164829 */   GIM_Try, /*On fail goto*//*Label 3186*/ GIMT_Encode4(164874), // Rule ID 1364 //
     /* 164834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 164842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 164845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 164848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 164851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164863 */     // (intrinsic_wo_chain:{ *:[v16i8] } 659:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SABDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 164863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv16i8),
     /* 164866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164868 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164870 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164872 */     GIR_RootConstrainSelectedInstOperands,
     /* 164873 */     // GIR_Coverage, 1364,
     /* 164873 */     GIR_EraseRootFromParent_Done,
     /* 164874 */   // Label 3186: @164874
     /* 164874 */   GIM_Try, /*On fail goto*//*Label 3187*/ GIMT_Encode4(164919), // Rule ID 1366 //
     /* 164879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 164887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 164890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 164893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 164896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164908 */     // (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SABDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 164908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv4i16),
     /* 164911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164915 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164917 */     GIR_RootConstrainSelectedInstOperands,
     /* 164918 */     // GIR_Coverage, 1366,
     /* 164918 */     GIR_EraseRootFromParent_Done,
     /* 164919 */   // Label 3187: @164919
     /* 164919 */   GIM_Try, /*On fail goto*//*Label 3188*/ GIMT_Encode4(164964), // Rule ID 1368 //
     /* 164924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 164932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 164935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 164938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 164941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164953 */     // (intrinsic_wo_chain:{ *:[v8i16] } 659:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SABDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 164953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv8i16),
     /* 164956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 164962 */     GIR_RootConstrainSelectedInstOperands,
     /* 164963 */     // GIR_Coverage, 1368,
     /* 164963 */     GIR_EraseRootFromParent_Done,
     /* 164964 */   // Label 3188: @164964
     /* 164964 */   GIM_Try, /*On fail goto*//*Label 3189*/ GIMT_Encode4(165009), // Rule ID 1370 //
     /* 164969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 164977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 164983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 164986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164998 */     // (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SABDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 164998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv2i32),
     /* 165001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165005 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165007 */     GIR_RootConstrainSelectedInstOperands,
     /* 165008 */     // GIR_Coverage, 1370,
     /* 165008 */     GIR_EraseRootFromParent_Done,
     /* 165009 */   // Label 3189: @165009
     /* 165009 */   GIM_Try, /*On fail goto*//*Label 3190*/ GIMT_Encode4(165054), // Rule ID 1372 //
     /* 165014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 165022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 165025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 165031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165043 */     // (intrinsic_wo_chain:{ *:[v4i32] } 659:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SABDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 165043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv4i32),
     /* 165046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165048 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165050 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165052 */     GIR_RootConstrainSelectedInstOperands,
     /* 165053 */     // GIR_Coverage, 1372,
     /* 165053 */     GIR_EraseRootFromParent_Done,
     /* 165054 */   // Label 3190: @165054
     /* 165054 */   GIM_Try, /*On fail goto*//*Label 3191*/ GIMT_Encode4(165099), // Rule ID 1379 //
     /* 165059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 165067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 165070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 165073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 165076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165088 */     // (intrinsic_wo_chain:{ *:[v8i8] } 669:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SHSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 165088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv8i8),
     /* 165091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165095 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165097 */     GIR_RootConstrainSelectedInstOperands,
     /* 165098 */     // GIR_Coverage, 1379,
     /* 165098 */     GIR_EraseRootFromParent_Done,
     /* 165099 */   // Label 3191: @165099
     /* 165099 */   GIM_Try, /*On fail goto*//*Label 3192*/ GIMT_Encode4(165144), // Rule ID 1380 //
     /* 165104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 165112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 165115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 165118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 165121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165133 */     // (intrinsic_wo_chain:{ *:[v16i8] } 669:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SHSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 165133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv16i8),
     /* 165136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165138 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165140 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165142 */     GIR_RootConstrainSelectedInstOperands,
     /* 165143 */     // GIR_Coverage, 1380,
     /* 165143 */     GIR_EraseRootFromParent_Done,
     /* 165144 */   // Label 3192: @165144
     /* 165144 */   GIM_Try, /*On fail goto*//*Label 3193*/ GIMT_Encode4(165189), // Rule ID 1381 //
     /* 165149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 165157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 165160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 165163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 165166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165178 */     // (intrinsic_wo_chain:{ *:[v4i16] } 669:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SHSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 165178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv4i16),
     /* 165181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165185 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165187 */     GIR_RootConstrainSelectedInstOperands,
     /* 165188 */     // GIR_Coverage, 1381,
     /* 165188 */     GIR_EraseRootFromParent_Done,
     /* 165189 */   // Label 3193: @165189
     /* 165189 */   GIM_Try, /*On fail goto*//*Label 3194*/ GIMT_Encode4(165234), // Rule ID 1382 //
     /* 165194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 165202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 165205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 165208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 165211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165223 */     // (intrinsic_wo_chain:{ *:[v8i16] } 669:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SHSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 165223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv8i16),
     /* 165226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165230 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165232 */     GIR_RootConstrainSelectedInstOperands,
     /* 165233 */     // GIR_Coverage, 1382,
     /* 165233 */     GIR_EraseRootFromParent_Done,
     /* 165234 */   // Label 3194: @165234
     /* 165234 */   GIM_Try, /*On fail goto*//*Label 3195*/ GIMT_Encode4(165279), // Rule ID 1383 //
     /* 165239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 165247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 165250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 165253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 165256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165268 */     // (intrinsic_wo_chain:{ *:[v2i32] } 669:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SHSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 165268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv2i32),
     /* 165271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165273 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165275 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165277 */     GIR_RootConstrainSelectedInstOperands,
     /* 165278 */     // GIR_Coverage, 1383,
     /* 165278 */     GIR_EraseRootFromParent_Done,
     /* 165279 */   // Label 3195: @165279
     /* 165279 */   GIM_Try, /*On fail goto*//*Label 3196*/ GIMT_Encode4(165324), // Rule ID 1384 //
     /* 165284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 165292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 165295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 165301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165313 */     // (intrinsic_wo_chain:{ *:[v4i32] } 669:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 165313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv4i32),
     /* 165316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165320 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165322 */     GIR_RootConstrainSelectedInstOperands,
     /* 165323 */     // GIR_Coverage, 1384,
     /* 165323 */     GIR_EraseRootFromParent_Done,
     /* 165324 */   // Label 3196: @165324
     /* 165324 */   GIM_Try, /*On fail goto*//*Label 3197*/ GIMT_Encode4(165369), // Rule ID 1385 //
     /* 165329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 165337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 165340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 165343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 165346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165358 */     // (intrinsic_wo_chain:{ *:[v8i8] } 671:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMAXPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 165358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv8i8),
     /* 165361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165363 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165365 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165367 */     GIR_RootConstrainSelectedInstOperands,
     /* 165368 */     // GIR_Coverage, 1385,
     /* 165368 */     GIR_EraseRootFromParent_Done,
     /* 165369 */   // Label 3197: @165369
     /* 165369 */   GIM_Try, /*On fail goto*//*Label 3198*/ GIMT_Encode4(165414), // Rule ID 1386 //
     /* 165374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 165382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 165385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 165388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 165391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165403 */     // (intrinsic_wo_chain:{ *:[v16i8] } 671:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMAXPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 165403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv16i8),
     /* 165406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165410 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165412 */     GIR_RootConstrainSelectedInstOperands,
     /* 165413 */     // GIR_Coverage, 1386,
     /* 165413 */     GIR_EraseRootFromParent_Done,
     /* 165414 */   // Label 3198: @165414
     /* 165414 */   GIM_Try, /*On fail goto*//*Label 3199*/ GIMT_Encode4(165459), // Rule ID 1387 //
     /* 165419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 165427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 165430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 165433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 165436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165448 */     // (intrinsic_wo_chain:{ *:[v4i16] } 671:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMAXPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 165448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv4i16),
     /* 165451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165455 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165457 */     GIR_RootConstrainSelectedInstOperands,
     /* 165458 */     // GIR_Coverage, 1387,
     /* 165458 */     GIR_EraseRootFromParent_Done,
     /* 165459 */   // Label 3199: @165459
     /* 165459 */   GIM_Try, /*On fail goto*//*Label 3200*/ GIMT_Encode4(165504), // Rule ID 1388 //
     /* 165464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 165472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 165475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 165478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 165481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165493 */     // (intrinsic_wo_chain:{ *:[v8i16] } 671:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMAXPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 165493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv8i16),
     /* 165496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165500 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165502 */     GIR_RootConstrainSelectedInstOperands,
     /* 165503 */     // GIR_Coverage, 1388,
     /* 165503 */     GIR_EraseRootFromParent_Done,
     /* 165504 */   // Label 3200: @165504
     /* 165504 */   GIM_Try, /*On fail goto*//*Label 3201*/ GIMT_Encode4(165549), // Rule ID 1389 //
     /* 165509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 165517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 165520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 165523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 165526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165538 */     // (intrinsic_wo_chain:{ *:[v2i32] } 671:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMAXPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 165538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
     /* 165541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165545 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165547 */     GIR_RootConstrainSelectedInstOperands,
     /* 165548 */     // GIR_Coverage, 1389,
     /* 165548 */     GIR_EraseRootFromParent_Done,
     /* 165549 */   // Label 3201: @165549
     /* 165549 */   GIM_Try, /*On fail goto*//*Label 3202*/ GIMT_Encode4(165594), // Rule ID 1390 //
     /* 165554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 165562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 165565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 165571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165583 */     // (intrinsic_wo_chain:{ *:[v4i32] } 671:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMAXPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 165583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv4i32),
     /* 165586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165592 */     GIR_RootConstrainSelectedInstOperands,
     /* 165593 */     // GIR_Coverage, 1390,
     /* 165593 */     GIR_EraseRootFromParent_Done,
     /* 165594 */   // Label 3202: @165594
     /* 165594 */   GIM_Try, /*On fail goto*//*Label 3203*/ GIMT_Encode4(165639), // Rule ID 1397 //
     /* 165599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 165607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 165610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 165613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 165616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165628 */     // (intrinsic_wo_chain:{ *:[v8i8] } 674:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMINPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 165628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv8i8),
     /* 165631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165635 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165637 */     GIR_RootConstrainSelectedInstOperands,
     /* 165638 */     // GIR_Coverage, 1397,
     /* 165638 */     GIR_EraseRootFromParent_Done,
     /* 165639 */   // Label 3203: @165639
     /* 165639 */   GIM_Try, /*On fail goto*//*Label 3204*/ GIMT_Encode4(165684), // Rule ID 1398 //
     /* 165644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 165652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 165655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 165658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 165661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165673 */     // (intrinsic_wo_chain:{ *:[v16i8] } 674:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMINPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 165673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv16i8),
     /* 165676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165682 */     GIR_RootConstrainSelectedInstOperands,
     /* 165683 */     // GIR_Coverage, 1398,
     /* 165683 */     GIR_EraseRootFromParent_Done,
     /* 165684 */   // Label 3204: @165684
     /* 165684 */   GIM_Try, /*On fail goto*//*Label 3205*/ GIMT_Encode4(165729), // Rule ID 1399 //
     /* 165689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 165697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 165700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 165703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 165706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165718 */     // (intrinsic_wo_chain:{ *:[v4i16] } 674:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMINPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 165718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv4i16),
     /* 165721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165725 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165727 */     GIR_RootConstrainSelectedInstOperands,
     /* 165728 */     // GIR_Coverage, 1399,
     /* 165728 */     GIR_EraseRootFromParent_Done,
     /* 165729 */   // Label 3205: @165729
     /* 165729 */   GIM_Try, /*On fail goto*//*Label 3206*/ GIMT_Encode4(165774), // Rule ID 1400 //
     /* 165734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 165742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 165745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 165748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 165751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165763 */     // (intrinsic_wo_chain:{ *:[v8i16] } 674:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMINPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 165763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv8i16),
     /* 165766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165768 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165770 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165772 */     GIR_RootConstrainSelectedInstOperands,
     /* 165773 */     // GIR_Coverage, 1400,
     /* 165773 */     GIR_EraseRootFromParent_Done,
     /* 165774 */   // Label 3206: @165774
     /* 165774 */   GIM_Try, /*On fail goto*//*Label 3207*/ GIMT_Encode4(165819), // Rule ID 1401 //
     /* 165779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 165787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 165790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 165793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 165796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165808 */     // (intrinsic_wo_chain:{ *:[v2i32] } 674:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMINPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 165808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
     /* 165811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165815 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165817 */     GIR_RootConstrainSelectedInstOperands,
     /* 165818 */     // GIR_Coverage, 1401,
     /* 165818 */     GIR_EraseRootFromParent_Done,
     /* 165819 */   // Label 3207: @165819
     /* 165819 */   GIM_Try, /*On fail goto*//*Label 3208*/ GIMT_Encode4(165864), // Rule ID 1402 //
     /* 165824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 165832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 165835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 165841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165853 */     // (intrinsic_wo_chain:{ *:[v4i32] } 674:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMINPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 165853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv4i32),
     /* 165856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165858 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165860 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165862 */     GIR_RootConstrainSelectedInstOperands,
     /* 165863 */     // GIR_Coverage, 1402,
     /* 165863 */     GIR_EraseRootFromParent_Done,
     /* 165864 */   // Label 3208: @165864
     /* 165864 */   GIM_Try, /*On fail goto*//*Label 3209*/ GIMT_Encode4(165909), // Rule ID 1409 //
     /* 165869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 165877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 165880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 165883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 165886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165898 */     // (intrinsic_wo_chain:{ *:[v8i8] } 679:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 165898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i8),
     /* 165901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165905 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165907 */     GIR_RootConstrainSelectedInstOperands,
     /* 165908 */     // GIR_Coverage, 1409,
     /* 165908 */     GIR_EraseRootFromParent_Done,
     /* 165909 */   // Label 3209: @165909
     /* 165909 */   GIM_Try, /*On fail goto*//*Label 3210*/ GIMT_Encode4(165954), // Rule ID 1410 //
     /* 165914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 165922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 165925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 165928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 165931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165943 */     // (intrinsic_wo_chain:{ *:[v16i8] } 679:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 165943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv16i8),
     /* 165946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165950 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165952 */     GIR_RootConstrainSelectedInstOperands,
     /* 165953 */     // GIR_Coverage, 1410,
     /* 165953 */     GIR_EraseRootFromParent_Done,
     /* 165954 */   // Label 3210: @165954
     /* 165954 */   GIM_Try, /*On fail goto*//*Label 3211*/ GIMT_Encode4(165999), // Rule ID 1411 //
     /* 165959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 165967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 165970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 165973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 165976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165988 */     // (intrinsic_wo_chain:{ *:[v4i16] } 679:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 165988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i16),
     /* 165991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165995 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 165997 */     GIR_RootConstrainSelectedInstOperands,
     /* 165998 */     // GIR_Coverage, 1411,
     /* 165998 */     GIR_EraseRootFromParent_Done,
     /* 165999 */   // Label 3211: @165999
     /* 165999 */   GIM_Try, /*On fail goto*//*Label 3212*/ GIMT_Encode4(166044), // Rule ID 1412 //
     /* 166004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 166012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 166015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 166018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 166021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166033 */     // (intrinsic_wo_chain:{ *:[v8i16] } 679:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 166033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i16),
     /* 166036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166038 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166040 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166042 */     GIR_RootConstrainSelectedInstOperands,
     /* 166043 */     // GIR_Coverage, 1412,
     /* 166043 */     GIR_EraseRootFromParent_Done,
     /* 166044 */   // Label 3212: @166044
     /* 166044 */   GIM_Try, /*On fail goto*//*Label 3213*/ GIMT_Encode4(166089), // Rule ID 1413 //
     /* 166049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 166057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 166060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 166063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 166066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166078 */     // (intrinsic_wo_chain:{ *:[v2i32] } 679:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 166078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i32),
     /* 166081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166085 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166087 */     GIR_RootConstrainSelectedInstOperands,
     /* 166088 */     // GIR_Coverage, 1413,
     /* 166088 */     GIR_EraseRootFromParent_Done,
     /* 166089 */   // Label 3213: @166089
     /* 166089 */   GIM_Try, /*On fail goto*//*Label 3214*/ GIMT_Encode4(166134), // Rule ID 1414 //
     /* 166094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 166102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 166105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 166111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166123 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 166123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i32),
     /* 166126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166130 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166132 */     GIR_RootConstrainSelectedInstOperands,
     /* 166133 */     // GIR_Coverage, 1414,
     /* 166133 */     GIR_EraseRootFromParent_Done,
     /* 166134 */   // Label 3214: @166134
     /* 166134 */   GIM_Try, /*On fail goto*//*Label 3215*/ GIMT_Encode4(166179), // Rule ID 1415 //
     /* 166139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 166147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 166150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 166153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 166156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166168 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 166168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i64),
     /* 166171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166175 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166177 */     GIR_RootConstrainSelectedInstOperands,
     /* 166178 */     // GIR_Coverage, 1415,
     /* 166178 */     GIR_EraseRootFromParent_Done,
     /* 166179 */   // Label 3215: @166179
     /* 166179 */   GIM_Try, /*On fail goto*//*Label 3216*/ GIMT_Encode4(166224), // Rule ID 1416 //
     /* 166184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 166192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 166195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 166198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 166201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166213 */     // (intrinsic_wo_chain:{ *:[v4i16] } 680:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQDMULHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 166213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16),
     /* 166216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166220 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166222 */     GIR_RootConstrainSelectedInstOperands,
     /* 166223 */     // GIR_Coverage, 1416,
     /* 166223 */     GIR_EraseRootFromParent_Done,
     /* 166224 */   // Label 3216: @166224
     /* 166224 */   GIM_Try, /*On fail goto*//*Label 3217*/ GIMT_Encode4(166269), // Rule ID 1417 //
     /* 166229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 166237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 166240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 166243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 166246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166258 */     // (intrinsic_wo_chain:{ *:[v8i16] } 680:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQDMULHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 166258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv8i16),
     /* 166261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166263 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166265 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166267 */     GIR_RootConstrainSelectedInstOperands,
     /* 166268 */     // GIR_Coverage, 1417,
     /* 166268 */     GIR_EraseRootFromParent_Done,
     /* 166269 */   // Label 3217: @166269
     /* 166269 */   GIM_Try, /*On fail goto*//*Label 3218*/ GIMT_Encode4(166314), // Rule ID 1418 //
     /* 166274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 166282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 166285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 166288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 166291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166303 */     // (intrinsic_wo_chain:{ *:[v2i32] } 680:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQDMULHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 166303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32),
     /* 166306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166310 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166312 */     GIR_RootConstrainSelectedInstOperands,
     /* 166313 */     // GIR_Coverage, 1418,
     /* 166313 */     GIR_EraseRootFromParent_Done,
     /* 166314 */   // Label 3218: @166314
     /* 166314 */   GIM_Try, /*On fail goto*//*Label 3219*/ GIMT_Encode4(166359), // Rule ID 1419 //
     /* 166319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 166327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 166330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 166336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166348 */     // (intrinsic_wo_chain:{ *:[v4i32] } 680:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQDMULHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 166348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i32),
     /* 166351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166355 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166357 */     GIR_RootConstrainSelectedInstOperands,
     /* 166358 */     // GIR_Coverage, 1419,
     /* 166358 */     GIR_EraseRootFromParent_Done,
     /* 166359 */   // Label 3219: @166359
     /* 166359 */   GIM_Try, /*On fail goto*//*Label 3220*/ GIMT_Encode4(166404), // Rule ID 1420 //
     /* 166364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 166372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 166375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 166378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 166381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166393 */     // (intrinsic_wo_chain:{ *:[v4i16] } 688:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMULHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 166393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16),
     /* 166396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166398 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166400 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166402 */     GIR_RootConstrainSelectedInstOperands,
     /* 166403 */     // GIR_Coverage, 1420,
     /* 166403 */     GIR_EraseRootFromParent_Done,
     /* 166404 */   // Label 3220: @166404
     /* 166404 */   GIM_Try, /*On fail goto*//*Label 3221*/ GIMT_Encode4(166449), // Rule ID 1421 //
     /* 166409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 166417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 166420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 166423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 166426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166438 */     // (intrinsic_wo_chain:{ *:[v8i16] } 688:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMULHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 166438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv8i16),
     /* 166441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166445 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166447 */     GIR_RootConstrainSelectedInstOperands,
     /* 166448 */     // GIR_Coverage, 1421,
     /* 166448 */     GIR_EraseRootFromParent_Done,
     /* 166449 */   // Label 3221: @166449
     /* 166449 */   GIM_Try, /*On fail goto*//*Label 3222*/ GIMT_Encode4(166494), // Rule ID 1422 //
     /* 166454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 166462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 166465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 166468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 166471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166483 */     // (intrinsic_wo_chain:{ *:[v2i32] } 688:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMULHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 166483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32),
     /* 166486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166490 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166492 */     GIR_RootConstrainSelectedInstOperands,
     /* 166493 */     // GIR_Coverage, 1422,
     /* 166493 */     GIR_EraseRootFromParent_Done,
     /* 166494 */   // Label 3222: @166494
     /* 166494 */   GIM_Try, /*On fail goto*//*Label 3223*/ GIMT_Encode4(166539), // Rule ID 1423 //
     /* 166499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 166507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 166510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 166516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166528 */     // (intrinsic_wo_chain:{ *:[v4i32] } 688:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMULHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 166528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i32),
     /* 166531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166535 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166537 */     GIR_RootConstrainSelectedInstOperands,
     /* 166538 */     // GIR_Coverage, 1423,
     /* 166538 */     GIR_EraseRootFromParent_Done,
     /* 166539 */   // Label 3223: @166539
     /* 166539 */   GIM_Try, /*On fail goto*//*Label 3224*/ GIMT_Encode4(166584), // Rule ID 1424 //
     /* 166544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 166552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 166555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 166558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 166561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166573 */     // (intrinsic_wo_chain:{ *:[v8i8] } 691:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 166573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv8i8),
     /* 166576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166578 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166580 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166582 */     GIR_RootConstrainSelectedInstOperands,
     /* 166583 */     // GIR_Coverage, 1424,
     /* 166583 */     GIR_EraseRootFromParent_Done,
     /* 166584 */   // Label 3224: @166584
     /* 166584 */   GIM_Try, /*On fail goto*//*Label 3225*/ GIMT_Encode4(166629), // Rule ID 1425 //
     /* 166589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 166597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 166600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 166603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 166606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166618 */     // (intrinsic_wo_chain:{ *:[v16i8] } 691:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 166618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv16i8),
     /* 166621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166625 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166627 */     GIR_RootConstrainSelectedInstOperands,
     /* 166628 */     // GIR_Coverage, 1425,
     /* 166628 */     GIR_EraseRootFromParent_Done,
     /* 166629 */   // Label 3225: @166629
     /* 166629 */   GIM_Try, /*On fail goto*//*Label 3226*/ GIMT_Encode4(166674), // Rule ID 1426 //
     /* 166634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 166642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 166645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 166648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 166651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166663 */     // (intrinsic_wo_chain:{ *:[v4i16] } 691:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 166663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv4i16),
     /* 166666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166670 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166672 */     GIR_RootConstrainSelectedInstOperands,
     /* 166673 */     // GIR_Coverage, 1426,
     /* 166673 */     GIR_EraseRootFromParent_Done,
     /* 166674 */   // Label 3226: @166674
     /* 166674 */   GIM_Try, /*On fail goto*//*Label 3227*/ GIMT_Encode4(166719), // Rule ID 1427 //
     /* 166679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 166687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 166690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 166693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 166696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166708 */     // (intrinsic_wo_chain:{ *:[v8i16] } 691:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 166708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv8i16),
     /* 166711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166715 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166717 */     GIR_RootConstrainSelectedInstOperands,
     /* 166718 */     // GIR_Coverage, 1427,
     /* 166718 */     GIR_EraseRootFromParent_Done,
     /* 166719 */   // Label 3227: @166719
     /* 166719 */   GIM_Try, /*On fail goto*//*Label 3228*/ GIMT_Encode4(166764), // Rule ID 1428 //
     /* 166724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 166732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 166735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 166738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 166741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166753 */     // (intrinsic_wo_chain:{ *:[v2i32] } 691:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 166753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv2i32),
     /* 166756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166760 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166762 */     GIR_RootConstrainSelectedInstOperands,
     /* 166763 */     // GIR_Coverage, 1428,
     /* 166763 */     GIR_EraseRootFromParent_Done,
     /* 166764 */   // Label 3228: @166764
     /* 166764 */   GIM_Try, /*On fail goto*//*Label 3229*/ GIMT_Encode4(166809), // Rule ID 1429 //
     /* 166769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 166777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 166780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 166786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166798 */     // (intrinsic_wo_chain:{ *:[v4i32] } 691:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 166798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv4i32),
     /* 166801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166805 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166807 */     GIR_RootConstrainSelectedInstOperands,
     /* 166808 */     // GIR_Coverage, 1429,
     /* 166808 */     GIR_EraseRootFromParent_Done,
     /* 166809 */   // Label 3229: @166809
     /* 166809 */   GIM_Try, /*On fail goto*//*Label 3230*/ GIMT_Encode4(166854), // Rule ID 1430 //
     /* 166814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 166822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 166825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 166828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 166831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166843 */     // (intrinsic_wo_chain:{ *:[v2i64] } 691:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 166843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv2i64),
     /* 166846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166850 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166852 */     GIR_RootConstrainSelectedInstOperands,
     /* 166853 */     // GIR_Coverage, 1430,
     /* 166853 */     GIR_EraseRootFromParent_Done,
     /* 166854 */   // Label 3230: @166854
     /* 166854 */   GIM_Try, /*On fail goto*//*Label 3231*/ GIMT_Encode4(166899), // Rule ID 1431 //
     /* 166859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 166867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 166870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 166873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 166876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166888 */     // (intrinsic_wo_chain:{ *:[v8i8] } 694:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 166888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv8i8),
     /* 166891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166895 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166897 */     GIR_RootConstrainSelectedInstOperands,
     /* 166898 */     // GIR_Coverage, 1431,
     /* 166898 */     GIR_EraseRootFromParent_Done,
     /* 166899 */   // Label 3231: @166899
     /* 166899 */   GIM_Try, /*On fail goto*//*Label 3232*/ GIMT_Encode4(166944), // Rule ID 1432 //
     /* 166904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 166912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 166915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 166918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 166921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166933 */     // (intrinsic_wo_chain:{ *:[v16i8] } 694:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 166933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv16i8),
     /* 166936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166940 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166942 */     GIR_RootConstrainSelectedInstOperands,
     /* 166943 */     // GIR_Coverage, 1432,
     /* 166943 */     GIR_EraseRootFromParent_Done,
     /* 166944 */   // Label 3232: @166944
     /* 166944 */   GIM_Try, /*On fail goto*//*Label 3233*/ GIMT_Encode4(166989), // Rule ID 1433 //
     /* 166949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 166957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 166960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 166963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 166966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166978 */     // (intrinsic_wo_chain:{ *:[v4i16] } 694:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 166978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv4i16),
     /* 166981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166985 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166987 */     GIR_RootConstrainSelectedInstOperands,
     /* 166988 */     // GIR_Coverage, 1433,
     /* 166988 */     GIR_EraseRootFromParent_Done,
     /* 166989 */   // Label 3233: @166989
     /* 166989 */   GIM_Try, /*On fail goto*//*Label 3234*/ GIMT_Encode4(167034), // Rule ID 1434 //
     /* 166994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 167002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 167005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 167008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 167011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167023 */     // (intrinsic_wo_chain:{ *:[v8i16] } 694:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 167023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv8i16),
     /* 167026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167030 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167032 */     GIR_RootConstrainSelectedInstOperands,
     /* 167033 */     // GIR_Coverage, 1434,
     /* 167033 */     GIR_EraseRootFromParent_Done,
     /* 167034 */   // Label 3234: @167034
     /* 167034 */   GIM_Try, /*On fail goto*//*Label 3235*/ GIMT_Encode4(167079), // Rule ID 1435 //
     /* 167039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 167047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 167050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 167053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 167056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167068 */     // (intrinsic_wo_chain:{ *:[v2i32] } 694:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 167068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv2i32),
     /* 167071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167075 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167077 */     GIR_RootConstrainSelectedInstOperands,
     /* 167078 */     // GIR_Coverage, 1435,
     /* 167078 */     GIR_EraseRootFromParent_Done,
     /* 167079 */   // Label 3235: @167079
     /* 167079 */   GIM_Try, /*On fail goto*//*Label 3236*/ GIMT_Encode4(167124), // Rule ID 1436 //
     /* 167084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 167092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 167095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 167098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 167101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167113 */     // (intrinsic_wo_chain:{ *:[v4i32] } 694:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 167113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv4i32),
     /* 167116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167120 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167122 */     GIR_RootConstrainSelectedInstOperands,
     /* 167123 */     // GIR_Coverage, 1436,
     /* 167123 */     GIR_EraseRootFromParent_Done,
     /* 167124 */   // Label 3236: @167124
     /* 167124 */   GIM_Try, /*On fail goto*//*Label 3237*/ GIMT_Encode4(167169), // Rule ID 1437 //
     /* 167129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 167137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 167140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 167143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 167146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167158 */     // (intrinsic_wo_chain:{ *:[v2i64] } 694:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 167158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv2i64),
     /* 167161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167163 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167165 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167167 */     GIR_RootConstrainSelectedInstOperands,
     /* 167168 */     // GIR_Coverage, 1437,
     /* 167168 */     GIR_EraseRootFromParent_Done,
     /* 167169 */   // Label 3237: @167169
     /* 167169 */   GIM_Try, /*On fail goto*//*Label 3238*/ GIMT_Encode4(167214), // Rule ID 1438 //
     /* 167174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 167182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 167185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 167188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 167191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167203 */     // (intrinsic_wo_chain:{ *:[v8i8] } 698:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 167203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i8),
     /* 167206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167208 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167210 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167212 */     GIR_RootConstrainSelectedInstOperands,
     /* 167213 */     // GIR_Coverage, 1438,
     /* 167213 */     GIR_EraseRootFromParent_Done,
     /* 167214 */   // Label 3238: @167214
     /* 167214 */   GIM_Try, /*On fail goto*//*Label 3239*/ GIMT_Encode4(167259), // Rule ID 1439 //
     /* 167219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 167227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 167230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 167233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 167236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167248 */     // (intrinsic_wo_chain:{ *:[v16i8] } 698:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 167248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv16i8),
     /* 167251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167255 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167257 */     GIR_RootConstrainSelectedInstOperands,
     /* 167258 */     // GIR_Coverage, 1439,
     /* 167258 */     GIR_EraseRootFromParent_Done,
     /* 167259 */   // Label 3239: @167259
     /* 167259 */   GIM_Try, /*On fail goto*//*Label 3240*/ GIMT_Encode4(167304), // Rule ID 1440 //
     /* 167264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 167272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 167275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 167278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 167281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167293 */     // (intrinsic_wo_chain:{ *:[v4i16] } 698:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 167293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i16),
     /* 167296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167298 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167300 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167302 */     GIR_RootConstrainSelectedInstOperands,
     /* 167303 */     // GIR_Coverage, 1440,
     /* 167303 */     GIR_EraseRootFromParent_Done,
     /* 167304 */   // Label 3240: @167304
     /* 167304 */   GIM_Try, /*On fail goto*//*Label 3241*/ GIMT_Encode4(167349), // Rule ID 1441 //
     /* 167309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 167317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 167320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 167323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 167326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167338 */     // (intrinsic_wo_chain:{ *:[v8i16] } 698:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 167338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i16),
     /* 167341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167343 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167345 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167347 */     GIR_RootConstrainSelectedInstOperands,
     /* 167348 */     // GIR_Coverage, 1441,
     /* 167348 */     GIR_EraseRootFromParent_Done,
     /* 167349 */   // Label 3241: @167349
     /* 167349 */   GIM_Try, /*On fail goto*//*Label 3242*/ GIMT_Encode4(167394), // Rule ID 1442 //
     /* 167354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 167362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 167365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 167368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 167371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167383 */     // (intrinsic_wo_chain:{ *:[v2i32] } 698:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 167383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i32),
     /* 167386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167390 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167392 */     GIR_RootConstrainSelectedInstOperands,
     /* 167393 */     // GIR_Coverage, 1442,
     /* 167393 */     GIR_EraseRootFromParent_Done,
     /* 167394 */   // Label 3242: @167394
     /* 167394 */   GIM_Try, /*On fail goto*//*Label 3243*/ GIMT_Encode4(167439), // Rule ID 1443 //
     /* 167399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 167407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 167410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 167413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 167416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167428 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 167428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i32),
     /* 167431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167435 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167437 */     GIR_RootConstrainSelectedInstOperands,
     /* 167438 */     // GIR_Coverage, 1443,
     /* 167438 */     GIR_EraseRootFromParent_Done,
     /* 167439 */   // Label 3243: @167439
     /* 167439 */   GIM_Try, /*On fail goto*//*Label 3244*/ GIMT_Encode4(167484), // Rule ID 1444 //
     /* 167444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 167452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 167455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 167458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 167461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167473 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 167473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i64),
     /* 167476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167480 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167482 */     GIR_RootConstrainSelectedInstOperands,
     /* 167483 */     // GIR_Coverage, 1444,
     /* 167483 */     GIR_EraseRootFromParent_Done,
     /* 167484 */   // Label 3244: @167484
     /* 167484 */   GIM_Try, /*On fail goto*//*Label 3245*/ GIMT_Encode4(167529), // Rule ID 1451 //
     /* 167489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 167497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 167500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 167503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 167506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167518 */     // (intrinsic_wo_chain:{ *:[v8i8] } 702:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 167518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv8i8),
     /* 167521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167523 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167525 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167527 */     GIR_RootConstrainSelectedInstOperands,
     /* 167528 */     // GIR_Coverage, 1451,
     /* 167528 */     GIR_EraseRootFromParent_Done,
     /* 167529 */   // Label 3245: @167529
     /* 167529 */   GIM_Try, /*On fail goto*//*Label 3246*/ GIMT_Encode4(167574), // Rule ID 1452 //
     /* 167534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 167542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 167545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 167548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 167551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167563 */     // (intrinsic_wo_chain:{ *:[v16i8] } 702:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 167563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv16i8),
     /* 167566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167570 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167572 */     GIR_RootConstrainSelectedInstOperands,
     /* 167573 */     // GIR_Coverage, 1452,
     /* 167573 */     GIR_EraseRootFromParent_Done,
     /* 167574 */   // Label 3246: @167574
     /* 167574 */   GIM_Try, /*On fail goto*//*Label 3247*/ GIMT_Encode4(167619), // Rule ID 1453 //
     /* 167579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 167587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 167590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 167593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 167596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167608 */     // (intrinsic_wo_chain:{ *:[v4i16] } 702:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 167608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv4i16),
     /* 167611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167615 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167617 */     GIR_RootConstrainSelectedInstOperands,
     /* 167618 */     // GIR_Coverage, 1453,
     /* 167618 */     GIR_EraseRootFromParent_Done,
     /* 167619 */   // Label 3247: @167619
     /* 167619 */   GIM_Try, /*On fail goto*//*Label 3248*/ GIMT_Encode4(167664), // Rule ID 1454 //
     /* 167624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 167632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 167635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 167638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 167641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167653 */     // (intrinsic_wo_chain:{ *:[v8i16] } 702:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 167653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv8i16),
     /* 167656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167658 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167660 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167662 */     GIR_RootConstrainSelectedInstOperands,
     /* 167663 */     // GIR_Coverage, 1454,
     /* 167663 */     GIR_EraseRootFromParent_Done,
     /* 167664 */   // Label 3248: @167664
     /* 167664 */   GIM_Try, /*On fail goto*//*Label 3249*/ GIMT_Encode4(167709), // Rule ID 1455 //
     /* 167669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 167677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 167680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 167683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 167686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167698 */     // (intrinsic_wo_chain:{ *:[v2i32] } 702:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 167698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv2i32),
     /* 167701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167707 */     GIR_RootConstrainSelectedInstOperands,
     /* 167708 */     // GIR_Coverage, 1455,
     /* 167708 */     GIR_EraseRootFromParent_Done,
     /* 167709 */   // Label 3249: @167709
     /* 167709 */   GIM_Try, /*On fail goto*//*Label 3250*/ GIMT_Encode4(167754), // Rule ID 1456 //
     /* 167714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 167722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 167725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 167728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 167731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167743 */     // (intrinsic_wo_chain:{ *:[v4i32] } 702:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 167743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv4i32),
     /* 167746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167748 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167750 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167752 */     GIR_RootConstrainSelectedInstOperands,
     /* 167753 */     // GIR_Coverage, 1456,
     /* 167753 */     GIR_EraseRootFromParent_Done,
     /* 167754 */   // Label 3250: @167754
     /* 167754 */   GIM_Try, /*On fail goto*//*Label 3251*/ GIMT_Encode4(167799), // Rule ID 1457 //
     /* 167759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 167767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 167770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 167773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 167776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167788 */     // (intrinsic_wo_chain:{ *:[v2i64] } 702:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 167788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv2i64),
     /* 167791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167795 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167797 */     GIR_RootConstrainSelectedInstOperands,
     /* 167798 */     // GIR_Coverage, 1457,
     /* 167798 */     GIR_EraseRootFromParent_Done,
     /* 167799 */   // Label 3251: @167799
     /* 167799 */   GIM_Try, /*On fail goto*//*Label 3252*/ GIMT_Encode4(167844), // Rule ID 1458 //
     /* 167804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 167812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 167815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 167818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 167821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167833 */     // (intrinsic_wo_chain:{ *:[v8i8] } 703:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 167833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv8i8),
     /* 167836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167840 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167842 */     GIR_RootConstrainSelectedInstOperands,
     /* 167843 */     // GIR_Coverage, 1458,
     /* 167843 */     GIR_EraseRootFromParent_Done,
     /* 167844 */   // Label 3252: @167844
     /* 167844 */   GIM_Try, /*On fail goto*//*Label 3253*/ GIMT_Encode4(167889), // Rule ID 1459 //
     /* 167849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 167857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 167860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 167863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 167866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167878 */     // (intrinsic_wo_chain:{ *:[v16i8] } 703:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 167878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv16i8),
     /* 167881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167885 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167887 */     GIR_RootConstrainSelectedInstOperands,
     /* 167888 */     // GIR_Coverage, 1459,
     /* 167888 */     GIR_EraseRootFromParent_Done,
     /* 167889 */   // Label 3253: @167889
     /* 167889 */   GIM_Try, /*On fail goto*//*Label 3254*/ GIMT_Encode4(167934), // Rule ID 1460 //
     /* 167894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 167902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 167905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 167908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 167911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167923 */     // (intrinsic_wo_chain:{ *:[v4i16] } 703:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 167923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv4i16),
     /* 167926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167928 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167930 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167932 */     GIR_RootConstrainSelectedInstOperands,
     /* 167933 */     // GIR_Coverage, 1460,
     /* 167933 */     GIR_EraseRootFromParent_Done,
     /* 167934 */   // Label 3254: @167934
     /* 167934 */   GIM_Try, /*On fail goto*//*Label 3255*/ GIMT_Encode4(167979), // Rule ID 1461 //
     /* 167939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 167947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 167950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 167953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 167956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167968 */     // (intrinsic_wo_chain:{ *:[v8i16] } 703:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 167968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv8i16),
     /* 167971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167975 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167977 */     GIR_RootConstrainSelectedInstOperands,
     /* 167978 */     // GIR_Coverage, 1461,
     /* 167978 */     GIR_EraseRootFromParent_Done,
     /* 167979 */   // Label 3255: @167979
     /* 167979 */   GIM_Try, /*On fail goto*//*Label 3256*/ GIMT_Encode4(168024), // Rule ID 1462 //
     /* 167984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 167992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 167995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 167998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 168001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168013 */     // (intrinsic_wo_chain:{ *:[v2i32] } 703:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 168013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv2i32),
     /* 168016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168020 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168022 */     GIR_RootConstrainSelectedInstOperands,
     /* 168023 */     // GIR_Coverage, 1462,
     /* 168023 */     GIR_EraseRootFromParent_Done,
     /* 168024 */   // Label 3256: @168024
     /* 168024 */   GIM_Try, /*On fail goto*//*Label 3257*/ GIMT_Encode4(168069), // Rule ID 1463 //
     /* 168029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 168037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 168040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 168046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168058 */     // (intrinsic_wo_chain:{ *:[v4i32] } 703:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 168058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv4i32),
     /* 168061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168065 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168067 */     GIR_RootConstrainSelectedInstOperands,
     /* 168068 */     // GIR_Coverage, 1463,
     /* 168068 */     GIR_EraseRootFromParent_Done,
     /* 168069 */   // Label 3257: @168069
     /* 168069 */   GIM_Try, /*On fail goto*//*Label 3258*/ GIMT_Encode4(168114), // Rule ID 1464 //
     /* 168074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 168082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 168085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 168088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 168091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168103 */     // (intrinsic_wo_chain:{ *:[v2i64] } 703:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 168103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv2i64),
     /* 168106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168110 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168112 */     GIR_RootConstrainSelectedInstOperands,
     /* 168113 */     // GIR_Coverage, 1464,
     /* 168113 */     GIR_EraseRootFromParent_Done,
     /* 168114 */   // Label 3258: @168114
     /* 168114 */   GIM_Try, /*On fail goto*//*Label 3259*/ GIMT_Encode4(168159), // Rule ID 1485 //
     /* 168119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 168127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 168130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 168133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 168136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168148 */     // (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UABDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 168148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv8i8),
     /* 168151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168155 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168157 */     GIR_RootConstrainSelectedInstOperands,
     /* 168158 */     // GIR_Coverage, 1485,
     /* 168158 */     GIR_EraseRootFromParent_Done,
     /* 168159 */   // Label 3259: @168159
     /* 168159 */   GIM_Try, /*On fail goto*//*Label 3260*/ GIMT_Encode4(168204), // Rule ID 1487 //
     /* 168164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 168172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 168175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 168178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 168181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168193 */     // (intrinsic_wo_chain:{ *:[v16i8] } 724:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UABDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 168193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv16i8),
     /* 168196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168202 */     GIR_RootConstrainSelectedInstOperands,
     /* 168203 */     // GIR_Coverage, 1487,
     /* 168203 */     GIR_EraseRootFromParent_Done,
     /* 168204 */   // Label 3260: @168204
     /* 168204 */   GIM_Try, /*On fail goto*//*Label 3261*/ GIMT_Encode4(168249), // Rule ID 1489 //
     /* 168209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 168217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 168220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 168223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 168226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168238 */     // (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UABDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 168238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv4i16),
     /* 168241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168245 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168247 */     GIR_RootConstrainSelectedInstOperands,
     /* 168248 */     // GIR_Coverage, 1489,
     /* 168248 */     GIR_EraseRootFromParent_Done,
     /* 168249 */   // Label 3261: @168249
     /* 168249 */   GIM_Try, /*On fail goto*//*Label 3262*/ GIMT_Encode4(168294), // Rule ID 1491 //
     /* 168254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 168262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 168265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 168268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 168271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168283 */     // (intrinsic_wo_chain:{ *:[v8i16] } 724:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UABDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 168283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv8i16),
     /* 168286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168290 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168292 */     GIR_RootConstrainSelectedInstOperands,
     /* 168293 */     // GIR_Coverage, 1491,
     /* 168293 */     GIR_EraseRootFromParent_Done,
     /* 168294 */   // Label 3262: @168294
     /* 168294 */   GIM_Try, /*On fail goto*//*Label 3263*/ GIMT_Encode4(168339), // Rule ID 1493 //
     /* 168299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 168307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 168310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 168313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 168316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168328 */     // (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UABDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 168328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv2i32),
     /* 168331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168335 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168337 */     GIR_RootConstrainSelectedInstOperands,
     /* 168338 */     // GIR_Coverage, 1493,
     /* 168338 */     GIR_EraseRootFromParent_Done,
     /* 168339 */   // Label 3263: @168339
     /* 168339 */   GIM_Try, /*On fail goto*//*Label 3264*/ GIMT_Encode4(168384), // Rule ID 1495 //
     /* 168344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 168352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 168355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 168361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168373 */     // (intrinsic_wo_chain:{ *:[v4i32] } 724:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UABDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 168373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv4i32),
     /* 168376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168380 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168382 */     GIR_RootConstrainSelectedInstOperands,
     /* 168383 */     // GIR_Coverage, 1495,
     /* 168383 */     GIR_EraseRootFromParent_Done,
     /* 168384 */   // Label 3264: @168384
     /* 168384 */   GIM_Try, /*On fail goto*//*Label 3265*/ GIMT_Encode4(168429), // Rule ID 1502 //
     /* 168389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 168397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 168400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 168403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 168406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168418 */     // (intrinsic_wo_chain:{ *:[v8i8] } 730:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UHSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 168418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv8i8),
     /* 168421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168425 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168427 */     GIR_RootConstrainSelectedInstOperands,
     /* 168428 */     // GIR_Coverage, 1502,
     /* 168428 */     GIR_EraseRootFromParent_Done,
     /* 168429 */   // Label 3265: @168429
     /* 168429 */   GIM_Try, /*On fail goto*//*Label 3266*/ GIMT_Encode4(168474), // Rule ID 1503 //
     /* 168434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 168442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 168445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 168448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 168451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168463 */     // (intrinsic_wo_chain:{ *:[v16i8] } 730:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UHSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 168463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv16i8),
     /* 168466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168470 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168472 */     GIR_RootConstrainSelectedInstOperands,
     /* 168473 */     // GIR_Coverage, 1503,
     /* 168473 */     GIR_EraseRootFromParent_Done,
     /* 168474 */   // Label 3266: @168474
     /* 168474 */   GIM_Try, /*On fail goto*//*Label 3267*/ GIMT_Encode4(168519), // Rule ID 1504 //
     /* 168479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 168487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 168490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 168493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 168496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168508 */     // (intrinsic_wo_chain:{ *:[v4i16] } 730:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UHSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 168508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv4i16),
     /* 168511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168515 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168517 */     GIR_RootConstrainSelectedInstOperands,
     /* 168518 */     // GIR_Coverage, 1504,
     /* 168518 */     GIR_EraseRootFromParent_Done,
     /* 168519 */   // Label 3267: @168519
     /* 168519 */   GIM_Try, /*On fail goto*//*Label 3268*/ GIMT_Encode4(168564), // Rule ID 1505 //
     /* 168524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 168532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 168535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 168538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 168541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168553 */     // (intrinsic_wo_chain:{ *:[v8i16] } 730:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UHSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 168553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv8i16),
     /* 168556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168560 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168562 */     GIR_RootConstrainSelectedInstOperands,
     /* 168563 */     // GIR_Coverage, 1505,
     /* 168563 */     GIR_EraseRootFromParent_Done,
     /* 168564 */   // Label 3268: @168564
     /* 168564 */   GIM_Try, /*On fail goto*//*Label 3269*/ GIMT_Encode4(168609), // Rule ID 1506 //
     /* 168569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 168577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 168580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 168583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 168586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168598 */     // (intrinsic_wo_chain:{ *:[v2i32] } 730:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UHSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 168598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv2i32),
     /* 168601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168603 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168605 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168607 */     GIR_RootConstrainSelectedInstOperands,
     /* 168608 */     // GIR_Coverage, 1506,
     /* 168608 */     GIR_EraseRootFromParent_Done,
     /* 168609 */   // Label 3269: @168609
     /* 168609 */   GIM_Try, /*On fail goto*//*Label 3270*/ GIMT_Encode4(168654), // Rule ID 1507 //
     /* 168614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 168622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 168625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 168631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168643 */     // (intrinsic_wo_chain:{ *:[v4i32] } 730:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UHSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 168643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv4i32),
     /* 168646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168650 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168652 */     GIR_RootConstrainSelectedInstOperands,
     /* 168653 */     // GIR_Coverage, 1507,
     /* 168653 */     GIR_EraseRootFromParent_Done,
     /* 168654 */   // Label 3270: @168654
     /* 168654 */   GIM_Try, /*On fail goto*//*Label 3271*/ GIMT_Encode4(168699), // Rule ID 1508 //
     /* 168659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 168667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 168670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 168673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 168676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168688 */     // (intrinsic_wo_chain:{ *:[v8i8] } 732:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMAXPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 168688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv8i8),
     /* 168691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168695 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168697 */     GIR_RootConstrainSelectedInstOperands,
     /* 168698 */     // GIR_Coverage, 1508,
     /* 168698 */     GIR_EraseRootFromParent_Done,
     /* 168699 */   // Label 3271: @168699
     /* 168699 */   GIM_Try, /*On fail goto*//*Label 3272*/ GIMT_Encode4(168744), // Rule ID 1509 //
     /* 168704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 168712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 168715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 168718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 168721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168733 */     // (intrinsic_wo_chain:{ *:[v16i8] } 732:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMAXPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 168733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv16i8),
     /* 168736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168738 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168740 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168742 */     GIR_RootConstrainSelectedInstOperands,
     /* 168743 */     // GIR_Coverage, 1509,
     /* 168743 */     GIR_EraseRootFromParent_Done,
     /* 168744 */   // Label 3272: @168744
     /* 168744 */   GIM_Try, /*On fail goto*//*Label 3273*/ GIMT_Encode4(168789), // Rule ID 1510 //
     /* 168749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 168757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 168760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 168763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 168766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168778 */     // (intrinsic_wo_chain:{ *:[v4i16] } 732:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMAXPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 168778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv4i16),
     /* 168781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168785 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168787 */     GIR_RootConstrainSelectedInstOperands,
     /* 168788 */     // GIR_Coverage, 1510,
     /* 168788 */     GIR_EraseRootFromParent_Done,
     /* 168789 */   // Label 3273: @168789
     /* 168789 */   GIM_Try, /*On fail goto*//*Label 3274*/ GIMT_Encode4(168834), // Rule ID 1511 //
     /* 168794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 168802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 168805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 168808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 168811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168823 */     // (intrinsic_wo_chain:{ *:[v8i16] } 732:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMAXPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 168823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv8i16),
     /* 168826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168830 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168832 */     GIR_RootConstrainSelectedInstOperands,
     /* 168833 */     // GIR_Coverage, 1511,
     /* 168833 */     GIR_EraseRootFromParent_Done,
     /* 168834 */   // Label 3274: @168834
     /* 168834 */   GIM_Try, /*On fail goto*//*Label 3275*/ GIMT_Encode4(168879), // Rule ID 1512 //
     /* 168839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 168847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 168850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 168853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 168856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168868 */     // (intrinsic_wo_chain:{ *:[v2i32] } 732:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMAXPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 168868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
     /* 168871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168875 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168877 */     GIR_RootConstrainSelectedInstOperands,
     /* 168878 */     // GIR_Coverage, 1512,
     /* 168878 */     GIR_EraseRootFromParent_Done,
     /* 168879 */   // Label 3275: @168879
     /* 168879 */   GIM_Try, /*On fail goto*//*Label 3276*/ GIMT_Encode4(168924), // Rule ID 1513 //
     /* 168884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 168892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 168895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 168901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168913 */     // (intrinsic_wo_chain:{ *:[v4i32] } 732:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMAXPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 168913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv4i32),
     /* 168916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168922 */     GIR_RootConstrainSelectedInstOperands,
     /* 168923 */     // GIR_Coverage, 1513,
     /* 168923 */     GIR_EraseRootFromParent_Done,
     /* 168924 */   // Label 3276: @168924
     /* 168924 */   GIM_Try, /*On fail goto*//*Label 3277*/ GIMT_Encode4(168969), // Rule ID 1520 //
     /* 168929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 168937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 168940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 168943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 168946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168958 */     // (intrinsic_wo_chain:{ *:[v8i8] } 735:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMINPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 168958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv8i8),
     /* 168961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168963 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168965 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168967 */     GIR_RootConstrainSelectedInstOperands,
     /* 168968 */     // GIR_Coverage, 1520,
     /* 168968 */     GIR_EraseRootFromParent_Done,
     /* 168969 */   // Label 3277: @168969
     /* 168969 */   GIM_Try, /*On fail goto*//*Label 3278*/ GIMT_Encode4(169014), // Rule ID 1521 //
     /* 168974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 168982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 168985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 168988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 168991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169003 */     // (intrinsic_wo_chain:{ *:[v16i8] } 735:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMINPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 169003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv16i8),
     /* 169006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169010 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169012 */     GIR_RootConstrainSelectedInstOperands,
     /* 169013 */     // GIR_Coverage, 1521,
     /* 169013 */     GIR_EraseRootFromParent_Done,
     /* 169014 */   // Label 3278: @169014
     /* 169014 */   GIM_Try, /*On fail goto*//*Label 3279*/ GIMT_Encode4(169059), // Rule ID 1522 //
     /* 169019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 169027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 169030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 169036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169048 */     // (intrinsic_wo_chain:{ *:[v4i16] } 735:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMINPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 169048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv4i16),
     /* 169051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169055 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169057 */     GIR_RootConstrainSelectedInstOperands,
     /* 169058 */     // GIR_Coverage, 1522,
     /* 169058 */     GIR_EraseRootFromParent_Done,
     /* 169059 */   // Label 3279: @169059
     /* 169059 */   GIM_Try, /*On fail goto*//*Label 3280*/ GIMT_Encode4(169104), // Rule ID 1523 //
     /* 169064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 169072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 169075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 169081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169093 */     // (intrinsic_wo_chain:{ *:[v8i16] } 735:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMINPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 169093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv8i16),
     /* 169096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169100 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169102 */     GIR_RootConstrainSelectedInstOperands,
     /* 169103 */     // GIR_Coverage, 1523,
     /* 169103 */     GIR_EraseRootFromParent_Done,
     /* 169104 */   // Label 3280: @169104
     /* 169104 */   GIM_Try, /*On fail goto*//*Label 3281*/ GIMT_Encode4(169149), // Rule ID 1524 //
     /* 169109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 169117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 169120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 169126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169138 */     // (intrinsic_wo_chain:{ *:[v2i32] } 735:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMINPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 169138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
     /* 169141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169145 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169147 */     GIR_RootConstrainSelectedInstOperands,
     /* 169148 */     // GIR_Coverage, 1524,
     /* 169148 */     GIR_EraseRootFromParent_Done,
     /* 169149 */   // Label 3281: @169149
     /* 169149 */   GIM_Try, /*On fail goto*//*Label 3282*/ GIMT_Encode4(169194), // Rule ID 1525 //
     /* 169154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 169162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 169165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 169171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169183 */     // (intrinsic_wo_chain:{ *:[v4i32] } 735:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMINPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 169183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv4i32),
     /* 169186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169190 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169192 */     GIR_RootConstrainSelectedInstOperands,
     /* 169193 */     // GIR_Coverage, 1525,
     /* 169193 */     GIR_EraseRootFromParent_Done,
     /* 169194 */   // Label 3282: @169194
     /* 169194 */   GIM_Try, /*On fail goto*//*Label 3283*/ GIMT_Encode4(169239), // Rule ID 1532 //
     /* 169199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 169207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 169210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 169213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 169216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169228 */     // (intrinsic_wo_chain:{ *:[v8i8] } 739:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 169228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i8),
     /* 169231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169235 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169237 */     GIR_RootConstrainSelectedInstOperands,
     /* 169238 */     // GIR_Coverage, 1532,
     /* 169238 */     GIR_EraseRootFromParent_Done,
     /* 169239 */   // Label 3283: @169239
     /* 169239 */   GIM_Try, /*On fail goto*//*Label 3284*/ GIMT_Encode4(169284), // Rule ID 1533 //
     /* 169244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 169252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 169255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 169258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 169261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169273 */     // (intrinsic_wo_chain:{ *:[v16i8] } 739:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 169273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv16i8),
     /* 169276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169280 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169282 */     GIR_RootConstrainSelectedInstOperands,
     /* 169283 */     // GIR_Coverage, 1533,
     /* 169283 */     GIR_EraseRootFromParent_Done,
     /* 169284 */   // Label 3284: @169284
     /* 169284 */   GIM_Try, /*On fail goto*//*Label 3285*/ GIMT_Encode4(169329), // Rule ID 1534 //
     /* 169289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 169297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 169300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 169306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169318 */     // (intrinsic_wo_chain:{ *:[v4i16] } 739:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 169318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i16),
     /* 169321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169323 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169325 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169327 */     GIR_RootConstrainSelectedInstOperands,
     /* 169328 */     // GIR_Coverage, 1534,
     /* 169328 */     GIR_EraseRootFromParent_Done,
     /* 169329 */   // Label 3285: @169329
     /* 169329 */   GIM_Try, /*On fail goto*//*Label 3286*/ GIMT_Encode4(169374), // Rule ID 1535 //
     /* 169334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 169342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 169345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 169351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169363 */     // (intrinsic_wo_chain:{ *:[v8i16] } 739:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 169363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i16),
     /* 169366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169370 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169372 */     GIR_RootConstrainSelectedInstOperands,
     /* 169373 */     // GIR_Coverage, 1535,
     /* 169373 */     GIR_EraseRootFromParent_Done,
     /* 169374 */   // Label 3286: @169374
     /* 169374 */   GIM_Try, /*On fail goto*//*Label 3287*/ GIMT_Encode4(169419), // Rule ID 1536 //
     /* 169379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 169387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 169390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 169396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169408 */     // (intrinsic_wo_chain:{ *:[v2i32] } 739:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 169408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i32),
     /* 169411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169415 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169417 */     GIR_RootConstrainSelectedInstOperands,
     /* 169418 */     // GIR_Coverage, 1536,
     /* 169418 */     GIR_EraseRootFromParent_Done,
     /* 169419 */   // Label 3287: @169419
     /* 169419 */   GIM_Try, /*On fail goto*//*Label 3288*/ GIMT_Encode4(169464), // Rule ID 1537 //
     /* 169424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 169432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 169435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 169441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169453 */     // (intrinsic_wo_chain:{ *:[v4i32] } 739:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 169453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i32),
     /* 169456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169458 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169460 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169462 */     GIR_RootConstrainSelectedInstOperands,
     /* 169463 */     // GIR_Coverage, 1537,
     /* 169463 */     GIR_EraseRootFromParent_Done,
     /* 169464 */   // Label 3288: @169464
     /* 169464 */   GIM_Try, /*On fail goto*//*Label 3289*/ GIMT_Encode4(169509), // Rule ID 1538 //
     /* 169469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 169477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 169480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 169483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 169486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169498 */     // (intrinsic_wo_chain:{ *:[v2i64] } 739:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 169498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i64),
     /* 169501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169503 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169505 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169507 */     GIR_RootConstrainSelectedInstOperands,
     /* 169508 */     // GIR_Coverage, 1538,
     /* 169508 */     GIR_EraseRootFromParent_Done,
     /* 169509 */   // Label 3289: @169509
     /* 169509 */   GIM_Try, /*On fail goto*//*Label 3290*/ GIMT_Encode4(169554), // Rule ID 1539 //
     /* 169514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 169522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 169525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 169528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 169531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169543 */     // (intrinsic_wo_chain:{ *:[v8i8] } 740:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 169543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv8i8),
     /* 169546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169548 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169550 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169552 */     GIR_RootConstrainSelectedInstOperands,
     /* 169553 */     // GIR_Coverage, 1539,
     /* 169553 */     GIR_EraseRootFromParent_Done,
     /* 169554 */   // Label 3290: @169554
     /* 169554 */   GIM_Try, /*On fail goto*//*Label 3291*/ GIMT_Encode4(169599), // Rule ID 1540 //
     /* 169559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 169567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 169570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 169573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 169576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169588 */     // (intrinsic_wo_chain:{ *:[v16i8] } 740:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 169588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv16i8),
     /* 169591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169595 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169597 */     GIR_RootConstrainSelectedInstOperands,
     /* 169598 */     // GIR_Coverage, 1540,
     /* 169598 */     GIR_EraseRootFromParent_Done,
     /* 169599 */   // Label 3291: @169599
     /* 169599 */   GIM_Try, /*On fail goto*//*Label 3292*/ GIMT_Encode4(169644), // Rule ID 1541 //
     /* 169604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 169612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 169615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 169621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169633 */     // (intrinsic_wo_chain:{ *:[v4i16] } 740:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 169633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv4i16),
     /* 169636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169640 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169642 */     GIR_RootConstrainSelectedInstOperands,
     /* 169643 */     // GIR_Coverage, 1541,
     /* 169643 */     GIR_EraseRootFromParent_Done,
     /* 169644 */   // Label 3292: @169644
     /* 169644 */   GIM_Try, /*On fail goto*//*Label 3293*/ GIMT_Encode4(169689), // Rule ID 1542 //
     /* 169649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 169657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 169660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 169666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169678 */     // (intrinsic_wo_chain:{ *:[v8i16] } 740:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 169678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv8i16),
     /* 169681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169685 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169687 */     GIR_RootConstrainSelectedInstOperands,
     /* 169688 */     // GIR_Coverage, 1542,
     /* 169688 */     GIR_EraseRootFromParent_Done,
     /* 169689 */   // Label 3293: @169689
     /* 169689 */   GIM_Try, /*On fail goto*//*Label 3294*/ GIMT_Encode4(169734), // Rule ID 1543 //
     /* 169694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 169702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 169705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 169711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169723 */     // (intrinsic_wo_chain:{ *:[v2i32] } 740:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 169723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv2i32),
     /* 169726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169732 */     GIR_RootConstrainSelectedInstOperands,
     /* 169733 */     // GIR_Coverage, 1543,
     /* 169733 */     GIR_EraseRootFromParent_Done,
     /* 169734 */   // Label 3294: @169734
     /* 169734 */   GIM_Try, /*On fail goto*//*Label 3295*/ GIMT_Encode4(169779), // Rule ID 1544 //
     /* 169739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 169747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 169750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 169756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169768 */     // (intrinsic_wo_chain:{ *:[v4i32] } 740:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 169768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv4i32),
     /* 169771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169775 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169777 */     GIR_RootConstrainSelectedInstOperands,
     /* 169778 */     // GIR_Coverage, 1544,
     /* 169778 */     GIR_EraseRootFromParent_Done,
     /* 169779 */   // Label 3295: @169779
     /* 169779 */   GIM_Try, /*On fail goto*//*Label 3296*/ GIMT_Encode4(169824), // Rule ID 1545 //
     /* 169784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 169792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 169795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 169798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 169801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169813 */     // (intrinsic_wo_chain:{ *:[v2i64] } 740:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 169813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv2i64),
     /* 169816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169818 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169820 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169822 */     GIR_RootConstrainSelectedInstOperands,
     /* 169823 */     // GIR_Coverage, 1545,
     /* 169823 */     GIR_EraseRootFromParent_Done,
     /* 169824 */   // Label 3296: @169824
     /* 169824 */   GIM_Try, /*On fail goto*//*Label 3297*/ GIMT_Encode4(169869), // Rule ID 1546 //
     /* 169829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 169837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 169840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 169843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 169846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169858 */     // (intrinsic_wo_chain:{ *:[v8i8] } 742:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 169858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv8i8),
     /* 169861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169865 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169867 */     GIR_RootConstrainSelectedInstOperands,
     /* 169868 */     // GIR_Coverage, 1546,
     /* 169868 */     GIR_EraseRootFromParent_Done,
     /* 169869 */   // Label 3297: @169869
     /* 169869 */   GIM_Try, /*On fail goto*//*Label 3298*/ GIMT_Encode4(169914), // Rule ID 1547 //
     /* 169874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 169882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 169885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 169888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 169891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169903 */     // (intrinsic_wo_chain:{ *:[v16i8] } 742:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 169903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv16i8),
     /* 169906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169910 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169912 */     GIR_RootConstrainSelectedInstOperands,
     /* 169913 */     // GIR_Coverage, 1547,
     /* 169913 */     GIR_EraseRootFromParent_Done,
     /* 169914 */   // Label 3298: @169914
     /* 169914 */   GIM_Try, /*On fail goto*//*Label 3299*/ GIMT_Encode4(169959), // Rule ID 1548 //
     /* 169919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 169927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 169930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 169936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169948 */     // (intrinsic_wo_chain:{ *:[v4i16] } 742:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 169948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv4i16),
     /* 169951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169955 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169957 */     GIR_RootConstrainSelectedInstOperands,
     /* 169958 */     // GIR_Coverage, 1548,
     /* 169958 */     GIR_EraseRootFromParent_Done,
     /* 169959 */   // Label 3299: @169959
     /* 169959 */   GIM_Try, /*On fail goto*//*Label 3300*/ GIMT_Encode4(170004), // Rule ID 1549 //
     /* 169964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 169972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 169975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 169981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169993 */     // (intrinsic_wo_chain:{ *:[v8i16] } 742:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 169993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv8i16),
     /* 169996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170000 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170002 */     GIR_RootConstrainSelectedInstOperands,
     /* 170003 */     // GIR_Coverage, 1549,
     /* 170003 */     GIR_EraseRootFromParent_Done,
     /* 170004 */   // Label 3300: @170004
     /* 170004 */   GIM_Try, /*On fail goto*//*Label 3301*/ GIMT_Encode4(170049), // Rule ID 1550 //
     /* 170009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 170017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 170020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 170023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 170026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170038 */     // (intrinsic_wo_chain:{ *:[v2i32] } 742:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 170038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv2i32),
     /* 170041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170045 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170047 */     GIR_RootConstrainSelectedInstOperands,
     /* 170048 */     // GIR_Coverage, 1550,
     /* 170048 */     GIR_EraseRootFromParent_Done,
     /* 170049 */   // Label 3301: @170049
     /* 170049 */   GIM_Try, /*On fail goto*//*Label 3302*/ GIMT_Encode4(170094), // Rule ID 1551 //
     /* 170054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 170062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 170065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 170071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170083 */     // (intrinsic_wo_chain:{ *:[v4i32] } 742:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 170083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv4i32),
     /* 170086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170090 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170092 */     GIR_RootConstrainSelectedInstOperands,
     /* 170093 */     // GIR_Coverage, 1551,
     /* 170093 */     GIR_EraseRootFromParent_Done,
     /* 170094 */   // Label 3302: @170094
     /* 170094 */   GIM_Try, /*On fail goto*//*Label 3303*/ GIMT_Encode4(170139), // Rule ID 1552 //
     /* 170099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 170107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 170110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 170113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 170116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170128 */     // (intrinsic_wo_chain:{ *:[v2i64] } 742:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 170128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv2i64),
     /* 170131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170135 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170137 */     GIR_RootConstrainSelectedInstOperands,
     /* 170138 */     // GIR_Coverage, 1552,
     /* 170138 */     GIR_EraseRootFromParent_Done,
     /* 170139 */   // Label 3303: @170139
     /* 170139 */   GIM_Try, /*On fail goto*//*Label 3304*/ GIMT_Encode4(170184), // Rule ID 1553 //
     /* 170144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 170152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 170155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 170158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 170161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170173 */     // (intrinsic_wo_chain:{ *:[v8i8] } 744:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 170173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i8),
     /* 170176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170180 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170182 */     GIR_RootConstrainSelectedInstOperands,
     /* 170183 */     // GIR_Coverage, 1553,
     /* 170183 */     GIR_EraseRootFromParent_Done,
     /* 170184 */   // Label 3304: @170184
     /* 170184 */   GIM_Try, /*On fail goto*//*Label 3305*/ GIMT_Encode4(170229), // Rule ID 1554 //
     /* 170189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 170197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 170200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 170203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 170206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170218 */     // (intrinsic_wo_chain:{ *:[v16i8] } 744:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 170218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv16i8),
     /* 170221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170223 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170225 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170227 */     GIR_RootConstrainSelectedInstOperands,
     /* 170228 */     // GIR_Coverage, 1554,
     /* 170228 */     GIR_EraseRootFromParent_Done,
     /* 170229 */   // Label 3305: @170229
     /* 170229 */   GIM_Try, /*On fail goto*//*Label 3306*/ GIMT_Encode4(170274), // Rule ID 1555 //
     /* 170234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 170242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 170245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 170248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 170251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170263 */     // (intrinsic_wo_chain:{ *:[v4i16] } 744:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 170263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i16),
     /* 170266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170270 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170272 */     GIR_RootConstrainSelectedInstOperands,
     /* 170273 */     // GIR_Coverage, 1555,
     /* 170273 */     GIR_EraseRootFromParent_Done,
     /* 170274 */   // Label 3306: @170274
     /* 170274 */   GIM_Try, /*On fail goto*//*Label 3307*/ GIMT_Encode4(170319), // Rule ID 1556 //
     /* 170279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 170287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 170290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 170296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170308 */     // (intrinsic_wo_chain:{ *:[v8i16] } 744:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 170308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i16),
     /* 170311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170317 */     GIR_RootConstrainSelectedInstOperands,
     /* 170318 */     // GIR_Coverage, 1556,
     /* 170318 */     GIR_EraseRootFromParent_Done,
     /* 170319 */   // Label 3307: @170319
     /* 170319 */   GIM_Try, /*On fail goto*//*Label 3308*/ GIMT_Encode4(170364), // Rule ID 1557 //
     /* 170324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 170332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 170335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 170338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 170341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170353 */     // (intrinsic_wo_chain:{ *:[v2i32] } 744:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 170353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i32),
     /* 170356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170362 */     GIR_RootConstrainSelectedInstOperands,
     /* 170363 */     // GIR_Coverage, 1557,
     /* 170363 */     GIR_EraseRootFromParent_Done,
     /* 170364 */   // Label 3308: @170364
     /* 170364 */   GIM_Try, /*On fail goto*//*Label 3309*/ GIMT_Encode4(170409), // Rule ID 1558 //
     /* 170369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 170377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 170380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 170386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170398 */     // (intrinsic_wo_chain:{ *:[v4i32] } 744:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 170398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i32),
     /* 170401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170405 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170407 */     GIR_RootConstrainSelectedInstOperands,
     /* 170408 */     // GIR_Coverage, 1558,
     /* 170408 */     GIR_EraseRootFromParent_Done,
     /* 170409 */   // Label 3309: @170409
     /* 170409 */   GIM_Try, /*On fail goto*//*Label 3310*/ GIMT_Encode4(170454), // Rule ID 1559 //
     /* 170414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 170422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 170425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 170428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 170431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170443 */     // (intrinsic_wo_chain:{ *:[v2i64] } 744:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 170443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i64),
     /* 170446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170448 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170450 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170452 */     GIR_RootConstrainSelectedInstOperands,
     /* 170453 */     // GIR_Coverage, 1559,
     /* 170453 */     GIR_EraseRootFromParent_Done,
     /* 170454 */   // Label 3310: @170454
     /* 170454 */   GIM_Try, /*On fail goto*//*Label 3311*/ GIMT_Encode4(170499), // Rule ID 1566 //
     /* 170459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 170467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 170470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 170473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 170476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170488 */     // (intrinsic_wo_chain:{ *:[v8i8] } 748:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (URSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 170488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv8i8),
     /* 170491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170495 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170497 */     GIR_RootConstrainSelectedInstOperands,
     /* 170498 */     // GIR_Coverage, 1566,
     /* 170498 */     GIR_EraseRootFromParent_Done,
     /* 170499 */   // Label 3311: @170499
     /* 170499 */   GIM_Try, /*On fail goto*//*Label 3312*/ GIMT_Encode4(170544), // Rule ID 1567 //
     /* 170504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 170512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 170515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 170518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 170521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170533 */     // (intrinsic_wo_chain:{ *:[v16i8] } 748:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (URSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 170533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv16i8),
     /* 170536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170540 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170542 */     GIR_RootConstrainSelectedInstOperands,
     /* 170543 */     // GIR_Coverage, 1567,
     /* 170543 */     GIR_EraseRootFromParent_Done,
     /* 170544 */   // Label 3312: @170544
     /* 170544 */   GIM_Try, /*On fail goto*//*Label 3313*/ GIMT_Encode4(170589), // Rule ID 1568 //
     /* 170549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 170557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 170560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 170563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 170566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170578 */     // (intrinsic_wo_chain:{ *:[v4i16] } 748:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (URSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 170578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv4i16),
     /* 170581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170585 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170587 */     GIR_RootConstrainSelectedInstOperands,
     /* 170588 */     // GIR_Coverage, 1568,
     /* 170588 */     GIR_EraseRootFromParent_Done,
     /* 170589 */   // Label 3313: @170589
     /* 170589 */   GIM_Try, /*On fail goto*//*Label 3314*/ GIMT_Encode4(170634), // Rule ID 1569 //
     /* 170594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 170602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 170605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 170611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170623 */     // (intrinsic_wo_chain:{ *:[v8i16] } 748:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (URSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 170623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv8i16),
     /* 170626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170630 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170632 */     GIR_RootConstrainSelectedInstOperands,
     /* 170633 */     // GIR_Coverage, 1569,
     /* 170633 */     GIR_EraseRootFromParent_Done,
     /* 170634 */   // Label 3314: @170634
     /* 170634 */   GIM_Try, /*On fail goto*//*Label 3315*/ GIMT_Encode4(170679), // Rule ID 1570 //
     /* 170639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 170647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 170650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 170653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 170656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170668 */     // (intrinsic_wo_chain:{ *:[v2i32] } 748:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (URSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 170668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv2i32),
     /* 170671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170675 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170677 */     GIR_RootConstrainSelectedInstOperands,
     /* 170678 */     // GIR_Coverage, 1570,
     /* 170678 */     GIR_EraseRootFromParent_Done,
     /* 170679 */   // Label 3315: @170679
     /* 170679 */   GIM_Try, /*On fail goto*//*Label 3316*/ GIMT_Encode4(170724), // Rule ID 1571 //
     /* 170684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 170692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 170695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 170701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170713 */     // (intrinsic_wo_chain:{ *:[v4i32] } 748:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (URSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 170713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv4i32),
     /* 170716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170720 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170722 */     GIR_RootConstrainSelectedInstOperands,
     /* 170723 */     // GIR_Coverage, 1571,
     /* 170723 */     GIR_EraseRootFromParent_Done,
     /* 170724 */   // Label 3316: @170724
     /* 170724 */   GIM_Try, /*On fail goto*//*Label 3317*/ GIMT_Encode4(170769), // Rule ID 1572 //
     /* 170729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 170737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 170740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 170743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 170746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170758 */     // (intrinsic_wo_chain:{ *:[v2i64] } 748:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (URSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 170758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv2i64),
     /* 170761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170765 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170767 */     GIR_RootConstrainSelectedInstOperands,
     /* 170768 */     // GIR_Coverage, 1572,
     /* 170768 */     GIR_EraseRootFromParent_Done,
     /* 170769 */   // Label 3317: @170769
     /* 170769 */   GIM_Try, /*On fail goto*//*Label 3318*/ GIMT_Encode4(170814), // Rule ID 1573 //
     /* 170774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 170782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 170785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 170788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 170791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170803 */     // (intrinsic_wo_chain:{ *:[v8i8] } 751:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (USHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 170803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv8i8),
     /* 170806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170810 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170812 */     GIR_RootConstrainSelectedInstOperands,
     /* 170813 */     // GIR_Coverage, 1573,
     /* 170813 */     GIR_EraseRootFromParent_Done,
     /* 170814 */   // Label 3318: @170814
     /* 170814 */   GIM_Try, /*On fail goto*//*Label 3319*/ GIMT_Encode4(170859), // Rule ID 1574 //
     /* 170819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 170827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 170830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 170833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 170836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170848 */     // (intrinsic_wo_chain:{ *:[v16i8] } 751:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (USHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 170848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv16i8),
     /* 170851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170855 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170857 */     GIR_RootConstrainSelectedInstOperands,
     /* 170858 */     // GIR_Coverage, 1574,
     /* 170858 */     GIR_EraseRootFromParent_Done,
     /* 170859 */   // Label 3319: @170859
     /* 170859 */   GIM_Try, /*On fail goto*//*Label 3320*/ GIMT_Encode4(170904), // Rule ID 1575 //
     /* 170864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 170872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 170875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 170878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 170881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170893 */     // (intrinsic_wo_chain:{ *:[v4i16] } 751:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (USHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 170893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv4i16),
     /* 170896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170898 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170900 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170902 */     GIR_RootConstrainSelectedInstOperands,
     /* 170903 */     // GIR_Coverage, 1575,
     /* 170903 */     GIR_EraseRootFromParent_Done,
     /* 170904 */   // Label 3320: @170904
     /* 170904 */   GIM_Try, /*On fail goto*//*Label 3321*/ GIMT_Encode4(170949), // Rule ID 1576 //
     /* 170909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 170917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 170920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 170926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170938 */     // (intrinsic_wo_chain:{ *:[v8i16] } 751:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (USHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 170938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv8i16),
     /* 170941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170945 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170947 */     GIR_RootConstrainSelectedInstOperands,
     /* 170948 */     // GIR_Coverage, 1576,
     /* 170948 */     GIR_EraseRootFromParent_Done,
     /* 170949 */   // Label 3321: @170949
     /* 170949 */   GIM_Try, /*On fail goto*//*Label 3322*/ GIMT_Encode4(170994), // Rule ID 1577 //
     /* 170954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 170962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 170965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 170968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 170971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170983 */     // (intrinsic_wo_chain:{ *:[v2i32] } 751:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (USHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 170983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv2i32),
     /* 170986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170990 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170992 */     GIR_RootConstrainSelectedInstOperands,
     /* 170993 */     // GIR_Coverage, 1577,
     /* 170993 */     GIR_EraseRootFromParent_Done,
     /* 170994 */   // Label 3322: @170994
     /* 170994 */   GIM_Try, /*On fail goto*//*Label 3323*/ GIMT_Encode4(171039), // Rule ID 1578 //
     /* 170999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 171007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 171010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 171013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 171016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171028 */     // (intrinsic_wo_chain:{ *:[v4i32] } 751:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (USHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 171028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv4i32),
     /* 171031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171035 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171037 */     GIR_RootConstrainSelectedInstOperands,
     /* 171038 */     // GIR_Coverage, 1578,
     /* 171038 */     GIR_EraseRootFromParent_Done,
     /* 171039 */   // Label 3323: @171039
     /* 171039 */   GIM_Try, /*On fail goto*//*Label 3324*/ GIMT_Encode4(171084), // Rule ID 1579 //
     /* 171044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 171052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 171055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 171058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 171061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171073 */     // (intrinsic_wo_chain:{ *:[v2i64] } 751:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (USHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 171073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv2i64),
     /* 171076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171080 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171082 */     GIR_RootConstrainSelectedInstOperands,
     /* 171083 */     // GIR_Coverage, 1579,
     /* 171083 */     GIR_EraseRootFromParent_Done,
     /* 171084 */   // Label 3324: @171084
     /* 171084 */   GIM_Try, /*On fail goto*//*Label 3325*/ GIMT_Encode4(171129), // Rule ID 1607 //
     /* 171089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 171097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 171100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 171103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 171106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171118 */     // (intrinsic_wo_chain:{ *:[f64] } 785:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FABD64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 171118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 171121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171123 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171125 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171127 */     GIR_RootConstrainSelectedInstOperands,
     /* 171128 */     // GIR_Coverage, 1607,
     /* 171128 */     GIR_EraseRootFromParent_Done,
     /* 171129 */   // Label 3325: @171129
     /* 171129 */   GIM_Try, /*On fail goto*//*Label 3326*/ GIMT_Encode4(171174), // Rule ID 1608 //
     /* 171134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 171142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 171145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 171148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 171151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171163 */     // (intrinsic_wo_chain:{ *:[f32] } 785:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FABD32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 171163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD32),
     /* 171166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171170 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171172 */     GIR_RootConstrainSelectedInstOperands,
     /* 171173 */     // GIR_Coverage, 1608,
     /* 171173 */     GIR_EraseRootFromParent_Done,
     /* 171174 */   // Label 3326: @171174
     /* 171174 */   GIM_Try, /*On fail goto*//*Label 3327*/ GIMT_Encode4(171219), // Rule ID 1609 //
     /* 171179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 171182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 171187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 171190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 171193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 171196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 171200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 171204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 171208 */     // (intrinsic_wo_chain:{ *:[f16] } 785:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FABD16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 171208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD16),
     /* 171211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171215 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171217 */     GIR_RootConstrainSelectedInstOperands,
     /* 171218 */     // GIR_Coverage, 1609,
     /* 171218 */     GIR_EraseRootFromParent_Done,
     /* 171219 */   // Label 3327: @171219
     /* 171219 */   GIM_Try, /*On fail goto*//*Label 3328*/ GIMT_Encode4(171264), // Rule ID 1610 //
     /* 171224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 171232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 171235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 171238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 171241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171253 */     // (intrinsic_wo_chain:{ *:[i64] } 577:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FACGE64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 171253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE64),
     /* 171256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171260 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171262 */     GIR_RootConstrainSelectedInstOperands,
     /* 171263 */     // GIR_Coverage, 1610,
     /* 171263 */     GIR_EraseRootFromParent_Done,
     /* 171264 */   // Label 3328: @171264
     /* 171264 */   GIM_Try, /*On fail goto*//*Label 3329*/ GIMT_Encode4(171309), // Rule ID 1611 //
     /* 171269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 171277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 171280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 171283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 171286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171298 */     // (intrinsic_wo_chain:{ *:[i32] } 577:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FACGE32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 171298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE32),
     /* 171301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171305 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171307 */     GIR_RootConstrainSelectedInstOperands,
     /* 171308 */     // GIR_Coverage, 1611,
     /* 171308 */     GIR_EraseRootFromParent_Done,
     /* 171309 */   // Label 3329: @171309
     /* 171309 */   GIM_Try, /*On fail goto*//*Label 3330*/ GIMT_Encode4(171354), // Rule ID 1612 //
     /* 171314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 171322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 171325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 171328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 171331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171343 */     // (intrinsic_wo_chain:{ *:[i64] } 578:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FACGT64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 171343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT64),
     /* 171346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171350 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171352 */     GIR_RootConstrainSelectedInstOperands,
     /* 171353 */     // GIR_Coverage, 1612,
     /* 171353 */     GIR_EraseRootFromParent_Done,
     /* 171354 */   // Label 3330: @171354
     /* 171354 */   GIM_Try, /*On fail goto*//*Label 3331*/ GIMT_Encode4(171399), // Rule ID 1613 //
     /* 171359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 171367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 171370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 171373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 171376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171388 */     // (intrinsic_wo_chain:{ *:[i32] } 578:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FACGT32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 171388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT32),
     /* 171391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171395 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171397 */     GIR_RootConstrainSelectedInstOperands,
     /* 171398 */     // GIR_Coverage, 1613,
     /* 171398 */     GIR_EraseRootFromParent_Done,
     /* 171399 */   // Label 3331: @171399
     /* 171399 */   GIM_Try, /*On fail goto*//*Label 3332*/ GIMT_Encode4(171444), // Rule ID 1620 //
     /* 171404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 171407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 171412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 171415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 171418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 171421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171433 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 171433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 171436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171440 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171442 */     GIR_RootConstrainSelectedInstOperands,
     /* 171443 */     // GIR_Coverage, 1620,
     /* 171443 */     GIR_EraseRootFromParent_Done,
     /* 171444 */   // Label 3332: @171444
     /* 171444 */   GIM_Try, /*On fail goto*//*Label 3333*/ GIMT_Encode4(171489), // Rule ID 1621 //
     /* 171449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 171452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 171457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 171460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 171463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 171466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171478 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 171478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
     /* 171481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171485 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171487 */     GIR_RootConstrainSelectedInstOperands,
     /* 171488 */     // GIR_Coverage, 1621,
     /* 171488 */     GIR_EraseRootFromParent_Done,
     /* 171489 */   // Label 3333: @171489
     /* 171489 */   GIM_Try, /*On fail goto*//*Label 3334*/ GIMT_Encode4(171534), // Rule ID 1622 //
     /* 171494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 171497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 171502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 171505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 171508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 171511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 171515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 171519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 171523 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 171523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
     /* 171526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171530 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171532 */     GIR_RootConstrainSelectedInstOperands,
     /* 171533 */     // GIR_Coverage, 1622,
     /* 171533 */     GIR_EraseRootFromParent_Done,
     /* 171534 */   // Label 3334: @171534
     /* 171534 */   GIM_Try, /*On fail goto*//*Label 3335*/ GIMT_Encode4(171579), // Rule ID 1623 //
     /* 171539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 171542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 171547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 171550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 171553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 171556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171568 */     // (intrinsic_wo_chain:{ *:[f64] } 633:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FRECPS64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 171568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS64),
     /* 171571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171577 */     GIR_RootConstrainSelectedInstOperands,
     /* 171578 */     // GIR_Coverage, 1623,
     /* 171578 */     GIR_EraseRootFromParent_Done,
     /* 171579 */   // Label 3335: @171579
     /* 171579 */   GIM_Try, /*On fail goto*//*Label 3336*/ GIMT_Encode4(171624), // Rule ID 1624 //
     /* 171584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 171587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 171592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 171595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 171598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 171601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171613 */     // (intrinsic_wo_chain:{ *:[f32] } 633:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FRECPS32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 171613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS32),
     /* 171616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171622 */     GIR_RootConstrainSelectedInstOperands,
     /* 171623 */     // GIR_Coverage, 1624,
     /* 171623 */     GIR_EraseRootFromParent_Done,
     /* 171624 */   // Label 3336: @171624
     /* 171624 */   GIM_Try, /*On fail goto*//*Label 3337*/ GIMT_Encode4(171669), // Rule ID 1625 //
     /* 171629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 171632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 171637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 171640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 171643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 171646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 171650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 171654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 171658 */     // (intrinsic_wo_chain:{ *:[f16] } 633:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FRECPS16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 171658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS16),
     /* 171661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171663 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171665 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171667 */     GIR_RootConstrainSelectedInstOperands,
     /* 171668 */     // GIR_Coverage, 1625,
     /* 171668 */     GIR_EraseRootFromParent_Done,
     /* 171669 */   // Label 3337: @171669
     /* 171669 */   GIM_Try, /*On fail goto*//*Label 3338*/ GIMT_Encode4(171714), // Rule ID 1626 //
     /* 171674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 171677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 171682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 171685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 171688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 171691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171703 */     // (intrinsic_wo_chain:{ *:[f64] } 640:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FRSQRTS64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 171703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS64),
     /* 171706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171710 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171712 */     GIR_RootConstrainSelectedInstOperands,
     /* 171713 */     // GIR_Coverage, 1626,
     /* 171713 */     GIR_EraseRootFromParent_Done,
     /* 171714 */   // Label 3338: @171714
     /* 171714 */   GIM_Try, /*On fail goto*//*Label 3339*/ GIMT_Encode4(171759), // Rule ID 1627 //
     /* 171719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 171722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 171727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 171730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 171733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 171736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171748 */     // (intrinsic_wo_chain:{ *:[f32] } 640:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FRSQRTS32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 171748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS32),
     /* 171751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171755 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171757 */     GIR_RootConstrainSelectedInstOperands,
     /* 171758 */     // GIR_Coverage, 1627,
     /* 171758 */     GIR_EraseRootFromParent_Done,
     /* 171759 */   // Label 3339: @171759
     /* 171759 */   GIM_Try, /*On fail goto*//*Label 3340*/ GIMT_Encode4(171804), // Rule ID 1628 //
     /* 171764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 171767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 171772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 171775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 171778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 171781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 171785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 171789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 171793 */     // (intrinsic_wo_chain:{ *:[f16] } 640:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FRSQRTS16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 171793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS16),
     /* 171796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171802 */     GIR_RootConstrainSelectedInstOperands,
     /* 171803 */     // GIR_Coverage, 1628,
     /* 171803 */     GIR_EraseRootFromParent_Done,
     /* 171804 */   // Label 3340: @171804
     /* 171804 */   GIM_Try, /*On fail goto*//*Label 3341*/ GIMT_Encode4(171849), // Rule ID 1629 //
     /* 171809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 171817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 171820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 171823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 171826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171838 */     // (intrinsic_wo_chain:{ *:[v1i64] } 679:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 171838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i64),
     /* 171841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171845 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171847 */     GIR_RootConstrainSelectedInstOperands,
     /* 171848 */     // GIR_Coverage, 1629,
     /* 171848 */     GIR_EraseRootFromParent_Done,
     /* 171849 */   // Label 3341: @171849
     /* 171849 */   GIM_Try, /*On fail goto*//*Label 3342*/ GIMT_Encode4(171894), // Rule ID 1630 //
     /* 171854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 171862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 171865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 171868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 171871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171883 */     // (intrinsic_wo_chain:{ *:[i32] } 680:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQDMULHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 171883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv1i32),
     /* 171886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171890 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171892 */     GIR_RootConstrainSelectedInstOperands,
     /* 171893 */     // GIR_Coverage, 1630,
     /* 171893 */     GIR_EraseRootFromParent_Done,
     /* 171894 */   // Label 3342: @171894
     /* 171894 */   GIM_Try, /*On fail goto*//*Label 3343*/ GIMT_Encode4(171939), // Rule ID 1631 //
     /* 171899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 171907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 171910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 171913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 171916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171928 */     // (intrinsic_wo_chain:{ *:[i32] } 688:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMULHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 171928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv1i32),
     /* 171931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171935 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171937 */     GIR_RootConstrainSelectedInstOperands,
     /* 171938 */     // GIR_Coverage, 1631,
     /* 171938 */     GIR_EraseRootFromParent_Done,
     /* 171939 */   // Label 3343: @171939
     /* 171939 */   GIM_Try, /*On fail goto*//*Label 3344*/ GIMT_Encode4(171984), // Rule ID 1632 //
     /* 171944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 171952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 171955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 171958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 171961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171973 */     // (intrinsic_wo_chain:{ *:[v1i64] } 691:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 171973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i64),
     /* 171976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171978 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171980 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171982 */     GIR_RootConstrainSelectedInstOperands,
     /* 171983 */     // GIR_Coverage, 1632,
     /* 171983 */     GIR_EraseRootFromParent_Done,
     /* 171984 */   // Label 3344: @171984
     /* 171984 */   GIM_Try, /*On fail goto*//*Label 3345*/ GIMT_Encode4(172029), // Rule ID 1633 //
     /* 171989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 171997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 172000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 172003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 172006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172018 */     // (intrinsic_wo_chain:{ *:[v1i64] } 694:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 172018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i64),
     /* 172021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172025 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172027 */     GIR_RootConstrainSelectedInstOperands,
     /* 172028 */     // GIR_Coverage, 1633,
     /* 172028 */     GIR_EraseRootFromParent_Done,
     /* 172029 */   // Label 3345: @172029
     /* 172029 */   GIM_Try, /*On fail goto*//*Label 3346*/ GIMT_Encode4(172074), // Rule ID 1634 //
     /* 172034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 172042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 172045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 172048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 172051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172063 */     // (intrinsic_wo_chain:{ *:[v1i64] } 698:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQSUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 172063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i64),
     /* 172066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172070 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172072 */     GIR_RootConstrainSelectedInstOperands,
     /* 172073 */     // GIR_Coverage, 1634,
     /* 172073 */     GIR_EraseRootFromParent_Done,
     /* 172074 */   // Label 3346: @172074
     /* 172074 */   GIM_Try, /*On fail goto*//*Label 3347*/ GIMT_Encode4(172119), // Rule ID 1635 //
     /* 172079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 172087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 172090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 172093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 172096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172108 */     // (intrinsic_wo_chain:{ *:[v1i64] } 702:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 172108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv1i64),
     /* 172111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172115 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172117 */     GIR_RootConstrainSelectedInstOperands,
     /* 172118 */     // GIR_Coverage, 1635,
     /* 172118 */     GIR_EraseRootFromParent_Done,
     /* 172119 */   // Label 3347: @172119
     /* 172119 */   GIM_Try, /*On fail goto*//*Label 3348*/ GIMT_Encode4(172164), // Rule ID 1636 //
     /* 172124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 172132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 172135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 172138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 172141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172153 */     // (intrinsic_wo_chain:{ *:[v1i64] } 703:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 172153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv1i64),
     /* 172156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172160 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172162 */     GIR_RootConstrainSelectedInstOperands,
     /* 172163 */     // GIR_Coverage, 1636,
     /* 172163 */     GIR_EraseRootFromParent_Done,
     /* 172164 */   // Label 3348: @172164
     /* 172164 */   GIM_Try, /*On fail goto*//*Label 3349*/ GIMT_Encode4(172209), // Rule ID 1638 //
     /* 172169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 172177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 172180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 172183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 172186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172198 */     // (intrinsic_wo_chain:{ *:[v1i64] } 739:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 172198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i64),
     /* 172201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172205 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172207 */     GIR_RootConstrainSelectedInstOperands,
     /* 172208 */     // GIR_Coverage, 1638,
     /* 172208 */     GIR_EraseRootFromParent_Done,
     /* 172209 */   // Label 3349: @172209
     /* 172209 */   GIM_Try, /*On fail goto*//*Label 3350*/ GIMT_Encode4(172254), // Rule ID 1639 //
     /* 172214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 172222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 172225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 172228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 172231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172243 */     // (intrinsic_wo_chain:{ *:[v1i64] } 740:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 172243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i64),
     /* 172246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172250 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172252 */     GIR_RootConstrainSelectedInstOperands,
     /* 172253 */     // GIR_Coverage, 1639,
     /* 172253 */     GIR_EraseRootFromParent_Done,
     /* 172254 */   // Label 3350: @172254
     /* 172254 */   GIM_Try, /*On fail goto*//*Label 3351*/ GIMT_Encode4(172299), // Rule ID 1640 //
     /* 172259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 172267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 172270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 172273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 172276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172288 */     // (intrinsic_wo_chain:{ *:[v1i64] } 742:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 172288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i64),
     /* 172291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172295 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172297 */     GIR_RootConstrainSelectedInstOperands,
     /* 172298 */     // GIR_Coverage, 1640,
     /* 172298 */     GIR_EraseRootFromParent_Done,
     /* 172299 */   // Label 3351: @172299
     /* 172299 */   GIM_Try, /*On fail goto*//*Label 3352*/ GIMT_Encode4(172344), // Rule ID 1641 //
     /* 172304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 172312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 172315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 172318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 172321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172333 */     // (intrinsic_wo_chain:{ *:[v1i64] } 744:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQSUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 172333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i64),
     /* 172336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172338 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172340 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172342 */     GIR_RootConstrainSelectedInstOperands,
     /* 172343 */     // GIR_Coverage, 1641,
     /* 172343 */     GIR_EraseRootFromParent_Done,
     /* 172344 */   // Label 3352: @172344
     /* 172344 */   GIM_Try, /*On fail goto*//*Label 3353*/ GIMT_Encode4(172389), // Rule ID 1642 //
     /* 172349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 172357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 172360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 172363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 172366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172378 */     // (intrinsic_wo_chain:{ *:[v1i64] } 748:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (URSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 172378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv1i64),
     /* 172381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172383 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172385 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172387 */     GIR_RootConstrainSelectedInstOperands,
     /* 172388 */     // GIR_Coverage, 1642,
     /* 172388 */     GIR_EraseRootFromParent_Done,
     /* 172389 */   // Label 3353: @172389
     /* 172389 */   GIM_Try, /*On fail goto*//*Label 3354*/ GIMT_Encode4(172434), // Rule ID 1643 //
     /* 172394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 172402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 172405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 172408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 172411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172423 */     // (intrinsic_wo_chain:{ *:[v1i64] } 751:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (USHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 172423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv1i64),
     /* 172426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172430 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172432 */     GIR_RootConstrainSelectedInstOperands,
     /* 172433 */     // GIR_Coverage, 1643,
     /* 172433 */     GIR_EraseRootFromParent_Done,
     /* 172434 */   // Label 3354: @172434
     /* 172434 */   GIM_Try, /*On fail goto*//*Label 3355*/ GIMT_Encode4(172479), // Rule ID 1644 //
     /* 172439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 172447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 172450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 172453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 172456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 172464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 172468 */     // (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQDMULLi32:{ *:[i64] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 172468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLi32),
     /* 172471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172475 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172477 */     GIR_RootConstrainSelectedInstOperands,
     /* 172478 */     // GIR_Coverage, 1644,
     /* 172478 */     GIR_EraseRootFromParent_Done,
     /* 172479 */   // Label 3355: @172479
     /* 172479 */   GIM_Try, /*On fail goto*//*Label 3356*/ GIMT_Encode4(172524), // Rule ID 1658 //
     /* 172484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 172492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 172495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 172498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 172501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172513 */     // (intrinsic_wo_chain:{ *:[i64] } 715:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)  =>  (SUQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)
     /* 172513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i64),
     /* 172516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 172520 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 172522 */     GIR_RootConstrainSelectedInstOperands,
     /* 172523 */     // GIR_Coverage, 1658,
     /* 172523 */     GIR_EraseRootFromParent_Done,
     /* 172524 */   // Label 3356: @172524
     /* 172524 */   GIM_Try, /*On fail goto*//*Label 3357*/ GIMT_Encode4(172569), // Rule ID 1659 //
     /* 172529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 172537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 172540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 172543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 172546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 172550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 172554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 172558 */     // (intrinsic_wo_chain:{ *:[i32] } 715:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)  =>  (SUQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)
     /* 172558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i32),
     /* 172561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 172565 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 172567 */     GIR_RootConstrainSelectedInstOperands,
     /* 172568 */     // GIR_Coverage, 1659,
     /* 172568 */     GIR_EraseRootFromParent_Done,
     /* 172569 */   // Label 3357: @172569
     /* 172569 */   GIM_Try, /*On fail goto*//*Label 3358*/ GIMT_Encode4(172614), // Rule ID 1664 //
     /* 172574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 172582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 172585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 172588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 172591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172603 */     // (intrinsic_wo_chain:{ *:[i64] } 754:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)  =>  (USQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)
     /* 172603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i64),
     /* 172606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 172610 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 172612 */     GIR_RootConstrainSelectedInstOperands,
     /* 172613 */     // GIR_Coverage, 1664,
     /* 172613 */     GIR_EraseRootFromParent_Done,
     /* 172614 */   // Label 3358: @172614
     /* 172614 */   GIM_Try, /*On fail goto*//*Label 3359*/ GIMT_Encode4(172659), // Rule ID 1665 //
     /* 172619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 172627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 172630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 172633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 172636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 172640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 172644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 172648 */     // (intrinsic_wo_chain:{ *:[i32] } 754:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)  =>  (USQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)
     /* 172648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i32),
     /* 172651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 172655 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 172657 */     GIR_RootConstrainSelectedInstOperands,
     /* 172658 */     // GIR_Coverage, 1665,
     /* 172658 */     GIR_EraseRootFromParent_Done,
     /* 172659 */   // Label 3359: @172659
     /* 172659 */   GIM_Try, /*On fail goto*//*Label 3360*/ GIMT_Encode4(172704), // Rule ID 1666 //
     /* 172664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 172672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 172675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 172678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 172681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172693 */     // (intrinsic_wo_chain:{ *:[v8i8] } 569:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 172693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v8i8),
     /* 172696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172700 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172702 */     GIR_RootConstrainSelectedInstOperands,
     /* 172703 */     // GIR_Coverage, 1666,
     /* 172703 */     GIR_EraseRootFromParent_Done,
     /* 172704 */   // Label 3360: @172704
     /* 172704 */   GIM_Try, /*On fail goto*//*Label 3361*/ GIMT_Encode4(172749), // Rule ID 1667 //
     /* 172709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 172717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 172720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 172723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 172726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172738 */     // (intrinsic_wo_chain:{ *:[v4i16] } 569:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 172738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v4i16),
     /* 172741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172743 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172745 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172747 */     GIR_RootConstrainSelectedInstOperands,
     /* 172748 */     // GIR_Coverage, 1667,
     /* 172748 */     GIR_EraseRootFromParent_Done,
     /* 172749 */   // Label 3361: @172749
     /* 172749 */   GIM_Try, /*On fail goto*//*Label 3362*/ GIMT_Encode4(172794), // Rule ID 1668 //
     /* 172754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 172762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 172765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 172768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 172771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172783 */     // (intrinsic_wo_chain:{ *:[v2i32] } 569:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 172783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v2i32),
     /* 172786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172788 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172790 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172792 */     GIR_RootConstrainSelectedInstOperands,
     /* 172793 */     // GIR_Coverage, 1668,
     /* 172793 */     GIR_EraseRootFromParent_Done,
     /* 172794 */   // Label 3362: @172794
     /* 172794 */   GIM_Try, /*On fail goto*//*Label 3363*/ GIMT_Encode4(172839), // Rule ID 1669 //
     /* 172799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 172807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 172810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 172813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 172816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172828 */     // (intrinsic_wo_chain:{ *:[v8i8] } 714:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 172828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v8i8),
     /* 172831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172835 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172837 */     GIR_RootConstrainSelectedInstOperands,
     /* 172838 */     // GIR_Coverage, 1669,
     /* 172838 */     GIR_EraseRootFromParent_Done,
     /* 172839 */   // Label 3363: @172839
     /* 172839 */   GIM_Try, /*On fail goto*//*Label 3364*/ GIMT_Encode4(172884), // Rule ID 1670 //
     /* 172844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 172852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 172855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 172858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 172861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172873 */     // (intrinsic_wo_chain:{ *:[v4i16] } 714:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 172873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v4i16),
     /* 172876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172882 */     GIR_RootConstrainSelectedInstOperands,
     /* 172883 */     // GIR_Coverage, 1670,
     /* 172883 */     GIR_EraseRootFromParent_Done,
     /* 172884 */   // Label 3364: @172884
     /* 172884 */   GIM_Try, /*On fail goto*//*Label 3365*/ GIMT_Encode4(172929), // Rule ID 1671 //
     /* 172889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 172897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 172900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 172903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 172906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172918 */     // (intrinsic_wo_chain:{ *:[v2i32] } 714:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 172918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v2i32),
     /* 172921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172925 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172927 */     GIR_RootConstrainSelectedInstOperands,
     /* 172928 */     // GIR_Coverage, 1671,
     /* 172928 */     GIR_EraseRootFromParent_Done,
     /* 172929 */   // Label 3365: @172929
     /* 172929 */   GIM_Try, /*On fail goto*//*Label 3366*/ GIMT_Encode4(172974), // Rule ID 1672 //
     /* 172934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 172942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 172945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 172948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 172951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172963 */     // (intrinsic_wo_chain:{ *:[v8i8] } 656:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (RADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 172963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v8i8),
     /* 172966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172970 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172972 */     GIR_RootConstrainSelectedInstOperands,
     /* 172973 */     // GIR_Coverage, 1672,
     /* 172973 */     GIR_EraseRootFromParent_Done,
     /* 172974 */   // Label 3366: @172974
     /* 172974 */   GIM_Try, /*On fail goto*//*Label 3367*/ GIMT_Encode4(173019), // Rule ID 1673 //
     /* 172979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 172987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 172990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 172993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 172996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173008 */     // (intrinsic_wo_chain:{ *:[v4i16] } 656:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (RADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 173008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v4i16),
     /* 173011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173015 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173017 */     GIR_RootConstrainSelectedInstOperands,
     /* 173018 */     // GIR_Coverage, 1673,
     /* 173018 */     GIR_EraseRootFromParent_Done,
     /* 173019 */   // Label 3367: @173019
     /* 173019 */   GIM_Try, /*On fail goto*//*Label 3368*/ GIMT_Encode4(173064), // Rule ID 1674 //
     /* 173024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 173032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 173035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 173038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 173041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173053 */     // (intrinsic_wo_chain:{ *:[v2i32] } 656:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (RADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 173053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v2i32),
     /* 173056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173058 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173060 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173062 */     GIR_RootConstrainSelectedInstOperands,
     /* 173063 */     // GIR_Coverage, 1674,
     /* 173063 */     GIR_EraseRootFromParent_Done,
     /* 173064 */   // Label 3368: @173064
     /* 173064 */   GIM_Try, /*On fail goto*//*Label 3369*/ GIMT_Encode4(173109), // Rule ID 1675 //
     /* 173069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 173077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 173080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 173083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 173086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173098 */     // (intrinsic_wo_chain:{ *:[v8i8] } 658:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (RSUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 173098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv8i16_v8i8),
     /* 173101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173105 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173107 */     GIR_RootConstrainSelectedInstOperands,
     /* 173108 */     // GIR_Coverage, 1675,
     /* 173108 */     GIR_EraseRootFromParent_Done,
     /* 173109 */   // Label 3369: @173109
     /* 173109 */   GIM_Try, /*On fail goto*//*Label 3370*/ GIMT_Encode4(173154), // Rule ID 1676 //
     /* 173114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 173122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 173125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 173128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 173131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173143 */     // (intrinsic_wo_chain:{ *:[v4i16] } 658:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (RSUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 173143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv4i32_v4i16),
     /* 173146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173152 */     GIR_RootConstrainSelectedInstOperands,
     /* 173153 */     // GIR_Coverage, 1676,
     /* 173153 */     GIR_EraseRootFromParent_Done,
     /* 173154 */   // Label 3370: @173154
     /* 173154 */   GIM_Try, /*On fail goto*//*Label 3371*/ GIMT_Encode4(173199), // Rule ID 1677 //
     /* 173159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 173167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 173170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 173173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 173176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173188 */     // (intrinsic_wo_chain:{ *:[v2i32] } 658:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (RSUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 173188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv2i64_v2i32),
     /* 173191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173195 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173197 */     GIR_RootConstrainSelectedInstOperands,
     /* 173198 */     // GIR_Coverage, 1677,
     /* 173198 */     GIR_EraseRootFromParent_Done,
     /* 173199 */   // Label 3371: @173199
     /* 173199 */   GIM_Try, /*On fail goto*//*Label 3372*/ GIMT_Encode4(173244), // Rule ID 1743 //
     /* 173204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 173212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 173215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173233 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQDMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 173233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_v4i32),
     /* 173236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173240 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173242 */     GIR_RootConstrainSelectedInstOperands,
     /* 173243 */     // GIR_Coverage, 1743,
     /* 173243 */     GIR_EraseRootFromParent_Done,
     /* 173244 */   // Label 3372: @173244
     /* 173244 */   GIM_Try, /*On fail goto*//*Label 3373*/ GIMT_Encode4(173289), // Rule ID 1745 //
     /* 173249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 173257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 173260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 173263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 173266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173278 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQDMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 173278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_v2i64),
     /* 173281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173285 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173287 */     GIR_RootConstrainSelectedInstOperands,
     /* 173288 */     // GIR_Coverage, 1745,
     /* 173288 */     GIR_EraseRootFromParent_Done,
     /* 173289 */   // Label 3373: @173289
     /* 173289 */   GIM_Try, /*On fail goto*//*Label 3374*/ GIMT_Encode4(173334), // Rule ID 2294 //
     /* 173294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 173297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aese),
     /* 173302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 173305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 173308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 173311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173323 */     // (intrinsic_wo_chain:{ *:[v16i8] } 512:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (AESErr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 173323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESErr),
     /* 173326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 173330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 173332 */     GIR_RootConstrainSelectedInstOperands,
     /* 173333 */     // GIR_Coverage, 2294,
     /* 173333 */     GIR_EraseRootFromParent_Done,
     /* 173334 */   // Label 3374: @173334
     /* 173334 */   GIM_Try, /*On fail goto*//*Label 3375*/ GIMT_Encode4(173379), // Rule ID 2295 //
     /* 173339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 173342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesd),
     /* 173347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 173350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 173353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 173356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173368 */     // (intrinsic_wo_chain:{ *:[v16i8] } 511:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (AESDrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 173368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESDrr),
     /* 173371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 173375 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 173377 */     GIR_RootConstrainSelectedInstOperands,
     /* 173378 */     // GIR_Coverage, 2295,
     /* 173378 */     GIR_EraseRootFromParent_Done,
     /* 173379 */   // Label 3375: @173379
     /* 173379 */   GIM_Try, /*On fail goto*//*Label 3376*/ GIMT_Encode4(173424), // Rule ID 2306 //
     /* 173384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 173387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1su1),
     /* 173392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 173395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 173398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 173401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173413 */     // (intrinsic_wo_chain:{ *:[v4i32] } 525:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SHA1SU1rr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 173413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1SU1rr),
     /* 173416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173418 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 173420 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 173422 */     GIR_RootConstrainSelectedInstOperands,
     /* 173423 */     // GIR_Coverage, 2306,
     /* 173423 */     GIR_EraseRootFromParent_Done,
     /* 173424 */   // Label 3376: @173424
     /* 173424 */   GIM_Try, /*On fail goto*//*Label 3377*/ GIMT_Encode4(173469), // Rule ID 2307 //
     /* 173429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 173432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256su0),
     /* 173437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 173440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 173443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 173446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173458 */     // (intrinsic_wo_chain:{ *:[v4i32] } 528:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SHA256SU0rr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 173458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256SU0rr),
     /* 173461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 173465 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 173467 */     GIR_RootConstrainSelectedInstOperands,
     /* 173468 */     // GIR_Coverage, 2307,
     /* 173468 */     GIR_EraseRootFromParent_Done,
     /* 173469 */   // Label 3377: @173469
     /* 173469 */   GIM_Try, /*On fail goto*//*Label 3378*/ GIMT_Encode4(173514), // Rule ID 2330 //
     /* 173474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 173477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 173482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 173485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173503 */     // (intrinsic_wo_chain:{ *:[v4f16] } 631:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (FSCALEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 173503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv4f16),
     /* 173506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173510 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173512 */     GIR_RootConstrainSelectedInstOperands,
     /* 173513 */     // GIR_Coverage, 2330,
     /* 173513 */     GIR_EraseRootFromParent_Done,
     /* 173514 */   // Label 3378: @173514
     /* 173514 */   GIM_Try, /*On fail goto*//*Label 3379*/ GIMT_Encode4(173559), // Rule ID 2331 //
     /* 173519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 173522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 173527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 173530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 173533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 173536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173548 */     // (intrinsic_wo_chain:{ *:[v8f16] } 631:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (FSCALEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 173548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv8f16),
     /* 173551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173555 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173557 */     GIR_RootConstrainSelectedInstOperands,
     /* 173558 */     // GIR_Coverage, 2331,
     /* 173558 */     GIR_EraseRootFromParent_Done,
     /* 173559 */   // Label 3379: @173559
     /* 173559 */   GIM_Try, /*On fail goto*//*Label 3380*/ GIMT_Encode4(173604), // Rule ID 2332 //
     /* 173564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 173567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 173572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 173575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 173578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 173581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173593 */     // (intrinsic_wo_chain:{ *:[v2f32] } 631:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (FSCALEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 173593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv2f32),
     /* 173596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173602 */     GIR_RootConstrainSelectedInstOperands,
     /* 173603 */     // GIR_Coverage, 2332,
     /* 173603 */     GIR_EraseRootFromParent_Done,
     /* 173604 */   // Label 3380: @173604
     /* 173604 */   GIM_Try, /*On fail goto*//*Label 3381*/ GIMT_Encode4(173649), // Rule ID 2333 //
     /* 173609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 173612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 173617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 173620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 173623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 173626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173638 */     // (intrinsic_wo_chain:{ *:[v4f32] } 631:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (FSCALEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 173638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv4f32),
     /* 173641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173645 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173647 */     GIR_RootConstrainSelectedInstOperands,
     /* 173648 */     // GIR_Coverage, 2333,
     /* 173648 */     GIR_EraseRootFromParent_Done,
     /* 173649 */   // Label 3381: @173649
     /* 173649 */   GIM_Try, /*On fail goto*//*Label 3382*/ GIMT_Encode4(173694), // Rule ID 2334 //
     /* 173654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 173657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 173662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 173665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 173668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 173671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173683 */     // (intrinsic_wo_chain:{ *:[v2f64] } 631:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (FSCALEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 173683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv2f64),
     /* 173686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173688 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173690 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173692 */     GIR_RootConstrainSelectedInstOperands,
     /* 173693 */     // GIR_Coverage, 2334,
     /* 173693 */     GIR_EraseRootFromParent_Done,
     /* 173694 */   // Label 3382: @173694
     /* 173694 */   GIM_Try, /*On fail goto*//*Label 3383*/ GIMT_Encode4(173739), // Rule ID 2335 //
     /* 173699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 173702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 173707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 173710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173728 */     // (intrinsic_wo_chain:{ *:[v4f16] } 581:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FAMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 173728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f16),
     /* 173731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173733 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173735 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173737 */     GIR_RootConstrainSelectedInstOperands,
     /* 173738 */     // GIR_Coverage, 2335,
     /* 173738 */     GIR_EraseRootFromParent_Done,
     /* 173739 */   // Label 3383: @173739
     /* 173739 */   GIM_Try, /*On fail goto*//*Label 3384*/ GIMT_Encode4(173784), // Rule ID 2338 //
     /* 173744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 173747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 173752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 173755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 173758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 173761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173773 */     // (intrinsic_wo_chain:{ *:[v8f16] } 581:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FAMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 173773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv8f16),
     /* 173776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173782 */     GIR_RootConstrainSelectedInstOperands,
     /* 173783 */     // GIR_Coverage, 2338,
     /* 173783 */     GIR_EraseRootFromParent_Done,
     /* 173784 */   // Label 3384: @173784
     /* 173784 */   GIM_Try, /*On fail goto*//*Label 3385*/ GIMT_Encode4(173829), // Rule ID 2341 //
     /* 173789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 173792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 173797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 173800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 173803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 173806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173818 */     // (intrinsic_wo_chain:{ *:[v2f32] } 581:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FAMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 173818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f32),
     /* 173821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173825 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173827 */     GIR_RootConstrainSelectedInstOperands,
     /* 173828 */     // GIR_Coverage, 2341,
     /* 173828 */     GIR_EraseRootFromParent_Done,
     /* 173829 */   // Label 3385: @173829
     /* 173829 */   GIM_Try, /*On fail goto*//*Label 3386*/ GIMT_Encode4(173874), // Rule ID 2344 //
     /* 173834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 173837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 173842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 173845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 173848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 173851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173863 */     // (intrinsic_wo_chain:{ *:[v4f32] } 581:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FAMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 173863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f32),
     /* 173866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173868 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173870 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173872 */     GIR_RootConstrainSelectedInstOperands,
     /* 173873 */     // GIR_Coverage, 2344,
     /* 173873 */     GIR_EraseRootFromParent_Done,
     /* 173874 */   // Label 3386: @173874
     /* 173874 */   GIM_Try, /*On fail goto*//*Label 3387*/ GIMT_Encode4(173919), // Rule ID 2347 //
     /* 173879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 173882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 173887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 173890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 173893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 173896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173908 */     // (intrinsic_wo_chain:{ *:[v2f64] } 581:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FAMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 173908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f64),
     /* 173911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173915 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173917 */     GIR_RootConstrainSelectedInstOperands,
     /* 173918 */     // GIR_Coverage, 2347,
     /* 173918 */     GIR_EraseRootFromParent_Done,
     /* 173919 */   // Label 3387: @173919
     /* 173919 */   GIM_Try, /*On fail goto*//*Label 3388*/ GIMT_Encode4(173964), // Rule ID 2350 //
     /* 173924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 173927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 173932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 173935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173953 */     // (intrinsic_wo_chain:{ *:[v4f16] } 582:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FAMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 173953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f16),
     /* 173956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173962 */     GIR_RootConstrainSelectedInstOperands,
     /* 173963 */     // GIR_Coverage, 2350,
     /* 173963 */     GIR_EraseRootFromParent_Done,
     /* 173964 */   // Label 3388: @173964
     /* 173964 */   GIM_Try, /*On fail goto*//*Label 3389*/ GIMT_Encode4(174009), // Rule ID 2353 //
     /* 173969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 173972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 173977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 173980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 173983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 173986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173998 */     // (intrinsic_wo_chain:{ *:[v8f16] } 582:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FAMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 173998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv8f16),
     /* 174001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174005 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174007 */     GIR_RootConstrainSelectedInstOperands,
     /* 174008 */     // GIR_Coverage, 2353,
     /* 174008 */     GIR_EraseRootFromParent_Done,
     /* 174009 */   // Label 3389: @174009
     /* 174009 */   GIM_Try, /*On fail goto*//*Label 3390*/ GIMT_Encode4(174054), // Rule ID 2356 //
     /* 174014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 174017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 174022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 174025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 174028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 174031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174043 */     // (intrinsic_wo_chain:{ *:[v2f32] } 582:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FAMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 174043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f32),
     /* 174046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174048 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174050 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174052 */     GIR_RootConstrainSelectedInstOperands,
     /* 174053 */     // GIR_Coverage, 2356,
     /* 174053 */     GIR_EraseRootFromParent_Done,
     /* 174054 */   // Label 3390: @174054
     /* 174054 */   GIM_Try, /*On fail goto*//*Label 3391*/ GIMT_Encode4(174099), // Rule ID 2359 //
     /* 174059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 174062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 174067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 174070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 174073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 174076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174088 */     // (intrinsic_wo_chain:{ *:[v4f32] } 582:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FAMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 174088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f32),
     /* 174091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174095 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174097 */     GIR_RootConstrainSelectedInstOperands,
     /* 174098 */     // GIR_Coverage, 2359,
     /* 174098 */     GIR_EraseRootFromParent_Done,
     /* 174099 */   // Label 3391: @174099
     /* 174099 */   GIM_Try, /*On fail goto*//*Label 3392*/ GIMT_Encode4(174144), // Rule ID 2362 //
     /* 174104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 174107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 174112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 174115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 174118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 174121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174133 */     // (intrinsic_wo_chain:{ *:[v2f64] } 582:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FAMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 174133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f64),
     /* 174136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174138 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174140 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174142 */     GIR_RootConstrainSelectedInstOperands,
     /* 174143 */     // GIR_Coverage, 2362,
     /* 174143 */     GIR_EraseRootFromParent_Done,
     /* 174144 */   // Label 3392: @174144
     /* 174144 */   GIM_Try, /*On fail goto*//*Label 3393*/ GIMT_Encode4(174189), // Rule ID 2499 //
     /* 174149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 174157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 174160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 174163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 174166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174178 */     // (intrinsic_wo_chain:{ *:[i64] } 679:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 174178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i64),
     /* 174181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174185 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174187 */     GIR_RootConstrainSelectedInstOperands,
     /* 174188 */     // GIR_Coverage, 2499,
     /* 174188 */     GIR_EraseRootFromParent_Done,
     /* 174189 */   // Label 3393: @174189
     /* 174189 */   GIM_Try, /*On fail goto*//*Label 3394*/ GIMT_Encode4(174234), // Rule ID 2500 //
     /* 174194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 174202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 174205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 174208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 174211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 174215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 174219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 174223 */     // (intrinsic_wo_chain:{ *:[i32] } 679:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 174223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i32),
     /* 174226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174230 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174232 */     GIR_RootConstrainSelectedInstOperands,
     /* 174233 */     // GIR_Coverage, 2500,
     /* 174233 */     GIR_EraseRootFromParent_Done,
     /* 174234 */   // Label 3394: @174234
     /* 174234 */   GIM_Try, /*On fail goto*//*Label 3395*/ GIMT_Encode4(174279), // Rule ID 2501 //
     /* 174239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 174247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 174250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 174253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 174256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174268 */     // (intrinsic_wo_chain:{ *:[v1f64] } 785:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FABD64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 174268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 174271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174273 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174275 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174277 */     GIR_RootConstrainSelectedInstOperands,
     /* 174278 */     // GIR_Coverage, 2501,
     /* 174278 */     GIR_EraseRootFromParent_Done,
     /* 174279 */   // Label 3395: @174279
     /* 174279 */   GIM_Try, /*On fail goto*//*Label 3396*/ GIMT_Encode4(174324), // Rule ID 2502 //
     /* 174284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 174292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 174295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 174298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 174301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174313 */     // (intrinsic_wo_chain:{ *:[v1i64] } 577:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FACGE64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 174313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE64),
     /* 174316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174320 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174322 */     GIR_RootConstrainSelectedInstOperands,
     /* 174323 */     // GIR_Coverage, 2502,
     /* 174323 */     GIR_EraseRootFromParent_Done,
     /* 174324 */   // Label 3396: @174324
     /* 174324 */   GIM_Try, /*On fail goto*//*Label 3397*/ GIMT_Encode4(174369), // Rule ID 2507 //
     /* 174329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 174337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 174340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 174343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 174346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174358 */     // (intrinsic_wo_chain:{ *:[v1i64] } 715:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)  =>  (SUQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)
     /* 174358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i64),
     /* 174361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174363 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 174365 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 174367 */     GIR_RootConstrainSelectedInstOperands,
     /* 174368 */     // GIR_Coverage, 2507,
     /* 174368 */     GIR_EraseRootFromParent_Done,
     /* 174369 */   // Label 3397: @174369
     /* 174369 */   GIM_Try, /*On fail goto*//*Label 3398*/ GIMT_Encode4(174414), // Rule ID 2620 //
     /* 174374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 174377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 174382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 174385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 174388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 174391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 174395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 174399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 174403 */     // (intrinsic_wo_chain:{ *:[i32] } 1931:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQINCP_WP_B:{ *:[i32] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 174403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_B),
     /* 174406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 174408 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 174410 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174412 */     GIR_RootConstrainSelectedInstOperands,
     /* 174413 */     // GIR_Coverage, 2620,
     /* 174413 */     GIR_EraseRootFromParent_Done,
     /* 174414 */   // Label 3398: @174414
     /* 174414 */   GIM_Try, /*On fail goto*//*Label 3399*/ GIMT_Encode4(174459), // Rule ID 2621 //
     /* 174419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 174422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 174427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 174430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 174433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 174436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 174440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 174444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 174448 */     // (intrinsic_wo_chain:{ *:[i32] } 1931:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQINCP_WP_H:{ *:[i32] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 174448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_H),
     /* 174451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 174453 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 174455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174457 */     GIR_RootConstrainSelectedInstOperands,
     /* 174458 */     // GIR_Coverage, 2621,
     /* 174458 */     GIR_EraseRootFromParent_Done,
     /* 174459 */   // Label 3399: @174459
     /* 174459 */   GIM_Try, /*On fail goto*//*Label 3400*/ GIMT_Encode4(174504), // Rule ID 2622 //
     /* 174464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 174467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 174472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 174475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 174478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 174481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 174485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 174489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 174493 */     // (intrinsic_wo_chain:{ *:[i32] } 1931:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQINCP_WP_S:{ *:[i32] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 174493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_S),
     /* 174496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 174498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 174500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174502 */     GIR_RootConstrainSelectedInstOperands,
     /* 174503 */     // GIR_Coverage, 2622,
     /* 174503 */     GIR_EraseRootFromParent_Done,
     /* 174504 */   // Label 3400: @174504
     /* 174504 */   GIM_Try, /*On fail goto*//*Label 3401*/ GIMT_Encode4(174549), // Rule ID 2623 //
     /* 174509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 174512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 174517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 174520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 174523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 174526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 174530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 174534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 174538 */     // (intrinsic_wo_chain:{ *:[i32] } 1931:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQINCP_WP_D:{ *:[i32] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 174538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_D),
     /* 174541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 174543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 174545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174547 */     GIR_RootConstrainSelectedInstOperands,
     /* 174548 */     // GIR_Coverage, 2623,
     /* 174548 */     GIR_EraseRootFromParent_Done,
     /* 174549 */   // Label 3401: @174549
     /* 174549 */   GIM_Try, /*On fail goto*//*Label 3402*/ GIMT_Encode4(174594), // Rule ID 2624 //
     /* 174554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 174557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 174562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 174565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 174568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 174571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 174575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 174579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 174583 */     // (intrinsic_wo_chain:{ *:[i64] } 1721:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (SQINCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 174583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_B),
     /* 174586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 174588 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 174590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174592 */     GIR_RootConstrainSelectedInstOperands,
     /* 174593 */     // GIR_Coverage, 2624,
     /* 174593 */     GIR_EraseRootFromParent_Done,
     /* 174594 */   // Label 3402: @174594
     /* 174594 */   GIM_Try, /*On fail goto*//*Label 3403*/ GIMT_Encode4(174639), // Rule ID 2625 //
     /* 174599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 174602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 174607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 174610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 174613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 174616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 174620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 174624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 174628 */     // (intrinsic_wo_chain:{ *:[i64] } 1721:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (SQINCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 174628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_H),
     /* 174631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 174633 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 174635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174637 */     GIR_RootConstrainSelectedInstOperands,
     /* 174638 */     // GIR_Coverage, 2625,
     /* 174638 */     GIR_EraseRootFromParent_Done,
     /* 174639 */   // Label 3403: @174639
     /* 174639 */   GIM_Try, /*On fail goto*//*Label 3404*/ GIMT_Encode4(174684), // Rule ID 2626 //
     /* 174644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 174647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 174652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 174655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 174658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 174661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 174665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 174669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 174673 */     // (intrinsic_wo_chain:{ *:[i64] } 1721:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (SQINCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 174673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_S),
     /* 174676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 174678 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 174680 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174682 */     GIR_RootConstrainSelectedInstOperands,
     /* 174683 */     // GIR_Coverage, 2626,
     /* 174683 */     GIR_EraseRootFromParent_Done,
     /* 174684 */   // Label 3404: @174684
     /* 174684 */   GIM_Try, /*On fail goto*//*Label 3405*/ GIMT_Encode4(174729), // Rule ID 2627 //
     /* 174689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 174692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 174697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 174700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 174703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 174706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 174710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 174714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 174718 */     // (intrinsic_wo_chain:{ *:[i64] } 1721:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (SQINCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 174718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_D),
     /* 174721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 174723 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 174725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174727 */     GIR_RootConstrainSelectedInstOperands,
     /* 174728 */     // GIR_Coverage, 2627,
     /* 174728 */     GIR_EraseRootFromParent_Done,
     /* 174729 */   // Label 3405: @174729
     /* 174729 */   GIM_Try, /*On fail goto*//*Label 3406*/ GIMT_Encode4(174774), // Rule ID 3757 //
     /* 174734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 174737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512su0),
     /* 174742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 174745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 174748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 174751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174763 */     // (intrinsic_wo_chain:{ *:[v2i64] } 532:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512SU0:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 174763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512SU0),
     /* 174766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 174768 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 174770 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 174772 */     GIR_RootConstrainSelectedInstOperands,
     /* 174773 */     // GIR_Coverage, 3757,
     /* 174773 */     GIR_EraseRootFromParent_Done,
     /* 174774 */   // Label 3406: @174774
     /* 174774 */   GIM_Try, /*On fail goto*//*Label 3407*/ GIMT_Encode4(174819), // Rule ID 3785 //
     /* 174779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 174782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_rax1),
     /* 174787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 174790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 174793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 174796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174808 */     // (intrinsic_wo_chain:{ *:[v2i64] } 519:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (RAX1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 174808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RAX1),
     /* 174811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 174813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 174815 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 174817 */     GIR_RootConstrainSelectedInstOperands,
     /* 174818 */     // GIR_Coverage, 3785,
     /* 174818 */     GIR_EraseRootFromParent_Done,
     /* 174819 */   // Label 3407: @174819
     /* 174819 */   GIM_Try, /*On fail goto*//*Label 3408*/ GIMT_Encode4(174864), // Rule ID 3795 //
     /* 174824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 174827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm4ekey),
     /* 174832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 174835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 174838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 174841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174853 */     // (intrinsic_wo_chain:{ *:[v4i32] } 542:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM4ENCKEY:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 174853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4ENCKEY),
     /* 174856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 174858 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 174860 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 174862 */     GIR_RootConstrainSelectedInstOperands,
     /* 174863 */     // GIR_Coverage, 3795,
     /* 174863 */     GIR_EraseRootFromParent_Done,
     /* 174864 */   // Label 3408: @174864
     /* 174864 */   GIM_Try, /*On fail goto*//*Label 3409*/ GIMT_Encode4(174909), // Rule ID 3796 //
     /* 174869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 174872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm4e),
     /* 174877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 174880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 174883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 174886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174898 */     // (intrinsic_wo_chain:{ *:[v4i32] } 541:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM4E:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 174898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4E),
     /* 174901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 174903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 174905 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 174907 */     GIR_RootConstrainSelectedInstOperands,
     /* 174908 */     // GIR_Coverage, 3796,
     /* 174908 */     GIR_EraseRootFromParent_Done,
     /* 174909 */   // Label 3409: @174909
     /* 174909 */   GIM_Try, /*On fail goto*//*Label 3410*/ GIMT_Encode4(174957), // Rule ID 3797 //
     /* 174914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 174917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 174922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 174925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174943 */     // (intrinsic_wo_chain:{ *:[v4f16] } 756:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, 0:{ *:[i32] })
     /* 174943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f16),
     /* 174946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174950 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174955 */     GIR_RootConstrainSelectedInstOperands,
     /* 174956 */     // GIR_Coverage, 3797,
     /* 174956 */     GIR_EraseRootFromParent_Done,
     /* 174957 */   // Label 3410: @174957
     /* 174957 */   GIM_Try, /*On fail goto*//*Label 3411*/ GIMT_Encode4(175005), // Rule ID 3798 //
     /* 174962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 174965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 174970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 174973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174991 */     // (intrinsic_wo_chain:{ *:[v4f16] } 755:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, 1:{ *:[i32] })
     /* 174991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f16),
     /* 174994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174998 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 175003 */     GIR_RootConstrainSelectedInstOperands,
     /* 175004 */     // GIR_Coverage, 3798,
     /* 175004 */     GIR_EraseRootFromParent_Done,
     /* 175005 */   // Label 3411: @175005
     /* 175005 */   GIM_Try, /*On fail goto*//*Label 3412*/ GIMT_Encode4(175053), // Rule ID 3799 //
     /* 175010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 175013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 175018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 175021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 175024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 175027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175039 */     // (intrinsic_wo_chain:{ *:[v8f16] } 756:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, 0:{ *:[i32] })
     /* 175039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv8f16),
     /* 175042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175046 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175051 */     GIR_RootConstrainSelectedInstOperands,
     /* 175052 */     // GIR_Coverage, 3799,
     /* 175052 */     GIR_EraseRootFromParent_Done,
     /* 175053 */   // Label 3412: @175053
     /* 175053 */   GIM_Try, /*On fail goto*//*Label 3413*/ GIMT_Encode4(175101), // Rule ID 3800 //
     /* 175058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 175061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 175066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 175069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 175072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 175075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175087 */     // (intrinsic_wo_chain:{ *:[v8f16] } 755:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, 1:{ *:[i32] })
     /* 175087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv8f16),
     /* 175090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 175099 */     GIR_RootConstrainSelectedInstOperands,
     /* 175100 */     // GIR_Coverage, 3800,
     /* 175100 */     GIR_EraseRootFromParent_Done,
     /* 175101 */   // Label 3413: @175101
     /* 175101 */   GIM_Try, /*On fail goto*//*Label 3414*/ GIMT_Encode4(175149), // Rule ID 3801 //
     /* 175106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 175109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 175114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 175117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 175120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 175123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175135 */     // (intrinsic_wo_chain:{ *:[v2f32] } 756:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, 0:{ *:[i32] })
     /* 175135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f32),
     /* 175138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175142 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175147 */     GIR_RootConstrainSelectedInstOperands,
     /* 175148 */     // GIR_Coverage, 3801,
     /* 175148 */     GIR_EraseRootFromParent_Done,
     /* 175149 */   // Label 3414: @175149
     /* 175149 */   GIM_Try, /*On fail goto*//*Label 3415*/ GIMT_Encode4(175197), // Rule ID 3802 //
     /* 175154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 175157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 175162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 175165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 175168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 175171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175183 */     // (intrinsic_wo_chain:{ *:[v2f32] } 755:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, 1:{ *:[i32] })
     /* 175183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f32),
     /* 175186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175190 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 175195 */     GIR_RootConstrainSelectedInstOperands,
     /* 175196 */     // GIR_Coverage, 3802,
     /* 175196 */     GIR_EraseRootFromParent_Done,
     /* 175197 */   // Label 3415: @175197
     /* 175197 */   GIM_Try, /*On fail goto*//*Label 3416*/ GIMT_Encode4(175245), // Rule ID 3803 //
     /* 175202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 175205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 175210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 175213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 175216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 175219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175231 */     // (intrinsic_wo_chain:{ *:[v4f32] } 756:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, 0:{ *:[i32] })
     /* 175231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f32),
     /* 175234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175238 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175243 */     GIR_RootConstrainSelectedInstOperands,
     /* 175244 */     // GIR_Coverage, 3803,
     /* 175244 */     GIR_EraseRootFromParent_Done,
     /* 175245 */   // Label 3416: @175245
     /* 175245 */   GIM_Try, /*On fail goto*//*Label 3417*/ GIMT_Encode4(175293), // Rule ID 3804 //
     /* 175250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 175253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 175258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 175261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 175264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 175267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175279 */     // (intrinsic_wo_chain:{ *:[v4f32] } 755:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, 1:{ *:[i32] })
     /* 175279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f32),
     /* 175282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 175291 */     GIR_RootConstrainSelectedInstOperands,
     /* 175292 */     // GIR_Coverage, 3804,
     /* 175292 */     GIR_EraseRootFromParent_Done,
     /* 175293 */   // Label 3417: @175293
     /* 175293 */   GIM_Try, /*On fail goto*//*Label 3418*/ GIMT_Encode4(175341), // Rule ID 3805 //
     /* 175298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 175301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 175306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 175309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 175312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 175315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175327 */     // (intrinsic_wo_chain:{ *:[v2f64] } 756:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, 0:{ *:[i32] })
     /* 175327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f64),
     /* 175330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175334 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175339 */     GIR_RootConstrainSelectedInstOperands,
     /* 175340 */     // GIR_Coverage, 3805,
     /* 175340 */     GIR_EraseRootFromParent_Done,
     /* 175341 */   // Label 3418: @175341
     /* 175341 */   GIM_Try, /*On fail goto*//*Label 3419*/ GIMT_Encode4(175389), // Rule ID 3806 //
     /* 175346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 175349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 175354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 175357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 175360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 175363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175375 */     // (intrinsic_wo_chain:{ *:[v2f64] } 755:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, 1:{ *:[i32] })
     /* 175375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f64),
     /* 175378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175380 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175382 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 175387 */     GIR_RootConstrainSelectedInstOperands,
     /* 175388 */     // GIR_Coverage, 3806,
     /* 175388 */     GIR_EraseRootFromParent_Done,
     /* 175389 */   // Label 3419: @175389
     /* 175389 */   GIM_Try, /*On fail goto*//*Label 3420*/ GIMT_Encode4(175431), // Rule ID 3871 //
     /* 175394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_udiv),
     /* 175399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 175402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 175405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 175408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 175412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 175416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 175420 */     // (intrinsic_wo_chain:{ *:[i32] } 2075:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 175420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVWr),
     /* 175423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175427 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175429 */     GIR_RootConstrainSelectedInstOperands,
     /* 175430 */     // GIR_Coverage, 3871,
     /* 175430 */     GIR_EraseRootFromParent_Done,
     /* 175431 */   // Label 3420: @175431
     /* 175431 */   GIM_Try, /*On fail goto*//*Label 3421*/ GIMT_Encode4(175473), // Rule ID 3872 //
     /* 175436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_udiv),
     /* 175441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 175444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 175447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 175450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 175454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 175458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 175462 */     // (intrinsic_wo_chain:{ *:[i64] } 2075:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 175462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVXr),
     /* 175465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175469 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175471 */     GIR_RootConstrainSelectedInstOperands,
     /* 175472 */     // GIR_Coverage, 3872,
     /* 175472 */     GIR_EraseRootFromParent_Done,
     /* 175473 */   // Label 3421: @175473
     /* 175473 */   GIM_Try, /*On fail goto*//*Label 3422*/ GIMT_Encode4(175515), // Rule ID 3873 //
     /* 175478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sdiv),
     /* 175483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 175486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 175489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 175492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 175496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 175500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 175504 */     // (intrinsic_wo_chain:{ *:[i32] } 779:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 175504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVWr),
     /* 175507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175511 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175513 */     GIR_RootConstrainSelectedInstOperands,
     /* 175514 */     // GIR_Coverage, 3873,
     /* 175514 */     GIR_EraseRootFromParent_Done,
     /* 175515 */   // Label 3422: @175515
     /* 175515 */   GIM_Try, /*On fail goto*//*Label 3423*/ GIMT_Encode4(175557), // Rule ID 3874 //
     /* 175520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sdiv),
     /* 175525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 175528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 175531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 175534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 175538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 175542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 175546 */     // (intrinsic_wo_chain:{ *:[i64] } 779:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 175546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVXr),
     /* 175549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175553 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175555 */     GIR_RootConstrainSelectedInstOperands,
     /* 175556 */     // GIR_Coverage, 3874,
     /* 175556 */     GIR_EraseRootFromParent_Done,
     /* 175557 */   // Label 3423: @175557
     /* 175557 */   GIM_Try, /*On fail goto*//*Label 3424*/ GIMT_Encode4(175599), // Rule ID 5144 //
     /* 175562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 175567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 175570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 175573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 175576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175588 */     // (intrinsic_wo_chain:{ *:[v1f64] } 576:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FABD64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 175588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 175591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175595 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175597 */     GIR_RootConstrainSelectedInstOperands,
     /* 175598 */     // GIR_Coverage, 5144,
     /* 175598 */     GIR_EraseRootFromParent_Done,
     /* 175599 */   // Label 3424: @175599
     /* 175599 */   GIM_Try, /*On fail goto*//*Label 3425*/ GIMT_Encode4(175644), // Rule ID 5148 //
     /* 175604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 175612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 175615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 175618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 175621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175633 */     // (intrinsic_wo_chain:{ *:[v1i64] } 578:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FACGT64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 175633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT64),
     /* 175636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175640 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175642 */     GIR_RootConstrainSelectedInstOperands,
     /* 175643 */     // GIR_Coverage, 5148,
     /* 175643 */     GIR_EraseRootFromParent_Done,
     /* 175644 */   // Label 3425: @175644
     /* 175644 */   GIM_Try, /*On fail goto*//*Label 3426*/ GIMT_Encode4(175689), // Rule ID 5152 //
     /* 175649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 175657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 175660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 175663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 175666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175678 */     // (intrinsic_wo_chain:{ *:[v1f64] } 610:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMULX64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 175678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 175681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175685 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175687 */     GIR_RootConstrainSelectedInstOperands,
     /* 175688 */     // GIR_Coverage, 5152,
     /* 175688 */     GIR_EraseRootFromParent_Done,
     /* 175689 */   // Label 3426: @175689
     /* 175689 */   GIM_Try, /*On fail goto*//*Label 3427*/ GIMT_Encode4(175734), // Rule ID 5153 //
     /* 175694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 175702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 175705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 175708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 175711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175723 */     // (intrinsic_wo_chain:{ *:[v1f64] } 633:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FRECPS64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 175723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS64),
     /* 175726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175732 */     GIR_RootConstrainSelectedInstOperands,
     /* 175733 */     // GIR_Coverage, 5153,
     /* 175733 */     GIR_EraseRootFromParent_Done,
     /* 175734 */   // Label 3427: @175734
     /* 175734 */   GIM_Try, /*On fail goto*//*Label 3428*/ GIMT_Encode4(175779), // Rule ID 5154 //
     /* 175739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 175747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 175750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 175753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 175756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175768 */     // (intrinsic_wo_chain:{ *:[v1f64] } 640:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FRSQRTS64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 175768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS64),
     /* 175771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175775 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175777 */     GIR_RootConstrainSelectedInstOperands,
     /* 175778 */     // GIR_Coverage, 5154,
     /* 175778 */     GIR_EraseRootFromParent_Done,
     /* 175779 */   // Label 3428: @175779
     /* 175779 */   GIM_Try, /*On fail goto*//*Label 3429*/ GIMT_Encode4(175824), // Rule ID 5155 //
     /* 175784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 175792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 175795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 175798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 175801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175813 */     // (intrinsic_wo_chain:{ *:[i64] } 691:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 175813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i64),
     /* 175816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175818 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175820 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175822 */     GIR_RootConstrainSelectedInstOperands,
     /* 175823 */     // GIR_Coverage, 5155,
     /* 175823 */     GIR_EraseRootFromParent_Done,
     /* 175824 */   // Label 3429: @175824
     /* 175824 */   GIM_Try, /*On fail goto*//*Label 3430*/ GIMT_Encode4(175869), // Rule ID 5156 //
     /* 175829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 175837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 175840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 175843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 175846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 175850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 175854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 175858 */     // (intrinsic_wo_chain:{ *:[i32] } 691:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 175858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i32),
     /* 175861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175865 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175867 */     GIR_RootConstrainSelectedInstOperands,
     /* 175868 */     // GIR_Coverage, 5156,
     /* 175868 */     GIR_EraseRootFromParent_Done,
     /* 175869 */   // Label 3430: @175869
     /* 175869 */   GIM_Try, /*On fail goto*//*Label 3431*/ GIMT_Encode4(175914), // Rule ID 5157 //
     /* 175874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 175882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 175885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 175888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 175891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175903 */     // (intrinsic_wo_chain:{ *:[i64] } 694:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 175903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i64),
     /* 175906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175910 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175912 */     GIR_RootConstrainSelectedInstOperands,
     /* 175913 */     // GIR_Coverage, 5157,
     /* 175913 */     GIR_EraseRootFromParent_Done,
     /* 175914 */   // Label 3431: @175914
     /* 175914 */   GIM_Try, /*On fail goto*//*Label 3432*/ GIMT_Encode4(175959), // Rule ID 5158 //
     /* 175919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 175927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 175930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 175933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 175936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 175940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 175944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 175948 */     // (intrinsic_wo_chain:{ *:[i32] } 694:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 175948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i32),
     /* 175951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175955 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175957 */     GIR_RootConstrainSelectedInstOperands,
     /* 175958 */     // GIR_Coverage, 5158,
     /* 175958 */     GIR_EraseRootFromParent_Done,
     /* 175959 */   // Label 3432: @175959
     /* 175959 */   GIM_Try, /*On fail goto*//*Label 3433*/ GIMT_Encode4(176004), // Rule ID 5159 //
     /* 175964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 175972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 175975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 175978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 175981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175993 */     // (intrinsic_wo_chain:{ *:[i64] } 698:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQSUBv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 175993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i64),
     /* 175996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176000 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176002 */     GIR_RootConstrainSelectedInstOperands,
     /* 176003 */     // GIR_Coverage, 5159,
     /* 176003 */     GIR_EraseRootFromParent_Done,
     /* 176004 */   // Label 3433: @176004
     /* 176004 */   GIM_Try, /*On fail goto*//*Label 3434*/ GIMT_Encode4(176049), // Rule ID 5160 //
     /* 176009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 176017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 176020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 176023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 176026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176038 */     // (intrinsic_wo_chain:{ *:[i32] } 698:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQSUBv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 176038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i32),
     /* 176041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176045 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176047 */     GIR_RootConstrainSelectedInstOperands,
     /* 176048 */     // GIR_Coverage, 5160,
     /* 176048 */     GIR_EraseRootFromParent_Done,
     /* 176049 */   // Label 3434: @176049
     /* 176049 */   GIM_Try, /*On fail goto*//*Label 3435*/ GIMT_Encode4(176094), // Rule ID 5161 //
     /* 176054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 176062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 176065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 176068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 176071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176083 */     // (intrinsic_wo_chain:{ *:[i64] } 739:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 176083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i64),
     /* 176086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176090 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176092 */     GIR_RootConstrainSelectedInstOperands,
     /* 176093 */     // GIR_Coverage, 5161,
     /* 176093 */     GIR_EraseRootFromParent_Done,
     /* 176094 */   // Label 3435: @176094
     /* 176094 */   GIM_Try, /*On fail goto*//*Label 3436*/ GIMT_Encode4(176139), // Rule ID 5162 //
     /* 176099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 176107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 176110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 176113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 176116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176128 */     // (intrinsic_wo_chain:{ *:[i32] } 739:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 176128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i32),
     /* 176131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176135 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176137 */     GIR_RootConstrainSelectedInstOperands,
     /* 176138 */     // GIR_Coverage, 5162,
     /* 176138 */     GIR_EraseRootFromParent_Done,
     /* 176139 */   // Label 3436: @176139
     /* 176139 */   GIM_Try, /*On fail goto*//*Label 3437*/ GIMT_Encode4(176184), // Rule ID 5163 //
     /* 176144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 176152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 176155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 176158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 176161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176173 */     // (intrinsic_wo_chain:{ *:[i64] } 740:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 176173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i64),
     /* 176176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176180 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176182 */     GIR_RootConstrainSelectedInstOperands,
     /* 176183 */     // GIR_Coverage, 5163,
     /* 176183 */     GIR_EraseRootFromParent_Done,
     /* 176184 */   // Label 3437: @176184
     /* 176184 */   GIM_Try, /*On fail goto*//*Label 3438*/ GIMT_Encode4(176229), // Rule ID 5164 //
     /* 176189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 176197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 176200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 176203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 176206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176218 */     // (intrinsic_wo_chain:{ *:[i32] } 740:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQRSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 176218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i32),
     /* 176221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176223 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176225 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176227 */     GIR_RootConstrainSelectedInstOperands,
     /* 176228 */     // GIR_Coverage, 5164,
     /* 176228 */     GIR_EraseRootFromParent_Done,
     /* 176229 */   // Label 3438: @176229
     /* 176229 */   GIM_Try, /*On fail goto*//*Label 3439*/ GIMT_Encode4(176274), // Rule ID 5165 //
     /* 176234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 176242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 176245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 176248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 176251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176263 */     // (intrinsic_wo_chain:{ *:[i64] } 742:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 176263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i64),
     /* 176266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176270 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176272 */     GIR_RootConstrainSelectedInstOperands,
     /* 176273 */     // GIR_Coverage, 5165,
     /* 176273 */     GIR_EraseRootFromParent_Done,
     /* 176274 */   // Label 3439: @176274
     /* 176274 */   GIM_Try, /*On fail goto*//*Label 3440*/ GIMT_Encode4(176319), // Rule ID 5166 //
     /* 176279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 176287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 176290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 176293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 176296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176308 */     // (intrinsic_wo_chain:{ *:[i32] } 742:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 176308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i32),
     /* 176311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176317 */     GIR_RootConstrainSelectedInstOperands,
     /* 176318 */     // GIR_Coverage, 5166,
     /* 176318 */     GIR_EraseRootFromParent_Done,
     /* 176319 */   // Label 3440: @176319
     /* 176319 */   GIM_Try, /*On fail goto*//*Label 3441*/ GIMT_Encode4(176364), // Rule ID 5167 //
     /* 176324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 176332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 176335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 176338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 176341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176353 */     // (intrinsic_wo_chain:{ *:[i64] } 744:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQSUBv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 176353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i64),
     /* 176356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176362 */     GIR_RootConstrainSelectedInstOperands,
     /* 176363 */     // GIR_Coverage, 5167,
     /* 176363 */     GIR_EraseRootFromParent_Done,
     /* 176364 */   // Label 3441: @176364
     /* 176364 */   GIM_Try, /*On fail goto*//*Label 3442*/ GIMT_Encode4(176409), // Rule ID 5168 //
     /* 176369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 176377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 176380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 176383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 176386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176398 */     // (intrinsic_wo_chain:{ *:[i32] } 744:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQSUBv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 176398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i32),
     /* 176401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176405 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176407 */     GIR_RootConstrainSelectedInstOperands,
     /* 176408 */     // GIR_Coverage, 5168,
     /* 176408 */     GIR_EraseRootFromParent_Done,
     /* 176409 */   // Label 3442: @176409
     /* 176409 */   GIM_Try, /*On fail goto*//*Label 3443*/ GIMT_Encode4(176454), // Rule ID 5186 //
     /* 176414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 176422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 176425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 176428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 176431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176443 */     // (intrinsic_wo_chain:{ *:[v1i64] } 754:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)  =>  (USQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)
     /* 176443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i64),
     /* 176446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176448 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 176450 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 176452 */     GIR_RootConstrainSelectedInstOperands,
     /* 176453 */     // GIR_Coverage, 5186,
     /* 176453 */     GIR_EraseRootFromParent_Done,
     /* 176454 */   // Label 3443: @176454
     /* 176454 */   GIM_Try, /*On fail goto*//*Label 3444*/ GIMT_Encode4(176496), // Rule ID 5514 //
     /* 176459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbl1),
     /* 176464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 176467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 176470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 176473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176485 */     // (intrinsic_wo_chain:{ *:[v8i8] } 716:{ *:[iPTR] }, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)  =>  (TBLv8i8One:{ *:[v8i8] } VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)
     /* 176485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLv8i8One),
     /* 176488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 176490 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176492 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ri
     /* 176494 */     GIR_RootConstrainSelectedInstOperands,
     /* 176495 */     // GIR_Coverage, 5514,
     /* 176495 */     GIR_EraseRootFromParent_Done,
     /* 176496 */   // Label 3444: @176496
     /* 176496 */   GIM_Try, /*On fail goto*//*Label 3445*/ GIMT_Encode4(176538), // Rule ID 5515 //
     /* 176501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbl1),
     /* 176506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 176509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 176512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 176515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176527 */     // (intrinsic_wo_chain:{ *:[v16i8] } 716:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)  =>  (TBLv16i8One:{ *:[v16i8] } V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)
     /* 176527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLv16i8One),
     /* 176530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 176532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ri
     /* 176534 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 176536 */     GIR_RootConstrainSelectedInstOperands,
     /* 176537 */     // GIR_Coverage, 5515,
     /* 176537 */     GIR_EraseRootFromParent_Done,
     /* 176538 */   // Label 3445: @176538
     /* 176538 */   GIM_Try, /*On fail goto*//*Label 3446*/ GIMT_Encode4(176635), // Rule ID 6192 //
     /* 176543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 176548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 176551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 176554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 176557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 176565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 176569 */     // (intrinsic_wo_chain:{ *:[i32] } 577:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FACGE16:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm), hsub:{ *:[i32] })
     /* 176569 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 176572 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FACGE16),
     /* 176576 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176581 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 176585 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 176589 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 176591 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 176594 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 176598 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176603 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 176605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 176608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176610 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 176613 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 176616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 176619 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176624 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176629 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 176634 */     // GIR_Coverage, 6192,
     /* 176634 */     GIR_EraseRootFromParent_Done,
     /* 176635 */   // Label 3446: @176635
     /* 176635 */   GIM_Try, /*On fail goto*//*Label 3447*/ GIMT_Encode4(176732), // Rule ID 6193 //
     /* 176640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 176645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 176648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 176651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 176654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 176662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 176666 */     // (intrinsic_wo_chain:{ *:[i32] } 578:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FACGT16:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm), hsub:{ *:[i32] })
     /* 176666 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 176669 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FACGT16),
     /* 176673 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176678 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 176682 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 176686 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 176688 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 176691 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 176695 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176700 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 176702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 176705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176707 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 176710 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 176713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 176716 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176721 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176726 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 176731 */     // GIR_Coverage, 6193,
     /* 176731 */     GIR_EraseRootFromParent_Done,
     /* 176732 */   // Label 3447: @176732
     /* 176732 */   GIM_Try, /*On fail goto*//*Label 3448*/ GIMT_Encode4(176774), // Rule ID 6846 //
     /* 176737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 176742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 176745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 176748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 176751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176763 */     // (intrinsic_wo_chain:{ *:[i64] } 703:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 176763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv1i64),
     /* 176766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176768 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176770 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176772 */     GIR_RootConstrainSelectedInstOperands,
     /* 176773 */     // GIR_Coverage, 6846,
     /* 176773 */     GIR_EraseRootFromParent_Done,
     /* 176774 */   // Label 3448: @176774
     /* 176774 */   GIM_Try, /*On fail goto*//*Label 3449*/ GIMT_Encode4(176816), // Rule ID 6847 //
     /* 176779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 176784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 176787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 176790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 176793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176805 */     // (intrinsic_wo_chain:{ *:[i64] } 751:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (USHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 176805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv1i64),
     /* 176808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176812 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176814 */     GIR_RootConstrainSelectedInstOperands,
     /* 176815 */     // GIR_Coverage, 6847,
     /* 176815 */     GIR_EraseRootFromParent_Done,
     /* 176816 */   // Label 3449: @176816
     /* 176816 */   GIM_Try, /*On fail goto*//*Label 3450*/ GIMT_Encode4(176858), // Rule ID 6848 //
     /* 176821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 176826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 176829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 176832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 176835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176847 */     // (intrinsic_wo_chain:{ *:[i64] } 702:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 176847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv1i64),
     /* 176850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176854 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176856 */     GIR_RootConstrainSelectedInstOperands,
     /* 176857 */     // GIR_Coverage, 6848,
     /* 176857 */     GIR_EraseRootFromParent_Done,
     /* 176858 */   // Label 3450: @176858
     /* 176858 */   GIM_Try, /*On fail goto*//*Label 3451*/ GIMT_Encode4(176900), // Rule ID 6849 //
     /* 176863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 176868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 176871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 176874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 176877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176889 */     // (intrinsic_wo_chain:{ *:[i64] } 748:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (URSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 176889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv1i64),
     /* 176892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176894 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176896 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176898 */     GIR_RootConstrainSelectedInstOperands,
     /* 176899 */     // GIR_Coverage, 6849,
     /* 176899 */     GIR_EraseRootFromParent_Done,
     /* 176900 */   // Label 3451: @176900
     /* 176900 */   GIM_Try, /*On fail goto*//*Label 3452*/ GIMT_Encode4(176948), // Rule ID 6889 //
     /* 176905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_blend),
     /* 176910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 176913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 176916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 176919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 176923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 176927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 176931 */     // (intrinsic_wo_chain:{ *:[i64] } 294:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, GPR64:{ *:[i64] }:$Rn)  =>  (BFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64:{ *:[i64] }:$Rn, 16:{ *:[i64] }, 15:{ *:[i64] })
     /* 176931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMXri),
     /* 176934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176936 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 176938 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 176940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 176943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 176946 */     GIR_RootConstrainSelectedInstOperands,
     /* 176947 */     // GIR_Coverage, 6889,
     /* 176947 */     GIR_EraseRootFromParent_Done,
     /* 176948 */   // Label 3452: @176948
     /* 176948 */   GIM_Try, /*On fail goto*//*Label 3453*/ GIMT_Encode4(176993), // Rule ID 9871 //
     /* 176953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 176956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 176961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 176964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 176967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 176970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 176974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 176978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 176982 */     // (intrinsic_wo_chain:{ *:[i64] } 1932:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQINCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 176982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_B),
     /* 176985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 176987 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 176989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176991 */     GIR_RootConstrainSelectedInstOperands,
     /* 176992 */     // GIR_Coverage, 9871,
     /* 176992 */     GIR_EraseRootFromParent_Done,
     /* 176993 */   // Label 3453: @176993
     /* 176993 */   GIM_Try, /*On fail goto*//*Label 3454*/ GIMT_Encode4(177038), // Rule ID 9872 //
     /* 176998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 177001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 177006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 177015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 177027 */     // (intrinsic_wo_chain:{ *:[i64] } 1932:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQINCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 177027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_H),
     /* 177030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 177032 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 177034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177036 */     GIR_RootConstrainSelectedInstOperands,
     /* 177037 */     // GIR_Coverage, 9872,
     /* 177037 */     GIR_EraseRootFromParent_Done,
     /* 177038 */   // Label 3454: @177038
     /* 177038 */   GIM_Try, /*On fail goto*//*Label 3455*/ GIMT_Encode4(177083), // Rule ID 9873 //
     /* 177043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 177046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 177051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 177060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 177072 */     // (intrinsic_wo_chain:{ *:[i64] } 1932:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQINCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 177072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_S),
     /* 177075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 177077 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 177079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177081 */     GIR_RootConstrainSelectedInstOperands,
     /* 177082 */     // GIR_Coverage, 9873,
     /* 177082 */     GIR_EraseRootFromParent_Done,
     /* 177083 */   // Label 3455: @177083
     /* 177083 */   GIM_Try, /*On fail goto*//*Label 3456*/ GIMT_Encode4(177128), // Rule ID 9874 //
     /* 177088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 177091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 177096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 177105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 177117 */     // (intrinsic_wo_chain:{ *:[i64] } 1932:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQINCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 177117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_D),
     /* 177120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 177122 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 177124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177126 */     GIR_RootConstrainSelectedInstOperands,
     /* 177127 */     // GIR_Coverage, 9874,
     /* 177127 */     GIR_EraseRootFromParent_Done,
     /* 177128 */   // Label 3456: @177128
     /* 177128 */   GIM_Try, /*On fail goto*//*Label 3457*/ GIMT_Encode4(177173), // Rule ID 9883 //
     /* 177133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 177136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 177141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 177150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 177162 */     // (intrinsic_wo_chain:{ *:[i64] } 1687:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (SQDECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 177162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_B),
     /* 177165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 177167 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 177169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177171 */     GIR_RootConstrainSelectedInstOperands,
     /* 177172 */     // GIR_Coverage, 9883,
     /* 177172 */     GIR_EraseRootFromParent_Done,
     /* 177173 */   // Label 3457: @177173
     /* 177173 */   GIM_Try, /*On fail goto*//*Label 3458*/ GIMT_Encode4(177218), // Rule ID 9884 //
     /* 177178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 177181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 177186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 177195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 177207 */     // (intrinsic_wo_chain:{ *:[i64] } 1687:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (SQDECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 177207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_H),
     /* 177210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 177212 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 177214 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177216 */     GIR_RootConstrainSelectedInstOperands,
     /* 177217 */     // GIR_Coverage, 9884,
     /* 177217 */     GIR_EraseRootFromParent_Done,
     /* 177218 */   // Label 3458: @177218
     /* 177218 */   GIM_Try, /*On fail goto*//*Label 3459*/ GIMT_Encode4(177263), // Rule ID 9885 //
     /* 177223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 177226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 177231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 177240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 177252 */     // (intrinsic_wo_chain:{ *:[i64] } 1687:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (SQDECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 177252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_S),
     /* 177255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 177257 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 177259 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177261 */     GIR_RootConstrainSelectedInstOperands,
     /* 177262 */     // GIR_Coverage, 9885,
     /* 177262 */     GIR_EraseRootFromParent_Done,
     /* 177263 */   // Label 3459: @177263
     /* 177263 */   GIM_Try, /*On fail goto*//*Label 3460*/ GIMT_Encode4(177308), // Rule ID 9886 //
     /* 177268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 177271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 177276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 177285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 177297 */     // (intrinsic_wo_chain:{ *:[i64] } 1687:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (SQDECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 177297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_D),
     /* 177300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 177302 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 177304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177306 */     GIR_RootConstrainSelectedInstOperands,
     /* 177307 */     // GIR_Coverage, 9886,
     /* 177307 */     GIR_EraseRootFromParent_Done,
     /* 177308 */   // Label 3460: @177308
     /* 177308 */   GIM_Try, /*On fail goto*//*Label 3461*/ GIMT_Encode4(177353), // Rule ID 9887 //
     /* 177313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 177316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 177321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 177324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 177327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 177330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 177334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 177338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 177342 */     // (intrinsic_wo_chain:{ *:[i32] } 1917:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQDECP_WP_B:{ *:[i32] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 177342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_B),
     /* 177345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 177347 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 177349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177351 */     GIR_RootConstrainSelectedInstOperands,
     /* 177352 */     // GIR_Coverage, 9887,
     /* 177352 */     GIR_EraseRootFromParent_Done,
     /* 177353 */   // Label 3461: @177353
     /* 177353 */   GIM_Try, /*On fail goto*//*Label 3462*/ GIMT_Encode4(177398), // Rule ID 9888 //
     /* 177358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 177361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 177366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 177369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 177372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 177375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 177379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 177383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 177387 */     // (intrinsic_wo_chain:{ *:[i32] } 1917:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQDECP_WP_H:{ *:[i32] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 177387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_H),
     /* 177390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 177392 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 177394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177396 */     GIR_RootConstrainSelectedInstOperands,
     /* 177397 */     // GIR_Coverage, 9888,
     /* 177397 */     GIR_EraseRootFromParent_Done,
     /* 177398 */   // Label 3462: @177398
     /* 177398 */   GIM_Try, /*On fail goto*//*Label 3463*/ GIMT_Encode4(177443), // Rule ID 9889 //
     /* 177403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 177406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 177411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 177414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 177417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 177420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 177424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 177428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 177432 */     // (intrinsic_wo_chain:{ *:[i32] } 1917:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQDECP_WP_S:{ *:[i32] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 177432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_S),
     /* 177435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 177437 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 177439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177441 */     GIR_RootConstrainSelectedInstOperands,
     /* 177442 */     // GIR_Coverage, 9889,
     /* 177442 */     GIR_EraseRootFromParent_Done,
     /* 177443 */   // Label 3463: @177443
     /* 177443 */   GIM_Try, /*On fail goto*//*Label 3464*/ GIMT_Encode4(177488), // Rule ID 9890 //
     /* 177448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 177451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 177456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 177459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 177462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 177465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 177469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 177473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 177477 */     // (intrinsic_wo_chain:{ *:[i32] } 1917:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQDECP_WP_D:{ *:[i32] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 177477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_D),
     /* 177480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 177482 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 177484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177486 */     GIR_RootConstrainSelectedInstOperands,
     /* 177487 */     // GIR_Coverage, 9890,
     /* 177487 */     GIR_EraseRootFromParent_Done,
     /* 177488 */   // Label 3464: @177488
     /* 177488 */   GIM_Try, /*On fail goto*//*Label 3465*/ GIMT_Encode4(177533), // Rule ID 9891 //
     /* 177493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 177496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 177501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 177510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 177522 */     // (intrinsic_wo_chain:{ *:[i64] } 1918:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQDECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 177522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_B),
     /* 177525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 177527 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 177529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177531 */     GIR_RootConstrainSelectedInstOperands,
     /* 177532 */     // GIR_Coverage, 9891,
     /* 177532 */     GIR_EraseRootFromParent_Done,
     /* 177533 */   // Label 3465: @177533
     /* 177533 */   GIM_Try, /*On fail goto*//*Label 3466*/ GIMT_Encode4(177578), // Rule ID 9892 //
     /* 177538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 177541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 177546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 177555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 177567 */     // (intrinsic_wo_chain:{ *:[i64] } 1918:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQDECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 177567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_H),
     /* 177570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 177572 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 177574 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177576 */     GIR_RootConstrainSelectedInstOperands,
     /* 177577 */     // GIR_Coverage, 9892,
     /* 177577 */     GIR_EraseRootFromParent_Done,
     /* 177578 */   // Label 3466: @177578
     /* 177578 */   GIM_Try, /*On fail goto*//*Label 3467*/ GIMT_Encode4(177623), // Rule ID 9893 //
     /* 177583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 177586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 177591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 177600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 177612 */     // (intrinsic_wo_chain:{ *:[i64] } 1918:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQDECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 177612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_S),
     /* 177615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 177617 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 177619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177621 */     GIR_RootConstrainSelectedInstOperands,
     /* 177622 */     // GIR_Coverage, 9893,
     /* 177622 */     GIR_EraseRootFromParent_Done,
     /* 177623 */   // Label 3467: @177623
     /* 177623 */   GIM_Try, /*On fail goto*//*Label 3468*/ GIMT_Encode4(177668), // Rule ID 9894 //
     /* 177628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 177631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 177636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 177645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 177657 */     // (intrinsic_wo_chain:{ *:[i64] } 1918:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQDECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 177657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_D),
     /* 177660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 177662 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 177664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177666 */     GIR_RootConstrainSelectedInstOperands,
     /* 177667 */     // GIR_Coverage, 9894,
     /* 177667 */     GIR_EraseRootFromParent_Done,
     /* 177668 */   // Label 3468: @177668
     /* 177668 */   GIM_Try, /*On fail goto*//*Label 3469*/ GIMT_Encode4(177714), // Rule ID 138 //
     /* 177673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 177676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_gmi),
     /* 177681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177691 */     // MIs[0] Rn
     /* 177691 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 177695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 177699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177703 */     // (intrinsic_wo_chain:{ *:[i64] } 555:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (GMI:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 177703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::GMI),
     /* 177706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177710 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177712 */     GIR_RootConstrainSelectedInstOperands,
     /* 177713 */     // GIR_Coverage, 138,
     /* 177713 */     GIR_EraseRootFromParent_Done,
     /* 177714 */   // Label 3469: @177714
     /* 177714 */   GIM_Try, /*On fail goto*//*Label 3470*/ GIMT_Encode4(177761), // Rule ID 139 //
     /* 177719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 177722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_subp),
     /* 177727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 177734 */     // MIs[0] Rn
     /* 177734 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 177738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 177742 */     // MIs[0] Rm
     /* 177742 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 177746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 177750 */     // (intrinsic_wo_chain:{ *:[i64] } 1148:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)  =>  (SUBP:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)
     /* 177750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBP),
     /* 177753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177757 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177759 */     GIR_RootConstrainSelectedInstOperands,
     /* 177760 */     // GIR_Coverage, 139,
     /* 177760 */     GIR_EraseRootFromParent_Done,
     /* 177761 */   // Label 3470: @177761
     /* 177761 */   GIM_Try, /*On fail goto*//*Label 3471*/ GIMT_Encode4(177798), // Rule ID 2390 //
     /* 177766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 177769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b16),
     /* 177774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 177777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 177780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 177783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 177787 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2057:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 177787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_H),
     /* 177790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 177792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 177794 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 177796 */     GIR_RootConstrainSelectedInstOperands,
     /* 177797 */     // GIR_Coverage, 2390,
     /* 177797 */     GIR_EraseRootFromParent_Done,
     /* 177798 */   // Label 3471: @177798
     /* 177798 */   GIM_Try, /*On fail goto*//*Label 3472*/ GIMT_Encode4(177835), // Rule ID 2391 //
     /* 177803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 177806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b32),
     /* 177811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 177814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 177817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 177820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 177824 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2058:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 177824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_S),
     /* 177827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 177829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 177831 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 177833 */     GIR_RootConstrainSelectedInstOperands,
     /* 177834 */     // GIR_Coverage, 2391,
     /* 177834 */     GIR_EraseRootFromParent_Done,
     /* 177835 */   // Label 3472: @177835
     /* 177835 */   GIM_Try, /*On fail goto*//*Label 3473*/ GIMT_Encode4(177872), // Rule ID 2392 //
     /* 177840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 177843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b64),
     /* 177848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 177851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 177854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 177857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 177861 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2059:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 177861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_D),
     /* 177864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 177866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 177868 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 177870 */     GIR_RootConstrainSelectedInstOperands,
     /* 177871 */     // GIR_Coverage, 2392,
     /* 177871 */     GIR_EraseRootFromParent_Done,
     /* 177872 */   // Label 3473: @177872
     /* 177872 */   GIM_Try, /*On fail goto*//*Label 3474*/ GIMT_Encode4(177909), // Rule ID 2394 //
     /* 177877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 177880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b16),
     /* 177885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 177888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 177891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 177894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 177898 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2062:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 177898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_H),
     /* 177901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 177903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 177905 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 177907 */     GIR_RootConstrainSelectedInstOperands,
     /* 177908 */     // GIR_Coverage, 2394,
     /* 177908 */     GIR_EraseRootFromParent_Done,
     /* 177909 */   // Label 3474: @177909
     /* 177909 */   GIM_Try, /*On fail goto*//*Label 3475*/ GIMT_Encode4(177946), // Rule ID 2395 //
     /* 177914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 177917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b32),
     /* 177922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 177925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 177928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 177931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 177935 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2063:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 177935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_S),
     /* 177938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 177940 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 177942 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 177944 */     GIR_RootConstrainSelectedInstOperands,
     /* 177945 */     // GIR_Coverage, 2395,
     /* 177945 */     GIR_EraseRootFromParent_Done,
     /* 177946 */   // Label 3475: @177946
     /* 177946 */   GIM_Try, /*On fail goto*//*Label 3476*/ GIMT_Encode4(177983), // Rule ID 2396 //
     /* 177951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 177954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b64),
     /* 177959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 177962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 177965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 177968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 177972 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2064:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 177972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_D),
     /* 177975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 177977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 177979 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 177981 */     GIR_RootConstrainSelectedInstOperands,
     /* 177982 */     // GIR_Coverage, 2396,
     /* 177982 */     GIR_EraseRootFromParent_Done,
     /* 177983 */   // Label 3476: @177983
     /* 177983 */   GIM_Try, /*On fail goto*//*Label 3477*/ GIMT_Encode4(178020), // Rule ID 2398 //
     /* 177988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 177991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b16),
     /* 177996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 177999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 178002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 178005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 178009 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1983:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 178009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
     /* 178012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 178014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 178016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 178018 */     GIR_RootConstrainSelectedInstOperands,
     /* 178019 */     // GIR_Coverage, 2398,
     /* 178019 */     GIR_EraseRootFromParent_Done,
     /* 178020 */   // Label 3477: @178020
     /* 178020 */   GIM_Try, /*On fail goto*//*Label 3478*/ GIMT_Encode4(178057), // Rule ID 2399 //
     /* 178025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b32),
     /* 178033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 178036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 178039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 178042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 178046 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1984:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 178046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
     /* 178049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 178051 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 178053 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 178055 */     GIR_RootConstrainSelectedInstOperands,
     /* 178056 */     // GIR_Coverage, 2399,
     /* 178056 */     GIR_EraseRootFromParent_Done,
     /* 178057 */   // Label 3478: @178057
     /* 178057 */   GIM_Try, /*On fail goto*//*Label 3479*/ GIMT_Encode4(178094), // Rule ID 2400 //
     /* 178062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b64),
     /* 178070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 178073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 178076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 178079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 178083 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1985:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 178083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
     /* 178086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 178088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 178090 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 178092 */     GIR_RootConstrainSelectedInstOperands,
     /* 178093 */     // GIR_Coverage, 2400,
     /* 178093 */     GIR_EraseRootFromParent_Done,
     /* 178094 */   // Label 3479: @178094
     /* 178094 */   GIM_Try, /*On fail goto*//*Label 3480*/ GIMT_Encode4(178131), // Rule ID 2402 //
     /* 178099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b16),
     /* 178107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 178110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 178113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 178116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 178120 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1988:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 178120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_H),
     /* 178123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 178125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 178127 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 178129 */     GIR_RootConstrainSelectedInstOperands,
     /* 178130 */     // GIR_Coverage, 2402,
     /* 178130 */     GIR_EraseRootFromParent_Done,
     /* 178131 */   // Label 3480: @178131
     /* 178131 */   GIM_Try, /*On fail goto*//*Label 3481*/ GIMT_Encode4(178168), // Rule ID 2403 //
     /* 178136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b32),
     /* 178144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 178147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 178150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 178153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 178157 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1989:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 178157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_S),
     /* 178160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 178162 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 178164 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 178166 */     GIR_RootConstrainSelectedInstOperands,
     /* 178167 */     // GIR_Coverage, 2403,
     /* 178167 */     GIR_EraseRootFromParent_Done,
     /* 178168 */   // Label 3481: @178168
     /* 178168 */   GIM_Try, /*On fail goto*//*Label 3482*/ GIMT_Encode4(178205), // Rule ID 2404 //
     /* 178173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b64),
     /* 178181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 178184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 178187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 178190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 178194 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1990:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 178194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_D),
     /* 178197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 178199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 178201 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 178203 */     GIR_RootConstrainSelectedInstOperands,
     /* 178204 */     // GIR_Coverage, 2404,
     /* 178204 */     GIR_EraseRootFromParent_Done,
     /* 178205 */   // Label 3482: @178205
     /* 178205 */   GIM_Try, /*On fail goto*//*Label 3483*/ GIMT_Encode4(178242), // Rule ID 2406 //
     /* 178210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b16),
     /* 178218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 178221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 178224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 178227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 178231 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1827:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 178231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_H),
     /* 178234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 178236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 178238 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 178240 */     GIR_RootConstrainSelectedInstOperands,
     /* 178241 */     // GIR_Coverage, 2406,
     /* 178241 */     GIR_EraseRootFromParent_Done,
     /* 178242 */   // Label 3483: @178242
     /* 178242 */   GIM_Try, /*On fail goto*//*Label 3484*/ GIMT_Encode4(178279), // Rule ID 2407 //
     /* 178247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b32),
     /* 178255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 178258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 178261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 178264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 178268 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1828:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 178268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_S),
     /* 178271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 178273 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 178275 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 178277 */     GIR_RootConstrainSelectedInstOperands,
     /* 178278 */     // GIR_Coverage, 2407,
     /* 178278 */     GIR_EraseRootFromParent_Done,
     /* 178279 */   // Label 3484: @178279
     /* 178279 */   GIM_Try, /*On fail goto*//*Label 3485*/ GIMT_Encode4(178316), // Rule ID 2408 //
     /* 178284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b64),
     /* 178292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 178295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 178298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 178301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 178305 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1829:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 178305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_D),
     /* 178308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 178310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 178312 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 178314 */     GIR_RootConstrainSelectedInstOperands,
     /* 178315 */     // GIR_Coverage, 2408,
     /* 178315 */     GIR_EraseRootFromParent_Done,
     /* 178316 */   // Label 3485: @178316
     /* 178316 */   GIM_Try, /*On fail goto*//*Label 3486*/ GIMT_Encode4(178353), // Rule ID 2410 //
     /* 178321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b16),
     /* 178329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 178332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 178335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 178338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 178342 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1832:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 178342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_H),
     /* 178345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 178347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 178349 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 178351 */     GIR_RootConstrainSelectedInstOperands,
     /* 178352 */     // GIR_Coverage, 2410,
     /* 178352 */     GIR_EraseRootFromParent_Done,
     /* 178353 */   // Label 3486: @178353
     /* 178353 */   GIM_Try, /*On fail goto*//*Label 3487*/ GIMT_Encode4(178390), // Rule ID 2411 //
     /* 178358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b32),
     /* 178366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 178369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 178372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 178375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 178379 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1833:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 178379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_S),
     /* 178382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 178384 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 178386 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 178388 */     GIR_RootConstrainSelectedInstOperands,
     /* 178389 */     // GIR_Coverage, 2411,
     /* 178389 */     GIR_EraseRootFromParent_Done,
     /* 178390 */   // Label 3487: @178390
     /* 178390 */   GIM_Try, /*On fail goto*//*Label 3488*/ GIMT_Encode4(178427), // Rule ID 2412 //
     /* 178395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b64),
     /* 178403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 178406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 178409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 178412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 178416 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1834:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 178416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_D),
     /* 178419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 178421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 178423 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 178425 */     GIR_RootConstrainSelectedInstOperands,
     /* 178426 */     // GIR_Coverage, 2412,
     /* 178426 */     GIR_EraseRootFromParent_Done,
     /* 178427 */   // Label 3488: @178427
     /* 178427 */   GIM_Try, /*On fail goto*//*Label 3489*/ GIMT_Encode4(178464), // Rule ID 2413 //
     /* 178432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 178435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histseg),
     /* 178440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 178443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 178446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 178449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 178453 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1452:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (HISTSEG_ZZZ:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)
     /* 178453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTSEG_ZZZ),
     /* 178456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 178458 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 178460 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 178462 */     GIR_RootConstrainSelectedInstOperands,
     /* 178463 */     // GIR_Coverage, 2413,
     /* 178463 */     GIR_EraseRootFromParent_Done,
     /* 178464 */   // Label 3489: @178464
     /* 178464 */   GIM_Try, /*On fail goto*//*Label 3490*/ GIMT_Encode4(178504), // Rule ID 2607 //
     /* 178469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pfirst),
     /* 178477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 178480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 178483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 178486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 178490 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1531:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (PFIRST_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 178490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PFIRST_B),
     /* 178493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 178495 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 178497 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 178499 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 178502 */     GIR_RootConstrainSelectedInstOperands,
     /* 178503 */     // GIR_Coverage, 2607,
     /* 178503 */     GIR_EraseRootFromParent_Done,
     /* 178504 */   // Label 3490: @178504
     /* 178504 */   GIM_Try, /*On fail goto*//*Label 3491*/ GIMT_Encode4(178544), // Rule ID 2608 //
     /* 178509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 178517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 178520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 178523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 178526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 178530 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1539:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (PNEXT_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 178530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_B),
     /* 178533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 178535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 178537 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 178539 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 178542 */     GIR_RootConstrainSelectedInstOperands,
     /* 178543 */     // GIR_Coverage, 2608,
     /* 178543 */     GIR_EraseRootFromParent_Done,
     /* 178544 */   // Label 3491: @178544
     /* 178544 */   GIM_Try, /*On fail goto*//*Label 3492*/ GIMT_Encode4(178584), // Rule ID 2609 //
     /* 178549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 178557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 178560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 178563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 178566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 178570 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1539:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (PNEXT_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 178570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_H),
     /* 178573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 178575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 178577 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 178579 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 178582 */     GIR_RootConstrainSelectedInstOperands,
     /* 178583 */     // GIR_Coverage, 2609,
     /* 178583 */     GIR_EraseRootFromParent_Done,
     /* 178584 */   // Label 3492: @178584
     /* 178584 */   GIM_Try, /*On fail goto*//*Label 3493*/ GIMT_Encode4(178624), // Rule ID 2610 //
     /* 178589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 178597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 178600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 178603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 178606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 178610 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1539:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (PNEXT_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 178610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_S),
     /* 178613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 178615 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 178617 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 178619 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 178622 */     GIR_RootConstrainSelectedInstOperands,
     /* 178623 */     // GIR_Coverage, 2610,
     /* 178623 */     GIR_EraseRootFromParent_Done,
     /* 178624 */   // Label 3493: @178624
     /* 178624 */   GIM_Try, /*On fail goto*//*Label 3494*/ GIMT_Encode4(178664), // Rule ID 2611 //
     /* 178629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 178637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 178640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 178643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 178646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 178650 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1539:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (PNEXT_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 178650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_D),
     /* 178653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 178655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 178657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 178659 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 178662 */     GIR_RootConstrainSelectedInstOperands,
     /* 178663 */     // GIR_Coverage, 2611,
     /* 178663 */     GIR_EraseRootFromParent_Done,
     /* 178664 */   // Label 3494: @178664
     /* 178664 */   GIM_Try, /*On fail goto*//*Label 3495*/ GIMT_Encode4(178701), // Rule ID 2628 //
     /* 178669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
     /* 178677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 178680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 178683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 178686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 178690 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1719:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SQINCP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 178690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_H),
     /* 178693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 178695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 178697 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 178699 */     GIR_RootConstrainSelectedInstOperands,
     /* 178700 */     // GIR_Coverage, 2628,
     /* 178700 */     GIR_EraseRootFromParent_Done,
     /* 178701 */   // Label 3495: @178701
     /* 178701 */   GIM_Try, /*On fail goto*//*Label 3496*/ GIMT_Encode4(178738), // Rule ID 2629 //
     /* 178706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
     /* 178714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 178717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 178720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 178723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 178727 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1719:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SQINCP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 178727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_S),
     /* 178730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 178732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 178734 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 178736 */     GIR_RootConstrainSelectedInstOperands,
     /* 178737 */     // GIR_Coverage, 2629,
     /* 178737 */     GIR_EraseRootFromParent_Done,
     /* 178738 */   // Label 3496: @178738
     /* 178738 */   GIM_Try, /*On fail goto*//*Label 3497*/ GIMT_Encode4(178775), // Rule ID 2630 //
     /* 178743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
     /* 178751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 178754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 178757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 178760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 178764 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1719:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SQINCP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 178764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_D),
     /* 178767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 178769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 178771 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 178773 */     GIR_RootConstrainSelectedInstOperands,
     /* 178774 */     // GIR_Coverage, 2630,
     /* 178774 */     GIR_EraseRootFromParent_Done,
     /* 178775 */   // Label 3497: @178775
     /* 178775 */   GIM_Try, /*On fail goto*//*Label 3498*/ GIMT_Encode4(178812), // Rule ID 2631 //
     /* 178780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 178788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 178794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 178797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 178801 */     // (intrinsic_wo_chain:{ *:[i64] } 1241:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (CNTP_XPP_B:{ *:[i64] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 178801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_B),
     /* 178804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 178808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 178810 */     GIR_RootConstrainSelectedInstOperands,
     /* 178811 */     // GIR_Coverage, 2631,
     /* 178811 */     GIR_EraseRootFromParent_Done,
     /* 178812 */   // Label 3498: @178812
     /* 178812 */   GIM_Try, /*On fail goto*//*Label 3499*/ GIMT_Encode4(178849), // Rule ID 2632 //
     /* 178817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 178825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 178831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 178834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 178838 */     // (intrinsic_wo_chain:{ *:[i64] } 1241:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (CNTP_XPP_H:{ *:[i64] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 178838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_H),
     /* 178841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 178845 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 178847 */     GIR_RootConstrainSelectedInstOperands,
     /* 178848 */     // GIR_Coverage, 2632,
     /* 178848 */     GIR_EraseRootFromParent_Done,
     /* 178849 */   // Label 3499: @178849
     /* 178849 */   GIM_Try, /*On fail goto*//*Label 3500*/ GIMT_Encode4(178886), // Rule ID 2633 //
     /* 178854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 178862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 178868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 178871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 178875 */     // (intrinsic_wo_chain:{ *:[i64] } 1241:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (CNTP_XPP_S:{ *:[i64] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 178875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_S),
     /* 178878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 178882 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 178884 */     GIR_RootConstrainSelectedInstOperands,
     /* 178885 */     // GIR_Coverage, 2633,
     /* 178885 */     GIR_EraseRootFromParent_Done,
     /* 178886 */   // Label 3500: @178886
     /* 178886 */   GIM_Try, /*On fail goto*//*Label 3501*/ GIMT_Encode4(178923), // Rule ID 2634 //
     /* 178891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 178894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 178899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 178905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 178908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 178912 */     // (intrinsic_wo_chain:{ *:[i64] } 1241:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (CNTP_XPP_D:{ *:[i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 178912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_D),
     /* 178915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 178919 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 178921 */     GIR_RootConstrainSelectedInstOperands,
     /* 178922 */     // GIR_Coverage, 2634,
     /* 178922 */     GIR_EraseRootFromParent_Done,
     /* 178923 */   // Label 3501: @178923
     /* 178923 */   GIM_Try, /*On fail goto*//*Label 3502*/ GIMT_Encode4(178960), // Rule ID 2812 //
     /* 178928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 178931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
     /* 178936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 178939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 178942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 178945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 178949 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1449:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (FTSMUL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 178949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_H),
     /* 178952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 178954 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 178956 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 178958 */     GIR_RootConstrainSelectedInstOperands,
     /* 178959 */     // GIR_Coverage, 2812,
     /* 178959 */     GIR_EraseRootFromParent_Done,
     /* 178960 */   // Label 3502: @178960
     /* 178960 */   GIM_Try, /*On fail goto*//*Label 3503*/ GIMT_Encode4(178997), // Rule ID 2813 //
     /* 178965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 178968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
     /* 178973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 178976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 178979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 178982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 178986 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1449:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (FTSMUL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 178986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_S),
     /* 178989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 178991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 178993 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 178995 */     GIR_RootConstrainSelectedInstOperands,
     /* 178996 */     // GIR_Coverage, 2813,
     /* 178996 */     GIR_EraseRootFromParent_Done,
     /* 178997 */   // Label 3503: @178997
     /* 178997 */   GIM_Try, /*On fail goto*//*Label 3504*/ GIMT_Encode4(179034), // Rule ID 2814 //
     /* 179002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 179005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
     /* 179010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 179013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 179016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 179019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179023 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1449:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (FTSMUL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 179023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_D),
     /* 179026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179030 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179032 */     GIR_RootConstrainSelectedInstOperands,
     /* 179033 */     // GIR_Coverage, 2814,
     /* 179033 */     GIR_EraseRootFromParent_Done,
     /* 179034 */   // Label 3504: @179034
     /* 179034 */   GIM_Try, /*On fail goto*//*Label 3505*/ GIMT_Encode4(179071), // Rule ID 2985 //
     /* 179039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 179042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 179047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 179050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 179053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 179056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179060 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1701:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 179060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_B),
     /* 179063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179067 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179069 */     GIR_RootConstrainSelectedInstOperands,
     /* 179070 */     // GIR_Coverage, 2985,
     /* 179070 */     GIR_EraseRootFromParent_Done,
     /* 179071 */   // Label 3505: @179071
     /* 179071 */   GIM_Try, /*On fail goto*//*Label 3506*/ GIMT_Encode4(179108), // Rule ID 2986 //
     /* 179076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 179079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 179084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 179087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 179090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 179093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179097 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1701:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 179097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_H),
     /* 179100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179102 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179104 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179106 */     GIR_RootConstrainSelectedInstOperands,
     /* 179107 */     // GIR_Coverage, 2986,
     /* 179107 */     GIR_EraseRootFromParent_Done,
     /* 179108 */   // Label 3506: @179108
     /* 179108 */   GIM_Try, /*On fail goto*//*Label 3507*/ GIMT_Encode4(179145), // Rule ID 2987 //
     /* 179113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 179116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 179121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 179124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 179127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 179130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179134 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1701:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 179134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_S),
     /* 179137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179141 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179143 */     GIR_RootConstrainSelectedInstOperands,
     /* 179144 */     // GIR_Coverage, 2987,
     /* 179144 */     GIR_EraseRootFromParent_Done,
     /* 179145 */   // Label 3507: @179145
     /* 179145 */   GIM_Try, /*On fail goto*//*Label 3508*/ GIMT_Encode4(179182), // Rule ID 2988 //
     /* 179150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 179153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 179158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 179161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 179164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 179167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179171 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1701:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQDMULH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 179171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_D),
     /* 179174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179178 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179180 */     GIR_RootConstrainSelectedInstOperands,
     /* 179181 */     // GIR_Coverage, 2988,
     /* 179181 */     GIR_EraseRootFromParent_Done,
     /* 179182 */   // Label 3508: @179182
     /* 179182 */   GIM_Try, /*On fail goto*//*Label 3509*/ GIMT_Encode4(179219), // Rule ID 2989 //
     /* 179187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 179190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmul),
     /* 179195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 179198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 179201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 179204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179208 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1536:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMUL_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 179208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMUL_ZZZ_B),
     /* 179211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179215 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179217 */     GIR_RootConstrainSelectedInstOperands,
     /* 179218 */     // GIR_Coverage, 2989,
     /* 179218 */     GIR_EraseRootFromParent_Done,
     /* 179219 */   // Label 3509: @179219
     /* 179219 */   GIM_Try, /*On fail goto*//*Label 3510*/ GIMT_Encode4(179256), // Rule ID 3011 //
     /* 179224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 179227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
     /* 179232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 179235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 179238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 179241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179245 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1594:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 179245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_H),
     /* 179248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179252 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179254 */     GIR_RootConstrainSelectedInstOperands,
     /* 179255 */     // GIR_Coverage, 3011,
     /* 179255 */     GIR_EraseRootFromParent_Done,
     /* 179256 */   // Label 3510: @179256
     /* 179256 */   GIM_Try, /*On fail goto*//*Label 3511*/ GIMT_Encode4(179293), // Rule ID 3012 //
     /* 179261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 179264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
     /* 179269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 179272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 179275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 179278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179282 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1594:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 179282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_S),
     /* 179285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179289 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179291 */     GIR_RootConstrainSelectedInstOperands,
     /* 179292 */     // GIR_Coverage, 3012,
     /* 179292 */     GIR_EraseRootFromParent_Done,
     /* 179293 */   // Label 3511: @179293
     /* 179293 */   GIM_Try, /*On fail goto*//*Label 3512*/ GIMT_Encode4(179330), // Rule ID 3013 //
     /* 179298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 179301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
     /* 179306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 179309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 179312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 179315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179319 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1594:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 179319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_D),
     /* 179322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179326 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179328 */     GIR_RootConstrainSelectedInstOperands,
     /* 179329 */     // GIR_Coverage, 3013,
     /* 179329 */     GIR_EraseRootFromParent_Done,
     /* 179330 */   // Label 3512: @179330
     /* 179330 */   GIM_Try, /*On fail goto*//*Label 3513*/ GIMT_Encode4(179367), // Rule ID 3017 //
     /* 179335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 179338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
     /* 179343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 179346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 179349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 179352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179356 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1537:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (PMULLB_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 179356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_Q),
     /* 179359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179363 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179365 */     GIR_RootConstrainSelectedInstOperands,
     /* 179366 */     // GIR_Coverage, 3017,
     /* 179366 */     GIR_EraseRootFromParent_Done,
     /* 179367 */   // Label 3513: @179367
     /* 179367 */   GIM_Try, /*On fail goto*//*Label 3514*/ GIMT_Encode4(179404), // Rule ID 3018 //
     /* 179372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 179375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
     /* 179380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 179383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 179386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 179389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179393 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1537:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMULLB_ZZZ_H:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 179393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_H),
     /* 179396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179398 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179400 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179402 */     GIR_RootConstrainSelectedInstOperands,
     /* 179403 */     // GIR_Coverage, 3018,
     /* 179403 */     GIR_EraseRootFromParent_Done,
     /* 179404 */   // Label 3514: @179404
     /* 179404 */   GIM_Try, /*On fail goto*//*Label 3515*/ GIMT_Encode4(179441), // Rule ID 3019 //
     /* 179409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 179412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
     /* 179417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 179420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 179423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 179426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179430 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1537:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (PMULLB_ZZZ_D:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 179430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_D),
     /* 179433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179435 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179437 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179439 */     GIR_RootConstrainSelectedInstOperands,
     /* 179440 */     // GIR_Coverage, 3019,
     /* 179440 */     GIR_EraseRootFromParent_Done,
     /* 179441 */   // Label 3515: @179441
     /* 179441 */   GIM_Try, /*On fail goto*//*Label 3516*/ GIMT_Encode4(179478), // Rule ID 3020 //
     /* 179446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 179449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 179454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 179457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 179460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 179463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179467 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1179:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BEXT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 179467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_B),
     /* 179470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179476 */     GIR_RootConstrainSelectedInstOperands,
     /* 179477 */     // GIR_Coverage, 3020,
     /* 179477 */     GIR_EraseRootFromParent_Done,
     /* 179478 */   // Label 3516: @179478
     /* 179478 */   GIM_Try, /*On fail goto*//*Label 3517*/ GIMT_Encode4(179515), // Rule ID 3021 //
     /* 179483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 179486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 179491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 179494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 179497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 179500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179504 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1179:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BEXT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 179504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_H),
     /* 179507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179511 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179513 */     GIR_RootConstrainSelectedInstOperands,
     /* 179514 */     // GIR_Coverage, 3021,
     /* 179514 */     GIR_EraseRootFromParent_Done,
     /* 179515 */   // Label 3517: @179515
     /* 179515 */   GIM_Try, /*On fail goto*//*Label 3518*/ GIMT_Encode4(179552), // Rule ID 3022 //
     /* 179520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 179523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 179528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 179531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 179534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 179537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179541 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1179:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BEXT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 179541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_S),
     /* 179544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179548 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179550 */     GIR_RootConstrainSelectedInstOperands,
     /* 179551 */     // GIR_Coverage, 3022,
     /* 179551 */     GIR_EraseRootFromParent_Done,
     /* 179552 */   // Label 3518: @179552
     /* 179552 */   GIM_Try, /*On fail goto*//*Label 3519*/ GIMT_Encode4(179589), // Rule ID 3023 //
     /* 179557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 179560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 179565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 179568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 179571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 179574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179578 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1179:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BEXT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 179578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_D),
     /* 179581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179585 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179587 */     GIR_RootConstrainSelectedInstOperands,
     /* 179588 */     // GIR_Coverage, 3023,
     /* 179588 */     GIR_EraseRootFromParent_Done,
     /* 179589 */   // Label 3519: @179589
     /* 179589 */   GIM_Try, /*On fail goto*//*Label 3520*/ GIMT_Encode4(179626), // Rule ID 3024 //
     /* 179594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 179597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
     /* 179602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 179605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 179608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 179611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179615 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1595:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 179615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_H),
     /* 179618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179620 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179622 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179624 */     GIR_RootConstrainSelectedInstOperands,
     /* 179625 */     // GIR_Coverage, 3024,
     /* 179625 */     GIR_EraseRootFromParent_Done,
     /* 179626 */   // Label 3520: @179626
     /* 179626 */   GIM_Try, /*On fail goto*//*Label 3521*/ GIMT_Encode4(179663), // Rule ID 3025 //
     /* 179631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 179634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
     /* 179639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 179642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 179645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 179648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179652 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1595:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 179652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_S),
     /* 179655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179659 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179661 */     GIR_RootConstrainSelectedInstOperands,
     /* 179662 */     // GIR_Coverage, 3025,
     /* 179662 */     GIR_EraseRootFromParent_Done,
     /* 179663 */   // Label 3521: @179663
     /* 179663 */   GIM_Try, /*On fail goto*//*Label 3522*/ GIMT_Encode4(179700), // Rule ID 3026 //
     /* 179668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 179671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
     /* 179676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 179679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 179682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 179685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179689 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1595:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 179689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_D),
     /* 179692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179696 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179698 */     GIR_RootConstrainSelectedInstOperands,
     /* 179699 */     // GIR_Coverage, 3026,
     /* 179699 */     GIR_EraseRootFromParent_Done,
     /* 179700 */   // Label 3522: @179700
     /* 179700 */   GIM_Try, /*On fail goto*//*Label 3523*/ GIMT_Encode4(179737), // Rule ID 3073 //
     /* 179705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 179708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
     /* 179713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 179716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 179719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 179722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179726 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1156:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADDHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 179726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_B),
     /* 179729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179733 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179735 */     GIR_RootConstrainSelectedInstOperands,
     /* 179736 */     // GIR_Coverage, 3073,
     /* 179736 */     GIR_EraseRootFromParent_Done,
     /* 179737 */   // Label 3523: @179737
     /* 179737 */   GIM_Try, /*On fail goto*//*Label 3524*/ GIMT_Encode4(179774), // Rule ID 3074 //
     /* 179742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 179745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
     /* 179750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 179753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 179756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 179759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179763 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1156:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADDHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 179763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_H),
     /* 179766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179768 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179770 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179772 */     GIR_RootConstrainSelectedInstOperands,
     /* 179773 */     // GIR_Coverage, 3074,
     /* 179773 */     GIR_EraseRootFromParent_Done,
     /* 179774 */   // Label 3524: @179774
     /* 179774 */   GIM_Try, /*On fail goto*//*Label 3525*/ GIMT_Encode4(179811), // Rule ID 3075 //
     /* 179779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 179782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
     /* 179787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 179790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 179793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 179796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179800 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1156:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADDHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 179800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_S),
     /* 179803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179807 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179809 */     GIR_RootConstrainSelectedInstOperands,
     /* 179810 */     // GIR_Coverage, 3075,
     /* 179810 */     GIR_EraseRootFromParent_Done,
     /* 179811 */   // Label 3525: @179811
     /* 179811 */   GIM_Try, /*On fail goto*//*Label 3526*/ GIMT_Encode4(179848), // Rule ID 3082 //
     /* 179816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 179819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
     /* 179824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 179827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 179830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 179833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179837 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1758:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQXTNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 179837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_B),
     /* 179840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179842 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179844 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179846 */     GIR_RootConstrainSelectedInstOperands,
     /* 179847 */     // GIR_Coverage, 3082,
     /* 179847 */     GIR_EraseRootFromParent_Done,
     /* 179848 */   // Label 3526: @179848
     /* 179848 */   GIM_Try, /*On fail goto*//*Label 3527*/ GIMT_Encode4(179885), // Rule ID 3083 //
     /* 179853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 179856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
     /* 179861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 179864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 179867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 179870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179874 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1758:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQXTNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 179874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_H),
     /* 179877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179881 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179883 */     GIR_RootConstrainSelectedInstOperands,
     /* 179884 */     // GIR_Coverage, 3083,
     /* 179884 */     GIR_EraseRootFromParent_Done,
     /* 179885 */   // Label 3527: @179885
     /* 179885 */   GIM_Try, /*On fail goto*//*Label 3528*/ GIMT_Encode4(179922), // Rule ID 3084 //
     /* 179890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 179893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
     /* 179898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 179901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 179904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 179907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 179911 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1758:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQXTNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 179911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_S),
     /* 179914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 179916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179918 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179920 */     GIR_RootConstrainSelectedInstOperands,
     /* 179921 */     // GIR_Coverage, 3084,
     /* 179921 */     GIR_EraseRootFromParent_Done,
     /* 179922 */   // Label 3528: @179922
     /* 179922 */   GIM_Try, /*On fail goto*//*Label 3529*/ GIMT_Encode4(179962), // Rule ID 3182 //
     /* 179927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 179930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 179935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 179938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 179941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 179944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 179948 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2038:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 179948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_B),
     /* 179951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 179953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179955 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179957 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 179960 */     GIR_RootConstrainSelectedInstOperands,
     /* 179961 */     // GIR_Coverage, 3182,
     /* 179961 */     GIR_EraseRootFromParent_Done,
     /* 179962 */   // Label 3529: @179962
     /* 179962 */   GIM_Try, /*On fail goto*//*Label 3530*/ GIMT_Encode4(180002), // Rule ID 3183 //
     /* 179967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 179970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 179975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 179978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 179981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 179984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 179988 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2038:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 179988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_H),
     /* 179991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 179993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 179995 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 179997 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 180000 */     GIR_RootConstrainSelectedInstOperands,
     /* 180001 */     // GIR_Coverage, 3183,
     /* 180001 */     GIR_EraseRootFromParent_Done,
     /* 180002 */   // Label 3530: @180002
     /* 180002 */   GIM_Try, /*On fail goto*//*Label 3531*/ GIMT_Encode4(180042), // Rule ID 3184 //
     /* 180007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 180015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 180018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180028 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2038:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 180028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_S),
     /* 180031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 180033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180035 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180037 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 180040 */     GIR_RootConstrainSelectedInstOperands,
     /* 180041 */     // GIR_Coverage, 3184,
     /* 180041 */     GIR_EraseRootFromParent_Done,
     /* 180042 */   // Label 3531: @180042
     /* 180042 */   GIM_Try, /*On fail goto*//*Label 3532*/ GIMT_Encode4(180082), // Rule ID 3185 //
     /* 180047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 180055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 180058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180068 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2038:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 180068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_D),
     /* 180071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 180073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180075 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180077 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 180080 */     GIR_RootConstrainSelectedInstOperands,
     /* 180081 */     // GIR_Coverage, 3185,
     /* 180081 */     GIR_EraseRootFromParent_Done,
     /* 180082 */   // Label 3532: @180082
     /* 180082 */   GIM_Try, /*On fail goto*//*Label 3533*/ GIMT_Encode4(180122), // Rule ID 3190 //
     /* 180087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 180095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 180098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180108 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2038:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 180108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_B),
     /* 180111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 180113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180115 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180117 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 180120 */     GIR_RootConstrainSelectedInstOperands,
     /* 180121 */     // GIR_Coverage, 3190,
     /* 180121 */     GIR_EraseRootFromParent_Done,
     /* 180122 */   // Label 3533: @180122
     /* 180122 */   GIM_Try, /*On fail goto*//*Label 3534*/ GIMT_Encode4(180162), // Rule ID 3191 //
     /* 180127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 180135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 180138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180148 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2038:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 180148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_H),
     /* 180151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 180153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180155 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180157 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 180160 */     GIR_RootConstrainSelectedInstOperands,
     /* 180161 */     // GIR_Coverage, 3191,
     /* 180161 */     GIR_EraseRootFromParent_Done,
     /* 180162 */   // Label 3534: @180162
     /* 180162 */   GIM_Try, /*On fail goto*//*Label 3535*/ GIMT_Encode4(180202), // Rule ID 3192 //
     /* 180167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 180175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 180178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180188 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2038:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 180188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_S),
     /* 180191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 180193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180195 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180197 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 180200 */     GIR_RootConstrainSelectedInstOperands,
     /* 180201 */     // GIR_Coverage, 3192,
     /* 180201 */     GIR_EraseRootFromParent_Done,
     /* 180202 */   // Label 3535: @180202
     /* 180202 */   GIM_Try, /*On fail goto*//*Label 3536*/ GIMT_Encode4(180242), // Rule ID 3193 //
     /* 180207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 180215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 180218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180228 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2038:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 180228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_D),
     /* 180231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 180233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180235 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180237 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 180240 */     GIR_RootConstrainSelectedInstOperands,
     /* 180241 */     // GIR_Coverage, 3193,
     /* 180241 */     GIR_EraseRootFromParent_Done,
     /* 180242 */   // Label 3536: @180242
     /* 180242 */   GIM_Try, /*On fail goto*//*Label 3537*/ GIMT_Encode4(180279), // Rule ID 3382 //
     /* 180247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 180250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 180255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 180258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 180261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 180264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 180268 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1247:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (COMPACT_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 180268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_S),
     /* 180271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 180273 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180275 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180277 */     GIR_RootConstrainSelectedInstOperands,
     /* 180278 */     // GIR_Coverage, 3382,
     /* 180278 */     GIR_EraseRootFromParent_Done,
     /* 180279 */   // Label 3537: @180279
     /* 180279 */   GIM_Try, /*On fail goto*//*Label 3538*/ GIMT_Encode4(180316), // Rule ID 3383 //
     /* 180284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 180287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 180292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 180295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 180298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 180301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 180305 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1247:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (COMPACT_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 180305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_S),
     /* 180308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 180310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180312 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180314 */     GIR_RootConstrainSelectedInstOperands,
     /* 180315 */     // GIR_Coverage, 3383,
     /* 180315 */     GIR_EraseRootFromParent_Done,
     /* 180316 */   // Label 3538: @180316
     /* 180316 */   GIM_Try, /*On fail goto*//*Label 3539*/ GIMT_Encode4(180353), // Rule ID 3384 //
     /* 180321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 180324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 180329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 180332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 180335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 180338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 180342 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1247:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (COMPACT_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 180342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_D),
     /* 180345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 180347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180349 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180351 */     GIR_RootConstrainSelectedInstOperands,
     /* 180352 */     // GIR_Coverage, 3384,
     /* 180352 */     GIR_EraseRootFromParent_Done,
     /* 180353 */   // Label 3539: @180353
     /* 180353 */   GIM_Try, /*On fail goto*//*Label 3540*/ GIMT_Encode4(180390), // Rule ID 3385 //
     /* 180358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 180361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 180366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 180369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 180372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 180375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 180379 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1247:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (COMPACT_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 180379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_D),
     /* 180382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 180384 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180386 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180388 */     GIR_RootConstrainSelectedInstOperands,
     /* 180389 */     // GIR_Coverage, 3385,
     /* 180389 */     GIR_EraseRootFromParent_Done,
     /* 180390 */   // Label 3540: @180390
     /* 180390 */   GIM_Try, /*On fail goto*//*Label 3541*/ GIMT_Encode4(180427), // Rule ID 3407 //
     /* 180395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 180398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
     /* 180403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 180406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 180409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 180412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 180416 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1450:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (FTSSEL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 180416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_H),
     /* 180419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 180421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180423 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180425 */     GIR_RootConstrainSelectedInstOperands,
     /* 180426 */     // GIR_Coverage, 3407,
     /* 180426 */     GIR_EraseRootFromParent_Done,
     /* 180427 */   // Label 3541: @180427
     /* 180427 */   GIM_Try, /*On fail goto*//*Label 3542*/ GIMT_Encode4(180464), // Rule ID 3408 //
     /* 180432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 180435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
     /* 180440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 180443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 180446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 180449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 180453 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1450:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (FTSSEL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 180453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_S),
     /* 180456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 180458 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180460 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180462 */     GIR_RootConstrainSelectedInstOperands,
     /* 180463 */     // GIR_Coverage, 3408,
     /* 180463 */     GIR_EraseRootFromParent_Done,
     /* 180464 */   // Label 3542: @180464
     /* 180464 */   GIM_Try, /*On fail goto*//*Label 3543*/ GIMT_Encode4(180501), // Rule ID 3409 //
     /* 180469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 180472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
     /* 180477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 180480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 180483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 180486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 180490 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1450:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (FTSSEL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 180490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_D),
     /* 180493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 180495 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180497 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180499 */     GIR_RootConstrainSelectedInstOperands,
     /* 180500 */     // GIR_Coverage, 3409,
     /* 180500 */     GIR_EraseRootFromParent_Done,
     /* 180501 */   // Label 3543: @180501
     /* 180501 */   GIM_Try, /*On fail goto*//*Label 3544*/ GIMT_Encode4(180538), // Rule ID 3431 //
     /* 180506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brka_z),
     /* 180514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 180517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 180520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 180523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180527 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1200:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (BRKA_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 180527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKA_PPzP),
     /* 180530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 180532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180534 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180536 */     GIR_RootConstrainSelectedInstOperands,
     /* 180537 */     // GIR_Coverage, 3431,
     /* 180537 */     GIR_EraseRootFromParent_Done,
     /* 180538 */   // Label 3544: @180538
     /* 180538 */   GIM_Try, /*On fail goto*//*Label 3545*/ GIMT_Encode4(180575), // Rule ID 3436 //
     /* 180543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2SM4),
     /* 180546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sm4ekey),
     /* 180551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 180554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 180557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 180560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 180564 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1630:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SM4EKEY_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 180564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4EKEY_ZZZ_S),
     /* 180567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 180569 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180571 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180573 */     GIR_RootConstrainSelectedInstOperands,
     /* 180574 */     // GIR_Coverage, 3436,
     /* 180574 */     GIR_EraseRootFromParent_Done,
     /* 180575 */   // Label 3545: @180575
     /* 180575 */   GIM_Try, /*On fail goto*//*Label 3546*/ GIMT_Encode4(180612), // Rule ID 3437 //
     /* 180580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 180583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aese),
     /* 180588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 180591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 180594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 180597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 180601 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1165:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (AESE_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 180601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESE_ZZZ_B),
     /* 180604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 180606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180608 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180610 */     GIR_RootConstrainSelectedInstOperands,
     /* 180611 */     // GIR_Coverage, 3437,
     /* 180611 */     GIR_EraseRootFromParent_Done,
     /* 180612 */   // Label 3546: @180612
     /* 180612 */   GIM_Try, /*On fail goto*//*Label 3547*/ GIMT_Encode4(180649), // Rule ID 3446 //
     /* 180617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 180620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 180625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 180628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 180631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 180634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 180638 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2060:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 180638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 180641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 180643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180645 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180647 */     GIR_RootConstrainSelectedInstOperands,
     /* 180648 */     // GIR_Coverage, 3446,
     /* 180648 */     GIR_EraseRootFromParent_Done,
     /* 180649 */   // Label 3547: @180649
     /* 180649 */   GIM_Try, /*On fail goto*//*Label 3548*/ GIMT_Encode4(180686), // Rule ID 3447 //
     /* 180654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 180657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 180662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 180665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 180668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 180671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 180675 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2060:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 180675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 180678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 180680 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180682 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180684 */     GIR_RootConstrainSelectedInstOperands,
     /* 180685 */     // GIR_Coverage, 3447,
     /* 180685 */     GIR_EraseRootFromParent_Done,
     /* 180686 */   // Label 3548: @180686
     /* 180686 */   GIM_Try, /*On fail goto*//*Label 3549*/ GIMT_Encode4(180723), // Rule ID 3448 //
     /* 180691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 180694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 180699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 180702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 180705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 180708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 180712 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2060:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 180712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 180715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 180717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180719 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180721 */     GIR_RootConstrainSelectedInstOperands,
     /* 180722 */     // GIR_Coverage, 3448,
     /* 180722 */     GIR_EraseRootFromParent_Done,
     /* 180723 */   // Label 3549: @180723
     /* 180723 */   GIM_Try, /*On fail goto*//*Label 3550*/ GIMT_Encode4(180760), // Rule ID 3449 //
     /* 180728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 180731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 180736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 180739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 180742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 180745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 180749 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2060:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 180749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 180752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 180754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180756 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180758 */     GIR_RootConstrainSelectedInstOperands,
     /* 180759 */     // GIR_Coverage, 3449,
     /* 180759 */     GIR_EraseRootFromParent_Done,
     /* 180760 */   // Label 3550: @180760
     /* 180760 */   GIM_Try, /*On fail goto*//*Label 3551*/ GIMT_Encode4(180797), // Rule ID 3450 //
     /* 180765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 180768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 180773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 180776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 180779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 180782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 180786 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2060:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 180786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 180789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 180791 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180793 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180795 */     GIR_RootConstrainSelectedInstOperands,
     /* 180796 */     // GIR_Coverage, 3450,
     /* 180796 */     GIR_EraseRootFromParent_Done,
     /* 180797 */   // Label 3551: @180797
     /* 180797 */   GIM_Try, /*On fail goto*//*Label 3552*/ GIMT_Encode4(180834), // Rule ID 3451 //
     /* 180802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 180805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 180810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 180813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 180816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 180819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 180823 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2060:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 180823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 180826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 180828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180830 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180832 */     GIR_RootConstrainSelectedInstOperands,
     /* 180833 */     // GIR_Coverage, 3451,
     /* 180833 */     GIR_EraseRootFromParent_Done,
     /* 180834 */   // Label 3552: @180834
     /* 180834 */   GIM_Try, /*On fail goto*//*Label 3553*/ GIMT_Encode4(180871), // Rule ID 3452 //
     /* 180839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 180842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 180847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 180850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 180853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 180856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 180860 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2060:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 180860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 180863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 180865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180867 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180869 */     GIR_RootConstrainSelectedInstOperands,
     /* 180870 */     // GIR_Coverage, 3452,
     /* 180870 */     GIR_EraseRootFromParent_Done,
     /* 180871 */   // Label 3553: @180871
     /* 180871 */   GIM_Try, /*On fail goto*//*Label 3554*/ GIMT_Encode4(180908), // Rule ID 3507 //
     /* 180876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 180879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
     /* 180884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 180887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 180890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 180893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180897 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1273:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FADDQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 180897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_H),
     /* 180900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 180902 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180904 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180906 */     GIR_RootConstrainSelectedInstOperands,
     /* 180907 */     // GIR_Coverage, 3507,
     /* 180907 */     GIR_EraseRootFromParent_Done,
     /* 180908 */   // Label 3554: @180908
     /* 180908 */   GIM_Try, /*On fail goto*//*Label 3555*/ GIMT_Encode4(180945), // Rule ID 3508 //
     /* 180913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 180916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
     /* 180921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 180924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 180927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 180930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180934 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1273:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FADDQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 180934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_S),
     /* 180937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 180939 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180941 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180943 */     GIR_RootConstrainSelectedInstOperands,
     /* 180944 */     // GIR_Coverage, 3508,
     /* 180944 */     GIR_EraseRootFromParent_Done,
     /* 180945 */   // Label 3555: @180945
     /* 180945 */   GIM_Try, /*On fail goto*//*Label 3556*/ GIMT_Encode4(180982), // Rule ID 3509 //
     /* 180950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 180953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
     /* 180958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 180961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 180964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 180967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180971 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1273:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FADDQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 180971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_D),
     /* 180974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 180976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 180978 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 180980 */     GIR_RootConstrainSelectedInstOperands,
     /* 180981 */     // GIR_Coverage, 3509,
     /* 180981 */     GIR_EraseRootFromParent_Done,
     /* 180982 */   // Label 3556: @180982
     /* 180982 */   GIM_Try, /*On fail goto*//*Label 3557*/ GIMT_Encode4(181019), // Rule ID 3539 //
     /* 180987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 180990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 180995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 180998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 181001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 181004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181008 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1524:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ORQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 181008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_B),
     /* 181011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 181013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181015 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181017 */     GIR_RootConstrainSelectedInstOperands,
     /* 181018 */     // GIR_Coverage, 3539,
     /* 181018 */     GIR_EraseRootFromParent_Done,
     /* 181019 */   // Label 3557: @181019
     /* 181019 */   GIM_Try, /*On fail goto*//*Label 3558*/ GIMT_Encode4(181056), // Rule ID 3540 //
     /* 181024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 181032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 181035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 181038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 181041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181045 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1524:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ORQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 181045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_H),
     /* 181048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 181050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181052 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181054 */     GIR_RootConstrainSelectedInstOperands,
     /* 181055 */     // GIR_Coverage, 3540,
     /* 181055 */     GIR_EraseRootFromParent_Done,
     /* 181056 */   // Label 3558: @181056
     /* 181056 */   GIM_Try, /*On fail goto*//*Label 3559*/ GIMT_Encode4(181093), // Rule ID 3541 //
     /* 181061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 181069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 181072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 181075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 181078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181082 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1524:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ORQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 181082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_S),
     /* 181085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 181087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181089 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181091 */     GIR_RootConstrainSelectedInstOperands,
     /* 181092 */     // GIR_Coverage, 3541,
     /* 181092 */     GIR_EraseRootFromParent_Done,
     /* 181093 */   // Label 3559: @181093
     /* 181093 */   GIM_Try, /*On fail goto*//*Label 3560*/ GIMT_Encode4(181130), // Rule ID 3542 //
     /* 181098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 181106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 181109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 181112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 181115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181119 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1524:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ORQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 181119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_D),
     /* 181122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 181124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181126 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181128 */     GIR_RootConstrainSelectedInstOperands,
     /* 181129 */     // GIR_Coverage, 3542,
     /* 181129 */     GIR_EraseRootFromParent_Done,
     /* 181130 */   // Label 3560: @181130
     /* 181130 */   GIM_Try, /*On fail goto*//*Label 3561*/ GIMT_Encode4(181167), // Rule ID 3543 //
     /* 181135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 181143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 181146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 181149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 181152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181156 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2068:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIPQ1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 181156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_B),
     /* 181159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181163 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181165 */     GIR_RootConstrainSelectedInstOperands,
     /* 181166 */     // GIR_Coverage, 3543,
     /* 181166 */     GIR_EraseRootFromParent_Done,
     /* 181167 */   // Label 3561: @181167
     /* 181167 */   GIM_Try, /*On fail goto*//*Label 3562*/ GIMT_Encode4(181204), // Rule ID 3544 //
     /* 181172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 181180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 181183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 181186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 181189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181193 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2068:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIPQ1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 181193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_H),
     /* 181196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181202 */     GIR_RootConstrainSelectedInstOperands,
     /* 181203 */     // GIR_Coverage, 3544,
     /* 181203 */     GIR_EraseRootFromParent_Done,
     /* 181204 */   // Label 3562: @181204
     /* 181204 */   GIM_Try, /*On fail goto*//*Label 3563*/ GIMT_Encode4(181241), // Rule ID 3545 //
     /* 181209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 181217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 181220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 181223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 181226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181230 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2068:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIPQ1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 181230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_S),
     /* 181233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181235 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181237 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181239 */     GIR_RootConstrainSelectedInstOperands,
     /* 181240 */     // GIR_Coverage, 3545,
     /* 181240 */     GIR_EraseRootFromParent_Done,
     /* 181241 */   // Label 3563: @181241
     /* 181241 */   GIM_Try, /*On fail goto*//*Label 3564*/ GIMT_Encode4(181278), // Rule ID 3546 //
     /* 181246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 181254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 181257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 181260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 181263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181267 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2068:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIPQ1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 181267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_D),
     /* 181270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181274 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181276 */     GIR_RootConstrainSelectedInstOperands,
     /* 181277 */     // GIR_Coverage, 3546,
     /* 181277 */     GIR_EraseRootFromParent_Done,
     /* 181278 */   // Label 3564: @181278
     /* 181278 */   GIM_Try, /*On fail goto*//*Label 3565*/ GIMT_Encode4(181315), // Rule ID 3547 //
     /* 181283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 181291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 181294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 181297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 181300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181304 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2068:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIPQ1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 181304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_H),
     /* 181307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181309 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181311 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181313 */     GIR_RootConstrainSelectedInstOperands,
     /* 181314 */     // GIR_Coverage, 3547,
     /* 181314 */     GIR_EraseRootFromParent_Done,
     /* 181315 */   // Label 3565: @181315
     /* 181315 */   GIM_Try, /*On fail goto*//*Label 3566*/ GIMT_Encode4(181352), // Rule ID 3548 //
     /* 181320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 181328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 181331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 181334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 181337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181341 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2068:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIPQ1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 181341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_S),
     /* 181344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181348 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181350 */     GIR_RootConstrainSelectedInstOperands,
     /* 181351 */     // GIR_Coverage, 3548,
     /* 181351 */     GIR_EraseRootFromParent_Done,
     /* 181352 */   // Label 3566: @181352
     /* 181352 */   GIM_Try, /*On fail goto*//*Label 3567*/ GIMT_Encode4(181389), // Rule ID 3549 //
     /* 181357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 181365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 181368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 181371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 181374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181378 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2068:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIPQ1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 181378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_D),
     /* 181381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181383 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181385 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181387 */     GIR_RootConstrainSelectedInstOperands,
     /* 181388 */     // GIR_Coverage, 3549,
     /* 181388 */     GIR_EraseRootFromParent_Done,
     /* 181389 */   // Label 3567: @181389
     /* 181389 */   GIM_Try, /*On fail goto*//*Label 3568*/ GIMT_Encode4(181426), // Rule ID 3550 //
     /* 181394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 181402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 181405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 181408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 181411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181415 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1823:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TBLQ_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 181415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_B),
     /* 181418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181422 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181424 */     GIR_RootConstrainSelectedInstOperands,
     /* 181425 */     // GIR_Coverage, 3550,
     /* 181425 */     GIR_EraseRootFromParent_Done,
     /* 181426 */   // Label 3568: @181426
     /* 181426 */   GIM_Try, /*On fail goto*//*Label 3569*/ GIMT_Encode4(181463), // Rule ID 3551 //
     /* 181431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 181439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 181442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 181445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 181448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181452 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1823:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TBLQ_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 181452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_H),
     /* 181455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181461 */     GIR_RootConstrainSelectedInstOperands,
     /* 181462 */     // GIR_Coverage, 3551,
     /* 181462 */     GIR_EraseRootFromParent_Done,
     /* 181463 */   // Label 3569: @181463
     /* 181463 */   GIM_Try, /*On fail goto*//*Label 3570*/ GIMT_Encode4(181500), // Rule ID 3552 //
     /* 181468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 181476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 181479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 181482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 181485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181489 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1823:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TBLQ_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 181489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_S),
     /* 181492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181494 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181496 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181498 */     GIR_RootConstrainSelectedInstOperands,
     /* 181499 */     // GIR_Coverage, 3552,
     /* 181499 */     GIR_EraseRootFromParent_Done,
     /* 181500 */   // Label 3570: @181500
     /* 181500 */   GIM_Try, /*On fail goto*//*Label 3571*/ GIMT_Encode4(181537), // Rule ID 3553 //
     /* 181505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 181513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 181516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 181519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 181522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181526 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1823:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TBLQ_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 181526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_D),
     /* 181529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181531 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181533 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181535 */     GIR_RootConstrainSelectedInstOperands,
     /* 181536 */     // GIR_Coverage, 3553,
     /* 181536 */     GIR_EraseRootFromParent_Done,
     /* 181537 */   // Label 3571: @181537
     /* 181537 */   GIM_Try, /*On fail goto*//*Label 3572*/ GIMT_Encode4(181574), // Rule ID 3554 //
     /* 181542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 181550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 181553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 181556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 181559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181563 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1823:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TBLQ_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 181563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_H),
     /* 181566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181570 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181572 */     GIR_RootConstrainSelectedInstOperands,
     /* 181573 */     // GIR_Coverage, 3554,
     /* 181573 */     GIR_EraseRootFromParent_Done,
     /* 181574 */   // Label 3572: @181574
     /* 181574 */   GIM_Try, /*On fail goto*//*Label 3573*/ GIMT_Encode4(181611), // Rule ID 3555 //
     /* 181579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 181587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 181590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 181593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 181596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181600 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1823:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TBLQ_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 181600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_S),
     /* 181603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181607 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181609 */     GIR_RootConstrainSelectedInstOperands,
     /* 181610 */     // GIR_Coverage, 3555,
     /* 181610 */     GIR_EraseRootFromParent_Done,
     /* 181611 */   // Label 3573: @181611
     /* 181611 */   GIM_Try, /*On fail goto*//*Label 3574*/ GIMT_Encode4(181648), // Rule ID 3556 //
     /* 181616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 181624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 181627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 181630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 181633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181637 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1823:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TBLQ_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 181637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_D),
     /* 181640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181642 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181644 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181646 */     GIR_RootConstrainSelectedInstOperands,
     /* 181647 */     // GIR_Coverage, 3556,
     /* 181647 */     GIR_EraseRootFromParent_Done,
     /* 181648 */   // Label 3574: @181648
     /* 181648 */   GIM_Try, /*On fail goto*//*Label 3575*/ GIMT_Encode4(181685), // Rule ID 8254 //
     /* 181653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 181656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkb_z),
     /* 181661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 181664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 181667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 181670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 181674 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1202:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (BRKB_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 181674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKB_PPzP),
     /* 181677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 181679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181681 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181683 */     GIR_RootConstrainSelectedInstOperands,
     /* 181684 */     // GIR_Coverage, 8254,
     /* 181684 */     GIR_EraseRootFromParent_Done,
     /* 181685 */   // Label 3575: @181685
     /* 181685 */   GIM_Try, /*On fail goto*//*Label 3576*/ GIMT_Encode4(181722), // Rule ID 8730 //
     /* 181690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 181693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrb),
     /* 181698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 181701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 181704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 181707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181711 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1160:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_0:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 181711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_0),
     /* 181714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181718 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181720 */     GIR_RootConstrainSelectedInstOperands,
     /* 181721 */     // GIR_Coverage, 8730,
     /* 181721 */     GIR_EraseRootFromParent_Done,
     /* 181722 */   // Label 3576: @181722
     /* 181722 */   GIM_Try, /*On fail goto*//*Label 3577*/ GIMT_Encode4(181759), // Rule ID 8731 //
     /* 181727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 181730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrh),
     /* 181735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 181738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 181741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 181744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181748 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1162:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_1:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 181748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_1),
     /* 181751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181755 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181757 */     GIR_RootConstrainSelectedInstOperands,
     /* 181758 */     // GIR_Coverage, 8731,
     /* 181758 */     GIR_EraseRootFromParent_Done,
     /* 181759 */   // Label 3577: @181759
     /* 181759 */   GIM_Try, /*On fail goto*//*Label 3578*/ GIMT_Encode4(181796), // Rule ID 8732 //
     /* 181764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 181767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrw),
     /* 181772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 181775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 181778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 181781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181785 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1163:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_2:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 181785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_2),
     /* 181788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181792 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181794 */     GIR_RootConstrainSelectedInstOperands,
     /* 181795 */     // GIR_Coverage, 8732,
     /* 181795 */     GIR_EraseRootFromParent_Done,
     /* 181796 */   // Label 3578: @181796
     /* 181796 */   GIM_Try, /*On fail goto*//*Label 3579*/ GIMT_Encode4(181833), // Rule ID 8733 //
     /* 181801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 181804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrd),
     /* 181809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 181812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 181815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 181818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181822 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1161:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_3:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 181822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_3),
     /* 181825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181829 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181831 */     GIR_RootConstrainSelectedInstOperands,
     /* 181832 */     // GIR_Coverage, 8733,
     /* 181832 */     GIR_EraseRootFromParent_Done,
     /* 181833 */   // Label 3579: @181833
     /* 181833 */   GIM_Try, /*On fail goto*//*Label 3580*/ GIMT_Encode4(181870), // Rule ID 8734 //
     /* 181838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 181841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrb),
     /* 181846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 181849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 181852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 181855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181859 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1160:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 181859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_0),
     /* 181862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181866 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181868 */     GIR_RootConstrainSelectedInstOperands,
     /* 181869 */     // GIR_Coverage, 8734,
     /* 181869 */     GIR_EraseRootFromParent_Done,
     /* 181870 */   // Label 3580: @181870
     /* 181870 */   GIM_Try, /*On fail goto*//*Label 3581*/ GIMT_Encode4(181907), // Rule ID 8735 //
     /* 181875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 181878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrh),
     /* 181883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 181886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 181889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 181892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181896 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1162:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_1:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 181896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_1),
     /* 181899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181903 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181905 */     GIR_RootConstrainSelectedInstOperands,
     /* 181906 */     // GIR_Coverage, 8735,
     /* 181906 */     GIR_EraseRootFromParent_Done,
     /* 181907 */   // Label 3581: @181907
     /* 181907 */   GIM_Try, /*On fail goto*//*Label 3582*/ GIMT_Encode4(181944), // Rule ID 8736 //
     /* 181912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 181915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrw),
     /* 181920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 181923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 181926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 181929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181933 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1163:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_2:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 181933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_2),
     /* 181936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181940 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181942 */     GIR_RootConstrainSelectedInstOperands,
     /* 181943 */     // GIR_Coverage, 8736,
     /* 181943 */     GIR_EraseRootFromParent_Done,
     /* 181944 */   // Label 3582: @181944
     /* 181944 */   GIM_Try, /*On fail goto*//*Label 3583*/ GIMT_Encode4(181981), // Rule ID 8737 //
     /* 181949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 181952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrd),
     /* 181957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 181960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 181963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 181966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181970 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1161:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_3:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 181970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_3),
     /* 181973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 181975 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 181977 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 181979 */     GIR_RootConstrainSelectedInstOperands,
     /* 181980 */     // GIR_Coverage, 8737,
     /* 181980 */     GIR_EraseRootFromParent_Done,
     /* 181981 */   // Label 3583: @181981
     /* 181981 */   GIM_Try, /*On fail goto*//*Label 3584*/ GIMT_Encode4(182021), // Rule ID 9737 //
     /* 181986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 181989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 181994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 181997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182007 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2020:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 182007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_B),
     /* 182010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182014 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182016 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182019 */     GIR_RootConstrainSelectedInstOperands,
     /* 182020 */     // GIR_Coverage, 9737,
     /* 182020 */     GIR_EraseRootFromParent_Done,
     /* 182021 */   // Label 3584: @182021
     /* 182021 */   GIM_Try, /*On fail goto*//*Label 3585*/ GIMT_Encode4(182061), // Rule ID 9738 //
     /* 182026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 182034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 182037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182047 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2020:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 182047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_H),
     /* 182050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182054 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182056 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182059 */     GIR_RootConstrainSelectedInstOperands,
     /* 182060 */     // GIR_Coverage, 9738,
     /* 182060 */     GIR_EraseRootFromParent_Done,
     /* 182061 */   // Label 3585: @182061
     /* 182061 */   GIM_Try, /*On fail goto*//*Label 3586*/ GIMT_Encode4(182101), // Rule ID 9739 //
     /* 182066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 182074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 182077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182087 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2020:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 182087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_S),
     /* 182090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182096 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182099 */     GIR_RootConstrainSelectedInstOperands,
     /* 182100 */     // GIR_Coverage, 9739,
     /* 182100 */     GIR_EraseRootFromParent_Done,
     /* 182101 */   // Label 3586: @182101
     /* 182101 */   GIM_Try, /*On fail goto*//*Label 3587*/ GIMT_Encode4(182141), // Rule ID 9740 //
     /* 182106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 182114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 182117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182127 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2020:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 182127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_D),
     /* 182130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182134 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182136 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182139 */     GIR_RootConstrainSelectedInstOperands,
     /* 182140 */     // GIR_Coverage, 9740,
     /* 182140 */     GIR_EraseRootFromParent_Done,
     /* 182141 */   // Label 3587: @182141
     /* 182141 */   GIM_Try, /*On fail goto*//*Label 3588*/ GIMT_Encode4(182181), // Rule ID 9741 //
     /* 182146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 182154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 182157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182167 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2026:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELO_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 182167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PWW_B),
     /* 182170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182174 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182176 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182179 */     GIR_RootConstrainSelectedInstOperands,
     /* 182180 */     // GIR_Coverage, 9741,
     /* 182180 */     GIR_EraseRootFromParent_Done,
     /* 182181 */   // Label 3588: @182181
     /* 182181 */   GIM_Try, /*On fail goto*//*Label 3589*/ GIMT_Encode4(182221), // Rule ID 9742 //
     /* 182186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 182194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 182197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182207 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2026:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELO_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 182207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PWW_H),
     /* 182210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182214 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182216 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182219 */     GIR_RootConstrainSelectedInstOperands,
     /* 182220 */     // GIR_Coverage, 9742,
     /* 182220 */     GIR_EraseRootFromParent_Done,
     /* 182221 */   // Label 3589: @182221
     /* 182221 */   GIM_Try, /*On fail goto*//*Label 3590*/ GIMT_Encode4(182261), // Rule ID 9743 //
     /* 182226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 182234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 182237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182247 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2026:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELO_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 182247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PWW_S),
     /* 182250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182254 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182256 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182259 */     GIR_RootConstrainSelectedInstOperands,
     /* 182260 */     // GIR_Coverage, 9743,
     /* 182260 */     GIR_EraseRootFromParent_Done,
     /* 182261 */   // Label 3590: @182261
     /* 182261 */   GIM_Try, /*On fail goto*//*Label 3591*/ GIMT_Encode4(182301), // Rule ID 9744 //
     /* 182266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 182274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 182277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182287 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2026:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELO_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 182287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PWW_D),
     /* 182290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182294 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182296 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182299 */     GIR_RootConstrainSelectedInstOperands,
     /* 182300 */     // GIR_Coverage, 9744,
     /* 182300 */     GIR_EraseRootFromParent_Done,
     /* 182301 */   // Label 3591: @182301
     /* 182301 */   GIM_Try, /*On fail goto*//*Label 3592*/ GIMT_Encode4(182341), // Rule ID 9749 //
     /* 182306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 182314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 182317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182327 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2032:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 182327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_B),
     /* 182330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182334 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182336 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182339 */     GIR_RootConstrainSelectedInstOperands,
     /* 182340 */     // GIR_Coverage, 9749,
     /* 182340 */     GIR_EraseRootFromParent_Done,
     /* 182341 */   // Label 3592: @182341
     /* 182341 */   GIM_Try, /*On fail goto*//*Label 3593*/ GIMT_Encode4(182381), // Rule ID 9750 //
     /* 182346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 182354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 182357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182367 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2032:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 182367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_H),
     /* 182370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182374 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182376 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182379 */     GIR_RootConstrainSelectedInstOperands,
     /* 182380 */     // GIR_Coverage, 9750,
     /* 182380 */     GIR_EraseRootFromParent_Done,
     /* 182381 */   // Label 3593: @182381
     /* 182381 */   GIM_Try, /*On fail goto*//*Label 3594*/ GIMT_Encode4(182421), // Rule ID 9751 //
     /* 182386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 182394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 182397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182407 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2032:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 182407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_S),
     /* 182410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182414 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182416 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182419 */     GIR_RootConstrainSelectedInstOperands,
     /* 182420 */     // GIR_Coverage, 9751,
     /* 182420 */     GIR_EraseRootFromParent_Done,
     /* 182421 */   // Label 3594: @182421
     /* 182421 */   GIM_Try, /*On fail goto*//*Label 3595*/ GIMT_Encode4(182461), // Rule ID 9752 //
     /* 182426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 182434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 182437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182447 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2032:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 182447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_D),
     /* 182450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182452 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182454 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182456 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182459 */     GIR_RootConstrainSelectedInstOperands,
     /* 182460 */     // GIR_Coverage, 9752,
     /* 182460 */     GIR_EraseRootFromParent_Done,
     /* 182461 */   // Label 3595: @182461
     /* 182461 */   GIM_Try, /*On fail goto*//*Label 3596*/ GIMT_Encode4(182501), // Rule ID 9753 //
     /* 182466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 182474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 182477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182487 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2020:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 182487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_B),
     /* 182490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182492 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182494 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182496 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182499 */     GIR_RootConstrainSelectedInstOperands,
     /* 182500 */     // GIR_Coverage, 9753,
     /* 182500 */     GIR_EraseRootFromParent_Done,
     /* 182501 */   // Label 3596: @182501
     /* 182501 */   GIM_Try, /*On fail goto*//*Label 3597*/ GIMT_Encode4(182541), // Rule ID 9754 //
     /* 182506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 182514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 182517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182527 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2020:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 182527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_H),
     /* 182530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182534 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182536 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182539 */     GIR_RootConstrainSelectedInstOperands,
     /* 182540 */     // GIR_Coverage, 9754,
     /* 182540 */     GIR_EraseRootFromParent_Done,
     /* 182541 */   // Label 3597: @182541
     /* 182541 */   GIM_Try, /*On fail goto*//*Label 3598*/ GIMT_Encode4(182581), // Rule ID 9755 //
     /* 182546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 182554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 182557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182567 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2020:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 182567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_S),
     /* 182570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182574 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182576 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182579 */     GIR_RootConstrainSelectedInstOperands,
     /* 182580 */     // GIR_Coverage, 9755,
     /* 182580 */     GIR_EraseRootFromParent_Done,
     /* 182581 */   // Label 3598: @182581
     /* 182581 */   GIM_Try, /*On fail goto*//*Label 3599*/ GIMT_Encode4(182621), // Rule ID 9756 //
     /* 182586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 182594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 182597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182607 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2020:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 182607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_D),
     /* 182610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182614 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182616 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182619 */     GIR_RootConstrainSelectedInstOperands,
     /* 182620 */     // GIR_Coverage, 9756,
     /* 182620 */     GIR_EraseRootFromParent_Done,
     /* 182621 */   // Label 3599: @182621
     /* 182621 */   GIM_Try, /*On fail goto*//*Label 3600*/ GIMT_Encode4(182661), // Rule ID 9757 //
     /* 182626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 182634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 182637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182647 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2026:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELO_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 182647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PXX_B),
     /* 182650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182654 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182656 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182659 */     GIR_RootConstrainSelectedInstOperands,
     /* 182660 */     // GIR_Coverage, 9757,
     /* 182660 */     GIR_EraseRootFromParent_Done,
     /* 182661 */   // Label 3600: @182661
     /* 182661 */   GIM_Try, /*On fail goto*//*Label 3601*/ GIMT_Encode4(182701), // Rule ID 9758 //
     /* 182666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 182674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 182677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182687 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2026:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELO_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 182687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PXX_H),
     /* 182690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182694 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182696 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182699 */     GIR_RootConstrainSelectedInstOperands,
     /* 182700 */     // GIR_Coverage, 9758,
     /* 182700 */     GIR_EraseRootFromParent_Done,
     /* 182701 */   // Label 3601: @182701
     /* 182701 */   GIM_Try, /*On fail goto*//*Label 3602*/ GIMT_Encode4(182741), // Rule ID 9759 //
     /* 182706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 182714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 182717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182727 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2026:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELO_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 182727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PXX_S),
     /* 182730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182734 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182736 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182739 */     GIR_RootConstrainSelectedInstOperands,
     /* 182740 */     // GIR_Coverage, 9759,
     /* 182740 */     GIR_EraseRootFromParent_Done,
     /* 182741 */   // Label 3602: @182741
     /* 182741 */   GIM_Try, /*On fail goto*//*Label 3603*/ GIMT_Encode4(182781), // Rule ID 9760 //
     /* 182746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 182754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 182757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182767 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2026:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELO_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 182767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PXX_D),
     /* 182770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182774 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182776 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182779 */     GIR_RootConstrainSelectedInstOperands,
     /* 182780 */     // GIR_Coverage, 9760,
     /* 182780 */     GIR_EraseRootFromParent_Done,
     /* 182781 */   // Label 3603: @182781
     /* 182781 */   GIM_Try, /*On fail goto*//*Label 3604*/ GIMT_Encode4(182821), // Rule ID 9765 //
     /* 182786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 182794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 182797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182807 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2032:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 182807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_B),
     /* 182810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182814 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182816 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182819 */     GIR_RootConstrainSelectedInstOperands,
     /* 182820 */     // GIR_Coverage, 9765,
     /* 182820 */     GIR_EraseRootFromParent_Done,
     /* 182821 */   // Label 3604: @182821
     /* 182821 */   GIM_Try, /*On fail goto*//*Label 3605*/ GIMT_Encode4(182861), // Rule ID 9766 //
     /* 182826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 182834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 182837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182847 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2032:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 182847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
     /* 182850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182854 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182856 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182859 */     GIR_RootConstrainSelectedInstOperands,
     /* 182860 */     // GIR_Coverage, 9766,
     /* 182860 */     GIR_EraseRootFromParent_Done,
     /* 182861 */   // Label 3605: @182861
     /* 182861 */   GIM_Try, /*On fail goto*//*Label 3606*/ GIMT_Encode4(182901), // Rule ID 9767 //
     /* 182866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 182874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 182877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182887 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2032:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 182887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 182890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182894 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182896 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182899 */     GIR_RootConstrainSelectedInstOperands,
     /* 182900 */     // GIR_Coverage, 9767,
     /* 182900 */     GIR_EraseRootFromParent_Done,
     /* 182901 */   // Label 3606: @182901
     /* 182901 */   GIM_Try, /*On fail goto*//*Label 3607*/ GIMT_Encode4(182941), // Rule ID 9768 //
     /* 182906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 182914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 182917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182927 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2032:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 182927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 182930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 182932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182934 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182936 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 182939 */     GIR_RootConstrainSelectedInstOperands,
     /* 182940 */     // GIR_Coverage, 9768,
     /* 182940 */     GIR_EraseRootFromParent_Done,
     /* 182941 */   // Label 3607: @182941
     /* 182941 */   GIM_Try, /*On fail goto*//*Label 3608*/ GIMT_Encode4(182978), // Rule ID 9927 //
     /* 182946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
     /* 182954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 182957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 182960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 182963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182967 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1930:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UQINCP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 182967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_H),
     /* 182970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 182972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 182974 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 182976 */     GIR_RootConstrainSelectedInstOperands,
     /* 182977 */     // GIR_Coverage, 9927,
     /* 182977 */     GIR_EraseRootFromParent_Done,
     /* 182978 */   // Label 3608: @182978
     /* 182978 */   GIM_Try, /*On fail goto*//*Label 3609*/ GIMT_Encode4(183015), // Rule ID 9928 //
     /* 182983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
     /* 182991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 182994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 182997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 183000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183004 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1930:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UQINCP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 183004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_S),
     /* 183007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 183009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183011 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183013 */     GIR_RootConstrainSelectedInstOperands,
     /* 183014 */     // GIR_Coverage, 9928,
     /* 183014 */     GIR_EraseRootFromParent_Done,
     /* 183015 */   // Label 3609: @183015
     /* 183015 */   GIM_Try, /*On fail goto*//*Label 3610*/ GIMT_Encode4(183052), // Rule ID 9929 //
     /* 183020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
     /* 183028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 183031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 183034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 183037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183041 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1930:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UQINCP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 183041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_D),
     /* 183044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 183046 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183048 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183050 */     GIR_RootConstrainSelectedInstOperands,
     /* 183051 */     // GIR_Coverage, 9929,
     /* 183051 */     GIR_EraseRootFromParent_Done,
     /* 183052 */   // Label 3610: @183052
     /* 183052 */   GIM_Try, /*On fail goto*//*Label 3611*/ GIMT_Encode4(183089), // Rule ID 9930 //
     /* 183057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
     /* 183065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 183068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 183071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 183074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183078 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1685:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SQDECP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 183078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_H),
     /* 183081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 183083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183085 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183087 */     GIR_RootConstrainSelectedInstOperands,
     /* 183088 */     // GIR_Coverage, 9930,
     /* 183088 */     GIR_EraseRootFromParent_Done,
     /* 183089 */   // Label 3611: @183089
     /* 183089 */   GIM_Try, /*On fail goto*//*Label 3612*/ GIMT_Encode4(183126), // Rule ID 9931 //
     /* 183094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
     /* 183102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 183105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 183111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183115 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1685:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SQDECP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 183115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_S),
     /* 183118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 183120 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183122 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183124 */     GIR_RootConstrainSelectedInstOperands,
     /* 183125 */     // GIR_Coverage, 9931,
     /* 183125 */     GIR_EraseRootFromParent_Done,
     /* 183126 */   // Label 3612: @183126
     /* 183126 */   GIM_Try, /*On fail goto*//*Label 3613*/ GIMT_Encode4(183163), // Rule ID 9932 //
     /* 183131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
     /* 183139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 183142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 183145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 183148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183152 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1685:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SQDECP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 183152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_D),
     /* 183155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 183157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183161 */     GIR_RootConstrainSelectedInstOperands,
     /* 183162 */     // GIR_Coverage, 9932,
     /* 183162 */     GIR_EraseRootFromParent_Done,
     /* 183163 */   // Label 3613: @183163
     /* 183163 */   GIM_Try, /*On fail goto*//*Label 3614*/ GIMT_Encode4(183200), // Rule ID 9933 //
     /* 183168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
     /* 183176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 183179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 183182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 183185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183189 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1916:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UQDECP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 183189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_H),
     /* 183192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 183194 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183196 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183198 */     GIR_RootConstrainSelectedInstOperands,
     /* 183199 */     // GIR_Coverage, 9933,
     /* 183199 */     GIR_EraseRootFromParent_Done,
     /* 183200 */   // Label 3614: @183200
     /* 183200 */   GIM_Try, /*On fail goto*//*Label 3615*/ GIMT_Encode4(183237), // Rule ID 9934 //
     /* 183205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
     /* 183213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 183216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 183222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183226 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1916:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UQDECP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 183226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_S),
     /* 183229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 183231 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183233 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183235 */     GIR_RootConstrainSelectedInstOperands,
     /* 183236 */     // GIR_Coverage, 9934,
     /* 183236 */     GIR_EraseRootFromParent_Done,
     /* 183237 */   // Label 3615: @183237
     /* 183237 */   GIM_Try, /*On fail goto*//*Label 3616*/ GIMT_Encode4(183274), // Rule ID 9935 //
     /* 183242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
     /* 183250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 183253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 183256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 183259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183263 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1916:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UQDECP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 183263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_D),
     /* 183266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 183268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183270 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183272 */     GIR_RootConstrainSelectedInstOperands,
     /* 183273 */     // GIR_Coverage, 9935,
     /* 183273 */     GIR_EraseRootFromParent_Done,
     /* 183274 */   // Label 3616: @183274
     /* 183274 */   GIM_Try, /*On fail goto*//*Label 3617*/ GIMT_Encode4(183311), // Rule ID 11075 //
     /* 183279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 183282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 183287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 183290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 183293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 183296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183300 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2065:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 183300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 183303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183307 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183309 */     GIR_RootConstrainSelectedInstOperands,
     /* 183310 */     // GIR_Coverage, 11075,
     /* 183310 */     GIR_EraseRootFromParent_Done,
     /* 183311 */   // Label 3617: @183311
     /* 183311 */   GIM_Try, /*On fail goto*//*Label 3618*/ GIMT_Encode4(183348), // Rule ID 11076 //
     /* 183316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 183319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 183324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 183327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 183330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 183333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183337 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2065:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 183337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 183340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183346 */     GIR_RootConstrainSelectedInstOperands,
     /* 183347 */     // GIR_Coverage, 11076,
     /* 183347 */     GIR_EraseRootFromParent_Done,
     /* 183348 */   // Label 3618: @183348
     /* 183348 */   GIM_Try, /*On fail goto*//*Label 3619*/ GIMT_Encode4(183385), // Rule ID 11077 //
     /* 183353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 183356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 183361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 183364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 183367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 183370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183374 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2065:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 183374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 183377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183379 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183381 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183383 */     GIR_RootConstrainSelectedInstOperands,
     /* 183384 */     // GIR_Coverage, 11077,
     /* 183384 */     GIR_EraseRootFromParent_Done,
     /* 183385 */   // Label 3619: @183385
     /* 183385 */   GIM_Try, /*On fail goto*//*Label 3620*/ GIMT_Encode4(183422), // Rule ID 11078 //
     /* 183390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 183393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 183398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 183401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 183407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183411 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2065:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 183411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 183414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183416 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183418 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183420 */     GIR_RootConstrainSelectedInstOperands,
     /* 183421 */     // GIR_Coverage, 11078,
     /* 183421 */     GIR_EraseRootFromParent_Done,
     /* 183422 */   // Label 3620: @183422
     /* 183422 */   GIM_Try, /*On fail goto*//*Label 3621*/ GIMT_Encode4(183459), // Rule ID 11079 //
     /* 183427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 183430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 183435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 183438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 183444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183448 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2065:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 183448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 183451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183455 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183457 */     GIR_RootConstrainSelectedInstOperands,
     /* 183458 */     // GIR_Coverage, 11079,
     /* 183458 */     GIR_EraseRootFromParent_Done,
     /* 183459 */   // Label 3621: @183459
     /* 183459 */   GIM_Try, /*On fail goto*//*Label 3622*/ GIMT_Encode4(183496), // Rule ID 11080 //
     /* 183464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 183467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 183472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 183475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 183478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 183481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183485 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2065:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 183485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 183488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183490 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183492 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183494 */     GIR_RootConstrainSelectedInstOperands,
     /* 183495 */     // GIR_Coverage, 11080,
     /* 183495 */     GIR_EraseRootFromParent_Done,
     /* 183496 */   // Label 3622: @183496
     /* 183496 */   GIM_Try, /*On fail goto*//*Label 3623*/ GIMT_Encode4(183533), // Rule ID 11081 //
     /* 183501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 183504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 183509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 183512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 183515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 183518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183522 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2065:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 183522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 183525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183529 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183531 */     GIR_RootConstrainSelectedInstOperands,
     /* 183532 */     // GIR_Coverage, 11081,
     /* 183532 */     GIR_EraseRootFromParent_Done,
     /* 183533 */   // Label 3623: @183533
     /* 183533 */   GIM_Try, /*On fail goto*//*Label 3624*/ GIMT_Encode4(183570), // Rule ID 11082 //
     /* 183538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 183541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 183546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 183549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 183552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 183555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183559 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1986:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 183559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 183562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183566 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183568 */     GIR_RootConstrainSelectedInstOperands,
     /* 183569 */     // GIR_Coverage, 11082,
     /* 183569 */     GIR_EraseRootFromParent_Done,
     /* 183570 */   // Label 3624: @183570
     /* 183570 */   GIM_Try, /*On fail goto*//*Label 3625*/ GIMT_Encode4(183607), // Rule ID 11083 //
     /* 183575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 183578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 183583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 183586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 183589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 183592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183596 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1986:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 183596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 183599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183603 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183605 */     GIR_RootConstrainSelectedInstOperands,
     /* 183606 */     // GIR_Coverage, 11083,
     /* 183606 */     GIR_EraseRootFromParent_Done,
     /* 183607 */   // Label 3625: @183607
     /* 183607 */   GIM_Try, /*On fail goto*//*Label 3626*/ GIMT_Encode4(183644), // Rule ID 11084 //
     /* 183612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 183615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 183620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 183623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 183626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 183629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183633 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1986:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 183633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 183636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183640 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183642 */     GIR_RootConstrainSelectedInstOperands,
     /* 183643 */     // GIR_Coverage, 11084,
     /* 183643 */     GIR_EraseRootFromParent_Done,
     /* 183644 */   // Label 3626: @183644
     /* 183644 */   GIM_Try, /*On fail goto*//*Label 3627*/ GIMT_Encode4(183681), // Rule ID 11085 //
     /* 183649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 183652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 183657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 183660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 183666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183670 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1986:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 183670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 183673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183677 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183679 */     GIR_RootConstrainSelectedInstOperands,
     /* 183680 */     // GIR_Coverage, 11085,
     /* 183680 */     GIR_EraseRootFromParent_Done,
     /* 183681 */   // Label 3627: @183681
     /* 183681 */   GIM_Try, /*On fail goto*//*Label 3628*/ GIMT_Encode4(183718), // Rule ID 11086 //
     /* 183686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 183689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 183694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 183697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 183703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183707 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1986:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 183707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 183710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183714 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183716 */     GIR_RootConstrainSelectedInstOperands,
     /* 183717 */     // GIR_Coverage, 11086,
     /* 183717 */     GIR_EraseRootFromParent_Done,
     /* 183718 */   // Label 3628: @183718
     /* 183718 */   GIM_Try, /*On fail goto*//*Label 3629*/ GIMT_Encode4(183755), // Rule ID 11087 //
     /* 183723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 183726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 183731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 183734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 183737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 183740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183744 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1986:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 183744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 183747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183751 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183753 */     GIR_RootConstrainSelectedInstOperands,
     /* 183754 */     // GIR_Coverage, 11087,
     /* 183754 */     GIR_EraseRootFromParent_Done,
     /* 183755 */   // Label 3629: @183755
     /* 183755 */   GIM_Try, /*On fail goto*//*Label 3630*/ GIMT_Encode4(183792), // Rule ID 11088 //
     /* 183760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 183763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 183768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 183771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 183774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 183777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183781 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1986:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 183781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 183784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183788 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183790 */     GIR_RootConstrainSelectedInstOperands,
     /* 183791 */     // GIR_Coverage, 11088,
     /* 183791 */     GIR_EraseRootFromParent_Done,
     /* 183792 */   // Label 3630: @183792
     /* 183792 */   GIM_Try, /*On fail goto*//*Label 3631*/ GIMT_Encode4(183829), // Rule ID 11089 //
     /* 183797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 183800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 183805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 183808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 183811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 183814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183818 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1991:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 183818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 183821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183825 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183827 */     GIR_RootConstrainSelectedInstOperands,
     /* 183828 */     // GIR_Coverage, 11089,
     /* 183828 */     GIR_EraseRootFromParent_Done,
     /* 183829 */   // Label 3631: @183829
     /* 183829 */   GIM_Try, /*On fail goto*//*Label 3632*/ GIMT_Encode4(183866), // Rule ID 11090 //
     /* 183834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 183837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 183842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 183845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 183848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 183851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183855 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1991:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 183855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 183858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183860 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183862 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183864 */     GIR_RootConstrainSelectedInstOperands,
     /* 183865 */     // GIR_Coverage, 11090,
     /* 183865 */     GIR_EraseRootFromParent_Done,
     /* 183866 */   // Label 3632: @183866
     /* 183866 */   GIM_Try, /*On fail goto*//*Label 3633*/ GIMT_Encode4(183903), // Rule ID 11091 //
     /* 183871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 183874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 183879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 183882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 183885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 183888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183892 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1991:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 183892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 183895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183899 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183901 */     GIR_RootConstrainSelectedInstOperands,
     /* 183902 */     // GIR_Coverage, 11091,
     /* 183902 */     GIR_EraseRootFromParent_Done,
     /* 183903 */   // Label 3633: @183903
     /* 183903 */   GIM_Try, /*On fail goto*//*Label 3634*/ GIMT_Encode4(183940), // Rule ID 11092 //
     /* 183908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 183911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 183916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 183919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 183925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183929 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1991:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 183929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 183932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183936 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183938 */     GIR_RootConstrainSelectedInstOperands,
     /* 183939 */     // GIR_Coverage, 11092,
     /* 183939 */     GIR_EraseRootFromParent_Done,
     /* 183940 */   // Label 3634: @183940
     /* 183940 */   GIM_Try, /*On fail goto*//*Label 3635*/ GIMT_Encode4(183977), // Rule ID 11093 //
     /* 183945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 183948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 183953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 183956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 183962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183966 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1991:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 183966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 183969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183973 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183975 */     GIR_RootConstrainSelectedInstOperands,
     /* 183976 */     // GIR_Coverage, 11093,
     /* 183976 */     GIR_EraseRootFromParent_Done,
     /* 183977 */   // Label 3635: @183977
     /* 183977 */   GIM_Try, /*On fail goto*//*Label 3636*/ GIMT_Encode4(184014), // Rule ID 11094 //
     /* 183982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 183985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 183990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 183993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 183996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 183999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184003 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1991:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 184003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 184006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184010 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184012 */     GIR_RootConstrainSelectedInstOperands,
     /* 184013 */     // GIR_Coverage, 11094,
     /* 184013 */     GIR_EraseRootFromParent_Done,
     /* 184014 */   // Label 3636: @184014
     /* 184014 */   GIM_Try, /*On fail goto*//*Label 3637*/ GIMT_Encode4(184051), // Rule ID 11095 //
     /* 184019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 184022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 184027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 184030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 184033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 184036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184040 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1991:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 184040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 184043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184047 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184049 */     GIR_RootConstrainSelectedInstOperands,
     /* 184050 */     // GIR_Coverage, 11095,
     /* 184050 */     GIR_EraseRootFromParent_Done,
     /* 184051 */   // Label 3637: @184051
     /* 184051 */   GIM_Try, /*On fail goto*//*Label 3638*/ GIMT_Encode4(184088), // Rule ID 11096 //
     /* 184056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 184059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 184064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 184067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 184070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 184073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184077 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1830:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 184077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 184080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184084 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184086 */     GIR_RootConstrainSelectedInstOperands,
     /* 184087 */     // GIR_Coverage, 11096,
     /* 184087 */     GIR_EraseRootFromParent_Done,
     /* 184088 */   // Label 3638: @184088
     /* 184088 */   GIM_Try, /*On fail goto*//*Label 3639*/ GIMT_Encode4(184125), // Rule ID 11097 //
     /* 184093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 184096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 184101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 184110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184114 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1830:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 184114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 184117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184119 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184121 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184123 */     GIR_RootConstrainSelectedInstOperands,
     /* 184124 */     // GIR_Coverage, 11097,
     /* 184124 */     GIR_EraseRootFromParent_Done,
     /* 184125 */   // Label 3639: @184125
     /* 184125 */   GIM_Try, /*On fail goto*//*Label 3640*/ GIMT_Encode4(184162), // Rule ID 11098 //
     /* 184130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 184133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 184138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 184147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184151 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1830:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 184151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 184154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184160 */     GIR_RootConstrainSelectedInstOperands,
     /* 184161 */     // GIR_Coverage, 11098,
     /* 184161 */     GIR_EraseRootFromParent_Done,
     /* 184162 */   // Label 3640: @184162
     /* 184162 */   GIM_Try, /*On fail goto*//*Label 3641*/ GIMT_Encode4(184199), // Rule ID 11099 //
     /* 184167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 184170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 184175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 184184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184188 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1830:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 184188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 184191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184195 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184197 */     GIR_RootConstrainSelectedInstOperands,
     /* 184198 */     // GIR_Coverage, 11099,
     /* 184198 */     GIR_EraseRootFromParent_Done,
     /* 184199 */   // Label 3641: @184199
     /* 184199 */   GIM_Try, /*On fail goto*//*Label 3642*/ GIMT_Encode4(184236), // Rule ID 11100 //
     /* 184204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 184207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 184212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 184221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184225 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1830:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 184225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 184228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184230 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184232 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184234 */     GIR_RootConstrainSelectedInstOperands,
     /* 184235 */     // GIR_Coverage, 11100,
     /* 184235 */     GIR_EraseRootFromParent_Done,
     /* 184236 */   // Label 3642: @184236
     /* 184236 */   GIM_Try, /*On fail goto*//*Label 3643*/ GIMT_Encode4(184273), // Rule ID 11101 //
     /* 184241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 184244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 184249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 184252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 184255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 184258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184262 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1830:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 184262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 184265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184269 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184271 */     GIR_RootConstrainSelectedInstOperands,
     /* 184272 */     // GIR_Coverage, 11101,
     /* 184272 */     GIR_EraseRootFromParent_Done,
     /* 184273 */   // Label 3643: @184273
     /* 184273 */   GIM_Try, /*On fail goto*//*Label 3644*/ GIMT_Encode4(184310), // Rule ID 11102 //
     /* 184278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 184281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 184286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 184289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 184292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 184295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184299 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1830:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 184299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 184302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184306 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184308 */     GIR_RootConstrainSelectedInstOperands,
     /* 184309 */     // GIR_Coverage, 11102,
     /* 184309 */     GIR_EraseRootFromParent_Done,
     /* 184310 */   // Label 3644: @184310
     /* 184310 */   GIM_Try, /*On fail goto*//*Label 3645*/ GIMT_Encode4(184347), // Rule ID 11103 //
     /* 184315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 184318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 184323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 184326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 184329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 184332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184336 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1835:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 184336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 184339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184343 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184345 */     GIR_RootConstrainSelectedInstOperands,
     /* 184346 */     // GIR_Coverage, 11103,
     /* 184346 */     GIR_EraseRootFromParent_Done,
     /* 184347 */   // Label 3645: @184347
     /* 184347 */   GIM_Try, /*On fail goto*//*Label 3646*/ GIMT_Encode4(184384), // Rule ID 11104 //
     /* 184352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 184355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 184360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 184369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184373 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1835:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 184373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 184376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184380 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184382 */     GIR_RootConstrainSelectedInstOperands,
     /* 184383 */     // GIR_Coverage, 11104,
     /* 184383 */     GIR_EraseRootFromParent_Done,
     /* 184384 */   // Label 3646: @184384
     /* 184384 */   GIM_Try, /*On fail goto*//*Label 3647*/ GIMT_Encode4(184421), // Rule ID 11105 //
     /* 184389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 184392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 184397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 184406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184410 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1835:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 184410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 184413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184417 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184419 */     GIR_RootConstrainSelectedInstOperands,
     /* 184420 */     // GIR_Coverage, 11105,
     /* 184420 */     GIR_EraseRootFromParent_Done,
     /* 184421 */   // Label 3647: @184421
     /* 184421 */   GIM_Try, /*On fail goto*//*Label 3648*/ GIMT_Encode4(184458), // Rule ID 11106 //
     /* 184426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 184429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 184434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 184443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184447 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1835:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 184447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 184450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184452 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184454 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184456 */     GIR_RootConstrainSelectedInstOperands,
     /* 184457 */     // GIR_Coverage, 11106,
     /* 184457 */     GIR_EraseRootFromParent_Done,
     /* 184458 */   // Label 3648: @184458
     /* 184458 */   GIM_Try, /*On fail goto*//*Label 3649*/ GIMT_Encode4(184495), // Rule ID 11107 //
     /* 184463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 184466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 184471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 184480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184484 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1835:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 184484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 184487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184491 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184493 */     GIR_RootConstrainSelectedInstOperands,
     /* 184494 */     // GIR_Coverage, 11107,
     /* 184494 */     GIR_EraseRootFromParent_Done,
     /* 184495 */   // Label 3649: @184495
     /* 184495 */   GIM_Try, /*On fail goto*//*Label 3650*/ GIMT_Encode4(184532), // Rule ID 11108 //
     /* 184500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 184503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 184508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 184511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 184514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 184517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184521 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1835:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 184521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 184524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184528 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184530 */     GIR_RootConstrainSelectedInstOperands,
     /* 184531 */     // GIR_Coverage, 11108,
     /* 184531 */     GIR_EraseRootFromParent_Done,
     /* 184532 */   // Label 3650: @184532
     /* 184532 */   GIM_Try, /*On fail goto*//*Label 3651*/ GIMT_Encode4(184569), // Rule ID 11109 //
     /* 184537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 184540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 184545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 184548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 184551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 184554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184558 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1835:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 184558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 184561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184565 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184567 */     GIR_RootConstrainSelectedInstOperands,
     /* 184568 */     // GIR_Coverage, 11109,
     /* 184568 */     GIR_EraseRootFromParent_Done,
     /* 184569 */   // Label 3651: @184569
     /* 184569 */   GIM_Try, /*On fail goto*//*Label 3652*/ GIMT_Encode4(184606), // Rule ID 11129 //
     /* 184574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 184582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 184585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 184588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 184591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184595 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1732:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQRDMULH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 184595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_B),
     /* 184598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184600 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184602 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184604 */     GIR_RootConstrainSelectedInstOperands,
     /* 184605 */     // GIR_Coverage, 11129,
     /* 184605 */     GIR_EraseRootFromParent_Done,
     /* 184606 */   // Label 3652: @184606
     /* 184606 */   GIM_Try, /*On fail goto*//*Label 3653*/ GIMT_Encode4(184643), // Rule ID 11130 //
     /* 184611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 184619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 184628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184632 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1732:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQRDMULH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 184632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_H),
     /* 184635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184639 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184641 */     GIR_RootConstrainSelectedInstOperands,
     /* 184642 */     // GIR_Coverage, 11130,
     /* 184642 */     GIR_EraseRootFromParent_Done,
     /* 184643 */   // Label 3653: @184643
     /* 184643 */   GIM_Try, /*On fail goto*//*Label 3654*/ GIMT_Encode4(184680), // Rule ID 11131 //
     /* 184648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 184656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 184665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184669 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1732:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQRDMULH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 184669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_S),
     /* 184672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184676 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184678 */     GIR_RootConstrainSelectedInstOperands,
     /* 184679 */     // GIR_Coverage, 11131,
     /* 184679 */     GIR_EraseRootFromParent_Done,
     /* 184680 */   // Label 3654: @184680
     /* 184680 */   GIM_Try, /*On fail goto*//*Label 3655*/ GIMT_Encode4(184717), // Rule ID 11132 //
     /* 184685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 184693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 184696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 184699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 184702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184706 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1732:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQRDMULH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 184706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_D),
     /* 184709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184713 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184715 */     GIR_RootConstrainSelectedInstOperands,
     /* 184716 */     // GIR_Coverage, 11132,
     /* 184716 */     GIR_EraseRootFromParent_Done,
     /* 184717 */   // Label 3655: @184717
     /* 184717 */   GIM_Try, /*On fail goto*//*Label 3656*/ GIMT_Encode4(184754), // Rule ID 11420 //
     /* 184722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
     /* 184730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 184736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 184739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184743 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1596:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 184743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_H),
     /* 184746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184748 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184750 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184752 */     GIR_RootConstrainSelectedInstOperands,
     /* 184753 */     // GIR_Coverage, 11420,
     /* 184753 */     GIR_EraseRootFromParent_Done,
     /* 184754 */   // Label 3656: @184754
     /* 184754 */   GIM_Try, /*On fail goto*//*Label 3657*/ GIMT_Encode4(184791), // Rule ID 11421 //
     /* 184759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
     /* 184767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 184776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184780 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1596:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 184780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_S),
     /* 184783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184785 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184787 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184789 */     GIR_RootConstrainSelectedInstOperands,
     /* 184790 */     // GIR_Coverage, 11421,
     /* 184790 */     GIR_EraseRootFromParent_Done,
     /* 184791 */   // Label 3657: @184791
     /* 184791 */   GIM_Try, /*On fail goto*//*Label 3658*/ GIMT_Encode4(184828), // Rule ID 11422 //
     /* 184796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
     /* 184804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 184807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 184813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184817 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1596:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 184817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_D),
     /* 184820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184824 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184826 */     GIR_RootConstrainSelectedInstOperands,
     /* 184827 */     // GIR_Coverage, 11422,
     /* 184827 */     GIR_EraseRootFromParent_Done,
     /* 184828 */   // Label 3658: @184828
     /* 184828 */   GIM_Try, /*On fail goto*//*Label 3659*/ GIMT_Encode4(184865), // Rule ID 11423 //
     /* 184833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
     /* 184841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 184847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 184850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184854 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1844:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UADDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 184854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_H),
     /* 184857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184861 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184863 */     GIR_RootConstrainSelectedInstOperands,
     /* 184864 */     // GIR_Coverage, 11423,
     /* 184864 */     GIR_EraseRootFromParent_Done,
     /* 184865 */   // Label 3659: @184865
     /* 184865 */   GIM_Try, /*On fail goto*//*Label 3660*/ GIMT_Encode4(184902), // Rule ID 11424 //
     /* 184870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
     /* 184878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 184887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184891 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1844:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UADDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 184891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_S),
     /* 184894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184900 */     GIR_RootConstrainSelectedInstOperands,
     /* 184901 */     // GIR_Coverage, 11424,
     /* 184901 */     GIR_EraseRootFromParent_Done,
     /* 184902 */   // Label 3660: @184902
     /* 184902 */   GIM_Try, /*On fail goto*//*Label 3661*/ GIMT_Encode4(184939), // Rule ID 11425 //
     /* 184907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
     /* 184915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 184918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 184924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184928 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1844:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UADDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 184928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_D),
     /* 184931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184935 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184937 */     GIR_RootConstrainSelectedInstOperands,
     /* 184938 */     // GIR_Coverage, 11425,
     /* 184938 */     GIR_EraseRootFromParent_Done,
     /* 184939 */   // Label 3661: @184939
     /* 184939 */   GIM_Try, /*On fail goto*//*Label 3662*/ GIMT_Encode4(184976), // Rule ID 11426 //
     /* 184944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
     /* 184952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 184958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 184961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184965 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1845:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UADDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 184965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_H),
     /* 184968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184970 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184972 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184974 */     GIR_RootConstrainSelectedInstOperands,
     /* 184975 */     // GIR_Coverage, 11426,
     /* 184975 */     GIR_EraseRootFromParent_Done,
     /* 184976 */   // Label 3662: @184976
     /* 184976 */   GIM_Try, /*On fail goto*//*Label 3663*/ GIMT_Encode4(185013), // Rule ID 11427 //
     /* 184981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
     /* 184989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 184998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185002 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1845:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UADDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 185002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_S),
     /* 185005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185009 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185011 */     GIR_RootConstrainSelectedInstOperands,
     /* 185012 */     // GIR_Coverage, 11427,
     /* 185012 */     GIR_EraseRootFromParent_Done,
     /* 185013 */   // Label 3663: @185013
     /* 185013 */   GIM_Try, /*On fail goto*//*Label 3664*/ GIMT_Encode4(185050), // Rule ID 11428 //
     /* 185018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
     /* 185026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 185035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185039 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1845:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UADDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 185039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_D),
     /* 185042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185046 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185048 */     GIR_RootConstrainSelectedInstOperands,
     /* 185049 */     // GIR_Coverage, 11428,
     /* 185049 */     GIR_EraseRootFromParent_Done,
     /* 185050 */   // Label 3664: @185050
     /* 185050 */   GIM_Try, /*On fail goto*//*Label 3665*/ GIMT_Encode4(185087), // Rule ID 11429 //
     /* 185055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
     /* 185063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 185069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 185072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185076 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1773:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 185076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_H),
     /* 185079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185083 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185085 */     GIR_RootConstrainSelectedInstOperands,
     /* 185086 */     // GIR_Coverage, 11429,
     /* 185086 */     GIR_EraseRootFromParent_Done,
     /* 185087 */   // Label 3665: @185087
     /* 185087 */   GIM_Try, /*On fail goto*//*Label 3666*/ GIMT_Encode4(185124), // Rule ID 11430 //
     /* 185092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
     /* 185100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 185109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185113 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1773:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 185113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_S),
     /* 185116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185120 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185122 */     GIR_RootConstrainSelectedInstOperands,
     /* 185123 */     // GIR_Coverage, 11430,
     /* 185123 */     GIR_EraseRootFromParent_Done,
     /* 185124 */   // Label 3666: @185124
     /* 185124 */   GIM_Try, /*On fail goto*//*Label 3667*/ GIMT_Encode4(185161), // Rule ID 11431 //
     /* 185129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
     /* 185137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 185146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185150 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1773:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 185150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_D),
     /* 185153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185155 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185157 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185159 */     GIR_RootConstrainSelectedInstOperands,
     /* 185160 */     // GIR_Coverage, 11431,
     /* 185160 */     GIR_EraseRootFromParent_Done,
     /* 185161 */   // Label 3667: @185161
     /* 185161 */   GIM_Try, /*On fail goto*//*Label 3668*/ GIMT_Encode4(185198), // Rule ID 11432 //
     /* 185166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
     /* 185174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 185180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 185183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185187 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1775:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 185187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_H),
     /* 185190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185194 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185196 */     GIR_RootConstrainSelectedInstOperands,
     /* 185197 */     // GIR_Coverage, 11432,
     /* 185197 */     GIR_EraseRootFromParent_Done,
     /* 185198 */   // Label 3668: @185198
     /* 185198 */   GIM_Try, /*On fail goto*//*Label 3669*/ GIMT_Encode4(185235), // Rule ID 11433 //
     /* 185203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
     /* 185211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 185220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185224 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1775:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 185224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_S),
     /* 185227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185231 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185233 */     GIR_RootConstrainSelectedInstOperands,
     /* 185234 */     // GIR_Coverage, 11433,
     /* 185234 */     GIR_EraseRootFromParent_Done,
     /* 185235 */   // Label 3669: @185235
     /* 185235 */   GIM_Try, /*On fail goto*//*Label 3670*/ GIMT_Encode4(185272), // Rule ID 11434 //
     /* 185240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
     /* 185248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 185257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185261 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1775:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 185261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_D),
     /* 185264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185268 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185270 */     GIR_RootConstrainSelectedInstOperands,
     /* 185271 */     // GIR_Coverage, 11434,
     /* 185271 */     GIR_EraseRootFromParent_Done,
     /* 185272 */   // Label 3670: @185272
     /* 185272 */   GIM_Try, /*On fail goto*//*Label 3671*/ GIMT_Encode4(185309), // Rule ID 11435 //
     /* 185277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
     /* 185285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 185291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 185294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185298 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1969:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 185298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_H),
     /* 185301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185305 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185307 */     GIR_RootConstrainSelectedInstOperands,
     /* 185308 */     // GIR_Coverage, 11435,
     /* 185308 */     GIR_EraseRootFromParent_Done,
     /* 185309 */   // Label 3671: @185309
     /* 185309 */   GIM_Try, /*On fail goto*//*Label 3672*/ GIMT_Encode4(185346), // Rule ID 11436 //
     /* 185314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
     /* 185322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 185331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185335 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1969:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 185335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_S),
     /* 185338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185342 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185344 */     GIR_RootConstrainSelectedInstOperands,
     /* 185345 */     // GIR_Coverage, 11436,
     /* 185345 */     GIR_EraseRootFromParent_Done,
     /* 185346 */   // Label 3672: @185346
     /* 185346 */   GIM_Try, /*On fail goto*//*Label 3673*/ GIMT_Encode4(185383), // Rule ID 11437 //
     /* 185351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
     /* 185359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 185368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185372 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1969:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 185372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_D),
     /* 185375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185379 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185381 */     GIR_RootConstrainSelectedInstOperands,
     /* 185382 */     // GIR_Coverage, 11437,
     /* 185382 */     GIR_EraseRootFromParent_Done,
     /* 185383 */   // Label 3673: @185383
     /* 185383 */   GIM_Try, /*On fail goto*//*Label 3674*/ GIMT_Encode4(185420), // Rule ID 11438 //
     /* 185388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
     /* 185396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 185402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 185405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185409 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1970:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 185409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_H),
     /* 185412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185414 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185416 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185418 */     GIR_RootConstrainSelectedInstOperands,
     /* 185419 */     // GIR_Coverage, 11438,
     /* 185419 */     GIR_EraseRootFromParent_Done,
     /* 185420 */   // Label 3674: @185420
     /* 185420 */   GIM_Try, /*On fail goto*//*Label 3675*/ GIMT_Encode4(185457), // Rule ID 11439 //
     /* 185425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
     /* 185433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 185442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185446 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1970:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 185446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_S),
     /* 185449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185453 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185455 */     GIR_RootConstrainSelectedInstOperands,
     /* 185456 */     // GIR_Coverage, 11439,
     /* 185456 */     GIR_EraseRootFromParent_Done,
     /* 185457 */   // Label 3675: @185457
     /* 185457 */   GIM_Try, /*On fail goto*//*Label 3676*/ GIMT_Encode4(185494), // Rule ID 11440 //
     /* 185462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
     /* 185470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 185479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185483 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1970:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 185483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_D),
     /* 185486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185490 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185492 */     GIR_RootConstrainSelectedInstOperands,
     /* 185493 */     // GIR_Coverage, 11440,
     /* 185493 */     GIR_EraseRootFromParent_Done,
     /* 185494 */   // Label 3676: @185494
     /* 185494 */   GIM_Try, /*On fail goto*//*Label 3677*/ GIMT_Encode4(185531), // Rule ID 11441 //
     /* 185499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
     /* 185507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 185513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 185516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185520 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1591:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SABDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 185520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_H),
     /* 185523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185525 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185527 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185529 */     GIR_RootConstrainSelectedInstOperands,
     /* 185530 */     // GIR_Coverage, 11441,
     /* 185530 */     GIR_EraseRootFromParent_Done,
     /* 185531 */   // Label 3677: @185531
     /* 185531 */   GIM_Try, /*On fail goto*//*Label 3678*/ GIMT_Encode4(185568), // Rule ID 11442 //
     /* 185536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
     /* 185544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 185553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185557 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1591:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SABDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 185557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_S),
     /* 185560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185564 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185566 */     GIR_RootConstrainSelectedInstOperands,
     /* 185567 */     // GIR_Coverage, 11442,
     /* 185567 */     GIR_EraseRootFromParent_Done,
     /* 185568 */   // Label 3678: @185568
     /* 185568 */   GIM_Try, /*On fail goto*//*Label 3679*/ GIMT_Encode4(185605), // Rule ID 11443 //
     /* 185573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
     /* 185581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 185590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185594 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1591:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SABDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 185594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_D),
     /* 185597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185601 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185603 */     GIR_RootConstrainSelectedInstOperands,
     /* 185604 */     // GIR_Coverage, 11443,
     /* 185604 */     GIR_EraseRootFromParent_Done,
     /* 185605 */   // Label 3679: @185605
     /* 185605 */   GIM_Try, /*On fail goto*//*Label 3680*/ GIMT_Encode4(185642), // Rule ID 11444 //
     /* 185610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
     /* 185618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 185624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 185627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185631 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1592:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SABDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 185631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_H),
     /* 185634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185638 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185640 */     GIR_RootConstrainSelectedInstOperands,
     /* 185641 */     // GIR_Coverage, 11444,
     /* 185641 */     GIR_EraseRootFromParent_Done,
     /* 185642 */   // Label 3680: @185642
     /* 185642 */   GIM_Try, /*On fail goto*//*Label 3681*/ GIMT_Encode4(185679), // Rule ID 11445 //
     /* 185647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
     /* 185655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 185664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185668 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1592:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SABDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 185668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_S),
     /* 185671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185675 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185677 */     GIR_RootConstrainSelectedInstOperands,
     /* 185678 */     // GIR_Coverage, 11445,
     /* 185678 */     GIR_EraseRootFromParent_Done,
     /* 185679 */   // Label 3681: @185679
     /* 185679 */   GIM_Try, /*On fail goto*//*Label 3682*/ GIMT_Encode4(185716), // Rule ID 11446 //
     /* 185684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
     /* 185692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 185701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185705 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1592:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SABDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 185705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_D),
     /* 185708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185710 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185712 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185714 */     GIR_RootConstrainSelectedInstOperands,
     /* 185715 */     // GIR_Coverage, 11446,
     /* 185715 */     GIR_EraseRootFromParent_Done,
     /* 185716 */   // Label 3682: @185716
     /* 185716 */   GIM_Try, /*On fail goto*//*Label 3683*/ GIMT_Encode4(185753), // Rule ID 11447 //
     /* 185721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
     /* 185729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 185735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 185738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185742 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1841:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UABDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 185742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_H),
     /* 185745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185749 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185751 */     GIR_RootConstrainSelectedInstOperands,
     /* 185752 */     // GIR_Coverage, 11447,
     /* 185752 */     GIR_EraseRootFromParent_Done,
     /* 185753 */   // Label 3683: @185753
     /* 185753 */   GIM_Try, /*On fail goto*//*Label 3684*/ GIMT_Encode4(185790), // Rule ID 11448 //
     /* 185758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
     /* 185766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 185775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185779 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1841:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UABDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 185779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_S),
     /* 185782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185784 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185786 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185788 */     GIR_RootConstrainSelectedInstOperands,
     /* 185789 */     // GIR_Coverage, 11448,
     /* 185789 */     GIR_EraseRootFromParent_Done,
     /* 185790 */   // Label 3684: @185790
     /* 185790 */   GIM_Try, /*On fail goto*//*Label 3685*/ GIMT_Encode4(185827), // Rule ID 11449 //
     /* 185795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
     /* 185803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 185812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185816 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1841:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UABDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 185816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_D),
     /* 185819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185823 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185825 */     GIR_RootConstrainSelectedInstOperands,
     /* 185826 */     // GIR_Coverage, 11449,
     /* 185826 */     GIR_EraseRootFromParent_Done,
     /* 185827 */   // Label 3685: @185827
     /* 185827 */   GIM_Try, /*On fail goto*//*Label 3686*/ GIMT_Encode4(185864), // Rule ID 11450 //
     /* 185832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
     /* 185840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 185846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 185849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185853 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1842:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UABDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 185853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_H),
     /* 185856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185858 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185860 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185862 */     GIR_RootConstrainSelectedInstOperands,
     /* 185863 */     // GIR_Coverage, 11450,
     /* 185863 */     GIR_EraseRootFromParent_Done,
     /* 185864 */   // Label 3686: @185864
     /* 185864 */   GIM_Try, /*On fail goto*//*Label 3687*/ GIMT_Encode4(185901), // Rule ID 11451 //
     /* 185869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
     /* 185877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 185886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185890 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1842:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UABDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 185890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_S),
     /* 185893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185897 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185899 */     GIR_RootConstrainSelectedInstOperands,
     /* 185900 */     // GIR_Coverage, 11451,
     /* 185900 */     GIR_EraseRootFromParent_Done,
     /* 185901 */   // Label 3687: @185901
     /* 185901 */   GIM_Try, /*On fail goto*//*Label 3688*/ GIMT_Encode4(185938), // Rule ID 11452 //
     /* 185906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
     /* 185914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 185923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185927 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1842:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UABDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 185927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_D),
     /* 185930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185934 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185936 */     GIR_RootConstrainSelectedInstOperands,
     /* 185937 */     // GIR_Coverage, 11452,
     /* 185937 */     GIR_EraseRootFromParent_Done,
     /* 185938 */   // Label 3688: @185938
     /* 185938 */   GIM_Try, /*On fail goto*//*Label 3689*/ GIMT_Encode4(185975), // Rule ID 11462 //
     /* 185943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
     /* 185951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 185960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185964 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1777:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBWB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 185964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_H),
     /* 185967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185971 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185973 */     GIR_RootConstrainSelectedInstOperands,
     /* 185974 */     // GIR_Coverage, 11462,
     /* 185974 */     GIR_EraseRootFromParent_Done,
     /* 185975 */   // Label 3689: @185975
     /* 185975 */   GIM_Try, /*On fail goto*//*Label 3690*/ GIMT_Encode4(186012), // Rule ID 11463 //
     /* 185980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
     /* 185988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 185997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186001 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1777:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBWB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 186001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_S),
     /* 186004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186006 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186008 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186010 */     GIR_RootConstrainSelectedInstOperands,
     /* 186011 */     // GIR_Coverage, 11463,
     /* 186011 */     GIR_EraseRootFromParent_Done,
     /* 186012 */   // Label 3690: @186012
     /* 186012 */   GIM_Try, /*On fail goto*//*Label 3691*/ GIMT_Encode4(186049), // Rule ID 11464 //
     /* 186017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
     /* 186025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 186028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 186031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186038 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1777:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBWB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 186038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_D),
     /* 186041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186045 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186047 */     GIR_RootConstrainSelectedInstOperands,
     /* 186048 */     // GIR_Coverage, 11464,
     /* 186048 */     GIR_EraseRootFromParent_Done,
     /* 186049 */   // Label 3691: @186049
     /* 186049 */   GIM_Try, /*On fail goto*//*Label 3692*/ GIMT_Encode4(186086), // Rule ID 11465 //
     /* 186054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
     /* 186062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 186065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 186068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 186071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186075 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1778:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBWT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 186075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_H),
     /* 186078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186080 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186082 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186084 */     GIR_RootConstrainSelectedInstOperands,
     /* 186085 */     // GIR_Coverage, 11465,
     /* 186085 */     GIR_EraseRootFromParent_Done,
     /* 186086 */   // Label 3692: @186086
     /* 186086 */   GIM_Try, /*On fail goto*//*Label 3693*/ GIMT_Encode4(186123), // Rule ID 11466 //
     /* 186091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
     /* 186099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 186105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 186108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186112 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1778:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBWT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 186112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_S),
     /* 186115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186119 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186121 */     GIR_RootConstrainSelectedInstOperands,
     /* 186122 */     // GIR_Coverage, 11466,
     /* 186122 */     GIR_EraseRootFromParent_Done,
     /* 186123 */   // Label 3693: @186123
     /* 186123 */   GIM_Try, /*On fail goto*//*Label 3694*/ GIMT_Encode4(186160), // Rule ID 11467 //
     /* 186128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
     /* 186136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 186139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 186142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186149 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1778:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBWT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 186149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_D),
     /* 186152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186154 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186156 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186158 */     GIR_RootConstrainSelectedInstOperands,
     /* 186159 */     // GIR_Coverage, 11467,
     /* 186159 */     GIR_EraseRootFromParent_Done,
     /* 186160 */   // Label 3694: @186160
     /* 186160 */   GIM_Try, /*On fail goto*//*Label 3695*/ GIMT_Encode4(186197), // Rule ID 11468 //
     /* 186165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
     /* 186173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 186176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 186179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 186182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186186 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1971:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBWB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 186186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_H),
     /* 186189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186191 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186193 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186195 */     GIR_RootConstrainSelectedInstOperands,
     /* 186196 */     // GIR_Coverage, 11468,
     /* 186196 */     GIR_EraseRootFromParent_Done,
     /* 186197 */   // Label 3695: @186197
     /* 186197 */   GIM_Try, /*On fail goto*//*Label 3696*/ GIMT_Encode4(186234), // Rule ID 11469 //
     /* 186202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
     /* 186210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 186216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 186219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186223 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1971:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBWB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 186223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_S),
     /* 186226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186230 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186232 */     GIR_RootConstrainSelectedInstOperands,
     /* 186233 */     // GIR_Coverage, 11469,
     /* 186233 */     GIR_EraseRootFromParent_Done,
     /* 186234 */   // Label 3696: @186234
     /* 186234 */   GIM_Try, /*On fail goto*//*Label 3697*/ GIMT_Encode4(186271), // Rule ID 11470 //
     /* 186239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
     /* 186247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 186250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 186253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186260 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1971:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBWB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 186260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_D),
     /* 186263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186265 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186267 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186269 */     GIR_RootConstrainSelectedInstOperands,
     /* 186270 */     // GIR_Coverage, 11470,
     /* 186270 */     GIR_EraseRootFromParent_Done,
     /* 186271 */   // Label 3697: @186271
     /* 186271 */   GIM_Try, /*On fail goto*//*Label 3698*/ GIMT_Encode4(186308), // Rule ID 11471 //
     /* 186276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
     /* 186284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 186287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 186290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 186293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186297 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1972:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBWT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 186297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_H),
     /* 186300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186306 */     GIR_RootConstrainSelectedInstOperands,
     /* 186307 */     // GIR_Coverage, 11471,
     /* 186307 */     GIR_EraseRootFromParent_Done,
     /* 186308 */   // Label 3698: @186308
     /* 186308 */   GIM_Try, /*On fail goto*//*Label 3699*/ GIMT_Encode4(186345), // Rule ID 11472 //
     /* 186313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
     /* 186321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 186327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 186330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186334 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1972:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBWT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 186334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_S),
     /* 186337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186339 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186341 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186343 */     GIR_RootConstrainSelectedInstOperands,
     /* 186344 */     // GIR_Coverage, 11472,
     /* 186344 */     GIR_EraseRootFromParent_Done,
     /* 186345 */   // Label 3699: @186345
     /* 186345 */   GIM_Try, /*On fail goto*//*Label 3700*/ GIMT_Encode4(186382), // Rule ID 11473 //
     /* 186350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
     /* 186358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 186361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 186364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186371 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1972:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBWT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 186371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_D),
     /* 186374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186378 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186380 */     GIR_RootConstrainSelectedInstOperands,
     /* 186381 */     // GIR_Coverage, 11473,
     /* 186381 */     GIR_EraseRootFromParent_Done,
     /* 186382 */   // Label 3700: @186382
     /* 186382 */   GIM_Try, /*On fail goto*//*Label 3701*/ GIMT_Encode4(186419), // Rule ID 11474 //
     /* 186387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
     /* 186395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 186398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 186401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 186404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186408 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1707:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 186408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_H),
     /* 186411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186415 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186417 */     GIR_RootConstrainSelectedInstOperands,
     /* 186418 */     // GIR_Coverage, 11474,
     /* 186418 */     GIR_EraseRootFromParent_Done,
     /* 186419 */   // Label 3701: @186419
     /* 186419 */   GIM_Try, /*On fail goto*//*Label 3702*/ GIMT_Encode4(186456), // Rule ID 11475 //
     /* 186424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
     /* 186432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 186438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 186441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186445 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1707:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 186445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_S),
     /* 186448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186450 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186452 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186454 */     GIR_RootConstrainSelectedInstOperands,
     /* 186455 */     // GIR_Coverage, 11475,
     /* 186455 */     GIR_EraseRootFromParent_Done,
     /* 186456 */   // Label 3702: @186456
     /* 186456 */   GIM_Try, /*On fail goto*//*Label 3703*/ GIMT_Encode4(186493), // Rule ID 11476 //
     /* 186461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
     /* 186469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 186472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 186475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186482 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1707:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 186482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_D),
     /* 186485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186489 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186491 */     GIR_RootConstrainSelectedInstOperands,
     /* 186492 */     // GIR_Coverage, 11476,
     /* 186492 */     GIR_EraseRootFromParent_Done,
     /* 186493 */   // Label 3703: @186493
     /* 186493 */   GIM_Try, /*On fail goto*//*Label 3704*/ GIMT_Encode4(186530), // Rule ID 11477 //
     /* 186498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
     /* 186506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 186509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 186512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 186515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186519 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1709:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 186519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_H),
     /* 186522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186526 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186528 */     GIR_RootConstrainSelectedInstOperands,
     /* 186529 */     // GIR_Coverage, 11477,
     /* 186529 */     GIR_EraseRootFromParent_Done,
     /* 186530 */   // Label 3704: @186530
     /* 186530 */   GIM_Try, /*On fail goto*//*Label 3705*/ GIMT_Encode4(186567), // Rule ID 11478 //
     /* 186535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
     /* 186543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 186549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 186552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186556 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1709:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 186556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_S),
     /* 186559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186563 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186565 */     GIR_RootConstrainSelectedInstOperands,
     /* 186566 */     // GIR_Coverage, 11478,
     /* 186566 */     GIR_EraseRootFromParent_Done,
     /* 186567 */   // Label 3705: @186567
     /* 186567 */   GIM_Try, /*On fail goto*//*Label 3706*/ GIMT_Encode4(186604), // Rule ID 11479 //
     /* 186572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
     /* 186580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 186583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 186586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186593 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1709:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 186593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_D),
     /* 186596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186602 */     GIR_RootConstrainSelectedInstOperands,
     /* 186603 */     // GIR_Coverage, 11479,
     /* 186603 */     GIR_EraseRootFromParent_Done,
     /* 186604 */   // Label 3706: @186604
     /* 186604 */   GIM_Try, /*On fail goto*//*Label 3707*/ GIMT_Encode4(186641), // Rule ID 11480 //
     /* 186609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
     /* 186617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 186620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 186623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 186626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186630 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1660:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 186630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_H),
     /* 186633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186637 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186639 */     GIR_RootConstrainSelectedInstOperands,
     /* 186640 */     // GIR_Coverage, 11480,
     /* 186640 */     GIR_EraseRootFromParent_Done,
     /* 186641 */   // Label 3707: @186641
     /* 186641 */   GIM_Try, /*On fail goto*//*Label 3708*/ GIMT_Encode4(186678), // Rule ID 11481 //
     /* 186646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
     /* 186654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 186660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 186663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186667 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1660:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 186667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_S),
     /* 186670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186674 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186676 */     GIR_RootConstrainSelectedInstOperands,
     /* 186677 */     // GIR_Coverage, 11481,
     /* 186677 */     GIR_EraseRootFromParent_Done,
     /* 186678 */   // Label 3708: @186678
     /* 186678 */   GIM_Try, /*On fail goto*//*Label 3709*/ GIMT_Encode4(186715), // Rule ID 11482 //
     /* 186683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
     /* 186691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 186694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 186697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186704 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1660:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 186704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_D),
     /* 186707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186711 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186713 */     GIR_RootConstrainSelectedInstOperands,
     /* 186714 */     // GIR_Coverage, 11482,
     /* 186714 */     GIR_EraseRootFromParent_Done,
     /* 186715 */   // Label 3709: @186715
     /* 186715 */   GIM_Try, /*On fail goto*//*Label 3710*/ GIMT_Encode4(186752), // Rule ID 11483 //
     /* 186720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
     /* 186728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 186731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 186734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 186737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186741 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1662:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 186741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_H),
     /* 186744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186746 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186748 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186750 */     GIR_RootConstrainSelectedInstOperands,
     /* 186751 */     // GIR_Coverage, 11483,
     /* 186751 */     GIR_EraseRootFromParent_Done,
     /* 186752 */   // Label 3710: @186752
     /* 186752 */   GIM_Try, /*On fail goto*//*Label 3711*/ GIMT_Encode4(186789), // Rule ID 11484 //
     /* 186757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
     /* 186765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 186771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 186774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186778 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1662:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 186778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_S),
     /* 186781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186785 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186787 */     GIR_RootConstrainSelectedInstOperands,
     /* 186788 */     // GIR_Coverage, 11484,
     /* 186788 */     GIR_EraseRootFromParent_Done,
     /* 186789 */   // Label 3711: @186789
     /* 186789 */   GIM_Try, /*On fail goto*//*Label 3712*/ GIMT_Encode4(186826), // Rule ID 11485 //
     /* 186794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
     /* 186802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 186805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 186808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186815 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1662:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 186815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_D),
     /* 186818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186822 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186824 */     GIR_RootConstrainSelectedInstOperands,
     /* 186825 */     // GIR_Coverage, 11485,
     /* 186825 */     GIR_EraseRootFromParent_Done,
     /* 186826 */   // Label 3712: @186826
     /* 186826 */   GIM_Try, /*On fail goto*//*Label 3713*/ GIMT_Encode4(186863), // Rule ID 11486 //
     /* 186831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
     /* 186839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 186842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 186845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 186848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186852 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1898:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 186852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_H),
     /* 186855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186861 */     GIR_RootConstrainSelectedInstOperands,
     /* 186862 */     // GIR_Coverage, 11486,
     /* 186862 */     GIR_EraseRootFromParent_Done,
     /* 186863 */   // Label 3713: @186863
     /* 186863 */   GIM_Try, /*On fail goto*//*Label 3714*/ GIMT_Encode4(186900), // Rule ID 11487 //
     /* 186868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
     /* 186876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 186882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 186885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186889 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1898:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 186889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_S),
     /* 186892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186894 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186896 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186898 */     GIR_RootConstrainSelectedInstOperands,
     /* 186899 */     // GIR_Coverage, 11487,
     /* 186899 */     GIR_EraseRootFromParent_Done,
     /* 186900 */   // Label 3714: @186900
     /* 186900 */   GIM_Try, /*On fail goto*//*Label 3715*/ GIMT_Encode4(186937), // Rule ID 11488 //
     /* 186905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
     /* 186913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 186916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 186919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186926 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1898:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 186926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_D),
     /* 186929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186931 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186933 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186935 */     GIR_RootConstrainSelectedInstOperands,
     /* 186936 */     // GIR_Coverage, 11488,
     /* 186936 */     GIR_EraseRootFromParent_Done,
     /* 186937 */   // Label 3715: @186937
     /* 186937 */   GIM_Try, /*On fail goto*//*Label 3716*/ GIMT_Encode4(186974), // Rule ID 11489 //
     /* 186942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
     /* 186950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 186953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 186956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 186959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186963 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1900:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 186963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_H),
     /* 186966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186970 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186972 */     GIR_RootConstrainSelectedInstOperands,
     /* 186973 */     // GIR_Coverage, 11489,
     /* 186973 */     GIR_EraseRootFromParent_Done,
     /* 186974 */   // Label 3716: @186974
     /* 186974 */   GIM_Try, /*On fail goto*//*Label 3717*/ GIMT_Encode4(187011), // Rule ID 11490 //
     /* 186979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
     /* 186987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 186993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 186996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187000 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1900:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 187000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_S),
     /* 187003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187007 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187009 */     GIR_RootConstrainSelectedInstOperands,
     /* 187010 */     // GIR_Coverage, 11490,
     /* 187010 */     GIR_EraseRootFromParent_Done,
     /* 187011 */   // Label 3717: @187011
     /* 187011 */   GIM_Try, /*On fail goto*//*Label 3718*/ GIMT_Encode4(187048), // Rule ID 11491 //
     /* 187016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
     /* 187024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 187027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187037 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1900:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_D),
     /* 187040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187044 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187046 */     GIR_RootConstrainSelectedInstOperands,
     /* 187047 */     // GIR_Coverage, 11491,
     /* 187047 */     GIR_EraseRootFromParent_Done,
     /* 187048 */   // Label 3718: @187048
     /* 187048 */   GIM_Try, /*On fail goto*//*Label 3719*/ GIMT_Encode4(187085), // Rule ID 11492 //
     /* 187053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
     /* 187061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 187064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 187067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 187070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187074 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1538:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMULLT_ZZZ_H:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 187074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_H),
     /* 187077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187083 */     GIR_RootConstrainSelectedInstOperands,
     /* 187084 */     // GIR_Coverage, 11492,
     /* 187084 */     GIR_EraseRootFromParent_Done,
     /* 187085 */   // Label 3719: @187085
     /* 187085 */   GIM_Try, /*On fail goto*//*Label 3720*/ GIMT_Encode4(187122), // Rule ID 11493 //
     /* 187090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
     /* 187098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187111 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1538:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (PMULLT_ZZZ_D:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_D),
     /* 187114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187118 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187120 */     GIR_RootConstrainSelectedInstOperands,
     /* 187121 */     // GIR_Coverage, 11493,
     /* 187121 */     GIR_EraseRootFromParent_Done,
     /* 187122 */   // Label 3720: @187122
     /* 187122 */   GIM_Try, /*On fail goto*//*Label 3721*/ GIMT_Encode4(187159), // Rule ID 11594 //
     /* 187127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
     /* 187135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 187138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 187141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187148 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1568:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (RADDHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 187148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_B),
     /* 187151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187155 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187157 */     GIR_RootConstrainSelectedInstOperands,
     /* 187158 */     // GIR_Coverage, 11594,
     /* 187158 */     GIR_EraseRootFromParent_Done,
     /* 187159 */   // Label 3721: @187159
     /* 187159 */   GIM_Try, /*On fail goto*//*Label 3722*/ GIMT_Encode4(187196), // Rule ID 11595 //
     /* 187164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
     /* 187172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 187175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187185 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1568:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (RADDHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_H),
     /* 187188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187194 */     GIR_RootConstrainSelectedInstOperands,
     /* 187195 */     // GIR_Coverage, 11595,
     /* 187195 */     GIR_EraseRootFromParent_Done,
     /* 187196 */   // Label 3722: @187196
     /* 187196 */   GIM_Try, /*On fail goto*//*Label 3723*/ GIMT_Encode4(187233), // Rule ID 11596 //
     /* 187201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
     /* 187209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 187215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 187218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187222 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1568:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RADDHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 187222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_S),
     /* 187225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187229 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187231 */     GIR_RootConstrainSelectedInstOperands,
     /* 187232 */     // GIR_Coverage, 11596,
     /* 187232 */     GIR_EraseRootFromParent_Done,
     /* 187233 */   // Label 3723: @187233
     /* 187233 */   GIM_Try, /*On fail goto*//*Label 3724*/ GIMT_Encode4(187270), // Rule ID 11597 //
     /* 187238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
     /* 187246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 187249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 187252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187259 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1809:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUBHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 187259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_B),
     /* 187262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187266 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187268 */     GIR_RootConstrainSelectedInstOperands,
     /* 187269 */     // GIR_Coverage, 11597,
     /* 187269 */     GIR_EraseRootFromParent_Done,
     /* 187270 */   // Label 3724: @187270
     /* 187270 */   GIM_Try, /*On fail goto*//*Label 3725*/ GIMT_Encode4(187307), // Rule ID 11598 //
     /* 187275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
     /* 187283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 187286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187296 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1809:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUBHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_H),
     /* 187299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187303 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187305 */     GIR_RootConstrainSelectedInstOperands,
     /* 187306 */     // GIR_Coverage, 11598,
     /* 187306 */     GIR_EraseRootFromParent_Done,
     /* 187307 */   // Label 3725: @187307
     /* 187307 */   GIM_Try, /*On fail goto*//*Label 3726*/ GIMT_Encode4(187344), // Rule ID 11599 //
     /* 187312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
     /* 187320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 187326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 187329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187333 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1809:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUBHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 187333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_S),
     /* 187336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187338 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187340 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187342 */     GIR_RootConstrainSelectedInstOperands,
     /* 187343 */     // GIR_Coverage, 11599,
     /* 187343 */     GIR_EraseRootFromParent_Done,
     /* 187344 */   // Label 3726: @187344
     /* 187344 */   GIM_Try, /*On fail goto*//*Label 3727*/ GIMT_Encode4(187381), // Rule ID 11600 //
     /* 187349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
     /* 187357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 187360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 187363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187370 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1584:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (RSUBHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 187370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_B),
     /* 187373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187375 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187377 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187379 */     GIR_RootConstrainSelectedInstOperands,
     /* 187380 */     // GIR_Coverage, 11600,
     /* 187380 */     GIR_EraseRootFromParent_Done,
     /* 187381 */   // Label 3727: @187381
     /* 187381 */   GIM_Try, /*On fail goto*//*Label 3728*/ GIMT_Encode4(187418), // Rule ID 11601 //
     /* 187386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
     /* 187394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 187397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187407 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1584:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (RSUBHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_H),
     /* 187410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187414 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187416 */     GIR_RootConstrainSelectedInstOperands,
     /* 187417 */     // GIR_Coverage, 11601,
     /* 187417 */     GIR_EraseRootFromParent_Done,
     /* 187418 */   // Label 3728: @187418
     /* 187418 */   GIM_Try, /*On fail goto*//*Label 3729*/ GIMT_Encode4(187455), // Rule ID 11602 //
     /* 187423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
     /* 187431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 187437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 187440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187444 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1584:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RSUBHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 187444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_S),
     /* 187447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187451 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187453 */     GIR_RootConstrainSelectedInstOperands,
     /* 187454 */     // GIR_Coverage, 11602,
     /* 187454 */     GIR_EraseRootFromParent_Done,
     /* 187455 */   // Label 3729: @187455
     /* 187455 */   GIM_Try, /*On fail goto*//*Label 3730*/ GIMT_Encode4(187492), // Rule ID 11618 //
     /* 187460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
     /* 187468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 187471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 187474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187481 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1951:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQXTNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 187481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_B),
     /* 187484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187488 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187490 */     GIR_RootConstrainSelectedInstOperands,
     /* 187491 */     // GIR_Coverage, 11618,
     /* 187491 */     GIR_EraseRootFromParent_Done,
     /* 187492 */   // Label 3730: @187492
     /* 187492 */   GIM_Try, /*On fail goto*//*Label 3731*/ GIMT_Encode4(187529), // Rule ID 11619 //
     /* 187497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
     /* 187505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 187508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 187511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187518 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1951:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQXTNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_H),
     /* 187521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187523 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187525 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187527 */     GIR_RootConstrainSelectedInstOperands,
     /* 187528 */     // GIR_Coverage, 11619,
     /* 187528 */     GIR_EraseRootFromParent_Done,
     /* 187529 */   // Label 3731: @187529
     /* 187529 */   GIM_Try, /*On fail goto*//*Label 3732*/ GIMT_Encode4(187566), // Rule ID 11620 //
     /* 187534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
     /* 187542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 187551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187555 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1951:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQXTNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 187555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_S),
     /* 187558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187562 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187564 */     GIR_RootConstrainSelectedInstOperands,
     /* 187565 */     // GIR_Coverage, 11620,
     /* 187565 */     GIR_EraseRootFromParent_Done,
     /* 187566 */   // Label 3732: @187566
     /* 187566 */   GIM_Try, /*On fail goto*//*Label 3733*/ GIMT_Encode4(187603), // Rule ID 11621 //
     /* 187571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
     /* 187579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 187582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 187585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187592 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1760:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQXTUNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 187592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_B),
     /* 187595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187599 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187601 */     GIR_RootConstrainSelectedInstOperands,
     /* 187602 */     // GIR_Coverage, 11621,
     /* 187602 */     GIR_EraseRootFromParent_Done,
     /* 187603 */   // Label 3733: @187603
     /* 187603 */   GIM_Try, /*On fail goto*//*Label 3734*/ GIMT_Encode4(187640), // Rule ID 11622 //
     /* 187608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
     /* 187616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 187619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 187622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187629 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1760:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQXTUNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_H),
     /* 187632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187636 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187638 */     GIR_RootConstrainSelectedInstOperands,
     /* 187639 */     // GIR_Coverage, 11622,
     /* 187639 */     GIR_EraseRootFromParent_Done,
     /* 187640 */   // Label 3734: @187640
     /* 187640 */   GIM_Try, /*On fail goto*//*Label 3735*/ GIMT_Encode4(187677), // Rule ID 11623 //
     /* 187645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
     /* 187653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 187662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187666 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1760:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQXTUNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 187666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_S),
     /* 187669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187673 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187675 */     GIR_RootConstrainSelectedInstOperands,
     /* 187676 */     // GIR_Coverage, 11623,
     /* 187676 */     GIR_EraseRootFromParent_Done,
     /* 187677 */   // Label 3735: @187677
     /* 187677 */   GIM_Try, /*On fail goto*//*Label 3736*/ GIMT_Encode4(187714), // Rule ID 11639 //
     /* 187682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
     /* 187690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 187693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 187696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 187699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187703 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1774:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 187703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_H),
     /* 187706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187710 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187712 */     GIR_RootConstrainSelectedInstOperands,
     /* 187713 */     // GIR_Coverage, 11639,
     /* 187713 */     GIR_EraseRootFromParent_Done,
     /* 187714 */   // Label 3736: @187714
     /* 187714 */   GIM_Try, /*On fail goto*//*Label 3737*/ GIMT_Encode4(187751), // Rule ID 11640 //
     /* 187719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
     /* 187727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 187733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187740 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1774:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 187740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_S),
     /* 187743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187747 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187749 */     GIR_RootConstrainSelectedInstOperands,
     /* 187750 */     // GIR_Coverage, 11640,
     /* 187750 */     GIR_EraseRootFromParent_Done,
     /* 187751 */   // Label 3737: @187751
     /* 187751 */   GIM_Try, /*On fail goto*//*Label 3738*/ GIMT_Encode4(187788), // Rule ID 11641 //
     /* 187756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
     /* 187764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 187767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187777 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1774:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_D),
     /* 187780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187786 */     GIR_RootConstrainSelectedInstOperands,
     /* 187787 */     // GIR_Coverage, 11641,
     /* 187787 */     GIR_EraseRootFromParent_Done,
     /* 187788 */   // Label 3738: @187788
     /* 187788 */   GIM_Try, /*On fail goto*//*Label 3739*/ GIMT_Encode4(187825), // Rule ID 11642 //
     /* 187793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
     /* 187801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 187804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 187807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 187810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187814 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1776:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLTB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 187814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_H),
     /* 187817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187821 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187823 */     GIR_RootConstrainSelectedInstOperands,
     /* 187824 */     // GIR_Coverage, 11642,
     /* 187824 */     GIR_EraseRootFromParent_Done,
     /* 187825 */   // Label 3739: @187825
     /* 187825 */   GIM_Try, /*On fail goto*//*Label 3740*/ GIMT_Encode4(187862), // Rule ID 11643 //
     /* 187830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
     /* 187838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 187844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187851 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1776:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLTB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 187851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_S),
     /* 187854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187858 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187860 */     GIR_RootConstrainSelectedInstOperands,
     /* 187861 */     // GIR_Coverage, 11643,
     /* 187861 */     GIR_EraseRootFromParent_Done,
     /* 187862 */   // Label 3740: @187862
     /* 187862 */   GIM_Try, /*On fail goto*//*Label 3741*/ GIMT_Encode4(187899), // Rule ID 11644 //
     /* 187867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
     /* 187875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 187878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187888 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1776:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLTB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_D),
     /* 187891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187895 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187897 */     GIR_RootConstrainSelectedInstOperands,
     /* 187898 */     // GIR_Coverage, 11644,
     /* 187898 */     GIR_EraseRootFromParent_Done,
     /* 187899 */   // Label 3741: @187899
     /* 187899 */   GIM_Try, /*On fail goto*//*Label 3742*/ GIMT_Encode4(187939), // Rule ID 11719 //
     /* 187904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 187912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 187915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 187918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 187921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 187925 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1996:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 187925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_B),
     /* 187928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 187930 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187932 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187934 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 187937 */     GIR_RootConstrainSelectedInstOperands,
     /* 187938 */     // GIR_Coverage, 11719,
     /* 187938 */     GIR_EraseRootFromParent_Done,
     /* 187939 */   // Label 3742: @187939
     /* 187939 */   GIM_Try, /*On fail goto*//*Label 3743*/ GIMT_Encode4(187979), // Rule ID 11720 //
     /* 187944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 187952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 187955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 187958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 187961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 187965 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1996:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 187965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_H),
     /* 187968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 187970 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187972 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187974 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 187977 */     GIR_RootConstrainSelectedInstOperands,
     /* 187978 */     // GIR_Coverage, 11720,
     /* 187978 */     GIR_EraseRootFromParent_Done,
     /* 187979 */   // Label 3743: @187979
     /* 187979 */   GIM_Try, /*On fail goto*//*Label 3744*/ GIMT_Encode4(188019), // Rule ID 11721 //
     /* 187984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 187987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 187992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 187995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 187998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188005 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1996:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_S),
     /* 188008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188010 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188012 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188014 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188017 */     GIR_RootConstrainSelectedInstOperands,
     /* 188018 */     // GIR_Coverage, 11721,
     /* 188018 */     GIR_EraseRootFromParent_Done,
     /* 188019 */   // Label 3744: @188019
     /* 188019 */   GIM_Try, /*On fail goto*//*Label 3745*/ GIMT_Encode4(188059), // Rule ID 11722 //
     /* 188024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 188032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 188035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188045 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1996:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_D),
     /* 188048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188052 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188054 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188057 */     GIR_RootConstrainSelectedInstOperands,
     /* 188058 */     // GIR_Coverage, 11722,
     /* 188058 */     GIR_EraseRootFromParent_Done,
     /* 188059 */   // Label 3745: @188059
     /* 188059 */   GIM_Try, /*On fail goto*//*Label 3746*/ GIMT_Encode4(188099), // Rule ID 11723 //
     /* 188064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 188072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 188075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188085 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2002:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_B),
     /* 188088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188092 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188094 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188097 */     GIR_RootConstrainSelectedInstOperands,
     /* 188098 */     // GIR_Coverage, 11723,
     /* 188098 */     GIR_EraseRootFromParent_Done,
     /* 188099 */   // Label 3746: @188099
     /* 188099 */   GIM_Try, /*On fail goto*//*Label 3747*/ GIMT_Encode4(188139), // Rule ID 11724 //
     /* 188104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 188112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 188115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188125 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2002:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_H),
     /* 188128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188130 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188132 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188134 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188137 */     GIR_RootConstrainSelectedInstOperands,
     /* 188138 */     // GIR_Coverage, 11724,
     /* 188138 */     GIR_EraseRootFromParent_Done,
     /* 188139 */   // Label 3747: @188139
     /* 188139 */   GIM_Try, /*On fail goto*//*Label 3748*/ GIMT_Encode4(188179), // Rule ID 11725 //
     /* 188144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 188152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 188155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188165 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2002:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_S),
     /* 188168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188170 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188172 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188174 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188177 */     GIR_RootConstrainSelectedInstOperands,
     /* 188178 */     // GIR_Coverage, 11725,
     /* 188178 */     GIR_EraseRootFromParent_Done,
     /* 188179 */   // Label 3748: @188179
     /* 188179 */   GIM_Try, /*On fail goto*//*Label 3749*/ GIMT_Encode4(188219), // Rule ID 11726 //
     /* 188184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 188192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 188195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188205 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2002:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_D),
     /* 188208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188210 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188212 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188214 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188217 */     GIR_RootConstrainSelectedInstOperands,
     /* 188218 */     // GIR_Coverage, 11726,
     /* 188218 */     GIR_EraseRootFromParent_Done,
     /* 188219 */   // Label 3749: @188219
     /* 188219 */   GIM_Try, /*On fail goto*//*Label 3750*/ GIMT_Encode4(188259), // Rule ID 11731 //
     /* 188224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 188232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 188235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188245 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2014:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_B),
     /* 188248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188252 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188254 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188257 */     GIR_RootConstrainSelectedInstOperands,
     /* 188258 */     // GIR_Coverage, 11731,
     /* 188258 */     GIR_EraseRootFromParent_Done,
     /* 188259 */   // Label 3750: @188259
     /* 188259 */   GIM_Try, /*On fail goto*//*Label 3751*/ GIMT_Encode4(188299), // Rule ID 11732 //
     /* 188264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 188272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 188275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188285 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2014:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_H),
     /* 188288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188292 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188294 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188297 */     GIR_RootConstrainSelectedInstOperands,
     /* 188298 */     // GIR_Coverage, 11732,
     /* 188298 */     GIR_EraseRootFromParent_Done,
     /* 188299 */   // Label 3751: @188299
     /* 188299 */   GIM_Try, /*On fail goto*//*Label 3752*/ GIMT_Encode4(188339), // Rule ID 11733 //
     /* 188304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 188312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 188315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188325 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2014:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_S),
     /* 188328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188330 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188332 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188334 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188337 */     GIR_RootConstrainSelectedInstOperands,
     /* 188338 */     // GIR_Coverage, 11733,
     /* 188338 */     GIR_EraseRootFromParent_Done,
     /* 188339 */   // Label 3752: @188339
     /* 188339 */   GIM_Try, /*On fail goto*//*Label 3753*/ GIMT_Encode4(188379), // Rule ID 11734 //
     /* 188344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 188352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 188355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188365 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2014:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_D),
     /* 188368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188372 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188374 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188377 */     GIR_RootConstrainSelectedInstOperands,
     /* 188378 */     // GIR_Coverage, 11734,
     /* 188378 */     GIR_EraseRootFromParent_Done,
     /* 188379 */   // Label 3753: @188379
     /* 188379 */   GIM_Try, /*On fail goto*//*Label 3754*/ GIMT_Encode4(188419), // Rule ID 11735 //
     /* 188384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 188392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 188395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188405 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2008:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_B),
     /* 188408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188410 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188412 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188414 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188417 */     GIR_RootConstrainSelectedInstOperands,
     /* 188418 */     // GIR_Coverage, 11735,
     /* 188418 */     GIR_EraseRootFromParent_Done,
     /* 188419 */   // Label 3754: @188419
     /* 188419 */   GIM_Try, /*On fail goto*//*Label 3755*/ GIMT_Encode4(188459), // Rule ID 11736 //
     /* 188424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 188432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 188435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188445 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2008:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_H),
     /* 188448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188450 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188452 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188454 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188457 */     GIR_RootConstrainSelectedInstOperands,
     /* 188458 */     // GIR_Coverage, 11736,
     /* 188458 */     GIR_EraseRootFromParent_Done,
     /* 188459 */   // Label 3755: @188459
     /* 188459 */   GIM_Try, /*On fail goto*//*Label 3756*/ GIMT_Encode4(188499), // Rule ID 11737 //
     /* 188464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 188472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 188475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188485 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2008:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_S),
     /* 188488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188490 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188492 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188494 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188497 */     GIR_RootConstrainSelectedInstOperands,
     /* 188498 */     // GIR_Coverage, 11737,
     /* 188498 */     GIR_EraseRootFromParent_Done,
     /* 188499 */   // Label 3756: @188499
     /* 188499 */   GIM_Try, /*On fail goto*//*Label 3757*/ GIMT_Encode4(188539), // Rule ID 11738 //
     /* 188504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 188512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 188515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188525 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2008:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_D),
     /* 188528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188532 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188534 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188537 */     GIR_RootConstrainSelectedInstOperands,
     /* 188538 */     // GIR_Coverage, 11738,
     /* 188538 */     GIR_EraseRootFromParent_Done,
     /* 188539 */   // Label 3757: @188539
     /* 188539 */   GIM_Try, /*On fail goto*//*Label 3758*/ GIMT_Encode4(188579), // Rule ID 11743 //
     /* 188544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 188552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 188555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188565 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1996:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_B),
     /* 188568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188570 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188572 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188574 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188577 */     GIR_RootConstrainSelectedInstOperands,
     /* 188578 */     // GIR_Coverage, 11743,
     /* 188578 */     GIR_EraseRootFromParent_Done,
     /* 188579 */   // Label 3758: @188579
     /* 188579 */   GIM_Try, /*On fail goto*//*Label 3759*/ GIMT_Encode4(188619), // Rule ID 11744 //
     /* 188584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 188592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 188595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188605 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1996:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_H),
     /* 188608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188614 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188617 */     GIR_RootConstrainSelectedInstOperands,
     /* 188618 */     // GIR_Coverage, 11744,
     /* 188618 */     GIR_EraseRootFromParent_Done,
     /* 188619 */   // Label 3759: @188619
     /* 188619 */   GIM_Try, /*On fail goto*//*Label 3760*/ GIMT_Encode4(188659), // Rule ID 11745 //
     /* 188624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 188632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 188635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188645 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1996:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_S),
     /* 188648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188650 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188652 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188654 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188657 */     GIR_RootConstrainSelectedInstOperands,
     /* 188658 */     // GIR_Coverage, 11745,
     /* 188658 */     GIR_EraseRootFromParent_Done,
     /* 188659 */   // Label 3760: @188659
     /* 188659 */   GIM_Try, /*On fail goto*//*Label 3761*/ GIMT_Encode4(188699), // Rule ID 11746 //
     /* 188664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 188672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 188675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188685 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1996:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_D),
     /* 188688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188690 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188692 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188694 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188697 */     GIR_RootConstrainSelectedInstOperands,
     /* 188698 */     // GIR_Coverage, 11746,
     /* 188698 */     GIR_EraseRootFromParent_Done,
     /* 188699 */   // Label 3761: @188699
     /* 188699 */   GIM_Try, /*On fail goto*//*Label 3762*/ GIMT_Encode4(188739), // Rule ID 11747 //
     /* 188704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 188712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 188715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188725 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2002:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_B),
     /* 188728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188732 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188734 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188737 */     GIR_RootConstrainSelectedInstOperands,
     /* 188738 */     // GIR_Coverage, 11747,
     /* 188738 */     GIR_EraseRootFromParent_Done,
     /* 188739 */   // Label 3762: @188739
     /* 188739 */   GIM_Try, /*On fail goto*//*Label 3763*/ GIMT_Encode4(188779), // Rule ID 11748 //
     /* 188744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 188752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 188755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188765 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2002:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_H),
     /* 188768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188772 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188774 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188777 */     GIR_RootConstrainSelectedInstOperands,
     /* 188778 */     // GIR_Coverage, 11748,
     /* 188778 */     GIR_EraseRootFromParent_Done,
     /* 188779 */   // Label 3763: @188779
     /* 188779 */   GIM_Try, /*On fail goto*//*Label 3764*/ GIMT_Encode4(188819), // Rule ID 11749 //
     /* 188784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 188792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 188795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188805 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2002:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_S),
     /* 188808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188812 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188814 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188817 */     GIR_RootConstrainSelectedInstOperands,
     /* 188818 */     // GIR_Coverage, 11749,
     /* 188818 */     GIR_EraseRootFromParent_Done,
     /* 188819 */   // Label 3764: @188819
     /* 188819 */   GIM_Try, /*On fail goto*//*Label 3765*/ GIMT_Encode4(188859), // Rule ID 11750 //
     /* 188824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 188832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 188835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188845 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2002:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_D),
     /* 188848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188852 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188854 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188857 */     GIR_RootConstrainSelectedInstOperands,
     /* 188858 */     // GIR_Coverage, 11750,
     /* 188858 */     GIR_EraseRootFromParent_Done,
     /* 188859 */   // Label 3765: @188859
     /* 188859 */   GIM_Try, /*On fail goto*//*Label 3766*/ GIMT_Encode4(188899), // Rule ID 11755 //
     /* 188864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 188872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 188875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188885 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2014:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_B),
     /* 188888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188890 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188892 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188894 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188897 */     GIR_RootConstrainSelectedInstOperands,
     /* 188898 */     // GIR_Coverage, 11755,
     /* 188898 */     GIR_EraseRootFromParent_Done,
     /* 188899 */   // Label 3766: @188899
     /* 188899 */   GIM_Try, /*On fail goto*//*Label 3767*/ GIMT_Encode4(188939), // Rule ID 11756 //
     /* 188904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 188912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 188915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188925 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2014:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_H),
     /* 188928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188930 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188932 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188934 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188937 */     GIR_RootConstrainSelectedInstOperands,
     /* 188938 */     // GIR_Coverage, 11756,
     /* 188938 */     GIR_EraseRootFromParent_Done,
     /* 188939 */   // Label 3767: @188939
     /* 188939 */   GIM_Try, /*On fail goto*//*Label 3768*/ GIMT_Encode4(188979), // Rule ID 11757 //
     /* 188944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 188952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 188955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188965 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2014:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_S),
     /* 188968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188970 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188972 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188974 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188977 */     GIR_RootConstrainSelectedInstOperands,
     /* 188978 */     // GIR_Coverage, 11757,
     /* 188978 */     GIR_EraseRootFromParent_Done,
     /* 188979 */   // Label 3768: @188979
     /* 188979 */   GIM_Try, /*On fail goto*//*Label 3769*/ GIMT_Encode4(189019), // Rule ID 11758 //
     /* 188984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 188987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 188992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 188995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 189001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189005 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2014:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 189005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_D),
     /* 189008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189010 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189012 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189014 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189017 */     GIR_RootConstrainSelectedInstOperands,
     /* 189018 */     // GIR_Coverage, 11758,
     /* 189018 */     GIR_EraseRootFromParent_Done,
     /* 189019 */   // Label 3769: @189019
     /* 189019 */   GIM_Try, /*On fail goto*//*Label 3770*/ GIMT_Encode4(189059), // Rule ID 11759 //
     /* 189024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 189027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 189032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 189035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 189038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 189041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189045 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2008:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 189045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_B),
     /* 189048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189052 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189054 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189057 */     GIR_RootConstrainSelectedInstOperands,
     /* 189058 */     // GIR_Coverage, 11759,
     /* 189058 */     GIR_EraseRootFromParent_Done,
     /* 189059 */   // Label 3770: @189059
     /* 189059 */   GIM_Try, /*On fail goto*//*Label 3771*/ GIMT_Encode4(189099), // Rule ID 11760 //
     /* 189064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 189067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 189072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 189075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 189078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 189081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189085 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2008:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 189085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_H),
     /* 189088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189092 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189094 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189097 */     GIR_RootConstrainSelectedInstOperands,
     /* 189098 */     // GIR_Coverage, 11760,
     /* 189098 */     GIR_EraseRootFromParent_Done,
     /* 189099 */   // Label 3771: @189099
     /* 189099 */   GIM_Try, /*On fail goto*//*Label 3772*/ GIMT_Encode4(189139), // Rule ID 11761 //
     /* 189104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 189107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 189112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 189115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 189118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 189121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189125 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2008:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 189125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_S),
     /* 189128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189130 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189132 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189134 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189137 */     GIR_RootConstrainSelectedInstOperands,
     /* 189138 */     // GIR_Coverage, 11761,
     /* 189138 */     GIR_EraseRootFromParent_Done,
     /* 189139 */   // Label 3772: @189139
     /* 189139 */   GIM_Try, /*On fail goto*//*Label 3773*/ GIMT_Encode4(189179), // Rule ID 11762 //
     /* 189144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 189147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 189152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 189155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 189158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 189161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189165 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2008:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 189165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_D),
     /* 189168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189170 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189172 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189174 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189177 */     GIR_RootConstrainSelectedInstOperands,
     /* 189178 */     // GIR_Coverage, 11762,
     /* 189178 */     GIR_EraseRootFromParent_Done,
     /* 189179 */   // Label 3773: @189179
     /* 189179 */   GIM_Try, /*On fail goto*//*Label 3774*/ GIMT_Encode4(189216), // Rule ID 11771 //
     /* 189184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 189187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesd),
     /* 189192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 189195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 189198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 189201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189205 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1164:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (AESD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 189205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESD_ZZZ_B),
     /* 189208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 189210 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189212 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189214 */     GIR_RootConstrainSelectedInstOperands,
     /* 189215 */     // GIR_Coverage, 11771,
     /* 189215 */     GIR_EraseRootFromParent_Done,
     /* 189216 */   // Label 3774: @189216
     /* 189216 */   GIM_Try, /*On fail goto*//*Label 3775*/ GIMT_Encode4(189253), // Rule ID 11773 //
     /* 189221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 189224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
     /* 189229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 189232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 189235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 189238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189242 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1538:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (PMULLT_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 189242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_Q),
     /* 189245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189251 */     GIR_RootConstrainSelectedInstOperands,
     /* 189252 */     // GIR_Coverage, 11773,
     /* 189252 */     GIR_EraseRootFromParent_Done,
     /* 189253 */   // Label 3775: @189253
     /* 189253 */   GIM_Try, /*On fail goto*//*Label 3776*/ GIMT_Encode4(189290), // Rule ID 11774 //
     /* 189258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2SM4),
     /* 189261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sm4e),
     /* 189266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 189269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 189272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 189275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189279 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1629:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SM4E_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 189279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4E_ZZZ_S),
     /* 189282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 189284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189288 */     GIR_RootConstrainSelectedInstOperands,
     /* 189289 */     // GIR_Coverage, 11774,
     /* 189289 */     GIR_EraseRootFromParent_Done,
     /* 189290 */   // Label 3776: @189290
     /* 189290 */   GIM_Try, /*On fail goto*//*Label 3777*/ GIMT_Encode4(189327), // Rule ID 11775 //
     /* 189295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2SHA3),
     /* 189298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rax1),
     /* 189303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 189306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 189309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 189312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189316 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1570:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RAX1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 189316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RAX1_ZZZ_D),
     /* 189319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189323 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189325 */     GIR_RootConstrainSelectedInstOperands,
     /* 189326 */     // GIR_Coverage, 11775,
     /* 189326 */     GIR_EraseRootFromParent_Done,
     /* 189327 */   // Label 3777: @189327
     /* 189327 */   GIM_Try, /*On fail goto*//*Label 3778*/ GIMT_Encode4(189364), // Rule ID 11776 //
     /* 189332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 189335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 189340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 189343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 189346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 189349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189353 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1178:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BDEP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 189353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_B),
     /* 189356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189362 */     GIR_RootConstrainSelectedInstOperands,
     /* 189363 */     // GIR_Coverage, 11776,
     /* 189363 */     GIR_EraseRootFromParent_Done,
     /* 189364 */   // Label 3778: @189364
     /* 189364 */   GIM_Try, /*On fail goto*//*Label 3779*/ GIMT_Encode4(189401), // Rule ID 11777 //
     /* 189369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 189372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 189377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 189380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 189383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 189386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189390 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1178:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BDEP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 189390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_H),
     /* 189393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189397 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189399 */     GIR_RootConstrainSelectedInstOperands,
     /* 189400 */     // GIR_Coverage, 11777,
     /* 189400 */     GIR_EraseRootFromParent_Done,
     /* 189401 */   // Label 3779: @189401
     /* 189401 */   GIM_Try, /*On fail goto*//*Label 3780*/ GIMT_Encode4(189438), // Rule ID 11778 //
     /* 189406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 189409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 189414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 189417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 189420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 189423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189427 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1178:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BDEP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 189427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_S),
     /* 189430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189432 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189434 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189436 */     GIR_RootConstrainSelectedInstOperands,
     /* 189437 */     // GIR_Coverage, 11778,
     /* 189437 */     GIR_EraseRootFromParent_Done,
     /* 189438 */   // Label 3780: @189438
     /* 189438 */   GIM_Try, /*On fail goto*//*Label 3781*/ GIMT_Encode4(189475), // Rule ID 11779 //
     /* 189443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 189446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 189451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 189454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 189457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 189460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189464 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1178:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BDEP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 189464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_D),
     /* 189467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189471 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189473 */     GIR_RootConstrainSelectedInstOperands,
     /* 189474 */     // GIR_Coverage, 11779,
     /* 189474 */     GIR_EraseRootFromParent_Done,
     /* 189475 */   // Label 3781: @189475
     /* 189475 */   GIM_Try, /*On fail goto*//*Label 3782*/ GIMT_Encode4(189512), // Rule ID 11780 //
     /* 189480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 189483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 189488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 189491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 189494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 189497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189501 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1195:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BGRP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 189501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_B),
     /* 189504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189506 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189508 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189510 */     GIR_RootConstrainSelectedInstOperands,
     /* 189511 */     // GIR_Coverage, 11780,
     /* 189511 */     GIR_EraseRootFromParent_Done,
     /* 189512 */   // Label 3782: @189512
     /* 189512 */   GIM_Try, /*On fail goto*//*Label 3783*/ GIMT_Encode4(189549), // Rule ID 11781 //
     /* 189517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 189520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 189525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 189528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 189531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 189534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189538 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1195:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BGRP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 189538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_H),
     /* 189541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189545 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189547 */     GIR_RootConstrainSelectedInstOperands,
     /* 189548 */     // GIR_Coverage, 11781,
     /* 189548 */     GIR_EraseRootFromParent_Done,
     /* 189549 */   // Label 3783: @189549
     /* 189549 */   GIM_Try, /*On fail goto*//*Label 3784*/ GIMT_Encode4(189586), // Rule ID 11782 //
     /* 189554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 189557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 189562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 189565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 189568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 189571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189575 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1195:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BGRP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 189575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_S),
     /* 189578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189580 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189582 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189584 */     GIR_RootConstrainSelectedInstOperands,
     /* 189585 */     // GIR_Coverage, 11782,
     /* 189585 */     GIR_EraseRootFromParent_Done,
     /* 189586 */   // Label 3784: @189586
     /* 189586 */   GIM_Try, /*On fail goto*//*Label 3785*/ GIMT_Encode4(189623), // Rule ID 11783 //
     /* 189591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 189594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 189599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 189602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 189605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 189608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189612 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1195:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BGRP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 189612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_D),
     /* 189615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189619 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189621 */     GIR_RootConstrainSelectedInstOperands,
     /* 189622 */     // GIR_Coverage, 11783,
     /* 189622 */     GIR_EraseRootFromParent_Done,
     /* 189623 */   // Label 3785: @189623
     /* 189623 */   GIM_Try, /*On fail goto*//*Label 3786*/ GIMT_Encode4(189660), // Rule ID 11896 //
     /* 189628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 189631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
     /* 189636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 189639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 189642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 189645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189649 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1344:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMAXNMQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 189649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_H),
     /* 189652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 189654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189656 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189658 */     GIR_RootConstrainSelectedInstOperands,
     /* 189659 */     // GIR_Coverage, 11896,
     /* 189659 */     GIR_EraseRootFromParent_Done,
     /* 189660 */   // Label 3786: @189660
     /* 189660 */   GIM_Try, /*On fail goto*//*Label 3787*/ GIMT_Encode4(189697), // Rule ID 11897 //
     /* 189665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 189668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
     /* 189673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 189676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 189679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 189682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189686 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1344:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMAXNMQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 189686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_S),
     /* 189689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 189691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189693 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189695 */     GIR_RootConstrainSelectedInstOperands,
     /* 189696 */     // GIR_Coverage, 11897,
     /* 189696 */     GIR_EraseRootFromParent_Done,
     /* 189697 */   // Label 3787: @189697
     /* 189697 */   GIM_Try, /*On fail goto*//*Label 3788*/ GIMT_Encode4(189734), // Rule ID 11898 //
     /* 189702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 189705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
     /* 189710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 189713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 189716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 189719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189723 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1344:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMAXNMQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 189723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_D),
     /* 189726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 189728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189732 */     GIR_RootConstrainSelectedInstOperands,
     /* 189733 */     // GIR_Coverage, 11898,
     /* 189733 */     GIR_EraseRootFromParent_Done,
     /* 189734 */   // Label 3788: @189734
     /* 189734 */   GIM_Try, /*On fail goto*//*Label 3789*/ GIMT_Encode4(189771), // Rule ID 11899 //
     /* 189739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 189742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
     /* 189747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 189750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 189753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 189756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189760 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1362:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMINNMQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 189760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_H),
     /* 189763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 189765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189767 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189769 */     GIR_RootConstrainSelectedInstOperands,
     /* 189770 */     // GIR_Coverage, 11899,
     /* 189770 */     GIR_EraseRootFromParent_Done,
     /* 189771 */   // Label 3789: @189771
     /* 189771 */   GIM_Try, /*On fail goto*//*Label 3790*/ GIMT_Encode4(189808), // Rule ID 11900 //
     /* 189776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 189779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
     /* 189784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 189787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 189790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 189793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189797 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1362:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMINNMQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 189797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_S),
     /* 189800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 189802 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189804 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189806 */     GIR_RootConstrainSelectedInstOperands,
     /* 189807 */     // GIR_Coverage, 11900,
     /* 189807 */     GIR_EraseRootFromParent_Done,
     /* 189808 */   // Label 3790: @189808
     /* 189808 */   GIM_Try, /*On fail goto*//*Label 3791*/ GIMT_Encode4(189845), // Rule ID 11901 //
     /* 189813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 189816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
     /* 189821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 189824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 189827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 189830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189834 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1362:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMINNMQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 189834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_D),
     /* 189837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 189839 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189841 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189843 */     GIR_RootConstrainSelectedInstOperands,
     /* 189844 */     // GIR_Coverage, 11901,
     /* 189844 */     GIR_EraseRootFromParent_Done,
     /* 189845 */   // Label 3791: @189845
     /* 189845 */   GIM_Try, /*On fail goto*//*Label 3792*/ GIMT_Encode4(189882), // Rule ID 11902 //
     /* 189850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 189853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
     /* 189858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 189861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 189864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 189867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189871 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1347:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMAXQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 189871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_H),
     /* 189874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 189876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189878 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189880 */     GIR_RootConstrainSelectedInstOperands,
     /* 189881 */     // GIR_Coverage, 11902,
     /* 189881 */     GIR_EraseRootFromParent_Done,
     /* 189882 */   // Label 3792: @189882
     /* 189882 */   GIM_Try, /*On fail goto*//*Label 3793*/ GIMT_Encode4(189919), // Rule ID 11903 //
     /* 189887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 189890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
     /* 189895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 189898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 189901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 189904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189908 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1347:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMAXQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 189908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_S),
     /* 189911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 189913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189915 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189917 */     GIR_RootConstrainSelectedInstOperands,
     /* 189918 */     // GIR_Coverage, 11903,
     /* 189918 */     GIR_EraseRootFromParent_Done,
     /* 189919 */   // Label 3793: @189919
     /* 189919 */   GIM_Try, /*On fail goto*//*Label 3794*/ GIMT_Encode4(189956), // Rule ID 11904 //
     /* 189924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 189927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
     /* 189932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 189935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 189938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 189941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189945 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1347:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMAXQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 189945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_D),
     /* 189948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 189950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189952 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189954 */     GIR_RootConstrainSelectedInstOperands,
     /* 189955 */     // GIR_Coverage, 11904,
     /* 189955 */     GIR_EraseRootFromParent_Done,
     /* 189956 */   // Label 3794: @189956
     /* 189956 */   GIM_Try, /*On fail goto*//*Label 3795*/ GIMT_Encode4(189993), // Rule ID 11905 //
     /* 189961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 189964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
     /* 189969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 189972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 189975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 189978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189982 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1365:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMINQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 189982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_H),
     /* 189985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 189987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189989 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189991 */     GIR_RootConstrainSelectedInstOperands,
     /* 189992 */     // GIR_Coverage, 11905,
     /* 189992 */     GIR_EraseRootFromParent_Done,
     /* 189993 */   // Label 3795: @189993
     /* 189993 */   GIM_Try, /*On fail goto*//*Label 3796*/ GIMT_Encode4(190030), // Rule ID 11906 //
     /* 189998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
     /* 190006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 190009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 190012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190019 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1365:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMINQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 190019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_S),
     /* 190022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190024 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190026 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190028 */     GIR_RootConstrainSelectedInstOperands,
     /* 190029 */     // GIR_Coverage, 11906,
     /* 190029 */     GIR_EraseRootFromParent_Done,
     /* 190030 */   // Label 3796: @190030
     /* 190030 */   GIM_Try, /*On fail goto*//*Label 3797*/ GIMT_Encode4(190067), // Rule ID 11907 //
     /* 190035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
     /* 190043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 190046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 190049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190056 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1365:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMINQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 190056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_D),
     /* 190059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190063 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190065 */     GIR_RootConstrainSelectedInstOperands,
     /* 190066 */     // GIR_Coverage, 11907,
     /* 190066 */     GIR_EraseRootFromParent_Done,
     /* 190067 */   // Label 3797: @190067
     /* 190067 */   GIM_Try, /*On fail goto*//*Label 3798*/ GIMT_Encode4(190104), // Rule ID 11908 //
     /* 190072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 190080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 190083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 190086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 190089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190093 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1259:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (EORQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 190093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_B),
     /* 190096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190100 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190102 */     GIR_RootConstrainSelectedInstOperands,
     /* 190103 */     // GIR_Coverage, 11908,
     /* 190103 */     GIR_EraseRootFromParent_Done,
     /* 190104 */   // Label 3798: @190104
     /* 190104 */   GIM_Try, /*On fail goto*//*Label 3799*/ GIMT_Encode4(190141), // Rule ID 11909 //
     /* 190109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 190117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 190120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 190123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190130 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1259:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (EORQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 190130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_H),
     /* 190133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190137 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190139 */     GIR_RootConstrainSelectedInstOperands,
     /* 190140 */     // GIR_Coverage, 11909,
     /* 190140 */     GIR_EraseRootFromParent_Done,
     /* 190141 */   // Label 3799: @190141
     /* 190141 */   GIM_Try, /*On fail goto*//*Label 3800*/ GIMT_Encode4(190178), // Rule ID 11910 //
     /* 190146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 190154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 190157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 190160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190167 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1259:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (EORQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 190167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_S),
     /* 190170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190174 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190176 */     GIR_RootConstrainSelectedInstOperands,
     /* 190177 */     // GIR_Coverage, 11910,
     /* 190177 */     GIR_EraseRootFromParent_Done,
     /* 190178 */   // Label 3800: @190178
     /* 190178 */   GIM_Try, /*On fail goto*//*Label 3801*/ GIMT_Encode4(190215), // Rule ID 11911 //
     /* 190183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 190191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 190194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 190197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190204 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1259:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (EORQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 190204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_D),
     /* 190207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190211 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190213 */     GIR_RootConstrainSelectedInstOperands,
     /* 190214 */     // GIR_Coverage, 11911,
     /* 190214 */     GIR_EraseRootFromParent_Done,
     /* 190215 */   // Label 3801: @190215
     /* 190215 */   GIM_Try, /*On fail goto*//*Label 3802*/ GIMT_Encode4(190252), // Rule ID 11912 //
     /* 190220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 190228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 190231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 190234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 190237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190241 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1171:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ANDQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 190241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_B),
     /* 190244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190248 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190250 */     GIR_RootConstrainSelectedInstOperands,
     /* 190251 */     // GIR_Coverage, 11912,
     /* 190251 */     GIR_EraseRootFromParent_Done,
     /* 190252 */   // Label 3802: @190252
     /* 190252 */   GIM_Try, /*On fail goto*//*Label 3803*/ GIMT_Encode4(190289), // Rule ID 11913 //
     /* 190257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 190265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 190268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 190271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190278 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1171:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ANDQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 190278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_H),
     /* 190281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190285 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190287 */     GIR_RootConstrainSelectedInstOperands,
     /* 190288 */     // GIR_Coverage, 11913,
     /* 190288 */     GIR_EraseRootFromParent_Done,
     /* 190289 */   // Label 3803: @190289
     /* 190289 */   GIM_Try, /*On fail goto*//*Label 3804*/ GIMT_Encode4(190326), // Rule ID 11914 //
     /* 190294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 190302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 190305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 190308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190315 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1171:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ANDQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 190315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_S),
     /* 190318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190322 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190324 */     GIR_RootConstrainSelectedInstOperands,
     /* 190325 */     // GIR_Coverage, 11914,
     /* 190325 */     GIR_EraseRootFromParent_Done,
     /* 190326 */   // Label 3804: @190326
     /* 190326 */   GIM_Try, /*On fail goto*//*Label 3805*/ GIMT_Encode4(190363), // Rule ID 11915 //
     /* 190331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 190339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 190342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 190345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190352 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1171:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ANDQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 190352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_D),
     /* 190355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190359 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190361 */     GIR_RootConstrainSelectedInstOperands,
     /* 190362 */     // GIR_Coverage, 11915,
     /* 190362 */     GIR_EraseRootFromParent_Done,
     /* 190363 */   // Label 3805: @190363
     /* 190363 */   GIM_Try, /*On fail goto*//*Label 3806*/ GIMT_Encode4(190400), // Rule ID 11916 //
     /* 190368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 190376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 190379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 190382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 190385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190389 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1159:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ADDQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 190389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_B),
     /* 190392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190396 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190398 */     GIR_RootConstrainSelectedInstOperands,
     /* 190399 */     // GIR_Coverage, 11916,
     /* 190399 */     GIR_EraseRootFromParent_Done,
     /* 190400 */   // Label 3806: @190400
     /* 190400 */   GIM_Try, /*On fail goto*//*Label 3807*/ GIMT_Encode4(190437), // Rule ID 11917 //
     /* 190405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 190413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 190416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 190419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190426 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1159:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADDQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 190426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_H),
     /* 190429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190433 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190435 */     GIR_RootConstrainSelectedInstOperands,
     /* 190436 */     // GIR_Coverage, 11917,
     /* 190436 */     GIR_EraseRootFromParent_Done,
     /* 190437 */   // Label 3807: @190437
     /* 190437 */   GIM_Try, /*On fail goto*//*Label 3808*/ GIMT_Encode4(190474), // Rule ID 11918 //
     /* 190442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 190450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 190453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 190456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190463 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1159:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADDQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 190463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_S),
     /* 190466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190470 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190472 */     GIR_RootConstrainSelectedInstOperands,
     /* 190473 */     // GIR_Coverage, 11918,
     /* 190473 */     GIR_EraseRootFromParent_Done,
     /* 190474 */   // Label 3808: @190474
     /* 190474 */   GIM_Try, /*On fail goto*//*Label 3809*/ GIMT_Encode4(190511), // Rule ID 11919 //
     /* 190479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 190487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 190490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 190493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190500 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1159:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADDQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 190500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_D),
     /* 190503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190507 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190509 */     GIR_RootConstrainSelectedInstOperands,
     /* 190510 */     // GIR_Coverage, 11919,
     /* 190510 */     GIR_EraseRootFromParent_Done,
     /* 190511 */   // Label 3809: @190511
     /* 190511 */   GIM_Try, /*On fail goto*//*Label 3810*/ GIMT_Encode4(190548), // Rule ID 11920 //
     /* 190516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 190524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 190527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 190530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 190533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190537 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1638:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMAXQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 190537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_B),
     /* 190540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190544 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190546 */     GIR_RootConstrainSelectedInstOperands,
     /* 190547 */     // GIR_Coverage, 11920,
     /* 190547 */     GIR_EraseRootFromParent_Done,
     /* 190548 */   // Label 3810: @190548
     /* 190548 */   GIM_Try, /*On fail goto*//*Label 3811*/ GIMT_Encode4(190585), // Rule ID 11921 //
     /* 190553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 190561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 190564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 190567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190574 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1638:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMAXQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 190574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_H),
     /* 190577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190581 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190583 */     GIR_RootConstrainSelectedInstOperands,
     /* 190584 */     // GIR_Coverage, 11921,
     /* 190584 */     GIR_EraseRootFromParent_Done,
     /* 190585 */   // Label 3811: @190585
     /* 190585 */   GIM_Try, /*On fail goto*//*Label 3812*/ GIMT_Encode4(190622), // Rule ID 11922 //
     /* 190590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 190598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 190601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 190604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190611 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1638:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMAXQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 190611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_S),
     /* 190614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190616 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190618 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190620 */     GIR_RootConstrainSelectedInstOperands,
     /* 190621 */     // GIR_Coverage, 11922,
     /* 190621 */     GIR_EraseRootFromParent_Done,
     /* 190622 */   // Label 3812: @190622
     /* 190622 */   GIM_Try, /*On fail goto*//*Label 3813*/ GIMT_Encode4(190659), // Rule ID 11923 //
     /* 190627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 190635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 190638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 190641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190648 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1638:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SMAXQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 190648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_D),
     /* 190651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190655 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190657 */     GIR_RootConstrainSelectedInstOperands,
     /* 190658 */     // GIR_Coverage, 11923,
     /* 190658 */     GIR_EraseRootFromParent_Done,
     /* 190659 */   // Label 3813: @190659
     /* 190659 */   GIM_Try, /*On fail goto*//*Label 3814*/ GIMT_Encode4(190696), // Rule ID 11924 //
     /* 190664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 190672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 190675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 190678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 190681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190685 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1876:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMAXQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 190685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_B),
     /* 190688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190690 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190692 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190694 */     GIR_RootConstrainSelectedInstOperands,
     /* 190695 */     // GIR_Coverage, 11924,
     /* 190695 */     GIR_EraseRootFromParent_Done,
     /* 190696 */   // Label 3814: @190696
     /* 190696 */   GIM_Try, /*On fail goto*//*Label 3815*/ GIMT_Encode4(190733), // Rule ID 11925 //
     /* 190701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 190709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 190712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 190715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190722 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1876:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMAXQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 190722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_H),
     /* 190725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190729 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190731 */     GIR_RootConstrainSelectedInstOperands,
     /* 190732 */     // GIR_Coverage, 11925,
     /* 190732 */     GIR_EraseRootFromParent_Done,
     /* 190733 */   // Label 3815: @190733
     /* 190733 */   GIM_Try, /*On fail goto*//*Label 3816*/ GIMT_Encode4(190770), // Rule ID 11926 //
     /* 190738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 190746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 190749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 190752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190759 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1876:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMAXQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 190759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_S),
     /* 190762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190766 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190768 */     GIR_RootConstrainSelectedInstOperands,
     /* 190769 */     // GIR_Coverage, 11926,
     /* 190769 */     GIR_EraseRootFromParent_Done,
     /* 190770 */   // Label 3816: @190770
     /* 190770 */   GIM_Try, /*On fail goto*//*Label 3817*/ GIMT_Encode4(190807), // Rule ID 11927 //
     /* 190775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 190783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 190786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 190789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190796 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1876:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UMAXQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 190796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_D),
     /* 190799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190803 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190805 */     GIR_RootConstrainSelectedInstOperands,
     /* 190806 */     // GIR_Coverage, 11927,
     /* 190806 */     GIR_EraseRootFromParent_Done,
     /* 190807 */   // Label 3817: @190807
     /* 190807 */   GIM_Try, /*On fail goto*//*Label 3818*/ GIMT_Encode4(190844), // Rule ID 11928 //
     /* 190812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 190820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 190823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 190826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 190829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190833 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1647:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMINQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 190833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_B),
     /* 190836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190840 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190842 */     GIR_RootConstrainSelectedInstOperands,
     /* 190843 */     // GIR_Coverage, 11928,
     /* 190843 */     GIR_EraseRootFromParent_Done,
     /* 190844 */   // Label 3818: @190844
     /* 190844 */   GIM_Try, /*On fail goto*//*Label 3819*/ GIMT_Encode4(190881), // Rule ID 11929 //
     /* 190849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 190857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 190860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 190863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190870 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1647:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMINQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 190870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_H),
     /* 190873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190877 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190879 */     GIR_RootConstrainSelectedInstOperands,
     /* 190880 */     // GIR_Coverage, 11929,
     /* 190880 */     GIR_EraseRootFromParent_Done,
     /* 190881 */   // Label 3819: @190881
     /* 190881 */   GIM_Try, /*On fail goto*//*Label 3820*/ GIMT_Encode4(190918), // Rule ID 11930 //
     /* 190886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 190894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 190897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 190900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190907 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1647:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMINQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 190907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_S),
     /* 190910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190914 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190916 */     GIR_RootConstrainSelectedInstOperands,
     /* 190917 */     // GIR_Coverage, 11930,
     /* 190917 */     GIR_EraseRootFromParent_Done,
     /* 190918 */   // Label 3820: @190918
     /* 190918 */   GIM_Try, /*On fail goto*//*Label 3821*/ GIMT_Encode4(190955), // Rule ID 11931 //
     /* 190923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 190931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 190934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 190937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190944 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1647:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SMINQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 190944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_D),
     /* 190947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190951 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190953 */     GIR_RootConstrainSelectedInstOperands,
     /* 190954 */     // GIR_Coverage, 11931,
     /* 190954 */     GIR_EraseRootFromParent_Done,
     /* 190955 */   // Label 3821: @190955
     /* 190955 */   GIM_Try, /*On fail goto*//*Label 3822*/ GIMT_Encode4(190992), // Rule ID 11932 //
     /* 190960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 190963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 190968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 190971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 190974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 190977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190981 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1885:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMINQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 190981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_B),
     /* 190984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 190986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190988 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190990 */     GIR_RootConstrainSelectedInstOperands,
     /* 190991 */     // GIR_Coverage, 11932,
     /* 190991 */     GIR_EraseRootFromParent_Done,
     /* 190992 */   // Label 3822: @190992
     /* 190992 */   GIM_Try, /*On fail goto*//*Label 3823*/ GIMT_Encode4(191029), // Rule ID 11933 //
     /* 190997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 191005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 191008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 191011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191018 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1885:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMINQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_H),
     /* 191021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 191023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191025 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191027 */     GIR_RootConstrainSelectedInstOperands,
     /* 191028 */     // GIR_Coverage, 11933,
     /* 191028 */     GIR_EraseRootFromParent_Done,
     /* 191029 */   // Label 3823: @191029
     /* 191029 */   GIM_Try, /*On fail goto*//*Label 3824*/ GIMT_Encode4(191066), // Rule ID 11934 //
     /* 191034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 191042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 191045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 191048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191055 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1885:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMINQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_S),
     /* 191058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 191060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191062 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191064 */     GIR_RootConstrainSelectedInstOperands,
     /* 191065 */     // GIR_Coverage, 11934,
     /* 191065 */     GIR_EraseRootFromParent_Done,
     /* 191066 */   // Label 3824: @191066
     /* 191066 */   GIM_Try, /*On fail goto*//*Label 3825*/ GIMT_Encode4(191103), // Rule ID 11935 //
     /* 191071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 191079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 191082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 191085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 191088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191092 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1885:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UMINQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 191092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_D),
     /* 191095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 191097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191099 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191101 */     GIR_RootConstrainSelectedInstOperands,
     /* 191102 */     // GIR_Coverage, 11935,
     /* 191102 */     GIR_EraseRootFromParent_Done,
     /* 191103 */   // Label 3825: @191103
     /* 191103 */   GIM_Try, /*On fail goto*//*Label 3826*/ GIMT_Encode4(191140), // Rule ID 11936 //
     /* 191108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 191116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 191119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 191122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 191125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191129 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2069:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIPQ2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 191129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_B),
     /* 191132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191136 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191138 */     GIR_RootConstrainSelectedInstOperands,
     /* 191139 */     // GIR_Coverage, 11936,
     /* 191139 */     GIR_EraseRootFromParent_Done,
     /* 191140 */   // Label 3826: @191140
     /* 191140 */   GIM_Try, /*On fail goto*//*Label 3827*/ GIMT_Encode4(191177), // Rule ID 11937 //
     /* 191145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 191153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191166 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2069:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIPQ2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_H),
     /* 191169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191173 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191175 */     GIR_RootConstrainSelectedInstOperands,
     /* 191176 */     // GIR_Coverage, 11937,
     /* 191176 */     GIR_EraseRootFromParent_Done,
     /* 191177 */   // Label 3827: @191177
     /* 191177 */   GIM_Try, /*On fail goto*//*Label 3828*/ GIMT_Encode4(191214), // Rule ID 11938 //
     /* 191182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 191190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191203 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2069:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIPQ2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_S),
     /* 191206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191208 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191210 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191212 */     GIR_RootConstrainSelectedInstOperands,
     /* 191213 */     // GIR_Coverage, 11938,
     /* 191213 */     GIR_EraseRootFromParent_Done,
     /* 191214 */   // Label 3828: @191214
     /* 191214 */   GIM_Try, /*On fail goto*//*Label 3829*/ GIMT_Encode4(191251), // Rule ID 11939 //
     /* 191219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 191227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 191233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 191236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191240 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2069:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIPQ2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 191240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_D),
     /* 191243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191247 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191249 */     GIR_RootConstrainSelectedInstOperands,
     /* 191250 */     // GIR_Coverage, 11939,
     /* 191250 */     GIR_EraseRootFromParent_Done,
     /* 191251 */   // Label 3829: @191251
     /* 191251 */   GIM_Try, /*On fail goto*//*Label 3830*/ GIMT_Encode4(191288), // Rule ID 11940 //
     /* 191256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 191264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191277 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2069:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIPQ2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 191277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_H),
     /* 191280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191282 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191284 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191286 */     GIR_RootConstrainSelectedInstOperands,
     /* 191287 */     // GIR_Coverage, 11940,
     /* 191287 */     GIR_EraseRootFromParent_Done,
     /* 191288 */   // Label 3830: @191288
     /* 191288 */   GIM_Try, /*On fail goto*//*Label 3831*/ GIMT_Encode4(191325), // Rule ID 11941 //
     /* 191293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 191301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191314 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2069:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIPQ2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 191314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_S),
     /* 191317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191319 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191321 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191323 */     GIR_RootConstrainSelectedInstOperands,
     /* 191324 */     // GIR_Coverage, 11941,
     /* 191324 */     GIR_EraseRootFromParent_Done,
     /* 191325 */   // Label 3831: @191325
     /* 191325 */   GIM_Try, /*On fail goto*//*Label 3832*/ GIMT_Encode4(191362), // Rule ID 11942 //
     /* 191330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 191338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 191344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 191347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191351 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2069:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIPQ2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 191351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_D),
     /* 191354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191356 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191358 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191360 */     GIR_RootConstrainSelectedInstOperands,
     /* 191361 */     // GIR_Coverage, 11942,
     /* 191361 */     GIR_EraseRootFromParent_Done,
     /* 191362 */   // Label 3832: @191362
     /* 191362 */   GIM_Try, /*On fail goto*//*Label 3833*/ GIMT_Encode4(191399), // Rule ID 11943 //
     /* 191367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 191375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 191378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 191381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 191384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191388 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1994:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZPQ1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 191388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_B),
     /* 191391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191395 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191397 */     GIR_RootConstrainSelectedInstOperands,
     /* 191398 */     // GIR_Coverage, 11943,
     /* 191398 */     GIR_EraseRootFromParent_Done,
     /* 191399 */   // Label 3833: @191399
     /* 191399 */   GIM_Try, /*On fail goto*//*Label 3834*/ GIMT_Encode4(191436), // Rule ID 11944 //
     /* 191404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 191412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191425 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1994:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZPQ1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_H),
     /* 191428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191430 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191432 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191434 */     GIR_RootConstrainSelectedInstOperands,
     /* 191435 */     // GIR_Coverage, 11944,
     /* 191435 */     GIR_EraseRootFromParent_Done,
     /* 191436 */   // Label 3834: @191436
     /* 191436 */   GIM_Try, /*On fail goto*//*Label 3835*/ GIMT_Encode4(191473), // Rule ID 11945 //
     /* 191441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 191449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191462 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1994:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZPQ1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_S),
     /* 191465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191469 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191471 */     GIR_RootConstrainSelectedInstOperands,
     /* 191472 */     // GIR_Coverage, 11945,
     /* 191472 */     GIR_EraseRootFromParent_Done,
     /* 191473 */   // Label 3835: @191473
     /* 191473 */   GIM_Try, /*On fail goto*//*Label 3836*/ GIMT_Encode4(191510), // Rule ID 11946 //
     /* 191478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 191486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 191492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 191495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191499 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1994:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZPQ1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 191499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_D),
     /* 191502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191506 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191508 */     GIR_RootConstrainSelectedInstOperands,
     /* 191509 */     // GIR_Coverage, 11946,
     /* 191509 */     GIR_EraseRootFromParent_Done,
     /* 191510 */   // Label 3836: @191510
     /* 191510 */   GIM_Try, /*On fail goto*//*Label 3837*/ GIMT_Encode4(191547), // Rule ID 11947 //
     /* 191515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 191523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191536 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1994:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZPQ1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 191536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_H),
     /* 191539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191545 */     GIR_RootConstrainSelectedInstOperands,
     /* 191546 */     // GIR_Coverage, 11947,
     /* 191546 */     GIR_EraseRootFromParent_Done,
     /* 191547 */   // Label 3837: @191547
     /* 191547 */   GIM_Try, /*On fail goto*//*Label 3838*/ GIMT_Encode4(191584), // Rule ID 11948 //
     /* 191552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 191560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191573 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1994:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZPQ1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 191573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_S),
     /* 191576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191578 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191580 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191582 */     GIR_RootConstrainSelectedInstOperands,
     /* 191583 */     // GIR_Coverage, 11948,
     /* 191583 */     GIR_EraseRootFromParent_Done,
     /* 191584 */   // Label 3838: @191584
     /* 191584 */   GIM_Try, /*On fail goto*//*Label 3839*/ GIMT_Encode4(191621), // Rule ID 11949 //
     /* 191589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 191597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 191603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 191606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191610 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1994:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZPQ1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 191610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_D),
     /* 191613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191615 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191617 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191619 */     GIR_RootConstrainSelectedInstOperands,
     /* 191620 */     // GIR_Coverage, 11949,
     /* 191620 */     GIR_EraseRootFromParent_Done,
     /* 191621 */   // Label 3839: @191621
     /* 191621 */   GIM_Try, /*On fail goto*//*Label 3840*/ GIMT_Encode4(191658), // Rule ID 11950 //
     /* 191626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 191634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 191637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 191640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 191643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191647 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1995:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZPQ2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 191647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_B),
     /* 191650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191654 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191656 */     GIR_RootConstrainSelectedInstOperands,
     /* 191657 */     // GIR_Coverage, 11950,
     /* 191657 */     GIR_EraseRootFromParent_Done,
     /* 191658 */   // Label 3840: @191658
     /* 191658 */   GIM_Try, /*On fail goto*//*Label 3841*/ GIMT_Encode4(191695), // Rule ID 11951 //
     /* 191663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 191671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191684 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1995:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZPQ2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_H),
     /* 191687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191691 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191693 */     GIR_RootConstrainSelectedInstOperands,
     /* 191694 */     // GIR_Coverage, 11951,
     /* 191694 */     GIR_EraseRootFromParent_Done,
     /* 191695 */   // Label 3841: @191695
     /* 191695 */   GIM_Try, /*On fail goto*//*Label 3842*/ GIMT_Encode4(191732), // Rule ID 11952 //
     /* 191700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 191708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191721 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1995:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZPQ2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_S),
     /* 191724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191728 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191730 */     GIR_RootConstrainSelectedInstOperands,
     /* 191731 */     // GIR_Coverage, 11952,
     /* 191731 */     GIR_EraseRootFromParent_Done,
     /* 191732 */   // Label 3842: @191732
     /* 191732 */   GIM_Try, /*On fail goto*//*Label 3843*/ GIMT_Encode4(191769), // Rule ID 11953 //
     /* 191737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 191745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 191751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 191754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191758 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1995:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZPQ2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 191758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_D),
     /* 191761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191765 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191767 */     GIR_RootConstrainSelectedInstOperands,
     /* 191768 */     // GIR_Coverage, 11953,
     /* 191768 */     GIR_EraseRootFromParent_Done,
     /* 191769 */   // Label 3843: @191769
     /* 191769 */   GIM_Try, /*On fail goto*//*Label 3844*/ GIMT_Encode4(191806), // Rule ID 11954 //
     /* 191774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 191782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191795 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1995:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZPQ2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 191795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_H),
     /* 191798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191802 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191804 */     GIR_RootConstrainSelectedInstOperands,
     /* 191805 */     // GIR_Coverage, 11954,
     /* 191805 */     GIR_EraseRootFromParent_Done,
     /* 191806 */   // Label 3844: @191806
     /* 191806 */   GIM_Try, /*On fail goto*//*Label 3845*/ GIMT_Encode4(191843), // Rule ID 11955 //
     /* 191811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 191819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191832 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1995:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZPQ2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 191832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_S),
     /* 191835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191839 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191841 */     GIR_RootConstrainSelectedInstOperands,
     /* 191842 */     // GIR_Coverage, 11955,
     /* 191842 */     GIR_EraseRootFromParent_Done,
     /* 191843 */   // Label 3845: @191843
     /* 191843 */   GIM_Try, /*On fail goto*//*Label 3846*/ GIMT_Encode4(191880), // Rule ID 11956 //
     /* 191848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 191851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 191856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 191862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 191865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191869 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1995:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZPQ2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 191869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_D),
     /* 191872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191876 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191878 */     GIR_RootConstrainSelectedInstOperands,
     /* 191879 */     // GIR_Coverage, 11956,
     /* 191879 */     GIR_EraseRootFromParent_Done,
     /* 191880 */   // Label 3846: @191880
     /* 191880 */   GIM_Try, /*On fail goto*//*Label 3847*/ GIMT_Encode4(191922), // Rule ID 3198 //
     /* 191885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_b),
     /* 191893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 191896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 191900 */     // MIs[0] Op1
     /* 191900 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 191904 */     // MIs[0] Op2
     /* 191904 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 191908 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2048:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 191908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_B),
     /* 191911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 191913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191915 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191917 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 191920 */     GIR_RootConstrainSelectedInstOperands,
     /* 191921 */     // GIR_Coverage, 3198,
     /* 191921 */     GIR_EraseRootFromParent_Done,
     /* 191922 */   // Label 3847: @191922
     /* 191922 */   GIM_Try, /*On fail goto*//*Label 3848*/ GIMT_Encode4(191964), // Rule ID 3199 //
     /* 191927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_h),
     /* 191935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 191938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 191942 */     // MIs[0] Op1
     /* 191942 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 191946 */     // MIs[0] Op2
     /* 191946 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 191950 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2050:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 191950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_H),
     /* 191953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 191955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191957 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191959 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 191962 */     GIR_RootConstrainSelectedInstOperands,
     /* 191963 */     // GIR_Coverage, 3199,
     /* 191963 */     GIR_EraseRootFromParent_Done,
     /* 191964 */   // Label 3848: @191964
     /* 191964 */   GIM_Try, /*On fail goto*//*Label 3849*/ GIMT_Encode4(192006), // Rule ID 3200 //
     /* 191969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_s),
     /* 191977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 191980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 191984 */     // MIs[0] Op1
     /* 191984 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 191988 */     // MIs[0] Op2
     /* 191988 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 191992 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2051:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 191992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_S),
     /* 191995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 191997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191999 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192001 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 192004 */     GIR_RootConstrainSelectedInstOperands,
     /* 192005 */     // GIR_Coverage, 3200,
     /* 192005 */     GIR_EraseRootFromParent_Done,
     /* 192006 */   // Label 3849: @192006
     /* 192006 */   GIM_Try, /*On fail goto*//*Label 3850*/ GIMT_Encode4(192048), // Rule ID 3201 //
     /* 192011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_d),
     /* 192019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 192022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 192026 */     // MIs[0] Op1
     /* 192026 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 192030 */     // MIs[0] Op2
     /* 192030 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 192034 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2049:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 192034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_D),
     /* 192037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 192039 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192041 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192043 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 192046 */     GIR_RootConstrainSelectedInstOperands,
     /* 192047 */     // GIR_Coverage, 3201,
     /* 192047 */     GIR_EraseRootFromParent_Done,
     /* 192048 */   // Label 3850: @192048
     /* 192048 */   GIM_Try, /*On fail goto*//*Label 3851*/ GIMT_Encode4(192090), // Rule ID 11767 //
     /* 192053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_b),
     /* 192061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 192064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 192068 */     // MIs[0] Op1
     /* 192068 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 192072 */     // MIs[0] Op2
     /* 192072 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 192076 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2044:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 192076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_B),
     /* 192079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 192081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192083 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192085 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 192088 */     GIR_RootConstrainSelectedInstOperands,
     /* 192089 */     // GIR_Coverage, 11767,
     /* 192089 */     GIR_EraseRootFromParent_Done,
     /* 192090 */   // Label 3851: @192090
     /* 192090 */   GIM_Try, /*On fail goto*//*Label 3852*/ GIMT_Encode4(192132), // Rule ID 11768 //
     /* 192095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_h),
     /* 192103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 192106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 192110 */     // MIs[0] Op1
     /* 192110 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 192114 */     // MIs[0] Op2
     /* 192114 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 192118 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2046:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 192118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_H),
     /* 192121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 192123 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192125 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192127 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 192130 */     GIR_RootConstrainSelectedInstOperands,
     /* 192131 */     // GIR_Coverage, 11768,
     /* 192131 */     GIR_EraseRootFromParent_Done,
     /* 192132 */   // Label 3852: @192132
     /* 192132 */   GIM_Try, /*On fail goto*//*Label 3853*/ GIMT_Encode4(192174), // Rule ID 11769 //
     /* 192137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_s),
     /* 192145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 192148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 192152 */     // MIs[0] Op1
     /* 192152 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 192156 */     // MIs[0] Op2
     /* 192156 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 192160 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2047:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 192160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_S),
     /* 192163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 192165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192167 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192169 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 192172 */     GIR_RootConstrainSelectedInstOperands,
     /* 192173 */     // GIR_Coverage, 11769,
     /* 192173 */     GIR_EraseRootFromParent_Done,
     /* 192174 */   // Label 3853: @192174
     /* 192174 */   GIM_Try, /*On fail goto*//*Label 3854*/ GIMT_Encode4(192216), // Rule ID 11770 //
     /* 192179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_d),
     /* 192187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 192190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 192194 */     // MIs[0] Op1
     /* 192194 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 192198 */     // MIs[0] Op2
     /* 192198 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 192202 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2045:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 192202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_D),
     /* 192205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 192207 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192209 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192211 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 192214 */     GIR_RootConstrainSelectedInstOperands,
     /* 192215 */     // GIR_Coverage, 11770,
     /* 192215 */     GIR_EraseRootFromParent_Done,
     /* 192216 */   // Label 3854: @192216
     /* 192216 */   GIM_Reject,
     /* 192217 */ // Label 2901: @192217
     /* 192217 */ GIM_Try, /*On fail goto*//*Label 3855*/ GIMT_Encode4(236000),
     /* 192222 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /* 192225 */   GIM_Try, /*On fail goto*//*Label 3856*/ GIMT_Encode4(192338), // Rule ID 2062 //
     /* 192230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 192233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 192238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 192241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 192244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 192247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 192250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 192266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 192270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 192274 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 192278 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 192282 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 192286 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 192290 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 192295 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 192299 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 192303 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 192307 */     // MIs[3] Operand 1
     /* 192307 */     // No operand predicates
     /* 192307 */     // MIs[1] Operand 2
     /* 192307 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 192318 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 192320 */     // (intrinsic_wo_chain:{ *:[v4i16] } 686:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLAHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 192320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16_indexed),
     /* 192323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 192327 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 192329 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 192333 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 192336 */     GIR_RootConstrainSelectedInstOperands,
     /* 192337 */     // GIR_Coverage, 2062,
     /* 192337 */     GIR_EraseRootFromParent_Done,
     /* 192338 */   // Label 3856: @192338
     /* 192338 */   GIM_Try, /*On fail goto*//*Label 3857*/ GIMT_Encode4(192451), // Rule ID 2069 //
     /* 192343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 192346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 192351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 192354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 192357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 192360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 192363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 192379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 192383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 192387 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 192391 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 192395 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 192399 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 192403 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 192408 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 192412 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 192416 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 192420 */     // MIs[3] Operand 1
     /* 192420 */     // No operand predicates
     /* 192420 */     // MIs[1] Operand 2
     /* 192420 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 192431 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 192433 */     // (intrinsic_wo_chain:{ *:[v4i16] } 687:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLSHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 192433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16_indexed),
     /* 192436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 192440 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 192442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 192446 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 192449 */     GIR_RootConstrainSelectedInstOperands,
     /* 192450 */     // GIR_Coverage, 2069,
     /* 192450 */     GIR_EraseRootFromParent_Done,
     /* 192451 */   // Label 3857: @192451
     /* 192451 */   GIM_Try, /*On fail goto*//*Label 3858*/ GIMT_Encode4(192564), // Rule ID 2065 //
     /* 192456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 192459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 192464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 192467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 192470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 192473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 192476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 192492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 192496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 192500 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 192504 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 192508 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 192512 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 192516 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192521 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 192525 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 192529 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 192533 */     // MIs[3] Operand 1
     /* 192533 */     // No operand predicates
     /* 192533 */     // MIs[1] Operand 2
     /* 192533 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 192544 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 192546 */     // (intrinsic_wo_chain:{ *:[v2i32] } 686:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLAHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 192546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32_indexed),
     /* 192549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 192553 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 192555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 192559 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 192562 */     GIR_RootConstrainSelectedInstOperands,
     /* 192563 */     // GIR_Coverage, 2065,
     /* 192563 */     GIR_EraseRootFromParent_Done,
     /* 192564 */   // Label 3858: @192564
     /* 192564 */   GIM_Try, /*On fail goto*//*Label 3859*/ GIMT_Encode4(192677), // Rule ID 2072 //
     /* 192569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 192572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 192577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 192580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 192583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 192586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 192589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 192605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 192609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 192613 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 192617 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 192621 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 192625 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 192629 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192634 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 192638 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 192642 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 192646 */     // MIs[3] Operand 1
     /* 192646 */     // No operand predicates
     /* 192646 */     // MIs[1] Operand 2
     /* 192646 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 192657 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 192659 */     // (intrinsic_wo_chain:{ *:[v2i32] } 687:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLSHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 192659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32_indexed),
     /* 192662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 192666 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 192668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 192672 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 192675 */     GIR_RootConstrainSelectedInstOperands,
     /* 192676 */     // GIR_Coverage, 2072,
     /* 192676 */     GIR_EraseRootFromParent_Done,
     /* 192677 */   // Label 3859: @192677
     /* 192677 */   GIM_Try, /*On fail goto*//*Label 3860*/ GIMT_Encode4(192782), // Rule ID 3811 //
     /* 192682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 192685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 192690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 192693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 192696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 192699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 192702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 192718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 192722 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 192726 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 192730 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 192734 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 192738 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 192742 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192747 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 192751 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 192755 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 192759 */     // MIs[3] Operand 1
     /* 192759 */     // No operand predicates
     /* 192759 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 192761 */     // (intrinsic_wo_chain:{ *:[v4f16] } 757:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 0:{ *:[i32] })
     /* 192761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 192764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 192768 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 192770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 192774 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 192777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 192780 */     GIR_RootConstrainSelectedInstOperands,
     /* 192781 */     // GIR_Coverage, 3811,
     /* 192781 */     GIR_EraseRootFromParent_Done,
     /* 192782 */   // Label 3860: @192782
     /* 192782 */   GIM_Try, /*On fail goto*//*Label 3861*/ GIMT_Encode4(192887), // Rule ID 3812 //
     /* 192787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 192790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 192795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 192798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 192801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 192804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 192807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 192823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 192827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 192831 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 192835 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 192839 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 192843 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 192847 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192852 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 192856 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 192860 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 192864 */     // MIs[3] Operand 1
     /* 192864 */     // No operand predicates
     /* 192864 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 192866 */     // (intrinsic_wo_chain:{ *:[v4f16] } 760:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 1:{ *:[i32] })
     /* 192866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 192869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 192873 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 192875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 192879 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 192882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 192885 */     GIR_RootConstrainSelectedInstOperands,
     /* 192886 */     // GIR_Coverage, 3812,
     /* 192886 */     GIR_EraseRootFromParent_Done,
     /* 192887 */   // Label 3861: @192887
     /* 192887 */   GIM_Try, /*On fail goto*//*Label 3862*/ GIMT_Encode4(192992), // Rule ID 3813 //
     /* 192892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 192895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 192900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 192903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 192906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 192909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 192912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 192928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 192932 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 192936 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 192940 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 192944 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 192948 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 192952 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192957 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 192961 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 192965 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 192969 */     // MIs[3] Operand 1
     /* 192969 */     // No operand predicates
     /* 192969 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 192971 */     // (intrinsic_wo_chain:{ *:[v4f16] } 758:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 2:{ *:[i32] })
     /* 192971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 192974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 192978 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 192980 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 192984 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 192987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 192990 */     GIR_RootConstrainSelectedInstOperands,
     /* 192991 */     // GIR_Coverage, 3813,
     /* 192991 */     GIR_EraseRootFromParent_Done,
     /* 192992 */   // Label 3862: @192992
     /* 192992 */   GIM_Try, /*On fail goto*//*Label 3863*/ GIMT_Encode4(193097), // Rule ID 3814 //
     /* 192997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 193000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 193005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 193008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 193011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 193014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 193017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 193033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 193037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 193041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 193045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 193049 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 193053 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 193057 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193062 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 193066 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 193070 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 193074 */     // MIs[3] Operand 1
     /* 193074 */     // No operand predicates
     /* 193074 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 193076 */     // (intrinsic_wo_chain:{ *:[v4f16] } 759:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 3:{ *:[i32] })
     /* 193076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 193079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 193083 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 193085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 193089 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 193092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 193095 */     GIR_RootConstrainSelectedInstOperands,
     /* 193096 */     // GIR_Coverage, 3814,
     /* 193096 */     GIR_EraseRootFromParent_Done,
     /* 193097 */   // Label 3863: @193097
     /* 193097 */   GIM_Try, /*On fail goto*//*Label 3864*/ GIMT_Encode4(193202), // Rule ID 3819 //
     /* 193102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 193105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 193110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 193113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 193116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 193119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 193122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 193138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 193142 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 193146 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 193150 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 193154 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 193158 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 193162 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193167 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 193171 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 193175 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 193179 */     // MIs[3] Operand 1
     /* 193179 */     // No operand predicates
     /* 193179 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 193181 */     // (intrinsic_wo_chain:{ *:[v8f16] } 757:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 0:{ *:[i32] })
     /* 193181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 193184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 193188 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 193190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 193194 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 193197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 193200 */     GIR_RootConstrainSelectedInstOperands,
     /* 193201 */     // GIR_Coverage, 3819,
     /* 193201 */     GIR_EraseRootFromParent_Done,
     /* 193202 */   // Label 3864: @193202
     /* 193202 */   GIM_Try, /*On fail goto*//*Label 3865*/ GIMT_Encode4(193307), // Rule ID 3820 //
     /* 193207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 193210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 193215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 193218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 193221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 193224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 193227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 193243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 193247 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 193251 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 193255 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 193259 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 193263 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 193267 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193272 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 193276 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 193280 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 193284 */     // MIs[3] Operand 1
     /* 193284 */     // No operand predicates
     /* 193284 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 193286 */     // (intrinsic_wo_chain:{ *:[v8f16] } 760:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 1:{ *:[i32] })
     /* 193286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 193289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 193293 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 193295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 193299 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 193302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 193305 */     GIR_RootConstrainSelectedInstOperands,
     /* 193306 */     // GIR_Coverage, 3820,
     /* 193306 */     GIR_EraseRootFromParent_Done,
     /* 193307 */   // Label 3865: @193307
     /* 193307 */   GIM_Try, /*On fail goto*//*Label 3866*/ GIMT_Encode4(193412), // Rule ID 3821 //
     /* 193312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 193315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 193320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 193323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 193326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 193329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 193332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 193348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 193352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 193356 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 193360 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 193364 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 193368 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 193372 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193377 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 193381 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 193385 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 193389 */     // MIs[3] Operand 1
     /* 193389 */     // No operand predicates
     /* 193389 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 193391 */     // (intrinsic_wo_chain:{ *:[v8f16] } 758:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 2:{ *:[i32] })
     /* 193391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 193394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 193398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 193400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 193404 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 193407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 193410 */     GIR_RootConstrainSelectedInstOperands,
     /* 193411 */     // GIR_Coverage, 3821,
     /* 193411 */     GIR_EraseRootFromParent_Done,
     /* 193412 */   // Label 3866: @193412
     /* 193412 */   GIM_Try, /*On fail goto*//*Label 3867*/ GIMT_Encode4(193517), // Rule ID 3822 //
     /* 193417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 193420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 193425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 193428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 193431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 193434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 193437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 193453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 193457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 193461 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 193465 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 193469 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 193473 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 193477 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193482 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 193486 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 193490 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 193494 */     // MIs[3] Operand 1
     /* 193494 */     // No operand predicates
     /* 193494 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 193496 */     // (intrinsic_wo_chain:{ *:[v8f16] } 759:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 3:{ *:[i32] })
     /* 193496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 193499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 193503 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 193505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 193509 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 193512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 193515 */     GIR_RootConstrainSelectedInstOperands,
     /* 193516 */     // GIR_Coverage, 3822,
     /* 193516 */     GIR_EraseRootFromParent_Done,
     /* 193517 */   // Label 3867: @193517
     /* 193517 */   GIM_Try, /*On fail goto*//*Label 3868*/ GIMT_Encode4(193622), // Rule ID 3835 //
     /* 193522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 193525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 193530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 193533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 193536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 193539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 193542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 193558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 193562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 193566 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 193570 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 193574 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 193578 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 193582 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193587 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 193591 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 193595 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 193599 */     // MIs[3] Operand 1
     /* 193599 */     // No operand predicates
     /* 193599 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 193601 */     // (intrinsic_wo_chain:{ *:[v4f32] } 757:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 0:{ *:[i32] })
     /* 193601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 193604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 193608 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 193610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 193614 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 193617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 193620 */     GIR_RootConstrainSelectedInstOperands,
     /* 193621 */     // GIR_Coverage, 3835,
     /* 193621 */     GIR_EraseRootFromParent_Done,
     /* 193622 */   // Label 3868: @193622
     /* 193622 */   GIM_Try, /*On fail goto*//*Label 3869*/ GIMT_Encode4(193727), // Rule ID 3836 //
     /* 193627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 193630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 193635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 193638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 193641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 193644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 193647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 193663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 193667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 193671 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 193675 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 193679 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 193683 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 193687 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193692 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 193696 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 193700 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 193704 */     // MIs[3] Operand 1
     /* 193704 */     // No operand predicates
     /* 193704 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 193706 */     // (intrinsic_wo_chain:{ *:[v4f32] } 760:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 1:{ *:[i32] })
     /* 193706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 193709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 193713 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 193715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 193719 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 193722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 193725 */     GIR_RootConstrainSelectedInstOperands,
     /* 193726 */     // GIR_Coverage, 3836,
     /* 193726 */     GIR_EraseRootFromParent_Done,
     /* 193727 */   // Label 3869: @193727
     /* 193727 */   GIM_Try, /*On fail goto*//*Label 3870*/ GIMT_Encode4(193832), // Rule ID 3837 //
     /* 193732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 193735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 193740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 193743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 193746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 193749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 193752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 193768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 193772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 193776 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 193780 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 193784 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 193788 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 193792 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193797 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 193801 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 193805 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 193809 */     // MIs[3] Operand 1
     /* 193809 */     // No operand predicates
     /* 193809 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 193811 */     // (intrinsic_wo_chain:{ *:[v4f32] } 758:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 2:{ *:[i32] })
     /* 193811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 193814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193816 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 193818 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 193820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 193824 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 193827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 193830 */     GIR_RootConstrainSelectedInstOperands,
     /* 193831 */     // GIR_Coverage, 3837,
     /* 193831 */     GIR_EraseRootFromParent_Done,
     /* 193832 */   // Label 3870: @193832
     /* 193832 */   GIM_Try, /*On fail goto*//*Label 3871*/ GIMT_Encode4(193937), // Rule ID 3838 //
     /* 193837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 193840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 193845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 193848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 193851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 193854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 193857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 193873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 193877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 193881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 193885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 193889 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 193893 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 193897 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193902 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 193906 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 193910 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 193914 */     // MIs[3] Operand 1
     /* 193914 */     // No operand predicates
     /* 193914 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 193916 */     // (intrinsic_wo_chain:{ *:[v4f32] } 759:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 3:{ *:[i32] })
     /* 193916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 193919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 193923 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 193925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 193929 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 193932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 193935 */     GIR_RootConstrainSelectedInstOperands,
     /* 193936 */     // GIR_Coverage, 3838,
     /* 193936 */     GIR_EraseRootFromParent_Done,
     /* 193937 */   // Label 3871: @193937
     /* 193937 */   GIM_Try, /*On fail goto*//*Label 3872*/ GIMT_Encode4(193991), // Rule ID 59 //
     /* 193942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 193945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 193950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 193953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 193956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 193959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 193963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 193967 */     // MIs[0] Operand 3
     /* 193967 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 193978 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 193982 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACIZA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 193982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIZA),
     /* 193985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 193989 */     GIR_RootConstrainSelectedInstOperands,
     /* 193990 */     // GIR_Coverage, 59,
     /* 193990 */     GIR_EraseRootFromParent_Done,
     /* 193991 */   // Label 3872: @193991
     /* 193991 */   GIM_Try, /*On fail goto*//*Label 3873*/ GIMT_Encode4(194045), // Rule ID 60 //
     /* 193996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 193999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 194004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 194007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 194013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 194017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 194021 */     // MIs[0] Operand 3
     /* 194021 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 194032 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 194036 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACDZA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 194036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDZA),
     /* 194039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 194043 */     GIR_RootConstrainSelectedInstOperands,
     /* 194044 */     // GIR_Coverage, 60,
     /* 194044 */     GIR_EraseRootFromParent_Done,
     /* 194045 */   // Label 3873: @194045
     /* 194045 */   GIM_Try, /*On fail goto*//*Label 3874*/ GIMT_Encode4(194099), // Rule ID 61 //
     /* 194050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 194053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 194058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 194061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 194067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 194071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 194075 */     // MIs[0] Operand 3
     /* 194075 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 194086 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 194090 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACIZB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 194090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIZB),
     /* 194093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 194097 */     GIR_RootConstrainSelectedInstOperands,
     /* 194098 */     // GIR_Coverage, 61,
     /* 194098 */     GIR_EraseRootFromParent_Done,
     /* 194099 */   // Label 3874: @194099
     /* 194099 */   GIM_Try, /*On fail goto*//*Label 3875*/ GIMT_Encode4(194153), // Rule ID 62 //
     /* 194104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 194107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 194112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 194115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 194121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 194125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 194129 */     // MIs[0] Operand 3
     /* 194129 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 194140 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 194144 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACDZB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 194144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDZB),
     /* 194147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 194151 */     GIR_RootConstrainSelectedInstOperands,
     /* 194152 */     // GIR_Coverage, 62,
     /* 194152 */     GIR_EraseRootFromParent_Done,
     /* 194153 */   // Label 3875: @194153
     /* 194153 */   GIM_Try, /*On fail goto*//*Label 3876*/ GIMT_Encode4(194209), // Rule ID 2638 //
     /* 194158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 194161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqinch),
     /* 194166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 194169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 194172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194180 */     // MIs[0] pattern
     /* 194180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 194183 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 194188 */     // MIs[0] imm4
     /* 194188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 194191 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 194196 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1716:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 194196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCH_ZPiI),
     /* 194199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 194201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 194203 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 194205 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 194207 */     GIR_RootConstrainSelectedInstOperands,
     /* 194208 */     // GIR_Coverage, 2638,
     /* 194208 */     GIR_EraseRootFromParent_Done,
     /* 194209 */   // Label 3876: @194209
     /* 194209 */   GIM_Try, /*On fail goto*//*Label 3877*/ GIMT_Encode4(194265), // Rule ID 2647 //
     /* 194214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 194217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincb_n32),
     /* 194222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 194225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 194232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 194236 */     // MIs[0] pattern
     /* 194236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 194239 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 194244 */     // MIs[0] imm4
     /* 194244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 194247 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 194252 */     // (intrinsic_wo_chain:{ *:[i32] } 1922:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCB_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 194252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCB_WPiI),
     /* 194255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 194257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194259 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 194261 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 194263 */     GIR_RootConstrainSelectedInstOperands,
     /* 194264 */     // GIR_Coverage, 2647,
     /* 194264 */     GIR_EraseRootFromParent_Done,
     /* 194265 */   // Label 3877: @194265
     /* 194265 */   GIM_Try, /*On fail goto*//*Label 3878*/ GIMT_Encode4(194321), // Rule ID 2648 //
     /* 194270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 194273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincb_n64),
     /* 194278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 194281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 194288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 194292 */     // MIs[0] pattern
     /* 194292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 194295 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 194300 */     // MIs[0] imm4
     /* 194300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 194303 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 194308 */     // (intrinsic_wo_chain:{ *:[i64] } 1712:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 194308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCB_XPiI),
     /* 194311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 194313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194315 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 194317 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 194319 */     GIR_RootConstrainSelectedInstOperands,
     /* 194320 */     // GIR_Coverage, 2648,
     /* 194320 */     GIR_EraseRootFromParent_Done,
     /* 194321 */   // Label 3878: @194321
     /* 194321 */   GIM_Try, /*On fail goto*//*Label 3879*/ GIMT_Encode4(194377), // Rule ID 9826 //
     /* 194326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 194329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecb_n32),
     /* 194334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 194337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 194344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 194348 */     // MIs[0] pattern
     /* 194348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 194351 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 194356 */     // MIs[0] imm4
     /* 194356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 194359 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 194364 */     // (intrinsic_wo_chain:{ *:[i32] } 1908:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECB_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 194364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECB_WPiI),
     /* 194367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 194369 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194371 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 194373 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 194375 */     GIR_RootConstrainSelectedInstOperands,
     /* 194376 */     // GIR_Coverage, 9826,
     /* 194376 */     GIR_EraseRootFromParent_Done,
     /* 194377 */   // Label 3879: @194377
     /* 194377 */   GIM_Try, /*On fail goto*//*Label 3880*/ GIMT_Encode4(194433), // Rule ID 9827 //
     /* 194382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 194385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincb_n64),
     /* 194390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 194393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 194400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 194404 */     // MIs[0] pattern
     /* 194404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 194407 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 194412 */     // MIs[0] imm4
     /* 194412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 194415 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 194420 */     // (intrinsic_wo_chain:{ *:[i64] } 1923:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 194420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCB_XPiI),
     /* 194423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 194425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194427 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 194429 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 194431 */     GIR_RootConstrainSelectedInstOperands,
     /* 194432 */     // GIR_Coverage, 9827,
     /* 194432 */     GIR_EraseRootFromParent_Done,
     /* 194433 */   // Label 3880: @194433
     /* 194433 */   GIM_Try, /*On fail goto*//*Label 3881*/ GIMT_Encode4(194489), // Rule ID 9828 //
     /* 194438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 194441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecb_n64),
     /* 194446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 194449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 194456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 194460 */     // MIs[0] pattern
     /* 194460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 194463 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 194468 */     // MIs[0] imm4
     /* 194468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 194471 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 194476 */     // (intrinsic_wo_chain:{ *:[i64] } 1678:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 194476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECB_XPiI),
     /* 194479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 194481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194483 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 194485 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 194487 */     GIR_RootConstrainSelectedInstOperands,
     /* 194488 */     // GIR_Coverage, 9828,
     /* 194488 */     GIR_EraseRootFromParent_Done,
     /* 194489 */   // Label 3881: @194489
     /* 194489 */   GIM_Try, /*On fail goto*//*Label 3882*/ GIMT_Encode4(194545), // Rule ID 9829 //
     /* 194494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 194497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecb_n64),
     /* 194502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 194505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 194512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 194516 */     // MIs[0] pattern
     /* 194516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 194519 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 194524 */     // MIs[0] imm4
     /* 194524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 194527 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 194532 */     // (intrinsic_wo_chain:{ *:[i64] } 1909:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 194532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECB_XPiI),
     /* 194535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 194537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194539 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 194541 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 194543 */     GIR_RootConstrainSelectedInstOperands,
     /* 194544 */     // GIR_Coverage, 9829,
     /* 194544 */     GIR_EraseRootFromParent_Done,
     /* 194545 */   // Label 3882: @194545
     /* 194545 */   GIM_Try, /*On fail goto*//*Label 3883*/ GIMT_Encode4(194601), // Rule ID 9832 //
     /* 194550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 194553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch_n32),
     /* 194558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 194561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 194568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 194572 */     // MIs[0] pattern
     /* 194572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 194575 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 194580 */     // MIs[0] imm4
     /* 194580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 194583 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 194588 */     // (intrinsic_wo_chain:{ *:[i32] } 1928:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 194588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_WPiI),
     /* 194591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 194593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194595 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 194597 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 194599 */     GIR_RootConstrainSelectedInstOperands,
     /* 194600 */     // GIR_Coverage, 9832,
     /* 194600 */     GIR_EraseRootFromParent_Done,
     /* 194601 */   // Label 3883: @194601
     /* 194601 */   GIM_Try, /*On fail goto*//*Label 3884*/ GIMT_Encode4(194657), // Rule ID 9835 //
     /* 194606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 194609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech_n32),
     /* 194614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 194617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 194624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 194628 */     // MIs[0] pattern
     /* 194628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 194631 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 194636 */     // MIs[0] imm4
     /* 194636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 194639 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 194644 */     // (intrinsic_wo_chain:{ *:[i32] } 1914:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 194644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_WPiI),
     /* 194647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 194649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194651 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 194653 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 194655 */     GIR_RootConstrainSelectedInstOperands,
     /* 194656 */     // GIR_Coverage, 9835,
     /* 194656 */     GIR_EraseRootFromParent_Done,
     /* 194657 */   // Label 3884: @194657
     /* 194657 */   GIM_Try, /*On fail goto*//*Label 3885*/ GIMT_Encode4(194713), // Rule ID 9836 //
     /* 194662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 194665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqinch_n64),
     /* 194670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 194673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 194680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 194684 */     // MIs[0] pattern
     /* 194684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 194687 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 194692 */     // MIs[0] imm4
     /* 194692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 194695 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 194700 */     // (intrinsic_wo_chain:{ *:[i64] } 1718:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 194700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCH_XPiI),
     /* 194703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 194705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194707 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 194709 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 194711 */     GIR_RootConstrainSelectedInstOperands,
     /* 194712 */     // GIR_Coverage, 9836,
     /* 194712 */     GIR_EraseRootFromParent_Done,
     /* 194713 */   // Label 3885: @194713
     /* 194713 */   GIM_Try, /*On fail goto*//*Label 3886*/ GIMT_Encode4(194769), // Rule ID 9837 //
     /* 194718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 194721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch_n64),
     /* 194726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 194729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 194736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 194740 */     // MIs[0] pattern
     /* 194740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 194743 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 194748 */     // MIs[0] imm4
     /* 194748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 194751 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 194756 */     // (intrinsic_wo_chain:{ *:[i64] } 1929:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 194756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_XPiI),
     /* 194759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 194761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194763 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 194765 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 194767 */     GIR_RootConstrainSelectedInstOperands,
     /* 194768 */     // GIR_Coverage, 9837,
     /* 194768 */     GIR_EraseRootFromParent_Done,
     /* 194769 */   // Label 3886: @194769
     /* 194769 */   GIM_Try, /*On fail goto*//*Label 3887*/ GIMT_Encode4(194825), // Rule ID 9838 //
     /* 194774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 194777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdech_n64),
     /* 194782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 194785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 194792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 194796 */     // MIs[0] pattern
     /* 194796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 194799 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 194804 */     // MIs[0] imm4
     /* 194804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 194807 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 194812 */     // (intrinsic_wo_chain:{ *:[i64] } 1684:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 194812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECH_XPiI),
     /* 194815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 194817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194819 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 194821 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 194823 */     GIR_RootConstrainSelectedInstOperands,
     /* 194824 */     // GIR_Coverage, 9838,
     /* 194824 */     GIR_EraseRootFromParent_Done,
     /* 194825 */   // Label 3887: @194825
     /* 194825 */   GIM_Try, /*On fail goto*//*Label 3888*/ GIMT_Encode4(194881), // Rule ID 9839 //
     /* 194830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 194833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech_n64),
     /* 194838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 194841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 194848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 194852 */     // MIs[0] pattern
     /* 194852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 194855 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 194860 */     // MIs[0] imm4
     /* 194860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 194863 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 194868 */     // (intrinsic_wo_chain:{ *:[i64] } 1915:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 194868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_XPiI),
     /* 194871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 194873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194875 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 194877 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 194879 */     GIR_RootConstrainSelectedInstOperands,
     /* 194880 */     // GIR_Coverage, 9839,
     /* 194880 */     GIR_EraseRootFromParent_Done,
     /* 194881 */   // Label 3888: @194881
     /* 194881 */   GIM_Try, /*On fail goto*//*Label 3889*/ GIMT_Encode4(194937), // Rule ID 9842 //
     /* 194886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 194889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw_n32),
     /* 194894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 194897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 194904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 194908 */     // MIs[0] pattern
     /* 194908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 194911 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 194916 */     // MIs[0] imm4
     /* 194916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 194919 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 194924 */     // (intrinsic_wo_chain:{ *:[i32] } 1934:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 194924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_WPiI),
     /* 194927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 194929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194931 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 194933 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 194935 */     GIR_RootConstrainSelectedInstOperands,
     /* 194936 */     // GIR_Coverage, 9842,
     /* 194936 */     GIR_EraseRootFromParent_Done,
     /* 194937 */   // Label 3889: @194937
     /* 194937 */   GIM_Try, /*On fail goto*//*Label 3890*/ GIMT_Encode4(194993), // Rule ID 9845 //
     /* 194942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 194945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw_n32),
     /* 194950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 194953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 194960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 194964 */     // MIs[0] pattern
     /* 194964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 194967 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 194972 */     // MIs[0] imm4
     /* 194972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 194975 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 194980 */     // (intrinsic_wo_chain:{ *:[i32] } 1920:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 194980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_WPiI),
     /* 194983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 194985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194987 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 194989 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 194991 */     GIR_RootConstrainSelectedInstOperands,
     /* 194992 */     // GIR_Coverage, 9845,
     /* 194992 */     GIR_EraseRootFromParent_Done,
     /* 194993 */   // Label 3890: @194993
     /* 194993 */   GIM_Try, /*On fail goto*//*Label 3891*/ GIMT_Encode4(195049), // Rule ID 9846 //
     /* 194998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 195001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincw_n64),
     /* 195006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 195016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 195020 */     // MIs[0] pattern
     /* 195020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 195023 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 195028 */     // MIs[0] imm4
     /* 195028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 195031 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 195036 */     // (intrinsic_wo_chain:{ *:[i64] } 1724:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 195036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCW_XPiI),
     /* 195039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 195041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195043 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 195045 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 195047 */     GIR_RootConstrainSelectedInstOperands,
     /* 195048 */     // GIR_Coverage, 9846,
     /* 195048 */     GIR_EraseRootFromParent_Done,
     /* 195049 */   // Label 3891: @195049
     /* 195049 */   GIM_Try, /*On fail goto*//*Label 3892*/ GIMT_Encode4(195105), // Rule ID 9847 //
     /* 195054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 195057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw_n64),
     /* 195062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 195072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 195076 */     // MIs[0] pattern
     /* 195076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 195079 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 195084 */     // MIs[0] imm4
     /* 195084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 195087 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 195092 */     // (intrinsic_wo_chain:{ *:[i64] } 1935:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 195092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_XPiI),
     /* 195095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 195097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195099 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 195101 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 195103 */     GIR_RootConstrainSelectedInstOperands,
     /* 195104 */     // GIR_Coverage, 9847,
     /* 195104 */     GIR_EraseRootFromParent_Done,
     /* 195105 */   // Label 3892: @195105
     /* 195105 */   GIM_Try, /*On fail goto*//*Label 3893*/ GIMT_Encode4(195161), // Rule ID 9848 //
     /* 195110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 195113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecw_n64),
     /* 195118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 195128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 195132 */     // MIs[0] pattern
     /* 195132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 195135 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 195140 */     // MIs[0] imm4
     /* 195140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 195143 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 195148 */     // (intrinsic_wo_chain:{ *:[i64] } 1690:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 195148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECW_XPiI),
     /* 195151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 195153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195155 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 195157 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 195159 */     GIR_RootConstrainSelectedInstOperands,
     /* 195160 */     // GIR_Coverage, 9848,
     /* 195160 */     GIR_EraseRootFromParent_Done,
     /* 195161 */   // Label 3893: @195161
     /* 195161 */   GIM_Try, /*On fail goto*//*Label 3894*/ GIMT_Encode4(195217), // Rule ID 9849 //
     /* 195166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 195169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw_n64),
     /* 195174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 195184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 195188 */     // MIs[0] pattern
     /* 195188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 195191 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 195196 */     // MIs[0] imm4
     /* 195196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 195199 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 195204 */     // (intrinsic_wo_chain:{ *:[i64] } 1921:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 195204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_XPiI),
     /* 195207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 195209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195211 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 195213 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 195215 */     GIR_RootConstrainSelectedInstOperands,
     /* 195216 */     // GIR_Coverage, 9849,
     /* 195216 */     GIR_EraseRootFromParent_Done,
     /* 195217 */   // Label 3894: @195217
     /* 195217 */   GIM_Try, /*On fail goto*//*Label 3895*/ GIMT_Encode4(195273), // Rule ID 9852 //
     /* 195222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 195225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd_n32),
     /* 195230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 195233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 195236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 195240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 195244 */     // MIs[0] pattern
     /* 195244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 195247 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 195252 */     // MIs[0] imm4
     /* 195252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 195255 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 195260 */     // (intrinsic_wo_chain:{ *:[i32] } 1925:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 195260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_WPiI),
     /* 195263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 195265 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195267 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 195269 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 195271 */     GIR_RootConstrainSelectedInstOperands,
     /* 195272 */     // GIR_Coverage, 9852,
     /* 195272 */     GIR_EraseRootFromParent_Done,
     /* 195273 */   // Label 3895: @195273
     /* 195273 */   GIM_Try, /*On fail goto*//*Label 3896*/ GIMT_Encode4(195329), // Rule ID 9855 //
     /* 195278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 195281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd_n32),
     /* 195286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 195289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 195292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 195296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 195300 */     // MIs[0] pattern
     /* 195300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 195303 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 195308 */     // MIs[0] imm4
     /* 195308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 195311 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 195316 */     // (intrinsic_wo_chain:{ *:[i32] } 1911:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 195316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_WPiI),
     /* 195319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 195321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195323 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 195325 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 195327 */     GIR_RootConstrainSelectedInstOperands,
     /* 195328 */     // GIR_Coverage, 9855,
     /* 195328 */     GIR_EraseRootFromParent_Done,
     /* 195329 */   // Label 3896: @195329
     /* 195329 */   GIM_Try, /*On fail goto*//*Label 3897*/ GIMT_Encode4(195385), // Rule ID 9856 //
     /* 195334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 195337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincd_n64),
     /* 195342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 195352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 195356 */     // MIs[0] pattern
     /* 195356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 195359 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 195364 */     // MIs[0] imm4
     /* 195364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 195367 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 195372 */     // (intrinsic_wo_chain:{ *:[i64] } 1715:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 195372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCD_XPiI),
     /* 195375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 195377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195379 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 195381 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 195383 */     GIR_RootConstrainSelectedInstOperands,
     /* 195384 */     // GIR_Coverage, 9856,
     /* 195384 */     GIR_EraseRootFromParent_Done,
     /* 195385 */   // Label 3897: @195385
     /* 195385 */   GIM_Try, /*On fail goto*//*Label 3898*/ GIMT_Encode4(195441), // Rule ID 9857 //
     /* 195390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 195393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd_n64),
     /* 195398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 195408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 195412 */     // MIs[0] pattern
     /* 195412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 195415 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 195420 */     // MIs[0] imm4
     /* 195420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 195423 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 195428 */     // (intrinsic_wo_chain:{ *:[i64] } 1926:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 195428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_XPiI),
     /* 195431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 195433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195435 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 195437 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 195439 */     GIR_RootConstrainSelectedInstOperands,
     /* 195440 */     // GIR_Coverage, 9857,
     /* 195440 */     GIR_EraseRootFromParent_Done,
     /* 195441 */   // Label 3898: @195441
     /* 195441 */   GIM_Try, /*On fail goto*//*Label 3899*/ GIMT_Encode4(195497), // Rule ID 9858 //
     /* 195446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 195449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecd_n64),
     /* 195454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 195464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 195468 */     // MIs[0] pattern
     /* 195468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 195471 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 195476 */     // MIs[0] imm4
     /* 195476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 195479 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 195484 */     // (intrinsic_wo_chain:{ *:[i64] } 1681:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 195484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECD_XPiI),
     /* 195487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 195489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195491 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 195493 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 195495 */     GIR_RootConstrainSelectedInstOperands,
     /* 195496 */     // GIR_Coverage, 9858,
     /* 195496 */     GIR_EraseRootFromParent_Done,
     /* 195497 */   // Label 3899: @195497
     /* 195497 */   GIM_Try, /*On fail goto*//*Label 3900*/ GIMT_Encode4(195553), // Rule ID 9859 //
     /* 195502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 195505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd_n64),
     /* 195510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 195520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 195524 */     // MIs[0] pattern
     /* 195524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 195527 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 195532 */     // MIs[0] imm4
     /* 195532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 195535 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 195540 */     // (intrinsic_wo_chain:{ *:[i64] } 1912:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 195540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_XPiI),
     /* 195543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 195545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195547 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 195549 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 195551 */     GIR_RootConstrainSelectedInstOperands,
     /* 195552 */     // GIR_Coverage, 9859,
     /* 195552 */     GIR_EraseRootFromParent_Done,
     /* 195553 */   // Label 3900: @195553
     /* 195553 */   GIM_Try, /*On fail goto*//*Label 3901*/ GIMT_Encode4(195609), // Rule ID 9860 //
     /* 195558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 195561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch),
     /* 195566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 195569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 195572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195580 */     // MIs[0] pattern
     /* 195580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 195583 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 195588 */     // MIs[0] imm4
     /* 195588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 195591 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 195596 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1927:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 195596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_ZPiI),
     /* 195599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 195601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 195603 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 195605 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 195607 */     GIR_RootConstrainSelectedInstOperands,
     /* 195608 */     // GIR_Coverage, 9860,
     /* 195608 */     GIR_EraseRootFromParent_Done,
     /* 195609 */   // Label 3901: @195609
     /* 195609 */   GIM_Try, /*On fail goto*//*Label 3902*/ GIMT_Encode4(195665), // Rule ID 9861 //
     /* 195614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 195617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdech),
     /* 195622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 195625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 195628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195636 */     // MIs[0] pattern
     /* 195636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 195639 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 195644 */     // MIs[0] imm4
     /* 195644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 195647 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 195652 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1682:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 195652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECH_ZPiI),
     /* 195655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 195657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 195659 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 195661 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 195663 */     GIR_RootConstrainSelectedInstOperands,
     /* 195664 */     // GIR_Coverage, 9861,
     /* 195664 */     GIR_EraseRootFromParent_Done,
     /* 195665 */   // Label 3902: @195665
     /* 195665 */   GIM_Try, /*On fail goto*//*Label 3903*/ GIMT_Encode4(195721), // Rule ID 9862 //
     /* 195670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 195673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech),
     /* 195678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 195681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 195684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195692 */     // MIs[0] pattern
     /* 195692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 195695 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 195700 */     // MIs[0] imm4
     /* 195700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 195703 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 195708 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1913:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 195708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_ZPiI),
     /* 195711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 195713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 195715 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 195717 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 195719 */     GIR_RootConstrainSelectedInstOperands,
     /* 195720 */     // GIR_Coverage, 9862,
     /* 195720 */     GIR_EraseRootFromParent_Done,
     /* 195721 */   // Label 3903: @195721
     /* 195721 */   GIM_Try, /*On fail goto*//*Label 3904*/ GIMT_Encode4(195777), // Rule ID 9863 //
     /* 195726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 195729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincw),
     /* 195734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 195737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 195740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195748 */     // MIs[0] pattern
     /* 195748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 195751 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 195756 */     // MIs[0] imm4
     /* 195756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 195759 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 195764 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1722:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 195764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCW_ZPiI),
     /* 195767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 195769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 195771 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 195773 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 195775 */     GIR_RootConstrainSelectedInstOperands,
     /* 195776 */     // GIR_Coverage, 9863,
     /* 195776 */     GIR_EraseRootFromParent_Done,
     /* 195777 */   // Label 3904: @195777
     /* 195777 */   GIM_Try, /*On fail goto*//*Label 3905*/ GIMT_Encode4(195833), // Rule ID 9864 //
     /* 195782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 195785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw),
     /* 195790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 195793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 195796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195804 */     // MIs[0] pattern
     /* 195804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 195807 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 195812 */     // MIs[0] imm4
     /* 195812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 195815 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 195820 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1933:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 195820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_ZPiI),
     /* 195823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 195825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 195827 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 195829 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 195831 */     GIR_RootConstrainSelectedInstOperands,
     /* 195832 */     // GIR_Coverage, 9864,
     /* 195832 */     GIR_EraseRootFromParent_Done,
     /* 195833 */   // Label 3905: @195833
     /* 195833 */   GIM_Try, /*On fail goto*//*Label 3906*/ GIMT_Encode4(195889), // Rule ID 9865 //
     /* 195838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 195841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecw),
     /* 195846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 195849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 195852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195860 */     // MIs[0] pattern
     /* 195860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 195863 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 195868 */     // MIs[0] imm4
     /* 195868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 195871 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 195876 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1688:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 195876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECW_ZPiI),
     /* 195879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 195881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 195883 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 195885 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 195887 */     GIR_RootConstrainSelectedInstOperands,
     /* 195888 */     // GIR_Coverage, 9865,
     /* 195888 */     GIR_EraseRootFromParent_Done,
     /* 195889 */   // Label 3906: @195889
     /* 195889 */   GIM_Try, /*On fail goto*//*Label 3907*/ GIMT_Encode4(195945), // Rule ID 9866 //
     /* 195894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 195897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw),
     /* 195902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 195905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 195908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195916 */     // MIs[0] pattern
     /* 195916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 195919 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 195924 */     // MIs[0] imm4
     /* 195924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 195927 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 195932 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1919:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 195932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_ZPiI),
     /* 195935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 195937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 195939 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 195941 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 195943 */     GIR_RootConstrainSelectedInstOperands,
     /* 195944 */     // GIR_Coverage, 9866,
     /* 195944 */     GIR_EraseRootFromParent_Done,
     /* 195945 */   // Label 3907: @195945
     /* 195945 */   GIM_Try, /*On fail goto*//*Label 3908*/ GIMT_Encode4(196001), // Rule ID 9867 //
     /* 195950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 195953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincd),
     /* 195958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 195961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 195964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195972 */     // MIs[0] pattern
     /* 195972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 195975 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 195980 */     // MIs[0] imm4
     /* 195980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 195983 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 195988 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1713:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 195988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCD_ZPiI),
     /* 195991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 195993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 195995 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 195997 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 195999 */     GIR_RootConstrainSelectedInstOperands,
     /* 196000 */     // GIR_Coverage, 9867,
     /* 196000 */     GIR_EraseRootFromParent_Done,
     /* 196001 */   // Label 3908: @196001
     /* 196001 */   GIM_Try, /*On fail goto*//*Label 3909*/ GIMT_Encode4(196057), // Rule ID 9868 //
     /* 196006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 196009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd),
     /* 196014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 196017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 196020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196028 */     // MIs[0] pattern
     /* 196028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 196031 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 196036 */     // MIs[0] imm4
     /* 196036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 196039 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 196044 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1924:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 196044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_ZPiI),
     /* 196047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 196049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 196051 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 196053 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 196055 */     GIR_RootConstrainSelectedInstOperands,
     /* 196056 */     // GIR_Coverage, 9868,
     /* 196056 */     GIR_EraseRootFromParent_Done,
     /* 196057 */   // Label 3909: @196057
     /* 196057 */   GIM_Try, /*On fail goto*//*Label 3910*/ GIMT_Encode4(196113), // Rule ID 9869 //
     /* 196062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 196065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecd),
     /* 196070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 196073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 196076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196084 */     // MIs[0] pattern
     /* 196084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 196087 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 196092 */     // MIs[0] imm4
     /* 196092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 196095 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 196100 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1679:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 196100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECD_ZPiI),
     /* 196103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 196105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 196107 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 196109 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 196111 */     GIR_RootConstrainSelectedInstOperands,
     /* 196112 */     // GIR_Coverage, 9869,
     /* 196112 */     GIR_EraseRootFromParent_Done,
     /* 196113 */   // Label 3910: @196113
     /* 196113 */   GIM_Try, /*On fail goto*//*Label 3911*/ GIMT_Encode4(196169), // Rule ID 9870 //
     /* 196118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 196121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd),
     /* 196126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 196129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 196132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196140 */     // MIs[0] pattern
     /* 196140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 196143 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 196148 */     // MIs[0] imm4
     /* 196148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 196151 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 196156 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1910:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 196156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_ZPiI),
     /* 196159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 196161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 196163 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 196165 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 196167 */     GIR_RootConstrainSelectedInstOperands,
     /* 196168 */     // GIR_Coverage, 9870,
     /* 196168 */     GIR_EraseRootFromParent_Done,
     /* 196169 */   // Label 3911: @196169
     /* 196169 */   GIM_Try, /*On fail goto*//*Label 3912*/ GIMT_Encode4(196259), // Rule ID 47 //
     /* 196174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 196177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 196182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 196185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 196188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 196191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 196194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 196210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 196214 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 196218 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 196222 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 196227 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 196231 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 196235 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 196239 */     // MIs[2] Operand 1
     /* 196239 */     // No operand predicates
     /* 196239 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 196241 */     // (intrinsic_wo_chain:{ *:[v2f32] } 606:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLALlanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 196241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALlanev4f16),
     /* 196244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 196248 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 196250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 196254 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 196257 */     GIR_RootConstrainSelectedInstOperands,
     /* 196258 */     // GIR_Coverage, 47,
     /* 196258 */     GIR_EraseRootFromParent_Done,
     /* 196259 */   // Label 3912: @196259
     /* 196259 */   GIM_Try, /*On fail goto*//*Label 3913*/ GIMT_Encode4(196349), // Rule ID 48 //
     /* 196264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 196267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 196272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 196278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 196281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 196284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 196300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 196304 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 196308 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 196312 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 196317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 196321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 196325 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 196329 */     // MIs[2] Operand 1
     /* 196329 */     // No operand predicates
     /* 196329 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 196331 */     // (intrinsic_wo_chain:{ *:[v4f32] } 606:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLALlanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 196331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALlanev8f16),
     /* 196334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 196338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 196340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 196344 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 196347 */     GIR_RootConstrainSelectedInstOperands,
     /* 196348 */     // GIR_Coverage, 48,
     /* 196348 */     GIR_EraseRootFromParent_Done,
     /* 196349 */   // Label 3913: @196349
     /* 196349 */   GIM_Try, /*On fail goto*//*Label 3914*/ GIMT_Encode4(196439), // Rule ID 49 //
     /* 196354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 196357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 196362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 196365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 196368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 196371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 196374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 196390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 196394 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 196398 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 196402 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 196407 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 196411 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 196415 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 196419 */     // MIs[2] Operand 1
     /* 196419 */     // No operand predicates
     /* 196419 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 196421 */     // (intrinsic_wo_chain:{ *:[v2f32] } 608:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSLlanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 196421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLlanev4f16),
     /* 196424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 196428 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 196430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 196434 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 196437 */     GIR_RootConstrainSelectedInstOperands,
     /* 196438 */     // GIR_Coverage, 49,
     /* 196438 */     GIR_EraseRootFromParent_Done,
     /* 196439 */   // Label 3914: @196439
     /* 196439 */   GIM_Try, /*On fail goto*//*Label 3915*/ GIMT_Encode4(196529), // Rule ID 50 //
     /* 196444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 196447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 196452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 196458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 196461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 196464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 196480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 196484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 196488 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 196492 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 196497 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 196501 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 196505 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 196509 */     // MIs[2] Operand 1
     /* 196509 */     // No operand predicates
     /* 196509 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 196511 */     // (intrinsic_wo_chain:{ *:[v4f32] } 608:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSLlanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 196511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLlanev8f16),
     /* 196514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 196518 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 196520 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 196524 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 196527 */     GIR_RootConstrainSelectedInstOperands,
     /* 196528 */     // GIR_Coverage, 50,
     /* 196528 */     GIR_EraseRootFromParent_Done,
     /* 196529 */   // Label 3915: @196529
     /* 196529 */   GIM_Try, /*On fail goto*//*Label 3916*/ GIMT_Encode4(196619), // Rule ID 51 //
     /* 196534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 196537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 196542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 196545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 196548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 196551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 196554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 196570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 196574 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 196578 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 196582 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 196587 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 196591 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 196595 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 196599 */     // MIs[2] Operand 1
     /* 196599 */     // No operand predicates
     /* 196599 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 196601 */     // (intrinsic_wo_chain:{ *:[v2f32] } 607:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLAL2lanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 196601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2lanev4f16),
     /* 196604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 196608 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 196610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 196614 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 196617 */     GIR_RootConstrainSelectedInstOperands,
     /* 196618 */     // GIR_Coverage, 51,
     /* 196618 */     GIR_EraseRootFromParent_Done,
     /* 196619 */   // Label 3916: @196619
     /* 196619 */   GIM_Try, /*On fail goto*//*Label 3917*/ GIMT_Encode4(196709), // Rule ID 52 //
     /* 196624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 196627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 196632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 196638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 196641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 196644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 196660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 196664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 196668 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 196672 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 196677 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 196681 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 196685 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 196689 */     // MIs[2] Operand 1
     /* 196689 */     // No operand predicates
     /* 196689 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 196691 */     // (intrinsic_wo_chain:{ *:[v4f32] } 607:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLAL2lanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 196691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2lanev8f16),
     /* 196694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 196698 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 196700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 196704 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 196707 */     GIR_RootConstrainSelectedInstOperands,
     /* 196708 */     // GIR_Coverage, 52,
     /* 196708 */     GIR_EraseRootFromParent_Done,
     /* 196709 */   // Label 3917: @196709
     /* 196709 */   GIM_Try, /*On fail goto*//*Label 3918*/ GIMT_Encode4(196799), // Rule ID 53 //
     /* 196714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 196717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 196722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 196725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 196728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 196731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 196734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 196750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 196754 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 196758 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 196762 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 196767 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 196771 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 196775 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 196779 */     // MIs[2] Operand 1
     /* 196779 */     // No operand predicates
     /* 196779 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 196781 */     // (intrinsic_wo_chain:{ *:[v2f32] } 609:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSL2lanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 196781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2lanev4f16),
     /* 196784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 196788 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 196790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 196794 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 196797 */     GIR_RootConstrainSelectedInstOperands,
     /* 196798 */     // GIR_Coverage, 53,
     /* 196798 */     GIR_EraseRootFromParent_Done,
     /* 196799 */   // Label 3918: @196799
     /* 196799 */   GIM_Try, /*On fail goto*//*Label 3919*/ GIMT_Encode4(196889), // Rule ID 54 //
     /* 196804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 196807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 196812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 196818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 196821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 196824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 196840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 196844 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 196848 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 196852 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 196857 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 196861 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 196865 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 196869 */     // MIs[2] Operand 1
     /* 196869 */     // No operand predicates
     /* 196869 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 196871 */     // (intrinsic_wo_chain:{ *:[v4f32] } 609:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSL2lanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 196871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2lanev8f16),
     /* 196874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 196878 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 196880 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 196884 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 196887 */     GIR_RootConstrainSelectedInstOperands,
     /* 196888 */     // GIR_Coverage, 54,
     /* 196888 */     GIR_EraseRootFromParent_Done,
     /* 196889 */   // Label 3919: @196889
     /* 196889 */   GIM_Try, /*On fail goto*//*Label 3920*/ GIMT_Encode4(196979), // Rule ID 2063 //
     /* 196894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 196897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 196902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 196905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 196908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 196911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 196914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 196930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 196934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 196938 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 196942 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 196947 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 196951 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 196955 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 196959 */     // MIs[2] Operand 1
     /* 196959 */     // No operand predicates
     /* 196959 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 196961 */     // (intrinsic_wo_chain:{ *:[v4i16] } 686:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLAHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 196961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16_indexed),
     /* 196964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 196968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 196970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 196974 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 196977 */     GIR_RootConstrainSelectedInstOperands,
     /* 196978 */     // GIR_Coverage, 2063,
     /* 196978 */     GIR_EraseRootFromParent_Done,
     /* 196979 */   // Label 3920: @196979
     /* 196979 */   GIM_Try, /*On fail goto*//*Label 3921*/ GIMT_Encode4(197069), // Rule ID 2064 //
     /* 196984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 196987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 196992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 196995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 196998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 197001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 197004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 197020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 197024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 197028 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 197032 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 197037 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 197041 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 197045 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 197049 */     // MIs[2] Operand 1
     /* 197049 */     // No operand predicates
     /* 197049 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 197051 */     // (intrinsic_wo_chain:{ *:[v8i16] } 686:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLAHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 197051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv8i16_indexed),
     /* 197054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197056 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 197058 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 197060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 197064 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 197067 */     GIR_RootConstrainSelectedInstOperands,
     /* 197068 */     // GIR_Coverage, 2064,
     /* 197068 */     GIR_EraseRootFromParent_Done,
     /* 197069 */   // Label 3921: @197069
     /* 197069 */   GIM_Try, /*On fail goto*//*Label 3922*/ GIMT_Encode4(197159), // Rule ID 2070 //
     /* 197074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 197077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 197082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 197085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 197088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 197091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 197094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 197110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 197114 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 197118 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 197122 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 197127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 197131 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 197135 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 197139 */     // MIs[2] Operand 1
     /* 197139 */     // No operand predicates
     /* 197139 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 197141 */     // (intrinsic_wo_chain:{ *:[v4i16] } 687:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLSHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 197141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16_indexed),
     /* 197144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197146 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 197148 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 197150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 197154 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 197157 */     GIR_RootConstrainSelectedInstOperands,
     /* 197158 */     // GIR_Coverage, 2070,
     /* 197158 */     GIR_EraseRootFromParent_Done,
     /* 197159 */   // Label 3922: @197159
     /* 197159 */   GIM_Try, /*On fail goto*//*Label 3923*/ GIMT_Encode4(197249), // Rule ID 2071 //
     /* 197164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 197167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 197172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 197175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 197178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 197181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 197184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 197200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 197204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 197208 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 197212 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 197217 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 197221 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 197225 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 197229 */     // MIs[2] Operand 1
     /* 197229 */     // No operand predicates
     /* 197229 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 197231 */     // (intrinsic_wo_chain:{ *:[v8i16] } 687:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLSHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 197231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv8i16_indexed),
     /* 197234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 197238 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 197240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 197244 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 197247 */     GIR_RootConstrainSelectedInstOperands,
     /* 197248 */     // GIR_Coverage, 2071,
     /* 197248 */     GIR_EraseRootFromParent_Done,
     /* 197249 */   // Label 3923: @197249
     /* 197249 */   GIM_Try, /*On fail goto*//*Label 3924*/ GIMT_Encode4(197339), // Rule ID 2066 //
     /* 197254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 197257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 197262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 197265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 197268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 197271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 197274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 197290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 197294 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 197298 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 197302 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197307 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 197311 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 197315 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 197319 */     // MIs[2] Operand 1
     /* 197319 */     // No operand predicates
     /* 197319 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 197321 */     // (intrinsic_wo_chain:{ *:[v2i32] } 686:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 197321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32_indexed),
     /* 197324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197326 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 197328 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 197330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 197334 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 197337 */     GIR_RootConstrainSelectedInstOperands,
     /* 197338 */     // GIR_Coverage, 2066,
     /* 197338 */     GIR_EraseRootFromParent_Done,
     /* 197339 */   // Label 3924: @197339
     /* 197339 */   GIM_Try, /*On fail goto*//*Label 3925*/ GIMT_Encode4(197429), // Rule ID 2067 //
     /* 197344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 197347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 197352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 197355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 197358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 197361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 197364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 197380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 197384 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 197388 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 197392 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197397 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 197401 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 197405 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 197409 */     // MIs[2] Operand 1
     /* 197409 */     // No operand predicates
     /* 197409 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 197411 */     // (intrinsic_wo_chain:{ *:[v4i32] } 686:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 197411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i32_indexed),
     /* 197414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197416 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 197418 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 197420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 197424 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 197427 */     GIR_RootConstrainSelectedInstOperands,
     /* 197428 */     // GIR_Coverage, 2067,
     /* 197428 */     GIR_EraseRootFromParent_Done,
     /* 197429 */   // Label 3925: @197429
     /* 197429 */   GIM_Try, /*On fail goto*//*Label 3926*/ GIMT_Encode4(197519), // Rule ID 2073 //
     /* 197434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 197437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 197442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 197445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 197448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 197451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 197454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 197470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 197474 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 197478 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 197482 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197487 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 197491 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 197495 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 197499 */     // MIs[2] Operand 1
     /* 197499 */     // No operand predicates
     /* 197499 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 197501 */     // (intrinsic_wo_chain:{ *:[v2i32] } 687:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 197501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32_indexed),
     /* 197504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197506 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 197508 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 197510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 197514 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 197517 */     GIR_RootConstrainSelectedInstOperands,
     /* 197518 */     // GIR_Coverage, 2073,
     /* 197518 */     GIR_EraseRootFromParent_Done,
     /* 197519 */   // Label 3926: @197519
     /* 197519 */   GIM_Try, /*On fail goto*//*Label 3927*/ GIMT_Encode4(197609), // Rule ID 2074 //
     /* 197524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 197527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 197532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 197535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 197538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 197541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 197544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 197560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 197564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 197568 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 197572 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 197581 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 197585 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 197589 */     // MIs[2] Operand 1
     /* 197589 */     // No operand predicates
     /* 197589 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 197591 */     // (intrinsic_wo_chain:{ *:[v4i32] } 687:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 197591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i32_indexed),
     /* 197594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 197598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 197600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 197604 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 197607 */     GIR_RootConstrainSelectedInstOperands,
     /* 197608 */     // GIR_Coverage, 2074,
     /* 197608 */     GIR_EraseRootFromParent_Done,
     /* 197609 */   // Label 3927: @197609
     /* 197609 */   GIM_Try, /*On fail goto*//*Label 3928*/ GIMT_Encode4(197699), // Rule ID 2068 //
     /* 197614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 197617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 197622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 197625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 197628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 197631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 197634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 197638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 197642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 197646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 197650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 197654 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 197658 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 197662 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197667 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 197671 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 197675 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 197679 */     // MIs[2] Operand 1
     /* 197679 */     // No operand predicates
     /* 197679 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 197681 */     // (intrinsic_wo_chain:{ *:[i32] } 686:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 197681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv1i32_indexed),
     /* 197684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 197688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 197690 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 197694 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 197697 */     GIR_RootConstrainSelectedInstOperands,
     /* 197698 */     // GIR_Coverage, 2068,
     /* 197698 */     GIR_EraseRootFromParent_Done,
     /* 197699 */   // Label 3928: @197699
     /* 197699 */   GIM_Try, /*On fail goto*//*Label 3929*/ GIMT_Encode4(197789), // Rule ID 2075 //
     /* 197704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 197707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 197712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 197715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 197718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 197721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 197724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 197728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 197732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 197736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 197740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 197744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 197748 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 197752 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197757 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 197761 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 197765 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 197769 */     // MIs[2] Operand 1
     /* 197769 */     // No operand predicates
     /* 197769 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 197771 */     // (intrinsic_wo_chain:{ *:[i32] } 687:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 197771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv1i32_indexed),
     /* 197774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197776 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 197778 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 197780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 197784 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 197787 */     GIR_RootConstrainSelectedInstOperands,
     /* 197788 */     // GIR_Coverage, 2075,
     /* 197788 */     GIR_EraseRootFromParent_Done,
     /* 197789 */   // Label 3929: @197789
     /* 197789 */   GIM_Try, /*On fail goto*//*Label 3930*/ GIMT_Encode4(197866), // Rule ID 2767 //
     /* 197794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 197797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 197802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 197805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 197808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 197811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 197814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 197822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 197830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 197834 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 197838 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 197842 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 197846 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 197850 */     // MIs[2] Operand 1
     /* 197850 */     // No operand predicates
     /* 197850 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 197852 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1269:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 197852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_H),
     /* 197855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 197857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 197859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 197861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 197864 */     GIR_RootConstrainSelectedInstOperands,
     /* 197865 */     // GIR_Coverage, 2767,
     /* 197865 */     GIR_EraseRootFromParent_Done,
     /* 197866 */   // Label 3930: @197866
     /* 197866 */   GIM_Try, /*On fail goto*//*Label 3931*/ GIMT_Encode4(197943), // Rule ID 2768 //
     /* 197871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 197874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 197879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 197882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 197885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 197888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 197891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 197899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 197907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 197911 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 197915 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 197919 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 197923 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 197927 */     // MIs[2] Operand 1
     /* 197927 */     // No operand predicates
     /* 197927 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 197929 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1269:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 197929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_H),
     /* 197932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 197934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 197936 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 197938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 197941 */     GIR_RootConstrainSelectedInstOperands,
     /* 197942 */     // GIR_Coverage, 2768,
     /* 197942 */     GIR_EraseRootFromParent_Done,
     /* 197943 */   // Label 3931: @197943
     /* 197943 */   GIM_Try, /*On fail goto*//*Label 3932*/ GIMT_Encode4(198020), // Rule ID 2769 //
     /* 197948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 197951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 197956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 197959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 197962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 197965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 197968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 197976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 197984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 197988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 197992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 197996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 198000 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 198004 */     // MIs[2] Operand 1
     /* 198004 */     // No operand predicates
     /* 198004 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 198006 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1269:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 198006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_S),
     /* 198009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 198011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 198013 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 198015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198018 */     GIR_RootConstrainSelectedInstOperands,
     /* 198019 */     // GIR_Coverage, 2769,
     /* 198019 */     GIR_EraseRootFromParent_Done,
     /* 198020 */   // Label 3932: @198020
     /* 198020 */   GIM_Try, /*On fail goto*//*Label 3933*/ GIMT_Encode4(198097), // Rule ID 2770 //
     /* 198025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 198033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 198036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 198039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 198042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 198045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 198053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 198065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 198069 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 198073 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 198077 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 198081 */     // MIs[2] Operand 1
     /* 198081 */     // No operand predicates
     /* 198081 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 198083 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1269:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 198083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_S),
     /* 198086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 198088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 198090 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 198092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198095 */     GIR_RootConstrainSelectedInstOperands,
     /* 198096 */     // GIR_Coverage, 2770,
     /* 198096 */     GIR_EraseRootFromParent_Done,
     /* 198097 */   // Label 3933: @198097
     /* 198097 */   GIM_Try, /*On fail goto*//*Label 3934*/ GIMT_Encode4(198174), // Rule ID 2771 //
     /* 198102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 198110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 198113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 198116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 198119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 198122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 198130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 198142 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 198146 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 198150 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 198154 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 198158 */     // MIs[2] Operand 1
     /* 198158 */     // No operand predicates
     /* 198158 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 198160 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1269:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 198160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_D),
     /* 198163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 198165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 198167 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 198169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198172 */     GIR_RootConstrainSelectedInstOperands,
     /* 198173 */     // GIR_Coverage, 2771,
     /* 198173 */     GIR_EraseRootFromParent_Done,
     /* 198174 */   // Label 3934: @198174
     /* 198174 */   GIM_Try, /*On fail goto*//*Label 3935*/ GIMT_Encode4(198251), // Rule ID 2772 //
     /* 198179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 198187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 198190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 198193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 198196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 198199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 198207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 198219 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 198223 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 198227 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 198231 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 198235 */     // MIs[2] Operand 1
     /* 198235 */     // No operand predicates
     /* 198235 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 198237 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1269:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 198237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_D),
     /* 198240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 198242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 198244 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 198246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198249 */     GIR_RootConstrainSelectedInstOperands,
     /* 198250 */     // GIR_Coverage, 2772,
     /* 198250 */     GIR_EraseRootFromParent_Done,
     /* 198251 */   // Label 3935: @198251
     /* 198251 */   GIM_Try, /*On fail goto*//*Label 3936*/ GIMT_Encode4(198328), // Rule ID 7713 //
     /* 198256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 198264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 198267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 198270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 198273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 198276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 198284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 198296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 198300 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 198304 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 198308 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 198312 */     // MIs[2] Operand 1
     /* 198312 */     // No operand predicates
     /* 198312 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 198314 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1445:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 198314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_H),
     /* 198317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 198319 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 198321 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 198323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198326 */     GIR_RootConstrainSelectedInstOperands,
     /* 198327 */     // GIR_Coverage, 7713,
     /* 198327 */     GIR_EraseRootFromParent_Done,
     /* 198328 */   // Label 3936: @198328
     /* 198328 */   GIM_Try, /*On fail goto*//*Label 3937*/ GIMT_Encode4(198405), // Rule ID 7714 //
     /* 198333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 198341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 198344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 198347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 198350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 198353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 198361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 198373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 198377 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 198381 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 198385 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 198389 */     // MIs[2] Operand 1
     /* 198389 */     // No operand predicates
     /* 198389 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 198391 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1445:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 198391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_H),
     /* 198394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 198396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 198398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 198400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198403 */     GIR_RootConstrainSelectedInstOperands,
     /* 198404 */     // GIR_Coverage, 7714,
     /* 198404 */     GIR_EraseRootFromParent_Done,
     /* 198405 */   // Label 3937: @198405
     /* 198405 */   GIM_Try, /*On fail goto*//*Label 3938*/ GIMT_Encode4(198482), // Rule ID 7715 //
     /* 198410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 198418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 198421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 198424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 198427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 198430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 198438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 198450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 198454 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 198458 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 198462 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 198466 */     // MIs[2] Operand 1
     /* 198466 */     // No operand predicates
     /* 198466 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 198468 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1445:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 198468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_S),
     /* 198471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 198473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 198475 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 198477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198480 */     GIR_RootConstrainSelectedInstOperands,
     /* 198481 */     // GIR_Coverage, 7715,
     /* 198481 */     GIR_EraseRootFromParent_Done,
     /* 198482 */   // Label 3938: @198482
     /* 198482 */   GIM_Try, /*On fail goto*//*Label 3939*/ GIMT_Encode4(198559), // Rule ID 7716 //
     /* 198487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 198495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 198498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 198501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 198504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 198507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 198515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 198527 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 198531 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 198535 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 198539 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 198543 */     // MIs[2] Operand 1
     /* 198543 */     // No operand predicates
     /* 198543 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 198545 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1445:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 198545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_S),
     /* 198548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 198550 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 198552 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 198554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198557 */     GIR_RootConstrainSelectedInstOperands,
     /* 198558 */     // GIR_Coverage, 7716,
     /* 198558 */     GIR_EraseRootFromParent_Done,
     /* 198559 */   // Label 3939: @198559
     /* 198559 */   GIM_Try, /*On fail goto*//*Label 3940*/ GIMT_Encode4(198636), // Rule ID 7717 //
     /* 198564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 198572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 198575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 198578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 198581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 198584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 198592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 198604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 198608 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 198612 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 198616 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 198620 */     // MIs[2] Operand 1
     /* 198620 */     // No operand predicates
     /* 198620 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 198622 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1445:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 198622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_D),
     /* 198625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 198627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 198629 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 198631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198634 */     GIR_RootConstrainSelectedInstOperands,
     /* 198635 */     // GIR_Coverage, 7717,
     /* 198635 */     GIR_EraseRootFromParent_Done,
     /* 198636 */   // Label 3940: @198636
     /* 198636 */   GIM_Try, /*On fail goto*//*Label 3941*/ GIMT_Encode4(198713), // Rule ID 7718 //
     /* 198641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 198649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 198652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 198655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 198658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 198661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 198669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 198681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 198685 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 198689 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 198693 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 198697 */     // MIs[2] Operand 1
     /* 198697 */     // No operand predicates
     /* 198697 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 198699 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1445:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 198699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_D),
     /* 198702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 198704 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 198706 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 198708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198711 */     GIR_RootConstrainSelectedInstOperands,
     /* 198712 */     // GIR_Coverage, 7718,
     /* 198712 */     GIR_EraseRootFromParent_Done,
     /* 198713 */   // Label 3941: @198713
     /* 198713 */   GIM_Try, /*On fail goto*//*Label 3942*/ GIMT_Encode4(198790), // Rule ID 7719 //
     /* 198718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 198726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 198729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 198732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 198735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 198738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 198746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 198758 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 198762 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 198766 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 198770 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 198774 */     // MIs[2] Operand 1
     /* 198774 */     // No operand predicates
     /* 198774 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 198776 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1383:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 198776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_H),
     /* 198779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 198781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 198783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 198785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198788 */     GIR_RootConstrainSelectedInstOperands,
     /* 198789 */     // GIR_Coverage, 7719,
     /* 198789 */     GIR_EraseRootFromParent_Done,
     /* 198790 */   // Label 3942: @198790
     /* 198790 */   GIM_Try, /*On fail goto*//*Label 3943*/ GIMT_Encode4(198867), // Rule ID 7720 //
     /* 198795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 198803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 198806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 198809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 198812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 198815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 198823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 198835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 198839 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 198843 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 198847 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
     /* 198851 */     // MIs[2] Operand 1
     /* 198851 */     // No operand predicates
     /* 198851 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 198853 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1383:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 198853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_H),
     /* 198856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 198858 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 198860 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 198862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198865 */     GIR_RootConstrainSelectedInstOperands,
     /* 198866 */     // GIR_Coverage, 7720,
     /* 198866 */     GIR_EraseRootFromParent_Done,
     /* 198867 */   // Label 3943: @198867
     /* 198867 */   GIM_Try, /*On fail goto*//*Label 3944*/ GIMT_Encode4(198944), // Rule ID 7721 //
     /* 198872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 198880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 198883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 198886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 198889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 198892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 198900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 198912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 198916 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 198920 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 198924 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 198928 */     // MIs[2] Operand 1
     /* 198928 */     // No operand predicates
     /* 198928 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 198930 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1383:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 198930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_S),
     /* 198933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 198935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 198937 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 198939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198942 */     GIR_RootConstrainSelectedInstOperands,
     /* 198943 */     // GIR_Coverage, 7721,
     /* 198943 */     GIR_EraseRootFromParent_Done,
     /* 198944 */   // Label 3944: @198944
     /* 198944 */   GIM_Try, /*On fail goto*//*Label 3945*/ GIMT_Encode4(199021), // Rule ID 7722 //
     /* 198949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 198957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 198960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 198963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 198966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 198969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 198977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 198989 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 198993 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 198997 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 199001 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
     /* 199005 */     // MIs[2] Operand 1
     /* 199005 */     // No operand predicates
     /* 199005 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 199007 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1383:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 199007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_S),
     /* 199010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 199012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 199014 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 199016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199019 */     GIR_RootConstrainSelectedInstOperands,
     /* 199020 */     // GIR_Coverage, 7722,
     /* 199020 */     GIR_EraseRootFromParent_Done,
     /* 199021 */   // Label 3945: @199021
     /* 199021 */   GIM_Try, /*On fail goto*//*Label 3946*/ GIMT_Encode4(199098), // Rule ID 7723 //
     /* 199026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 199034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 199037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 199040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 199043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 199046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 199054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 199066 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 199070 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199074 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 199078 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 199082 */     // MIs[2] Operand 1
     /* 199082 */     // No operand predicates
     /* 199082 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 199084 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1383:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 199084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_D),
     /* 199087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 199089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 199091 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 199093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 199096 */     GIR_RootConstrainSelectedInstOperands,
     /* 199097 */     // GIR_Coverage, 7723,
     /* 199097 */     GIR_EraseRootFromParent_Done,
     /* 199098 */   // Label 3946: @199098
     /* 199098 */   GIM_Try, /*On fail goto*//*Label 3947*/ GIMT_Encode4(199175), // Rule ID 7724 //
     /* 199103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 199111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 199114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 199117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 199120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 199123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 199131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 199143 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 199147 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199151 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 199155 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
     /* 199159 */     // MIs[2] Operand 1
     /* 199159 */     // No operand predicates
     /* 199159 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 199161 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1383:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 199161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_D),
     /* 199164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 199166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 199168 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 199170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199173 */     GIR_RootConstrainSelectedInstOperands,
     /* 199174 */     // GIR_Coverage, 7724,
     /* 199174 */     GIR_EraseRootFromParent_Done,
     /* 199175 */   // Label 3947: @199175
     /* 199175 */   GIM_Try, /*On fail goto*//*Label 3948*/ GIMT_Encode4(199252), // Rule ID 7725 //
     /* 199180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 199188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 199191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 199194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 199197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 199200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 199208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 199220 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 199224 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199228 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 199232 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 199236 */     // MIs[2] Operand 1
     /* 199236 */     // No operand predicates
     /* 199236 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 199238 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1447:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 199238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_H),
     /* 199241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 199243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 199245 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 199247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 199250 */     GIR_RootConstrainSelectedInstOperands,
     /* 199251 */     // GIR_Coverage, 7725,
     /* 199251 */     GIR_EraseRootFromParent_Done,
     /* 199252 */   // Label 3948: @199252
     /* 199252 */   GIM_Try, /*On fail goto*//*Label 3949*/ GIMT_Encode4(199329), // Rule ID 7726 //
     /* 199257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 199265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 199268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 199271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 199274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 199277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 199285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 199297 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 199301 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199305 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 199309 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 199313 */     // MIs[2] Operand 1
     /* 199313 */     // No operand predicates
     /* 199313 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 199315 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1447:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 199315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_H),
     /* 199318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 199320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 199322 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 199324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199327 */     GIR_RootConstrainSelectedInstOperands,
     /* 199328 */     // GIR_Coverage, 7726,
     /* 199328 */     GIR_EraseRootFromParent_Done,
     /* 199329 */   // Label 3949: @199329
     /* 199329 */   GIM_Try, /*On fail goto*//*Label 3950*/ GIMT_Encode4(199406), // Rule ID 7727 //
     /* 199334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 199342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 199345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 199348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 199351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 199354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 199362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 199374 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 199378 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199382 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 199386 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 199390 */     // MIs[2] Operand 1
     /* 199390 */     // No operand predicates
     /* 199390 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 199392 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1447:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 199392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_S),
     /* 199395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 199397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 199399 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 199401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 199404 */     GIR_RootConstrainSelectedInstOperands,
     /* 199405 */     // GIR_Coverage, 7727,
     /* 199405 */     GIR_EraseRootFromParent_Done,
     /* 199406 */   // Label 3950: @199406
     /* 199406 */   GIM_Try, /*On fail goto*//*Label 3951*/ GIMT_Encode4(199483), // Rule ID 7728 //
     /* 199411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 199419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 199422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 199425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 199428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 199431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 199439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 199451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 199455 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199459 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 199463 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 199467 */     // MIs[2] Operand 1
     /* 199467 */     // No operand predicates
     /* 199467 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 199469 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1447:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 199469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_S),
     /* 199472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 199474 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 199476 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 199478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199481 */     GIR_RootConstrainSelectedInstOperands,
     /* 199482 */     // GIR_Coverage, 7728,
     /* 199482 */     GIR_EraseRootFromParent_Done,
     /* 199483 */   // Label 3951: @199483
     /* 199483 */   GIM_Try, /*On fail goto*//*Label 3952*/ GIMT_Encode4(199560), // Rule ID 7729 //
     /* 199488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 199496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 199499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 199502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 199505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 199508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 199516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 199528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 199532 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199536 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 199540 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 199544 */     // MIs[2] Operand 1
     /* 199544 */     // No operand predicates
     /* 199544 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 199546 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1447:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 199546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_D),
     /* 199549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 199551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 199553 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 199555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 199558 */     GIR_RootConstrainSelectedInstOperands,
     /* 199559 */     // GIR_Coverage, 7729,
     /* 199559 */     GIR_EraseRootFromParent_Done,
     /* 199560 */   // Label 3952: @199560
     /* 199560 */   GIM_Try, /*On fail goto*//*Label 3953*/ GIMT_Encode4(199637), // Rule ID 7730 //
     /* 199565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 199573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 199576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 199579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 199582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 199585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 199593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 199605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 199609 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199613 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 199617 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 199621 */     // MIs[2] Operand 1
     /* 199621 */     // No operand predicates
     /* 199621 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 199623 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1447:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 199623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_D),
     /* 199626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 199628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 199630 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 199632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199635 */     GIR_RootConstrainSelectedInstOperands,
     /* 199636 */     // GIR_Coverage, 7730,
     /* 199636 */     GIR_EraseRootFromParent_Done,
     /* 199637 */   // Label 3953: @199637
     /* 199637 */   GIM_Try, /*On fail goto*//*Label 3954*/ GIMT_Encode4(199714), // Rule ID 7731 //
     /* 199642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 199650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 199653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 199656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 199659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 199662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 199670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 199682 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 199686 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199690 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 199694 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 199698 */     // MIs[2] Operand 1
     /* 199698 */     // No operand predicates
     /* 199698 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 199700 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1337:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 199700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_H),
     /* 199703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 199705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 199707 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 199709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 199712 */     GIR_RootConstrainSelectedInstOperands,
     /* 199713 */     // GIR_Coverage, 7731,
     /* 199713 */     GIR_EraseRootFromParent_Done,
     /* 199714 */   // Label 3954: @199714
     /* 199714 */   GIM_Try, /*On fail goto*//*Label 3955*/ GIMT_Encode4(199791), // Rule ID 7732 //
     /* 199719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 199727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 199730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 199733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 199736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 199739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 199747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 199759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 199763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 199771 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 199775 */     // MIs[2] Operand 1
     /* 199775 */     // No operand predicates
     /* 199775 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 199777 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1337:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 199777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_H),
     /* 199780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 199782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 199784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 199786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199789 */     GIR_RootConstrainSelectedInstOperands,
     /* 199790 */     // GIR_Coverage, 7732,
     /* 199790 */     GIR_EraseRootFromParent_Done,
     /* 199791 */   // Label 3955: @199791
     /* 199791 */   GIM_Try, /*On fail goto*//*Label 3956*/ GIMT_Encode4(199868), // Rule ID 7733 //
     /* 199796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 199804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 199807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 199810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 199813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 199816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 199824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 199836 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 199840 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199844 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 199848 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 199852 */     // MIs[2] Operand 1
     /* 199852 */     // No operand predicates
     /* 199852 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 199854 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1337:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 199854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_S),
     /* 199857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 199859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 199861 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 199863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 199866 */     GIR_RootConstrainSelectedInstOperands,
     /* 199867 */     // GIR_Coverage, 7733,
     /* 199867 */     GIR_EraseRootFromParent_Done,
     /* 199868 */   // Label 3956: @199868
     /* 199868 */   GIM_Try, /*On fail goto*//*Label 3957*/ GIMT_Encode4(199945), // Rule ID 7734 //
     /* 199873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 199881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 199884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 199887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 199890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 199893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 199901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 199913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 199917 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199921 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 199925 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 199929 */     // MIs[2] Operand 1
     /* 199929 */     // No operand predicates
     /* 199929 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 199931 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1337:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 199931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_S),
     /* 199934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 199936 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 199938 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 199940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199943 */     GIR_RootConstrainSelectedInstOperands,
     /* 199944 */     // GIR_Coverage, 7734,
     /* 199944 */     GIR_EraseRootFromParent_Done,
     /* 199945 */   // Label 3957: @199945
     /* 199945 */   GIM_Try, /*On fail goto*//*Label 3958*/ GIMT_Encode4(200022), // Rule ID 7735 //
     /* 199950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 199958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 199961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 199964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 199967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 199970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 199978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 199990 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 199994 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199998 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 200002 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 200006 */     // MIs[2] Operand 1
     /* 200006 */     // No operand predicates
     /* 200006 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 200008 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1337:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 200008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_D),
     /* 200011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 200013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 200015 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 200017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 200020 */     GIR_RootConstrainSelectedInstOperands,
     /* 200021 */     // GIR_Coverage, 7735,
     /* 200021 */     GIR_EraseRootFromParent_Done,
     /* 200022 */   // Label 3958: @200022
     /* 200022 */   GIM_Try, /*On fail goto*//*Label 3959*/ GIMT_Encode4(200099), // Rule ID 7736 //
     /* 200027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 200035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 200038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 200041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 200044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 200047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 200055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 200067 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 200071 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200075 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 200079 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 200083 */     // MIs[2] Operand 1
     /* 200083 */     // No operand predicates
     /* 200083 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 200085 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1337:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 200085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_D),
     /* 200088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 200090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 200092 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 200094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200097 */     GIR_RootConstrainSelectedInstOperands,
     /* 200098 */     // GIR_Coverage, 7736,
     /* 200098 */     GIR_EraseRootFromParent_Done,
     /* 200099 */   // Label 3959: @200099
     /* 200099 */   GIM_Try, /*On fail goto*//*Label 3960*/ GIMT_Encode4(200176), // Rule ID 7737 //
     /* 200104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 200112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 200115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 200118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 200121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 200124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 200132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 200144 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 200148 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200152 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 200156 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 200160 */     // MIs[2] Operand 1
     /* 200160 */     // No operand predicates
     /* 200160 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 200162 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1355:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 200162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_H),
     /* 200165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 200167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 200169 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 200171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 200174 */     GIR_RootConstrainSelectedInstOperands,
     /* 200175 */     // GIR_Coverage, 7737,
     /* 200175 */     GIR_EraseRootFromParent_Done,
     /* 200176 */   // Label 3960: @200176
     /* 200176 */   GIM_Try, /*On fail goto*//*Label 3961*/ GIMT_Encode4(200253), // Rule ID 7738 //
     /* 200181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 200189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 200192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 200195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 200198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 200201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 200209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 200221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 200225 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200229 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 200233 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 200237 */     // MIs[2] Operand 1
     /* 200237 */     // No operand predicates
     /* 200237 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 200239 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1355:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 200239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_H),
     /* 200242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 200244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 200246 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 200248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200251 */     GIR_RootConstrainSelectedInstOperands,
     /* 200252 */     // GIR_Coverage, 7738,
     /* 200252 */     GIR_EraseRootFromParent_Done,
     /* 200253 */   // Label 3961: @200253
     /* 200253 */   GIM_Try, /*On fail goto*//*Label 3962*/ GIMT_Encode4(200330), // Rule ID 7739 //
     /* 200258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 200266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 200269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 200272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 200275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 200278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 200286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 200298 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 200302 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200306 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 200310 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 200314 */     // MIs[2] Operand 1
     /* 200314 */     // No operand predicates
     /* 200314 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 200316 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1355:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 200316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_S),
     /* 200319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 200321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 200323 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 200325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 200328 */     GIR_RootConstrainSelectedInstOperands,
     /* 200329 */     // GIR_Coverage, 7739,
     /* 200329 */     GIR_EraseRootFromParent_Done,
     /* 200330 */   // Label 3962: @200330
     /* 200330 */   GIM_Try, /*On fail goto*//*Label 3963*/ GIMT_Encode4(200407), // Rule ID 7740 //
     /* 200335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 200343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 200346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 200349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 200352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 200355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 200363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 200375 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 200379 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200383 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 200387 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 200391 */     // MIs[2] Operand 1
     /* 200391 */     // No operand predicates
     /* 200391 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 200393 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1355:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 200393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_S),
     /* 200396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 200398 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 200400 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 200402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200405 */     GIR_RootConstrainSelectedInstOperands,
     /* 200406 */     // GIR_Coverage, 7740,
     /* 200406 */     GIR_EraseRootFromParent_Done,
     /* 200407 */   // Label 3963: @200407
     /* 200407 */   GIM_Try, /*On fail goto*//*Label 3964*/ GIMT_Encode4(200484), // Rule ID 7741 //
     /* 200412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 200420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 200423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 200426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 200429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 200432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 200440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 200452 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 200456 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200460 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 200464 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 200468 */     // MIs[2] Operand 1
     /* 200468 */     // No operand predicates
     /* 200468 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 200470 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1355:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 200470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_D),
     /* 200473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 200475 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 200477 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 200479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 200482 */     GIR_RootConstrainSelectedInstOperands,
     /* 200483 */     // GIR_Coverage, 7741,
     /* 200483 */     GIR_EraseRootFromParent_Done,
     /* 200484 */   // Label 3964: @200484
     /* 200484 */   GIM_Try, /*On fail goto*//*Label 3965*/ GIMT_Encode4(200561), // Rule ID 7742 //
     /* 200489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 200497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 200500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 200503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 200506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 200509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 200517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 200529 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 200533 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200537 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 200541 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 200545 */     // MIs[2] Operand 1
     /* 200545 */     // No operand predicates
     /* 200545 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 200547 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1355:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 200547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_D),
     /* 200550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 200552 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 200554 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 200556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200559 */     GIR_RootConstrainSelectedInstOperands,
     /* 200560 */     // GIR_Coverage, 7742,
     /* 200560 */     GIR_EraseRootFromParent_Done,
     /* 200561 */   // Label 3965: @200561
     /* 200561 */   GIM_Try, /*On fail goto*//*Label 3966*/ GIMT_Encode4(200638), // Rule ID 7743 //
     /* 200566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 200574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 200577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 200580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 200583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 200586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 200594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 200606 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 200610 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200614 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 200618 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 200622 */     // MIs[2] Operand 1
     /* 200622 */     // No operand predicates
     /* 200622 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 200624 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1331:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 200624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_H),
     /* 200627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 200629 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 200631 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 200633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 200636 */     GIR_RootConstrainSelectedInstOperands,
     /* 200637 */     // GIR_Coverage, 7743,
     /* 200637 */     GIR_EraseRootFromParent_Done,
     /* 200638 */   // Label 3966: @200638
     /* 200638 */   GIM_Try, /*On fail goto*//*Label 3967*/ GIMT_Encode4(200715), // Rule ID 7744 //
     /* 200643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 200651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 200654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 200657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 200660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 200663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 200671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 200683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 200687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 200695 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 200699 */     // MIs[2] Operand 1
     /* 200699 */     // No operand predicates
     /* 200699 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 200701 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1331:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 200701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_H),
     /* 200704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 200706 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 200708 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 200710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200713 */     GIR_RootConstrainSelectedInstOperands,
     /* 200714 */     // GIR_Coverage, 7744,
     /* 200714 */     GIR_EraseRootFromParent_Done,
     /* 200715 */   // Label 3967: @200715
     /* 200715 */   GIM_Try, /*On fail goto*//*Label 3968*/ GIMT_Encode4(200792), // Rule ID 7745 //
     /* 200720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 200728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 200731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 200734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 200737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 200740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 200748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 200760 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 200764 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200768 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 200772 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 200776 */     // MIs[2] Operand 1
     /* 200776 */     // No operand predicates
     /* 200776 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 200778 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1331:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 200778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_S),
     /* 200781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 200783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 200785 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 200787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 200790 */     GIR_RootConstrainSelectedInstOperands,
     /* 200791 */     // GIR_Coverage, 7745,
     /* 200791 */     GIR_EraseRootFromParent_Done,
     /* 200792 */   // Label 3968: @200792
     /* 200792 */   GIM_Try, /*On fail goto*//*Label 3969*/ GIMT_Encode4(200869), // Rule ID 7746 //
     /* 200797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 200805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 200808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 200811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 200814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 200817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 200825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 200837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 200841 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200845 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 200849 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 200853 */     // MIs[2] Operand 1
     /* 200853 */     // No operand predicates
     /* 200853 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 200855 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1331:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 200855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_S),
     /* 200858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 200860 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 200862 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 200864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200867 */     GIR_RootConstrainSelectedInstOperands,
     /* 200868 */     // GIR_Coverage, 7746,
     /* 200868 */     GIR_EraseRootFromParent_Done,
     /* 200869 */   // Label 3969: @200869
     /* 200869 */   GIM_Try, /*On fail goto*//*Label 3970*/ GIMT_Encode4(200946), // Rule ID 7747 //
     /* 200874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 200882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 200885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 200888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 200891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 200894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 200902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 200914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 200918 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200922 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 200926 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 200930 */     // MIs[2] Operand 1
     /* 200930 */     // No operand predicates
     /* 200930 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 200932 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1331:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 200932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_D),
     /* 200935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 200937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 200939 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 200941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 200944 */     GIR_RootConstrainSelectedInstOperands,
     /* 200945 */     // GIR_Coverage, 7747,
     /* 200945 */     GIR_EraseRootFromParent_Done,
     /* 200946 */   // Label 3970: @200946
     /* 200946 */   GIM_Try, /*On fail goto*//*Label 3971*/ GIMT_Encode4(201023), // Rule ID 7748 //
     /* 200951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 200959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 200962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 200965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 200968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 200971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 200979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 200991 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 200995 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200999 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 201003 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 201007 */     // MIs[2] Operand 1
     /* 201007 */     // No operand predicates
     /* 201007 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 201009 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1331:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 201009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_D),
     /* 201012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 201016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 201018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 201021 */     GIR_RootConstrainSelectedInstOperands,
     /* 201022 */     // GIR_Coverage, 7748,
     /* 201022 */     GIR_EraseRootFromParent_Done,
     /* 201023 */   // Label 3971: @201023
     /* 201023 */   GIM_Try, /*On fail goto*//*Label 3972*/ GIMT_Encode4(201100), // Rule ID 7749 //
     /* 201028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 201036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 201039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 201042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 201045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 201048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 201056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 201064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 201068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 201072 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 201076 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 201080 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 201084 */     // MIs[2] Operand 1
     /* 201084 */     // No operand predicates
     /* 201084 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 201086 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1349:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 201086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_H),
     /* 201089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 201093 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 201095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 201098 */     GIR_RootConstrainSelectedInstOperands,
     /* 201099 */     // GIR_Coverage, 7749,
     /* 201099 */     GIR_EraseRootFromParent_Done,
     /* 201100 */   // Label 3972: @201100
     /* 201100 */   GIM_Try, /*On fail goto*//*Label 3973*/ GIMT_Encode4(201177), // Rule ID 7750 //
     /* 201105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 201113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 201116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 201119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 201122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 201125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 201133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 201141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 201145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 201149 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 201153 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 201157 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 201161 */     // MIs[2] Operand 1
     /* 201161 */     // No operand predicates
     /* 201161 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 201163 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1349:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 201163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_H),
     /* 201166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 201170 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 201172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 201175 */     GIR_RootConstrainSelectedInstOperands,
     /* 201176 */     // GIR_Coverage, 7750,
     /* 201176 */     GIR_EraseRootFromParent_Done,
     /* 201177 */   // Label 3973: @201177
     /* 201177 */   GIM_Try, /*On fail goto*//*Label 3974*/ GIMT_Encode4(201254), // Rule ID 7751 //
     /* 201182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 201190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 201193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 201196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 201199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 201202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 201210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 201218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 201222 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 201226 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 201230 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 201234 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 201238 */     // MIs[2] Operand 1
     /* 201238 */     // No operand predicates
     /* 201238 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 201240 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1349:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 201240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_S),
     /* 201243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 201247 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 201249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 201252 */     GIR_RootConstrainSelectedInstOperands,
     /* 201253 */     // GIR_Coverage, 7751,
     /* 201253 */     GIR_EraseRootFromParent_Done,
     /* 201254 */   // Label 3974: @201254
     /* 201254 */   GIM_Try, /*On fail goto*//*Label 3975*/ GIMT_Encode4(201331), // Rule ID 7752 //
     /* 201259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 201267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 201270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 201273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 201276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 201279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 201287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 201295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 201299 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 201303 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 201307 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 201311 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 201315 */     // MIs[2] Operand 1
     /* 201315 */     // No operand predicates
     /* 201315 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 201317 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1349:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 201317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_S),
     /* 201320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 201324 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 201326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 201329 */     GIR_RootConstrainSelectedInstOperands,
     /* 201330 */     // GIR_Coverage, 7752,
     /* 201330 */     GIR_EraseRootFromParent_Done,
     /* 201331 */   // Label 3975: @201331
     /* 201331 */   GIM_Try, /*On fail goto*//*Label 3976*/ GIMT_Encode4(201408), // Rule ID 7753 //
     /* 201336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 201344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 201347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 201350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 201353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 201356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 201364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 201372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 201376 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 201380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 201384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 201388 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 201392 */     // MIs[2] Operand 1
     /* 201392 */     // No operand predicates
     /* 201392 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 201394 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1349:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 201394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_D),
     /* 201397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 201401 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 201403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 201406 */     GIR_RootConstrainSelectedInstOperands,
     /* 201407 */     // GIR_Coverage, 7753,
     /* 201407 */     GIR_EraseRootFromParent_Done,
     /* 201408 */   // Label 3976: @201408
     /* 201408 */   GIM_Try, /*On fail goto*//*Label 3977*/ GIMT_Encode4(201485), // Rule ID 7754 //
     /* 201413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 201421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 201424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 201427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 201430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 201433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 201441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 201449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 201453 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 201457 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 201461 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 201465 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 201469 */     // MIs[2] Operand 1
     /* 201469 */     // No operand predicates
     /* 201469 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 201471 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1349:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 201471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_D),
     /* 201474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 201478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 201480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 201483 */     GIR_RootConstrainSelectedInstOperands,
     /* 201484 */     // GIR_Coverage, 7754,
     /* 201484 */     GIR_EraseRootFromParent_Done,
     /* 201485 */   // Label 3977: @201485
     /* 201485 */   GIM_Try, /*On fail goto*//*Label 3978*/ GIMT_Encode4(201541), // Rule ID 55 //
     /* 201490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 201493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 201498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 201507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201515 */     // MIs[0] Operand 3
     /* 201515 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 201526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 201530 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACIA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 201530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIA),
     /* 201533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 201537 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 201539 */     GIR_RootConstrainSelectedInstOperands,
     /* 201540 */     // GIR_Coverage, 55,
     /* 201540 */     GIR_EraseRootFromParent_Done,
     /* 201541 */   // Label 3978: @201541
     /* 201541 */   GIM_Try, /*On fail goto*//*Label 3979*/ GIMT_Encode4(201597), // Rule ID 56 //
     /* 201546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 201549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 201554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 201563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201571 */     // MIs[0] Operand 3
     /* 201571 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 201582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 201586 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACIB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 201586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIB),
     /* 201589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 201593 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 201595 */     GIR_RootConstrainSelectedInstOperands,
     /* 201596 */     // GIR_Coverage, 56,
     /* 201596 */     GIR_EraseRootFromParent_Done,
     /* 201597 */   // Label 3979: @201597
     /* 201597 */   GIM_Try, /*On fail goto*//*Label 3980*/ GIMT_Encode4(201653), // Rule ID 57 //
     /* 201602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 201605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 201610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 201619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201627 */     // MIs[0] Operand 3
     /* 201627 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 201638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 201642 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACDA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 201642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDA),
     /* 201645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 201649 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 201651 */     GIR_RootConstrainSelectedInstOperands,
     /* 201652 */     // GIR_Coverage, 57,
     /* 201652 */     GIR_EraseRootFromParent_Done,
     /* 201653 */   // Label 3980: @201653
     /* 201653 */   GIM_Try, /*On fail goto*//*Label 3981*/ GIMT_Encode4(201709), // Rule ID 58 //
     /* 201658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 201661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 201666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 201675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201683 */     // MIs[0] Operand 3
     /* 201683 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 201694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 201698 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACDB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 201698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDB),
     /* 201701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 201705 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 201707 */     GIR_RootConstrainSelectedInstOperands,
     /* 201708 */     // GIR_Coverage, 58,
     /* 201708 */     GIR_EraseRootFromParent_Done,
     /* 201709 */   // Label 3981: @201709
     /* 201709 */   GIM_Try, /*On fail goto*//*Label 3982*/ GIMT_Encode4(201764), // Rule ID 2785 //
     /* 201714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 201717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
     /* 201722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 201725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 201728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 201731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201743 */     // MIs[0] imm
     /* 201743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201746 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 201751 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1448:{ *:[iPTR] }, ZPR16:{ *:[nxv8f16] }:$Zn, ZPR16:{ *:[nxv8f16] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_H:{ *:[nxv8f16] } ZPR16:{ *:[nxv8f16] }:$Zn, ZPR16:{ *:[nxv8f16] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
     /* 201751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_H),
     /* 201754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 201758 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 201760 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 201762 */     GIR_RootConstrainSelectedInstOperands,
     /* 201763 */     // GIR_Coverage, 2785,
     /* 201763 */     GIR_EraseRootFromParent_Done,
     /* 201764 */   // Label 3982: @201764
     /* 201764 */   GIM_Try, /*On fail goto*//*Label 3983*/ GIMT_Encode4(201819), // Rule ID 2786 //
     /* 201769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 201772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
     /* 201777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 201780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 201783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 201786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201798 */     // MIs[0] imm
     /* 201798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201801 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 201806 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1448:{ *:[iPTR] }, ZPR32:{ *:[nxv4f32] }:$Zn, ZPR32:{ *:[nxv4f32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_S:{ *:[nxv4f32] } ZPR32:{ *:[nxv4f32] }:$Zn, ZPR32:{ *:[nxv4f32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
     /* 201806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_S),
     /* 201809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 201813 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 201815 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 201817 */     GIR_RootConstrainSelectedInstOperands,
     /* 201818 */     // GIR_Coverage, 2786,
     /* 201818 */     GIR_EraseRootFromParent_Done,
     /* 201819 */   // Label 3983: @201819
     /* 201819 */   GIM_Try, /*On fail goto*//*Label 3984*/ GIMT_Encode4(201874), // Rule ID 2787 //
     /* 201824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 201827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
     /* 201832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 201835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 201838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 201841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201853 */     // MIs[0] imm
     /* 201853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201856 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 201861 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1448:{ *:[iPTR] }, ZPR64:{ *:[nxv2f64] }:$Zn, ZPR64:{ *:[nxv2f64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_D:{ *:[nxv2f64] } ZPR64:{ *:[nxv2f64] }:$Zn, ZPR64:{ *:[nxv2f64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
     /* 201861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_D),
     /* 201864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 201868 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 201870 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 201872 */     GIR_RootConstrainSelectedInstOperands,
     /* 201873 */     // GIR_Coverage, 2787,
     /* 201873 */     GIR_EraseRootFromParent_Done,
     /* 201874 */   // Label 3984: @201874
     /* 201874 */   GIM_Try, /*On fail goto*//*Label 3985*/ GIMT_Encode4(201929), // Rule ID 3532 //
     /* 201879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 201882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
     /* 201887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 201890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 201893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 201896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201908 */     // MIs[0] Idx
     /* 201908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201911 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_1),
     /* 201916 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1534:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zd, PPR16:{ *:[nxv8i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_1>>:$Idx)  =>  (PMOV_ZIP_H:{ *:[nxv8i16] } ZPRAny:{ *:[nxv8i16] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_1>>:$Idx, PPR16:{ *:[nxv8i1] }:$Pn)
     /* 201916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_H),
     /* 201919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 201921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zd
     /* 201923 */     GIR_RootToRootCopy, /*OpIdx*/4, // Idx
     /* 201925 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pn
     /* 201927 */     GIR_RootConstrainSelectedInstOperands,
     /* 201928 */     // GIR_Coverage, 3532,
     /* 201928 */     GIR_EraseRootFromParent_Done,
     /* 201929 */   // Label 3985: @201929
     /* 201929 */   GIM_Try, /*On fail goto*//*Label 3986*/ GIMT_Encode4(201984), // Rule ID 3533 //
     /* 201934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 201937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
     /* 201942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 201945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 201948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 201951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201963 */     // MIs[0] Idx
     /* 201963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201966 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_3),
     /* 201971 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1534:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zd, PPR32:{ *:[nxv4i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_3>>:$Idx)  =>  (PMOV_ZIP_S:{ *:[nxv4i32] } ZPRAny:{ *:[nxv4i32] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_3>>:$Idx, PPR32:{ *:[nxv4i1] }:$Pn)
     /* 201971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_S),
     /* 201974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 201976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zd
     /* 201978 */     GIR_RootToRootCopy, /*OpIdx*/4, // Idx
     /* 201980 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pn
     /* 201982 */     GIR_RootConstrainSelectedInstOperands,
     /* 201983 */     // GIR_Coverage, 3533,
     /* 201983 */     GIR_EraseRootFromParent_Done,
     /* 201984 */   // Label 3986: @201984
     /* 201984 */   GIM_Try, /*On fail goto*//*Label 3987*/ GIMT_Encode4(202039), // Rule ID 3534 //
     /* 201989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 201992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
     /* 201997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 202000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 202003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 202006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202018 */     // MIs[0] Idx
     /* 202018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202021 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_7),
     /* 202026 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1534:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zd, PPR64:{ *:[nxv2i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_7>>:$Idx)  =>  (PMOV_ZIP_D:{ *:[nxv2i64] } ZPRAny:{ *:[nxv2i64] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_7>>:$Idx, PPR64:{ *:[nxv2i1] }:$Pn)
     /* 202026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_D),
     /* 202029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zd
     /* 202033 */     GIR_RootToRootCopy, /*OpIdx*/4, // Idx
     /* 202035 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pn
     /* 202037 */     GIR_RootConstrainSelectedInstOperands,
     /* 202038 */     // GIR_Coverage, 3534,
     /* 202038 */     GIR_EraseRootFromParent_Done,
     /* 202039 */   // Label 3987: @202039
     /* 202039 */   GIM_Try, /*On fail goto*//*Label 3988*/ GIMT_Encode4(202094), // Rule ID 3786 //
     /* 202044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 202047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_xar),
     /* 202052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 202055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 202058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 202061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202073 */     // MIs[0] imm
     /* 202073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202076 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm0_63),
     /* 202081 */     // (intrinsic_wo_chain:{ *:[v2i64] } 543:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_timm0_63>>:$imm)  =>  (XAR:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_timm0_63>>:$imm)
     /* 202081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR),
     /* 202084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 202086 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 202088 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 202090 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 202092 */     GIR_RootConstrainSelectedInstOperands,
     /* 202093 */     // GIR_Coverage, 3786,
     /* 202093 */     GIR_EraseRootFromParent_Done,
     /* 202094 */   // Label 3988: @202094
     /* 202094 */   GIM_Try, /*On fail goto*//*Label 3989*/ GIMT_Encode4(202141), // Rule ID 2839 //
     /* 202099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
     /* 202107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 202110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 202113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 202116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202120 */     // MIs[0] idx
     /* 202120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202123 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 202128 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1384:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMUL_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
     /* 202128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_H),
     /* 202131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202135 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202137 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 202139 */     GIR_RootConstrainSelectedInstOperands,
     /* 202140 */     // GIR_Coverage, 2839,
     /* 202140 */     GIR_EraseRootFromParent_Done,
     /* 202141 */   // Label 3989: @202141
     /* 202141 */   GIM_Try, /*On fail goto*//*Label 3990*/ GIMT_Encode4(202188), // Rule ID 2840 //
     /* 202146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
     /* 202154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 202157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 202160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 202163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202167 */     // MIs[0] idx
     /* 202167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202170 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 202175 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1384:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMUL_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 202175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_S),
     /* 202178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202182 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202184 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 202186 */     GIR_RootConstrainSelectedInstOperands,
     /* 202187 */     // GIR_Coverage, 2840,
     /* 202187 */     GIR_EraseRootFromParent_Done,
     /* 202188 */   // Label 3990: @202188
     /* 202188 */   GIM_Try, /*On fail goto*//*Label 3991*/ GIMT_Encode4(202235), // Rule ID 2841 //
     /* 202193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
     /* 202201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 202204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 202207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 202210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202214 */     // MIs[0] idx
     /* 202214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202217 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 202222 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1384:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMUL_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 202222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_D),
     /* 202225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202229 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202231 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 202233 */     GIR_RootConstrainSelectedInstOperands,
     /* 202234 */     // GIR_Coverage, 2841,
     /* 202234 */     GIR_EraseRootFromParent_Done,
     /* 202235 */   // Label 3991: @202235
     /* 202235 */   GIM_Try, /*On fail goto*//*Label 3992*/ GIMT_Encode4(202282), // Rule ID 2990 //
     /* 202240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
     /* 202248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 202251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 202254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 202257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202261 */     // MIs[0] Op3
     /* 202261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202264 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 202269 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1515:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (MUL_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 202269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_H),
     /* 202272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202274 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202276 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202278 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 202280 */     GIR_RootConstrainSelectedInstOperands,
     /* 202281 */     // GIR_Coverage, 2990,
     /* 202281 */     GIR_EraseRootFromParent_Done,
     /* 202282 */   // Label 3992: @202282
     /* 202282 */   GIM_Try, /*On fail goto*//*Label 3993*/ GIMT_Encode4(202329), // Rule ID 2991 //
     /* 202287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
     /* 202295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 202298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 202301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 202304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202308 */     // MIs[0] Op3
     /* 202308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202311 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 202316 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1515:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (MUL_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 202316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_S),
     /* 202319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202323 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202325 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 202327 */     GIR_RootConstrainSelectedInstOperands,
     /* 202328 */     // GIR_Coverage, 2991,
     /* 202328 */     GIR_EraseRootFromParent_Done,
     /* 202329 */   // Label 3993: @202329
     /* 202329 */   GIM_Try, /*On fail goto*//*Label 3994*/ GIMT_Encode4(202376), // Rule ID 2992 //
     /* 202334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
     /* 202342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 202345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 202348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 202351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202355 */     // MIs[0] Op3
     /* 202355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202358 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 202363 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1515:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (MUL_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
     /* 202363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_D),
     /* 202366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202370 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202372 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 202374 */     GIR_RootConstrainSelectedInstOperands,
     /* 202375 */     // GIR_Coverage, 2992,
     /* 202375 */     GIR_EraseRootFromParent_Done,
     /* 202376 */   // Label 3994: @202376
     /* 202376 */   GIM_Try, /*On fail goto*//*Label 3995*/ GIMT_Encode4(202423), // Rule ID 2993 //
     /* 202381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb_lane),
     /* 202389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 202392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 202395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 202398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202402 */     // MIs[0] Op3
     /* 202402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202405 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 202410 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1661:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 202410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZI_S),
     /* 202413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202417 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202419 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 202421 */     GIR_RootConstrainSelectedInstOperands,
     /* 202422 */     // GIR_Coverage, 2993,
     /* 202422 */     GIR_EraseRootFromParent_Done,
     /* 202423 */   // Label 3995: @202423
     /* 202423 */   GIM_Try, /*On fail goto*//*Label 3996*/ GIMT_Encode4(202470), // Rule ID 2994 //
     /* 202428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb_lane),
     /* 202436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 202439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 202442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 202445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202449 */     // MIs[0] Op3
     /* 202449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202452 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 202457 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1661:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 202457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZI_D),
     /* 202460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202462 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202464 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202466 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 202468 */     GIR_RootConstrainSelectedInstOperands,
     /* 202469 */     // GIR_Coverage, 2994,
     /* 202469 */     GIR_EraseRootFromParent_Done,
     /* 202470 */   // Label 3996: @202470
     /* 202470 */   GIM_Try, /*On fail goto*//*Label 3997*/ GIMT_Encode4(202517), // Rule ID 3042 //
     /* 202475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 202483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 202486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 202489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 202492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202496 */     // MIs[0] Op3
     /* 202496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202499 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 202504 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1772:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 202504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_B),
     /* 202507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 202509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202511 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202513 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 202515 */     GIR_RootConstrainSelectedInstOperands,
     /* 202516 */     // GIR_Coverage, 3042,
     /* 202516 */     GIR_EraseRootFromParent_Done,
     /* 202517 */   // Label 3997: @202517
     /* 202517 */   GIM_Try, /*On fail goto*//*Label 3998*/ GIMT_Encode4(202564), // Rule ID 3044 //
     /* 202522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 202530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 202533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 202536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 202539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202543 */     // MIs[0] Op3
     /* 202543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202546 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 202551 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1772:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 202551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_H),
     /* 202554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 202556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202558 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202560 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 202562 */     GIR_RootConstrainSelectedInstOperands,
     /* 202563 */     // GIR_Coverage, 3044,
     /* 202563 */     GIR_EraseRootFromParent_Done,
     /* 202564 */   // Label 3998: @202564
     /* 202564 */   GIM_Try, /*On fail goto*//*Label 3999*/ GIMT_Encode4(202611), // Rule ID 3046 //
     /* 202569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 202577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 202580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 202583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 202586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202590 */     // MIs[0] Op3
     /* 202590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202593 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 202598 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1772:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 202598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_S),
     /* 202601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 202603 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202605 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202607 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 202609 */     GIR_RootConstrainSelectedInstOperands,
     /* 202610 */     // GIR_Coverage, 3046,
     /* 202610 */     GIR_EraseRootFromParent_Done,
     /* 202611 */   // Label 3999: @202611
     /* 202611 */   GIM_Try, /*On fail goto*//*Label 4000*/ GIMT_Encode4(202658), // Rule ID 3048 //
     /* 202616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 202624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 202627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 202630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 202633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202637 */     // MIs[0] Op3
     /* 202637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202640 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 202645 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1772:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 202645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_D),
     /* 202648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 202650 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202652 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202654 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 202656 */     GIR_RootConstrainSelectedInstOperands,
     /* 202657 */     // GIR_Coverage, 3048,
     /* 202657 */     GIR_EraseRootFromParent_Done,
     /* 202658 */   // Label 4000: @202658
     /* 202658 */   GIM_Try, /*On fail goto*//*Label 4001*/ GIMT_Encode4(202705), // Rule ID 3070 //
     /* 202663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
     /* 202671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 202674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 202677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 202680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202684 */     // MIs[0] Op3
     /* 202684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202687 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 202692 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1752:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQSHRUNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 202692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_B),
     /* 202695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202699 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202701 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 202703 */     GIR_RootConstrainSelectedInstOperands,
     /* 202704 */     // GIR_Coverage, 3070,
     /* 202704 */     GIR_EraseRootFromParent_Done,
     /* 202705 */   // Label 4001: @202705
     /* 202705 */   GIM_Try, /*On fail goto*//*Label 4002*/ GIMT_Encode4(202752), // Rule ID 3071 //
     /* 202710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
     /* 202718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 202721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 202724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 202727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202731 */     // MIs[0] Op3
     /* 202731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202734 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 202739 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1752:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQSHRUNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 202739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_H),
     /* 202742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202746 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202748 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 202750 */     GIR_RootConstrainSelectedInstOperands,
     /* 202751 */     // GIR_Coverage, 3071,
     /* 202751 */     GIR_EraseRootFromParent_Done,
     /* 202752 */   // Label 4002: @202752
     /* 202752 */   GIM_Try, /*On fail goto*//*Label 4003*/ GIMT_Encode4(202799), // Rule ID 3072 //
     /* 202757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
     /* 202765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 202768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 202771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 202774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202778 */     // MIs[0] Op3
     /* 202778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202781 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 202786 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1752:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQSHRUNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 202786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_S),
     /* 202789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202791 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202793 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202795 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 202797 */     GIR_RootConstrainSelectedInstOperands,
     /* 202798 */     // GIR_Coverage, 3072,
     /* 202798 */     GIR_EraseRootFromParent_Done,
     /* 202799 */   // Label 4003: @202799
     /* 202799 */   GIM_Try, /*On fail goto*//*Label 4004*/ GIMT_Encode4(202846), // Rule ID 3141 //
     /* 202804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 202812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 202815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 202818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 202821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202825 */     // MIs[0] Op3
     /* 202825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202828 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 202833 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2053:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (XAR_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 202833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_B),
     /* 202836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202840 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202842 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 202844 */     GIR_RootConstrainSelectedInstOperands,
     /* 202845 */     // GIR_Coverage, 3141,
     /* 202845 */     GIR_EraseRootFromParent_Done,
     /* 202846 */   // Label 4004: @202846
     /* 202846 */   GIM_Try, /*On fail goto*//*Label 4005*/ GIMT_Encode4(202893), // Rule ID 3142 //
     /* 202851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 202859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 202862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 202865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 202868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202872 */     // MIs[0] Op3
     /* 202872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202875 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 202880 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2053:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (XAR_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 202880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_H),
     /* 202883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202887 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202889 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 202891 */     GIR_RootConstrainSelectedInstOperands,
     /* 202892 */     // GIR_Coverage, 3142,
     /* 202892 */     GIR_EraseRootFromParent_Done,
     /* 202893 */   // Label 4005: @202893
     /* 202893 */   GIM_Try, /*On fail goto*//*Label 4006*/ GIMT_Encode4(202940), // Rule ID 3143 //
     /* 202898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 202906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 202909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 202912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 202915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202919 */     // MIs[0] Op3
     /* 202919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202922 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 202927 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2053:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (XAR_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 202927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_S),
     /* 202930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202934 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202936 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 202938 */     GIR_RootConstrainSelectedInstOperands,
     /* 202939 */     // GIR_Coverage, 3143,
     /* 202939 */     GIR_EraseRootFromParent_Done,
     /* 202940 */   // Label 4006: @202940
     /* 202940 */   GIM_Try, /*On fail goto*//*Label 4007*/ GIMT_Encode4(202987), // Rule ID 3144 //
     /* 202945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 202953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 202956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 202959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 202962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202966 */     // MIs[0] Op3
     /* 202966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202969 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 202974 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2053:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (XAR_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 202974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_D),
     /* 202977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202979 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202981 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202983 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 202985 */     GIR_RootConstrainSelectedInstOperands,
     /* 202986 */     // GIR_Coverage, 3144,
     /* 202986 */     GIR_EraseRootFromParent_Done,
     /* 202987 */   // Label 4007: @202987
     /* 202987 */   GIM_Try, /*On fail goto*//*Label 4008*/ GIMT_Encode4(203034), // Rule ID 3517 //
     /* 202992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 202995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_extq),
     /* 203000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 203003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 203006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 203009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203013 */     // MIs[0] Op3
     /* 203013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203016 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_15),
     /* 203021 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1263:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_15>>:$Op3)  =>  (EXTQ_ZZI:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_15>>:$Op3)
     /* 203021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTQ_ZZI),
     /* 203024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 203026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203028 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203030 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 203032 */     GIR_RootConstrainSelectedInstOperands,
     /* 203033 */     // GIR_Coverage, 3517,
     /* 203033 */     GIR_EraseRootFromParent_Done,
     /* 203034 */   // Label 4008: @203034
     /* 203034 */   GIM_Try, /*On fail goto*//*Label 4009*/ GIMT_Encode4(203081), // Rule ID 3565 //
     /* 203039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 203042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
     /* 203047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 203050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 203053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 203056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203060 */     // MIs[0] Op3
     /* 203060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203063 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 203068 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1502:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI2_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
     /* 203068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_B),
     /* 203071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203075 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203077 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 203079 */     GIR_RootConstrainSelectedInstOperands,
     /* 203080 */     // GIR_Coverage, 3565,
     /* 203080 */     GIR_EraseRootFromParent_Done,
     /* 203081 */   // Label 4009: @203081
     /* 203081 */   GIM_Try, /*On fail goto*//*Label 4010*/ GIMT_Encode4(203128), // Rule ID 3566 //
     /* 203086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 203089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
     /* 203094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 203097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 203100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 203103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203107 */     // MIs[0] Op3
     /* 203107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203110 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 203115 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1502:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)  =>  (LUTI2_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)
     /* 203115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_H),
     /* 203118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203120 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203122 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203124 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 203126 */     GIR_RootConstrainSelectedInstOperands,
     /* 203127 */     // GIR_Coverage, 3566,
     /* 203127 */     GIR_EraseRootFromParent_Done,
     /* 203128 */   // Label 4010: @203128
     /* 203128 */   GIM_Try, /*On fail goto*//*Label 4011*/ GIMT_Encode4(203175), // Rule ID 3567 //
     /* 203133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 203136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
     /* 203141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 203144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 203147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 203150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203154 */     // MIs[0] Op3
     /* 203154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203157 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 203162 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1502:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)  =>  (LUTI2_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)
     /* 203162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_H),
     /* 203165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203169 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203171 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 203173 */     GIR_RootConstrainSelectedInstOperands,
     /* 203174 */     // GIR_Coverage, 3567,
     /* 203174 */     GIR_EraseRootFromParent_Done,
     /* 203175 */   // Label 4011: @203175
     /* 203175 */   GIM_Try, /*On fail goto*//*Label 4012*/ GIMT_Encode4(203222), // Rule ID 3568 //
     /* 203180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 203183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
     /* 203188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 203191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 203194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 203197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203201 */     // MIs[0] Op3
     /* 203201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203204 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 203209 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1503:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Op3)  =>  (LUTI4_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Op3)
     /* 203209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_B),
     /* 203212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203214 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203216 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203218 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 203220 */     GIR_RootConstrainSelectedInstOperands,
     /* 203221 */     // GIR_Coverage, 3568,
     /* 203221 */     GIR_EraseRootFromParent_Done,
     /* 203222 */   // Label 4012: @203222
     /* 203222 */   GIM_Try, /*On fail goto*//*Label 4013*/ GIMT_Encode4(203269), // Rule ID 3569 //
     /* 203227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 203230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
     /* 203235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 203238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 203241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 203244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203248 */     // MIs[0] Op3
     /* 203248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203251 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 203256 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1503:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI4_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
     /* 203256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_H),
     /* 203259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203263 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203265 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 203267 */     GIR_RootConstrainSelectedInstOperands,
     /* 203268 */     // GIR_Coverage, 3569,
     /* 203268 */     GIR_EraseRootFromParent_Done,
     /* 203269 */   // Label 4013: @203269
     /* 203269 */   GIM_Try, /*On fail goto*//*Label 4014*/ GIMT_Encode4(203316), // Rule ID 3570 //
     /* 203274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 203277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
     /* 203282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 203285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 203288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 203291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203295 */     // MIs[0] Op3
     /* 203295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203298 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 203303 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1503:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI4_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
     /* 203303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_H),
     /* 203306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203310 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203312 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 203314 */     GIR_RootConstrainSelectedInstOperands,
     /* 203315 */     // GIR_Coverage, 3570,
     /* 203315 */     GIR_EraseRootFromParent_Done,
     /* 203316 */   // Label 4014: @203316
     /* 203316 */   GIM_Try, /*On fail goto*//*Label 4015*/ GIMT_Encode4(203363), // Rule ID 11123 //
     /* 203321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
     /* 203329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 203332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 203335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 203338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203342 */     // MIs[0] Op3
     /* 203342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203345 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 203350 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1702:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 203350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_H),
     /* 203353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203355 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203357 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203359 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 203361 */     GIR_RootConstrainSelectedInstOperands,
     /* 203362 */     // GIR_Coverage, 11123,
     /* 203362 */     GIR_EraseRootFromParent_Done,
     /* 203363 */   // Label 4015: @203363
     /* 203363 */   GIM_Try, /*On fail goto*//*Label 4016*/ GIMT_Encode4(203410), // Rule ID 11124 //
     /* 203368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
     /* 203376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 203382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203389 */     // MIs[0] Op3
     /* 203389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203392 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 203397 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1702:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 203397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_S),
     /* 203400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203404 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203406 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 203408 */     GIR_RootConstrainSelectedInstOperands,
     /* 203409 */     // GIR_Coverage, 11124,
     /* 203409 */     GIR_EraseRootFromParent_Done,
     /* 203410 */   // Label 4016: @203410
     /* 203410 */   GIM_Try, /*On fail goto*//*Label 4017*/ GIMT_Encode4(203457), // Rule ID 11125 //
     /* 203415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
     /* 203423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 203426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 203429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 203432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203436 */     // MIs[0] Op3
     /* 203436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203439 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 203444 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1702:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
     /* 203444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_D),
     /* 203447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203451 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203453 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 203455 */     GIR_RootConstrainSelectedInstOperands,
     /* 203456 */     // GIR_Coverage, 11125,
     /* 203456 */     GIR_EraseRootFromParent_Done,
     /* 203457 */   // Label 4017: @203457
     /* 203457 */   GIM_Try, /*On fail goto*//*Label 4018*/ GIMT_Encode4(203504), // Rule ID 11126 //
     /* 203462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
     /* 203470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 203473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 203476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 203479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203483 */     // MIs[0] Op3
     /* 203483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203486 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 203491 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1733:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 203491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_H),
     /* 203494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203500 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 203502 */     GIR_RootConstrainSelectedInstOperands,
     /* 203503 */     // GIR_Coverage, 11126,
     /* 203503 */     GIR_EraseRootFromParent_Done,
     /* 203504 */   // Label 4018: @203504
     /* 203504 */   GIM_Try, /*On fail goto*//*Label 4019*/ GIMT_Encode4(203551), // Rule ID 11127 //
     /* 203509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
     /* 203517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 203523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203530 */     // MIs[0] Op3
     /* 203530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203533 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 203538 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1733:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 203538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_S),
     /* 203541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203545 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203547 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 203549 */     GIR_RootConstrainSelectedInstOperands,
     /* 203550 */     // GIR_Coverage, 11127,
     /* 203550 */     GIR_EraseRootFromParent_Done,
     /* 203551 */   // Label 4019: @203551
     /* 203551 */   GIM_Try, /*On fail goto*//*Label 4020*/ GIMT_Encode4(203598), // Rule ID 11128 //
     /* 203556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
     /* 203564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 203567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 203570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 203573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203577 */     // MIs[0] Op3
     /* 203577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203580 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 203585 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1733:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
     /* 203585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_D),
     /* 203588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203592 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203594 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 203596 */     GIR_RootConstrainSelectedInstOperands,
     /* 203597 */     // GIR_Coverage, 11128,
     /* 203597 */     GIR_EraseRootFromParent_Done,
     /* 203598 */   // Label 4020: @203598
     /* 203598 */   GIM_Try, /*On fail goto*//*Label 4021*/ GIMT_Encode4(203645), // Rule ID 11151 //
     /* 203603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt_lane),
     /* 203611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 203617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 203620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203624 */     // MIs[0] Op3
     /* 203624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203627 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 203632 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1663:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 203632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZI_S),
     /* 203635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203639 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203641 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 203643 */     GIR_RootConstrainSelectedInstOperands,
     /* 203644 */     // GIR_Coverage, 11151,
     /* 203644 */     GIR_EraseRootFromParent_Done,
     /* 203645 */   // Label 4021: @203645
     /* 203645 */   GIM_Try, /*On fail goto*//*Label 4022*/ GIMT_Encode4(203692), // Rule ID 11152 //
     /* 203650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt_lane),
     /* 203658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 203661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 203664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203671 */     // MIs[0] Op3
     /* 203671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203674 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 203679 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1663:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 203679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZI_D),
     /* 203682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203684 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203686 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203688 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 203690 */     GIR_RootConstrainSelectedInstOperands,
     /* 203691 */     // GIR_Coverage, 11152,
     /* 203691 */     GIR_EraseRootFromParent_Done,
     /* 203692 */   // Label 4022: @203692
     /* 203692 */   GIM_Try, /*On fail goto*//*Label 4023*/ GIMT_Encode4(203739), // Rule ID 11153 //
     /* 203697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb_lane),
     /* 203705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 203711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 203714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203718 */     // MIs[0] Op3
     /* 203718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203721 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 203726 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1899:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (UMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 203726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZI_S),
     /* 203729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203733 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203735 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 203737 */     GIR_RootConstrainSelectedInstOperands,
     /* 203738 */     // GIR_Coverage, 11153,
     /* 203738 */     GIR_EraseRootFromParent_Done,
     /* 203739 */   // Label 4023: @203739
     /* 203739 */   GIM_Try, /*On fail goto*//*Label 4024*/ GIMT_Encode4(203786), // Rule ID 11154 //
     /* 203744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb_lane),
     /* 203752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 203755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 203758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203765 */     // MIs[0] Op3
     /* 203765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203768 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 203773 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1899:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (UMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 203773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZI_D),
     /* 203776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203782 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 203784 */     GIR_RootConstrainSelectedInstOperands,
     /* 203785 */     // GIR_Coverage, 11154,
     /* 203785 */     GIR_EraseRootFromParent_Done,
     /* 203786 */   // Label 4024: @203786
     /* 203786 */   GIM_Try, /*On fail goto*//*Label 4025*/ GIMT_Encode4(203833), // Rule ID 11155 //
     /* 203791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt_lane),
     /* 203799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 203805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 203808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203812 */     // MIs[0] Op3
     /* 203812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203815 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 203820 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1901:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (UMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 203820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZI_S),
     /* 203823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203827 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203829 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 203831 */     GIR_RootConstrainSelectedInstOperands,
     /* 203832 */     // GIR_Coverage, 11155,
     /* 203832 */     GIR_EraseRootFromParent_Done,
     /* 203833 */   // Label 4025: @203833
     /* 203833 */   GIM_Try, /*On fail goto*//*Label 4026*/ GIMT_Encode4(203880), // Rule ID 11156 //
     /* 203838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt_lane),
     /* 203846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 203849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 203852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203859 */     // MIs[0] Op3
     /* 203859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203862 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 203867 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1901:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (UMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 203867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZI_D),
     /* 203870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203872 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203874 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203876 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 203878 */     GIR_RootConstrainSelectedInstOperands,
     /* 203879 */     // GIR_Coverage, 11156,
     /* 203879 */     GIR_EraseRootFromParent_Done,
     /* 203880 */   // Label 4026: @203880
     /* 203880 */   GIM_Try, /*On fail goto*//*Label 4027*/ GIMT_Encode4(203927), // Rule ID 11157 //
     /* 203885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb_lane),
     /* 203893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 203899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 203902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203906 */     // MIs[0] Op3
     /* 203906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203909 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 203914 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1708:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 203914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZI_S),
     /* 203917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203921 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203923 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 203925 */     GIR_RootConstrainSelectedInstOperands,
     /* 203926 */     // GIR_Coverage, 11157,
     /* 203926 */     GIR_EraseRootFromParent_Done,
     /* 203927 */   // Label 4027: @203927
     /* 203927 */   GIM_Try, /*On fail goto*//*Label 4028*/ GIMT_Encode4(203974), // Rule ID 11158 //
     /* 203932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb_lane),
     /* 203940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 203943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 203946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203953 */     // MIs[0] Op3
     /* 203953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 203956 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 203961 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1708:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 203961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZI_D),
     /* 203964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203970 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 203972 */     GIR_RootConstrainSelectedInstOperands,
     /* 203973 */     // GIR_Coverage, 11158,
     /* 203973 */     GIR_EraseRootFromParent_Done,
     /* 203974 */   // Label 4028: @203974
     /* 203974 */   GIM_Try, /*On fail goto*//*Label 4029*/ GIMT_Encode4(204021), // Rule ID 11159 //
     /* 203979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt_lane),
     /* 203987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 203993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 203996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204000 */     // MIs[0] Op3
     /* 204000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204003 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 204008 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1710:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 204008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZI_S),
     /* 204011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204015 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204017 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204019 */     GIR_RootConstrainSelectedInstOperands,
     /* 204020 */     // GIR_Coverage, 11159,
     /* 204020 */     GIR_EraseRootFromParent_Done,
     /* 204021 */   // Label 4029: @204021
     /* 204021 */   GIM_Try, /*On fail goto*//*Label 4030*/ GIMT_Encode4(204068), // Rule ID 11160 //
     /* 204026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt_lane),
     /* 204034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 204040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204047 */     // MIs[0] Op3
     /* 204047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204050 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 204055 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1710:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 204055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZI_D),
     /* 204058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204062 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204064 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204066 */     GIR_RootConstrainSelectedInstOperands,
     /* 204067 */     // GIR_Coverage, 11160,
     /* 204067 */     GIR_EraseRootFromParent_Done,
     /* 204068 */   // Label 4030: @204068
     /* 204068 */   GIM_Try, /*On fail goto*//*Label 4031*/ GIMT_Encode4(204115), // Rule ID 11404 //
     /* 204073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 204081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 204084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 204087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 204090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204094 */     // MIs[0] Op3
     /* 204094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204097 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 204102 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1768:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SRSHR_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 204102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_B),
     /* 204105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204109 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204111 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204113 */     GIR_RootConstrainSelectedInstOperands,
     /* 204114 */     // GIR_Coverage, 11404,
     /* 204114 */     GIR_EraseRootFromParent_Done,
     /* 204115 */   // Label 4031: @204115
     /* 204115 */   GIM_Try, /*On fail goto*//*Label 4032*/ GIMT_Encode4(204162), // Rule ID 11405 //
     /* 204120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 204128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 204134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204141 */     // MIs[0] Op3
     /* 204141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204144 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 204149 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1768:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SRSHR_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 204149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_H),
     /* 204152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204154 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204156 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204158 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204160 */     GIR_RootConstrainSelectedInstOperands,
     /* 204161 */     // GIR_Coverage, 11405,
     /* 204161 */     GIR_EraseRootFromParent_Done,
     /* 204162 */   // Label 4032: @204162
     /* 204162 */   GIM_Try, /*On fail goto*//*Label 4033*/ GIMT_Encode4(204209), // Rule ID 11406 //
     /* 204167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 204175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 204181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204188 */     // MIs[0] Op3
     /* 204188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204191 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 204196 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1768:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SRSHR_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 204196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_S),
     /* 204199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204203 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204205 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204207 */     GIR_RootConstrainSelectedInstOperands,
     /* 204208 */     // GIR_Coverage, 11406,
     /* 204208 */     GIR_EraseRootFromParent_Done,
     /* 204209 */   // Label 4033: @204209
     /* 204209 */   GIM_Try, /*On fail goto*//*Label 4034*/ GIMT_Encode4(204256), // Rule ID 11407 //
     /* 204214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 204222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 204228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204235 */     // MIs[0] Op3
     /* 204235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204238 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 204243 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1768:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SRSHR_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 204243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_D),
     /* 204246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204250 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204252 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204254 */     GIR_RootConstrainSelectedInstOperands,
     /* 204255 */     // GIR_Coverage, 11407,
     /* 204255 */     GIR_EraseRootFromParent_Done,
     /* 204256 */   // Label 4034: @204256
     /* 204256 */   GIM_Try, /*On fail goto*//*Label 4035*/ GIMT_Encode4(204303), // Rule ID 11408 //
     /* 204261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 204269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 204272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 204275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 204278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204282 */     // MIs[0] Op3
     /* 204282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204285 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 204290 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1959:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (URSHR_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 204290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_B),
     /* 204293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204297 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204299 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204301 */     GIR_RootConstrainSelectedInstOperands,
     /* 204302 */     // GIR_Coverage, 11408,
     /* 204302 */     GIR_EraseRootFromParent_Done,
     /* 204303 */   // Label 4035: @204303
     /* 204303 */   GIM_Try, /*On fail goto*//*Label 4036*/ GIMT_Encode4(204350), // Rule ID 11410 //
     /* 204308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 204316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 204322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204329 */     // MIs[0] Op3
     /* 204329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204332 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 204337 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1959:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (URSHR_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 204337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_H),
     /* 204340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204346 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204348 */     GIR_RootConstrainSelectedInstOperands,
     /* 204349 */     // GIR_Coverage, 11410,
     /* 204349 */     GIR_EraseRootFromParent_Done,
     /* 204350 */   // Label 4036: @204350
     /* 204350 */   GIM_Try, /*On fail goto*//*Label 4037*/ GIMT_Encode4(204397), // Rule ID 11412 //
     /* 204355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 204363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 204369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204376 */     // MIs[0] Op3
     /* 204376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204379 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 204384 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1959:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (URSHR_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 204384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_S),
     /* 204387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204391 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204393 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204395 */     GIR_RootConstrainSelectedInstOperands,
     /* 204396 */     // GIR_Coverage, 11412,
     /* 204396 */     GIR_EraseRootFromParent_Done,
     /* 204397 */   // Label 4037: @204397
     /* 204397 */   GIM_Try, /*On fail goto*//*Label 4038*/ GIMT_Encode4(204444), // Rule ID 11414 //
     /* 204402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 204410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 204416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204423 */     // MIs[0] Op3
     /* 204423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204426 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 204431 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1959:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (URSHR_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 204431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_D),
     /* 204434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204438 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204440 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204442 */     GIR_RootConstrainSelectedInstOperands,
     /* 204443 */     // GIR_Coverage, 11414,
     /* 204443 */     GIR_EraseRootFromParent_Done,
     /* 204444 */   // Label 4038: @204444
     /* 204444 */   GIM_Try, /*On fail goto*//*Label 4039*/ GIMT_Encode4(204491), // Rule ID 11416 //
     /* 204449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 204457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 204460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 204463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 204466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204470 */     // MIs[0] Op3
     /* 204470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204473 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 204478 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1748:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op3)  =>  (SQSHLU_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op3)
     /* 204478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_B),
     /* 204481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204485 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204487 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204489 */     GIR_RootConstrainSelectedInstOperands,
     /* 204490 */     // GIR_Coverage, 11416,
     /* 204490 */     GIR_EraseRootFromParent_Done,
     /* 204491 */   // Label 4039: @204491
     /* 204491 */   GIM_Try, /*On fail goto*//*Label 4040*/ GIMT_Encode4(204538), // Rule ID 11417 //
     /* 204496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 204504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 204510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204517 */     // MIs[0] Op3
     /* 204517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204520 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 204525 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1748:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op3)  =>  (SQSHLU_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op3)
     /* 204525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_H),
     /* 204528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204532 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204534 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204536 */     GIR_RootConstrainSelectedInstOperands,
     /* 204537 */     // GIR_Coverage, 11417,
     /* 204537 */     GIR_EraseRootFromParent_Done,
     /* 204538 */   // Label 4040: @204538
     /* 204538 */   GIM_Try, /*On fail goto*//*Label 4041*/ GIMT_Encode4(204585), // Rule ID 11418 //
     /* 204543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 204551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 204557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204564 */     // MIs[0] Op3
     /* 204564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204567 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 204572 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1748:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op3)  =>  (SQSHLU_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op3)
     /* 204572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_S),
     /* 204575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204579 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204581 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204583 */     GIR_RootConstrainSelectedInstOperands,
     /* 204584 */     // GIR_Coverage, 11418,
     /* 204584 */     GIR_EraseRootFromParent_Done,
     /* 204585 */   // Label 4041: @204585
     /* 204585 */   GIM_Try, /*On fail goto*//*Label 4042*/ GIMT_Encode4(204632), // Rule ID 11419 //
     /* 204590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 204598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 204604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204611 */     // MIs[0] Op3
     /* 204611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204614 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL64),
     /* 204619 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1748:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL64>>:$Op3)  =>  (SQSHLU_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL64>>:$Op3)
     /* 204619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_D),
     /* 204622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204626 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204628 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204630 */     GIR_RootConstrainSelectedInstOperands,
     /* 204631 */     // GIR_Coverage, 11419,
     /* 204631 */     GIR_EraseRootFromParent_Done,
     /* 204632 */   // Label 4042: @204632
     /* 204632 */   GIM_Try, /*On fail goto*//*Label 4043*/ GIMT_Encode4(204679), // Rule ID 11494 //
     /* 204637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 204645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 204648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 204651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 204654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204658 */     // MIs[0] Op3
     /* 204658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204661 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 204666 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1968:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (USRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 204666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_B),
     /* 204669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 204671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204673 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204675 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204677 */     GIR_RootConstrainSelectedInstOperands,
     /* 204678 */     // GIR_Coverage, 11494,
     /* 204678 */     GIR_EraseRootFromParent_Done,
     /* 204679 */   // Label 4043: @204679
     /* 204679 */   GIM_Try, /*On fail goto*//*Label 4044*/ GIMT_Encode4(204726), // Rule ID 11496 //
     /* 204684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 204692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 204698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204705 */     // MIs[0] Op3
     /* 204705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204708 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 204713 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1968:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (USRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 204713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_H),
     /* 204716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 204718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204720 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204722 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204724 */     GIR_RootConstrainSelectedInstOperands,
     /* 204725 */     // GIR_Coverage, 11496,
     /* 204725 */     GIR_EraseRootFromParent_Done,
     /* 204726 */   // Label 4044: @204726
     /* 204726 */   GIM_Try, /*On fail goto*//*Label 4045*/ GIMT_Encode4(204773), // Rule ID 11498 //
     /* 204731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 204739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 204745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204752 */     // MIs[0] Op3
     /* 204752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204755 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 204760 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1968:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (USRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 204760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_S),
     /* 204763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 204765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204767 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204769 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204771 */     GIR_RootConstrainSelectedInstOperands,
     /* 204772 */     // GIR_Coverage, 11498,
     /* 204772 */     GIR_EraseRootFromParent_Done,
     /* 204773 */   // Label 4045: @204773
     /* 204773 */   GIM_Try, /*On fail goto*//*Label 4046*/ GIMT_Encode4(204820), // Rule ID 11500 //
     /* 204778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 204786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 204792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204799 */     // MIs[0] Op3
     /* 204799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204802 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 204807 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1968:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (USRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 204807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_D),
     /* 204810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 204812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204814 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204816 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204818 */     GIR_RootConstrainSelectedInstOperands,
     /* 204819 */     // GIR_Coverage, 11500,
     /* 204819 */     GIR_EraseRootFromParent_Done,
     /* 204820 */   // Label 4046: @204820
     /* 204820 */   GIM_Try, /*On fail goto*//*Label 4047*/ GIMT_Encode4(204867), // Rule ID 11502 //
     /* 204825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 204833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 204836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 204839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 204842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204846 */     // MIs[0] Op3
     /* 204846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204849 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 204854 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1769:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SRSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 204854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_B),
     /* 204857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 204859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204861 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204863 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204865 */     GIR_RootConstrainSelectedInstOperands,
     /* 204866 */     // GIR_Coverage, 11502,
     /* 204866 */     GIR_EraseRootFromParent_Done,
     /* 204867 */   // Label 4047: @204867
     /* 204867 */   GIM_Try, /*On fail goto*//*Label 4048*/ GIMT_Encode4(204914), // Rule ID 11503 //
     /* 204872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 204880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 204886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204893 */     // MIs[0] Op3
     /* 204893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204896 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 204901 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1769:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SRSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 204901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_H),
     /* 204904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 204906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204908 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204910 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204912 */     GIR_RootConstrainSelectedInstOperands,
     /* 204913 */     // GIR_Coverage, 11503,
     /* 204913 */     GIR_EraseRootFromParent_Done,
     /* 204914 */   // Label 4048: @204914
     /* 204914 */   GIM_Try, /*On fail goto*//*Label 4049*/ GIMT_Encode4(204961), // Rule ID 11504 //
     /* 204919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 204927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 204933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204940 */     // MIs[0] Op3
     /* 204940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204943 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 204948 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1769:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SRSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 204948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_S),
     /* 204951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 204953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204955 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204957 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 204959 */     GIR_RootConstrainSelectedInstOperands,
     /* 204960 */     // GIR_Coverage, 11504,
     /* 204960 */     GIR_EraseRootFromParent_Done,
     /* 204961 */   // Label 4049: @204961
     /* 204961 */   GIM_Try, /*On fail goto*//*Label 4050*/ GIMT_Encode4(205008), // Rule ID 11505 //
     /* 204966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 204974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 204980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204987 */     // MIs[0] Op3
     /* 204987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 204990 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 204995 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1769:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SRSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 204995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_D),
     /* 204998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 205000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205002 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205004 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205006 */     GIR_RootConstrainSelectedInstOperands,
     /* 205007 */     // GIR_Coverage, 11505,
     /* 205007 */     GIR_EraseRootFromParent_Done,
     /* 205008 */   // Label 4050: @205008
     /* 205008 */   GIM_Try, /*On fail goto*//*Label 4051*/ GIMT_Encode4(205055), // Rule ID 11510 //
     /* 205013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 205021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 205024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 205027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 205030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205034 */     // MIs[0] Op3
     /* 205034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205037 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 205042 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1961:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (URSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 205042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_B),
     /* 205045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 205047 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205049 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205051 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205053 */     GIR_RootConstrainSelectedInstOperands,
     /* 205054 */     // GIR_Coverage, 11510,
     /* 205054 */     GIR_EraseRootFromParent_Done,
     /* 205055 */   // Label 4051: @205055
     /* 205055 */   GIM_Try, /*On fail goto*//*Label 4052*/ GIMT_Encode4(205102), // Rule ID 11511 //
     /* 205060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 205068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 205074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205081 */     // MIs[0] Op3
     /* 205081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205084 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 205089 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1961:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (URSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 205089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_H),
     /* 205092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 205094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205096 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205098 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205100 */     GIR_RootConstrainSelectedInstOperands,
     /* 205101 */     // GIR_Coverage, 11511,
     /* 205101 */     GIR_EraseRootFromParent_Done,
     /* 205102 */   // Label 4052: @205102
     /* 205102 */   GIM_Try, /*On fail goto*//*Label 4053*/ GIMT_Encode4(205149), // Rule ID 11512 //
     /* 205107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 205115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205128 */     // MIs[0] Op3
     /* 205128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205131 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 205136 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1961:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (URSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 205136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_S),
     /* 205139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 205141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205143 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205145 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205147 */     GIR_RootConstrainSelectedInstOperands,
     /* 205148 */     // GIR_Coverage, 11512,
     /* 205148 */     GIR_EraseRootFromParent_Done,
     /* 205149 */   // Label 4053: @205149
     /* 205149 */   GIM_Try, /*On fail goto*//*Label 4054*/ GIMT_Encode4(205196), // Rule ID 11513 //
     /* 205154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 205162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 205168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205175 */     // MIs[0] Op3
     /* 205175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205178 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 205183 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1961:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (URSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 205183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_D),
     /* 205186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 205188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205190 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205192 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205194 */     GIR_RootConstrainSelectedInstOperands,
     /* 205195 */     // GIR_Coverage, 11513,
     /* 205195 */     GIR_EraseRootFromParent_Done,
     /* 205196 */   // Label 4054: @205196
     /* 205196 */   GIM_Try, /*On fail goto*//*Label 4055*/ GIMT_Encode4(205243), // Rule ID 11573 //
     /* 205201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
     /* 205209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 205212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 205215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205222 */     // MIs[0] Op3
     /* 205222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205225 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 205230 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1746:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQRSHRUNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 205230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_B),
     /* 205233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205235 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205237 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205239 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205241 */     GIR_RootConstrainSelectedInstOperands,
     /* 205242 */     // GIR_Coverage, 11573,
     /* 205242 */     GIR_EraseRootFromParent_Done,
     /* 205243 */   // Label 4055: @205243
     /* 205243 */   GIM_Try, /*On fail goto*//*Label 4056*/ GIMT_Encode4(205290), // Rule ID 11574 //
     /* 205248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
     /* 205256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 205262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205269 */     // MIs[0] Op3
     /* 205269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205272 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 205277 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1746:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQRSHRUNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 205277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_H),
     /* 205280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205282 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205284 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205286 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205288 */     GIR_RootConstrainSelectedInstOperands,
     /* 205289 */     // GIR_Coverage, 11574,
     /* 205289 */     GIR_EraseRootFromParent_Done,
     /* 205290 */   // Label 4056: @205290
     /* 205290 */   GIM_Try, /*On fail goto*//*Label 4057*/ GIMT_Encode4(205337), // Rule ID 11575 //
     /* 205295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
     /* 205303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205316 */     // MIs[0] Op3
     /* 205316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205319 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 205324 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1746:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQRSHRUNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 205324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_S),
     /* 205327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205329 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205331 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205333 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205335 */     GIR_RootConstrainSelectedInstOperands,
     /* 205336 */     // GIR_Coverage, 11575,
     /* 205336 */     GIR_EraseRootFromParent_Done,
     /* 205337 */   // Label 4057: @205337
     /* 205337 */   GIM_Try, /*On fail goto*//*Label 4058*/ GIMT_Encode4(205384), // Rule ID 11576 //
     /* 205342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
     /* 205350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 205353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 205356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205363 */     // MIs[0] Op3
     /* 205363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205366 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 205371 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1625:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 205371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_B),
     /* 205374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205378 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205380 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205382 */     GIR_RootConstrainSelectedInstOperands,
     /* 205383 */     // GIR_Coverage, 11576,
     /* 205383 */     GIR_EraseRootFromParent_Done,
     /* 205384 */   // Label 4058: @205384
     /* 205384 */   GIM_Try, /*On fail goto*//*Label 4059*/ GIMT_Encode4(205431), // Rule ID 11577 //
     /* 205389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
     /* 205397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 205403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205410 */     // MIs[0] Op3
     /* 205410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205413 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 205418 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1625:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 205418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_H),
     /* 205421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205425 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205427 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205429 */     GIR_RootConstrainSelectedInstOperands,
     /* 205430 */     // GIR_Coverage, 11577,
     /* 205430 */     GIR_EraseRootFromParent_Done,
     /* 205431 */   // Label 4059: @205431
     /* 205431 */   GIM_Try, /*On fail goto*//*Label 4060*/ GIMT_Encode4(205478), // Rule ID 11578 //
     /* 205436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
     /* 205444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205457 */     // MIs[0] Op3
     /* 205457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205460 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 205465 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1625:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 205465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_S),
     /* 205468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205472 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205474 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205476 */     GIR_RootConstrainSelectedInstOperands,
     /* 205477 */     // GIR_Coverage, 11578,
     /* 205477 */     GIR_EraseRootFromParent_Done,
     /* 205478 */   // Label 4060: @205478
     /* 205478 */   GIM_Try, /*On fail goto*//*Label 4061*/ GIMT_Encode4(205525), // Rule ID 11579 //
     /* 205483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
     /* 205491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 205494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 205497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205504 */     // MIs[0] Op3
     /* 205504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205507 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 205512 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1583:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (RSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 205512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_B),
     /* 205515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205519 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205521 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205523 */     GIR_RootConstrainSelectedInstOperands,
     /* 205524 */     // GIR_Coverage, 11579,
     /* 205524 */     GIR_EraseRootFromParent_Done,
     /* 205525 */   // Label 4061: @205525
     /* 205525 */   GIM_Try, /*On fail goto*//*Label 4062*/ GIMT_Encode4(205572), // Rule ID 11580 //
     /* 205530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
     /* 205538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 205544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205551 */     // MIs[0] Op3
     /* 205551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205554 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 205559 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1583:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (RSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 205559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_H),
     /* 205562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205566 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205568 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205570 */     GIR_RootConstrainSelectedInstOperands,
     /* 205571 */     // GIR_Coverage, 11580,
     /* 205571 */     GIR_EraseRootFromParent_Done,
     /* 205572 */   // Label 4062: @205572
     /* 205572 */   GIM_Try, /*On fail goto*//*Label 4063*/ GIMT_Encode4(205619), // Rule ID 11581 //
     /* 205577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
     /* 205585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205598 */     // MIs[0] Op3
     /* 205598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205601 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 205606 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1583:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (RSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 205606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_S),
     /* 205609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205613 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205615 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205617 */     GIR_RootConstrainSelectedInstOperands,
     /* 205618 */     // GIR_Coverage, 11581,
     /* 205618 */     GIR_EraseRootFromParent_Done,
     /* 205619 */   // Label 4063: @205619
     /* 205619 */   GIM_Try, /*On fail goto*//*Label 4064*/ GIMT_Encode4(205666), // Rule ID 11582 //
     /* 205624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
     /* 205632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 205635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 205638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205645 */     // MIs[0] Op3
     /* 205645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205648 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 205653 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1750:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 205653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_B),
     /* 205656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205658 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205660 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205662 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205664 */     GIR_RootConstrainSelectedInstOperands,
     /* 205665 */     // GIR_Coverage, 11582,
     /* 205665 */     GIR_EraseRootFromParent_Done,
     /* 205666 */   // Label 4064: @205666
     /* 205666 */   GIM_Try, /*On fail goto*//*Label 4065*/ GIMT_Encode4(205713), // Rule ID 11583 //
     /* 205671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
     /* 205679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 205685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205692 */     // MIs[0] Op3
     /* 205692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205695 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 205700 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1750:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 205700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_H),
     /* 205703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205707 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205709 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205711 */     GIR_RootConstrainSelectedInstOperands,
     /* 205712 */     // GIR_Coverage, 11583,
     /* 205712 */     GIR_EraseRootFromParent_Done,
     /* 205713 */   // Label 4065: @205713
     /* 205713 */   GIM_Try, /*On fail goto*//*Label 4066*/ GIMT_Encode4(205760), // Rule ID 11584 //
     /* 205718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
     /* 205726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205739 */     // MIs[0] Op3
     /* 205739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205742 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 205747 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1750:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 205747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_S),
     /* 205750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205754 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205756 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205758 */     GIR_RootConstrainSelectedInstOperands,
     /* 205759 */     // GIR_Coverage, 11584,
     /* 205759 */     GIR_EraseRootFromParent_Done,
     /* 205760 */   // Label 4066: @205760
     /* 205760 */   GIM_Try, /*On fail goto*//*Label 4067*/ GIMT_Encode4(205807), // Rule ID 11585 //
     /* 205765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
     /* 205773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 205776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 205779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205786 */     // MIs[0] Op3
     /* 205786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205789 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 205794 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1740:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQRSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 205794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_B),
     /* 205797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205799 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205801 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205803 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205805 */     GIR_RootConstrainSelectedInstOperands,
     /* 205806 */     // GIR_Coverage, 11585,
     /* 205806 */     GIR_EraseRootFromParent_Done,
     /* 205807 */   // Label 4067: @205807
     /* 205807 */   GIM_Try, /*On fail goto*//*Label 4068*/ GIMT_Encode4(205854), // Rule ID 11586 //
     /* 205812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
     /* 205820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 205826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205833 */     // MIs[0] Op3
     /* 205833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205836 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 205841 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1740:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQRSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 205841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_H),
     /* 205844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205848 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205850 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205852 */     GIR_RootConstrainSelectedInstOperands,
     /* 205853 */     // GIR_Coverage, 11586,
     /* 205853 */     GIR_EraseRootFromParent_Done,
     /* 205854 */   // Label 4068: @205854
     /* 205854 */   GIM_Try, /*On fail goto*//*Label 4069*/ GIMT_Encode4(205901), // Rule ID 11587 //
     /* 205859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
     /* 205867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205880 */     // MIs[0] Op3
     /* 205880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205883 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 205888 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1740:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQRSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 205888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_S),
     /* 205891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205895 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205897 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205899 */     GIR_RootConstrainSelectedInstOperands,
     /* 205900 */     // GIR_Coverage, 11587,
     /* 205900 */     GIR_EraseRootFromParent_Done,
     /* 205901 */   // Label 4069: @205901
     /* 205901 */   GIM_Try, /*On fail goto*//*Label 4070*/ GIMT_Encode4(205948), // Rule ID 11588 //
     /* 205906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
     /* 205914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 205917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 205920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205927 */     // MIs[0] Op3
     /* 205927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205930 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 205935 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1945:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (UQSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 205935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_B),
     /* 205938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205940 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205942 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205944 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205946 */     GIR_RootConstrainSelectedInstOperands,
     /* 205947 */     // GIR_Coverage, 11588,
     /* 205947 */     GIR_EraseRootFromParent_Done,
     /* 205948 */   // Label 4070: @205948
     /* 205948 */   GIM_Try, /*On fail goto*//*Label 4071*/ GIMT_Encode4(205995), // Rule ID 11589 //
     /* 205953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
     /* 205961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 205967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205974 */     // MIs[0] Op3
     /* 205974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 205977 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 205982 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1945:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (UQSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 205982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_H),
     /* 205985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205989 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205991 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 205993 */     GIR_RootConstrainSelectedInstOperands,
     /* 205994 */     // GIR_Coverage, 11589,
     /* 205994 */     GIR_EraseRootFromParent_Done,
     /* 205995 */   // Label 4071: @205995
     /* 205995 */   GIM_Try, /*On fail goto*//*Label 4072*/ GIMT_Encode4(206042), // Rule ID 11590 //
     /* 206000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
     /* 206008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206021 */     // MIs[0] Op3
     /* 206021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 206024 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 206029 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1945:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (UQSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 206029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_S),
     /* 206032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206036 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206038 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 206040 */     GIR_RootConstrainSelectedInstOperands,
     /* 206041 */     // GIR_Coverage, 11590,
     /* 206041 */     GIR_EraseRootFromParent_Done,
     /* 206042 */   // Label 4072: @206042
     /* 206042 */   GIM_Try, /*On fail goto*//*Label 4073*/ GIMT_Encode4(206089), // Rule ID 11591 //
     /* 206047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
     /* 206055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 206058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 206061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206068 */     // MIs[0] Op3
     /* 206068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 206071 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 206076 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1942:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (UQRSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 206076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_B),
     /* 206079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206083 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206085 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 206087 */     GIR_RootConstrainSelectedInstOperands,
     /* 206088 */     // GIR_Coverage, 11591,
     /* 206088 */     GIR_EraseRootFromParent_Done,
     /* 206089 */   // Label 4073: @206089
     /* 206089 */   GIM_Try, /*On fail goto*//*Label 4074*/ GIMT_Encode4(206136), // Rule ID 11592 //
     /* 206094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
     /* 206102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206115 */     // MIs[0] Op3
     /* 206115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 206118 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 206123 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1942:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (UQRSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 206123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_H),
     /* 206126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206130 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206132 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 206134 */     GIR_RootConstrainSelectedInstOperands,
     /* 206135 */     // GIR_Coverage, 11592,
     /* 206135 */     GIR_EraseRootFromParent_Done,
     /* 206136 */   // Label 4074: @206136
     /* 206136 */   GIM_Try, /*On fail goto*//*Label 4075*/ GIMT_Encode4(206183), // Rule ID 11593 //
     /* 206141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
     /* 206149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206162 */     // MIs[0] Op3
     /* 206162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 206165 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 206170 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1942:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (UQRSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 206170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_S),
     /* 206173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206175 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206177 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206179 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 206181 */     GIR_RootConstrainSelectedInstOperands,
     /* 206182 */     // GIR_Coverage, 11593,
     /* 206182 */     GIR_EraseRootFromParent_Done,
     /* 206183 */   // Label 4075: @206183
     /* 206183 */   GIM_Try, /*On fail goto*//*Label 4076*/ GIMT_Encode4(206250), // Rule ID 2590 //
     /* 206188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 206191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urecpe),
     /* 206196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 206205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 206208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 206216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 206220 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206222 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1952:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (URECPE_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 206222 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 206225 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 206229 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206234 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 206236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPE_ZPmZ_S_UNDEF),
     /* 206239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206241 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 206244 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 206246 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 206248 */     GIR_RootConstrainSelectedInstOperands,
     /* 206249 */     // GIR_Coverage, 2590,
     /* 206249 */     GIR_EraseRootFromParent_Done,
     /* 206250 */   // Label 4076: @206250
     /* 206250 */   GIM_Try, /*On fail goto*//*Label 4077*/ GIMT_Encode4(206317), // Rule ID 7552 //
     /* 206255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 206263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 206266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 206269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 206272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 206275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 206283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 206287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206289 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1216:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CLS_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 206289 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 206292 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 206296 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206301 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 206303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_B_UNDEF),
     /* 206306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206308 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 206311 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 206313 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 206315 */     GIR_RootConstrainSelectedInstOperands,
     /* 206316 */     // GIR_Coverage, 7552,
     /* 206316 */     GIR_EraseRootFromParent_Done,
     /* 206317 */   // Label 4077: @206317
     /* 206317 */   GIM_Try, /*On fail goto*//*Label 4078*/ GIMT_Encode4(206384), // Rule ID 7554 //
     /* 206322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 206330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 206339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 206342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 206350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 206354 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206356 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1216:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CLS_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 206356 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 206359 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 206363 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206368 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 206370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_H_UNDEF),
     /* 206373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206375 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 206378 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 206380 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 206382 */     GIR_RootConstrainSelectedInstOperands,
     /* 206383 */     // GIR_Coverage, 7554,
     /* 206383 */     GIR_EraseRootFromParent_Done,
     /* 206384 */   // Label 4078: @206384
     /* 206384 */   GIM_Try, /*On fail goto*//*Label 4079*/ GIMT_Encode4(206451), // Rule ID 7556 //
     /* 206389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 206397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 206406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 206409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 206417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 206421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206423 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1216:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CLS_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 206423 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 206426 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 206430 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206435 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 206437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_S_UNDEF),
     /* 206440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206442 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 206445 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 206447 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 206449 */     GIR_RootConstrainSelectedInstOperands,
     /* 206450 */     // GIR_Coverage, 7556,
     /* 206450 */     GIR_EraseRootFromParent_Done,
     /* 206451 */   // Label 4079: @206451
     /* 206451 */   GIM_Try, /*On fail goto*//*Label 4080*/ GIMT_Encode4(206518), // Rule ID 7558 //
     /* 206456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 206464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 206470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 206473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 206476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 206484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 206488 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206490 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1216:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CLS_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 206490 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 206493 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 206497 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206502 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 206504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_D_UNDEF),
     /* 206507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206509 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 206512 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 206514 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 206516 */     GIR_RootConstrainSelectedInstOperands,
     /* 206517 */     // GIR_Coverage, 7558,
     /* 206517 */     GIR_EraseRootFromParent_Done,
     /* 206518 */   // Label 4080: @206518
     /* 206518 */   GIM_Try, /*On fail goto*//*Label 4081*/ GIMT_Encode4(206585), // Rule ID 7588 //
     /* 206523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 206531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 206534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 206537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 206540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 206543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 206551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 206555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206557 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1236:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CNOT_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 206557 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 206560 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 206564 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206569 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 206571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_B_UNDEF),
     /* 206574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206576 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 206579 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 206581 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 206583 */     GIR_RootConstrainSelectedInstOperands,
     /* 206584 */     // GIR_Coverage, 7588,
     /* 206584 */     GIR_EraseRootFromParent_Done,
     /* 206585 */   // Label 4081: @206585
     /* 206585 */   GIM_Try, /*On fail goto*//*Label 4082*/ GIMT_Encode4(206652), // Rule ID 7590 //
     /* 206590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 206598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 206607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 206610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 206618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 206622 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206624 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1236:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CNOT_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 206624 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 206627 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 206631 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206636 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 206638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_H_UNDEF),
     /* 206641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206643 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 206646 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 206648 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 206650 */     GIR_RootConstrainSelectedInstOperands,
     /* 206651 */     // GIR_Coverage, 7590,
     /* 206651 */     GIR_EraseRootFromParent_Done,
     /* 206652 */   // Label 4082: @206652
     /* 206652 */   GIM_Try, /*On fail goto*//*Label 4083*/ GIMT_Encode4(206719), // Rule ID 7592 //
     /* 206657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 206665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 206674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 206677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 206685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 206689 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206691 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1236:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CNOT_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 206691 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 206694 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 206698 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206703 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 206705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_S_UNDEF),
     /* 206708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206710 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 206713 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 206715 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 206717 */     GIR_RootConstrainSelectedInstOperands,
     /* 206718 */     // GIR_Coverage, 7592,
     /* 206718 */     GIR_EraseRootFromParent_Done,
     /* 206719 */   // Label 4083: @206719
     /* 206719 */   GIM_Try, /*On fail goto*//*Label 4084*/ GIMT_Encode4(206786), // Rule ID 7594 //
     /* 206724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 206732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 206738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 206741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 206744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 206752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 206756 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206758 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1236:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CNOT_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 206758 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 206761 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 206765 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206770 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 206772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_D_UNDEF),
     /* 206775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206777 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 206780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 206782 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 206784 */     GIR_RootConstrainSelectedInstOperands,
     /* 206785 */     // GIR_Coverage, 7594,
     /* 206785 */     GIR_EraseRootFromParent_Done,
     /* 206786 */   // Label 4084: @206786
     /* 206786 */   GIM_Try, /*On fail goto*//*Label 4085*/ GIMT_Encode4(206853), // Rule ID 7600 //
     /* 206791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 206799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 206802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 206805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 206808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 206811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 206819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 206823 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206825 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1522:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (NOT_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 206825 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 206828 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 206832 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206837 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 206839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_B_UNDEF),
     /* 206842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206844 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 206847 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 206849 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 206851 */     GIR_RootConstrainSelectedInstOperands,
     /* 206852 */     // GIR_Coverage, 7600,
     /* 206852 */     GIR_EraseRootFromParent_Done,
     /* 206853 */   // Label 4085: @206853
     /* 206853 */   GIM_Try, /*On fail goto*//*Label 4086*/ GIMT_Encode4(206920), // Rule ID 7602 //
     /* 206858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 206866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 206875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 206878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 206886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 206890 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206892 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1522:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (NOT_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 206892 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 206895 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 206899 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206904 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 206906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_H_UNDEF),
     /* 206909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206911 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 206914 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 206916 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 206918 */     GIR_RootConstrainSelectedInstOperands,
     /* 206919 */     // GIR_Coverage, 7602,
     /* 206919 */     GIR_EraseRootFromParent_Done,
     /* 206920 */   // Label 4086: @206920
     /* 206920 */   GIM_Try, /*On fail goto*//*Label 4087*/ GIMT_Encode4(206987), // Rule ID 7604 //
     /* 206925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 206933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 206942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 206945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 206953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 206957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206959 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1522:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (NOT_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 206959 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 206962 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 206966 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206971 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 206973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_S_UNDEF),
     /* 206976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206978 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 206981 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 206983 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 206985 */     GIR_RootConstrainSelectedInstOperands,
     /* 206986 */     // GIR_Coverage, 7604,
     /* 206986 */     GIR_EraseRootFromParent_Done,
     /* 206987 */   // Label 4087: @206987
     /* 206987 */   GIM_Try, /*On fail goto*//*Label 4088*/ GIMT_Encode4(207054), // Rule ID 7606 //
     /* 206992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 207000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 207009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 207012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 207020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 207024 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207026 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1522:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (NOT_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 207026 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 207029 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 207033 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207038 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 207040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_D_UNDEF),
     /* 207043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207045 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 207048 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 207050 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 207052 */     GIR_RootConstrainSelectedInstOperands,
     /* 207053 */     // GIR_Coverage, 7606,
     /* 207053 */     GIR_EraseRootFromParent_Done,
     /* 207054 */   // Label 4088: @207054
     /* 207054 */   GIM_Try, /*On fail goto*//*Label 4089*/ GIMT_Encode4(207121), // Rule ID 11286 //
     /* 207059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursqrte),
     /* 207067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 207076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 207079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 207087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 207091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207093 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1960:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (URSQRTE_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 207093 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 207096 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 207100 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207105 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 207107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTE_ZPmZ_S_UNDEF),
     /* 207110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207112 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 207115 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 207117 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 207119 */     GIR_RootConstrainSelectedInstOperands,
     /* 207120 */     // GIR_Coverage, 11286,
     /* 207120 */     GIR_EraseRootFromParent_Done,
     /* 207121 */   // Label 4089: @207121
     /* 207121 */   GIM_Try, /*On fail goto*//*Label 4090*/ GIMT_Encode4(207188), // Rule ID 11288 //
     /* 207126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 207134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 207137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 207140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 207143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 207146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 207154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 207158 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207160 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1665:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQABS_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 207160 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 207163 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 207167 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207172 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 207174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_B_UNDEF),
     /* 207177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207179 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 207182 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 207184 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 207186 */     GIR_RootConstrainSelectedInstOperands,
     /* 207187 */     // GIR_Coverage, 11288,
     /* 207187 */     GIR_EraseRootFromParent_Done,
     /* 207188 */   // Label 4090: @207188
     /* 207188 */   GIM_Try, /*On fail goto*//*Label 4091*/ GIMT_Encode4(207255), // Rule ID 11290 //
     /* 207193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 207201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 207210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 207213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 207221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 207225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207227 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1665:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQABS_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 207227 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 207230 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 207234 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207239 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 207241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_H_UNDEF),
     /* 207244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207246 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 207249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 207251 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 207253 */     GIR_RootConstrainSelectedInstOperands,
     /* 207254 */     // GIR_Coverage, 11290,
     /* 207254 */     GIR_EraseRootFromParent_Done,
     /* 207255 */   // Label 4091: @207255
     /* 207255 */   GIM_Try, /*On fail goto*//*Label 4092*/ GIMT_Encode4(207322), // Rule ID 11292 //
     /* 207260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 207268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 207277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 207280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 207288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 207292 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207294 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1665:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQABS_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 207294 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 207297 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 207301 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207306 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 207308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_S_UNDEF),
     /* 207311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207313 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 207316 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 207318 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 207320 */     GIR_RootConstrainSelectedInstOperands,
     /* 207321 */     // GIR_Coverage, 11292,
     /* 207321 */     GIR_EraseRootFromParent_Done,
     /* 207322 */   // Label 4092: @207322
     /* 207322 */   GIM_Try, /*On fail goto*//*Label 4093*/ GIMT_Encode4(207389), // Rule ID 11294 //
     /* 207327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 207335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 207344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 207347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 207355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 207359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207361 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1665:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQABS_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 207361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 207364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 207368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207373 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 207375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_D_UNDEF),
     /* 207378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207380 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 207383 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 207385 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 207387 */     GIR_RootConstrainSelectedInstOperands,
     /* 207388 */     // GIR_Coverage, 11294,
     /* 207388 */     GIR_EraseRootFromParent_Done,
     /* 207389 */   // Label 4093: @207389
     /* 207389 */   GIM_Try, /*On fail goto*//*Label 4094*/ GIMT_Encode4(207456), // Rule ID 11300 //
     /* 207394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 207402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 207405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 207408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 207411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 207414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 207422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 207426 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207428 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1725:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQNEG_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 207428 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 207431 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 207435 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207440 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 207442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_B_UNDEF),
     /* 207445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207447 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 207450 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 207452 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 207454 */     GIR_RootConstrainSelectedInstOperands,
     /* 207455 */     // GIR_Coverage, 11300,
     /* 207455 */     GIR_EraseRootFromParent_Done,
     /* 207456 */   // Label 4094: @207456
     /* 207456 */   GIM_Try, /*On fail goto*//*Label 4095*/ GIMT_Encode4(207523), // Rule ID 11302 //
     /* 207461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 207469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 207478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 207481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 207489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 207493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207495 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1725:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQNEG_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 207495 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 207498 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 207502 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207507 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 207509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_H_UNDEF),
     /* 207512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207514 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 207517 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 207519 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 207521 */     GIR_RootConstrainSelectedInstOperands,
     /* 207522 */     // GIR_Coverage, 11302,
     /* 207522 */     GIR_EraseRootFromParent_Done,
     /* 207523 */   // Label 4095: @207523
     /* 207523 */   GIM_Try, /*On fail goto*//*Label 4096*/ GIMT_Encode4(207590), // Rule ID 11304 //
     /* 207528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 207536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 207545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 207548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 207556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 207560 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207562 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1725:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQNEG_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 207562 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 207565 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 207569 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 207576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_S_UNDEF),
     /* 207579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207581 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 207584 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 207586 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 207588 */     GIR_RootConstrainSelectedInstOperands,
     /* 207589 */     // GIR_Coverage, 11304,
     /* 207589 */     GIR_EraseRootFromParent_Done,
     /* 207590 */   // Label 4096: @207590
     /* 207590 */   GIM_Try, /*On fail goto*//*Label 4097*/ GIMT_Encode4(207657), // Rule ID 11306 //
     /* 207595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 207603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 207612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 207615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 207623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 207627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207629 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1725:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQNEG_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 207629 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 207632 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 207636 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207641 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 207643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_D_UNDEF),
     /* 207646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207648 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 207651 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 207653 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 207655 */     GIR_RootConstrainSelectedInstOperands,
     /* 207656 */     // GIR_Coverage, 11306,
     /* 207656 */     GIR_EraseRootFromParent_Done,
     /* 207657 */   // Label 4097: @207657
     /* 207657 */   GIM_Try, /*On fail goto*//*Label 4098*/ GIMT_Encode4(207711), // Rule ID 30 //
     /* 207662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /* 207665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smmla),
     /* 207670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 207673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 207676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 207679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 207682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 207686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 207690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 207694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 207698 */     // (intrinsic_wo_chain:{ *:[v4i32] } 676:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 207698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMMLA),
     /* 207701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 207705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 207707 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 207709 */     GIR_RootConstrainSelectedInstOperands,
     /* 207710 */     // GIR_Coverage, 30,
     /* 207710 */     GIR_EraseRootFromParent_Done,
     /* 207711 */   // Label 4098: @207711
     /* 207711 */   GIM_Try, /*On fail goto*//*Label 4099*/ GIMT_Encode4(207765), // Rule ID 31 //
     /* 207716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /* 207719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ummla),
     /* 207724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 207727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 207730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 207733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 207736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 207740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 207744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 207748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 207752 */     // (intrinsic_wo_chain:{ *:[v4i32] } 737:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 207752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMMLA),
     /* 207755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 207759 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 207761 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 207763 */     GIR_RootConstrainSelectedInstOperands,
     /* 207764 */     // GIR_Coverage, 31,
     /* 207764 */     GIR_EraseRootFromParent_Done,
     /* 207765 */   // Label 4099: @207765
     /* 207765 */   GIM_Try, /*On fail goto*//*Label 4100*/ GIMT_Encode4(207819), // Rule ID 32 //
     /* 207770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /* 207773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usmmla),
     /* 207778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 207781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 207784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 207787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 207790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 207794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 207798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 207802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 207806 */     // (intrinsic_wo_chain:{ *:[v4i32] } 753:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (USMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 207806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMMLA),
     /* 207809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 207813 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 207815 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 207817 */     GIR_RootConstrainSelectedInstOperands,
     /* 207818 */     // GIR_Coverage, 32,
     /* 207818 */     GIR_EraseRootFromParent_Done,
     /* 207819 */   // Label 4100: @207819
     /* 207819 */   GIM_Try, /*On fail goto*//*Label 4101*/ GIMT_Encode4(207873), // Rule ID 39 //
     /* 207824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 207827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 207832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 207835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 207838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 207841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 207844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 207848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 207852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 207856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 207860 */     // (intrinsic_wo_chain:{ *:[v2f32] } 606:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLALv4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 207860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALv4f16),
     /* 207863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 207867 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 207869 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 207871 */     GIR_RootConstrainSelectedInstOperands,
     /* 207872 */     // GIR_Coverage, 39,
     /* 207872 */     GIR_EraseRootFromParent_Done,
     /* 207873 */   // Label 4101: @207873
     /* 207873 */   GIM_Try, /*On fail goto*//*Label 4102*/ GIMT_Encode4(207927), // Rule ID 40 //
     /* 207878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 207881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 207886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 207889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 207892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 207895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 207898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 207902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 207906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 207910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 207914 */     // (intrinsic_wo_chain:{ *:[v4f32] } 606:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLALv8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 207914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALv8f16),
     /* 207917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 207921 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 207923 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 207925 */     GIR_RootConstrainSelectedInstOperands,
     /* 207926 */     // GIR_Coverage, 40,
     /* 207926 */     GIR_EraseRootFromParent_Done,
     /* 207927 */   // Label 4102: @207927
     /* 207927 */   GIM_Try, /*On fail goto*//*Label 4103*/ GIMT_Encode4(207981), // Rule ID 41 //
     /* 207932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 207935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 207940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 207943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 207946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 207949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 207952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 207956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 207960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 207964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 207968 */     // (intrinsic_wo_chain:{ *:[v2f32] } 608:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLSLv4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 207968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLv4f16),
     /* 207971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 207975 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 207977 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 207979 */     GIR_RootConstrainSelectedInstOperands,
     /* 207980 */     // GIR_Coverage, 41,
     /* 207980 */     GIR_EraseRootFromParent_Done,
     /* 207981 */   // Label 4103: @207981
     /* 207981 */   GIM_Try, /*On fail goto*//*Label 4104*/ GIMT_Encode4(208035), // Rule ID 42 //
     /* 207986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 207989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 207994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 207997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 208000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 208003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 208006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208022 */     // (intrinsic_wo_chain:{ *:[v4f32] } 608:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLSLv8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 208022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLv8f16),
     /* 208025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 208029 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 208031 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 208033 */     GIR_RootConstrainSelectedInstOperands,
     /* 208034 */     // GIR_Coverage, 42,
     /* 208034 */     GIR_EraseRootFromParent_Done,
     /* 208035 */   // Label 4104: @208035
     /* 208035 */   GIM_Try, /*On fail goto*//*Label 4105*/ GIMT_Encode4(208089), // Rule ID 43 //
     /* 208040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 208043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 208048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 208051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 208054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 208057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 208060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208076 */     // (intrinsic_wo_chain:{ *:[v2f32] } 607:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLAL2v4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 208076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2v4f16),
     /* 208079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 208083 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 208085 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 208087 */     GIR_RootConstrainSelectedInstOperands,
     /* 208088 */     // GIR_Coverage, 43,
     /* 208088 */     GIR_EraseRootFromParent_Done,
     /* 208089 */   // Label 4105: @208089
     /* 208089 */   GIM_Try, /*On fail goto*//*Label 4106*/ GIMT_Encode4(208143), // Rule ID 44 //
     /* 208094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 208097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 208102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 208105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 208108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 208111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 208114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208130 */     // (intrinsic_wo_chain:{ *:[v4f32] } 607:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLAL2v8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 208130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2v8f16),
     /* 208133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 208137 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 208139 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 208141 */     GIR_RootConstrainSelectedInstOperands,
     /* 208142 */     // GIR_Coverage, 44,
     /* 208142 */     GIR_EraseRootFromParent_Done,
     /* 208143 */   // Label 4106: @208143
     /* 208143 */   GIM_Try, /*On fail goto*//*Label 4107*/ GIMT_Encode4(208197), // Rule ID 45 //
     /* 208148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 208151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 208156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 208159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 208162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 208165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 208168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208184 */     // (intrinsic_wo_chain:{ *:[v2f32] } 609:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLSL2v4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 208184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2v4f16),
     /* 208187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 208191 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 208193 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 208195 */     GIR_RootConstrainSelectedInstOperands,
     /* 208196 */     // GIR_Coverage, 45,
     /* 208196 */     GIR_EraseRootFromParent_Done,
     /* 208197 */   // Label 4107: @208197
     /* 208197 */   GIM_Try, /*On fail goto*//*Label 4108*/ GIMT_Encode4(208251), // Rule ID 46 //
     /* 208202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 208205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 208210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 208213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 208216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 208219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 208222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208238 */     // (intrinsic_wo_chain:{ *:[v4f32] } 609:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLSL2v8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 208238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2v8f16),
     /* 208241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 208245 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 208247 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 208249 */     GIR_RootConstrainSelectedInstOperands,
     /* 208250 */     // GIR_Coverage, 46,
     /* 208250 */     GIR_EraseRootFromParent_Done,
     /* 208251 */   // Label 4108: @208251
     /* 208251 */   GIM_Try, /*On fail goto*//*Label 4109*/ GIMT_Encode4(208305), // Rule ID 1580 //
     /* 208256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 208259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 208264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 208267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 208270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 208273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 208276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208292 */     // (intrinsic_wo_chain:{ *:[v4i16] } 686:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMLAHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 208292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16),
     /* 208295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 208299 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 208301 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 208303 */     GIR_RootConstrainSelectedInstOperands,
     /* 208304 */     // GIR_Coverage, 1580,
     /* 208304 */     GIR_EraseRootFromParent_Done,
     /* 208305 */   // Label 4109: @208305
     /* 208305 */   GIM_Try, /*On fail goto*//*Label 4110*/ GIMT_Encode4(208359), // Rule ID 1581 //
     /* 208310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 208313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 208318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 208321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 208324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 208327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 208330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208346 */     // (intrinsic_wo_chain:{ *:[v8i16] } 686:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMLAHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 208346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv8i16),
     /* 208349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 208353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 208355 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 208357 */     GIR_RootConstrainSelectedInstOperands,
     /* 208358 */     // GIR_Coverage, 1581,
     /* 208358 */     GIR_EraseRootFromParent_Done,
     /* 208359 */   // Label 4110: @208359
     /* 208359 */   GIM_Try, /*On fail goto*//*Label 4111*/ GIMT_Encode4(208413), // Rule ID 1582 //
     /* 208364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 208367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 208372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 208375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 208378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 208381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 208384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208400 */     // (intrinsic_wo_chain:{ *:[v2i32] } 686:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMLAHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 208400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32),
     /* 208403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 208407 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 208409 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 208411 */     GIR_RootConstrainSelectedInstOperands,
     /* 208412 */     // GIR_Coverage, 1582,
     /* 208412 */     GIR_EraseRootFromParent_Done,
     /* 208413 */   // Label 4111: @208413
     /* 208413 */   GIM_Try, /*On fail goto*//*Label 4112*/ GIMT_Encode4(208467), // Rule ID 1583 //
     /* 208418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 208421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 208426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 208429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 208432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 208435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 208438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208454 */     // (intrinsic_wo_chain:{ *:[v4i32] } 686:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMLAHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 208454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i32),
     /* 208457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 208461 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 208463 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 208465 */     GIR_RootConstrainSelectedInstOperands,
     /* 208466 */     // GIR_Coverage, 1583,
     /* 208466 */     GIR_EraseRootFromParent_Done,
     /* 208467 */   // Label 4112: @208467
     /* 208467 */   GIM_Try, /*On fail goto*//*Label 4113*/ GIMT_Encode4(208521), // Rule ID 1584 //
     /* 208472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 208475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 208480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 208483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 208486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 208489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 208492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208508 */     // (intrinsic_wo_chain:{ *:[v4i16] } 687:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMLSHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 208508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16),
     /* 208511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 208515 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 208517 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 208519 */     GIR_RootConstrainSelectedInstOperands,
     /* 208520 */     // GIR_Coverage, 1584,
     /* 208520 */     GIR_EraseRootFromParent_Done,
     /* 208521 */   // Label 4113: @208521
     /* 208521 */   GIM_Try, /*On fail goto*//*Label 4114*/ GIMT_Encode4(208575), // Rule ID 1585 //
     /* 208526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 208529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 208534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 208537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 208540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 208543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 208546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208562 */     // (intrinsic_wo_chain:{ *:[v8i16] } 687:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMLSHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 208562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv8i16),
     /* 208565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 208569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 208571 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 208573 */     GIR_RootConstrainSelectedInstOperands,
     /* 208574 */     // GIR_Coverage, 1585,
     /* 208574 */     GIR_EraseRootFromParent_Done,
     /* 208575 */   // Label 4114: @208575
     /* 208575 */   GIM_Try, /*On fail goto*//*Label 4115*/ GIMT_Encode4(208629), // Rule ID 1586 //
     /* 208580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 208583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 208588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 208591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 208594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 208597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 208600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 208616 */     // (intrinsic_wo_chain:{ *:[v2i32] } 687:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMLSHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 208616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32),
     /* 208619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 208623 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 208625 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 208627 */     GIR_RootConstrainSelectedInstOperands,
     /* 208628 */     // GIR_Coverage, 1586,
     /* 208628 */     GIR_EraseRootFromParent_Done,
     /* 208629 */   // Label 4115: @208629
     /* 208629 */   GIM_Try, /*On fail goto*//*Label 4116*/ GIMT_Encode4(208683), // Rule ID 1587 //
     /* 208634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 208637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 208642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 208645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 208648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 208651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 208654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208670 */     // (intrinsic_wo_chain:{ *:[v4i32] } 687:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMLSHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 208670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i32),
     /* 208673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 208677 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 208679 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 208681 */     GIR_RootConstrainSelectedInstOperands,
     /* 208682 */     // GIR_Coverage, 1587,
     /* 208682 */     GIR_EraseRootFromParent_Done,
     /* 208683 */   // Label 4116: @208683
     /* 208683 */   GIM_Try, /*On fail goto*//*Label 4117*/ GIMT_Encode4(208737), // Rule ID 2298 //
     /* 208688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 208691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1c),
     /* 208696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 208699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 208702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 208705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 208708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 208720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208724 */     // (intrinsic_wo_chain:{ *:[v4i32] } 520:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Crrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 208724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Crrr),
     /* 208727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 208731 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 208733 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 208735 */     GIR_RootConstrainSelectedInstOperands,
     /* 208736 */     // GIR_Coverage, 2298,
     /* 208736 */     GIR_EraseRootFromParent_Done,
     /* 208737 */   // Label 4117: @208737
     /* 208737 */   GIM_Try, /*On fail goto*//*Label 4118*/ GIMT_Encode4(208791), // Rule ID 2299 //
     /* 208742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 208745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1p),
     /* 208750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 208753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 208756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 208759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 208762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 208774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208778 */     // (intrinsic_wo_chain:{ *:[v4i32] } 523:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Prrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 208778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Prrr),
     /* 208781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 208785 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 208787 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 208789 */     GIR_RootConstrainSelectedInstOperands,
     /* 208790 */     // GIR_Coverage, 2299,
     /* 208790 */     GIR_EraseRootFromParent_Done,
     /* 208791 */   // Label 4118: @208791
     /* 208791 */   GIM_Try, /*On fail goto*//*Label 4119*/ GIMT_Encode4(208845), // Rule ID 2300 //
     /* 208796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 208799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1m),
     /* 208804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 208807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 208810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 208813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 208816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 208828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208832 */     // (intrinsic_wo_chain:{ *:[v4i32] } 522:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Mrrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 208832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Mrrr),
     /* 208835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 208839 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 208841 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 208843 */     GIR_RootConstrainSelectedInstOperands,
     /* 208844 */     // GIR_Coverage, 2300,
     /* 208844 */     GIR_EraseRootFromParent_Done,
     /* 208845 */   // Label 4119: @208845
     /* 208845 */   GIM_Try, /*On fail goto*//*Label 4120*/ GIMT_Encode4(208899), // Rule ID 2301 //
     /* 208850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 208853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1su0),
     /* 208858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 208861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 208864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 208867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 208870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208886 */     // (intrinsic_wo_chain:{ *:[v4i32] } 524:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1SU0rrr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 208886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1SU0rrr),
     /* 208889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 208893 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 208895 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 208897 */     GIR_RootConstrainSelectedInstOperands,
     /* 208898 */     // GIR_Coverage, 2301,
     /* 208898 */     GIR_EraseRootFromParent_Done,
     /* 208899 */   // Label 4120: @208899
     /* 208899 */   GIM_Try, /*On fail goto*//*Label 4121*/ GIMT_Encode4(208953), // Rule ID 2302 //
     /* 208904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 208907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256h),
     /* 208912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 208915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 208918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 208921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 208924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208940 */     // (intrinsic_wo_chain:{ *:[v4i32] } 526:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256Hrrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 208940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256Hrrr),
     /* 208943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 208947 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 208949 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 208951 */     GIR_RootConstrainSelectedInstOperands,
     /* 208952 */     // GIR_Coverage, 2302,
     /* 208952 */     GIR_EraseRootFromParent_Done,
     /* 208953 */   // Label 4121: @208953
     /* 208953 */   GIM_Try, /*On fail goto*//*Label 4122*/ GIMT_Encode4(209007), // Rule ID 2303 //
     /* 208958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 208961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256h2),
     /* 208966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 208969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 208972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 208975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 208978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208994 */     // (intrinsic_wo_chain:{ *:[v4i32] } 527:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256H2rrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 208994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256H2rrr),
     /* 208997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208999 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 209001 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 209003 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 209005 */     GIR_RootConstrainSelectedInstOperands,
     /* 209006 */     // GIR_Coverage, 2303,
     /* 209006 */     GIR_EraseRootFromParent_Done,
     /* 209007 */   // Label 4122: @209007
     /* 209007 */   GIM_Try, /*On fail goto*//*Label 4123*/ GIMT_Encode4(209061), // Rule ID 2304 //
     /* 209012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 209015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256su1),
     /* 209020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 209023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 209026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 209029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 209032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209048 */     // (intrinsic_wo_chain:{ *:[v4i32] } 529:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256SU1rrr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 209048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256SU1rrr),
     /* 209051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 209055 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 209057 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 209059 */     GIR_RootConstrainSelectedInstOperands,
     /* 209060 */     // GIR_Coverage, 2304,
     /* 209060 */     GIR_EraseRootFromParent_Done,
     /* 209061 */   // Label 4123: @209061
     /* 209061 */   GIM_Try, /*On fail goto*//*Label 4124*/ GIMT_Encode4(209118), // Rule ID 3608 //
     /* 209066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 209069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 209074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 209077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 209080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 209083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 209086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 209090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 209094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 209098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 209102 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1557:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR8:{ *:[nxv16i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_B:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 209102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_B),
     /* 209105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 209107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 209109 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 209111 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 209113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 209116 */     GIR_RootConstrainSelectedInstOperands,
     /* 209117 */     // GIR_Coverage, 3608,
     /* 209117 */     GIR_EraseRootFromParent_Done,
     /* 209118 */   // Label 4124: @209118
     /* 209118 */   GIM_Try, /*On fail goto*//*Label 4125*/ GIMT_Encode4(209175), // Rule ID 3609 //
     /* 209123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 209126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 209131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 209134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 209137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 209140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 209143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 209147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 209151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 209155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 209159 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1557:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR16:{ *:[nxv8i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_H:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 209159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_H),
     /* 209162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 209164 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 209166 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 209168 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 209170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 209173 */     GIR_RootConstrainSelectedInstOperands,
     /* 209174 */     // GIR_Coverage, 3609,
     /* 209174 */     GIR_EraseRootFromParent_Done,
     /* 209175 */   // Label 4125: @209175
     /* 209175 */   GIM_Try, /*On fail goto*//*Label 4126*/ GIMT_Encode4(209232), // Rule ID 3610 //
     /* 209180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 209183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 209188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 209191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 209194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 209197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 209200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 209204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 209208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 209212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 209216 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1557:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR32:{ *:[nxv4i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_S:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 209216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_S),
     /* 209219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 209221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 209223 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 209225 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 209227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 209230 */     GIR_RootConstrainSelectedInstOperands,
     /* 209231 */     // GIR_Coverage, 3610,
     /* 209231 */     GIR_EraseRootFromParent_Done,
     /* 209232 */   // Label 4126: @209232
     /* 209232 */   GIM_Try, /*On fail goto*//*Label 4127*/ GIMT_Encode4(209289), // Rule ID 3611 //
     /* 209237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 209240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 209245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 209248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 209251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 209254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 209257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 209261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 209265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 209269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 209273 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1557:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR64:{ *:[nxv2i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_D:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 209273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_D),
     /* 209276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 209278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 209280 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 209282 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 209284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 209287 */     GIR_RootConstrainSelectedInstOperands,
     /* 209288 */     // GIR_Coverage, 3611,
     /* 209288 */     GIR_EraseRootFromParent_Done,
     /* 209289 */   // Label 4127: @209289
     /* 209289 */   GIM_Try, /*On fail goto*//*Label 4128*/ GIMT_Encode4(209343), // Rule ID 3758 //
     /* 209294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 209297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512h),
     /* 209302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 209305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 209308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 209311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 209314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209330 */     // (intrinsic_wo_chain:{ *:[v2i64] } 530:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512H:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 209330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512H),
     /* 209333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 209335 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 209337 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 209339 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 209341 */     GIR_RootConstrainSelectedInstOperands,
     /* 209342 */     // GIR_Coverage, 3758,
     /* 209342 */     GIR_EraseRootFromParent_Done,
     /* 209343 */   // Label 4128: @209343
     /* 209343 */   GIM_Try, /*On fail goto*//*Label 4129*/ GIMT_Encode4(209397), // Rule ID 3759 //
     /* 209348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 209351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512h2),
     /* 209356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 209359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 209362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 209365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 209368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209384 */     // (intrinsic_wo_chain:{ *:[v2i64] } 531:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512H2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 209384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512H2),
     /* 209387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 209389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 209391 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 209393 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 209395 */     GIR_RootConstrainSelectedInstOperands,
     /* 209396 */     // GIR_Coverage, 3759,
     /* 209396 */     GIR_EraseRootFromParent_Done,
     /* 209397 */   // Label 4129: @209397
     /* 209397 */   GIM_Try, /*On fail goto*//*Label 4130*/ GIMT_Encode4(209451), // Rule ID 3760 //
     /* 209402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 209405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512su1),
     /* 209410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 209413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 209416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 209419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 209422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209438 */     // (intrinsic_wo_chain:{ *:[v2i64] } 533:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512SU1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 209438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512SU1),
     /* 209441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 209443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 209445 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 209447 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 209449 */     GIR_RootConstrainSelectedInstOperands,
     /* 209450 */     // GIR_Coverage, 3760,
     /* 209450 */     GIR_EraseRootFromParent_Done,
     /* 209451 */   // Label 4130: @209451
     /* 209451 */   GIM_Try, /*On fail goto*//*Label 4131*/ GIMT_Encode4(209505), // Rule ID 3761 //
     /* 209456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 209459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 209464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 209467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 209470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 209473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 209476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209492 */     // (intrinsic_wo_chain:{ *:[v16i8] } 518:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 209492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 209495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 209497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 209499 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 209501 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 209503 */     GIR_RootConstrainSelectedInstOperands,
     /* 209504 */     // GIR_Coverage, 3761,
     /* 209504 */     GIR_EraseRootFromParent_Done,
     /* 209505 */   // Label 4131: @209505
     /* 209505 */   GIM_Try, /*On fail goto*//*Label 4132*/ GIMT_Encode4(209559), // Rule ID 3762 //
     /* 209510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 209513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 209518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 209521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 209524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 209527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 209530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209546 */     // (intrinsic_wo_chain:{ *:[v8i16] } 518:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 209546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 209549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 209551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 209553 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 209555 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 209557 */     GIR_RootConstrainSelectedInstOperands,
     /* 209558 */     // GIR_Coverage, 3762,
     /* 209558 */     GIR_EraseRootFromParent_Done,
     /* 209559 */   // Label 4132: @209559
     /* 209559 */   GIM_Try, /*On fail goto*//*Label 4133*/ GIMT_Encode4(209613), // Rule ID 3763 //
     /* 209564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 209567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 209572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 209575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 209578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 209581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 209584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209600 */     // (intrinsic_wo_chain:{ *:[v4i32] } 518:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 209600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 209603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 209605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 209607 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 209609 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 209611 */     GIR_RootConstrainSelectedInstOperands,
     /* 209612 */     // GIR_Coverage, 3763,
     /* 209612 */     GIR_EraseRootFromParent_Done,
     /* 209613 */   // Label 4133: @209613
     /* 209613 */   GIM_Try, /*On fail goto*//*Label 4134*/ GIMT_Encode4(209667), // Rule ID 3764 //
     /* 209618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 209621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 209626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 209629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 209632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 209635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 209638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209654 */     // (intrinsic_wo_chain:{ *:[v2i64] } 518:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 209654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 209657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 209659 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 209661 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 209663 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 209665 */     GIR_RootConstrainSelectedInstOperands,
     /* 209666 */     // GIR_Coverage, 3764,
     /* 209666 */     GIR_EraseRootFromParent_Done,
     /* 209667 */   // Label 4134: @209667
     /* 209667 */   GIM_Try, /*On fail goto*//*Label 4135*/ GIMT_Encode4(209721), // Rule ID 3773 //
     /* 209672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 209675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 209680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 209683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 209686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 209689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 209692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209708 */     // (intrinsic_wo_chain:{ *:[v16i8] } 516:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 209708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 209711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 209713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 209715 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 209717 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 209719 */     GIR_RootConstrainSelectedInstOperands,
     /* 209720 */     // GIR_Coverage, 3773,
     /* 209720 */     GIR_EraseRootFromParent_Done,
     /* 209721 */   // Label 4135: @209721
     /* 209721 */   GIM_Try, /*On fail goto*//*Label 4136*/ GIMT_Encode4(209775), // Rule ID 3774 //
     /* 209726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 209729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 209734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 209737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 209740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 209743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 209746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209762 */     // (intrinsic_wo_chain:{ *:[v8i16] } 516:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 209762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 209765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 209767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 209769 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 209771 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 209773 */     GIR_RootConstrainSelectedInstOperands,
     /* 209774 */     // GIR_Coverage, 3774,
     /* 209774 */     GIR_EraseRootFromParent_Done,
     /* 209775 */   // Label 4136: @209775
     /* 209775 */   GIM_Try, /*On fail goto*//*Label 4137*/ GIMT_Encode4(209829), // Rule ID 3775 //
     /* 209780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 209783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 209788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 209791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 209794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 209797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 209800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209816 */     // (intrinsic_wo_chain:{ *:[v4i32] } 516:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 209816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 209819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 209821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 209823 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 209825 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 209827 */     GIR_RootConstrainSelectedInstOperands,
     /* 209828 */     // GIR_Coverage, 3775,
     /* 209828 */     GIR_EraseRootFromParent_Done,
     /* 209829 */   // Label 4137: @209829
     /* 209829 */   GIM_Try, /*On fail goto*//*Label 4138*/ GIMT_Encode4(209883), // Rule ID 3776 //
     /* 209834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 209837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 209842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 209845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 209848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 209851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 209854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209870 */     // (intrinsic_wo_chain:{ *:[v2i64] } 516:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 209870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 209873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 209875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 209877 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 209879 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 209881 */     GIR_RootConstrainSelectedInstOperands,
     /* 209882 */     // GIR_Coverage, 3776,
     /* 209882 */     GIR_EraseRootFromParent_Done,
     /* 209883 */   // Label 4138: @209883
     /* 209883 */   GIM_Try, /*On fail goto*//*Label 4139*/ GIMT_Encode4(209937), // Rule ID 3777 //
     /* 209888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 209891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 209896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 209899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 209902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 209905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 209908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209924 */     // (intrinsic_wo_chain:{ *:[v16i8] } 517:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 209924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 209927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 209929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 209931 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 209933 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 209935 */     GIR_RootConstrainSelectedInstOperands,
     /* 209936 */     // GIR_Coverage, 3777,
     /* 209936 */     GIR_EraseRootFromParent_Done,
     /* 209937 */   // Label 4139: @209937
     /* 209937 */   GIM_Try, /*On fail goto*//*Label 4140*/ GIMT_Encode4(209991), // Rule ID 3778 //
     /* 209942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 209945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 209950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 209953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 209956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 209959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 209962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 209978 */     // (intrinsic_wo_chain:{ *:[v8i16] } 517:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 209978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 209981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 209983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 209985 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 209987 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 209989 */     GIR_RootConstrainSelectedInstOperands,
     /* 209990 */     // GIR_Coverage, 3778,
     /* 209990 */     GIR_EraseRootFromParent_Done,
     /* 209991 */   // Label 4140: @209991
     /* 209991 */   GIM_Try, /*On fail goto*//*Label 4141*/ GIMT_Encode4(210045), // Rule ID 3779 //
     /* 209996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 209999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 210004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 210007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 210010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 210013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 210016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210032 */     // (intrinsic_wo_chain:{ *:[v4i32] } 517:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 210032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 210035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 210037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 210039 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 210041 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 210043 */     GIR_RootConstrainSelectedInstOperands,
     /* 210044 */     // GIR_Coverage, 3779,
     /* 210044 */     GIR_EraseRootFromParent_Done,
     /* 210045 */   // Label 4141: @210045
     /* 210045 */   GIM_Try, /*On fail goto*//*Label 4142*/ GIMT_Encode4(210099), // Rule ID 3780 //
     /* 210050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 210053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 210058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 210061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 210064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 210067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 210070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210086 */     // (intrinsic_wo_chain:{ *:[v2i64] } 517:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 210086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 210089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 210091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 210093 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 210095 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 210097 */     GIR_RootConstrainSelectedInstOperands,
     /* 210098 */     // GIR_Coverage, 3780,
     /* 210098 */     GIR_EraseRootFromParent_Done,
     /* 210099 */   // Label 4142: @210099
     /* 210099 */   GIM_Try, /*On fail goto*//*Label 4143*/ GIMT_Encode4(210153), // Rule ID 3781 //
     /* 210104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 210107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 210112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 210115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 210118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 210121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 210124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210140 */     // (intrinsic_wo_chain:{ *:[v16i8] } 515:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 210140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 210143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 210145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 210147 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 210149 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 210151 */     GIR_RootConstrainSelectedInstOperands,
     /* 210152 */     // GIR_Coverage, 3781,
     /* 210152 */     GIR_EraseRootFromParent_Done,
     /* 210153 */   // Label 4143: @210153
     /* 210153 */   GIM_Try, /*On fail goto*//*Label 4144*/ GIMT_Encode4(210207), // Rule ID 3782 //
     /* 210158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 210161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 210166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 210169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 210172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 210175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 210178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210194 */     // (intrinsic_wo_chain:{ *:[v8i16] } 515:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 210194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 210197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 210199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 210201 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 210203 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 210205 */     GIR_RootConstrainSelectedInstOperands,
     /* 210206 */     // GIR_Coverage, 3782,
     /* 210206 */     GIR_EraseRootFromParent_Done,
     /* 210207 */   // Label 4144: @210207
     /* 210207 */   GIM_Try, /*On fail goto*//*Label 4145*/ GIMT_Encode4(210261), // Rule ID 3783 //
     /* 210212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 210215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 210220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 210223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 210226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 210229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 210232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210248 */     // (intrinsic_wo_chain:{ *:[v4i32] } 515:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 210248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 210251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 210253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 210255 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 210257 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 210259 */     GIR_RootConstrainSelectedInstOperands,
     /* 210260 */     // GIR_Coverage, 3783,
     /* 210260 */     GIR_EraseRootFromParent_Done,
     /* 210261 */   // Label 4145: @210261
     /* 210261 */   GIM_Try, /*On fail goto*//*Label 4146*/ GIMT_Encode4(210315), // Rule ID 3784 //
     /* 210266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 210269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 210274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 210277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 210280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 210283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 210286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210302 */     // (intrinsic_wo_chain:{ *:[v2i64] } 515:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 210302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 210305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 210307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 210309 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 210311 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 210313 */     GIR_RootConstrainSelectedInstOperands,
     /* 210314 */     // GIR_Coverage, 3784,
     /* 210314 */     GIR_EraseRootFromParent_Done,
     /* 210315 */   // Label 4146: @210315
     /* 210315 */   GIM_Try, /*On fail goto*//*Label 4147*/ GIMT_Encode4(210369), // Rule ID 3788 //
     /* 210320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 210323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3ss1),
     /* 210328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 210331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 210334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 210337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 210340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210356 */     // (intrinsic_wo_chain:{ *:[v4i32] } 536:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)  =>  (SM3SS1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /* 210356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3SS1),
     /* 210359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 210361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 210363 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 210365 */     GIR_RootToRootCopy, /*OpIdx*/4, // Va
     /* 210367 */     GIR_RootConstrainSelectedInstOperands,
     /* 210368 */     // GIR_Coverage, 3788,
     /* 210368 */     GIR_EraseRootFromParent_Done,
     /* 210369 */   // Label 4147: @210369
     /* 210369 */   GIM_Try, /*On fail goto*//*Label 4148*/ GIMT_Encode4(210423), // Rule ID 3789 //
     /* 210374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 210377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3partw1),
     /* 210382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 210385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 210388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 210391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 210394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210410 */     // (intrinsic_wo_chain:{ *:[v4i32] } 534:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM3PARTW1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 210410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3PARTW1),
     /* 210413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 210415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 210417 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 210419 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 210421 */     GIR_RootConstrainSelectedInstOperands,
     /* 210422 */     // GIR_Coverage, 3789,
     /* 210422 */     GIR_EraseRootFromParent_Done,
     /* 210423 */   // Label 4148: @210423
     /* 210423 */   GIM_Try, /*On fail goto*//*Label 4149*/ GIMT_Encode4(210477), // Rule ID 3790 //
     /* 210428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 210431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3partw2),
     /* 210436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 210439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 210442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 210445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 210448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210464 */     // (intrinsic_wo_chain:{ *:[v4i32] } 535:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM3PARTW2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 210464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3PARTW2),
     /* 210467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 210469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 210471 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 210473 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 210475 */     GIR_RootConstrainSelectedInstOperands,
     /* 210476 */     // GIR_Coverage, 3790,
     /* 210476 */     GIR_EraseRootFromParent_Done,
     /* 210477 */   // Label 4149: @210477
     /* 210477 */   GIM_Try, /*On fail goto*//*Label 4150*/ GIMT_Encode4(210534), // Rule ID 3807 //
     /* 210482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 210485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 210490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 210493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 210496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 210499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 210502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210518 */     // (intrinsic_wo_chain:{ *:[v4f16] } 757:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 0:{ *:[i32] })
     /* 210518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 210521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210523 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 210525 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 210527 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 210529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 210532 */     GIR_RootConstrainSelectedInstOperands,
     /* 210533 */     // GIR_Coverage, 3807,
     /* 210533 */     GIR_EraseRootFromParent_Done,
     /* 210534 */   // Label 4150: @210534
     /* 210534 */   GIM_Try, /*On fail goto*//*Label 4151*/ GIMT_Encode4(210591), // Rule ID 3808 //
     /* 210539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 210542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 210547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 210550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 210553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 210556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 210559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210575 */     // (intrinsic_wo_chain:{ *:[v4f16] } 760:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 1:{ *:[i32] })
     /* 210575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 210578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210580 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 210582 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 210584 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 210586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 210589 */     GIR_RootConstrainSelectedInstOperands,
     /* 210590 */     // GIR_Coverage, 3808,
     /* 210590 */     GIR_EraseRootFromParent_Done,
     /* 210591 */   // Label 4151: @210591
     /* 210591 */   GIM_Try, /*On fail goto*//*Label 4152*/ GIMT_Encode4(210648), // Rule ID 3809 //
     /* 210596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 210599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 210604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 210607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 210610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 210613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 210616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210632 */     // (intrinsic_wo_chain:{ *:[v4f16] } 758:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 2:{ *:[i32] })
     /* 210632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 210635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 210639 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 210641 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 210643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 210646 */     GIR_RootConstrainSelectedInstOperands,
     /* 210647 */     // GIR_Coverage, 3809,
     /* 210647 */     GIR_EraseRootFromParent_Done,
     /* 210648 */   // Label 4152: @210648
     /* 210648 */   GIM_Try, /*On fail goto*//*Label 4153*/ GIMT_Encode4(210705), // Rule ID 3810 //
     /* 210653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 210656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 210661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 210664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 210667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 210670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 210673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210689 */     // (intrinsic_wo_chain:{ *:[v4f16] } 759:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 3:{ *:[i32] })
     /* 210689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 210692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 210696 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 210698 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 210700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 210703 */     GIR_RootConstrainSelectedInstOperands,
     /* 210704 */     // GIR_Coverage, 3810,
     /* 210704 */     GIR_EraseRootFromParent_Done,
     /* 210705 */   // Label 4153: @210705
     /* 210705 */   GIM_Try, /*On fail goto*//*Label 4154*/ GIMT_Encode4(210762), // Rule ID 3815 //
     /* 210710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 210713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 210718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 210721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 210724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 210727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 210730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210746 */     // (intrinsic_wo_chain:{ *:[v8f16] } 757:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 0:{ *:[i32] })
     /* 210746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 210749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 210753 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 210755 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 210757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 210760 */     GIR_RootConstrainSelectedInstOperands,
     /* 210761 */     // GIR_Coverage, 3815,
     /* 210761 */     GIR_EraseRootFromParent_Done,
     /* 210762 */   // Label 4154: @210762
     /* 210762 */   GIM_Try, /*On fail goto*//*Label 4155*/ GIMT_Encode4(210819), // Rule ID 3816 //
     /* 210767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 210770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 210775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 210778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 210781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 210784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 210787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210803 */     // (intrinsic_wo_chain:{ *:[v8f16] } 760:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 1:{ *:[i32] })
     /* 210803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 210806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 210810 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 210812 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 210814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 210817 */     GIR_RootConstrainSelectedInstOperands,
     /* 210818 */     // GIR_Coverage, 3816,
     /* 210818 */     GIR_EraseRootFromParent_Done,
     /* 210819 */   // Label 4155: @210819
     /* 210819 */   GIM_Try, /*On fail goto*//*Label 4156*/ GIMT_Encode4(210876), // Rule ID 3817 //
     /* 210824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 210827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 210832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 210835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 210838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 210841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 210844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210860 */     // (intrinsic_wo_chain:{ *:[v8f16] } 758:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 2:{ *:[i32] })
     /* 210860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 210863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 210867 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 210869 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 210871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 210874 */     GIR_RootConstrainSelectedInstOperands,
     /* 210875 */     // GIR_Coverage, 3817,
     /* 210875 */     GIR_EraseRootFromParent_Done,
     /* 210876 */   // Label 4156: @210876
     /* 210876 */   GIM_Try, /*On fail goto*//*Label 4157*/ GIMT_Encode4(210933), // Rule ID 3818 //
     /* 210881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 210884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 210889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 210892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 210895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 210898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 210901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 210917 */     // (intrinsic_wo_chain:{ *:[v8f16] } 759:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 3:{ *:[i32] })
     /* 210917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 210920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210922 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 210924 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 210926 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 210928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 210931 */     GIR_RootConstrainSelectedInstOperands,
     /* 210932 */     // GIR_Coverage, 3818,
     /* 210932 */     GIR_EraseRootFromParent_Done,
     /* 210933 */   // Label 4157: @210933
     /* 210933 */   GIM_Try, /*On fail goto*//*Label 4158*/ GIMT_Encode4(210990), // Rule ID 3823 //
     /* 210938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 210941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 210946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 210949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 210952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 210955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 210958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 210974 */     // (intrinsic_wo_chain:{ *:[v2f32] } 757:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 0:{ *:[i32] })
     /* 210974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 210977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210979 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 210981 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 210983 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 210985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 210988 */     GIR_RootConstrainSelectedInstOperands,
     /* 210989 */     // GIR_Coverage, 3823,
     /* 210989 */     GIR_EraseRootFromParent_Done,
     /* 210990 */   // Label 4158: @210990
     /* 210990 */   GIM_Try, /*On fail goto*//*Label 4159*/ GIMT_Encode4(211047), // Rule ID 3824 //
     /* 210995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 210998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 211003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 211006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 211009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 211012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 211015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 211019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 211023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 211027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 211031 */     // (intrinsic_wo_chain:{ *:[v2f32] } 760:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 1:{ *:[i32] })
     /* 211031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 211034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 211038 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 211040 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 211042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 211045 */     GIR_RootConstrainSelectedInstOperands,
     /* 211046 */     // GIR_Coverage, 3824,
     /* 211046 */     GIR_EraseRootFromParent_Done,
     /* 211047 */   // Label 4159: @211047
     /* 211047 */   GIM_Try, /*On fail goto*//*Label 4160*/ GIMT_Encode4(211104), // Rule ID 3825 //
     /* 211052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 211055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 211060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 211063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 211066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 211069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 211072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 211076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 211080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 211084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 211088 */     // (intrinsic_wo_chain:{ *:[v2f32] } 758:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 2:{ *:[i32] })
     /* 211088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 211091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 211095 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 211097 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 211099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 211102 */     GIR_RootConstrainSelectedInstOperands,
     /* 211103 */     // GIR_Coverage, 3825,
     /* 211103 */     GIR_EraseRootFromParent_Done,
     /* 211104 */   // Label 4160: @211104
     /* 211104 */   GIM_Try, /*On fail goto*//*Label 4161*/ GIMT_Encode4(211161), // Rule ID 3826 //
     /* 211109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 211112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 211117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 211120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 211123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 211126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 211129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 211133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 211137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 211141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 211145 */     // (intrinsic_wo_chain:{ *:[v2f32] } 759:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 3:{ *:[i32] })
     /* 211145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 211148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 211152 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 211154 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 211156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 211159 */     GIR_RootConstrainSelectedInstOperands,
     /* 211160 */     // GIR_Coverage, 3826,
     /* 211160 */     GIR_EraseRootFromParent_Done,
     /* 211161 */   // Label 4161: @211161
     /* 211161 */   GIM_Try, /*On fail goto*//*Label 4162*/ GIMT_Encode4(211218), // Rule ID 3827 //
     /* 211166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 211169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 211174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 211177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 211180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 211183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 211186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211202 */     // (intrinsic_wo_chain:{ *:[v4f32] } 757:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 0:{ *:[i32] })
     /* 211202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 211205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211207 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 211209 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 211211 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 211213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 211216 */     GIR_RootConstrainSelectedInstOperands,
     /* 211217 */     // GIR_Coverage, 3827,
     /* 211217 */     GIR_EraseRootFromParent_Done,
     /* 211218 */   // Label 4162: @211218
     /* 211218 */   GIM_Try, /*On fail goto*//*Label 4163*/ GIMT_Encode4(211275), // Rule ID 3828 //
     /* 211223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 211226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 211231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 211234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 211237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 211240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 211243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211259 */     // (intrinsic_wo_chain:{ *:[v4f32] } 760:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 1:{ *:[i32] })
     /* 211259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 211262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 211266 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 211268 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 211270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 211273 */     GIR_RootConstrainSelectedInstOperands,
     /* 211274 */     // GIR_Coverage, 3828,
     /* 211274 */     GIR_EraseRootFromParent_Done,
     /* 211275 */   // Label 4163: @211275
     /* 211275 */   GIM_Try, /*On fail goto*//*Label 4164*/ GIMT_Encode4(211332), // Rule ID 3829 //
     /* 211280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 211283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 211288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 211291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 211294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 211297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 211300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211316 */     // (intrinsic_wo_chain:{ *:[v4f32] } 758:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 2:{ *:[i32] })
     /* 211316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 211319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 211323 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 211325 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 211327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 211330 */     GIR_RootConstrainSelectedInstOperands,
     /* 211331 */     // GIR_Coverage, 3829,
     /* 211331 */     GIR_EraseRootFromParent_Done,
     /* 211332 */   // Label 4164: @211332
     /* 211332 */   GIM_Try, /*On fail goto*//*Label 4165*/ GIMT_Encode4(211389), // Rule ID 3830 //
     /* 211337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 211340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 211345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 211348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 211351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 211354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 211357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211373 */     // (intrinsic_wo_chain:{ *:[v4f32] } 759:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 3:{ *:[i32] })
     /* 211373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 211376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 211380 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 211382 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 211384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 211387 */     GIR_RootConstrainSelectedInstOperands,
     /* 211388 */     // GIR_Coverage, 3830,
     /* 211388 */     GIR_EraseRootFromParent_Done,
     /* 211389 */   // Label 4165: @211389
     /* 211389 */   GIM_Try, /*On fail goto*//*Label 4166*/ GIMT_Encode4(211446), // Rule ID 3831 //
     /* 211394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 211397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 211402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 211405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 211408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 211411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 211414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211430 */     // (intrinsic_wo_chain:{ *:[v2f64] } 757:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 0:{ *:[i32] })
     /* 211430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 211433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211435 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 211437 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 211439 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 211441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 211444 */     GIR_RootConstrainSelectedInstOperands,
     /* 211445 */     // GIR_Coverage, 3831,
     /* 211445 */     GIR_EraseRootFromParent_Done,
     /* 211446 */   // Label 4166: @211446
     /* 211446 */   GIM_Try, /*On fail goto*//*Label 4167*/ GIMT_Encode4(211503), // Rule ID 3832 //
     /* 211451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 211454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 211459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 211462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 211465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 211468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 211471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211487 */     // (intrinsic_wo_chain:{ *:[v2f64] } 760:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 1:{ *:[i32] })
     /* 211487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 211490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211492 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 211494 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 211496 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 211498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 211501 */     GIR_RootConstrainSelectedInstOperands,
     /* 211502 */     // GIR_Coverage, 3832,
     /* 211502 */     GIR_EraseRootFromParent_Done,
     /* 211503 */   // Label 4167: @211503
     /* 211503 */   GIM_Try, /*On fail goto*//*Label 4168*/ GIMT_Encode4(211560), // Rule ID 3833 //
     /* 211508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 211511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 211516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 211519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 211522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 211525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 211528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211544 */     // (intrinsic_wo_chain:{ *:[v2f64] } 758:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 2:{ *:[i32] })
     /* 211544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 211547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 211551 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 211553 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 211555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 211558 */     GIR_RootConstrainSelectedInstOperands,
     /* 211559 */     // GIR_Coverage, 3833,
     /* 211559 */     GIR_EraseRootFromParent_Done,
     /* 211560 */   // Label 4168: @211560
     /* 211560 */   GIM_Try, /*On fail goto*//*Label 4169*/ GIMT_Encode4(211617), // Rule ID 3834 //
     /* 211565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 211568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 211573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 211576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 211579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 211582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 211585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211601 */     // (intrinsic_wo_chain:{ *:[v2f64] } 759:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 3:{ *:[i32] })
     /* 211601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 211604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 211608 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 211610 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 211612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 211615 */     GIR_RootConstrainSelectedInstOperands,
     /* 211616 */     // GIR_Coverage, 3834,
     /* 211616 */     GIR_EraseRootFromParent_Done,
     /* 211617 */   // Label 4169: @211617
     /* 211617 */   GIM_Try, /*On fail goto*//*Label 4170*/ GIMT_Encode4(211671), // Rule ID 5169 //
     /* 211622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRDM),
     /* 211625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 211630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 211633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 211636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 211639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 211642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 211646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 211650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 211654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 211658 */     // (intrinsic_wo_chain:{ *:[i32] } 686:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMLAHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 211658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv1i32),
     /* 211661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211663 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 211665 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 211667 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 211669 */     GIR_RootConstrainSelectedInstOperands,
     /* 211670 */     // GIR_Coverage, 5169,
     /* 211670 */     GIR_EraseRootFromParent_Done,
     /* 211671 */   // Label 4170: @211671
     /* 211671 */   GIM_Try, /*On fail goto*//*Label 4171*/ GIMT_Encode4(211725), // Rule ID 5170 //
     /* 211676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRDM),
     /* 211679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 211684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 211687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 211690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 211693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 211696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 211700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 211704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 211708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 211712 */     // (intrinsic_wo_chain:{ *:[i32] } 687:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMLSHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 211712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv1i32),
     /* 211715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 211719 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 211721 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 211723 */     GIR_RootConstrainSelectedInstOperands,
     /* 211724 */     // GIR_Coverage, 5170,
     /* 211724 */     GIR_EraseRootFromParent_Done,
     /* 211725 */   // Label 4171: @211725
     /* 211725 */   GIM_Try, /*On fail goto*//*Label 4172*/ GIMT_Encode4(211776), // Rule ID 5516 //
     /* 211730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbx1),
     /* 211735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 211738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 211741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 211744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /* 211747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 211751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 211755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 211763 */     // (intrinsic_wo_chain:{ *:[v8i8] } 720:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)  =>  (TBXv8i8One:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)
     /* 211763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXv8i8One),
     /* 211766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211768 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 211770 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 211772 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ri
     /* 211774 */     GIR_RootConstrainSelectedInstOperands,
     /* 211775 */     // GIR_Coverage, 5516,
     /* 211775 */     GIR_EraseRootFromParent_Done,
     /* 211776 */   // Label 4172: @211776
     /* 211776 */   GIM_Try, /*On fail goto*//*Label 4173*/ GIMT_Encode4(211827), // Rule ID 5517 //
     /* 211781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbx1),
     /* 211786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 211789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 211792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 211795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 211798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 211814 */     // (intrinsic_wo_chain:{ *:[v16i8] } 720:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)  =>  (TBXv16i8One:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)
     /* 211814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXv16i8One),
     /* 211817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 211821 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ri
     /* 211823 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 211825 */     GIR_RootConstrainSelectedInstOperands,
     /* 211826 */     // GIR_Coverage, 5517,
     /* 211826 */     GIR_EraseRootFromParent_Done,
     /* 211827 */   // Label 4173: @211827
     /* 211827 */   GIM_Try, /*On fail goto*//*Label 4174*/ GIMT_Encode4(211869), // Rule ID 2685 //
     /* 211832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 211840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 211843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 211849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 211852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211856 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1824:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (TBX_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 211856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_B),
     /* 211859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211863 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211865 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211867 */     GIR_RootConstrainSelectedInstOperands,
     /* 211868 */     // GIR_Coverage, 2685,
     /* 211868 */     GIR_EraseRootFromParent_Done,
     /* 211869 */   // Label 4174: @211869
     /* 211869 */   GIM_Try, /*On fail goto*//*Label 4175*/ GIMT_Encode4(211911), // Rule ID 2686 //
     /* 211874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 211882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 211894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211898 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1824:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBX_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 211898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_H),
     /* 211901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211905 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211907 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211909 */     GIR_RootConstrainSelectedInstOperands,
     /* 211910 */     // GIR_Coverage, 2686,
     /* 211910 */     GIR_EraseRootFromParent_Done,
     /* 211911 */   // Label 4175: @211911
     /* 211911 */   GIM_Try, /*On fail goto*//*Label 4176*/ GIMT_Encode4(211953), // Rule ID 2687 //
     /* 211916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 211924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 211936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211940 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1824:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBX_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 211940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_S),
     /* 211943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211947 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211949 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211951 */     GIR_RootConstrainSelectedInstOperands,
     /* 211952 */     // GIR_Coverage, 2687,
     /* 211952 */     GIR_EraseRootFromParent_Done,
     /* 211953 */   // Label 4176: @211953
     /* 211953 */   GIM_Try, /*On fail goto*//*Label 4177*/ GIMT_Encode4(211995), // Rule ID 2688 //
     /* 211958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 211966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 211969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 211972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 211978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211982 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1824:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBX_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 211982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_D),
     /* 211985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211989 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211991 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211993 */     GIR_RootConstrainSelectedInstOperands,
     /* 211994 */     // GIR_Coverage, 2688,
     /* 211994 */     GIR_EraseRootFromParent_Done,
     /* 211995 */   // Label 4177: @211995
     /* 211995 */   GIM_Try, /*On fail goto*//*Label 4178*/ GIMT_Encode4(212037), // Rule ID 2689 //
     /* 212000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 212008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 212020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212024 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1824:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBX_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 212024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_H),
     /* 212027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212031 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212033 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212035 */     GIR_RootConstrainSelectedInstOperands,
     /* 212036 */     // GIR_Coverage, 2689,
     /* 212036 */     GIR_EraseRootFromParent_Done,
     /* 212037 */   // Label 4178: @212037
     /* 212037 */   GIM_Try, /*On fail goto*//*Label 4179*/ GIMT_Encode4(212079), // Rule ID 2690 //
     /* 212042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 212050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 212062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212066 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1824:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBX_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 212066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_S),
     /* 212069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212073 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212075 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212077 */     GIR_RootConstrainSelectedInstOperands,
     /* 212078 */     // GIR_Coverage, 2690,
     /* 212078 */     GIR_EraseRootFromParent_Done,
     /* 212079 */   // Label 4179: @212079
     /* 212079 */   GIM_Try, /*On fail goto*//*Label 4180*/ GIMT_Encode4(212121), // Rule ID 2691 //
     /* 212084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 212092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 212098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 212104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212108 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1824:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBX_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 212108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_D),
     /* 212111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212115 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212117 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212119 */     GIR_RootConstrainSelectedInstOperands,
     /* 212120 */     // GIR_Coverage, 2691,
     /* 212120 */     GIR_EraseRootFromParent_Done,
     /* 212121 */   // Label 4180: @212121
     /* 212121 */   GIM_Try, /*On fail goto*//*Label 4181*/ GIMT_Encode4(212163), // Rule ID 2730 //
     /* 212126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 212134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 212137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 212140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 212143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 212146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 212150 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1170:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 212150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 212153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212155 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212157 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212159 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212161 */     GIR_RootConstrainSelectedInstOperands,
     /* 212162 */     // GIR_Coverage, 2730,
     /* 212162 */     GIR_EraseRootFromParent_Done,
     /* 212163 */   // Label 4181: @212163
     /* 212163 */   GIM_Try, /*On fail goto*//*Label 4182*/ GIMT_Encode4(212205), // Rule ID 2731 //
     /* 212168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 212176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 212179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 212182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 212185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 212188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 212192 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1170:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 212192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 212195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212199 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212201 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212203 */     GIR_RootConstrainSelectedInstOperands,
     /* 212204 */     // GIR_Coverage, 2731,
     /* 212204 */     GIR_EraseRootFromParent_Done,
     /* 212205 */   // Label 4182: @212205
     /* 212205 */   GIM_Try, /*On fail goto*//*Label 4183*/ GIMT_Encode4(212247), // Rule ID 2732 //
     /* 212210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 212218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 212221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 212224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 212227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 212230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 212234 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1170:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 212234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 212237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212241 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212243 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212245 */     GIR_RootConstrainSelectedInstOperands,
     /* 212246 */     // GIR_Coverage, 2732,
     /* 212246 */     GIR_EraseRootFromParent_Done,
     /* 212247 */   // Label 4183: @212247
     /* 212247 */   GIM_Try, /*On fail goto*//*Label 4184*/ GIMT_Encode4(212289), // Rule ID 2733 //
     /* 212252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 212260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 212263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 212266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 212269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 212272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 212276 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1170:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 212276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 212279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212283 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212285 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212287 */     GIR_RootConstrainSelectedInstOperands,
     /* 212288 */     // GIR_Coverage, 2733,
     /* 212288 */     GIR_EraseRootFromParent_Done,
     /* 212289 */   // Label 4184: @212289
     /* 212289 */   GIM_Try, /*On fail goto*//*Label 4185*/ GIMT_Encode4(212331), // Rule ID 2734 //
     /* 212294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 212302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 212305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 212308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 212311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 212314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 212318 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1170:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 212318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 212321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212323 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212325 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212327 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212329 */     GIR_RootConstrainSelectedInstOperands,
     /* 212330 */     // GIR_Coverage, 2734,
     /* 212330 */     GIR_EraseRootFromParent_Done,
     /* 212331 */   // Label 4185: @212331
     /* 212331 */   GIM_Try, /*On fail goto*//*Label 4186*/ GIMT_Encode4(212373), // Rule ID 2773 //
     /* 212336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 212344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 212350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 212356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212360 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1269:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FADD_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 212360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_H),
     /* 212363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 212365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212367 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212369 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212371 */     GIR_RootConstrainSelectedInstOperands,
     /* 212372 */     // GIR_Coverage, 2773,
     /* 212372 */     GIR_EraseRootFromParent_Done,
     /* 212373 */   // Label 4186: @212373
     /* 212373 */   GIM_Try, /*On fail goto*//*Label 4187*/ GIMT_Encode4(212415), // Rule ID 2775 //
     /* 212378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 212386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 212392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 212398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212402 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1269:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FADD_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 212402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_S),
     /* 212405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 212407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212409 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212411 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212413 */     GIR_RootConstrainSelectedInstOperands,
     /* 212414 */     // GIR_Coverage, 2775,
     /* 212414 */     GIR_EraseRootFromParent_Done,
     /* 212415 */   // Label 4187: @212415
     /* 212415 */   GIM_Try, /*On fail goto*//*Label 4188*/ GIMT_Encode4(212457), // Rule ID 2777 //
     /* 212420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 212428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 212434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 212440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212444 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1269:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FADD_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 212444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_D),
     /* 212447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 212449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212451 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212453 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212455 */     GIR_RootConstrainSelectedInstOperands,
     /* 212456 */     // GIR_Coverage, 2777,
     /* 212456 */     GIR_EraseRootFromParent_Done,
     /* 212457 */   // Label 4188: @212457
     /* 212457 */   GIM_Try, /*On fail goto*//*Label 4189*/ GIMT_Encode4(212499), // Rule ID 2779 //
     /* 212462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
     /* 212470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 212476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 212482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212486 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1443:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (FSCALE_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 212486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_H),
     /* 212489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 212491 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212493 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212495 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212497 */     GIR_RootConstrainSelectedInstOperands,
     /* 212498 */     // GIR_Coverage, 2779,
     /* 212498 */     GIR_EraseRootFromParent_Done,
     /* 212499 */   // Label 4189: @212499
     /* 212499 */   GIM_Try, /*On fail goto*//*Label 4190*/ GIMT_Encode4(212541), // Rule ID 2780 //
     /* 212504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
     /* 212512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 212518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 212524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212528 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1443:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (FSCALE_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 212528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_S),
     /* 212531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 212533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212535 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212537 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212539 */     GIR_RootConstrainSelectedInstOperands,
     /* 212540 */     // GIR_Coverage, 2780,
     /* 212540 */     GIR_EraseRootFromParent_Done,
     /* 212541 */   // Label 4190: @212541
     /* 212541 */   GIM_Try, /*On fail goto*//*Label 4191*/ GIMT_Encode4(212583), // Rule ID 2781 //
     /* 212546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
     /* 212554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 212560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 212566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212570 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1443:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (FSCALE_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 212570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_D),
     /* 212573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 212575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212577 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212579 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212581 */     GIR_RootConstrainSelectedInstOperands,
     /* 212582 */     // GIR_Coverage, 2781,
     /* 212582 */     GIR_EraseRootFromParent_Done,
     /* 212583 */   // Label 4191: @212583
     /* 212583 */   GIM_Try, /*On fail goto*//*Label 4192*/ GIMT_Encode4(212625), // Rule ID 2850 //
     /* 212588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtnt_f16f32),
     /* 212596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 212605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 212608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212612 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1305:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTNT_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 212612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNT_ZPmZ_StoH),
     /* 212615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212619 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212621 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212623 */     GIR_RootConstrainSelectedInstOperands,
     /* 212624 */     // GIR_Coverage, 2850,
     /* 212624 */     GIR_EraseRootFromParent_Done,
     /* 212625 */   // Label 4192: @212625
     /* 212625 */   GIM_Try, /*On fail goto*//*Label 4193*/ GIMT_Encode4(212667), // Rule ID 2851 //
     /* 212630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtnt_f32f64),
     /* 212638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 212647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 212650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212654 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1306:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTNT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 212654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNT_ZPmZ_DtoS),
     /* 212657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212659 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212661 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212663 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212665 */     GIR_RootConstrainSelectedInstOperands,
     /* 212666 */     // GIR_Coverage, 2851,
     /* 212666 */     GIR_EraseRootFromParent_Done,
     /* 212667 */   // Label 4193: @212667
     /* 212667 */   GIM_Try, /*On fail goto*//*Label 4194*/ GIMT_Encode4(212709), // Rule ID 2852 //
     /* 212672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtlt_f32f16),
     /* 212680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 212689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 212692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212696 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1301:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTLT_ZPmZ_HtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 212696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLT_ZPmZ_HtoS),
     /* 212699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212703 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212705 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212707 */     GIR_RootConstrainSelectedInstOperands,
     /* 212708 */     // GIR_Coverage, 2852,
     /* 212708 */     GIR_EraseRootFromParent_Done,
     /* 212709 */   // Label 4194: @212709
     /* 212709 */   GIM_Try, /*On fail goto*//*Label 4195*/ GIMT_Encode4(212751), // Rule ID 2853 //
     /* 212714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtlt_f64f32),
     /* 212722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 212728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 212731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 212734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212738 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1302:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTLT_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 212738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLT_ZPmZ_StoD),
     /* 212741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212743 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212745 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212747 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212749 */     GIR_RootConstrainSelectedInstOperands,
     /* 212750 */     // GIR_Coverage, 2853,
     /* 212750 */     GIR_EraseRootFromParent_Done,
     /* 212751 */   // Label 4195: @212751
     /* 212751 */   GIM_Try, /*On fail goto*//*Label 4196*/ GIMT_Encode4(212793), // Rule ID 2854 //
     /* 212756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtxnt_f32f64),
     /* 212764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 212773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 212776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212780 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1308:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTXNT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 212780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNT_ZPmZ_DtoS),
     /* 212783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212785 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212787 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212789 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212791 */     GIR_RootConstrainSelectedInstOperands,
     /* 212792 */     // GIR_Coverage, 2854,
     /* 212792 */     GIR_EraseRootFromParent_Done,
     /* 212793 */   // Label 4196: @212793
     /* 212793 */   GIM_Try, /*On fail goto*//*Label 4197*/ GIMT_Encode4(212835), // Rule ID 2855 //
     /* 212798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
     /* 212806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 212812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 212818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212822 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1272:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FADDP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 212822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_H),
     /* 212825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 212827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212829 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212831 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212833 */     GIR_RootConstrainSelectedInstOperands,
     /* 212834 */     // GIR_Coverage, 2855,
     /* 212834 */     GIR_EraseRootFromParent_Done,
     /* 212835 */   // Label 4197: @212835
     /* 212835 */   GIM_Try, /*On fail goto*//*Label 4198*/ GIMT_Encode4(212877), // Rule ID 2856 //
     /* 212840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
     /* 212848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 212854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 212860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212864 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1272:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FADDP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 212864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_S),
     /* 212867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 212869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212871 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212873 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212875 */     GIR_RootConstrainSelectedInstOperands,
     /* 212876 */     // GIR_Coverage, 2856,
     /* 212876 */     GIR_EraseRootFromParent_Done,
     /* 212877 */   // Label 4198: @212877
     /* 212877 */   GIM_Try, /*On fail goto*//*Label 4199*/ GIMT_Encode4(212919), // Rule ID 2857 //
     /* 212882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
     /* 212890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 212896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 212902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212906 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1272:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FADDP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 212906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_D),
     /* 212909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 212911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212913 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212915 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212917 */     GIR_RootConstrainSelectedInstOperands,
     /* 212918 */     // GIR_Coverage, 2857,
     /* 212918 */     GIR_EraseRootFromParent_Done,
     /* 212919 */   // Label 4199: @212919
     /* 212919 */   GIM_Try, /*On fail goto*//*Label 4200*/ GIMT_Encode4(212961), // Rule ID 2868 //
     /* 212924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f32f16),
     /* 212932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 212941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 212944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212948 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1294:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVT_ZPmZ_HtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 212948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_HtoS),
     /* 212951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212955 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212957 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212959 */     GIR_RootConstrainSelectedInstOperands,
     /* 212960 */     // GIR_Coverage, 2868,
     /* 212960 */     GIR_EraseRootFromParent_Done,
     /* 212961 */   // Label 4200: @212961
     /* 212961 */   GIM_Try, /*On fail goto*//*Label 4201*/ GIMT_Encode4(213003), // Rule ID 2870 //
     /* 212966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f16f32),
     /* 212974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 212983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 212986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212990 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1292:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVT_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 212990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_StoH),
     /* 212993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212997 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212999 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213001 */     GIR_RootConstrainSelectedInstOperands,
     /* 213002 */     // GIR_Coverage, 2870,
     /* 213002 */     GIR_EraseRootFromParent_Done,
     /* 213003 */   // Label 4201: @213003
     /* 213003 */   GIM_Try, /*On fail goto*//*Label 4202*/ GIMT_Encode4(213045), // Rule ID 2878 //
     /* 213008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
     /* 213016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 213019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 213022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 213025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 213028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213032 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1329:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FLOGB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 213032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_H),
     /* 213035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213039 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213041 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213043 */     GIR_RootConstrainSelectedInstOperands,
     /* 213044 */     // GIR_Coverage, 2878,
     /* 213044 */     GIR_EraseRootFromParent_Done,
     /* 213045 */   // Label 4202: @213045
     /* 213045 */   GIM_Try, /*On fail goto*//*Label 4203*/ GIMT_Encode4(213087), // Rule ID 2879 //
     /* 213050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
     /* 213058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 213067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 213070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213074 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1329:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FLOGB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 213074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_S),
     /* 213077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213083 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213085 */     GIR_RootConstrainSelectedInstOperands,
     /* 213086 */     // GIR_Coverage, 2879,
     /* 213086 */     GIR_EraseRootFromParent_Done,
     /* 213087 */   // Label 4203: @213087
     /* 213087 */   GIM_Try, /*On fail goto*//*Label 4204*/ GIMT_Encode4(213129), // Rule ID 2880 //
     /* 213092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
     /* 213100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 213103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 213106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 213109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 213112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213116 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1329:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FLOGB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 213116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_D),
     /* 213119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213123 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213125 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213127 */     GIR_RootConstrainSelectedInstOperands,
     /* 213128 */     // GIR_Coverage, 2880,
     /* 213128 */     GIR_EraseRootFromParent_Done,
     /* 213129 */   // Label 4204: @213129
     /* 213129 */   GIM_Try, /*On fail goto*//*Label 4205*/ GIMT_Encode4(213171), // Rule ID 2884 //
     /* 213134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtx_f32f64),
     /* 213142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 213151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 213154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213158 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1307:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTX_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 213158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTX_ZPmZ_DtoS),
     /* 213161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213163 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213165 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213167 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213169 */     GIR_RootConstrainSelectedInstOperands,
     /* 213170 */     // GIR_Coverage, 2884,
     /* 213170 */     GIR_EraseRootFromParent_Done,
     /* 213171 */   // Label 4205: @213171
     /* 213171 */   GIM_Try, /*On fail goto*//*Label 4206*/ GIMT_Encode4(213213), // Rule ID 2929 //
     /* 213176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 213179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdiv),
     /* 213184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 213190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 213196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213200 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1612:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SDIV_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 213200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIV_ZPmZ_S),
     /* 213203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 213205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213207 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213209 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213211 */     GIR_RootConstrainSelectedInstOperands,
     /* 213212 */     // GIR_Coverage, 2929,
     /* 213212 */     GIR_EraseRootFromParent_Done,
     /* 213213 */   // Label 4206: @213213
     /* 213213 */   GIM_Try, /*On fail goto*//*Label 4207*/ GIMT_Encode4(213255), // Rule ID 2930 //
     /* 213218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 213221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdiv),
     /* 213226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 213229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 213232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 213238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213242 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1612:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SDIV_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 213242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIV_ZPmZ_D),
     /* 213245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 213247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213251 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213253 */     GIR_RootConstrainSelectedInstOperands,
     /* 213254 */     // GIR_Coverage, 2930,
     /* 213254 */     GIR_EraseRootFromParent_Done,
     /* 213255 */   // Label 4207: @213255
     /* 213255 */   GIM_Try, /*On fail goto*//*Label 4208*/ GIMT_Encode4(213297), // Rule ID 2959 //
     /* 213260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 213268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 213271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 213274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 213277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 213280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213284 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1728:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRDMLAH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 213284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_B),
     /* 213287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 213289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213291 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213293 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213295 */     GIR_RootConstrainSelectedInstOperands,
     /* 213296 */     // GIR_Coverage, 2959,
     /* 213296 */     GIR_EraseRootFromParent_Done,
     /* 213297 */   // Label 4208: @213297
     /* 213297 */   GIM_Try, /*On fail goto*//*Label 4209*/ GIMT_Encode4(213339), // Rule ID 2960 //
     /* 213302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 213310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 213313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 213316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 213322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213326 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1728:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRDMLAH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 213326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_H),
     /* 213329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 213331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213333 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213335 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213337 */     GIR_RootConstrainSelectedInstOperands,
     /* 213338 */     // GIR_Coverage, 2960,
     /* 213338 */     GIR_EraseRootFromParent_Done,
     /* 213339 */   // Label 4209: @213339
     /* 213339 */   GIM_Try, /*On fail goto*//*Label 4210*/ GIMT_Encode4(213381), // Rule ID 2961 //
     /* 213344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 213352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 213364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213368 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1728:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRDMLAH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 213368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_S),
     /* 213371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 213373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213375 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213377 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213379 */     GIR_RootConstrainSelectedInstOperands,
     /* 213380 */     // GIR_Coverage, 2961,
     /* 213380 */     GIR_EraseRootFromParent_Done,
     /* 213381 */   // Label 4210: @213381
     /* 213381 */   GIM_Try, /*On fail goto*//*Label 4211*/ GIMT_Encode4(213423), // Rule ID 2962 //
     /* 213386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 213394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 213397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 213400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 213406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213410 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1728:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRDMLAH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 213410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_D),
     /* 213413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 213415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213417 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213419 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213421 */     GIR_RootConstrainSelectedInstOperands,
     /* 213422 */     // GIR_Coverage, 2962,
     /* 213422 */     GIR_EraseRootFromParent_Done,
     /* 213423 */   // Label 4211: @213423
     /* 213423 */   GIM_Try, /*On fail goto*//*Label 4212*/ GIMT_Encode4(213465), // Rule ID 2963 //
     /* 213428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
     /* 213436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 213439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 213442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 213445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 213448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213452 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1649:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 213452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_H),
     /* 213455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 213457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213461 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213463 */     GIR_RootConstrainSelectedInstOperands,
     /* 213464 */     // GIR_Coverage, 2963,
     /* 213464 */     GIR_EraseRootFromParent_Done,
     /* 213465 */   // Label 4212: @213465
     /* 213465 */   GIM_Try, /*On fail goto*//*Label 4213*/ GIMT_Encode4(213507), // Rule ID 2964 //
     /* 213470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
     /* 213478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 213490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213494 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1649:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 213494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_S),
     /* 213497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 213499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213501 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213503 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213505 */     GIR_RootConstrainSelectedInstOperands,
     /* 213506 */     // GIR_Coverage, 2964,
     /* 213506 */     GIR_EraseRootFromParent_Done,
     /* 213507 */   // Label 4213: @213507
     /* 213507 */   GIM_Try, /*On fail goto*//*Label 4214*/ GIMT_Encode4(213549), // Rule ID 2965 //
     /* 213512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
     /* 213520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 213523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 213526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 213532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213536 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1649:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 213536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_D),
     /* 213539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 213541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213545 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213547 */     GIR_RootConstrainSelectedInstOperands,
     /* 213548 */     // GIR_Coverage, 2965,
     /* 213548 */     GIR_EraseRootFromParent_Done,
     /* 213549 */   // Label 4214: @213549
     /* 213549 */   GIM_Try, /*On fail goto*//*Label 4215*/ GIMT_Encode4(213591), // Rule ID 2995 //
     /* 213554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 213562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 213565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 213568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 213571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 213574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213578 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1623:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 213578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_B),
     /* 213581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 213583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213585 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213587 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213589 */     GIR_RootConstrainSelectedInstOperands,
     /* 213590 */     // GIR_Coverage, 2995,
     /* 213590 */     GIR_EraseRootFromParent_Done,
     /* 213591 */   // Label 4215: @213591
     /* 213591 */   GIM_Try, /*On fail goto*//*Label 4216*/ GIMT_Encode4(213633), // Rule ID 2997 //
     /* 213596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 213604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 213607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 213610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 213616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213620 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1623:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 213620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_H),
     /* 213623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 213625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213627 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213629 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213631 */     GIR_RootConstrainSelectedInstOperands,
     /* 213632 */     // GIR_Coverage, 2997,
     /* 213632 */     GIR_EraseRootFromParent_Done,
     /* 213633 */   // Label 4216: @213633
     /* 213633 */   GIM_Try, /*On fail goto*//*Label 4217*/ GIMT_Encode4(213675), // Rule ID 2999 //
     /* 213638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 213646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 213652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 213658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213662 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1623:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 213662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_S),
     /* 213665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 213667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213669 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213671 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213673 */     GIR_RootConstrainSelectedInstOperands,
     /* 213674 */     // GIR_Coverage, 2999,
     /* 213674 */     GIR_EraseRootFromParent_Done,
     /* 213675 */   // Label 4217: @213675
     /* 213675 */   GIM_Try, /*On fail goto*//*Label 4218*/ GIMT_Encode4(213717), // Rule ID 3001 //
     /* 213680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 213688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 213691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 213694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 213700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213704 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1623:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 213704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_D),
     /* 213707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 213709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213711 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213713 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213715 */     GIR_RootConstrainSelectedInstOperands,
     /* 213716 */     // GIR_Coverage, 3001,
     /* 213716 */     GIR_EraseRootFromParent_Done,
     /* 213717 */   // Label 4218: @213717
     /* 213717 */   GIM_Try, /*On fail goto*//*Label 4219*/ GIMT_Encode4(213759), // Rule ID 3003 //
     /* 213722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
     /* 213730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 213733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 213736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 213742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213746 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1593:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SADALP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 213746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_H),
     /* 213749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 213751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213753 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213755 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213757 */     GIR_RootConstrainSelectedInstOperands,
     /* 213758 */     // GIR_Coverage, 3003,
     /* 213758 */     GIR_EraseRootFromParent_Done,
     /* 213759 */   // Label 4219: @213759
     /* 213759 */   GIM_Try, /*On fail goto*//*Label 4220*/ GIMT_Encode4(213801), // Rule ID 3004 //
     /* 213764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
     /* 213772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 213778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 213784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213788 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1593:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SADALP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 213788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_S),
     /* 213791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 213793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213795 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213797 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213799 */     GIR_RootConstrainSelectedInstOperands,
     /* 213800 */     // GIR_Coverage, 3004,
     /* 213800 */     GIR_EraseRootFromParent_Done,
     /* 213801 */   // Label 4220: @213801
     /* 213801 */   GIM_Try, /*On fail goto*//*Label 4221*/ GIMT_Encode4(213843), // Rule ID 3005 //
     /* 213806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
     /* 213814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 213817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 213820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 213826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213830 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1593:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SADALP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 213830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_D),
     /* 213833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 213835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213837 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213839 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213841 */     GIR_RootConstrainSelectedInstOperands,
     /* 213842 */     // GIR_Coverage, 3005,
     /* 213842 */     GIR_EraseRootFromParent_Done,
     /* 213843 */   // Label 4221: @213843
     /* 213843 */   GIM_Try, /*On fail goto*//*Label 4222*/ GIMT_Encode4(213885), // Rule ID 3006 //
     /* 213848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urecpe),
     /* 213856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 213865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 213868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213872 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1952:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URECPE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 213872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPE_ZPmZ_S),
     /* 213875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213879 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213881 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213883 */     GIR_RootConstrainSelectedInstOperands,
     /* 213884 */     // GIR_Coverage, 3006,
     /* 213884 */     GIR_EraseRootFromParent_Done,
     /* 213885 */   // Label 4222: @213885
     /* 213885 */   GIM_Try, /*On fail goto*//*Label 4223*/ GIMT_Encode4(213927), // Rule ID 3007 //
     /* 213890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 213898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 213901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 213904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 213907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 213910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213914 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1665:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQABS_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 213914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_B),
     /* 213917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213921 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213923 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213925 */     GIR_RootConstrainSelectedInstOperands,
     /* 213926 */     // GIR_Coverage, 3007,
     /* 213926 */     GIR_EraseRootFromParent_Done,
     /* 213927 */   // Label 4223: @213927
     /* 213927 */   GIM_Try, /*On fail goto*//*Label 4224*/ GIMT_Encode4(213969), // Rule ID 3008 //
     /* 213932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 213940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 213943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 213946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 213949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 213952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213956 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1665:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQABS_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 213956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_H),
     /* 213959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213963 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213965 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 213967 */     GIR_RootConstrainSelectedInstOperands,
     /* 213968 */     // GIR_Coverage, 3008,
     /* 213968 */     GIR_EraseRootFromParent_Done,
     /* 213969 */   // Label 4224: @213969
     /* 213969 */   GIM_Try, /*On fail goto*//*Label 4225*/ GIMT_Encode4(214011), // Rule ID 3009 //
     /* 213974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 213982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 213991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 213994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213998 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1665:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQABS_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 213998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_S),
     /* 214001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214005 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214007 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214009 */     GIR_RootConstrainSelectedInstOperands,
     /* 214010 */     // GIR_Coverage, 3009,
     /* 214010 */     GIR_EraseRootFromParent_Done,
     /* 214011 */   // Label 4225: @214011
     /* 214011 */   GIM_Try, /*On fail goto*//*Label 4226*/ GIMT_Encode4(214053), // Rule ID 3010 //
     /* 214016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 214024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 214027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 214030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 214033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 214036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214040 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1665:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQABS_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 214040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_D),
     /* 214043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214047 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214049 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214051 */     GIR_RootConstrainSelectedInstOperands,
     /* 214052 */     // GIR_Coverage, 3010,
     /* 214052 */     GIR_EraseRootFromParent_Done,
     /* 214053 */   // Label 4226: @214053
     /* 214053 */   GIM_Try, /*On fail goto*//*Label 4227*/ GIMT_Encode4(214095), // Rule ID 3027 //
     /* 214058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 214066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 214069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 214072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 214075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 214078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214082 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1258:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EORBT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 214082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_B),
     /* 214085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214089 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214091 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214093 */     GIR_RootConstrainSelectedInstOperands,
     /* 214094 */     // GIR_Coverage, 3027,
     /* 214094 */     GIR_EraseRootFromParent_Done,
     /* 214095 */   // Label 4227: @214095
     /* 214095 */   GIM_Try, /*On fail goto*//*Label 4228*/ GIMT_Encode4(214137), // Rule ID 3028 //
     /* 214100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 214108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 214111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 214114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 214117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 214120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214124 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1258:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EORBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 214124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_H),
     /* 214127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214131 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214133 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214135 */     GIR_RootConstrainSelectedInstOperands,
     /* 214136 */     // GIR_Coverage, 3028,
     /* 214136 */     GIR_EraseRootFromParent_Done,
     /* 214137 */   // Label 4228: @214137
     /* 214137 */   GIM_Try, /*On fail goto*//*Label 4229*/ GIMT_Encode4(214179), // Rule ID 3029 //
     /* 214142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 214150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 214153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 214156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 214159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 214162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214166 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1258:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EORBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 214166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_S),
     /* 214169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214173 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214175 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214177 */     GIR_RootConstrainSelectedInstOperands,
     /* 214178 */     // GIR_Coverage, 3029,
     /* 214178 */     GIR_EraseRootFromParent_Done,
     /* 214179 */   // Label 4229: @214179
     /* 214179 */   GIM_Try, /*On fail goto*//*Label 4230*/ GIMT_Encode4(214221), // Rule ID 3030 //
     /* 214184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 214192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 214195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 214198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 214201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 214204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214208 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1258:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EORBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 214208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_D),
     /* 214211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214215 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214217 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214219 */     GIR_RootConstrainSelectedInstOperands,
     /* 214220 */     // GIR_Coverage, 3030,
     /* 214220 */     GIR_EraseRootFromParent_Done,
     /* 214221 */   // Label 4230: @214221
     /* 214221 */   GIM_Try, /*On fail goto*//*Label 4231*/ GIMT_Encode4(214263), // Rule ID 3054 //
     /* 214226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 214234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 214237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 214240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 214243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 214246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214250 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1586:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABA_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 214250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_B),
     /* 214253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 214255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214257 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214259 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214261 */     GIR_RootConstrainSelectedInstOperands,
     /* 214262 */     // GIR_Coverage, 3054,
     /* 214262 */     GIR_EraseRootFromParent_Done,
     /* 214263 */   // Label 4231: @214263
     /* 214263 */   GIM_Try, /*On fail goto*//*Label 4232*/ GIMT_Encode4(214305), // Rule ID 3056 //
     /* 214268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 214276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 214279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 214282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 214285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 214288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214292 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1586:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABA_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 214292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_H),
     /* 214295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 214297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214299 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214301 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214303 */     GIR_RootConstrainSelectedInstOperands,
     /* 214304 */     // GIR_Coverage, 3056,
     /* 214304 */     GIR_EraseRootFromParent_Done,
     /* 214305 */   // Label 4232: @214305
     /* 214305 */   GIM_Try, /*On fail goto*//*Label 4233*/ GIMT_Encode4(214347), // Rule ID 3058 //
     /* 214310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 214318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 214321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 214324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 214327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 214330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214334 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1586:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABA_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 214334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_S),
     /* 214337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 214339 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214341 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214343 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214345 */     GIR_RootConstrainSelectedInstOperands,
     /* 214346 */     // GIR_Coverage, 3058,
     /* 214346 */     GIR_EraseRootFromParent_Done,
     /* 214347 */   // Label 4233: @214347
     /* 214347 */   GIM_Try, /*On fail goto*//*Label 4234*/ GIMT_Encode4(214389), // Rule ID 3060 //
     /* 214352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 214360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 214363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 214366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 214369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 214372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214376 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1586:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SABA_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 214376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_D),
     /* 214379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 214381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214383 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214385 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214387 */     GIR_RootConstrainSelectedInstOperands,
     /* 214388 */     // GIR_Coverage, 3060,
     /* 214388 */     GIR_EraseRootFromParent_Done,
     /* 214389 */   // Label 4234: @214389
     /* 214389 */   GIM_Try, /*On fail goto*//*Label 4235*/ GIMT_Encode4(214431), // Rule ID 3062 //
     /* 214394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
     /* 214402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 214405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 214408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 214411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 214414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214418 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1587:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 214418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_H),
     /* 214421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 214423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214425 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214427 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214429 */     GIR_RootConstrainSelectedInstOperands,
     /* 214430 */     // GIR_Coverage, 3062,
     /* 214430 */     GIR_EraseRootFromParent_Done,
     /* 214431 */   // Label 4235: @214431
     /* 214431 */   GIM_Try, /*On fail goto*//*Label 4236*/ GIMT_Encode4(214473), // Rule ID 3063 //
     /* 214436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
     /* 214444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 214447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 214450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 214453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 214456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214460 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1587:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 214460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_S),
     /* 214463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 214465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214467 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214469 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214471 */     GIR_RootConstrainSelectedInstOperands,
     /* 214472 */     // GIR_Coverage, 3063,
     /* 214472 */     GIR_EraseRootFromParent_Done,
     /* 214473 */   // Label 4236: @214473
     /* 214473 */   GIM_Try, /*On fail goto*//*Label 4237*/ GIMT_Encode4(214515), // Rule ID 3064 //
     /* 214478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
     /* 214486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 214489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 214492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 214495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 214498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214502 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1587:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 214502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_D),
     /* 214505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 214507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214509 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214511 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214513 */     GIR_RootConstrainSelectedInstOperands,
     /* 214514 */     // GIR_Coverage, 3064,
     /* 214514 */     GIR_EraseRootFromParent_Done,
     /* 214515 */   // Label 4237: @214515
     /* 214515 */   GIM_Try, /*On fail goto*//*Label 4238*/ GIMT_Encode4(214557), // Rule ID 3065 //
     /* 214520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclb),
     /* 214528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 214531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 214534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 214537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 214540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214544 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1150:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADCLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 214544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLB_ZZZ_S),
     /* 214547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 214549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214551 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214553 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214555 */     GIR_RootConstrainSelectedInstOperands,
     /* 214556 */     // GIR_Coverage, 3065,
     /* 214556 */     GIR_EraseRootFromParent_Done,
     /* 214557 */   // Label 4238: @214557
     /* 214557 */   GIM_Try, /*On fail goto*//*Label 4239*/ GIMT_Encode4(214599), // Rule ID 3066 //
     /* 214562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclb),
     /* 214570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 214573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 214576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 214579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 214582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214586 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1150:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADCLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 214586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLB_ZZZ_D),
     /* 214589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 214591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214593 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214595 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214597 */     GIR_RootConstrainSelectedInstOperands,
     /* 214598 */     // GIR_Coverage, 3066,
     /* 214598 */     GIR_EraseRootFromParent_Done,
     /* 214599 */   // Label 4239: @214599
     /* 214599 */   GIM_Try, /*On fail goto*//*Label 4240*/ GIMT_Encode4(214641), // Rule ID 3076 //
     /* 214604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
     /* 214612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 214615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 214618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 214621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 214624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214628 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1157:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ADDHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 214628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_B),
     /* 214631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214635 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214637 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214639 */     GIR_RootConstrainSelectedInstOperands,
     /* 214640 */     // GIR_Coverage, 3076,
     /* 214640 */     GIR_EraseRootFromParent_Done,
     /* 214641 */   // Label 4240: @214641
     /* 214641 */   GIM_Try, /*On fail goto*//*Label 4241*/ GIMT_Encode4(214683), // Rule ID 3077 //
     /* 214646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
     /* 214654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 214657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 214660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 214663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 214666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214670 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1157:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADDHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 214670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_H),
     /* 214673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214677 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214679 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214681 */     GIR_RootConstrainSelectedInstOperands,
     /* 214682 */     // GIR_Coverage, 3077,
     /* 214682 */     GIR_EraseRootFromParent_Done,
     /* 214683 */   // Label 4241: @214683
     /* 214683 */   GIM_Try, /*On fail goto*//*Label 4242*/ GIMT_Encode4(214725), // Rule ID 3078 //
     /* 214688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
     /* 214696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 214699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 214702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 214705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 214708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214712 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1157:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADDHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 214712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_S),
     /* 214715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214719 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214721 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214723 */     GIR_RootConstrainSelectedInstOperands,
     /* 214724 */     // GIR_Coverage, 3078,
     /* 214724 */     GIR_EraseRootFromParent_Done,
     /* 214725 */   // Label 4242: @214725
     /* 214725 */   GIM_Try, /*On fail goto*//*Label 4243*/ GIMT_Encode4(214767), // Rule ID 3095 //
     /* 214730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 214733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 214738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 214741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 214744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 214747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 214750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214754 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1216:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CLS_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 214754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_B),
     /* 214757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214759 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 214761 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 214763 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 214765 */     GIR_RootConstrainSelectedInstOperands,
     /* 214766 */     // GIR_Coverage, 3095,
     /* 214766 */     GIR_EraseRootFromParent_Done,
     /* 214767 */   // Label 4243: @214767
     /* 214767 */   GIM_Try, /*On fail goto*//*Label 4244*/ GIMT_Encode4(214809), // Rule ID 3096 //
     /* 214772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 214775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 214780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 214783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 214786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 214789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 214792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214796 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1216:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CLS_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 214796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_H),
     /* 214799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 214803 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 214805 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 214807 */     GIR_RootConstrainSelectedInstOperands,
     /* 214808 */     // GIR_Coverage, 3096,
     /* 214808 */     GIR_EraseRootFromParent_Done,
     /* 214809 */   // Label 4244: @214809
     /* 214809 */   GIM_Try, /*On fail goto*//*Label 4245*/ GIMT_Encode4(214851), // Rule ID 3097 //
     /* 214814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 214817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 214822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 214825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 214828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 214831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 214834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214838 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1216:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CLS_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 214838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_S),
     /* 214841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 214845 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 214847 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 214849 */     GIR_RootConstrainSelectedInstOperands,
     /* 214850 */     // GIR_Coverage, 3097,
     /* 214850 */     GIR_EraseRootFromParent_Done,
     /* 214851 */   // Label 4245: @214851
     /* 214851 */   GIM_Try, /*On fail goto*//*Label 4246*/ GIMT_Encode4(214893), // Rule ID 3098 //
     /* 214856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 214859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 214864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 214867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 214870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 214873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 214876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214880 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1216:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CLS_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 214880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_D),
     /* 214883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 214887 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 214889 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 214891 */     GIR_RootConstrainSelectedInstOperands,
     /* 214892 */     // GIR_Coverage, 3098,
     /* 214892 */     GIR_EraseRootFromParent_Done,
     /* 214893 */   // Label 4246: @214893
     /* 214893 */   GIM_Try, /*On fail goto*//*Label 4247*/ GIMT_Encode4(214935), // Rule ID 3133 //
     /* 214898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 214906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 214909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 214912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 214915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 214918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214922 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1257:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 214922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 214925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 214927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214929 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214931 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214933 */     GIR_RootConstrainSelectedInstOperands,
     /* 214934 */     // GIR_Coverage, 3133,
     /* 214934 */     GIR_EraseRootFromParent_Done,
     /* 214935 */   // Label 4247: @214935
     /* 214935 */   GIM_Try, /*On fail goto*//*Label 4248*/ GIMT_Encode4(214977), // Rule ID 3135 //
     /* 214940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 214948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 214951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 214954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 214957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 214960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214964 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1257:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 214964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 214967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 214969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214971 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214973 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 214975 */     GIR_RootConstrainSelectedInstOperands,
     /* 214976 */     // GIR_Coverage, 3135,
     /* 214976 */     GIR_EraseRootFromParent_Done,
     /* 214977 */   // Label 4248: @214977
     /* 214977 */   GIM_Try, /*On fail goto*//*Label 4249*/ GIMT_Encode4(215019), // Rule ID 3137 //
     /* 214982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 214990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 214993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 214996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 214999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 215002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215006 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1257:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 215006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 215009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 215011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215013 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215015 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215017 */     GIR_RootConstrainSelectedInstOperands,
     /* 215018 */     // GIR_Coverage, 3137,
     /* 215018 */     GIR_EraseRootFromParent_Done,
     /* 215019 */   // Label 4249: @215019
     /* 215019 */   GIM_Try, /*On fail goto*//*Label 4250*/ GIMT_Encode4(215061), // Rule ID 3139 //
     /* 215024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 215032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 215035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 215038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 215041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 215044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215048 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1257:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 215048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 215051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 215053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215055 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215057 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215059 */     GIR_RootConstrainSelectedInstOperands,
     /* 215060 */     // GIR_Coverage, 3139,
     /* 215060 */     GIR_EraseRootFromParent_Done,
     /* 215061 */   // Label 4250: @215061
     /* 215061 */   GIM_Try, /*On fail goto*//*Label 4251*/ GIMT_Encode4(215106), // Rule ID 3172 //
     /* 215066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
     /* 215074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 215077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 215080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 215083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 215086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215090 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1221:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 215090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_B),
     /* 215093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215097 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215099 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215101 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 215104 */     GIR_RootConstrainSelectedInstOperands,
     /* 215105 */     // GIR_Coverage, 3172,
     /* 215105 */     GIR_EraseRootFromParent_Done,
     /* 215106 */   // Label 4251: @215106
     /* 215106 */   GIM_Try, /*On fail goto*//*Label 4252*/ GIMT_Encode4(215151), // Rule ID 3173 //
     /* 215111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
     /* 215119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 215122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 215125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 215128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 215131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215135 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1221:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 215135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_H),
     /* 215138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215142 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215144 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215146 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 215149 */     GIR_RootConstrainSelectedInstOperands,
     /* 215150 */     // GIR_Coverage, 3173,
     /* 215150 */     GIR_EraseRootFromParent_Done,
     /* 215151 */   // Label 4252: @215151
     /* 215151 */   GIM_Try, /*On fail goto*//*Label 4253*/ GIMT_Encode4(215196), // Rule ID 3174 //
     /* 215156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
     /* 215164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 215167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 215170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 215173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 215176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215180 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1221:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 215180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_S),
     /* 215183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215187 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215189 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215191 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 215194 */     GIR_RootConstrainSelectedInstOperands,
     /* 215195 */     // GIR_Coverage, 3174,
     /* 215195 */     GIR_EraseRootFromParent_Done,
     /* 215196 */   // Label 4253: @215196
     /* 215196 */   GIM_Try, /*On fail goto*//*Label 4254*/ GIMT_Encode4(215241), // Rule ID 3175 //
     /* 215201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
     /* 215209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 215212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 215215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 215218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 215221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215225 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1223:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 215225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_B),
     /* 215228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215230 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215232 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215234 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215236 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 215239 */     GIR_RootConstrainSelectedInstOperands,
     /* 215240 */     // GIR_Coverage, 3175,
     /* 215240 */     GIR_EraseRootFromParent_Done,
     /* 215241 */   // Label 4254: @215241
     /* 215241 */   GIM_Try, /*On fail goto*//*Label 4255*/ GIMT_Encode4(215286), // Rule ID 3176 //
     /* 215246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
     /* 215254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 215257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 215260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 215263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 215266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215270 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1223:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 215270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_H),
     /* 215273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215275 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215277 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215279 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215281 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 215284 */     GIR_RootConstrainSelectedInstOperands,
     /* 215285 */     // GIR_Coverage, 3176,
     /* 215285 */     GIR_EraseRootFromParent_Done,
     /* 215286 */   // Label 4255: @215286
     /* 215286 */   GIM_Try, /*On fail goto*//*Label 4256*/ GIMT_Encode4(215331), // Rule ID 3177 //
     /* 215291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
     /* 215299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 215302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 215305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 215308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 215311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215315 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1223:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 215315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_S),
     /* 215318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215322 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215324 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215326 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 215329 */     GIR_RootConstrainSelectedInstOperands,
     /* 215330 */     // GIR_Coverage, 3177,
     /* 215330 */     GIR_EraseRootFromParent_Done,
     /* 215331 */   // Label 4256: @215331
     /* 215331 */   GIM_Try, /*On fail goto*//*Label 4257*/ GIMT_Encode4(215373), // Rule ID 3232 //
     /* 215336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
     /* 215344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 215347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 215350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 215353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 215356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215360 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1267:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FACGE_PPzZZ_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 215360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_H),
     /* 215363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215367 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215369 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215371 */     GIR_RootConstrainSelectedInstOperands,
     /* 215372 */     // GIR_Coverage, 3232,
     /* 215372 */     GIR_EraseRootFromParent_Done,
     /* 215373 */   // Label 4257: @215373
     /* 215373 */   GIM_Try, /*On fail goto*//*Label 4258*/ GIMT_Encode4(215415), // Rule ID 3233 //
     /* 215378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
     /* 215386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 215389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 215392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 215395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 215398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215402 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1267:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FACGE_PPzZZ_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 215402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_S),
     /* 215405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215409 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215411 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215413 */     GIR_RootConstrainSelectedInstOperands,
     /* 215414 */     // GIR_Coverage, 3233,
     /* 215414 */     GIR_EraseRootFromParent_Done,
     /* 215415 */   // Label 4258: @215415
     /* 215415 */   GIM_Try, /*On fail goto*//*Label 4259*/ GIMT_Encode4(215457), // Rule ID 3234 //
     /* 215420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
     /* 215428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 215431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 215434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 215437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 215440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215444 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1267:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FACGE_PPzZZ_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 215444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_D),
     /* 215447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215451 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215453 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215455 */     GIR_RootConstrainSelectedInstOperands,
     /* 215456 */     // GIR_Coverage, 3234,
     /* 215456 */     GIR_EraseRootFromParent_Done,
     /* 215457 */   // Label 4259: @215457
     /* 215457 */   GIM_Try, /*On fail goto*//*Label 4260*/ GIMT_Encode4(215499), // Rule ID 3286 //
     /* 215462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 215470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 215473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 215476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 215479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 215482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215486 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1173:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (ASR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 215486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_B),
     /* 215489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 215491 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215493 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215495 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215497 */     GIR_RootConstrainSelectedInstOperands,
     /* 215498 */     // GIR_Coverage, 3286,
     /* 215498 */     GIR_EraseRootFromParent_Done,
     /* 215499 */   // Label 4260: @215499
     /* 215499 */   GIM_Try, /*On fail goto*//*Label 4261*/ GIMT_Encode4(215541), // Rule ID 3287 //
     /* 215504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 215512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 215515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 215518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 215521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 215524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215528 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1173:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ASR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 215528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_H),
     /* 215531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 215533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215535 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215537 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215539 */     GIR_RootConstrainSelectedInstOperands,
     /* 215540 */     // GIR_Coverage, 3287,
     /* 215540 */     GIR_EraseRootFromParent_Done,
     /* 215541 */   // Label 4261: @215541
     /* 215541 */   GIM_Try, /*On fail goto*//*Label 4262*/ GIMT_Encode4(215583), // Rule ID 3288 //
     /* 215546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 215554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 215557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 215560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 215563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 215566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215570 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1173:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ASR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 215570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_S),
     /* 215573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 215575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215577 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215579 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215581 */     GIR_RootConstrainSelectedInstOperands,
     /* 215582 */     // GIR_Coverage, 3288,
     /* 215582 */     GIR_EraseRootFromParent_Done,
     /* 215583 */   // Label 4262: @215583
     /* 215583 */   GIM_Try, /*On fail goto*//*Label 4263*/ GIMT_Encode4(215625), // Rule ID 3289 //
     /* 215588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 215596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 215599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 215602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 215605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 215608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215612 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1173:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 215612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_D),
     /* 215615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 215617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215619 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215621 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215623 */     GIR_RootConstrainSelectedInstOperands,
     /* 215624 */     // GIR_Coverage, 3289,
     /* 215624 */     GIR_EraseRootFromParent_Done,
     /* 215625 */   // Label 4263: @215625
     /* 215625 */   GIM_Try, /*On fail goto*//*Label 4264*/ GIMT_Encode4(215667), // Rule ID 3298 //
     /* 215630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
     /* 215638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 215641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 215644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 215647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 215650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215654 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1175:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 215654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_B),
     /* 215657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 215659 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215661 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215663 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215665 */     GIR_RootConstrainSelectedInstOperands,
     /* 215666 */     // GIR_Coverage, 3298,
     /* 215666 */     GIR_EraseRootFromParent_Done,
     /* 215667 */   // Label 4264: @215667
     /* 215667 */   GIM_Try, /*On fail goto*//*Label 4265*/ GIMT_Encode4(215709), // Rule ID 3299 //
     /* 215672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
     /* 215680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 215683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 215686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 215689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 215692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215696 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1175:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 215696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_H),
     /* 215699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 215701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215703 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215705 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215707 */     GIR_RootConstrainSelectedInstOperands,
     /* 215708 */     // GIR_Coverage, 3299,
     /* 215708 */     GIR_EraseRootFromParent_Done,
     /* 215709 */   // Label 4265: @215709
     /* 215709 */   GIM_Try, /*On fail goto*//*Label 4266*/ GIMT_Encode4(215751), // Rule ID 3300 //
     /* 215714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
     /* 215722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 215725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 215728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 215731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 215734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215738 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1175:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 215738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_S),
     /* 215741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 215743 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215745 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215747 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215749 */     GIR_RootConstrainSelectedInstOperands,
     /* 215750 */     // GIR_Coverage, 3300,
     /* 215750 */     GIR_EraseRootFromParent_Done,
     /* 215751 */   // Label 4266: @215751
     /* 215751 */   GIM_Try, /*On fail goto*//*Label 4267*/ GIMT_Encode4(215793), // Rule ID 3339 //
     /* 215756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 215764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 215767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 215770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 215773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 215776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215780 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1212:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (CLASTA_ZPZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 215780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_B),
     /* 215783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 215785 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215787 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215789 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215791 */     GIR_RootConstrainSelectedInstOperands,
     /* 215792 */     // GIR_Coverage, 3339,
     /* 215792 */     GIR_EraseRootFromParent_Done,
     /* 215793 */   // Label 4267: @215793
     /* 215793 */   GIM_Try, /*On fail goto*//*Label 4268*/ GIMT_Encode4(215835), // Rule ID 3340 //
     /* 215798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 215806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 215809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 215812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 215815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 215818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215822 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1212:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (CLASTA_ZPZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 215822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_H),
     /* 215825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 215827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215829 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215831 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215833 */     GIR_RootConstrainSelectedInstOperands,
     /* 215834 */     // GIR_Coverage, 3340,
     /* 215834 */     GIR_EraseRootFromParent_Done,
     /* 215835 */   // Label 4268: @215835
     /* 215835 */   GIM_Try, /*On fail goto*//*Label 4269*/ GIMT_Encode4(215877), // Rule ID 3341 //
     /* 215840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 215848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 215851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 215854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 215857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 215860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215864 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1212:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (CLASTA_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 215864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_S),
     /* 215867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 215869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215871 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215873 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215875 */     GIR_RootConstrainSelectedInstOperands,
     /* 215876 */     // GIR_Coverage, 3341,
     /* 215876 */     GIR_EraseRootFromParent_Done,
     /* 215877 */   // Label 4269: @215877
     /* 215877 */   GIM_Try, /*On fail goto*//*Label 4270*/ GIMT_Encode4(215919), // Rule ID 3342 //
     /* 215882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 215890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 215893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 215896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 215899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 215902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215906 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1212:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CLASTA_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 215906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_D),
     /* 215909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 215911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215913 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215915 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215917 */     GIR_RootConstrainSelectedInstOperands,
     /* 215918 */     // GIR_Coverage, 3342,
     /* 215918 */     GIR_EraseRootFromParent_Done,
     /* 215919 */   // Label 4270: @215919
     /* 215919 */   GIM_Try, /*On fail goto*//*Label 4271*/ GIMT_Encode4(215961), // Rule ID 3343 //
     /* 215924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 215932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 215935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 215938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 215941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 215944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215948 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1212:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (CLASTA_ZPZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 215948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_H),
     /* 215951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 215953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215955 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215957 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 215959 */     GIR_RootConstrainSelectedInstOperands,
     /* 215960 */     // GIR_Coverage, 3343,
     /* 215960 */     GIR_EraseRootFromParent_Done,
     /* 215961 */   // Label 4271: @215961
     /* 215961 */   GIM_Try, /*On fail goto*//*Label 4272*/ GIMT_Encode4(216003), // Rule ID 3344 //
     /* 215966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 215969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 215974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 215977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 215980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 215983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 215986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215990 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1212:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (CLASTA_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 215990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_S),
     /* 215993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 215995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215997 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215999 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216001 */     GIR_RootConstrainSelectedInstOperands,
     /* 216002 */     // GIR_Coverage, 3344,
     /* 216002 */     GIR_EraseRootFromParent_Done,
     /* 216003 */   // Label 4272: @216003
     /* 216003 */   GIM_Try, /*On fail goto*//*Label 4273*/ GIMT_Encode4(216045), // Rule ID 3345 //
     /* 216008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 216016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 216019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 216022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 216025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 216028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216032 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1212:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (CLASTA_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 216032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_D),
     /* 216035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 216037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216039 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216041 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216043 */     GIR_RootConstrainSelectedInstOperands,
     /* 216044 */     // GIR_Coverage, 3345,
     /* 216044 */     GIR_EraseRootFromParent_Done,
     /* 216045 */   // Label 4273: @216045
     /* 216045 */   GIM_Try, /*On fail goto*//*Label 4274*/ GIMT_Encode4(216087), // Rule ID 3428 //
     /* 216050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkpa_z),
     /* 216058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 216061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 216064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 216067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 216070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 216074 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1204:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKPA_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 216074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKPA_PPzPP),
     /* 216077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 216079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216083 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216085 */     GIR_RootConstrainSelectedInstOperands,
     /* 216086 */     // GIR_Coverage, 3428,
     /* 216086 */     GIR_EraseRootFromParent_Done,
     /* 216087 */   // Label 4274: @216087
     /* 216087 */   GIM_Try, /*On fail goto*//*Label 4275*/ GIMT_Encode4(216129), // Rule ID 3429 //
     /* 216092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkn_z),
     /* 216100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 216103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 216106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 216109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 216112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 216116 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1203:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKN_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 216116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKN_PPzP),
     /* 216119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdm]
     /* 216121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216123 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216125 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216127 */     GIR_RootConstrainSelectedInstOperands,
     /* 216128 */     // GIR_Coverage, 3429,
     /* 216128 */     GIR_EraseRootFromParent_Done,
     /* 216129 */   // Label 4275: @216129
     /* 216129 */   GIM_Try, /*On fail goto*//*Label 4276*/ GIMT_Encode4(216171), // Rule ID 3430 //
     /* 216134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brka),
     /* 216142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 216145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 216148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 216151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 216154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 216158 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1199:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKA_PPmP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 216158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKA_PPmP),
     /* 216161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 216163 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216165 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216167 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216169 */     GIR_RootConstrainSelectedInstOperands,
     /* 216170 */     // GIR_Coverage, 3430,
     /* 216170 */     GIR_EraseRootFromParent_Done,
     /* 216171 */   // Label 4276: @216171
     /* 216171 */   GIM_Try, /*On fail goto*//*Label 4277*/ GIMT_Encode4(216216), // Rule ID 3432 //
     /* 216176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 216179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_match),
     /* 216184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 216187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 216190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 216193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 216196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 216200 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1506:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (MATCH_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 216200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MATCH_PPzZZ_B),
     /* 216203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 216205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216207 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216209 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216211 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 216214 */     GIR_RootConstrainSelectedInstOperands,
     /* 216215 */     // GIR_Coverage, 3432,
     /* 216215 */     GIR_EraseRootFromParent_Done,
     /* 216216 */   // Label 4277: @216216
     /* 216216 */   GIM_Try, /*On fail goto*//*Label 4278*/ GIMT_Encode4(216261), // Rule ID 3433 //
     /* 216221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 216224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_match),
     /* 216229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 216232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 216235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 216238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 216241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 216245 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1506:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (MATCH_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 216245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MATCH_PPzZZ_H),
     /* 216248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 216250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216252 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216254 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216256 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 216259 */     GIR_RootConstrainSelectedInstOperands,
     /* 216260 */     // GIR_Coverage, 3433,
     /* 216260 */     GIR_EraseRootFromParent_Done,
     /* 216261 */   // Label 4278: @216261
     /* 216261 */   GIM_Try, /*On fail goto*//*Label 4279*/ GIMT_Encode4(216303), // Rule ID 3434 //
     /* 216266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 216269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histcnt),
     /* 216274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 216277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 216280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 216283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 216286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216290 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1451:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (HISTCNT_ZPzZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 216290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTCNT_ZPzZZ_S),
     /* 216293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 216295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216297 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216299 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216301 */     GIR_RootConstrainSelectedInstOperands,
     /* 216302 */     // GIR_Coverage, 3434,
     /* 216302 */     GIR_EraseRootFromParent_Done,
     /* 216303 */   // Label 4279: @216303
     /* 216303 */   GIM_Try, /*On fail goto*//*Label 4280*/ GIMT_Encode4(216345), // Rule ID 3435 //
     /* 216308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 216311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histcnt),
     /* 216316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 216319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 216322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 216325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 216328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216332 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1451:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (HISTCNT_ZPzZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 216332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTCNT_ZPzZZ_D),
     /* 216335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 216337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216339 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216341 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216343 */     GIR_RootConstrainSelectedInstOperands,
     /* 216344 */     // GIR_Coverage, 3435,
     /* 216344 */     GIR_EraseRootFromParent_Done,
     /* 216345 */   // Label 4280: @216345
     /* 216345 */   GIM_Try, /*On fail goto*//*Label 4281*/ GIMT_Encode4(216387), // Rule ID 3440 //
     /* 216350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
     /* 216353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smmla),
     /* 216358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 216361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 216364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 216367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 216370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216374 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1657:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 216374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMMLA_ZZZ),
     /* 216377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 216379 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216381 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216383 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216385 */     GIR_RootConstrainSelectedInstOperands,
     /* 216386 */     // GIR_Coverage, 3440,
     /* 216386 */     GIR_EraseRootFromParent_Done,
     /* 216387 */   // Label 4281: @216387
     /* 216387 */   GIM_Try, /*On fail goto*//*Label 4282*/ GIMT_Encode4(216429), // Rule ID 3479 //
     /* 216392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 216395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
     /* 216400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 216403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 216406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 216409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 216412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216416 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1280:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCLAMP_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 216416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_H),
     /* 216419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 216421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216423 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216425 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216427 */     GIR_RootConstrainSelectedInstOperands,
     /* 216428 */     // GIR_Coverage, 3479,
     /* 216428 */     GIR_EraseRootFromParent_Done,
     /* 216429 */   // Label 4282: @216429
     /* 216429 */   GIM_Try, /*On fail goto*//*Label 4283*/ GIMT_Encode4(216471), // Rule ID 3481 //
     /* 216434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 216437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
     /* 216442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 216445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 216448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 216451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 216454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216458 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1280:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCLAMP_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 216458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_S),
     /* 216461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 216463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216465 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216467 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216469 */     GIR_RootConstrainSelectedInstOperands,
     /* 216470 */     // GIR_Coverage, 3481,
     /* 216470 */     GIR_EraseRootFromParent_Done,
     /* 216471 */   // Label 4283: @216471
     /* 216471 */   GIM_Try, /*On fail goto*//*Label 4284*/ GIMT_Encode4(216513), // Rule ID 3483 //
     /* 216476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 216479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
     /* 216484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 216487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 216490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 216493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 216496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216500 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1280:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCLAMP_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 216500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_D),
     /* 216503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 216505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216507 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216509 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216511 */     GIR_RootConstrainSelectedInstOperands,
     /* 216512 */     // GIR_Coverage, 3483,
     /* 216512 */     GIR_EraseRootFromParent_Done,
     /* 216513 */   // Label 4284: @216513
     /* 216513 */   GIM_Try, /*On fail goto*//*Label 4285*/ GIMT_Encode4(216555), // Rule ID 3485 //
     /* 216518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 216521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_x2),
     /* 216526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 216529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 216532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 216535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 216538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216542 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1618:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SDOT_ZZZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 216542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_HtoS),
     /* 216545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 216547 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216549 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216551 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216553 */     GIR_RootConstrainSelectedInstOperands,
     /* 216554 */     // GIR_Coverage, 3485,
     /* 216554 */     GIR_EraseRootFromParent_Done,
     /* 216555 */   // Label 4285: @216555
     /* 216555 */   GIM_Try, /*On fail goto*//*Label 4286*/ GIMT_Encode4(216597), // Rule ID 3600 //
     /* 216560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 216563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 216568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 216571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 216574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 216577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 216580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216584 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1602:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SCLAMP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 216584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_B),
     /* 216587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 216589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216591 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216593 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216595 */     GIR_RootConstrainSelectedInstOperands,
     /* 216596 */     // GIR_Coverage, 3600,
     /* 216596 */     GIR_EraseRootFromParent_Done,
     /* 216597 */   // Label 4286: @216597
     /* 216597 */   GIM_Try, /*On fail goto*//*Label 4287*/ GIMT_Encode4(216639), // Rule ID 3602 //
     /* 216602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 216605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 216610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 216613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 216616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 216619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 216622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216626 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1602:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SCLAMP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 216626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_H),
     /* 216629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 216631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216633 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216635 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216637 */     GIR_RootConstrainSelectedInstOperands,
     /* 216638 */     // GIR_Coverage, 3602,
     /* 216638 */     GIR_EraseRootFromParent_Done,
     /* 216639 */   // Label 4287: @216639
     /* 216639 */   GIM_Try, /*On fail goto*//*Label 4288*/ GIMT_Encode4(216681), // Rule ID 3604 //
     /* 216644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 216647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 216652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 216655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 216658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 216661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 216664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216668 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1602:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCLAMP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 216668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_S),
     /* 216671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 216673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216675 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216677 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216679 */     GIR_RootConstrainSelectedInstOperands,
     /* 216680 */     // GIR_Coverage, 3604,
     /* 216680 */     GIR_EraseRootFromParent_Done,
     /* 216681 */   // Label 4288: @216681
     /* 216681 */   GIM_Try, /*On fail goto*//*Label 4289*/ GIMT_Encode4(216723), // Rule ID 3606 //
     /* 216686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 216689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 216694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 216697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 216700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 216703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 216706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216710 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1602:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCLAMP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 216710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_D),
     /* 216713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 216715 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216717 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216719 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216721 */     GIR_RootConstrainSelectedInstOperands,
     /* 216722 */     // GIR_Coverage, 3606,
     /* 216722 */     GIR_EraseRootFromParent_Done,
     /* 216723 */   // Label 4289: @216723
     /* 216723 */   GIM_Try, /*On fail goto*//*Label 4290*/ GIMT_Encode4(216765), // Rule ID 7338 //
     /* 216728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 216736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 216739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 216742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 216745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 216748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216752 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1811:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 216752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_B),
     /* 216755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 216757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216759 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216761 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216763 */     GIR_RootConstrainSelectedInstOperands,
     /* 216764 */     // GIR_Coverage, 7338,
     /* 216764 */     GIR_EraseRootFromParent_Done,
     /* 216765 */   // Label 4290: @216765
     /* 216765 */   GIM_Try, /*On fail goto*//*Label 4291*/ GIMT_Encode4(216807), // Rule ID 7340 //
     /* 216770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 216778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 216781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 216784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 216787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 216790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216794 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1811:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 216794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_H),
     /* 216797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 216799 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216801 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216803 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216805 */     GIR_RootConstrainSelectedInstOperands,
     /* 216806 */     // GIR_Coverage, 7340,
     /* 216806 */     GIR_EraseRootFromParent_Done,
     /* 216807 */   // Label 4291: @216807
     /* 216807 */   GIM_Try, /*On fail goto*//*Label 4292*/ GIMT_Encode4(216849), // Rule ID 7342 //
     /* 216812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 216820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 216823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 216826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 216829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 216832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216836 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1811:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 216836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_S),
     /* 216839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 216841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216843 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216845 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216847 */     GIR_RootConstrainSelectedInstOperands,
     /* 216848 */     // GIR_Coverage, 7342,
     /* 216848 */     GIR_EraseRootFromParent_Done,
     /* 216849 */   // Label 4292: @216849
     /* 216849 */   GIM_Try, /*On fail goto*//*Label 4293*/ GIMT_Encode4(216891), // Rule ID 7344 //
     /* 216854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 216862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 216865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 216868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 216871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 216874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216878 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1811:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 216878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_D),
     /* 216881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 216883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216885 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216887 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216889 */     GIR_RootConstrainSelectedInstOperands,
     /* 216890 */     // GIR_Coverage, 7344,
     /* 216890 */     GIR_EraseRootFromParent_Done,
     /* 216891 */   // Label 4293: @216891
     /* 216891 */   GIM_Try, /*On fail goto*//*Label 4294*/ GIMT_Encode4(216933), // Rule ID 7362 //
     /* 216896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 216904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 216907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 216910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 216913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 216916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216920 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1196:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BIC_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 216920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_B),
     /* 216923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 216925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216927 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216929 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216931 */     GIR_RootConstrainSelectedInstOperands,
     /* 216932 */     // GIR_Coverage, 7362,
     /* 216932 */     GIR_EraseRootFromParent_Done,
     /* 216933 */   // Label 4294: @216933
     /* 216933 */   GIM_Try, /*On fail goto*//*Label 4295*/ GIMT_Encode4(216975), // Rule ID 7363 //
     /* 216938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 216946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 216949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 216952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 216955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 216958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216962 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1196:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BIC_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 216962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_H),
     /* 216965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 216967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216969 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216971 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 216973 */     GIR_RootConstrainSelectedInstOperands,
     /* 216974 */     // GIR_Coverage, 7363,
     /* 216974 */     GIR_EraseRootFromParent_Done,
     /* 216975 */   // Label 4295: @216975
     /* 216975 */   GIM_Try, /*On fail goto*//*Label 4296*/ GIMT_Encode4(217017), // Rule ID 7364 //
     /* 216980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 216983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 216988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 216991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 216994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 216997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 217000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217004 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1196:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BIC_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 217004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_S),
     /* 217007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217011 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217013 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217015 */     GIR_RootConstrainSelectedInstOperands,
     /* 217016 */     // GIR_Coverage, 7364,
     /* 217016 */     GIR_EraseRootFromParent_Done,
     /* 217017 */   // Label 4296: @217017
     /* 217017 */   GIM_Try, /*On fail goto*//*Label 4297*/ GIMT_Encode4(217059), // Rule ID 7365 //
     /* 217022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 217030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 217033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 217036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 217039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 217042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217046 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1196:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BIC_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 217046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_D),
     /* 217049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217051 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217053 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217055 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217057 */     GIR_RootConstrainSelectedInstOperands,
     /* 217058 */     // GIR_Coverage, 7365,
     /* 217058 */     GIR_EraseRootFromParent_Done,
     /* 217059 */   // Label 4297: @217059
     /* 217059 */   GIM_Try, /*On fail goto*//*Label 4298*/ GIMT_Encode4(217101), // Rule ID 7478 //
     /* 217064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 217072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 217075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 217078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 217081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 217084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217088 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1658:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMULH_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 217088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_B),
     /* 217091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217095 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217097 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217099 */     GIR_RootConstrainSelectedInstOperands,
     /* 217100 */     // GIR_Coverage, 7478,
     /* 217100 */     GIR_EraseRootFromParent_Done,
     /* 217101 */   // Label 4298: @217101
     /* 217101 */   GIM_Try, /*On fail goto*//*Label 4299*/ GIMT_Encode4(217143), // Rule ID 7479 //
     /* 217106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 217114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 217117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 217120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 217123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 217126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217130 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1658:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMULH_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 217130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_H),
     /* 217133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217137 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217139 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217141 */     GIR_RootConstrainSelectedInstOperands,
     /* 217142 */     // GIR_Coverage, 7479,
     /* 217142 */     GIR_EraseRootFromParent_Done,
     /* 217143 */   // Label 4299: @217143
     /* 217143 */   GIM_Try, /*On fail goto*//*Label 4300*/ GIMT_Encode4(217185), // Rule ID 7480 //
     /* 217148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 217156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 217159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 217162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 217165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 217168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217172 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1658:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMULH_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 217172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_S),
     /* 217175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217179 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217181 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217183 */     GIR_RootConstrainSelectedInstOperands,
     /* 217184 */     // GIR_Coverage, 7480,
     /* 217184 */     GIR_EraseRootFromParent_Done,
     /* 217185 */   // Label 4300: @217185
     /* 217185 */   GIM_Try, /*On fail goto*//*Label 4301*/ GIMT_Encode4(217227), // Rule ID 7481 //
     /* 217190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 217198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 217201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 217204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 217207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 217210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217214 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1658:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMULH_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 217214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_D),
     /* 217217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217219 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217221 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217223 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217225 */     GIR_RootConstrainSelectedInstOperands,
     /* 217226 */     // GIR_Coverage, 7481,
     /* 217226 */     GIR_EraseRootFromParent_Done,
     /* 217227 */   // Label 4301: @217227
     /* 217227 */   GIM_Try, /*On fail goto*//*Label 4302*/ GIMT_Encode4(217269), // Rule ID 7482 //
     /* 217232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 217240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 217243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 217246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 217249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 217252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217256 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1896:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMULH_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 217256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_B),
     /* 217259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217263 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217265 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217267 */     GIR_RootConstrainSelectedInstOperands,
     /* 217268 */     // GIR_Coverage, 7482,
     /* 217268 */     GIR_EraseRootFromParent_Done,
     /* 217269 */   // Label 4302: @217269
     /* 217269 */   GIM_Try, /*On fail goto*//*Label 4303*/ GIMT_Encode4(217311), // Rule ID 7483 //
     /* 217274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 217282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 217285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 217288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 217291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 217294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217298 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1896:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMULH_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 217298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_H),
     /* 217301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217305 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217307 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217309 */     GIR_RootConstrainSelectedInstOperands,
     /* 217310 */     // GIR_Coverage, 7483,
     /* 217310 */     GIR_EraseRootFromParent_Done,
     /* 217311 */   // Label 4303: @217311
     /* 217311 */   GIM_Try, /*On fail goto*//*Label 4304*/ GIMT_Encode4(217353), // Rule ID 7484 //
     /* 217316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 217324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 217327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 217330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 217333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 217336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217340 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1896:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMULH_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 217340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_S),
     /* 217343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217347 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217349 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217351 */     GIR_RootConstrainSelectedInstOperands,
     /* 217352 */     // GIR_Coverage, 7484,
     /* 217352 */     GIR_EraseRootFromParent_Done,
     /* 217353 */   // Label 4304: @217353
     /* 217353 */   GIM_Try, /*On fail goto*//*Label 4305*/ GIMT_Encode4(217395), // Rule ID 7485 //
     /* 217358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 217366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 217369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 217372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 217375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 217378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217382 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1896:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMULH_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 217382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_D),
     /* 217385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217391 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217393 */     GIR_RootConstrainSelectedInstOperands,
     /* 217394 */     // GIR_Coverage, 7485,
     /* 217394 */     GIR_EraseRootFromParent_Done,
     /* 217395 */   // Label 4305: @217395
     /* 217395 */   GIM_Try, /*On fail goto*//*Label 4306*/ GIMT_Encode4(217437), // Rule ID 7494 //
     /* 217400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udiv),
     /* 217408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 217411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 217414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 217417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 217420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217424 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1859:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UDIV_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 217424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIV_ZPmZ_S),
     /* 217427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217429 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217431 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217433 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217435 */     GIR_RootConstrainSelectedInstOperands,
     /* 217436 */     // GIR_Coverage, 7494,
     /* 217436 */     GIR_EraseRootFromParent_Done,
     /* 217437 */   // Label 4306: @217437
     /* 217437 */   GIM_Try, /*On fail goto*//*Label 4307*/ GIMT_Encode4(217479), // Rule ID 7495 //
     /* 217442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udiv),
     /* 217450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 217453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 217456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 217459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 217462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217466 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1859:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UDIV_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 217466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIV_ZPmZ_D),
     /* 217469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217473 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217475 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217477 */     GIR_RootConstrainSelectedInstOperands,
     /* 217478 */     // GIR_Coverage, 7495,
     /* 217478 */     GIR_EraseRootFromParent_Done,
     /* 217479 */   // Label 4307: @217479
     /* 217479 */   GIM_Try, /*On fail goto*//*Label 4308*/ GIMT_Encode4(217521), // Rule ID 7496 //
     /* 217484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdivr),
     /* 217492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 217495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 217498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 217501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 217504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217508 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1614:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SDIVR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 217508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVR_ZPmZ_S),
     /* 217511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217515 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217517 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217519 */     GIR_RootConstrainSelectedInstOperands,
     /* 217520 */     // GIR_Coverage, 7496,
     /* 217520 */     GIR_EraseRootFromParent_Done,
     /* 217521 */   // Label 4308: @217521
     /* 217521 */   GIM_Try, /*On fail goto*//*Label 4309*/ GIMT_Encode4(217563), // Rule ID 7497 //
     /* 217526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdivr),
     /* 217534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 217537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 217540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 217543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 217546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217550 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1614:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SDIVR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 217550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVR_ZPmZ_D),
     /* 217553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217557 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217559 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217561 */     GIR_RootConstrainSelectedInstOperands,
     /* 217562 */     // GIR_Coverage, 7497,
     /* 217562 */     GIR_EraseRootFromParent_Done,
     /* 217563 */   // Label 4309: @217563
     /* 217563 */   GIM_Try, /*On fail goto*//*Label 4310*/ GIMT_Encode4(217605), // Rule ID 7498 //
     /* 217568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udivr),
     /* 217576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 217579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 217582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 217585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 217588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217592 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1861:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UDIVR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 217592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVR_ZPmZ_S),
     /* 217595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217599 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217601 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217603 */     GIR_RootConstrainSelectedInstOperands,
     /* 217604 */     // GIR_Coverage, 7498,
     /* 217604 */     GIR_EraseRootFromParent_Done,
     /* 217605 */   // Label 4310: @217605
     /* 217605 */   GIM_Try, /*On fail goto*//*Label 4311*/ GIMT_Encode4(217647), // Rule ID 7499 //
     /* 217610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udivr),
     /* 217618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 217621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 217624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 217627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 217630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217634 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1861:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UDIVR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 217634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVR_ZPmZ_D),
     /* 217637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217641 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217643 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217645 */     GIR_RootConstrainSelectedInstOperands,
     /* 217646 */     // GIR_Coverage, 7499,
     /* 217646 */     GIR_EraseRootFromParent_Done,
     /* 217647 */   // Label 4311: @217647
     /* 217647 */   GIM_Try, /*On fail goto*//*Label 4312*/ GIMT_Encode4(217689), // Rule ID 7584 //
     /* 217652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 217660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 217663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 217666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 217669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 217672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217676 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1236:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CNOT_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 217676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_B),
     /* 217679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 217681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 217683 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 217685 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 217687 */     GIR_RootConstrainSelectedInstOperands,
     /* 217688 */     // GIR_Coverage, 7584,
     /* 217688 */     GIR_EraseRootFromParent_Done,
     /* 217689 */   // Label 4312: @217689
     /* 217689 */   GIM_Try, /*On fail goto*//*Label 4313*/ GIMT_Encode4(217731), // Rule ID 7585 //
     /* 217694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 217702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 217705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 217708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 217711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 217714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217718 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1236:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CNOT_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 217718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_H),
     /* 217721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 217723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 217725 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 217727 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 217729 */     GIR_RootConstrainSelectedInstOperands,
     /* 217730 */     // GIR_Coverage, 7585,
     /* 217730 */     GIR_EraseRootFromParent_Done,
     /* 217731 */   // Label 4313: @217731
     /* 217731 */   GIM_Try, /*On fail goto*//*Label 4314*/ GIMT_Encode4(217773), // Rule ID 7586 //
     /* 217736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 217744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 217747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 217750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 217753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 217756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217760 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1236:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CNOT_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 217760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_S),
     /* 217763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 217765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 217767 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 217769 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 217771 */     GIR_RootConstrainSelectedInstOperands,
     /* 217772 */     // GIR_Coverage, 7586,
     /* 217772 */     GIR_EraseRootFromParent_Done,
     /* 217773 */   // Label 4314: @217773
     /* 217773 */   GIM_Try, /*On fail goto*//*Label 4315*/ GIMT_Encode4(217815), // Rule ID 7587 //
     /* 217778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 217786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 217789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 217792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 217795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 217798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217802 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1236:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CNOT_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 217802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_D),
     /* 217805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 217807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 217809 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 217811 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 217813 */     GIR_RootConstrainSelectedInstOperands,
     /* 217814 */     // GIR_Coverage, 7587,
     /* 217814 */     GIR_EraseRootFromParent_Done,
     /* 217815 */   // Label 4315: @217815
     /* 217815 */   GIM_Try, /*On fail goto*//*Label 4316*/ GIMT_Encode4(217857), // Rule ID 7596 //
     /* 217820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 217828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 217831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 217834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 217837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 217840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217844 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1522:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (NOT_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 217844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_B),
     /* 217847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 217849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 217851 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 217853 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 217855 */     GIR_RootConstrainSelectedInstOperands,
     /* 217856 */     // GIR_Coverage, 7596,
     /* 217856 */     GIR_EraseRootFromParent_Done,
     /* 217857 */   // Label 4316: @217857
     /* 217857 */   GIM_Try, /*On fail goto*//*Label 4317*/ GIMT_Encode4(217899), // Rule ID 7597 //
     /* 217862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 217870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 217873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 217876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 217879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 217882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217886 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1522:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (NOT_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 217886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_H),
     /* 217889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 217891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 217893 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 217895 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 217897 */     GIR_RootConstrainSelectedInstOperands,
     /* 217898 */     // GIR_Coverage, 7597,
     /* 217898 */     GIR_EraseRootFromParent_Done,
     /* 217899 */   // Label 4317: @217899
     /* 217899 */   GIM_Try, /*On fail goto*//*Label 4318*/ GIMT_Encode4(217941), // Rule ID 7598 //
     /* 217904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 217912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 217915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 217918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 217921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 217924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217928 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1522:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (NOT_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 217928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_S),
     /* 217931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 217933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 217935 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 217937 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 217939 */     GIR_RootConstrainSelectedInstOperands,
     /* 217940 */     // GIR_Coverage, 7598,
     /* 217940 */     GIR_EraseRootFromParent_Done,
     /* 217941 */   // Label 4318: @217941
     /* 217941 */   GIM_Try, /*On fail goto*//*Label 4319*/ GIMT_Encode4(217983), // Rule ID 7599 //
     /* 217946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 217954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 217957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 217960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 217963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 217966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217970 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1522:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (NOT_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 217970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_D),
     /* 217973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 217975 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 217977 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 217979 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 217981 */     GIR_RootConstrainSelectedInstOperands,
     /* 217982 */     // GIR_Coverage, 7599,
     /* 217982 */     GIR_EraseRootFromParent_Done,
     /* 217983 */   // Label 4319: @217983
     /* 217983 */   GIM_Try, /*On fail goto*//*Label 4320*/ GIMT_Encode4(218025), // Rule ID 7678 //
     /* 217988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 217996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 217999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 218002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 218005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 218008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218012 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1589:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 218012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_B),
     /* 218015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218021 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218023 */     GIR_RootConstrainSelectedInstOperands,
     /* 218024 */     // GIR_Coverage, 7678,
     /* 218024 */     GIR_EraseRootFromParent_Done,
     /* 218025 */   // Label 4320: @218025
     /* 218025 */   GIM_Try, /*On fail goto*//*Label 4321*/ GIMT_Encode4(218067), // Rule ID 7679 //
     /* 218030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 218038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 218041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 218044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 218047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 218050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218054 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1589:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 218054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_H),
     /* 218057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218059 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218061 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218063 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218065 */     GIR_RootConstrainSelectedInstOperands,
     /* 218066 */     // GIR_Coverage, 7679,
     /* 218066 */     GIR_EraseRootFromParent_Done,
     /* 218067 */   // Label 4321: @218067
     /* 218067 */   GIM_Try, /*On fail goto*//*Label 4322*/ GIMT_Encode4(218109), // Rule ID 7680 //
     /* 218072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 218080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 218086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 218089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 218092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218096 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1589:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 218096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_S),
     /* 218099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218103 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218105 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218107 */     GIR_RootConstrainSelectedInstOperands,
     /* 218108 */     // GIR_Coverage, 7680,
     /* 218108 */     GIR_EraseRootFromParent_Done,
     /* 218109 */   // Label 4322: @218109
     /* 218109 */   GIM_Try, /*On fail goto*//*Label 4323*/ GIMT_Encode4(218151), // Rule ID 7681 //
     /* 218114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 218122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 218125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 218128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 218131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 218134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218138 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1589:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SABD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 218138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_D),
     /* 218141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218145 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218147 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218149 */     GIR_RootConstrainSelectedInstOperands,
     /* 218150 */     // GIR_Coverage, 7681,
     /* 218150 */     GIR_EraseRootFromParent_Done,
     /* 218151 */   // Label 4323: @218151
     /* 218151 */   GIM_Try, /*On fail goto*//*Label 4324*/ GIMT_Encode4(218193), // Rule ID 7682 //
     /* 218156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 218164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 218167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 218170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 218173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 218176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218180 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1839:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 218180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_B),
     /* 218183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218187 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218189 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218191 */     GIR_RootConstrainSelectedInstOperands,
     /* 218192 */     // GIR_Coverage, 7682,
     /* 218192 */     GIR_EraseRootFromParent_Done,
     /* 218193 */   // Label 4324: @218193
     /* 218193 */   GIM_Try, /*On fail goto*//*Label 4325*/ GIMT_Encode4(218235), // Rule ID 7683 //
     /* 218198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 218206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 218209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 218212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 218215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 218218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218222 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1839:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 218222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_H),
     /* 218225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218229 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218231 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218233 */     GIR_RootConstrainSelectedInstOperands,
     /* 218234 */     // GIR_Coverage, 7683,
     /* 218234 */     GIR_EraseRootFromParent_Done,
     /* 218235 */   // Label 4325: @218235
     /* 218235 */   GIM_Try, /*On fail goto*//*Label 4326*/ GIMT_Encode4(218277), // Rule ID 7684 //
     /* 218240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 218248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 218254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 218257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 218260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218264 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1839:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 218264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_S),
     /* 218267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218271 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218273 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218275 */     GIR_RootConstrainSelectedInstOperands,
     /* 218276 */     // GIR_Coverage, 7684,
     /* 218276 */     GIR_EraseRootFromParent_Done,
     /* 218277 */   // Label 4326: @218277
     /* 218277 */   GIM_Try, /*On fail goto*//*Label 4327*/ GIMT_Encode4(218319), // Rule ID 7685 //
     /* 218282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 218290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 218293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 218296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 218299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 218302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218306 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1839:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UABD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 218306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_D),
     /* 218309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218313 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218315 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218317 */     GIR_RootConstrainSelectedInstOperands,
     /* 218318 */     // GIR_Coverage, 7685,
     /* 218318 */     GIR_EraseRootFromParent_Done,
     /* 218319 */   // Label 4327: @218319
     /* 218319 */   GIM_Try, /*On fail goto*//*Label 4328*/ GIMT_Encode4(218361), // Rule ID 7881 //
     /* 218324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 218332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 218335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 218338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 218341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 218344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218348 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1445:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FSUB_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 218348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_H),
     /* 218351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218355 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218357 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218359 */     GIR_RootConstrainSelectedInstOperands,
     /* 218360 */     // GIR_Coverage, 7881,
     /* 218360 */     GIR_EraseRootFromParent_Done,
     /* 218361 */   // Label 4328: @218361
     /* 218361 */   GIM_Try, /*On fail goto*//*Label 4329*/ GIMT_Encode4(218403), // Rule ID 7883 //
     /* 218366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 218374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 218380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 218383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 218386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218390 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1445:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FSUB_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 218390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_S),
     /* 218393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218397 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218399 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218401 */     GIR_RootConstrainSelectedInstOperands,
     /* 218402 */     // GIR_Coverage, 7883,
     /* 218402 */     GIR_EraseRootFromParent_Done,
     /* 218403 */   // Label 4329: @218403
     /* 218403 */   GIM_Try, /*On fail goto*//*Label 4330*/ GIMT_Encode4(218445), // Rule ID 7885 //
     /* 218408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 218416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 218419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 218422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 218425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 218428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218432 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1445:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FSUB_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 218432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_D),
     /* 218435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218439 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218441 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218443 */     GIR_RootConstrainSelectedInstOperands,
     /* 218444 */     // GIR_Coverage, 7885,
     /* 218444 */     GIR_EraseRootFromParent_Done,
     /* 218445 */   // Label 4330: @218445
     /* 218445 */   GIM_Try, /*On fail goto*//*Label 4331*/ GIMT_Encode4(218487), // Rule ID 7893 //
     /* 218450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 218458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 218461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 218464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 218467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 218470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218474 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1447:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FSUBR_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 218474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_H),
     /* 218477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218481 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218483 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218485 */     GIR_RootConstrainSelectedInstOperands,
     /* 218486 */     // GIR_Coverage, 7893,
     /* 218486 */     GIR_EraseRootFromParent_Done,
     /* 218487 */   // Label 4331: @218487
     /* 218487 */   GIM_Try, /*On fail goto*//*Label 4332*/ GIMT_Encode4(218529), // Rule ID 7895 //
     /* 218492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 218500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 218506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 218509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 218512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218516 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1447:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FSUBR_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 218516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_S),
     /* 218519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218525 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218527 */     GIR_RootConstrainSelectedInstOperands,
     /* 218528 */     // GIR_Coverage, 7895,
     /* 218528 */     GIR_EraseRootFromParent_Done,
     /* 218529 */   // Label 4332: @218529
     /* 218529 */   GIM_Try, /*On fail goto*//*Label 4333*/ GIMT_Encode4(218571), // Rule ID 7897 //
     /* 218534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 218542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 218545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 218548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 218551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 218554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218558 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1447:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FSUBR_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 218558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_D),
     /* 218561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218565 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218567 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218569 */     GIR_RootConstrainSelectedInstOperands,
     /* 218570 */     // GIR_Coverage, 7897,
     /* 218570 */     GIR_EraseRootFromParent_Done,
     /* 218571 */   // Label 4333: @218571
     /* 218571 */   GIM_Try, /*On fail goto*//*Label 4334*/ GIMT_Encode4(218613), // Rule ID 7935 //
     /* 218576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
     /* 218584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 218587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 218590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 218593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 218596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218600 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1264:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FABD_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 218600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_H),
     /* 218603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218607 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218609 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218611 */     GIR_RootConstrainSelectedInstOperands,
     /* 218612 */     // GIR_Coverage, 7935,
     /* 218612 */     GIR_EraseRootFromParent_Done,
     /* 218613 */   // Label 4334: @218613
     /* 218613 */   GIM_Try, /*On fail goto*//*Label 4335*/ GIMT_Encode4(218655), // Rule ID 7936 //
     /* 218618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
     /* 218626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 218632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 218635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 218638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218642 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1264:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FABD_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 218642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_S),
     /* 218645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218651 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218653 */     GIR_RootConstrainSelectedInstOperands,
     /* 218654 */     // GIR_Coverage, 7936,
     /* 218654 */     GIR_EraseRootFromParent_Done,
     /* 218655 */   // Label 4335: @218655
     /* 218655 */   GIM_Try, /*On fail goto*//*Label 4336*/ GIMT_Encode4(218697), // Rule ID 7937 //
     /* 218660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
     /* 218668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 218671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 218674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 218677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 218680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218684 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1264:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FABD_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 218684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_D),
     /* 218687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218691 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218693 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218695 */     GIR_RootConstrainSelectedInstOperands,
     /* 218696 */     // GIR_Coverage, 7937,
     /* 218696 */     GIR_EraseRootFromParent_Done,
     /* 218697 */   // Label 4336: @218697
     /* 218697 */   GIM_Try, /*On fail goto*//*Label 4337*/ GIMT_Encode4(218739), // Rule ID 7938 //
     /* 218702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
     /* 218710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 218713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 218716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 218719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 218722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218726 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1386:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMULX_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 218726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_H),
     /* 218729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218733 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218735 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218737 */     GIR_RootConstrainSelectedInstOperands,
     /* 218738 */     // GIR_Coverage, 7938,
     /* 218738 */     GIR_EraseRootFromParent_Done,
     /* 218739 */   // Label 4337: @218739
     /* 218739 */   GIM_Try, /*On fail goto*//*Label 4338*/ GIMT_Encode4(218781), // Rule ID 7939 //
     /* 218744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
     /* 218752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 218758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 218761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 218764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218768 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1386:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMULX_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 218768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_S),
     /* 218771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218775 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218777 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218779 */     GIR_RootConstrainSelectedInstOperands,
     /* 218780 */     // GIR_Coverage, 7939,
     /* 218780 */     GIR_EraseRootFromParent_Done,
     /* 218781 */   // Label 4338: @218781
     /* 218781 */   GIM_Try, /*On fail goto*//*Label 4339*/ GIMT_Encode4(218823), // Rule ID 7940 //
     /* 218786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
     /* 218794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 218797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 218800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 218803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 218806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218810 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1386:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMULX_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 218810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_D),
     /* 218813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218815 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218817 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218819 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218821 */     GIR_RootConstrainSelectedInstOperands,
     /* 218822 */     // GIR_Coverage, 7940,
     /* 218822 */     GIR_EraseRootFromParent_Done,
     /* 218823 */   // Label 4339: @218823
     /* 218823 */   GIM_Try, /*On fail goto*//*Label 4340*/ GIMT_Encode4(218865), // Rule ID 7941 //
     /* 218828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
     /* 218836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 218839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 218842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 218845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 218848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218852 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1325:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDIVR_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 218852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_H),
     /* 218855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218861 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218863 */     GIR_RootConstrainSelectedInstOperands,
     /* 218864 */     // GIR_Coverage, 7941,
     /* 218864 */     GIR_EraseRootFromParent_Done,
     /* 218865 */   // Label 4340: @218865
     /* 218865 */   GIM_Try, /*On fail goto*//*Label 4341*/ GIMT_Encode4(218907), // Rule ID 7942 //
     /* 218870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
     /* 218878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 218884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 218887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 218890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218894 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1325:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FDIVR_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 218894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_S),
     /* 218897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218899 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218901 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218903 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218905 */     GIR_RootConstrainSelectedInstOperands,
     /* 218906 */     // GIR_Coverage, 7942,
     /* 218906 */     GIR_EraseRootFromParent_Done,
     /* 218907 */   // Label 4341: @218907
     /* 218907 */   GIM_Try, /*On fail goto*//*Label 4342*/ GIMT_Encode4(218949), // Rule ID 7943 //
     /* 218912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
     /* 218920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 218923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 218926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 218929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 218932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218936 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1325:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FDIVR_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 218936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_D),
     /* 218939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218945 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218947 */     GIR_RootConstrainSelectedInstOperands,
     /* 218948 */     // GIR_Coverage, 7943,
     /* 218948 */     GIR_EraseRootFromParent_Done,
     /* 218949 */   // Label 4342: @218949
     /* 218949 */   GIM_Try, /*On fail goto*//*Label 4343*/ GIMT_Encode4(218991), // Rule ID 7944 //
     /* 218954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
     /* 218962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 218965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 218968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 218971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 218974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218978 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1323:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDIV_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 218978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_H),
     /* 218981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218985 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218987 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218989 */     GIR_RootConstrainSelectedInstOperands,
     /* 218990 */     // GIR_Coverage, 7944,
     /* 218990 */     GIR_EraseRootFromParent_Done,
     /* 218991 */   // Label 4343: @218991
     /* 218991 */   GIM_Try, /*On fail goto*//*Label 4344*/ GIMT_Encode4(219033), // Rule ID 7945 //
     /* 218996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
     /* 219004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 219010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 219013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219020 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1323:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FDIV_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 219020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_S),
     /* 219023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219027 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219029 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219031 */     GIR_RootConstrainSelectedInstOperands,
     /* 219032 */     // GIR_Coverage, 7945,
     /* 219032 */     GIR_EraseRootFromParent_Done,
     /* 219033 */   // Label 4344: @219033
     /* 219033 */   GIM_Try, /*On fail goto*//*Label 4345*/ GIMT_Encode4(219075), // Rule ID 7946 //
     /* 219038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
     /* 219046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 219052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 219055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 219058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219062 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1323:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FDIV_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 219062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_D),
     /* 219065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219069 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219071 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219073 */     GIR_RootConstrainSelectedInstOperands,
     /* 219074 */     // GIR_Coverage, 7946,
     /* 219074 */     GIR_EraseRootFromParent_Done,
     /* 219075 */   // Label 4345: @219075
     /* 219075 */   GIM_Try, /*On fail goto*//*Label 4346*/ GIMT_Encode4(219117), // Rule ID 7983 //
     /* 219080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 219088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 219091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 219094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 219097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 219100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219104 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1265:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 219104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
     /* 219107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219111 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219113 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219115 */     GIR_RootConstrainSelectedInstOperands,
     /* 219116 */     // GIR_Coverage, 7983,
     /* 219116 */     GIR_EraseRootFromParent_Done,
     /* 219117 */   // Label 4346: @219117
     /* 219117 */   GIM_Try, /*On fail goto*//*Label 4347*/ GIMT_Encode4(219159), // Rule ID 7985 //
     /* 219122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 219130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 219133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 219136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 219139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 219142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219146 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1265:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 219146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
     /* 219149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219153 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219155 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219157 */     GIR_RootConstrainSelectedInstOperands,
     /* 219158 */     // GIR_Coverage, 7985,
     /* 219158 */     GIR_EraseRootFromParent_Done,
     /* 219159 */   // Label 4347: @219159
     /* 219159 */   GIM_Try, /*On fail goto*//*Label 4348*/ GIMT_Encode4(219201), // Rule ID 7987 //
     /* 219164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 219172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 219175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 219178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 219181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 219184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219188 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1265:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 219188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
     /* 219191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219195 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219197 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219199 */     GIR_RootConstrainSelectedInstOperands,
     /* 219200 */     // GIR_Coverage, 7987,
     /* 219200 */     GIR_EraseRootFromParent_Done,
     /* 219201 */   // Label 4348: @219201
     /* 219201 */   GIM_Try, /*On fail goto*//*Label 4349*/ GIMT_Encode4(219243), // Rule ID 7989 //
     /* 219206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 219214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 219220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 219223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219230 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1265:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FABD_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 219230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_S_UNDEF),
     /* 219233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219235 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219237 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219239 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219241 */     GIR_RootConstrainSelectedInstOperands,
     /* 219242 */     // GIR_Coverage, 7989,
     /* 219242 */     GIR_EraseRootFromParent_Done,
     /* 219243 */   // Label 4349: @219243
     /* 219243 */   GIM_Try, /*On fail goto*//*Label 4350*/ GIMT_Encode4(219285), // Rule ID 7991 //
     /* 219248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 219256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 219259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 219262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 219265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 219268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219272 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1265:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FABD_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 219272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_S_UNDEF),
     /* 219275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219279 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219281 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219283 */     GIR_RootConstrainSelectedInstOperands,
     /* 219284 */     // GIR_Coverage, 7991,
     /* 219284 */     GIR_EraseRootFromParent_Done,
     /* 219285 */   // Label 4350: @219285
     /* 219285 */   GIM_Try, /*On fail goto*//*Label 4351*/ GIMT_Encode4(219327), // Rule ID 7993 //
     /* 219290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 219298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 219304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 219307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 219310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219314 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1265:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FABD_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 219314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_D_UNDEF),
     /* 219317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219319 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219321 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219323 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219325 */     GIR_RootConstrainSelectedInstOperands,
     /* 219326 */     // GIR_Coverage, 7993,
     /* 219326 */     GIR_EraseRootFromParent_Done,
     /* 219327 */   // Label 4351: @219327
     /* 219327 */   GIM_Try, /*On fail goto*//*Label 4352*/ GIMT_Encode4(219369), // Rule ID 7995 //
     /* 219332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 219340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 219343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 219346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 219349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 219352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219356 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1387:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 219356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
     /* 219359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219363 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219365 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219367 */     GIR_RootConstrainSelectedInstOperands,
     /* 219368 */     // GIR_Coverage, 7995,
     /* 219368 */     GIR_EraseRootFromParent_Done,
     /* 219369 */   // Label 4352: @219369
     /* 219369 */   GIM_Try, /*On fail goto*//*Label 4353*/ GIMT_Encode4(219411), // Rule ID 7996 //
     /* 219374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 219382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 219385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 219388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 219391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 219394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219398 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1387:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 219398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
     /* 219401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219405 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219407 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219409 */     GIR_RootConstrainSelectedInstOperands,
     /* 219410 */     // GIR_Coverage, 7996,
     /* 219410 */     GIR_EraseRootFromParent_Done,
     /* 219411 */   // Label 4353: @219411
     /* 219411 */   GIM_Try, /*On fail goto*//*Label 4354*/ GIMT_Encode4(219453), // Rule ID 7997 //
     /* 219416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 219424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 219427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 219430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 219433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 219436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219440 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1387:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 219440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
     /* 219443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219447 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219449 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219451 */     GIR_RootConstrainSelectedInstOperands,
     /* 219452 */     // GIR_Coverage, 7997,
     /* 219452 */     GIR_EraseRootFromParent_Done,
     /* 219453 */   // Label 4354: @219453
     /* 219453 */   GIM_Try, /*On fail goto*//*Label 4355*/ GIMT_Encode4(219495), // Rule ID 7998 //
     /* 219458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 219466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 219472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 219475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219482 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1387:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMULX_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 219482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_S_UNDEF),
     /* 219485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219489 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219491 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219493 */     GIR_RootConstrainSelectedInstOperands,
     /* 219494 */     // GIR_Coverage, 7998,
     /* 219494 */     GIR_EraseRootFromParent_Done,
     /* 219495 */   // Label 4355: @219495
     /* 219495 */   GIM_Try, /*On fail goto*//*Label 4356*/ GIMT_Encode4(219537), // Rule ID 7999 //
     /* 219500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 219508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 219511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 219514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 219517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 219520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219524 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1387:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FMULX_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 219524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_S_UNDEF),
     /* 219527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219531 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219533 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219535 */     GIR_RootConstrainSelectedInstOperands,
     /* 219536 */     // GIR_Coverage, 7999,
     /* 219536 */     GIR_EraseRootFromParent_Done,
     /* 219537 */   // Label 4356: @219537
     /* 219537 */   GIM_Try, /*On fail goto*//*Label 4357*/ GIMT_Encode4(219579), // Rule ID 8000 //
     /* 219542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 219550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 219556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 219559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 219562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219566 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1387:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMULX_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 219566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_D_UNDEF),
     /* 219569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219573 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219575 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219577 */     GIR_RootConstrainSelectedInstOperands,
     /* 219578 */     // GIR_Coverage, 8000,
     /* 219578 */     GIR_EraseRootFromParent_Done,
     /* 219579 */   // Label 4357: @219579
     /* 219579 */   GIM_Try, /*On fail goto*//*Label 4358*/ GIMT_Encode4(219621), // Rule ID 8253 //
     /* 219584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkpb_z),
     /* 219592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 219595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 219598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 219601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 219604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 219608 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1205:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKPB_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 219608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKPB_PPzPP),
     /* 219611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 219613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219615 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219617 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219619 */     GIR_RootConstrainSelectedInstOperands,
     /* 219620 */     // GIR_Coverage, 8253,
     /* 219620 */     GIR_EraseRootFromParent_Done,
     /* 219621 */   // Label 4358: @219621
     /* 219621 */   GIM_Try, /*On fail goto*//*Label 4359*/ GIMT_Encode4(219663), // Rule ID 8255 //
     /* 219626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkb),
     /* 219634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 219637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 219640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 219643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 219646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 219650 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1201:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKB_PPmP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 219650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKB_PPmP),
     /* 219653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 219655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219659 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219661 */     GIR_RootConstrainSelectedInstOperands,
     /* 219662 */     // GIR_Coverage, 8255,
     /* 219662 */     GIR_EraseRootFromParent_Done,
     /* 219663 */   // Label 4359: @219663
     /* 219663 */   GIM_Try, /*On fail goto*//*Label 4360*/ GIMT_Encode4(219705), // Rule ID 8256 //
     /* 219668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 219676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 219679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 219682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 219685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 219688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 219692 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1198:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 219692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 219695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 219697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219699 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219701 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219703 */     GIR_RootConstrainSelectedInstOperands,
     /* 219704 */     // GIR_Coverage, 8256,
     /* 219704 */     GIR_EraseRootFromParent_Done,
     /* 219705 */   // Label 4360: @219705
     /* 219705 */   GIM_Try, /*On fail goto*//*Label 4361*/ GIMT_Encode4(219747), // Rule ID 8257 //
     /* 219710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 219718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 219721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 219724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 219727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 219730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 219734 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1198:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 219734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 219737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 219739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219741 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219743 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219745 */     GIR_RootConstrainSelectedInstOperands,
     /* 219746 */     // GIR_Coverage, 8257,
     /* 219746 */     GIR_EraseRootFromParent_Done,
     /* 219747 */   // Label 4361: @219747
     /* 219747 */   GIM_Try, /*On fail goto*//*Label 4362*/ GIMT_Encode4(219789), // Rule ID 8258 //
     /* 219752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 219760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 219763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 219766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 219769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 219772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 219776 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1198:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 219776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 219779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 219781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219785 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219787 */     GIR_RootConstrainSelectedInstOperands,
     /* 219788 */     // GIR_Coverage, 8258,
     /* 219788 */     GIR_EraseRootFromParent_Done,
     /* 219789 */   // Label 4362: @219789
     /* 219789 */   GIM_Try, /*On fail goto*//*Label 4363*/ GIMT_Encode4(219831), // Rule ID 8259 //
     /* 219794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 219802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 219805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 219808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 219811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 219814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 219818 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1198:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 219818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 219821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 219823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219825 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219827 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219829 */     GIR_RootConstrainSelectedInstOperands,
     /* 219830 */     // GIR_Coverage, 8259,
     /* 219830 */     GIR_EraseRootFromParent_Done,
     /* 219831 */   // Label 4363: @219831
     /* 219831 */   GIM_Try, /*On fail goto*//*Label 4364*/ GIMT_Encode4(219873), // Rule ID 8260 //
     /* 219836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 219844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 219847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 219850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 219853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 219856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 219860 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1198:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 219860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 219863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 219865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219867 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219869 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219871 */     GIR_RootConstrainSelectedInstOperands,
     /* 219872 */     // GIR_Coverage, 8260,
     /* 219872 */     GIR_EraseRootFromParent_Done,
     /* 219873 */   // Label 4364: @219873
     /* 219873 */   GIM_Try, /*On fail goto*//*Label 4365*/ GIMT_Encode4(219915), // Rule ID 8281 //
     /* 219878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 219886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 219889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 219892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 219895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 219898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 219902 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1256:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 219902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 219905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 219907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219909 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219911 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219913 */     GIR_RootConstrainSelectedInstOperands,
     /* 219914 */     // GIR_Coverage, 8281,
     /* 219914 */     GIR_EraseRootFromParent_Done,
     /* 219915 */   // Label 4365: @219915
     /* 219915 */   GIM_Try, /*On fail goto*//*Label 4366*/ GIMT_Encode4(219957), // Rule ID 8282 //
     /* 219920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 219928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 219931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 219934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 219937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 219940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 219944 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1256:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 219944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 219947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 219949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219951 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219953 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219955 */     GIR_RootConstrainSelectedInstOperands,
     /* 219956 */     // GIR_Coverage, 8282,
     /* 219956 */     GIR_EraseRootFromParent_Done,
     /* 219957 */   // Label 4366: @219957
     /* 219957 */   GIM_Try, /*On fail goto*//*Label 4367*/ GIMT_Encode4(219999), // Rule ID 8283 //
     /* 219962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 219970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 219973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 219976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 219979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 219982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 219986 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1256:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 219986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 219989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 219991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219993 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219995 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219997 */     GIR_RootConstrainSelectedInstOperands,
     /* 219998 */     // GIR_Coverage, 8283,
     /* 219998 */     GIR_EraseRootFromParent_Done,
     /* 219999 */   // Label 4367: @219999
     /* 219999 */   GIM_Try, /*On fail goto*//*Label 4368*/ GIMT_Encode4(220041), // Rule ID 8284 //
     /* 220004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 220012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 220015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 220018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 220021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 220024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220028 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1256:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 220028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 220031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220035 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220037 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220039 */     GIR_RootConstrainSelectedInstOperands,
     /* 220040 */     // GIR_Coverage, 8284,
     /* 220040 */     GIR_EraseRootFromParent_Done,
     /* 220041 */   // Label 4368: @220041
     /* 220041 */   GIM_Try, /*On fail goto*//*Label 4369*/ GIMT_Encode4(220083), // Rule ID 8285 //
     /* 220046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 220054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 220057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 220060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 220063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 220066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220070 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1256:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 220070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 220073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220077 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220079 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220081 */     GIR_RootConstrainSelectedInstOperands,
     /* 220082 */     // GIR_Coverage, 8285,
     /* 220082 */     GIR_EraseRootFromParent_Done,
     /* 220083 */   // Label 4369: @220083
     /* 220083 */   GIM_Try, /*On fail goto*//*Label 4370*/ GIMT_Encode4(220125), // Rule ID 8301 //
     /* 220088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 220096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 220099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 220102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 220105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 220108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220112 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1527:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 220112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 220115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220119 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220121 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220123 */     GIR_RootConstrainSelectedInstOperands,
     /* 220124 */     // GIR_Coverage, 8301,
     /* 220124 */     GIR_EraseRootFromParent_Done,
     /* 220125 */   // Label 4370: @220125
     /* 220125 */   GIM_Try, /*On fail goto*//*Label 4371*/ GIMT_Encode4(220167), // Rule ID 8302 //
     /* 220130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 220138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 220141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 220144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 220147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 220150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220154 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1527:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 220154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 220157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220159 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220161 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220163 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220165 */     GIR_RootConstrainSelectedInstOperands,
     /* 220166 */     // GIR_Coverage, 8302,
     /* 220166 */     GIR_EraseRootFromParent_Done,
     /* 220167 */   // Label 4371: @220167
     /* 220167 */   GIM_Try, /*On fail goto*//*Label 4372*/ GIMT_Encode4(220209), // Rule ID 8303 //
     /* 220172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 220180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 220183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 220186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 220189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 220192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220196 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1527:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 220196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 220199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220203 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220205 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220207 */     GIR_RootConstrainSelectedInstOperands,
     /* 220208 */     // GIR_Coverage, 8303,
     /* 220208 */     GIR_EraseRootFromParent_Done,
     /* 220209 */   // Label 4372: @220209
     /* 220209 */   GIM_Try, /*On fail goto*//*Label 4373*/ GIMT_Encode4(220251), // Rule ID 8304 //
     /* 220214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 220222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 220225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 220228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 220231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 220234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220238 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1527:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 220238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 220241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220245 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220247 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220249 */     GIR_RootConstrainSelectedInstOperands,
     /* 220250 */     // GIR_Coverage, 8304,
     /* 220250 */     GIR_EraseRootFromParent_Done,
     /* 220251 */   // Label 4373: @220251
     /* 220251 */   GIM_Try, /*On fail goto*//*Label 4374*/ GIMT_Encode4(220293), // Rule ID 8305 //
     /* 220256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 220264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 220267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 220270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 220273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 220276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220280 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1527:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 220280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 220283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220287 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220289 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220291 */     GIR_RootConstrainSelectedInstOperands,
     /* 220292 */     // GIR_Coverage, 8305,
     /* 220292 */     GIR_EraseRootFromParent_Done,
     /* 220293 */   // Label 4374: @220293
     /* 220293 */   GIM_Try, /*On fail goto*//*Label 4375*/ GIMT_Encode4(220335), // Rule ID 8306 //
     /* 220298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 220306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 220309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 220312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 220315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 220318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220322 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1523:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 220322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 220325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220329 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220331 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220333 */     GIR_RootConstrainSelectedInstOperands,
     /* 220334 */     // GIR_Coverage, 8306,
     /* 220334 */     GIR_EraseRootFromParent_Done,
     /* 220335 */   // Label 4375: @220335
     /* 220335 */   GIM_Try, /*On fail goto*//*Label 4376*/ GIMT_Encode4(220377), // Rule ID 8307 //
     /* 220340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 220348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 220351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 220354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 220357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 220360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220364 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1523:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 220364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 220367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220369 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220371 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220373 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220375 */     GIR_RootConstrainSelectedInstOperands,
     /* 220376 */     // GIR_Coverage, 8307,
     /* 220376 */     GIR_EraseRootFromParent_Done,
     /* 220377 */   // Label 4376: @220377
     /* 220377 */   GIM_Try, /*On fail goto*//*Label 4377*/ GIMT_Encode4(220419), // Rule ID 8308 //
     /* 220382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 220390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 220393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 220396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 220399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 220402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220406 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1523:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 220406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 220409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220413 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220415 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220417 */     GIR_RootConstrainSelectedInstOperands,
     /* 220418 */     // GIR_Coverage, 8308,
     /* 220418 */     GIR_EraseRootFromParent_Done,
     /* 220419 */   // Label 4377: @220419
     /* 220419 */   GIM_Try, /*On fail goto*//*Label 4378*/ GIMT_Encode4(220461), // Rule ID 8309 //
     /* 220424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 220432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 220435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 220438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 220441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 220444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220448 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1523:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 220448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 220451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220455 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220457 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220459 */     GIR_RootConstrainSelectedInstOperands,
     /* 220460 */     // GIR_Coverage, 8309,
     /* 220460 */     GIR_EraseRootFromParent_Done,
     /* 220461 */   // Label 4378: @220461
     /* 220461 */   GIM_Try, /*On fail goto*//*Label 4379*/ GIMT_Encode4(220503), // Rule ID 8310 //
     /* 220466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 220474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 220477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 220480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 220483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 220486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220490 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1523:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 220490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 220493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220495 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220497 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220499 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220501 */     GIR_RootConstrainSelectedInstOperands,
     /* 220502 */     // GIR_Coverage, 8310,
     /* 220502 */     GIR_EraseRootFromParent_Done,
     /* 220503 */   // Label 4379: @220503
     /* 220503 */   GIM_Try, /*On fail goto*//*Label 4380*/ GIMT_Encode4(220545), // Rule ID 8311 //
     /* 220508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 220516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 220519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 220522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 220525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 220528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220532 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1521:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 220532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 220535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220539 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220541 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220543 */     GIR_RootConstrainSelectedInstOperands,
     /* 220544 */     // GIR_Coverage, 8311,
     /* 220544 */     GIR_EraseRootFromParent_Done,
     /* 220545 */   // Label 4380: @220545
     /* 220545 */   GIM_Try, /*On fail goto*//*Label 4381*/ GIMT_Encode4(220587), // Rule ID 8312 //
     /* 220550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 220558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 220561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 220564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 220567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 220570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220574 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1521:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 220574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 220577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220581 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220583 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220585 */     GIR_RootConstrainSelectedInstOperands,
     /* 220586 */     // GIR_Coverage, 8312,
     /* 220586 */     GIR_EraseRootFromParent_Done,
     /* 220587 */   // Label 4381: @220587
     /* 220587 */   GIM_Try, /*On fail goto*//*Label 4382*/ GIMT_Encode4(220629), // Rule ID 8313 //
     /* 220592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 220600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 220603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 220606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 220609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 220612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220616 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1521:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 220616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 220619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220623 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220625 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220627 */     GIR_RootConstrainSelectedInstOperands,
     /* 220628 */     // GIR_Coverage, 8313,
     /* 220628 */     GIR_EraseRootFromParent_Done,
     /* 220629 */   // Label 4382: @220629
     /* 220629 */   GIM_Try, /*On fail goto*//*Label 4383*/ GIMT_Encode4(220671), // Rule ID 8314 //
     /* 220634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 220642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 220645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 220648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 220651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 220654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220658 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1521:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 220658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 220661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220663 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220665 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220667 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220669 */     GIR_RootConstrainSelectedInstOperands,
     /* 220670 */     // GIR_Coverage, 8314,
     /* 220670 */     GIR_EraseRootFromParent_Done,
     /* 220671 */   // Label 4383: @220671
     /* 220671 */   GIM_Try, /*On fail goto*//*Label 4384*/ GIMT_Encode4(220713), // Rule ID 8315 //
     /* 220676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 220684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 220687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 220690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 220693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 220696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220700 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1521:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 220700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 220703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220707 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220709 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220711 */     GIR_RootConstrainSelectedInstOperands,
     /* 220712 */     // GIR_Coverage, 8315,
     /* 220712 */     GIR_EraseRootFromParent_Done,
     /* 220713 */   // Label 4384: @220713
     /* 220713 */   GIM_Try, /*On fail goto*//*Label 4385*/ GIMT_Encode4(220755), // Rule ID 8316 //
     /* 220718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 220726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 220729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 220732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 220735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 220738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220742 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1517:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 220742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 220745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220749 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220751 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220753 */     GIR_RootConstrainSelectedInstOperands,
     /* 220754 */     // GIR_Coverage, 8316,
     /* 220754 */     GIR_EraseRootFromParent_Done,
     /* 220755 */   // Label 4385: @220755
     /* 220755 */   GIM_Try, /*On fail goto*//*Label 4386*/ GIMT_Encode4(220797), // Rule ID 8317 //
     /* 220760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 220768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 220771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 220774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 220777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 220780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220784 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1517:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 220784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 220787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220791 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220793 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220795 */     GIR_RootConstrainSelectedInstOperands,
     /* 220796 */     // GIR_Coverage, 8317,
     /* 220796 */     GIR_EraseRootFromParent_Done,
     /* 220797 */   // Label 4386: @220797
     /* 220797 */   GIM_Try, /*On fail goto*//*Label 4387*/ GIMT_Encode4(220839), // Rule ID 8318 //
     /* 220802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 220810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 220813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 220816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 220819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 220822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220826 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1517:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 220826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 220829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220833 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220835 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220837 */     GIR_RootConstrainSelectedInstOperands,
     /* 220838 */     // GIR_Coverage, 8318,
     /* 220838 */     GIR_EraseRootFromParent_Done,
     /* 220839 */   // Label 4387: @220839
     /* 220839 */   GIM_Try, /*On fail goto*//*Label 4388*/ GIMT_Encode4(220881), // Rule ID 8319 //
     /* 220844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 220852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 220855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 220858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 220861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 220864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220868 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1517:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 220868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 220871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220875 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220877 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220879 */     GIR_RootConstrainSelectedInstOperands,
     /* 220880 */     // GIR_Coverage, 8319,
     /* 220880 */     GIR_EraseRootFromParent_Done,
     /* 220881 */   // Label 4388: @220881
     /* 220881 */   GIM_Try, /*On fail goto*//*Label 4389*/ GIMT_Encode4(220923), // Rule ID 8320 //
     /* 220886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 220894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 220897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 220900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 220903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 220906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 220910 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1517:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 220910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 220913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220915 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220917 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220919 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220921 */     GIR_RootConstrainSelectedInstOperands,
     /* 220922 */     // GIR_Coverage, 8320,
     /* 220922 */     GIR_EraseRootFromParent_Done,
     /* 220923 */   // Label 4389: @220923
     /* 220923 */   GIM_Try, /*On fail goto*//*Label 4390*/ GIMT_Encode4(220965), // Rule ID 8328 //
     /* 220928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 220936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 220939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 220942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 220945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 220948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220952 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1214:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (CLASTB_ZPZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 220952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_B),
     /* 220955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220959 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220961 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220963 */     GIR_RootConstrainSelectedInstOperands,
     /* 220964 */     // GIR_Coverage, 8328,
     /* 220964 */     GIR_EraseRootFromParent_Done,
     /* 220965 */   // Label 4390: @220965
     /* 220965 */   GIM_Try, /*On fail goto*//*Label 4391*/ GIMT_Encode4(221007), // Rule ID 8329 //
     /* 220970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 220978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 220981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 220984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 220987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 220990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220994 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1214:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (CLASTB_ZPZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 220994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_H),
     /* 220997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220999 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221001 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221003 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221005 */     GIR_RootConstrainSelectedInstOperands,
     /* 221006 */     // GIR_Coverage, 8329,
     /* 221006 */     GIR_EraseRootFromParent_Done,
     /* 221007 */   // Label 4391: @221007
     /* 221007 */   GIM_Try, /*On fail goto*//*Label 4392*/ GIMT_Encode4(221049), // Rule ID 8330 //
     /* 221012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 221020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221036 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1214:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (CLASTB_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 221036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_S),
     /* 221039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221043 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221045 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221047 */     GIR_RootConstrainSelectedInstOperands,
     /* 221048 */     // GIR_Coverage, 8330,
     /* 221048 */     GIR_EraseRootFromParent_Done,
     /* 221049 */   // Label 4392: @221049
     /* 221049 */   GIM_Try, /*On fail goto*//*Label 4393*/ GIMT_Encode4(221091), // Rule ID 8331 //
     /* 221054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 221062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 221068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 221071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221078 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1214:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CLASTB_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_D),
     /* 221081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221085 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221087 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221089 */     GIR_RootConstrainSelectedInstOperands,
     /* 221090 */     // GIR_Coverage, 8331,
     /* 221090 */     GIR_EraseRootFromParent_Done,
     /* 221091 */   // Label 4393: @221091
     /* 221091 */   GIM_Try, /*On fail goto*//*Label 4394*/ GIMT_Encode4(221133), // Rule ID 8332 //
     /* 221096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 221104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221120 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1214:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (CLASTB_ZPZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 221120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_H),
     /* 221123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221127 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221129 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221131 */     GIR_RootConstrainSelectedInstOperands,
     /* 221132 */     // GIR_Coverage, 8332,
     /* 221132 */     GIR_EraseRootFromParent_Done,
     /* 221133 */   // Label 4394: @221133
     /* 221133 */   GIM_Try, /*On fail goto*//*Label 4395*/ GIMT_Encode4(221175), // Rule ID 8333 //
     /* 221138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 221146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221162 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1214:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (CLASTB_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 221162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_S),
     /* 221165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221169 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221171 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221173 */     GIR_RootConstrainSelectedInstOperands,
     /* 221174 */     // GIR_Coverage, 8333,
     /* 221174 */     GIR_EraseRootFromParent_Done,
     /* 221175 */   // Label 4395: @221175
     /* 221175 */   GIM_Try, /*On fail goto*//*Label 4396*/ GIMT_Encode4(221217), // Rule ID 8334 //
     /* 221180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 221188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 221194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 221197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221204 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1214:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (CLASTB_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 221204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_D),
     /* 221207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221211 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221213 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221215 */     GIR_RootConstrainSelectedInstOperands,
     /* 221216 */     // GIR_Coverage, 8334,
     /* 221216 */     GIR_EraseRootFromParent_Done,
     /* 221217 */   // Label 4396: @221217
     /* 221217 */   GIM_Try, /*On fail goto*//*Label 4397*/ GIMT_Encode4(221262), // Rule ID 9030 //
     /* 221222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
     /* 221230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 221233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 221236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 221239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221246 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1235:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_B),
     /* 221249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221253 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221255 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221257 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221260 */     GIR_RootConstrainSelectedInstOperands,
     /* 221261 */     // GIR_Coverage, 9030,
     /* 221261 */     GIR_EraseRootFromParent_Done,
     /* 221262 */   // Label 4397: @221262
     /* 221262 */   GIM_Try, /*On fail goto*//*Label 4398*/ GIMT_Encode4(221307), // Rule ID 9031 //
     /* 221267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
     /* 221275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 221278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221291 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1235:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_H),
     /* 221294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221296 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221298 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221300 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221302 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221305 */     GIR_RootConstrainSelectedInstOperands,
     /* 221306 */     // GIR_Coverage, 9031,
     /* 221306 */     GIR_EraseRootFromParent_Done,
     /* 221307 */   // Label 4398: @221307
     /* 221307 */   GIM_Try, /*On fail goto*//*Label 4399*/ GIMT_Encode4(221352), // Rule ID 9032 //
     /* 221312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
     /* 221320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 221323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221336 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1235:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_S),
     /* 221339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221343 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221345 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221347 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221350 */     GIR_RootConstrainSelectedInstOperands,
     /* 221351 */     // GIR_Coverage, 9032,
     /* 221351 */     GIR_EraseRootFromParent_Done,
     /* 221352 */   // Label 4399: @221352
     /* 221352 */   GIM_Try, /*On fail goto*//*Label 4400*/ GIMT_Encode4(221397), // Rule ID 9033 //
     /* 221357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
     /* 221365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 221368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 221371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 221374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221381 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1225:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_B),
     /* 221384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221388 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221390 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221392 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221395 */     GIR_RootConstrainSelectedInstOperands,
     /* 221396 */     // GIR_Coverage, 9033,
     /* 221396 */     GIR_EraseRootFromParent_Done,
     /* 221397 */   // Label 4400: @221397
     /* 221397 */   GIM_Try, /*On fail goto*//*Label 4401*/ GIMT_Encode4(221442), // Rule ID 9034 //
     /* 221402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
     /* 221410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 221413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221426 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1225:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_H),
     /* 221429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221433 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221435 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221437 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221440 */     GIR_RootConstrainSelectedInstOperands,
     /* 221441 */     // GIR_Coverage, 9034,
     /* 221441 */     GIR_EraseRootFromParent_Done,
     /* 221442 */   // Label 4401: @221442
     /* 221442 */   GIM_Try, /*On fail goto*//*Label 4402*/ GIMT_Encode4(221487), // Rule ID 9035 //
     /* 221447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
     /* 221455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 221458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221471 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1225:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_S),
     /* 221474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221480 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221482 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221485 */     GIR_RootConstrainSelectedInstOperands,
     /* 221486 */     // GIR_Coverage, 9035,
     /* 221486 */     GIR_EraseRootFromParent_Done,
     /* 221487 */   // Label 4402: @221487
     /* 221487 */   GIM_Try, /*On fail goto*//*Label 4403*/ GIMT_Encode4(221532), // Rule ID 9036 //
     /* 221492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
     /* 221500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 221503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 221506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 221509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221516 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1233:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_B),
     /* 221519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221525 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221527 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221530 */     GIR_RootConstrainSelectedInstOperands,
     /* 221531 */     // GIR_Coverage, 9036,
     /* 221531 */     GIR_EraseRootFromParent_Done,
     /* 221532 */   // Label 4403: @221532
     /* 221532 */   GIM_Try, /*On fail goto*//*Label 4404*/ GIMT_Encode4(221577), // Rule ID 9037 //
     /* 221537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
     /* 221545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 221548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221561 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1233:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_H),
     /* 221564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221566 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221568 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221570 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221572 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221575 */     GIR_RootConstrainSelectedInstOperands,
     /* 221576 */     // GIR_Coverage, 9037,
     /* 221576 */     GIR_EraseRootFromParent_Done,
     /* 221577 */   // Label 4404: @221577
     /* 221577 */   GIM_Try, /*On fail goto*//*Label 4405*/ GIMT_Encode4(221622), // Rule ID 9038 //
     /* 221582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
     /* 221590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 221593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221606 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1233:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_S),
     /* 221609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221613 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221615 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221617 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221620 */     GIR_RootConstrainSelectedInstOperands,
     /* 221621 */     // GIR_Coverage, 9038,
     /* 221621 */     GIR_EraseRootFromParent_Done,
     /* 221622 */   // Label 4405: @221622
     /* 221622 */   GIM_Try, /*On fail goto*//*Label 4406*/ GIMT_Encode4(221667), // Rule ID 9039 //
     /* 221627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
     /* 221635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 221638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 221641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 221644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221651 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1230:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_B),
     /* 221654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221658 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221660 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221662 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221665 */     GIR_RootConstrainSelectedInstOperands,
     /* 221666 */     // GIR_Coverage, 9039,
     /* 221666 */     GIR_EraseRootFromParent_Done,
     /* 221667 */   // Label 4406: @221667
     /* 221667 */   GIM_Try, /*On fail goto*//*Label 4407*/ GIMT_Encode4(221712), // Rule ID 9040 //
     /* 221672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
     /* 221680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 221683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221696 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1230:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_H),
     /* 221699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221703 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221705 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221707 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221710 */     GIR_RootConstrainSelectedInstOperands,
     /* 221711 */     // GIR_Coverage, 9040,
     /* 221711 */     GIR_EraseRootFromParent_Done,
     /* 221712 */   // Label 4407: @221712
     /* 221712 */   GIM_Try, /*On fail goto*//*Label 4408*/ GIMT_Encode4(221757), // Rule ID 9041 //
     /* 221717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
     /* 221725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 221728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221741 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1230:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_S),
     /* 221744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221746 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221748 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221750 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221752 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221755 */     GIR_RootConstrainSelectedInstOperands,
     /* 221756 */     // GIR_Coverage, 9041,
     /* 221756 */     GIR_EraseRootFromParent_Done,
     /* 221757 */   // Label 4408: @221757
     /* 221757 */   GIM_Try, /*On fail goto*//*Label 4409*/ GIMT_Encode4(221802), // Rule ID 9042 //
     /* 221762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
     /* 221770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 221773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 221776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 221779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221786 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1229:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_B),
     /* 221789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221791 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221793 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221795 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221797 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221800 */     GIR_RootConstrainSelectedInstOperands,
     /* 221801 */     // GIR_Coverage, 9042,
     /* 221801 */     GIR_EraseRootFromParent_Done,
     /* 221802 */   // Label 4409: @221802
     /* 221802 */   GIM_Try, /*On fail goto*//*Label 4410*/ GIMT_Encode4(221847), // Rule ID 9043 //
     /* 221807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
     /* 221815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 221818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221831 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1229:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_H),
     /* 221834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221836 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221838 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221840 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221842 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221845 */     GIR_RootConstrainSelectedInstOperands,
     /* 221846 */     // GIR_Coverage, 9043,
     /* 221846 */     GIR_EraseRootFromParent_Done,
     /* 221847 */   // Label 4410: @221847
     /* 221847 */   GIM_Try, /*On fail goto*//*Label 4411*/ GIMT_Encode4(221892), // Rule ID 9044 //
     /* 221852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
     /* 221860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 221863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221876 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1229:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_S),
     /* 221879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221883 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221885 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221887 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221890 */     GIR_RootConstrainSelectedInstOperands,
     /* 221891 */     // GIR_Coverage, 9044,
     /* 221891 */     GIR_EraseRootFromParent_Done,
     /* 221892 */   // Label 4411: @221892
     /* 221892 */   GIM_Try, /*On fail goto*//*Label 4412*/ GIMT_Encode4(221937), // Rule ID 9045 //
     /* 221897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
     /* 221905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 221908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 221911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 221914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221921 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1227:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_B),
     /* 221924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221928 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221930 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221932 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221935 */     GIR_RootConstrainSelectedInstOperands,
     /* 221936 */     // GIR_Coverage, 9045,
     /* 221936 */     GIR_EraseRootFromParent_Done,
     /* 221937 */   // Label 4412: @221937
     /* 221937 */   GIM_Try, /*On fail goto*//*Label 4413*/ GIMT_Encode4(221982), // Rule ID 9046 //
     /* 221942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
     /* 221950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 221953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221966 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1227:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_H),
     /* 221969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221973 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221975 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221977 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221980 */     GIR_RootConstrainSelectedInstOperands,
     /* 221981 */     // GIR_Coverage, 9046,
     /* 221981 */     GIR_EraseRootFromParent_Done,
     /* 221982 */   // Label 4413: @221982
     /* 221982 */   GIM_Try, /*On fail goto*//*Label 4414*/ GIMT_Encode4(222027), // Rule ID 9047 //
     /* 221987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
     /* 221995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 221998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222011 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1227:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_S),
     /* 222014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222016 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222018 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222020 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222022 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 222025 */     GIR_RootConstrainSelectedInstOperands,
     /* 222026 */     // GIR_Coverage, 9047,
     /* 222026 */     GIR_EraseRootFromParent_Done,
     /* 222027 */   // Label 4414: @222027
     /* 222027 */   GIM_Try, /*On fail goto*//*Label 4415*/ GIMT_Encode4(222072), // Rule ID 9048 //
     /* 222032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
     /* 222040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 222043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 222046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 222049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222056 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1231:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_B),
     /* 222059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222063 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222065 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222067 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 222070 */     GIR_RootConstrainSelectedInstOperands,
     /* 222071 */     // GIR_Coverage, 9048,
     /* 222071 */     GIR_EraseRootFromParent_Done,
     /* 222072 */   // Label 4415: @222072
     /* 222072 */   GIM_Try, /*On fail goto*//*Label 4416*/ GIMT_Encode4(222117), // Rule ID 9049 //
     /* 222077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
     /* 222085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 222088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222101 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1231:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_H),
     /* 222104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222110 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222112 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 222115 */     GIR_RootConstrainSelectedInstOperands,
     /* 222116 */     // GIR_Coverage, 9049,
     /* 222116 */     GIR_EraseRootFromParent_Done,
     /* 222117 */   // Label 4416: @222117
     /* 222117 */   GIM_Try, /*On fail goto*//*Label 4417*/ GIMT_Encode4(222162), // Rule ID 9050 //
     /* 222122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
     /* 222130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 222133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222146 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1231:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_S),
     /* 222149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222153 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222155 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222157 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 222160 */     GIR_RootConstrainSelectedInstOperands,
     /* 222161 */     // GIR_Coverage, 9050,
     /* 222161 */     GIR_EraseRootFromParent_Done,
     /* 222162 */   // Label 4417: @222162
     /* 222162 */   GIM_Try, /*On fail goto*//*Label 4418*/ GIMT_Encode4(222207), // Rule ID 9051 //
     /* 222167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
     /* 222175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 222178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 222181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 222184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222191 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1232:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_B),
     /* 222194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222198 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222200 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222202 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 222205 */     GIR_RootConstrainSelectedInstOperands,
     /* 222206 */     // GIR_Coverage, 9051,
     /* 222206 */     GIR_EraseRootFromParent_Done,
     /* 222207 */   // Label 4418: @222207
     /* 222207 */   GIM_Try, /*On fail goto*//*Label 4419*/ GIMT_Encode4(222252), // Rule ID 9052 //
     /* 222212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
     /* 222220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 222223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222236 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1232:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_H),
     /* 222239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222243 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222245 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222247 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 222250 */     GIR_RootConstrainSelectedInstOperands,
     /* 222251 */     // GIR_Coverage, 9052,
     /* 222251 */     GIR_EraseRootFromParent_Done,
     /* 222252 */   // Label 4419: @222252
     /* 222252 */   GIM_Try, /*On fail goto*//*Label 4420*/ GIMT_Encode4(222297), // Rule ID 9053 //
     /* 222257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
     /* 222265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 222268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222281 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1232:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_S),
     /* 222284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222288 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222290 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222292 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 222295 */     GIR_RootConstrainSelectedInstOperands,
     /* 222296 */     // GIR_Coverage, 9053,
     /* 222296 */     GIR_EraseRootFromParent_Done,
     /* 222297 */   // Label 4420: @222297
     /* 222297 */   GIM_Try, /*On fail goto*//*Label 4421*/ GIMT_Encode4(222339), // Rule ID 9450 //
     /* 222302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
     /* 222310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 222313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222326 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1268:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FACGT_PPzZZ_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 222326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_H),
     /* 222329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222333 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222335 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222337 */     GIR_RootConstrainSelectedInstOperands,
     /* 222338 */     // GIR_Coverage, 9450,
     /* 222338 */     GIR_EraseRootFromParent_Done,
     /* 222339 */   // Label 4421: @222339
     /* 222339 */   GIM_Try, /*On fail goto*//*Label 4422*/ GIMT_Encode4(222381), // Rule ID 9451 //
     /* 222344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
     /* 222352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 222355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222368 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1268:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FACGT_PPzZZ_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 222368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_S),
     /* 222371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222375 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222377 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222379 */     GIR_RootConstrainSelectedInstOperands,
     /* 222380 */     // GIR_Coverage, 9451,
     /* 222380 */     GIR_EraseRootFromParent_Done,
     /* 222381 */   // Label 4422: @222381
     /* 222381 */   GIM_Try, /*On fail goto*//*Label 4423*/ GIMT_Encode4(222423), // Rule ID 9452 //
     /* 222386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
     /* 222394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 222397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222410 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1268:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FACGT_PPzZZ_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 222410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_D),
     /* 222413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222417 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222419 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222421 */     GIR_RootConstrainSelectedInstOperands,
     /* 222422 */     // GIR_Coverage, 9452,
     /* 222422 */     GIR_EraseRootFromParent_Done,
     /* 222423 */   // Label 4423: @222423
     /* 222423 */   GIM_Try, /*On fail goto*//*Label 4424*/ GIMT_Encode4(222465), // Rule ID 9990 //
     /* 222428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 222436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 222439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 222442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 222445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 222448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222452 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1499:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (LSR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 222452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_B),
     /* 222455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222461 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222463 */     GIR_RootConstrainSelectedInstOperands,
     /* 222464 */     // GIR_Coverage, 9990,
     /* 222464 */     GIR_EraseRootFromParent_Done,
     /* 222465 */   // Label 4424: @222465
     /* 222465 */   GIM_Try, /*On fail goto*//*Label 4425*/ GIMT_Encode4(222507), // Rule ID 9991 //
     /* 222470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 222478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222494 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1499:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (LSR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 222494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_H),
     /* 222497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222501 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222503 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222505 */     GIR_RootConstrainSelectedInstOperands,
     /* 222506 */     // GIR_Coverage, 9991,
     /* 222506 */     GIR_EraseRootFromParent_Done,
     /* 222507 */   // Label 4425: @222507
     /* 222507 */   GIM_Try, /*On fail goto*//*Label 4426*/ GIMT_Encode4(222549), // Rule ID 9992 //
     /* 222512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 222520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222536 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1499:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (LSR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 222536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_S),
     /* 222539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222545 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222547 */     GIR_RootConstrainSelectedInstOperands,
     /* 222548 */     // GIR_Coverage, 9992,
     /* 222548 */     GIR_EraseRootFromParent_Done,
     /* 222549 */   // Label 4426: @222549
     /* 222549 */   GIM_Try, /*On fail goto*//*Label 4427*/ GIMT_Encode4(222591), // Rule ID 9993 //
     /* 222554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 222562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222578 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1499:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_D),
     /* 222581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222585 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222587 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222589 */     GIR_RootConstrainSelectedInstOperands,
     /* 222590 */     // GIR_Coverage, 9993,
     /* 222590 */     GIR_EraseRootFromParent_Done,
     /* 222591 */   // Label 4427: @222591
     /* 222591 */   GIM_Try, /*On fail goto*//*Label 4428*/ GIMT_Encode4(222633), // Rule ID 9994 //
     /* 222596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 222604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 222607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 222610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 222613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 222616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222620 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1496:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (LSL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 222620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_B),
     /* 222623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222627 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222629 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222631 */     GIR_RootConstrainSelectedInstOperands,
     /* 222632 */     // GIR_Coverage, 9994,
     /* 222632 */     GIR_EraseRootFromParent_Done,
     /* 222633 */   // Label 4428: @222633
     /* 222633 */   GIM_Try, /*On fail goto*//*Label 4429*/ GIMT_Encode4(222675), // Rule ID 9995 //
     /* 222638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 222646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222662 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1496:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (LSL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 222662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_H),
     /* 222665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222669 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222671 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222673 */     GIR_RootConstrainSelectedInstOperands,
     /* 222674 */     // GIR_Coverage, 9995,
     /* 222674 */     GIR_EraseRootFromParent_Done,
     /* 222675 */   // Label 4429: @222675
     /* 222675 */   GIM_Try, /*On fail goto*//*Label 4430*/ GIMT_Encode4(222717), // Rule ID 9996 //
     /* 222680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 222688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222704 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1496:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (LSL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 222704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_S),
     /* 222707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222711 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222713 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222715 */     GIR_RootConstrainSelectedInstOperands,
     /* 222716 */     // GIR_Coverage, 9996,
     /* 222716 */     GIR_EraseRootFromParent_Done,
     /* 222717 */   // Label 4430: @222717
     /* 222717 */   GIM_Try, /*On fail goto*//*Label 4431*/ GIMT_Encode4(222759), // Rule ID 9997 //
     /* 222722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 222730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222746 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1496:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_D),
     /* 222749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222753 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222755 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222757 */     GIR_RootConstrainSelectedInstOperands,
     /* 222758 */     // GIR_Coverage, 9997,
     /* 222758 */     GIR_EraseRootFromParent_Done,
     /* 222759 */   // Label 4431: @222759
     /* 222759 */   GIM_Try, /*On fail goto*//*Label 4432*/ GIMT_Encode4(222801), // Rule ID 10010 //
     /* 222764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
     /* 222772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 222775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 222778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 222781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222788 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1501:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_B),
     /* 222791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222795 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222797 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222799 */     GIR_RootConstrainSelectedInstOperands,
     /* 222800 */     // GIR_Coverage, 10010,
     /* 222800 */     GIR_EraseRootFromParent_Done,
     /* 222801 */   // Label 4432: @222801
     /* 222801 */   GIM_Try, /*On fail goto*//*Label 4433*/ GIMT_Encode4(222843), // Rule ID 10011 //
     /* 222806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
     /* 222814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222830 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1501:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_H),
     /* 222833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222837 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222839 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222841 */     GIR_RootConstrainSelectedInstOperands,
     /* 222842 */     // GIR_Coverage, 10011,
     /* 222842 */     GIR_EraseRootFromParent_Done,
     /* 222843 */   // Label 4433: @222843
     /* 222843 */   GIM_Try, /*On fail goto*//*Label 4434*/ GIMT_Encode4(222885), // Rule ID 10012 //
     /* 222848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
     /* 222856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222872 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1501:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_S),
     /* 222875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222879 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222881 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222883 */     GIR_RootConstrainSelectedInstOperands,
     /* 222884 */     // GIR_Coverage, 10012,
     /* 222884 */     GIR_EraseRootFromParent_Done,
     /* 222885 */   // Label 4434: @222885
     /* 222885 */   GIM_Try, /*On fail goto*//*Label 4435*/ GIMT_Encode4(222927), // Rule ID 10013 //
     /* 222890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
     /* 222898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 222901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 222904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 222907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222914 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1498:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_B),
     /* 222917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222921 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222923 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222925 */     GIR_RootConstrainSelectedInstOperands,
     /* 222926 */     // GIR_Coverage, 10013,
     /* 222926 */     GIR_EraseRootFromParent_Done,
     /* 222927 */   // Label 4435: @222927
     /* 222927 */   GIM_Try, /*On fail goto*//*Label 4436*/ GIMT_Encode4(222969), // Rule ID 10014 //
     /* 222932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
     /* 222940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222956 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1498:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_H),
     /* 222959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222963 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222965 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222967 */     GIR_RootConstrainSelectedInstOperands,
     /* 222968 */     // GIR_Coverage, 10014,
     /* 222968 */     GIR_EraseRootFromParent_Done,
     /* 222969 */   // Label 4436: @222969
     /* 222969 */   GIM_Try, /*On fail goto*//*Label 4437*/ GIMT_Encode4(223011), // Rule ID 10015 //
     /* 222974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
     /* 222982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222998 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1498:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_S),
     /* 223001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223005 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223007 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223009 */     GIR_RootConstrainSelectedInstOperands,
     /* 223010 */     // GIR_Coverage, 10015,
     /* 223010 */     GIR_EraseRootFromParent_Done,
     /* 223011 */   // Label 4437: @223011
     /* 223011 */   GIM_Try, /*On fail goto*//*Label 4438*/ GIMT_Encode4(223053), // Rule ID 10042 //
     /* 223016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f16f64),
     /* 223024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 223030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 223033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223040 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1293:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVT_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 223040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_DtoH),
     /* 223043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223047 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223049 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223051 */     GIR_RootConstrainSelectedInstOperands,
     /* 223052 */     // GIR_Coverage, 10042,
     /* 223052 */     GIR_EraseRootFromParent_Done,
     /* 223053 */   // Label 4438: @223053
     /* 223053 */   GIM_Try, /*On fail goto*//*Label 4439*/ GIMT_Encode4(223095), // Rule ID 10046 //
     /* 223058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f64f16),
     /* 223066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 223072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 223075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223082 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1296:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVT_ZPmZ_HtoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 223082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_HtoD),
     /* 223085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223089 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223091 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223093 */     GIR_RootConstrainSelectedInstOperands,
     /* 223094 */     // GIR_Coverage, 10046,
     /* 223094 */     GIR_EraseRootFromParent_Done,
     /* 223095 */   // Label 4439: @223095
     /* 223095 */   GIM_Try, /*On fail goto*//*Label 4440*/ GIMT_Encode4(223137), // Rule ID 10050 //
     /* 223100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f32f64),
     /* 223108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 223114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 223117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223124 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1295:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 223124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_DtoS),
     /* 223127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223131 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223133 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223135 */     GIR_RootConstrainSelectedInstOperands,
     /* 223136 */     // GIR_Coverage, 10050,
     /* 223136 */     GIR_EraseRootFromParent_Done,
     /* 223137 */   // Label 4440: @223137
     /* 223137 */   GIM_Try, /*On fail goto*//*Label 4441*/ GIMT_Encode4(223179), // Rule ID 10054 //
     /* 223142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f64f32),
     /* 223150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 223156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 223159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223166 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1297:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVT_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 223166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_StoD),
     /* 223169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223173 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223175 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223177 */     GIR_RootConstrainSelectedInstOperands,
     /* 223178 */     // GIR_Coverage, 10054,
     /* 223178 */     GIR_EraseRootFromParent_Done,
     /* 223179 */   // Label 4441: @223179
     /* 223179 */   GIM_Try, /*On fail goto*//*Label 4442*/ GIMT_Encode4(223221), // Rule ID 10058 //
     /* 223184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f64i32),
     /* 223192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 223198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 223201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223208 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1609:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCVTF_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 223208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_StoD),
     /* 223211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223215 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223217 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223219 */     GIR_RootConstrainSelectedInstOperands,
     /* 223220 */     // GIR_Coverage, 10058,
     /* 223220 */     GIR_EraseRootFromParent_Done,
     /* 223221 */   // Label 4442: @223221
     /* 223221 */   GIM_Try, /*On fail goto*//*Label 4443*/ GIMT_Encode4(223263), // Rule ID 10059 //
     /* 223226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f64i32),
     /* 223234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 223240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 223243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223250 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1856:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCVTF_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 223250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_StoD),
     /* 223253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223257 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223259 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223261 */     GIR_RootConstrainSelectedInstOperands,
     /* 223262 */     // GIR_Coverage, 10059,
     /* 223262 */     GIR_EraseRootFromParent_Done,
     /* 223263 */   // Label 4443: @223263
     /* 223263 */   GIM_Try, /*On fail goto*//*Label 4444*/ GIMT_Encode4(223305), // Rule ID 10060 //
     /* 223268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f16i32),
     /* 223276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 223282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 223285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223292 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1853:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCVTF_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 223292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_StoH),
     /* 223295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223299 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223301 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223303 */     GIR_RootConstrainSelectedInstOperands,
     /* 223304 */     // GIR_Coverage, 10060,
     /* 223304 */     GIR_EraseRootFromParent_Done,
     /* 223305 */   // Label 4444: @223305
     /* 223305 */   GIM_Try, /*On fail goto*//*Label 4445*/ GIMT_Encode4(223347), // Rule ID 10064 //
     /* 223310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f32i64),
     /* 223318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 223324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 223327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223334 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1608:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCVTF_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_DtoS),
     /* 223337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223339 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223341 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223343 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223345 */     GIR_RootConstrainSelectedInstOperands,
     /* 223346 */     // GIR_Coverage, 10064,
     /* 223346 */     GIR_EraseRootFromParent_Done,
     /* 223347 */   // Label 4445: @223347
     /* 223347 */   GIM_Try, /*On fail goto*//*Label 4446*/ GIMT_Encode4(223389), // Rule ID 10068 //
     /* 223352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f16i32),
     /* 223360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 223366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 223369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223376 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1606:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCVTF_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 223376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_StoH),
     /* 223379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223383 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223385 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223387 */     GIR_RootConstrainSelectedInstOperands,
     /* 223388 */     // GIR_Coverage, 10068,
     /* 223388 */     GIR_EraseRootFromParent_Done,
     /* 223389 */   // Label 4446: @223389
     /* 223389 */   GIM_Try, /*On fail goto*//*Label 4447*/ GIMT_Encode4(223431), // Rule ID 10072 //
     /* 223394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f16i64),
     /* 223402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 223408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 223411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223418 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1607:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCVTF_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_DtoH),
     /* 223421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223425 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223427 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223429 */     GIR_RootConstrainSelectedInstOperands,
     /* 223430 */     // GIR_Coverage, 10072,
     /* 223430 */     GIR_EraseRootFromParent_Done,
     /* 223431 */   // Label 4447: @223431
     /* 223431 */   GIM_Try, /*On fail goto*//*Label 4448*/ GIMT_Encode4(223473), // Rule ID 10076 //
     /* 223436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f32i64),
     /* 223444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 223450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 223453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223460 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1855:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCVTF_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_DtoS),
     /* 223463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223467 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223469 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223471 */     GIR_RootConstrainSelectedInstOperands,
     /* 223472 */     // GIR_Coverage, 10076,
     /* 223472 */     GIR_EraseRootFromParent_Done,
     /* 223473 */   // Label 4448: @223473
     /* 223473 */   GIM_Try, /*On fail goto*//*Label 4449*/ GIMT_Encode4(223515), // Rule ID 10080 //
     /* 223478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f16i64),
     /* 223486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 223492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 223495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223502 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1854:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCVTF_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_DtoH),
     /* 223505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223509 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223511 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223513 */     GIR_RootConstrainSelectedInstOperands,
     /* 223514 */     // GIR_Coverage, 10080,
     /* 223514 */     GIR_EraseRootFromParent_Done,
     /* 223515 */   // Label 4449: @223515
     /* 223515 */   GIM_Try, /*On fail goto*//*Label 4450*/ GIMT_Encode4(223557), // Rule ID 10090 //
     /* 223520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i32f64),
     /* 223528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 223534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 223537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223544 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1311:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTZS_ZPmZ_DtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 223544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_DtoS),
     /* 223547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223551 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223553 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223555 */     GIR_RootConstrainSelectedInstOperands,
     /* 223556 */     // GIR_Coverage, 10090,
     /* 223556 */     GIR_EraseRootFromParent_Done,
     /* 223557 */   // Label 4450: @223557
     /* 223557 */   GIM_Try, /*On fail goto*//*Label 4451*/ GIMT_Encode4(223599), // Rule ID 10091 //
     /* 223562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i32f64),
     /* 223570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 223576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 223579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223586 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1318:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTZU_ZPmZ_DtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 223586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_DtoS),
     /* 223589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223593 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223595 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223597 */     GIR_RootConstrainSelectedInstOperands,
     /* 223598 */     // GIR_Coverage, 10091,
     /* 223598 */     GIR_EraseRootFromParent_Done,
     /* 223599 */   // Label 4451: @223599
     /* 223599 */   GIM_Try, /*On fail goto*//*Label 4452*/ GIMT_Encode4(223641), // Rule ID 10092 //
     /* 223604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i64f32),
     /* 223612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 223618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 223621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223628 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1313:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTZS_ZPmZ_StoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 223628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_StoD),
     /* 223631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223635 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223637 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223639 */     GIR_RootConstrainSelectedInstOperands,
     /* 223640 */     // GIR_Coverage, 10092,
     /* 223640 */     GIR_EraseRootFromParent_Done,
     /* 223641 */   // Label 4452: @223641
     /* 223641 */   GIM_Try, /*On fail goto*//*Label 4453*/ GIMT_Encode4(223683), // Rule ID 10096 //
     /* 223646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i32f16),
     /* 223654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 223660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 223663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223670 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1310:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZS_ZPmZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 223670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_HtoS),
     /* 223673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223677 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223679 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223681 */     GIR_RootConstrainSelectedInstOperands,
     /* 223682 */     // GIR_Coverage, 10096,
     /* 223682 */     GIR_EraseRootFromParent_Done,
     /* 223683 */   // Label 4453: @223683
     /* 223683 */   GIM_Try, /*On fail goto*//*Label 4454*/ GIMT_Encode4(223725), // Rule ID 10100 //
     /* 223688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i64f16),
     /* 223696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 223702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 223705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223712 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1312:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZS_ZPmZ_HtoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 223712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_HtoD),
     /* 223715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223719 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223721 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223723 */     GIR_RootConstrainSelectedInstOperands,
     /* 223724 */     // GIR_Coverage, 10100,
     /* 223724 */     GIR_EraseRootFromParent_Done,
     /* 223725 */   // Label 4454: @223725
     /* 223725 */   GIM_Try, /*On fail goto*//*Label 4455*/ GIMT_Encode4(223767), // Rule ID 10104 //
     /* 223730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i32f16),
     /* 223738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 223744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 223747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223754 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1317:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZU_ZPmZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 223754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_HtoS),
     /* 223757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223759 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223761 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223763 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223765 */     GIR_RootConstrainSelectedInstOperands,
     /* 223766 */     // GIR_Coverage, 10104,
     /* 223766 */     GIR_EraseRootFromParent_Done,
     /* 223767 */   // Label 4455: @223767
     /* 223767 */   GIM_Try, /*On fail goto*//*Label 4456*/ GIMT_Encode4(223809), // Rule ID 10108 //
     /* 223772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i64f16),
     /* 223780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 223786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 223789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223796 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1319:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZU_ZPmZ_HtoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 223796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_HtoD),
     /* 223799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223803 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223805 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223807 */     GIR_RootConstrainSelectedInstOperands,
     /* 223808 */     // GIR_Coverage, 10108,
     /* 223808 */     GIR_EraseRootFromParent_Done,
     /* 223809 */   // Label 4456: @223809
     /* 223809 */   GIM_Try, /*On fail goto*//*Label 4457*/ GIMT_Encode4(223851), // Rule ID 10112 //
     /* 223814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i64f32),
     /* 223822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 223828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 223831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223838 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1320:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTZU_ZPmZ_StoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 223838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_StoD),
     /* 223841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223845 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223847 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223849 */     GIR_RootConstrainSelectedInstOperands,
     /* 223850 */     // GIR_Coverage, 10112,
     /* 223850 */     GIR_EraseRootFromParent_Done,
     /* 223851 */   // Label 4457: @223851
     /* 223851 */   GIM_Try, /*On fail goto*//*Label 4458*/ GIMT_Encode4(223893), // Rule ID 11061 //
     /* 223856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
     /* 223859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ummla),
     /* 223864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 223870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 223873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 223876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223880 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1895:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 223880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMMLA_ZZZ),
     /* 223883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 223885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223887 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223889 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223891 */     GIR_RootConstrainSelectedInstOperands,
     /* 223892 */     // GIR_Coverage, 11061,
     /* 223892 */     GIR_EraseRootFromParent_Done,
     /* 223893 */   // Label 4458: @223893
     /* 223893 */   GIM_Try, /*On fail goto*//*Label 4459*/ GIMT_Encode4(223935), // Rule ID 11062 //
     /* 223898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
     /* 223901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usmmla),
     /* 223906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 223912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 223915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 223918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223922 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1966:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (USMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 223922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMMLA_ZZZ),
     /* 223925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 223927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223929 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223931 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223933 */     GIR_RootConstrainSelectedInstOperands,
     /* 223934 */     // GIR_Coverage, 11062,
     /* 223934 */     GIR_EraseRootFromParent_Done,
     /* 223935 */   // Label 4459: @223935
     /* 223935 */   GIM_Try, /*On fail goto*//*Label 4460*/ GIMT_Encode4(223977), // Rule ID 11064 //
     /* 223940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP32_HasSVE),
     /* 223943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmmla),
     /* 223948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 223954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223964 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1381:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMMLA_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 223964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMMLA_ZZZ_S),
     /* 223967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 223969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223971 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223973 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223975 */     GIR_RootConstrainSelectedInstOperands,
     /* 223976 */     // GIR_Coverage, 11064,
     /* 223976 */     GIR_EraseRootFromParent_Done,
     /* 223977 */   // Label 4460: @223977
     /* 223977 */   GIM_Try, /*On fail goto*//*Label 4461*/ GIMT_Encode4(224019), // Rule ID 11065 //
     /* 223982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE),
     /* 223985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmmla),
     /* 223990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 223996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224006 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1381:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMMLA_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 224006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMMLA_ZZZ_D),
     /* 224009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224013 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224015 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224017 */     GIR_RootConstrainSelectedInstOperands,
     /* 224018 */     // GIR_Coverage, 11065,
     /* 224018 */     GIR_EraseRootFromParent_Done,
     /* 224019 */   // Label 4461: @224019
     /* 224019 */   GIM_Try, /*On fail goto*//*Label 4462*/ GIMT_Encode4(224061), // Rule ID 11119 //
     /* 224024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 224032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 224035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 224038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 224041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 224044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224048 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1730:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRDMLSH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 224048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_B),
     /* 224051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224055 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224057 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224059 */     GIR_RootConstrainSelectedInstOperands,
     /* 224060 */     // GIR_Coverage, 11119,
     /* 224060 */     GIR_EraseRootFromParent_Done,
     /* 224061 */   // Label 4462: @224061
     /* 224061 */   GIM_Try, /*On fail goto*//*Label 4463*/ GIMT_Encode4(224103), // Rule ID 11120 //
     /* 224066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 224074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 224080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224090 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1730:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRDMLSH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 224090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_H),
     /* 224093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224097 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224099 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224101 */     GIR_RootConstrainSelectedInstOperands,
     /* 224102 */     // GIR_Coverage, 11120,
     /* 224102 */     GIR_EraseRootFromParent_Done,
     /* 224103 */   // Label 4463: @224103
     /* 224103 */   GIM_Try, /*On fail goto*//*Label 4464*/ GIMT_Encode4(224145), // Rule ID 11121 //
     /* 224108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 224116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 224122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224132 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1730:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRDMLSH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 224132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_S),
     /* 224135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224139 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224141 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224143 */     GIR_RootConstrainSelectedInstOperands,
     /* 224144 */     // GIR_Coverage, 11121,
     /* 224144 */     GIR_EraseRootFromParent_Done,
     /* 224145 */   // Label 4464: @224145
     /* 224145 */   GIM_Try, /*On fail goto*//*Label 4465*/ GIMT_Encode4(224187), // Rule ID 11122 //
     /* 224150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 224158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 224164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224174 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1730:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRDMLSH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 224174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_D),
     /* 224177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224181 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224183 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224185 */     GIR_RootConstrainSelectedInstOperands,
     /* 224186 */     // GIR_Coverage, 11122,
     /* 224186 */     GIR_EraseRootFromParent_Done,
     /* 224187 */   // Label 4465: @224187
     /* 224187 */   GIM_Try, /*On fail goto*//*Label 4466*/ GIMT_Encode4(224229), // Rule ID 11175 //
     /* 224192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
     /* 224200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 224206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 224209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 224212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224216 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1651:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 224216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_H),
     /* 224219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224223 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224225 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224227 */     GIR_RootConstrainSelectedInstOperands,
     /* 224228 */     // GIR_Coverage, 11175,
     /* 224228 */     GIR_EraseRootFromParent_Done,
     /* 224229 */   // Label 4466: @224229
     /* 224229 */   GIM_Try, /*On fail goto*//*Label 4467*/ GIMT_Encode4(224271), // Rule ID 11176 //
     /* 224234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
     /* 224242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 224248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224258 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1651:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 224258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_S),
     /* 224261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224263 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224265 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224267 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224269 */     GIR_RootConstrainSelectedInstOperands,
     /* 224270 */     // GIR_Coverage, 11176,
     /* 224270 */     GIR_EraseRootFromParent_Done,
     /* 224271 */   // Label 4467: @224271
     /* 224271 */   GIM_Try, /*On fail goto*//*Label 4468*/ GIMT_Encode4(224313), // Rule ID 11177 //
     /* 224276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
     /* 224284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 224290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224300 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1651:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 224300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_D),
     /* 224303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224307 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224309 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224311 */     GIR_RootConstrainSelectedInstOperands,
     /* 224312 */     // GIR_Coverage, 11177,
     /* 224312 */     GIR_EraseRootFromParent_Done,
     /* 224313 */   // Label 4468: @224313
     /* 224313 */   GIM_Try, /*On fail goto*//*Label 4469*/ GIMT_Encode4(224355), // Rule ID 11178 //
     /* 224318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
     /* 224326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 224332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 224335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 224338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224342 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1887:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 224342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_H),
     /* 224345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224349 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224351 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224353 */     GIR_RootConstrainSelectedInstOperands,
     /* 224354 */     // GIR_Coverage, 11178,
     /* 224354 */     GIR_EraseRootFromParent_Done,
     /* 224355 */   // Label 4469: @224355
     /* 224355 */   GIM_Try, /*On fail goto*//*Label 4470*/ GIMT_Encode4(224397), // Rule ID 11179 //
     /* 224360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
     /* 224368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 224374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224384 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1887:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 224384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_S),
     /* 224387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224391 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224393 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224395 */     GIR_RootConstrainSelectedInstOperands,
     /* 224396 */     // GIR_Coverage, 11179,
     /* 224396 */     GIR_EraseRootFromParent_Done,
     /* 224397 */   // Label 4470: @224397
     /* 224397 */   GIM_Try, /*On fail goto*//*Label 4471*/ GIMT_Encode4(224439), // Rule ID 11180 //
     /* 224402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
     /* 224410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 224416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224426 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1887:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 224426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_D),
     /* 224429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224433 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224435 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224437 */     GIR_RootConstrainSelectedInstOperands,
     /* 224438 */     // GIR_Coverage, 11180,
     /* 224438 */     GIR_EraseRootFromParent_Done,
     /* 224439 */   // Label 4471: @224439
     /* 224439 */   GIM_Try, /*On fail goto*//*Label 4472*/ GIMT_Encode4(224481), // Rule ID 11181 //
     /* 224444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
     /* 224452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 224458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 224461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 224464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224468 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1889:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 224468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_H),
     /* 224471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224475 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224477 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224479 */     GIR_RootConstrainSelectedInstOperands,
     /* 224480 */     // GIR_Coverage, 11181,
     /* 224480 */     GIR_EraseRootFromParent_Done,
     /* 224481 */   // Label 4472: @224481
     /* 224481 */   GIM_Try, /*On fail goto*//*Label 4473*/ GIMT_Encode4(224523), // Rule ID 11182 //
     /* 224486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
     /* 224494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 224500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224510 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1889:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 224510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_S),
     /* 224513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224515 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224517 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224519 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224521 */     GIR_RootConstrainSelectedInstOperands,
     /* 224522 */     // GIR_Coverage, 11182,
     /* 224522 */     GIR_EraseRootFromParent_Done,
     /* 224523 */   // Label 4473: @224523
     /* 224523 */   GIM_Try, /*On fail goto*//*Label 4474*/ GIMT_Encode4(224565), // Rule ID 11183 //
     /* 224528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
     /* 224536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 224542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224552 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1889:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 224552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_D),
     /* 224555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224559 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224561 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224563 */     GIR_RootConstrainSelectedInstOperands,
     /* 224564 */     // GIR_Coverage, 11183,
     /* 224564 */     GIR_EraseRootFromParent_Done,
     /* 224565 */   // Label 4474: @224565
     /* 224565 */   GIM_Try, /*On fail goto*//*Label 4475*/ GIMT_Encode4(224607), // Rule ID 11184 //
     /* 224570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
     /* 224578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 224584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 224587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 224590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224594 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1653:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 224594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_H),
     /* 224597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224601 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224603 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224605 */     GIR_RootConstrainSelectedInstOperands,
     /* 224606 */     // GIR_Coverage, 11184,
     /* 224606 */     GIR_EraseRootFromParent_Done,
     /* 224607 */   // Label 4475: @224607
     /* 224607 */   GIM_Try, /*On fail goto*//*Label 4476*/ GIMT_Encode4(224649), // Rule ID 11185 //
     /* 224612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
     /* 224620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 224626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224636 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1653:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 224636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_S),
     /* 224639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224643 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224645 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224647 */     GIR_RootConstrainSelectedInstOperands,
     /* 224648 */     // GIR_Coverage, 11185,
     /* 224648 */     GIR_EraseRootFromParent_Done,
     /* 224649 */   // Label 4476: @224649
     /* 224649 */   GIM_Try, /*On fail goto*//*Label 4477*/ GIMT_Encode4(224691), // Rule ID 11186 //
     /* 224654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
     /* 224662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 224668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224678 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1653:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 224678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_D),
     /* 224681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224685 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224687 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224689 */     GIR_RootConstrainSelectedInstOperands,
     /* 224690 */     // GIR_Coverage, 11186,
     /* 224690 */     GIR_EraseRootFromParent_Done,
     /* 224691 */   // Label 4477: @224691
     /* 224691 */   GIM_Try, /*On fail goto*//*Label 4478*/ GIMT_Encode4(224733), // Rule ID 11187 //
     /* 224696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
     /* 224704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 224710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 224713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 224716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224720 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1655:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 224720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_H),
     /* 224723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224727 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224729 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224731 */     GIR_RootConstrainSelectedInstOperands,
     /* 224732 */     // GIR_Coverage, 11187,
     /* 224732 */     GIR_EraseRootFromParent_Done,
     /* 224733 */   // Label 4478: @224733
     /* 224733 */   GIM_Try, /*On fail goto*//*Label 4479*/ GIMT_Encode4(224775), // Rule ID 11188 //
     /* 224738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
     /* 224746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 224752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224762 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1655:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 224762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_S),
     /* 224765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224769 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224771 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224773 */     GIR_RootConstrainSelectedInstOperands,
     /* 224774 */     // GIR_Coverage, 11188,
     /* 224774 */     GIR_EraseRootFromParent_Done,
     /* 224775 */   // Label 4479: @224775
     /* 224775 */   GIM_Try, /*On fail goto*//*Label 4480*/ GIMT_Encode4(224817), // Rule ID 11189 //
     /* 224780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
     /* 224788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 224794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224804 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1655:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 224804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_D),
     /* 224807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224811 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224813 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224815 */     GIR_RootConstrainSelectedInstOperands,
     /* 224816 */     // GIR_Coverage, 11189,
     /* 224816 */     GIR_EraseRootFromParent_Done,
     /* 224817 */   // Label 4480: @224817
     /* 224817 */   GIM_Try, /*On fail goto*//*Label 4481*/ GIMT_Encode4(224859), // Rule ID 11190 //
     /* 224822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
     /* 224830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 224836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 224839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 224842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224846 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1891:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 224846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_H),
     /* 224849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224853 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224855 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224857 */     GIR_RootConstrainSelectedInstOperands,
     /* 224858 */     // GIR_Coverage, 11190,
     /* 224858 */     GIR_EraseRootFromParent_Done,
     /* 224859 */   // Label 4481: @224859
     /* 224859 */   GIM_Try, /*On fail goto*//*Label 4482*/ GIMT_Encode4(224901), // Rule ID 11191 //
     /* 224864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
     /* 224872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 224878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224888 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1891:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 224888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_S),
     /* 224891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224895 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224897 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224899 */     GIR_RootConstrainSelectedInstOperands,
     /* 224900 */     // GIR_Coverage, 11191,
     /* 224900 */     GIR_EraseRootFromParent_Done,
     /* 224901 */   // Label 4482: @224901
     /* 224901 */   GIM_Try, /*On fail goto*//*Label 4483*/ GIMT_Encode4(224943), // Rule ID 11192 //
     /* 224906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
     /* 224914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 224920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224930 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1891:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 224930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_D),
     /* 224933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224937 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224939 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224941 */     GIR_RootConstrainSelectedInstOperands,
     /* 224942 */     // GIR_Coverage, 11192,
     /* 224942 */     GIR_EraseRootFromParent_Done,
     /* 224943 */   // Label 4483: @224943
     /* 224943 */   GIM_Try, /*On fail goto*//*Label 4484*/ GIMT_Encode4(224985), // Rule ID 11193 //
     /* 224948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
     /* 224956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 224962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 224965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 224968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224972 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1893:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 224972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_H),
     /* 224975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 224977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224979 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224981 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224983 */     GIR_RootConstrainSelectedInstOperands,
     /* 224984 */     // GIR_Coverage, 11193,
     /* 224984 */     GIR_EraseRootFromParent_Done,
     /* 224985 */   // Label 4484: @224985
     /* 224985 */   GIM_Try, /*On fail goto*//*Label 4485*/ GIMT_Encode4(225027), // Rule ID 11194 //
     /* 224990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 224993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
     /* 224998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 225004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225014 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1893:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 225014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_S),
     /* 225017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225021 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225023 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225025 */     GIR_RootConstrainSelectedInstOperands,
     /* 225026 */     // GIR_Coverage, 11194,
     /* 225026 */     GIR_EraseRootFromParent_Done,
     /* 225027 */   // Label 4485: @225027
     /* 225027 */   GIM_Try, /*On fail goto*//*Label 4486*/ GIMT_Encode4(225069), // Rule ID 11195 //
     /* 225032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
     /* 225040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 225046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225056 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1893:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 225056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_D),
     /* 225059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225063 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225065 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225067 */     GIR_RootConstrainSelectedInstOperands,
     /* 225068 */     // GIR_Coverage, 11195,
     /* 225068 */     GIR_EraseRootFromParent_Done,
     /* 225069 */   // Label 4486: @225069
     /* 225069 */   GIM_Try, /*On fail goto*//*Label 4487*/ GIMT_Encode4(225111), // Rule ID 11204 //
     /* 225074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
     /* 225082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 225091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 225094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225098 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1691:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 225098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_H),
     /* 225101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225105 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225107 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225109 */     GIR_RootConstrainSelectedInstOperands,
     /* 225110 */     // GIR_Coverage, 11204,
     /* 225110 */     GIR_EraseRootFromParent_Done,
     /* 225111 */   // Label 4487: @225111
     /* 225111 */   GIM_Try, /*On fail goto*//*Label 4488*/ GIMT_Encode4(225153), // Rule ID 11205 //
     /* 225116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
     /* 225124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 225130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225140 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1691:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 225140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_S),
     /* 225143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225147 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225149 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225151 */     GIR_RootConstrainSelectedInstOperands,
     /* 225152 */     // GIR_Coverage, 11205,
     /* 225152 */     GIR_EraseRootFromParent_Done,
     /* 225153 */   // Label 4488: @225153
     /* 225153 */   GIM_Try, /*On fail goto*//*Label 4489*/ GIMT_Encode4(225195), // Rule ID 11206 //
     /* 225158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
     /* 225166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 225172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225182 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1691:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 225182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_D),
     /* 225185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225189 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225191 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225193 */     GIR_RootConstrainSelectedInstOperands,
     /* 225194 */     // GIR_Coverage, 11206,
     /* 225194 */     GIR_EraseRootFromParent_Done,
     /* 225195 */   // Label 4489: @225195
     /* 225195 */   GIM_Try, /*On fail goto*//*Label 4490*/ GIMT_Encode4(225237), // Rule ID 11207 //
     /* 225200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
     /* 225208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 225217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 225220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225224 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1694:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 225224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_H),
     /* 225227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225231 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225233 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225235 */     GIR_RootConstrainSelectedInstOperands,
     /* 225236 */     // GIR_Coverage, 11207,
     /* 225236 */     GIR_EraseRootFromParent_Done,
     /* 225237 */   // Label 4490: @225237
     /* 225237 */   GIM_Try, /*On fail goto*//*Label 4491*/ GIMT_Encode4(225279), // Rule ID 11208 //
     /* 225242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
     /* 225250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 225256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225266 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1694:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 225266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_S),
     /* 225269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225271 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225273 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225275 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225277 */     GIR_RootConstrainSelectedInstOperands,
     /* 225278 */     // GIR_Coverage, 11208,
     /* 225278 */     GIR_EraseRootFromParent_Done,
     /* 225279 */   // Label 4491: @225279
     /* 225279 */   GIM_Try, /*On fail goto*//*Label 4492*/ GIMT_Encode4(225321), // Rule ID 11209 //
     /* 225284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
     /* 225292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 225298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225308 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1694:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 225308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_D),
     /* 225311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225317 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225319 */     GIR_RootConstrainSelectedInstOperands,
     /* 225320 */     // GIR_Coverage, 11209,
     /* 225320 */     GIR_EraseRootFromParent_Done,
     /* 225321 */   // Label 4492: @225321
     /* 225321 */   GIM_Try, /*On fail goto*//*Label 4493*/ GIMT_Encode4(225363), // Rule ID 11210 //
     /* 225326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
     /* 225334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 225343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 225346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225350 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1696:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 225350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_H),
     /* 225353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225355 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225357 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225359 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225361 */     GIR_RootConstrainSelectedInstOperands,
     /* 225362 */     // GIR_Coverage, 11210,
     /* 225362 */     GIR_EraseRootFromParent_Done,
     /* 225363 */   // Label 4493: @225363
     /* 225363 */   GIM_Try, /*On fail goto*//*Label 4494*/ GIMT_Encode4(225405), // Rule ID 11211 //
     /* 225368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
     /* 225376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 225382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225392 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1696:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 225392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_S),
     /* 225395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225399 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225401 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225403 */     GIR_RootConstrainSelectedInstOperands,
     /* 225404 */     // GIR_Coverage, 11211,
     /* 225404 */     GIR_EraseRootFromParent_Done,
     /* 225405 */   // Label 4494: @225405
     /* 225405 */   GIM_Try, /*On fail goto*//*Label 4495*/ GIMT_Encode4(225447), // Rule ID 11212 //
     /* 225410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
     /* 225418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 225424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225434 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1696:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 225434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_D),
     /* 225437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225441 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225443 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225445 */     GIR_RootConstrainSelectedInstOperands,
     /* 225446 */     // GIR_Coverage, 11212,
     /* 225446 */     GIR_EraseRootFromParent_Done,
     /* 225447 */   // Label 4495: @225447
     /* 225447 */   GIM_Try, /*On fail goto*//*Label 4496*/ GIMT_Encode4(225489), // Rule ID 11213 //
     /* 225452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
     /* 225460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 225469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 225472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225476 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1699:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 225476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_H),
     /* 225479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225485 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225487 */     GIR_RootConstrainSelectedInstOperands,
     /* 225488 */     // GIR_Coverage, 11213,
     /* 225488 */     GIR_EraseRootFromParent_Done,
     /* 225489 */   // Label 4496: @225489
     /* 225489 */   GIM_Try, /*On fail goto*//*Label 4497*/ GIMT_Encode4(225531), // Rule ID 11214 //
     /* 225494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
     /* 225502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 225508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225518 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1699:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 225518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_S),
     /* 225521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225523 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225525 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225527 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225529 */     GIR_RootConstrainSelectedInstOperands,
     /* 225530 */     // GIR_Coverage, 11214,
     /* 225530 */     GIR_EraseRootFromParent_Done,
     /* 225531 */   // Label 4497: @225531
     /* 225531 */   GIM_Try, /*On fail goto*//*Label 4498*/ GIMT_Encode4(225573), // Rule ID 11215 //
     /* 225536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
     /* 225544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 225550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225560 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1699:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 225560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_D),
     /* 225563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225565 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225567 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225569 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225571 */     GIR_RootConstrainSelectedInstOperands,
     /* 225572 */     // GIR_Coverage, 11215,
     /* 225572 */     GIR_EraseRootFromParent_Done,
     /* 225573 */   // Label 4498: @225573
     /* 225573 */   GIM_Try, /*On fail goto*//*Label 4499*/ GIMT_Encode4(225615), // Rule ID 11216 //
     /* 225578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
     /* 225586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 225595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 225598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225602 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1693:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 225602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_H),
     /* 225605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225607 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225609 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225611 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225613 */     GIR_RootConstrainSelectedInstOperands,
     /* 225614 */     // GIR_Coverage, 11216,
     /* 225614 */     GIR_EraseRootFromParent_Done,
     /* 225615 */   // Label 4499: @225615
     /* 225615 */   GIM_Try, /*On fail goto*//*Label 4500*/ GIMT_Encode4(225657), // Rule ID 11217 //
     /* 225620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
     /* 225628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 225634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225644 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1693:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 225644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_S),
     /* 225647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225651 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225653 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225655 */     GIR_RootConstrainSelectedInstOperands,
     /* 225656 */     // GIR_Coverage, 11217,
     /* 225656 */     GIR_EraseRootFromParent_Done,
     /* 225657 */   // Label 4500: @225657
     /* 225657 */   GIM_Try, /*On fail goto*//*Label 4501*/ GIMT_Encode4(225699), // Rule ID 11218 //
     /* 225662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
     /* 225670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 225676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225686 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1693:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 225686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_D),
     /* 225689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225693 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225695 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225697 */     GIR_RootConstrainSelectedInstOperands,
     /* 225698 */     // GIR_Coverage, 11218,
     /* 225698 */     GIR_EraseRootFromParent_Done,
     /* 225699 */   // Label 4501: @225699
     /* 225699 */   GIM_Try, /*On fail goto*//*Label 4502*/ GIMT_Encode4(225741), // Rule ID 11219 //
     /* 225704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
     /* 225712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 225721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 225724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225728 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1698:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 225728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_H),
     /* 225731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225733 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225735 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225737 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225739 */     GIR_RootConstrainSelectedInstOperands,
     /* 225740 */     // GIR_Coverage, 11219,
     /* 225740 */     GIR_EraseRootFromParent_Done,
     /* 225741 */   // Label 4502: @225741
     /* 225741 */   GIM_Try, /*On fail goto*//*Label 4503*/ GIMT_Encode4(225783), // Rule ID 11220 //
     /* 225746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
     /* 225754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 225760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225770 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1698:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 225770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_S),
     /* 225773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225775 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225777 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225779 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225781 */     GIR_RootConstrainSelectedInstOperands,
     /* 225782 */     // GIR_Coverage, 11220,
     /* 225782 */     GIR_EraseRootFromParent_Done,
     /* 225783 */   // Label 4503: @225783
     /* 225783 */   GIM_Try, /*On fail goto*//*Label 4504*/ GIMT_Encode4(225825), // Rule ID 11221 //
     /* 225788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
     /* 225796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 225802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225812 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1698:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 225812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_D),
     /* 225815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225819 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225821 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225823 */     GIR_RootConstrainSelectedInstOperands,
     /* 225824 */     // GIR_Coverage, 11221,
     /* 225824 */     GIR_EraseRootFromParent_Done,
     /* 225825 */   // Label 4504: @225825
     /* 225825 */   GIM_Try, /*On fail goto*//*Label 4505*/ GIMT_Encode4(225867), // Rule ID 11222 //
     /* 225830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 225838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 225841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 225844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 225847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 225850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225854 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1866:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 225854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_B),
     /* 225857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225861 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225863 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225865 */     GIR_RootConstrainSelectedInstOperands,
     /* 225866 */     // GIR_Coverage, 11222,
     /* 225866 */     GIR_EraseRootFromParent_Done,
     /* 225867 */   // Label 4505: @225867
     /* 225867 */   GIM_Try, /*On fail goto*//*Label 4506*/ GIMT_Encode4(225909), // Rule ID 11224 //
     /* 225872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 225880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 225886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225896 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1866:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 225896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_H),
     /* 225899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225903 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225905 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225907 */     GIR_RootConstrainSelectedInstOperands,
     /* 225908 */     // GIR_Coverage, 11224,
     /* 225908 */     GIR_EraseRootFromParent_Done,
     /* 225909 */   // Label 4506: @225909
     /* 225909 */   GIM_Try, /*On fail goto*//*Label 4507*/ GIMT_Encode4(225951), // Rule ID 11226 //
     /* 225914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 225922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225938 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1866:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 225938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_S),
     /* 225941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225945 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225947 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225949 */     GIR_RootConstrainSelectedInstOperands,
     /* 225950 */     // GIR_Coverage, 11226,
     /* 225950 */     GIR_EraseRootFromParent_Done,
     /* 225951 */   // Label 4507: @225951
     /* 225951 */   GIM_Try, /*On fail goto*//*Label 4508*/ GIMT_Encode4(225993), // Rule ID 11228 //
     /* 225956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 225964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 225976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225980 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1866:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 225980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_D),
     /* 225983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225987 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225989 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225991 */     GIR_RootConstrainSelectedInstOperands,
     /* 225992 */     // GIR_Coverage, 11228,
     /* 225992 */     GIR_EraseRootFromParent_Done,
     /* 225993 */   // Label 4508: @225993
     /* 225993 */   GIM_Try, /*On fail goto*//*Label 4509*/ GIMT_Encode4(226035), // Rule ID 11230 //
     /* 225998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 226006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 226009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 226012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 226018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226022 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1626:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 226022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_B),
     /* 226025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226029 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226031 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226033 */     GIR_RootConstrainSelectedInstOperands,
     /* 226034 */     // GIR_Coverage, 11230,
     /* 226034 */     GIR_EraseRootFromParent_Done,
     /* 226035 */   // Label 4509: @226035
     /* 226035 */   GIM_Try, /*On fail goto*//*Label 4510*/ GIMT_Encode4(226077), // Rule ID 11231 //
     /* 226040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 226048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 226060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226064 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1626:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 226064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_H),
     /* 226067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226071 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226073 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226075 */     GIR_RootConstrainSelectedInstOperands,
     /* 226076 */     // GIR_Coverage, 11231,
     /* 226076 */     GIR_EraseRootFromParent_Done,
     /* 226077 */   // Label 4510: @226077
     /* 226077 */   GIM_Try, /*On fail goto*//*Label 4511*/ GIMT_Encode4(226119), // Rule ID 11232 //
     /* 226082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 226090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 226102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226106 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1626:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 226106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_S),
     /* 226109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226111 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226113 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226115 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226117 */     GIR_RootConstrainSelectedInstOperands,
     /* 226118 */     // GIR_Coverage, 11232,
     /* 226118 */     GIR_EraseRootFromParent_Done,
     /* 226119 */   // Label 4511: @226119
     /* 226119 */   GIM_Try, /*On fail goto*//*Label 4512*/ GIMT_Encode4(226161), // Rule ID 11233 //
     /* 226124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 226132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 226144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226148 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1626:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 226148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_D),
     /* 226151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226155 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226157 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226159 */     GIR_RootConstrainSelectedInstOperands,
     /* 226160 */     // GIR_Coverage, 11233,
     /* 226160 */     GIR_EraseRootFromParent_Done,
     /* 226161 */   // Label 4512: @226161
     /* 226161 */   GIM_Try, /*On fail goto*//*Label 4513*/ GIMT_Encode4(226203), // Rule ID 11234 //
     /* 226166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 226174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 226177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 226180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 226186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226190 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1867:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 226190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_B),
     /* 226193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226195 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226197 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226199 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226201 */     GIR_RootConstrainSelectedInstOperands,
     /* 226202 */     // GIR_Coverage, 11234,
     /* 226202 */     GIR_EraseRootFromParent_Done,
     /* 226203 */   // Label 4513: @226203
     /* 226203 */   GIM_Try, /*On fail goto*//*Label 4514*/ GIMT_Encode4(226245), // Rule ID 11235 //
     /* 226208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 226216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 226228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226232 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1867:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 226232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_H),
     /* 226235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226239 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226241 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226243 */     GIR_RootConstrainSelectedInstOperands,
     /* 226244 */     // GIR_Coverage, 11235,
     /* 226244 */     GIR_EraseRootFromParent_Done,
     /* 226245 */   // Label 4514: @226245
     /* 226245 */   GIM_Try, /*On fail goto*//*Label 4515*/ GIMT_Encode4(226287), // Rule ID 11236 //
     /* 226250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 226258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 226270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226274 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1867:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 226274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_S),
     /* 226277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226279 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226281 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226283 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226285 */     GIR_RootConstrainSelectedInstOperands,
     /* 226286 */     // GIR_Coverage, 11236,
     /* 226286 */     GIR_EraseRootFromParent_Done,
     /* 226287 */   // Label 4515: @226287
     /* 226287 */   GIM_Try, /*On fail goto*//*Label 4516*/ GIMT_Encode4(226329), // Rule ID 11237 //
     /* 226292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 226300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 226312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226316 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1867:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 226316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_D),
     /* 226319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226323 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226325 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226327 */     GIR_RootConstrainSelectedInstOperands,
     /* 226328 */     // GIR_Coverage, 11237,
     /* 226328 */     GIR_EraseRootFromParent_Done,
     /* 226329 */   // Label 4516: @226329
     /* 226329 */   GIM_Try, /*On fail goto*//*Label 4517*/ GIMT_Encode4(226371), // Rule ID 11238 //
     /* 226334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 226342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 226345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 226348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 226354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226358 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1761:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SRHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 226358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_B),
     /* 226361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226363 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226365 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226367 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226369 */     GIR_RootConstrainSelectedInstOperands,
     /* 226370 */     // GIR_Coverage, 11238,
     /* 226370 */     GIR_EraseRootFromParent_Done,
     /* 226371 */   // Label 4517: @226371
     /* 226371 */   GIM_Try, /*On fail goto*//*Label 4518*/ GIMT_Encode4(226413), // Rule ID 11240 //
     /* 226376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 226384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 226396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226400 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1761:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SRHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 226400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_H),
     /* 226403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226407 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226409 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226411 */     GIR_RootConstrainSelectedInstOperands,
     /* 226412 */     // GIR_Coverage, 11240,
     /* 226412 */     GIR_EraseRootFromParent_Done,
     /* 226413 */   // Label 4518: @226413
     /* 226413 */   GIM_Try, /*On fail goto*//*Label 4519*/ GIMT_Encode4(226455), // Rule ID 11242 //
     /* 226418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 226426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 226438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226442 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1761:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SRHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 226442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_S),
     /* 226445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226449 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226451 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226453 */     GIR_RootConstrainSelectedInstOperands,
     /* 226454 */     // GIR_Coverage, 11242,
     /* 226454 */     GIR_EraseRootFromParent_Done,
     /* 226455 */   // Label 4519: @226455
     /* 226455 */   GIM_Try, /*On fail goto*//*Label 4520*/ GIMT_Encode4(226497), // Rule ID 11244 //
     /* 226460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 226468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 226480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226484 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1761:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SRHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 226484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_D),
     /* 226487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226491 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226493 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226495 */     GIR_RootConstrainSelectedInstOperands,
     /* 226496 */     // GIR_Coverage, 11244,
     /* 226496 */     GIR_EraseRootFromParent_Done,
     /* 226497 */   // Label 4520: @226497
     /* 226497 */   GIM_Try, /*On fail goto*//*Label 4521*/ GIMT_Encode4(226539), // Rule ID 11246 //
     /* 226502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 226510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 226513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 226516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 226522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226526 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1953:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (URHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 226526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_B),
     /* 226529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226531 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226533 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226535 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226537 */     GIR_RootConstrainSelectedInstOperands,
     /* 226538 */     // GIR_Coverage, 11246,
     /* 226538 */     GIR_EraseRootFromParent_Done,
     /* 226539 */   // Label 4521: @226539
     /* 226539 */   GIM_Try, /*On fail goto*//*Label 4522*/ GIMT_Encode4(226581), // Rule ID 11248 //
     /* 226544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 226552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 226564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226568 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1953:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (URHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 226568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_H),
     /* 226571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226577 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226579 */     GIR_RootConstrainSelectedInstOperands,
     /* 226580 */     // GIR_Coverage, 11248,
     /* 226580 */     GIR_EraseRootFromParent_Done,
     /* 226581 */   // Label 4522: @226581
     /* 226581 */   GIM_Try, /*On fail goto*//*Label 4523*/ GIMT_Encode4(226623), // Rule ID 11250 //
     /* 226586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 226594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 226606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226610 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1953:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 226610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_S),
     /* 226613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226615 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226617 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226619 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226621 */     GIR_RootConstrainSelectedInstOperands,
     /* 226622 */     // GIR_Coverage, 11250,
     /* 226622 */     GIR_EraseRootFromParent_Done,
     /* 226623 */   // Label 4523: @226623
     /* 226623 */   GIM_Try, /*On fail goto*//*Label 4524*/ GIMT_Encode4(226665), // Rule ID 11252 //
     /* 226628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 226636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 226648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226652 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1953:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (URHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 226652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_D),
     /* 226655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226659 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226661 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226663 */     GIR_RootConstrainSelectedInstOperands,
     /* 226664 */     // GIR_Coverage, 11252,
     /* 226664 */     GIR_EraseRootFromParent_Done,
     /* 226665 */   // Label 4524: @226665
     /* 226665 */   GIM_Try, /*On fail goto*//*Label 4525*/ GIMT_Encode4(226707), // Rule ID 11254 //
     /* 226670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 226678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 226681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 226684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 226690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226694 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1627:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 226694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_B),
     /* 226697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226701 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226703 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226705 */     GIR_RootConstrainSelectedInstOperands,
     /* 226706 */     // GIR_Coverage, 11254,
     /* 226706 */     GIR_EraseRootFromParent_Done,
     /* 226707 */   // Label 4525: @226707
     /* 226707 */   GIM_Try, /*On fail goto*//*Label 4526*/ GIMT_Encode4(226749), // Rule ID 11255 //
     /* 226712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 226720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 226732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226736 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1627:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 226736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_H),
     /* 226739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226743 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226745 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226747 */     GIR_RootConstrainSelectedInstOperands,
     /* 226748 */     // GIR_Coverage, 11255,
     /* 226748 */     GIR_EraseRootFromParent_Done,
     /* 226749 */   // Label 4526: @226749
     /* 226749 */   GIM_Try, /*On fail goto*//*Label 4527*/ GIMT_Encode4(226791), // Rule ID 11256 //
     /* 226754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 226762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 226774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226778 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1627:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 226778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_S),
     /* 226781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226785 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226787 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226789 */     GIR_RootConstrainSelectedInstOperands,
     /* 226790 */     // GIR_Coverage, 11256,
     /* 226790 */     GIR_EraseRootFromParent_Done,
     /* 226791 */   // Label 4527: @226791
     /* 226791 */   GIM_Try, /*On fail goto*//*Label 4528*/ GIMT_Encode4(226833), // Rule ID 11257 //
     /* 226796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 226804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 226816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226820 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1627:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 226820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_D),
     /* 226823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226827 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226829 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226831 */     GIR_RootConstrainSelectedInstOperands,
     /* 226832 */     // GIR_Coverage, 11257,
     /* 226832 */     GIR_EraseRootFromParent_Done,
     /* 226833 */   // Label 4528: @226833
     /* 226833 */   GIM_Try, /*On fail goto*//*Label 4529*/ GIMT_Encode4(226875), // Rule ID 11258 //
     /* 226838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 226846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 226849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 226852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 226858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226862 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1868:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 226862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_B),
     /* 226865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226867 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226869 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226871 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226873 */     GIR_RootConstrainSelectedInstOperands,
     /* 226874 */     // GIR_Coverage, 11258,
     /* 226874 */     GIR_EraseRootFromParent_Done,
     /* 226875 */   // Label 4529: @226875
     /* 226875 */   GIM_Try, /*On fail goto*//*Label 4530*/ GIMT_Encode4(226917), // Rule ID 11259 //
     /* 226880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 226888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 226900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226904 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1868:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 226904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_H),
     /* 226907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226911 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226913 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226915 */     GIR_RootConstrainSelectedInstOperands,
     /* 226916 */     // GIR_Coverage, 11259,
     /* 226916 */     GIR_EraseRootFromParent_Done,
     /* 226917 */   // Label 4530: @226917
     /* 226917 */   GIM_Try, /*On fail goto*//*Label 4531*/ GIMT_Encode4(226959), // Rule ID 11260 //
     /* 226922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 226930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 226942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226946 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1868:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 226946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_S),
     /* 226949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226953 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226955 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226957 */     GIR_RootConstrainSelectedInstOperands,
     /* 226958 */     // GIR_Coverage, 11260,
     /* 226958 */     GIR_EraseRootFromParent_Done,
     /* 226959 */   // Label 4531: @226959
     /* 226959 */   GIM_Try, /*On fail goto*//*Label 4532*/ GIMT_Encode4(227001), // Rule ID 11261 //
     /* 226964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 226972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 226984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226988 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1868:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 226988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_D),
     /* 226991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226995 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226997 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226999 */     GIR_RootConstrainSelectedInstOperands,
     /* 227000 */     // GIR_Coverage, 11261,
     /* 227000 */     GIR_EraseRootFromParent_Done,
     /* 227001 */   // Label 4532: @227001
     /* 227001 */   GIM_Try, /*On fail goto*//*Label 4533*/ GIMT_Encode4(227043), // Rule ID 11262 //
     /* 227006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
     /* 227014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 227026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227030 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1843:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UADALP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 227030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_H),
     /* 227033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 227035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227037 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227039 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227041 */     GIR_RootConstrainSelectedInstOperands,
     /* 227042 */     // GIR_Coverage, 11262,
     /* 227042 */     GIR_EraseRootFromParent_Done,
     /* 227043 */   // Label 4533: @227043
     /* 227043 */   GIM_Try, /*On fail goto*//*Label 4534*/ GIMT_Encode4(227085), // Rule ID 11263 //
     /* 227048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
     /* 227056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 227068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227072 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1843:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UADALP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 227072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_S),
     /* 227075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 227077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227079 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227081 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227083 */     GIR_RootConstrainSelectedInstOperands,
     /* 227084 */     // GIR_Coverage, 11263,
     /* 227084 */     GIR_EraseRootFromParent_Done,
     /* 227085 */   // Label 4534: @227085
     /* 227085 */   GIM_Try, /*On fail goto*//*Label 4535*/ GIMT_Encode4(227127), // Rule ID 11264 //
     /* 227090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
     /* 227098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 227110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227114 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1843:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UADALP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 227114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_D),
     /* 227117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 227119 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227121 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227123 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227125 */     GIR_RootConstrainSelectedInstOperands,
     /* 227126 */     // GIR_Coverage, 11264,
     /* 227126 */     GIR_EraseRootFromParent_Done,
     /* 227127 */   // Label 4535: @227127
     /* 227127 */   GIM_Try, /*On fail goto*//*Label 4536*/ GIMT_Encode4(227169), // Rule ID 11265 //
     /* 227132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 227140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 227143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 227146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 227152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227156 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1158:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (ADDP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 227156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_B),
     /* 227159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227163 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227165 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227167 */     GIR_RootConstrainSelectedInstOperands,
     /* 227168 */     // GIR_Coverage, 11265,
     /* 227168 */     GIR_EraseRootFromParent_Done,
     /* 227169 */   // Label 4536: @227169
     /* 227169 */   GIM_Try, /*On fail goto*//*Label 4537*/ GIMT_Encode4(227211), // Rule ID 11266 //
     /* 227174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 227182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 227194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227198 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1158:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ADDP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 227198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_H),
     /* 227201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227205 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227207 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227209 */     GIR_RootConstrainSelectedInstOperands,
     /* 227210 */     // GIR_Coverage, 11266,
     /* 227210 */     GIR_EraseRootFromParent_Done,
     /* 227211 */   // Label 4537: @227211
     /* 227211 */   GIM_Try, /*On fail goto*//*Label 4538*/ GIMT_Encode4(227253), // Rule ID 11267 //
     /* 227216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 227224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 227236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227240 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1158:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADDP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 227240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_S),
     /* 227243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227247 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227249 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227251 */     GIR_RootConstrainSelectedInstOperands,
     /* 227252 */     // GIR_Coverage, 11267,
     /* 227252 */     GIR_EraseRootFromParent_Done,
     /* 227253 */   // Label 4538: @227253
     /* 227253 */   GIM_Try, /*On fail goto*//*Label 4539*/ GIMT_Encode4(227295), // Rule ID 11268 //
     /* 227258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 227266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227282 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1158:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADDP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_D),
     /* 227285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227289 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227291 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227293 */     GIR_RootConstrainSelectedInstOperands,
     /* 227294 */     // GIR_Coverage, 11268,
     /* 227294 */     GIR_EraseRootFromParent_Done,
     /* 227295 */   // Label 4539: @227295
     /* 227295 */   GIM_Try, /*On fail goto*//*Label 4540*/ GIMT_Encode4(227337), // Rule ID 11269 //
     /* 227300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 227308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 227311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 227314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 227320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227324 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1637:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMAXP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 227324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_B),
     /* 227327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227329 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227331 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227333 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227335 */     GIR_RootConstrainSelectedInstOperands,
     /* 227336 */     // GIR_Coverage, 11269,
     /* 227336 */     GIR_EraseRootFromParent_Done,
     /* 227337 */   // Label 4540: @227337
     /* 227337 */   GIM_Try, /*On fail goto*//*Label 4541*/ GIMT_Encode4(227379), // Rule ID 11270 //
     /* 227342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 227350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 227362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227366 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1637:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMAXP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 227366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_H),
     /* 227369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227373 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227375 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227377 */     GIR_RootConstrainSelectedInstOperands,
     /* 227378 */     // GIR_Coverage, 11270,
     /* 227378 */     GIR_EraseRootFromParent_Done,
     /* 227379 */   // Label 4541: @227379
     /* 227379 */   GIM_Try, /*On fail goto*//*Label 4542*/ GIMT_Encode4(227421), // Rule ID 11271 //
     /* 227384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 227392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 227404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227408 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1637:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMAXP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 227408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_S),
     /* 227411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227415 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227417 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227419 */     GIR_RootConstrainSelectedInstOperands,
     /* 227420 */     // GIR_Coverage, 11271,
     /* 227420 */     GIR_EraseRootFromParent_Done,
     /* 227421 */   // Label 4542: @227421
     /* 227421 */   GIM_Try, /*On fail goto*//*Label 4543*/ GIMT_Encode4(227463), // Rule ID 11272 //
     /* 227426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 227434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227450 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1637:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMAXP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_D),
     /* 227453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227457 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227459 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227461 */     GIR_RootConstrainSelectedInstOperands,
     /* 227462 */     // GIR_Coverage, 11272,
     /* 227462 */     GIR_EraseRootFromParent_Done,
     /* 227463 */   // Label 4543: @227463
     /* 227463 */   GIM_Try, /*On fail goto*//*Label 4544*/ GIMT_Encode4(227505), // Rule ID 11273 //
     /* 227468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 227476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 227479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 227482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 227488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227492 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1875:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMAXP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 227492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_B),
     /* 227495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227499 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227501 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227503 */     GIR_RootConstrainSelectedInstOperands,
     /* 227504 */     // GIR_Coverage, 11273,
     /* 227504 */     GIR_EraseRootFromParent_Done,
     /* 227505 */   // Label 4544: @227505
     /* 227505 */   GIM_Try, /*On fail goto*//*Label 4545*/ GIMT_Encode4(227547), // Rule ID 11274 //
     /* 227510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 227518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 227530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227534 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1875:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMAXP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 227534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_H),
     /* 227537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227541 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227543 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227545 */     GIR_RootConstrainSelectedInstOperands,
     /* 227546 */     // GIR_Coverage, 11274,
     /* 227546 */     GIR_EraseRootFromParent_Done,
     /* 227547 */   // Label 4545: @227547
     /* 227547 */   GIM_Try, /*On fail goto*//*Label 4546*/ GIMT_Encode4(227589), // Rule ID 11275 //
     /* 227552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 227560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 227572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227576 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1875:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMAXP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 227576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_S),
     /* 227579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227583 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227585 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227587 */     GIR_RootConstrainSelectedInstOperands,
     /* 227588 */     // GIR_Coverage, 11275,
     /* 227588 */     GIR_EraseRootFromParent_Done,
     /* 227589 */   // Label 4546: @227589
     /* 227589 */   GIM_Try, /*On fail goto*//*Label 4547*/ GIMT_Encode4(227631), // Rule ID 11276 //
     /* 227594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 227602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227618 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1875:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMAXP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_D),
     /* 227621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227625 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227627 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227629 */     GIR_RootConstrainSelectedInstOperands,
     /* 227630 */     // GIR_Coverage, 11276,
     /* 227630 */     GIR_EraseRootFromParent_Done,
     /* 227631 */   // Label 4547: @227631
     /* 227631 */   GIM_Try, /*On fail goto*//*Label 4548*/ GIMT_Encode4(227673), // Rule ID 11277 //
     /* 227636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 227644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 227647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 227650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 227656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227660 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1646:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMINP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 227660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_B),
     /* 227663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227667 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227669 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227671 */     GIR_RootConstrainSelectedInstOperands,
     /* 227672 */     // GIR_Coverage, 11277,
     /* 227672 */     GIR_EraseRootFromParent_Done,
     /* 227673 */   // Label 4548: @227673
     /* 227673 */   GIM_Try, /*On fail goto*//*Label 4549*/ GIMT_Encode4(227715), // Rule ID 11278 //
     /* 227678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 227686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 227698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227702 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1646:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMINP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 227702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_H),
     /* 227705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227709 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227711 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227713 */     GIR_RootConstrainSelectedInstOperands,
     /* 227714 */     // GIR_Coverage, 11278,
     /* 227714 */     GIR_EraseRootFromParent_Done,
     /* 227715 */   // Label 4549: @227715
     /* 227715 */   GIM_Try, /*On fail goto*//*Label 4550*/ GIMT_Encode4(227757), // Rule ID 11279 //
     /* 227720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 227728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 227740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227744 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1646:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMINP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 227744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_S),
     /* 227747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227751 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227753 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227755 */     GIR_RootConstrainSelectedInstOperands,
     /* 227756 */     // GIR_Coverage, 11279,
     /* 227756 */     GIR_EraseRootFromParent_Done,
     /* 227757 */   // Label 4550: @227757
     /* 227757 */   GIM_Try, /*On fail goto*//*Label 4551*/ GIMT_Encode4(227799), // Rule ID 11280 //
     /* 227762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 227770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227786 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1646:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMINP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_D),
     /* 227789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227791 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227793 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227795 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227797 */     GIR_RootConstrainSelectedInstOperands,
     /* 227798 */     // GIR_Coverage, 11280,
     /* 227798 */     GIR_EraseRootFromParent_Done,
     /* 227799 */   // Label 4551: @227799
     /* 227799 */   GIM_Try, /*On fail goto*//*Label 4552*/ GIMT_Encode4(227841), // Rule ID 11281 //
     /* 227804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 227812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 227815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 227818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 227824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227828 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1884:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMINP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 227828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_B),
     /* 227831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227835 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227837 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227839 */     GIR_RootConstrainSelectedInstOperands,
     /* 227840 */     // GIR_Coverage, 11281,
     /* 227840 */     GIR_EraseRootFromParent_Done,
     /* 227841 */   // Label 4552: @227841
     /* 227841 */   GIM_Try, /*On fail goto*//*Label 4553*/ GIMT_Encode4(227883), // Rule ID 11282 //
     /* 227846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 227854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 227866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227870 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1884:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMINP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 227870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_H),
     /* 227873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227877 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227879 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227881 */     GIR_RootConstrainSelectedInstOperands,
     /* 227882 */     // GIR_Coverage, 11282,
     /* 227882 */     GIR_EraseRootFromParent_Done,
     /* 227883 */   // Label 4553: @227883
     /* 227883 */   GIM_Try, /*On fail goto*//*Label 4554*/ GIMT_Encode4(227925), // Rule ID 11283 //
     /* 227888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 227896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 227908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227912 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1884:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMINP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 227912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_S),
     /* 227915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227919 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227921 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227923 */     GIR_RootConstrainSelectedInstOperands,
     /* 227924 */     // GIR_Coverage, 11283,
     /* 227924 */     GIR_EraseRootFromParent_Done,
     /* 227925 */   // Label 4554: @227925
     /* 227925 */   GIM_Try, /*On fail goto*//*Label 4555*/ GIMT_Encode4(227967), // Rule ID 11284 //
     /* 227930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 227938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227954 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1884:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMINP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_D),
     /* 227957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227959 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227961 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227963 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227965 */     GIR_RootConstrainSelectedInstOperands,
     /* 227966 */     // GIR_Coverage, 11284,
     /* 227966 */     GIR_EraseRootFromParent_Done,
     /* 227967 */   // Label 4555: @227967
     /* 227967 */   GIM_Try, /*On fail goto*//*Label 4556*/ GIMT_Encode4(228009), // Rule ID 11285 //
     /* 227972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursqrte),
     /* 227980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 227986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 227989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 227992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227996 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1960:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URSQRTE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 227996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTE_ZPmZ_S),
     /* 227999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228003 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228005 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228007 */     GIR_RootConstrainSelectedInstOperands,
     /* 228008 */     // GIR_Coverage, 11285,
     /* 228008 */     GIR_EraseRootFromParent_Done,
     /* 228009 */   // Label 4556: @228009
     /* 228009 */   GIM_Try, /*On fail goto*//*Label 4557*/ GIMT_Encode4(228051), // Rule ID 11296 //
     /* 228014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 228022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 228028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 228031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 228034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228038 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1725:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQNEG_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 228038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_B),
     /* 228041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228045 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228047 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228049 */     GIR_RootConstrainSelectedInstOperands,
     /* 228050 */     // GIR_Coverage, 11296,
     /* 228050 */     GIR_EraseRootFromParent_Done,
     /* 228051 */   // Label 4557: @228051
     /* 228051 */   GIM_Try, /*On fail goto*//*Label 4558*/ GIMT_Encode4(228093), // Rule ID 11297 //
     /* 228056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 228064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 228070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 228073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 228076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228080 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1725:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQNEG_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 228080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_H),
     /* 228083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228087 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228089 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228091 */     GIR_RootConstrainSelectedInstOperands,
     /* 228092 */     // GIR_Coverage, 11297,
     /* 228092 */     GIR_EraseRootFromParent_Done,
     /* 228093 */   // Label 4558: @228093
     /* 228093 */   GIM_Try, /*On fail goto*//*Label 4559*/ GIMT_Encode4(228135), // Rule ID 11298 //
     /* 228098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 228106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 228112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 228115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 228118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228122 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1725:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQNEG_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 228122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_S),
     /* 228125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228127 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228129 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228131 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228133 */     GIR_RootConstrainSelectedInstOperands,
     /* 228134 */     // GIR_Coverage, 11298,
     /* 228134 */     GIR_EraseRootFromParent_Done,
     /* 228135 */   // Label 4559: @228135
     /* 228135 */   GIM_Try, /*On fail goto*//*Label 4560*/ GIMT_Encode4(228177), // Rule ID 11299 //
     /* 228140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 228148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 228154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 228157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228164 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1725:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQNEG_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_D),
     /* 228167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228173 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228175 */     GIR_RootConstrainSelectedInstOperands,
     /* 228176 */     // GIR_Coverage, 11299,
     /* 228176 */     GIR_EraseRootFromParent_Done,
     /* 228177 */   // Label 4560: @228177
     /* 228177 */   GIM_Try, /*On fail goto*//*Label 4561*/ GIMT_Encode4(228219), // Rule ID 11308 //
     /* 228182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 228190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 228202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228206 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1666:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 228206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_B),
     /* 228209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228213 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228215 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228217 */     GIR_RootConstrainSelectedInstOperands,
     /* 228218 */     // GIR_Coverage, 11308,
     /* 228218 */     GIR_EraseRootFromParent_Done,
     /* 228219 */   // Label 4561: @228219
     /* 228219 */   GIM_Try, /*On fail goto*//*Label 4562*/ GIMT_Encode4(228261), // Rule ID 11309 //
     /* 228224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 228232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 228244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228248 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1666:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 228248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_H),
     /* 228251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228255 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228257 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228259 */     GIR_RootConstrainSelectedInstOperands,
     /* 228260 */     // GIR_Coverage, 11309,
     /* 228260 */     GIR_EraseRootFromParent_Done,
     /* 228261 */   // Label 4562: @228261
     /* 228261 */   GIM_Try, /*On fail goto*//*Label 4563*/ GIMT_Encode4(228303), // Rule ID 11310 //
     /* 228266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 228274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 228286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228290 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1666:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 228290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_S),
     /* 228293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228297 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228299 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228301 */     GIR_RootConstrainSelectedInstOperands,
     /* 228302 */     // GIR_Coverage, 11310,
     /* 228302 */     GIR_EraseRootFromParent_Done,
     /* 228303 */   // Label 4563: @228303
     /* 228303 */   GIM_Try, /*On fail goto*//*Label 4564*/ GIMT_Encode4(228345), // Rule ID 11311 //
     /* 228308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 228316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 228322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 228325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228332 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1666:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_D),
     /* 228335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228339 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228341 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228343 */     GIR_RootConstrainSelectedInstOperands,
     /* 228344 */     // GIR_Coverage, 11311,
     /* 228344 */     GIR_EraseRootFromParent_Done,
     /* 228345 */   // Label 4564: @228345
     /* 228345 */   GIM_Try, /*On fail goto*//*Label 4565*/ GIMT_Encode4(228387), // Rule ID 11312 //
     /* 228350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 228358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 228370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228374 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1902:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 228374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_B),
     /* 228377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228379 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228381 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228383 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228385 */     GIR_RootConstrainSelectedInstOperands,
     /* 228386 */     // GIR_Coverage, 11312,
     /* 228386 */     GIR_EraseRootFromParent_Done,
     /* 228387 */   // Label 4565: @228387
     /* 228387 */   GIM_Try, /*On fail goto*//*Label 4566*/ GIMT_Encode4(228429), // Rule ID 11313 //
     /* 228392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 228400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 228412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228416 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1902:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 228416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_H),
     /* 228419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228423 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228425 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228427 */     GIR_RootConstrainSelectedInstOperands,
     /* 228428 */     // GIR_Coverage, 11313,
     /* 228428 */     GIR_EraseRootFromParent_Done,
     /* 228429 */   // Label 4566: @228429
     /* 228429 */   GIM_Try, /*On fail goto*//*Label 4567*/ GIMT_Encode4(228471), // Rule ID 11314 //
     /* 228434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 228442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 228454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228458 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1902:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 228458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_S),
     /* 228461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228465 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228467 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228469 */     GIR_RootConstrainSelectedInstOperands,
     /* 228470 */     // GIR_Coverage, 11314,
     /* 228470 */     GIR_EraseRootFromParent_Done,
     /* 228471 */   // Label 4567: @228471
     /* 228471 */   GIM_Try, /*On fail goto*//*Label 4568*/ GIMT_Encode4(228513), // Rule ID 11315 //
     /* 228476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 228484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 228490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 228493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228500 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1902:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_D),
     /* 228503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228507 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228509 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228511 */     GIR_RootConstrainSelectedInstOperands,
     /* 228512 */     // GIR_Coverage, 11315,
     /* 228512 */     GIR_EraseRootFromParent_Done,
     /* 228513 */   // Label 4568: @228513
     /* 228513 */   GIM_Try, /*On fail goto*//*Label 4569*/ GIMT_Encode4(228555), // Rule ID 11316 //
     /* 228518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 228526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 228538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228542 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1753:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 228542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_B),
     /* 228545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228547 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228549 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228551 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228553 */     GIR_RootConstrainSelectedInstOperands,
     /* 228554 */     // GIR_Coverage, 11316,
     /* 228554 */     GIR_EraseRootFromParent_Done,
     /* 228555 */   // Label 4569: @228555
     /* 228555 */   GIM_Try, /*On fail goto*//*Label 4570*/ GIMT_Encode4(228597), // Rule ID 11317 //
     /* 228560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 228568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 228580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228584 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1753:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 228584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_H),
     /* 228587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228591 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228593 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228595 */     GIR_RootConstrainSelectedInstOperands,
     /* 228596 */     // GIR_Coverage, 11317,
     /* 228596 */     GIR_EraseRootFromParent_Done,
     /* 228597 */   // Label 4570: @228597
     /* 228597 */   GIM_Try, /*On fail goto*//*Label 4571*/ GIMT_Encode4(228639), // Rule ID 11318 //
     /* 228602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 228610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 228622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228626 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1753:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 228626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_S),
     /* 228629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228633 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228635 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228637 */     GIR_RootConstrainSelectedInstOperands,
     /* 228638 */     // GIR_Coverage, 11318,
     /* 228638 */     GIR_EraseRootFromParent_Done,
     /* 228639 */   // Label 4571: @228639
     /* 228639 */   GIM_Try, /*On fail goto*//*Label 4572*/ GIMT_Encode4(228681), // Rule ID 11319 //
     /* 228644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 228652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 228658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 228661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228668 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1753:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_D),
     /* 228671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228675 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228677 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228679 */     GIR_RootConstrainSelectedInstOperands,
     /* 228680 */     // GIR_Coverage, 11319,
     /* 228680 */     GIR_EraseRootFromParent_Done,
     /* 228681 */   // Label 4572: @228681
     /* 228681 */   GIM_Try, /*On fail goto*//*Label 4573*/ GIMT_Encode4(228723), // Rule ID 11320 //
     /* 228686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 228694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 228706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228710 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1946:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 228710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_B),
     /* 228713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228715 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228717 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228719 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228721 */     GIR_RootConstrainSelectedInstOperands,
     /* 228722 */     // GIR_Coverage, 11320,
     /* 228722 */     GIR_EraseRootFromParent_Done,
     /* 228723 */   // Label 4573: @228723
     /* 228723 */   GIM_Try, /*On fail goto*//*Label 4574*/ GIMT_Encode4(228765), // Rule ID 11321 //
     /* 228728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 228736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 228748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228752 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1946:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 228752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_H),
     /* 228755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228759 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228761 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228763 */     GIR_RootConstrainSelectedInstOperands,
     /* 228764 */     // GIR_Coverage, 11321,
     /* 228764 */     GIR_EraseRootFromParent_Done,
     /* 228765 */   // Label 4574: @228765
     /* 228765 */   GIM_Try, /*On fail goto*//*Label 4575*/ GIMT_Encode4(228807), // Rule ID 11322 //
     /* 228770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 228778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 228790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228794 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1946:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 228794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_S),
     /* 228797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228799 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228801 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228803 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228805 */     GIR_RootConstrainSelectedInstOperands,
     /* 228806 */     // GIR_Coverage, 11322,
     /* 228806 */     GIR_EraseRootFromParent_Done,
     /* 228807 */   // Label 4575: @228807
     /* 228807 */   GIM_Try, /*On fail goto*//*Label 4576*/ GIMT_Encode4(228849), // Rule ID 11323 //
     /* 228812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 228820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 228826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 228829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228836 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1946:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_D),
     /* 228839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228843 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228845 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228847 */     GIR_RootConstrainSelectedInstOperands,
     /* 228848 */     // GIR_Coverage, 11323,
     /* 228848 */     GIR_EraseRootFromParent_Done,
     /* 228849 */   // Label 4576: @228849
     /* 228849 */   GIM_Try, /*On fail goto*//*Label 4577*/ GIMT_Encode4(228891), // Rule ID 11324 //
     /* 228854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 228862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 228874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228878 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1817:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SUQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 228878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_B),
     /* 228881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228885 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228887 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228889 */     GIR_RootConstrainSelectedInstOperands,
     /* 228890 */     // GIR_Coverage, 11324,
     /* 228890 */     GIR_EraseRootFromParent_Done,
     /* 228891 */   // Label 4577: @228891
     /* 228891 */   GIM_Try, /*On fail goto*//*Label 4578*/ GIMT_Encode4(228933), // Rule ID 11325 //
     /* 228896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 228904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 228916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228920 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1817:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 228920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_H),
     /* 228923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228927 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228929 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228931 */     GIR_RootConstrainSelectedInstOperands,
     /* 228932 */     // GIR_Coverage, 11325,
     /* 228932 */     GIR_EraseRootFromParent_Done,
     /* 228933 */   // Label 4578: @228933
     /* 228933 */   GIM_Try, /*On fail goto*//*Label 4579*/ GIMT_Encode4(228975), // Rule ID 11326 //
     /* 228938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 228946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 228958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228962 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1817:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 228962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_S),
     /* 228965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228969 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228971 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228973 */     GIR_RootConstrainSelectedInstOperands,
     /* 228974 */     // GIR_Coverage, 11326,
     /* 228974 */     GIR_EraseRootFromParent_Done,
     /* 228975 */   // Label 4579: @228975
     /* 228975 */   GIM_Try, /*On fail goto*//*Label 4580*/ GIMT_Encode4(229017), // Rule ID 11327 //
     /* 228980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 228988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 228994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 228997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229004 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1817:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_D),
     /* 229007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229011 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229013 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229015 */     GIR_RootConstrainSelectedInstOperands,
     /* 229016 */     // GIR_Coverage, 11327,
     /* 229016 */     GIR_EraseRootFromParent_Done,
     /* 229017 */   // Label 4580: @229017
     /* 229017 */   GIM_Try, /*On fail goto*//*Label 4581*/ GIMT_Encode4(229059), // Rule ID 11328 //
     /* 229022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 229030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 229036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 229039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 229042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229046 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1967:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (USQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 229046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_B),
     /* 229049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229051 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229053 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229055 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229057 */     GIR_RootConstrainSelectedInstOperands,
     /* 229058 */     // GIR_Coverage, 11328,
     /* 229058 */     GIR_EraseRootFromParent_Done,
     /* 229059 */   // Label 4581: @229059
     /* 229059 */   GIM_Try, /*On fail goto*//*Label 4582*/ GIMT_Encode4(229101), // Rule ID 11329 //
     /* 229064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 229072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 229078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229088 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1967:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (USQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 229088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_H),
     /* 229091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229095 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229097 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229099 */     GIR_RootConstrainSelectedInstOperands,
     /* 229100 */     // GIR_Coverage, 11329,
     /* 229100 */     GIR_EraseRootFromParent_Done,
     /* 229101 */   // Label 4582: @229101
     /* 229101 */   GIM_Try, /*On fail goto*//*Label 4583*/ GIMT_Encode4(229143), // Rule ID 11330 //
     /* 229106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 229114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 229120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229130 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1967:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (USQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 229130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_S),
     /* 229133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229137 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229139 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229141 */     GIR_RootConstrainSelectedInstOperands,
     /* 229142 */     // GIR_Coverage, 11330,
     /* 229142 */     GIR_EraseRootFromParent_Done,
     /* 229143 */   // Label 4583: @229143
     /* 229143 */   GIM_Try, /*On fail goto*//*Label 4584*/ GIMT_Encode4(229185), // Rule ID 11331 //
     /* 229148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 229156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 229162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 229165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229172 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1967:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (USQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_D),
     /* 229175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229179 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229181 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229183 */     GIR_RootConstrainSelectedInstOperands,
     /* 229184 */     // GIR_Coverage, 11331,
     /* 229184 */     GIR_EraseRootFromParent_Done,
     /* 229185 */   // Label 4584: @229185
     /* 229185 */   GIM_Try, /*On fail goto*//*Label 4585*/ GIMT_Encode4(229227), // Rule ID 11332 //
     /* 229190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 229198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 229204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 229207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 229210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229214 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1756:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 229214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_B),
     /* 229217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229219 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229221 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229223 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229225 */     GIR_RootConstrainSelectedInstOperands,
     /* 229226 */     // GIR_Coverage, 11332,
     /* 229226 */     GIR_EraseRootFromParent_Done,
     /* 229227 */   // Label 4585: @229227
     /* 229227 */   GIM_Try, /*On fail goto*//*Label 4586*/ GIMT_Encode4(229269), // Rule ID 11333 //
     /* 229232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 229240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 229246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229256 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1756:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 229256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_H),
     /* 229259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229263 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229265 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229267 */     GIR_RootConstrainSelectedInstOperands,
     /* 229268 */     // GIR_Coverage, 11333,
     /* 229268 */     GIR_EraseRootFromParent_Done,
     /* 229269 */   // Label 4586: @229269
     /* 229269 */   GIM_Try, /*On fail goto*//*Label 4587*/ GIMT_Encode4(229311), // Rule ID 11334 //
     /* 229274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 229282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 229288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229298 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1756:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 229298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_S),
     /* 229301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229305 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229307 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229309 */     GIR_RootConstrainSelectedInstOperands,
     /* 229310 */     // GIR_Coverage, 11334,
     /* 229310 */     GIR_EraseRootFromParent_Done,
     /* 229311 */   // Label 4587: @229311
     /* 229311 */   GIM_Try, /*On fail goto*//*Label 4588*/ GIMT_Encode4(229353), // Rule ID 11335 //
     /* 229316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 229324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 229330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 229333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229340 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1756:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_D),
     /* 229343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229347 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229349 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229351 */     GIR_RootConstrainSelectedInstOperands,
     /* 229352 */     // GIR_Coverage, 11335,
     /* 229352 */     GIR_EraseRootFromParent_Done,
     /* 229353 */   // Label 4588: @229353
     /* 229353 */   GIM_Try, /*On fail goto*//*Label 4589*/ GIMT_Encode4(229395), // Rule ID 11336 //
     /* 229358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 229366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 229372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 229375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 229378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229382 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1949:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 229382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_B),
     /* 229385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229391 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229393 */     GIR_RootConstrainSelectedInstOperands,
     /* 229394 */     // GIR_Coverage, 11336,
     /* 229394 */     GIR_EraseRootFromParent_Done,
     /* 229395 */   // Label 4589: @229395
     /* 229395 */   GIM_Try, /*On fail goto*//*Label 4590*/ GIMT_Encode4(229437), // Rule ID 11337 //
     /* 229400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 229408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 229414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229424 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1949:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 229424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_H),
     /* 229427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229429 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229431 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229433 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229435 */     GIR_RootConstrainSelectedInstOperands,
     /* 229436 */     // GIR_Coverage, 11337,
     /* 229436 */     GIR_EraseRootFromParent_Done,
     /* 229437 */   // Label 4590: @229437
     /* 229437 */   GIM_Try, /*On fail goto*//*Label 4591*/ GIMT_Encode4(229479), // Rule ID 11338 //
     /* 229442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 229450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 229456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229466 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1949:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 229466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_S),
     /* 229469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229473 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229475 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229477 */     GIR_RootConstrainSelectedInstOperands,
     /* 229478 */     // GIR_Coverage, 11338,
     /* 229478 */     GIR_EraseRootFromParent_Done,
     /* 229479 */   // Label 4591: @229479
     /* 229479 */   GIM_Try, /*On fail goto*//*Label 4592*/ GIMT_Encode4(229521), // Rule ID 11339 //
     /* 229484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 229492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 229498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 229501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229508 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1949:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_D),
     /* 229511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229515 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229517 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229519 */     GIR_RootConstrainSelectedInstOperands,
     /* 229520 */     // GIR_Coverage, 11339,
     /* 229520 */     GIR_EraseRootFromParent_Done,
     /* 229521 */   // Label 4592: @229521
     /* 229521 */   GIM_Try, /*On fail goto*//*Label 4593*/ GIMT_Encode4(229563), // Rule ID 11340 //
     /* 229526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 229534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 229540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 229543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 229546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229550 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1763:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 229550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_B),
     /* 229553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229557 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229559 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229561 */     GIR_RootConstrainSelectedInstOperands,
     /* 229562 */     // GIR_Coverage, 11340,
     /* 229562 */     GIR_EraseRootFromParent_Done,
     /* 229563 */   // Label 4593: @229563
     /* 229563 */   GIM_Try, /*On fail goto*//*Label 4594*/ GIMT_Encode4(229605), // Rule ID 11341 //
     /* 229568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 229576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 229582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229592 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1763:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 229592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_H),
     /* 229595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229599 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229601 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229603 */     GIR_RootConstrainSelectedInstOperands,
     /* 229604 */     // GIR_Coverage, 11341,
     /* 229604 */     GIR_EraseRootFromParent_Done,
     /* 229605 */   // Label 4594: @229605
     /* 229605 */   GIM_Try, /*On fail goto*//*Label 4595*/ GIMT_Encode4(229647), // Rule ID 11342 //
     /* 229610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 229618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 229624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229634 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1763:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 229634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_S),
     /* 229637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229641 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229643 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229645 */     GIR_RootConstrainSelectedInstOperands,
     /* 229646 */     // GIR_Coverage, 11342,
     /* 229646 */     GIR_EraseRootFromParent_Done,
     /* 229647 */   // Label 4595: @229647
     /* 229647 */   GIM_Try, /*On fail goto*//*Label 4596*/ GIMT_Encode4(229689), // Rule ID 11343 //
     /* 229652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 229660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 229666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 229669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229676 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1763:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_D),
     /* 229679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229683 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229685 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229687 */     GIR_RootConstrainSelectedInstOperands,
     /* 229688 */     // GIR_Coverage, 11343,
     /* 229688 */     GIR_EraseRootFromParent_Done,
     /* 229689 */   // Label 4596: @229689
     /* 229689 */   GIM_Try, /*On fail goto*//*Label 4597*/ GIMT_Encode4(229731), // Rule ID 11344 //
     /* 229694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 229702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 229708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 229711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 229714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229718 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1954:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (URSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 229718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_B),
     /* 229721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229725 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229727 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229729 */     GIR_RootConstrainSelectedInstOperands,
     /* 229730 */     // GIR_Coverage, 11344,
     /* 229730 */     GIR_EraseRootFromParent_Done,
     /* 229731 */   // Label 4597: @229731
     /* 229731 */   GIM_Try, /*On fail goto*//*Label 4598*/ GIMT_Encode4(229773), // Rule ID 11345 //
     /* 229736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 229744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 229750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229760 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1954:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (URSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 229760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_H),
     /* 229763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229767 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229769 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229771 */     GIR_RootConstrainSelectedInstOperands,
     /* 229772 */     // GIR_Coverage, 11345,
     /* 229772 */     GIR_EraseRootFromParent_Done,
     /* 229773 */   // Label 4598: @229773
     /* 229773 */   GIM_Try, /*On fail goto*//*Label 4599*/ GIMT_Encode4(229815), // Rule ID 11346 //
     /* 229778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 229786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 229792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229802 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1954:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 229802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_S),
     /* 229805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229809 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229811 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229813 */     GIR_RootConstrainSelectedInstOperands,
     /* 229814 */     // GIR_Coverage, 11346,
     /* 229814 */     GIR_EraseRootFromParent_Done,
     /* 229815 */   // Label 4599: @229815
     /* 229815 */   GIM_Try, /*On fail goto*//*Label 4600*/ GIMT_Encode4(229857), // Rule ID 11347 //
     /* 229820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 229828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 229834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 229837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229844 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1954:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (URSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_D),
     /* 229847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229851 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229853 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229855 */     GIR_RootConstrainSelectedInstOperands,
     /* 229856 */     // GIR_Coverage, 11347,
     /* 229856 */     GIR_EraseRootFromParent_Done,
     /* 229857 */   // Label 4600: @229857
     /* 229857 */   GIM_Try, /*On fail goto*//*Label 4601*/ GIMT_Encode4(229899), // Rule ID 11348 //
     /* 229862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 229870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 229876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 229879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 229882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229886 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1747:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 229886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_B),
     /* 229889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229893 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229895 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229897 */     GIR_RootConstrainSelectedInstOperands,
     /* 229898 */     // GIR_Coverage, 11348,
     /* 229898 */     GIR_EraseRootFromParent_Done,
     /* 229899 */   // Label 4601: @229899
     /* 229899 */   GIM_Try, /*On fail goto*//*Label 4602*/ GIMT_Encode4(229941), // Rule ID 11349 //
     /* 229904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 229912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 229918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229928 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1747:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 229928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_H),
     /* 229931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229935 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229937 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229939 */     GIR_RootConstrainSelectedInstOperands,
     /* 229940 */     // GIR_Coverage, 11349,
     /* 229940 */     GIR_EraseRootFromParent_Done,
     /* 229941 */   // Label 4602: @229941
     /* 229941 */   GIM_Try, /*On fail goto*//*Label 4603*/ GIMT_Encode4(229983), // Rule ID 11350 //
     /* 229946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 229954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 229960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229970 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1747:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 229970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_S),
     /* 229973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229975 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229977 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229979 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229981 */     GIR_RootConstrainSelectedInstOperands,
     /* 229982 */     // GIR_Coverage, 11350,
     /* 229982 */     GIR_EraseRootFromParent_Done,
     /* 229983 */   // Label 4603: @229983
     /* 229983 */   GIM_Try, /*On fail goto*//*Label 4604*/ GIMT_Encode4(230025), // Rule ID 11351 //
     /* 229988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 229996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 230002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 230005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230012 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1747:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_D),
     /* 230015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230021 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230023 */     GIR_RootConstrainSelectedInstOperands,
     /* 230024 */     // GIR_Coverage, 11351,
     /* 230024 */     GIR_EraseRootFromParent_Done,
     /* 230025 */   // Label 4604: @230025
     /* 230025 */   GIM_Try, /*On fail goto*//*Label 4605*/ GIMT_Encode4(230067), // Rule ID 11352 //
     /* 230030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 230038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 230041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 230044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230054 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1943:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_B),
     /* 230057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230059 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230061 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230063 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230065 */     GIR_RootConstrainSelectedInstOperands,
     /* 230066 */     // GIR_Coverage, 11352,
     /* 230066 */     GIR_EraseRootFromParent_Done,
     /* 230067 */   // Label 4605: @230067
     /* 230067 */   GIM_Try, /*On fail goto*//*Label 4606*/ GIMT_Encode4(230109), // Rule ID 11353 //
     /* 230072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 230080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 230086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230096 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1943:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 230096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_H),
     /* 230099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230103 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230105 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230107 */     GIR_RootConstrainSelectedInstOperands,
     /* 230108 */     // GIR_Coverage, 11353,
     /* 230108 */     GIR_EraseRootFromParent_Done,
     /* 230109 */   // Label 4606: @230109
     /* 230109 */   GIM_Try, /*On fail goto*//*Label 4607*/ GIMT_Encode4(230151), // Rule ID 11354 //
     /* 230114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 230122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 230128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230138 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1943:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 230138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_S),
     /* 230141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230145 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230147 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230149 */     GIR_RootConstrainSelectedInstOperands,
     /* 230150 */     // GIR_Coverage, 11354,
     /* 230150 */     GIR_EraseRootFromParent_Done,
     /* 230151 */   // Label 4607: @230151
     /* 230151 */   GIM_Try, /*On fail goto*//*Label 4608*/ GIMT_Encode4(230193), // Rule ID 11355 //
     /* 230156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 230164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 230170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 230173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230180 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1943:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_D),
     /* 230183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230187 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230189 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230191 */     GIR_RootConstrainSelectedInstOperands,
     /* 230192 */     // GIR_Coverage, 11355,
     /* 230192 */     GIR_EraseRootFromParent_Done,
     /* 230193 */   // Label 4608: @230193
     /* 230193 */   GIM_Try, /*On fail goto*//*Label 4609*/ GIMT_Encode4(230235), // Rule ID 11356 //
     /* 230198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 230206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 230209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 230212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230222 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1734:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_B),
     /* 230225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230229 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230231 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230233 */     GIR_RootConstrainSelectedInstOperands,
     /* 230234 */     // GIR_Coverage, 11356,
     /* 230234 */     GIR_EraseRootFromParent_Done,
     /* 230235 */   // Label 4609: @230235
     /* 230235 */   GIM_Try, /*On fail goto*//*Label 4610*/ GIMT_Encode4(230277), // Rule ID 11357 //
     /* 230240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 230248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 230254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230264 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1734:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 230264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_H),
     /* 230267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230271 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230273 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230275 */     GIR_RootConstrainSelectedInstOperands,
     /* 230276 */     // GIR_Coverage, 11357,
     /* 230276 */     GIR_EraseRootFromParent_Done,
     /* 230277 */   // Label 4610: @230277
     /* 230277 */   GIM_Try, /*On fail goto*//*Label 4611*/ GIMT_Encode4(230319), // Rule ID 11358 //
     /* 230282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 230290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 230296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230306 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1734:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 230306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_S),
     /* 230309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230313 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230315 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230317 */     GIR_RootConstrainSelectedInstOperands,
     /* 230318 */     // GIR_Coverage, 11358,
     /* 230318 */     GIR_EraseRootFromParent_Done,
     /* 230319 */   // Label 4611: @230319
     /* 230319 */   GIM_Try, /*On fail goto*//*Label 4612*/ GIMT_Encode4(230361), // Rule ID 11359 //
     /* 230324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 230332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 230338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 230341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230348 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1734:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_D),
     /* 230351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230355 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230357 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230359 */     GIR_RootConstrainSelectedInstOperands,
     /* 230360 */     // GIR_Coverage, 11359,
     /* 230360 */     GIR_EraseRootFromParent_Done,
     /* 230361 */   // Label 4612: @230361
     /* 230361 */   GIM_Try, /*On fail goto*//*Label 4613*/ GIMT_Encode4(230403), // Rule ID 11360 //
     /* 230366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 230374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 230377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 230380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230390 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1936:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_B),
     /* 230393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230397 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230399 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230401 */     GIR_RootConstrainSelectedInstOperands,
     /* 230402 */     // GIR_Coverage, 11360,
     /* 230402 */     GIR_EraseRootFromParent_Done,
     /* 230403 */   // Label 4613: @230403
     /* 230403 */   GIM_Try, /*On fail goto*//*Label 4614*/ GIMT_Encode4(230445), // Rule ID 11361 //
     /* 230408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 230416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 230422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230432 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1936:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 230432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_H),
     /* 230435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230439 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230441 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230443 */     GIR_RootConstrainSelectedInstOperands,
     /* 230444 */     // GIR_Coverage, 11361,
     /* 230444 */     GIR_EraseRootFromParent_Done,
     /* 230445 */   // Label 4614: @230445
     /* 230445 */   GIM_Try, /*On fail goto*//*Label 4615*/ GIMT_Encode4(230487), // Rule ID 11362 //
     /* 230450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 230458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 230464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230474 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1936:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 230474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_S),
     /* 230477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230481 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230483 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230485 */     GIR_RootConstrainSelectedInstOperands,
     /* 230486 */     // GIR_Coverage, 11362,
     /* 230486 */     GIR_EraseRootFromParent_Done,
     /* 230487 */   // Label 4615: @230487
     /* 230487 */   GIM_Try, /*On fail goto*//*Label 4616*/ GIMT_Encode4(230529), // Rule ID 11363 //
     /* 230492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 230500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 230506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 230509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230516 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1936:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_D),
     /* 230519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230525 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230527 */     GIR_RootConstrainSelectedInstOperands,
     /* 230528 */     // GIR_Coverage, 11363,
     /* 230528 */     GIR_EraseRootFromParent_Done,
     /* 230529 */   // Label 4616: @230529
     /* 230529 */   GIM_Try, /*On fail goto*//*Label 4617*/ GIMT_Encode4(230571), // Rule ID 11526 //
     /* 230534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 230542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 230545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 230548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230558 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1836:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABA_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_B),
     /* 230561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230565 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230567 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230569 */     GIR_RootConstrainSelectedInstOperands,
     /* 230570 */     // GIR_Coverage, 11526,
     /* 230570 */     GIR_EraseRootFromParent_Done,
     /* 230571 */   // Label 4617: @230571
     /* 230571 */   GIM_Try, /*On fail goto*//*Label 4618*/ GIMT_Encode4(230613), // Rule ID 11528 //
     /* 230576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 230584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230600 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1836:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABA_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 230600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_H),
     /* 230603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230607 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230609 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230611 */     GIR_RootConstrainSelectedInstOperands,
     /* 230612 */     // GIR_Coverage, 11528,
     /* 230612 */     GIR_EraseRootFromParent_Done,
     /* 230613 */   // Label 4618: @230613
     /* 230613 */   GIM_Try, /*On fail goto*//*Label 4619*/ GIMT_Encode4(230655), // Rule ID 11530 //
     /* 230618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 230626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230642 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1836:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABA_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 230642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_S),
     /* 230645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230651 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230653 */     GIR_RootConstrainSelectedInstOperands,
     /* 230654 */     // GIR_Coverage, 11530,
     /* 230654 */     GIR_EraseRootFromParent_Done,
     /* 230655 */   // Label 4619: @230655
     /* 230655 */   GIM_Try, /*On fail goto*//*Label 4620*/ GIMT_Encode4(230697), // Rule ID 11532 //
     /* 230660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 230668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 230677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230684 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1836:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UABA_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_D),
     /* 230687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230691 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230693 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230695 */     GIR_RootConstrainSelectedInstOperands,
     /* 230696 */     // GIR_Coverage, 11532,
     /* 230696 */     GIR_EraseRootFromParent_Done,
     /* 230697 */   // Label 4620: @230697
     /* 230697 */   GIM_Try, /*On fail goto*//*Label 4621*/ GIMT_Encode4(230739), // Rule ID 11534 //
     /* 230702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
     /* 230710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230726 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1588:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_H),
     /* 230729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230733 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230735 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230737 */     GIR_RootConstrainSelectedInstOperands,
     /* 230738 */     // GIR_Coverage, 11534,
     /* 230738 */     GIR_EraseRootFromParent_Done,
     /* 230739 */   // Label 4621: @230739
     /* 230739 */   GIM_Try, /*On fail goto*//*Label 4622*/ GIMT_Encode4(230781), // Rule ID 11535 //
     /* 230744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
     /* 230752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230768 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1588:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 230768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_S),
     /* 230771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230775 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230777 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230779 */     GIR_RootConstrainSelectedInstOperands,
     /* 230780 */     // GIR_Coverage, 11535,
     /* 230780 */     GIR_EraseRootFromParent_Done,
     /* 230781 */   // Label 4622: @230781
     /* 230781 */   GIM_Try, /*On fail goto*//*Label 4623*/ GIMT_Encode4(230823), // Rule ID 11536 //
     /* 230786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
     /* 230794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230810 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1588:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 230810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_D),
     /* 230813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230815 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230817 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230819 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230821 */     GIR_RootConstrainSelectedInstOperands,
     /* 230822 */     // GIR_Coverage, 11536,
     /* 230822 */     GIR_EraseRootFromParent_Done,
     /* 230823 */   // Label 4623: @230823
     /* 230823 */   GIM_Try, /*On fail goto*//*Label 4624*/ GIMT_Encode4(230865), // Rule ID 11537 //
     /* 230828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
     /* 230836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230852 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1837:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_H),
     /* 230855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230861 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230863 */     GIR_RootConstrainSelectedInstOperands,
     /* 230864 */     // GIR_Coverage, 11537,
     /* 230864 */     GIR_EraseRootFromParent_Done,
     /* 230865 */   // Label 4624: @230865
     /* 230865 */   GIM_Try, /*On fail goto*//*Label 4625*/ GIMT_Encode4(230907), // Rule ID 11538 //
     /* 230870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
     /* 230878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230894 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1837:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 230894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_S),
     /* 230897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230899 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230901 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230903 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230905 */     GIR_RootConstrainSelectedInstOperands,
     /* 230906 */     // GIR_Coverage, 11538,
     /* 230906 */     GIR_EraseRootFromParent_Done,
     /* 230907 */   // Label 4625: @230907
     /* 230907 */   GIM_Try, /*On fail goto*//*Label 4626*/ GIMT_Encode4(230949), // Rule ID 11539 //
     /* 230912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
     /* 230920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230936 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1837:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 230936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_D),
     /* 230939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230945 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230947 */     GIR_RootConstrainSelectedInstOperands,
     /* 230948 */     // GIR_Coverage, 11539,
     /* 230948 */     GIR_EraseRootFromParent_Done,
     /* 230949 */   // Label 4626: @230949
     /* 230949 */   GIM_Try, /*On fail goto*//*Label 4627*/ GIMT_Encode4(230991), // Rule ID 11540 //
     /* 230954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
     /* 230962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230978 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1838:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_H),
     /* 230981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230985 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230987 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230989 */     GIR_RootConstrainSelectedInstOperands,
     /* 230990 */     // GIR_Coverage, 11540,
     /* 230990 */     GIR_EraseRootFromParent_Done,
     /* 230991 */   // Label 4627: @230991
     /* 230991 */   GIM_Try, /*On fail goto*//*Label 4628*/ GIMT_Encode4(231033), // Rule ID 11541 //
     /* 230996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
     /* 231004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231020 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1838:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_S),
     /* 231023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231027 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231029 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231031 */     GIR_RootConstrainSelectedInstOperands,
     /* 231032 */     // GIR_Coverage, 11541,
     /* 231032 */     GIR_EraseRootFromParent_Done,
     /* 231033 */   // Label 4628: @231033
     /* 231033 */   GIM_Try, /*On fail goto*//*Label 4629*/ GIMT_Encode4(231075), // Rule ID 11542 //
     /* 231038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
     /* 231046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231062 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1838:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_D),
     /* 231065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231069 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231071 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231073 */     GIR_RootConstrainSelectedInstOperands,
     /* 231074 */     // GIR_Coverage, 11542,
     /* 231074 */     GIR_EraseRootFromParent_Done,
     /* 231075 */   // Label 4629: @231075
     /* 231075 */   GIM_Try, /*On fail goto*//*Label 4630*/ GIMT_Encode4(231117), // Rule ID 11543 //
     /* 231080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclt),
     /* 231088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231104 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1151:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADCLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLT_ZZZ_S),
     /* 231107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231111 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231113 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231115 */     GIR_RootConstrainSelectedInstOperands,
     /* 231116 */     // GIR_Coverage, 11543,
     /* 231116 */     GIR_EraseRootFromParent_Done,
     /* 231117 */   // Label 4630: @231117
     /* 231117 */   GIM_Try, /*On fail goto*//*Label 4631*/ GIMT_Encode4(231159), // Rule ID 11544 //
     /* 231122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclt),
     /* 231130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 231139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 231142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231146 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1151:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADCLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 231146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLT_ZZZ_D),
     /* 231149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231153 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231155 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231157 */     GIR_RootConstrainSelectedInstOperands,
     /* 231158 */     // GIR_Coverage, 11544,
     /* 231158 */     GIR_EraseRootFromParent_Done,
     /* 231159 */   // Label 4631: @231159
     /* 231159 */   GIM_Try, /*On fail goto*//*Label 4632*/ GIMT_Encode4(231201), // Rule ID 11545 //
     /* 231164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclb),
     /* 231172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231188 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1600:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SBCLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLB_ZZZ_S),
     /* 231191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231195 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231197 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231199 */     GIR_RootConstrainSelectedInstOperands,
     /* 231200 */     // GIR_Coverage, 11545,
     /* 231200 */     GIR_EraseRootFromParent_Done,
     /* 231201 */   // Label 4632: @231201
     /* 231201 */   GIM_Try, /*On fail goto*//*Label 4633*/ GIMT_Encode4(231243), // Rule ID 11546 //
     /* 231206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclb),
     /* 231214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 231223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 231226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231230 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1600:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SBCLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 231230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLB_ZZZ_D),
     /* 231233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231235 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231237 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231239 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231241 */     GIR_RootConstrainSelectedInstOperands,
     /* 231242 */     // GIR_Coverage, 11546,
     /* 231242 */     GIR_EraseRootFromParent_Done,
     /* 231243 */   // Label 4633: @231243
     /* 231243 */   GIM_Try, /*On fail goto*//*Label 4634*/ GIMT_Encode4(231285), // Rule ID 11547 //
     /* 231248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclt),
     /* 231256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231272 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1601:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SBCLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLT_ZZZ_S),
     /* 231275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231279 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231281 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231283 */     GIR_RootConstrainSelectedInstOperands,
     /* 231284 */     // GIR_Coverage, 11547,
     /* 231284 */     GIR_EraseRootFromParent_Done,
     /* 231285 */   // Label 4634: @231285
     /* 231285 */   GIM_Try, /*On fail goto*//*Label 4635*/ GIMT_Encode4(231327), // Rule ID 11548 //
     /* 231290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclt),
     /* 231298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 231307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 231310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231314 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1601:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SBCLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 231314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLT_ZZZ_D),
     /* 231317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231319 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231321 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231323 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231325 */     GIR_RootConstrainSelectedInstOperands,
     /* 231326 */     // GIR_Coverage, 11548,
     /* 231326 */     GIR_EraseRootFromParent_Done,
     /* 231327 */   // Label 4635: @231327
     /* 231327 */   GIM_Try, /*On fail goto*//*Label 4636*/ GIMT_Encode4(231369), // Rule ID 11603 //
     /* 231332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
     /* 231340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 231343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 231346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231356 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1569:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (RADDHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_B),
     /* 231359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231363 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231365 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231367 */     GIR_RootConstrainSelectedInstOperands,
     /* 231368 */     // GIR_Coverage, 11603,
     /* 231368 */     GIR_EraseRootFromParent_Done,
     /* 231369 */   // Label 4636: @231369
     /* 231369 */   GIM_Try, /*On fail goto*//*Label 4637*/ GIMT_Encode4(231411), // Rule ID 11604 //
     /* 231374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
     /* 231382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231398 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1569:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (RADDHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_H),
     /* 231401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231405 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231407 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231409 */     GIR_RootConstrainSelectedInstOperands,
     /* 231410 */     // GIR_Coverage, 11604,
     /* 231410 */     GIR_EraseRootFromParent_Done,
     /* 231411 */   // Label 4637: @231411
     /* 231411 */   GIM_Try, /*On fail goto*//*Label 4638*/ GIMT_Encode4(231453), // Rule ID 11605 //
     /* 231416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
     /* 231424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 231433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 231436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231440 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1569:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (RADDHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 231440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_S),
     /* 231443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231447 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231449 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231451 */     GIR_RootConstrainSelectedInstOperands,
     /* 231452 */     // GIR_Coverage, 11605,
     /* 231452 */     GIR_EraseRootFromParent_Done,
     /* 231453 */   // Label 4638: @231453
     /* 231453 */   GIM_Try, /*On fail goto*//*Label 4639*/ GIMT_Encode4(231495), // Rule ID 11606 //
     /* 231458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
     /* 231466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 231469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 231472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231482 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1810:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUBHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_B),
     /* 231485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231489 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231491 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231493 */     GIR_RootConstrainSelectedInstOperands,
     /* 231494 */     // GIR_Coverage, 11606,
     /* 231494 */     GIR_EraseRootFromParent_Done,
     /* 231495 */   // Label 4639: @231495
     /* 231495 */   GIM_Try, /*On fail goto*//*Label 4640*/ GIMT_Encode4(231537), // Rule ID 11607 //
     /* 231500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
     /* 231508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231524 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1810:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUBHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_H),
     /* 231527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231531 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231533 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231535 */     GIR_RootConstrainSelectedInstOperands,
     /* 231536 */     // GIR_Coverage, 11607,
     /* 231536 */     GIR_EraseRootFromParent_Done,
     /* 231537 */   // Label 4640: @231537
     /* 231537 */   GIM_Try, /*On fail goto*//*Label 4641*/ GIMT_Encode4(231579), // Rule ID 11608 //
     /* 231542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
     /* 231550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 231559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 231562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231566 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1810:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUBHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 231566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_S),
     /* 231569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231573 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231575 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231577 */     GIR_RootConstrainSelectedInstOperands,
     /* 231578 */     // GIR_Coverage, 11608,
     /* 231578 */     GIR_EraseRootFromParent_Done,
     /* 231579 */   // Label 4641: @231579
     /* 231579 */   GIM_Try, /*On fail goto*//*Label 4642*/ GIMT_Encode4(231621), // Rule ID 11609 //
     /* 231584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
     /* 231592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 231595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 231598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231608 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1585:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (RSUBHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_B),
     /* 231611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231615 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231617 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231619 */     GIR_RootConstrainSelectedInstOperands,
     /* 231620 */     // GIR_Coverage, 11609,
     /* 231620 */     GIR_EraseRootFromParent_Done,
     /* 231621 */   // Label 4642: @231621
     /* 231621 */   GIM_Try, /*On fail goto*//*Label 4643*/ GIMT_Encode4(231663), // Rule ID 11610 //
     /* 231626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
     /* 231634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231650 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1585:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (RSUBHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_H),
     /* 231653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231659 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231661 */     GIR_RootConstrainSelectedInstOperands,
     /* 231662 */     // GIR_Coverage, 11610,
     /* 231662 */     GIR_EraseRootFromParent_Done,
     /* 231663 */   // Label 4643: @231663
     /* 231663 */   GIM_Try, /*On fail goto*//*Label 4644*/ GIMT_Encode4(231705), // Rule ID 11611 //
     /* 231668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
     /* 231676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 231685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 231688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231692 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1585:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (RSUBHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 231692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_S),
     /* 231695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231699 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231701 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231703 */     GIR_RootConstrainSelectedInstOperands,
     /* 231704 */     // GIR_Coverage, 11611,
     /* 231704 */     GIR_EraseRootFromParent_Done,
     /* 231705 */   // Label 4644: @231705
     /* 231705 */   GIM_Try, /*On fail goto*//*Label 4645*/ GIMT_Encode4(231750), // Rule ID 11624 //
     /* 231710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 231713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nmatch),
     /* 231718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 231721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 231724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 231734 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1520:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (NMATCH_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 231734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NMATCH_PPzZZ_B),
     /* 231737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 231739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231741 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231743 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231745 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 231748 */     GIR_RootConstrainSelectedInstOperands,
     /* 231749 */     // GIR_Coverage, 11624,
     /* 231749 */     GIR_EraseRootFromParent_Done,
     /* 231750 */   // Label 4645: @231750
     /* 231750 */   GIM_Try, /*On fail goto*//*Label 4646*/ GIMT_Encode4(231795), // Rule ID 11625 //
     /* 231755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 231758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nmatch),
     /* 231763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 231766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 231769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 231779 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1520:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (NMATCH_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NMATCH_PPzZZ_H),
     /* 231782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 231784 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231786 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231788 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231790 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 231793 */     GIR_RootConstrainSelectedInstOperands,
     /* 231794 */     // GIR_Coverage, 11625,
     /* 231794 */     GIR_EraseRootFromParent_Done,
     /* 231795 */   // Label 4646: @231795
     /* 231795 */   GIM_Try, /*On fail goto*//*Label 4647*/ GIMT_Encode4(231837), // Rule ID 11626 //
     /* 231800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 231808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 231811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 231814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231824 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1260:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EORTB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 231824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_B),
     /* 231827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231831 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231833 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231835 */     GIR_RootConstrainSelectedInstOperands,
     /* 231836 */     // GIR_Coverage, 11626,
     /* 231836 */     GIR_EraseRootFromParent_Done,
     /* 231837 */   // Label 4647: @231837
     /* 231837 */   GIM_Try, /*On fail goto*//*Label 4648*/ GIMT_Encode4(231879), // Rule ID 11627 //
     /* 231842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 231850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231866 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1260:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EORTB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_H),
     /* 231869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231873 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231875 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231877 */     GIR_RootConstrainSelectedInstOperands,
     /* 231878 */     // GIR_Coverage, 11627,
     /* 231878 */     GIR_EraseRootFromParent_Done,
     /* 231879 */   // Label 4648: @231879
     /* 231879 */   GIM_Try, /*On fail goto*//*Label 4649*/ GIMT_Encode4(231921), // Rule ID 11628 //
     /* 231884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 231892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231908 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1260:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EORTB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_S),
     /* 231911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231915 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231917 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231919 */     GIR_RootConstrainSelectedInstOperands,
     /* 231920 */     // GIR_Coverage, 11628,
     /* 231920 */     GIR_EraseRootFromParent_Done,
     /* 231921 */   // Label 4649: @231921
     /* 231921 */   GIM_Try, /*On fail goto*//*Label 4650*/ GIMT_Encode4(231963), // Rule ID 11629 //
     /* 231926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 231934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 231943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 231946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231950 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1260:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EORTB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 231950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_D),
     /* 231953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231957 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231959 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231961 */     GIR_RootConstrainSelectedInstOperands,
     /* 231962 */     // GIR_Coverage, 11629,
     /* 231962 */     GIR_EraseRootFromParent_Done,
     /* 231963 */   // Label 4650: @231963
     /* 231963 */   GIM_Try, /*On fail goto*//*Label 4651*/ GIMT_Encode4(232005), // Rule ID 11645 //
     /* 231968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
     /* 231976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 231982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231992 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1343:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMAXNMP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 231992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_H),
     /* 231995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231999 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232001 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232003 */     GIR_RootConstrainSelectedInstOperands,
     /* 232004 */     // GIR_Coverage, 11645,
     /* 232004 */     GIR_EraseRootFromParent_Done,
     /* 232005 */   // Label 4651: @232005
     /* 232005 */   GIM_Try, /*On fail goto*//*Label 4652*/ GIMT_Encode4(232047), // Rule ID 11646 //
     /* 232010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
     /* 232018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 232024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232034 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1343:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMAXNMP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 232034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_S),
     /* 232037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232039 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232041 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232043 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232045 */     GIR_RootConstrainSelectedInstOperands,
     /* 232046 */     // GIR_Coverage, 11646,
     /* 232046 */     GIR_EraseRootFromParent_Done,
     /* 232047 */   // Label 4652: @232047
     /* 232047 */   GIM_Try, /*On fail goto*//*Label 4653*/ GIMT_Encode4(232089), // Rule ID 11647 //
     /* 232052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
     /* 232060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 232066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 232069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232076 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1343:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMAXNMP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 232076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_D),
     /* 232079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232083 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232085 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232087 */     GIR_RootConstrainSelectedInstOperands,
     /* 232088 */     // GIR_Coverage, 11647,
     /* 232088 */     GIR_EraseRootFromParent_Done,
     /* 232089 */   // Label 4653: @232089
     /* 232089 */   GIM_Try, /*On fail goto*//*Label 4654*/ GIMT_Encode4(232131), // Rule ID 11648 //
     /* 232094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
     /* 232102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 232108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232118 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1361:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMINNMP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 232118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_H),
     /* 232121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232123 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232125 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232127 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232129 */     GIR_RootConstrainSelectedInstOperands,
     /* 232130 */     // GIR_Coverage, 11648,
     /* 232130 */     GIR_EraseRootFromParent_Done,
     /* 232131 */   // Label 4654: @232131
     /* 232131 */   GIM_Try, /*On fail goto*//*Label 4655*/ GIMT_Encode4(232173), // Rule ID 11649 //
     /* 232136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
     /* 232144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 232150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232160 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1361:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMINNMP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 232160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_S),
     /* 232163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232167 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232169 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232171 */     GIR_RootConstrainSelectedInstOperands,
     /* 232172 */     // GIR_Coverage, 11649,
     /* 232172 */     GIR_EraseRootFromParent_Done,
     /* 232173 */   // Label 4655: @232173
     /* 232173 */   GIM_Try, /*On fail goto*//*Label 4656*/ GIMT_Encode4(232215), // Rule ID 11650 //
     /* 232178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
     /* 232186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 232192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 232195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232202 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1361:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMINNMP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 232202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_D),
     /* 232205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232207 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232209 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232211 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232213 */     GIR_RootConstrainSelectedInstOperands,
     /* 232214 */     // GIR_Coverage, 11650,
     /* 232214 */     GIR_EraseRootFromParent_Done,
     /* 232215 */   // Label 4656: @232215
     /* 232215 */   GIM_Try, /*On fail goto*//*Label 4657*/ GIMT_Encode4(232257), // Rule ID 11651 //
     /* 232220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
     /* 232228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 232234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232244 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1346:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMAXP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 232244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_H),
     /* 232247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232251 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232253 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232255 */     GIR_RootConstrainSelectedInstOperands,
     /* 232256 */     // GIR_Coverage, 11651,
     /* 232256 */     GIR_EraseRootFromParent_Done,
     /* 232257 */   // Label 4657: @232257
     /* 232257 */   GIM_Try, /*On fail goto*//*Label 4658*/ GIMT_Encode4(232299), // Rule ID 11652 //
     /* 232262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
     /* 232270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 232276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232286 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1346:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMAXP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 232286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_S),
     /* 232289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232293 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232295 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232297 */     GIR_RootConstrainSelectedInstOperands,
     /* 232298 */     // GIR_Coverage, 11652,
     /* 232298 */     GIR_EraseRootFromParent_Done,
     /* 232299 */   // Label 4658: @232299
     /* 232299 */   GIM_Try, /*On fail goto*//*Label 4659*/ GIMT_Encode4(232341), // Rule ID 11653 //
     /* 232304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
     /* 232312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 232318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 232321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232328 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1346:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMAXP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 232328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_D),
     /* 232331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232335 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232337 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232339 */     GIR_RootConstrainSelectedInstOperands,
     /* 232340 */     // GIR_Coverage, 11653,
     /* 232340 */     GIR_EraseRootFromParent_Done,
     /* 232341 */   // Label 4659: @232341
     /* 232341 */   GIM_Try, /*On fail goto*//*Label 4660*/ GIMT_Encode4(232383), // Rule ID 11654 //
     /* 232346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
     /* 232354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 232360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232370 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1364:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMINP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 232370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_H),
     /* 232373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232375 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232377 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232379 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232381 */     GIR_RootConstrainSelectedInstOperands,
     /* 232382 */     // GIR_Coverage, 11654,
     /* 232382 */     GIR_EraseRootFromParent_Done,
     /* 232383 */   // Label 4660: @232383
     /* 232383 */   GIM_Try, /*On fail goto*//*Label 4661*/ GIMT_Encode4(232425), // Rule ID 11655 //
     /* 232388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
     /* 232396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 232402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232412 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1364:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMINP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 232412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_S),
     /* 232415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232419 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232421 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232423 */     GIR_RootConstrainSelectedInstOperands,
     /* 232424 */     // GIR_Coverage, 11655,
     /* 232424 */     GIR_EraseRootFromParent_Done,
     /* 232425 */   // Label 4661: @232425
     /* 232425 */   GIM_Try, /*On fail goto*//*Label 4662*/ GIMT_Encode4(232467), // Rule ID 11656 //
     /* 232430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
     /* 232438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 232444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 232447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232454 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1364:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMINP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 232454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_D),
     /* 232457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232461 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232463 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232465 */     GIR_RootConstrainSelectedInstOperands,
     /* 232466 */     // GIR_Coverage, 11656,
     /* 232466 */     GIR_EraseRootFromParent_Done,
     /* 232467 */   // Label 4662: @232467
     /* 232467 */   GIM_Try, /*On fail goto*//*Label 4663*/ GIMT_Encode4(232509), // Rule ID 11661 //
     /* 232472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalb),
     /* 232480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 232486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232496 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1370:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLALB_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 232496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZ_SHH),
     /* 232499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232503 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232505 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232507 */     GIR_RootConstrainSelectedInstOperands,
     /* 232508 */     // GIR_Coverage, 11661,
     /* 232508 */     GIR_EraseRootFromParent_Done,
     /* 232509 */   // Label 4663: @232509
     /* 232509 */   GIM_Try, /*On fail goto*//*Label 4664*/ GIMT_Encode4(232551), // Rule ID 11662 //
     /* 232514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalt),
     /* 232522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 232528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232538 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1372:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLALT_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 232538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZ_SHH),
     /* 232541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232545 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232547 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232549 */     GIR_RootConstrainSelectedInstOperands,
     /* 232550 */     // GIR_Coverage, 11662,
     /* 232550 */     GIR_EraseRootFromParent_Done,
     /* 232551 */   // Label 4664: @232551
     /* 232551 */   GIM_Try, /*On fail goto*//*Label 4665*/ GIMT_Encode4(232593), // Rule ID 11663 //
     /* 232556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslb),
     /* 232564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 232570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232580 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1377:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLSLB_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 232580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLB_ZZZ_SHH),
     /* 232583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232587 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232589 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232591 */     GIR_RootConstrainSelectedInstOperands,
     /* 232592 */     // GIR_Coverage, 11663,
     /* 232592 */     GIR_EraseRootFromParent_Done,
     /* 232593 */   // Label 4665: @232593
     /* 232593 */   GIM_Try, /*On fail goto*//*Label 4666*/ GIMT_Encode4(232635), // Rule ID 11664 //
     /* 232598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslt),
     /* 232606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 232612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232622 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1379:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLSLT_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 232622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLT_ZZZ_SHH),
     /* 232625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232629 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232631 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232633 */     GIR_RootConstrainSelectedInstOperands,
     /* 232634 */     // GIR_Coverage, 11664,
     /* 232634 */     GIR_EraseRootFromParent_Done,
     /* 232635 */   // Label 4666: @232635
     /* 232635 */   GIM_Try, /*On fail goto*//*Label 4667*/ GIMT_Encode4(232677), // Rule ID 11665 //
     /* 232640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 232648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 232651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 232654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 232657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232664 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1177:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 232664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 232667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232671 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232673 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232675 */     GIR_RootConstrainSelectedInstOperands,
     /* 232676 */     // GIR_Coverage, 11665,
     /* 232676 */     GIR_EraseRootFromParent_Done,
     /* 232677 */   // Label 4667: @232677
     /* 232677 */   GIM_Try, /*On fail goto*//*Label 4668*/ GIMT_Encode4(232719), // Rule ID 11667 //
     /* 232682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 232690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 232696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232706 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1177:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 232706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 232709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232713 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232715 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232717 */     GIR_RootConstrainSelectedInstOperands,
     /* 232718 */     // GIR_Coverage, 11667,
     /* 232718 */     GIR_EraseRootFromParent_Done,
     /* 232719 */   // Label 4668: @232719
     /* 232719 */   GIM_Try, /*On fail goto*//*Label 4669*/ GIMT_Encode4(232761), // Rule ID 11669 //
     /* 232724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 232732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 232738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232748 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1177:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 232748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 232751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232755 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232757 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232759 */     GIR_RootConstrainSelectedInstOperands,
     /* 232760 */     // GIR_Coverage, 11669,
     /* 232760 */     GIR_EraseRootFromParent_Done,
     /* 232761 */   // Label 4669: @232761
     /* 232761 */   GIM_Try, /*On fail goto*//*Label 4670*/ GIMT_Encode4(232803), // Rule ID 11671 //
     /* 232766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 232774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 232780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 232783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232790 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1177:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 232790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 232793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232795 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232797 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232799 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232801 */     GIR_RootConstrainSelectedInstOperands,
     /* 232802 */     // GIR_Coverage, 11671,
     /* 232802 */     GIR_EraseRootFromParent_Done,
     /* 232803 */   // Label 4670: @232803
     /* 232803 */   GIM_Try, /*On fail goto*//*Label 4671*/ GIMT_Encode4(232845), // Rule ID 11673 //
     /* 232808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl),
     /* 232816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 232819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 232822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 232825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232832 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1206:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 232832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 232835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232839 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232841 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232843 */     GIR_RootConstrainSelectedInstOperands,
     /* 232844 */     // GIR_Coverage, 11673,
     /* 232844 */     GIR_EraseRootFromParent_Done,
     /* 232845 */   // Label 4671: @232845
     /* 232845 */   GIM_Try, /*On fail goto*//*Label 4672*/ GIMT_Encode4(232887), // Rule ID 11675 //
     /* 232850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl),
     /* 232858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 232864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232874 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1206:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 232874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 232877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232881 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232883 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232885 */     GIR_RootConstrainSelectedInstOperands,
     /* 232886 */     // GIR_Coverage, 11675,
     /* 232886 */     GIR_EraseRootFromParent_Done,
     /* 232887 */   // Label 4672: @232887
     /* 232887 */   GIM_Try, /*On fail goto*//*Label 4673*/ GIMT_Encode4(232929), // Rule ID 11677 //
     /* 232892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl),
     /* 232900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 232906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232916 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1206:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 232916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 232919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232923 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232925 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232927 */     GIR_RootConstrainSelectedInstOperands,
     /* 232928 */     // GIR_Coverage, 11677,
     /* 232928 */     GIR_EraseRootFromParent_Done,
     /* 232929 */   // Label 4673: @232929
     /* 232929 */   GIM_Try, /*On fail goto*//*Label 4674*/ GIMT_Encode4(232971), // Rule ID 11679 //
     /* 232934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl),
     /* 232942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 232948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 232951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232958 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1206:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 232958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 232961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232963 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232965 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232967 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232969 */     GIR_RootConstrainSelectedInstOperands,
     /* 232970 */     // GIR_Coverage, 11679,
     /* 232970 */     GIR_EraseRootFromParent_Done,
     /* 232971 */   // Label 4674: @232971
     /* 232971 */   GIM_Try, /*On fail goto*//*Label 4675*/ GIMT_Encode4(233013), // Rule ID 11681 //
     /* 232976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl1n),
     /* 232984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 232987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 232990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 232993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233000 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1207:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 233003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233007 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233009 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233011 */     GIR_RootConstrainSelectedInstOperands,
     /* 233012 */     // GIR_Coverage, 11681,
     /* 233012 */     GIR_EraseRootFromParent_Done,
     /* 233013 */   // Label 4675: @233013
     /* 233013 */   GIM_Try, /*On fail goto*//*Label 4676*/ GIMT_Encode4(233055), // Rule ID 11682 //
     /* 233018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl1n),
     /* 233026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 233032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233042 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1207:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 233045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233047 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233049 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233051 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233053 */     GIR_RootConstrainSelectedInstOperands,
     /* 233054 */     // GIR_Coverage, 11682,
     /* 233054 */     GIR_EraseRootFromParent_Done,
     /* 233055 */   // Label 4676: @233055
     /* 233055 */   GIM_Try, /*On fail goto*//*Label 4677*/ GIMT_Encode4(233097), // Rule ID 11683 //
     /* 233060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl1n),
     /* 233068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 233074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233084 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1207:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 233087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233091 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233093 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233095 */     GIR_RootConstrainSelectedInstOperands,
     /* 233096 */     // GIR_Coverage, 11683,
     /* 233096 */     GIR_EraseRootFromParent_Done,
     /* 233097 */   // Label 4677: @233097
     /* 233097 */   GIM_Try, /*On fail goto*//*Label 4678*/ GIMT_Encode4(233139), // Rule ID 11684 //
     /* 233102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl1n),
     /* 233110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 233116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 233119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 233122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233126 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1207:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 233126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 233129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233133 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233135 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233137 */     GIR_RootConstrainSelectedInstOperands,
     /* 233138 */     // GIR_Coverage, 11684,
     /* 233138 */     GIR_EraseRootFromParent_Done,
     /* 233139 */   // Label 4678: @233139
     /* 233139 */   GIM_Try, /*On fail goto*//*Label 4679*/ GIMT_Encode4(233181), // Rule ID 11685 //
     /* 233144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl2n),
     /* 233152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 233155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 233158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233168 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1208:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 233171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233175 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233177 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233179 */     GIR_RootConstrainSelectedInstOperands,
     /* 233180 */     // GIR_Coverage, 11685,
     /* 233180 */     GIR_EraseRootFromParent_Done,
     /* 233181 */   // Label 4679: @233181
     /* 233181 */   GIM_Try, /*On fail goto*//*Label 4680*/ GIMT_Encode4(233223), // Rule ID 11686 //
     /* 233186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl2n),
     /* 233194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 233200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233210 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1208:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 233213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233215 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233217 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233219 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233221 */     GIR_RootConstrainSelectedInstOperands,
     /* 233222 */     // GIR_Coverage, 11686,
     /* 233222 */     GIR_EraseRootFromParent_Done,
     /* 233223 */   // Label 4680: @233223
     /* 233223 */   GIM_Try, /*On fail goto*//*Label 4681*/ GIMT_Encode4(233265), // Rule ID 11687 //
     /* 233228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl2n),
     /* 233236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 233242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233252 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1208:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 233255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233259 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233261 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233263 */     GIR_RootConstrainSelectedInstOperands,
     /* 233264 */     // GIR_Coverage, 11687,
     /* 233264 */     GIR_EraseRootFromParent_Done,
     /* 233265 */   // Label 4681: @233265
     /* 233265 */   GIM_Try, /*On fail goto*//*Label 4682*/ GIMT_Encode4(233307), // Rule ID 11688 //
     /* 233270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl2n),
     /* 233278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 233284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 233287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 233290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233294 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1208:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 233294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 233297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233301 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233303 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233305 */     GIR_RootConstrainSelectedInstOperands,
     /* 233306 */     // GIR_Coverage, 11688,
     /* 233306 */     GIR_EraseRootFromParent_Done,
     /* 233307 */   // Label 4682: @233307
     /* 233307 */   GIM_Try, /*On fail goto*//*Label 4683*/ GIMT_Encode4(233349), // Rule ID 11689 //
     /* 233312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nbsl),
     /* 233320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 233323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 233326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233336 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1518:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /* 233339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233343 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233345 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233347 */     GIR_RootConstrainSelectedInstOperands,
     /* 233348 */     // GIR_Coverage, 11689,
     /* 233348 */     GIR_EraseRootFromParent_Done,
     /* 233349 */   // Label 4683: @233349
     /* 233349 */   GIM_Try, /*On fail goto*//*Label 4684*/ GIMT_Encode4(233391), // Rule ID 11691 //
     /* 233354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nbsl),
     /* 233362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 233368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233378 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1518:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /* 233381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233383 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233385 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233387 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233389 */     GIR_RootConstrainSelectedInstOperands,
     /* 233390 */     // GIR_Coverage, 11691,
     /* 233390 */     GIR_EraseRootFromParent_Done,
     /* 233391 */   // Label 4684: @233391
     /* 233391 */   GIM_Try, /*On fail goto*//*Label 4685*/ GIMT_Encode4(233433), // Rule ID 11693 //
     /* 233396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nbsl),
     /* 233404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 233410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233420 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1518:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /* 233423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233427 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233429 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233431 */     GIR_RootConstrainSelectedInstOperands,
     /* 233432 */     // GIR_Coverage, 11693,
     /* 233432 */     GIR_EraseRootFromParent_Done,
     /* 233433 */   // Label 4685: @233433
     /* 233433 */   GIM_Try, /*On fail goto*//*Label 4686*/ GIMT_Encode4(233475), // Rule ID 11695 //
     /* 233438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nbsl),
     /* 233446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 233452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 233455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 233458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233462 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1518:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 233462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /* 233465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233469 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233471 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233473 */     GIR_RootConstrainSelectedInstOperands,
     /* 233474 */     // GIR_Coverage, 11695,
     /* 233474 */     GIR_EraseRootFromParent_Done,
     /* 233475 */   // Label 4686: @233475
     /* 233475 */   GIM_Try, /*On fail goto*//*Label 4687*/ GIMT_Encode4(233517), // Rule ID 11784 //
     /* 233480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 233483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 233488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 233491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 233494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233504 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1849:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UCLAMP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_B),
     /* 233507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 233509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233511 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233513 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233515 */     GIR_RootConstrainSelectedInstOperands,
     /* 233516 */     // GIR_Coverage, 11784,
     /* 233516 */     GIR_EraseRootFromParent_Done,
     /* 233517 */   // Label 4687: @233517
     /* 233517 */   GIM_Try, /*On fail goto*//*Label 4688*/ GIMT_Encode4(233559), // Rule ID 11786 //
     /* 233522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 233525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 233530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 233536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233546 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1849:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UCLAMP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_H),
     /* 233549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 233551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233553 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233555 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233557 */     GIR_RootConstrainSelectedInstOperands,
     /* 233558 */     // GIR_Coverage, 11786,
     /* 233558 */     GIR_EraseRootFromParent_Done,
     /* 233559 */   // Label 4688: @233559
     /* 233559 */   GIM_Try, /*On fail goto*//*Label 4689*/ GIMT_Encode4(233601), // Rule ID 11788 //
     /* 233564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 233567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 233572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 233578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233588 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1849:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCLAMP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_S),
     /* 233591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 233593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233595 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233597 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233599 */     GIR_RootConstrainSelectedInstOperands,
     /* 233600 */     // GIR_Coverage, 11788,
     /* 233600 */     GIR_EraseRootFromParent_Done,
     /* 233601 */   // Label 4689: @233601
     /* 233601 */   GIM_Try, /*On fail goto*//*Label 4690*/ GIMT_Encode4(233643), // Rule ID 11790 //
     /* 233606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 233609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 233614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 233620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 233623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 233626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233630 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1849:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCLAMP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 233630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_D),
     /* 233633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 233635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233637 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233639 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233641 */     GIR_RootConstrainSelectedInstOperands,
     /* 233642 */     // GIR_Coverage, 11790,
     /* 233642 */     GIR_EraseRootFromParent_Done,
     /* 233643 */   // Label 4690: @233643
     /* 233643 */   GIM_Try, /*On fail goto*//*Label 4691*/ GIMT_Encode4(233685), // Rule ID 11792 //
     /* 233648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 233651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdot_x2),
     /* 233656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 233662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233672 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1327:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDOT_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 233672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZ_S),
     /* 233675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233679 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233681 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233683 */     GIR_RootConstrainSelectedInstOperands,
     /* 233684 */     // GIR_Coverage, 11792,
     /* 233684 */     GIR_EraseRootFromParent_Done,
     /* 233685 */   // Label 4691: @233685
     /* 233685 */   GIM_Try, /*On fail goto*//*Label 4692*/ GIMT_Encode4(233727), // Rule ID 11794 //
     /* 233690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 233693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_x2),
     /* 233698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 233704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233714 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1865:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UDOT_ZZZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_HtoS),
     /* 233717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233721 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233723 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233725 */     GIR_RootConstrainSelectedInstOperands,
     /* 233726 */     // GIR_Coverage, 11794,
     /* 233726 */     GIR_EraseRootFromParent_Done,
     /* 233727 */   // Label 4692: @233727
     /* 233727 */   GIM_Try, /*On fail goto*//*Label 4693*/ GIMT_Encode4(233769), // Rule ID 11957 //
     /* 233732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 233735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 233740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 233743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 233746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233756 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1825:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (TBXQ_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_B),
     /* 233759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 233761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233763 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233765 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233767 */     GIR_RootConstrainSelectedInstOperands,
     /* 233768 */     // GIR_Coverage, 11957,
     /* 233768 */     GIR_EraseRootFromParent_Done,
     /* 233769 */   // Label 4693: @233769
     /* 233769 */   GIM_Try, /*On fail goto*//*Label 4694*/ GIMT_Encode4(233811), // Rule ID 11958 //
     /* 233774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 233777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 233782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 233788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233798 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1825:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBXQ_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_H),
     /* 233801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 233803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233805 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233807 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233809 */     GIR_RootConstrainSelectedInstOperands,
     /* 233810 */     // GIR_Coverage, 11958,
     /* 233810 */     GIR_EraseRootFromParent_Done,
     /* 233811 */   // Label 4694: @233811
     /* 233811 */   GIM_Try, /*On fail goto*//*Label 4695*/ GIMT_Encode4(233853), // Rule ID 11959 //
     /* 233816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 233819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 233824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 233830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233840 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1825:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBXQ_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_S),
     /* 233843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 233845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233847 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233849 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233851 */     GIR_RootConstrainSelectedInstOperands,
     /* 233852 */     // GIR_Coverage, 11959,
     /* 233852 */     GIR_EraseRootFromParent_Done,
     /* 233853 */   // Label 4695: @233853
     /* 233853 */   GIM_Try, /*On fail goto*//*Label 4696*/ GIMT_Encode4(233895), // Rule ID 11960 //
     /* 233858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 233861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 233866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 233872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 233875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 233878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233882 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1825:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBXQ_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 233882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_D),
     /* 233885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 233887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233889 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233891 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233893 */     GIR_RootConstrainSelectedInstOperands,
     /* 233894 */     // GIR_Coverage, 11960,
     /* 233894 */     GIR_EraseRootFromParent_Done,
     /* 233895 */   // Label 4696: @233895
     /* 233895 */   GIM_Try, /*On fail goto*//*Label 4697*/ GIMT_Encode4(233937), // Rule ID 11961 //
     /* 233900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 233903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 233908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 233914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233924 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1825:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBXQ_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_H),
     /* 233927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 233929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233931 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233933 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233935 */     GIR_RootConstrainSelectedInstOperands,
     /* 233936 */     // GIR_Coverage, 11961,
     /* 233936 */     GIR_EraseRootFromParent_Done,
     /* 233937 */   // Label 4697: @233937
     /* 233937 */   GIM_Try, /*On fail goto*//*Label 4698*/ GIMT_Encode4(233979), // Rule ID 11962 //
     /* 233942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 233945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 233950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 233956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233966 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1825:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBXQ_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_S),
     /* 233969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 233971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233973 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233975 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233977 */     GIR_RootConstrainSelectedInstOperands,
     /* 233978 */     // GIR_Coverage, 11962,
     /* 233978 */     GIR_EraseRootFromParent_Done,
     /* 233979 */   // Label 4698: @233979
     /* 233979 */   GIM_Try, /*On fail goto*//*Label 4699*/ GIMT_Encode4(234021), // Rule ID 11963 //
     /* 233984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 233987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 233992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 233998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234008 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1825:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBXQ_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 234008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_D),
     /* 234011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234015 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234017 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234019 */     GIR_RootConstrainSelectedInstOperands,
     /* 234020 */     // GIR_Coverage, 11963,
     /* 234020 */     GIR_EraseRootFromParent_Done,
     /* 234021 */   // Label 4699: @234021
     /* 234021 */   GIM_Try, /*On fail goto*//*Label 4700*/ GIMT_Encode4(234063), // Rule ID 12308 //
     /* 234026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 234029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
     /* 234034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 234040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234050 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1277:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMIN_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 234050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_H),
     /* 234053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234057 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234059 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234061 */     GIR_RootConstrainSelectedInstOperands,
     /* 234062 */     // GIR_Coverage, 12308,
     /* 234062 */     GIR_EraseRootFromParent_Done,
     /* 234063 */   // Label 4700: @234063
     /* 234063 */   GIM_Try, /*On fail goto*//*Label 4701*/ GIMT_Encode4(234105), // Rule ID 12309 //
     /* 234068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 234071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
     /* 234076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234092 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1277:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMIN_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 234092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_S),
     /* 234095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234099 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234101 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234103 */     GIR_RootConstrainSelectedInstOperands,
     /* 234104 */     // GIR_Coverage, 12309,
     /* 234104 */     GIR_EraseRootFromParent_Done,
     /* 234105 */   // Label 4701: @234105
     /* 234105 */   GIM_Try, /*On fail goto*//*Label 4702*/ GIMT_Encode4(234147), // Rule ID 12310 //
     /* 234110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 234113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
     /* 234118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234134 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1277:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMIN_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 234134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_D),
     /* 234137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234141 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234143 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234145 */     GIR_RootConstrainSelectedInstOperands,
     /* 234146 */     // GIR_Coverage, 12310,
     /* 234146 */     GIR_EraseRootFromParent_Done,
     /* 234147 */   // Label 4702: @234147
     /* 234147 */   GIM_Try, /*On fail goto*//*Label 4703*/ GIMT_Encode4(234189), // Rule ID 12311 //
     /* 234152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 234155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
     /* 234160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 234166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234176 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1275:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMAX_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 234176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_H),
     /* 234179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234183 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234185 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234187 */     GIR_RootConstrainSelectedInstOperands,
     /* 234188 */     // GIR_Coverage, 12311,
     /* 234188 */     GIR_EraseRootFromParent_Done,
     /* 234189 */   // Label 4703: @234189
     /* 234189 */   GIM_Try, /*On fail goto*//*Label 4704*/ GIMT_Encode4(234231), // Rule ID 12312 //
     /* 234194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 234197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
     /* 234202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234218 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1275:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMAX_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 234218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_S),
     /* 234221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234223 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234225 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234227 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234229 */     GIR_RootConstrainSelectedInstOperands,
     /* 234230 */     // GIR_Coverage, 12312,
     /* 234230 */     GIR_EraseRootFromParent_Done,
     /* 234231 */   // Label 4704: @234231
     /* 234231 */   GIM_Try, /*On fail goto*//*Label 4705*/ GIMT_Encode4(234273), // Rule ID 12313 //
     /* 234236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 234239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
     /* 234244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234260 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1275:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMAX_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 234260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_D),
     /* 234263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234265 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234267 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234269 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234271 */     GIR_RootConstrainSelectedInstOperands,
     /* 234272 */     // GIR_Coverage, 12313,
     /* 234272 */     GIR_EraseRootFromParent_Done,
     /* 234273 */   // Label 4705: @234273
     /* 234273 */   GIM_Try, /*On fail goto*//*Label 4706*/ GIMT_Encode4(234315), // Rule ID 12314 //
     /* 234278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 234281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 234286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 234292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234302 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1276:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 234302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
     /* 234305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234309 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234311 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234313 */     GIR_RootConstrainSelectedInstOperands,
     /* 234314 */     // GIR_Coverage, 12314,
     /* 234314 */     GIR_EraseRootFromParent_Done,
     /* 234315 */   // Label 4706: @234315
     /* 234315 */   GIM_Try, /*On fail goto*//*Label 4707*/ GIMT_Encode4(234357), // Rule ID 12317 //
     /* 234320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 234323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 234328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 234331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 234337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 234340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234344 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1276:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 234344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
     /* 234347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234351 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234353 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234355 */     GIR_RootConstrainSelectedInstOperands,
     /* 234356 */     // GIR_Coverage, 12317,
     /* 234356 */     GIR_EraseRootFromParent_Done,
     /* 234357 */   // Label 4707: @234357
     /* 234357 */   GIM_Try, /*On fail goto*//*Label 4708*/ GIMT_Encode4(234399), // Rule ID 12320 //
     /* 234362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 234365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 234370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 234373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 234379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 234382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234386 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1276:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 234386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
     /* 234389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234393 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234395 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234397 */     GIR_RootConstrainSelectedInstOperands,
     /* 234398 */     // GIR_Coverage, 12320,
     /* 234398 */     GIR_EraseRootFromParent_Done,
     /* 234399 */   // Label 4708: @234399
     /* 234399 */   GIM_Try, /*On fail goto*//*Label 4709*/ GIMT_Encode4(234441), // Rule ID 12323 //
     /* 234404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 234407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 234412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234428 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1276:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMAX_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 234428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_S_UNDEF),
     /* 234431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234435 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234437 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234439 */     GIR_RootConstrainSelectedInstOperands,
     /* 234440 */     // GIR_Coverage, 12323,
     /* 234440 */     GIR_EraseRootFromParent_Done,
     /* 234441 */   // Label 4709: @234441
     /* 234441 */   GIM_Try, /*On fail goto*//*Label 4710*/ GIMT_Encode4(234483), // Rule ID 12326 //
     /* 234446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 234449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 234454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 234457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 234463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 234466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234470 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1276:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FAMAX_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 234470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_S_UNDEF),
     /* 234473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234475 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234477 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234479 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234481 */     GIR_RootConstrainSelectedInstOperands,
     /* 234482 */     // GIR_Coverage, 12326,
     /* 234482 */     GIR_EraseRootFromParent_Done,
     /* 234483 */   // Label 4710: @234483
     /* 234483 */   GIM_Try, /*On fail goto*//*Label 4711*/ GIMT_Encode4(234525), // Rule ID 12329 //
     /* 234488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 234491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 234496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234512 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1276:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMAX_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 234512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_D_UNDEF),
     /* 234515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234519 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234521 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234523 */     GIR_RootConstrainSelectedInstOperands,
     /* 234524 */     // GIR_Coverage, 12329,
     /* 234524 */     GIR_EraseRootFromParent_Done,
     /* 234525 */   // Label 4711: @234525
     /* 234525 */   GIM_Try, /*On fail goto*//*Label 4712*/ GIMT_Encode4(234567), // Rule ID 12332 //
     /* 234530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 234533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 234538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 234544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234554 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1278:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 234554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
     /* 234557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234561 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234563 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234565 */     GIR_RootConstrainSelectedInstOperands,
     /* 234566 */     // GIR_Coverage, 12332,
     /* 234566 */     GIR_EraseRootFromParent_Done,
     /* 234567 */   // Label 4712: @234567
     /* 234567 */   GIM_Try, /*On fail goto*//*Label 4713*/ GIMT_Encode4(234609), // Rule ID 12335 //
     /* 234572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 234575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 234580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 234583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 234589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 234592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234596 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1278:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 234596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
     /* 234599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234603 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234605 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234607 */     GIR_RootConstrainSelectedInstOperands,
     /* 234608 */     // GIR_Coverage, 12335,
     /* 234608 */     GIR_EraseRootFromParent_Done,
     /* 234609 */   // Label 4713: @234609
     /* 234609 */   GIM_Try, /*On fail goto*//*Label 4714*/ GIMT_Encode4(234651), // Rule ID 12338 //
     /* 234614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 234617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 234622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 234625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 234631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 234634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234638 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1278:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 234638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
     /* 234641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234645 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234647 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234649 */     GIR_RootConstrainSelectedInstOperands,
     /* 234650 */     // GIR_Coverage, 12338,
     /* 234650 */     GIR_EraseRootFromParent_Done,
     /* 234651 */   // Label 4714: @234651
     /* 234651 */   GIM_Try, /*On fail goto*//*Label 4715*/ GIMT_Encode4(234693), // Rule ID 12341 //
     /* 234656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 234659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 234664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234680 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1278:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMIN_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 234680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_S_UNDEF),
     /* 234683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234687 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234689 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234691 */     GIR_RootConstrainSelectedInstOperands,
     /* 234692 */     // GIR_Coverage, 12341,
     /* 234692 */     GIR_EraseRootFromParent_Done,
     /* 234693 */   // Label 4715: @234693
     /* 234693 */   GIM_Try, /*On fail goto*//*Label 4716*/ GIMT_Encode4(234735), // Rule ID 12344 //
     /* 234698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 234701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 234706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 234709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 234715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 234718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234722 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1278:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FAMIN_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 234722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_S_UNDEF),
     /* 234725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234729 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234731 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234733 */     GIR_RootConstrainSelectedInstOperands,
     /* 234734 */     // GIR_Coverage, 12344,
     /* 234734 */     GIR_EraseRootFromParent_Done,
     /* 234735 */   // Label 4716: @234735
     /* 234735 */   GIM_Try, /*On fail goto*//*Label 4717*/ GIMT_Encode4(234777), // Rule ID 12347 //
     /* 234740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 234743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 234748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234764 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1278:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMIN_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 234764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_D_UNDEF),
     /* 234767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234771 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234773 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234775 */     GIR_RootConstrainSelectedInstOperands,
     /* 234776 */     // GIR_Coverage, 12347,
     /* 234776 */     GIR_EraseRootFromParent_Done,
     /* 234777 */   // Label 4717: @234777
     /* 234777 */   GIM_Try, /*On fail goto*//*Label 4718*/ GIMT_Encode4(234920), // Rule ID 5518 //
     /* 234782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 234785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 234790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 234793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 234796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 234799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234803 */     // MIs[0] idx
     /* 234803 */     // No operand predicates
     /* 234803 */     // (intrinsic_wo_chain:{ *:[v16i8] } 768:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 234803 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 234806 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 234810 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 234815 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 234817 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 234820 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 234824 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 234829 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 234832 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 234836 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 234839 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234844 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234849 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234854 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 234857 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 234861 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 234866 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 234868 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 234871 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 234875 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 234880 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 234883 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 234887 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 234890 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234895 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234900 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 234908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 234910 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 234913 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 234916 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 234918 */     GIR_RootConstrainSelectedInstOperands,
     /* 234919 */     // GIR_Coverage, 5518,
     /* 234919 */     GIR_EraseRootFromParent_Done,
     /* 234920 */   // Label 4718: @234920
     /* 234920 */   GIM_Try, /*On fail goto*//*Label 4719*/ GIMT_Encode4(235011), // Rule ID 5519 //
     /* 234925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 234928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 234933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 234936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 234939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 234942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234946 */     // MIs[0] idx
     /* 234946 */     // No operand predicates
     /* 234946 */     // (intrinsic_wo_chain:{ *:[v16i8] } 769:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 234946 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 234949 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 234953 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 234958 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 234960 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 234963 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 234967 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 234972 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 234975 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 234979 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 234982 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234987 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234992 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 235000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 235002 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 235005 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 235007 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 235009 */     GIR_RootConstrainSelectedInstOperands,
     /* 235010 */     // GIR_Coverage, 5519,
     /* 235010 */     GIR_EraseRootFromParent_Done,
     /* 235011 */   // Label 4719: @235011
     /* 235011 */   GIM_Try, /*On fail goto*//*Label 4720*/ GIMT_Encode4(235102), // Rule ID 5520 //
     /* 235016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 235019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 235024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 235027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 235030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 235033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235037 */     // MIs[0] idx
     /* 235037 */     // No operand predicates
     /* 235037 */     // (intrinsic_wo_chain:{ *:[v16i8] } 768:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 235037 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 235040 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 235044 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 235049 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 235051 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 235054 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 235058 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 235063 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 235066 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 235070 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 235073 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235078 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235083 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 235088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 235091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 235093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 235095 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 235098 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 235100 */     GIR_RootConstrainSelectedInstOperands,
     /* 235101 */     // GIR_Coverage, 5520,
     /* 235101 */     GIR_EraseRootFromParent_Done,
     /* 235102 */   // Label 4720: @235102
     /* 235102 */   GIM_Try, /*On fail goto*//*Label 4721*/ GIMT_Encode4(235141), // Rule ID 5521 //
     /* 235107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 235110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 235115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 235118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 235121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 235124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235128 */     // MIs[0] idx
     /* 235128 */     // No operand predicates
     /* 235128 */     // (intrinsic_wo_chain:{ *:[v16i8] } 769:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 235128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 235131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 235133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 235135 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 235137 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 235139 */     GIR_RootConstrainSelectedInstOperands,
     /* 235140 */     // GIR_Coverage, 5521,
     /* 235140 */     GIR_EraseRootFromParent_Done,
     /* 235141 */   // Label 4721: @235141
     /* 235141 */   GIM_Try, /*On fail goto*//*Label 4722*/ GIMT_Encode4(235284), // Rule ID 5522 //
     /* 235146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 235149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 235154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 235157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 235160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 235163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235167 */     // MIs[0] idx
     /* 235167 */     // No operand predicates
     /* 235167 */     // (intrinsic_wo_chain:{ *:[v8i16] } 768:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 235167 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 235170 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 235174 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 235179 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 235181 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 235184 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 235188 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 235193 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 235196 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 235200 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 235203 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235208 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235213 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 235218 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 235221 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 235225 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 235230 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 235232 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 235235 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 235239 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 235244 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 235247 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 235251 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 235254 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235259 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235264 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 235269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 235272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 235274 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 235277 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 235280 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 235282 */     GIR_RootConstrainSelectedInstOperands,
     /* 235283 */     // GIR_Coverage, 5522,
     /* 235283 */     GIR_EraseRootFromParent_Done,
     /* 235284 */   // Label 4722: @235284
     /* 235284 */   GIM_Try, /*On fail goto*//*Label 4723*/ GIMT_Encode4(235375), // Rule ID 5523 //
     /* 235289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 235292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 235297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 235300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 235303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 235306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235310 */     // MIs[0] idx
     /* 235310 */     // No operand predicates
     /* 235310 */     // (intrinsic_wo_chain:{ *:[v8i16] } 769:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 235310 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 235313 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 235317 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 235322 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 235324 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 235327 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 235331 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 235336 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 235339 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 235343 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 235346 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235351 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235356 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 235361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 235364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 235366 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 235369 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 235371 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 235373 */     GIR_RootConstrainSelectedInstOperands,
     /* 235374 */     // GIR_Coverage, 5523,
     /* 235374 */     GIR_EraseRootFromParent_Done,
     /* 235375 */   // Label 4723: @235375
     /* 235375 */   GIM_Try, /*On fail goto*//*Label 4724*/ GIMT_Encode4(235466), // Rule ID 5524 //
     /* 235380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 235383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 235388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 235391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 235394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 235397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235401 */     // MIs[0] idx
     /* 235401 */     // No operand predicates
     /* 235401 */     // (intrinsic_wo_chain:{ *:[v8i16] } 768:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 235401 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 235404 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 235408 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 235413 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 235415 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 235418 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 235422 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 235427 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 235430 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 235434 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 235437 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235442 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235447 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 235452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 235455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 235457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 235459 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 235462 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 235464 */     GIR_RootConstrainSelectedInstOperands,
     /* 235465 */     // GIR_Coverage, 5524,
     /* 235465 */     GIR_EraseRootFromParent_Done,
     /* 235466 */   // Label 4724: @235466
     /* 235466 */   GIM_Try, /*On fail goto*//*Label 4725*/ GIMT_Encode4(235505), // Rule ID 5525 //
     /* 235471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 235474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 235479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 235482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 235485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 235488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235492 */     // MIs[0] idx
     /* 235492 */     // No operand predicates
     /* 235492 */     // (intrinsic_wo_chain:{ *:[v8i16] } 769:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 235492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 235495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 235497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 235499 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 235501 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 235503 */     GIR_RootConstrainSelectedInstOperands,
     /* 235504 */     // GIR_Coverage, 5525,
     /* 235504 */     GIR_EraseRootFromParent_Done,
     /* 235505 */   // Label 4725: @235505
     /* 235505 */   GIM_Try, /*On fail goto*//*Label 4726*/ GIMT_Encode4(235648), // Rule ID 5526 //
     /* 235510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 235513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 235518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 235521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 235524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 235527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235531 */     // MIs[0] idx
     /* 235531 */     // No operand predicates
     /* 235531 */     // (intrinsic_wo_chain:{ *:[v8f16] } 768:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 235531 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 235534 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 235538 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 235543 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 235545 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 235548 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 235552 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 235557 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 235560 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 235564 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 235567 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235572 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235577 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 235582 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 235585 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 235589 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 235594 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 235596 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 235599 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 235603 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 235608 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 235611 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 235615 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 235618 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235623 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235628 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 235633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 235636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 235638 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 235641 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 235644 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 235646 */     GIR_RootConstrainSelectedInstOperands,
     /* 235647 */     // GIR_Coverage, 5526,
     /* 235647 */     GIR_EraseRootFromParent_Done,
     /* 235648 */   // Label 4726: @235648
     /* 235648 */   GIM_Try, /*On fail goto*//*Label 4727*/ GIMT_Encode4(235739), // Rule ID 5527 //
     /* 235653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 235656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 235661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 235664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 235667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 235670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235674 */     // MIs[0] idx
     /* 235674 */     // No operand predicates
     /* 235674 */     // (intrinsic_wo_chain:{ *:[v8f16] } 769:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 235674 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 235677 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 235681 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 235686 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 235688 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 235691 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 235695 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 235700 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 235703 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 235707 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 235710 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235715 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235720 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 235725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 235728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 235730 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 235733 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 235735 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 235737 */     GIR_RootConstrainSelectedInstOperands,
     /* 235738 */     // GIR_Coverage, 5527,
     /* 235738 */     GIR_EraseRootFromParent_Done,
     /* 235739 */   // Label 4727: @235739
     /* 235739 */   GIM_Try, /*On fail goto*//*Label 4728*/ GIMT_Encode4(235830), // Rule ID 5528 //
     /* 235744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 235747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 235752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 235755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 235758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 235761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235765 */     // MIs[0] idx
     /* 235765 */     // No operand predicates
     /* 235765 */     // (intrinsic_wo_chain:{ *:[v8f16] } 768:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 235765 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 235768 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 235772 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 235777 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 235779 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 235782 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 235786 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 235791 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 235794 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 235798 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 235801 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235806 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235811 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 235816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 235819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 235821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 235823 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 235826 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 235828 */     GIR_RootConstrainSelectedInstOperands,
     /* 235829 */     // GIR_Coverage, 5528,
     /* 235829 */     GIR_EraseRootFromParent_Done,
     /* 235830 */   // Label 4728: @235830
     /* 235830 */   GIM_Try, /*On fail goto*//*Label 4729*/ GIMT_Encode4(235869), // Rule ID 5529 //
     /* 235835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 235838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 235843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 235846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 235849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 235852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235856 */     // MIs[0] idx
     /* 235856 */     // No operand predicates
     /* 235856 */     // (intrinsic_wo_chain:{ *:[v8f16] } 769:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 235856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 235859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 235861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 235863 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 235865 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 235867 */     GIR_RootConstrainSelectedInstOperands,
     /* 235868 */     // GIR_Coverage, 5529,
     /* 235868 */     GIR_EraseRootFromParent_Done,
     /* 235869 */   // Label 4729: @235869
     /* 235869 */   GIM_Try, /*On fail goto*//*Label 4730*/ GIMT_Encode4(235908), // Rule ID 5530 //
     /* 235874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 235877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti4q_laneq),
     /* 235882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 235885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 235888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 235891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235895 */     // MIs[0] idx
     /* 235895 */     // No operand predicates
     /* 235895 */     // (intrinsic_wo_chain:{ *:[v16i8] } 772:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT4_B:{ *:[v16i8] } VecListOne16b:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 235895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT4_B),
     /* 235898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 235900 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 235902 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 235904 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 235906 */     GIR_RootConstrainSelectedInstOperands,
     /* 235907 */     // GIR_Coverage, 5530,
     /* 235907 */     GIR_EraseRootFromParent_Done,
     /* 235908 */   // Label 4730: @235908
     /* 235908 */   GIM_Try, /*On fail goto*//*Label 4731*/ GIMT_Encode4(235999), // Rule ID 5531 //
     /* 235913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 235916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti4q_lane),
     /* 235921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 235924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 235927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 235930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235934 */     // MIs[0] idx
     /* 235934 */     // No operand predicates
     /* 235934 */     // (intrinsic_wo_chain:{ *:[v16i8] } 770:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT4_B:{ *:[v16i8] } VecListOne16b:{ *:[v16i8] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 235934 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 235937 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 235941 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 235946 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 235948 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 235951 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 235955 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 235960 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 235963 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 235967 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 235970 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235975 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235980 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 235985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT4_B),
     /* 235988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 235990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 235992 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 235995 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 235997 */     GIR_RootConstrainSelectedInstOperands,
     /* 235998 */     // GIR_Coverage, 5531,
     /* 235998 */     GIR_EraseRootFromParent_Done,
     /* 235999 */   // Label 4731: @235999
     /* 235999 */   GIM_Reject,
     /* 236000 */ // Label 3855: @236000
     /* 236000 */ GIM_Try, /*On fail goto*//*Label 4732*/ GIMT_Encode4(243111),
     /* 236005 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /* 236008 */   GIM_Try, /*On fail goto*//*Label 4733*/ GIMT_Encode4(236055), // Rule ID 2951 //
     /* 236013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 236016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 236021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 236024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 236027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 236036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236040 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1509:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLA_ZPZZZ_B_UNDEF:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 236040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_B_UNDEF),
     /* 236043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236047 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236049 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236051 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 236053 */     GIR_RootConstrainSelectedInstOperands,
     /* 236054 */     // GIR_Coverage, 2951,
     /* 236054 */     GIR_EraseRootFromParent_Done,
     /* 236055 */   // Label 4733: @236055
     /* 236055 */   GIM_Try, /*On fail goto*//*Label 4734*/ GIMT_Encode4(236102), // Rule ID 2953 //
     /* 236060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 236063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 236068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 236074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 236083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236087 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1509:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLA_ZPZZZ_H_UNDEF:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 236087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_H_UNDEF),
     /* 236090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236096 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236098 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 236100 */     GIR_RootConstrainSelectedInstOperands,
     /* 236101 */     // GIR_Coverage, 2953,
     /* 236101 */     GIR_EraseRootFromParent_Done,
     /* 236102 */   // Label 4734: @236102
     /* 236102 */   GIM_Try, /*On fail goto*//*Label 4735*/ GIMT_Encode4(236149), // Rule ID 2955 //
     /* 236107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 236110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 236115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 236121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 236130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236134 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1509:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLA_ZPZZZ_S_UNDEF:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 236134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_S_UNDEF),
     /* 236137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236141 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236143 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236145 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 236147 */     GIR_RootConstrainSelectedInstOperands,
     /* 236148 */     // GIR_Coverage, 2955,
     /* 236148 */     GIR_EraseRootFromParent_Done,
     /* 236149 */   // Label 4735: @236149
     /* 236149 */   GIM_Try, /*On fail goto*//*Label 4736*/ GIMT_Encode4(236196), // Rule ID 2957 //
     /* 236154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 236157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 236162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 236168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 236177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236181 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1509:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLA_ZPZZZ_D_UNDEF:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 236181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_D_UNDEF),
     /* 236184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236188 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236190 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236192 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 236194 */     GIR_RootConstrainSelectedInstOperands,
     /* 236195 */     // GIR_Coverage, 2957,
     /* 236195 */     GIR_EraseRootFromParent_Done,
     /* 236196 */   // Label 4736: @236196
     /* 236196 */   GIM_Try, /*On fail goto*//*Label 4737*/ GIMT_Encode4(236243), // Rule ID 7434 //
     /* 236201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 236204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 236209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 236212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 236215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 236224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236228 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1512:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLS_ZPZZZ_B_UNDEF:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 236228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_B_UNDEF),
     /* 236231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236235 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236237 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236239 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 236241 */     GIR_RootConstrainSelectedInstOperands,
     /* 236242 */     // GIR_Coverage, 7434,
     /* 236242 */     GIR_EraseRootFromParent_Done,
     /* 236243 */   // Label 4737: @236243
     /* 236243 */   GIM_Try, /*On fail goto*//*Label 4738*/ GIMT_Encode4(236290), // Rule ID 7436 //
     /* 236248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 236251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 236256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 236262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 236271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236275 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1512:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLS_ZPZZZ_H_UNDEF:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 236275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_H_UNDEF),
     /* 236278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236282 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236284 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236286 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 236288 */     GIR_RootConstrainSelectedInstOperands,
     /* 236289 */     // GIR_Coverage, 7436,
     /* 236289 */     GIR_EraseRootFromParent_Done,
     /* 236290 */   // Label 4738: @236290
     /* 236290 */   GIM_Try, /*On fail goto*//*Label 4739*/ GIMT_Encode4(236337), // Rule ID 7438 //
     /* 236295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 236298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 236303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 236309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 236318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236322 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1512:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLS_ZPZZZ_S_UNDEF:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 236322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_S_UNDEF),
     /* 236325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236329 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236331 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236333 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 236335 */     GIR_RootConstrainSelectedInstOperands,
     /* 236336 */     // GIR_Coverage, 7438,
     /* 236336 */     GIR_EraseRootFromParent_Done,
     /* 236337 */   // Label 4739: @236337
     /* 236337 */   GIM_Try, /*On fail goto*//*Label 4740*/ GIMT_Encode4(236384), // Rule ID 7440 //
     /* 236342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 236345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 236350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 236356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 236365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236369 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1512:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLS_ZPZZZ_D_UNDEF:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 236369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_D_UNDEF),
     /* 236372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236374 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236376 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236378 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236380 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 236382 */     GIR_RootConstrainSelectedInstOperands,
     /* 236383 */     // GIR_Coverage, 7440,
     /* 236383 */     GIR_EraseRootFromParent_Done,
     /* 236384 */   // Label 4740: @236384
     /* 236384 */   GIM_Try, /*On fail goto*//*Label 4741*/ GIMT_Encode4(236464), // Rule ID 5638 //
     /* 236389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 236394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 236397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 236400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 236403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 236406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 236409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 236421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 236425 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 236429 */     // MIs[1] Operand 1
     /* 236429 */     // No operand predicates
     /* 236429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 236437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 236441 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 236445 */     // MIs[2] Operand 1
     /* 236445 */     // No operand predicates
     /* 236445 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 236447 */     // (intrinsic_wo_chain:{ *:[v16i8] } 761:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, V128:{ *:[v16i8] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, V128:{ *:[v16i8] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2)
     /* 236447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 236450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 236452 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 236454 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 236457 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 236459 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 236462 */     GIR_RootConstrainSelectedInstOperands,
     /* 236463 */     // GIR_Coverage, 5638,
     /* 236463 */     GIR_EraseRootFromParent_Done,
     /* 236464 */   // Label 4741: @236464
     /* 236464 */   GIM_Try, /*On fail goto*//*Label 4742*/ GIMT_Encode4(236544), // Rule ID 5639 //
     /* 236469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 236474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 236477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 236480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 236483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 236486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 236489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 236501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 236505 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 236509 */     // MIs[1] Operand 1
     /* 236509 */     // No operand predicates
     /* 236509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236513 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 236517 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 236521 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 236525 */     // MIs[2] Operand 1
     /* 236525 */     // No operand predicates
     /* 236525 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 236527 */     // (intrinsic_wo_chain:{ *:[v8i16] } 761:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, V128:{ *:[v8i16] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, V128:{ *:[v8i16] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2)
     /* 236527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 236530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 236532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 236534 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 236537 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 236539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 236542 */     GIR_RootConstrainSelectedInstOperands,
     /* 236543 */     // GIR_Coverage, 5639,
     /* 236543 */     GIR_EraseRootFromParent_Done,
     /* 236544 */   // Label 4742: @236544
     /* 236544 */   GIM_Try, /*On fail goto*//*Label 4743*/ GIMT_Encode4(236624), // Rule ID 5640 //
     /* 236549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 236554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 236557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 236560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 236563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 236566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 236569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 236581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 236585 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 236589 */     // MIs[1] Operand 1
     /* 236589 */     // No operand predicates
     /* 236589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236593 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 236597 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 236601 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 236605 */     // MIs[2] Operand 1
     /* 236605 */     // No operand predicates
     /* 236605 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 236607 */     // (intrinsic_wo_chain:{ *:[v4i32] } 761:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, V128:{ *:[v4i32] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, V128:{ *:[v4i32] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2)
     /* 236607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 236610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 236612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 236614 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 236617 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 236619 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 236622 */     GIR_RootConstrainSelectedInstOperands,
     /* 236623 */     // GIR_Coverage, 5640,
     /* 236623 */     GIR_EraseRootFromParent_Done,
     /* 236624 */   // Label 4743: @236624
     /* 236624 */   GIM_Try, /*On fail goto*//*Label 4744*/ GIMT_Encode4(236704), // Rule ID 5641 //
     /* 236629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 236634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 236637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 236640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 236643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 236646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 236649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 236661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 236665 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 236669 */     // MIs[1] Operand 1
     /* 236669 */     // No operand predicates
     /* 236669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236673 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 236677 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 236681 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 236685 */     // MIs[2] Operand 1
     /* 236685 */     // No operand predicates
     /* 236685 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 236687 */     // (intrinsic_wo_chain:{ *:[v2i64] } 761:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, V128:{ *:[v2i64] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, V128:{ *:[v2i64] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2)
     /* 236687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 236690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 236692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 236694 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 236697 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 236699 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 236702 */     GIR_RootConstrainSelectedInstOperands,
     /* 236703 */     // GIR_Coverage, 5641,
     /* 236703 */     GIR_EraseRootFromParent_Done,
     /* 236704 */   // Label 4744: @236704
     /* 236704 */   GIM_Try, /*On fail goto*//*Label 4745*/ GIMT_Encode4(236768), // Rule ID 3791 //
     /* 236709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 236712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt1a),
     /* 236717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 236720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 236723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 236726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 236729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236745 */     // MIs[0] imm
     /* 236745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 236748 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 236753 */     // (intrinsic_wo_chain:{ *:[v4i32] } 537:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT1A:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 236753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT1A),
     /* 236756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 236758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 236760 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 236762 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 236764 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 236766 */     GIR_RootConstrainSelectedInstOperands,
     /* 236767 */     // GIR_Coverage, 3791,
     /* 236767 */     GIR_EraseRootFromParent_Done,
     /* 236768 */   // Label 4745: @236768
     /* 236768 */   GIM_Try, /*On fail goto*//*Label 4746*/ GIMT_Encode4(236832), // Rule ID 3792 //
     /* 236773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 236776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt1b),
     /* 236781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 236784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 236787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 236790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 236793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236809 */     // MIs[0] imm
     /* 236809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 236812 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 236817 */     // (intrinsic_wo_chain:{ *:[v4i32] } 538:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT1B:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 236817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT1B),
     /* 236820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 236822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 236824 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 236826 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 236828 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 236830 */     GIR_RootConstrainSelectedInstOperands,
     /* 236831 */     // GIR_Coverage, 3792,
     /* 236831 */     GIR_EraseRootFromParent_Done,
     /* 236832 */   // Label 4746: @236832
     /* 236832 */   GIM_Try, /*On fail goto*//*Label 4747*/ GIMT_Encode4(236896), // Rule ID 3793 //
     /* 236837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 236840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt2a),
     /* 236845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 236848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 236851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 236854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 236857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236873 */     // MIs[0] imm
     /* 236873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 236876 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 236881 */     // (intrinsic_wo_chain:{ *:[v4i32] } 539:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT2A:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 236881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT2A),
     /* 236884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 236886 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 236888 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 236890 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 236892 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 236894 */     GIR_RootConstrainSelectedInstOperands,
     /* 236895 */     // GIR_Coverage, 3793,
     /* 236895 */     GIR_EraseRootFromParent_Done,
     /* 236896 */   // Label 4747: @236896
     /* 236896 */   GIM_Try, /*On fail goto*//*Label 4748*/ GIMT_Encode4(236960), // Rule ID 3794 //
     /* 236901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 236904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt2b),
     /* 236909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 236912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 236915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 236918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 236921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236937 */     // MIs[0] imm
     /* 236937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 236940 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 236945 */     // (intrinsic_wo_chain:{ *:[v4i32] } 540:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT2B:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 236945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT2B),
     /* 236948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 236950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 236952 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 236954 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 236956 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 236958 */     GIR_RootConstrainSelectedInstOperands,
     /* 236959 */     // GIR_Coverage, 3794,
     /* 236959 */     GIR_EraseRootFromParent_Done,
     /* 236960 */   // Label 4748: @236960
     /* 236960 */   GIM_Try, /*On fail goto*//*Label 4749*/ GIMT_Encode4(237012), // Rule ID 2836 //
     /* 236965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 236968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
     /* 236973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 236979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236989 */     // MIs[0] idx
     /* 236989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 236992 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 236997 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1368:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMLA_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
     /* 236997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_H),
     /* 237000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237004 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237006 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237008 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 237010 */     GIR_RootConstrainSelectedInstOperands,
     /* 237011 */     // GIR_Coverage, 2836,
     /* 237011 */     GIR_EraseRootFromParent_Done,
     /* 237012 */   // Label 4749: @237012
     /* 237012 */   GIM_Try, /*On fail goto*//*Label 4750*/ GIMT_Encode4(237064), // Rule ID 2837 //
     /* 237017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
     /* 237025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237041 */     // MIs[0] idx
     /* 237041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 237044 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 237049 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1368:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMLA_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 237049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_S),
     /* 237052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237054 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237056 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237058 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237060 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 237062 */     GIR_RootConstrainSelectedInstOperands,
     /* 237063 */     // GIR_Coverage, 2837,
     /* 237063 */     GIR_EraseRootFromParent_Done,
     /* 237064 */   // Label 4750: @237064
     /* 237064 */   GIM_Try, /*On fail goto*//*Label 4751*/ GIMT_Encode4(237116), // Rule ID 2838 //
     /* 237069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
     /* 237077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237093 */     // MIs[0] idx
     /* 237093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 237096 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 237101 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1368:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMLA_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 237101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_D),
     /* 237104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237110 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237112 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 237114 */     GIR_RootConstrainSelectedInstOperands,
     /* 237115 */     // GIR_Coverage, 2838,
     /* 237115 */     GIR_EraseRootFromParent_Done,
     /* 237116 */   // Label 4751: @237116
     /* 237116 */   GIM_Try, /*On fail goto*//*Label 4752*/ GIMT_Encode4(237168), // Rule ID 2966 //
     /* 237121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
     /* 237129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 237135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237145 */     // MIs[0] Op4
     /* 237145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 237148 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 237153 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1508:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (MLA_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 237153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_H),
     /* 237156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237160 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237162 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237164 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 237166 */     GIR_RootConstrainSelectedInstOperands,
     /* 237167 */     // GIR_Coverage, 2966,
     /* 237167 */     GIR_EraseRootFromParent_Done,
     /* 237168 */   // Label 4752: @237168
     /* 237168 */   GIM_Try, /*On fail goto*//*Label 4753*/ GIMT_Encode4(237220), // Rule ID 2967 //
     /* 237173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
     /* 237181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237197 */     // MIs[0] Op4
     /* 237197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 237200 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 237205 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1508:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (MLA_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 237205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_S),
     /* 237208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237210 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237212 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237214 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237216 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 237218 */     GIR_RootConstrainSelectedInstOperands,
     /* 237219 */     // GIR_Coverage, 2967,
     /* 237219 */     GIR_EraseRootFromParent_Done,
     /* 237220 */   // Label 4753: @237220
     /* 237220 */   GIM_Try, /*On fail goto*//*Label 4754*/ GIMT_Encode4(237272), // Rule ID 2968 //
     /* 237225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
     /* 237233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237249 */     // MIs[0] Op4
     /* 237249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 237252 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 237257 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1508:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (MLA_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 237257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_D),
     /* 237260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237264 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237266 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237268 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 237270 */     GIR_RootConstrainSelectedInstOperands,
     /* 237271 */     // GIR_Coverage, 2968,
     /* 237271 */     GIR_EraseRootFromParent_Done,
     /* 237272 */   // Label 4754: @237272
     /* 237272 */   GIM_Try, /*On fail goto*//*Label 4755*/ GIMT_Encode4(237324), // Rule ID 2969 //
     /* 237277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb_lane),
     /* 237285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237301 */     // MIs[0] Op4
     /* 237301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 237304 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 237309 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1650:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 237309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZI_S),
     /* 237312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237314 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237316 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237318 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237320 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 237322 */     GIR_RootConstrainSelectedInstOperands,
     /* 237323 */     // GIR_Coverage, 2969,
     /* 237323 */     GIR_EraseRootFromParent_Done,
     /* 237324 */   // Label 4755: @237324
     /* 237324 */   GIM_Try, /*On fail goto*//*Label 4756*/ GIMT_Encode4(237376), // Rule ID 2970 //
     /* 237329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb_lane),
     /* 237337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237353 */     // MIs[0] Op4
     /* 237353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 237356 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 237361 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1650:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 237361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZI_D),
     /* 237364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237370 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237372 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 237374 */     GIR_RootConstrainSelectedInstOperands,
     /* 237375 */     // GIR_Coverage, 2970,
     /* 237375 */     GIR_EraseRootFromParent_Done,
     /* 237376 */   // Label 4756: @237376
     /* 237376 */   GIM_Try, /*On fail goto*//*Label 4757*/ GIMT_Encode4(237428), // Rule ID 2973 //
     /* 237381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane),
     /* 237389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237405 */     // MIs[0] Op4
     /* 237405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 237408 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 237413 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1616:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SDOT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 237413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_S),
     /* 237416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237418 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237420 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237422 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237424 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 237426 */     GIR_RootConstrainSelectedInstOperands,
     /* 237427 */     // GIR_Coverage, 2973,
     /* 237427 */     GIR_EraseRootFromParent_Done,
     /* 237428 */   // Label 4757: @237428
     /* 237428 */   GIM_Try, /*On fail goto*//*Label 4758*/ GIMT_Encode4(237480), // Rule ID 2974 //
     /* 237433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane),
     /* 237441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237457 */     // MIs[0] Op4
     /* 237457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 237460 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 237465 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1616:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SDOT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 237465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_D),
     /* 237468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237472 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237474 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237476 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 237478 */     GIR_RootConstrainSelectedInstOperands,
     /* 237479 */     // GIR_Coverage, 2974,
     /* 237479 */     GIR_EraseRootFromParent_Done,
     /* 237480 */   // Label 4758: @237480
     /* 237480 */   GIM_Try, /*On fail goto*//*Label 4759*/ GIMT_Encode4(237532), // Rule ID 3442 //
     /* 237485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE_or_SME),
     /* 237488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usdot_lane),
     /* 237493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237509 */     // MIs[0] Op4
     /* 237509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 237512 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 237517 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1963:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (USDOT_ZZZI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 237517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USDOT_ZZZI),
     /* 237520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237524 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237526 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237528 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 237530 */     GIR_RootConstrainSelectedInstOperands,
     /* 237531 */     // GIR_Coverage, 3442,
     /* 237531 */     GIR_EraseRootFromParent_Done,
     /* 237532 */   // Label 4759: @237532
     /* 237532 */   GIM_Try, /*On fail goto*//*Label 4760*/ GIMT_Encode4(237584), // Rule ID 3486 //
     /* 237537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 237540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane_x2),
     /* 237545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237561 */     // MIs[0] Op4
     /* 237561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 237564 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 237569 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1617:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SDOT_ZZZI_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 237569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_HtoS),
     /* 237572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237574 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237576 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237578 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237580 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 237582 */     GIR_RootConstrainSelectedInstOperands,
     /* 237583 */     // GIR_Coverage, 3486,
     /* 237583 */     GIR_EraseRootFromParent_Done,
     /* 237584 */   // Label 4760: @237584
     /* 237584 */   GIM_Try, /*On fail goto*//*Label 4761*/ GIMT_Encode4(237636), // Rule ID 7504 //
     /* 237589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane),
     /* 237597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237613 */     // MIs[0] Op4
     /* 237613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 237616 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 237621 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1863:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UDOT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 237621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_S),
     /* 237624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237626 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237628 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237630 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237632 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 237634 */     GIR_RootConstrainSelectedInstOperands,
     /* 237635 */     // GIR_Coverage, 7504,
     /* 237635 */     GIR_EraseRootFromParent_Done,
     /* 237636 */   // Label 4761: @237636
     /* 237636 */   GIM_Try, /*On fail goto*//*Label 4762*/ GIMT_Encode4(237688), // Rule ID 7505 //
     /* 237641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane),
     /* 237649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237665 */     // MIs[0] Op4
     /* 237665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 237668 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 237673 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1863:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (UDOT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 237673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_D),
     /* 237676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237682 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237684 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 237686 */     GIR_RootConstrainSelectedInstOperands,
     /* 237687 */     // GIR_Coverage, 7505,
     /* 237687 */     GIR_EraseRootFromParent_Done,
     /* 237688 */   // Label 4762: @237688
     /* 237688 */   GIM_Try, /*On fail goto*//*Label 4763*/ GIMT_Encode4(237740), // Rule ID 8145 //
     /* 237693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
     /* 237701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 237707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237717 */     // MIs[0] idx
     /* 237717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 237720 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 237725 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1375:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMLS_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
     /* 237725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_H),
     /* 237728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237732 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237734 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237736 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 237738 */     GIR_RootConstrainSelectedInstOperands,
     /* 237739 */     // GIR_Coverage, 8145,
     /* 237739 */     GIR_EraseRootFromParent_Done,
     /* 237740 */   // Label 4763: @237740
     /* 237740 */   GIM_Try, /*On fail goto*//*Label 4764*/ GIMT_Encode4(237792), // Rule ID 8146 //
     /* 237745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
     /* 237753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237769 */     // MIs[0] idx
     /* 237769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 237772 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 237777 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1375:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMLS_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 237777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_S),
     /* 237780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237786 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237788 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 237790 */     GIR_RootConstrainSelectedInstOperands,
     /* 237791 */     // GIR_Coverage, 8146,
     /* 237791 */     GIR_EraseRootFromParent_Done,
     /* 237792 */   // Label 4764: @237792
     /* 237792 */   GIM_Try, /*On fail goto*//*Label 4765*/ GIMT_Encode4(237844), // Rule ID 8147 //
     /* 237797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
     /* 237805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237821 */     // MIs[0] idx
     /* 237821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 237824 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 237829 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1375:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMLS_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 237829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_D),
     /* 237832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237834 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237836 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237838 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237840 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 237842 */     GIR_RootConstrainSelectedInstOperands,
     /* 237843 */     // GIR_Coverage, 8147,
     /* 237843 */     GIR_EraseRootFromParent_Done,
     /* 237844 */   // Label 4765: @237844
     /* 237844 */   GIM_Try, /*On fail goto*//*Label 4766*/ GIMT_Encode4(237896), // Rule ID 11063 //
     /* 237849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE_or_SME),
     /* 237852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sudot_lane),
     /* 237857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237873 */     // MIs[0] Op4
     /* 237873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 237876 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 237881 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1812:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SUDOT_ZZZI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 237881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUDOT_ZZZI),
     /* 237884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237886 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237888 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237890 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237892 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 237894 */     GIR_RootConstrainSelectedInstOperands,
     /* 237895 */     // GIR_Coverage, 11063,
     /* 237895 */     GIR_EraseRootFromParent_Done,
     /* 237896 */   // Label 4766: @237896
     /* 237896 */   GIM_Try, /*On fail goto*//*Label 4767*/ GIMT_Encode4(237948), // Rule ID 11110 //
     /* 237901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
     /* 237909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 237915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237925 */     // MIs[0] Op4
     /* 237925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 237928 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 237933 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1511:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (MLS_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 237933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_H),
     /* 237936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237940 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237942 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237944 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 237946 */     GIR_RootConstrainSelectedInstOperands,
     /* 237947 */     // GIR_Coverage, 11110,
     /* 237947 */     GIR_EraseRootFromParent_Done,
     /* 237948 */   // Label 4767: @237948
     /* 237948 */   GIM_Try, /*On fail goto*//*Label 4768*/ GIMT_Encode4(238000), // Rule ID 11111 //
     /* 237953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
     /* 237961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237977 */     // MIs[0] Op4
     /* 237977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 237980 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 237985 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1511:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (MLS_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 237985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_S),
     /* 237988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237992 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237994 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237996 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 237998 */     GIR_RootConstrainSelectedInstOperands,
     /* 237999 */     // GIR_Coverage, 11111,
     /* 237999 */     GIR_EraseRootFromParent_Done,
     /* 238000 */   // Label 4768: @238000
     /* 238000 */   GIM_Try, /*On fail goto*//*Label 4769*/ GIMT_Encode4(238052), // Rule ID 11112 //
     /* 238005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
     /* 238013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 238019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238029 */     // MIs[0] Op4
     /* 238029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 238032 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 238037 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1511:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (MLS_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 238037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_D),
     /* 238040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238044 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238046 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238048 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 238050 */     GIR_RootConstrainSelectedInstOperands,
     /* 238051 */     // GIR_Coverage, 11112,
     /* 238051 */     GIR_EraseRootFromParent_Done,
     /* 238052 */   // Label 4769: @238052
     /* 238052 */   GIM_Try, /*On fail goto*//*Label 4770*/ GIMT_Encode4(238104), // Rule ID 11113 //
     /* 238057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
     /* 238065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 238071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238081 */     // MIs[0] Op4
     /* 238081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 238084 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 238089 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1729:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 238089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_H),
     /* 238092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238096 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238098 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238100 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 238102 */     GIR_RootConstrainSelectedInstOperands,
     /* 238103 */     // GIR_Coverage, 11113,
     /* 238103 */     GIR_EraseRootFromParent_Done,
     /* 238104 */   // Label 4770: @238104
     /* 238104 */   GIM_Try, /*On fail goto*//*Label 4771*/ GIMT_Encode4(238156), // Rule ID 11114 //
     /* 238109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
     /* 238117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238133 */     // MIs[0] Op4
     /* 238133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 238136 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 238141 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1729:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 238141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_S),
     /* 238144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238146 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238148 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238150 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238152 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 238154 */     GIR_RootConstrainSelectedInstOperands,
     /* 238155 */     // GIR_Coverage, 11114,
     /* 238155 */     GIR_EraseRootFromParent_Done,
     /* 238156 */   // Label 4771: @238156
     /* 238156 */   GIM_Try, /*On fail goto*//*Label 4772*/ GIMT_Encode4(238208), // Rule ID 11115 //
     /* 238161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
     /* 238169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 238175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238185 */     // MIs[0] Op4
     /* 238185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 238188 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 238193 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1729:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 238193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_D),
     /* 238196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238202 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238204 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 238206 */     GIR_RootConstrainSelectedInstOperands,
     /* 238207 */     // GIR_Coverage, 11115,
     /* 238207 */     GIR_EraseRootFromParent_Done,
     /* 238208 */   // Label 4772: @238208
     /* 238208 */   GIM_Try, /*On fail goto*//*Label 4773*/ GIMT_Encode4(238260), // Rule ID 11116 //
     /* 238213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
     /* 238221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 238227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238237 */     // MIs[0] Op4
     /* 238237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 238240 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 238245 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1731:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 238245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_H),
     /* 238248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238252 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238254 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238256 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 238258 */     GIR_RootConstrainSelectedInstOperands,
     /* 238259 */     // GIR_Coverage, 11116,
     /* 238259 */     GIR_EraseRootFromParent_Done,
     /* 238260 */   // Label 4773: @238260
     /* 238260 */   GIM_Try, /*On fail goto*//*Label 4774*/ GIMT_Encode4(238312), // Rule ID 11117 //
     /* 238265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
     /* 238273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238289 */     // MIs[0] Op4
     /* 238289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 238292 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 238297 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1731:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 238297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_S),
     /* 238300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238306 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238308 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 238310 */     GIR_RootConstrainSelectedInstOperands,
     /* 238311 */     // GIR_Coverage, 11117,
     /* 238311 */     GIR_EraseRootFromParent_Done,
     /* 238312 */   // Label 4774: @238312
     /* 238312 */   GIM_Try, /*On fail goto*//*Label 4775*/ GIMT_Encode4(238364), // Rule ID 11118 //
     /* 238317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
     /* 238325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 238331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238341 */     // MIs[0] Op4
     /* 238341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 238344 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 238349 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1731:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 238349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_D),
     /* 238352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238356 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238358 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238360 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 238362 */     GIR_RootConstrainSelectedInstOperands,
     /* 238363 */     // GIR_Coverage, 11118,
     /* 238363 */     GIR_EraseRootFromParent_Done,
     /* 238364 */   // Label 4775: @238364
     /* 238364 */   GIM_Try, /*On fail goto*//*Label 4776*/ GIMT_Encode4(238416), // Rule ID 11161 //
     /* 238369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt_lane),
     /* 238377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238393 */     // MIs[0] Op4
     /* 238393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 238396 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 238401 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1652:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 238401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZI_S),
     /* 238404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238406 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238408 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238410 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238412 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 238414 */     GIR_RootConstrainSelectedInstOperands,
     /* 238415 */     // GIR_Coverage, 11161,
     /* 238415 */     GIR_EraseRootFromParent_Done,
     /* 238416 */   // Label 4776: @238416
     /* 238416 */   GIM_Try, /*On fail goto*//*Label 4777*/ GIMT_Encode4(238468), // Rule ID 11162 //
     /* 238421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt_lane),
     /* 238429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 238435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238445 */     // MIs[0] Op4
     /* 238445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 238448 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 238453 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1652:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 238453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZI_D),
     /* 238456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238458 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238460 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238462 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238464 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 238466 */     GIR_RootConstrainSelectedInstOperands,
     /* 238467 */     // GIR_Coverage, 11162,
     /* 238467 */     GIR_EraseRootFromParent_Done,
     /* 238468 */   // Label 4777: @238468
     /* 238468 */   GIM_Try, /*On fail goto*//*Label 4778*/ GIMT_Encode4(238520), // Rule ID 11163 //
     /* 238473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb_lane),
     /* 238481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238497 */     // MIs[0] Op4
     /* 238497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 238500 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 238505 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1888:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 238505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZI_S),
     /* 238508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238512 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238514 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238516 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 238518 */     GIR_RootConstrainSelectedInstOperands,
     /* 238519 */     // GIR_Coverage, 11163,
     /* 238519 */     GIR_EraseRootFromParent_Done,
     /* 238520 */   // Label 4778: @238520
     /* 238520 */   GIM_Try, /*On fail goto*//*Label 4779*/ GIMT_Encode4(238572), // Rule ID 11164 //
     /* 238525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb_lane),
     /* 238533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 238539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238549 */     // MIs[0] Op4
     /* 238549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 238552 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 238557 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1888:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 238557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZI_D),
     /* 238560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238564 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238566 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238568 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 238570 */     GIR_RootConstrainSelectedInstOperands,
     /* 238571 */     // GIR_Coverage, 11164,
     /* 238571 */     GIR_EraseRootFromParent_Done,
     /* 238572 */   // Label 4779: @238572
     /* 238572 */   GIM_Try, /*On fail goto*//*Label 4780*/ GIMT_Encode4(238624), // Rule ID 11165 //
     /* 238577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt_lane),
     /* 238585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238601 */     // MIs[0] Op4
     /* 238601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 238604 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 238609 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1890:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 238609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZI_S),
     /* 238612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238614 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238616 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238618 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238620 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 238622 */     GIR_RootConstrainSelectedInstOperands,
     /* 238623 */     // GIR_Coverage, 11165,
     /* 238623 */     GIR_EraseRootFromParent_Done,
     /* 238624 */   // Label 4780: @238624
     /* 238624 */   GIM_Try, /*On fail goto*//*Label 4781*/ GIMT_Encode4(238676), // Rule ID 11166 //
     /* 238629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt_lane),
     /* 238637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 238643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238653 */     // MIs[0] Op4
     /* 238653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 238656 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 238661 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1890:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 238661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZI_D),
     /* 238664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238668 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238670 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238672 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 238674 */     GIR_RootConstrainSelectedInstOperands,
     /* 238675 */     // GIR_Coverage, 11166,
     /* 238675 */     GIR_EraseRootFromParent_Done,
     /* 238676 */   // Label 4781: @238676
     /* 238676 */   GIM_Try, /*On fail goto*//*Label 4782*/ GIMT_Encode4(238728), // Rule ID 11167 //
     /* 238681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb_lane),
     /* 238689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238705 */     // MIs[0] Op4
     /* 238705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 238708 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 238713 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1654:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 238713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZI_S),
     /* 238716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238720 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238722 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238724 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 238726 */     GIR_RootConstrainSelectedInstOperands,
     /* 238727 */     // GIR_Coverage, 11167,
     /* 238727 */     GIR_EraseRootFromParent_Done,
     /* 238728 */   // Label 4782: @238728
     /* 238728 */   GIM_Try, /*On fail goto*//*Label 4783*/ GIMT_Encode4(238780), // Rule ID 11168 //
     /* 238733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb_lane),
     /* 238741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 238747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238757 */     // MIs[0] Op4
     /* 238757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 238760 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 238765 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1654:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 238765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZI_D),
     /* 238768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238772 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238774 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238776 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 238778 */     GIR_RootConstrainSelectedInstOperands,
     /* 238779 */     // GIR_Coverage, 11168,
     /* 238779 */     GIR_EraseRootFromParent_Done,
     /* 238780 */   // Label 4783: @238780
     /* 238780 */   GIM_Try, /*On fail goto*//*Label 4784*/ GIMT_Encode4(238832), // Rule ID 11169 //
     /* 238785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt_lane),
     /* 238793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238809 */     // MIs[0] Op4
     /* 238809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 238812 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 238817 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1656:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 238817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZI_S),
     /* 238820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238824 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238826 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238828 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 238830 */     GIR_RootConstrainSelectedInstOperands,
     /* 238831 */     // GIR_Coverage, 11169,
     /* 238831 */     GIR_EraseRootFromParent_Done,
     /* 238832 */   // Label 4784: @238832
     /* 238832 */   GIM_Try, /*On fail goto*//*Label 4785*/ GIMT_Encode4(238884), // Rule ID 11170 //
     /* 238837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt_lane),
     /* 238845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 238851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238861 */     // MIs[0] Op4
     /* 238861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 238864 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 238869 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1656:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 238869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZI_D),
     /* 238872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238876 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238878 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238880 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 238882 */     GIR_RootConstrainSelectedInstOperands,
     /* 238883 */     // GIR_Coverage, 11170,
     /* 238883 */     GIR_EraseRootFromParent_Done,
     /* 238884 */   // Label 4785: @238884
     /* 238884 */   GIM_Try, /*On fail goto*//*Label 4786*/ GIMT_Encode4(238936), // Rule ID 11171 //
     /* 238889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb_lane),
     /* 238897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238913 */     // MIs[0] Op4
     /* 238913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 238916 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 238921 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1892:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 238921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZI_S),
     /* 238924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238928 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238930 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238932 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 238934 */     GIR_RootConstrainSelectedInstOperands,
     /* 238935 */     // GIR_Coverage, 11171,
     /* 238935 */     GIR_EraseRootFromParent_Done,
     /* 238936 */   // Label 4786: @238936
     /* 238936 */   GIM_Try, /*On fail goto*//*Label 4787*/ GIMT_Encode4(238988), // Rule ID 11172 //
     /* 238941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb_lane),
     /* 238949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 238955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238965 */     // MIs[0] Op4
     /* 238965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 238968 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 238973 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1892:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 238973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZI_D),
     /* 238976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238978 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238980 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238982 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238984 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 238986 */     GIR_RootConstrainSelectedInstOperands,
     /* 238987 */     // GIR_Coverage, 11172,
     /* 238987 */     GIR_EraseRootFromParent_Done,
     /* 238988 */   // Label 4787: @238988
     /* 238988 */   GIM_Try, /*On fail goto*//*Label 4788*/ GIMT_Encode4(239040), // Rule ID 11173 //
     /* 238993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt_lane),
     /* 239001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239017 */     // MIs[0] Op4
     /* 239017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 239020 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 239025 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1894:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 239025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZI_S),
     /* 239028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239032 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239034 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239036 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 239038 */     GIR_RootConstrainSelectedInstOperands,
     /* 239039 */     // GIR_Coverage, 11173,
     /* 239039 */     GIR_EraseRootFromParent_Done,
     /* 239040 */   // Label 4788: @239040
     /* 239040 */   GIM_Try, /*On fail goto*//*Label 4789*/ GIMT_Encode4(239092), // Rule ID 11174 //
     /* 239045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt_lane),
     /* 239053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239069 */     // MIs[0] Op4
     /* 239069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 239072 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 239077 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1894:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 239077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZI_D),
     /* 239080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239084 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239086 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239088 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 239090 */     GIR_RootConstrainSelectedInstOperands,
     /* 239091 */     // GIR_Coverage, 11174,
     /* 239091 */     GIR_EraseRootFromParent_Done,
     /* 239092 */   // Label 4789: @239092
     /* 239092 */   GIM_Try, /*On fail goto*//*Label 4790*/ GIMT_Encode4(239144), // Rule ID 11196 //
     /* 239097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb_lane),
     /* 239105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239121 */     // MIs[0] Op4
     /* 239121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 239124 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 239129 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1692:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 239129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZI_S),
     /* 239132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239136 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239138 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239140 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 239142 */     GIR_RootConstrainSelectedInstOperands,
     /* 239143 */     // GIR_Coverage, 11196,
     /* 239143 */     GIR_EraseRootFromParent_Done,
     /* 239144 */   // Label 4790: @239144
     /* 239144 */   GIM_Try, /*On fail goto*//*Label 4791*/ GIMT_Encode4(239196), // Rule ID 11197 //
     /* 239149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb_lane),
     /* 239157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239173 */     // MIs[0] Op4
     /* 239173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 239176 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 239181 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1692:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 239181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZI_D),
     /* 239184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239188 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239190 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239192 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 239194 */     GIR_RootConstrainSelectedInstOperands,
     /* 239195 */     // GIR_Coverage, 11197,
     /* 239195 */     GIR_EraseRootFromParent_Done,
     /* 239196 */   // Label 4791: @239196
     /* 239196 */   GIM_Try, /*On fail goto*//*Label 4792*/ GIMT_Encode4(239248), // Rule ID 11198 //
     /* 239201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt_lane),
     /* 239209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239225 */     // MIs[0] Op4
     /* 239225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 239228 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 239233 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1695:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 239233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZI_S),
     /* 239236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239240 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239242 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239244 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 239246 */     GIR_RootConstrainSelectedInstOperands,
     /* 239247 */     // GIR_Coverage, 11198,
     /* 239247 */     GIR_EraseRootFromParent_Done,
     /* 239248 */   // Label 4792: @239248
     /* 239248 */   GIM_Try, /*On fail goto*//*Label 4793*/ GIMT_Encode4(239300), // Rule ID 11199 //
     /* 239253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt_lane),
     /* 239261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239277 */     // MIs[0] Op4
     /* 239277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 239280 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 239285 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1695:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 239285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZI_D),
     /* 239288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239292 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239294 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239296 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 239298 */     GIR_RootConstrainSelectedInstOperands,
     /* 239299 */     // GIR_Coverage, 11199,
     /* 239299 */     GIR_EraseRootFromParent_Done,
     /* 239300 */   // Label 4793: @239300
     /* 239300 */   GIM_Try, /*On fail goto*//*Label 4794*/ GIMT_Encode4(239352), // Rule ID 11200 //
     /* 239305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb_lane),
     /* 239313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239329 */     // MIs[0] Op4
     /* 239329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 239332 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 239337 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1697:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 239337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZI_S),
     /* 239340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239346 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239348 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 239350 */     GIR_RootConstrainSelectedInstOperands,
     /* 239351 */     // GIR_Coverage, 11200,
     /* 239351 */     GIR_EraseRootFromParent_Done,
     /* 239352 */   // Label 4794: @239352
     /* 239352 */   GIM_Try, /*On fail goto*//*Label 4795*/ GIMT_Encode4(239404), // Rule ID 11201 //
     /* 239357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb_lane),
     /* 239365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239381 */     // MIs[0] Op4
     /* 239381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 239384 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 239389 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1697:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 239389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZI_D),
     /* 239392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239396 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239398 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239400 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 239402 */     GIR_RootConstrainSelectedInstOperands,
     /* 239403 */     // GIR_Coverage, 11201,
     /* 239403 */     GIR_EraseRootFromParent_Done,
     /* 239404 */   // Label 4795: @239404
     /* 239404 */   GIM_Try, /*On fail goto*//*Label 4796*/ GIMT_Encode4(239456), // Rule ID 11202 //
     /* 239409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt_lane),
     /* 239417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239433 */     // MIs[0] Op4
     /* 239433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 239436 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 239441 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1700:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 239441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZI_S),
     /* 239444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239448 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239450 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239452 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 239454 */     GIR_RootConstrainSelectedInstOperands,
     /* 239455 */     // GIR_Coverage, 11202,
     /* 239455 */     GIR_EraseRootFromParent_Done,
     /* 239456 */   // Label 4796: @239456
     /* 239456 */   GIM_Try, /*On fail goto*//*Label 4797*/ GIMT_Encode4(239508), // Rule ID 11203 //
     /* 239461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt_lane),
     /* 239469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239485 */     // MIs[0] Op4
     /* 239485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 239488 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 239493 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1700:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 239493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZI_D),
     /* 239496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239500 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239502 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239504 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 239506 */     GIR_RootConstrainSelectedInstOperands,
     /* 239507 */     // GIR_Coverage, 11203,
     /* 239507 */     GIR_EraseRootFromParent_Done,
     /* 239508 */   // Label 4797: @239508
     /* 239508 */   GIM_Try, /*On fail goto*//*Label 4798*/ GIMT_Encode4(239560), // Rule ID 11657 //
     /* 239513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalb_lane),
     /* 239521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239537 */     // MIs[0] Op4
     /* 239537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 239540 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 239545 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1371:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLALB_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 239545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZI_SHH),
     /* 239548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239550 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239552 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239554 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239556 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 239558 */     GIR_RootConstrainSelectedInstOperands,
     /* 239559 */     // GIR_Coverage, 11657,
     /* 239559 */     GIR_EraseRootFromParent_Done,
     /* 239560 */   // Label 4798: @239560
     /* 239560 */   GIM_Try, /*On fail goto*//*Label 4799*/ GIMT_Encode4(239612), // Rule ID 11658 //
     /* 239565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalt_lane),
     /* 239573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239589 */     // MIs[0] Op4
     /* 239589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 239592 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 239597 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1373:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLALT_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 239597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZI_SHH),
     /* 239600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239604 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239606 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239608 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 239610 */     GIR_RootConstrainSelectedInstOperands,
     /* 239611 */     // GIR_Coverage, 11658,
     /* 239611 */     GIR_EraseRootFromParent_Done,
     /* 239612 */   // Label 4799: @239612
     /* 239612 */   GIM_Try, /*On fail goto*//*Label 4800*/ GIMT_Encode4(239664), // Rule ID 11659 //
     /* 239617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslb_lane),
     /* 239625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239641 */     // MIs[0] Op4
     /* 239641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 239644 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 239649 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1378:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLSLB_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 239649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLB_ZZZI_SHH),
     /* 239652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239656 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239658 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239660 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 239662 */     GIR_RootConstrainSelectedInstOperands,
     /* 239663 */     // GIR_Coverage, 11659,
     /* 239663 */     GIR_EraseRootFromParent_Done,
     /* 239664 */   // Label 4800: @239664
     /* 239664 */   GIM_Try, /*On fail goto*//*Label 4801*/ GIMT_Encode4(239716), // Rule ID 11660 //
     /* 239669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslt_lane),
     /* 239677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239693 */     // MIs[0] Op4
     /* 239693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 239696 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 239701 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1380:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLSLT_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 239701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLT_ZZZI_SHH),
     /* 239704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239706 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239708 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239710 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239712 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 239714 */     GIR_RootConstrainSelectedInstOperands,
     /* 239715 */     // GIR_Coverage, 11660,
     /* 239715 */     GIR_EraseRootFromParent_Done,
     /* 239716 */   // Label 4801: @239716
     /* 239716 */   GIM_Try, /*On fail goto*//*Label 4802*/ GIMT_Encode4(239768), // Rule ID 11793 //
     /* 239721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 239724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdot_lane_x2),
     /* 239729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239745 */     // MIs[0] Op4
     /* 239745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 239748 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 239753 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1326:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (FDOT_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 239753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZI_S),
     /* 239756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239760 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239762 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239764 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 239766 */     GIR_RootConstrainSelectedInstOperands,
     /* 239767 */     // GIR_Coverage, 11793,
     /* 239767 */     GIR_EraseRootFromParent_Done,
     /* 239768 */   // Label 4802: @239768
     /* 239768 */   GIM_Try, /*On fail goto*//*Label 4803*/ GIMT_Encode4(239820), // Rule ID 11795 //
     /* 239773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 239776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane_x2),
     /* 239781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239797 */     // MIs[0] Op4
     /* 239797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 239800 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 239805 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1864:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UDOT_ZZZI_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 239805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_HtoS),
     /* 239808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239812 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239814 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239816 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 239818 */     GIR_RootConstrainSelectedInstOperands,
     /* 239819 */     // GIR_Coverage, 11795,
     /* 239819 */     GIR_EraseRootFromParent_Done,
     /* 239820 */   // Label 4803: @239820
     /* 239820 */   GIM_Try, /*On fail goto*//*Label 4804*/ GIMT_Encode4(239867), // Rule ID 2815 //
     /* 239825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 239833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 239839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 239848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239852 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1367:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 239852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
     /* 239855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239861 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239863 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 239865 */     GIR_RootConstrainSelectedInstOperands,
     /* 239866 */     // GIR_Coverage, 2815,
     /* 239866 */     GIR_EraseRootFromParent_Done,
     /* 239867 */   // Label 4804: @239867
     /* 239867 */   GIM_Try, /*On fail goto*//*Label 4805*/ GIMT_Encode4(239914), // Rule ID 2818 //
     /* 239872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 239880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 239883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 239886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 239889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 239892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 239895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239899 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1367:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 239899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
     /* 239902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239908 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239910 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 239912 */     GIR_RootConstrainSelectedInstOperands,
     /* 239913 */     // GIR_Coverage, 2818,
     /* 239913 */     GIR_EraseRootFromParent_Done,
     /* 239914 */   // Label 4805: @239914
     /* 239914 */   GIM_Try, /*On fail goto*//*Label 4806*/ GIMT_Encode4(239961), // Rule ID 2821 //
     /* 239919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 239927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 239930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 239933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 239936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 239939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 239942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239946 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1367:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 239946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
     /* 239949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239953 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239955 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239957 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 239959 */     GIR_RootConstrainSelectedInstOperands,
     /* 239960 */     // GIR_Coverage, 2821,
     /* 239960 */     GIR_EraseRootFromParent_Done,
     /* 239961 */   // Label 4806: @239961
     /* 239961 */   GIM_Try, /*On fail goto*//*Label 4807*/ GIMT_Encode4(240008), // Rule ID 2824 //
     /* 239966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 239974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 239980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 239989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239993 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1367:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLA_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 239993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_S),
     /* 239996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240000 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240002 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240004 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240006 */     GIR_RootConstrainSelectedInstOperands,
     /* 240007 */     // GIR_Coverage, 2824,
     /* 240007 */     GIR_EraseRootFromParent_Done,
     /* 240008 */   // Label 4807: @240008
     /* 240008 */   GIM_Try, /*On fail goto*//*Label 4808*/ GIMT_Encode4(240055), // Rule ID 2827 //
     /* 240013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 240021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 240024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 240030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 240033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 240036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240040 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1367:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLA_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 240040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_S),
     /* 240043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240047 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240049 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240051 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240053 */     GIR_RootConstrainSelectedInstOperands,
     /* 240054 */     // GIR_Coverage, 2827,
     /* 240054 */     GIR_EraseRootFromParent_Done,
     /* 240055 */   // Label 4808: @240055
     /* 240055 */   GIM_Try, /*On fail goto*//*Label 4809*/ GIMT_Encode4(240102), // Rule ID 2830 //
     /* 240060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 240068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 240083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240087 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1367:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLA_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 240087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_D),
     /* 240090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240096 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240098 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240100 */     GIR_RootConstrainSelectedInstOperands,
     /* 240101 */     // GIR_Coverage, 2830,
     /* 240101 */     GIR_EraseRootFromParent_Done,
     /* 240102 */   // Label 4809: @240102
     /* 240102 */   GIM_Try, /*On fail goto*//*Label 4810*/ GIMT_Encode4(240149), // Rule ID 2833 //
     /* 240107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
     /* 240115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 240130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240134 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1330:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMAD_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 240134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_H),
     /* 240137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240141 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240143 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240145 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240147 */     GIR_RootConstrainSelectedInstOperands,
     /* 240148 */     // GIR_Coverage, 2833,
     /* 240148 */     GIR_EraseRootFromParent_Done,
     /* 240149 */   // Label 4810: @240149
     /* 240149 */   GIM_Try, /*On fail goto*//*Label 4811*/ GIMT_Encode4(240196), // Rule ID 2834 //
     /* 240154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
     /* 240162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 240177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240181 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1330:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMAD_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 240181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_S),
     /* 240184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240188 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240190 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240192 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240194 */     GIR_RootConstrainSelectedInstOperands,
     /* 240195 */     // GIR_Coverage, 2834,
     /* 240195 */     GIR_EraseRootFromParent_Done,
     /* 240196 */   // Label 4811: @240196
     /* 240196 */   GIM_Try, /*On fail goto*//*Label 4812*/ GIMT_Encode4(240243), // Rule ID 2835 //
     /* 240201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
     /* 240209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 240224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240228 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1330:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMAD_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 240228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_D),
     /* 240231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240235 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240237 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240239 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240241 */     GIR_RootConstrainSelectedInstOperands,
     /* 240242 */     // GIR_Coverage, 2835,
     /* 240242 */     GIR_EraseRootFromParent_Done,
     /* 240243 */   // Label 4812: @240243
     /* 240243 */   GIM_Try, /*On fail goto*//*Label 4813*/ GIMT_Encode4(240290), // Rule ID 2931 //
     /* 240248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 240256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 240259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 240262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 240265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 240268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 240271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240275 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1505:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MAD_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 240275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_B),
     /* 240278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240282 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240284 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240286 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240288 */     GIR_RootConstrainSelectedInstOperands,
     /* 240289 */     // GIR_Coverage, 2931,
     /* 240289 */     GIR_EraseRootFromParent_Done,
     /* 240290 */   // Label 4813: @240290
     /* 240290 */   GIM_Try, /*On fail goto*//*Label 4814*/ GIMT_Encode4(240337), // Rule ID 2934 //
     /* 240295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 240303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 240318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240322 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1505:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MAD_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 240322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_H),
     /* 240325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240329 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240331 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240333 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240335 */     GIR_RootConstrainSelectedInstOperands,
     /* 240336 */     // GIR_Coverage, 2934,
     /* 240336 */     GIR_EraseRootFromParent_Done,
     /* 240337 */   // Label 4814: @240337
     /* 240337 */   GIM_Try, /*On fail goto*//*Label 4815*/ GIMT_Encode4(240384), // Rule ID 2937 //
     /* 240342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 240350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 240365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240369 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1505:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MAD_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 240369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_S),
     /* 240372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240374 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240376 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240378 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240380 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240382 */     GIR_RootConstrainSelectedInstOperands,
     /* 240383 */     // GIR_Coverage, 2937,
     /* 240383 */     GIR_EraseRootFromParent_Done,
     /* 240384 */   // Label 4815: @240384
     /* 240384 */   GIM_Try, /*On fail goto*//*Label 4816*/ GIMT_Encode4(240431), // Rule ID 2940 //
     /* 240389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 240397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 240412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240416 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1505:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MAD_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 240416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_D),
     /* 240419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240423 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240425 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240427 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240429 */     GIR_RootConstrainSelectedInstOperands,
     /* 240430 */     // GIR_Coverage, 2940,
     /* 240430 */     GIR_EraseRootFromParent_Done,
     /* 240431 */   // Label 4816: @240431
     /* 240431 */   GIM_Try, /*On fail goto*//*Label 4817*/ GIMT_Encode4(240478), // Rule ID 2943 //
     /* 240436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 240444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 240447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 240450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 240453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 240456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 240459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240463 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1507:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLA_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 240463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_B),
     /* 240466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240470 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240472 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240474 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240476 */     GIR_RootConstrainSelectedInstOperands,
     /* 240477 */     // GIR_Coverage, 2943,
     /* 240477 */     GIR_EraseRootFromParent_Done,
     /* 240478 */   // Label 4817: @240478
     /* 240478 */   GIM_Try, /*On fail goto*//*Label 4818*/ GIMT_Encode4(240525), // Rule ID 2945 //
     /* 240483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 240491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 240506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240510 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1507:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLA_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 240510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_H),
     /* 240513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240515 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240517 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240519 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240521 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240523 */     GIR_RootConstrainSelectedInstOperands,
     /* 240524 */     // GIR_Coverage, 2945,
     /* 240524 */     GIR_EraseRootFromParent_Done,
     /* 240525 */   // Label 4818: @240525
     /* 240525 */   GIM_Try, /*On fail goto*//*Label 4819*/ GIMT_Encode4(240572), // Rule ID 2947 //
     /* 240530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 240538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 240553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240557 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1507:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLA_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 240557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_S),
     /* 240560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240564 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240566 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240568 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240570 */     GIR_RootConstrainSelectedInstOperands,
     /* 240571 */     // GIR_Coverage, 2947,
     /* 240571 */     GIR_EraseRootFromParent_Done,
     /* 240572 */   // Label 4819: @240572
     /* 240572 */   GIM_Try, /*On fail goto*//*Label 4820*/ GIMT_Encode4(240619), // Rule ID 2949 //
     /* 240577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 240585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 240600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240604 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1507:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLA_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 240604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_D),
     /* 240607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240611 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240613 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240615 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240617 */     GIR_RootConstrainSelectedInstOperands,
     /* 240618 */     // GIR_Coverage, 2949,
     /* 240618 */     GIR_EraseRootFromParent_Done,
     /* 240619 */   // Label 4820: @240619
     /* 240619 */   GIM_Try, /*On fail goto*//*Label 4821*/ GIMT_Encode4(240666), // Rule ID 7414 //
     /* 240624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 240632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 240635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 240638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 240641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 240644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 240647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240651 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1513:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MSB_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 240651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_B),
     /* 240654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240658 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240660 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240662 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240664 */     GIR_RootConstrainSelectedInstOperands,
     /* 240665 */     // GIR_Coverage, 7414,
     /* 240665 */     GIR_EraseRootFromParent_Done,
     /* 240666 */   // Label 4821: @240666
     /* 240666 */   GIM_Try, /*On fail goto*//*Label 4822*/ GIMT_Encode4(240713), // Rule ID 7417 //
     /* 240671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 240679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 240694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240698 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1513:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MSB_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 240698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_H),
     /* 240701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240707 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240709 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240711 */     GIR_RootConstrainSelectedInstOperands,
     /* 240712 */     // GIR_Coverage, 7417,
     /* 240712 */     GIR_EraseRootFromParent_Done,
     /* 240713 */   // Label 4822: @240713
     /* 240713 */   GIM_Try, /*On fail goto*//*Label 4823*/ GIMT_Encode4(240760), // Rule ID 7420 //
     /* 240718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 240726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 240741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240745 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1513:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MSB_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 240745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_S),
     /* 240748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240752 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240754 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240756 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240758 */     GIR_RootConstrainSelectedInstOperands,
     /* 240759 */     // GIR_Coverage, 7420,
     /* 240759 */     GIR_EraseRootFromParent_Done,
     /* 240760 */   // Label 4823: @240760
     /* 240760 */   GIM_Try, /*On fail goto*//*Label 4824*/ GIMT_Encode4(240807), // Rule ID 7423 //
     /* 240765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 240773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 240788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240792 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1513:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MSB_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 240792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_D),
     /* 240795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240799 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240801 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240803 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240805 */     GIR_RootConstrainSelectedInstOperands,
     /* 240806 */     // GIR_Coverage, 7423,
     /* 240806 */     GIR_EraseRootFromParent_Done,
     /* 240807 */   // Label 4824: @240807
     /* 240807 */   GIM_Try, /*On fail goto*//*Label 4825*/ GIMT_Encode4(240854), // Rule ID 7426 //
     /* 240812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 240820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 240823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 240826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 240829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 240832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 240835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240839 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1510:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLS_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 240839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_B),
     /* 240842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240844 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240846 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240848 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240850 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240852 */     GIR_RootConstrainSelectedInstOperands,
     /* 240853 */     // GIR_Coverage, 7426,
     /* 240853 */     GIR_EraseRootFromParent_Done,
     /* 240854 */   // Label 4825: @240854
     /* 240854 */   GIM_Try, /*On fail goto*//*Label 4826*/ GIMT_Encode4(240901), // Rule ID 7428 //
     /* 240859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 240867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 240882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240886 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1510:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLS_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 240886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_H),
     /* 240889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240893 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240895 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240897 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240899 */     GIR_RootConstrainSelectedInstOperands,
     /* 240900 */     // GIR_Coverage, 7428,
     /* 240900 */     GIR_EraseRootFromParent_Done,
     /* 240901 */   // Label 4826: @240901
     /* 240901 */   GIM_Try, /*On fail goto*//*Label 4827*/ GIMT_Encode4(240948), // Rule ID 7430 //
     /* 240906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 240914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 240929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240933 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1510:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLS_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 240933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_S),
     /* 240936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240940 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240942 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240944 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240946 */     GIR_RootConstrainSelectedInstOperands,
     /* 240947 */     // GIR_Coverage, 7430,
     /* 240947 */     GIR_EraseRootFromParent_Done,
     /* 240948 */   // Label 4827: @240948
     /* 240948 */   GIM_Try, /*On fail goto*//*Label 4828*/ GIMT_Encode4(240995), // Rule ID 7432 //
     /* 240953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 240961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 240976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240980 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1510:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLS_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 240980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_D),
     /* 240983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240987 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240989 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240991 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 240993 */     GIR_RootConstrainSelectedInstOperands,
     /* 240994 */     // GIR_Coverage, 7432,
     /* 240994 */     GIR_EraseRootFromParent_Done,
     /* 240995 */   // Label 4828: @240995
     /* 240995 */   GIM_Try, /*On fail goto*//*Label 4829*/ GIMT_Encode4(241042), // Rule ID 8058 //
     /* 241000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 241008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 241014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 241023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241027 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1374:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 241027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
     /* 241030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241032 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241034 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241036 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241038 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241040 */     GIR_RootConstrainSelectedInstOperands,
     /* 241041 */     // GIR_Coverage, 8058,
     /* 241041 */     GIR_EraseRootFromParent_Done,
     /* 241042 */   // Label 4829: @241042
     /* 241042 */   GIM_Try, /*On fail goto*//*Label 4830*/ GIMT_Encode4(241089), // Rule ID 8061 //
     /* 241047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 241055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 241058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 241064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 241067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 241070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241074 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1374:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 241074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
     /* 241077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241083 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241085 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241087 */     GIR_RootConstrainSelectedInstOperands,
     /* 241088 */     // GIR_Coverage, 8061,
     /* 241088 */     GIR_EraseRootFromParent_Done,
     /* 241089 */   // Label 4830: @241089
     /* 241089 */   GIM_Try, /*On fail goto*//*Label 4831*/ GIMT_Encode4(241136), // Rule ID 8064 //
     /* 241094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 241102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 241105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 241111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 241114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 241117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241121 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1374:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 241121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
     /* 241124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241126 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241128 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241130 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241132 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241134 */     GIR_RootConstrainSelectedInstOperands,
     /* 241135 */     // GIR_Coverage, 8064,
     /* 241135 */     GIR_EraseRootFromParent_Done,
     /* 241136 */   // Label 4831: @241136
     /* 241136 */   GIM_Try, /*On fail goto*//*Label 4832*/ GIMT_Encode4(241183), // Rule ID 8067 //
     /* 241141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 241149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 241164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241168 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1374:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLS_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 241168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_S),
     /* 241171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241175 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241177 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241179 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241181 */     GIR_RootConstrainSelectedInstOperands,
     /* 241182 */     // GIR_Coverage, 8067,
     /* 241182 */     GIR_EraseRootFromParent_Done,
     /* 241183 */   // Label 4832: @241183
     /* 241183 */   GIM_Try, /*On fail goto*//*Label 4833*/ GIMT_Encode4(241230), // Rule ID 8070 //
     /* 241188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 241196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 241199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 241205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 241208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 241211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241215 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1374:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLS_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 241215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_S),
     /* 241218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241222 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241224 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241226 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241228 */     GIR_RootConstrainSelectedInstOperands,
     /* 241229 */     // GIR_Coverage, 8070,
     /* 241229 */     GIR_EraseRootFromParent_Done,
     /* 241230 */   // Label 4833: @241230
     /* 241230 */   GIM_Try, /*On fail goto*//*Label 4834*/ GIMT_Encode4(241277), // Rule ID 8073 //
     /* 241235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 241243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 241258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241262 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1374:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLS_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 241262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_D),
     /* 241265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241269 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241271 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241273 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241275 */     GIR_RootConstrainSelectedInstOperands,
     /* 241276 */     // GIR_Coverage, 8073,
     /* 241276 */     GIR_EraseRootFromParent_Done,
     /* 241277 */   // Label 4834: @241277
     /* 241277 */   GIM_Try, /*On fail goto*//*Label 4835*/ GIMT_Encode4(241324), // Rule ID 8076 //
     /* 241282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 241290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 241296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 241305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241309 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1390:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 241309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
     /* 241312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241314 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241316 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241318 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241320 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241322 */     GIR_RootConstrainSelectedInstOperands,
     /* 241323 */     // GIR_Coverage, 8076,
     /* 241323 */     GIR_EraseRootFromParent_Done,
     /* 241324 */   // Label 4835: @241324
     /* 241324 */   GIM_Try, /*On fail goto*//*Label 4836*/ GIMT_Encode4(241371), // Rule ID 8077 //
     /* 241329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 241337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 241340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 241346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 241349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 241352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241356 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1390:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 241356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
     /* 241359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241363 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241365 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241367 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241369 */     GIR_RootConstrainSelectedInstOperands,
     /* 241370 */     // GIR_Coverage, 8077,
     /* 241370 */     GIR_EraseRootFromParent_Done,
     /* 241371 */   // Label 4836: @241371
     /* 241371 */   GIM_Try, /*On fail goto*//*Label 4837*/ GIMT_Encode4(241418), // Rule ID 8078 //
     /* 241376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 241384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 241387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 241393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 241396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 241399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241403 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1390:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 241403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
     /* 241406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241410 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241412 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241414 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241416 */     GIR_RootConstrainSelectedInstOperands,
     /* 241417 */     // GIR_Coverage, 8078,
     /* 241417 */     GIR_EraseRootFromParent_Done,
     /* 241418 */   // Label 4837: @241418
     /* 241418 */   GIM_Try, /*On fail goto*//*Label 4838*/ GIMT_Encode4(241465), // Rule ID 8079 //
     /* 241423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 241431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 241446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241450 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1390:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLA_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 241450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_S),
     /* 241453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241457 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241459 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241461 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241463 */     GIR_RootConstrainSelectedInstOperands,
     /* 241464 */     // GIR_Coverage, 8079,
     /* 241464 */     GIR_EraseRootFromParent_Done,
     /* 241465 */   // Label 4838: @241465
     /* 241465 */   GIM_Try, /*On fail goto*//*Label 4839*/ GIMT_Encode4(241512), // Rule ID 8080 //
     /* 241470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 241478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 241481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 241487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 241490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 241493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241497 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1390:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLA_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 241497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_S),
     /* 241500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241504 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241506 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241508 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241510 */     GIR_RootConstrainSelectedInstOperands,
     /* 241511 */     // GIR_Coverage, 8080,
     /* 241511 */     GIR_EraseRootFromParent_Done,
     /* 241512 */   // Label 4839: @241512
     /* 241512 */   GIM_Try, /*On fail goto*//*Label 4840*/ GIMT_Encode4(241559), // Rule ID 8081 //
     /* 241517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 241525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 241540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241544 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1390:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLA_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 241544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_D),
     /* 241547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241551 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241553 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241555 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241557 */     GIR_RootConstrainSelectedInstOperands,
     /* 241558 */     // GIR_Coverage, 8081,
     /* 241558 */     GIR_EraseRootFromParent_Done,
     /* 241559 */   // Label 4840: @241559
     /* 241559 */   GIM_Try, /*On fail goto*//*Label 4841*/ GIMT_Encode4(241606), // Rule ID 8082 //
     /* 241564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 241572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 241578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 241587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241591 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1392:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 241591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
     /* 241594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241600 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241602 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241604 */     GIR_RootConstrainSelectedInstOperands,
     /* 241605 */     // GIR_Coverage, 8082,
     /* 241605 */     GIR_EraseRootFromParent_Done,
     /* 241606 */   // Label 4841: @241606
     /* 241606 */   GIM_Try, /*On fail goto*//*Label 4842*/ GIMT_Encode4(241653), // Rule ID 8083 //
     /* 241611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 241619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 241622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 241628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 241631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 241634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241638 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1392:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 241638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
     /* 241641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241645 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241647 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241649 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241651 */     GIR_RootConstrainSelectedInstOperands,
     /* 241652 */     // GIR_Coverage, 8083,
     /* 241652 */     GIR_EraseRootFromParent_Done,
     /* 241653 */   // Label 4842: @241653
     /* 241653 */   GIM_Try, /*On fail goto*//*Label 4843*/ GIMT_Encode4(241700), // Rule ID 8084 //
     /* 241658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 241666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 241669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 241675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 241678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 241681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241685 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1392:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 241685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
     /* 241688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241690 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241692 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241694 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241696 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241698 */     GIR_RootConstrainSelectedInstOperands,
     /* 241699 */     // GIR_Coverage, 8084,
     /* 241699 */     GIR_EraseRootFromParent_Done,
     /* 241700 */   // Label 4843: @241700
     /* 241700 */   GIM_Try, /*On fail goto*//*Label 4844*/ GIMT_Encode4(241747), // Rule ID 8085 //
     /* 241705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 241713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 241728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241732 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1392:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLS_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 241732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_S),
     /* 241735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241739 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241741 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241743 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241745 */     GIR_RootConstrainSelectedInstOperands,
     /* 241746 */     // GIR_Coverage, 8085,
     /* 241746 */     GIR_EraseRootFromParent_Done,
     /* 241747 */   // Label 4844: @241747
     /* 241747 */   GIM_Try, /*On fail goto*//*Label 4845*/ GIMT_Encode4(241794), // Rule ID 8086 //
     /* 241752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 241760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 241763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 241769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 241772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 241775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241779 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1392:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLS_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 241779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_S),
     /* 241782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241784 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241786 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241788 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241790 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241792 */     GIR_RootConstrainSelectedInstOperands,
     /* 241793 */     // GIR_Coverage, 8086,
     /* 241793 */     GIR_EraseRootFromParent_Done,
     /* 241794 */   // Label 4845: @241794
     /* 241794 */   GIM_Try, /*On fail goto*//*Label 4846*/ GIMT_Encode4(241841), // Rule ID 8087 //
     /* 241799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 241807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 241822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241826 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1392:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLS_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 241826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_D),
     /* 241829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241833 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241835 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241837 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241839 */     GIR_RootConstrainSelectedInstOperands,
     /* 241840 */     // GIR_Coverage, 8087,
     /* 241840 */     GIR_EraseRootFromParent_Done,
     /* 241841 */   // Label 4846: @241841
     /* 241841 */   GIM_Try, /*On fail goto*//*Label 4847*/ GIMT_Encode4(241888), // Rule ID 8088 //
     /* 241846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
     /* 241854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 241860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 241869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241873 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1382:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMSB_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 241873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_H),
     /* 241876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241882 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241884 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241886 */     GIR_RootConstrainSelectedInstOperands,
     /* 241887 */     // GIR_Coverage, 8088,
     /* 241887 */     GIR_EraseRootFromParent_Done,
     /* 241888 */   // Label 4847: @241888
     /* 241888 */   GIM_Try, /*On fail goto*//*Label 4848*/ GIMT_Encode4(241935), // Rule ID 8089 //
     /* 241893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
     /* 241901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 241916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241920 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1382:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMSB_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 241920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_S),
     /* 241923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241927 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241929 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241931 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241933 */     GIR_RootConstrainSelectedInstOperands,
     /* 241934 */     // GIR_Coverage, 8089,
     /* 241934 */     GIR_EraseRootFromParent_Done,
     /* 241935 */   // Label 4848: @241935
     /* 241935 */   GIM_Try, /*On fail goto*//*Label 4849*/ GIMT_Encode4(241982), // Rule ID 8090 //
     /* 241940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
     /* 241948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 241963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241967 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1382:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMSB_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 241967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_D),
     /* 241970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241974 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241976 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241978 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241980 */     GIR_RootConstrainSelectedInstOperands,
     /* 241981 */     // GIR_Coverage, 8090,
     /* 241981 */     GIR_EraseRootFromParent_Done,
     /* 241982 */   // Label 4849: @241982
     /* 241982 */   GIM_Try, /*On fail goto*//*Label 4850*/ GIMT_Encode4(242029), // Rule ID 8091 //
     /* 241987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
     /* 241995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 242010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242014 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1389:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMAD_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 242014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_H),
     /* 242017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242021 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242023 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242025 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242027 */     GIR_RootConstrainSelectedInstOperands,
     /* 242028 */     // GIR_Coverage, 8091,
     /* 242028 */     GIR_EraseRootFromParent_Done,
     /* 242029 */   // Label 4850: @242029
     /* 242029 */   GIM_Try, /*On fail goto*//*Label 4851*/ GIMT_Encode4(242076), // Rule ID 8092 //
     /* 242034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
     /* 242042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 242057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242061 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1389:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMAD_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 242061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_S),
     /* 242064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242066 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242068 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242070 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242072 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242074 */     GIR_RootConstrainSelectedInstOperands,
     /* 242075 */     // GIR_Coverage, 8092,
     /* 242075 */     GIR_EraseRootFromParent_Done,
     /* 242076 */   // Label 4851: @242076
     /* 242076 */   GIM_Try, /*On fail goto*//*Label 4852*/ GIMT_Encode4(242123), // Rule ID 8093 //
     /* 242081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
     /* 242089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 242104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242108 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1389:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMAD_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 242108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_D),
     /* 242111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242115 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242117 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242119 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242121 */     GIR_RootConstrainSelectedInstOperands,
     /* 242122 */     // GIR_Coverage, 8093,
     /* 242122 */     GIR_EraseRootFromParent_Done,
     /* 242123 */   // Label 4852: @242123
     /* 242123 */   GIM_Try, /*On fail goto*//*Label 4853*/ GIMT_Encode4(242170), // Rule ID 8094 //
     /* 242128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
     /* 242136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 242151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242155 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1394:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMSB_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 242155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_H),
     /* 242158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242162 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242164 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242166 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242168 */     GIR_RootConstrainSelectedInstOperands,
     /* 242169 */     // GIR_Coverage, 8094,
     /* 242169 */     GIR_EraseRootFromParent_Done,
     /* 242170 */   // Label 4853: @242170
     /* 242170 */   GIM_Try, /*On fail goto*//*Label 4854*/ GIMT_Encode4(242217), // Rule ID 8095 //
     /* 242175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
     /* 242183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 242198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242202 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1394:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMSB_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 242202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_S),
     /* 242205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242207 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242209 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242211 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242213 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242215 */     GIR_RootConstrainSelectedInstOperands,
     /* 242216 */     // GIR_Coverage, 8095,
     /* 242216 */     GIR_EraseRootFromParent_Done,
     /* 242217 */   // Label 4854: @242217
     /* 242217 */   GIM_Try, /*On fail goto*//*Label 4855*/ GIMT_Encode4(242264), // Rule ID 8096 //
     /* 242222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
     /* 242230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 242245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242249 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1394:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMSB_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 242249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_D),
     /* 242252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242258 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242260 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242262 */     GIR_RootConstrainSelectedInstOperands,
     /* 242263 */     // GIR_Coverage, 8096,
     /* 242263 */     GIR_EraseRootFromParent_Done,
     /* 242264 */   // Label 4855: @242264
     /* 242264 */   GIM_Try, /*On fail goto*//*Label 4856*/ GIMT_Encode4(242311), // Rule ID 8097 //
     /* 242269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 242277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 242292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242296 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1376:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 242296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
     /* 242299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242303 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242305 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242307 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242309 */     GIR_RootConstrainSelectedInstOperands,
     /* 242310 */     // GIR_Coverage, 8097,
     /* 242310 */     GIR_EraseRootFromParent_Done,
     /* 242311 */   // Label 4856: @242311
     /* 242311 */   GIM_Try, /*On fail goto*//*Label 4857*/ GIMT_Encode4(242358), // Rule ID 8100 //
     /* 242316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 242324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 242327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 242333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 242336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 242339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242343 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1376:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 242343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
     /* 242346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242350 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242352 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242354 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242356 */     GIR_RootConstrainSelectedInstOperands,
     /* 242357 */     // GIR_Coverage, 8100,
     /* 242357 */     GIR_EraseRootFromParent_Done,
     /* 242358 */   // Label 4857: @242358
     /* 242358 */   GIM_Try, /*On fail goto*//*Label 4858*/ GIMT_Encode4(242405), // Rule ID 8103 //
     /* 242363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 242371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 242374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 242380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 242383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 242386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242390 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1376:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 242390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
     /* 242393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242397 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242399 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242401 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242403 */     GIR_RootConstrainSelectedInstOperands,
     /* 242404 */     // GIR_Coverage, 8103,
     /* 242404 */     GIR_EraseRootFromParent_Done,
     /* 242405 */   // Label 4858: @242405
     /* 242405 */   GIM_Try, /*On fail goto*//*Label 4859*/ GIMT_Encode4(242452), // Rule ID 8106 //
     /* 242410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 242418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 242433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242437 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1376:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLS_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 242437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_S_UNDEF),
     /* 242440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242444 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242446 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242448 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242450 */     GIR_RootConstrainSelectedInstOperands,
     /* 242451 */     // GIR_Coverage, 8106,
     /* 242451 */     GIR_EraseRootFromParent_Done,
     /* 242452 */   // Label 4859: @242452
     /* 242452 */   GIM_Try, /*On fail goto*//*Label 4860*/ GIMT_Encode4(242499), // Rule ID 8109 //
     /* 242457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 242465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 242468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 242474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 242477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 242480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242484 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1376:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLS_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 242484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_S_UNDEF),
     /* 242487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242491 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242493 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242495 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242497 */     GIR_RootConstrainSelectedInstOperands,
     /* 242498 */     // GIR_Coverage, 8109,
     /* 242498 */     GIR_EraseRootFromParent_Done,
     /* 242499 */   // Label 4860: @242499
     /* 242499 */   GIM_Try, /*On fail goto*//*Label 4861*/ GIMT_Encode4(242546), // Rule ID 8112 //
     /* 242504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 242512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 242527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242531 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1376:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLS_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 242531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_D_UNDEF),
     /* 242534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242538 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242540 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242542 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242544 */     GIR_RootConstrainSelectedInstOperands,
     /* 242545 */     // GIR_Coverage, 8112,
     /* 242545 */     GIR_EraseRootFromParent_Done,
     /* 242546 */   // Label 4861: @242546
     /* 242546 */   GIM_Try, /*On fail goto*//*Label 4862*/ GIMT_Encode4(242593), // Rule ID 8115 //
     /* 242551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 242559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 242574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242578 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1391:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 242578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
     /* 242581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242585 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242587 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242589 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242591 */     GIR_RootConstrainSelectedInstOperands,
     /* 242592 */     // GIR_Coverage, 8115,
     /* 242592 */     GIR_EraseRootFromParent_Done,
     /* 242593 */   // Label 4862: @242593
     /* 242593 */   GIM_Try, /*On fail goto*//*Label 4863*/ GIMT_Encode4(242640), // Rule ID 8118 //
     /* 242598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 242606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 242609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 242615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 242618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 242621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242625 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1391:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 242625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
     /* 242628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242632 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242634 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242636 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242638 */     GIR_RootConstrainSelectedInstOperands,
     /* 242639 */     // GIR_Coverage, 8118,
     /* 242639 */     GIR_EraseRootFromParent_Done,
     /* 242640 */   // Label 4863: @242640
     /* 242640 */   GIM_Try, /*On fail goto*//*Label 4864*/ GIMT_Encode4(242687), // Rule ID 8121 //
     /* 242645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 242653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 242656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 242662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 242665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 242668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242672 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1391:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 242672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
     /* 242675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242679 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242681 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242683 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242685 */     GIR_RootConstrainSelectedInstOperands,
     /* 242686 */     // GIR_Coverage, 8121,
     /* 242686 */     GIR_EraseRootFromParent_Done,
     /* 242687 */   // Label 4864: @242687
     /* 242687 */   GIM_Try, /*On fail goto*//*Label 4865*/ GIMT_Encode4(242734), // Rule ID 8124 //
     /* 242692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 242700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 242715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242719 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1391:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLA_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 242719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_S_UNDEF),
     /* 242722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242724 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242726 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242728 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242730 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242732 */     GIR_RootConstrainSelectedInstOperands,
     /* 242733 */     // GIR_Coverage, 8124,
     /* 242733 */     GIR_EraseRootFromParent_Done,
     /* 242734 */   // Label 4865: @242734
     /* 242734 */   GIM_Try, /*On fail goto*//*Label 4866*/ GIMT_Encode4(242781), // Rule ID 8127 //
     /* 242739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 242747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 242750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 242756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 242759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 242762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242766 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1391:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLA_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 242766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_S_UNDEF),
     /* 242769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242773 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242775 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242777 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242779 */     GIR_RootConstrainSelectedInstOperands,
     /* 242780 */     // GIR_Coverage, 8127,
     /* 242780 */     GIR_EraseRootFromParent_Done,
     /* 242781 */   // Label 4866: @242781
     /* 242781 */   GIM_Try, /*On fail goto*//*Label 4867*/ GIMT_Encode4(242828), // Rule ID 8130 //
     /* 242786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 242794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 242809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242813 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1391:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLA_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 242813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_D_UNDEF),
     /* 242816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242818 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242820 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242822 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242824 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242826 */     GIR_RootConstrainSelectedInstOperands,
     /* 242827 */     // GIR_Coverage, 8130,
     /* 242827 */     GIR_EraseRootFromParent_Done,
     /* 242828 */   // Label 4867: @242828
     /* 242828 */   GIM_Try, /*On fail goto*//*Label 4868*/ GIMT_Encode4(242875), // Rule ID 8133 //
     /* 242833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 242841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 242856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242860 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1393:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 242860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
     /* 242863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242867 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242869 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242871 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242873 */     GIR_RootConstrainSelectedInstOperands,
     /* 242874 */     // GIR_Coverage, 8133,
     /* 242874 */     GIR_EraseRootFromParent_Done,
     /* 242875 */   // Label 4868: @242875
     /* 242875 */   GIM_Try, /*On fail goto*//*Label 4869*/ GIMT_Encode4(242922), // Rule ID 8135 //
     /* 242880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 242888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 242891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 242897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 242900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 242903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242907 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1393:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 242907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
     /* 242910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242914 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242916 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242918 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242920 */     GIR_RootConstrainSelectedInstOperands,
     /* 242921 */     // GIR_Coverage, 8135,
     /* 242921 */     GIR_EraseRootFromParent_Done,
     /* 242922 */   // Label 4869: @242922
     /* 242922 */   GIM_Try, /*On fail goto*//*Label 4870*/ GIMT_Encode4(242969), // Rule ID 8137 //
     /* 242927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 242935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 242938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 242944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 242947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 242950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242954 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1393:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 242954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
     /* 242957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242959 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242961 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242963 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242965 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242967 */     GIR_RootConstrainSelectedInstOperands,
     /* 242968 */     // GIR_Coverage, 8137,
     /* 242968 */     GIR_EraseRootFromParent_Done,
     /* 242969 */   // Label 4870: @242969
     /* 242969 */   GIM_Try, /*On fail goto*//*Label 4871*/ GIMT_Encode4(243016), // Rule ID 8139 //
     /* 242974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 242982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 242997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243001 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1393:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLS_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 243001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_S_UNDEF),
     /* 243004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 243006 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243008 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243010 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243012 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243014 */     GIR_RootConstrainSelectedInstOperands,
     /* 243015 */     // GIR_Coverage, 8139,
     /* 243015 */     GIR_EraseRootFromParent_Done,
     /* 243016 */   // Label 4871: @243016
     /* 243016 */   GIM_Try, /*On fail goto*//*Label 4872*/ GIMT_Encode4(243063), // Rule ID 8141 //
     /* 243021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 243029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 243032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 243035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 243038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 243041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 243044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243048 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1393:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLS_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 243048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_S_UNDEF),
     /* 243051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 243053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243055 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243057 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243059 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243061 */     GIR_RootConstrainSelectedInstOperands,
     /* 243062 */     // GIR_Coverage, 8141,
     /* 243062 */     GIR_EraseRootFromParent_Done,
     /* 243063 */   // Label 4872: @243063
     /* 243063 */   GIM_Try, /*On fail goto*//*Label 4873*/ GIMT_Encode4(243110), // Rule ID 8143 //
     /* 243068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 243076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 243079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 243082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 243085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 243091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243095 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1393:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLS_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 243095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_D_UNDEF),
     /* 243098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 243100 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243102 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243104 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243106 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243108 */     GIR_RootConstrainSelectedInstOperands,
     /* 243109 */     // GIR_Coverage, 8143,
     /* 243109 */     GIR_EraseRootFromParent_Done,
     /* 243110 */   // Label 4873: @243110
     /* 243110 */   GIM_Reject,
     /* 243111 */ // Label 4732: @243111
     /* 243111 */ GIM_Reject,
     /* 243112 */ // Label 33: @243112
     /* 243112 */ GIM_Try, /*On fail goto*//*Label 4874*/ GIMT_Encode4(243190),
     /* 243117 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/1,
     /* 243120 */   GIM_Try, /*On fail goto*//*Label 4875*/ GIMT_Encode4(243142), // Rule ID 78 //
     /* 243125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 243128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_tcommit),
     /* 243133 */     // (intrinsic_void 2072:{ *:[iPTR] })  =>  (TCOMMIT)
     /* 243133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TCOMMIT),
     /* 243136 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 243140 */     GIR_RootConstrainSelectedInstOperands,
     /* 243141 */     // GIR_Coverage, 78,
     /* 243141 */     GIR_EraseRootFromParent_Done,
     /* 243142 */   // Label 4875: @243142
     /* 243142 */   GIM_Try, /*On fail goto*//*Label 4876*/ GIMT_Encode4(243167), // Rule ID 2377 //
     /* 243147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 243150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_setffr),
     /* 243155 */     // (intrinsic_void 1622:{ *:[iPTR] })  =>  (SETFFR:{ *:[i64] })
     /* 243155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SETFFR),
     /* 243158 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FFR*/0,
     /* 243161 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 243165 */     GIR_RootConstrainSelectedInstOperands,
     /* 243166 */     // GIR_Coverage, 2377,
     /* 243166 */     GIR_EraseRootFromParent_Done,
     /* 243167 */   // Label 4876: @243167
     /* 243167 */   GIM_Try, /*On fail goto*//*Label 4877*/ GIMT_Encode4(243189), // Rule ID 7038 //
     /* 243172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_clrex),
     /* 243177 */     // (intrinsic_void 500:{ *:[iPTR] })  =>  (CLREX 15:{ *:[i64] })
     /* 243177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLREX),
     /* 243180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 243183 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 243187 */     GIR_RootConstrainSelectedInstOperands,
     /* 243188 */     // GIR_Coverage, 7038,
     /* 243188 */     GIR_EraseRootFromParent_Done,
     /* 243189 */   // Label 4877: @243189
     /* 243189 */   GIM_Reject,
     /* 243190 */ // Label 4874: @243190
     /* 243190 */ GIM_Try, /*On fail goto*//*Label 4878*/ GIMT_Encode4(243790),
     /* 243195 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
     /* 243198 */   GIM_Try, /*On fail goto*//*Label 4879*/ GIMT_Encode4(243230), // Rule ID 79 //
     /* 243203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 243206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_tcancel),
     /* 243211 */     // MIs[0] imm
     /* 243211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 243214 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm64_0_65535),
     /* 243219 */     // (intrinsic_void 2071:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_timm64_0_65535>>:$imm)  =>  (TCANCEL (timm:{ *:[i64] }):$imm)
     /* 243219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TCANCEL),
     /* 243222 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 243224 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 243228 */     GIR_RootConstrainSelectedInstOperands,
     /* 243229 */     // GIR_Coverage, 79,
     /* 243229 */     GIR_EraseRootFromParent_Done,
     /* 243230 */   // Label 4879: @243230
     /* 243230 */   GIM_Try, /*On fail goto*//*Label 4880*/ GIMT_Encode4(243255), // Rule ID 227 //
     /* 243235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_break),
     /* 243240 */     // MIs[0] imm
     /* 243240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 243243 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_65535),
     /* 243248 */     // (intrinsic_void 498:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_65535>>:$imm)  =>  (BRK (timm:{ *:[i32] }):$imm)
     /* 243248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 243251 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 243253 */     GIR_RootConstrainSelectedInstOperands,
     /* 243254 */     // GIR_Coverage, 227,
     /* 243254 */     GIR_EraseRootFromParent_Done,
     /* 243255 */   // Label 4880: @243255
     /* 243255 */   GIM_Try, /*On fail goto*//*Label 4881*/ GIMT_Encode4(243280), // Rule ID 228 //
     /* 243260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_hlt),
     /* 243265 */     // MIs[0] imm
     /* 243265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 243268 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_65535),
     /* 243273 */     // (intrinsic_void 557:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_65535>>:$imm)  =>  (HLT (timm:{ *:[i32] }):$imm)
     /* 243273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HLT),
     /* 243276 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 243278 */     GIR_RootConstrainSelectedInstOperands,
     /* 243279 */     // GIR_Coverage, 228,
     /* 243279 */     GIR_EraseRootFromParent_Done,
     /* 243280 */   // Label 4881: @243280
     /* 243280 */   GIM_Try, /*On fail goto*//*Label 4882*/ GIMT_Encode4(243312), // Rule ID 3592 //
     /* 243285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
     /* 243288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_zero),
     /* 243293 */     // MIs[0] imm
     /* 243293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 243296 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_255),
     /* 243301 */     // (intrinsic_void 1128:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_255>>:$imm)  =>  (ZERO_M_PSEUDO (timm:{ *:[i32] })<<P:Predicate_timm32_0_255>>:$imm)
     /* 243301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZERO_M_PSEUDO),
     /* 243304 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 243306 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 243310 */     GIR_RootConstrainSelectedInstOperands,
     /* 243311 */     // GIR_Coverage, 3592,
     /* 243311 */     GIR_EraseRootFromParent_Done,
     /* 243312 */   // Label 4882: @243312
     /* 243312 */   GIM_Try, /*On fail goto*//*Label 4883*/ GIMT_Encode4(243352), // Rule ID 16 //
     /* 243317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_hint),
     /* 243322 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 243325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 243329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 243333 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_127),
     /* 243337 */     // MIs[1] Operand 1
     /* 243337 */     // No operand predicates
     /* 243337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 243339 */     // (intrinsic_void 556:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_127>>:$imm)  =>  (HINT (imm:{ *:[i32] }):$imm)
     /* 243339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HINT),
     /* 243342 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 243345 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 243350 */     GIR_RootConstrainSelectedInstOperands,
     /* 243351 */     // GIR_Coverage, 16,
     /* 243351 */     GIR_EraseRootFromParent_Done,
     /* 243352 */   // Label 4883: @243352
     /* 243352 */   GIM_Try, /*On fail goto*//*Label 4884*/ GIMT_Encode4(243392), // Rule ID 17 //
     /* 243357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_dmb),
     /* 243362 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 243365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 243369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 243373 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 243377 */     // MIs[1] Operand 1
     /* 243377 */     // No operand predicates
     /* 243377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 243379 */     // (intrinsic_void 544:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (DMB (imm:{ *:[i32] }):$CRm)
     /* 243379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
     /* 243382 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
     /* 243385 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 243390 */     GIR_RootConstrainSelectedInstOperands,
     /* 243391 */     // GIR_Coverage, 17,
     /* 243391 */     GIR_EraseRootFromParent_Done,
     /* 243392 */   // Label 4884: @243392
     /* 243392 */   GIM_Try, /*On fail goto*//*Label 4885*/ GIMT_Encode4(243432), // Rule ID 18 //
     /* 243397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_dsb),
     /* 243402 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 243405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 243409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 243413 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 243417 */     // MIs[1] Operand 1
     /* 243417 */     // No operand predicates
     /* 243417 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 243419 */     // (intrinsic_void 545:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (DSB (imm:{ *:[i32] }):$CRm)
     /* 243419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DSB),
     /* 243422 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
     /* 243425 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 243430 */     GIR_RootConstrainSelectedInstOperands,
     /* 243431 */     // GIR_Coverage, 18,
     /* 243431 */     GIR_EraseRootFromParent_Done,
     /* 243432 */   // Label 4885: @243432
     /* 243432 */   GIM_Try, /*On fail goto*//*Label 4886*/ GIMT_Encode4(243472), // Rule ID 19 //
     /* 243437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_isb),
     /* 243442 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 243445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 243449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 243453 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 243457 */     // MIs[1] Operand 1
     /* 243457 */     // No operand predicates
     /* 243457 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 243459 */     // (intrinsic_void 560:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (ISB (imm:{ *:[i32] }):$CRm)
     /* 243459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ISB),
     /* 243462 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
     /* 243465 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 243470 */     GIR_RootConstrainSelectedInstOperands,
     /* 243471 */     // GIR_Coverage, 19,
     /* 243471 */     GIR_EraseRootFromParent_Done,
     /* 243472 */   // Label 4886: @243472
     /* 243472 */   GIM_Try, /*On fail goto*//*Label 4887*/ GIMT_Encode4(243496), // Rule ID 72 //
     /* 243477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_get_fpcr),
     /* 243482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 243485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 243489 */     // (intrinsic_w_chain:{ *:[i64] } 553:{ *:[iPTR] })  =>  (MRS_FPCR:{ *:[i64] })
     /* 243489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS_FPCR),
     /* 243492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 243494 */     GIR_RootConstrainSelectedInstOperands,
     /* 243495 */     // GIR_Coverage, 72,
     /* 243495 */     GIR_EraseRootFromParent_Done,
     /* 243496 */   // Label 4887: @243496
     /* 243496 */   GIM_Try, /*On fail goto*//*Label 4888*/ GIMT_Encode4(243520), // Rule ID 74 //
     /* 243501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_get_fpsr),
     /* 243506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 243509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 243513 */     // (intrinsic_w_chain:{ *:[i64] } 554:{ *:[iPTR] })  =>  (MRS_FPSR:{ *:[i64] })
     /* 243513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS_FPSR),
     /* 243516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 243518 */     GIR_RootConstrainSelectedInstOperands,
     /* 243519 */     // GIR_Coverage, 74,
     /* 243519 */     GIR_EraseRootFromParent_Done,
     /* 243520 */   // Label 4888: @243520
     /* 243520 */   GIM_Try, /*On fail goto*//*Label 4889*/ GIMT_Encode4(243551), // Rule ID 77 //
     /* 243525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 243528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_tstart),
     /* 243533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 243536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 243540 */     // (intrinsic_w_chain:{ *:[i64] } 2073:{ *:[iPTR] })  =>  (TSTART:{ *:[i64] })
     /* 243540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TSTART),
     /* 243543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 243545 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 243549 */     GIR_RootConstrainSelectedInstOperands,
     /* 243550 */     // GIR_Coverage, 77,
     /* 243550 */     GIR_EraseRootFromParent_Done,
     /* 243551 */   // Label 4889: @243551
     /* 243551 */   GIM_Try, /*On fail goto*//*Label 4890*/ GIMT_Encode4(243578), // Rule ID 80 //
     /* 243556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 243559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ttest),
     /* 243564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 243567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 243571 */     // (intrinsic_w_chain:{ *:[i64] } 2074:{ *:[iPTR] })  =>  (TTEST:{ *:[i64] })
     /* 243571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TTEST),
     /* 243574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 243576 */     GIR_RootConstrainSelectedInstOperands,
     /* 243577 */     // GIR_Coverage, 80,
     /* 243577 */     GIR_EraseRootFromParent_Done,
     /* 243578 */   // Label 4890: @243578
     /* 243578 */   GIM_Try, /*On fail goto*//*Label 4891*/ GIMT_Encode4(243609), // Rule ID 2376 //
     /* 243583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 243586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rdffr),
     /* 243591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 243594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 243598 */     // (intrinsic_w_chain:{ *:[nxv16i1] } 1572:{ *:[iPTR] })  =>  (RDFFR_P:{ *:[nxv16i1] })
     /* 243598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RDFFR_P),
     /* 243601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243603 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 243607 */     GIR_RootConstrainSelectedInstOperands,
     /* 243608 */     // GIR_Coverage, 2376,
     /* 243608 */     GIR_EraseRootFromParent_Done,
     /* 243609 */   // Label 4891: @243609
     /* 243609 */   GIM_Try, /*On fail goto*//*Label 4892*/ GIMT_Encode4(243649), // Rule ID 12502 //
     /* 243614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
     /* 243617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sme_get_tpidr2),
     /* 243622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 243625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 243629 */     // (intrinsic_w_chain:{ *:[i64] } 881:{ *:[iPTR] })  =>  (MRS:{ *:[i64] }:{ *:[i32] } 56965:{ *:[i32] })
     /* 243629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS),
     /* 243632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 243634 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(56965),
     /* 243644 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 243647 */     GIR_RootConstrainSelectedInstOperands,
     /* 243648 */     // GIR_Coverage, 12502,
     /* 243648 */     GIR_EraseRootFromParent_Done,
     /* 243649 */   // Label 4892: @243649
     /* 243649 */   GIM_Try, /*On fail goto*//*Label 4893*/ GIMT_Encode4(243683), // Rule ID 2378 //
     /* 243654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 243657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_wrffr),
     /* 243662 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 243665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 243669 */     // (intrinsic_void 2052:{ *:[iPTR] }, PPR8:{ *:[nxv16i1] }:$Pn)  =>  (WRFFR:{ *:[i64] } PPR8:{ *:[nxv16i1] }:$Pn)
     /* 243669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WRFFR),
     /* 243672 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pn
     /* 243674 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FFR*/0,
     /* 243677 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 243681 */     GIR_RootConstrainSelectedInstOperands,
     /* 243682 */     // GIR_Coverage, 2378,
     /* 243682 */     GIR_EraseRootFromParent_Done,
     /* 243683 */   // Label 4893: @243683
     /* 243683 */   GIM_Try, /*On fail goto*//*Label 4894*/ GIMT_Encode4(243706), // Rule ID 73 //
     /* 243688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpcr),
     /* 243693 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 243696 */     // (intrinsic_void 780:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPCR i64:{ *:[i64] }:$val)
     /* 243696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPCR),
     /* 243699 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 243701 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPCR*/0,
     /* 243704 */     GIR_RootConstrainSelectedInstOperands,
     /* 243705 */     // GIR_Coverage, 73,
     /* 243705 */     GIR_EraseRootFromParent_Done,
     /* 243706 */   // Label 4894: @243706
     /* 243706 */   GIM_Try, /*On fail goto*//*Label 4895*/ GIMT_Encode4(243729), // Rule ID 75 //
     /* 243711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpsr),
     /* 243716 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 243719 */     // (intrinsic_void 782:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPSR i64:{ *:[i64] }:$val)
     /* 243719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPSR),
     /* 243722 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 243724 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPSR*/0,
     /* 243727 */     GIR_RootConstrainSelectedInstOperands,
     /* 243728 */     // GIR_Coverage, 75,
     /* 243728 */     GIR_EraseRootFromParent_Done,
     /* 243729 */   // Label 4895: @243729
     /* 243729 */   GIM_Try, /*On fail goto*//*Label 4896*/ GIMT_Encode4(243756), // Rule ID 76 //
     /* 243734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpmr),
     /* 243739 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 243742 */     // (intrinsic_void 781:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPMR i64:{ *:[i64] }:$val)
     /* 243742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPMR),
     /* 243745 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 243747 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPMR*/0,
     /* 243750 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 243754 */     GIR_RootConstrainSelectedInstOperands,
     /* 243755 */     // GIR_Coverage, 76,
     /* 243755 */     GIR_EraseRootFromParent_Done,
     /* 243756 */   // Label 4896: @243756
     /* 243756 */   GIM_Try, /*On fail goto*//*Label 4897*/ GIMT_Encode4(243789), // Rule ID 12501 //
     /* 243761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
     /* 243764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_set_tpidr2),
     /* 243769 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 243772 */     // (intrinsic_void 940:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR 56965:{ *:[i32] }, GPR64:{ *:[i64] }:$val)
     /* 243772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR),
     /* 243775 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(56965),
     /* 243785 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 243787 */     GIR_RootConstrainSelectedInstOperands,
     /* 243788 */     // GIR_Coverage, 12501,
     /* 243788 */     GIR_EraseRootFromParent_Done,
     /* 243789 */   // Label 4897: @243789
     /* 243789 */   GIM_Reject,
     /* 243790 */ // Label 4878: @243790
     /* 243790 */ GIM_Try, /*On fail goto*//*Label 4898*/ GIMT_Encode4(244761),
     /* 243795 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 243798 */   GIM_Try, /*On fail goto*//*Label 4899*/ GIMT_Encode4(243874), // Rule ID 7004 //
     /* 243803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 243808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 243811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 243815 */     // MIs[0] addr
     /* 243815 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 243819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 243823 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_1),
     /* 243827 */     // (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 243827 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 243830 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRB),
     /* 243834 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 243839 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 243843 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 243847 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 243849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 243852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 243854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243857 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 243860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 243863 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 243868 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 243873 */     // GIR_Coverage, 7004,
     /* 243873 */     GIR_EraseRootFromParent_Done,
     /* 243874 */   // Label 4899: @243874
     /* 243874 */   GIM_Try, /*On fail goto*//*Label 4900*/ GIMT_Encode4(243950), // Rule ID 7005 //
     /* 243879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 243884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 243887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 243891 */     // MIs[0] addr
     /* 243891 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 243895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 243899 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_2),
     /* 243903 */     // (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_2>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 243903 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 243906 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRH),
     /* 243910 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 243915 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 243919 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 243923 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 243925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 243928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 243930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243933 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 243936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 243939 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 243944 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 243949 */     // GIR_Coverage, 7005,
     /* 243949 */     GIR_EraseRootFromParent_Done,
     /* 243950 */   // Label 4900: @243950
     /* 243950 */   GIM_Try, /*On fail goto*//*Label 4901*/ GIMT_Encode4(244026), // Rule ID 7006 //
     /* 243955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 243960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 243963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 243967 */     // MIs[0] addr
     /* 243967 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 243971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 243975 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_4),
     /* 243979 */     // (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_4>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 243979 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 243982 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRW),
     /* 243986 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 243991 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 243995 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 243999 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 244001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 244004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 244006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 244009 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 244012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 244015 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 244020 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 244025 */     // GIR_Coverage, 7006,
     /* 244025 */     GIR_EraseRootFromParent_Done,
     /* 244026 */   // Label 4901: @244026
     /* 244026 */   GIM_Try, /*On fail goto*//*Label 4902*/ GIMT_Encode4(244068), // Rule ID 7007 //
     /* 244031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 244036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 244039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 244043 */     // MIs[0] addr
     /* 244043 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 244047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 244051 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_8),
     /* 244055 */     // (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_8>>  =>  (LDXRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$addr)
     /* 244055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDXRX),
     /* 244058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 244060 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 244062 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 244066 */     GIR_RootConstrainSelectedInstOperands,
     /* 244067 */     // GIR_Coverage, 7007,
     /* 244067 */     GIR_EraseRootFromParent_Done,
     /* 244068 */   // Label 4902: @244068
     /* 244068 */   GIM_Try, /*On fail goto*//*Label 4903*/ GIMT_Encode4(244144), // Rule ID 7011 //
     /* 244073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 244078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 244081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 244085 */     // MIs[0] addr
     /* 244085 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 244089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 244093 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_1),
     /* 244097 */     // (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 244097 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 244100 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRB),
     /* 244104 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 244109 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 244113 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 244117 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 244119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 244122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 244124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 244127 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 244130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 244133 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 244138 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 244143 */     // GIR_Coverage, 7011,
     /* 244143 */     GIR_EraseRootFromParent_Done,
     /* 244144 */   // Label 4903: @244144
     /* 244144 */   GIM_Try, /*On fail goto*//*Label 4904*/ GIMT_Encode4(244220), // Rule ID 7012 //
     /* 244149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 244154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 244157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 244161 */     // MIs[0] addr
     /* 244161 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 244165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 244169 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_2),
     /* 244173 */     // (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_2>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 244173 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 244176 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRH),
     /* 244180 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 244185 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 244189 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 244193 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 244195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 244198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 244200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 244203 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 244206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 244209 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 244214 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 244219 */     // GIR_Coverage, 7012,
     /* 244219 */     GIR_EraseRootFromParent_Done,
     /* 244220 */   // Label 4904: @244220
     /* 244220 */   GIM_Try, /*On fail goto*//*Label 4905*/ GIMT_Encode4(244296), // Rule ID 7013 //
     /* 244225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 244230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 244233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 244237 */     // MIs[0] addr
     /* 244237 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 244241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 244245 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_4),
     /* 244249 */     // (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_4>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 244249 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 244252 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRW),
     /* 244256 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 244261 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 244265 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 244269 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 244271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 244274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 244276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 244279 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 244282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 244285 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 244290 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 244295 */     // GIR_Coverage, 7013,
     /* 244295 */     GIR_EraseRootFromParent_Done,
     /* 244296 */   // Label 4905: @244296
     /* 244296 */   GIM_Try, /*On fail goto*//*Label 4906*/ GIMT_Encode4(244338), // Rule ID 7014 //
     /* 244301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 244306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 244309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 244313 */     // MIs[0] addr
     /* 244313 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 244317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 244321 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_8),
     /* 244325 */     // (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_8>>  =>  (LDAXRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$addr)
     /* 244325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAXRX),
     /* 244328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 244330 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 244332 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 244336 */     GIR_RootConstrainSelectedInstOperands,
     /* 244337 */     // GIR_Coverage, 7014,
     /* 244337 */     GIR_EraseRootFromParent_Done,
     /* 244338 */   // Label 4906: @244338
     /* 244338 */   GIM_Try, /*On fail goto*//*Label 4907*/ GIMT_Encode4(244378), // Rule ID 20 //
     /* 244343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGCS),
     /* 244346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_gcspopm),
     /* 244351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 244354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 244357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 244361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 244365 */     // (intrinsic_w_chain:{ *:[i64] } 551:{ *:[iPTR] }, GPR64:{ *:[i64] }:$src)  =>  (GCSPOPM:{ *:[i64] } GPR64:{ *:[i64] }:$src)
     /* 244365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::GCSPOPM),
     /* 244368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 244370 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 244372 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 244376 */     GIR_RootConstrainSelectedInstOperands,
     /* 244377 */     // GIR_Coverage, 20,
     /* 244377 */     GIR_EraseRootFromParent_Done,
     /* 244378 */   // Label 4907: @244378
     /* 244378 */   GIM_Try, /*On fail goto*//*Label 4908*/ GIMT_Encode4(244418), // Rule ID 2375 //
     /* 244383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 244386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rdffr_z),
     /* 244391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 244394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 244397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 244401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 244405 */     // (intrinsic_w_chain:{ *:[nxv16i1] } 1573:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (RDFFR_PPz:{ *:[nxv16i1] } PPRAny:{ *:[nxv16i1] }:$Pg)
     /* 244405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RDFFR_PPz),
     /* 244408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244410 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 244412 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 244416 */     GIR_RootConstrainSelectedInstOperands,
     /* 244417 */     // GIR_Coverage, 2375,
     /* 244417 */     GIR_EraseRootFromParent_Done,
     /* 244418 */   // Label 4908: @244418
     /* 244418 */   GIM_Try, /*On fail goto*//*Label 4909*/ GIMT_Encode4(244458), // Rule ID 2486 //
     /* 244423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 244426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl1),
     /* 244431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 244434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 244437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 244441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 244445 */     // (intrinsic_w_chain:{ *:[v8f16] } 611:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (F1CVTL:{ *:[v8f16] } V64:{ *:[v8i8] }:$Rn)
     /* 244445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVTL),
     /* 244448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 244450 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 244452 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 244456 */     GIR_RootConstrainSelectedInstOperands,
     /* 244457 */     // GIR_Coverage, 2486,
     /* 244457 */     GIR_EraseRootFromParent_Done,
     /* 244458 */   // Label 4909: @244458
     /* 244458 */   GIM_Try, /*On fail goto*//*Label 4910*/ GIMT_Encode4(244498), // Rule ID 2487 //
     /* 244463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 244466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl1),
     /* 244471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 244474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 244477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 244481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 244485 */     // (intrinsic_w_chain:{ *:[v8f16] } 611:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (F1CVTL2:{ *:[v8f16] } V128:{ *:[v16i8] }:$Rn)
     /* 244485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVTL2),
     /* 244488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 244490 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 244492 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 244496 */     GIR_RootConstrainSelectedInstOperands,
     /* 244497 */     // GIR_Coverage, 2487,
     /* 244497 */     GIR_EraseRootFromParent_Done,
     /* 244498 */   // Label 4910: @244498
     /* 244498 */   GIM_Try, /*On fail goto*//*Label 4911*/ GIMT_Encode4(244538), // Rule ID 6893 //
     /* 244503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 244506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl2),
     /* 244511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 244514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 244517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 244521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 244525 */     // (intrinsic_w_chain:{ *:[v8f16] } 612:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (F2CVTL:{ *:[v8f16] } V64:{ *:[v8i8] }:$Rn)
     /* 244525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVTL),
     /* 244528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 244530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 244532 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 244536 */     GIR_RootConstrainSelectedInstOperands,
     /* 244537 */     // GIR_Coverage, 6893,
     /* 244537 */     GIR_EraseRootFromParent_Done,
     /* 244538 */   // Label 4911: @244538
     /* 244538 */   GIM_Try, /*On fail goto*//*Label 4912*/ GIMT_Encode4(244578), // Rule ID 6894 //
     /* 244543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 244546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl2),
     /* 244551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 244554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 244557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 244561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 244565 */     // (intrinsic_w_chain:{ *:[v8f16] } 612:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (F2CVTL2:{ *:[v8f16] } V128:{ *:[v16i8] }:$Rn)
     /* 244565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVTL2),
     /* 244568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 244570 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 244572 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 244576 */     GIR_RootConstrainSelectedInstOperands,
     /* 244577 */     // GIR_Coverage, 6894,
     /* 244577 */     GIR_EraseRootFromParent_Done,
     /* 244578 */   // Label 4912: @244578
     /* 244578 */   GIM_Try, /*On fail goto*//*Label 4913*/ GIMT_Encode4(244614), // Rule ID 3557 //
     /* 244583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 244586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvt1),
     /* 244591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 244594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 244597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244601 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1397:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F1CVT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 244601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVT_ZZ_BtoH),
     /* 244604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 244606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244608 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 244612 */     GIR_RootConstrainSelectedInstOperands,
     /* 244613 */     // GIR_Coverage, 3557,
     /* 244613 */     GIR_EraseRootFromParent_Done,
     /* 244614 */   // Label 4913: @244614
     /* 244614 */   GIM_Try, /*On fail goto*//*Label 4914*/ GIMT_Encode4(244652), // Rule ID 3943 //
     /* 244619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 244622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_irg_sp),
     /* 244627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 244630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 244633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 244637 */     // (intrinsic_w_chain:{ *:[i64] } 559:{ *:[iPTR] }, i64:{ *:[i64] }:$Rm)  =>  (IRGstack:{ *:[i64] } SP:{ *:[i64] }, i64:{ *:[i64] }:$Rm)
     /* 244637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::IRGstack),
     /* 244640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 244642 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::SP), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 244648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 244650 */     GIR_RootConstrainSelectedInstOperands,
     /* 244651 */     // GIR_Coverage, 3943,
     /* 244651 */     GIR_EraseRootFromParent_Done,
     /* 244652 */   // Label 4914: @244652
     /* 244652 */   GIM_Try, /*On fail goto*//*Label 4915*/ GIMT_Encode4(244688), // Rule ID 12304 //
     /* 244657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 244660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvt2),
     /* 244665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 244668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 244671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244675 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1399:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F2CVT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 244675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVT_ZZ_BtoH),
     /* 244678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 244680 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244682 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 244686 */     GIR_RootConstrainSelectedInstOperands,
     /* 244687 */     // GIR_Coverage, 12304,
     /* 244687 */     GIR_EraseRootFromParent_Done,
     /* 244688 */   // Label 4915: @244688
     /* 244688 */   GIM_Try, /*On fail goto*//*Label 4916*/ GIMT_Encode4(244724), // Rule ID 12305 //
     /* 244693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 244696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvtlt1),
     /* 244701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 244704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 244707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244711 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1403:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F1CVTLT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 244711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVTLT_ZZ_BtoH),
     /* 244714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 244716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244718 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 244722 */     GIR_RootConstrainSelectedInstOperands,
     /* 244723 */     // GIR_Coverage, 12305,
     /* 244723 */     GIR_EraseRootFromParent_Done,
     /* 244724 */   // Label 4916: @244724
     /* 244724 */   GIM_Try, /*On fail goto*//*Label 4917*/ GIMT_Encode4(244760), // Rule ID 12306 //
     /* 244729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 244732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvtlt2),
     /* 244737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 244740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 244743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244747 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1404:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F2CVTLT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 244747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVTLT_ZZ_BtoH),
     /* 244750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 244752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244754 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 244758 */     GIR_RootConstrainSelectedInstOperands,
     /* 244759 */     // GIR_Coverage, 12306,
     /* 244759 */     GIR_EraseRootFromParent_Done,
     /* 244760 */   // Label 4917: @244760
     /* 244760 */   GIM_Reject,
     /* 244761 */ // Label 4898: @244761
     /* 244761 */ GIM_Try, /*On fail goto*//*Label 4918*/ GIMT_Encode4(247669),
     /* 244766 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 244769 */   GIM_Try, /*On fail goto*//*Label 4919*/ GIMT_Encode4(244866), // Rule ID 7022 //
     /* 244774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 244779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 244782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 244785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 244789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 244793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 244797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 244801 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 244805 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 244809 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 244813 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 244817 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 244822 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(255),
     /* 244833 */     // MIs[0] addr
     /* 244833 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 244837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 244841 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
     /* 244845 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 244847 */     // (intrinsic_w_chain:{ *:[i32] } 1147:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 255:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 244847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
     /* 244850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 244852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 244856 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 244858 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 244864 */     GIR_RootConstrainSelectedInstOperands,
     /* 244865 */     // GIR_Coverage, 7022,
     /* 244865 */     GIR_EraseRootFromParent_Done,
     /* 244866 */   // Label 4919: @244866
     /* 244866 */   GIM_Try, /*On fail goto*//*Label 4920*/ GIMT_Encode4(244963), // Rule ID 7023 //
     /* 244871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 244876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 244879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 244882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 244886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 244890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 244894 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 244898 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 244902 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 244906 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 244910 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 244914 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 244919 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /* 244930 */     // MIs[0] addr
     /* 244930 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 244934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 244938 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
     /* 244942 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 244944 */     // (intrinsic_w_chain:{ *:[i32] } 1147:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 65535:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 244944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
     /* 244947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 244949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 244953 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 244955 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 244961 */     GIR_RootConstrainSelectedInstOperands,
     /* 244962 */     // GIR_Coverage, 7023,
     /* 244962 */     GIR_EraseRootFromParent_Done,
     /* 244963 */   // Label 4920: @244963
     /* 244963 */   GIM_Try, /*On fail goto*//*Label 4921*/ GIMT_Encode4(245060), // Rule ID 7032 //
     /* 244968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 244973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 244976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 244979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 244983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 244987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 244991 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 244995 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 244999 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 245003 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 245007 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 245011 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 245016 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(255),
     /* 245027 */     // MIs[0] addr
     /* 245027 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 245031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 245035 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
     /* 245039 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 245041 */     // (intrinsic_w_chain:{ *:[i32] } 1145:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 255:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 245041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
     /* 245044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 245046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 245050 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 245052 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 245058 */     GIR_RootConstrainSelectedInstOperands,
     /* 245059 */     // GIR_Coverage, 7032,
     /* 245059 */     GIR_EraseRootFromParent_Done,
     /* 245060 */   // Label 4921: @245060
     /* 245060 */   GIM_Try, /*On fail goto*//*Label 4922*/ GIMT_Encode4(245157), // Rule ID 7033 //
     /* 245065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 245070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 245073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 245076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 245080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 245084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 245088 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 245092 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 245096 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 245100 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 245104 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 245108 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 245113 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /* 245124 */     // MIs[0] addr
     /* 245124 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 245128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 245132 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
     /* 245136 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 245138 */     // (intrinsic_w_chain:{ *:[i32] } 1145:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 65535:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 245138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
     /* 245141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 245143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 245147 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 245149 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 245155 */     GIR_RootConstrainSelectedInstOperands,
     /* 245156 */     // GIR_Coverage, 7033,
     /* 245156 */     GIR_EraseRootFromParent_Done,
     /* 245157 */   // Label 4922: @245157
     /* 245157 */   GIM_Try, /*On fail goto*//*Label 4923*/ GIMT_Encode4(245268), // Rule ID 7025 //
     /* 245162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 245167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 245170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 245173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 245177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 245181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 245185 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 245189 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 245193 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 245198 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /* 245209 */     // MIs[0] addr
     /* 245209 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 245213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 245217 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
     /* 245221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 245223 */     // (intrinsic_w_chain:{ *:[i32] } 1147:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 255:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 245223 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 245226 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 245230 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 245235 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 245241 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 245246 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 245251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
     /* 245254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 245256 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 245259 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 245261 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 245266 */     GIR_RootConstrainSelectedInstOperands,
     /* 245267 */     // GIR_Coverage, 7025,
     /* 245267 */     GIR_EraseRootFromParent_Done,
     /* 245268 */   // Label 4923: @245268
     /* 245268 */   GIM_Try, /*On fail goto*//*Label 4924*/ GIMT_Encode4(245379), // Rule ID 7026 //
     /* 245273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 245278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 245281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 245284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 245288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 245292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 245296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 245300 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 245304 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 245309 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 245320 */     // MIs[0] addr
     /* 245320 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 245324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 245328 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
     /* 245332 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 245334 */     // (intrinsic_w_chain:{ *:[i32] } 1147:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 65535:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 245334 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 245337 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 245341 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 245346 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 245352 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 245357 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 245362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
     /* 245365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 245367 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 245370 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 245372 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 245377 */     GIR_RootConstrainSelectedInstOperands,
     /* 245378 */     // GIR_Coverage, 7026,
     /* 245378 */     GIR_EraseRootFromParent_Done,
     /* 245379 */   // Label 4924: @245379
     /* 245379 */   GIM_Try, /*On fail goto*//*Label 4925*/ GIMT_Encode4(245490), // Rule ID 7027 //
     /* 245384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 245389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 245392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 245395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 245399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 245403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 245407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 245411 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 245415 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 245420 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /* 245431 */     // MIs[0] addr
     /* 245431 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 245435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 245439 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
     /* 245443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 245445 */     // (intrinsic_w_chain:{ *:[i32] } 1147:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 4294967295:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 245445 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 245448 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 245452 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 245457 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 245463 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 245468 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 245473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
     /* 245476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 245478 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 245481 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 245483 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 245488 */     GIR_RootConstrainSelectedInstOperands,
     /* 245489 */     // GIR_Coverage, 7027,
     /* 245489 */     GIR_EraseRootFromParent_Done,
     /* 245490 */   // Label 4925: @245490
     /* 245490 */   GIM_Try, /*On fail goto*//*Label 4926*/ GIMT_Encode4(245601), // Rule ID 7035 //
     /* 245495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 245500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 245503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 245506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 245510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 245514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 245518 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 245522 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 245526 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 245531 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /* 245542 */     // MIs[0] addr
     /* 245542 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 245546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 245550 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
     /* 245554 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 245556 */     // (intrinsic_w_chain:{ *:[i32] } 1145:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 255:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 245556 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 245559 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 245563 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 245568 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 245574 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 245579 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 245584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
     /* 245587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 245589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 245592 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 245594 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 245599 */     GIR_RootConstrainSelectedInstOperands,
     /* 245600 */     // GIR_Coverage, 7035,
     /* 245600 */     GIR_EraseRootFromParent_Done,
     /* 245601 */   // Label 4926: @245601
     /* 245601 */   GIM_Try, /*On fail goto*//*Label 4927*/ GIMT_Encode4(245712), // Rule ID 7036 //
     /* 245606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 245611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 245614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 245617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 245621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 245625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 245629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 245633 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 245637 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 245642 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 245653 */     // MIs[0] addr
     /* 245653 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 245657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 245661 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
     /* 245665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 245667 */     // (intrinsic_w_chain:{ *:[i32] } 1145:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 65535:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 245667 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 245670 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 245674 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 245679 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 245685 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 245690 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 245695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
     /* 245698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 245700 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 245703 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 245705 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 245710 */     GIR_RootConstrainSelectedInstOperands,
     /* 245711 */     // GIR_Coverage, 7036,
     /* 245711 */     GIR_EraseRootFromParent_Done,
     /* 245712 */   // Label 4927: @245712
     /* 245712 */   GIM_Try, /*On fail goto*//*Label 4928*/ GIMT_Encode4(245823), // Rule ID 7037 //
     /* 245717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 245722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 245725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 245728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 245732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 245736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 245740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 245744 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 245748 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 245753 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /* 245764 */     // MIs[0] addr
     /* 245764 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 245768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 245772 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
     /* 245776 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 245778 */     // (intrinsic_w_chain:{ *:[i32] } 1145:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 4294967295:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 245778 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 245781 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 245785 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 245790 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 245796 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 245801 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 245806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
     /* 245809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 245811 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 245814 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 245816 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 245821 */     GIR_RootConstrainSelectedInstOperands,
     /* 245822 */     // GIR_Coverage, 7037,
     /* 245822 */     GIR_EraseRootFromParent_Done,
     /* 245823 */   // Label 4928: @245823
     /* 245823 */   GIM_Try, /*On fail goto*//*Label 4929*/ GIMT_Encode4(245874), // Rule ID 70 //
     /* 245828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_fixedshadow),
     /* 245833 */     // MIs[0] ptr
     /* 245833 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 245837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 245841 */     // MIs[0] accessinfo
     /* 245841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 245844 */     // MIs[0] fixed_shadow
     /* 245844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 245847 */     // (intrinsic_void 191:{ *:[iPTR] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)  =>  (HWASAN_CHECK_MEMACCESS_FIXEDSHADOW:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)
     /* 245847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_FIXEDSHADOW),
     /* 245850 */     GIR_RootToRootCopy, /*OpIdx*/1, // ptr
     /* 245852 */     GIR_RootToRootCopy, /*OpIdx*/2, // accessinfo
     /* 245854 */     GIR_RootToRootCopy, /*OpIdx*/3, // fixed_shadow
     /* 245856 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 245859 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 245862 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 245865 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 245868 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 245872 */     GIR_RootConstrainSelectedInstOperands,
     /* 245873 */     // GIR_Coverage, 70,
     /* 245873 */     GIR_EraseRootFromParent_Done,
     /* 245874 */   // Label 4929: @245874
     /* 245874 */   GIM_Try, /*On fail goto*//*Label 4930*/ GIMT_Encode4(245925), // Rule ID 71 //
     /* 245879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_shortgranules_fixedshadow),
     /* 245884 */     // MIs[0] ptr
     /* 245884 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 245888 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 245892 */     // MIs[0] accessinfo
     /* 245892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 245895 */     // MIs[0] fixed_shadow
     /* 245895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 245898 */     // (intrinsic_void 193:{ *:[iPTR] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)  =>  (HWASAN_CHECK_MEMACCESS_SHORTGRANULES_FIXEDSHADOW:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)
     /* 245898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_SHORTGRANULES_FIXEDSHADOW),
     /* 245901 */     GIR_RootToRootCopy, /*OpIdx*/1, // ptr
     /* 245903 */     GIR_RootToRootCopy, /*OpIdx*/2, // accessinfo
     /* 245905 */     GIR_RootToRootCopy, /*OpIdx*/3, // fixed_shadow
     /* 245907 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 245910 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 245913 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 245916 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 245919 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 245923 */     GIR_RootConstrainSelectedInstOperands,
     /* 245924 */     // GIR_Coverage, 71,
     /* 245924 */     GIR_EraseRootFromParent_Done,
     /* 245925 */   // Label 4930: @245925
     /* 245925 */   GIM_Try, /*On fail goto*//*Label 4931*/ GIMT_Encode4(245994), // Rule ID 7024 //
     /* 245930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 245935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 245938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 245941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 245945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 245949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 245953 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 245957 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 245962 */     // MIs[0] addr
     /* 245962 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 245966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 245970 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
     /* 245974 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 245976 */     // (intrinsic_w_chain:{ *:[i32] } 1147:{ *:[iPTR] }, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$val), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 245976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
     /* 245979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 245981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 245985 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 245987 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 245992 */     GIR_RootConstrainSelectedInstOperands,
     /* 245993 */     // GIR_Coverage, 7024,
     /* 245993 */     GIR_EraseRootFromParent_Done,
     /* 245994 */   // Label 4931: @245994
     /* 245994 */   GIM_Try, /*On fail goto*//*Label 4932*/ GIMT_Encode4(246063), // Rule ID 7034 //
     /* 245999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 246004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 246007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 246010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 246014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 246018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 246022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 246026 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 246031 */     // MIs[0] addr
     /* 246031 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 246035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 246039 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
     /* 246043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 246045 */     // (intrinsic_w_chain:{ *:[i32] } 1145:{ *:[iPTR] }, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$val), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 246045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
     /* 246048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 246050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 246054 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 246056 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 246061 */     GIR_RootConstrainSelectedInstOperands,
     /* 246062 */     // GIR_Coverage, 7034,
     /* 246062 */     GIR_EraseRootFromParent_Done,
     /* 246063 */   // Label 4932: @246063
     /* 246063 */   GIM_Try, /*On fail goto*//*Label 4933*/ GIMT_Encode4(246117), // Rule ID 8697 //
     /* 246068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 246076 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 246079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 246083 */     // MIs[0] base
     /* 246083 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 246087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 246091 */     // MIs[0] prfop
     /* 246091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 246094 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 246099 */     // (intrinsic_void 1540:{ *:[iPTR] }, PPR_3b:{ *:[nxv16i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv16i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 246099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_PRI),
     /* 246102 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 246104 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 246106 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 246108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 246111 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246115 */     GIR_RootConstrainSelectedInstOperands,
     /* 246116 */     // GIR_Coverage, 8697,
     /* 246116 */     GIR_EraseRootFromParent_Done,
     /* 246117 */   // Label 4933: @246117
     /* 246117 */   GIM_Try, /*On fail goto*//*Label 4934*/ GIMT_Encode4(246171), // Rule ID 8700 //
     /* 246122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 246130 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 246133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 246137 */     // MIs[0] base
     /* 246137 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 246141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 246145 */     // MIs[0] prfop
     /* 246145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 246148 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 246153 */     // (intrinsic_void 1540:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv8i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 246153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_PRI),
     /* 246156 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 246158 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 246160 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 246162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 246165 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246169 */     GIR_RootConstrainSelectedInstOperands,
     /* 246170 */     // GIR_Coverage, 8700,
     /* 246170 */     GIR_EraseRootFromParent_Done,
     /* 246171 */   // Label 4934: @246171
     /* 246171 */   GIM_Try, /*On fail goto*//*Label 4935*/ GIMT_Encode4(246225), // Rule ID 8703 //
     /* 246176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 246184 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 246187 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 246191 */     // MIs[0] base
     /* 246191 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 246195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 246199 */     // MIs[0] prfop
     /* 246199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 246202 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 246207 */     // (intrinsic_void 1540:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv4i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 246207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_PRI),
     /* 246210 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 246212 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 246214 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 246216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 246219 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246223 */     GIR_RootConstrainSelectedInstOperands,
     /* 246224 */     // GIR_Coverage, 8703,
     /* 246224 */     GIR_EraseRootFromParent_Done,
     /* 246225 */   // Label 4935: @246225
     /* 246225 */   GIM_Try, /*On fail goto*//*Label 4936*/ GIMT_Encode4(246279), // Rule ID 8706 //
     /* 246230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 246238 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 246241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 246245 */     // MIs[0] base
     /* 246245 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 246249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 246253 */     // MIs[0] prfop
     /* 246253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 246256 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 246261 */     // (intrinsic_void 1540:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv2i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 246261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_PRI),
     /* 246264 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 246266 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 246268 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 246270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 246273 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246277 */     GIR_RootConstrainSelectedInstOperands,
     /* 246278 */     // GIR_Coverage, 8706,
     /* 246278 */     GIR_EraseRootFromParent_Done,
     /* 246279 */   // Label 4936: @246279
     /* 246279 */   GIM_Try, /*On fail goto*//*Label 4937*/ GIMT_Encode4(246333), // Rule ID 15 //
     /* 246284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_space),
     /* 246289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 246292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 246295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 246298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 246302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 246306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 246310 */     // MIs[1] Operand 1
     /* 246310 */     // No operand predicates
     /* 246310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 246314 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 246316 */     // (intrinsic_w_chain:{ *:[i64] } 1138:{ *:[iPTR] }, (imm:{ *:[i32] }):$size, GPR64:{ *:[i64] }:$Rn)  =>  (SPACE:{ *:[i64] } (imm:{ *:[i32] }):$size, GPR64:{ *:[i64] }:$Rn)
     /* 246316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SPACE),
     /* 246319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 246321 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // size
     /* 246324 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 246326 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 246331 */     GIR_RootConstrainSelectedInstOperands,
     /* 246332 */     // GIR_Coverage, 15,
     /* 246332 */     GIR_EraseRootFromParent_Done,
     /* 246333 */   // Label 4937: @246333
     /* 246333 */   GIM_Try, /*On fail goto*//*Label 4938*/ GIMT_Encode4(246401), // Rule ID 68 //
     /* 246338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess),
     /* 246343 */     // MIs[0] Operand 1
     /* 246343 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 246347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64_with_sub_32_in_MatrixIndexGPR32_8_11RegClassID),
     /* 246351 */     // MIs[0] ptr
     /* 246351 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 246355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 246359 */     // MIs[0] accessinfo
     /* 246359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 246362 */     // (intrinsic_void 190:{ *:[iPTR] }, X9:{ *:[i64] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)  =>  (HWASAN_CHECK_MEMACCESS:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)
     /* 246362 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 246366 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::X9), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 246372 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // X9
     /* 246376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS),
     /* 246379 */     GIR_RootToRootCopy, /*OpIdx*/2, // ptr
     /* 246381 */     GIR_RootToRootCopy, /*OpIdx*/3, // accessinfo
     /* 246383 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 246386 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 246389 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 246392 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 246395 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246399 */     GIR_RootConstrainSelectedInstOperands,
     /* 246400 */     // GIR_Coverage, 68,
     /* 246400 */     GIR_EraseRootFromParent_Done,
     /* 246401 */   // Label 4938: @246401
     /* 246401 */   GIM_Try, /*On fail goto*//*Label 4939*/ GIMT_Encode4(246469), // Rule ID 69 //
     /* 246406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_shortgranules),
     /* 246411 */     // MIs[0] Operand 1
     /* 246411 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 246415 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64common_and_GPR64noipRegClassID),
     /* 246419 */     // MIs[0] ptr
     /* 246419 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 246423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 246427 */     // MIs[0] accessinfo
     /* 246427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 246430 */     // (intrinsic_void 192:{ *:[iPTR] }, X20:{ *:[i64] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)  =>  (HWASAN_CHECK_MEMACCESS_SHORTGRANULES:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)
     /* 246430 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 246434 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::X20), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 246440 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // X20
     /* 246444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_SHORTGRANULES),
     /* 246447 */     GIR_RootToRootCopy, /*OpIdx*/2, // ptr
     /* 246449 */     GIR_RootToRootCopy, /*OpIdx*/3, // accessinfo
     /* 246451 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 246454 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 246457 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 246460 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 246463 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246467 */     GIR_RootConstrainSelectedInstOperands,
     /* 246468 */     // GIR_Coverage, 69,
     /* 246468 */     GIR_EraseRootFromParent_Done,
     /* 246469 */   // Label 4939: @246469
     /* 246469 */   GIM_Try, /*On fail goto*//*Label 4940*/ GIMT_Encode4(246549), // Rule ID 7018 //
     /* 246474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 246479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 246482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 246485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 246489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 246493 */     // MIs[0] addr
     /* 246493 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 246497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 246501 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
     /* 246505 */     // (intrinsic_w_chain:{ *:[i32] } 1147:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 246505 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 246508 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 246512 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 246517 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 246523 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 246528 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 246533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
     /* 246536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 246538 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 246541 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 246543 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246547 */     GIR_RootConstrainSelectedInstOperands,
     /* 246548 */     // GIR_Coverage, 7018,
     /* 246548 */     GIR_EraseRootFromParent_Done,
     /* 246549 */   // Label 4940: @246549
     /* 246549 */   GIM_Try, /*On fail goto*//*Label 4941*/ GIMT_Encode4(246629), // Rule ID 7019 //
     /* 246554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 246559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 246562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 246565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 246569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 246573 */     // MIs[0] addr
     /* 246573 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 246577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 246581 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
     /* 246585 */     // (intrinsic_w_chain:{ *:[i32] } 1147:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 246585 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 246588 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 246592 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 246597 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 246603 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 246608 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 246613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
     /* 246616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 246618 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 246621 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 246623 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246627 */     GIR_RootConstrainSelectedInstOperands,
     /* 246628 */     // GIR_Coverage, 7019,
     /* 246628 */     GIR_EraseRootFromParent_Done,
     /* 246629 */   // Label 4941: @246629
     /* 246629 */   GIM_Try, /*On fail goto*//*Label 4942*/ GIMT_Encode4(246709), // Rule ID 7020 //
     /* 246634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 246639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 246642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 246645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 246649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 246653 */     // MIs[0] addr
     /* 246653 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 246657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 246661 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
     /* 246665 */     // (intrinsic_w_chain:{ *:[i32] } 1147:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 246665 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 246668 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 246672 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 246677 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 246683 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 246688 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 246693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
     /* 246696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 246698 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 246701 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 246703 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246707 */     GIR_RootConstrainSelectedInstOperands,
     /* 246708 */     // GIR_Coverage, 7020,
     /* 246708 */     GIR_EraseRootFromParent_Done,
     /* 246709 */   // Label 4942: @246709
     /* 246709 */   GIM_Try, /*On fail goto*//*Label 4943*/ GIMT_Encode4(246760), // Rule ID 7021 //
     /* 246714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 246719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 246722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 246725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 246729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 246733 */     // MIs[0] addr
     /* 246733 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 246737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 246741 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_8),
     /* 246745 */     // (intrinsic_w_chain:{ *:[i32] } 1147:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_8>>  =>  (STXRX:{ *:[i32] } GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 246745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRX),
     /* 246748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 246750 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /* 246752 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 246754 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246758 */     GIR_RootConstrainSelectedInstOperands,
     /* 246759 */     // GIR_Coverage, 7021,
     /* 246759 */     GIR_EraseRootFromParent_Done,
     /* 246760 */   // Label 4943: @246760
     /* 246760 */   GIM_Try, /*On fail goto*//*Label 4944*/ GIMT_Encode4(246840), // Rule ID 7028 //
     /* 246765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 246770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 246773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 246776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 246780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 246784 */     // MIs[0] addr
     /* 246784 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 246788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 246792 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
     /* 246796 */     // (intrinsic_w_chain:{ *:[i32] } 1145:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 246796 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 246799 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 246803 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 246808 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 246814 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 246819 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 246824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
     /* 246827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 246829 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 246832 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 246834 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246838 */     GIR_RootConstrainSelectedInstOperands,
     /* 246839 */     // GIR_Coverage, 7028,
     /* 246839 */     GIR_EraseRootFromParent_Done,
     /* 246840 */   // Label 4944: @246840
     /* 246840 */   GIM_Try, /*On fail goto*//*Label 4945*/ GIMT_Encode4(246920), // Rule ID 7029 //
     /* 246845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 246850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 246853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 246856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 246860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 246864 */     // MIs[0] addr
     /* 246864 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 246868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 246872 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
     /* 246876 */     // (intrinsic_w_chain:{ *:[i32] } 1145:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 246876 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 246879 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 246883 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 246888 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 246894 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 246899 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 246904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
     /* 246907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 246909 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 246912 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 246914 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246918 */     GIR_RootConstrainSelectedInstOperands,
     /* 246919 */     // GIR_Coverage, 7029,
     /* 246919 */     GIR_EraseRootFromParent_Done,
     /* 246920 */   // Label 4945: @246920
     /* 246920 */   GIM_Try, /*On fail goto*//*Label 4946*/ GIMT_Encode4(247000), // Rule ID 7030 //
     /* 246925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 246930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 246933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 246936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 246940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 246944 */     // MIs[0] addr
     /* 246944 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 246948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 246952 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
     /* 246956 */     // (intrinsic_w_chain:{ *:[i32] } 1145:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 246956 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 246959 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 246963 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 246968 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 246974 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 246979 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 246984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
     /* 246987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 246989 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 246992 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 246994 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 246998 */     GIR_RootConstrainSelectedInstOperands,
     /* 246999 */     // GIR_Coverage, 7030,
     /* 246999 */     GIR_EraseRootFromParent_Done,
     /* 247000 */   // Label 4946: @247000
     /* 247000 */   GIM_Try, /*On fail goto*//*Label 4947*/ GIMT_Encode4(247051), // Rule ID 7031 //
     /* 247005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 247010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 247013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 247016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 247020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 247024 */     // MIs[0] addr
     /* 247024 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 247028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 247032 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_8),
     /* 247036 */     // (intrinsic_w_chain:{ *:[i32] } 1145:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_8>>  =>  (STLXRX:{ *:[i32] } GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 247036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRX),
     /* 247039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 247041 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /* 247043 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 247045 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247049 */     GIR_RootConstrainSelectedInstOperands,
     /* 247050 */     // GIR_Coverage, 7031,
     /* 247050 */     GIR_EraseRootFromParent_Done,
     /* 247051 */   // Label 4947: @247051
     /* 247051 */   GIM_Try, /*On fail goto*//*Label 4948*/ GIMT_Encode4(247100), // Rule ID 2479 //
     /* 247056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 247059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn),
     /* 247064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 247067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 247070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 247073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 247077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 247081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 247085 */     // (intrinsic_w_chain:{ *:[v8i8] } 613:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCVTN_F16v8f8:{ *:[v8i8] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 247085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F16v8f8),
     /* 247088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 247090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 247092 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 247094 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247098 */     GIR_RootConstrainSelectedInstOperands,
     /* 247099 */     // GIR_Coverage, 2479,
     /* 247099 */     GIR_EraseRootFromParent_Done,
     /* 247100 */   // Label 4948: @247100
     /* 247100 */   GIM_Try, /*On fail goto*//*Label 4949*/ GIMT_Encode4(247149), // Rule ID 2480 //
     /* 247105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 247108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn),
     /* 247113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 247116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 247119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 247122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 247126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 247130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 247134 */     // (intrinsic_w_chain:{ *:[v16i8] } 613:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTN_F16v16f8:{ *:[v16i8] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 247134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F16v16f8),
     /* 247137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 247139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 247141 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 247143 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247147 */     GIR_RootConstrainSelectedInstOperands,
     /* 247148 */     // GIR_Coverage, 2480,
     /* 247148 */     GIR_EraseRootFromParent_Done,
     /* 247149 */   // Label 4949: @247149
     /* 247149 */   GIM_Try, /*On fail goto*//*Label 4950*/ GIMT_Encode4(247198), // Rule ID 2481 //
     /* 247154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 247157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn),
     /* 247162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 247165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 247168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 247171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 247175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 247179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 247183 */     // (intrinsic_w_chain:{ *:[v8i8] } 613:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCVTN_F32v8f8:{ *:[v8i8] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 247183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F32v8f8),
     /* 247186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 247188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 247190 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 247192 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247196 */     GIR_RootConstrainSelectedInstOperands,
     /* 247197 */     // GIR_Coverage, 2481,
     /* 247197 */     GIR_EraseRootFromParent_Done,
     /* 247198 */   // Label 4950: @247198
     /* 247198 */   GIM_Try, /*On fail goto*//*Label 4951*/ GIMT_Encode4(247251), // Rule ID 8583 //
     /* 247203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1uwq),
     /* 247211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 247217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 247225 */     // MIs[0] base
     /* 247225 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 247229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 247233 */     // (intrinsic_w_chain:{ *:[nxv4i32] } 1473:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1W_Q_IMM:{ *:[nxv4i32] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 247233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_Q_IMM),
     /* 247236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 247238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 247240 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 247242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 247245 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247249 */     GIR_RootConstrainSelectedInstOperands,
     /* 247250 */     // GIR_Coverage, 8583,
     /* 247250 */     GIR_EraseRootFromParent_Done,
     /* 247251 */   // Label 4951: @247251
     /* 247251 */   GIM_Try, /*On fail goto*//*Label 4952*/ GIMT_Encode4(247304), // Rule ID 8586 //
     /* 247256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1uwq),
     /* 247264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 247270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 247278 */     // MIs[0] base
     /* 247278 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 247282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 247286 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1473:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1W_Q_IMM:{ *:[nxv4f32] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 247286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_Q_IMM),
     /* 247289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 247291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 247293 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 247295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 247298 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247302 */     GIR_RootConstrainSelectedInstOperands,
     /* 247303 */     // GIR_Coverage, 8586,
     /* 247303 */     GIR_EraseRootFromParent_Done,
     /* 247304 */   // Label 4952: @247304
     /* 247304 */   GIM_Try, /*On fail goto*//*Label 4953*/ GIMT_Encode4(247357), // Rule ID 8595 //
     /* 247309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1udq),
     /* 247317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 247323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 247331 */     // MIs[0] base
     /* 247331 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 247335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 247339 */     // (intrinsic_w_chain:{ *:[nxv2i64] } 1472:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1D_Q_IMM:{ *:[nxv2i64] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 247339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_Q_IMM),
     /* 247342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 247344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 247346 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 247348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 247351 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247355 */     GIR_RootConstrainSelectedInstOperands,
     /* 247356 */     // GIR_Coverage, 8595,
     /* 247356 */     GIR_EraseRootFromParent_Done,
     /* 247357 */   // Label 4953: @247357
     /* 247357 */   GIM_Try, /*On fail goto*//*Label 4954*/ GIMT_Encode4(247410), // Rule ID 8598 //
     /* 247362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1udq),
     /* 247370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 247376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 247384 */     // MIs[0] base
     /* 247384 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 247388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 247392 */     // (intrinsic_w_chain:{ *:[nxv2f64] } 1472:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1D_Q_IMM:{ *:[nxv2f64] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 247392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_Q_IMM),
     /* 247395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 247397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 247399 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 247401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 247404 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247408 */     GIR_RootConstrainSelectedInstOperands,
     /* 247409 */     // GIR_Coverage, 8598,
     /* 247409 */     GIR_EraseRootFromParent_Done,
     /* 247410 */   // Label 4954: @247410
     /* 247410 */   GIM_Try, /*On fail goto*//*Label 4955*/ GIMT_Encode4(247456), // Rule ID 137 //
     /* 247415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 247418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_irg),
     /* 247423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 247426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 247429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 247433 */     // MIs[0] Rn
     /* 247433 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 247437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 247441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 247445 */     // (intrinsic_w_chain:{ *:[i64] } 558:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (IRG:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 247445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::IRG),
     /* 247448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 247450 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 247452 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 247454 */     GIR_RootConstrainSelectedInstOperands,
     /* 247455 */     // GIR_Coverage, 137,
     /* 247455 */     GIR_EraseRootFromParent_Done,
     /* 247456 */   // Label 4955: @247456
     /* 247456 */   GIM_Try, /*On fail goto*//*Label 4956*/ GIMT_Encode4(247509), // Rule ID 8589 //
     /* 247461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1wq),
     /* 247469 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 247472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 247475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 247483 */     // MIs[0] base
     /* 247483 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 247487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 247491 */     // (intrinsic_void 1793:{ *:[iPTR] }, ZPR128:{ *:[nxv4i32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1W_Q_IMM Z_q:{ *:[nxv4i32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 247491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_Q_IMM),
     /* 247494 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 247496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 247498 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 247500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 247503 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247507 */     GIR_RootConstrainSelectedInstOperands,
     /* 247508 */     // GIR_Coverage, 8589,
     /* 247508 */     GIR_EraseRootFromParent_Done,
     /* 247509 */   // Label 4956: @247509
     /* 247509 */   GIM_Try, /*On fail goto*//*Label 4957*/ GIMT_Encode4(247562), // Rule ID 8592 //
     /* 247514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1wq),
     /* 247522 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 247525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 247528 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 247536 */     // MIs[0] base
     /* 247536 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 247540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 247544 */     // (intrinsic_void 1793:{ *:[iPTR] }, ZPR128:{ *:[nxv4f32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1W_Q_IMM Z_q:{ *:[nxv4f32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 247544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_Q_IMM),
     /* 247547 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 247549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 247551 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 247553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 247556 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247560 */     GIR_RootConstrainSelectedInstOperands,
     /* 247561 */     // GIR_Coverage, 8592,
     /* 247561 */     GIR_EraseRootFromParent_Done,
     /* 247562 */   // Label 4957: @247562
     /* 247562 */   GIM_Try, /*On fail goto*//*Label 4958*/ GIMT_Encode4(247615), // Rule ID 8601 //
     /* 247567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1dq),
     /* 247575 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 247578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 247581 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 247589 */     // MIs[0] base
     /* 247589 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 247593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 247597 */     // (intrinsic_void 1789:{ *:[iPTR] }, ZPR128:{ *:[nxv2i64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1D_Q_IMM Z_q:{ *:[nxv2i64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 247597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_Q_IMM),
     /* 247600 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 247602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 247604 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 247606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 247609 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247613 */     GIR_RootConstrainSelectedInstOperands,
     /* 247614 */     // GIR_Coverage, 8601,
     /* 247614 */     GIR_EraseRootFromParent_Done,
     /* 247615 */   // Label 4958: @247615
     /* 247615 */   GIM_Try, /*On fail goto*//*Label 4959*/ GIMT_Encode4(247668), // Rule ID 8604 //
     /* 247620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1dq),
     /* 247628 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 247631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 247634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 247642 */     // MIs[0] base
     /* 247642 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 247646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 247650 */     // (intrinsic_void 1789:{ *:[iPTR] }, ZPR128:{ *:[nxv2f64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1D_Q_IMM Z_q:{ *:[nxv2f64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 247650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_Q_IMM),
     /* 247653 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 247655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 247657 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 247659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 247662 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247666 */     GIR_RootConstrainSelectedInstOperands,
     /* 247667 */     // GIR_Coverage, 8604,
     /* 247667 */     GIR_EraseRootFromParent_Done,
     /* 247668 */   // Label 4959: @247668
     /* 247668 */   GIM_Reject,
     /* 247669 */ // Label 4918: @247669
     /* 247669 */ GIM_Try, /*On fail goto*//*Label 4960*/ GIMT_Encode4(250374),
     /* 247674 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /* 247677 */   GIM_Try, /*On fail goto*//*Label 4961*/ GIMT_Encode4(247748), // Rule ID 3393 //
     /* 247682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 247685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_scalar_offset),
     /* 247690 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 247693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 247699 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 247703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 247711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 247715 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 247719 */     // MIs[1] Operand 1
     /* 247719 */     // No operand predicates
     /* 247719 */     // MIs[0] prfop
     /* 247719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 247722 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 247727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 247729 */     // (intrinsic_void 1542:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR32:{ *:[nxv4i32] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_PZI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR32:{ *:[nxv4i32] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
     /* 247729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_PZI),
     /* 247732 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 247734 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 247736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 247738 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 247741 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 247746 */     GIR_RootConstrainSelectedInstOperands,
     /* 247747 */     // GIR_Coverage, 3393,
     /* 247747 */     GIR_EraseRootFromParent_Done,
     /* 247748 */   // Label 4961: @247748
     /* 247748 */   GIM_Try, /*On fail goto*//*Label 4962*/ GIMT_Encode4(247819), // Rule ID 3406 //
     /* 247753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 247756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_scalar_offset),
     /* 247761 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 247764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 247770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 247774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 247782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 247786 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 247790 */     // MIs[1] Operand 1
     /* 247790 */     // No operand predicates
     /* 247790 */     // MIs[0] prfop
     /* 247790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 247793 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 247798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 247800 */     // (intrinsic_void 1542:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR32:{ *:[nxv2i64] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_PZI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR32:{ *:[nxv2i64] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
     /* 247800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_PZI),
     /* 247803 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 247805 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 247807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 247809 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 247812 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 247817 */     GIR_RootConstrainSelectedInstOperands,
     /* 247818 */     // GIR_Coverage, 3406,
     /* 247818 */     GIR_EraseRootFromParent_Done,
     /* 247819 */   // Label 4962: @247819
     /* 247819 */   GIM_Try, /*On fail goto*//*Label 4963*/ GIMT_Encode4(247878), // Rule ID 3581 //
     /* 247824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 247827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addha),
     /* 247832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 247838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247841 */     // MIs[0] tile
     /* 247841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 247844 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 247849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 247853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 247857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247861 */     // (intrinsic_void 797:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$pn, PPR3bAny:{ *:[nxv4i1] }:$pm, ZPR32:{ *:[nxv4i32] }:$zn)  =>  (ADDHA_MPPZ_S_PSEUDO_S (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, ?:{ *:[nxv4i1] }:$pn, ?:{ *:[nxv4i1] }:$pm, ?:{ *:[nxv4i32] }:$zn)
     /* 247861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHA_MPPZ_S_PSEUDO_S),
     /* 247864 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 247866 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 247868 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 247870 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 247872 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247876 */     GIR_RootConstrainSelectedInstOperands,
     /* 247877 */     // GIR_Coverage, 3581,
     /* 247877 */     GIR_EraseRootFromParent_Done,
     /* 247878 */   // Label 4963: @247878
     /* 247878 */   GIM_Try, /*On fail goto*//*Label 4964*/ GIMT_Encode4(247937), // Rule ID 3582 //
     /* 247883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 247886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addha),
     /* 247891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 247894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 247897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247900 */     // MIs[0] tile
     /* 247900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 247903 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 247908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 247912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 247916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247920 */     // (intrinsic_void 797:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$pn, PPR3bAny:{ *:[nxv2i1] }:$pm, ZPR64:{ *:[nxv2i64] }:$zn)  =>  (ADDHA_MPPZ_D_PSEUDO_D (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, ?:{ *:[nxv2i1] }:$pn, ?:{ *:[nxv2i1] }:$pm, ?:{ *:[nxv2i64] }:$zn)
     /* 247920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHA_MPPZ_D_PSEUDO_D),
     /* 247923 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 247925 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 247927 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 247929 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 247931 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247935 */     GIR_RootConstrainSelectedInstOperands,
     /* 247936 */     // GIR_Coverage, 3582,
     /* 247936 */     GIR_EraseRootFromParent_Done,
     /* 247937 */   // Label 4964: @247937
     /* 247937 */   GIM_Try, /*On fail goto*//*Label 4965*/ GIMT_Encode4(247996), // Rule ID 12364 //
     /* 247942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 247945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addva),
     /* 247950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 247956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247959 */     // MIs[0] tile
     /* 247959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 247962 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 247967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 247971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 247975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247979 */     // (intrinsic_void 798:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$pn, PPR3bAny:{ *:[nxv4i1] }:$pm, ZPR32:{ *:[nxv4i32] }:$zn)  =>  (ADDVA_MPPZ_S_PSEUDO_S (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, ?:{ *:[nxv4i1] }:$pn, ?:{ *:[nxv4i1] }:$pm, ?:{ *:[nxv4i32] }:$zn)
     /* 247979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVA_MPPZ_S_PSEUDO_S),
     /* 247982 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 247984 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 247986 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 247988 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 247990 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 247994 */     GIR_RootConstrainSelectedInstOperands,
     /* 247995 */     // GIR_Coverage, 12364,
     /* 247995 */     GIR_EraseRootFromParent_Done,
     /* 247996 */   // Label 4965: @247996
     /* 247996 */   GIM_Try, /*On fail goto*//*Label 4966*/ GIMT_Encode4(248055), // Rule ID 12365 //
     /* 248001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 248004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addva),
     /* 248009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 248015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248018 */     // MIs[0] tile
     /* 248018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 248021 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 248026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 248030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 248034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248038 */     // (intrinsic_void 798:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$pn, PPR3bAny:{ *:[nxv2i1] }:$pm, ZPR64:{ *:[nxv2i64] }:$zn)  =>  (ADDVA_MPPZ_D_PSEUDO_D (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, ?:{ *:[nxv2i1] }:$pn, ?:{ *:[nxv2i1] }:$pm, ?:{ *:[nxv2i64] }:$zn)
     /* 248038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVA_MPPZ_D_PSEUDO_D),
     /* 248041 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 248043 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 248045 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 248047 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 248049 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248053 */     GIR_RootConstrainSelectedInstOperands,
     /* 248054 */     // GIR_Coverage, 12365,
     /* 248054 */     GIR_EraseRootFromParent_Done,
     /* 248055 */   // Label 4966: @248055
     /* 248055 */   GIM_Try, /*On fail goto*//*Label 4967*/ GIMT_Encode4(248115), // Rule ID 3391 //
     /* 248060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 248063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_uxtw_index),
     /* 248068 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 248071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248074 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 248078 */     // MIs[0] Rn
     /* 248078 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 248082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 248086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248090 */     // MIs[0] prfop
     /* 248090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 248093 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 248098 */     // (intrinsic_void 1544:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW8Only:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW8Only:{ *:[nxv4i32] }:$Zm)
     /* 248098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_UXTW_SCALED),
     /* 248101 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 248103 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 248105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 248107 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 248109 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248113 */     GIR_RootConstrainSelectedInstOperands,
     /* 248114 */     // GIR_Coverage, 3391,
     /* 248114 */     GIR_EraseRootFromParent_Done,
     /* 248115 */   // Label 4967: @248115
     /* 248115 */   GIM_Try, /*On fail goto*//*Label 4968*/ GIMT_Encode4(248175), // Rule ID 3392 //
     /* 248120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 248123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_sxtw_index),
     /* 248128 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 248131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 248138 */     // MIs[0] Rn
     /* 248138 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 248142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 248146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248150 */     // MIs[0] prfop
     /* 248150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 248153 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 248158 */     // (intrinsic_void 1543:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW8Only:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW8Only:{ *:[nxv4i32] }:$Zm)
     /* 248158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_SXTW_SCALED),
     /* 248161 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 248163 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 248165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 248167 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 248169 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248173 */     GIR_RootConstrainSelectedInstOperands,
     /* 248174 */     // GIR_Coverage, 3392,
     /* 248174 */     GIR_EraseRootFromParent_Done,
     /* 248175 */   // Label 4968: @248175
     /* 248175 */   GIM_Try, /*On fail goto*//*Label 4969*/ GIMT_Encode4(248235), // Rule ID 3403 //
     /* 248180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 248183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_uxtw_index),
     /* 248188 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 248191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248194 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 248198 */     // MIs[0] Rn
     /* 248198 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 248202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 248206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248210 */     // MIs[0] prfop
     /* 248210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 248213 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 248218 */     // (intrinsic_void 1544:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW8Only:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW8Only:{ *:[nxv2i64] }:$Zm)
     /* 248218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_UXTW_SCALED),
     /* 248221 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 248223 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 248225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 248227 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 248229 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248233 */     GIR_RootConstrainSelectedInstOperands,
     /* 248234 */     // GIR_Coverage, 3403,
     /* 248234 */     GIR_EraseRootFromParent_Done,
     /* 248235 */   // Label 4969: @248235
     /* 248235 */   GIM_Try, /*On fail goto*//*Label 4970*/ GIMT_Encode4(248295), // Rule ID 3404 //
     /* 248240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 248243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_sxtw_index),
     /* 248248 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 248251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248254 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 248258 */     // MIs[0] Rn
     /* 248258 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 248262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 248266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248270 */     // MIs[0] prfop
     /* 248270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 248273 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 248278 */     // (intrinsic_void 1543:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW8Only:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW8Only:{ *:[nxv2i64] }:$Zm)
     /* 248278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_SXTW_SCALED),
     /* 248281 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 248283 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 248285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 248287 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 248289 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248293 */     GIR_RootConstrainSelectedInstOperands,
     /* 248294 */     // GIR_Coverage, 3404,
     /* 248294 */     GIR_EraseRootFromParent_Done,
     /* 248295 */   // Label 4970: @248295
     /* 248295 */   GIM_Try, /*On fail goto*//*Label 4971*/ GIMT_Encode4(248355), // Rule ID 3405 //
     /* 248300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 248303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_index),
     /* 248308 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 248311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248314 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 248318 */     // MIs[0] Rn
     /* 248318 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 248322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 248326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248330 */     // MIs[0] prfop
     /* 248330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 248333 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 248338 */     // (intrinsic_void 1541:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL8:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL8:{ *:[nxv2i64] }:$Zm)
     /* 248338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_SCALED),
     /* 248341 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 248343 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 248345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 248347 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 248349 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248353 */     GIR_RootConstrainSelectedInstOperands,
     /* 248354 */     // GIR_Coverage, 3405,
     /* 248354 */     GIR_EraseRootFromParent_Done,
     /* 248355 */   // Label 4971: @248355
     /* 248355 */   GIM_Try, /*On fail goto*//*Label 4972*/ GIMT_Encode4(248415), // Rule ID 8709 //
     /* 248360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 248363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_uxtw_index),
     /* 248368 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 248371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 248378 */     // MIs[0] Rn
     /* 248378 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 248382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 248386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248390 */     // MIs[0] prfop
     /* 248390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 248393 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 248398 */     // (intrinsic_void 1552:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW16:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW16:{ *:[nxv4i32] }:$Zm)
     /* 248398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_S_UXTW_SCALED),
     /* 248401 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 248403 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 248405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 248407 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 248409 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248413 */     GIR_RootConstrainSelectedInstOperands,
     /* 248414 */     // GIR_Coverage, 8709,
     /* 248414 */     GIR_EraseRootFromParent_Done,
     /* 248415 */   // Label 4972: @248415
     /* 248415 */   GIM_Try, /*On fail goto*//*Label 4973*/ GIMT_Encode4(248475), // Rule ID 8710 //
     /* 248420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 248423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_sxtw_index),
     /* 248428 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 248431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 248438 */     // MIs[0] Rn
     /* 248438 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 248442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 248446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248450 */     // MIs[0] prfop
     /* 248450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 248453 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 248458 */     // (intrinsic_void 1551:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW16:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW16:{ *:[nxv4i32] }:$Zm)
     /* 248458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_S_SXTW_SCALED),
     /* 248461 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 248463 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 248465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 248467 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 248469 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248473 */     GIR_RootConstrainSelectedInstOperands,
     /* 248474 */     // GIR_Coverage, 8710,
     /* 248474 */     GIR_EraseRootFromParent_Done,
     /* 248475 */   // Label 4973: @248475
     /* 248475 */   GIM_Try, /*On fail goto*//*Label 4974*/ GIMT_Encode4(248535), // Rule ID 8711 //
     /* 248480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 248483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_uxtw_index),
     /* 248488 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 248491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 248498 */     // MIs[0] Rn
     /* 248498 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 248502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 248506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248510 */     // MIs[0] prfop
     /* 248510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 248513 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 248518 */     // (intrinsic_void 1556:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW32:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW32:{ *:[nxv4i32] }:$Zm)
     /* 248518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_S_UXTW_SCALED),
     /* 248521 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 248523 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 248525 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 248527 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 248529 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248533 */     GIR_RootConstrainSelectedInstOperands,
     /* 248534 */     // GIR_Coverage, 8711,
     /* 248534 */     GIR_EraseRootFromParent_Done,
     /* 248535 */   // Label 4974: @248535
     /* 248535 */   GIM_Try, /*On fail goto*//*Label 4975*/ GIMT_Encode4(248595), // Rule ID 8712 //
     /* 248540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 248543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_sxtw_index),
     /* 248548 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 248551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248554 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 248558 */     // MIs[0] Rn
     /* 248558 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 248562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 248566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248570 */     // MIs[0] prfop
     /* 248570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 248573 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 248578 */     // (intrinsic_void 1555:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW32:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW32:{ *:[nxv4i32] }:$Zm)
     /* 248578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_S_SXTW_SCALED),
     /* 248581 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 248583 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 248585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 248587 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 248589 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248593 */     GIR_RootConstrainSelectedInstOperands,
     /* 248594 */     // GIR_Coverage, 8712,
     /* 248594 */     GIR_EraseRootFromParent_Done,
     /* 248595 */   // Label 4975: @248595
     /* 248595 */   GIM_Try, /*On fail goto*//*Label 4976*/ GIMT_Encode4(248655), // Rule ID 8713 //
     /* 248600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 248603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_uxtw_index),
     /* 248608 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 248611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248614 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 248618 */     // MIs[0] Rn
     /* 248618 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 248622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 248626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248630 */     // MIs[0] prfop
     /* 248630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 248633 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 248638 */     // (intrinsic_void 1548:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW64:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW64:{ *:[nxv4i32] }:$Zm)
     /* 248638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_S_UXTW_SCALED),
     /* 248641 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 248643 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 248645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 248647 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 248649 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248653 */     GIR_RootConstrainSelectedInstOperands,
     /* 248654 */     // GIR_Coverage, 8713,
     /* 248654 */     GIR_EraseRootFromParent_Done,
     /* 248655 */   // Label 4976: @248655
     /* 248655 */   GIM_Try, /*On fail goto*//*Label 4977*/ GIMT_Encode4(248715), // Rule ID 8714 //
     /* 248660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 248663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_sxtw_index),
     /* 248668 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 248671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 248678 */     // MIs[0] Rn
     /* 248678 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 248682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 248686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248690 */     // MIs[0] prfop
     /* 248690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 248693 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 248698 */     // (intrinsic_void 1547:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW64:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW64:{ *:[nxv4i32] }:$Zm)
     /* 248698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_S_SXTW_SCALED),
     /* 248701 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 248703 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 248705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 248707 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 248709 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248713 */     GIR_RootConstrainSelectedInstOperands,
     /* 248714 */     // GIR_Coverage, 8714,
     /* 248714 */     GIR_EraseRootFromParent_Done,
     /* 248715 */   // Label 4977: @248715
     /* 248715 */   GIM_Try, /*On fail goto*//*Label 4978*/ GIMT_Encode4(248775), // Rule ID 8715 //
     /* 248720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 248723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_uxtw_index),
     /* 248728 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 248731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248734 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 248738 */     // MIs[0] Rn
     /* 248738 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 248742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 248746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248750 */     // MIs[0] prfop
     /* 248750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 248753 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 248758 */     // (intrinsic_void 1552:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW16:{ *:[nxv2i64] }:$Zm)
     /* 248758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_UXTW_SCALED),
     /* 248761 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 248763 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 248765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 248767 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 248769 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248773 */     GIR_RootConstrainSelectedInstOperands,
     /* 248774 */     // GIR_Coverage, 8715,
     /* 248774 */     GIR_EraseRootFromParent_Done,
     /* 248775 */   // Label 4978: @248775
     /* 248775 */   GIM_Try, /*On fail goto*//*Label 4979*/ GIMT_Encode4(248835), // Rule ID 8716 //
     /* 248780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 248783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_sxtw_index),
     /* 248788 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 248791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 248798 */     // MIs[0] Rn
     /* 248798 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 248802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 248806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248810 */     // MIs[0] prfop
     /* 248810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 248813 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 248818 */     // (intrinsic_void 1551:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW16:{ *:[nxv2i64] }:$Zm)
     /* 248818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_SXTW_SCALED),
     /* 248821 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 248823 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 248825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 248827 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 248829 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248833 */     GIR_RootConstrainSelectedInstOperands,
     /* 248834 */     // GIR_Coverage, 8716,
     /* 248834 */     GIR_EraseRootFromParent_Done,
     /* 248835 */   // Label 4979: @248835
     /* 248835 */   GIM_Try, /*On fail goto*//*Label 4980*/ GIMT_Encode4(248895), // Rule ID 8717 //
     /* 248840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 248843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_uxtw_index),
     /* 248848 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 248851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 248858 */     // MIs[0] Rn
     /* 248858 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 248862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 248866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248870 */     // MIs[0] prfop
     /* 248870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 248873 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 248878 */     // (intrinsic_void 1556:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW32:{ *:[nxv2i64] }:$Zm)
     /* 248878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_UXTW_SCALED),
     /* 248881 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 248883 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 248885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 248887 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 248889 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248893 */     GIR_RootConstrainSelectedInstOperands,
     /* 248894 */     // GIR_Coverage, 8717,
     /* 248894 */     GIR_EraseRootFromParent_Done,
     /* 248895 */   // Label 4980: @248895
     /* 248895 */   GIM_Try, /*On fail goto*//*Label 4981*/ GIMT_Encode4(248955), // Rule ID 8718 //
     /* 248900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 248903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_sxtw_index),
     /* 248908 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 248911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 248918 */     // MIs[0] Rn
     /* 248918 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 248922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 248926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248930 */     // MIs[0] prfop
     /* 248930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 248933 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 248938 */     // (intrinsic_void 1555:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW32:{ *:[nxv2i64] }:$Zm)
     /* 248938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_SXTW_SCALED),
     /* 248941 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 248943 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 248945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 248947 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 248949 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248953 */     GIR_RootConstrainSelectedInstOperands,
     /* 248954 */     // GIR_Coverage, 8718,
     /* 248954 */     GIR_EraseRootFromParent_Done,
     /* 248955 */   // Label 4981: @248955
     /* 248955 */   GIM_Try, /*On fail goto*//*Label 4982*/ GIMT_Encode4(249015), // Rule ID 8719 //
     /* 248960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 248963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_uxtw_index),
     /* 248968 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 248971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 248978 */     // MIs[0] Rn
     /* 248978 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 248982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 248986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248990 */     // MIs[0] prfop
     /* 248990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 248993 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 248998 */     // (intrinsic_void 1548:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW64:{ *:[nxv2i64] }:$Zm)
     /* 248998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_UXTW_SCALED),
     /* 249001 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 249003 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 249005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 249007 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 249009 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249013 */     GIR_RootConstrainSelectedInstOperands,
     /* 249014 */     // GIR_Coverage, 8719,
     /* 249014 */     GIR_EraseRootFromParent_Done,
     /* 249015 */   // Label 4982: @249015
     /* 249015 */   GIM_Try, /*On fail goto*//*Label 4983*/ GIMT_Encode4(249075), // Rule ID 8720 //
     /* 249020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 249023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_sxtw_index),
     /* 249028 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 249031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249034 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 249038 */     // MIs[0] Rn
     /* 249038 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 249042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 249046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249050 */     // MIs[0] prfop
     /* 249050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 249053 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 249058 */     // (intrinsic_void 1547:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW64:{ *:[nxv2i64] }:$Zm)
     /* 249058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_SXTW_SCALED),
     /* 249061 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 249063 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 249065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 249067 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 249069 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249073 */     GIR_RootConstrainSelectedInstOperands,
     /* 249074 */     // GIR_Coverage, 8720,
     /* 249074 */     GIR_EraseRootFromParent_Done,
     /* 249075 */   // Label 4983: @249075
     /* 249075 */   GIM_Try, /*On fail goto*//*Label 4984*/ GIMT_Encode4(249135), // Rule ID 8721 //
     /* 249080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 249083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_index),
     /* 249088 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 249091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249094 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 249098 */     // MIs[0] Rn
     /* 249098 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 249102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 249106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249110 */     // MIs[0] prfop
     /* 249110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 249113 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 249118 */     // (intrinsic_void 1549:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL16:{ *:[nxv2i64] }:$Zm)
     /* 249118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_SCALED),
     /* 249121 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 249123 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 249125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 249127 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 249129 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249133 */     GIR_RootConstrainSelectedInstOperands,
     /* 249134 */     // GIR_Coverage, 8721,
     /* 249134 */     GIR_EraseRootFromParent_Done,
     /* 249135 */   // Label 4984: @249135
     /* 249135 */   GIM_Try, /*On fail goto*//*Label 4985*/ GIMT_Encode4(249195), // Rule ID 8722 //
     /* 249140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 249143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_index),
     /* 249148 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 249151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249154 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 249158 */     // MIs[0] Rn
     /* 249158 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 249162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 249166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249170 */     // MIs[0] prfop
     /* 249170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 249173 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 249178 */     // (intrinsic_void 1553:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL32:{ *:[nxv2i64] }:$Zm)
     /* 249178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_SCALED),
     /* 249181 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 249183 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 249185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 249187 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 249189 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249193 */     GIR_RootConstrainSelectedInstOperands,
     /* 249194 */     // GIR_Coverage, 8722,
     /* 249194 */     GIR_EraseRootFromParent_Done,
     /* 249195 */   // Label 4985: @249195
     /* 249195 */   GIM_Try, /*On fail goto*//*Label 4986*/ GIMT_Encode4(249255), // Rule ID 8723 //
     /* 249200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 249203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_index),
     /* 249208 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 249211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249214 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 249218 */     // MIs[0] Rn
     /* 249218 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 249222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 249226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249230 */     // MIs[0] prfop
     /* 249230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 249233 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 249238 */     // (intrinsic_void 1545:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL64:{ *:[nxv2i64] }:$Zm)
     /* 249238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_SCALED),
     /* 249241 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 249243 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 249245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 249247 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 249249 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249253 */     GIR_RootConstrainSelectedInstOperands,
     /* 249254 */     // GIR_Coverage, 8723,
     /* 249254 */     GIR_EraseRootFromParent_Done,
     /* 249255 */   // Label 4986: @249255
     /* 249255 */   GIM_Try, /*On fail goto*//*Label 4987*/ GIMT_Encode4(249313), // Rule ID 2365 //
     /* 249260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 249263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalb),
     /* 249268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 249271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 249274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 249277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 249280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249296 */     // (intrinsic_w_chain:{ *:[v8f16] } 619:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALBv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 249296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALBv8f16),
     /* 249299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 249301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 249303 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 249305 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 249307 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249311 */     GIR_RootConstrainSelectedInstOperands,
     /* 249312 */     // GIR_Coverage, 2365,
     /* 249312 */     GIR_EraseRootFromParent_Done,
     /* 249313 */   // Label 4987: @249313
     /* 249313 */   GIM_Try, /*On fail goto*//*Label 4988*/ GIMT_Encode4(249371), // Rule ID 2366 //
     /* 249318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 249321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalt),
     /* 249326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 249329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 249332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 249335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 249338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249354 */     // (intrinsic_w_chain:{ *:[v8f16] } 629:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 249354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALTv8f16),
     /* 249357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 249359 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 249361 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 249363 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 249365 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249369 */     GIR_RootConstrainSelectedInstOperands,
     /* 249370 */     // GIR_Coverage, 2366,
     /* 249370 */     GIR_EraseRootFromParent_Done,
     /* 249371 */   // Label 4988: @249371
     /* 249371 */   GIM_Try, /*On fail goto*//*Label 4989*/ GIMT_Encode4(249429), // Rule ID 2367 //
     /* 249376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 249379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbb),
     /* 249384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 249387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 249390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 249393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 249396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249412 */     // (intrinsic_w_chain:{ *:[v4f32] } 621:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLBBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 249412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBBv4f32),
     /* 249415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 249417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 249419 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 249421 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 249423 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249427 */     GIR_RootConstrainSelectedInstOperands,
     /* 249428 */     // GIR_Coverage, 2367,
     /* 249428 */     GIR_EraseRootFromParent_Done,
     /* 249429 */   // Label 4989: @249429
     /* 249429 */   GIM_Try, /*On fail goto*//*Label 4990*/ GIMT_Encode4(249487), // Rule ID 2368 //
     /* 249434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 249437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbt),
     /* 249442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 249445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 249448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 249451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 249454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249470 */     // (intrinsic_w_chain:{ *:[v4f32] } 623:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLBTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 249470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBTv4f32),
     /* 249473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 249475 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 249477 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 249479 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 249481 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249485 */     GIR_RootConstrainSelectedInstOperands,
     /* 249486 */     // GIR_Coverage, 2368,
     /* 249486 */     GIR_EraseRootFromParent_Done,
     /* 249487 */   // Label 4990: @249487
     /* 249487 */   GIM_Try, /*On fail goto*//*Label 4991*/ GIMT_Encode4(249545), // Rule ID 2369 //
     /* 249492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 249495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltb),
     /* 249500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 249503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 249506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 249509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 249512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249528 */     // (intrinsic_w_chain:{ *:[v4f32] } 625:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLTBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 249528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTBv4f32),
     /* 249531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 249533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 249535 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 249537 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 249539 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249543 */     GIR_RootConstrainSelectedInstOperands,
     /* 249544 */     // GIR_Coverage, 2369,
     /* 249544 */     GIR_EraseRootFromParent_Done,
     /* 249545 */   // Label 4991: @249545
     /* 249545 */   GIM_Try, /*On fail goto*//*Label 4992*/ GIMT_Encode4(249603), // Rule ID 2370 //
     /* 249550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 249553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltt),
     /* 249558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 249561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 249564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 249567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 249570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249586 */     // (intrinsic_w_chain:{ *:[v4f32] } 627:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLTTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 249586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTTv4f32),
     /* 249589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 249591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 249593 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 249595 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 249597 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249601 */     GIR_RootConstrainSelectedInstOperands,
     /* 249602 */     // GIR_Coverage, 2370,
     /* 249602 */     GIR_EraseRootFromParent_Done,
     /* 249603 */   // Label 4992: @249603
     /* 249603 */   GIM_Try, /*On fail goto*//*Label 4993*/ GIMT_Encode4(249661), // Rule ID 2371 //
     /* 249608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 249611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2),
     /* 249616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 249619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 249622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 249625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /* 249628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 249632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 249636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 249640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 249644 */     // (intrinsic_w_chain:{ *:[v4f16] } 615:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (FDOTv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 249644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv4f16),
     /* 249647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 249649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 249651 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 249653 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 249655 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249659 */     GIR_RootConstrainSelectedInstOperands,
     /* 249660 */     // GIR_Coverage, 2371,
     /* 249660 */     GIR_EraseRootFromParent_Done,
     /* 249661 */   // Label 4993: @249661
     /* 249661 */   GIM_Try, /*On fail goto*//*Label 4994*/ GIMT_Encode4(249719), // Rule ID 2372 //
     /* 249666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 249669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2),
     /* 249674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 249677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 249680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 249683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 249686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249702 */     // (intrinsic_w_chain:{ *:[v8f16] } 615:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FDOTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 249702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv8f16),
     /* 249705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 249707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 249709 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 249711 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 249713 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249717 */     GIR_RootConstrainSelectedInstOperands,
     /* 249718 */     // GIR_Coverage, 2372,
     /* 249718 */     GIR_EraseRootFromParent_Done,
     /* 249719 */   // Label 4994: @249719
     /* 249719 */   GIM_Try, /*On fail goto*//*Label 4995*/ GIMT_Encode4(249777), // Rule ID 2373 //
     /* 249724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 249727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4),
     /* 249732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 249735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 249738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 249741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /* 249744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 249748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 249752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 249756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 249760 */     // (intrinsic_w_chain:{ *:[v2f32] } 617:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (FDOTv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 249760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv2f32),
     /* 249763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 249765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 249767 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 249769 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 249771 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249775 */     GIR_RootConstrainSelectedInstOperands,
     /* 249776 */     // GIR_Coverage, 2373,
     /* 249776 */     GIR_EraseRootFromParent_Done,
     /* 249777 */   // Label 4995: @249777
     /* 249777 */   GIM_Try, /*On fail goto*//*Label 4996*/ GIMT_Encode4(249835), // Rule ID 2374 //
     /* 249782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 249785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4),
     /* 249790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 249793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 249796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 249799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 249802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249818 */     // (intrinsic_w_chain:{ *:[v4f32] } 617:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FDOTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 249818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv4f32),
     /* 249821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 249823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 249825 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 249827 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 249829 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249833 */     GIR_RootConstrainSelectedInstOperands,
     /* 249834 */     // GIR_Coverage, 2374,
     /* 249834 */     GIR_EraseRootFromParent_Done,
     /* 249835 */   // Label 4996: @249835
     /* 249835 */   GIM_Try, /*On fail goto*//*Label 4997*/ GIMT_Encode4(249893), // Rule ID 2482 //
     /* 249840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 249843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn2),
     /* 249848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 249851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 249854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 249857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 249860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249876 */     // (intrinsic_w_chain:{ *:[v16i8] } 614:{ *:[iPTR] }, V128:{ *:[v16i8] }:$_Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCVTN_F322v16f8:{ *:[v16i8] } V128:{ *:[v16i8] }:$_Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 249876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F322v16f8),
     /* 249879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 249881 */     GIR_RootToRootCopy, /*OpIdx*/2, // _Rd
     /* 249883 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 249885 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 249887 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249891 */     GIR_RootConstrainSelectedInstOperands,
     /* 249892 */     // GIR_Coverage, 2482,
     /* 249892 */     GIR_EraseRootFromParent_Done,
     /* 249893 */   // Label 4997: @249893
     /* 249893 */   GIM_Try, /*On fail goto*//*Label 4998*/ GIMT_Encode4(249949), // Rule ID 12838 //
     /* 249898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxp),
     /* 249903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 249906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 249909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 249912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 249916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 249920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 249924 */     // MIs[0] addr
     /* 249924 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/4, /*SizeInBits*/64,
     /* 249928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 249932 */     // (intrinsic_w_chain:{ *:[i32] } 1144:{ *:[iPTR] }, GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)  =>  (STLXPX:{ *:[i32] } GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)
     /* 249932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXPX),
     /* 249935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 249937 */     GIR_RootToRootCopy, /*OpIdx*/2, // lo
     /* 249939 */     GIR_RootToRootCopy, /*OpIdx*/3, // hi
     /* 249941 */     GIR_RootToRootCopy, /*OpIdx*/4, // addr
     /* 249943 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249947 */     GIR_RootConstrainSelectedInstOperands,
     /* 249948 */     // GIR_Coverage, 12838,
     /* 249948 */     GIR_EraseRootFromParent_Done,
     /* 249949 */   // Label 4998: @249949
     /* 249949 */   GIM_Try, /*On fail goto*//*Label 4999*/ GIMT_Encode4(250005), // Rule ID 12839 //
     /* 249954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxp),
     /* 249959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 249962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 249965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 249968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 249972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 249976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 249980 */     // MIs[0] addr
     /* 249980 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/4, /*SizeInBits*/64,
     /* 249984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 249988 */     // (intrinsic_w_chain:{ *:[i32] } 1146:{ *:[iPTR] }, GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)  =>  (STXPX:{ *:[i32] } GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)
     /* 249988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXPX),
     /* 249991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 249993 */     GIR_RootToRootCopy, /*OpIdx*/2, // lo
     /* 249995 */     GIR_RootToRootCopy, /*OpIdx*/3, // hi
     /* 249997 */     GIR_RootToRootCopy, /*OpIdx*/4, // addr
     /* 249999 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250003 */     GIR_RootConstrainSelectedInstOperands,
     /* 250004 */     // GIR_Coverage, 12839,
     /* 250004 */     GIR_EraseRootFromParent_Done,
     /* 250005 */   // Label 4999: @250005
     /* 250005 */   GIM_Try, /*On fail goto*//*Label 5000*/ GIMT_Encode4(250051), // Rule ID 3439 //
     /* 250010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT2),
     /* 250013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot),
     /* 250018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 250024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250034 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1409:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FDOT_ZZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZ_BtoH),
     /* 250037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250039 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250041 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250043 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250045 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250049 */     GIR_RootConstrainSelectedInstOperands,
     /* 250050 */     // GIR_Coverage, 3439,
     /* 250050 */     GIR_EraseRootFromParent_Done,
     /* 250051 */   // Label 5000: @250051
     /* 250051 */   GIM_Try, /*On fail goto*//*Label 5001*/ GIMT_Encode4(250097), // Rule ID 3561 //
     /* 250056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 250059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalb),
     /* 250064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 250070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250080 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1411:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALB_ZZZ:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZ),
     /* 250083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250087 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250089 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250091 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250095 */     GIR_RootConstrainSelectedInstOperands,
     /* 250096 */     // GIR_Coverage, 3561,
     /* 250096 */     GIR_EraseRootFromParent_Done,
     /* 250097 */   // Label 5001: @250097
     /* 250097 */   GIM_Try, /*On fail goto*//*Label 5002*/ GIMT_Encode4(250143), // Rule ID 12351 //
     /* 250102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 250105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalt),
     /* 250110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 250116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250126 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1421:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALT_ZZZ:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZ),
     /* 250129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250133 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250135 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250137 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250141 */     GIR_RootConstrainSelectedInstOperands,
     /* 250142 */     // GIR_Coverage, 12351,
     /* 250142 */     GIR_EraseRootFromParent_Done,
     /* 250143 */   // Label 5002: @250143
     /* 250143 */   GIM_Try, /*On fail goto*//*Label 5003*/ GIMT_Encode4(250189), // Rule ID 12355 //
     /* 250148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 250151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbb),
     /* 250156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 250162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250172 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1413:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLBB_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBB_ZZZ),
     /* 250175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250179 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250181 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250183 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250187 */     GIR_RootConstrainSelectedInstOperands,
     /* 250188 */     // GIR_Coverage, 12355,
     /* 250188 */     GIR_EraseRootFromParent_Done,
     /* 250189 */   // Label 5003: @250189
     /* 250189 */   GIM_Try, /*On fail goto*//*Label 5004*/ GIMT_Encode4(250235), // Rule ID 12356 //
     /* 250194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 250197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbt),
     /* 250202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 250208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250218 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1415:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLBT_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBT_ZZZ),
     /* 250221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250223 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250225 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250227 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250229 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250233 */     GIR_RootConstrainSelectedInstOperands,
     /* 250234 */     // GIR_Coverage, 12356,
     /* 250234 */     GIR_EraseRootFromParent_Done,
     /* 250235 */   // Label 5004: @250235
     /* 250235 */   GIM_Try, /*On fail goto*//*Label 5005*/ GIMT_Encode4(250281), // Rule ID 12357 //
     /* 250240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 250243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltb),
     /* 250248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 250254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250264 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1417:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLTB_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTB_ZZZ),
     /* 250267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250271 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250273 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250275 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250279 */     GIR_RootConstrainSelectedInstOperands,
     /* 250280 */     // GIR_Coverage, 12357,
     /* 250280 */     GIR_EraseRootFromParent_Done,
     /* 250281 */   // Label 5005: @250281
     /* 250281 */   GIM_Try, /*On fail goto*//*Label 5006*/ GIMT_Encode4(250327), // Rule ID 12358 //
     /* 250286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 250289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltt),
     /* 250294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 250300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250310 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1419:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLTT_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTT_ZZZ),
     /* 250313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250315 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250317 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250319 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250321 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250325 */     GIR_RootConstrainSelectedInstOperands,
     /* 250326 */     // GIR_Coverage, 12358,
     /* 250326 */     GIR_EraseRootFromParent_Done,
     /* 250327 */   // Label 5006: @250327
     /* 250327 */   GIM_Try, /*On fail goto*//*Label 5007*/ GIMT_Encode4(250373), // Rule ID 12359 //
     /* 250332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT4),
     /* 250335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot),
     /* 250340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 250346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250356 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1409:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FDOT_ZZZ_BtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZ_BtoS),
     /* 250359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250363 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250365 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250367 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250371 */     GIR_RootConstrainSelectedInstOperands,
     /* 250372 */     // GIR_Coverage, 12359,
     /* 250372 */     GIR_EraseRootFromParent_Done,
     /* 250373 */   // Label 5007: @250373
     /* 250373 */   GIM_Reject,
     /* 250374 */ // Label 4960: @250374
     /* 250374 */ GIM_Try, /*On fail goto*//*Label 5008*/ GIMT_Encode4(253367),
     /* 250379 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /* 250382 */   GIM_Try, /*On fail goto*//*Label 5009*/ GIMT_Encode4(250450), // Rule ID 2509 //
     /* 250387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 250390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalb_lane),
     /* 250395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 250398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 250401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 250404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 250407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 250423 */     // MIs[0] Idx
     /* 250423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 250426 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 250431 */     // (intrinsic_w_chain:{ *:[v8f16] } 620:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALBlanev8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 250431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALBlanev8f16),
     /* 250434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 250436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 250438 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 250440 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 250442 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 250444 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250448 */     GIR_RootConstrainSelectedInstOperands,
     /* 250449 */     // GIR_Coverage, 2509,
     /* 250449 */     GIR_EraseRootFromParent_Done,
     /* 250450 */   // Label 5009: @250450
     /* 250450 */   GIM_Try, /*On fail goto*//*Label 5010*/ GIMT_Encode4(250518), // Rule ID 2510 //
     /* 250455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 250458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbb_lane),
     /* 250463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 250466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 250469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 250472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 250475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 250491 */     // MIs[0] Idx
     /* 250491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 250494 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 250499 */     // (intrinsic_w_chain:{ *:[v4f32] } 622:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLBBlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 250499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBBlanev4f32),
     /* 250502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 250504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 250506 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 250508 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 250510 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 250512 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250516 */     GIR_RootConstrainSelectedInstOperands,
     /* 250517 */     // GIR_Coverage, 2510,
     /* 250517 */     GIR_EraseRootFromParent_Done,
     /* 250518 */   // Label 5010: @250518
     /* 250518 */   GIM_Try, /*On fail goto*//*Label 5011*/ GIMT_Encode4(250586), // Rule ID 2511 //
     /* 250523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 250526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4_lane),
     /* 250531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 250534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 250537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 250540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 250543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 250547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 250551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 250555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250559 */     // MIs[0] Idx
     /* 250559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 250562 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 250567 */     // (intrinsic_w_chain:{ *:[v2f32] } 618:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Idx)  =>  (FDOTlanev2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v8i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 250567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev2f32),
     /* 250570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 250572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 250574 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 250576 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 250578 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 250580 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250584 */     GIR_RootConstrainSelectedInstOperands,
     /* 250585 */     // GIR_Coverage, 2511,
     /* 250585 */     GIR_EraseRootFromParent_Done,
     /* 250586 */   // Label 5011: @250586
     /* 250586 */   GIM_Try, /*On fail goto*//*Label 5012*/ GIMT_Encode4(250654), // Rule ID 2512 //
     /* 250591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 250594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4_lane),
     /* 250599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 250602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 250605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 250608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 250611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250627 */     // MIs[0] Idx
     /* 250627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 250630 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 250635 */     // (intrinsic_w_chain:{ *:[v4f32] } 618:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Idx)  =>  (FDOTlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 250635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev4f32),
     /* 250638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 250640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 250642 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 250644 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 250646 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 250648 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250652 */     GIR_RootConstrainSelectedInstOperands,
     /* 250653 */     // GIR_Coverage, 2512,
     /* 250653 */     GIR_EraseRootFromParent_Done,
     /* 250654 */   // Label 5012: @250654
     /* 250654 */   GIM_Try, /*On fail goto*//*Label 5013*/ GIMT_Encode4(250722), // Rule ID 2513 //
     /* 250659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 250662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2_lane),
     /* 250667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 250670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 250673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 250676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 250679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 250683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 250687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 250691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 250695 */     // MIs[0] Idx
     /* 250695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 250698 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 250703 */     // (intrinsic_w_chain:{ *:[v4f16] } 616:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128_lo:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Idx)  =>  (FDOTlanev4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v8i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 250703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev4f16),
     /* 250706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 250708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 250710 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 250712 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 250714 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 250716 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250720 */     GIR_RootConstrainSelectedInstOperands,
     /* 250721 */     // GIR_Coverage, 2513,
     /* 250721 */     GIR_EraseRootFromParent_Done,
     /* 250722 */   // Label 5013: @250722
     /* 250722 */   GIM_Try, /*On fail goto*//*Label 5014*/ GIMT_Encode4(250790), // Rule ID 2514 //
     /* 250727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 250730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2_lane),
     /* 250735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 250738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 250741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 250744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 250747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 250763 */     // MIs[0] Idx
     /* 250763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 250766 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 250771 */     // (intrinsic_w_chain:{ *:[v8f16] } 616:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_lo:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Idx)  =>  (FDOTlanev8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 250771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev8f16),
     /* 250774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 250776 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 250778 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 250780 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 250782 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 250784 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250788 */     GIR_RootConstrainSelectedInstOperands,
     /* 250789 */     // GIR_Coverage, 2514,
     /* 250789 */     GIR_EraseRootFromParent_Done,
     /* 250790 */   // Label 5014: @250790
     /* 250790 */   GIM_Try, /*On fail goto*//*Label 5015*/ GIMT_Encode4(250858), // Rule ID 6895 //
     /* 250795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 250798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalt_lane),
     /* 250803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 250806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 250809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 250812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 250815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 250831 */     // MIs[0] Idx
     /* 250831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 250834 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 250839 */     // (intrinsic_w_chain:{ *:[v8f16] } 630:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALTlanev8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 250839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALTlanev8f16),
     /* 250842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 250844 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 250846 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 250848 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 250850 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 250852 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250856 */     GIR_RootConstrainSelectedInstOperands,
     /* 250857 */     // GIR_Coverage, 6895,
     /* 250857 */     GIR_EraseRootFromParent_Done,
     /* 250858 */   // Label 5015: @250858
     /* 250858 */   GIM_Try, /*On fail goto*//*Label 5016*/ GIMT_Encode4(250926), // Rule ID 6896 //
     /* 250863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 250866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbt_lane),
     /* 250871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 250874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 250877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 250880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 250883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 250899 */     // MIs[0] Idx
     /* 250899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 250902 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 250907 */     // (intrinsic_w_chain:{ *:[v4f32] } 624:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLBTlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 250907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBTlanev4f32),
     /* 250910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 250912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 250914 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 250916 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 250918 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 250920 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250924 */     GIR_RootConstrainSelectedInstOperands,
     /* 250925 */     // GIR_Coverage, 6896,
     /* 250925 */     GIR_EraseRootFromParent_Done,
     /* 250926 */   // Label 5016: @250926
     /* 250926 */   GIM_Try, /*On fail goto*//*Label 5017*/ GIMT_Encode4(250994), // Rule ID 6897 //
     /* 250931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 250934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltb_lane),
     /* 250939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 250942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 250945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 250948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 250951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 250967 */     // MIs[0] Idx
     /* 250967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 250970 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 250975 */     // (intrinsic_w_chain:{ *:[v4f32] } 626:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLTBlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 250975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTBlanev4f32),
     /* 250978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 250980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 250982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 250984 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 250986 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 250988 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250992 */     GIR_RootConstrainSelectedInstOperands,
     /* 250993 */     // GIR_Coverage, 6897,
     /* 250993 */     GIR_EraseRootFromParent_Done,
     /* 250994 */   // Label 5017: @250994
     /* 250994 */   GIM_Try, /*On fail goto*//*Label 5018*/ GIMT_Encode4(251062), // Rule ID 6898 //
     /* 250999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 251002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltt_lane),
     /* 251007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 251010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 251013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 251016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 251019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 251023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 251027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 251031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 251035 */     // MIs[0] Idx
     /* 251035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 251038 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 251043 */     // (intrinsic_w_chain:{ *:[v4f32] } 628:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLTTlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 251043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTTlanev4f32),
     /* 251046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 251048 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 251050 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 251052 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 251054 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 251056 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251060 */     GIR_RootConstrainSelectedInstOperands,
     /* 251061 */     // GIR_Coverage, 6898,
     /* 251061 */     GIR_EraseRootFromParent_Done,
     /* 251062 */   // Label 5018: @251062
     /* 251062 */   GIM_Try, /*On fail goto*//*Label 5019*/ GIMT_Encode4(251122), // Rule ID 3573 //
     /* 251067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 251070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
     /* 251075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 251078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 251081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 251084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 251087 */     // MIs[0] tile
     /* 251087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251090 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 251095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251103 */     // (intrinsic_void 902:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 251103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_S_PSEUDO),
     /* 251106 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 251108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 251110 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 251112 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 251114 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 251116 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251120 */     GIR_RootConstrainSelectedInstOperands,
     /* 251121 */     // GIR_Coverage, 3573,
     /* 251121 */     GIR_EraseRootFromParent_Done,
     /* 251122 */   // Label 5019: @251122
     /* 251122 */   GIM_Try, /*On fail goto*//*Label 5020*/ GIMT_Encode4(251182), // Rule ID 3574 //
     /* 251127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F32),
     /* 251130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmopa_za32),
     /* 251135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 251138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 251141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 251144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 251147 */     // MIs[0] tile
     /* 251147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251150 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 251155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251163 */     // (intrinsic_void 872:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOPA_MPPZZ_BtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 251163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_BtoS_PSEUDO),
     /* 251166 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 251168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 251170 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 251172 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 251174 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 251176 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251180 */     GIR_RootConstrainSelectedInstOperands,
     /* 251181 */     // GIR_Coverage, 3574,
     /* 251181 */     GIR_EraseRootFromParent_Done,
     /* 251182 */   // Label 5020: @251182
     /* 251182 */   GIM_Try, /*On fail goto*//*Label 5021*/ GIMT_Encode4(251242), // Rule ID 3575 //
     /* 251187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64),
     /* 251190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
     /* 251195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 251198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 251201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 251204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 251207 */     // MIs[0] tile
     /* 251207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251210 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 251215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251223 */     // (intrinsic_void 902:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$Pn, PPR3bAny:{ *:[nxv2i1] }:$Pm, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 251223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_D_PSEUDO),
     /* 251226 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 251228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 251230 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 251232 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 251234 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 251236 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251240 */     GIR_RootConstrainSelectedInstOperands,
     /* 251241 */     // GIR_Coverage, 3575,
     /* 251241 */     GIR_EraseRootFromParent_Done,
     /* 251242 */   // Label 5021: @251242
     /* 251242 */   GIM_Try, /*On fail goto*//*Label 5022*/ GIMT_Encode4(251302), // Rule ID 3576 //
     /* 251247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F16),
     /* 251250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmopa_za16),
     /* 251255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 251258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 251261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 251264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 251267 */     // MIs[0] tile
     /* 251267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251270 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 251275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251283 */     // (intrinsic_void 871:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOPA_MPPZZ_BtoH_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 251283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_BtoH_PSEUDO),
     /* 251286 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 251288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 251290 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 251292 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 251294 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 251296 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251300 */     GIR_RootConstrainSelectedInstOperands,
     /* 251301 */     // GIR_Coverage, 3576,
     /* 251301 */     GIR_EraseRootFromParent_Done,
     /* 251302 */   // Label 5022: @251302
     /* 251302 */   GIM_Try, /*On fail goto*//*Label 5023*/ GIMT_Encode4(251362), // Rule ID 3577 //
     /* 251307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_or_SMEF8F16),
     /* 251310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
     /* 251315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 251318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 251321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 251327 */     // MIs[0] tile
     /* 251327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251330 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 251335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251343 */     // (intrinsic_void 902:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPA_MPPZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 251343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_H_PSEUDO),
     /* 251346 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 251348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 251350 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 251352 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 251354 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 251356 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251360 */     GIR_RootConstrainSelectedInstOperands,
     /* 251361 */     // GIR_Coverage, 3577,
     /* 251361 */     GIR_EraseRootFromParent_Done,
     /* 251362 */   // Label 5023: @251362
     /* 251362 */   GIM_Try, /*On fail goto*//*Label 5024*/ GIMT_Encode4(251422), // Rule ID 3578 //
     /* 251367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 251370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_wide),
     /* 251375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 251378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 251381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 251384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 251387 */     // MIs[0] tile
     /* 251387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251390 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 251395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251403 */     // (intrinsic_void 989:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 251403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_S_PSEUDO),
     /* 251406 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 251408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 251410 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 251412 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 251414 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 251416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251420 */     GIR_RootConstrainSelectedInstOperands,
     /* 251421 */     // GIR_Coverage, 3578,
     /* 251421 */     GIR_EraseRootFromParent_Done,
     /* 251422 */   // Label 5024: @251422
     /* 251422 */   GIM_Try, /*On fail goto*//*Label 5025*/ GIMT_Encode4(251482), // Rule ID 3579 //
     /* 251427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 251430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_wide),
     /* 251435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 251438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 251441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 251447 */     // MIs[0] tile
     /* 251447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251450 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 251455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251463 */     // (intrinsic_void 989:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 251463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_D_PSEUDO),
     /* 251466 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 251468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 251470 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 251472 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 251474 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 251476 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251480 */     GIR_RootConstrainSelectedInstOperands,
     /* 251481 */     // GIR_Coverage, 3579,
     /* 251481 */     GIR_EraseRootFromParent_Done,
     /* 251482 */   // Label 5025: @251482
     /* 251482 */   GIM_Try, /*On fail goto*//*Label 5026*/ GIMT_Encode4(251542), // Rule ID 3580 //
     /* 251487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 251490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa_wide),
     /* 251495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 251498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 251501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 251507 */     // MIs[0] tile
     /* 251507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251510 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 251515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251523 */     // (intrinsic_void 904:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPAL_MPPZZ_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 251523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPAL_MPPZZ_PSEUDO),
     /* 251526 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 251528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 251530 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 251532 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 251534 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 251536 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251540 */     GIR_RootConstrainSelectedInstOperands,
     /* 251541 */     // GIR_Coverage, 3580,
     /* 251541 */     GIR_EraseRootFromParent_Done,
     /* 251542 */   // Label 5026: @251542
     /* 251542 */   GIM_Try, /*On fail goto*//*Label 5027*/ GIMT_Encode4(251602), // Rule ID 3662 //
     /* 251547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 251550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_za32),
     /* 251555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 251558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 251561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 251567 */     // MIs[0] tile
     /* 251567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251570 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 251575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251583 */     // (intrinsic_void 990:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPA_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 251583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_HtoS_PSEUDO),
     /* 251586 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 251588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 251590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 251592 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 251594 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 251596 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251600 */     GIR_RootConstrainSelectedInstOperands,
     /* 251601 */     // GIR_Coverage, 3662,
     /* 251601 */     GIR_EraseRootFromParent_Done,
     /* 251602 */   // Label 5027: @251602
     /* 251602 */   GIM_Try, /*On fail goto*//*Label 5028*/ GIMT_Encode4(251662), // Rule ID 3663 //
     /* 251607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 251610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_bmopa_za32),
     /* 251615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 251618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 251621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 251624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 251627 */     // MIs[0] tile
     /* 251627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251630 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 251635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251643 */     // (intrinsic_void 799:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4i32:{ *:[nxv4i32] }:$Zn, nxv4i32:{ *:[nxv4i32] }:$Zm)  =>  (BMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4i32] }:$Zn, ?:{ *:[nxv4i32] }:$Zm)
     /* 251643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BMOPA_MPPZZ_S_PSEUDO),
     /* 251646 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 251648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 251650 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 251652 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 251654 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 251656 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251660 */     GIR_RootConstrainSelectedInstOperands,
     /* 251661 */     // GIR_Coverage, 3663,
     /* 251661 */     GIR_EraseRootFromParent_Done,
     /* 251662 */   // Label 5028: @251662
     /* 251662 */   GIM_Try, /*On fail goto*//*Label 5029*/ GIMT_Encode4(251722), // Rule ID 12366 //
     /* 251667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 251670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
     /* 251675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 251678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 251681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 251684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 251687 */     // MIs[0] tile
     /* 251687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251690 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 251695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251703 */     // (intrinsic_void 905:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 251703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_S_PSEUDO),
     /* 251706 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 251708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 251710 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 251712 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 251714 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 251716 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251720 */     GIR_RootConstrainSelectedInstOperands,
     /* 251721 */     // GIR_Coverage, 12366,
     /* 251721 */     GIR_EraseRootFromParent_Done,
     /* 251722 */   // Label 5029: @251722
     /* 251722 */   GIM_Try, /*On fail goto*//*Label 5030*/ GIMT_Encode4(251782), // Rule ID 12367 //
     /* 251727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64),
     /* 251730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
     /* 251735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 251738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 251741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 251744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 251747 */     // MIs[0] tile
     /* 251747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251750 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 251755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251763 */     // (intrinsic_void 905:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$Pn, PPR3bAny:{ *:[nxv2i1] }:$Pm, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 251763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_D_PSEUDO),
     /* 251766 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 251768 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 251770 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 251772 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 251774 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 251776 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251780 */     GIR_RootConstrainSelectedInstOperands,
     /* 251781 */     // GIR_Coverage, 12367,
     /* 251781 */     GIR_EraseRootFromParent_Done,
     /* 251782 */   // Label 5030: @251782
     /* 251782 */   GIM_Try, /*On fail goto*//*Label 5031*/ GIMT_Encode4(251842), // Rule ID 12368 //
     /* 251787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 251790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops_wide),
     /* 251795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 251798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 251801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 251807 */     // MIs[0] tile
     /* 251807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251810 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 251815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251823 */     // (intrinsic_void 907:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPSL_MPPZZ_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 251823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPSL_MPPZZ_PSEUDO),
     /* 251826 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 251828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 251830 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 251832 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 251834 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 251836 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251840 */     GIR_RootConstrainSelectedInstOperands,
     /* 251841 */     // GIR_Coverage, 12368,
     /* 251841 */     GIR_EraseRootFromParent_Done,
     /* 251842 */   // Label 5031: @251842
     /* 251842 */   GIM_Try, /*On fail goto*//*Label 5032*/ GIMT_Encode4(251902), // Rule ID 12369 //
     /* 251847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 251850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_wide),
     /* 251855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 251858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 251861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 251864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 251867 */     // MIs[0] tile
     /* 251867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251870 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 251875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251883 */     // (intrinsic_void 991:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 251883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_S_PSEUDO),
     /* 251886 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 251888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 251890 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 251892 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 251894 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 251896 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251900 */     GIR_RootConstrainSelectedInstOperands,
     /* 251901 */     // GIR_Coverage, 12369,
     /* 251901 */     GIR_EraseRootFromParent_Done,
     /* 251902 */   // Label 5032: @251902
     /* 251902 */   GIM_Try, /*On fail goto*//*Label 5033*/ GIMT_Encode4(251962), // Rule ID 12370 //
     /* 251907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 251910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_wide),
     /* 251915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 251918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 251921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 251924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 251927 */     // MIs[0] tile
     /* 251927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251930 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 251935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251943 */     // (intrinsic_void 1090:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 251943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_S_PSEUDO),
     /* 251946 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 251948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 251950 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 251952 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 251954 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 251956 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251960 */     GIR_RootConstrainSelectedInstOperands,
     /* 251961 */     // GIR_Coverage, 12370,
     /* 251961 */     GIR_EraseRootFromParent_Done,
     /* 251962 */   // Label 5033: @251962
     /* 251962 */   GIM_Try, /*On fail goto*//*Label 5034*/ GIMT_Encode4(252022), // Rule ID 12371 //
     /* 251967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 251970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_wide),
     /* 251975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 251978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 251981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 251984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 251987 */     // MIs[0] tile
     /* 251987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251990 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 251995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 251999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252003 */     // (intrinsic_void 1092:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 252003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_S_PSEUDO),
     /* 252006 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 252010 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 252012 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 252014 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 252016 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252020 */     GIR_RootConstrainSelectedInstOperands,
     /* 252021 */     // GIR_Coverage, 12371,
     /* 252021 */     GIR_EraseRootFromParent_Done,
     /* 252022 */   // Label 5034: @252022
     /* 252022 */   GIM_Try, /*On fail goto*//*Label 5035*/ GIMT_Encode4(252082), // Rule ID 12372 //
     /* 252027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 252030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumopa_wide),
     /* 252035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 252038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 252041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 252047 */     // MIs[0] tile
     /* 252047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252050 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252063 */     // (intrinsic_void 1024:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 252063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPA_MPPZZ_S_PSEUDO),
     /* 252066 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 252070 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 252072 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 252074 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 252076 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252080 */     GIR_RootConstrainSelectedInstOperands,
     /* 252081 */     // GIR_Coverage, 12372,
     /* 252081 */     GIR_EraseRootFromParent_Done,
     /* 252082 */   // Label 5035: @252082
     /* 252082 */   GIM_Try, /*On fail goto*//*Label 5036*/ GIMT_Encode4(252142), // Rule ID 12373 //
     /* 252087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 252090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumops_wide),
     /* 252095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 252098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 252101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 252107 */     // MIs[0] tile
     /* 252107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252110 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252123 */     // (intrinsic_void 1025:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 252123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPS_MPPZZ_S_PSEUDO),
     /* 252126 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 252130 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 252132 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 252134 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 252136 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252140 */     GIR_RootConstrainSelectedInstOperands,
     /* 252141 */     // GIR_Coverage, 12373,
     /* 252141 */     GIR_EraseRootFromParent_Done,
     /* 252142 */   // Label 5036: @252142
     /* 252142 */   GIM_Try, /*On fail goto*//*Label 5037*/ GIMT_Encode4(252202), // Rule ID 12374 //
     /* 252147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 252150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmopa_wide),
     /* 252155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 252158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 252161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 252167 */     // MIs[0] tile
     /* 252167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252170 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252183 */     // (intrinsic_void 1108:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 252183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPA_MPPZZ_S_PSEUDO),
     /* 252186 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 252190 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 252192 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 252194 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 252196 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252200 */     GIR_RootConstrainSelectedInstOperands,
     /* 252201 */     // GIR_Coverage, 12374,
     /* 252201 */     GIR_EraseRootFromParent_Done,
     /* 252202 */   // Label 5037: @252202
     /* 252202 */   GIM_Try, /*On fail goto*//*Label 5038*/ GIMT_Encode4(252262), // Rule ID 12375 //
     /* 252207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 252210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmops_wide),
     /* 252215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 252218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 252221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 252227 */     // MIs[0] tile
     /* 252227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252230 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252243 */     // (intrinsic_void 1109:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 252243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPS_MPPZZ_S_PSEUDO),
     /* 252246 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 252250 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 252252 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 252254 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 252256 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252260 */     GIR_RootConstrainSelectedInstOperands,
     /* 252261 */     // GIR_Coverage, 12375,
     /* 252261 */     GIR_EraseRootFromParent_Done,
     /* 252262 */   // Label 5038: @252262
     /* 252262 */   GIM_Try, /*On fail goto*//*Label 5039*/ GIMT_Encode4(252322), // Rule ID 12376 //
     /* 252267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 252270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_wide),
     /* 252275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 252281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 252287 */     // MIs[0] tile
     /* 252287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252290 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 252295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252303 */     // (intrinsic_void 991:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 252303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_D_PSEUDO),
     /* 252306 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 252310 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 252312 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 252314 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 252316 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252320 */     GIR_RootConstrainSelectedInstOperands,
     /* 252321 */     // GIR_Coverage, 12376,
     /* 252321 */     GIR_EraseRootFromParent_Done,
     /* 252322 */   // Label 5039: @252322
     /* 252322 */   GIM_Try, /*On fail goto*//*Label 5040*/ GIMT_Encode4(252382), // Rule ID 12377 //
     /* 252327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 252330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_wide),
     /* 252335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 252341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 252347 */     // MIs[0] tile
     /* 252347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252350 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 252355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252363 */     // (intrinsic_void 1090:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 252363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_D_PSEUDO),
     /* 252366 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 252370 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 252372 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 252374 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 252376 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252380 */     GIR_RootConstrainSelectedInstOperands,
     /* 252381 */     // GIR_Coverage, 12377,
     /* 252381 */     GIR_EraseRootFromParent_Done,
     /* 252382 */   // Label 5040: @252382
     /* 252382 */   GIM_Try, /*On fail goto*//*Label 5041*/ GIMT_Encode4(252442), // Rule ID 12378 //
     /* 252387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 252390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_wide),
     /* 252395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 252401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 252407 */     // MIs[0] tile
     /* 252407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252410 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 252415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252423 */     // (intrinsic_void 1092:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 252423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_D_PSEUDO),
     /* 252426 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 252430 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 252432 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 252434 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 252436 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252440 */     GIR_RootConstrainSelectedInstOperands,
     /* 252441 */     // GIR_Coverage, 12378,
     /* 252441 */     GIR_EraseRootFromParent_Done,
     /* 252442 */   // Label 5041: @252442
     /* 252442 */   GIM_Try, /*On fail goto*//*Label 5042*/ GIMT_Encode4(252502), // Rule ID 12379 //
     /* 252447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 252450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumopa_wide),
     /* 252455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 252461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 252467 */     // MIs[0] tile
     /* 252467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252470 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 252475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252483 */     // (intrinsic_void 1024:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 252483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPA_MPPZZ_D_PSEUDO),
     /* 252486 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 252490 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 252492 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 252494 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 252496 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252500 */     GIR_RootConstrainSelectedInstOperands,
     /* 252501 */     // GIR_Coverage, 12379,
     /* 252501 */     GIR_EraseRootFromParent_Done,
     /* 252502 */   // Label 5042: @252502
     /* 252502 */   GIM_Try, /*On fail goto*//*Label 5043*/ GIMT_Encode4(252562), // Rule ID 12380 //
     /* 252507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 252510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumops_wide),
     /* 252515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 252521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 252527 */     // MIs[0] tile
     /* 252527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252530 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 252535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252543 */     // (intrinsic_void 1025:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 252543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPS_MPPZZ_D_PSEUDO),
     /* 252546 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252548 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 252550 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 252552 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 252554 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 252556 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252560 */     GIR_RootConstrainSelectedInstOperands,
     /* 252561 */     // GIR_Coverage, 12380,
     /* 252561 */     GIR_EraseRootFromParent_Done,
     /* 252562 */   // Label 5043: @252562
     /* 252562 */   GIM_Try, /*On fail goto*//*Label 5044*/ GIMT_Encode4(252622), // Rule ID 12381 //
     /* 252567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 252570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmopa_wide),
     /* 252575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 252581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 252587 */     // MIs[0] tile
     /* 252587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252590 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 252595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252603 */     // (intrinsic_void 1108:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 252603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPA_MPPZZ_D_PSEUDO),
     /* 252606 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 252610 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 252612 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 252614 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 252616 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252620 */     GIR_RootConstrainSelectedInstOperands,
     /* 252621 */     // GIR_Coverage, 12381,
     /* 252621 */     GIR_EraseRootFromParent_Done,
     /* 252622 */   // Label 5044: @252622
     /* 252622 */   GIM_Try, /*On fail goto*//*Label 5045*/ GIMT_Encode4(252682), // Rule ID 12382 //
     /* 252627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 252630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmops_wide),
     /* 252635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 252641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 252647 */     // MIs[0] tile
     /* 252647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252650 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 252655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252663 */     // (intrinsic_void 1109:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 252663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPS_MPPZZ_D_PSEUDO),
     /* 252666 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 252670 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 252672 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 252674 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 252676 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252680 */     GIR_RootConstrainSelectedInstOperands,
     /* 252681 */     // GIR_Coverage, 12382,
     /* 252681 */     GIR_EraseRootFromParent_Done,
     /* 252682 */   // Label 5045: @252682
     /* 252682 */   GIM_Try, /*On fail goto*//*Label 5046*/ GIMT_Encode4(252742), // Rule ID 12679 //
     /* 252687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 252690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_bmops_za32),
     /* 252695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 252698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 252701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 252704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 252707 */     // MIs[0] tile
     /* 252707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252710 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252723 */     // (intrinsic_void 800:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4i32:{ *:[nxv4i32] }:$Zn, nxv4i32:{ *:[nxv4i32] }:$Zm)  =>  (BMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4i32] }:$Zn, ?:{ *:[nxv4i32] }:$Zm)
     /* 252723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BMOPS_MPPZZ_S_PSEUDO),
     /* 252726 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 252730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 252732 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 252734 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 252736 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252740 */     GIR_RootConstrainSelectedInstOperands,
     /* 252741 */     // GIR_Coverage, 12679,
     /* 252741 */     GIR_EraseRootFromParent_Done,
     /* 252742 */   // Label 5046: @252742
     /* 252742 */   GIM_Try, /*On fail goto*//*Label 5047*/ GIMT_Encode4(252802), // Rule ID 12680 //
     /* 252747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 252750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_za32),
     /* 252755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 252761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 252767 */     // MIs[0] tile
     /* 252767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252770 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252783 */     // (intrinsic_void 992:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPS_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 252783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_HtoS_PSEUDO),
     /* 252786 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252788 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 252790 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 252792 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 252794 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 252796 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252800 */     GIR_RootConstrainSelectedInstOperands,
     /* 252801 */     // GIR_Coverage, 12680,
     /* 252801 */     GIR_EraseRootFromParent_Done,
     /* 252802 */   // Label 5047: @252802
     /* 252802 */   GIM_Try, /*On fail goto*//*Label 5048*/ GIMT_Encode4(252862), // Rule ID 12681 //
     /* 252807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 252810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_za32),
     /* 252815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 252821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 252827 */     // MIs[0] tile
     /* 252827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252830 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252843 */     // (intrinsic_void 1091:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPA_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 252843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_HtoS_PSEUDO),
     /* 252846 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 252850 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 252852 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 252854 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 252856 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252860 */     GIR_RootConstrainSelectedInstOperands,
     /* 252861 */     // GIR_Coverage, 12681,
     /* 252861 */     GIR_EraseRootFromParent_Done,
     /* 252862 */   // Label 5048: @252862
     /* 252862 */   GIM_Try, /*On fail goto*//*Label 5049*/ GIMT_Encode4(252922), // Rule ID 12682 //
     /* 252867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 252870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_za32),
     /* 252875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 252881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 252887 */     // MIs[0] tile
     /* 252887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252890 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252903 */     // (intrinsic_void 1093:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPS_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 252903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_HtoS_PSEUDO),
     /* 252906 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 252910 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 252912 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 252914 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 252916 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252920 */     GIR_RootConstrainSelectedInstOperands,
     /* 252921 */     // GIR_Coverage, 12682,
     /* 252921 */     GIR_EraseRootFromParent_Done,
     /* 252922 */   // Label 5049: @252922
     /* 252922 */   GIM_Try, /*On fail goto*//*Label 5050*/ GIMT_Encode4(252982), // Rule ID 12793 //
     /* 252927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_or_SMEF8F16),
     /* 252930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
     /* 252935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 252941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 252947 */     // MIs[0] tile
     /* 252947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252950 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 252955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252963 */     // (intrinsic_void 905:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPS_MPPZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 252963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_H_PSEUDO),
     /* 252966 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 252970 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 252972 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 252974 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 252976 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252980 */     GIR_RootConstrainSelectedInstOperands,
     /* 252981 */     // GIR_Coverage, 12793,
     /* 252981 */     GIR_EraseRootFromParent_Done,
     /* 252982 */   // Label 5050: @252982
     /* 252982 */   GIM_Try, /*On fail goto*//*Label 5051*/ GIMT_Encode4(253030), // Rule ID 3560 //
     /* 252987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 252990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalb_lane),
     /* 252995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 252998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 253001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253011 */     // MIs[0] Op4
     /* 253011 */     // No operand predicates
     /* 253011 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1412:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALB_ZZZI:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 253011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZI),
     /* 253014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 253016 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253018 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253020 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253022 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 253024 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253028 */     GIR_RootConstrainSelectedInstOperands,
     /* 253029 */     // GIR_Coverage, 3560,
     /* 253029 */     GIR_EraseRootFromParent_Done,
     /* 253030 */   // Label 5051: @253030
     /* 253030 */   GIM_Try, /*On fail goto*//*Label 5052*/ GIMT_Encode4(253078), // Rule ID 3562 //
     /* 253035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 253038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbb_lane),
     /* 253043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 253049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253059 */     // MIs[0] Op4
     /* 253059 */     // No operand predicates
     /* 253059 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1414:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLBB_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 253059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBB_ZZZI),
     /* 253062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 253064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253066 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253068 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253070 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 253072 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253076 */     GIR_RootConstrainSelectedInstOperands,
     /* 253077 */     // GIR_Coverage, 3562,
     /* 253077 */     GIR_EraseRootFromParent_Done,
     /* 253078 */   // Label 5052: @253078
     /* 253078 */   GIM_Try, /*On fail goto*//*Label 5053*/ GIMT_Encode4(253126), // Rule ID 3563 //
     /* 253083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT2),
     /* 253086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot_lane),
     /* 253091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 253094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 253097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253107 */     // MIs[0] Op4
     /* 253107 */     // No operand predicates
     /* 253107 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1410:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FDOT_ZZZI_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 253107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZI_BtoH),
     /* 253110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 253112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253114 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253116 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253118 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 253120 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253124 */     GIR_RootConstrainSelectedInstOperands,
     /* 253125 */     // GIR_Coverage, 3563,
     /* 253125 */     GIR_EraseRootFromParent_Done,
     /* 253126 */   // Label 5053: @253126
     /* 253126 */   GIM_Try, /*On fail goto*//*Label 5054*/ GIMT_Encode4(253174), // Rule ID 3564 //
     /* 253131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT4),
     /* 253134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot_lane),
     /* 253139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 253145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253155 */     // MIs[0] Op4
     /* 253155 */     // No operand predicates
     /* 253155 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1410:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FDOT_ZZZI_BtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 253155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZI_BtoS),
     /* 253158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 253160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253162 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253164 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253166 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 253168 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253172 */     GIR_RootConstrainSelectedInstOperands,
     /* 253173 */     // GIR_Coverage, 3564,
     /* 253173 */     GIR_EraseRootFromParent_Done,
     /* 253174 */   // Label 5054: @253174
     /* 253174 */   GIM_Try, /*On fail goto*//*Label 5055*/ GIMT_Encode4(253222), // Rule ID 12350 //
     /* 253179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 253182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalt_lane),
     /* 253187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 253190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 253193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253203 */     // MIs[0] Op4
     /* 253203 */     // No operand predicates
     /* 253203 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1422:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALT_ZZZI:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 253203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZI),
     /* 253206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 253208 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253210 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253212 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253214 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 253216 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253220 */     GIR_RootConstrainSelectedInstOperands,
     /* 253221 */     // GIR_Coverage, 12350,
     /* 253221 */     GIR_EraseRootFromParent_Done,
     /* 253222 */   // Label 5055: @253222
     /* 253222 */   GIM_Try, /*On fail goto*//*Label 5056*/ GIMT_Encode4(253270), // Rule ID 12352 //
     /* 253227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 253230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbt_lane),
     /* 253235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 253241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253251 */     // MIs[0] Op4
     /* 253251 */     // No operand predicates
     /* 253251 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1416:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLBT_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 253251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBT_ZZZI),
     /* 253254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 253256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253258 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253260 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253262 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 253264 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253268 */     GIR_RootConstrainSelectedInstOperands,
     /* 253269 */     // GIR_Coverage, 12352,
     /* 253269 */     GIR_EraseRootFromParent_Done,
     /* 253270 */   // Label 5056: @253270
     /* 253270 */   GIM_Try, /*On fail goto*//*Label 5057*/ GIMT_Encode4(253318), // Rule ID 12353 //
     /* 253275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 253278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltb_lane),
     /* 253283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 253289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253299 */     // MIs[0] Op4
     /* 253299 */     // No operand predicates
     /* 253299 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1418:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLTB_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 253299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTB_ZZZI),
     /* 253302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 253304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253306 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253308 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253310 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 253312 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253316 */     GIR_RootConstrainSelectedInstOperands,
     /* 253317 */     // GIR_Coverage, 12353,
     /* 253317 */     GIR_EraseRootFromParent_Done,
     /* 253318 */   // Label 5057: @253318
     /* 253318 */   GIM_Try, /*On fail goto*//*Label 5058*/ GIMT_Encode4(253366), // Rule ID 12354 //
     /* 253323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 253326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltt_lane),
     /* 253331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 253337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253347 */     // MIs[0] Op4
     /* 253347 */     // No operand predicates
     /* 253347 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1420:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLTT_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 253347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTT_ZZZI),
     /* 253350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 253352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253354 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253356 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253358 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 253360 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253364 */     GIR_RootConstrainSelectedInstOperands,
     /* 253365 */     // GIR_Coverage, 12354,
     /* 253365 */     GIR_EraseRootFromParent_Done,
     /* 253366 */   // Label 5058: @253366
     /* 253366 */   GIM_Reject,
     /* 253367 */ // Label 5008: @253367
     /* 253367 */ GIM_Reject,
     /* 253368 */ // Label 34: @253368
     /* 253368 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 5063*/ GIMT_Encode4(253657),
     /* 253379 */ /*GILLT_s64*//*Label 5059*/ GIMT_Encode4(253411), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 253391 */ /*GILLT_v2s64*//*Label 5060*/ GIMT_Encode4(253471), GIMT_Encode4(0),
     /* 253399 */ /*GILLT_v4s32*//*Label 5061*/ GIMT_Encode4(253533), GIMT_Encode4(0),
     /* 253407 */ /*GILLT_v8s16*//*Label 5062*/ GIMT_Encode4(253595),
     /* 253411 */ // Label 5059: @253411
     /* 253411 */ GIM_Try, /*On fail goto*//*Label 5064*/ GIMT_Encode4(253470), // Rule ID 6407 //
     /* 253416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 253419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 253423 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253427 */   // (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$src, sub_32:{ *:[i32] })
     /* 253427 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 253430 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 253434 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 253439 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 253441 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 253444 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 253446 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 253449 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 253451 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 253454 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 253459 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 253464 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253469 */   // GIR_Coverage, 6407,
     /* 253469 */   GIR_EraseRootFromParent_Done,
     /* 253470 */ // Label 5064: @253470
     /* 253470 */ GIM_Reject,
     /* 253471 */ // Label 5060: @253471
     /* 253471 */ GIM_Try, /*On fail goto*//*Label 5065*/ GIMT_Encode4(253532),
     /* 253476 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 253479 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 253483 */   GIM_Try, /*On fail goto*//*Label 5066*/ GIMT_Encode4(253510), // Rule ID 6279 //
     /* 253488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 253495 */     // (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (USHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
     /* 253495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i32_shift),
     /* 253498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 253500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 253505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253508 */     GIR_RootConstrainSelectedInstOperands,
     /* 253509 */     // GIR_Coverage, 6279,
     /* 253509 */     GIR_EraseRootFromParent_Done,
     /* 253510 */   // Label 5066: @253510
     /* 253510 */   GIM_Try, /*On fail goto*//*Label 5067*/ GIMT_Encode4(253531), // Rule ID 6272 //
     /* 253515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 253519 */     // (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
     /* 253519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 253522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 253524 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 253526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253529 */     GIR_RootConstrainSelectedInstOperands,
     /* 253530 */     // GIR_Coverage, 6272,
     /* 253530 */     GIR_EraseRootFromParent_Done,
     /* 253531 */   // Label 5067: @253531
     /* 253531 */   GIM_Reject,
     /* 253532 */ // Label 5065: @253532
     /* 253532 */ GIM_Reject,
     /* 253533 */ // Label 5061: @253533
     /* 253533 */ GIM_Try, /*On fail goto*//*Label 5068*/ GIMT_Encode4(253594),
     /* 253538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 253541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 253545 */   GIM_Try, /*On fail goto*//*Label 5069*/ GIMT_Encode4(253572), // Rule ID 6276 //
     /* 253550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 253557 */     // (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (USHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
     /* 253557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i16_shift),
     /* 253560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 253562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 253567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253570 */     GIR_RootConstrainSelectedInstOperands,
     /* 253571 */     // GIR_Coverage, 6276,
     /* 253571 */     GIR_EraseRootFromParent_Done,
     /* 253572 */   // Label 5069: @253572
     /* 253572 */   GIM_Try, /*On fail goto*//*Label 5070*/ GIMT_Encode4(253593), // Rule ID 6269 //
     /* 253577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 253581 */     // (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
     /* 253581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
     /* 253584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 253586 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 253588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253591 */     GIR_RootConstrainSelectedInstOperands,
     /* 253592 */     // GIR_Coverage, 6269,
     /* 253592 */     GIR_EraseRootFromParent_Done,
     /* 253593 */   // Label 5070: @253593
     /* 253593 */   GIM_Reject,
     /* 253594 */ // Label 5068: @253594
     /* 253594 */ GIM_Reject,
     /* 253595 */ // Label 5062: @253595
     /* 253595 */ GIM_Try, /*On fail goto*//*Label 5071*/ GIMT_Encode4(253656),
     /* 253600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 253603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 253607 */   GIM_Try, /*On fail goto*//*Label 5072*/ GIMT_Encode4(253634), // Rule ID 6273 //
     /* 253612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 253619 */     // (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (USHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
     /* 253619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv16i8_shift),
     /* 253622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 253624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 253629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253632 */     GIR_RootConstrainSelectedInstOperands,
     /* 253633 */     // GIR_Coverage, 6273,
     /* 253633 */     GIR_EraseRootFromParent_Done,
     /* 253634 */   // Label 5072: @253634
     /* 253634 */   GIM_Try, /*On fail goto*//*Label 5073*/ GIMT_Encode4(253655), // Rule ID 6266 //
     /* 253639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 253643 */     // (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
     /* 253643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
     /* 253646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 253648 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 253650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253653 */     GIR_RootConstrainSelectedInstOperands,
     /* 253654 */     // GIR_Coverage, 6266,
     /* 253654 */     GIR_EraseRootFromParent_Done,
     /* 253655 */   // Label 5073: @253655
     /* 253655 */   GIM_Reject,
     /* 253656 */ // Label 5071: @253656
     /* 253656 */ GIM_Reject,
     /* 253657 */ // Label 5063: @253657
     /* 253657 */ GIM_Reject,
     /* 253658 */ // Label 35: @253658
     /* 253658 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(10), /*)*//*default:*//*Label 5078*/ GIMT_Encode4(255094),
     /* 253669 */ /*GILLT_s32*//*Label 5074*/ GIMT_Encode4(253701), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 253681 */ /*GILLT_v2s32*//*Label 5075*/ GIMT_Encode4(253740), GIMT_Encode4(0),
     /* 253689 */ /*GILLT_v4s16*//*Label 5076*/ GIMT_Encode4(254096), GIMT_Encode4(0),
     /* 253697 */ /*GILLT_v8s8*//*Label 5077*/ GIMT_Encode4(254595),
     /* 253701 */ // Label 5074: @253701
     /* 253701 */ GIM_Try, /*On fail goto*//*Label 5079*/ GIMT_Encode4(253739), // Rule ID 6428 //
     /* 253706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 253709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 253713 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 253717 */   // (trunc:{ *:[i32] } GPR64sp:{ *:[i64] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i32] } GPR64sp:{ *:[i64] }:$src, sub_32:{ *:[i32] })
     /* 253717 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 253720 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 253722 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // src
     /* 253728 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 253733 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 253738 */   // GIR_Coverage, 6428,
     /* 253738 */   GIR_EraseRootFromParent_Done,
     /* 253739 */ // Label 5079: @253739
     /* 253739 */ GIM_Reject,
     /* 253740 */ // Label 5075: @253740
     /* 253740 */ GIM_Try, /*On fail goto*//*Label 5080*/ GIMT_Encode4(254095),
     /* 253745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 253748 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 253752 */   GIM_Try, /*On fail goto*//*Label 5081*/ GIMT_Encode4(253830), // Rule ID 5366 //
     /* 253757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 253761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 253765 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 253769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 253773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 253777 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 253781 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 253785 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 253790 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 253794 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 253800 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /* 253802 */     // MIs[1] Operand 2
     /* 253802 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 253813 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 253815 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] }:$Rm), 32:{ *:[i32] }))  =>  (SUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 253815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v2i32),
     /* 253818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 253820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 253824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 253828 */     GIR_RootConstrainSelectedInstOperands,
     /* 253829 */     // GIR_Coverage, 5366,
     /* 253829 */     GIR_EraseRootFromParent_Done,
     /* 253830 */   // Label 5081: @253830
     /* 253830 */   GIM_Try, /*On fail goto*//*Label 5082*/ GIMT_Encode4(253901), // Rule ID 5362 //
     /* 253835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 253839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 253843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 253847 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 253851 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 253855 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 253859 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 253863 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 253868 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 253873 */     // MIs[1] Operand 2
     /* 253873 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 253884 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 253886 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] }))  =>  (ADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 253886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v2i32),
     /* 253889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 253891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 253895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 253899 */     GIR_RootConstrainSelectedInstOperands,
     /* 253900 */     // GIR_Coverage, 5362,
     /* 253900 */     GIR_EraseRootFromParent_Done,
     /* 253901 */   // Label 5082: @253901
     /* 253901 */   GIM_Try, /*On fail goto*//*Label 5083*/ GIMT_Encode4(253972), // Rule ID 5364 //
     /* 253906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 253910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 253914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 253918 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 253922 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 253926 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 253930 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 253934 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 253939 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 253944 */     // MIs[1] Operand 2
     /* 253944 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 253955 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 253957 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] }))  =>  (SUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 253957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v2i32),
     /* 253960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 253962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 253966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 253970 */     GIR_RootConstrainSelectedInstOperands,
     /* 253971 */     // GIR_Coverage, 5364,
     /* 253971 */     GIR_EraseRootFromParent_Done,
     /* 253972 */   // Label 5083: @253972
     /* 253972 */   GIM_Try, /*On fail goto*//*Label 5084*/ GIMT_Encode4(254025), // Rule ID 2153 //
     /* 253977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 253980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 253984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /* 253988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 253992 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 253997 */     // MIs[1] imm
     /* 253997 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 254001 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 254005 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 254009 */     // MIs[2] Operand 1
     /* 254009 */     // No operand predicates
     /* 254009 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 254011 */     // (trunc:{ *:[v2i32] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (SHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 254011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv2i32_shift),
     /* 254014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 254016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 254020 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 254023 */     GIR_RootConstrainSelectedInstOperands,
     /* 254024 */     // GIR_Coverage, 2153,
     /* 254024 */     GIR_EraseRootFromParent_Done,
     /* 254025 */   // Label 5084: @254025
     /* 254025 */   GIM_Try, /*On fail goto*//*Label 5085*/ GIMT_Encode4(254075), // Rule ID 6254 //
     /* 254030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 254034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 254038 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 254042 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254047 */     // MIs[1] imm
     /* 254047 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 254051 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 254055 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 254059 */     // MIs[2] Operand 1
     /* 254059 */     // No operand predicates
     /* 254059 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 254061 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (SHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
     /* 254061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv2i32_shift),
     /* 254064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 254066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 254070 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 254073 */     GIR_RootConstrainSelectedInstOperands,
     /* 254074 */     // GIR_Coverage, 6254,
     /* 254074 */     GIR_EraseRootFromParent_Done,
     /* 254075 */   // Label 5085: @254075
     /* 254075 */   GIM_Try, /*On fail goto*//*Label 5086*/ GIMT_Encode4(254094), // Rule ID 1092 //
     /* 254080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 254083 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254087 */     // (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn)  =>  (XTNv2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn)
     /* 254087 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv2i32),
     /* 254092 */     GIR_RootConstrainSelectedInstOperands,
     /* 254093 */     // GIR_Coverage, 1092,
     /* 254093 */     GIR_Done,
     /* 254094 */   // Label 5086: @254094
     /* 254094 */   GIM_Reject,
     /* 254095 */ // Label 5080: @254095
     /* 254095 */ GIM_Reject,
     /* 254096 */ // Label 5076: @254096
     /* 254096 */ GIM_Try, /*On fail goto*//*Label 5087*/ GIMT_Encode4(254594),
     /* 254101 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 254104 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 254108 */   GIM_Try, /*On fail goto*//*Label 5088*/ GIMT_Encode4(254186), // Rule ID 5360 //
     /* 254113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 254117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 254121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 254125 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 254129 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 254133 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 254137 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 254141 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254146 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 254150 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 254156 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /* 254158 */     // MIs[1] Operand 2
     /* 254158 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 254169 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 254171 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] }:$Rm), 16:{ *:[i32] }))  =>  (SUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 254171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v4i16),
     /* 254174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 254176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 254180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 254184 */     GIR_RootConstrainSelectedInstOperands,
     /* 254185 */     // GIR_Coverage, 5360,
     /* 254185 */     GIR_EraseRootFromParent_Done,
     /* 254186 */   // Label 5088: @254186
     /* 254186 */   GIM_Try, /*On fail goto*//*Label 5089*/ GIMT_Encode4(254257), // Rule ID 5356 //
     /* 254191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 254195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 254199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 254203 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 254207 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 254211 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 254215 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 254219 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254224 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254229 */     // MIs[1] Operand 2
     /* 254229 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 254240 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 254242 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] }))  =>  (ADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 254242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v4i16),
     /* 254245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 254247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 254251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 254255 */     GIR_RootConstrainSelectedInstOperands,
     /* 254256 */     // GIR_Coverage, 5356,
     /* 254256 */     GIR_EraseRootFromParent_Done,
     /* 254257 */   // Label 5089: @254257
     /* 254257 */   GIM_Try, /*On fail goto*//*Label 5090*/ GIMT_Encode4(254328), // Rule ID 5358 //
     /* 254262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 254266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 254270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 254274 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 254278 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 254282 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 254286 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 254290 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254295 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254300 */     // MIs[1] Operand 2
     /* 254300 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 254311 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 254313 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] }))  =>  (SUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 254313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v4i16),
     /* 254316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 254318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 254322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 254326 */     GIR_RootConstrainSelectedInstOperands,
     /* 254327 */     // GIR_Coverage, 5358,
     /* 254327 */     GIR_EraseRootFromParent_Done,
     /* 254328 */   // Label 5090: @254328
     /* 254328 */   GIM_Try, /*On fail goto*//*Label 5091*/ GIMT_Encode4(254420), // Rule ID 5482 //
     /* 254333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 254337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 254341 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 254344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 254348 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 254352 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 254356 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 254360 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 254364 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254369 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 254373 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 254377 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 254381 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254386 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 254388 */     // (trunc:{ *:[v4i16] } (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn), (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vm)))  =>  (XTNv4i16:{ *:[v4i16] } (UZP1v4i32:{ *:[f128] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm))
     /* 254388 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 254391 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /* 254395 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 254400 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /* 254404 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, // Vm
     /* 254408 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 254410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i16),
     /* 254413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 254415 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 254418 */     GIR_RootConstrainSelectedInstOperands,
     /* 254419 */     // GIR_Coverage, 5482,
     /* 254419 */     GIR_EraseRootFromParent_Done,
     /* 254420 */   // Label 5091: @254420
     /* 254420 */   GIM_Try, /*On fail goto*//*Label 5092*/ GIMT_Encode4(254473), // Rule ID 2152 //
     /* 254425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 254428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 254432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /* 254436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 254440 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254445 */     // MIs[1] imm
     /* 254445 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 254449 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 254453 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 254457 */     // MIs[2] Operand 1
     /* 254457 */     // No operand predicates
     /* 254457 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 254459 */     // (trunc:{ *:[v4i16] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (SHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 254459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i16_shift),
     /* 254462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 254464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 254468 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 254471 */     GIR_RootConstrainSelectedInstOperands,
     /* 254472 */     // GIR_Coverage, 2152,
     /* 254472 */     GIR_EraseRootFromParent_Done,
     /* 254473 */   // Label 5092: @254473
     /* 254473 */   GIM_Try, /*On fail goto*//*Label 5093*/ GIMT_Encode4(254523), // Rule ID 6253 //
     /* 254478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 254482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 254486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 254490 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254495 */     // MIs[1] imm
     /* 254495 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 254499 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 254503 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 254507 */     // MIs[2] Operand 1
     /* 254507 */     // No operand predicates
     /* 254507 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 254509 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (SHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /* 254509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i16_shift),
     /* 254512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 254514 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 254518 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 254521 */     GIR_RootConstrainSelectedInstOperands,
     /* 254522 */     // GIR_Coverage, 6253,
     /* 254522 */     GIR_EraseRootFromParent_Done,
     /* 254523 */   // Label 5093: @254523
     /* 254523 */   GIM_Try, /*On fail goto*//*Label 5094*/ GIMT_Encode4(254574), // Rule ID 5510 //
     /* 254528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 254532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 254536 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 254539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 254543 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 254547 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 254552 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 254557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 254559 */     // (trunc:{ *:[v4i16] } (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vm))  =>  (UZP1v4i16:{ *:[v4i16] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vm)
     /* 254559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
     /* 254562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 254564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 254568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 254572 */     GIR_RootConstrainSelectedInstOperands,
     /* 254573 */     // GIR_Coverage, 5510,
     /* 254573 */     GIR_EraseRootFromParent_Done,
     /* 254574 */   // Label 5094: @254574
     /* 254574 */   GIM_Try, /*On fail goto*//*Label 5095*/ GIMT_Encode4(254593), // Rule ID 1091 //
     /* 254579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 254582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254586 */     // (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn)  =>  (XTNv4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn)
     /* 254586 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i16),
     /* 254591 */     GIR_RootConstrainSelectedInstOperands,
     /* 254592 */     // GIR_Coverage, 1091,
     /* 254592 */     GIR_Done,
     /* 254593 */   // Label 5095: @254593
     /* 254593 */   GIM_Reject,
     /* 254594 */ // Label 5087: @254594
     /* 254594 */ GIM_Reject,
     /* 254595 */ // Label 5077: @254595
     /* 254595 */ GIM_Try, /*On fail goto*//*Label 5096*/ GIMT_Encode4(255093),
     /* 254600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 254603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 254607 */   GIM_Try, /*On fail goto*//*Label 5097*/ GIMT_Encode4(254685), // Rule ID 5354 //
     /* 254612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 254616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 254620 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 254624 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 254628 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 254632 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 254636 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 254640 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254645 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 254649 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 254655 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /* 254657 */     // MIs[1] Operand 2
     /* 254657 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 254668 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 254670 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] }:$Rm), 8:{ *:[i32] }))  =>  (SUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 254670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v8i8),
     /* 254673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 254675 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 254679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 254683 */     GIR_RootConstrainSelectedInstOperands,
     /* 254684 */     // GIR_Coverage, 5354,
     /* 254684 */     GIR_EraseRootFromParent_Done,
     /* 254685 */   // Label 5097: @254685
     /* 254685 */   GIM_Try, /*On fail goto*//*Label 5098*/ GIMT_Encode4(254756), // Rule ID 5350 //
     /* 254690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 254694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 254698 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 254702 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 254706 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 254710 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 254714 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 254718 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254723 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254728 */     // MIs[1] Operand 2
     /* 254728 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 254739 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 254741 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] }))  =>  (ADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 254741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v8i8),
     /* 254744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 254746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 254750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 254754 */     GIR_RootConstrainSelectedInstOperands,
     /* 254755 */     // GIR_Coverage, 5350,
     /* 254755 */     GIR_EraseRootFromParent_Done,
     /* 254756 */   // Label 5098: @254756
     /* 254756 */   GIM_Try, /*On fail goto*//*Label 5099*/ GIMT_Encode4(254827), // Rule ID 5352 //
     /* 254761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 254765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 254769 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 254773 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 254777 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 254781 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 254785 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 254789 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254794 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254799 */     // MIs[1] Operand 2
     /* 254799 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 254810 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 254812 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] }))  =>  (SUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 254812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v8i8),
     /* 254815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 254817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 254821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 254825 */     GIR_RootConstrainSelectedInstOperands,
     /* 254826 */     // GIR_Coverage, 5352,
     /* 254826 */     GIR_EraseRootFromParent_Done,
     /* 254827 */   // Label 5099: @254827
     /* 254827 */   GIM_Try, /*On fail goto*//*Label 5100*/ GIMT_Encode4(254919), // Rule ID 5455 //
     /* 254832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 254836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 254840 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 254843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 254847 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 254851 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 254855 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 254859 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 254863 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254868 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 254872 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 254876 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 254880 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254885 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 254887 */     // (trunc:{ *:[v8i8] } (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn), (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vm)))  =>  (XTNv8i8:{ *:[v8i8] } (UZP1v8i16:{ *:[f128] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm))
     /* 254887 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 254890 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 254894 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 254899 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /* 254903 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, // Vm
     /* 254907 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 254909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i8),
     /* 254912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 254914 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 254917 */     GIR_RootConstrainSelectedInstOperands,
     /* 254918 */     // GIR_Coverage, 5455,
     /* 254918 */     GIR_EraseRootFromParent_Done,
     /* 254919 */   // Label 5100: @254919
     /* 254919 */   GIM_Try, /*On fail goto*//*Label 5101*/ GIMT_Encode4(254972), // Rule ID 2151 //
     /* 254924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 254927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 254931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /* 254935 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 254939 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254944 */     // MIs[1] imm
     /* 254944 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 254948 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 254952 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 254956 */     // MIs[2] Operand 1
     /* 254956 */     // No operand predicates
     /* 254956 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 254958 */     // (trunc:{ *:[v8i8] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (SHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 254958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i8_shift),
     /* 254961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 254963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 254967 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 254970 */     GIR_RootConstrainSelectedInstOperands,
     /* 254971 */     // GIR_Coverage, 2151,
     /* 254971 */     GIR_EraseRootFromParent_Done,
     /* 254972 */   // Label 5101: @254972
     /* 254972 */   GIM_Try, /*On fail goto*//*Label 5102*/ GIMT_Encode4(255022), // Rule ID 6252 //
     /* 254977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 254981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 254985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 254989 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254994 */     // MIs[1] imm
     /* 254994 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 254998 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 255002 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 255006 */     // MIs[2] Operand 1
     /* 255006 */     // No operand predicates
     /* 255006 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 255008 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (SHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /* 255008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i8_shift),
     /* 255011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 255013 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 255017 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 255020 */     GIR_RootConstrainSelectedInstOperands,
     /* 255021 */     // GIR_Coverage, 6252,
     /* 255021 */     GIR_EraseRootFromParent_Done,
     /* 255022 */   // Label 5102: @255022
     /* 255022 */   GIM_Try, /*On fail goto*//*Label 5103*/ GIMT_Encode4(255073), // Rule ID 5509 //
     /* 255027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 255031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 255035 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 255038 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 255042 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 255046 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 255051 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 255056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 255058 */     // (trunc:{ *:[v8i8] } (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vm))  =>  (UZP1v8i8:{ *:[v8i8] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vm)
     /* 255058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i8),
     /* 255061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 255063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 255067 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 255071 */     GIR_RootConstrainSelectedInstOperands,
     /* 255072 */     // GIR_Coverage, 5509,
     /* 255072 */     GIR_EraseRootFromParent_Done,
     /* 255073 */   // Label 5103: @255073
     /* 255073 */   GIM_Try, /*On fail goto*//*Label 5104*/ GIMT_Encode4(255092), // Rule ID 1090 //
     /* 255078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 255081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 255085 */     // (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn)  =>  (XTNv8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn)
     /* 255085 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i8),
     /* 255090 */     GIR_RootConstrainSelectedInstOperands,
     /* 255091 */     // GIR_Coverage, 1090,
     /* 255091 */     GIR_Done,
     /* 255092 */   // Label 5104: @255092
     /* 255092 */   GIM_Reject,
     /* 255093 */ // Label 5096: @255093
     /* 255093 */ GIM_Reject,
     /* 255094 */ // Label 5078: @255094
     /* 255094 */ GIM_Reject,
     /* 255095 */ // Label 36: @255095
     /* 255095 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5107*/ GIMT_Encode4(255214),
     /* 255106 */ /*GILLT_s32*//*Label 5105*/ GIMT_Encode4(255114),
     /* 255110 */ /*GILLT_s64*//*Label 5106*/ GIMT_Encode4(255134),
     /* 255114 */ // Label 5105: @255114
     /* 255114 */ GIM_Try, /*On fail goto*//*Label 5108*/ GIMT_Encode4(255133), // Rule ID 81 //
     /* 255119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 255123 */   // MIs[0] Operand 1
     /* 255123 */   // No operand predicates
     /* 255123 */   // (imm:{ *:[i32] }):$src  =>  (MOVi32imm:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /* 255123 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /* 255126 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 255128 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 255131 */   GIR_RootConstrainSelectedInstOperands,
     /* 255132 */   // GIR_Coverage, 81,
     /* 255132 */   GIR_EraseRootFromParent_Done,
     /* 255133 */ // Label 5108: @255133
     /* 255133 */ GIM_Reject,
     /* 255134 */ // Label 5106: @255134
     /* 255134 */ GIM_Try, /*On fail goto*//*Label 5109*/ GIMT_Encode4(255194), // Rule ID 3847 //
     /* 255139 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptimizedGISelOrOtherSelector),
     /* 255142 */   GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /* 255146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 255150 */   // MIs[0] Operand 1
     /* 255150 */   // No operand predicates
     /* 255150 */   // (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$src  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$src)), sub_32:{ *:[i32] })
     /* 255150 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 255153 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /* 255157 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 255162 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // src
     /* 255167 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 255169 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 255172 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 255174 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255177 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 255180 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 255183 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 255188 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 255193 */   // GIR_Coverage, 3847,
     /* 255193 */   GIR_EraseRootFromParent_Done,
     /* 255194 */ // Label 5109: @255194
     /* 255194 */ GIM_Try, /*On fail goto*//*Label 5110*/ GIMT_Encode4(255213), // Rule ID 82 //
     /* 255199 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 255203 */   // MIs[0] Operand 1
     /* 255203 */   // No operand predicates
     /* 255203 */   // (imm:{ *:[i64] }):$src  =>  (MOVi64imm:{ *:[i64] } (imm:{ *:[i64] }):$src)
     /* 255203 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MOVi64imm),
     /* 255206 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 255208 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 255211 */   GIR_RootConstrainSelectedInstOperands,
     /* 255212 */   // GIR_Coverage, 82,
     /* 255212 */   GIR_EraseRootFromParent_Done,
     /* 255213 */ // Label 5110: @255213
     /* 255213 */ GIM_Reject,
     /* 255214 */ // Label 5107: @255214
     /* 255214 */ GIM_Reject,
     /* 255215 */ // Label 37: @255215
     /* 255215 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 5114*/ GIMT_Encode4(255455),
     /* 255226 */ /*GILLT_s16*//*Label 5111*/ GIMT_Encode4(255238),
     /* 255230 */ /*GILLT_s32*//*Label 5112*/ GIMT_Encode4(255290),
     /* 255234 */ /*GILLT_s64*//*Label 5113*/ GIMT_Encode4(255403),
     /* 255238 */ // Label 5111: @255238
     /* 255238 */ GIM_Try, /*On fail goto*//*Label 5115*/ GIMT_Encode4(255261), // Rule ID 506 //
     /* 255243 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 255246 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 255250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 255254 */   // MIs[0] Operand 1
     /* 255254 */   // No operand predicates
     /* 255254 */   // (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>  =>  (FMOVH0:{ *:[f16] })
     /* 255254 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVH0),
     /* 255257 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 255259 */   GIR_RootConstrainSelectedInstOperands,
     /* 255260 */   // GIR_Coverage, 506,
     /* 255260 */   GIR_EraseRootFromParent_Done,
     /* 255261 */ // Label 5115: @255261
     /* 255261 */ GIM_Try, /*On fail goto*//*Label 5116*/ GIMT_Encode4(255289), // Rule ID 688 //
     /* 255266 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 255269 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 255273 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 255277 */   // MIs[0] Operand 1
     /* 255277 */   // No operand predicates
     /* 255277 */   // (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm  =>  (FMOVHi:{ *:[f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] }):$imm))
     /* 255277 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVHi),
     /* 255280 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 255282 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm
     /* 255287 */   GIR_RootConstrainSelectedInstOperands,
     /* 255288 */   // GIR_Coverage, 688,
     /* 255288 */   GIR_EraseRootFromParent_Done,
     /* 255289 */ // Label 5116: @255289
     /* 255289 */ GIM_Reject,
     /* 255290 */ // Label 5112: @255290
     /* 255290 */ GIM_Try, /*On fail goto*//*Label 5117*/ GIMT_Encode4(255313), // Rule ID 507 //
     /* 255295 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 255298 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 255302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 255306 */   // MIs[0] Operand 1
     /* 255306 */   // No operand predicates
     /* 255306 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>  =>  (FMOVS0:{ *:[f32] })
     /* 255306 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVS0),
     /* 255309 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 255311 */   GIR_RootConstrainSelectedInstOperands,
     /* 255312 */   // GIR_Coverage, 507,
     /* 255312 */   GIR_EraseRootFromParent_Done,
     /* 255313 */ // Label 5117: @255313
     /* 255313 */ GIM_Try, /*On fail goto*//*Label 5118*/ GIMT_Encode4(255341), // Rule ID 689 //
     /* 255318 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 255321 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 255325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 255329 */   // MIs[0] Operand 1
     /* 255329 */   // No operand predicates
     /* 255329 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm  =>  (FMOVSi:{ *:[f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] }):$imm))
     /* 255329 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVSi),
     /* 255332 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 255334 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm
     /* 255339 */   GIR_RootConstrainSelectedInstOperands,
     /* 255340 */   // GIR_Coverage, 689,
     /* 255340 */   GIR_EraseRootFromParent_Done,
     /* 255341 */ // Label 5118: @255341
     /* 255341 */ GIM_Try, /*On fail goto*//*Label 5119*/ GIMT_Encode4(255402), // Rule ID 5933 //
     /* 255346 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 255349 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4),
     /* 255353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 255357 */   // MIs[0] Operand 1
     /* 255357 */   // No operand predicates
     /* 255357 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm32SIMDModImmType4>><<X:fpimm32SIMDModImmType4XForm>>:$in  =>  (EXTRACT_SUBREG:{ *:[f32] } (MOVIv2i32:{ *:[i64] } (fpimm32SIMDModImmType4XForm:{ *:[i32] } f32:{ *:[f32] }:$in), 24:{ *:[i32] }), ssub:{ *:[i32] })
     /* 255357 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 255360 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2i32),
     /* 255364 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 255369 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32SIMDModImmType4), // in
     /* 255374 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/24,
     /* 255377 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 255379 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 255382 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 255384 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 255391 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 255396 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 255401 */   // GIR_Coverage, 5933,
     /* 255401 */   GIR_EraseRootFromParent_Done,
     /* 255402 */ // Label 5119: @255402
     /* 255402 */ GIM_Reject,
     /* 255403 */ // Label 5113: @255403
     /* 255403 */ GIM_Try, /*On fail goto*//*Label 5120*/ GIMT_Encode4(255426), // Rule ID 508 //
     /* 255408 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 255411 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 255415 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 255419 */   // MIs[0] Operand 1
     /* 255419 */   // No operand predicates
     /* 255419 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>  =>  (FMOVD0:{ *:[f64] })
     /* 255419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVD0),
     /* 255422 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 255424 */   GIR_RootConstrainSelectedInstOperands,
     /* 255425 */   // GIR_Coverage, 508,
     /* 255425 */   GIR_EraseRootFromParent_Done,
     /* 255426 */ // Label 5120: @255426
     /* 255426 */ GIM_Try, /*On fail goto*//*Label 5121*/ GIMT_Encode4(255454), // Rule ID 690 //
     /* 255431 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 255434 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm64),
     /* 255438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 255442 */   // MIs[0] Operand 1
     /* 255442 */   // No operand predicates
     /* 255442 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>><<X:fpimm64XForm>>:$imm  =>  (FMOVDi:{ *:[f64] } (fpimm64XForm:{ *:[f64] } (fpimm:{ *:[f64] }):$imm))
     /* 255442 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVDi),
     /* 255445 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 255447 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm64), // imm
     /* 255452 */   GIR_RootConstrainSelectedInstOperands,
     /* 255453 */   // GIR_Coverage, 690,
     /* 255453 */   GIR_EraseRootFromParent_Done,
     /* 255454 */ // Label 5121: @255454
     /* 255454 */ GIM_Reject,
     /* 255455 */ // Label 5114: @255455
     /* 255455 */ GIM_Reject,
     /* 255456 */ // Label 38: @255456
     /* 255456 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5127*/ GIMT_Encode4(257353),
     /* 255467 */ /*GILLT_s32*//*Label 5122*/ GIMT_Encode4(255503),
     /* 255471 */ /*GILLT_s64*//*Label 5123*/ GIMT_Encode4(256944), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 255483 */ /*GILLT_v2s64*//*Label 5124*/ GIMT_Encode4(257167), GIMT_Encode4(0),
     /* 255491 */ /*GILLT_v4s32*//*Label 5125*/ GIMT_Encode4(257229), GIMT_Encode4(0),
     /* 255499 */ /*GILLT_v8s16*//*Label 5126*/ GIMT_Encode4(257291),
     /* 255503 */ // Label 5122: @255503
     /* 255503 */ GIM_Try, /*On fail goto*//*Label 5128*/ GIMT_Encode4(255623), // Rule ID 12840 //
     /* 255508 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 255511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 255515 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 255519 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 255523 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 255526 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 255531 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 255535 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 255540 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 255542 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 662:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 255542 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 255545 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 255549 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 255554 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 255558 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 255560 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 255563 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 255567 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 255572 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 255574 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 255577 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 255581 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 255586 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 255589 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 255592 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 255595 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 255600 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 255605 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 255610 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 255613 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 255615 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 255618 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255621 */   GIR_RootConstrainSelectedInstOperands,
     /* 255622 */   // GIR_Coverage, 12840,
     /* 255622 */   GIR_EraseRootFromParent_Done,
     /* 255623 */ // Label 5128: @255623
     /* 255623 */ GIM_Try, /*On fail goto*//*Label 5129*/ GIMT_Encode4(255743), // Rule ID 12842 //
     /* 255628 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 255631 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 255635 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 255639 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 255643 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 255646 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 255651 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 255655 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 255660 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 255662 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 662:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 255662 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 255665 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 255669 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 255674 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 255678 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 255680 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 255683 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 255687 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 255692 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 255694 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 255697 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 255701 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 255706 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 255709 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 255712 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 255715 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 255720 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 255725 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 255730 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 255733 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 255735 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 255738 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255741 */   GIR_RootConstrainSelectedInstOperands,
     /* 255742 */   // GIR_Coverage, 12842,
     /* 255742 */   GIR_EraseRootFromParent_Done,
     /* 255743 */ // Label 5129: @255743
     /* 255743 */ GIM_Try, /*On fail goto*//*Label 5130*/ GIMT_Encode4(255863), // Rule ID 12844 //
     /* 255748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 255751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 255755 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 255759 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 255763 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 255766 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 255771 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 255775 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 255780 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 255782 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 662:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 255782 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 255785 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 255789 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 255794 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 255798 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 255800 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 255803 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 255807 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 255812 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 255814 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 255817 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 255821 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 255826 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 255829 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 255832 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 255835 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 255840 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 255845 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 255850 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 255853 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 255855 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 255858 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255861 */   GIR_RootConstrainSelectedInstOperands,
     /* 255862 */   // GIR_Coverage, 12844,
     /* 255862 */   GIR_EraseRootFromParent_Done,
     /* 255863 */ // Label 5130: @255863
     /* 255863 */ GIM_Try, /*On fail goto*//*Label 5131*/ GIMT_Encode4(255983), // Rule ID 12846 //
     /* 255868 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 255871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 255875 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 255879 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 255883 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 255886 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 255891 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 255895 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 255900 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 255902 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 662:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 255902 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 255905 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 255909 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 255914 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 255918 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 255920 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 255923 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 255927 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 255932 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 255934 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 255937 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 255941 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 255946 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 255949 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 255952 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 255955 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 255960 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 255965 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 255970 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 255973 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 255975 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 255978 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255981 */   GIR_RootConstrainSelectedInstOperands,
     /* 255982 */   // GIR_Coverage, 12846,
     /* 255982 */   GIR_EraseRootFromParent_Done,
     /* 255983 */ // Label 5131: @255983
     /* 255983 */ GIM_Try, /*On fail goto*//*Label 5132*/ GIMT_Encode4(256103), // Rule ID 12862 //
     /* 255988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 255991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 255995 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 255999 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 256003 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 256006 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 256011 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 256015 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256020 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 256022 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 672:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 256022 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 256025 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
     /* 256029 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256034 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 256038 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 256040 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 256043 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 256047 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256052 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 256054 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 256057 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 256061 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256066 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 256069 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 256072 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 256075 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256080 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256085 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 256090 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 256093 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256095 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 256098 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256101 */   GIR_RootConstrainSelectedInstOperands,
     /* 256102 */   // GIR_Coverage, 12862,
     /* 256102 */   GIR_EraseRootFromParent_Done,
     /* 256103 */ // Label 5132: @256103
     /* 256103 */ GIM_Try, /*On fail goto*//*Label 5133*/ GIMT_Encode4(256223), // Rule ID 12864 //
     /* 256108 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 256111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 256115 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 256119 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 256123 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 256126 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 256131 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 256135 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256140 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 256142 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 672:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 256142 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 256145 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
     /* 256149 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256154 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 256158 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 256160 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 256163 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 256167 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256172 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 256174 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 256177 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 256181 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256186 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 256189 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 256192 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 256195 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256200 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256205 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 256210 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 256213 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256215 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 256218 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256221 */   GIR_RootConstrainSelectedInstOperands,
     /* 256222 */   // GIR_Coverage, 12864,
     /* 256222 */   GIR_EraseRootFromParent_Done,
     /* 256223 */ // Label 5133: @256223
     /* 256223 */ GIM_Try, /*On fail goto*//*Label 5134*/ GIMT_Encode4(256343), // Rule ID 12866 //
     /* 256228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 256231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 256235 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 256239 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 256243 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 256246 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 256251 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 256255 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256260 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 256262 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 672:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 256262 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 256265 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
     /* 256269 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256274 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 256278 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 256280 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 256283 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 256287 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256292 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 256294 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 256297 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 256301 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256306 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 256309 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 256312 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 256315 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256320 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256325 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 256330 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 256333 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256335 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 256338 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256341 */   GIR_RootConstrainSelectedInstOperands,
     /* 256342 */   // GIR_Coverage, 12866,
     /* 256342 */   GIR_EraseRootFromParent_Done,
     /* 256343 */ // Label 5134: @256343
     /* 256343 */ GIM_Try, /*On fail goto*//*Label 5135*/ GIMT_Encode4(256463), // Rule ID 12868 //
     /* 256348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 256351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 256355 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 256359 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 256363 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 256366 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 256371 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 256375 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256380 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 256382 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 672:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 256382 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 256385 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
     /* 256389 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256394 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 256398 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 256400 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 256403 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 256407 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256412 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 256414 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 256417 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 256421 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256426 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 256429 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 256432 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 256435 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256440 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256445 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 256450 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 256453 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256455 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 256458 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256461 */   GIR_RootConstrainSelectedInstOperands,
     /* 256462 */   // GIR_Coverage, 12868,
     /* 256462 */   GIR_EraseRootFromParent_Done,
     /* 256463 */ // Label 5135: @256463
     /* 256463 */ GIM_Try, /*On fail goto*//*Label 5136*/ GIMT_Encode4(256583), // Rule ID 12872 //
     /* 256468 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 256471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 256475 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 256479 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 256483 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 256486 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 256491 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 256495 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256500 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 256502 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 675:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 256502 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 256505 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
     /* 256509 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256514 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 256518 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 256520 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 256523 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 256527 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256532 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 256534 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 256537 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 256541 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256546 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 256549 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 256552 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 256555 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256560 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256565 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 256570 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 256573 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256575 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 256578 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256581 */   GIR_RootConstrainSelectedInstOperands,
     /* 256582 */   // GIR_Coverage, 12872,
     /* 256582 */   GIR_EraseRootFromParent_Done,
     /* 256583 */ // Label 5136: @256583
     /* 256583 */ GIM_Try, /*On fail goto*//*Label 5137*/ GIMT_Encode4(256703), // Rule ID 12874 //
     /* 256588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 256591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 256595 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 256599 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 256603 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 256606 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 256611 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 256615 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256620 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 256622 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 675:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 256622 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 256625 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
     /* 256629 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256634 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 256638 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 256640 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 256643 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 256647 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256652 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 256654 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 256657 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 256661 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256666 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 256669 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 256672 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 256675 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256680 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256685 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 256690 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 256693 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256695 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 256698 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256701 */   GIR_RootConstrainSelectedInstOperands,
     /* 256702 */   // GIR_Coverage, 12874,
     /* 256702 */   GIR_EraseRootFromParent_Done,
     /* 256703 */ // Label 5137: @256703
     /* 256703 */ GIM_Try, /*On fail goto*//*Label 5138*/ GIMT_Encode4(256823), // Rule ID 12876 //
     /* 256708 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 256711 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 256715 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 256719 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 256723 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 256726 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 256731 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 256735 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256740 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 256742 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 675:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 256742 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 256745 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
     /* 256749 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256754 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 256758 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 256760 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 256763 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 256767 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256772 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 256774 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 256777 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 256781 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256786 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 256789 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 256792 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 256795 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256800 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256805 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 256810 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 256813 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256815 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 256818 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256821 */   GIR_RootConstrainSelectedInstOperands,
     /* 256822 */   // GIR_Coverage, 12876,
     /* 256822 */   GIR_EraseRootFromParent_Done,
     /* 256823 */ // Label 5138: @256823
     /* 256823 */ GIM_Try, /*On fail goto*//*Label 5139*/ GIMT_Encode4(256943), // Rule ID 12878 //
     /* 256828 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 256831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 256835 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 256839 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 256843 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 256846 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 256851 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 256855 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256860 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 256862 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 675:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 256862 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 256865 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
     /* 256869 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256874 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 256878 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 256880 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 256883 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 256887 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256892 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 256894 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 256897 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 256901 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 256906 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 256909 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 256912 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 256915 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256920 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256925 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 256930 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 256933 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 256935 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 256938 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256941 */   GIR_RootConstrainSelectedInstOperands,
     /* 256942 */   // GIR_Coverage, 12878,
     /* 256942 */   GIR_EraseRootFromParent_Done,
     /* 256943 */ // Label 5139: @256943
     /* 256943 */ GIM_Reject,
     /* 256944 */ // Label 5123: @256944
     /* 256944 */ GIM_Try, /*On fail goto*//*Label 5140*/ GIMT_Encode4(257166),
     /* 256949 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 256952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 256956 */   GIM_Try, /*On fail goto*//*Label 5141*/ GIMT_Encode4(257010), // Rule ID 5587 //
     /* 256961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 256965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 256969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 256973 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 256977 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256982 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 256986 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 256990 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 256994 */     // MIs[2] Operand 1
     /* 256994 */     // No operand predicates
     /* 256994 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 256996 */     // (sext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SMOVvi32to64:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 256996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi32to64),
     /* 256999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 257005 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 257008 */     GIR_RootConstrainSelectedInstOperands,
     /* 257009 */     // GIR_Coverage, 5587,
     /* 257009 */     GIR_EraseRootFromParent_Done,
     /* 257010 */   // Label 5141: @257010
     /* 257010 */   GIM_Try, /*On fail goto*//*Label 5142*/ GIMT_Encode4(257089), // Rule ID 11038 //
     /* 257015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 257018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 257022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 257026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 257030 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 257034 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 257038 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 257042 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 257046 */     // MIs[2] Operand 1
     /* 257046 */     // No operand predicates
     /* 257046 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 257048 */     // (sext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index))  =>  (SMOVvi32to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v4i32] } ZPR:{ *:[nxv4i32] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)
     /* 257048 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 257051 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 257055 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257060 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 257066 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257071 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi32to64),
     /* 257079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257081 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 257084 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 257087 */     GIR_RootConstrainSelectedInstOperands,
     /* 257088 */     // GIR_Coverage, 11038,
     /* 257088 */     GIR_EraseRootFromParent_Done,
     /* 257089 */   // Label 5142: @257089
     /* 257089 */   GIM_Try, /*On fail goto*//*Label 5143*/ GIMT_Encode4(257165), // Rule ID 6409 //
     /* 257094 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 257098 */     // (sext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (SBFMXri:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$src, sub_32:{ *:[i32] }), 0:{ *:[i64] }, 31:{ *:[i64] })
     /* 257098 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 257101 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 257105 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257110 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 257112 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 257115 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 257119 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257124 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 257127 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 257131 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 257134 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 257139 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 257144 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 257149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 257152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257154 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 257157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 257163 */     GIR_RootConstrainSelectedInstOperands,
     /* 257164 */     // GIR_Coverage, 6409,
     /* 257164 */     GIR_EraseRootFromParent_Done,
     /* 257165 */   // Label 5143: @257165
     /* 257165 */   GIM_Reject,
     /* 257166 */ // Label 5140: @257166
     /* 257166 */ GIM_Reject,
     /* 257167 */ // Label 5124: @257167
     /* 257167 */ GIM_Try, /*On fail goto*//*Label 5144*/ GIMT_Encode4(257228),
     /* 257172 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 257175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257179 */   GIM_Try, /*On fail goto*//*Label 5145*/ GIMT_Encode4(257206), // Rule ID 6281 //
     /* 257184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 257191 */     // (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (SSHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
     /* 257191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i32_shift),
     /* 257194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 257201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257204 */     GIR_RootConstrainSelectedInstOperands,
     /* 257205 */     // GIR_Coverage, 6281,
     /* 257205 */     GIR_EraseRootFromParent_Done,
     /* 257206 */   // Label 5145: @257206
     /* 257206 */   GIM_Try, /*On fail goto*//*Label 5146*/ GIMT_Encode4(257227), // Rule ID 6270 //
     /* 257211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257215 */     // (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (SSHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
     /* 257215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 257218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257220 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 257222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257225 */     GIR_RootConstrainSelectedInstOperands,
     /* 257226 */     // GIR_Coverage, 6270,
     /* 257226 */     GIR_EraseRootFromParent_Done,
     /* 257227 */   // Label 5146: @257227
     /* 257227 */   GIM_Reject,
     /* 257228 */ // Label 5144: @257228
     /* 257228 */ GIM_Reject,
     /* 257229 */ // Label 5125: @257229
     /* 257229 */ GIM_Try, /*On fail goto*//*Label 5147*/ GIMT_Encode4(257290),
     /* 257234 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 257237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257241 */   GIM_Try, /*On fail goto*//*Label 5148*/ GIMT_Encode4(257268), // Rule ID 6278 //
     /* 257246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 257253 */     // (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (SSHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
     /* 257253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i16_shift),
     /* 257256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 257263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257266 */     GIR_RootConstrainSelectedInstOperands,
     /* 257267 */     // GIR_Coverage, 6278,
     /* 257267 */     GIR_EraseRootFromParent_Done,
     /* 257268 */   // Label 5148: @257268
     /* 257268 */   GIM_Try, /*On fail goto*//*Label 5149*/ GIMT_Encode4(257289), // Rule ID 6267 //
     /* 257273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257277 */     // (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SSHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
     /* 257277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 257280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257282 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 257284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257287 */     GIR_RootConstrainSelectedInstOperands,
     /* 257288 */     // GIR_Coverage, 6267,
     /* 257288 */     GIR_EraseRootFromParent_Done,
     /* 257289 */   // Label 5149: @257289
     /* 257289 */   GIM_Reject,
     /* 257290 */ // Label 5147: @257290
     /* 257290 */ GIM_Reject,
     /* 257291 */ // Label 5126: @257291
     /* 257291 */ GIM_Try, /*On fail goto*//*Label 5150*/ GIMT_Encode4(257352),
     /* 257296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 257299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257303 */   GIM_Try, /*On fail goto*//*Label 5151*/ GIMT_Encode4(257330), // Rule ID 6275 //
     /* 257308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 257315 */     // (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (SSHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
     /* 257315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv16i8_shift),
     /* 257318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 257325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257328 */     GIR_RootConstrainSelectedInstOperands,
     /* 257329 */     // GIR_Coverage, 6275,
     /* 257329 */     GIR_EraseRootFromParent_Done,
     /* 257330 */   // Label 5151: @257330
     /* 257330 */   GIM_Try, /*On fail goto*//*Label 5152*/ GIMT_Encode4(257351), // Rule ID 6264 //
     /* 257335 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257339 */     // (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (SSHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
     /* 257339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 257342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257344 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 257346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257349 */     GIR_RootConstrainSelectedInstOperands,
     /* 257350 */     // GIR_Coverage, 6264,
     /* 257350 */     GIR_EraseRootFromParent_Done,
     /* 257351 */   // Label 5152: @257351
     /* 257351 */   GIM_Reject,
     /* 257352 */ // Label 5150: @257352
     /* 257352 */ GIM_Reject,
     /* 257353 */ // Label 5127: @257353
     /* 257353 */ GIM_Reject,
     /* 257354 */ // Label 39: @257354
     /* 257354 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(22), /*)*//*default:*//*Label 5158*/ GIMT_Encode4(259007),
     /* 257365 */ /*GILLT_s32*//*Label 5153*/ GIMT_Encode4(257445),
     /* 257369 */ /*GILLT_s64*//*Label 5154*/ GIMT_Encode4(257939), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 257421 */ /*GILLT_nxv2s64*//*Label 5155*/ GIMT_Encode4(258581), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 257433 */ /*GILLT_nxv4s32*//*Label 5156*/ GIMT_Encode4(258790), GIMT_Encode4(0),
     /* 257441 */ /*GILLT_nxv8s16*//*Label 5157*/ GIMT_Encode4(258934),
     /* 257445 */ // Label 5153: @257445
     /* 257445 */ GIM_Try, /*On fail goto*//*Label 5159*/ GIMT_Encode4(257938),
     /* 257450 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 257453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 257457 */   GIM_Try, /*On fail goto*//*Label 5160*/ GIMT_Encode4(257522), // Rule ID 5582 //
     /* 257462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 257466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 257470 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 257474 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 257478 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257483 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 257487 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 257491 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 257495 */     // MIs[2] Operand 1
     /* 257495 */     // No operand predicates
     /* 257495 */     // MIs[0] Operand 2
     /* 257495 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 257506 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 257508 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), i8:{ *:[Other] })  =>  (SMOVvi8to32:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /* 257508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 257511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257513 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 257517 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 257520 */     GIR_RootConstrainSelectedInstOperands,
     /* 257521 */     // GIR_Coverage, 5582,
     /* 257521 */     GIR_EraseRootFromParent_Done,
     /* 257522 */   // Label 5160: @257522
     /* 257522 */   GIM_Try, /*On fail goto*//*Label 5161*/ GIMT_Encode4(257587), // Rule ID 5584 //
     /* 257527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 257531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 257535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 257539 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 257543 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257548 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 257552 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 257556 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 257560 */     // MIs[2] Operand 1
     /* 257560 */     // No operand predicates
     /* 257560 */     // MIs[0] Operand 2
     /* 257560 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 257571 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 257573 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 257573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 257576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 257582 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 257585 */     GIR_RootConstrainSelectedInstOperands,
     /* 257586 */     // GIR_Coverage, 5584,
     /* 257586 */     GIR_EraseRootFromParent_Done,
     /* 257587 */   // Label 5161: @257587
     /* 257587 */   GIM_Try, /*On fail goto*//*Label 5162*/ GIMT_Encode4(257652), // Rule ID 5586 //
     /* 257592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 257596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 257600 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 257604 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 257608 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257613 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 257617 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 257621 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 257625 */     // MIs[2] Operand 1
     /* 257625 */     // No operand predicates
     /* 257625 */     // MIs[0] Operand 2
     /* 257625 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 257636 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 257638 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 257638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 257641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 257647 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 257650 */     GIR_RootConstrainSelectedInstOperands,
     /* 257651 */     // GIR_Coverage, 5586,
     /* 257651 */     GIR_EraseRootFromParent_Done,
     /* 257652 */   // Label 5162: @257652
     /* 257652 */   GIM_Try, /*On fail goto*//*Label 5163*/ GIMT_Encode4(257742), // Rule ID 11034 //
     /* 257657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 257660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 257664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 257668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 257672 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 257676 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 257680 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 257684 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 257688 */     // MIs[2] Operand 1
     /* 257688 */     // No operand predicates
     /* 257688 */     // MIs[0] Operand 2
     /* 257688 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 257699 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 257701 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index), i8:{ *:[Other] })  =>  (SMOVvi8to32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
     /* 257701 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 257704 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 257708 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257713 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 257719 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257724 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 257732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 257737 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 257740 */     GIR_RootConstrainSelectedInstOperands,
     /* 257741 */     // GIR_Coverage, 11034,
     /* 257741 */     GIR_EraseRootFromParent_Done,
     /* 257742 */   // Label 5163: @257742
     /* 257742 */   GIM_Try, /*On fail goto*//*Label 5164*/ GIMT_Encode4(257832), // Rule ID 11036 //
     /* 257747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 257750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 257754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 257758 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 257762 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 257766 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 257770 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 257774 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 257778 */     // MIs[2] Operand 1
     /* 257778 */     // No operand predicates
     /* 257778 */     // MIs[0] Operand 2
     /* 257778 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 257789 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 257791 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
     /* 257791 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 257794 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 257798 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257803 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 257809 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257814 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 257822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257824 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 257827 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 257830 */     GIR_RootConstrainSelectedInstOperands,
     /* 257831 */     // GIR_Coverage, 11036,
     /* 257831 */     GIR_EraseRootFromParent_Done,
     /* 257832 */   // Label 5164: @257832
     /* 257832 */   GIM_Try, /*On fail goto*//*Label 5165*/ GIMT_Encode4(257867), // Rule ID 6414 //
     /* 257837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 257841 */     // MIs[0] Operand 2
     /* 257841 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 257852 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i16:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 15:{ *:[i64] })
     /* 257852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 257855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257857 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 257859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 257865 */     GIR_RootConstrainSelectedInstOperands,
     /* 257866 */     // GIR_Coverage, 6414,
     /* 257866 */     GIR_EraseRootFromParent_Done,
     /* 257867 */   // Label 5165: @257867
     /* 257867 */   GIM_Try, /*On fail goto*//*Label 5166*/ GIMT_Encode4(257902), // Rule ID 6415 //
     /* 257872 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 257876 */     // MIs[0] Operand 2
     /* 257876 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 257887 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i8:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 7:{ *:[i64] })
     /* 257887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 257890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257892 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 257894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 257900 */     GIR_RootConstrainSelectedInstOperands,
     /* 257901 */     // GIR_Coverage, 6415,
     /* 257901 */     GIR_EraseRootFromParent_Done,
     /* 257902 */   // Label 5166: @257902
     /* 257902 */   GIM_Try, /*On fail goto*//*Label 5167*/ GIMT_Encode4(257937), // Rule ID 6416 //
     /* 257907 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 257911 */     // MIs[0] Operand 2
     /* 257911 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 257922 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i1:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 0:{ *:[i64] })
     /* 257922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 257925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257927 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 257929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257935 */     GIR_RootConstrainSelectedInstOperands,
     /* 257936 */     // GIR_Coverage, 6416,
     /* 257936 */     GIR_EraseRootFromParent_Done,
     /* 257937 */   // Label 5167: @257937
     /* 257937 */   GIM_Reject,
     /* 257938 */ // Label 5159: @257938
     /* 257938 */ GIM_Reject,
     /* 257939 */ // Label 5154: @257939
     /* 257939 */ GIM_Try, /*On fail goto*//*Label 5168*/ GIMT_Encode4(258580),
     /* 257944 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 257947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 257951 */   GIM_Try, /*On fail goto*//*Label 5169*/ GIMT_Encode4(258028), // Rule ID 5588 //
     /* 257956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 257960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 257964 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 257968 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 257972 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 257976 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 257980 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 257984 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257989 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 257993 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 257997 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 258001 */     // MIs[3] Operand 1
     /* 258001 */     // No operand predicates
     /* 258001 */     // MIs[0] Operand 2
     /* 258001 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 258012 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 258014 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /* 258014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
     /* 258017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 258023 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 258026 */     GIR_RootConstrainSelectedInstOperands,
     /* 258027 */     // GIR_Coverage, 5588,
     /* 258027 */     GIR_EraseRootFromParent_Done,
     /* 258028 */   // Label 5169: @258028
     /* 258028 */   GIM_Try, /*On fail goto*//*Label 5170*/ GIMT_Encode4(258105), // Rule ID 5589 //
     /* 258033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 258037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 258041 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 258045 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 258049 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 258053 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 258057 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 258061 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258066 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 258070 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 258074 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 258078 */     // MIs[3] Operand 1
     /* 258078 */     // No operand predicates
     /* 258078 */     // MIs[0] Operand 2
     /* 258078 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 258089 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 258091 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 258091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
     /* 258094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 258100 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 258103 */     GIR_RootConstrainSelectedInstOperands,
     /* 258104 */     // GIR_Coverage, 5589,
     /* 258104 */     GIR_EraseRootFromParent_Done,
     /* 258105 */   // Label 5170: @258105
     /* 258105 */   GIM_Try, /*On fail goto*//*Label 5171*/ GIMT_Encode4(258207), // Rule ID 11035 //
     /* 258110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 258113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 258117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 258121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 258125 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 258129 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 258133 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 258137 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 258141 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 258145 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 258149 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 258153 */     // MIs[3] Operand 1
     /* 258153 */     // No operand predicates
     /* 258153 */     // MIs[0] Operand 2
     /* 258153 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 258164 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 258166 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
     /* 258166 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 258169 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 258173 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258178 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 258184 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258189 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
     /* 258197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258199 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 258202 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // index
     /* 258205 */     GIR_RootConstrainSelectedInstOperands,
     /* 258206 */     // GIR_Coverage, 11035,
     /* 258206 */     GIR_EraseRootFromParent_Done,
     /* 258207 */   // Label 5171: @258207
     /* 258207 */   GIM_Try, /*On fail goto*//*Label 5172*/ GIMT_Encode4(258309), // Rule ID 11037 //
     /* 258212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 258215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 258219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 258223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 258227 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 258231 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 258235 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 258239 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 258243 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 258247 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 258251 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 258255 */     // MIs[3] Operand 1
     /* 258255 */     // No operand predicates
     /* 258255 */     // MIs[0] Operand 2
     /* 258255 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 258266 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 258268 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
     /* 258268 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 258271 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 258275 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258280 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 258286 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258291 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
     /* 258299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258301 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 258304 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // index
     /* 258307 */     GIR_RootConstrainSelectedInstOperands,
     /* 258308 */     // GIR_Coverage, 11037,
     /* 258308 */     GIR_EraseRootFromParent_Done,
     /* 258309 */   // Label 5172: @258309
     /* 258309 */   GIM_Try, /*On fail goto*//*Label 5173*/ GIMT_Encode4(258374), // Rule ID 5583 //
     /* 258314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 258318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 258322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 258326 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 258330 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258335 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 258339 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 258343 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 258347 */     // MIs[2] Operand 1
     /* 258347 */     // No operand predicates
     /* 258347 */     // MIs[0] Operand 2
     /* 258347 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 258358 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 258360 */     // (sext_inreg:{ *:[i64] } (vector_extract:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /* 258360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
     /* 258363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 258369 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 258372 */     GIR_RootConstrainSelectedInstOperands,
     /* 258373 */     // GIR_Coverage, 5583,
     /* 258373 */     GIR_EraseRootFromParent_Done,
     /* 258374 */   // Label 5173: @258374
     /* 258374 */   GIM_Try, /*On fail goto*//*Label 5174*/ GIMT_Encode4(258439), // Rule ID 5585 //
     /* 258379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 258383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 258387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 258391 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 258395 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258400 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 258404 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 258408 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 258412 */     // MIs[2] Operand 1
     /* 258412 */     // No operand predicates
     /* 258412 */     // MIs[0] Operand 2
     /* 258412 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 258423 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 258425 */     // (sext_inreg:{ *:[i64] } (vector_extract:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 258425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
     /* 258428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 258434 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 258437 */     GIR_RootConstrainSelectedInstOperands,
     /* 258438 */     // GIR_Coverage, 5585,
     /* 258438 */     GIR_EraseRootFromParent_Done,
     /* 258439 */   // Label 5174: @258439
     /* 258439 */   GIM_Try, /*On fail goto*//*Label 5175*/ GIMT_Encode4(258474), // Rule ID 6410 //
     /* 258444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 258448 */     // MIs[0] Operand 2
     /* 258448 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 258459 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i32:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 31:{ *:[i64] })
     /* 258459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 258462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258464 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 258466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 258469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 258472 */     GIR_RootConstrainSelectedInstOperands,
     /* 258473 */     // GIR_Coverage, 6410,
     /* 258473 */     GIR_EraseRootFromParent_Done,
     /* 258474 */   // Label 5175: @258474
     /* 258474 */   GIM_Try, /*On fail goto*//*Label 5176*/ GIMT_Encode4(258509), // Rule ID 6411 //
     /* 258479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 258483 */     // MIs[0] Operand 2
     /* 258483 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 258494 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i16:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 15:{ *:[i64] })
     /* 258494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 258497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258499 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 258501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 258504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 258507 */     GIR_RootConstrainSelectedInstOperands,
     /* 258508 */     // GIR_Coverage, 6411,
     /* 258508 */     GIR_EraseRootFromParent_Done,
     /* 258509 */   // Label 5176: @258509
     /* 258509 */   GIM_Try, /*On fail goto*//*Label 5177*/ GIMT_Encode4(258544), // Rule ID 6412 //
     /* 258514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 258518 */     // MIs[0] Operand 2
     /* 258518 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 258529 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i8:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 7:{ *:[i64] })
     /* 258529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 258532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258534 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 258536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 258539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 258542 */     GIR_RootConstrainSelectedInstOperands,
     /* 258543 */     // GIR_Coverage, 6412,
     /* 258543 */     GIR_EraseRootFromParent_Done,
     /* 258544 */   // Label 5177: @258544
     /* 258544 */   GIM_Try, /*On fail goto*//*Label 5178*/ GIMT_Encode4(258579), // Rule ID 6413 //
     /* 258549 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 258553 */     // MIs[0] Operand 2
     /* 258553 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 258564 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i1:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 0:{ *:[i64] })
     /* 258564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 258567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258569 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 258571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 258574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 258577 */     GIR_RootConstrainSelectedInstOperands,
     /* 258578 */     // GIR_Coverage, 6413,
     /* 258578 */     GIR_EraseRootFromParent_Done,
     /* 258579 */   // Label 5178: @258579
     /* 258579 */   GIM_Reject,
     /* 258580 */ // Label 5168: @258580
     /* 258580 */ GIM_Reject,
     /* 258581 */ // Label 5155: @258581
     /* 258581 */ GIM_Try, /*On fail goto*//*Label 5179*/ GIMT_Encode4(258789),
     /* 258586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 258589 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258593 */   GIM_Try, /*On fail goto*//*Label 5180*/ GIMT_Encode4(258658), // Rule ID 10346 //
     /* 258598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 258601 */     // MIs[0] Operand 2
     /* 258601 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 258612 */     // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i32:{ *:[Other] })  =>  (SXTW_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
     /* 258612 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 258615 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 258619 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258624 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 258627 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 258629 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 258632 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 258636 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258641 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 258643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTW_ZPmZ_D_UNDEF),
     /* 258646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 258648 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 258651 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 258654 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 258656 */     GIR_RootConstrainSelectedInstOperands,
     /* 258657 */     // GIR_Coverage, 10346,
     /* 258657 */     GIR_EraseRootFromParent_Done,
     /* 258658 */   // Label 5180: @258658
     /* 258658 */   GIM_Try, /*On fail goto*//*Label 5181*/ GIMT_Encode4(258723), // Rule ID 10347 //
     /* 258663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 258666 */     // MIs[0] Operand 2
     /* 258666 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 258677 */     // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i16:{ *:[Other] })  =>  (SXTH_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
     /* 258677 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 258680 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 258684 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258689 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 258692 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 258694 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 258697 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 258701 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258706 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 258708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTH_ZPmZ_D_UNDEF),
     /* 258711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 258713 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 258716 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 258719 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 258721 */     GIR_RootConstrainSelectedInstOperands,
     /* 258722 */     // GIR_Coverage, 10347,
     /* 258722 */     GIR_EraseRootFromParent_Done,
     /* 258723 */   // Label 5181: @258723
     /* 258723 */   GIM_Try, /*On fail goto*//*Label 5182*/ GIMT_Encode4(258788), // Rule ID 10348 //
     /* 258728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 258731 */     // MIs[0] Operand 2
     /* 258731 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 258742 */     // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i8:{ *:[Other] })  =>  (SXTB_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
     /* 258742 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 258745 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 258749 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258754 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 258757 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 258759 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 258762 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 258766 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258771 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 258773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_D_UNDEF),
     /* 258776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 258778 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 258781 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 258784 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 258786 */     GIR_RootConstrainSelectedInstOperands,
     /* 258787 */     // GIR_Coverage, 10348,
     /* 258787 */     GIR_EraseRootFromParent_Done,
     /* 258788 */   // Label 5182: @258788
     /* 258788 */   GIM_Reject,
     /* 258789 */ // Label 5179: @258789
     /* 258789 */ GIM_Reject,
     /* 258790 */ // Label 5156: @258790
     /* 258790 */ GIM_Try, /*On fail goto*//*Label 5183*/ GIMT_Encode4(258933),
     /* 258795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 258798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258802 */   GIM_Try, /*On fail goto*//*Label 5184*/ GIMT_Encode4(258867), // Rule ID 10349 //
     /* 258807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 258810 */     // MIs[0] Operand 2
     /* 258810 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 258821 */     // (sext_inreg:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, nxv4i16:{ *:[Other] })  =>  (SXTH_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv4i32] }:$Zs)
     /* 258821 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 258824 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 258828 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258833 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 258836 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 258838 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 258841 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 258845 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258850 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 258852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTH_ZPmZ_S_UNDEF),
     /* 258855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 258857 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 258860 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 258863 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 258865 */     GIR_RootConstrainSelectedInstOperands,
     /* 258866 */     // GIR_Coverage, 10349,
     /* 258866 */     GIR_EraseRootFromParent_Done,
     /* 258867 */   // Label 5184: @258867
     /* 258867 */   GIM_Try, /*On fail goto*//*Label 5185*/ GIMT_Encode4(258932), // Rule ID 10350 //
     /* 258872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 258875 */     // MIs[0] Operand 2
     /* 258875 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 258886 */     // (sext_inreg:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, nxv4i8:{ *:[Other] })  =>  (SXTB_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv4i32] }:$Zs)
     /* 258886 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 258889 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 258893 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258898 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 258901 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 258903 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 258906 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 258910 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258915 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 258917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_S_UNDEF),
     /* 258920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 258922 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 258925 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 258928 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 258930 */     GIR_RootConstrainSelectedInstOperands,
     /* 258931 */     // GIR_Coverage, 10350,
     /* 258931 */     GIR_EraseRootFromParent_Done,
     /* 258932 */   // Label 5185: @258932
     /* 258932 */   GIM_Reject,
     /* 258933 */ // Label 5183: @258933
     /* 258933 */ GIM_Reject,
     /* 258934 */ // Label 5157: @258934
     /* 258934 */ GIM_Try, /*On fail goto*//*Label 5186*/ GIMT_Encode4(259006), // Rule ID 10351 //
     /* 258939 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 258942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 258945 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258949 */   // MIs[0] Operand 2
     /* 258949 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 258960 */   // (sext_inreg:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Zs, nxv8i8:{ *:[Other] })  =>  (SXTB_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv8i16] }:$Zs)
     /* 258960 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 258963 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 258967 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258972 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 258975 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 258977 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 258980 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 258984 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258989 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 258991 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_H_UNDEF),
     /* 258994 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 258996 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 258999 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 259002 */   GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 259004 */   GIR_RootConstrainSelectedInstOperands,
     /* 259005 */   // GIR_Coverage, 10351,
     /* 259005 */   GIR_EraseRootFromParent_Done,
     /* 259006 */ // Label 5186: @259006
     /* 259006 */ GIM_Reject,
     /* 259007 */ // Label 5158: @259007
     /* 259007 */ GIM_Reject,
     /* 259008 */ // Label 40: @259008
     /* 259008 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5191*/ GIMT_Encode4(261786),
     /* 259019 */ /*GILLT_s32*//*Label 5187*/ GIMT_Encode4(259055), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 259035 */ /*GILLT_v2s64*//*Label 5188*/ GIMT_Encode4(260856), GIMT_Encode4(0),
     /* 259043 */ /*GILLT_v4s32*//*Label 5189*/ GIMT_Encode4(261166), GIMT_Encode4(0),
     /* 259051 */ /*GILLT_v8s16*//*Label 5190*/ GIMT_Encode4(261476),
     /* 259055 */ // Label 5187: @259055
     /* 259055 */ GIM_Try, /*On fail goto*//*Label 5192*/ GIMT_Encode4(259205), // Rule ID 12849 //
     /* 259060 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 259063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 259067 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 259071 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 259075 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 259078 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 259083 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 259087 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 259092 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 259094 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 727:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 259094 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 259097 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 259101 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259106 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 259110 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 259112 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 259115 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 259119 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259124 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 259126 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 259129 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 259133 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259138 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 259141 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 259144 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 259147 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259152 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259157 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 259162 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 259165 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 259169 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259174 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 259181 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 259186 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259191 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 259194 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 259196 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 259199 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 259204 */   // GIR_Coverage, 12849,
     /* 259204 */   GIR_EraseRootFromParent_Done,
     /* 259205 */ // Label 5192: @259205
     /* 259205 */ GIM_Try, /*On fail goto*//*Label 5193*/ GIMT_Encode4(259355), // Rule ID 12851 //
     /* 259210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 259213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 259217 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 259221 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 259225 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 259228 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 259233 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 259237 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259242 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 259244 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 727:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 259244 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 259247 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 259251 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259256 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 259260 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 259262 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 259265 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 259269 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259274 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 259276 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 259279 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 259283 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259288 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 259291 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 259294 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 259297 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259302 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259307 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 259312 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 259315 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 259319 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259324 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 259331 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 259336 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259341 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 259344 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 259346 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 259349 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 259354 */   // GIR_Coverage, 12851,
     /* 259354 */   GIR_EraseRootFromParent_Done,
     /* 259355 */ // Label 5193: @259355
     /* 259355 */ GIM_Try, /*On fail goto*//*Label 5194*/ GIMT_Encode4(259505), // Rule ID 12853 //
     /* 259360 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 259363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 259367 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 259371 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 259375 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 259378 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 259383 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 259387 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 259392 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 259394 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 727:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 259394 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 259397 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 259401 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259406 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 259410 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 259412 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 259415 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 259419 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259424 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 259426 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 259429 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 259433 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259438 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 259441 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 259444 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 259447 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259452 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259457 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 259462 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 259465 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 259469 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259474 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 259481 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 259486 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259491 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 259494 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 259496 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 259499 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 259504 */   // GIR_Coverage, 12853,
     /* 259504 */   GIR_EraseRootFromParent_Done,
     /* 259505 */ // Label 5194: @259505
     /* 259505 */ GIM_Try, /*On fail goto*//*Label 5195*/ GIMT_Encode4(259655), // Rule ID 12855 //
     /* 259510 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 259513 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 259517 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 259521 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 259525 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 259528 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 259533 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 259537 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259542 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 259544 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 727:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 259544 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 259547 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 259551 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259556 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 259560 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 259562 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 259565 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 259569 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259574 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 259576 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 259579 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 259583 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259588 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 259591 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 259594 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 259597 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259602 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259607 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 259612 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 259615 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 259619 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259624 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 259631 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 259636 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259641 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 259644 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 259646 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 259649 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 259654 */   // GIR_Coverage, 12855,
     /* 259654 */   GIR_EraseRootFromParent_Done,
     /* 259655 */ // Label 5195: @259655
     /* 259655 */ GIM_Try, /*On fail goto*//*Label 5196*/ GIMT_Encode4(259805), // Rule ID 12882 //
     /* 259660 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 259663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 259667 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 259671 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 259675 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 259678 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 259683 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 259687 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 259692 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 259694 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 733:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 259694 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 259697 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
     /* 259701 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259706 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 259710 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 259712 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 259715 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 259719 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259724 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 259726 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 259729 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 259733 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259738 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 259741 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 259744 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 259747 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259752 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259757 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 259762 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 259765 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 259769 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259774 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 259781 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 259786 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259791 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 259794 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 259796 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 259799 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 259804 */   // GIR_Coverage, 12882,
     /* 259804 */   GIR_EraseRootFromParent_Done,
     /* 259805 */ // Label 5196: @259805
     /* 259805 */ GIM_Try, /*On fail goto*//*Label 5197*/ GIMT_Encode4(259955), // Rule ID 12884 //
     /* 259810 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 259813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 259817 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 259821 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 259825 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 259828 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 259833 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 259837 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259842 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 259844 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 733:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 259844 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 259847 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
     /* 259851 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259856 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 259860 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 259862 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 259865 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 259869 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259874 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 259876 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 259879 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 259883 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259888 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 259891 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 259894 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 259897 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259902 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259907 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 259912 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 259915 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 259919 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259924 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 259931 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 259936 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259941 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 259944 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 259946 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 259949 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 259954 */   // GIR_Coverage, 12884,
     /* 259954 */   GIR_EraseRootFromParent_Done,
     /* 259955 */ // Label 5197: @259955
     /* 259955 */ GIM_Try, /*On fail goto*//*Label 5198*/ GIMT_Encode4(260105), // Rule ID 12886 //
     /* 259960 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 259963 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 259967 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 259971 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 259975 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 259978 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 259983 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 259987 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 259992 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 259994 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 733:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 259994 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 259997 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
     /* 260001 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260006 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 260010 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 260012 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 260015 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 260019 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260024 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 260026 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 260029 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 260033 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260038 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 260041 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 260044 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 260047 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260052 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260057 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 260062 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 260065 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 260069 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260074 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 260081 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 260086 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260091 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 260094 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 260096 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 260099 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 260104 */   // GIR_Coverage, 12886,
     /* 260104 */   GIR_EraseRootFromParent_Done,
     /* 260105 */ // Label 5198: @260105
     /* 260105 */ GIM_Try, /*On fail goto*//*Label 5199*/ GIMT_Encode4(260255), // Rule ID 12888 //
     /* 260110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 260113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 260117 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 260121 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 260125 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 260128 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 260133 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 260137 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260142 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 260144 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 733:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 260144 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 260147 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
     /* 260151 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260156 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 260160 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 260162 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 260165 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 260169 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260174 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 260176 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 260179 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 260183 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260188 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 260191 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 260194 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 260197 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260202 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260207 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 260212 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 260215 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 260219 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260224 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 260231 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 260236 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260241 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 260244 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 260246 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 260249 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 260254 */   // GIR_Coverage, 12888,
     /* 260254 */   GIR_EraseRootFromParent_Done,
     /* 260255 */ // Label 5199: @260255
     /* 260255 */ GIM_Try, /*On fail goto*//*Label 5200*/ GIMT_Encode4(260405), // Rule ID 12892 //
     /* 260260 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 260263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 260267 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 260271 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 260275 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 260278 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 260283 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 260287 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 260292 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 260294 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 736:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 260294 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 260297 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
     /* 260301 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260306 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 260310 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 260312 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 260315 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 260319 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260324 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 260326 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 260329 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 260333 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260338 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 260341 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 260344 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 260347 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260352 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260357 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 260362 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 260365 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 260369 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260374 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 260381 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 260386 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260391 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 260394 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 260396 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 260399 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 260404 */   // GIR_Coverage, 12892,
     /* 260404 */   GIR_EraseRootFromParent_Done,
     /* 260405 */ // Label 5200: @260405
     /* 260405 */ GIM_Try, /*On fail goto*//*Label 5201*/ GIMT_Encode4(260555), // Rule ID 12894 //
     /* 260410 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 260413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 260417 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 260421 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 260425 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 260428 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 260433 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 260437 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260442 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 260444 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 736:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 260444 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 260447 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
     /* 260451 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260456 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 260460 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 260462 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 260465 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 260469 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260474 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 260476 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 260479 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 260483 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260488 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 260491 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 260494 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 260497 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260502 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260507 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 260512 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 260515 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 260519 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260524 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 260531 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 260536 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260541 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 260544 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 260546 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 260549 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 260554 */   // GIR_Coverage, 12894,
     /* 260554 */   GIR_EraseRootFromParent_Done,
     /* 260555 */ // Label 5201: @260555
     /* 260555 */ GIM_Try, /*On fail goto*//*Label 5202*/ GIMT_Encode4(260705), // Rule ID 12896 //
     /* 260560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 260563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 260567 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 260571 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 260575 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 260578 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 260583 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 260587 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 260592 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 260594 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 736:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 260594 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 260597 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
     /* 260601 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260606 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 260610 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 260612 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 260615 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 260619 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260624 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 260626 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 260629 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 260633 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260638 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 260641 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 260644 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 260647 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260652 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260657 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 260662 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 260665 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 260669 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260674 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 260681 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 260686 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260691 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 260694 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 260696 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 260699 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 260704 */   // GIR_Coverage, 12896,
     /* 260704 */   GIR_EraseRootFromParent_Done,
     /* 260705 */ // Label 5202: @260705
     /* 260705 */ GIM_Try, /*On fail goto*//*Label 5203*/ GIMT_Encode4(260855), // Rule ID 12898 //
     /* 260710 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 260713 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 260717 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 260721 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 260725 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 260728 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 260733 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 260737 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260742 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 260744 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 736:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 260744 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 260747 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
     /* 260751 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260756 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 260760 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 260762 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 260765 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 260769 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260774 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 260776 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 260779 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 260783 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260788 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 260791 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 260794 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 260797 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260802 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260807 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 260812 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 260815 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 260819 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260824 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 260831 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 260836 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260841 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 260844 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 260846 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 260849 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 260854 */   // GIR_Coverage, 12898,
     /* 260854 */   GIR_EraseRootFromParent_Done,
     /* 260855 */ // Label 5203: @260855
     /* 260855 */ GIM_Reject,
     /* 260856 */ // Label 5188: @260856
     /* 260856 */ GIM_Try, /*On fail goto*//*Label 5204*/ GIMT_Encode4(261165),
     /* 260861 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 260864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260868 */   GIM_Try, /*On fail goto*//*Label 5205*/ GIMT_Encode4(260933), // Rule ID 702 //
     /* 260873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 260876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 260880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 260884 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 260887 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 260892 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 260896 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 260900 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 260902 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 260909 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 260916 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 260916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i32_v2i64),
     /* 260919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 260926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 260931 */     GIR_RootConstrainSelectedInstOperands,
     /* 260932 */     // GIR_Coverage, 702,
     /* 260932 */     GIR_EraseRootFromParent_Done,
     /* 260933 */   // Label 5205: @260933
     /* 260933 */   GIM_Try, /*On fail goto*//*Label 5206*/ GIMT_Encode4(260998), // Rule ID 1704 //
     /* 260938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 260941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 260945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 260949 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 260952 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 260957 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 260961 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 260965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 260967 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 260974 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 260981 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 260981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv4i32_v2i64),
     /* 260984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 260991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 260996 */     GIR_RootConstrainSelectedInstOperands,
     /* 260997 */     // GIR_Coverage, 1704,
     /* 260997 */     GIR_EraseRootFromParent_Done,
     /* 260998 */   // Label 5206: @260998
     /* 260998 */   GIM_Try, /*On fail goto*//*Label 5207*/ GIMT_Encode4(261057), // Rule ID 700 //
     /* 261003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 261006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 261014 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 261017 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 261022 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 261026 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 261030 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261035 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261040 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 261042 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 261042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv2i32_v2i64),
     /* 261045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 261051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 261055 */     GIR_RootConstrainSelectedInstOperands,
     /* 261056 */     // GIR_Coverage, 700,
     /* 261056 */     GIR_EraseRootFromParent_Done,
     /* 261057 */   // Label 5207: @261057
     /* 261057 */   GIM_Try, /*On fail goto*//*Label 5208*/ GIMT_Encode4(261116), // Rule ID 1702 //
     /* 261062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 261065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 261073 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 261076 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 261081 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 261085 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 261089 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261094 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 261101 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 261101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv2i32_v2i64),
     /* 261104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 261110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 261114 */     GIR_RootConstrainSelectedInstOperands,
     /* 261115 */     // GIR_Coverage, 1702,
     /* 261115 */     GIR_EraseRootFromParent_Done,
     /* 261116 */   // Label 5208: @261116
     /* 261116 */   GIM_Try, /*On fail goto*//*Label 5209*/ GIMT_Encode4(261143), // Rule ID 6280 //
     /* 261121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 261128 */     // (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (USHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
     /* 261128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i32_shift),
     /* 261131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 261138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 261141 */     GIR_RootConstrainSelectedInstOperands,
     /* 261142 */     // GIR_Coverage, 6280,
     /* 261142 */     GIR_EraseRootFromParent_Done,
     /* 261143 */   // Label 5209: @261143
     /* 261143 */   GIM_Try, /*On fail goto*//*Label 5210*/ GIMT_Encode4(261164), // Rule ID 6271 //
     /* 261148 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261152 */     // (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
     /* 261152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 261155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261157 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 261159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 261162 */     GIR_RootConstrainSelectedInstOperands,
     /* 261163 */     // GIR_Coverage, 6271,
     /* 261163 */     GIR_EraseRootFromParent_Done,
     /* 261164 */   // Label 5210: @261164
     /* 261164 */   GIM_Reject,
     /* 261165 */ // Label 5204: @261165
     /* 261165 */ GIM_Reject,
     /* 261166 */ // Label 5189: @261166
     /* 261166 */ GIM_Try, /*On fail goto*//*Label 5211*/ GIMT_Encode4(261475),
     /* 261171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 261174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261178 */   GIM_Try, /*On fail goto*//*Label 5212*/ GIMT_Encode4(261243), // Rule ID 698 //
     /* 261183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 261186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 261194 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 261197 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 261202 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 261206 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 261210 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 261212 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 261219 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 261226 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 261226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i16_v4i32),
     /* 261229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 261236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 261241 */     GIR_RootConstrainSelectedInstOperands,
     /* 261242 */     // GIR_Coverage, 698,
     /* 261242 */     GIR_EraseRootFromParent_Done,
     /* 261243 */   // Label 5212: @261243
     /* 261243 */   GIM_Try, /*On fail goto*//*Label 5213*/ GIMT_Encode4(261308), // Rule ID 1700 //
     /* 261248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 261251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 261259 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 261262 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 261267 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 261271 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 261275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 261277 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 261284 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 261291 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 261291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv8i16_v4i32),
     /* 261294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 261301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 261306 */     GIR_RootConstrainSelectedInstOperands,
     /* 261307 */     // GIR_Coverage, 1700,
     /* 261307 */     GIR_EraseRootFromParent_Done,
     /* 261308 */   // Label 5213: @261308
     /* 261308 */   GIM_Try, /*On fail goto*//*Label 5214*/ GIMT_Encode4(261367), // Rule ID 696 //
     /* 261313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 261316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 261324 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 261327 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 261332 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 261336 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 261340 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261345 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261350 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 261352 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 261352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i16_v4i32),
     /* 261355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 261361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 261365 */     GIR_RootConstrainSelectedInstOperands,
     /* 261366 */     // GIR_Coverage, 696,
     /* 261366 */     GIR_EraseRootFromParent_Done,
     /* 261367 */   // Label 5214: @261367
     /* 261367 */   GIM_Try, /*On fail goto*//*Label 5215*/ GIMT_Encode4(261426), // Rule ID 1698 //
     /* 261372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 261375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 261383 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 261386 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 261391 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 261395 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 261399 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261404 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261409 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 261411 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 261411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv4i16_v4i32),
     /* 261414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 261420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 261424 */     GIR_RootConstrainSelectedInstOperands,
     /* 261425 */     // GIR_Coverage, 1698,
     /* 261425 */     GIR_EraseRootFromParent_Done,
     /* 261426 */   // Label 5215: @261426
     /* 261426 */   GIM_Try, /*On fail goto*//*Label 5216*/ GIMT_Encode4(261453), // Rule ID 6277 //
     /* 261431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 261438 */     // (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (USHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
     /* 261438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i16_shift),
     /* 261441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 261448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 261451 */     GIR_RootConstrainSelectedInstOperands,
     /* 261452 */     // GIR_Coverage, 6277,
     /* 261452 */     GIR_EraseRootFromParent_Done,
     /* 261453 */   // Label 5216: @261453
     /* 261453 */   GIM_Try, /*On fail goto*//*Label 5217*/ GIMT_Encode4(261474), // Rule ID 6268 //
     /* 261458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261462 */     // (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
     /* 261462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
     /* 261465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261467 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 261469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 261472 */     GIR_RootConstrainSelectedInstOperands,
     /* 261473 */     // GIR_Coverage, 6268,
     /* 261473 */     GIR_EraseRootFromParent_Done,
     /* 261474 */   // Label 5217: @261474
     /* 261474 */   GIM_Reject,
     /* 261475 */ // Label 5211: @261475
     /* 261475 */ GIM_Reject,
     /* 261476 */ // Label 5190: @261476
     /* 261476 */ GIM_Try, /*On fail goto*//*Label 5218*/ GIMT_Encode4(261785),
     /* 261481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 261484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261488 */   GIM_Try, /*On fail goto*//*Label 5219*/ GIMT_Encode4(261553), // Rule ID 694 //
     /* 261493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 261496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 261504 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 261507 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 261512 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 261516 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 261520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 261522 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 261529 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 261536 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 261536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv16i8_v8i16),
     /* 261539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 261546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 261551 */     GIR_RootConstrainSelectedInstOperands,
     /* 261552 */     // GIR_Coverage, 694,
     /* 261552 */     GIR_EraseRootFromParent_Done,
     /* 261553 */   // Label 5219: @261553
     /* 261553 */   GIM_Try, /*On fail goto*//*Label 5220*/ GIMT_Encode4(261618), // Rule ID 1696 //
     /* 261558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 261561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 261569 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 261572 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 261577 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 261581 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 261585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 261587 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 261594 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 261601 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 261601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv16i8_v8i16),
     /* 261604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 261611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 261616 */     GIR_RootConstrainSelectedInstOperands,
     /* 261617 */     // GIR_Coverage, 1696,
     /* 261617 */     GIR_EraseRootFromParent_Done,
     /* 261618 */   // Label 5220: @261618
     /* 261618 */   GIM_Try, /*On fail goto*//*Label 5221*/ GIMT_Encode4(261677), // Rule ID 692 //
     /* 261623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 261626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 261634 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 261637 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 261642 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 261646 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 261650 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261655 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261660 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 261662 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 261662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i8_v8i16),
     /* 261665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 261671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 261675 */     GIR_RootConstrainSelectedInstOperands,
     /* 261676 */     // GIR_Coverage, 692,
     /* 261676 */     GIR_EraseRootFromParent_Done,
     /* 261677 */   // Label 5221: @261677
     /* 261677 */   GIM_Try, /*On fail goto*//*Label 5222*/ GIMT_Encode4(261736), // Rule ID 1694 //
     /* 261682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 261685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 261693 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 261696 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 261701 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 261705 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 261709 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261714 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 261721 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 261721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv8i8_v8i16),
     /* 261724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 261730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 261734 */     GIR_RootConstrainSelectedInstOperands,
     /* 261735 */     // GIR_Coverage, 1694,
     /* 261735 */     GIR_EraseRootFromParent_Done,
     /* 261736 */   // Label 5222: @261736
     /* 261736 */   GIM_Try, /*On fail goto*//*Label 5223*/ GIMT_Encode4(261763), // Rule ID 6274 //
     /* 261741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 261748 */     // (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (USHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
     /* 261748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv16i8_shift),
     /* 261751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 261758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 261761 */     GIR_RootConstrainSelectedInstOperands,
     /* 261762 */     // GIR_Coverage, 6274,
     /* 261762 */     GIR_EraseRootFromParent_Done,
     /* 261763 */   // Label 5223: @261763
     /* 261763 */   GIM_Try, /*On fail goto*//*Label 5224*/ GIMT_Encode4(261784), // Rule ID 6265 //
     /* 261768 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261772 */     // (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
     /* 261772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
     /* 261775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261777 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 261779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 261782 */     GIR_RootConstrainSelectedInstOperands,
     /* 261783 */     // GIR_Coverage, 6265,
     /* 261783 */     GIR_EraseRootFromParent_Done,
     /* 261784 */   // Label 5224: @261784
     /* 261784 */   GIM_Reject,
     /* 261785 */ // Label 5218: @261785
     /* 261785 */ GIM_Reject,
     /* 261786 */ // Label 5191: @261786
     /* 261786 */ GIM_Reject,
     /* 261787 */ // Label 41: @261787
     /* 261787 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5230*/ GIMT_Encode4(262566),
     /* 261798 */ /*GILLT_s32*//*Label 5225*/ GIMT_Encode4(261834),
     /* 261802 */ /*GILLT_s64*//*Label 5226*/ GIMT_Encode4(261966), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 261814 */ /*GILLT_v2s64*//*Label 5227*/ GIMT_Encode4(262139), GIMT_Encode4(0),
     /* 261822 */ /*GILLT_v4s32*//*Label 5228*/ GIMT_Encode4(262284), GIMT_Encode4(0),
     /* 261830 */ /*GILLT_v8s16*//*Label 5229*/ GIMT_Encode4(262425),
     /* 261834 */ // Label 5225: @261834
     /* 261834 */ GIM_Try, /*On fail goto*//*Label 5231*/ GIMT_Encode4(261965),
     /* 261839 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 261842 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 261845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 261849 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 261853 */   GIM_Try, /*On fail goto*//*Label 5232*/ GIMT_Encode4(261890), // Rule ID 3877 //
     /* 261858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 261862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 261866 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 261870 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 261875 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 261877 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 261877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 261880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261882 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 261884 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 261888 */     GIR_RootConstrainSelectedInstOperands,
     /* 261889 */     // GIR_Coverage, 3877,
     /* 261889 */     GIR_EraseRootFromParent_Done,
     /* 261890 */   // Label 5232: @261890
     /* 261890 */   GIM_Try, /*On fail goto*//*Label 5233*/ GIMT_Encode4(261927), // Rule ID 3878 //
     /* 261895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 261899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 261903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 261907 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 261912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 261914 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 261914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 261917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261919 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 261921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 261925 */     GIR_RootConstrainSelectedInstOperands,
     /* 261926 */     // GIR_Coverage, 3878,
     /* 261926 */     GIR_EraseRootFromParent_Done,
     /* 261927 */   // Label 5233: @261927
     /* 261927 */   GIM_Try, /*On fail goto*//*Label 5234*/ GIMT_Encode4(261964), // Rule ID 3876 //
     /* 261932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 261936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 261940 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 261944 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 261949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 261951 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 261951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 261954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261956 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 261958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 261962 */     GIR_RootConstrainSelectedInstOperands,
     /* 261963 */     // GIR_Coverage, 3876,
     /* 261963 */     GIR_EraseRootFromParent_Done,
     /* 261964 */   // Label 5234: @261964
     /* 261964 */   GIM_Reject,
     /* 261965 */ // Label 5231: @261965
     /* 261965 */ GIM_Reject,
     /* 261966 */ // Label 5226: @261966
     /* 261966 */ GIM_Try, /*On fail goto*//*Label 5235*/ GIMT_Encode4(262138),
     /* 261971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 261974 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 261977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 261981 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 261985 */   GIM_Try, /*On fail goto*//*Label 5236*/ GIMT_Encode4(262053), // Rule ID 3879 //
     /* 261990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 261994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 261998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 262002 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 262009 */     // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 262009 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 262012 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 262016 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262021 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 262024 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 262028 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 262031 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 262036 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
     /* 262044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262046 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 262048 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 262051 */     GIR_RootConstrainSelectedInstOperands,
     /* 262052 */     // GIR_Coverage, 3879,
     /* 262052 */     GIR_EraseRootFromParent_Done,
     /* 262053 */   // Label 5236: @262053
     /* 262053 */   GIM_Try, /*On fail goto*//*Label 5237*/ GIMT_Encode4(262121), // Rule ID 3880 //
     /* 262058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 262062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 262066 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 262070 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 262077 */     // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 262077 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 262080 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 262084 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262089 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 262092 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 262096 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 262099 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 262104 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
     /* 262112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262114 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 262116 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 262119 */     GIR_RootConstrainSelectedInstOperands,
     /* 262120 */     // GIR_Coverage, 3880,
     /* 262120 */     GIR_EraseRootFromParent_Done,
     /* 262121 */   // Label 5237: @262121
     /* 262121 */   GIM_Try, /*On fail goto*//*Label 5238*/ GIMT_Encode4(262137), // Rule ID 120 //
     /* 262126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 262130 */     // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 262130 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
     /* 262135 */     GIR_RootConstrainSelectedInstOperands,
     /* 262136 */     // GIR_Coverage, 120,
     /* 262136 */     GIR_Done,
     /* 262137 */   // Label 5238: @262137
     /* 262137 */   GIM_Reject,
     /* 262138 */ // Label 5235: @262138
     /* 262138 */ GIM_Reject,
     /* 262139 */ // Label 5227: @262139
     /* 262139 */ GIM_Try, /*On fail goto*//*Label 5239*/ GIMT_Encode4(262283),
     /* 262144 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 262147 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 262150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262154 */   GIM_Try, /*On fail goto*//*Label 5240*/ GIMT_Encode4(262218), // Rule ID 6263 //
     /* 262159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 262167 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 262171 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 262176 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 262180 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 262184 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 262188 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 262192 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 262196 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 262200 */     // MIs[3] Operand 1
     /* 262200 */     // No operand predicates
     /* 262200 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 262202 */     // (shl:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), (AArch64dup:{ *:[v2i64] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))  =>  (SSHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))
     /* 262202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 262205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 262211 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // size
     /* 262216 */     GIR_RootConstrainSelectedInstOperands,
     /* 262217 */     // GIR_Coverage, 6263,
     /* 262217 */     GIR_EraseRootFromParent_Done,
     /* 262218 */   // Label 5240: @262218
     /* 262218 */   GIM_Try, /*On fail goto*//*Label 5241*/ GIMT_Encode4(262282), // Rule ID 6260 //
     /* 262223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 262231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 262235 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 262240 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 262244 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 262248 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 262252 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 262256 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 262260 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 262264 */     // MIs[3] Operand 1
     /* 262264 */     // No operand predicates
     /* 262264 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 262266 */     // (shl:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), (AArch64dup:{ *:[v2i64] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))
     /* 262266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 262269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 262275 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // size
     /* 262280 */     GIR_RootConstrainSelectedInstOperands,
     /* 262281 */     // GIR_Coverage, 6260,
     /* 262281 */     GIR_EraseRootFromParent_Done,
     /* 262282 */   // Label 5241: @262282
     /* 262282 */   GIM_Reject,
     /* 262283 */ // Label 5239: @262283
     /* 262283 */ GIM_Reject,
     /* 262284 */ // Label 5228: @262284
     /* 262284 */ GIM_Try, /*On fail goto*//*Label 5242*/ GIMT_Encode4(262424),
     /* 262289 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 262292 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 262295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262299 */   GIM_Try, /*On fail goto*//*Label 5243*/ GIMT_Encode4(262361), // Rule ID 6262 //
     /* 262304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 262312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 262316 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 262321 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 262325 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 262329 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 262333 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 262337 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 262341 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 262345 */     // MIs[3] Operand 1
     /* 262345 */     // No operand predicates
     /* 262345 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 262347 */     // (shl:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), (AArch64dup:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size))  =>  (SSHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size)
     /* 262347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 262350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 262356 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 262359 */     GIR_RootConstrainSelectedInstOperands,
     /* 262360 */     // GIR_Coverage, 6262,
     /* 262360 */     GIR_EraseRootFromParent_Done,
     /* 262361 */   // Label 5243: @262361
     /* 262361 */   GIM_Try, /*On fail goto*//*Label 5244*/ GIMT_Encode4(262423), // Rule ID 6259 //
     /* 262366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 262374 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 262378 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 262383 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 262387 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 262391 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 262395 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 262399 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 262403 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 262407 */     // MIs[3] Operand 1
     /* 262407 */     // No operand predicates
     /* 262407 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 262409 */     // (shl:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), (AArch64dup:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size))  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size)
     /* 262409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
     /* 262412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 262418 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 262421 */     GIR_RootConstrainSelectedInstOperands,
     /* 262422 */     // GIR_Coverage, 6259,
     /* 262422 */     GIR_EraseRootFromParent_Done,
     /* 262423 */   // Label 5244: @262423
     /* 262423 */   GIM_Reject,
     /* 262424 */ // Label 5242: @262424
     /* 262424 */ GIM_Reject,
     /* 262425 */ // Label 5229: @262425
     /* 262425 */ GIM_Try, /*On fail goto*//*Label 5245*/ GIMT_Encode4(262565),
     /* 262430 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 262433 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 262436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262440 */   GIM_Try, /*On fail goto*//*Label 5246*/ GIMT_Encode4(262502), // Rule ID 6261 //
     /* 262445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 262453 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 262457 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 262462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 262466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 262470 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 262474 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 262478 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 262482 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_7),
     /* 262486 */     // MIs[3] Operand 1
     /* 262486 */     // No operand predicates
     /* 262486 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 262488 */     // (shl:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), (AArch64dup:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size))  =>  (SSHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size)
     /* 262488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 262491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 262497 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 262500 */     GIR_RootConstrainSelectedInstOperands,
     /* 262501 */     // GIR_Coverage, 6261,
     /* 262501 */     GIR_EraseRootFromParent_Done,
     /* 262502 */   // Label 5246: @262502
     /* 262502 */   GIM_Try, /*On fail goto*//*Label 5247*/ GIMT_Encode4(262564), // Rule ID 6258 //
     /* 262507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 262515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 262519 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 262524 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 262528 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 262532 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 262536 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 262540 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 262544 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_7),
     /* 262548 */     // MIs[3] Operand 1
     /* 262548 */     // No operand predicates
     /* 262548 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 262550 */     // (shl:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), (AArch64dup:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size))  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size)
     /* 262550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
     /* 262553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 262559 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 262562 */     GIR_RootConstrainSelectedInstOperands,
     /* 262563 */     // GIR_Coverage, 6258,
     /* 262563 */     GIR_EraseRootFromParent_Done,
     /* 262564 */   // Label 5247: @262564
     /* 262564 */   GIM_Reject,
     /* 262565 */ // Label 5245: @262565
     /* 262565 */ GIM_Reject,
     /* 262566 */ // Label 5230: @262566
     /* 262566 */ GIM_Reject,
     /* 262567 */ // Label 42: @262567
     /* 262567 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5250*/ GIMT_Encode4(262959),
     /* 262578 */ /*GILLT_s32*//*Label 5248*/ GIMT_Encode4(262586),
     /* 262582 */ /*GILLT_s64*//*Label 5249*/ GIMT_Encode4(262752),
     /* 262586 */ // Label 5248: @262586
     /* 262586 */ GIM_Try, /*On fail goto*//*Label 5251*/ GIMT_Encode4(262751),
     /* 262591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 262594 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 262597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262601 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262605 */   GIM_Try, /*On fail goto*//*Label 5252*/ GIMT_Encode4(262639), // Rule ID 3966 //
     /* 262610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 262614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 262618 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 262622 */     // MIs[1] Operand 1
     /* 262622 */     // No operand predicates
     /* 262622 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 262624 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (UBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
     /* 262624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UBFMWri),
     /* 262627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262629 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 262631 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 262634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 262637 */     GIR_RootConstrainSelectedInstOperands,
     /* 262638 */     // GIR_Coverage, 3966,
     /* 262638 */     GIR_EraseRootFromParent_Done,
     /* 262639 */   // Label 5252: @262639
     /* 262639 */   GIM_Try, /*On fail goto*//*Label 5253*/ GIMT_Encode4(262676), // Rule ID 3883 //
     /* 262644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 262648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 262652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 262656 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 262663 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 262663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 262666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262668 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 262670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 262674 */     GIR_RootConstrainSelectedInstOperands,
     /* 262675 */     // GIR_Coverage, 3883,
     /* 262675 */     GIR_EraseRootFromParent_Done,
     /* 262676 */   // Label 5253: @262676
     /* 262676 */   GIM_Try, /*On fail goto*//*Label 5254*/ GIMT_Encode4(262713), // Rule ID 3884 //
     /* 262681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 262685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 262689 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 262693 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262698 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 262700 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 262700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 262703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262705 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 262707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 262711 */     GIR_RootConstrainSelectedInstOperands,
     /* 262712 */     // GIR_Coverage, 3884,
     /* 262712 */     GIR_EraseRootFromParent_Done,
     /* 262713 */   // Label 5254: @262713
     /* 262713 */   GIM_Try, /*On fail goto*//*Label 5255*/ GIMT_Encode4(262750), // Rule ID 3882 //
     /* 262718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 262722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 262726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 262730 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 262737 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 262737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 262740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262742 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 262744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 262748 */     GIR_RootConstrainSelectedInstOperands,
     /* 262749 */     // GIR_Coverage, 3882,
     /* 262749 */     GIR_EraseRootFromParent_Done,
     /* 262750 */   // Label 5255: @262750
     /* 262750 */   GIM_Reject,
     /* 262751 */ // Label 5251: @262751
     /* 262751 */ GIM_Reject,
     /* 262752 */ // Label 5249: @262752
     /* 262752 */ GIM_Try, /*On fail goto*//*Label 5256*/ GIMT_Encode4(262958),
     /* 262757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 262760 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 262763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 262767 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 262771 */   GIM_Try, /*On fail goto*//*Label 5257*/ GIMT_Encode4(262805), // Rule ID 3967 //
     /* 262776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 262780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 262784 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 262788 */     // MIs[1] Operand 1
     /* 262788 */     // No operand predicates
     /* 262788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 262790 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (UBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm, 63:{ *:[i64] })
     /* 262790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UBFMXri),
     /* 262793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262795 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 262797 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 262800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 262803 */     GIR_RootConstrainSelectedInstOperands,
     /* 262804 */     // GIR_Coverage, 3967,
     /* 262804 */     GIR_EraseRootFromParent_Done,
     /* 262805 */   // Label 5257: @262805
     /* 262805 */   GIM_Try, /*On fail goto*//*Label 5258*/ GIMT_Encode4(262873), // Rule ID 3885 //
     /* 262810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 262814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 262818 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 262822 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 262829 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 262829 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 262832 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 262836 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262841 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 262844 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 262848 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 262851 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 262856 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
     /* 262864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262866 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 262868 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 262871 */     GIR_RootConstrainSelectedInstOperands,
     /* 262872 */     // GIR_Coverage, 3885,
     /* 262872 */     GIR_EraseRootFromParent_Done,
     /* 262873 */   // Label 5258: @262873
     /* 262873 */   GIM_Try, /*On fail goto*//*Label 5259*/ GIMT_Encode4(262941), // Rule ID 3886 //
     /* 262878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 262882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 262886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 262890 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 262897 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 262897 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 262900 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 262904 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262909 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 262912 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 262916 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 262919 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 262924 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
     /* 262932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262934 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 262936 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 262939 */     GIR_RootConstrainSelectedInstOperands,
     /* 262940 */     // GIR_Coverage, 3886,
     /* 262940 */     GIR_EraseRootFromParent_Done,
     /* 262941 */   // Label 5259: @262941
     /* 262941 */   GIM_Try, /*On fail goto*//*Label 5260*/ GIMT_Encode4(262957), // Rule ID 121 //
     /* 262946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 262950 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 262950 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
     /* 262955 */     GIR_RootConstrainSelectedInstOperands,
     /* 262956 */     // GIR_Coverage, 121,
     /* 262956 */     GIR_Done,
     /* 262957 */   // Label 5260: @262957
     /* 262957 */   GIM_Reject,
     /* 262958 */ // Label 5256: @262958
     /* 262958 */ GIM_Reject,
     /* 262959 */ // Label 5250: @262959
     /* 262959 */ GIM_Reject,
     /* 262960 */ // Label 43: @262960
     /* 262960 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5263*/ GIMT_Encode4(263735),
     /* 262971 */ /*GILLT_s32*//*Label 5261*/ GIMT_Encode4(262979),
     /* 262975 */ /*GILLT_s64*//*Label 5262*/ GIMT_Encode4(263285),
     /* 262979 */ // Label 5261: @262979
     /* 262979 */ GIM_Try, /*On fail goto*//*Label 5264*/ GIMT_Encode4(263284),
     /* 262984 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 262987 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 262990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262994 */   GIM_Try, /*On fail goto*//*Label 5265*/ GIMT_Encode4(263058), // Rule ID 6423 //
     /* 262999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 263007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 263011 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263016 */     // MIs[1] Operand 2
     /* 263016 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 263027 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 263031 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 263035 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /* 263039 */     // MIs[2] Operand 1
     /* 263039 */     // No operand predicates
     /* 263039 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 263041 */     // (sra:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i8:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm, 7:{ *:[i64] })
     /* 263041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 263044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 263050 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 263053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 263056 */     GIR_RootConstrainSelectedInstOperands,
     /* 263057 */     // GIR_Coverage, 6423,
     /* 263057 */     GIR_EraseRootFromParent_Done,
     /* 263058 */   // Label 5265: @263058
     /* 263058 */   GIM_Try, /*On fail goto*//*Label 5266*/ GIMT_Encode4(263122), // Rule ID 6425 //
     /* 263063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 263071 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 263075 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263080 */     // MIs[1] Operand 2
     /* 263080 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 263091 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 263095 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 263099 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /* 263103 */     // MIs[2] Operand 1
     /* 263103 */     // No operand predicates
     /* 263103 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 263105 */     // (sra:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm, 15:{ *:[i64] })
     /* 263105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 263108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 263114 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 263117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 263120 */     GIR_RootConstrainSelectedInstOperands,
     /* 263121 */     // GIR_Coverage, 6425,
     /* 263121 */     GIR_EraseRootFromParent_Done,
     /* 263122 */   // Label 5266: @263122
     /* 263122 */   GIM_Try, /*On fail goto*//*Label 5267*/ GIMT_Encode4(263160), // Rule ID 3964 //
     /* 263127 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 263135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 263139 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 263143 */     // MIs[1] Operand 1
     /* 263143 */     // No operand predicates
     /* 263143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263145 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
     /* 263145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 263148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263150 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 263152 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 263155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 263158 */     GIR_RootConstrainSelectedInstOperands,
     /* 263159 */     // GIR_Coverage, 3964,
     /* 263159 */     GIR_EraseRootFromParent_Done,
     /* 263160 */   // Label 5267: @263160
     /* 263160 */   GIM_Try, /*On fail goto*//*Label 5268*/ GIMT_Encode4(263201), // Rule ID 2426 //
     /* 263165 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 263173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 263177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 263181 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263188 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 263188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 263191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263193 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 263195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 263199 */     GIR_RootConstrainSelectedInstOperands,
     /* 263200 */     // GIR_Coverage, 2426,
     /* 263200 */     GIR_EraseRootFromParent_Done,
     /* 263201 */   // Label 5268: @263201
     /* 263201 */   GIM_Try, /*On fail goto*//*Label 5269*/ GIMT_Encode4(263242), // Rule ID 2427 //
     /* 263206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 263214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 263218 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 263222 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263227 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263229 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 263229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 263232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263234 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 263236 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 263240 */     GIR_RootConstrainSelectedInstOperands,
     /* 263241 */     // GIR_Coverage, 2427,
     /* 263241 */     GIR_EraseRootFromParent_Done,
     /* 263242 */   // Label 5269: @263242
     /* 263242 */   GIM_Try, /*On fail goto*//*Label 5270*/ GIMT_Encode4(263283), // Rule ID 2425 //
     /* 263247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 263255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 263259 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 263263 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263270 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 263270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 263273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263275 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 263277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 263281 */     GIR_RootConstrainSelectedInstOperands,
     /* 263282 */     // GIR_Coverage, 2425,
     /* 263282 */     GIR_EraseRootFromParent_Done,
     /* 263283 */   // Label 5270: @263283
     /* 263283 */   GIM_Reject,
     /* 263284 */ // Label 5264: @263284
     /* 263284 */ GIM_Reject,
     /* 263285 */ // Label 5262: @263285
     /* 263285 */ GIM_Try, /*On fail goto*//*Label 5271*/ GIMT_Encode4(263734),
     /* 263290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 263293 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 263296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 263300 */   GIM_Try, /*On fail goto*//*Label 5272*/ GIMT_Encode4(263364), // Rule ID 6424 //
     /* 263305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 263313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 263317 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 263322 */     // MIs[1] Operand 2
     /* 263322 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 263333 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 263337 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 263341 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /* 263345 */     // MIs[2] Operand 1
     /* 263345 */     // No operand predicates
     /* 263345 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 263347 */     // (sra:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i8:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm, 7:{ *:[i64] })
     /* 263347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 263350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 263356 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 263359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 263362 */     GIR_RootConstrainSelectedInstOperands,
     /* 263363 */     // GIR_Coverage, 6424,
     /* 263363 */     GIR_EraseRootFromParent_Done,
     /* 263364 */   // Label 5272: @263364
     /* 263364 */   GIM_Try, /*On fail goto*//*Label 5273*/ GIMT_Encode4(263428), // Rule ID 6426 //
     /* 263369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 263377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 263381 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 263386 */     // MIs[1] Operand 2
     /* 263386 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 263397 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 263401 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 263405 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /* 263409 */     // MIs[2] Operand 1
     /* 263409 */     // No operand predicates
     /* 263409 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 263411 */     // (sra:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm, 15:{ *:[i64] })
     /* 263411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 263414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 263420 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 263423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 263426 */     GIR_RootConstrainSelectedInstOperands,
     /* 263427 */     // GIR_Coverage, 6426,
     /* 263427 */     GIR_EraseRootFromParent_Done,
     /* 263428 */   // Label 5273: @263428
     /* 263428 */   GIM_Try, /*On fail goto*//*Label 5274*/ GIMT_Encode4(263531), // Rule ID 6427 //
     /* 263433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 263441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 263445 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263450 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 263454 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 263458 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 263462 */     // MIs[2] Operand 1
     /* 263462 */     // No operand predicates
     /* 263462 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 263464 */     // (sra:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (SBFMXri:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
     /* 263464 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 263467 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 263471 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263476 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 263478 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 263481 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 263485 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263490 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 263493 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 263497 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 263500 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 263505 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 263510 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 263518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263520 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 263523 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 263526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 263529 */     GIR_RootConstrainSelectedInstOperands,
     /* 263530 */     // GIR_Coverage, 6427,
     /* 263530 */     GIR_EraseRootFromParent_Done,
     /* 263531 */   // Label 5274: @263531
     /* 263531 */   GIM_Try, /*On fail goto*//*Label 5275*/ GIMT_Encode4(263569), // Rule ID 3965 //
     /* 263536 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 263540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 263544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 263548 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 263552 */     // MIs[1] Operand 1
     /* 263552 */     // No operand predicates
     /* 263552 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263554 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm, 63:{ *:[i64] })
     /* 263554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 263557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263559 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 263561 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 263564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 263567 */     GIR_RootConstrainSelectedInstOperands,
     /* 263568 */     // GIR_Coverage, 3965,
     /* 263568 */     GIR_EraseRootFromParent_Done,
     /* 263569 */   // Label 5275: @263569
     /* 263569 */   GIM_Try, /*On fail goto*//*Label 5276*/ GIMT_Encode4(263641), // Rule ID 2428 //
     /* 263574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 263578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 263582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 263586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 263590 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263597 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 263597 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 263600 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 263604 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263609 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 263612 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 263616 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 263619 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 263624 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
     /* 263632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263634 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 263636 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 263639 */     GIR_RootConstrainSelectedInstOperands,
     /* 263640 */     // GIR_Coverage, 2428,
     /* 263640 */     GIR_EraseRootFromParent_Done,
     /* 263641 */   // Label 5276: @263641
     /* 263641 */   GIM_Try, /*On fail goto*//*Label 5277*/ GIMT_Encode4(263713), // Rule ID 2429 //
     /* 263646 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 263650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 263654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 263658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 263662 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263669 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 263669 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 263672 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 263676 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263681 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 263684 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 263688 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 263691 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 263696 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
     /* 263704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263706 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 263708 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 263711 */     GIR_RootConstrainSelectedInstOperands,
     /* 263712 */     // GIR_Coverage, 2429,
     /* 263712 */     GIR_EraseRootFromParent_Done,
     /* 263713 */   // Label 5277: @263713
     /* 263713 */   GIM_Try, /*On fail goto*//*Label 5278*/ GIMT_Encode4(263733), // Rule ID 119 //
     /* 263718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 263722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 263726 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 263726 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
     /* 263731 */     GIR_RootConstrainSelectedInstOperands,
     /* 263732 */     // GIR_Coverage, 119,
     /* 263732 */     GIR_Done,
     /* 263733 */   // Label 5278: @263733
     /* 263733 */   GIM_Reject,
     /* 263734 */ // Label 5271: @263734
     /* 263734 */ GIM_Reject,
     /* 263735 */ // Label 5263: @263735
     /* 263735 */ GIM_Reject,
     /* 263736 */ // Label 44: @263736
     /* 263736 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5281*/ GIMT_Encode4(263865),
     /* 263747 */ /*GILLT_s32*//*Label 5279*/ GIMT_Encode4(263755),
     /* 263751 */ /*GILLT_s64*//*Label 5280*/ GIMT_Encode4(263810),
     /* 263755 */ // Label 5279: @263755
     /* 263755 */ GIM_Try, /*On fail goto*//*Label 5282*/ GIMT_Encode4(263809), // Rule ID 188 //
     /* 263760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 263763 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 263766 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 263769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263773 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263777 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263781 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 263785 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 263789 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 263793 */   // MIs[1] Operand 1
     /* 263793 */   // No operand predicates
     /* 263793 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263795 */   // (fshr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (EXTRWrri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] }):$imm)
     /* 263795 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRWrri),
     /* 263798 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263800 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 263802 */   GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 263804 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 263807 */   GIR_RootConstrainSelectedInstOperands,
     /* 263808 */   // GIR_Coverage, 188,
     /* 263808 */   GIR_EraseRootFromParent_Done,
     /* 263809 */ // Label 5282: @263809
     /* 263809 */ GIM_Reject,
     /* 263810 */ // Label 5280: @263810
     /* 263810 */ GIM_Try, /*On fail goto*//*Label 5283*/ GIMT_Encode4(263864), // Rule ID 189 //
     /* 263815 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 263818 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 263821 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 263824 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 263828 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 263832 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 263836 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 263840 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 263844 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 263848 */   // MIs[1] Operand 1
     /* 263848 */   // No operand predicates
     /* 263848 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263850 */   // (fshr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (EXTRXrri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, (imm:{ *:[i64] }):$imm)
     /* 263850 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRXrri),
     /* 263853 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263855 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 263857 */   GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 263859 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 263862 */   GIR_RootConstrainSelectedInstOperands,
     /* 263863 */   // GIR_Coverage, 189,
     /* 263863 */   GIR_EraseRootFromParent_Done,
     /* 263864 */ // Label 5283: @263864
     /* 263864 */ GIM_Reject,
     /* 263865 */ // Label 5281: @263865
     /* 263865 */ GIM_Reject,
     /* 263866 */ // Label 45: @263866
     /* 263866 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5286*/ GIMT_Encode4(264358),
     /* 263877 */ /*GILLT_s32*//*Label 5284*/ GIMT_Encode4(263885),
     /* 263881 */ /*GILLT_s64*//*Label 5285*/ GIMT_Encode4(264101),
     /* 263885 */ // Label 5284: @263885
     /* 263885 */ GIM_Try, /*On fail goto*//*Label 5287*/ GIMT_Encode4(264100),
     /* 263890 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 263893 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 263896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263900 */   GIM_Try, /*On fail goto*//*Label 5288*/ GIMT_Encode4(263939), // Rule ID 184 //
     /* 263905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 263913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 263917 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263922 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 263926 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263928 */     // (rotr:{ *:[i32] } (bswap:{ *:[i32] } GPR32:{ *:[i32] }:$Rn), 16:{ *:[i64] })  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 263928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
     /* 263931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263933 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 263937 */     GIR_RootConstrainSelectedInstOperands,
     /* 263938 */     // GIR_Coverage, 184,
     /* 263938 */     GIR_EraseRootFromParent_Done,
     /* 263939 */   // Label 5288: @263939
     /* 263939 */   GIM_Try, /*On fail goto*//*Label 5289*/ GIMT_Encode4(263976), // Rule ID 3960 //
     /* 263944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 263952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 263956 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 263960 */     // MIs[1] Operand 1
     /* 263960 */     // No operand predicates
     /* 263960 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263962 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (EXTRWrri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
     /* 263962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRWrri),
     /* 263965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263967 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 263969 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 263971 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 263974 */     GIR_RootConstrainSelectedInstOperands,
     /* 263975 */     // GIR_Coverage, 3960,
     /* 263975 */     GIR_EraseRootFromParent_Done,
     /* 263976 */   // Label 5289: @263976
     /* 263976 */   GIM_Try, /*On fail goto*//*Label 5290*/ GIMT_Encode4(264017), // Rule ID 3889 //
     /* 263981 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 263989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 263993 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 263997 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264002 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264004 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 264004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 264007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264009 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 264011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 264015 */     GIR_RootConstrainSelectedInstOperands,
     /* 264016 */     // GIR_Coverage, 3889,
     /* 264016 */     GIR_EraseRootFromParent_Done,
     /* 264017 */   // Label 5290: @264017
     /* 264017 */   GIM_Try, /*On fail goto*//*Label 5291*/ GIMT_Encode4(264058), // Rule ID 3890 //
     /* 264022 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 264030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 264034 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 264038 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264045 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 264045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 264048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264050 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 264052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 264056 */     GIR_RootConstrainSelectedInstOperands,
     /* 264057 */     // GIR_Coverage, 3890,
     /* 264057 */     GIR_EraseRootFromParent_Done,
     /* 264058 */   // Label 5291: @264058
     /* 264058 */   GIM_Try, /*On fail goto*//*Label 5292*/ GIMT_Encode4(264099), // Rule ID 3888 //
     /* 264063 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 264071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 264075 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 264079 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264084 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264086 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 264086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 264089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264091 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 264093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 264097 */     GIR_RootConstrainSelectedInstOperands,
     /* 264098 */     // GIR_Coverage, 3888,
     /* 264098 */     GIR_EraseRootFromParent_Done,
     /* 264099 */   // Label 5292: @264099
     /* 264099 */   GIM_Reject,
     /* 264100 */ // Label 5287: @264100
     /* 264100 */ GIM_Reject,
     /* 264101 */ // Label 5285: @264101
     /* 264101 */ GIM_Try, /*On fail goto*//*Label 5293*/ GIMT_Encode4(264357),
     /* 264106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 264109 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 264112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 264116 */   GIM_Try, /*On fail goto*//*Label 5294*/ GIMT_Encode4(264155), // Rule ID 187 //
     /* 264121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 264129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 264133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 264138 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 32,
     /* 264142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264144 */     // (rotr:{ *:[i64] } (bswap:{ *:[i64] } GPR64:{ *:[i64] }:$Rn), 32:{ *:[i64] })  =>  (REV32Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 264144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV32Xr),
     /* 264147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 264153 */     GIR_RootConstrainSelectedInstOperands,
     /* 264154 */     // GIR_Coverage, 187,
     /* 264154 */     GIR_EraseRootFromParent_Done,
     /* 264155 */   // Label 5294: @264155
     /* 264155 */   GIM_Try, /*On fail goto*//*Label 5295*/ GIMT_Encode4(264192), // Rule ID 3961 //
     /* 264160 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 264164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 264168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 264172 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 264176 */     // MIs[1] Operand 1
     /* 264176 */     // No operand predicates
     /* 264176 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264178 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (EXTRXrri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)
     /* 264178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRXrri),
     /* 264181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264183 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 264185 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 264187 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 264190 */     GIR_RootConstrainSelectedInstOperands,
     /* 264191 */     // GIR_Coverage, 3961,
     /* 264191 */     GIR_EraseRootFromParent_Done,
     /* 264192 */   // Label 5295: @264192
     /* 264192 */   GIM_Try, /*On fail goto*//*Label 5296*/ GIMT_Encode4(264264), // Rule ID 3891 //
     /* 264197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 264201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 264205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 264209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 264213 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264218 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264220 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 264220 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 264223 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 264227 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264232 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 264235 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 264239 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 264242 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 264247 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
     /* 264255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264257 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 264259 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 264262 */     GIR_RootConstrainSelectedInstOperands,
     /* 264263 */     // GIR_Coverage, 3891,
     /* 264263 */     GIR_EraseRootFromParent_Done,
     /* 264264 */   // Label 5296: @264264
     /* 264264 */   GIM_Try, /*On fail goto*//*Label 5297*/ GIMT_Encode4(264336), // Rule ID 3892 //
     /* 264269 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 264273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 264277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 264281 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 264285 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264290 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264292 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 264292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 264295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 264299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264304 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 264307 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 264311 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 264314 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 264319 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
     /* 264327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264329 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 264331 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 264334 */     GIR_RootConstrainSelectedInstOperands,
     /* 264335 */     // GIR_Coverage, 3892,
     /* 264335 */     GIR_EraseRootFromParent_Done,
     /* 264336 */   // Label 5297: @264336
     /* 264336 */   GIM_Try, /*On fail goto*//*Label 5298*/ GIMT_Encode4(264356), // Rule ID 122 //
     /* 264341 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 264345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 264349 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 264349 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
     /* 264354 */     GIR_RootConstrainSelectedInstOperands,
     /* 264355 */     // GIR_Coverage, 122,
     /* 264355 */     GIR_Done,
     /* 264356 */   // Label 5298: @264356
     /* 264356 */   GIM_Reject,
     /* 264357 */ // Label 5293: @264357
     /* 264357 */ GIM_Reject,
     /* 264358 */ // Label 5286: @264358
     /* 264358 */ GIM_Reject,
     /* 264359 */ // Label 46: @264359
     /* 264359 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(12), /*)*//*default:*//*Label 5306*/ GIMT_Encode4(268934),
     /* 264370 */ /*GILLT_v2s32*//*Label 5299*/ GIMT_Encode4(264398),
     /* 264374 */ /*GILLT_v2s64*//*Label 5300*/ GIMT_Encode4(265046),
     /* 264378 */ /*GILLT_v4s16*//*Label 5301*/ GIMT_Encode4(265694),
     /* 264382 */ /*GILLT_v4s32*//*Label 5302*/ GIMT_Encode4(266342),
     /* 264386 */ /*GILLT_v8s8*//*Label 5303*/ GIMT_Encode4(266990),
     /* 264390 */ /*GILLT_v8s16*//*Label 5304*/ GIMT_Encode4(267638),
     /* 264394 */ /*GILLT_v16s8*//*Label 5305*/ GIMT_Encode4(268286),
     /* 264398 */ // Label 5299: @264398
     /* 264398 */ GIM_Try, /*On fail goto*//*Label 5307*/ GIMT_Encode4(265045),
     /* 264403 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 264406 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 264409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264413 */   GIM_Try, /*On fail goto*//*Label 5308*/ GIMT_Encode4(264450), // Rule ID 5113 //
     /* 264418 */     // MIs[0] Operand 1
     /* 264418 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 264423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 264427 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 264433 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 264435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264441 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 264441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32rz),
     /* 264444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264446 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 264448 */     GIR_RootConstrainSelectedInstOperands,
     /* 264449 */     // GIR_Coverage, 5113,
     /* 264449 */     GIR_EraseRootFromParent_Done,
     /* 264450 */   // Label 5308: @264450
     /* 264450 */   GIM_Try, /*On fail goto*//*Label 5309*/ GIMT_Encode4(264487), // Rule ID 5120 //
     /* 264455 */     // MIs[0] Operand 1
     /* 264455 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 264460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 264464 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 264470 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 264472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264476 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264478 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 264478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 264481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 264485 */     GIR_RootConstrainSelectedInstOperands,
     /* 264486 */     // GIR_Coverage, 5120,
     /* 264486 */     GIR_EraseRootFromParent_Done,
     /* 264487 */   // Label 5309: @264487
     /* 264487 */   GIM_Try, /*On fail goto*//*Label 5310*/ GIMT_Encode4(264524), // Rule ID 5127 //
     /* 264492 */     // MIs[0] Operand 1
     /* 264492 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 264497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 264501 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 264507 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 264509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264513 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264515 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 264515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i32rz),
     /* 264518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264520 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 264522 */     GIR_RootConstrainSelectedInstOperands,
     /* 264523 */     // GIR_Coverage, 5127,
     /* 264523 */     GIR_EraseRootFromParent_Done,
     /* 264524 */   // Label 5310: @264524
     /* 264524 */   GIM_Try, /*On fail goto*//*Label 5311*/ GIMT_Encode4(264561), // Rule ID 5134 //
     /* 264529 */     // MIs[0] Operand 1
     /* 264529 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 264534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 264538 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 264544 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 264546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264550 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264552 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 264552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32rz),
     /* 264555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264557 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 264559 */     GIR_RootConstrainSelectedInstOperands,
     /* 264560 */     // GIR_Coverage, 5134,
     /* 264560 */     GIR_EraseRootFromParent_Done,
     /* 264561 */   // Label 5311: @264561
     /* 264561 */   GIM_Try, /*On fail goto*//*Label 5312*/ GIMT_Encode4(264598), // Rule ID 5141 //
     /* 264566 */     // MIs[0] Operand 1
     /* 264566 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 264571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 264575 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 264581 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 264583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264587 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264589 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 264589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 264592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264594 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 264596 */     GIR_RootConstrainSelectedInstOperands,
     /* 264597 */     // GIR_Coverage, 5141,
     /* 264597 */     GIR_EraseRootFromParent_Done,
     /* 264598 */   // Label 5312: @264598
     /* 264598 */   GIM_Try, /*On fail goto*//*Label 5313*/ GIMT_Encode4(264635), // Rule ID 5078 //
     /* 264603 */     // MIs[0] Operand 1
     /* 264603 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 264608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 264616 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 264622 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 264624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264626 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 264626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32rz),
     /* 264629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 264633 */     GIR_RootConstrainSelectedInstOperands,
     /* 264634 */     // GIR_Coverage, 5078,
     /* 264634 */     GIR_EraseRootFromParent_Done,
     /* 264635 */   // Label 5313: @264635
     /* 264635 */   GIM_Try, /*On fail goto*//*Label 5314*/ GIMT_Encode4(264672), // Rule ID 5085 //
     /* 264640 */     // MIs[0] Operand 1
     /* 264640 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 264645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 264653 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 264659 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 264661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264663 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGT:{ *:[Other] })  =>  (CMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 264663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32rz),
     /* 264666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 264670 */     GIR_RootConstrainSelectedInstOperands,
     /* 264671 */     // GIR_Coverage, 5085,
     /* 264671 */     GIR_EraseRootFromParent_Done,
     /* 264672 */   // Label 5314: @264672
     /* 264672 */   GIM_Try, /*On fail goto*//*Label 5315*/ GIMT_Encode4(264709), // Rule ID 5092 //
     /* 264677 */     // MIs[0] Operand 1
     /* 264677 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 264682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 264690 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 264696 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 264698 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264700 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGE:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 264700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 264703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 264707 */     GIR_RootConstrainSelectedInstOperands,
     /* 264708 */     // GIR_Coverage, 5092,
     /* 264708 */     GIR_EraseRootFromParent_Done,
     /* 264709 */   // Label 5315: @264709
     /* 264709 */   GIM_Try, /*On fail goto*//*Label 5316*/ GIMT_Encode4(264746), // Rule ID 5099 //
     /* 264714 */     // MIs[0] Operand 1
     /* 264714 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 264719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 264727 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 264733 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 264735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264737 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETLT:{ *:[Other] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 264737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 264740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 264744 */     GIR_RootConstrainSelectedInstOperands,
     /* 264745 */     // GIR_Coverage, 5099,
     /* 264745 */     GIR_EraseRootFromParent_Done,
     /* 264746 */   // Label 5316: @264746
     /* 264746 */   GIM_Try, /*On fail goto*//*Label 5317*/ GIMT_Encode4(264783), // Rule ID 5106 //
     /* 264751 */     // MIs[0] Operand 1
     /* 264751 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 264756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 264764 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 264770 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 264772 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264774 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETLE:{ *:[Other] })  =>  (CMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 264774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i32rz),
     /* 264777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264779 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 264781 */     GIR_RootConstrainSelectedInstOperands,
     /* 264782 */     // GIR_Coverage, 5106,
     /* 264782 */     GIR_EraseRootFromParent_Done,
     /* 264783 */   // Label 5317: @264783
     /* 264783 */   GIM_Try, /*On fail goto*//*Label 5318*/ GIMT_Encode4(264812), // Rule ID 5015 //
     /* 264788 */     // MIs[0] Operand 1
     /* 264788 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 264793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264801 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 264801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32),
     /* 264804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 264808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 264810 */     GIR_RootConstrainSelectedInstOperands,
     /* 264811 */     // GIR_Coverage, 5015,
     /* 264811 */     GIR_EraseRootFromParent_Done,
     /* 264812 */   // Label 5318: @264812
     /* 264812 */   GIM_Try, /*On fail goto*//*Label 5319*/ GIMT_Encode4(264841), // Rule ID 5022 //
     /* 264817 */     // MIs[0] Operand 1
     /* 264817 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 264822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264830 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 264830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32),
     /* 264833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 264837 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 264839 */     GIR_RootConstrainSelectedInstOperands,
     /* 264840 */     // GIR_Coverage, 5022,
     /* 264840 */     GIR_EraseRootFromParent_Done,
     /* 264841 */   // Label 5319: @264841
     /* 264841 */   GIM_Try, /*On fail goto*//*Label 5320*/ GIMT_Encode4(264870), // Rule ID 5029 //
     /* 264846 */     // MIs[0] Operand 1
     /* 264846 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 264851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264859 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 264859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32),
     /* 264862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 264866 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 264868 */     GIR_RootConstrainSelectedInstOperands,
     /* 264869 */     // GIR_Coverage, 5029,
     /* 264869 */     GIR_EraseRootFromParent_Done,
     /* 264870 */   // Label 5320: @264870
     /* 264870 */   GIM_Try, /*On fail goto*//*Label 5321*/ GIMT_Encode4(264899), // Rule ID 5036 //
     /* 264875 */     // MIs[0] Operand 1
     /* 264875 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 264880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264888 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 264888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i32),
     /* 264891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 264895 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 264897 */     GIR_RootConstrainSelectedInstOperands,
     /* 264898 */     // GIR_Coverage, 5036,
     /* 264898 */     GIR_EraseRootFromParent_Done,
     /* 264899 */   // Label 5321: @264899
     /* 264899 */   GIM_Try, /*On fail goto*//*Label 5322*/ GIMT_Encode4(264928), // Rule ID 5043 //
     /* 264904 */     // MIs[0] Operand 1
     /* 264904 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 264909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264917 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 264917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i32),
     /* 264920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264922 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 264924 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 264926 */     GIR_RootConstrainSelectedInstOperands,
     /* 264927 */     // GIR_Coverage, 5043,
     /* 264927 */     GIR_EraseRootFromParent_Done,
     /* 264928 */   // Label 5322: @264928
     /* 264928 */   GIM_Try, /*On fail goto*//*Label 5323*/ GIMT_Encode4(264957), // Rule ID 5050 //
     /* 264933 */     // MIs[0] Operand 1
     /* 264933 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 264938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264946 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 264946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32),
     /* 264949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264951 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 264953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 264955 */     GIR_RootConstrainSelectedInstOperands,
     /* 264956 */     // GIR_Coverage, 5050,
     /* 264956 */     GIR_EraseRootFromParent_Done,
     /* 264957 */   // Label 5323: @264957
     /* 264957 */   GIM_Try, /*On fail goto*//*Label 5324*/ GIMT_Encode4(264986), // Rule ID 5057 //
     /* 264962 */     // MIs[0] Operand 1
     /* 264962 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 264967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264975 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 264975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32),
     /* 264978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264980 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 264982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 264984 */     GIR_RootConstrainSelectedInstOperands,
     /* 264985 */     // GIR_Coverage, 5057,
     /* 264985 */     GIR_EraseRootFromParent_Done,
     /* 264986 */   // Label 5324: @264986
     /* 264986 */   GIM_Try, /*On fail goto*//*Label 5325*/ GIMT_Encode4(265015), // Rule ID 5064 //
     /* 264991 */     // MIs[0] Operand 1
     /* 264991 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 264996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265004 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 265004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i32),
     /* 265007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265009 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 265011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265013 */     GIR_RootConstrainSelectedInstOperands,
     /* 265014 */     // GIR_Coverage, 5064,
     /* 265014 */     GIR_EraseRootFromParent_Done,
     /* 265015 */   // Label 5325: @265015
     /* 265015 */   GIM_Try, /*On fail goto*//*Label 5326*/ GIMT_Encode4(265044), // Rule ID 5071 //
     /* 265020 */     // MIs[0] Operand 1
     /* 265020 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 265025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265033 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 265033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i32),
     /* 265036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265038 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 265040 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265042 */     GIR_RootConstrainSelectedInstOperands,
     /* 265043 */     // GIR_Coverage, 5071,
     /* 265043 */     GIR_EraseRootFromParent_Done,
     /* 265044 */   // Label 5326: @265044
     /* 265044 */   GIM_Reject,
     /* 265045 */ // Label 5307: @265045
     /* 265045 */ GIM_Reject,
     /* 265046 */ // Label 5300: @265046
     /* 265046 */ GIM_Try, /*On fail goto*//*Label 5327*/ GIMT_Encode4(265693),
     /* 265051 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 265054 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 265057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265061 */   GIM_Try, /*On fail goto*//*Label 5328*/ GIMT_Encode4(265098), // Rule ID 5115 //
     /* 265066 */     // MIs[0] Operand 1
     /* 265066 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 265071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 265075 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 265081 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 265083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265089 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 265089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64rz),
     /* 265092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 265096 */     GIR_RootConstrainSelectedInstOperands,
     /* 265097 */     // GIR_Coverage, 5115,
     /* 265097 */     GIR_EraseRootFromParent_Done,
     /* 265098 */   // Label 5328: @265098
     /* 265098 */   GIM_Try, /*On fail goto*//*Label 5329*/ GIMT_Encode4(265135), // Rule ID 5122 //
     /* 265103 */     // MIs[0] Operand 1
     /* 265103 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 265108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 265112 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 265118 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 265120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265124 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265126 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 265126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 265129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265131 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 265133 */     GIR_RootConstrainSelectedInstOperands,
     /* 265134 */     // GIR_Coverage, 5122,
     /* 265134 */     GIR_EraseRootFromParent_Done,
     /* 265135 */   // Label 5329: @265135
     /* 265135 */   GIM_Try, /*On fail goto*//*Label 5330*/ GIMT_Encode4(265172), // Rule ID 5129 //
     /* 265140 */     // MIs[0] Operand 1
     /* 265140 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 265145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 265149 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 265155 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 265157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265163 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 265163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i64rz),
     /* 265166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265168 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 265170 */     GIR_RootConstrainSelectedInstOperands,
     /* 265171 */     // GIR_Coverage, 5129,
     /* 265171 */     GIR_EraseRootFromParent_Done,
     /* 265172 */   // Label 5330: @265172
     /* 265172 */   GIM_Try, /*On fail goto*//*Label 5331*/ GIMT_Encode4(265209), // Rule ID 5136 //
     /* 265177 */     // MIs[0] Operand 1
     /* 265177 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 265182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 265186 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 265192 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 265194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265200 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 265200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64rz),
     /* 265203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265205 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 265207 */     GIR_RootConstrainSelectedInstOperands,
     /* 265208 */     // GIR_Coverage, 5136,
     /* 265208 */     GIR_EraseRootFromParent_Done,
     /* 265209 */   // Label 5331: @265209
     /* 265209 */   GIM_Try, /*On fail goto*//*Label 5332*/ GIMT_Encode4(265246), // Rule ID 5143 //
     /* 265214 */     // MIs[0] Operand 1
     /* 265214 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 265219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 265223 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 265229 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 265231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265237 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 265237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 265240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 265244 */     GIR_RootConstrainSelectedInstOperands,
     /* 265245 */     // GIR_Coverage, 5143,
     /* 265245 */     GIR_EraseRootFromParent_Done,
     /* 265246 */   // Label 5332: @265246
     /* 265246 */   GIM_Try, /*On fail goto*//*Label 5333*/ GIMT_Encode4(265283), // Rule ID 5080 //
     /* 265251 */     // MIs[0] Operand 1
     /* 265251 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 265256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 265264 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 265270 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 265272 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265274 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 265274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64rz),
     /* 265277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265279 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265281 */     GIR_RootConstrainSelectedInstOperands,
     /* 265282 */     // GIR_Coverage, 5080,
     /* 265282 */     GIR_EraseRootFromParent_Done,
     /* 265283 */   // Label 5333: @265283
     /* 265283 */   GIM_Try, /*On fail goto*//*Label 5334*/ GIMT_Encode4(265320), // Rule ID 5087 //
     /* 265288 */     // MIs[0] Operand 1
     /* 265288 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 265293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 265301 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 265307 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 265309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265311 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGT:{ *:[Other] })  =>  (CMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 265311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64rz),
     /* 265314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265318 */     GIR_RootConstrainSelectedInstOperands,
     /* 265319 */     // GIR_Coverage, 5087,
     /* 265319 */     GIR_EraseRootFromParent_Done,
     /* 265320 */   // Label 5334: @265320
     /* 265320 */   GIM_Try, /*On fail goto*//*Label 5335*/ GIMT_Encode4(265357), // Rule ID 5094 //
     /* 265325 */     // MIs[0] Operand 1
     /* 265325 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 265330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 265338 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 265344 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 265346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265348 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGE:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 265348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 265351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265355 */     GIR_RootConstrainSelectedInstOperands,
     /* 265356 */     // GIR_Coverage, 5094,
     /* 265356 */     GIR_EraseRootFromParent_Done,
     /* 265357 */   // Label 5335: @265357
     /* 265357 */   GIM_Try, /*On fail goto*//*Label 5336*/ GIMT_Encode4(265394), // Rule ID 5101 //
     /* 265362 */     // MIs[0] Operand 1
     /* 265362 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 265367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 265375 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 265381 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 265383 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265385 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETLT:{ *:[Other] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 265385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 265388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265390 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265392 */     GIR_RootConstrainSelectedInstOperands,
     /* 265393 */     // GIR_Coverage, 5101,
     /* 265393 */     GIR_EraseRootFromParent_Done,
     /* 265394 */   // Label 5336: @265394
     /* 265394 */   GIM_Try, /*On fail goto*//*Label 5337*/ GIMT_Encode4(265431), // Rule ID 5108 //
     /* 265399 */     // MIs[0] Operand 1
     /* 265399 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 265404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 265412 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 265418 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 265420 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265422 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETLE:{ *:[Other] })  =>  (CMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 265422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i64rz),
     /* 265425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265427 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265429 */     GIR_RootConstrainSelectedInstOperands,
     /* 265430 */     // GIR_Coverage, 5108,
     /* 265430 */     GIR_EraseRootFromParent_Done,
     /* 265431 */   // Label 5337: @265431
     /* 265431 */   GIM_Try, /*On fail goto*//*Label 5338*/ GIMT_Encode4(265460), // Rule ID 5017 //
     /* 265436 */     // MIs[0] Operand 1
     /* 265436 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 265441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265449 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 265449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64),
     /* 265452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265456 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 265458 */     GIR_RootConstrainSelectedInstOperands,
     /* 265459 */     // GIR_Coverage, 5017,
     /* 265459 */     GIR_EraseRootFromParent_Done,
     /* 265460 */   // Label 5338: @265460
     /* 265460 */   GIM_Try, /*On fail goto*//*Label 5339*/ GIMT_Encode4(265489), // Rule ID 5024 //
     /* 265465 */     // MIs[0] Operand 1
     /* 265465 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 265470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265478 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 265478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64),
     /* 265481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265485 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 265487 */     GIR_RootConstrainSelectedInstOperands,
     /* 265488 */     // GIR_Coverage, 5024,
     /* 265488 */     GIR_EraseRootFromParent_Done,
     /* 265489 */   // Label 5339: @265489
     /* 265489 */   GIM_Try, /*On fail goto*//*Label 5340*/ GIMT_Encode4(265518), // Rule ID 5031 //
     /* 265494 */     // MIs[0] Operand 1
     /* 265494 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 265499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265507 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 265507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64),
     /* 265510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265512 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265514 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 265516 */     GIR_RootConstrainSelectedInstOperands,
     /* 265517 */     // GIR_Coverage, 5031,
     /* 265517 */     GIR_EraseRootFromParent_Done,
     /* 265518 */   // Label 5340: @265518
     /* 265518 */   GIM_Try, /*On fail goto*//*Label 5341*/ GIMT_Encode4(265547), // Rule ID 5038 //
     /* 265523 */     // MIs[0] Operand 1
     /* 265523 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 265528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265536 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 265536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i64),
     /* 265539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 265545 */     GIR_RootConstrainSelectedInstOperands,
     /* 265546 */     // GIR_Coverage, 5038,
     /* 265546 */     GIR_EraseRootFromParent_Done,
     /* 265547 */   // Label 5341: @265547
     /* 265547 */   GIM_Try, /*On fail goto*//*Label 5342*/ GIMT_Encode4(265576), // Rule ID 5045 //
     /* 265552 */     // MIs[0] Operand 1
     /* 265552 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 265557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265565 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 265565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i64),
     /* 265568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265570 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265572 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 265574 */     GIR_RootConstrainSelectedInstOperands,
     /* 265575 */     // GIR_Coverage, 5045,
     /* 265575 */     GIR_EraseRootFromParent_Done,
     /* 265576 */   // Label 5342: @265576
     /* 265576 */   GIM_Try, /*On fail goto*//*Label 5343*/ GIMT_Encode4(265605), // Rule ID 5052 //
     /* 265581 */     // MIs[0] Operand 1
     /* 265581 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 265586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265594 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 265594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64),
     /* 265597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265599 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 265601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265603 */     GIR_RootConstrainSelectedInstOperands,
     /* 265604 */     // GIR_Coverage, 5052,
     /* 265604 */     GIR_EraseRootFromParent_Done,
     /* 265605 */   // Label 5343: @265605
     /* 265605 */   GIM_Try, /*On fail goto*//*Label 5344*/ GIMT_Encode4(265634), // Rule ID 5059 //
     /* 265610 */     // MIs[0] Operand 1
     /* 265610 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 265615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265623 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 265623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64),
     /* 265626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265628 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 265630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265632 */     GIR_RootConstrainSelectedInstOperands,
     /* 265633 */     // GIR_Coverage, 5059,
     /* 265633 */     GIR_EraseRootFromParent_Done,
     /* 265634 */   // Label 5344: @265634
     /* 265634 */   GIM_Try, /*On fail goto*//*Label 5345*/ GIMT_Encode4(265663), // Rule ID 5066 //
     /* 265639 */     // MIs[0] Operand 1
     /* 265639 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 265644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265652 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 265652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i64),
     /* 265655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 265659 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265661 */     GIR_RootConstrainSelectedInstOperands,
     /* 265662 */     // GIR_Coverage, 5066,
     /* 265662 */     GIR_EraseRootFromParent_Done,
     /* 265663 */   // Label 5345: @265663
     /* 265663 */   GIM_Try, /*On fail goto*//*Label 5346*/ GIMT_Encode4(265692), // Rule ID 5073 //
     /* 265668 */     // MIs[0] Operand 1
     /* 265668 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 265673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265681 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 265681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i64),
     /* 265684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265686 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 265688 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265690 */     GIR_RootConstrainSelectedInstOperands,
     /* 265691 */     // GIR_Coverage, 5073,
     /* 265691 */     GIR_EraseRootFromParent_Done,
     /* 265692 */   // Label 5346: @265692
     /* 265692 */   GIM_Reject,
     /* 265693 */ // Label 5327: @265693
     /* 265693 */ GIM_Reject,
     /* 265694 */ // Label 5301: @265694
     /* 265694 */ GIM_Try, /*On fail goto*//*Label 5347*/ GIMT_Encode4(266341),
     /* 265699 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 265702 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 265705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265709 */   GIM_Try, /*On fail goto*//*Label 5348*/ GIMT_Encode4(265746), // Rule ID 5111 //
     /* 265714 */     // MIs[0] Operand 1
     /* 265714 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 265719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 265723 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 265729 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 265731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265737 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 265737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16rz),
     /* 265740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265742 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 265744 */     GIR_RootConstrainSelectedInstOperands,
     /* 265745 */     // GIR_Coverage, 5111,
     /* 265745 */     GIR_EraseRootFromParent_Done,
     /* 265746 */   // Label 5348: @265746
     /* 265746 */   GIM_Try, /*On fail goto*//*Label 5349*/ GIMT_Encode4(265783), // Rule ID 5118 //
     /* 265751 */     // MIs[0] Operand 1
     /* 265751 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 265756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 265760 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 265766 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 265768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265772 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265774 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 265774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 265777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265779 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 265781 */     GIR_RootConstrainSelectedInstOperands,
     /* 265782 */     // GIR_Coverage, 5118,
     /* 265782 */     GIR_EraseRootFromParent_Done,
     /* 265783 */   // Label 5349: @265783
     /* 265783 */   GIM_Try, /*On fail goto*//*Label 5350*/ GIMT_Encode4(265820), // Rule ID 5125 //
     /* 265788 */     // MIs[0] Operand 1
     /* 265788 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 265793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 265797 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 265803 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 265805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265811 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 265811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i16rz),
     /* 265814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265816 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 265818 */     GIR_RootConstrainSelectedInstOperands,
     /* 265819 */     // GIR_Coverage, 5125,
     /* 265819 */     GIR_EraseRootFromParent_Done,
     /* 265820 */   // Label 5350: @265820
     /* 265820 */   GIM_Try, /*On fail goto*//*Label 5351*/ GIMT_Encode4(265857), // Rule ID 5132 //
     /* 265825 */     // MIs[0] Operand 1
     /* 265825 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 265830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 265834 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 265840 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 265842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265846 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265848 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 265848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16rz),
     /* 265851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265853 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 265855 */     GIR_RootConstrainSelectedInstOperands,
     /* 265856 */     // GIR_Coverage, 5132,
     /* 265856 */     GIR_EraseRootFromParent_Done,
     /* 265857 */   // Label 5351: @265857
     /* 265857 */   GIM_Try, /*On fail goto*//*Label 5352*/ GIMT_Encode4(265894), // Rule ID 5139 //
     /* 265862 */     // MIs[0] Operand 1
     /* 265862 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 265867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 265871 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 265877 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 265879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265885 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 265885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 265888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265890 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 265892 */     GIR_RootConstrainSelectedInstOperands,
     /* 265893 */     // GIR_Coverage, 5139,
     /* 265893 */     GIR_EraseRootFromParent_Done,
     /* 265894 */   // Label 5352: @265894
     /* 265894 */   GIM_Try, /*On fail goto*//*Label 5353*/ GIMT_Encode4(265931), // Rule ID 5076 //
     /* 265899 */     // MIs[0] Operand 1
     /* 265899 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 265904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 265912 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 265918 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 265920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265922 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 265922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16rz),
     /* 265925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265929 */     GIR_RootConstrainSelectedInstOperands,
     /* 265930 */     // GIR_Coverage, 5076,
     /* 265930 */     GIR_EraseRootFromParent_Done,
     /* 265931 */   // Label 5353: @265931
     /* 265931 */   GIM_Try, /*On fail goto*//*Label 5354*/ GIMT_Encode4(265968), // Rule ID 5083 //
     /* 265936 */     // MIs[0] Operand 1
     /* 265936 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 265941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 265949 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 265955 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 265957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265959 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGT:{ *:[Other] })  =>  (CMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 265959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16rz),
     /* 265962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265964 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 265966 */     GIR_RootConstrainSelectedInstOperands,
     /* 265967 */     // GIR_Coverage, 5083,
     /* 265967 */     GIR_EraseRootFromParent_Done,
     /* 265968 */   // Label 5354: @265968
     /* 265968 */   GIM_Try, /*On fail goto*//*Label 5355*/ GIMT_Encode4(266005), // Rule ID 5090 //
     /* 265973 */     // MIs[0] Operand 1
     /* 265973 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 265978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 265986 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 265992 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 265994 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265996 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGE:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 265996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 265999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266003 */     GIR_RootConstrainSelectedInstOperands,
     /* 266004 */     // GIR_Coverage, 5090,
     /* 266004 */     GIR_EraseRootFromParent_Done,
     /* 266005 */   // Label 5355: @266005
     /* 266005 */   GIM_Try, /*On fail goto*//*Label 5356*/ GIMT_Encode4(266042), // Rule ID 5097 //
     /* 266010 */     // MIs[0] Operand 1
     /* 266010 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 266015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 266023 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 266029 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 266031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266033 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETLT:{ *:[Other] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 266033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 266036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266038 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266040 */     GIR_RootConstrainSelectedInstOperands,
     /* 266041 */     // GIR_Coverage, 5097,
     /* 266041 */     GIR_EraseRootFromParent_Done,
     /* 266042 */   // Label 5356: @266042
     /* 266042 */   GIM_Try, /*On fail goto*//*Label 5357*/ GIMT_Encode4(266079), // Rule ID 5104 //
     /* 266047 */     // MIs[0] Operand 1
     /* 266047 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 266052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 266060 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 266066 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 266068 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266070 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETLE:{ *:[Other] })  =>  (CMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 266070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i16rz),
     /* 266073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266077 */     GIR_RootConstrainSelectedInstOperands,
     /* 266078 */     // GIR_Coverage, 5104,
     /* 266078 */     GIR_EraseRootFromParent_Done,
     /* 266079 */   // Label 5357: @266079
     /* 266079 */   GIM_Try, /*On fail goto*//*Label 5358*/ GIMT_Encode4(266108), // Rule ID 5013 //
     /* 266084 */     // MIs[0] Operand 1
     /* 266084 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 266089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266097 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 266097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16),
     /* 266100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266102 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266104 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 266106 */     GIR_RootConstrainSelectedInstOperands,
     /* 266107 */     // GIR_Coverage, 5013,
     /* 266107 */     GIR_EraseRootFromParent_Done,
     /* 266108 */   // Label 5358: @266108
     /* 266108 */   GIM_Try, /*On fail goto*//*Label 5359*/ GIMT_Encode4(266137), // Rule ID 5020 //
     /* 266113 */     // MIs[0] Operand 1
     /* 266113 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 266118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266126 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 266126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16),
     /* 266129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266133 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 266135 */     GIR_RootConstrainSelectedInstOperands,
     /* 266136 */     // GIR_Coverage, 5020,
     /* 266136 */     GIR_EraseRootFromParent_Done,
     /* 266137 */   // Label 5359: @266137
     /* 266137 */   GIM_Try, /*On fail goto*//*Label 5360*/ GIMT_Encode4(266166), // Rule ID 5027 //
     /* 266142 */     // MIs[0] Operand 1
     /* 266142 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 266147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266155 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 266155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16),
     /* 266158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266162 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 266164 */     GIR_RootConstrainSelectedInstOperands,
     /* 266165 */     // GIR_Coverage, 5027,
     /* 266165 */     GIR_EraseRootFromParent_Done,
     /* 266166 */   // Label 5360: @266166
     /* 266166 */   GIM_Try, /*On fail goto*//*Label 5361*/ GIMT_Encode4(266195), // Rule ID 5034 //
     /* 266171 */     // MIs[0] Operand 1
     /* 266171 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 266176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266184 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 266184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i16),
     /* 266187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266191 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 266193 */     GIR_RootConstrainSelectedInstOperands,
     /* 266194 */     // GIR_Coverage, 5034,
     /* 266194 */     GIR_EraseRootFromParent_Done,
     /* 266195 */   // Label 5361: @266195
     /* 266195 */   GIM_Try, /*On fail goto*//*Label 5362*/ GIMT_Encode4(266224), // Rule ID 5041 //
     /* 266200 */     // MIs[0] Operand 1
     /* 266200 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 266205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266213 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 266213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i16),
     /* 266216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266220 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 266222 */     GIR_RootConstrainSelectedInstOperands,
     /* 266223 */     // GIR_Coverage, 5041,
     /* 266223 */     GIR_EraseRootFromParent_Done,
     /* 266224 */   // Label 5362: @266224
     /* 266224 */   GIM_Try, /*On fail goto*//*Label 5363*/ GIMT_Encode4(266253), // Rule ID 5048 //
     /* 266229 */     // MIs[0] Operand 1
     /* 266229 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 266234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266242 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 266242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16),
     /* 266245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266247 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 266249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266251 */     GIR_RootConstrainSelectedInstOperands,
     /* 266252 */     // GIR_Coverage, 5048,
     /* 266252 */     GIR_EraseRootFromParent_Done,
     /* 266253 */   // Label 5363: @266253
     /* 266253 */   GIM_Try, /*On fail goto*//*Label 5364*/ GIMT_Encode4(266282), // Rule ID 5055 //
     /* 266258 */     // MIs[0] Operand 1
     /* 266258 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 266263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266271 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 266271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16),
     /* 266274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266276 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 266278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266280 */     GIR_RootConstrainSelectedInstOperands,
     /* 266281 */     // GIR_Coverage, 5055,
     /* 266281 */     GIR_EraseRootFromParent_Done,
     /* 266282 */   // Label 5364: @266282
     /* 266282 */   GIM_Try, /*On fail goto*//*Label 5365*/ GIMT_Encode4(266311), // Rule ID 5062 //
     /* 266287 */     // MIs[0] Operand 1
     /* 266287 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 266292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266300 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 266300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i16),
     /* 266303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266305 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 266307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266309 */     GIR_RootConstrainSelectedInstOperands,
     /* 266310 */     // GIR_Coverage, 5062,
     /* 266310 */     GIR_EraseRootFromParent_Done,
     /* 266311 */   // Label 5365: @266311
     /* 266311 */   GIM_Try, /*On fail goto*//*Label 5366*/ GIMT_Encode4(266340), // Rule ID 5069 //
     /* 266316 */     // MIs[0] Operand 1
     /* 266316 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 266321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266329 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 266329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i16),
     /* 266332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266334 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 266336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266338 */     GIR_RootConstrainSelectedInstOperands,
     /* 266339 */     // GIR_Coverage, 5069,
     /* 266339 */     GIR_EraseRootFromParent_Done,
     /* 266340 */   // Label 5366: @266340
     /* 266340 */   GIM_Reject,
     /* 266341 */ // Label 5347: @266341
     /* 266341 */ GIM_Reject,
     /* 266342 */ // Label 5302: @266342
     /* 266342 */ GIM_Try, /*On fail goto*//*Label 5367*/ GIMT_Encode4(266989),
     /* 266347 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 266350 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 266353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266357 */   GIM_Try, /*On fail goto*//*Label 5368*/ GIMT_Encode4(266394), // Rule ID 5114 //
     /* 266362 */     // MIs[0] Operand 1
     /* 266362 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 266367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 266371 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 266377 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 266379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266383 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266385 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 266385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32rz),
     /* 266388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266390 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 266392 */     GIR_RootConstrainSelectedInstOperands,
     /* 266393 */     // GIR_Coverage, 5114,
     /* 266393 */     GIR_EraseRootFromParent_Done,
     /* 266394 */   // Label 5368: @266394
     /* 266394 */   GIM_Try, /*On fail goto*//*Label 5369*/ GIMT_Encode4(266431), // Rule ID 5121 //
     /* 266399 */     // MIs[0] Operand 1
     /* 266399 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 266404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 266408 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 266414 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 266416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266420 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266422 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 266422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 266425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266427 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 266429 */     GIR_RootConstrainSelectedInstOperands,
     /* 266430 */     // GIR_Coverage, 5121,
     /* 266430 */     GIR_EraseRootFromParent_Done,
     /* 266431 */   // Label 5369: @266431
     /* 266431 */   GIM_Try, /*On fail goto*//*Label 5370*/ GIMT_Encode4(266468), // Rule ID 5128 //
     /* 266436 */     // MIs[0] Operand 1
     /* 266436 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 266441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 266445 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 266451 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 266453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266457 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266459 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 266459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i32rz),
     /* 266462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266464 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 266466 */     GIR_RootConstrainSelectedInstOperands,
     /* 266467 */     // GIR_Coverage, 5128,
     /* 266467 */     GIR_EraseRootFromParent_Done,
     /* 266468 */   // Label 5370: @266468
     /* 266468 */   GIM_Try, /*On fail goto*//*Label 5371*/ GIMT_Encode4(266505), // Rule ID 5135 //
     /* 266473 */     // MIs[0] Operand 1
     /* 266473 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 266478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 266482 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 266488 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 266490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266496 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 266496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32rz),
     /* 266499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266501 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 266503 */     GIR_RootConstrainSelectedInstOperands,
     /* 266504 */     // GIR_Coverage, 5135,
     /* 266504 */     GIR_EraseRootFromParent_Done,
     /* 266505 */   // Label 5371: @266505
     /* 266505 */   GIM_Try, /*On fail goto*//*Label 5372*/ GIMT_Encode4(266542), // Rule ID 5142 //
     /* 266510 */     // MIs[0] Operand 1
     /* 266510 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 266515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 266519 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 266525 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 266527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266533 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 266533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 266536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266538 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 266540 */     GIR_RootConstrainSelectedInstOperands,
     /* 266541 */     // GIR_Coverage, 5142,
     /* 266541 */     GIR_EraseRootFromParent_Done,
     /* 266542 */   // Label 5372: @266542
     /* 266542 */   GIM_Try, /*On fail goto*//*Label 5373*/ GIMT_Encode4(266579), // Rule ID 5079 //
     /* 266547 */     // MIs[0] Operand 1
     /* 266547 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 266552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 266560 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 266566 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 266568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266570 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 266570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32rz),
     /* 266573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266577 */     GIR_RootConstrainSelectedInstOperands,
     /* 266578 */     // GIR_Coverage, 5079,
     /* 266578 */     GIR_EraseRootFromParent_Done,
     /* 266579 */   // Label 5373: @266579
     /* 266579 */   GIM_Try, /*On fail goto*//*Label 5374*/ GIMT_Encode4(266616), // Rule ID 5086 //
     /* 266584 */     // MIs[0] Operand 1
     /* 266584 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 266589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 266597 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 266603 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 266605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266607 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGT:{ *:[Other] })  =>  (CMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 266607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32rz),
     /* 266610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266614 */     GIR_RootConstrainSelectedInstOperands,
     /* 266615 */     // GIR_Coverage, 5086,
     /* 266615 */     GIR_EraseRootFromParent_Done,
     /* 266616 */   // Label 5374: @266616
     /* 266616 */   GIM_Try, /*On fail goto*//*Label 5375*/ GIMT_Encode4(266653), // Rule ID 5093 //
     /* 266621 */     // MIs[0] Operand 1
     /* 266621 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 266626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 266634 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 266640 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 266642 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266644 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGE:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 266644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 266647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266651 */     GIR_RootConstrainSelectedInstOperands,
     /* 266652 */     // GIR_Coverage, 5093,
     /* 266652 */     GIR_EraseRootFromParent_Done,
     /* 266653 */   // Label 5375: @266653
     /* 266653 */   GIM_Try, /*On fail goto*//*Label 5376*/ GIMT_Encode4(266690), // Rule ID 5100 //
     /* 266658 */     // MIs[0] Operand 1
     /* 266658 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 266663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 266671 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 266677 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 266679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266681 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETLT:{ *:[Other] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 266681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 266684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266688 */     GIR_RootConstrainSelectedInstOperands,
     /* 266689 */     // GIR_Coverage, 5100,
     /* 266689 */     GIR_EraseRootFromParent_Done,
     /* 266690 */   // Label 5376: @266690
     /* 266690 */   GIM_Try, /*On fail goto*//*Label 5377*/ GIMT_Encode4(266727), // Rule ID 5107 //
     /* 266695 */     // MIs[0] Operand 1
     /* 266695 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 266700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 266708 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 266714 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 266716 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266718 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETLE:{ *:[Other] })  =>  (CMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 266718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i32rz),
     /* 266721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266725 */     GIR_RootConstrainSelectedInstOperands,
     /* 266726 */     // GIR_Coverage, 5107,
     /* 266726 */     GIR_EraseRootFromParent_Done,
     /* 266727 */   // Label 5377: @266727
     /* 266727 */   GIM_Try, /*On fail goto*//*Label 5378*/ GIMT_Encode4(266756), // Rule ID 5016 //
     /* 266732 */     // MIs[0] Operand 1
     /* 266732 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 266737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266745 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 266745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32),
     /* 266748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266752 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 266754 */     GIR_RootConstrainSelectedInstOperands,
     /* 266755 */     // GIR_Coverage, 5016,
     /* 266755 */     GIR_EraseRootFromParent_Done,
     /* 266756 */   // Label 5378: @266756
     /* 266756 */   GIM_Try, /*On fail goto*//*Label 5379*/ GIMT_Encode4(266785), // Rule ID 5023 //
     /* 266761 */     // MIs[0] Operand 1
     /* 266761 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 266766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266774 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 266774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32),
     /* 266777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266779 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266781 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 266783 */     GIR_RootConstrainSelectedInstOperands,
     /* 266784 */     // GIR_Coverage, 5023,
     /* 266784 */     GIR_EraseRootFromParent_Done,
     /* 266785 */   // Label 5379: @266785
     /* 266785 */   GIM_Try, /*On fail goto*//*Label 5380*/ GIMT_Encode4(266814), // Rule ID 5030 //
     /* 266790 */     // MIs[0] Operand 1
     /* 266790 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 266795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266803 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 266803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32),
     /* 266806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266810 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 266812 */     GIR_RootConstrainSelectedInstOperands,
     /* 266813 */     // GIR_Coverage, 5030,
     /* 266813 */     GIR_EraseRootFromParent_Done,
     /* 266814 */   // Label 5380: @266814
     /* 266814 */   GIM_Try, /*On fail goto*//*Label 5381*/ GIMT_Encode4(266843), // Rule ID 5037 //
     /* 266819 */     // MIs[0] Operand 1
     /* 266819 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 266824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266832 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 266832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i32),
     /* 266835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266839 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 266841 */     GIR_RootConstrainSelectedInstOperands,
     /* 266842 */     // GIR_Coverage, 5037,
     /* 266842 */     GIR_EraseRootFromParent_Done,
     /* 266843 */   // Label 5381: @266843
     /* 266843 */   GIM_Try, /*On fail goto*//*Label 5382*/ GIMT_Encode4(266872), // Rule ID 5044 //
     /* 266848 */     // MIs[0] Operand 1
     /* 266848 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 266853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266861 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 266861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i32),
     /* 266864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266868 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 266870 */     GIR_RootConstrainSelectedInstOperands,
     /* 266871 */     // GIR_Coverage, 5044,
     /* 266871 */     GIR_EraseRootFromParent_Done,
     /* 266872 */   // Label 5382: @266872
     /* 266872 */   GIM_Try, /*On fail goto*//*Label 5383*/ GIMT_Encode4(266901), // Rule ID 5051 //
     /* 266877 */     // MIs[0] Operand 1
     /* 266877 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 266882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266890 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 266890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32),
     /* 266893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266895 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 266897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266899 */     GIR_RootConstrainSelectedInstOperands,
     /* 266900 */     // GIR_Coverage, 5051,
     /* 266900 */     GIR_EraseRootFromParent_Done,
     /* 266901 */   // Label 5383: @266901
     /* 266901 */   GIM_Try, /*On fail goto*//*Label 5384*/ GIMT_Encode4(266930), // Rule ID 5058 //
     /* 266906 */     // MIs[0] Operand 1
     /* 266906 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 266911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266919 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 266919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32),
     /* 266922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266924 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 266926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266928 */     GIR_RootConstrainSelectedInstOperands,
     /* 266929 */     // GIR_Coverage, 5058,
     /* 266929 */     GIR_EraseRootFromParent_Done,
     /* 266930 */   // Label 5384: @266930
     /* 266930 */   GIM_Try, /*On fail goto*//*Label 5385*/ GIMT_Encode4(266959), // Rule ID 5065 //
     /* 266935 */     // MIs[0] Operand 1
     /* 266935 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 266940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266948 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 266948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i32),
     /* 266951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266953 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 266955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266957 */     GIR_RootConstrainSelectedInstOperands,
     /* 266958 */     // GIR_Coverage, 5065,
     /* 266958 */     GIR_EraseRootFromParent_Done,
     /* 266959 */   // Label 5385: @266959
     /* 266959 */   GIM_Try, /*On fail goto*//*Label 5386*/ GIMT_Encode4(266988), // Rule ID 5072 //
     /* 266964 */     // MIs[0] Operand 1
     /* 266964 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 266969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266977 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 266977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i32),
     /* 266980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 266984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266986 */     GIR_RootConstrainSelectedInstOperands,
     /* 266987 */     // GIR_Coverage, 5072,
     /* 266987 */     GIR_EraseRootFromParent_Done,
     /* 266988 */   // Label 5386: @266988
     /* 266988 */   GIM_Reject,
     /* 266989 */ // Label 5367: @266989
     /* 266989 */ GIM_Reject,
     /* 266990 */ // Label 5303: @266990
     /* 266990 */ GIM_Try, /*On fail goto*//*Label 5387*/ GIMT_Encode4(267637),
     /* 266995 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 266998 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 267001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267005 */   GIM_Try, /*On fail goto*//*Label 5388*/ GIMT_Encode4(267042), // Rule ID 5109 //
     /* 267010 */     // MIs[0] Operand 1
     /* 267010 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 267015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 267019 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267025 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267033 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 267033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8rz),
     /* 267036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267038 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 267040 */     GIR_RootConstrainSelectedInstOperands,
     /* 267041 */     // GIR_Coverage, 5109,
     /* 267041 */     GIR_EraseRootFromParent_Done,
     /* 267042 */   // Label 5388: @267042
     /* 267042 */   GIM_Try, /*On fail goto*//*Label 5389*/ GIMT_Encode4(267079), // Rule ID 5116 //
     /* 267047 */     // MIs[0] Operand 1
     /* 267047 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 267052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 267056 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267062 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267068 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267070 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 267070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 267073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267075 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 267077 */     GIR_RootConstrainSelectedInstOperands,
     /* 267078 */     // GIR_Coverage, 5116,
     /* 267078 */     GIR_EraseRootFromParent_Done,
     /* 267079 */   // Label 5389: @267079
     /* 267079 */   GIM_Try, /*On fail goto*//*Label 5390*/ GIMT_Encode4(267116), // Rule ID 5123 //
     /* 267084 */     // MIs[0] Operand 1
     /* 267084 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 267089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 267093 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267099 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267105 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267107 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 267107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i8rz),
     /* 267110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267112 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 267114 */     GIR_RootConstrainSelectedInstOperands,
     /* 267115 */     // GIR_Coverage, 5123,
     /* 267115 */     GIR_EraseRootFromParent_Done,
     /* 267116 */   // Label 5390: @267116
     /* 267116 */   GIM_Try, /*On fail goto*//*Label 5391*/ GIMT_Encode4(267153), // Rule ID 5130 //
     /* 267121 */     // MIs[0] Operand 1
     /* 267121 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 267126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 267130 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267136 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267144 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 267144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8rz),
     /* 267147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267149 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 267151 */     GIR_RootConstrainSelectedInstOperands,
     /* 267152 */     // GIR_Coverage, 5130,
     /* 267152 */     GIR_EraseRootFromParent_Done,
     /* 267153 */   // Label 5391: @267153
     /* 267153 */   GIM_Try, /*On fail goto*//*Label 5392*/ GIMT_Encode4(267190), // Rule ID 5137 //
     /* 267158 */     // MIs[0] Operand 1
     /* 267158 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 267163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 267167 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267173 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267181 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 267181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 267184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267186 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 267188 */     GIR_RootConstrainSelectedInstOperands,
     /* 267189 */     // GIR_Coverage, 5137,
     /* 267189 */     GIR_EraseRootFromParent_Done,
     /* 267190 */   // Label 5392: @267190
     /* 267190 */   GIM_Try, /*On fail goto*//*Label 5393*/ GIMT_Encode4(267227), // Rule ID 5074 //
     /* 267195 */     // MIs[0] Operand 1
     /* 267195 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 267200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 267208 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267214 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267216 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267218 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 267218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8rz),
     /* 267221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267223 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267225 */     GIR_RootConstrainSelectedInstOperands,
     /* 267226 */     // GIR_Coverage, 5074,
     /* 267226 */     GIR_EraseRootFromParent_Done,
     /* 267227 */   // Label 5393: @267227
     /* 267227 */   GIM_Try, /*On fail goto*//*Label 5394*/ GIMT_Encode4(267264), // Rule ID 5081 //
     /* 267232 */     // MIs[0] Operand 1
     /* 267232 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 267237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 267245 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267251 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267255 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGT:{ *:[Other] })  =>  (CMGTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 267255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8rz),
     /* 267258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267262 */     GIR_RootConstrainSelectedInstOperands,
     /* 267263 */     // GIR_Coverage, 5081,
     /* 267263 */     GIR_EraseRootFromParent_Done,
     /* 267264 */   // Label 5394: @267264
     /* 267264 */   GIM_Try, /*On fail goto*//*Label 5395*/ GIMT_Encode4(267301), // Rule ID 5088 //
     /* 267269 */     // MIs[0] Operand 1
     /* 267269 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 267274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 267282 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267288 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267290 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267292 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGE:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 267292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 267295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267299 */     GIR_RootConstrainSelectedInstOperands,
     /* 267300 */     // GIR_Coverage, 5088,
     /* 267300 */     GIR_EraseRootFromParent_Done,
     /* 267301 */   // Label 5395: @267301
     /* 267301 */   GIM_Try, /*On fail goto*//*Label 5396*/ GIMT_Encode4(267338), // Rule ID 5095 //
     /* 267306 */     // MIs[0] Operand 1
     /* 267306 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 267311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 267319 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267325 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267329 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETLT:{ *:[Other] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 267329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 267332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267336 */     GIR_RootConstrainSelectedInstOperands,
     /* 267337 */     // GIR_Coverage, 5095,
     /* 267337 */     GIR_EraseRootFromParent_Done,
     /* 267338 */   // Label 5396: @267338
     /* 267338 */   GIM_Try, /*On fail goto*//*Label 5397*/ GIMT_Encode4(267375), // Rule ID 5102 //
     /* 267343 */     // MIs[0] Operand 1
     /* 267343 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 267348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 267356 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267362 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267364 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267366 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETLE:{ *:[Other] })  =>  (CMLEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 267366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i8rz),
     /* 267369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267373 */     GIR_RootConstrainSelectedInstOperands,
     /* 267374 */     // GIR_Coverage, 5102,
     /* 267374 */     GIR_EraseRootFromParent_Done,
     /* 267375 */   // Label 5397: @267375
     /* 267375 */   GIM_Try, /*On fail goto*//*Label 5398*/ GIMT_Encode4(267404), // Rule ID 5011 //
     /* 267380 */     // MIs[0] Operand 1
     /* 267380 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 267385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267393 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 267393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8),
     /* 267396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267398 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267400 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 267402 */     GIR_RootConstrainSelectedInstOperands,
     /* 267403 */     // GIR_Coverage, 5011,
     /* 267403 */     GIR_EraseRootFromParent_Done,
     /* 267404 */   // Label 5398: @267404
     /* 267404 */   GIM_Try, /*On fail goto*//*Label 5399*/ GIMT_Encode4(267433), // Rule ID 5018 //
     /* 267409 */     // MIs[0] Operand 1
     /* 267409 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 267414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267422 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 267422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8),
     /* 267425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267427 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267429 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 267431 */     GIR_RootConstrainSelectedInstOperands,
     /* 267432 */     // GIR_Coverage, 5018,
     /* 267432 */     GIR_EraseRootFromParent_Done,
     /* 267433 */   // Label 5399: @267433
     /* 267433 */   GIM_Try, /*On fail goto*//*Label 5400*/ GIMT_Encode4(267462), // Rule ID 5025 //
     /* 267438 */     // MIs[0] Operand 1
     /* 267438 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 267443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267451 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 267451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8),
     /* 267454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267458 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 267460 */     GIR_RootConstrainSelectedInstOperands,
     /* 267461 */     // GIR_Coverage, 5025,
     /* 267461 */     GIR_EraseRootFromParent_Done,
     /* 267462 */   // Label 5400: @267462
     /* 267462 */   GIM_Try, /*On fail goto*//*Label 5401*/ GIMT_Encode4(267491), // Rule ID 5032 //
     /* 267467 */     // MIs[0] Operand 1
     /* 267467 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 267472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267480 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 267480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i8),
     /* 267483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267487 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 267489 */     GIR_RootConstrainSelectedInstOperands,
     /* 267490 */     // GIR_Coverage, 5032,
     /* 267490 */     GIR_EraseRootFromParent_Done,
     /* 267491 */   // Label 5401: @267491
     /* 267491 */   GIM_Try, /*On fail goto*//*Label 5402*/ GIMT_Encode4(267520), // Rule ID 5039 //
     /* 267496 */     // MIs[0] Operand 1
     /* 267496 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 267501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267509 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 267509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i8),
     /* 267512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267516 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 267518 */     GIR_RootConstrainSelectedInstOperands,
     /* 267519 */     // GIR_Coverage, 5039,
     /* 267519 */     GIR_EraseRootFromParent_Done,
     /* 267520 */   // Label 5402: @267520
     /* 267520 */   GIM_Try, /*On fail goto*//*Label 5403*/ GIMT_Encode4(267549), // Rule ID 5046 //
     /* 267525 */     // MIs[0] Operand 1
     /* 267525 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 267530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267538 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 267538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8),
     /* 267541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 267545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267547 */     GIR_RootConstrainSelectedInstOperands,
     /* 267548 */     // GIR_Coverage, 5046,
     /* 267548 */     GIR_EraseRootFromParent_Done,
     /* 267549 */   // Label 5403: @267549
     /* 267549 */   GIM_Try, /*On fail goto*//*Label 5404*/ GIMT_Encode4(267578), // Rule ID 5053 //
     /* 267554 */     // MIs[0] Operand 1
     /* 267554 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 267559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267567 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 267567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8),
     /* 267570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267572 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 267574 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267576 */     GIR_RootConstrainSelectedInstOperands,
     /* 267577 */     // GIR_Coverage, 5053,
     /* 267577 */     GIR_EraseRootFromParent_Done,
     /* 267578 */   // Label 5404: @267578
     /* 267578 */   GIM_Try, /*On fail goto*//*Label 5405*/ GIMT_Encode4(267607), // Rule ID 5060 //
     /* 267583 */     // MIs[0] Operand 1
     /* 267583 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 267588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267596 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 267596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i8),
     /* 267599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267601 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 267603 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267605 */     GIR_RootConstrainSelectedInstOperands,
     /* 267606 */     // GIR_Coverage, 5060,
     /* 267606 */     GIR_EraseRootFromParent_Done,
     /* 267607 */   // Label 5405: @267607
     /* 267607 */   GIM_Try, /*On fail goto*//*Label 5406*/ GIMT_Encode4(267636), // Rule ID 5067 //
     /* 267612 */     // MIs[0] Operand 1
     /* 267612 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 267617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267625 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 267625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i8),
     /* 267628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267630 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 267632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267634 */     GIR_RootConstrainSelectedInstOperands,
     /* 267635 */     // GIR_Coverage, 5067,
     /* 267635 */     GIR_EraseRootFromParent_Done,
     /* 267636 */   // Label 5406: @267636
     /* 267636 */   GIM_Reject,
     /* 267637 */ // Label 5387: @267637
     /* 267637 */ GIM_Reject,
     /* 267638 */ // Label 5304: @267638
     /* 267638 */ GIM_Try, /*On fail goto*//*Label 5407*/ GIMT_Encode4(268285),
     /* 267643 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 267646 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 267649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267653 */   GIM_Try, /*On fail goto*//*Label 5408*/ GIMT_Encode4(267690), // Rule ID 5112 //
     /* 267658 */     // MIs[0] Operand 1
     /* 267658 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 267663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 267667 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267673 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267681 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 267681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16rz),
     /* 267684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267686 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 267688 */     GIR_RootConstrainSelectedInstOperands,
     /* 267689 */     // GIR_Coverage, 5112,
     /* 267689 */     GIR_EraseRootFromParent_Done,
     /* 267690 */   // Label 5408: @267690
     /* 267690 */   GIM_Try, /*On fail goto*//*Label 5409*/ GIMT_Encode4(267727), // Rule ID 5119 //
     /* 267695 */     // MIs[0] Operand 1
     /* 267695 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 267700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 267704 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267710 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267716 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267718 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 267718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 267721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267723 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 267725 */     GIR_RootConstrainSelectedInstOperands,
     /* 267726 */     // GIR_Coverage, 5119,
     /* 267726 */     GIR_EraseRootFromParent_Done,
     /* 267727 */   // Label 5409: @267727
     /* 267727 */   GIM_Try, /*On fail goto*//*Label 5410*/ GIMT_Encode4(267764), // Rule ID 5126 //
     /* 267732 */     // MIs[0] Operand 1
     /* 267732 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 267737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 267741 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267747 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267755 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 267755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i16rz),
     /* 267758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267760 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 267762 */     GIR_RootConstrainSelectedInstOperands,
     /* 267763 */     // GIR_Coverage, 5126,
     /* 267763 */     GIR_EraseRootFromParent_Done,
     /* 267764 */   // Label 5410: @267764
     /* 267764 */   GIM_Try, /*On fail goto*//*Label 5411*/ GIMT_Encode4(267801), // Rule ID 5133 //
     /* 267769 */     // MIs[0] Operand 1
     /* 267769 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 267774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 267778 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267784 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267790 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267792 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 267792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16rz),
     /* 267795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267797 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 267799 */     GIR_RootConstrainSelectedInstOperands,
     /* 267800 */     // GIR_Coverage, 5133,
     /* 267800 */     GIR_EraseRootFromParent_Done,
     /* 267801 */   // Label 5411: @267801
     /* 267801 */   GIM_Try, /*On fail goto*//*Label 5412*/ GIMT_Encode4(267838), // Rule ID 5140 //
     /* 267806 */     // MIs[0] Operand 1
     /* 267806 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 267811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 267815 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267821 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267829 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 267829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 267832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267834 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 267836 */     GIR_RootConstrainSelectedInstOperands,
     /* 267837 */     // GIR_Coverage, 5140,
     /* 267837 */     GIR_EraseRootFromParent_Done,
     /* 267838 */   // Label 5412: @267838
     /* 267838 */   GIM_Try, /*On fail goto*//*Label 5413*/ GIMT_Encode4(267875), // Rule ID 5077 //
     /* 267843 */     // MIs[0] Operand 1
     /* 267843 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 267848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 267856 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267862 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267864 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267866 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 267866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16rz),
     /* 267869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267873 */     GIR_RootConstrainSelectedInstOperands,
     /* 267874 */     // GIR_Coverage, 5077,
     /* 267874 */     GIR_EraseRootFromParent_Done,
     /* 267875 */   // Label 5413: @267875
     /* 267875 */   GIM_Try, /*On fail goto*//*Label 5414*/ GIMT_Encode4(267912), // Rule ID 5084 //
     /* 267880 */     // MIs[0] Operand 1
     /* 267880 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 267885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 267893 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267899 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267901 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267903 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGT:{ *:[Other] })  =>  (CMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 267903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16rz),
     /* 267906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267910 */     GIR_RootConstrainSelectedInstOperands,
     /* 267911 */     // GIR_Coverage, 5084,
     /* 267911 */     GIR_EraseRootFromParent_Done,
     /* 267912 */   // Label 5414: @267912
     /* 267912 */   GIM_Try, /*On fail goto*//*Label 5415*/ GIMT_Encode4(267949), // Rule ID 5091 //
     /* 267917 */     // MIs[0] Operand 1
     /* 267917 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 267922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 267930 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267936 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267938 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267940 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGE:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 267940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 267943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267947 */     GIR_RootConstrainSelectedInstOperands,
     /* 267948 */     // GIR_Coverage, 5091,
     /* 267948 */     GIR_EraseRootFromParent_Done,
     /* 267949 */   // Label 5415: @267949
     /* 267949 */   GIM_Try, /*On fail goto*//*Label 5416*/ GIMT_Encode4(267986), // Rule ID 5098 //
     /* 267954 */     // MIs[0] Operand 1
     /* 267954 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 267959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 267967 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 267973 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 267975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267977 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETLT:{ *:[Other] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 267977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 267980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267984 */     GIR_RootConstrainSelectedInstOperands,
     /* 267985 */     // GIR_Coverage, 5098,
     /* 267985 */     GIR_EraseRootFromParent_Done,
     /* 267986 */   // Label 5416: @267986
     /* 267986 */   GIM_Try, /*On fail goto*//*Label 5417*/ GIMT_Encode4(268023), // Rule ID 5105 //
     /* 267991 */     // MIs[0] Operand 1
     /* 267991 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 267996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 268004 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 268010 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 268012 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268014 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETLE:{ *:[Other] })  =>  (CMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 268014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i16rz),
     /* 268017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268021 */     GIR_RootConstrainSelectedInstOperands,
     /* 268022 */     // GIR_Coverage, 5105,
     /* 268022 */     GIR_EraseRootFromParent_Done,
     /* 268023 */   // Label 5417: @268023
     /* 268023 */   GIM_Try, /*On fail goto*//*Label 5418*/ GIMT_Encode4(268052), // Rule ID 5014 //
     /* 268028 */     // MIs[0] Operand 1
     /* 268028 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 268033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268041 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 268041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16),
     /* 268044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268046 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268048 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268050 */     GIR_RootConstrainSelectedInstOperands,
     /* 268051 */     // GIR_Coverage, 5014,
     /* 268051 */     GIR_EraseRootFromParent_Done,
     /* 268052 */   // Label 5418: @268052
     /* 268052 */   GIM_Try, /*On fail goto*//*Label 5419*/ GIMT_Encode4(268081), // Rule ID 5021 //
     /* 268057 */     // MIs[0] Operand 1
     /* 268057 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 268062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268070 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 268070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16),
     /* 268073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268077 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268079 */     GIR_RootConstrainSelectedInstOperands,
     /* 268080 */     // GIR_Coverage, 5021,
     /* 268080 */     GIR_EraseRootFromParent_Done,
     /* 268081 */   // Label 5419: @268081
     /* 268081 */   GIM_Try, /*On fail goto*//*Label 5420*/ GIMT_Encode4(268110), // Rule ID 5028 //
     /* 268086 */     // MIs[0] Operand 1
     /* 268086 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 268091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268099 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 268099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16),
     /* 268102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268104 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268106 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268108 */     GIR_RootConstrainSelectedInstOperands,
     /* 268109 */     // GIR_Coverage, 5028,
     /* 268109 */     GIR_EraseRootFromParent_Done,
     /* 268110 */   // Label 5420: @268110
     /* 268110 */   GIM_Try, /*On fail goto*//*Label 5421*/ GIMT_Encode4(268139), // Rule ID 5035 //
     /* 268115 */     // MIs[0] Operand 1
     /* 268115 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 268120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268128 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 268128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i16),
     /* 268131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268135 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268137 */     GIR_RootConstrainSelectedInstOperands,
     /* 268138 */     // GIR_Coverage, 5035,
     /* 268138 */     GIR_EraseRootFromParent_Done,
     /* 268139 */   // Label 5421: @268139
     /* 268139 */   GIM_Try, /*On fail goto*//*Label 5422*/ GIMT_Encode4(268168), // Rule ID 5042 //
     /* 268144 */     // MIs[0] Operand 1
     /* 268144 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 268149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268157 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 268157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i16),
     /* 268160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268162 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268164 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268166 */     GIR_RootConstrainSelectedInstOperands,
     /* 268167 */     // GIR_Coverage, 5042,
     /* 268167 */     GIR_EraseRootFromParent_Done,
     /* 268168 */   // Label 5422: @268168
     /* 268168 */   GIM_Try, /*On fail goto*//*Label 5423*/ GIMT_Encode4(268197), // Rule ID 5049 //
     /* 268173 */     // MIs[0] Operand 1
     /* 268173 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 268178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268186 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 268186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16),
     /* 268189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268191 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268195 */     GIR_RootConstrainSelectedInstOperands,
     /* 268196 */     // GIR_Coverage, 5049,
     /* 268196 */     GIR_EraseRootFromParent_Done,
     /* 268197 */   // Label 5423: @268197
     /* 268197 */   GIM_Try, /*On fail goto*//*Label 5424*/ GIMT_Encode4(268226), // Rule ID 5056 //
     /* 268202 */     // MIs[0] Operand 1
     /* 268202 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 268207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268215 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 268215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16),
     /* 268218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268220 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268224 */     GIR_RootConstrainSelectedInstOperands,
     /* 268225 */     // GIR_Coverage, 5056,
     /* 268225 */     GIR_EraseRootFromParent_Done,
     /* 268226 */   // Label 5424: @268226
     /* 268226 */   GIM_Try, /*On fail goto*//*Label 5425*/ GIMT_Encode4(268255), // Rule ID 5063 //
     /* 268231 */     // MIs[0] Operand 1
     /* 268231 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 268236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268244 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 268244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i16),
     /* 268247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268253 */     GIR_RootConstrainSelectedInstOperands,
     /* 268254 */     // GIR_Coverage, 5063,
     /* 268254 */     GIR_EraseRootFromParent_Done,
     /* 268255 */   // Label 5425: @268255
     /* 268255 */   GIM_Try, /*On fail goto*//*Label 5426*/ GIMT_Encode4(268284), // Rule ID 5070 //
     /* 268260 */     // MIs[0] Operand 1
     /* 268260 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 268265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268273 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 268273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i16),
     /* 268276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268282 */     GIR_RootConstrainSelectedInstOperands,
     /* 268283 */     // GIR_Coverage, 5070,
     /* 268283 */     GIR_EraseRootFromParent_Done,
     /* 268284 */   // Label 5426: @268284
     /* 268284 */   GIM_Reject,
     /* 268285 */ // Label 5407: @268285
     /* 268285 */ GIM_Reject,
     /* 268286 */ // Label 5305: @268286
     /* 268286 */ GIM_Try, /*On fail goto*//*Label 5427*/ GIMT_Encode4(268933),
     /* 268291 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 268294 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 268297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268301 */   GIM_Try, /*On fail goto*//*Label 5428*/ GIMT_Encode4(268338), // Rule ID 5110 //
     /* 268306 */     // MIs[0] Operand 1
     /* 268306 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 268311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 268315 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 268321 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 268323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268329 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 268329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8rz),
     /* 268332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268334 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 268336 */     GIR_RootConstrainSelectedInstOperands,
     /* 268337 */     // GIR_Coverage, 5110,
     /* 268337 */     GIR_EraseRootFromParent_Done,
     /* 268338 */   // Label 5428: @268338
     /* 268338 */   GIM_Try, /*On fail goto*//*Label 5429*/ GIMT_Encode4(268375), // Rule ID 5117 //
     /* 268343 */     // MIs[0] Operand 1
     /* 268343 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 268348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 268352 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 268358 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 268360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268364 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268366 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 268366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 268369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268371 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 268373 */     GIR_RootConstrainSelectedInstOperands,
     /* 268374 */     // GIR_Coverage, 5117,
     /* 268374 */     GIR_EraseRootFromParent_Done,
     /* 268375 */   // Label 5429: @268375
     /* 268375 */   GIM_Try, /*On fail goto*//*Label 5430*/ GIMT_Encode4(268412), // Rule ID 5124 //
     /* 268380 */     // MIs[0] Operand 1
     /* 268380 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 268385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 268389 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 268395 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 268397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268403 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 268403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv16i8rz),
     /* 268406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268408 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 268410 */     GIR_RootConstrainSelectedInstOperands,
     /* 268411 */     // GIR_Coverage, 5124,
     /* 268411 */     GIR_EraseRootFromParent_Done,
     /* 268412 */   // Label 5430: @268412
     /* 268412 */   GIM_Try, /*On fail goto*//*Label 5431*/ GIMT_Encode4(268449), // Rule ID 5131 //
     /* 268417 */     // MIs[0] Operand 1
     /* 268417 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 268422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 268426 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 268432 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 268434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268440 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 268440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8rz),
     /* 268443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268445 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 268447 */     GIR_RootConstrainSelectedInstOperands,
     /* 268448 */     // GIR_Coverage, 5131,
     /* 268448 */     GIR_EraseRootFromParent_Done,
     /* 268449 */   // Label 5431: @268449
     /* 268449 */   GIM_Try, /*On fail goto*//*Label 5432*/ GIMT_Encode4(268486), // Rule ID 5138 //
     /* 268454 */     // MIs[0] Operand 1
     /* 268454 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 268459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 268463 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 268469 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 268471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268477 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 268477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 268480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268482 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 268484 */     GIR_RootConstrainSelectedInstOperands,
     /* 268485 */     // GIR_Coverage, 5138,
     /* 268485 */     GIR_EraseRootFromParent_Done,
     /* 268486 */   // Label 5432: @268486
     /* 268486 */   GIM_Try, /*On fail goto*//*Label 5433*/ GIMT_Encode4(268523), // Rule ID 5075 //
     /* 268491 */     // MIs[0] Operand 1
     /* 268491 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 268496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 268504 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 268510 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 268512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268514 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 268514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8rz),
     /* 268517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268519 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268521 */     GIR_RootConstrainSelectedInstOperands,
     /* 268522 */     // GIR_Coverage, 5075,
     /* 268522 */     GIR_EraseRootFromParent_Done,
     /* 268523 */   // Label 5433: @268523
     /* 268523 */   GIM_Try, /*On fail goto*//*Label 5434*/ GIMT_Encode4(268560), // Rule ID 5082 //
     /* 268528 */     // MIs[0] Operand 1
     /* 268528 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 268533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 268541 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 268547 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 268549 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268551 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGT:{ *:[Other] })  =>  (CMGTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 268551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8rz),
     /* 268554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268558 */     GIR_RootConstrainSelectedInstOperands,
     /* 268559 */     // GIR_Coverage, 5082,
     /* 268559 */     GIR_EraseRootFromParent_Done,
     /* 268560 */   // Label 5434: @268560
     /* 268560 */   GIM_Try, /*On fail goto*//*Label 5435*/ GIMT_Encode4(268597), // Rule ID 5089 //
     /* 268565 */     // MIs[0] Operand 1
     /* 268565 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 268570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 268578 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 268584 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 268586 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268588 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGE:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 268588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 268591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268595 */     GIR_RootConstrainSelectedInstOperands,
     /* 268596 */     // GIR_Coverage, 5089,
     /* 268596 */     GIR_EraseRootFromParent_Done,
     /* 268597 */   // Label 5435: @268597
     /* 268597 */   GIM_Try, /*On fail goto*//*Label 5436*/ GIMT_Encode4(268634), // Rule ID 5096 //
     /* 268602 */     // MIs[0] Operand 1
     /* 268602 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 268607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 268615 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 268621 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 268623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268625 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETLT:{ *:[Other] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 268625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 268628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268632 */     GIR_RootConstrainSelectedInstOperands,
     /* 268633 */     // GIR_Coverage, 5096,
     /* 268633 */     GIR_EraseRootFromParent_Done,
     /* 268634 */   // Label 5436: @268634
     /* 268634 */   GIM_Try, /*On fail goto*//*Label 5437*/ GIMT_Encode4(268671), // Rule ID 5103 //
     /* 268639 */     // MIs[0] Operand 1
     /* 268639 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 268644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 268652 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 268658 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 268660 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268662 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETLE:{ *:[Other] })  =>  (CMLEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 268662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv16i8rz),
     /* 268665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268669 */     GIR_RootConstrainSelectedInstOperands,
     /* 268670 */     // GIR_Coverage, 5103,
     /* 268670 */     GIR_EraseRootFromParent_Done,
     /* 268671 */   // Label 5437: @268671
     /* 268671 */   GIM_Try, /*On fail goto*//*Label 5438*/ GIMT_Encode4(268700), // Rule ID 5012 //
     /* 268676 */     // MIs[0] Operand 1
     /* 268676 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 268681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268689 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 268689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8),
     /* 268692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268696 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268698 */     GIR_RootConstrainSelectedInstOperands,
     /* 268699 */     // GIR_Coverage, 5012,
     /* 268699 */     GIR_EraseRootFromParent_Done,
     /* 268700 */   // Label 5438: @268700
     /* 268700 */   GIM_Try, /*On fail goto*//*Label 5439*/ GIMT_Encode4(268729), // Rule ID 5019 //
     /* 268705 */     // MIs[0] Operand 1
     /* 268705 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 268710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268718 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 268718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8),
     /* 268721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268725 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268727 */     GIR_RootConstrainSelectedInstOperands,
     /* 268728 */     // GIR_Coverage, 5019,
     /* 268728 */     GIR_EraseRootFromParent_Done,
     /* 268729 */   // Label 5439: @268729
     /* 268729 */   GIM_Try, /*On fail goto*//*Label 5440*/ GIMT_Encode4(268758), // Rule ID 5026 //
     /* 268734 */     // MIs[0] Operand 1
     /* 268734 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 268739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268747 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 268747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8),
     /* 268750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268754 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268756 */     GIR_RootConstrainSelectedInstOperands,
     /* 268757 */     // GIR_Coverage, 5026,
     /* 268757 */     GIR_EraseRootFromParent_Done,
     /* 268758 */   // Label 5440: @268758
     /* 268758 */   GIM_Try, /*On fail goto*//*Label 5441*/ GIMT_Encode4(268787), // Rule ID 5033 //
     /* 268763 */     // MIs[0] Operand 1
     /* 268763 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 268768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268776 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 268776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv16i8),
     /* 268779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268785 */     GIR_RootConstrainSelectedInstOperands,
     /* 268786 */     // GIR_Coverage, 5033,
     /* 268786 */     GIR_EraseRootFromParent_Done,
     /* 268787 */   // Label 5441: @268787
     /* 268787 */   GIM_Try, /*On fail goto*//*Label 5442*/ GIMT_Encode4(268816), // Rule ID 5040 //
     /* 268792 */     // MIs[0] Operand 1
     /* 268792 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 268797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268805 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 268805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv16i8),
     /* 268808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268812 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268814 */     GIR_RootConstrainSelectedInstOperands,
     /* 268815 */     // GIR_Coverage, 5040,
     /* 268815 */     GIR_EraseRootFromParent_Done,
     /* 268816 */   // Label 5442: @268816
     /* 268816 */   GIM_Try, /*On fail goto*//*Label 5443*/ GIMT_Encode4(268845), // Rule ID 5047 //
     /* 268821 */     // MIs[0] Operand 1
     /* 268821 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 268826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268834 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 268834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8),
     /* 268837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268839 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268843 */     GIR_RootConstrainSelectedInstOperands,
     /* 268844 */     // GIR_Coverage, 5047,
     /* 268844 */     GIR_EraseRootFromParent_Done,
     /* 268845 */   // Label 5443: @268845
     /* 268845 */   GIM_Try, /*On fail goto*//*Label 5444*/ GIMT_Encode4(268874), // Rule ID 5054 //
     /* 268850 */     // MIs[0] Operand 1
     /* 268850 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 268855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268863 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 268863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8),
     /* 268866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268868 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268872 */     GIR_RootConstrainSelectedInstOperands,
     /* 268873 */     // GIR_Coverage, 5054,
     /* 268873 */     GIR_EraseRootFromParent_Done,
     /* 268874 */   // Label 5444: @268874
     /* 268874 */   GIM_Try, /*On fail goto*//*Label 5445*/ GIMT_Encode4(268903), // Rule ID 5061 //
     /* 268879 */     // MIs[0] Operand 1
     /* 268879 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 268884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268892 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 268892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv16i8),
     /* 268895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268897 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268899 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268901 */     GIR_RootConstrainSelectedInstOperands,
     /* 268902 */     // GIR_Coverage, 5061,
     /* 268902 */     GIR_EraseRootFromParent_Done,
     /* 268903 */   // Label 5445: @268903
     /* 268903 */   GIM_Try, /*On fail goto*//*Label 5446*/ GIMT_Encode4(268932), // Rule ID 5068 //
     /* 268908 */     // MIs[0] Operand 1
     /* 268908 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 268913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268921 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 268921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv16i8),
     /* 268924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268926 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 268928 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 268930 */     GIR_RootConstrainSelectedInstOperands,
     /* 268931 */     // GIR_Coverage, 5068,
     /* 268931 */     GIR_EraseRootFromParent_Done,
     /* 268932 */   // Label 5446: @268932
     /* 268932 */   GIM_Reject,
     /* 268933 */ // Label 5427: @268933
     /* 268933 */ GIM_Reject,
     /* 268934 */ // Label 5306: @268934
     /* 268934 */ GIM_Reject,
     /* 268935 */ // Label 47: @268935
     /* 268935 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(12), GIMT_Encode2(24), /*)*//*default:*//*Label 5459*/ GIMT_Encode4(269640),
     /* 268946 */ /*GILLT_nxv1s1*//*Label 5447*/ GIMT_Encode4(268994),
     /* 268950 */ /*GILLT_nxv2s1*//*Label 5448*/ GIMT_Encode4(269023),
     /* 268954 */ /*GILLT_nxv2s16*//*Label 5449*/ GIMT_Encode4(269052),
     /* 268958 */ /*GILLT_nxv2s32*//*Label 5450*/ GIMT_Encode4(269081),
     /* 268962 */ /*GILLT_nxv2s64*//*Label 5451*/ GIMT_Encode4(269110),
     /* 268966 */ /*GILLT_nxv4s1*//*Label 5452*/ GIMT_Encode4(269219),
     /* 268970 */ /*GILLT_nxv4s16*//*Label 5453*/ GIMT_Encode4(269248),
     /* 268974 */ /*GILLT_nxv4s32*//*Label 5454*/ GIMT_Encode4(269277),
     /* 268978 */ /*GILLT_nxv8s1*//*Label 5455*/ GIMT_Encode4(269386),
     /* 268982 */ /*GILLT_nxv8s16*//*Label 5456*/ GIMT_Encode4(269415),
     /* 268986 */ /*GILLT_nxv16s1*//*Label 5457*/ GIMT_Encode4(269524),
     /* 268990 */ /*GILLT_nxv16s8*//*Label 5458*/ GIMT_Encode4(269553),
     /* 268994 */ // Label 5447: @268994
     /* 268994 */ GIM_Try, /*On fail goto*//*Label 5460*/ GIMT_Encode4(269022), // Rule ID 8295 //
     /* 268999 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /* 269005 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 269008 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 269011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 269015 */   // (vselect:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 269015 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 269020 */   GIR_RootConstrainSelectedInstOperands,
     /* 269021 */   // GIR_Coverage, 8295,
     /* 269021 */   GIR_Done,
     /* 269022 */ // Label 5460: @269022
     /* 269022 */ GIM_Reject,
     /* 269023 */ // Label 5448: @269023
     /* 269023 */ GIM_Try, /*On fail goto*//*Label 5461*/ GIMT_Encode4(269051), // Rule ID 8294 //
     /* 269028 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269031 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 269034 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 269037 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 269040 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 269044 */   // (vselect:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 269044 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 269049 */   GIR_RootConstrainSelectedInstOperands,
     /* 269050 */   // GIR_Coverage, 8294,
     /* 269050 */   GIR_Done,
     /* 269051 */ // Label 5461: @269051
     /* 269051 */ GIM_Reject,
     /* 269052 */ // Label 5449: @269052
     /* 269052 */ GIM_Try, /*On fail goto*//*Label 5462*/ GIMT_Encode4(269080), // Rule ID 2727 //
     /* 269057 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269060 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 269063 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 269066 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 269069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 269073 */   // (vselect:{ *:[nxv2f16] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 269073 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 269078 */   GIR_RootConstrainSelectedInstOperands,
     /* 269079 */   // GIR_Coverage, 2727,
     /* 269079 */   GIR_Done,
     /* 269080 */ // Label 5462: @269080
     /* 269080 */ GIM_Reject,
     /* 269081 */ // Label 5450: @269081
     /* 269081 */ GIM_Try, /*On fail goto*//*Label 5463*/ GIMT_Encode4(269109), // Rule ID 2728 //
     /* 269086 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 269092 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 269095 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 269098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 269102 */   // (vselect:{ *:[nxv2f32] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 269102 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 269107 */   GIR_RootConstrainSelectedInstOperands,
     /* 269108 */   // GIR_Coverage, 2728,
     /* 269108 */   GIR_Done,
     /* 269109 */ // Label 5463: @269109
     /* 269109 */ GIM_Reject,
     /* 269110 */ // Label 5451: @269110
     /* 269110 */ GIM_Try, /*On fail goto*//*Label 5464*/ GIMT_Encode4(269218),
     /* 269115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 269118 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 269121 */   GIM_Try, /*On fail goto*//*Label 5465*/ GIMT_Encode4(269173), // Rule ID 7345 //
     /* 269126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 269133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 269141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 269145 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 269149 */     // MIs[0] Op2
     /* 269149 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 269154 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269156 */     // (vselect:{ *:[nxv2i64] } nxv2i1:{ *:[nxv2i1] }:$Op1, (sub:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 269156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_D),
     /* 269159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 269161 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 269163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 269167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 269171 */     GIR_RootConstrainSelectedInstOperands,
     /* 269172 */     // GIR_Coverage, 7345,
     /* 269172 */     GIR_EraseRootFromParent_Done,
     /* 269173 */   // Label 5465: @269173
     /* 269173 */   GIM_Try, /*On fail goto*//*Label 5466*/ GIMT_Encode4(269195), // Rule ID 2723 //
     /* 269178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 269184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 269188 */     // (vselect:{ *:[nxv2i64] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 269188 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 269193 */     GIR_RootConstrainSelectedInstOperands,
     /* 269194 */     // GIR_Coverage, 2723,
     /* 269194 */     GIR_Done,
     /* 269195 */   // Label 5466: @269195
     /* 269195 */   GIM_Try, /*On fail goto*//*Label 5467*/ GIMT_Encode4(269217), // Rule ID 2729 //
     /* 269200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 269206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 269210 */     // (vselect:{ *:[nxv2f64] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 269210 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 269215 */     GIR_RootConstrainSelectedInstOperands,
     /* 269216 */     // GIR_Coverage, 2729,
     /* 269216 */     GIR_Done,
     /* 269217 */   // Label 5467: @269217
     /* 269217 */   GIM_Reject,
     /* 269218 */ // Label 5464: @269218
     /* 269218 */ GIM_Reject,
     /* 269219 */ // Label 5452: @269219
     /* 269219 */ GIM_Try, /*On fail goto*//*Label 5468*/ GIMT_Encode4(269247), // Rule ID 8293 //
     /* 269224 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 269230 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 269233 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 269236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 269240 */   // (vselect:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 269240 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 269245 */   GIR_RootConstrainSelectedInstOperands,
     /* 269246 */   // GIR_Coverage, 8293,
     /* 269246 */   GIR_Done,
     /* 269247 */ // Label 5468: @269247
     /* 269247 */ GIM_Reject,
     /* 269248 */ // Label 5453: @269248
     /* 269248 */ GIM_Try, /*On fail goto*//*Label 5469*/ GIMT_Encode4(269276), // Rule ID 2725 //
     /* 269253 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269256 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 269259 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 269262 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 269265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 269269 */   // (vselect:{ *:[nxv4f16] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 269269 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
     /* 269274 */   GIR_RootConstrainSelectedInstOperands,
     /* 269275 */   // GIR_Coverage, 2725,
     /* 269275 */   GIR_Done,
     /* 269276 */ // Label 5469: @269276
     /* 269276 */ GIM_Reject,
     /* 269277 */ // Label 5454: @269277
     /* 269277 */ GIM_Try, /*On fail goto*//*Label 5470*/ GIMT_Encode4(269385),
     /* 269282 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 269285 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 269288 */   GIM_Try, /*On fail goto*//*Label 5471*/ GIMT_Encode4(269340), // Rule ID 7343 //
     /* 269293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 269300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 269308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 269312 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 269316 */     // MIs[0] Op2
     /* 269316 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 269321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269323 */     // (vselect:{ *:[nxv4i32] } nxv4i1:{ *:[nxv4i1] }:$Op1, (sub:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 269323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_S),
     /* 269326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 269328 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 269330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 269334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 269338 */     GIR_RootConstrainSelectedInstOperands,
     /* 269339 */     // GIR_Coverage, 7343,
     /* 269339 */     GIR_EraseRootFromParent_Done,
     /* 269340 */   // Label 5471: @269340
     /* 269340 */   GIM_Try, /*On fail goto*//*Label 5472*/ GIMT_Encode4(269362), // Rule ID 2722 //
     /* 269345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 269351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 269355 */     // (vselect:{ *:[nxv4i32] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 269355 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
     /* 269360 */     GIR_RootConstrainSelectedInstOperands,
     /* 269361 */     // GIR_Coverage, 2722,
     /* 269361 */     GIR_Done,
     /* 269362 */   // Label 5472: @269362
     /* 269362 */   GIM_Try, /*On fail goto*//*Label 5473*/ GIMT_Encode4(269384), // Rule ID 2726 //
     /* 269367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 269373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 269377 */     // (vselect:{ *:[nxv4f32] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 269377 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
     /* 269382 */     GIR_RootConstrainSelectedInstOperands,
     /* 269383 */     // GIR_Coverage, 2726,
     /* 269383 */     GIR_Done,
     /* 269384 */   // Label 5473: @269384
     /* 269384 */   GIM_Reject,
     /* 269385 */ // Label 5470: @269385
     /* 269385 */ GIM_Reject,
     /* 269386 */ // Label 5455: @269386
     /* 269386 */ GIM_Try, /*On fail goto*//*Label 5474*/ GIMT_Encode4(269414), // Rule ID 8292 //
     /* 269391 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269394 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 269397 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 269400 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 269403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 269407 */   // (vselect:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 269407 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 269412 */   GIR_RootConstrainSelectedInstOperands,
     /* 269413 */   // GIR_Coverage, 8292,
     /* 269413 */   GIR_Done,
     /* 269414 */ // Label 5474: @269414
     /* 269414 */ GIM_Reject,
     /* 269415 */ // Label 5456: @269415
     /* 269415 */ GIM_Try, /*On fail goto*//*Label 5475*/ GIMT_Encode4(269523),
     /* 269420 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 269423 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 269426 */   GIM_Try, /*On fail goto*//*Label 5476*/ GIMT_Encode4(269478), // Rule ID 7341 //
     /* 269431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 269438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 269446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 269450 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 269454 */     // MIs[0] Op2
     /* 269454 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 269459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269461 */     // (vselect:{ *:[nxv8i16] } nxv8i1:{ *:[nxv8i1] }:$Op1, (sub:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 269461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_H),
     /* 269464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 269466 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 269468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 269472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 269476 */     GIR_RootConstrainSelectedInstOperands,
     /* 269477 */     // GIR_Coverage, 7341,
     /* 269477 */     GIR_EraseRootFromParent_Done,
     /* 269478 */   // Label 5476: @269478
     /* 269478 */   GIM_Try, /*On fail goto*//*Label 5477*/ GIMT_Encode4(269500), // Rule ID 2721 //
     /* 269483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 269489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 269493 */     // (vselect:{ *:[nxv8i16] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SEL_ZPZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 269493 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_H),
     /* 269498 */     GIR_RootConstrainSelectedInstOperands,
     /* 269499 */     // GIR_Coverage, 2721,
     /* 269499 */     GIR_Done,
     /* 269500 */   // Label 5477: @269500
     /* 269500 */   GIM_Try, /*On fail goto*//*Label 5478*/ GIMT_Encode4(269522), // Rule ID 2724 //
     /* 269505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 269511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 269515 */     // (vselect:{ *:[nxv8f16] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (SEL_ZPZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 269515 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_H),
     /* 269520 */     GIR_RootConstrainSelectedInstOperands,
     /* 269521 */     // GIR_Coverage, 2724,
     /* 269521 */     GIR_Done,
     /* 269522 */   // Label 5478: @269522
     /* 269522 */   GIM_Reject,
     /* 269523 */ // Label 5475: @269523
     /* 269523 */ GIM_Reject,
     /* 269524 */ // Label 5457: @269524
     /* 269524 */ GIM_Try, /*On fail goto*//*Label 5479*/ GIMT_Encode4(269552), // Rule ID 8291 //
     /* 269529 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269532 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 269535 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 269538 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 269541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 269545 */   // (vselect:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 269545 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 269550 */   GIR_RootConstrainSelectedInstOperands,
     /* 269551 */   // GIR_Coverage, 8291,
     /* 269551 */   GIR_Done,
     /* 269552 */ // Label 5479: @269552
     /* 269552 */ GIM_Reject,
     /* 269553 */ // Label 5458: @269553
     /* 269553 */ GIM_Try, /*On fail goto*//*Label 5480*/ GIMT_Encode4(269639),
     /* 269558 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 269561 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 269564 */   GIM_Try, /*On fail goto*//*Label 5481*/ GIMT_Encode4(269616), // Rule ID 7339 //
     /* 269569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 269576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 269584 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 269588 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 269592 */     // MIs[0] Op2
     /* 269592 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 269597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269599 */     // (vselect:{ *:[nxv16i8] } nxv16i1:{ *:[nxv16i1] }:$Op1, (sub:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 269599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_B),
     /* 269602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 269604 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 269606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 269610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 269614 */     GIR_RootConstrainSelectedInstOperands,
     /* 269615 */     // GIR_Coverage, 7339,
     /* 269615 */     GIR_EraseRootFromParent_Done,
     /* 269616 */   // Label 5481: @269616
     /* 269616 */   GIM_Try, /*On fail goto*//*Label 5482*/ GIMT_Encode4(269638), // Rule ID 2720 //
     /* 269621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 269627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 269631 */     // (vselect:{ *:[nxv16i8] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SEL_ZPZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 269631 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_B),
     /* 269636 */     GIR_RootConstrainSelectedInstOperands,
     /* 269637 */     // GIR_Coverage, 2720,
     /* 269637 */     GIR_Done,
     /* 269638 */   // Label 5482: @269638
     /* 269638 */   GIM_Reject,
     /* 269639 */ // Label 5480: @269639
     /* 269639 */ GIM_Reject,
     /* 269640 */ // Label 5459: @269640
     /* 269640 */ GIM_Reject,
     /* 269641 */ // Label 48: @269641
     /* 269641 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 5487*/ GIMT_Encode4(270124),
     /* 269652 */ /*GILLT_s64*//*Label 5483*/ GIMT_Encode4(269688), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 269672 */ /*GILLT_v4s32*//*Label 5484*/ GIMT_Encode4(269719), GIMT_Encode4(0),
     /* 269680 */ /*GILLT_v8s16*//*Label 5485*/ GIMT_Encode4(269854),
     /* 269684 */ /*GILLT_v16s8*//*Label 5486*/ GIMT_Encode4(269989),
     /* 269688 */ // Label 5483: @269688
     /* 269688 */ GIM_Try, /*On fail goto*//*Label 5488*/ GIMT_Encode4(269718), // Rule ID 128 //
     /* 269693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 269696 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 269699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269703 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269707 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269711 */   // (mulhu:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMULHrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 269711 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULHrr),
     /* 269716 */   GIR_RootConstrainSelectedInstOperands,
     /* 269717 */   // GIR_Coverage, 128,
     /* 269717 */   GIR_Done,
     /* 269718 */ // Label 5488: @269718
     /* 269718 */ GIM_Reject,
     /* 269719 */ // Label 5484: @269719
     /* 269719 */ GIM_Try, /*On fail goto*//*Label 5489*/ GIMT_Encode4(269853), // Rule ID 6437 //
     /* 269724 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 269727 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 269730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269734 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269738 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269742 */   // (mulhu:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } (UMULLv2i32_v2i64:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rm, dsub:{ *:[i32] })), (UMULLv4i32_v2i64:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))
     /* 269742 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 269745 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_v2i64),
     /* 269749 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269754 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 269758 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 269762 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 269764 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 269767 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 269771 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269776 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 269782 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269787 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269792 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 269795 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 269799 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269804 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 269810 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269815 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269820 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 269823 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_v2i64),
     /* 269827 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269832 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 269835 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 269838 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 269840 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 269843 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269845 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 269848 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 269851 */   GIR_RootConstrainSelectedInstOperands,
     /* 269852 */   // GIR_Coverage, 6437,
     /* 269852 */   GIR_EraseRootFromParent_Done,
     /* 269853 */ // Label 5489: @269853
     /* 269853 */ GIM_Reject,
     /* 269854 */ // Label 5485: @269854
     /* 269854 */ GIM_Try, /*On fail goto*//*Label 5490*/ GIMT_Encode4(269988), // Rule ID 6436 //
     /* 269859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 269862 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 269865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269869 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269873 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269877 */   // (mulhu:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } (UMULLv4i16_v4i32:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rm, dsub:{ *:[i32] })), (UMULLv8i16_v4i32:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))
     /* 269877 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 269880 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_v4i32),
     /* 269884 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269889 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 269893 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 269897 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 269899 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 269902 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 269906 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269911 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 269917 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269922 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269927 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 269930 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 269934 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269939 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 269945 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269950 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269955 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 269958 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_v4i32),
     /* 269962 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269967 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 269970 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 269973 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 269975 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 269978 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269980 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 269983 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 269986 */   GIR_RootConstrainSelectedInstOperands,
     /* 269987 */   // GIR_Coverage, 6436,
     /* 269987 */   GIR_EraseRootFromParent_Done,
     /* 269988 */ // Label 5490: @269988
     /* 269988 */ GIM_Reject,
     /* 269989 */ // Label 5486: @269989
     /* 269989 */ GIM_Try, /*On fail goto*//*Label 5491*/ GIMT_Encode4(270123), // Rule ID 6435 //
     /* 269994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 269997 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 270000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270004 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270008 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270012 */   // (mulhu:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } (UMULLv8i8_v8i16:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rm, dsub:{ *:[i32] })), (UMULLv16i8_v8i16:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))
     /* 270012 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 270015 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv16i8_v8i16),
     /* 270019 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270024 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 270028 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 270032 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 270034 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 270037 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270041 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270046 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 270052 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270057 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270062 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 270065 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270069 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270074 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 270080 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270085 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270090 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 270093 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i8_v8i16),
     /* 270097 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270102 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 270105 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 270108 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 270110 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 270113 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270115 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270118 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 270121 */   GIR_RootConstrainSelectedInstOperands,
     /* 270122 */   // GIR_Coverage, 6435,
     /* 270122 */   GIR_EraseRootFromParent_Done,
     /* 270123 */ // Label 5491: @270123
     /* 270123 */ GIM_Reject,
     /* 270124 */ // Label 5487: @270124
     /* 270124 */ GIM_Reject,
     /* 270125 */ // Label 49: @270125
     /* 270125 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 5496*/ GIMT_Encode4(270608),
     /* 270136 */ /*GILLT_s64*//*Label 5492*/ GIMT_Encode4(270172), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 270156 */ /*GILLT_v4s32*//*Label 5493*/ GIMT_Encode4(270203), GIMT_Encode4(0),
     /* 270164 */ /*GILLT_v8s16*//*Label 5494*/ GIMT_Encode4(270338),
     /* 270168 */ /*GILLT_v16s8*//*Label 5495*/ GIMT_Encode4(270473),
     /* 270172 */ // Label 5492: @270172
     /* 270172 */ GIM_Try, /*On fail goto*//*Label 5497*/ GIMT_Encode4(270202), // Rule ID 127 //
     /* 270177 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 270180 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270183 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270187 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270191 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270195 */   // (mulhs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMULHrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 270195 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULHrr),
     /* 270200 */   GIR_RootConstrainSelectedInstOperands,
     /* 270201 */   // GIR_Coverage, 127,
     /* 270201 */   GIR_Done,
     /* 270202 */ // Label 5497: @270202
     /* 270202 */ GIM_Reject,
     /* 270203 */ // Label 5493: @270203
     /* 270203 */ GIM_Try, /*On fail goto*//*Label 5498*/ GIMT_Encode4(270337), // Rule ID 6434 //
     /* 270208 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 270211 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 270214 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270218 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270222 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270226 */   // (mulhs:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } (SMULLv2i32_v2i64:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rm, dsub:{ *:[i32] })), (SMULLv4i32_v2i64:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))
     /* 270226 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 270229 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_v2i64),
     /* 270233 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270238 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 270242 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 270246 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 270248 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 270251 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270255 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270260 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 270266 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270271 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270276 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 270279 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270283 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270288 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 270294 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270299 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270304 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 270307 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_v2i64),
     /* 270311 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270316 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 270319 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 270322 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 270324 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 270327 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270329 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270332 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 270335 */   GIR_RootConstrainSelectedInstOperands,
     /* 270336 */   // GIR_Coverage, 6434,
     /* 270336 */   GIR_EraseRootFromParent_Done,
     /* 270337 */ // Label 5498: @270337
     /* 270337 */ GIM_Reject,
     /* 270338 */ // Label 5494: @270338
     /* 270338 */ GIM_Try, /*On fail goto*//*Label 5499*/ GIMT_Encode4(270472), // Rule ID 6433 //
     /* 270343 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 270346 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 270349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270353 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270357 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270361 */   // (mulhs:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } (SMULLv4i16_v4i32:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rm, dsub:{ *:[i32] })), (SMULLv8i16_v4i32:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))
     /* 270361 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 270364 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_v4i32),
     /* 270368 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270373 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 270377 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 270381 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 270383 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 270386 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270390 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270395 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 270401 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270406 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270411 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 270414 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270418 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270423 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 270429 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270434 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270439 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 270442 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_v4i32),
     /* 270446 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270451 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 270454 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 270457 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 270459 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 270462 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270464 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270467 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 270470 */   GIR_RootConstrainSelectedInstOperands,
     /* 270471 */   // GIR_Coverage, 6433,
     /* 270471 */   GIR_EraseRootFromParent_Done,
     /* 270472 */ // Label 5499: @270472
     /* 270472 */ GIM_Reject,
     /* 270473 */ // Label 5495: @270473
     /* 270473 */ GIM_Try, /*On fail goto*//*Label 5500*/ GIMT_Encode4(270607), // Rule ID 6432 //
     /* 270478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 270481 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 270484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270488 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270492 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270496 */   // (mulhs:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } (SMULLv8i8_v8i16:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rm, dsub:{ *:[i32] })), (SMULLv16i8_v8i16:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))
     /* 270496 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 270499 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv16i8_v8i16),
     /* 270503 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270508 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 270512 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 270516 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 270518 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 270521 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270525 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270530 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 270536 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270541 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270546 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 270549 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270553 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270558 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 270564 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270569 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270574 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 270577 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i8_v8i16),
     /* 270581 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270586 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 270589 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 270592 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 270594 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 270597 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270599 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270602 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 270605 */   GIR_RootConstrainSelectedInstOperands,
     /* 270606 */   // GIR_Coverage, 6432,
     /* 270606 */   GIR_EraseRootFromParent_Done,
     /* 270607 */ // Label 5500: @270607
     /* 270607 */ GIM_Reject,
     /* 270608 */ // Label 5496: @270608
     /* 270608 */ GIM_Reject,
     /* 270609 */ // Label 50: @270609
     /* 270609 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5512*/ GIMT_Encode4(271038),
     /* 270620 */ /*GILLT_v2s32*//*Label 5501*/ GIMT_Encode4(270696),
     /* 270624 */ /*GILLT_v2s64*//*Label 5502*/ GIMT_Encode4(270730),
     /* 270628 */ /*GILLT_v4s16*//*Label 5503*/ GIMT_Encode4(270764),
     /* 270632 */ /*GILLT_v4s32*//*Label 5504*/ GIMT_Encode4(270798),
     /* 270636 */ /*GILLT_v8s8*//*Label 5505*/ GIMT_Encode4(270832),
     /* 270640 */ /*GILLT_v8s16*//*Label 5506*/ GIMT_Encode4(270866),
     /* 270644 */ /*GILLT_v16s8*//*Label 5507*/ GIMT_Encode4(270900), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 270664 */ /*GILLT_nxv2s64*//*Label 5508*/ GIMT_Encode4(270934), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 270676 */ /*GILLT_nxv4s32*//*Label 5509*/ GIMT_Encode4(270960), GIMT_Encode4(0),
     /* 270684 */ /*GILLT_nxv8s16*//*Label 5510*/ GIMT_Encode4(270986), GIMT_Encode4(0),
     /* 270692 */ /*GILLT_nxv16s8*//*Label 5511*/ GIMT_Encode4(271012),
     /* 270696 */ // Label 5501: @270696
     /* 270696 */ GIM_Try, /*On fail goto*//*Label 5513*/ GIMT_Encode4(270729), // Rule ID 4960 //
     /* 270701 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 270704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 270707 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 270710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270714 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270718 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270722 */   // (uaddsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (UQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /* 270722 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i32),
     /* 270727 */   GIR_RootConstrainSelectedInstOperands,
     /* 270728 */   // GIR_Coverage, 4960,
     /* 270728 */   GIR_Done,
     /* 270729 */ // Label 5513: @270729
     /* 270729 */ GIM_Reject,
     /* 270730 */ // Label 5502: @270730
     /* 270730 */ GIM_Try, /*On fail goto*//*Label 5514*/ GIMT_Encode4(270763), // Rule ID 4964 //
     /* 270735 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 270738 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 270741 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 270744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270748 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270752 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270756 */   // (uaddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (UQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /* 270756 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i64),
     /* 270761 */   GIR_RootConstrainSelectedInstOperands,
     /* 270762 */   // GIR_Coverage, 4964,
     /* 270762 */   GIR_Done,
     /* 270763 */ // Label 5514: @270763
     /* 270763 */ GIM_Reject,
     /* 270764 */ // Label 5503: @270764
     /* 270764 */ GIM_Try, /*On fail goto*//*Label 5515*/ GIMT_Encode4(270797), // Rule ID 4959 //
     /* 270769 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 270772 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 270775 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 270778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270782 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270786 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270790 */   // (uaddsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (UQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /* 270790 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i16),
     /* 270795 */   GIR_RootConstrainSelectedInstOperands,
     /* 270796 */   // GIR_Coverage, 4959,
     /* 270796 */   GIR_Done,
     /* 270797 */ // Label 5515: @270797
     /* 270797 */ GIM_Reject,
     /* 270798 */ // Label 5504: @270798
     /* 270798 */ GIM_Try, /*On fail goto*//*Label 5516*/ GIMT_Encode4(270831), // Rule ID 4963 //
     /* 270803 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 270806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 270809 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 270812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270816 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270820 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270824 */   // (uaddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (UQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /* 270824 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i32),
     /* 270829 */   GIR_RootConstrainSelectedInstOperands,
     /* 270830 */   // GIR_Coverage, 4963,
     /* 270830 */   GIR_Done,
     /* 270831 */ // Label 5516: @270831
     /* 270831 */ GIM_Reject,
     /* 270832 */ // Label 5505: @270832
     /* 270832 */ GIM_Try, /*On fail goto*//*Label 5517*/ GIMT_Encode4(270865), // Rule ID 4958 //
     /* 270837 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 270840 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 270843 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 270846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270850 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270854 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270858 */   // (uaddsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)  =>  (UQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)
     /* 270858 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i8),
     /* 270863 */   GIR_RootConstrainSelectedInstOperands,
     /* 270864 */   // GIR_Coverage, 4958,
     /* 270864 */   GIR_Done,
     /* 270865 */ // Label 5517: @270865
     /* 270865 */ GIM_Reject,
     /* 270866 */ // Label 5506: @270866
     /* 270866 */ GIM_Try, /*On fail goto*//*Label 5518*/ GIMT_Encode4(270899), // Rule ID 4962 //
     /* 270871 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 270874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 270877 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 270880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270884 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270888 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270892 */   // (uaddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (UQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /* 270892 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i16),
     /* 270897 */   GIR_RootConstrainSelectedInstOperands,
     /* 270898 */   // GIR_Coverage, 4962,
     /* 270898 */   GIR_Done,
     /* 270899 */ // Label 5518: @270899
     /* 270899 */ GIM_Reject,
     /* 270900 */ // Label 5507: @270900
     /* 270900 */ GIM_Try, /*On fail goto*//*Label 5519*/ GIMT_Encode4(270933), // Rule ID 4961 //
     /* 270905 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 270908 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 270911 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 270914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270918 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270922 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270926 */   // (uaddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)  =>  (UQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)
     /* 270926 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv16i8),
     /* 270931 */   GIR_RootConstrainSelectedInstOperands,
     /* 270932 */   // GIR_Coverage, 4961,
     /* 270932 */   GIR_Done,
     /* 270933 */ // Label 5519: @270933
     /* 270933 */ GIM_Reject,
     /* 270934 */ // Label 5508: @270934
     /* 270934 */ GIM_Try, /*On fail goto*//*Label 5520*/ GIMT_Encode4(270959), // Rule ID 7297 //
     /* 270939 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 270942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 270945 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 270948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 270952 */   // (uaddsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 270952 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_D),
     /* 270957 */   GIR_RootConstrainSelectedInstOperands,
     /* 270958 */   // GIR_Coverage, 7297,
     /* 270958 */   GIR_Done,
     /* 270959 */ // Label 5520: @270959
     /* 270959 */ GIM_Reject,
     /* 270960 */ // Label 5509: @270960
     /* 270960 */ GIM_Try, /*On fail goto*//*Label 5521*/ GIMT_Encode4(270985), // Rule ID 7296 //
     /* 270965 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 270968 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 270971 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 270974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 270978 */   // (uaddsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 270978 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_S),
     /* 270983 */   GIR_RootConstrainSelectedInstOperands,
     /* 270984 */   // GIR_Coverage, 7296,
     /* 270984 */   GIR_Done,
     /* 270985 */ // Label 5521: @270985
     /* 270985 */ GIM_Reject,
     /* 270986 */ // Label 5510: @270986
     /* 270986 */ GIM_Try, /*On fail goto*//*Label 5522*/ GIMT_Encode4(271011), // Rule ID 7295 //
     /* 270991 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 270994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 270997 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 271000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271004 */   // (uaddsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 271004 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_H),
     /* 271009 */   GIR_RootConstrainSelectedInstOperands,
     /* 271010 */   // GIR_Coverage, 7295,
     /* 271010 */   GIR_Done,
     /* 271011 */ // Label 5522: @271011
     /* 271011 */ GIM_Reject,
     /* 271012 */ // Label 5511: @271012
     /* 271012 */ GIM_Try, /*On fail goto*//*Label 5523*/ GIMT_Encode4(271037), // Rule ID 7294 //
     /* 271017 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271020 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 271023 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 271026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271030 */   // (uaddsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UQADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 271030 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_B),
     /* 271035 */   GIR_RootConstrainSelectedInstOperands,
     /* 271036 */   // GIR_Coverage, 7294,
     /* 271036 */   GIR_Done,
     /* 271037 */ // Label 5523: @271037
     /* 271037 */ GIM_Reject,
     /* 271038 */ // Label 5512: @271038
     /* 271038 */ GIM_Reject,
     /* 271039 */ // Label 51: @271039
     /* 271039 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5535*/ GIMT_Encode4(271468),
     /* 271050 */ /*GILLT_v2s32*//*Label 5524*/ GIMT_Encode4(271126),
     /* 271054 */ /*GILLT_v2s64*//*Label 5525*/ GIMT_Encode4(271160),
     /* 271058 */ /*GILLT_v4s16*//*Label 5526*/ GIMT_Encode4(271194),
     /* 271062 */ /*GILLT_v4s32*//*Label 5527*/ GIMT_Encode4(271228),
     /* 271066 */ /*GILLT_v8s8*//*Label 5528*/ GIMT_Encode4(271262),
     /* 271070 */ /*GILLT_v8s16*//*Label 5529*/ GIMT_Encode4(271296),
     /* 271074 */ /*GILLT_v16s8*//*Label 5530*/ GIMT_Encode4(271330), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 271094 */ /*GILLT_nxv2s64*//*Label 5531*/ GIMT_Encode4(271364), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 271106 */ /*GILLT_nxv4s32*//*Label 5532*/ GIMT_Encode4(271390), GIMT_Encode4(0),
     /* 271114 */ /*GILLT_nxv8s16*//*Label 5533*/ GIMT_Encode4(271416), GIMT_Encode4(0),
     /* 271122 */ /*GILLT_nxv16s8*//*Label 5534*/ GIMT_Encode4(271442),
     /* 271126 */ // Label 5524: @271126
     /* 271126 */ GIM_Try, /*On fail goto*//*Label 5536*/ GIMT_Encode4(271159), // Rule ID 2468 //
     /* 271131 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271134 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 271137 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 271140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271144 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271148 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271152 */   // (saddsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (SQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /* 271152 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i32),
     /* 271157 */   GIR_RootConstrainSelectedInstOperands,
     /* 271158 */   // GIR_Coverage, 2468,
     /* 271158 */   GIR_Done,
     /* 271159 */ // Label 5536: @271159
     /* 271159 */ GIM_Reject,
     /* 271160 */ // Label 5525: @271160
     /* 271160 */ GIM_Try, /*On fail goto*//*Label 5537*/ GIMT_Encode4(271193), // Rule ID 2472 //
     /* 271165 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 271171 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 271174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271178 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271182 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271186 */   // (saddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (SQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /* 271186 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i64),
     /* 271191 */   GIR_RootConstrainSelectedInstOperands,
     /* 271192 */   // GIR_Coverage, 2472,
     /* 271192 */   GIR_Done,
     /* 271193 */ // Label 5537: @271193
     /* 271193 */ GIM_Reject,
     /* 271194 */ // Label 5526: @271194
     /* 271194 */ GIM_Try, /*On fail goto*//*Label 5538*/ GIMT_Encode4(271227), // Rule ID 2467 //
     /* 271199 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 271205 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 271208 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271212 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271216 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271220 */   // (saddsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (SQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /* 271220 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i16),
     /* 271225 */   GIR_RootConstrainSelectedInstOperands,
     /* 271226 */   // GIR_Coverage, 2467,
     /* 271226 */   GIR_Done,
     /* 271227 */ // Label 5538: @271227
     /* 271227 */ GIM_Reject,
     /* 271228 */ // Label 5527: @271228
     /* 271228 */ GIM_Try, /*On fail goto*//*Label 5539*/ GIMT_Encode4(271261), // Rule ID 2471 //
     /* 271233 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271236 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 271239 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 271242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271246 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271250 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271254 */   // (saddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (SQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /* 271254 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i32),
     /* 271259 */   GIR_RootConstrainSelectedInstOperands,
     /* 271260 */   // GIR_Coverage, 2471,
     /* 271260 */   GIR_Done,
     /* 271261 */ // Label 5539: @271261
     /* 271261 */ GIM_Reject,
     /* 271262 */ // Label 5528: @271262
     /* 271262 */ GIM_Try, /*On fail goto*//*Label 5540*/ GIMT_Encode4(271295), // Rule ID 2466 //
     /* 271267 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271270 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 271273 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 271276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271280 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271284 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271288 */   // (saddsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)  =>  (SQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)
     /* 271288 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i8),
     /* 271293 */   GIR_RootConstrainSelectedInstOperands,
     /* 271294 */   // GIR_Coverage, 2466,
     /* 271294 */   GIR_Done,
     /* 271295 */ // Label 5540: @271295
     /* 271295 */ GIM_Reject,
     /* 271296 */ // Label 5529: @271296
     /* 271296 */ GIM_Try, /*On fail goto*//*Label 5541*/ GIMT_Encode4(271329), // Rule ID 2470 //
     /* 271301 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 271307 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 271310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271314 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271318 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271322 */   // (saddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (SQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /* 271322 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i16),
     /* 271327 */   GIR_RootConstrainSelectedInstOperands,
     /* 271328 */   // GIR_Coverage, 2470,
     /* 271328 */   GIR_Done,
     /* 271329 */ // Label 5541: @271329
     /* 271329 */ GIM_Reject,
     /* 271330 */ // Label 5530: @271330
     /* 271330 */ GIM_Try, /*On fail goto*//*Label 5542*/ GIMT_Encode4(271363), // Rule ID 2469 //
     /* 271335 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271338 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 271341 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 271344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271348 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271352 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271356 */   // (saddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)  =>  (SQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)
     /* 271356 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv16i8),
     /* 271361 */   GIR_RootConstrainSelectedInstOperands,
     /* 271362 */   // GIR_Coverage, 2469,
     /* 271362 */   GIR_Done,
     /* 271363 */ // Label 5542: @271363
     /* 271363 */ GIM_Reject,
     /* 271364 */ // Label 5531: @271364
     /* 271364 */ GIM_Try, /*On fail goto*//*Label 5543*/ GIMT_Encode4(271389), // Rule ID 7293 //
     /* 271369 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271372 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 271375 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 271378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271382 */   // (saddsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 271382 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_D),
     /* 271387 */   GIR_RootConstrainSelectedInstOperands,
     /* 271388 */   // GIR_Coverage, 7293,
     /* 271388 */   GIR_Done,
     /* 271389 */ // Label 5543: @271389
     /* 271389 */ GIM_Reject,
     /* 271390 */ // Label 5532: @271390
     /* 271390 */ GIM_Try, /*On fail goto*//*Label 5544*/ GIMT_Encode4(271415), // Rule ID 7292 //
     /* 271395 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 271401 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 271404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271408 */   // (saddsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 271408 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_S),
     /* 271413 */   GIR_RootConstrainSelectedInstOperands,
     /* 271414 */   // GIR_Coverage, 7292,
     /* 271414 */   GIR_Done,
     /* 271415 */ // Label 5544: @271415
     /* 271415 */ GIM_Reject,
     /* 271416 */ // Label 5533: @271416
     /* 271416 */ GIM_Try, /*On fail goto*//*Label 5545*/ GIMT_Encode4(271441), // Rule ID 7291 //
     /* 271421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 271427 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 271430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271434 */   // (saddsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 271434 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_H),
     /* 271439 */   GIR_RootConstrainSelectedInstOperands,
     /* 271440 */   // GIR_Coverage, 7291,
     /* 271440 */   GIR_Done,
     /* 271441 */ // Label 5545: @271441
     /* 271441 */ GIM_Reject,
     /* 271442 */ // Label 5534: @271442
     /* 271442 */ GIM_Try, /*On fail goto*//*Label 5546*/ GIMT_Encode4(271467), // Rule ID 7290 //
     /* 271447 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271450 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 271453 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 271456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271460 */   // (saddsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 271460 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_B),
     /* 271465 */   GIR_RootConstrainSelectedInstOperands,
     /* 271466 */   // GIR_Coverage, 7290,
     /* 271466 */   GIR_Done,
     /* 271467 */ // Label 5546: @271467
     /* 271467 */ GIM_Reject,
     /* 271468 */ // Label 5535: @271468
     /* 271468 */ GIM_Reject,
     /* 271469 */ // Label 52: @271469
     /* 271469 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5558*/ GIMT_Encode4(271898),
     /* 271480 */ /*GILLT_v2s32*//*Label 5547*/ GIMT_Encode4(271556),
     /* 271484 */ /*GILLT_v2s64*//*Label 5548*/ GIMT_Encode4(271590),
     /* 271488 */ /*GILLT_v4s16*//*Label 5549*/ GIMT_Encode4(271624),
     /* 271492 */ /*GILLT_v4s32*//*Label 5550*/ GIMT_Encode4(271658),
     /* 271496 */ /*GILLT_v8s8*//*Label 5551*/ GIMT_Encode4(271692),
     /* 271500 */ /*GILLT_v8s16*//*Label 5552*/ GIMT_Encode4(271726),
     /* 271504 */ /*GILLT_v16s8*//*Label 5553*/ GIMT_Encode4(271760), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 271524 */ /*GILLT_nxv2s64*//*Label 5554*/ GIMT_Encode4(271794), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 271536 */ /*GILLT_nxv4s32*//*Label 5555*/ GIMT_Encode4(271820), GIMT_Encode4(0),
     /* 271544 */ /*GILLT_nxv8s16*//*Label 5556*/ GIMT_Encode4(271846), GIMT_Encode4(0),
     /* 271552 */ /*GILLT_nxv16s8*//*Label 5557*/ GIMT_Encode4(271872),
     /* 271556 */ // Label 5547: @271556
     /* 271556 */ GIM_Try, /*On fail goto*//*Label 5559*/ GIMT_Encode4(271589), // Rule ID 4974 //
     /* 271561 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271564 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 271567 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 271570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271574 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271578 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271582 */   // (usubsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (UQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /* 271582 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i32),
     /* 271587 */   GIR_RootConstrainSelectedInstOperands,
     /* 271588 */   // GIR_Coverage, 4974,
     /* 271588 */   GIR_Done,
     /* 271589 */ // Label 5559: @271589
     /* 271589 */ GIM_Reject,
     /* 271590 */ // Label 5548: @271590
     /* 271590 */ GIM_Try, /*On fail goto*//*Label 5560*/ GIMT_Encode4(271623), // Rule ID 4978 //
     /* 271595 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271598 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 271601 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 271604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271608 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271612 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271616 */   // (usubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (UQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /* 271616 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i64),
     /* 271621 */   GIR_RootConstrainSelectedInstOperands,
     /* 271622 */   // GIR_Coverage, 4978,
     /* 271622 */   GIR_Done,
     /* 271623 */ // Label 5560: @271623
     /* 271623 */ GIM_Reject,
     /* 271624 */ // Label 5549: @271624
     /* 271624 */ GIM_Try, /*On fail goto*//*Label 5561*/ GIMT_Encode4(271657), // Rule ID 4973 //
     /* 271629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 271635 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 271638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271642 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271646 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271650 */   // (usubsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (UQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /* 271650 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i16),
     /* 271655 */   GIR_RootConstrainSelectedInstOperands,
     /* 271656 */   // GIR_Coverage, 4973,
     /* 271656 */   GIR_Done,
     /* 271657 */ // Label 5561: @271657
     /* 271657 */ GIM_Reject,
     /* 271658 */ // Label 5550: @271658
     /* 271658 */ GIM_Try, /*On fail goto*//*Label 5562*/ GIMT_Encode4(271691), // Rule ID 4977 //
     /* 271663 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271666 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 271669 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 271672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271676 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271680 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271684 */   // (usubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (UQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /* 271684 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i32),
     /* 271689 */   GIR_RootConstrainSelectedInstOperands,
     /* 271690 */   // GIR_Coverage, 4977,
     /* 271690 */   GIR_Done,
     /* 271691 */ // Label 5562: @271691
     /* 271691 */ GIM_Reject,
     /* 271692 */ // Label 5551: @271692
     /* 271692 */ GIM_Try, /*On fail goto*//*Label 5563*/ GIMT_Encode4(271725), // Rule ID 4972 //
     /* 271697 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271700 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 271703 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 271706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271710 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271714 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271718 */   // (usubsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)  =>  (UQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)
     /* 271718 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i8),
     /* 271723 */   GIR_RootConstrainSelectedInstOperands,
     /* 271724 */   // GIR_Coverage, 4972,
     /* 271724 */   GIR_Done,
     /* 271725 */ // Label 5563: @271725
     /* 271725 */ GIM_Reject,
     /* 271726 */ // Label 5552: @271726
     /* 271726 */ GIM_Try, /*On fail goto*//*Label 5564*/ GIMT_Encode4(271759), // Rule ID 4976 //
     /* 271731 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271734 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 271737 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 271740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271744 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271748 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271752 */   // (usubsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (UQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /* 271752 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i16),
     /* 271757 */   GIR_RootConstrainSelectedInstOperands,
     /* 271758 */   // GIR_Coverage, 4976,
     /* 271758 */   GIR_Done,
     /* 271759 */ // Label 5564: @271759
     /* 271759 */ GIM_Reject,
     /* 271760 */ // Label 5553: @271760
     /* 271760 */ GIM_Try, /*On fail goto*//*Label 5565*/ GIMT_Encode4(271793), // Rule ID 4975 //
     /* 271765 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271768 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 271771 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 271774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271778 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271782 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271786 */   // (usubsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)  =>  (UQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)
     /* 271786 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv16i8),
     /* 271791 */   GIR_RootConstrainSelectedInstOperands,
     /* 271792 */   // GIR_Coverage, 4975,
     /* 271792 */   GIR_Done,
     /* 271793 */ // Label 5565: @271793
     /* 271793 */ GIM_Reject,
     /* 271794 */ // Label 5554: @271794
     /* 271794 */ GIM_Try, /*On fail goto*//*Label 5566*/ GIMT_Encode4(271819), // Rule ID 7305 //
     /* 271799 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 271805 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 271808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271812 */   // (usubsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQSUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 271812 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_D),
     /* 271817 */   GIR_RootConstrainSelectedInstOperands,
     /* 271818 */   // GIR_Coverage, 7305,
     /* 271818 */   GIR_Done,
     /* 271819 */ // Label 5566: @271819
     /* 271819 */ GIM_Reject,
     /* 271820 */ // Label 5555: @271820
     /* 271820 */ GIM_Try, /*On fail goto*//*Label 5567*/ GIMT_Encode4(271845), // Rule ID 7304 //
     /* 271825 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271828 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 271831 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 271834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271838 */   // (usubsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQSUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 271838 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_S),
     /* 271843 */   GIR_RootConstrainSelectedInstOperands,
     /* 271844 */   // GIR_Coverage, 7304,
     /* 271844 */   GIR_Done,
     /* 271845 */ // Label 5567: @271845
     /* 271845 */ GIM_Reject,
     /* 271846 */ // Label 5556: @271846
     /* 271846 */ GIM_Try, /*On fail goto*//*Label 5568*/ GIMT_Encode4(271871), // Rule ID 7303 //
     /* 271851 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 271857 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 271860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271864 */   // (usubsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQSUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 271864 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_H),
     /* 271869 */   GIR_RootConstrainSelectedInstOperands,
     /* 271870 */   // GIR_Coverage, 7303,
     /* 271870 */   GIR_Done,
     /* 271871 */ // Label 5568: @271871
     /* 271871 */ GIM_Reject,
     /* 271872 */ // Label 5557: @271872
     /* 271872 */ GIM_Try, /*On fail goto*//*Label 5569*/ GIMT_Encode4(271897), // Rule ID 7302 //
     /* 271877 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271880 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 271883 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 271886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271890 */   // (usubsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UQSUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 271890 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_B),
     /* 271895 */   GIR_RootConstrainSelectedInstOperands,
     /* 271896 */   // GIR_Coverage, 7302,
     /* 271896 */   GIR_Done,
     /* 271897 */ // Label 5569: @271897
     /* 271897 */ GIM_Reject,
     /* 271898 */ // Label 5558: @271898
     /* 271898 */ GIM_Reject,
     /* 271899 */ // Label 53: @271899
     /* 271899 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5581*/ GIMT_Encode4(272328),
     /* 271910 */ /*GILLT_v2s32*//*Label 5570*/ GIMT_Encode4(271986),
     /* 271914 */ /*GILLT_v2s64*//*Label 5571*/ GIMT_Encode4(272020),
     /* 271918 */ /*GILLT_v4s16*//*Label 5572*/ GIMT_Encode4(272054),
     /* 271922 */ /*GILLT_v4s32*//*Label 5573*/ GIMT_Encode4(272088),
     /* 271926 */ /*GILLT_v8s8*//*Label 5574*/ GIMT_Encode4(272122),
     /* 271930 */ /*GILLT_v8s16*//*Label 5575*/ GIMT_Encode4(272156),
     /* 271934 */ /*GILLT_v16s8*//*Label 5576*/ GIMT_Encode4(272190), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 271954 */ /*GILLT_nxv2s64*//*Label 5577*/ GIMT_Encode4(272224), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 271966 */ /*GILLT_nxv4s32*//*Label 5578*/ GIMT_Encode4(272250), GIMT_Encode4(0),
     /* 271974 */ /*GILLT_nxv8s16*//*Label 5579*/ GIMT_Encode4(272276), GIMT_Encode4(0),
     /* 271982 */ /*GILLT_nxv16s8*//*Label 5580*/ GIMT_Encode4(272302),
     /* 271986 */ // Label 5570: @271986
     /* 271986 */ GIM_Try, /*On fail goto*//*Label 5582*/ GIMT_Encode4(272019), // Rule ID 4967 //
     /* 271991 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 271997 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 272000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272004 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272008 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272012 */   // (ssubsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (SQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /* 272012 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i32),
     /* 272017 */   GIR_RootConstrainSelectedInstOperands,
     /* 272018 */   // GIR_Coverage, 4967,
     /* 272018 */   GIR_Done,
     /* 272019 */ // Label 5582: @272019
     /* 272019 */ GIM_Reject,
     /* 272020 */ // Label 5571: @272020
     /* 272020 */ GIM_Try, /*On fail goto*//*Label 5583*/ GIMT_Encode4(272053), // Rule ID 4971 //
     /* 272025 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 272031 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 272034 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272038 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272042 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272046 */   // (ssubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (SQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /* 272046 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i64),
     /* 272051 */   GIR_RootConstrainSelectedInstOperands,
     /* 272052 */   // GIR_Coverage, 4971,
     /* 272052 */   GIR_Done,
     /* 272053 */ // Label 5583: @272053
     /* 272053 */ GIM_Reject,
     /* 272054 */ // Label 5572: @272054
     /* 272054 */ GIM_Try, /*On fail goto*//*Label 5584*/ GIMT_Encode4(272087), // Rule ID 4966 //
     /* 272059 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 272065 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 272068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272072 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272076 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272080 */   // (ssubsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (SQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /* 272080 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i16),
     /* 272085 */   GIR_RootConstrainSelectedInstOperands,
     /* 272086 */   // GIR_Coverage, 4966,
     /* 272086 */   GIR_Done,
     /* 272087 */ // Label 5584: @272087
     /* 272087 */ GIM_Reject,
     /* 272088 */ // Label 5573: @272088
     /* 272088 */ GIM_Try, /*On fail goto*//*Label 5585*/ GIMT_Encode4(272121), // Rule ID 4970 //
     /* 272093 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272096 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 272099 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 272102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272106 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272110 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272114 */   // (ssubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (SQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /* 272114 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i32),
     /* 272119 */   GIR_RootConstrainSelectedInstOperands,
     /* 272120 */   // GIR_Coverage, 4970,
     /* 272120 */   GIR_Done,
     /* 272121 */ // Label 5585: @272121
     /* 272121 */ GIM_Reject,
     /* 272122 */ // Label 5574: @272122
     /* 272122 */ GIM_Try, /*On fail goto*//*Label 5586*/ GIMT_Encode4(272155), // Rule ID 4965 //
     /* 272127 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272130 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 272133 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 272136 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272140 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272144 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272148 */   // (ssubsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)  =>  (SQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)
     /* 272148 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i8),
     /* 272153 */   GIR_RootConstrainSelectedInstOperands,
     /* 272154 */   // GIR_Coverage, 4965,
     /* 272154 */   GIR_Done,
     /* 272155 */ // Label 5586: @272155
     /* 272155 */ GIM_Reject,
     /* 272156 */ // Label 5575: @272156
     /* 272156 */ GIM_Try, /*On fail goto*//*Label 5587*/ GIMT_Encode4(272189), // Rule ID 4969 //
     /* 272161 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272164 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 272167 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 272170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272174 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272178 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272182 */   // (ssubsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (SQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /* 272182 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i16),
     /* 272187 */   GIR_RootConstrainSelectedInstOperands,
     /* 272188 */   // GIR_Coverage, 4969,
     /* 272188 */   GIR_Done,
     /* 272189 */ // Label 5587: @272189
     /* 272189 */ GIM_Reject,
     /* 272190 */ // Label 5576: @272190
     /* 272190 */ GIM_Try, /*On fail goto*//*Label 5588*/ GIMT_Encode4(272223), // Rule ID 4968 //
     /* 272195 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 272201 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 272204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272208 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272212 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272216 */   // (ssubsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)  =>  (SQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)
     /* 272216 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv16i8),
     /* 272221 */   GIR_RootConstrainSelectedInstOperands,
     /* 272222 */   // GIR_Coverage, 4968,
     /* 272222 */   GIR_Done,
     /* 272223 */ // Label 5588: @272223
     /* 272223 */ GIM_Reject,
     /* 272224 */ // Label 5577: @272224
     /* 272224 */ GIM_Try, /*On fail goto*//*Label 5589*/ GIMT_Encode4(272249), // Rule ID 7301 //
     /* 272229 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 272232 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 272235 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 272238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272242 */   // (ssubsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQSUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 272242 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_D),
     /* 272247 */   GIR_RootConstrainSelectedInstOperands,
     /* 272248 */   // GIR_Coverage, 7301,
     /* 272248 */   GIR_Done,
     /* 272249 */ // Label 5589: @272249
     /* 272249 */ GIM_Reject,
     /* 272250 */ // Label 5578: @272250
     /* 272250 */ GIM_Try, /*On fail goto*//*Label 5590*/ GIMT_Encode4(272275), // Rule ID 7300 //
     /* 272255 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 272258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 272261 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 272264 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272268 */   // (ssubsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQSUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 272268 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_S),
     /* 272273 */   GIR_RootConstrainSelectedInstOperands,
     /* 272274 */   // GIR_Coverage, 7300,
     /* 272274 */   GIR_Done,
     /* 272275 */ // Label 5590: @272275
     /* 272275 */ GIM_Reject,
     /* 272276 */ // Label 5579: @272276
     /* 272276 */ GIM_Try, /*On fail goto*//*Label 5591*/ GIMT_Encode4(272301), // Rule ID 7299 //
     /* 272281 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 272284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 272287 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 272290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272294 */   // (ssubsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQSUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 272294 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_H),
     /* 272299 */   GIR_RootConstrainSelectedInstOperands,
     /* 272300 */   // GIR_Coverage, 7299,
     /* 272300 */   GIR_Done,
     /* 272301 */ // Label 5591: @272301
     /* 272301 */ GIM_Reject,
     /* 272302 */ // Label 5580: @272302
     /* 272302 */ GIM_Try, /*On fail goto*//*Label 5592*/ GIMT_Encode4(272327), // Rule ID 7298 //
     /* 272307 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 272310 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 272313 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 272316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272320 */   // (ssubsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQSUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 272320 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_B),
     /* 272325 */   GIR_RootConstrainSelectedInstOperands,
     /* 272326 */   // GIR_Coverage, 7298,
     /* 272326 */   GIR_Done,
     /* 272327 */ // Label 5592: @272327
     /* 272327 */ GIM_Reject,
     /* 272328 */ // Label 5581: @272328
     /* 272328 */ GIM_Reject,
     /* 272329 */ // Label 54: @272329
     /* 272329 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 5604*/ GIMT_Encode4(274126),
     /* 272340 */ /*GILLT_s16*//*Label 5593*/ GIMT_Encode4(272424),
     /* 272344 */ /*GILLT_s32*//*Label 5594*/ GIMT_Encode4(272650),
     /* 272348 */ /*GILLT_s64*//*Label 5595*/ GIMT_Encode4(273004), GIMT_Encode4(0),
     /* 272356 */ /*GILLT_v2s32*//*Label 5596*/ GIMT_Encode4(273176),
     /* 272360 */ /*GILLT_v2s64*//*Label 5597*/ GIMT_Encode4(273214),
     /* 272364 */ /*GILLT_v4s16*//*Label 5598*/ GIMT_Encode4(273390),
     /* 272368 */ /*GILLT_v4s32*//*Label 5599*/ GIMT_Encode4(273428), GIMT_Encode4(0),
     /* 272376 */ /*GILLT_v8s16*//*Label 5600*/ GIMT_Encode4(273604), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 272400 */ /*GILLT_nxv2s64*//*Label 5601*/ GIMT_Encode4(274048), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 272412 */ /*GILLT_nxv4s32*//*Label 5602*/ GIMT_Encode4(274074), GIMT_Encode4(0),
     /* 272420 */ /*GILLT_nxv8s16*//*Label 5603*/ GIMT_Encode4(274100),
     /* 272424 */ // Label 5593: @272424
     /* 272424 */ GIM_Try, /*On fail goto*//*Label 5605*/ GIMT_Encode4(272649),
     /* 272429 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 272432 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 272435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 272439 */   GIM_Try, /*On fail goto*//*Label 5606*/ GIMT_Encode4(272530), // Rule ID 6825 //
     /* 272444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 272448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 272452 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 272456 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 272460 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272465 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 272469 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 272473 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 272477 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 272481 */     // MIs[2] Rn
     /* 272481 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 272486 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 272490 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 272492 */     // (fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 272492 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 272495 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 272499 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 272504 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 272510 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272515 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 272523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272525 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 272528 */     GIR_RootConstrainSelectedInstOperands,
     /* 272529 */     // GIR_Coverage, 6825,
     /* 272529 */     GIR_EraseRootFromParent_Done,
     /* 272530 */   // Label 5606: @272530
     /* 272530 */   GIM_Try, /*On fail goto*//*Label 5607*/ GIMT_Encode4(272621), // Rule ID 13654 //
     /* 272535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 272539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 272543 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 272547 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 272551 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272556 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 272560 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 272564 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 272568 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 272572 */     // MIs[2] Rn
     /* 272572 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 272577 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 272581 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 272583 */     // (fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 272583 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 272586 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 272590 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 272595 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 272601 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272606 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 272614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272616 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 272619 */     GIR_RootConstrainSelectedInstOperands,
     /* 272620 */     // GIR_Coverage, 13654,
     /* 272620 */     GIR_EraseRootFromParent_Done,
     /* 272621 */   // Label 5607: @272621
     /* 272621 */   GIM_Try, /*On fail goto*//*Label 5608*/ GIMT_Encode4(272648), // Rule ID 584 //
     /* 272626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 272629 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 272633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 272637 */     // (fadd:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FADDHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 272637 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDHrr),
     /* 272642 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 272646 */     GIR_RootConstrainSelectedInstOperands,
     /* 272647 */     // GIR_Coverage, 584,
     /* 272647 */     GIR_Done,
     /* 272648 */   // Label 5608: @272648
     /* 272648 */   GIM_Reject,
     /* 272649 */ // Label 5605: @272649
     /* 272649 */ GIM_Reject,
     /* 272650 */ // Label 5594: @272650
     /* 272650 */ GIM_Try, /*On fail goto*//*Label 5609*/ GIMT_Encode4(273003),
     /* 272655 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 272658 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 272661 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 272665 */   GIM_Try, /*On fail goto*//*Label 5610*/ GIMT_Encode4(272756), // Rule ID 6823 //
     /* 272670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 272674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 272678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 272682 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 272686 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272691 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 272695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 272699 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 272703 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 272707 */     // MIs[2] Rn
     /* 272707 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 272712 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 272716 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 272718 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 272718 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 272721 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 272725 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 272730 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 272736 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272741 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 272749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272751 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 272754 */     GIR_RootConstrainSelectedInstOperands,
     /* 272755 */     // GIR_Coverage, 6823,
     /* 272755 */     GIR_EraseRootFromParent_Done,
     /* 272756 */   // Label 5610: @272756
     /* 272756 */   GIM_Try, /*On fail goto*//*Label 5611*/ GIMT_Encode4(272820), // Rule ID 12825 //
     /* 272761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 272765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 272769 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 272773 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 272777 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272782 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 272786 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 272790 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 272794 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 272798 */     // MIs[2] Rn
     /* 272798 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 272803 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 272807 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 272809 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn)
     /* 272809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 272812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 272818 */     GIR_RootConstrainSelectedInstOperands,
     /* 272819 */     // GIR_Coverage, 12825,
     /* 272819 */     GIR_EraseRootFromParent_Done,
     /* 272820 */   // Label 5611: @272820
     /* 272820 */   GIM_Try, /*On fail goto*//*Label 5612*/ GIMT_Encode4(272911), // Rule ID 13652 //
     /* 272825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 272829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 272833 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 272837 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 272841 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272846 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 272850 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 272854 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 272858 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 272862 */     // MIs[2] Rn
     /* 272862 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 272867 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 272871 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 272873 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 272873 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 272876 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 272880 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 272885 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 272891 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272896 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 272904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272906 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 272909 */     GIR_RootConstrainSelectedInstOperands,
     /* 272910 */     // GIR_Coverage, 13652,
     /* 272910 */     GIR_EraseRootFromParent_Done,
     /* 272911 */   // Label 5612: @272911
     /* 272911 */   GIM_Try, /*On fail goto*//*Label 5613*/ GIMT_Encode4(272975), // Rule ID 15327 //
     /* 272916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 272920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 272924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 272928 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 272932 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272937 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 272941 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 272945 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 272949 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 272953 */     // MIs[2] Rn
     /* 272953 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 272958 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 272962 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 272964 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn)
     /* 272964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 272967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 272973 */     GIR_RootConstrainSelectedInstOperands,
     /* 272974 */     // GIR_Coverage, 15327,
     /* 272974 */     GIR_EraseRootFromParent_Done,
     /* 272975 */   // Label 5613: @272975
     /* 272975 */   GIM_Try, /*On fail goto*//*Label 5614*/ GIMT_Encode4(273002), // Rule ID 586 //
     /* 272980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 272983 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 272987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 272991 */     // (fadd:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FADDSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 272991 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDSrr),
     /* 272996 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 273000 */     GIR_RootConstrainSelectedInstOperands,
     /* 273001 */     // GIR_Coverage, 586,
     /* 273001 */     GIR_Done,
     /* 273002 */   // Label 5614: @273002
     /* 273002 */   GIM_Reject,
     /* 273003 */ // Label 5609: @273003
     /* 273003 */ GIM_Reject,
     /* 273004 */ // Label 5595: @273004
     /* 273004 */ GIM_Try, /*On fail goto*//*Label 5615*/ GIMT_Encode4(273175),
     /* 273009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 273012 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 273015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273019 */   GIM_Try, /*On fail goto*//*Label 5616*/ GIMT_Encode4(273083), // Rule ID 6821 //
     /* 273024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 273028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 273032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 273036 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 273040 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273045 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 273049 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 273053 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 273057 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 273061 */     // MIs[2] Rn
     /* 273061 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 273066 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 273070 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 273072 */     // (fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 273072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 273075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 273081 */     GIR_RootConstrainSelectedInstOperands,
     /* 273082 */     // GIR_Coverage, 6821,
     /* 273082 */     GIR_EraseRootFromParent_Done,
     /* 273083 */   // Label 5616: @273083
     /* 273083 */   GIM_Try, /*On fail goto*//*Label 5617*/ GIMT_Encode4(273147), // Rule ID 13650 //
     /* 273088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 273092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 273096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 273100 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 273104 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273109 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 273113 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 273117 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 273121 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 273125 */     // MIs[2] Rn
     /* 273125 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 273130 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 273134 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 273136 */     // (fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 273136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 273139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 273145 */     GIR_RootConstrainSelectedInstOperands,
     /* 273146 */     // GIR_Coverage, 13650,
     /* 273146 */     GIR_EraseRootFromParent_Done,
     /* 273147 */   // Label 5617: @273147
     /* 273147 */   GIM_Try, /*On fail goto*//*Label 5618*/ GIMT_Encode4(273174), // Rule ID 588 //
     /* 273152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 273155 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273163 */     // (fadd:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FADDDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 273163 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDDrr),
     /* 273168 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 273172 */     GIR_RootConstrainSelectedInstOperands,
     /* 273173 */     // GIR_Coverage, 588,
     /* 273173 */     GIR_Done,
     /* 273174 */   // Label 5618: @273174
     /* 273174 */   GIM_Reject,
     /* 273175 */ // Label 5615: @273175
     /* 273175 */ GIM_Reject,
     /* 273176 */ // Label 5596: @273176
     /* 273176 */ GIM_Try, /*On fail goto*//*Label 5619*/ GIMT_Encode4(273213), // Rule ID 1196 //
     /* 273181 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273184 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 273187 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 273190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273194 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273198 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273202 */   // (fadd:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 273202 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f32),
     /* 273207 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 273211 */   GIR_RootConstrainSelectedInstOperands,
     /* 273212 */   // GIR_Coverage, 1196,
     /* 273212 */   GIR_Done,
     /* 273213 */ // Label 5619: @273213
     /* 273213 */ GIM_Reject,
     /* 273214 */ // Label 5597: @273214
     /* 273214 */ GIM_Try, /*On fail goto*//*Label 5620*/ GIMT_Encode4(273389),
     /* 273219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 273222 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 273225 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273229 */   GIM_Try, /*On fail goto*//*Label 5621*/ GIMT_Encode4(273295), // Rule ID 6843 //
     /* 273234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 273238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP1),
     /* 273242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 273246 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 273250 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273255 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273260 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 273264 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP2),
     /* 273268 */     // MIs[2] Rn
     /* 273268 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 273273 */     // MIs[2] Rm
     /* 273273 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 273278 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 273280 */     // (fadd:{ *:[v2f64] } (AArch64zip1:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm), (AArch64zip2:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm))  =>  (FADDPv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm)
     /* 273280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f64),
     /* 273283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 273289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 273293 */     GIR_RootConstrainSelectedInstOperands,
     /* 273294 */     // GIR_Coverage, 6843,
     /* 273294 */     GIR_EraseRootFromParent_Done,
     /* 273295 */   // Label 5621: @273295
     /* 273295 */   GIM_Try, /*On fail goto*//*Label 5622*/ GIMT_Encode4(273361), // Rule ID 13662 //
     /* 273300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 273304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP2),
     /* 273308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 273312 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 273316 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273321 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273326 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 273330 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP1),
     /* 273334 */     // MIs[2] Rn
     /* 273334 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 273339 */     // MIs[2] Rm
     /* 273339 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 273344 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 273346 */     // (fadd:{ *:[v2f64] } (AArch64zip2:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm), (AArch64zip1:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm))  =>  (FADDPv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm)
     /* 273346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f64),
     /* 273349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 273355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 273359 */     GIR_RootConstrainSelectedInstOperands,
     /* 273360 */     // GIR_Coverage, 13662,
     /* 273360 */     GIR_EraseRootFromParent_Done,
     /* 273361 */   // Label 5622: @273361
     /* 273361 */   GIM_Try, /*On fail goto*//*Label 5623*/ GIMT_Encode4(273388), // Rule ID 1200 //
     /* 273366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273377 */     // (fadd:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 273377 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f64),
     /* 273382 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 273386 */     GIR_RootConstrainSelectedInstOperands,
     /* 273387 */     // GIR_Coverage, 1200,
     /* 273387 */     GIR_Done,
     /* 273388 */   // Label 5623: @273388
     /* 273388 */   GIM_Reject,
     /* 273389 */ // Label 5620: @273389
     /* 273389 */ GIM_Reject,
     /* 273390 */ // Label 5598: @273390
     /* 273390 */ GIM_Try, /*On fail goto*//*Label 5624*/ GIMT_Encode4(273427), // Rule ID 1192 //
     /* 273395 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 273398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 273401 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 273404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273412 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273416 */   // (fadd:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 273416 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f16),
     /* 273421 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 273425 */   GIR_RootConstrainSelectedInstOperands,
     /* 273426 */   // GIR_Coverage, 1192,
     /* 273426 */   GIR_Done,
     /* 273427 */ // Label 5624: @273427
     /* 273427 */ GIM_Reject,
     /* 273428 */ // Label 5599: @273428
     /* 273428 */ GIM_Try, /*On fail goto*//*Label 5625*/ GIMT_Encode4(273603),
     /* 273433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 273436 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 273439 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273443 */   GIM_Try, /*On fail goto*//*Label 5626*/ GIMT_Encode4(273509), // Rule ID 6844 //
     /* 273448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 273452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /* 273456 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 273460 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 273464 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273469 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273474 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 273478 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /* 273482 */     // MIs[2] Rn
     /* 273482 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 273487 */     // MIs[2] Rm
     /* 273487 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 273492 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 273494 */     // (fadd:{ *:[v4f32] } (AArch64uzp1:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm), (AArch64uzp2:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm))  =>  (FADDPv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm)
     /* 273494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 273497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 273503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 273507 */     GIR_RootConstrainSelectedInstOperands,
     /* 273508 */     // GIR_Coverage, 6844,
     /* 273508 */     GIR_EraseRootFromParent_Done,
     /* 273509 */   // Label 5626: @273509
     /* 273509 */   GIM_Try, /*On fail goto*//*Label 5627*/ GIMT_Encode4(273575), // Rule ID 13663 //
     /* 273514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 273518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /* 273522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 273526 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 273530 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273535 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273540 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 273544 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /* 273548 */     // MIs[2] Rn
     /* 273548 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 273553 */     // MIs[2] Rm
     /* 273553 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 273558 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 273560 */     // (fadd:{ *:[v4f32] } (AArch64uzp2:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm), (AArch64uzp1:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm))  =>  (FADDPv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm)
     /* 273560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 273563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 273569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 273573 */     GIR_RootConstrainSelectedInstOperands,
     /* 273574 */     // GIR_Coverage, 13663,
     /* 273574 */     GIR_EraseRootFromParent_Done,
     /* 273575 */   // Label 5627: @273575
     /* 273575 */   GIM_Try, /*On fail goto*//*Label 5628*/ GIMT_Encode4(273602), // Rule ID 1198 //
     /* 273580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273583 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273591 */     // (fadd:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 273591 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 273596 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 273600 */     GIR_RootConstrainSelectedInstOperands,
     /* 273601 */     // GIR_Coverage, 1198,
     /* 273601 */     GIR_Done,
     /* 273602 */   // Label 5628: @273602
     /* 273602 */   GIM_Reject,
     /* 273603 */ // Label 5625: @273603
     /* 273603 */ GIM_Reject,
     /* 273604 */ // Label 5600: @273604
     /* 273604 */ GIM_Try, /*On fail goto*//*Label 5629*/ GIMT_Encode4(274047),
     /* 273609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 273612 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 273615 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273619 */   GIM_Try, /*On fail goto*//*Label 5630*/ GIMT_Encode4(273688), // Rule ID 6845 //
     /* 273624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 273627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 273631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /* 273635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 273639 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 273643 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273648 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273653 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 273657 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /* 273661 */     // MIs[2] Rn
     /* 273661 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 273666 */     // MIs[2] Rm
     /* 273666 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 273671 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 273673 */     // (fadd:{ *:[v8f16] } (AArch64uzp1:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm), (AArch64uzp2:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm))  =>  (FADDPv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm)
     /* 273673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 273676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 273682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 273686 */     GIR_RootConstrainSelectedInstOperands,
     /* 273687 */     // GIR_Coverage, 6845,
     /* 273687 */     GIR_EraseRootFromParent_Done,
     /* 273688 */   // Label 5630: @273688
     /* 273688 */   GIM_Try, /*On fail goto*//*Label 5631*/ GIMT_Encode4(273757), // Rule ID 13664 //
     /* 273693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 273696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 273700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /* 273704 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 273708 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 273712 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273717 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273722 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 273726 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /* 273730 */     // MIs[2] Rn
     /* 273730 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 273735 */     // MIs[2] Rm
     /* 273735 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 273740 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 273742 */     // (fadd:{ *:[v8f16] } (AArch64uzp2:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm), (AArch64uzp1:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm))  =>  (FADDPv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm)
     /* 273742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 273745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 273751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 273755 */     GIR_RootConstrainSelectedInstOperands,
     /* 273756 */     // GIR_Coverage, 13664,
     /* 273756 */     GIR_EraseRootFromParent_Done,
     /* 273757 */   // Label 5631: @273757
     /* 273757 */   GIM_Try, /*On fail goto*//*Label 5632*/ GIMT_Encode4(273784), // Rule ID 1194 //
     /* 273762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 273765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273773 */     // (fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 273773 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv8f16),
     /* 273778 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 273782 */     GIR_RootConstrainSelectedInstOperands,
     /* 273783 */     // GIR_Coverage, 1194,
     /* 273783 */     GIR_Done,
     /* 273784 */   // Label 5632: @273784
     /* 273784 */   GIM_Try, /*On fail goto*//*Label 5633*/ GIMT_Encode4(274046), // Rule ID 6914 //
     /* 273789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 273792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273800 */     // (fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FADDv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FADDv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 273800 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 273803 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 273807 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 273812 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 273816 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 273818 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 273821 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 273825 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 273830 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 273834 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 273836 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 273839 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 273843 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 273848 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 273851 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 273854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 273856 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 273859 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 273863 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 273868 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 273874 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273879 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273884 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 273887 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 273891 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 273896 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 273899 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 273901 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 273904 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 273908 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 273913 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 273919 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273924 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273929 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 273932 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 273936 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 273941 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 273944 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 273946 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 273949 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 273953 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 273958 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 273961 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 273964 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 273966 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 273969 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 273973 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 273978 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 273981 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 273983 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 273986 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 273990 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 273995 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 273997 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 274000 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 274004 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 274009 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 274012 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 274015 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 274018 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274023 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274028 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 274036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 274038 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 274041 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 274044 */     GIR_RootConstrainSelectedInstOperands,
     /* 274045 */     // GIR_Coverage, 6914,
     /* 274045 */     GIR_EraseRootFromParent_Done,
     /* 274046 */   // Label 5633: @274046
     /* 274046 */   GIM_Reject,
     /* 274047 */ // Label 5629: @274047
     /* 274047 */ GIM_Reject,
     /* 274048 */ // Label 5601: @274048
     /* 274048 */ GIM_Try, /*On fail goto*//*Label 5634*/ GIMT_Encode4(274073), // Rule ID 2810 //
     /* 274053 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 274056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 274059 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 274062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274066 */   // (fadd:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FADD_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 274066 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_D),
     /* 274071 */   GIR_RootConstrainSelectedInstOperands,
     /* 274072 */   // GIR_Coverage, 2810,
     /* 274072 */   GIR_Done,
     /* 274073 */ // Label 5634: @274073
     /* 274073 */ GIM_Reject,
     /* 274074 */ // Label 5602: @274074
     /* 274074 */ GIM_Try, /*On fail goto*//*Label 5635*/ GIMT_Encode4(274099), // Rule ID 2808 //
     /* 274079 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 274082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 274085 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 274088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274092 */   // (fadd:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FADD_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 274092 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_S),
     /* 274097 */   GIR_RootConstrainSelectedInstOperands,
     /* 274098 */   // GIR_Coverage, 2808,
     /* 274098 */   GIR_Done,
     /* 274099 */ // Label 5635: @274099
     /* 274099 */ GIM_Reject,
     /* 274100 */ // Label 5603: @274100
     /* 274100 */ GIM_Try, /*On fail goto*//*Label 5636*/ GIMT_Encode4(274125), // Rule ID 2806 //
     /* 274105 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 274108 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 274111 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 274114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274118 */   // (fadd:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FADD_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 274118 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_H),
     /* 274123 */   GIR_RootConstrainSelectedInstOperands,
     /* 274124 */   // GIR_Coverage, 2806,
     /* 274124 */   GIR_Done,
     /* 274125 */ // Label 5636: @274125
     /* 274125 */ GIM_Reject,
     /* 274126 */ // Label 5604: @274126
     /* 274126 */ GIM_Reject,
     /* 274127 */ // Label 55: @274127
     /* 274127 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 5648*/ GIMT_Encode4(274864),
     /* 274138 */ /*GILLT_s16*//*Label 5637*/ GIMT_Encode4(274222),
     /* 274142 */ /*GILLT_s32*//*Label 5638*/ GIMT_Encode4(274260),
     /* 274146 */ /*GILLT_s64*//*Label 5639*/ GIMT_Encode4(274298), GIMT_Encode4(0),
     /* 274154 */ /*GILLT_v2s32*//*Label 5640*/ GIMT_Encode4(274336),
     /* 274158 */ /*GILLT_v2s64*//*Label 5641*/ GIMT_Encode4(274374),
     /* 274162 */ /*GILLT_v4s16*//*Label 5642*/ GIMT_Encode4(274412),
     /* 274166 */ /*GILLT_v4s32*//*Label 5643*/ GIMT_Encode4(274450), GIMT_Encode4(0),
     /* 274174 */ /*GILLT_v8s16*//*Label 5644*/ GIMT_Encode4(274488), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 274198 */ /*GILLT_nxv2s64*//*Label 5645*/ GIMT_Encode4(274786), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 274210 */ /*GILLT_nxv4s32*//*Label 5646*/ GIMT_Encode4(274812), GIMT_Encode4(0),
     /* 274218 */ /*GILLT_nxv8s16*//*Label 5647*/ GIMT_Encode4(274838),
     /* 274222 */ // Label 5637: @274222
     /* 274222 */ GIM_Try, /*On fail goto*//*Label 5649*/ GIMT_Encode4(274259), // Rule ID 632 //
     /* 274227 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 274230 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 274233 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 274236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 274240 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 274244 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 274248 */   // (fsub:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FSUBHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 274248 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBHrr),
     /* 274253 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 274257 */   GIR_RootConstrainSelectedInstOperands,
     /* 274258 */   // GIR_Coverage, 632,
     /* 274258 */   GIR_Done,
     /* 274259 */ // Label 5649: @274259
     /* 274259 */ GIM_Reject,
     /* 274260 */ // Label 5638: @274260
     /* 274260 */ GIM_Try, /*On fail goto*//*Label 5650*/ GIMT_Encode4(274297), // Rule ID 634 //
     /* 274265 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 274268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 274271 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 274274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 274278 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 274282 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 274286 */   // (fsub:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FSUBSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 274286 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBSrr),
     /* 274291 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 274295 */   GIR_RootConstrainSelectedInstOperands,
     /* 274296 */   // GIR_Coverage, 634,
     /* 274296 */   GIR_Done,
     /* 274297 */ // Label 5650: @274297
     /* 274297 */ GIM_Reject,
     /* 274298 */ // Label 5639: @274298
     /* 274298 */ GIM_Try, /*On fail goto*//*Label 5651*/ GIMT_Encode4(274335), // Rule ID 636 //
     /* 274303 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 274306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 274309 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 274312 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274316 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274320 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274324 */   // (fsub:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FSUBDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 274324 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBDrr),
     /* 274329 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 274333 */   GIR_RootConstrainSelectedInstOperands,
     /* 274334 */   // GIR_Coverage, 636,
     /* 274334 */   GIR_Done,
     /* 274335 */ // Label 5651: @274335
     /* 274335 */ GIM_Reject,
     /* 274336 */ // Label 5640: @274336
     /* 274336 */ GIM_Try, /*On fail goto*//*Label 5652*/ GIMT_Encode4(274373), // Rule ID 1336 //
     /* 274341 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 274347 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 274350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274354 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274358 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274362 */   // (fsub:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FSUBv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 274362 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f32),
     /* 274367 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 274371 */   GIR_RootConstrainSelectedInstOperands,
     /* 274372 */   // GIR_Coverage, 1336,
     /* 274372 */   GIR_Done,
     /* 274373 */ // Label 5652: @274373
     /* 274373 */ GIM_Reject,
     /* 274374 */ // Label 5641: @274374
     /* 274374 */ GIM_Try, /*On fail goto*//*Label 5653*/ GIMT_Encode4(274411), // Rule ID 1340 //
     /* 274379 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 274385 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 274388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274392 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274396 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274400 */   // (fsub:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FSUBv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 274400 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f64),
     /* 274405 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 274409 */   GIR_RootConstrainSelectedInstOperands,
     /* 274410 */   // GIR_Coverage, 1340,
     /* 274410 */   GIR_Done,
     /* 274411 */ // Label 5653: @274411
     /* 274411 */ GIM_Reject,
     /* 274412 */ // Label 5642: @274412
     /* 274412 */ GIM_Try, /*On fail goto*//*Label 5654*/ GIMT_Encode4(274449), // Rule ID 1332 //
     /* 274417 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 274420 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 274423 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 274426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274430 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274434 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274438 */   // (fsub:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FSUBv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 274438 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f16),
     /* 274443 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 274447 */   GIR_RootConstrainSelectedInstOperands,
     /* 274448 */   // GIR_Coverage, 1332,
     /* 274448 */   GIR_Done,
     /* 274449 */ // Label 5654: @274449
     /* 274449 */ GIM_Reject,
     /* 274450 */ // Label 5643: @274450
     /* 274450 */ GIM_Try, /*On fail goto*//*Label 5655*/ GIMT_Encode4(274487), // Rule ID 1338 //
     /* 274455 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 274461 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 274464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274468 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274472 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274476 */   // (fsub:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FSUBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 274476 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 274481 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 274485 */   GIR_RootConstrainSelectedInstOperands,
     /* 274486 */   // GIR_Coverage, 1338,
     /* 274486 */   GIR_Done,
     /* 274487 */ // Label 5655: @274487
     /* 274487 */ GIM_Reject,
     /* 274488 */ // Label 5644: @274488
     /* 274488 */ GIM_Try, /*On fail goto*//*Label 5656*/ GIMT_Encode4(274785),
     /* 274493 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 274496 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 274499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274503 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274507 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274511 */   GIM_Try, /*On fail goto*//*Label 5657*/ GIMT_Encode4(274530), // Rule ID 1334 //
     /* 274516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 274519 */     // (fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FSUBv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 274519 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv8f16),
     /* 274524 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 274528 */     GIR_RootConstrainSelectedInstOperands,
     /* 274529 */     // GIR_Coverage, 1334,
     /* 274529 */     GIR_Done,
     /* 274530 */   // Label 5657: @274530
     /* 274530 */   GIM_Try, /*On fail goto*//*Label 5658*/ GIMT_Encode4(274784), // Rule ID 6920 //
     /* 274535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 274538 */     // (fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FSUBv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FSUBv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 274538 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 274541 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 274545 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 274550 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 274554 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 274556 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 274559 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 274563 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 274568 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 274572 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 274574 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 274577 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 274581 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 274586 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 274589 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 274592 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 274594 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 274597 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 274601 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 274606 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 274612 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274617 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274622 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 274625 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 274629 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 274634 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 274637 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 274639 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 274642 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 274646 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 274651 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 274657 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274662 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274667 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 274670 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 274674 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 274679 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 274682 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 274684 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 274687 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 274691 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 274696 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 274699 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 274702 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 274704 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 274707 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 274711 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 274716 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 274719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 274721 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 274724 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 274728 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 274733 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 274735 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 274738 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 274742 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 274747 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 274750 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 274753 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 274756 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274761 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274766 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 274774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 274776 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 274779 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 274782 */     GIR_RootConstrainSelectedInstOperands,
     /* 274783 */     // GIR_Coverage, 6920,
     /* 274783 */     GIR_EraseRootFromParent_Done,
     /* 274784 */   // Label 5658: @274784
     /* 274784 */   GIM_Reject,
     /* 274785 */ // Label 5656: @274785
     /* 274785 */ GIM_Reject,
     /* 274786 */ // Label 5645: @274786
     /* 274786 */ GIM_Try, /*On fail goto*//*Label 5659*/ GIMT_Encode4(274811), // Rule ID 8044 //
     /* 274791 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 274794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 274797 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 274800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274804 */   // (fsub:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FSUB_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 274804 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_D),
     /* 274809 */   GIR_RootConstrainSelectedInstOperands,
     /* 274810 */   // GIR_Coverage, 8044,
     /* 274810 */   GIR_Done,
     /* 274811 */ // Label 5659: @274811
     /* 274811 */ GIM_Reject,
     /* 274812 */ // Label 5646: @274812
     /* 274812 */ GIM_Try, /*On fail goto*//*Label 5660*/ GIMT_Encode4(274837), // Rule ID 8042 //
     /* 274817 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 274820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 274823 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 274826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274830 */   // (fsub:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FSUB_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 274830 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_S),
     /* 274835 */   GIR_RootConstrainSelectedInstOperands,
     /* 274836 */   // GIR_Coverage, 8042,
     /* 274836 */   GIR_Done,
     /* 274837 */ // Label 5660: @274837
     /* 274837 */ GIM_Reject,
     /* 274838 */ // Label 5647: @274838
     /* 274838 */ GIM_Try, /*On fail goto*//*Label 5661*/ GIMT_Encode4(274863), // Rule ID 8040 //
     /* 274843 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 274846 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 274849 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 274852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274856 */   // (fsub:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FSUB_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 274856 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_H),
     /* 274861 */   GIR_RootConstrainSelectedInstOperands,
     /* 274862 */   // GIR_Coverage, 8040,
     /* 274862 */   GIR_Done,
     /* 274863 */ // Label 5661: @274863
     /* 274863 */ GIM_Reject,
     /* 274864 */ // Label 5648: @274864
     /* 274864 */ GIM_Reject,
     /* 274865 */ // Label 56: @274865
     /* 274865 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 5673*/ GIMT_Encode4(278960),
     /* 274876 */ /*GILLT_s16*//*Label 5662*/ GIMT_Encode4(274960),
     /* 274880 */ /*GILLT_s32*//*Label 5663*/ GIMT_Encode4(275602),
     /* 274884 */ /*GILLT_s64*//*Label 5664*/ GIMT_Encode4(276232), GIMT_Encode4(0),
     /* 274892 */ /*GILLT_v2s32*//*Label 5665*/ GIMT_Encode4(276862),
     /* 274896 */ /*GILLT_v2s64*//*Label 5666*/ GIMT_Encode4(277392),
     /* 274900 */ /*GILLT_v4s16*//*Label 5667*/ GIMT_Encode4(277750),
     /* 274904 */ /*GILLT_v4s32*//*Label 5668*/ GIMT_Encode4(278092), GIMT_Encode4(0),
     /* 274912 */ /*GILLT_v8s16*//*Label 5669*/ GIMT_Encode4(278450), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 274936 */ /*GILLT_nxv2s64*//*Label 5670*/ GIMT_Encode4(278882), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 274948 */ /*GILLT_nxv4s32*//*Label 5671*/ GIMT_Encode4(278908), GIMT_Encode4(0),
     /* 274956 */ /*GILLT_nxv8s16*//*Label 5672*/ GIMT_Encode4(278934),
     /* 274960 */ // Label 5662: @274960
     /* 274960 */ GIM_Try, /*On fail goto*//*Label 5674*/ GIMT_Encode4(275601),
     /* 274965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 274968 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 274971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 274975 */   GIM_Try, /*On fail goto*//*Label 5675*/ GIMT_Encode4(275088), // Rule ID 6147 //
     /* 274980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 274983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 274987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 274991 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 274995 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 274999 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275004 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 275008 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 275012 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 275016 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 275020 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 275024 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275029 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 275033 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 275037 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 275041 */     // MIs[3] Operand 1
     /* 275041 */     // No operand predicates
     /* 275041 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 275043 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 275043 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 275046 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 275050 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 275055 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 275061 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 275066 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 275074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275076 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 275079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 275083 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 275086 */     GIR_RootConstrainSelectedInstOperands,
     /* 275087 */     // GIR_Coverage, 6147,
     /* 275087 */     GIR_EraseRootFromParent_Done,
     /* 275088 */   // Label 5675: @275088
     /* 275088 */   GIM_Try, /*On fail goto*//*Label 5676*/ GIMT_Encode4(275201), // Rule ID 13625 //
     /* 275093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 275096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 275100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 275104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 275108 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 275112 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 275121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 275125 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 275129 */     // MIs[2] Operand 1
     /* 275129 */     // No operand predicates
     /* 275129 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 275133 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 275137 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 275141 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 275145 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275150 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 275154 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 275156 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 275156 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 275159 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 275163 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 275168 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 275174 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 275179 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 275187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275189 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 275192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 275196 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 275199 */     GIR_RootConstrainSelectedInstOperands,
     /* 275200 */     // GIR_Coverage, 13625,
     /* 275200 */     GIR_EraseRootFromParent_Done,
     /* 275201 */   // Label 5676: @275201
     /* 275201 */   GIM_Try, /*On fail goto*//*Label 5677*/ GIMT_Encode4(275280), // Rule ID 13562 //
     /* 275206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 275209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 275213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 275217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 275221 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 275225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275230 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 275234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 275238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275240 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 275240 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 275243 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 275247 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 275252 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 275258 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 275263 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 275271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275273 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275275 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 275278 */     GIR_RootConstrainSelectedInstOperands,
     /* 275279 */     // GIR_Coverage, 13562,
     /* 275279 */     GIR_EraseRootFromParent_Done,
     /* 275280 */   // Label 5677: @275280
     /* 275280 */   GIM_Try, /*On fail goto*//*Label 5678*/ GIMT_Encode4(275359), // Rule ID 4743 //
     /* 275285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 275288 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 275292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 275296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 275300 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 275304 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 275308 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275313 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 275317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275319 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 275319 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 275322 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 275326 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 275331 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 275337 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 275342 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 275350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275352 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 275354 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 275357 */     GIR_RootConstrainSelectedInstOperands,
     /* 275358 */     // GIR_Coverage, 4743,
     /* 275358 */     GIR_EraseRootFromParent_Done,
     /* 275359 */   // Label 5678: @275359
     /* 275359 */   GIM_Try, /*On fail goto*//*Label 5679*/ GIMT_Encode4(275422), // Rule ID 13177 //
     /* 275364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 275367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 275371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 275375 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 275379 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 275383 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 275388 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 275392 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 275396 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 275400 */     // MIs[2] Operand 1
     /* 275400 */     // No operand predicates
     /* 275400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 275404 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 275406 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 275406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 275409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 275417 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 275420 */     GIR_RootConstrainSelectedInstOperands,
     /* 275421 */     // GIR_Coverage, 13177,
     /* 275421 */     GIR_EraseRootFromParent_Done,
     /* 275422 */   // Label 5679: @275422
     /* 275422 */   GIM_Try, /*On fail goto*//*Label 5680*/ GIMT_Encode4(275485), // Rule ID 2005 //
     /* 275427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 275430 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 275434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 275438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 275442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 275446 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 275450 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 275455 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 275459 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 275463 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 275467 */     // MIs[2] Operand 1
     /* 275467 */     // No operand predicates
     /* 275467 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 275469 */     // (fmul:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 275469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 275472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275474 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 275476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 275480 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 275483 */     GIR_RootConstrainSelectedInstOperands,
     /* 275484 */     // GIR_Coverage, 2005,
     /* 275484 */     GIR_EraseRootFromParent_Done,
     /* 275485 */   // Label 5680: @275485
     /* 275485 */   GIM_Try, /*On fail goto*//*Label 5681*/ GIMT_Encode4(275529), // Rule ID 4748 //
     /* 275490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 275493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 275497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 275501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 275505 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 275510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 275514 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275516 */     // (fmul:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$a), FPR16:{ *:[f16] }:$b)  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 275516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 275519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 275525 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 275527 */     GIR_RootConstrainSelectedInstOperands,
     /* 275528 */     // GIR_Coverage, 4748,
     /* 275528 */     GIR_EraseRootFromParent_Done,
     /* 275529 */   // Label 5681: @275529
     /* 275529 */   GIM_Try, /*On fail goto*//*Label 5682*/ GIMT_Encode4(275573), // Rule ID 13567 //
     /* 275534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 275537 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 275541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 275545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 275549 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 275553 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 275558 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275560 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$b, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$a))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 275560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 275563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 275569 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 275571 */     GIR_RootConstrainSelectedInstOperands,
     /* 275572 */     // GIR_Coverage, 13567,
     /* 275572 */     GIR_EraseRootFromParent_Done,
     /* 275573 */   // Label 5682: @275573
     /* 275573 */   GIM_Try, /*On fail goto*//*Label 5683*/ GIMT_Encode4(275600), // Rule ID 620 //
     /* 275578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 275581 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 275585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 275589 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 275589 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 275594 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 275598 */     GIR_RootConstrainSelectedInstOperands,
     /* 275599 */     // GIR_Coverage, 620,
     /* 275599 */     GIR_Done,
     /* 275600 */   // Label 5683: @275600
     /* 275600 */   GIM_Reject,
     /* 275601 */ // Label 5674: @275601
     /* 275601 */ GIM_Reject,
     /* 275602 */ // Label 5663: @275602
     /* 275602 */ GIM_Try, /*On fail goto*//*Label 5684*/ GIMT_Encode4(276231),
     /* 275607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 275610 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 275613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 275617 */   GIM_Try, /*On fail goto*//*Label 5685*/ GIMT_Encode4(275730), // Rule ID 6149 //
     /* 275622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 275629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 275633 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 275637 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 275641 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275646 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 275650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 275654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 275658 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 275662 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 275666 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275671 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 275675 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 275679 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 275683 */     // MIs[3] Operand 1
     /* 275683 */     // No operand predicates
     /* 275683 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 275685 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 275685 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 275688 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 275692 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 275697 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 275703 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 275708 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 275716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275718 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 275721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 275725 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 275728 */     GIR_RootConstrainSelectedInstOperands,
     /* 275729 */     // GIR_Coverage, 6149,
     /* 275729 */     GIR_EraseRootFromParent_Done,
     /* 275730 */   // Label 5685: @275730
     /* 275730 */   GIM_Try, /*On fail goto*//*Label 5686*/ GIMT_Encode4(275843), // Rule ID 13627 //
     /* 275735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 275742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 275746 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 275750 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 275754 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275759 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 275763 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 275767 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 275771 */     // MIs[2] Operand 1
     /* 275771 */     // No operand predicates
     /* 275771 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 275775 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 275779 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 275783 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 275787 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275792 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 275796 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 275798 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 275798 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 275801 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 275805 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 275810 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 275816 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 275821 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 275829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275831 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 275834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 275838 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 275841 */     GIR_RootConstrainSelectedInstOperands,
     /* 275842 */     // GIR_Coverage, 13627,
     /* 275842 */     GIR_EraseRootFromParent_Done,
     /* 275843 */   // Label 5686: @275843
     /* 275843 */   GIM_Try, /*On fail goto*//*Label 5687*/ GIMT_Encode4(275919), // Rule ID 13564 //
     /* 275848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 275852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 275856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 275860 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 275864 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275869 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 275873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 275877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275879 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 275879 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 275882 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 275886 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 275891 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 275897 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 275902 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 275910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275914 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 275917 */     GIR_RootConstrainSelectedInstOperands,
     /* 275918 */     // GIR_Coverage, 13564,
     /* 275918 */     GIR_EraseRootFromParent_Done,
     /* 275919 */   // Label 5687: @275919
     /* 275919 */   GIM_Try, /*On fail goto*//*Label 5688*/ GIMT_Encode4(275995), // Rule ID 4745 //
     /* 275924 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 275928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 275932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 275936 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 275940 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 275944 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275949 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 275953 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275955 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 275955 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 275958 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 275962 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 275967 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 275973 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 275978 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 275986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275988 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 275990 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 275993 */     GIR_RootConstrainSelectedInstOperands,
     /* 275994 */     // GIR_Coverage, 4745,
     /* 275994 */     GIR_EraseRootFromParent_Done,
     /* 275995 */   // Label 5688: @275995
     /* 275995 */   GIM_Try, /*On fail goto*//*Label 5689*/ GIMT_Encode4(276058), // Rule ID 13179 //
     /* 276000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 276007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 276011 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 276015 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 276019 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276024 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 276028 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 276032 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 276036 */     // MIs[2] Operand 1
     /* 276036 */     // No operand predicates
     /* 276036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 276040 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 276042 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 276042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 276045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276047 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 276053 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 276056 */     GIR_RootConstrainSelectedInstOperands,
     /* 276057 */     // GIR_Coverage, 13179,
     /* 276057 */     GIR_EraseRootFromParent_Done,
     /* 276058 */   // Label 5689: @276058
     /* 276058 */   GIM_Try, /*On fail goto*//*Label 5690*/ GIMT_Encode4(276121), // Rule ID 2007 //
     /* 276063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 276070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 276078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 276082 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 276086 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276091 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 276095 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 276099 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 276103 */     // MIs[2] Operand 1
     /* 276103 */     // No operand predicates
     /* 276103 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 276105 */     // (fmul:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 276105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 276108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276110 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 276112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 276116 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 276119 */     GIR_RootConstrainSelectedInstOperands,
     /* 276120 */     // GIR_Coverage, 2007,
     /* 276120 */     GIR_EraseRootFromParent_Done,
     /* 276121 */   // Label 5690: @276121
     /* 276121 */   GIM_Try, /*On fail goto*//*Label 5691*/ GIMT_Encode4(276162), // Rule ID 4749 //
     /* 276126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 276130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 276134 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 276138 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 276143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 276147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276149 */     // (fmul:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$a), FPR32:{ *:[f32] }:$b)  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 276149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 276152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 276158 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 276160 */     GIR_RootConstrainSelectedInstOperands,
     /* 276161 */     // GIR_Coverage, 4749,
     /* 276161 */     GIR_EraseRootFromParent_Done,
     /* 276162 */   // Label 5691: @276162
     /* 276162 */   GIM_Try, /*On fail goto*//*Label 5692*/ GIMT_Encode4(276203), // Rule ID 13568 //
     /* 276167 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 276171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 276179 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 276183 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 276188 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276190 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$b, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$a))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 276190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 276193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 276199 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 276201 */     GIR_RootConstrainSelectedInstOperands,
     /* 276202 */     // GIR_Coverage, 13568,
     /* 276202 */     GIR_EraseRootFromParent_Done,
     /* 276203 */   // Label 5692: @276203
     /* 276203 */   GIM_Try, /*On fail goto*//*Label 5693*/ GIMT_Encode4(276230), // Rule ID 622 //
     /* 276208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 276211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 276215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 276219 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 276219 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 276224 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 276228 */     GIR_RootConstrainSelectedInstOperands,
     /* 276229 */     // GIR_Coverage, 622,
     /* 276229 */     GIR_Done,
     /* 276230 */   // Label 5693: @276230
     /* 276230 */   GIM_Reject,
     /* 276231 */ // Label 5684: @276231
     /* 276231 */ GIM_Reject,
     /* 276232 */ // Label 5664: @276232
     /* 276232 */ GIM_Try, /*On fail goto*//*Label 5694*/ GIMT_Encode4(276861),
     /* 276237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 276240 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 276243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276247 */   GIM_Try, /*On fail goto*//*Label 5695*/ GIMT_Encode4(276360), // Rule ID 6151 //
     /* 276252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 276259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 276263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 276267 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 276271 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276276 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 276280 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 276284 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 276288 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 276292 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 276296 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276301 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 276305 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 276309 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 276313 */     // MIs[3] Operand 1
     /* 276313 */     // No operand predicates
     /* 276313 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 276315 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 276315 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 276318 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 276322 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 276327 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 276333 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276338 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 276346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276348 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 276351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 276355 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 276358 */     GIR_RootConstrainSelectedInstOperands,
     /* 276359 */     // GIR_Coverage, 6151,
     /* 276359 */     GIR_EraseRootFromParent_Done,
     /* 276360 */   // Label 5695: @276360
     /* 276360 */   GIM_Try, /*On fail goto*//*Label 5696*/ GIMT_Encode4(276473), // Rule ID 13629 //
     /* 276365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 276372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 276376 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 276380 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 276384 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 276393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 276397 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 276401 */     // MIs[2] Operand 1
     /* 276401 */     // No operand predicates
     /* 276401 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 276405 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 276409 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 276413 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 276417 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276422 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 276426 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 276428 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 276428 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 276431 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 276435 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 276440 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 276446 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276451 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 276459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 276464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 276468 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 276471 */     GIR_RootConstrainSelectedInstOperands,
     /* 276472 */     // GIR_Coverage, 13629,
     /* 276472 */     GIR_EraseRootFromParent_Done,
     /* 276473 */   // Label 5696: @276473
     /* 276473 */   GIM_Try, /*On fail goto*//*Label 5697*/ GIMT_Encode4(276549), // Rule ID 13566 //
     /* 276478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 276482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 276486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 276490 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 276494 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276499 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 276503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276509 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 276509 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 276512 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 276516 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 276521 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 276527 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276532 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 276540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276544 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 276547 */     GIR_RootConstrainSelectedInstOperands,
     /* 276548 */     // GIR_Coverage, 13566,
     /* 276548 */     GIR_EraseRootFromParent_Done,
     /* 276549 */   // Label 5697: @276549
     /* 276549 */   GIM_Try, /*On fail goto*//*Label 5698*/ GIMT_Encode4(276625), // Rule ID 4747 //
     /* 276554 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 276566 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 276570 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 276574 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276579 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 276583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276585 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 276585 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 276588 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 276592 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 276597 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 276603 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276608 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 276616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276618 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 276620 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 276623 */     GIR_RootConstrainSelectedInstOperands,
     /* 276624 */     // GIR_Coverage, 4747,
     /* 276624 */     GIR_EraseRootFromParent_Done,
     /* 276625 */   // Label 5698: @276625
     /* 276625 */   GIM_Try, /*On fail goto*//*Label 5699*/ GIMT_Encode4(276688), // Rule ID 13181 //
     /* 276630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 276637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 276641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 276645 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 276649 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276654 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 276658 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 276662 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 276666 */     // MIs[2] Operand 1
     /* 276666 */     // No operand predicates
     /* 276666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276670 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 276672 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 276672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 276675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 276683 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 276686 */     GIR_RootConstrainSelectedInstOperands,
     /* 276687 */     // GIR_Coverage, 13181,
     /* 276687 */     GIR_EraseRootFromParent_Done,
     /* 276688 */   // Label 5699: @276688
     /* 276688 */   GIM_Try, /*On fail goto*//*Label 5700*/ GIMT_Encode4(276751), // Rule ID 2009 //
     /* 276693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276696 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 276708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 276712 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 276716 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276721 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 276725 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 276729 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 276733 */     // MIs[2] Operand 1
     /* 276733 */     // No operand predicates
     /* 276733 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 276735 */     // (fmul:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 276735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 276738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276740 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 276742 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 276746 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 276749 */     GIR_RootConstrainSelectedInstOperands,
     /* 276750 */     // GIR_Coverage, 2009,
     /* 276750 */     GIR_EraseRootFromParent_Done,
     /* 276751 */   // Label 5700: @276751
     /* 276751 */   GIM_Try, /*On fail goto*//*Label 5701*/ GIMT_Encode4(276792), // Rule ID 4750 //
     /* 276756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 276760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 276764 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 276768 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276779 */     // (fmul:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$a), FPR64:{ *:[f64] }:$b)  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 276779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 276782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 276788 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 276790 */     GIR_RootConstrainSelectedInstOperands,
     /* 276791 */     // GIR_Coverage, 4750,
     /* 276791 */     GIR_EraseRootFromParent_Done,
     /* 276792 */   // Label 5701: @276792
     /* 276792 */   GIM_Try, /*On fail goto*//*Label 5702*/ GIMT_Encode4(276833), // Rule ID 13569 //
     /* 276797 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 276809 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 276813 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276818 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276820 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$b, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$a))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 276820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 276823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 276829 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 276831 */     GIR_RootConstrainSelectedInstOperands,
     /* 276832 */     // GIR_Coverage, 13569,
     /* 276832 */     GIR_EraseRootFromParent_Done,
     /* 276833 */   // Label 5702: @276833
     /* 276833 */   GIM_Try, /*On fail goto*//*Label 5703*/ GIMT_Encode4(276860), // Rule ID 624 //
     /* 276838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 276841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276849 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 276849 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 276854 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 276858 */     GIR_RootConstrainSelectedInstOperands,
     /* 276859 */     // GIR_Coverage, 624,
     /* 276859 */     GIR_Done,
     /* 276860 */   // Label 5703: @276860
     /* 276860 */   GIM_Reject,
     /* 276861 */ // Label 5694: @276861
     /* 276861 */ GIM_Reject,
     /* 276862 */ // Label 5665: @276862
     /* 276862 */ GIM_Try, /*On fail goto*//*Label 5704*/ GIMT_Encode4(277391),
     /* 276867 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 276870 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 276873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276877 */   GIM_Try, /*On fail goto*//*Label 5705*/ GIMT_Encode4(276963), // Rule ID 13170 //
     /* 276882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 276889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 276893 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 276897 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 276901 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 276905 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 276909 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 276913 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276918 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 276922 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 276926 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 276930 */     // MIs[3] Operand 1
     /* 276930 */     // No operand predicates
     /* 276930 */     // MIs[1] Operand 2
     /* 276930 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 276941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276945 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 276947 */     // (fmul:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 276947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 276950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 276958 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 276961 */     GIR_RootConstrainSelectedInstOperands,
     /* 276962 */     // GIR_Coverage, 13170,
     /* 276962 */     GIR_EraseRootFromParent_Done,
     /* 276963 */   // Label 5705: @276963
     /* 276963 */   GIM_Try, /*On fail goto*//*Label 5706*/ GIMT_Encode4(277049), // Rule ID 1998 //
     /* 276968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276971 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 276983 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 276987 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 276991 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 276995 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 276999 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 277003 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277008 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 277012 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 277016 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 277020 */     // MIs[3] Operand 1
     /* 277020 */     // No operand predicates
     /* 277020 */     // MIs[1] Operand 2
     /* 277020 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 277031 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 277033 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 277033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 277036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277038 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 277040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 277044 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 277047 */     GIR_RootConstrainSelectedInstOperands,
     /* 277048 */     // GIR_Coverage, 1998,
     /* 277048 */     GIR_EraseRootFromParent_Done,
     /* 277049 */   // Label 5706: @277049
     /* 277049 */   GIM_Try, /*On fail goto*//*Label 5707*/ GIMT_Encode4(277112), // Rule ID 13171 //
     /* 277054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 277061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 277065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 277069 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 277073 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277078 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 277082 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 277086 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 277090 */     // MIs[2] Operand 1
     /* 277090 */     // No operand predicates
     /* 277090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277094 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 277096 */     // (fmul:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 277096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 277099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 277107 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 277110 */     GIR_RootConstrainSelectedInstOperands,
     /* 277111 */     // GIR_Coverage, 13171,
     /* 277111 */     GIR_EraseRootFromParent_Done,
     /* 277112 */   // Label 5707: @277112
     /* 277112 */   GIM_Try, /*On fail goto*//*Label 5708*/ GIMT_Encode4(277175), // Rule ID 1999 //
     /* 277117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277120 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 277128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 277132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 277136 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 277140 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277145 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 277149 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 277153 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 277157 */     // MIs[2] Operand 1
     /* 277157 */     // No operand predicates
     /* 277157 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 277159 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 277159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 277162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277164 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 277166 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 277170 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 277173 */     GIR_RootConstrainSelectedInstOperands,
     /* 277174 */     // GIR_Coverage, 1999,
     /* 277174 */     GIR_EraseRootFromParent_Done,
     /* 277175 */   // Label 5708: @277175
     /* 277175 */   GIM_Try, /*On fail goto*//*Label 5709*/ GIMT_Encode4(277269), // Rule ID 13631 //
     /* 277180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 277184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 277188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 277192 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 277197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277203 */     // (fmul:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 277203 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 277206 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 277210 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277215 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 277217 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 277220 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 277224 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277229 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 277232 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 277236 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 277239 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277244 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277249 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 277254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 277257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277259 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277261 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 277264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 277267 */     GIR_RootConstrainSelectedInstOperands,
     /* 277268 */     // GIR_Coverage, 13631,
     /* 277268 */     GIR_EraseRootFromParent_Done,
     /* 277269 */   // Label 5709: @277269
     /* 277269 */   GIM_Try, /*On fail goto*//*Label 5710*/ GIMT_Encode4(277363), // Rule ID 6153 //
     /* 277274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 277282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 277286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 277290 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 277295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277297 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 277297 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 277300 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 277304 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277309 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 277311 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 277314 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 277318 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277323 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 277326 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 277330 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 277333 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277338 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277343 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 277348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 277351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277353 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 277355 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 277358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 277361 */     GIR_RootConstrainSelectedInstOperands,
     /* 277362 */     // GIR_Coverage, 6153,
     /* 277362 */     GIR_EraseRootFromParent_Done,
     /* 277363 */   // Label 5710: @277363
     /* 277363 */   GIM_Try, /*On fail goto*//*Label 5711*/ GIMT_Encode4(277390), // Rule ID 1316 //
     /* 277368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277379 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 277379 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f32),
     /* 277384 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 277388 */     GIR_RootConstrainSelectedInstOperands,
     /* 277389 */     // GIR_Coverage, 1316,
     /* 277389 */     GIR_Done,
     /* 277390 */   // Label 5711: @277390
     /* 277390 */   GIM_Reject,
     /* 277391 */ // Label 5704: @277391
     /* 277391 */ GIM_Reject,
     /* 277392 */ // Label 5666: @277392
     /* 277392 */ GIM_Try, /*On fail goto*//*Label 5712*/ GIMT_Encode4(277749),
     /* 277397 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 277400 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 277403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277407 */   GIM_Try, /*On fail goto*//*Label 5713*/ GIMT_Encode4(277470), // Rule ID 13175 //
     /* 277412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 277419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 277423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 277427 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 277431 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277436 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 277440 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 277444 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 277448 */     // MIs[2] Operand 1
     /* 277448 */     // No operand predicates
     /* 277448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277452 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 277454 */     // (fmul:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 277454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 277457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 277465 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 277468 */     GIR_RootConstrainSelectedInstOperands,
     /* 277469 */     // GIR_Coverage, 13175,
     /* 277469 */     GIR_EraseRootFromParent_Done,
     /* 277470 */   // Label 5713: @277470
     /* 277470 */   GIM_Try, /*On fail goto*//*Label 5714*/ GIMT_Encode4(277533), // Rule ID 2003 //
     /* 277475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277478 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 277486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 277490 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 277494 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 277498 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277503 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 277507 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 277511 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 277515 */     // MIs[2] Operand 1
     /* 277515 */     // No operand predicates
     /* 277515 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 277517 */     // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 277517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 277520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277522 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 277524 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 277528 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 277531 */     GIR_RootConstrainSelectedInstOperands,
     /* 277532 */     // GIR_Coverage, 2003,
     /* 277532 */     GIR_EraseRootFromParent_Done,
     /* 277533 */   // Label 5714: @277533
     /* 277533 */   GIM_Try, /*On fail goto*//*Label 5715*/ GIMT_Encode4(277627), // Rule ID 13635 //
     /* 277538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 277542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 277546 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 277550 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277561 */     // (fmul:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 277561 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 277564 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 277568 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277573 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 277575 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 277578 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 277582 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277587 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 277590 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 277594 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 277597 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277602 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277607 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 277615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277619 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 277622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 277625 */     GIR_RootConstrainSelectedInstOperands,
     /* 277626 */     // GIR_Coverage, 13635,
     /* 277626 */     GIR_EraseRootFromParent_Done,
     /* 277627 */   // Label 5715: @277627
     /* 277627 */   GIM_Try, /*On fail goto*//*Label 5716*/ GIMT_Encode4(277721), // Rule ID 6157 //
     /* 277632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 277640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 277644 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 277648 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277655 */     // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 277655 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 277658 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 277662 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277667 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 277669 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 277672 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 277676 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277681 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 277684 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 277688 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 277691 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277696 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277701 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 277709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277711 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 277713 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 277716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 277719 */     GIR_RootConstrainSelectedInstOperands,
     /* 277720 */     // GIR_Coverage, 6157,
     /* 277720 */     GIR_EraseRootFromParent_Done,
     /* 277721 */   // Label 5716: @277721
     /* 277721 */   GIM_Try, /*On fail goto*//*Label 5717*/ GIMT_Encode4(277748), // Rule ID 1320 //
     /* 277726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277729 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277737 */     // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 277737 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f64),
     /* 277742 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 277746 */     GIR_RootConstrainSelectedInstOperands,
     /* 277747 */     // GIR_Coverage, 1320,
     /* 277747 */     GIR_Done,
     /* 277748 */   // Label 5717: @277748
     /* 277748 */   GIM_Reject,
     /* 277749 */ // Label 5712: @277749
     /* 277749 */ GIM_Reject,
     /* 277750 */ // Label 5667: @277750
     /* 277750 */ GIM_Try, /*On fail goto*//*Label 5718*/ GIMT_Encode4(278091),
     /* 277755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 277758 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 277761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277765 */   GIM_Try, /*On fail goto*//*Label 5719*/ GIMT_Encode4(277851), // Rule ID 13164 //
     /* 277770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 277773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 277777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 277781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 277785 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 277789 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 277793 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 277797 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 277801 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 277806 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 277810 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 277814 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 277818 */     // MIs[3] Operand 1
     /* 277818 */     // No operand predicates
     /* 277818 */     // MIs[1] Operand 2
     /* 277818 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 277829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277833 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 277835 */     // (fmul:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 277835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 277838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 277846 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 277849 */     GIR_RootConstrainSelectedInstOperands,
     /* 277850 */     // GIR_Coverage, 13164,
     /* 277850 */     GIR_EraseRootFromParent_Done,
     /* 277851 */   // Label 5719: @277851
     /* 277851 */   GIM_Try, /*On fail goto*//*Label 5720*/ GIMT_Encode4(277937), // Rule ID 1992 //
     /* 277856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 277859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 277867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 277871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 277875 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 277879 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 277883 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 277887 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 277891 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 277896 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 277900 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 277904 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 277908 */     // MIs[3] Operand 1
     /* 277908 */     // No operand predicates
     /* 277908 */     // MIs[1] Operand 2
     /* 277908 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 277919 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 277921 */     // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 277921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 277924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277926 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 277928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 277932 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 277935 */     GIR_RootConstrainSelectedInstOperands,
     /* 277936 */     // GIR_Coverage, 1992,
     /* 277936 */     GIR_EraseRootFromParent_Done,
     /* 277937 */   // Label 5720: @277937
     /* 277937 */   GIM_Try, /*On fail goto*//*Label 5721*/ GIMT_Encode4(278000), // Rule ID 13165 //
     /* 277942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 277945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 277949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 277953 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 277957 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 277961 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 277966 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 277970 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 277974 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 277978 */     // MIs[2] Operand 1
     /* 277978 */     // No operand predicates
     /* 277978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277982 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 277984 */     // (fmul:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 277984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 277987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 277995 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 277998 */     GIR_RootConstrainSelectedInstOperands,
     /* 277999 */     // GIR_Coverage, 13165,
     /* 277999 */     GIR_EraseRootFromParent_Done,
     /* 278000 */   // Label 5721: @278000
     /* 278000 */   GIM_Try, /*On fail goto*//*Label 5722*/ GIMT_Encode4(278063), // Rule ID 1993 //
     /* 278005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 278008 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 278016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 278020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 278024 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 278028 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 278033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 278037 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 278041 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 278045 */     // MIs[2] Operand 1
     /* 278045 */     // No operand predicates
     /* 278045 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 278047 */     // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 278047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 278050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278052 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 278054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 278058 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 278061 */     GIR_RootConstrainSelectedInstOperands,
     /* 278062 */     // GIR_Coverage, 1993,
     /* 278062 */     GIR_EraseRootFromParent_Done,
     /* 278063 */   // Label 5722: @278063
     /* 278063 */   GIM_Try, /*On fail goto*//*Label 5723*/ GIMT_Encode4(278090), // Rule ID 1312 //
     /* 278068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 278071 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278079 */     // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 278079 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f16),
     /* 278084 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 278088 */     GIR_RootConstrainSelectedInstOperands,
     /* 278089 */     // GIR_Coverage, 1312,
     /* 278089 */     GIR_Done,
     /* 278090 */   // Label 5723: @278090
     /* 278090 */   GIM_Reject,
     /* 278091 */ // Label 5718: @278091
     /* 278091 */ GIM_Reject,
     /* 278092 */ // Label 5668: @278092
     /* 278092 */ GIM_Try, /*On fail goto*//*Label 5724*/ GIMT_Encode4(278449),
     /* 278097 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 278100 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 278103 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278107 */   GIM_Try, /*On fail goto*//*Label 5725*/ GIMT_Encode4(278170), // Rule ID 13173 //
     /* 278112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 278123 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 278127 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 278131 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278136 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 278140 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 278144 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 278148 */     // MIs[2] Operand 1
     /* 278148 */     // No operand predicates
     /* 278148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278152 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 278154 */     // (fmul:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 278154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 278157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278159 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 278165 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 278168 */     GIR_RootConstrainSelectedInstOperands,
     /* 278169 */     // GIR_Coverage, 13173,
     /* 278169 */     GIR_EraseRootFromParent_Done,
     /* 278170 */   // Label 5725: @278170
     /* 278170 */   GIM_Try, /*On fail goto*//*Label 5726*/ GIMT_Encode4(278233), // Rule ID 2001 //
     /* 278175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 278186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 278190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 278194 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 278198 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278203 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 278207 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 278211 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 278215 */     // MIs[2] Operand 1
     /* 278215 */     // No operand predicates
     /* 278215 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 278217 */     // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 278217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 278220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278222 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 278224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 278228 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 278231 */     GIR_RootConstrainSelectedInstOperands,
     /* 278232 */     // GIR_Coverage, 2001,
     /* 278232 */     GIR_EraseRootFromParent_Done,
     /* 278233 */   // Label 5726: @278233
     /* 278233 */   GIM_Try, /*On fail goto*//*Label 5727*/ GIMT_Encode4(278327), // Rule ID 13633 //
     /* 278238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 278246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 278250 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 278255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278259 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278261 */     // (fmul:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 278261 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 278264 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 278268 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278273 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 278275 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 278278 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 278282 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278287 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 278290 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 278294 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 278297 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278302 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278307 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 278312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 278315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278319 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 278322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 278325 */     GIR_RootConstrainSelectedInstOperands,
     /* 278326 */     // GIR_Coverage, 13633,
     /* 278326 */     GIR_EraseRootFromParent_Done,
     /* 278327 */   // Label 5727: @278327
     /* 278327 */   GIM_Try, /*On fail goto*//*Label 5728*/ GIMT_Encode4(278421), // Rule ID 6155 //
     /* 278332 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 278340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 278344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 278348 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 278353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278355 */     // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 278355 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 278358 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 278362 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278367 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 278369 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 278372 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 278376 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278381 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 278384 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 278388 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 278391 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278396 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278401 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 278406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 278409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278411 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 278413 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 278416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 278419 */     GIR_RootConstrainSelectedInstOperands,
     /* 278420 */     // GIR_Coverage, 6155,
     /* 278420 */     GIR_EraseRootFromParent_Done,
     /* 278421 */   // Label 5728: @278421
     /* 278421 */   GIM_Try, /*On fail goto*//*Label 5729*/ GIMT_Encode4(278448), // Rule ID 1318 //
     /* 278426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278437 */     // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 278437 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 278442 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 278446 */     GIR_RootConstrainSelectedInstOperands,
     /* 278447 */     // GIR_Coverage, 1318,
     /* 278447 */     GIR_Done,
     /* 278448 */   // Label 5729: @278448
     /* 278448 */   GIM_Reject,
     /* 278449 */ // Label 5724: @278449
     /* 278449 */ GIM_Reject,
     /* 278450 */ // Label 5669: @278450
     /* 278450 */ GIM_Try, /*On fail goto*//*Label 5730*/ GIMT_Encode4(278881),
     /* 278455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 278458 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 278461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278465 */   GIM_Try, /*On fail goto*//*Label 5731*/ GIMT_Encode4(278528), // Rule ID 13167 //
     /* 278470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 278473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 278481 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 278485 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 278489 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 278494 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 278498 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 278502 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 278506 */     // MIs[2] Operand 1
     /* 278506 */     // No operand predicates
     /* 278506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278510 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 278512 */     // (fmul:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 278512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 278515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 278523 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 278526 */     GIR_RootConstrainSelectedInstOperands,
     /* 278527 */     // GIR_Coverage, 13167,
     /* 278527 */     GIR_EraseRootFromParent_Done,
     /* 278528 */   // Label 5731: @278528
     /* 278528 */   GIM_Try, /*On fail goto*//*Label 5732*/ GIMT_Encode4(278591), // Rule ID 1995 //
     /* 278533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 278536 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 278544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 278548 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 278552 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 278556 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 278561 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 278565 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 278569 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 278573 */     // MIs[2] Operand 1
     /* 278573 */     // No operand predicates
     /* 278573 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 278575 */     // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 278575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 278578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278580 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 278582 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 278586 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 278589 */     GIR_RootConstrainSelectedInstOperands,
     /* 278590 */     // GIR_Coverage, 1995,
     /* 278590 */     GIR_EraseRootFromParent_Done,
     /* 278591 */   // Label 5732: @278591
     /* 278591 */   GIM_Try, /*On fail goto*//*Label 5733*/ GIMT_Encode4(278618), // Rule ID 1314 //
     /* 278596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 278599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278607 */     // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 278607 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv8f16),
     /* 278612 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 278616 */     GIR_RootConstrainSelectedInstOperands,
     /* 278617 */     // GIR_Coverage, 1314,
     /* 278617 */     GIR_Done,
     /* 278618 */   // Label 5733: @278618
     /* 278618 */   GIM_Try, /*On fail goto*//*Label 5734*/ GIMT_Encode4(278880), // Rule ID 6918 //
     /* 278623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 278626 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278634 */     // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FMULv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FMULv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 278634 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 278637 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 278641 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278646 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 278650 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 278652 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 278655 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 278659 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278664 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 278668 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 278670 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 278673 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 278677 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278682 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 278685 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 278688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 278690 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 278693 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 278697 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278702 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 278708 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278713 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278718 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 278721 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 278725 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278730 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 278733 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 278735 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 278738 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 278742 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278747 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 278753 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278758 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278763 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 278766 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 278770 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278775 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 278778 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 278780 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 278783 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 278787 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278792 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 278795 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 278798 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 278800 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 278803 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 278807 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278812 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 278815 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 278817 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 278820 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 278824 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278829 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 278831 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 278834 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 278838 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278843 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 278846 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 278849 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 278852 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278857 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278862 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 278870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 278872 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 278875 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 278878 */     GIR_RootConstrainSelectedInstOperands,
     /* 278879 */     // GIR_Coverage, 6918,
     /* 278879 */     GIR_EraseRootFromParent_Done,
     /* 278880 */   // Label 5734: @278880
     /* 278880 */   GIM_Reject,
     /* 278881 */ // Label 5730: @278881
     /* 278881 */ GIM_Reject,
     /* 278882 */ // Label 5670: @278882
     /* 278882 */ GIM_Try, /*On fail goto*//*Label 5735*/ GIMT_Encode4(278907), // Rule ID 8050 //
     /* 278887 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 278890 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 278893 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 278896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 278900 */   // (fmul:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMUL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 278900 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_D),
     /* 278905 */   GIR_RootConstrainSelectedInstOperands,
     /* 278906 */   // GIR_Coverage, 8050,
     /* 278906 */   GIR_Done,
     /* 278907 */ // Label 5735: @278907
     /* 278907 */ GIM_Reject,
     /* 278908 */ // Label 5671: @278908
     /* 278908 */ GIM_Try, /*On fail goto*//*Label 5736*/ GIMT_Encode4(278933), // Rule ID 8048 //
     /* 278913 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 278916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 278919 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 278922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 278926 */   // (fmul:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMUL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 278926 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_S),
     /* 278931 */   GIR_RootConstrainSelectedInstOperands,
     /* 278932 */   // GIR_Coverage, 8048,
     /* 278932 */   GIR_Done,
     /* 278933 */ // Label 5736: @278933
     /* 278933 */ GIM_Reject,
     /* 278934 */ // Label 5672: @278934
     /* 278934 */ GIM_Try, /*On fail goto*//*Label 5737*/ GIMT_Encode4(278959), // Rule ID 8046 //
     /* 278939 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 278942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 278945 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 278948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 278952 */   // (fmul:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMUL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 278952 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_H),
     /* 278957 */   GIR_RootConstrainSelectedInstOperands,
     /* 278958 */   // GIR_Coverage, 8046,
     /* 278958 */   GIR_Done,
     /* 278959 */ // Label 5737: @278959
     /* 278959 */ GIM_Reject,
     /* 278960 */ // Label 5673: @278960
     /* 278960 */ GIM_Reject,
     /* 278961 */ // Label 57: @278961
     /* 278961 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 5746*/ GIMT_Encode4(295233),
     /* 278972 */ /*GILLT_s16*//*Label 5738*/ GIMT_Encode4(279012),
     /* 278976 */ /*GILLT_s32*//*Label 5739*/ GIMT_Encode4(282016),
     /* 278980 */ /*GILLT_s64*//*Label 5740*/ GIMT_Encode4(285164), GIMT_Encode4(0),
     /* 278988 */ /*GILLT_v2s32*//*Label 5741*/ GIMT_Encode4(288312),
     /* 278992 */ /*GILLT_v2s64*//*Label 5742*/ GIMT_Encode4(289833),
     /* 278996 */ /*GILLT_v4s16*//*Label 5743*/ GIMT_Encode4(291354),
     /* 279000 */ /*GILLT_v4s32*//*Label 5744*/ GIMT_Encode4(292533), GIMT_Encode4(0),
     /* 279008 */ /*GILLT_v8s16*//*Label 5745*/ GIMT_Encode4(294054),
     /* 279012 */ // Label 5738: @279012
     /* 279012 */ GIM_Try, /*On fail goto*//*Label 5747*/ GIMT_Encode4(282015),
     /* 279017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 279020 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 279023 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 279026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279030 */   GIM_Try, /*On fail goto*//*Label 5748*/ GIMT_Encode4(279180), // Rule ID 4805 //
     /* 279035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 279038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279046 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 279050 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 279054 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279059 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 279063 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 279067 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279071 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 279075 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 279079 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279084 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 279088 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 279092 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 279096 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 279100 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279105 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 279107 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 279107 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 279110 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 279114 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279119 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 279125 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279130 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279135 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 279138 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 279142 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279147 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 279153 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279158 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 279166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279168 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279171 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 279174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 279178 */     GIR_RootConstrainSelectedInstOperands,
     /* 279179 */     // GIR_Coverage, 4805,
     /* 279179 */     GIR_EraseRootFromParent_Done,
     /* 279180 */   // Label 5748: @279180
     /* 279180 */   GIM_Try, /*On fail goto*//*Label 5749*/ GIMT_Encode4(279327), // Rule ID 4769 //
     /* 279185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 279188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279196 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 279200 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 279204 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279209 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 279213 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 279217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 279221 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 279225 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 279229 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279233 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 279237 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 279241 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279246 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 279250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279254 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 279256 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 279256 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 279259 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 279263 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279268 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 279274 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279279 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279284 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 279287 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 279291 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279296 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 279302 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279307 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 279315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279317 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279320 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 279323 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 279325 */     GIR_RootConstrainSelectedInstOperands,
     /* 279326 */     // GIR_Coverage, 4769,
     /* 279326 */     GIR_EraseRootFromParent_Done,
     /* 279327 */   // Label 5749: @279327
     /* 279327 */   GIM_Try, /*On fail goto*//*Label 5750*/ GIMT_Encode4(279474), // Rule ID 13575 //
     /* 279332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 279335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 279343 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 279347 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 279351 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279355 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 279359 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 279363 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279368 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 279372 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 279376 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279380 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 279384 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 279388 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279393 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 279397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279401 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 279403 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 279403 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 279406 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 279410 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279415 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 279421 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279426 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279431 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 279434 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 279438 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279443 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 279449 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279454 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 279462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279467 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 279470 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 279472 */     GIR_RootConstrainSelectedInstOperands,
     /* 279473 */     // GIR_Coverage, 13575,
     /* 279473 */     GIR_EraseRootFromParent_Done,
     /* 279474 */   // Label 5750: @279474
     /* 279474 */   GIM_Try, /*On fail goto*//*Label 5751*/ GIMT_Encode4(279605), // Rule ID 5985 //
     /* 279479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 279482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279490 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 279494 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 279498 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279503 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 279507 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 279511 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 279515 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 279519 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 279523 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279527 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 279531 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 279535 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 279540 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 279544 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 279548 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 279552 */     // MIs[4] Operand 1
     /* 279552 */     // No operand predicates
     /* 279552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279556 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 279558 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 279558 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 279561 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 279565 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279570 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 279576 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279581 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 279589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 279591 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 279593 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279596 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 279600 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 279603 */     GIR_RootConstrainSelectedInstOperands,
     /* 279604 */     // GIR_Coverage, 5985,
     /* 279604 */     GIR_EraseRootFromParent_Done,
     /* 279605 */   // Label 5751: @279605
     /* 279605 */   GIM_Try, /*On fail goto*//*Label 5752*/ GIMT_Encode4(279736), // Rule ID 6017 //
     /* 279610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 279613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 279625 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 279629 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 279634 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 279638 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 279642 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 279646 */     // MIs[2] Operand 1
     /* 279646 */     // No operand predicates
     /* 279646 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 279650 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 279654 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 279658 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 279662 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279666 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 279670 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 279674 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279679 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 279683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279687 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 279689 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 279689 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 279692 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 279696 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279701 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 279707 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279712 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 279720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 279722 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 279724 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 279731 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 279734 */     GIR_RootConstrainSelectedInstOperands,
     /* 279735 */     // GIR_Coverage, 6017,
     /* 279735 */     GIR_EraseRootFromParent_Done,
     /* 279736 */   // Label 5752: @279736
     /* 279736 */   GIM_Try, /*On fail goto*//*Label 5753*/ GIMT_Encode4(279867), // Rule ID 6081 //
     /* 279741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 279744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 279752 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 279756 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 279760 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279764 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 279768 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 279772 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279777 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 279781 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 279785 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279789 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 279793 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 279797 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 279802 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 279806 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 279810 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 279814 */     // MIs[4] Operand 1
     /* 279814 */     // No operand predicates
     /* 279814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279818 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 279820 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 279820 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 279823 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 279827 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279832 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 279838 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279843 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 279851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 279853 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 279855 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 279862 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 279865 */     GIR_RootConstrainSelectedInstOperands,
     /* 279866 */     // GIR_Coverage, 6081,
     /* 279866 */     GIR_EraseRootFromParent_Done,
     /* 279867 */   // Label 5753: @279867
     /* 279867 */   GIM_Try, /*On fail goto*//*Label 5754*/ GIMT_Encode4(279998), // Rule ID 6049 //
     /* 279872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 279875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 279883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 279887 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 279891 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279895 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 279899 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 279903 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 279908 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 279912 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 279916 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 279920 */     // MIs[3] Operand 1
     /* 279920 */     // No operand predicates
     /* 279920 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 279924 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279928 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 279932 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 279936 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279941 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 279945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279949 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 279951 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 279951 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 279954 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 279958 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279963 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 279969 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279974 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 279982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 279984 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 279986 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279989 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 279993 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 279996 */     GIR_RootConstrainSelectedInstOperands,
     /* 279997 */     // GIR_Coverage, 6049,
     /* 279997 */     GIR_EraseRootFromParent_Done,
     /* 279998 */   // Label 5754: @279998
     /* 279998 */   GIM_Try, /*On fail goto*//*Label 5755*/ GIMT_Encode4(280133), // Rule ID 2447 //
     /* 280003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 280006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 280014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280018 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 280022 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280027 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 280031 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 280035 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 280039 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280043 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 280047 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280052 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 280056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280060 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280062 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 280062 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 280065 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 280069 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280074 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 280080 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280085 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280090 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 280093 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 280097 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280102 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 280108 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280113 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 280121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280123 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280126 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 280129 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 280131 */     GIR_RootConstrainSelectedInstOperands,
     /* 280132 */     // GIR_Coverage, 2447,
     /* 280132 */     GIR_EraseRootFromParent_Done,
     /* 280133 */   // Label 5755: @280133
     /* 280133 */   GIM_Try, /*On fail goto*//*Label 5756*/ GIMT_Encode4(280252), // Rule ID 5953 //
     /* 280138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 280141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 280149 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280153 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 280157 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280162 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 280166 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 280170 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 280174 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280178 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 280182 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 280187 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 280191 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 280195 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 280199 */     // MIs[3] Operand 1
     /* 280199 */     // No operand predicates
     /* 280199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280203 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 280205 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 280205 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 280208 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 280212 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280217 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 280223 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280228 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 280236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 280238 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 280240 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 280247 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 280250 */     GIR_RootConstrainSelectedInstOperands,
     /* 280251 */     // GIR_Coverage, 5953,
     /* 280251 */     GIR_EraseRootFromParent_Done,
     /* 280252 */   // Label 5756: @280252
     /* 280252 */   GIM_Try, /*On fail goto*//*Label 5757*/ GIMT_Encode4(280371), // Rule ID 2529 //
     /* 280257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 280260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 280268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280272 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 280276 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 280281 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 280285 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 280289 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 280293 */     // MIs[2] Operand 1
     /* 280293 */     // No operand predicates
     /* 280293 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 280297 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 280301 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280305 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 280309 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280314 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 280318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280322 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 280324 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 280324 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 280327 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 280331 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280336 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 280342 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280347 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 280355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 280357 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 280359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 280366 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 280369 */     GIR_RootConstrainSelectedInstOperands,
     /* 280370 */     // GIR_Coverage, 2529,
     /* 280370 */     GIR_EraseRootFromParent_Done,
     /* 280371 */   // Label 5757: @280371
     /* 280371 */   GIM_Try, /*On fail goto*//*Label 5758*/ GIMT_Encode4(280471), // Rule ID 4767 //
     /* 280376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 280379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 280387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280391 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 280395 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280400 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 280404 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 280408 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 280412 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 280416 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280425 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280427 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 280427 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 280430 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 280434 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280439 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 280445 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280450 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 280458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 280467 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 280469 */     GIR_RootConstrainSelectedInstOperands,
     /* 280470 */     // GIR_Coverage, 4767,
     /* 280470 */     GIR_EraseRootFromParent_Done,
     /* 280471 */   // Label 5758: @280471
     /* 280471 */   GIM_Try, /*On fail goto*//*Label 5759*/ GIMT_Encode4(280571), // Rule ID 4803 //
     /* 280476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 280479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 280487 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280491 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 280495 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280500 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 280504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280508 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 280512 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 280516 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 280520 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280525 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280527 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 280527 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 280530 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 280534 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280539 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 280545 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280550 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 280558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280560 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 280565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 280569 */     GIR_RootConstrainSelectedInstOperands,
     /* 280570 */     // GIR_Coverage, 4803,
     /* 280570 */     GIR_EraseRootFromParent_Done,
     /* 280571 */   // Label 5759: @280571
     /* 280571 */   GIM_Try, /*On fail goto*//*Label 5760*/ GIMT_Encode4(280668), // Rule ID 13571 //
     /* 280576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 280579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 280587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 280591 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 280595 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 280599 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280603 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 280607 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280612 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 280616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280624 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280626 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 280626 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 280629 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 280633 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280638 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 280644 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280649 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 280657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280659 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 280661 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280664 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 280666 */     GIR_RootConstrainSelectedInstOperands,
     /* 280667 */     // GIR_Coverage, 13571,
     /* 280667 */     GIR_EraseRootFromParent_Done,
     /* 280668 */   // Label 5760: @280668
     /* 280668 */   GIM_Try, /*On fail goto*//*Label 5761*/ GIMT_Encode4(280768), // Rule ID 13573 //
     /* 280673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 280676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 280684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 280688 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280693 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 280697 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 280701 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280705 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 280709 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280714 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 280718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280722 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280724 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 280724 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 280727 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 280731 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280736 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 280742 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280747 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 280755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280757 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 280764 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 280766 */     GIR_RootConstrainSelectedInstOperands,
     /* 280767 */     // GIR_Coverage, 13573,
     /* 280767 */     GIR_EraseRootFromParent_Done,
     /* 280768 */   // Label 5761: @280768
     /* 280768 */   GIM_Try, /*On fail goto*//*Label 5762*/ GIMT_Encode4(280868), // Rule ID 4801 //
     /* 280773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 280776 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 280784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 280788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280792 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 280796 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280801 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 280805 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 280809 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 280813 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 280817 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280822 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280824 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 280824 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 280827 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 280831 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280836 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 280842 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280847 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 280855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280857 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 280859 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 280866 */     GIR_RootConstrainSelectedInstOperands,
     /* 280867 */     // GIR_Coverage, 4801,
     /* 280867 */     GIR_EraseRootFromParent_Done,
     /* 280868 */   // Label 5762: @280868
     /* 280868 */   GIM_Try, /*On fail goto*//*Label 5763*/ GIMT_Encode4(280965), // Rule ID 4765 //
     /* 280873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 280876 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 280884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 280888 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 280892 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 280896 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 280900 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280904 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 280908 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280913 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 280917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280921 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280923 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 280923 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 280926 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 280930 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280935 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 280941 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280946 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 280954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280956 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 280958 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280961 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 280963 */     GIR_RootConstrainSelectedInstOperands,
     /* 280964 */     // GIR_Coverage, 4765,
     /* 280964 */     GIR_EraseRootFromParent_Done,
     /* 280965 */   // Label 5763: @280965
     /* 280965 */   GIM_Try, /*On fail goto*//*Label 5764*/ GIMT_Encode4(281049), // Rule ID 6015 //
     /* 280970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 280973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 280981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280985 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 280989 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 280994 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 280998 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281002 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 281006 */     // MIs[2] Operand 1
     /* 281006 */     // No operand predicates
     /* 281006 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 281010 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 281014 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 281018 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281027 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 281029 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 281029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 281032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 281034 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 281036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 281040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 281044 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 281047 */     GIR_RootConstrainSelectedInstOperands,
     /* 281048 */     // GIR_Coverage, 6015,
     /* 281048 */     GIR_EraseRootFromParent_Done,
     /* 281049 */   // Label 5764: @281049
     /* 281049 */   GIM_Try, /*On fail goto*//*Label 5765*/ GIMT_Encode4(281130), // Rule ID 6047 //
     /* 281054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 281057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 281065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 281069 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 281073 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 281077 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 281081 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 281085 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 281090 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 281094 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281098 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 281102 */     // MIs[3] Operand 1
     /* 281102 */     // No operand predicates
     /* 281102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281110 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 281112 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 281112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 281115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 281117 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 281119 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 281121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 281125 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 281128 */     GIR_RootConstrainSelectedInstOperands,
     /* 281129 */     // GIR_Coverage, 6047,
     /* 281129 */     GIR_EraseRootFromParent_Done,
     /* 281130 */   // Label 5765: @281130
     /* 281130 */   GIM_Try, /*On fail goto*//*Label 5766*/ GIMT_Encode4(281214), // Rule ID 6079 //
     /* 281135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 281138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 281146 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 281150 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 281159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 281163 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 281167 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 281171 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 281176 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 281180 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281184 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 281188 */     // MIs[3] Operand 1
     /* 281188 */     // No operand predicates
     /* 281188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281192 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 281194 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 281194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 281197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 281199 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 281201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 281205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 281209 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 281212 */     GIR_RootConstrainSelectedInstOperands,
     /* 281213 */     // GIR_Coverage, 6079,
     /* 281213 */     GIR_EraseRootFromParent_Done,
     /* 281214 */   // Label 5766: @281214
     /* 281214 */   GIM_Try, /*On fail goto*//*Label 5767*/ GIMT_Encode4(281295), // Rule ID 5983 //
     /* 281219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 281222 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 281230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 281234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 281238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 281242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 281246 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 281250 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 281254 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 281259 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 281263 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281267 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 281271 */     // MIs[3] Operand 1
     /* 281271 */     // No operand predicates
     /* 281271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281275 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 281277 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 281277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 281280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 281282 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 281284 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 281286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 281290 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 281293 */     GIR_RootConstrainSelectedInstOperands,
     /* 281294 */     // GIR_Coverage, 5983,
     /* 281294 */     GIR_EraseRootFromParent_Done,
     /* 281295 */   // Label 5767: @281295
     /* 281295 */   GIM_Try, /*On fail goto*//*Label 5768*/ GIMT_Encode4(281380), // Rule ID 2445 //
     /* 281300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 281303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 281311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 281315 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 281319 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281324 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 281328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281336 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281338 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 281338 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 281341 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281345 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281350 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 281356 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281361 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 281369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281371 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281374 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 281376 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 281378 */     GIR_RootConstrainSelectedInstOperands,
     /* 281379 */     // GIR_Coverage, 2445,
     /* 281379 */     GIR_EraseRootFromParent_Done,
     /* 281380 */   // Label 5768: @281380
     /* 281380 */   GIM_Try, /*On fail goto*//*Label 5769*/ GIMT_Encode4(281465), // Rule ID 2443 //
     /* 281385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 281388 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 281396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 281400 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 281404 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 281408 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281413 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 281417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281423 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 281423 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 281426 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281430 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281435 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 281441 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281446 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 281454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281456 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 281458 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281461 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 281463 */     GIR_RootConstrainSelectedInstOperands,
     /* 281464 */     // GIR_Coverage, 2443,
     /* 281464 */     GIR_EraseRootFromParent_Done,
     /* 281465 */   // Label 5769: @281465
     /* 281465 */   GIM_Try, /*On fail goto*//*Label 5770*/ GIMT_Encode4(281534), // Rule ID 2527 //
     /* 281470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 281473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 281481 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 281485 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 281489 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 281494 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 281498 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281502 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 281506 */     // MIs[2] Operand 1
     /* 281506 */     // No operand predicates
     /* 281506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281514 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 281516 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 281516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 281519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 281521 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 281523 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 281525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 281529 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 281532 */     GIR_RootConstrainSelectedInstOperands,
     /* 281533 */     // GIR_Coverage, 2527,
     /* 281533 */     GIR_EraseRootFromParent_Done,
     /* 281534 */   // Label 5770: @281534
     /* 281534 */   GIM_Try, /*On fail goto*//*Label 5771*/ GIMT_Encode4(281603), // Rule ID 5951 //
     /* 281539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 281542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 281550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 281554 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 281558 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 281562 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 281567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 281571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281575 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 281579 */     // MIs[2] Operand 1
     /* 281579 */     // No operand predicates
     /* 281579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281583 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 281585 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 281585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 281588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 281590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 281592 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 281594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 281598 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 281601 */     GIR_RootConstrainSelectedInstOperands,
     /* 281602 */     // GIR_Coverage, 5951,
     /* 281602 */     GIR_EraseRootFromParent_Done,
     /* 281603 */   // Label 5771: @281603
     /* 281603 */   GIM_Try, /*On fail goto*//*Label 5772*/ GIMT_Encode4(281668), // Rule ID 4821 //
     /* 281608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 281611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 281619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 281623 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281632 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 281636 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 281640 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 281644 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281649 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 281651 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 281651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 281654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 281660 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 281662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 281666 */     GIR_RootConstrainSelectedInstOperands,
     /* 281667 */     // GIR_Coverage, 4821,
     /* 281667 */     GIR_EraseRootFromParent_Done,
     /* 281668 */   // Label 5772: @281668
     /* 281668 */   GIM_Try, /*On fail goto*//*Label 5773*/ GIMT_Encode4(281733), // Rule ID 13591 //
     /* 281673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 281676 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 281684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 281688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 281692 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281697 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 281701 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 281705 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 281709 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281714 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 281716 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 281716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 281719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 281725 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 281727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 281731 */     GIR_RootConstrainSelectedInstOperands,
     /* 281732 */     // GIR_Coverage, 13591,
     /* 281732 */     GIR_EraseRootFromParent_Done,
     /* 281733 */   // Label 5773: @281733
     /* 281733 */   GIM_Try, /*On fail goto*//*Label 5774*/ GIMT_Encode4(281783), // Rule ID 4818 //
     /* 281738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 281741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 281749 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 281753 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281766 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281768 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 281768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 281771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281773 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 281777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 281779 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 281781 */     GIR_RootConstrainSelectedInstOperands,
     /* 281782 */     // GIR_Coverage, 4818,
     /* 281782 */     GIR_EraseRootFromParent_Done,
     /* 281783 */   // Label 5774: @281783
     /* 281783 */   GIM_Try, /*On fail goto*//*Label 5775*/ GIMT_Encode4(281833), // Rule ID 13017 //
     /* 281788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 281791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 281799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 281803 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281816 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281818 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 281818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 281821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 281825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 281829 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 281831 */     GIR_RootConstrainSelectedInstOperands,
     /* 281832 */     // GIR_Coverage, 13017,
     /* 281832 */     GIR_EraseRootFromParent_Done,
     /* 281833 */   // Label 5775: @281833
     /* 281833 */   GIM_Try, /*On fail goto*//*Label 5776*/ GIMT_Encode4(281883), // Rule ID 644 //
     /* 281838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 281841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 281849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 281853 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 281857 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281866 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281868 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 281868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 281871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281873 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 281875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 281879 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 281881 */     GIR_RootConstrainSelectedInstOperands,
     /* 281882 */     // GIR_Coverage, 644,
     /* 281882 */     GIR_EraseRootFromParent_Done,
     /* 281883 */   // Label 5776: @281883
     /* 281883 */   GIM_Try, /*On fail goto*//*Label 5777*/ GIMT_Encode4(281933), // Rule ID 13588 //
     /* 281888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 281891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 281899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 281903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 281907 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281916 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281918 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 281918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 281921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 281927 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 281929 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 281931 */     GIR_RootConstrainSelectedInstOperands,
     /* 281932 */     // GIR_Coverage, 13588,
     /* 281932 */     GIR_EraseRootFromParent_Done,
     /* 281933 */   // Label 5777: @281933
     /* 281933 */   GIM_Try, /*On fail goto*//*Label 5778*/ GIMT_Encode4(281983), // Rule ID 656 //
     /* 281938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 281941 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 281953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 281957 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 281961 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281966 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281968 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 281968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 281971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281973 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 281975 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 281977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 281981 */     GIR_RootConstrainSelectedInstOperands,
     /* 281982 */     // GIR_Coverage, 656,
     /* 281982 */     GIR_EraseRootFromParent_Done,
     /* 281983 */   // Label 5778: @281983
     /* 281983 */   GIM_Try, /*On fail goto*//*Label 5779*/ GIMT_Encode4(282014), // Rule ID 638 //
     /* 281988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 281991 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282003 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 282003 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 282008 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 282012 */     GIR_RootConstrainSelectedInstOperands,
     /* 282013 */     // GIR_Coverage, 638,
     /* 282013 */     GIR_Done,
     /* 282014 */   // Label 5779: @282014
     /* 282014 */   GIM_Reject,
     /* 282015 */ // Label 5747: @282015
     /* 282015 */ GIM_Reject,
     /* 282016 */ // Label 5739: @282016
     /* 282016 */ GIM_Try, /*On fail goto*//*Label 5780*/ GIMT_Encode4(285163),
     /* 282021 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 282024 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 282027 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 282030 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282034 */   GIM_Try, /*On fail goto*//*Label 5781*/ GIMT_Encode4(282184), // Rule ID 4811 //
     /* 282039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 282042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282050 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 282054 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 282058 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282063 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 282067 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 282071 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282075 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 282079 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 282083 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282088 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 282092 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 282096 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 282100 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 282104 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282109 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 282111 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 282111 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 282114 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282118 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282123 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 282129 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282134 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282139 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 282142 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282146 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282151 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 282157 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282162 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 282170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282172 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282175 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 282178 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 282182 */     GIR_RootConstrainSelectedInstOperands,
     /* 282183 */     // GIR_Coverage, 4811,
     /* 282183 */     GIR_EraseRootFromParent_Done,
     /* 282184 */   // Label 5781: @282184
     /* 282184 */   GIM_Try, /*On fail goto*//*Label 5782*/ GIMT_Encode4(282331), // Rule ID 4775 //
     /* 282189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 282192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 282204 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 282208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282213 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 282217 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 282221 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 282225 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 282229 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 282233 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282237 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 282241 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 282245 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282250 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 282254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282258 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 282260 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 282260 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 282263 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282267 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282272 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 282278 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282283 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 282291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282300 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 282306 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282311 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 282319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282321 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282324 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 282327 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 282329 */     GIR_RootConstrainSelectedInstOperands,
     /* 282330 */     // GIR_Coverage, 4775,
     /* 282330 */     GIR_EraseRootFromParent_Done,
     /* 282331 */   // Label 5782: @282331
     /* 282331 */   GIM_Try, /*On fail goto*//*Label 5783*/ GIMT_Encode4(282478), // Rule ID 13581 //
     /* 282336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 282339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 282347 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 282351 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 282355 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282359 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 282363 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 282367 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282372 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 282376 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 282380 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282384 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 282388 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 282392 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282397 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 282401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282405 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 282407 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 282407 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 282410 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282414 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282419 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 282425 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282430 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282435 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 282438 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282442 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282447 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 282453 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282458 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 282466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282468 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282471 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 282474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 282476 */     GIR_RootConstrainSelectedInstOperands,
     /* 282477 */     // GIR_Coverage, 13581,
     /* 282477 */     GIR_EraseRootFromParent_Done,
     /* 282478 */   // Label 5783: @282478
     /* 282478 */   GIM_Try, /*On fail goto*//*Label 5784*/ GIMT_Encode4(282609), // Rule ID 6001 //
     /* 282483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282494 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 282498 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 282502 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282507 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 282511 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 282515 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 282519 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 282523 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 282527 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282531 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 282535 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 282539 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282544 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 282548 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 282552 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 282556 */     // MIs[4] Operand 1
     /* 282556 */     // No operand predicates
     /* 282556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282560 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 282562 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 282562 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 282565 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282569 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282574 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 282580 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282585 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 282593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 282595 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 282597 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 282604 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 282607 */     GIR_RootConstrainSelectedInstOperands,
     /* 282608 */     // GIR_Coverage, 6001,
     /* 282608 */     GIR_EraseRootFromParent_Done,
     /* 282609 */   // Label 5784: @282609
     /* 282609 */   GIM_Try, /*On fail goto*//*Label 5785*/ GIMT_Encode4(282740), // Rule ID 6033 //
     /* 282614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282625 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 282629 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 282633 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282638 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 282642 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 282646 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 282650 */     // MIs[2] Operand 1
     /* 282650 */     // No operand predicates
     /* 282650 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 282654 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 282658 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 282662 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 282666 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282670 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 282674 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 282678 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282683 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 282687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282691 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 282693 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 282693 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 282696 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282700 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282705 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 282711 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282716 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 282724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 282726 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 282728 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 282735 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 282738 */     GIR_RootConstrainSelectedInstOperands,
     /* 282739 */     // GIR_Coverage, 6033,
     /* 282739 */     GIR_EraseRootFromParent_Done,
     /* 282740 */   // Label 5785: @282740
     /* 282740 */   GIM_Try, /*On fail goto*//*Label 5786*/ GIMT_Encode4(282871), // Rule ID 6097 //
     /* 282745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 282756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 282760 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 282764 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282768 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 282772 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 282776 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282781 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 282785 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 282789 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282793 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 282797 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 282801 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282806 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 282810 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 282814 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 282818 */     // MIs[4] Operand 1
     /* 282818 */     // No operand predicates
     /* 282818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282822 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 282824 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 282824 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 282827 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282831 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282836 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 282842 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282847 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 282855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 282857 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 282859 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 282866 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 282869 */     GIR_RootConstrainSelectedInstOperands,
     /* 282870 */     // GIR_Coverage, 6097,
     /* 282870 */     GIR_EraseRootFromParent_Done,
     /* 282871 */   // Label 5786: @282871
     /* 282871 */   GIM_Try, /*On fail goto*//*Label 5787*/ GIMT_Encode4(283002), // Rule ID 6065 //
     /* 282876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 282887 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 282891 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 282895 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282899 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 282903 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 282907 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282912 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 282916 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 282920 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 282924 */     // MIs[3] Operand 1
     /* 282924 */     // No operand predicates
     /* 282924 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 282928 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282932 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 282936 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 282940 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282945 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 282949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282953 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 282955 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 282955 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 282958 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282962 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282967 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 282973 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282978 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 282986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 282988 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 282990 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 282997 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 283000 */     GIR_RootConstrainSelectedInstOperands,
     /* 283001 */     // GIR_Coverage, 6065,
     /* 283001 */     GIR_EraseRootFromParent_Done,
     /* 283002 */   // Label 5787: @283002
     /* 283002 */   GIM_Try, /*On fail goto*//*Label 5788*/ GIMT_Encode4(283137), // Rule ID 2453 //
     /* 283007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 283010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 283022 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283026 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283031 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 283035 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 283039 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283043 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 283047 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 283051 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283056 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 283060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283064 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283066 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 283066 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 283069 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283073 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283078 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 283084 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283089 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283094 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 283097 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283101 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283106 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 283112 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283117 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 283125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283127 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283130 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 283133 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 283135 */     GIR_RootConstrainSelectedInstOperands,
     /* 283136 */     // GIR_Coverage, 2453,
     /* 283136 */     GIR_EraseRootFromParent_Done,
     /* 283137 */   // Label 5788: @283137
     /* 283137 */   GIM_Try, /*On fail goto*//*Label 5789*/ GIMT_Encode4(283256), // Rule ID 5969 //
     /* 283142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 283157 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283161 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283166 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 283170 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 283174 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283178 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 283182 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 283186 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283191 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 283195 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 283199 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 283203 */     // MIs[3] Operand 1
     /* 283203 */     // No operand predicates
     /* 283203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283207 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 283209 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 283209 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 283212 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283216 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283221 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 283227 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283232 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 283240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 283242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 283244 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 283251 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 283254 */     GIR_RootConstrainSelectedInstOperands,
     /* 283255 */     // GIR_Coverage, 5969,
     /* 283255 */     GIR_EraseRootFromParent_Done,
     /* 283256 */   // Label 5789: @283256
     /* 283256 */   GIM_Try, /*On fail goto*//*Label 5790*/ GIMT_Encode4(283375), // Rule ID 2545 //
     /* 283261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 283276 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283280 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283285 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 283289 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 283293 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 283297 */     // MIs[2] Operand 1
     /* 283297 */     // No operand predicates
     /* 283297 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 283301 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283305 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 283309 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 283313 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283318 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 283322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283326 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 283328 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 283328 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 283331 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283335 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283340 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 283346 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283351 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 283359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 283361 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 283363 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 283370 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 283373 */     GIR_RootConstrainSelectedInstOperands,
     /* 283374 */     // GIR_Coverage, 2545,
     /* 283374 */     GIR_EraseRootFromParent_Done,
     /* 283375 */   // Label 5790: @283375
     /* 283375 */   GIM_Try, /*On fail goto*//*Label 5791*/ GIMT_Encode4(283475), // Rule ID 4773 //
     /* 283380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 283383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283391 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 283395 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283399 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283404 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 283408 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 283412 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 283416 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 283420 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283429 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283431 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 283431 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 283434 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283438 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283443 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 283449 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283454 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 283462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 283471 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 283473 */     GIR_RootConstrainSelectedInstOperands,
     /* 283474 */     // GIR_Coverage, 4773,
     /* 283474 */     GIR_EraseRootFromParent_Done,
     /* 283475 */   // Label 5791: @283475
     /* 283475 */   GIM_Try, /*On fail goto*//*Label 5792*/ GIMT_Encode4(283575), // Rule ID 4809 //
     /* 283480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 283483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283491 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 283495 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283499 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283504 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 283508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283512 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 283516 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 283520 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 283524 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283529 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283531 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 283531 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 283534 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283538 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283543 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 283549 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283554 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 283562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283564 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 283569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 283573 */     GIR_RootConstrainSelectedInstOperands,
     /* 283574 */     // GIR_Coverage, 4809,
     /* 283574 */     GIR_EraseRootFromParent_Done,
     /* 283575 */   // Label 5792: @283575
     /* 283575 */   GIM_Try, /*On fail goto*//*Label 5793*/ GIMT_Encode4(283672), // Rule ID 13577 //
     /* 283580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 283583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 283591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 283595 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 283599 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283603 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 283607 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 283611 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283616 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 283620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283628 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283630 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 283630 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 283633 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283637 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283642 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 283648 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283653 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 283661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283663 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 283665 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283668 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 283670 */     GIR_RootConstrainSelectedInstOperands,
     /* 283671 */     // GIR_Coverage, 13577,
     /* 283671 */     GIR_EraseRootFromParent_Done,
     /* 283672 */   // Label 5793: @283672
     /* 283672 */   GIM_Try, /*On fail goto*//*Label 5794*/ GIMT_Encode4(283772), // Rule ID 13579 //
     /* 283677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 283680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 283688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 283692 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283697 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 283701 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283705 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 283709 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 283713 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283718 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 283722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283726 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283728 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 283728 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 283731 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283735 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283740 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 283746 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283751 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 283759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283761 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 283768 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 283770 */     GIR_RootConstrainSelectedInstOperands,
     /* 283771 */     // GIR_Coverage, 13579,
     /* 283771 */     GIR_EraseRootFromParent_Done,
     /* 283772 */   // Label 5794: @283772
     /* 283772 */   GIM_Try, /*On fail goto*//*Label 5795*/ GIMT_Encode4(283872), // Rule ID 4807 //
     /* 283777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 283780 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 283788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283792 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 283796 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283800 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283805 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 283809 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 283813 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 283817 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 283821 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283826 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283828 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 283828 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 283831 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283835 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283840 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 283846 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283851 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 283859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283861 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 283863 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 283870 */     GIR_RootConstrainSelectedInstOperands,
     /* 283871 */     // GIR_Coverage, 4807,
     /* 283871 */     GIR_EraseRootFromParent_Done,
     /* 283872 */   // Label 5795: @283872
     /* 283872 */   GIM_Try, /*On fail goto*//*Label 5796*/ GIMT_Encode4(283969), // Rule ID 4771 //
     /* 283877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 283880 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 283888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 283892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 283896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 283900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283904 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 283908 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 283912 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283917 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 283921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283925 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283927 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 283927 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 283930 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283934 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283939 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 283945 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283950 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 283958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283960 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 283962 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283965 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 283967 */     GIR_RootConstrainSelectedInstOperands,
     /* 283968 */     // GIR_Coverage, 4771,
     /* 283968 */     GIR_EraseRootFromParent_Done,
     /* 283969 */   // Label 5796: @283969
     /* 283969 */   GIM_Try, /*On fail goto*//*Label 5797*/ GIMT_Encode4(284047), // Rule ID 6119 //
     /* 283974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283982 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 283986 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283990 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 283994 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 283998 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 284002 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284007 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 284011 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284015 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 284019 */     // MIs[3] Operand 1
     /* 284019 */     // No operand predicates
     /* 284019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284027 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 284029 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 284029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 284032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 284034 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 284036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 284038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 284042 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 284045 */     GIR_RootConstrainSelectedInstOperands,
     /* 284046 */     // GIR_Coverage, 6119,
     /* 284046 */     GIR_EraseRootFromParent_Done,
     /* 284047 */   // Label 5797: @284047
     /* 284047 */   GIM_Try, /*On fail goto*//*Label 5798*/ GIMT_Encode4(284131), // Rule ID 6031 //
     /* 284052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 284067 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 284071 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284076 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 284080 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284084 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 284088 */     // MIs[2] Operand 1
     /* 284088 */     // No operand predicates
     /* 284088 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 284092 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 284096 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 284100 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284109 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 284111 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 284111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 284114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 284116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 284118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 284122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 284126 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 284129 */     GIR_RootConstrainSelectedInstOperands,
     /* 284130 */     // GIR_Coverage, 6031,
     /* 284130 */     GIR_EraseRootFromParent_Done,
     /* 284131 */   // Label 5798: @284131
     /* 284131 */   GIM_Try, /*On fail goto*//*Label 5799*/ GIMT_Encode4(284212), // Rule ID 6063 //
     /* 284136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 284147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 284151 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 284155 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284159 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 284163 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 284167 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284172 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 284176 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284180 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 284184 */     // MIs[3] Operand 1
     /* 284184 */     // No operand predicates
     /* 284184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284192 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 284194 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 284194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 284197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 284199 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 284201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 284203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 284207 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 284210 */     GIR_RootConstrainSelectedInstOperands,
     /* 284211 */     // GIR_Coverage, 6063,
     /* 284211 */     GIR_EraseRootFromParent_Done,
     /* 284212 */   // Label 5799: @284212
     /* 284212 */   GIM_Try, /*On fail goto*//*Label 5800*/ GIMT_Encode4(284296), // Rule ID 6095 //
     /* 284217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 284228 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 284232 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284237 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 284241 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284245 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 284249 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 284253 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284258 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 284262 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284266 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 284270 */     // MIs[3] Operand 1
     /* 284270 */     // No operand predicates
     /* 284270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284274 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 284276 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 284276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 284279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 284281 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 284283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 284287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 284291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 284294 */     GIR_RootConstrainSelectedInstOperands,
     /* 284295 */     // GIR_Coverage, 6095,
     /* 284295 */     GIR_EraseRootFromParent_Done,
     /* 284296 */   // Label 5800: @284296
     /* 284296 */   GIM_Try, /*On fail goto*//*Label 5801*/ GIMT_Encode4(284374), // Rule ID 6141 //
     /* 284301 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 284309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 284317 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 284321 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 284325 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 284329 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 284333 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284338 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 284342 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284346 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 284350 */     // MIs[3] Operand 1
     /* 284350 */     // No operand predicates
     /* 284350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284354 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 284356 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 284356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 284359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 284361 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 284363 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 284365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 284369 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 284372 */     GIR_RootConstrainSelectedInstOperands,
     /* 284373 */     // GIR_Coverage, 6141,
     /* 284373 */     GIR_EraseRootFromParent_Done,
     /* 284374 */   // Label 5801: @284374
     /* 284374 */   GIM_Try, /*On fail goto*//*Label 5802*/ GIMT_Encode4(284455), // Rule ID 5999 //
     /* 284379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284382 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 284390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 284394 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 284398 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 284402 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284406 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 284410 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 284414 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284419 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 284423 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284427 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 284431 */     // MIs[3] Operand 1
     /* 284431 */     // No operand predicates
     /* 284431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284435 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 284437 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 284437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 284440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 284442 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 284444 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 284446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 284450 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 284453 */     GIR_RootConstrainSelectedInstOperands,
     /* 284454 */     // GIR_Coverage, 5999,
     /* 284454 */     GIR_EraseRootFromParent_Done,
     /* 284455 */   // Label 5802: @284455
     /* 284455 */   GIM_Try, /*On fail goto*//*Label 5803*/ GIMT_Encode4(284540), // Rule ID 2451 //
     /* 284460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 284463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 284475 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 284479 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284484 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 284488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284496 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284498 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 284498 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 284501 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284505 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284510 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 284516 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284521 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 284529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284531 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 284536 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 284538 */     GIR_RootConstrainSelectedInstOperands,
     /* 284539 */     // GIR_Coverage, 2451,
     /* 284539 */     GIR_EraseRootFromParent_Done,
     /* 284540 */   // Label 5803: @284540
     /* 284540 */   GIM_Try, /*On fail goto*//*Label 5804*/ GIMT_Encode4(284625), // Rule ID 2449 //
     /* 284545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 284548 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 284556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 284564 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 284568 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284573 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 284577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284583 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 284583 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 284586 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284590 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284595 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 284601 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284606 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 284614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284616 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 284618 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284621 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 284623 */     GIR_RootConstrainSelectedInstOperands,
     /* 284624 */     // GIR_Coverage, 2449,
     /* 284624 */     GIR_EraseRootFromParent_Done,
     /* 284625 */   // Label 5804: @284625
     /* 284625 */   GIM_Try, /*On fail goto*//*Label 5805*/ GIMT_Encode4(284694), // Rule ID 2543 //
     /* 284630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 284645 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 284649 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284654 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 284658 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284662 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 284666 */     // MIs[2] Operand 1
     /* 284666 */     // No operand predicates
     /* 284666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284674 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284676 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 284676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 284679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 284681 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 284683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 284685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 284689 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 284692 */     GIR_RootConstrainSelectedInstOperands,
     /* 284693 */     // GIR_Coverage, 2543,
     /* 284693 */     GIR_EraseRootFromParent_Done,
     /* 284694 */   // Label 5805: @284694
     /* 284694 */   GIM_Try, /*On fail goto*//*Label 5806*/ GIMT_Encode4(284763), // Rule ID 5967 //
     /* 284699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284702 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 284710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284714 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 284718 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 284722 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284727 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 284731 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284735 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 284739 */     // MIs[2] Operand 1
     /* 284739 */     // No operand predicates
     /* 284739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284743 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284745 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 284745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 284748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 284750 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 284752 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 284754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 284758 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 284761 */     GIR_RootConstrainSelectedInstOperands,
     /* 284762 */     // GIR_Coverage, 5967,
     /* 284762 */     GIR_EraseRootFromParent_Done,
     /* 284763 */   // Label 5806: @284763
     /* 284763 */   GIM_Try, /*On fail goto*//*Label 5807*/ GIMT_Encode4(284825), // Rule ID 4822 //
     /* 284768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 284776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 284780 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284789 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 284793 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 284797 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 284801 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284806 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284808 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 284808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 284811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 284817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 284819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 284823 */     GIR_RootConstrainSelectedInstOperands,
     /* 284824 */     // GIR_Coverage, 4822,
     /* 284824 */     GIR_EraseRootFromParent_Done,
     /* 284825 */   // Label 5807: @284825
     /* 284825 */   GIM_Try, /*On fail goto*//*Label 5808*/ GIMT_Encode4(284887), // Rule ID 13592 //
     /* 284830 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 284838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 284842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 284846 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284851 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 284855 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 284859 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 284863 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284868 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284870 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 284870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 284873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 284879 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 284881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 284885 */     GIR_RootConstrainSelectedInstOperands,
     /* 284886 */     // GIR_Coverage, 13592,
     /* 284886 */     GIR_EraseRootFromParent_Done,
     /* 284887 */   // Label 5808: @284887
     /* 284887 */   GIM_Try, /*On fail goto*//*Label 5809*/ GIMT_Encode4(284934), // Rule ID 4819 //
     /* 284892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 284900 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 284904 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284917 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284919 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 284919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 284922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 284928 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 284930 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 284932 */     GIR_RootConstrainSelectedInstOperands,
     /* 284933 */     // GIR_Coverage, 4819,
     /* 284933 */     GIR_EraseRootFromParent_Done,
     /* 284934 */   // Label 5809: @284934
     /* 284934 */   GIM_Try, /*On fail goto*//*Label 5810*/ GIMT_Encode4(284984), // Rule ID 13019 //
     /* 284939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 284942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 284950 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 284954 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284969 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 284969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 284972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284974 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 284976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 284980 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 284982 */     GIR_RootConstrainSelectedInstOperands,
     /* 284983 */     // GIR_Coverage, 13019,
     /* 284983 */     GIR_EraseRootFromParent_Done,
     /* 284984 */   // Label 5810: @284984
     /* 284984 */   GIM_Try, /*On fail goto*//*Label 5811*/ GIMT_Encode4(285034), // Rule ID 646 //
     /* 284989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 284992 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 285000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 285004 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 285008 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285019 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 285019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 285022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285024 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 285026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 285030 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 285032 */     GIR_RootConstrainSelectedInstOperands,
     /* 285033 */     // GIR_Coverage, 646,
     /* 285033 */     GIR_EraseRootFromParent_Done,
     /* 285034 */   // Label 5811: @285034
     /* 285034 */   GIM_Try, /*On fail goto*//*Label 5812*/ GIMT_Encode4(285081), // Rule ID 13589 //
     /* 285039 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 285047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 285051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 285055 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285064 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285066 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 285066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 285069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 285075 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 285077 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 285079 */     GIR_RootConstrainSelectedInstOperands,
     /* 285080 */     // GIR_Coverage, 13589,
     /* 285080 */     GIR_EraseRootFromParent_Done,
     /* 285081 */   // Label 5812: @285081
     /* 285081 */   GIM_Try, /*On fail goto*//*Label 5813*/ GIMT_Encode4(285131), // Rule ID 658 //
     /* 285086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 285089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 285101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 285105 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 285109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285114 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285116 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 285116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 285119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285121 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 285123 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 285125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 285129 */     GIR_RootConstrainSelectedInstOperands,
     /* 285130 */     // GIR_Coverage, 658,
     /* 285130 */     GIR_EraseRootFromParent_Done,
     /* 285131 */   // Label 5813: @285131
     /* 285131 */   GIM_Try, /*On fail goto*//*Label 5814*/ GIMT_Encode4(285162), // Rule ID 640 //
     /* 285136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 285139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285151 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 285151 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 285156 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 285160 */     GIR_RootConstrainSelectedInstOperands,
     /* 285161 */     // GIR_Coverage, 640,
     /* 285161 */     GIR_Done,
     /* 285162 */   // Label 5814: @285162
     /* 285162 */   GIM_Reject,
     /* 285163 */ // Label 5780: @285163
     /* 285163 */ GIM_Reject,
     /* 285164 */ // Label 5740: @285164
     /* 285164 */ GIM_Try, /*On fail goto*//*Label 5815*/ GIMT_Encode4(288311),
     /* 285169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 285172 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 285175 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 285178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285182 */   GIM_Try, /*On fail goto*//*Label 5816*/ GIMT_Encode4(285332), // Rule ID 4817 //
     /* 285187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 285190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 285202 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 285206 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285211 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 285215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 285219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285223 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 285227 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 285231 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285236 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 285240 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 285244 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 285248 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 285252 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285257 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 285259 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 285259 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 285262 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285266 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285271 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 285277 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285282 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285287 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 285290 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285294 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285299 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 285305 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285310 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 285318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285320 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285323 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 285326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 285330 */     GIR_RootConstrainSelectedInstOperands,
     /* 285331 */     // GIR_Coverage, 4817,
     /* 285331 */     GIR_EraseRootFromParent_Done,
     /* 285332 */   // Label 5816: @285332
     /* 285332 */   GIM_Try, /*On fail goto*//*Label 5817*/ GIMT_Encode4(285479), // Rule ID 4781 //
     /* 285337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 285340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285348 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 285352 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 285356 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285361 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 285365 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 285369 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 285373 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 285377 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 285381 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285385 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 285389 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 285393 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285398 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 285402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285406 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 285408 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 285408 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 285411 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285415 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285420 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 285426 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285431 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285436 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 285439 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285443 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285448 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 285454 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285459 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 285467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285469 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285472 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 285475 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 285477 */     GIR_RootConstrainSelectedInstOperands,
     /* 285478 */     // GIR_Coverage, 4781,
     /* 285478 */     GIR_EraseRootFromParent_Done,
     /* 285479 */   // Label 5817: @285479
     /* 285479 */   GIM_Try, /*On fail goto*//*Label 5818*/ GIMT_Encode4(285626), // Rule ID 13587 //
     /* 285484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 285487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 285495 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 285499 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 285503 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285507 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 285511 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 285515 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285520 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 285524 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 285528 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285532 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 285536 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 285540 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285545 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 285549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285553 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 285555 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 285555 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 285558 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285562 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285567 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 285573 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285578 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285583 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 285586 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285590 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285595 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 285601 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285606 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 285614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285616 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285619 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 285622 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 285624 */     GIR_RootConstrainSelectedInstOperands,
     /* 285625 */     // GIR_Coverage, 13587,
     /* 285625 */     GIR_EraseRootFromParent_Done,
     /* 285626 */   // Label 5818: @285626
     /* 285626 */   GIM_Try, /*On fail goto*//*Label 5819*/ GIMT_Encode4(285757), // Rule ID 6005 //
     /* 285631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 285646 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 285650 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285655 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 285659 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 285663 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 285667 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 285671 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 285675 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285679 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 285683 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 285687 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285692 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 285696 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 285700 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 285704 */     // MIs[4] Operand 1
     /* 285704 */     // No operand predicates
     /* 285704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285708 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 285710 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 285710 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 285713 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285717 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285722 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 285728 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285733 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 285741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 285743 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 285745 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 285752 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 285755 */     GIR_RootConstrainSelectedInstOperands,
     /* 285756 */     // GIR_Coverage, 6005,
     /* 285756 */     GIR_EraseRootFromParent_Done,
     /* 285757 */   // Label 5819: @285757
     /* 285757 */   GIM_Try, /*On fail goto*//*Label 5820*/ GIMT_Encode4(285888), // Rule ID 6037 //
     /* 285762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 285777 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 285781 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285786 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 285790 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 285794 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 285798 */     // MIs[2] Operand 1
     /* 285798 */     // No operand predicates
     /* 285798 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 285802 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 285806 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 285810 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 285814 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285818 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 285822 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 285826 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285831 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 285835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285839 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 285841 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 285841 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 285844 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285848 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285853 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 285859 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285864 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 285872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 285874 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 285876 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 285883 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 285886 */     GIR_RootConstrainSelectedInstOperands,
     /* 285887 */     // GIR_Coverage, 6037,
     /* 285887 */     GIR_EraseRootFromParent_Done,
     /* 285888 */   // Label 5820: @285888
     /* 285888 */   GIM_Try, /*On fail goto*//*Label 5821*/ GIMT_Encode4(286019), // Rule ID 6101 //
     /* 285893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 285904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 285908 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 285912 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285916 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 285920 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 285924 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285929 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 285933 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 285937 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285941 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 285945 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 285949 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285954 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 285958 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 285962 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 285966 */     // MIs[4] Operand 1
     /* 285966 */     // No operand predicates
     /* 285966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285970 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 285972 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 285972 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 285975 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285979 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285984 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 285990 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285995 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 286003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 286005 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 286007 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 286014 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 286017 */     GIR_RootConstrainSelectedInstOperands,
     /* 286018 */     // GIR_Coverage, 6101,
     /* 286018 */     GIR_EraseRootFromParent_Done,
     /* 286019 */   // Label 5821: @286019
     /* 286019 */   GIM_Try, /*On fail goto*//*Label 5822*/ GIMT_Encode4(286150), // Rule ID 6069 //
     /* 286024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 286027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 286035 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 286039 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 286043 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286047 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 286051 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 286055 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286060 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 286064 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286068 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 286072 */     // MIs[3] Operand 1
     /* 286072 */     // No operand predicates
     /* 286072 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 286076 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286080 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 286084 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 286088 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286093 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 286097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286101 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 286103 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 286103 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 286106 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286110 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286115 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 286121 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286126 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 286134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 286136 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 286138 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 286145 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 286148 */     GIR_RootConstrainSelectedInstOperands,
     /* 286149 */     // GIR_Coverage, 6069,
     /* 286149 */     GIR_EraseRootFromParent_Done,
     /* 286150 */   // Label 5822: @286150
     /* 286150 */   GIM_Try, /*On fail goto*//*Label 5823*/ GIMT_Encode4(286285), // Rule ID 2459 //
     /* 286155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 286158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286166 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 286170 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286174 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286179 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 286183 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286187 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286191 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 286195 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 286199 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286204 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 286208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286212 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286214 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 286214 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 286217 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286221 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286226 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 286232 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286237 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286242 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 286245 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286249 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286254 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 286260 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286265 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 286273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286275 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286278 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 286281 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 286283 */     GIR_RootConstrainSelectedInstOperands,
     /* 286284 */     // GIR_Coverage, 2459,
     /* 286284 */     GIR_EraseRootFromParent_Done,
     /* 286285 */   // Label 5823: @286285
     /* 286285 */   GIM_Try, /*On fail goto*//*Label 5824*/ GIMT_Encode4(286404), // Rule ID 5973 //
     /* 286290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 286293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286301 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 286305 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286309 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286314 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 286318 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286322 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286326 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 286330 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 286334 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286339 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 286343 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286347 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 286351 */     // MIs[3] Operand 1
     /* 286351 */     // No operand predicates
     /* 286351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286355 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 286357 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 286357 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 286360 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286364 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286369 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 286375 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286380 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 286388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 286390 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 286392 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 286399 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 286402 */     GIR_RootConstrainSelectedInstOperands,
     /* 286403 */     // GIR_Coverage, 5973,
     /* 286403 */     GIR_EraseRootFromParent_Done,
     /* 286404 */   // Label 5824: @286404
     /* 286404 */   GIM_Try, /*On fail goto*//*Label 5825*/ GIMT_Encode4(286523), // Rule ID 2549 //
     /* 286409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 286412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 286424 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286428 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 286437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286441 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 286445 */     // MIs[2] Operand 1
     /* 286445 */     // No operand predicates
     /* 286445 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 286449 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286453 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 286457 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 286461 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286466 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 286470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286474 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 286476 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 286476 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 286479 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286483 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286488 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 286494 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286499 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 286507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 286509 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 286511 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286514 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286518 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 286521 */     GIR_RootConstrainSelectedInstOperands,
     /* 286522 */     // GIR_Coverage, 2549,
     /* 286522 */     GIR_EraseRootFromParent_Done,
     /* 286523 */   // Label 5825: @286523
     /* 286523 */   GIM_Try, /*On fail goto*//*Label 5826*/ GIMT_Encode4(286623), // Rule ID 4779 //
     /* 286528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 286531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 286543 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286547 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286552 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 286556 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286560 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 286564 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 286568 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286577 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286579 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 286579 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 286582 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286586 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286591 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 286597 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286602 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 286610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286612 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 286619 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 286621 */     GIR_RootConstrainSelectedInstOperands,
     /* 286622 */     // GIR_Coverage, 4779,
     /* 286622 */     GIR_EraseRootFromParent_Done,
     /* 286623 */   // Label 5826: @286623
     /* 286623 */   GIM_Try, /*On fail goto*//*Label 5827*/ GIMT_Encode4(286723), // Rule ID 4815 //
     /* 286628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 286631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286639 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 286643 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286647 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286652 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 286656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286660 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 286664 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 286668 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 286672 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286677 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286679 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 286679 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 286682 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286686 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286691 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 286697 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286702 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 286710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286712 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286715 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 286717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 286721 */     GIR_RootConstrainSelectedInstOperands,
     /* 286722 */     // GIR_Coverage, 4815,
     /* 286722 */     GIR_EraseRootFromParent_Done,
     /* 286723 */   // Label 5827: @286723
     /* 286723 */   GIM_Try, /*On fail goto*//*Label 5828*/ GIMT_Encode4(286820), // Rule ID 13583 //
     /* 286728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 286731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 286739 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 286743 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 286747 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286751 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 286755 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 286759 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286764 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 286768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286776 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286778 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 286778 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 286781 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286785 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286790 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 286796 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286801 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 286809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 286813 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286816 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 286818 */     GIR_RootConstrainSelectedInstOperands,
     /* 286819 */     // GIR_Coverage, 13583,
     /* 286819 */     GIR_EraseRootFromParent_Done,
     /* 286820 */   // Label 5828: @286820
     /* 286820 */   GIM_Try, /*On fail goto*//*Label 5829*/ GIMT_Encode4(286920), // Rule ID 13585 //
     /* 286825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 286828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 286836 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 286840 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286853 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 286857 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 286861 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286866 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 286870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286874 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286876 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 286876 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 286879 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286883 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286888 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 286894 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286899 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 286907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286909 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286916 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 286918 */     GIR_RootConstrainSelectedInstOperands,
     /* 286919 */     // GIR_Coverage, 13585,
     /* 286919 */     GIR_EraseRootFromParent_Done,
     /* 286920 */   // Label 5829: @286920
     /* 286920 */   GIM_Try, /*On fail goto*//*Label 5830*/ GIMT_Encode4(287020), // Rule ID 4813 //
     /* 286925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 286928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286940 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 286944 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286948 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286953 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 286957 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 286961 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 286965 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 286969 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286974 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286976 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 286976 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 286979 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286983 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286988 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 286994 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286999 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 287007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287009 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287011 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 287018 */     GIR_RootConstrainSelectedInstOperands,
     /* 287019 */     // GIR_Coverage, 4813,
     /* 287019 */     GIR_EraseRootFromParent_Done,
     /* 287020 */   // Label 5830: @287020
     /* 287020 */   GIM_Try, /*On fail goto*//*Label 5831*/ GIMT_Encode4(287117), // Rule ID 4777 //
     /* 287025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 287028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287040 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 287044 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 287048 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287052 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287056 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 287060 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287065 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 287069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287073 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287075 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 287075 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 287078 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 287082 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287087 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 287093 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287098 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 287106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287108 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287110 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287113 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 287115 */     GIR_RootConstrainSelectedInstOperands,
     /* 287116 */     // GIR_Coverage, 4777,
     /* 287116 */     GIR_EraseRootFromParent_Done,
     /* 287117 */   // Label 5831: @287117
     /* 287117 */   GIM_Try, /*On fail goto*//*Label 5832*/ GIMT_Encode4(287195), // Rule ID 6123 //
     /* 287122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287134 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 287142 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287146 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287150 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287155 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 287159 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287163 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 287167 */     // MIs[3] Operand 1
     /* 287167 */     // No operand predicates
     /* 287167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287175 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 287177 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 287177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 287180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 287182 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 287184 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 287190 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 287193 */     GIR_RootConstrainSelectedInstOperands,
     /* 287194 */     // GIR_Coverage, 6123,
     /* 287194 */     GIR_EraseRootFromParent_Done,
     /* 287195 */   // Label 5832: @287195
     /* 287195 */   GIM_Try, /*On fail goto*//*Label 5833*/ GIMT_Encode4(287279), // Rule ID 6035 //
     /* 287200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287215 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287219 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287224 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 287228 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287232 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 287236 */     // MIs[2] Operand 1
     /* 287236 */     // No operand predicates
     /* 287236 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 287240 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287244 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 287248 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287257 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 287259 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 287259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 287262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 287264 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 287266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 287270 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287274 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 287277 */     GIR_RootConstrainSelectedInstOperands,
     /* 287278 */     // GIR_Coverage, 6035,
     /* 287278 */     GIR_EraseRootFromParent_Done,
     /* 287279 */   // Label 5833: @287279
     /* 287279 */   GIM_Try, /*On fail goto*//*Label 5834*/ GIMT_Encode4(287360), // Rule ID 6067 //
     /* 287284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287295 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 287299 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 287303 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287307 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287311 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 287315 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287320 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 287324 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287328 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 287332 */     // MIs[3] Operand 1
     /* 287332 */     // No operand predicates
     /* 287332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287340 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 287342 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 287342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 287345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 287347 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 287349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 287355 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 287358 */     GIR_RootConstrainSelectedInstOperands,
     /* 287359 */     // GIR_Coverage, 6067,
     /* 287359 */     GIR_EraseRootFromParent_Done,
     /* 287360 */   // Label 5834: @287360
     /* 287360 */   GIM_Try, /*On fail goto*//*Label 5835*/ GIMT_Encode4(287444), // Rule ID 6099 //
     /* 287365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287376 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 287380 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 287389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287393 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287397 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 287401 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287406 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 287410 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287414 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 287418 */     // MIs[3] Operand 1
     /* 287418 */     // No operand predicates
     /* 287418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287422 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 287424 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 287424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 287427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 287429 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 287431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 287435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 287439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 287442 */     GIR_RootConstrainSelectedInstOperands,
     /* 287443 */     // GIR_Coverage, 6099,
     /* 287443 */     GIR_EraseRootFromParent_Done,
     /* 287444 */   // Label 5835: @287444
     /* 287444 */   GIM_Try, /*On fail goto*//*Label 5836*/ GIMT_Encode4(287522), // Rule ID 6145 //
     /* 287449 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287465 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287469 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 287473 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287477 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287481 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287486 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 287490 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287494 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 287498 */     // MIs[3] Operand 1
     /* 287498 */     // No operand predicates
     /* 287498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287502 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 287504 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 287504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 287507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 287509 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 287511 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287513 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 287517 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 287520 */     GIR_RootConstrainSelectedInstOperands,
     /* 287521 */     // GIR_Coverage, 6145,
     /* 287521 */     GIR_EraseRootFromParent_Done,
     /* 287522 */   // Label 5836: @287522
     /* 287522 */   GIM_Try, /*On fail goto*//*Label 5837*/ GIMT_Encode4(287603), // Rule ID 6003 //
     /* 287527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287530 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 287546 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 287550 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287554 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287558 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 287562 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287567 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 287571 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287575 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 287579 */     // MIs[3] Operand 1
     /* 287579 */     // No operand predicates
     /* 287579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287583 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 287585 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 287585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 287588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 287590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 287592 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 287598 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 287601 */     GIR_RootConstrainSelectedInstOperands,
     /* 287602 */     // GIR_Coverage, 6003,
     /* 287602 */     GIR_EraseRootFromParent_Done,
     /* 287603 */   // Label 5837: @287603
     /* 287603 */   GIM_Try, /*On fail goto*//*Label 5838*/ GIMT_Encode4(287688), // Rule ID 2457 //
     /* 287608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 287611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287623 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287627 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287632 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 287636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287644 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287646 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 287646 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 287649 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 287653 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287658 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 287664 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287669 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 287677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287679 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 287684 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 287686 */     GIR_RootConstrainSelectedInstOperands,
     /* 287687 */     // GIR_Coverage, 2457,
     /* 287687 */     GIR_EraseRootFromParent_Done,
     /* 287688 */   // Label 5838: @287688
     /* 287688 */   GIM_Try, /*On fail goto*//*Label 5839*/ GIMT_Encode4(287773), // Rule ID 2455 //
     /* 287693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 287696 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287712 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287716 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287721 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 287725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287731 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 287731 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 287734 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 287738 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287743 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 287749 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287754 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 287762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287764 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287766 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287769 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 287771 */     GIR_RootConstrainSelectedInstOperands,
     /* 287772 */     // GIR_Coverage, 2455,
     /* 287772 */     GIR_EraseRootFromParent_Done,
     /* 287773 */   // Label 5839: @287773
     /* 287773 */   GIM_Try, /*On fail goto*//*Label 5840*/ GIMT_Encode4(287842), // Rule ID 2547 //
     /* 287778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287793 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287797 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 287806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287810 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 287814 */     // MIs[2] Operand 1
     /* 287814 */     // No operand predicates
     /* 287814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287822 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287824 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 287824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 287827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 287829 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 287831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 287840 */     GIR_RootConstrainSelectedInstOperands,
     /* 287841 */     // GIR_Coverage, 2547,
     /* 287841 */     GIR_EraseRootFromParent_Done,
     /* 287842 */   // Label 5840: @287842
     /* 287842 */   GIM_Try, /*On fail goto*//*Label 5841*/ GIMT_Encode4(287911), // Rule ID 5971 //
     /* 287847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287850 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287862 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287866 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287870 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287875 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 287879 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287883 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 287887 */     // MIs[2] Operand 1
     /* 287887 */     // No operand predicates
     /* 287887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287891 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287893 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 287893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 287896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 287898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 287900 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287906 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 287909 */     GIR_RootConstrainSelectedInstOperands,
     /* 287910 */     // GIR_Coverage, 5971,
     /* 287910 */     GIR_EraseRootFromParent_Done,
     /* 287911 */   // Label 5841: @287911
     /* 287911 */   GIM_Try, /*On fail goto*//*Label 5842*/ GIMT_Encode4(287973), // Rule ID 4823 //
     /* 287916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 287928 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287937 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 287941 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287945 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 287949 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287954 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287956 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 287956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 287959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 287965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 287967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 287971 */     GIR_RootConstrainSelectedInstOperands,
     /* 287972 */     // GIR_Coverage, 4823,
     /* 287972 */     GIR_EraseRootFromParent_Done,
     /* 287973 */   // Label 5842: @287973
     /* 287973 */   GIM_Try, /*On fail goto*//*Label 5843*/ GIMT_Encode4(288035), // Rule ID 13593 //
     /* 287978 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287990 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 287994 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287999 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 288003 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 288007 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 288011 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288016 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 288018 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 288018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 288021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 288027 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 288029 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 288033 */     GIR_RootConstrainSelectedInstOperands,
     /* 288034 */     // GIR_Coverage, 13593,
     /* 288034 */     GIR_EraseRootFromParent_Done,
     /* 288035 */   // Label 5843: @288035
     /* 288035 */   GIM_Try, /*On fail goto*//*Label 5844*/ GIMT_Encode4(288082), // Rule ID 4820 //
     /* 288040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 288048 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 288052 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288067 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 288067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 288070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288072 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 288076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 288078 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 288080 */     GIR_RootConstrainSelectedInstOperands,
     /* 288081 */     // GIR_Coverage, 4820,
     /* 288081 */     GIR_EraseRootFromParent_Done,
     /* 288082 */   // Label 5844: @288082
     /* 288082 */   GIM_Try, /*On fail goto*//*Label 5845*/ GIMT_Encode4(288132), // Rule ID 13021 //
     /* 288087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 288090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 288098 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 288102 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288115 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288117 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 288117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 288120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288124 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288128 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 288130 */     GIR_RootConstrainSelectedInstOperands,
     /* 288131 */     // GIR_Coverage, 13021,
     /* 288131 */     GIR_EraseRootFromParent_Done,
     /* 288132 */   // Label 5845: @288132
     /* 288132 */   GIM_Try, /*On fail goto*//*Label 5846*/ GIMT_Encode4(288182), // Rule ID 648 //
     /* 288137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 288140 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 288152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 288156 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288167 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 288167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 288170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288172 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288178 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 288180 */     GIR_RootConstrainSelectedInstOperands,
     /* 288181 */     // GIR_Coverage, 648,
     /* 288181 */     GIR_EraseRootFromParent_Done,
     /* 288182 */   // Label 5846: @288182
     /* 288182 */   GIM_Try, /*On fail goto*//*Label 5847*/ GIMT_Encode4(288229), // Rule ID 13590 //
     /* 288187 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 288199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 288203 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288212 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288214 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 288214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 288217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 288223 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 288225 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 288227 */     GIR_RootConstrainSelectedInstOperands,
     /* 288228 */     // GIR_Coverage, 13590,
     /* 288228 */     GIR_EraseRootFromParent_Done,
     /* 288229 */   // Label 5847: @288229
     /* 288229 */   GIM_Try, /*On fail goto*//*Label 5848*/ GIMT_Encode4(288279), // Rule ID 660 //
     /* 288234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 288237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 288249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 288253 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 288257 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288262 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288264 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 288264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 288267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288269 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288271 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 288273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 288277 */     GIR_RootConstrainSelectedInstOperands,
     /* 288278 */     // GIR_Coverage, 660,
     /* 288278 */     GIR_EraseRootFromParent_Done,
     /* 288279 */   // Label 5848: @288279
     /* 288279 */   GIM_Try, /*On fail goto*//*Label 5849*/ GIMT_Encode4(288310), // Rule ID 642 //
     /* 288284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 288287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288299 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 288299 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 288304 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 288308 */     GIR_RootConstrainSelectedInstOperands,
     /* 288309 */     // GIR_Coverage, 642,
     /* 288309 */     GIR_Done,
     /* 288310 */   // Label 5849: @288310
     /* 288310 */   GIM_Reject,
     /* 288311 */ // Label 5815: @288311
     /* 288311 */ GIM_Reject,
     /* 288312 */ // Label 5741: @288312
     /* 288312 */ GIM_Try, /*On fail goto*//*Label 5850*/ GIMT_Encode4(289832),
     /* 288317 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 288320 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 288323 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 288326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288330 */   GIM_Try, /*On fail goto*//*Label 5851*/ GIMT_Encode4(288408), // Rule ID 6103 //
     /* 288335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 288343 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 288347 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288351 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 288355 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 288359 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 288363 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288368 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 288372 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288376 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 288380 */     // MIs[3] Operand 1
     /* 288380 */     // No operand predicates
     /* 288380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288388 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 288390 */     // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 288390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 288393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 288395 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 288397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 288403 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 288406 */     GIR_RootConstrainSelectedInstOperands,
     /* 288407 */     // GIR_Coverage, 6103,
     /* 288407 */     GIR_EraseRootFromParent_Done,
     /* 288408 */   // Label 5851: @288408
     /* 288408 */   GIM_Try, /*On fail goto*//*Label 5852*/ GIMT_Encode4(288492), // Rule ID 6019 //
     /* 288413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 288424 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 288428 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288432 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288437 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 288441 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288445 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 288449 */     // MIs[2] Operand 1
     /* 288449 */     // No operand predicates
     /* 288449 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 288453 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 288457 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 288461 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288470 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 288472 */     // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 288472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 288475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 288477 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 288479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 288483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288487 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 288490 */     GIR_RootConstrainSelectedInstOperands,
     /* 288491 */     // GIR_Coverage, 6019,
     /* 288491 */     GIR_EraseRootFromParent_Done,
     /* 288492 */   // Label 5852: @288492
     /* 288492 */   GIM_Try, /*On fail goto*//*Label 5853*/ GIMT_Encode4(288573), // Rule ID 6051 //
     /* 288497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 288508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 288512 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 288516 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 288520 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 288524 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 288528 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288533 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 288537 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288541 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 288545 */     // MIs[3] Operand 1
     /* 288545 */     // No operand predicates
     /* 288545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288553 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 288555 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 288555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 288558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 288560 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 288562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 288568 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 288571 */     GIR_RootConstrainSelectedInstOperands,
     /* 288572 */     // GIR_Coverage, 6051,
     /* 288572 */     GIR_EraseRootFromParent_Done,
     /* 288573 */   // Label 5853: @288573
     /* 288573 */   GIM_Try, /*On fail goto*//*Label 5854*/ GIMT_Encode4(288657), // Rule ID 6083 //
     /* 288578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 288589 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 288593 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288598 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 288602 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 288606 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 288610 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 288614 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288619 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 288623 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288627 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 288631 */     // MIs[3] Operand 1
     /* 288631 */     // No operand predicates
     /* 288631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288635 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 288637 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 288637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 288640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 288642 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 288644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 288648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 288652 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 288655 */     GIR_RootConstrainSelectedInstOperands,
     /* 288656 */     // GIR_Coverage, 6083,
     /* 288656 */     GIR_EraseRootFromParent_Done,
     /* 288657 */   // Label 5854: @288657
     /* 288657 */   GIM_Try, /*On fail goto*//*Label 5855*/ GIMT_Encode4(288735), // Rule ID 6125 //
     /* 288662 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 288674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 288678 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288682 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 288686 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 288690 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 288694 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288699 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 288703 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288707 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 288711 */     // MIs[3] Operand 1
     /* 288711 */     // No operand predicates
     /* 288711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288715 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 288717 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 288717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 288720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 288722 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 288724 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 288730 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 288733 */     GIR_RootConstrainSelectedInstOperands,
     /* 288734 */     // GIR_Coverage, 6125,
     /* 288734 */     GIR_EraseRootFromParent_Done,
     /* 288735 */   // Label 5855: @288735
     /* 288735 */   GIM_Try, /*On fail goto*//*Label 5856*/ GIMT_Encode4(288816), // Rule ID 5987 //
     /* 288740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288743 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 288755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 288759 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 288763 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 288767 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 288771 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 288775 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288780 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 288784 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288788 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 288792 */     // MIs[3] Operand 1
     /* 288792 */     // No operand predicates
     /* 288792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288796 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 288798 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 288798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 288801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 288803 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 288805 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 288811 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 288814 */     GIR_RootConstrainSelectedInstOperands,
     /* 288815 */     // GIR_Coverage, 5987,
     /* 288815 */     GIR_EraseRootFromParent_Done,
     /* 288816 */   // Label 5856: @288816
     /* 288816 */   GIM_Try, /*On fail goto*//*Label 5857*/ GIMT_Encode4(288885), // Rule ID 2531 //
     /* 288821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 288832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 288836 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288840 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 288849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288853 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 288857 */     // MIs[2] Operand 1
     /* 288857 */     // No operand predicates
     /* 288857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288865 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 288867 */     // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 288867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 288870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 288872 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 288874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288880 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 288883 */     GIR_RootConstrainSelectedInstOperands,
     /* 288884 */     // GIR_Coverage, 2531,
     /* 288884 */     GIR_EraseRootFromParent_Done,
     /* 288885 */   // Label 5857: @288885
     /* 288885 */   GIM_Try, /*On fail goto*//*Label 5858*/ GIMT_Encode4(288954), // Rule ID 5955 //
     /* 288890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288893 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 288905 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 288909 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288913 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288918 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 288922 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288926 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 288930 */     // MIs[2] Operand 1
     /* 288930 */     // No operand predicates
     /* 288930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288934 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 288936 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 288936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 288939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 288941 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 288943 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288949 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 288952 */     GIR_RootConstrainSelectedInstOperands,
     /* 288953 */     // GIR_Coverage, 5955,
     /* 288953 */     GIR_EraseRootFromParent_Done,
     /* 288954 */   // Label 5858: @288954
     /* 288954 */   GIM_Try, /*On fail goto*//*Label 5859*/ GIMT_Encode4(289047), // Rule ID 6107 //
     /* 288959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 288967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 288971 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 288975 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 288979 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 288983 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 288988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288996 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 288998 */     // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 288998 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 289001 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 289005 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289010 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 289013 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 289017 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 289020 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289025 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 289033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 289035 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 289037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289039 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 289045 */     GIR_RootConstrainSelectedInstOperands,
     /* 289046 */     // GIR_Coverage, 6107,
     /* 289046 */     GIR_EraseRootFromParent_Done,
     /* 289047 */   // Label 5859: @289047
     /* 289047 */   GIM_Try, /*On fail goto*//*Label 5860*/ GIMT_Encode4(289146), // Rule ID 6021 //
     /* 289052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 289063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 289067 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289072 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 289076 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 289080 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 289084 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289093 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 289095 */     // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 289095 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 289098 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 289102 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289107 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 289110 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289114 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 289117 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289122 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 289130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 289132 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 289134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 289138 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 289144 */     GIR_RootConstrainSelectedInstOperands,
     /* 289145 */     // GIR_Coverage, 6021,
     /* 289145 */     GIR_EraseRootFromParent_Done,
     /* 289146 */   // Label 5860: @289146
     /* 289146 */   GIM_Try, /*On fail goto*//*Label 5861*/ GIMT_Encode4(289242), // Rule ID 6053 //
     /* 289151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 289162 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 289166 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 289170 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 289174 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 289178 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289191 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 289193 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 289193 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 289196 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 289200 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289205 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 289208 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 289212 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 289215 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289220 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 289228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 289230 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 289232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 289240 */     GIR_RootConstrainSelectedInstOperands,
     /* 289241 */     // GIR_Coverage, 6053,
     /* 289241 */     GIR_EraseRootFromParent_Done,
     /* 289242 */   // Label 5861: @289242
     /* 289242 */   GIM_Try, /*On fail goto*//*Label 5862*/ GIMT_Encode4(289341), // Rule ID 6085 //
     /* 289247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 289258 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 289262 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289267 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 289271 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 289275 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 289279 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289288 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 289290 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 289290 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 289293 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 289297 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289302 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 289305 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 289309 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 289312 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289317 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 289325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 289327 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 289329 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 289333 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 289339 */     GIR_RootConstrainSelectedInstOperands,
     /* 289340 */     // GIR_Coverage, 6085,
     /* 289340 */     GIR_EraseRootFromParent_Done,
     /* 289341 */   // Label 5862: @289341
     /* 289341 */   GIM_Try, /*On fail goto*//*Label 5863*/ GIMT_Encode4(289434), // Rule ID 6129 //
     /* 289346 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 289358 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 289362 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 289366 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 289370 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 289374 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289383 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 289385 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 289385 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 289388 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 289392 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289397 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 289400 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 289404 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 289407 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289412 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 289420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 289422 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 289424 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 289426 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 289432 */     GIR_RootConstrainSelectedInstOperands,
     /* 289433 */     // GIR_Coverage, 6129,
     /* 289433 */     GIR_EraseRootFromParent_Done,
     /* 289434 */   // Label 5863: @289434
     /* 289434 */   GIM_Try, /*On fail goto*//*Label 5864*/ GIMT_Encode4(289530), // Rule ID 5989 //
     /* 289439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 289454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 289458 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 289462 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 289466 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 289470 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289479 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 289481 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 289481 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 289484 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 289488 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289493 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 289496 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 289500 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 289503 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289508 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 289516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 289518 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 289520 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 289522 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 289528 */     GIR_RootConstrainSelectedInstOperands,
     /* 289529 */     // GIR_Coverage, 5989,
     /* 289529 */     GIR_EraseRootFromParent_Done,
     /* 289530 */   // Label 5864: @289530
     /* 289530 */   GIM_Try, /*On fail goto*//*Label 5865*/ GIMT_Encode4(289614), // Rule ID 2533 //
     /* 289535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 289546 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 289550 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289565 */     // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 289565 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 289568 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 289572 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289577 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 289580 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289584 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 289587 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289592 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 289600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 289602 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 289604 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289606 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 289612 */     GIR_RootConstrainSelectedInstOperands,
     /* 289613 */     // GIR_Coverage, 2533,
     /* 289613 */     GIR_EraseRootFromParent_Done,
     /* 289614 */   // Label 5865: @289614
     /* 289614 */   GIM_Try, /*On fail goto*//*Label 5866*/ GIMT_Encode4(289664), // Rule ID 13051 //
     /* 289619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 289630 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 289634 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289649 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 289649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 289652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 289654 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 289656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289662 */     GIR_RootConstrainSelectedInstOperands,
     /* 289663 */     // GIR_Coverage, 13051,
     /* 289663 */     GIR_EraseRootFromParent_Done,
     /* 289664 */   // Label 5866: @289664
     /* 289664 */   GIM_Try, /*On fail goto*//*Label 5867*/ GIMT_Encode4(289748), // Rule ID 5957 //
     /* 289669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289672 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 289684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 289688 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289697 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289699 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 289699 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 289702 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 289706 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289711 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 289714 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289718 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 289721 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289726 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 289734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 289736 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 289738 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 289740 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 289746 */     GIR_RootConstrainSelectedInstOperands,
     /* 289747 */     // GIR_Coverage, 5957,
     /* 289747 */     GIR_EraseRootFromParent_Done,
     /* 289748 */   // Label 5867: @289748
     /* 289748 */   GIM_Try, /*On fail goto*//*Label 5868*/ GIMT_Encode4(289798), // Rule ID 1301 //
     /* 289753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 289768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 289772 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289783 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 289783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 289786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 289788 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 289790 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 289792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289796 */     GIR_RootConstrainSelectedInstOperands,
     /* 289797 */     // GIR_Coverage, 1301,
     /* 289797 */     GIR_EraseRootFromParent_Done,
     /* 289798 */   // Label 5868: @289798
     /* 289798 */   GIM_Try, /*On fail goto*//*Label 5869*/ GIMT_Encode4(289831), // Rule ID 1291 //
     /* 289803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289806 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289818 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 289818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f32),
     /* 289821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 289823 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 289825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289827 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 289829 */     GIR_RootConstrainSelectedInstOperands,
     /* 289830 */     // GIR_Coverage, 1291,
     /* 289830 */     GIR_EraseRootFromParent_Done,
     /* 289831 */   // Label 5869: @289831
     /* 289831 */   GIM_Reject,
     /* 289832 */ // Label 5850: @289832
     /* 289832 */ GIM_Reject,
     /* 289833 */ // Label 5742: @289833
     /* 289833 */ GIM_Try, /*On fail goto*//*Label 5870*/ GIMT_Encode4(291353),
     /* 289838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 289841 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 289844 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 289847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289851 */   GIM_Try, /*On fail goto*//*Label 5871*/ GIMT_Encode4(289929), // Rule ID 6115 //
     /* 289856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 289864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 289868 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 289872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 289876 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 289880 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 289884 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289889 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 289893 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289897 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 289901 */     // MIs[3] Operand 1
     /* 289901 */     // No operand predicates
     /* 289901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289909 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 289911 */     // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 289911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 289914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 289916 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 289918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289920 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 289924 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 289927 */     GIR_RootConstrainSelectedInstOperands,
     /* 289928 */     // GIR_Coverage, 6115,
     /* 289928 */     GIR_EraseRootFromParent_Done,
     /* 289929 */   // Label 5871: @289929
     /* 289929 */   GIM_Try, /*On fail goto*//*Label 5872*/ GIMT_Encode4(290013), // Rule ID 6027 //
     /* 289934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 289945 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 289949 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 289953 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289958 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 289962 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289966 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 289970 */     // MIs[2] Operand 1
     /* 289970 */     // No operand predicates
     /* 289970 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 289974 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 289978 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 289982 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289991 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 289993 */     // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 289993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 289996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 289998 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290000 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 290004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 290008 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 290011 */     GIR_RootConstrainSelectedInstOperands,
     /* 290012 */     // GIR_Coverage, 6027,
     /* 290012 */     GIR_EraseRootFromParent_Done,
     /* 290013 */   // Label 5872: @290013
     /* 290013 */   GIM_Try, /*On fail goto*//*Label 5873*/ GIMT_Encode4(290094), // Rule ID 6059 //
     /* 290018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 290037 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 290041 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290045 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 290049 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290054 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 290058 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290062 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 290066 */     // MIs[3] Operand 1
     /* 290066 */     // No operand predicates
     /* 290066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290074 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 290076 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 290076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 290079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 290089 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 290092 */     GIR_RootConstrainSelectedInstOperands,
     /* 290093 */     // GIR_Coverage, 6059,
     /* 290093 */     GIR_EraseRootFromParent_Done,
     /* 290094 */   // Label 5873: @290094
     /* 290094 */   GIM_Try, /*On fail goto*//*Label 5874*/ GIMT_Encode4(290178), // Rule ID 6091 //
     /* 290099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290110 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290114 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290119 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 290123 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 290127 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290131 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 290135 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290140 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 290144 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290148 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 290152 */     // MIs[3] Operand 1
     /* 290152 */     // No operand predicates
     /* 290152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290156 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 290158 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 290158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 290161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290163 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 290169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 290173 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 290176 */     GIR_RootConstrainSelectedInstOperands,
     /* 290177 */     // GIR_Coverage, 6091,
     /* 290177 */     GIR_EraseRootFromParent_Done,
     /* 290178 */   // Label 5874: @290178
     /* 290178 */   GIM_Try, /*On fail goto*//*Label 5875*/ GIMT_Encode4(290256), // Rule ID 6137 //
     /* 290183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 290195 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290199 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 290203 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 290207 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290211 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290215 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290220 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 290224 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290228 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 290232 */     // MIs[3] Operand 1
     /* 290232 */     // No operand predicates
     /* 290232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290236 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 290238 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 290238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 290241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290243 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290245 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 290247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 290251 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 290254 */     GIR_RootConstrainSelectedInstOperands,
     /* 290255 */     // GIR_Coverage, 6137,
     /* 290255 */     GIR_EraseRootFromParent_Done,
     /* 290256 */   // Label 5875: @290256
     /* 290256 */   GIM_Try, /*On fail goto*//*Label 5876*/ GIMT_Encode4(290337), // Rule ID 5995 //
     /* 290261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290280 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 290284 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 290288 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290292 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 290296 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290301 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 290305 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290309 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 290313 */     // MIs[3] Operand 1
     /* 290313 */     // No operand predicates
     /* 290313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290317 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 290319 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 290319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 290322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290324 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290326 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 290328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 290332 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 290335 */     GIR_RootConstrainSelectedInstOperands,
     /* 290336 */     // GIR_Coverage, 5995,
     /* 290336 */     GIR_EraseRootFromParent_Done,
     /* 290337 */   // Label 5876: @290337
     /* 290337 */   GIM_Try, /*On fail goto*//*Label 5877*/ GIMT_Encode4(290406), // Rule ID 2539 //
     /* 290342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 290353 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290357 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 290361 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290366 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 290370 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290374 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 290378 */     // MIs[2] Operand 1
     /* 290378 */     // No operand predicates
     /* 290378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290386 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 290388 */     // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 290388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 290391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290393 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 290401 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 290404 */     GIR_RootConstrainSelectedInstOperands,
     /* 290405 */     // GIR_Coverage, 2539,
     /* 290405 */     GIR_EraseRootFromParent_Done,
     /* 290406 */   // Label 5877: @290406
     /* 290406 */   GIM_Try, /*On fail goto*//*Label 5878*/ GIMT_Encode4(290475), // Rule ID 5963 //
     /* 290411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290414 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 290426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290430 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 290434 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290439 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 290443 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290447 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 290451 */     // MIs[2] Operand 1
     /* 290451 */     // No operand predicates
     /* 290451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290455 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 290457 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 290457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 290460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290462 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290464 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 290466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 290470 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 290473 */     GIR_RootConstrainSelectedInstOperands,
     /* 290474 */     // GIR_Coverage, 5963,
     /* 290474 */     GIR_EraseRootFromParent_Done,
     /* 290475 */   // Label 5878: @290475
     /* 290475 */   GIM_Try, /*On fail goto*//*Label 5879*/ GIMT_Encode4(290568), // Rule ID 6117 //
     /* 290480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 290488 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 290492 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 290496 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290500 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 290504 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290517 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 290519 */     // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 290519 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 290522 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 290526 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290531 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 290534 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 290538 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 290541 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290546 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 290554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290556 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290560 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 290566 */     GIR_RootConstrainSelectedInstOperands,
     /* 290567 */     // GIR_Coverage, 6117,
     /* 290567 */     GIR_EraseRootFromParent_Done,
     /* 290568 */   // Label 5879: @290568
     /* 290568 */   GIM_Try, /*On fail goto*//*Label 5880*/ GIMT_Encode4(290667), // Rule ID 6029 //
     /* 290573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 290584 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 290588 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290593 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 290597 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290601 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290605 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290614 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 290616 */     // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 290616 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 290619 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 290623 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290628 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 290631 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 290635 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 290638 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290643 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 290651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290653 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 290659 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 290665 */     GIR_RootConstrainSelectedInstOperands,
     /* 290666 */     // GIR_Coverage, 6029,
     /* 290666 */     GIR_EraseRootFromParent_Done,
     /* 290667 */   // Label 5880: @290667
     /* 290667 */   GIM_Try, /*On fail goto*//*Label 5881*/ GIMT_Encode4(290763), // Rule ID 6061 //
     /* 290672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 290691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 290695 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 290699 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290712 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 290714 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 290714 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 290717 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 290721 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290726 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 290729 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 290733 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 290736 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290741 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 290749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290751 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290755 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 290761 */     GIR_RootConstrainSelectedInstOperands,
     /* 290762 */     // GIR_Coverage, 6061,
     /* 290762 */     GIR_EraseRootFromParent_Done,
     /* 290763 */   // Label 5881: @290763
     /* 290763 */   GIM_Try, /*On fail goto*//*Label 5882*/ GIMT_Encode4(290862), // Rule ID 6093 //
     /* 290768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290779 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290783 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290788 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 290792 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 290796 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 290800 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290809 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 290811 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 290811 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 290814 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 290818 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290823 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 290826 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 290830 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 290833 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290838 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 290846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290848 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 290854 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 290860 */     GIR_RootConstrainSelectedInstOperands,
     /* 290861 */     // GIR_Coverage, 6093,
     /* 290861 */     GIR_EraseRootFromParent_Done,
     /* 290862 */   // Label 5882: @290862
     /* 290862 */   GIM_Try, /*On fail goto*//*Label 5883*/ GIMT_Encode4(290955), // Rule ID 6139 //
     /* 290867 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 290879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 290883 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 290887 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290891 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 290895 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290904 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 290906 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 290906 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 290909 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 290913 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290918 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 290921 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 290925 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 290928 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290933 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 290941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290945 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 290947 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 290953 */     GIR_RootConstrainSelectedInstOperands,
     /* 290954 */     // GIR_Coverage, 6139,
     /* 290954 */     GIR_EraseRootFromParent_Done,
     /* 290955 */   // Label 5883: @290955
     /* 290955 */   GIM_Try, /*On fail goto*//*Label 5884*/ GIMT_Encode4(291051), // Rule ID 5997 //
     /* 290960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290975 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 290979 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 290983 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 290987 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 290991 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291000 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 291002 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 291002 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 291005 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 291009 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291014 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 291017 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 291021 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 291024 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291029 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 291037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291039 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291041 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 291043 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 291049 */     GIR_RootConstrainSelectedInstOperands,
     /* 291050 */     // GIR_Coverage, 5997,
     /* 291050 */     GIR_EraseRootFromParent_Done,
     /* 291051 */   // Label 5884: @291051
     /* 291051 */   GIM_Try, /*On fail goto*//*Label 5885*/ GIMT_Encode4(291135), // Rule ID 2541 //
     /* 291056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 291067 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 291071 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291084 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291086 */     // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 291086 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 291089 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 291093 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291098 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 291101 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 291105 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 291108 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291113 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 291121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291123 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291127 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 291133 */     GIR_RootConstrainSelectedInstOperands,
     /* 291134 */     // GIR_Coverage, 2541,
     /* 291134 */     GIR_EraseRootFromParent_Done,
     /* 291135 */   // Label 5885: @291135
     /* 291135 */   GIM_Try, /*On fail goto*//*Label 5886*/ GIMT_Encode4(291185), // Rule ID 13055 //
     /* 291140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 291155 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291168 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291170 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 291170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 291173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291175 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 291183 */     GIR_RootConstrainSelectedInstOperands,
     /* 291184 */     // GIR_Coverage, 13055,
     /* 291184 */     GIR_EraseRootFromParent_Done,
     /* 291185 */   // Label 5886: @291185
     /* 291185 */   GIM_Try, /*On fail goto*//*Label 5887*/ GIMT_Encode4(291269), // Rule ID 5965 //
     /* 291190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 291205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 291209 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291218 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291220 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 291220 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 291223 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 291227 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291232 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 291235 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 291239 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 291242 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291247 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 291255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291257 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291259 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 291261 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 291267 */     GIR_RootConstrainSelectedInstOperands,
     /* 291268 */     // GIR_Coverage, 5965,
     /* 291268 */     GIR_EraseRootFromParent_Done,
     /* 291269 */   // Label 5887: @291269
     /* 291269 */   GIM_Try, /*On fail goto*//*Label 5888*/ GIMT_Encode4(291319), // Rule ID 1305 //
     /* 291274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291277 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291289 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 291293 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291302 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291304 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 291304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 291307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291309 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291311 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 291313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 291317 */     GIR_RootConstrainSelectedInstOperands,
     /* 291318 */     // GIR_Coverage, 1305,
     /* 291318 */     GIR_EraseRootFromParent_Done,
     /* 291319 */   // Label 5888: @291319
     /* 291319 */   GIM_Try, /*On fail goto*//*Label 5889*/ GIMT_Encode4(291352), // Rule ID 1295 //
     /* 291324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291327 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291339 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 291339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f64),
     /* 291342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291348 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 291350 */     GIR_RootConstrainSelectedInstOperands,
     /* 291351 */     // GIR_Coverage, 1295,
     /* 291351 */     GIR_EraseRootFromParent_Done,
     /* 291352 */   // Label 5889: @291352
     /* 291352 */   GIM_Reject,
     /* 291353 */ // Label 5870: @291353
     /* 291353 */ GIM_Reject,
     /* 291354 */ // Label 5743: @291354
     /* 291354 */ GIM_Try, /*On fail goto*//*Label 5890*/ GIMT_Encode4(292532),
     /* 291359 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 291362 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 291365 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 291368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291372 */   GIM_Try, /*On fail goto*//*Label 5891*/ GIMT_Encode4(291456), // Rule ID 6011 //
     /* 291377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 291380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 291388 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291392 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 291396 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 291401 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 291405 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 291409 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 291413 */     // MIs[2] Operand 1
     /* 291413 */     // No operand predicates
     /* 291413 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 291417 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291421 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 291425 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291434 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 291436 */     // (fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 291436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 291439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291441 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 291447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 291451 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 291454 */     GIR_RootConstrainSelectedInstOperands,
     /* 291455 */     // GIR_Coverage, 6011,
     /* 291455 */     GIR_EraseRootFromParent_Done,
     /* 291456 */   // Label 5891: @291456
     /* 291456 */   GIM_Try, /*On fail goto*//*Label 5892*/ GIMT_Encode4(291537), // Rule ID 6043 //
     /* 291461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 291464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 291476 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 291480 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 291484 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291488 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 291492 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 291497 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 291501 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 291505 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 291509 */     // MIs[3] Operand 1
     /* 291509 */     // No operand predicates
     /* 291509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291517 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 291519 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 291519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 291522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291524 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 291532 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 291535 */     GIR_RootConstrainSelectedInstOperands,
     /* 291536 */     // GIR_Coverage, 6043,
     /* 291536 */     GIR_EraseRootFromParent_Done,
     /* 291537 */   // Label 5892: @291537
     /* 291537 */   GIM_Try, /*On fail goto*//*Label 5893*/ GIMT_Encode4(291621), // Rule ID 6075 //
     /* 291542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 291545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291553 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 291557 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291562 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 291566 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 291570 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291574 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 291578 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 291583 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 291587 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 291591 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 291595 */     // MIs[3] Operand 1
     /* 291595 */     // No operand predicates
     /* 291595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291599 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 291601 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 291601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 291604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291606 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 291612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 291616 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 291619 */     GIR_RootConstrainSelectedInstOperands,
     /* 291620 */     // GIR_Coverage, 6075,
     /* 291620 */     GIR_EraseRootFromParent_Done,
     /* 291621 */   // Label 5893: @291621
     /* 291621 */   GIM_Try, /*On fail goto*//*Label 5894*/ GIMT_Encode4(291702), // Rule ID 5979 //
     /* 291626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 291629 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 291645 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 291649 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 291653 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291657 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 291661 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 291666 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 291670 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 291674 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 291678 */     // MIs[3] Operand 1
     /* 291678 */     // No operand predicates
     /* 291678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291682 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 291684 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 291684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 291687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291689 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291691 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 291693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 291697 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 291700 */     GIR_RootConstrainSelectedInstOperands,
     /* 291701 */     // GIR_Coverage, 5979,
     /* 291701 */     GIR_EraseRootFromParent_Done,
     /* 291702 */   // Label 5894: @291702
     /* 291702 */   GIM_Try, /*On fail goto*//*Label 5895*/ GIMT_Encode4(291771), // Rule ID 2523 //
     /* 291707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 291710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 291718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291722 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 291726 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 291731 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 291735 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 291739 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 291743 */     // MIs[2] Operand 1
     /* 291743 */     // No operand predicates
     /* 291743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291751 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 291753 */     // (fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 291753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 291756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291758 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291760 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 291766 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 291769 */     GIR_RootConstrainSelectedInstOperands,
     /* 291770 */     // GIR_Coverage, 2523,
     /* 291770 */     GIR_EraseRootFromParent_Done,
     /* 291771 */   // Label 5895: @291771
     /* 291771 */   GIM_Try, /*On fail goto*//*Label 5896*/ GIMT_Encode4(291840), // Rule ID 5947 //
     /* 291776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 291779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 291791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291795 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 291799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 291804 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 291808 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 291812 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 291816 */     // MIs[2] Operand 1
     /* 291816 */     // No operand predicates
     /* 291816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291820 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 291822 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 291822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 291825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291827 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291829 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 291831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 291835 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 291838 */     GIR_RootConstrainSelectedInstOperands,
     /* 291839 */     // GIR_Coverage, 5947,
     /* 291839 */     GIR_EraseRootFromParent_Done,
     /* 291840 */   // Label 5896: @291840
     /* 291840 */   GIM_Try, /*On fail goto*//*Label 5897*/ GIMT_Encode4(291939), // Rule ID 6013 //
     /* 291845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 291848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 291856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 291860 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 291865 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 291869 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291873 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 291877 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291886 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 291888 */     // (fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 291888 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 291891 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 291895 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291900 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 291903 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 291907 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 291910 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291915 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 291920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 291923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291925 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 291931 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 291937 */     GIR_RootConstrainSelectedInstOperands,
     /* 291938 */     // GIR_Coverage, 6013,
     /* 291938 */     GIR_EraseRootFromParent_Done,
     /* 291939 */   // Label 5897: @291939
     /* 291939 */   GIM_Try, /*On fail goto*//*Label 5898*/ GIMT_Encode4(292035), // Rule ID 6045 //
     /* 291944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 291947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 291959 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 291963 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 291967 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 291971 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 291976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291984 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 291986 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 291986 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 291989 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 291993 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291998 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 292001 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 292005 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 292008 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292013 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 292018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 292021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292023 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292027 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 292030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 292033 */     GIR_RootConstrainSelectedInstOperands,
     /* 292034 */     // GIR_Coverage, 6045,
     /* 292034 */     GIR_EraseRootFromParent_Done,
     /* 292035 */   // Label 5898: @292035
     /* 292035 */   GIM_Try, /*On fail goto*//*Label 5899*/ GIMT_Encode4(292134), // Rule ID 6077 //
     /* 292040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 292043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 292055 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 292064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 292068 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 292072 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 292077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292081 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 292083 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 292083 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 292086 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 292090 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292095 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 292098 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 292102 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 292105 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292110 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 292115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 292118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292120 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 292126 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 292129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 292132 */     GIR_RootConstrainSelectedInstOperands,
     /* 292133 */     // GIR_Coverage, 6077,
     /* 292133 */     GIR_EraseRootFromParent_Done,
     /* 292134 */   // Label 5899: @292134
     /* 292134 */   GIM_Try, /*On fail goto*//*Label 5900*/ GIMT_Encode4(292230), // Rule ID 5981 //
     /* 292139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 292142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292154 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 292158 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 292162 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 292166 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 292170 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 292175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292179 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 292181 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 292181 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 292184 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 292188 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292193 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 292196 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 292200 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 292203 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292208 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 292213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 292216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292218 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292220 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 292222 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 292225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 292228 */     GIR_RootConstrainSelectedInstOperands,
     /* 292229 */     // GIR_Coverage, 5981,
     /* 292229 */     GIR_EraseRootFromParent_Done,
     /* 292230 */   // Label 5900: @292230
     /* 292230 */   GIM_Try, /*On fail goto*//*Label 5901*/ GIMT_Encode4(292314), // Rule ID 2525 //
     /* 292235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 292238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 292246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 292250 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 292255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292265 */     // (fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 292265 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 292268 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 292272 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292277 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 292280 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 292284 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 292287 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292292 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 292297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 292300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292302 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292306 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 292309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 292312 */     GIR_RootConstrainSelectedInstOperands,
     /* 292313 */     // GIR_Coverage, 2525,
     /* 292313 */     GIR_EraseRootFromParent_Done,
     /* 292314 */   // Label 5901: @292314
     /* 292314 */   GIM_Try, /*On fail goto*//*Label 5902*/ GIMT_Encode4(292364), // Rule ID 13047 //
     /* 292319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 292322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292330 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 292334 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292349 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 292349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 292352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292354 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292356 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 292362 */     GIR_RootConstrainSelectedInstOperands,
     /* 292363 */     // GIR_Coverage, 13047,
     /* 292363 */     GIR_EraseRootFromParent_Done,
     /* 292364 */   // Label 5902: @292364
     /* 292364 */   GIM_Try, /*On fail goto*//*Label 5903*/ GIMT_Encode4(292448), // Rule ID 5949 //
     /* 292369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 292372 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 292384 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 292388 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 292393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292399 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 292399 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 292402 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 292406 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292411 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 292414 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 292418 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 292421 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292426 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 292431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 292434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292436 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292438 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 292440 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 292443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 292446 */     GIR_RootConstrainSelectedInstOperands,
     /* 292447 */     // GIR_Coverage, 5949,
     /* 292447 */     GIR_EraseRootFromParent_Done,
     /* 292448 */   // Label 5903: @292448
     /* 292448 */   GIM_Try, /*On fail goto*//*Label 5904*/ GIMT_Encode4(292498), // Rule ID 1297 //
     /* 292453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 292456 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292468 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 292472 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292483 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 292483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 292486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292488 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292490 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 292492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 292496 */     GIR_RootConstrainSelectedInstOperands,
     /* 292497 */     // GIR_Coverage, 1297,
     /* 292497 */     GIR_EraseRootFromParent_Done,
     /* 292498 */   // Label 5904: @292498
     /* 292498 */   GIM_Try, /*On fail goto*//*Label 5905*/ GIMT_Encode4(292531), // Rule ID 1287 //
     /* 292503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 292506 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292518 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 292518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f16),
     /* 292521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292525 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292527 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 292529 */     GIR_RootConstrainSelectedInstOperands,
     /* 292530 */     // GIR_Coverage, 1287,
     /* 292530 */     GIR_EraseRootFromParent_Done,
     /* 292531 */   // Label 5905: @292531
     /* 292531 */   GIM_Reject,
     /* 292532 */ // Label 5890: @292532
     /* 292532 */ GIM_Reject,
     /* 292533 */ // Label 5744: @292533
     /* 292533 */ GIM_Try, /*On fail goto*//*Label 5906*/ GIMT_Encode4(294053),
     /* 292538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 292541 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 292544 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 292547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292551 */   GIM_Try, /*On fail goto*//*Label 5907*/ GIMT_Encode4(292629), // Rule ID 6109 //
     /* 292556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 292564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 292568 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 292572 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 292576 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292580 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 292584 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292589 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 292593 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 292597 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 292601 */     // MIs[3] Operand 1
     /* 292601 */     // No operand predicates
     /* 292601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292609 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 292611 */     // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 292611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 292614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292616 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 292624 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 292627 */     GIR_RootConstrainSelectedInstOperands,
     /* 292628 */     // GIR_Coverage, 6109,
     /* 292628 */     GIR_EraseRootFromParent_Done,
     /* 292629 */   // Label 5907: @292629
     /* 292629 */   GIM_Try, /*On fail goto*//*Label 5908*/ GIMT_Encode4(292713), // Rule ID 6023 //
     /* 292634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 292645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 292649 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 292653 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292658 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 292662 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 292666 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 292670 */     // MIs[2] Operand 1
     /* 292670 */     // No operand predicates
     /* 292670 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 292674 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292678 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 292682 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292691 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 292693 */     // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 292693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 292696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292698 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 292704 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 292708 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 292711 */     GIR_RootConstrainSelectedInstOperands,
     /* 292712 */     // GIR_Coverage, 6023,
     /* 292712 */     GIR_EraseRootFromParent_Done,
     /* 292713 */   // Label 5908: @292713
     /* 292713 */   GIM_Try, /*On fail goto*//*Label 5909*/ GIMT_Encode4(292794), // Rule ID 6055 //
     /* 292718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292729 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 292733 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 292737 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 292741 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 292745 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 292749 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292754 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 292758 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 292762 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 292766 */     // MIs[3] Operand 1
     /* 292766 */     // No operand predicates
     /* 292766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292774 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 292776 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 292776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 292779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292781 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 292789 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 292792 */     GIR_RootConstrainSelectedInstOperands,
     /* 292793 */     // GIR_Coverage, 6055,
     /* 292793 */     GIR_EraseRootFromParent_Done,
     /* 292794 */   // Label 5909: @292794
     /* 292794 */   GIM_Try, /*On fail goto*//*Label 5910*/ GIMT_Encode4(292878), // Rule ID 6087 //
     /* 292799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292810 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 292814 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292819 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 292823 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 292827 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 292831 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 292835 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292840 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 292844 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 292848 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 292852 */     // MIs[3] Operand 1
     /* 292852 */     // No operand predicates
     /* 292852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292856 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 292858 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 292858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 292861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292863 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 292869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 292873 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 292876 */     GIR_RootConstrainSelectedInstOperands,
     /* 292877 */     // GIR_Coverage, 6087,
     /* 292877 */     GIR_EraseRootFromParent_Done,
     /* 292878 */   // Label 5910: @292878
     /* 292878 */   GIM_Try, /*On fail goto*//*Label 5911*/ GIMT_Encode4(292956), // Rule ID 6131 //
     /* 292883 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 292895 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 292899 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 292903 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 292907 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292911 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 292915 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292920 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 292924 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 292928 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 292932 */     // MIs[3] Operand 1
     /* 292932 */     // No operand predicates
     /* 292932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292936 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 292938 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 292938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 292941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292945 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 292947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 292951 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 292954 */     GIR_RootConstrainSelectedInstOperands,
     /* 292955 */     // GIR_Coverage, 6131,
     /* 292955 */     GIR_EraseRootFromParent_Done,
     /* 292956 */   // Label 5911: @292956
     /* 292956 */   GIM_Try, /*On fail goto*//*Label 5912*/ GIMT_Encode4(293037), // Rule ID 5991 //
     /* 292961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292964 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292976 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 292980 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 292984 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 292988 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 292992 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 292996 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293001 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 293005 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 293009 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 293013 */     // MIs[3] Operand 1
     /* 293013 */     // No operand predicates
     /* 293013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293017 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 293019 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 293019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 293022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293024 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293026 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 293028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 293032 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 293035 */     GIR_RootConstrainSelectedInstOperands,
     /* 293036 */     // GIR_Coverage, 5991,
     /* 293036 */     GIR_EraseRootFromParent_Done,
     /* 293037 */   // Label 5912: @293037
     /* 293037 */   GIM_Try, /*On fail goto*//*Label 5913*/ GIMT_Encode4(293106), // Rule ID 2535 //
     /* 293042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 293053 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293057 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 293061 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293066 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 293070 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 293074 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 293078 */     // MIs[2] Operand 1
     /* 293078 */     // No operand predicates
     /* 293078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293086 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 293088 */     // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 293088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 293091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293093 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 293101 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 293104 */     GIR_RootConstrainSelectedInstOperands,
     /* 293105 */     // GIR_Coverage, 2535,
     /* 293105 */     GIR_EraseRootFromParent_Done,
     /* 293106 */   // Label 5913: @293106
     /* 293106 */   GIM_Try, /*On fail goto*//*Label 5914*/ GIMT_Encode4(293175), // Rule ID 5959 //
     /* 293111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 293126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293130 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 293134 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293139 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 293143 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 293147 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 293151 */     // MIs[2] Operand 1
     /* 293151 */     // No operand predicates
     /* 293151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293155 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 293157 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 293157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 293160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293162 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293164 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 293166 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 293170 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 293173 */     GIR_RootConstrainSelectedInstOperands,
     /* 293174 */     // GIR_Coverage, 5959,
     /* 293174 */     GIR_EraseRootFromParent_Done,
     /* 293175 */   // Label 5914: @293175
     /* 293175 */   GIM_Try, /*On fail goto*//*Label 5915*/ GIMT_Encode4(293268), // Rule ID 6113 //
     /* 293180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 293188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 293192 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 293196 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293200 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 293204 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293217 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 293219 */     // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 293219 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 293222 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 293226 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293231 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 293234 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 293238 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 293241 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293246 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 293254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293260 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293266 */     GIR_RootConstrainSelectedInstOperands,
     /* 293267 */     // GIR_Coverage, 6113,
     /* 293267 */     GIR_EraseRootFromParent_Done,
     /* 293268 */   // Label 5915: @293268
     /* 293268 */   GIM_Try, /*On fail goto*//*Label 5916*/ GIMT_Encode4(293367), // Rule ID 6025 //
     /* 293273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 293284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 293288 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293293 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 293297 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293301 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293305 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293314 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 293316 */     // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 293316 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 293319 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 293323 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293328 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 293331 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 293335 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 293338 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293343 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 293351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 293359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293365 */     GIR_RootConstrainSelectedInstOperands,
     /* 293366 */     // GIR_Coverage, 6025,
     /* 293366 */     GIR_EraseRootFromParent_Done,
     /* 293367 */   // Label 5916: @293367
     /* 293367 */   GIM_Try, /*On fail goto*//*Label 5917*/ GIMT_Encode4(293463), // Rule ID 6057 //
     /* 293372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293387 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 293391 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 293395 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 293399 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293412 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 293414 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 293414 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 293417 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 293421 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293426 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 293429 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 293433 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 293436 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293441 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 293449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293451 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293455 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293461 */     GIR_RootConstrainSelectedInstOperands,
     /* 293462 */     // GIR_Coverage, 6057,
     /* 293462 */     GIR_EraseRootFromParent_Done,
     /* 293463 */   // Label 5917: @293463
     /* 293463 */   GIM_Try, /*On fail goto*//*Label 5918*/ GIMT_Encode4(293562), // Rule ID 6089 //
     /* 293468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293479 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293483 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293488 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 293492 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 293496 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 293500 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293509 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 293511 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 293511 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 293514 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 293518 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293523 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 293526 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 293530 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 293533 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293538 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 293546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293548 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 293554 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293560 */     GIR_RootConstrainSelectedInstOperands,
     /* 293561 */     // GIR_Coverage, 6089,
     /* 293561 */     GIR_EraseRootFromParent_Done,
     /* 293562 */   // Label 5918: @293562
     /* 293562 */   GIM_Try, /*On fail goto*//*Label 5919*/ GIMT_Encode4(293655), // Rule ID 6135 //
     /* 293567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 293579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 293583 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 293587 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293591 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 293595 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293604 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 293606 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 293606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 293609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 293613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293618 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 293621 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 293625 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 293628 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293633 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 293641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293643 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293645 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 293647 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293653 */     GIR_RootConstrainSelectedInstOperands,
     /* 293654 */     // GIR_Coverage, 6135,
     /* 293654 */     GIR_EraseRootFromParent_Done,
     /* 293655 */   // Label 5919: @293655
     /* 293655 */   GIM_Try, /*On fail goto*//*Label 5920*/ GIMT_Encode4(293751), // Rule ID 5993 //
     /* 293660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293663 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293675 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293679 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 293683 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 293687 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 293691 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293700 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 293702 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 293702 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 293705 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 293709 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293714 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 293717 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 293721 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 293724 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293729 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 293737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293739 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293741 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 293743 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293749 */     GIR_RootConstrainSelectedInstOperands,
     /* 293750 */     // GIR_Coverage, 5993,
     /* 293750 */     GIR_EraseRootFromParent_Done,
     /* 293751 */   // Label 5920: @293751
     /* 293751 */   GIM_Try, /*On fail goto*//*Label 5921*/ GIMT_Encode4(293835), // Rule ID 2537 //
     /* 293756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 293767 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 293771 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293784 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293786 */     // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 293786 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 293789 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 293793 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293798 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 293801 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 293805 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 293808 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293813 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 293821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293823 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293827 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293833 */     GIR_RootConstrainSelectedInstOperands,
     /* 293834 */     // GIR_Coverage, 2537,
     /* 293834 */     GIR_EraseRootFromParent_Done,
     /* 293835 */   // Label 5921: @293835
     /* 293835 */   GIM_Try, /*On fail goto*//*Label 5922*/ GIMT_Encode4(293885), // Rule ID 13053 //
     /* 293840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293855 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293868 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293870 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 293870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 293873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293875 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 293883 */     GIR_RootConstrainSelectedInstOperands,
     /* 293884 */     // GIR_Coverage, 13053,
     /* 293884 */     GIR_EraseRootFromParent_Done,
     /* 293885 */   // Label 5922: @293885
     /* 293885 */   GIM_Try, /*On fail goto*//*Label 5923*/ GIMT_Encode4(293969), // Rule ID 5961 //
     /* 293890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293893 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 293905 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 293909 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293918 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293920 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 293920 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 293923 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 293927 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293932 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 293935 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 293939 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 293942 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293947 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 293955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293957 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293959 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 293961 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293967 */     GIR_RootConstrainSelectedInstOperands,
     /* 293968 */     // GIR_Coverage, 5961,
     /* 293968 */     GIR_EraseRootFromParent_Done,
     /* 293969 */   // Label 5923: @293969
     /* 293969 */   GIM_Try, /*On fail goto*//*Label 5924*/ GIMT_Encode4(294019), // Rule ID 1303 //
     /* 293974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293977 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293989 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293993 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294002 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294004 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 294004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 294007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294009 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294011 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 294013 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 294017 */     GIR_RootConstrainSelectedInstOperands,
     /* 294018 */     // GIR_Coverage, 1303,
     /* 294018 */     GIR_EraseRootFromParent_Done,
     /* 294019 */   // Label 5924: @294019
     /* 294019 */   GIM_Try, /*On fail goto*//*Label 5925*/ GIMT_Encode4(294052), // Rule ID 1293 //
     /* 294024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294027 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294039 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 294039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f32),
     /* 294042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294044 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294046 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294048 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 294050 */     GIR_RootConstrainSelectedInstOperands,
     /* 294051 */     // GIR_Coverage, 1293,
     /* 294051 */     GIR_EraseRootFromParent_Done,
     /* 294052 */   // Label 5925: @294052
     /* 294052 */   GIM_Reject,
     /* 294053 */ // Label 5906: @294053
     /* 294053 */ GIM_Reject,
     /* 294054 */ // Label 5745: @294054
     /* 294054 */ GIM_Try, /*On fail goto*//*Label 5926*/ GIMT_Encode4(295232),
     /* 294059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294062 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 294065 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 294068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294072 */   GIM_Try, /*On fail goto*//*Label 5927*/ GIMT_Encode4(294156), // Rule ID 6007 //
     /* 294077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 294080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 294088 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294092 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 294096 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 294101 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 294105 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 294109 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 294113 */     // MIs[2] Operand 1
     /* 294113 */     // No operand predicates
     /* 294113 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 294117 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294121 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294125 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294134 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 294136 */     // (fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 294136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 294139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294141 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 294147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 294151 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 294154 */     GIR_RootConstrainSelectedInstOperands,
     /* 294155 */     // GIR_Coverage, 6007,
     /* 294155 */     GIR_EraseRootFromParent_Done,
     /* 294156 */   // Label 5927: @294156
     /* 294156 */   GIM_Try, /*On fail goto*//*Label 5928*/ GIMT_Encode4(294237), // Rule ID 6039 //
     /* 294161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 294164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294176 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 294180 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 294184 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294188 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 294192 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 294197 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 294201 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 294205 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 294209 */     // MIs[3] Operand 1
     /* 294209 */     // No operand predicates
     /* 294209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294217 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 294219 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 294219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 294222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294224 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294226 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294228 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 294232 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 294235 */     GIR_RootConstrainSelectedInstOperands,
     /* 294236 */     // GIR_Coverage, 6039,
     /* 294236 */     GIR_EraseRootFromParent_Done,
     /* 294237 */   // Label 5928: @294237
     /* 294237 */   GIM_Try, /*On fail goto*//*Label 5929*/ GIMT_Encode4(294321), // Rule ID 6071 //
     /* 294242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 294245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294253 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294257 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294262 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 294266 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 294270 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294274 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 294278 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 294283 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 294287 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 294291 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 294295 */     // MIs[3] Operand 1
     /* 294295 */     // No operand predicates
     /* 294295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294299 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 294301 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 294301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 294304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294306 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 294312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 294316 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 294319 */     GIR_RootConstrainSelectedInstOperands,
     /* 294320 */     // GIR_Coverage, 6071,
     /* 294320 */     GIR_EraseRootFromParent_Done,
     /* 294321 */   // Label 5929: @294321
     /* 294321 */   GIM_Try, /*On fail goto*//*Label 5930*/ GIMT_Encode4(294402), // Rule ID 5975 //
     /* 294326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 294329 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294341 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294345 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 294349 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 294353 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294357 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 294361 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 294366 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 294370 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 294374 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 294378 */     // MIs[3] Operand 1
     /* 294378 */     // No operand predicates
     /* 294378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294382 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 294384 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 294384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 294387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294391 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 294393 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 294397 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 294400 */     GIR_RootConstrainSelectedInstOperands,
     /* 294401 */     // GIR_Coverage, 5975,
     /* 294401 */     GIR_EraseRootFromParent_Done,
     /* 294402 */   // Label 5930: @294402
     /* 294402 */   GIM_Try, /*On fail goto*//*Label 5931*/ GIMT_Encode4(294471), // Rule ID 2519 //
     /* 294407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 294410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 294418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294422 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 294426 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 294431 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 294435 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 294439 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 294443 */     // MIs[2] Operand 1
     /* 294443 */     // No operand predicates
     /* 294443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294451 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294453 */     // (fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 294453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 294456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294458 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294460 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 294466 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 294469 */     GIR_RootConstrainSelectedInstOperands,
     /* 294470 */     // GIR_Coverage, 2519,
     /* 294470 */     GIR_EraseRootFromParent_Done,
     /* 294471 */   // Label 5931: @294471
     /* 294471 */   GIM_Try, /*On fail goto*//*Label 5932*/ GIMT_Encode4(294540), // Rule ID 5943 //
     /* 294476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 294479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 294491 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294495 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 294499 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 294504 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 294508 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 294512 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 294516 */     // MIs[2] Operand 1
     /* 294516 */     // No operand predicates
     /* 294516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294520 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294522 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 294522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 294525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294527 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294529 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 294531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 294535 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 294538 */     GIR_RootConstrainSelectedInstOperands,
     /* 294539 */     // GIR_Coverage, 5943,
     /* 294539 */     GIR_EraseRootFromParent_Done,
     /* 294540 */   // Label 5932: @294540
     /* 294540 */   GIM_Try, /*On fail goto*//*Label 5933*/ GIMT_Encode4(294639), // Rule ID 6009 //
     /* 294545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 294548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 294556 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 294560 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 294565 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 294569 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294573 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294577 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294586 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294588 */     // (fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 294588 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 294591 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 294595 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294600 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 294603 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 294607 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 294610 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294615 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 294620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 294623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294625 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 294631 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 294637 */     GIR_RootConstrainSelectedInstOperands,
     /* 294638 */     // GIR_Coverage, 6009,
     /* 294638 */     GIR_EraseRootFromParent_Done,
     /* 294639 */   // Label 5933: @294639
     /* 294639 */   GIM_Try, /*On fail goto*//*Label 5934*/ GIMT_Encode4(294735), // Rule ID 6041 //
     /* 294644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 294647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294655 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294659 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 294663 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 294667 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 294671 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 294676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294684 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294686 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 294686 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 294689 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 294693 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294698 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 294701 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 294705 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 294708 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294713 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 294718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 294721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294723 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294727 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 294733 */     GIR_RootConstrainSelectedInstOperands,
     /* 294734 */     // GIR_Coverage, 6041,
     /* 294734 */     GIR_EraseRootFromParent_Done,
     /* 294735 */   // Label 5934: @294735
     /* 294735 */   GIM_Try, /*On fail goto*//*Label 5935*/ GIMT_Encode4(294834), // Rule ID 6073 //
     /* 294740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 294743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294751 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294755 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294760 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 294764 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 294768 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 294772 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 294777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294781 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294783 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 294783 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 294786 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 294790 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294795 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 294798 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 294802 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 294805 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294810 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 294815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 294818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294820 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 294826 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 294832 */     GIR_RootConstrainSelectedInstOperands,
     /* 294833 */     // GIR_Coverage, 6073,
     /* 294833 */     GIR_EraseRootFromParent_Done,
     /* 294834 */   // Label 5935: @294834
     /* 294834 */   GIM_Try, /*On fail goto*//*Label 5936*/ GIMT_Encode4(294930), // Rule ID 5977 //
     /* 294839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 294842 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 294858 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 294862 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 294866 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 294870 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 294875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294879 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294881 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 294881 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 294884 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 294888 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294893 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 294896 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 294900 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 294903 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294908 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 294913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 294916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294918 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294920 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 294922 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 294928 */     GIR_RootConstrainSelectedInstOperands,
     /* 294929 */     // GIR_Coverage, 5977,
     /* 294929 */     GIR_EraseRootFromParent_Done,
     /* 294930 */   // Label 5936: @294930
     /* 294930 */   GIM_Try, /*On fail goto*//*Label 5937*/ GIMT_Encode4(295014), // Rule ID 2521 //
     /* 294935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 294938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 294946 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 294950 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 294955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294965 */     // (fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 294965 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 294968 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 294972 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294977 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 294980 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 294984 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 294987 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294992 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 294997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 295000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295002 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295006 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 295009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295012 */     GIR_RootConstrainSelectedInstOperands,
     /* 295013 */     // GIR_Coverage, 2521,
     /* 295013 */     GIR_EraseRootFromParent_Done,
     /* 295014 */   // Label 5937: @295014
     /* 295014 */   GIM_Try, /*On fail goto*//*Label 5938*/ GIMT_Encode4(295064), // Rule ID 13049 //
     /* 295019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 295022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295030 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 295034 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295049 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 295049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 295052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295054 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295056 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 295062 */     GIR_RootConstrainSelectedInstOperands,
     /* 295063 */     // GIR_Coverage, 13049,
     /* 295063 */     GIR_EraseRootFromParent_Done,
     /* 295064 */   // Label 5938: @295064
     /* 295064 */   GIM_Try, /*On fail goto*//*Label 5939*/ GIMT_Encode4(295148), // Rule ID 5945 //
     /* 295069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 295072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 295084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 295088 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 295093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295099 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 295099 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 295102 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 295106 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295111 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 295114 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 295118 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 295121 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295126 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 295131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 295134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295136 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295138 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 295140 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 295143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295146 */     GIR_RootConstrainSelectedInstOperands,
     /* 295147 */     // GIR_Coverage, 5945,
     /* 295147 */     GIR_EraseRootFromParent_Done,
     /* 295148 */   // Label 5939: @295148
     /* 295148 */   GIM_Try, /*On fail goto*//*Label 5940*/ GIMT_Encode4(295198), // Rule ID 1299 //
     /* 295153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 295156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295168 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 295172 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295183 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 295183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 295186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295188 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295190 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 295192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 295196 */     GIR_RootConstrainSelectedInstOperands,
     /* 295197 */     // GIR_Coverage, 1299,
     /* 295197 */     GIR_EraseRootFromParent_Done,
     /* 295198 */   // Label 5940: @295198
     /* 295198 */   GIM_Try, /*On fail goto*//*Label 5941*/ GIMT_Encode4(295231), // Rule ID 1289 //
     /* 295203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 295206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295218 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 295218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8f16),
     /* 295221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295223 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295227 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 295229 */     GIR_RootConstrainSelectedInstOperands,
     /* 295230 */     // GIR_Coverage, 1289,
     /* 295230 */     GIR_EraseRootFromParent_Done,
     /* 295231 */   // Label 5941: @295231
     /* 295231 */   GIM_Reject,
     /* 295232 */ // Label 5926: @295232
     /* 295232 */ GIM_Reject,
     /* 295233 */ // Label 5746: @295233
     /* 295233 */ GIM_Reject,
     /* 295234 */ // Label 58: @295234
     /* 295234 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 5950*/ GIMT_Encode4(295849),
     /* 295245 */ /*GILLT_s16*//*Label 5942*/ GIMT_Encode4(295285),
     /* 295249 */ /*GILLT_s32*//*Label 5943*/ GIMT_Encode4(295323),
     /* 295253 */ /*GILLT_s64*//*Label 5944*/ GIMT_Encode4(295361), GIMT_Encode4(0),
     /* 295261 */ /*GILLT_v2s32*//*Label 5945*/ GIMT_Encode4(295399),
     /* 295265 */ /*GILLT_v2s64*//*Label 5946*/ GIMT_Encode4(295437),
     /* 295269 */ /*GILLT_v4s16*//*Label 5947*/ GIMT_Encode4(295475),
     /* 295273 */ /*GILLT_v4s32*//*Label 5948*/ GIMT_Encode4(295513), GIMT_Encode4(0),
     /* 295281 */ /*GILLT_v8s16*//*Label 5949*/ GIMT_Encode4(295551),
     /* 295285 */ // Label 5942: @295285
     /* 295285 */ GIM_Try, /*On fail goto*//*Label 5951*/ GIMT_Encode4(295322), // Rule ID 590 //
     /* 295290 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 295293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 295296 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 295299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295303 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295307 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295311 */   // (fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FDIVHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 295311 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVHrr),
     /* 295316 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 295320 */   GIR_RootConstrainSelectedInstOperands,
     /* 295321 */   // GIR_Coverage, 590,
     /* 295321 */   GIR_Done,
     /* 295322 */ // Label 5951: @295322
     /* 295322 */ GIM_Reject,
     /* 295323 */ // Label 5943: @295323
     /* 295323 */ GIM_Try, /*On fail goto*//*Label 5952*/ GIMT_Encode4(295360), // Rule ID 592 //
     /* 295328 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 295331 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 295334 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 295337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295341 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295345 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295349 */   // (fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FDIVSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 295349 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVSrr),
     /* 295354 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 295358 */   GIR_RootConstrainSelectedInstOperands,
     /* 295359 */   // GIR_Coverage, 592,
     /* 295359 */   GIR_Done,
     /* 295360 */ // Label 5952: @295360
     /* 295360 */ GIM_Reject,
     /* 295361 */ // Label 5944: @295361
     /* 295361 */ GIM_Try, /*On fail goto*//*Label 5953*/ GIMT_Encode4(295398), // Rule ID 594 //
     /* 295366 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 295369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 295372 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 295375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295379 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295383 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295387 */   // (fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FDIVDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 295387 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVDrr),
     /* 295392 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 295396 */   GIR_RootConstrainSelectedInstOperands,
     /* 295397 */   // GIR_Coverage, 594,
     /* 295397 */   GIR_Done,
     /* 295398 */ // Label 5953: @295398
     /* 295398 */ GIM_Reject,
     /* 295399 */ // Label 5945: @295399
     /* 295399 */ GIM_Try, /*On fail goto*//*Label 5954*/ GIMT_Encode4(295436), // Rule ID 1221 //
     /* 295404 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295407 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 295410 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 295413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295417 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295421 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295425 */   // (fdiv:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FDIVv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 295425 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f32),
     /* 295430 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 295434 */   GIR_RootConstrainSelectedInstOperands,
     /* 295435 */   // GIR_Coverage, 1221,
     /* 295435 */   GIR_Done,
     /* 295436 */ // Label 5954: @295436
     /* 295436 */ GIM_Reject,
     /* 295437 */ // Label 5946: @295437
     /* 295437 */ GIM_Try, /*On fail goto*//*Label 5955*/ GIMT_Encode4(295474), // Rule ID 1225 //
     /* 295442 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 295448 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 295451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295455 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295459 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295463 */   // (fdiv:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FDIVv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 295463 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f64),
     /* 295468 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 295472 */   GIR_RootConstrainSelectedInstOperands,
     /* 295473 */   // GIR_Coverage, 1225,
     /* 295473 */   GIR_Done,
     /* 295474 */ // Label 5955: @295474
     /* 295474 */ GIM_Reject,
     /* 295475 */ // Label 5947: @295475
     /* 295475 */ GIM_Try, /*On fail goto*//*Label 5956*/ GIMT_Encode4(295512), // Rule ID 1217 //
     /* 295480 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 295483 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 295486 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 295489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295493 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295497 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295501 */   // (fdiv:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FDIVv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 295501 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f16),
     /* 295506 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 295510 */   GIR_RootConstrainSelectedInstOperands,
     /* 295511 */   // GIR_Coverage, 1217,
     /* 295511 */   GIR_Done,
     /* 295512 */ // Label 5956: @295512
     /* 295512 */ GIM_Reject,
     /* 295513 */ // Label 5948: @295513
     /* 295513 */ GIM_Try, /*On fail goto*//*Label 5957*/ GIMT_Encode4(295550), // Rule ID 1223 //
     /* 295518 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295524 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 295527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295531 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295535 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295539 */   // (fdiv:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FDIVv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 295539 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 295544 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 295548 */   GIR_RootConstrainSelectedInstOperands,
     /* 295549 */   // GIR_Coverage, 1223,
     /* 295549 */   GIR_Done,
     /* 295550 */ // Label 5957: @295550
     /* 295550 */ GIM_Reject,
     /* 295551 */ // Label 5949: @295551
     /* 295551 */ GIM_Try, /*On fail goto*//*Label 5958*/ GIMT_Encode4(295848),
     /* 295556 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 295559 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 295562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295566 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295570 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295574 */   GIM_Try, /*On fail goto*//*Label 5959*/ GIMT_Encode4(295593), // Rule ID 1219 //
     /* 295579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 295582 */     // (fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FDIVv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 295582 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv8f16),
     /* 295587 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 295591 */     GIR_RootConstrainSelectedInstOperands,
     /* 295592 */     // GIR_Coverage, 1219,
     /* 295592 */     GIR_Done,
     /* 295593 */   // Label 5959: @295593
     /* 295593 */   GIM_Try, /*On fail goto*//*Label 5960*/ GIMT_Encode4(295847), // Rule ID 6916 //
     /* 295598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 295601 */     // (fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FDIVv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FDIVv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 295601 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 295604 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 295608 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295613 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 295617 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 295619 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 295622 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 295626 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295631 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 295635 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 295637 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 295640 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 295644 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295649 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 295652 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 295655 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 295657 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 295660 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 295664 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295669 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 295675 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295680 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295685 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 295688 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 295692 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295697 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 295700 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 295702 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 295705 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 295709 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295714 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 295720 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295725 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295730 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 295733 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 295737 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295742 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 295745 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 295747 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 295750 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 295754 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295759 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 295762 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 295765 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 295767 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 295770 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 295774 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295779 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 295782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 295784 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 295787 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 295791 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295796 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 295798 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 295801 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 295805 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295810 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 295813 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 295816 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 295819 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295824 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295829 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 295837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295839 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 295842 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 295845 */     GIR_RootConstrainSelectedInstOperands,
     /* 295846 */     // GIR_Coverage, 6916,
     /* 295846 */     GIR_EraseRootFromParent_Done,
     /* 295847 */   // Label 5960: @295847
     /* 295847 */   GIM_Reject,
     /* 295848 */ // Label 5958: @295848
     /* 295848 */ GIM_Reject,
     /* 295849 */ // Label 5950: @295849
     /* 295849 */ GIM_Reject,
     /* 295850 */ // Label 59: @295850
     /* 295850 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 5969*/ GIMT_Encode4(299356),
     /* 295861 */ /*GILLT_s16*//*Label 5961*/ GIMT_Encode4(295901),
     /* 295865 */ /*GILLT_s32*//*Label 5962*/ GIMT_Encode4(297069),
     /* 295869 */ /*GILLT_s64*//*Label 5963*/ GIMT_Encode4(298092), GIMT_Encode4(0),
     /* 295877 */ /*GILLT_v2s32*//*Label 5964*/ GIMT_Encode4(299115),
     /* 295881 */ /*GILLT_v2s64*//*Label 5965*/ GIMT_Encode4(299142),
     /* 295885 */ /*GILLT_v4s16*//*Label 5966*/ GIMT_Encode4(299169),
     /* 295889 */ /*GILLT_v4s32*//*Label 5967*/ GIMT_Encode4(299249), GIMT_Encode4(0),
     /* 295897 */ /*GILLT_v8s16*//*Label 5968*/ GIMT_Encode4(299276),
     /* 295901 */ // Label 5961: @295901
     /* 295901 */ GIM_Try, /*On fail goto*//*Label 5970*/ GIMT_Encode4(297068),
     /* 295906 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 295909 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295913 */   GIM_Try, /*On fail goto*//*Label 5971*/ GIMT_Encode4(296071), // Rule ID 4787 //
     /* 295918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 295921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 295929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 295933 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 295937 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 295941 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 295945 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295949 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 295953 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 295957 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295962 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 295966 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 295970 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295974 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 295978 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 295982 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295987 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 295991 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 295996 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 295998 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 295998 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 296001 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296005 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296010 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 296016 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296021 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296026 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 296029 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296033 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296038 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 296044 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296049 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 296057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296059 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296062 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 296065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 296069 */     GIR_RootConstrainSelectedInstOperands,
     /* 296070 */     // GIR_Coverage, 4787,
     /* 296070 */     GIR_EraseRootFromParent_Done,
     /* 296071 */   // Label 5971: @296071
     /* 296071 */   GIM_Try, /*On fail goto*//*Label 5972*/ GIMT_Encode4(296229), // Rule ID 4786 //
     /* 296076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 296079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 296087 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 296091 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 296095 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 296099 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 296103 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296107 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 296111 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 296115 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296120 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 296124 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 296128 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296132 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 296136 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 296140 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296145 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 296149 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296154 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 296156 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 296156 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 296159 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296163 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296168 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 296174 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296179 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296184 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 296187 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296191 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296196 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 296202 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296207 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 296215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296217 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296220 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 296223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 296227 */     GIR_RootConstrainSelectedInstOperands,
     /* 296228 */     // GIR_Coverage, 4786,
     /* 296228 */     GIR_EraseRootFromParent_Done,
     /* 296229 */   // Label 5972: @296229
     /* 296229 */   GIM_Try, /*On fail goto*//*Label 5973*/ GIMT_Encode4(296340), // Rule ID 4785 //
     /* 296234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 296237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 296245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 296249 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 296253 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 296257 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 296261 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296265 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 296269 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 296273 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296278 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 296282 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296287 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296292 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 296294 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 296294 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 296297 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296301 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296306 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 296312 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296317 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 296325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296327 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 296334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 296338 */     GIR_RootConstrainSelectedInstOperands,
     /* 296339 */     // GIR_Coverage, 4785,
     /* 296339 */     GIR_EraseRootFromParent_Done,
     /* 296340 */   // Label 5973: @296340
     /* 296340 */   GIM_Try, /*On fail goto*//*Label 5974*/ GIMT_Encode4(296451), // Rule ID 4783 //
     /* 296345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 296348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 296356 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 296360 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 296364 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 296368 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296373 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 296377 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296381 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 296385 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 296389 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296394 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 296398 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296403 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 296405 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 296405 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 296408 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296412 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296417 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 296423 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296428 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 296436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 296442 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 296449 */     GIR_RootConstrainSelectedInstOperands,
     /* 296450 */     // GIR_Coverage, 4783,
     /* 296450 */     GIR_EraseRootFromParent_Done,
     /* 296451 */   // Label 5974: @296451
     /* 296451 */   GIM_Try, /*On fail goto*//*Label 5975*/ GIMT_Encode4(296562), // Rule ID 4784 //
     /* 296456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 296459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 296467 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 296471 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 296475 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 296479 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 296483 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296487 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 296491 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 296495 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296500 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 296504 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296509 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296514 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 296516 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 296516 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 296519 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296523 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296528 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 296534 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296539 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 296547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296549 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 296556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 296560 */     GIR_RootConstrainSelectedInstOperands,
     /* 296561 */     // GIR_Coverage, 4784,
     /* 296561 */     GIR_EraseRootFromParent_Done,
     /* 296562 */   // Label 5975: @296562
     /* 296562 */   GIM_Try, /*On fail goto*//*Label 5976*/ GIMT_Encode4(296673), // Rule ID 4782 //
     /* 296567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 296570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 296578 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 296582 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 296586 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 296590 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296595 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 296599 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296603 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 296607 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 296611 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296616 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 296620 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296625 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 296627 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 296627 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 296630 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296634 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296639 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 296645 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296650 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 296658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 296664 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 296671 */     GIR_RootConstrainSelectedInstOperands,
     /* 296672 */     // GIR_Coverage, 4782,
     /* 296672 */     GIR_EraseRootFromParent_Done,
     /* 296673 */   // Label 5976: @296673
     /* 296673 */   GIM_Try, /*On fail goto*//*Label 5977*/ GIMT_Encode4(296737), // Rule ID 650 //
     /* 296678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 296681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 296689 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 296693 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 296697 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 296701 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296706 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296711 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296716 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296718 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 296718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 296721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 296727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 296731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 296735 */     GIR_RootConstrainSelectedInstOperands,
     /* 296736 */     // GIR_Coverage, 650,
     /* 296736 */     GIR_EraseRootFromParent_Done,
     /* 296737 */   // Label 5977: @296737
     /* 296737 */   GIM_Try, /*On fail goto*//*Label 5978*/ GIMT_Encode4(296801), // Rule ID 649 //
     /* 296742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 296745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 296753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 296757 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 296761 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 296765 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296770 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296775 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296780 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296782 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 296782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 296785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 296791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 296795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 296799 */     GIR_RootConstrainSelectedInstOperands,
     /* 296800 */     // GIR_Coverage, 649,
     /* 296800 */     GIR_EraseRootFromParent_Done,
     /* 296801 */   // Label 5978: @296801
     /* 296801 */   GIM_Try, /*On fail goto*//*Label 5979*/ GIMT_Encode4(296852), // Rule ID 626 //
     /* 296806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 296809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 296817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 296821 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 296825 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296830 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296835 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296837 */     // (fneg:{ *:[f16] } (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 296837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 296840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 296846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 296850 */     GIR_RootConstrainSelectedInstOperands,
     /* 296851 */     // GIR_Coverage, 626,
     /* 296851 */     GIR_EraseRootFromParent_Done,
     /* 296852 */   // Label 5979: @296852
     /* 296852 */   GIM_Try, /*On fail goto*//*Label 5980*/ GIMT_Encode4(296903), // Rule ID 625 //
     /* 296857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 296860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
     /* 296868 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 296872 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 296876 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296881 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296886 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296888 */     // (fneg:{ *:[f16] } (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 296888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 296891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 296897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 296901 */     GIR_RootConstrainSelectedInstOperands,
     /* 296902 */     // GIR_Coverage, 625,
     /* 296902 */     GIR_EraseRootFromParent_Done,
     /* 296903 */   // Label 5980: @296903
     /* 296903 */   GIM_Try, /*On fail goto*//*Label 5981*/ GIMT_Encode4(296922), // Rule ID 524 //
     /* 296908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 296911 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296915 */     // (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FNEGHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 296915 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGHr),
     /* 296920 */     GIR_RootConstrainSelectedInstOperands,
     /* 296921 */     // GIR_Coverage, 524,
     /* 296921 */     GIR_Done,
     /* 296922 */   // Label 5981: @296922
     /* 296922 */   GIM_Try, /*On fail goto*//*Label 5982*/ GIMT_Encode4(297067), // Rule ID 6283 //
     /* 296927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296931 */     // (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } (EORWri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), GPR32:{ *:[i32] }), (logical_imm32_XFORM:{ *:[i32] } 32768:{ *:[i32] })), FPR32:{ *:[i32] }), hsub:{ *:[i32] })
     /* 296931 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 296934 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 296938 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296943 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 296945 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 296948 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 296952 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296957 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 296960 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 296964 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
     /* 296967 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296972 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296977 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 296982 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 296985 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296989 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296994 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 296997 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 297002 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 297005 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::EORWri),
     /* 297009 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297014 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 297017 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // 
     /* 297022 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 297024 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 297027 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297031 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297036 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 297039 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297049 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 297056 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 297061 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297066 */     // GIR_Coverage, 6283,
     /* 297066 */     GIR_EraseRootFromParent_Done,
     /* 297067 */   // Label 5982: @297067
     /* 297067 */   GIM_Reject,
     /* 297068 */ // Label 5970: @297068
     /* 297068 */ GIM_Reject,
     /* 297069 */ // Label 5962: @297069
     /* 297069 */ GIM_Try, /*On fail goto*//*Label 5983*/ GIMT_Encode4(298091),
     /* 297074 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 297077 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297081 */   GIM_Try, /*On fail goto*//*Label 5984*/ GIMT_Encode4(297239), // Rule ID 4793 //
     /* 297086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 297089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 297097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 297101 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 297105 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 297109 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 297113 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297117 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297121 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 297125 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297130 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 297134 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 297138 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297142 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297146 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 297150 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297155 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 297159 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297164 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 297166 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 297166 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 297169 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297173 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297178 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 297184 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297189 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297194 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 297197 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297201 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297206 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 297212 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297217 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 297225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297227 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297230 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 297233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 297237 */     GIR_RootConstrainSelectedInstOperands,
     /* 297238 */     // GIR_Coverage, 4793,
     /* 297238 */     GIR_EraseRootFromParent_Done,
     /* 297239 */   // Label 5984: @297239
     /* 297239 */   GIM_Try, /*On fail goto*//*Label 5985*/ GIMT_Encode4(297397), // Rule ID 4792 //
     /* 297244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 297247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 297255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 297259 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 297263 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 297267 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 297271 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297275 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297279 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 297283 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297288 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 297292 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 297296 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297300 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297304 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 297308 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297313 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 297317 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297322 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 297324 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 297324 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 297327 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297331 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297336 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 297342 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297347 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297352 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 297355 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297359 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297364 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 297370 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297375 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 297383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297388 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 297391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 297395 */     GIR_RootConstrainSelectedInstOperands,
     /* 297396 */     // GIR_Coverage, 4792,
     /* 297396 */     GIR_EraseRootFromParent_Done,
     /* 297397 */   // Label 5985: @297397
     /* 297397 */   GIM_Try, /*On fail goto*//*Label 5986*/ GIMT_Encode4(297508), // Rule ID 4791 //
     /* 297402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 297405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 297413 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 297417 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 297421 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 297425 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 297429 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297433 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297437 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 297441 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297446 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 297450 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297455 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297460 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 297462 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 297462 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 297465 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297469 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297474 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 297480 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297485 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 297493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297495 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 297502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 297506 */     GIR_RootConstrainSelectedInstOperands,
     /* 297507 */     // GIR_Coverage, 4791,
     /* 297507 */     GIR_EraseRootFromParent_Done,
     /* 297508 */   // Label 5986: @297508
     /* 297508 */   GIM_Try, /*On fail goto*//*Label 5987*/ GIMT_Encode4(297619), // Rule ID 4789 //
     /* 297513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 297516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 297524 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 297528 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 297532 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 297536 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297541 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 297545 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297549 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297553 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 297557 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297562 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 297566 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297571 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 297573 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 297573 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 297576 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297580 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297585 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 297591 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297596 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 297604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 297610 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 297617 */     GIR_RootConstrainSelectedInstOperands,
     /* 297618 */     // GIR_Coverage, 4789,
     /* 297618 */     GIR_EraseRootFromParent_Done,
     /* 297619 */   // Label 5987: @297619
     /* 297619 */   GIM_Try, /*On fail goto*//*Label 5988*/ GIMT_Encode4(297730), // Rule ID 4790 //
     /* 297624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 297627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 297635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 297639 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 297643 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 297647 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 297651 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297655 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297659 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 297663 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297668 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 297672 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297677 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297682 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 297684 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 297684 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 297687 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297691 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297696 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 297702 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297707 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 297715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297717 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 297724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 297728 */     GIR_RootConstrainSelectedInstOperands,
     /* 297729 */     // GIR_Coverage, 4790,
     /* 297729 */     GIR_EraseRootFromParent_Done,
     /* 297730 */   // Label 5988: @297730
     /* 297730 */   GIM_Try, /*On fail goto*//*Label 5989*/ GIMT_Encode4(297841), // Rule ID 4788 //
     /* 297735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 297738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 297746 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 297750 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 297754 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 297758 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 297767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297771 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297775 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 297779 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297784 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 297788 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297793 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 297795 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 297795 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 297798 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297802 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297807 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 297813 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297818 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 297826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 297832 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 297839 */     GIR_RootConstrainSelectedInstOperands,
     /* 297840 */     // GIR_Coverage, 4788,
     /* 297840 */     GIR_EraseRootFromParent_Done,
     /* 297841 */   // Label 5989: @297841
     /* 297841 */   GIM_Try, /*On fail goto*//*Label 5990*/ GIMT_Encode4(297905), // Rule ID 652 //
     /* 297846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 297849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 297857 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 297861 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 297865 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 297869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297874 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297879 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297884 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297886 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 297886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 297889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 297895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 297899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 297903 */     GIR_RootConstrainSelectedInstOperands,
     /* 297904 */     // GIR_Coverage, 652,
     /* 297904 */     GIR_EraseRootFromParent_Done,
     /* 297905 */   // Label 5990: @297905
     /* 297905 */   GIM_Try, /*On fail goto*//*Label 5991*/ GIMT_Encode4(297969), // Rule ID 651 //
     /* 297910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 297913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 297921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 297925 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 297929 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 297933 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297938 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297943 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297948 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297950 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 297950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 297953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 297959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 297963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 297967 */     GIR_RootConstrainSelectedInstOperands,
     /* 297968 */     // GIR_Coverage, 651,
     /* 297968 */     GIR_EraseRootFromParent_Done,
     /* 297969 */   // Label 5991: @297969
     /* 297969 */   GIM_Try, /*On fail goto*//*Label 5992*/ GIMT_Encode4(298020), // Rule ID 628 //
     /* 297974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 297977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 297985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 297989 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 297993 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 297998 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 298005 */     // (fneg:{ *:[f32] } (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 298005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 298008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 298014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 298018 */     GIR_RootConstrainSelectedInstOperands,
     /* 298019 */     // GIR_Coverage, 628,
     /* 298019 */     GIR_EraseRootFromParent_Done,
     /* 298020 */   // Label 5992: @298020
     /* 298020 */   GIM_Try, /*On fail goto*//*Label 5993*/ GIMT_Encode4(298071), // Rule ID 627 //
     /* 298025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
     /* 298036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 298040 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 298044 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298049 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298054 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 298056 */     // (fneg:{ *:[f32] } (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 298056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 298059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 298065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 298069 */     GIR_RootConstrainSelectedInstOperands,
     /* 298070 */     // GIR_Coverage, 627,
     /* 298070 */     GIR_EraseRootFromParent_Done,
     /* 298071 */   // Label 5993: @298071
     /* 298071 */   GIM_Try, /*On fail goto*//*Label 5994*/ GIMT_Encode4(298090), // Rule ID 525 //
     /* 298076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 298083 */     // (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FNEGSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 298083 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGSr),
     /* 298088 */     GIR_RootConstrainSelectedInstOperands,
     /* 298089 */     // GIR_Coverage, 525,
     /* 298089 */     GIR_Done,
     /* 298090 */   // Label 5994: @298090
     /* 298090 */   GIM_Reject,
     /* 298091 */ // Label 5983: @298091
     /* 298091 */ GIM_Reject,
     /* 298092 */ // Label 5963: @298092
     /* 298092 */ GIM_Try, /*On fail goto*//*Label 5995*/ GIMT_Encode4(299114),
     /* 298097 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 298100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298104 */   GIM_Try, /*On fail goto*//*Label 5996*/ GIMT_Encode4(298262), // Rule ID 4799 //
     /* 298109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 298120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 298124 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 298128 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 298132 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 298136 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298140 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298144 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 298148 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298153 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 298157 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 298161 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298165 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298169 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 298173 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298178 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 298182 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298187 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 298189 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 298189 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 298192 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298196 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298201 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 298207 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298212 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298217 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 298220 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298224 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298229 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 298235 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298240 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 298248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298250 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298253 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 298256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 298260 */     GIR_RootConstrainSelectedInstOperands,
     /* 298261 */     // GIR_Coverage, 4799,
     /* 298261 */     GIR_EraseRootFromParent_Done,
     /* 298262 */   // Label 5996: @298262
     /* 298262 */   GIM_Try, /*On fail goto*//*Label 5997*/ GIMT_Encode4(298420), // Rule ID 4798 //
     /* 298267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 298278 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 298282 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 298286 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 298290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 298294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298298 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298302 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 298306 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298311 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 298315 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 298319 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298323 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298327 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 298331 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298336 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 298340 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298345 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 298347 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 298347 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 298350 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298354 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298359 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 298365 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298370 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298375 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 298378 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298382 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298387 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 298393 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298398 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 298406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298408 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298411 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 298414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 298418 */     GIR_RootConstrainSelectedInstOperands,
     /* 298419 */     // GIR_Coverage, 4798,
     /* 298419 */     GIR_EraseRootFromParent_Done,
     /* 298420 */   // Label 5997: @298420
     /* 298420 */   GIM_Try, /*On fail goto*//*Label 5998*/ GIMT_Encode4(298531), // Rule ID 4797 //
     /* 298425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 298436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 298440 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 298444 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 298448 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 298452 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298456 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298460 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 298464 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298469 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 298473 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298478 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298483 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 298485 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 298485 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 298488 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298492 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298497 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 298503 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298508 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 298516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298518 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 298525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 298529 */     GIR_RootConstrainSelectedInstOperands,
     /* 298530 */     // GIR_Coverage, 4797,
     /* 298530 */     GIR_EraseRootFromParent_Done,
     /* 298531 */   // Label 5998: @298531
     /* 298531 */   GIM_Try, /*On fail goto*//*Label 5999*/ GIMT_Encode4(298642), // Rule ID 4795 //
     /* 298536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 298547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 298551 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 298555 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 298559 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 298568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298572 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298576 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 298580 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298585 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 298589 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298594 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 298596 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 298596 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 298599 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298603 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298608 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 298614 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298619 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 298627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 298633 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298636 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 298640 */     GIR_RootConstrainSelectedInstOperands,
     /* 298641 */     // GIR_Coverage, 4795,
     /* 298641 */     GIR_EraseRootFromParent_Done,
     /* 298642 */   // Label 5999: @298642
     /* 298642 */   GIM_Try, /*On fail goto*//*Label 6000*/ GIMT_Encode4(298753), // Rule ID 4796 //
     /* 298647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 298658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 298662 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 298666 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 298670 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 298674 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298678 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298682 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 298686 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298691 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 298695 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298700 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298705 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 298707 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 298707 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 298710 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298714 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298719 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 298725 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298730 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 298738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298740 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 298747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 298751 */     GIR_RootConstrainSelectedInstOperands,
     /* 298752 */     // GIR_Coverage, 4796,
     /* 298752 */     GIR_EraseRootFromParent_Done,
     /* 298753 */   // Label 6000: @298753
     /* 298753 */   GIM_Try, /*On fail goto*//*Label 6001*/ GIMT_Encode4(298864), // Rule ID 4794 //
     /* 298758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 298769 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 298773 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 298777 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 298781 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298786 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 298790 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298794 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298798 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 298802 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298807 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 298811 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298816 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 298818 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 298818 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 298821 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298825 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298830 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 298836 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298841 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 298849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 298855 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 298862 */     GIR_RootConstrainSelectedInstOperands,
     /* 298863 */     // GIR_Coverage, 4794,
     /* 298863 */     GIR_EraseRootFromParent_Done,
     /* 298864 */   // Label 6001: @298864
     /* 298864 */   GIM_Try, /*On fail goto*//*Label 6002*/ GIMT_Encode4(298928), // Rule ID 654 //
     /* 298869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 298880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 298884 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 298888 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 298892 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298897 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298902 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 298909 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 298909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 298912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 298918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 298922 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 298926 */     GIR_RootConstrainSelectedInstOperands,
     /* 298927 */     // GIR_Coverage, 654,
     /* 298927 */     GIR_EraseRootFromParent_Done,
     /* 298928 */   // Label 6002: @298928
     /* 298928 */   GIM_Try, /*On fail goto*//*Label 6003*/ GIMT_Encode4(298992), // Rule ID 653 //
     /* 298933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 298944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 298948 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 298952 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 298956 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298961 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298966 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 298973 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 298973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 298976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 298982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 298986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 298990 */     GIR_RootConstrainSelectedInstOperands,
     /* 298991 */     // GIR_Coverage, 653,
     /* 298991 */     GIR_EraseRootFromParent_Done,
     /* 298992 */   // Label 6003: @298992
     /* 298992 */   GIM_Try, /*On fail goto*//*Label 6004*/ GIMT_Encode4(299043), // Rule ID 630 //
     /* 298997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 299000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 299008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 299012 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 299016 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299021 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299026 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299028 */     // (fneg:{ *:[f64] } (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 299028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 299031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 299037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 299041 */     GIR_RootConstrainSelectedInstOperands,
     /* 299042 */     // GIR_Coverage, 630,
     /* 299042 */     GIR_EraseRootFromParent_Done,
     /* 299043 */   // Label 6004: @299043
     /* 299043 */   GIM_Try, /*On fail goto*//*Label 6005*/ GIMT_Encode4(299094), // Rule ID 629 //
     /* 299048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 299051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
     /* 299059 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 299063 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 299067 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299072 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299077 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299079 */     // (fneg:{ *:[f64] } (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 299079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 299082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 299088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 299092 */     GIR_RootConstrainSelectedInstOperands,
     /* 299093 */     // GIR_Coverage, 629,
     /* 299093 */     GIR_EraseRootFromParent_Done,
     /* 299094 */   // Label 6005: @299094
     /* 299094 */   GIM_Try, /*On fail goto*//*Label 6006*/ GIMT_Encode4(299113), // Rule ID 526 //
     /* 299099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 299102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299106 */     // (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FNEGDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 299106 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGDr),
     /* 299111 */     GIR_RootConstrainSelectedInstOperands,
     /* 299112 */     // GIR_Coverage, 526,
     /* 299112 */     GIR_Done,
     /* 299113 */   // Label 6006: @299113
     /* 299113 */   GIM_Reject,
     /* 299114 */ // Label 5995: @299114
     /* 299114 */ GIM_Reject,
     /* 299115 */ // Label 5964: @299115
     /* 299115 */ GIM_Try, /*On fail goto*//*Label 6007*/ GIMT_Encode4(299141), // Rule ID 853 //
     /* 299120 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299123 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 299126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299130 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299134 */   // (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FNEGv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 299134 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv2f32),
     /* 299139 */   GIR_RootConstrainSelectedInstOperands,
     /* 299140 */   // GIR_Coverage, 853,
     /* 299140 */   GIR_Done,
     /* 299141 */ // Label 6007: @299141
     /* 299141 */ GIM_Reject,
     /* 299142 */ // Label 5965: @299142
     /* 299142 */ GIM_Try, /*On fail goto*//*Label 6008*/ GIMT_Encode4(299168), // Rule ID 855 //
     /* 299147 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299150 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 299153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299157 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299161 */   // (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FNEGv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 299161 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv2f64),
     /* 299166 */   GIR_RootConstrainSelectedInstOperands,
     /* 299167 */   // GIR_Coverage, 855,
     /* 299167 */   GIR_Done,
     /* 299168 */ // Label 6008: @299168
     /* 299168 */ GIM_Reject,
     /* 299169 */ // Label 5966: @299169
     /* 299169 */ GIM_Try, /*On fail goto*//*Label 6009*/ GIMT_Encode4(299248),
     /* 299174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 299177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299181 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299185 */   GIM_Try, /*On fail goto*//*Label 6010*/ GIMT_Encode4(299200), // Rule ID 851 //
     /* 299190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 299193 */     // (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FNEGv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 299193 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv4f16),
     /* 299198 */     GIR_RootConstrainSelectedInstOperands,
     /* 299199 */     // GIR_Coverage, 851,
     /* 299199 */     GIR_Done,
     /* 299200 */   // Label 6010: @299200
     /* 299200 */   GIM_Try, /*On fail goto*//*Label 6011*/ GIMT_Encode4(299247), // Rule ID 6286 //
     /* 299205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299208 */     // (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (EORv8i8:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (MOVIv4i16:{ *:[i64] } 128:{ *:[i32] }, 8:{ *:[i32] }))
     /* 299208 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 299211 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i16),
     /* 299215 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299220 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(128),
     /* 299230 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 299233 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 299235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /* 299238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299240 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 299242 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 299245 */     GIR_RootConstrainSelectedInstOperands,
     /* 299246 */     // GIR_Coverage, 6286,
     /* 299246 */     GIR_EraseRootFromParent_Done,
     /* 299247 */   // Label 6011: @299247
     /* 299247 */   GIM_Reject,
     /* 299248 */ // Label 6009: @299248
     /* 299248 */ GIM_Reject,
     /* 299249 */ // Label 5967: @299249
     /* 299249 */ GIM_Try, /*On fail goto*//*Label 6012*/ GIMT_Encode4(299275), // Rule ID 854 //
     /* 299254 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299264 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299268 */   // (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FNEGv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 299268 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv4f32),
     /* 299273 */   GIR_RootConstrainSelectedInstOperands,
     /* 299274 */   // GIR_Coverage, 854,
     /* 299274 */   GIR_Done,
     /* 299275 */ // Label 6012: @299275
     /* 299275 */ GIM_Reject,
     /* 299276 */ // Label 5968: @299276
     /* 299276 */ GIM_Try, /*On fail goto*//*Label 6013*/ GIMT_Encode4(299355),
     /* 299281 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 299284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299288 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299292 */   GIM_Try, /*On fail goto*//*Label 6014*/ GIMT_Encode4(299307), // Rule ID 852 //
     /* 299297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 299300 */     // (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FNEGv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 299300 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv8f16),
     /* 299305 */     GIR_RootConstrainSelectedInstOperands,
     /* 299306 */     // GIR_Coverage, 852,
     /* 299306 */     GIR_Done,
     /* 299307 */   // Label 6014: @299307
     /* 299307 */   GIM_Try, /*On fail goto*//*Label 6015*/ GIMT_Encode4(299354), // Rule ID 6287 //
     /* 299312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299315 */     // (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (EORv16i8:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (MOVIv8i16:{ *:[f128] } 128:{ *:[i32] }, 8:{ *:[i32] }))
     /* 299315 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 299318 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv8i16),
     /* 299322 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299327 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(128),
     /* 299337 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 299340 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 299342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /* 299345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299347 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 299349 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 299352 */     GIR_RootConstrainSelectedInstOperands,
     /* 299353 */     // GIR_Coverage, 6287,
     /* 299353 */     GIR_EraseRootFromParent_Done,
     /* 299354 */   // Label 6015: @299354
     /* 299354 */   GIM_Reject,
     /* 299355 */ // Label 6013: @299355
     /* 299355 */ GIM_Reject,
     /* 299356 */ // Label 5969: @299356
     /* 299356 */ GIM_Reject,
     /* 299357 */ // Label 60: @299357
     /* 299357 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(9), /*)*//*default:*//*Label 6020*/ GIMT_Encode4(299604),
     /* 299368 */ /*GILLT_s32*//*Label 6016*/ GIMT_Encode4(299396),
     /* 299372 */ /*GILLT_s64*//*Label 6017*/ GIMT_Encode4(299427), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 299384 */ /*GILLT_v2s64*//*Label 6018*/ GIMT_Encode4(299488), GIMT_Encode4(0),
     /* 299392 */ /*GILLT_v4s32*//*Label 6019*/ GIMT_Encode4(299546),
     /* 299396 */ // Label 6016: @299396
     /* 299396 */ GIM_Try, /*On fail goto*//*Label 6021*/ GIMT_Encode4(299426), // Rule ID 516 //
     /* 299401 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 299404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 299407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 299411 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 299415 */   // (fpextend:{ *:[f32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTSHr:{ *:[f32] } FPR16:{ *:[f16] }:$Rn)
     /* 299415 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTSHr),
     /* 299420 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 299424 */   GIR_RootConstrainSelectedInstOperands,
     /* 299425 */   // GIR_Coverage, 516,
     /* 299425 */   GIR_Done,
     /* 299426 */ // Label 6021: @299426
     /* 299426 */ GIM_Reject,
     /* 299427 */ // Label 6017: @299427
     /* 299427 */ GIM_Try, /*On fail goto*//*Label 6022*/ GIMT_Encode4(299457), // Rule ID 514 //
     /* 299432 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 299435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 299438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299442 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 299446 */   // (fpextend:{ *:[f64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTDHr:{ *:[f64] } FPR16:{ *:[f16] }:$Rn)
     /* 299446 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTDHr),
     /* 299451 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 299455 */   GIR_RootConstrainSelectedInstOperands,
     /* 299456 */   // GIR_Coverage, 514,
     /* 299456 */   GIR_Done,
     /* 299457 */ // Label 6022: @299457
     /* 299457 */ GIM_Try, /*On fail goto*//*Label 6023*/ GIMT_Encode4(299487), // Rule ID 518 //
     /* 299462 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 299465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 299468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299472 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 299476 */   // (fpextend:{ *:[f64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTDSr:{ *:[f64] } FPR32:{ *:[f32] }:$Rn)
     /* 299476 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTDSr),
     /* 299481 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 299485 */   GIR_RootConstrainSelectedInstOperands,
     /* 299486 */   // GIR_Coverage, 518,
     /* 299486 */   GIR_Done,
     /* 299487 */ // Label 6023: @299487
     /* 299487 */ GIM_Reject,
     /* 299488 */ // Label 6018: @299488
     /* 299488 */ GIM_Try, /*On fail goto*//*Label 6024*/ GIMT_Encode4(299545),
     /* 299493 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 299496 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299500 */   GIM_Try, /*On fail goto*//*Label 6025*/ GIMT_Encode4(299524), // Rule ID 4842 //
     /* 299505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4f32),
     /* 299512 */     // (fpextend:{ *:[v2f64] } (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn))  =>  (FCVTLv4i32:{ *:[v2f64] } V128:{ *:[v4f32] }:$Rn)
     /* 299512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i32),
     /* 299515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 299522 */     GIR_RootConstrainSelectedInstOperands,
     /* 299523 */     // GIR_Coverage, 4842,
     /* 299523 */     GIR_EraseRootFromParent_Done,
     /* 299524 */   // Label 6025: @299524
     /* 299524 */   GIM_Try, /*On fail goto*//*Label 6026*/ GIMT_Encode4(299544), // Rule ID 4840 //
     /* 299529 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299533 */     // (fpextend:{ *:[v2f64] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTLv2i32:{ *:[v2f64] } V64:{ *:[v2f32] }:$Rn)
     /* 299533 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv2i32),
     /* 299538 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 299542 */     GIR_RootConstrainSelectedInstOperands,
     /* 299543 */     // GIR_Coverage, 4840,
     /* 299543 */     GIR_Done,
     /* 299544 */   // Label 6026: @299544
     /* 299544 */   GIM_Reject,
     /* 299545 */ // Label 6024: @299545
     /* 299545 */ GIM_Reject,
     /* 299546 */ // Label 6019: @299546
     /* 299546 */ GIM_Try, /*On fail goto*//*Label 6027*/ GIMT_Encode4(299603),
     /* 299551 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 299554 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299558 */   GIM_Try, /*On fail goto*//*Label 6028*/ GIMT_Encode4(299582), // Rule ID 4846 //
     /* 299563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8f16),
     /* 299570 */     // (fpextend:{ *:[v4f32] } (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn))  =>  (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)
     /* 299570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 299573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 299580 */     GIR_RootConstrainSelectedInstOperands,
     /* 299581 */     // GIR_Coverage, 4846,
     /* 299581 */     GIR_EraseRootFromParent_Done,
     /* 299582 */   // Label 6028: @299582
     /* 299582 */   GIM_Try, /*On fail goto*//*Label 6029*/ GIMT_Encode4(299602), // Rule ID 4844 //
     /* 299587 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299591 */     // (fpextend:{ *:[v4f32] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTLv4i16:{ *:[v4f32] } V64:{ *:[v4f16] }:$Rn)
     /* 299591 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 299596 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 299600 */     GIR_RootConstrainSelectedInstOperands,
     /* 299601 */     // GIR_Coverage, 4844,
     /* 299601 */     GIR_Done,
     /* 299602 */   // Label 6029: @299602
     /* 299602 */   GIM_Reject,
     /* 299603 */ // Label 6027: @299603
     /* 299603 */ GIM_Reject,
     /* 299604 */ // Label 6020: @299604
     /* 299604 */ GIM_Reject,
     /* 299605 */ // Label 61: @299605
     /* 299605 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(8), /*)*//*default:*//*Label 6034*/ GIMT_Encode4(299792),
     /* 299616 */ /*GILLT_s16*//*Label 6030*/ GIMT_Encode4(299644),
     /* 299620 */ /*GILLT_s32*//*Label 6031*/ GIMT_Encode4(299705), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 299632 */ /*GILLT_v2s32*//*Label 6032*/ GIMT_Encode4(299736), GIMT_Encode4(0),
     /* 299640 */ /*GILLT_v4s16*//*Label 6033*/ GIMT_Encode4(299764),
     /* 299644 */ // Label 6030: @299644
     /* 299644 */ GIM_Try, /*On fail goto*//*Label 6035*/ GIMT_Encode4(299674), // Rule ID 510 //
     /* 299649 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 299652 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 299655 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 299659 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299663 */   // (fpround:{ *:[f16] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTHDr:{ *:[f16] } FPR64:{ *:[f64] }:$Rn)
     /* 299663 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTHDr),
     /* 299668 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 299672 */   GIR_RootConstrainSelectedInstOperands,
     /* 299673 */   // GIR_Coverage, 510,
     /* 299673 */   GIR_Done,
     /* 299674 */ // Label 6035: @299674
     /* 299674 */ GIM_Try, /*On fail goto*//*Label 6036*/ GIMT_Encode4(299704), // Rule ID 520 //
     /* 299679 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 299682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 299685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 299689 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 299693 */   // (fpround:{ *:[f16] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTHSr:{ *:[f16] } FPR32:{ *:[f32] }:$Rn)
     /* 299693 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTHSr),
     /* 299698 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 299702 */   GIR_RootConstrainSelectedInstOperands,
     /* 299703 */   // GIR_Coverage, 520,
     /* 299703 */   GIR_Done,
     /* 299704 */ // Label 6036: @299704
     /* 299704 */ GIM_Reject,
     /* 299705 */ // Label 6031: @299705
     /* 299705 */ GIM_Try, /*On fail goto*//*Label 6037*/ GIMT_Encode4(299735), // Rule ID 512 //
     /* 299710 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 299713 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 299716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 299720 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299724 */   // (fpround:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTSDr:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 299724 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTSDr),
     /* 299729 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 299733 */   GIR_RootConstrainSelectedInstOperands,
     /* 299734 */   // GIR_Coverage, 512,
     /* 299734 */   GIR_Done,
     /* 299735 */ // Label 6037: @299735
     /* 299735 */ GIM_Reject,
     /* 299736 */ // Label 6032: @299736
     /* 299736 */ GIM_Try, /*On fail goto*//*Label 6038*/ GIMT_Encode4(299763), // Rule ID 4850 //
     /* 299741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 299744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299748 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299752 */   // (fpround:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNv2i32:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)
     /* 299752 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv2i32),
     /* 299757 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 299761 */   GIR_RootConstrainSelectedInstOperands,
     /* 299762 */   // GIR_Coverage, 4850,
     /* 299762 */   GIR_Done,
     /* 299763 */ // Label 6038: @299763
     /* 299763 */ GIM_Reject,
     /* 299764 */ // Label 6033: @299764
     /* 299764 */ GIM_Try, /*On fail goto*//*Label 6039*/ GIMT_Encode4(299791), // Rule ID 4852 //
     /* 299769 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299776 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299780 */   // (fpround:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNv4i16:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn)
     /* 299780 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 299785 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 299789 */   GIR_RootConstrainSelectedInstOperands,
     /* 299790 */   // GIR_Coverage, 4852,
     /* 299790 */   GIR_Done,
     /* 299791 */ // Label 6039: @299791
     /* 299791 */ GIM_Reject,
     /* 299792 */ // Label 6034: @299792
     /* 299792 */ GIM_Reject,
     /* 299793 */ // Label 62: @299793
     /* 299793 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6047*/ GIMT_Encode4(300855),
     /* 299804 */ /*GILLT_s32*//*Label 6040*/ GIMT_Encode4(299840),
     /* 299808 */ /*GILLT_s64*//*Label 6041*/ GIMT_Encode4(300227), GIMT_Encode4(0),
     /* 299816 */ /*GILLT_v2s32*//*Label 6042*/ GIMT_Encode4(300614),
     /* 299820 */ /*GILLT_v2s64*//*Label 6043*/ GIMT_Encode4(300688),
     /* 299824 */ /*GILLT_v4s16*//*Label 6044*/ GIMT_Encode4(300762),
     /* 299828 */ /*GILLT_v4s32*//*Label 6045*/ GIMT_Encode4(300793), GIMT_Encode4(0),
     /* 299836 */ /*GILLT_v8s16*//*Label 6046*/ GIMT_Encode4(300824),
     /* 299840 */ // Label 6040: @299840
     /* 299840 */ GIM_Try, /*On fail goto*//*Label 6048*/ GIMT_Encode4(299877), // Rule ID 4589 //
     /* 299845 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 299848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 299852 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299856 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 299860 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 299864 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299866 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 299866 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWSr),
     /* 299869 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299871 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 299875 */   GIR_RootConstrainSelectedInstOperands,
     /* 299876 */   // GIR_Coverage, 4589,
     /* 299876 */   GIR_EraseRootFromParent_Done,
     /* 299877 */ // Label 6048: @299877
     /* 299877 */ GIM_Try, /*On fail goto*//*Label 6049*/ GIMT_Encode4(299914), // Rule ID 4591 //
     /* 299882 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 299885 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 299889 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299893 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 299897 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 299901 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299903 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 299903 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWDr),
     /* 299906 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299908 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 299912 */   GIR_RootConstrainSelectedInstOperands,
     /* 299913 */   // GIR_Coverage, 4591,
     /* 299913 */   GIR_EraseRootFromParent_Done,
     /* 299914 */ // Label 6049: @299914
     /* 299914 */ GIM_Try, /*On fail goto*//*Label 6050*/ GIMT_Encode4(299951), // Rule ID 4609 //
     /* 299919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 299922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 299926 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299930 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 299934 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 299938 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299940 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 299940 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWSr),
     /* 299943 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299945 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 299949 */   GIR_RootConstrainSelectedInstOperands,
     /* 299950 */   // GIR_Coverage, 4609,
     /* 299950 */   GIR_EraseRootFromParent_Done,
     /* 299951 */ // Label 6050: @299951
     /* 299951 */ GIM_Try, /*On fail goto*//*Label 6051*/ GIMT_Encode4(299988), // Rule ID 4611 //
     /* 299956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 299959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 299963 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299967 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 299971 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 299975 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299977 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 299977 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWDr),
     /* 299980 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299982 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 299986 */   GIR_RootConstrainSelectedInstOperands,
     /* 299987 */   // GIR_Coverage, 4611,
     /* 299987 */   GIR_EraseRootFromParent_Done,
     /* 299988 */ // Label 6051: @299988
     /* 299988 */ GIM_Try, /*On fail goto*//*Label 6052*/ GIMT_Encode4(300025), // Rule ID 4649 //
     /* 299993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 299996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 300000 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300004 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 300008 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 300012 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300014 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTASUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 300014 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
     /* 300017 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300019 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 300023 */   GIR_RootConstrainSelectedInstOperands,
     /* 300024 */   // GIR_Coverage, 4649,
     /* 300024 */   GIR_EraseRootFromParent_Done,
     /* 300025 */ // Label 6052: @300025
     /* 300025 */ GIM_Try, /*On fail goto*//*Label 6053*/ GIMT_Encode4(300062), // Rule ID 4651 //
     /* 300030 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 300033 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 300037 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300041 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 300045 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 300049 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300051 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTASUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 300051 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
     /* 300054 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300056 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 300060 */   GIR_RootConstrainSelectedInstOperands,
     /* 300061 */   // GIR_Coverage, 4651,
     /* 300061 */   GIR_EraseRootFromParent_Done,
     /* 300062 */ // Label 6053: @300062
     /* 300062 */ GIM_Try, /*On fail goto*//*Label 6054*/ GIMT_Encode4(300099), // Rule ID 4629 //
     /* 300067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 300070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 300074 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300078 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 300082 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 300086 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300088 */   // (fp_to_sint:{ *:[i32] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 300088 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 300091 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300093 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 300097 */   GIR_RootConstrainSelectedInstOperands,
     /* 300098 */   // GIR_Coverage, 4629,
     /* 300098 */   GIR_EraseRootFromParent_Done,
     /* 300099 */ // Label 6054: @300099
     /* 300099 */ GIM_Try, /*On fail goto*//*Label 6055*/ GIMT_Encode4(300136), // Rule ID 4631 //
     /* 300104 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 300107 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 300111 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300115 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 300119 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 300123 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300125 */   // (fp_to_sint:{ *:[i32] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 300125 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 300128 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300130 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 300134 */   GIR_RootConstrainSelectedInstOperands,
     /* 300135 */   // GIR_Coverage, 4631,
     /* 300135 */   GIR_EraseRootFromParent_Done,
     /* 300136 */ // Label 6055: @300136
     /* 300136 */ GIM_Try, /*On fail goto*//*Label 6056*/ GIMT_Encode4(300166), // Rule ID 395 //
     /* 300141 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 300144 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 300147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 300151 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 300155 */   // (fp_to_sint:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 300155 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 300160 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 300164 */   GIR_RootConstrainSelectedInstOperands,
     /* 300165 */   // GIR_Coverage, 395,
     /* 300165 */   GIR_Done,
     /* 300166 */ // Label 6056: @300166
     /* 300166 */ GIM_Try, /*On fail goto*//*Label 6057*/ GIMT_Encode4(300196), // Rule ID 399 //
     /* 300171 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 300174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 300177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 300181 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300185 */   // (fp_to_sint:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 300185 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 300190 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 300194 */   GIR_RootConstrainSelectedInstOperands,
     /* 300195 */   // GIR_Coverage, 399,
     /* 300195 */   GIR_Done,
     /* 300196 */ // Label 6057: @300196
     /* 300196 */ GIM_Try, /*On fail goto*//*Label 6058*/ GIMT_Encode4(300226), // Rule ID 403 //
     /* 300201 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 300204 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 300207 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 300211 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300215 */   // (fp_to_sint:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 300215 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 300220 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 300224 */   GIR_RootConstrainSelectedInstOperands,
     /* 300225 */   // GIR_Coverage, 403,
     /* 300225 */   GIR_Done,
     /* 300226 */ // Label 6058: @300226
     /* 300226 */ GIM_Reject,
     /* 300227 */ // Label 6041: @300227
     /* 300227 */ GIM_Try, /*On fail goto*//*Label 6059*/ GIMT_Encode4(300264), // Rule ID 4590 //
     /* 300232 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 300235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 300239 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300243 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 300247 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 300251 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300253 */   // (fp_to_sint:{ *:[i64] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 300253 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXSr),
     /* 300256 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300258 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 300262 */   GIR_RootConstrainSelectedInstOperands,
     /* 300263 */   // GIR_Coverage, 4590,
     /* 300263 */   GIR_EraseRootFromParent_Done,
     /* 300264 */ // Label 6059: @300264
     /* 300264 */ GIM_Try, /*On fail goto*//*Label 6060*/ GIMT_Encode4(300301), // Rule ID 4592 //
     /* 300269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 300272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 300276 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300280 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 300284 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 300288 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300290 */   // (fp_to_sint:{ *:[i64] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 300290 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXDr),
     /* 300293 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300295 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 300299 */   GIR_RootConstrainSelectedInstOperands,
     /* 300300 */   // GIR_Coverage, 4592,
     /* 300300 */   GIR_EraseRootFromParent_Done,
     /* 300301 */ // Label 6060: @300301
     /* 300301 */ GIM_Try, /*On fail goto*//*Label 6061*/ GIMT_Encode4(300338), // Rule ID 4610 //
     /* 300306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 300309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 300313 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300317 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 300321 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 300325 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300327 */   // (fp_to_sint:{ *:[i64] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 300327 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXSr),
     /* 300330 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300332 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 300336 */   GIR_RootConstrainSelectedInstOperands,
     /* 300337 */   // GIR_Coverage, 4610,
     /* 300337 */   GIR_EraseRootFromParent_Done,
     /* 300338 */ // Label 6061: @300338
     /* 300338 */ GIM_Try, /*On fail goto*//*Label 6062*/ GIMT_Encode4(300375), // Rule ID 4612 //
     /* 300343 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 300346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 300350 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300354 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 300358 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 300362 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300364 */   // (fp_to_sint:{ *:[i64] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 300364 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXDr),
     /* 300367 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300369 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 300373 */   GIR_RootConstrainSelectedInstOperands,
     /* 300374 */   // GIR_Coverage, 4612,
     /* 300374 */   GIR_EraseRootFromParent_Done,
     /* 300375 */ // Label 6062: @300375
     /* 300375 */ GIM_Try, /*On fail goto*//*Label 6063*/ GIMT_Encode4(300412), // Rule ID 4650 //
     /* 300380 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 300383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 300387 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300391 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 300395 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 300399 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300401 */   // (fp_to_sint:{ *:[i64] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 300401 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 300404 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300406 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 300410 */   GIR_RootConstrainSelectedInstOperands,
     /* 300411 */   // GIR_Coverage, 4650,
     /* 300411 */   GIR_EraseRootFromParent_Done,
     /* 300412 */ // Label 6063: @300412
     /* 300412 */ GIM_Try, /*On fail goto*//*Label 6064*/ GIMT_Encode4(300449), // Rule ID 4652 //
     /* 300417 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 300420 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 300424 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300428 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 300432 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 300436 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300438 */   // (fp_to_sint:{ *:[i64] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 300438 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 300441 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300443 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 300447 */   GIR_RootConstrainSelectedInstOperands,
     /* 300448 */   // GIR_Coverage, 4652,
     /* 300448 */   GIR_EraseRootFromParent_Done,
     /* 300449 */ // Label 6064: @300449
     /* 300449 */ GIM_Try, /*On fail goto*//*Label 6065*/ GIMT_Encode4(300486), // Rule ID 4630 //
     /* 300454 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 300457 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 300461 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300465 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 300469 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 300473 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300475 */   // (fp_to_sint:{ *:[i64] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 300475 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 300478 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300480 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 300484 */   GIR_RootConstrainSelectedInstOperands,
     /* 300485 */   // GIR_Coverage, 4630,
     /* 300485 */   GIR_EraseRootFromParent_Done,
     /* 300486 */ // Label 6065: @300486
     /* 300486 */ GIM_Try, /*On fail goto*//*Label 6066*/ GIMT_Encode4(300523), // Rule ID 4632 //
     /* 300491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 300494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 300498 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300502 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 300506 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 300510 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300512 */   // (fp_to_sint:{ *:[i64] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 300512 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 300515 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300517 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 300521 */   GIR_RootConstrainSelectedInstOperands,
     /* 300522 */   // GIR_Coverage, 4632,
     /* 300522 */   GIR_EraseRootFromParent_Done,
     /* 300523 */ // Label 6066: @300523
     /* 300523 */ GIM_Try, /*On fail goto*//*Label 6067*/ GIMT_Encode4(300553), // Rule ID 397 //
     /* 300528 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 300531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 300534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 300538 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 300542 */   // (fp_to_sint:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 300542 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 300547 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 300551 */   GIR_RootConstrainSelectedInstOperands,
     /* 300552 */   // GIR_Coverage, 397,
     /* 300552 */   GIR_Done,
     /* 300553 */ // Label 6067: @300553
     /* 300553 */ GIM_Try, /*On fail goto*//*Label 6068*/ GIMT_Encode4(300583), // Rule ID 401 //
     /* 300558 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 300561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 300564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 300568 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300572 */   // (fp_to_sint:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 300572 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 300577 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 300581 */   GIR_RootConstrainSelectedInstOperands,
     /* 300582 */   // GIR_Coverage, 401,
     /* 300582 */   GIR_Done,
     /* 300583 */ // Label 6068: @300583
     /* 300583 */ GIM_Try, /*On fail goto*//*Label 6069*/ GIMT_Encode4(300613), // Rule ID 405 //
     /* 300588 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 300591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 300594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 300598 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300602 */   // (fp_to_sint:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 300602 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 300607 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 300611 */   GIR_RootConstrainSelectedInstOperands,
     /* 300612 */   // GIR_Coverage, 405,
     /* 300612 */   GIR_Done,
     /* 300613 */ // Label 6069: @300613
     /* 300613 */ GIM_Reject,
     /* 300614 */ // Label 6042: @300614
     /* 300614 */ GIM_Try, /*On fail goto*//*Label 6070*/ GIMT_Encode4(300644), // Rule ID 836 //
     /* 300619 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 300625 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300629 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300633 */   // (fp_to_sint:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 300633 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
     /* 300638 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 300642 */   GIR_RootConstrainSelectedInstOperands,
     /* 300643 */   // GIR_Coverage, 836,
     /* 300643 */   GIR_Done,
     /* 300644 */ // Label 6070: @300644
     /* 300644 */ GIM_Try, /*On fail goto*//*Label 6071*/ GIMT_Encode4(300687), // Rule ID 12832 //
     /* 300649 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300652 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300655 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300659 */   // (fp_to_sint:{ *:[v2i32] } v2f64:{ *:[v2f64] }:$src)  =>  (XTNv2i32:{ *:[v2i32] } (FCVTZSv2f64:{ *:[f128] } V128:{ *:[v2f64] }:$src))
     /* 300659 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 300662 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 300666 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300671 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 300675 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 300677 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv2i32),
     /* 300680 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300682 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300685 */   GIR_RootConstrainSelectedInstOperands,
     /* 300686 */   // GIR_Coverage, 12832,
     /* 300686 */   GIR_EraseRootFromParent_Done,
     /* 300687 */ // Label 6071: @300687
     /* 300687 */ GIM_Reject,
     /* 300688 */ // Label 6043: @300688
     /* 300688 */ GIM_Try, /*On fail goto*//*Label 6072*/ GIMT_Encode4(300718), // Rule ID 840 //
     /* 300693 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300696 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300703 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300707 */   // (fp_to_sint:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 300707 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 300712 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 300716 */   GIR_RootConstrainSelectedInstOperands,
     /* 300717 */   // GIR_Coverage, 840,
     /* 300717 */   GIR_Done,
     /* 300718 */ // Label 6072: @300718
     /* 300718 */ GIM_Try, /*On fail goto*//*Label 6073*/ GIMT_Encode4(300761), // Rule ID 12830 //
     /* 300723 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300726 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 300729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300733 */   // (fp_to_sint:{ *:[v2i64] } v2f32:{ *:[v2f32] }:$src)  =>  (FCVTZSv2f64:{ *:[v2i64] } (FCVTLv2i32:{ *:[f128] } V64:{ *:[v2f32] }:$src))
     /* 300733 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 300736 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv2i32),
     /* 300740 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300745 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 300749 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 300751 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 300754 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300756 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300759 */   GIR_RootConstrainSelectedInstOperands,
     /* 300760 */   // GIR_Coverage, 12830,
     /* 300760 */   GIR_EraseRootFromParent_Done,
     /* 300761 */ // Label 6073: @300761
     /* 300761 */ GIM_Reject,
     /* 300762 */ // Label 6044: @300762
     /* 300762 */ GIM_Try, /*On fail goto*//*Label 6074*/ GIMT_Encode4(300792), // Rule ID 832 //
     /* 300767 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 300770 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 300773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300777 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300781 */   // (fp_to_sint:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 300781 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
     /* 300786 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 300790 */   GIR_RootConstrainSelectedInstOperands,
     /* 300791 */   // GIR_Coverage, 832,
     /* 300791 */   GIR_Done,
     /* 300792 */ // Label 6074: @300792
     /* 300792 */ GIM_Reject,
     /* 300793 */ // Label 6045: @300793
     /* 300793 */ GIM_Try, /*On fail goto*//*Label 6075*/ GIMT_Encode4(300823), // Rule ID 838 //
     /* 300798 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 300804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300808 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300812 */   // (fp_to_sint:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 300812 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
     /* 300817 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 300821 */   GIR_RootConstrainSelectedInstOperands,
     /* 300822 */   // GIR_Coverage, 838,
     /* 300822 */   GIR_Done,
     /* 300823 */ // Label 6075: @300823
     /* 300823 */ GIM_Reject,
     /* 300824 */ // Label 6046: @300824
     /* 300824 */ GIM_Try, /*On fail goto*//*Label 6076*/ GIMT_Encode4(300854), // Rule ID 834 //
     /* 300829 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 300832 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 300835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300839 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300843 */   // (fp_to_sint:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 300843 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
     /* 300848 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 300852 */   GIR_RootConstrainSelectedInstOperands,
     /* 300853 */   // GIR_Coverage, 834,
     /* 300853 */   GIR_Done,
     /* 300854 */ // Label 6076: @300854
     /* 300854 */ GIM_Reject,
     /* 300855 */ // Label 6047: @300855
     /* 300855 */ GIM_Reject,
     /* 300856 */ // Label 63: @300856
     /* 300856 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6084*/ GIMT_Encode4(301918),
     /* 300867 */ /*GILLT_s32*//*Label 6077*/ GIMT_Encode4(300903),
     /* 300871 */ /*GILLT_s64*//*Label 6078*/ GIMT_Encode4(301290), GIMT_Encode4(0),
     /* 300879 */ /*GILLT_v2s32*//*Label 6079*/ GIMT_Encode4(301677),
     /* 300883 */ /*GILLT_v2s64*//*Label 6080*/ GIMT_Encode4(301751),
     /* 300887 */ /*GILLT_v4s16*//*Label 6081*/ GIMT_Encode4(301825),
     /* 300891 */ /*GILLT_v4s32*//*Label 6082*/ GIMT_Encode4(301856), GIMT_Encode4(0),
     /* 300899 */ /*GILLT_v8s16*//*Label 6083*/ GIMT_Encode4(301887),
     /* 300903 */ // Label 6077: @300903
     /* 300903 */ GIM_Try, /*On fail goto*//*Label 6085*/ GIMT_Encode4(300940), // Rule ID 4599 //
     /* 300908 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 300911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 300915 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300919 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 300923 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 300927 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300929 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 300929 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWSr),
     /* 300932 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300934 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 300938 */   GIR_RootConstrainSelectedInstOperands,
     /* 300939 */   // GIR_Coverage, 4599,
     /* 300939 */   GIR_EraseRootFromParent_Done,
     /* 300940 */ // Label 6085: @300940
     /* 300940 */ GIM_Try, /*On fail goto*//*Label 6086*/ GIMT_Encode4(300977), // Rule ID 4601 //
     /* 300945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 300948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 300952 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300956 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 300960 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 300964 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300966 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 300966 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWDr),
     /* 300969 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300971 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 300975 */   GIR_RootConstrainSelectedInstOperands,
     /* 300976 */   // GIR_Coverage, 4601,
     /* 300976 */   GIR_EraseRootFromParent_Done,
     /* 300977 */ // Label 6086: @300977
     /* 300977 */ GIM_Try, /*On fail goto*//*Label 6087*/ GIMT_Encode4(301014), // Rule ID 4619 //
     /* 300982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 300985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 300989 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300993 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 300997 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 301001 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301003 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 301003 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWSr),
     /* 301006 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301008 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301012 */   GIR_RootConstrainSelectedInstOperands,
     /* 301013 */   // GIR_Coverage, 4619,
     /* 301013 */   GIR_EraseRootFromParent_Done,
     /* 301014 */ // Label 6087: @301014
     /* 301014 */ GIM_Try, /*On fail goto*//*Label 6088*/ GIMT_Encode4(301051), // Rule ID 4621 //
     /* 301019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 301022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 301026 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301030 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 301034 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 301038 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301040 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 301040 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWDr),
     /* 301043 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301045 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301049 */   GIR_RootConstrainSelectedInstOperands,
     /* 301050 */   // GIR_Coverage, 4621,
     /* 301050 */   GIR_EraseRootFromParent_Done,
     /* 301051 */ // Label 6088: @301051
     /* 301051 */ GIM_Try, /*On fail goto*//*Label 6089*/ GIMT_Encode4(301088), // Rule ID 4659 //
     /* 301056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 301059 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 301063 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301067 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 301071 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 301075 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301077 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTAUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 301077 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWSr),
     /* 301080 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301082 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301086 */   GIR_RootConstrainSelectedInstOperands,
     /* 301087 */   // GIR_Coverage, 4659,
     /* 301087 */   GIR_EraseRootFromParent_Done,
     /* 301088 */ // Label 6089: @301088
     /* 301088 */ GIM_Try, /*On fail goto*//*Label 6090*/ GIMT_Encode4(301125), // Rule ID 4661 //
     /* 301093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 301096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 301100 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301104 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 301108 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 301112 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301114 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTAUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 301114 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWDr),
     /* 301117 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301119 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301123 */   GIR_RootConstrainSelectedInstOperands,
     /* 301124 */   // GIR_Coverage, 4661,
     /* 301124 */   GIR_EraseRootFromParent_Done,
     /* 301125 */ // Label 6090: @301125
     /* 301125 */ GIM_Try, /*On fail goto*//*Label 6091*/ GIMT_Encode4(301162), // Rule ID 4639 //
     /* 301130 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 301133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 301137 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301141 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 301145 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 301149 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301151 */   // (fp_to_uint:{ *:[i32] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 301151 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 301154 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301156 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301160 */   GIR_RootConstrainSelectedInstOperands,
     /* 301161 */   // GIR_Coverage, 4639,
     /* 301161 */   GIR_EraseRootFromParent_Done,
     /* 301162 */ // Label 6091: @301162
     /* 301162 */ GIM_Try, /*On fail goto*//*Label 6092*/ GIMT_Encode4(301199), // Rule ID 4641 //
     /* 301167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 301170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 301174 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301178 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 301182 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 301186 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301188 */   // (fp_to_uint:{ *:[i32] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 301188 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 301191 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301193 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301197 */   GIR_RootConstrainSelectedInstOperands,
     /* 301198 */   // GIR_Coverage, 4641,
     /* 301198 */   GIR_EraseRootFromParent_Done,
     /* 301199 */ // Label 6092: @301199
     /* 301199 */ GIM_Try, /*On fail goto*//*Label 6093*/ GIMT_Encode4(301229), // Rule ID 407 //
     /* 301204 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 301207 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 301210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 301214 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 301218 */   // (fp_to_uint:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 301218 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
     /* 301223 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 301227 */   GIR_RootConstrainSelectedInstOperands,
     /* 301228 */   // GIR_Coverage, 407,
     /* 301228 */   GIR_Done,
     /* 301229 */ // Label 6093: @301229
     /* 301229 */ GIM_Try, /*On fail goto*//*Label 6094*/ GIMT_Encode4(301259), // Rule ID 411 //
     /* 301234 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 301237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 301240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 301244 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 301248 */   // (fp_to_uint:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 301248 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 301253 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 301257 */   GIR_RootConstrainSelectedInstOperands,
     /* 301258 */   // GIR_Coverage, 411,
     /* 301258 */   GIR_Done,
     /* 301259 */ // Label 6094: @301259
     /* 301259 */ GIM_Try, /*On fail goto*//*Label 6095*/ GIMT_Encode4(301289), // Rule ID 415 //
     /* 301264 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 301267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 301270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 301274 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301278 */   // (fp_to_uint:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 301278 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 301283 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 301287 */   GIR_RootConstrainSelectedInstOperands,
     /* 301288 */   // GIR_Coverage, 415,
     /* 301288 */   GIR_Done,
     /* 301289 */ // Label 6095: @301289
     /* 301289 */ GIM_Reject,
     /* 301290 */ // Label 6078: @301290
     /* 301290 */ GIM_Try, /*On fail goto*//*Label 6096*/ GIMT_Encode4(301327), // Rule ID 4600 //
     /* 301295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 301298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 301302 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301306 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 301310 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 301314 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301316 */   // (fp_to_uint:{ *:[i64] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 301316 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXSr),
     /* 301319 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301321 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301325 */   GIR_RootConstrainSelectedInstOperands,
     /* 301326 */   // GIR_Coverage, 4600,
     /* 301326 */   GIR_EraseRootFromParent_Done,
     /* 301327 */ // Label 6096: @301327
     /* 301327 */ GIM_Try, /*On fail goto*//*Label 6097*/ GIMT_Encode4(301364), // Rule ID 4602 //
     /* 301332 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 301335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 301339 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301343 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 301347 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 301351 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301353 */   // (fp_to_uint:{ *:[i64] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 301353 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXDr),
     /* 301356 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301358 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301362 */   GIR_RootConstrainSelectedInstOperands,
     /* 301363 */   // GIR_Coverage, 4602,
     /* 301363 */   GIR_EraseRootFromParent_Done,
     /* 301364 */ // Label 6097: @301364
     /* 301364 */ GIM_Try, /*On fail goto*//*Label 6098*/ GIMT_Encode4(301401), // Rule ID 4620 //
     /* 301369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 301372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 301376 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301380 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 301384 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 301388 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301390 */   // (fp_to_uint:{ *:[i64] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 301390 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXSr),
     /* 301393 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301395 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301399 */   GIR_RootConstrainSelectedInstOperands,
     /* 301400 */   // GIR_Coverage, 4620,
     /* 301400 */   GIR_EraseRootFromParent_Done,
     /* 301401 */ // Label 6098: @301401
     /* 301401 */ GIM_Try, /*On fail goto*//*Label 6099*/ GIMT_Encode4(301438), // Rule ID 4622 //
     /* 301406 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 301409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 301413 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301417 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 301421 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 301425 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301427 */   // (fp_to_uint:{ *:[i64] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 301427 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXDr),
     /* 301430 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301432 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301436 */   GIR_RootConstrainSelectedInstOperands,
     /* 301437 */   // GIR_Coverage, 4622,
     /* 301437 */   GIR_EraseRootFromParent_Done,
     /* 301438 */ // Label 6099: @301438
     /* 301438 */ GIM_Try, /*On fail goto*//*Label 6100*/ GIMT_Encode4(301475), // Rule ID 4660 //
     /* 301443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 301446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 301450 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301454 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 301458 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 301462 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301464 */   // (fp_to_uint:{ *:[i64] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTAUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 301464 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXSr),
     /* 301467 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301469 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301473 */   GIR_RootConstrainSelectedInstOperands,
     /* 301474 */   // GIR_Coverage, 4660,
     /* 301474 */   GIR_EraseRootFromParent_Done,
     /* 301475 */ // Label 6100: @301475
     /* 301475 */ GIM_Try, /*On fail goto*//*Label 6101*/ GIMT_Encode4(301512), // Rule ID 4662 //
     /* 301480 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 301483 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 301487 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301491 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 301495 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 301499 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301501 */   // (fp_to_uint:{ *:[i64] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTAUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 301501 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXDr),
     /* 301504 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301506 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301510 */   GIR_RootConstrainSelectedInstOperands,
     /* 301511 */   // GIR_Coverage, 4662,
     /* 301511 */   GIR_EraseRootFromParent_Done,
     /* 301512 */ // Label 6101: @301512
     /* 301512 */ GIM_Try, /*On fail goto*//*Label 6102*/ GIMT_Encode4(301549), // Rule ID 4640 //
     /* 301517 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 301520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 301524 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301528 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 301532 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 301536 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301538 */   // (fp_to_uint:{ *:[i64] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 301538 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 301541 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301543 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301547 */   GIR_RootConstrainSelectedInstOperands,
     /* 301548 */   // GIR_Coverage, 4640,
     /* 301548 */   GIR_EraseRootFromParent_Done,
     /* 301549 */ // Label 6102: @301549
     /* 301549 */ GIM_Try, /*On fail goto*//*Label 6103*/ GIMT_Encode4(301586), // Rule ID 4642 //
     /* 301554 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 301557 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 301561 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301565 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 301569 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 301573 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301575 */   // (fp_to_uint:{ *:[i64] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 301575 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 301578 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301580 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301584 */   GIR_RootConstrainSelectedInstOperands,
     /* 301585 */   // GIR_Coverage, 4642,
     /* 301585 */   GIR_EraseRootFromParent_Done,
     /* 301586 */ // Label 6103: @301586
     /* 301586 */ GIM_Try, /*On fail goto*//*Label 6104*/ GIMT_Encode4(301616), // Rule ID 409 //
     /* 301591 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 301594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 301597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 301601 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 301605 */   // (fp_to_uint:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 301605 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
     /* 301610 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 301614 */   GIR_RootConstrainSelectedInstOperands,
     /* 301615 */   // GIR_Coverage, 409,
     /* 301615 */   GIR_Done,
     /* 301616 */ // Label 6104: @301616
     /* 301616 */ GIM_Try, /*On fail goto*//*Label 6105*/ GIMT_Encode4(301646), // Rule ID 413 //
     /* 301621 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 301624 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 301627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 301631 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 301635 */   // (fp_to_uint:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 301635 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 301640 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 301644 */   GIR_RootConstrainSelectedInstOperands,
     /* 301645 */   // GIR_Coverage, 413,
     /* 301645 */   GIR_Done,
     /* 301646 */ // Label 6105: @301646
     /* 301646 */ GIM_Try, /*On fail goto*//*Label 6106*/ GIMT_Encode4(301676), // Rule ID 417 //
     /* 301651 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 301654 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 301657 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 301661 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301665 */   // (fp_to_uint:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 301665 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 301670 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 301674 */   GIR_RootConstrainSelectedInstOperands,
     /* 301675 */   // GIR_Coverage, 417,
     /* 301675 */   GIR_Done,
     /* 301676 */ // Label 6106: @301676
     /* 301676 */ GIM_Reject,
     /* 301677 */ // Label 6079: @301677
     /* 301677 */ GIM_Try, /*On fail goto*//*Label 6107*/ GIMT_Encode4(301707), // Rule ID 846 //
     /* 301682 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301685 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 301688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301692 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301696 */   // (fp_to_uint:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 301696 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
     /* 301701 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 301705 */   GIR_RootConstrainSelectedInstOperands,
     /* 301706 */   // GIR_Coverage, 846,
     /* 301706 */   GIR_Done,
     /* 301707 */ // Label 6107: @301707
     /* 301707 */ GIM_Try, /*On fail goto*//*Label 6108*/ GIMT_Encode4(301750), // Rule ID 12833 //
     /* 301712 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301722 */   // (fp_to_uint:{ *:[v2i32] } v2f64:{ *:[v2f64] }:$src)  =>  (XTNv2i32:{ *:[v2i32] } (FCVTZUv2f64:{ *:[f128] } V128:{ *:[v2f64] }:$src))
     /* 301722 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 301725 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 301729 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301734 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 301738 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 301740 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv2i32),
     /* 301743 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301745 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301748 */   GIR_RootConstrainSelectedInstOperands,
     /* 301749 */   // GIR_Coverage, 12833,
     /* 301749 */   GIR_EraseRootFromParent_Done,
     /* 301750 */ // Label 6108: @301750
     /* 301750 */ GIM_Reject,
     /* 301751 */ // Label 6080: @301751
     /* 301751 */ GIM_Try, /*On fail goto*//*Label 6109*/ GIMT_Encode4(301781), // Rule ID 850 //
     /* 301756 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301759 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301766 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301770 */   // (fp_to_uint:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 301770 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 301775 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 301779 */   GIR_RootConstrainSelectedInstOperands,
     /* 301780 */   // GIR_Coverage, 850,
     /* 301780 */   GIR_Done,
     /* 301781 */ // Label 6109: @301781
     /* 301781 */ GIM_Try, /*On fail goto*//*Label 6110*/ GIMT_Encode4(301824), // Rule ID 12831 //
     /* 301786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 301792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301796 */   // (fp_to_uint:{ *:[v2i64] } v2f32:{ *:[v2f32] }:$src)  =>  (FCVTZUv2f64:{ *:[v2i64] } (FCVTLv2i32:{ *:[f128] } V64:{ *:[v2f32] }:$src))
     /* 301796 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 301799 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv2i32),
     /* 301803 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301808 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 301812 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 301814 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 301817 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 301819 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301822 */   GIR_RootConstrainSelectedInstOperands,
     /* 301823 */   // GIR_Coverage, 12831,
     /* 301823 */   GIR_EraseRootFromParent_Done,
     /* 301824 */ // Label 6110: @301824
     /* 301824 */ GIM_Reject,
     /* 301825 */ // Label 6081: @301825
     /* 301825 */ GIM_Try, /*On fail goto*//*Label 6111*/ GIMT_Encode4(301855), // Rule ID 842 //
     /* 301830 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 301833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 301836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301840 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301844 */   // (fp_to_uint:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 301844 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
     /* 301849 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 301853 */   GIR_RootConstrainSelectedInstOperands,
     /* 301854 */   // GIR_Coverage, 842,
     /* 301854 */   GIR_Done,
     /* 301855 */ // Label 6111: @301855
     /* 301855 */ GIM_Reject,
     /* 301856 */ // Label 6082: @301856
     /* 301856 */ GIM_Try, /*On fail goto*//*Label 6112*/ GIMT_Encode4(301886), // Rule ID 848 //
     /* 301861 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301864 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 301867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301871 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301875 */   // (fp_to_uint:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 301875 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
     /* 301880 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 301884 */   GIR_RootConstrainSelectedInstOperands,
     /* 301885 */   // GIR_Coverage, 848,
     /* 301885 */   GIR_Done,
     /* 301886 */ // Label 6112: @301886
     /* 301886 */ GIM_Reject,
     /* 301887 */ // Label 6083: @301887
     /* 301887 */ GIM_Try, /*On fail goto*//*Label 6113*/ GIMT_Encode4(301917), // Rule ID 844 //
     /* 301892 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 301895 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 301898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301902 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301906 */   // (fp_to_uint:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 301906 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
     /* 301911 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 301915 */   GIR_RootConstrainSelectedInstOperands,
     /* 301916 */   // GIR_Coverage, 844,
     /* 301916 */   GIR_Done,
     /* 301917 */ // Label 6113: @301917
     /* 301917 */ GIM_Reject,
     /* 301918 */ // Label 6084: @301918
     /* 301918 */ GIM_Reject,
     /* 301919 */ // Label 64: @301919
     /* 301919 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6122*/ GIMT_Encode4(306315),
     /* 301930 */ /*GILLT_s16*//*Label 6114*/ GIMT_Encode4(301970),
     /* 301934 */ /*GILLT_s32*//*Label 6115*/ GIMT_Encode4(302251),
     /* 301938 */ /*GILLT_s64*//*Label 6116*/ GIMT_Encode4(304167), GIMT_Encode4(0),
     /* 301946 */ /*GILLT_v2s32*//*Label 6117*/ GIMT_Encode4(306071),
     /* 301950 */ /*GILLT_v2s64*//*Label 6118*/ GIMT_Encode4(306145),
     /* 301954 */ /*GILLT_v4s16*//*Label 6119*/ GIMT_Encode4(306222),
     /* 301958 */ /*GILLT_v4s32*//*Label 6120*/ GIMT_Encode4(306253), GIMT_Encode4(0),
     /* 301966 */ /*GILLT_v8s16*//*Label 6121*/ GIMT_Encode4(306284),
     /* 301970 */ // Label 6114: @301970
     /* 301970 */ GIM_Try, /*On fail goto*//*Label 6123*/ GIMT_Encode4(302073), // Rule ID 5259 //
     /* 301975 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 301978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 301981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 301985 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301989 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 301993 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 301997 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 302001 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 302005 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302009 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 302013 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302018 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 302022 */   // MIs[1] Operand 2
     /* 302022 */   GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 302033 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302035 */   // (sint_to_fp:{ *:[f16] } (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), i16:{ *:[Other] }))  =>  (SCVTFv1i16:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR128:{ *:[v8i16] }:$Rn, hsub:{ *:[i32] }))
     /* 302035 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 302038 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 302042 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302047 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 302053 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 302058 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302063 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
     /* 302066 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 302068 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302071 */   GIR_RootConstrainSelectedInstOperands,
     /* 302072 */   // GIR_Coverage, 5259,
     /* 302072 */   GIR_EraseRootFromParent_Done,
     /* 302073 */ // Label 6123: @302073
     /* 302073 */ GIM_Try, /*On fail goto*//*Label 6124*/ GIMT_Encode4(302130), // Rule ID 5250 //
     /* 302078 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 302081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 302084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 302088 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302092 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
     /* 302096 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 302100 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 302102 */   // (sint_to_fp:{ *:[f16] } (fp_to_sint:{ *:[i32] } f16:{ *:[f16] }:$Rn))  =>  (SCVTFv1i16:{ *:[f16] } (FCVTZSv1f16:{ *:[f16] } f16:{ *:[f16] }:$Rn))
     /* 302102 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 302105 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1f16),
     /* 302109 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302114 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 302118 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 302120 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
     /* 302123 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 302125 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302128 */   GIR_RootConstrainSelectedInstOperands,
     /* 302129 */   // GIR_Coverage, 5250,
     /* 302129 */   GIR_EraseRootFromParent_Done,
     /* 302130 */ // Label 6124: @302130
     /* 302130 */ GIM_Try, /*On fail goto*//*Label 6125*/ GIMT_Encode4(302160), // Rule ID 443 //
     /* 302135 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 302138 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 302141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 302145 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 302149 */   // (sint_to_fp:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWHri:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)
     /* 302149 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWHri),
     /* 302154 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 302158 */   GIR_RootConstrainSelectedInstOperands,
     /* 302159 */   // GIR_Coverage, 443,
     /* 302159 */   GIR_Done,
     /* 302160 */ // Label 6125: @302160
     /* 302160 */ GIM_Try, /*On fail goto*//*Label 6126*/ GIMT_Encode4(302190), // Rule ID 449 //
     /* 302165 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 302168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 302171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 302175 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 302179 */   // (sint_to_fp:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXHri:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)
     /* 302179 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXHri),
     /* 302184 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 302188 */   GIR_RootConstrainSelectedInstOperands,
     /* 302189 */   // GIR_Coverage, 449,
     /* 302189 */   GIR_Done,
     /* 302190 */ // Label 6126: @302190
     /* 302190 */ GIM_Try, /*On fail goto*//*Label 6127*/ GIMT_Encode4(302220), // Rule ID 491 //
     /* 302195 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 302198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 302201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 302205 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 302209 */   // (sint_to_fp:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)  =>  (SCVTFHSr:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)
     /* 302209 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFHSr),
     /* 302214 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 302218 */   GIR_RootConstrainSelectedInstOperands,
     /* 302219 */   // GIR_Coverage, 491,
     /* 302219 */   GIR_Done,
     /* 302220 */ // Label 6127: @302220
     /* 302220 */ GIM_Try, /*On fail goto*//*Label 6128*/ GIMT_Encode4(302250), // Rule ID 495 //
     /* 302225 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 302228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 302231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 302235 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302239 */   // (sint_to_fp:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)  =>  (SCVTFHDr:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)
     /* 302239 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFHDr),
     /* 302244 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 302248 */   GIR_RootConstrainSelectedInstOperands,
     /* 302249 */   // GIR_Coverage, 495,
     /* 302249 */   GIR_Done,
     /* 302250 */ // Label 6128: @302250
     /* 302250 */ GIM_Reject,
     /* 302251 */ // Label 6115: @302251
     /* 302251 */ GIM_Try, /*On fail goto*//*Label 6129*/ GIMT_Encode4(302489), // Rule ID 6288 //
     /* 302256 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 302259 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 302262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 302266 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302270 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 302274 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 302277 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 302284 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 302288 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 302290 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 302297 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$ext), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 302297 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 302300 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 302304 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302309 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 302314 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 302319 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 302324 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 302329 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 302331 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 302334 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 302338 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302343 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 302345 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 302348 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 302352 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302357 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 302360 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 302363 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 302366 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302371 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302376 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 302381 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 302384 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 302388 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302393 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 302396 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 302399 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 302401 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 302404 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 302408 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302413 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 302420 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302425 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302430 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 302433 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 302437 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302442 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 302445 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 302448 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 302450 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 302453 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 302457 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302462 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 302469 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 302474 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302479 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 302482 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 302484 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302487 */   GIR_RootConstrainSelectedInstOperands,
     /* 302488 */   // GIR_Coverage, 6288,
     /* 302488 */   GIR_EraseRootFromParent_Done,
     /* 302489 */ // Label 6129: @302489
     /* 302489 */ GIM_Try, /*On fail goto*//*Label 6130*/ GIMT_Encode4(302727), // Rule ID 6289 //
     /* 302494 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 302497 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 302500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 302504 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302508 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 302512 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 302515 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 302522 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 302526 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 302528 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 302535 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$ext), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 302535 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 302538 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 302542 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302547 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 302552 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 302557 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 302562 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 302567 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 302569 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 302572 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 302576 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302581 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 302583 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 302586 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 302590 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302595 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 302598 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 302601 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 302604 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302609 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302614 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 302619 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 302622 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 302626 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302631 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 302634 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 302637 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 302639 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 302642 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 302646 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302651 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 302658 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302663 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302668 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 302671 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 302675 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302680 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 302683 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 302686 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 302688 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 302691 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 302695 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302700 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 302707 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 302712 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302717 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 302720 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 302722 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302725 */   GIR_RootConstrainSelectedInstOperands,
     /* 302726 */   // GIR_Coverage, 6289,
     /* 302726 */   GIR_EraseRootFromParent_Done,
     /* 302727 */ // Label 6130: @302727
     /* 302727 */ GIM_Try, /*On fail goto*//*Label 6131*/ GIMT_Encode4(302916), // Rule ID 6292 //
     /* 302732 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 302735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 302738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 302742 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302746 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 302750 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 302753 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 302760 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 302764 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 302766 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 302773 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 302773 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 302776 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 302780 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302785 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 302790 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 302795 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 302800 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 302805 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 302807 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 302810 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 302814 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302819 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 302821 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 302824 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 302828 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302833 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 302836 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 302839 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 302842 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302847 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302852 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 302857 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 302860 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 302864 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302869 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 302872 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 302875 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 302877 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 302880 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 302884 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302889 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 302896 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 302901 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302906 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 302909 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 302911 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302914 */   GIR_RootConstrainSelectedInstOperands,
     /* 302915 */   // GIR_Coverage, 6292,
     /* 302915 */   GIR_EraseRootFromParent_Done,
     /* 302916 */ // Label 6131: @302916
     /* 302916 */ GIM_Try, /*On fail goto*//*Label 6132*/ GIMT_Encode4(303105), // Rule ID 6293 //
     /* 302921 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 302924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 302927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 302931 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302935 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 302939 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 302942 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 302949 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 302953 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 302955 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 302962 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 302962 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 302965 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 302969 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302974 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 302979 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 302984 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 302989 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 302994 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 302996 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 302999 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 303003 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303008 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 303010 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 303013 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 303017 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303022 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 303025 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 303028 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 303031 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303036 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303041 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 303046 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 303049 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 303053 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303058 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 303061 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 303064 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 303066 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 303069 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 303073 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303078 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 303085 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303090 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303095 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 303098 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303100 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303103 */   GIR_RootConstrainSelectedInstOperands,
     /* 303104 */   // GIR_Coverage, 6293,
     /* 303104 */   GIR_EraseRootFromParent_Done,
     /* 303105 */ // Label 6132: @303105
     /* 303105 */ GIM_Try, /*On fail goto*//*Label 6133*/ GIMT_Encode4(303338), // Rule ID 6290 //
     /* 303110 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 303113 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 303116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303120 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303124 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 303128 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 303131 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 303138 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 303142 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 303144 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 303151 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 303151 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 303154 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 303158 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303163 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 303168 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 303173 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 303178 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 303180 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 303183 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 303187 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303192 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 303194 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 303197 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 303201 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303206 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 303209 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 303212 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 303215 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303220 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303225 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 303230 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 303233 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 303237 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303242 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 303245 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 303248 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 303250 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 303253 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 303257 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303262 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 303269 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303274 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303279 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 303282 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 303286 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303291 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 303294 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 303297 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 303299 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 303302 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 303306 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303311 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 303318 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303323 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303328 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 303331 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303333 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303336 */   GIR_RootConstrainSelectedInstOperands,
     /* 303337 */   // GIR_Coverage, 6290,
     /* 303337 */   GIR_EraseRootFromParent_Done,
     /* 303338 */ // Label 6133: @303338
     /* 303338 */ GIM_Try, /*On fail goto*//*Label 6134*/ GIMT_Encode4(303571), // Rule ID 6291 //
     /* 303343 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 303346 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 303349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303353 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303357 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 303361 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 303364 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 303371 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 303375 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 303377 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 303384 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 303384 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 303387 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 303391 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303396 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 303401 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 303406 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 303411 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 303413 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 303416 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 303420 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303425 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 303427 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 303430 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 303434 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303439 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 303442 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 303445 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 303448 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303453 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303458 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 303463 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 303466 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 303470 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303475 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 303478 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 303481 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 303483 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 303486 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 303490 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303495 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 303502 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303507 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303512 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 303515 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 303519 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303524 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 303527 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 303530 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 303532 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 303535 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 303539 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303544 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 303551 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303556 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303561 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 303564 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303566 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303569 */   GIR_RootConstrainSelectedInstOperands,
     /* 303570 */   // GIR_Coverage, 6291,
     /* 303570 */   GIR_EraseRootFromParent_Done,
     /* 303571 */ // Label 6134: @303571
     /* 303571 */ GIM_Try, /*On fail goto*//*Label 6135*/ GIMT_Encode4(303755), // Rule ID 6294 //
     /* 303576 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 303579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 303582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303586 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303590 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 303594 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 303597 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 303604 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 303608 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 303610 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 303617 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 303617 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 303620 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 303624 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303629 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 303634 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 303639 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 303644 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 303646 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 303649 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 303653 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303658 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 303660 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 303663 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 303667 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303672 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 303675 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 303678 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 303681 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303686 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303691 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 303696 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 303699 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 303703 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303708 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 303711 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 303714 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 303716 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 303719 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 303723 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303728 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 303735 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303740 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303745 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 303748 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303750 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303753 */   GIR_RootConstrainSelectedInstOperands,
     /* 303754 */   // GIR_Coverage, 6294,
     /* 303754 */   GIR_EraseRootFromParent_Done,
     /* 303755 */ // Label 6135: @303755
     /* 303755 */ GIM_Try, /*On fail goto*//*Label 6136*/ GIMT_Encode4(303939), // Rule ID 6295 //
     /* 303760 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 303763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 303766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303770 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303774 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 303778 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 303781 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 303788 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 303792 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 303794 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 303801 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 303801 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 303804 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 303808 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303813 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 303818 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 303823 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 303828 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 303830 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 303833 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 303837 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303842 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 303844 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 303847 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 303851 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303856 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 303859 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 303862 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 303865 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303870 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303875 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 303880 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 303883 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 303887 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303892 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 303895 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 303898 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 303900 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 303903 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 303907 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303912 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 303919 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303924 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303929 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 303932 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303934 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303937 */   GIR_RootConstrainSelectedInstOperands,
     /* 303938 */   // GIR_Coverage, 6295,
     /* 303938 */   GIR_EraseRootFromParent_Done,
     /* 303939 */ // Label 6136: @303939
     /* 303939 */ GIM_Try, /*On fail goto*//*Label 6137*/ GIMT_Encode4(304019), // Rule ID 5255 //
     /* 303944 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 303947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 303950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303954 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303958 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303962 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303966 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 303970 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303975 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 303979 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 303981 */   // (sint_to_fp:{ *:[f32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 303981 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 303984 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 303988 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303993 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 303999 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304004 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304009 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 304012 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304014 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304017 */   GIR_RootConstrainSelectedInstOperands,
     /* 304018 */   // GIR_Coverage, 5255,
     /* 304018 */   GIR_EraseRootFromParent_Done,
     /* 304019 */ // Label 6137: @304019
     /* 304019 */ GIM_Try, /*On fail goto*//*Label 6138*/ GIMT_Encode4(304076), // Rule ID 5238 //
     /* 304024 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 304027 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 304030 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304034 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304038 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
     /* 304042 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 304046 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304048 */   // (sint_to_fp:{ *:[f32] } (fp_to_sint:{ *:[i32] } f32:{ *:[f32] }:$Rn))  =>  (SCVTFv1i32:{ *:[f32] } (FCVTZSv1i32:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /* 304048 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 304051 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i32),
     /* 304055 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304060 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 304064 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 304066 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 304069 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304071 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304074 */   GIR_RootConstrainSelectedInstOperands,
     /* 304075 */   // GIR_Coverage, 5238,
     /* 304075 */   GIR_EraseRootFromParent_Done,
     /* 304076 */ // Label 6138: @304076
     /* 304076 */ GIM_Try, /*On fail goto*//*Label 6139*/ GIMT_Encode4(304106), // Rule ID 445 //
     /* 304081 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 304084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 304087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304091 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 304095 */   // (sint_to_fp:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWSri:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)
     /* 304095 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWSri),
     /* 304100 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 304104 */   GIR_RootConstrainSelectedInstOperands,
     /* 304105 */   // GIR_Coverage, 445,
     /* 304105 */   GIR_Done,
     /* 304106 */ // Label 6139: @304106
     /* 304106 */ GIM_Try, /*On fail goto*//*Label 6140*/ GIMT_Encode4(304136), // Rule ID 451 //
     /* 304111 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 304114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 304117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304121 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 304125 */   // (sint_to_fp:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXSri:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)
     /* 304125 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXSri),
     /* 304130 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 304134 */   GIR_RootConstrainSelectedInstOperands,
     /* 304135 */   // GIR_Coverage, 451,
     /* 304135 */   GIR_Done,
     /* 304136 */ // Label 6140: @304136
     /* 304136 */ GIM_Try, /*On fail goto*//*Label 6141*/ GIMT_Encode4(304166), // Rule ID 497 //
     /* 304141 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 304144 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 304147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304151 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304155 */   // (sint_to_fp:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)  =>  (SCVTFSDr:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)
     /* 304155 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFSDr),
     /* 304160 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 304164 */   GIR_RootConstrainSelectedInstOperands,
     /* 304165 */   // GIR_Coverage, 497,
     /* 304165 */   GIR_Done,
     /* 304166 */ // Label 6141: @304166
     /* 304166 */ GIM_Reject,
     /* 304167 */ // Label 6116: @304167
     /* 304167 */ GIM_Try, /*On fail goto*//*Label 6142*/ GIMT_Encode4(304353), // Rule ID 6300 //
     /* 304172 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 304175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 304178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304182 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304186 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 304190 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 304193 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 304197 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 304201 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304203 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 304210 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$ext), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 304210 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 304213 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 304217 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304222 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 304227 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 304232 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 304237 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 304242 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 304244 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 304247 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 304251 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304256 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 304258 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 304261 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 304265 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304270 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 304273 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 304276 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 304279 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304284 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304289 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304294 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 304297 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 304301 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304306 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 304309 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 304312 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 304314 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 304317 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 304321 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304326 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 304333 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304338 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304343 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 304346 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304348 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304351 */   GIR_RootConstrainSelectedInstOperands,
     /* 304352 */   // GIR_Coverage, 6300,
     /* 304352 */   GIR_EraseRootFromParent_Done,
     /* 304353 */ // Label 6142: @304353
     /* 304353 */ GIM_Try, /*On fail goto*//*Label 6143*/ GIMT_Encode4(304539), // Rule ID 6301 //
     /* 304358 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 304361 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 304364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304368 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304372 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 304376 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 304379 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 304383 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 304387 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304389 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 304396 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$ext), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 304396 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 304399 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 304403 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304408 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 304413 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 304418 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 304423 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 304428 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 304430 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 304433 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 304437 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304442 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 304444 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 304447 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 304451 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304456 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 304459 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 304462 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 304465 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304470 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304475 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304480 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 304483 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 304487 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304492 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 304495 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 304498 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 304500 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 304503 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 304507 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304512 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 304519 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304524 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304529 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 304532 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304534 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304537 */   GIR_RootConstrainSelectedInstOperands,
     /* 304538 */   // GIR_Coverage, 6301,
     /* 304538 */   GIR_EraseRootFromParent_Done,
     /* 304539 */ // Label 6143: @304539
     /* 304539 */ GIM_Try, /*On fail goto*//*Label 6144*/ GIMT_Encode4(304777), // Rule ID 6296 //
     /* 304544 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 304547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 304550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304554 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304558 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 304562 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 304565 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 304572 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 304576 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304578 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 304585 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 304585 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 304588 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 304592 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304597 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 304602 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 304607 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 304612 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 304617 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 304619 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 304622 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 304626 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304631 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 304633 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 304636 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 304640 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304645 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 304648 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 304651 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 304654 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304659 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304664 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 304669 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 304672 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 304676 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304681 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 304684 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 304687 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 304689 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 304692 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 304696 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304701 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 304708 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304713 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304718 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 304721 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 304725 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304730 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 304733 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 304736 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 304738 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 304741 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 304745 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304750 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 304757 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304762 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304767 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 304770 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304772 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304775 */   GIR_RootConstrainSelectedInstOperands,
     /* 304776 */   // GIR_Coverage, 6296,
     /* 304776 */   GIR_EraseRootFromParent_Done,
     /* 304777 */ // Label 6144: @304777
     /* 304777 */ GIM_Try, /*On fail goto*//*Label 6145*/ GIMT_Encode4(305015), // Rule ID 6297 //
     /* 304782 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 304785 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 304788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304792 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304796 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 304800 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 304803 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 304810 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 304814 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304816 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 304823 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 304823 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 304826 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 304830 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304835 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 304840 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 304845 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 304850 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 304855 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 304857 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 304860 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 304864 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304869 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 304871 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 304874 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 304878 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304883 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 304886 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 304889 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 304892 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304897 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304902 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 304907 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 304910 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 304914 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304919 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 304922 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 304925 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 304927 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 304930 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 304934 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304939 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 304946 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304951 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304956 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 304959 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 304963 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304968 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 304971 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 304974 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 304976 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 304979 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 304983 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304988 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 304995 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305000 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305005 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 305008 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305010 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305013 */   GIR_RootConstrainSelectedInstOperands,
     /* 305014 */   // GIR_Coverage, 6297,
     /* 305014 */   GIR_EraseRootFromParent_Done,
     /* 305015 */ // Label 6145: @305015
     /* 305015 */ GIM_Try, /*On fail goto*//*Label 6146*/ GIMT_Encode4(305196), // Rule ID 6302 //
     /* 305020 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 305023 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 305026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305030 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305034 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 305038 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 305041 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 305045 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 305049 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305051 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 305058 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 305058 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 305061 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 305065 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305070 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 305075 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 305080 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 305085 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 305087 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 305090 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 305094 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305099 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 305101 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 305104 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 305108 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305113 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 305116 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 305119 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 305122 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305127 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305132 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305137 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 305140 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 305144 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305149 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 305152 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 305155 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 305157 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 305160 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305164 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305169 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 305176 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305181 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305186 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 305189 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305191 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305194 */   GIR_RootConstrainSelectedInstOperands,
     /* 305195 */   // GIR_Coverage, 6302,
     /* 305195 */   GIR_EraseRootFromParent_Done,
     /* 305196 */ // Label 6146: @305196
     /* 305196 */ GIM_Try, /*On fail goto*//*Label 6147*/ GIMT_Encode4(305377), // Rule ID 6303 //
     /* 305201 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 305204 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 305207 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305211 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305215 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 305219 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 305222 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 305226 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 305230 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305232 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 305239 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 305239 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 305242 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 305246 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305251 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 305256 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 305261 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 305266 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 305268 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 305271 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 305275 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305280 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 305282 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 305285 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 305289 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305294 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 305297 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 305300 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 305303 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305308 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305313 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305318 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 305321 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 305325 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305330 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 305333 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 305336 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 305338 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 305341 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305345 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305350 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 305357 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305362 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305367 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 305370 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305372 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305375 */   GIR_RootConstrainSelectedInstOperands,
     /* 305376 */   // GIR_Coverage, 6303,
     /* 305376 */   GIR_EraseRootFromParent_Done,
     /* 305377 */ // Label 6147: @305377
     /* 305377 */ GIM_Try, /*On fail goto*//*Label 6148*/ GIMT_Encode4(305610), // Rule ID 6298 //
     /* 305382 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 305385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 305388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305392 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305396 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 305400 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 305403 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 305410 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 305414 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305416 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 305423 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 305423 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 305426 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 305430 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305435 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 305440 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 305445 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 305450 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 305452 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 305455 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 305459 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305464 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 305466 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 305469 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 305473 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305478 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 305481 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 305484 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 305487 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305492 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305497 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 305502 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 305505 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 305509 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305514 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 305517 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 305520 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 305522 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 305525 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305529 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305534 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 305541 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305546 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305551 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 305554 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 305558 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305563 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 305566 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 305569 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 305571 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 305574 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305578 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305583 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 305590 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305595 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305600 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 305603 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305605 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305608 */   GIR_RootConstrainSelectedInstOperands,
     /* 305609 */   // GIR_Coverage, 6298,
     /* 305609 */   GIR_EraseRootFromParent_Done,
     /* 305610 */ // Label 6148: @305610
     /* 305610 */ GIM_Try, /*On fail goto*//*Label 6149*/ GIMT_Encode4(305843), // Rule ID 6299 //
     /* 305615 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 305618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 305621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305625 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305629 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 305633 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 305636 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 305643 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 305647 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305649 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 305656 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 305656 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 305659 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 305663 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305668 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 305673 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 305678 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 305683 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 305685 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 305688 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 305692 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305697 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 305699 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 305702 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 305706 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305711 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 305714 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 305717 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 305720 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305725 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305730 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 305735 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 305738 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 305742 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305747 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 305750 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 305753 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 305755 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 305758 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305762 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305767 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 305774 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305779 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305784 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 305787 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 305791 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305796 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 305799 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 305802 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 305804 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 305807 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305811 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305816 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 305823 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305828 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305833 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 305836 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305838 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305841 */   GIR_RootConstrainSelectedInstOperands,
     /* 305842 */   // GIR_Coverage, 6299,
     /* 305842 */   GIR_EraseRootFromParent_Done,
     /* 305843 */ // Label 6149: @305843
     /* 305843 */ GIM_Try, /*On fail goto*//*Label 6150*/ GIMT_Encode4(305923), // Rule ID 5257 //
     /* 305848 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 305851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 305854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305858 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305862 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305866 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 305870 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305874 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305879 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 305883 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305885 */   // (sint_to_fp:{ *:[f64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 305885 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 305888 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305892 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305897 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 305903 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305908 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305913 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 305916 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305918 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305921 */   GIR_RootConstrainSelectedInstOperands,
     /* 305922 */   // GIR_Coverage, 5257,
     /* 305922 */   GIR_EraseRootFromParent_Done,
     /* 305923 */ // Label 6150: @305923
     /* 305923 */ GIM_Try, /*On fail goto*//*Label 6151*/ GIMT_Encode4(305980), // Rule ID 5234 //
     /* 305928 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 305931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 305934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305938 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305942 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
     /* 305946 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 305950 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305952 */   // (sint_to_fp:{ *:[f64] } (fp_to_sint:{ *:[i64] } f64:{ *:[f64] }:$Rn))  =>  (SCVTFv1i64:{ *:[f64] } (FCVTZSv1i64:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /* 305952 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 305955 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i64),
     /* 305959 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305964 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 305968 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 305970 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 305973 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305975 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305978 */   GIR_RootConstrainSelectedInstOperands,
     /* 305979 */   // GIR_Coverage, 5234,
     /* 305979 */   GIR_EraseRootFromParent_Done,
     /* 305980 */ // Label 6151: @305980
     /* 305980 */ GIM_Try, /*On fail goto*//*Label 6152*/ GIMT_Encode4(306010), // Rule ID 447 //
     /* 305985 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 305988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 305991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305995 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 305999 */   // (sint_to_fp:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWDri:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)
     /* 305999 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWDri),
     /* 306004 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306008 */   GIR_RootConstrainSelectedInstOperands,
     /* 306009 */   // GIR_Coverage, 447,
     /* 306009 */   GIR_Done,
     /* 306010 */ // Label 6152: @306010
     /* 306010 */ GIM_Try, /*On fail goto*//*Label 6153*/ GIMT_Encode4(306040), // Rule ID 453 //
     /* 306015 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 306018 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 306021 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306025 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 306029 */   // (sint_to_fp:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXDri:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)
     /* 306029 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXDri),
     /* 306034 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306038 */   GIR_RootConstrainSelectedInstOperands,
     /* 306039 */   // GIR_Coverage, 453,
     /* 306039 */   GIR_Done,
     /* 306040 */ // Label 6153: @306040
     /* 306040 */ GIM_Try, /*On fail goto*//*Label 6154*/ GIMT_Encode4(306070), // Rule ID 493 //
     /* 306045 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 306048 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 306051 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306055 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306059 */   // (sint_to_fp:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)  =>  (SCVTFDSr:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)
     /* 306059 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFDSr),
     /* 306064 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306068 */   GIR_RootConstrainSelectedInstOperands,
     /* 306069 */   // GIR_Coverage, 493,
     /* 306069 */   GIR_Done,
     /* 306070 */ // Label 6154: @306070
     /* 306070 */ GIM_Reject,
     /* 306071 */ // Label 6117: @306071
     /* 306071 */ GIM_Try, /*On fail goto*//*Label 6155*/ GIMT_Encode4(306101), // Rule ID 1010 //
     /* 306076 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 306082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306086 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306090 */   // (sint_to_fp:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)  =>  (SCVTFv2f32:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)
     /* 306090 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2f32),
     /* 306095 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306099 */   GIR_RootConstrainSelectedInstOperands,
     /* 306100 */   // GIR_Coverage, 1010,
     /* 306100 */   GIR_Done,
     /* 306101 */ // Label 6155: @306101
     /* 306101 */ GIM_Try, /*On fail goto*//*Label 6156*/ GIMT_Encode4(306144), // Rule ID 12828 //
     /* 306106 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 306112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306116 */   // (sint_to_fp:{ *:[v2f32] } v2i64:{ *:[v2i64] }:$src)  =>  (FCVTNv2i32:{ *:[v2f32] } (SCVTFv2f64:{ *:[f128] } V128:{ *:[v2i64] }:$src))
     /* 306116 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 306119 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2f64),
     /* 306123 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306128 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 306132 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 306134 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv2i32),
     /* 306137 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306139 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306142 */   GIR_RootConstrainSelectedInstOperands,
     /* 306143 */   // GIR_Coverage, 12828,
     /* 306143 */   GIR_EraseRootFromParent_Done,
     /* 306144 */ // Label 6156: @306144
     /* 306144 */ GIM_Reject,
     /* 306145 */ // Label 6118: @306145
     /* 306145 */ GIM_Try, /*On fail goto*//*Label 6157*/ GIMT_Encode4(306175), // Rule ID 1014 //
     /* 306150 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306153 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 306156 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306160 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306164 */   // (sint_to_fp:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)  =>  (SCVTFv2f64:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)
     /* 306164 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2f64),
     /* 306169 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306173 */   GIR_RootConstrainSelectedInstOperands,
     /* 306174 */   // GIR_Coverage, 1014,
     /* 306174 */   GIR_Done,
     /* 306175 */ // Label 6157: @306175
     /* 306175 */ GIM_Try, /*On fail goto*//*Label 6158*/ GIMT_Encode4(306221), // Rule ID 12826 //
     /* 306180 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 306186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306190 */   // (sint_to_fp:{ *:[v2f64] } v2i32:{ *:[v2i32] }:$src)  =>  (SCVTFv2f64:{ *:[v2f64] } (SSHLLv2i32_shift:{ *:[f128] } V64:{ *:[v2i32] }:$src, 0:{ *:[i32] }))
     /* 306190 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 306193 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 306197 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306202 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 306206 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 306209 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 306211 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2f64),
     /* 306214 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306216 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306219 */   GIR_RootConstrainSelectedInstOperands,
     /* 306220 */   // GIR_Coverage, 12826,
     /* 306220 */   GIR_EraseRootFromParent_Done,
     /* 306221 */ // Label 6158: @306221
     /* 306221 */ GIM_Reject,
     /* 306222 */ // Label 6119: @306222
     /* 306222 */ GIM_Try, /*On fail goto*//*Label 6159*/ GIMT_Encode4(306252), // Rule ID 1006 //
     /* 306227 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 306230 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 306233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306237 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306241 */   // (sint_to_fp:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)  =>  (SCVTFv4f16:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)
     /* 306241 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4f16),
     /* 306246 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306250 */   GIR_RootConstrainSelectedInstOperands,
     /* 306251 */   // GIR_Coverage, 1006,
     /* 306251 */   GIR_Done,
     /* 306252 */ // Label 6159: @306252
     /* 306252 */ GIM_Reject,
     /* 306253 */ // Label 6120: @306253
     /* 306253 */ GIM_Try, /*On fail goto*//*Label 6160*/ GIMT_Encode4(306283), // Rule ID 1012 //
     /* 306258 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306261 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306264 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306268 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306272 */   // (sint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)  =>  (SCVTFv4f32:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)
     /* 306272 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4f32),
     /* 306277 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306281 */   GIR_RootConstrainSelectedInstOperands,
     /* 306282 */   // GIR_Coverage, 1012,
     /* 306282 */   GIR_Done,
     /* 306283 */ // Label 6160: @306283
     /* 306283 */ GIM_Reject,
     /* 306284 */ // Label 6121: @306284
     /* 306284 */ GIM_Try, /*On fail goto*//*Label 6161*/ GIMT_Encode4(306314), // Rule ID 1008 //
     /* 306289 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 306292 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306299 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306303 */   // (sint_to_fp:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)  =>  (SCVTFv8f16:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)
     /* 306303 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv8f16),
     /* 306308 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306312 */   GIR_RootConstrainSelectedInstOperands,
     /* 306313 */   // GIR_Coverage, 1008,
     /* 306313 */   GIR_Done,
     /* 306314 */ // Label 6161: @306314
     /* 306314 */ GIM_Reject,
     /* 306315 */ // Label 6122: @306315
     /* 306315 */ GIM_Reject,
     /* 306316 */ // Label 65: @306316
     /* 306316 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6170*/ GIMT_Encode4(310090),
     /* 306327 */ /*GILLT_s16*//*Label 6162*/ GIMT_Encode4(306367),
     /* 306331 */ /*GILLT_s32*//*Label 6163*/ GIMT_Encode4(306652),
     /* 306335 */ /*GILLT_s64*//*Label 6164*/ GIMT_Encode4(307980), GIMT_Encode4(0),
     /* 306343 */ /*GILLT_v2s32*//*Label 6165*/ GIMT_Encode4(309846),
     /* 306347 */ /*GILLT_v2s64*//*Label 6166*/ GIMT_Encode4(309920),
     /* 306351 */ /*GILLT_v4s16*//*Label 6167*/ GIMT_Encode4(309997),
     /* 306355 */ /*GILLT_v4s32*//*Label 6168*/ GIMT_Encode4(310028), GIMT_Encode4(0),
     /* 306363 */ /*GILLT_v8s16*//*Label 6169*/ GIMT_Encode4(310059),
     /* 306367 */ // Label 6162: @306367
     /* 306367 */ GIM_Try, /*On fail goto*//*Label 6171*/ GIMT_Encode4(306474), // Rule ID 5260 //
     /* 306372 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 306375 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 306378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306382 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306386 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 306390 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 306394 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 306398 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 306402 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306406 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306410 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 306414 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306419 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 306423 */   GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 306434 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 306436 */   // (uint_to_fp:{ *:[f16] } (and:{ *:[i32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), 65535:{ *:[i32] }))  =>  (UCVTFv1i16:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR128:{ *:[v8i16] }:$Rn, hsub:{ *:[i32] }))
     /* 306436 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 306439 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306443 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306448 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 306454 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306459 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306464 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
     /* 306467 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306469 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306472 */   GIR_RootConstrainSelectedInstOperands,
     /* 306473 */   // GIR_Coverage, 5260,
     /* 306473 */   GIR_EraseRootFromParent_Done,
     /* 306474 */ // Label 6171: @306474
     /* 306474 */ GIM_Try, /*On fail goto*//*Label 6172*/ GIMT_Encode4(306531), // Rule ID 5254 //
     /* 306479 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 306482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 306485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306489 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306493 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
     /* 306497 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 306501 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306503 */   // (uint_to_fp:{ *:[f16] } (fp_to_uint:{ *:[i32] } f16:{ *:[f16] }:$Rn))  =>  (UCVTFv1i16:{ *:[f16] } (FCVTZUv1f16:{ *:[f16] } f16:{ *:[f16] }:$Rn))
     /* 306503 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 306506 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1f16),
     /* 306510 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306515 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 306519 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 306521 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
     /* 306524 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306526 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306529 */   GIR_RootConstrainSelectedInstOperands,
     /* 306530 */   // GIR_Coverage, 5254,
     /* 306530 */   GIR_EraseRootFromParent_Done,
     /* 306531 */ // Label 6172: @306531
     /* 306531 */ GIM_Try, /*On fail goto*//*Label 6173*/ GIMT_Encode4(306561), // Rule ID 467 //
     /* 306536 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 306539 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 306542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306546 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 306550 */   // (uint_to_fp:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWHri:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)
     /* 306550 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWHri),
     /* 306555 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306559 */   GIR_RootConstrainSelectedInstOperands,
     /* 306560 */   // GIR_Coverage, 467,
     /* 306560 */   GIR_Done,
     /* 306561 */ // Label 6173: @306561
     /* 306561 */ GIM_Try, /*On fail goto*//*Label 6174*/ GIMT_Encode4(306591), // Rule ID 473 //
     /* 306566 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 306569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 306572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306576 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 306580 */   // (uint_to_fp:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXHri:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)
     /* 306580 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXHri),
     /* 306585 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306589 */   GIR_RootConstrainSelectedInstOperands,
     /* 306590 */   // GIR_Coverage, 473,
     /* 306590 */   GIR_Done,
     /* 306591 */ // Label 6174: @306591
     /* 306591 */ GIM_Try, /*On fail goto*//*Label 6175*/ GIMT_Encode4(306621), // Rule ID 499 //
     /* 306596 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 306599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 306602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306606 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306610 */   // (uint_to_fp:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)  =>  (UCVTFHSr:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)
     /* 306610 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFHSr),
     /* 306615 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306619 */   GIR_RootConstrainSelectedInstOperands,
     /* 306620 */   // GIR_Coverage, 499,
     /* 306620 */   GIR_Done,
     /* 306621 */ // Label 6175: @306621
     /* 306621 */ GIM_Try, /*On fail goto*//*Label 6176*/ GIMT_Encode4(306651), // Rule ID 503 //
     /* 306626 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 306629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 306632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306636 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306640 */   // (uint_to_fp:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)  =>  (UCVTFHDr:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)
     /* 306640 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFHDr),
     /* 306645 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306649 */   GIR_RootConstrainSelectedInstOperands,
     /* 306650 */   // GIR_Coverage, 503,
     /* 306650 */   GIR_Done,
     /* 306651 */ // Label 6176: @306651
     /* 306651 */ GIM_Reject,
     /* 306652 */ // Label 6163: @306652
     /* 306652 */ GIM_Try, /*On fail goto*//*Label 6177*/ GIMT_Encode4(306792), // Rule ID 5261 //
     /* 306657 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 306660 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 306663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306667 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306671 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 306675 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 306678 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 306685 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 306689 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306691 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 306698 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 306698 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 306701 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 306705 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306710 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 306715 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 306720 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 306725 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 306730 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 306732 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 306735 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 306739 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306744 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 306746 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 306749 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 306753 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306758 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 306761 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 306764 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 306767 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306772 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306777 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 306782 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 306785 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306787 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306790 */   GIR_RootConstrainSelectedInstOperands,
     /* 306791 */   // GIR_Coverage, 5261,
     /* 306791 */   GIR_EraseRootFromParent_Done,
     /* 306792 */ // Label 6177: @306792
     /* 306792 */ GIM_Try, /*On fail goto*//*Label 6178*/ GIMT_Encode4(306932), // Rule ID 5262 //
     /* 306797 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 306800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 306803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306807 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306811 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 306815 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 306818 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 306825 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 306829 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306831 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 306838 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 306838 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 306841 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 306845 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306850 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 306855 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 306860 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 306865 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 306870 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 306872 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 306875 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 306879 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306884 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 306886 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 306889 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 306893 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306898 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 306901 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 306904 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 306907 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306912 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306917 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 306922 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 306925 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306927 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306930 */   GIR_RootConstrainSelectedInstOperands,
     /* 306931 */   // GIR_Coverage, 5262,
     /* 306931 */   GIR_EraseRootFromParent_Done,
     /* 306932 */ // Label 6178: @306932
     /* 306932 */ GIM_Try, /*On fail goto*//*Label 6179*/ GIMT_Encode4(307072), // Rule ID 5265 //
     /* 306937 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 306940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 306943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306947 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306951 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 306955 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 306958 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 306965 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 306969 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306971 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 306978 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 306978 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 306981 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 306985 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306990 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 306995 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 307000 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 307005 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 307010 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 307012 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 307015 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 307019 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307024 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 307026 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 307029 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 307033 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307038 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 307041 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 307044 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 307047 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307052 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307057 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307062 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 307065 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307067 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307070 */   GIR_RootConstrainSelectedInstOperands,
     /* 307071 */   // GIR_Coverage, 5265,
     /* 307071 */   GIR_EraseRootFromParent_Done,
     /* 307072 */ // Label 6179: @307072
     /* 307072 */ GIM_Try, /*On fail goto*//*Label 6180*/ GIMT_Encode4(307212), // Rule ID 5266 //
     /* 307077 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 307080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 307083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307087 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307091 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 307095 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 307098 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 307105 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 307109 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307111 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 307118 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 307118 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 307121 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 307125 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307130 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 307135 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 307140 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 307145 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 307150 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 307152 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 307155 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 307159 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307164 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 307166 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 307169 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 307173 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307178 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 307181 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 307184 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 307187 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307192 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307197 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307202 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 307205 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307207 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307210 */   GIR_RootConstrainSelectedInstOperands,
     /* 307211 */   // GIR_Coverage, 5266,
     /* 307211 */   GIR_EraseRootFromParent_Done,
     /* 307212 */ // Label 6180: @307212
     /* 307212 */ GIM_Try, /*On fail goto*//*Label 6181*/ GIMT_Encode4(307347), // Rule ID 5263 //
     /* 307217 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 307220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 307223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307227 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307231 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 307235 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 307238 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 307245 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 307249 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307251 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 307258 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }))
     /* 307258 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 307261 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 307265 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307270 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 307275 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 307280 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 307285 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 307287 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 307290 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 307294 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307299 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 307301 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 307304 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 307308 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307313 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 307316 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 307319 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 307322 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307327 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307332 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 307337 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 307340 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307342 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307345 */   GIR_RootConstrainSelectedInstOperands,
     /* 307346 */   // GIR_Coverage, 5263,
     /* 307346 */   GIR_EraseRootFromParent_Done,
     /* 307347 */ // Label 6181: @307347
     /* 307347 */ GIM_Try, /*On fail goto*//*Label 6182*/ GIMT_Encode4(307482), // Rule ID 5264 //
     /* 307352 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 307355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 307358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307362 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307366 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 307370 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 307373 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 307380 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 307384 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307386 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 307393 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }))
     /* 307393 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 307396 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 307400 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307405 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 307410 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 307415 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 307420 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 307422 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 307425 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 307429 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307434 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 307436 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 307439 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 307443 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307448 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 307451 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 307454 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 307457 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307462 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307467 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 307472 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 307475 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307477 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307480 */   GIR_RootConstrainSelectedInstOperands,
     /* 307481 */   // GIR_Coverage, 5264,
     /* 307481 */   GIR_EraseRootFromParent_Done,
     /* 307482 */ // Label 6182: @307482
     /* 307482 */ GIM_Try, /*On fail goto*//*Label 6183*/ GIMT_Encode4(307617), // Rule ID 5267 //
     /* 307487 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 307490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 307493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307497 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307501 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 307505 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 307508 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 307515 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 307519 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307521 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 307528 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }))
     /* 307528 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 307531 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 307535 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307540 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 307545 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 307550 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 307555 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 307557 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 307560 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 307564 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307569 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 307571 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 307574 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 307578 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307583 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 307586 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 307589 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 307592 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307597 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307602 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307607 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 307610 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307612 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307615 */   GIR_RootConstrainSelectedInstOperands,
     /* 307616 */   // GIR_Coverage, 5267,
     /* 307616 */   GIR_EraseRootFromParent_Done,
     /* 307617 */ // Label 6183: @307617
     /* 307617 */ GIM_Try, /*On fail goto*//*Label 6184*/ GIMT_Encode4(307752), // Rule ID 5268 //
     /* 307622 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 307625 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 307628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307632 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307636 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 307640 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 307643 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 307650 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 307654 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307656 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 307663 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }))
     /* 307663 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 307666 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 307670 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307675 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 307680 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 307685 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 307690 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 307692 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 307695 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 307699 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307704 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 307706 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 307709 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 307713 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307718 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 307721 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 307724 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 307727 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307732 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307737 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307742 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 307745 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307747 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307750 */   GIR_RootConstrainSelectedInstOperands,
     /* 307751 */   // GIR_Coverage, 5268,
     /* 307751 */   GIR_EraseRootFromParent_Done,
     /* 307752 */ // Label 6184: @307752
     /* 307752 */ GIM_Try, /*On fail goto*//*Label 6185*/ GIMT_Encode4(307832), // Rule ID 5256 //
     /* 307757 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 307760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 307763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307767 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307771 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 307775 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 307779 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 307783 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307788 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 307792 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307794 */   // (uint_to_fp:{ *:[f32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 307794 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 307797 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307801 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307806 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 307812 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307817 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307822 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 307825 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307827 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307830 */   GIR_RootConstrainSelectedInstOperands,
     /* 307831 */   // GIR_Coverage, 5256,
     /* 307831 */   GIR_EraseRootFromParent_Done,
     /* 307832 */ // Label 6185: @307832
     /* 307832 */ GIM_Try, /*On fail goto*//*Label 6186*/ GIMT_Encode4(307889), // Rule ID 5246 //
     /* 307837 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 307840 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 307843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307847 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307851 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
     /* 307855 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 307859 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307861 */   // (uint_to_fp:{ *:[f32] } (fp_to_uint:{ *:[i32] } f32:{ *:[f32] }:$Rn))  =>  (UCVTFv1i32:{ *:[f32] } (FCVTZUv1i32:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /* 307861 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 307864 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i32),
     /* 307868 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307873 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 307877 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 307879 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 307882 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307884 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307887 */   GIR_RootConstrainSelectedInstOperands,
     /* 307888 */   // GIR_Coverage, 5246,
     /* 307888 */   GIR_EraseRootFromParent_Done,
     /* 307889 */ // Label 6186: @307889
     /* 307889 */ GIM_Try, /*On fail goto*//*Label 6187*/ GIMT_Encode4(307919), // Rule ID 469 //
     /* 307894 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 307897 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 307900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307904 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 307908 */   // (uint_to_fp:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWSri:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)
     /* 307908 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWSri),
     /* 307913 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 307917 */   GIR_RootConstrainSelectedInstOperands,
     /* 307918 */   // GIR_Coverage, 469,
     /* 307918 */   GIR_Done,
     /* 307919 */ // Label 6187: @307919
     /* 307919 */ GIM_Try, /*On fail goto*//*Label 6188*/ GIMT_Encode4(307949), // Rule ID 475 //
     /* 307924 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 307927 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 307930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307934 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 307938 */   // (uint_to_fp:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXSri:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)
     /* 307938 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXSri),
     /* 307943 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 307947 */   GIR_RootConstrainSelectedInstOperands,
     /* 307948 */   // GIR_Coverage, 475,
     /* 307948 */   GIR_Done,
     /* 307949 */ // Label 6188: @307949
     /* 307949 */ GIM_Try, /*On fail goto*//*Label 6189*/ GIMT_Encode4(307979), // Rule ID 505 //
     /* 307954 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 307957 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 307960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307964 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307968 */   // (uint_to_fp:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)  =>  (UCVTFSDr:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)
     /* 307968 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFSDr),
     /* 307973 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 307977 */   GIR_RootConstrainSelectedInstOperands,
     /* 307978 */   // GIR_Coverage, 505,
     /* 307978 */   GIR_Done,
     /* 307979 */ // Label 6189: @307979
     /* 307979 */ GIM_Reject,
     /* 307980 */ // Label 6164: @307980
     /* 307980 */ GIM_Try, /*On fail goto*//*Label 6190*/ GIMT_Encode4(308117), // Rule ID 5277 //
     /* 307985 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 307988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 307991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307995 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307999 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 308003 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 308006 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 308010 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 308014 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308016 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 308023 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] }))
     /* 308023 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 308026 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 308030 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308035 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 308040 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 308045 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 308050 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 308055 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 308057 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 308060 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 308064 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308069 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 308071 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 308074 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 308078 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308083 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 308086 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 308089 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 308092 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308097 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308102 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308107 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 308110 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308112 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308115 */   GIR_RootConstrainSelectedInstOperands,
     /* 308116 */   // GIR_Coverage, 5277,
     /* 308116 */   GIR_EraseRootFromParent_Done,
     /* 308117 */ // Label 6190: @308117
     /* 308117 */ GIM_Try, /*On fail goto*//*Label 6191*/ GIMT_Encode4(308254), // Rule ID 5278 //
     /* 308122 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 308125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 308128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308132 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308136 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 308140 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 308143 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 308147 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 308151 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308153 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 308160 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] }))
     /* 308160 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 308163 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 308167 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308172 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 308177 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 308182 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 308187 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 308192 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 308194 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 308197 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 308201 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308206 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 308208 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 308211 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 308215 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308220 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 308223 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 308226 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 308229 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308234 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308239 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308244 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 308247 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308249 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308252 */   GIR_RootConstrainSelectedInstOperands,
     /* 308253 */   // GIR_Coverage, 5278,
     /* 308253 */   GIR_EraseRootFromParent_Done,
     /* 308254 */ // Label 6191: @308254
     /* 308254 */ GIM_Try, /*On fail goto*//*Label 6192*/ GIMT_Encode4(308394), // Rule ID 5269 //
     /* 308259 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 308262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 308265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308269 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308273 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 308277 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 308280 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 308287 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 308291 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308293 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 308300 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 308300 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 308303 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 308307 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308312 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 308317 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 308322 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 308327 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 308332 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 308334 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 308337 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 308341 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308346 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 308348 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 308351 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 308355 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308360 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 308363 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 308366 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 308369 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308374 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308379 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 308384 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 308387 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308389 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308392 */   GIR_RootConstrainSelectedInstOperands,
     /* 308393 */   // GIR_Coverage, 5269,
     /* 308393 */   GIR_EraseRootFromParent_Done,
     /* 308394 */ // Label 6192: @308394
     /* 308394 */ GIM_Try, /*On fail goto*//*Label 6193*/ GIMT_Encode4(308534), // Rule ID 5270 //
     /* 308399 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 308402 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 308405 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308409 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308413 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 308417 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 308420 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 308427 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 308431 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308433 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 308440 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 308440 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 308443 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 308447 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308452 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 308457 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 308462 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 308467 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 308472 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 308474 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 308477 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 308481 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308486 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 308488 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 308491 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 308495 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308500 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 308503 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 308506 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 308509 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308514 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308519 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 308524 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 308527 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308529 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308532 */   GIR_RootConstrainSelectedInstOperands,
     /* 308533 */   // GIR_Coverage, 5270,
     /* 308533 */   GIR_EraseRootFromParent_Done,
     /* 308534 */ // Label 6193: @308534
     /* 308534 */ GIM_Try, /*On fail goto*//*Label 6194*/ GIMT_Encode4(308674), // Rule ID 5273 //
     /* 308539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 308542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 308545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308549 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308553 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 308557 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 308560 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 308567 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 308571 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308573 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 308580 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 308580 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 308583 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 308587 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308592 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 308597 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 308602 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 308607 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 308612 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 308614 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 308617 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 308621 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308626 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 308628 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 308631 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 308635 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308640 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 308643 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 308646 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 308649 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308654 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308659 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308664 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 308667 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308669 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308672 */   GIR_RootConstrainSelectedInstOperands,
     /* 308673 */   // GIR_Coverage, 5273,
     /* 308673 */   GIR_EraseRootFromParent_Done,
     /* 308674 */ // Label 6194: @308674
     /* 308674 */ GIM_Try, /*On fail goto*//*Label 6195*/ GIMT_Encode4(308814), // Rule ID 5274 //
     /* 308679 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 308682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 308685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308689 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308693 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 308697 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 308700 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 308707 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 308711 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308713 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 308720 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 308720 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 308723 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 308727 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308732 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 308737 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 308742 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 308747 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 308752 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 308754 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 308757 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 308761 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308766 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 308768 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 308771 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 308775 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308780 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 308783 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 308786 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 308789 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308794 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308799 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308804 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 308807 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308809 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308812 */   GIR_RootConstrainSelectedInstOperands,
     /* 308813 */   // GIR_Coverage, 5274,
     /* 308813 */   GIR_EraseRootFromParent_Done,
     /* 308814 */ // Label 6195: @308814
     /* 308814 */ GIM_Try, /*On fail goto*//*Label 6196*/ GIMT_Encode4(308946), // Rule ID 5279 //
     /* 308819 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 308822 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 308825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308829 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308833 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 308837 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 308840 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 308844 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 308848 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308850 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 308857 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] }))
     /* 308857 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 308860 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 308864 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308869 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 308874 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 308879 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 308884 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 308886 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 308889 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 308893 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308898 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 308900 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 308903 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 308907 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308912 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 308915 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 308918 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 308921 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308926 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308931 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308936 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 308939 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308941 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308944 */   GIR_RootConstrainSelectedInstOperands,
     /* 308945 */   // GIR_Coverage, 5279,
     /* 308945 */   GIR_EraseRootFromParent_Done,
     /* 308946 */ // Label 6196: @308946
     /* 308946 */ GIM_Try, /*On fail goto*//*Label 6197*/ GIMT_Encode4(309078), // Rule ID 5280 //
     /* 308951 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 308954 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 308957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308961 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308965 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 308969 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 308972 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 308976 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 308980 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308982 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 308989 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] }))
     /* 308989 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 308992 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 308996 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309001 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 309006 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 309011 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 309016 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 309018 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 309021 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 309025 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309030 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 309032 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 309035 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 309039 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309044 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 309047 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 309050 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 309053 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309058 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309063 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309068 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 309071 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309073 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309076 */   GIR_RootConstrainSelectedInstOperands,
     /* 309077 */   // GIR_Coverage, 5280,
     /* 309077 */   GIR_EraseRootFromParent_Done,
     /* 309078 */ // Label 6197: @309078
     /* 309078 */ GIM_Try, /*On fail goto*//*Label 6198*/ GIMT_Encode4(309213), // Rule ID 5271 //
     /* 309083 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 309086 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 309089 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309093 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309097 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 309101 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 309104 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 309111 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 309115 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 309117 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 309124 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }))
     /* 309124 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 309127 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 309131 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309136 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 309141 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 309146 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 309151 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 309153 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 309156 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 309160 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309165 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 309167 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 309170 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 309174 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309179 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 309182 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 309185 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 309188 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309193 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309198 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 309203 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 309206 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309208 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309211 */   GIR_RootConstrainSelectedInstOperands,
     /* 309212 */   // GIR_Coverage, 5271,
     /* 309212 */   GIR_EraseRootFromParent_Done,
     /* 309213 */ // Label 6198: @309213
     /* 309213 */ GIM_Try, /*On fail goto*//*Label 6199*/ GIMT_Encode4(309348), // Rule ID 5272 //
     /* 309218 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 309221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 309224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309228 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309232 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 309236 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 309239 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 309246 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 309250 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 309252 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 309259 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }))
     /* 309259 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 309262 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 309266 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309271 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 309276 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 309281 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 309286 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 309288 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 309291 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 309295 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309300 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 309302 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 309305 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 309309 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309314 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 309317 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 309320 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 309323 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309328 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309333 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 309338 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 309341 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309343 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309346 */   GIR_RootConstrainSelectedInstOperands,
     /* 309347 */   // GIR_Coverage, 5272,
     /* 309347 */   GIR_EraseRootFromParent_Done,
     /* 309348 */ // Label 6199: @309348
     /* 309348 */ GIM_Try, /*On fail goto*//*Label 6200*/ GIMT_Encode4(309483), // Rule ID 5275 //
     /* 309353 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 309356 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 309359 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309363 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309367 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 309371 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 309374 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 309381 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 309385 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 309387 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 309394 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }))
     /* 309394 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 309397 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 309401 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309406 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 309411 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 309416 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 309421 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 309423 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 309426 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 309430 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309435 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 309437 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 309440 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 309444 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309449 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 309452 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 309455 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 309458 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309463 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309468 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309473 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 309476 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309478 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309481 */   GIR_RootConstrainSelectedInstOperands,
     /* 309482 */   // GIR_Coverage, 5275,
     /* 309482 */   GIR_EraseRootFromParent_Done,
     /* 309483 */ // Label 6200: @309483
     /* 309483 */ GIM_Try, /*On fail goto*//*Label 6201*/ GIMT_Encode4(309618), // Rule ID 5276 //
     /* 309488 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 309491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 309494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309498 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309502 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 309506 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 309509 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 309516 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 309520 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 309522 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 309529 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }))
     /* 309529 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 309532 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 309536 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309541 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 309546 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 309551 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 309556 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 309558 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 309561 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 309565 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309570 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 309572 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 309575 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 309579 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309584 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 309587 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 309590 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 309593 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309598 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309603 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309608 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 309611 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309613 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309616 */   GIR_RootConstrainSelectedInstOperands,
     /* 309617 */   // GIR_Coverage, 5276,
     /* 309617 */   GIR_EraseRootFromParent_Done,
     /* 309618 */ // Label 6201: @309618
     /* 309618 */ GIM_Try, /*On fail goto*//*Label 6202*/ GIMT_Encode4(309698), // Rule ID 5258 //
     /* 309623 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 309626 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 309629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309633 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309637 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309641 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 309645 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309649 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309654 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 309658 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 309660 */   // (uint_to_fp:{ *:[f64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 309660 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 309663 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309667 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309672 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 309678 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309683 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309688 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 309691 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309693 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309696 */   GIR_RootConstrainSelectedInstOperands,
     /* 309697 */   // GIR_Coverage, 5258,
     /* 309697 */   GIR_EraseRootFromParent_Done,
     /* 309698 */ // Label 6202: @309698
     /* 309698 */ GIM_Try, /*On fail goto*//*Label 6203*/ GIMT_Encode4(309755), // Rule ID 5242 //
     /* 309703 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 309706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 309709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309713 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309717 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
     /* 309721 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 309725 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 309727 */   // (uint_to_fp:{ *:[f64] } (fp_to_uint:{ *:[i64] } f64:{ *:[f64] }:$Rn))  =>  (UCVTFv1i64:{ *:[f64] } (FCVTZUv1i64:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /* 309727 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 309730 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i64),
     /* 309734 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309739 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 309743 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 309745 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 309748 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309750 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309753 */   GIR_RootConstrainSelectedInstOperands,
     /* 309754 */   // GIR_Coverage, 5242,
     /* 309754 */   GIR_EraseRootFromParent_Done,
     /* 309755 */ // Label 6203: @309755
     /* 309755 */ GIM_Try, /*On fail goto*//*Label 6204*/ GIMT_Encode4(309785), // Rule ID 471 //
     /* 309760 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 309763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 309766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309770 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 309774 */   // (uint_to_fp:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWDri:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)
     /* 309774 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWDri),
     /* 309779 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 309783 */   GIR_RootConstrainSelectedInstOperands,
     /* 309784 */   // GIR_Coverage, 471,
     /* 309784 */   GIR_Done,
     /* 309785 */ // Label 6204: @309785
     /* 309785 */ GIM_Try, /*On fail goto*//*Label 6205*/ GIMT_Encode4(309815), // Rule ID 477 //
     /* 309790 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 309793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 309796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309800 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 309804 */   // (uint_to_fp:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXDri:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)
     /* 309804 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXDri),
     /* 309809 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 309813 */   GIR_RootConstrainSelectedInstOperands,
     /* 309814 */   // GIR_Coverage, 477,
     /* 309814 */   GIR_Done,
     /* 309815 */ // Label 6205: @309815
     /* 309815 */ GIM_Try, /*On fail goto*//*Label 6206*/ GIMT_Encode4(309845), // Rule ID 501 //
     /* 309820 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 309823 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 309826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309830 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309834 */   // (uint_to_fp:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)  =>  (UCVTFDSr:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)
     /* 309834 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFDSr),
     /* 309839 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 309843 */   GIR_RootConstrainSelectedInstOperands,
     /* 309844 */   // GIR_Coverage, 501,
     /* 309844 */   GIR_Done,
     /* 309845 */ // Label 6206: @309845
     /* 309845 */ GIM_Reject,
     /* 309846 */ // Label 6165: @309846
     /* 309846 */ GIM_Try, /*On fail goto*//*Label 6207*/ GIMT_Encode4(309876), // Rule ID 1071 //
     /* 309851 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 309854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 309857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309861 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309865 */   // (uint_to_fp:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)  =>  (UCVTFv2f32:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)
     /* 309865 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2f32),
     /* 309870 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 309874 */   GIR_RootConstrainSelectedInstOperands,
     /* 309875 */   // GIR_Coverage, 1071,
     /* 309875 */   GIR_Done,
     /* 309876 */ // Label 6207: @309876
     /* 309876 */ GIM_Try, /*On fail goto*//*Label 6208*/ GIMT_Encode4(309919), // Rule ID 12829 //
     /* 309881 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 309884 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 309887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309891 */   // (uint_to_fp:{ *:[v2f32] } v2i64:{ *:[v2i64] }:$src)  =>  (FCVTNv2i32:{ *:[v2f32] } (UCVTFv2f64:{ *:[f128] } V128:{ *:[v2i64] }:$src))
     /* 309891 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 309894 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2f64),
     /* 309898 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309903 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 309907 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 309909 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv2i32),
     /* 309912 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309914 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309917 */   GIR_RootConstrainSelectedInstOperands,
     /* 309918 */   // GIR_Coverage, 12829,
     /* 309918 */   GIR_EraseRootFromParent_Done,
     /* 309919 */ // Label 6208: @309919
     /* 309919 */ GIM_Reject,
     /* 309920 */ // Label 6166: @309920
     /* 309920 */ GIM_Try, /*On fail goto*//*Label 6209*/ GIMT_Encode4(309950), // Rule ID 1075 //
     /* 309925 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 309928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 309931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309935 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309939 */   // (uint_to_fp:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)  =>  (UCVTFv2f64:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)
     /* 309939 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2f64),
     /* 309944 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 309948 */   GIR_RootConstrainSelectedInstOperands,
     /* 309949 */   // GIR_Coverage, 1075,
     /* 309949 */   GIR_Done,
     /* 309950 */ // Label 6209: @309950
     /* 309950 */ GIM_Try, /*On fail goto*//*Label 6210*/ GIMT_Encode4(309996), // Rule ID 12827 //
     /* 309955 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 309958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 309961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309965 */   // (uint_to_fp:{ *:[v2f64] } v2i32:{ *:[v2i32] }:$src)  =>  (UCVTFv2f64:{ *:[v2f64] } (USHLLv2i32_shift:{ *:[f128] } V64:{ *:[v2i32] }:$src, 0:{ *:[i32] }))
     /* 309965 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 309968 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 309972 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309977 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 309981 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 309984 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 309986 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2f64),
     /* 309989 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309991 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309994 */   GIR_RootConstrainSelectedInstOperands,
     /* 309995 */   // GIR_Coverage, 12827,
     /* 309995 */   GIR_EraseRootFromParent_Done,
     /* 309996 */ // Label 6210: @309996
     /* 309996 */ GIM_Reject,
     /* 309997 */ // Label 6167: @309997
     /* 309997 */ GIM_Try, /*On fail goto*//*Label 6211*/ GIMT_Encode4(310027), // Rule ID 1067 //
     /* 310002 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 310005 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 310008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310012 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310016 */   // (uint_to_fp:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)  =>  (UCVTFv4f16:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)
     /* 310016 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4f16),
     /* 310021 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310025 */   GIR_RootConstrainSelectedInstOperands,
     /* 310026 */   // GIR_Coverage, 1067,
     /* 310026 */   GIR_Done,
     /* 310027 */ // Label 6211: @310027
     /* 310027 */ GIM_Reject,
     /* 310028 */ // Label 6168: @310028
     /* 310028 */ GIM_Try, /*On fail goto*//*Label 6212*/ GIMT_Encode4(310058), // Rule ID 1073 //
     /* 310033 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 310036 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 310039 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310043 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310047 */   // (uint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)  =>  (UCVTFv4f32:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)
     /* 310047 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4f32),
     /* 310052 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310056 */   GIR_RootConstrainSelectedInstOperands,
     /* 310057 */   // GIR_Coverage, 1073,
     /* 310057 */   GIR_Done,
     /* 310058 */ // Label 6212: @310058
     /* 310058 */ GIM_Reject,
     /* 310059 */ // Label 6169: @310059
     /* 310059 */ GIM_Try, /*On fail goto*//*Label 6213*/ GIMT_Encode4(310089), // Rule ID 1069 //
     /* 310064 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 310067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310074 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310078 */   // (uint_to_fp:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)  =>  (UCVTFv8f16:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)
     /* 310078 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv8f16),
     /* 310083 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310087 */   GIR_RootConstrainSelectedInstOperands,
     /* 310088 */   // GIR_Coverage, 1069,
     /* 310088 */   GIR_Done,
     /* 310089 */ // Label 6213: @310089
     /* 310089 */ GIM_Reject,
     /* 310090 */ // Label 6170: @310090
     /* 310090 */ GIM_Reject,
     /* 310091 */ // Label 66: @310091
     /* 310091 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6221*/ GIMT_Encode4(310410),
     /* 310102 */ /*GILLT_s32*//*Label 6214*/ GIMT_Encode4(310138),
     /* 310106 */ /*GILLT_s64*//*Label 6215*/ GIMT_Encode4(310211), GIMT_Encode4(0),
     /* 310114 */ /*GILLT_v2s32*//*Label 6216*/ GIMT_Encode4(310284),
     /* 310118 */ /*GILLT_v2s64*//*Label 6217*/ GIMT_Encode4(310308),
     /* 310122 */ /*GILLT_v4s16*//*Label 6218*/ GIMT_Encode4(310332),
     /* 310126 */ /*GILLT_v4s32*//*Label 6219*/ GIMT_Encode4(310359), GIMT_Encode4(0),
     /* 310134 */ /*GILLT_v8s16*//*Label 6220*/ GIMT_Encode4(310383),
     /* 310138 */ // Label 6214: @310138
     /* 310138 */ GIM_Try, /*On fail goto*//*Label 6222*/ GIMT_Encode4(310164), // Rule ID 4523 //
     /* 310143 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310146 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 310149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 310153 */   // (fp_to_sint_sat_gi:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
     /* 310153 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 310158 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310162 */   GIR_RootConstrainSelectedInstOperands,
     /* 310163 */   // GIR_Coverage, 4523,
     /* 310163 */   GIR_Done,
     /* 310164 */ // Label 6222: @310164
     /* 310164 */ GIM_Try, /*On fail goto*//*Label 6223*/ GIMT_Encode4(310187), // Rule ID 4525 //
     /* 310169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 310172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 310176 */   // (fp_to_sint_sat_gi:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 310176 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 310181 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310185 */   GIR_RootConstrainSelectedInstOperands,
     /* 310186 */   // GIR_Coverage, 4525,
     /* 310186 */   GIR_Done,
     /* 310187 */ // Label 6223: @310187
     /* 310187 */ GIM_Try, /*On fail goto*//*Label 6224*/ GIMT_Encode4(310210), // Rule ID 4527 //
     /* 310192 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 310195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 310199 */   // (fp_to_sint_sat_gi:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 310199 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 310204 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310208 */   GIR_RootConstrainSelectedInstOperands,
     /* 310209 */   // GIR_Coverage, 4527,
     /* 310209 */   GIR_Done,
     /* 310210 */ // Label 6224: @310210
     /* 310210 */ GIM_Reject,
     /* 310211 */ // Label 6215: @310211
     /* 310211 */ GIM_Try, /*On fail goto*//*Label 6225*/ GIMT_Encode4(310237), // Rule ID 4524 //
     /* 310216 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 310222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 310226 */   // (fp_to_sint_sat_gi:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 310226 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 310231 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310235 */   GIR_RootConstrainSelectedInstOperands,
     /* 310236 */   // GIR_Coverage, 4524,
     /* 310236 */   GIR_Done,
     /* 310237 */ // Label 6225: @310237
     /* 310237 */ GIM_Try, /*On fail goto*//*Label 6226*/ GIMT_Encode4(310260), // Rule ID 4526 //
     /* 310242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 310245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 310249 */   // (fp_to_sint_sat_gi:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 310249 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 310254 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310258 */   GIR_RootConstrainSelectedInstOperands,
     /* 310259 */   // GIR_Coverage, 4526,
     /* 310259 */   GIR_Done,
     /* 310260 */ // Label 6226: @310260
     /* 310260 */ GIM_Try, /*On fail goto*//*Label 6227*/ GIMT_Encode4(310283), // Rule ID 4528 //
     /* 310265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 310268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 310272 */   // (fp_to_sint_sat_gi:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 310272 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 310277 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310281 */   GIR_RootConstrainSelectedInstOperands,
     /* 310282 */   // GIR_Coverage, 4528,
     /* 310282 */   GIR_Done,
     /* 310283 */ // Label 6227: @310283
     /* 310283 */ GIM_Reject,
     /* 310284 */ // Label 6216: @310284
     /* 310284 */ GIM_Try, /*On fail goto*//*Label 6228*/ GIMT_Encode4(310307), // Rule ID 4864 //
     /* 310289 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 310292 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310296 */   // (fp_to_sint_sat_gi:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)
     /* 310296 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
     /* 310301 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310305 */   GIR_RootConstrainSelectedInstOperands,
     /* 310306 */   // GIR_Coverage, 4864,
     /* 310306 */   GIR_Done,
     /* 310307 */ // Label 6228: @310307
     /* 310307 */ GIM_Reject,
     /* 310308 */ // Label 6217: @310308
     /* 310308 */ GIM_Try, /*On fail goto*//*Label 6229*/ GIMT_Encode4(310331), // Rule ID 4866 //
     /* 310313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 310316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310320 */   // (fp_to_sint_sat_gi:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)
     /* 310320 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 310325 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310329 */   GIR_RootConstrainSelectedInstOperands,
     /* 310330 */   // GIR_Coverage, 4866,
     /* 310330 */   GIR_Done,
     /* 310331 */ // Label 6229: @310331
     /* 310331 */ GIM_Reject,
     /* 310332 */ // Label 6218: @310332
     /* 310332 */ GIM_Try, /*On fail goto*//*Label 6230*/ GIMT_Encode4(310358), // Rule ID 4859 //
     /* 310337 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 310343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310347 */   // (fp_to_sint_sat_gi:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)
     /* 310347 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
     /* 310352 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310356 */   GIR_RootConstrainSelectedInstOperands,
     /* 310357 */   // GIR_Coverage, 4859,
     /* 310357 */   GIR_Done,
     /* 310358 */ // Label 6230: @310358
     /* 310358 */ GIM_Reject,
     /* 310359 */ // Label 6219: @310359
     /* 310359 */ GIM_Try, /*On fail goto*//*Label 6231*/ GIMT_Encode4(310382), // Rule ID 4865 //
     /* 310364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 310367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310371 */   // (fp_to_sint_sat_gi:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)
     /* 310371 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
     /* 310376 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310380 */   GIR_RootConstrainSelectedInstOperands,
     /* 310381 */   // GIR_Coverage, 4865,
     /* 310381 */   GIR_Done,
     /* 310382 */ // Label 6231: @310382
     /* 310382 */ GIM_Reject,
     /* 310383 */ // Label 6220: @310383
     /* 310383 */ GIM_Try, /*On fail goto*//*Label 6232*/ GIMT_Encode4(310409), // Rule ID 4860 //
     /* 310388 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310391 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310394 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310398 */   // (fp_to_sint_sat_gi:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)
     /* 310398 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
     /* 310403 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310407 */   GIR_RootConstrainSelectedInstOperands,
     /* 310408 */   // GIR_Coverage, 4860,
     /* 310408 */   GIR_Done,
     /* 310409 */ // Label 6232: @310409
     /* 310409 */ GIM_Reject,
     /* 310410 */ // Label 6221: @310410
     /* 310410 */ GIM_Reject,
     /* 310411 */ // Label 67: @310411
     /* 310411 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6240*/ GIMT_Encode4(310730),
     /* 310422 */ /*GILLT_s32*//*Label 6233*/ GIMT_Encode4(310458),
     /* 310426 */ /*GILLT_s64*//*Label 6234*/ GIMT_Encode4(310531), GIMT_Encode4(0),
     /* 310434 */ /*GILLT_v2s32*//*Label 6235*/ GIMT_Encode4(310604),
     /* 310438 */ /*GILLT_v2s64*//*Label 6236*/ GIMT_Encode4(310628),
     /* 310442 */ /*GILLT_v4s16*//*Label 6237*/ GIMT_Encode4(310652),
     /* 310446 */ /*GILLT_v4s32*//*Label 6238*/ GIMT_Encode4(310679), GIMT_Encode4(0),
     /* 310454 */ /*GILLT_v8s16*//*Label 6239*/ GIMT_Encode4(310703),
     /* 310458 */ // Label 6233: @310458
     /* 310458 */ GIM_Try, /*On fail goto*//*Label 6241*/ GIMT_Encode4(310484), // Rule ID 4547 //
     /* 310463 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310466 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 310469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 310473 */   // (fp_to_uint_sat_gi:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
     /* 310473 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
     /* 310478 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310482 */   GIR_RootConstrainSelectedInstOperands,
     /* 310483 */   // GIR_Coverage, 4547,
     /* 310483 */   GIR_Done,
     /* 310484 */ // Label 6241: @310484
     /* 310484 */ GIM_Try, /*On fail goto*//*Label 6242*/ GIMT_Encode4(310507), // Rule ID 4549 //
     /* 310489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 310492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 310496 */   // (fp_to_uint_sat_gi:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 310496 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 310501 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310505 */   GIR_RootConstrainSelectedInstOperands,
     /* 310506 */   // GIR_Coverage, 4549,
     /* 310506 */   GIR_Done,
     /* 310507 */ // Label 6242: @310507
     /* 310507 */ GIM_Try, /*On fail goto*//*Label 6243*/ GIMT_Encode4(310530), // Rule ID 4551 //
     /* 310512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 310515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 310519 */   // (fp_to_uint_sat_gi:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 310519 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 310524 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310528 */   GIR_RootConstrainSelectedInstOperands,
     /* 310529 */   // GIR_Coverage, 4551,
     /* 310529 */   GIR_Done,
     /* 310530 */ // Label 6243: @310530
     /* 310530 */ GIM_Reject,
     /* 310531 */ // Label 6234: @310531
     /* 310531 */ GIM_Try, /*On fail goto*//*Label 6244*/ GIMT_Encode4(310557), // Rule ID 4548 //
     /* 310536 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310539 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 310542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 310546 */   // (fp_to_uint_sat_gi:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 310546 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
     /* 310551 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310555 */   GIR_RootConstrainSelectedInstOperands,
     /* 310556 */   // GIR_Coverage, 4548,
     /* 310556 */   GIR_Done,
     /* 310557 */ // Label 6244: @310557
     /* 310557 */ GIM_Try, /*On fail goto*//*Label 6245*/ GIMT_Encode4(310580), // Rule ID 4550 //
     /* 310562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 310565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 310569 */   // (fp_to_uint_sat_gi:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 310569 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 310574 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310578 */   GIR_RootConstrainSelectedInstOperands,
     /* 310579 */   // GIR_Coverage, 4550,
     /* 310579 */   GIR_Done,
     /* 310580 */ // Label 6245: @310580
     /* 310580 */ GIM_Try, /*On fail goto*//*Label 6246*/ GIMT_Encode4(310603), // Rule ID 4552 //
     /* 310585 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 310588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 310592 */   // (fp_to_uint_sat_gi:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 310592 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 310597 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310601 */   GIR_RootConstrainSelectedInstOperands,
     /* 310602 */   // GIR_Coverage, 4552,
     /* 310602 */   GIR_Done,
     /* 310603 */ // Label 6246: @310603
     /* 310603 */ GIM_Reject,
     /* 310604 */ // Label 6235: @310604
     /* 310604 */ GIM_Try, /*On fail goto*//*Label 6247*/ GIMT_Encode4(310627), // Rule ID 4874 //
     /* 310609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 310612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310616 */   // (fp_to_uint_sat_gi:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)
     /* 310616 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
     /* 310621 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310625 */   GIR_RootConstrainSelectedInstOperands,
     /* 310626 */   // GIR_Coverage, 4874,
     /* 310626 */   GIR_Done,
     /* 310627 */ // Label 6247: @310627
     /* 310627 */ GIM_Reject,
     /* 310628 */ // Label 6236: @310628
     /* 310628 */ GIM_Try, /*On fail goto*//*Label 6248*/ GIMT_Encode4(310651), // Rule ID 4876 //
     /* 310633 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 310636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310640 */   // (fp_to_uint_sat_gi:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)
     /* 310640 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 310645 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310649 */   GIR_RootConstrainSelectedInstOperands,
     /* 310650 */   // GIR_Coverage, 4876,
     /* 310650 */   GIR_Done,
     /* 310651 */ // Label 6248: @310651
     /* 310651 */ GIM_Reject,
     /* 310652 */ // Label 6237: @310652
     /* 310652 */ GIM_Try, /*On fail goto*//*Label 6249*/ GIMT_Encode4(310678), // Rule ID 4869 //
     /* 310657 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310660 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 310663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310667 */   // (fp_to_uint_sat_gi:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)
     /* 310667 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
     /* 310672 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310676 */   GIR_RootConstrainSelectedInstOperands,
     /* 310677 */   // GIR_Coverage, 4869,
     /* 310677 */   GIR_Done,
     /* 310678 */ // Label 6249: @310678
     /* 310678 */ GIM_Reject,
     /* 310679 */ // Label 6238: @310679
     /* 310679 */ GIM_Try, /*On fail goto*//*Label 6250*/ GIMT_Encode4(310702), // Rule ID 4875 //
     /* 310684 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 310687 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310691 */   // (fp_to_uint_sat_gi:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)
     /* 310691 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
     /* 310696 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310700 */   GIR_RootConstrainSelectedInstOperands,
     /* 310701 */   // GIR_Coverage, 4875,
     /* 310701 */   GIR_Done,
     /* 310702 */ // Label 6250: @310702
     /* 310702 */ GIM_Reject,
     /* 310703 */ // Label 6239: @310703
     /* 310703 */ GIM_Try, /*On fail goto*//*Label 6251*/ GIMT_Encode4(310729), // Rule ID 4870 //
     /* 310708 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310718 */   // (fp_to_uint_sat_gi:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)
     /* 310718 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
     /* 310723 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310727 */   GIR_RootConstrainSelectedInstOperands,
     /* 310728 */   // GIR_Coverage, 4870,
     /* 310728 */   GIR_Done,
     /* 310729 */ // Label 6251: @310729
     /* 310729 */ GIM_Reject,
     /* 310730 */ // Label 6240: @310730
     /* 310730 */ GIM_Reject,
     /* 310731 */ // Label 68: @310731
     /* 310731 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6260*/ GIMT_Encode4(311587),
     /* 310742 */ /*GILLT_s16*//*Label 6252*/ GIMT_Encode4(310782),
     /* 310746 */ /*GILLT_s32*//*Label 6253*/ GIMT_Encode4(311001),
     /* 310750 */ /*GILLT_s64*//*Label 6254*/ GIMT_Encode4(311075), GIMT_Encode4(0),
     /* 310758 */ /*GILLT_v2s32*//*Label 6255*/ GIMT_Encode4(311149),
     /* 310762 */ /*GILLT_v2s64*//*Label 6256*/ GIMT_Encode4(311223),
     /* 310766 */ /*GILLT_v4s16*//*Label 6257*/ GIMT_Encode4(311297),
     /* 310770 */ /*GILLT_v4s32*//*Label 6258*/ GIMT_Encode4(311405), GIMT_Encode4(0),
     /* 310778 */ /*GILLT_v8s16*//*Label 6259*/ GIMT_Encode4(311479),
     /* 310782 */ // Label 6252: @310782
     /* 310782 */ GIM_Try, /*On fail goto*//*Label 6261*/ GIMT_Encode4(311000),
     /* 310787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 310790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310794 */   GIM_Try, /*On fail goto*//*Label 6262*/ GIMT_Encode4(310835), // Rule ID 5145 //
     /* 310799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 310802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 310810 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 310814 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 310818 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310820 */     // (fabs:{ *:[f16] } (fsub:{ *:[f16] } f16:{ *:[f16] }:$Rn, f16:{ *:[f16] }:$Rm))  =>  (FABD16:{ *:[f16] } f16:{ *:[f16] }:$Rn, f16:{ *:[f16] }:$Rm)
     /* 310820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD16),
     /* 310823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 310829 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 310833 */     GIR_RootConstrainSelectedInstOperands,
     /* 310834 */     // GIR_Coverage, 5145,
     /* 310834 */     GIR_EraseRootFromParent_Done,
     /* 310835 */   // Label 6262: @310835
     /* 310835 */   GIM_Try, /*On fail goto*//*Label 6263*/ GIMT_Encode4(310854), // Rule ID 521 //
     /* 310840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310843 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310847 */     // (fabs:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FABSHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 310847 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSHr),
     /* 310852 */     GIR_RootConstrainSelectedInstOperands,
     /* 310853 */     // GIR_Coverage, 521,
     /* 310853 */     GIR_Done,
     /* 310854 */   // Label 6263: @310854
     /* 310854 */   GIM_Try, /*On fail goto*//*Label 6264*/ GIMT_Encode4(310999), // Rule ID 6282 //
     /* 310859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310863 */     // (fabs:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } (ANDWri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), GPR32:{ *:[i32] }), (logical_imm32_XFORM:{ *:[i32] } 32767:{ *:[i32] })), FPR32:{ *:[i32] }), hsub:{ *:[i32] })
     /* 310863 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 310866 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 310870 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310875 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 310877 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 310880 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 310884 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310889 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 310892 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 310896 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
     /* 310899 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310904 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310909 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310914 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 310917 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310921 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310926 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 310929 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 310934 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 310937 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::ANDWri),
     /* 310941 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310946 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 310949 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // 
     /* 310954 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 310956 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 310959 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310963 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310968 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 310971 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 310981 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 310988 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310993 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310998 */     // GIR_Coverage, 6282,
     /* 310998 */     GIR_EraseRootFromParent_Done,
     /* 310999 */   // Label 6264: @310999
     /* 310999 */   GIM_Reject,
     /* 311000 */ // Label 6261: @311000
     /* 311000 */ GIM_Reject,
     /* 311001 */ // Label 6253: @311001
     /* 311001 */ GIM_Try, /*On fail goto*//*Label 6265*/ GIMT_Encode4(311074),
     /* 311006 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311013 */   GIM_Try, /*On fail goto*//*Label 6266*/ GIMT_Encode4(311054), // Rule ID 5146 //
     /* 311018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 311021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 311029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 311033 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 311037 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311039 */     // (fabs:{ *:[f32] } (fsub:{ *:[f32] } f32:{ *:[f32] }:$Rn, f32:{ *:[f32] }:$Rm))  =>  (FABD32:{ *:[f32] } f32:{ *:[f32] }:$Rn, f32:{ *:[f32] }:$Rm)
     /* 311039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD32),
     /* 311042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 311052 */     GIR_RootConstrainSelectedInstOperands,
     /* 311053 */     // GIR_Coverage, 5146,
     /* 311053 */     GIR_EraseRootFromParent_Done,
     /* 311054 */   // Label 6266: @311054
     /* 311054 */   GIM_Try, /*On fail goto*//*Label 6267*/ GIMT_Encode4(311073), // Rule ID 522 //
     /* 311059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 311062 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311066 */     // (fabs:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FABSSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 311066 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSSr),
     /* 311071 */     GIR_RootConstrainSelectedInstOperands,
     /* 311072 */     // GIR_Coverage, 522,
     /* 311072 */     GIR_Done,
     /* 311073 */   // Label 6267: @311073
     /* 311073 */   GIM_Reject,
     /* 311074 */ // Label 6265: @311074
     /* 311074 */ GIM_Reject,
     /* 311075 */ // Label 6254: @311075
     /* 311075 */ GIM_Try, /*On fail goto*//*Label 6268*/ GIMT_Encode4(311148),
     /* 311080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 311083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311087 */   GIM_Try, /*On fail goto*//*Label 6269*/ GIMT_Encode4(311128), // Rule ID 5147 //
     /* 311092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 311095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 311103 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 311107 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 311111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311113 */     // (fabs:{ *:[f64] } (fsub:{ *:[f64] } f64:{ *:[f64] }:$Rn, f64:{ *:[f64] }:$Rm))  =>  (FABD64:{ *:[f64] } f64:{ *:[f64] }:$Rn, f64:{ *:[f64] }:$Rm)
     /* 311113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 311116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 311126 */     GIR_RootConstrainSelectedInstOperands,
     /* 311127 */     // GIR_Coverage, 5147,
     /* 311127 */     GIR_EraseRootFromParent_Done,
     /* 311128 */   // Label 6269: @311128
     /* 311128 */   GIM_Try, /*On fail goto*//*Label 6270*/ GIMT_Encode4(311147), // Rule ID 523 //
     /* 311133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 311136 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311140 */     // (fabs:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FABSDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 311140 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSDr),
     /* 311145 */     GIR_RootConstrainSelectedInstOperands,
     /* 311146 */     // GIR_Coverage, 523,
     /* 311146 */     GIR_Done,
     /* 311147 */   // Label 6270: @311147
     /* 311147 */   GIM_Reject,
     /* 311148 */ // Label 6268: @311148
     /* 311148 */ GIM_Reject,
     /* 311149 */ // Label 6255: @311149
     /* 311149 */ GIM_Try, /*On fail goto*//*Label 6271*/ GIMT_Encode4(311222),
     /* 311154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 311157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311161 */   GIM_Try, /*On fail goto*//*Label 6272*/ GIMT_Encode4(311202), // Rule ID 4938 //
     /* 311166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 311169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 311177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 311181 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 311185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311187 */     // (fabs:{ *:[v2f32] } (fsub:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$Rn, v2f32:{ *:[v2f32] }:$Rm))  =>  (FABDv2f32:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$Rn, v2f32:{ *:[v2f32] }:$Rm)
     /* 311187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f32),
     /* 311190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 311200 */     GIR_RootConstrainSelectedInstOperands,
     /* 311201 */     // GIR_Coverage, 4938,
     /* 311201 */     GIR_EraseRootFromParent_Done,
     /* 311202 */   // Label 6272: @311202
     /* 311202 */   GIM_Try, /*On fail goto*//*Label 6273*/ GIMT_Encode4(311221), // Rule ID 761 //
     /* 311207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 311210 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311214 */     // (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FABSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 311214 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv2f32),
     /* 311219 */     GIR_RootConstrainSelectedInstOperands,
     /* 311220 */     // GIR_Coverage, 761,
     /* 311220 */     GIR_Done,
     /* 311221 */   // Label 6273: @311221
     /* 311221 */   GIM_Reject,
     /* 311222 */ // Label 6271: @311222
     /* 311222 */ GIM_Reject,
     /* 311223 */ // Label 6256: @311223
     /* 311223 */ GIM_Try, /*On fail goto*//*Label 6274*/ GIMT_Encode4(311296),
     /* 311228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 311231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311235 */   GIM_Try, /*On fail goto*//*Label 6275*/ GIMT_Encode4(311276), // Rule ID 4940 //
     /* 311240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 311243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 311251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 311255 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 311259 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311261 */     // (fabs:{ *:[v2f64] } (fsub:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, v2f64:{ *:[v2f64] }:$Rm))  =>  (FABDv2f64:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, v2f64:{ *:[v2f64] }:$Rm)
     /* 311261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f64),
     /* 311264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311270 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 311274 */     GIR_RootConstrainSelectedInstOperands,
     /* 311275 */     // GIR_Coverage, 4940,
     /* 311275 */     GIR_EraseRootFromParent_Done,
     /* 311276 */   // Label 6275: @311276
     /* 311276 */   GIM_Try, /*On fail goto*//*Label 6276*/ GIMT_Encode4(311295), // Rule ID 763 //
     /* 311281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 311284 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311288 */     // (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FABSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 311288 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv2f64),
     /* 311293 */     GIR_RootConstrainSelectedInstOperands,
     /* 311294 */     // GIR_Coverage, 763,
     /* 311294 */     GIR_Done,
     /* 311295 */   // Label 6276: @311295
     /* 311295 */   GIM_Reject,
     /* 311296 */ // Label 6274: @311296
     /* 311296 */ GIM_Reject,
     /* 311297 */ // Label 6257: @311297
     /* 311297 */ GIM_Try, /*On fail goto*//*Label 6277*/ GIMT_Encode4(311404),
     /* 311302 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 311305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311309 */   GIM_Try, /*On fail goto*//*Label 6278*/ GIMT_Encode4(311350), // Rule ID 4941 //
     /* 311314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 311317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 311325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 311329 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 311333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311335 */     // (fabs:{ *:[v4f16] } (fsub:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$Rn, v4f16:{ *:[v4f16] }:$Rm))  =>  (FABDv4f16:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$Rn, v4f16:{ *:[v4f16] }:$Rm)
     /* 311335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f16),
     /* 311338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 311348 */     GIR_RootConstrainSelectedInstOperands,
     /* 311349 */     // GIR_Coverage, 4941,
     /* 311349 */     GIR_EraseRootFromParent_Done,
     /* 311350 */   // Label 6278: @311350
     /* 311350 */   GIM_Try, /*On fail goto*//*Label 6279*/ GIMT_Encode4(311369), // Rule ID 759 //
     /* 311355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 311358 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311362 */     // (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FABSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 311362 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv4f16),
     /* 311367 */     GIR_RootConstrainSelectedInstOperands,
     /* 311368 */     // GIR_Coverage, 759,
     /* 311368 */     GIR_Done,
     /* 311369 */   // Label 6279: @311369
     /* 311369 */   GIM_Try, /*On fail goto*//*Label 6280*/ GIMT_Encode4(311403), // Rule ID 6284 //
     /* 311374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 311377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311381 */     // (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (BICv4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, 128:{ *:[i32] }, 8:{ *:[i32] })
     /* 311381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv4i16),
     /* 311384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 311386 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 311388 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
     /* 311398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 311401 */     GIR_RootConstrainSelectedInstOperands,
     /* 311402 */     // GIR_Coverage, 6284,
     /* 311402 */     GIR_EraseRootFromParent_Done,
     /* 311403 */   // Label 6280: @311403
     /* 311403 */   GIM_Reject,
     /* 311404 */ // Label 6277: @311404
     /* 311404 */ GIM_Reject,
     /* 311405 */ // Label 6258: @311405
     /* 311405 */ GIM_Try, /*On fail goto*//*Label 6281*/ GIMT_Encode4(311478),
     /* 311410 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 311413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311417 */   GIM_Try, /*On fail goto*//*Label 6282*/ GIMT_Encode4(311458), // Rule ID 4939 //
     /* 311422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 311425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 311433 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 311437 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 311441 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311443 */     // (fabs:{ *:[v4f32] } (fsub:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, v4f32:{ *:[v4f32] }:$Rm))  =>  (FABDv4f32:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, v4f32:{ *:[v4f32] }:$Rm)
     /* 311443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f32),
     /* 311446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 311456 */     GIR_RootConstrainSelectedInstOperands,
     /* 311457 */     // GIR_Coverage, 4939,
     /* 311457 */     GIR_EraseRootFromParent_Done,
     /* 311458 */   // Label 6282: @311458
     /* 311458 */   GIM_Try, /*On fail goto*//*Label 6283*/ GIMT_Encode4(311477), // Rule ID 762 //
     /* 311463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 311466 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311470 */     // (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FABSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 311470 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv4f32),
     /* 311475 */     GIR_RootConstrainSelectedInstOperands,
     /* 311476 */     // GIR_Coverage, 762,
     /* 311476 */     GIR_Done,
     /* 311477 */   // Label 6283: @311477
     /* 311477 */   GIM_Reject,
     /* 311478 */ // Label 6281: @311478
     /* 311478 */ GIM_Reject,
     /* 311479 */ // Label 6259: @311479
     /* 311479 */ GIM_Try, /*On fail goto*//*Label 6284*/ GIMT_Encode4(311586),
     /* 311484 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311491 */   GIM_Try, /*On fail goto*//*Label 6285*/ GIMT_Encode4(311532), // Rule ID 4942 //
     /* 311496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 311499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 311507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311511 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 311515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311517 */     // (fabs:{ *:[v8f16] } (fsub:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, v8f16:{ *:[v8f16] }:$Rm))  =>  (FABDv8f16:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, v8f16:{ *:[v8f16] }:$Rm)
     /* 311517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv8f16),
     /* 311520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311522 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311526 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 311530 */     GIR_RootConstrainSelectedInstOperands,
     /* 311531 */     // GIR_Coverage, 4942,
     /* 311531 */     GIR_EraseRootFromParent_Done,
     /* 311532 */   // Label 6285: @311532
     /* 311532 */   GIM_Try, /*On fail goto*//*Label 6286*/ GIMT_Encode4(311551), // Rule ID 760 //
     /* 311537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 311540 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311544 */     // (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FABSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 311544 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv8f16),
     /* 311549 */     GIR_RootConstrainSelectedInstOperands,
     /* 311550 */     // GIR_Coverage, 760,
     /* 311550 */     GIR_Done,
     /* 311551 */   // Label 6286: @311551
     /* 311551 */   GIM_Try, /*On fail goto*//*Label 6287*/ GIMT_Encode4(311585), // Rule ID 6285 //
     /* 311556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 311559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311563 */     // (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (BICv8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, 128:{ *:[i32] }, 8:{ *:[i32] })
     /* 311563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i16),
     /* 311566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 311568 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 311570 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
     /* 311580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 311583 */     GIR_RootConstrainSelectedInstOperands,
     /* 311584 */     // GIR_Coverage, 6285,
     /* 311584 */     GIR_EraseRootFromParent_Done,
     /* 311585 */   // Label 6287: @311585
     /* 311585 */   GIM_Reject,
     /* 311586 */ // Label 6284: @311586
     /* 311586 */ GIM_Reject,
     /* 311587 */ // Label 6260: @311587
     /* 311587 */ GIM_Reject,
     /* 311588 */ // Label 69: @311588
     /* 311588 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6296*/ GIMT_Encode4(311869),
     /* 311599 */ /*GILLT_s16*//*Label 6288*/ GIMT_Encode4(311639),
     /* 311603 */ /*GILLT_s32*//*Label 6289*/ GIMT_Encode4(311666),
     /* 311607 */ /*GILLT_s64*//*Label 6290*/ GIMT_Encode4(311690), GIMT_Encode4(0),
     /* 311615 */ /*GILLT_v2s32*//*Label 6291*/ GIMT_Encode4(311714),
     /* 311619 */ /*GILLT_v2s64*//*Label 6292*/ GIMT_Encode4(311745),
     /* 311623 */ /*GILLT_v4s16*//*Label 6293*/ GIMT_Encode4(311776),
     /* 311627 */ /*GILLT_v4s32*//*Label 6294*/ GIMT_Encode4(311807), GIMT_Encode4(0),
     /* 311635 */ /*GILLT_v8s16*//*Label 6295*/ GIMT_Encode4(311838),
     /* 311639 */ // Label 6288: @311639
     /* 311639 */ GIM_Try, /*On fail goto*//*Label 6297*/ GIMT_Encode4(311665), // Rule ID 4763 //
     /* 311644 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 311647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 311650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311654 */   // (fcanonicalize:{ *:[f16] } f16:{ *:[f16] }:$a)  =>  (FMINNMHrr:{ *:[f16] } f16:{ *:[f16] }:$a, f16:{ *:[f16] }:$a)
     /* 311654 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
     /* 311657 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311659 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 311661 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 311663 */   GIR_RootConstrainSelectedInstOperands,
     /* 311664 */   // GIR_Coverage, 4763,
     /* 311664 */   GIR_EraseRootFromParent_Done,
     /* 311665 */ // Label 6297: @311665
     /* 311665 */ GIM_Reject,
     /* 311666 */ // Label 6289: @311666
     /* 311666 */ GIM_Try, /*On fail goto*//*Label 6298*/ GIMT_Encode4(311689), // Rule ID 4760 //
     /* 311671 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311678 */   // (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$a)  =>  (FMINNMSrr:{ *:[f32] } f32:{ *:[f32] }:$a, f32:{ *:[f32] }:$a)
     /* 311678 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
     /* 311681 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311683 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 311685 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 311687 */   GIR_RootConstrainSelectedInstOperands,
     /* 311688 */   // GIR_Coverage, 4760,
     /* 311688 */   GIR_EraseRootFromParent_Done,
     /* 311689 */ // Label 6298: @311689
     /* 311689 */ GIM_Reject,
     /* 311690 */ // Label 6290: @311690
     /* 311690 */ GIM_Try, /*On fail goto*//*Label 6299*/ GIMT_Encode4(311713), // Rule ID 4757 //
     /* 311695 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 311698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311702 */   // (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$a)  =>  (FMINNMDrr:{ *:[f64] } f64:{ *:[f64] }:$a, f64:{ *:[f64] }:$a)
     /* 311702 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 311705 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311707 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 311709 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 311711 */   GIR_RootConstrainSelectedInstOperands,
     /* 311712 */   // GIR_Coverage, 4757,
     /* 311712 */   GIR_EraseRootFromParent_Done,
     /* 311713 */ // Label 6299: @311713
     /* 311713 */ GIM_Reject,
     /* 311714 */ // Label 6291: @311714
     /* 311714 */ GIM_Try, /*On fail goto*//*Label 6300*/ GIMT_Encode4(311744), // Rule ID 4951 //
     /* 311719 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 311722 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 311725 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311729 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311733 */   // (fcanonicalize:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rn)
     /* 311733 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
     /* 311736 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311738 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 311740 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 311742 */   GIR_RootConstrainSelectedInstOperands,
     /* 311743 */   // GIR_Coverage, 4951,
     /* 311743 */   GIR_EraseRootFromParent_Done,
     /* 311744 */ // Label 6300: @311744
     /* 311744 */ GIM_Reject,
     /* 311745 */ // Label 6292: @311745
     /* 311745 */ GIM_Try, /*On fail goto*//*Label 6301*/ GIMT_Encode4(311775), // Rule ID 4945 //
     /* 311750 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 311753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 311756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311760 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311764 */   // (fcanonicalize:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn)
     /* 311764 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
     /* 311767 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311769 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 311771 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 311773 */   GIR_RootConstrainSelectedInstOperands,
     /* 311774 */   // GIR_Coverage, 4945,
     /* 311774 */   GIR_EraseRootFromParent_Done,
     /* 311775 */ // Label 6301: @311775
     /* 311775 */ GIM_Reject,
     /* 311776 */ // Label 6293: @311776
     /* 311776 */ GIM_Try, /*On fail goto*//*Label 6302*/ GIMT_Encode4(311806), // Rule ID 4957 //
     /* 311781 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 311784 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 311787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311791 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311795 */   // (fcanonicalize:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rn)
     /* 311795 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
     /* 311798 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311800 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 311802 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 311804 */   GIR_RootConstrainSelectedInstOperands,
     /* 311805 */   // GIR_Coverage, 4957,
     /* 311805 */   GIR_EraseRootFromParent_Done,
     /* 311806 */ // Label 6302: @311806
     /* 311806 */ GIM_Reject,
     /* 311807 */ // Label 6294: @311807
     /* 311807 */ GIM_Try, /*On fail goto*//*Label 6303*/ GIMT_Encode4(311837), // Rule ID 4948 //
     /* 311812 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 311815 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 311818 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311822 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311826 */   // (fcanonicalize:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn)
     /* 311826 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
     /* 311829 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311831 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 311833 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 311835 */   GIR_RootConstrainSelectedInstOperands,
     /* 311836 */   // GIR_Coverage, 4948,
     /* 311836 */   GIR_EraseRootFromParent_Done,
     /* 311837 */ // Label 6303: @311837
     /* 311837 */ GIM_Reject,
     /* 311838 */ // Label 6295: @311838
     /* 311838 */ GIM_Try, /*On fail goto*//*Label 6304*/ GIMT_Encode4(311868), // Rule ID 4954 //
     /* 311843 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 311846 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311853 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311857 */   // (fcanonicalize:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn)
     /* 311857 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
     /* 311860 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311862 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 311864 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 311866 */   GIR_RootConstrainSelectedInstOperands,
     /* 311867 */   // GIR_Coverage, 4954,
     /* 311867 */   GIR_EraseRootFromParent_Done,
     /* 311868 */ // Label 6304: @311868
     /* 311868 */ GIM_Reject,
     /* 311869 */ // Label 6296: @311869
     /* 311869 */ GIM_Reject,
     /* 311870 */ // Label 70: @311870
     /* 311870 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6313*/ GIMT_Encode4(312247),
     /* 311881 */ /*GILLT_s16*//*Label 6305*/ GIMT_Encode4(311921),
     /* 311885 */ /*GILLT_s32*//*Label 6306*/ GIMT_Encode4(311959),
     /* 311889 */ /*GILLT_s64*//*Label 6307*/ GIMT_Encode4(311997), GIMT_Encode4(0),
     /* 311897 */ /*GILLT_v2s32*//*Label 6308*/ GIMT_Encode4(312057),
     /* 311901 */ /*GILLT_v2s64*//*Label 6309*/ GIMT_Encode4(312095),
     /* 311905 */ /*GILLT_v4s16*//*Label 6310*/ GIMT_Encode4(312133),
     /* 311909 */ /*GILLT_v4s32*//*Label 6311*/ GIMT_Encode4(312171), GIMT_Encode4(0),
     /* 311917 */ /*GILLT_v8s16*//*Label 6312*/ GIMT_Encode4(312209),
     /* 311921 */ // Label 6305: @311921
     /* 311921 */ GIM_Try, /*On fail goto*//*Label 6314*/ GIMT_Encode4(311958), // Rule ID 608 //
     /* 311926 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 311929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 311932 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 311935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311939 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311943 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311947 */   // (fminnum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMINNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 311947 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
     /* 311952 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311956 */   GIR_RootConstrainSelectedInstOperands,
     /* 311957 */   // GIR_Coverage, 608,
     /* 311957 */   GIR_Done,
     /* 311958 */ // Label 6314: @311958
     /* 311958 */ GIM_Reject,
     /* 311959 */ // Label 6306: @311959
     /* 311959 */ GIM_Try, /*On fail goto*//*Label 6315*/ GIMT_Encode4(311996), // Rule ID 610 //
     /* 311964 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 311967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311970 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 311973 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311977 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311981 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311985 */   // (fminnum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMINNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 311985 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
     /* 311990 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311994 */   GIR_RootConstrainSelectedInstOperands,
     /* 311995 */   // GIR_Coverage, 610,
     /* 311995 */   GIR_Done,
     /* 311996 */ // Label 6315: @311996
     /* 311996 */ GIM_Reject,
     /* 311997 */ // Label 6307: @311997
     /* 311997 */ GIM_Try, /*On fail goto*//*Label 6316*/ GIMT_Encode4(312056),
     /* 312002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 312005 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 312008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312012 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312016 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312020 */   GIM_Try, /*On fail goto*//*Label 6317*/ GIMT_Encode4(312039), // Rule ID 612 //
     /* 312025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312028 */     // (fminnum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMINNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 312028 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 312033 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312037 */     GIR_RootConstrainSelectedInstOperands,
     /* 312038 */     // GIR_Coverage, 612,
     /* 312038 */     GIR_Done,
     /* 312039 */   // Label 6317: @312039
     /* 312039 */   GIM_Try, /*On fail goto*//*Label 6318*/ GIMT_Encode4(312055), // Rule ID 4754 //
     /* 312044 */     // (fminnum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMINNMDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 312044 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 312049 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312053 */     GIR_RootConstrainSelectedInstOperands,
     /* 312054 */     // GIR_Coverage, 4754,
     /* 312054 */     GIR_Done,
     /* 312055 */   // Label 6318: @312055
     /* 312055 */   GIM_Reject,
     /* 312056 */ // Label 6316: @312056
     /* 312056 */ GIM_Reject,
     /* 312057 */ // Label 6308: @312057
     /* 312057 */ GIM_Try, /*On fail goto*//*Label 6319*/ GIMT_Encode4(312094), // Rule ID 1266 //
     /* 312062 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 312068 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 312071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312075 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312079 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312083 */   // (fminnum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 312083 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
     /* 312088 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312092 */   GIR_RootConstrainSelectedInstOperands,
     /* 312093 */   // GIR_Coverage, 1266,
     /* 312093 */   GIR_Done,
     /* 312094 */ // Label 6319: @312094
     /* 312094 */ GIM_Reject,
     /* 312095 */ // Label 6309: @312095
     /* 312095 */ GIM_Try, /*On fail goto*//*Label 6320*/ GIMT_Encode4(312132), // Rule ID 1270 //
     /* 312100 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 312106 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 312109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312113 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312117 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312121 */   // (fminnum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 312121 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
     /* 312126 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312130 */   GIR_RootConstrainSelectedInstOperands,
     /* 312131 */   // GIR_Coverage, 1270,
     /* 312131 */   GIR_Done,
     /* 312132 */ // Label 6320: @312132
     /* 312132 */ GIM_Reject,
     /* 312133 */ // Label 6310: @312133
     /* 312133 */ GIM_Try, /*On fail goto*//*Label 6321*/ GIMT_Encode4(312170), // Rule ID 1262 //
     /* 312138 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 312141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 312144 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 312147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312151 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312155 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312159 */   // (fminnum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 312159 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
     /* 312164 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312168 */   GIR_RootConstrainSelectedInstOperands,
     /* 312169 */   // GIR_Coverage, 1262,
     /* 312169 */   GIR_Done,
     /* 312170 */ // Label 6321: @312170
     /* 312170 */ GIM_Reject,
     /* 312171 */ // Label 6311: @312171
     /* 312171 */ GIM_Try, /*On fail goto*//*Label 6322*/ GIMT_Encode4(312208), // Rule ID 1268 //
     /* 312176 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312182 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 312185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312189 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312193 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312197 */   // (fminnum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 312197 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
     /* 312202 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312206 */   GIR_RootConstrainSelectedInstOperands,
     /* 312207 */   // GIR_Coverage, 1268,
     /* 312207 */   GIR_Done,
     /* 312208 */ // Label 6322: @312208
     /* 312208 */ GIM_Reject,
     /* 312209 */ // Label 6312: @312209
     /* 312209 */ GIM_Try, /*On fail goto*//*Label 6323*/ GIMT_Encode4(312246), // Rule ID 1264 //
     /* 312214 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 312217 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 312220 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 312223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312227 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312231 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312235 */   // (fminnum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 312235 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
     /* 312240 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312244 */   GIR_RootConstrainSelectedInstOperands,
     /* 312245 */   // GIR_Coverage, 1264,
     /* 312245 */   GIR_Done,
     /* 312246 */ // Label 6323: @312246
     /* 312246 */ GIM_Reject,
     /* 312247 */ // Label 6313: @312247
     /* 312247 */ GIM_Reject,
     /* 312248 */ // Label 71: @312248
     /* 312248 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6332*/ GIMT_Encode4(312625),
     /* 312259 */ /*GILLT_s16*//*Label 6324*/ GIMT_Encode4(312299),
     /* 312263 */ /*GILLT_s32*//*Label 6325*/ GIMT_Encode4(312337),
     /* 312267 */ /*GILLT_s64*//*Label 6326*/ GIMT_Encode4(312375), GIMT_Encode4(0),
     /* 312275 */ /*GILLT_v2s32*//*Label 6327*/ GIMT_Encode4(312435),
     /* 312279 */ /*GILLT_v2s64*//*Label 6328*/ GIMT_Encode4(312473),
     /* 312283 */ /*GILLT_v4s16*//*Label 6329*/ GIMT_Encode4(312511),
     /* 312287 */ /*GILLT_v4s32*//*Label 6330*/ GIMT_Encode4(312549), GIMT_Encode4(0),
     /* 312295 */ /*GILLT_v8s16*//*Label 6331*/ GIMT_Encode4(312587),
     /* 312299 */ // Label 6324: @312299
     /* 312299 */ GIM_Try, /*On fail goto*//*Label 6333*/ GIMT_Encode4(312336), // Rule ID 596 //
     /* 312304 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 312307 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 312310 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 312313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312317 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312321 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312325 */   // (fmaxnum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMAXNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 312325 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMHrr),
     /* 312330 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312334 */   GIR_RootConstrainSelectedInstOperands,
     /* 312335 */   // GIR_Coverage, 596,
     /* 312335 */   GIR_Done,
     /* 312336 */ // Label 6333: @312336
     /* 312336 */ GIM_Reject,
     /* 312337 */ // Label 6325: @312337
     /* 312337 */ GIM_Try, /*On fail goto*//*Label 6334*/ GIMT_Encode4(312374), // Rule ID 598 //
     /* 312342 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312348 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 312351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312355 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312359 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312363 */   // (fmaxnum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMAXNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 312363 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMSrr),
     /* 312368 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312372 */   GIR_RootConstrainSelectedInstOperands,
     /* 312373 */   // GIR_Coverage, 598,
     /* 312373 */   GIR_Done,
     /* 312374 */ // Label 6334: @312374
     /* 312374 */ GIM_Reject,
     /* 312375 */ // Label 6326: @312375
     /* 312375 */ GIM_Try, /*On fail goto*//*Label 6335*/ GIMT_Encode4(312434),
     /* 312380 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 312383 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 312386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312390 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312394 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312398 */   GIM_Try, /*On fail goto*//*Label 6336*/ GIMT_Encode4(312417), // Rule ID 600 //
     /* 312403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312406 */     // (fmaxnum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMAXNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 312406 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
     /* 312411 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312415 */     GIR_RootConstrainSelectedInstOperands,
     /* 312416 */     // GIR_Coverage, 600,
     /* 312416 */     GIR_Done,
     /* 312417 */   // Label 6336: @312417
     /* 312417 */   GIM_Try, /*On fail goto*//*Label 6337*/ GIMT_Encode4(312433), // Rule ID 4753 //
     /* 312422 */     // (fmaxnum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMAXNMDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 312422 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
     /* 312427 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312431 */     GIR_RootConstrainSelectedInstOperands,
     /* 312432 */     // GIR_Coverage, 4753,
     /* 312432 */     GIR_Done,
     /* 312433 */   // Label 6337: @312433
     /* 312433 */   GIM_Reject,
     /* 312434 */ // Label 6335: @312434
     /* 312434 */ GIM_Reject,
     /* 312435 */ // Label 6327: @312435
     /* 312435 */ GIM_Try, /*On fail goto*//*Label 6338*/ GIMT_Encode4(312472), // Rule ID 1236 //
     /* 312440 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 312446 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 312449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312453 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312457 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312461 */   // (fmaxnum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 312461 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f32),
     /* 312466 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312470 */   GIR_RootConstrainSelectedInstOperands,
     /* 312471 */   // GIR_Coverage, 1236,
     /* 312471 */   GIR_Done,
     /* 312472 */ // Label 6338: @312472
     /* 312472 */ GIM_Reject,
     /* 312473 */ // Label 6328: @312473
     /* 312473 */ GIM_Try, /*On fail goto*//*Label 6339*/ GIMT_Encode4(312510), // Rule ID 1240 //
     /* 312478 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 312484 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 312487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312491 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312495 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312499 */   // (fmaxnum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 312499 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f64),
     /* 312504 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312508 */   GIR_RootConstrainSelectedInstOperands,
     /* 312509 */   // GIR_Coverage, 1240,
     /* 312509 */   GIR_Done,
     /* 312510 */ // Label 6339: @312510
     /* 312510 */ GIM_Reject,
     /* 312511 */ // Label 6329: @312511
     /* 312511 */ GIM_Try, /*On fail goto*//*Label 6340*/ GIMT_Encode4(312548), // Rule ID 1232 //
     /* 312516 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 312519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 312522 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 312525 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312529 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312533 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312537 */   // (fmaxnum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 312537 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f16),
     /* 312542 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312546 */   GIR_RootConstrainSelectedInstOperands,
     /* 312547 */   // GIR_Coverage, 1232,
     /* 312547 */   GIR_Done,
     /* 312548 */ // Label 6340: @312548
     /* 312548 */ GIM_Reject,
     /* 312549 */ // Label 6330: @312549
     /* 312549 */ GIM_Try, /*On fail goto*//*Label 6341*/ GIMT_Encode4(312586), // Rule ID 1238 //
     /* 312554 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312557 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312560 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 312563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312567 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312571 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312575 */   // (fmaxnum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 312575 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f32),
     /* 312580 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312584 */   GIR_RootConstrainSelectedInstOperands,
     /* 312585 */   // GIR_Coverage, 1238,
     /* 312585 */   GIR_Done,
     /* 312586 */ // Label 6341: @312586
     /* 312586 */ GIM_Reject,
     /* 312587 */ // Label 6331: @312587
     /* 312587 */ GIM_Try, /*On fail goto*//*Label 6342*/ GIMT_Encode4(312624), // Rule ID 1234 //
     /* 312592 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 312595 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 312598 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 312601 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312605 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312609 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312613 */   // (fmaxnum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 312613 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv8f16),
     /* 312618 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312622 */   GIR_RootConstrainSelectedInstOperands,
     /* 312623 */   // GIR_Coverage, 1234,
     /* 312623 */   GIR_Done,
     /* 312624 */ // Label 6342: @312624
     /* 312624 */ GIM_Reject,
     /* 312625 */ // Label 6332: @312625
     /* 312625 */ GIM_Reject,
     /* 312626 */ // Label 72: @312626
     /* 312626 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6351*/ GIMT_Encode4(312975),
     /* 312637 */ /*GILLT_s16*//*Label 6343*/ GIMT_Encode4(312677),
     /* 312641 */ /*GILLT_s32*//*Label 6344*/ GIMT_Encode4(312715),
     /* 312645 */ /*GILLT_s64*//*Label 6345*/ GIMT_Encode4(312750), GIMT_Encode4(0),
     /* 312653 */ /*GILLT_v2s32*//*Label 6346*/ GIMT_Encode4(312785),
     /* 312657 */ /*GILLT_v2s64*//*Label 6347*/ GIMT_Encode4(312823),
     /* 312661 */ /*GILLT_v4s16*//*Label 6348*/ GIMT_Encode4(312861),
     /* 312665 */ /*GILLT_v4s32*//*Label 6349*/ GIMT_Encode4(312899), GIMT_Encode4(0),
     /* 312673 */ /*GILLT_v8s16*//*Label 6350*/ GIMT_Encode4(312937),
     /* 312677 */ // Label 6343: @312677
     /* 312677 */ GIM_Try, /*On fail goto*//*Label 6352*/ GIMT_Encode4(312714), // Rule ID 4761 //
     /* 312682 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 312685 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 312688 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 312691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312695 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312699 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312703 */   // (fminnum_ieee:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)  =>  (FMINNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 312703 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
     /* 312708 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312712 */   GIR_RootConstrainSelectedInstOperands,
     /* 312713 */   // GIR_Coverage, 4761,
     /* 312713 */   GIR_Done,
     /* 312714 */ // Label 6352: @312714
     /* 312714 */ GIM_Reject,
     /* 312715 */ // Label 6344: @312715
     /* 312715 */ GIM_Try, /*On fail goto*//*Label 6353*/ GIMT_Encode4(312749), // Rule ID 4758 //
     /* 312720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312723 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 312726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312730 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312734 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312738 */   // (fminnum_ieee:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)  =>  (FMINNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 312738 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
     /* 312743 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312747 */   GIR_RootConstrainSelectedInstOperands,
     /* 312748 */   // GIR_Coverage, 4758,
     /* 312748 */   GIR_Done,
     /* 312749 */ // Label 6353: @312749
     /* 312749 */ GIM_Reject,
     /* 312750 */ // Label 6345: @312750
     /* 312750 */ GIM_Try, /*On fail goto*//*Label 6354*/ GIMT_Encode4(312784), // Rule ID 4755 //
     /* 312755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 312758 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 312761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312765 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312769 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312773 */   // (fminnum_ieee:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)  =>  (FMINNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 312773 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 312778 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312782 */   GIR_RootConstrainSelectedInstOperands,
     /* 312783 */   // GIR_Coverage, 4755,
     /* 312783 */   GIR_Done,
     /* 312784 */ // Label 6354: @312784
     /* 312784 */ GIM_Reject,
     /* 312785 */ // Label 6346: @312785
     /* 312785 */ GIM_Try, /*On fail goto*//*Label 6355*/ GIMT_Encode4(312822), // Rule ID 4949 //
     /* 312790 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 312796 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 312799 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312803 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312807 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312811 */   // (fminnum_ieee:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 312811 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
     /* 312816 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312820 */   GIR_RootConstrainSelectedInstOperands,
     /* 312821 */   // GIR_Coverage, 4949,
     /* 312821 */   GIR_Done,
     /* 312822 */ // Label 6355: @312822
     /* 312822 */ GIM_Reject,
     /* 312823 */ // Label 6347: @312823
     /* 312823 */ GIM_Try, /*On fail goto*//*Label 6356*/ GIMT_Encode4(312860), // Rule ID 4943 //
     /* 312828 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 312834 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 312837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312841 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312845 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312849 */   // (fminnum_ieee:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 312849 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
     /* 312854 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312858 */   GIR_RootConstrainSelectedInstOperands,
     /* 312859 */   // GIR_Coverage, 4943,
     /* 312859 */   GIR_Done,
     /* 312860 */ // Label 6356: @312860
     /* 312860 */ GIM_Reject,
     /* 312861 */ // Label 6348: @312861
     /* 312861 */ GIM_Try, /*On fail goto*//*Label 6357*/ GIMT_Encode4(312898), // Rule ID 4955 //
     /* 312866 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 312869 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 312872 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 312875 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312879 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312883 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312887 */   // (fminnum_ieee:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 312887 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
     /* 312892 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312896 */   GIR_RootConstrainSelectedInstOperands,
     /* 312897 */   // GIR_Coverage, 4955,
     /* 312897 */   GIR_Done,
     /* 312898 */ // Label 6357: @312898
     /* 312898 */ GIM_Reject,
     /* 312899 */ // Label 6349: @312899
     /* 312899 */ GIM_Try, /*On fail goto*//*Label 6358*/ GIMT_Encode4(312936), // Rule ID 4946 //
     /* 312904 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312910 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 312913 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312917 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312921 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312925 */   // (fminnum_ieee:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 312925 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
     /* 312930 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312934 */   GIR_RootConstrainSelectedInstOperands,
     /* 312935 */   // GIR_Coverage, 4946,
     /* 312935 */   GIR_Done,
     /* 312936 */ // Label 6358: @312936
     /* 312936 */ GIM_Reject,
     /* 312937 */ // Label 6350: @312937
     /* 312937 */ GIM_Try, /*On fail goto*//*Label 6359*/ GIMT_Encode4(312974), // Rule ID 4952 //
     /* 312942 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 312945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 312948 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 312951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312955 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312959 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312963 */   // (fminnum_ieee:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 312963 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
     /* 312968 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312972 */   GIR_RootConstrainSelectedInstOperands,
     /* 312973 */   // GIR_Coverage, 4952,
     /* 312973 */   GIR_Done,
     /* 312974 */ // Label 6359: @312974
     /* 312974 */ GIM_Reject,
     /* 312975 */ // Label 6351: @312975
     /* 312975 */ GIM_Reject,
     /* 312976 */ // Label 73: @312976
     /* 312976 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6368*/ GIMT_Encode4(313325),
     /* 312987 */ /*GILLT_s16*//*Label 6360*/ GIMT_Encode4(313027),
     /* 312991 */ /*GILLT_s32*//*Label 6361*/ GIMT_Encode4(313065),
     /* 312995 */ /*GILLT_s64*//*Label 6362*/ GIMT_Encode4(313100), GIMT_Encode4(0),
     /* 313003 */ /*GILLT_v2s32*//*Label 6363*/ GIMT_Encode4(313135),
     /* 313007 */ /*GILLT_v2s64*//*Label 6364*/ GIMT_Encode4(313173),
     /* 313011 */ /*GILLT_v4s16*//*Label 6365*/ GIMT_Encode4(313211),
     /* 313015 */ /*GILLT_v4s32*//*Label 6366*/ GIMT_Encode4(313249), GIMT_Encode4(0),
     /* 313023 */ /*GILLT_v8s16*//*Label 6367*/ GIMT_Encode4(313287),
     /* 313027 */ // Label 6360: @313027
     /* 313027 */ GIM_Try, /*On fail goto*//*Label 6369*/ GIMT_Encode4(313064), // Rule ID 4762 //
     /* 313032 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 313035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 313038 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 313041 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313045 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313049 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313053 */   // (fmaxnum_ieee:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)  =>  (FMAXNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 313053 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMHrr),
     /* 313058 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313062 */   GIR_RootConstrainSelectedInstOperands,
     /* 313063 */   // GIR_Coverage, 4762,
     /* 313063 */   GIR_Done,
     /* 313064 */ // Label 6369: @313064
     /* 313064 */ GIM_Reject,
     /* 313065 */ // Label 6361: @313065
     /* 313065 */ GIM_Try, /*On fail goto*//*Label 6370*/ GIMT_Encode4(313099), // Rule ID 4759 //
     /* 313070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313073 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 313076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313080 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313084 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313088 */   // (fmaxnum_ieee:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)  =>  (FMAXNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 313088 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMSrr),
     /* 313093 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313097 */   GIR_RootConstrainSelectedInstOperands,
     /* 313098 */   // GIR_Coverage, 4759,
     /* 313098 */   GIR_Done,
     /* 313099 */ // Label 6370: @313099
     /* 313099 */ GIM_Reject,
     /* 313100 */ // Label 6362: @313100
     /* 313100 */ GIM_Try, /*On fail goto*//*Label 6371*/ GIMT_Encode4(313134), // Rule ID 4756 //
     /* 313105 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 313108 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 313111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313115 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313119 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313123 */   // (fmaxnum_ieee:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)  =>  (FMAXNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 313123 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
     /* 313128 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313132 */   GIR_RootConstrainSelectedInstOperands,
     /* 313133 */   // GIR_Coverage, 4756,
     /* 313133 */   GIR_Done,
     /* 313134 */ // Label 6371: @313134
     /* 313134 */ GIM_Reject,
     /* 313135 */ // Label 6363: @313135
     /* 313135 */ GIM_Try, /*On fail goto*//*Label 6372*/ GIMT_Encode4(313172), // Rule ID 4950 //
     /* 313140 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 313143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 313146 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 313149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313153 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313157 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313161 */   // (fmaxnum_ieee:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 313161 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f32),
     /* 313166 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313170 */   GIR_RootConstrainSelectedInstOperands,
     /* 313171 */   // GIR_Coverage, 4950,
     /* 313171 */   GIR_Done,
     /* 313172 */ // Label 6372: @313172
     /* 313172 */ GIM_Reject,
     /* 313173 */ // Label 6364: @313173
     /* 313173 */ GIM_Try, /*On fail goto*//*Label 6373*/ GIMT_Encode4(313210), // Rule ID 4944 //
     /* 313178 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 313181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 313184 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 313187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313191 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313195 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313199 */   // (fmaxnum_ieee:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 313199 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f64),
     /* 313204 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313208 */   GIR_RootConstrainSelectedInstOperands,
     /* 313209 */   // GIR_Coverage, 4944,
     /* 313209 */   GIR_Done,
     /* 313210 */ // Label 6373: @313210
     /* 313210 */ GIM_Reject,
     /* 313211 */ // Label 6365: @313211
     /* 313211 */ GIM_Try, /*On fail goto*//*Label 6374*/ GIMT_Encode4(313248), // Rule ID 4956 //
     /* 313216 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 313219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 313222 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 313225 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313229 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313233 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313237 */   // (fmaxnum_ieee:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 313237 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f16),
     /* 313242 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313246 */   GIR_RootConstrainSelectedInstOperands,
     /* 313247 */   // GIR_Coverage, 4956,
     /* 313247 */   GIR_Done,
     /* 313248 */ // Label 6374: @313248
     /* 313248 */ GIM_Reject,
     /* 313249 */ // Label 6366: @313249
     /* 313249 */ GIM_Try, /*On fail goto*//*Label 6375*/ GIMT_Encode4(313286), // Rule ID 4947 //
     /* 313254 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 313257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313260 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 313263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313267 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313271 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313275 */   // (fmaxnum_ieee:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 313275 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f32),
     /* 313280 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313284 */   GIR_RootConstrainSelectedInstOperands,
     /* 313285 */   // GIR_Coverage, 4947,
     /* 313285 */   GIR_Done,
     /* 313286 */ // Label 6375: @313286
     /* 313286 */ GIM_Reject,
     /* 313287 */ // Label 6367: @313287
     /* 313287 */ GIM_Try, /*On fail goto*//*Label 6376*/ GIMT_Encode4(313324), // Rule ID 4953 //
     /* 313292 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 313295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 313298 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 313301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313305 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313309 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313313 */   // (fmaxnum_ieee:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 313313 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv8f16),
     /* 313318 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313322 */   GIR_RootConstrainSelectedInstOperands,
     /* 313323 */   // GIR_Coverage, 4953,
     /* 313323 */   GIR_Done,
     /* 313324 */ // Label 6376: @313324
     /* 313324 */ GIM_Reject,
     /* 313325 */ // Label 6368: @313325
     /* 313325 */ GIM_Reject,
     /* 313326 */ // Label 74: @313326
     /* 313326 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6385*/ GIMT_Encode4(314028),
     /* 313337 */ /*GILLT_s16*//*Label 6377*/ GIMT_Encode4(313377),
     /* 313341 */ /*GILLT_s32*//*Label 6378*/ GIMT_Encode4(313415),
     /* 313345 */ /*GILLT_s64*//*Label 6379*/ GIMT_Encode4(313453), GIMT_Encode4(0),
     /* 313353 */ /*GILLT_v2s32*//*Label 6380*/ GIMT_Encode4(313513),
     /* 313357 */ /*GILLT_v2s64*//*Label 6381*/ GIMT_Encode4(313616),
     /* 313361 */ /*GILLT_v4s16*//*Label 6382*/ GIMT_Encode4(313719),
     /* 313365 */ /*GILLT_v4s32*//*Label 6383*/ GIMT_Encode4(313822), GIMT_Encode4(0),
     /* 313373 */ /*GILLT_v8s16*//*Label 6384*/ GIMT_Encode4(313925),
     /* 313377 */ // Label 6377: @313377
     /* 313377 */ GIM_Try, /*On fail goto*//*Label 6386*/ GIMT_Encode4(313414), // Rule ID 614 //
     /* 313382 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 313385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 313388 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 313391 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313395 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313399 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313403 */   // (fminimum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMINHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 313403 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINHrr),
     /* 313408 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313412 */   GIR_RootConstrainSelectedInstOperands,
     /* 313413 */   // GIR_Coverage, 614,
     /* 313413 */   GIR_Done,
     /* 313414 */ // Label 6386: @313414
     /* 313414 */ GIM_Reject,
     /* 313415 */ // Label 6378: @313415
     /* 313415 */ GIM_Try, /*On fail goto*//*Label 6387*/ GIMT_Encode4(313452), // Rule ID 616 //
     /* 313420 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 313423 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313426 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 313429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313433 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313437 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313441 */   // (fminimum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMINSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 313441 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINSrr),
     /* 313446 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313450 */   GIR_RootConstrainSelectedInstOperands,
     /* 313451 */   // GIR_Coverage, 616,
     /* 313451 */   GIR_Done,
     /* 313452 */ // Label 6387: @313452
     /* 313452 */ GIM_Reject,
     /* 313453 */ // Label 6379: @313453
     /* 313453 */ GIM_Try, /*On fail goto*//*Label 6388*/ GIMT_Encode4(313512),
     /* 313458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 313461 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 313464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313468 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313472 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313476 */   GIM_Try, /*On fail goto*//*Label 6389*/ GIMT_Encode4(313495), // Rule ID 618 //
     /* 313481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 313484 */     // (fminimum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMINDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 313484 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINDrr),
     /* 313489 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313493 */     GIR_RootConstrainSelectedInstOperands,
     /* 313494 */     // GIR_Coverage, 618,
     /* 313494 */     GIR_Done,
     /* 313495 */   // Label 6389: @313495
     /* 313495 */   GIM_Try, /*On fail goto*//*Label 6390*/ GIMT_Encode4(313511), // Rule ID 4752 //
     /* 313500 */     // (fminimum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMINDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 313500 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINDrr),
     /* 313505 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313509 */     GIR_RootConstrainSelectedInstOperands,
     /* 313510 */     // GIR_Coverage, 4752,
     /* 313510 */     GIR_Done,
     /* 313511 */   // Label 6390: @313511
     /* 313511 */   GIM_Reject,
     /* 313512 */ // Label 6388: @313512
     /* 313512 */ GIM_Reject,
     /* 313513 */ // Label 6380: @313513
     /* 313513 */ GIM_Try, /*On fail goto*//*Label 6391*/ GIMT_Encode4(313615),
     /* 313518 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 313521 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 313524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313528 */   GIM_Try, /*On fail goto*//*Label 6392*/ GIMT_Encode4(313587), // Rule ID 2357 //
     /* 313533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 313536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 313544 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 313548 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313553 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 313557 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 313561 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 313565 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313570 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 313572 */     // (fminimum:{ *:[v2f32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FAMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 313572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f32),
     /* 313575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 313585 */     GIR_RootConstrainSelectedInstOperands,
     /* 313586 */     // GIR_Coverage, 2357,
     /* 313586 */     GIR_EraseRootFromParent_Done,
     /* 313587 */   // Label 6392: @313587
     /* 313587 */   GIM_Try, /*On fail goto*//*Label 6393*/ GIMT_Encode4(313614), // Rule ID 1281 //
     /* 313592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 313595 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313603 */     // (fminimum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 313603 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv2f32),
     /* 313608 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313612 */     GIR_RootConstrainSelectedInstOperands,
     /* 313613 */     // GIR_Coverage, 1281,
     /* 313613 */     GIR_Done,
     /* 313614 */   // Label 6393: @313614
     /* 313614 */   GIM_Reject,
     /* 313615 */ // Label 6391: @313615
     /* 313615 */ GIM_Reject,
     /* 313616 */ // Label 6381: @313616
     /* 313616 */ GIM_Try, /*On fail goto*//*Label 6394*/ GIMT_Encode4(313718),
     /* 313621 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 313624 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 313627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313631 */   GIM_Try, /*On fail goto*//*Label 6395*/ GIMT_Encode4(313690), // Rule ID 2363 //
     /* 313636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 313639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 313647 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 313651 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313656 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 313660 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 313664 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 313668 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313673 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 313675 */     // (fminimum:{ *:[v2f64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FAMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 313675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f64),
     /* 313678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 313688 */     GIR_RootConstrainSelectedInstOperands,
     /* 313689 */     // GIR_Coverage, 2363,
     /* 313689 */     GIR_EraseRootFromParent_Done,
     /* 313690 */   // Label 6395: @313690
     /* 313690 */   GIM_Try, /*On fail goto*//*Label 6396*/ GIMT_Encode4(313717), // Rule ID 1285 //
     /* 313695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 313698 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313706 */     // (fminimum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 313706 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv2f64),
     /* 313711 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313715 */     GIR_RootConstrainSelectedInstOperands,
     /* 313716 */     // GIR_Coverage, 1285,
     /* 313716 */     GIR_Done,
     /* 313717 */   // Label 6396: @313717
     /* 313717 */   GIM_Reject,
     /* 313718 */ // Label 6394: @313718
     /* 313718 */ GIM_Reject,
     /* 313719 */ // Label 6382: @313719
     /* 313719 */ GIM_Try, /*On fail goto*//*Label 6397*/ GIMT_Encode4(313821),
     /* 313724 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 313727 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 313730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313734 */   GIM_Try, /*On fail goto*//*Label 6398*/ GIMT_Encode4(313793), // Rule ID 2351 //
     /* 313739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 313742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 313750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 313754 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313759 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 313763 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 313767 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 313771 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313776 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 313778 */     // (fminimum:{ *:[v4f16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FAMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 313778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f16),
     /* 313781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 313791 */     GIR_RootConstrainSelectedInstOperands,
     /* 313792 */     // GIR_Coverage, 2351,
     /* 313792 */     GIR_EraseRootFromParent_Done,
     /* 313793 */   // Label 6398: @313793
     /* 313793 */   GIM_Try, /*On fail goto*//*Label 6399*/ GIMT_Encode4(313820), // Rule ID 1277 //
     /* 313798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 313801 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313809 */     // (fminimum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 313809 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv4f16),
     /* 313814 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313818 */     GIR_RootConstrainSelectedInstOperands,
     /* 313819 */     // GIR_Coverage, 1277,
     /* 313819 */     GIR_Done,
     /* 313820 */   // Label 6399: @313820
     /* 313820 */   GIM_Reject,
     /* 313821 */ // Label 6397: @313821
     /* 313821 */ GIM_Reject,
     /* 313822 */ // Label 6383: @313822
     /* 313822 */ GIM_Try, /*On fail goto*//*Label 6400*/ GIMT_Encode4(313924),
     /* 313827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313830 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 313833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313837 */   GIM_Try, /*On fail goto*//*Label 6401*/ GIMT_Encode4(313896), // Rule ID 2360 //
     /* 313842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 313845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 313853 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313857 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 313866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 313870 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313874 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313879 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 313881 */     // (fminimum:{ *:[v4f32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FAMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 313881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f32),
     /* 313884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 313894 */     GIR_RootConstrainSelectedInstOperands,
     /* 313895 */     // GIR_Coverage, 2360,
     /* 313895 */     GIR_EraseRootFromParent_Done,
     /* 313896 */   // Label 6401: @313896
     /* 313896 */   GIM_Try, /*On fail goto*//*Label 6402*/ GIMT_Encode4(313923), // Rule ID 1283 //
     /* 313901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 313904 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313912 */     // (fminimum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 313912 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv4f32),
     /* 313917 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313921 */     GIR_RootConstrainSelectedInstOperands,
     /* 313922 */     // GIR_Coverage, 1283,
     /* 313922 */     GIR_Done,
     /* 313923 */   // Label 6402: @313923
     /* 313923 */   GIM_Reject,
     /* 313924 */ // Label 6400: @313924
     /* 313924 */ GIM_Reject,
     /* 313925 */ // Label 6384: @313925
     /* 313925 */ GIM_Try, /*On fail goto*//*Label 6403*/ GIMT_Encode4(314027),
     /* 313930 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 313933 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 313936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313940 */   GIM_Try, /*On fail goto*//*Label 6404*/ GIMT_Encode4(313999), // Rule ID 2354 //
     /* 313945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 313948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 313956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 313960 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313965 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 313969 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 313973 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 313977 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313982 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 313984 */     // (fminimum:{ *:[v8f16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FAMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 313984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv8f16),
     /* 313987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313989 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 313997 */     GIR_RootConstrainSelectedInstOperands,
     /* 313998 */     // GIR_Coverage, 2354,
     /* 313998 */     GIR_EraseRootFromParent_Done,
     /* 313999 */   // Label 6404: @313999
     /* 313999 */   GIM_Try, /*On fail goto*//*Label 6405*/ GIMT_Encode4(314026), // Rule ID 1279 //
     /* 314004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 314007 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314015 */     // (fminimum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 314015 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv8f16),
     /* 314020 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314024 */     GIR_RootConstrainSelectedInstOperands,
     /* 314025 */     // GIR_Coverage, 1279,
     /* 314025 */     GIR_Done,
     /* 314026 */   // Label 6405: @314026
     /* 314026 */   GIM_Reject,
     /* 314027 */ // Label 6403: @314027
     /* 314027 */ GIM_Reject,
     /* 314028 */ // Label 6385: @314028
     /* 314028 */ GIM_Reject,
     /* 314029 */ // Label 75: @314029
     /* 314029 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6414*/ GIMT_Encode4(314731),
     /* 314040 */ /*GILLT_s16*//*Label 6406*/ GIMT_Encode4(314080),
     /* 314044 */ /*GILLT_s32*//*Label 6407*/ GIMT_Encode4(314118),
     /* 314048 */ /*GILLT_s64*//*Label 6408*/ GIMT_Encode4(314156), GIMT_Encode4(0),
     /* 314056 */ /*GILLT_v2s32*//*Label 6409*/ GIMT_Encode4(314216),
     /* 314060 */ /*GILLT_v2s64*//*Label 6410*/ GIMT_Encode4(314319),
     /* 314064 */ /*GILLT_v4s16*//*Label 6411*/ GIMT_Encode4(314422),
     /* 314068 */ /*GILLT_v4s32*//*Label 6412*/ GIMT_Encode4(314525), GIMT_Encode4(0),
     /* 314076 */ /*GILLT_v8s16*//*Label 6413*/ GIMT_Encode4(314628),
     /* 314080 */ // Label 6406: @314080
     /* 314080 */ GIM_Try, /*On fail goto*//*Label 6415*/ GIMT_Encode4(314117), // Rule ID 602 //
     /* 314085 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 314088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 314091 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 314094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 314098 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 314102 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 314106 */   // (fmaximum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMAXHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 314106 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXHrr),
     /* 314111 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314115 */   GIR_RootConstrainSelectedInstOperands,
     /* 314116 */   // GIR_Coverage, 602,
     /* 314116 */   GIR_Done,
     /* 314117 */ // Label 6415: @314117
     /* 314117 */ GIM_Reject,
     /* 314118 */ // Label 6407: @314118
     /* 314118 */ GIM_Try, /*On fail goto*//*Label 6416*/ GIMT_Encode4(314155), // Rule ID 604 //
     /* 314123 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 314126 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314129 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 314132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314136 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314140 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314144 */   // (fmaximum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMAXSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 314144 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXSrr),
     /* 314149 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314153 */   GIR_RootConstrainSelectedInstOperands,
     /* 314154 */   // GIR_Coverage, 604,
     /* 314154 */   GIR_Done,
     /* 314155 */ // Label 6416: @314155
     /* 314155 */ GIM_Reject,
     /* 314156 */ // Label 6408: @314156
     /* 314156 */ GIM_Try, /*On fail goto*//*Label 6417*/ GIMT_Encode4(314215),
     /* 314161 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 314164 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 314167 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314171 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314175 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314179 */   GIM_Try, /*On fail goto*//*Label 6418*/ GIMT_Encode4(314198), // Rule ID 606 //
     /* 314184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 314187 */     // (fmaximum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMAXDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 314187 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXDrr),
     /* 314192 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314196 */     GIR_RootConstrainSelectedInstOperands,
     /* 314197 */     // GIR_Coverage, 606,
     /* 314197 */     GIR_Done,
     /* 314198 */   // Label 6418: @314198
     /* 314198 */   GIM_Try, /*On fail goto*//*Label 6419*/ GIMT_Encode4(314214), // Rule ID 4751 //
     /* 314203 */     // (fmaximum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMAXDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 314203 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXDrr),
     /* 314208 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314212 */     GIR_RootConstrainSelectedInstOperands,
     /* 314213 */     // GIR_Coverage, 4751,
     /* 314213 */     GIR_Done,
     /* 314214 */   // Label 6419: @314214
     /* 314214 */   GIM_Reject,
     /* 314215 */ // Label 6417: @314215
     /* 314215 */ GIM_Reject,
     /* 314216 */ // Label 6409: @314216
     /* 314216 */ GIM_Try, /*On fail goto*//*Label 6420*/ GIMT_Encode4(314318),
     /* 314221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 314224 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 314227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314231 */   GIM_Try, /*On fail goto*//*Label 6421*/ GIMT_Encode4(314290), // Rule ID 2342 //
     /* 314236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 314239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 314247 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 314251 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314256 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 314260 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 314264 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 314268 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314273 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 314275 */     // (fmaximum:{ *:[v2f32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FAMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 314275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f32),
     /* 314278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314280 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314284 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 314288 */     GIR_RootConstrainSelectedInstOperands,
     /* 314289 */     // GIR_Coverage, 2342,
     /* 314289 */     GIR_EraseRootFromParent_Done,
     /* 314290 */   // Label 6421: @314290
     /* 314290 */   GIM_Try, /*On fail goto*//*Label 6422*/ GIMT_Encode4(314317), // Rule ID 1251 //
     /* 314295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314306 */     // (fmaximum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 314306 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv2f32),
     /* 314311 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314315 */     GIR_RootConstrainSelectedInstOperands,
     /* 314316 */     // GIR_Coverage, 1251,
     /* 314316 */     GIR_Done,
     /* 314317 */   // Label 6422: @314317
     /* 314317 */   GIM_Reject,
     /* 314318 */ // Label 6420: @314318
     /* 314318 */ GIM_Reject,
     /* 314319 */ // Label 6410: @314319
     /* 314319 */ GIM_Try, /*On fail goto*//*Label 6423*/ GIMT_Encode4(314421),
     /* 314324 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 314327 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 314330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314334 */   GIM_Try, /*On fail goto*//*Label 6424*/ GIMT_Encode4(314393), // Rule ID 2348 //
     /* 314339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 314342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 314350 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 314354 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314359 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 314363 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 314367 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 314371 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314376 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 314378 */     // (fmaximum:{ *:[v2f64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FAMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 314378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f64),
     /* 314381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 314391 */     GIR_RootConstrainSelectedInstOperands,
     /* 314392 */     // GIR_Coverage, 2348,
     /* 314392 */     GIR_EraseRootFromParent_Done,
     /* 314393 */   // Label 6424: @314393
     /* 314393 */   GIM_Try, /*On fail goto*//*Label 6425*/ GIMT_Encode4(314420), // Rule ID 1255 //
     /* 314398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314409 */     // (fmaximum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 314409 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv2f64),
     /* 314414 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314418 */     GIR_RootConstrainSelectedInstOperands,
     /* 314419 */     // GIR_Coverage, 1255,
     /* 314419 */     GIR_Done,
     /* 314420 */   // Label 6425: @314420
     /* 314420 */   GIM_Reject,
     /* 314421 */ // Label 6423: @314421
     /* 314421 */ GIM_Reject,
     /* 314422 */ // Label 6411: @314422
     /* 314422 */ GIM_Try, /*On fail goto*//*Label 6426*/ GIMT_Encode4(314524),
     /* 314427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 314430 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 314433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314437 */   GIM_Try, /*On fail goto*//*Label 6427*/ GIMT_Encode4(314496), // Rule ID 2336 //
     /* 314442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 314445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 314453 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 314457 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 314466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 314470 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 314474 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314479 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 314481 */     // (fmaximum:{ *:[v4f16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FAMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 314481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f16),
     /* 314484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 314494 */     GIR_RootConstrainSelectedInstOperands,
     /* 314495 */     // GIR_Coverage, 2336,
     /* 314495 */     GIR_EraseRootFromParent_Done,
     /* 314496 */   // Label 6427: @314496
     /* 314496 */   GIM_Try, /*On fail goto*//*Label 6428*/ GIMT_Encode4(314523), // Rule ID 1247 //
     /* 314501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 314504 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314512 */     // (fmaximum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 314512 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv4f16),
     /* 314517 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314521 */     GIR_RootConstrainSelectedInstOperands,
     /* 314522 */     // GIR_Coverage, 1247,
     /* 314522 */     GIR_Done,
     /* 314523 */   // Label 6428: @314523
     /* 314523 */   GIM_Reject,
     /* 314524 */ // Label 6426: @314524
     /* 314524 */ GIM_Reject,
     /* 314525 */ // Label 6412: @314525
     /* 314525 */ GIM_Try, /*On fail goto*//*Label 6429*/ GIMT_Encode4(314627),
     /* 314530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314533 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 314536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314540 */   GIM_Try, /*On fail goto*//*Label 6430*/ GIMT_Encode4(314599), // Rule ID 2345 //
     /* 314545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 314548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 314556 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314560 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314565 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 314569 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 314573 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314577 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314582 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 314584 */     // (fmaximum:{ *:[v4f32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FAMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 314584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f32),
     /* 314587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 314597 */     GIR_RootConstrainSelectedInstOperands,
     /* 314598 */     // GIR_Coverage, 2345,
     /* 314598 */     GIR_EraseRootFromParent_Done,
     /* 314599 */   // Label 6430: @314599
     /* 314599 */   GIM_Try, /*On fail goto*//*Label 6431*/ GIMT_Encode4(314626), // Rule ID 1253 //
     /* 314604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314615 */     // (fmaximum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 314615 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv4f32),
     /* 314620 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314624 */     GIR_RootConstrainSelectedInstOperands,
     /* 314625 */     // GIR_Coverage, 1253,
     /* 314625 */     GIR_Done,
     /* 314626 */   // Label 6431: @314626
     /* 314626 */   GIM_Reject,
     /* 314627 */ // Label 6429: @314627
     /* 314627 */ GIM_Reject,
     /* 314628 */ // Label 6413: @314628
     /* 314628 */ GIM_Try, /*On fail goto*//*Label 6432*/ GIMT_Encode4(314730),
     /* 314633 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 314636 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 314639 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314643 */   GIM_Try, /*On fail goto*//*Label 6433*/ GIMT_Encode4(314702), // Rule ID 2339 //
     /* 314648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 314651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 314659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 314663 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 314672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 314676 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 314680 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314685 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 314687 */     // (fmaximum:{ *:[v8f16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FAMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 314687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv8f16),
     /* 314690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314692 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 314700 */     GIR_RootConstrainSelectedInstOperands,
     /* 314701 */     // GIR_Coverage, 2339,
     /* 314701 */     GIR_EraseRootFromParent_Done,
     /* 314702 */   // Label 6433: @314702
     /* 314702 */   GIM_Try, /*On fail goto*//*Label 6434*/ GIMT_Encode4(314729), // Rule ID 1249 //
     /* 314707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 314710 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314718 */     // (fmaximum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 314718 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv8f16),
     /* 314723 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314727 */     GIR_RootConstrainSelectedInstOperands,
     /* 314728 */     // GIR_Coverage, 1249,
     /* 314728 */     GIR_Done,
     /* 314729 */   // Label 6434: @314729
     /* 314729 */   GIM_Reject,
     /* 314730 */ // Label 6432: @314730
     /* 314730 */ GIM_Reject,
     /* 314731 */ // Label 6414: @314731
     /* 314731 */ GIM_Reject,
     /* 314732 */ // Label 76: @314732
     /* 314732 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6443*/ GIMT_Encode4(315135),
     /* 314743 */ /*GILLT_s32*//*Label 6435*/ GIMT_Encode4(314783),
     /* 314747 */ /*GILLT_s64*//*Label 6436*/ GIMT_Encode4(314857), GIMT_Encode4(0),
     /* 314755 */ /*GILLT_v2s32*//*Label 6437*/ GIMT_Encode4(314931), GIMT_Encode4(0),
     /* 314763 */ /*GILLT_v4s16*//*Label 6438*/ GIMT_Encode4(314965),
     /* 314767 */ /*GILLT_v4s32*//*Label 6439*/ GIMT_Encode4(314999),
     /* 314771 */ /*GILLT_v8s8*//*Label 6440*/ GIMT_Encode4(315033),
     /* 314775 */ /*GILLT_v8s16*//*Label 6441*/ GIMT_Encode4(315067),
     /* 314779 */ /*GILLT_v16s8*//*Label 6442*/ GIMT_Encode4(315101),
     /* 314783 */ // Label 6435: @314783
     /* 314783 */ GIM_Try, /*On fail goto*//*Label 6444*/ GIMT_Encode4(314856),
     /* 314788 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314791 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 314794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 314798 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 314802 */   GIM_Try, /*On fail goto*//*Label 6445*/ GIMT_Encode4(314836), // Rule ID 2319 //
     /* 314807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 314810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 314814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 314818 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_32b),
     /* 314822 */     // MIs[1] Operand 1
     /* 314822 */     // No operand predicates
     /* 314822 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314824 */     // (smin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_simm8_32b>>:$imm)  =>  (SMINWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 314824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINWri),
     /* 314827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314829 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 314831 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 314834 */     GIR_RootConstrainSelectedInstOperands,
     /* 314835 */     // GIR_Coverage, 2319,
     /* 314835 */     GIR_EraseRootFromParent_Done,
     /* 314836 */   // Label 6445: @314836
     /* 314836 */   GIM_Try, /*On fail goto*//*Label 6446*/ GIMT_Encode4(314855), // Rule ID 2318 //
     /* 314841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 314844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 314848 */     // (smin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SMINWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 314848 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINWrr),
     /* 314853 */     GIR_RootConstrainSelectedInstOperands,
     /* 314854 */     // GIR_Coverage, 2318,
     /* 314854 */     GIR_Done,
     /* 314855 */   // Label 6446: @314855
     /* 314855 */   GIM_Reject,
     /* 314856 */ // Label 6444: @314856
     /* 314856 */ GIM_Reject,
     /* 314857 */ // Label 6436: @314857
     /* 314857 */ GIM_Try, /*On fail goto*//*Label 6447*/ GIMT_Encode4(314930),
     /* 314862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 314865 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 314868 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 314872 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 314876 */   GIM_Try, /*On fail goto*//*Label 6448*/ GIMT_Encode4(314910), // Rule ID 2321 //
     /* 314881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 314884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 314888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 314892 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_64b),
     /* 314896 */     // MIs[1] Operand 1
     /* 314896 */     // No operand predicates
     /* 314896 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314898 */     // (smin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm8_64b>>:$imm)  =>  (SMINXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 314898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINXri),
     /* 314901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314903 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 314905 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 314908 */     GIR_RootConstrainSelectedInstOperands,
     /* 314909 */     // GIR_Coverage, 2321,
     /* 314909 */     GIR_EraseRootFromParent_Done,
     /* 314910 */   // Label 6448: @314910
     /* 314910 */   GIM_Try, /*On fail goto*//*Label 6449*/ GIMT_Encode4(314929), // Rule ID 2320 //
     /* 314915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 314918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 314922 */     // (smin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMINXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 314922 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINXrr),
     /* 314927 */     GIR_RootConstrainSelectedInstOperands,
     /* 314928 */     // GIR_Coverage, 2320,
     /* 314928 */     GIR_Done,
     /* 314929 */   // Label 6449: @314929
     /* 314929 */   GIM_Reject,
     /* 314930 */ // Label 6447: @314930
     /* 314930 */ GIM_Reject,
     /* 314931 */ // Label 6437: @314931
     /* 314931 */ GIM_Try, /*On fail goto*//*Label 6450*/ GIMT_Encode4(314964), // Rule ID 1407 //
     /* 314936 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 314942 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 314945 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314949 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314953 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314957 */   // (smin:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMINv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 314957 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv2i32),
     /* 314962 */   GIR_RootConstrainSelectedInstOperands,
     /* 314963 */   // GIR_Coverage, 1407,
     /* 314963 */   GIR_Done,
     /* 314964 */ // Label 6450: @314964
     /* 314964 */ GIM_Reject,
     /* 314965 */ // Label 6438: @314965
     /* 314965 */ GIM_Try, /*On fail goto*//*Label 6451*/ GIMT_Encode4(314998), // Rule ID 1405 //
     /* 314970 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314973 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 314976 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 314979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314983 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314987 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314991 */   // (smin:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMINv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 314991 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv4i16),
     /* 314996 */   GIR_RootConstrainSelectedInstOperands,
     /* 314997 */   // GIR_Coverage, 1405,
     /* 314997 */   GIR_Done,
     /* 314998 */ // Label 6451: @314998
     /* 314998 */ GIM_Reject,
     /* 314999 */ // Label 6439: @314999
     /* 314999 */ GIM_Try, /*On fail goto*//*Label 6452*/ GIMT_Encode4(315032), // Rule ID 1408 //
     /* 315004 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 315010 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 315013 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315017 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315021 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315025 */   // (smin:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMINv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 315025 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv4i32),
     /* 315030 */   GIR_RootConstrainSelectedInstOperands,
     /* 315031 */   // GIR_Coverage, 1408,
     /* 315031 */   GIR_Done,
     /* 315032 */ // Label 6452: @315032
     /* 315032 */ GIM_Reject,
     /* 315033 */ // Label 6440: @315033
     /* 315033 */ GIM_Try, /*On fail goto*//*Label 6453*/ GIMT_Encode4(315066), // Rule ID 1403 //
     /* 315038 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 315044 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 315047 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315051 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315055 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315059 */   // (smin:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMINv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 315059 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv8i8),
     /* 315064 */   GIR_RootConstrainSelectedInstOperands,
     /* 315065 */   // GIR_Coverage, 1403,
     /* 315065 */   GIR_Done,
     /* 315066 */ // Label 6453: @315066
     /* 315066 */ GIM_Reject,
     /* 315067 */ // Label 6441: @315067
     /* 315067 */ GIM_Try, /*On fail goto*//*Label 6454*/ GIMT_Encode4(315100), // Rule ID 1406 //
     /* 315072 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315075 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 315078 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 315081 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315085 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315089 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315093 */   // (smin:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMINv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 315093 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv8i16),
     /* 315098 */   GIR_RootConstrainSelectedInstOperands,
     /* 315099 */   // GIR_Coverage, 1406,
     /* 315099 */   GIR_Done,
     /* 315100 */ // Label 6454: @315100
     /* 315100 */ GIM_Reject,
     /* 315101 */ // Label 6442: @315101
     /* 315101 */ GIM_Try, /*On fail goto*//*Label 6455*/ GIMT_Encode4(315134), // Rule ID 1404 //
     /* 315106 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 315112 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 315115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315119 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315123 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315127 */   // (smin:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMINv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 315127 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv16i8),
     /* 315132 */   GIR_RootConstrainSelectedInstOperands,
     /* 315133 */   // GIR_Coverage, 1404,
     /* 315133 */   GIR_Done,
     /* 315134 */ // Label 6455: @315134
     /* 315134 */ GIM_Reject,
     /* 315135 */ // Label 6443: @315135
     /* 315135 */ GIM_Reject,
     /* 315136 */ // Label 77: @315136
     /* 315136 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6464*/ GIMT_Encode4(315539),
     /* 315147 */ /*GILLT_s32*//*Label 6456*/ GIMT_Encode4(315187),
     /* 315151 */ /*GILLT_s64*//*Label 6457*/ GIMT_Encode4(315261), GIMT_Encode4(0),
     /* 315159 */ /*GILLT_v2s32*//*Label 6458*/ GIMT_Encode4(315335), GIMT_Encode4(0),
     /* 315167 */ /*GILLT_v4s16*//*Label 6459*/ GIMT_Encode4(315369),
     /* 315171 */ /*GILLT_v4s32*//*Label 6460*/ GIMT_Encode4(315403),
     /* 315175 */ /*GILLT_v8s8*//*Label 6461*/ GIMT_Encode4(315437),
     /* 315179 */ /*GILLT_v8s16*//*Label 6462*/ GIMT_Encode4(315471),
     /* 315183 */ /*GILLT_v16s8*//*Label 6463*/ GIMT_Encode4(315505),
     /* 315187 */ // Label 6456: @315187
     /* 315187 */ GIM_Try, /*On fail goto*//*Label 6465*/ GIMT_Encode4(315260),
     /* 315192 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 315195 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 315198 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 315202 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 315206 */   GIM_Try, /*On fail goto*//*Label 6466*/ GIMT_Encode4(315240), // Rule ID 2315 //
     /* 315211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 315214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 315218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 315222 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_32b),
     /* 315226 */     // MIs[1] Operand 1
     /* 315226 */     // No operand predicates
     /* 315226 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315228 */     // (smax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_simm8_32b>>:$imm)  =>  (SMAXWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 315228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXWri),
     /* 315231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315233 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 315235 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 315238 */     GIR_RootConstrainSelectedInstOperands,
     /* 315239 */     // GIR_Coverage, 2315,
     /* 315239 */     GIR_EraseRootFromParent_Done,
     /* 315240 */   // Label 6466: @315240
     /* 315240 */   GIM_Try, /*On fail goto*//*Label 6467*/ GIMT_Encode4(315259), // Rule ID 2314 //
     /* 315245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 315248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 315252 */     // (smax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SMAXWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 315252 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXWrr),
     /* 315257 */     GIR_RootConstrainSelectedInstOperands,
     /* 315258 */     // GIR_Coverage, 2314,
     /* 315258 */     GIR_Done,
     /* 315259 */   // Label 6467: @315259
     /* 315259 */   GIM_Reject,
     /* 315260 */ // Label 6465: @315260
     /* 315260 */ GIM_Reject,
     /* 315261 */ // Label 6457: @315261
     /* 315261 */ GIM_Try, /*On fail goto*//*Label 6468*/ GIMT_Encode4(315334),
     /* 315266 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 315269 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 315272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 315276 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 315280 */   GIM_Try, /*On fail goto*//*Label 6469*/ GIMT_Encode4(315314), // Rule ID 2317 //
     /* 315285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 315288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 315292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 315296 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_64b),
     /* 315300 */     // MIs[1] Operand 1
     /* 315300 */     // No operand predicates
     /* 315300 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315302 */     // (smax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm8_64b>>:$imm)  =>  (SMAXXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 315302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXXri),
     /* 315305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315307 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 315309 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 315312 */     GIR_RootConstrainSelectedInstOperands,
     /* 315313 */     // GIR_Coverage, 2317,
     /* 315313 */     GIR_EraseRootFromParent_Done,
     /* 315314 */   // Label 6469: @315314
     /* 315314 */   GIM_Try, /*On fail goto*//*Label 6470*/ GIMT_Encode4(315333), // Rule ID 2316 //
     /* 315319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 315322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 315326 */     // (smax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMAXXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 315326 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXXrr),
     /* 315331 */     GIR_RootConstrainSelectedInstOperands,
     /* 315332 */     // GIR_Coverage, 2316,
     /* 315332 */     GIR_Done,
     /* 315333 */   // Label 6470: @315333
     /* 315333 */   GIM_Reject,
     /* 315334 */ // Label 6468: @315334
     /* 315334 */ GIM_Reject,
     /* 315335 */ // Label 6458: @315335
     /* 315335 */ GIM_Try, /*On fail goto*//*Label 6471*/ GIMT_Encode4(315368), // Rule ID 1395 //
     /* 315340 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315343 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 315346 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 315349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315353 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315357 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315361 */   // (smax:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMAXv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 315361 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv2i32),
     /* 315366 */   GIR_RootConstrainSelectedInstOperands,
     /* 315367 */   // GIR_Coverage, 1395,
     /* 315367 */   GIR_Done,
     /* 315368 */ // Label 6471: @315368
     /* 315368 */ GIM_Reject,
     /* 315369 */ // Label 6459: @315369
     /* 315369 */ GIM_Try, /*On fail goto*//*Label 6472*/ GIMT_Encode4(315402), // Rule ID 1393 //
     /* 315374 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 315380 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 315383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315387 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315391 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315395 */   // (smax:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMAXv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 315395 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv4i16),
     /* 315400 */   GIR_RootConstrainSelectedInstOperands,
     /* 315401 */   // GIR_Coverage, 1393,
     /* 315401 */   GIR_Done,
     /* 315402 */ // Label 6472: @315402
     /* 315402 */ GIM_Reject,
     /* 315403 */ // Label 6460: @315403
     /* 315403 */ GIM_Try, /*On fail goto*//*Label 6473*/ GIMT_Encode4(315436), // Rule ID 1396 //
     /* 315408 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 315414 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 315417 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315421 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315425 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315429 */   // (smax:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMAXv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 315429 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv4i32),
     /* 315434 */   GIR_RootConstrainSelectedInstOperands,
     /* 315435 */   // GIR_Coverage, 1396,
     /* 315435 */   GIR_Done,
     /* 315436 */ // Label 6473: @315436
     /* 315436 */ GIM_Reject,
     /* 315437 */ // Label 6461: @315437
     /* 315437 */ GIM_Try, /*On fail goto*//*Label 6474*/ GIMT_Encode4(315470), // Rule ID 1391 //
     /* 315442 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 315448 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 315451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315455 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315459 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315463 */   // (smax:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMAXv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 315463 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv8i8),
     /* 315468 */   GIR_RootConstrainSelectedInstOperands,
     /* 315469 */   // GIR_Coverage, 1391,
     /* 315469 */   GIR_Done,
     /* 315470 */ // Label 6474: @315470
     /* 315470 */ GIM_Reject,
     /* 315471 */ // Label 6462: @315471
     /* 315471 */ GIM_Try, /*On fail goto*//*Label 6475*/ GIMT_Encode4(315504), // Rule ID 1394 //
     /* 315476 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315479 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 315482 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 315485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315489 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315493 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315497 */   // (smax:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMAXv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 315497 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv8i16),
     /* 315502 */   GIR_RootConstrainSelectedInstOperands,
     /* 315503 */   // GIR_Coverage, 1394,
     /* 315503 */   GIR_Done,
     /* 315504 */ // Label 6475: @315504
     /* 315504 */ GIM_Reject,
     /* 315505 */ // Label 6463: @315505
     /* 315505 */ GIM_Try, /*On fail goto*//*Label 6476*/ GIMT_Encode4(315538), // Rule ID 1392 //
     /* 315510 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315513 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 315516 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 315519 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315523 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315527 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315531 */   // (smax:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMAXv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 315531 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv16i8),
     /* 315536 */   GIR_RootConstrainSelectedInstOperands,
     /* 315537 */   // GIR_Coverage, 1392,
     /* 315537 */   GIR_Done,
     /* 315538 */ // Label 6476: @315538
     /* 315538 */ GIM_Reject,
     /* 315539 */ // Label 6464: @315539
     /* 315539 */ GIM_Reject,
     /* 315540 */ // Label 78: @315540
     /* 315540 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6485*/ GIMT_Encode4(315943),
     /* 315551 */ /*GILLT_s32*//*Label 6477*/ GIMT_Encode4(315591),
     /* 315555 */ /*GILLT_s64*//*Label 6478*/ GIMT_Encode4(315665), GIMT_Encode4(0),
     /* 315563 */ /*GILLT_v2s32*//*Label 6479*/ GIMT_Encode4(315739), GIMT_Encode4(0),
     /* 315571 */ /*GILLT_v4s16*//*Label 6480*/ GIMT_Encode4(315773),
     /* 315575 */ /*GILLT_v4s32*//*Label 6481*/ GIMT_Encode4(315807),
     /* 315579 */ /*GILLT_v8s8*//*Label 6482*/ GIMT_Encode4(315841),
     /* 315583 */ /*GILLT_v8s16*//*Label 6483*/ GIMT_Encode4(315875),
     /* 315587 */ /*GILLT_v16s8*//*Label 6484*/ GIMT_Encode4(315909),
     /* 315591 */ // Label 6477: @315591
     /* 315591 */ GIM_Try, /*On fail goto*//*Label 6486*/ GIMT_Encode4(315664),
     /* 315596 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 315599 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 315602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 315606 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 315610 */   GIM_Try, /*On fail goto*//*Label 6487*/ GIMT_Encode4(315644), // Rule ID 2327 //
     /* 315615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 315618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 315622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 315626 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_32b),
     /* 315630 */     // MIs[1] Operand 1
     /* 315630 */     // No operand predicates
     /* 315630 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315632 */     // (umin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_uimm8_32b>>:$imm)  =>  (UMINWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 315632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINWri),
     /* 315635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315637 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 315639 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 315642 */     GIR_RootConstrainSelectedInstOperands,
     /* 315643 */     // GIR_Coverage, 2327,
     /* 315643 */     GIR_EraseRootFromParent_Done,
     /* 315644 */   // Label 6487: @315644
     /* 315644 */   GIM_Try, /*On fail goto*//*Label 6488*/ GIMT_Encode4(315663), // Rule ID 2326 //
     /* 315649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 315652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 315656 */     // (umin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UMINWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 315656 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINWrr),
     /* 315661 */     GIR_RootConstrainSelectedInstOperands,
     /* 315662 */     // GIR_Coverage, 2326,
     /* 315662 */     GIR_Done,
     /* 315663 */   // Label 6488: @315663
     /* 315663 */   GIM_Reject,
     /* 315664 */ // Label 6486: @315664
     /* 315664 */ GIM_Reject,
     /* 315665 */ // Label 6478: @315665
     /* 315665 */ GIM_Try, /*On fail goto*//*Label 6489*/ GIMT_Encode4(315738),
     /* 315670 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 315673 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 315676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 315680 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 315684 */   GIM_Try, /*On fail goto*//*Label 6490*/ GIMT_Encode4(315718), // Rule ID 2329 //
     /* 315689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 315692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 315696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 315700 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_64b),
     /* 315704 */     // MIs[1] Operand 1
     /* 315704 */     // No operand predicates
     /* 315704 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315706 */     // (umin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_uimm8_64b>>:$imm)  =>  (UMINXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 315706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINXri),
     /* 315709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315711 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 315713 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 315716 */     GIR_RootConstrainSelectedInstOperands,
     /* 315717 */     // GIR_Coverage, 2329,
     /* 315717 */     GIR_EraseRootFromParent_Done,
     /* 315718 */   // Label 6490: @315718
     /* 315718 */   GIM_Try, /*On fail goto*//*Label 6491*/ GIMT_Encode4(315737), // Rule ID 2328 //
     /* 315723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 315726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 315730 */     // (umin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMINXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 315730 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINXrr),
     /* 315735 */     GIR_RootConstrainSelectedInstOperands,
     /* 315736 */     // GIR_Coverage, 2328,
     /* 315736 */     GIR_Done,
     /* 315737 */   // Label 6491: @315737
     /* 315737 */   GIM_Reject,
     /* 315738 */ // Label 6489: @315738
     /* 315738 */ GIM_Reject,
     /* 315739 */ // Label 6479: @315739
     /* 315739 */ GIM_Try, /*On fail goto*//*Label 6492*/ GIMT_Encode4(315772), // Rule ID 1530 //
     /* 315744 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315747 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 315750 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 315753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315757 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315761 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315765 */   // (umin:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMINv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 315765 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv2i32),
     /* 315770 */   GIR_RootConstrainSelectedInstOperands,
     /* 315771 */   // GIR_Coverage, 1530,
     /* 315771 */   GIR_Done,
     /* 315772 */ // Label 6492: @315772
     /* 315772 */ GIM_Reject,
     /* 315773 */ // Label 6480: @315773
     /* 315773 */ GIM_Try, /*On fail goto*//*Label 6493*/ GIMT_Encode4(315806), // Rule ID 1528 //
     /* 315778 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315781 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 315784 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 315787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315791 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315795 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315799 */   // (umin:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMINv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 315799 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv4i16),
     /* 315804 */   GIR_RootConstrainSelectedInstOperands,
     /* 315805 */   // GIR_Coverage, 1528,
     /* 315805 */   GIR_Done,
     /* 315806 */ // Label 6493: @315806
     /* 315806 */ GIM_Reject,
     /* 315807 */ // Label 6481: @315807
     /* 315807 */ GIM_Try, /*On fail goto*//*Label 6494*/ GIMT_Encode4(315840), // Rule ID 1531 //
     /* 315812 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315815 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 315818 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 315821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315825 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315829 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315833 */   // (umin:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMINv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 315833 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv4i32),
     /* 315838 */   GIR_RootConstrainSelectedInstOperands,
     /* 315839 */   // GIR_Coverage, 1531,
     /* 315839 */   GIR_Done,
     /* 315840 */ // Label 6494: @315840
     /* 315840 */ GIM_Reject,
     /* 315841 */ // Label 6482: @315841
     /* 315841 */ GIM_Try, /*On fail goto*//*Label 6495*/ GIMT_Encode4(315874), // Rule ID 1526 //
     /* 315846 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 315852 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 315855 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315859 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315863 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315867 */   // (umin:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMINv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 315867 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv8i8),
     /* 315872 */   GIR_RootConstrainSelectedInstOperands,
     /* 315873 */   // GIR_Coverage, 1526,
     /* 315873 */   GIR_Done,
     /* 315874 */ // Label 6495: @315874
     /* 315874 */ GIM_Reject,
     /* 315875 */ // Label 6483: @315875
     /* 315875 */ GIM_Try, /*On fail goto*//*Label 6496*/ GIMT_Encode4(315908), // Rule ID 1529 //
     /* 315880 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315883 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 315886 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 315889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315893 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315897 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315901 */   // (umin:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMINv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 315901 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv8i16),
     /* 315906 */   GIR_RootConstrainSelectedInstOperands,
     /* 315907 */   // GIR_Coverage, 1529,
     /* 315907 */   GIR_Done,
     /* 315908 */ // Label 6496: @315908
     /* 315908 */ GIM_Reject,
     /* 315909 */ // Label 6484: @315909
     /* 315909 */ GIM_Try, /*On fail goto*//*Label 6497*/ GIMT_Encode4(315942), // Rule ID 1527 //
     /* 315914 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315917 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 315920 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 315923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315927 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315931 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315935 */   // (umin:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMINv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 315935 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv16i8),
     /* 315940 */   GIR_RootConstrainSelectedInstOperands,
     /* 315941 */   // GIR_Coverage, 1527,
     /* 315941 */   GIR_Done,
     /* 315942 */ // Label 6497: @315942
     /* 315942 */ GIM_Reject,
     /* 315943 */ // Label 6485: @315943
     /* 315943 */ GIM_Reject,
     /* 315944 */ // Label 79: @315944
     /* 315944 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6506*/ GIMT_Encode4(316347),
     /* 315955 */ /*GILLT_s32*//*Label 6498*/ GIMT_Encode4(315995),
     /* 315959 */ /*GILLT_s64*//*Label 6499*/ GIMT_Encode4(316069), GIMT_Encode4(0),
     /* 315967 */ /*GILLT_v2s32*//*Label 6500*/ GIMT_Encode4(316143), GIMT_Encode4(0),
     /* 315975 */ /*GILLT_v4s16*//*Label 6501*/ GIMT_Encode4(316177),
     /* 315979 */ /*GILLT_v4s32*//*Label 6502*/ GIMT_Encode4(316211),
     /* 315983 */ /*GILLT_v8s8*//*Label 6503*/ GIMT_Encode4(316245),
     /* 315987 */ /*GILLT_v8s16*//*Label 6504*/ GIMT_Encode4(316279),
     /* 315991 */ /*GILLT_v16s8*//*Label 6505*/ GIMT_Encode4(316313),
     /* 315995 */ // Label 6498: @315995
     /* 315995 */ GIM_Try, /*On fail goto*//*Label 6507*/ GIMT_Encode4(316068),
     /* 316000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 316003 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 316006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 316010 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 316014 */   GIM_Try, /*On fail goto*//*Label 6508*/ GIMT_Encode4(316048), // Rule ID 2323 //
     /* 316019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 316022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 316026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 316030 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_32b),
     /* 316034 */     // MIs[1] Operand 1
     /* 316034 */     // No operand predicates
     /* 316034 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 316036 */     // (umax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_uimm8_32b>>:$imm)  =>  (UMAXWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 316036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXWri),
     /* 316039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316041 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 316043 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 316046 */     GIR_RootConstrainSelectedInstOperands,
     /* 316047 */     // GIR_Coverage, 2323,
     /* 316047 */     GIR_EraseRootFromParent_Done,
     /* 316048 */   // Label 6508: @316048
     /* 316048 */   GIM_Try, /*On fail goto*//*Label 6509*/ GIMT_Encode4(316067), // Rule ID 2322 //
     /* 316053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 316056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 316060 */     // (umax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UMAXWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 316060 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXWrr),
     /* 316065 */     GIR_RootConstrainSelectedInstOperands,
     /* 316066 */     // GIR_Coverage, 2322,
     /* 316066 */     GIR_Done,
     /* 316067 */   // Label 6509: @316067
     /* 316067 */   GIM_Reject,
     /* 316068 */ // Label 6507: @316068
     /* 316068 */ GIM_Reject,
     /* 316069 */ // Label 6499: @316069
     /* 316069 */ GIM_Try, /*On fail goto*//*Label 6510*/ GIMT_Encode4(316142),
     /* 316074 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 316077 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 316080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 316084 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 316088 */   GIM_Try, /*On fail goto*//*Label 6511*/ GIMT_Encode4(316122), // Rule ID 2325 //
     /* 316093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 316096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 316100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 316104 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_64b),
     /* 316108 */     // MIs[1] Operand 1
     /* 316108 */     // No operand predicates
     /* 316108 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 316110 */     // (umax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_uimm8_64b>>:$imm)  =>  (UMAXXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 316110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXXri),
     /* 316113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316115 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 316117 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 316120 */     GIR_RootConstrainSelectedInstOperands,
     /* 316121 */     // GIR_Coverage, 2325,
     /* 316121 */     GIR_EraseRootFromParent_Done,
     /* 316122 */   // Label 6511: @316122
     /* 316122 */   GIM_Try, /*On fail goto*//*Label 6512*/ GIMT_Encode4(316141), // Rule ID 2324 //
     /* 316127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 316130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 316134 */     // (umax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMAXXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 316134 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXXrr),
     /* 316139 */     GIR_RootConstrainSelectedInstOperands,
     /* 316140 */     // GIR_Coverage, 2324,
     /* 316140 */     GIR_Done,
     /* 316141 */   // Label 6512: @316141
     /* 316141 */   GIM_Reject,
     /* 316142 */ // Label 6510: @316142
     /* 316142 */ GIM_Reject,
     /* 316143 */ // Label 6500: @316143
     /* 316143 */ GIM_Try, /*On fail goto*//*Label 6513*/ GIMT_Encode4(316176), // Rule ID 1518 //
     /* 316148 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 316154 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 316157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316161 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316165 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316169 */   // (umax:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMAXv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 316169 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv2i32),
     /* 316174 */   GIR_RootConstrainSelectedInstOperands,
     /* 316175 */   // GIR_Coverage, 1518,
     /* 316175 */   GIR_Done,
     /* 316176 */ // Label 6513: @316176
     /* 316176 */ GIM_Reject,
     /* 316177 */ // Label 6501: @316177
     /* 316177 */ GIM_Try, /*On fail goto*//*Label 6514*/ GIMT_Encode4(316210), // Rule ID 1516 //
     /* 316182 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316185 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 316188 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 316191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316195 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316199 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316203 */   // (umax:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMAXv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 316203 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv4i16),
     /* 316208 */   GIR_RootConstrainSelectedInstOperands,
     /* 316209 */   // GIR_Coverage, 1516,
     /* 316209 */   GIR_Done,
     /* 316210 */ // Label 6514: @316210
     /* 316210 */ GIM_Reject,
     /* 316211 */ // Label 6502: @316211
     /* 316211 */ GIM_Try, /*On fail goto*//*Label 6515*/ GIMT_Encode4(316244), // Rule ID 1519 //
     /* 316216 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 316222 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 316225 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316229 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316233 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316237 */   // (umax:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMAXv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 316237 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv4i32),
     /* 316242 */   GIR_RootConstrainSelectedInstOperands,
     /* 316243 */   // GIR_Coverage, 1519,
     /* 316243 */   GIR_Done,
     /* 316244 */ // Label 6515: @316244
     /* 316244 */ GIM_Reject,
     /* 316245 */ // Label 6503: @316245
     /* 316245 */ GIM_Try, /*On fail goto*//*Label 6516*/ GIMT_Encode4(316278), // Rule ID 1514 //
     /* 316250 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 316256 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 316259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316263 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316267 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316271 */   // (umax:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMAXv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 316271 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv8i8),
     /* 316276 */   GIR_RootConstrainSelectedInstOperands,
     /* 316277 */   // GIR_Coverage, 1514,
     /* 316277 */   GIR_Done,
     /* 316278 */ // Label 6516: @316278
     /* 316278 */ GIM_Reject,
     /* 316279 */ // Label 6504: @316279
     /* 316279 */ GIM_Try, /*On fail goto*//*Label 6517*/ GIMT_Encode4(316312), // Rule ID 1517 //
     /* 316284 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 316290 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 316293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316297 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316301 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316305 */   // (umax:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMAXv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 316305 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv8i16),
     /* 316310 */   GIR_RootConstrainSelectedInstOperands,
     /* 316311 */   // GIR_Coverage, 1517,
     /* 316311 */   GIR_Done,
     /* 316312 */ // Label 6517: @316312
     /* 316312 */ GIM_Reject,
     /* 316313 */ // Label 6505: @316313
     /* 316313 */ GIM_Try, /*On fail goto*//*Label 6518*/ GIMT_Encode4(316346), // Rule ID 1515 //
     /* 316318 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316321 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 316324 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 316327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316331 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316335 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316339 */   // (umax:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMAXv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 316339 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv16i8),
     /* 316344 */   GIR_RootConstrainSelectedInstOperands,
     /* 316345 */   // GIR_Coverage, 1515,
     /* 316345 */   GIR_Done,
     /* 316346 */ // Label 6518: @316346
     /* 316346 */ GIM_Reject,
     /* 316347 */ // Label 6506: @316347
     /* 316347 */ GIM_Reject,
     /* 316348 */ // Label 80: @316348
     /* 316348 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6528*/ GIMT_Encode4(317162),
     /* 316359 */ /*GILLT_s32*//*Label 6519*/ GIMT_Encode4(316399),
     /* 316363 */ /*GILLT_s64*//*Label 6520*/ GIMT_Encode4(316426), GIMT_Encode4(0),
     /* 316371 */ /*GILLT_v2s32*//*Label 6521*/ GIMT_Encode4(316505),
     /* 316375 */ /*GILLT_v2s64*//*Label 6522*/ GIMT_Encode4(316532),
     /* 316379 */ /*GILLT_v4s16*//*Label 6523*/ GIMT_Encode4(316715),
     /* 316383 */ /*GILLT_v4s32*//*Label 6524*/ GIMT_Encode4(316742),
     /* 316387 */ /*GILLT_v8s8*//*Label 6525*/ GIMT_Encode4(316925),
     /* 316391 */ /*GILLT_v8s16*//*Label 6526*/ GIMT_Encode4(316952),
     /* 316395 */ /*GILLT_v16s8*//*Label 6527*/ GIMT_Encode4(317135),
     /* 316399 */ // Label 6519: @316399
     /* 316399 */ GIM_Try, /*On fail goto*//*Label 6529*/ GIMT_Encode4(316425), // Rule ID 2308 //
     /* 316404 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 316407 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 316410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 316414 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 316418 */   // (abs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (ABSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 316418 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSWr),
     /* 316423 */   GIR_RootConstrainSelectedInstOperands,
     /* 316424 */   // GIR_Coverage, 2308,
     /* 316424 */   GIR_Done,
     /* 316425 */ // Label 6529: @316425
     /* 316425 */ GIM_Reject,
     /* 316426 */ // Label 6520: @316426
     /* 316426 */ GIM_Try, /*On fail goto*//*Label 6530*/ GIMT_Encode4(316504),
     /* 316431 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 316434 */   GIM_Try, /*On fail goto*//*Label 6531*/ GIMT_Encode4(316457), // Rule ID 1645 //
     /* 316439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316446 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316450 */     // (abs:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)  =>  (ABSv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 316450 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv1i64),
     /* 316455 */     GIR_RootConstrainSelectedInstOperands,
     /* 316456 */     // GIR_Coverage, 1645,
     /* 316456 */     GIR_Done,
     /* 316457 */   // Label 6531: @316457
     /* 316457 */   GIM_Try, /*On fail goto*//*Label 6532*/ GIMT_Encode4(316480), // Rule ID 2309 //
     /* 316462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 316465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 316469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 316473 */     // (abs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (ABSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 316473 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSXr),
     /* 316478 */     GIR_RootConstrainSelectedInstOperands,
     /* 316479 */     // GIR_Coverage, 2309,
     /* 316479 */     GIR_Done,
     /* 316480 */   // Label 6532: @316480
     /* 316480 */   GIM_Try, /*On fail goto*//*Label 6533*/ GIMT_Encode4(316503), // Rule ID 2505 //
     /* 316485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoCSSC),
     /* 316488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316492 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316496 */     // (abs:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)  =>  (ABSv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /* 316496 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv1i64),
     /* 316501 */     GIR_RootConstrainSelectedInstOperands,
     /* 316502 */     // GIR_Coverage, 2505,
     /* 316502 */     GIR_Done,
     /* 316503 */   // Label 6533: @316503
     /* 316503 */   GIM_Reject,
     /* 316504 */ // Label 6530: @316504
     /* 316504 */ GIM_Reject,
     /* 316505 */ // Label 6521: @316505
     /* 316505 */ GIM_Try, /*On fail goto*//*Label 6534*/ GIMT_Encode4(316531), // Rule ID 707 //
     /* 316510 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316513 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 316516 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316520 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316524 */   // (abs:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (ABSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 316524 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv2i32),
     /* 316529 */   GIR_RootConstrainSelectedInstOperands,
     /* 316530 */   // GIR_Coverage, 707,
     /* 316530 */   GIR_Done,
     /* 316531 */ // Label 6534: @316531
     /* 316531 */ GIM_Reject,
     /* 316532 */ // Label 6522: @316532
     /* 316532 */ GIM_Try, /*On fail goto*//*Label 6535*/ GIMT_Encode4(316714),
     /* 316537 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316544 */   GIM_Try, /*On fail goto*//*Label 6536*/ GIMT_Encode4(316622), // Rule ID 4829 //
     /* 316549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 316557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316561 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 316565 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 316569 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 316573 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 316577 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 316581 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 316585 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 316589 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 316591 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 316598 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 316605 */     // (abs:{ *:[v2i64] } (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$opA)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$opB))))  =>  (UABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$opA, V128:{ *:[v4i32] }:$opB)
     /* 316605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i32_v2i64),
     /* 316608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
     /* 316615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
     /* 316620 */     GIR_RootConstrainSelectedInstOperands,
     /* 316621 */     // GIR_Coverage, 4829,
     /* 316621 */     GIR_EraseRootFromParent_Done,
     /* 316622 */   // Label 6536: @316622
     /* 316622 */   GIM_Try, /*On fail goto*//*Label 6537*/ GIMT_Encode4(316694), // Rule ID 4828 //
     /* 316627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 316635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316639 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 316643 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 316647 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 316651 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 316655 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316660 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 316664 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 316668 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 316672 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316677 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 316679 */     // (abs:{ *:[v2i64] } (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$opA), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$opB)))  =>  (UABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$opA, V64:{ *:[v2i32] }:$opB)
     /* 316679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv2i32_v2i64),
     /* 316682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
     /* 316688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
     /* 316692 */     GIR_RootConstrainSelectedInstOperands,
     /* 316693 */     // GIR_Coverage, 4828,
     /* 316693 */     GIR_EraseRootFromParent_Done,
     /* 316694 */   // Label 6537: @316694
     /* 316694 */   GIM_Try, /*On fail goto*//*Label 6538*/ GIMT_Encode4(316713), // Rule ID 709 //
     /* 316699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316702 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316706 */     // (abs:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)  =>  (ABSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 316706 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv2i64),
     /* 316711 */     GIR_RootConstrainSelectedInstOperands,
     /* 316712 */     // GIR_Coverage, 709,
     /* 316712 */     GIR_Done,
     /* 316713 */   // Label 6538: @316713
     /* 316713 */   GIM_Reject,
     /* 316714 */ // Label 6535: @316714
     /* 316714 */ GIM_Reject,
     /* 316715 */ // Label 6523: @316715
     /* 316715 */ GIM_Try, /*On fail goto*//*Label 6539*/ GIMT_Encode4(316741), // Rule ID 705 //
     /* 316720 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 316726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316730 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316734 */   // (abs:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (ABSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 316734 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv4i16),
     /* 316739 */   GIR_RootConstrainSelectedInstOperands,
     /* 316740 */   // GIR_Coverage, 705,
     /* 316740 */   GIR_Done,
     /* 316741 */ // Label 6539: @316741
     /* 316741 */ GIM_Reject,
     /* 316742 */ // Label 6524: @316742
     /* 316742 */ GIM_Try, /*On fail goto*//*Label 6540*/ GIMT_Encode4(316924),
     /* 316747 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 316750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316754 */   GIM_Try, /*On fail goto*//*Label 6541*/ GIMT_Encode4(316832), // Rule ID 4827 //
     /* 316759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 316767 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 316771 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 316775 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 316779 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 316783 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 316787 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 316791 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 316795 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 316799 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 316801 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 316808 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 316815 */     // (abs:{ *:[v4i32] } (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$opA)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$opB))))  =>  (UABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$opA, V128:{ *:[v8i16] }:$opB)
     /* 316815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i16_v4i32),
     /* 316818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
     /* 316825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
     /* 316830 */     GIR_RootConstrainSelectedInstOperands,
     /* 316831 */     // GIR_Coverage, 4827,
     /* 316831 */     GIR_EraseRootFromParent_Done,
     /* 316832 */   // Label 6541: @316832
     /* 316832 */   GIM_Try, /*On fail goto*//*Label 6542*/ GIMT_Encode4(316904), // Rule ID 4826 //
     /* 316837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 316845 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 316849 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 316853 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 316857 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 316861 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 316865 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316870 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 316874 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 316878 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 316882 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316887 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 316889 */     // (abs:{ *:[v4i32] } (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$opA), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$opB)))  =>  (UABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$opA, V64:{ *:[v4i16] }:$opB)
     /* 316889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i16_v4i32),
     /* 316892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
     /* 316898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
     /* 316902 */     GIR_RootConstrainSelectedInstOperands,
     /* 316903 */     // GIR_Coverage, 4826,
     /* 316903 */     GIR_EraseRootFromParent_Done,
     /* 316904 */   // Label 6542: @316904
     /* 316904 */   GIM_Try, /*On fail goto*//*Label 6543*/ GIMT_Encode4(316923), // Rule ID 708 //
     /* 316909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316916 */     // (abs:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (ABSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 316916 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv4i32),
     /* 316921 */     GIR_RootConstrainSelectedInstOperands,
     /* 316922 */     // GIR_Coverage, 708,
     /* 316922 */     GIR_Done,
     /* 316923 */   // Label 6543: @316923
     /* 316923 */   GIM_Reject,
     /* 316924 */ // Label 6540: @316924
     /* 316924 */ GIM_Reject,
     /* 316925 */ // Label 6525: @316925
     /* 316925 */ GIM_Try, /*On fail goto*//*Label 6544*/ GIMT_Encode4(316951), // Rule ID 703 //
     /* 316930 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316933 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 316936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316940 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316944 */   // (abs:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (ABSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 316944 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv8i8),
     /* 316949 */   GIR_RootConstrainSelectedInstOperands,
     /* 316950 */   // GIR_Coverage, 703,
     /* 316950 */   GIR_Done,
     /* 316951 */ // Label 6544: @316951
     /* 316951 */ GIM_Reject,
     /* 316952 */ // Label 6526: @316952
     /* 316952 */ GIM_Try, /*On fail goto*//*Label 6545*/ GIMT_Encode4(317134),
     /* 316957 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 316960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316964 */   GIM_Try, /*On fail goto*//*Label 6546*/ GIMT_Encode4(317042), // Rule ID 4825 //
     /* 316969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 316977 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 316981 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 316985 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 316989 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 316993 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 316997 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 317001 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 317005 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 317009 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317011 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 317018 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 317025 */     // (abs:{ *:[v8i16] } (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$opA)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$opB))))  =>  (UABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$opA, V128:{ *:[v16i8] }:$opB)
     /* 317025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv16i8_v8i16),
     /* 317028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
     /* 317035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
     /* 317040 */     GIR_RootConstrainSelectedInstOperands,
     /* 317041 */     // GIR_Coverage, 4825,
     /* 317041 */     GIR_EraseRootFromParent_Done,
     /* 317042 */   // Label 6546: @317042
     /* 317042 */   GIM_Try, /*On fail goto*//*Label 6547*/ GIMT_Encode4(317114), // Rule ID 4824 //
     /* 317047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 317055 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 317059 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 317063 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 317067 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 317071 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 317075 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317080 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 317084 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 317088 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 317092 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317097 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317099 */     // (abs:{ *:[v8i16] } (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$opA), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$opB)))  =>  (UABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$opA, V64:{ *:[v8i8] }:$opB)
     /* 317099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i8_v8i16),
     /* 317102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
     /* 317108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
     /* 317112 */     GIR_RootConstrainSelectedInstOperands,
     /* 317113 */     // GIR_Coverage, 4824,
     /* 317113 */     GIR_EraseRootFromParent_Done,
     /* 317114 */   // Label 6547: @317114
     /* 317114 */   GIM_Try, /*On fail goto*//*Label 6548*/ GIMT_Encode4(317133), // Rule ID 706 //
     /* 317119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317122 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317126 */     // (abs:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (ABSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 317126 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv8i16),
     /* 317131 */     GIR_RootConstrainSelectedInstOperands,
     /* 317132 */     // GIR_Coverage, 706,
     /* 317132 */     GIR_Done,
     /* 317133 */   // Label 6548: @317133
     /* 317133 */   GIM_Reject,
     /* 317134 */ // Label 6545: @317134
     /* 317134 */ GIM_Reject,
     /* 317135 */ // Label 6527: @317135
     /* 317135 */ GIM_Try, /*On fail goto*//*Label 6549*/ GIMT_Encode4(317161), // Rule ID 704 //
     /* 317140 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 317146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317150 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317154 */   // (abs:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (ABSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 317154 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv16i8),
     /* 317159 */   GIR_RootConstrainSelectedInstOperands,
     /* 317160 */   // GIR_Coverage, 704,
     /* 317160 */   GIR_Done,
     /* 317161 */ // Label 6549: @317161
     /* 317161 */ GIM_Reject,
     /* 317162 */ // Label 6528: @317162
     /* 317162 */ GIM_Reject,
     /* 317163 */ // Label 81: @317163
     /* 317163 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 6552*/ GIMT_Encode4(317328),
     /* 317174 */ /*GILLT_s32*//*Label 6550*/ GIMT_Encode4(317182),
     /* 317178 */ /*GILLT_s64*//*Label 6551*/ GIMT_Encode4(317255),
     /* 317182 */ // Label 6550: @317182
     /* 317182 */ GIM_Try, /*On fail goto*//*Label 6553*/ GIMT_Encode4(317208), // Rule ID 4670 //
     /* 317187 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 317190 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 317193 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 317197 */   // (lround:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
     /* 317197 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWHr),
     /* 317202 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317206 */   GIR_RootConstrainSelectedInstOperands,
     /* 317207 */   // GIR_Coverage, 4670,
     /* 317207 */   GIR_Done,
     /* 317208 */ // Label 6553: @317208
     /* 317208 */ GIM_Try, /*On fail goto*//*Label 6554*/ GIMT_Encode4(317231), // Rule ID 4676 //
     /* 317213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 317220 */   // (lround:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 317220 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
     /* 317225 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317229 */   GIR_RootConstrainSelectedInstOperands,
     /* 317230 */   // GIR_Coverage, 4676,
     /* 317230 */   GIR_Done,
     /* 317231 */ // Label 6554: @317231
     /* 317231 */ GIM_Try, /*On fail goto*//*Label 6555*/ GIMT_Encode4(317254), // Rule ID 4678 //
     /* 317236 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 317239 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 317243 */   // (lround:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 317243 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
     /* 317248 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317252 */   GIR_RootConstrainSelectedInstOperands,
     /* 317253 */   // GIR_Coverage, 4678,
     /* 317253 */   GIR_Done,
     /* 317254 */ // Label 6555: @317254
     /* 317254 */ GIM_Reject,
     /* 317255 */ // Label 6551: @317255
     /* 317255 */ GIM_Try, /*On fail goto*//*Label 6556*/ GIMT_Encode4(317281), // Rule ID 4672 //
     /* 317260 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 317263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 317266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 317270 */   // (lround:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 317270 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
     /* 317275 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317279 */   GIR_RootConstrainSelectedInstOperands,
     /* 317280 */   // GIR_Coverage, 4672,
     /* 317280 */   GIR_Done,
     /* 317281 */ // Label 6556: @317281
     /* 317281 */ GIM_Try, /*On fail goto*//*Label 6557*/ GIMT_Encode4(317304), // Rule ID 4680 //
     /* 317286 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317289 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 317293 */   // (lround:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 317293 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 317298 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317302 */   GIR_RootConstrainSelectedInstOperands,
     /* 317303 */   // GIR_Coverage, 4680,
     /* 317303 */   GIR_Done,
     /* 317304 */ // Label 6557: @317304
     /* 317304 */ GIM_Try, /*On fail goto*//*Label 6558*/ GIMT_Encode4(317327), // Rule ID 4682 //
     /* 317309 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 317312 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 317316 */   // (lround:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 317316 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 317321 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317325 */   GIR_RootConstrainSelectedInstOperands,
     /* 317326 */   // GIR_Coverage, 4682,
     /* 317326 */   GIR_Done,
     /* 317327 */ // Label 6558: @317327
     /* 317327 */ GIM_Reject,
     /* 317328 */ // Label 6552: @317328
     /* 317328 */ GIM_Reject,
     /* 317329 */ // Label 82: @317329
     /* 317329 */ GIM_Try, /*On fail goto*//*Label 6559*/ GIMT_Encode4(317427),
     /* 317334 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 317337 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 6563*/ GIMT_Encode4(317426),
     /* 317348 */   /*GILLT_s16*//*Label 6560*/ GIMT_Encode4(317360),
     /* 317352 */   /*GILLT_s32*//*Label 6561*/ GIMT_Encode4(317384),
     /* 317356 */   /*GILLT_s64*//*Label 6562*/ GIMT_Encode4(317405),
     /* 317360 */   // Label 6560: @317360
     /* 317360 */   GIM_Try, /*On fail goto*//*Label 6564*/ GIMT_Encode4(317383), // Rule ID 4674 //
     /* 317365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 317368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 317372 */     // (llround:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 317372 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
     /* 317377 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317381 */     GIR_RootConstrainSelectedInstOperands,
     /* 317382 */     // GIR_Coverage, 4674,
     /* 317382 */     GIR_Done,
     /* 317383 */   // Label 6564: @317383
     /* 317383 */   GIM_Reject,
     /* 317384 */   // Label 6561: @317384
     /* 317384 */   GIM_Try, /*On fail goto*//*Label 6565*/ GIMT_Encode4(317404), // Rule ID 4684 //
     /* 317389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 317393 */     // (llround:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 317393 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 317398 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317402 */     GIR_RootConstrainSelectedInstOperands,
     /* 317403 */     // GIR_Coverage, 4684,
     /* 317403 */     GIR_Done,
     /* 317404 */   // Label 6565: @317404
     /* 317404 */   GIM_Reject,
     /* 317405 */   // Label 6562: @317405
     /* 317405 */   GIM_Try, /*On fail goto*//*Label 6566*/ GIMT_Encode4(317425), // Rule ID 4686 //
     /* 317410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 317414 */     // (llround:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 317414 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 317419 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317423 */     GIR_RootConstrainSelectedInstOperands,
     /* 317424 */     // GIR_Coverage, 4686,
     /* 317424 */     GIR_Done,
     /* 317425 */   // Label 6566: @317425
     /* 317425 */   GIM_Reject,
     /* 317426 */   // Label 6563: @317426
     /* 317426 */   GIM_Reject,
     /* 317427 */ // Label 6559: @317427
     /* 317427 */ GIM_Reject,
     /* 317428 */ // Label 83: @317428
     /* 317428 */ GIM_Try, /*On fail goto*//*Label 6567*/ GIMT_Encode4(317443), // Rule ID 225 //
     /* 317433 */   // MIs[0] addr
     /* 317433 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
     /* 317436 */   // (br (bb:{ *:[Other] }):$addr)  =>  (B (bb:{ *:[Other] }):$addr)
     /* 317436 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::B),
     /* 317441 */   GIR_RootConstrainSelectedInstOperands,
     /* 317442 */   // GIR_Coverage, 225,
     /* 317442 */   GIR_Done,
     /* 317443 */ // Label 6567: @317443
     /* 317443 */ GIM_Reject,
     /* 317444 */ // Label 84: @317444
     /* 317444 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(21), /*)*//*default:*//*Label 6579*/ GIMT_Encode4(322455),
     /* 317455 */ /*GILLT_s64*//*Label 6568*/ GIMT_Encode4(317527), GIMT_Encode4(0),
     /* 317463 */ /*GILLT_v2s32*//*Label 6569*/ GIMT_Encode4(317809), GIMT_Encode4(0),
     /* 317471 */ /*GILLT_v4s16*//*Label 6570*/ GIMT_Encode4(318091), GIMT_Encode4(0),
     /* 317479 */ /*GILLT_v8s8*//*Label 6571*/ GIMT_Encode4(318373), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 317491 */ /*GILLT_nxv1s1*//*Label 6572*/ GIMT_Encode4(318553),
     /* 317495 */ /*GILLT_nxv2s1*//*Label 6573*/ GIMT_Encode4(320816),
     /* 317499 */ /*GILLT_nxv2s16*//*Label 6574*/ GIMT_Encode4(321671),
     /* 317503 */ /*GILLT_nxv2s32*//*Label 6575*/ GIMT_Encode4(321958), GIMT_Encode4(0),
     /* 317511 */ /*GILLT_nxv4s1*//*Label 6576*/ GIMT_Encode4(322028),
     /* 317515 */ /*GILLT_nxv4s16*//*Label 6577*/ GIMT_Encode4(322315), GIMT_Encode4(0),
     /* 317523 */ /*GILLT_nxv8s1*//*Label 6578*/ GIMT_Encode4(322385),
     /* 317527 */ // Label 6568: @317527
     /* 317527 */ GIM_Try, /*On fail goto*//*Label 6580*/ GIMT_Encode4(317808),
     /* 317532 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317535 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317539 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317543 */   GIM_Try, /*On fail goto*//*Label 6581*/ GIMT_Encode4(317607), // Rule ID 5395 //
     /* 317548 */     // MIs[0] Operand 2
     /* 317548 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 317559 */     // (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 317559 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 317562 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 317566 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317571 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 317575 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 317579 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 317582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 317584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317589 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 317596 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317601 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317606 */     // GIR_Coverage, 5395,
     /* 317606 */     GIR_EraseRootFromParent_Done,
     /* 317607 */   // Label 6581: @317607
     /* 317607 */   GIM_Try, /*On fail goto*//*Label 6582*/ GIMT_Encode4(317671), // Rule ID 5400 //
     /* 317612 */     // MIs[0] Operand 2
     /* 317612 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 317623 */     // (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 317623 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 317626 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 317630 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317635 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 317639 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 317643 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 317646 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 317648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317653 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 317660 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317665 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317670 */     // GIR_Coverage, 5400,
     /* 317670 */     GIR_EraseRootFromParent_Done,
     /* 317671 */   // Label 6582: @317671
     /* 317671 */   GIM_Try, /*On fail goto*//*Label 6583*/ GIMT_Encode4(317709), // Rule ID 6799 //
     /* 317676 */     // MIs[0] Operand 2
     /* 317676 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 317687 */     // (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] })
     /* 317687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317692 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 317698 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317703 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317708 */     // GIR_Coverage, 6799,
     /* 317708 */     GIR_EraseRootFromParent_Done,
     /* 317709 */   // Label 6583: @317709
     /* 317709 */   GIM_Try, /*On fail goto*//*Label 6584*/ GIMT_Encode4(317747), // Rule ID 6800 //
     /* 317714 */     // MIs[0] Operand 2
     /* 317714 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 317725 */     // (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] })
     /* 317725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317730 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 317736 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317741 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317746 */     // GIR_Coverage, 6800,
     /* 317746 */     GIR_EraseRootFromParent_Done,
     /* 317747 */   // Label 6584: @317747
     /* 317747 */   GIM_Try, /*On fail goto*//*Label 6585*/ GIMT_Encode4(317807), // Rule ID 6804 //
     /* 317752 */     // MIs[0] Operand 2
     /* 317752 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 317763 */     // (extract_subvector:{ *:[v1i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 317763 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 317766 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 317770 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317775 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 317779 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 317782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 317784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317789 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 317796 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317801 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317806 */     // GIR_Coverage, 6804,
     /* 317806 */     GIR_EraseRootFromParent_Done,
     /* 317807 */   // Label 6585: @317807
     /* 317807 */   GIM_Reject,
     /* 317808 */ // Label 6580: @317808
     /* 317808 */ GIM_Reject,
     /* 317809 */ // Label 6569: @317809
     /* 317809 */ GIM_Try, /*On fail goto*//*Label 6586*/ GIMT_Encode4(318090),
     /* 317814 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 317817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317821 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317825 */   GIM_Try, /*On fail goto*//*Label 6587*/ GIMT_Encode4(317889), // Rule ID 5385 //
     /* 317830 */     // MIs[0] Operand 2
     /* 317830 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 317841 */     // (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 317841 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 317844 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 317848 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317853 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 317857 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 317861 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 317864 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 317866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317871 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 317878 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317883 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317888 */     // GIR_Coverage, 5385,
     /* 317888 */     GIR_EraseRootFromParent_Done,
     /* 317889 */   // Label 6587: @317889
     /* 317889 */   GIM_Try, /*On fail goto*//*Label 6588*/ GIMT_Encode4(317953), // Rule ID 5390 //
     /* 317894 */     // MIs[0] Operand 2
     /* 317894 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 317905 */     // (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 317905 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 317908 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 317912 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317917 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 317921 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 317925 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 317928 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 317930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317935 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 317942 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317947 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317952 */     // GIR_Coverage, 5390,
     /* 317952 */     GIR_EraseRootFromParent_Done,
     /* 317953 */   // Label 6588: @317953
     /* 317953 */   GIM_Try, /*On fail goto*//*Label 6589*/ GIMT_Encode4(317991), // Rule ID 6796 //
     /* 317958 */     // MIs[0] Operand 2
     /* 317958 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 317969 */     // (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] })
     /* 317969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317974 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 317980 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317985 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317990 */     // GIR_Coverage, 6796,
     /* 317990 */     GIR_EraseRootFromParent_Done,
     /* 317991 */   // Label 6589: @317991
     /* 317991 */   GIM_Try, /*On fail goto*//*Label 6590*/ GIMT_Encode4(318029), // Rule ID 6798 //
     /* 317996 */     // MIs[0] Operand 2
     /* 317996 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 318007 */     // (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] })
     /* 318007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318012 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 318018 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318023 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318028 */     // GIR_Coverage, 6798,
     /* 318028 */     GIR_EraseRootFromParent_Done,
     /* 318029 */   // Label 6590: @318029
     /* 318029 */   GIM_Try, /*On fail goto*//*Label 6591*/ GIMT_Encode4(318089), // Rule ID 6803 //
     /* 318034 */     // MIs[0] Operand 2
     /* 318034 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 318045 */     // (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 318045 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 318048 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 318052 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318057 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 318061 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 318064 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 318066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318071 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 318078 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318083 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318088 */     // GIR_Coverage, 6803,
     /* 318088 */     GIR_EraseRootFromParent_Done,
     /* 318089 */   // Label 6591: @318089
     /* 318089 */   GIM_Reject,
     /* 318090 */ // Label 6586: @318090
     /* 318090 */ GIM_Reject,
     /* 318091 */ // Label 6570: @318091
     /* 318091 */ GIM_Try, /*On fail goto*//*Label 6592*/ GIMT_Encode4(318372),
     /* 318096 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 318099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318103 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318107 */   GIM_Try, /*On fail goto*//*Label 6593*/ GIMT_Encode4(318171), // Rule ID 5375 //
     /* 318112 */     // MIs[0] Operand 2
     /* 318112 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 318123 */     // (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 318123 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 318126 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 318130 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318135 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 318139 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 318143 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 318146 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 318148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318153 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 318160 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318165 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318170 */     // GIR_Coverage, 5375,
     /* 318170 */     GIR_EraseRootFromParent_Done,
     /* 318171 */   // Label 6593: @318171
     /* 318171 */   GIM_Try, /*On fail goto*//*Label 6594*/ GIMT_Encode4(318235), // Rule ID 5380 //
     /* 318176 */     // MIs[0] Operand 2
     /* 318176 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 318187 */     // (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 318187 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 318190 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 318194 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318199 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 318203 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 318207 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 318210 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 318212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318217 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 318224 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318229 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318234 */     // GIR_Coverage, 5380,
     /* 318234 */     GIR_EraseRootFromParent_Done,
     /* 318235 */   // Label 6594: @318235
     /* 318235 */   GIM_Try, /*On fail goto*//*Label 6595*/ GIMT_Encode4(318273), // Rule ID 6794 //
     /* 318240 */     // MIs[0] Operand 2
     /* 318240 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 318251 */     // (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] })
     /* 318251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318256 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 318262 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318267 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318272 */     // GIR_Coverage, 6794,
     /* 318272 */     GIR_EraseRootFromParent_Done,
     /* 318273 */   // Label 6595: @318273
     /* 318273 */   GIM_Try, /*On fail goto*//*Label 6596*/ GIMT_Encode4(318311), // Rule ID 6797 //
     /* 318278 */     // MIs[0] Operand 2
     /* 318278 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 318289 */     // (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })
     /* 318289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318294 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 318300 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318305 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318310 */     // GIR_Coverage, 6797,
     /* 318310 */     GIR_EraseRootFromParent_Done,
     /* 318311 */   // Label 6596: @318311
     /* 318311 */   GIM_Try, /*On fail goto*//*Label 6597*/ GIMT_Encode4(318371), // Rule ID 6802 //
     /* 318316 */     // MIs[0] Operand 2
     /* 318316 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 318327 */     // (extract_subvector:{ *:[v4i16] } FPR128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 318327 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 318330 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 318334 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318339 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 318343 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 318346 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 318348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318353 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 318360 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318365 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318370 */     // GIR_Coverage, 6802,
     /* 318370 */     GIR_EraseRootFromParent_Done,
     /* 318371 */   // Label 6597: @318371
     /* 318371 */   GIM_Reject,
     /* 318372 */ // Label 6592: @318372
     /* 318372 */ GIM_Reject,
     /* 318373 */ // Label 6571: @318373
     /* 318373 */ GIM_Try, /*On fail goto*//*Label 6598*/ GIMT_Encode4(318552),
     /* 318378 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 318381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318385 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318389 */   GIM_Try, /*On fail goto*//*Label 6599*/ GIMT_Encode4(318453), // Rule ID 5370 //
     /* 318394 */     // MIs[0] Operand 2
     /* 318394 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 318405 */     // (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (EXTv16i8:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 318405 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 318408 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 318412 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318417 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 318421 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 318425 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 318428 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 318430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318435 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 318442 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318447 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318452 */     // GIR_Coverage, 5370,
     /* 318452 */     GIR_EraseRootFromParent_Done,
     /* 318453 */   // Label 6599: @318453
     /* 318453 */   GIM_Try, /*On fail goto*//*Label 6600*/ GIMT_Encode4(318491), // Rule ID 6795 //
     /* 318458 */     // MIs[0] Operand 2
     /* 318458 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 318469 */     // (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] })
     /* 318469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318474 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 318480 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318485 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318490 */     // GIR_Coverage, 6795,
     /* 318490 */     GIR_EraseRootFromParent_Done,
     /* 318491 */   // Label 6600: @318491
     /* 318491 */   GIM_Try, /*On fail goto*//*Label 6601*/ GIMT_Encode4(318551), // Rule ID 6801 //
     /* 318496 */     // MIs[0] Operand 2
     /* 318496 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 318507 */     // (extract_subvector:{ *:[v8i8] } FPR128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 318507 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 318510 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 318514 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318519 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 318523 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 318526 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 318528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318533 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 318540 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318545 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318550 */     // GIR_Coverage, 6801,
     /* 318550 */     GIR_EraseRootFromParent_Done,
     /* 318551 */   // Label 6601: @318551
     /* 318551 */   GIM_Reject,
     /* 318552 */ // Label 6598: @318552
     /* 318552 */ GIM_Reject,
     /* 318553 */ // Label 6572: @318553
     /* 318553 */ GIM_Try, /*On fail goto*//*Label 6602*/ GIMT_Encode4(318588), // Rule ID 8817 //
     /* 318558 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 318561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 318564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 318568 */   // MIs[0] Operand 2
     /* 318568 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 318579 */   // (extract_subvector:{ *:[nxv1i1] } nxv2i1:{ *:[nxv2i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv2i1] }:$Ps)
     /* 318579 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 318582 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 318584 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 318586 */   GIR_RootConstrainSelectedInstOperands,
     /* 318587 */   // GIR_Coverage, 8817,
     /* 318587 */   GIR_EraseRootFromParent_Done,
     /* 318588 */ // Label 6602: @318588
     /* 318588 */ GIM_Try, /*On fail goto*//*Label 6603*/ GIMT_Encode4(318623), // Rule ID 8818 //
     /* 318593 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 318596 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 318599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 318603 */   // MIs[0] Operand 2
     /* 318603 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 318614 */   // (extract_subvector:{ *:[nxv1i1] } nxv2i1:{ *:[nxv2i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv2i1] }:$Ps)
     /* 318614 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 318617 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 318619 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 318621 */   GIR_RootConstrainSelectedInstOperands,
     /* 318622 */   // GIR_Coverage, 8818,
     /* 318622 */   GIR_EraseRootFromParent_Done,
     /* 318623 */ // Label 6603: @318623
     /* 318623 */ GIM_Try, /*On fail goto*//*Label 6604*/ GIMT_Encode4(318677), // Rule ID 8825 //
     /* 318628 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 318631 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 318634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 318638 */   // MIs[0] Operand 2
     /* 318638 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 318649 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 318649 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 318652 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 318656 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318661 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 318665 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 318667 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 318670 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 318672 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318675 */   GIR_RootConstrainSelectedInstOperands,
     /* 318676 */   // GIR_Coverage, 8825,
     /* 318676 */   GIR_EraseRootFromParent_Done,
     /* 318677 */ // Label 6604: @318677
     /* 318677 */ GIM_Try, /*On fail goto*//*Label 6605*/ GIMT_Encode4(318731), // Rule ID 8826 //
     /* 318682 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 318685 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 318688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 318692 */   // MIs[0] Operand 2
     /* 318692 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 318703 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 318703 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 318706 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 318710 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318715 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 318719 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 318721 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 318724 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 318726 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318729 */   GIR_RootConstrainSelectedInstOperands,
     /* 318730 */   // GIR_Coverage, 8826,
     /* 318730 */   GIR_EraseRootFromParent_Done,
     /* 318731 */ // Label 6605: @318731
     /* 318731 */ GIM_Try, /*On fail goto*//*Label 6606*/ GIMT_Encode4(318785), // Rule ID 8827 //
     /* 318736 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 318739 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 318742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 318746 */   // MIs[0] Operand 2
     /* 318746 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 318757 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 318757 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 318760 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 318764 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318769 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 318773 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 318775 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 318778 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 318780 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318783 */   GIR_RootConstrainSelectedInstOperands,
     /* 318784 */   // GIR_Coverage, 8827,
     /* 318784 */   GIR_EraseRootFromParent_Done,
     /* 318785 */ // Label 6606: @318785
     /* 318785 */ GIM_Try, /*On fail goto*//*Label 6607*/ GIMT_Encode4(318839), // Rule ID 8828 //
     /* 318790 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 318793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 318796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 318800 */   // MIs[0] Operand 2
     /* 318800 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
     /* 318811 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 318811 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 318814 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 318818 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318823 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 318827 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 318829 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 318832 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 318834 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318837 */   GIR_RootConstrainSelectedInstOperands,
     /* 318838 */   // GIR_Coverage, 8828,
     /* 318838 */   GIR_EraseRootFromParent_Done,
     /* 318839 */ // Label 6607: @318839
     /* 318839 */ GIM_Try, /*On fail goto*//*Label 6608*/ GIMT_Encode4(318910), // Rule ID 8837 //
     /* 318844 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 318847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 318850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 318854 */   // MIs[0] Operand 2
     /* 318854 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 318865 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 318865 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 318868 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 318872 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318877 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 318881 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 318883 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 318886 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 318890 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318895 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 318898 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 318900 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 318903 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 318905 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318908 */   GIR_RootConstrainSelectedInstOperands,
     /* 318909 */   // GIR_Coverage, 8837,
     /* 318909 */   GIR_EraseRootFromParent_Done,
     /* 318910 */ // Label 6608: @318910
     /* 318910 */ GIM_Try, /*On fail goto*//*Label 6609*/ GIMT_Encode4(318981), // Rule ID 8838 //
     /* 318915 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 318918 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 318921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 318925 */   // MIs[0] Operand 2
     /* 318925 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 318936 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 318936 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 318939 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 318943 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318948 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 318952 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 318954 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 318957 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 318961 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318966 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 318969 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 318971 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 318974 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 318976 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318979 */   GIR_RootConstrainSelectedInstOperands,
     /* 318980 */   // GIR_Coverage, 8838,
     /* 318980 */   GIR_EraseRootFromParent_Done,
     /* 318981 */ // Label 6609: @318981
     /* 318981 */ GIM_Try, /*On fail goto*//*Label 6610*/ GIMT_Encode4(319052), // Rule ID 8839 //
     /* 318986 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 318989 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 318992 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 318996 */   // MIs[0] Operand 2
     /* 318996 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 319007 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 319007 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 319010 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319014 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319019 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 319023 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319025 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 319028 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 319032 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319037 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319040 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 319042 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319045 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 319047 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319050 */   GIR_RootConstrainSelectedInstOperands,
     /* 319051 */   // GIR_Coverage, 8839,
     /* 319051 */   GIR_EraseRootFromParent_Done,
     /* 319052 */ // Label 6610: @319052
     /* 319052 */ GIM_Try, /*On fail goto*//*Label 6611*/ GIMT_Encode4(319123), // Rule ID 8840 //
     /* 319057 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 319060 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 319063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 319067 */   // MIs[0] Operand 2
     /* 319067 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
     /* 319078 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 319078 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 319081 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319085 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319090 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 319094 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319096 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 319099 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 319103 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319108 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319111 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 319113 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 319116 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 319118 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319121 */   GIR_RootConstrainSelectedInstOperands,
     /* 319122 */   // GIR_Coverage, 8840,
     /* 319122 */   GIR_EraseRootFromParent_Done,
     /* 319123 */ // Label 6611: @319123
     /* 319123 */ GIM_Try, /*On fail goto*//*Label 6612*/ GIMT_Encode4(319194), // Rule ID 8841 //
     /* 319128 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 319131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 319134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 319138 */   // MIs[0] Operand 2
     /* 319138 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 319149 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 319149 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 319152 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 319156 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319161 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 319165 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319167 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 319170 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319174 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319179 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319182 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 319184 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319187 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 319189 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319192 */   GIR_RootConstrainSelectedInstOperands,
     /* 319193 */   // GIR_Coverage, 8841,
     /* 319193 */   GIR_EraseRootFromParent_Done,
     /* 319194 */ // Label 6612: @319194
     /* 319194 */ GIM_Try, /*On fail goto*//*Label 6613*/ GIMT_Encode4(319265), // Rule ID 8842 //
     /* 319199 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 319202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 319205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 319209 */   // MIs[0] Operand 2
     /* 319209 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(5),
     /* 319220 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 5:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 319220 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 319223 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 319227 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319232 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 319236 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319238 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 319241 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319245 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319250 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319253 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 319255 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 319258 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 319260 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319263 */   GIR_RootConstrainSelectedInstOperands,
     /* 319264 */   // GIR_Coverage, 8842,
     /* 319264 */   GIR_EraseRootFromParent_Done,
     /* 319265 */ // Label 6613: @319265
     /* 319265 */ GIM_Try, /*On fail goto*//*Label 6614*/ GIMT_Encode4(319336), // Rule ID 8843 //
     /* 319270 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 319273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 319276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 319280 */   // MIs[0] Operand 2
     /* 319280 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 319291 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 319291 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 319294 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 319298 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319303 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 319307 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319309 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 319312 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 319316 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319321 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319324 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 319326 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319329 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 319331 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319334 */   GIR_RootConstrainSelectedInstOperands,
     /* 319335 */   // GIR_Coverage, 8843,
     /* 319335 */   GIR_EraseRootFromParent_Done,
     /* 319336 */ // Label 6614: @319336
     /* 319336 */ GIM_Try, /*On fail goto*//*Label 6615*/ GIMT_Encode4(319407), // Rule ID 8844 //
     /* 319341 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 319344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 319347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 319351 */   // MIs[0] Operand 2
     /* 319351 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 319362 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 7:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 319362 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 319365 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 319369 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319374 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 319378 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319380 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 319383 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 319387 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319392 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319395 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 319397 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 319400 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 319402 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319405 */   GIR_RootConstrainSelectedInstOperands,
     /* 319406 */   // GIR_Coverage, 8844,
     /* 319406 */   GIR_EraseRootFromParent_Done,
     /* 319407 */ // Label 6615: @319407
     /* 319407 */ GIM_Try, /*On fail goto*//*Label 6616*/ GIMT_Encode4(319495), // Rule ID 8853 //
     /* 319412 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 319415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 319418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 319422 */   // MIs[0] Operand 2
     /* 319422 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 319433 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 319433 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 319436 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319440 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319445 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 319449 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 319451 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 319454 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319458 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319463 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 319466 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319468 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 319471 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319475 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319480 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319483 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 319485 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319488 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 319490 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319493 */   GIR_RootConstrainSelectedInstOperands,
     /* 319494 */   // GIR_Coverage, 8853,
     /* 319494 */   GIR_EraseRootFromParent_Done,
     /* 319495 */ // Label 6616: @319495
     /* 319495 */ GIM_Try, /*On fail goto*//*Label 6617*/ GIMT_Encode4(319583), // Rule ID 8854 //
     /* 319500 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 319503 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 319506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 319510 */   // MIs[0] Operand 2
     /* 319510 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 319521 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 319521 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 319524 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319528 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319533 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 319537 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 319539 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 319542 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319546 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319551 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 319554 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319556 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 319559 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319563 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319568 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319571 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 319573 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 319576 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 319578 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319581 */   GIR_RootConstrainSelectedInstOperands,
     /* 319582 */   // GIR_Coverage, 8854,
     /* 319582 */   GIR_EraseRootFromParent_Done,
     /* 319583 */ // Label 6617: @319583
     /* 319583 */ GIM_Try, /*On fail goto*//*Label 6618*/ GIMT_Encode4(319671), // Rule ID 8855 //
     /* 319588 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 319591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 319594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 319598 */   // MIs[0] Operand 2
     /* 319598 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 319609 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 319609 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 319612 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319616 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319621 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 319625 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 319627 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 319630 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319634 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319639 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 319642 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319644 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 319647 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 319651 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319656 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319659 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 319661 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319664 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 319666 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319669 */   GIR_RootConstrainSelectedInstOperands,
     /* 319670 */   // GIR_Coverage, 8855,
     /* 319670 */   GIR_EraseRootFromParent_Done,
     /* 319671 */ // Label 6618: @319671
     /* 319671 */ GIM_Try, /*On fail goto*//*Label 6619*/ GIMT_Encode4(319759), // Rule ID 8856 //
     /* 319676 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 319679 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 319682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 319686 */   // MIs[0] Operand 2
     /* 319686 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
     /* 319697 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 319697 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 319700 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319704 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319709 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 319713 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 319715 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 319718 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319722 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319727 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 319730 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319732 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 319735 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 319739 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319744 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319747 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 319749 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 319752 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 319754 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319757 */   GIR_RootConstrainSelectedInstOperands,
     /* 319758 */   // GIR_Coverage, 8856,
     /* 319758 */   GIR_EraseRootFromParent_Done,
     /* 319759 */ // Label 6619: @319759
     /* 319759 */ GIM_Try, /*On fail goto*//*Label 6620*/ GIMT_Encode4(319847), // Rule ID 8857 //
     /* 319764 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 319767 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 319770 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 319774 */   // MIs[0] Operand 2
     /* 319774 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 319785 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 319785 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 319788 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319792 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319797 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 319801 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 319803 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 319806 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 319810 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319815 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 319818 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319820 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 319823 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319827 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319832 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319835 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 319837 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319840 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 319842 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319845 */   GIR_RootConstrainSelectedInstOperands,
     /* 319846 */   // GIR_Coverage, 8857,
     /* 319846 */   GIR_EraseRootFromParent_Done,
     /* 319847 */ // Label 6620: @319847
     /* 319847 */ GIM_Try, /*On fail goto*//*Label 6621*/ GIMT_Encode4(319935), // Rule ID 8858 //
     /* 319852 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 319855 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 319858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 319862 */   // MIs[0] Operand 2
     /* 319862 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(5),
     /* 319873 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 5:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 319873 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 319876 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319880 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319885 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 319889 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 319891 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 319894 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 319898 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319903 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 319906 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319908 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 319911 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319915 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319920 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319923 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 319925 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 319928 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 319930 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319933 */   GIR_RootConstrainSelectedInstOperands,
     /* 319934 */   // GIR_Coverage, 8858,
     /* 319934 */   GIR_EraseRootFromParent_Done,
     /* 319935 */ // Label 6621: @319935
     /* 319935 */ GIM_Try, /*On fail goto*//*Label 6622*/ GIMT_Encode4(320023), // Rule ID 8859 //
     /* 319940 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 319943 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 319946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 319950 */   // MIs[0] Operand 2
     /* 319950 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 319961 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 319961 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 319964 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 319968 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319973 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 319977 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 319979 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 319982 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 319986 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319991 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 319994 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319996 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 319999 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320003 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320008 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 320011 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 320013 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 320016 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 320018 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320021 */   GIR_RootConstrainSelectedInstOperands,
     /* 320022 */   // GIR_Coverage, 8859,
     /* 320022 */   GIR_EraseRootFromParent_Done,
     /* 320023 */ // Label 6622: @320023
     /* 320023 */ GIM_Try, /*On fail goto*//*Label 6623*/ GIMT_Encode4(320111), // Rule ID 8860 //
     /* 320028 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 320031 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 320034 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 320038 */   // MIs[0] Operand 2
     /* 320038 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 320049 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 7:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 320049 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 320052 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 320056 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320061 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 320065 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 320067 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 320070 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320074 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320079 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 320082 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 320084 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 320087 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320091 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320096 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 320099 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 320101 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320104 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 320106 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320109 */   GIR_RootConstrainSelectedInstOperands,
     /* 320110 */   // GIR_Coverage, 8860,
     /* 320110 */   GIR_EraseRootFromParent_Done,
     /* 320111 */ // Label 6623: @320111
     /* 320111 */ GIM_Try, /*On fail goto*//*Label 6624*/ GIMT_Encode4(320199), // Rule ID 8861 //
     /* 320116 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 320119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 320122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 320126 */   // MIs[0] Operand 2
     /* 320126 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 320137 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 320137 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 320140 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320144 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320149 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 320153 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 320155 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 320158 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 320162 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320167 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 320170 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 320172 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 320175 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 320179 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320184 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 320187 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 320189 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 320192 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 320194 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320197 */   GIR_RootConstrainSelectedInstOperands,
     /* 320198 */   // GIR_Coverage, 8861,
     /* 320198 */   GIR_EraseRootFromParent_Done,
     /* 320199 */ // Label 6624: @320199
     /* 320199 */ GIM_Try, /*On fail goto*//*Label 6625*/ GIMT_Encode4(320287), // Rule ID 8862 //
     /* 320204 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 320207 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 320210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 320214 */   // MIs[0] Operand 2
     /* 320214 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(9),
     /* 320225 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 9:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 320225 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 320228 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320232 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320237 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 320241 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 320243 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 320246 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 320250 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320255 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 320258 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 320260 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 320263 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 320267 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320272 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 320275 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 320277 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320280 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 320282 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320285 */   GIR_RootConstrainSelectedInstOperands,
     /* 320286 */   // GIR_Coverage, 8862,
     /* 320286 */   GIR_EraseRootFromParent_Done,
     /* 320287 */ // Label 6625: @320287
     /* 320287 */ GIM_Try, /*On fail goto*//*Label 6626*/ GIMT_Encode4(320375), // Rule ID 8863 //
     /* 320292 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 320295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 320298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 320302 */   // MIs[0] Operand 2
     /* 320302 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(10),
     /* 320313 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 10:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 320313 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 320316 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320320 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320325 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 320329 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 320331 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 320334 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 320338 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320343 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 320346 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 320348 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 320351 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320355 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320360 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 320363 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 320365 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 320368 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 320370 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320373 */   GIR_RootConstrainSelectedInstOperands,
     /* 320374 */   // GIR_Coverage, 8863,
     /* 320374 */   GIR_EraseRootFromParent_Done,
     /* 320375 */ // Label 6626: @320375
     /* 320375 */ GIM_Try, /*On fail goto*//*Label 6627*/ GIMT_Encode4(320463), // Rule ID 8864 //
     /* 320380 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 320383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 320386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 320390 */   // MIs[0] Operand 2
     /* 320390 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(11),
     /* 320401 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 11:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 320401 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 320404 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320408 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320413 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 320417 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 320419 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 320422 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 320426 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320431 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 320434 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 320436 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 320439 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320443 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320448 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 320451 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 320453 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320456 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 320458 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320461 */   GIR_RootConstrainSelectedInstOperands,
     /* 320462 */   // GIR_Coverage, 8864,
     /* 320462 */   GIR_EraseRootFromParent_Done,
     /* 320463 */ // Label 6627: @320463
     /* 320463 */ GIM_Try, /*On fail goto*//*Label 6628*/ GIMT_Encode4(320551), // Rule ID 8865 //
     /* 320468 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 320471 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 320474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 320478 */   // MIs[0] Operand 2
     /* 320478 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
     /* 320489 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 320489 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 320492 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320496 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320501 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 320505 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 320507 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 320510 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320514 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320519 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 320522 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 320524 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 320527 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 320531 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320536 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 320539 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 320541 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 320544 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 320546 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320549 */   GIR_RootConstrainSelectedInstOperands,
     /* 320550 */   // GIR_Coverage, 8865,
     /* 320550 */   GIR_EraseRootFromParent_Done,
     /* 320551 */ // Label 6628: @320551
     /* 320551 */ GIM_Try, /*On fail goto*//*Label 6629*/ GIMT_Encode4(320639), // Rule ID 8866 //
     /* 320556 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 320559 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 320562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 320566 */   // MIs[0] Operand 2
     /* 320566 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(13),
     /* 320577 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 13:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 320577 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 320580 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320584 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320589 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 320593 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 320595 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 320598 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320602 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320607 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 320610 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 320612 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 320615 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 320619 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320624 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 320627 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 320629 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320632 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 320634 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320637 */   GIR_RootConstrainSelectedInstOperands,
     /* 320638 */   // GIR_Coverage, 8866,
     /* 320638 */   GIR_EraseRootFromParent_Done,
     /* 320639 */ // Label 6629: @320639
     /* 320639 */ GIM_Try, /*On fail goto*//*Label 6630*/ GIMT_Encode4(320727), // Rule ID 8867 //
     /* 320644 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 320647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 320650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 320654 */   // MIs[0] Operand 2
     /* 320654 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(14),
     /* 320665 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 14:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 320665 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 320668 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320672 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320677 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 320681 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 320683 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 320686 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320690 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320695 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 320698 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 320700 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 320703 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320707 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320712 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 320715 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 320717 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 320720 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 320722 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320725 */   GIR_RootConstrainSelectedInstOperands,
     /* 320726 */   // GIR_Coverage, 8867,
     /* 320726 */   GIR_EraseRootFromParent_Done,
     /* 320727 */ // Label 6630: @320727
     /* 320727 */ GIM_Try, /*On fail goto*//*Label 6631*/ GIMT_Encode4(320815), // Rule ID 8868 //
     /* 320732 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 320735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 320738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 320742 */   // MIs[0] Operand 2
     /* 320742 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
     /* 320753 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 15:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 320753 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 320756 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320760 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320765 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 320769 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 320771 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 320774 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320778 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320783 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 320786 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 320788 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 320791 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320795 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320800 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 320803 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 320805 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320808 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 320810 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320813 */   GIR_RootConstrainSelectedInstOperands,
     /* 320814 */   // GIR_Coverage, 8868,
     /* 320814 */   GIR_EraseRootFromParent_Done,
     /* 320815 */ // Label 6631: @320815
     /* 320815 */ GIM_Reject,
     /* 320816 */ // Label 6573: @320816
     /* 320816 */ GIM_Try, /*On fail goto*//*Label 6632*/ GIMT_Encode4(320851), // Rule ID 8819 //
     /* 320821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 320824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 320827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 320831 */   // MIs[0] Operand 2
     /* 320831 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 320842 */   // (extract_subvector:{ *:[nxv2i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } PPR:{ *:[nxv4i1] }:$Ps)
     /* 320842 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 320845 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 320847 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 320849 */   GIR_RootConstrainSelectedInstOperands,
     /* 320850 */   // GIR_Coverage, 8819,
     /* 320850 */   GIR_EraseRootFromParent_Done,
     /* 320851 */ // Label 6632: @320851
     /* 320851 */ GIM_Try, /*On fail goto*//*Label 6633*/ GIMT_Encode4(320886), // Rule ID 8820 //
     /* 320856 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 320859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 320862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 320866 */   // MIs[0] Operand 2
     /* 320866 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 320877 */   // (extract_subvector:{ *:[nxv2i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } PPR:{ *:[nxv4i1] }:$Ps)
     /* 320877 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320880 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 320882 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 320884 */   GIR_RootConstrainSelectedInstOperands,
     /* 320885 */   // GIR_Coverage, 8820,
     /* 320885 */   GIR_EraseRootFromParent_Done,
     /* 320886 */ // Label 6633: @320886
     /* 320886 */ GIM_Try, /*On fail goto*//*Label 6634*/ GIMT_Encode4(320940), // Rule ID 8829 //
     /* 320891 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 320894 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 320897 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 320901 */   // MIs[0] Operand 2
     /* 320901 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 320912 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 320912 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 320915 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 320919 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320924 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 320928 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 320930 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 320933 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 320935 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320938 */   GIR_RootConstrainSelectedInstOperands,
     /* 320939 */   // GIR_Coverage, 8829,
     /* 320939 */   GIR_EraseRootFromParent_Done,
     /* 320940 */ // Label 6634: @320940
     /* 320940 */ GIM_Try, /*On fail goto*//*Label 6635*/ GIMT_Encode4(320994), // Rule ID 8830 //
     /* 320945 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 320948 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 320951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 320955 */   // MIs[0] Operand 2
     /* 320955 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 320966 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 320966 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 320969 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 320973 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320978 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 320982 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 320984 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 320987 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 320989 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320992 */   GIR_RootConstrainSelectedInstOperands,
     /* 320993 */   // GIR_Coverage, 8830,
     /* 320993 */   GIR_EraseRootFromParent_Done,
     /* 320994 */ // Label 6635: @320994
     /* 320994 */ GIM_Try, /*On fail goto*//*Label 6636*/ GIMT_Encode4(321048), // Rule ID 8831 //
     /* 320999 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 321002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 321005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 321009 */   // MIs[0] Operand 2
     /* 321009 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 321020 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 321020 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 321023 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 321027 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321032 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 321036 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 321038 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 321041 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 321043 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321046 */   GIR_RootConstrainSelectedInstOperands,
     /* 321047 */   // GIR_Coverage, 8831,
     /* 321047 */   GIR_EraseRootFromParent_Done,
     /* 321048 */ // Label 6636: @321048
     /* 321048 */ GIM_Try, /*On fail goto*//*Label 6637*/ GIMT_Encode4(321102), // Rule ID 8832 //
     /* 321053 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 321056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 321059 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 321063 */   // MIs[0] Operand 2
     /* 321063 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 321074 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 321074 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 321077 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 321081 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321086 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 321090 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 321092 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 321095 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 321097 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321100 */   GIR_RootConstrainSelectedInstOperands,
     /* 321101 */   // GIR_Coverage, 8832,
     /* 321101 */   GIR_EraseRootFromParent_Done,
     /* 321102 */ // Label 6637: @321102
     /* 321102 */ GIM_Try, /*On fail goto*//*Label 6638*/ GIMT_Encode4(321173), // Rule ID 8845 //
     /* 321107 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 321110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 321113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 321117 */   // MIs[0] Operand 2
     /* 321117 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 321128 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 321128 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 321131 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 321135 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321140 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 321144 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 321146 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 321149 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 321153 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321158 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 321161 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 321163 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 321166 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 321168 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321171 */   GIR_RootConstrainSelectedInstOperands,
     /* 321172 */   // GIR_Coverage, 8845,
     /* 321172 */   GIR_EraseRootFromParent_Done,
     /* 321173 */ // Label 6638: @321173
     /* 321173 */ GIM_Try, /*On fail goto*//*Label 6639*/ GIMT_Encode4(321244), // Rule ID 8846 //
     /* 321178 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 321181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 321184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 321188 */   // MIs[0] Operand 2
     /* 321188 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 321199 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 321199 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 321202 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 321206 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321211 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 321215 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 321217 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 321220 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 321224 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321229 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 321232 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 321234 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 321237 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 321239 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321242 */   GIR_RootConstrainSelectedInstOperands,
     /* 321243 */   // GIR_Coverage, 8846,
     /* 321243 */   GIR_EraseRootFromParent_Done,
     /* 321244 */ // Label 6639: @321244
     /* 321244 */ GIM_Try, /*On fail goto*//*Label 6640*/ GIMT_Encode4(321315), // Rule ID 8847 //
     /* 321249 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 321252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 321255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 321259 */   // MIs[0] Operand 2
     /* 321259 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 321270 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 321270 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 321273 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 321277 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321282 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 321286 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 321288 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 321291 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 321295 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321300 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 321303 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 321305 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 321308 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 321310 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321313 */   GIR_RootConstrainSelectedInstOperands,
     /* 321314 */   // GIR_Coverage, 8847,
     /* 321314 */   GIR_EraseRootFromParent_Done,
     /* 321315 */ // Label 6640: @321315
     /* 321315 */ GIM_Try, /*On fail goto*//*Label 6641*/ GIMT_Encode4(321386), // Rule ID 8848 //
     /* 321320 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 321323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 321326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 321330 */   // MIs[0] Operand 2
     /* 321330 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 321341 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 321341 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 321344 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 321348 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321353 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 321357 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 321359 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 321362 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 321366 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321371 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 321374 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 321376 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 321379 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 321381 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321384 */   GIR_RootConstrainSelectedInstOperands,
     /* 321385 */   // GIR_Coverage, 8848,
     /* 321385 */   GIR_EraseRootFromParent_Done,
     /* 321386 */ // Label 6641: @321386
     /* 321386 */ GIM_Try, /*On fail goto*//*Label 6642*/ GIMT_Encode4(321457), // Rule ID 8849 //
     /* 321391 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 321394 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 321397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 321401 */   // MIs[0] Operand 2
     /* 321401 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 321412 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 321412 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 321415 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 321419 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321424 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 321428 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 321430 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 321433 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 321437 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321442 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 321445 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 321447 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 321450 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 321452 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321455 */   GIR_RootConstrainSelectedInstOperands,
     /* 321456 */   // GIR_Coverage, 8849,
     /* 321456 */   GIR_EraseRootFromParent_Done,
     /* 321457 */ // Label 6642: @321457
     /* 321457 */ GIM_Try, /*On fail goto*//*Label 6643*/ GIMT_Encode4(321528), // Rule ID 8850 //
     /* 321462 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 321465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 321468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 321472 */   // MIs[0] Operand 2
     /* 321472 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(10),
     /* 321483 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 10:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 321483 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 321486 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 321490 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321495 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 321499 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 321501 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 321504 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 321508 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321513 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 321516 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 321518 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 321521 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 321523 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321526 */   GIR_RootConstrainSelectedInstOperands,
     /* 321527 */   // GIR_Coverage, 8850,
     /* 321527 */   GIR_EraseRootFromParent_Done,
     /* 321528 */ // Label 6643: @321528
     /* 321528 */ GIM_Try, /*On fail goto*//*Label 6644*/ GIMT_Encode4(321599), // Rule ID 8851 //
     /* 321533 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 321536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 321539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 321543 */   // MIs[0] Operand 2
     /* 321543 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
     /* 321554 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 321554 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 321557 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 321561 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321566 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 321570 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 321572 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 321575 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 321579 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321584 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 321587 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 321589 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 321592 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 321594 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321597 */   GIR_RootConstrainSelectedInstOperands,
     /* 321598 */   // GIR_Coverage, 8851,
     /* 321598 */   GIR_EraseRootFromParent_Done,
     /* 321599 */ // Label 6644: @321599
     /* 321599 */ GIM_Try, /*On fail goto*//*Label 6645*/ GIMT_Encode4(321670), // Rule ID 8852 //
     /* 321604 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 321607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 321610 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 321614 */   // MIs[0] Operand 2
     /* 321614 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(14),
     /* 321625 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 14:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 321625 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 321628 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 321632 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321637 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 321641 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 321643 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 321646 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 321650 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321655 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 321658 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 321660 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 321663 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 321665 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321668 */   GIR_RootConstrainSelectedInstOperands,
     /* 321669 */   // GIR_Coverage, 8852,
     /* 321669 */   GIR_EraseRootFromParent_Done,
     /* 321670 */ // Label 6645: @321670
     /* 321670 */ GIM_Reject,
     /* 321671 */ // Label 6574: @321671
     /* 321671 */ GIM_Try, /*On fail goto*//*Label 6646*/ GIMT_Encode4(321706), // Rule ID 8869 //
     /* 321676 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 321679 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 321682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 321686 */   // MIs[0] Operand 2
     /* 321686 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 321697 */   // (extract_subvector:{ *:[nxv2f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$Zs)
     /* 321697 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 321700 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 321702 */   GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 321704 */   GIR_RootConstrainSelectedInstOperands,
     /* 321705 */   // GIR_Coverage, 8869,
     /* 321705 */   GIR_EraseRootFromParent_Done,
     /* 321706 */ // Label 6646: @321706
     /* 321706 */ GIM_Try, /*On fail goto*//*Label 6647*/ GIMT_Encode4(321741), // Rule ID 8870 //
     /* 321711 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 321714 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 321717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 321721 */   // MIs[0] Operand 2
     /* 321721 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 321732 */   // (extract_subvector:{ *:[nxv2f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$Zs)
     /* 321732 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 321735 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 321737 */   GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 321739 */   GIR_RootConstrainSelectedInstOperands,
     /* 321740 */   // GIR_Coverage, 8870,
     /* 321740 */   GIR_EraseRootFromParent_Done,
     /* 321741 */ // Label 6647: @321741
     /* 321741 */ GIM_Try, /*On fail goto*//*Label 6648*/ GIMT_Encode4(321795), // Rule ID 8875 //
     /* 321746 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 321749 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 321752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 321756 */   // MIs[0] Operand 2
     /* 321756 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 321767 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } (UUNPKLO_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 321767 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 321770 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
     /* 321774 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321779 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 321783 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 321785 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 321788 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 321790 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321793 */   GIR_RootConstrainSelectedInstOperands,
     /* 321794 */   // GIR_Coverage, 8875,
     /* 321794 */   GIR_EraseRootFromParent_Done,
     /* 321795 */ // Label 6648: @321795
     /* 321795 */ GIM_Try, /*On fail goto*//*Label 6649*/ GIMT_Encode4(321849), // Rule ID 8876 //
     /* 321800 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 321803 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 321806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 321810 */   // MIs[0] Operand 2
     /* 321810 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 321821 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } (UUNPKLO_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 321821 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 321824 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
     /* 321828 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321833 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 321837 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 321839 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 321842 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 321844 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321847 */   GIR_RootConstrainSelectedInstOperands,
     /* 321848 */   // GIR_Coverage, 8876,
     /* 321848 */   GIR_EraseRootFromParent_Done,
     /* 321849 */ // Label 6649: @321849
     /* 321849 */ GIM_Try, /*On fail goto*//*Label 6650*/ GIMT_Encode4(321903), // Rule ID 8877 //
     /* 321854 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 321857 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 321860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 321864 */   // MIs[0] Operand 2
     /* 321864 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 321875 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 4:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } (UUNPKHI_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 321875 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 321878 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
     /* 321882 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321887 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 321891 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 321893 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 321896 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 321898 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321901 */   GIR_RootConstrainSelectedInstOperands,
     /* 321902 */   // GIR_Coverage, 8877,
     /* 321902 */   GIR_EraseRootFromParent_Done,
     /* 321903 */ // Label 6650: @321903
     /* 321903 */ GIM_Try, /*On fail goto*//*Label 6651*/ GIMT_Encode4(321957), // Rule ID 8878 //
     /* 321908 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 321911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 321914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 321918 */   // MIs[0] Operand 2
     /* 321918 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 321929 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 6:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } (UUNPKHI_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 321929 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 321932 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
     /* 321936 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321941 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 321945 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 321947 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 321950 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 321952 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321955 */   GIR_RootConstrainSelectedInstOperands,
     /* 321956 */   // GIR_Coverage, 8878,
     /* 321956 */   GIR_EraseRootFromParent_Done,
     /* 321957 */ // Label 6651: @321957
     /* 321957 */ GIM_Reject,
     /* 321958 */ // Label 6575: @321958
     /* 321958 */ GIM_Try, /*On fail goto*//*Label 6652*/ GIMT_Encode4(322027),
     /* 321963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 321966 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 321970 */   GIM_Try, /*On fail goto*//*Label 6653*/ GIMT_Encode4(321998), // Rule ID 8873 //
     /* 321975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 321978 */     // MIs[0] Operand 2
     /* 321978 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 321989 */     // (extract_subvector:{ *:[nxv2f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$Zs)
     /* 321989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 321992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 321994 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 321996 */     GIR_RootConstrainSelectedInstOperands,
     /* 321997 */     // GIR_Coverage, 8873,
     /* 321997 */     GIR_EraseRootFromParent_Done,
     /* 321998 */   // Label 6653: @321998
     /* 321998 */   GIM_Try, /*On fail goto*//*Label 6654*/ GIMT_Encode4(322026), // Rule ID 8874 //
     /* 322003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 322006 */     // MIs[0] Operand 2
     /* 322006 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 322017 */     // (extract_subvector:{ *:[nxv2f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$Zs)
     /* 322017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 322020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 322022 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 322024 */     GIR_RootConstrainSelectedInstOperands,
     /* 322025 */     // GIR_Coverage, 8874,
     /* 322025 */     GIR_EraseRootFromParent_Done,
     /* 322026 */   // Label 6654: @322026
     /* 322026 */   GIM_Reject,
     /* 322027 */ // Label 6652: @322027
     /* 322027 */ GIM_Reject,
     /* 322028 */ // Label 6576: @322028
     /* 322028 */ GIM_Try, /*On fail goto*//*Label 6655*/ GIMT_Encode4(322063), // Rule ID 8821 //
     /* 322033 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 322036 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 322039 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 322043 */   // MIs[0] Operand 2
     /* 322043 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 322054 */   // (extract_subvector:{ *:[nxv4i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } PPR:{ *:[nxv8i1] }:$Ps)
     /* 322054 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 322057 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 322059 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 322061 */   GIR_RootConstrainSelectedInstOperands,
     /* 322062 */   // GIR_Coverage, 8821,
     /* 322062 */   GIR_EraseRootFromParent_Done,
     /* 322063 */ // Label 6655: @322063
     /* 322063 */ GIM_Try, /*On fail goto*//*Label 6656*/ GIMT_Encode4(322098), // Rule ID 8822 //
     /* 322068 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 322071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 322074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 322078 */   // MIs[0] Operand 2
     /* 322078 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 322089 */   // (extract_subvector:{ *:[nxv4i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } PPR:{ *:[nxv8i1] }:$Ps)
     /* 322089 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 322092 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 322094 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 322096 */   GIR_RootConstrainSelectedInstOperands,
     /* 322097 */   // GIR_Coverage, 8822,
     /* 322097 */   GIR_EraseRootFromParent_Done,
     /* 322098 */ // Label 6656: @322098
     /* 322098 */ GIM_Try, /*On fail goto*//*Label 6657*/ GIMT_Encode4(322152), // Rule ID 8833 //
     /* 322103 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 322106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 322109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 322113 */   // MIs[0] Operand 2
     /* 322113 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 322124 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 322124 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 322127 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 322131 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322136 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 322140 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 322142 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 322145 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 322147 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322150 */   GIR_RootConstrainSelectedInstOperands,
     /* 322151 */   // GIR_Coverage, 8833,
     /* 322151 */   GIR_EraseRootFromParent_Done,
     /* 322152 */ // Label 6657: @322152
     /* 322152 */ GIM_Try, /*On fail goto*//*Label 6658*/ GIMT_Encode4(322206), // Rule ID 8834 //
     /* 322157 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 322160 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 322163 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 322167 */   // MIs[0] Operand 2
     /* 322167 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 322178 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 322178 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 322181 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 322185 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322190 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 322194 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 322196 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 322199 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 322201 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322204 */   GIR_RootConstrainSelectedInstOperands,
     /* 322205 */   // GIR_Coverage, 8834,
     /* 322205 */   GIR_EraseRootFromParent_Done,
     /* 322206 */ // Label 6658: @322206
     /* 322206 */ GIM_Try, /*On fail goto*//*Label 6659*/ GIMT_Encode4(322260), // Rule ID 8835 //
     /* 322211 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 322214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 322217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 322221 */   // MIs[0] Operand 2
     /* 322221 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 322232 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 322232 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 322235 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 322239 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322244 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 322248 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 322250 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 322253 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 322255 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322258 */   GIR_RootConstrainSelectedInstOperands,
     /* 322259 */   // GIR_Coverage, 8835,
     /* 322259 */   GIR_EraseRootFromParent_Done,
     /* 322260 */ // Label 6659: @322260
     /* 322260 */ GIM_Try, /*On fail goto*//*Label 6660*/ GIMT_Encode4(322314), // Rule ID 8836 //
     /* 322265 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 322268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 322271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 322275 */   // MIs[0] Operand 2
     /* 322275 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
     /* 322286 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 322286 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 322289 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 322293 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322298 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 322302 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 322304 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 322307 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 322309 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322312 */   GIR_RootConstrainSelectedInstOperands,
     /* 322313 */   // GIR_Coverage, 8836,
     /* 322313 */   GIR_EraseRootFromParent_Done,
     /* 322314 */ // Label 6660: @322314
     /* 322314 */ GIM_Reject,
     /* 322315 */ // Label 6577: @322315
     /* 322315 */ GIM_Try, /*On fail goto*//*Label 6661*/ GIMT_Encode4(322384),
     /* 322320 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 322323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 322327 */   GIM_Try, /*On fail goto*//*Label 6662*/ GIMT_Encode4(322355), // Rule ID 8871 //
     /* 322332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 322335 */     // MIs[0] Operand 2
     /* 322335 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 322346 */     // (extract_subvector:{ *:[nxv4f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_S:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$Zs)
     /* 322346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
     /* 322349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 322351 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 322353 */     GIR_RootConstrainSelectedInstOperands,
     /* 322354 */     // GIR_Coverage, 8871,
     /* 322354 */     GIR_EraseRootFromParent_Done,
     /* 322355 */   // Label 6662: @322355
     /* 322355 */   GIM_Try, /*On fail goto*//*Label 6663*/ GIMT_Encode4(322383), // Rule ID 8872 //
     /* 322360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 322363 */     // MIs[0] Operand 2
     /* 322363 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 322374 */     // (extract_subvector:{ *:[nxv4f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 4:{ *:[i64] })  =>  (UUNPKHI_ZZ_S:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$Zs)
     /* 322374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
     /* 322377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 322379 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 322381 */     GIR_RootConstrainSelectedInstOperands,
     /* 322382 */     // GIR_Coverage, 8872,
     /* 322382 */     GIR_EraseRootFromParent_Done,
     /* 322383 */   // Label 6663: @322383
     /* 322383 */   GIM_Reject,
     /* 322384 */ // Label 6661: @322384
     /* 322384 */ GIM_Reject,
     /* 322385 */ // Label 6578: @322385
     /* 322385 */ GIM_Try, /*On fail goto*//*Label 6664*/ GIMT_Encode4(322454),
     /* 322390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 322393 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 322397 */   GIM_Try, /*On fail goto*//*Label 6665*/ GIMT_Encode4(322425), // Rule ID 8823 //
     /* 322402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 322405 */     // MIs[0] Operand 2
     /* 322405 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 322416 */     // (extract_subvector:{ *:[nxv8i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv8i1] } PPR:{ *:[nxv16i1] }:$Ps)
     /* 322416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 322419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 322421 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 322423 */     GIR_RootConstrainSelectedInstOperands,
     /* 322424 */     // GIR_Coverage, 8823,
     /* 322424 */     GIR_EraseRootFromParent_Done,
     /* 322425 */   // Label 6665: @322425
     /* 322425 */   GIM_Try, /*On fail goto*//*Label 6666*/ GIMT_Encode4(322453), // Rule ID 8824 //
     /* 322430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 322433 */     // MIs[0] Operand 2
     /* 322433 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 322444 */     // (extract_subvector:{ *:[nxv8i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv8i1] } PPR:{ *:[nxv16i1] }:$Ps)
     /* 322444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 322447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 322449 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 322451 */     GIR_RootConstrainSelectedInstOperands,
     /* 322452 */     // GIR_Coverage, 8824,
     /* 322452 */     GIR_EraseRootFromParent_Done,
     /* 322453 */   // Label 6666: @322453
     /* 322453 */   GIM_Reject,
     /* 322454 */ // Label 6664: @322454
     /* 322454 */ GIM_Reject,
     /* 322455 */ // Label 6579: @322455
     /* 322455 */ GIM_Reject,
     /* 322456 */ // Label 85: @322456
     /* 322456 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 6682*/ GIMT_Encode4(349852),
     /* 322467 */ /*GILLT_s64*//*Label 6667*/ GIMT_Encode4(322551), GIMT_Encode4(0),
     /* 322475 */ /*GILLT_v2s32*//*Label 6668*/ GIMT_Encode4(323261),
     /* 322479 */ /*GILLT_v2s64*//*Label 6669*/ GIMT_Encode4(326792),
     /* 322483 */ /*GILLT_v4s16*//*Label 6670*/ GIMT_Encode4(329621),
     /* 322487 */ /*GILLT_v4s32*//*Label 6671*/ GIMT_Encode4(333261),
     /* 322491 */ /*GILLT_v8s8*//*Label 6672*/ GIMT_Encode4(335925),
     /* 322495 */ /*GILLT_v8s16*//*Label 6673*/ GIMT_Encode4(337769),
     /* 322499 */ /*GILLT_v16s8*//*Label 6674*/ GIMT_Encode4(340744), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 322511 */ /*GILLT_nxv2s16*//*Label 6675*/ GIMT_Encode4(342324),
     /* 322515 */ /*GILLT_nxv2s32*//*Label 6676*/ GIMT_Encode4(342449),
     /* 322519 */ /*GILLT_nxv2s64*//*Label 6677*/ GIMT_Encode4(342574), GIMT_Encode4(0),
     /* 322527 */ /*GILLT_nxv4s16*//*Label 6678*/ GIMT_Encode4(344488),
     /* 322531 */ /*GILLT_nxv4s32*//*Label 6679*/ GIMT_Encode4(344640), GIMT_Encode4(0),
     /* 322539 */ /*GILLT_nxv8s16*//*Label 6680*/ GIMT_Encode4(346608), GIMT_Encode4(0),
     /* 322547 */ /*GILLT_nxv16s8*//*Label 6681*/ GIMT_Encode4(348802),
     /* 322551 */ // Label 6667: @322551
     /* 322551 */ GIM_Try, /*On fail goto*//*Label 6683*/ GIMT_Encode4(323260),
     /* 322556 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 322559 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 322562 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 322565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322569 */   GIM_Try, /*On fail goto*//*Label 6684*/ GIMT_Encode4(322699), // Rule ID 5658 //
     /* 322574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 322582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 322586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 322590 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 322594 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322599 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 322603 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 322607 */     // MIs[2] Operand 1
     /* 322607 */     // No operand predicates
     /* 322607 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 322611 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 322615 */     // MIs[3] Operand 1
     /* 322615 */     // No operand predicates
     /* 322615 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 322617 */     // (vector_insert:{ *:[v1f64] } V64:{ *:[v1f64] }:$src, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 322617 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 322620 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 322624 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322629 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 322632 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 322636 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 322639 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322644 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322649 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 322652 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 322656 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322661 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 322664 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 322667 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 322671 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 322674 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 322676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 322679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322681 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 322688 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322693 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322698 */     // GIR_Coverage, 5658,
     /* 322698 */     GIR_EraseRootFromParent_Done,
     /* 322699 */   // Label 6684: @322699
     /* 322699 */   GIM_Try, /*On fail goto*//*Label 6685*/ GIMT_Encode4(322860), // Rule ID 5659 //
     /* 322704 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 322712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 322716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 322720 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 322724 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322729 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 322733 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 322737 */     // MIs[2] Operand 1
     /* 322737 */     // No operand predicates
     /* 322737 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 322741 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 322745 */     // MIs[3] Operand 1
     /* 322745 */     // No operand predicates
     /* 322745 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 322747 */     // (vector_insert:{ *:[v1f64] } V64:{ *:[v1f64] }:$src, (vector_extract:{ *:[f64] } V64:{ *:[v1f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 322747 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 322750 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 322754 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322759 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 322762 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 322766 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 322769 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322774 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322779 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 322782 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 322786 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322791 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 322794 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 322798 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 322801 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322806 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322811 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 322814 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 322818 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322823 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 322826 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 322829 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 322832 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 322835 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 322837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 322840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322842 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 322849 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322854 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322859 */     // GIR_Coverage, 5659,
     /* 322859 */     GIR_EraseRootFromParent_Done,
     /* 322860 */   // Label 6685: @322860
     /* 322860 */   GIM_Try, /*On fail goto*//*Label 6686*/ GIMT_Encode4(322990), // Rule ID 5682 //
     /* 322865 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 322873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 322877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 322881 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 322885 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322890 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 322894 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 322898 */     // MIs[2] Operand 1
     /* 322898 */     // No operand predicates
     /* 322898 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 322902 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 322906 */     // MIs[3] Operand 1
     /* 322906 */     // No operand predicates
     /* 322906 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 322908 */     // (vector_insert:{ *:[v1i64] } V64:{ *:[v1i64] }:$src, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 322908 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 322911 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 322915 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322920 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 322923 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 322927 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 322930 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322935 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322940 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 322943 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 322947 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322952 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 322955 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 322958 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 322962 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 322965 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 322967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 322970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322972 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 322979 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322984 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322989 */     // GIR_Coverage, 5682,
     /* 322989 */     GIR_EraseRootFromParent_Done,
     /* 322990 */   // Label 6686: @322990
     /* 322990 */   GIM_Try, /*On fail goto*//*Label 6687*/ GIMT_Encode4(323151), // Rule ID 5683 //
     /* 322995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 323003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 323007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 323011 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 323015 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323020 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 323024 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 323028 */     // MIs[2] Operand 1
     /* 323028 */     // No operand predicates
     /* 323028 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 323032 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 323036 */     // MIs[3] Operand 1
     /* 323036 */     // No operand predicates
     /* 323036 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 323038 */     // (vector_insert:{ *:[v1i64] } V64:{ *:[v1i64] }:$src, (vector_extract:{ *:[i64] } V64:{ *:[v1i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 323038 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 323041 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323045 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323050 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 323053 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 323057 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 323060 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323065 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323070 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 323073 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323077 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323082 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 323085 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 323089 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 323092 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323097 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323102 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 323105 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 323109 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323114 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 323117 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 323120 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 323123 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 323126 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 323128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 323131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323133 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 323140 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323145 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323150 */     // GIR_Coverage, 5683,
     /* 323150 */     GIR_EraseRootFromParent_Done,
     /* 323151 */   // Label 6687: @323151
     /* 323151 */   GIM_Try, /*On fail goto*//*Label 6688*/ GIMT_Encode4(323187), // Rule ID 6575 //
     /* 323156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 323164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 323168 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 323172 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 323174 */     // (vector_insert:{ *:[v1i64] } (undef:{ *:[v1i64] }), GPR64:{ *:[i64] }:$Xn, 0:{ *:[i64] })  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 323174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 323177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Xn
     /* 323181 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323186 */     // GIR_Coverage, 6575,
     /* 323186 */     GIR_EraseRootFromParent_Done,
     /* 323187 */   // Label 6688: @323187
     /* 323187 */   GIM_Try, /*On fail goto*//*Label 6689*/ GIMT_Encode4(323223), // Rule ID 6577 //
     /* 323192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 323200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 323204 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 323208 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 323210 */     // (vector_insert:{ *:[v1f64] } (undef:{ *:[v1f64] }), GPR64:{ *:[i64] }:$Xn, 0:{ *:[i64] })  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 323210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 323213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323215 */     GIR_RootToRootCopy, /*OpIdx*/2, // Xn
     /* 323217 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323222 */     // GIR_Coverage, 6577,
     /* 323222 */     GIR_EraseRootFromParent_Done,
     /* 323223 */   // Label 6689: @323223
     /* 323223 */   GIM_Try, /*On fail goto*//*Label 6690*/ GIMT_Encode4(323259), // Rule ID 6579 //
     /* 323228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 323236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323240 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 323244 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 323246 */     // (vector_insert:{ *:[v1f64] } (undef:{ *:[v1f64] }), FPR64:{ *:[f64] }:$Xn, 0:{ *:[i64] })  =>  FPR64:{ *:[v1f64] }:$Xn
     /* 323246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 323249 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 323251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Xn
     /* 323253 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323258 */     // GIR_Coverage, 6579,
     /* 323258 */     GIR_EraseRootFromParent_Done,
     /* 323259 */   // Label 6690: @323259
     /* 323259 */   GIM_Reject,
     /* 323260 */ // Label 6683: @323260
     /* 323260 */ GIM_Reject,
     /* 323261 */ // Label 6668: @323261
     /* 323261 */ GIM_Try, /*On fail goto*//*Label 6691*/ GIMT_Encode4(326791),
     /* 323266 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 323269 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 323272 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 323275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323279 */   GIM_Try, /*On fail goto*//*Label 6692*/ GIMT_Encode4(323388), // Rule ID 4214 //
     /* 323284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323288 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 323294 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 323296 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 323300 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 323304 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 323307 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 323311 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 323315 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 323319 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 323321 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 323328 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 323328 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 323331 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 323335 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 323345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 323350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 323355 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 323361 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 323363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323371 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 323377 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323382 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323387 */     // GIR_Coverage, 4214,
     /* 323387 */     GIR_EraseRootFromParent_Done,
     /* 323388 */   // Label 6692: @323388
     /* 323388 */   GIM_Try, /*On fail goto*//*Label 6693*/ GIMT_Encode4(323497), // Rule ID 4215 //
     /* 323393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323397 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 323403 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 323405 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 323409 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 323413 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 323416 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 323420 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 323424 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 323428 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 323430 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 323437 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 323437 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 323440 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 323444 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 323454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 323459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 323464 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 323470 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 323472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323480 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 323486 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323491 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323496 */     // GIR_Coverage, 4215,
     /* 323496 */     GIR_EraseRootFromParent_Done,
     /* 323497 */   // Label 6693: @323497
     /* 323497 */   GIM_Try, /*On fail goto*//*Label 6694*/ GIMT_Encode4(323606), // Rule ID 4322 //
     /* 323502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323506 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 323512 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 323514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 323518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 323522 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 323525 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 323529 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 323533 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 323537 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 323539 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 323546 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 323546 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 323549 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 323553 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 323563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 323568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 323573 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 323579 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 323581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 323595 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323600 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323605 */     // GIR_Coverage, 4322,
     /* 323605 */     GIR_EraseRootFromParent_Done,
     /* 323606 */   // Label 6694: @323606
     /* 323606 */   GIM_Try, /*On fail goto*//*Label 6695*/ GIMT_Encode4(323715), // Rule ID 4323 //
     /* 323611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323615 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 323621 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 323623 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 323627 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 323631 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 323634 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 323638 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 323642 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 323646 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 323648 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 323655 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 323655 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 323658 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 323662 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 323672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 323677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 323682 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 323688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 323690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323698 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 323704 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323709 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323714 */     // GIR_Coverage, 4323,
     /* 323714 */     GIR_EraseRootFromParent_Done,
     /* 323715 */   // Label 6695: @323715
     /* 323715 */   GIM_Try, /*On fail goto*//*Label 6696*/ GIMT_Encode4(323820), // Rule ID 4220 //
     /* 323720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 323728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 323732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 323736 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 323739 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 323743 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 323747 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 323751 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 323753 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 323760 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 323760 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 323763 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 323767 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 323777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 323782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 323787 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 323793 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 323795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323803 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 323809 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323814 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323819 */     // GIR_Coverage, 4220,
     /* 323819 */     GIR_EraseRootFromParent_Done,
     /* 323820 */   // Label 6696: @323820
     /* 323820 */   GIM_Try, /*On fail goto*//*Label 6697*/ GIMT_Encode4(323925), // Rule ID 4222 //
     /* 323825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 323833 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 323837 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 323841 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 323844 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 323848 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 323852 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 323856 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 323858 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 323865 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 323865 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 323868 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 323872 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 323882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 323887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 323892 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 323898 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 323900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323908 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 323914 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323919 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323924 */     // GIR_Coverage, 4222,
     /* 323924 */     GIR_EraseRootFromParent_Done,
     /* 323925 */   // Label 6697: @323925
     /* 323925 */   GIM_Try, /*On fail goto*//*Label 6698*/ GIMT_Encode4(324030), // Rule ID 4328 //
     /* 323930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 323938 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 323942 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 323946 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 323949 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 323953 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 323957 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 323961 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 323963 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 323970 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 323970 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 323973 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 323977 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 323987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 323992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 323997 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 324003 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 324005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 324008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 324019 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324024 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324029 */     // GIR_Coverage, 4328,
     /* 324029 */     GIR_EraseRootFromParent_Done,
     /* 324030 */   // Label 6698: @324030
     /* 324030 */   GIM_Try, /*On fail goto*//*Label 6699*/ GIMT_Encode4(324135), // Rule ID 4330 //
     /* 324035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 324043 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324047 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 324051 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 324054 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 324058 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 324062 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 324066 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324068 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 324075 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 324075 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 324078 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 324082 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 324092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 324097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 324102 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 324108 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 324110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 324113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324118 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 324124 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324129 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324134 */     // GIR_Coverage, 4330,
     /* 324134 */     GIR_EraseRootFromParent_Done,
     /* 324135 */   // Label 6699: @324135
     /* 324135 */   GIM_Try, /*On fail goto*//*Label 6700*/ GIMT_Encode4(324239), // Rule ID 4212 //
     /* 324140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324144 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 324150 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 324152 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324156 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 324160 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 324163 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 324167 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 324171 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 324175 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324177 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 324184 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 324184 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 324187 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 324191 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 324201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 324206 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 324212 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 324214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 324217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324222 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 324228 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324233 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324238 */     // GIR_Coverage, 4212,
     /* 324238 */     GIR_EraseRootFromParent_Done,
     /* 324239 */   // Label 6700: @324239
     /* 324239 */   GIM_Try, /*On fail goto*//*Label 6701*/ GIMT_Encode4(324343), // Rule ID 4213 //
     /* 324244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324248 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 324254 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 324256 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324260 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 324264 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 324267 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 324271 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 324275 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 324279 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324281 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 324288 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 324288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 324291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 324295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 324305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 324310 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 324316 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 324318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 324321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324326 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 324332 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324337 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324342 */     // GIR_Coverage, 4213,
     /* 324342 */     GIR_EraseRootFromParent_Done,
     /* 324343 */   // Label 6701: @324343
     /* 324343 */   GIM_Try, /*On fail goto*//*Label 6702*/ GIMT_Encode4(324447), // Rule ID 4320 //
     /* 324348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324352 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 324358 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 324360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 324368 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 324371 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 324375 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 324379 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 324383 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324385 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 324392 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 324392 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 324395 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 324399 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 324409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 324414 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 324420 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 324422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 324425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324430 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 324436 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324441 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324446 */     // GIR_Coverage, 4320,
     /* 324446 */     GIR_EraseRootFromParent_Done,
     /* 324447 */   // Label 6702: @324447
     /* 324447 */   GIM_Try, /*On fail goto*//*Label 6703*/ GIMT_Encode4(324551), // Rule ID 4321 //
     /* 324452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324456 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 324462 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 324464 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324468 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 324472 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 324475 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 324479 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 324483 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 324487 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324489 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 324496 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 324496 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 324499 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 324503 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 324513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 324518 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 324524 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 324526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 324529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324534 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 324540 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324545 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324550 */     // GIR_Coverage, 4321,
     /* 324550 */     GIR_EraseRootFromParent_Done,
     /* 324551 */   // Label 6703: @324551
     /* 324551 */   GIM_Try, /*On fail goto*//*Label 6704*/ GIMT_Encode4(324651), // Rule ID 4216 //
     /* 324556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 324564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 324572 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 324575 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 324579 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 324583 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 324587 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324589 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 324596 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 324596 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 324599 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 324603 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 324613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 324618 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 324624 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 324626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 324629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324634 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 324640 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324645 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324650 */     // GIR_Coverage, 4216,
     /* 324650 */     GIR_EraseRootFromParent_Done,
     /* 324651 */   // Label 6704: @324651
     /* 324651 */   GIM_Try, /*On fail goto*//*Label 6705*/ GIMT_Encode4(324751), // Rule ID 4218 //
     /* 324656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 324664 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324668 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 324672 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 324675 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 324679 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 324683 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 324687 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324689 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 324696 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 324696 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 324699 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 324703 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 324713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 324718 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 324724 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 324726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 324729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 324740 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324745 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324750 */     // GIR_Coverage, 4218,
     /* 324750 */     GIR_EraseRootFromParent_Done,
     /* 324751 */   // Label 6705: @324751
     /* 324751 */   GIM_Try, /*On fail goto*//*Label 6706*/ GIMT_Encode4(324851), // Rule ID 4324 //
     /* 324756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 324764 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324768 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 324772 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 324775 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 324779 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 324783 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 324787 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324789 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 324796 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 324796 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 324799 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 324803 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 324813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 324818 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 324824 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 324826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 324829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324834 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 324840 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324845 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324850 */     // GIR_Coverage, 4324,
     /* 324850 */     GIR_EraseRootFromParent_Done,
     /* 324851 */   // Label 6706: @324851
     /* 324851 */   GIM_Try, /*On fail goto*//*Label 6707*/ GIMT_Encode4(324951), // Rule ID 4326 //
     /* 324856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 324864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 324872 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 324875 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 324879 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 324883 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 324887 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324889 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 324896 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 324896 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 324899 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 324903 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 324913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 324918 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 324924 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 324926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 324929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324934 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 324940 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324945 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324950 */     // GIR_Coverage, 4326,
     /* 324950 */     GIR_EraseRootFromParent_Done,
     /* 324951 */   // Label 6707: @324951
     /* 324951 */   GIM_Try, /*On fail goto*//*Label 6708*/ GIMT_Encode4(325071), // Rule ID 6354 //
     /* 324956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 324967 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324971 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 324975 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 324978 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 324982 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 324989 */     // MIs[2] Rn
     /* 324989 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 324993 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 324998 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 325002 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 325004 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i16:{ *:[f128] } (IMPLICIT_DEF:{ *:[v8i16] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 325004 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 325007 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 325011 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325016 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 325018 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 325021 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 325025 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325030 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 325033 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 325036 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 325040 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 325046 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 325048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 325051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325053 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 325060 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325065 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325070 */     // GIR_Coverage, 6354,
     /* 325070 */     GIR_EraseRootFromParent_Done,
     /* 325071 */   // Label 6708: @325071
     /* 325071 */   GIM_Try, /*On fail goto*//*Label 6709*/ GIMT_Encode4(325191), // Rule ID 6356 //
     /* 325076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 325087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 325091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 325095 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 325098 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 325102 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 325109 */     // MIs[2] Rn
     /* 325109 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 325113 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 325118 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 325122 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 325124 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i8:{ *:[f128] } (IMPLICIT_DEF:{ *:[v16i8] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 325124 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 325127 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 325131 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325136 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 325138 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 325141 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 325145 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325150 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 325153 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 325156 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 325160 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 325166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 325168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 325171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325173 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 325180 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325185 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325190 */     // GIR_Coverage, 6356,
     /* 325190 */     GIR_EraseRootFromParent_Done,
     /* 325191 */   // Label 6709: @325191
     /* 325191 */   GIM_Try, /*On fail goto*//*Label 6710*/ GIMT_Encode4(325321), // Rule ID 5652 //
     /* 325196 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 325204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 325208 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 325212 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 325216 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325221 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 325225 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 325229 */     // MIs[2] Operand 1
     /* 325229 */     // No operand predicates
     /* 325229 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 325233 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 325237 */     // MIs[3] Operand 1
     /* 325237 */     // No operand predicates
     /* 325237 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 325239 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$src, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 325239 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 325242 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 325246 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325251 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 325254 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 325258 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 325261 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325266 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325271 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 325274 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 325278 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325283 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 325286 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 325289 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 325293 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 325296 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 325298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 325301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325303 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 325310 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325315 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325320 */     // GIR_Coverage, 5652,
     /* 325320 */     GIR_EraseRootFromParent_Done,
     /* 325321 */   // Label 6710: @325321
     /* 325321 */   GIM_Try, /*On fail goto*//*Label 6711*/ GIMT_Encode4(325482), // Rule ID 5653 //
     /* 325326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 325334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 325338 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 325342 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 325346 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325351 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 325355 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 325359 */     // MIs[2] Operand 1
     /* 325359 */     // No operand predicates
     /* 325359 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 325363 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 325367 */     // MIs[3] Operand 1
     /* 325367 */     // No operand predicates
     /* 325367 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 325369 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$src, (vector_extract:{ *:[f32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 325369 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 325372 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 325376 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325381 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 325384 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 325388 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 325391 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325396 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325401 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 325404 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 325408 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325413 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 325416 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 325420 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 325423 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325428 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325433 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 325436 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 325440 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325445 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 325448 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 325451 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 325454 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 325457 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 325459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 325462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325464 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 325471 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325476 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325481 */     // GIR_Coverage, 5653,
     /* 325481 */     GIR_EraseRootFromParent_Done,
     /* 325482 */   // Label 6711: @325482
     /* 325482 */   GIM_Try, /*On fail goto*//*Label 6712*/ GIMT_Encode4(325612), // Rule ID 5676 //
     /* 325487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 325495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 325499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 325503 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 325507 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325512 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 325516 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 325520 */     // MIs[2] Operand 1
     /* 325520 */     // No operand predicates
     /* 325520 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 325524 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 325528 */     // MIs[3] Operand 1
     /* 325528 */     // No operand predicates
     /* 325528 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 325530 */     // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 325530 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 325533 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 325537 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325542 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 325545 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 325549 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 325552 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325557 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325562 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 325565 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 325569 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325574 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 325577 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 325580 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 325584 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 325587 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 325589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 325592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325594 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 325601 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325606 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325611 */     // GIR_Coverage, 5676,
     /* 325611 */     GIR_EraseRootFromParent_Done,
     /* 325612 */   // Label 6712: @325612
     /* 325612 */   GIM_Try, /*On fail goto*//*Label 6713*/ GIMT_Encode4(325773), // Rule ID 5677 //
     /* 325617 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 325625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 325629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 325633 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 325637 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 325646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 325650 */     // MIs[2] Operand 1
     /* 325650 */     // No operand predicates
     /* 325650 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 325654 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 325658 */     // MIs[3] Operand 1
     /* 325658 */     // No operand predicates
     /* 325658 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 325660 */     // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 325660 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 325663 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 325667 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325672 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 325675 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 325679 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 325682 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325687 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325692 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 325695 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 325699 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325704 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 325707 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 325711 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 325714 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325719 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325724 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 325727 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 325731 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325736 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 325739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 325742 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 325745 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 325748 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 325750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 325753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325755 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 325762 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325767 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325772 */     // GIR_Coverage, 5677,
     /* 325772 */     GIR_EraseRootFromParent_Done,
     /* 325773 */   // Label 6713: @325773
     /* 325773 */   GIM_Try, /*On fail goto*//*Label 6714*/ GIMT_Encode4(325839), // Rule ID 5607 //
     /* 325778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 325786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 325790 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 325794 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 325796 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), FPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2i32] } (IMPLICIT_DEF:{ *:[v2i32] }), FPR32:{ *:[i32] }:$Rn, ssub:{ *:[i32] })
     /* 325796 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 325799 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 325803 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325808 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 325810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 325813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325815 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 325818 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 325820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 325823 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325828 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325833 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 325838 */     // GIR_Coverage, 5607,
     /* 325838 */     GIR_EraseRootFromParent_Done,
     /* 325839 */   // Label 6714: @325839
     /* 325839 */   GIM_Try, /*On fail goto*//*Label 6715*/ GIMT_Encode4(325905), // Rule ID 5619 //
     /* 325844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 325852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 325856 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 325860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 325862 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), FPR32:{ *:[f32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] })
     /* 325862 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 325865 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 325869 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325874 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 325876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 325879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325881 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 325884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 325886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 325889 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325894 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325899 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 325904 */     // GIR_Coverage, 5619,
     /* 325904 */     GIR_EraseRootFromParent_Done,
     /* 325905 */   // Label 6715: @325905
     /* 325905 */   GIM_Try, /*On fail goto*//*Label 6716*/ GIMT_Encode4(326040), // Rule ID 5627 //
     /* 325910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 325918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 325922 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 325926 */     // MIs[1] Operand 1
     /* 325926 */     // No operand predicates
     /* 325926 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 325930 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 325934 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 325938 */     // MIs[2] Operand 1
     /* 325938 */     // No operand predicates
     /* 325938 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 325940 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, WZR:{ *:[i32] }), dsub:{ *:[i32] })
     /* 325940 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 325943 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 325947 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325952 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 325954 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 325957 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 325961 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325966 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 325969 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 325973 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 325976 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325981 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325986 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325991 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 325994 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 325998 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326003 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 326006 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /* 326009 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 326015 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 326017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 326022 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 326029 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326034 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326039 */     // GIR_Coverage, 5627,
     /* 326039 */     GIR_EraseRootFromParent_Done,
     /* 326040 */   // Label 6716: @326040
     /* 326040 */   GIM_Try, /*On fail goto*//*Label 6717*/ GIMT_Encode4(326172), // Rule ID 6362 //
     /* 326045 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 326053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 326057 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 326060 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 326064 */     // MIs[1] Rn
     /* 326064 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 326068 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 326073 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 326077 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 326081 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 326085 */     // MIs[2] Operand 1
     /* 326085 */     // No operand predicates
     /* 326085 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 326087 */     // (vector_insert:{ *:[v2i32] } VecListOne64:{ *:[v2i32] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i32:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 326087 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 326090 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 326094 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326099 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 326102 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 326106 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 326109 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326114 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326119 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 326122 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 326126 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326131 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 326134 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 326137 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 326141 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 326147 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 326149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 326154 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 326161 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326166 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326171 */     // GIR_Coverage, 6362,
     /* 326171 */     GIR_EraseRootFromParent_Done,
     /* 326172 */   // Label 6717: @326172
     /* 326172 */   GIM_Try, /*On fail goto*//*Label 6718*/ GIMT_Encode4(326304), // Rule ID 6363 //
     /* 326177 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 326185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 326189 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 326192 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 326196 */     // MIs[1] Rn
     /* 326196 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 326200 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 326205 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 326209 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 326213 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 326217 */     // MIs[2] Operand 1
     /* 326217 */     // No operand predicates
     /* 326217 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 326219 */     // (vector_insert:{ *:[v2f32] } VecListOne64:{ *:[v2f32] }:$Rd, (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (LD1i32:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 326219 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 326222 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 326226 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326231 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 326234 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 326238 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 326241 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326246 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326251 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 326254 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 326258 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326263 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 326266 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 326269 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 326273 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 326279 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 326281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 326286 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 326293 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326298 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326303 */     // GIR_Coverage, 6363,
     /* 326303 */     GIR_EraseRootFromParent_Done,
     /* 326304 */   // Label 6718: @326304
     /* 326304 */   GIM_Try, /*On fail goto*//*Label 6719*/ GIMT_Encode4(326487), // Rule ID 5685 //
     /* 326309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 326313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 326317 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 326321 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326326 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 326330 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 326334 */     // MIs[2] Operand 1
     /* 326334 */     // No operand predicates
     /* 326334 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 326336 */     // (vector_insert:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$src, (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR32:{ *:[f32] }:$Sn, ssub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 326336 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s128,
     /* 326339 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 326343 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326348 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 326350 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 326353 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 326357 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326362 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 326365 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 326369 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/18,
     /* 326372 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326377 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326382 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326387 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 326390 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 326394 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326399 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 326401 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 326404 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 326408 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326413 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 326416 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 326420 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 326423 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326428 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326433 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326438 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 326441 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 326445 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326450 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 326453 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immd
     /* 326456 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 326459 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 326462 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 326464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 326469 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 326476 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326481 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326486 */     // GIR_Coverage, 5685,
     /* 326486 */     GIR_EraseRootFromParent_Done,
     /* 326487 */   // Label 6719: @326487
     /* 326487 */   GIM_Try, /*On fail goto*//*Label 6720*/ GIMT_Encode4(326665), // Rule ID 5630 //
     /* 326492 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 326504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 326508 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 326512 */     // MIs[1] Operand 1
     /* 326512 */     // No operand predicates
     /* 326512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 326514 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 326514 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 326517 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 326521 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326526 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 326528 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 326531 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 326535 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326540 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 326543 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 326547 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/18,
     /* 326550 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326555 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326560 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326565 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 326568 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 326572 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326577 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 326579 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 326582 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 326586 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326591 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 326594 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 326598 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 326601 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326606 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326611 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326616 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 326619 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 326623 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326628 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 326631 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 326634 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 326637 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 326640 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 326642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 326647 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 326654 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326659 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326664 */     // GIR_Coverage, 5630,
     /* 326664 */     GIR_EraseRootFromParent_Done,
     /* 326665 */   // Label 6720: @326665
     /* 326665 */   GIM_Try, /*On fail goto*//*Label 6721*/ GIMT_Encode4(326790), // Rule ID 5633 //
     /* 326670 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 326678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 326682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 326686 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 326690 */     // MIs[1] Operand 1
     /* 326690 */     // No operand predicates
     /* 326690 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 326692 */     // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
     /* 326692 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 326695 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 326699 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326704 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 326706 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 326709 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 326713 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326718 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 326721 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 326725 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 326728 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326733 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326738 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326743 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 326746 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 326750 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326755 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 326758 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 326761 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 326765 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 326767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 326772 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 326779 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326784 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326789 */     // GIR_Coverage, 5633,
     /* 326789 */     GIR_EraseRootFromParent_Done,
     /* 326790 */   // Label 6721: @326790
     /* 326790 */   GIM_Reject,
     /* 326791 */ // Label 6691: @326791
     /* 326791 */ GIM_Reject,
     /* 326792 */ // Label 6669: @326792
     /* 326792 */ GIM_Try, /*On fail goto*//*Label 6722*/ GIMT_Encode4(329620),
     /* 326797 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 326800 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 326803 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 326806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326810 */   GIM_Try, /*On fail goto*//*Label 6723*/ GIMT_Encode4(326919), // Rule ID 4238 //
     /* 326815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326819 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 326825 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 326827 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 326831 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 326835 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 326838 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 326842 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 326846 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 326850 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 326852 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 326859 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 326859 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 326862 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 326866 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 326876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 326881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 326886 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 326892 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 326894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 326897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 326899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326902 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 326905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 326908 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326913 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326918 */     // GIR_Coverage, 4238,
     /* 326918 */     GIR_EraseRootFromParent_Done,
     /* 326919 */   // Label 6723: @326919
     /* 326919 */   GIM_Try, /*On fail goto*//*Label 6724*/ GIMT_Encode4(327028), // Rule ID 4239 //
     /* 326924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326928 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 326934 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 326936 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 326940 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 326944 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 326947 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 326951 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 326955 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 326959 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 326961 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 326968 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 326968 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 326971 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 326975 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 326985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 326990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 326995 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 327001 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 327003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 327006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 327008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327011 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 327017 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327022 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327027 */     // GIR_Coverage, 4239,
     /* 327027 */     GIR_EraseRootFromParent_Done,
     /* 327028 */   // Label 6724: @327028
     /* 327028 */   GIM_Try, /*On fail goto*//*Label 6725*/ GIMT_Encode4(327137), // Rule ID 4346 //
     /* 327033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327037 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 327043 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 327045 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 327049 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 327053 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 327056 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 327060 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 327064 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 327068 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327070 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 327077 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 327077 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 327080 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 327084 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 327094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 327099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 327104 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 327110 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 327112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 327115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 327117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327120 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 327126 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327131 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327136 */     // GIR_Coverage, 4346,
     /* 327136 */     GIR_EraseRootFromParent_Done,
     /* 327137 */   // Label 6725: @327137
     /* 327137 */   GIM_Try, /*On fail goto*//*Label 6726*/ GIMT_Encode4(327246), // Rule ID 4347 //
     /* 327142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327146 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 327152 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 327154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 327158 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 327162 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 327165 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 327169 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 327173 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 327177 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327179 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 327186 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 327186 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 327189 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 327193 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 327203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 327208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 327213 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 327219 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 327221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 327224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 327226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327229 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 327235 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327240 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327245 */     // GIR_Coverage, 4347,
     /* 327245 */     GIR_EraseRootFromParent_Done,
     /* 327246 */   // Label 6726: @327246
     /* 327246 */   GIM_Try, /*On fail goto*//*Label 6727*/ GIMT_Encode4(327351), // Rule ID 4244 //
     /* 327251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 327259 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 327263 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 327267 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 327270 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 327274 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 327278 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 327282 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327284 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 327291 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 327291 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 327294 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 327298 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 327308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 327313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 327318 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 327324 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 327326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 327329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 327331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327334 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 327340 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327345 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327350 */     // GIR_Coverage, 4244,
     /* 327350 */     GIR_EraseRootFromParent_Done,
     /* 327351 */   // Label 6727: @327351
     /* 327351 */   GIM_Try, /*On fail goto*//*Label 6728*/ GIMT_Encode4(327456), // Rule ID 4246 //
     /* 327356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 327364 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 327368 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 327372 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 327375 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 327379 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 327383 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 327387 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327389 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 327396 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 327396 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 327399 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 327403 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 327413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 327418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 327423 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 327429 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 327431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 327434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 327436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327439 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 327445 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327450 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327455 */     // GIR_Coverage, 4246,
     /* 327455 */     GIR_EraseRootFromParent_Done,
     /* 327456 */   // Label 6728: @327456
     /* 327456 */   GIM_Try, /*On fail goto*//*Label 6729*/ GIMT_Encode4(327561), // Rule ID 4352 //
     /* 327461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 327469 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 327473 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 327477 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 327480 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 327484 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 327488 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 327492 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327494 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 327501 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 327501 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 327504 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 327508 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 327518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 327523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 327528 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 327534 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 327536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 327539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 327541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327544 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 327550 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327555 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327560 */     // GIR_Coverage, 4352,
     /* 327560 */     GIR_EraseRootFromParent_Done,
     /* 327561 */   // Label 6729: @327561
     /* 327561 */   GIM_Try, /*On fail goto*//*Label 6730*/ GIMT_Encode4(327666), // Rule ID 4354 //
     /* 327566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 327574 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 327578 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 327582 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 327585 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 327589 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 327593 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 327597 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327599 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 327606 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 327606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 327609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 327613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 327623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 327628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 327633 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 327639 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 327641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 327644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 327646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327649 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 327655 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327660 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327665 */     // GIR_Coverage, 4354,
     /* 327665 */     GIR_EraseRootFromParent_Done,
     /* 327666 */   // Label 6730: @327666
     /* 327666 */   GIM_Try, /*On fail goto*//*Label 6731*/ GIMT_Encode4(327770), // Rule ID 4236 //
     /* 327671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327675 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 327681 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 327683 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 327687 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 327691 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 327694 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 327698 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 327702 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 327706 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327708 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 327715 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 327715 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 327718 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 327722 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 327732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 327737 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 327743 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 327745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 327748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 327750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327753 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 327759 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327764 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327769 */     // GIR_Coverage, 4236,
     /* 327769 */     GIR_EraseRootFromParent_Done,
     /* 327770 */   // Label 6731: @327770
     /* 327770 */   GIM_Try, /*On fail goto*//*Label 6732*/ GIMT_Encode4(327874), // Rule ID 4237 //
     /* 327775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327779 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 327785 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 327787 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 327791 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 327795 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 327798 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 327802 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 327806 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 327810 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327812 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 327819 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 327819 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 327822 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 327826 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 327836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 327841 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 327847 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 327849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 327852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 327854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327857 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 327863 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327868 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327873 */     // GIR_Coverage, 4237,
     /* 327873 */     GIR_EraseRootFromParent_Done,
     /* 327874 */   // Label 6732: @327874
     /* 327874 */   GIM_Try, /*On fail goto*//*Label 6733*/ GIMT_Encode4(327978), // Rule ID 4344 //
     /* 327879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327883 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 327889 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 327891 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 327895 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 327899 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 327902 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 327906 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 327910 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 327914 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327916 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 327923 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 327923 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 327926 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 327930 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 327940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 327945 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 327951 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 327953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 327956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 327958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327961 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 327967 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327972 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327977 */     // GIR_Coverage, 4344,
     /* 327977 */     GIR_EraseRootFromParent_Done,
     /* 327978 */   // Label 6733: @327978
     /* 327978 */   GIM_Try, /*On fail goto*//*Label 6734*/ GIMT_Encode4(328082), // Rule ID 4345 //
     /* 327983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327987 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 327993 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 327995 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 327999 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 328003 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 328006 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 328010 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 328014 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 328018 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 328020 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 328027 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 328027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 328030 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 328034 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 328044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 328049 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 328055 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 328060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328065 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 328071 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328076 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328081 */     // GIR_Coverage, 4345,
     /* 328081 */     GIR_EraseRootFromParent_Done,
     /* 328082 */   // Label 6734: @328082
     /* 328082 */   GIM_Try, /*On fail goto*//*Label 6735*/ GIMT_Encode4(328182), // Rule ID 4240 //
     /* 328087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 328095 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 328099 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 328103 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 328106 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 328110 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 328114 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 328118 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 328120 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 328127 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 328127 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 328130 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 328134 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 328144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 328149 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 328155 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 328160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328165 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 328171 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328176 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328181 */     // GIR_Coverage, 4240,
     /* 328181 */     GIR_EraseRootFromParent_Done,
     /* 328182 */   // Label 6735: @328182
     /* 328182 */   GIM_Try, /*On fail goto*//*Label 6736*/ GIMT_Encode4(328282), // Rule ID 4242 //
     /* 328187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 328195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 328199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 328203 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 328206 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 328210 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 328214 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 328218 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 328220 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 328227 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 328227 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 328230 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 328234 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 328244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 328249 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 328255 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 328260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328265 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 328271 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328276 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328281 */     // GIR_Coverage, 4242,
     /* 328281 */     GIR_EraseRootFromParent_Done,
     /* 328282 */   // Label 6736: @328282
     /* 328282 */   GIM_Try, /*On fail goto*//*Label 6737*/ GIMT_Encode4(328382), // Rule ID 4348 //
     /* 328287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 328295 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 328299 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 328303 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 328306 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 328310 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 328314 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 328318 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 328320 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 328327 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 328327 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 328330 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 328334 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 328344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 328349 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 328355 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 328360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328365 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 328371 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328376 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328381 */     // GIR_Coverage, 4348,
     /* 328381 */     GIR_EraseRootFromParent_Done,
     /* 328382 */   // Label 6737: @328382
     /* 328382 */   GIM_Try, /*On fail goto*//*Label 6738*/ GIMT_Encode4(328482), // Rule ID 4350 //
     /* 328387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 328395 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 328399 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 328403 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 328406 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 328410 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 328414 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 328418 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 328420 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 328427 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 328427 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 328430 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 328434 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 328444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 328449 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 328455 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 328460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328465 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 328471 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328476 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328481 */     // GIR_Coverage, 4350,
     /* 328481 */     GIR_EraseRootFromParent_Done,
     /* 328482 */   // Label 6738: @328482
     /* 328482 */   GIM_Try, /*On fail goto*//*Label 6739*/ GIMT_Encode4(328560), // Rule ID 1934 //
     /* 328487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 328490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 328498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 328502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 328506 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 328510 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328515 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 328519 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 328523 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 328527 */     // MIs[2] Operand 1
     /* 328527 */     // No operand predicates
     /* 328527 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 328531 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 328535 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 328539 */     // MIs[3] Operand 1
     /* 328539 */     // No operand predicates
     /* 328539 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 328541 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 328541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 328544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328546 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 328548 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 328551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328555 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 328558 */     GIR_RootConstrainSelectedInstOperands,
     /* 328559 */     // GIR_Coverage, 1934,
     /* 328559 */     GIR_EraseRootFromParent_Done,
     /* 328560 */   // Label 6739: @328560
     /* 328560 */   GIM_Try, /*On fail goto*//*Label 6740*/ GIMT_Encode4(328651), // Rule ID 7270 //
     /* 328565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 328568 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 328576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 328580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 328584 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 328588 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 328592 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 328595 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 328602 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 328605 */     // MIs[2] Rn
     /* 328605 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 328609 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 328614 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 328618 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 328622 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 328626 */     // MIs[3] Operand 1
     /* 328626 */     // No operand predicates
     /* 328626 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 328628 */     // (vector_insert:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15496>>), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LDAP1:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 328628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAP1),
     /* 328631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328633 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 328635 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 328638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 328642 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /* 328649 */     GIR_RootConstrainSelectedInstOperands,
     /* 328650 */     // GIR_Coverage, 7270,
     /* 328650 */     GIR_EraseRootFromParent_Done,
     /* 328651 */   // Label 6740: @328651
     /* 328651 */   GIM_Try, /*On fail goto*//*Label 6741*/ GIMT_Encode4(328718), // Rule ID 5656 //
     /* 328656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 328664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 328668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 328672 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 328676 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328681 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 328685 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 328689 */     // MIs[2] Operand 1
     /* 328689 */     // No operand predicates
     /* 328689 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 328693 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 328697 */     // MIs[3] Operand 1
     /* 328697 */     // No operand predicates
     /* 328697 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 328699 */     // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 328699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 328702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328704 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 328706 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 328709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328713 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 328716 */     GIR_RootConstrainSelectedInstOperands,
     /* 328717 */     // GIR_Coverage, 5656,
     /* 328717 */     GIR_EraseRootFromParent_Done,
     /* 328718 */   // Label 6741: @328718
     /* 328718 */   GIM_Try, /*On fail goto*//*Label 6742*/ GIMT_Encode4(328816), // Rule ID 5657 //
     /* 328723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 328731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 328735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 328739 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 328743 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328748 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 328752 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 328756 */     // MIs[2] Operand 1
     /* 328756 */     // No operand predicates
     /* 328756 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 328760 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 328764 */     // MIs[3] Operand 1
     /* 328764 */     // No operand predicates
     /* 328764 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 328766 */     // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (vector_extract:{ *:[f64] } V64:{ *:[v1f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 328766 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 328769 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 328773 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328778 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 328781 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328785 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 328788 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328793 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 328801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328803 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 328805 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 328808 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328811 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 328814 */     GIR_RootConstrainSelectedInstOperands,
     /* 328815 */     // GIR_Coverage, 5657,
     /* 328815 */     GIR_EraseRootFromParent_Done,
     /* 328816 */   // Label 6742: @328816
     /* 328816 */   GIM_Try, /*On fail goto*//*Label 6743*/ GIMT_Encode4(328883), // Rule ID 5680 //
     /* 328821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 328829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 328833 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 328837 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 328841 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328846 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 328850 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 328854 */     // MIs[2] Operand 1
     /* 328854 */     // No operand predicates
     /* 328854 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 328858 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 328862 */     // MIs[3] Operand 1
     /* 328862 */     // No operand predicates
     /* 328862 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 328864 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 328864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 328867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328869 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 328871 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 328874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328878 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 328881 */     GIR_RootConstrainSelectedInstOperands,
     /* 328882 */     // GIR_Coverage, 5680,
     /* 328882 */     GIR_EraseRootFromParent_Done,
     /* 328883 */   // Label 6743: @328883
     /* 328883 */   GIM_Try, /*On fail goto*//*Label 6744*/ GIMT_Encode4(328981), // Rule ID 5681 //
     /* 328888 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 328896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 328900 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 328904 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 328908 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328913 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 328917 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 328921 */     // MIs[2] Operand 1
     /* 328921 */     // No operand predicates
     /* 328921 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 328925 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 328929 */     // MIs[3] Operand 1
     /* 328929 */     // No operand predicates
     /* 328929 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 328931 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (vector_extract:{ *:[i64] } V64:{ *:[v1i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 328931 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 328934 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 328938 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328943 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 328946 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328950 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 328953 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328958 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 328966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328968 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 328970 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 328973 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328976 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 328979 */     GIR_RootConstrainSelectedInstOperands,
     /* 328980 */     // GIR_Coverage, 5681,
     /* 328980 */     GIR_EraseRootFromParent_Done,
     /* 328981 */   // Label 6744: @328981
     /* 328981 */   GIM_Try, /*On fail goto*//*Label 6745*/ GIMT_Encode4(329047), // Rule ID 5611 //
     /* 328986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 328994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328998 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 329002 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329004 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), FPR64:{ *:[i64] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), FPR64:{ *:[i64] }:$Rn, dsub:{ *:[i32] })
     /* 329004 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 329007 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 329011 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329016 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 329021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 329028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 329031 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329036 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329041 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329046 */     // GIR_Coverage, 5611,
     /* 329046 */     GIR_EraseRootFromParent_Done,
     /* 329047 */   // Label 6745: @329047
     /* 329047 */   GIM_Try, /*On fail goto*//*Label 6746*/ GIMT_Encode4(329113), // Rule ID 5621 //
     /* 329052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 329060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329064 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 329068 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329070 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rn, dsub:{ *:[i32] })
     /* 329070 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 329073 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 329077 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329082 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 329087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329089 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 329094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 329097 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329102 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329107 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329112 */     // GIR_Coverage, 5621,
     /* 329112 */     GIR_EraseRootFromParent_Done,
     /* 329113 */   // Label 6746: @329113
     /* 329113 */   GIM_Try, /*On fail goto*//*Label 6747*/ GIMT_Encode4(329191), // Rule ID 7269 //
     /* 329118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 329121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 329129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 329133 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 329136 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 329143 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 329146 */     // MIs[1] Rn
     /* 329146 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 329150 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 329155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 329159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 329163 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 329167 */     // MIs[2] Operand 1
     /* 329167 */     // No operand predicates
     /* 329167 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 329169 */     // (vector_insert:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15496>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LDAP1:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 329169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAP1),
     /* 329172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329174 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 329176 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 329179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329183 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 329189 */     GIR_RootConstrainSelectedInstOperands,
     /* 329190 */     // GIR_Coverage, 7269,
     /* 329190 */     GIR_EraseRootFromParent_Done,
     /* 329191 */   // Label 6747: @329191
     /* 329191 */   GIM_Try, /*On fail goto*//*Label 6748*/ GIMT_Encode4(329260), // Rule ID 6345 //
     /* 329196 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 329204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 329208 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 329211 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 329215 */     // MIs[1] Rn
     /* 329215 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 329219 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 329224 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 329228 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 329232 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 329236 */     // MIs[2] Operand 1
     /* 329236 */     // No operand predicates
     /* 329236 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 329238 */     // (vector_insert:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LD1i64:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 329238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i64),
     /* 329241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329243 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 329245 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 329248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329252 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 329258 */     GIR_RootConstrainSelectedInstOperands,
     /* 329259 */     // GIR_Coverage, 6345,
     /* 329259 */     GIR_EraseRootFromParent_Done,
     /* 329260 */   // Label 6748: @329260
     /* 329260 */   GIM_Try, /*On fail goto*//*Label 6749*/ GIMT_Encode4(329329), // Rule ID 6346 //
     /* 329265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 329273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 329277 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 329280 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 329284 */     // MIs[1] Rn
     /* 329284 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 329288 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 329293 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 329297 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 329301 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 329305 */     // MIs[2] Operand 1
     /* 329305 */     // No operand predicates
     /* 329305 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 329307 */     // (vector_insert:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LD1i64:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 329307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i64),
     /* 329310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329312 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 329314 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 329317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329321 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 329327 */     GIR_RootConstrainSelectedInstOperands,
     /* 329328 */     // GIR_Coverage, 6346,
     /* 329328 */     GIR_EraseRootFromParent_Done,
     /* 329329 */   // Label 6749: @329329
     /* 329329 */   GIM_Try, /*On fail goto*//*Label 6750*/ GIMT_Encode4(329378), // Rule ID 5628 //
     /* 329334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 329338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 329342 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 329346 */     // MIs[1] Operand 1
     /* 329346 */     // No operand predicates
     /* 329346 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 329350 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 329354 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 329358 */     // MIs[2] Operand 1
     /* 329358 */     // No operand predicates
     /* 329358 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 329360 */     // (vector_insert:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (INSvi64gpr:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, XZR:{ *:[i64] })
     /* 329360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64gpr),
     /* 329363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329365 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 329367 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 329370 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 329376 */     GIR_RootConstrainSelectedInstOperands,
     /* 329377 */     // GIR_Coverage, 5628,
     /* 329377 */     GIR_EraseRootFromParent_Done,
     /* 329378 */   // Label 6750: @329378
     /* 329378 */   GIM_Try, /*On fail goto*//*Label 6751*/ GIMT_Encode4(329479), // Rule ID 5686 //
     /* 329383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 329387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 329391 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 329395 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329400 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 329404 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 329408 */     // MIs[2] Operand 1
     /* 329408 */     // No operand predicates
     /* 329408 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 329410 */     // (vector_insert:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$src, (bitconvert:{ *:[i64] } FPR64:{ *:[f64] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR64:{ *:[f64] }:$Sn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 329410 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 329413 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 329417 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329422 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 329424 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 329427 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 329431 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329436 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 329439 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 329443 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 329446 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329451 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329456 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 329464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329466 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 329468 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immd
     /* 329471 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329477 */     GIR_RootConstrainSelectedInstOperands,
     /* 329478 */     // GIR_Coverage, 5686,
     /* 329478 */     GIR_EraseRootFromParent_Done,
     /* 329479 */   // Label 6751: @329479
     /* 329479 */   GIM_Try, /*On fail goto*//*Label 6752*/ GIMT_Encode4(329523), // Rule ID 1930 //
     /* 329484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 329487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 329495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 329499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 329503 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 329507 */     // MIs[1] Operand 1
     /* 329507 */     // No operand predicates
     /* 329507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329509 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (INSvi64gpr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] }):$idx, GPR64:{ *:[i64] }:$Rn)
     /* 329509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64gpr),
     /* 329512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329514 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 329516 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 329519 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 329521 */     GIR_RootConstrainSelectedInstOperands,
     /* 329522 */     // GIR_Coverage, 1930,
     /* 329522 */     GIR_EraseRootFromParent_Done,
     /* 329523 */   // Label 6752: @329523
     /* 329523 */   GIM_Try, /*On fail goto*//*Label 6753*/ GIMT_Encode4(329619), // Rule ID 5632 //
     /* 329528 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 329540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 329544 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 329548 */     // MIs[1] Operand 1
     /* 329548 */     // No operand predicates
     /* 329548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329550 */     // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm, (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 329550 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 329553 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 329557 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329562 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 329564 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 329567 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 329571 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329576 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 329579 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 329583 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 329586 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329591 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329596 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 329604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329606 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 329608 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 329611 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329617 */     GIR_RootConstrainSelectedInstOperands,
     /* 329618 */     // GIR_Coverage, 5632,
     /* 329618 */     GIR_EraseRootFromParent_Done,
     /* 329619 */   // Label 6753: @329619
     /* 329619 */   GIM_Reject,
     /* 329620 */ // Label 6722: @329620
     /* 329620 */ GIM_Reject,
     /* 329621 */ // Label 6670: @329621
     /* 329621 */ GIM_Try, /*On fail goto*//*Label 6754*/ GIMT_Encode4(333260),
     /* 329626 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 329629 */   GIM_Try, /*On fail goto*//*Label 6755*/ GIMT_Encode4(329755), // Rule ID 4178 //
     /* 329634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 329637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 329640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329648 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 329654 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 329656 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 329660 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 329664 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 329667 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 329671 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 329678 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 329682 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 329686 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 329688 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 329695 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 329695 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 329698 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 329702 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 329712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 329717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 329722 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 329728 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 329733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329738 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 329744 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329749 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 329754 */     // GIR_Coverage, 4178,
     /* 329754 */     GIR_EraseRootFromParent_Done,
     /* 329755 */   // Label 6755: @329755
     /* 329755 */   GIM_Try, /*On fail goto*//*Label 6756*/ GIMT_Encode4(329881), // Rule ID 4179 //
     /* 329760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 329763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 329766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329774 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 329780 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 329782 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 329786 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 329790 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 329793 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 329797 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 329804 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 329808 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 329812 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 329814 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 329821 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 329821 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 329824 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 329828 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 329838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 329843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 329848 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 329854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 329859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329864 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 329870 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329875 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 329880 */     // GIR_Coverage, 4179,
     /* 329880 */     GIR_EraseRootFromParent_Done,
     /* 329881 */   // Label 6756: @329881
     /* 329881 */   GIM_Try, /*On fail goto*//*Label 6757*/ GIMT_Encode4(330000), // Rule ID 4286 //
     /* 329886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 329889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 329892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329900 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 329906 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 329908 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 329912 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 329916 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 329919 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 329923 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 329927 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 329931 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 329933 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 329940 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 329940 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 329943 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 329947 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 329957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 329962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 329967 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 329973 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 329978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329983 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 329989 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329994 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 329999 */     // GIR_Coverage, 4286,
     /* 329999 */     GIR_EraseRootFromParent_Done,
     /* 330000 */   // Label 6757: @330000
     /* 330000 */   GIM_Try, /*On fail goto*//*Label 6758*/ GIMT_Encode4(330119), // Rule ID 4287 //
     /* 330005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 330008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 330011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330019 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 330025 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 330027 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 330031 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 330035 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 330038 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 330042 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 330046 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 330050 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 330052 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 330059 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 330059 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 330062 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 330066 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 330076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 330081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 330086 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 330092 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 330097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 330099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330102 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 330108 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330113 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 330118 */     // GIR_Coverage, 4287,
     /* 330118 */     GIR_EraseRootFromParent_Done,
     /* 330119 */   // Label 6758: @330119
     /* 330119 */   GIM_Try, /*On fail goto*//*Label 6759*/ GIMT_Encode4(330241), // Rule ID 4184 //
     /* 330124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 330127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 330130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 330142 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 330146 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 330150 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 330153 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 330157 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 330164 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 330168 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 330172 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 330174 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 330181 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 330181 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 330184 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 330188 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 330198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 330203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 330208 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 330214 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 330219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 330221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330224 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 330230 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330235 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 330240 */     // GIR_Coverage, 4184,
     /* 330240 */     GIR_EraseRootFromParent_Done,
     /* 330241 */   // Label 6759: @330241
     /* 330241 */   GIM_Try, /*On fail goto*//*Label 6760*/ GIMT_Encode4(330363), // Rule ID 4186 //
     /* 330246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 330249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 330252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 330264 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 330268 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 330272 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 330275 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 330279 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 330286 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 330290 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 330294 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 330296 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 330303 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 330303 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 330306 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 330310 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 330320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 330325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 330330 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 330336 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 330341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 330343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330346 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 330352 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330357 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 330362 */     // GIR_Coverage, 4186,
     /* 330362 */     GIR_EraseRootFromParent_Done,
     /* 330363 */   // Label 6760: @330363
     /* 330363 */   GIM_Try, /*On fail goto*//*Label 6761*/ GIMT_Encode4(330478), // Rule ID 4292 //
     /* 330368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 330371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 330374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 330386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 330390 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 330394 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 330397 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 330401 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 330405 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 330409 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 330411 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 330418 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 330418 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 330421 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 330425 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 330435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 330440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 330445 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 330451 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 330456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 330458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 330467 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330472 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 330477 */     // GIR_Coverage, 4292,
     /* 330477 */     GIR_EraseRootFromParent_Done,
     /* 330478 */   // Label 6761: @330478
     /* 330478 */   GIM_Try, /*On fail goto*//*Label 6762*/ GIMT_Encode4(330593), // Rule ID 4294 //
     /* 330483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 330486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 330489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 330501 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 330505 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 330509 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 330512 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 330516 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 330520 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 330524 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 330526 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 330533 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 330533 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 330536 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 330540 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 330550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 330555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 330560 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 330566 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 330571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 330573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330576 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 330582 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330587 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 330592 */     // GIR_Coverage, 4294,
     /* 330592 */     GIR_EraseRootFromParent_Done,
     /* 330593 */   // Label 6762: @330593
     /* 330593 */   GIM_Try, /*On fail goto*//*Label 6763*/ GIMT_Encode4(330714), // Rule ID 4176 //
     /* 330598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 330601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 330604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330612 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 330618 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 330620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 330624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 330628 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 330631 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 330635 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 330642 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 330646 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 330650 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 330652 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 330659 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 330659 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 330662 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 330666 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 330676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 330681 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 330687 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 330692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 330694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330697 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 330703 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330708 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 330713 */     // GIR_Coverage, 4176,
     /* 330713 */     GIR_EraseRootFromParent_Done,
     /* 330714 */   // Label 6763: @330714
     /* 330714 */   GIM_Try, /*On fail goto*//*Label 6764*/ GIMT_Encode4(330835), // Rule ID 4177 //
     /* 330719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 330722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 330725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330733 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 330739 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 330741 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 330745 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 330749 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 330752 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 330756 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 330763 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 330767 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 330771 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 330773 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 330780 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 330780 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 330783 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 330787 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 330797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 330802 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 330808 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 330813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 330815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330818 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 330824 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330829 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 330834 */     // GIR_Coverage, 4177,
     /* 330834 */     GIR_EraseRootFromParent_Done,
     /* 330835 */   // Label 6764: @330835
     /* 330835 */   GIM_Try, /*On fail goto*//*Label 6765*/ GIMT_Encode4(330949), // Rule ID 4284 //
     /* 330840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 330843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 330846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330854 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 330860 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 330862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 330866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 330870 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 330873 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 330877 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 330881 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 330885 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 330887 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 330894 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 330894 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 330897 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 330901 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 330911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 330916 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 330922 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 330927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 330929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330932 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 330938 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330943 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 330948 */     // GIR_Coverage, 4284,
     /* 330948 */     GIR_EraseRootFromParent_Done,
     /* 330949 */   // Label 6765: @330949
     /* 330949 */   GIM_Try, /*On fail goto*//*Label 6766*/ GIMT_Encode4(331063), // Rule ID 4285 //
     /* 330954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 330957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 330960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330968 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 330974 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 330976 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 330980 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 330984 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 330987 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 330991 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 330995 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 330999 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 331001 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 331008 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 331008 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 331011 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 331015 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 331025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 331030 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 331036 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 331041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331046 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 331052 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331057 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 331062 */     // GIR_Coverage, 4285,
     /* 331062 */     GIR_EraseRootFromParent_Done,
     /* 331063 */   // Label 6766: @331063
     /* 331063 */   GIM_Try, /*On fail goto*//*Label 6767*/ GIMT_Encode4(331180), // Rule ID 4180 //
     /* 331068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 331071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 331074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 331086 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 331090 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 331094 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 331097 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 331101 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 331108 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 331112 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 331116 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 331118 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 331125 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 331125 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 331128 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 331132 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 331142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 331147 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 331153 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 331158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331163 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 331169 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331174 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 331179 */     // GIR_Coverage, 4180,
     /* 331179 */     GIR_EraseRootFromParent_Done,
     /* 331180 */   // Label 6767: @331180
     /* 331180 */   GIM_Try, /*On fail goto*//*Label 6768*/ GIMT_Encode4(331297), // Rule ID 4182 //
     /* 331185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 331188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 331191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 331203 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 331207 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 331211 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 331214 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 331218 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 331225 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 331229 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 331233 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 331235 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 331242 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 331242 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 331245 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 331249 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 331259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 331264 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 331270 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 331275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331280 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 331286 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331291 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 331296 */     // GIR_Coverage, 4182,
     /* 331296 */     GIR_EraseRootFromParent_Done,
     /* 331297 */   // Label 6768: @331297
     /* 331297 */   GIM_Try, /*On fail goto*//*Label 6769*/ GIMT_Encode4(331407), // Rule ID 4288 //
     /* 331302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 331305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 331308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 331320 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 331324 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 331328 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 331331 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 331335 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 331339 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 331343 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 331345 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 331352 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 331352 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 331355 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 331359 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 331369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 331374 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 331380 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 331385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331390 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 331396 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331401 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 331406 */     // GIR_Coverage, 4288,
     /* 331406 */     GIR_EraseRootFromParent_Done,
     /* 331407 */   // Label 6769: @331407
     /* 331407 */   GIM_Try, /*On fail goto*//*Label 6770*/ GIMT_Encode4(331517), // Rule ID 4290 //
     /* 331412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 331415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 331418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 331430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 331434 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 331438 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 331441 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 331445 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 331449 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 331453 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 331455 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 331462 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 331462 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 331465 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 331469 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 331479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 331484 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 331490 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 331495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331500 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 331506 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331511 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 331516 */     // GIR_Coverage, 4290,
     /* 331516 */     GIR_EraseRootFromParent_Done,
     /* 331517 */   // Label 6770: @331517
     /* 331517 */   GIM_Try, /*On fail goto*//*Label 6771*/ GIMT_Encode4(331647), // Rule ID 6358 //
     /* 331522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 331525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 331528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 331531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 331543 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 331547 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 331551 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 331554 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 331558 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 331565 */     // MIs[2] Rn
     /* 331565 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 331569 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 331574 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 331578 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 331580 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (LD1i8:{ *:[f128] } (IMPLICIT_DEF:{ *:[v16i8] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 331580 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 331583 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 331587 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331592 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 331594 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 331597 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 331601 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331606 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 331609 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 331612 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 331616 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 331622 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 331627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331629 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 331636 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331641 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331646 */     // GIR_Coverage, 6358,
     /* 331646 */     GIR_EraseRootFromParent_Done,
     /* 331647 */   // Label 6771: @331647
     /* 331647 */   GIM_Try, /*On fail goto*//*Label 6772*/ GIMT_Encode4(331787), // Rule ID 5646 //
     /* 331652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 331655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 331658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331662 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 331670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 331674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 331678 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 331682 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 331691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 331695 */     // MIs[2] Operand 1
     /* 331695 */     // No operand predicates
     /* 331695 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 331699 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 331703 */     // MIs[3] Operand 1
     /* 331703 */     // No operand predicates
     /* 331703 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 331705 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$src, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 331705 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 331708 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 331712 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331717 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 331720 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 331724 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 331727 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331732 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331737 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 331740 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 331744 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331749 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 331752 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 331755 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331759 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 331762 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 331767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331769 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 331776 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331781 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331786 */     // GIR_Coverage, 5646,
     /* 331786 */     GIR_EraseRootFromParent_Done,
     /* 331787 */   // Label 6772: @331787
     /* 331787 */   GIM_Try, /*On fail goto*//*Label 6773*/ GIMT_Encode4(331958), // Rule ID 5647 //
     /* 331792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 331795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 331798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331802 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 331810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 331814 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 331818 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 331822 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331827 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 331831 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 331835 */     // MIs[2] Operand 1
     /* 331835 */     // No operand predicates
     /* 331835 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 331839 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 331843 */     // MIs[3] Operand 1
     /* 331843 */     // No operand predicates
     /* 331843 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 331845 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$src, (vector_extract:{ *:[f16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 331845 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 331848 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 331852 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331857 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 331860 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331864 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 331867 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331872 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331877 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 331880 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 331884 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331889 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 331892 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 331896 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 331899 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331904 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331909 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 331912 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 331916 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331921 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 331924 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 331927 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 331930 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 331933 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 331938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331940 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 331947 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331952 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331957 */     // GIR_Coverage, 5647,
     /* 331957 */     GIR_EraseRootFromParent_Done,
     /* 331958 */   // Label 6773: @331958
     /* 331958 */   GIM_Try, /*On fail goto*//*Label 6774*/ GIMT_Encode4(332098), // Rule ID 5670 //
     /* 331963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 331966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 331969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331973 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 331981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 331985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 331989 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 331993 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331998 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 332002 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 332006 */     // MIs[2] Operand 1
     /* 332006 */     // No operand predicates
     /* 332006 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 332010 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 332014 */     // MIs[3] Operand 1
     /* 332014 */     // No operand predicates
     /* 332014 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 332016 */     // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 332016 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 332019 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 332023 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332028 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 332031 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 332035 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 332038 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332043 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332048 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 332051 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 332055 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332060 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332063 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 332066 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332070 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 332073 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 332080 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 332087 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332092 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332097 */     // GIR_Coverage, 5670,
     /* 332097 */     GIR_EraseRootFromParent_Done,
     /* 332098 */   // Label 6774: @332098
     /* 332098 */   GIM_Try, /*On fail goto*//*Label 6775*/ GIMT_Encode4(332269), // Rule ID 5671 //
     /* 332103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 332106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 332109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 332121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 332125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 332129 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 332133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 332142 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 332146 */     // MIs[2] Operand 1
     /* 332146 */     // No operand predicates
     /* 332146 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 332150 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 332154 */     // MIs[3] Operand 1
     /* 332154 */     // No operand predicates
     /* 332154 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 332156 */     // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 332156 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 332159 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 332163 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332168 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 332171 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332175 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 332178 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332183 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332188 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 332191 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 332195 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332200 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 332203 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 332207 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 332210 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332215 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332220 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 332223 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 332227 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332232 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332235 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 332238 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 332241 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 332244 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 332251 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 332258 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332263 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332268 */     // GIR_Coverage, 5671,
     /* 332268 */     GIR_EraseRootFromParent_Done,
     /* 332269 */   // Label 6775: @332269
     /* 332269 */   GIM_Try, /*On fail goto*//*Label 6776*/ GIMT_Encode4(332348), // Rule ID 5601 //
     /* 332274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 332277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 332280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 332292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 332296 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 332300 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332302 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 332302 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 332305 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332309 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332314 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 332318 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 332323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 332326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 332328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332331 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 332337 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332342 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 332347 */     // GIR_Coverage, 5601,
     /* 332347 */     GIR_EraseRootFromParent_Done,
     /* 332348 */   // Label 6776: @332348
     /* 332348 */   GIM_Try, /*On fail goto*//*Label 6777*/ GIMT_Encode4(332424), // Rule ID 5603 //
     /* 332353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 332356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 332359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 332371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 332375 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 332379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332381 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 332381 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
     /* 332384 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 332388 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332393 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 332398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 332400 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 332405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 332408 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332413 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332418 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 332423 */     // GIR_Coverage, 5603,
     /* 332423 */     GIR_EraseRootFromParent_Done,
     /* 332424 */   // Label 6777: @332424
     /* 332424 */   GIM_Try, /*On fail goto*//*Label 6778*/ GIMT_Encode4(332500), // Rule ID 5613 //
     /* 332429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 332432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 332435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 332447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 332451 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 332455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332457 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 332457 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
     /* 332460 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 332464 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332469 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 332474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 332476 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 332481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 332484 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332489 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332494 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 332499 */     // GIR_Coverage, 5613,
     /* 332499 */     GIR_EraseRootFromParent_Done,
     /* 332500 */   // Label 6778: @332500
     /* 332500 */   GIM_Try, /*On fail goto*//*Label 6779*/ GIMT_Encode4(332645), // Rule ID 5625 //
     /* 332505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 332508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 332511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 332523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 332527 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 332531 */     // MIs[1] Operand 1
     /* 332531 */     // No operand predicates
     /* 332531 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 332535 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 332539 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 332543 */     // MIs[2] Operand 1
     /* 332543 */     // No operand predicates
     /* 332543 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 332545 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, WZR:{ *:[i32] }), dsub:{ *:[i32] })
     /* 332545 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 332548 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 332552 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332557 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 332559 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 332562 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 332566 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332571 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 332574 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 332578 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 332581 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332586 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332591 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332596 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 332599 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 332603 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332608 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332611 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /* 332614 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 332620 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 332627 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 332634 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332639 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332644 */     // GIR_Coverage, 5625,
     /* 332644 */     GIR_EraseRootFromParent_Done,
     /* 332645 */   // Label 6779: @332645
     /* 332645 */   GIM_Try, /*On fail goto*//*Label 6780*/ GIMT_Encode4(332794), // Rule ID 6361 //
     /* 332650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 332653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 332656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332660 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 332668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 332672 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 332675 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 332679 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 332686 */     // MIs[1] Rn
     /* 332686 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 332690 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 332695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 332699 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 332703 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 332707 */     // MIs[2] Operand 1
     /* 332707 */     // No operand predicates
     /* 332707 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 332709 */     // (vector_insert:{ *:[v4i16] } VecListOne64:{ *:[v4i16] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (LD1i16:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 332709 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 332712 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 332716 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332721 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 332724 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 332728 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 332731 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332736 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332741 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 332744 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 332748 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332753 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332756 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 332759 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332763 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 332769 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 332776 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 332783 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332788 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332793 */     // GIR_Coverage, 6361,
     /* 332793 */     GIR_EraseRootFromParent_Done,
     /* 332794 */   // Label 6780: @332794
     /* 332794 */   GIM_Try, /*On fail goto*//*Label 6781*/ GIMT_Encode4(332936), // Rule ID 6364 //
     /* 332799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 332802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 332805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 332817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 332821 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 332824 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 332828 */     // MIs[1] Rn
     /* 332828 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 332832 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 332837 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 332841 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 332845 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 332849 */     // MIs[2] Operand 1
     /* 332849 */     // No operand predicates
     /* 332849 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 332851 */     // (vector_insert:{ *:[v4f16] } VecListOne64:{ *:[v4f16] }:$Rd, (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (LD1i16:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 332851 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 332854 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 332858 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332863 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 332866 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 332870 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 332873 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332878 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332883 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 332886 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 332890 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332895 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332898 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 332901 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332905 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 332911 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 332918 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 332925 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332930 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332935 */     // GIR_Coverage, 6364,
     /* 332935 */     GIR_EraseRootFromParent_Done,
     /* 332936 */   // Label 6781: @332936
     /* 332936 */   GIM_Try, /*On fail goto*//*Label 6782*/ GIMT_Encode4(333124), // Rule ID 5623 //
     /* 332941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 332944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 332947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332951 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 332959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 332963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 332967 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 332971 */     // MIs[1] Operand 1
     /* 332971 */     // No operand predicates
     /* 332971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332973 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 332973 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s16,
     /* 332976 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 332980 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332985 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 332987 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s16,
     /* 332990 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 332994 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332999 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 333002 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 333006 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
     /* 333009 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333014 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333019 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 333024 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 333027 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 333031 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333036 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 333038 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 333041 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 333045 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333050 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 333053 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 333057 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 333060 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333065 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333070 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333075 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 333078 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 333082 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333087 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 333090 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 333093 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 333096 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 333099 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 333106 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 333113 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333118 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333123 */     // GIR_Coverage, 5623,
     /* 333123 */     GIR_EraseRootFromParent_Done,
     /* 333124 */   // Label 6782: @333124
     /* 333124 */   GIM_Try, /*On fail goto*//*Label 6783*/ GIMT_Encode4(333259), // Rule ID 5634 //
     /* 333129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 333132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 333135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 333147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 333151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 333155 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 333159 */     // MIs[1] Operand 1
     /* 333159 */     // No operand predicates
     /* 333159 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 333161 */     // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
     /* 333161 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 333164 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 333168 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333173 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 333175 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 333178 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 333182 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333187 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 333190 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 333194 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 333197 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333202 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333207 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333212 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 333215 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 333219 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333224 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 333227 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 333230 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 333234 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 333241 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 333248 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333253 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333258 */     // GIR_Coverage, 5634,
     /* 333258 */     GIR_EraseRootFromParent_Done,
     /* 333259 */   // Label 6783: @333259
     /* 333259 */   GIM_Reject,
     /* 333260 */ // Label 6754: @333260
     /* 333260 */ GIM_Reject,
     /* 333261 */ // Label 6671: @333261
     /* 333261 */ GIM_Try, /*On fail goto*//*Label 6784*/ GIMT_Encode4(335924),
     /* 333266 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 333269 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 333272 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 333275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333279 */   GIM_Try, /*On fail goto*//*Label 6785*/ GIMT_Encode4(333388), // Rule ID 4202 //
     /* 333284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333288 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 333294 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 333296 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 333300 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 333304 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 333307 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 333311 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 333315 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 333319 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 333321 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 333328 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 333328 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 333331 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 333335 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 333345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 333350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 333355 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 333361 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 333366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 333368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333371 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 333377 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333382 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333387 */     // GIR_Coverage, 4202,
     /* 333387 */     GIR_EraseRootFromParent_Done,
     /* 333388 */   // Label 6785: @333388
     /* 333388 */   GIM_Try, /*On fail goto*//*Label 6786*/ GIMT_Encode4(333497), // Rule ID 4203 //
     /* 333393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333397 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 333403 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 333405 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 333409 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 333413 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 333416 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 333420 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 333424 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 333428 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 333430 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 333437 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 333437 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 333440 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 333444 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 333454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 333459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 333464 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 333470 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 333475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 333477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333480 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 333486 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333491 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333496 */     // GIR_Coverage, 4203,
     /* 333496 */     GIR_EraseRootFromParent_Done,
     /* 333497 */   // Label 6786: @333497
     /* 333497 */   GIM_Try, /*On fail goto*//*Label 6787*/ GIMT_Encode4(333606), // Rule ID 4310 //
     /* 333502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333506 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 333512 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 333514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 333518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 333522 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 333525 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 333529 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 333533 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 333537 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 333539 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 333546 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 333546 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 333549 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 333553 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 333563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 333568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 333573 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 333579 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 333584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 333586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 333595 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333600 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333605 */     // GIR_Coverage, 4310,
     /* 333605 */     GIR_EraseRootFromParent_Done,
     /* 333606 */   // Label 6787: @333606
     /* 333606 */   GIM_Try, /*On fail goto*//*Label 6788*/ GIMT_Encode4(333715), // Rule ID 4311 //
     /* 333611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333615 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 333621 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 333623 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 333627 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 333631 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 333634 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 333638 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 333642 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 333646 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 333648 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 333655 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 333655 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 333658 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 333662 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 333672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 333677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 333682 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 333688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 333693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 333695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333698 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 333704 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333709 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333714 */     // GIR_Coverage, 4311,
     /* 333714 */     GIR_EraseRootFromParent_Done,
     /* 333715 */   // Label 6788: @333715
     /* 333715 */   GIM_Try, /*On fail goto*//*Label 6789*/ GIMT_Encode4(333820), // Rule ID 4208 //
     /* 333720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 333728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 333732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 333736 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 333739 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 333743 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 333747 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 333751 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 333753 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 333760 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 333760 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 333763 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 333767 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 333777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 333782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 333787 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 333793 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 333798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 333800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333803 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 333809 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333814 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333819 */     // GIR_Coverage, 4208,
     /* 333819 */     GIR_EraseRootFromParent_Done,
     /* 333820 */   // Label 6789: @333820
     /* 333820 */   GIM_Try, /*On fail goto*//*Label 6790*/ GIMT_Encode4(333925), // Rule ID 4210 //
     /* 333825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 333833 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 333837 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 333841 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 333844 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 333848 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 333852 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 333856 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 333858 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 333865 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 333865 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 333868 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 333872 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 333882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 333887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 333892 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 333898 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 333903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 333905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333908 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 333914 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333919 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333924 */     // GIR_Coverage, 4210,
     /* 333924 */     GIR_EraseRootFromParent_Done,
     /* 333925 */   // Label 6790: @333925
     /* 333925 */   GIM_Try, /*On fail goto*//*Label 6791*/ GIMT_Encode4(334030), // Rule ID 4316 //
     /* 333930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 333938 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 333942 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 333946 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 333949 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 333953 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 333957 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 333961 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 333963 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 333970 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 333970 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 333973 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 333977 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 333987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 333992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 333997 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334003 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 334019 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334024 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334029 */     // GIR_Coverage, 4316,
     /* 334029 */     GIR_EraseRootFromParent_Done,
     /* 334030 */   // Label 6791: @334030
     /* 334030 */   GIM_Try, /*On fail goto*//*Label 6792*/ GIMT_Encode4(334135), // Rule ID 4318 //
     /* 334035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 334043 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334047 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334051 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334054 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 334058 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 334062 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334066 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 334068 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 334075 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 334075 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334078 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 334082 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 334097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 334102 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334108 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334118 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 334124 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334129 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334134 */     // GIR_Coverage, 4318,
     /* 334134 */     GIR_EraseRootFromParent_Done,
     /* 334135 */   // Label 6792: @334135
     /* 334135 */   GIM_Try, /*On fail goto*//*Label 6793*/ GIMT_Encode4(334239), // Rule ID 4200 //
     /* 334140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334144 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 334150 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 334152 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334156 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334160 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334163 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 334167 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 334171 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334175 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 334177 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 334184 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 334184 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334187 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 334191 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 334206 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334212 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334222 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 334228 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334233 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334238 */     // GIR_Coverage, 4200,
     /* 334238 */     GIR_EraseRootFromParent_Done,
     /* 334239 */   // Label 6793: @334239
     /* 334239 */   GIM_Try, /*On fail goto*//*Label 6794*/ GIMT_Encode4(334343), // Rule ID 4201 //
     /* 334244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334248 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 334254 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 334256 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334260 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334264 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334267 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 334271 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 334275 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334279 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 334281 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 334288 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 334288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 334295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 334310 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334316 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334326 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 334332 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334337 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334342 */     // GIR_Coverage, 4201,
     /* 334342 */     GIR_EraseRootFromParent_Done,
     /* 334343 */   // Label 6794: @334343
     /* 334343 */   GIM_Try, /*On fail goto*//*Label 6795*/ GIMT_Encode4(334447), // Rule ID 4308 //
     /* 334348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334352 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 334358 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 334360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334368 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334371 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 334375 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 334379 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334383 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 334385 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 334392 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 334392 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334395 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 334399 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 334414 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334420 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334430 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 334436 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334441 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334446 */     // GIR_Coverage, 4308,
     /* 334446 */     GIR_EraseRootFromParent_Done,
     /* 334447 */   // Label 6795: @334447
     /* 334447 */   GIM_Try, /*On fail goto*//*Label 6796*/ GIMT_Encode4(334551), // Rule ID 4309 //
     /* 334452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334456 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 334462 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 334464 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334468 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334472 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334475 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 334479 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 334483 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334487 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 334489 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 334496 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 334496 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334499 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 334503 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 334518 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334524 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334534 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 334540 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334545 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334550 */     // GIR_Coverage, 4309,
     /* 334550 */     GIR_EraseRootFromParent_Done,
     /* 334551 */   // Label 6796: @334551
     /* 334551 */   GIM_Try, /*On fail goto*//*Label 6797*/ GIMT_Encode4(334651), // Rule ID 4204 //
     /* 334556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 334564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334572 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334575 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 334579 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 334583 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334587 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 334589 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 334596 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 334596 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334599 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 334603 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 334618 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334624 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334634 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 334640 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334645 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334650 */     // GIR_Coverage, 4204,
     /* 334650 */     GIR_EraseRootFromParent_Done,
     /* 334651 */   // Label 6797: @334651
     /* 334651 */   GIM_Try, /*On fail goto*//*Label 6798*/ GIMT_Encode4(334751), // Rule ID 4206 //
     /* 334656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 334664 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334668 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334672 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334675 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 334679 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 334683 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334687 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 334689 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 334696 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 334696 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334699 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 334703 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 334718 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334724 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 334740 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334745 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334750 */     // GIR_Coverage, 4206,
     /* 334750 */     GIR_EraseRootFromParent_Done,
     /* 334751 */   // Label 6798: @334751
     /* 334751 */   GIM_Try, /*On fail goto*//*Label 6799*/ GIMT_Encode4(334851), // Rule ID 4312 //
     /* 334756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 334764 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334768 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334772 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334775 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 334779 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 334783 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334787 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 334789 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 334796 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 334796 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334799 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 334803 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 334818 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334824 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334834 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 334840 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334845 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334850 */     // GIR_Coverage, 4312,
     /* 334850 */     GIR_EraseRootFromParent_Done,
     /* 334851 */   // Label 6799: @334851
     /* 334851 */   GIM_Try, /*On fail goto*//*Label 6800*/ GIMT_Encode4(334951), // Rule ID 4314 //
     /* 334856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 334864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334872 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334875 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 334879 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 334883 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334887 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 334889 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 334896 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 334896 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334899 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 334903 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 334918 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334924 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334934 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 334940 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334945 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334950 */     // GIR_Coverage, 4314,
     /* 334950 */     GIR_EraseRootFromParent_Done,
     /* 334951 */   // Label 6800: @334951
     /* 334951 */   GIM_Try, /*On fail goto*//*Label 6801*/ GIMT_Encode4(335029), // Rule ID 1933 //
     /* 334956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 334959 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 334967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 334971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 334975 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 334979 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334984 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 334988 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 334992 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 334996 */     // MIs[2] Operand 1
     /* 334996 */     // No operand predicates
     /* 334996 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 335000 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 335004 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 335008 */     // MIs[3] Operand 1
     /* 335008 */     // No operand predicates
     /* 335008 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 335010 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 335010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 335013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335015 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 335017 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 335020 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 335024 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 335027 */     GIR_RootConstrainSelectedInstOperands,
     /* 335028 */     // GIR_Coverage, 1933,
     /* 335028 */     GIR_EraseRootFromParent_Done,
     /* 335029 */   // Label 6801: @335029
     /* 335029 */   GIM_Try, /*On fail goto*//*Label 6802*/ GIMT_Encode4(335096), // Rule ID 5650 //
     /* 335034 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 335042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 335046 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 335050 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 335054 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335059 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 335063 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 335067 */     // MIs[2] Operand 1
     /* 335067 */     // No operand predicates
     /* 335067 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 335071 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 335075 */     // MIs[3] Operand 1
     /* 335075 */     // No operand predicates
     /* 335075 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 335077 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 335077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 335080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335082 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 335084 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 335087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 335091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 335094 */     GIR_RootConstrainSelectedInstOperands,
     /* 335095 */     // GIR_Coverage, 5650,
     /* 335095 */     GIR_EraseRootFromParent_Done,
     /* 335096 */   // Label 6802: @335096
     /* 335096 */   GIM_Try, /*On fail goto*//*Label 6803*/ GIMT_Encode4(335194), // Rule ID 5651 //
     /* 335101 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 335109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 335113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 335117 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 335121 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335126 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 335130 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 335134 */     // MIs[2] Operand 1
     /* 335134 */     // No operand predicates
     /* 335134 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 335138 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 335142 */     // MIs[3] Operand 1
     /* 335142 */     // No operand predicates
     /* 335142 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 335144 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (vector_extract:{ *:[f32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 335144 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 335147 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335151 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335156 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 335159 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 335163 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 335166 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335171 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 335179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335181 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 335183 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 335186 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335189 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 335192 */     GIR_RootConstrainSelectedInstOperands,
     /* 335193 */     // GIR_Coverage, 5651,
     /* 335193 */     GIR_EraseRootFromParent_Done,
     /* 335194 */   // Label 6803: @335194
     /* 335194 */   GIM_Try, /*On fail goto*//*Label 6804*/ GIMT_Encode4(335261), // Rule ID 5674 //
     /* 335199 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 335207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 335211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 335215 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 335219 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335224 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 335228 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 335232 */     // MIs[2] Operand 1
     /* 335232 */     // No operand predicates
     /* 335232 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 335236 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 335240 */     // MIs[3] Operand 1
     /* 335240 */     // No operand predicates
     /* 335240 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 335242 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 335242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 335245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335247 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 335249 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 335252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 335256 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 335259 */     GIR_RootConstrainSelectedInstOperands,
     /* 335260 */     // GIR_Coverage, 5674,
     /* 335260 */     GIR_EraseRootFromParent_Done,
     /* 335261 */   // Label 6804: @335261
     /* 335261 */   GIM_Try, /*On fail goto*//*Label 6805*/ GIMT_Encode4(335359), // Rule ID 5675 //
     /* 335266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 335274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 335278 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 335282 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 335286 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335291 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 335295 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 335299 */     // MIs[2] Operand 1
     /* 335299 */     // No operand predicates
     /* 335299 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 335303 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 335307 */     // MIs[3] Operand 1
     /* 335307 */     // No operand predicates
     /* 335307 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 335309 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 335309 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 335312 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335316 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335321 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 335324 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 335328 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 335331 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335336 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 335344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335346 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 335348 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 335351 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335354 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 335357 */     GIR_RootConstrainSelectedInstOperands,
     /* 335358 */     // GIR_Coverage, 5675,
     /* 335358 */     GIR_EraseRootFromParent_Done,
     /* 335359 */   // Label 6805: @335359
     /* 335359 */   GIM_Try, /*On fail goto*//*Label 6806*/ GIMT_Encode4(335425), // Rule ID 5609 //
     /* 335364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 335372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335376 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 335380 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 335382 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), FPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[i32] }:$Rn, ssub:{ *:[i32] })
     /* 335382 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 335385 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 335389 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335394 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 335399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335401 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 335406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 335409 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335414 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335419 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335424 */     // GIR_Coverage, 5609,
     /* 335424 */     GIR_EraseRootFromParent_Done,
     /* 335425 */   // Label 6806: @335425
     /* 335425 */   GIM_Try, /*On fail goto*//*Label 6807*/ GIMT_Encode4(335491), // Rule ID 5617 //
     /* 335430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 335438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335442 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 335446 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 335448 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] })
     /* 335448 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 335451 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 335455 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335460 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 335465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335467 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 335472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 335475 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335480 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335485 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335490 */     // GIR_Coverage, 5617,
     /* 335490 */     GIR_EraseRootFromParent_Done,
     /* 335491 */   // Label 6807: @335491
     /* 335491 */   GIM_Try, /*On fail goto*//*Label 6808*/ GIMT_Encode4(335544), // Rule ID 5626 //
     /* 335496 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 335504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 335508 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 335512 */     // MIs[1] Operand 1
     /* 335512 */     // No operand predicates
     /* 335512 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 335516 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 335520 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 335524 */     // MIs[2] Operand 1
     /* 335524 */     // No operand predicates
     /* 335524 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335526 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (INSvi32gpr:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, WZR:{ *:[i32] })
     /* 335526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 335529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335531 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 335533 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 335536 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 335542 */     GIR_RootConstrainSelectedInstOperands,
     /* 335543 */     // GIR_Coverage, 5626,
     /* 335543 */     GIR_EraseRootFromParent_Done,
     /* 335544 */   // Label 6808: @335544
     /* 335544 */   GIM_Try, /*On fail goto*//*Label 6809*/ GIMT_Encode4(335613), // Rule ID 6343 //
     /* 335549 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 335557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335561 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335564 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 335568 */     // MIs[1] Rn
     /* 335568 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 335572 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 335577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 335581 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 335585 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 335589 */     // MIs[2] Operand 1
     /* 335589 */     // No operand predicates
     /* 335589 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335591 */     // (vector_insert:{ *:[v4i32] } VecListOne128:{ *:[v4i32] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (LD1i32:{ *:[v4i32] } VecListOne128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 335591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 335594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335596 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 335598 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 335601 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 335605 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 335611 */     GIR_RootConstrainSelectedInstOperands,
     /* 335612 */     // GIR_Coverage, 6343,
     /* 335612 */     GIR_EraseRootFromParent_Done,
     /* 335613 */   // Label 6809: @335613
     /* 335613 */   GIM_Try, /*On fail goto*//*Label 6810*/ GIMT_Encode4(335682), // Rule ID 6344 //
     /* 335618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 335626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335630 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335633 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 335637 */     // MIs[1] Rn
     /* 335637 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 335641 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 335646 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 335650 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 335654 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 335658 */     // MIs[2] Operand 1
     /* 335658 */     // No operand predicates
     /* 335658 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335660 */     // (vector_insert:{ *:[v4f32] } VecListOne128:{ *:[v4f32] }:$Rd, (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (LD1i32:{ *:[v4f32] } VecListOne128:{ *:[v4f32] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 335660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 335663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335665 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 335667 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 335670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 335674 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 335680 */     GIR_RootConstrainSelectedInstOperands,
     /* 335681 */     // GIR_Coverage, 6344,
     /* 335681 */     GIR_EraseRootFromParent_Done,
     /* 335682 */   // Label 6810: @335682
     /* 335682 */   GIM_Try, /*On fail goto*//*Label 6811*/ GIMT_Encode4(335783), // Rule ID 5684 //
     /* 335687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 335691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 335695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 335699 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 335708 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 335712 */     // MIs[2] Operand 1
     /* 335712 */     // No operand predicates
     /* 335712 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335714 */     // (vector_insert:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src, (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR32:{ *:[f32] }:$Sn, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 335714 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 335717 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 335721 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335726 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 335728 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 335731 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 335735 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335740 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 335743 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 335747 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 335750 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335755 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335760 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 335768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335770 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 335772 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immd
     /* 335775 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335781 */     GIR_RootConstrainSelectedInstOperands,
     /* 335782 */     // GIR_Coverage, 5684,
     /* 335782 */     GIR_EraseRootFromParent_Done,
     /* 335783 */   // Label 6811: @335783
     /* 335783 */   GIM_Try, /*On fail goto*//*Label 6812*/ GIMT_Encode4(335827), // Rule ID 1929 //
     /* 335788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 335791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 335799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 335803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 335807 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 335811 */     // MIs[1] Operand 1
     /* 335811 */     // No operand predicates
     /* 335811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 335813 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (INSvi32gpr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
     /* 335813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 335816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335818 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 335820 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 335823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 335825 */     GIR_RootConstrainSelectedInstOperands,
     /* 335826 */     // GIR_Coverage, 1929,
     /* 335826 */     GIR_EraseRootFromParent_Done,
     /* 335827 */   // Label 6812: @335827
     /* 335827 */   GIM_Try, /*On fail goto*//*Label 6813*/ GIMT_Encode4(335923), // Rule ID 5631 //
     /* 335832 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 335844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 335848 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 335852 */     // MIs[1] Operand 1
     /* 335852 */     // No operand predicates
     /* 335852 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 335854 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 335854 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 335857 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 335861 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335866 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 335868 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 335871 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 335875 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335880 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 335883 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 335887 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 335890 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335895 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335900 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 335908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335910 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 335912 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 335915 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335921 */     GIR_RootConstrainSelectedInstOperands,
     /* 335922 */     // GIR_Coverage, 5631,
     /* 335922 */     GIR_EraseRootFromParent_Done,
     /* 335923 */   // Label 6813: @335923
     /* 335923 */   GIM_Reject,
     /* 335924 */ // Label 6784: @335924
     /* 335924 */ GIM_Reject,
     /* 335925 */ // Label 6672: @335925
     /* 335925 */ GIM_Try, /*On fail goto*//*Label 6814*/ GIMT_Encode4(337768),
     /* 335930 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 335933 */   GIM_Try, /*On fail goto*//*Label 6815*/ GIMT_Encode4(336059), // Rule ID 4142 //
     /* 335938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 335941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 335944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335952 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 335958 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 335960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 335964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335968 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335971 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 335975 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 335982 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 335986 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 335990 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335992 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 335999 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 335999 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 336002 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 336006 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 336021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 336026 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 336032 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336042 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 336048 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336053 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 336058 */     // GIR_Coverage, 4142,
     /* 336058 */     GIR_EraseRootFromParent_Done,
     /* 336059 */   // Label 6815: @336059
     /* 336059 */   GIM_Try, /*On fail goto*//*Label 6816*/ GIMT_Encode4(336185), // Rule ID 4143 //
     /* 336064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 336067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 336070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336078 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 336084 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 336086 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 336090 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 336094 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336097 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 336101 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 336108 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 336112 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 336116 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 336118 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 336125 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 336125 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 336128 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 336132 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 336147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 336152 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 336158 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336168 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 336174 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336179 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 336184 */     // GIR_Coverage, 4143,
     /* 336184 */     GIR_EraseRootFromParent_Done,
     /* 336185 */   // Label 6816: @336185
     /* 336185 */   GIM_Try, /*On fail goto*//*Label 6817*/ GIMT_Encode4(336307), // Rule ID 4148 //
     /* 336190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 336193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 336196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 336208 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 336212 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 336216 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336219 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 336223 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 336230 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 336234 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 336238 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 336240 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 336247 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 336247 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 336250 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 336254 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 336269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 336274 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 336280 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336290 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 336296 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336301 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 336306 */     // GIR_Coverage, 4148,
     /* 336306 */     GIR_EraseRootFromParent_Done,
     /* 336307 */   // Label 6817: @336307
     /* 336307 */   GIM_Try, /*On fail goto*//*Label 6818*/ GIMT_Encode4(336429), // Rule ID 4150 //
     /* 336312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 336315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 336318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 336330 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 336334 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 336338 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336341 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 336345 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 336352 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 336356 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 336360 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 336362 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 336369 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 336369 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 336372 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 336376 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 336391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 336396 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 336402 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336412 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 336418 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336423 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 336428 */     // GIR_Coverage, 4150,
     /* 336428 */     GIR_EraseRootFromParent_Done,
     /* 336429 */   // Label 6818: @336429
     /* 336429 */   GIM_Try, /*On fail goto*//*Label 6819*/ GIMT_Encode4(336550), // Rule ID 4140 //
     /* 336434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 336437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 336440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336448 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 336454 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 336456 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 336460 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 336464 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336467 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 336471 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 336478 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 336482 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 336486 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 336488 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 336495 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 336495 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 336498 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 336502 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 336517 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 336523 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336533 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 336539 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336544 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 336549 */     // GIR_Coverage, 4140,
     /* 336549 */     GIR_EraseRootFromParent_Done,
     /* 336550 */   // Label 6819: @336550
     /* 336550 */   GIM_Try, /*On fail goto*//*Label 6820*/ GIMT_Encode4(336671), // Rule ID 4141 //
     /* 336555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 336558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 336561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336569 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 336575 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 336577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 336581 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 336585 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336588 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 336592 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 336599 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 336603 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 336607 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 336609 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 336616 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 336616 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 336619 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 336623 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 336638 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 336644 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336654 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 336660 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336665 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 336670 */     // GIR_Coverage, 4141,
     /* 336670 */     GIR_EraseRootFromParent_Done,
     /* 336671 */   // Label 6820: @336671
     /* 336671 */   GIM_Try, /*On fail goto*//*Label 6821*/ GIMT_Encode4(336788), // Rule ID 4144 //
     /* 336676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 336679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 336682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 336694 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 336698 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 336702 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336705 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 336709 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 336716 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 336720 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 336724 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 336726 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 336733 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 336733 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 336736 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 336740 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 336755 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 336761 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336771 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 336777 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336782 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 336787 */     // GIR_Coverage, 4144,
     /* 336787 */     GIR_EraseRootFromParent_Done,
     /* 336788 */   // Label 6821: @336788
     /* 336788 */   GIM_Try, /*On fail goto*//*Label 6822*/ GIMT_Encode4(336905), // Rule ID 4146 //
     /* 336793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 336796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 336799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 336811 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 336815 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 336819 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336822 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 336826 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 336833 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 336837 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 336841 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 336843 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 336850 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 336850 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 336853 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 336857 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 336872 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 336878 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336888 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 336894 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336899 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 336904 */     // GIR_Coverage, 4146,
     /* 336904 */     GIR_EraseRootFromParent_Done,
     /* 336905 */   // Label 6822: @336905
     /* 336905 */   GIM_Try, /*On fail goto*//*Label 6823*/ GIMT_Encode4(337045), // Rule ID 5664 //
     /* 336910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 336913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 336916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336920 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 336928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 336932 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 336936 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 336940 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336945 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 336949 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 336953 */     // MIs[2] Operand 1
     /* 336953 */     // No operand predicates
     /* 336953 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 336957 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 336961 */     // MIs[3] Operand 1
     /* 336961 */     // No operand predicates
     /* 336961 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 336963 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 336963 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 336966 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336970 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336975 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 336978 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 336982 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 336985 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336990 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336995 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 336998 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 337002 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337007 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337010 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 337013 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 337017 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 337020 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337027 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 337034 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337039 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337044 */     // GIR_Coverage, 5664,
     /* 337044 */     GIR_EraseRootFromParent_Done,
     /* 337045 */   // Label 6823: @337045
     /* 337045 */   GIM_Try, /*On fail goto*//*Label 6824*/ GIMT_Encode4(337216), // Rule ID 5665 //
     /* 337050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 337053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 337056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337060 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 337068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 337072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 337076 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 337080 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337085 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 337089 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 337093 */     // MIs[2] Operand 1
     /* 337093 */     // No operand predicates
     /* 337093 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 337097 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 337101 */     // MIs[3] Operand 1
     /* 337101 */     // No operand predicates
     /* 337101 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 337103 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 337103 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 337106 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337110 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337115 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 337118 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 337122 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 337125 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337130 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337135 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 337138 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337142 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337147 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 337150 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 337154 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 337157 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337162 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337167 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 337170 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 337174 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337179 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337182 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 337185 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 337188 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 337191 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337198 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 337205 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337210 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337215 */     // GIR_Coverage, 5665,
     /* 337215 */     GIR_EraseRootFromParent_Done,
     /* 337216 */   // Label 6824: @337216
     /* 337216 */   GIM_Try, /*On fail goto*//*Label 6825*/ GIMT_Encode4(337295), // Rule ID 5596 //
     /* 337221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 337224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 337227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 337239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 337243 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 337247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337249 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 337249 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 337252 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337256 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337261 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 337265 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337278 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 337284 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337289 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337294 */     // GIR_Coverage, 5596,
     /* 337294 */     GIR_EraseRootFromParent_Done,
     /* 337295 */   // Label 6825: @337295
     /* 337295 */   GIM_Try, /*On fail goto*//*Label 6826*/ GIMT_Encode4(337444), // Rule ID 6360 //
     /* 337300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 337303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 337306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 337318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 337322 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337325 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 337329 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 337336 */     // MIs[1] Rn
     /* 337336 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 337340 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 337345 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 337349 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 337353 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 337357 */     // MIs[2] Operand 1
     /* 337357 */     // No operand predicates
     /* 337357 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337359 */     // (vector_insert:{ *:[v8i8] } VecListOne64:{ *:[v8i8] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (LD1i8:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 337359 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 337362 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337366 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337371 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 337374 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 337378 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 337381 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337386 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337391 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 337394 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 337398 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337403 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337406 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 337409 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 337413 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 337419 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337426 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 337433 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337438 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337443 */     // GIR_Coverage, 6360,
     /* 337443 */     GIR_EraseRootFromParent_Done,
     /* 337444 */   // Label 6826: @337444
     /* 337444 */   GIM_Try, /*On fail goto*//*Label 6827*/ GIMT_Encode4(337579), // Rule ID 5635 //
     /* 337449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 337452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 337455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337459 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 337467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 337471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 337475 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 337479 */     // MIs[1] Operand 1
     /* 337479 */     // No operand predicates
     /* 337479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337481 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
     /* 337481 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 337484 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 337488 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337493 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 337495 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 337498 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 337502 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337507 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 337510 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 337514 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 337517 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337522 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337527 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337532 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 337535 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8gpr),
     /* 337539 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337544 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337547 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 337550 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 337554 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337561 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 337568 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337573 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337578 */     // GIR_Coverage, 5635,
     /* 337578 */     GIR_EraseRootFromParent_Done,
     /* 337579 */   // Label 6827: @337579
     /* 337579 */   GIM_Try, /*On fail goto*//*Label 6828*/ GIMT_Encode4(337767), // Rule ID 5636 //
     /* 337584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 337587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 337590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337594 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 337602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 337606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 337610 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 337614 */     // MIs[1] Operand 1
     /* 337614 */     // No operand predicates
     /* 337614 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337616 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, FPR8:{ *:[i8] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), FPR8:{ *:[i8] }:$Rm, bsub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 337616 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s8,
     /* 337619 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 337623 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337628 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 337630 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s8,
     /* 337633 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 337637 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337642 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 337645 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 337649 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 337652 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337657 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337662 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 337667 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 337670 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 337674 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337679 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 337681 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 337684 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 337688 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337693 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 337696 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 337700 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 337703 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337708 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337713 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337718 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 337721 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 337725 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337730 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337733 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 337736 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 337739 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 337742 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337749 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 337756 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337761 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337766 */     // GIR_Coverage, 5636,
     /* 337766 */     GIR_EraseRootFromParent_Done,
     /* 337767 */   // Label 6828: @337767
     /* 337767 */   GIM_Reject,
     /* 337768 */ // Label 6814: @337768
     /* 337768 */ GIM_Reject,
     /* 337769 */ // Label 6673: @337769
     /* 337769 */ GIM_Try, /*On fail goto*//*Label 6829*/ GIMT_Encode4(340743),
     /* 337774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 337777 */   GIM_Try, /*On fail goto*//*Label 6830*/ GIMT_Encode4(337903), // Rule ID 4166 //
     /* 337782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 337785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 337788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337796 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 337802 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 337804 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337808 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 337812 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337815 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 337819 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 337826 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 337830 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 337834 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337836 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 337843 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 337843 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 337846 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 337850 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 337865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 337870 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 337876 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337886 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 337892 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337897 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 337902 */     // GIR_Coverage, 4166,
     /* 337902 */     GIR_EraseRootFromParent_Done,
     /* 337903 */   // Label 6830: @337903
     /* 337903 */   GIM_Try, /*On fail goto*//*Label 6831*/ GIMT_Encode4(338029), // Rule ID 4167 //
     /* 337908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 337911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 337914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337922 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 337928 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 337930 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337934 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 337938 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337941 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 337945 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 337952 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 337956 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 337960 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337962 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 337969 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 337969 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 337972 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 337976 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 337991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 337996 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338002 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338012 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 338018 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338023 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 338028 */     // GIR_Coverage, 4167,
     /* 338028 */     GIR_EraseRootFromParent_Done,
     /* 338029 */   // Label 6831: @338029
     /* 338029 */   GIM_Try, /*On fail goto*//*Label 6832*/ GIMT_Encode4(338148), // Rule ID 4274 //
     /* 338034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 338037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 338040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338048 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 338054 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 338056 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338060 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338064 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338067 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338071 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338075 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338079 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338081 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 338088 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 338088 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 338091 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 338095 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338115 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338121 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338131 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 338137 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338142 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 338147 */     // GIR_Coverage, 4274,
     /* 338147 */     GIR_EraseRootFromParent_Done,
     /* 338148 */   // Label 6832: @338148
     /* 338148 */   GIM_Try, /*On fail goto*//*Label 6833*/ GIMT_Encode4(338267), // Rule ID 4275 //
     /* 338153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 338156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 338159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338167 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 338173 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 338175 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338179 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338183 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338186 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338190 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338194 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338198 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338200 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 338207 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 338207 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 338210 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 338214 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338234 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338240 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338250 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 338256 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338261 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 338266 */     // GIR_Coverage, 4275,
     /* 338266 */     GIR_EraseRootFromParent_Done,
     /* 338267 */   // Label 6833: @338267
     /* 338267 */   GIM_Try, /*On fail goto*//*Label 6834*/ GIMT_Encode4(338389), // Rule ID 4172 //
     /* 338272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 338275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 338278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 338290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338298 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338301 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338305 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 338312 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338316 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338320 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338322 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 338329 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 338329 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 338332 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 338336 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338356 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338362 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338372 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 338378 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338383 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 338388 */     // GIR_Coverage, 4172,
     /* 338388 */     GIR_EraseRootFromParent_Done,
     /* 338389 */   // Label 6834: @338389
     /* 338389 */   GIM_Try, /*On fail goto*//*Label 6835*/ GIMT_Encode4(338511), // Rule ID 4174 //
     /* 338394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 338397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 338400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 338412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338420 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338423 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338427 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 338434 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338438 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338442 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338444 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 338451 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 338451 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 338454 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 338458 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338478 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338484 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338494 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 338500 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338505 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 338510 */     // GIR_Coverage, 4174,
     /* 338510 */     GIR_EraseRootFromParent_Done,
     /* 338511 */   // Label 6835: @338511
     /* 338511 */   GIM_Try, /*On fail goto*//*Label 6836*/ GIMT_Encode4(338626), // Rule ID 4280 //
     /* 338516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 338519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 338522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 338534 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338538 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338542 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338545 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338549 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338553 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338557 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338559 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 338566 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 338566 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 338569 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 338573 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338593 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338599 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338609 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 338615 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338620 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 338625 */     // GIR_Coverage, 4280,
     /* 338625 */     GIR_EraseRootFromParent_Done,
     /* 338626 */   // Label 6836: @338626
     /* 338626 */   GIM_Try, /*On fail goto*//*Label 6837*/ GIMT_Encode4(338741), // Rule ID 4282 //
     /* 338631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 338634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 338637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 338649 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338653 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338657 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338660 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338664 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338668 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338672 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338674 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 338681 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 338681 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 338684 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 338688 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338708 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338714 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338724 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 338730 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338735 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 338740 */     // GIR_Coverage, 4282,
     /* 338740 */     GIR_EraseRootFromParent_Done,
     /* 338741 */   // Label 6837: @338741
     /* 338741 */   GIM_Try, /*On fail goto*//*Label 6838*/ GIMT_Encode4(338862), // Rule ID 4164 //
     /* 338746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 338749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 338752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338760 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 338766 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 338768 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338772 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338776 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338779 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338783 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 338790 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338794 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338798 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338800 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 338807 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 338807 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 338810 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 338814 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 338829 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338835 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338845 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 338851 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338856 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 338861 */     // GIR_Coverage, 4164,
     /* 338861 */     GIR_EraseRootFromParent_Done,
     /* 338862 */   // Label 6838: @338862
     /* 338862 */   GIM_Try, /*On fail goto*//*Label 6839*/ GIMT_Encode4(338983), // Rule ID 4165 //
     /* 338867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 338870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 338873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338881 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 338887 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 338889 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338893 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338897 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338900 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338904 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 338911 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338915 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338919 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338921 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 338928 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 338928 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 338931 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 338935 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 338950 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338956 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338966 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 338972 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338977 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 338982 */     // GIR_Coverage, 4165,
     /* 338982 */     GIR_EraseRootFromParent_Done,
     /* 338983 */   // Label 6839: @338983
     /* 338983 */   GIM_Try, /*On fail goto*//*Label 6840*/ GIMT_Encode4(339097), // Rule ID 4272 //
     /* 338988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 338991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 338994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339002 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 339008 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 339010 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339014 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339018 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339021 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 339025 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 339029 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339033 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 339035 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 339042 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 339042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 339045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 339049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 339064 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339080 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 339086 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339091 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 339096 */     // GIR_Coverage, 4272,
     /* 339096 */     GIR_EraseRootFromParent_Done,
     /* 339097 */   // Label 6840: @339097
     /* 339097 */   GIM_Try, /*On fail goto*//*Label 6841*/ GIMT_Encode4(339211), // Rule ID 4273 //
     /* 339102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 339105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 339108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339116 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 339122 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 339124 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339128 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339132 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339135 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 339139 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 339143 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339147 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 339149 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 339156 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 339156 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 339159 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 339163 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 339178 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339184 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339194 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 339200 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339205 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 339210 */     // GIR_Coverage, 4273,
     /* 339210 */     GIR_EraseRootFromParent_Done,
     /* 339211 */   // Label 6841: @339211
     /* 339211 */   GIM_Try, /*On fail goto*//*Label 6842*/ GIMT_Encode4(339328), // Rule ID 4168 //
     /* 339216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 339219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 339222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 339234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339238 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339242 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339245 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 339249 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 339256 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 339260 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339264 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 339266 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 339273 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 339273 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 339276 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 339280 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 339295 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339301 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339311 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 339317 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339322 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 339327 */     // GIR_Coverage, 4168,
     /* 339327 */     GIR_EraseRootFromParent_Done,
     /* 339328 */   // Label 6842: @339328
     /* 339328 */   GIM_Try, /*On fail goto*//*Label 6843*/ GIMT_Encode4(339445), // Rule ID 4170 //
     /* 339333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 339336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 339339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 339351 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339355 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339359 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339362 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 339366 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 339373 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 339377 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339381 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 339383 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 339390 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 339390 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 339393 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 339397 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 339412 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339418 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339428 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 339434 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339439 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 339444 */     // GIR_Coverage, 4170,
     /* 339444 */     GIR_EraseRootFromParent_Done,
     /* 339445 */   // Label 6843: @339445
     /* 339445 */   GIM_Try, /*On fail goto*//*Label 6844*/ GIMT_Encode4(339555), // Rule ID 4276 //
     /* 339450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 339453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 339456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 339468 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339472 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339476 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339479 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 339483 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 339487 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339491 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 339493 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 339500 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 339500 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 339503 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 339507 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 339522 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339528 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339538 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 339544 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339549 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 339554 */     // GIR_Coverage, 4276,
     /* 339554 */     GIR_EraseRootFromParent_Done,
     /* 339555 */   // Label 6844: @339555
     /* 339555 */   GIM_Try, /*On fail goto*//*Label 6845*/ GIMT_Encode4(339665), // Rule ID 4278 //
     /* 339560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 339563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 339566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 339578 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339582 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339586 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339589 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 339593 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 339597 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339601 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 339603 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 339610 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 339610 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 339613 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 339617 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 339632 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339638 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339648 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 339654 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339659 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 339664 */     // GIR_Coverage, 4278,
     /* 339664 */     GIR_EraseRootFromParent_Done,
     /* 339665 */   // Label 6845: @339665
     /* 339665 */   GIM_Try, /*On fail goto*//*Label 6846*/ GIMT_Encode4(339753), // Rule ID 1932 //
     /* 339670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 339673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 339676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 339679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 339691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 339695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 339699 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 339703 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339708 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 339712 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339716 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 339720 */     // MIs[2] Operand 1
     /* 339720 */     // No operand predicates
     /* 339720 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 339724 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339728 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 339732 */     // MIs[3] Operand 1
     /* 339732 */     // No operand predicates
     /* 339732 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 339734 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 339734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 339737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339739 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 339741 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 339744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 339748 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 339751 */     GIR_RootConstrainSelectedInstOperands,
     /* 339752 */     // GIR_Coverage, 1932,
     /* 339752 */     GIR_EraseRootFromParent_Done,
     /* 339753 */   // Label 6846: @339753
     /* 339753 */   GIM_Try, /*On fail goto*//*Label 6847*/ GIMT_Encode4(339830), // Rule ID 5644 //
     /* 339758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 339761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 339764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339768 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 339776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 339780 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 339784 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 339788 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339793 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 339797 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339801 */     // MIs[2] Operand 1
     /* 339801 */     // No operand predicates
     /* 339801 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 339805 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339809 */     // MIs[3] Operand 1
     /* 339809 */     // No operand predicates
     /* 339809 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 339811 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 339811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 339814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339816 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 339818 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 339821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 339825 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 339828 */     GIR_RootConstrainSelectedInstOperands,
     /* 339829 */     // GIR_Coverage, 5644,
     /* 339829 */     GIR_EraseRootFromParent_Done,
     /* 339830 */   // Label 6847: @339830
     /* 339830 */   GIM_Try, /*On fail goto*//*Label 6848*/ GIMT_Encode4(339938), // Rule ID 5645 //
     /* 339835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 339838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 339841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339845 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 339853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 339857 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 339861 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 339865 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339870 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 339874 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339878 */     // MIs[2] Operand 1
     /* 339878 */     // No operand predicates
     /* 339878 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 339882 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339886 */     // MIs[3] Operand 1
     /* 339886 */     // No operand predicates
     /* 339886 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 339888 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (vector_extract:{ *:[f16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 339888 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 339891 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339895 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339900 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 339903 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 339907 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 339910 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339915 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 339923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339925 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 339927 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 339930 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339933 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 339936 */     GIR_RootConstrainSelectedInstOperands,
     /* 339937 */     // GIR_Coverage, 5645,
     /* 339937 */     GIR_EraseRootFromParent_Done,
     /* 339938 */   // Label 6848: @339938
     /* 339938 */   GIM_Try, /*On fail goto*//*Label 6849*/ GIMT_Encode4(340015), // Rule ID 5668 //
     /* 339943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 339946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 339949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339953 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 339961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 339965 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 339969 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 339973 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339978 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 339982 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339986 */     // MIs[2] Operand 1
     /* 339986 */     // No operand predicates
     /* 339986 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 339990 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339994 */     // MIs[3] Operand 1
     /* 339994 */     // No operand predicates
     /* 339994 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 339996 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 339996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 339999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340001 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 340003 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 340006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 340010 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 340013 */     GIR_RootConstrainSelectedInstOperands,
     /* 340014 */     // GIR_Coverage, 5668,
     /* 340014 */     GIR_EraseRootFromParent_Done,
     /* 340015 */   // Label 6849: @340015
     /* 340015 */   GIM_Try, /*On fail goto*//*Label 6850*/ GIMT_Encode4(340123), // Rule ID 5669 //
     /* 340020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 340023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 340026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340030 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 340038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 340042 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 340046 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 340050 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340055 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 340059 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340063 */     // MIs[2] Operand 1
     /* 340063 */     // No operand predicates
     /* 340063 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 340067 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340071 */     // MIs[3] Operand 1
     /* 340071 */     // No operand predicates
     /* 340071 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 340073 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 340073 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 340076 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 340080 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340085 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 340088 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 340092 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 340095 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340100 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 340108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340110 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 340112 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 340115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340118 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 340121 */     GIR_RootConstrainSelectedInstOperands,
     /* 340122 */     // GIR_Coverage, 5669,
     /* 340122 */     GIR_EraseRootFromParent_Done,
     /* 340123 */   // Label 6850: @340123
     /* 340123 */   GIM_Try, /*On fail goto*//*Label 6851*/ GIMT_Encode4(340202), // Rule ID 5599 //
     /* 340128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 340131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 340134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 340146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 340150 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 340154 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340156 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 340156 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 340159 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 340163 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340168 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 340172 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 340177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 340180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340185 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 340191 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340196 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 340201 */     // GIR_Coverage, 5599,
     /* 340201 */     GIR_EraseRootFromParent_Done,
     /* 340202 */   // Label 6851: @340202
     /* 340202 */   GIM_Try, /*On fail goto*//*Label 6852*/ GIMT_Encode4(340278), // Rule ID 5605 //
     /* 340207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 340210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 340213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 340225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 340229 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 340233 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340235 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 340235 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 340238 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340242 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340247 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340254 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 340259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 340262 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340267 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340272 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 340277 */     // GIR_Coverage, 5605,
     /* 340277 */     GIR_EraseRootFromParent_Done,
     /* 340278 */   // Label 6852: @340278
     /* 340278 */   GIM_Try, /*On fail goto*//*Label 6853*/ GIMT_Encode4(340354), // Rule ID 5615 //
     /* 340283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 340286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 340289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 340301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 340305 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 340309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340311 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 340311 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 340314 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340318 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340323 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340330 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 340335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 340338 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340343 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340348 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 340353 */     // GIR_Coverage, 5615,
     /* 340353 */     GIR_EraseRootFromParent_Done,
     /* 340354 */   // Label 6853: @340354
     /* 340354 */   GIM_Try, /*On fail goto*//*Label 6854*/ GIMT_Encode4(340417), // Rule ID 5624 //
     /* 340359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 340362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 340365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 340377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 340381 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 340385 */     // MIs[1] Operand 1
     /* 340385 */     // No operand predicates
     /* 340385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 340389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340393 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 340397 */     // MIs[2] Operand 1
     /* 340397 */     // No operand predicates
     /* 340397 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340399 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (INSvi16gpr:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, WZR:{ *:[i32] })
     /* 340399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 340402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340404 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 340406 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 340409 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 340415 */     GIR_RootConstrainSelectedInstOperands,
     /* 340416 */     // GIR_Coverage, 5624,
     /* 340416 */     GIR_EraseRootFromParent_Done,
     /* 340417 */   // Label 6854: @340417
     /* 340417 */   GIM_Try, /*On fail goto*//*Label 6855*/ GIMT_Encode4(340503), // Rule ID 6342 //
     /* 340422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 340425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 340428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 340440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 340444 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340447 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 340451 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 340458 */     // MIs[1] Rn
     /* 340458 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 340462 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 340467 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 340471 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340475 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 340479 */     // MIs[2] Operand 1
     /* 340479 */     // No operand predicates
     /* 340479 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340481 */     // (vector_insert:{ *:[v8i16] } VecListOne128:{ *:[v8i16] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (LD1i16:{ *:[v8i16] } VecListOne128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 340481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 340484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340486 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 340488 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 340491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 340495 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 340501 */     GIR_RootConstrainSelectedInstOperands,
     /* 340502 */     // GIR_Coverage, 6342,
     /* 340502 */     GIR_EraseRootFromParent_Done,
     /* 340503 */   // Label 6855: @340503
     /* 340503 */   GIM_Try, /*On fail goto*//*Label 6856*/ GIMT_Encode4(340582), // Rule ID 6347 //
     /* 340508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 340511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 340514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 340526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 340530 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340533 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 340537 */     // MIs[1] Rn
     /* 340537 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 340541 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 340546 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 340550 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340554 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 340558 */     // MIs[2] Operand 1
     /* 340558 */     // No operand predicates
     /* 340558 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340560 */     // (vector_insert:{ *:[v8f16] } VecListOne128:{ *:[v8f16] }:$Rd, (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (LD1i16:{ *:[v8f16] } VecListOne128:{ *:[v8f16] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 340560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 340563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340565 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 340567 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 340570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 340574 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 340580 */     GIR_RootConstrainSelectedInstOperands,
     /* 340581 */     // GIR_Coverage, 6347,
     /* 340581 */     GIR_EraseRootFromParent_Done,
     /* 340582 */   // Label 6856: @340582
     /* 340582 */   GIM_Try, /*On fail goto*//*Label 6857*/ GIMT_Encode4(340636), // Rule ID 1928 //
     /* 340587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 340590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 340593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 340596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340600 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 340608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 340612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340616 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 340620 */     // MIs[1] Operand 1
     /* 340620 */     // No operand predicates
     /* 340620 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340622 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (INSvi16gpr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
     /* 340622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 340625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340627 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 340629 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 340632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 340634 */     GIR_RootConstrainSelectedInstOperands,
     /* 340635 */     // GIR_Coverage, 1928,
     /* 340635 */     GIR_EraseRootFromParent_Done,
     /* 340636 */   // Label 6857: @340636
     /* 340636 */   GIM_Try, /*On fail goto*//*Label 6858*/ GIMT_Encode4(340742), // Rule ID 5629 //
     /* 340641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 340644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 340647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340651 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 340659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 340663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340667 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 340671 */     // MIs[1] Operand 1
     /* 340671 */     // No operand predicates
     /* 340671 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340673 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 340673 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 340676 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340680 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340685 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 340687 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 340690 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340694 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340699 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 340702 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 340706 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 340709 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340714 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340719 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 340724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 340727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340729 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 340731 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 340734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340740 */     GIR_RootConstrainSelectedInstOperands,
     /* 340741 */     // GIR_Coverage, 5629,
     /* 340741 */     GIR_EraseRootFromParent_Done,
     /* 340742 */   // Label 6858: @340742
     /* 340742 */   GIM_Reject,
     /* 340743 */ // Label 6829: @340743
     /* 340743 */ GIM_Reject,
     /* 340744 */ // Label 6674: @340744
     /* 340744 */ GIM_Try, /*On fail goto*//*Label 6859*/ GIMT_Encode4(342323),
     /* 340749 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 340752 */   GIM_Try, /*On fail goto*//*Label 6860*/ GIMT_Encode4(340878), // Rule ID 4130 //
     /* 340757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 340760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 340763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340771 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 340777 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 340779 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 340783 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 340787 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340790 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 340794 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 340801 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 340805 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 340809 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340811 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 340818 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 340818 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 340821 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 340825 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 340835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 340840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 340845 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 340851 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 340856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340861 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 340867 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340872 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 340877 */     // GIR_Coverage, 4130,
     /* 340877 */     GIR_EraseRootFromParent_Done,
     /* 340878 */   // Label 6860: @340878
     /* 340878 */   GIM_Try, /*On fail goto*//*Label 6861*/ GIMT_Encode4(341004), // Rule ID 4131 //
     /* 340883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 340886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 340889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340897 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 340903 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 340905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 340909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 340913 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340916 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 340920 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 340927 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 340931 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 340935 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340937 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 340944 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 340944 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 340947 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 340951 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 340961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 340966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 340971 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 340977 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 340982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340987 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 340993 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340998 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 341003 */     // GIR_Coverage, 4131,
     /* 341003 */     GIR_EraseRootFromParent_Done,
     /* 341004 */   // Label 6861: @341004
     /* 341004 */   GIM_Try, /*On fail goto*//*Label 6862*/ GIMT_Encode4(341126), // Rule ID 4136 //
     /* 341009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 341012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 341027 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341031 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341035 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341038 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341042 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 341049 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341053 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341057 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341059 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 341066 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 341066 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 341069 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 341073 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 341088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 341093 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341099 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341109 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 341115 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341120 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 341125 */     // GIR_Coverage, 4136,
     /* 341125 */     GIR_EraseRootFromParent_Done,
     /* 341126 */   // Label 6862: @341126
     /* 341126 */   GIM_Try, /*On fail goto*//*Label 6863*/ GIMT_Encode4(341248), // Rule ID 4138 //
     /* 341131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 341134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 341149 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341153 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341157 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341160 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341164 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 341171 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341175 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341179 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341181 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 341188 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 341188 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 341191 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 341195 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 341210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 341215 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341221 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341231 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 341237 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341242 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 341247 */     // GIR_Coverage, 4138,
     /* 341247 */     GIR_EraseRootFromParent_Done,
     /* 341248 */   // Label 6863: @341248
     /* 341248 */   GIM_Try, /*On fail goto*//*Label 6864*/ GIMT_Encode4(341369), // Rule ID 4128 //
     /* 341253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 341256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341267 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 341273 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 341275 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341279 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341283 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341286 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341290 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 341297 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341301 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341305 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341307 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 341314 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 341314 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 341317 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 341321 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 341336 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341342 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341352 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 341358 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341363 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 341368 */     // GIR_Coverage, 4128,
     /* 341368 */     GIR_EraseRootFromParent_Done,
     /* 341369 */   // Label 6864: @341369
     /* 341369 */   GIM_Try, /*On fail goto*//*Label 6865*/ GIMT_Encode4(341490), // Rule ID 4129 //
     /* 341374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 341377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341388 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 341394 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 341396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341404 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341407 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341411 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 341418 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341422 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341426 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341428 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 341435 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 341435 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 341438 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 341442 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 341457 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341463 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341473 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 341479 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341484 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 341489 */     // GIR_Coverage, 4129,
     /* 341489 */     GIR_EraseRootFromParent_Done,
     /* 341490 */   // Label 6865: @341490
     /* 341490 */   GIM_Try, /*On fail goto*//*Label 6866*/ GIMT_Encode4(341607), // Rule ID 4132 //
     /* 341495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 341498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 341513 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341517 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341521 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341524 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341528 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 341535 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341539 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341543 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341545 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 341552 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 341552 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 341555 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 341559 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 341574 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341580 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341590 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 341596 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341601 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 341606 */     // GIR_Coverage, 4132,
     /* 341606 */     GIR_EraseRootFromParent_Done,
     /* 341607 */   // Label 6866: @341607
     /* 341607 */   GIM_Try, /*On fail goto*//*Label 6867*/ GIMT_Encode4(341724), // Rule ID 4134 //
     /* 341612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 341615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 341630 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341634 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341638 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341641 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341645 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 341652 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341656 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341660 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341662 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 341669 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 341669 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 341672 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 341676 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 341691 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341697 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341707 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 341713 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341718 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 341723 */     // GIR_Coverage, 4134,
     /* 341723 */     GIR_EraseRootFromParent_Done,
     /* 341724 */   // Label 6867: @341724
     /* 341724 */   GIM_Try, /*On fail goto*//*Label 6868*/ GIMT_Encode4(341812), // Rule ID 1931 //
     /* 341729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 341732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 341735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 341750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 341754 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 341758 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 341762 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341767 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 341771 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 341775 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 341779 */     // MIs[2] Operand 1
     /* 341779 */     // No operand predicates
     /* 341779 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 341783 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 341787 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 341791 */     // MIs[3] Operand 1
     /* 341791 */     // No operand predicates
     /* 341791 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 341793 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 341793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 341796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341798 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 341800 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 341803 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 341807 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 341810 */     GIR_RootConstrainSelectedInstOperands,
     /* 341811 */     // GIR_Coverage, 1931,
     /* 341811 */     GIR_EraseRootFromParent_Done,
     /* 341812 */   // Label 6868: @341812
     /* 341812 */   GIM_Try, /*On fail goto*//*Label 6869*/ GIMT_Encode4(341889), // Rule ID 5662 //
     /* 341817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 341820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341827 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 341835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 341839 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 341843 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 341847 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341852 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 341856 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 341860 */     // MIs[2] Operand 1
     /* 341860 */     // No operand predicates
     /* 341860 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 341864 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 341868 */     // MIs[3] Operand 1
     /* 341868 */     // No operand predicates
     /* 341868 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 341870 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 341870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 341873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341875 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 341877 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 341880 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 341884 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 341887 */     GIR_RootConstrainSelectedInstOperands,
     /* 341888 */     // GIR_Coverage, 5662,
     /* 341888 */     GIR_EraseRootFromParent_Done,
     /* 341889 */   // Label 6869: @341889
     /* 341889 */   GIM_Try, /*On fail goto*//*Label 6870*/ GIMT_Encode4(341997), // Rule ID 5663 //
     /* 341894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 341897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341904 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 341912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 341916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 341920 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 341924 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 341933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 341937 */     // MIs[2] Operand 1
     /* 341937 */     // No operand predicates
     /* 341937 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 341941 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 341945 */     // MIs[3] Operand 1
     /* 341945 */     // No operand predicates
     /* 341945 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 341947 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 341947 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 341950 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341954 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341959 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 341962 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 341966 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 341969 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341974 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 341982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341984 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 341986 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 341989 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341992 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 341995 */     GIR_RootConstrainSelectedInstOperands,
     /* 341996 */     // GIR_Coverage, 5663,
     /* 341996 */     GIR_EraseRootFromParent_Done,
     /* 341997 */   // Label 6870: @341997
     /* 341997 */   GIM_Try, /*On fail goto*//*Label 6871*/ GIMT_Encode4(342076), // Rule ID 5594 //
     /* 342002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 342005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 342020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 342024 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342028 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 342030 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 342030 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 342033 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 342037 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342042 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 342046 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342059 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 342065 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342070 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342075 */     // GIR_Coverage, 5594,
     /* 342075 */     GIR_EraseRootFromParent_Done,
     /* 342076 */   // Label 6871: @342076
     /* 342076 */   GIM_Try, /*On fail goto*//*Label 6872*/ GIMT_Encode4(342162), // Rule ID 6341 //
     /* 342081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 342084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 342099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 342103 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 342106 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 342110 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 342117 */     // MIs[1] Rn
     /* 342117 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 342121 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 342126 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 342130 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342134 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 342138 */     // MIs[2] Operand 1
     /* 342138 */     // No operand predicates
     /* 342138 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342140 */     // (vector_insert:{ *:[v16i8] } VecListOne128:{ *:[v16i8] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (LD1i8:{ *:[v16i8] } VecListOne128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 342140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 342143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342145 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 342147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 342150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 342154 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 342160 */     GIR_RootConstrainSelectedInstOperands,
     /* 342161 */     // GIR_Coverage, 6341,
     /* 342161 */     GIR_EraseRootFromParent_Done,
     /* 342162 */   // Label 6872: @342162
     /* 342162 */   GIM_Try, /*On fail goto*//*Label 6873*/ GIMT_Encode4(342216), // Rule ID 1927 //
     /* 342167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 342173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342180 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 342188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 342192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342196 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 342200 */     // MIs[1] Operand 1
     /* 342200 */     // No operand predicates
     /* 342200 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 342202 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (INSvi8gpr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
     /* 342202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8gpr),
     /* 342205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342207 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 342209 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 342212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 342214 */     GIR_RootConstrainSelectedInstOperands,
     /* 342215 */     // GIR_Coverage, 1927,
     /* 342215 */     GIR_EraseRootFromParent_Done,
     /* 342216 */   // Label 6873: @342216
     /* 342216 */   GIM_Try, /*On fail goto*//*Label 6874*/ GIMT_Encode4(342322), // Rule ID 5637 //
     /* 342221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 342224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342231 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 342239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 342243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342247 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 342251 */     // MIs[1] Operand 1
     /* 342251 */     // No operand predicates
     /* 342251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 342253 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, FPR8:{ *:[i8] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), FPR8:{ *:[i8] }:$Rm, bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 342253 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 342256 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 342260 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342265 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 342267 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 342270 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 342274 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342279 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 342282 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 342286 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 342289 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342294 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342299 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 342304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 342307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342309 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 342311 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 342314 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342320 */     GIR_RootConstrainSelectedInstOperands,
     /* 342321 */     // GIR_Coverage, 5637,
     /* 342321 */     GIR_EraseRootFromParent_Done,
     /* 342322 */   // Label 6874: @342322
     /* 342322 */   GIM_Reject,
     /* 342323 */ // Label 6859: @342323
     /* 342323 */ GIM_Reject,
     /* 342324 */ // Label 6675: @342324
     /* 342324 */ GIM_Try, /*On fail goto*//*Label 6875*/ GIMT_Encode4(342448), // Rule ID 10998 //
     /* 342329 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 342332 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 342335 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 342338 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 342345 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342349 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 342353 */   // (vector_insert:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv2f16] } ZPR:{ *:[nxv2f16] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), ?:{ *:[f16] }:$src)
     /* 342353 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 342356 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 342360 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342365 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 342369 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 342371 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 342374 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 342378 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342383 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 342386 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 342389 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 342391 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 342394 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 342398 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342403 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 342406 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 342408 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 342411 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 342415 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342420 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 342423 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 342426 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 342429 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 342432 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342434 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
     /* 342437 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 342439 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 342441 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342444 */   GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 342446 */   GIR_RootConstrainSelectedInstOperands,
     /* 342447 */   // GIR_Coverage, 10998,
     /* 342447 */   GIR_EraseRootFromParent_Done,
     /* 342448 */ // Label 6875: @342448
     /* 342448 */ GIM_Reject,
     /* 342449 */ // Label 6676: @342449
     /* 342449 */ GIM_Try, /*On fail goto*//*Label 6876*/ GIMT_Encode4(342573), // Rule ID 11001 //
     /* 342454 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 342457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 342460 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 342463 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 342470 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342474 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 342478 */   // (vector_insert:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$vec, FPR32:{ *:[f32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_S:{ *:[nxv2f32] } ZPR:{ *:[nxv2f32] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), ?:{ *:[f32] }:$src)
     /* 342478 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 342481 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 342485 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342490 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 342494 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 342496 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 342499 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 342503 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342508 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 342511 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 342514 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 342516 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 342519 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 342523 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342528 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 342531 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 342533 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 342536 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 342540 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342545 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 342548 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 342551 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 342554 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 342557 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342559 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_S),
     /* 342562 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 342564 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 342566 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342569 */   GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 342571 */   GIR_RootConstrainSelectedInstOperands,
     /* 342572 */   // GIR_Coverage, 11001,
     /* 342572 */   GIR_EraseRootFromParent_Done,
     /* 342573 */ // Label 6876: @342573
     /* 342573 */ GIM_Reject,
     /* 342574 */ // Label 6677: @342574
     /* 342574 */ GIM_Try, /*On fail goto*//*Label 6877*/ GIMT_Encode4(344487),
     /* 342579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 342582 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 342585 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 342592 */   GIM_Try, /*On fail goto*//*Label 6878*/ GIMT_Encode4(342701), // Rule ID 4262 //
     /* 342597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342601 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 342607 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 342609 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342613 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 342617 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 342620 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 342624 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 342628 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342632 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342634 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 342641 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 342641 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 342644 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 342648 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 342658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 342663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 342668 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 342674 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342684 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 342690 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 342695 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342700 */     // GIR_Coverage, 4262,
     /* 342700 */     GIR_EraseRootFromParent_Done,
     /* 342701 */   // Label 6878: @342701
     /* 342701 */   GIM_Try, /*On fail goto*//*Label 6879*/ GIMT_Encode4(342810), // Rule ID 4263 //
     /* 342706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342710 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 342716 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 342718 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342722 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 342726 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 342729 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 342733 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 342737 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342741 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342743 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 342750 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 342750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 342753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 342757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 342767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 342772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 342777 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 342783 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342793 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 342799 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 342804 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342809 */     // GIR_Coverage, 4263,
     /* 342809 */     GIR_EraseRootFromParent_Done,
     /* 342810 */   // Label 6879: @342810
     /* 342810 */   GIM_Try, /*On fail goto*//*Label 6880*/ GIMT_Encode4(342919), // Rule ID 4370 //
     /* 342815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342819 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 342825 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 342827 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342831 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 342835 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 342838 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 342842 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 342846 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342850 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342852 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 342859 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 342859 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 342862 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 342866 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 342876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 342881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 342886 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 342892 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342902 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 342908 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 342913 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342918 */     // GIR_Coverage, 4370,
     /* 342918 */     GIR_EraseRootFromParent_Done,
     /* 342919 */   // Label 6880: @342919
     /* 342919 */   GIM_Try, /*On fail goto*//*Label 6881*/ GIMT_Encode4(343028), // Rule ID 4371 //
     /* 342924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342928 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 342934 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 342936 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342940 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 342944 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 342947 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 342951 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 342955 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342959 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342961 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 342968 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 342968 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 342971 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 342975 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 342985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 342990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 342995 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 343001 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343011 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 343017 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 343022 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343027 */     // GIR_Coverage, 4371,
     /* 343027 */     GIR_EraseRootFromParent_Done,
     /* 343028 */   // Label 6881: @343028
     /* 343028 */   GIM_Try, /*On fail goto*//*Label 6882*/ GIMT_Encode4(343133), // Rule ID 4268 //
     /* 343033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 343041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343049 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 343052 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 343056 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 343060 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343064 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343066 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 343073 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 343073 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 343076 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 343080 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 343090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 343095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 343100 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 343106 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343116 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 343122 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 343127 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343132 */     // GIR_Coverage, 4268,
     /* 343132 */     GIR_EraseRootFromParent_Done,
     /* 343133 */   // Label 6882: @343133
     /* 343133 */   GIM_Try, /*On fail goto*//*Label 6883*/ GIMT_Encode4(343238), // Rule ID 4270 //
     /* 343138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 343146 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343150 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343154 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 343157 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 343161 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 343165 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343169 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343171 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 343178 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 343178 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 343181 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 343185 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 343195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 343200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 343205 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 343211 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343221 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 343227 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 343232 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343237 */     // GIR_Coverage, 4270,
     /* 343237 */     GIR_EraseRootFromParent_Done,
     /* 343238 */   // Label 6883: @343238
     /* 343238 */   GIM_Try, /*On fail goto*//*Label 6884*/ GIMT_Encode4(343343), // Rule ID 4376 //
     /* 343243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 343251 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343255 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343259 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 343262 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 343266 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 343270 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343274 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343276 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 343283 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 343283 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 343286 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 343290 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 343300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 343305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 343310 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 343316 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343326 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 343332 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 343337 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343342 */     // GIR_Coverage, 4376,
     /* 343342 */     GIR_EraseRootFromParent_Done,
     /* 343343 */   // Label 6884: @343343
     /* 343343 */   GIM_Try, /*On fail goto*//*Label 6885*/ GIMT_Encode4(343448), // Rule ID 4378 //
     /* 343348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 343356 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343360 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343364 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 343367 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 343371 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 343375 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343379 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343381 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 343388 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 343388 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 343391 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 343395 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 343405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 343410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 343415 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 343421 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343431 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 343437 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 343442 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343447 */     // GIR_Coverage, 4378,
     /* 343447 */     GIR_EraseRootFromParent_Done,
     /* 343448 */   // Label 6885: @343448
     /* 343448 */   GIM_Try, /*On fail goto*//*Label 6886*/ GIMT_Encode4(343552), // Rule ID 4260 //
     /* 343453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343457 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 343463 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 343465 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343469 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343473 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 343476 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 343480 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 343484 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343488 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343490 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 343497 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 343497 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 343500 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 343504 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 343514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 343519 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 343525 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343535 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 343541 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 343546 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343551 */     // GIR_Coverage, 4260,
     /* 343551 */     GIR_EraseRootFromParent_Done,
     /* 343552 */   // Label 6886: @343552
     /* 343552 */   GIM_Try, /*On fail goto*//*Label 6887*/ GIMT_Encode4(343656), // Rule ID 4261 //
     /* 343557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343561 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 343567 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 343569 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343573 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343577 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 343580 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 343584 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 343588 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343592 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343594 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 343601 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 343601 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 343604 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 343608 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 343618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 343623 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 343629 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343639 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 343645 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 343650 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343655 */     // GIR_Coverage, 4261,
     /* 343655 */     GIR_EraseRootFromParent_Done,
     /* 343656 */   // Label 6887: @343656
     /* 343656 */   GIM_Try, /*On fail goto*//*Label 6888*/ GIMT_Encode4(343760), // Rule ID 4368 //
     /* 343661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343665 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 343671 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 343673 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343677 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343681 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 343684 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 343688 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 343692 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343696 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343698 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 343705 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 343705 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 343708 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 343712 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 343722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 343727 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 343733 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343743 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 343749 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 343754 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343759 */     // GIR_Coverage, 4368,
     /* 343759 */     GIR_EraseRootFromParent_Done,
     /* 343760 */   // Label 6888: @343760
     /* 343760 */   GIM_Try, /*On fail goto*//*Label 6889*/ GIMT_Encode4(343864), // Rule ID 4369 //
     /* 343765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343769 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 343775 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 343777 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343781 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343785 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 343788 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 343792 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 343796 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343800 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343802 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 343809 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 343809 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 343812 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 343816 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 343826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 343831 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 343837 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343847 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 343853 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 343858 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343863 */     // GIR_Coverage, 4369,
     /* 343863 */     GIR_EraseRootFromParent_Done,
     /* 343864 */   // Label 6889: @343864
     /* 343864 */   GIM_Try, /*On fail goto*//*Label 6890*/ GIMT_Encode4(343964), // Rule ID 4264 //
     /* 343869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 343877 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343881 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343885 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 343888 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 343892 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 343896 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343900 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343902 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 343909 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 343909 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 343912 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 343916 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 343926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 343931 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 343937 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343947 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 343953 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 343958 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343963 */     // GIR_Coverage, 4264,
     /* 343963 */     GIR_EraseRootFromParent_Done,
     /* 343964 */   // Label 6890: @343964
     /* 343964 */   GIM_Try, /*On fail goto*//*Label 6891*/ GIMT_Encode4(344064), // Rule ID 4266 //
     /* 343969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 343977 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343981 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343985 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 343988 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 343992 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 343996 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344000 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344002 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 344009 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 344009 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 344012 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 344016 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 344031 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344037 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344047 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 344053 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 344058 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344063 */     // GIR_Coverage, 4266,
     /* 344063 */     GIR_EraseRootFromParent_Done,
     /* 344064 */   // Label 6891: @344064
     /* 344064 */   GIM_Try, /*On fail goto*//*Label 6892*/ GIMT_Encode4(344164), // Rule ID 4372 //
     /* 344069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 344077 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344081 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344085 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344088 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 344092 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 344096 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344100 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344102 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 344109 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 344109 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 344112 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 344116 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 344131 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344137 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344147 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 344153 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 344158 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344163 */     // GIR_Coverage, 4372,
     /* 344163 */     GIR_EraseRootFromParent_Done,
     /* 344164 */   // Label 6892: @344164
     /* 344164 */   GIM_Try, /*On fail goto*//*Label 6893*/ GIMT_Encode4(344264), // Rule ID 4374 //
     /* 344169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 344177 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344181 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344185 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344188 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 344192 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 344196 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344200 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344202 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 344209 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 344209 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 344212 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 344216 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 344231 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344237 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344247 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 344253 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 344258 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344263 */     // GIR_Coverage, 4374,
     /* 344263 */     GIR_EraseRootFromParent_Done,
     /* 344264 */   // Label 6893: @344264
     /* 344264 */   GIM_Try, /*On fail goto*//*Label 6894*/ GIMT_Encode4(344375), // Rule ID 10997 //
     /* 344269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 344272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 344276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 344280 */     // (vector_insert:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$vec, GPR64:{ *:[i64] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_D:{ *:[nxv2i64] } ZPR:{ *:[nxv2i64] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), GPR64:{ *:[i64] }:$src)
     /* 344280 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 344283 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 344287 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344292 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 344296 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 344298 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 344301 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 344305 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344310 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 344313 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 344316 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 344318 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 344321 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 344325 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344330 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 344333 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 344335 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 344338 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 344342 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344347 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 344350 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 344353 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 344356 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 344359 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_D),
     /* 344364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 344366 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 344368 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344371 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 344373 */     GIR_RootConstrainSelectedInstOperands,
     /* 344374 */     // GIR_Coverage, 10997,
     /* 344374 */     GIR_EraseRootFromParent_Done,
     /* 344375 */   // Label 6894: @344375
     /* 344375 */   GIM_Try, /*On fail goto*//*Label 6895*/ GIMT_Encode4(344486), // Rule ID 11003 //
     /* 344380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 344383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 344391 */     // (vector_insert:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$vec, FPR64:{ *:[f64] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_D:{ *:[nxv2f64] } ZPR:{ *:[nxv2f64] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } ?:{ *:[i64] }:$index)), ?:{ *:[f64] }:$src)
     /* 344391 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 344394 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 344398 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344403 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 344407 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 344409 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 344412 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 344416 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344421 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 344424 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 344427 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 344429 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 344432 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 344436 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344441 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 344444 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 344446 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 344449 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 344453 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344458 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 344461 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 344464 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 344467 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 344470 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_D),
     /* 344475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 344477 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 344479 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344482 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 344484 */     GIR_RootConstrainSelectedInstOperands,
     /* 344485 */     // GIR_Coverage, 11003,
     /* 344485 */     GIR_EraseRootFromParent_Done,
     /* 344486 */   // Label 6895: @344486
     /* 344486 */   GIM_Reject,
     /* 344487 */ // Label 6877: @344487
     /* 344487 */ GIM_Reject,
     /* 344488 */ // Label 6678: @344488
     /* 344488 */ GIM_Try, /*On fail goto*//*Label 6896*/ GIMT_Encode4(344639), // Rule ID 10999 //
     /* 344493 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 344496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 344499 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 344502 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 344505 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 344509 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 344513 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 344517 */   // (vector_insert:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv4f16] } ZPR:{ *:[nxv4f16] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f16] }:$src)
     /* 344517 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 344520 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 344524 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344529 */   GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 344535 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 344540 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 344545 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 344548 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 344552 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344557 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 344560 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 344562 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 344565 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
     /* 344569 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344574 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 344577 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 344580 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 344582 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 344585 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 344589 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344594 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 344597 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 344599 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 344602 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
     /* 344606 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344611 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 344614 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 344617 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 344620 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 344623 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344625 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
     /* 344628 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 344630 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 344632 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344635 */   GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 344637 */   GIR_RootConstrainSelectedInstOperands,
     /* 344638 */   // GIR_Coverage, 10999,
     /* 344638 */   GIR_EraseRootFromParent_Done,
     /* 344639 */ // Label 6896: @344639
     /* 344639 */ GIM_Reject,
     /* 344640 */ // Label 6679: @344640
     /* 344640 */ GIM_Try, /*On fail goto*//*Label 6897*/ GIMT_Encode4(346607),
     /* 344645 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 344648 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 344651 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 344654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 344658 */   GIM_Try, /*On fail goto*//*Label 6898*/ GIMT_Encode4(344767), // Rule ID 4226 //
     /* 344663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344667 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 344673 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 344675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344679 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344683 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344686 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 344690 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 344694 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344698 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344700 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 344707 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 344707 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 344710 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 344714 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 344729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 344734 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344740 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344750 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 344756 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 344761 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 344766 */     // GIR_Coverage, 4226,
     /* 344766 */     GIR_EraseRootFromParent_Done,
     /* 344767 */   // Label 6898: @344767
     /* 344767 */   GIM_Try, /*On fail goto*//*Label 6899*/ GIMT_Encode4(344876), // Rule ID 4227 //
     /* 344772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344776 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 344782 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 344784 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344788 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344792 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344795 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 344799 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 344803 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344807 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344809 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 344816 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 344816 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 344819 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 344823 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 344838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 344843 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344849 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344859 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 344865 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 344870 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 344875 */     // GIR_Coverage, 4227,
     /* 344875 */     GIR_EraseRootFromParent_Done,
     /* 344876 */   // Label 6899: @344876
     /* 344876 */   GIM_Try, /*On fail goto*//*Label 6900*/ GIMT_Encode4(344985), // Rule ID 4334 //
     /* 344881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344885 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 344891 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 344893 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344897 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344901 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344904 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 344908 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 344912 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344916 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344918 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 344925 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 344925 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 344928 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 344932 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 344947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 344952 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344958 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344968 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 344974 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 344979 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 344984 */     // GIR_Coverage, 4334,
     /* 344984 */     GIR_EraseRootFromParent_Done,
     /* 344985 */   // Label 6900: @344985
     /* 344985 */   GIM_Try, /*On fail goto*//*Label 6901*/ GIMT_Encode4(345094), // Rule ID 4335 //
     /* 344990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344994 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 345000 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 345002 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345006 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345010 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345013 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345017 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345021 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345025 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345027 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 345034 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 345034 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345037 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 345041 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 345056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 345061 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345067 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345077 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 345083 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 345088 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345093 */     // GIR_Coverage, 4335,
     /* 345093 */     GIR_EraseRootFromParent_Done,
     /* 345094 */   // Label 6901: @345094
     /* 345094 */   GIM_Try, /*On fail goto*//*Label 6902*/ GIMT_Encode4(345199), // Rule ID 4232 //
     /* 345099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 345107 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345111 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345115 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345118 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345122 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345126 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345130 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345132 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 345139 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 345139 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345142 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 345146 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 345161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 345166 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345172 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345182 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 345188 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 345193 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345198 */     // GIR_Coverage, 4232,
     /* 345198 */     GIR_EraseRootFromParent_Done,
     /* 345199 */   // Label 6902: @345199
     /* 345199 */   GIM_Try, /*On fail goto*//*Label 6903*/ GIMT_Encode4(345304), // Rule ID 4234 //
     /* 345204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 345212 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345216 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345220 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345223 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345227 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345231 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345235 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345237 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 345244 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 345244 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345247 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 345251 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 345266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 345271 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345277 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345287 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 345293 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 345298 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345303 */     // GIR_Coverage, 4234,
     /* 345303 */     GIR_EraseRootFromParent_Done,
     /* 345304 */   // Label 6903: @345304
     /* 345304 */   GIM_Try, /*On fail goto*//*Label 6904*/ GIMT_Encode4(345409), // Rule ID 4340 //
     /* 345309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 345317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345325 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345328 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345332 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345336 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345340 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345342 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 345349 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 345349 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345352 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 345356 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 345371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 345376 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345382 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345392 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 345398 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 345403 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345408 */     // GIR_Coverage, 4340,
     /* 345408 */     GIR_EraseRootFromParent_Done,
     /* 345409 */   // Label 6904: @345409
     /* 345409 */   GIM_Try, /*On fail goto*//*Label 6905*/ GIMT_Encode4(345514), // Rule ID 4342 //
     /* 345414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 345422 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345426 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345430 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345433 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345437 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345441 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345445 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345447 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 345454 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 345454 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345457 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 345461 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 345476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 345481 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345487 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345497 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 345503 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 345508 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345513 */     // GIR_Coverage, 4342,
     /* 345513 */     GIR_EraseRootFromParent_Done,
     /* 345514 */   // Label 6905: @345514
     /* 345514 */   GIM_Try, /*On fail goto*//*Label 6906*/ GIMT_Encode4(345618), // Rule ID 4224 //
     /* 345519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345523 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 345529 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 345531 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345535 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345539 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345542 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345546 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345550 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345554 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345556 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 345563 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 345563 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345566 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 345570 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 345585 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345591 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345601 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 345607 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 345612 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345617 */     // GIR_Coverage, 4224,
     /* 345617 */     GIR_EraseRootFromParent_Done,
     /* 345618 */   // Label 6906: @345618
     /* 345618 */   GIM_Try, /*On fail goto*//*Label 6907*/ GIMT_Encode4(345722), // Rule ID 4225 //
     /* 345623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345627 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 345633 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 345635 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345639 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345643 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345646 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345650 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345654 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345658 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345660 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 345667 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 345667 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345670 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 345674 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 345689 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345695 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345705 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 345711 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 345716 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345721 */     // GIR_Coverage, 4225,
     /* 345721 */     GIR_EraseRootFromParent_Done,
     /* 345722 */   // Label 6907: @345722
     /* 345722 */   GIM_Try, /*On fail goto*//*Label 6908*/ GIMT_Encode4(345826), // Rule ID 4332 //
     /* 345727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345731 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 345737 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 345739 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345743 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345747 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345750 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345754 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345758 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345762 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345764 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 345771 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 345771 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345774 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 345778 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 345793 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345799 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345809 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 345815 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 345820 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345825 */     // GIR_Coverage, 4332,
     /* 345825 */     GIR_EraseRootFromParent_Done,
     /* 345826 */   // Label 6908: @345826
     /* 345826 */   GIM_Try, /*On fail goto*//*Label 6909*/ GIMT_Encode4(345930), // Rule ID 4333 //
     /* 345831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345835 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 345841 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 345843 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345847 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345851 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345854 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345858 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345862 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345866 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345868 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 345875 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 345875 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345878 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 345882 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 345897 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345903 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345913 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 345919 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 345924 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345929 */     // GIR_Coverage, 4333,
     /* 345929 */     GIR_EraseRootFromParent_Done,
     /* 345930 */   // Label 6909: @345930
     /* 345930 */   GIM_Try, /*On fail goto*//*Label 6910*/ GIMT_Encode4(346030), // Rule ID 4228 //
     /* 345935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 345943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345951 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345954 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345958 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345962 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345966 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345968 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 345975 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 345975 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345978 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 345982 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 345997 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 346003 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 346019 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 346024 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 346029 */     // GIR_Coverage, 4228,
     /* 346029 */     GIR_EraseRootFromParent_Done,
     /* 346030 */   // Label 6910: @346030
     /* 346030 */   GIM_Try, /*On fail goto*//*Label 6911*/ GIMT_Encode4(346130), // Rule ID 4230 //
     /* 346035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 346043 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346047 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 346051 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 346054 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 346058 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 346062 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346066 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346068 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 346075 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 346075 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 346078 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 346082 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 346092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 346097 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 346103 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346113 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 346119 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 346124 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 346129 */     // GIR_Coverage, 4230,
     /* 346129 */     GIR_EraseRootFromParent_Done,
     /* 346130 */   // Label 6911: @346130
     /* 346130 */   GIM_Try, /*On fail goto*//*Label 6912*/ GIMT_Encode4(346230), // Rule ID 4336 //
     /* 346135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 346143 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346147 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 346151 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 346154 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 346158 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 346162 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346166 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346168 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 346175 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 346175 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 346178 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 346182 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 346192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 346197 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 346203 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346213 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 346219 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 346224 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 346229 */     // GIR_Coverage, 4336,
     /* 346229 */     GIR_EraseRootFromParent_Done,
     /* 346230 */   // Label 6912: @346230
     /* 346230 */   GIM_Try, /*On fail goto*//*Label 6913*/ GIMT_Encode4(346330), // Rule ID 4338 //
     /* 346235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 346243 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346247 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 346251 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 346254 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 346258 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 346262 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346266 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346268 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 346275 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 346275 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 346278 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 346282 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 346292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 346297 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 346303 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346313 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 346319 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 346324 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 346329 */     // GIR_Coverage, 4338,
     /* 346329 */     GIR_EraseRootFromParent_Done,
     /* 346330 */   // Label 6913: @346330
     /* 346330 */   GIM_Try, /*On fail goto*//*Label 6914*/ GIMT_Encode4(346468), // Rule ID 10996 //
     /* 346335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 346338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 346342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346346 */     // (vector_insert:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_S:{ *:[nxv4i32] } ZPR:{ *:[nxv4i32] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
     /* 346346 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 346349 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 346353 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346358 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 346364 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 346369 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346374 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 346377 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 346381 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346386 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 346389 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 346391 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 346394 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
     /* 346398 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346403 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 346406 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 346409 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 346411 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 346414 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 346418 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346423 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 346426 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 346428 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 346431 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
     /* 346435 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346440 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 346443 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 346446 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 346449 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 346452 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_S),
     /* 346457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 346459 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 346461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346464 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 346466 */     GIR_RootConstrainSelectedInstOperands,
     /* 346467 */     // GIR_Coverage, 10996,
     /* 346467 */     GIR_EraseRootFromParent_Done,
     /* 346468 */   // Label 6914: @346468
     /* 346468 */   GIM_Try, /*On fail goto*//*Label 6915*/ GIMT_Encode4(346606), // Rule ID 11002 //
     /* 346473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 346476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 346480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346484 */     // (vector_insert:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$vec, FPR32:{ *:[f32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_S:{ *:[nxv4f32] } ZPR:{ *:[nxv4f32] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f32] }:$src)
     /* 346484 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 346487 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 346491 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346496 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 346502 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 346507 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346512 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 346515 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 346519 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346524 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 346527 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 346529 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 346532 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
     /* 346536 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346541 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 346544 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 346547 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 346549 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 346552 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 346556 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346561 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 346564 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 346566 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 346569 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
     /* 346573 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346578 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 346581 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 346584 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 346587 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 346590 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_S),
     /* 346595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 346597 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 346599 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346602 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 346604 */     GIR_RootConstrainSelectedInstOperands,
     /* 346605 */     // GIR_Coverage, 11002,
     /* 346605 */     GIR_EraseRootFromParent_Done,
     /* 346606 */   // Label 6915: @346606
     /* 346606 */   GIM_Reject,
     /* 346607 */ // Label 6897: @346607
     /* 346607 */ GIM_Reject,
     /* 346608 */ // Label 6680: @346608
     /* 346608 */ GIM_Try, /*On fail goto*//*Label 6916*/ GIMT_Encode4(348801),
     /* 346613 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 346616 */   GIM_Try, /*On fail goto*//*Label 6917*/ GIMT_Encode4(346742), // Rule ID 4190 //
     /* 346621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 346624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 346627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 346631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346635 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 346641 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 346643 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346647 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 346651 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 346654 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 346658 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 346665 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 346669 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346673 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346675 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 346682 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 346682 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 346685 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 346689 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 346699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 346704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 346709 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 346715 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346725 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 346731 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 346736 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 346741 */     // GIR_Coverage, 4190,
     /* 346741 */     GIR_EraseRootFromParent_Done,
     /* 346742 */   // Label 6917: @346742
     /* 346742 */   GIM_Try, /*On fail goto*//*Label 6918*/ GIMT_Encode4(346868), // Rule ID 4191 //
     /* 346747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 346750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 346753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 346757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346761 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 346767 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 346769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 346777 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 346780 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 346784 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 346791 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 346795 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346799 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346801 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 346808 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 346808 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 346811 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 346815 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 346825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 346830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 346835 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 346841 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346851 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 346857 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 346862 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 346867 */     // GIR_Coverage, 4191,
     /* 346867 */     GIR_EraseRootFromParent_Done,
     /* 346868 */   // Label 6918: @346868
     /* 346868 */   GIM_Try, /*On fail goto*//*Label 6919*/ GIMT_Encode4(346987), // Rule ID 4298 //
     /* 346873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 346876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 346879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 346883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346887 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 346893 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 346895 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346899 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 346903 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 346906 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 346910 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 346914 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346918 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346920 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 346927 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 346927 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 346930 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 346934 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 346944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 346949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 346954 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 346960 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346970 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 346976 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 346981 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 346986 */     // GIR_Coverage, 4298,
     /* 346986 */     GIR_EraseRootFromParent_Done,
     /* 346987 */   // Label 6919: @346987
     /* 346987 */   GIM_Try, /*On fail goto*//*Label 6920*/ GIMT_Encode4(347106), // Rule ID 4299 //
     /* 346992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 346995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 346998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 347002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347006 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 347012 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 347014 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347018 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347022 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347025 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347029 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347033 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347037 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347039 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 347046 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 347046 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 347049 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 347053 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 347068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 347073 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347079 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347089 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 347095 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 347100 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 347105 */     // GIR_Coverage, 4299,
     /* 347105 */     GIR_EraseRootFromParent_Done,
     /* 347106 */   // Label 6920: @347106
     /* 347106 */   GIM_Try, /*On fail goto*//*Label 6921*/ GIMT_Encode4(347228), // Rule ID 4196 //
     /* 347111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 347114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 347121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 347129 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347133 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347137 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347140 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347144 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 347151 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347155 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347159 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347161 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 347168 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 347168 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 347171 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 347175 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 347190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 347195 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347201 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347211 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 347217 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 347222 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 347227 */     // GIR_Coverage, 4196,
     /* 347227 */     GIR_EraseRootFromParent_Done,
     /* 347228 */   // Label 6921: @347228
     /* 347228 */   GIM_Try, /*On fail goto*//*Label 6922*/ GIMT_Encode4(347350), // Rule ID 4198 //
     /* 347233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 347236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 347243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 347251 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347255 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347259 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347262 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347266 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 347273 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347277 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347281 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347283 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 347290 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 347290 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 347293 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 347297 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 347312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 347317 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347323 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347333 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 347339 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 347344 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 347349 */     // GIR_Coverage, 4198,
     /* 347349 */     GIR_EraseRootFromParent_Done,
     /* 347350 */   // Label 6922: @347350
     /* 347350 */   GIM_Try, /*On fail goto*//*Label 6923*/ GIMT_Encode4(347465), // Rule ID 4304 //
     /* 347355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 347358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 347365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 347373 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347377 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347381 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347384 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347388 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347392 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347396 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347398 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 347405 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 347405 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 347408 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 347412 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 347427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 347432 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347438 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347448 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 347454 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 347459 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 347464 */     // GIR_Coverage, 4304,
     /* 347464 */     GIR_EraseRootFromParent_Done,
     /* 347465 */   // Label 6923: @347465
     /* 347465 */   GIM_Try, /*On fail goto*//*Label 6924*/ GIMT_Encode4(347580), // Rule ID 4306 //
     /* 347470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 347473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 347480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 347488 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347492 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347496 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347499 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347503 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347507 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347511 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347513 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 347520 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 347520 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 347523 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 347527 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 347542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 347547 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347553 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347563 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 347569 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 347574 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 347579 */     // GIR_Coverage, 4306,
     /* 347579 */     GIR_EraseRootFromParent_Done,
     /* 347580 */   // Label 6924: @347580
     /* 347580 */   GIM_Try, /*On fail goto*//*Label 6925*/ GIMT_Encode4(347701), // Rule ID 4188 //
     /* 347585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 347588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 347595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347599 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 347605 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 347607 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347611 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347615 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347618 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347622 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 347629 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347633 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347637 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347639 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 347646 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 347646 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 347649 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 347653 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 347668 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347674 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347684 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 347690 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 347695 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 347700 */     // GIR_Coverage, 4188,
     /* 347700 */     GIR_EraseRootFromParent_Done,
     /* 347701 */   // Label 6925: @347701
     /* 347701 */   GIM_Try, /*On fail goto*//*Label 6926*/ GIMT_Encode4(347822), // Rule ID 4189 //
     /* 347706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 347709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 347716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347720 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 347726 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 347728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347736 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347739 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347743 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 347750 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347754 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347758 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347760 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 347767 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 347767 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 347770 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 347774 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 347789 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347805 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 347811 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 347816 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 347821 */     // GIR_Coverage, 4189,
     /* 347821 */     GIR_EraseRootFromParent_Done,
     /* 347822 */   // Label 6926: @347822
     /* 347822 */   GIM_Try, /*On fail goto*//*Label 6927*/ GIMT_Encode4(347936), // Rule ID 4296 //
     /* 347827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 347830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 347837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347841 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 347847 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 347849 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347853 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347857 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347860 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347864 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347868 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347872 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347874 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 347881 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 347881 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 347884 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 347888 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 347903 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347909 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347919 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 347925 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 347930 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 347935 */     // GIR_Coverage, 4296,
     /* 347935 */     GIR_EraseRootFromParent_Done,
     /* 347936 */   // Label 6927: @347936
     /* 347936 */   GIM_Try, /*On fail goto*//*Label 6928*/ GIMT_Encode4(348050), // Rule ID 4297 //
     /* 347941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 347944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 347951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347955 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 347961 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 347963 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347967 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347971 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347974 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347978 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347982 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347986 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347988 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 347995 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 347995 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 347998 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 348002 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 348017 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348023 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348033 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 348039 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 348044 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 348049 */     // GIR_Coverage, 4297,
     /* 348049 */     GIR_EraseRootFromParent_Done,
     /* 348050 */   // Label 6928: @348050
     /* 348050 */   GIM_Try, /*On fail goto*//*Label 6929*/ GIMT_Encode4(348167), // Rule ID 4192 //
     /* 348055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 348058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 348061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 348065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 348073 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348077 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348081 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348084 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348088 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 348095 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348099 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348103 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348105 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 348112 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 348112 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 348115 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 348119 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 348134 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348140 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348150 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 348156 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 348161 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 348166 */     // GIR_Coverage, 4192,
     /* 348166 */     GIR_EraseRootFromParent_Done,
     /* 348167 */   // Label 6929: @348167
     /* 348167 */   GIM_Try, /*On fail goto*//*Label 6930*/ GIMT_Encode4(348284), // Rule ID 4194 //
     /* 348172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 348175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 348178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 348182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 348190 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348194 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348198 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348201 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348205 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 348212 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348216 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348220 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348222 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 348229 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 348229 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 348232 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 348236 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 348251 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348257 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348267 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 348273 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 348278 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 348283 */     // GIR_Coverage, 4194,
     /* 348283 */     GIR_EraseRootFromParent_Done,
     /* 348284 */   // Label 6930: @348284
     /* 348284 */   GIM_Try, /*On fail goto*//*Label 6931*/ GIMT_Encode4(348394), // Rule ID 4300 //
     /* 348289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 348292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 348295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 348299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 348307 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348311 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348315 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348318 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348322 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348326 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348330 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348332 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 348339 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 348339 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 348342 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 348346 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 348361 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348367 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348377 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 348383 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 348388 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 348393 */     // GIR_Coverage, 4300,
     /* 348393 */     GIR_EraseRootFromParent_Done,
     /* 348394 */   // Label 6931: @348394
     /* 348394 */   GIM_Try, /*On fail goto*//*Label 6932*/ GIMT_Encode4(348504), // Rule ID 4302 //
     /* 348399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 348402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 348405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 348409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 348417 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348421 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348425 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348428 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348432 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348436 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348440 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348442 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 348449 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 348449 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 348452 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 348456 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 348471 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348477 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348487 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 348493 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 348498 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 348503 */     // GIR_Coverage, 4302,
     /* 348503 */     GIR_EraseRootFromParent_Done,
     /* 348504 */   // Label 6932: @348504
     /* 348504 */   GIM_Try, /*On fail goto*//*Label 6933*/ GIMT_Encode4(348652), // Rule ID 10995 //
     /* 348509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 348512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 348515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 348518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 348522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 348526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 348530 */     // (vector_insert:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_H:{ *:[nxv8i16] } ZPR:{ *:[nxv8i16] }:$vec, (CMPEQ_PPzZZ_H:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_H:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_H:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
     /* 348530 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 348533 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348537 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348542 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 348548 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 348553 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 348558 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 348561 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
     /* 348565 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348570 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 348573 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 348575 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 348578 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_H),
     /* 348582 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348587 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 348590 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 348593 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 348595 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 348598 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 348602 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348607 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 348610 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 348612 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 348615 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_H),
     /* 348619 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348624 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 348627 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 348630 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 348633 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 348636 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_H),
     /* 348641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 348643 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 348645 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348648 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 348650 */     GIR_RootConstrainSelectedInstOperands,
     /* 348651 */     // GIR_Coverage, 10995,
     /* 348651 */     GIR_EraseRootFromParent_Done,
     /* 348652 */   // Label 6933: @348652
     /* 348652 */   GIM_Try, /*On fail goto*//*Label 6934*/ GIMT_Encode4(348800), // Rule ID 11000 //
     /* 348657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 348660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 348663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 348666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 348670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 348674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 348678 */     // (vector_insert:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv8f16] } ZPR:{ *:[nxv8f16] }:$vec, (CMPEQ_PPzZZ_H:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_H:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_H:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f16] }:$src)
     /* 348678 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 348681 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348685 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348690 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 348696 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 348701 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 348706 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 348709 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
     /* 348713 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348718 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 348721 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 348723 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 348726 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_H),
     /* 348730 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348735 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 348738 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 348741 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 348743 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 348746 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 348750 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348755 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 348758 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 348760 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 348763 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_H),
     /* 348767 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348772 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 348775 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 348778 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 348781 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 348784 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
     /* 348789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 348791 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 348793 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348796 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 348798 */     GIR_RootConstrainSelectedInstOperands,
     /* 348799 */     // GIR_Coverage, 11000,
     /* 348799 */     GIR_EraseRootFromParent_Done,
     /* 348800 */   // Label 6934: @348800
     /* 348800 */   GIM_Reject,
     /* 348801 */ // Label 6916: @348801
     /* 348801 */ GIM_Reject,
     /* 348802 */ // Label 6681: @348802
     /* 348802 */ GIM_Try, /*On fail goto*//*Label 6935*/ GIMT_Encode4(349851),
     /* 348807 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 348810 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 348813 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 348816 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 348820 */   GIM_Try, /*On fail goto*//*Label 6936*/ GIMT_Encode4(348936), // Rule ID 4154 //
     /* 348825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348829 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 348835 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 348837 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348841 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348845 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348848 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348852 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 348859 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348863 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348867 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348869 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 348876 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 348876 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 348879 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 348883 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 348898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 348903 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348909 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348919 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 348925 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 348930 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 348935 */     // GIR_Coverage, 4154,
     /* 348935 */     GIR_EraseRootFromParent_Done,
     /* 348936 */   // Label 6936: @348936
     /* 348936 */   GIM_Try, /*On fail goto*//*Label 6937*/ GIMT_Encode4(349052), // Rule ID 4155 //
     /* 348941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348945 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 348951 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 348953 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348957 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348961 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348964 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348968 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 348975 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348979 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348983 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348985 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 348992 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 348992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 348995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 348999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 349014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 349019 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349025 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349035 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 349041 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 349046 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 349051 */     // GIR_Coverage, 4155,
     /* 349051 */     GIR_EraseRootFromParent_Done,
     /* 349052 */   // Label 6937: @349052
     /* 349052 */   GIM_Try, /*On fail goto*//*Label 6938*/ GIMT_Encode4(349164), // Rule ID 4160 //
     /* 349057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 349065 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349069 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349073 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349076 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349080 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 349087 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349091 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349095 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349097 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 349104 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 349104 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 349107 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 349111 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 349126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 349131 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349137 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349147 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 349153 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 349158 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 349163 */     // GIR_Coverage, 4160,
     /* 349163 */     GIR_EraseRootFromParent_Done,
     /* 349164 */   // Label 6938: @349164
     /* 349164 */   GIM_Try, /*On fail goto*//*Label 6939*/ GIMT_Encode4(349276), // Rule ID 4162 //
     /* 349169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 349177 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349181 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349185 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349188 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349192 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 349199 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349203 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349207 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349209 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 349216 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 349216 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 349219 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 349223 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 349238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 349243 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349249 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349259 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 349265 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 349270 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 349275 */     // GIR_Coverage, 4162,
     /* 349275 */     GIR_EraseRootFromParent_Done,
     /* 349276 */   // Label 6939: @349276
     /* 349276 */   GIM_Try, /*On fail goto*//*Label 6940*/ GIMT_Encode4(349387), // Rule ID 4152 //
     /* 349281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349285 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 349291 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 349293 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349297 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349301 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349304 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349308 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 349315 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349319 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349323 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349325 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 349332 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 349332 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 349335 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 349339 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 349354 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349360 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349370 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 349376 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 349381 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 349386 */     // GIR_Coverage, 4152,
     /* 349386 */     GIR_EraseRootFromParent_Done,
     /* 349387 */   // Label 6940: @349387
     /* 349387 */   GIM_Try, /*On fail goto*//*Label 6941*/ GIMT_Encode4(349498), // Rule ID 4153 //
     /* 349392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349396 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 349402 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 349404 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349408 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349412 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349415 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349419 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 349426 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349430 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349434 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349436 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 349443 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 349443 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 349446 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 349450 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 349465 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349471 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349481 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 349487 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 349492 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 349497 */     // GIR_Coverage, 4153,
     /* 349497 */     GIR_EraseRootFromParent_Done,
     /* 349498 */   // Label 6941: @349498
     /* 349498 */   GIM_Try, /*On fail goto*//*Label 6942*/ GIMT_Encode4(349605), // Rule ID 4156 //
     /* 349503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 349511 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349515 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349519 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349522 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349526 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 349533 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349537 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349541 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349543 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 349550 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 349550 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 349553 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 349557 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 349572 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349578 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349588 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 349594 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 349599 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 349604 */     // GIR_Coverage, 4156,
     /* 349604 */     GIR_EraseRootFromParent_Done,
     /* 349605 */   // Label 6942: @349605
     /* 349605 */   GIM_Try, /*On fail goto*//*Label 6943*/ GIMT_Encode4(349712), // Rule ID 4158 //
     /* 349610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 349618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349622 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349626 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349629 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349633 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 349640 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349644 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349648 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349650 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 349657 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 349657 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 349660 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 349664 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 349679 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349685 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349695 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 349701 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 349706 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 349711 */     // GIR_Coverage, 4158,
     /* 349711 */     GIR_EraseRootFromParent_Done,
     /* 349712 */   // Label 6943: @349712
     /* 349712 */   GIM_Try, /*On fail goto*//*Label 6944*/ GIMT_Encode4(349850), // Rule ID 10994 //
     /* 349717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 349724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 349728 */     // (vector_insert:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (CMPEQ_PPzZZ_B:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_B:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_B:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
     /* 349728 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 349731 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 349735 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349740 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 349746 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 349751 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 349756 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 349759 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_B),
     /* 349763 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349768 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 349771 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 349773 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 349776 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_B),
     /* 349780 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349785 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 349788 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 349791 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 349793 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 349796 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /* 349800 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349805 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 349808 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 349810 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 349813 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_B),
     /* 349817 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349822 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 349825 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 349828 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 349831 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 349834 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_B),
     /* 349839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 349841 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 349843 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349846 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 349848 */     GIR_RootConstrainSelectedInstOperands,
     /* 349849 */     // GIR_Coverage, 10994,
     /* 349849 */     GIR_EraseRootFromParent_Done,
     /* 349850 */   // Label 6944: @349850
     /* 349850 */   GIM_Reject,
     /* 349851 */ // Label 6935: @349851
     /* 349851 */ GIM_Reject,
     /* 349852 */ // Label 6682: @349852
     /* 349852 */ GIM_Reject,
     /* 349853 */ // Label 86: @349853
     /* 349853 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 6948*/ GIMT_Encode4(352770),
     /* 349864 */ /*GILLT_s16*//*Label 6945*/ GIMT_Encode4(349876),
     /* 349868 */ /*GILLT_s32*//*Label 6946*/ GIMT_Encode4(350510),
     /* 349872 */ /*GILLT_s64*//*Label 6947*/ GIMT_Encode4(352103),
     /* 349876 */ // Label 6945: @349876
     /* 349876 */ GIM_Try, /*On fail goto*//*Label 6949*/ GIMT_Encode4(349920), // Rule ID 11043 //
     /* 349881 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349884 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 349887 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 349890 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 349894 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 349898 */   // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$Zs, hsub:{ *:[i32] })
     /* 349898 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 349901 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349903 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
     /* 349909 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 349914 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 349919 */   // GIR_Coverage, 11043,
     /* 349919 */   GIR_EraseRootFromParent_Done,
     /* 349920 */ // Label 6949: @349920
     /* 349920 */ GIM_Try, /*On fail goto*//*Label 6950*/ GIMT_Encode4(349964), // Rule ID 11044 //
     /* 349925 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 349931 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 349934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 349938 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 349942 */   // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$Zs, hsub:{ *:[i32] })
     /* 349942 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 349945 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349947 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
     /* 349953 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 349958 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 349963 */   // GIR_Coverage, 11044,
     /* 349963 */   GIR_EraseRootFromParent_Done,
     /* 349964 */ // Label 6950: @349964
     /* 349964 */ GIM_Try, /*On fail goto*//*Label 6951*/ GIMT_Encode4(350008), // Rule ID 11045 //
     /* 349969 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 349975 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 349978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 349982 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 349986 */   // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv2f16] }:$Zs, hsub:{ *:[i32] })
     /* 349986 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 349989 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349991 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
     /* 349997 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350002 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 350007 */   // GIR_Coverage, 11045,
     /* 350007 */   GIR_EraseRootFromParent_Done,
     /* 350008 */ // Label 6951: @350008
     /* 350008 */ GIM_Try, /*On fail goto*//*Label 6952*/ GIMT_Encode4(350053), // Rule ID 5693 //
     /* 350013 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 350016 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 350019 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350023 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350027 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 350031 */   // (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] })
     /* 350031 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350034 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350036 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 350042 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350047 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350052 */   // GIR_Coverage, 5693,
     /* 350052 */   GIR_EraseRootFromParent_Done,
     /* 350053 */ // Label 6952: @350053
     /* 350053 */ GIM_Try, /*On fail goto*//*Label 6953*/ GIMT_Encode4(350098), // Rule ID 5696 //
     /* 350058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 350061 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 350064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350068 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350072 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 350076 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350080 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 350084 */   // MIs[1] Operand 1
     /* 350084 */   // No operand predicates
     /* 350084 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 350086 */   // (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPi16:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 350086 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi16),
     /* 350089 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350091 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 350093 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 350096 */   GIR_RootConstrainSelectedInstOperands,
     /* 350097 */   // GIR_Coverage, 5696,
     /* 350097 */   GIR_EraseRootFromParent_Done,
     /* 350098 */ // Label 6953: @350098
     /* 350098 */ GIM_Try, /*On fail goto*//*Label 6954*/ GIMT_Encode4(350174), // Rule ID 11018 //
     /* 350103 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 350109 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 350112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350116 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 350120 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350124 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 350128 */   // MIs[1] Operand 1
     /* 350128 */   // No operand predicates
     /* 350128 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 350130 */   // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_H:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index), hsub:{ *:[i32] })
     /* 350130 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 350133 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 350137 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350142 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 350146 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 350149 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350151 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350154 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350156 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 350163 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350168 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 350173 */   // GIR_Coverage, 11018,
     /* 350173 */   GIR_EraseRootFromParent_Done,
     /* 350174 */ // Label 6954: @350174
     /* 350174 */ GIM_Try, /*On fail goto*//*Label 6955*/ GIMT_Encode4(350250), // Rule ID 11019 //
     /* 350179 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 350185 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 350188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350192 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 350196 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350200 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 350204 */   // MIs[1] Operand 1
     /* 350204 */   // No operand predicates
     /* 350204 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 350206 */   // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), hsub:{ *:[i32] })
     /* 350206 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 350209 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 350213 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350218 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 350222 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 350225 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350227 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350230 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350232 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 350239 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350244 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 350249 */   // GIR_Coverage, 11019,
     /* 350249 */   GIR_EraseRootFromParent_Done,
     /* 350250 */ // Label 6955: @350250
     /* 350250 */ GIM_Try, /*On fail goto*//*Label 6956*/ GIMT_Encode4(350326), // Rule ID 11020 //
     /* 350255 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 350261 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 350264 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350268 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 350272 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350276 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 350280 */   // MIs[1] Operand 1
     /* 350280 */   // No operand predicates
     /* 350280 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 350282 */   // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), hsub:{ *:[i32] })
     /* 350282 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 350285 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 350289 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350294 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 350298 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 350301 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350303 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350306 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350308 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 350315 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350320 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 350325 */   // GIR_Coverage, 11020,
     /* 350325 */   GIR_EraseRootFromParent_Done,
     /* 350326 */ // Label 6956: @350326
     /* 350326 */ GIM_Try, /*On fail goto*//*Label 6957*/ GIMT_Encode4(350387), // Rule ID 11008 //
     /* 350331 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 350337 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 350340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350344 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 350348 */   // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_H:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv8f16] }:$vec)
     /* 350348 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350351 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
     /* 350355 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350360 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 350366 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 350370 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 350373 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350375 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
     /* 350378 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 350380 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350383 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 350385 */   GIR_RootConstrainSelectedInstOperands,
     /* 350386 */   // GIR_Coverage, 11008,
     /* 350386 */   GIR_EraseRootFromParent_Done,
     /* 350387 */ // Label 6957: @350387
     /* 350387 */ GIM_Try, /*On fail goto*//*Label 6958*/ GIMT_Encode4(350448), // Rule ID 11009 //
     /* 350392 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350395 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 350398 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 350401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350405 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 350409 */   // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4f16] }:$vec)
     /* 350409 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350412 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 350416 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350421 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 350427 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 350431 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 350434 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350436 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
     /* 350439 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 350441 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350444 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 350446 */   GIR_RootConstrainSelectedInstOperands,
     /* 350447 */   // GIR_Coverage, 11009,
     /* 350447 */   GIR_EraseRootFromParent_Done,
     /* 350448 */ // Label 6958: @350448
     /* 350448 */ GIM_Try, /*On fail goto*//*Label 6959*/ GIMT_Encode4(350509), // Rule ID 11010 //
     /* 350453 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 350459 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 350462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350466 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 350470 */   // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f16] }:$vec)
     /* 350470 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350473 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 350477 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350482 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 350488 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 350492 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 350495 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350497 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
     /* 350500 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 350502 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350505 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 350507 */   GIR_RootConstrainSelectedInstOperands,
     /* 350508 */   // GIR_Coverage, 11010,
     /* 350508 */   GIR_EraseRootFromParent_Done,
     /* 350509 */ // Label 6959: @350509
     /* 350509 */ GIM_Reject,
     /* 350510 */ // Label 6946: @350510
     /* 350510 */ GIM_Try, /*On fail goto*//*Label 6960*/ GIMT_Encode4(350555), // Rule ID 6868 //
     /* 350515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 350518 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 350521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 350525 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350529 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 350533 */   // (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$V, ssub:{ *:[i32] })
     /* 350533 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350536 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350538 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // V
     /* 350544 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 350549 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350554 */   // GIR_Coverage, 6868,
     /* 350554 */   GIR_EraseRootFromParent_Done,
     /* 350555 */ // Label 6960: @350555
     /* 350555 */ GIM_Try, /*On fail goto*//*Label 6961*/ GIMT_Encode4(350600), // Rule ID 6869 //
     /* 350560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 350563 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 350566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 350570 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350574 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 350578 */   // (extractelt:{ *:[i32] } V64:{ *:[v2i32] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } V64:{ *:[v2i32] }:$V, ssub:{ *:[i32] })
     /* 350578 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350581 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350583 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // V
     /* 350589 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 350594 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350599 */   // GIR_Coverage, 6869,
     /* 350599 */   GIR_EraseRootFromParent_Done,
     /* 350600 */ // Label 6961: @350600
     /* 350600 */ GIM_Try, /*On fail goto*//*Label 6962*/ GIMT_Encode4(350644), // Rule ID 11039 //
     /* 350605 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350608 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 350611 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 350614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 350618 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 350622 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv16i8] }:$Zs, ssub:{ *:[i32] })
     /* 350622 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350625 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350627 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 350633 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 350638 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 350643 */   // GIR_Coverage, 11039,
     /* 350643 */   GIR_EraseRootFromParent_Done,
     /* 350644 */ // Label 6962: @350644
     /* 350644 */ GIM_Try, /*On fail goto*//*Label 6963*/ GIMT_Encode4(350688), // Rule ID 11040 //
     /* 350649 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350652 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 350655 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 350658 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 350662 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 350666 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv8i16] }:$Zs, ssub:{ *:[i32] })
     /* 350666 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350669 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350671 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 350677 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 350682 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 350687 */   // GIR_Coverage, 11040,
     /* 350687 */   GIR_EraseRootFromParent_Done,
     /* 350688 */ // Label 6963: @350688
     /* 350688 */ GIM_Try, /*On fail goto*//*Label 6964*/ GIMT_Encode4(350732), // Rule ID 11041 //
     /* 350693 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350696 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 350699 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 350702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 350706 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 350710 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv4i32] }:$Zs, ssub:{ *:[i32] })
     /* 350710 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350713 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350715 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 350721 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 350726 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 350731 */   // GIR_Coverage, 11041,
     /* 350731 */   GIR_EraseRootFromParent_Done,
     /* 350732 */ // Label 6964: @350732
     /* 350732 */ GIM_Try, /*On fail goto*//*Label 6965*/ GIMT_Encode4(350776), // Rule ID 11046 //
     /* 350737 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350740 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 350743 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 350746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 350750 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 350754 */   // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$Zs, ssub:{ *:[i32] })
     /* 350754 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350757 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350759 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 350765 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 350770 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 350775 */   // GIR_Coverage, 11046,
     /* 350775 */   GIR_EraseRootFromParent_Done,
     /* 350776 */ // Label 6965: @350776
     /* 350776 */ GIM_Try, /*On fail goto*//*Label 6966*/ GIMT_Encode4(350820), // Rule ID 11047 //
     /* 350781 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350784 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 350787 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 350790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 350794 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 350798 */   // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } ZPR:{ *:[nxv2f32] }:$Zs, ssub:{ *:[i32] })
     /* 350798 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350801 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350803 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 350809 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 350814 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 350819 */   // GIR_Coverage, 11047,
     /* 350819 */   GIR_EraseRootFromParent_Done,
     /* 350820 */ // Label 6966: @350820
     /* 350820 */ GIM_Try, /*On fail goto*//*Label 6967*/ GIMT_Encode4(350865), // Rule ID 5692 //
     /* 350825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 350828 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 350831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 350835 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350839 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 350843 */   // (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] })
     /* 350843 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350846 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350848 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 350854 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 350859 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350864 */   // GIR_Coverage, 5692,
     /* 350864 */   GIR_EraseRootFromParent_Done,
     /* 350865 */ // Label 6967: @350865
     /* 350865 */ GIM_Try, /*On fail goto*//*Label 6968*/ GIMT_Encode4(350938), // Rule ID 11024 //
     /* 350870 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 350873 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 350876 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 350879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 350883 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 350887 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350891 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 350895 */   // MIs[1] Operand 1
     /* 350895 */   // No operand predicates
     /* 350895 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 350897 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)  =>  (UMOVvi8:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
     /* 350897 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 350900 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350904 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350909 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 350915 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350920 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 350925 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /* 350928 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 350930 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350933 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 350936 */   GIR_RootConstrainSelectedInstOperands,
     /* 350937 */   // GIR_Coverage, 11024,
     /* 350937 */   GIR_EraseRootFromParent_Done,
     /* 350938 */ // Label 6968: @350938
     /* 350938 */ GIM_Try, /*On fail goto*//*Label 6969*/ GIMT_Encode4(351011), // Rule ID 11025 //
     /* 350943 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 350946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 350949 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 350952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 350956 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 350960 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350964 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 350968 */   // MIs[1] Operand 1
     /* 350968 */   // No operand predicates
     /* 350968 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 350970 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)  =>  (UMOVvi16:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
     /* 350970 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 350973 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 350977 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350982 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 350988 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350993 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 350998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /* 351001 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 351003 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351006 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 351009 */   GIR_RootConstrainSelectedInstOperands,
     /* 351010 */   // GIR_Coverage, 11025,
     /* 351010 */   GIR_EraseRootFromParent_Done,
     /* 351011 */ // Label 6969: @351011
     /* 351011 */ GIM_Try, /*On fail goto*//*Label 6970*/ GIMT_Encode4(351084), // Rule ID 11026 //
     /* 351016 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 351019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 351022 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 351025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 351029 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 351033 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351037 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 351041 */   // MIs[1] Operand 1
     /* 351041 */   // No operand predicates
     /* 351041 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 351043 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)  =>  (UMOVvi32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v4i32] } ZPR:{ *:[nxv4i32] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)
     /* 351043 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 351046 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 351050 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351055 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 351061 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351066 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 351071 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32),
     /* 351074 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 351076 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351079 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 351082 */   GIR_RootConstrainSelectedInstOperands,
     /* 351083 */   // GIR_Coverage, 11026,
     /* 351083 */   GIR_EraseRootFromParent_Done,
     /* 351084 */ // Label 6970: @351084
     /* 351084 */ GIM_Try, /*On fail goto*//*Label 6971*/ GIMT_Encode4(351132), // Rule ID 1919 //
     /* 351089 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 351092 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 351095 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 351098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 351102 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351106 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 351110 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351114 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 351118 */   // MIs[1] Operand 1
     /* 351118 */   // No operand predicates
     /* 351118 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 351120 */   // (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi8_idx0:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 351120 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8_idx0),
     /* 351123 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 351125 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 351127 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 351130 */   GIR_RootConstrainSelectedInstOperands,
     /* 351131 */   // GIR_Coverage, 1919,
     /* 351131 */   GIR_EraseRootFromParent_Done,
     /* 351132 */ // Label 6971: @351132
     /* 351132 */ GIM_Try, /*On fail goto*//*Label 6972*/ GIMT_Encode4(351180), // Rule ID 1920 //
     /* 351137 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 351140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 351143 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 351146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 351150 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351154 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 351158 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351162 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 351166 */   // MIs[1] Operand 1
     /* 351166 */   // No operand predicates
     /* 351166 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 351168 */   // (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi16_idx0:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 351168 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16_idx0),
     /* 351171 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 351173 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 351175 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 351178 */   GIR_RootConstrainSelectedInstOperands,
     /* 351179 */   // GIR_Coverage, 1920,
     /* 351179 */   GIR_EraseRootFromParent_Done,
     /* 351180 */ // Label 6972: @351180
     /* 351180 */ GIM_Try, /*On fail goto*//*Label 6973*/ GIMT_Encode4(351228), // Rule ID 1921 //
     /* 351185 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 351188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 351191 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 351194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 351198 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351202 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 351206 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351210 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 351214 */   // MIs[1] Operand 1
     /* 351214 */   // No operand predicates
     /* 351214 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 351216 */   // (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi32_idx0:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 351216 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32_idx0),
     /* 351219 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 351221 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 351223 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 351226 */   GIR_RootConstrainSelectedInstOperands,
     /* 351227 */   // GIR_Coverage, 1921,
     /* 351227 */   GIR_EraseRootFromParent_Done,
     /* 351228 */ // Label 6973: @351228
     /* 351228 */ GIM_Try, /*On fail goto*//*Label 6974*/ GIMT_Encode4(351276), // Rule ID 1923 //
     /* 351233 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 351236 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 351239 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 351242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 351246 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351250 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 351254 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351258 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 351262 */   // MIs[1] Operand 1
     /* 351262 */   // No operand predicates
     /* 351262 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 351264 */   // (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 351264 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /* 351267 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 351269 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 351271 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 351274 */   GIR_RootConstrainSelectedInstOperands,
     /* 351275 */   // GIR_Coverage, 1923,
     /* 351275 */   GIR_EraseRootFromParent_Done,
     /* 351276 */ // Label 6974: @351276
     /* 351276 */ GIM_Try, /*On fail goto*//*Label 6975*/ GIMT_Encode4(351324), // Rule ID 1924 //
     /* 351281 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 351284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 351287 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 351290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 351294 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351298 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 351302 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351306 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 351310 */   // MIs[1] Operand 1
     /* 351310 */   // No operand predicates
     /* 351310 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 351312 */   // (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 351312 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /* 351315 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 351317 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 351319 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 351322 */   GIR_RootConstrainSelectedInstOperands,
     /* 351323 */   // GIR_Coverage, 1924,
     /* 351323 */   GIR_EraseRootFromParent_Done,
     /* 351324 */ // Label 6975: @351324
     /* 351324 */ GIM_Try, /*On fail goto*//*Label 6976*/ GIMT_Encode4(351372), // Rule ID 1925 //
     /* 351329 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 351332 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 351335 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 351338 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 351342 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351346 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 351350 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351354 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 351358 */   // MIs[1] Operand 1
     /* 351358 */   // No operand predicates
     /* 351358 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 351360 */   // (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (UMOVvi32:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 351360 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32),
     /* 351363 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 351365 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 351367 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 351370 */   GIR_RootConstrainSelectedInstOperands,
     /* 351371 */   // GIR_Coverage, 1925,
     /* 351371 */   GIR_EraseRootFromParent_Done,
     /* 351372 */ // Label 6976: @351372
     /* 351372 */ GIM_Try, /*On fail goto*//*Label 6977*/ GIMT_Encode4(351417), // Rule ID 5695 //
     /* 351377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 351380 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 351383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 351387 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351391 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 351395 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351399 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 351403 */   // MIs[1] Operand 1
     /* 351403 */   // No operand predicates
     /* 351403 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 351405 */   // (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPi32:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 351405 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi32),
     /* 351408 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351410 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 351412 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 351415 */   GIR_RootConstrainSelectedInstOperands,
     /* 351416 */   // GIR_Coverage, 5695,
     /* 351416 */   GIR_EraseRootFromParent_Done,
     /* 351417 */ // Label 6977: @351417
     /* 351417 */ GIM_Try, /*On fail goto*//*Label 6978*/ GIMT_Encode4(351493), // Rule ID 11014 //
     /* 351422 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 351428 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 351431 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 351435 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 351439 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351443 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_b),
     /* 351447 */   // MIs[1] Operand 1
     /* 351447 */   // No operand predicates
     /* 351447 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 351449 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index), ssub:{ *:[i32] })
     /* 351449 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 351452 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_B),
     /* 351456 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351461 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 351465 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 351468 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351470 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 351473 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351475 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 351482 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 351487 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 351492 */   // GIR_Coverage, 11014,
     /* 351492 */   GIR_EraseRootFromParent_Done,
     /* 351493 */ // Label 6978: @351493
     /* 351493 */ GIM_Try, /*On fail goto*//*Label 6979*/ GIMT_Encode4(351569), // Rule ID 11015 //
     /* 351498 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 351504 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 351507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 351511 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 351515 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351519 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 351523 */   // MIs[1] Operand 1
     /* 351523 */   // No operand predicates
     /* 351523 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 351525 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_H:{ *:[nxv16i8] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index), ssub:{ *:[i32] })
     /* 351525 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 351528 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 351532 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351537 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 351541 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 351544 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351546 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 351549 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351551 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 351558 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 351563 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 351568 */   // GIR_Coverage, 11015,
     /* 351568 */   GIR_EraseRootFromParent_Done,
     /* 351569 */ // Label 6979: @351569
     /* 351569 */ GIM_Try, /*On fail goto*//*Label 6980*/ GIMT_Encode4(351645), // Rule ID 11016 //
     /* 351574 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351577 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 351580 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 351583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 351587 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 351591 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351595 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 351599 */   // MIs[1] Operand 1
     /* 351599 */   // No operand predicates
     /* 351599 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 351601 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), ssub:{ *:[i32] })
     /* 351601 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 351604 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 351608 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351613 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 351617 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 351620 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351622 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 351625 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351627 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 351634 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 351639 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 351644 */   // GIR_Coverage, 11016,
     /* 351644 */   GIR_EraseRootFromParent_Done,
     /* 351645 */ // Label 6980: @351645
     /* 351645 */ GIM_Try, /*On fail goto*//*Label 6981*/ GIMT_Encode4(351721), // Rule ID 11021 //
     /* 351650 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351653 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 351656 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 351659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 351663 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 351667 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351671 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 351675 */   // MIs[1] Operand 1
     /* 351675 */   // No operand predicates
     /* 351675 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 351677 */   // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f32] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), ssub:{ *:[i32] })
     /* 351677 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 351680 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 351684 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351689 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 351693 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 351696 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351698 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 351701 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351703 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 351710 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 351715 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 351720 */   // GIR_Coverage, 11021,
     /* 351720 */   GIR_EraseRootFromParent_Done,
     /* 351721 */ // Label 6981: @351721
     /* 351721 */ GIM_Try, /*On fail goto*//*Label 6982*/ GIMT_Encode4(351797), // Rule ID 11022 //
     /* 351726 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 351732 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 351735 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 351739 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 351743 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351747 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 351751 */   // MIs[1] Operand 1
     /* 351751 */   // No operand predicates
     /* 351751 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 351753 */   // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f32] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), ssub:{ *:[i32] })
     /* 351753 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 351756 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 351760 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351765 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 351769 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 351772 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 351777 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351779 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 351786 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 351791 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 351796 */   // GIR_Coverage, 11022,
     /* 351796 */   GIR_EraseRootFromParent_Done,
     /* 351797 */ // Label 6982: @351797
     /* 351797 */ GIM_Try, /*On fail goto*//*Label 6983*/ GIMT_Encode4(351858), // Rule ID 11004 //
     /* 351802 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351805 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 351808 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 351811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 351815 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 351819 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_B:{ *:[i32] } (WHILELS_PXX_B:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv16i8] }:$vec)
     /* 351819 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351822 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_B),
     /* 351826 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351831 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 351837 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 351841 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 351844 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351846 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_B),
     /* 351849 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 351851 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351854 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 351856 */   GIR_RootConstrainSelectedInstOperands,
     /* 351857 */   // GIR_Coverage, 11004,
     /* 351857 */   GIR_EraseRootFromParent_Done,
     /* 351858 */ // Label 6983: @351858
     /* 351858 */ GIM_Try, /*On fail goto*//*Label 6984*/ GIMT_Encode4(351919), // Rule ID 11005 //
     /* 351863 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 351869 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 351872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 351876 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 351880 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_H:{ *:[i32] } (WHILELS_PXX_H:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv8i16] }:$vec)
     /* 351880 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351883 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
     /* 351887 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351892 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 351898 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 351902 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 351905 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351907 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_H),
     /* 351910 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 351912 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351915 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 351917 */   GIR_RootConstrainSelectedInstOperands,
     /* 351918 */   // GIR_Coverage, 11005,
     /* 351918 */   GIR_EraseRootFromParent_Done,
     /* 351919 */ // Label 6984: @351919
     /* 351919 */ GIM_Try, /*On fail goto*//*Label 6985*/ GIMT_Encode4(351980), // Rule ID 11006 //
     /* 351924 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351927 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 351930 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 351933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 351937 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 351941 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_S:{ *:[i32] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4i32] }:$vec)
     /* 351941 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351944 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 351948 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351953 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 351959 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 351963 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 351966 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351968 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_S),
     /* 351971 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 351973 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351976 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 351978 */   GIR_RootConstrainSelectedInstOperands,
     /* 351979 */   // GIR_Coverage, 11006,
     /* 351979 */   GIR_EraseRootFromParent_Done,
     /* 351980 */ // Label 6985: @351980
     /* 351980 */ GIM_Try, /*On fail goto*//*Label 6986*/ GIMT_Encode4(352041), // Rule ID 11011 //
     /* 351985 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 351991 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 351994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 351998 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 352002 */   // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_S:{ *:[f32] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4f32] }:$vec)
     /* 352002 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352005 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 352009 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352014 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 352020 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 352024 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 352027 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352029 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_S),
     /* 352032 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 352034 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352037 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 352039 */   GIR_RootConstrainSelectedInstOperands,
     /* 352040 */   // GIR_Coverage, 11011,
     /* 352040 */   GIR_EraseRootFromParent_Done,
     /* 352041 */ // Label 6986: @352041
     /* 352041 */ GIM_Try, /*On fail goto*//*Label 6987*/ GIMT_Encode4(352102), // Rule ID 11012 //
     /* 352046 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 352052 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 352055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 352059 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 352063 */   // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_S:{ *:[f32] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f32] }:$vec)
     /* 352063 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352066 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 352070 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352075 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 352081 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 352085 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 352088 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352090 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_S),
     /* 352093 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 352095 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352098 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 352100 */   GIR_RootConstrainSelectedInstOperands,
     /* 352101 */   // GIR_Coverage, 11012,
     /* 352101 */   GIR_EraseRootFromParent_Done,
     /* 352102 */ // Label 6987: @352102
     /* 352102 */ GIM_Reject,
     /* 352103 */ // Label 6947: @352103
     /* 352103 */ GIM_Try, /*On fail goto*//*Label 6988*/ GIMT_Encode4(352148), // Rule ID 6867 //
     /* 352108 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 352111 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 352114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352118 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352122 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 352126 */   // (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$V, dsub:{ *:[i32] })
     /* 352126 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 352129 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352131 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // V
     /* 352137 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352142 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352147 */   // GIR_Coverage, 6867,
     /* 352147 */   GIR_EraseRootFromParent_Done,
     /* 352148 */ // Label 6988: @352148
     /* 352148 */ GIM_Try, /*On fail goto*//*Label 6989*/ GIMT_Encode4(352192), // Rule ID 11042 //
     /* 352153 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 352159 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 352162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352166 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 352170 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i64] } ZPR:{ *:[nxv2i64] }:$Zs, dsub:{ *:[i32] })
     /* 352170 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 352173 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352175 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Zs
     /* 352181 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352186 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 352191 */   // GIR_Coverage, 11042,
     /* 352191 */   GIR_EraseRootFromParent_Done,
     /* 352192 */ // Label 6989: @352192
     /* 352192 */ GIM_Try, /*On fail goto*//*Label 6990*/ GIMT_Encode4(352236), // Rule ID 11048 //
     /* 352197 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 352203 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 352206 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352210 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 352214 */   // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f64] } ZPR:{ *:[nxv2f64] }:$Zs, dsub:{ *:[i32] })
     /* 352214 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 352217 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352219 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Zs
     /* 352225 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352230 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 352235 */   // GIR_Coverage, 11048,
     /* 352235 */   GIR_EraseRootFromParent_Done,
     /* 352236 */ // Label 6990: @352236
     /* 352236 */ GIM_Try, /*On fail goto*//*Label 6991*/ GIMT_Encode4(352281), // Rule ID 5691 //
     /* 352241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 352244 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 352247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352251 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352255 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 352259 */   // (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] })
     /* 352259 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 352262 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352264 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 352270 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352275 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352280 */   // GIR_Coverage, 5691,
     /* 352280 */   GIR_EraseRootFromParent_Done,
     /* 352281 */ // Label 6991: @352281
     /* 352281 */ GIM_Try, /*On fail goto*//*Label 6992*/ GIMT_Encode4(352354), // Rule ID 11027 //
     /* 352286 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 352289 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 352292 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 352295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 352299 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 352303 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352307 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 352311 */   // MIs[1] Operand 1
     /* 352311 */   // No operand predicates
     /* 352311 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 352313 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$index)  =>  (UMOVvi64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v2i64] } ZPR:{ *:[nxv2i64] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$index)
     /* 352313 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 352316 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 352320 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352325 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 352331 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352336 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 352341 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64),
     /* 352344 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 352346 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352349 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 352352 */   GIR_RootConstrainSelectedInstOperands,
     /* 352353 */   // GIR_Coverage, 11027,
     /* 352353 */   GIR_EraseRootFromParent_Done,
     /* 352354 */ // Label 6992: @352354
     /* 352354 */ GIM_Try, /*On fail goto*//*Label 6993*/ GIMT_Encode4(352402), // Rule ID 1922 //
     /* 352359 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 352362 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 352365 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 352368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 352372 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352376 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 352380 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352384 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 352388 */   // MIs[1] Operand 1
     /* 352388 */   // No operand predicates
     /* 352388 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 352390 */   // (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi64_idx0:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 352390 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64_idx0),
     /* 352393 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 352395 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 352397 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 352400 */   GIR_RootConstrainSelectedInstOperands,
     /* 352401 */   // GIR_Coverage, 1922,
     /* 352401 */   GIR_EraseRootFromParent_Done,
     /* 352402 */ // Label 6993: @352402
     /* 352402 */ GIM_Try, /*On fail goto*//*Label 6994*/ GIMT_Encode4(352450), // Rule ID 1926 //
     /* 352407 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 352410 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 352413 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 352416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 352420 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352424 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 352428 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352432 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 352436 */   // MIs[1] Operand 1
     /* 352436 */   // No operand predicates
     /* 352436 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 352438 */   // (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (UMOVvi64:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 352438 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64),
     /* 352441 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 352443 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 352445 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 352448 */   GIR_RootConstrainSelectedInstOperands,
     /* 352449 */   // GIR_Coverage, 1926,
     /* 352449 */   GIR_EraseRootFromParent_Done,
     /* 352450 */ // Label 6994: @352450
     /* 352450 */ GIM_Try, /*On fail goto*//*Label 6995*/ GIMT_Encode4(352495), // Rule ID 5694 //
     /* 352455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 352458 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 352461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352465 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352469 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 352473 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352477 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 352481 */   // MIs[1] Operand 1
     /* 352481 */   // No operand predicates
     /* 352481 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 352483 */   // (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (DUPi64:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 352483 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi64),
     /* 352486 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352488 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 352490 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 352493 */   GIR_RootConstrainSelectedInstOperands,
     /* 352494 */   // GIR_Coverage, 5694,
     /* 352494 */   GIR_EraseRootFromParent_Done,
     /* 352495 */ // Label 6995: @352495
     /* 352495 */ GIM_Try, /*On fail goto*//*Label 6996*/ GIMT_Encode4(352571), // Rule ID 11017 //
     /* 352500 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352503 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 352506 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 352509 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352513 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 352517 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352521 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 352525 */   // MIs[1] Operand 1
     /* 352525 */   // No operand predicates
     /* 352525 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 352527 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i64] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), dsub:{ *:[i32] })
     /* 352527 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 352530 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 352534 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352539 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 352543 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 352546 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352548 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 352551 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352553 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 352560 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352565 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 352570 */   // GIR_Coverage, 11017,
     /* 352570 */   GIR_EraseRootFromParent_Done,
     /* 352571 */ // Label 6996: @352571
     /* 352571 */ GIM_Try, /*On fail goto*//*Label 6997*/ GIMT_Encode4(352647), // Rule ID 11023 //
     /* 352576 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 352582 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 352585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352589 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 352593 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352597 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 352601 */   // MIs[1] Operand 1
     /* 352601 */   // No operand predicates
     /* 352601 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 352603 */   // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f64] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), dsub:{ *:[i32] })
     /* 352603 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 352606 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 352610 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352615 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 352619 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 352622 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352624 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 352627 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352629 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 352636 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352641 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 352646 */   // GIR_Coverage, 11023,
     /* 352646 */   GIR_EraseRootFromParent_Done,
     /* 352647 */ // Label 6997: @352647
     /* 352647 */ GIM_Try, /*On fail goto*//*Label 6998*/ GIMT_Encode4(352708), // Rule ID 11007 //
     /* 352652 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352655 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 352658 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 352661 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 352665 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 352669 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_D:{ *:[i64] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2i64] }:$vec)
     /* 352669 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352672 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 352676 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352681 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 352687 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 352691 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 352694 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352696 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_D),
     /* 352699 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 352701 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352704 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 352706 */   GIR_RootConstrainSelectedInstOperands,
     /* 352707 */   // GIR_Coverage, 11007,
     /* 352707 */   GIR_EraseRootFromParent_Done,
     /* 352708 */ // Label 6998: @352708
     /* 352708 */ GIM_Try, /*On fail goto*//*Label 6999*/ GIMT_Encode4(352769), // Rule ID 11013 //
     /* 352713 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352716 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 352719 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 352722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352726 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 352730 */   // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_D:{ *:[f64] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f64] }:$vec)
     /* 352730 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352733 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 352737 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352742 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 352748 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 352752 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 352755 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352757 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_D),
     /* 352760 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 352762 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352765 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 352767 */   GIR_RootConstrainSelectedInstOperands,
     /* 352768 */   // GIR_Coverage, 11013,
     /* 352768 */   GIR_EraseRootFromParent_Done,
     /* 352769 */ // Label 6999: @352769
     /* 352769 */ GIM_Reject,
     /* 352770 */ // Label 6948: @352770
     /* 352770 */ GIM_Reject,
     /* 352771 */ // Label 87: @352771
     /* 352771 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(14), GIMT_Encode2(24), /*)*//*default:*//*Label 7007*/ GIMT_Encode4(354476),
     /* 352782 */ /*GILLT_nxv2s16*//*Label 7000*/ GIMT_Encode4(352822),
     /* 352786 */ /*GILLT_nxv2s32*//*Label 7001*/ GIMT_Encode4(353117),
     /* 352790 */ /*GILLT_nxv2s64*//*Label 7002*/ GIMT_Encode4(353355), GIMT_Encode4(0),
     /* 352798 */ /*GILLT_nxv4s16*//*Label 7003*/ GIMT_Encode4(353612),
     /* 352802 */ /*GILLT_nxv4s32*//*Label 7004*/ GIMT_Encode4(353850), GIMT_Encode4(0),
     /* 352810 */ /*GILLT_nxv8s16*//*Label 7005*/ GIMT_Encode4(354107), GIMT_Encode4(0),
     /* 352818 */ /*GILLT_nxv16s8*//*Label 7006*/ GIMT_Encode4(354386),
     /* 352822 */ // Label 7000: @352822
     /* 352822 */ GIM_Try, /*On fail goto*//*Label 7008*/ GIMT_Encode4(353116),
     /* 352827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 352830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 352834 */   GIM_Try, /*On fail goto*//*Label 7009*/ GIMT_Encode4(352891), // Rule ID 2661 //
     /* 352839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 352850 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 352854 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 352858 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 352863 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 352867 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352871 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 352875 */     // MIs[2] Operand 1
     /* 352875 */     // No operand predicates
     /* 352875 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 352877 */     // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 352877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 352880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 352882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 352886 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 352889 */     GIR_RootConstrainSelectedInstOperands,
     /* 352890 */     // GIR_Coverage, 2661,
     /* 352890 */     GIR_EraseRootFromParent_Done,
     /* 352891 */   // Label 7009: @352891
     /* 352891 */   GIM_Try, /*On fail goto*//*Label 7010*/ GIMT_Encode4(352948), // Rule ID 2663 //
     /* 352896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 352907 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 352911 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 352915 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 352920 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 352924 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352928 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 352932 */     // MIs[2] Operand 1
     /* 352932 */     // No operand predicates
     /* 352932 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 352934 */     // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f16] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 352934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 352937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 352939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 352943 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 352946 */     GIR_RootConstrainSelectedInstOperands,
     /* 352947 */     // GIR_Coverage, 2663,
     /* 352947 */     GIR_EraseRootFromParent_Done,
     /* 352948 */   // Label 7010: @352948
     /* 352948 */   GIM_Try, /*On fail goto*//*Label 7011*/ GIMT_Encode4(353005), // Rule ID 8187 //
     /* 352953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 352964 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 352968 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 352972 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 352977 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 352981 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352985 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 352989 */     // MIs[2] Operand 1
     /* 352989 */     // No operand predicates
     /* 352989 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 352991 */     // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv2f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 352991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 352994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 352996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 353000 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 353003 */     GIR_RootConstrainSelectedInstOperands,
     /* 353004 */     // GIR_Coverage, 8187,
     /* 353004 */     GIR_EraseRootFromParent_Done,
     /* 353005 */   // Label 7011: @353005
     /* 353005 */   GIM_Try, /*On fail goto*//*Label 7012*/ GIMT_Encode4(353039), // Rule ID 8230 //
     /* 353010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 353021 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 353025 */     // MIs[1] Operand 1
     /* 353025 */     // No operand predicates
     /* 353025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 353027 */     // (splat_vector:{ *:[nxv2f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv2f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 353027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
     /* 353030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353032 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 353037 */     GIR_RootConstrainSelectedInstOperands,
     /* 353038 */     // GIR_Coverage, 8230,
     /* 353038 */     GIR_EraseRootFromParent_Done,
     /* 353039 */   // Label 7012: @353039
     /* 353039 */   GIM_Try, /*On fail goto*//*Label 7013*/ GIMT_Encode4(353115), // Rule ID 8208 //
     /* 353044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353047 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 353051 */     // (splat_vector:{ *:[nxv2f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv2f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 353051 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 353054 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 353058 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353063 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 353065 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 353068 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 353072 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353077 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 353080 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 353084 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 353087 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353092 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353097 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 353102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 353105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353107 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353113 */     GIR_RootConstrainSelectedInstOperands,
     /* 353114 */     // GIR_Coverage, 8208,
     /* 353114 */     GIR_EraseRootFromParent_Done,
     /* 353115 */   // Label 7013: @353115
     /* 353115 */   GIM_Reject,
     /* 353116 */ // Label 7008: @353116
     /* 353116 */ GIM_Reject,
     /* 353117 */ // Label 7001: @353117
     /* 353117 */ GIM_Try, /*On fail goto*//*Label 7014*/ GIMT_Encode4(353354),
     /* 353122 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 353125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353129 */   GIM_Try, /*On fail goto*//*Label 7015*/ GIMT_Encode4(353186), // Rule ID 8196 //
     /* 353134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 353145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 353149 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 353153 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353158 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353162 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353166 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 353170 */     // MIs[2] Operand 1
     /* 353170 */     // No operand predicates
     /* 353170 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353172 */     // (splat_vector:{ *:[nxv2f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 353172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 353175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 353181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 353184 */     GIR_RootConstrainSelectedInstOperands,
     /* 353185 */     // GIR_Coverage, 8196,
     /* 353185 */     GIR_EraseRootFromParent_Done,
     /* 353186 */   // Label 7015: @353186
     /* 353186 */   GIM_Try, /*On fail goto*//*Label 7016*/ GIMT_Encode4(353243), // Rule ID 8205 //
     /* 353191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 353202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 353206 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 353210 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353223 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 353227 */     // MIs[2] Operand 1
     /* 353227 */     // No operand predicates
     /* 353227 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353229 */     // (splat_vector:{ *:[nxv2f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f32] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 353229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 353232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 353238 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 353241 */     GIR_RootConstrainSelectedInstOperands,
     /* 353242 */     // GIR_Coverage, 8205,
     /* 353242 */     GIR_EraseRootFromParent_Done,
     /* 353243 */   // Label 7016: @353243
     /* 353243 */   GIM_Try, /*On fail goto*//*Label 7017*/ GIMT_Encode4(353277), // Rule ID 8232 //
     /* 353248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 353259 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 353263 */     // MIs[1] Operand 1
     /* 353263 */     // No operand predicates
     /* 353263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 353265 */     // (splat_vector:{ *:[nxv2f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8)  =>  (FDUP_ZI_S:{ *:[nxv2f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 353265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_S),
     /* 353268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353270 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 353275 */     GIR_RootConstrainSelectedInstOperands,
     /* 353276 */     // GIR_Coverage, 8232,
     /* 353276 */     GIR_EraseRootFromParent_Done,
     /* 353277 */   // Label 7017: @353277
     /* 353277 */   GIM_Try, /*On fail goto*//*Label 7018*/ GIMT_Encode4(353353), // Rule ID 8210 //
     /* 353282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353285 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 353289 */     // (splat_vector:{ *:[nxv2f32] } FPR32:{ *:[f32] }:$src)  =>  (DUP_ZZI_S:{ *:[nxv2f32] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR32:{ *:[f32] }:$src, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 353289 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 353292 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 353296 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353301 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 353303 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 353306 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 353310 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353315 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 353318 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 353322 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 353325 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353330 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353335 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 353340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 353343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353345 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353351 */     GIR_RootConstrainSelectedInstOperands,
     /* 353352 */     // GIR_Coverage, 8210,
     /* 353352 */     GIR_EraseRootFromParent_Done,
     /* 353353 */   // Label 7018: @353353
     /* 353353 */   GIM_Reject,
     /* 353354 */ // Label 7014: @353354
     /* 353354 */ GIM_Reject,
     /* 353355 */ // Label 7002: @353355
     /* 353355 */ GIM_Try, /*On fail goto*//*Label 7019*/ GIMT_Encode4(353611),
     /* 353360 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 353363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353367 */   GIM_Try, /*On fail goto*//*Label 7020*/ GIMT_Encode4(353424), // Rule ID 2658 //
     /* 353372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 353383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 353387 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 353391 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353404 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 353408 */     // MIs[2] Operand 1
     /* 353408 */     // No operand predicates
     /* 353408 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353410 */     // (splat_vector:{ *:[nxv2i64] } (vector_extract:{ *:[i64] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2i64] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 353410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 353413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 353419 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 353422 */     GIR_RootConstrainSelectedInstOperands,
     /* 353423 */     // GIR_Coverage, 2658,
     /* 353423 */     GIR_EraseRootFromParent_Done,
     /* 353424 */   // Label 7020: @353424
     /* 353424 */   GIM_Try, /*On fail goto*//*Label 7021*/ GIMT_Encode4(353481), // Rule ID 8202 //
     /* 353429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 353440 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 353444 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 353448 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353453 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353457 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353461 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 353465 */     // MIs[2] Operand 1
     /* 353465 */     // No operand predicates
     /* 353465 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353467 */     // (splat_vector:{ *:[nxv2f64] } (vector_extract:{ *:[f64] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f64] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 353467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 353470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 353476 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 353479 */     GIR_RootConstrainSelectedInstOperands,
     /* 353480 */     // GIR_Coverage, 8202,
     /* 353480 */     GIR_EraseRootFromParent_Done,
     /* 353481 */   // Label 7021: @353481
     /* 353481 */   GIM_Try, /*On fail goto*//*Label 7022*/ GIMT_Encode4(353515), // Rule ID 8233 //
     /* 353486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 353497 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm64),
     /* 353501 */     // MIs[1] Operand 1
     /* 353501 */     // No operand predicates
     /* 353501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 353503 */     // (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>><<X:fpimm64XForm>>:$imm8)  =>  (FDUP_ZI_D:{ *:[nxv2f64] } (fpimm64XForm:{ *:[f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>>:$imm8))
     /* 353503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_D),
     /* 353506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353508 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm64), // imm8
     /* 353513 */     GIR_RootConstrainSelectedInstOperands,
     /* 353514 */     // GIR_Coverage, 8233,
     /* 353514 */     GIR_EraseRootFromParent_Done,
     /* 353515 */   // Label 7022: @353515
     /* 353515 */   GIM_Try, /*On fail goto*//*Label 7023*/ GIMT_Encode4(353534), // Rule ID 2382 //
     /* 353520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353523 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 353527 */     // (splat_vector:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$Rn)  =>  (DUP_ZR_D:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 353527 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 353532 */     GIR_RootConstrainSelectedInstOperands,
     /* 353533 */     // GIR_Coverage, 2382,
     /* 353533 */     GIR_Done,
     /* 353534 */   // Label 7023: @353534
     /* 353534 */   GIM_Try, /*On fail goto*//*Label 7024*/ GIMT_Encode4(353610), // Rule ID 8211 //
     /* 353539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353546 */     // (splat_vector:{ *:[nxv2f64] } FPR64:{ *:[f64] }:$src)  =>  (DUP_ZZI_D:{ *:[nxv2f64] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR64:{ *:[f64] }:$src, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 353546 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 353549 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 353553 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353558 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 353560 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 353563 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 353567 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353572 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 353575 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 353579 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 353582 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353587 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353592 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 353600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353602 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353608 */     GIR_RootConstrainSelectedInstOperands,
     /* 353609 */     // GIR_Coverage, 8211,
     /* 353609 */     GIR_EraseRootFromParent_Done,
     /* 353610 */   // Label 7024: @353610
     /* 353610 */   GIM_Reject,
     /* 353611 */ // Label 7019: @353611
     /* 353611 */ GIM_Reject,
     /* 353612 */ // Label 7003: @353612
     /* 353612 */ GIM_Try, /*On fail goto*//*Label 7025*/ GIMT_Encode4(353849),
     /* 353617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 353620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353624 */   GIM_Try, /*On fail goto*//*Label 7026*/ GIMT_Encode4(353681), // Rule ID 2662 //
     /* 353629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 353640 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 353644 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 353648 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353653 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353657 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353661 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 353665 */     // MIs[2] Operand 1
     /* 353665 */     // No operand predicates
     /* 353665 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353667 */     // (splat_vector:{ *:[nxv4f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 353667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 353670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 353676 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 353679 */     GIR_RootConstrainSelectedInstOperands,
     /* 353680 */     // GIR_Coverage, 2662,
     /* 353680 */     GIR_EraseRootFromParent_Done,
     /* 353681 */   // Label 7026: @353681
     /* 353681 */   GIM_Try, /*On fail goto*//*Label 7027*/ GIMT_Encode4(353738), // Rule ID 8190 //
     /* 353686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 353697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 353701 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 353705 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353710 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353714 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353718 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 353722 */     // MIs[2] Operand 1
     /* 353722 */     // No operand predicates
     /* 353722 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353724 */     // (splat_vector:{ *:[nxv4f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 353724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 353727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 353733 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 353736 */     GIR_RootConstrainSelectedInstOperands,
     /* 353737 */     // GIR_Coverage, 8190,
     /* 353737 */     GIR_EraseRootFromParent_Done,
     /* 353738 */   // Label 7027: @353738
     /* 353738 */   GIM_Try, /*On fail goto*//*Label 7028*/ GIMT_Encode4(353772), // Rule ID 8229 //
     /* 353743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 353754 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 353758 */     // MIs[1] Operand 1
     /* 353758 */     // No operand predicates
     /* 353758 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 353760 */     // (splat_vector:{ *:[nxv4f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv4f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 353760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
     /* 353763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353765 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 353770 */     GIR_RootConstrainSelectedInstOperands,
     /* 353771 */     // GIR_Coverage, 8229,
     /* 353771 */     GIR_EraseRootFromParent_Done,
     /* 353772 */   // Label 7028: @353772
     /* 353772 */   GIM_Try, /*On fail goto*//*Label 7029*/ GIMT_Encode4(353848), // Rule ID 8207 //
     /* 353777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353780 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 353784 */     // (splat_vector:{ *:[nxv4f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv4f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 353784 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 353787 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 353791 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353796 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 353798 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 353801 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 353805 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353810 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 353813 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 353817 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 353820 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353825 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353830 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 353835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 353838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353840 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353846 */     GIR_RootConstrainSelectedInstOperands,
     /* 353847 */     // GIR_Coverage, 8207,
     /* 353847 */     GIR_EraseRootFromParent_Done,
     /* 353848 */   // Label 7029: @353848
     /* 353848 */   GIM_Reject,
     /* 353849 */ // Label 7025: @353849
     /* 353849 */ GIM_Reject,
     /* 353850 */ // Label 7004: @353850
     /* 353850 */ GIM_Try, /*On fail goto*//*Label 7030*/ GIMT_Encode4(354106),
     /* 353855 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 353858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353862 */   GIM_Try, /*On fail goto*//*Label 7031*/ GIMT_Encode4(353919), // Rule ID 2655 //
     /* 353867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 353878 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 353882 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 353886 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353891 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353895 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353899 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 353903 */     // MIs[2] Operand 1
     /* 353903 */     // No operand predicates
     /* 353903 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353905 */     // (splat_vector:{ *:[nxv4i32] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4i32] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 353905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 353908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 353914 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 353917 */     GIR_RootConstrainSelectedInstOperands,
     /* 353918 */     // GIR_Coverage, 2655,
     /* 353918 */     GIR_EraseRootFromParent_Done,
     /* 353919 */   // Label 7031: @353919
     /* 353919 */   GIM_Try, /*On fail goto*//*Label 7032*/ GIMT_Encode4(353976), // Rule ID 8199 //
     /* 353924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 353935 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 353939 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 353943 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353956 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 353960 */     // MIs[2] Operand 1
     /* 353960 */     // No operand predicates
     /* 353960 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353962 */     // (splat_vector:{ *:[nxv4f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 353962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 353965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 353971 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 353974 */     GIR_RootConstrainSelectedInstOperands,
     /* 353975 */     // GIR_Coverage, 8199,
     /* 353975 */     GIR_EraseRootFromParent_Done,
     /* 353976 */   // Label 7032: @353976
     /* 353976 */   GIM_Try, /*On fail goto*//*Label 7033*/ GIMT_Encode4(354010), // Rule ID 8231 //
     /* 353981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 353992 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 353996 */     // MIs[1] Operand 1
     /* 353996 */     // No operand predicates
     /* 353996 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 353998 */     // (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8)  =>  (FDUP_ZI_S:{ *:[nxv4f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 353998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_S),
     /* 354001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 354003 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 354008 */     GIR_RootConstrainSelectedInstOperands,
     /* 354009 */     // GIR_Coverage, 8231,
     /* 354009 */     GIR_EraseRootFromParent_Done,
     /* 354010 */   // Label 7033: @354010
     /* 354010 */   GIM_Try, /*On fail goto*//*Label 7034*/ GIMT_Encode4(354029), // Rule ID 2381 //
     /* 354015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354018 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 354022 */     // (splat_vector:{ *:[nxv4i32] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_S:{ *:[nxv4i32] } GPR32sp:{ *:[i32] }:$Rn)
     /* 354022 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 354027 */     GIR_RootConstrainSelectedInstOperands,
     /* 354028 */     // GIR_Coverage, 2381,
     /* 354028 */     GIR_Done,
     /* 354029 */   // Label 7034: @354029
     /* 354029 */   GIM_Try, /*On fail goto*//*Label 7035*/ GIMT_Encode4(354105), // Rule ID 8209 //
     /* 354034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354037 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 354041 */     // (splat_vector:{ *:[nxv4f32] } FPR32:{ *:[f32] }:$src)  =>  (DUP_ZZI_S:{ *:[nxv4f32] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR32:{ *:[f32] }:$src, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 354041 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 354044 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 354048 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354053 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 354055 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 354058 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 354062 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354067 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 354070 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 354074 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 354077 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354082 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354087 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 354092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 354095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 354097 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354103 */     GIR_RootConstrainSelectedInstOperands,
     /* 354104 */     // GIR_Coverage, 8209,
     /* 354104 */     GIR_EraseRootFromParent_Done,
     /* 354105 */   // Label 7035: @354105
     /* 354105 */   GIM_Reject,
     /* 354106 */ // Label 7030: @354106
     /* 354106 */ GIM_Reject,
     /* 354107 */ // Label 7005: @354107
     /* 354107 */ GIM_Try, /*On fail goto*//*Label 7036*/ GIMT_Encode4(354171), // Rule ID 2652 //
     /* 354112 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 354118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354122 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354126 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 354130 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 354134 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 354138 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354143 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 354147 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 354151 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 354155 */   // MIs[2] Operand 1
     /* 354155 */   // No operand predicates
     /* 354155 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354157 */   // (splat_vector:{ *:[nxv8i16] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv8i16] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 354157 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 354160 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 354162 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 354166 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 354169 */   GIR_RootConstrainSelectedInstOperands,
     /* 354170 */   // GIR_Coverage, 2652,
     /* 354170 */   GIR_EraseRootFromParent_Done,
     /* 354171 */ // Label 7036: @354171
     /* 354171 */ GIM_Try, /*On fail goto*//*Label 7037*/ GIMT_Encode4(354235), // Rule ID 8193 //
     /* 354176 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 354182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354186 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354190 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 354194 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 354198 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 354202 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354207 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 354211 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 354215 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 354219 */   // MIs[2] Operand 1
     /* 354219 */   // No operand predicates
     /* 354219 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354221 */   // (splat_vector:{ *:[nxv8f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv8f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 354221 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 354224 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 354226 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 354230 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 354233 */   GIR_RootConstrainSelectedInstOperands,
     /* 354234 */   // GIR_Coverage, 8193,
     /* 354234 */   GIR_EraseRootFromParent_Done,
     /* 354235 */ // Label 7037: @354235
     /* 354235 */ GIM_Try, /*On fail goto*//*Label 7038*/ GIMT_Encode4(354276), // Rule ID 8228 //
     /* 354240 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354243 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 354246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354250 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354254 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 354258 */   GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 354262 */   // MIs[1] Operand 1
     /* 354262 */   // No operand predicates
     /* 354262 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 354264 */   // (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv8f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 354264 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
     /* 354267 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 354269 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 354274 */   GIR_RootConstrainSelectedInstOperands,
     /* 354275 */   // GIR_Coverage, 8228,
     /* 354275 */   GIR_EraseRootFromParent_Done,
     /* 354276 */ // Label 7038: @354276
     /* 354276 */ GIM_Try, /*On fail goto*//*Label 7039*/ GIMT_Encode4(354302), // Rule ID 2380 //
     /* 354281 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 354287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354291 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 354295 */   // (splat_vector:{ *:[nxv8i16] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_H:{ *:[nxv8i16] } GPR32sp:{ *:[i32] }:$Rn)
     /* 354295 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
     /* 354300 */   GIR_RootConstrainSelectedInstOperands,
     /* 354301 */   // GIR_Coverage, 2380,
     /* 354301 */   GIR_Done,
     /* 354302 */ // Label 7039: @354302
     /* 354302 */ GIM_Try, /*On fail goto*//*Label 7040*/ GIMT_Encode4(354385), // Rule ID 8206 //
     /* 354307 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354310 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 354313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354317 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 354321 */   // (splat_vector:{ *:[nxv8f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv8f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 354321 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 354324 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 354328 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354333 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 354335 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 354338 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 354342 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354347 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 354350 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 354354 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 354357 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354362 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354367 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 354372 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 354375 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 354377 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354380 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354383 */   GIR_RootConstrainSelectedInstOperands,
     /* 354384 */   // GIR_Coverage, 8206,
     /* 354384 */   GIR_EraseRootFromParent_Done,
     /* 354385 */ // Label 7040: @354385
     /* 354385 */ GIM_Reject,
     /* 354386 */ // Label 7006: @354386
     /* 354386 */ GIM_Try, /*On fail goto*//*Label 7041*/ GIMT_Encode4(354475),
     /* 354391 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 354394 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354398 */   GIM_Try, /*On fail goto*//*Label 7042*/ GIMT_Encode4(354455), // Rule ID 2649 //
     /* 354403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 354414 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 354418 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 354422 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354427 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 354431 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 354435 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_b),
     /* 354439 */     // MIs[2] Operand 1
     /* 354439 */     // No operand predicates
     /* 354439 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354441 */     // (splat_vector:{ *:[nxv16i8] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index))  =>  (DUP_ZZI_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index)
     /* 354441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_B),
     /* 354444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 354446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 354450 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 354453 */     GIR_RootConstrainSelectedInstOperands,
     /* 354454 */     // GIR_Coverage, 2649,
     /* 354454 */     GIR_EraseRootFromParent_Done,
     /* 354455 */   // Label 7042: @354455
     /* 354455 */   GIM_Try, /*On fail goto*//*Label 7043*/ GIMT_Encode4(354474), // Rule ID 2379 //
     /* 354460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354463 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 354467 */     // (splat_vector:{ *:[nxv16i8] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_B:{ *:[nxv16i8] } GPR32sp:{ *:[i32] }:$Rn)
     /* 354467 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_B),
     /* 354472 */     GIR_RootConstrainSelectedInstOperands,
     /* 354473 */     // GIR_Coverage, 2379,
     /* 354473 */     GIR_Done,
     /* 354474 */   // Label 7043: @354474
     /* 354474 */   GIM_Reject,
     /* 354475 */ // Label 7041: @354475
     /* 354475 */ GIM_Reject,
     /* 354476 */ // Label 7007: @354476
     /* 354476 */ GIM_Reject,
     /* 354477 */ // Label 88: @354477
     /* 354477 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 7046*/ GIMT_Encode4(354628),
     /* 354488 */ /*GILLT_s32*//*Label 7044*/ GIMT_Encode4(354496),
     /* 354492 */ /*GILLT_s64*//*Label 7045*/ GIMT_Encode4(354562),
     /* 354496 */ // Label 7044: @354496
     /* 354496 */ GIM_Try, /*On fail goto*//*Label 7047*/ GIMT_Encode4(354561),
     /* 354501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 354504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 354508 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 354512 */   GIM_Try, /*On fail goto*//*Label 7048*/ GIMT_Encode4(354527), // Rule ID 2312 //
     /* 354517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 354520 */     // (cttz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CTZWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 354520 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CTZWr),
     /* 354525 */     GIR_RootConstrainSelectedInstOperands,
     /* 354526 */     // GIR_Coverage, 2312,
     /* 354526 */     GIR_Done,
     /* 354527 */   // Label 7048: @354527
     /* 354527 */   GIM_Try, /*On fail goto*//*Label 7049*/ GIMT_Encode4(354560), // Rule ID 3947 //
     /* 354532 */     // (cttz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CLZWr:{ *:[i32] } (RBITWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn))
     /* 354532 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 354535 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::RBITWr),
     /* 354539 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354544 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 354548 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLZWr),
     /* 354553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 354555 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354558 */     GIR_RootConstrainSelectedInstOperands,
     /* 354559 */     // GIR_Coverage, 3947,
     /* 354559 */     GIR_EraseRootFromParent_Done,
     /* 354560 */   // Label 7049: @354560
     /* 354560 */   GIM_Reject,
     /* 354561 */ // Label 7047: @354561
     /* 354561 */ GIM_Reject,
     /* 354562 */ // Label 7045: @354562
     /* 354562 */ GIM_Try, /*On fail goto*//*Label 7050*/ GIMT_Encode4(354627),
     /* 354567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 354570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 354574 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 354578 */   GIM_Try, /*On fail goto*//*Label 7051*/ GIMT_Encode4(354593), // Rule ID 2313 //
     /* 354583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 354586 */     // (cttz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CTZXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 354586 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CTZXr),
     /* 354591 */     GIR_RootConstrainSelectedInstOperands,
     /* 354592 */     // GIR_Coverage, 2313,
     /* 354592 */     GIR_Done,
     /* 354593 */   // Label 7051: @354593
     /* 354593 */   GIM_Try, /*On fail goto*//*Label 7052*/ GIMT_Encode4(354626), // Rule ID 3948 //
     /* 354598 */     // (cttz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CLZXr:{ *:[i64] } (RBITXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn))
     /* 354598 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 354601 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::RBITXr),
     /* 354605 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354610 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 354614 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLZXr),
     /* 354619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 354621 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354624 */     GIR_RootConstrainSelectedInstOperands,
     /* 354625 */     // GIR_Coverage, 3948,
     /* 354625 */     GIR_EraseRootFromParent_Done,
     /* 354626 */   // Label 7052: @354626
     /* 354626 */   GIM_Reject,
     /* 354627 */ // Label 7050: @354627
     /* 354627 */ GIM_Reject,
     /* 354628 */ // Label 7046: @354628
     /* 354628 */ GIM_Reject,
     /* 354629 */ // Label 89: @354629
     /* 354629 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7061*/ GIMT_Encode4(355302),
     /* 354640 */ /*GILLT_s32*//*Label 7053*/ GIMT_Encode4(354680),
     /* 354644 */ /*GILLT_s64*//*Label 7054*/ GIMT_Encode4(354910), GIMT_Encode4(0),
     /* 354652 */ /*GILLT_v2s32*//*Label 7055*/ GIMT_Encode4(355140), GIMT_Encode4(0),
     /* 354660 */ /*GILLT_v4s16*//*Label 7056*/ GIMT_Encode4(355167),
     /* 354664 */ /*GILLT_v4s32*//*Label 7057*/ GIMT_Encode4(355194),
     /* 354668 */ /*GILLT_v8s8*//*Label 7058*/ GIMT_Encode4(355221),
     /* 354672 */ /*GILLT_v8s16*//*Label 7059*/ GIMT_Encode4(355248),
     /* 354676 */ /*GILLT_v16s8*//*Label 7060*/ GIMT_Encode4(355275),
     /* 354680 */ // Label 7053: @354680
     /* 354680 */ GIM_Try, /*On fail goto*//*Label 7062*/ GIMT_Encode4(354909),
     /* 354685 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 354688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 354692 */   GIM_Try, /*On fail goto*//*Label 7063*/ GIMT_Encode4(354792), // Rule ID 3949 //
     /* 354697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 354705 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 354709 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 354713 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 354717 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 354721 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 354725 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 354729 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 354733 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 354737 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 354741 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 354745 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 354749 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /* 354753 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 354757 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 354762 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 31,
     /* 354766 */     // MIs[3] Rn
     /* 354766 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /* 354771 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 354775 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 354779 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 354781 */     // (ctlz:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (xor:{ *:[i32] } (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 31:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn), 1:{ *:[i64] }), 1:{ *:[i32] }))  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 354781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
     /* 354784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 354786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /* 354790 */     GIR_RootConstrainSelectedInstOperands,
     /* 354791 */     // GIR_Coverage, 3949,
     /* 354791 */     GIR_EraseRootFromParent_Done,
     /* 354792 */   // Label 7063: @354792
     /* 354792 */   GIM_Try, /*On fail goto*//*Label 7064*/ GIMT_Encode4(354892), // Rule ID 13512 //
     /* 354797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 354805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 354809 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 354813 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 354817 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 354821 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 354825 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 354829 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 354833 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 354837 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 354841 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 354845 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 354850 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 354854 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 354858 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 354862 */     // MIs[4] Rn
     /* 354862 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /* 354867 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 31,
     /* 354871 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 354875 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 354879 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 354881 */     // (ctlz:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 31:{ *:[i64] })), 1:{ *:[i64] }), 1:{ *:[i32] }))  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 354881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
     /* 354884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 354886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 354890 */     GIR_RootConstrainSelectedInstOperands,
     /* 354891 */     // GIR_Coverage, 13512,
     /* 354891 */     GIR_EraseRootFromParent_Done,
     /* 354892 */   // Label 7064: @354892
     /* 354892 */   GIM_Try, /*On fail goto*//*Label 7065*/ GIMT_Encode4(354908), // Rule ID 180 //
     /* 354897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 354901 */     // (ctlz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CLZWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 354901 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZWr),
     /* 354906 */     GIR_RootConstrainSelectedInstOperands,
     /* 354907 */     // GIR_Coverage, 180,
     /* 354907 */     GIR_Done,
     /* 354908 */   // Label 7065: @354908
     /* 354908 */   GIM_Reject,
     /* 354909 */ // Label 7062: @354909
     /* 354909 */ GIM_Reject,
     /* 354910 */ // Label 7054: @354910
     /* 354910 */ GIM_Try, /*On fail goto*//*Label 7066*/ GIMT_Encode4(355139),
     /* 354915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 354918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 354922 */   GIM_Try, /*On fail goto*//*Label 7067*/ GIMT_Encode4(355022), // Rule ID 3950 //
     /* 354927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 354935 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 354939 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 354943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 354947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 354951 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 354955 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 354959 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 354963 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 354967 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 354971 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 354975 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 354979 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /* 354983 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 354987 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 354992 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 63,
     /* 354996 */     // MIs[3] Rn
     /* 354996 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /* 355001 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 355005 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 355009 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 355011 */     // (ctlz:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (xor:{ *:[i64] } (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 63:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn), 1:{ *:[i64] }), 1:{ *:[i64] }))  =>  (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 355011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
     /* 355014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 355016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /* 355020 */     GIR_RootConstrainSelectedInstOperands,
     /* 355021 */     // GIR_Coverage, 3950,
     /* 355021 */     GIR_EraseRootFromParent_Done,
     /* 355022 */   // Label 7067: @355022
     /* 355022 */   GIM_Try, /*On fail goto*//*Label 7068*/ GIMT_Encode4(355122), // Rule ID 13513 //
     /* 355027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 355035 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 355039 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 355043 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 355047 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 355051 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 355055 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 355059 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 355063 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 355067 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 355071 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 355075 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 355080 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 355084 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 355088 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 355092 */     // MIs[4] Rn
     /* 355092 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /* 355097 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 63,
     /* 355101 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 355105 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 355109 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 355111 */     // (ctlz:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 63:{ *:[i64] })), 1:{ *:[i64] }), 1:{ *:[i64] }))  =>  (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 355111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
     /* 355114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 355116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 355120 */     GIR_RootConstrainSelectedInstOperands,
     /* 355121 */     // GIR_Coverage, 13513,
     /* 355121 */     GIR_EraseRootFromParent_Done,
     /* 355122 */   // Label 7068: @355122
     /* 355122 */   GIM_Try, /*On fail goto*//*Label 7069*/ GIMT_Encode4(355138), // Rule ID 181 //
     /* 355127 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 355131 */     // (ctlz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CLZXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 355131 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZXr),
     /* 355136 */     GIR_RootConstrainSelectedInstOperands,
     /* 355137 */     // GIR_Coverage, 181,
     /* 355137 */     GIR_Done,
     /* 355138 */   // Label 7069: @355138
     /* 355138 */   GIM_Reject,
     /* 355139 */ // Label 7066: @355139
     /* 355139 */ GIM_Reject,
     /* 355140 */ // Label 7055: @355140
     /* 355140 */ GIM_Try, /*On fail goto*//*Label 7070*/ GIMT_Encode4(355166), // Rule ID 720 //
     /* 355145 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 355148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 355151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355155 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355159 */   // (ctlz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (CLZv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 355159 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv2i32),
     /* 355164 */   GIR_RootConstrainSelectedInstOperands,
     /* 355165 */   // GIR_Coverage, 720,
     /* 355165 */   GIR_Done,
     /* 355166 */ // Label 7070: @355166
     /* 355166 */ GIM_Reject,
     /* 355167 */ // Label 7056: @355167
     /* 355167 */ GIM_Try, /*On fail goto*//*Label 7071*/ GIMT_Encode4(355193), // Rule ID 718 //
     /* 355172 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 355175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 355178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355182 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355186 */   // (ctlz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (CLZv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 355186 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv4i16),
     /* 355191 */   GIR_RootConstrainSelectedInstOperands,
     /* 355192 */   // GIR_Coverage, 718,
     /* 355192 */   GIR_Done,
     /* 355193 */ // Label 7071: @355193
     /* 355193 */ GIM_Reject,
     /* 355194 */ // Label 7057: @355194
     /* 355194 */ GIM_Try, /*On fail goto*//*Label 7072*/ GIMT_Encode4(355220), // Rule ID 721 //
     /* 355199 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 355202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 355205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355209 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355213 */   // (ctlz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (CLZv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 355213 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv4i32),
     /* 355218 */   GIR_RootConstrainSelectedInstOperands,
     /* 355219 */   // GIR_Coverage, 721,
     /* 355219 */   GIR_Done,
     /* 355220 */ // Label 7072: @355220
     /* 355220 */ GIM_Reject,
     /* 355221 */ // Label 7058: @355221
     /* 355221 */ GIM_Try, /*On fail goto*//*Label 7073*/ GIMT_Encode4(355247), // Rule ID 716 //
     /* 355226 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 355229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 355232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355236 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355240 */   // (ctlz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (CLZv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 355240 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv8i8),
     /* 355245 */   GIR_RootConstrainSelectedInstOperands,
     /* 355246 */   // GIR_Coverage, 716,
     /* 355246 */   GIR_Done,
     /* 355247 */ // Label 7073: @355247
     /* 355247 */ GIM_Reject,
     /* 355248 */ // Label 7059: @355248
     /* 355248 */ GIM_Try, /*On fail goto*//*Label 7074*/ GIMT_Encode4(355274), // Rule ID 719 //
     /* 355253 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 355256 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 355259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355263 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355267 */   // (ctlz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (CLZv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 355267 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv8i16),
     /* 355272 */   GIR_RootConstrainSelectedInstOperands,
     /* 355273 */   // GIR_Coverage, 719,
     /* 355273 */   GIR_Done,
     /* 355274 */ // Label 7074: @355274
     /* 355274 */ GIM_Reject,
     /* 355275 */ // Label 7060: @355275
     /* 355275 */ GIM_Try, /*On fail goto*//*Label 7075*/ GIMT_Encode4(355301), // Rule ID 717 //
     /* 355280 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 355283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 355286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355290 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355294 */   // (ctlz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (CLZv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 355294 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv16i8),
     /* 355299 */   GIR_RootConstrainSelectedInstOperands,
     /* 355300 */   // GIR_Coverage, 717,
     /* 355300 */   GIR_Done,
     /* 355301 */ // Label 7075: @355301
     /* 355301 */ GIM_Reject,
     /* 355302 */ // Label 7061: @355302
     /* 355302 */ GIM_Reject,
     /* 355303 */ // Label 90: @355303
     /* 355303 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7080*/ GIMT_Encode4(355462),
     /* 355314 */ /*GILLT_s32*//*Label 7076*/ GIMT_Encode4(355354),
     /* 355318 */ /*GILLT_s64*//*Label 7077*/ GIMT_Encode4(355381), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 355342 */ /*GILLT_v8s8*//*Label 7078*/ GIMT_Encode4(355408), GIMT_Encode4(0),
     /* 355350 */ /*GILLT_v16s8*//*Label 7079*/ GIMT_Encode4(355435),
     /* 355354 */ // Label 7076: @355354
     /* 355354 */ GIM_Try, /*On fail goto*//*Label 7081*/ GIMT_Encode4(355380), // Rule ID 2310 //
     /* 355359 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 355362 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 355365 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 355369 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 355373 */   // (ctpop:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CNTWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 355373 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTWr),
     /* 355378 */   GIR_RootConstrainSelectedInstOperands,
     /* 355379 */   // GIR_Coverage, 2310,
     /* 355379 */   GIR_Done,
     /* 355380 */ // Label 7081: @355380
     /* 355380 */ GIM_Reject,
     /* 355381 */ // Label 7077: @355381
     /* 355381 */ GIM_Try, /*On fail goto*//*Label 7082*/ GIMT_Encode4(355407), // Rule ID 2311 //
     /* 355386 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 355389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 355392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 355396 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 355400 */   // (ctpop:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CNTXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 355400 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTXr),
     /* 355405 */   GIR_RootConstrainSelectedInstOperands,
     /* 355406 */   // GIR_Coverage, 2311,
     /* 355406 */   GIR_Done,
     /* 355407 */ // Label 7082: @355407
     /* 355407 */ GIM_Reject,
     /* 355408 */ // Label 7078: @355408
     /* 355408 */ GIM_Try, /*On fail goto*//*Label 7083*/ GIMT_Encode4(355434), // Rule ID 757 //
     /* 355413 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 355416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 355419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355423 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355427 */   // (ctpop:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (CNTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 355427 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTv8i8),
     /* 355432 */   GIR_RootConstrainSelectedInstOperands,
     /* 355433 */   // GIR_Coverage, 757,
     /* 355433 */   GIR_Done,
     /* 355434 */ // Label 7083: @355434
     /* 355434 */ GIM_Reject,
     /* 355435 */ // Label 7079: @355435
     /* 355435 */ GIM_Try, /*On fail goto*//*Label 7084*/ GIMT_Encode4(355461), // Rule ID 758 //
     /* 355440 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 355443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 355446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355450 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355454 */   // (ctpop:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (CNTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 355454 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTv16i8),
     /* 355459 */   GIR_RootConstrainSelectedInstOperands,
     /* 355460 */   // GIR_Coverage, 758,
     /* 355460 */   GIR_Done,
     /* 355461 */ // Label 7084: @355461
     /* 355461 */ GIM_Reject,
     /* 355462 */ // Label 7080: @355462
     /* 355462 */ GIM_Reject,
     /* 355463 */ // Label 91: @355463
     /* 355463 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 7092*/ GIMT_Encode4(355776),
     /* 355474 */ /*GILLT_s32*//*Label 7085*/ GIMT_Encode4(355510),
     /* 355478 */ /*GILLT_s64*//*Label 7086*/ GIMT_Encode4(355583), GIMT_Encode4(0),
     /* 355486 */ /*GILLT_v2s32*//*Label 7087*/ GIMT_Encode4(355656),
     /* 355490 */ /*GILLT_v2s64*//*Label 7088*/ GIMT_Encode4(355680),
     /* 355494 */ /*GILLT_v4s16*//*Label 7089*/ GIMT_Encode4(355704),
     /* 355498 */ /*GILLT_v4s32*//*Label 7090*/ GIMT_Encode4(355728), GIMT_Encode4(0),
     /* 355506 */ /*GILLT_v8s16*//*Label 7091*/ GIMT_Encode4(355752),
     /* 355510 */ // Label 7085: @355510
     /* 355510 */ GIM_Try, /*On fail goto*//*Label 7093*/ GIMT_Encode4(355582),
     /* 355515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 355518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 355522 */   GIM_Try, /*On fail goto*//*Label 7094*/ GIMT_Encode4(355565), // Rule ID 3953 //
     /* 355527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /* 355535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 355539 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 355543 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 355548 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 355552 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 355554 */     // (bswap:{ *:[i32] } (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 16:{ *:[i64] }))  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 355554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
     /* 355557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 355559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 355563 */     GIR_RootConstrainSelectedInstOperands,
     /* 355564 */     // GIR_Coverage, 3953,
     /* 355564 */     GIR_EraseRootFromParent_Done,
     /* 355565 */   // Label 7094: @355565
     /* 355565 */   GIM_Try, /*On fail goto*//*Label 7095*/ GIMT_Encode4(355581), // Rule ID 185 //
     /* 355570 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 355574 */     // (bswap:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (REVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 355574 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REVWr),
     /* 355579 */     GIR_RootConstrainSelectedInstOperands,
     /* 355580 */     // GIR_Coverage, 185,
     /* 355580 */     GIR_Done,
     /* 355581 */   // Label 7095: @355581
     /* 355581 */   GIM_Reject,
     /* 355582 */ // Label 7093: @355582
     /* 355582 */ GIM_Reject,
     /* 355583 */ // Label 7086: @355583
     /* 355583 */ GIM_Try, /*On fail goto*//*Label 7096*/ GIMT_Encode4(355655),
     /* 355588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 355591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 355595 */   GIM_Try, /*On fail goto*//*Label 7097*/ GIMT_Encode4(355638), // Rule ID 3954 //
     /* 355600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /* 355608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 355612 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 355616 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 355621 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 32,
     /* 355625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 355627 */     // (bswap:{ *:[i64] } (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 32:{ *:[i64] }))  =>  (REV32Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 355627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV32Xr),
     /* 355630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 355632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 355636 */     GIR_RootConstrainSelectedInstOperands,
     /* 355637 */     // GIR_Coverage, 3954,
     /* 355637 */     GIR_EraseRootFromParent_Done,
     /* 355638 */   // Label 7097: @355638
     /* 355638 */   GIM_Try, /*On fail goto*//*Label 7098*/ GIMT_Encode4(355654), // Rule ID 186 //
     /* 355643 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 355647 */     // (bswap:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (REVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 355647 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REVXr),
     /* 355652 */     GIR_RootConstrainSelectedInstOperands,
     /* 355653 */     // GIR_Coverage, 186,
     /* 355653 */     GIR_Done,
     /* 355654 */   // Label 7098: @355654
     /* 355654 */   GIM_Reject,
     /* 355655 */ // Label 7096: @355655
     /* 355655 */ GIM_Reject,
     /* 355656 */ // Label 7087: @355656
     /* 355656 */ GIM_Try, /*On fail goto*//*Label 7099*/ GIMT_Encode4(355679), // Rule ID 4928 //
     /* 355661 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 355664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355668 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355672 */   // (bswap:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (REV32v8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 355672 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 355677 */   GIR_RootConstrainSelectedInstOperands,
     /* 355678 */   // GIR_Coverage, 4928,
     /* 355678 */   GIR_Done,
     /* 355679 */ // Label 7099: @355679
     /* 355679 */ GIM_Reject,
     /* 355680 */ // Label 7088: @355680
     /* 355680 */ GIM_Try, /*On fail goto*//*Label 7100*/ GIMT_Encode4(355703), // Rule ID 4930 //
     /* 355685 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 355688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355692 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355696 */   // (bswap:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)  =>  (REV64v16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 355696 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 355701 */   GIR_RootConstrainSelectedInstOperands,
     /* 355702 */   // GIR_Coverage, 4930,
     /* 355702 */   GIR_Done,
     /* 355703 */ // Label 7100: @355703
     /* 355703 */ GIM_Reject,
     /* 355704 */ // Label 7089: @355704
     /* 355704 */ GIM_Try, /*On fail goto*//*Label 7101*/ GIMT_Encode4(355727), // Rule ID 4926 //
     /* 355709 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 355712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355716 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355720 */   // (bswap:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV16v8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 355720 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 355725 */   GIR_RootConstrainSelectedInstOperands,
     /* 355726 */   // GIR_Coverage, 4926,
     /* 355726 */   GIR_Done,
     /* 355727 */ // Label 7101: @355727
     /* 355727 */ GIM_Reject,
     /* 355728 */ // Label 7090: @355728
     /* 355728 */ GIM_Try, /*On fail goto*//*Label 7102*/ GIMT_Encode4(355751), // Rule ID 4929 //
     /* 355733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 355736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355740 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355744 */   // (bswap:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (REV32v16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 355744 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 355749 */   GIR_RootConstrainSelectedInstOperands,
     /* 355750 */   // GIR_Coverage, 4929,
     /* 355750 */   GIR_Done,
     /* 355751 */ // Label 7102: @355751
     /* 355751 */ GIM_Reject,
     /* 355752 */ // Label 7091: @355752
     /* 355752 */ GIM_Try, /*On fail goto*//*Label 7103*/ GIMT_Encode4(355775), // Rule ID 4927 //
     /* 355757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 355760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355764 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355768 */   // (bswap:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV16v16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 355768 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 355773 */   GIR_RootConstrainSelectedInstOperands,
     /* 355774 */   // GIR_Coverage, 4927,
     /* 355774 */   GIR_Done,
     /* 355775 */ // Label 7103: @355775
     /* 355775 */ GIM_Reject,
     /* 355776 */ // Label 7092: @355776
     /* 355776 */ GIM_Reject,
     /* 355777 */ // Label 92: @355777
     /* 355777 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7108*/ GIMT_Encode4(355930),
     /* 355788 */ /*GILLT_s32*//*Label 7104*/ GIMT_Encode4(355828),
     /* 355792 */ /*GILLT_s64*//*Label 7105*/ GIMT_Encode4(355852), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 355816 */ /*GILLT_v8s8*//*Label 7106*/ GIMT_Encode4(355876), GIMT_Encode4(0),
     /* 355824 */ /*GILLT_v16s8*//*Label 7107*/ GIMT_Encode4(355903),
     /* 355828 */ // Label 7104: @355828
     /* 355828 */ GIM_Try, /*On fail goto*//*Label 7109*/ GIMT_Encode4(355851), // Rule ID 182 //
     /* 355833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 355836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 355840 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 355844 */   // (bitreverse:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (RBITWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 355844 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITWr),
     /* 355849 */   GIR_RootConstrainSelectedInstOperands,
     /* 355850 */   // GIR_Coverage, 182,
     /* 355850 */   GIR_Done,
     /* 355851 */ // Label 7109: @355851
     /* 355851 */ GIM_Reject,
     /* 355852 */ // Label 7105: @355852
     /* 355852 */ GIM_Try, /*On fail goto*//*Label 7110*/ GIMT_Encode4(355875), // Rule ID 183 //
     /* 355857 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 355860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 355864 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 355868 */   // (bitreverse:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (RBITXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 355868 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITXr),
     /* 355873 */   GIR_RootConstrainSelectedInstOperands,
     /* 355874 */   // GIR_Coverage, 183,
     /* 355874 */   GIR_Done,
     /* 355875 */ // Label 7110: @355875
     /* 355875 */ GIM_Reject,
     /* 355876 */ // Label 7106: @355876
     /* 355876 */ GIM_Try, /*On fail goto*//*Label 7111*/ GIMT_Encode4(355902), // Rule ID 967 //
     /* 355881 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 355884 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 355887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355891 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355895 */   // (bitreverse:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (RBITv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 355895 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITv8i8),
     /* 355900 */   GIR_RootConstrainSelectedInstOperands,
     /* 355901 */   // GIR_Coverage, 967,
     /* 355901 */   GIR_Done,
     /* 355902 */ // Label 7111: @355902
     /* 355902 */ GIM_Reject,
     /* 355903 */ // Label 7107: @355903
     /* 355903 */ GIM_Try, /*On fail goto*//*Label 7112*/ GIMT_Encode4(355929), // Rule ID 968 //
     /* 355908 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 355911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 355914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355918 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355922 */   // (bitreverse:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (RBITv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 355922 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITv16i8),
     /* 355927 */   GIR_RootConstrainSelectedInstOperands,
     /* 355928 */   // GIR_Coverage, 968,
     /* 355928 */   GIR_Done,
     /* 355929 */ // Label 7112: @355929
     /* 355929 */ GIM_Reject,
     /* 355930 */ // Label 7108: @355930
     /* 355930 */ GIM_Reject,
     /* 355931 */ // Label 93: @355931
     /* 355931 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7121*/ GIMT_Encode4(356421),
     /* 355942 */ /*GILLT_s16*//*Label 7113*/ GIMT_Encode4(355982),
     /* 355946 */ /*GILLT_s32*//*Label 7114*/ GIMT_Encode4(356013),
     /* 355950 */ /*GILLT_s64*//*Label 7115*/ GIMT_Encode4(356044), GIMT_Encode4(0),
     /* 355958 */ /*GILLT_v2s32*//*Label 7116*/ GIMT_Encode4(356075),
     /* 355962 */ /*GILLT_v2s64*//*Label 7117*/ GIMT_Encode4(356106),
     /* 355966 */ /*GILLT_v4s16*//*Label 7118*/ GIMT_Encode4(356137),
     /* 355970 */ /*GILLT_v4s32*//*Label 7119*/ GIMT_Encode4(356168), GIMT_Encode4(0),
     /* 355978 */ /*GILLT_v8s16*//*Label 7120*/ GIMT_Encode4(356199),
     /* 355982 */ // Label 7113: @355982
     /* 355982 */ GIM_Try, /*On fail goto*//*Label 7122*/ GIMT_Encode4(356012), // Rule ID 552 //
     /* 355987 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 355990 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 355993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 355997 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 356001 */   // (fceil:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTPHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 356001 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPHr),
     /* 356006 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 356010 */   GIR_RootConstrainSelectedInstOperands,
     /* 356011 */   // GIR_Coverage, 552,
     /* 356011 */   GIR_Done,
     /* 356012 */ // Label 7122: @356012
     /* 356012 */ GIM_Reject,
     /* 356013 */ // Label 7114: @356013
     /* 356013 */ GIM_Try, /*On fail goto*//*Label 7123*/ GIMT_Encode4(356043), // Rule ID 554 //
     /* 356018 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 356021 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 356024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356028 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356032 */   // (fceil:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTPSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 356032 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPSr),
     /* 356037 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 356041 */   GIR_RootConstrainSelectedInstOperands,
     /* 356042 */   // GIR_Coverage, 554,
     /* 356042 */   GIR_Done,
     /* 356043 */ // Label 7123: @356043
     /* 356043 */ GIM_Reject,
     /* 356044 */ // Label 7115: @356044
     /* 356044 */ GIM_Try, /*On fail goto*//*Label 7124*/ GIMT_Encode4(356074), // Rule ID 556 //
     /* 356049 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 356052 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 356055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356059 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356063 */   // (fceil:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTPDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 356063 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPDr),
     /* 356068 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 356072 */   GIR_RootConstrainSelectedInstOperands,
     /* 356073 */   // GIR_Coverage, 556,
     /* 356073 */   GIR_Done,
     /* 356074 */ // Label 7124: @356074
     /* 356074 */ GIM_Reject,
     /* 356075 */ // Label 7116: @356075
     /* 356075 */ GIM_Try, /*On fail goto*//*Label 7125*/ GIMT_Encode4(356105), // Rule ID 906 //
     /* 356080 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 356083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 356086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356090 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356094 */   // (fceil:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 356094 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv2f32),
     /* 356099 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 356103 */   GIR_RootConstrainSelectedInstOperands,
     /* 356104 */   // GIR_Coverage, 906,
     /* 356104 */   GIR_Done,
     /* 356105 */ // Label 7125: @356105
     /* 356105 */ GIM_Reject,
     /* 356106 */ // Label 7117: @356106
     /* 356106 */ GIM_Try, /*On fail goto*//*Label 7126*/ GIMT_Encode4(356136), // Rule ID 910 //
     /* 356111 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 356114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 356117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356121 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356125 */   // (fceil:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 356125 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv2f64),
     /* 356130 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 356134 */   GIR_RootConstrainSelectedInstOperands,
     /* 356135 */   // GIR_Coverage, 910,
     /* 356135 */   GIR_Done,
     /* 356136 */ // Label 7126: @356136
     /* 356136 */ GIM_Reject,
     /* 356137 */ // Label 7118: @356137
     /* 356137 */ GIM_Try, /*On fail goto*//*Label 7127*/ GIMT_Encode4(356167), // Rule ID 902 //
     /* 356142 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 356145 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 356148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356152 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356156 */   // (fceil:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 356156 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f16),
     /* 356161 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 356165 */   GIR_RootConstrainSelectedInstOperands,
     /* 356166 */   // GIR_Coverage, 902,
     /* 356166 */   GIR_Done,
     /* 356167 */ // Label 7127: @356167
     /* 356167 */ GIM_Reject,
     /* 356168 */ // Label 7119: @356168
     /* 356168 */ GIM_Try, /*On fail goto*//*Label 7128*/ GIMT_Encode4(356198), // Rule ID 908 //
     /* 356173 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 356176 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 356179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356183 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356187 */   // (fceil:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 356187 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
     /* 356192 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 356196 */   GIR_RootConstrainSelectedInstOperands,
     /* 356197 */   // GIR_Coverage, 908,
     /* 356197 */   GIR_Done,
     /* 356198 */ // Label 7128: @356198
     /* 356198 */ GIM_Reject,
     /* 356199 */ // Label 7120: @356199
     /* 356199 */ GIM_Try, /*On fail goto*//*Label 7129*/ GIMT_Encode4(356420),
     /* 356204 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 356207 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356211 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356215 */   GIM_Try, /*On fail goto*//*Label 7130*/ GIMT_Encode4(356234), // Rule ID 904 //
     /* 356220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 356223 */     // (fceil:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 356223 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv8f16),
     /* 356228 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 356232 */     GIR_RootConstrainSelectedInstOperands,
     /* 356233 */     // GIR_Coverage, 904,
     /* 356233 */     GIR_Done,
     /* 356234 */   // Label 7130: @356234
     /* 356234 */   GIM_Try, /*On fail goto*//*Label 7131*/ GIMT_Encode4(356419), // Rule ID 6900 //
     /* 356239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 356242 */     // (fceil:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTPv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTPv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 356242 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 356245 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 356249 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356254 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 356258 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 356260 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 356263 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
     /* 356267 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356272 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 356275 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 356277 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 356280 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 356284 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356289 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 356295 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356300 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356305 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 356308 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 356312 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356317 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 356320 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 356322 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 356325 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
     /* 356329 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356334 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 356337 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 356339 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 356342 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 356346 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356351 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 356354 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 356356 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 356359 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 356363 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356368 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 356370 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 356373 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 356377 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356382 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 356385 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 356388 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 356391 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356396 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356401 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 356409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356411 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356414 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 356417 */     GIR_RootConstrainSelectedInstOperands,
     /* 356418 */     // GIR_Coverage, 6900,
     /* 356418 */     GIR_EraseRootFromParent_Done,
     /* 356419 */   // Label 7131: @356419
     /* 356419 */   GIM_Reject,
     /* 356420 */ // Label 7129: @356420
     /* 356420 */ GIM_Reject,
     /* 356421 */ // Label 7121: @356421
     /* 356421 */ GIM_Reject,
     /* 356422 */ // Label 94: @356422
     /* 356422 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7140*/ GIMT_Encode4(356721),
     /* 356433 */ /*GILLT_s16*//*Label 7132*/ GIMT_Encode4(356473),
     /* 356437 */ /*GILLT_s32*//*Label 7133*/ GIMT_Encode4(356504),
     /* 356441 */ /*GILLT_s64*//*Label 7134*/ GIMT_Encode4(356535), GIMT_Encode4(0),
     /* 356449 */ /*GILLT_v2s32*//*Label 7135*/ GIMT_Encode4(356566),
     /* 356453 */ /*GILLT_v2s64*//*Label 7136*/ GIMT_Encode4(356597),
     /* 356457 */ /*GILLT_v4s16*//*Label 7137*/ GIMT_Encode4(356628),
     /* 356461 */ /*GILLT_v4s32*//*Label 7138*/ GIMT_Encode4(356659), GIMT_Encode4(0),
     /* 356469 */ /*GILLT_v8s16*//*Label 7139*/ GIMT_Encode4(356690),
     /* 356473 */ // Label 7132: @356473
     /* 356473 */ GIM_Try, /*On fail goto*//*Label 7141*/ GIMT_Encode4(356503), // Rule ID 570 //
     /* 356478 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 356481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 356484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 356488 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 356492 */   // (fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FSQRTHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 356492 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTHr),
     /* 356497 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 356501 */   GIR_RootConstrainSelectedInstOperands,
     /* 356502 */   // GIR_Coverage, 570,
     /* 356502 */   GIR_Done,
     /* 356503 */ // Label 7141: @356503
     /* 356503 */ GIM_Reject,
     /* 356504 */ // Label 7133: @356504
     /* 356504 */ GIM_Try, /*On fail goto*//*Label 7142*/ GIMT_Encode4(356534), // Rule ID 572 //
     /* 356509 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 356512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 356515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356519 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356523 */   // (fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FSQRTSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 356523 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTSr),
     /* 356528 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 356532 */   GIR_RootConstrainSelectedInstOperands,
     /* 356533 */   // GIR_Coverage, 572,
     /* 356533 */   GIR_Done,
     /* 356534 */ // Label 7142: @356534
     /* 356534 */ GIM_Reject,
     /* 356535 */ // Label 7134: @356535
     /* 356535 */ GIM_Try, /*On fail goto*//*Label 7143*/ GIMT_Encode4(356565), // Rule ID 574 //
     /* 356540 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 356543 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 356546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356550 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356554 */   // (fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FSQRTDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 356554 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTDr),
     /* 356559 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 356563 */   GIR_RootConstrainSelectedInstOperands,
     /* 356564 */   // GIR_Coverage, 574,
     /* 356564 */   GIR_Done,
     /* 356565 */ // Label 7143: @356565
     /* 356565 */ GIM_Reject,
     /* 356566 */ // Label 7135: @356566
     /* 356566 */ GIM_Try, /*On fail goto*//*Label 7144*/ GIMT_Encode4(356596), // Rule ID 953 //
     /* 356571 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 356574 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 356577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356581 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356585 */   // (fsqrt:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FSQRTv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 356585 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f32),
     /* 356590 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 356594 */   GIR_RootConstrainSelectedInstOperands,
     /* 356595 */   // GIR_Coverage, 953,
     /* 356595 */   GIR_Done,
     /* 356596 */ // Label 7144: @356596
     /* 356596 */ GIM_Reject,
     /* 356597 */ // Label 7136: @356597
     /* 356597 */ GIM_Try, /*On fail goto*//*Label 7145*/ GIMT_Encode4(356627), // Rule ID 957 //
     /* 356602 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 356605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 356608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356612 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356616 */   // (fsqrt:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FSQRTv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 356616 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f64),
     /* 356621 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 356625 */   GIR_RootConstrainSelectedInstOperands,
     /* 356626 */   // GIR_Coverage, 957,
     /* 356626 */   GIR_Done,
     /* 356627 */ // Label 7145: @356627
     /* 356627 */ GIM_Reject,
     /* 356628 */ // Label 7137: @356628
     /* 356628 */ GIM_Try, /*On fail goto*//*Label 7146*/ GIMT_Encode4(356658), // Rule ID 949 //
     /* 356633 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 356636 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 356639 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356643 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356647 */   // (fsqrt:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FSQRTv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 356647 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f16),
     /* 356652 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 356656 */   GIR_RootConstrainSelectedInstOperands,
     /* 356657 */   // GIR_Coverage, 949,
     /* 356657 */   GIR_Done,
     /* 356658 */ // Label 7146: @356658
     /* 356658 */ GIM_Reject,
     /* 356659 */ // Label 7138: @356659
     /* 356659 */ GIM_Try, /*On fail goto*//*Label 7147*/ GIMT_Encode4(356689), // Rule ID 955 //
     /* 356664 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 356667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 356670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356674 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356678 */   // (fsqrt:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FSQRTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 356678 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f32),
     /* 356683 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 356687 */   GIR_RootConstrainSelectedInstOperands,
     /* 356688 */   // GIR_Coverage, 955,
     /* 356688 */   GIR_Done,
     /* 356689 */ // Label 7147: @356689
     /* 356689 */ GIM_Reject,
     /* 356690 */ // Label 7139: @356690
     /* 356690 */ GIM_Try, /*On fail goto*//*Label 7148*/ GIMT_Encode4(356720), // Rule ID 951 //
     /* 356695 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 356698 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 356701 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356705 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356709 */   // (fsqrt:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FSQRTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 356709 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv8f16),
     /* 356714 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 356718 */   GIR_RootConstrainSelectedInstOperands,
     /* 356719 */   // GIR_Coverage, 951,
     /* 356719 */   GIR_Done,
     /* 356720 */ // Label 7148: @356720
     /* 356720 */ GIM_Reject,
     /* 356721 */ // Label 7140: @356721
     /* 356721 */ GIM_Reject,
     /* 356722 */ // Label 95: @356722
     /* 356722 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7157*/ GIMT_Encode4(357212),
     /* 356733 */ /*GILLT_s16*//*Label 7149*/ GIMT_Encode4(356773),
     /* 356737 */ /*GILLT_s32*//*Label 7150*/ GIMT_Encode4(356804),
     /* 356741 */ /*GILLT_s64*//*Label 7151*/ GIMT_Encode4(356835), GIMT_Encode4(0),
     /* 356749 */ /*GILLT_v2s32*//*Label 7152*/ GIMT_Encode4(356866),
     /* 356753 */ /*GILLT_v2s64*//*Label 7153*/ GIMT_Encode4(356897),
     /* 356757 */ /*GILLT_v4s16*//*Label 7154*/ GIMT_Encode4(356928),
     /* 356761 */ /*GILLT_v4s32*//*Label 7155*/ GIMT_Encode4(356959), GIMT_Encode4(0),
     /* 356769 */ /*GILLT_v8s16*//*Label 7156*/ GIMT_Encode4(356990),
     /* 356773 */ // Label 7149: @356773
     /* 356773 */ GIM_Try, /*On fail goto*//*Label 7158*/ GIMT_Encode4(356803), // Rule ID 540 //
     /* 356778 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 356781 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 356784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 356788 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 356792 */   // (ffloor:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTMHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 356792 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMHr),
     /* 356797 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 356801 */   GIR_RootConstrainSelectedInstOperands,
     /* 356802 */   // GIR_Coverage, 540,
     /* 356802 */   GIR_Done,
     /* 356803 */ // Label 7158: @356803
     /* 356803 */ GIM_Reject,
     /* 356804 */ // Label 7150: @356804
     /* 356804 */ GIM_Try, /*On fail goto*//*Label 7159*/ GIMT_Encode4(356834), // Rule ID 542 //
     /* 356809 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 356812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 356815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356819 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356823 */   // (ffloor:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTMSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 356823 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMSr),
     /* 356828 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 356832 */   GIR_RootConstrainSelectedInstOperands,
     /* 356833 */   // GIR_Coverage, 542,
     /* 356833 */   GIR_Done,
     /* 356834 */ // Label 7159: @356834
     /* 356834 */ GIM_Reject,
     /* 356835 */ // Label 7151: @356835
     /* 356835 */ GIM_Try, /*On fail goto*//*Label 7160*/ GIMT_Encode4(356865), // Rule ID 544 //
     /* 356840 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 356843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 356846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356850 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356854 */   // (ffloor:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTMDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 356854 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMDr),
     /* 356859 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 356863 */   GIR_RootConstrainSelectedInstOperands,
     /* 356864 */   // GIR_Coverage, 544,
     /* 356864 */   GIR_Done,
     /* 356865 */ // Label 7160: @356865
     /* 356865 */ GIM_Reject,
     /* 356866 */ // Label 7152: @356866
     /* 356866 */ GIM_Try, /*On fail goto*//*Label 7161*/ GIMT_Encode4(356896), // Rule ID 886 //
     /* 356871 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 356874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 356877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356881 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356885 */   // (ffloor:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 356885 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv2f32),
     /* 356890 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 356894 */   GIR_RootConstrainSelectedInstOperands,
     /* 356895 */   // GIR_Coverage, 886,
     /* 356895 */   GIR_Done,
     /* 356896 */ // Label 7161: @356896
     /* 356896 */ GIM_Reject,
     /* 356897 */ // Label 7153: @356897
     /* 356897 */ GIM_Try, /*On fail goto*//*Label 7162*/ GIMT_Encode4(356927), // Rule ID 890 //
     /* 356902 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 356905 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 356908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356912 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356916 */   // (ffloor:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 356916 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv2f64),
     /* 356921 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 356925 */   GIR_RootConstrainSelectedInstOperands,
     /* 356926 */   // GIR_Coverage, 890,
     /* 356926 */   GIR_Done,
     /* 356927 */ // Label 7162: @356927
     /* 356927 */ GIM_Reject,
     /* 356928 */ // Label 7154: @356928
     /* 356928 */ GIM_Try, /*On fail goto*//*Label 7163*/ GIMT_Encode4(356958), // Rule ID 882 //
     /* 356933 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 356936 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 356939 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356943 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356947 */   // (ffloor:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 356947 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f16),
     /* 356952 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 356956 */   GIR_RootConstrainSelectedInstOperands,
     /* 356957 */   // GIR_Coverage, 882,
     /* 356957 */   GIR_Done,
     /* 356958 */ // Label 7163: @356958
     /* 356958 */ GIM_Reject,
     /* 356959 */ // Label 7155: @356959
     /* 356959 */ GIM_Try, /*On fail goto*//*Label 7164*/ GIMT_Encode4(356989), // Rule ID 888 //
     /* 356964 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 356967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 356970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356974 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356978 */   // (ffloor:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 356978 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
     /* 356983 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 356987 */   GIR_RootConstrainSelectedInstOperands,
     /* 356988 */   // GIR_Coverage, 888,
     /* 356988 */   GIR_Done,
     /* 356989 */ // Label 7164: @356989
     /* 356989 */ GIM_Reject,
     /* 356990 */ // Label 7156: @356990
     /* 356990 */ GIM_Try, /*On fail goto*//*Label 7165*/ GIMT_Encode4(357211),
     /* 356995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 356998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357002 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357006 */   GIM_Try, /*On fail goto*//*Label 7166*/ GIMT_Encode4(357025), // Rule ID 884 //
     /* 357011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 357014 */     // (ffloor:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 357014 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv8f16),
     /* 357019 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 357023 */     GIR_RootConstrainSelectedInstOperands,
     /* 357024 */     // GIR_Coverage, 884,
     /* 357024 */     GIR_Done,
     /* 357025 */   // Label 7166: @357025
     /* 357025 */   GIM_Try, /*On fail goto*//*Label 7167*/ GIMT_Encode4(357210), // Rule ID 6902 //
     /* 357030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 357033 */     // (ffloor:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTMv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTMv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 357033 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 357036 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 357040 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357045 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 357049 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 357051 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 357054 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
     /* 357058 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357063 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 357066 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 357068 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 357071 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 357075 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357080 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 357086 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357091 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357096 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 357099 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 357103 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357108 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 357111 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 357113 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 357116 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
     /* 357120 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357125 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 357128 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 357130 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 357133 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 357137 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357142 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 357145 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 357147 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 357150 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 357154 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357159 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 357161 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 357164 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 357168 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357173 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 357176 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 357179 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 357182 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357187 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357192 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 357200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357202 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357205 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 357208 */     GIR_RootConstrainSelectedInstOperands,
     /* 357209 */     // GIR_Coverage, 6902,
     /* 357209 */     GIR_EraseRootFromParent_Done,
     /* 357210 */   // Label 7167: @357210
     /* 357210 */   GIM_Reject,
     /* 357211 */ // Label 7165: @357211
     /* 357211 */ GIM_Reject,
     /* 357212 */ // Label 7157: @357212
     /* 357212 */ GIM_Reject,
     /* 357213 */ // Label 96: @357213
     /* 357213 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7176*/ GIMT_Encode4(357703),
     /* 357224 */ /*GILLT_s16*//*Label 7168*/ GIMT_Encode4(357264),
     /* 357228 */ /*GILLT_s32*//*Label 7169*/ GIMT_Encode4(357295),
     /* 357232 */ /*GILLT_s64*//*Label 7170*/ GIMT_Encode4(357326), GIMT_Encode4(0),
     /* 357240 */ /*GILLT_v2s32*//*Label 7171*/ GIMT_Encode4(357357),
     /* 357244 */ /*GILLT_v2s64*//*Label 7172*/ GIMT_Encode4(357388),
     /* 357248 */ /*GILLT_v4s16*//*Label 7173*/ GIMT_Encode4(357419),
     /* 357252 */ /*GILLT_v4s32*//*Label 7174*/ GIMT_Encode4(357450), GIMT_Encode4(0),
     /* 357260 */ /*GILLT_v8s16*//*Label 7175*/ GIMT_Encode4(357481),
     /* 357264 */ // Label 7168: @357264
     /* 357264 */ GIM_Try, /*On fail goto*//*Label 7177*/ GIMT_Encode4(357294), // Rule ID 558 //
     /* 357269 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 357272 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 357275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 357279 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 357283 */   // (frint:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTXHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 357283 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /* 357288 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 357292 */   GIR_RootConstrainSelectedInstOperands,
     /* 357293 */   // GIR_Coverage, 558,
     /* 357293 */   GIR_Done,
     /* 357294 */ // Label 7177: @357294
     /* 357294 */ GIM_Reject,
     /* 357295 */ // Label 7169: @357295
     /* 357295 */ GIM_Try, /*On fail goto*//*Label 7178*/ GIMT_Encode4(357325), // Rule ID 560 //
     /* 357300 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 357303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 357306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357310 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357314 */   // (frint:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTXSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 357314 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /* 357319 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 357323 */   GIR_RootConstrainSelectedInstOperands,
     /* 357324 */   // GIR_Coverage, 560,
     /* 357324 */   GIR_Done,
     /* 357325 */ // Label 7178: @357325
     /* 357325 */ GIM_Reject,
     /* 357326 */ // Label 7170: @357326
     /* 357326 */ GIM_Try, /*On fail goto*//*Label 7179*/ GIMT_Encode4(357356), // Rule ID 562 //
     /* 357331 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 357334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 357337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357341 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357345 */   // (frint:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTXDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 357345 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /* 357350 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 357354 */   GIR_RootConstrainSelectedInstOperands,
     /* 357355 */   // GIR_Coverage, 562,
     /* 357355 */   GIR_Done,
     /* 357356 */ // Label 7179: @357356
     /* 357356 */ GIM_Reject,
     /* 357357 */ // Label 7171: @357357
     /* 357357 */ GIM_Try, /*On fail goto*//*Label 7180*/ GIMT_Encode4(357387), // Rule ID 916 //
     /* 357362 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 357365 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 357368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357372 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357376 */   // (frint:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 357376 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv2f32),
     /* 357381 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 357385 */   GIR_RootConstrainSelectedInstOperands,
     /* 357386 */   // GIR_Coverage, 916,
     /* 357386 */   GIR_Done,
     /* 357387 */ // Label 7180: @357387
     /* 357387 */ GIM_Reject,
     /* 357388 */ // Label 7172: @357388
     /* 357388 */ GIM_Try, /*On fail goto*//*Label 7181*/ GIMT_Encode4(357418), // Rule ID 920 //
     /* 357393 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 357396 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 357399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357403 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357407 */   // (frint:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 357407 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv2f64),
     /* 357412 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 357416 */   GIR_RootConstrainSelectedInstOperands,
     /* 357417 */   // GIR_Coverage, 920,
     /* 357417 */   GIR_Done,
     /* 357418 */ // Label 7181: @357418
     /* 357418 */ GIM_Reject,
     /* 357419 */ // Label 7173: @357419
     /* 357419 */ GIM_Try, /*On fail goto*//*Label 7182*/ GIMT_Encode4(357449), // Rule ID 912 //
     /* 357424 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 357427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 357430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357434 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357438 */   // (frint:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 357438 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f16),
     /* 357443 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 357447 */   GIR_RootConstrainSelectedInstOperands,
     /* 357448 */   // GIR_Coverage, 912,
     /* 357448 */   GIR_Done,
     /* 357449 */ // Label 7182: @357449
     /* 357449 */ GIM_Reject,
     /* 357450 */ // Label 7174: @357450
     /* 357450 */ GIM_Try, /*On fail goto*//*Label 7183*/ GIMT_Encode4(357480), // Rule ID 918 //
     /* 357455 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 357458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 357461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357465 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357469 */   // (frint:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 357469 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
     /* 357474 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 357478 */   GIR_RootConstrainSelectedInstOperands,
     /* 357479 */   // GIR_Coverage, 918,
     /* 357479 */   GIR_Done,
     /* 357480 */ // Label 7183: @357480
     /* 357480 */ GIM_Reject,
     /* 357481 */ // Label 7175: @357481
     /* 357481 */ GIM_Try, /*On fail goto*//*Label 7184*/ GIMT_Encode4(357702),
     /* 357486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 357489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357493 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357497 */   GIM_Try, /*On fail goto*//*Label 7185*/ GIMT_Encode4(357516), // Rule ID 914 //
     /* 357502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 357505 */     // (frint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 357505 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv8f16),
     /* 357510 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 357514 */     GIR_RootConstrainSelectedInstOperands,
     /* 357515 */     // GIR_Coverage, 914,
     /* 357515 */     GIR_Done,
     /* 357516 */   // Label 7185: @357516
     /* 357516 */   GIM_Try, /*On fail goto*//*Label 7186*/ GIMT_Encode4(357701), // Rule ID 6910 //
     /* 357521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 357524 */     // (frint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTXv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTXv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 357524 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 357527 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 357531 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357536 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 357540 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 357542 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 357545 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
     /* 357549 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357554 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 357557 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 357559 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 357562 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 357566 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357571 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 357577 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357582 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357587 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 357590 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 357594 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357599 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 357602 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 357604 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 357607 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
     /* 357611 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357616 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 357619 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 357621 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 357624 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 357628 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357633 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 357636 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 357638 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 357641 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 357645 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357650 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 357652 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 357655 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 357659 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357664 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 357667 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 357670 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 357673 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357678 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357683 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 357691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357693 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357696 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 357699 */     GIR_RootConstrainSelectedInstOperands,
     /* 357700 */     // GIR_Coverage, 6910,
     /* 357700 */     GIR_EraseRootFromParent_Done,
     /* 357701 */   // Label 7186: @357701
     /* 357701 */   GIM_Reject,
     /* 357702 */ // Label 7184: @357702
     /* 357702 */ GIM_Reject,
     /* 357703 */ // Label 7176: @357703
     /* 357703 */ GIM_Reject,
     /* 357704 */ // Label 97: @357704
     /* 357704 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7195*/ GIMT_Encode4(358194),
     /* 357715 */ /*GILLT_s16*//*Label 7187*/ GIMT_Encode4(357755),
     /* 357719 */ /*GILLT_s32*//*Label 7188*/ GIMT_Encode4(357786),
     /* 357723 */ /*GILLT_s64*//*Label 7189*/ GIMT_Encode4(357817), GIMT_Encode4(0),
     /* 357731 */ /*GILLT_v2s32*//*Label 7190*/ GIMT_Encode4(357848),
     /* 357735 */ /*GILLT_v2s64*//*Label 7191*/ GIMT_Encode4(357879),
     /* 357739 */ /*GILLT_v4s16*//*Label 7192*/ GIMT_Encode4(357910),
     /* 357743 */ /*GILLT_v4s32*//*Label 7193*/ GIMT_Encode4(357941), GIMT_Encode4(0),
     /* 357751 */ /*GILLT_v8s16*//*Label 7194*/ GIMT_Encode4(357972),
     /* 357755 */ // Label 7187: @357755
     /* 357755 */ GIM_Try, /*On fail goto*//*Label 7196*/ GIMT_Encode4(357785), // Rule ID 534 //
     /* 357760 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 357763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 357766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 357770 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 357774 */   // (fnearbyint:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTIHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 357774 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIHr),
     /* 357779 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 357783 */   GIR_RootConstrainSelectedInstOperands,
     /* 357784 */   // GIR_Coverage, 534,
     /* 357784 */   GIR_Done,
     /* 357785 */ // Label 7196: @357785
     /* 357785 */ GIM_Reject,
     /* 357786 */ // Label 7188: @357786
     /* 357786 */ GIM_Try, /*On fail goto*//*Label 7197*/ GIMT_Encode4(357816), // Rule ID 536 //
     /* 357791 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 357794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 357797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357801 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357805 */   // (fnearbyint:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTISr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 357805 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTISr),
     /* 357810 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 357814 */   GIR_RootConstrainSelectedInstOperands,
     /* 357815 */   // GIR_Coverage, 536,
     /* 357815 */   GIR_Done,
     /* 357816 */ // Label 7197: @357816
     /* 357816 */ GIM_Reject,
     /* 357817 */ // Label 7189: @357817
     /* 357817 */ GIM_Try, /*On fail goto*//*Label 7198*/ GIMT_Encode4(357847), // Rule ID 538 //
     /* 357822 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 357825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 357828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357832 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357836 */   // (fnearbyint:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTIDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 357836 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIDr),
     /* 357841 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 357845 */   GIR_RootConstrainSelectedInstOperands,
     /* 357846 */   // GIR_Coverage, 538,
     /* 357846 */   GIR_Done,
     /* 357847 */ // Label 7198: @357847
     /* 357847 */ GIM_Reject,
     /* 357848 */ // Label 7190: @357848
     /* 357848 */ GIM_Try, /*On fail goto*//*Label 7199*/ GIMT_Encode4(357878), // Rule ID 876 //
     /* 357853 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 357856 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 357859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357863 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357867 */   // (fnearbyint:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTIv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 357867 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv2f32),
     /* 357872 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 357876 */   GIR_RootConstrainSelectedInstOperands,
     /* 357877 */   // GIR_Coverage, 876,
     /* 357877 */   GIR_Done,
     /* 357878 */ // Label 7199: @357878
     /* 357878 */ GIM_Reject,
     /* 357879 */ // Label 7191: @357879
     /* 357879 */ GIM_Try, /*On fail goto*//*Label 7200*/ GIMT_Encode4(357909), // Rule ID 880 //
     /* 357884 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 357887 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 357890 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357894 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357898 */   // (fnearbyint:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTIv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 357898 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv2f64),
     /* 357903 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 357907 */   GIR_RootConstrainSelectedInstOperands,
     /* 357908 */   // GIR_Coverage, 880,
     /* 357908 */   GIR_Done,
     /* 357909 */ // Label 7200: @357909
     /* 357909 */ GIM_Reject,
     /* 357910 */ // Label 7192: @357910
     /* 357910 */ GIM_Try, /*On fail goto*//*Label 7201*/ GIMT_Encode4(357940), // Rule ID 872 //
     /* 357915 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 357918 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 357921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357925 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357929 */   // (fnearbyint:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTIv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 357929 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f16),
     /* 357934 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 357938 */   GIR_RootConstrainSelectedInstOperands,
     /* 357939 */   // GIR_Coverage, 872,
     /* 357939 */   GIR_Done,
     /* 357940 */ // Label 7201: @357940
     /* 357940 */ GIM_Reject,
     /* 357941 */ // Label 7193: @357941
     /* 357941 */ GIM_Try, /*On fail goto*//*Label 7202*/ GIMT_Encode4(357971), // Rule ID 878 //
     /* 357946 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 357949 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 357952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357956 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357960 */   // (fnearbyint:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTIv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 357960 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
     /* 357965 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 357969 */   GIR_RootConstrainSelectedInstOperands,
     /* 357970 */   // GIR_Coverage, 878,
     /* 357970 */   GIR_Done,
     /* 357971 */ // Label 7202: @357971
     /* 357971 */ GIM_Reject,
     /* 357972 */ // Label 7194: @357972
     /* 357972 */ GIM_Try, /*On fail goto*//*Label 7203*/ GIMT_Encode4(358193),
     /* 357977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 357980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357984 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357988 */   GIM_Try, /*On fail goto*//*Label 7204*/ GIMT_Encode4(358007), // Rule ID 874 //
     /* 357993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 357996 */     // (fnearbyint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTIv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 357996 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv8f16),
     /* 358001 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 358005 */     GIR_RootConstrainSelectedInstOperands,
     /* 358006 */     // GIR_Coverage, 874,
     /* 358006 */     GIR_Done,
     /* 358007 */   // Label 7204: @358007
     /* 358007 */   GIM_Try, /*On fail goto*//*Label 7205*/ GIMT_Encode4(358192), // Rule ID 6904 //
     /* 358012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 358015 */     // (fnearbyint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTIv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTIv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 358015 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 358018 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 358022 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358027 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 358031 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 358033 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 358036 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
     /* 358040 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358045 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 358048 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 358050 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 358053 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 358057 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358062 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 358068 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358073 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358078 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 358081 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 358085 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358090 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 358093 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 358095 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 358098 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
     /* 358102 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358107 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 358110 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 358112 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 358115 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 358119 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358124 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 358127 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 358129 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 358132 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 358136 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358141 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 358143 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 358146 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 358150 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358155 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 358158 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 358161 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 358164 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358169 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358174 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 358182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358184 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358187 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 358190 */     GIR_RootConstrainSelectedInstOperands,
     /* 358191 */     // GIR_Coverage, 6904,
     /* 358191 */     GIR_EraseRootFromParent_Done,
     /* 358192 */   // Label 7205: @358192
     /* 358192 */   GIM_Reject,
     /* 358193 */ // Label 7203: @358193
     /* 358193 */ GIM_Reject,
     /* 358194 */ // Label 7195: @358194
     /* 358194 */ GIM_Reject,
     /* 358195 */ // Label 98: @358195
     /* 358195 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7214*/ GIMT_Encode4(359320),
     /* 358206 */ /*GILLT_s16*//*Label 7206*/ GIMT_Encode4(358246),
     /* 358210 */ /*GILLT_s32*//*Label 7207*/ GIMT_Encode4(358472),
     /* 358214 */ /*GILLT_s64*//*Label 7208*/ GIMT_Encode4(358698), GIMT_Encode4(0),
     /* 358222 */ /*GILLT_v2s32*//*Label 7209*/ GIMT_Encode4(358870),
     /* 358226 */ /*GILLT_v2s64*//*Label 7210*/ GIMT_Encode4(358908),
     /* 358230 */ /*GILLT_v4s16*//*Label 7211*/ GIMT_Encode4(358946),
     /* 358234 */ /*GILLT_v4s32*//*Label 7212*/ GIMT_Encode4(358984), GIMT_Encode4(0),
     /* 358242 */ /*GILLT_v8s16*//*Label 7213*/ GIMT_Encode4(359022),
     /* 358246 */ // Label 7206: @358246
     /* 358246 */ GIM_Try, /*On fail goto*//*Label 7215*/ GIMT_Encode4(358471),
     /* 358251 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 358254 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 358257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 358261 */   GIM_Try, /*On fail goto*//*Label 7216*/ GIMT_Encode4(358352), // Rule ID 6824 //
     /* 358266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 358274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 358278 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 358282 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358287 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 358291 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358295 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 358299 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 358303 */     // MIs[2] Rn
     /* 358303 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 358308 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 358312 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358314 */     // (strict_fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 358314 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358317 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 358321 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358326 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 358332 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358337 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 358345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 358347 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358350 */     GIR_RootConstrainSelectedInstOperands,
     /* 358351 */     // GIR_Coverage, 6824,
     /* 358351 */     GIR_EraseRootFromParent_Done,
     /* 358352 */   // Label 7216: @358352
     /* 358352 */   GIM_Try, /*On fail goto*//*Label 7217*/ GIMT_Encode4(358443), // Rule ID 13653 //
     /* 358357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 358365 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 358369 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 358373 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358378 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 358382 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358386 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 358390 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 358394 */     // MIs[2] Rn
     /* 358394 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 358399 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 358403 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358405 */     // (strict_fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 358405 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358408 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 358412 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358417 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 358423 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358428 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 358436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 358438 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358441 */     GIR_RootConstrainSelectedInstOperands,
     /* 358442 */     // GIR_Coverage, 13653,
     /* 358442 */     GIR_EraseRootFromParent_Done,
     /* 358443 */   // Label 7217: @358443
     /* 358443 */   GIM_Try, /*On fail goto*//*Label 7218*/ GIMT_Encode4(358470), // Rule ID 583 //
     /* 358448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 358451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 358455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 358459 */     // (strict_fadd:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FADDHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 358459 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDHrr),
     /* 358464 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 358468 */     GIR_RootConstrainSelectedInstOperands,
     /* 358469 */     // GIR_Coverage, 583,
     /* 358469 */     GIR_Done,
     /* 358470 */   // Label 7218: @358470
     /* 358470 */   GIM_Reject,
     /* 358471 */ // Label 7215: @358471
     /* 358471 */ GIM_Reject,
     /* 358472 */ // Label 7207: @358472
     /* 358472 */ GIM_Try, /*On fail goto*//*Label 7219*/ GIMT_Encode4(358697),
     /* 358477 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 358480 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 358483 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 358487 */   GIM_Try, /*On fail goto*//*Label 7220*/ GIMT_Encode4(358578), // Rule ID 6822 //
     /* 358492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 358500 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 358504 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 358508 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358513 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 358517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 358525 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 358529 */     // MIs[2] Rn
     /* 358529 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 358534 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 358538 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358540 */     // (strict_fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 358540 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358543 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 358547 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358552 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 358558 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358563 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 358571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 358573 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358576 */     GIR_RootConstrainSelectedInstOperands,
     /* 358577 */     // GIR_Coverage, 6822,
     /* 358577 */     GIR_EraseRootFromParent_Done,
     /* 358578 */   // Label 7220: @358578
     /* 358578 */   GIM_Try, /*On fail goto*//*Label 7221*/ GIMT_Encode4(358669), // Rule ID 13651 //
     /* 358583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 358591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 358595 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 358599 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358604 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 358608 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358612 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 358616 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 358620 */     // MIs[2] Rn
     /* 358620 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 358625 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 358629 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358631 */     // (strict_fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 358631 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358634 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 358638 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358643 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 358649 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358654 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 358662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 358664 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358667 */     GIR_RootConstrainSelectedInstOperands,
     /* 358668 */     // GIR_Coverage, 13651,
     /* 358668 */     GIR_EraseRootFromParent_Done,
     /* 358669 */   // Label 7221: @358669
     /* 358669 */   GIM_Try, /*On fail goto*//*Label 7222*/ GIMT_Encode4(358696), // Rule ID 585 //
     /* 358674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 358677 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 358681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 358685 */     // (strict_fadd:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FADDSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 358685 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDSrr),
     /* 358690 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 358694 */     GIR_RootConstrainSelectedInstOperands,
     /* 358695 */     // GIR_Coverage, 585,
     /* 358695 */     GIR_Done,
     /* 358696 */   // Label 7222: @358696
     /* 358696 */   GIM_Reject,
     /* 358697 */ // Label 7219: @358697
     /* 358697 */ GIM_Reject,
     /* 358698 */ // Label 7208: @358698
     /* 358698 */ GIM_Try, /*On fail goto*//*Label 7223*/ GIMT_Encode4(358869),
     /* 358703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 358706 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 358709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358713 */   GIM_Try, /*On fail goto*//*Label 7224*/ GIMT_Encode4(358777), // Rule ID 6820 //
     /* 358718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 358726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 358730 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 358734 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358739 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 358743 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358747 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 358751 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 358755 */     // MIs[2] Rn
     /* 358755 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 358760 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 358764 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358766 */     // (strict_fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 358766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 358769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 358771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 358775 */     GIR_RootConstrainSelectedInstOperands,
     /* 358776 */     // GIR_Coverage, 6820,
     /* 358776 */     GIR_EraseRootFromParent_Done,
     /* 358777 */   // Label 7224: @358777
     /* 358777 */   GIM_Try, /*On fail goto*//*Label 7225*/ GIMT_Encode4(358841), // Rule ID 13649 //
     /* 358782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 358790 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 358794 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 358798 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358803 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 358807 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358811 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 358815 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 358819 */     // MIs[2] Rn
     /* 358819 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 358824 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 358828 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358830 */     // (strict_fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 358830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 358833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 358835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 358839 */     GIR_RootConstrainSelectedInstOperands,
     /* 358840 */     // GIR_Coverage, 13649,
     /* 358840 */     GIR_EraseRootFromParent_Done,
     /* 358841 */   // Label 7225: @358841
     /* 358841 */   GIM_Try, /*On fail goto*//*Label 7226*/ GIMT_Encode4(358868), // Rule ID 587 //
     /* 358846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 358849 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358857 */     // (strict_fadd:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FADDDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 358857 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDDrr),
     /* 358862 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 358866 */     GIR_RootConstrainSelectedInstOperands,
     /* 358867 */     // GIR_Coverage, 587,
     /* 358867 */     GIR_Done,
     /* 358868 */   // Label 7226: @358868
     /* 358868 */   GIM_Reject,
     /* 358869 */ // Label 7223: @358869
     /* 358869 */ GIM_Reject,
     /* 358870 */ // Label 7209: @358870
     /* 358870 */ GIM_Try, /*On fail goto*//*Label 7227*/ GIMT_Encode4(358907), // Rule ID 1195 //
     /* 358875 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 358878 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 358881 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 358884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358888 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358892 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358896 */   // (strict_fadd:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 358896 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f32),
     /* 358901 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 358905 */   GIR_RootConstrainSelectedInstOperands,
     /* 358906 */   // GIR_Coverage, 1195,
     /* 358906 */   GIR_Done,
     /* 358907 */ // Label 7227: @358907
     /* 358907 */ GIM_Reject,
     /* 358908 */ // Label 7210: @358908
     /* 358908 */ GIM_Try, /*On fail goto*//*Label 7228*/ GIMT_Encode4(358945), // Rule ID 1199 //
     /* 358913 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 358916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 358919 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 358922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358926 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358930 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358934 */   // (strict_fadd:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 358934 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f64),
     /* 358939 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 358943 */   GIR_RootConstrainSelectedInstOperands,
     /* 358944 */   // GIR_Coverage, 1199,
     /* 358944 */   GIR_Done,
     /* 358945 */ // Label 7228: @358945
     /* 358945 */ GIM_Reject,
     /* 358946 */ // Label 7211: @358946
     /* 358946 */ GIM_Try, /*On fail goto*//*Label 7229*/ GIMT_Encode4(358983), // Rule ID 1191 //
     /* 358951 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 358954 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 358957 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 358960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358964 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358968 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358972 */   // (strict_fadd:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 358972 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f16),
     /* 358977 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 358981 */   GIR_RootConstrainSelectedInstOperands,
     /* 358982 */   // GIR_Coverage, 1191,
     /* 358982 */   GIR_Done,
     /* 358983 */ // Label 7229: @358983
     /* 358983 */ GIM_Reject,
     /* 358984 */ // Label 7212: @358984
     /* 358984 */ GIM_Try, /*On fail goto*//*Label 7230*/ GIMT_Encode4(359021), // Rule ID 1197 //
     /* 358989 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 358992 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 358995 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 358998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359002 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359006 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359010 */   // (strict_fadd:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 359010 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 359015 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 359019 */   GIR_RootConstrainSelectedInstOperands,
     /* 359020 */   // GIR_Coverage, 1197,
     /* 359020 */   GIR_Done,
     /* 359021 */ // Label 7230: @359021
     /* 359021 */ GIM_Reject,
     /* 359022 */ // Label 7213: @359022
     /* 359022 */ GIM_Try, /*On fail goto*//*Label 7231*/ GIMT_Encode4(359319),
     /* 359027 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 359030 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 359033 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359037 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359041 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359045 */   GIM_Try, /*On fail goto*//*Label 7232*/ GIMT_Encode4(359064), // Rule ID 1193 //
     /* 359050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 359053 */     // (strict_fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 359053 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv8f16),
     /* 359058 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 359062 */     GIR_RootConstrainSelectedInstOperands,
     /* 359063 */     // GIR_Coverage, 1193,
     /* 359063 */     GIR_Done,
     /* 359064 */   // Label 7232: @359064
     /* 359064 */   GIM_Try, /*On fail goto*//*Label 7233*/ GIMT_Encode4(359318), // Rule ID 6913 //
     /* 359069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 359072 */     // (strict_fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FADDv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FADDv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 359072 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 359075 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 359079 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359084 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 359088 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 359090 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 359093 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 359097 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359102 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 359106 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 359108 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 359111 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 359115 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359120 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 359123 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 359126 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 359128 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 359131 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 359135 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359140 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 359146 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359151 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359156 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 359159 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 359163 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359168 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 359171 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 359173 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 359176 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 359180 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359185 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 359191 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359196 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359201 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 359204 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 359208 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359213 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 359216 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 359218 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 359221 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 359225 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359230 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 359233 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 359236 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 359238 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 359241 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 359245 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359250 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 359253 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 359255 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 359258 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 359262 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359267 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 359269 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 359272 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 359276 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359281 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 359284 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 359287 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 359290 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359295 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359300 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 359308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359310 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359313 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 359316 */     GIR_RootConstrainSelectedInstOperands,
     /* 359317 */     // GIR_Coverage, 6913,
     /* 359317 */     GIR_EraseRootFromParent_Done,
     /* 359318 */   // Label 7233: @359318
     /* 359318 */   GIM_Reject,
     /* 359319 */ // Label 7231: @359319
     /* 359319 */ GIM_Reject,
     /* 359320 */ // Label 7214: @359320
     /* 359320 */ GIM_Reject,
     /* 359321 */ // Label 99: @359321
     /* 359321 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7242*/ GIMT_Encode4(359936),
     /* 359332 */ /*GILLT_s16*//*Label 7234*/ GIMT_Encode4(359372),
     /* 359336 */ /*GILLT_s32*//*Label 7235*/ GIMT_Encode4(359410),
     /* 359340 */ /*GILLT_s64*//*Label 7236*/ GIMT_Encode4(359448), GIMT_Encode4(0),
     /* 359348 */ /*GILLT_v2s32*//*Label 7237*/ GIMT_Encode4(359486),
     /* 359352 */ /*GILLT_v2s64*//*Label 7238*/ GIMT_Encode4(359524),
     /* 359356 */ /*GILLT_v4s16*//*Label 7239*/ GIMT_Encode4(359562),
     /* 359360 */ /*GILLT_v4s32*//*Label 7240*/ GIMT_Encode4(359600), GIMT_Encode4(0),
     /* 359368 */ /*GILLT_v8s16*//*Label 7241*/ GIMT_Encode4(359638),
     /* 359372 */ // Label 7234: @359372
     /* 359372 */ GIM_Try, /*On fail goto*//*Label 7243*/ GIMT_Encode4(359409), // Rule ID 631 //
     /* 359377 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 359380 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 359383 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 359386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 359390 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 359394 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 359398 */   // (strict_fsub:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FSUBHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 359398 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBHrr),
     /* 359403 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 359407 */   GIR_RootConstrainSelectedInstOperands,
     /* 359408 */   // GIR_Coverage, 631,
     /* 359408 */   GIR_Done,
     /* 359409 */ // Label 7243: @359409
     /* 359409 */ GIM_Reject,
     /* 359410 */ // Label 7235: @359410
     /* 359410 */ GIM_Try, /*On fail goto*//*Label 7244*/ GIMT_Encode4(359447), // Rule ID 633 //
     /* 359415 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 359418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 359421 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 359424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 359428 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 359432 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 359436 */   // (strict_fsub:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FSUBSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 359436 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBSrr),
     /* 359441 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 359445 */   GIR_RootConstrainSelectedInstOperands,
     /* 359446 */   // GIR_Coverage, 633,
     /* 359446 */   GIR_Done,
     /* 359447 */ // Label 7244: @359447
     /* 359447 */ GIM_Reject,
     /* 359448 */ // Label 7236: @359448
     /* 359448 */ GIM_Try, /*On fail goto*//*Label 7245*/ GIMT_Encode4(359485), // Rule ID 635 //
     /* 359453 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 359456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 359459 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 359462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359466 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359470 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359474 */   // (strict_fsub:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FSUBDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 359474 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBDrr),
     /* 359479 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 359483 */   GIR_RootConstrainSelectedInstOperands,
     /* 359484 */   // GIR_Coverage, 635,
     /* 359484 */   GIR_Done,
     /* 359485 */ // Label 7245: @359485
     /* 359485 */ GIM_Reject,
     /* 359486 */ // Label 7237: @359486
     /* 359486 */ GIM_Try, /*On fail goto*//*Label 7246*/ GIMT_Encode4(359523), // Rule ID 1335 //
     /* 359491 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 359494 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 359497 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 359500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359504 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359508 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359512 */   // (strict_fsub:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FSUBv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 359512 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f32),
     /* 359517 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 359521 */   GIR_RootConstrainSelectedInstOperands,
     /* 359522 */   // GIR_Coverage, 1335,
     /* 359522 */   GIR_Done,
     /* 359523 */ // Label 7246: @359523
     /* 359523 */ GIM_Reject,
     /* 359524 */ // Label 7238: @359524
     /* 359524 */ GIM_Try, /*On fail goto*//*Label 7247*/ GIMT_Encode4(359561), // Rule ID 1339 //
     /* 359529 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 359532 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 359535 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 359538 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359542 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359546 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359550 */   // (strict_fsub:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FSUBv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 359550 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f64),
     /* 359555 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 359559 */   GIR_RootConstrainSelectedInstOperands,
     /* 359560 */   // GIR_Coverage, 1339,
     /* 359560 */   GIR_Done,
     /* 359561 */ // Label 7247: @359561
     /* 359561 */ GIM_Reject,
     /* 359562 */ // Label 7239: @359562
     /* 359562 */ GIM_Try, /*On fail goto*//*Label 7248*/ GIMT_Encode4(359599), // Rule ID 1331 //
     /* 359567 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 359570 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 359573 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 359576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359580 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359584 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359588 */   // (strict_fsub:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FSUBv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 359588 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f16),
     /* 359593 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 359597 */   GIR_RootConstrainSelectedInstOperands,
     /* 359598 */   // GIR_Coverage, 1331,
     /* 359598 */   GIR_Done,
     /* 359599 */ // Label 7248: @359599
     /* 359599 */ GIM_Reject,
     /* 359600 */ // Label 7240: @359600
     /* 359600 */ GIM_Try, /*On fail goto*//*Label 7249*/ GIMT_Encode4(359637), // Rule ID 1337 //
     /* 359605 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 359608 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 359611 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 359614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359618 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359622 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359626 */   // (strict_fsub:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FSUBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 359626 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 359631 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 359635 */   GIR_RootConstrainSelectedInstOperands,
     /* 359636 */   // GIR_Coverage, 1337,
     /* 359636 */   GIR_Done,
     /* 359637 */ // Label 7249: @359637
     /* 359637 */ GIM_Reject,
     /* 359638 */ // Label 7241: @359638
     /* 359638 */ GIM_Try, /*On fail goto*//*Label 7250*/ GIMT_Encode4(359935),
     /* 359643 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 359646 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 359649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359653 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359657 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359661 */   GIM_Try, /*On fail goto*//*Label 7251*/ GIMT_Encode4(359680), // Rule ID 1333 //
     /* 359666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 359669 */     // (strict_fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FSUBv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 359669 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv8f16),
     /* 359674 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 359678 */     GIR_RootConstrainSelectedInstOperands,
     /* 359679 */     // GIR_Coverage, 1333,
     /* 359679 */     GIR_Done,
     /* 359680 */   // Label 7251: @359680
     /* 359680 */   GIM_Try, /*On fail goto*//*Label 7252*/ GIMT_Encode4(359934), // Rule ID 6919 //
     /* 359685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 359688 */     // (strict_fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FSUBv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FSUBv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 359688 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 359691 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 359695 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359700 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 359704 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 359706 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 359709 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 359713 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359718 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 359722 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 359724 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 359727 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 359731 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359736 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 359739 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 359742 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 359744 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 359747 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 359751 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359756 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 359762 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359767 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359772 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 359775 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 359779 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359784 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 359787 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 359789 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 359792 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 359796 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359801 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 359807 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359812 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359817 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 359820 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 359824 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359829 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 359832 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 359834 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 359837 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 359841 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359846 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 359849 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 359852 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 359854 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 359857 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 359861 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359866 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 359869 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 359871 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 359874 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 359878 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359883 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 359885 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 359888 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 359892 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359897 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 359900 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 359903 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 359906 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359911 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359916 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 359924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359926 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359929 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 359932 */     GIR_RootConstrainSelectedInstOperands,
     /* 359933 */     // GIR_Coverage, 6919,
     /* 359933 */     GIR_EraseRootFromParent_Done,
     /* 359934 */   // Label 7252: @359934
     /* 359934 */   GIM_Reject,
     /* 359935 */ // Label 7250: @359935
     /* 359935 */ GIM_Reject,
     /* 359936 */ // Label 7242: @359936
     /* 359936 */ GIM_Reject,
     /* 359937 */ // Label 100: @359937
     /* 359937 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7261*/ GIMT_Encode4(363658),
     /* 359948 */ /*GILLT_s16*//*Label 7253*/ GIMT_Encode4(359988),
     /* 359952 */ /*GILLT_s32*//*Label 7254*/ GIMT_Encode4(360542),
     /* 359956 */ /*GILLT_s64*//*Label 7255*/ GIMT_Encode4(361090), GIMT_Encode4(0),
     /* 359964 */ /*GILLT_v2s32*//*Label 7256*/ GIMT_Encode4(361638),
     /* 359968 */ /*GILLT_v2s64*//*Label 7257*/ GIMT_Encode4(362168),
     /* 359972 */ /*GILLT_v4s16*//*Label 7258*/ GIMT_Encode4(362526),
     /* 359976 */ /*GILLT_v4s32*//*Label 7259*/ GIMT_Encode4(362868), GIMT_Encode4(0),
     /* 359984 */ /*GILLT_v8s16*//*Label 7260*/ GIMT_Encode4(363226),
     /* 359988 */ // Label 7253: @359988
     /* 359988 */ GIM_Try, /*On fail goto*//*Label 7262*/ GIMT_Encode4(360541),
     /* 359993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 359996 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 359999 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360003 */   GIM_Try, /*On fail goto*//*Label 7263*/ GIMT_Encode4(360116), // Rule ID 6146 //
     /* 360008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 360011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 360019 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 360023 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 360027 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360032 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 360036 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360040 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 360044 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 360048 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 360052 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360057 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 360061 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360065 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 360069 */     // MIs[3] Operand 1
     /* 360069 */     // No operand predicates
     /* 360069 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 360071 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 360071 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 360074 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 360078 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360083 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 360089 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360094 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 360102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 360104 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 360111 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 360114 */     GIR_RootConstrainSelectedInstOperands,
     /* 360115 */     // GIR_Coverage, 6146,
     /* 360115 */     GIR_EraseRootFromParent_Done,
     /* 360116 */   // Label 7263: @360116
     /* 360116 */   GIM_Try, /*On fail goto*//*Label 7264*/ GIMT_Encode4(360229), // Rule ID 13624 //
     /* 360121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 360124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 360132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 360136 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 360140 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360145 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 360149 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360153 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 360157 */     // MIs[2] Operand 1
     /* 360157 */     // No operand predicates
     /* 360157 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 360161 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 360165 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 360169 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 360173 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360178 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 360182 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 360184 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 360184 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 360187 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 360191 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360196 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 360202 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360207 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 360215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 360217 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 360224 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 360227 */     GIR_RootConstrainSelectedInstOperands,
     /* 360228 */     // GIR_Coverage, 13624,
     /* 360228 */     GIR_EraseRootFromParent_Done,
     /* 360229 */   // Label 7264: @360229
     /* 360229 */   GIM_Try, /*On fail goto*//*Label 7265*/ GIMT_Encode4(360308), // Rule ID 13561 //
     /* 360234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 360237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 360245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 360249 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 360253 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360258 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 360262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360266 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 360268 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 360268 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 360271 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 360275 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360280 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 360286 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360291 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 360299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 360301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 360303 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360306 */     GIR_RootConstrainSelectedInstOperands,
     /* 360307 */     // GIR_Coverage, 13561,
     /* 360307 */     GIR_EraseRootFromParent_Done,
     /* 360308 */   // Label 7265: @360308
     /* 360308 */   GIM_Try, /*On fail goto*//*Label 7266*/ GIMT_Encode4(360387), // Rule ID 4742 //
     /* 360313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 360316 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 360324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 360328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 360332 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 360336 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360341 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 360345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 360347 */     // (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 360347 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 360350 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 360354 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360359 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 360365 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360370 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 360378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 360380 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 360382 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360385 */     GIR_RootConstrainSelectedInstOperands,
     /* 360386 */     // GIR_Coverage, 4742,
     /* 360386 */     GIR_EraseRootFromParent_Done,
     /* 360387 */   // Label 7266: @360387
     /* 360387 */   GIM_Try, /*On fail goto*//*Label 7267*/ GIMT_Encode4(360450), // Rule ID 13176 //
     /* 360392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 360395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 360403 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 360407 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 360411 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 360416 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 360420 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360424 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 360428 */     // MIs[2] Operand 1
     /* 360428 */     // No operand predicates
     /* 360428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360432 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360434 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 360434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 360437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 360439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 360441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 360445 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 360448 */     GIR_RootConstrainSelectedInstOperands,
     /* 360449 */     // GIR_Coverage, 13176,
     /* 360449 */     GIR_EraseRootFromParent_Done,
     /* 360450 */   // Label 7267: @360450
     /* 360450 */   GIM_Try, /*On fail goto*//*Label 7268*/ GIMT_Encode4(360513), // Rule ID 2004 //
     /* 360455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 360458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 360466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 360470 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 360474 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 360478 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 360483 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 360487 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360491 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 360495 */     // MIs[2] Operand 1
     /* 360495 */     // No operand predicates
     /* 360495 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360497 */     // (strict_fmul:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 360497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 360500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 360502 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 360504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 360508 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 360511 */     GIR_RootConstrainSelectedInstOperands,
     /* 360512 */     // GIR_Coverage, 2004,
     /* 360512 */     GIR_EraseRootFromParent_Done,
     /* 360513 */   // Label 7268: @360513
     /* 360513 */   GIM_Try, /*On fail goto*//*Label 7269*/ GIMT_Encode4(360540), // Rule ID 619 //
     /* 360518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 360521 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360529 */     // (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 360529 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 360534 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 360538 */     GIR_RootConstrainSelectedInstOperands,
     /* 360539 */     // GIR_Coverage, 619,
     /* 360539 */     GIR_Done,
     /* 360540 */   // Label 7269: @360540
     /* 360540 */   GIM_Reject,
     /* 360541 */ // Label 7262: @360541
     /* 360541 */ GIM_Reject,
     /* 360542 */ // Label 7254: @360542
     /* 360542 */ GIM_Try, /*On fail goto*//*Label 7270*/ GIMT_Encode4(361089),
     /* 360547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 360550 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 360553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 360557 */   GIM_Try, /*On fail goto*//*Label 7271*/ GIMT_Encode4(360670), // Rule ID 6148 //
     /* 360562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 360565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 360573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 360577 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 360581 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360586 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 360590 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360594 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 360598 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 360602 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 360606 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360611 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 360615 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360619 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 360623 */     // MIs[3] Operand 1
     /* 360623 */     // No operand predicates
     /* 360623 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 360625 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 360625 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 360628 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 360632 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360637 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 360643 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 360648 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 360656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 360658 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 360665 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 360668 */     GIR_RootConstrainSelectedInstOperands,
     /* 360669 */     // GIR_Coverage, 6148,
     /* 360669 */     GIR_EraseRootFromParent_Done,
     /* 360670 */   // Label 7271: @360670
     /* 360670 */   GIM_Try, /*On fail goto*//*Label 7272*/ GIMT_Encode4(360783), // Rule ID 13626 //
     /* 360675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 360678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 360686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 360690 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 360694 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360699 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 360703 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360707 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 360711 */     // MIs[2] Operand 1
     /* 360711 */     // No operand predicates
     /* 360711 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 360715 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 360719 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 360723 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 360727 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360732 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 360736 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 360738 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 360738 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 360741 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 360745 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360750 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 360756 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 360761 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 360769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 360771 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 360778 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 360781 */     GIR_RootConstrainSelectedInstOperands,
     /* 360782 */     // GIR_Coverage, 13626,
     /* 360782 */     GIR_EraseRootFromParent_Done,
     /* 360783 */   // Label 7272: @360783
     /* 360783 */   GIM_Try, /*On fail goto*//*Label 7273*/ GIMT_Encode4(360859), // Rule ID 13563 //
     /* 360788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 360796 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 360800 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 360804 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360809 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 360813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 360817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 360819 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 360819 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 360822 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 360826 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360831 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 360837 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 360842 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 360850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 360852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 360854 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360857 */     GIR_RootConstrainSelectedInstOperands,
     /* 360858 */     // GIR_Coverage, 13563,
     /* 360858 */     GIR_EraseRootFromParent_Done,
     /* 360859 */   // Label 7273: @360859
     /* 360859 */   GIM_Try, /*On fail goto*//*Label 7274*/ GIMT_Encode4(360935), // Rule ID 4744 //
     /* 360864 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 360868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 360872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 360876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 360880 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 360884 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360889 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 360893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 360895 */     // (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 360895 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 360898 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 360902 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360907 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 360913 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 360918 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 360926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 360928 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 360930 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360933 */     GIR_RootConstrainSelectedInstOperands,
     /* 360934 */     // GIR_Coverage, 4744,
     /* 360934 */     GIR_EraseRootFromParent_Done,
     /* 360935 */   // Label 7274: @360935
     /* 360935 */   GIM_Try, /*On fail goto*//*Label 7275*/ GIMT_Encode4(360998), // Rule ID 13178 //
     /* 360940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 360943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 360951 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 360955 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 360959 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360964 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 360968 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360972 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 360976 */     // MIs[2] Operand 1
     /* 360976 */     // No operand predicates
     /* 360976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 360980 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360982 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 360982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 360985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 360987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 360989 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 360993 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 360996 */     GIR_RootConstrainSelectedInstOperands,
     /* 360997 */     // GIR_Coverage, 13178,
     /* 360997 */     GIR_EraseRootFromParent_Done,
     /* 360998 */   // Label 7275: @360998
     /* 360998 */   GIM_Try, /*On fail goto*//*Label 7276*/ GIMT_Encode4(361061), // Rule ID 2006 //
     /* 361003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 361006 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 361014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 361022 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 361026 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361031 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 361035 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361039 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 361043 */     // MIs[2] Operand 1
     /* 361043 */     // No operand predicates
     /* 361043 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361045 */     // (strict_fmul:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 361045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 361048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 361050 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 361052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 361056 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 361059 */     GIR_RootConstrainSelectedInstOperands,
     /* 361060 */     // GIR_Coverage, 2006,
     /* 361060 */     GIR_EraseRootFromParent_Done,
     /* 361061 */   // Label 7276: @361061
     /* 361061 */   GIM_Try, /*On fail goto*//*Label 7277*/ GIMT_Encode4(361088), // Rule ID 621 //
     /* 361066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 361069 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361077 */     // (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 361077 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 361082 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 361086 */     GIR_RootConstrainSelectedInstOperands,
     /* 361087 */     // GIR_Coverage, 621,
     /* 361087 */     GIR_Done,
     /* 361088 */   // Label 7277: @361088
     /* 361088 */   GIM_Reject,
     /* 361089 */ // Label 7270: @361089
     /* 361089 */ GIM_Reject,
     /* 361090 */ // Label 7255: @361090
     /* 361090 */ GIM_Try, /*On fail goto*//*Label 7278*/ GIMT_Encode4(361637),
     /* 361095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 361098 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 361101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361105 */   GIM_Try, /*On fail goto*//*Label 7279*/ GIMT_Encode4(361218), // Rule ID 6150 //
     /* 361110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 361113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 361125 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 361129 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361134 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 361138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361142 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361146 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 361150 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 361154 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361159 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 361163 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361167 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 361171 */     // MIs[3] Operand 1
     /* 361171 */     // No operand predicates
     /* 361171 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 361173 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 361173 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 361176 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361180 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361185 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 361191 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361196 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 361204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 361206 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 361213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 361216 */     GIR_RootConstrainSelectedInstOperands,
     /* 361217 */     // GIR_Coverage, 6150,
     /* 361217 */     GIR_EraseRootFromParent_Done,
     /* 361218 */   // Label 7279: @361218
     /* 361218 */   GIM_Try, /*On fail goto*//*Label 7280*/ GIMT_Encode4(361331), // Rule ID 13628 //
     /* 361223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 361226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 361238 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 361242 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361247 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 361251 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361255 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 361259 */     // MIs[2] Operand 1
     /* 361259 */     // No operand predicates
     /* 361259 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 361263 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361267 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 361271 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 361275 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361280 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 361284 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 361286 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 361286 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 361289 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361293 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361298 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 361304 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361309 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 361317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 361319 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 361326 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 361329 */     GIR_RootConstrainSelectedInstOperands,
     /* 361330 */     // GIR_Coverage, 13628,
     /* 361330 */     GIR_EraseRootFromParent_Done,
     /* 361331 */   // Label 7280: @361331
     /* 361331 */   GIM_Try, /*On fail goto*//*Label 7281*/ GIMT_Encode4(361407), // Rule ID 13565 //
     /* 361336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 361348 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 361352 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361357 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 361361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 361367 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 361367 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 361370 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361374 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361379 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 361385 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361390 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 361398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 361400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 361402 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361405 */     GIR_RootConstrainSelectedInstOperands,
     /* 361406 */     // GIR_Coverage, 13565,
     /* 361406 */     GIR_EraseRootFromParent_Done,
     /* 361407 */   // Label 7281: @361407
     /* 361407 */   GIM_Try, /*On fail goto*//*Label 7282*/ GIMT_Encode4(361483), // Rule ID 4746 //
     /* 361412 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 361420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361424 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 361428 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 361432 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361437 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 361441 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 361443 */     // (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 361443 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 361446 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361450 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361455 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 361461 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361466 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 361474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 361476 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 361478 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361481 */     GIR_RootConstrainSelectedInstOperands,
     /* 361482 */     // GIR_Coverage, 4746,
     /* 361482 */     GIR_EraseRootFromParent_Done,
     /* 361483 */   // Label 7282: @361483
     /* 361483 */   GIM_Try, /*On fail goto*//*Label 7283*/ GIMT_Encode4(361546), // Rule ID 13180 //
     /* 361488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 361491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 361503 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 361507 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361512 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 361516 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361520 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 361524 */     // MIs[2] Operand 1
     /* 361524 */     // No operand predicates
     /* 361524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361528 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361530 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 361530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 361533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 361535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 361537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 361541 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 361544 */     GIR_RootConstrainSelectedInstOperands,
     /* 361545 */     // GIR_Coverage, 13180,
     /* 361545 */     GIR_EraseRootFromParent_Done,
     /* 361546 */   // Label 7283: @361546
     /* 361546 */   GIM_Try, /*On fail goto*//*Label 7284*/ GIMT_Encode4(361609), // Rule ID 2008 //
     /* 361551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 361554 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 361562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361566 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 361570 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 361574 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361579 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 361583 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361587 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 361591 */     // MIs[2] Operand 1
     /* 361591 */     // No operand predicates
     /* 361591 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361593 */     // (strict_fmul:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 361593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 361596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 361598 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 361600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 361604 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 361607 */     GIR_RootConstrainSelectedInstOperands,
     /* 361608 */     // GIR_Coverage, 2008,
     /* 361608 */     GIR_EraseRootFromParent_Done,
     /* 361609 */   // Label 7284: @361609
     /* 361609 */   GIM_Try, /*On fail goto*//*Label 7285*/ GIMT_Encode4(361636), // Rule ID 623 //
     /* 361614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 361617 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361625 */     // (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 361625 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 361630 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 361634 */     GIR_RootConstrainSelectedInstOperands,
     /* 361635 */     // GIR_Coverage, 623,
     /* 361635 */     GIR_Done,
     /* 361636 */   // Label 7285: @361636
     /* 361636 */   GIM_Reject,
     /* 361637 */ // Label 7278: @361637
     /* 361637 */ GIM_Reject,
     /* 361638 */ // Label 7256: @361638
     /* 361638 */ GIM_Try, /*On fail goto*//*Label 7286*/ GIMT_Encode4(362167),
     /* 361643 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 361646 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 361649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361653 */   GIM_Try, /*On fail goto*//*Label 7287*/ GIMT_Encode4(361739), // Rule ID 13168 //
     /* 361658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 361661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 361669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 361673 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 361677 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 361681 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 361685 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 361689 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361694 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 361698 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361702 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 361706 */     // MIs[3] Operand 1
     /* 361706 */     // No operand predicates
     /* 361706 */     // MIs[1] Operand 2
     /* 361706 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 361717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361721 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 361723 */     // (strict_fmul:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 361723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 361726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 361728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 361730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 361734 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 361737 */     GIR_RootConstrainSelectedInstOperands,
     /* 361738 */     // GIR_Coverage, 13168,
     /* 361738 */     GIR_EraseRootFromParent_Done,
     /* 361739 */   // Label 7287: @361739
     /* 361739 */   GIM_Try, /*On fail goto*//*Label 7288*/ GIMT_Encode4(361825), // Rule ID 1996 //
     /* 361744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 361747 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 361755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 361759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 361763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 361767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 361771 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 361775 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 361779 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361784 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 361788 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361792 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 361796 */     // MIs[3] Operand 1
     /* 361796 */     // No operand predicates
     /* 361796 */     // MIs[1] Operand 2
     /* 361796 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 361807 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 361809 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 361809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 361812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 361814 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 361816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 361820 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 361823 */     GIR_RootConstrainSelectedInstOperands,
     /* 361824 */     // GIR_Coverage, 1996,
     /* 361824 */     GIR_EraseRootFromParent_Done,
     /* 361825 */   // Label 7288: @361825
     /* 361825 */   GIM_Try, /*On fail goto*//*Label 7289*/ GIMT_Encode4(361888), // Rule ID 13169 //
     /* 361830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 361833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 361841 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 361845 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 361849 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361854 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 361858 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361862 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 361866 */     // MIs[2] Operand 1
     /* 361866 */     // No operand predicates
     /* 361866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361870 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361872 */     // (strict_fmul:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 361872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 361875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 361877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 361879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 361883 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 361886 */     GIR_RootConstrainSelectedInstOperands,
     /* 361887 */     // GIR_Coverage, 13169,
     /* 361887 */     GIR_EraseRootFromParent_Done,
     /* 361888 */   // Label 7289: @361888
     /* 361888 */   GIM_Try, /*On fail goto*//*Label 7290*/ GIMT_Encode4(361951), // Rule ID 1997 //
     /* 361893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 361896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 361904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 361908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 361912 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 361916 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361921 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 361925 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361929 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 361933 */     // MIs[2] Operand 1
     /* 361933 */     // No operand predicates
     /* 361933 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361935 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 361935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 361938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 361940 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 361942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 361946 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 361949 */     GIR_RootConstrainSelectedInstOperands,
     /* 361950 */     // GIR_Coverage, 1997,
     /* 361950 */     GIR_EraseRootFromParent_Done,
     /* 361951 */   // Label 7290: @361951
     /* 361951 */   GIM_Try, /*On fail goto*//*Label 7291*/ GIMT_Encode4(362045), // Rule ID 13630 //
     /* 361956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 361964 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 361968 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361977 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 361979 */     // (strict_fmul:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 361979 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 361982 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 361986 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361991 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 361993 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 361996 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 362000 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362005 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 362008 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 362012 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 362015 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362020 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362025 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 362033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 362037 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362043 */     GIR_RootConstrainSelectedInstOperands,
     /* 362044 */     // GIR_Coverage, 13630,
     /* 362044 */     GIR_EraseRootFromParent_Done,
     /* 362045 */   // Label 7291: @362045
     /* 362045 */   GIM_Try, /*On fail goto*//*Label 7292*/ GIMT_Encode4(362139), // Rule ID 6152 //
     /* 362050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 362062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 362066 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362073 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 362073 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 362076 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 362080 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362085 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 362087 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 362090 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 362094 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362099 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 362102 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 362106 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 362109 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362114 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362119 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 362127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362129 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 362131 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362137 */     GIR_RootConstrainSelectedInstOperands,
     /* 362138 */     // GIR_Coverage, 6152,
     /* 362138 */     GIR_EraseRootFromParent_Done,
     /* 362139 */   // Label 7292: @362139
     /* 362139 */   GIM_Try, /*On fail goto*//*Label 7293*/ GIMT_Encode4(362166), // Rule ID 1315 //
     /* 362144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 362147 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362155 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 362155 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f32),
     /* 362160 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 362164 */     GIR_RootConstrainSelectedInstOperands,
     /* 362165 */     // GIR_Coverage, 1315,
     /* 362165 */     GIR_Done,
     /* 362166 */   // Label 7293: @362166
     /* 362166 */   GIM_Reject,
     /* 362167 */ // Label 7286: @362167
     /* 362167 */ GIM_Reject,
     /* 362168 */ // Label 7257: @362168
     /* 362168 */ GIM_Try, /*On fail goto*//*Label 7294*/ GIMT_Encode4(362525),
     /* 362173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 362176 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 362179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362183 */   GIM_Try, /*On fail goto*//*Label 7295*/ GIMT_Encode4(362246), // Rule ID 13174 //
     /* 362188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 362191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 362199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 362203 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 362207 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362212 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 362216 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362220 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 362224 */     // MIs[2] Operand 1
     /* 362224 */     // No operand predicates
     /* 362224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362228 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362230 */     // (strict_fmul:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 362230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 362233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362235 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 362237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 362241 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 362244 */     GIR_RootConstrainSelectedInstOperands,
     /* 362245 */     // GIR_Coverage, 13174,
     /* 362245 */     GIR_EraseRootFromParent_Done,
     /* 362246 */   // Label 7295: @362246
     /* 362246 */   GIM_Try, /*On fail goto*//*Label 7296*/ GIMT_Encode4(362309), // Rule ID 2002 //
     /* 362251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 362254 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 362266 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 362270 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 362274 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362279 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 362283 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362287 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 362291 */     // MIs[2] Operand 1
     /* 362291 */     // No operand predicates
     /* 362291 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362293 */     // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 362293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 362296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362298 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 362300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 362304 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 362307 */     GIR_RootConstrainSelectedInstOperands,
     /* 362308 */     // GIR_Coverage, 2002,
     /* 362308 */     GIR_EraseRootFromParent_Done,
     /* 362309 */   // Label 7296: @362309
     /* 362309 */   GIM_Try, /*On fail goto*//*Label 7297*/ GIMT_Encode4(362403), // Rule ID 13634 //
     /* 362314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 362322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 362326 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362337 */     // (strict_fmul:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 362337 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 362340 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 362344 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362349 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 362351 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 362354 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 362358 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362363 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 362366 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 362370 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 362373 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362378 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362383 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 362391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 362395 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362401 */     GIR_RootConstrainSelectedInstOperands,
     /* 362402 */     // GIR_Coverage, 13634,
     /* 362402 */     GIR_EraseRootFromParent_Done,
     /* 362403 */   // Label 7297: @362403
     /* 362403 */   GIM_Try, /*On fail goto*//*Label 7298*/ GIMT_Encode4(362497), // Rule ID 6156 //
     /* 362408 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 362420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 362424 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362431 */     // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 362431 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 362434 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 362438 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362443 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 362445 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 362448 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 362452 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362457 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 362460 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 362464 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 362467 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362472 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362477 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 362485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362487 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 362489 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362495 */     GIR_RootConstrainSelectedInstOperands,
     /* 362496 */     // GIR_Coverage, 6156,
     /* 362496 */     GIR_EraseRootFromParent_Done,
     /* 362497 */   // Label 7298: @362497
     /* 362497 */   GIM_Try, /*On fail goto*//*Label 7299*/ GIMT_Encode4(362524), // Rule ID 1319 //
     /* 362502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 362505 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362513 */     // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 362513 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f64),
     /* 362518 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 362522 */     GIR_RootConstrainSelectedInstOperands,
     /* 362523 */     // GIR_Coverage, 1319,
     /* 362523 */     GIR_Done,
     /* 362524 */   // Label 7299: @362524
     /* 362524 */   GIM_Reject,
     /* 362525 */ // Label 7294: @362525
     /* 362525 */ GIM_Reject,
     /* 362526 */ // Label 7258: @362526
     /* 362526 */ GIM_Try, /*On fail goto*//*Label 7300*/ GIMT_Encode4(362867),
     /* 362531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 362534 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 362537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362541 */   GIM_Try, /*On fail goto*//*Label 7301*/ GIMT_Encode4(362627), // Rule ID 13162 //
     /* 362546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 362549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 362557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 362561 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 362565 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 362569 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 362573 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 362577 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 362582 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 362586 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362590 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 362594 */     // MIs[3] Operand 1
     /* 362594 */     // No operand predicates
     /* 362594 */     // MIs[1] Operand 2
     /* 362594 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 362605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362609 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 362611 */     // (strict_fmul:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 362611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 362614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362616 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 362618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 362622 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 362625 */     GIR_RootConstrainSelectedInstOperands,
     /* 362626 */     // GIR_Coverage, 13162,
     /* 362626 */     GIR_EraseRootFromParent_Done,
     /* 362627 */   // Label 7301: @362627
     /* 362627 */   GIM_Try, /*On fail goto*//*Label 7302*/ GIMT_Encode4(362713), // Rule ID 1990 //
     /* 362632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 362635 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 362647 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 362651 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 362655 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 362659 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 362663 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 362667 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 362672 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 362676 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362680 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 362684 */     // MIs[3] Operand 1
     /* 362684 */     // No operand predicates
     /* 362684 */     // MIs[1] Operand 2
     /* 362684 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 362695 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 362697 */     // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 362697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 362700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362702 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 362704 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 362708 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 362711 */     GIR_RootConstrainSelectedInstOperands,
     /* 362712 */     // GIR_Coverage, 1990,
     /* 362712 */     GIR_EraseRootFromParent_Done,
     /* 362713 */   // Label 7302: @362713
     /* 362713 */   GIM_Try, /*On fail goto*//*Label 7303*/ GIMT_Encode4(362776), // Rule ID 13163 //
     /* 362718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 362721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 362729 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 362733 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 362737 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 362742 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 362746 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362750 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 362754 */     // MIs[2] Operand 1
     /* 362754 */     // No operand predicates
     /* 362754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362758 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362760 */     // (strict_fmul:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 362760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 362763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 362767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 362771 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 362774 */     GIR_RootConstrainSelectedInstOperands,
     /* 362775 */     // GIR_Coverage, 13163,
     /* 362775 */     GIR_EraseRootFromParent_Done,
     /* 362776 */   // Label 7303: @362776
     /* 362776 */   GIM_Try, /*On fail goto*//*Label 7304*/ GIMT_Encode4(362839), // Rule ID 1991 //
     /* 362781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 362784 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 362796 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 362800 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 362804 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 362809 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 362813 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362817 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 362821 */     // MIs[2] Operand 1
     /* 362821 */     // No operand predicates
     /* 362821 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362823 */     // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 362823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 362826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362828 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 362830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 362834 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 362837 */     GIR_RootConstrainSelectedInstOperands,
     /* 362838 */     // GIR_Coverage, 1991,
     /* 362838 */     GIR_EraseRootFromParent_Done,
     /* 362839 */   // Label 7304: @362839
     /* 362839 */   GIM_Try, /*On fail goto*//*Label 7305*/ GIMT_Encode4(362866), // Rule ID 1311 //
     /* 362844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 362847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362855 */     // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 362855 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f16),
     /* 362860 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 362864 */     GIR_RootConstrainSelectedInstOperands,
     /* 362865 */     // GIR_Coverage, 1311,
     /* 362865 */     GIR_Done,
     /* 362866 */   // Label 7305: @362866
     /* 362866 */   GIM_Reject,
     /* 362867 */ // Label 7300: @362867
     /* 362867 */ GIM_Reject,
     /* 362868 */ // Label 7259: @362868
     /* 362868 */ GIM_Try, /*On fail goto*//*Label 7306*/ GIMT_Encode4(363225),
     /* 362873 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 362876 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 362879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362883 */   GIM_Try, /*On fail goto*//*Label 7307*/ GIMT_Encode4(362946), // Rule ID 13172 //
     /* 362888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 362891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 362899 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 362903 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 362907 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362912 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 362916 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362920 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 362924 */     // MIs[2] Operand 1
     /* 362924 */     // No operand predicates
     /* 362924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362928 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362930 */     // (strict_fmul:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 362930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 362933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 362937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 362941 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 362944 */     GIR_RootConstrainSelectedInstOperands,
     /* 362945 */     // GIR_Coverage, 13172,
     /* 362945 */     GIR_EraseRootFromParent_Done,
     /* 362946 */   // Label 7307: @362946
     /* 362946 */   GIM_Try, /*On fail goto*//*Label 7308*/ GIMT_Encode4(363009), // Rule ID 2000 //
     /* 362951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 362954 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 362966 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 362970 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 362974 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362979 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 362983 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362987 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 362991 */     // MIs[2] Operand 1
     /* 362991 */     // No operand predicates
     /* 362991 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362993 */     // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 362993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 362996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362998 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 363000 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 363004 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 363007 */     GIR_RootConstrainSelectedInstOperands,
     /* 363008 */     // GIR_Coverage, 2000,
     /* 363008 */     GIR_EraseRootFromParent_Done,
     /* 363009 */   // Label 7308: @363009
     /* 363009 */   GIM_Try, /*On fail goto*//*Label 7309*/ GIMT_Encode4(363103), // Rule ID 13632 //
     /* 363014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 363022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 363026 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 363037 */     // (strict_fmul:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 363037 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 363040 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 363044 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363049 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 363051 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 363054 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 363058 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363063 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 363066 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 363070 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 363073 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363078 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363083 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 363091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 363093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 363095 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363101 */     GIR_RootConstrainSelectedInstOperands,
     /* 363102 */     // GIR_Coverage, 13632,
     /* 363102 */     GIR_EraseRootFromParent_Done,
     /* 363103 */   // Label 7309: @363103
     /* 363103 */   GIM_Try, /*On fail goto*//*Label 7310*/ GIMT_Encode4(363197), // Rule ID 6154 //
     /* 363108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 363116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 363120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 363124 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 363131 */     // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 363131 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 363134 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 363138 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363143 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 363145 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 363148 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 363152 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363157 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 363160 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 363164 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 363167 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363172 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363177 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 363185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 363187 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 363189 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363195 */     GIR_RootConstrainSelectedInstOperands,
     /* 363196 */     // GIR_Coverage, 6154,
     /* 363196 */     GIR_EraseRootFromParent_Done,
     /* 363197 */   // Label 7310: @363197
     /* 363197 */   GIM_Try, /*On fail goto*//*Label 7311*/ GIMT_Encode4(363224), // Rule ID 1317 //
     /* 363202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 363205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363213 */     // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 363213 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 363218 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 363222 */     GIR_RootConstrainSelectedInstOperands,
     /* 363223 */     // GIR_Coverage, 1317,
     /* 363223 */     GIR_Done,
     /* 363224 */   // Label 7311: @363224
     /* 363224 */   GIM_Reject,
     /* 363225 */ // Label 7306: @363225
     /* 363225 */ GIM_Reject,
     /* 363226 */ // Label 7260: @363226
     /* 363226 */ GIM_Try, /*On fail goto*//*Label 7312*/ GIMT_Encode4(363657),
     /* 363231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 363234 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 363237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363241 */   GIM_Try, /*On fail goto*//*Label 7313*/ GIMT_Encode4(363304), // Rule ID 13166 //
     /* 363246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 363249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 363257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 363261 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 363265 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 363270 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 363274 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363278 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 363282 */     // MIs[2] Operand 1
     /* 363282 */     // No operand predicates
     /* 363282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363286 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363288 */     // (strict_fmul:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 363288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 363291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 363293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 363295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 363299 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 363302 */     GIR_RootConstrainSelectedInstOperands,
     /* 363303 */     // GIR_Coverage, 13166,
     /* 363303 */     GIR_EraseRootFromParent_Done,
     /* 363304 */   // Label 7313: @363304
     /* 363304 */   GIM_Try, /*On fail goto*//*Label 7314*/ GIMT_Encode4(363367), // Rule ID 1994 //
     /* 363309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 363312 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 363320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 363324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 363328 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 363332 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 363337 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 363341 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363345 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 363349 */     // MIs[2] Operand 1
     /* 363349 */     // No operand predicates
     /* 363349 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363351 */     // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 363351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 363354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 363356 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 363358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 363362 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 363365 */     GIR_RootConstrainSelectedInstOperands,
     /* 363366 */     // GIR_Coverage, 1994,
     /* 363366 */     GIR_EraseRootFromParent_Done,
     /* 363367 */   // Label 7314: @363367
     /* 363367 */   GIM_Try, /*On fail goto*//*Label 7315*/ GIMT_Encode4(363394), // Rule ID 1313 //
     /* 363372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 363375 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363383 */     // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 363383 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv8f16),
     /* 363388 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 363392 */     GIR_RootConstrainSelectedInstOperands,
     /* 363393 */     // GIR_Coverage, 1313,
     /* 363393 */     GIR_Done,
     /* 363394 */   // Label 7315: @363394
     /* 363394 */   GIM_Try, /*On fail goto*//*Label 7316*/ GIMT_Encode4(363656), // Rule ID 6917 //
     /* 363399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 363402 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363410 */     // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FMULv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FMULv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 363410 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 363413 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 363417 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363422 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 363426 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 363428 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 363431 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 363435 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363440 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 363444 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 363446 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 363449 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 363453 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363458 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 363461 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 363464 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 363466 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 363469 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363473 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363478 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 363484 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363489 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363494 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 363497 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 363501 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363506 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 363509 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 363511 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 363514 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363518 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363523 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 363529 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363534 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363539 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 363542 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 363546 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363551 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 363554 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 363556 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 363559 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 363563 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363568 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 363571 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 363574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 363576 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 363579 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 363583 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363588 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 363591 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 363593 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 363596 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 363600 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363605 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 363607 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 363610 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 363614 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363619 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 363622 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 363625 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 363628 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363633 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363638 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 363646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363648 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363651 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 363654 */     GIR_RootConstrainSelectedInstOperands,
     /* 363655 */     // GIR_Coverage, 6917,
     /* 363655 */     GIR_EraseRootFromParent_Done,
     /* 363656 */   // Label 7316: @363656
     /* 363656 */   GIM_Reject,
     /* 363657 */ // Label 7312: @363657
     /* 363657 */ GIM_Reject,
     /* 363658 */ // Label 7261: @363658
     /* 363658 */ GIM_Reject,
     /* 363659 */ // Label 101: @363659
     /* 363659 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7325*/ GIMT_Encode4(364274),
     /* 363670 */ /*GILLT_s16*//*Label 7317*/ GIMT_Encode4(363710),
     /* 363674 */ /*GILLT_s32*//*Label 7318*/ GIMT_Encode4(363748),
     /* 363678 */ /*GILLT_s64*//*Label 7319*/ GIMT_Encode4(363786), GIMT_Encode4(0),
     /* 363686 */ /*GILLT_v2s32*//*Label 7320*/ GIMT_Encode4(363824),
     /* 363690 */ /*GILLT_v2s64*//*Label 7321*/ GIMT_Encode4(363862),
     /* 363694 */ /*GILLT_v4s16*//*Label 7322*/ GIMT_Encode4(363900),
     /* 363698 */ /*GILLT_v4s32*//*Label 7323*/ GIMT_Encode4(363938), GIMT_Encode4(0),
     /* 363706 */ /*GILLT_v8s16*//*Label 7324*/ GIMT_Encode4(363976),
     /* 363710 */ // Label 7317: @363710
     /* 363710 */ GIM_Try, /*On fail goto*//*Label 7326*/ GIMT_Encode4(363747), // Rule ID 589 //
     /* 363715 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 363718 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 363721 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 363724 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363728 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363732 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363736 */   // (strict_fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FDIVHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 363736 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVHrr),
     /* 363741 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 363745 */   GIR_RootConstrainSelectedInstOperands,
     /* 363746 */   // GIR_Coverage, 589,
     /* 363746 */   GIR_Done,
     /* 363747 */ // Label 7326: @363747
     /* 363747 */ GIM_Reject,
     /* 363748 */ // Label 7318: @363748
     /* 363748 */ GIM_Try, /*On fail goto*//*Label 7327*/ GIMT_Encode4(363785), // Rule ID 591 //
     /* 363753 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 363756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 363759 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 363762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363766 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363770 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363774 */   // (strict_fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FDIVSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 363774 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVSrr),
     /* 363779 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 363783 */   GIR_RootConstrainSelectedInstOperands,
     /* 363784 */   // GIR_Coverage, 591,
     /* 363784 */   GIR_Done,
     /* 363785 */ // Label 7327: @363785
     /* 363785 */ GIM_Reject,
     /* 363786 */ // Label 7319: @363786
     /* 363786 */ GIM_Try, /*On fail goto*//*Label 7328*/ GIMT_Encode4(363823), // Rule ID 593 //
     /* 363791 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 363794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 363797 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 363800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363804 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363808 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363812 */   // (strict_fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FDIVDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 363812 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVDrr),
     /* 363817 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 363821 */   GIR_RootConstrainSelectedInstOperands,
     /* 363822 */   // GIR_Coverage, 593,
     /* 363822 */   GIR_Done,
     /* 363823 */ // Label 7328: @363823
     /* 363823 */ GIM_Reject,
     /* 363824 */ // Label 7320: @363824
     /* 363824 */ GIM_Try, /*On fail goto*//*Label 7329*/ GIMT_Encode4(363861), // Rule ID 1220 //
     /* 363829 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 363832 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 363835 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 363838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363842 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363846 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363850 */   // (strict_fdiv:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FDIVv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 363850 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f32),
     /* 363855 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 363859 */   GIR_RootConstrainSelectedInstOperands,
     /* 363860 */   // GIR_Coverage, 1220,
     /* 363860 */   GIR_Done,
     /* 363861 */ // Label 7329: @363861
     /* 363861 */ GIM_Reject,
     /* 363862 */ // Label 7321: @363862
     /* 363862 */ GIM_Try, /*On fail goto*//*Label 7330*/ GIMT_Encode4(363899), // Rule ID 1224 //
     /* 363867 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 363870 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 363873 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 363876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363880 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363884 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363888 */   // (strict_fdiv:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FDIVv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 363888 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f64),
     /* 363893 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 363897 */   GIR_RootConstrainSelectedInstOperands,
     /* 363898 */   // GIR_Coverage, 1224,
     /* 363898 */   GIR_Done,
     /* 363899 */ // Label 7330: @363899
     /* 363899 */ GIM_Reject,
     /* 363900 */ // Label 7322: @363900
     /* 363900 */ GIM_Try, /*On fail goto*//*Label 7331*/ GIMT_Encode4(363937), // Rule ID 1216 //
     /* 363905 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 363908 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 363911 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 363914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363918 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363922 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363926 */   // (strict_fdiv:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FDIVv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 363926 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f16),
     /* 363931 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 363935 */   GIR_RootConstrainSelectedInstOperands,
     /* 363936 */   // GIR_Coverage, 1216,
     /* 363936 */   GIR_Done,
     /* 363937 */ // Label 7331: @363937
     /* 363937 */ GIM_Reject,
     /* 363938 */ // Label 7323: @363938
     /* 363938 */ GIM_Try, /*On fail goto*//*Label 7332*/ GIMT_Encode4(363975), // Rule ID 1222 //
     /* 363943 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 363946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 363949 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 363952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363956 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363960 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363964 */   // (strict_fdiv:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FDIVv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 363964 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 363969 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 363973 */   GIR_RootConstrainSelectedInstOperands,
     /* 363974 */   // GIR_Coverage, 1222,
     /* 363974 */   GIR_Done,
     /* 363975 */ // Label 7332: @363975
     /* 363975 */ GIM_Reject,
     /* 363976 */ // Label 7324: @363976
     /* 363976 */ GIM_Try, /*On fail goto*//*Label 7333*/ GIMT_Encode4(364273),
     /* 363981 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 363984 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 363987 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363991 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363995 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363999 */   GIM_Try, /*On fail goto*//*Label 7334*/ GIMT_Encode4(364018), // Rule ID 1218 //
     /* 364004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 364007 */     // (strict_fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FDIVv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 364007 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv8f16),
     /* 364012 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 364016 */     GIR_RootConstrainSelectedInstOperands,
     /* 364017 */     // GIR_Coverage, 1218,
     /* 364017 */     GIR_Done,
     /* 364018 */   // Label 7334: @364018
     /* 364018 */   GIM_Try, /*On fail goto*//*Label 7335*/ GIMT_Encode4(364272), // Rule ID 6915 //
     /* 364023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 364026 */     // (strict_fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FDIVv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FDIVv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 364026 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 364029 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 364033 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364038 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 364042 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 364044 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 364047 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 364051 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364056 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 364060 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 364062 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 364065 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 364069 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364074 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 364077 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 364080 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 364082 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 364085 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364089 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364094 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 364100 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364105 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364110 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 364113 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 364117 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364122 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 364125 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 364127 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 364130 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364134 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364139 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 364145 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364150 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364155 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 364158 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 364162 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364167 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 364170 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 364172 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 364175 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 364179 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364184 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 364187 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 364190 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 364192 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 364195 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 364199 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364204 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 364207 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 364209 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 364212 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 364216 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364221 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 364223 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 364226 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 364230 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364235 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 364238 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 364241 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 364244 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364249 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364254 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 364262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364264 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364267 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 364270 */     GIR_RootConstrainSelectedInstOperands,
     /* 364271 */     // GIR_Coverage, 6915,
     /* 364271 */     GIR_EraseRootFromParent_Done,
     /* 364272 */   // Label 7335: @364272
     /* 364272 */   GIM_Reject,
     /* 364273 */ // Label 7333: @364273
     /* 364273 */ GIM_Reject,
     /* 364274 */ // Label 7325: @364274
     /* 364274 */ GIM_Reject,
     /* 364275 */ // Label 102: @364275
     /* 364275 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7344*/ GIMT_Encode4(379881),
     /* 364286 */ /*GILLT_s16*//*Label 7336*/ GIMT_Encode4(364326),
     /* 364290 */ /*GILLT_s32*//*Label 7337*/ GIMT_Encode4(367100),
     /* 364294 */ /*GILLT_s64*//*Label 7338*/ GIMT_Encode4(370030), GIMT_Encode4(0),
     /* 364302 */ /*GILLT_v2s32*//*Label 7339*/ GIMT_Encode4(372960),
     /* 364306 */ /*GILLT_v2s64*//*Label 7340*/ GIMT_Encode4(374481),
     /* 364310 */ /*GILLT_v4s16*//*Label 7341*/ GIMT_Encode4(376002),
     /* 364314 */ /*GILLT_v4s32*//*Label 7342*/ GIMT_Encode4(377181), GIMT_Encode4(0),
     /* 364322 */ /*GILLT_v8s16*//*Label 7343*/ GIMT_Encode4(378702),
     /* 364326 */ // Label 7336: @364326
     /* 364326 */ GIM_Try, /*On fail goto*//*Label 7345*/ GIMT_Encode4(367099),
     /* 364331 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 364334 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 364337 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 364340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364344 */   GIM_Try, /*On fail goto*//*Label 7346*/ GIMT_Encode4(364494), // Rule ID 4804 //
     /* 364349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 364352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 364360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 364364 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 364368 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364373 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 364377 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364381 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 364385 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 364389 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 364393 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364398 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 364402 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 364406 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 364410 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 364414 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364419 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 364421 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 364421 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 364424 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364428 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364433 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 364439 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364444 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364449 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 364452 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364456 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364461 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 364467 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364472 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 364480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 364482 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364485 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 364488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 364492 */     GIR_RootConstrainSelectedInstOperands,
     /* 364493 */     // GIR_Coverage, 4804,
     /* 364493 */     GIR_EraseRootFromParent_Done,
     /* 364494 */   // Label 7346: @364494
     /* 364494 */   GIM_Try, /*On fail goto*//*Label 7347*/ GIMT_Encode4(364641), // Rule ID 4768 //
     /* 364499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 364502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 364510 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 364514 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 364518 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364523 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 364527 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364531 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 364535 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 364539 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 364543 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 364547 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 364551 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 364555 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364560 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 364564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364568 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 364570 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 364570 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 364573 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364577 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364582 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 364588 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364593 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364598 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 364601 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364605 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364610 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 364616 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364621 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 364629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 364631 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364634 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 364637 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 364639 */     GIR_RootConstrainSelectedInstOperands,
     /* 364640 */     // GIR_Coverage, 4768,
     /* 364640 */     GIR_EraseRootFromParent_Done,
     /* 364641 */   // Label 7347: @364641
     /* 364641 */   GIM_Try, /*On fail goto*//*Label 7348*/ GIMT_Encode4(364788), // Rule ID 13574 //
     /* 364646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 364649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 364657 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 364661 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 364665 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 364669 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 364673 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 364677 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364682 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 364686 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 364690 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 364694 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 364698 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 364702 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364707 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 364711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364715 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 364717 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 364717 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 364720 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364724 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364729 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 364735 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364740 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364745 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 364748 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364752 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364757 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 364763 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364768 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 364776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 364778 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364781 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 364784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 364786 */     GIR_RootConstrainSelectedInstOperands,
     /* 364787 */     // GIR_Coverage, 13574,
     /* 364787 */     GIR_EraseRootFromParent_Done,
     /* 364788 */   // Label 7348: @364788
     /* 364788 */   GIM_Try, /*On fail goto*//*Label 7349*/ GIMT_Encode4(364919), // Rule ID 5984 //
     /* 364793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 364796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 364804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 364808 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 364812 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364817 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 364821 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364825 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 364829 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 364833 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 364837 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 364841 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 364845 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 364849 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 364854 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 364858 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364862 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 364866 */     // MIs[4] Operand 1
     /* 364866 */     // No operand predicates
     /* 364866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364870 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 364872 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 364872 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 364875 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364879 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364884 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 364890 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364895 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 364903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364905 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 364907 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 364914 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 364917 */     GIR_RootConstrainSelectedInstOperands,
     /* 364918 */     // GIR_Coverage, 5984,
     /* 364918 */     GIR_EraseRootFromParent_Done,
     /* 364919 */   // Label 7349: @364919
     /* 364919 */   GIM_Try, /*On fail goto*//*Label 7350*/ GIMT_Encode4(365050), // Rule ID 6016 //
     /* 364924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 364927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 364935 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 364939 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 364943 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 364948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 364952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364956 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 364960 */     // MIs[2] Operand 1
     /* 364960 */     // No operand predicates
     /* 364960 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 364964 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 364968 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 364972 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 364976 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 364980 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 364984 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 364988 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364993 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 364997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365001 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 365003 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 365003 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 365006 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365010 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365015 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 365021 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365026 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 365034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365036 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 365038 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 365045 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 365048 */     GIR_RootConstrainSelectedInstOperands,
     /* 365049 */     // GIR_Coverage, 6016,
     /* 365049 */     GIR_EraseRootFromParent_Done,
     /* 365050 */   // Label 7350: @365050
     /* 365050 */   GIM_Try, /*On fail goto*//*Label 7351*/ GIMT_Encode4(365181), // Rule ID 6080 //
     /* 365055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 365058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 365066 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 365070 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 365074 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365078 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 365082 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 365086 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365091 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 365095 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 365099 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365103 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 365107 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 365111 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 365116 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 365120 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365124 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 365128 */     // MIs[4] Operand 1
     /* 365128 */     // No operand predicates
     /* 365128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365132 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 365134 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 365134 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 365137 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365141 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365146 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 365152 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365157 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 365165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365167 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 365169 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 365176 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 365179 */     GIR_RootConstrainSelectedInstOperands,
     /* 365180 */     // GIR_Coverage, 6080,
     /* 365180 */     GIR_EraseRootFromParent_Done,
     /* 365181 */   // Label 7351: @365181
     /* 365181 */   GIM_Try, /*On fail goto*//*Label 7352*/ GIMT_Encode4(365312), // Rule ID 6048 //
     /* 365186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 365189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 365197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 365201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 365205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365209 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 365213 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 365217 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 365222 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 365226 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365230 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 365234 */     // MIs[3] Operand 1
     /* 365234 */     // No operand predicates
     /* 365234 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 365238 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365242 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 365246 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 365250 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365255 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 365259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365263 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 365265 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 365265 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 365268 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365272 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365277 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 365283 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365288 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 365296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365298 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 365300 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 365307 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 365310 */     GIR_RootConstrainSelectedInstOperands,
     /* 365311 */     // GIR_Coverage, 6048,
     /* 365311 */     GIR_EraseRootFromParent_Done,
     /* 365312 */   // Label 7352: @365312
     /* 365312 */   GIM_Try, /*On fail goto*//*Label 7353*/ GIMT_Encode4(365447), // Rule ID 2446 //
     /* 365317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 365320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 365332 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365336 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365341 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 365345 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365349 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365353 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 365357 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 365361 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365366 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 365370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365374 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365376 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 365376 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 365379 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365383 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365388 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 365394 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365399 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365404 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 365407 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365411 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365416 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 365422 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365427 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 365435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 365437 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365440 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 365443 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 365445 */     GIR_RootConstrainSelectedInstOperands,
     /* 365446 */     // GIR_Coverage, 2446,
     /* 365446 */     GIR_EraseRootFromParent_Done,
     /* 365447 */   // Label 7353: @365447
     /* 365447 */   GIM_Try, /*On fail goto*//*Label 7354*/ GIMT_Encode4(365566), // Rule ID 5952 //
     /* 365452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 365455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365463 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 365467 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365471 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365476 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 365480 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365484 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365488 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 365492 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 365496 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 365501 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 365505 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365509 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 365513 */     // MIs[3] Operand 1
     /* 365513 */     // No operand predicates
     /* 365513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365517 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 365519 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 365519 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 365522 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365526 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365531 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 365537 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365542 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 365550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365552 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 365554 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 365561 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 365564 */     GIR_RootConstrainSelectedInstOperands,
     /* 365565 */     // GIR_Coverage, 5952,
     /* 365565 */     GIR_EraseRootFromParent_Done,
     /* 365566 */   // Label 7354: @365566
     /* 365566 */   GIM_Try, /*On fail goto*//*Label 7355*/ GIMT_Encode4(365685), // Rule ID 2528 //
     /* 365571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 365574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365582 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 365586 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365590 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 365595 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 365599 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365603 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 365607 */     // MIs[2] Operand 1
     /* 365607 */     // No operand predicates
     /* 365607 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 365611 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365615 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 365619 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 365623 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365628 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 365632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365636 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 365638 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 365638 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 365641 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365645 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365650 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 365656 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365661 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 365669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365671 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 365673 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 365680 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 365683 */     GIR_RootConstrainSelectedInstOperands,
     /* 365684 */     // GIR_Coverage, 2528,
     /* 365684 */     GIR_EraseRootFromParent_Done,
     /* 365685 */   // Label 7355: @365685
     /* 365685 */   GIM_Try, /*On fail goto*//*Label 7356*/ GIMT_Encode4(365785), // Rule ID 4766 //
     /* 365690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 365693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365701 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 365705 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365709 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365714 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 365718 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365722 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 365726 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 365730 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365739 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365741 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 365741 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 365744 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365748 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365753 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 365759 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365764 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 365772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 365774 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365777 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 365781 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 365783 */     GIR_RootConstrainSelectedInstOperands,
     /* 365784 */     // GIR_Coverage, 4766,
     /* 365784 */     GIR_EraseRootFromParent_Done,
     /* 365785 */   // Label 7356: @365785
     /* 365785 */   GIM_Try, /*On fail goto*//*Label 7357*/ GIMT_Encode4(365885), // Rule ID 4802 //
     /* 365790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 365793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365801 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 365805 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365809 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365814 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 365818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365822 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 365826 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 365830 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 365834 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365839 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365841 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 365841 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 365844 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365848 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365853 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 365859 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365864 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 365872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 365874 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 365879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 365883 */     GIR_RootConstrainSelectedInstOperands,
     /* 365884 */     // GIR_Coverage, 4802,
     /* 365884 */     GIR_EraseRootFromParent_Done,
     /* 365885 */   // Label 7357: @365885
     /* 365885 */   GIM_Try, /*On fail goto*//*Label 7358*/ GIMT_Encode4(365982), // Rule ID 13570 //
     /* 365890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 365893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 365901 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 365905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 365909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365913 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 365917 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 365921 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365926 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 365930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365938 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365940 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 365940 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 365943 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365947 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365952 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 365958 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365963 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 365971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 365973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 365975 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365978 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 365980 */     GIR_RootConstrainSelectedInstOperands,
     /* 365981 */     // GIR_Coverage, 13570,
     /* 365981 */     GIR_EraseRootFromParent_Done,
     /* 365982 */   // Label 7358: @365982
     /* 365982 */   GIM_Try, /*On fail goto*//*Label 7359*/ GIMT_Encode4(366082), // Rule ID 13572 //
     /* 365987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 365990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 365998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 366002 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366007 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 366011 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 366015 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 366019 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 366023 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366028 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 366032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366036 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366038 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 366038 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 366041 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366045 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366050 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 366056 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366061 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 366069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 366071 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 366078 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 366080 */     GIR_RootConstrainSelectedInstOperands,
     /* 366081 */     // GIR_Coverage, 13572,
     /* 366081 */     GIR_EraseRootFromParent_Done,
     /* 366082 */   // Label 7359: @366082
     /* 366082 */   GIM_Try, /*On fail goto*//*Label 7360*/ GIMT_Encode4(366182), // Rule ID 4800 //
     /* 366087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 366090 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 366102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 366106 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 366110 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366115 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 366119 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 366123 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 366127 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 366131 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366136 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366138 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 366138 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 366141 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366145 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366150 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 366156 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366161 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 366169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 366171 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 366173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 366180 */     GIR_RootConstrainSelectedInstOperands,
     /* 366181 */     // GIR_Coverage, 4800,
     /* 366181 */     GIR_EraseRootFromParent_Done,
     /* 366182 */   // Label 7360: @366182
     /* 366182 */   GIM_Try, /*On fail goto*//*Label 7361*/ GIMT_Encode4(366279), // Rule ID 4764 //
     /* 366187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 366190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 366202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 366206 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 366210 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 366214 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 366218 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 366222 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366227 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 366231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366235 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366237 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 366237 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 366240 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366244 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366249 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 366255 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366260 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 366268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 366270 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 366272 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366275 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 366277 */     GIR_RootConstrainSelectedInstOperands,
     /* 366278 */     // GIR_Coverage, 4764,
     /* 366278 */     GIR_EraseRootFromParent_Done,
     /* 366279 */   // Label 7361: @366279
     /* 366279 */   GIM_Try, /*On fail goto*//*Label 7362*/ GIMT_Encode4(366363), // Rule ID 6014 //
     /* 366284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 366287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 366295 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 366299 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 366303 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 366308 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 366312 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366316 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 366320 */     // MIs[2] Operand 1
     /* 366320 */     // No operand predicates
     /* 366320 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 366324 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 366328 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 366332 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366341 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 366343 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 366343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 366346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366348 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 366350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 366354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 366358 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 366361 */     GIR_RootConstrainSelectedInstOperands,
     /* 366362 */     // GIR_Coverage, 6014,
     /* 366362 */     GIR_EraseRootFromParent_Done,
     /* 366363 */   // Label 7362: @366363
     /* 366363 */   GIM_Try, /*On fail goto*//*Label 7363*/ GIMT_Encode4(366444), // Rule ID 6046 //
     /* 366368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 366371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 366379 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 366383 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 366387 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 366391 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 366395 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 366399 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 366404 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 366408 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366412 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 366416 */     // MIs[3] Operand 1
     /* 366416 */     // No operand predicates
     /* 366416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366424 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 366426 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 366426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 366429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366431 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 366433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 366435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 366439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 366442 */     GIR_RootConstrainSelectedInstOperands,
     /* 366443 */     // GIR_Coverage, 6046,
     /* 366443 */     GIR_EraseRootFromParent_Done,
     /* 366444 */   // Label 7363: @366444
     /* 366444 */   GIM_Try, /*On fail goto*//*Label 7364*/ GIMT_Encode4(366528), // Rule ID 6078 //
     /* 366449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 366452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 366460 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 366464 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366469 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 366473 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 366477 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 366481 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 366485 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 366490 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 366494 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366498 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 366502 */     // MIs[3] Operand 1
     /* 366502 */     // No operand predicates
     /* 366502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366506 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 366508 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 366508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 366511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366513 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 366515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 366519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 366523 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 366526 */     GIR_RootConstrainSelectedInstOperands,
     /* 366527 */     // GIR_Coverage, 6078,
     /* 366527 */     GIR_EraseRootFromParent_Done,
     /* 366528 */   // Label 7364: @366528
     /* 366528 */   GIM_Try, /*On fail goto*//*Label 7365*/ GIMT_Encode4(366609), // Rule ID 5982 //
     /* 366533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 366536 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 366548 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 366552 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 366556 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 366560 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 366564 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 366568 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 366573 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 366577 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366581 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 366585 */     // MIs[3] Operand 1
     /* 366585 */     // No operand predicates
     /* 366585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366589 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 366591 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 366591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 366594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366596 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 366598 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 366600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 366604 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 366607 */     GIR_RootConstrainSelectedInstOperands,
     /* 366608 */     // GIR_Coverage, 5982,
     /* 366608 */     GIR_EraseRootFromParent_Done,
     /* 366609 */   // Label 7365: @366609
     /* 366609 */   GIM_Try, /*On fail goto*//*Label 7366*/ GIMT_Encode4(366694), // Rule ID 2444 //
     /* 366614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 366617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 366625 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 366629 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 366633 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366638 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 366642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366650 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 366652 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 366652 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 366655 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366659 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366664 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 366670 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366675 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 366683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 366685 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366688 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 366690 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 366692 */     GIR_RootConstrainSelectedInstOperands,
     /* 366693 */     // GIR_Coverage, 2444,
     /* 366693 */     GIR_EraseRootFromParent_Done,
     /* 366694 */   // Label 7366: @366694
     /* 366694 */   GIM_Try, /*On fail goto*//*Label 7367*/ GIMT_Encode4(366779), // Rule ID 2442 //
     /* 366699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 366702 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 366714 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 366718 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 366722 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366727 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 366731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 366737 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 366737 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 366740 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366744 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366749 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 366755 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366760 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 366768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 366770 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 366772 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366775 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 366777 */     GIR_RootConstrainSelectedInstOperands,
     /* 366778 */     // GIR_Coverage, 2442,
     /* 366778 */     GIR_EraseRootFromParent_Done,
     /* 366779 */   // Label 7367: @366779
     /* 366779 */   GIM_Try, /*On fail goto*//*Label 7368*/ GIMT_Encode4(366848), // Rule ID 2526 //
     /* 366784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 366787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 366795 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 366799 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 366803 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 366808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 366812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366816 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 366820 */     // MIs[2] Operand 1
     /* 366820 */     // No operand predicates
     /* 366820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366828 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366830 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 366830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 366833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366835 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 366837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 366839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 366843 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 366846 */     GIR_RootConstrainSelectedInstOperands,
     /* 366847 */     // GIR_Coverage, 2526,
     /* 366847 */     GIR_EraseRootFromParent_Done,
     /* 366848 */   // Label 7368: @366848
     /* 366848 */   GIM_Try, /*On fail goto*//*Label 7369*/ GIMT_Encode4(366917), // Rule ID 5950 //
     /* 366853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 366856 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 366868 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 366872 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 366876 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 366881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 366885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366889 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 366893 */     // MIs[2] Operand 1
     /* 366893 */     // No operand predicates
     /* 366893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366897 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366899 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 366899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 366902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366904 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 366906 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 366908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 366912 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 366915 */     GIR_RootConstrainSelectedInstOperands,
     /* 366916 */     // GIR_Coverage, 5950,
     /* 366916 */     GIR_EraseRootFromParent_Done,
     /* 366917 */   // Label 7369: @366917
     /* 366917 */   GIM_Try, /*On fail goto*//*Label 7370*/ GIMT_Encode4(366967), // Rule ID 13016 //
     /* 366922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 366925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 366933 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 366937 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 366952 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 366952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 366955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 366957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 366959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 366963 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 366965 */     GIR_RootConstrainSelectedInstOperands,
     /* 366966 */     // GIR_Coverage, 13016,
     /* 366966 */     GIR_EraseRootFromParent_Done,
     /* 366967 */   // Label 7370: @366967
     /* 366967 */   GIM_Try, /*On fail goto*//*Label 7371*/ GIMT_Encode4(367017), // Rule ID 643 //
     /* 366972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 366975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 366987 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 366991 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 367002 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 367002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 367005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 367007 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 367009 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 367013 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 367015 */     GIR_RootConstrainSelectedInstOperands,
     /* 367016 */     // GIR_Coverage, 643,
     /* 367016 */     GIR_EraseRootFromParent_Done,
     /* 367017 */   // Label 7371: @367017
     /* 367017 */   GIM_Try, /*On fail goto*//*Label 7372*/ GIMT_Encode4(367067), // Rule ID 655 //
     /* 367022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 367025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 367037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 367041 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 367045 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367050 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 367052 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 367052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 367055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 367057 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 367059 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 367061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 367065 */     GIR_RootConstrainSelectedInstOperands,
     /* 367066 */     // GIR_Coverage, 655,
     /* 367066 */     GIR_EraseRootFromParent_Done,
     /* 367067 */   // Label 7372: @367067
     /* 367067 */   GIM_Try, /*On fail goto*//*Label 7373*/ GIMT_Encode4(367098), // Rule ID 637 //
     /* 367072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 367075 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367087 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 367087 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 367092 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 367096 */     GIR_RootConstrainSelectedInstOperands,
     /* 367097 */     // GIR_Coverage, 637,
     /* 367097 */     GIR_Done,
     /* 367098 */   // Label 7373: @367098
     /* 367098 */   GIM_Reject,
     /* 367099 */ // Label 7345: @367099
     /* 367099 */ GIM_Reject,
     /* 367100 */ // Label 7337: @367100
     /* 367100 */ GIM_Try, /*On fail goto*//*Label 7374*/ GIMT_Encode4(370029),
     /* 367105 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 367108 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 367111 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 367114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367118 */   GIM_Try, /*On fail goto*//*Label 7375*/ GIMT_Encode4(367268), // Rule ID 4810 //
     /* 367123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 367126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367134 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 367138 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 367142 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367147 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 367151 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367155 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367159 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 367163 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 367167 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367172 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 367176 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 367180 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 367184 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 367188 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367193 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 367195 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 367195 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 367198 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 367202 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367207 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 367213 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367218 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367223 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 367226 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 367230 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367235 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 367241 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367246 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 367254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 367256 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367259 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 367262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 367266 */     GIR_RootConstrainSelectedInstOperands,
     /* 367267 */     // GIR_Coverage, 4810,
     /* 367267 */     GIR_EraseRootFromParent_Done,
     /* 367268 */   // Label 7375: @367268
     /* 367268 */   GIM_Try, /*On fail goto*//*Label 7376*/ GIMT_Encode4(367415), // Rule ID 4774 //
     /* 367273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 367276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 367288 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 367292 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367297 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 367301 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367305 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 367309 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 367313 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 367317 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367321 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 367325 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 367329 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367334 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 367338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367342 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 367344 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 367344 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 367347 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 367351 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367356 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 367362 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367367 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367372 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 367375 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 367379 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367384 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 367390 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367395 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 367403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 367405 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367408 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 367411 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 367413 */     GIR_RootConstrainSelectedInstOperands,
     /* 367414 */     // GIR_Coverage, 4774,
     /* 367414 */     GIR_EraseRootFromParent_Done,
     /* 367415 */   // Label 7376: @367415
     /* 367415 */   GIM_Try, /*On fail goto*//*Label 7377*/ GIMT_Encode4(367562), // Rule ID 13580 //
     /* 367420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 367423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 367431 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 367435 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 367439 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367443 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 367447 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 367451 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367456 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 367460 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 367464 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367468 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 367472 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 367476 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367481 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 367485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367489 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 367491 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 367491 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 367494 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 367498 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367503 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 367509 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367514 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367519 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 367522 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 367526 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367531 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 367537 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367542 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 367550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 367552 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367555 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 367558 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 367560 */     GIR_RootConstrainSelectedInstOperands,
     /* 367561 */     // GIR_Coverage, 13580,
     /* 367561 */     GIR_EraseRootFromParent_Done,
     /* 367562 */   // Label 7377: @367562
     /* 367562 */   GIM_Try, /*On fail goto*//*Label 7378*/ GIMT_Encode4(367693), // Rule ID 6000 //
     /* 367567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 367570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367578 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 367582 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 367586 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367591 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 367595 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367599 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 367603 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 367607 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 367611 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367615 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 367619 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 367623 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367628 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 367632 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367636 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 367640 */     // MIs[4] Operand 1
     /* 367640 */     // No operand predicates
     /* 367640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367644 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 367646 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 367646 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 367649 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 367653 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367658 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 367664 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367669 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 367677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367679 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 367681 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 367688 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 367691 */     GIR_RootConstrainSelectedInstOperands,
     /* 367692 */     // GIR_Coverage, 6000,
     /* 367692 */     GIR_EraseRootFromParent_Done,
     /* 367693 */   // Label 7378: @367693
     /* 367693 */   GIM_Try, /*On fail goto*//*Label 7379*/ GIMT_Encode4(367824), // Rule ID 6032 //
     /* 367698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 367701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367709 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 367713 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 367717 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367722 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 367726 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367730 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 367734 */     // MIs[2] Operand 1
     /* 367734 */     // No operand predicates
     /* 367734 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 367738 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 367742 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 367746 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 367750 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367754 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 367758 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 367762 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367767 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 367771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367775 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 367777 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 367777 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 367780 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 367784 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367789 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 367795 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367800 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 367808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367810 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 367812 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 367819 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 367822 */     GIR_RootConstrainSelectedInstOperands,
     /* 367823 */     // GIR_Coverage, 6032,
     /* 367823 */     GIR_EraseRootFromParent_Done,
     /* 367824 */   // Label 7379: @367824
     /* 367824 */   GIM_Try, /*On fail goto*//*Label 7380*/ GIMT_Encode4(367955), // Rule ID 6096 //
     /* 367829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 367832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 367840 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 367844 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 367848 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367852 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 367856 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 367860 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367865 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 367869 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 367873 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367877 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 367881 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 367885 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367890 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 367894 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367898 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 367902 */     // MIs[4] Operand 1
     /* 367902 */     // No operand predicates
     /* 367902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367906 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 367908 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 367908 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 367911 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 367915 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367920 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 367926 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367931 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 367939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367941 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 367943 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 367950 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 367953 */     GIR_RootConstrainSelectedInstOperands,
     /* 367954 */     // GIR_Coverage, 6096,
     /* 367954 */     GIR_EraseRootFromParent_Done,
     /* 367955 */   // Label 7380: @367955
     /* 367955 */   GIM_Try, /*On fail goto*//*Label 7381*/ GIMT_Encode4(368086), // Rule ID 6064 //
     /* 367960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 367963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 367971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 367975 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 367979 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367983 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 367987 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 367991 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367996 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 368000 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368004 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 368008 */     // MIs[3] Operand 1
     /* 368008 */     // No operand predicates
     /* 368008 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 368012 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368016 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368020 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 368024 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368029 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 368033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368037 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 368039 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 368039 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 368042 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368046 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368051 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 368057 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368062 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 368070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368072 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 368074 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 368081 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 368084 */     GIR_RootConstrainSelectedInstOperands,
     /* 368085 */     // GIR_Coverage, 6064,
     /* 368085 */     GIR_EraseRootFromParent_Done,
     /* 368086 */   // Label 7381: @368086
     /* 368086 */   GIM_Try, /*On fail goto*//*Label 7382*/ GIMT_Encode4(368221), // Rule ID 2452 //
     /* 368091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 368094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368106 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368110 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368115 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 368119 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 368123 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368127 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368131 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 368135 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368140 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 368144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368148 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368150 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 368150 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 368153 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368157 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368162 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 368168 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368173 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368178 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 368181 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368185 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368190 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 368196 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368201 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 368209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 368211 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368214 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 368217 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 368219 */     GIR_RootConstrainSelectedInstOperands,
     /* 368220 */     // GIR_Coverage, 2452,
     /* 368220 */     GIR_EraseRootFromParent_Done,
     /* 368221 */   // Label 7382: @368221
     /* 368221 */   GIM_Try, /*On fail goto*//*Label 7383*/ GIMT_Encode4(368340), // Rule ID 5968 //
     /* 368226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 368229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368241 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368245 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368250 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 368254 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 368258 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368262 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368266 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 368270 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368275 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 368279 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368283 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 368287 */     // MIs[3] Operand 1
     /* 368287 */     // No operand predicates
     /* 368287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368291 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 368293 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 368293 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 368296 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368300 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368305 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 368311 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368316 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 368324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368326 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 368328 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 368335 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 368338 */     GIR_RootConstrainSelectedInstOperands,
     /* 368339 */     // GIR_Coverage, 5968,
     /* 368339 */     GIR_EraseRootFromParent_Done,
     /* 368340 */   // Label 7383: @368340
     /* 368340 */   GIM_Try, /*On fail goto*//*Label 7384*/ GIMT_Encode4(368459), // Rule ID 2544 //
     /* 368345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 368348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368356 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368360 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368364 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368369 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 368373 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368377 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 368381 */     // MIs[2] Operand 1
     /* 368381 */     // No operand predicates
     /* 368381 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 368385 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368389 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368393 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 368397 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368402 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 368406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368410 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 368412 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 368412 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 368415 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368419 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368424 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 368430 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368435 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 368443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368445 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 368447 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 368454 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 368457 */     GIR_RootConstrainSelectedInstOperands,
     /* 368458 */     // GIR_Coverage, 2544,
     /* 368458 */     GIR_EraseRootFromParent_Done,
     /* 368459 */   // Label 7384: @368459
     /* 368459 */   GIM_Try, /*On fail goto*//*Label 7385*/ GIMT_Encode4(368559), // Rule ID 4772 //
     /* 368464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 368467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368479 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368483 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368488 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 368492 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 368496 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 368500 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 368504 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368513 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368515 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 368515 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 368518 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368522 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368527 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 368533 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368538 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 368546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 368548 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 368555 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 368557 */     GIR_RootConstrainSelectedInstOperands,
     /* 368558 */     // GIR_Coverage, 4772,
     /* 368558 */     GIR_EraseRootFromParent_Done,
     /* 368559 */   // Label 7385: @368559
     /* 368559 */   GIM_Try, /*On fail goto*//*Label 7386*/ GIMT_Encode4(368659), // Rule ID 4808 //
     /* 368564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 368567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368579 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368583 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368588 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 368592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368596 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 368600 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 368604 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 368608 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368613 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368615 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 368615 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 368618 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368622 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368627 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 368633 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368638 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 368646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 368648 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368651 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 368653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 368657 */     GIR_RootConstrainSelectedInstOperands,
     /* 368658 */     // GIR_Coverage, 4808,
     /* 368658 */     GIR_EraseRootFromParent_Done,
     /* 368659 */   // Label 7386: @368659
     /* 368659 */   GIM_Try, /*On fail goto*//*Label 7387*/ GIMT_Encode4(368756), // Rule ID 13576 //
     /* 368664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 368667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 368675 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 368679 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 368683 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368687 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368691 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 368695 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368700 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 368704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368712 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368714 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 368714 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 368717 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368721 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368726 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 368732 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368737 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 368745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 368747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 368749 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368752 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 368754 */     GIR_RootConstrainSelectedInstOperands,
     /* 368755 */     // GIR_Coverage, 13576,
     /* 368755 */     GIR_EraseRootFromParent_Done,
     /* 368756 */   // Label 7387: @368756
     /* 368756 */   GIM_Try, /*On fail goto*//*Label 7388*/ GIMT_Encode4(368856), // Rule ID 13578 //
     /* 368761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 368764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 368772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 368776 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368781 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 368785 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368789 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368793 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 368797 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368802 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 368806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368810 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368812 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 368812 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 368815 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368819 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368824 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 368830 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368835 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 368843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 368845 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 368852 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 368854 */     GIR_RootConstrainSelectedInstOperands,
     /* 368855 */     // GIR_Coverage, 13578,
     /* 368855 */     GIR_EraseRootFromParent_Done,
     /* 368856 */   // Label 7388: @368856
     /* 368856 */   GIM_Try, /*On fail goto*//*Label 7389*/ GIMT_Encode4(368956), // Rule ID 4806 //
     /* 368861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 368864 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 368872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368880 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368884 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368889 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 368893 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 368897 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 368901 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 368905 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368910 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368912 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 368912 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 368915 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368919 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368924 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 368930 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368935 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 368943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 368945 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 368947 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 368954 */     GIR_RootConstrainSelectedInstOperands,
     /* 368955 */     // GIR_Coverage, 4806,
     /* 368955 */     GIR_EraseRootFromParent_Done,
     /* 368956 */   // Label 7389: @368956
     /* 368956 */   GIM_Try, /*On fail goto*//*Label 7390*/ GIMT_Encode4(369053), // Rule ID 4770 //
     /* 368961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 368964 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 368972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 368976 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 368980 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 368984 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368988 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368992 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 368996 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369001 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 369005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369009 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369011 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 369011 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 369014 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 369018 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369023 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 369029 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369034 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 369042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 369044 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 369046 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369049 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 369051 */     GIR_RootConstrainSelectedInstOperands,
     /* 369052 */     // GIR_Coverage, 4770,
     /* 369052 */     GIR_EraseRootFromParent_Done,
     /* 369053 */   // Label 7390: @369053
     /* 369053 */   GIM_Try, /*On fail goto*//*Label 7391*/ GIMT_Encode4(369131), // Rule ID 6118 //
     /* 369058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369066 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 369070 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 369074 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 369078 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 369082 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 369086 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369091 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 369095 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369099 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 369103 */     // MIs[3] Operand 1
     /* 369103 */     // No operand predicates
     /* 369103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369111 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 369113 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 369113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 369116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369118 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 369120 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 369122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 369126 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 369129 */     GIR_RootConstrainSelectedInstOperands,
     /* 369130 */     // GIR_Coverage, 6118,
     /* 369130 */     GIR_EraseRootFromParent_Done,
     /* 369131 */   // Label 7391: @369131
     /* 369131 */   GIM_Try, /*On fail goto*//*Label 7392*/ GIMT_Encode4(369215), // Rule ID 6030 //
     /* 369136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 369139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 369151 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 369155 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369160 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 369164 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369168 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 369172 */     // MIs[2] Operand 1
     /* 369172 */     // No operand predicates
     /* 369172 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 369176 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 369180 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 369184 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369193 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 369195 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 369195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 369198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 369202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 369206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 369210 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 369213 */     GIR_RootConstrainSelectedInstOperands,
     /* 369214 */     // GIR_Coverage, 6030,
     /* 369214 */     GIR_EraseRootFromParent_Done,
     /* 369215 */   // Label 7392: @369215
     /* 369215 */   GIM_Try, /*On fail goto*//*Label 7393*/ GIMT_Encode4(369296), // Rule ID 6062 //
     /* 369220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 369223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 369231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 369235 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 369239 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369243 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 369247 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 369251 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369256 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 369260 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369264 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 369268 */     // MIs[3] Operand 1
     /* 369268 */     // No operand predicates
     /* 369268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369276 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 369278 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 369278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 369281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369283 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 369285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 369287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 369291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 369294 */     GIR_RootConstrainSelectedInstOperands,
     /* 369295 */     // GIR_Coverage, 6062,
     /* 369295 */     GIR_EraseRootFromParent_Done,
     /* 369296 */   // Label 7393: @369296
     /* 369296 */   GIM_Try, /*On fail goto*//*Label 7394*/ GIMT_Encode4(369380), // Rule ID 6094 //
     /* 369301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 369304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 369312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 369316 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369321 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 369325 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369329 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 369333 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 369337 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369342 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 369346 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369350 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 369354 */     // MIs[3] Operand 1
     /* 369354 */     // No operand predicates
     /* 369354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369358 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 369360 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 369360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 369363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369365 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 369367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 369371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 369375 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 369378 */     GIR_RootConstrainSelectedInstOperands,
     /* 369379 */     // GIR_Coverage, 6094,
     /* 369379 */     GIR_EraseRootFromParent_Done,
     /* 369380 */   // Label 7394: @369380
     /* 369380 */   GIM_Try, /*On fail goto*//*Label 7395*/ GIMT_Encode4(369458), // Rule ID 6140 //
     /* 369385 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 369393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 369401 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 369405 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 369409 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 369413 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 369417 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369422 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 369426 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369430 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 369434 */     // MIs[3] Operand 1
     /* 369434 */     // No operand predicates
     /* 369434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369438 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 369440 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 369440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 369443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369445 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 369447 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 369449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 369453 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 369456 */     GIR_RootConstrainSelectedInstOperands,
     /* 369457 */     // GIR_Coverage, 6140,
     /* 369457 */     GIR_EraseRootFromParent_Done,
     /* 369458 */   // Label 7395: @369458
     /* 369458 */   GIM_Try, /*On fail goto*//*Label 7396*/ GIMT_Encode4(369539), // Rule ID 5998 //
     /* 369463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 369466 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 369474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 369478 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 369482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 369486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369490 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 369494 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 369498 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369503 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 369507 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369511 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 369515 */     // MIs[3] Operand 1
     /* 369515 */     // No operand predicates
     /* 369515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369519 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 369521 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 369521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 369524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369526 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 369528 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 369530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 369534 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 369537 */     GIR_RootConstrainSelectedInstOperands,
     /* 369538 */     // GIR_Coverage, 5998,
     /* 369538 */     GIR_EraseRootFromParent_Done,
     /* 369539 */   // Label 7396: @369539
     /* 369539 */   GIM_Try, /*On fail goto*//*Label 7397*/ GIMT_Encode4(369624), // Rule ID 2450 //
     /* 369544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 369547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369555 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 369559 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 369563 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369568 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 369572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369580 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 369582 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 369582 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 369585 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 369589 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369594 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 369600 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369605 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 369613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 369615 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 369620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 369622 */     GIR_RootConstrainSelectedInstOperands,
     /* 369623 */     // GIR_Coverage, 2450,
     /* 369623 */     GIR_EraseRootFromParent_Done,
     /* 369624 */   // Label 7397: @369624
     /* 369624 */   GIM_Try, /*On fail goto*//*Label 7398*/ GIMT_Encode4(369709), // Rule ID 2448 //
     /* 369629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 369632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 369640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369644 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 369648 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 369652 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369657 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 369661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 369667 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 369667 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 369670 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 369674 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369679 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 369685 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369690 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 369698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 369700 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 369702 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 369707 */     GIR_RootConstrainSelectedInstOperands,
     /* 369708 */     // GIR_Coverage, 2448,
     /* 369708 */     GIR_EraseRootFromParent_Done,
     /* 369709 */   // Label 7398: @369709
     /* 369709 */   GIM_Try, /*On fail goto*//*Label 7399*/ GIMT_Encode4(369778), // Rule ID 2542 //
     /* 369714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 369717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 369729 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 369733 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369738 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 369742 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369746 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 369750 */     // MIs[2] Operand 1
     /* 369750 */     // No operand predicates
     /* 369750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369758 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369760 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 369760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 369763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369765 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 369767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 369769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 369773 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 369776 */     GIR_RootConstrainSelectedInstOperands,
     /* 369777 */     // GIR_Coverage, 2542,
     /* 369777 */     GIR_EraseRootFromParent_Done,
     /* 369778 */   // Label 7399: @369778
     /* 369778 */   GIM_Try, /*On fail goto*//*Label 7400*/ GIMT_Encode4(369847), // Rule ID 5966 //
     /* 369783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 369786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 369794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369798 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 369802 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 369806 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369811 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 369815 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369819 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 369823 */     // MIs[2] Operand 1
     /* 369823 */     // No operand predicates
     /* 369823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369827 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369829 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 369829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 369832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369834 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 369836 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 369838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 369842 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 369845 */     GIR_RootConstrainSelectedInstOperands,
     /* 369846 */     // GIR_Coverage, 5966,
     /* 369846 */     GIR_EraseRootFromParent_Done,
     /* 369847 */   // Label 7400: @369847
     /* 369847 */   GIM_Try, /*On fail goto*//*Label 7401*/ GIMT_Encode4(369897), // Rule ID 13018 //
     /* 369852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 369855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 369863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 369867 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369880 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 369882 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 369882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 369885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 369887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 369889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 369893 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 369895 */     GIR_RootConstrainSelectedInstOperands,
     /* 369896 */     // GIR_Coverage, 13018,
     /* 369896 */     GIR_EraseRootFromParent_Done,
     /* 369897 */   // Label 7401: @369897
     /* 369897 */   GIM_Try, /*On fail goto*//*Label 7402*/ GIMT_Encode4(369947), // Rule ID 645 //
     /* 369902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 369905 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 369913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 369917 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 369921 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369930 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 369932 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 369932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 369935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 369937 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 369939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 369943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 369945 */     GIR_RootConstrainSelectedInstOperands,
     /* 369946 */     // GIR_Coverage, 645,
     /* 369946 */     GIR_EraseRootFromParent_Done,
     /* 369947 */   // Label 7402: @369947
     /* 369947 */   GIM_Try, /*On fail goto*//*Label 7403*/ GIMT_Encode4(369997), // Rule ID 657 //
     /* 369952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 369955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 369967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 369971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 369975 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369980 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 369982 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 369982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 369985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 369987 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 369989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 369991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 369995 */     GIR_RootConstrainSelectedInstOperands,
     /* 369996 */     // GIR_Coverage, 657,
     /* 369996 */     GIR_EraseRootFromParent_Done,
     /* 369997 */   // Label 7403: @369997
     /* 369997 */   GIM_Try, /*On fail goto*//*Label 7404*/ GIMT_Encode4(370028), // Rule ID 639 //
     /* 370002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 370005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370017 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 370017 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 370022 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 370026 */     GIR_RootConstrainSelectedInstOperands,
     /* 370027 */     // GIR_Coverage, 639,
     /* 370027 */     GIR_Done,
     /* 370028 */   // Label 7404: @370028
     /* 370028 */   GIM_Reject,
     /* 370029 */ // Label 7374: @370029
     /* 370029 */ GIM_Reject,
     /* 370030 */ // Label 7338: @370030
     /* 370030 */ GIM_Try, /*On fail goto*//*Label 7405*/ GIMT_Encode4(372959),
     /* 370035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 370038 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 370041 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370048 */   GIM_Try, /*On fail goto*//*Label 7406*/ GIMT_Encode4(370198), // Rule ID 4816 //
     /* 370053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 370056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 370068 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 370072 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370077 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 370081 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370085 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370089 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 370093 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 370097 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370102 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 370106 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 370110 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 370114 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 370118 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370123 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 370125 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 370125 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 370128 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370132 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370137 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 370143 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370148 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370153 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 370156 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370160 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370165 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 370171 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370176 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 370184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 370186 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370189 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 370192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 370196 */     GIR_RootConstrainSelectedInstOperands,
     /* 370197 */     // GIR_Coverage, 4816,
     /* 370197 */     GIR_EraseRootFromParent_Done,
     /* 370198 */   // Label 7406: @370198
     /* 370198 */   GIM_Try, /*On fail goto*//*Label 7407*/ GIMT_Encode4(370345), // Rule ID 4780 //
     /* 370203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 370206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370214 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 370218 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 370222 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370227 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 370231 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370235 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 370239 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 370243 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 370247 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370251 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 370255 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 370259 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370264 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 370268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370272 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 370274 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 370274 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 370277 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370281 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370286 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 370292 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370297 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370302 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 370305 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370309 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370314 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 370320 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370325 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 370333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 370335 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370338 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 370341 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 370343 */     GIR_RootConstrainSelectedInstOperands,
     /* 370344 */     // GIR_Coverage, 4780,
     /* 370344 */     GIR_EraseRootFromParent_Done,
     /* 370345 */   // Label 7407: @370345
     /* 370345 */   GIM_Try, /*On fail goto*//*Label 7408*/ GIMT_Encode4(370492), // Rule ID 13586 //
     /* 370350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 370353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 370361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 370365 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 370369 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370373 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 370377 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 370381 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370386 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 370390 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 370394 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370398 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 370402 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 370406 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370411 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 370415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370419 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 370421 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 370421 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 370424 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370428 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370433 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 370439 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370444 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370449 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 370452 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370456 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370461 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 370467 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370472 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 370480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 370482 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370485 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 370488 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 370490 */     GIR_RootConstrainSelectedInstOperands,
     /* 370491 */     // GIR_Coverage, 13586,
     /* 370491 */     GIR_EraseRootFromParent_Done,
     /* 370492 */   // Label 7408: @370492
     /* 370492 */   GIM_Try, /*On fail goto*//*Label 7409*/ GIMT_Encode4(370623), // Rule ID 6004 //
     /* 370497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 370500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 370512 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 370516 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370521 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 370525 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370529 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 370533 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 370537 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 370541 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370545 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 370549 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 370553 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370558 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 370562 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 370566 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 370570 */     // MIs[4] Operand 1
     /* 370570 */     // No operand predicates
     /* 370570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370574 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 370576 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 370576 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 370579 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370583 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370588 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 370594 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370599 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 370607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370609 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 370611 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 370618 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 370621 */     GIR_RootConstrainSelectedInstOperands,
     /* 370622 */     // GIR_Coverage, 6004,
     /* 370622 */     GIR_EraseRootFromParent_Done,
     /* 370623 */   // Label 7409: @370623
     /* 370623 */   GIM_Try, /*On fail goto*//*Label 7410*/ GIMT_Encode4(370754), // Rule ID 6036 //
     /* 370628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 370631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370639 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 370643 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 370647 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370652 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 370656 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 370660 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 370664 */     // MIs[2] Operand 1
     /* 370664 */     // No operand predicates
     /* 370664 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 370668 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 370672 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 370676 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 370680 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370684 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 370688 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 370692 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370697 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 370701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370705 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 370707 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 370707 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 370710 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370714 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370719 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 370725 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370730 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 370738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370740 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 370742 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 370749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 370752 */     GIR_RootConstrainSelectedInstOperands,
     /* 370753 */     // GIR_Coverage, 6036,
     /* 370753 */     GIR_EraseRootFromParent_Done,
     /* 370754 */   // Label 7410: @370754
     /* 370754 */   GIM_Try, /*On fail goto*//*Label 7411*/ GIMT_Encode4(370885), // Rule ID 6100 //
     /* 370759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 370762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 370770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 370774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 370778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370782 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 370786 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 370790 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370795 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 370799 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 370803 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370807 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 370811 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 370815 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370820 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 370824 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 370828 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 370832 */     // MIs[4] Operand 1
     /* 370832 */     // No operand predicates
     /* 370832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370836 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 370838 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 370838 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 370841 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370845 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370850 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 370856 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370861 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 370869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370871 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 370873 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 370880 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 370883 */     GIR_RootConstrainSelectedInstOperands,
     /* 370884 */     // GIR_Coverage, 6100,
     /* 370884 */     GIR_EraseRootFromParent_Done,
     /* 370885 */   // Label 7411: @370885
     /* 370885 */   GIM_Try, /*On fail goto*//*Label 7412*/ GIMT_Encode4(371016), // Rule ID 6068 //
     /* 370890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 370893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 370901 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 370905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 370909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370913 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 370917 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 370921 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370926 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 370930 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 370934 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 370938 */     // MIs[3] Operand 1
     /* 370938 */     // No operand predicates
     /* 370938 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 370942 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370946 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 370950 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 370954 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370959 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 370963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370967 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 370969 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 370969 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 370972 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370976 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370981 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 370987 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370992 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 371000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371002 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 371004 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 371011 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 371014 */     GIR_RootConstrainSelectedInstOperands,
     /* 371015 */     // GIR_Coverage, 6068,
     /* 371015 */     GIR_EraseRootFromParent_Done,
     /* 371016 */   // Label 7412: @371016
     /* 371016 */   GIM_Try, /*On fail goto*//*Label 7413*/ GIMT_Encode4(371151), // Rule ID 2458 //
     /* 371021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 371024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 371036 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 371040 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371045 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 371049 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371053 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371057 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 371061 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 371065 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371070 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 371074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371078 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371080 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 371080 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 371083 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371087 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371092 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 371098 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371103 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371108 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 371111 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371115 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371120 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 371126 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371131 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 371139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 371141 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371144 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 371147 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 371149 */     GIR_RootConstrainSelectedInstOperands,
     /* 371150 */     // GIR_Coverage, 2458,
     /* 371150 */     GIR_EraseRootFromParent_Done,
     /* 371151 */   // Label 7413: @371151
     /* 371151 */   GIM_Try, /*On fail goto*//*Label 7414*/ GIMT_Encode4(371270), // Rule ID 5972 //
     /* 371156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 371159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371167 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 371171 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 371175 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371180 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 371184 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371188 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371192 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 371196 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 371200 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371205 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 371209 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 371213 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 371217 */     // MIs[3] Operand 1
     /* 371217 */     // No operand predicates
     /* 371217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371221 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 371223 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 371223 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 371226 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371230 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371235 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 371241 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371246 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 371254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 371258 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 371265 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 371268 */     GIR_RootConstrainSelectedInstOperands,
     /* 371269 */     // GIR_Coverage, 5972,
     /* 371269 */     GIR_EraseRootFromParent_Done,
     /* 371270 */   // Label 7414: @371270
     /* 371270 */   GIM_Try, /*On fail goto*//*Label 7415*/ GIMT_Encode4(371389), // Rule ID 2548 //
     /* 371275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 371278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 371290 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 371294 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371299 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 371303 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 371307 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 371311 */     // MIs[2] Operand 1
     /* 371311 */     // No operand predicates
     /* 371311 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 371315 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371319 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 371323 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 371327 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371332 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 371336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371340 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 371342 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 371342 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 371345 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371349 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371354 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 371360 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371365 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 371373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371375 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 371377 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371380 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 371384 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 371387 */     GIR_RootConstrainSelectedInstOperands,
     /* 371388 */     // GIR_Coverage, 2548,
     /* 371388 */     GIR_EraseRootFromParent_Done,
     /* 371389 */   // Label 7415: @371389
     /* 371389 */   GIM_Try, /*On fail goto*//*Label 7416*/ GIMT_Encode4(371489), // Rule ID 4778 //
     /* 371394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 371397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 371409 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 371413 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371418 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 371422 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371426 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 371430 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 371434 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371443 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371445 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 371445 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 371448 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371452 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371457 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 371463 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371468 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 371476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 371478 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 371485 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 371487 */     GIR_RootConstrainSelectedInstOperands,
     /* 371488 */     // GIR_Coverage, 4778,
     /* 371488 */     GIR_EraseRootFromParent_Done,
     /* 371489 */   // Label 7416: @371489
     /* 371489 */   GIM_Try, /*On fail goto*//*Label 7417*/ GIMT_Encode4(371589), // Rule ID 4814 //
     /* 371494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 371497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 371509 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 371513 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371518 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 371522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 371530 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 371534 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 371538 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371543 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371545 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 371545 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 371548 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371552 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371557 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 371563 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371568 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 371576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 371578 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 371583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 371587 */     GIR_RootConstrainSelectedInstOperands,
     /* 371588 */     // GIR_Coverage, 4814,
     /* 371588 */     GIR_EraseRootFromParent_Done,
     /* 371589 */   // Label 7417: @371589
     /* 371589 */   GIM_Try, /*On fail goto*//*Label 7418*/ GIMT_Encode4(371686), // Rule ID 13582 //
     /* 371594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 371597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 371605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 371609 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 371613 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371617 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 371621 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 371625 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371630 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 371634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371642 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371644 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 371644 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 371647 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371651 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371656 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 371662 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371667 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 371675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 371677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 371679 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371682 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 371684 */     GIR_RootConstrainSelectedInstOperands,
     /* 371685 */     // GIR_Coverage, 13582,
     /* 371685 */     GIR_EraseRootFromParent_Done,
     /* 371686 */   // Label 7418: @371686
     /* 371686 */   GIM_Try, /*On fail goto*//*Label 7419*/ GIMT_Encode4(371786), // Rule ID 13584 //
     /* 371691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 371694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 371702 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 371706 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371711 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371715 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371719 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 371723 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 371727 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371732 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 371736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371740 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371742 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 371742 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 371745 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371749 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371754 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 371760 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371765 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 371773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 371775 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 371782 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 371784 */     GIR_RootConstrainSelectedInstOperands,
     /* 371785 */     // GIR_Coverage, 13584,
     /* 371785 */     GIR_EraseRootFromParent_Done,
     /* 371786 */   // Label 7419: @371786
     /* 371786 */   GIM_Try, /*On fail goto*//*Label 7420*/ GIMT_Encode4(371886), // Rule ID 4812 //
     /* 371791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 371794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 371802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371806 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 371810 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 371814 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371819 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 371823 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 371827 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 371831 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 371835 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371840 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371842 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 371842 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 371845 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371849 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371854 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 371860 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371865 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 371873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 371875 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 371877 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371880 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 371884 */     GIR_RootConstrainSelectedInstOperands,
     /* 371885 */     // GIR_Coverage, 4812,
     /* 371885 */     GIR_EraseRootFromParent_Done,
     /* 371886 */   // Label 7420: @371886
     /* 371886 */   GIM_Try, /*On fail goto*//*Label 7421*/ GIMT_Encode4(371983), // Rule ID 4776 //
     /* 371891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 371894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 371902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 371906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 371910 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 371914 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371918 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 371922 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 371926 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371931 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 371935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371939 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371941 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 371941 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 371944 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371948 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371953 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 371959 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371964 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 371972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 371974 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 371976 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371979 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 371981 */     GIR_RootConstrainSelectedInstOperands,
     /* 371982 */     // GIR_Coverage, 4776,
     /* 371982 */     GIR_EraseRootFromParent_Done,
     /* 371983 */   // Label 7421: @371983
     /* 371983 */   GIM_Try, /*On fail goto*//*Label 7422*/ GIMT_Encode4(372061), // Rule ID 6122 //
     /* 371988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 372000 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372004 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 372008 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 372012 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 372016 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372021 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 372025 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372029 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 372033 */     // MIs[3] Operand 1
     /* 372033 */     // No operand predicates
     /* 372033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372041 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372043 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 372043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 372046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372048 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 372050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 372052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 372056 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 372059 */     GIR_RootConstrainSelectedInstOperands,
     /* 372060 */     // GIR_Coverage, 6122,
     /* 372060 */     GIR_EraseRootFromParent_Done,
     /* 372061 */   // Label 7422: @372061
     /* 372061 */   GIM_Try, /*On fail goto*//*Label 7423*/ GIMT_Encode4(372145), // Rule ID 6034 //
     /* 372066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 372069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372077 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 372081 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372085 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372090 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 372094 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372098 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 372102 */     // MIs[2] Operand 1
     /* 372102 */     // No operand predicates
     /* 372102 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 372106 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 372110 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 372114 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372123 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372125 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 372125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 372128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372130 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 372132 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 372136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 372140 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 372143 */     GIR_RootConstrainSelectedInstOperands,
     /* 372144 */     // GIR_Coverage, 6034,
     /* 372144 */     GIR_EraseRootFromParent_Done,
     /* 372145 */   // Label 7423: @372145
     /* 372145 */   GIM_Try, /*On fail goto*//*Label 7424*/ GIMT_Encode4(372226), // Rule ID 6066 //
     /* 372150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 372153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 372161 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 372165 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 372169 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372173 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 372177 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 372181 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372186 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 372190 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372194 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 372198 */     // MIs[3] Operand 1
     /* 372198 */     // No operand predicates
     /* 372198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372206 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372208 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 372208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 372211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372213 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 372215 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 372217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 372221 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 372224 */     GIR_RootConstrainSelectedInstOperands,
     /* 372225 */     // GIR_Coverage, 6066,
     /* 372225 */     GIR_EraseRootFromParent_Done,
     /* 372226 */   // Label 7424: @372226
     /* 372226 */   GIM_Try, /*On fail goto*//*Label 7425*/ GIMT_Encode4(372310), // Rule ID 6098 //
     /* 372231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 372234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 372242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 372246 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372251 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 372255 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372259 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 372263 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 372267 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372272 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 372276 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372280 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 372284 */     // MIs[3] Operand 1
     /* 372284 */     // No operand predicates
     /* 372284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372288 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372290 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 372290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 372293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372295 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 372297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 372301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 372305 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 372308 */     GIR_RootConstrainSelectedInstOperands,
     /* 372309 */     // GIR_Coverage, 6098,
     /* 372309 */     GIR_EraseRootFromParent_Done,
     /* 372310 */   // Label 7425: @372310
     /* 372310 */   GIM_Try, /*On fail goto*//*Label 7426*/ GIMT_Encode4(372388), // Rule ID 6144 //
     /* 372315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 372323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 372331 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372335 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 372339 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 372343 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 372347 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372352 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 372356 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372360 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 372364 */     // MIs[3] Operand 1
     /* 372364 */     // No operand predicates
     /* 372364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372368 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372370 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 372370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 372373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372375 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 372377 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 372379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 372383 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 372386 */     GIR_RootConstrainSelectedInstOperands,
     /* 372387 */     // GIR_Coverage, 6144,
     /* 372387 */     GIR_EraseRootFromParent_Done,
     /* 372388 */   // Label 7426: @372388
     /* 372388 */   GIM_Try, /*On fail goto*//*Label 7427*/ GIMT_Encode4(372469), // Rule ID 6002 //
     /* 372393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 372396 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 372404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 372408 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 372412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 372416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372420 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 372424 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 372428 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372433 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 372437 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372441 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 372445 */     // MIs[3] Operand 1
     /* 372445 */     // No operand predicates
     /* 372445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372449 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372451 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 372451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 372454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372456 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 372458 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 372460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 372464 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 372467 */     GIR_RootConstrainSelectedInstOperands,
     /* 372468 */     // GIR_Coverage, 6002,
     /* 372468 */     GIR_EraseRootFromParent_Done,
     /* 372469 */   // Label 7427: @372469
     /* 372469 */   GIM_Try, /*On fail goto*//*Label 7428*/ GIMT_Encode4(372554), // Rule ID 2456 //
     /* 372474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 372477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372485 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 372489 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372493 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372498 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 372502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372510 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 372512 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 372512 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 372515 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372519 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372524 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 372530 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372535 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 372543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 372545 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372548 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 372550 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 372552 */     GIR_RootConstrainSelectedInstOperands,
     /* 372553 */     // GIR_Coverage, 2456,
     /* 372553 */     GIR_EraseRootFromParent_Done,
     /* 372554 */   // Label 7428: @372554
     /* 372554 */   GIM_Try, /*On fail goto*//*Label 7429*/ GIMT_Encode4(372639), // Rule ID 2454 //
     /* 372559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 372562 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 372570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372574 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 372578 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372582 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372587 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 372591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 372597 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 372597 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 372600 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372604 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372609 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 372615 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372620 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 372628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 372630 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 372632 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372635 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 372637 */     GIR_RootConstrainSelectedInstOperands,
     /* 372638 */     // GIR_Coverage, 2454,
     /* 372638 */     GIR_EraseRootFromParent_Done,
     /* 372639 */   // Label 7429: @372639
     /* 372639 */   GIM_Try, /*On fail goto*//*Label 7430*/ GIMT_Encode4(372708), // Rule ID 2546 //
     /* 372644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 372647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372655 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 372659 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372663 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 372672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372676 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 372680 */     // MIs[2] Operand 1
     /* 372680 */     // No operand predicates
     /* 372680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372688 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 372690 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 372690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 372693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372695 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 372697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 372699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 372703 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 372706 */     GIR_RootConstrainSelectedInstOperands,
     /* 372707 */     // GIR_Coverage, 2546,
     /* 372707 */     GIR_EraseRootFromParent_Done,
     /* 372708 */   // Label 7430: @372708
     /* 372708 */   GIM_Try, /*On fail goto*//*Label 7431*/ GIMT_Encode4(372777), // Rule ID 5970 //
     /* 372713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 372716 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 372724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372728 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 372732 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372736 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372741 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 372745 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372749 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 372753 */     // MIs[2] Operand 1
     /* 372753 */     // No operand predicates
     /* 372753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372757 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 372759 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 372759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 372762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372764 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 372766 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 372768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 372772 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 372775 */     GIR_RootConstrainSelectedInstOperands,
     /* 372776 */     // GIR_Coverage, 5970,
     /* 372776 */     GIR_EraseRootFromParent_Done,
     /* 372777 */   // Label 7431: @372777
     /* 372777 */   GIM_Try, /*On fail goto*//*Label 7432*/ GIMT_Encode4(372827), // Rule ID 13020 //
     /* 372782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 372785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 372793 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 372797 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372810 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 372812 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 372812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 372815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 372817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 372819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 372823 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 372825 */     GIR_RootConstrainSelectedInstOperands,
     /* 372826 */     // GIR_Coverage, 13020,
     /* 372826 */     GIR_EraseRootFromParent_Done,
     /* 372827 */   // Label 7432: @372827
     /* 372827 */   GIM_Try, /*On fail goto*//*Label 7433*/ GIMT_Encode4(372877), // Rule ID 647 //
     /* 372832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 372835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 372843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 372847 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 372851 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 372862 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 372862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 372865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 372867 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 372869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 372873 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 372875 */     GIR_RootConstrainSelectedInstOperands,
     /* 372876 */     // GIR_Coverage, 647,
     /* 372876 */     GIR_EraseRootFromParent_Done,
     /* 372877 */   // Label 7433: @372877
     /* 372877 */   GIM_Try, /*On fail goto*//*Label 7434*/ GIMT_Encode4(372927), // Rule ID 659 //
     /* 372882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 372885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 372897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 372901 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 372905 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372910 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 372912 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 372912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 372915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 372917 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 372919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 372921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 372925 */     GIR_RootConstrainSelectedInstOperands,
     /* 372926 */     // GIR_Coverage, 659,
     /* 372926 */     GIR_EraseRootFromParent_Done,
     /* 372927 */   // Label 7434: @372927
     /* 372927 */   GIM_Try, /*On fail goto*//*Label 7435*/ GIMT_Encode4(372958), // Rule ID 641 //
     /* 372932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 372935 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372947 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 372947 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 372952 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 372956 */     GIR_RootConstrainSelectedInstOperands,
     /* 372957 */     // GIR_Coverage, 641,
     /* 372957 */     GIR_Done,
     /* 372958 */   // Label 7435: @372958
     /* 372958 */   GIM_Reject,
     /* 372959 */ // Label 7405: @372959
     /* 372959 */ GIM_Reject,
     /* 372960 */ // Label 7339: @372960
     /* 372960 */ GIM_Try, /*On fail goto*//*Label 7436*/ GIMT_Encode4(374480),
     /* 372965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 372968 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 372971 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 372974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372978 */   GIM_Try, /*On fail goto*//*Label 7437*/ GIMT_Encode4(373056), // Rule ID 6102 //
     /* 372983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 372991 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 372995 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372999 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 373003 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 373007 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 373011 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373016 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 373020 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373024 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 373028 */     // MIs[3] Operand 1
     /* 373028 */     // No operand predicates
     /* 373028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373036 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373038 */     // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 373038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 373041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373043 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 373045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 373047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 373051 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 373054 */     GIR_RootConstrainSelectedInstOperands,
     /* 373055 */     // GIR_Coverage, 6102,
     /* 373055 */     GIR_EraseRootFromParent_Done,
     /* 373056 */   // Label 7437: @373056
     /* 373056 */   GIM_Try, /*On fail goto*//*Label 7438*/ GIMT_Encode4(373140), // Rule ID 6018 //
     /* 373061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 373072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 373076 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373080 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373085 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 373089 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373093 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 373097 */     // MIs[2] Operand 1
     /* 373097 */     // No operand predicates
     /* 373097 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 373101 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 373105 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 373109 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373118 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373120 */     // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 373120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 373123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373125 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 373127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 373131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 373135 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 373138 */     GIR_RootConstrainSelectedInstOperands,
     /* 373139 */     // GIR_Coverage, 6018,
     /* 373139 */     GIR_EraseRootFromParent_Done,
     /* 373140 */   // Label 7438: @373140
     /* 373140 */   GIM_Try, /*On fail goto*//*Label 7439*/ GIMT_Encode4(373221), // Rule ID 6050 //
     /* 373145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 373156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 373160 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 373164 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 373168 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 373172 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 373176 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373181 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 373185 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373189 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 373193 */     // MIs[3] Operand 1
     /* 373193 */     // No operand predicates
     /* 373193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373201 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373203 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 373203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 373206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373208 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 373210 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 373212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 373216 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 373219 */     GIR_RootConstrainSelectedInstOperands,
     /* 373220 */     // GIR_Coverage, 6050,
     /* 373220 */     GIR_EraseRootFromParent_Done,
     /* 373221 */   // Label 7439: @373221
     /* 373221 */   GIM_Try, /*On fail goto*//*Label 7440*/ GIMT_Encode4(373305), // Rule ID 6082 //
     /* 373226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 373237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 373241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373246 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373250 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 373254 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 373258 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 373262 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373267 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 373271 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373275 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 373279 */     // MIs[3] Operand 1
     /* 373279 */     // No operand predicates
     /* 373279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373283 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373285 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 373285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 373288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373290 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 373292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 373296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 373300 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 373303 */     GIR_RootConstrainSelectedInstOperands,
     /* 373304 */     // GIR_Coverage, 6082,
     /* 373304 */     GIR_EraseRootFromParent_Done,
     /* 373305 */   // Label 7440: @373305
     /* 373305 */   GIM_Try, /*On fail goto*//*Label 7441*/ GIMT_Encode4(373383), // Rule ID 6124 //
     /* 373310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 373318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 373322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 373326 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373330 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 373334 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 373338 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 373342 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373347 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 373351 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373355 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 373359 */     // MIs[3] Operand 1
     /* 373359 */     // No operand predicates
     /* 373359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373363 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373365 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 373365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 373368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373370 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 373372 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 373374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 373378 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 373381 */     GIR_RootConstrainSelectedInstOperands,
     /* 373382 */     // GIR_Coverage, 6124,
     /* 373382 */     GIR_EraseRootFromParent_Done,
     /* 373383 */   // Label 7441: @373383
     /* 373383 */   GIM_Try, /*On fail goto*//*Label 7442*/ GIMT_Encode4(373464), // Rule ID 5986 //
     /* 373388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373391 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 373399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 373403 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 373407 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 373411 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 373415 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 373419 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 373423 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373428 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 373432 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373436 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 373440 */     // MIs[3] Operand 1
     /* 373440 */     // No operand predicates
     /* 373440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373444 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373446 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 373446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 373449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373451 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 373453 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 373455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 373459 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 373462 */     GIR_RootConstrainSelectedInstOperands,
     /* 373463 */     // GIR_Coverage, 5986,
     /* 373463 */     GIR_EraseRootFromParent_Done,
     /* 373464 */   // Label 7442: @373464
     /* 373464 */   GIM_Try, /*On fail goto*//*Label 7443*/ GIMT_Encode4(373533), // Rule ID 2530 //
     /* 373469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 373480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 373484 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373488 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 373497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373501 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 373505 */     // MIs[2] Operand 1
     /* 373505 */     // No operand predicates
     /* 373505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373513 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373515 */     // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 373515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 373518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373520 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 373522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 373524 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 373528 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 373531 */     GIR_RootConstrainSelectedInstOperands,
     /* 373532 */     // GIR_Coverage, 2530,
     /* 373532 */     GIR_EraseRootFromParent_Done,
     /* 373533 */   // Label 7443: @373533
     /* 373533 */   GIM_Try, /*On fail goto*//*Label 7444*/ GIMT_Encode4(373602), // Rule ID 5954 //
     /* 373538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 373549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 373553 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 373557 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373561 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373566 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 373570 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373574 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 373578 */     // MIs[2] Operand 1
     /* 373578 */     // No operand predicates
     /* 373578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373582 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373584 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 373584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 373587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373589 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 373591 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 373593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 373597 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 373600 */     GIR_RootConstrainSelectedInstOperands,
     /* 373601 */     // GIR_Coverage, 5954,
     /* 373601 */     GIR_EraseRootFromParent_Done,
     /* 373602 */   // Label 7444: @373602
     /* 373602 */   GIM_Try, /*On fail goto*//*Label 7445*/ GIMT_Encode4(373695), // Rule ID 6106 //
     /* 373607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 373615 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 373619 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 373623 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 373627 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 373631 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 373636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373644 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373646 */     // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 373646 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 373649 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 373653 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373658 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 373661 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 373665 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 373668 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373673 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 373678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 373681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373683 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 373685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 373687 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373693 */     GIR_RootConstrainSelectedInstOperands,
     /* 373694 */     // GIR_Coverage, 6106,
     /* 373694 */     GIR_EraseRootFromParent_Done,
     /* 373695 */   // Label 7445: @373695
     /* 373695 */   GIM_Try, /*On fail goto*//*Label 7446*/ GIMT_Encode4(373794), // Rule ID 6020 //
     /* 373700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 373711 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 373715 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 373720 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373724 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 373728 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 373732 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373741 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373743 */     // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 373743 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 373746 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 373750 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373755 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 373758 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 373762 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 373765 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373770 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 373775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 373778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 373782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 373786 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373792 */     GIR_RootConstrainSelectedInstOperands,
     /* 373793 */     // GIR_Coverage, 6020,
     /* 373793 */     GIR_EraseRootFromParent_Done,
     /* 373794 */   // Label 7446: @373794
     /* 373794 */   GIM_Try, /*On fail goto*//*Label 7447*/ GIMT_Encode4(373890), // Rule ID 6052 //
     /* 373799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 373810 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 373814 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 373818 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 373822 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 373826 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 373831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373839 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373841 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 373841 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 373844 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 373848 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373853 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 373856 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 373860 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 373863 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373868 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 373873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 373876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373878 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 373880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 373882 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373888 */     GIR_RootConstrainSelectedInstOperands,
     /* 373889 */     // GIR_Coverage, 6052,
     /* 373889 */     GIR_EraseRootFromParent_Done,
     /* 373890 */   // Label 7447: @373890
     /* 373890 */   GIM_Try, /*On fail goto*//*Label 7448*/ GIMT_Encode4(373989), // Rule ID 6084 //
     /* 373895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 373906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 373910 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373915 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373919 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 373923 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 373927 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 373932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373936 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373938 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 373938 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 373941 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 373945 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373950 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 373953 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 373957 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 373960 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373965 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 373970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 373973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373975 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 373977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 373981 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373987 */     GIR_RootConstrainSelectedInstOperands,
     /* 373988 */     // GIR_Coverage, 6084,
     /* 373988 */     GIR_EraseRootFromParent_Done,
     /* 373989 */   // Label 7448: @373989
     /* 373989 */   GIM_Try, /*On fail goto*//*Label 7449*/ GIMT_Encode4(374082), // Rule ID 6128 //
     /* 373994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 374002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 374006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 374010 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 374014 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 374018 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 374022 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374031 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374033 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 374033 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 374036 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374040 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374045 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 374048 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 374052 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 374055 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374060 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 374068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374070 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 374072 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 374074 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374080 */     GIR_RootConstrainSelectedInstOperands,
     /* 374081 */     // GIR_Coverage, 6128,
     /* 374081 */     GIR_EraseRootFromParent_Done,
     /* 374082 */   // Label 7449: @374082
     /* 374082 */   GIM_Try, /*On fail goto*//*Label 7450*/ GIMT_Encode4(374178), // Rule ID 5988 //
     /* 374087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374090 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 374098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 374102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 374106 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 374110 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 374114 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 374118 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374127 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374129 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 374129 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 374132 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374136 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374141 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 374144 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 374148 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 374151 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374156 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 374164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374166 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 374168 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 374170 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374176 */     GIR_RootConstrainSelectedInstOperands,
     /* 374177 */     // GIR_Coverage, 5988,
     /* 374177 */     GIR_EraseRootFromParent_Done,
     /* 374178 */   // Label 7450: @374178
     /* 374178 */   GIM_Try, /*On fail goto*//*Label 7451*/ GIMT_Encode4(374262), // Rule ID 2532 //
     /* 374183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 374194 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 374198 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 374213 */     // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 374213 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 374216 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374220 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374225 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 374228 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 374232 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 374235 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374240 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 374248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374250 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 374252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 374254 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374260 */     GIR_RootConstrainSelectedInstOperands,
     /* 374261 */     // GIR_Coverage, 2532,
     /* 374261 */     GIR_EraseRootFromParent_Done,
     /* 374262 */   // Label 7451: @374262
     /* 374262 */   GIM_Try, /*On fail goto*//*Label 7452*/ GIMT_Encode4(374312), // Rule ID 13050 //
     /* 374267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 374278 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 374282 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 374297 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 374297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 374300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374302 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 374304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 374306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 374310 */     GIR_RootConstrainSelectedInstOperands,
     /* 374311 */     // GIR_Coverage, 13050,
     /* 374311 */     GIR_EraseRootFromParent_Done,
     /* 374312 */   // Label 7452: @374312
     /* 374312 */   GIM_Try, /*On fail goto*//*Label 7453*/ GIMT_Encode4(374396), // Rule ID 5956 //
     /* 374317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374320 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 374328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 374332 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 374336 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 374347 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 374347 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 374350 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374354 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374359 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 374362 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 374366 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 374369 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374374 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 374382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374384 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 374386 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 374388 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374394 */     GIR_RootConstrainSelectedInstOperands,
     /* 374395 */     // GIR_Coverage, 5956,
     /* 374395 */     GIR_EraseRootFromParent_Done,
     /* 374396 */   // Label 7453: @374396
     /* 374396 */   GIM_Try, /*On fail goto*//*Label 7454*/ GIMT_Encode4(374446), // Rule ID 1300 //
     /* 374401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 374412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 374416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 374420 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 374431 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 374431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 374434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374436 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 374438 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 374440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 374444 */     GIR_RootConstrainSelectedInstOperands,
     /* 374445 */     // GIR_Coverage, 1300,
     /* 374445 */     GIR_EraseRootFromParent_Done,
     /* 374446 */   // Label 7454: @374446
     /* 374446 */   GIM_Try, /*On fail goto*//*Label 7455*/ GIMT_Encode4(374479), // Rule ID 1290 //
     /* 374451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374466 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 374466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f32),
     /* 374469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374471 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 374473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 374475 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 374477 */     GIR_RootConstrainSelectedInstOperands,
     /* 374478 */     // GIR_Coverage, 1290,
     /* 374478 */     GIR_EraseRootFromParent_Done,
     /* 374479 */   // Label 7455: @374479
     /* 374479 */   GIM_Reject,
     /* 374480 */ // Label 7436: @374480
     /* 374480 */ GIM_Reject,
     /* 374481 */ // Label 7340: @374481
     /* 374481 */ GIM_Try, /*On fail goto*//*Label 7456*/ GIMT_Encode4(376001),
     /* 374486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 374489 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 374492 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 374495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374499 */   GIM_Try, /*On fail goto*//*Label 7457*/ GIMT_Encode4(374577), // Rule ID 6114 //
     /* 374504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 374512 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 374516 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 374520 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 374524 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 374528 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 374532 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374537 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 374541 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374545 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 374549 */     // MIs[3] Operand 1
     /* 374549 */     // No operand predicates
     /* 374549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374557 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 374559 */     // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 374559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 374562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374564 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 374566 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 374568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 374572 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 374575 */     GIR_RootConstrainSelectedInstOperands,
     /* 374576 */     // GIR_Coverage, 6114,
     /* 374576 */     GIR_EraseRootFromParent_Done,
     /* 374577 */   // Label 7457: @374577
     /* 374577 */   GIM_Try, /*On fail goto*//*Label 7458*/ GIMT_Encode4(374661), // Rule ID 6026 //
     /* 374582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 374593 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 374597 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 374601 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374606 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 374610 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374614 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 374618 */     // MIs[2] Operand 1
     /* 374618 */     // No operand predicates
     /* 374618 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 374622 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 374626 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 374630 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374639 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 374641 */     // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 374641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 374644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374646 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 374648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 374652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 374656 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 374659 */     GIR_RootConstrainSelectedInstOperands,
     /* 374660 */     // GIR_Coverage, 6026,
     /* 374660 */     GIR_EraseRootFromParent_Done,
     /* 374661 */   // Label 7458: @374661
     /* 374661 */   GIM_Try, /*On fail goto*//*Label 7459*/ GIMT_Encode4(374742), // Rule ID 6058 //
     /* 374666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 374677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 374681 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 374685 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 374689 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 374693 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 374697 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374702 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 374706 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374710 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 374714 */     // MIs[3] Operand 1
     /* 374714 */     // No operand predicates
     /* 374714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374722 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 374724 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 374724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 374727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374729 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 374731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 374733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 374737 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 374740 */     GIR_RootConstrainSelectedInstOperands,
     /* 374741 */     // GIR_Coverage, 6058,
     /* 374741 */     GIR_EraseRootFromParent_Done,
     /* 374742 */   // Label 7459: @374742
     /* 374742 */   GIM_Try, /*On fail goto*//*Label 7460*/ GIMT_Encode4(374826), // Rule ID 6090 //
     /* 374747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 374758 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 374762 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374767 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374771 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 374775 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 374779 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 374783 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374788 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 374792 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374796 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 374800 */     // MIs[3] Operand 1
     /* 374800 */     // No operand predicates
     /* 374800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374804 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 374806 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 374806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 374809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374811 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 374813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 374817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 374821 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 374824 */     GIR_RootConstrainSelectedInstOperands,
     /* 374825 */     // GIR_Coverage, 6090,
     /* 374825 */     GIR_EraseRootFromParent_Done,
     /* 374826 */   // Label 7460: @374826
     /* 374826 */   GIM_Try, /*On fail goto*//*Label 7461*/ GIMT_Encode4(374904), // Rule ID 6136 //
     /* 374831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 374839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 374843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 374847 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 374851 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 374855 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 374859 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 374863 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374868 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 374872 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374876 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 374880 */     // MIs[3] Operand 1
     /* 374880 */     // No operand predicates
     /* 374880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374884 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 374886 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 374886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 374889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374891 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 374893 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 374895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 374899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 374902 */     GIR_RootConstrainSelectedInstOperands,
     /* 374903 */     // GIR_Coverage, 6136,
     /* 374903 */     GIR_EraseRootFromParent_Done,
     /* 374904 */   // Label 7461: @374904
     /* 374904 */   GIM_Try, /*On fail goto*//*Label 7462*/ GIMT_Encode4(374985), // Rule ID 5994 //
     /* 374909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 374920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 374924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 374928 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 374932 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 374936 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 374940 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 374944 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374949 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 374953 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374957 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 374961 */     // MIs[3] Operand 1
     /* 374961 */     // No operand predicates
     /* 374961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374965 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 374967 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 374967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 374970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374972 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 374974 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 374976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 374980 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 374983 */     GIR_RootConstrainSelectedInstOperands,
     /* 374984 */     // GIR_Coverage, 5994,
     /* 374984 */     GIR_EraseRootFromParent_Done,
     /* 374985 */   // Label 7462: @374985
     /* 374985 */   GIM_Try, /*On fail goto*//*Label 7463*/ GIMT_Encode4(375054), // Rule ID 2538 //
     /* 374990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 375001 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 375005 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375009 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375014 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375018 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375022 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 375026 */     // MIs[2] Operand 1
     /* 375026 */     // No operand predicates
     /* 375026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375034 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375036 */     // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 375036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 375039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375041 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 375043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 375045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 375049 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 375052 */     GIR_RootConstrainSelectedInstOperands,
     /* 375053 */     // GIR_Coverage, 2538,
     /* 375053 */     GIR_EraseRootFromParent_Done,
     /* 375054 */   // Label 7463: @375054
     /* 375054 */   GIM_Try, /*On fail goto*//*Label 7464*/ GIMT_Encode4(375123), // Rule ID 5962 //
     /* 375059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375062 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 375070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 375074 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 375078 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375082 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375095 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 375099 */     // MIs[2] Operand 1
     /* 375099 */     // No operand predicates
     /* 375099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375103 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375105 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 375105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 375108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375110 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 375112 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 375114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 375118 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 375121 */     GIR_RootConstrainSelectedInstOperands,
     /* 375122 */     // GIR_Coverage, 5962,
     /* 375122 */     GIR_EraseRootFromParent_Done,
     /* 375123 */   // Label 7464: @375123
     /* 375123 */   GIM_Try, /*On fail goto*//*Label 7465*/ GIMT_Encode4(375216), // Rule ID 6116 //
     /* 375128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 375136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 375140 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 375144 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 375148 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 375152 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375165 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375167 */     // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 375167 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 375170 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 375174 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375179 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 375182 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 375186 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 375189 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375194 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 375202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375204 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 375206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 375208 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375214 */     GIR_RootConstrainSelectedInstOperands,
     /* 375215 */     // GIR_Coverage, 6116,
     /* 375215 */     GIR_EraseRootFromParent_Done,
     /* 375216 */   // Label 7465: @375216
     /* 375216 */   GIM_Try, /*On fail goto*//*Label 7466*/ GIMT_Encode4(375315), // Rule ID 6028 //
     /* 375221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 375232 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 375236 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 375249 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 375253 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375262 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375264 */     // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 375264 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 375267 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 375271 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375276 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 375279 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 375283 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 375286 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375291 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 375299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375301 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 375303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 375307 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375313 */     GIR_RootConstrainSelectedInstOperands,
     /* 375314 */     // GIR_Coverage, 6028,
     /* 375314 */     GIR_EraseRootFromParent_Done,
     /* 375315 */   // Label 7466: @375315
     /* 375315 */   GIM_Try, /*On fail goto*//*Label 7467*/ GIMT_Encode4(375411), // Rule ID 6060 //
     /* 375320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 375331 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 375335 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 375339 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 375343 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 375347 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375360 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375362 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 375362 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 375365 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 375369 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375374 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 375377 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 375381 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 375384 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375389 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 375397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375399 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 375401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 375403 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375409 */     GIR_RootConstrainSelectedInstOperands,
     /* 375410 */     // GIR_Coverage, 6060,
     /* 375410 */     GIR_EraseRootFromParent_Done,
     /* 375411 */   // Label 7467: @375411
     /* 375411 */   GIM_Try, /*On fail goto*//*Label 7468*/ GIMT_Encode4(375510), // Rule ID 6092 //
     /* 375416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 375427 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 375431 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375436 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375440 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 375444 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 375448 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375457 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375459 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 375459 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 375462 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 375466 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375471 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 375474 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 375478 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 375481 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375486 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 375494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375496 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 375498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 375502 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375508 */     GIR_RootConstrainSelectedInstOperands,
     /* 375509 */     // GIR_Coverage, 6092,
     /* 375509 */     GIR_EraseRootFromParent_Done,
     /* 375510 */   // Label 7468: @375510
     /* 375510 */   GIM_Try, /*On fail goto*//*Label 7469*/ GIMT_Encode4(375603), // Rule ID 6138 //
     /* 375515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 375523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 375527 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 375531 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 375535 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 375539 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 375543 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375552 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375554 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 375554 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 375557 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 375561 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375566 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 375569 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 375573 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 375576 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375581 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 375589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375591 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 375593 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 375595 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375601 */     GIR_RootConstrainSelectedInstOperands,
     /* 375602 */     // GIR_Coverage, 6138,
     /* 375602 */     GIR_EraseRootFromParent_Done,
     /* 375603 */   // Label 7469: @375603
     /* 375603 */   GIM_Try, /*On fail goto*//*Label 7470*/ GIMT_Encode4(375699), // Rule ID 5996 //
     /* 375608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375611 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 375619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 375623 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 375627 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 375631 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 375635 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 375639 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375648 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375650 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 375650 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 375653 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 375657 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375662 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 375665 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 375669 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 375672 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375677 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 375685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375687 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 375689 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 375691 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375697 */     GIR_RootConstrainSelectedInstOperands,
     /* 375698 */     // GIR_Coverage, 5996,
     /* 375698 */     GIR_EraseRootFromParent_Done,
     /* 375699 */   // Label 7470: @375699
     /* 375699 */   GIM_Try, /*On fail goto*//*Label 7471*/ GIMT_Encode4(375783), // Rule ID 2540 //
     /* 375704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 375715 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 375719 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375732 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 375734 */     // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 375734 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 375737 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 375741 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375746 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 375749 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 375753 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 375756 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375761 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 375769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375771 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 375773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 375775 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375781 */     GIR_RootConstrainSelectedInstOperands,
     /* 375782 */     // GIR_Coverage, 2540,
     /* 375782 */     GIR_EraseRootFromParent_Done,
     /* 375783 */   // Label 7471: @375783
     /* 375783 */   GIM_Try, /*On fail goto*//*Label 7472*/ GIMT_Encode4(375833), // Rule ID 13054 //
     /* 375788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 375799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 375803 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375816 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 375818 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 375818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 375821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375823 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 375825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 375827 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 375831 */     GIR_RootConstrainSelectedInstOperands,
     /* 375832 */     // GIR_Coverage, 13054,
     /* 375832 */     GIR_EraseRootFromParent_Done,
     /* 375833 */   // Label 7472: @375833
     /* 375833 */   GIM_Try, /*On fail goto*//*Label 7473*/ GIMT_Encode4(375917), // Rule ID 5964 //
     /* 375838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 375849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 375853 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 375857 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375866 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 375868 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 375868 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 375871 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 375875 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375880 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 375883 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 375887 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 375890 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375895 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 375903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375905 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 375907 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 375909 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375915 */     GIR_RootConstrainSelectedInstOperands,
     /* 375916 */     // GIR_Coverage, 5964,
     /* 375916 */     GIR_EraseRootFromParent_Done,
     /* 375917 */   // Label 7473: @375917
     /* 375917 */   GIM_Try, /*On fail goto*//*Label 7474*/ GIMT_Encode4(375967), // Rule ID 1304 //
     /* 375922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375925 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 375933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 375937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 375941 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 375952 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 375952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 375955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375957 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 375959 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 375961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 375965 */     GIR_RootConstrainSelectedInstOperands,
     /* 375966 */     // GIR_Coverage, 1304,
     /* 375966 */     GIR_EraseRootFromParent_Done,
     /* 375967 */   // Label 7474: @375967
     /* 375967 */   GIM_Try, /*On fail goto*//*Label 7475*/ GIMT_Encode4(376000), // Rule ID 1294 //
     /* 375972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375987 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 375987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f64),
     /* 375990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375992 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 375994 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 375996 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 375998 */     GIR_RootConstrainSelectedInstOperands,
     /* 375999 */     // GIR_Coverage, 1294,
     /* 375999 */     GIR_EraseRootFromParent_Done,
     /* 376000 */   // Label 7475: @376000
     /* 376000 */   GIM_Reject,
     /* 376001 */ // Label 7456: @376001
     /* 376001 */ GIM_Reject,
     /* 376002 */ // Label 7341: @376002
     /* 376002 */ GIM_Try, /*On fail goto*//*Label 7476*/ GIMT_Encode4(377180),
     /* 376007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 376010 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 376013 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 376016 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376020 */   GIM_Try, /*On fail goto*//*Label 7477*/ GIMT_Encode4(376104), // Rule ID 6010 //
     /* 376025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 376028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 376036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376040 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376044 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 376049 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 376053 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376057 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 376061 */     // MIs[2] Operand 1
     /* 376061 */     // No operand predicates
     /* 376061 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 376065 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 376069 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 376073 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376082 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376084 */     // (strict_fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 376084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 376087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376089 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 376095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 376099 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 376102 */     GIR_RootConstrainSelectedInstOperands,
     /* 376103 */     // GIR_Coverage, 6010,
     /* 376103 */     GIR_EraseRootFromParent_Done,
     /* 376104 */   // Label 7477: @376104
     /* 376104 */   GIM_Try, /*On fail goto*//*Label 7478*/ GIMT_Encode4(376185), // Rule ID 6042 //
     /* 376109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 376112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 376120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 376124 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 376128 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 376132 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376136 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 376140 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 376145 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 376149 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376153 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 376157 */     // MIs[3] Operand 1
     /* 376157 */     // No operand predicates
     /* 376157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376165 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376167 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 376167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 376170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376172 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 376176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 376180 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 376183 */     GIR_RootConstrainSelectedInstOperands,
     /* 376184 */     // GIR_Coverage, 6042,
     /* 376184 */     GIR_EraseRootFromParent_Done,
     /* 376185 */   // Label 7478: @376185
     /* 376185 */   GIM_Try, /*On fail goto*//*Label 7479*/ GIMT_Encode4(376269), // Rule ID 6074 //
     /* 376190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 376193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 376201 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 376205 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376210 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376214 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 376218 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376222 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 376226 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 376231 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 376235 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376239 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 376243 */     // MIs[3] Operand 1
     /* 376243 */     // No operand predicates
     /* 376243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376247 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376249 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 376249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 376252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376254 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 376260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 376264 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 376267 */     GIR_RootConstrainSelectedInstOperands,
     /* 376268 */     // GIR_Coverage, 6074,
     /* 376268 */     GIR_EraseRootFromParent_Done,
     /* 376269 */   // Label 7479: @376269
     /* 376269 */   GIM_Try, /*On fail goto*//*Label 7480*/ GIMT_Encode4(376350), // Rule ID 5978 //
     /* 376274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 376277 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 376285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 376289 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 376293 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 376297 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 376301 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376305 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 376309 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 376314 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 376318 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376322 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 376326 */     // MIs[3] Operand 1
     /* 376326 */     // No operand predicates
     /* 376326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376330 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376332 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 376332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 376335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376337 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376339 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 376341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 376345 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 376348 */     GIR_RootConstrainSelectedInstOperands,
     /* 376349 */     // GIR_Coverage, 5978,
     /* 376349 */     GIR_EraseRootFromParent_Done,
     /* 376350 */   // Label 7480: @376350
     /* 376350 */   GIM_Try, /*On fail goto*//*Label 7481*/ GIMT_Encode4(376419), // Rule ID 2522 //
     /* 376355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 376358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 376366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376370 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376374 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 376379 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 376383 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376387 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 376391 */     // MIs[2] Operand 1
     /* 376391 */     // No operand predicates
     /* 376391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376399 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376401 */     // (strict_fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 376401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 376404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376406 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 376410 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 376414 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 376417 */     GIR_RootConstrainSelectedInstOperands,
     /* 376418 */     // GIR_Coverage, 2522,
     /* 376418 */     GIR_EraseRootFromParent_Done,
     /* 376419 */   // Label 7481: @376419
     /* 376419 */   GIM_Try, /*On fail goto*//*Label 7482*/ GIMT_Encode4(376488), // Rule ID 5946 //
     /* 376424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 376427 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 376435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 376439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376443 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376447 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 376452 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 376456 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376460 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 376464 */     // MIs[2] Operand 1
     /* 376464 */     // No operand predicates
     /* 376464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376468 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376470 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 376470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 376473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376475 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376477 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 376479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 376483 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 376486 */     GIR_RootConstrainSelectedInstOperands,
     /* 376487 */     // GIR_Coverage, 5946,
     /* 376487 */     GIR_EraseRootFromParent_Done,
     /* 376488 */   // Label 7482: @376488
     /* 376488 */   GIM_Try, /*On fail goto*//*Label 7483*/ GIMT_Encode4(376587), // Rule ID 6012 //
     /* 376493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 376496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 376504 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 376508 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 376513 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376517 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 376521 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 376525 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376534 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376536 */     // (strict_fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 376536 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 376539 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 376543 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376548 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 376551 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 376555 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 376558 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376563 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 376568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 376571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376573 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 376579 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376585 */     GIR_RootConstrainSelectedInstOperands,
     /* 376586 */     // GIR_Coverage, 6012,
     /* 376586 */     GIR_EraseRootFromParent_Done,
     /* 376587 */   // Label 7483: @376587
     /* 376587 */   GIM_Try, /*On fail goto*//*Label 7484*/ GIMT_Encode4(376683), // Rule ID 6044 //
     /* 376592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 376595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 376603 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 376607 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 376611 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 376615 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 376619 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 376624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376632 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376634 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 376634 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 376637 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 376641 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376646 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 376649 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 376653 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 376656 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376661 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 376666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 376669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376671 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 376675 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376681 */     GIR_RootConstrainSelectedInstOperands,
     /* 376682 */     // GIR_Coverage, 6044,
     /* 376682 */     GIR_EraseRootFromParent_Done,
     /* 376683 */   // Label 7484: @376683
     /* 376683 */   GIM_Try, /*On fail goto*//*Label 7485*/ GIMT_Encode4(376782), // Rule ID 6076 //
     /* 376688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 376691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 376699 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 376703 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376708 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376712 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 376716 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 376720 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 376725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376729 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376731 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 376731 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 376734 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 376738 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376743 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 376746 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 376750 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 376753 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376758 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 376763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 376766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376768 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 376774 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376780 */     GIR_RootConstrainSelectedInstOperands,
     /* 376781 */     // GIR_Coverage, 6076,
     /* 376781 */     GIR_EraseRootFromParent_Done,
     /* 376782 */   // Label 7485: @376782
     /* 376782 */   GIM_Try, /*On fail goto*//*Label 7486*/ GIMT_Encode4(376878), // Rule ID 5980 //
     /* 376787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 376790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 376798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 376802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 376806 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 376810 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 376814 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 376818 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 376823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376827 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376829 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 376829 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 376832 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 376836 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376841 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 376844 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 376848 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 376851 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376856 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 376861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 376864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376866 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376868 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 376870 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376876 */     GIR_RootConstrainSelectedInstOperands,
     /* 376877 */     // GIR_Coverage, 5980,
     /* 376877 */     GIR_EraseRootFromParent_Done,
     /* 376878 */   // Label 7486: @376878
     /* 376878 */   GIM_Try, /*On fail goto*//*Label 7487*/ GIMT_Encode4(376962), // Rule ID 2524 //
     /* 376883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 376886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 376894 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 376898 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 376903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 376913 */     // (strict_fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 376913 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 376916 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 376920 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376925 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 376928 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 376932 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 376935 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376940 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 376945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 376948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376950 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 376954 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376960 */     GIR_RootConstrainSelectedInstOperands,
     /* 376961 */     // GIR_Coverage, 2524,
     /* 376961 */     GIR_EraseRootFromParent_Done,
     /* 376962 */   // Label 7487: @376962
     /* 376962 */   GIM_Try, /*On fail goto*//*Label 7488*/ GIMT_Encode4(377012), // Rule ID 13046 //
     /* 376967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 376970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 376978 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 376982 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376995 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 376997 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 376997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 377000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377002 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 377006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 377010 */     GIR_RootConstrainSelectedInstOperands,
     /* 377011 */     // GIR_Coverage, 13046,
     /* 377011 */     GIR_EraseRootFromParent_Done,
     /* 377012 */   // Label 7488: @377012
     /* 377012 */   GIM_Try, /*On fail goto*//*Label 7489*/ GIMT_Encode4(377096), // Rule ID 5948 //
     /* 377017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 377020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 377028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 377032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 377036 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 377041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 377047 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 377047 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 377050 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377054 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377059 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 377062 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 377066 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 377069 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377074 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 377079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 377082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377084 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377086 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 377088 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377094 */     GIR_RootConstrainSelectedInstOperands,
     /* 377095 */     // GIR_Coverage, 5948,
     /* 377095 */     GIR_EraseRootFromParent_Done,
     /* 377096 */   // Label 7489: @377096
     /* 377096 */   GIM_Try, /*On fail goto*//*Label 7490*/ GIMT_Encode4(377146), // Rule ID 1296 //
     /* 377101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 377104 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 377112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377116 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 377120 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 377131 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 377131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 377134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377136 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377138 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 377140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 377144 */     GIR_RootConstrainSelectedInstOperands,
     /* 377145 */     // GIR_Coverage, 1296,
     /* 377145 */     GIR_EraseRootFromParent_Done,
     /* 377146 */   // Label 7490: @377146
     /* 377146 */   GIM_Try, /*On fail goto*//*Label 7491*/ GIMT_Encode4(377179), // Rule ID 1286 //
     /* 377151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 377154 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377166 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 377166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f16),
     /* 377169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 377175 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 377177 */     GIR_RootConstrainSelectedInstOperands,
     /* 377178 */     // GIR_Coverage, 1286,
     /* 377178 */     GIR_EraseRootFromParent_Done,
     /* 377179 */   // Label 7491: @377179
     /* 377179 */   GIM_Reject,
     /* 377180 */ // Label 7476: @377180
     /* 377180 */ GIM_Reject,
     /* 377181 */ // Label 7342: @377181
     /* 377181 */ GIM_Try, /*On fail goto*//*Label 7492*/ GIMT_Encode4(378701),
     /* 377186 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 377189 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 377192 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 377195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377199 */   GIM_Try, /*On fail goto*//*Label 7493*/ GIMT_Encode4(377277), // Rule ID 6108 //
     /* 377204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 377212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 377216 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377220 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 377224 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377228 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 377232 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377237 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 377241 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377245 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 377249 */     // MIs[3] Operand 1
     /* 377249 */     // No operand predicates
     /* 377249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377257 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377259 */     // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 377259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 377262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377264 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 377268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 377272 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 377275 */     GIR_RootConstrainSelectedInstOperands,
     /* 377276 */     // GIR_Coverage, 6108,
     /* 377276 */     GIR_EraseRootFromParent_Done,
     /* 377277 */   // Label 7493: @377277
     /* 377277 */   GIM_Try, /*On fail goto*//*Label 7494*/ GIMT_Encode4(377361), // Rule ID 6022 //
     /* 377282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 377285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 377293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 377297 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377301 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377306 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 377310 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377314 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 377318 */     // MIs[2] Operand 1
     /* 377318 */     // No operand predicates
     /* 377318 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 377322 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377326 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 377330 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377339 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377341 */     // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 377341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 377344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377346 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377348 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 377352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 377356 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 377359 */     GIR_RootConstrainSelectedInstOperands,
     /* 377360 */     // GIR_Coverage, 6022,
     /* 377360 */     GIR_EraseRootFromParent_Done,
     /* 377361 */   // Label 7494: @377361
     /* 377361 */   GIM_Try, /*On fail goto*//*Label 7495*/ GIMT_Encode4(377442), // Rule ID 6054 //
     /* 377366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 377369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 377381 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 377385 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 377389 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 377393 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 377397 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377402 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 377406 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377410 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 377414 */     // MIs[3] Operand 1
     /* 377414 */     // No operand predicates
     /* 377414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377422 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377424 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 377424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 377427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377429 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 377433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 377437 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 377440 */     GIR_RootConstrainSelectedInstOperands,
     /* 377441 */     // GIR_Coverage, 6054,
     /* 377441 */     GIR_EraseRootFromParent_Done,
     /* 377442 */   // Label 7495: @377442
     /* 377442 */   GIM_Try, /*On fail goto*//*Label 7496*/ GIMT_Encode4(377526), // Rule ID 6086 //
     /* 377447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 377450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377458 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 377462 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377467 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377471 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 377475 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 377479 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 377483 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377488 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 377492 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377496 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 377500 */     // MIs[3] Operand 1
     /* 377500 */     // No operand predicates
     /* 377500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377504 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377506 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 377506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 377509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377511 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377513 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 377517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 377521 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 377524 */     GIR_RootConstrainSelectedInstOperands,
     /* 377525 */     // GIR_Coverage, 6086,
     /* 377525 */     GIR_EraseRootFromParent_Done,
     /* 377526 */   // Label 7496: @377526
     /* 377526 */   GIM_Try, /*On fail goto*//*Label 7497*/ GIMT_Encode4(377604), // Rule ID 6130 //
     /* 377531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 377539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 377543 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 377547 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377551 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 377555 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377559 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 377563 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377568 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 377572 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377576 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 377580 */     // MIs[3] Operand 1
     /* 377580 */     // No operand predicates
     /* 377580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377584 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377586 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 377586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 377589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377591 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377593 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 377595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 377599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 377602 */     GIR_RootConstrainSelectedInstOperands,
     /* 377603 */     // GIR_Coverage, 6130,
     /* 377603 */     GIR_EraseRootFromParent_Done,
     /* 377604 */   // Label 7497: @377604
     /* 377604 */   GIM_Try, /*On fail goto*//*Label 7498*/ GIMT_Encode4(377685), // Rule ID 5990 //
     /* 377609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 377612 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 377620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377624 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 377628 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 377632 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 377636 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 377640 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 377644 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377649 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 377653 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377657 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 377661 */     // MIs[3] Operand 1
     /* 377661 */     // No operand predicates
     /* 377661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377665 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377667 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 377667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 377670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377672 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377674 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 377676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 377680 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 377683 */     GIR_RootConstrainSelectedInstOperands,
     /* 377684 */     // GIR_Coverage, 5990,
     /* 377684 */     GIR_EraseRootFromParent_Done,
     /* 377685 */   // Label 7498: @377685
     /* 377685 */   GIM_Try, /*On fail goto*//*Label 7499*/ GIMT_Encode4(377754), // Rule ID 2534 //
     /* 377690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 377693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 377701 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 377705 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377709 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377714 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 377718 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377722 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 377726 */     // MIs[2] Operand 1
     /* 377726 */     // No operand predicates
     /* 377726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377734 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377736 */     // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 377736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 377739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377741 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377743 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 377745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 377749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 377752 */     GIR_RootConstrainSelectedInstOperands,
     /* 377753 */     // GIR_Coverage, 2534,
     /* 377753 */     GIR_EraseRootFromParent_Done,
     /* 377754 */   // Label 7499: @377754
     /* 377754 */   GIM_Try, /*On fail goto*//*Label 7500*/ GIMT_Encode4(377823), // Rule ID 5958 //
     /* 377759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 377762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 377770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 377774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 377778 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377782 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377787 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 377791 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377795 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 377799 */     // MIs[2] Operand 1
     /* 377799 */     // No operand predicates
     /* 377799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377803 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377805 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 377805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 377808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377810 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377812 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 377814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 377818 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 377821 */     GIR_RootConstrainSelectedInstOperands,
     /* 377822 */     // GIR_Coverage, 5958,
     /* 377822 */     GIR_EraseRootFromParent_Done,
     /* 377823 */   // Label 7500: @377823
     /* 377823 */   GIM_Try, /*On fail goto*//*Label 7501*/ GIMT_Encode4(377916), // Rule ID 6112 //
     /* 377828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 377836 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 377840 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 377844 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377848 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 377852 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 377857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377865 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377867 */     // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 377867 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 377870 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377874 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377879 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 377882 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 377886 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 377889 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377894 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 377899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 377902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377904 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 377908 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377914 */     GIR_RootConstrainSelectedInstOperands,
     /* 377915 */     // GIR_Coverage, 6112,
     /* 377915 */     GIR_EraseRootFromParent_Done,
     /* 377916 */   // Label 7501: @377916
     /* 377916 */   GIM_Try, /*On fail goto*//*Label 7502*/ GIMT_Encode4(378015), // Rule ID 6024 //
     /* 377921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 377924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 377932 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 377936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 377941 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377945 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377949 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 377953 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377962 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377964 */     // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 377964 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 377967 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377971 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377976 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 377979 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 377983 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 377986 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377991 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 377996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 377999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378001 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 378007 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378013 */     GIR_RootConstrainSelectedInstOperands,
     /* 378014 */     // GIR_Coverage, 6024,
     /* 378014 */     GIR_EraseRootFromParent_Done,
     /* 378015 */   // Label 7502: @378015
     /* 378015 */   GIM_Try, /*On fail goto*//*Label 7503*/ GIMT_Encode4(378111), // Rule ID 6056 //
     /* 378020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 378023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378031 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 378035 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 378039 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 378043 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 378047 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378060 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378062 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 378062 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 378065 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378069 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378074 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 378077 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 378081 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 378084 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378089 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 378097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378099 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 378103 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378109 */     GIR_RootConstrainSelectedInstOperands,
     /* 378110 */     // GIR_Coverage, 6056,
     /* 378110 */     GIR_EraseRootFromParent_Done,
     /* 378111 */   // Label 7503: @378111
     /* 378111 */   GIM_Try, /*On fail goto*//*Label 7504*/ GIMT_Encode4(378210), // Rule ID 6088 //
     /* 378116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 378119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 378131 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378136 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378140 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 378144 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 378148 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378157 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378159 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 378159 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 378162 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378166 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378171 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 378174 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 378178 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 378181 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378186 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 378194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378196 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 378202 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378208 */     GIR_RootConstrainSelectedInstOperands,
     /* 378209 */     // GIR_Coverage, 6088,
     /* 378209 */     GIR_EraseRootFromParent_Done,
     /* 378210 */   // Label 7504: @378210
     /* 378210 */   GIM_Try, /*On fail goto*//*Label 7505*/ GIMT_Encode4(378303), // Rule ID 6134 //
     /* 378215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 378223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 378227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 378231 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 378235 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378239 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 378243 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378252 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378254 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 378254 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 378257 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378261 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378266 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 378269 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 378273 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 378276 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378281 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 378289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378291 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378293 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 378295 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378301 */     GIR_RootConstrainSelectedInstOperands,
     /* 378302 */     // GIR_Coverage, 6134,
     /* 378302 */     GIR_EraseRootFromParent_Done,
     /* 378303 */   // Label 7505: @378303
     /* 378303 */   GIM_Try, /*On fail goto*//*Label 7506*/ GIMT_Encode4(378399), // Rule ID 5992 //
     /* 378308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 378311 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 378319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378323 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 378327 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 378331 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 378335 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 378339 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378348 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378350 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 378350 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 378353 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378357 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378362 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 378365 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 378369 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 378372 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378377 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 378385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378387 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378389 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 378391 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378397 */     GIR_RootConstrainSelectedInstOperands,
     /* 378398 */     // GIR_Coverage, 5992,
     /* 378398 */     GIR_EraseRootFromParent_Done,
     /* 378399 */   // Label 7506: @378399
     /* 378399 */   GIM_Try, /*On fail goto*//*Label 7507*/ GIMT_Encode4(378483), // Rule ID 2536 //
     /* 378404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 378407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 378415 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 378419 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378432 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 378434 */     // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 378434 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 378437 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378441 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378446 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 378449 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 378453 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 378456 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378461 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 378469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378471 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 378475 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378481 */     GIR_RootConstrainSelectedInstOperands,
     /* 378482 */     // GIR_Coverage, 2536,
     /* 378482 */     GIR_EraseRootFromParent_Done,
     /* 378483 */   // Label 7507: @378483
     /* 378483 */   GIM_Try, /*On fail goto*//*Label 7508*/ GIMT_Encode4(378533), // Rule ID 13052 //
     /* 378488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 378491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 378503 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378516 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 378518 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 378518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 378521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378525 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 378527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 378531 */     GIR_RootConstrainSelectedInstOperands,
     /* 378532 */     // GIR_Coverage, 13052,
     /* 378532 */     GIR_EraseRootFromParent_Done,
     /* 378533 */   // Label 7508: @378533
     /* 378533 */   GIM_Try, /*On fail goto*//*Label 7509*/ GIMT_Encode4(378617), // Rule ID 5960 //
     /* 378538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 378541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 378549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 378553 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 378557 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378566 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 378568 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 378568 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 378571 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378575 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378580 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 378583 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 378587 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 378590 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378595 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 378603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378605 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378607 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 378609 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378615 */     GIR_RootConstrainSelectedInstOperands,
     /* 378616 */     // GIR_Coverage, 5960,
     /* 378616 */     GIR_EraseRootFromParent_Done,
     /* 378617 */   // Label 7509: @378617
     /* 378617 */   GIM_Try, /*On fail goto*//*Label 7510*/ GIMT_Encode4(378667), // Rule ID 1302 //
     /* 378622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 378625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 378633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 378641 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378650 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 378652 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 378652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 378655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378659 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 378661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 378665 */     GIR_RootConstrainSelectedInstOperands,
     /* 378666 */     // GIR_Coverage, 1302,
     /* 378666 */     GIR_EraseRootFromParent_Done,
     /* 378667 */   // Label 7510: @378667
     /* 378667 */   GIM_Try, /*On fail goto*//*Label 7511*/ GIMT_Encode4(378700), // Rule ID 1292 //
     /* 378672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 378675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378687 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 378687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f32),
     /* 378690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378692 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 378696 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 378698 */     GIR_RootConstrainSelectedInstOperands,
     /* 378699 */     // GIR_Coverage, 1292,
     /* 378699 */     GIR_EraseRootFromParent_Done,
     /* 378700 */   // Label 7511: @378700
     /* 378700 */   GIM_Reject,
     /* 378701 */ // Label 7492: @378701
     /* 378701 */ GIM_Reject,
     /* 378702 */ // Label 7343: @378702
     /* 378702 */ GIM_Try, /*On fail goto*//*Label 7512*/ GIMT_Encode4(379880),
     /* 378707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 378710 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 378713 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 378716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378720 */   GIM_Try, /*On fail goto*//*Label 7513*/ GIMT_Encode4(378804), // Rule ID 6006 //
     /* 378725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 378728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 378736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 378740 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 378744 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 378749 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 378753 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378757 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 378761 */     // MIs[2] Operand 1
     /* 378761 */     // No operand predicates
     /* 378761 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 378765 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378769 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 378773 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378782 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378784 */     // (strict_fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 378784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 378787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378789 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 378795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 378799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 378802 */     GIR_RootConstrainSelectedInstOperands,
     /* 378803 */     // GIR_Coverage, 6006,
     /* 378803 */     GIR_EraseRootFromParent_Done,
     /* 378804 */   // Label 7513: @378804
     /* 378804 */   GIM_Try, /*On fail goto*//*Label 7514*/ GIMT_Encode4(378885), // Rule ID 6038 //
     /* 378809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 378812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378820 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 378824 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 378828 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 378832 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 378836 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 378840 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 378845 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 378849 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378853 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 378857 */     // MIs[3] Operand 1
     /* 378857 */     // No operand predicates
     /* 378857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378865 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378867 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 378867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 378870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378872 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 378876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 378880 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 378883 */     GIR_RootConstrainSelectedInstOperands,
     /* 378884 */     // GIR_Coverage, 6038,
     /* 378884 */     GIR_EraseRootFromParent_Done,
     /* 378885 */   // Label 7514: @378885
     /* 378885 */   GIM_Try, /*On fail goto*//*Label 7515*/ GIMT_Encode4(378969), // Rule ID 6070 //
     /* 378890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 378893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378901 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 378905 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378910 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378914 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 378918 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 378922 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 378926 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 378931 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 378935 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378939 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 378943 */     // MIs[3] Operand 1
     /* 378943 */     // No operand predicates
     /* 378943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378947 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378949 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 378949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 378952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378954 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 378960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 378964 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 378967 */     GIR_RootConstrainSelectedInstOperands,
     /* 378968 */     // GIR_Coverage, 6070,
     /* 378968 */     GIR_EraseRootFromParent_Done,
     /* 378969 */   // Label 7515: @378969
     /* 378969 */   GIM_Try, /*On fail goto*//*Label 7516*/ GIMT_Encode4(379050), // Rule ID 5974 //
     /* 378974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 378977 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 378985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378989 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 378993 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 378997 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 379001 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379005 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 379009 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 379014 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 379018 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379022 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 379026 */     // MIs[3] Operand 1
     /* 379026 */     // No operand predicates
     /* 379026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379030 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 379032 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 379032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 379035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379037 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379039 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 379041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 379045 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 379048 */     GIR_RootConstrainSelectedInstOperands,
     /* 379049 */     // GIR_Coverage, 5974,
     /* 379049 */     GIR_EraseRootFromParent_Done,
     /* 379050 */   // Label 7516: @379050
     /* 379050 */   GIM_Try, /*On fail goto*//*Label 7517*/ GIMT_Encode4(379119), // Rule ID 2518 //
     /* 379055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 379066 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379070 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 379074 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 379079 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 379083 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379087 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 379091 */     // MIs[2] Operand 1
     /* 379091 */     // No operand predicates
     /* 379091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379099 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379101 */     // (strict_fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 379101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 379104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379106 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 379110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 379114 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 379117 */     GIR_RootConstrainSelectedInstOperands,
     /* 379118 */     // GIR_Coverage, 2518,
     /* 379118 */     GIR_EraseRootFromParent_Done,
     /* 379119 */   // Label 7517: @379119
     /* 379119 */   GIM_Try, /*On fail goto*//*Label 7518*/ GIMT_Encode4(379188), // Rule ID 5942 //
     /* 379124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379127 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 379135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 379139 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379143 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 379147 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 379152 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 379156 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379160 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 379164 */     // MIs[2] Operand 1
     /* 379164 */     // No operand predicates
     /* 379164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379168 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379170 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 379170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 379173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379175 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379177 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 379179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 379183 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 379186 */     GIR_RootConstrainSelectedInstOperands,
     /* 379187 */     // GIR_Coverage, 5942,
     /* 379187 */     GIR_EraseRootFromParent_Done,
     /* 379188 */   // Label 7518: @379188
     /* 379188 */   GIM_Try, /*On fail goto*//*Label 7519*/ GIMT_Encode4(379287), // Rule ID 6008 //
     /* 379193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 379204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 379208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 379213 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379221 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379225 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379234 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379236 */     // (strict_fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 379236 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 379239 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379243 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379248 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 379251 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 379255 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 379258 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379263 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 379268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 379271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379273 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 379279 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379285 */     GIR_RootConstrainSelectedInstOperands,
     /* 379286 */     // GIR_Coverage, 6008,
     /* 379286 */     GIR_EraseRootFromParent_Done,
     /* 379287 */   // Label 7519: @379287
     /* 379287 */   GIM_Try, /*On fail goto*//*Label 7520*/ GIMT_Encode4(379383), // Rule ID 6040 //
     /* 379292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379307 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 379311 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 379315 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 379319 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 379324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379332 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379334 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 379334 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 379337 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379341 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379346 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 379349 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 379353 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 379356 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379361 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 379366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 379369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379371 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 379375 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379381 */     GIR_RootConstrainSelectedInstOperands,
     /* 379382 */     // GIR_Coverage, 6040,
     /* 379382 */     GIR_EraseRootFromParent_Done,
     /* 379383 */   // Label 7520: @379383
     /* 379383 */   GIM_Try, /*On fail goto*//*Label 7521*/ GIMT_Encode4(379482), // Rule ID 6072 //
     /* 379388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379403 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379408 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379412 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 379416 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 379420 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 379425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379429 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379431 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 379431 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 379434 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379438 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379443 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 379446 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 379450 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 379453 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379458 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 379463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 379466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379468 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379470 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 379474 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379480 */     GIR_RootConstrainSelectedInstOperands,
     /* 379481 */     // GIR_Coverage, 6072,
     /* 379481 */     GIR_EraseRootFromParent_Done,
     /* 379482 */   // Label 7521: @379482
     /* 379482 */   GIM_Try, /*On fail goto*//*Label 7522*/ GIMT_Encode4(379578), // Rule ID 5976 //
     /* 379487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 379498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379506 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 379510 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 379514 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 379518 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 379523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379527 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379529 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 379529 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 379532 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379536 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379541 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 379544 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 379548 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 379551 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379556 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 379561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 379564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379566 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379568 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 379570 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379576 */     GIR_RootConstrainSelectedInstOperands,
     /* 379577 */     // GIR_Coverage, 5976,
     /* 379577 */     GIR_EraseRootFromParent_Done,
     /* 379578 */   // Label 7522: @379578
     /* 379578 */   GIM_Try, /*On fail goto*//*Label 7523*/ GIMT_Encode4(379662), // Rule ID 2520 //
     /* 379583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 379594 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 379598 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 379603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 379613 */     // (strict_fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 379613 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 379616 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379620 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379625 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 379628 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 379632 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 379635 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379640 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 379645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 379648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379650 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 379654 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379660 */     GIR_RootConstrainSelectedInstOperands,
     /* 379661 */     // GIR_Coverage, 2520,
     /* 379661 */     GIR_EraseRootFromParent_Done,
     /* 379662 */   // Label 7523: @379662
     /* 379662 */   GIM_Try, /*On fail goto*//*Label 7524*/ GIMT_Encode4(379712), // Rule ID 13048 //
     /* 379667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379682 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379695 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 379697 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 379697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 379700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379702 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379704 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 379706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 379710 */     GIR_RootConstrainSelectedInstOperands,
     /* 379711 */     // GIR_Coverage, 13048,
     /* 379711 */     GIR_EraseRootFromParent_Done,
     /* 379712 */   // Label 7524: @379712
     /* 379712 */   GIM_Try, /*On fail goto*//*Label 7525*/ GIMT_Encode4(379796), // Rule ID 5944 //
     /* 379717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379720 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 379728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 379732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 379736 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 379741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 379747 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 379747 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 379750 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379754 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379759 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 379762 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 379766 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 379769 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379774 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 379779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 379782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379786 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 379788 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379794 */     GIR_RootConstrainSelectedInstOperands,
     /* 379795 */     // GIR_Coverage, 5944,
     /* 379795 */     GIR_EraseRootFromParent_Done,
     /* 379796 */   // Label 7525: @379796
     /* 379796 */   GIM_Try, /*On fail goto*//*Label 7526*/ GIMT_Encode4(379846), // Rule ID 1298 //
     /* 379801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 379812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379820 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 379831 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 379831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 379834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379836 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379838 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 379840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 379844 */     GIR_RootConstrainSelectedInstOperands,
     /* 379845 */     // GIR_Coverage, 1298,
     /* 379845 */     GIR_EraseRootFromParent_Done,
     /* 379846 */   // Label 7526: @379846
     /* 379846 */   GIM_Try, /*On fail goto*//*Label 7527*/ GIMT_Encode4(379879), // Rule ID 1288 //
     /* 379851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379866 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 379866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8f16),
     /* 379869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379871 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 379875 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 379877 */     GIR_RootConstrainSelectedInstOperands,
     /* 379878 */     // GIR_Coverage, 1288,
     /* 379878 */     GIR_EraseRootFromParent_Done,
     /* 379879 */   // Label 7527: @379879
     /* 379879 */   GIM_Reject,
     /* 379880 */ // Label 7512: @379880
     /* 379880 */ GIM_Reject,
     /* 379881 */ // Label 7344: @379881
     /* 379881 */ GIM_Reject,
     /* 379882 */ // Label 103: @379882
     /* 379882 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7536*/ GIMT_Encode4(380181),
     /* 379893 */ /*GILLT_s16*//*Label 7528*/ GIMT_Encode4(379933),
     /* 379897 */ /*GILLT_s32*//*Label 7529*/ GIMT_Encode4(379964),
     /* 379901 */ /*GILLT_s64*//*Label 7530*/ GIMT_Encode4(379995), GIMT_Encode4(0),
     /* 379909 */ /*GILLT_v2s32*//*Label 7531*/ GIMT_Encode4(380026),
     /* 379913 */ /*GILLT_v2s64*//*Label 7532*/ GIMT_Encode4(380057),
     /* 379917 */ /*GILLT_v4s16*//*Label 7533*/ GIMT_Encode4(380088),
     /* 379921 */ /*GILLT_v4s32*//*Label 7534*/ GIMT_Encode4(380119), GIMT_Encode4(0),
     /* 379929 */ /*GILLT_v8s16*//*Label 7535*/ GIMT_Encode4(380150),
     /* 379933 */ // Label 7528: @379933
     /* 379933 */ GIM_Try, /*On fail goto*//*Label 7537*/ GIMT_Encode4(379963), // Rule ID 569 //
     /* 379938 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 379941 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 379944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379948 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379952 */   // (strict_fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FSQRTHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 379952 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTHr),
     /* 379957 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 379961 */   GIR_RootConstrainSelectedInstOperands,
     /* 379962 */   // GIR_Coverage, 569,
     /* 379962 */   GIR_Done,
     /* 379963 */ // Label 7537: @379963
     /* 379963 */ GIM_Reject,
     /* 379964 */ // Label 7529: @379964
     /* 379964 */ GIM_Try, /*On fail goto*//*Label 7538*/ GIMT_Encode4(379994), // Rule ID 571 //
     /* 379969 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 379972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 379975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379979 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379983 */   // (strict_fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FSQRTSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 379983 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTSr),
     /* 379988 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 379992 */   GIR_RootConstrainSelectedInstOperands,
     /* 379993 */   // GIR_Coverage, 571,
     /* 379993 */   GIR_Done,
     /* 379994 */ // Label 7538: @379994
     /* 379994 */ GIM_Reject,
     /* 379995 */ // Label 7530: @379995
     /* 379995 */ GIM_Try, /*On fail goto*//*Label 7539*/ GIMT_Encode4(380025), // Rule ID 573 //
     /* 380000 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 380003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 380006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380010 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380014 */   // (strict_fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FSQRTDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 380014 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTDr),
     /* 380019 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380023 */   GIR_RootConstrainSelectedInstOperands,
     /* 380024 */   // GIR_Coverage, 573,
     /* 380024 */   GIR_Done,
     /* 380025 */ // Label 7539: @380025
     /* 380025 */ GIM_Reject,
     /* 380026 */ // Label 7531: @380026
     /* 380026 */ GIM_Try, /*On fail goto*//*Label 7540*/ GIMT_Encode4(380056), // Rule ID 952 //
     /* 380031 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 380034 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 380037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380041 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380045 */   // (strict_fsqrt:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FSQRTv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 380045 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f32),
     /* 380050 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380054 */   GIR_RootConstrainSelectedInstOperands,
     /* 380055 */   // GIR_Coverage, 952,
     /* 380055 */   GIR_Done,
     /* 380056 */ // Label 7540: @380056
     /* 380056 */ GIM_Reject,
     /* 380057 */ // Label 7532: @380057
     /* 380057 */ GIM_Try, /*On fail goto*//*Label 7541*/ GIMT_Encode4(380087), // Rule ID 956 //
     /* 380062 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 380065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 380068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380072 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380076 */   // (strict_fsqrt:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FSQRTv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 380076 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f64),
     /* 380081 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380085 */   GIR_RootConstrainSelectedInstOperands,
     /* 380086 */   // GIR_Coverage, 956,
     /* 380086 */   GIR_Done,
     /* 380087 */ // Label 7541: @380087
     /* 380087 */ GIM_Reject,
     /* 380088 */ // Label 7533: @380088
     /* 380088 */ GIM_Try, /*On fail goto*//*Label 7542*/ GIMT_Encode4(380118), // Rule ID 948 //
     /* 380093 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 380096 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 380099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380103 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380107 */   // (strict_fsqrt:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FSQRTv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 380107 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f16),
     /* 380112 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380116 */   GIR_RootConstrainSelectedInstOperands,
     /* 380117 */   // GIR_Coverage, 948,
     /* 380117 */   GIR_Done,
     /* 380118 */ // Label 7542: @380118
     /* 380118 */ GIM_Reject,
     /* 380119 */ // Label 7534: @380119
     /* 380119 */ GIM_Try, /*On fail goto*//*Label 7543*/ GIMT_Encode4(380149), // Rule ID 954 //
     /* 380124 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 380127 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380134 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380138 */   // (strict_fsqrt:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FSQRTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 380138 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f32),
     /* 380143 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380147 */   GIR_RootConstrainSelectedInstOperands,
     /* 380148 */   // GIR_Coverage, 954,
     /* 380148 */   GIR_Done,
     /* 380149 */ // Label 7543: @380149
     /* 380149 */ GIM_Reject,
     /* 380150 */ // Label 7535: @380150
     /* 380150 */ GIM_Try, /*On fail goto*//*Label 7544*/ GIMT_Encode4(380180), // Rule ID 950 //
     /* 380155 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 380158 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 380161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380165 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380169 */   // (strict_fsqrt:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FSQRTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 380169 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv8f16),
     /* 380174 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380178 */   GIR_RootConstrainSelectedInstOperands,
     /* 380179 */   // GIR_Coverage, 950,
     /* 380179 */   GIR_Done,
     /* 380180 */ // Label 7544: @380180
     /* 380180 */ GIM_Reject,
     /* 380181 */ // Label 7536: @380181
     /* 380181 */ GIM_Reject,
     /* 380182 */ // Label 104: @380182
     /* 380182 */ GIM_Try, /*On fail goto*//*Label 7545*/ GIMT_Encode4(380195), // Rule ID 6429 //
     /* 380187 */   // (trap)  =>  (BRK 1:{ *:[i32] })
     /* 380187 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 380190 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 380193 */   GIR_RootConstrainSelectedInstOperands,
     /* 380194 */   // GIR_Coverage, 6429,
     /* 380194 */   GIR_EraseRootFromParent_Done,
     /* 380195 */ // Label 7545: @380195
     /* 380195 */ GIM_Reject,
     /* 380196 */ // Label 105: @380196
     /* 380196 */ GIM_Try, /*On fail goto*//*Label 7546*/ GIMT_Encode4(380216), // Rule ID 6430 //
     /* 380201 */   // (debugtrap)  =>  (BRK 61440:{ *:[i32] })
     /* 380201 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 380204 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(61440),
     /* 380214 */   GIR_RootConstrainSelectedInstOperands,
     /* 380215 */   // GIR_Coverage, 6430,
     /* 380215 */   GIR_EraseRootFromParent_Done,
     /* 380216 */ // Label 7546: @380216
     /* 380216 */ GIM_Reject,
     /* 380217 */ // Label 106: @380217
     /* 380217 */ GIM_Try, /*On fail goto*//*Label 7547*/ GIMT_Encode4(380241), // Rule ID 6431 //
     /* 380222 */   // MIs[0] kind
     /* 380222 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 380225 */   GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_ubsan_trap_imm),
     /* 380230 */   // (ubsantrap (timm:{ *:[i32] })<<P:Predicate_ubsan_trap_imm>><<X:ubsan_trap_xform>>:$kind)  =>  (BRK (ubsan_trap_xform:{ *:[i32] } (timm:{ *:[i32] })<<P:Predicate_ubsan_trap_imm>>:$kind))
     /* 380230 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 380233 */   GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, /*OperandRenderer*/GIMT_Encode2(GICR_renderUbsanTrap), // kind
     /* 380239 */   GIR_RootConstrainSelectedInstOperands,
     /* 380240 */   // GIR_Coverage, 6431,
     /* 380240 */   GIR_EraseRootFromParent_Done,
     /* 380241 */ // Label 7547: @380241
     /* 380241 */ GIM_Reject,
     /* 380242 */ // Label 107: @380242
     /* 380242 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7551*/ GIMT_Encode4(380551),
     /* 380253 */ /*GILLT_s16*//*Label 7548*/ GIMT_Encode4(380265),
     /* 380257 */ /*GILLT_s32*//*Label 7549*/ GIMT_Encode4(380418),
     /* 380261 */ /*GILLT_s64*//*Label 7550*/ GIMT_Encode4(380523),
     /* 380265 */ // Label 7548: @380265
     /* 380265 */ GIM_Try, /*On fail goto*//*Label 7552*/ GIMT_Encode4(380366), // Rule ID 5536 //
     /* 380270 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 380273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 380276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 380280 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380284 */   // (vecreduce_fadd:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv8f16:{ *:[f128] } (FADDPv8f16:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rn), dsub:{ *:[i32] }))
     /* 380284 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 380287 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 380291 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380296 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 380300 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 380304 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 380306 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 380309 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 380313 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380318 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 380321 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 380325 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 380327 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 380330 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 380334 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380339 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 380346 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380351 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380356 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 380359 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 380361 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380364 */   GIR_RootConstrainSelectedInstOperands,
     /* 380365 */   // GIR_Coverage, 5536,
     /* 380365 */   GIR_EraseRootFromParent_Done,
     /* 380366 */ // Label 7552: @380366
     /* 380366 */ GIM_Try, /*On fail goto*//*Label 7553*/ GIMT_Encode4(380417), // Rule ID 5537 //
     /* 380371 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 380374 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 380377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 380381 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380385 */   // (vecreduce_fadd:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FADDPv2i16p:{ *:[f16] } (FADDPv4f16:{ *:[i64] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rn))
     /* 380385 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 380388 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f16),
     /* 380392 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380397 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 380401 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 380405 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380407 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 380410 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 380412 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380415 */   GIR_RootConstrainSelectedInstOperands,
     /* 380416 */   // GIR_Coverage, 5537,
     /* 380416 */   GIR_EraseRootFromParent_Done,
     /* 380417 */ // Label 7553: @380417
     /* 380417 */ GIM_Reject,
     /* 380418 */ // Label 7549: @380418
     /* 380418 */ GIM_Try, /*On fail goto*//*Label 7554*/ GIMT_Encode4(380495), // Rule ID 5538 //
     /* 380423 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380430 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380434 */   // (vecreduce_fadd:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv4f32:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] }))
     /* 380434 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 380437 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 380441 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380446 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 380450 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 380454 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 380456 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 380459 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 380463 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380468 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 380475 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380480 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380485 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 380488 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 380490 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380493 */   GIR_RootConstrainSelectedInstOperands,
     /* 380494 */   // GIR_Coverage, 5538,
     /* 380494 */   GIR_EraseRootFromParent_Done,
     /* 380495 */ // Label 7554: @380495
     /* 380495 */ GIM_Try, /*On fail goto*//*Label 7555*/ GIMT_Encode4(380522), // Rule ID 5539 //
     /* 380500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 380503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380507 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380511 */   // (vecreduce_fadd:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 380511 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 380516 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380520 */   GIR_RootConstrainSelectedInstOperands,
     /* 380521 */   // GIR_Coverage, 5539,
     /* 380521 */   GIR_Done,
     /* 380522 */ // Label 7555: @380522
     /* 380522 */ GIM_Reject,
     /* 380523 */ // Label 7550: @380523
     /* 380523 */ GIM_Try, /*On fail goto*//*Label 7556*/ GIMT_Encode4(380550), // Rule ID 5540 //
     /* 380528 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 380531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380535 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380539 */   // (vecreduce_fadd:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FADDPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 380539 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 380544 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380548 */   GIR_RootConstrainSelectedInstOperands,
     /* 380549 */   // GIR_Coverage, 5540,
     /* 380549 */   GIR_Done,
     /* 380550 */ // Label 7556: @380550
     /* 380550 */ GIM_Reject,
     /* 380551 */ // Label 7551: @380551
     /* 380551 */ GIM_Reject,
     /* 380552 */ // Label 108: @380552
     /* 380552 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7560*/ GIMT_Encode4(380722),
     /* 380563 */ /*GILLT_s16*//*Label 7557*/ GIMT_Encode4(380575),
     /* 380567 */ /*GILLT_s32*//*Label 7558*/ GIMT_Encode4(380636),
     /* 380571 */ /*GILLT_s64*//*Label 7559*/ GIMT_Encode4(380694),
     /* 380575 */ // Label 7557: @380575
     /* 380575 */ GIM_Try, /*On fail goto*//*Label 7561*/ GIMT_Encode4(380605), // Rule ID 1935 //
     /* 380580 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 380583 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 380586 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 380590 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380594 */   // (vecreduce_fmax:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMAXNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 380594 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i16v),
     /* 380599 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380603 */   GIR_RootConstrainSelectedInstOperands,
     /* 380604 */   // GIR_Coverage, 1935,
     /* 380604 */   GIR_Done,
     /* 380605 */ // Label 7561: @380605
     /* 380605 */ GIM_Try, /*On fail goto*//*Label 7562*/ GIMT_Encode4(380635), // Rule ID 1937 //
     /* 380610 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 380613 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 380616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 380620 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380624 */   // (vecreduce_fmax:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMAXNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 380624 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv8i16v),
     /* 380629 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380633 */   GIR_RootConstrainSelectedInstOperands,
     /* 380634 */   // GIR_Coverage, 1937,
     /* 380634 */   GIR_Done,
     /* 380635 */ // Label 7562: @380635
     /* 380635 */ GIM_Reject,
     /* 380636 */ // Label 7558: @380636
     /* 380636 */ GIM_Try, /*On fail goto*//*Label 7563*/ GIMT_Encode4(380666), // Rule ID 1939 //
     /* 380641 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 380644 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380651 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380655 */   // (vecreduce_fmax:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMAXNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 380655 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i32v),
     /* 380660 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380664 */   GIR_RootConstrainSelectedInstOperands,
     /* 380665 */   // GIR_Coverage, 1939,
     /* 380665 */   GIR_Done,
     /* 380666 */ // Label 7563: @380666
     /* 380666 */ GIM_Try, /*On fail goto*//*Label 7564*/ GIMT_Encode4(380693), // Rule ID 5546 //
     /* 380671 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 380674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380678 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380682 */   // (vecreduce_fmax:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMAXNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 380682 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i32p),
     /* 380687 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380691 */   GIR_RootConstrainSelectedInstOperands,
     /* 380692 */   // GIR_Coverage, 5546,
     /* 380692 */   GIR_Done,
     /* 380693 */ // Label 7564: @380693
     /* 380693 */ GIM_Reject,
     /* 380694 */ // Label 7559: @380694
     /* 380694 */ GIM_Try, /*On fail goto*//*Label 7565*/ GIMT_Encode4(380721), // Rule ID 5548 //
     /* 380699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 380702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380706 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380710 */   // (vecreduce_fmax:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMAXNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 380710 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i64p),
     /* 380715 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380719 */   GIR_RootConstrainSelectedInstOperands,
     /* 380720 */   // GIR_Coverage, 5548,
     /* 380720 */   GIR_Done,
     /* 380721 */ // Label 7565: @380721
     /* 380721 */ GIM_Reject,
     /* 380722 */ // Label 7560: @380722
     /* 380722 */ GIM_Reject,
     /* 380723 */ // Label 109: @380723
     /* 380723 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7569*/ GIMT_Encode4(380893),
     /* 380734 */ /*GILLT_s16*//*Label 7566*/ GIMT_Encode4(380746),
     /* 380738 */ /*GILLT_s32*//*Label 7567*/ GIMT_Encode4(380807),
     /* 380742 */ /*GILLT_s64*//*Label 7568*/ GIMT_Encode4(380865),
     /* 380746 */ // Label 7566: @380746
     /* 380746 */ GIM_Try, /*On fail goto*//*Label 7570*/ GIMT_Encode4(380776), // Rule ID 1947 //
     /* 380751 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 380754 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 380757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 380761 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380765 */   // (vecreduce_fmin:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 380765 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i16v),
     /* 380770 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380774 */   GIR_RootConstrainSelectedInstOperands,
     /* 380775 */   // GIR_Coverage, 1947,
     /* 380775 */   GIR_Done,
     /* 380776 */ // Label 7570: @380776
     /* 380776 */ GIM_Try, /*On fail goto*//*Label 7571*/ GIMT_Encode4(380806), // Rule ID 1949 //
     /* 380781 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 380784 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 380787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 380791 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380795 */   // (vecreduce_fmin:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 380795 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv8i16v),
     /* 380800 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380804 */   GIR_RootConstrainSelectedInstOperands,
     /* 380805 */   // GIR_Coverage, 1949,
     /* 380805 */   GIR_Done,
     /* 380806 */ // Label 7571: @380806
     /* 380806 */ GIM_Reject,
     /* 380807 */ // Label 7567: @380807
     /* 380807 */ GIM_Try, /*On fail goto*//*Label 7572*/ GIMT_Encode4(380837), // Rule ID 1951 //
     /* 380812 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 380815 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380818 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380822 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380826 */   // (vecreduce_fmin:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 380826 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i32v),
     /* 380831 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380835 */   GIR_RootConstrainSelectedInstOperands,
     /* 380836 */   // GIR_Coverage, 1951,
     /* 380836 */   GIR_Done,
     /* 380837 */ // Label 7572: @380837
     /* 380837 */ GIM_Try, /*On fail goto*//*Label 7573*/ GIMT_Encode4(380864), // Rule ID 5554 //
     /* 380842 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 380845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380849 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380853 */   // (vecreduce_fmin:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 380853 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i32p),
     /* 380858 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380862 */   GIR_RootConstrainSelectedInstOperands,
     /* 380863 */   // GIR_Coverage, 5554,
     /* 380863 */   GIR_Done,
     /* 380864 */ // Label 7573: @380864
     /* 380864 */ GIM_Reject,
     /* 380865 */ // Label 7568: @380865
     /* 380865 */ GIM_Try, /*On fail goto*//*Label 7574*/ GIMT_Encode4(380892), // Rule ID 5556 //
     /* 380870 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 380873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380877 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380881 */   // (vecreduce_fmin:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 380881 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i64p),
     /* 380886 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380890 */   GIR_RootConstrainSelectedInstOperands,
     /* 380891 */   // GIR_Coverage, 5556,
     /* 380891 */   GIR_Done,
     /* 380892 */ // Label 7574: @380892
     /* 380892 */ GIM_Reject,
     /* 380893 */ // Label 7569: @380893
     /* 380893 */ GIM_Reject,
     /* 380894 */ // Label 110: @380894
     /* 380894 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7578*/ GIMT_Encode4(381064),
     /* 380905 */ /*GILLT_s16*//*Label 7575*/ GIMT_Encode4(380917),
     /* 380909 */ /*GILLT_s32*//*Label 7576*/ GIMT_Encode4(380978),
     /* 380913 */ /*GILLT_s64*//*Label 7577*/ GIMT_Encode4(381036),
     /* 380917 */ // Label 7575: @380917
     /* 380917 */ GIM_Try, /*On fail goto*//*Label 7579*/ GIMT_Encode4(380947), // Rule ID 1941 //
     /* 380922 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 380925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 380928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 380932 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380936 */   // (vecreduce_fmaximum:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMAXVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 380936 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i16v),
     /* 380941 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380945 */   GIR_RootConstrainSelectedInstOperands,
     /* 380946 */   // GIR_Coverage, 1941,
     /* 380946 */   GIR_Done,
     /* 380947 */ // Label 7579: @380947
     /* 380947 */ GIM_Try, /*On fail goto*//*Label 7580*/ GIMT_Encode4(380977), // Rule ID 1943 //
     /* 380952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 380955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 380958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 380962 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380966 */   // (vecreduce_fmaximum:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMAXVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 380966 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv8i16v),
     /* 380971 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380975 */   GIR_RootConstrainSelectedInstOperands,
     /* 380976 */   // GIR_Coverage, 1943,
     /* 380976 */   GIR_Done,
     /* 380977 */ // Label 7580: @380977
     /* 380977 */ GIM_Reject,
     /* 380978 */ // Label 7576: @380978
     /* 380978 */ GIM_Try, /*On fail goto*//*Label 7581*/ GIMT_Encode4(381008), // Rule ID 1945 //
     /* 380983 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 380986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380993 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380997 */   // (vecreduce_fmaximum:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMAXVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 380997 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i32v),
     /* 381002 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 381006 */   GIR_RootConstrainSelectedInstOperands,
     /* 381007 */   // GIR_Coverage, 1945,
     /* 381007 */   GIR_Done,
     /* 381008 */ // Label 7581: @381008
     /* 381008 */ GIM_Try, /*On fail goto*//*Label 7582*/ GIMT_Encode4(381035), // Rule ID 5550 //
     /* 381013 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 381016 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381020 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381024 */   // (vecreduce_fmaximum:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMAXPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 381024 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i32p),
     /* 381029 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 381033 */   GIR_RootConstrainSelectedInstOperands,
     /* 381034 */   // GIR_Coverage, 5550,
     /* 381034 */   GIR_Done,
     /* 381035 */ // Label 7582: @381035
     /* 381035 */ GIM_Reject,
     /* 381036 */ // Label 7577: @381036
     /* 381036 */ GIM_Try, /*On fail goto*//*Label 7583*/ GIMT_Encode4(381063), // Rule ID 5552 //
     /* 381041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 381044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381048 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381052 */   // (vecreduce_fmaximum:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMAXPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 381052 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i64p),
     /* 381057 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 381061 */   GIR_RootConstrainSelectedInstOperands,
     /* 381062 */   // GIR_Coverage, 5552,
     /* 381062 */   GIR_Done,
     /* 381063 */ // Label 7583: @381063
     /* 381063 */ GIM_Reject,
     /* 381064 */ // Label 7578: @381064
     /* 381064 */ GIM_Reject,
     /* 381065 */ // Label 111: @381065
     /* 381065 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7587*/ GIMT_Encode4(381235),
     /* 381076 */ /*GILLT_s16*//*Label 7584*/ GIMT_Encode4(381088),
     /* 381080 */ /*GILLT_s32*//*Label 7585*/ GIMT_Encode4(381149),
     /* 381084 */ /*GILLT_s64*//*Label 7586*/ GIMT_Encode4(381207),
     /* 381088 */ // Label 7584: @381088
     /* 381088 */ GIM_Try, /*On fail goto*//*Label 7588*/ GIMT_Encode4(381118), // Rule ID 1953 //
     /* 381093 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 381096 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 381099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381103 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381107 */   // (vecreduce_fminimum:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 381107 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i16v),
     /* 381112 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 381116 */   GIR_RootConstrainSelectedInstOperands,
     /* 381117 */   // GIR_Coverage, 1953,
     /* 381117 */   GIR_Done,
     /* 381118 */ // Label 7588: @381118
     /* 381118 */ GIM_Try, /*On fail goto*//*Label 7589*/ GIMT_Encode4(381148), // Rule ID 1955 //
     /* 381123 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 381126 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381133 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381137 */   // (vecreduce_fminimum:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 381137 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv8i16v),
     /* 381142 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 381146 */   GIR_RootConstrainSelectedInstOperands,
     /* 381147 */   // GIR_Coverage, 1955,
     /* 381147 */   GIR_Done,
     /* 381148 */ // Label 7589: @381148
     /* 381148 */ GIM_Reject,
     /* 381149 */ // Label 7585: @381149
     /* 381149 */ GIM_Try, /*On fail goto*//*Label 7590*/ GIMT_Encode4(381179), // Rule ID 1957 //
     /* 381154 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 381157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 381160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381164 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381168 */   // (vecreduce_fminimum:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 381168 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i32v),
     /* 381173 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 381177 */   GIR_RootConstrainSelectedInstOperands,
     /* 381178 */   // GIR_Coverage, 1957,
     /* 381178 */   GIR_Done,
     /* 381179 */ // Label 7590: @381179
     /* 381179 */ GIM_Try, /*On fail goto*//*Label 7591*/ GIMT_Encode4(381206), // Rule ID 5558 //
     /* 381184 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 381187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381191 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381195 */   // (vecreduce_fminimum:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 381195 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i32p),
     /* 381200 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 381204 */   GIR_RootConstrainSelectedInstOperands,
     /* 381205 */   // GIR_Coverage, 5558,
     /* 381205 */   GIR_Done,
     /* 381206 */ // Label 7591: @381206
     /* 381206 */ GIM_Reject,
     /* 381207 */ // Label 7586: @381207
     /* 381207 */ GIM_Try, /*On fail goto*//*Label 7592*/ GIMT_Encode4(381234), // Rule ID 5560 //
     /* 381212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 381215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381219 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381223 */   // (vecreduce_fminimum:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 381223 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i64p),
     /* 381228 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 381232 */   GIR_RootConstrainSelectedInstOperands,
     /* 381233 */   // GIR_Coverage, 5560,
     /* 381233 */   GIR_Done,
     /* 381234 */ // Label 7592: @381234
     /* 381234 */ GIM_Reject,
     /* 381235 */ // Label 7587: @381235
     /* 381235 */ GIM_Reject,
     /* 381236 */ // Label 112: @381236
     /* 381236 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(4), /*)*//*default:*//*Label 7597*/ GIMT_Encode4(382364),
     /* 381247 */ /*GILLT_s8*//*Label 7593*/ GIMT_Encode4(381263),
     /* 381251 */ /*GILLT_s16*//*Label 7594*/ GIMT_Encode4(381310),
     /* 381255 */ /*GILLT_s32*//*Label 7595*/ GIMT_Encode4(381725),
     /* 381259 */ /*GILLT_s64*//*Label 7596*/ GIMT_Encode4(382178),
     /* 381263 */ // Label 7593: @381263
     /* 381263 */ GIM_Try, /*On fail goto*//*Label 7598*/ GIMT_Encode4(381286), // Rule ID 5805 //
     /* 381268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 381271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 381275 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381279 */   // (vecreduce_add:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 381279 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 381284 */   GIR_RootConstrainSelectedInstOperands,
     /* 381285 */   // GIR_Coverage, 5805,
     /* 381285 */   GIR_Done,
     /* 381286 */ // Label 7598: @381286
     /* 381286 */ GIM_Try, /*On fail goto*//*Label 7599*/ GIMT_Encode4(381309), // Rule ID 5806 //
     /* 381291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 381294 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 381298 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381302 */   // (vecreduce_add:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 381302 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 381307 */   GIR_RootConstrainSelectedInstOperands,
     /* 381308 */   // GIR_Coverage, 5806,
     /* 381308 */   GIR_Done,
     /* 381309 */ // Label 7599: @381309
     /* 381309 */ GIM_Reject,
     /* 381310 */ // Label 7594: @381310
     /* 381310 */ GIM_Try, /*On fail goto*//*Label 7600*/ GIMT_Encode4(381360), // Rule ID 5752 //
     /* 381315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 381318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381322 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381326 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 381330 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 381333 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 381338 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 381342 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381347 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 381349 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 381349 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 381352 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381354 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 381358 */   GIR_RootConstrainSelectedInstOperands,
     /* 381359 */   // GIR_Coverage, 5752,
     /* 381359 */   GIR_EraseRootFromParent_Done,
     /* 381360 */ // Label 7600: @381360
     /* 381360 */ GIM_Try, /*On fail goto*//*Label 7601*/ GIMT_Encode4(381410), // Rule ID 5754 //
     /* 381365 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381372 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381376 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 381380 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 381383 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 381388 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 381392 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381397 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 381399 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 381399 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 381402 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381404 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 381408 */   GIR_RootConstrainSelectedInstOperands,
     /* 381409 */   // GIR_Coverage, 5754,
     /* 381409 */   GIR_EraseRootFromParent_Done,
     /* 381410 */ // Label 7601: @381410
     /* 381410 */ GIM_Try, /*On fail goto*//*Label 7602*/ GIMT_Encode4(381460), // Rule ID 5762 //
     /* 381415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 381418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381422 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381426 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 381430 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 381433 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 381438 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 381442 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381447 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 381449 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v4i16] } 660:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 381449 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
     /* 381452 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381454 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 381458 */   GIR_RootConstrainSelectedInstOperands,
     /* 381459 */   // GIR_Coverage, 5762,
     /* 381459 */   GIR_EraseRootFromParent_Done,
     /* 381460 */ // Label 7602: @381460
     /* 381460 */ GIM_Try, /*On fail goto*//*Label 7603*/ GIMT_Encode4(381510), // Rule ID 5764 //
     /* 381465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381472 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381476 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 381480 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 381483 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 381488 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 381492 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381497 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 381499 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v8i16] } 660:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 381499 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
     /* 381502 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381504 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 381508 */   GIR_RootConstrainSelectedInstOperands,
     /* 381509 */   // GIR_Coverage, 5764,
     /* 381509 */   GIR_EraseRootFromParent_Done,
     /* 381510 */ // Label 7603: @381510
     /* 381510 */ GIM_Try, /*On fail goto*//*Label 7604*/ GIMT_Encode4(381552), // Rule ID 5761 //
     /* 381515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 381518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381522 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381526 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 381530 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 381534 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381539 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 381541 */   // (vecreduce_add:{ *:[i16] } (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 381541 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
     /* 381544 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381546 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 381550 */   GIR_RootConstrainSelectedInstOperands,
     /* 381551 */   // GIR_Coverage, 5761,
     /* 381551 */   GIR_EraseRootFromParent_Done,
     /* 381552 */ // Label 7604: @381552
     /* 381552 */ GIM_Try, /*On fail goto*//*Label 7605*/ GIMT_Encode4(381594), // Rule ID 5763 //
     /* 381557 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381564 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381568 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 381572 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 381576 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381581 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 381583 */   // (vecreduce_add:{ *:[i16] } (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 381583 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
     /* 381586 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381588 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 381592 */   GIR_RootConstrainSelectedInstOperands,
     /* 381593 */   // GIR_Coverage, 5763,
     /* 381593 */   GIR_EraseRootFromParent_Done,
     /* 381594 */ // Label 7605: @381594
     /* 381594 */ GIM_Try, /*On fail goto*//*Label 7606*/ GIMT_Encode4(381636), // Rule ID 5751 //
     /* 381599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 381602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381606 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381610 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 381614 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 381618 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381623 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 381625 */   // (vecreduce_add:{ *:[i16] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 381625 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 381628 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381630 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 381634 */   GIR_RootConstrainSelectedInstOperands,
     /* 381635 */   // GIR_Coverage, 5751,
     /* 381635 */   GIR_EraseRootFromParent_Done,
     /* 381636 */ // Label 7606: @381636
     /* 381636 */ GIM_Try, /*On fail goto*//*Label 7607*/ GIMT_Encode4(381678), // Rule ID 5753 //
     /* 381641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381648 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381652 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 381656 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 381660 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381665 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 381667 */   // (vecreduce_add:{ *:[i16] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 381667 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 381670 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381672 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 381676 */   GIR_RootConstrainSelectedInstOperands,
     /* 381677 */   // GIR_Coverage, 5753,
     /* 381677 */   GIR_EraseRootFromParent_Done,
     /* 381678 */ // Label 7607: @381678
     /* 381678 */ GIM_Try, /*On fail goto*//*Label 7608*/ GIMT_Encode4(381701), // Rule ID 5807 //
     /* 381683 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 381686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381690 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381694 */   // (vecreduce_add:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 381694 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 381699 */   GIR_RootConstrainSelectedInstOperands,
     /* 381700 */   // GIR_Coverage, 5807,
     /* 381700 */   GIR_Done,
     /* 381701 */ // Label 7608: @381701
     /* 381701 */ GIM_Try, /*On fail goto*//*Label 7609*/ GIMT_Encode4(381724), // Rule ID 5808 //
     /* 381706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381713 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381717 */   // (vecreduce_add:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 381717 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 381722 */   GIR_RootConstrainSelectedInstOperands,
     /* 381723 */   // GIR_Coverage, 5808,
     /* 381723 */   GIR_Done,
     /* 381724 */ // Label 7609: @381724
     /* 381724 */ GIM_Reject,
     /* 381725 */ // Label 7595: @381725
     /* 381725 */ GIM_Try, /*On fail goto*//*Label 7610*/ GIMT_Encode4(381775), // Rule ID 5756 //
     /* 381730 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 381733 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381737 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381741 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 381745 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 381748 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 381753 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 381757 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381762 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 381764 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 381764 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 381767 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381769 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 381773 */   GIR_RootConstrainSelectedInstOperands,
     /* 381774 */   // GIR_Coverage, 5756,
     /* 381774 */   GIR_EraseRootFromParent_Done,
     /* 381775 */ // Label 7610: @381775
     /* 381775 */ GIM_Try, /*On fail goto*//*Label 7611*/ GIMT_Encode4(381825), // Rule ID 5758 //
     /* 381780 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 381783 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381787 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381791 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 381795 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 381798 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 381803 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 381807 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381812 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 381814 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v2i32] } 725:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 381814 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
     /* 381817 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381819 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 381823 */   GIR_RootConstrainSelectedInstOperands,
     /* 381824 */   // GIR_Coverage, 5758,
     /* 381824 */   GIR_EraseRootFromParent_Done,
     /* 381825 */ // Label 7611: @381825
     /* 381825 */ GIM_Try, /*On fail goto*//*Label 7612*/ GIMT_Encode4(381875), // Rule ID 5766 //
     /* 381830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 381833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381837 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381841 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 381845 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 381848 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 381853 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 381857 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381862 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 381864 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 660:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 381864 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
     /* 381867 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381869 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 381873 */   GIR_RootConstrainSelectedInstOperands,
     /* 381874 */   // GIR_Coverage, 5766,
     /* 381874 */   GIR_EraseRootFromParent_Done,
     /* 381875 */ // Label 7612: @381875
     /* 381875 */ GIM_Try, /*On fail goto*//*Label 7613*/ GIMT_Encode4(381925), // Rule ID 5768 //
     /* 381880 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 381883 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381887 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381891 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 381895 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 381898 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 381903 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 381907 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381912 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 381914 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v2i32] } 660:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 381914 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
     /* 381917 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381919 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 381923 */   GIR_RootConstrainSelectedInstOperands,
     /* 381924 */   // GIR_Coverage, 5768,
     /* 381924 */   GIR_EraseRootFromParent_Done,
     /* 381925 */ // Label 7613: @381925
     /* 381925 */ GIM_Try, /*On fail goto*//*Label 7614*/ GIMT_Encode4(381967), // Rule ID 5765 //
     /* 381930 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 381933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381937 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381941 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 381945 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 381949 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381954 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 381956 */   // (vecreduce_add:{ *:[i32] } (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 381956 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
     /* 381959 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381961 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 381965 */   GIR_RootConstrainSelectedInstOperands,
     /* 381966 */   // GIR_Coverage, 5765,
     /* 381966 */   GIR_EraseRootFromParent_Done,
     /* 381967 */ // Label 7614: @381967
     /* 381967 */ GIM_Try, /*On fail goto*//*Label 7615*/ GIMT_Encode4(382009), // Rule ID 5767 //
     /* 381972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 381975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381979 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381983 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 381987 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 381991 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381996 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 381998 */   // (vecreduce_add:{ *:[i32] } (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 381998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
     /* 382001 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 382003 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 382007 */   GIR_RootConstrainSelectedInstOperands,
     /* 382008 */   // GIR_Coverage, 5767,
     /* 382008 */   GIR_EraseRootFromParent_Done,
     /* 382009 */ // Label 7615: @382009
     /* 382009 */ GIM_Try, /*On fail goto*//*Label 7616*/ GIMT_Encode4(382051), // Rule ID 5755 //
     /* 382014 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 382017 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382021 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382025 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 382029 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 382033 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382038 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 382040 */   // (vecreduce_add:{ *:[i32] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 382040 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 382043 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 382045 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 382049 */   GIR_RootConstrainSelectedInstOperands,
     /* 382050 */   // GIR_Coverage, 5755,
     /* 382050 */   GIR_EraseRootFromParent_Done,
     /* 382051 */ // Label 7616: @382051
     /* 382051 */ GIM_Try, /*On fail goto*//*Label 7617*/ GIMT_Encode4(382093), // Rule ID 5757 //
     /* 382056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 382059 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382063 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382067 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 382071 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 382075 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382080 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 382082 */   // (vecreduce_add:{ *:[i32] } (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 382082 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
     /* 382085 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 382087 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 382091 */   GIR_RootConstrainSelectedInstOperands,
     /* 382092 */   // GIR_Coverage, 5757,
     /* 382092 */   GIR_EraseRootFromParent_Done,
     /* 382093 */ // Label 7617: @382093
     /* 382093 */ GIM_Try, /*On fail goto*//*Label 7618*/ GIMT_Encode4(382154), // Rule ID 5809 //
     /* 382098 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 382101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382105 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382109 */   // (vecreduce_add:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 382109 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 382112 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 382116 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382121 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 382125 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 382129 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382131 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382134 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382136 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 382143 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382148 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382153 */   // GIR_Coverage, 5809,
     /* 382153 */   GIR_EraseRootFromParent_Done,
     /* 382154 */ // Label 7618: @382154
     /* 382154 */ GIM_Try, /*On fail goto*//*Label 7619*/ GIMT_Encode4(382177), // Rule ID 5810 //
     /* 382159 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 382162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382166 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382170 */   // (vecreduce_add:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 382170 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
     /* 382175 */   GIR_RootConstrainSelectedInstOperands,
     /* 382176 */   // GIR_Coverage, 5810,
     /* 382176 */   GIR_Done,
     /* 382177 */ // Label 7619: @382177
     /* 382177 */ GIM_Reject,
     /* 382178 */ // Label 7596: @382178
     /* 382178 */ GIM_Try, /*On fail goto*//*Label 7620*/ GIMT_Encode4(382363),
     /* 382183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 382186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382190 */   GIM_Try, /*On fail goto*//*Label 7621*/ GIMT_Encode4(382233), // Rule ID 5760 //
     /* 382195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 382203 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 382206 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 382211 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 382215 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382220 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 382222 */     // (vecreduce_add:{ *:[i64] } (intrinsic_wo_chain:{ *:[v2i64] } 725:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 382222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
     /* 382225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 382227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 382231 */     GIR_RootConstrainSelectedInstOperands,
     /* 382232 */     // GIR_Coverage, 5760,
     /* 382232 */     GIR_EraseRootFromParent_Done,
     /* 382233 */   // Label 7621: @382233
     /* 382233 */   GIM_Try, /*On fail goto*//*Label 7622*/ GIMT_Encode4(382276), // Rule ID 5770 //
     /* 382238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 382246 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 382249 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 382254 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 382258 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 382265 */     // (vecreduce_add:{ *:[i64] } (intrinsic_wo_chain:{ *:[v2i64] } 660:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 382265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
     /* 382268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 382270 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 382274 */     GIR_RootConstrainSelectedInstOperands,
     /* 382275 */     // GIR_Coverage, 5770,
     /* 382275 */     GIR_EraseRootFromParent_Done,
     /* 382276 */   // Label 7622: @382276
     /* 382276 */   GIM_Try, /*On fail goto*//*Label 7623*/ GIMT_Encode4(382311), // Rule ID 5769 //
     /* 382281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 382289 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 382293 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382298 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 382300 */     // (vecreduce_add:{ *:[i64] } (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 382300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
     /* 382303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 382305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 382309 */     GIR_RootConstrainSelectedInstOperands,
     /* 382310 */     // GIR_Coverage, 5769,
     /* 382310 */     GIR_EraseRootFromParent_Done,
     /* 382311 */   // Label 7623: @382311
     /* 382311 */   GIM_Try, /*On fail goto*//*Label 7624*/ GIMT_Encode4(382346), // Rule ID 5759 //
     /* 382316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 382324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 382328 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 382335 */     // (vecreduce_add:{ *:[i64] } (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 382335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
     /* 382338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 382340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 382344 */     GIR_RootConstrainSelectedInstOperands,
     /* 382345 */     // GIR_Coverage, 5759,
     /* 382345 */     GIR_EraseRootFromParent_Done,
     /* 382346 */   // Label 7624: @382346
     /* 382346 */   GIM_Try, /*On fail goto*//*Label 7625*/ GIMT_Encode4(382362), // Rule ID 5811 //
     /* 382351 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382355 */     // (vecreduce_add:{ *:[i64] } V128:{ *:[v2i64] }:$Rn)  =>  (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn)
     /* 382355 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /* 382360 */     GIR_RootConstrainSelectedInstOperands,
     /* 382361 */     // GIR_Coverage, 5811,
     /* 382361 */     GIR_Done,
     /* 382362 */   // Label 7625: @382362
     /* 382362 */   GIM_Reject,
     /* 382363 */ // Label 7620: @382363
     /* 382363 */ GIM_Reject,
     /* 382364 */ // Label 7597: @382364
     /* 382364 */ GIM_Reject,
     /* 382365 */ // Label 113: @382365
     /* 382365 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 7629*/ GIMT_Encode4(382567),
     /* 382376 */ /*GILLT_s8*//*Label 7626*/ GIMT_Encode4(382388),
     /* 382380 */ /*GILLT_s16*//*Label 7627*/ GIMT_Encode4(382435),
     /* 382384 */ /*GILLT_s32*//*Label 7628*/ GIMT_Encode4(382482),
     /* 382388 */ // Label 7626: @382388
     /* 382388 */ GIM_Try, /*On fail goto*//*Label 7630*/ GIMT_Encode4(382411), // Rule ID 5902 //
     /* 382393 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 382396 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 382400 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382404 */   // (vecreduce_smax:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (SMAXVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 382404 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
     /* 382409 */   GIR_RootConstrainSelectedInstOperands,
     /* 382410 */   // GIR_Coverage, 5902,
     /* 382410 */   GIR_Done,
     /* 382411 */ // Label 7630: @382411
     /* 382411 */ GIM_Try, /*On fail goto*//*Label 7631*/ GIMT_Encode4(382434), // Rule ID 5903 //
     /* 382416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 382419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 382423 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382427 */   // (vecreduce_smax:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (SMAXVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 382427 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
     /* 382432 */   GIR_RootConstrainSelectedInstOperands,
     /* 382433 */   // GIR_Coverage, 5903,
     /* 382433 */   GIR_Done,
     /* 382434 */ // Label 7631: @382434
     /* 382434 */ GIM_Reject,
     /* 382435 */ // Label 7627: @382435
     /* 382435 */ GIM_Try, /*On fail goto*//*Label 7632*/ GIMT_Encode4(382458), // Rule ID 5904 //
     /* 382440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 382443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382447 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382451 */   // (vecreduce_smax:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (SMAXVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 382451 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
     /* 382456 */   GIR_RootConstrainSelectedInstOperands,
     /* 382457 */   // GIR_Coverage, 5904,
     /* 382457 */   GIR_Done,
     /* 382458 */ // Label 7632: @382458
     /* 382458 */ GIM_Try, /*On fail goto*//*Label 7633*/ GIMT_Encode4(382481), // Rule ID 5905 //
     /* 382463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 382466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382470 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382474 */   // (vecreduce_smax:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (SMAXVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 382474 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
     /* 382479 */   GIR_RootConstrainSelectedInstOperands,
     /* 382480 */   // GIR_Coverage, 5905,
     /* 382480 */   GIR_Done,
     /* 382481 */ // Label 7633: @382481
     /* 382481 */ GIM_Reject,
     /* 382482 */ // Label 7628: @382482
     /* 382482 */ GIM_Try, /*On fail goto*//*Label 7634*/ GIMT_Encode4(382505), // Rule ID 5906 //
     /* 382487 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 382490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382494 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382498 */   // (vecreduce_smax:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (SMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 382498 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i32v),
     /* 382503 */   GIR_RootConstrainSelectedInstOperands,
     /* 382504 */   // GIR_Coverage, 5906,
     /* 382504 */   GIR_Done,
     /* 382505 */ // Label 7634: @382505
     /* 382505 */ GIM_Try, /*On fail goto*//*Label 7635*/ GIMT_Encode4(382566), // Rule ID 5907 //
     /* 382510 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 382513 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382517 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382521 */   // (vecreduce_smax:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (SMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 382521 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 382524 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
     /* 382528 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382533 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 382537 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 382541 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382543 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382546 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382548 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 382555 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382560 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382565 */   // GIR_Coverage, 5907,
     /* 382565 */   GIR_EraseRootFromParent_Done,
     /* 382566 */ // Label 7635: @382566
     /* 382566 */ GIM_Reject,
     /* 382567 */ // Label 7629: @382567
     /* 382567 */ GIM_Reject,
     /* 382568 */ // Label 114: @382568
     /* 382568 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 7639*/ GIMT_Encode4(382770),
     /* 382579 */ /*GILLT_s8*//*Label 7636*/ GIMT_Encode4(382591),
     /* 382583 */ /*GILLT_s16*//*Label 7637*/ GIMT_Encode4(382638),
     /* 382587 */ /*GILLT_s32*//*Label 7638*/ GIMT_Encode4(382685),
     /* 382591 */ // Label 7636: @382591
     /* 382591 */ GIM_Try, /*On fail goto*//*Label 7640*/ GIMT_Encode4(382614), // Rule ID 5896 //
     /* 382596 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 382599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 382603 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382607 */   // (vecreduce_smin:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (SMINVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 382607 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
     /* 382612 */   GIR_RootConstrainSelectedInstOperands,
     /* 382613 */   // GIR_Coverage, 5896,
     /* 382613 */   GIR_Done,
     /* 382614 */ // Label 7640: @382614
     /* 382614 */ GIM_Try, /*On fail goto*//*Label 7641*/ GIMT_Encode4(382637), // Rule ID 5897 //
     /* 382619 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 382622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 382626 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382630 */   // (vecreduce_smin:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (SMINVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 382630 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
     /* 382635 */   GIR_RootConstrainSelectedInstOperands,
     /* 382636 */   // GIR_Coverage, 5897,
     /* 382636 */   GIR_Done,
     /* 382637 */ // Label 7641: @382637
     /* 382637 */ GIM_Reject,
     /* 382638 */ // Label 7637: @382638
     /* 382638 */ GIM_Try, /*On fail goto*//*Label 7642*/ GIMT_Encode4(382661), // Rule ID 5898 //
     /* 382643 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 382646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382650 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382654 */   // (vecreduce_smin:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (SMINVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 382654 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
     /* 382659 */   GIR_RootConstrainSelectedInstOperands,
     /* 382660 */   // GIR_Coverage, 5898,
     /* 382660 */   GIR_Done,
     /* 382661 */ // Label 7642: @382661
     /* 382661 */ GIM_Try, /*On fail goto*//*Label 7643*/ GIMT_Encode4(382684), // Rule ID 5899 //
     /* 382666 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 382669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382673 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382677 */   // (vecreduce_smin:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (SMINVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 382677 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
     /* 382682 */   GIR_RootConstrainSelectedInstOperands,
     /* 382683 */   // GIR_Coverage, 5899,
     /* 382683 */   GIR_Done,
     /* 382684 */ // Label 7643: @382684
     /* 382684 */ GIM_Reject,
     /* 382685 */ // Label 7638: @382685
     /* 382685 */ GIM_Try, /*On fail goto*//*Label 7644*/ GIMT_Encode4(382708), // Rule ID 5900 //
     /* 382690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 382693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382697 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382701 */   // (vecreduce_smin:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (SMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 382701 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i32v),
     /* 382706 */   GIR_RootConstrainSelectedInstOperands,
     /* 382707 */   // GIR_Coverage, 5900,
     /* 382707 */   GIR_Done,
     /* 382708 */ // Label 7644: @382708
     /* 382708 */ GIM_Try, /*On fail goto*//*Label 7645*/ GIMT_Encode4(382769), // Rule ID 5901 //
     /* 382713 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 382716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382720 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382724 */   // (vecreduce_smin:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (SMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 382724 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 382727 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
     /* 382731 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382736 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 382740 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 382744 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382746 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382749 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382751 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 382758 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382763 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382768 */   // GIR_Coverage, 5901,
     /* 382768 */   GIR_EraseRootFromParent_Done,
     /* 382769 */ // Label 7645: @382769
     /* 382769 */ GIM_Reject,
     /* 382770 */ // Label 7639: @382770
     /* 382770 */ GIM_Reject,
     /* 382771 */ // Label 115: @382771
     /* 382771 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 7649*/ GIMT_Encode4(382973),
     /* 382782 */ /*GILLT_s8*//*Label 7646*/ GIMT_Encode4(382794),
     /* 382786 */ /*GILLT_s16*//*Label 7647*/ GIMT_Encode4(382841),
     /* 382790 */ /*GILLT_s32*//*Label 7648*/ GIMT_Encode4(382888),
     /* 382794 */ // Label 7646: @382794
     /* 382794 */ GIM_Try, /*On fail goto*//*Label 7650*/ GIMT_Encode4(382817), // Rule ID 5890 //
     /* 382799 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 382802 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 382806 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382810 */   // (vecreduce_umax:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (UMAXVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 382810 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
     /* 382815 */   GIR_RootConstrainSelectedInstOperands,
     /* 382816 */   // GIR_Coverage, 5890,
     /* 382816 */   GIR_Done,
     /* 382817 */ // Label 7650: @382817
     /* 382817 */ GIM_Try, /*On fail goto*//*Label 7651*/ GIMT_Encode4(382840), // Rule ID 5891 //
     /* 382822 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 382825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 382829 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382833 */   // (vecreduce_umax:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (UMAXVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 382833 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
     /* 382838 */   GIR_RootConstrainSelectedInstOperands,
     /* 382839 */   // GIR_Coverage, 5891,
     /* 382839 */   GIR_Done,
     /* 382840 */ // Label 7651: @382840
     /* 382840 */ GIM_Reject,
     /* 382841 */ // Label 7647: @382841
     /* 382841 */ GIM_Try, /*On fail goto*//*Label 7652*/ GIMT_Encode4(382864), // Rule ID 5892 //
     /* 382846 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 382849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382853 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382857 */   // (vecreduce_umax:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (UMAXVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 382857 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
     /* 382862 */   GIR_RootConstrainSelectedInstOperands,
     /* 382863 */   // GIR_Coverage, 5892,
     /* 382863 */   GIR_Done,
     /* 382864 */ // Label 7652: @382864
     /* 382864 */ GIM_Try, /*On fail goto*//*Label 7653*/ GIMT_Encode4(382887), // Rule ID 5893 //
     /* 382869 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 382872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382876 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382880 */   // (vecreduce_umax:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (UMAXVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 382880 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
     /* 382885 */   GIR_RootConstrainSelectedInstOperands,
     /* 382886 */   // GIR_Coverage, 5893,
     /* 382886 */   GIR_Done,
     /* 382887 */ // Label 7653: @382887
     /* 382887 */ GIM_Reject,
     /* 382888 */ // Label 7648: @382888
     /* 382888 */ GIM_Try, /*On fail goto*//*Label 7654*/ GIMT_Encode4(382911), // Rule ID 5894 //
     /* 382893 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 382896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382900 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382904 */   // (vecreduce_umax:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (UMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 382904 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i32v),
     /* 382909 */   GIR_RootConstrainSelectedInstOperands,
     /* 382910 */   // GIR_Coverage, 5894,
     /* 382910 */   GIR_Done,
     /* 382911 */ // Label 7654: @382911
     /* 382911 */ GIM_Try, /*On fail goto*//*Label 7655*/ GIMT_Encode4(382972), // Rule ID 5895 //
     /* 382916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 382919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382923 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382927 */   // (vecreduce_umax:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (UMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 382927 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 382930 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
     /* 382934 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382939 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 382943 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 382947 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382949 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382952 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382954 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 382961 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382966 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382971 */   // GIR_Coverage, 5895,
     /* 382971 */   GIR_EraseRootFromParent_Done,
     /* 382972 */ // Label 7655: @382972
     /* 382972 */ GIM_Reject,
     /* 382973 */ // Label 7649: @382973
     /* 382973 */ GIM_Reject,
     /* 382974 */ // Label 116: @382974
     /* 382974 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 7659*/ GIMT_Encode4(383176),
     /* 382985 */ /*GILLT_s8*//*Label 7656*/ GIMT_Encode4(382997),
     /* 382989 */ /*GILLT_s16*//*Label 7657*/ GIMT_Encode4(383044),
     /* 382993 */ /*GILLT_s32*//*Label 7658*/ GIMT_Encode4(383091),
     /* 382997 */ // Label 7656: @382997
     /* 382997 */ GIM_Try, /*On fail goto*//*Label 7660*/ GIMT_Encode4(383020), // Rule ID 5884 //
     /* 383002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 383005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 383009 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383013 */   // (vecreduce_umin:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (UMINVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 383013 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
     /* 383018 */   GIR_RootConstrainSelectedInstOperands,
     /* 383019 */   // GIR_Coverage, 5884,
     /* 383019 */   GIR_Done,
     /* 383020 */ // Label 7660: @383020
     /* 383020 */ GIM_Try, /*On fail goto*//*Label 7661*/ GIMT_Encode4(383043), // Rule ID 5885 //
     /* 383025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 383028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 383032 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383036 */   // (vecreduce_umin:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (UMINVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 383036 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
     /* 383041 */   GIR_RootConstrainSelectedInstOperands,
     /* 383042 */   // GIR_Coverage, 5885,
     /* 383042 */   GIR_Done,
     /* 383043 */ // Label 7661: @383043
     /* 383043 */ GIM_Reject,
     /* 383044 */ // Label 7657: @383044
     /* 383044 */ GIM_Try, /*On fail goto*//*Label 7662*/ GIMT_Encode4(383067), // Rule ID 5886 //
     /* 383049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 383052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383056 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383060 */   // (vecreduce_umin:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (UMINVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 383060 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
     /* 383065 */   GIR_RootConstrainSelectedInstOperands,
     /* 383066 */   // GIR_Coverage, 5886,
     /* 383066 */   GIR_Done,
     /* 383067 */ // Label 7662: @383067
     /* 383067 */ GIM_Try, /*On fail goto*//*Label 7663*/ GIMT_Encode4(383090), // Rule ID 5887 //
     /* 383072 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 383075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383079 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383083 */   // (vecreduce_umin:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (UMINVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 383083 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
     /* 383088 */   GIR_RootConstrainSelectedInstOperands,
     /* 383089 */   // GIR_Coverage, 5887,
     /* 383089 */   GIR_Done,
     /* 383090 */ // Label 7663: @383090
     /* 383090 */ GIM_Reject,
     /* 383091 */ // Label 7658: @383091
     /* 383091 */ GIM_Try, /*On fail goto*//*Label 7664*/ GIMT_Encode4(383114), // Rule ID 5888 //
     /* 383096 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 383099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383103 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383107 */   // (vecreduce_umin:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (UMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 383107 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i32v),
     /* 383112 */   GIR_RootConstrainSelectedInstOperands,
     /* 383113 */   // GIR_Coverage, 5888,
     /* 383113 */   GIR_Done,
     /* 383114 */ // Label 7664: @383114
     /* 383114 */ GIM_Try, /*On fail goto*//*Label 7665*/ GIMT_Encode4(383175), // Rule ID 5889 //
     /* 383119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 383122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383126 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383130 */   // (vecreduce_umin:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (UMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 383130 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 383133 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
     /* 383137 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383142 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 383146 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 383150 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383152 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383155 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383157 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 383164 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 383169 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383174 */   // GIR_Coverage, 5889,
     /* 383174 */   GIR_EraseRootFromParent_Done,
     /* 383175 */ // Label 7665: @383175
     /* 383175 */ GIM_Reject,
     /* 383176 */ // Label 7659: @383176
     /* 383176 */ GIM_Reject,
     /* 383177 */ // Label 117: @383177
     /* 383177 */ GIM_Try, /*On fail goto*//*Label 7666*/ GIMT_Encode4(383316),
     /* 383182 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 383185 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 383189 */   GIM_Try, /*On fail goto*//*Label 7667*/ GIMT_Encode4(383223), // Rule ID 257 //
     /* 383194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 383201 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))  =>  (PRFMroW (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 383201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMroW),
     /* 383204 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 383206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 383216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 383221 */     GIR_RootConstrainSelectedInstOperands,
     /* 383222 */     // GIR_Coverage, 257,
     /* 383222 */     GIR_EraseRootFromParent_Done,
     /* 383223 */   // Label 7667: @383223
     /* 383223 */   GIM_Try, /*On fail goto*//*Label 7668*/ GIMT_Encode4(383257), // Rule ID 258 //
     /* 383228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 383235 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))  =>  (PRFMroX (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 383235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMroX),
     /* 383238 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 383240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 383250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 383255 */     GIR_RootConstrainSelectedInstOperands,
     /* 383256 */     // GIR_Coverage, 258,
     /* 383256 */     GIR_EraseRootFromParent_Done,
     /* 383257 */   // Label 7668: @383257
     /* 383257 */   GIM_Try, /*On fail goto*//*Label 7669*/ GIMT_Encode4(383286), // Rule ID 273 //
     /* 383262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 383269 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))  =>  (PRFMui (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 383269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMui),
     /* 383272 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 383274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 383284 */     GIR_RootConstrainSelectedInstOperands,
     /* 383285 */     // GIR_Coverage, 273,
     /* 383285 */     GIR_EraseRootFromParent_Done,
     /* 383286 */   // Label 7669: @383286
     /* 383286 */   GIM_Try, /*On fail goto*//*Label 7670*/ GIMT_Encode4(383315), // Rule ID 294 //
     /* 383291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 383298 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))  =>  (PRFUMi (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 383298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFUMi),
     /* 383301 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 383303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 383313 */     GIR_RootConstrainSelectedInstOperands,
     /* 383314 */     // GIR_Coverage, 294,
     /* 383314 */     GIR_EraseRootFromParent_Done,
     /* 383315 */   // Label 7670: @383315
     /* 383315 */   GIM_Reject,
     /* 383316 */ // Label 7666: @383316
     /* 383316 */ GIM_Reject,
     /* 383317 */ // Label 118: @383317
     /* 383317 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 7683*/ GIMT_Encode4(383856),
     /* 383328 */ /*GILLT_s64*//*Label 7671*/ GIMT_Encode4(383412), GIMT_Encode4(0),
     /* 383336 */ /*GILLT_v2s32*//*Label 7672*/ GIMT_Encode4(383450),
     /* 383340 */ /*GILLT_v2s64*//*Label 7673*/ GIMT_Encode4(383488),
     /* 383344 */ /*GILLT_v4s16*//*Label 7674*/ GIMT_Encode4(383526),
     /* 383348 */ /*GILLT_v4s32*//*Label 7675*/ GIMT_Encode4(383564),
     /* 383352 */ /*GILLT_v8s8*//*Label 7676*/ GIMT_Encode4(383602),
     /* 383356 */ /*GILLT_v8s16*//*Label 7677*/ GIMT_Encode4(383640),
     /* 383360 */ /*GILLT_v16s8*//*Label 7678*/ GIMT_Encode4(383678), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 383380 */ /*GILLT_nxv2s64*//*Label 7679*/ GIMT_Encode4(383716), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 383392 */ /*GILLT_nxv4s32*//*Label 7680*/ GIMT_Encode4(383751), GIMT_Encode4(0),
     /* 383400 */ /*GILLT_nxv8s16*//*Label 7681*/ GIMT_Encode4(383786), GIMT_Encode4(0),
     /* 383408 */ /*GILLT_nxv16s8*//*Label 7682*/ GIMT_Encode4(383821),
     /* 383412 */ // Label 7671: @383412
     /* 383412 */ GIM_Try, /*On fail goto*//*Label 7684*/ GIMT_Encode4(383449), // Rule ID 5006 //
     /* 383417 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 383420 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 383423 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 383426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383430 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383434 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383438 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383442 */   // (AArch64bsp:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm)  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm)
     /* 383442 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 383447 */   GIR_RootConstrainSelectedInstOperands,
     /* 383448 */   // GIR_Coverage, 5006,
     /* 383448 */   GIR_Done,
     /* 383449 */ // Label 7684: @383449
     /* 383449 */ GIM_Reject,
     /* 383450 */ // Label 7672: @383450
     /* 383450 */ GIM_Try, /*On fail goto*//*Label 7685*/ GIMT_Encode4(383487), // Rule ID 5005 //
     /* 383455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 383458 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 383461 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 383464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383468 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383472 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383476 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383480 */   // (AArch64bsp:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 383480 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 383485 */   GIR_RootConstrainSelectedInstOperands,
     /* 383486 */   // GIR_Coverage, 5005,
     /* 383486 */   GIR_Done,
     /* 383487 */ // Label 7685: @383487
     /* 383487 */ GIM_Reject,
     /* 383488 */ // Label 7673: @383488
     /* 383488 */ GIM_Try, /*On fail goto*//*Label 7686*/ GIMT_Encode4(383525), // Rule ID 5010 //
     /* 383493 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 383496 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 383499 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 383502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383506 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383510 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383514 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383518 */   // (AArch64bsp:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 383518 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 383523 */   GIR_RootConstrainSelectedInstOperands,
     /* 383524 */   // GIR_Coverage, 5010,
     /* 383524 */   GIR_Done,
     /* 383525 */ // Label 7686: @383525
     /* 383525 */ GIM_Reject,
     /* 383526 */ // Label 7674: @383526
     /* 383526 */ GIM_Try, /*On fail goto*//*Label 7687*/ GIMT_Encode4(383563), // Rule ID 5004 //
     /* 383531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 383534 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 383537 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 383540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383544 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383548 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383552 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383556 */   // (AArch64bsp:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 383556 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 383561 */   GIR_RootConstrainSelectedInstOperands,
     /* 383562 */   // GIR_Coverage, 5004,
     /* 383562 */   GIR_Done,
     /* 383563 */ // Label 7687: @383563
     /* 383563 */ GIM_Reject,
     /* 383564 */ // Label 7675: @383564
     /* 383564 */ GIM_Try, /*On fail goto*//*Label 7688*/ GIMT_Encode4(383601), // Rule ID 5009 //
     /* 383569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 383572 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 383575 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 383578 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383582 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383586 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383590 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383594 */   // (AArch64bsp:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 383594 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 383599 */   GIR_RootConstrainSelectedInstOperands,
     /* 383600 */   // GIR_Coverage, 5009,
     /* 383600 */   GIR_Done,
     /* 383601 */ // Label 7688: @383601
     /* 383601 */ GIM_Reject,
     /* 383602 */ // Label 7676: @383602
     /* 383602 */ GIM_Try, /*On fail goto*//*Label 7689*/ GIMT_Encode4(383639), // Rule ID 5003 //
     /* 383607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 383610 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 383613 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 383616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383620 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383624 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383628 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383632 */   // (AArch64bsp:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 383632 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 383637 */   GIR_RootConstrainSelectedInstOperands,
     /* 383638 */   // GIR_Coverage, 5003,
     /* 383638 */   GIR_Done,
     /* 383639 */ // Label 7689: @383639
     /* 383639 */ GIM_Reject,
     /* 383640 */ // Label 7677: @383640
     /* 383640 */ GIM_Try, /*On fail goto*//*Label 7690*/ GIMT_Encode4(383677), // Rule ID 5008 //
     /* 383645 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 383648 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 383651 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 383654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383658 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383662 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383666 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383670 */   // (AArch64bsp:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 383670 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 383675 */   GIR_RootConstrainSelectedInstOperands,
     /* 383676 */   // GIR_Coverage, 5008,
     /* 383676 */   GIR_Done,
     /* 383677 */ // Label 7690: @383677
     /* 383677 */ GIM_Reject,
     /* 383678 */ // Label 7678: @383678
     /* 383678 */ GIM_Try, /*On fail goto*//*Label 7691*/ GIMT_Encode4(383715), // Rule ID 5007 //
     /* 383683 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 383686 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 383689 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 383692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383696 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383700 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383704 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383708 */   // (AArch64bsp:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 383708 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 383713 */   GIR_RootConstrainSelectedInstOperands,
     /* 383714 */   // GIR_Coverage, 5007,
     /* 383714 */   GIR_Done,
     /* 383715 */ // Label 7691: @383715
     /* 383715 */ GIM_Reject,
     /* 383716 */ // Label 7679: @383716
     /* 383716 */ GIM_Try, /*On fail goto*//*Label 7692*/ GIMT_Encode4(383750), // Rule ID 11680 //
     /* 383721 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 383724 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 383727 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 383730 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 383733 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383737 */   // (AArch64bsp:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 383737 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 383740 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 383742 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 383744 */   GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 383746 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 383748 */   GIR_RootConstrainSelectedInstOperands,
     /* 383749 */   // GIR_Coverage, 11680,
     /* 383749 */   GIR_EraseRootFromParent_Done,
     /* 383750 */ // Label 7692: @383750
     /* 383750 */ GIM_Reject,
     /* 383751 */ // Label 7680: @383751
     /* 383751 */ GIM_Try, /*On fail goto*//*Label 7693*/ GIMT_Encode4(383785), // Rule ID 11678 //
     /* 383756 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 383759 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 383762 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 383765 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 383768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383772 */   // (AArch64bsp:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 383772 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 383775 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 383777 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 383779 */   GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 383781 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 383783 */   GIR_RootConstrainSelectedInstOperands,
     /* 383784 */   // GIR_Coverage, 11678,
     /* 383784 */   GIR_EraseRootFromParent_Done,
     /* 383785 */ // Label 7693: @383785
     /* 383785 */ GIM_Reject,
     /* 383786 */ // Label 7681: @383786
     /* 383786 */ GIM_Try, /*On fail goto*//*Label 7694*/ GIMT_Encode4(383820), // Rule ID 11676 //
     /* 383791 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 383794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 383797 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 383800 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 383803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383807 */   // (AArch64bsp:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 383807 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 383810 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 383812 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 383814 */   GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 383816 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 383818 */   GIR_RootConstrainSelectedInstOperands,
     /* 383819 */   // GIR_Coverage, 11676,
     /* 383819 */   GIR_EraseRootFromParent_Done,
     /* 383820 */ // Label 7694: @383820
     /* 383820 */ GIM_Reject,
     /* 383821 */ // Label 7682: @383821
     /* 383821 */ GIM_Try, /*On fail goto*//*Label 7695*/ GIMT_Encode4(383855), // Rule ID 11674 //
     /* 383826 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 383829 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 383832 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 383835 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 383838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383842 */   // (AArch64bsp:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 383842 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 383845 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 383847 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 383849 */   GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 383851 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 383853 */   GIR_RootConstrainSelectedInstOperands,
     /* 383854 */   // GIR_Coverage, 11674,
     /* 383854 */   GIR_EraseRootFromParent_Done,
     /* 383855 */ // Label 7695: @383855
     /* 383855 */ GIM_Reject,
     /* 383856 */ // Label 7683: @383856
     /* 383856 */ GIM_Reject,
     /* 383857 */ // Label 119: @383857
     /* 383857 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 7704*/ GIMT_Encode4(385679),
     /* 383868 */ /*GILLT_s64*//*Label 7696*/ GIMT_Encode4(383904), GIMT_Encode4(0),
     /* 383876 */ /*GILLT_v2s32*//*Label 7697*/ GIMT_Encode4(384099),
     /* 383880 */ /*GILLT_v2s64*//*Label 7698*/ GIMT_Encode4(384346),
     /* 383884 */ /*GILLT_v4s16*//*Label 7699*/ GIMT_Encode4(384593),
     /* 383888 */ /*GILLT_v4s32*//*Label 7700*/ GIMT_Encode4(384869),
     /* 383892 */ /*GILLT_v8s8*//*Label 7701*/ GIMT_Encode4(385116),
     /* 383896 */ /*GILLT_v8s16*//*Label 7702*/ GIMT_Encode4(385261),
     /* 383900 */ /*GILLT_v16s8*//*Label 7703*/ GIMT_Encode4(385537),
     /* 383904 */ // Label 7696: @383904
     /* 383904 */ GIM_Try, /*On fail goto*//*Label 7705*/ GIMT_Encode4(384098),
     /* 383909 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 383912 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383916 */   GIM_Try, /*On fail goto*//*Label 7706*/ GIMT_Encode4(383963), // Rule ID 6327 //
     /* 383921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 383929 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 383932 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 383936 */     // MIs[1] Rn
     /* 383936 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 383940 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 383945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 383947 */     // (AArch64dup:{ *:[v1i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 383947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
     /* 383950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 383952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 383956 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 383961 */     GIR_RootConstrainSelectedInstOperands,
     /* 383962 */     // GIR_Coverage, 6327,
     /* 383962 */     GIR_EraseRootFromParent_Done,
     /* 383963 */   // Label 7706: @383963
     /* 383963 */   GIM_Try, /*On fail goto*//*Label 7707*/ GIMT_Encode4(384010), // Rule ID 6338 //
     /* 383968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 383976 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 383979 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 383983 */     // MIs[1] Rn
     /* 383983 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 383987 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 383992 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 383994 */     // (AArch64dup:{ *:[v1f64] } (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 383994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
     /* 383997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 383999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 384003 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 384008 */     GIR_RootConstrainSelectedInstOperands,
     /* 384009 */     // GIR_Coverage, 6338,
     /* 384009 */     GIR_EraseRootFromParent_Done,
     /* 384010 */   // Label 7707: @384010
     /* 384010 */   GIM_Try, /*On fail goto*//*Label 7708*/ GIMT_Encode4(384057), // Rule ID 12919 //
     /* 384015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384023 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384026 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 384030 */     // MIs[1] Rn
     /* 384030 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 384034 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 384039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384041 */     // (AArch64dup:{ *:[v1i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 384041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
     /* 384044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 384046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 384050 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 384055 */     GIR_RootConstrainSelectedInstOperands,
     /* 384056 */     // GIR_Coverage, 12919,
     /* 384056 */     GIR_EraseRootFromParent_Done,
     /* 384057 */   // Label 7708: @384057
     /* 384057 */   GIM_Try, /*On fail goto*//*Label 7709*/ GIMT_Encode4(384077), // Rule ID 5562 //
     /* 384062 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 384066 */     // (AArch64dup:{ *:[v1i64] } GPR64:{ *:[i64] }:$Rn)  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i32] })
     /* 384066 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 384071 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384076 */     // GIR_Coverage, 5562,
     /* 384076 */     GIR_Done,
     /* 384077 */   // Label 7709: @384077
     /* 384077 */   GIM_Try, /*On fail goto*//*Label 7710*/ GIMT_Encode4(384097), // Rule ID 5563 //
     /* 384082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384086 */     // (AArch64dup:{ *:[v1f64] } FPR64:{ *:[f64] }:$Rn)  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[i32] })
     /* 384086 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 384091 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384096 */     // GIR_Coverage, 5563,
     /* 384096 */     GIR_Done,
     /* 384097 */   // Label 7710: @384097
     /* 384097 */   GIM_Reject,
     /* 384098 */ // Label 7705: @384098
     /* 384098 */ GIM_Reject,
     /* 384099 */ // Label 7697: @384099
     /* 384099 */ GIM_Try, /*On fail goto*//*Label 7711*/ GIMT_Encode4(384345),
     /* 384104 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 384107 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384111 */   GIM_Try, /*On fail goto*//*Label 7712*/ GIMT_Encode4(384158), // Rule ID 6324 //
     /* 384116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384124 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384127 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 384131 */     // MIs[1] Rn
     /* 384131 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 384135 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 384140 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384142 */     // (AArch64dup:{ *:[v2i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 384142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
     /* 384145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 384147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 384151 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 384156 */     GIR_RootConstrainSelectedInstOperands,
     /* 384157 */     // GIR_Coverage, 6324,
     /* 384157 */     GIR_EraseRootFromParent_Done,
     /* 384158 */   // Label 7712: @384158
     /* 384158 */   GIM_Try, /*On fail goto*//*Label 7713*/ GIMT_Encode4(384205), // Rule ID 6335 //
     /* 384163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384171 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384174 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 384178 */     // MIs[1] Rn
     /* 384178 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 384182 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 384187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384189 */     // (AArch64dup:{ *:[v2f32] } (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 384189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
     /* 384192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 384194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 384198 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 384203 */     GIR_RootConstrainSelectedInstOperands,
     /* 384204 */     // GIR_Coverage, 6335,
     /* 384204 */     GIR_EraseRootFromParent_Done,
     /* 384205 */   // Label 7713: @384205
     /* 384205 */   GIM_Try, /*On fail goto*//*Label 7714*/ GIMT_Encode4(384252), // Rule ID 12916 //
     /* 384210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384218 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384221 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 384225 */     // MIs[1] Rn
     /* 384225 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 384229 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 384234 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384236 */     // (AArch64dup:{ *:[v2i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 384236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
     /* 384239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 384241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 384245 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 384250 */     GIR_RootConstrainSelectedInstOperands,
     /* 384251 */     // GIR_Coverage, 12916,
     /* 384251 */     GIR_EraseRootFromParent_Done,
     /* 384252 */   // Label 7714: @384252
     /* 384252 */   GIM_Try, /*On fail goto*//*Label 7715*/ GIMT_Encode4(384271), // Rule ID 1909 //
     /* 384257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 384260 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 384264 */     // (AArch64dup:{ *:[v2i32] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv2i32gpr:{ *:[v2i32] } GPR32:{ *:[i32] }:$Rn)
     /* 384264 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32gpr),
     /* 384269 */     GIR_RootConstrainSelectedInstOperands,
     /* 384270 */     // GIR_Coverage, 1909,
     /* 384270 */     GIR_Done,
     /* 384271 */   // Label 7715: @384271
     /* 384271 */   GIM_Try, /*On fail goto*//*Label 7716*/ GIMT_Encode4(384344), // Rule ID 5564 //
     /* 384276 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384280 */     // (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rn)  =>  (DUPv2i32lane:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 384280 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 384283 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 384287 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384292 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 384294 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 384297 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 384301 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384306 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 384309 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 384313 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 384316 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384321 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384326 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
     /* 384334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 384336 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384342 */     GIR_RootConstrainSelectedInstOperands,
     /* 384343 */     // GIR_Coverage, 5564,
     /* 384343 */     GIR_EraseRootFromParent_Done,
     /* 384344 */   // Label 7716: @384344
     /* 384344 */   GIM_Reject,
     /* 384345 */ // Label 7711: @384345
     /* 384345 */ GIM_Reject,
     /* 384346 */ // Label 7698: @384346
     /* 384346 */ GIM_Try, /*On fail goto*//*Label 7717*/ GIMT_Encode4(384592),
     /* 384351 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 384354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384358 */   GIM_Try, /*On fail goto*//*Label 7718*/ GIMT_Encode4(384405), // Rule ID 6326 //
     /* 384363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384371 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384374 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 384378 */     // MIs[1] Rn
     /* 384378 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 384382 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 384387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384389 */     // (AArch64dup:{ *:[v2i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 384389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 384392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 384394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 384398 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 384403 */     GIR_RootConstrainSelectedInstOperands,
     /* 384404 */     // GIR_Coverage, 6326,
     /* 384404 */     GIR_EraseRootFromParent_Done,
     /* 384405 */   // Label 7718: @384405
     /* 384405 */   GIM_Try, /*On fail goto*//*Label 7719*/ GIMT_Encode4(384452), // Rule ID 6337 //
     /* 384410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384418 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384421 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 384425 */     // MIs[1] Rn
     /* 384425 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 384429 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 384434 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384436 */     // (AArch64dup:{ *:[v2f64] } (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 384436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 384439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 384441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 384445 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 384450 */     GIR_RootConstrainSelectedInstOperands,
     /* 384451 */     // GIR_Coverage, 6337,
     /* 384451 */     GIR_EraseRootFromParent_Done,
     /* 384452 */   // Label 7719: @384452
     /* 384452 */   GIM_Try, /*On fail goto*//*Label 7720*/ GIMT_Encode4(384499), // Rule ID 12918 //
     /* 384457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384465 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384468 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 384472 */     // MIs[1] Rn
     /* 384472 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 384476 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 384481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384483 */     // (AArch64dup:{ *:[v2i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 384483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 384486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 384488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 384492 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 384497 */     GIR_RootConstrainSelectedInstOperands,
     /* 384498 */     // GIR_Coverage, 12918,
     /* 384498 */     GIR_EraseRootFromParent_Done,
     /* 384499 */   // Label 7720: @384499
     /* 384499 */   GIM_Try, /*On fail goto*//*Label 7721*/ GIMT_Encode4(384518), // Rule ID 1911 //
     /* 384504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 384507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 384511 */     // (AArch64dup:{ *:[v2i64] } GPR64:{ *:[i64] }:$Rn)  =>  (DUPv2i64gpr:{ *:[v2i64] } GPR64:{ *:[i64] }:$Rn)
     /* 384511 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64gpr),
     /* 384516 */     GIR_RootConstrainSelectedInstOperands,
     /* 384517 */     // GIR_Coverage, 1911,
     /* 384517 */     GIR_Done,
     /* 384518 */   // Label 7721: @384518
     /* 384518 */   GIM_Try, /*On fail goto*//*Label 7722*/ GIMT_Encode4(384591), // Rule ID 5566 //
     /* 384523 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384527 */     // (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rn)  =>  (DUPv2i64lane:{ *:[v2f64] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 384527 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 384530 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 384534 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384539 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 384541 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 384544 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 384548 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384553 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 384556 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 384560 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 384563 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384568 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384573 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 384581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 384583 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384589 */     GIR_RootConstrainSelectedInstOperands,
     /* 384590 */     // GIR_Coverage, 5566,
     /* 384590 */     GIR_EraseRootFromParent_Done,
     /* 384591 */   // Label 7722: @384591
     /* 384591 */   GIM_Reject,
     /* 384592 */ // Label 7717: @384592
     /* 384592 */ GIM_Reject,
     /* 384593 */ // Label 7699: @384593
     /* 384593 */ GIM_Try, /*On fail goto*//*Label 7723*/ GIMT_Encode4(384654), // Rule ID 6322 //
     /* 384598 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 384601 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384605 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384609 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384613 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384616 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 384620 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 384627 */   // MIs[1] Rn
     /* 384627 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 384631 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 384636 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384638 */   // (AArch64dup:{ *:[v4i16] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>)  =>  (LD1Rv4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 384638 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
     /* 384641 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 384643 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 384647 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 384652 */   GIR_RootConstrainSelectedInstOperands,
     /* 384653 */   // GIR_Coverage, 6322,
     /* 384653 */   GIR_EraseRootFromParent_Done,
     /* 384654 */ // Label 7723: @384654
     /* 384654 */ GIM_Try, /*On fail goto*//*Label 7724*/ GIMT_Encode4(384708), // Rule ID 6339 //
     /* 384659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 384662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384666 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384670 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384674 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384677 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 384681 */   // MIs[1] Rn
     /* 384681 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 384685 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 384690 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384692 */   // (AArch64dup:{ *:[v4f16] } (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4h:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 384692 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
     /* 384695 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 384697 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 384701 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 384706 */   GIR_RootConstrainSelectedInstOperands,
     /* 384707 */   // GIR_Coverage, 6339,
     /* 384707 */   GIR_EraseRootFromParent_Done,
     /* 384708 */ // Label 7724: @384708
     /* 384708 */ GIM_Try, /*On fail goto*//*Label 7725*/ GIMT_Encode4(384762), // Rule ID 12914 //
     /* 384713 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 384716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384720 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384724 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384728 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384731 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 384735 */   // MIs[1] Rn
     /* 384735 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 384739 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 384744 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384746 */   // (AArch64dup:{ *:[v4i16] } (ld:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 384746 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
     /* 384749 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 384751 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 384755 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 384760 */   GIR_RootConstrainSelectedInstOperands,
     /* 384761 */   // GIR_Coverage, 12914,
     /* 384761 */   GIR_EraseRootFromParent_Done,
     /* 384762 */ // Label 7725: @384762
     /* 384762 */ GIM_Try, /*On fail goto*//*Label 7726*/ GIMT_Encode4(384788), // Rule ID 1907 //
     /* 384767 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 384770 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 384773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384777 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 384781 */   // (AArch64dup:{ *:[v4i16] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv4i16gpr:{ *:[v4i16] } GPR32:{ *:[i32] }:$Rn)
     /* 384781 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16gpr),
     /* 384786 */   GIR_RootConstrainSelectedInstOperands,
     /* 384787 */   // GIR_Coverage, 1907,
     /* 384787 */   GIR_Done,
     /* 384788 */ // Label 7726: @384788
     /* 384788 */ GIM_Try, /*On fail goto*//*Label 7727*/ GIMT_Encode4(384868), // Rule ID 5567 //
     /* 384793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 384796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384800 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 384804 */   // (AArch64dup:{ *:[v4f16] } FPR16:{ *:[f16] }:$Rn)  =>  (DUPv4i16lane:{ *:[v4f16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 384804 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 384807 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 384811 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384816 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 384818 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 384821 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 384825 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384830 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 384833 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 384837 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 384840 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384845 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384850 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 384855 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
     /* 384858 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 384860 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384863 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384866 */   GIR_RootConstrainSelectedInstOperands,
     /* 384867 */   // GIR_Coverage, 5567,
     /* 384867 */   GIR_EraseRootFromParent_Done,
     /* 384868 */ // Label 7727: @384868
     /* 384868 */ GIM_Reject,
     /* 384869 */ // Label 7700: @384869
     /* 384869 */ GIM_Try, /*On fail goto*//*Label 7728*/ GIMT_Encode4(385115),
     /* 384874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 384877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384881 */   GIM_Try, /*On fail goto*//*Label 7729*/ GIMT_Encode4(384928), // Rule ID 6325 //
     /* 384886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384894 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384897 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 384901 */     // MIs[1] Rn
     /* 384901 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 384905 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 384910 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384912 */     // (AArch64dup:{ *:[v4i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 384912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 384915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 384917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 384921 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 384926 */     GIR_RootConstrainSelectedInstOperands,
     /* 384927 */     // GIR_Coverage, 6325,
     /* 384927 */     GIR_EraseRootFromParent_Done,
     /* 384928 */   // Label 7729: @384928
     /* 384928 */   GIM_Try, /*On fail goto*//*Label 7730*/ GIMT_Encode4(384975), // Rule ID 6336 //
     /* 384933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384941 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384944 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 384948 */     // MIs[1] Rn
     /* 384948 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 384952 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 384957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384959 */     // (AArch64dup:{ *:[v4f32] } (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 384959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 384962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 384964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 384968 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 384973 */     GIR_RootConstrainSelectedInstOperands,
     /* 384974 */     // GIR_Coverage, 6336,
     /* 384974 */     GIR_EraseRootFromParent_Done,
     /* 384975 */   // Label 7730: @384975
     /* 384975 */   GIM_Try, /*On fail goto*//*Label 7731*/ GIMT_Encode4(385022), // Rule ID 12917 //
     /* 384980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384988 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384991 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 384995 */     // MIs[1] Rn
     /* 384995 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 384999 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 385004 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385006 */     // (AArch64dup:{ *:[v4i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 385006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 385009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 385011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 385015 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 385020 */     GIR_RootConstrainSelectedInstOperands,
     /* 385021 */     // GIR_Coverage, 12917,
     /* 385021 */     GIR_EraseRootFromParent_Done,
     /* 385022 */   // Label 7731: @385022
     /* 385022 */   GIM_Try, /*On fail goto*//*Label 7732*/ GIMT_Encode4(385041), // Rule ID 1910 //
     /* 385027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385030 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 385034 */     // (AArch64dup:{ *:[v4i32] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv4i32gpr:{ *:[v4i32] } GPR32:{ *:[i32] }:$Rn)
     /* 385034 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32gpr),
     /* 385039 */     GIR_RootConstrainSelectedInstOperands,
     /* 385040 */     // GIR_Coverage, 1910,
     /* 385040 */     GIR_Done,
     /* 385041 */   // Label 7732: @385041
     /* 385041 */   GIM_Try, /*On fail goto*//*Label 7733*/ GIMT_Encode4(385114), // Rule ID 5565 //
     /* 385046 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385050 */     // (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rn)  =>  (DUPv4i32lane:{ *:[v4f32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 385050 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 385053 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 385057 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385062 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 385064 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 385067 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 385071 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385076 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 385079 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 385083 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 385086 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385091 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385096 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
     /* 385104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 385106 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385112 */     GIR_RootConstrainSelectedInstOperands,
     /* 385113 */     // GIR_Coverage, 5565,
     /* 385113 */     GIR_EraseRootFromParent_Done,
     /* 385114 */   // Label 7733: @385114
     /* 385114 */   GIM_Reject,
     /* 385115 */ // Label 7728: @385115
     /* 385115 */ GIM_Reject,
     /* 385116 */ // Label 7701: @385116
     /* 385116 */ GIM_Try, /*On fail goto*//*Label 7734*/ GIMT_Encode4(385173), // Rule ID 12912 //
     /* 385121 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 385124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385128 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385132 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385136 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385139 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 385143 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 385147 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385149 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 385156 */   // (AArch64dup:{ *:[v8i8] } (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 385156 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8b),
     /* 385159 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 385161 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 385166 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 385171 */   GIR_RootConstrainSelectedInstOperands,
     /* 385172 */   // GIR_Coverage, 12912,
     /* 385172 */   GIR_EraseRootFromParent_Done,
     /* 385173 */ // Label 7734: @385173
     /* 385173 */ GIM_Try, /*On fail goto*//*Label 7735*/ GIMT_Encode4(385234), // Rule ID 6320 //
     /* 385178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 385181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385185 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385189 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385193 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385196 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 385200 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 385207 */   // MIs[1] Rn
     /* 385207 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 385211 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 385216 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385218 */   // (AArch64dup:{ *:[v8i8] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>)  =>  (LD1Rv8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 385218 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8b),
     /* 385221 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 385223 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 385227 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 385232 */   GIR_RootConstrainSelectedInstOperands,
     /* 385233 */   // GIR_Coverage, 6320,
     /* 385233 */   GIR_EraseRootFromParent_Done,
     /* 385234 */ // Label 7735: @385234
     /* 385234 */ GIM_Try, /*On fail goto*//*Label 7736*/ GIMT_Encode4(385260), // Rule ID 1905 //
     /* 385239 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 385245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385249 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 385253 */   // (AArch64dup:{ *:[v8i8] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv8i8gpr:{ *:[v8i8] } GPR32:{ *:[i32] }:$Rn)
     /* 385253 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i8gpr),
     /* 385258 */   GIR_RootConstrainSelectedInstOperands,
     /* 385259 */   // GIR_Coverage, 1905,
     /* 385259 */   GIR_Done,
     /* 385260 */ // Label 7736: @385260
     /* 385260 */ GIM_Reject,
     /* 385261 */ // Label 7702: @385261
     /* 385261 */ GIM_Try, /*On fail goto*//*Label 7737*/ GIMT_Encode4(385322), // Rule ID 6323 //
     /* 385266 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 385269 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385273 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385277 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385281 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385284 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 385288 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 385295 */   // MIs[1] Rn
     /* 385295 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 385299 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 385304 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385306 */   // (AArch64dup:{ *:[v8i16] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>)  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 385306 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 385309 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 385311 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 385315 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 385320 */   GIR_RootConstrainSelectedInstOperands,
     /* 385321 */   // GIR_Coverage, 6323,
     /* 385321 */   GIR_EraseRootFromParent_Done,
     /* 385322 */ // Label 7737: @385322
     /* 385322 */ GIM_Try, /*On fail goto*//*Label 7738*/ GIMT_Encode4(385376), // Rule ID 6340 //
     /* 385327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 385330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385334 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385338 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385342 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385345 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 385349 */   // MIs[1] Rn
     /* 385349 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 385353 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 385358 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385360 */   // (AArch64dup:{ *:[v8f16] } (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8h:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 385360 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 385363 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 385365 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 385369 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 385374 */   GIR_RootConstrainSelectedInstOperands,
     /* 385375 */   // GIR_Coverage, 6340,
     /* 385375 */   GIR_EraseRootFromParent_Done,
     /* 385376 */ // Label 7738: @385376
     /* 385376 */ GIM_Try, /*On fail goto*//*Label 7739*/ GIMT_Encode4(385430), // Rule ID 12915 //
     /* 385381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 385384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385388 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385392 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385396 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385399 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 385403 */   // MIs[1] Rn
     /* 385403 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 385407 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 385412 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385414 */   // (AArch64dup:{ *:[v8i16] } (ld:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 385414 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 385417 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 385419 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 385423 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 385428 */   GIR_RootConstrainSelectedInstOperands,
     /* 385429 */   // GIR_Coverage, 12915,
     /* 385429 */   GIR_EraseRootFromParent_Done,
     /* 385430 */ // Label 7739: @385430
     /* 385430 */ GIM_Try, /*On fail goto*//*Label 7740*/ GIMT_Encode4(385456), // Rule ID 1908 //
     /* 385435 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 385441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385445 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 385449 */   // (AArch64dup:{ *:[v8i16] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv8i16gpr:{ *:[v8i16] } GPR32:{ *:[i32] }:$Rn)
     /* 385449 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16gpr),
     /* 385454 */   GIR_RootConstrainSelectedInstOperands,
     /* 385455 */   // GIR_Coverage, 1908,
     /* 385455 */   GIR_Done,
     /* 385456 */ // Label 7740: @385456
     /* 385456 */ GIM_Try, /*On fail goto*//*Label 7741*/ GIMT_Encode4(385536), // Rule ID 5568 //
     /* 385461 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 385464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385468 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385472 */   // (AArch64dup:{ *:[v8f16] } FPR16:{ *:[f16] }:$Rn)  =>  (DUPv8i16lane:{ *:[v8f16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 385472 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 385475 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 385479 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385484 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 385486 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 385489 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 385493 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385498 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 385501 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 385505 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 385508 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385513 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385518 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385523 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
     /* 385526 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 385528 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385531 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385534 */   GIR_RootConstrainSelectedInstOperands,
     /* 385535 */   // GIR_Coverage, 5568,
     /* 385535 */   GIR_EraseRootFromParent_Done,
     /* 385536 */ // Label 7741: @385536
     /* 385536 */ GIM_Reject,
     /* 385537 */ // Label 7703: @385537
     /* 385537 */ GIM_Try, /*On fail goto*//*Label 7742*/ GIMT_Encode4(385598), // Rule ID 6321 //
     /* 385542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 385545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385549 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385553 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385557 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385560 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 385564 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 385571 */   // MIs[1] Rn
     /* 385571 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 385575 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 385580 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385582 */   // (AArch64dup:{ *:[v16i8] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>)  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 385582 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
     /* 385585 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 385587 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 385591 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 385596 */   GIR_RootConstrainSelectedInstOperands,
     /* 385597 */   // GIR_Coverage, 6321,
     /* 385597 */   GIR_EraseRootFromParent_Done,
     /* 385598 */ // Label 7742: @385598
     /* 385598 */ GIM_Try, /*On fail goto*//*Label 7743*/ GIMT_Encode4(385652), // Rule ID 12913 //
     /* 385603 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 385606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385610 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385614 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385618 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385621 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 385625 */   // MIs[1] Rn
     /* 385625 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 385629 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 385634 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385636 */   // (AArch64dup:{ *:[v16i8] } (ld:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 385636 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
     /* 385639 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 385641 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 385645 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 385650 */   GIR_RootConstrainSelectedInstOperands,
     /* 385651 */   // GIR_Coverage, 12913,
     /* 385651 */   GIR_EraseRootFromParent_Done,
     /* 385652 */ // Label 7743: @385652
     /* 385652 */ GIM_Try, /*On fail goto*//*Label 7744*/ GIMT_Encode4(385678), // Rule ID 1906 //
     /* 385657 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385660 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 385663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385667 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 385671 */   // (AArch64dup:{ *:[v16i8] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv16i8gpr:{ *:[v16i8] } GPR32:{ *:[i32] }:$Rn)
     /* 385671 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv16i8gpr),
     /* 385676 */   GIR_RootConstrainSelectedInstOperands,
     /* 385677 */   // GIR_Coverage, 1906,
     /* 385677 */   GIR_Done,
     /* 385678 */ // Label 7744: @385678
     /* 385678 */ GIM_Reject,
     /* 385679 */ // Label 7704: @385679
     /* 385679 */ GIM_Reject,
     /* 385680 */ // Label 120: @385680
     /* 385680 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(11), /*)*//*default:*//*Label 7747*/ GIMT_Encode4(385934),
     /* 385691 */ /*GILLT_v4s16*//*Label 7745*/ GIMT_Encode4(385707), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 385703 */ /*GILLT_v8s16*//*Label 7746*/ GIMT_Encode4(385793),
     /* 385707 */ // Label 7745: @385707
     /* 385707 */ GIM_Try, /*On fail goto*//*Label 7748*/ GIMT_Encode4(385792),
     /* 385712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 385715 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 385718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385722 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385726 */   GIM_Try, /*On fail goto*//*Label 7749*/ GIMT_Encode4(385760), // Rule ID 1915 //
     /* 385731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 385738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 385742 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 385746 */     // MIs[1] Operand 1
     /* 385746 */     // No operand predicates
     /* 385746 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385748 */     // (AArch64duplane16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPv4i16lane:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 385748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
     /* 385751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 385753 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 385755 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 385758 */     GIR_RootConstrainSelectedInstOperands,
     /* 385759 */     // GIR_Coverage, 1915,
     /* 385759 */     GIR_EraseRootFromParent_Done,
     /* 385760 */   // Label 7749: @385760
     /* 385760 */   GIM_Try, /*On fail goto*//*Label 7750*/ GIMT_Encode4(385791), // Rule ID 5569 //
     /* 385765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 385769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 385773 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 385777 */     // MIs[1] Operand 1
     /* 385777 */     // No operand predicates
     /* 385777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385779 */     // (AArch64duplane16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (DUPv4i16lane:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)
     /* 385779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
     /* 385782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 385784 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 385786 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 385789 */     GIR_RootConstrainSelectedInstOperands,
     /* 385790 */     // GIR_Coverage, 5569,
     /* 385790 */     GIR_EraseRootFromParent_Done,
     /* 385791 */   // Label 7750: @385791
     /* 385791 */   GIM_Reject,
     /* 385792 */ // Label 7748: @385792
     /* 385792 */ GIM_Reject,
     /* 385793 */ // Label 7746: @385793
     /* 385793 */ GIM_Try, /*On fail goto*//*Label 7751*/ GIMT_Encode4(385933),
     /* 385798 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 385801 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 385804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385808 */   GIM_Try, /*On fail goto*//*Label 7752*/ GIMT_Encode4(385859), // Rule ID 6331 //
     /* 385813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385821 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385824 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 385828 */     // MIs[1] Rn
     /* 385828 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 385832 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 385837 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 385841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385843 */     // (AArch64duplane16:{ *:[v8i16] } (ld:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 385843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 385846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 385848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 385852 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 385857 */     GIR_RootConstrainSelectedInstOperands,
     /* 385858 */     // GIR_Coverage, 6331,
     /* 385858 */     GIR_EraseRootFromParent_Done,
     /* 385859 */   // Label 7752: @385859
     /* 385859 */   GIM_Try, /*On fail goto*//*Label 7753*/ GIMT_Encode4(385897), // Rule ID 1916 //
     /* 385864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385867 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 385875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 385879 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 385883 */     // MIs[1] Operand 1
     /* 385883 */     // No operand predicates
     /* 385883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385885 */     // (AArch64duplane16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPv8i16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 385885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
     /* 385888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 385890 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 385892 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 385895 */     GIR_RootConstrainSelectedInstOperands,
     /* 385896 */     // GIR_Coverage, 1916,
     /* 385896 */     GIR_EraseRootFromParent_Done,
     /* 385897 */   // Label 7753: @385897
     /* 385897 */   GIM_Try, /*On fail goto*//*Label 7754*/ GIMT_Encode4(385932), // Rule ID 5570 //
     /* 385902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 385910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 385914 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 385918 */     // MIs[1] Operand 1
     /* 385918 */     // No operand predicates
     /* 385918 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385920 */     // (AArch64duplane16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (DUPv8i16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)
     /* 385920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
     /* 385923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 385925 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 385927 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 385930 */     GIR_RootConstrainSelectedInstOperands,
     /* 385931 */     // GIR_Coverage, 5570,
     /* 385931 */     GIR_EraseRootFromParent_Done,
     /* 385932 */   // Label 7754: @385932
     /* 385932 */   GIM_Reject,
     /* 385933 */ // Label 7751: @385933
     /* 385933 */ GIM_Reject,
     /* 385934 */ // Label 7747: @385934
     /* 385934 */ GIM_Reject,
     /* 385935 */ // Label 121: @385935
     /* 385935 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(9), /*)*//*default:*//*Label 7757*/ GIMT_Encode4(386189),
     /* 385946 */ /*GILLT_v2s32*//*Label 7755*/ GIMT_Encode4(385962), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 385958 */ /*GILLT_v4s32*//*Label 7756*/ GIMT_Encode4(386048),
     /* 385962 */ // Label 7755: @385962
     /* 385962 */ GIM_Try, /*On fail goto*//*Label 7758*/ GIMT_Encode4(386047),
     /* 385967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 385970 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 385973 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385977 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385981 */   GIM_Try, /*On fail goto*//*Label 7759*/ GIMT_Encode4(386015), // Rule ID 1913 //
     /* 385986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 385993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 385997 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 386001 */     // MIs[1] Operand 1
     /* 386001 */     // No operand predicates
     /* 386001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386003 */     // (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPv2i32lane:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 386003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
     /* 386006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386008 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386010 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 386013 */     GIR_RootConstrainSelectedInstOperands,
     /* 386014 */     // GIR_Coverage, 1913,
     /* 386014 */     GIR_EraseRootFromParent_Done,
     /* 386015 */   // Label 7759: @386015
     /* 386015 */   GIM_Try, /*On fail goto*//*Label 7760*/ GIMT_Encode4(386046), // Rule ID 5571 //
     /* 386020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386028 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 386032 */     // MIs[1] Operand 1
     /* 386032 */     // No operand predicates
     /* 386032 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386034 */     // (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (DUPv2i32lane:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)
     /* 386034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
     /* 386037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386039 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386041 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 386044 */     GIR_RootConstrainSelectedInstOperands,
     /* 386045 */     // GIR_Coverage, 5571,
     /* 386045 */     GIR_EraseRootFromParent_Done,
     /* 386046 */   // Label 7760: @386046
     /* 386046 */   GIM_Reject,
     /* 386047 */ // Label 7758: @386047
     /* 386047 */ GIM_Reject,
     /* 386048 */ // Label 7756: @386048
     /* 386048 */ GIM_Try, /*On fail goto*//*Label 7761*/ GIMT_Encode4(386188),
     /* 386053 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 386056 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386059 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386063 */   GIM_Try, /*On fail goto*//*Label 7762*/ GIMT_Encode4(386114), // Rule ID 6333 //
     /* 386068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 386076 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 386079 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 386083 */     // MIs[1] Rn
     /* 386083 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 386087 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 386092 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 386096 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386098 */     // (AArch64duplane32:{ *:[v4i32] } (ld:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 386098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 386101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 386103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 386107 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 386112 */     GIR_RootConstrainSelectedInstOperands,
     /* 386113 */     // GIR_Coverage, 6333,
     /* 386113 */     GIR_EraseRootFromParent_Done,
     /* 386114 */   // Label 7762: @386114
     /* 386114 */   GIM_Try, /*On fail goto*//*Label 7763*/ GIMT_Encode4(386152), // Rule ID 1914 //
     /* 386119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386122 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386134 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 386138 */     // MIs[1] Operand 1
     /* 386138 */     // No operand predicates
     /* 386138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386140 */     // (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPv4i32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 386140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
     /* 386143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386145 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 386150 */     GIR_RootConstrainSelectedInstOperands,
     /* 386151 */     // GIR_Coverage, 1914,
     /* 386151 */     GIR_EraseRootFromParent_Done,
     /* 386152 */   // Label 7763: @386152
     /* 386152 */   GIM_Try, /*On fail goto*//*Label 7764*/ GIMT_Encode4(386187), // Rule ID 5572 //
     /* 386157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386169 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 386173 */     // MIs[1] Operand 1
     /* 386173 */     // No operand predicates
     /* 386173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386175 */     // (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (DUPv4i32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)
     /* 386175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
     /* 386178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386180 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386182 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 386185 */     GIR_RootConstrainSelectedInstOperands,
     /* 386186 */     // GIR_Coverage, 5572,
     /* 386186 */     GIR_EraseRootFromParent_Done,
     /* 386187 */   // Label 7764: @386187
     /* 386187 */   GIM_Reject,
     /* 386188 */ // Label 7761: @386188
     /* 386188 */ GIM_Reject,
     /* 386189 */ // Label 7757: @386189
     /* 386189 */ GIM_Reject,
     /* 386190 */ // Label 122: @386190
     /* 386190 */ GIM_Try, /*On fail goto*//*Label 7765*/ GIMT_Encode4(386335),
     /* 386195 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 386198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386201 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386208 */   GIM_Try, /*On fail goto*//*Label 7766*/ GIMT_Encode4(386259), // Rule ID 6334 //
     /* 386213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 386221 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 386224 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 386228 */     // MIs[1] Rn
     /* 386228 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 386232 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 386237 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 386241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386243 */     // (AArch64duplane64:{ *:[v2i64] } (ld:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 386243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 386246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 386248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 386252 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 386257 */     GIR_RootConstrainSelectedInstOperands,
     /* 386258 */     // GIR_Coverage, 6334,
     /* 386258 */     GIR_EraseRootFromParent_Done,
     /* 386259 */   // Label 7766: @386259
     /* 386259 */   GIM_Try, /*On fail goto*//*Label 7767*/ GIMT_Encode4(386334),
     /* 386264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386268 */     GIM_Try, /*On fail goto*//*Label 7768*/ GIMT_Encode4(386302), // Rule ID 1912 //
     /* 386273 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386276 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386280 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386284 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 386288 */       // MIs[1] Operand 1
     /* 386288 */       // No operand predicates
     /* 386288 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386290 */       // (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (DUPv2i64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 386290 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 386293 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386295 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386297 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 386300 */       GIR_RootConstrainSelectedInstOperands,
     /* 386301 */       // GIR_Coverage, 1912,
     /* 386301 */       GIR_EraseRootFromParent_Done,
     /* 386302 */     // Label 7768: @386302
     /* 386302 */     GIM_Try, /*On fail goto*//*Label 7769*/ GIMT_Encode4(386333), // Rule ID 5573 //
     /* 386307 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386311 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386315 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 386319 */       // MIs[1] Operand 1
     /* 386319 */       // No operand predicates
     /* 386319 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386321 */       // (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (DUPv2i64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)
     /* 386321 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 386324 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386326 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386328 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 386331 */       GIR_RootConstrainSelectedInstOperands,
     /* 386332 */       // GIR_Coverage, 5573,
     /* 386332 */       GIR_EraseRootFromParent_Done,
     /* 386333 */     // Label 7769: @386333
     /* 386333 */     GIM_Reject,
     /* 386334 */   // Label 7767: @386334
     /* 386334 */   GIM_Reject,
     /* 386335 */ // Label 7765: @386335
     /* 386335 */ GIM_Reject,
     /* 386336 */ // Label 123: @386336
     /* 386336 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(12), /*)*//*default:*//*Label 7772*/ GIMT_Encode4(386514),
     /* 386347 */ /*GILLT_v8s8*//*Label 7770*/ GIMT_Encode4(386359), GIMT_Encode4(0),
     /* 386355 */ /*GILLT_v16s8*//*Label 7771*/ GIMT_Encode4(386408),
     /* 386359 */ // Label 7770: @386359
     /* 386359 */ GIM_Try, /*On fail goto*//*Label 7773*/ GIMT_Encode4(386407), // Rule ID 1917 //
     /* 386364 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386367 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 386370 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386377 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386381 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386385 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386389 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 386393 */   // MIs[1] Operand 1
     /* 386393 */   // No operand predicates
     /* 386393 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386395 */   // (AArch64duplane8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (DUPv8i8lane:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 386395 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i8lane),
     /* 386398 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386400 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386402 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 386405 */   GIR_RootConstrainSelectedInstOperands,
     /* 386406 */   // GIR_Coverage, 1917,
     /* 386406 */   GIR_EraseRootFromParent_Done,
     /* 386407 */ // Label 7773: @386407
     /* 386407 */ GIM_Reject,
     /* 386408 */ // Label 7771: @386408
     /* 386408 */ GIM_Try, /*On fail goto*//*Label 7774*/ GIMT_Encode4(386513),
     /* 386413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 386416 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386423 */   GIM_Try, /*On fail goto*//*Label 7775*/ GIMT_Encode4(386474), // Rule ID 6329 //
     /* 386428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 386436 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 386439 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 386443 */     // MIs[1] Rn
     /* 386443 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 386447 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 386452 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 386456 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386458 */     // (AArch64duplane8:{ *:[v16i8] } (ld:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 386458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
     /* 386461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 386463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 386467 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 386472 */     GIR_RootConstrainSelectedInstOperands,
     /* 386473 */     // GIR_Coverage, 6329,
     /* 386473 */     GIR_EraseRootFromParent_Done,
     /* 386474 */   // Label 7775: @386474
     /* 386474 */   GIM_Try, /*On fail goto*//*Label 7776*/ GIMT_Encode4(386512), // Rule ID 1918 //
     /* 386479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386482 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386494 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 386498 */     // MIs[1] Operand 1
     /* 386498 */     // No operand predicates
     /* 386498 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386500 */     // (AArch64duplane8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (DUPv16i8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 386500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv16i8lane),
     /* 386503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386505 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386507 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 386510 */     GIR_RootConstrainSelectedInstOperands,
     /* 386511 */     // GIR_Coverage, 1918,
     /* 386511 */     GIR_EraseRootFromParent_Done,
     /* 386512 */   // Label 7776: @386512
     /* 386512 */   GIM_Reject,
     /* 386513 */ // Label 7774: @386513
     /* 386513 */ GIM_Reject,
     /* 386514 */ // Label 7772: @386514
     /* 386514 */ GIM_Reject,
     /* 386515 */ // Label 124: @386515
     /* 386515 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 7786*/ GIMT_Encode4(388164),
     /* 386526 */ /*GILLT_s64*//*Label 7777*/ GIMT_Encode4(386610), GIMT_Encode4(0),
     /* 386534 */ /*GILLT_v2s32*//*Label 7778*/ GIMT_Encode4(386931),
     /* 386538 */ /*GILLT_v2s64*//*Label 7779*/ GIMT_Encode4(387252),
     /* 386542 */ /*GILLT_v4s16*//*Label 7780*/ GIMT_Encode4(387335),
     /* 386546 */ /*GILLT_v4s32*//*Label 7781*/ GIMT_Encode4(387656),
     /* 386550 */ /*GILLT_v8s8*//*Label 7782*/ GIMT_Encode4(387739),
     /* 386554 */ /*GILLT_v8s16*//*Label 7783*/ GIMT_Encode4(387948),
     /* 386558 */ /*GILLT_v16s8*//*Label 7784*/ GIMT_Encode4(388031), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 386606 */ /*GILLT_nxv16s8*//*Label 7785*/ GIMT_Encode4(388117),
     /* 386610 */ // Label 7777: @386610
     /* 386610 */ GIM_Try, /*On fail goto*//*Label 7787*/ GIMT_Encode4(386930),
     /* 386615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 386618 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386625 */   GIM_Try, /*On fail goto*//*Label 7788*/ GIMT_Encode4(386740), // Rule ID 5396 //
     /* 386630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 386638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386642 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386647 */     // MIs[1] Operand 2
     /* 386647 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 386658 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386662 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 386666 */     // MIs[2] Rn
     /* 386666 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 386671 */     // MIs[2] Operand 2
     /* 386671 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(1),
     /* 386682 */     // MIs[0] imm
     /* 386682 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 386686 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386690 */     // MIs[3] Operand 1
     /* 386690 */     // No operand predicates
     /* 386690 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 386692 */     // (AArch64ext:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 386692 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 386695 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 386699 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386704 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 386708 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 386712 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 386715 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 386717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386722 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 386729 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386734 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386739 */     // GIR_Coverage, 5396,
     /* 386739 */     GIR_EraseRootFromParent_Done,
     /* 386740 */   // Label 7788: @386740
     /* 386740 */   GIM_Try, /*On fail goto*//*Label 7789*/ GIMT_Encode4(386855), // Rule ID 5401 //
     /* 386745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 386753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386757 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386762 */     // MIs[1] Operand 2
     /* 386762 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 386773 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386777 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 386781 */     // MIs[2] Rn
     /* 386781 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 386786 */     // MIs[2] Operand 2
     /* 386786 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(1),
     /* 386797 */     // MIs[0] imm
     /* 386797 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 386801 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386805 */     // MIs[3] Operand 1
     /* 386805 */     // No operand predicates
     /* 386805 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 386807 */     // (AArch64ext:{ *:[v1f64] } (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 386807 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 386810 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 386814 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386819 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 386823 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 386827 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 386830 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 386832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386837 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 386844 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386849 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386854 */     // GIR_Coverage, 5401,
     /* 386854 */     GIR_EraseRootFromParent_Done,
     /* 386855 */   // Label 7789: @386855
     /* 386855 */   GIM_Try, /*On fail goto*//*Label 7790*/ GIMT_Encode4(386892), // Rule ID 5393 //
     /* 386860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386868 */     // MIs[0] imm
     /* 386868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 386872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386876 */     // MIs[1] Operand 1
     /* 386876 */     // No operand predicates
     /* 386876 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386878 */     // (AArch64ext:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 386878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 386881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386883 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 386887 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 386890 */     GIR_RootConstrainSelectedInstOperands,
     /* 386891 */     // GIR_Coverage, 5393,
     /* 386891 */     GIR_EraseRootFromParent_Done,
     /* 386892 */   // Label 7790: @386892
     /* 386892 */   GIM_Try, /*On fail goto*//*Label 7791*/ GIMT_Encode4(386929), // Rule ID 5398 //
     /* 386897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386905 */     // MIs[0] imm
     /* 386905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 386909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386913 */     // MIs[1] Operand 1
     /* 386913 */     // No operand predicates
     /* 386913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386915 */     // (AArch64ext:{ *:[v1f64] } V64:{ *:[v1f64] }:$Rn, V64:{ *:[v1f64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v1f64] } V64:{ *:[v1f64] }:$Rn, V64:{ *:[v1f64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 386915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 386918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 386920 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386922 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 386924 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 386927 */     GIR_RootConstrainSelectedInstOperands,
     /* 386928 */     // GIR_Coverage, 5398,
     /* 386928 */     GIR_EraseRootFromParent_Done,
     /* 386929 */   // Label 7791: @386929
     /* 386929 */   GIM_Reject,
     /* 386930 */ // Label 7787: @386930
     /* 386930 */ GIM_Reject,
     /* 386931 */ // Label 7778: @386931
     /* 386931 */ GIM_Try, /*On fail goto*//*Label 7792*/ GIMT_Encode4(387251),
     /* 386936 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 386939 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 386942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386946 */   GIM_Try, /*On fail goto*//*Label 7793*/ GIMT_Encode4(387061), // Rule ID 5386 //
     /* 386951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 386959 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 386963 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386968 */     // MIs[1] Operand 2
     /* 386968 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 386979 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386983 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 386987 */     // MIs[2] Rn
     /* 386987 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 386992 */     // MIs[2] Operand 2
     /* 386992 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 387003 */     // MIs[0] imm
     /* 387003 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 387007 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387011 */     // MIs[3] Operand 1
     /* 387011 */     // No operand predicates
     /* 387011 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387013 */     // (AArch64ext:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 387013 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 387016 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 387020 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387025 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 387029 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 387033 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 387036 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387043 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 387050 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387055 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387060 */     // GIR_Coverage, 5386,
     /* 387060 */     GIR_EraseRootFromParent_Done,
     /* 387061 */   // Label 7793: @387061
     /* 387061 */   GIM_Try, /*On fail goto*//*Label 7794*/ GIMT_Encode4(387176), // Rule ID 5391 //
     /* 387066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 387074 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 387078 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387083 */     // MIs[1] Operand 2
     /* 387083 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 387094 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387098 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 387102 */     // MIs[2] Rn
     /* 387102 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 387107 */     // MIs[2] Operand 2
     /* 387107 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 387118 */     // MIs[0] imm
     /* 387118 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 387122 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387126 */     // MIs[3] Operand 1
     /* 387126 */     // No operand predicates
     /* 387126 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387128 */     // (AArch64ext:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 387128 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 387131 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 387135 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387140 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 387144 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 387148 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 387151 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387158 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 387165 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387170 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387175 */     // GIR_Coverage, 5391,
     /* 387175 */     GIR_EraseRootFromParent_Done,
     /* 387176 */   // Label 7794: @387176
     /* 387176 */   GIM_Try, /*On fail goto*//*Label 7795*/ GIMT_Encode4(387213), // Rule ID 5383 //
     /* 387181 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387189 */     // MIs[0] imm
     /* 387189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 387193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387197 */     // MIs[1] Operand 1
     /* 387197 */     // No operand predicates
     /* 387197 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387199 */     // (AArch64ext:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 387199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 387202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387204 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 387208 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 387211 */     GIR_RootConstrainSelectedInstOperands,
     /* 387212 */     // GIR_Coverage, 5383,
     /* 387212 */     GIR_EraseRootFromParent_Done,
     /* 387213 */   // Label 7795: @387213
     /* 387213 */   GIM_Try, /*On fail goto*//*Label 7796*/ GIMT_Encode4(387250), // Rule ID 5388 //
     /* 387218 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387226 */     // MIs[0] imm
     /* 387226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 387230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387234 */     // MIs[1] Operand 1
     /* 387234 */     // No operand predicates
     /* 387234 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387236 */     // (AArch64ext:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 387236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 387239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387241 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 387245 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 387248 */     GIR_RootConstrainSelectedInstOperands,
     /* 387249 */     // GIR_Coverage, 5388,
     /* 387249 */     GIR_EraseRootFromParent_Done,
     /* 387250 */   // Label 7796: @387250
     /* 387250 */   GIM_Reject,
     /* 387251 */ // Label 7792: @387251
     /* 387251 */ GIM_Reject,
     /* 387252 */ // Label 7779: @387252
     /* 387252 */ GIM_Try, /*On fail goto*//*Label 7797*/ GIMT_Encode4(387334),
     /* 387257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387260 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 387263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387267 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387271 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387275 */   GIM_Try, /*On fail goto*//*Label 7798*/ GIMT_Encode4(387304), // Rule ID 5394 //
     /* 387280 */     // MIs[0] imm
     /* 387280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 387284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387288 */     // MIs[1] Operand 1
     /* 387288 */     // No operand predicates
     /* 387288 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387290 */     // (AArch64ext:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 387290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 387293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387295 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 387299 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 387302 */     GIR_RootConstrainSelectedInstOperands,
     /* 387303 */     // GIR_Coverage, 5394,
     /* 387303 */     GIR_EraseRootFromParent_Done,
     /* 387304 */   // Label 7798: @387304
     /* 387304 */   GIM_Try, /*On fail goto*//*Label 7799*/ GIMT_Encode4(387333), // Rule ID 5399 //
     /* 387309 */     // MIs[0] imm
     /* 387309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 387313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387317 */     // MIs[1] Operand 1
     /* 387317 */     // No operand predicates
     /* 387317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387319 */     // (AArch64ext:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 387319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 387322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387324 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387326 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 387328 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 387331 */     GIR_RootConstrainSelectedInstOperands,
     /* 387332 */     // GIR_Coverage, 5399,
     /* 387332 */     GIR_EraseRootFromParent_Done,
     /* 387333 */   // Label 7799: @387333
     /* 387333 */   GIM_Reject,
     /* 387334 */ // Label 7797: @387334
     /* 387334 */ GIM_Reject,
     /* 387335 */ // Label 7780: @387335
     /* 387335 */ GIM_Try, /*On fail goto*//*Label 7800*/ GIMT_Encode4(387655),
     /* 387340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 387343 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 387346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387350 */   GIM_Try, /*On fail goto*//*Label 7801*/ GIMT_Encode4(387465), // Rule ID 5376 //
     /* 387355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 387363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 387367 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387372 */     // MIs[1] Operand 2
     /* 387372 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 387383 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387387 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 387391 */     // MIs[2] Rn
     /* 387391 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 387396 */     // MIs[2] Operand 2
     /* 387396 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 387407 */     // MIs[0] imm
     /* 387407 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 387411 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387415 */     // MIs[3] Operand 1
     /* 387415 */     // No operand predicates
     /* 387415 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387417 */     // (AArch64ext:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 387417 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 387420 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 387424 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387429 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 387433 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 387437 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 387440 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387447 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 387454 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387459 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387464 */     // GIR_Coverage, 5376,
     /* 387464 */     GIR_EraseRootFromParent_Done,
     /* 387465 */   // Label 7801: @387465
     /* 387465 */   GIM_Try, /*On fail goto*//*Label 7802*/ GIMT_Encode4(387580), // Rule ID 5381 //
     /* 387470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 387478 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 387482 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387487 */     // MIs[1] Operand 2
     /* 387487 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 387498 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387502 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 387506 */     // MIs[2] Rn
     /* 387506 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 387511 */     // MIs[2] Operand 2
     /* 387511 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 387522 */     // MIs[0] imm
     /* 387522 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 387526 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387530 */     // MIs[3] Operand 1
     /* 387530 */     // No operand predicates
     /* 387530 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387532 */     // (AArch64ext:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 387532 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 387535 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 387539 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387544 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 387548 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 387552 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 387555 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387562 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 387569 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387574 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387579 */     // GIR_Coverage, 5381,
     /* 387579 */     GIR_EraseRootFromParent_Done,
     /* 387580 */   // Label 7802: @387580
     /* 387580 */   GIM_Try, /*On fail goto*//*Label 7803*/ GIMT_Encode4(387617), // Rule ID 5373 //
     /* 387585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387593 */     // MIs[0] imm
     /* 387593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 387597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387601 */     // MIs[1] Operand 1
     /* 387601 */     // No operand predicates
     /* 387601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387603 */     // (AArch64ext:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 387603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 387606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387608 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 387612 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 387615 */     GIR_RootConstrainSelectedInstOperands,
     /* 387616 */     // GIR_Coverage, 5373,
     /* 387616 */     GIR_EraseRootFromParent_Done,
     /* 387617 */   // Label 7803: @387617
     /* 387617 */   GIM_Try, /*On fail goto*//*Label 7804*/ GIMT_Encode4(387654), // Rule ID 5378 //
     /* 387622 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387630 */     // MIs[0] imm
     /* 387630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 387634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387638 */     // MIs[1] Operand 1
     /* 387638 */     // No operand predicates
     /* 387638 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387640 */     // (AArch64ext:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 387640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 387643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387645 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 387649 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 387652 */     GIR_RootConstrainSelectedInstOperands,
     /* 387653 */     // GIR_Coverage, 5378,
     /* 387653 */     GIR_EraseRootFromParent_Done,
     /* 387654 */   // Label 7804: @387654
     /* 387654 */   GIM_Reject,
     /* 387655 */ // Label 7800: @387655
     /* 387655 */ GIM_Reject,
     /* 387656 */ // Label 7781: @387656
     /* 387656 */ GIM_Try, /*On fail goto*//*Label 7805*/ GIMT_Encode4(387738),
     /* 387661 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 387664 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 387667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387671 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387675 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387679 */   GIM_Try, /*On fail goto*//*Label 7806*/ GIMT_Encode4(387708), // Rule ID 5384 //
     /* 387684 */     // MIs[0] imm
     /* 387684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 387688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387692 */     // MIs[1] Operand 1
     /* 387692 */     // No operand predicates
     /* 387692 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387694 */     // (AArch64ext:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 387694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 387697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387699 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 387703 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 387706 */     GIR_RootConstrainSelectedInstOperands,
     /* 387707 */     // GIR_Coverage, 5384,
     /* 387707 */     GIR_EraseRootFromParent_Done,
     /* 387708 */   // Label 7806: @387708
     /* 387708 */   GIM_Try, /*On fail goto*//*Label 7807*/ GIMT_Encode4(387737), // Rule ID 5389 //
     /* 387713 */     // MIs[0] imm
     /* 387713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 387717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387721 */     // MIs[1] Operand 1
     /* 387721 */     // No operand predicates
     /* 387721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387723 */     // (AArch64ext:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 387723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 387726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387728 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 387732 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 387735 */     GIR_RootConstrainSelectedInstOperands,
     /* 387736 */     // GIR_Coverage, 5389,
     /* 387736 */     GIR_EraseRootFromParent_Done,
     /* 387737 */   // Label 7807: @387737
     /* 387737 */   GIM_Reject,
     /* 387738 */ // Label 7805: @387738
     /* 387738 */ GIM_Reject,
     /* 387739 */ // Label 7782: @387739
     /* 387739 */ GIM_Try, /*On fail goto*//*Label 7808*/ GIMT_Encode4(387947),
     /* 387744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 387747 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 387750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387754 */   GIM_Try, /*On fail goto*//*Label 7809*/ GIMT_Encode4(387869), // Rule ID 5371 //
     /* 387759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 387767 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 387771 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387776 */     // MIs[1] Operand 2
     /* 387776 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 387787 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387791 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 387795 */     // MIs[2] Rn
     /* 387795 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 387800 */     // MIs[2] Operand 2
     /* 387800 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 387811 */     // MIs[0] imm
     /* 387811 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 387815 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387819 */     // MIs[3] Operand 1
     /* 387819 */     // No operand predicates
     /* 387819 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387821 */     // (AArch64ext:{ *:[v8i8] } (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (EXTv16i8:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 387821 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 387824 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 387828 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387833 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 387837 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 387841 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 387844 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387851 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 387858 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387863 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387868 */     // GIR_Coverage, 5371,
     /* 387868 */     GIR_EraseRootFromParent_Done,
     /* 387869 */   // Label 7809: @387869
     /* 387869 */   GIM_Try, /*On fail goto*//*Label 7810*/ GIMT_Encode4(387909), // Rule ID 1861 //
     /* 387874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387877 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387885 */     // MIs[0] imm
     /* 387885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 387889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387893 */     // MIs[1] Operand 1
     /* 387893 */     // No operand predicates
     /* 387893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387895 */     // (AArch64ext:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 387895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 387898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387900 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387902 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 387904 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 387907 */     GIR_RootConstrainSelectedInstOperands,
     /* 387908 */     // GIR_Coverage, 1861,
     /* 387908 */     GIR_EraseRootFromParent_Done,
     /* 387909 */   // Label 7810: @387909
     /* 387909 */   GIM_Try, /*On fail goto*//*Label 7811*/ GIMT_Encode4(387946), // Rule ID 5368 //
     /* 387914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387922 */     // MIs[0] imm
     /* 387922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 387926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387930 */     // MIs[1] Operand 1
     /* 387930 */     // No operand predicates
     /* 387930 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387932 */     // (AArch64ext:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 387932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 387935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387937 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387939 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 387941 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 387944 */     GIR_RootConstrainSelectedInstOperands,
     /* 387945 */     // GIR_Coverage, 5368,
     /* 387945 */     GIR_EraseRootFromParent_Done,
     /* 387946 */   // Label 7811: @387946
     /* 387946 */   GIM_Reject,
     /* 387947 */ // Label 7808: @387947
     /* 387947 */ GIM_Reject,
     /* 387948 */ // Label 7783: @387948
     /* 387948 */ GIM_Try, /*On fail goto*//*Label 7812*/ GIMT_Encode4(388030),
     /* 387953 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 387956 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 387959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387963 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387967 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387971 */   GIM_Try, /*On fail goto*//*Label 7813*/ GIMT_Encode4(388000), // Rule ID 5374 //
     /* 387976 */     // MIs[0] imm
     /* 387976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 387980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387984 */     // MIs[1] Operand 1
     /* 387984 */     // No operand predicates
     /* 387984 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387986 */     // (AArch64ext:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 387986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 387989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387991 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 387995 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 387998 */     GIR_RootConstrainSelectedInstOperands,
     /* 387999 */     // GIR_Coverage, 5374,
     /* 387999 */     GIR_EraseRootFromParent_Done,
     /* 388000 */   // Label 7813: @388000
     /* 388000 */   GIM_Try, /*On fail goto*//*Label 7814*/ GIMT_Encode4(388029), // Rule ID 5379 //
     /* 388005 */     // MIs[0] imm
     /* 388005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 388009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388013 */     // MIs[1] Operand 1
     /* 388013 */     // No operand predicates
     /* 388013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388015 */     // (AArch64ext:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 388015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 388018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388020 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 388024 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 388027 */     GIR_RootConstrainSelectedInstOperands,
     /* 388028 */     // GIR_Coverage, 5379,
     /* 388028 */     GIR_EraseRootFromParent_Done,
     /* 388029 */   // Label 7814: @388029
     /* 388029 */   GIM_Reject,
     /* 388030 */ // Label 7812: @388030
     /* 388030 */ GIM_Reject,
     /* 388031 */ // Label 7784: @388031
     /* 388031 */ GIM_Try, /*On fail goto*//*Label 7815*/ GIMT_Encode4(388116),
     /* 388036 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 388039 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 388042 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388046 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388050 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388054 */   GIM_Try, /*On fail goto*//*Label 7816*/ GIMT_Encode4(388086), // Rule ID 1862 //
     /* 388059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388062 */     // MIs[0] imm
     /* 388062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 388066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388070 */     // MIs[1] Operand 1
     /* 388070 */     // No operand predicates
     /* 388070 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388072 */     // (AArch64ext:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 388072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 388075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388077 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 388081 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 388084 */     GIR_RootConstrainSelectedInstOperands,
     /* 388085 */     // GIR_Coverage, 1862,
     /* 388085 */     GIR_EraseRootFromParent_Done,
     /* 388086 */   // Label 7816: @388086
     /* 388086 */   GIM_Try, /*On fail goto*//*Label 7817*/ GIMT_Encode4(388115), // Rule ID 5369 //
     /* 388091 */     // MIs[0] imm
     /* 388091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 388095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388099 */     // MIs[1] Operand 1
     /* 388099 */     // No operand predicates
     /* 388099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388101 */     // (AArch64ext:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 388101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 388104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388106 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 388110 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 388113 */     GIR_RootConstrainSelectedInstOperands,
     /* 388114 */     // GIR_Coverage, 5369,
     /* 388114 */     GIR_EraseRootFromParent_Done,
     /* 388115 */   // Label 7817: @388115
     /* 388115 */   GIM_Reject,
     /* 388116 */ // Label 7815: @388116
     /* 388116 */ GIM_Reject,
     /* 388117 */ // Label 7785: @388117
     /* 388117 */ GIM_Try, /*On fail goto*//*Label 7818*/ GIMT_Encode4(388163), // Rule ID 2719 //
     /* 388122 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 388128 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 388131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388135 */   // MIs[0] Op3
     /* 388135 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 388139 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388143 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_255),
     /* 388147 */   // MIs[1] Operand 1
     /* 388147 */   // No operand predicates
     /* 388147 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388149 */   // (AArch64ext:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (imm:{ *:[i32] })<<P:Predicate_imm0_255>>:$Op3)  =>  (EXT_ZZI:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (imm:{ *:[i32] })<<P:Predicate_imm0_255>>:$Op3)
     /* 388149 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXT_ZZI),
     /* 388152 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 388154 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 388156 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /* 388158 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // Op3
     /* 388161 */   GIR_RootConstrainSelectedInstOperands,
     /* 388162 */   // GIR_Coverage, 2719,
     /* 388162 */   GIR_EraseRootFromParent_Done,
     /* 388163 */ // Label 7818: @388163
     /* 388163 */ GIM_Reject,
     /* 388164 */ // Label 7786: @388164
     /* 388164 */ GIM_Reject,
     /* 388165 */ // Label 125: @388165
     /* 388165 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 7826*/ GIMT_Encode4(388503),
     /* 388176 */ /*GILLT_s32*//*Label 7819*/ GIMT_Encode4(388212),
     /* 388180 */ /*GILLT_s64*//*Label 7820*/ GIMT_Encode4(388250), GIMT_Encode4(0),
     /* 388188 */ /*GILLT_v2s32*//*Label 7821*/ GIMT_Encode4(388313),
     /* 388192 */ /*GILLT_v2s64*//*Label 7822*/ GIMT_Encode4(388351),
     /* 388196 */ /*GILLT_v4s16*//*Label 7823*/ GIMT_Encode4(388389),
     /* 388200 */ /*GILLT_v4s32*//*Label 7824*/ GIMT_Encode4(388427), GIMT_Encode4(0),
     /* 388208 */ /*GILLT_v8s16*//*Label 7825*/ GIMT_Encode4(388465),
     /* 388212 */ // Label 7819: @388212
     /* 388212 */ GIM_Try, /*On fail goto*//*Label 7827*/ GIMT_Encode4(388249), // Rule ID 1615 //
     /* 388217 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 388223 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 388226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388230 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388234 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388238 */   // (AArch64fcmeq:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMEQ32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 388238 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ32),
     /* 388243 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 388247 */   GIR_RootConstrainSelectedInstOperands,
     /* 388248 */   // GIR_Coverage, 1615,
     /* 388248 */   GIR_Done,
     /* 388249 */ // Label 7827: @388249
     /* 388249 */ GIM_Reject,
     /* 388250 */ // Label 7820: @388250
     /* 388250 */ GIM_Try, /*On fail goto*//*Label 7828*/ GIMT_Encode4(388312),
     /* 388255 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 388258 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388265 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388269 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388273 */   GIM_Try, /*On fail goto*//*Label 7829*/ GIMT_Encode4(388292), // Rule ID 1614 //
     /* 388278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388281 */     // (AArch64fcmeq:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMEQ64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 388281 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ64),
     /* 388286 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 388290 */     GIR_RootConstrainSelectedInstOperands,
     /* 388291 */     // GIR_Coverage, 1614,
     /* 388291 */     GIR_Done,
     /* 388292 */   // Label 7829: @388292
     /* 388292 */   GIM_Try, /*On fail goto*//*Label 7830*/ GIMT_Encode4(388311), // Rule ID 5149 //
     /* 388297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388300 */     // (AArch64fcmeq:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMEQ64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 388300 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ64),
     /* 388305 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 388309 */     GIR_RootConstrainSelectedInstOperands,
     /* 388310 */     // GIR_Coverage, 5149,
     /* 388310 */     GIR_Done,
     /* 388311 */   // Label 7830: @388311
     /* 388311 */   GIM_Reject,
     /* 388312 */ // Label 7828: @388312
     /* 388312 */ GIM_Reject,
     /* 388313 */ // Label 7821: @388313
     /* 388313 */ GIM_Try, /*On fail goto*//*Label 7831*/ GIMT_Encode4(388350), // Rule ID 1203 //
     /* 388318 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388321 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 388324 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 388327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388331 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388335 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388339 */   // (AArch64fcmeq:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMEQv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 388339 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2f32),
     /* 388344 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 388348 */   GIR_RootConstrainSelectedInstOperands,
     /* 388349 */   // GIR_Coverage, 1203,
     /* 388349 */   GIR_Done,
     /* 388350 */ // Label 7831: @388350
     /* 388350 */ GIM_Reject,
     /* 388351 */ // Label 7822: @388351
     /* 388351 */ GIM_Try, /*On fail goto*//*Label 7832*/ GIMT_Encode4(388388), // Rule ID 1205 //
     /* 388356 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388359 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 388362 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 388365 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388369 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388373 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388377 */   // (AArch64fcmeq:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMEQv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 388377 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2f64),
     /* 388382 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 388386 */   GIR_RootConstrainSelectedInstOperands,
     /* 388387 */   // GIR_Coverage, 1205,
     /* 388387 */   GIR_Done,
     /* 388388 */ // Label 7832: @388388
     /* 388388 */ GIM_Reject,
     /* 388389 */ // Label 7823: @388389
     /* 388389 */ GIM_Try, /*On fail goto*//*Label 7833*/ GIMT_Encode4(388426), // Rule ID 1201 //
     /* 388394 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 388397 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 388400 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 388403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388407 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388411 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388415 */   // (AArch64fcmeq:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMEQv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 388415 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f16),
     /* 388420 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 388424 */   GIR_RootConstrainSelectedInstOperands,
     /* 388425 */   // GIR_Coverage, 1201,
     /* 388425 */   GIR_Done,
     /* 388426 */ // Label 7833: @388426
     /* 388426 */ GIM_Reject,
     /* 388427 */ // Label 7824: @388427
     /* 388427 */ GIM_Try, /*On fail goto*//*Label 7834*/ GIMT_Encode4(388464), // Rule ID 1204 //
     /* 388432 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 388438 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 388441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388445 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388449 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388453 */   // (AArch64fcmeq:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMEQv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 388453 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
     /* 388458 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 388462 */   GIR_RootConstrainSelectedInstOperands,
     /* 388463 */   // GIR_Coverage, 1204,
     /* 388463 */   GIR_Done,
     /* 388464 */ // Label 7834: @388464
     /* 388464 */ GIM_Reject,
     /* 388465 */ // Label 7825: @388465
     /* 388465 */ GIM_Try, /*On fail goto*//*Label 7835*/ GIMT_Encode4(388502), // Rule ID 1202 //
     /* 388470 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 388473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 388476 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 388479 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388483 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388487 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388491 */   // (AArch64fcmeq:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMEQv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 388491 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv8f16),
     /* 388496 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 388500 */   GIR_RootConstrainSelectedInstOperands,
     /* 388501 */   // GIR_Coverage, 1202,
     /* 388501 */   GIR_Done,
     /* 388502 */ // Label 7835: @388502
     /* 388502 */ GIM_Reject,
     /* 388503 */ // Label 7826: @388503
     /* 388503 */ GIM_Reject,
     /* 388504 */ // Label 126: @388504
     /* 388504 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 7842*/ GIMT_Encode4(388733),
     /* 388515 */ /*GILLT_s64*//*Label 7836*/ GIMT_Encode4(388547), GIMT_Encode4(0),
     /* 388523 */ /*GILLT_v2s32*//*Label 7837*/ GIMT_Encode4(388578),
     /* 388527 */ /*GILLT_v2s64*//*Label 7838*/ GIMT_Encode4(388609),
     /* 388531 */ /*GILLT_v4s16*//*Label 7839*/ GIMT_Encode4(388640),
     /* 388535 */ /*GILLT_v4s32*//*Label 7840*/ GIMT_Encode4(388671), GIMT_Encode4(0),
     /* 388543 */ /*GILLT_v8s16*//*Label 7841*/ GIMT_Encode4(388702),
     /* 388547 */ // Label 7836: @388547
     /* 388547 */ GIM_Try, /*On fail goto*//*Label 7843*/ GIMT_Encode4(388577), // Rule ID 2504 //
     /* 388552 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388555 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 388558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388562 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388566 */   // (AArch64fcmeqz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMEQv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 388566 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv1i64rz),
     /* 388571 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 388575 */   GIR_RootConstrainSelectedInstOperands,
     /* 388576 */   // GIR_Coverage, 2504,
     /* 388576 */   GIR_Done,
     /* 388577 */ // Label 7843: @388577
     /* 388577 */ GIM_Reject,
     /* 388578 */ // Label 7837: @388578
     /* 388578 */ GIM_Try, /*On fail goto*//*Label 7844*/ GIMT_Encode4(388608), // Rule ID 766 //
     /* 388583 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 388589 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388593 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388597 */   // (AArch64fcmeqz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 388597 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2i32rz),
     /* 388602 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 388606 */   GIR_RootConstrainSelectedInstOperands,
     /* 388607 */   // GIR_Coverage, 766,
     /* 388607 */   GIR_Done,
     /* 388608 */ // Label 7844: @388608
     /* 388608 */ GIM_Reject,
     /* 388609 */ // Label 7838: @388609
     /* 388609 */ GIM_Try, /*On fail goto*//*Label 7845*/ GIMT_Encode4(388639), // Rule ID 768 //
     /* 388614 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 388620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388624 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388628 */   // (AArch64fcmeqz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 388628 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2i64rz),
     /* 388633 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 388637 */   GIR_RootConstrainSelectedInstOperands,
     /* 388638 */   // GIR_Coverage, 768,
     /* 388638 */   GIR_Done,
     /* 388639 */ // Label 7845: @388639
     /* 388639 */ GIM_Reject,
     /* 388640 */ // Label 7839: @388640
     /* 388640 */ GIM_Try, /*On fail goto*//*Label 7846*/ GIMT_Encode4(388670), // Rule ID 764 //
     /* 388645 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 388648 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 388651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388655 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388659 */   // (AArch64fcmeqz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 388659 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4i16rz),
     /* 388664 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 388668 */   GIR_RootConstrainSelectedInstOperands,
     /* 388669 */   // GIR_Coverage, 764,
     /* 388669 */   GIR_Done,
     /* 388670 */ // Label 7846: @388670
     /* 388670 */ GIM_Reject,
     /* 388671 */ // Label 7840: @388671
     /* 388671 */ GIM_Try, /*On fail goto*//*Label 7847*/ GIMT_Encode4(388701), // Rule ID 767 //
     /* 388676 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388679 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 388682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388686 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388690 */   // (AArch64fcmeqz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 388690 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4i32rz),
     /* 388695 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 388699 */   GIR_RootConstrainSelectedInstOperands,
     /* 388700 */   // GIR_Coverage, 767,
     /* 388700 */   GIR_Done,
     /* 388701 */ // Label 7847: @388701
     /* 388701 */ GIM_Reject,
     /* 388702 */ // Label 7841: @388702
     /* 388702 */ GIM_Try, /*On fail goto*//*Label 7848*/ GIMT_Encode4(388732), // Rule ID 765 //
     /* 388707 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 388710 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 388713 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388717 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388721 */   // (AArch64fcmeqz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 388721 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv8i16rz),
     /* 388726 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 388730 */   GIR_RootConstrainSelectedInstOperands,
     /* 388731 */   // GIR_Coverage, 765,
     /* 388731 */   GIR_Done,
     /* 388732 */ // Label 7848: @388732
     /* 388732 */ GIM_Reject,
     /* 388733 */ // Label 7842: @388733
     /* 388733 */ GIM_Reject,
     /* 388734 */ // Label 127: @388734
     /* 388734 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 7856*/ GIMT_Encode4(389397),
     /* 388745 */ /*GILLT_s32*//*Label 7849*/ GIMT_Encode4(388781),
     /* 388749 */ /*GILLT_s64*//*Label 7850*/ GIMT_Encode4(388819), GIMT_Encode4(0),
     /* 388757 */ /*GILLT_v2s32*//*Label 7851*/ GIMT_Encode4(388882),
     /* 388761 */ /*GILLT_v2s64*//*Label 7852*/ GIMT_Encode4(388985),
     /* 388765 */ /*GILLT_v4s16*//*Label 7853*/ GIMT_Encode4(389088),
     /* 388769 */ /*GILLT_v4s32*//*Label 7854*/ GIMT_Encode4(389191), GIMT_Encode4(0),
     /* 388777 */ /*GILLT_v8s16*//*Label 7855*/ GIMT_Encode4(389294),
     /* 388781 */ // Label 7849: @388781
     /* 388781 */ GIM_Try, /*On fail goto*//*Label 7857*/ GIMT_Encode4(388818), // Rule ID 1617 //
     /* 388786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 388792 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 388795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388799 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388803 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388807 */   // (AArch64fcmge:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMGE32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 388807 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE32),
     /* 388812 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 388816 */   GIR_RootConstrainSelectedInstOperands,
     /* 388817 */   // GIR_Coverage, 1617,
     /* 388817 */   GIR_Done,
     /* 388818 */ // Label 7857: @388818
     /* 388818 */ GIM_Reject,
     /* 388819 */ // Label 7850: @388819
     /* 388819 */ GIM_Try, /*On fail goto*//*Label 7858*/ GIMT_Encode4(388881),
     /* 388824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 388827 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388834 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388838 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388842 */   GIM_Try, /*On fail goto*//*Label 7859*/ GIMT_Encode4(388861), // Rule ID 1616 //
     /* 388847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388850 */     // (AArch64fcmge:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMGE64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 388850 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE64),
     /* 388855 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 388859 */     GIR_RootConstrainSelectedInstOperands,
     /* 388860 */     // GIR_Coverage, 1616,
     /* 388860 */     GIR_Done,
     /* 388861 */   // Label 7859: @388861
     /* 388861 */   GIM_Try, /*On fail goto*//*Label 7860*/ GIMT_Encode4(388880), // Rule ID 5150 //
     /* 388866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388869 */     // (AArch64fcmge:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMGE64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 388869 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE64),
     /* 388874 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 388878 */     GIR_RootConstrainSelectedInstOperands,
     /* 388879 */     // GIR_Coverage, 5150,
     /* 388879 */     GIR_Done,
     /* 388880 */   // Label 7860: @388880
     /* 388880 */   GIM_Reject,
     /* 388881 */ // Label 7858: @388881
     /* 388881 */ GIM_Reject,
     /* 388882 */ // Label 7851: @388882
     /* 388882 */ GIM_Try, /*On fail goto*//*Label 7861*/ GIMT_Encode4(388984),
     /* 388887 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 388890 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 388893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388897 */   GIM_Try, /*On fail goto*//*Label 7862*/ GIMT_Encode4(388956), // Rule ID 1165 //
     /* 388902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 388913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 388917 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388922 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 388926 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 388930 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 388934 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388939 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 388941 */     // (AArch64fcmge:{ *:[v2i32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FACGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 388941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f32),
     /* 388944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 388950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 388954 */     GIR_RootConstrainSelectedInstOperands,
     /* 388955 */     // GIR_Coverage, 1165,
     /* 388955 */     GIR_EraseRootFromParent_Done,
     /* 388956 */   // Label 7862: @388956
     /* 388956 */   GIM_Try, /*On fail goto*//*Label 7863*/ GIMT_Encode4(388983), // Rule ID 1208 //
     /* 388961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388964 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388972 */     // (AArch64fcmge:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 388972 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2f32),
     /* 388977 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 388981 */     GIR_RootConstrainSelectedInstOperands,
     /* 388982 */     // GIR_Coverage, 1208,
     /* 388982 */     GIR_Done,
     /* 388983 */   // Label 7863: @388983
     /* 388983 */   GIM_Reject,
     /* 388984 */ // Label 7861: @388984
     /* 388984 */ GIM_Reject,
     /* 388985 */ // Label 7852: @388985
     /* 388985 */ GIM_Try, /*On fail goto*//*Label 7864*/ GIMT_Encode4(389087),
     /* 388990 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 388993 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 388996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389000 */   GIM_Try, /*On fail goto*//*Label 7865*/ GIMT_Encode4(389059), // Rule ID 1169 //
     /* 389005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 389016 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 389020 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 389029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 389033 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 389037 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389042 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389044 */     // (AArch64fcmge:{ *:[v2i64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FACGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 389044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f64),
     /* 389047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 389053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 389057 */     GIR_RootConstrainSelectedInstOperands,
     /* 389058 */     // GIR_Coverage, 1169,
     /* 389058 */     GIR_EraseRootFromParent_Done,
     /* 389059 */   // Label 7865: @389059
     /* 389059 */   GIM_Try, /*On fail goto*//*Label 7866*/ GIMT_Encode4(389086), // Rule ID 1210 //
     /* 389064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389075 */     // (AArch64fcmge:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 389075 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2f64),
     /* 389080 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 389084 */     GIR_RootConstrainSelectedInstOperands,
     /* 389085 */     // GIR_Coverage, 1210,
     /* 389085 */     GIR_Done,
     /* 389086 */   // Label 7866: @389086
     /* 389086 */   GIM_Reject,
     /* 389087 */ // Label 7864: @389087
     /* 389087 */ GIM_Reject,
     /* 389088 */ // Label 7853: @389088
     /* 389088 */ GIM_Try, /*On fail goto*//*Label 7867*/ GIMT_Encode4(389190),
     /* 389093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 389096 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 389099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389103 */   GIM_Try, /*On fail goto*//*Label 7868*/ GIMT_Encode4(389162), // Rule ID 1161 //
     /* 389108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 389111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 389119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 389123 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389128 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 389132 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 389136 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 389140 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389145 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389147 */     // (AArch64fcmge:{ *:[v4i16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FACGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 389147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f16),
     /* 389150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 389156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 389160 */     GIR_RootConstrainSelectedInstOperands,
     /* 389161 */     // GIR_Coverage, 1161,
     /* 389161 */     GIR_EraseRootFromParent_Done,
     /* 389162 */   // Label 7868: @389162
     /* 389162 */   GIM_Try, /*On fail goto*//*Label 7869*/ GIMT_Encode4(389189), // Rule ID 1206 //
     /* 389167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 389170 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389178 */     // (AArch64fcmge:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 389178 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4f16),
     /* 389183 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 389187 */     GIR_RootConstrainSelectedInstOperands,
     /* 389188 */     // GIR_Coverage, 1206,
     /* 389188 */     GIR_Done,
     /* 389189 */   // Label 7869: @389189
     /* 389189 */   GIM_Reject,
     /* 389190 */ // Label 7867: @389190
     /* 389190 */ GIM_Reject,
     /* 389191 */ // Label 7854: @389191
     /* 389191 */ GIM_Try, /*On fail goto*//*Label 7870*/ GIMT_Encode4(389293),
     /* 389196 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389199 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 389202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389206 */   GIM_Try, /*On fail goto*//*Label 7871*/ GIMT_Encode4(389265), // Rule ID 1167 //
     /* 389211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 389222 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389226 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389231 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 389235 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 389239 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389243 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389248 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389250 */     // (AArch64fcmge:{ *:[v4i32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FACGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 389250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f32),
     /* 389253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 389259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 389263 */     GIR_RootConstrainSelectedInstOperands,
     /* 389264 */     // GIR_Coverage, 1167,
     /* 389264 */     GIR_EraseRootFromParent_Done,
     /* 389265 */   // Label 7871: @389265
     /* 389265 */   GIM_Try, /*On fail goto*//*Label 7872*/ GIMT_Encode4(389292), // Rule ID 1209 //
     /* 389270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389281 */     // (AArch64fcmge:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 389281 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4f32),
     /* 389286 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 389290 */     GIR_RootConstrainSelectedInstOperands,
     /* 389291 */     // GIR_Coverage, 1209,
     /* 389291 */     GIR_Done,
     /* 389292 */   // Label 7872: @389292
     /* 389292 */   GIM_Reject,
     /* 389293 */ // Label 7870: @389293
     /* 389293 */ GIM_Reject,
     /* 389294 */ // Label 7855: @389294
     /* 389294 */ GIM_Try, /*On fail goto*//*Label 7873*/ GIMT_Encode4(389396),
     /* 389299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 389302 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 389305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389309 */   GIM_Try, /*On fail goto*//*Label 7874*/ GIMT_Encode4(389368), // Rule ID 1163 //
     /* 389314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 389317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 389325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 389329 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389334 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 389338 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 389342 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 389346 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389351 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389353 */     // (AArch64fcmge:{ *:[v8i16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FACGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 389353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv8f16),
     /* 389356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 389362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 389366 */     GIR_RootConstrainSelectedInstOperands,
     /* 389367 */     // GIR_Coverage, 1163,
     /* 389367 */     GIR_EraseRootFromParent_Done,
     /* 389368 */   // Label 7874: @389368
     /* 389368 */   GIM_Try, /*On fail goto*//*Label 7875*/ GIMT_Encode4(389395), // Rule ID 1207 //
     /* 389373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 389376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389384 */     // (AArch64fcmge:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 389384 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv8f16),
     /* 389389 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 389393 */     GIR_RootConstrainSelectedInstOperands,
     /* 389394 */     // GIR_Coverage, 1207,
     /* 389394 */     GIR_Done,
     /* 389395 */   // Label 7875: @389395
     /* 389395 */   GIM_Reject,
     /* 389396 */ // Label 7873: @389396
     /* 389396 */ GIM_Reject,
     /* 389397 */ // Label 7856: @389397
     /* 389397 */ GIM_Reject,
     /* 389398 */ // Label 128: @389398
     /* 389398 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 7882*/ GIMT_Encode4(389627),
     /* 389409 */ /*GILLT_s64*//*Label 7876*/ GIMT_Encode4(389441), GIMT_Encode4(0),
     /* 389417 */ /*GILLT_v2s32*//*Label 7877*/ GIMT_Encode4(389472),
     /* 389421 */ /*GILLT_v2s64*//*Label 7878*/ GIMT_Encode4(389503),
     /* 389425 */ /*GILLT_v4s16*//*Label 7879*/ GIMT_Encode4(389534),
     /* 389429 */ /*GILLT_v4s32*//*Label 7880*/ GIMT_Encode4(389565), GIMT_Encode4(0),
     /* 389437 */ /*GILLT_v8s16*//*Label 7881*/ GIMT_Encode4(389596),
     /* 389441 */ // Label 7876: @389441
     /* 389441 */ GIM_Try, /*On fail goto*//*Label 7883*/ GIMT_Encode4(389471), // Rule ID 5180 //
     /* 389446 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 389452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389456 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389460 */   // (AArch64fcmgez:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMGEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 389460 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv1i64rz),
     /* 389465 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 389469 */   GIR_RootConstrainSelectedInstOperands,
     /* 389470 */   // GIR_Coverage, 5180,
     /* 389470 */   GIR_Done,
     /* 389471 */ // Label 7883: @389471
     /* 389471 */ GIM_Reject,
     /* 389472 */ // Label 7877: @389472
     /* 389472 */ GIM_Try, /*On fail goto*//*Label 7884*/ GIMT_Encode4(389502), // Rule ID 771 //
     /* 389477 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389480 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 389483 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389487 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389491 */   // (AArch64fcmgez:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 389491 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2i32rz),
     /* 389496 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 389500 */   GIR_RootConstrainSelectedInstOperands,
     /* 389501 */   // GIR_Coverage, 771,
     /* 389501 */   GIR_Done,
     /* 389502 */ // Label 7884: @389502
     /* 389502 */ GIM_Reject,
     /* 389503 */ // Label 7878: @389503
     /* 389503 */ GIM_Try, /*On fail goto*//*Label 7885*/ GIMT_Encode4(389533), // Rule ID 773 //
     /* 389508 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389511 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 389514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389518 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389522 */   // (AArch64fcmgez:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 389522 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2i64rz),
     /* 389527 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 389531 */   GIR_RootConstrainSelectedInstOperands,
     /* 389532 */   // GIR_Coverage, 773,
     /* 389532 */   GIR_Done,
     /* 389533 */ // Label 7885: @389533
     /* 389533 */ GIM_Reject,
     /* 389534 */ // Label 7879: @389534
     /* 389534 */ GIM_Try, /*On fail goto*//*Label 7886*/ GIMT_Encode4(389564), // Rule ID 769 //
     /* 389539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 389542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 389545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389549 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389553 */   // (AArch64fcmgez:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 389553 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4i16rz),
     /* 389558 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 389562 */   GIR_RootConstrainSelectedInstOperands,
     /* 389563 */   // GIR_Coverage, 769,
     /* 389563 */   GIR_Done,
     /* 389564 */ // Label 7886: @389564
     /* 389564 */ GIM_Reject,
     /* 389565 */ // Label 7880: @389565
     /* 389565 */ GIM_Try, /*On fail goto*//*Label 7887*/ GIMT_Encode4(389595), // Rule ID 772 //
     /* 389570 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389580 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389584 */   // (AArch64fcmgez:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 389584 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4i32rz),
     /* 389589 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 389593 */   GIR_RootConstrainSelectedInstOperands,
     /* 389594 */   // GIR_Coverage, 772,
     /* 389594 */   GIR_Done,
     /* 389595 */ // Label 7887: @389595
     /* 389595 */ GIM_Reject,
     /* 389596 */ // Label 7881: @389596
     /* 389596 */ GIM_Try, /*On fail goto*//*Label 7888*/ GIMT_Encode4(389626), // Rule ID 770 //
     /* 389601 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 389604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 389607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389611 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389615 */   // (AArch64fcmgez:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 389615 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv8i16rz),
     /* 389620 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 389624 */   GIR_RootConstrainSelectedInstOperands,
     /* 389625 */   // GIR_Coverage, 770,
     /* 389625 */   GIR_Done,
     /* 389626 */ // Label 7888: @389626
     /* 389626 */ GIM_Reject,
     /* 389627 */ // Label 7882: @389627
     /* 389627 */ GIM_Reject,
     /* 389628 */ // Label 129: @389628
     /* 389628 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 7896*/ GIMT_Encode4(390291),
     /* 389639 */ /*GILLT_s32*//*Label 7889*/ GIMT_Encode4(389675),
     /* 389643 */ /*GILLT_s64*//*Label 7890*/ GIMT_Encode4(389713), GIMT_Encode4(0),
     /* 389651 */ /*GILLT_v2s32*//*Label 7891*/ GIMT_Encode4(389776),
     /* 389655 */ /*GILLT_v2s64*//*Label 7892*/ GIMT_Encode4(389879),
     /* 389659 */ /*GILLT_v4s16*//*Label 7893*/ GIMT_Encode4(389982),
     /* 389663 */ /*GILLT_v4s32*//*Label 7894*/ GIMT_Encode4(390085), GIMT_Encode4(0),
     /* 389671 */ /*GILLT_v8s16*//*Label 7895*/ GIMT_Encode4(390188),
     /* 389675 */ // Label 7889: @389675
     /* 389675 */ GIM_Try, /*On fail goto*//*Label 7897*/ GIMT_Encode4(389712), // Rule ID 1619 //
     /* 389680 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389683 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 389686 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 389689 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389693 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389697 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389701 */   // (AArch64fcmgt:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMGT32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 389701 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT32),
     /* 389706 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 389710 */   GIR_RootConstrainSelectedInstOperands,
     /* 389711 */   // GIR_Coverage, 1619,
     /* 389711 */   GIR_Done,
     /* 389712 */ // Label 7897: @389712
     /* 389712 */ GIM_Reject,
     /* 389713 */ // Label 7890: @389713
     /* 389713 */ GIM_Try, /*On fail goto*//*Label 7898*/ GIMT_Encode4(389775),
     /* 389718 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 389721 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 389724 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389728 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389732 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389736 */   GIM_Try, /*On fail goto*//*Label 7899*/ GIMT_Encode4(389755), // Rule ID 1618 //
     /* 389741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389744 */     // (AArch64fcmgt:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMGT64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 389744 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT64),
     /* 389749 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 389753 */     GIR_RootConstrainSelectedInstOperands,
     /* 389754 */     // GIR_Coverage, 1618,
     /* 389754 */     GIR_Done,
     /* 389755 */   // Label 7899: @389755
     /* 389755 */   GIM_Try, /*On fail goto*//*Label 7900*/ GIMT_Encode4(389774), // Rule ID 5151 //
     /* 389760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389763 */     // (AArch64fcmgt:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMGT64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 389763 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT64),
     /* 389768 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 389772 */     GIR_RootConstrainSelectedInstOperands,
     /* 389773 */     // GIR_Coverage, 5151,
     /* 389773 */     GIR_Done,
     /* 389774 */   // Label 7900: @389774
     /* 389774 */   GIM_Reject,
     /* 389775 */ // Label 7898: @389775
     /* 389775 */ GIM_Reject,
     /* 389776 */ // Label 7891: @389776
     /* 389776 */ GIM_Try, /*On fail goto*//*Label 7901*/ GIMT_Encode4(389878),
     /* 389781 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 389784 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 389787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389791 */   GIM_Try, /*On fail goto*//*Label 7902*/ GIMT_Encode4(389850), // Rule ID 1175 //
     /* 389796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 389807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 389811 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389816 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 389820 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 389824 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 389828 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389833 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389835 */     // (AArch64fcmgt:{ *:[v2i32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FACGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 389835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f32),
     /* 389838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 389844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 389848 */     GIR_RootConstrainSelectedInstOperands,
     /* 389849 */     // GIR_Coverage, 1175,
     /* 389849 */     GIR_EraseRootFromParent_Done,
     /* 389850 */   // Label 7902: @389850
     /* 389850 */   GIM_Try, /*On fail goto*//*Label 7903*/ GIMT_Encode4(389877), // Rule ID 1213 //
     /* 389855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389858 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389866 */     // (AArch64fcmgt:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 389866 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2f32),
     /* 389871 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 389875 */     GIR_RootConstrainSelectedInstOperands,
     /* 389876 */     // GIR_Coverage, 1213,
     /* 389876 */     GIR_Done,
     /* 389877 */   // Label 7903: @389877
     /* 389877 */   GIM_Reject,
     /* 389878 */ // Label 7901: @389878
     /* 389878 */ GIM_Reject,
     /* 389879 */ // Label 7892: @389879
     /* 389879 */ GIM_Try, /*On fail goto*//*Label 7904*/ GIMT_Encode4(389981),
     /* 389884 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 389887 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 389890 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389894 */   GIM_Try, /*On fail goto*//*Label 7905*/ GIMT_Encode4(389953), // Rule ID 1179 //
     /* 389899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 389910 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 389914 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389919 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 389923 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 389927 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 389931 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389936 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389938 */     // (AArch64fcmgt:{ *:[v2i64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FACGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 389938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f64),
     /* 389941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 389947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 389951 */     GIR_RootConstrainSelectedInstOperands,
     /* 389952 */     // GIR_Coverage, 1179,
     /* 389952 */     GIR_EraseRootFromParent_Done,
     /* 389953 */   // Label 7905: @389953
     /* 389953 */   GIM_Try, /*On fail goto*//*Label 7906*/ GIMT_Encode4(389980), // Rule ID 1215 //
     /* 389958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389961 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389969 */     // (AArch64fcmgt:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 389969 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2f64),
     /* 389974 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 389978 */     GIR_RootConstrainSelectedInstOperands,
     /* 389979 */     // GIR_Coverage, 1215,
     /* 389979 */     GIR_Done,
     /* 389980 */   // Label 7906: @389980
     /* 389980 */   GIM_Reject,
     /* 389981 */ // Label 7904: @389981
     /* 389981 */ GIM_Reject,
     /* 389982 */ // Label 7893: @389982
     /* 389982 */ GIM_Try, /*On fail goto*//*Label 7907*/ GIMT_Encode4(390084),
     /* 389987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 389990 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 389993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389997 */   GIM_Try, /*On fail goto*//*Label 7908*/ GIMT_Encode4(390056), // Rule ID 1171 //
     /* 390002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 390005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 390013 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 390017 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390022 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 390026 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 390030 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 390034 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390039 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390041 */     // (AArch64fcmgt:{ *:[v4i16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FACGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 390041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f16),
     /* 390044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 390046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 390050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 390054 */     GIR_RootConstrainSelectedInstOperands,
     /* 390055 */     // GIR_Coverage, 1171,
     /* 390055 */     GIR_EraseRootFromParent_Done,
     /* 390056 */   // Label 7908: @390056
     /* 390056 */   GIM_Try, /*On fail goto*//*Label 7909*/ GIMT_Encode4(390083), // Rule ID 1211 //
     /* 390061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 390064 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390072 */     // (AArch64fcmgt:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 390072 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4f16),
     /* 390077 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 390081 */     GIR_RootConstrainSelectedInstOperands,
     /* 390082 */     // GIR_Coverage, 1211,
     /* 390082 */     GIR_Done,
     /* 390083 */   // Label 7909: @390083
     /* 390083 */   GIM_Reject,
     /* 390084 */ // Label 7907: @390084
     /* 390084 */ GIM_Reject,
     /* 390085 */ // Label 7894: @390085
     /* 390085 */ GIM_Try, /*On fail goto*//*Label 7910*/ GIMT_Encode4(390187),
     /* 390090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 390093 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 390096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390100 */   GIM_Try, /*On fail goto*//*Label 7911*/ GIMT_Encode4(390159), // Rule ID 1177 //
     /* 390105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 390116 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 390120 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390125 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 390129 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 390133 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 390137 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390142 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390144 */     // (AArch64fcmgt:{ *:[v4i32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FACGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 390144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f32),
     /* 390147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 390149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 390153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 390157 */     GIR_RootConstrainSelectedInstOperands,
     /* 390158 */     // GIR_Coverage, 1177,
     /* 390158 */     GIR_EraseRootFromParent_Done,
     /* 390159 */   // Label 7911: @390159
     /* 390159 */   GIM_Try, /*On fail goto*//*Label 7912*/ GIMT_Encode4(390186), // Rule ID 1214 //
     /* 390164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390167 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390175 */     // (AArch64fcmgt:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 390175 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4f32),
     /* 390180 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 390184 */     GIR_RootConstrainSelectedInstOperands,
     /* 390185 */     // GIR_Coverage, 1214,
     /* 390185 */     GIR_Done,
     /* 390186 */   // Label 7912: @390186
     /* 390186 */   GIM_Reject,
     /* 390187 */ // Label 7910: @390187
     /* 390187 */ GIM_Reject,
     /* 390188 */ // Label 7895: @390188
     /* 390188 */ GIM_Try, /*On fail goto*//*Label 7913*/ GIMT_Encode4(390290),
     /* 390193 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 390196 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 390199 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390203 */   GIM_Try, /*On fail goto*//*Label 7914*/ GIMT_Encode4(390262), // Rule ID 1173 //
     /* 390208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 390211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 390219 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 390223 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390228 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 390232 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 390236 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 390240 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390245 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390247 */     // (AArch64fcmgt:{ *:[v8i16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FACGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 390247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv8f16),
     /* 390250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 390252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 390256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 390260 */     GIR_RootConstrainSelectedInstOperands,
     /* 390261 */     // GIR_Coverage, 1173,
     /* 390261 */     GIR_EraseRootFromParent_Done,
     /* 390262 */   // Label 7914: @390262
     /* 390262 */   GIM_Try, /*On fail goto*//*Label 7915*/ GIMT_Encode4(390289), // Rule ID 1212 //
     /* 390267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 390270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390278 */     // (AArch64fcmgt:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 390278 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv8f16),
     /* 390283 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 390287 */     GIR_RootConstrainSelectedInstOperands,
     /* 390288 */     // GIR_Coverage, 1212,
     /* 390288 */     GIR_Done,
     /* 390289 */   // Label 7915: @390289
     /* 390289 */   GIM_Reject,
     /* 390290 */ // Label 7913: @390290
     /* 390290 */ GIM_Reject,
     /* 390291 */ // Label 7896: @390291
     /* 390291 */ GIM_Reject,
     /* 390292 */ // Label 130: @390292
     /* 390292 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 7922*/ GIMT_Encode4(390521),
     /* 390303 */ /*GILLT_s64*//*Label 7916*/ GIMT_Encode4(390335), GIMT_Encode4(0),
     /* 390311 */ /*GILLT_v2s32*//*Label 7917*/ GIMT_Encode4(390366),
     /* 390315 */ /*GILLT_v2s64*//*Label 7918*/ GIMT_Encode4(390397),
     /* 390319 */ /*GILLT_v4s16*//*Label 7919*/ GIMT_Encode4(390428),
     /* 390323 */ /*GILLT_v4s32*//*Label 7920*/ GIMT_Encode4(390459), GIMT_Encode4(0),
     /* 390331 */ /*GILLT_v8s16*//*Label 7921*/ GIMT_Encode4(390490),
     /* 390335 */ // Label 7916: @390335
     /* 390335 */ GIM_Try, /*On fail goto*//*Label 7923*/ GIMT_Encode4(390365), // Rule ID 5181 //
     /* 390340 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390343 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 390346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390350 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390354 */   // (AArch64fcmgtz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMGTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 390354 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv1i64rz),
     /* 390359 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 390363 */   GIR_RootConstrainSelectedInstOperands,
     /* 390364 */   // GIR_Coverage, 5181,
     /* 390364 */   GIR_Done,
     /* 390365 */ // Label 7923: @390365
     /* 390365 */ GIM_Reject,
     /* 390366 */ // Label 7917: @390366
     /* 390366 */ GIM_Try, /*On fail goto*//*Label 7924*/ GIMT_Encode4(390396), // Rule ID 776 //
     /* 390371 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390374 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 390377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390381 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390385 */   // (AArch64fcmgtz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 390385 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2i32rz),
     /* 390390 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 390394 */   GIR_RootConstrainSelectedInstOperands,
     /* 390395 */   // GIR_Coverage, 776,
     /* 390395 */   GIR_Done,
     /* 390396 */ // Label 7924: @390396
     /* 390396 */ GIM_Reject,
     /* 390397 */ // Label 7918: @390397
     /* 390397 */ GIM_Try, /*On fail goto*//*Label 7925*/ GIMT_Encode4(390427), // Rule ID 778 //
     /* 390402 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390405 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 390408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390412 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390416 */   // (AArch64fcmgtz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 390416 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2i64rz),
     /* 390421 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 390425 */   GIR_RootConstrainSelectedInstOperands,
     /* 390426 */   // GIR_Coverage, 778,
     /* 390426 */   GIR_Done,
     /* 390427 */ // Label 7925: @390427
     /* 390427 */ GIM_Reject,
     /* 390428 */ // Label 7919: @390428
     /* 390428 */ GIM_Try, /*On fail goto*//*Label 7926*/ GIMT_Encode4(390458), // Rule ID 774 //
     /* 390433 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 390436 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 390439 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390443 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390447 */   // (AArch64fcmgtz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 390447 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4i16rz),
     /* 390452 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 390456 */   GIR_RootConstrainSelectedInstOperands,
     /* 390457 */   // GIR_Coverage, 774,
     /* 390457 */   GIR_Done,
     /* 390458 */ // Label 7926: @390458
     /* 390458 */ GIM_Reject,
     /* 390459 */ // Label 7920: @390459
     /* 390459 */ GIM_Try, /*On fail goto*//*Label 7927*/ GIMT_Encode4(390489), // Rule ID 777 //
     /* 390464 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390467 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 390470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390474 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390478 */   // (AArch64fcmgtz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 390478 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4i32rz),
     /* 390483 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 390487 */   GIR_RootConstrainSelectedInstOperands,
     /* 390488 */   // GIR_Coverage, 777,
     /* 390488 */   GIR_Done,
     /* 390489 */ // Label 7927: @390489
     /* 390489 */ GIM_Reject,
     /* 390490 */ // Label 7921: @390490
     /* 390490 */ GIM_Try, /*On fail goto*//*Label 7928*/ GIMT_Encode4(390520), // Rule ID 775 //
     /* 390495 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 390498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 390501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390505 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390509 */   // (AArch64fcmgtz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 390509 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv8i16rz),
     /* 390514 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 390518 */   GIR_RootConstrainSelectedInstOperands,
     /* 390519 */   // GIR_Coverage, 775,
     /* 390519 */   GIR_Done,
     /* 390520 */ // Label 7928: @390520
     /* 390520 */ GIM_Reject,
     /* 390521 */ // Label 7922: @390521
     /* 390521 */ GIM_Reject,
     /* 390522 */ // Label 131: @390522
     /* 390522 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 7935*/ GIMT_Encode4(390751),
     /* 390533 */ /*GILLT_s64*//*Label 7929*/ GIMT_Encode4(390565), GIMT_Encode4(0),
     /* 390541 */ /*GILLT_v2s32*//*Label 7930*/ GIMT_Encode4(390596),
     /* 390545 */ /*GILLT_v2s64*//*Label 7931*/ GIMT_Encode4(390627),
     /* 390549 */ /*GILLT_v4s16*//*Label 7932*/ GIMT_Encode4(390658),
     /* 390553 */ /*GILLT_v4s32*//*Label 7933*/ GIMT_Encode4(390689), GIMT_Encode4(0),
     /* 390561 */ /*GILLT_v8s16*//*Label 7934*/ GIMT_Encode4(390720),
     /* 390565 */ // Label 7929: @390565
     /* 390565 */ GIM_Try, /*On fail goto*//*Label 7936*/ GIMT_Encode4(390595), // Rule ID 5182 //
     /* 390570 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 390576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390580 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390584 */   // (AArch64fcmlez:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMLEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 390584 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv1i64rz),
     /* 390589 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 390593 */   GIR_RootConstrainSelectedInstOperands,
     /* 390594 */   // GIR_Coverage, 5182,
     /* 390594 */   GIR_Done,
     /* 390595 */ // Label 7936: @390595
     /* 390595 */ GIM_Reject,
     /* 390596 */ // Label 7930: @390596
     /* 390596 */ GIM_Try, /*On fail goto*//*Label 7937*/ GIMT_Encode4(390626), // Rule ID 781 //
     /* 390601 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 390607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390611 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390615 */   // (AArch64fcmlez:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 390615 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv2i32rz),
     /* 390620 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 390624 */   GIR_RootConstrainSelectedInstOperands,
     /* 390625 */   // GIR_Coverage, 781,
     /* 390625 */   GIR_Done,
     /* 390626 */ // Label 7937: @390626
     /* 390626 */ GIM_Reject,
     /* 390627 */ // Label 7931: @390627
     /* 390627 */ GIM_Try, /*On fail goto*//*Label 7938*/ GIMT_Encode4(390657), // Rule ID 783 //
     /* 390632 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390635 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 390638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390642 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390646 */   // (AArch64fcmlez:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 390646 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv2i64rz),
     /* 390651 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 390655 */   GIR_RootConstrainSelectedInstOperands,
     /* 390656 */   // GIR_Coverage, 783,
     /* 390656 */   GIR_Done,
     /* 390657 */ // Label 7938: @390657
     /* 390657 */ GIM_Reject,
     /* 390658 */ // Label 7932: @390658
     /* 390658 */ GIM_Try, /*On fail goto*//*Label 7939*/ GIMT_Encode4(390688), // Rule ID 779 //
     /* 390663 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 390666 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 390669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390673 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390677 */   // (AArch64fcmlez:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 390677 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv4i16rz),
     /* 390682 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 390686 */   GIR_RootConstrainSelectedInstOperands,
     /* 390687 */   // GIR_Coverage, 779,
     /* 390687 */   GIR_Done,
     /* 390688 */ // Label 7939: @390688
     /* 390688 */ GIM_Reject,
     /* 390689 */ // Label 7933: @390689
     /* 390689 */ GIM_Try, /*On fail goto*//*Label 7940*/ GIMT_Encode4(390719), // Rule ID 782 //
     /* 390694 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 390700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390704 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390708 */   // (AArch64fcmlez:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 390708 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv4i32rz),
     /* 390713 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 390717 */   GIR_RootConstrainSelectedInstOperands,
     /* 390718 */   // GIR_Coverage, 782,
     /* 390718 */   GIR_Done,
     /* 390719 */ // Label 7940: @390719
     /* 390719 */ GIM_Reject,
     /* 390720 */ // Label 7934: @390720
     /* 390720 */ GIM_Try, /*On fail goto*//*Label 7941*/ GIMT_Encode4(390750), // Rule ID 780 //
     /* 390725 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 390728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 390731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390735 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390739 */   // (AArch64fcmlez:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 390739 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv8i16rz),
     /* 390744 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 390748 */   GIR_RootConstrainSelectedInstOperands,
     /* 390749 */   // GIR_Coverage, 780,
     /* 390749 */   GIR_Done,
     /* 390750 */ // Label 7941: @390750
     /* 390750 */ GIM_Reject,
     /* 390751 */ // Label 7935: @390751
     /* 390751 */ GIM_Reject,
     /* 390752 */ // Label 132: @390752
     /* 390752 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 7948*/ GIMT_Encode4(390981),
     /* 390763 */ /*GILLT_s64*//*Label 7942*/ GIMT_Encode4(390795), GIMT_Encode4(0),
     /* 390771 */ /*GILLT_v2s32*//*Label 7943*/ GIMT_Encode4(390826),
     /* 390775 */ /*GILLT_v2s64*//*Label 7944*/ GIMT_Encode4(390857),
     /* 390779 */ /*GILLT_v4s16*//*Label 7945*/ GIMT_Encode4(390888),
     /* 390783 */ /*GILLT_v4s32*//*Label 7946*/ GIMT_Encode4(390919), GIMT_Encode4(0),
     /* 390791 */ /*GILLT_v8s16*//*Label 7947*/ GIMT_Encode4(390950),
     /* 390795 */ // Label 7942: @390795
     /* 390795 */ GIM_Try, /*On fail goto*//*Label 7949*/ GIMT_Encode4(390825), // Rule ID 5183 //
     /* 390800 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390803 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 390806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390810 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390814 */   // (AArch64fcmltz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMLTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 390814 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv1i64rz),
     /* 390819 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 390823 */   GIR_RootConstrainSelectedInstOperands,
     /* 390824 */   // GIR_Coverage, 5183,
     /* 390824 */   GIR_Done,
     /* 390825 */ // Label 7949: @390825
     /* 390825 */ GIM_Reject,
     /* 390826 */ // Label 7943: @390826
     /* 390826 */ GIM_Try, /*On fail goto*//*Label 7950*/ GIMT_Encode4(390856), // Rule ID 786 //
     /* 390831 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390834 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 390837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390841 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390845 */   // (AArch64fcmltz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 390845 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv2i32rz),
     /* 390850 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 390854 */   GIR_RootConstrainSelectedInstOperands,
     /* 390855 */   // GIR_Coverage, 786,
     /* 390855 */   GIR_Done,
     /* 390856 */ // Label 7950: @390856
     /* 390856 */ GIM_Reject,
     /* 390857 */ // Label 7944: @390857
     /* 390857 */ GIM_Try, /*On fail goto*//*Label 7951*/ GIMT_Encode4(390887), // Rule ID 788 //
     /* 390862 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 390868 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390872 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390876 */   // (AArch64fcmltz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 390876 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv2i64rz),
     /* 390881 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 390885 */   GIR_RootConstrainSelectedInstOperands,
     /* 390886 */   // GIR_Coverage, 788,
     /* 390886 */   GIR_Done,
     /* 390887 */ // Label 7951: @390887
     /* 390887 */ GIM_Reject,
     /* 390888 */ // Label 7945: @390888
     /* 390888 */ GIM_Try, /*On fail goto*//*Label 7952*/ GIMT_Encode4(390918), // Rule ID 784 //
     /* 390893 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 390896 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 390899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390903 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390907 */   // (AArch64fcmltz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 390907 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv4i16rz),
     /* 390912 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 390916 */   GIR_RootConstrainSelectedInstOperands,
     /* 390917 */   // GIR_Coverage, 784,
     /* 390917 */   GIR_Done,
     /* 390918 */ // Label 7952: @390918
     /* 390918 */ GIM_Reject,
     /* 390919 */ // Label 7946: @390919
     /* 390919 */ GIM_Try, /*On fail goto*//*Label 7953*/ GIMT_Encode4(390949), // Rule ID 787 //
     /* 390924 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390927 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 390930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390934 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390938 */   // (AArch64fcmltz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 390938 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv4i32rz),
     /* 390943 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 390947 */   GIR_RootConstrainSelectedInstOperands,
     /* 390948 */   // GIR_Coverage, 787,
     /* 390948 */   GIR_Done,
     /* 390949 */ // Label 7953: @390949
     /* 390949 */ GIM_Reject,
     /* 390950 */ // Label 7947: @390950
     /* 390950 */ GIM_Try, /*On fail goto*//*Label 7954*/ GIMT_Encode4(390980), // Rule ID 785 //
     /* 390955 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 390958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 390961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390965 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390969 */   // (AArch64fcmltz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 390969 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv8i16rz),
     /* 390974 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 390978 */   GIR_RootConstrainSelectedInstOperands,
     /* 390979 */   // GIR_Coverage, 785,
     /* 390979 */   GIR_Done,
     /* 390980 */ // Label 7954: @390980
     /* 390980 */ GIM_Reject,
     /* 390981 */ // Label 7948: @390981
     /* 390981 */ GIM_Reject,
     /* 390982 */ // Label 133: @390982
     /* 390982 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7959*/ GIMT_Encode4(391135),
     /* 390993 */ /*GILLT_s32*//*Label 7955*/ GIMT_Encode4(391033),
     /* 390997 */ /*GILLT_s64*//*Label 7956*/ GIMT_Encode4(391057), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 391021 */ /*GILLT_v8s8*//*Label 7957*/ GIMT_Encode4(391081), GIMT_Encode4(0),
     /* 391029 */ /*GILLT_v16s8*//*Label 7958*/ GIMT_Encode4(391108),
     /* 391033 */ // Label 7955: @391033
     /* 391033 */ GIM_Try, /*On fail goto*//*Label 7960*/ GIMT_Encode4(391056), // Rule ID 3957 //
     /* 391038 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 391041 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 391045 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 391049 */   // (AArch64rev16:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 391049 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
     /* 391054 */   GIR_RootConstrainSelectedInstOperands,
     /* 391055 */   // GIR_Coverage, 3957,
     /* 391055 */   GIR_Done,
     /* 391056 */ // Label 7960: @391056
     /* 391056 */ GIM_Reject,
     /* 391057 */ // Label 7956: @391057
     /* 391057 */ GIM_Try, /*On fail goto*//*Label 7961*/ GIMT_Encode4(391080), // Rule ID 3958 //
     /* 391062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 391065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 391069 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 391073 */   // (AArch64rev16:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (REV16Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 391073 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16Xr),
     /* 391078 */   GIR_RootConstrainSelectedInstOperands,
     /* 391079 */   // GIR_Coverage, 3958,
     /* 391079 */   GIR_Done,
     /* 391080 */ // Label 7961: @391080
     /* 391080 */ GIM_Reject,
     /* 391081 */ // Label 7957: @391081
     /* 391081 */ GIM_Try, /*On fail goto*//*Label 7962*/ GIMT_Encode4(391107), // Rule ID 969 //
     /* 391086 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 391092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391096 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391100 */   // (AArch64rev16:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV16v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 391100 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 391105 */   GIR_RootConstrainSelectedInstOperands,
     /* 391106 */   // GIR_Coverage, 969,
     /* 391106 */   GIR_Done,
     /* 391107 */ // Label 7962: @391107
     /* 391107 */ GIM_Reject,
     /* 391108 */ // Label 7958: @391108
     /* 391108 */ GIM_Try, /*On fail goto*//*Label 7963*/ GIMT_Encode4(391134), // Rule ID 970 //
     /* 391113 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391116 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 391119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391123 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391127 */   // (AArch64rev16:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV16v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 391127 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 391132 */   GIR_RootConstrainSelectedInstOperands,
     /* 391133 */   // GIR_Coverage, 970,
     /* 391133 */   GIR_Done,
     /* 391134 */ // Label 7963: @391134
     /* 391134 */ GIM_Reject,
     /* 391135 */ // Label 7959: @391135
     /* 391135 */ GIM_Reject,
     /* 391136 */ // Label 134: @391136
     /* 391136 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(12), /*)*//*default:*//*Label 7968*/ GIMT_Encode4(391311),
     /* 391147 */ /*GILLT_v4s16*//*Label 7964*/ GIMT_Encode4(391167), GIMT_Encode4(0),
     /* 391155 */ /*GILLT_v8s8*//*Label 7965*/ GIMT_Encode4(391212),
     /* 391159 */ /*GILLT_v8s16*//*Label 7966*/ GIMT_Encode4(391239),
     /* 391163 */ /*GILLT_v16s8*//*Label 7967*/ GIMT_Encode4(391284),
     /* 391167 */ // Label 7964: @391167
     /* 391167 */ GIM_Try, /*On fail goto*//*Label 7969*/ GIMT_Encode4(391211),
     /* 391172 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 391175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391179 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391183 */   GIM_Try, /*On fail goto*//*Label 7970*/ GIMT_Encode4(391198), // Rule ID 973 //
     /* 391188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391191 */     // (AArch64rev32:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV32v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 391191 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 391196 */     GIR_RootConstrainSelectedInstOperands,
     /* 391197 */     // GIR_Coverage, 973,
     /* 391197 */     GIR_Done,
     /* 391198 */   // Label 7970: @391198
     /* 391198 */   GIM_Try, /*On fail goto*//*Label 7971*/ GIMT_Encode4(391210), // Rule ID 4902 //
     /* 391203 */     // (AArch64rev32:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (REV32v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 391203 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 391208 */     GIR_RootConstrainSelectedInstOperands,
     /* 391209 */     // GIR_Coverage, 4902,
     /* 391209 */     GIR_Done,
     /* 391210 */   // Label 7971: @391210
     /* 391210 */   GIM_Reject,
     /* 391211 */ // Label 7969: @391211
     /* 391211 */ GIM_Reject,
     /* 391212 */ // Label 7965: @391212
     /* 391212 */ GIM_Try, /*On fail goto*//*Label 7972*/ GIMT_Encode4(391238), // Rule ID 971 //
     /* 391217 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 391223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391227 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391231 */   // (AArch64rev32:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV32v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 391231 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 391236 */   GIR_RootConstrainSelectedInstOperands,
     /* 391237 */   // GIR_Coverage, 971,
     /* 391237 */   GIR_Done,
     /* 391238 */ // Label 7972: @391238
     /* 391238 */ GIM_Reject,
     /* 391239 */ // Label 7966: @391239
     /* 391239 */ GIM_Try, /*On fail goto*//*Label 7973*/ GIMT_Encode4(391283),
     /* 391244 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 391247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391251 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391255 */   GIM_Try, /*On fail goto*//*Label 7974*/ GIMT_Encode4(391270), // Rule ID 974 //
     /* 391260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391263 */     // (AArch64rev32:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV32v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 391263 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 391268 */     GIR_RootConstrainSelectedInstOperands,
     /* 391269 */     // GIR_Coverage, 974,
     /* 391269 */     GIR_Done,
     /* 391270 */   // Label 7974: @391270
     /* 391270 */   GIM_Try, /*On fail goto*//*Label 7975*/ GIMT_Encode4(391282), // Rule ID 4904 //
     /* 391275 */     // (AArch64rev32:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (REV32v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 391275 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 391280 */     GIR_RootConstrainSelectedInstOperands,
     /* 391281 */     // GIR_Coverage, 4904,
     /* 391281 */     GIR_Done,
     /* 391282 */   // Label 7975: @391282
     /* 391282 */   GIM_Reject,
     /* 391283 */ // Label 7973: @391283
     /* 391283 */ GIM_Reject,
     /* 391284 */ // Label 7967: @391284
     /* 391284 */ GIM_Try, /*On fail goto*//*Label 7976*/ GIMT_Encode4(391310), // Rule ID 972 //
     /* 391289 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391292 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 391295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391299 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391303 */   // (AArch64rev32:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV32v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 391303 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 391308 */   GIR_RootConstrainSelectedInstOperands,
     /* 391309 */   // GIR_Coverage, 972,
     /* 391309 */   GIR_Done,
     /* 391310 */ // Label 7976: @391310
     /* 391310 */ GIM_Reject,
     /* 391311 */ // Label 7968: @391311
     /* 391311 */ GIM_Reject,
     /* 391312 */ // Label 135: @391312
     /* 391312 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(12), /*)*//*default:*//*Label 7983*/ GIMT_Encode4(391585),
     /* 391323 */ /*GILLT_v2s32*//*Label 7977*/ GIMT_Encode4(391351), GIMT_Encode4(0),
     /* 391331 */ /*GILLT_v4s16*//*Label 7978*/ GIMT_Encode4(391396),
     /* 391335 */ /*GILLT_v4s32*//*Label 7979*/ GIMT_Encode4(391441),
     /* 391339 */ /*GILLT_v8s8*//*Label 7980*/ GIMT_Encode4(391486),
     /* 391343 */ /*GILLT_v8s16*//*Label 7981*/ GIMT_Encode4(391513),
     /* 391347 */ /*GILLT_v16s8*//*Label 7982*/ GIMT_Encode4(391558),
     /* 391351 */ // Label 7977: @391351
     /* 391351 */ GIM_Try, /*On fail goto*//*Label 7984*/ GIMT_Encode4(391395),
     /* 391356 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 391359 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391363 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391367 */   GIM_Try, /*On fail goto*//*Label 7985*/ GIMT_Encode4(391382), // Rule ID 979 //
     /* 391372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391375 */     // (AArch64rev64:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (REV64v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 391375 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 391380 */     GIR_RootConstrainSelectedInstOperands,
     /* 391381 */     // GIR_Coverage, 979,
     /* 391381 */     GIR_Done,
     /* 391382 */   // Label 7985: @391382
     /* 391382 */   GIM_Try, /*On fail goto*//*Label 7986*/ GIMT_Encode4(391394), // Rule ID 4906 //
     /* 391387 */     // (AArch64rev64:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (REV64v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 391387 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 391392 */     GIR_RootConstrainSelectedInstOperands,
     /* 391393 */     // GIR_Coverage, 4906,
     /* 391393 */     GIR_Done,
     /* 391394 */   // Label 7986: @391394
     /* 391394 */   GIM_Reject,
     /* 391395 */ // Label 7984: @391395
     /* 391395 */ GIM_Reject,
     /* 391396 */ // Label 7978: @391396
     /* 391396 */ GIM_Try, /*On fail goto*//*Label 7987*/ GIMT_Encode4(391440),
     /* 391401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 391404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391412 */   GIM_Try, /*On fail goto*//*Label 7988*/ GIMT_Encode4(391427), // Rule ID 977 //
     /* 391417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391420 */     // (AArch64rev64:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV64v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 391420 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 391425 */     GIR_RootConstrainSelectedInstOperands,
     /* 391426 */     // GIR_Coverage, 977,
     /* 391426 */     GIR_Done,
     /* 391427 */   // Label 7988: @391427
     /* 391427 */   GIM_Try, /*On fail goto*//*Label 7989*/ GIMT_Encode4(391439), // Rule ID 4903 //
     /* 391432 */     // (AArch64rev64:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (REV64v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 391432 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 391437 */     GIR_RootConstrainSelectedInstOperands,
     /* 391438 */     // GIR_Coverage, 4903,
     /* 391438 */     GIR_Done,
     /* 391439 */   // Label 7989: @391439
     /* 391439 */   GIM_Reject,
     /* 391440 */ // Label 7987: @391440
     /* 391440 */ GIM_Reject,
     /* 391441 */ // Label 7979: @391441
     /* 391441 */ GIM_Try, /*On fail goto*//*Label 7990*/ GIMT_Encode4(391485),
     /* 391446 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 391449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391453 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391457 */   GIM_Try, /*On fail goto*//*Label 7991*/ GIMT_Encode4(391472), // Rule ID 980 //
     /* 391462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391465 */     // (AArch64rev64:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (REV64v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 391465 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 391470 */     GIR_RootConstrainSelectedInstOperands,
     /* 391471 */     // GIR_Coverage, 980,
     /* 391471 */     GIR_Done,
     /* 391472 */   // Label 7991: @391472
     /* 391472 */   GIM_Try, /*On fail goto*//*Label 7992*/ GIMT_Encode4(391484), // Rule ID 4907 //
     /* 391477 */     // (AArch64rev64:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (REV64v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 391477 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 391482 */     GIR_RootConstrainSelectedInstOperands,
     /* 391483 */     // GIR_Coverage, 4907,
     /* 391483 */     GIR_Done,
     /* 391484 */   // Label 7992: @391484
     /* 391484 */   GIM_Reject,
     /* 391485 */ // Label 7990: @391485
     /* 391485 */ GIM_Reject,
     /* 391486 */ // Label 7980: @391486
     /* 391486 */ GIM_Try, /*On fail goto*//*Label 7993*/ GIMT_Encode4(391512), // Rule ID 975 //
     /* 391491 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391494 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 391497 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391501 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391505 */   // (AArch64rev64:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV64v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 391505 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 391510 */   GIR_RootConstrainSelectedInstOperands,
     /* 391511 */   // GIR_Coverage, 975,
     /* 391511 */   GIR_Done,
     /* 391512 */ // Label 7993: @391512
     /* 391512 */ GIM_Reject,
     /* 391513 */ // Label 7981: @391513
     /* 391513 */ GIM_Try, /*On fail goto*//*Label 7994*/ GIMT_Encode4(391557),
     /* 391518 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 391521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391525 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391529 */   GIM_Try, /*On fail goto*//*Label 7995*/ GIMT_Encode4(391544), // Rule ID 978 //
     /* 391534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391537 */     // (AArch64rev64:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV64v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 391537 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 391542 */     GIR_RootConstrainSelectedInstOperands,
     /* 391543 */     // GIR_Coverage, 978,
     /* 391543 */     GIR_Done,
     /* 391544 */   // Label 7995: @391544
     /* 391544 */   GIM_Try, /*On fail goto*//*Label 7996*/ GIMT_Encode4(391556), // Rule ID 4905 //
     /* 391549 */     // (AArch64rev64:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (REV64v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 391549 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 391554 */     GIR_RootConstrainSelectedInstOperands,
     /* 391555 */     // GIR_Coverage, 4905,
     /* 391555 */     GIR_Done,
     /* 391556 */   // Label 7996: @391556
     /* 391556 */   GIM_Reject,
     /* 391557 */ // Label 7994: @391557
     /* 391557 */ GIM_Reject,
     /* 391558 */ // Label 7982: @391558
     /* 391558 */ GIM_Try, /*On fail goto*//*Label 7997*/ GIMT_Encode4(391584), // Rule ID 976 //
     /* 391563 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391566 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 391569 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391573 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391577 */   // (AArch64rev64:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV64v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 391577 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 391582 */   GIR_RootConstrainSelectedInstOperands,
     /* 391583 */   // GIR_Coverage, 976,
     /* 391583 */   GIR_Done,
     /* 391584 */ // Label 7997: @391584
     /* 391584 */ GIM_Reject,
     /* 391585 */ // Label 7983: @391585
     /* 391585 */ GIM_Reject,
     /* 391586 */ // Label 136: @391586
     /* 391586 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8004*/ GIMT_Encode4(391791),
     /* 391597 */ /*GILLT_s64*//*Label 7998*/ GIMT_Encode4(391629), GIMT_Encode4(0),
     /* 391605 */ /*GILLT_v2s32*//*Label 7999*/ GIMT_Encode4(391656),
     /* 391609 */ /*GILLT_v2s64*//*Label 8000*/ GIMT_Encode4(391683),
     /* 391613 */ /*GILLT_v4s16*//*Label 8001*/ GIMT_Encode4(391710),
     /* 391617 */ /*GILLT_v4s32*//*Label 8002*/ GIMT_Encode4(391737), GIMT_Encode4(0),
     /* 391625 */ /*GILLT_v8s16*//*Label 8003*/ GIMT_Encode4(391764),
     /* 391629 */ // Label 7998: @391629
     /* 391629 */ GIM_Try, /*On fail goto*//*Label 8005*/ GIMT_Encode4(391655), // Rule ID 1001 //
     /* 391634 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391637 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 391640 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391644 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391648 */   // (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)  =>  (SADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 391648 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
     /* 391653 */   GIR_RootConstrainSelectedInstOperands,
     /* 391654 */   // GIR_Coverage, 1001,
     /* 391654 */   GIR_Done,
     /* 391655 */ // Label 8005: @391655
     /* 391655 */ GIM_Reject,
     /* 391656 */ // Label 7999: @391656
     /* 391656 */ GIM_Try, /*On fail goto*//*Label 8006*/ GIMT_Encode4(391682), // Rule ID 997 //
     /* 391661 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391664 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 391667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391671 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391675 */   // (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 391675 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i16_v2i32),
     /* 391680 */   GIR_RootConstrainSelectedInstOperands,
     /* 391681 */   // GIR_Coverage, 997,
     /* 391681 */   GIR_Done,
     /* 391682 */ // Label 8006: @391682
     /* 391682 */ GIM_Reject,
     /* 391683 */ // Label 8000: @391683
     /* 391683 */ GIM_Try, /*On fail goto*//*Label 8007*/ GIMT_Encode4(391709), // Rule ID 1003 //
     /* 391688 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 391694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391698 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391702 */   // (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 391702 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i32_v2i64),
     /* 391707 */   GIR_RootConstrainSelectedInstOperands,
     /* 391708 */   // GIR_Coverage, 1003,
     /* 391708 */   GIR_Done,
     /* 391709 */ // Label 8007: @391709
     /* 391709 */ GIM_Reject,
     /* 391710 */ // Label 8001: @391710
     /* 391710 */ GIM_Try, /*On fail goto*//*Label 8008*/ GIMT_Encode4(391736), // Rule ID 993 //
     /* 391715 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391718 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 391721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391725 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391729 */   // (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)  =>  (SADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 391729 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i8_v4i16),
     /* 391734 */   GIR_RootConstrainSelectedInstOperands,
     /* 391735 */   // GIR_Coverage, 993,
     /* 391735 */   GIR_Done,
     /* 391736 */ // Label 8008: @391736
     /* 391736 */ GIM_Reject,
     /* 391737 */ // Label 8002: @391737
     /* 391737 */ GIM_Try, /*On fail goto*//*Label 8009*/ GIMT_Encode4(391763), // Rule ID 999 //
     /* 391742 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 391748 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391752 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391756 */   // (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 391756 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i16_v4i32),
     /* 391761 */   GIR_RootConstrainSelectedInstOperands,
     /* 391762 */   // GIR_Coverage, 999,
     /* 391762 */   GIR_Done,
     /* 391763 */ // Label 8009: @391763
     /* 391763 */ GIM_Reject,
     /* 391764 */ // Label 8003: @391764
     /* 391764 */ GIM_Try, /*On fail goto*//*Label 8010*/ GIMT_Encode4(391790), // Rule ID 995 //
     /* 391769 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391772 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 391775 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391779 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391783 */   // (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)  =>  (SADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 391783 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv16i8_v8i16),
     /* 391788 */   GIR_RootConstrainSelectedInstOperands,
     /* 391789 */   // GIR_Coverage, 995,
     /* 391789 */   GIR_Done,
     /* 391790 */ // Label 8010: @391790
     /* 391790 */ GIM_Reject,
     /* 391791 */ // Label 8004: @391791
     /* 391791 */ GIM_Reject,
     /* 391792 */ // Label 137: @391792
     /* 391792 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(9), /*)*//*default:*//*Label 8013*/ GIMT_Encode4(392190),
     /* 391803 */ /*GILLT_v2s64*//*Label 8011*/ GIMT_Encode4(391815), GIMT_Encode4(0),
     /* 391811 */ /*GILLT_v4s32*//*Label 8012*/ GIMT_Encode4(391953),
     /* 391815 */ // Label 8011: @391815
     /* 391815 */ GIM_Try, /*On fail goto*//*Label 8014*/ GIMT_Encode4(391874), // Rule ID 5786 //
     /* 391820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 391823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391827 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391831 */   // (AArch64saddlv:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /* 391831 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 391834 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
     /* 391838 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391843 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 391847 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 391849 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 391852 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391854 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391857 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391860 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 391863 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391868 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391873 */   // GIR_Coverage, 5786,
     /* 391873 */   GIR_EraseRootFromParent_Done,
     /* 391874 */ // Label 8014: @391874
     /* 391874 */ GIM_Try, /*On fail goto*//*Label 8015*/ GIMT_Encode4(391952), // Rule ID 5908 //
     /* 391879 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 391882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391886 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391890 */   // (AArch64saddlv:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (SADDLPv2i32_v1i64:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
     /* 391890 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 391893 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
     /* 391897 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391902 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 391906 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 391908 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 391911 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 391915 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391920 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 391922 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 391925 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391927 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391930 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 391933 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 391936 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391941 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391946 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391951 */   // GIR_Coverage, 5908,
     /* 391951 */   GIR_EraseRootFromParent_Done,
     /* 391952 */ // Label 8015: @391952
     /* 391952 */ GIM_Reject,
     /* 391953 */ // Label 8012: @391953
     /* 391953 */ GIM_Try, /*On fail goto*//*Label 8016*/ GIMT_Encode4(392012), // Rule ID 5782 //
     /* 391958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 391961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391965 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391969 */   // (AArch64saddlv:{ *:[v4i32] } V64:{ *:[v8i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn), hsub:{ *:[i32] })
     /* 391969 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 391972 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
     /* 391976 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391981 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 391985 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 391987 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 391990 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391992 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391995 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391998 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 392001 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392006 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392011 */   // GIR_Coverage, 5782,
     /* 392011 */   GIR_EraseRootFromParent_Done,
     /* 392012 */ // Label 8016: @392012
     /* 392012 */ GIM_Try, /*On fail goto*//*Label 8017*/ GIMT_Encode4(392071), // Rule ID 5783 //
     /* 392017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 392020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392024 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392028 */   // (AArch64saddlv:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn), ssub:{ *:[i32] })
     /* 392028 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 392031 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
     /* 392035 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392040 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 392044 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 392046 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 392049 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392051 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392054 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 392057 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 392060 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392065 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 392070 */   // GIR_Coverage, 5783,
     /* 392070 */   GIR_EraseRootFromParent_Done,
     /* 392071 */ // Label 8017: @392071
     /* 392071 */ GIM_Try, /*On fail goto*//*Label 8018*/ GIMT_Encode4(392130), // Rule ID 5784 //
     /* 392076 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 392079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392083 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392087 */   // (AArch64saddlv:{ *:[v4i32] } V128:{ *:[v16i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn), hsub:{ *:[i32] })
     /* 392087 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 392090 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
     /* 392094 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392099 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 392103 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 392105 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 392108 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392110 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392113 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 392116 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 392119 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392124 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392129 */   // GIR_Coverage, 5784,
     /* 392129 */   GIR_EraseRootFromParent_Done,
     /* 392130 */ // Label 8018: @392130
     /* 392130 */ GIM_Try, /*On fail goto*//*Label 8019*/ GIMT_Encode4(392189), // Rule ID 5785 //
     /* 392135 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 392138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392142 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392146 */   // (AArch64saddlv:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn), ssub:{ *:[i32] })
     /* 392146 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 392149 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
     /* 392153 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392158 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 392162 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 392164 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 392167 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392169 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392172 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 392175 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 392178 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392183 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 392188 */   // GIR_Coverage, 5785,
     /* 392188 */   GIR_EraseRootFromParent_Done,
     /* 392189 */ // Label 8019: @392189
     /* 392189 */ GIM_Reject,
     /* 392190 */ // Label 8013: @392190
     /* 392190 */ GIM_Reject,
     /* 392191 */ // Label 138: @392191
     /* 392191 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(20), /*)*//*default:*//*Label 8024*/ GIMT_Encode4(392560),
     /* 392202 */ /*GILLT_v2s32*//*Label 8020*/ GIMT_Encode4(392262), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 392214 */ /*GILLT_v4s32*//*Label 8021*/ GIMT_Encode4(392382), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 392246 */ /*GILLT_nxv2s64*//*Label 8022*/ GIMT_Encode4(392502), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 392258 */ /*GILLT_nxv4s32*//*Label 8023*/ GIMT_Encode4(392531),
     /* 392262 */ // Label 8020: @392262
     /* 392262 */ GIM_Try, /*On fail goto*//*Label 8025*/ GIMT_Encode4(392381),
     /* 392267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 392270 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 392273 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 392276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392280 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392284 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392288 */   GIM_Try, /*On fail goto*//*Label 8026*/ GIMT_Encode4(392361), // Rule ID 26 //
     /* 392293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 392296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 392300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 392304 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 392308 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 392312 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 392316 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392320 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 392324 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392329 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 392333 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 392337 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 392341 */     // MIs[3] Operand 1
     /* 392341 */     // No operand predicates
     /* 392341 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 392343 */     // (AArch64sdot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, (bitconvert:{ *:[v8i8] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SDOTlanev8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 392343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOTlanev8i8),
     /* 392346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392348 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 392350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 392352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 392356 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 392359 */     GIR_RootConstrainSelectedInstOperands,
     /* 392360 */     // GIR_Coverage, 26,
     /* 392360 */     GIR_EraseRootFromParent_Done,
     /* 392361 */   // Label 8026: @392361
     /* 392361 */   GIM_Try, /*On fail goto*//*Label 8027*/ GIMT_Encode4(392380), // Rule ID 22 //
     /* 392366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 392369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392373 */     // (AArch64sdot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SDOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 392373 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOTv8i8),
     /* 392378 */     GIR_RootConstrainSelectedInstOperands,
     /* 392379 */     // GIR_Coverage, 22,
     /* 392379 */     GIR_Done,
     /* 392380 */   // Label 8027: @392380
     /* 392380 */   GIM_Reject,
     /* 392381 */ // Label 8025: @392381
     /* 392381 */ GIM_Reject,
     /* 392382 */ // Label 8021: @392382
     /* 392382 */ GIM_Try, /*On fail goto*//*Label 8028*/ GIMT_Encode4(392501),
     /* 392387 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392390 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 392393 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 392396 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392400 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392404 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392408 */   GIM_Try, /*On fail goto*//*Label 8029*/ GIMT_Encode4(392481), // Rule ID 27 //
     /* 392413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 392416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 392420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 392424 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 392432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 392436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392440 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 392444 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392449 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 392453 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 392457 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 392461 */     // MIs[3] Operand 1
     /* 392461 */     // No operand predicates
     /* 392461 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 392463 */     // (AArch64sdot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, (bitconvert:{ *:[v16i8] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SDOTlanev16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 392463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOTlanev16i8),
     /* 392466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392468 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 392470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 392472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 392476 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 392479 */     GIR_RootConstrainSelectedInstOperands,
     /* 392480 */     // GIR_Coverage, 27,
     /* 392480 */     GIR_EraseRootFromParent_Done,
     /* 392481 */   // Label 8029: @392481
     /* 392481 */   GIM_Try, /*On fail goto*//*Label 8030*/ GIMT_Encode4(392500), // Rule ID 23 //
     /* 392486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 392489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392493 */     // (AArch64sdot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SDOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 392493 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOTv16i8),
     /* 392498 */     GIR_RootConstrainSelectedInstOperands,
     /* 392499 */     // GIR_Coverage, 23,
     /* 392499 */     GIR_Done,
     /* 392500 */   // Label 8030: @392500
     /* 392500 */   GIM_Reject,
     /* 392501 */ // Label 8028: @392501
     /* 392501 */ GIM_Reject,
     /* 392502 */ // Label 8022: @392502
     /* 392502 */ GIM_Try, /*On fail goto*//*Label 8031*/ GIMT_Encode4(392530), // Rule ID 2972 //
     /* 392507 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 392510 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 392513 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 392516 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 392519 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 392523 */   // (AArch64sdot:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SDOT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 392523 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_D),
     /* 392528 */   GIR_RootConstrainSelectedInstOperands,
     /* 392529 */   // GIR_Coverage, 2972,
     /* 392529 */   GIR_Done,
     /* 392530 */ // Label 8031: @392530
     /* 392530 */ GIM_Reject,
     /* 392531 */ // Label 8023: @392531
     /* 392531 */ GIM_Try, /*On fail goto*//*Label 8032*/ GIMT_Encode4(392559), // Rule ID 2971 //
     /* 392536 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 392539 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 392542 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 392545 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 392548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 392552 */   // (AArch64sdot:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SDOT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 392552 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_S),
     /* 392557 */   GIR_RootConstrainSelectedInstOperands,
     /* 392558 */   // GIR_Coverage, 2971,
     /* 392558 */   GIR_Done,
     /* 392559 */ // Label 8032: @392559
     /* 392559 */ GIM_Reject,
     /* 392560 */ // Label 8024: @392560
     /* 392560 */ GIM_Reject,
     /* 392561 */ // Label 139: @392561
     /* 392561 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8036*/ GIMT_Encode4(392677),
     /* 392572 */ /*GILLT_s16*//*Label 8033*/ GIMT_Encode4(392584),
     /* 392576 */ /*GILLT_s32*//*Label 8034*/ GIMT_Encode4(392615),
     /* 392580 */ /*GILLT_s64*//*Label 8035*/ GIMT_Encode4(392646),
     /* 392584 */ // Label 8033: @392584
     /* 392584 */ GIM_Try, /*On fail goto*//*Label 8037*/ GIMT_Encode4(392614), // Rule ID 1651 //
     /* 392589 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 392592 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 392595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392599 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392603 */   // (AArch64sitof:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (SCVTFv1i16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 392603 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
     /* 392608 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392612 */   GIR_RootConstrainSelectedInstOperands,
     /* 392613 */   // GIR_Coverage, 1651,
     /* 392613 */   GIR_Done,
     /* 392614 */ // Label 8037: @392614
     /* 392614 */ GIM_Reject,
     /* 392615 */ // Label 8034: @392615
     /* 392615 */ GIM_Try, /*On fail goto*//*Label 8038*/ GIMT_Encode4(392645), // Rule ID 1650 //
     /* 392620 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 392623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 392626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 392630 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 392634 */   // (AArch64sitof:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (SCVTFv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 392634 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 392639 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392643 */   GIR_RootConstrainSelectedInstOperands,
     /* 392644 */   // GIR_Coverage, 1650,
     /* 392644 */   GIR_Done,
     /* 392645 */ // Label 8038: @392645
     /* 392645 */ GIM_Reject,
     /* 392646 */ // Label 8035: @392646
     /* 392646 */ GIM_Try, /*On fail goto*//*Label 8039*/ GIMT_Encode4(392676), // Rule ID 1649 //
     /* 392651 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 392654 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 392657 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392661 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392665 */   // (AArch64sitof:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (SCVTFv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 392665 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 392670 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392674 */   GIR_RootConstrainSelectedInstOperands,
     /* 392675 */   // GIR_Coverage, 1649,
     /* 392675 */   GIR_Done,
     /* 392676 */ // Label 8039: @392676
     /* 392676 */ GIM_Reject,
     /* 392677 */ // Label 8036: @392677
     /* 392677 */ GIM_Reject,
     /* 392678 */ // Label 140: @392678
     /* 392678 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(11), /*)*//*default:*//*Label 8043*/ GIMT_Encode4(393910),
     /* 392689 */ /*GILLT_v2s64*//*Label 8040*/ GIMT_Encode4(392709), GIMT_Encode4(0),
     /* 392697 */ /*GILLT_v4s32*//*Label 8041*/ GIMT_Encode4(393270), GIMT_Encode4(0),
     /* 392705 */ /*GILLT_v8s16*//*Label 8042*/ GIMT_Encode4(393831),
     /* 392709 */ // Label 8040: @392709
     /* 392709 */ GIM_Try, /*On fail goto*//*Label 8044*/ GIMT_Encode4(393269),
     /* 392714 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 392717 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 392720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392724 */   GIM_Try, /*On fail goto*//*Label 8045*/ GIMT_Encode4(392816), // Rule ID 2047 //
     /* 392729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 392736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 392740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392744 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 392748 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 392752 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392756 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 392760 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392765 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 392769 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 392773 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 392777 */     // MIs[3] Operand 1
     /* 392777 */     // No operand predicates
     /* 392777 */     // MIs[1] Operand 2
     /* 392777 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 392788 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 392790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 392797 */     // (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (SMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 392797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_indexed),
     /* 392800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 392802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 392807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 392811 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 392814 */     GIR_RootConstrainSelectedInstOperands,
     /* 392815 */     // GIR_Coverage, 2047,
     /* 392815 */     GIR_EraseRootFromParent_Done,
     /* 392816 */   // Label 8045: @392816
     /* 392816 */   GIM_Try, /*On fail goto*//*Label 8046*/ GIMT_Encode4(392908), // Rule ID 13217 //
     /* 392821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 392832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392836 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 392840 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 392844 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392848 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 392852 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392857 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 392861 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 392865 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 392869 */     // MIs[3] Operand 1
     /* 392869 */     // No operand predicates
     /* 392869 */     // MIs[1] Operand 2
     /* 392869 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 392880 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 392882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 392889 */     // (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (SMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 392889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_indexed),
     /* 392892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 392894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 392899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 392903 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 392906 */     GIR_RootConstrainSelectedInstOperands,
     /* 392907 */     // GIR_Coverage, 13217,
     /* 392907 */     GIR_EraseRootFromParent_Done,
     /* 392908 */   // Label 8046: @392908
     /* 392908 */   GIM_Try, /*On fail goto*//*Label 8047*/ GIMT_Encode4(392994), // Rule ID 13215 //
     /* 392913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 392924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392928 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 392932 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 392936 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392940 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 392944 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392949 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 392953 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 392957 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 392961 */     // MIs[3] Operand 1
     /* 392961 */     // No operand predicates
     /* 392961 */     // MIs[1] Operand 2
     /* 392961 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 392972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392976 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 392978 */     // (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 392978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 392981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 392983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 392985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 392989 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 392992 */     GIR_RootConstrainSelectedInstOperands,
     /* 392993 */     // GIR_Coverage, 13215,
     /* 392993 */     GIR_EraseRootFromParent_Done,
     /* 392994 */   // Label 8047: @392994
     /* 392994 */   GIM_Try, /*On fail goto*//*Label 8048*/ GIMT_Encode4(393080), // Rule ID 2045 //
     /* 392999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393002 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 393010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 393014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393018 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 393022 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 393026 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393030 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 393034 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393039 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 393043 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 393047 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 393051 */     // MIs[3] Operand 1
     /* 393051 */     // No operand predicates
     /* 393051 */     // MIs[1] Operand 2
     /* 393051 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 393062 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 393064 */     // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 393064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 393067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393069 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 393071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 393075 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 393078 */     GIR_RootConstrainSelectedInstOperands,
     /* 393079 */     // GIR_Coverage, 2045,
     /* 393079 */     GIR_EraseRootFromParent_Done,
     /* 393080 */   // Label 8048: @393080
     /* 393080 */   GIM_Try, /*On fail goto*//*Label 8049*/ GIMT_Encode4(393119), // Rule ID 1734 //
     /* 393085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 393095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 393102 */     // (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (SMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 393102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_v2i64),
     /* 393105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 393112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 393117 */     GIR_RootConstrainSelectedInstOperands,
     /* 393118 */     // GIR_Coverage, 1734,
     /* 393118 */     GIR_EraseRootFromParent_Done,
     /* 393119 */   // Label 8049: @393119
     /* 393119 */   GIM_Try, /*On fail goto*//*Label 8050*/ GIMT_Encode4(393182), // Rule ID 13216 //
     /* 393124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 393135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393139 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 393143 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393148 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 393152 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 393156 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 393160 */     // MIs[2] Operand 1
     /* 393160 */     // No operand predicates
     /* 393160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393164 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 393166 */     // (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 393166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 393169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 393173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 393177 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 393180 */     GIR_RootConstrainSelectedInstOperands,
     /* 393181 */     // GIR_Coverage, 13216,
     /* 393181 */     GIR_EraseRootFromParent_Done,
     /* 393182 */   // Label 8050: @393182
     /* 393182 */   GIM_Try, /*On fail goto*//*Label 8051*/ GIMT_Encode4(393245), // Rule ID 2046 //
     /* 393187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 393198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 393202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393206 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 393210 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 393219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 393223 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 393227 */     // MIs[2] Operand 1
     /* 393227 */     // No operand predicates
     /* 393227 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 393229 */     // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 393229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 393232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393234 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 393236 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 393240 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 393243 */     GIR_RootConstrainSelectedInstOperands,
     /* 393244 */     // GIR_Coverage, 2046,
     /* 393244 */     GIR_EraseRootFromParent_Done,
     /* 393245 */   // Label 8051: @393245
     /* 393245 */   GIM_Try, /*On fail goto*//*Label 8052*/ GIMT_Encode4(393268), // Rule ID 1733 //
     /* 393250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393261 */     // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 393261 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_v2i64),
     /* 393266 */     GIR_RootConstrainSelectedInstOperands,
     /* 393267 */     // GIR_Coverage, 1733,
     /* 393267 */     GIR_Done,
     /* 393268 */   // Label 8052: @393268
     /* 393268 */   GIM_Reject,
     /* 393269 */ // Label 8044: @393269
     /* 393269 */ GIM_Reject,
     /* 393270 */ // Label 8041: @393270
     /* 393270 */ GIM_Try, /*On fail goto*//*Label 8053*/ GIMT_Encode4(393830),
     /* 393275 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 393278 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 393281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393285 */   GIM_Try, /*On fail goto*//*Label 8054*/ GIMT_Encode4(393377), // Rule ID 2044 //
     /* 393290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 393297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 393301 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393305 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 393309 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 393313 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393317 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 393321 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 393326 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 393330 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 393334 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 393338 */     // MIs[3] Operand 1
     /* 393338 */     // No operand predicates
     /* 393338 */     // MIs[1] Operand 2
     /* 393338 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 393349 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 393351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 393358 */     // (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (SMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 393358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_indexed),
     /* 393361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 393368 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 393372 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 393375 */     GIR_RootConstrainSelectedInstOperands,
     /* 393376 */     // GIR_Coverage, 2044,
     /* 393376 */     GIR_EraseRootFromParent_Done,
     /* 393377 */   // Label 8054: @393377
     /* 393377 */   GIM_Try, /*On fail goto*//*Label 8055*/ GIMT_Encode4(393469), // Rule ID 13214 //
     /* 393382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 393393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393397 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 393401 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 393405 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393409 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 393413 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 393418 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 393422 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 393426 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 393430 */     // MIs[3] Operand 1
     /* 393430 */     // No operand predicates
     /* 393430 */     // MIs[1] Operand 2
     /* 393430 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 393441 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 393443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 393450 */     // (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (SMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 393450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_indexed),
     /* 393453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 393460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 393464 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 393467 */     GIR_RootConstrainSelectedInstOperands,
     /* 393468 */     // GIR_Coverage, 13214,
     /* 393468 */     GIR_EraseRootFromParent_Done,
     /* 393469 */   // Label 8055: @393469
     /* 393469 */   GIM_Try, /*On fail goto*//*Label 8056*/ GIMT_Encode4(393555), // Rule ID 13212 //
     /* 393474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 393485 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393489 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 393493 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 393497 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393501 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 393505 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 393510 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 393514 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 393518 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 393522 */     // MIs[3] Operand 1
     /* 393522 */     // No operand predicates
     /* 393522 */     // MIs[1] Operand 2
     /* 393522 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 393533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393537 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 393539 */     // (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 393539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 393542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 393546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 393550 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 393553 */     GIR_RootConstrainSelectedInstOperands,
     /* 393554 */     // GIR_Coverage, 13212,
     /* 393554 */     GIR_EraseRootFromParent_Done,
     /* 393555 */   // Label 8056: @393555
     /* 393555 */   GIM_Try, /*On fail goto*//*Label 8057*/ GIMT_Encode4(393641), // Rule ID 2042 //
     /* 393560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393563 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 393571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 393575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393579 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 393583 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 393587 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393591 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 393595 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 393600 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 393604 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 393608 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 393612 */     // MIs[3] Operand 1
     /* 393612 */     // No operand predicates
     /* 393612 */     // MIs[1] Operand 2
     /* 393612 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 393623 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 393625 */     // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 393625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 393628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393630 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 393632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 393636 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 393639 */     GIR_RootConstrainSelectedInstOperands,
     /* 393640 */     // GIR_Coverage, 2042,
     /* 393640 */     GIR_EraseRootFromParent_Done,
     /* 393641 */   // Label 8057: @393641
     /* 393641 */   GIM_Try, /*On fail goto*//*Label 8058*/ GIMT_Encode4(393680), // Rule ID 1732 //
     /* 393646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 393656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 393663 */     // (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (SMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 393663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_v4i32),
     /* 393666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 393673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 393678 */     GIR_RootConstrainSelectedInstOperands,
     /* 393679 */     // GIR_Coverage, 1732,
     /* 393679 */     GIR_EraseRootFromParent_Done,
     /* 393680 */   // Label 8058: @393680
     /* 393680 */   GIM_Try, /*On fail goto*//*Label 8059*/ GIMT_Encode4(393743), // Rule ID 13213 //
     /* 393685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 393696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393700 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 393704 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 393709 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 393713 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 393717 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 393721 */     // MIs[2] Operand 1
     /* 393721 */     // No operand predicates
     /* 393721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393725 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 393727 */     // (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 393727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 393730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 393734 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 393738 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 393741 */     GIR_RootConstrainSelectedInstOperands,
     /* 393742 */     // GIR_Coverage, 13213,
     /* 393742 */     GIR_EraseRootFromParent_Done,
     /* 393743 */   // Label 8059: @393743
     /* 393743 */   GIM_Try, /*On fail goto*//*Label 8060*/ GIMT_Encode4(393806), // Rule ID 2043 //
     /* 393748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393751 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 393759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 393763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393767 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 393771 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 393776 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 393780 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 393784 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 393788 */     // MIs[2] Operand 1
     /* 393788 */     // No operand predicates
     /* 393788 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 393790 */     // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 393790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 393793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393795 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 393797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 393801 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 393804 */     GIR_RootConstrainSelectedInstOperands,
     /* 393805 */     // GIR_Coverage, 2043,
     /* 393805 */     GIR_EraseRootFromParent_Done,
     /* 393806 */   // Label 8060: @393806
     /* 393806 */   GIM_Try, /*On fail goto*//*Label 8061*/ GIMT_Encode4(393829), // Rule ID 1731 //
     /* 393811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393814 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393822 */     // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 393822 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_v4i32),
     /* 393827 */     GIR_RootConstrainSelectedInstOperands,
     /* 393828 */     // GIR_Coverage, 1731,
     /* 393828 */     GIR_Done,
     /* 393829 */   // Label 8061: @393829
     /* 393829 */   GIM_Reject,
     /* 393830 */ // Label 8053: @393830
     /* 393830 */ GIM_Reject,
     /* 393831 */ // Label 8042: @393831
     /* 393831 */ GIM_Try, /*On fail goto*//*Label 8062*/ GIMT_Encode4(393909),
     /* 393836 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 393839 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 393842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393846 */   GIM_Try, /*On fail goto*//*Label 8063*/ GIMT_Encode4(393885), // Rule ID 1730 //
     /* 393851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 393861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 393868 */     // (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (SMULLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 393868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv16i8_v8i16),
     /* 393871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 393878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 393883 */     GIR_RootConstrainSelectedInstOperands,
     /* 393884 */     // GIR_Coverage, 1730,
     /* 393884 */     GIR_EraseRootFromParent_Done,
     /* 393885 */   // Label 8063: @393885
     /* 393885 */   GIM_Try, /*On fail goto*//*Label 8064*/ GIMT_Encode4(393908), // Rule ID 1729 //
     /* 393890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393893 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393901 */     // (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMULLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 393901 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i8_v8i16),
     /* 393906 */     GIR_RootConstrainSelectedInstOperands,
     /* 393907 */     // GIR_Coverage, 1729,
     /* 393907 */     GIR_Done,
     /* 393908 */   // Label 8064: @393908
     /* 393908 */   GIM_Reject,
     /* 393909 */ // Label 8062: @393909
     /* 393909 */ GIM_Reject,
     /* 393910 */ // Label 8043: @393910
     /* 393910 */ GIM_Reject,
     /* 393911 */ // Label 141: @393911
     /* 393911 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8083*/ GIMT_Encode4(394690),
     /* 393922 */ /*GILLT_v2s32*//*Label 8065*/ GIMT_Encode4(393998),
     /* 393926 */ /*GILLT_v2s64*//*Label 8066*/ GIMT_Encode4(394053),
     /* 393930 */ /*GILLT_v4s16*//*Label 8067*/ GIMT_Encode4(394108),
     /* 393934 */ /*GILLT_v4s32*//*Label 8068*/ GIMT_Encode4(394163),
     /* 393938 */ /*GILLT_v8s8*//*Label 8069*/ GIMT_Encode4(394218),
     /* 393942 */ /*GILLT_v8s16*//*Label 8070*/ GIMT_Encode4(394252),
     /* 393946 */ /*GILLT_v16s8*//*Label 8071*/ GIMT_Encode4(394307), GIMT_Encode4(0),
     /* 393954 */ /*GILLT_nxv2s1*//*Label 8072*/ GIMT_Encode4(394341),
     /* 393958 */ /*GILLT_nxv2s16*//*Label 8073*/ GIMT_Encode4(394367),
     /* 393962 */ /*GILLT_nxv2s32*//*Label 8074*/ GIMT_Encode4(394393),
     /* 393966 */ /*GILLT_nxv2s64*//*Label 8075*/ GIMT_Encode4(394419),
     /* 393970 */ /*GILLT_nxv4s1*//*Label 8076*/ GIMT_Encode4(394466),
     /* 393974 */ /*GILLT_nxv4s16*//*Label 8077*/ GIMT_Encode4(394492),
     /* 393978 */ /*GILLT_nxv4s32*//*Label 8078*/ GIMT_Encode4(394518),
     /* 393982 */ /*GILLT_nxv8s1*//*Label 8079*/ GIMT_Encode4(394565),
     /* 393986 */ /*GILLT_nxv8s16*//*Label 8080*/ GIMT_Encode4(394591),
     /* 393990 */ /*GILLT_nxv16s1*//*Label 8081*/ GIMT_Encode4(394638),
     /* 393994 */ /*GILLT_nxv16s8*//*Label 8082*/ GIMT_Encode4(394664),
     /* 393998 */ // Label 8065: @393998
     /* 393998 */ GIM_Try, /*On fail goto*//*Label 8084*/ GIMT_Encode4(394052),
     /* 394003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 394006 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 394009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394013 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394017 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394021 */   GIM_Try, /*On fail goto*//*Label 8085*/ GIMT_Encode4(394036), // Rule ID 1867 //
     /* 394026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394029 */     // (AArch64trn1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (TRN1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 394029 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i32),
     /* 394034 */     GIR_RootConstrainSelectedInstOperands,
     /* 394035 */     // GIR_Coverage, 1867,
     /* 394035 */     GIR_Done,
     /* 394036 */   // Label 8085: @394036
     /* 394036 */   GIM_Try, /*On fail goto*//*Label 8086*/ GIMT_Encode4(394051), // Rule ID 2496 //
     /* 394041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394044 */     // (AArch64trn1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (TRN1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 394044 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i32),
     /* 394049 */     GIR_RootConstrainSelectedInstOperands,
     /* 394050 */     // GIR_Coverage, 2496,
     /* 394050 */     GIR_Done,
     /* 394051 */   // Label 8086: @394051
     /* 394051 */   GIM_Reject,
     /* 394052 */ // Label 8084: @394052
     /* 394052 */ GIM_Reject,
     /* 394053 */ // Label 8066: @394053
     /* 394053 */ GIM_Try, /*On fail goto*//*Label 8087*/ GIMT_Encode4(394107),
     /* 394058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 394061 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 394064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394068 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394072 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394076 */   GIM_Try, /*On fail goto*//*Label 8088*/ GIMT_Encode4(394091), // Rule ID 1869 //
     /* 394081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394084 */     // (AArch64trn1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (TRN1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 394084 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i64),
     /* 394089 */     GIR_RootConstrainSelectedInstOperands,
     /* 394090 */     // GIR_Coverage, 1869,
     /* 394090 */     GIR_Done,
     /* 394091 */   // Label 8088: @394091
     /* 394091 */   GIM_Try, /*On fail goto*//*Label 8089*/ GIMT_Encode4(394106), // Rule ID 2498 //
     /* 394096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394099 */     // (AArch64trn1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (TRN1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 394099 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i64),
     /* 394104 */     GIR_RootConstrainSelectedInstOperands,
     /* 394105 */     // GIR_Coverage, 2498,
     /* 394105 */     GIR_Done,
     /* 394106 */   // Label 8089: @394106
     /* 394106 */   GIM_Reject,
     /* 394107 */ // Label 8087: @394107
     /* 394107 */ GIM_Reject,
     /* 394108 */ // Label 8067: @394108
     /* 394108 */ GIM_Try, /*On fail goto*//*Label 8090*/ GIMT_Encode4(394162),
     /* 394113 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 394116 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 394119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394123 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394127 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394131 */   GIM_Try, /*On fail goto*//*Label 8091*/ GIMT_Encode4(394146), // Rule ID 1865 //
     /* 394136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394139 */     // (AArch64trn1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (TRN1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 394139 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i16),
     /* 394144 */     GIR_RootConstrainSelectedInstOperands,
     /* 394145 */     // GIR_Coverage, 1865,
     /* 394145 */     GIR_Done,
     /* 394146 */   // Label 8091: @394146
     /* 394146 */   GIM_Try, /*On fail goto*//*Label 8092*/ GIMT_Encode4(394161), // Rule ID 2494 //
     /* 394151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394154 */     // (AArch64trn1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (TRN1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 394154 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i16),
     /* 394159 */     GIR_RootConstrainSelectedInstOperands,
     /* 394160 */     // GIR_Coverage, 2494,
     /* 394160 */     GIR_Done,
     /* 394161 */   // Label 8092: @394161
     /* 394161 */   GIM_Reject,
     /* 394162 */ // Label 8090: @394162
     /* 394162 */ GIM_Reject,
     /* 394163 */ // Label 8068: @394163
     /* 394163 */ GIM_Try, /*On fail goto*//*Label 8093*/ GIMT_Encode4(394217),
     /* 394168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394171 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 394174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394178 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394182 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394186 */   GIM_Try, /*On fail goto*//*Label 8094*/ GIMT_Encode4(394201), // Rule ID 1868 //
     /* 394191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394194 */     // (AArch64trn1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (TRN1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 394194 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i32),
     /* 394199 */     GIR_RootConstrainSelectedInstOperands,
     /* 394200 */     // GIR_Coverage, 1868,
     /* 394200 */     GIR_Done,
     /* 394201 */   // Label 8094: @394201
     /* 394201 */   GIM_Try, /*On fail goto*//*Label 8095*/ GIMT_Encode4(394216), // Rule ID 2497 //
     /* 394206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394209 */     // (AArch64trn1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (TRN1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 394209 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i32),
     /* 394214 */     GIR_RootConstrainSelectedInstOperands,
     /* 394215 */     // GIR_Coverage, 2497,
     /* 394215 */     GIR_Done,
     /* 394216 */   // Label 8095: @394216
     /* 394216 */   GIM_Reject,
     /* 394217 */ // Label 8093: @394217
     /* 394217 */ GIM_Reject,
     /* 394218 */ // Label 8069: @394218
     /* 394218 */ GIM_Try, /*On fail goto*//*Label 8096*/ GIMT_Encode4(394251), // Rule ID 1863 //
     /* 394223 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394226 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 394229 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 394232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394236 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394240 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394244 */   // (AArch64trn1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (TRN1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 394244 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i8),
     /* 394249 */   GIR_RootConstrainSelectedInstOperands,
     /* 394250 */   // GIR_Coverage, 1863,
     /* 394250 */   GIR_Done,
     /* 394251 */ // Label 8096: @394251
     /* 394251 */ GIM_Reject,
     /* 394252 */ // Label 8070: @394252
     /* 394252 */ GIM_Try, /*On fail goto*//*Label 8097*/ GIMT_Encode4(394306),
     /* 394257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 394260 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 394263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394267 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394271 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394275 */   GIM_Try, /*On fail goto*//*Label 8098*/ GIMT_Encode4(394290), // Rule ID 1866 //
     /* 394280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394283 */     // (AArch64trn1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (TRN1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 394283 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i16),
     /* 394288 */     GIR_RootConstrainSelectedInstOperands,
     /* 394289 */     // GIR_Coverage, 1866,
     /* 394289 */     GIR_Done,
     /* 394290 */   // Label 8098: @394290
     /* 394290 */   GIM_Try, /*On fail goto*//*Label 8099*/ GIMT_Encode4(394305), // Rule ID 2495 //
     /* 394295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394298 */     // (AArch64trn1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (TRN1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 394298 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i16),
     /* 394303 */     GIR_RootConstrainSelectedInstOperands,
     /* 394304 */     // GIR_Coverage, 2495,
     /* 394304 */     GIR_Done,
     /* 394305 */   // Label 8099: @394305
     /* 394305 */   GIM_Reject,
     /* 394306 */ // Label 8097: @394306
     /* 394306 */ GIM_Reject,
     /* 394307 */ // Label 8071: @394307
     /* 394307 */ GIM_Try, /*On fail goto*//*Label 8100*/ GIMT_Encode4(394340), // Rule ID 1864 //
     /* 394312 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 394318 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 394321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394325 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394329 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394333 */   // (AArch64trn1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (TRN1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 394333 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v16i8),
     /* 394338 */   GIR_RootConstrainSelectedInstOperands,
     /* 394339 */   // GIR_Coverage, 1864,
     /* 394339 */   GIR_Done,
     /* 394340 */ // Label 8100: @394340
     /* 394340 */ GIM_Reject,
     /* 394341 */ // Label 8072: @394341
     /* 394341 */ GIM_Try, /*On fail goto*//*Label 8101*/ GIMT_Encode4(394366), // Rule ID 8813 //
     /* 394346 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 394349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 394352 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 394355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 394359 */   // (AArch64trn1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (TRN1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 394359 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_D),
     /* 394364 */   GIR_RootConstrainSelectedInstOperands,
     /* 394365 */   // GIR_Coverage, 8813,
     /* 394365 */   GIR_Done,
     /* 394366 */ // Label 8101: @394366
     /* 394366 */ GIM_Reject,
     /* 394367 */ // Label 8073: @394367
     /* 394367 */ GIM_Try, /*On fail goto*//*Label 8102*/ GIMT_Encode4(394392), // Rule ID 8789 //
     /* 394372 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 394375 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 394378 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 394381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 394385 */   // (AArch64trn1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 394385 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 394390 */   GIR_RootConstrainSelectedInstOperands,
     /* 394391 */   // GIR_Coverage, 8789,
     /* 394391 */   GIR_Done,
     /* 394392 */ // Label 8102: @394392
     /* 394392 */ GIM_Reject,
     /* 394393 */ // Label 8074: @394393
     /* 394393 */ GIM_Try, /*On fail goto*//*Label 8103*/ GIMT_Encode4(394418), // Rule ID 8790 //
     /* 394398 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 394401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 394404 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 394407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 394411 */   // (AArch64trn1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 394411 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 394416 */   GIR_RootConstrainSelectedInstOperands,
     /* 394417 */   // GIR_Coverage, 8790,
     /* 394417 */   GIR_Done,
     /* 394418 */ // Label 8103: @394418
     /* 394418 */ GIM_Reject,
     /* 394419 */ // Label 8075: @394419
     /* 394419 */ GIM_Try, /*On fail goto*//*Label 8104*/ GIMT_Encode4(394465),
     /* 394424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 394427 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 394430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 394434 */   GIM_Try, /*On fail goto*//*Label 8105*/ GIMT_Encode4(394449), // Rule ID 8785 //
     /* 394439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 394442 */     // (AArch64trn1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 394442 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 394447 */     GIR_RootConstrainSelectedInstOperands,
     /* 394448 */     // GIR_Coverage, 8785,
     /* 394448 */     GIR_Done,
     /* 394449 */   // Label 8105: @394449
     /* 394449 */   GIM_Try, /*On fail goto*//*Label 8106*/ GIMT_Encode4(394464), // Rule ID 8791 //
     /* 394454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 394457 */     // (AArch64trn1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 394457 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 394462 */     GIR_RootConstrainSelectedInstOperands,
     /* 394463 */     // GIR_Coverage, 8791,
     /* 394463 */     GIR_Done,
     /* 394464 */   // Label 8106: @394464
     /* 394464 */   GIM_Reject,
     /* 394465 */ // Label 8104: @394465
     /* 394465 */ GIM_Reject,
     /* 394466 */ // Label 8076: @394466
     /* 394466 */ GIM_Try, /*On fail goto*//*Label 8107*/ GIMT_Encode4(394491), // Rule ID 8812 //
     /* 394471 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 394474 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 394477 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 394480 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 394484 */   // (AArch64trn1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (TRN1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 394484 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_S),
     /* 394489 */   GIR_RootConstrainSelectedInstOperands,
     /* 394490 */   // GIR_Coverage, 8812,
     /* 394490 */   GIR_Done,
     /* 394491 */ // Label 8107: @394491
     /* 394491 */ GIM_Reject,
     /* 394492 */ // Label 8077: @394492
     /* 394492 */ GIM_Try, /*On fail goto*//*Label 8108*/ GIMT_Encode4(394517), // Rule ID 8787 //
     /* 394497 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 394500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 394503 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 394506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 394510 */   // (AArch64trn1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 394510 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
     /* 394515 */   GIR_RootConstrainSelectedInstOperands,
     /* 394516 */   // GIR_Coverage, 8787,
     /* 394516 */   GIR_Done,
     /* 394517 */ // Label 8108: @394517
     /* 394517 */ GIM_Reject,
     /* 394518 */ // Label 8078: @394518
     /* 394518 */ GIM_Try, /*On fail goto*//*Label 8109*/ GIMT_Encode4(394564),
     /* 394523 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 394526 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 394529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 394533 */   GIM_Try, /*On fail goto*//*Label 8110*/ GIMT_Encode4(394548), // Rule ID 8784 //
     /* 394538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 394541 */     // (AArch64trn1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 394541 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
     /* 394546 */     GIR_RootConstrainSelectedInstOperands,
     /* 394547 */     // GIR_Coverage, 8784,
     /* 394547 */     GIR_Done,
     /* 394548 */   // Label 8110: @394548
     /* 394548 */   GIM_Try, /*On fail goto*//*Label 8111*/ GIMT_Encode4(394563), // Rule ID 8788 //
     /* 394553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 394556 */     // (AArch64trn1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 394556 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
     /* 394561 */     GIR_RootConstrainSelectedInstOperands,
     /* 394562 */     // GIR_Coverage, 8788,
     /* 394562 */     GIR_Done,
     /* 394563 */   // Label 8111: @394563
     /* 394563 */   GIM_Reject,
     /* 394564 */ // Label 8109: @394564
     /* 394564 */ GIM_Reject,
     /* 394565 */ // Label 8079: @394565
     /* 394565 */ GIM_Try, /*On fail goto*//*Label 8112*/ GIMT_Encode4(394590), // Rule ID 8811 //
     /* 394570 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 394573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 394576 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 394579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 394583 */   // (AArch64trn1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (TRN1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 394583 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_H),
     /* 394588 */   GIR_RootConstrainSelectedInstOperands,
     /* 394589 */   // GIR_Coverage, 8811,
     /* 394589 */   GIR_Done,
     /* 394590 */ // Label 8112: @394590
     /* 394590 */ GIM_Reject,
     /* 394591 */ // Label 8080: @394591
     /* 394591 */ GIM_Try, /*On fail goto*//*Label 8113*/ GIMT_Encode4(394637),
     /* 394596 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 394599 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 394602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 394606 */   GIM_Try, /*On fail goto*//*Label 8114*/ GIMT_Encode4(394621), // Rule ID 8783 //
     /* 394611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 394614 */     // (AArch64trn1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 394614 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_H),
     /* 394619 */     GIR_RootConstrainSelectedInstOperands,
     /* 394620 */     // GIR_Coverage, 8783,
     /* 394620 */     GIR_Done,
     /* 394621 */   // Label 8114: @394621
     /* 394621 */   GIM_Try, /*On fail goto*//*Label 8115*/ GIMT_Encode4(394636), // Rule ID 8786 //
     /* 394626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 394629 */     // (AArch64trn1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 394629 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_H),
     /* 394634 */     GIR_RootConstrainSelectedInstOperands,
     /* 394635 */     // GIR_Coverage, 8786,
     /* 394635 */     GIR_Done,
     /* 394636 */   // Label 8115: @394636
     /* 394636 */   GIM_Reject,
     /* 394637 */ // Label 8113: @394637
     /* 394637 */ GIM_Reject,
     /* 394638 */ // Label 8081: @394638
     /* 394638 */ GIM_Try, /*On fail goto*//*Label 8116*/ GIMT_Encode4(394663), // Rule ID 2405 //
     /* 394643 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 394646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 394649 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 394652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 394656 */   // (AArch64trn1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 394656 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_B),
     /* 394661 */   GIR_RootConstrainSelectedInstOperands,
     /* 394662 */   // GIR_Coverage, 2405,
     /* 394662 */   GIR_Done,
     /* 394663 */ // Label 8116: @394663
     /* 394663 */ GIM_Reject,
     /* 394664 */ // Label 8082: @394664
     /* 394664 */ GIM_Try, /*On fail goto*//*Label 8117*/ GIMT_Encode4(394689), // Rule ID 8782 //
     /* 394669 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 394672 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 394675 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 394678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 394682 */   // (AArch64trn1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 394682 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_B),
     /* 394687 */   GIR_RootConstrainSelectedInstOperands,
     /* 394688 */   // GIR_Coverage, 8782,
     /* 394688 */   GIR_Done,
     /* 394689 */ // Label 8117: @394689
     /* 394689 */ GIM_Reject,
     /* 394690 */ // Label 8083: @394690
     /* 394690 */ GIM_Reject,
     /* 394691 */ // Label 142: @394691
     /* 394691 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8136*/ GIMT_Encode4(395470),
     /* 394702 */ /*GILLT_v2s32*//*Label 8118*/ GIMT_Encode4(394778),
     /* 394706 */ /*GILLT_v2s64*//*Label 8119*/ GIMT_Encode4(394833),
     /* 394710 */ /*GILLT_v4s16*//*Label 8120*/ GIMT_Encode4(394888),
     /* 394714 */ /*GILLT_v4s32*//*Label 8121*/ GIMT_Encode4(394943),
     /* 394718 */ /*GILLT_v8s8*//*Label 8122*/ GIMT_Encode4(394998),
     /* 394722 */ /*GILLT_v8s16*//*Label 8123*/ GIMT_Encode4(395032),
     /* 394726 */ /*GILLT_v16s8*//*Label 8124*/ GIMT_Encode4(395087), GIMT_Encode4(0),
     /* 394734 */ /*GILLT_nxv2s1*//*Label 8125*/ GIMT_Encode4(395121),
     /* 394738 */ /*GILLT_nxv2s16*//*Label 8126*/ GIMT_Encode4(395147),
     /* 394742 */ /*GILLT_nxv2s32*//*Label 8127*/ GIMT_Encode4(395173),
     /* 394746 */ /*GILLT_nxv2s64*//*Label 8128*/ GIMT_Encode4(395199),
     /* 394750 */ /*GILLT_nxv4s1*//*Label 8129*/ GIMT_Encode4(395246),
     /* 394754 */ /*GILLT_nxv4s16*//*Label 8130*/ GIMT_Encode4(395272),
     /* 394758 */ /*GILLT_nxv4s32*//*Label 8131*/ GIMT_Encode4(395298),
     /* 394762 */ /*GILLT_nxv8s1*//*Label 8132*/ GIMT_Encode4(395345),
     /* 394766 */ /*GILLT_nxv8s16*//*Label 8133*/ GIMT_Encode4(395371),
     /* 394770 */ /*GILLT_nxv16s1*//*Label 8134*/ GIMT_Encode4(395418),
     /* 394774 */ /*GILLT_nxv16s8*//*Label 8135*/ GIMT_Encode4(395444),
     /* 394778 */ // Label 8118: @394778
     /* 394778 */ GIM_Try, /*On fail goto*//*Label 8137*/ GIMT_Encode4(394832),
     /* 394783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 394786 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 394789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394793 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394797 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394801 */   GIM_Try, /*On fail goto*//*Label 8138*/ GIMT_Encode4(394816), // Rule ID 1874 //
     /* 394806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394809 */     // (AArch64trn2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (TRN2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 394809 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i32),
     /* 394814 */     GIR_RootConstrainSelectedInstOperands,
     /* 394815 */     // GIR_Coverage, 1874,
     /* 394815 */     GIR_Done,
     /* 394816 */   // Label 8138: @394816
     /* 394816 */   GIM_Try, /*On fail goto*//*Label 8139*/ GIMT_Encode4(394831), // Rule ID 5405 //
     /* 394821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394824 */     // (AArch64trn2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (TRN2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 394824 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i32),
     /* 394829 */     GIR_RootConstrainSelectedInstOperands,
     /* 394830 */     // GIR_Coverage, 5405,
     /* 394830 */     GIR_Done,
     /* 394831 */   // Label 8139: @394831
     /* 394831 */   GIM_Reject,
     /* 394832 */ // Label 8137: @394832
     /* 394832 */ GIM_Reject,
     /* 394833 */ // Label 8119: @394833
     /* 394833 */ GIM_Try, /*On fail goto*//*Label 8140*/ GIMT_Encode4(394887),
     /* 394838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 394841 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 394844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394848 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394852 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394856 */   GIM_Try, /*On fail goto*//*Label 8141*/ GIMT_Encode4(394871), // Rule ID 1876 //
     /* 394861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394864 */     // (AArch64trn2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (TRN2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 394864 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i64),
     /* 394869 */     GIR_RootConstrainSelectedInstOperands,
     /* 394870 */     // GIR_Coverage, 1876,
     /* 394870 */     GIR_Done,
     /* 394871 */   // Label 8141: @394871
     /* 394871 */   GIM_Try, /*On fail goto*//*Label 8142*/ GIMT_Encode4(394886), // Rule ID 5407 //
     /* 394876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394879 */     // (AArch64trn2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (TRN2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 394879 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i64),
     /* 394884 */     GIR_RootConstrainSelectedInstOperands,
     /* 394885 */     // GIR_Coverage, 5407,
     /* 394885 */     GIR_Done,
     /* 394886 */   // Label 8142: @394886
     /* 394886 */   GIM_Reject,
     /* 394887 */ // Label 8140: @394887
     /* 394887 */ GIM_Reject,
     /* 394888 */ // Label 8120: @394888
     /* 394888 */ GIM_Try, /*On fail goto*//*Label 8143*/ GIMT_Encode4(394942),
     /* 394893 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 394896 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 394899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394903 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394907 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394911 */   GIM_Try, /*On fail goto*//*Label 8144*/ GIMT_Encode4(394926), // Rule ID 1872 //
     /* 394916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394919 */     // (AArch64trn2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (TRN2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 394919 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i16),
     /* 394924 */     GIR_RootConstrainSelectedInstOperands,
     /* 394925 */     // GIR_Coverage, 1872,
     /* 394925 */     GIR_Done,
     /* 394926 */   // Label 8144: @394926
     /* 394926 */   GIM_Try, /*On fail goto*//*Label 8145*/ GIMT_Encode4(394941), // Rule ID 5403 //
     /* 394931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394934 */     // (AArch64trn2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (TRN2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 394934 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i16),
     /* 394939 */     GIR_RootConstrainSelectedInstOperands,
     /* 394940 */     // GIR_Coverage, 5403,
     /* 394940 */     GIR_Done,
     /* 394941 */   // Label 8145: @394941
     /* 394941 */   GIM_Reject,
     /* 394942 */ // Label 8143: @394942
     /* 394942 */ GIM_Reject,
     /* 394943 */ // Label 8121: @394943
     /* 394943 */ GIM_Try, /*On fail goto*//*Label 8146*/ GIMT_Encode4(394997),
     /* 394948 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394951 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 394954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394958 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394962 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394966 */   GIM_Try, /*On fail goto*//*Label 8147*/ GIMT_Encode4(394981), // Rule ID 1875 //
     /* 394971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394974 */     // (AArch64trn2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (TRN2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 394974 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i32),
     /* 394979 */     GIR_RootConstrainSelectedInstOperands,
     /* 394980 */     // GIR_Coverage, 1875,
     /* 394980 */     GIR_Done,
     /* 394981 */   // Label 8147: @394981
     /* 394981 */   GIM_Try, /*On fail goto*//*Label 8148*/ GIMT_Encode4(394996), // Rule ID 5406 //
     /* 394986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394989 */     // (AArch64trn2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (TRN2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 394989 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i32),
     /* 394994 */     GIR_RootConstrainSelectedInstOperands,
     /* 394995 */     // GIR_Coverage, 5406,
     /* 394995 */     GIR_Done,
     /* 394996 */   // Label 8148: @394996
     /* 394996 */   GIM_Reject,
     /* 394997 */ // Label 8146: @394997
     /* 394997 */ GIM_Reject,
     /* 394998 */ // Label 8122: @394998
     /* 394998 */ GIM_Try, /*On fail goto*//*Label 8149*/ GIMT_Encode4(395031), // Rule ID 1870 //
     /* 395003 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395006 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 395009 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 395012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395016 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395020 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395024 */   // (AArch64trn2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (TRN2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 395024 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i8),
     /* 395029 */   GIR_RootConstrainSelectedInstOperands,
     /* 395030 */   // GIR_Coverage, 1870,
     /* 395030 */   GIR_Done,
     /* 395031 */ // Label 8149: @395031
     /* 395031 */ GIM_Reject,
     /* 395032 */ // Label 8123: @395032
     /* 395032 */ GIM_Try, /*On fail goto*//*Label 8150*/ GIMT_Encode4(395086),
     /* 395037 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395040 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 395043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395047 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395051 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395055 */   GIM_Try, /*On fail goto*//*Label 8151*/ GIMT_Encode4(395070), // Rule ID 1873 //
     /* 395060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395063 */     // (AArch64trn2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (TRN2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 395063 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i16),
     /* 395068 */     GIR_RootConstrainSelectedInstOperands,
     /* 395069 */     // GIR_Coverage, 1873,
     /* 395069 */     GIR_Done,
     /* 395070 */   // Label 8151: @395070
     /* 395070 */   GIM_Try, /*On fail goto*//*Label 8152*/ GIMT_Encode4(395085), // Rule ID 5404 //
     /* 395075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395078 */     // (AArch64trn2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (TRN2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 395078 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i16),
     /* 395083 */     GIR_RootConstrainSelectedInstOperands,
     /* 395084 */     // GIR_Coverage, 5404,
     /* 395084 */     GIR_Done,
     /* 395085 */   // Label 8152: @395085
     /* 395085 */   GIM_Reject,
     /* 395086 */ // Label 8150: @395086
     /* 395086 */ GIM_Reject,
     /* 395087 */ // Label 8124: @395087
     /* 395087 */ GIM_Try, /*On fail goto*//*Label 8153*/ GIMT_Encode4(395120), // Rule ID 1871 //
     /* 395092 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 395098 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 395101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395105 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395109 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395113 */   // (AArch64trn2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (TRN2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 395113 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v16i8),
     /* 395118 */   GIR_RootConstrainSelectedInstOperands,
     /* 395119 */   // GIR_Coverage, 1871,
     /* 395119 */   GIR_Done,
     /* 395120 */ // Label 8153: @395120
     /* 395120 */ GIM_Reject,
     /* 395121 */ // Label 8125: @395121
     /* 395121 */ GIM_Try, /*On fail goto*//*Label 8154*/ GIMT_Encode4(395146), // Rule ID 8816 //
     /* 395126 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 395129 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 395132 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 395135 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 395139 */   // (AArch64trn2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (TRN2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 395139 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_D),
     /* 395144 */   GIR_RootConstrainSelectedInstOperands,
     /* 395145 */   // GIR_Coverage, 8816,
     /* 395145 */   GIR_Done,
     /* 395146 */ // Label 8154: @395146
     /* 395146 */ GIM_Reject,
     /* 395147 */ // Label 8126: @395147
     /* 395147 */ GIM_Try, /*On fail goto*//*Label 8155*/ GIMT_Encode4(395172), // Rule ID 8799 //
     /* 395152 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 395155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 395158 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 395161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 395165 */   // (AArch64trn2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 395165 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 395170 */   GIR_RootConstrainSelectedInstOperands,
     /* 395171 */   // GIR_Coverage, 8799,
     /* 395171 */   GIR_Done,
     /* 395172 */ // Label 8155: @395172
     /* 395172 */ GIM_Reject,
     /* 395173 */ // Label 8127: @395173
     /* 395173 */ GIM_Try, /*On fail goto*//*Label 8156*/ GIMT_Encode4(395198), // Rule ID 8800 //
     /* 395178 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 395181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 395184 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 395187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 395191 */   // (AArch64trn2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 395191 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 395196 */   GIR_RootConstrainSelectedInstOperands,
     /* 395197 */   // GIR_Coverage, 8800,
     /* 395197 */   GIR_Done,
     /* 395198 */ // Label 8156: @395198
     /* 395198 */ GIM_Reject,
     /* 395199 */ // Label 8128: @395199
     /* 395199 */ GIM_Try, /*On fail goto*//*Label 8157*/ GIMT_Encode4(395245),
     /* 395204 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 395207 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 395210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 395214 */   GIM_Try, /*On fail goto*//*Label 8158*/ GIMT_Encode4(395229), // Rule ID 8795 //
     /* 395219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 395222 */     // (AArch64trn2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 395222 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 395227 */     GIR_RootConstrainSelectedInstOperands,
     /* 395228 */     // GIR_Coverage, 8795,
     /* 395228 */     GIR_Done,
     /* 395229 */   // Label 8158: @395229
     /* 395229 */   GIM_Try, /*On fail goto*//*Label 8159*/ GIMT_Encode4(395244), // Rule ID 8801 //
     /* 395234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 395237 */     // (AArch64trn2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 395237 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 395242 */     GIR_RootConstrainSelectedInstOperands,
     /* 395243 */     // GIR_Coverage, 8801,
     /* 395243 */     GIR_Done,
     /* 395244 */   // Label 8159: @395244
     /* 395244 */   GIM_Reject,
     /* 395245 */ // Label 8157: @395245
     /* 395245 */ GIM_Reject,
     /* 395246 */ // Label 8129: @395246
     /* 395246 */ GIM_Try, /*On fail goto*//*Label 8160*/ GIMT_Encode4(395271), // Rule ID 8815 //
     /* 395251 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 395254 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 395257 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 395260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 395264 */   // (AArch64trn2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (TRN2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 395264 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_S),
     /* 395269 */   GIR_RootConstrainSelectedInstOperands,
     /* 395270 */   // GIR_Coverage, 8815,
     /* 395270 */   GIR_Done,
     /* 395271 */ // Label 8160: @395271
     /* 395271 */ GIM_Reject,
     /* 395272 */ // Label 8130: @395272
     /* 395272 */ GIM_Try, /*On fail goto*//*Label 8161*/ GIMT_Encode4(395297), // Rule ID 8797 //
     /* 395277 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 395280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 395283 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 395286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 395290 */   // (AArch64trn2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 395290 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
     /* 395295 */   GIR_RootConstrainSelectedInstOperands,
     /* 395296 */   // GIR_Coverage, 8797,
     /* 395296 */   GIR_Done,
     /* 395297 */ // Label 8161: @395297
     /* 395297 */ GIM_Reject,
     /* 395298 */ // Label 8131: @395298
     /* 395298 */ GIM_Try, /*On fail goto*//*Label 8162*/ GIMT_Encode4(395344),
     /* 395303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 395306 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 395309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 395313 */   GIM_Try, /*On fail goto*//*Label 8163*/ GIMT_Encode4(395328), // Rule ID 8794 //
     /* 395318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 395321 */     // (AArch64trn2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 395321 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
     /* 395326 */     GIR_RootConstrainSelectedInstOperands,
     /* 395327 */     // GIR_Coverage, 8794,
     /* 395327 */     GIR_Done,
     /* 395328 */   // Label 8163: @395328
     /* 395328 */   GIM_Try, /*On fail goto*//*Label 8164*/ GIMT_Encode4(395343), // Rule ID 8798 //
     /* 395333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 395336 */     // (AArch64trn2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 395336 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
     /* 395341 */     GIR_RootConstrainSelectedInstOperands,
     /* 395342 */     // GIR_Coverage, 8798,
     /* 395342 */     GIR_Done,
     /* 395343 */   // Label 8164: @395343
     /* 395343 */   GIM_Reject,
     /* 395344 */ // Label 8162: @395344
     /* 395344 */ GIM_Reject,
     /* 395345 */ // Label 8132: @395345
     /* 395345 */ GIM_Try, /*On fail goto*//*Label 8165*/ GIMT_Encode4(395370), // Rule ID 8814 //
     /* 395350 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 395353 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 395356 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 395359 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 395363 */   // (AArch64trn2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (TRN2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 395363 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_H),
     /* 395368 */   GIR_RootConstrainSelectedInstOperands,
     /* 395369 */   // GIR_Coverage, 8814,
     /* 395369 */   GIR_Done,
     /* 395370 */ // Label 8165: @395370
     /* 395370 */ GIM_Reject,
     /* 395371 */ // Label 8133: @395371
     /* 395371 */ GIM_Try, /*On fail goto*//*Label 8166*/ GIMT_Encode4(395417),
     /* 395376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 395379 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 395382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 395386 */   GIM_Try, /*On fail goto*//*Label 8167*/ GIMT_Encode4(395401), // Rule ID 8793 //
     /* 395391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 395394 */     // (AArch64trn2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 395394 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_H),
     /* 395399 */     GIR_RootConstrainSelectedInstOperands,
     /* 395400 */     // GIR_Coverage, 8793,
     /* 395400 */     GIR_Done,
     /* 395401 */   // Label 8167: @395401
     /* 395401 */   GIM_Try, /*On fail goto*//*Label 8168*/ GIMT_Encode4(395416), // Rule ID 8796 //
     /* 395406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 395409 */     // (AArch64trn2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 395409 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_H),
     /* 395414 */     GIR_RootConstrainSelectedInstOperands,
     /* 395415 */     // GIR_Coverage, 8796,
     /* 395415 */     GIR_Done,
     /* 395416 */   // Label 8168: @395416
     /* 395416 */   GIM_Reject,
     /* 395417 */ // Label 8166: @395417
     /* 395417 */ GIM_Reject,
     /* 395418 */ // Label 8134: @395418
     /* 395418 */ GIM_Try, /*On fail goto*//*Label 8169*/ GIMT_Encode4(395443), // Rule ID 2409 //
     /* 395423 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 395426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 395429 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 395432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 395436 */   // (AArch64trn2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 395436 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_B),
     /* 395441 */   GIR_RootConstrainSelectedInstOperands,
     /* 395442 */   // GIR_Coverage, 2409,
     /* 395442 */   GIR_Done,
     /* 395443 */ // Label 8169: @395443
     /* 395443 */ GIM_Reject,
     /* 395444 */ // Label 8135: @395444
     /* 395444 */ GIM_Try, /*On fail goto*//*Label 8170*/ GIMT_Encode4(395469), // Rule ID 8792 //
     /* 395449 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 395452 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 395455 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 395458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 395462 */   // (AArch64trn2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 395462 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_B),
     /* 395467 */   GIR_RootConstrainSelectedInstOperands,
     /* 395468 */   // GIR_Coverage, 8792,
     /* 395468 */   GIR_Done,
     /* 395469 */ // Label 8170: @395469
     /* 395469 */ GIM_Reject,
     /* 395470 */ // Label 8136: @395470
     /* 395470 */ GIM_Reject,
     /* 395471 */ // Label 143: @395471
     /* 395471 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8177*/ GIMT_Encode4(395676),
     /* 395482 */ /*GILLT_s64*//*Label 8171*/ GIMT_Encode4(395514), GIMT_Encode4(0),
     /* 395490 */ /*GILLT_v2s32*//*Label 8172*/ GIMT_Encode4(395541),
     /* 395494 */ /*GILLT_v2s64*//*Label 8173*/ GIMT_Encode4(395568),
     /* 395498 */ /*GILLT_v4s16*//*Label 8174*/ GIMT_Encode4(395595),
     /* 395502 */ /*GILLT_v4s32*//*Label 8175*/ GIMT_Encode4(395622), GIMT_Encode4(0),
     /* 395510 */ /*GILLT_v8s16*//*Label 8176*/ GIMT_Encode4(395649),
     /* 395514 */ // Label 8171: @395514
     /* 395514 */ GIM_Try, /*On fail goto*//*Label 8178*/ GIMT_Encode4(395540), // Rule ID 1062 //
     /* 395519 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395522 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 395525 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395529 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395533 */   // (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)  =>  (UADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 395533 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
     /* 395538 */   GIR_RootConstrainSelectedInstOperands,
     /* 395539 */   // GIR_Coverage, 1062,
     /* 395539 */   GIR_Done,
     /* 395540 */ // Label 8178: @395540
     /* 395540 */ GIM_Reject,
     /* 395541 */ // Label 8172: @395541
     /* 395541 */ GIM_Try, /*On fail goto*//*Label 8179*/ GIMT_Encode4(395567), // Rule ID 1058 //
     /* 395546 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 395552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395556 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395560 */   // (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)  =>  (UADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 395560 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i16_v2i32),
     /* 395565 */   GIR_RootConstrainSelectedInstOperands,
     /* 395566 */   // GIR_Coverage, 1058,
     /* 395566 */   GIR_Done,
     /* 395567 */ // Label 8179: @395567
     /* 395567 */ GIM_Reject,
     /* 395568 */ // Label 8173: @395568
     /* 395568 */ GIM_Try, /*On fail goto*//*Label 8180*/ GIMT_Encode4(395594), // Rule ID 1064 //
     /* 395573 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 395579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395583 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395587 */   // (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (UADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 395587 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i32_v2i64),
     /* 395592 */   GIR_RootConstrainSelectedInstOperands,
     /* 395593 */   // GIR_Coverage, 1064,
     /* 395593 */   GIR_Done,
     /* 395594 */ // Label 8180: @395594
     /* 395594 */ GIM_Reject,
     /* 395595 */ // Label 8174: @395595
     /* 395595 */ GIM_Try, /*On fail goto*//*Label 8181*/ GIMT_Encode4(395621), // Rule ID 1054 //
     /* 395600 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395603 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 395606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395610 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395614 */   // (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)  =>  (UADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 395614 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i8_v4i16),
     /* 395619 */   GIR_RootConstrainSelectedInstOperands,
     /* 395620 */   // GIR_Coverage, 1054,
     /* 395620 */   GIR_Done,
     /* 395621 */ // Label 8181: @395621
     /* 395621 */ GIM_Reject,
     /* 395622 */ // Label 8175: @395622
     /* 395622 */ GIM_Try, /*On fail goto*//*Label 8182*/ GIMT_Encode4(395648), // Rule ID 1060 //
     /* 395627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395637 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395641 */   // (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (UADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 395641 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i16_v4i32),
     /* 395646 */   GIR_RootConstrainSelectedInstOperands,
     /* 395647 */   // GIR_Coverage, 1060,
     /* 395647 */   GIR_Done,
     /* 395648 */ // Label 8182: @395648
     /* 395648 */ GIM_Reject,
     /* 395649 */ // Label 8176: @395649
     /* 395649 */ GIM_Try, /*On fail goto*//*Label 8183*/ GIMT_Encode4(395675), // Rule ID 1056 //
     /* 395654 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 395660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395664 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395668 */   // (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)  =>  (UADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 395668 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv16i8_v8i16),
     /* 395673 */   GIR_RootConstrainSelectedInstOperands,
     /* 395674 */   // GIR_Coverage, 1056,
     /* 395674 */   GIR_Done,
     /* 395675 */ // Label 8183: @395675
     /* 395675 */ GIM_Reject,
     /* 395676 */ // Label 8177: @395676
     /* 395676 */ GIM_Reject,
     /* 395677 */ // Label 144: @395677
     /* 395677 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(9), /*)*//*default:*//*Label 8186*/ GIMT_Encode4(396543),
     /* 395688 */ /*GILLT_v2s64*//*Label 8184*/ GIMT_Encode4(395700), GIMT_Encode4(0),
     /* 395696 */ /*GILLT_v4s32*//*Label 8185*/ GIMT_Encode4(395994),
     /* 395700 */ // Label 8184: @395700
     /* 395700 */ GIM_Try, /*On fail goto*//*Label 8187*/ GIMT_Encode4(395782), // Rule ID 5772 //
     /* 395705 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 395708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395712 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395716 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 395720 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 395723 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 395728 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 395732 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395737 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 395739 */   // (AArch64uaddlv:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$op))  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$op), ssub:{ *:[i32] })
     /* 395739 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 395742 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 395746 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395751 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
     /* 395755 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 395757 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 395760 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 395762 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395765 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 395768 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 395771 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395776 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395781 */   // GIR_Coverage, 5772,
     /* 395781 */   GIR_EraseRootFromParent_Done,
     /* 395782 */ // Label 8187: @395782
     /* 395782 */ GIM_Try, /*On fail goto*//*Label 8188*/ GIMT_Encode4(395856), // Rule ID 5771 //
     /* 395787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 395790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395794 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395798 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 395802 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395806 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395811 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 395813 */   // (AArch64uaddlv:{ *:[v2i64] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$op))  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$op), ssub:{ *:[i32] })
     /* 395813 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 395816 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 395820 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395825 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
     /* 395829 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 395831 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 395834 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 395836 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395839 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 395842 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 395845 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395850 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395855 */   // GIR_Coverage, 5771,
     /* 395855 */   GIR_EraseRootFromParent_Done,
     /* 395856 */ // Label 8188: @395856
     /* 395856 */ GIM_Try, /*On fail goto*//*Label 8189*/ GIMT_Encode4(395915), // Rule ID 5781 //
     /* 395861 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 395864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395868 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395872 */   // (AArch64uaddlv:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /* 395872 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 395875 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
     /* 395879 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395884 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 395888 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 395890 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 395893 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 395895 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395898 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 395901 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 395904 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395909 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395914 */   // GIR_Coverage, 5781,
     /* 395914 */   GIR_EraseRootFromParent_Done,
     /* 395915 */ // Label 8189: @395915
     /* 395915 */ GIM_Try, /*On fail goto*//*Label 8190*/ GIMT_Encode4(395993), // Rule ID 5909 //
     /* 395920 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 395923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395927 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395931 */   // (AArch64uaddlv:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (UADDLPv2i32_v1i64:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
     /* 395931 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 395934 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
     /* 395938 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395943 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 395947 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 395949 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 395952 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 395956 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395961 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 395963 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 395966 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 395968 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 395971 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 395974 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 395977 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395982 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395987 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395992 */   // GIR_Coverage, 5909,
     /* 395992 */   GIR_EraseRootFromParent_Done,
     /* 395993 */ // Label 8190: @395993
     /* 395993 */ GIM_Reject,
     /* 395994 */ // Label 8185: @395994
     /* 395994 */ GIM_Try, /*On fail goto*//*Label 8191*/ GIMT_Encode4(396076), // Rule ID 5774 //
     /* 395999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396006 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396010 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 396014 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 396017 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 396022 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 396026 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396031 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396033 */   // (AArch64uaddlv:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$op), hsub:{ *:[i32] })
     /* 396033 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 396036 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 396040 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396045 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
     /* 396049 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 396051 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 396054 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 396056 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396059 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396062 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 396065 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396070 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396075 */   // GIR_Coverage, 5774,
     /* 396075 */   GIR_EraseRootFromParent_Done,
     /* 396076 */ // Label 8191: @396076
     /* 396076 */ GIM_Try, /*On fail goto*//*Label 8192*/ GIMT_Encode4(396158), // Rule ID 5776 //
     /* 396081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 396084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396088 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396092 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 396096 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 396099 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 396104 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 396108 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396113 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396115 */   // (AArch64uaddlv:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$op), hsub:{ *:[i32] })
     /* 396115 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 396118 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 396122 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396127 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
     /* 396131 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 396133 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 396136 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 396138 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396141 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396144 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 396147 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396152 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396157 */   // GIR_Coverage, 5776,
     /* 396157 */   GIR_EraseRootFromParent_Done,
     /* 396158 */ // Label 8192: @396158
     /* 396158 */ GIM_Try, /*On fail goto*//*Label 8193*/ GIMT_Encode4(396232), // Rule ID 5773 //
     /* 396163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396170 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396174 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 396178 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 396182 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396187 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396189 */   // (AArch64uaddlv:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$op), hsub:{ *:[i32] })
     /* 396189 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 396192 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 396196 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396201 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
     /* 396205 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 396207 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 396210 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 396212 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396215 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396218 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 396221 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396226 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396231 */   // GIR_Coverage, 5773,
     /* 396231 */   GIR_EraseRootFromParent_Done,
     /* 396232 */ // Label 8193: @396232
     /* 396232 */ GIM_Try, /*On fail goto*//*Label 8194*/ GIMT_Encode4(396306), // Rule ID 5775 //
     /* 396237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 396240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396244 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396248 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 396252 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 396256 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396261 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396263 */   // (AArch64uaddlv:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$op), hsub:{ *:[i32] })
     /* 396263 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 396266 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 396270 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396275 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
     /* 396279 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 396281 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 396284 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 396286 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396289 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396292 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 396295 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396300 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396305 */   // GIR_Coverage, 5775,
     /* 396305 */   GIR_EraseRootFromParent_Done,
     /* 396306 */ // Label 8194: @396306
     /* 396306 */ GIM_Try, /*On fail goto*//*Label 8195*/ GIMT_Encode4(396365), // Rule ID 5777 //
     /* 396311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 396314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396318 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396322 */   // (AArch64uaddlv:{ *:[v4i32] } V64:{ *:[v8i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn), hsub:{ *:[i32] })
     /* 396322 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 396325 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 396329 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396334 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 396338 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 396340 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 396343 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 396345 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396348 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396351 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 396354 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396359 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396364 */   // GIR_Coverage, 5777,
     /* 396364 */   GIR_EraseRootFromParent_Done,
     /* 396365 */ // Label 8195: @396365
     /* 396365 */ GIM_Try, /*On fail goto*//*Label 8196*/ GIMT_Encode4(396424), // Rule ID 5778 //
     /* 396370 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 396373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396377 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396381 */   // (AArch64uaddlv:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn), ssub:{ *:[i32] })
     /* 396381 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 396384 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
     /* 396388 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396393 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 396397 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 396399 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 396402 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 396404 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396407 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396410 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 396413 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396418 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396423 */   // GIR_Coverage, 5778,
     /* 396423 */   GIR_EraseRootFromParent_Done,
     /* 396424 */ // Label 8196: @396424
     /* 396424 */ GIM_Try, /*On fail goto*//*Label 8197*/ GIMT_Encode4(396483), // Rule ID 5779 //
     /* 396429 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 396432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396436 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396440 */   // (AArch64uaddlv:{ *:[v4i32] } V128:{ *:[v16i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn), hsub:{ *:[i32] })
     /* 396440 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 396443 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 396447 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396452 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 396456 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 396458 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 396461 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 396463 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396466 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396469 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 396472 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396477 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396482 */   // GIR_Coverage, 5779,
     /* 396482 */   GIR_EraseRootFromParent_Done,
     /* 396483 */ // Label 8197: @396483
     /* 396483 */ GIM_Try, /*On fail goto*//*Label 8198*/ GIMT_Encode4(396542), // Rule ID 5780 //
     /* 396488 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396495 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396499 */   // (AArch64uaddlv:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn), ssub:{ *:[i32] })
     /* 396499 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 396502 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 396506 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396511 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 396515 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 396517 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 396520 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 396522 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396525 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396528 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 396531 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396536 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396541 */   // GIR_Coverage, 5780,
     /* 396541 */   GIR_EraseRootFromParent_Done,
     /* 396542 */ // Label 8198: @396542
     /* 396542 */ GIM_Reject,
     /* 396543 */ // Label 8186: @396543
     /* 396543 */ GIM_Reject,
     /* 396544 */ // Label 145: @396544
     /* 396544 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(20), /*)*//*default:*//*Label 8203*/ GIMT_Encode4(396913),
     /* 396555 */ /*GILLT_v2s32*//*Label 8199*/ GIMT_Encode4(396615), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 396567 */ /*GILLT_v4s32*//*Label 8200*/ GIMT_Encode4(396735), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 396599 */ /*GILLT_nxv2s64*//*Label 8201*/ GIMT_Encode4(396855), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 396611 */ /*GILLT_nxv4s32*//*Label 8202*/ GIMT_Encode4(396884),
     /* 396615 */ // Label 8199: @396615
     /* 396615 */ GIM_Try, /*On fail goto*//*Label 8204*/ GIMT_Encode4(396734),
     /* 396620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 396623 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 396626 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 396629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396633 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396637 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396641 */   GIM_Try, /*On fail goto*//*Label 8205*/ GIMT_Encode4(396714), // Rule ID 28 //
     /* 396646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 396649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 396653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 396657 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 396661 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 396665 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 396669 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 396673 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 396677 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396682 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 396686 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 396690 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 396694 */     // MIs[3] Operand 1
     /* 396694 */     // No operand predicates
     /* 396694 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 396696 */     // (AArch64udot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, (bitconvert:{ *:[v8i8] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UDOTlanev8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 396696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOTlanev8i8),
     /* 396699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 396701 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 396703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 396705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 396709 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 396712 */     GIR_RootConstrainSelectedInstOperands,
     /* 396713 */     // GIR_Coverage, 28,
     /* 396713 */     GIR_EraseRootFromParent_Done,
     /* 396714 */   // Label 8205: @396714
     /* 396714 */   GIM_Try, /*On fail goto*//*Label 8206*/ GIMT_Encode4(396733), // Rule ID 24 //
     /* 396719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 396722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396726 */     // (AArch64udot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UDOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 396726 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOTv8i8),
     /* 396731 */     GIR_RootConstrainSelectedInstOperands,
     /* 396732 */     // GIR_Coverage, 24,
     /* 396732 */     GIR_Done,
     /* 396733 */   // Label 8206: @396733
     /* 396733 */   GIM_Reject,
     /* 396734 */ // Label 8204: @396734
     /* 396734 */ GIM_Reject,
     /* 396735 */ // Label 8200: @396735
     /* 396735 */ GIM_Try, /*On fail goto*//*Label 8207*/ GIMT_Encode4(396854),
     /* 396740 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 396743 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 396746 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 396749 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396753 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396757 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396761 */   GIM_Try, /*On fail goto*//*Label 8208*/ GIMT_Encode4(396834), // Rule ID 29 //
     /* 396766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 396769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 396773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 396777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 396781 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 396785 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 396789 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 396793 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 396797 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396802 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 396806 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 396810 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 396814 */     // MIs[3] Operand 1
     /* 396814 */     // No operand predicates
     /* 396814 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 396816 */     // (AArch64udot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, (bitconvert:{ *:[v16i8] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UDOTlanev16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 396816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOTlanev16i8),
     /* 396819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 396821 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 396823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 396825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 396829 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 396832 */     GIR_RootConstrainSelectedInstOperands,
     /* 396833 */     // GIR_Coverage, 29,
     /* 396833 */     GIR_EraseRootFromParent_Done,
     /* 396834 */   // Label 8208: @396834
     /* 396834 */   GIM_Try, /*On fail goto*//*Label 8209*/ GIMT_Encode4(396853), // Rule ID 25 //
     /* 396839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 396842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396846 */     // (AArch64udot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UDOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 396846 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOTv16i8),
     /* 396851 */     GIR_RootConstrainSelectedInstOperands,
     /* 396852 */     // GIR_Coverage, 25,
     /* 396852 */     GIR_Done,
     /* 396853 */   // Label 8209: @396853
     /* 396853 */   GIM_Reject,
     /* 396854 */ // Label 8207: @396854
     /* 396854 */ GIM_Reject,
     /* 396855 */ // Label 8201: @396855
     /* 396855 */ GIM_Try, /*On fail goto*//*Label 8210*/ GIMT_Encode4(396883), // Rule ID 7503 //
     /* 396860 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 396863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 396866 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 396869 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 396872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 396876 */   // (AArch64udot:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UDOT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 396876 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_D),
     /* 396881 */   GIR_RootConstrainSelectedInstOperands,
     /* 396882 */   // GIR_Coverage, 7503,
     /* 396882 */   GIR_Done,
     /* 396883 */ // Label 8210: @396883
     /* 396883 */ GIM_Reject,
     /* 396884 */ // Label 8202: @396884
     /* 396884 */ GIM_Try, /*On fail goto*//*Label 8211*/ GIMT_Encode4(396912), // Rule ID 7502 //
     /* 396889 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 396892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 396895 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 396898 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 396901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 396905 */   // (AArch64udot:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UDOT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 396905 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_S),
     /* 396910 */   GIR_RootConstrainSelectedInstOperands,
     /* 396911 */   // GIR_Coverage, 7502,
     /* 396911 */   GIR_Done,
     /* 396912 */ // Label 8211: @396912
     /* 396912 */ GIM_Reject,
     /* 396913 */ // Label 8203: @396913
     /* 396913 */ GIM_Reject,
     /* 396914 */ // Label 146: @396914
     /* 396914 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8215*/ GIMT_Encode4(397030),
     /* 396925 */ /*GILLT_s16*//*Label 8212*/ GIMT_Encode4(396937),
     /* 396929 */ /*GILLT_s32*//*Label 8213*/ GIMT_Encode4(396968),
     /* 396933 */ /*GILLT_s64*//*Label 8214*/ GIMT_Encode4(396999),
     /* 396937 */ // Label 8212: @396937
     /* 396937 */ GIM_Try, /*On fail goto*//*Label 8216*/ GIMT_Encode4(396967), // Rule ID 1662 //
     /* 396942 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 396945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 396948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396952 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396956 */   // (AArch64uitof:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (UCVTFv1i16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 396956 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
     /* 396961 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396965 */   GIR_RootConstrainSelectedInstOperands,
     /* 396966 */   // GIR_Coverage, 1662,
     /* 396966 */   GIR_Done,
     /* 396967 */ // Label 8216: @396967
     /* 396967 */ GIM_Reject,
     /* 396968 */ // Label 8213: @396968
     /* 396968 */ GIM_Try, /*On fail goto*//*Label 8217*/ GIMT_Encode4(396998), // Rule ID 1661 //
     /* 396973 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 396976 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 396979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396983 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396987 */   // (AArch64uitof:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (UCVTFv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 396987 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 396992 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396996 */   GIR_RootConstrainSelectedInstOperands,
     /* 396997 */   // GIR_Coverage, 1661,
     /* 396997 */   GIR_Done,
     /* 396998 */ // Label 8217: @396998
     /* 396998 */ GIM_Reject,
     /* 396999 */ // Label 8214: @396999
     /* 396999 */ GIM_Try, /*On fail goto*//*Label 8218*/ GIMT_Encode4(397029), // Rule ID 1660 //
     /* 397004 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 397007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 397010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397014 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397018 */   // (AArch64uitof:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (UCVTFv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 397018 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 397023 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397027 */   GIR_RootConstrainSelectedInstOperands,
     /* 397028 */   // GIR_Coverage, 1660,
     /* 397028 */   GIR_Done,
     /* 397029 */ // Label 8218: @397029
     /* 397029 */ GIM_Reject,
     /* 397030 */ // Label 8215: @397030
     /* 397030 */ GIM_Reject,
     /* 397031 */ // Label 147: @397031
     /* 397031 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(11), /*)*//*default:*//*Label 8222*/ GIMT_Encode4(398263),
     /* 397042 */ /*GILLT_v2s64*//*Label 8219*/ GIMT_Encode4(397062), GIMT_Encode4(0),
     /* 397050 */ /*GILLT_v4s32*//*Label 8220*/ GIMT_Encode4(397623), GIMT_Encode4(0),
     /* 397058 */ /*GILLT_v8s16*//*Label 8221*/ GIMT_Encode4(398184),
     /* 397062 */ // Label 8219: @397062
     /* 397062 */ GIM_Try, /*On fail goto*//*Label 8223*/ GIMT_Encode4(397622),
     /* 397067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 397070 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 397073 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397077 */   GIM_Try, /*On fail goto*//*Label 8224*/ GIMT_Encode4(397169), // Rule ID 2099 //
     /* 397082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 397089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 397093 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 397101 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 397105 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397109 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 397113 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397118 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 397122 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397126 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 397130 */     // MIs[3] Operand 1
     /* 397130 */     // No operand predicates
     /* 397130 */     // MIs[1] Operand 2
     /* 397130 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 397141 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 397143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 397150 */     // (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (UMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 397150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_indexed),
     /* 397153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 397160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 397164 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 397167 */     GIR_RootConstrainSelectedInstOperands,
     /* 397168 */     // GIR_Coverage, 2099,
     /* 397168 */     GIR_EraseRootFromParent_Done,
     /* 397169 */   // Label 8224: @397169
     /* 397169 */   GIM_Try, /*On fail goto*//*Label 8225*/ GIMT_Encode4(397261), // Rule ID 13247 //
     /* 397174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 397185 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397189 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 397193 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 397197 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397201 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 397205 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397210 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 397214 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397218 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 397222 */     // MIs[3] Operand 1
     /* 397222 */     // No operand predicates
     /* 397222 */     // MIs[1] Operand 2
     /* 397222 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 397233 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 397235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 397242 */     // (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (UMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 397242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_indexed),
     /* 397245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 397252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 397256 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 397259 */     GIR_RootConstrainSelectedInstOperands,
     /* 397260 */     // GIR_Coverage, 13247,
     /* 397260 */     GIR_EraseRootFromParent_Done,
     /* 397261 */   // Label 8225: @397261
     /* 397261 */   GIM_Try, /*On fail goto*//*Label 8226*/ GIMT_Encode4(397347), // Rule ID 13245 //
     /* 397266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 397277 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397281 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 397285 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 397289 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397293 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 397297 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397302 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 397306 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397310 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 397314 */     // MIs[3] Operand 1
     /* 397314 */     // No operand predicates
     /* 397314 */     // MIs[1] Operand 2
     /* 397314 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 397325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397329 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 397331 */     // (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 397331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 397334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 397338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 397342 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 397345 */     GIR_RootConstrainSelectedInstOperands,
     /* 397346 */     // GIR_Coverage, 13245,
     /* 397346 */     GIR_EraseRootFromParent_Done,
     /* 397347 */   // Label 8226: @397347
     /* 397347 */   GIM_Try, /*On fail goto*//*Label 8227*/ GIMT_Encode4(397433), // Rule ID 2097 //
     /* 397352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 397363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 397367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397371 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 397375 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 397379 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397383 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 397387 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397392 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 397396 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397400 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 397404 */     // MIs[3] Operand 1
     /* 397404 */     // No operand predicates
     /* 397404 */     // MIs[1] Operand 2
     /* 397404 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 397415 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 397417 */     // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 397417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 397420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397422 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 397424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 397428 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 397431 */     GIR_RootConstrainSelectedInstOperands,
     /* 397432 */     // GIR_Coverage, 2097,
     /* 397432 */     GIR_EraseRootFromParent_Done,
     /* 397433 */   // Label 8227: @397433
     /* 397433 */   GIM_Try, /*On fail goto*//*Label 8228*/ GIMT_Encode4(397472), // Rule ID 1824 //
     /* 397438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 397448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 397455 */     // (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (UMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 397455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_v2i64),
     /* 397458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 397465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 397470 */     GIR_RootConstrainSelectedInstOperands,
     /* 397471 */     // GIR_Coverage, 1824,
     /* 397471 */     GIR_EraseRootFromParent_Done,
     /* 397472 */   // Label 8228: @397472
     /* 397472 */   GIM_Try, /*On fail goto*//*Label 8229*/ GIMT_Encode4(397535), // Rule ID 13246 //
     /* 397477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 397488 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397492 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 397496 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397501 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 397505 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397509 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 397513 */     // MIs[2] Operand 1
     /* 397513 */     // No operand predicates
     /* 397513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397517 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 397519 */     // (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 397519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 397522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 397526 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 397530 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 397533 */     GIR_RootConstrainSelectedInstOperands,
     /* 397534 */     // GIR_Coverage, 13246,
     /* 397534 */     GIR_EraseRootFromParent_Done,
     /* 397535 */   // Label 8229: @397535
     /* 397535 */   GIM_Try, /*On fail goto*//*Label 8230*/ GIMT_Encode4(397598), // Rule ID 2098 //
     /* 397540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 397551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 397555 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397559 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 397563 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397568 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 397572 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397576 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 397580 */     // MIs[2] Operand 1
     /* 397580 */     // No operand predicates
     /* 397580 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 397582 */     // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 397582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 397585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397587 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 397589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 397593 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 397596 */     GIR_RootConstrainSelectedInstOperands,
     /* 397597 */     // GIR_Coverage, 2098,
     /* 397597 */     GIR_EraseRootFromParent_Done,
     /* 397598 */   // Label 8230: @397598
     /* 397598 */   GIM_Try, /*On fail goto*//*Label 8231*/ GIMT_Encode4(397621), // Rule ID 1823 //
     /* 397603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397614 */     // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 397614 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_v2i64),
     /* 397619 */     GIR_RootConstrainSelectedInstOperands,
     /* 397620 */     // GIR_Coverage, 1823,
     /* 397620 */     GIR_Done,
     /* 397621 */   // Label 8231: @397621
     /* 397621 */   GIM_Reject,
     /* 397622 */ // Label 8223: @397622
     /* 397622 */ GIM_Reject,
     /* 397623 */ // Label 8220: @397623
     /* 397623 */ GIM_Try, /*On fail goto*//*Label 8232*/ GIMT_Encode4(398183),
     /* 397628 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 397631 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 397634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397638 */   GIM_Try, /*On fail goto*//*Label 8233*/ GIMT_Encode4(397730), // Rule ID 2096 //
     /* 397643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 397650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 397654 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397658 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 397662 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 397666 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397670 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 397674 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 397679 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 397683 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397687 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 397691 */     // MIs[3] Operand 1
     /* 397691 */     // No operand predicates
     /* 397691 */     // MIs[1] Operand 2
     /* 397691 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 397702 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 397704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 397711 */     // (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (UMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 397711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_indexed),
     /* 397714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 397721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 397725 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 397728 */     GIR_RootConstrainSelectedInstOperands,
     /* 397729 */     // GIR_Coverage, 2096,
     /* 397729 */     GIR_EraseRootFromParent_Done,
     /* 397730 */   // Label 8233: @397730
     /* 397730 */   GIM_Try, /*On fail goto*//*Label 8234*/ GIMT_Encode4(397822), // Rule ID 13244 //
     /* 397735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 397746 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397750 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 397754 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 397758 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397762 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 397766 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 397771 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 397775 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397779 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 397783 */     // MIs[3] Operand 1
     /* 397783 */     // No operand predicates
     /* 397783 */     // MIs[1] Operand 2
     /* 397783 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 397794 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 397796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 397803 */     // (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (UMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 397803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_indexed),
     /* 397806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 397813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 397817 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 397820 */     GIR_RootConstrainSelectedInstOperands,
     /* 397821 */     // GIR_Coverage, 13244,
     /* 397821 */     GIR_EraseRootFromParent_Done,
     /* 397822 */   // Label 8234: @397822
     /* 397822 */   GIM_Try, /*On fail goto*//*Label 8235*/ GIMT_Encode4(397908), // Rule ID 13242 //
     /* 397827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 397838 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397842 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 397846 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 397850 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397854 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 397858 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 397863 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 397867 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397871 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 397875 */     // MIs[3] Operand 1
     /* 397875 */     // No operand predicates
     /* 397875 */     // MIs[1] Operand 2
     /* 397875 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 397886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397890 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 397892 */     // (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 397892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 397895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 397899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 397903 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 397906 */     GIR_RootConstrainSelectedInstOperands,
     /* 397907 */     // GIR_Coverage, 13242,
     /* 397907 */     GIR_EraseRootFromParent_Done,
     /* 397908 */   // Label 8235: @397908
     /* 397908 */   GIM_Try, /*On fail goto*//*Label 8236*/ GIMT_Encode4(397994), // Rule ID 2094 //
     /* 397913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397916 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 397924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 397928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397932 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 397936 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 397940 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397944 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 397948 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 397953 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 397957 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397961 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 397965 */     // MIs[3] Operand 1
     /* 397965 */     // No operand predicates
     /* 397965 */     // MIs[1] Operand 2
     /* 397965 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 397976 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 397978 */     // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 397978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 397981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397983 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 397985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 397989 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 397992 */     GIR_RootConstrainSelectedInstOperands,
     /* 397993 */     // GIR_Coverage, 2094,
     /* 397993 */     GIR_EraseRootFromParent_Done,
     /* 397994 */   // Label 8236: @397994
     /* 397994 */   GIM_Try, /*On fail goto*//*Label 8237*/ GIMT_Encode4(398033), // Rule ID 1822 //
     /* 397999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 398009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 398016 */     // (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (UMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 398016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_v4i32),
     /* 398019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 398026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 398031 */     GIR_RootConstrainSelectedInstOperands,
     /* 398032 */     // GIR_Coverage, 1822,
     /* 398032 */     GIR_EraseRootFromParent_Done,
     /* 398033 */   // Label 8237: @398033
     /* 398033 */   GIM_Try, /*On fail goto*//*Label 8238*/ GIMT_Encode4(398096), // Rule ID 13243 //
     /* 398038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 398049 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398053 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 398057 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 398062 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398066 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398070 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 398074 */     // MIs[2] Operand 1
     /* 398074 */     // No operand predicates
     /* 398074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398078 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 398080 */     // (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 398080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 398083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 398087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 398091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 398094 */     GIR_RootConstrainSelectedInstOperands,
     /* 398095 */     // GIR_Coverage, 13243,
     /* 398095 */     GIR_EraseRootFromParent_Done,
     /* 398096 */   // Label 8238: @398096
     /* 398096 */   GIM_Try, /*On fail goto*//*Label 8239*/ GIMT_Encode4(398159), // Rule ID 2095 //
     /* 398101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398104 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 398112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 398116 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398120 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 398124 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 398129 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398133 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398137 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 398141 */     // MIs[2] Operand 1
     /* 398141 */     // No operand predicates
     /* 398141 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 398143 */     // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 398143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 398146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398148 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 398154 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 398157 */     GIR_RootConstrainSelectedInstOperands,
     /* 398158 */     // GIR_Coverage, 2095,
     /* 398158 */     GIR_EraseRootFromParent_Done,
     /* 398159 */   // Label 8239: @398159
     /* 398159 */   GIM_Try, /*On fail goto*//*Label 8240*/ GIMT_Encode4(398182), // Rule ID 1821 //
     /* 398164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398167 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398175 */     // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 398175 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_v4i32),
     /* 398180 */     GIR_RootConstrainSelectedInstOperands,
     /* 398181 */     // GIR_Coverage, 1821,
     /* 398181 */     GIR_Done,
     /* 398182 */   // Label 8240: @398182
     /* 398182 */   GIM_Reject,
     /* 398183 */ // Label 8232: @398183
     /* 398183 */ GIM_Reject,
     /* 398184 */ // Label 8221: @398184
     /* 398184 */ GIM_Try, /*On fail goto*//*Label 8241*/ GIMT_Encode4(398262),
     /* 398189 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 398192 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 398195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398199 */   GIM_Try, /*On fail goto*//*Label 8242*/ GIMT_Encode4(398238), // Rule ID 1820 //
     /* 398204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 398214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 398221 */     // (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (UMULLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 398221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv16i8_v8i16),
     /* 398224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 398231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 398236 */     GIR_RootConstrainSelectedInstOperands,
     /* 398237 */     // GIR_Coverage, 1820,
     /* 398237 */     GIR_EraseRootFromParent_Done,
     /* 398238 */   // Label 8242: @398238
     /* 398238 */   GIM_Try, /*On fail goto*//*Label 8243*/ GIMT_Encode4(398261), // Rule ID 1819 //
     /* 398243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398246 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398254 */     // (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMULLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 398254 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i8_v8i16),
     /* 398259 */     GIR_RootConstrainSelectedInstOperands,
     /* 398260 */     // GIR_Coverage, 1819,
     /* 398260 */     GIR_Done,
     /* 398261 */   // Label 8243: @398261
     /* 398261 */   GIM_Reject,
     /* 398262 */ // Label 8241: @398262
     /* 398262 */ GIM_Reject,
     /* 398263 */ // Label 8222: @398263
     /* 398263 */ GIM_Reject,
     /* 398264 */ // Label 148: @398264
     /* 398264 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8262*/ GIMT_Encode4(399043),
     /* 398275 */ /*GILLT_v2s32*//*Label 8244*/ GIMT_Encode4(398351),
     /* 398279 */ /*GILLT_v2s64*//*Label 8245*/ GIMT_Encode4(398406),
     /* 398283 */ /*GILLT_v4s16*//*Label 8246*/ GIMT_Encode4(398461),
     /* 398287 */ /*GILLT_v4s32*//*Label 8247*/ GIMT_Encode4(398516),
     /* 398291 */ /*GILLT_v8s8*//*Label 8248*/ GIMT_Encode4(398571),
     /* 398295 */ /*GILLT_v8s16*//*Label 8249*/ GIMT_Encode4(398605),
     /* 398299 */ /*GILLT_v16s8*//*Label 8250*/ GIMT_Encode4(398660), GIMT_Encode4(0),
     /* 398307 */ /*GILLT_nxv2s1*//*Label 8251*/ GIMT_Encode4(398694),
     /* 398311 */ /*GILLT_nxv2s16*//*Label 8252*/ GIMT_Encode4(398720),
     /* 398315 */ /*GILLT_nxv2s32*//*Label 8253*/ GIMT_Encode4(398746),
     /* 398319 */ /*GILLT_nxv2s64*//*Label 8254*/ GIMT_Encode4(398772),
     /* 398323 */ /*GILLT_nxv4s1*//*Label 8255*/ GIMT_Encode4(398819),
     /* 398327 */ /*GILLT_nxv4s16*//*Label 8256*/ GIMT_Encode4(398845),
     /* 398331 */ /*GILLT_nxv4s32*//*Label 8257*/ GIMT_Encode4(398871),
     /* 398335 */ /*GILLT_nxv8s1*//*Label 8258*/ GIMT_Encode4(398918),
     /* 398339 */ /*GILLT_nxv8s16*//*Label 8259*/ GIMT_Encode4(398944),
     /* 398343 */ /*GILLT_nxv16s1*//*Label 8260*/ GIMT_Encode4(398991),
     /* 398347 */ /*GILLT_nxv16s8*//*Label 8261*/ GIMT_Encode4(399017),
     /* 398351 */ // Label 8244: @398351
     /* 398351 */ GIM_Try, /*On fail goto*//*Label 8263*/ GIMT_Encode4(398405),
     /* 398356 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 398359 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 398362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398366 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398370 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398374 */   GIM_Try, /*On fail goto*//*Label 8264*/ GIMT_Encode4(398389), // Rule ID 1881 //
     /* 398379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398382 */     // (AArch64uzp1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UZP1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 398382 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i32),
     /* 398387 */     GIR_RootConstrainSelectedInstOperands,
     /* 398388 */     // GIR_Coverage, 1881,
     /* 398388 */     GIR_Done,
     /* 398389 */   // Label 8264: @398389
     /* 398389 */   GIM_Try, /*On fail goto*//*Label 8265*/ GIMT_Encode4(398404), // Rule ID 5410 //
     /* 398394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398397 */     // (AArch64uzp1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (UZP1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 398397 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i32),
     /* 398402 */     GIR_RootConstrainSelectedInstOperands,
     /* 398403 */     // GIR_Coverage, 5410,
     /* 398403 */     GIR_Done,
     /* 398404 */   // Label 8265: @398404
     /* 398404 */   GIM_Reject,
     /* 398405 */ // Label 8263: @398405
     /* 398405 */ GIM_Reject,
     /* 398406 */ // Label 8245: @398406
     /* 398406 */ GIM_Try, /*On fail goto*//*Label 8266*/ GIMT_Encode4(398460),
     /* 398411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 398414 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 398417 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398421 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398425 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398429 */   GIM_Try, /*On fail goto*//*Label 8267*/ GIMT_Encode4(398444), // Rule ID 1883 //
     /* 398434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398437 */     // (AArch64uzp1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UZP1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 398437 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i64),
     /* 398442 */     GIR_RootConstrainSelectedInstOperands,
     /* 398443 */     // GIR_Coverage, 1883,
     /* 398443 */     GIR_Done,
     /* 398444 */   // Label 8267: @398444
     /* 398444 */   GIM_Try, /*On fail goto*//*Label 8268*/ GIMT_Encode4(398459), // Rule ID 5412 //
     /* 398449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398452 */     // (AArch64uzp1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (UZP1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 398452 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i64),
     /* 398457 */     GIR_RootConstrainSelectedInstOperands,
     /* 398458 */     // GIR_Coverage, 5412,
     /* 398458 */     GIR_Done,
     /* 398459 */   // Label 8268: @398459
     /* 398459 */   GIM_Reject,
     /* 398460 */ // Label 8266: @398460
     /* 398460 */ GIM_Reject,
     /* 398461 */ // Label 8246: @398461
     /* 398461 */ GIM_Try, /*On fail goto*//*Label 8269*/ GIMT_Encode4(398515),
     /* 398466 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 398469 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 398472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398476 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398480 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398484 */   GIM_Try, /*On fail goto*//*Label 8270*/ GIMT_Encode4(398499), // Rule ID 1879 //
     /* 398489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398492 */     // (AArch64uzp1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UZP1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 398492 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
     /* 398497 */     GIR_RootConstrainSelectedInstOperands,
     /* 398498 */     // GIR_Coverage, 1879,
     /* 398498 */     GIR_Done,
     /* 398499 */   // Label 8270: @398499
     /* 398499 */   GIM_Try, /*On fail goto*//*Label 8271*/ GIMT_Encode4(398514), // Rule ID 5408 //
     /* 398504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398507 */     // (AArch64uzp1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (UZP1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 398507 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
     /* 398512 */     GIR_RootConstrainSelectedInstOperands,
     /* 398513 */     // GIR_Coverage, 5408,
     /* 398513 */     GIR_Done,
     /* 398514 */   // Label 8271: @398514
     /* 398514 */   GIM_Reject,
     /* 398515 */ // Label 8269: @398515
     /* 398515 */ GIM_Reject,
     /* 398516 */ // Label 8247: @398516
     /* 398516 */ GIM_Try, /*On fail goto*//*Label 8272*/ GIMT_Encode4(398570),
     /* 398521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398524 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 398527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398531 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398535 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398539 */   GIM_Try, /*On fail goto*//*Label 8273*/ GIMT_Encode4(398554), // Rule ID 1882 //
     /* 398544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398547 */     // (AArch64uzp1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 398547 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /* 398552 */     GIR_RootConstrainSelectedInstOperands,
     /* 398553 */     // GIR_Coverage, 1882,
     /* 398553 */     GIR_Done,
     /* 398554 */   // Label 8273: @398554
     /* 398554 */   GIM_Try, /*On fail goto*//*Label 8274*/ GIMT_Encode4(398569), // Rule ID 5411 //
     /* 398559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398562 */     // (AArch64uzp1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (UZP1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 398562 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /* 398567 */     GIR_RootConstrainSelectedInstOperands,
     /* 398568 */     // GIR_Coverage, 5411,
     /* 398568 */     GIR_Done,
     /* 398569 */   // Label 8274: @398569
     /* 398569 */   GIM_Reject,
     /* 398570 */ // Label 8272: @398570
     /* 398570 */ GIM_Reject,
     /* 398571 */ // Label 8248: @398571
     /* 398571 */ GIM_Try, /*On fail goto*//*Label 8275*/ GIMT_Encode4(398604), // Rule ID 1877 //
     /* 398576 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 398582 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 398585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398589 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398593 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398597 */   // (AArch64uzp1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UZP1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 398597 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i8),
     /* 398602 */   GIR_RootConstrainSelectedInstOperands,
     /* 398603 */   // GIR_Coverage, 1877,
     /* 398603 */   GIR_Done,
     /* 398604 */ // Label 8275: @398604
     /* 398604 */ GIM_Reject,
     /* 398605 */ // Label 8249: @398605
     /* 398605 */ GIM_Try, /*On fail goto*//*Label 8276*/ GIMT_Encode4(398659),
     /* 398610 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398613 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 398616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398620 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398624 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398628 */   GIM_Try, /*On fail goto*//*Label 8277*/ GIMT_Encode4(398643), // Rule ID 1880 //
     /* 398633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398636 */     // (AArch64uzp1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 398636 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 398641 */     GIR_RootConstrainSelectedInstOperands,
     /* 398642 */     // GIR_Coverage, 1880,
     /* 398642 */     GIR_Done,
     /* 398643 */   // Label 8277: @398643
     /* 398643 */   GIM_Try, /*On fail goto*//*Label 8278*/ GIMT_Encode4(398658), // Rule ID 5409 //
     /* 398648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398651 */     // (AArch64uzp1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (UZP1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 398651 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 398656 */     GIR_RootConstrainSelectedInstOperands,
     /* 398657 */     // GIR_Coverage, 5409,
     /* 398657 */     GIR_Done,
     /* 398658 */   // Label 8278: @398658
     /* 398658 */   GIM_Reject,
     /* 398659 */ // Label 8276: @398659
     /* 398659 */ GIM_Reject,
     /* 398660 */ // Label 8250: @398660
     /* 398660 */ GIM_Try, /*On fail goto*//*Label 8279*/ GIMT_Encode4(398693), // Rule ID 1878 //
     /* 398665 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398668 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 398671 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 398674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398678 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398682 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398686 */   // (AArch64uzp1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 398686 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v16i8),
     /* 398691 */   GIR_RootConstrainSelectedInstOperands,
     /* 398692 */   // GIR_Coverage, 1878,
     /* 398692 */   GIR_Done,
     /* 398693 */ // Label 8279: @398693
     /* 398693 */ GIM_Reject,
     /* 398694 */ // Label 8251: @398694
     /* 398694 */ GIM_Try, /*On fail goto*//*Label 8280*/ GIMT_Encode4(398719), // Rule ID 8807 //
     /* 398699 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 398702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 398705 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 398708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 398712 */   // (AArch64uzp1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UZP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 398712 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
     /* 398717 */   GIR_RootConstrainSelectedInstOperands,
     /* 398718 */   // GIR_Coverage, 8807,
     /* 398718 */   GIR_Done,
     /* 398719 */ // Label 8280: @398719
     /* 398719 */ GIM_Reject,
     /* 398720 */ // Label 8252: @398720
     /* 398720 */ GIM_Try, /*On fail goto*//*Label 8281*/ GIMT_Encode4(398745), // Rule ID 8769 //
     /* 398725 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 398728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 398731 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 398734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 398738 */   // (AArch64uzp1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 398738 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 398743 */   GIR_RootConstrainSelectedInstOperands,
     /* 398744 */   // GIR_Coverage, 8769,
     /* 398744 */   GIR_Done,
     /* 398745 */ // Label 8281: @398745
     /* 398745 */ GIM_Reject,
     /* 398746 */ // Label 8253: @398746
     /* 398746 */ GIM_Try, /*On fail goto*//*Label 8282*/ GIMT_Encode4(398771), // Rule ID 8770 //
     /* 398751 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 398754 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 398757 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 398760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 398764 */   // (AArch64uzp1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 398764 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 398769 */   GIR_RootConstrainSelectedInstOperands,
     /* 398770 */   // GIR_Coverage, 8770,
     /* 398770 */   GIR_Done,
     /* 398771 */ // Label 8282: @398771
     /* 398771 */ GIM_Reject,
     /* 398772 */ // Label 8254: @398772
     /* 398772 */ GIM_Try, /*On fail goto*//*Label 8283*/ GIMT_Encode4(398818),
     /* 398777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 398780 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 398783 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 398787 */   GIM_Try, /*On fail goto*//*Label 8284*/ GIMT_Encode4(398802), // Rule ID 8765 //
     /* 398792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 398795 */     // (AArch64uzp1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 398795 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 398800 */     GIR_RootConstrainSelectedInstOperands,
     /* 398801 */     // GIR_Coverage, 8765,
     /* 398801 */     GIR_Done,
     /* 398802 */   // Label 8284: @398802
     /* 398802 */   GIM_Try, /*On fail goto*//*Label 8285*/ GIMT_Encode4(398817), // Rule ID 8771 //
     /* 398807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 398810 */     // (AArch64uzp1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 398810 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 398815 */     GIR_RootConstrainSelectedInstOperands,
     /* 398816 */     // GIR_Coverage, 8771,
     /* 398816 */     GIR_Done,
     /* 398817 */   // Label 8285: @398817
     /* 398817 */   GIM_Reject,
     /* 398818 */ // Label 8283: @398818
     /* 398818 */ GIM_Reject,
     /* 398819 */ // Label 8255: @398819
     /* 398819 */ GIM_Try, /*On fail goto*//*Label 8286*/ GIMT_Encode4(398844), // Rule ID 8806 //
     /* 398824 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 398827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 398830 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 398833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 398837 */   // (AArch64uzp1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UZP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 398837 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
     /* 398842 */   GIR_RootConstrainSelectedInstOperands,
     /* 398843 */   // GIR_Coverage, 8806,
     /* 398843 */   GIR_Done,
     /* 398844 */ // Label 8286: @398844
     /* 398844 */ GIM_Reject,
     /* 398845 */ // Label 8256: @398845
     /* 398845 */ GIM_Try, /*On fail goto*//*Label 8287*/ GIMT_Encode4(398870), // Rule ID 8767 //
     /* 398850 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 398853 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 398856 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 398859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 398863 */   // (AArch64uzp1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 398863 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 398868 */   GIR_RootConstrainSelectedInstOperands,
     /* 398869 */   // GIR_Coverage, 8767,
     /* 398869 */   GIR_Done,
     /* 398870 */ // Label 8287: @398870
     /* 398870 */ GIM_Reject,
     /* 398871 */ // Label 8257: @398871
     /* 398871 */ GIM_Try, /*On fail goto*//*Label 8288*/ GIMT_Encode4(398917),
     /* 398876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 398879 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 398882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 398886 */   GIM_Try, /*On fail goto*//*Label 8289*/ GIMT_Encode4(398901), // Rule ID 8764 //
     /* 398891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 398894 */     // (AArch64uzp1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 398894 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 398899 */     GIR_RootConstrainSelectedInstOperands,
     /* 398900 */     // GIR_Coverage, 8764,
     /* 398900 */     GIR_Done,
     /* 398901 */   // Label 8289: @398901
     /* 398901 */   GIM_Try, /*On fail goto*//*Label 8290*/ GIMT_Encode4(398916), // Rule ID 8768 //
     /* 398906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 398909 */     // (AArch64uzp1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 398909 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 398914 */     GIR_RootConstrainSelectedInstOperands,
     /* 398915 */     // GIR_Coverage, 8768,
     /* 398915 */     GIR_Done,
     /* 398916 */   // Label 8290: @398916
     /* 398916 */   GIM_Reject,
     /* 398917 */ // Label 8288: @398917
     /* 398917 */ GIM_Reject,
     /* 398918 */ // Label 8258: @398918
     /* 398918 */ GIM_Try, /*On fail goto*//*Label 8291*/ GIMT_Encode4(398943), // Rule ID 8805 //
     /* 398923 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 398926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 398929 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 398932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 398936 */   // (AArch64uzp1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UZP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 398936 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
     /* 398941 */   GIR_RootConstrainSelectedInstOperands,
     /* 398942 */   // GIR_Coverage, 8805,
     /* 398942 */   GIR_Done,
     /* 398943 */ // Label 8291: @398943
     /* 398943 */ GIM_Reject,
     /* 398944 */ // Label 8259: @398944
     /* 398944 */ GIM_Try, /*On fail goto*//*Label 8292*/ GIMT_Encode4(398990),
     /* 398949 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 398952 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 398955 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 398959 */   GIM_Try, /*On fail goto*//*Label 8293*/ GIMT_Encode4(398974), // Rule ID 8763 //
     /* 398964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 398967 */     // (AArch64uzp1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 398967 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
     /* 398972 */     GIR_RootConstrainSelectedInstOperands,
     /* 398973 */     // GIR_Coverage, 8763,
     /* 398973 */     GIR_Done,
     /* 398974 */   // Label 8293: @398974
     /* 398974 */   GIM_Try, /*On fail goto*//*Label 8294*/ GIMT_Encode4(398989), // Rule ID 8766 //
     /* 398979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 398982 */     // (AArch64uzp1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 398982 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
     /* 398987 */     GIR_RootConstrainSelectedInstOperands,
     /* 398988 */     // GIR_Coverage, 8766,
     /* 398988 */     GIR_Done,
     /* 398989 */   // Label 8294: @398989
     /* 398989 */   GIM_Reject,
     /* 398990 */ // Label 8292: @398990
     /* 398990 */ GIM_Reject,
     /* 398991 */ // Label 8260: @398991
     /* 398991 */ GIM_Try, /*On fail goto*//*Label 8295*/ GIMT_Encode4(399016), // Rule ID 2397 //
     /* 398996 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 398999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 399002 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 399005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 399009 */   // (AArch64uzp1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 399009 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_B),
     /* 399014 */   GIR_RootConstrainSelectedInstOperands,
     /* 399015 */   // GIR_Coverage, 2397,
     /* 399015 */   GIR_Done,
     /* 399016 */ // Label 8295: @399016
     /* 399016 */ GIM_Reject,
     /* 399017 */ // Label 8261: @399017
     /* 399017 */ GIM_Try, /*On fail goto*//*Label 8296*/ GIMT_Encode4(399042), // Rule ID 8762 //
     /* 399022 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 399025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 399028 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 399031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 399035 */   // (AArch64uzp1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 399035 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_B),
     /* 399040 */   GIR_RootConstrainSelectedInstOperands,
     /* 399041 */   // GIR_Coverage, 8762,
     /* 399041 */   GIR_Done,
     /* 399042 */ // Label 8296: @399042
     /* 399042 */ GIM_Reject,
     /* 399043 */ // Label 8262: @399043
     /* 399043 */ GIM_Reject,
     /* 399044 */ // Label 149: @399044
     /* 399044 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8315*/ GIMT_Encode4(399823),
     /* 399055 */ /*GILLT_v2s32*//*Label 8297*/ GIMT_Encode4(399131),
     /* 399059 */ /*GILLT_v2s64*//*Label 8298*/ GIMT_Encode4(399186),
     /* 399063 */ /*GILLT_v4s16*//*Label 8299*/ GIMT_Encode4(399241),
     /* 399067 */ /*GILLT_v4s32*//*Label 8300*/ GIMT_Encode4(399296),
     /* 399071 */ /*GILLT_v8s8*//*Label 8301*/ GIMT_Encode4(399351),
     /* 399075 */ /*GILLT_v8s16*//*Label 8302*/ GIMT_Encode4(399385),
     /* 399079 */ /*GILLT_v16s8*//*Label 8303*/ GIMT_Encode4(399440), GIMT_Encode4(0),
     /* 399087 */ /*GILLT_nxv2s1*//*Label 8304*/ GIMT_Encode4(399474),
     /* 399091 */ /*GILLT_nxv2s16*//*Label 8305*/ GIMT_Encode4(399500),
     /* 399095 */ /*GILLT_nxv2s32*//*Label 8306*/ GIMT_Encode4(399526),
     /* 399099 */ /*GILLT_nxv2s64*//*Label 8307*/ GIMT_Encode4(399552),
     /* 399103 */ /*GILLT_nxv4s1*//*Label 8308*/ GIMT_Encode4(399599),
     /* 399107 */ /*GILLT_nxv4s16*//*Label 8309*/ GIMT_Encode4(399625),
     /* 399111 */ /*GILLT_nxv4s32*//*Label 8310*/ GIMT_Encode4(399651),
     /* 399115 */ /*GILLT_nxv8s1*//*Label 8311*/ GIMT_Encode4(399698),
     /* 399119 */ /*GILLT_nxv8s16*//*Label 8312*/ GIMT_Encode4(399724),
     /* 399123 */ /*GILLT_nxv16s1*//*Label 8313*/ GIMT_Encode4(399771),
     /* 399127 */ /*GILLT_nxv16s8*//*Label 8314*/ GIMT_Encode4(399797),
     /* 399131 */ // Label 8297: @399131
     /* 399131 */ GIM_Try, /*On fail goto*//*Label 8316*/ GIMT_Encode4(399185),
     /* 399136 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 399139 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 399142 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399146 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399150 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399154 */   GIM_Try, /*On fail goto*//*Label 8317*/ GIMT_Encode4(399169), // Rule ID 1888 //
     /* 399159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399162 */     // (AArch64uzp2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UZP2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 399162 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i32),
     /* 399167 */     GIR_RootConstrainSelectedInstOperands,
     /* 399168 */     // GIR_Coverage, 1888,
     /* 399168 */     GIR_Done,
     /* 399169 */   // Label 8317: @399169
     /* 399169 */   GIM_Try, /*On fail goto*//*Label 8318*/ GIMT_Encode4(399184), // Rule ID 5415 //
     /* 399174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399177 */     // (AArch64uzp2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (UZP2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 399177 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i32),
     /* 399182 */     GIR_RootConstrainSelectedInstOperands,
     /* 399183 */     // GIR_Coverage, 5415,
     /* 399183 */     GIR_Done,
     /* 399184 */   // Label 8318: @399184
     /* 399184 */   GIM_Reject,
     /* 399185 */ // Label 8316: @399185
     /* 399185 */ GIM_Reject,
     /* 399186 */ // Label 8298: @399186
     /* 399186 */ GIM_Try, /*On fail goto*//*Label 8319*/ GIMT_Encode4(399240),
     /* 399191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 399194 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 399197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399201 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399205 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399209 */   GIM_Try, /*On fail goto*//*Label 8320*/ GIMT_Encode4(399224), // Rule ID 1890 //
     /* 399214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399217 */     // (AArch64uzp2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UZP2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 399217 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i64),
     /* 399222 */     GIR_RootConstrainSelectedInstOperands,
     /* 399223 */     // GIR_Coverage, 1890,
     /* 399223 */     GIR_Done,
     /* 399224 */   // Label 8320: @399224
     /* 399224 */   GIM_Try, /*On fail goto*//*Label 8321*/ GIMT_Encode4(399239), // Rule ID 5417 //
     /* 399229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399232 */     // (AArch64uzp2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (UZP2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 399232 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i64),
     /* 399237 */     GIR_RootConstrainSelectedInstOperands,
     /* 399238 */     // GIR_Coverage, 5417,
     /* 399238 */     GIR_Done,
     /* 399239 */   // Label 8321: @399239
     /* 399239 */   GIM_Reject,
     /* 399240 */ // Label 8319: @399240
     /* 399240 */ GIM_Reject,
     /* 399241 */ // Label 8299: @399241
     /* 399241 */ GIM_Try, /*On fail goto*//*Label 8322*/ GIMT_Encode4(399295),
     /* 399246 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 399249 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 399252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399256 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399260 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399264 */   GIM_Try, /*On fail goto*//*Label 8323*/ GIMT_Encode4(399279), // Rule ID 1886 //
     /* 399269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399272 */     // (AArch64uzp2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UZP2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 399272 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i16),
     /* 399277 */     GIR_RootConstrainSelectedInstOperands,
     /* 399278 */     // GIR_Coverage, 1886,
     /* 399278 */     GIR_Done,
     /* 399279 */   // Label 8323: @399279
     /* 399279 */   GIM_Try, /*On fail goto*//*Label 8324*/ GIMT_Encode4(399294), // Rule ID 5413 //
     /* 399284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399287 */     // (AArch64uzp2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (UZP2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 399287 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i16),
     /* 399292 */     GIR_RootConstrainSelectedInstOperands,
     /* 399293 */     // GIR_Coverage, 5413,
     /* 399293 */     GIR_Done,
     /* 399294 */   // Label 8324: @399294
     /* 399294 */   GIM_Reject,
     /* 399295 */ // Label 8322: @399295
     /* 399295 */ GIM_Reject,
     /* 399296 */ // Label 8300: @399296
     /* 399296 */ GIM_Try, /*On fail goto*//*Label 8325*/ GIMT_Encode4(399350),
     /* 399301 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399304 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 399307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399311 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399315 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399319 */   GIM_Try, /*On fail goto*//*Label 8326*/ GIMT_Encode4(399334), // Rule ID 1889 //
     /* 399324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399327 */     // (AArch64uzp2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 399327 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 399332 */     GIR_RootConstrainSelectedInstOperands,
     /* 399333 */     // GIR_Coverage, 1889,
     /* 399333 */     GIR_Done,
     /* 399334 */   // Label 8326: @399334
     /* 399334 */   GIM_Try, /*On fail goto*//*Label 8327*/ GIMT_Encode4(399349), // Rule ID 5416 //
     /* 399339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399342 */     // (AArch64uzp2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 399342 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 399347 */     GIR_RootConstrainSelectedInstOperands,
     /* 399348 */     // GIR_Coverage, 5416,
     /* 399348 */     GIR_Done,
     /* 399349 */   // Label 8327: @399349
     /* 399349 */   GIM_Reject,
     /* 399350 */ // Label 8325: @399350
     /* 399350 */ GIM_Reject,
     /* 399351 */ // Label 8301: @399351
     /* 399351 */ GIM_Try, /*On fail goto*//*Label 8328*/ GIMT_Encode4(399384), // Rule ID 1884 //
     /* 399356 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399359 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 399362 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 399365 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399369 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399373 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399377 */   // (AArch64uzp2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UZP2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 399377 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i8),
     /* 399382 */   GIR_RootConstrainSelectedInstOperands,
     /* 399383 */   // GIR_Coverage, 1884,
     /* 399383 */   GIR_Done,
     /* 399384 */ // Label 8328: @399384
     /* 399384 */ GIM_Reject,
     /* 399385 */ // Label 8302: @399385
     /* 399385 */ GIM_Try, /*On fail goto*//*Label 8329*/ GIMT_Encode4(399439),
     /* 399390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 399393 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 399396 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399400 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399404 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399408 */   GIM_Try, /*On fail goto*//*Label 8330*/ GIMT_Encode4(399423), // Rule ID 1887 //
     /* 399413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399416 */     // (AArch64uzp2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 399416 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 399421 */     GIR_RootConstrainSelectedInstOperands,
     /* 399422 */     // GIR_Coverage, 1887,
     /* 399422 */     GIR_Done,
     /* 399423 */   // Label 8330: @399423
     /* 399423 */   GIM_Try, /*On fail goto*//*Label 8331*/ GIMT_Encode4(399438), // Rule ID 5414 //
     /* 399428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399431 */     // (AArch64uzp2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 399431 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 399436 */     GIR_RootConstrainSelectedInstOperands,
     /* 399437 */     // GIR_Coverage, 5414,
     /* 399437 */     GIR_Done,
     /* 399438 */   // Label 8331: @399438
     /* 399438 */   GIM_Reject,
     /* 399439 */ // Label 8329: @399439
     /* 399439 */ GIM_Reject,
     /* 399440 */ // Label 8303: @399440
     /* 399440 */ GIM_Try, /*On fail goto*//*Label 8332*/ GIMT_Encode4(399473), // Rule ID 1885 //
     /* 399445 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399448 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 399451 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 399454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399458 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399462 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399466 */   // (AArch64uzp2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 399466 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 399471 */   GIR_RootConstrainSelectedInstOperands,
     /* 399472 */   // GIR_Coverage, 1885,
     /* 399472 */   GIR_Done,
     /* 399473 */ // Label 8332: @399473
     /* 399473 */ GIM_Reject,
     /* 399474 */ // Label 8304: @399474
     /* 399474 */ GIM_Try, /*On fail goto*//*Label 8333*/ GIMT_Encode4(399499), // Rule ID 8810 //
     /* 399479 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 399482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 399485 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 399488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 399492 */   // (AArch64uzp2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UZP2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 399492 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_D),
     /* 399497 */   GIR_RootConstrainSelectedInstOperands,
     /* 399498 */   // GIR_Coverage, 8810,
     /* 399498 */   GIR_Done,
     /* 399499 */ // Label 8333: @399499
     /* 399499 */ GIM_Reject,
     /* 399500 */ // Label 8305: @399500
     /* 399500 */ GIM_Try, /*On fail goto*//*Label 8334*/ GIMT_Encode4(399525), // Rule ID 8779 //
     /* 399505 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 399508 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 399511 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 399514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 399518 */   // (AArch64uzp2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 399518 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 399523 */   GIR_RootConstrainSelectedInstOperands,
     /* 399524 */   // GIR_Coverage, 8779,
     /* 399524 */   GIR_Done,
     /* 399525 */ // Label 8334: @399525
     /* 399525 */ GIM_Reject,
     /* 399526 */ // Label 8306: @399526
     /* 399526 */ GIM_Try, /*On fail goto*//*Label 8335*/ GIMT_Encode4(399551), // Rule ID 8780 //
     /* 399531 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 399534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 399537 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 399540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 399544 */   // (AArch64uzp2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 399544 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 399549 */   GIR_RootConstrainSelectedInstOperands,
     /* 399550 */   // GIR_Coverage, 8780,
     /* 399550 */   GIR_Done,
     /* 399551 */ // Label 8335: @399551
     /* 399551 */ GIM_Reject,
     /* 399552 */ // Label 8307: @399552
     /* 399552 */ GIM_Try, /*On fail goto*//*Label 8336*/ GIMT_Encode4(399598),
     /* 399557 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 399560 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 399563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 399567 */   GIM_Try, /*On fail goto*//*Label 8337*/ GIMT_Encode4(399582), // Rule ID 8775 //
     /* 399572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 399575 */     // (AArch64uzp2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 399575 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 399580 */     GIR_RootConstrainSelectedInstOperands,
     /* 399581 */     // GIR_Coverage, 8775,
     /* 399581 */     GIR_Done,
     /* 399582 */   // Label 8337: @399582
     /* 399582 */   GIM_Try, /*On fail goto*//*Label 8338*/ GIMT_Encode4(399597), // Rule ID 8781 //
     /* 399587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 399590 */     // (AArch64uzp2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 399590 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 399595 */     GIR_RootConstrainSelectedInstOperands,
     /* 399596 */     // GIR_Coverage, 8781,
     /* 399596 */     GIR_Done,
     /* 399597 */   // Label 8338: @399597
     /* 399597 */   GIM_Reject,
     /* 399598 */ // Label 8336: @399598
     /* 399598 */ GIM_Reject,
     /* 399599 */ // Label 8308: @399599
     /* 399599 */ GIM_Try, /*On fail goto*//*Label 8339*/ GIMT_Encode4(399624), // Rule ID 8809 //
     /* 399604 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 399607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 399610 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 399613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 399617 */   // (AArch64uzp2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UZP2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 399617 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_S),
     /* 399622 */   GIR_RootConstrainSelectedInstOperands,
     /* 399623 */   // GIR_Coverage, 8809,
     /* 399623 */   GIR_Done,
     /* 399624 */ // Label 8339: @399624
     /* 399624 */ GIM_Reject,
     /* 399625 */ // Label 8309: @399625
     /* 399625 */ GIM_Try, /*On fail goto*//*Label 8340*/ GIMT_Encode4(399650), // Rule ID 8777 //
     /* 399630 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 399633 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 399636 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 399639 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 399643 */   // (AArch64uzp2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 399643 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
     /* 399648 */   GIR_RootConstrainSelectedInstOperands,
     /* 399649 */   // GIR_Coverage, 8777,
     /* 399649 */   GIR_Done,
     /* 399650 */ // Label 8340: @399650
     /* 399650 */ GIM_Reject,
     /* 399651 */ // Label 8310: @399651
     /* 399651 */ GIM_Try, /*On fail goto*//*Label 8341*/ GIMT_Encode4(399697),
     /* 399656 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 399659 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 399662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 399666 */   GIM_Try, /*On fail goto*//*Label 8342*/ GIMT_Encode4(399681), // Rule ID 8774 //
     /* 399671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 399674 */     // (AArch64uzp2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 399674 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
     /* 399679 */     GIR_RootConstrainSelectedInstOperands,
     /* 399680 */     // GIR_Coverage, 8774,
     /* 399680 */     GIR_Done,
     /* 399681 */   // Label 8342: @399681
     /* 399681 */   GIM_Try, /*On fail goto*//*Label 8343*/ GIMT_Encode4(399696), // Rule ID 8778 //
     /* 399686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 399689 */     // (AArch64uzp2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 399689 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
     /* 399694 */     GIR_RootConstrainSelectedInstOperands,
     /* 399695 */     // GIR_Coverage, 8778,
     /* 399695 */     GIR_Done,
     /* 399696 */   // Label 8343: @399696
     /* 399696 */   GIM_Reject,
     /* 399697 */ // Label 8341: @399697
     /* 399697 */ GIM_Reject,
     /* 399698 */ // Label 8311: @399698
     /* 399698 */ GIM_Try, /*On fail goto*//*Label 8344*/ GIMT_Encode4(399723), // Rule ID 8808 //
     /* 399703 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 399706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 399709 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 399712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 399716 */   // (AArch64uzp2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UZP2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 399716 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_H),
     /* 399721 */   GIR_RootConstrainSelectedInstOperands,
     /* 399722 */   // GIR_Coverage, 8808,
     /* 399722 */   GIR_Done,
     /* 399723 */ // Label 8344: @399723
     /* 399723 */ GIM_Reject,
     /* 399724 */ // Label 8312: @399724
     /* 399724 */ GIM_Try, /*On fail goto*//*Label 8345*/ GIMT_Encode4(399770),
     /* 399729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 399732 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 399735 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 399739 */   GIM_Try, /*On fail goto*//*Label 8346*/ GIMT_Encode4(399754), // Rule ID 8773 //
     /* 399744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 399747 */     // (AArch64uzp2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 399747 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_H),
     /* 399752 */     GIR_RootConstrainSelectedInstOperands,
     /* 399753 */     // GIR_Coverage, 8773,
     /* 399753 */     GIR_Done,
     /* 399754 */   // Label 8346: @399754
     /* 399754 */   GIM_Try, /*On fail goto*//*Label 8347*/ GIMT_Encode4(399769), // Rule ID 8776 //
     /* 399759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 399762 */     // (AArch64uzp2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 399762 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_H),
     /* 399767 */     GIR_RootConstrainSelectedInstOperands,
     /* 399768 */     // GIR_Coverage, 8776,
     /* 399768 */     GIR_Done,
     /* 399769 */   // Label 8347: @399769
     /* 399769 */   GIM_Reject,
     /* 399770 */ // Label 8345: @399770
     /* 399770 */ GIM_Reject,
     /* 399771 */ // Label 8313: @399771
     /* 399771 */ GIM_Try, /*On fail goto*//*Label 8348*/ GIMT_Encode4(399796), // Rule ID 2401 //
     /* 399776 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 399779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 399782 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 399785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 399789 */   // (AArch64uzp2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 399789 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_B),
     /* 399794 */   GIR_RootConstrainSelectedInstOperands,
     /* 399795 */   // GIR_Coverage, 2401,
     /* 399795 */   GIR_Done,
     /* 399796 */ // Label 8348: @399796
     /* 399796 */ GIM_Reject,
     /* 399797 */ // Label 8314: @399797
     /* 399797 */ GIM_Try, /*On fail goto*//*Label 8349*/ GIMT_Encode4(399822), // Rule ID 8772 //
     /* 399802 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 399805 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 399808 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 399811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 399815 */   // (AArch64uzp2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 399815 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_B),
     /* 399820 */   GIR_RootConstrainSelectedInstOperands,
     /* 399821 */   // GIR_Coverage, 8772,
     /* 399821 */   GIR_Done,
     /* 399822 */ // Label 8349: @399822
     /* 399822 */ GIM_Reject,
     /* 399823 */ // Label 8315: @399823
     /* 399823 */ GIM_Reject,
     /* 399824 */ // Label 150: @399824
     /* 399824 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 8358*/ GIMT_Encode4(400521),
     /* 399835 */ /*GILLT_s64*//*Label 8350*/ GIMT_Encode4(399871), GIMT_Encode4(0),
     /* 399843 */ /*GILLT_v2s32*//*Label 8351*/ GIMT_Encode4(399982),
     /* 399847 */ /*GILLT_v2s64*//*Label 8352*/ GIMT_Encode4(400059),
     /* 399851 */ /*GILLT_v4s16*//*Label 8353*/ GIMT_Encode4(400136),
     /* 399855 */ /*GILLT_v4s32*//*Label 8354*/ GIMT_Encode4(400213),
     /* 399859 */ /*GILLT_v8s8*//*Label 8355*/ GIMT_Encode4(400290),
     /* 399863 */ /*GILLT_v8s16*//*Label 8356*/ GIMT_Encode4(400367),
     /* 399867 */ /*GILLT_v16s8*//*Label 8357*/ GIMT_Encode4(400444),
     /* 399871 */ // Label 8350: @399871
     /* 399871 */ GIM_Try, /*On fail goto*//*Label 8359*/ GIMT_Encode4(399981),
     /* 399876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 399879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399883 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399887 */   GIM_Try, /*On fail goto*//*Label 8360*/ GIMT_Encode4(399912), // Rule ID 5187 //
     /* 399892 */     // MIs[0] Operand 2
     /* 399892 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(63),
     /* 399903 */     // (AArch64vashr:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, 63:{ *:[i32] })  =>  (CMLTv1i64rz:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn)
     /* 399903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv1i64rz),
     /* 399906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399908 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399910 */     GIR_RootConstrainSelectedInstOperands,
     /* 399911 */     // GIR_Coverage, 5187,
     /* 399911 */     GIR_EraseRootFromParent_Done,
     /* 399912 */   // Label 8360: @399912
     /* 399912 */   GIM_Try, /*On fail goto*//*Label 8361*/ GIMT_Encode4(399946), // Rule ID 2111 //
     /* 399917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399920 */     // MIs[0] imm
     /* 399920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 399924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399928 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 399932 */     // MIs[1] Operand 1
     /* 399932 */     // No operand predicates
     /* 399932 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399934 */     // (AArch64vashr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRd:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 399934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRd),
     /* 399937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399939 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399941 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 399944 */     GIR_RootConstrainSelectedInstOperands,
     /* 399945 */     // GIR_Coverage, 2111,
     /* 399945 */     GIR_EraseRootFromParent_Done,
     /* 399946 */   // Label 8361: @399946
     /* 399946 */   GIM_Try, /*On fail goto*//*Label 8362*/ GIMT_Encode4(399980), // Rule ID 6196 //
     /* 399951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399954 */     // MIs[0] imm
     /* 399954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 399958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399962 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 399966 */     // MIs[1] Operand 1
     /* 399966 */     // No operand predicates
     /* 399966 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399968 */     // (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 399968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRd),
     /* 399971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399973 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399975 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 399978 */     GIR_RootConstrainSelectedInstOperands,
     /* 399979 */     // GIR_Coverage, 6196,
     /* 399979 */     GIR_EraseRootFromParent_Done,
     /* 399980 */   // Label 8362: @399980
     /* 399980 */   GIM_Reject,
     /* 399981 */ // Label 8359: @399981
     /* 399981 */ GIM_Reject,
     /* 399982 */ // Label 8351: @399982
     /* 399982 */ GIM_Try, /*On fail goto*//*Label 8363*/ GIMT_Encode4(400058),
     /* 399987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 399990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399994 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399998 */   GIM_Try, /*On fail goto*//*Label 8364*/ GIMT_Encode4(400023), // Rule ID 4832 //
     /* 400003 */     // MIs[0] Operand 2
     /* 400003 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(31),
     /* 400014 */     // (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, 31:{ *:[i32] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 400014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 400017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400019 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400021 */     GIR_RootConstrainSelectedInstOperands,
     /* 400022 */     // GIR_Coverage, 4832,
     /* 400022 */     GIR_EraseRootFromParent_Done,
     /* 400023 */   // Label 8364: @400023
     /* 400023 */   GIM_Try, /*On fail goto*//*Label 8365*/ GIMT_Encode4(400057), // Rule ID 2218 //
     /* 400028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400031 */     // MIs[0] imm
     /* 400031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400039 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 400043 */     // MIs[1] Operand 1
     /* 400043 */     // No operand predicates
     /* 400043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400045 */     // (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SSHRv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 400045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv2i32_shift),
     /* 400048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400050 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400052 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 400055 */     GIR_RootConstrainSelectedInstOperands,
     /* 400056 */     // GIR_Coverage, 2218,
     /* 400056 */     GIR_EraseRootFromParent_Done,
     /* 400057 */   // Label 8365: @400057
     /* 400057 */   GIM_Reject,
     /* 400058 */ // Label 8363: @400058
     /* 400058 */ GIM_Reject,
     /* 400059 */ // Label 8352: @400059
     /* 400059 */ GIM_Try, /*On fail goto*//*Label 8366*/ GIMT_Encode4(400135),
     /* 400064 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 400067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400071 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400075 */   GIM_Try, /*On fail goto*//*Label 8367*/ GIMT_Encode4(400100), // Rule ID 4836 //
     /* 400080 */     // MIs[0] Operand 2
     /* 400080 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(63),
     /* 400091 */     // (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, 63:{ *:[i32] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 400091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 400094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400096 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400098 */     GIR_RootConstrainSelectedInstOperands,
     /* 400099 */     // GIR_Coverage, 4836,
     /* 400099 */     GIR_EraseRootFromParent_Done,
     /* 400100 */   // Label 8367: @400100
     /* 400100 */   GIM_Try, /*On fail goto*//*Label 8368*/ GIMT_Encode4(400134), // Rule ID 2220 //
     /* 400105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400108 */     // MIs[0] imm
     /* 400108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400116 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 400120 */     // MIs[1] Operand 1
     /* 400120 */     // No operand predicates
     /* 400120 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400122 */     // (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 400122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv2i64_shift),
     /* 400125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400127 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400129 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 400132 */     GIR_RootConstrainSelectedInstOperands,
     /* 400133 */     // GIR_Coverage, 2220,
     /* 400133 */     GIR_EraseRootFromParent_Done,
     /* 400134 */   // Label 8368: @400134
     /* 400134 */   GIM_Reject,
     /* 400135 */ // Label 8366: @400135
     /* 400135 */ GIM_Reject,
     /* 400136 */ // Label 8353: @400136
     /* 400136 */ GIM_Try, /*On fail goto*//*Label 8369*/ GIMT_Encode4(400212),
     /* 400141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 400144 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400148 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400152 */   GIM_Try, /*On fail goto*//*Label 8370*/ GIMT_Encode4(400177), // Rule ID 4831 //
     /* 400157 */     // MIs[0] Operand 2
     /* 400157 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
     /* 400168 */     // (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, 15:{ *:[i32] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 400168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 400171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400173 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400175 */     GIR_RootConstrainSelectedInstOperands,
     /* 400176 */     // GIR_Coverage, 4831,
     /* 400176 */     GIR_EraseRootFromParent_Done,
     /* 400177 */   // Label 8370: @400177
     /* 400177 */   GIM_Try, /*On fail goto*//*Label 8371*/ GIMT_Encode4(400211), // Rule ID 2216 //
     /* 400182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400185 */     // MIs[0] imm
     /* 400185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400193 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 400197 */     // MIs[1] Operand 1
     /* 400197 */     // No operand predicates
     /* 400197 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400199 */     // (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SSHRv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 400199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv4i16_shift),
     /* 400202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400204 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400206 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 400209 */     GIR_RootConstrainSelectedInstOperands,
     /* 400210 */     // GIR_Coverage, 2216,
     /* 400210 */     GIR_EraseRootFromParent_Done,
     /* 400211 */   // Label 8371: @400211
     /* 400211 */   GIM_Reject,
     /* 400212 */ // Label 8369: @400212
     /* 400212 */ GIM_Reject,
     /* 400213 */ // Label 8354: @400213
     /* 400213 */ GIM_Try, /*On fail goto*//*Label 8372*/ GIMT_Encode4(400289),
     /* 400218 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 400221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400225 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400229 */   GIM_Try, /*On fail goto*//*Label 8373*/ GIMT_Encode4(400254), // Rule ID 4835 //
     /* 400234 */     // MIs[0] Operand 2
     /* 400234 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(31),
     /* 400245 */     // (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, 31:{ *:[i32] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 400245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 400248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400250 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400252 */     GIR_RootConstrainSelectedInstOperands,
     /* 400253 */     // GIR_Coverage, 4835,
     /* 400253 */     GIR_EraseRootFromParent_Done,
     /* 400254 */   // Label 8373: @400254
     /* 400254 */   GIM_Try, /*On fail goto*//*Label 8374*/ GIMT_Encode4(400288), // Rule ID 2219 //
     /* 400259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400262 */     // MIs[0] imm
     /* 400262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400270 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 400274 */     // MIs[1] Operand 1
     /* 400274 */     // No operand predicates
     /* 400274 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400276 */     // (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SSHRv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 400276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv4i32_shift),
     /* 400279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400281 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400283 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 400286 */     GIR_RootConstrainSelectedInstOperands,
     /* 400287 */     // GIR_Coverage, 2219,
     /* 400287 */     GIR_EraseRootFromParent_Done,
     /* 400288 */   // Label 8374: @400288
     /* 400288 */   GIM_Reject,
     /* 400289 */ // Label 8372: @400289
     /* 400289 */ GIM_Reject,
     /* 400290 */ // Label 8355: @400290
     /* 400290 */ GIM_Try, /*On fail goto*//*Label 8375*/ GIMT_Encode4(400366),
     /* 400295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 400298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400302 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400306 */   GIM_Try, /*On fail goto*//*Label 8376*/ GIMT_Encode4(400331), // Rule ID 4830 //
     /* 400311 */     // MIs[0] Operand 2
     /* 400311 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 400322 */     // (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, 7:{ *:[i32] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 400322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 400325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400327 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400329 */     GIR_RootConstrainSelectedInstOperands,
     /* 400330 */     // GIR_Coverage, 4830,
     /* 400330 */     GIR_EraseRootFromParent_Done,
     /* 400331 */   // Label 8376: @400331
     /* 400331 */   GIM_Try, /*On fail goto*//*Label 8377*/ GIMT_Encode4(400365), // Rule ID 2214 //
     /* 400336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400339 */     // MIs[0] imm
     /* 400339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400347 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 400351 */     // MIs[1] Operand 1
     /* 400351 */     // No operand predicates
     /* 400351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400353 */     // (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (SSHRv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 400353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv8i8_shift),
     /* 400356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400358 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400360 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 400363 */     GIR_RootConstrainSelectedInstOperands,
     /* 400364 */     // GIR_Coverage, 2214,
     /* 400364 */     GIR_EraseRootFromParent_Done,
     /* 400365 */   // Label 8377: @400365
     /* 400365 */   GIM_Reject,
     /* 400366 */ // Label 8375: @400366
     /* 400366 */ GIM_Reject,
     /* 400367 */ // Label 8356: @400367
     /* 400367 */ GIM_Try, /*On fail goto*//*Label 8378*/ GIMT_Encode4(400443),
     /* 400372 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400379 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400383 */   GIM_Try, /*On fail goto*//*Label 8379*/ GIMT_Encode4(400408), // Rule ID 4834 //
     /* 400388 */     // MIs[0] Operand 2
     /* 400388 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
     /* 400399 */     // (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, 15:{ *:[i32] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 400399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 400402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400404 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400406 */     GIR_RootConstrainSelectedInstOperands,
     /* 400407 */     // GIR_Coverage, 4834,
     /* 400407 */     GIR_EraseRootFromParent_Done,
     /* 400408 */   // Label 8379: @400408
     /* 400408 */   GIM_Try, /*On fail goto*//*Label 8380*/ GIMT_Encode4(400442), // Rule ID 2217 //
     /* 400413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400416 */     // MIs[0] imm
     /* 400416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400424 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 400428 */     // MIs[1] Operand 1
     /* 400428 */     // No operand predicates
     /* 400428 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400430 */     // (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SSHRv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 400430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv8i16_shift),
     /* 400433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400435 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400437 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 400440 */     GIR_RootConstrainSelectedInstOperands,
     /* 400441 */     // GIR_Coverage, 2217,
     /* 400441 */     GIR_EraseRootFromParent_Done,
     /* 400442 */   // Label 8380: @400442
     /* 400442 */   GIM_Reject,
     /* 400443 */ // Label 8378: @400443
     /* 400443 */ GIM_Reject,
     /* 400444 */ // Label 8357: @400444
     /* 400444 */ GIM_Try, /*On fail goto*//*Label 8381*/ GIMT_Encode4(400520),
     /* 400449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 400452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400456 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400460 */   GIM_Try, /*On fail goto*//*Label 8382*/ GIMT_Encode4(400485), // Rule ID 4833 //
     /* 400465 */     // MIs[0] Operand 2
     /* 400465 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 400476 */     // (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, 7:{ *:[i32] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 400476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 400479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400481 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400483 */     GIR_RootConstrainSelectedInstOperands,
     /* 400484 */     // GIR_Coverage, 4833,
     /* 400484 */     GIR_EraseRootFromParent_Done,
     /* 400485 */   // Label 8382: @400485
     /* 400485 */   GIM_Try, /*On fail goto*//*Label 8383*/ GIMT_Encode4(400519), // Rule ID 2215 //
     /* 400490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400493 */     // MIs[0] imm
     /* 400493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400501 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 400505 */     // MIs[1] Operand 1
     /* 400505 */     // No operand predicates
     /* 400505 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400507 */     // (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (SSHRv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 400507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv16i8_shift),
     /* 400510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400512 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400514 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 400517 */     GIR_RootConstrainSelectedInstOperands,
     /* 400518 */     // GIR_Coverage, 2215,
     /* 400518 */     GIR_EraseRootFromParent_Done,
     /* 400519 */   // Label 8383: @400519
     /* 400519 */   GIM_Reject,
     /* 400520 */ // Label 8381: @400520
     /* 400520 */ GIM_Reject,
     /* 400521 */ // Label 8358: @400521
     /* 400521 */ GIM_Reject,
     /* 400522 */ // Label 151: @400522
     /* 400522 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 8392*/ GIMT_Encode4(400977),
     /* 400533 */ /*GILLT_s64*//*Label 8384*/ GIMT_Encode4(400569), GIMT_Encode4(0),
     /* 400541 */ /*GILLT_v2s32*//*Label 8385*/ GIMT_Encode4(400655),
     /* 400545 */ /*GILLT_v2s64*//*Label 8386*/ GIMT_Encode4(400701),
     /* 400549 */ /*GILLT_v4s16*//*Label 8387*/ GIMT_Encode4(400747),
     /* 400553 */ /*GILLT_v4s32*//*Label 8388*/ GIMT_Encode4(400793),
     /* 400557 */ /*GILLT_v8s8*//*Label 8389*/ GIMT_Encode4(400839),
     /* 400561 */ /*GILLT_v8s16*//*Label 8390*/ GIMT_Encode4(400885),
     /* 400565 */ /*GILLT_v16s8*//*Label 8391*/ GIMT_Encode4(400931),
     /* 400569 */ // Label 8384: @400569
     /* 400569 */ GIM_Try, /*On fail goto*//*Label 8393*/ GIMT_Encode4(400654),
     /* 400574 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 400577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400581 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400585 */   GIM_Try, /*On fail goto*//*Label 8394*/ GIMT_Encode4(400619), // Rule ID 2120 //
     /* 400590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400593 */     // MIs[0] imm
     /* 400593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400601 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 400605 */     // MIs[1] Operand 1
     /* 400605 */     // No operand predicates
     /* 400605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400607 */     // (AArch64vlshr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRd:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 400607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRd),
     /* 400610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400612 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400614 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 400617 */     GIR_RootConstrainSelectedInstOperands,
     /* 400618 */     // GIR_Coverage, 2120,
     /* 400618 */     GIR_EraseRootFromParent_Done,
     /* 400619 */   // Label 8394: @400619
     /* 400619 */   GIM_Try, /*On fail goto*//*Label 8395*/ GIMT_Encode4(400653), // Rule ID 6202 //
     /* 400624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400627 */     // MIs[0] imm
     /* 400627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400635 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 400639 */     // MIs[1] Operand 1
     /* 400639 */     // No operand predicates
     /* 400639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400641 */     // (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 400641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRd),
     /* 400644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400646 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400648 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 400651 */     GIR_RootConstrainSelectedInstOperands,
     /* 400652 */     // GIR_Coverage, 6202,
     /* 400652 */     GIR_EraseRootFromParent_Done,
     /* 400653 */   // Label 8395: @400653
     /* 400653 */   GIM_Reject,
     /* 400654 */ // Label 8393: @400654
     /* 400654 */ GIM_Reject,
     /* 400655 */ // Label 8385: @400655
     /* 400655 */ GIM_Try, /*On fail goto*//*Label 8396*/ GIMT_Encode4(400700), // Rule ID 2277 //
     /* 400660 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 400666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400670 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400674 */   // MIs[0] imm
     /* 400674 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400678 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400682 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 400686 */   // MIs[1] Operand 1
     /* 400686 */   // No operand predicates
     /* 400686 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400688 */   // (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (USHRv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 400688 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv2i32_shift),
     /* 400691 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400693 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400695 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 400698 */   GIR_RootConstrainSelectedInstOperands,
     /* 400699 */   // GIR_Coverage, 2277,
     /* 400699 */   GIR_EraseRootFromParent_Done,
     /* 400700 */ // Label 8396: @400700
     /* 400700 */ GIM_Reject,
     /* 400701 */ // Label 8386: @400701
     /* 400701 */ GIM_Try, /*On fail goto*//*Label 8397*/ GIMT_Encode4(400746), // Rule ID 2279 //
     /* 400706 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400709 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 400712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400716 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400720 */   // MIs[0] imm
     /* 400720 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400724 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400728 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 400732 */   // MIs[1] Operand 1
     /* 400732 */   // No operand predicates
     /* 400732 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400734 */   // (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 400734 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv2i64_shift),
     /* 400737 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400739 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400741 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 400744 */   GIR_RootConstrainSelectedInstOperands,
     /* 400745 */   // GIR_Coverage, 2279,
     /* 400745 */   GIR_EraseRootFromParent_Done,
     /* 400746 */ // Label 8397: @400746
     /* 400746 */ GIM_Reject,
     /* 400747 */ // Label 8387: @400747
     /* 400747 */ GIM_Try, /*On fail goto*//*Label 8398*/ GIMT_Encode4(400792), // Rule ID 2275 //
     /* 400752 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 400758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400762 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400766 */   // MIs[0] imm
     /* 400766 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400770 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400774 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 400778 */   // MIs[1] Operand 1
     /* 400778 */   // No operand predicates
     /* 400778 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400780 */   // (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (USHRv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 400780 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i16_shift),
     /* 400783 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400785 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400787 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 400790 */   GIR_RootConstrainSelectedInstOperands,
     /* 400791 */   // GIR_Coverage, 2275,
     /* 400791 */   GIR_EraseRootFromParent_Done,
     /* 400792 */ // Label 8398: @400792
     /* 400792 */ GIM_Reject,
     /* 400793 */ // Label 8388: @400793
     /* 400793 */ GIM_Try, /*On fail goto*//*Label 8399*/ GIMT_Encode4(400838), // Rule ID 2278 //
     /* 400798 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 400804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400808 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400812 */   // MIs[0] imm
     /* 400812 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400816 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400820 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 400824 */   // MIs[1] Operand 1
     /* 400824 */   // No operand predicates
     /* 400824 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400826 */   // (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (USHRv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 400826 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
     /* 400829 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400831 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400833 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 400836 */   GIR_RootConstrainSelectedInstOperands,
     /* 400837 */   // GIR_Coverage, 2278,
     /* 400837 */   GIR_EraseRootFromParent_Done,
     /* 400838 */ // Label 8399: @400838
     /* 400838 */ GIM_Reject,
     /* 400839 */ // Label 8389: @400839
     /* 400839 */ GIM_Try, /*On fail goto*//*Label 8400*/ GIMT_Encode4(400884), // Rule ID 2273 //
     /* 400844 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 400850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400854 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400858 */   // MIs[0] imm
     /* 400858 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400862 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400866 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 400870 */   // MIs[1] Operand 1
     /* 400870 */   // No operand predicates
     /* 400870 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400872 */   // (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (USHRv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 400872 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv8i8_shift),
     /* 400875 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400877 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400879 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 400882 */   GIR_RootConstrainSelectedInstOperands,
     /* 400883 */   // GIR_Coverage, 2273,
     /* 400883 */   GIR_EraseRootFromParent_Done,
     /* 400884 */ // Label 8400: @400884
     /* 400884 */ GIM_Reject,
     /* 400885 */ // Label 8390: @400885
     /* 400885 */ GIM_Try, /*On fail goto*//*Label 8401*/ GIMT_Encode4(400930), // Rule ID 2276 //
     /* 400890 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400893 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400900 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400904 */   // MIs[0] imm
     /* 400904 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400908 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400912 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 400916 */   // MIs[1] Operand 1
     /* 400916 */   // No operand predicates
     /* 400916 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400918 */   // (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (USHRv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 400918 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv8i16_shift),
     /* 400921 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400923 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400925 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 400928 */   GIR_RootConstrainSelectedInstOperands,
     /* 400929 */   // GIR_Coverage, 2276,
     /* 400929 */   GIR_EraseRootFromParent_Done,
     /* 400930 */ // Label 8401: @400930
     /* 400930 */ GIM_Reject,
     /* 400931 */ // Label 8391: @400931
     /* 400931 */ GIM_Try, /*On fail goto*//*Label 8402*/ GIMT_Encode4(400976), // Rule ID 2274 //
     /* 400936 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 400942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400946 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400950 */   // MIs[0] imm
     /* 400950 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400954 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400958 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 400962 */   // MIs[1] Operand 1
     /* 400962 */   // No operand predicates
     /* 400962 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400964 */   // (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (USHRv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 400964 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv16i8_shift),
     /* 400967 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400969 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400971 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 400974 */   GIR_RootConstrainSelectedInstOperands,
     /* 400975 */   // GIR_Coverage, 2274,
     /* 400975 */   GIR_EraseRootFromParent_Done,
     /* 400976 */ // Label 8402: @400976
     /* 400976 */ GIM_Reject,
     /* 400977 */ // Label 8392: @400977
     /* 400977 */ GIM_Reject,
     /* 400978 */ // Label 152: @400978
     /* 400978 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8421*/ GIMT_Encode4(401757),
     /* 400989 */ /*GILLT_v2s32*//*Label 8403*/ GIMT_Encode4(401065),
     /* 400993 */ /*GILLT_v2s64*//*Label 8404*/ GIMT_Encode4(401120),
     /* 400997 */ /*GILLT_v4s16*//*Label 8405*/ GIMT_Encode4(401175),
     /* 401001 */ /*GILLT_v4s32*//*Label 8406*/ GIMT_Encode4(401230),
     /* 401005 */ /*GILLT_v8s8*//*Label 8407*/ GIMT_Encode4(401285),
     /* 401009 */ /*GILLT_v8s16*//*Label 8408*/ GIMT_Encode4(401319),
     /* 401013 */ /*GILLT_v16s8*//*Label 8409*/ GIMT_Encode4(401374), GIMT_Encode4(0),
     /* 401021 */ /*GILLT_nxv2s1*//*Label 8410*/ GIMT_Encode4(401408),
     /* 401025 */ /*GILLT_nxv2s16*//*Label 8411*/ GIMT_Encode4(401434),
     /* 401029 */ /*GILLT_nxv2s32*//*Label 8412*/ GIMT_Encode4(401460),
     /* 401033 */ /*GILLT_nxv2s64*//*Label 8413*/ GIMT_Encode4(401486),
     /* 401037 */ /*GILLT_nxv4s1*//*Label 8414*/ GIMT_Encode4(401533),
     /* 401041 */ /*GILLT_nxv4s16*//*Label 8415*/ GIMT_Encode4(401559),
     /* 401045 */ /*GILLT_nxv4s32*//*Label 8416*/ GIMT_Encode4(401585),
     /* 401049 */ /*GILLT_nxv8s1*//*Label 8417*/ GIMT_Encode4(401632),
     /* 401053 */ /*GILLT_nxv8s16*//*Label 8418*/ GIMT_Encode4(401658),
     /* 401057 */ /*GILLT_nxv16s1*//*Label 8419*/ GIMT_Encode4(401705),
     /* 401061 */ /*GILLT_nxv16s8*//*Label 8420*/ GIMT_Encode4(401731),
     /* 401065 */ // Label 8403: @401065
     /* 401065 */ GIM_Try, /*On fail goto*//*Label 8422*/ GIMT_Encode4(401119),
     /* 401070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 401073 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 401076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401080 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401084 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401088 */   GIM_Try, /*On fail goto*//*Label 8423*/ GIMT_Encode4(401103), // Rule ID 1895 //
     /* 401093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401096 */     // (AArch64zip1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ZIP1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 401096 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i32),
     /* 401101 */     GIR_RootConstrainSelectedInstOperands,
     /* 401102 */     // GIR_Coverage, 1895,
     /* 401102 */     GIR_Done,
     /* 401103 */   // Label 8423: @401103
     /* 401103 */   GIM_Try, /*On fail goto*//*Label 8424*/ GIMT_Encode4(401118), // Rule ID 5420 //
     /* 401108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401111 */     // (AArch64zip1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (ZIP1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 401111 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i32),
     /* 401116 */     GIR_RootConstrainSelectedInstOperands,
     /* 401117 */     // GIR_Coverage, 5420,
     /* 401117 */     GIR_Done,
     /* 401118 */   // Label 8424: @401118
     /* 401118 */   GIM_Reject,
     /* 401119 */ // Label 8422: @401119
     /* 401119 */ GIM_Reject,
     /* 401120 */ // Label 8404: @401120
     /* 401120 */ GIM_Try, /*On fail goto*//*Label 8425*/ GIMT_Encode4(401174),
     /* 401125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 401128 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 401131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401135 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401139 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401143 */   GIM_Try, /*On fail goto*//*Label 8426*/ GIMT_Encode4(401158), // Rule ID 1897 //
     /* 401148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401151 */     // (AArch64zip1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ZIP1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 401151 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i64),
     /* 401156 */     GIR_RootConstrainSelectedInstOperands,
     /* 401157 */     // GIR_Coverage, 1897,
     /* 401157 */     GIR_Done,
     /* 401158 */   // Label 8426: @401158
     /* 401158 */   GIM_Try, /*On fail goto*//*Label 8427*/ GIMT_Encode4(401173), // Rule ID 5422 //
     /* 401163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401166 */     // (AArch64zip1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (ZIP1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 401166 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i64),
     /* 401171 */     GIR_RootConstrainSelectedInstOperands,
     /* 401172 */     // GIR_Coverage, 5422,
     /* 401172 */     GIR_Done,
     /* 401173 */   // Label 8427: @401173
     /* 401173 */   GIM_Reject,
     /* 401174 */ // Label 8425: @401174
     /* 401174 */ GIM_Reject,
     /* 401175 */ // Label 8405: @401175
     /* 401175 */ GIM_Try, /*On fail goto*//*Label 8428*/ GIMT_Encode4(401229),
     /* 401180 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 401183 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 401186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401190 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401194 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401198 */   GIM_Try, /*On fail goto*//*Label 8429*/ GIMT_Encode4(401213), // Rule ID 1893 //
     /* 401203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401206 */     // (AArch64zip1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ZIP1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 401206 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i16),
     /* 401211 */     GIR_RootConstrainSelectedInstOperands,
     /* 401212 */     // GIR_Coverage, 1893,
     /* 401212 */     GIR_Done,
     /* 401213 */   // Label 8429: @401213
     /* 401213 */   GIM_Try, /*On fail goto*//*Label 8430*/ GIMT_Encode4(401228), // Rule ID 5418 //
     /* 401218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401221 */     // (AArch64zip1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (ZIP1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 401221 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i16),
     /* 401226 */     GIR_RootConstrainSelectedInstOperands,
     /* 401227 */     // GIR_Coverage, 5418,
     /* 401227 */     GIR_Done,
     /* 401228 */   // Label 8430: @401228
     /* 401228 */   GIM_Reject,
     /* 401229 */ // Label 8428: @401229
     /* 401229 */ GIM_Reject,
     /* 401230 */ // Label 8406: @401230
     /* 401230 */ GIM_Try, /*On fail goto*//*Label 8431*/ GIMT_Encode4(401284),
     /* 401235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 401238 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 401241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401245 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401249 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401253 */   GIM_Try, /*On fail goto*//*Label 8432*/ GIMT_Encode4(401268), // Rule ID 1896 //
     /* 401258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401261 */     // (AArch64zip1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ZIP1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 401261 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i32),
     /* 401266 */     GIR_RootConstrainSelectedInstOperands,
     /* 401267 */     // GIR_Coverage, 1896,
     /* 401267 */     GIR_Done,
     /* 401268 */   // Label 8432: @401268
     /* 401268 */   GIM_Try, /*On fail goto*//*Label 8433*/ GIMT_Encode4(401283), // Rule ID 5421 //
     /* 401273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401276 */     // (AArch64zip1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (ZIP1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 401276 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i32),
     /* 401281 */     GIR_RootConstrainSelectedInstOperands,
     /* 401282 */     // GIR_Coverage, 5421,
     /* 401282 */     GIR_Done,
     /* 401283 */   // Label 8433: @401283
     /* 401283 */   GIM_Reject,
     /* 401284 */ // Label 8431: @401284
     /* 401284 */ GIM_Reject,
     /* 401285 */ // Label 8407: @401285
     /* 401285 */ GIM_Try, /*On fail goto*//*Label 8434*/ GIMT_Encode4(401318), // Rule ID 1891 //
     /* 401290 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 401296 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 401299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401303 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401307 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401311 */   // (AArch64zip1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ZIP1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 401311 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i8),
     /* 401316 */   GIR_RootConstrainSelectedInstOperands,
     /* 401317 */   // GIR_Coverage, 1891,
     /* 401317 */   GIR_Done,
     /* 401318 */ // Label 8434: @401318
     /* 401318 */ GIM_Reject,
     /* 401319 */ // Label 8408: @401319
     /* 401319 */ GIM_Try, /*On fail goto*//*Label 8435*/ GIMT_Encode4(401373),
     /* 401324 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401327 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 401330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401334 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401338 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401342 */   GIM_Try, /*On fail goto*//*Label 8436*/ GIMT_Encode4(401357), // Rule ID 1894 //
     /* 401347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401350 */     // (AArch64zip1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ZIP1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 401350 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i16),
     /* 401355 */     GIR_RootConstrainSelectedInstOperands,
     /* 401356 */     // GIR_Coverage, 1894,
     /* 401356 */     GIR_Done,
     /* 401357 */   // Label 8436: @401357
     /* 401357 */   GIM_Try, /*On fail goto*//*Label 8437*/ GIMT_Encode4(401372), // Rule ID 5419 //
     /* 401362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401365 */     // (AArch64zip1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (ZIP1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 401365 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i16),
     /* 401370 */     GIR_RootConstrainSelectedInstOperands,
     /* 401371 */     // GIR_Coverage, 5419,
     /* 401371 */     GIR_Done,
     /* 401372 */   // Label 8437: @401372
     /* 401372 */   GIM_Reject,
     /* 401373 */ // Label 8435: @401373
     /* 401373 */ GIM_Reject,
     /* 401374 */ // Label 8409: @401374
     /* 401374 */ GIM_Try, /*On fail goto*//*Label 8438*/ GIMT_Encode4(401407), // Rule ID 1892 //
     /* 401379 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 401385 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 401388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401392 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401396 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401400 */   // (AArch64zip1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ZIP1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 401400 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v16i8),
     /* 401405 */   GIR_RootConstrainSelectedInstOperands,
     /* 401406 */   // GIR_Coverage, 1892,
     /* 401406 */   GIR_Done,
     /* 401407 */ // Label 8438: @401407
     /* 401407 */ GIM_Reject,
     /* 401408 */ // Label 8410: @401408
     /* 401408 */ GIM_Try, /*On fail goto*//*Label 8439*/ GIMT_Encode4(401433), // Rule ID 3328 //
     /* 401413 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 401416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 401419 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 401422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 401426 */   // (AArch64zip1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (ZIP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 401426 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_D),
     /* 401431 */   GIR_RootConstrainSelectedInstOperands,
     /* 401432 */   // GIR_Coverage, 3328,
     /* 401432 */   GIR_Done,
     /* 401433 */ // Label 8439: @401433
     /* 401433 */ GIM_Reject,
     /* 401434 */ // Label 8411: @401434
     /* 401434 */ GIM_Try, /*On fail goto*//*Label 8440*/ GIMT_Encode4(401459), // Rule ID 2865 //
     /* 401439 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 401442 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 401445 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 401448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 401452 */   // (AArch64zip1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 401452 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 401457 */   GIR_RootConstrainSelectedInstOperands,
     /* 401458 */   // GIR_Coverage, 2865,
     /* 401458 */   GIR_Done,
     /* 401459 */ // Label 8440: @401459
     /* 401459 */ GIM_Reject,
     /* 401460 */ // Label 8412: @401460
     /* 401460 */ GIM_Try, /*On fail goto*//*Label 8441*/ GIMT_Encode4(401485), // Rule ID 2866 //
     /* 401465 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 401468 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 401471 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 401474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 401478 */   // (AArch64zip1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 401478 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 401483 */   GIR_RootConstrainSelectedInstOperands,
     /* 401484 */   // GIR_Coverage, 2866,
     /* 401484 */   GIR_Done,
     /* 401485 */ // Label 8441: @401485
     /* 401485 */ GIM_Reject,
     /* 401486 */ // Label 8413: @401486
     /* 401486 */ GIM_Try, /*On fail goto*//*Label 8442*/ GIMT_Encode4(401532),
     /* 401491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 401494 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 401497 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 401501 */   GIM_Try, /*On fail goto*//*Label 8443*/ GIMT_Encode4(401516), // Rule ID 2861 //
     /* 401506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 401509 */     // (AArch64zip1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 401509 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 401514 */     GIR_RootConstrainSelectedInstOperands,
     /* 401515 */     // GIR_Coverage, 2861,
     /* 401515 */     GIR_Done,
     /* 401516 */   // Label 8443: @401516
     /* 401516 */   GIM_Try, /*On fail goto*//*Label 8444*/ GIMT_Encode4(401531), // Rule ID 2867 //
     /* 401521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 401524 */     // (AArch64zip1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 401524 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 401529 */     GIR_RootConstrainSelectedInstOperands,
     /* 401530 */     // GIR_Coverage, 2867,
     /* 401530 */     GIR_Done,
     /* 401531 */   // Label 8444: @401531
     /* 401531 */   GIM_Reject,
     /* 401532 */ // Label 8442: @401532
     /* 401532 */ GIM_Reject,
     /* 401533 */ // Label 8414: @401533
     /* 401533 */ GIM_Try, /*On fail goto*//*Label 8445*/ GIMT_Encode4(401558), // Rule ID 3327 //
     /* 401538 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 401541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 401544 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 401547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 401551 */   // (AArch64zip1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (ZIP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 401551 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_S),
     /* 401556 */   GIR_RootConstrainSelectedInstOperands,
     /* 401557 */   // GIR_Coverage, 3327,
     /* 401557 */   GIR_Done,
     /* 401558 */ // Label 8445: @401558
     /* 401558 */ GIM_Reject,
     /* 401559 */ // Label 8415: @401559
     /* 401559 */ GIM_Try, /*On fail goto*//*Label 8446*/ GIMT_Encode4(401584), // Rule ID 2863 //
     /* 401564 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 401567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 401570 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 401573 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 401577 */   // (AArch64zip1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 401577 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
     /* 401582 */   GIR_RootConstrainSelectedInstOperands,
     /* 401583 */   // GIR_Coverage, 2863,
     /* 401583 */   GIR_Done,
     /* 401584 */ // Label 8446: @401584
     /* 401584 */ GIM_Reject,
     /* 401585 */ // Label 8416: @401585
     /* 401585 */ GIM_Try, /*On fail goto*//*Label 8447*/ GIMT_Encode4(401631),
     /* 401590 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 401593 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 401596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 401600 */   GIM_Try, /*On fail goto*//*Label 8448*/ GIMT_Encode4(401615), // Rule ID 2860 //
     /* 401605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 401608 */     // (AArch64zip1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 401608 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
     /* 401613 */     GIR_RootConstrainSelectedInstOperands,
     /* 401614 */     // GIR_Coverage, 2860,
     /* 401614 */     GIR_Done,
     /* 401615 */   // Label 8448: @401615
     /* 401615 */   GIM_Try, /*On fail goto*//*Label 8449*/ GIMT_Encode4(401630), // Rule ID 2864 //
     /* 401620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 401623 */     // (AArch64zip1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 401623 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
     /* 401628 */     GIR_RootConstrainSelectedInstOperands,
     /* 401629 */     // GIR_Coverage, 2864,
     /* 401629 */     GIR_Done,
     /* 401630 */   // Label 8449: @401630
     /* 401630 */   GIM_Reject,
     /* 401631 */ // Label 8447: @401631
     /* 401631 */ GIM_Reject,
     /* 401632 */ // Label 8417: @401632
     /* 401632 */ GIM_Try, /*On fail goto*//*Label 8450*/ GIMT_Encode4(401657), // Rule ID 3326 //
     /* 401637 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 401640 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 401643 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 401646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 401650 */   // (AArch64zip1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (ZIP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 401650 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_H),
     /* 401655 */   GIR_RootConstrainSelectedInstOperands,
     /* 401656 */   // GIR_Coverage, 3326,
     /* 401656 */   GIR_Done,
     /* 401657 */ // Label 8450: @401657
     /* 401657 */ GIM_Reject,
     /* 401658 */ // Label 8418: @401658
     /* 401658 */ GIM_Try, /*On fail goto*//*Label 8451*/ GIMT_Encode4(401704),
     /* 401663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 401666 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 401669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 401673 */   GIM_Try, /*On fail goto*//*Label 8452*/ GIMT_Encode4(401688), // Rule ID 2859 //
     /* 401678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 401681 */     // (AArch64zip1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 401681 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_H),
     /* 401686 */     GIR_RootConstrainSelectedInstOperands,
     /* 401687 */     // GIR_Coverage, 2859,
     /* 401687 */     GIR_Done,
     /* 401688 */   // Label 8452: @401688
     /* 401688 */   GIM_Try, /*On fail goto*//*Label 8453*/ GIMT_Encode4(401703), // Rule ID 2862 //
     /* 401693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 401696 */     // (AArch64zip1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 401696 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_H),
     /* 401701 */     GIR_RootConstrainSelectedInstOperands,
     /* 401702 */     // GIR_Coverage, 2862,
     /* 401702 */     GIR_Done,
     /* 401703 */   // Label 8453: @401703
     /* 401703 */   GIM_Reject,
     /* 401704 */ // Label 8451: @401704
     /* 401704 */ GIM_Reject,
     /* 401705 */ // Label 8419: @401705
     /* 401705 */ GIM_Try, /*On fail goto*//*Label 8454*/ GIMT_Encode4(401730), // Rule ID 2389 //
     /* 401710 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 401713 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 401716 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 401719 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 401723 */   // (AArch64zip1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 401723 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_B),
     /* 401728 */   GIR_RootConstrainSelectedInstOperands,
     /* 401729 */   // GIR_Coverage, 2389,
     /* 401729 */   GIR_Done,
     /* 401730 */ // Label 8454: @401730
     /* 401730 */ GIM_Reject,
     /* 401731 */ // Label 8420: @401731
     /* 401731 */ GIM_Try, /*On fail goto*//*Label 8455*/ GIMT_Encode4(401756), // Rule ID 2858 //
     /* 401736 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 401739 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 401742 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 401745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 401749 */   // (AArch64zip1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 401749 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_B),
     /* 401754 */   GIR_RootConstrainSelectedInstOperands,
     /* 401755 */   // GIR_Coverage, 2858,
     /* 401755 */   GIR_Done,
     /* 401756 */ // Label 8455: @401756
     /* 401756 */ GIM_Reject,
     /* 401757 */ // Label 8421: @401757
     /* 401757 */ GIM_Reject,
     /* 401758 */ // Label 153: @401758
     /* 401758 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8474*/ GIMT_Encode4(402537),
     /* 401769 */ /*GILLT_v2s32*//*Label 8456*/ GIMT_Encode4(401845),
     /* 401773 */ /*GILLT_v2s64*//*Label 8457*/ GIMT_Encode4(401900),
     /* 401777 */ /*GILLT_v4s16*//*Label 8458*/ GIMT_Encode4(401955),
     /* 401781 */ /*GILLT_v4s32*//*Label 8459*/ GIMT_Encode4(402010),
     /* 401785 */ /*GILLT_v8s8*//*Label 8460*/ GIMT_Encode4(402065),
     /* 401789 */ /*GILLT_v8s16*//*Label 8461*/ GIMT_Encode4(402099),
     /* 401793 */ /*GILLT_v16s8*//*Label 8462*/ GIMT_Encode4(402154), GIMT_Encode4(0),
     /* 401801 */ /*GILLT_nxv2s1*//*Label 8463*/ GIMT_Encode4(402188),
     /* 401805 */ /*GILLT_nxv2s16*//*Label 8464*/ GIMT_Encode4(402214),
     /* 401809 */ /*GILLT_nxv2s32*//*Label 8465*/ GIMT_Encode4(402240),
     /* 401813 */ /*GILLT_nxv2s64*//*Label 8466*/ GIMT_Encode4(402266),
     /* 401817 */ /*GILLT_nxv4s1*//*Label 8467*/ GIMT_Encode4(402313),
     /* 401821 */ /*GILLT_nxv4s16*//*Label 8468*/ GIMT_Encode4(402339),
     /* 401825 */ /*GILLT_nxv4s32*//*Label 8469*/ GIMT_Encode4(402365),
     /* 401829 */ /*GILLT_nxv8s1*//*Label 8470*/ GIMT_Encode4(402412),
     /* 401833 */ /*GILLT_nxv8s16*//*Label 8471*/ GIMT_Encode4(402438),
     /* 401837 */ /*GILLT_nxv16s1*//*Label 8472*/ GIMT_Encode4(402485),
     /* 401841 */ /*GILLT_nxv16s8*//*Label 8473*/ GIMT_Encode4(402511),
     /* 401845 */ // Label 8456: @401845
     /* 401845 */ GIM_Try, /*On fail goto*//*Label 8475*/ GIMT_Encode4(401899),
     /* 401850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 401853 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 401856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401860 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401864 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401868 */   GIM_Try, /*On fail goto*//*Label 8476*/ GIMT_Encode4(401883), // Rule ID 1902 //
     /* 401873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401876 */     // (AArch64zip2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ZIP2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 401876 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i32),
     /* 401881 */     GIR_RootConstrainSelectedInstOperands,
     /* 401882 */     // GIR_Coverage, 1902,
     /* 401882 */     GIR_Done,
     /* 401883 */   // Label 8476: @401883
     /* 401883 */   GIM_Try, /*On fail goto*//*Label 8477*/ GIMT_Encode4(401898), // Rule ID 5425 //
     /* 401888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401891 */     // (AArch64zip2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (ZIP2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 401891 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i32),
     /* 401896 */     GIR_RootConstrainSelectedInstOperands,
     /* 401897 */     // GIR_Coverage, 5425,
     /* 401897 */     GIR_Done,
     /* 401898 */   // Label 8477: @401898
     /* 401898 */   GIM_Reject,
     /* 401899 */ // Label 8475: @401899
     /* 401899 */ GIM_Reject,
     /* 401900 */ // Label 8457: @401900
     /* 401900 */ GIM_Try, /*On fail goto*//*Label 8478*/ GIMT_Encode4(401954),
     /* 401905 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 401908 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 401911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401915 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401919 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401923 */   GIM_Try, /*On fail goto*//*Label 8479*/ GIMT_Encode4(401938), // Rule ID 1904 //
     /* 401928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401931 */     // (AArch64zip2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ZIP2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 401931 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i64),
     /* 401936 */     GIR_RootConstrainSelectedInstOperands,
     /* 401937 */     // GIR_Coverage, 1904,
     /* 401937 */     GIR_Done,
     /* 401938 */   // Label 8479: @401938
     /* 401938 */   GIM_Try, /*On fail goto*//*Label 8480*/ GIMT_Encode4(401953), // Rule ID 5427 //
     /* 401943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401946 */     // (AArch64zip2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (ZIP2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 401946 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i64),
     /* 401951 */     GIR_RootConstrainSelectedInstOperands,
     /* 401952 */     // GIR_Coverage, 5427,
     /* 401952 */     GIR_Done,
     /* 401953 */   // Label 8480: @401953
     /* 401953 */   GIM_Reject,
     /* 401954 */ // Label 8478: @401954
     /* 401954 */ GIM_Reject,
     /* 401955 */ // Label 8458: @401955
     /* 401955 */ GIM_Try, /*On fail goto*//*Label 8481*/ GIMT_Encode4(402009),
     /* 401960 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 401963 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 401966 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401970 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401974 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401978 */   GIM_Try, /*On fail goto*//*Label 8482*/ GIMT_Encode4(401993), // Rule ID 1900 //
     /* 401983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401986 */     // (AArch64zip2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ZIP2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 401986 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i16),
     /* 401991 */     GIR_RootConstrainSelectedInstOperands,
     /* 401992 */     // GIR_Coverage, 1900,
     /* 401992 */     GIR_Done,
     /* 401993 */   // Label 8482: @401993
     /* 401993 */   GIM_Try, /*On fail goto*//*Label 8483*/ GIMT_Encode4(402008), // Rule ID 5423 //
     /* 401998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402001 */     // (AArch64zip2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (ZIP2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 402001 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i16),
     /* 402006 */     GIR_RootConstrainSelectedInstOperands,
     /* 402007 */     // GIR_Coverage, 5423,
     /* 402007 */     GIR_Done,
     /* 402008 */   // Label 8483: @402008
     /* 402008 */   GIM_Reject,
     /* 402009 */ // Label 8481: @402009
     /* 402009 */ GIM_Reject,
     /* 402010 */ // Label 8459: @402010
     /* 402010 */ GIM_Try, /*On fail goto*//*Label 8484*/ GIMT_Encode4(402064),
     /* 402015 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 402018 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 402021 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402025 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402029 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402033 */   GIM_Try, /*On fail goto*//*Label 8485*/ GIMT_Encode4(402048), // Rule ID 1903 //
     /* 402038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402041 */     // (AArch64zip2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ZIP2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 402041 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i32),
     /* 402046 */     GIR_RootConstrainSelectedInstOperands,
     /* 402047 */     // GIR_Coverage, 1903,
     /* 402047 */     GIR_Done,
     /* 402048 */   // Label 8485: @402048
     /* 402048 */   GIM_Try, /*On fail goto*//*Label 8486*/ GIMT_Encode4(402063), // Rule ID 5426 //
     /* 402053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402056 */     // (AArch64zip2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (ZIP2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 402056 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i32),
     /* 402061 */     GIR_RootConstrainSelectedInstOperands,
     /* 402062 */     // GIR_Coverage, 5426,
     /* 402062 */     GIR_Done,
     /* 402063 */   // Label 8486: @402063
     /* 402063 */   GIM_Reject,
     /* 402064 */ // Label 8484: @402064
     /* 402064 */ GIM_Reject,
     /* 402065 */ // Label 8460: @402065
     /* 402065 */ GIM_Try, /*On fail goto*//*Label 8487*/ GIMT_Encode4(402098), // Rule ID 1898 //
     /* 402070 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 402076 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 402079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402083 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402087 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402091 */   // (AArch64zip2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ZIP2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 402091 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i8),
     /* 402096 */   GIR_RootConstrainSelectedInstOperands,
     /* 402097 */   // GIR_Coverage, 1898,
     /* 402097 */   GIR_Done,
     /* 402098 */ // Label 8487: @402098
     /* 402098 */ GIM_Reject,
     /* 402099 */ // Label 8461: @402099
     /* 402099 */ GIM_Try, /*On fail goto*//*Label 8488*/ GIMT_Encode4(402153),
     /* 402104 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402107 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 402110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402114 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402118 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402122 */   GIM_Try, /*On fail goto*//*Label 8489*/ GIMT_Encode4(402137), // Rule ID 1901 //
     /* 402127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402130 */     // (AArch64zip2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ZIP2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 402130 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i16),
     /* 402135 */     GIR_RootConstrainSelectedInstOperands,
     /* 402136 */     // GIR_Coverage, 1901,
     /* 402136 */     GIR_Done,
     /* 402137 */   // Label 8489: @402137
     /* 402137 */   GIM_Try, /*On fail goto*//*Label 8490*/ GIMT_Encode4(402152), // Rule ID 5424 //
     /* 402142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402145 */     // (AArch64zip2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (ZIP2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 402145 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i16),
     /* 402150 */     GIR_RootConstrainSelectedInstOperands,
     /* 402151 */     // GIR_Coverage, 5424,
     /* 402151 */     GIR_Done,
     /* 402152 */   // Label 8490: @402152
     /* 402152 */   GIM_Reject,
     /* 402153 */ // Label 8488: @402153
     /* 402153 */ GIM_Reject,
     /* 402154 */ // Label 8462: @402154
     /* 402154 */ GIM_Try, /*On fail goto*//*Label 8491*/ GIMT_Encode4(402187), // Rule ID 1899 //
     /* 402159 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 402165 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 402168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402172 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402176 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402180 */   // (AArch64zip2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ZIP2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 402180 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v16i8),
     /* 402185 */   GIR_RootConstrainSelectedInstOperands,
     /* 402186 */   // GIR_Coverage, 1899,
     /* 402186 */   GIR_Done,
     /* 402187 */ // Label 8491: @402187
     /* 402187 */ GIM_Reject,
     /* 402188 */ // Label 8463: @402188
     /* 402188 */ GIM_Try, /*On fail goto*//*Label 8492*/ GIMT_Encode4(402213), // Rule ID 8804 //
     /* 402193 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402196 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 402199 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 402202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 402206 */   // (AArch64zip2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (ZIP2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 402206 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_D),
     /* 402211 */   GIR_RootConstrainSelectedInstOperands,
     /* 402212 */   // GIR_Coverage, 8804,
     /* 402212 */   GIR_Done,
     /* 402213 */ // Label 8492: @402213
     /* 402213 */ GIM_Reject,
     /* 402214 */ // Label 8464: @402214
     /* 402214 */ GIM_Try, /*On fail goto*//*Label 8493*/ GIMT_Encode4(402239), // Rule ID 8759 //
     /* 402219 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402222 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 402225 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 402228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 402232 */   // (AArch64zip2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 402232 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 402237 */   GIR_RootConstrainSelectedInstOperands,
     /* 402238 */   // GIR_Coverage, 8759,
     /* 402238 */   GIR_Done,
     /* 402239 */ // Label 8493: @402239
     /* 402239 */ GIM_Reject,
     /* 402240 */ // Label 8465: @402240
     /* 402240 */ GIM_Try, /*On fail goto*//*Label 8494*/ GIMT_Encode4(402265), // Rule ID 8760 //
     /* 402245 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402248 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 402251 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 402254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 402258 */   // (AArch64zip2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 402258 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 402263 */   GIR_RootConstrainSelectedInstOperands,
     /* 402264 */   // GIR_Coverage, 8760,
     /* 402264 */   GIR_Done,
     /* 402265 */ // Label 8494: @402265
     /* 402265 */ GIM_Reject,
     /* 402266 */ // Label 8466: @402266
     /* 402266 */ GIM_Try, /*On fail goto*//*Label 8495*/ GIMT_Encode4(402312),
     /* 402271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 402274 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 402277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 402281 */   GIM_Try, /*On fail goto*//*Label 8496*/ GIMT_Encode4(402296), // Rule ID 8755 //
     /* 402286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402289 */     // (AArch64zip2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 402289 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 402294 */     GIR_RootConstrainSelectedInstOperands,
     /* 402295 */     // GIR_Coverage, 8755,
     /* 402295 */     GIR_Done,
     /* 402296 */   // Label 8496: @402296
     /* 402296 */   GIM_Try, /*On fail goto*//*Label 8497*/ GIMT_Encode4(402311), // Rule ID 8761 //
     /* 402301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402304 */     // (AArch64zip2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 402304 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 402309 */     GIR_RootConstrainSelectedInstOperands,
     /* 402310 */     // GIR_Coverage, 8761,
     /* 402310 */     GIR_Done,
     /* 402311 */   // Label 8497: @402311
     /* 402311 */   GIM_Reject,
     /* 402312 */ // Label 8495: @402312
     /* 402312 */ GIM_Reject,
     /* 402313 */ // Label 8467: @402313
     /* 402313 */ GIM_Try, /*On fail goto*//*Label 8498*/ GIMT_Encode4(402338), // Rule ID 8803 //
     /* 402318 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402321 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 402324 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 402327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 402331 */   // (AArch64zip2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (ZIP2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 402331 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_S),
     /* 402336 */   GIR_RootConstrainSelectedInstOperands,
     /* 402337 */   // GIR_Coverage, 8803,
     /* 402337 */   GIR_Done,
     /* 402338 */ // Label 8498: @402338
     /* 402338 */ GIM_Reject,
     /* 402339 */ // Label 8468: @402339
     /* 402339 */ GIM_Try, /*On fail goto*//*Label 8499*/ GIMT_Encode4(402364), // Rule ID 8757 //
     /* 402344 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 402350 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 402353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 402357 */   // (AArch64zip2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 402357 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
     /* 402362 */   GIR_RootConstrainSelectedInstOperands,
     /* 402363 */   // GIR_Coverage, 8757,
     /* 402363 */   GIR_Done,
     /* 402364 */ // Label 8499: @402364
     /* 402364 */ GIM_Reject,
     /* 402365 */ // Label 8469: @402365
     /* 402365 */ GIM_Try, /*On fail goto*//*Label 8500*/ GIMT_Encode4(402411),
     /* 402370 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 402373 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 402376 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 402380 */   GIM_Try, /*On fail goto*//*Label 8501*/ GIMT_Encode4(402395), // Rule ID 8754 //
     /* 402385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402388 */     // (AArch64zip2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 402388 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
     /* 402393 */     GIR_RootConstrainSelectedInstOperands,
     /* 402394 */     // GIR_Coverage, 8754,
     /* 402394 */     GIR_Done,
     /* 402395 */   // Label 8501: @402395
     /* 402395 */   GIM_Try, /*On fail goto*//*Label 8502*/ GIMT_Encode4(402410), // Rule ID 8758 //
     /* 402400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402403 */     // (AArch64zip2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 402403 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
     /* 402408 */     GIR_RootConstrainSelectedInstOperands,
     /* 402409 */     // GIR_Coverage, 8758,
     /* 402409 */     GIR_Done,
     /* 402410 */   // Label 8502: @402410
     /* 402410 */   GIM_Reject,
     /* 402411 */ // Label 8500: @402411
     /* 402411 */ GIM_Reject,
     /* 402412 */ // Label 8470: @402412
     /* 402412 */ GIM_Try, /*On fail goto*//*Label 8503*/ GIMT_Encode4(402437), // Rule ID 8802 //
     /* 402417 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402420 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 402423 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 402426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 402430 */   // (AArch64zip2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (ZIP2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 402430 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_H),
     /* 402435 */   GIR_RootConstrainSelectedInstOperands,
     /* 402436 */   // GIR_Coverage, 8802,
     /* 402436 */   GIR_Done,
     /* 402437 */ // Label 8503: @402437
     /* 402437 */ GIM_Reject,
     /* 402438 */ // Label 8471: @402438
     /* 402438 */ GIM_Try, /*On fail goto*//*Label 8504*/ GIMT_Encode4(402484),
     /* 402443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 402446 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 402449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 402453 */   GIM_Try, /*On fail goto*//*Label 8505*/ GIMT_Encode4(402468), // Rule ID 8753 //
     /* 402458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402461 */     // (AArch64zip2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 402461 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_H),
     /* 402466 */     GIR_RootConstrainSelectedInstOperands,
     /* 402467 */     // GIR_Coverage, 8753,
     /* 402467 */     GIR_Done,
     /* 402468 */   // Label 8505: @402468
     /* 402468 */   GIM_Try, /*On fail goto*//*Label 8506*/ GIMT_Encode4(402483), // Rule ID 8756 //
     /* 402473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402476 */     // (AArch64zip2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 402476 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_H),
     /* 402481 */     GIR_RootConstrainSelectedInstOperands,
     /* 402482 */     // GIR_Coverage, 8756,
     /* 402482 */     GIR_Done,
     /* 402483 */   // Label 8506: @402483
     /* 402483 */   GIM_Reject,
     /* 402484 */ // Label 8504: @402484
     /* 402484 */ GIM_Reject,
     /* 402485 */ // Label 8472: @402485
     /* 402485 */ GIM_Try, /*On fail goto*//*Label 8507*/ GIMT_Encode4(402510), // Rule ID 2393 //
     /* 402490 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402493 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 402496 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 402499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 402503 */   // (AArch64zip2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 402503 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_B),
     /* 402508 */   GIR_RootConstrainSelectedInstOperands,
     /* 402509 */   // GIR_Coverage, 2393,
     /* 402509 */   GIR_Done,
     /* 402510 */ // Label 8507: @402510
     /* 402510 */ GIM_Reject,
     /* 402511 */ // Label 8473: @402511
     /* 402511 */ GIM_Try, /*On fail goto*//*Label 8508*/ GIMT_Encode4(402536), // Rule ID 8752 //
     /* 402516 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 402522 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 402525 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 402529 */   // (AArch64zip2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 402529 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_B),
     /* 402534 */   GIR_RootConstrainSelectedInstOperands,
     /* 402535 */   // GIR_Coverage, 8752,
     /* 402535 */   GIR_Done,
     /* 402536 */ // Label 8508: @402536
     /* 402536 */ GIM_Reject,
     /* 402537 */ // Label 8474: @402537
     /* 402537 */ GIM_Reject,
     /* 402538 */ // Label 154: @402538
     /* 402538 */ GIM_Reject,
     /* 402539 */ }; // Size: 402539 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const AArch64Subtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const AArch64Subtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
